prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4020
,p_default_id_offset=>0
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4020 - Oracle APEX Create App Wizard
--
-- Application Export:
--   Application:     4020
--   Name:            Oracle APEX Create App Wizard
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                     39
--       Items:                  379
--       Computations:            12
--       Validations:             71
--       Processes:              130
--       Regions:                205
--       Buttons:                186
--       Dynamic Actions:        159
--     Shared Components:
--       Logic:
--         Items:                 58
--         Processes:              1
--         Computations:           3
--         Build Options:         13
--       Navigation:
--         Parent Tabs:            1
--         Lists:                  5
--       Security:
--         Authentication:         1
--         Authorization:         10
--       User Interface:
--         Themes:                 1
--         Templates:
--           Page:                 8
--           Region:              44
--           Label:               14
--           List:                27
--           Popup LOV:            1
--           Calendar:             3
--           Breadcrumb:           1
--           Button:              10
--           Report:              15
--         LOVs:                  50
--         Shortcuts:              3
--         Plug-ins:              13
--       Globalization:
--         Messages:               4
--       Reports:
--       E-Mail:
--     Supporting Objects:  Included
--   Version:         21.2.0-19
--   Instance ID:     696285138374724
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Create App Wizard')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'NEW_SERVICE4020')
,p_application_group=>wwv_flow_api.id(91050719712959059)
,p_application_group_name=>'APEX Product'
,p_application_group_comment=>'Applications shipped with the APEX product distribution'
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211018035835'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.1'
,p_flow_language=>'en'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_documentation_banner=>'Oracle Application Express self service workspace provisioning sign up application.'
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(3324722473421190676)
,p_populate_roles=>'A'
,p_application_tab_set=>1
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O'
,p_security_scheme=>wwv_flow_api.id(2876432045198950826)
,p_authorize_public_pages_yn=>'Y'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_error_handling_function=>'wwv_flow_error_dev.internal_error_handler'
,p_friendly_url=>'N'
,p_substitution_string_01=>'PRODUCT_NAME'
,p_substitution_value_01=>'Oracle APEX'
,p_substitution_string_02=>'DONE'
,p_substitution_value_02=>'Done'
,p_substitution_string_03=>'MSG_COMPANY'
,p_substitution_value_03=>'Workspace: &COMPANY.'
,p_substitution_string_04=>'CLOSE'
,p_substitution_value_04=>'Close'
,p_substitution_string_05=>'DATE_FORMAT'
,p_substitution_value_05=>'mm/dd/yyyy'
,p_substitution_string_06=>'LONG_DATE_FORMAT'
,p_substitution_value_06=>'fmDay, Month dd, yyyy'
,p_substitution_string_07=>'TIME_FORMAT'
,p_substitution_value_07=>'hh:mi:ss AM'
,p_substitution_string_08=>'DATE_TIME_FORMAT'
,p_substitution_value_08=>'mm/dd/yyyy hh:mi:ss AM'
,p_substitution_string_09=>'RETURN_TO_APPLICATION'
,p_substitution_value_09=>'Return to Application'
,p_substitution_string_10=>'MSG_LANGUAGE'
,p_substitution_value_10=>'Language'
,p_substitution_string_12=>'MSG_COPYRIGHT'
,p_substitution_value_12=>'Copyright &copy; 1999, 2021, Oracle and/or its affiliates.'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20211018035835'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_files_version=>5
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/shared_components/navigation/lists/additional_page_types
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(599891668290343112)
,p_name=>'Additional Page Types'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(599891860611343113)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Classic Report'
,p_list_item_link_target=>'REPORT'
,p_list_item_current_for_pages=>'REPORT'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(599892201246343114)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Timeline'
,p_list_item_link_target=>'TIMELINE'
,p_list_item_current_for_pages=>'TIMELINE'
);
end;
/
prompt --application/shared_components/navigation/lists/create_app_wizard
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(2558503318577318905)
,p_name=>'Create App Wizard'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_administration_header
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(3078131037146643152)
,p_name=>'APEX 5 - Administration (Header)'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078131330088643190)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Administration'
,p_list_item_link_target=>'f?p=4350:1:&APP_SESSION.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078131706125643192)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'------'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078132165904643193)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Manage Service'
,p_security_scheme=>wwv_flow_api.id(477032281289042219)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078132505153643193)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Manage Service'
,p_list_item_link_target=>'f?p=4350:21:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(3078132165904643193)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078132924385643194)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'------'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(3078132165904643193)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078133367058643194)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Make a Service Request'
,p_list_item_link_target=>'f?p=4350:96:&SESSION.::NO:49::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''SERVICE_REQUESTS_ENABLED'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_api.id(3078132165904643193)
,p_security_scheme=>wwv_flow_api.id(477032281289042219)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078133750052643195)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Set Workspace Preferences'
,p_list_item_link_target=>'f?p=4350:17:&SESSION.::NO:RP::'
,p_parent_list_item_id=>wwv_flow_api.id(3078132165904643193)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078134173371643195)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Define Workspace Message'
,p_list_item_link_target=>'f?p=4350:35:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(3078132165904643193)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(180639817922584588)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Define Environment Banner'
,p_list_item_link_target=>'f?p=4350:105:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(3078132165904643193)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078134568371643195)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Workspace Utilization'
,p_list_item_link_target=>'f?p=4350:101:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(3078132165904643193)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078134932669643196)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Manage Users and Groups'
,p_list_item_link_target=>'f?p=4350:55:&SESSION.'
,p_security_scheme=>wwv_flow_api.id(477032281289042219)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078135328636643196)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Monitor Activity'
,p_list_item_link_target=>'f?p=4350:22:&SESSION.'
,p_security_scheme=>wwv_flow_api.id(477074727917083066)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078135799834643196)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Dashboards'
,p_list_item_link_target=>'f?p=4350:33:&SESSION.'
,p_security_scheme=>wwv_flow_api.id(477074727917083066)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078136195160643196)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Change My Password'
,p_list_item_link_target=>'f?p=4350:3:&SESSION.::&DEBUG.:3#pwd'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_authentication_dev.can_edit_builder_users'
,p_list_item_disp_condition2=>'PLSQL'
,p_security_scheme=>wwv_flow_api.id(477074727917083066)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_help
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(3078138630465643203)
,p_name=>'APEX 5 - Help'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078138974356643203)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Documentation'
,p_list_item_link_target=>'&SYSTEM_HELP_URL.'
,p_list_text_02=>'helpLinkNewWindow'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078139307044643204)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Discussion Forum'
,p_list_item_link_target=>'https://apex.oracle.com/forum'
,p_list_text_01=>'helpLinkForum'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078139708135643204)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Learn More about Oracle APEX'
,p_list_item_link_target=>'https://apex.oracle.com'
,p_list_text_01=>'helpLinkOTN'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078140162161643204)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'---'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078140539384643204)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'About'
,p_list_item_link_target=>'f?p=4350:9:&SESSION.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_tabs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(3078141213440643205)
,p_name=>'APEX 5 - Tabs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078158764400643220)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'App Builder'
,p_list_item_link_target=>'f?p=4000:1500:&SESSION.::&DEBUG.::P1500_SHOW::'
,p_list_item_icon_alt_attribute=>'App Builder Drill Down'
,p_list_text_01=>'tab-app-builder'
,p_security_scheme=>wwv_flow_api.id(477075720994096449)
,p_list_item_current_type=>'ALWAYS'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078159105583643220)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Database Applications'
,p_list_item_link_target=>'f?p=4000:1500:&SESSION.::&DEBUG.::P1500_SHOW:DATABASE:'
,p_parent_list_item_id=>wwv_flow_api.id(3078158764400643220)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078159989275643221)
,p_list_item_display_sequence=>125
,p_list_item_link_text=>'------'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(3078158764400643220)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078160350925643221)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Create'
,p_list_item_link_target=>'f?p=4000:56:&SESSION.::NO:56,103,104,106,130,131,35,227,3020,3000,3001:FB_FLOW_ID:'
,p_parent_list_item_id=>wwv_flow_api.id(3078158764400643220)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078160769374643230)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Import'
,p_list_item_link_target=>'f?p=4000:460:&SESSION.::&DEBUG.:460:P460_FILE_TYPE:FLOW_EXPORT:'
,p_parent_list_item_id=>wwv_flow_api.id(3078158764400643220)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078161069192643230)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Export'
,p_list_item_link_target=>'f?p=4000:523:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(3078158764400643220)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078161487249643231)
,p_list_item_display_sequence=>155
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(3078158764400643220)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078161868785643231)
,p_list_item_display_sequence=>160
,p_list_item_link_text=>'Workspace Utilities'
,p_parent_list_item_id=>wwv_flow_api.id(3078158764400643220)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078162240228643231)
,p_list_item_display_sequence=>161
,p_list_item_link_text=>'All Workspace Utilities'
,p_list_item_link_target=>'f?p=4000:182:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(3078161868785643231)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078162630383643232)
,p_list_item_display_sequence=>162
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(3078161868785643231)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078163040097643232)
,p_list_item_display_sequence=>163
,p_list_item_link_text=>'App Builder Defaults'
,p_list_item_link_target=>'f?p=4000:800:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(3078161868785643231)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078163837405643232)
,p_list_item_display_sequence=>165
,p_list_item_link_text=>'Workspace Themes'
,p_list_item_link_target=>'f?p=4000:763:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(3078161868785643231)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078164275460643233)
,p_list_item_display_sequence=>166
,p_list_item_link_text=>'Application Groups'
,p_list_item_link_target=>'f?p=4000:722:&SESSION.::&DEBUG.:RP'
,p_parent_list_item_id=>wwv_flow_api.id(3078161868785643231)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078164613494643233)
,p_list_item_display_sequence=>167
,p_list_item_link_text=>'Application Express Views'
,p_list_item_link_target=>'f?p=4000:714:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(3078161868785643231)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078141528445643206)
,p_list_item_display_sequence=>168
,p_list_item_link_text=>'Cross Application Reports'
,p_list_item_link_target=>'f?p=4000:9009:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(3078161868785643231)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078141956352643207)
,p_list_item_display_sequence=>169
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(3078158764400643220)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078142705697643207)
,p_list_item_display_sequence=>200
,p_list_item_link_text=>'SQL Workshop'
,p_list_item_link_target=>'f?p=4500:3002:&SESSION.'
,p_list_item_icon_alt_attribute=>'SQL Workshop Drill Down'
,p_list_text_01=>'tab-sql-workshop'
,p_security_scheme=>wwv_flow_api.id(477077192833096450)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078143128111643207)
,p_list_item_display_sequence=>210
,p_list_item_link_text=>'Object Browser'
,p_list_item_link_target=>'f?p=4500:1001:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(3078142705697643207)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078143529916643208)
,p_list_item_display_sequence=>220
,p_list_item_link_text=>'SQL Commands'
,p_list_item_link_target=>'f?p=4500:1003:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(3078142705697643207)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078143937072643209)
,p_list_item_display_sequence=>230
,p_list_item_link_text=>'SQL Scripts'
,p_list_item_link_target=>'f?p=4500:1004:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(3078142705697643207)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078144388250643209)
,p_list_item_display_sequence=>240
,p_list_item_link_text=>'Utilities'
,p_parent_list_item_id=>wwv_flow_api.id(3078142705697643207)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078144706995643209)
,p_list_item_display_sequence=>241
,p_list_item_link_text=>'All Utilities'
,p_list_item_link_target=>'f?p=4500:1005:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(3078144388250643209)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078145128474643210)
,p_list_item_display_sequence=>242
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(3078144388250643209)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078145586826643210)
,p_list_item_display_sequence=>243
,p_list_item_link_text=>'Data Workshop'
,p_list_item_link_target=>'f?p=4300:1:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(3078144388250643209)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078145948828643210)
,p_list_item_display_sequence=>244
,p_list_item_link_text=>'Query Builder'
,p_list_item_link_target=>'f?p=4500:1002:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(3078144388250643209)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(31854611787430473)
,p_list_item_display_sequence=>245
,p_list_item_link_text=>'Quick SQL'
,p_list_item_link_target=>'f?p=4500:1100:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(3078144388250643209)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(670879766511904790)
,p_list_item_display_sequence=>246
,p_list_item_link_text=>'Sample Datasets'
,p_list_item_link_target=>'f?p=4300:100:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(3078144388250643209)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078146321304643210)
,p_list_item_display_sequence=>247
,p_list_item_link_text=>'Generate DDL'
,p_list_item_link_target=>'f?p=4500:12:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(3078144388250643209)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078146722860643211)
,p_list_item_display_sequence=>248
,p_list_item_link_text=>'User Interface Defaults'
,p_list_item_link_target=>'f?p=4500:813:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(3078144388250643209)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078148775937643212)
,p_list_item_display_sequence=>249
,p_list_item_link_text=>'Schema Comparison'
,p_list_item_link_target=>'f?p=4500:1350:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(3078144388250643209)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078147198629643211)
,p_list_item_display_sequence=>250
,p_list_item_link_text=>'Methods on Tables'
,p_list_item_link_target=>'f?p=4500:120:&SESSION.::NO::P117_CREATE_PACKAGE:TABLE'
,p_parent_list_item_id=>wwv_flow_api.id(3078144388250643209)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078149179229643212)
,p_list_item_display_sequence=>251
,p_list_item_link_text=>'Recycle Bin'
,p_list_item_link_target=>'f?p=4500:1070:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(3078144388250643209)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078147910858643212)
,p_list_item_display_sequence=>252
,p_list_item_link_text=>'Object Reports'
,p_list_item_link_target=>'f?p=4500:1042:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(3078144388250643209)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078147534907643211)
,p_list_item_display_sequence=>253
,p_list_item_link_text=>'About Database'
,p_list_item_link_target=>'f?p=4500:36:&SESSION.'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''ALLOW_DB_MONITOR'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_api.id(3078144388250643209)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078148308650643212)
,p_list_item_display_sequence=>254
,p_list_item_link_text=>'Database Monitor'
,p_list_item_link_target=>'f?p=4500:11:&SESSION.'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''ALLOW_DB_MONITOR'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_api.id(3078144388250643209)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078149561859643213)
,p_list_item_display_sequence=>260
,p_list_item_link_text=>'RESTful Services'
,p_list_item_link_target=>'f?p=4850:500:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(3078142705697643207)
,p_security_scheme=>wwv_flow_api.id(477076806710096450)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078149987941643213)
,p_list_item_display_sequence=>300
,p_list_item_link_text=>'Team Development'
,p_list_item_link_target=>'f?p=4600:1:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon_alt_attribute=>'Team Development Drill Down'
,p_list_text_01=>'tab-team-dev'
,p_security_scheme=>wwv_flow_api.id(477077791361096450)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078150391370643213)
,p_list_item_display_sequence=>310
,p_list_item_link_text=>'Labels'
,p_list_item_link_target=>'f?p=4600:300:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_api.id(3078149987941643213)
,p_security_scheme=>wwv_flow_api.id(438801654750439842)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078150783002643213)
,p_list_item_display_sequence=>320
,p_list_item_link_text=>'Milestones'
,p_list_item_link_target=>'f?p=4600:200:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_api.id(3078149987941643213)
,p_security_scheme=>wwv_flow_api.id(438801654750439842)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078151130796643215)
,p_list_item_display_sequence=>330
,p_list_item_link_text=>'Templates'
,p_list_item_link_target=>'f?p=4600:1000:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_api.id(3078149987941643213)
,p_security_scheme=>wwv_flow_api.id(438801654750439842)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078152307541643215)
,p_list_item_display_sequence=>355
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(3078149987941643213)
,p_security_scheme=>wwv_flow_api.id(438801654750439842)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078152786311643216)
,p_list_item_display_sequence=>360
,p_list_item_link_text=>'Feedback'
,p_list_item_link_target=>'f?p=4650:8012:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(3078149987941643213)
,p_security_scheme=>wwv_flow_api.id(438801654750439842)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3078158358931643220)
,p_list_item_display_sequence=>400
,p_list_item_link_text=>'Gallery'
,p_list_item_link_target=>'f?p=4750:50:&APP_SESSION.'
,p_list_text_01=>'tab-apps'
,p_security_scheme=>wwv_flow_api.id(438801654750439842)
,p_list_item_current_type=>'NEVER'
);
end;
/
prompt --application/shared_components/files/nafpeobdfpjcaijo_png
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000500000002CC0802000000340B88E1000000017352474200AECE1CE900004000494441547801ECBD77941B497E26980609244CC2DB02CA5B168BDE34C926D96CC79E36D3333D1A6934D26A5623B72BEDDB77';
wwv_flow_api.g_varchar2_table(2) := '7FECEDBF7792DEDDBE7D6FDFD3BB3BBD59DD7BABD3EDCACD9C344E1A8D66A62DBD37C52259BE8AE55140150ADE2580CCFB1259045128C3A2E9168B8CEC6A303232E217115FD89F89085A96656AD5B3A6E7AA50C483204010200810040802040182004180';
wwv_flow_api.g_varchar2_table(3) := '2040102008100408025B00019AA6914B660BE49464912040102008100408020401820041802040102008100408024F8C0061809F1842428020401020081004080204018200418020401020081004B602028401DE0AB544F2481020081004080204018200';
wwv_flow_api.g_varchar2_table(4) := '41802040102008100408024F8C0061809F1842428020401020081004080204018200418020401020081004B602028401DE0AB544F248102008100408020401820041802040102008100408024F8C0061809F184242802040102008100408020401820041';
wwv_flow_api.g_varchar2_table(5) := '8020401020081004B602028401DE0AB544F248102008100408020401820041802040102008100408024F8C0061809F1842428020401020081004080204018200418020401020081004B602028401DE0AB544F24810200810040802040182004180204010';
wwv_flow_api.g_varchar2_table(6) := '2008100408024F8C0061809F1842428020401020081004080204018200418020401020081004B602029AA7984959969F2235428A204010200810040802040182004180204010200810040802D508D0345DFDFAA8EEC76180D763742BFE15C7A3E6868427';
wwv_flow_api.g_varchar2_table(7) := '0810040802040182004180204010200810040802040182C06A0454D617CCE67A3CF07AFED5A41E9901AE616EF15AE3534D9DB8090204018200418020401020081004080204018200418020F0E40854184FD5017677331C6F4DBA74854AF587877AAA016A';
wwv_flow_api.g_varchar2_table(8) := '8255BFAE19A03A09E2260810040802040182004180204010200810040802040182C006085458DC8A038157BB57FBACA6A98679640DB04AA89AD7858FFA2A4952C55D9D5E4DE0EA4FC44D1020081004080204018200418020401020081004080204811A04';
wwv_flow_api.g_varchar2_table(9) := '547EB58697543D194639CBB93A0082A99E354456BF6E56035C49188E1A77B50F7860F56B254C75926B7A5607206E8200418020401020081004080204018200418020401078611150D9DA9AE283B9052F59CDFD2240850DAE44814375ABBF354454CF47D3';
wwv_flow_api.g_varchar2_table(10) := '0023553C2A21382AECAEEA503F55EB81559F4A949A1C9057820041802040102008100408020401820041802040102008AC46A09A9555794C95E30577894F70AB9E2CCBAA3EA05071ACA656F1D9940658E560F15BEDA830BAAA3F7EE153715787AC24461C';
wwv_flow_api.g_varchar2_table(11) := '040182004180204010200810040802040182004180204010D82402E075D507E12B2ADF6A07BEE213D860FCDE0FBB7C4F92FAA99290FAFA081AE00A4F0B122AF75B2A9572B95C85F5AD30C0AA03C1547E58755412260E8200418020401020081004080204';
wwv_flow_api.g_varchar2_table(12) := '01820041802040102008AC8780CAAC567E5507F85E38743A1DD85D38F00B865475830355B962956955C3AF49FCE10C7035DF0B12157617EE6834FA939FFC048E0AEB5BE1782B3C7075AA2AA96A1FE2260810040802040182004180204010200810040802';
wwv_flow_api.g_varchar2_table(13) := '0401824005816AF6156E70912AEB8B00787DFBEDB71D0E07DCAABFEA59CD0CC3BF9A4285ACEA783803AC9256438316385BB8C16A6B349A9999993FF8833F503F915F8200418020401020081004080204018200418020401020087CAE08F4F4F4D8ED7655';
wwv_flow_api.g_varchar2_table(14) := 'F78B84C0A282FB5599DE0AEB5B71ACCEC9A61860952EA8E0811B89A9BF2A33BC9A28F1210810040802040182004180204010200810040802040182C0534700DCA8288A20ABF2A7D0CBC2A1F2C3E04FA1FBADA87FE15F7157B2B15906584D40356CAE2400';
wwv_flow_api.g_varchar2_table(15) := '4F8BC55AA1451C04018200418020401020083C1E0238C263F524FD78A448AC2F1881F20AEC0B4E93244710200810045E5C04C093168B458CBD607D81823A7B562B8155CF35B95F7CDA14038CC815802B3C70A1501004E1D77EFD5F553E551C8A91340EE9';
wwv_flow_api.g_varchar2_table(16) := 'AABC13C7564000B5B6BACA50F1CB67A86D8522903CD6205053A76A6DD678D64421AFCF2602EB0DAAEBF93F9BA520B95211A8E9834AC7A4290DC36A38161B9C70B807016A6B2180755149920BC522FE51734E06DBAD5583D5B925836A351AC44D10786611';
wwv_flow_api.g_varchar2_table(17) := '301A8DF97C5E3DF20ABF6529A4B251179CB0CA0C23E7EB71BFF8F4906B90547215A27080DBC60315B3F28BFDC0AC6E153498BC31F893678B2240A3BD10AE778B56DE1AD95617620F3E90EEF9008B2DE8AAA9BE9AD72D58A0173ACB0F065B1DC799CD46F0';
wwv_flow_api.g_varchar2_table(18) := 'BF2F341E5BBCF079B19448A5C1066FF17290ECAB0890D195B40482C0338D40743144C91277FF811E587DA004C6A34893CB4F851FAE70C5AA63531A601500950DAE762B8C7021FF4CC3433247102008D4F2C00491AD8C00A9CDAD5C7B6BE69D6359A3C544';
wwv_flow_api.g_varchar2_table(19) := 'B8DF35C1D9429E3A2D6BE0B591A5ACA21B20CF738000196C9F834A2445787E11C00660489151BE6A1617AC2FD855E881C1FCAA45C76B85F5AD06E3D1E4CD2A51F5174A60A97C1A563539E27E6E1058B3B93C37A57BB10A4236163E4FF50DB504799E2304';
wwv_flow_api.g_varchar2_table(20) := '607023980DBC4EFB1C95E9C52D8A41AFD31B78AC915E5C089EA79293C1F679AA4D5296E70E81621106378A49B2FA60E0C50337B85F94557DDDA0D09BD20057A8A80E90C60337FE7FE4F18148D436A88D67E6132A17AD0AB604CF4C8E48469E0801ECD8D7';
wwv_flow_api.g_varchar2_table(21) := 'B09A875BB693EEF944307F419131FC42E289ADA26BA457B3F05683A89E6B055F8302F1FA6211809D965EC77FB16992D43E2F04203886302395CAAC99C0BA6265195A8C9AAEBB2601E2F9852200D131F43C48B2A24AFA4293278911049E3D043088ADE80E';
wwv_flow_api.g_varchar2_table(22) := '32A5F69127CC2968961736CB64900A9E6A9F35E9834F019B8BB8EA03D6178E6ACE45655A416ACDE88FC0E1A8842ABF4818E73DB0EC9A64D7F02C17475145295C39F8E7358210AF6705014996969696BC5EEF43DB1F6A94CCDCCF4AB5AD930F8666509B0E';
wwv_flow_api.g_varchar2_table(23) := 'A783A5D7EDAECA00A19CBDA3764FE82F48075D07CD7F696F8CEF894402BF66C18C7E5A9D1D658CADE18A31D85212CD94EBBD2CB2AC0E4FDCCF0202344369340F33C5CA6629FCA1831A0C946EF5B91BCF4239481E9611D0ACB32A82C6006BA6F20929CA70';
wwv_flow_api.g_varchar2_table(24) := '8BA7AC2756465A745B56EDA4CB34C83FCF0402344B27E349AD566B301894A1F4610FEA7533C11E46867C27083CA30860E15110C5543ABD2C5A07F3C93282607EC2ECA2D72493499C68A5F620FCC2B6193CA65EAFDF88324DE3302A044048983D835BC103';
wwv_flow_api.g_varchar2_table(25) := '52AA03BFC8EDF250BB0E95476080AB29A89D1C4BAB6ACF0DDC18DC753CA76528E5942E8A2950542E572896BEA0B32294AA7AC481E991A29427B38D063EB50E54D05494CAF401C646006E26CC06983FC9278836E2F198CFE75B4D0465C96573B1D812A440';
wwv_flow_api.g_varchar2_table(26) := '65A9B5EC7038B105BDBA749558280296E46892EAB968651C00D4BAA54680CA9AA042A4E2D8A052368EF880C27DFA1B90AA04AE382AC437194B110A20E826E6CB4A12AA03912A702904148DEDC327DD1A226BBCD2146A13D785AF71CCB79222CD711AEC5E';
wwv_flow_api.g_varchar2_table(27) := 'E3944C6381C6889294CF156A98ABE51CDEEF47154CD6480E34F1A7ECBE5005788F5C0444DFA0C3624883FC0C8C9ED2AACA209733F3C8A92889DCCF27E86CD02C6BCA581614287944E29B8FF5D899AC491D74B2D9AC22E3C4A4535568F42A41C020CB2D87';
wwv_flow_api.g_varchar2_table(28) := '47E650590B77A9628EF6ED810EA3502826D7514CD524F1A8AF68B4E58AA8CACDFA2436AE5CC4AB342D35A4FABB4CAF5C28D58D14F10981D1182AB5A0F894B7FD9445AC9BCACFEA9C5632509D99D5C1541FA4F898C954510480556F2B9DB8E4F0DE3DEAFA';
wwv_flow_api.g_varchar2_table(29) := '756A66067A28AAB999DAB3876A6800D3BC321C797B5610C0D92BABB3822921128B60E188B5104E8C56FA4B79DDA06C579364F0CC2E978BD370D592C74A3B54BB40B98BAD200C7FACF0D0FC9EA4B5AFA0485E562280A93C9349C30F0CF0CA2FE56EAF54CC';
wwv_flow_api.g_varchar2_table(30) := '8A475D88AFF0C20B6A6855C8DA30E49D20F0CC2380EE00AEF2D6ED5BE74E9F365BCC1891745A5D369BF99DDFFBFDD5A3D3239506D14F7DFA71CF8E9DCDCDAD9006E260E7AB572E6391F3F2D163B05EDC8014CC9FD1C1101219532D9F410A6E353F0FCDD5';
wwv_flow_api.g_varchar2_table(31) := '6627D10A39953A12283F9B9AFA355056580C86645C1E1F9112718AD7191A9AF5DE403C9515C58DCAB641B137FF09238F58A26831C319F4987436F98845892E15385EF7D02898A570F623231738AD6E6DF2E0187305962A723A5E0D802C81BF60A434A733';
wwv_flow_api.g_varchar2_table(32) := 'ADB77C42988244496242AB33AA33E52673BEC9600A93466105B9AEFE16E55A931426ECE9E9C99BD7AFF9EAEA32D9F4DCCCCC2BAFBDD9D8D0C8966FA0AE895290A95C2A6132F214CD816349E50A9C9CD3F242F5345F898215412E9DD5F12CCD603B5C2D96';
wwv_flow_api.g_varchar2_table(33) := 'CB8014B2E872D8CF5E895576D0D95C4EC722115E614AD679403F9FCBEB6008ACD11570598528727AEDFAC12B54E85C5ED43212C3F1453085B99C56BF51AB40CEF21047497956675855880ACD351C4A01653A9F4A180D3A9AD5164A324B8934739F9F5923';
wwv_flow_api.g_varchar2_table(34) := 'C603AFC7AE4D24AAD369AD3CC7CE4EC9F8130BB4D562EAD896120CC964BA2CB978900A90CDA7733A838260362BEAC0312B87C0D7020E9AA24425E3098D249A0423CB3DDA8E3835BA9C4BEB8CE8B078AB7D92D9BC51C7243312AF296974068C75182E79E4';
wwv_flow_api.g_varchar2_table(35) := 'E6115719209D97A8742C46CB45935EC7E94D0F1D2E911570BF895C41CCA4184A120C3A96376DD0E4AAB24E8B791197DC6CC4EA54857E0C27FA14AFE74D8607C6B4A578387FF93B8CD3AF6D7B9961D85C4E4C24D3EBF5EBC748518D22C94C3E95E40DDA35';
wwv_flow_api.g_varchar2_table(36) := 'BBED6AB222BA5E41D4EAD12A567F547CB2F9828E29329C1E32184ACC660B4C319FC14005AE82D5E98A6008CB31D14DB245AA98CFE9B58CC16855C632A50751C968829545C16CA299351AE7DA4956F9021FB46D2D27B3AC167729A0C16B951109DD70EDEC';
wwv_flow_api.g_varchar2_table(37) := '428EAB6191F61A3C4F355544DF60B0AD0AB9D289C27EF619F5E77F4EF5F72BB300FEC02FEDDF4FFFCEEF50070EC0BD32B422908E46930E81A3340F9A41262D6A3592E689ADAC53794927A538BD22EC2FC954301C638A29AFD3C2E8849A6CACF75A94A97C';
wwv_flow_api.g_varchar2_table(38) := '2C65B48197D818AEF5086C61FFA25C9C999D45053AEDF67436134FA6C0B642BF61B75B7193E56C3804ED87D56A05335C29643693E3790D4D6BC4922CE5D3FCCAF1100D355728A513714E239B0541A6B1967B10B74284383646E0717AA54A71E5D484EA80';
wwv_flow_api.g_varchar2_table(39) := '61CEE0E0C09E3D7B349A95B3F6CA901BE7877C25083C3902CA5451BB48A6D654693C525A2CC75EBD74F9934F3E0C85E6B70B3DD95C566F305CBF76FDB77E1B56664FD4CAC15620CB3FF9C71FBFFFD5AFF9EAFCE07ECF9F3FF7D5AF7E6DE3251992C4E573';
wwv_flow_api.g_varchar2_table(40) := 'B2B4BC071881F1800D063FACBAF18B02E21768A8BF35E57D847948A5A592C32F186030DA35E4D67AA5CD569371299CFDF3EFA4FFFB9F657EF8DDEC5FFD3FF91F7CD7444936ABB0DA5848A9372C1215CDB59237C5AD38F0AB7A2A5F55795AD9A1AC471158';
wwv_flow_api.g_varchar2_table(41) := '09A8FC0FA7E251A2D8543C424BE0AE95F0B3C9DC6CDF3596C38BB262404825DCFD58AABB4831A9A528AD2C216030C8CCCE25C203439C0EB11F44016544BF9F936537AB61276613A17B43342B2F67A69C33645B0D8F48C15032159A83398D1A00F4E762B9';
wwv_flow_api.g_varchar2_table(42) := 'C4DC9052B672A6CBD97F403999CECA623259608393C3B45C40283C0F5257A3542DF7978994A9DC6FFA28E51A0FB206D38270385C948AA099C965E05E23DCFA5EA090C9645ADBDADF38F9A583070E154AA5C1FEBB8383FD95E651898A5C2D654A9FFEE24C';
wwv_flow_api.g_varchar2_table(43) := '31318DECCB34737E602A78E70CCD4224A23C4AED946B487D2DD0CCD4E07429174760F8E0FFF2C7F2B24FA93276312D4F0C5CA5E51CDC4A009A06C7985E5AC26A6A626EB1900CC2F8BF0205B2B14CA7DC7EF02AD19A81F1F17C640CCBD9C5542E7477106B';
wwv_flow_api.g_varchar2_table(44) := '865A6CCB74F325261B0F97AB11EB567A68623617466571D19C18BC8D8A2E956B40494A49A5FCA206861B8280E1B9787CFC22C3E8D472A9A540424AC0AAC015A05407B058CA33E73F3D9D5E18C1927A262AA6A34190ADAE5005E41ABE4196C3E110EA1169';
wwv_flow_api.g_varchar2_table(45) := 'A14EC3A11004666A666AE8AF7E05250DA771580CCCD50B99FFFA2799EFFDF7CC0FFF36F317FFB77CED32B8604158C1C0A3A8199A193C33404971ECB1B87D27985E9CA842F8010E22458F4D844E5DBA72F9DC67998571B5C8C85E7575ABD0219F0A446518';
wwv_flow_api.g_varchar2_table(46) := '15B70A0E030E530A0E8E53F48396AF8644E892CC9CED9FA0B28B67AE8D056F9FC6B691744E1A189ED0C819A67CEA3D42561A9542AF4C1349A3F8CB6EE5BBCA2CD183E3C133A7CE9C3F7B66E2F6D5A29840003C4A8ECA595A8D18BEA6F2C5EB03F7CE9C3B';
wwv_flow_api.g_varchar2_table(47) := '7BF6CC67D17BBD4A53AC8A02D24A89CA85ADA4880090640427A7A5EC7212A8D3D5C4955CD174341A8DC562A000370CD7E3F1381C6B065EC3B3D236303467B3F19FFE70E9934B92B1BB1C126DA7767D5C9DDBE552283957B2A136D7EA006B24A714964A88';
wwv_flow_api.g_varchar2_table(48) := 'D4F95357F2912125CB6ADCFB002A742AEE32322CAB995C482DDCBDCE6A9765016A1208A7D247BAB7C743F9E05D9AD18432A5F078DFC058F8679F9CF9D94F7F74F3F4674343A39F9D3FF7931FFCD3D9B31FCFCF8C9F3E7FE9D4A71FDEBCFCA9989AC7A80D';
wwv_flow_api.g_varchar2_table(49) := '22F7C28953672F5F397F5A8C069541A29C01A53CF76B1F1E6A0115CFAAEC2D87842F4B0D8E4563D3FD889CA198A1AB77E47C4CBD4FE13E32E598880BE533C3A4E219A99447BCD5F8201C8C6516C20BB25442B95299D4C2C2C2EA601BF9DCBA45FDD11F41';
wwv_flow_api.g_varchar2_table(50) := '54277FE52BF2AFFD1AF5CD6FCAEFBE4BCFCF53FFE93F511313AB23C68AD4871F5F4CCD8D563EA1CA076FCF25A6C72B3E8FEDE80B6616C6AEA8D1C716D21F9FBA74F6D427A9F991CD138C88A5814F7A211FDB7C94672A24D63CD33333994C16B982D00D6E';
wwv_flow_api.g_varchar2_table(51) := '68FC369B4308730A85A686FAD6A6C6E6A606AB5900F7DBDC541FF07ABA3A3BD054AB0F8E4663CA49D4ADEBA34C3186612B96298446C61916DBDB945E832929B69462E8E26C34FBD967172F9DFDAC189F5D67C4DA6CEE5EC070E89ECA009B581E60239148';
wwv_flow_api.g_varchar2_table(52) := '1A869D6B75E4CD8083233682F3C1FFF6E7FF2D97CBAB33DA666291300481A78E005617855221914CD4FC550BD71E2F515EC7FFCDDFFE654343E3BBEFBCDFDCDC02CBE7C1FE01B7C7BDA642EB519378EFFDAFB4B7777EFFEFFEBF7FFCD18FCE9D3BFD8D6F';
wwv_flow_api.g_varchar2_table(53) := '7C735B77F743075895FB55F5B1F805F78B74D5A54EF5EF7A9979B806B87AD90477E55192D984C491E7B5022F677FF16785813EC3377E5BD3B3AB343D29E772B25E6F603569BD3699CC3E18739415835828C2C83C27E839566FCE263212C4F9463E5160C4';
wwv_flow_api.g_varchar2_table(54) := '6CDAA4D76205ACD7D232CBE75219DEC8479359A990B30A869CCC95C4542E5FB01A348B94FDCE999F1ED8B3DF5ADF8D551182E4A7A7ADB198B6441BCC968C28A593319E964C5621277199E8929E95171861E8C38F0EBDF592606BA068369A14D9D97953D4';
wwv_flow_api.g_varchar2_table(55) := 'AFA338DE60CE15E44C32C26B18BD608EA5F2253163E2359CC192C8E44AC574687EC14B85186A4734952B8A198B911719BE908BC3B6C968829D00946A7A9EA1B3997C1EFA023167331BAC462DAFADC38A349ACA42CB6131F11467805BCEA77446F385DE3B';
wwv_flow_api.g_varchar2_table(56) := 'BB8C114BCF5B8CAB0E5A36A8CA0BF934B45E7AA3359E15E5425E2A88568B11627E88358A329D4C419C5C024A22CDC9251166AC1C4BB11CD49BCA92B77A4C873B9D4A9F3AF5D9DEBDFBEA03F5376FDC8CC7A26FBFFDEE3A0BF2B59B0D88E0417702B767B7';
wwv_flow_api.g_varchar2_table(57) := 'DA8C82E9FCB9B381FA06ABD58626F8200E4D150BA591A1C842577FBDBD752125CD8C0E361BA74B34158B24C0D8A3D44586CF67B2F962CEA06538A3D5E5B7C9AC219D4E65F325AD5C106CE69C4871529ED209A55C2299D74542335271572C19877EDE6231';
wwv_flow_api.g_varchar2_table(58) := 'CC2499C98F3E3AF4E5D75C5681D553996C369FCF011F8BD9847A8B44D34C29C7E9A06DD242EB2B51747031D2AA2DF23E2A858A0B86B1865D4A668BF9B48967F5264B3C93471BB39AB4E3716DF4D28FF69DF8155EB0C2D8763E126D28868DF5542A2FA6E7';
wwv_flow_api.g_varchar2_table(59) := 'E669B6279512F399A449CF69F4A66822851405A341C3EB63A99C2C66820B0B0E71B2443331451955300BC65C91C9E5B2D0511718AD98CD580C5A8E37A26ED0F2B1F556616AB19582A6D222331F9EEABF2BBEEC694EE468B39C0498E81050516A35ACCC72';
wwv_flow_api.g_varchar2_table(60) := '79B1A883F4A04AF3032257AE5E753A9C103C4F4D4DDDECBD79F28D933A0774D44AD53FEC918D269336391AFDFEFF415BDA8CBFFE6DDAE628F4F731B042A16994484149B130597E0A34151A9BA72837D664C160BCCD0E130E299D881A74146FB4C5D33968';
wwv_flow_api.g_varchar2_table(61) := 'EA6C267E2C4A4DF45E3C7AA0BBA0DB2DD3995C3E0FCB5B8E2999CDE66C892DE5E1230A3CAD33DAD2D97C369DD4718C6036E7725201FD3E8FBECCEBB57ACEEFA6282E9ECE16B249B3912FD07C2E93E419466BB68C0523720B1D4C64F97BB7DC6DDD05B63E';
wwv_flow_api.g_varchar2_table(62) := '148AC8DBDDD1445ACE670483BEA4E50B7990160D3CCCB93554210B199C4CEB62A98C2C66059381D5EAC1DE8C0553C19BD75E3EDC5E3278FB7AC785918BE68E372511C604A259CF680D161543F039D02D97DD32B0B8DE3F654E8F6D3F74302D16A45C46A6';
wwv_flow_api.g_varchar2_table(63) := '8A18108AB9A480838C8CA64C814A2723D80F60B6983046459329B9983770DA82DE98588AF9BC2628C10AF93C041C1094A0FEEF43BBFC2FE4A06363A3C1E0FCF1E3C78B85C2997367DADADA1D0EC743A781157450F53493EE1D08FDE53FE8EAB6736DAFA2';
wwv_flow_api.g_varchar2_table(64) := 'C5AC08507E41DA183A1291382B15CC762191837A3FA9D750468B359347AED35A8C21BC39198F6A29D9880E452B5A50A5E7C30E4A695D6A0363228BD1502A151C5A6AF3F5640B50C966603FAFE74A06B315E396984DE935ACC16CCE14A4541C4D858DA5B2';
wwv_flow_api.g_varchar2_table(65) := 'E9A96953D7128644DE20E44A54261685858501FB88C07DD2D4DC52AAB338032D61522CB2C1A91D87F796B897D2033FD973783F6B70D81AFDB7FEDF4F8FBCBF43E43BB4B72F1D7BE9C8A7D3CCC2E0D9C0E15F87F0F75AEFC40177D6D470440471594AA430';
wwv_flow_api.g_varchar2_table(66) := 'F46761195E64F4F95C1A909A74B2D660CB89058D5C2CD05C369934E818ADD11C4BE7A8424E51E96B0CA2513F3732E669DD115C6492A951896E5D88C674541173472E5B128BA25ECBC282872A1578543A867648F7146930D8E1323CF7B1C64B2C113B73E6';
wwv_flow_api.g_varchar2_table(67) := 'CC4B075F72B9DD9094A37D9F7CF3ADCD4AE261FAF5177F417574507BF7521F7F4C8F8C2843794B0BF5C61B8A42F8FBDFA7FEE37F54241055CF48309D5898EABF9D3E186893193EB4942C66633363B366A9A075F84D3673345DD2B3A2328565536EBBC018';
wwv_flow_api.g_varchar2_table(68) := 'AD69749B529113334E9F272F71F3A1053D9DC79A269EA5924B0B7693CE60732E25F399A585F199A2B3B0CC489FBA32B1CFBAE8E97E3D0B3B084A8A26F2D958C4ED10688325BC10A1F359B7CB5AE44CA96494CA8982C336BF98D0C9D98CC93EDD3F53176E';
wwv_flow_api.g_varchar2_table(69) := '847E1D80C090A42AEF5BC0896EF8F39F7FD4DEDEBA7BD7CEE1D1D16BD76FFCAB5FFD86D962D964D6517B6824B178229BCBF8CAAB4698434762314BD974AF860818EBB9A945EA80057D0E4D94F7B933393A9D583469E99CD6F4E947D7DF7ECD6DD1B5BC7C';
wwv_flow_api.g_varchar2_table(70) := '74775FDFCCECE878CBE1C662D5DC5B438DBCAE4600E00F0C0E406D7BFCE831C8F44F9F397DE0C0418BC5F26883ED7DBA32ADA89E52A934AA18A67B982F50DDF73F927F09025F1C02384E60291CB971FD5A4D92C78E9F104CC266679F9AC8E5574CFB1CA7';
wwv_flow_api.g_varchar2_table(71) := '7DF3E45BF5F50D68DE0303FDA32343C5EA35FF5AB136E387FE8235D16B6FBE79FDC6D53FFDBFFEE47FFDE3FF0D2B1F70820F8D5B843152D9E659E977E59C8094FA3C342E026C6A0602B91A5ACB295499EBD404505FA12486BD33238E684CDF35FEC6FFCC';
wwv_flow_api.g_varchar2_table(72) := 'BFF32B4B19799C6B83D28499A19ADD142C0F93499C97B83C52C04E76B07721161E88E4923D56BDF7F02B977FD16B76C63BBAB75D1A4C8667FAF6F85D05C1D5E561F39E9DE1ABBD961D1D172E0FE462136FEF6A1B37B6E5462F0453DC2E2F936B78B9AF7F';
wwv_flow_api.g_varchar2_table(73) := 'CCCEE9F6F99B28DA04D56B282186CE5F759692075E7BF5E61844E4BD0E5A7CE940F770363074E9A73B1B9D51674FEFC0A8B341BFFFB057A20D8832BD941A397DB1832F751F7DEBF6E8FCF0CD8B012375E4CD572E0FE4E787CEEFF51B5A8E7EE5F2F5C15C';
wwv_flow_api.g_varchar2_table(74) := '6CB090D6F85B2C4B69F1B38B7DF185A1D7DAFC4BBE7DE1BECF0236D3B64347298D3138B1641732D32929B938155D48BC7EC03BA9D9D9901F8B508EF397AFC90BE3AFEC6C36B41DB974A9974E4D366FDF37383C8C2CB77B76171646299DE9FC95C17C7CBA';
wwv_flow_api.g_varchar2_table(75) := 'DEC6EC3978FC933B8BF6E8E4522276626FABBD7D1F165ED91273F956BF1C8F1CDA1548183BC5C5315963B2E86887D703BE8B2E16743A1D383DB5465071169BA5A1A1E1FC85F32E97737161F1C4ABAFA2B08F211C42BB83D5D6AE3DFB385613595C48C6E3';
wwv_flow_api.g_varchar2_table(76) := '569BBDB61948B22BE09A9C5C0C74C56767F2668D462B70E922F5E9E9DB627AF8E48EB66CFDBEC18FAFA4CCE90626B7ED952F05C7C68DCD8D93437DF13C674C2DBEFCFA9EC1A8D024F6D11D1FCCF6FD9CF3EDC566E36481F9F4D28DE2DCBDD78E774D171A';
wwv_flow_api.g_varchar2_table(77) := 'AFF50F35747B9668EF0E2F77795A2A2DDD8B4553AF1E682EBA775E3875D528C72403FFFA9E268DB7879660B9A7990E868CDA7BA185889B2D40417DF5D2CD5862AEC56EDC71E8D0B96BF7527383AF1CEA9E8CDAC76F8FF8037D2DFB8E826D2ED19A99F052';
wwv_flow_api.g_varchar2_table(78) := '62E2DE7C3C6EA6F30951BE74F54E687C6057BDA1E5F897CE5CEF4F8EF7BFB2AFDED673E2CCD5DB9AE84C8262583F373C9FB87EFEAC3EBBF8DAD17D5359EBD4606F7BBD73245ECC2D4CBF76B0DBDEB4136C445E04D797D16920AC583ED8A6A34197D2B52D';
wwv_flow_api.g_varchar2_table(79) := 'DE1B64F82E88FAC19E07C3619E2A5A4D3C6FB1E3C877ACD0610A5AC1196AAE9E9E9ED3A74E459722E18585AEAE6D66ABB237A3126003078630032C51E7BEC7EF1CE3BEF4279AE66DC32129B9AF136B6AC39CD4E665B51C9B29142B1339DA9046A3B02878';
wwv_flow_api.g_varchar2_table(80) := '34E8C35ACDCDFEF0D4E02707DB1DF6CE574E5FBC1D0D0D1DEFF24F453CFBBA1DDE96ED52A9C8D2AED170FADC6717ACC5E03B274FF467BDF1A1734B7169BB2DDF78ECDD1B7D23A1992148AC8E1FDD3F302AC5160767E3C9D7DA04A9ED95DCD880C6E9B87A';
wwv_flow_api.g_varchar2_table(81) := '7D201D197AB9A77556DF7EEBCC477E4E3AFADEEBD82907B35B8F55E68503FDBDBD4DBBED302D8605C7A53B938B772F1DDBED939B8F0EDCBA924F94BC8298E51DE9A97B6FBDDE13E1BBAF9C3B975E9C3BB6ABB17EE73189E5E747829D8DA6BA96ED5896C6';
wwv_flow_api.g_varchar2_table(82) := '76EF8DDDFC1F77358BECCC8D85786997ABD479EC3DC83E8024846A8C5CE479F06B6C5294922313AF7F754744F2266727CD7673382EF55EBD065D7DBBD3D2F1D24B839399C9C1F37C893DB8BBA5E4DE76E9DC559D2EE5A484C65D5D0CABC1021516AAC968';
wwv_flow_api.g_varchar2_table(83) := 'C8CC6B150640B1535D515358427576744D4E4D7DFAE927382281E7F5AD2DADAA5073837AACF9048A508B877FF451E2CEA2FF95DFD038BC60CE2A2AD64A609C9C381B4ADEB878C943A777BE72F8E26834313DE4D6940EBDBCB777C1901D3ADBDAE84B9B5B';
wwv_flow_api.g_varchar2_table(84) := '6F5F3D2B48D9575F7BC9E8EEC2780E096351E100A1F050AEED11652A3C37F3EAC1E6C1FEC5AE5C78246299EB3F2F26690B173F7AE2E8DD1966F8F287CD82E6E5F7DEEC1BCB4FDEBDDA51A7E75C5D337171EACCC53693D879E4E4C064B4FFDA3907239E78';
wwv_flow_api.g_varchar2_table(85) := 'FDB0CED15E1635D053E1640CDD2D9AF5CB22C4850EB7461B149C2E0F640A1263310B568FC71514CD3CA731980C16332FA5C4729397BD66219E2839999CD916082745E09F0E4EBDB2D71BF3BE74AFF712B8C57A4DAAE7C43B43F716DD6C6422A51FBB7DBD';
wwv_flow_api.g_varchar2_table(86) := 'C3C66C3BF1EACFAECDD4E767F6EFED62749D5D01CBA55BF61D99F9D00CED757B6E87C43B572F3A98D4F1575F199ACE6722D32DADF5D38B6983A6D8D5D99C8AC89CCF9081956A41E4719711C7413CA4828CC6E372B83C1ECF9933A76D365B34167DE38D93';
wwv_flow_api.g_varchar2_table(87) := '5828AFACF34A85AC722C2E52D000FFBB7F47FDF11FD3C3C3CB9F0706A8BB77E5FFFC9FE9BFFB3B6821A9AA3342B0EF60E976FF919347EE5DEF95329145CAFBE9E94B9238272F1443EEC6F90BD78FBC7DE8D2AD708F2F757E38317FF7FA7B07EB9C473EB8';
wwv_flow_api.g_varchar2_table(88) := 'F0F1F98C912ACDCD7DF0F513C309D785B3A79B0CD943AF9D3C7B636EACF7CA814663CF1BEF9EB9329D9DB819A6CD4CFB32BF1DB01AA341CA5F483A030D9154E1F4D96B73C3B7DFDCEBF11F79EF17E76FA547EF7CEDADAE74FDEBB73EFBD8C3699DDB769E';
wwv_flow_api.g_varchar2_table(89) := 'BDD657CFC5BB8F9F582851A72F5F8480F983AFBCCE599A5695F999F6C0ECB37FFFDE9FFDFCC329287F67665F3D711C02C4CDE718E291B1F189D6964698EDE140142C82B099DF6432F50F8DC286AF865D421B82A594222365E8C57481B937341BEF9ABEF6';
wwv_flow_api.g_varchar2_table(90) := 'F3031DFE5CDDEE3BC3835D9EC9CE975B8279281824DE649225C45831986C3E632F66C8925CDAB66DDB471F7DF8F1A79FE472399BD5E6ABF33DEA600B0B17A810A6A6A761DB323131C1B2E8A9438A7287659B9A9AA0E4DFE45CFC62560129F5E782808CCD';
wwv_flow_api.g_varchar2_table(91) := '31387409AB8B150F16728F30FBAC88BAE2051B57F3621E72701C4015892C99CD96CA127145B847790185BC98BB78E1BC9ED7FFF6EFFE9BBBB76FB7B6B63536363D9C868CF314147953CD5313115FD7CCE40AF9714D9CA7F00A90A0AD2A2465CFBCF49262';
wwv_flow_api.g_varchar2_table(92) := '89371A94FEF49FC5FFF3A7E2FFF283DC60B004E5CF8A54B0265B4809A9D957DF7C7328A8492C8D87A7E677EF6E1C5AE01707AFB9BCF6D991708992E667E7E6669634D6E88573D34C7C94373BC6EF4C051716F5A9B9DD870EDD09E6027A717B5763E7EE9D';
wwv_flow_api.g_varchar2_table(93) := '3263C4593925892915732FEDDF1129192786EF8506EF7EF9F84ED3F657462EF5CDCFCF37D90CDEE68E409D7B676B4367CFEE12AD83BA47A4187D297AF8E8E1D0A4786F3E3C78E52397CD3899A2E293032E2B6FB63BAE0F2D8E4EDD332CF49F78FD0DD6DA';
wwv_flow_api.g_varchar2_table(94) := '0C73B95B7743B9A93B3687F3DEC0DC7C74914FCCB7EDDD2BD35A300C4B91542E119F9C8F356A13DEBDC7670687165399422AF4C9F5296D7490B3B806C6827D83C38D52F0D897DEA96F68C6AA77DFFEAE1CE78B45824323737572E8EDB7DE9CA61B17EF5C';
wwv_flow_api.g_varchar2_table(95) := '1E9D8E7478257BE7A1D1B1690D8556A82822AC666BD160094D8C62B15E4AC6EA03AE0263105349CCB86090AAF751A21D60E9BA6BD76E4C96376EDC0C04EA1B1B9A367D96D98ABAC20B16045DDDDBB7EFDAE5F3D6959542B50130D3FBCD5CDCDE3E333190';
wwv_flow_api.g_varchar2_table(96) := '5C9CF5367A957D7D25C9E333963496A1EBA3C97C327E6FF4C8CB7BC3734C7C29B8343F9FCA6617EE4DBCBE2FC036EF99BEDC17CBA50AB19902AD5B5A98910BB00B830558C163B6A7F48EE981CB0D758EBD6DCDFE8EDD6836523E3E31B3D46DCB3BB61D99';
wwv_flow_api.g_varchar2_table(97) := '9A9EE8EF1B6F32C5F69F7C732A542AE596CA46F414F6130E8D4FF7F7DF9D1A1DC25EBF8189C5062EFCCEFB6FCD65BD9343B790D0CE76BFC5E66DF0FB766FABF777ED55943A948C2DDE831341C4BA373CC0D0E9FEE904A41B82CF3B1E5A2825836E93B528';
wwv_flow_api.g_varchar2_table(98) := '78C7476F8D0DCF09D989135F7AB5A4F7A0989F5CE877D0912C6B9D999A9C5B8C04B884B57D772932BBABA391B7FA202386DC616A2179ED465F747E143A246087FFF5B4BCBDBBE5DE5CA2988942D33B379FB069335E7F2027696137A1D1624BD8F2F27A19';
wwv_flow_api.g_varchar2_table(99) := '6B896A6E6AF607FCD76FDE40F89DBB76A27E51CBB535B1CE3B266CA93826EF3350F57E04F987ABC53FFB45FE7FFF51EE4F3F147305BA7A87022822E122A31C83806605A91B966C4BD3A1769FE06CDEDE7B37949AB86D733946FBE7A5E43C366B42200EDD';
wwv_flow_api.g_varchar2_table(100) := '054E3DD532729D47984AF1A1A9C18544565A983EFCEAFE5B739AD1C9092E78E7DD774E689CBB26067AB1A5D021CEEF78F9D5C95B73293109B38A5B534BF6D8C8EB6FBD656EDC61A464A7CD370CEDE1DC106C1B90558C7BBB3ADDB352203276079840AEE9';
wwv_flow_api.g_varchar2_table(101) := 'E27594B56E7CA42F1A8F2DDEBBF7D2B1B681BB991E9728057A96EEF55E1B99A322431A6BFDE4E4082D66D19058BA04D98D4461F8A4752CF6E41B609DCB4683075F39747D92D2E46155CBE44A726FFFC4607F2F8D410C96CC00365BC4EA752991BB74FDEE';
wwv_flow_api.g_varchar2_table(102) := 'F495F3B72742CDD4DC1BEF7F7920220C0E0F2EF45F7BE35077E38113976F4EF40D0E355353FB8FBD194E70C56C140BDE74810DCD4EEA347456628BF9D47DB9DF83BA41C5D9ECB61D3D3B46474766A667F6ECDE236077DFA66B739910AC3CA682C14B4392';
wwv_flow_api.g_varchar2_table(103) := 'BDCE7212E22D884BCA6DA6AAE160D8CD529A81BEDB875A4DFBDE7C6B3ACAD3F377DE7BE308D3B87FE2C275487B7C74CCD47EE8E6854FED5A312C999726EE288031F4E85C0CE3463A320DCCC1E80513C5C59161CE6488C1C477767C292F25A7EEBDF9DAF6';
wwv_flow_api.g_varchar2_table(104) := '0563EBFC9D6B36BDC6E6A81B5E589AC3F2BDEFEEDBAF6CEBDE7B2C23EB5929B3EFD0C16028110C2FDEBEF4B1CB40CD15F9C40CB6B92AA315F6350C4F86FAFBFB2747FAA5425A15F0020345C95A7E5125BE2C25CF27E52B37EFE466FA5C2D07D020B02DE7';
wwv_flow_api.g_varchar2_table(105) := 'F08156F4FFABE72FC782A3BD43D3C5E06DADA76EF6DEF0422C518C4D1D3EB46B34624B2C8E4467E7E6256EECD2C70E8F752A968E87A66783C15D1D1EADBD0989407AA8F1D5CD8E4E25E2B3369FF3D3737D7E533E92D387E72667C34BCD76AA64AED76497';
wwv_flow_api.g_varchar2_table(106) := '025EAFCC19B329E53CC7423A65326AD13DA57247562B02158733C95089582EDCEABBD5D4D45CEF0F3C82A83197A360DA138928475E69B5CAA9573889077293A6261AA6D4D3D354D9DCABD27AA613C5C8FC758B8E9A8E5893C1E173A3F1F6D2D8C9935F16';
wwv_flow_api.g_varchar2_table(107) := 'B5100B308BC542687E569A1CC46E79BB60639D75FD572E6572E9B1A1B1E31D16BA7EC774FFDD5B977BDFDBE73EFCEABB7D117EF2EC3F38FDCE91F985E1E181C2F8EDB7BEFA3A6B6E28C2C2A1FCBC7EA8A110D87BE6F4C5E050EFD5F1F0C28D8F04BF7778';
wwv_flow_api.g_varchar2_table(108) := 'A05F4A857D822D6BF58DDC3A174D668A33633B8FEFBB7265E29D9DC291D7DF2B193C626EE9D55DDD12647C1596BE528067DE8136DFDDBDCD5FE73B75EAB4209876EFDE8585E623E51A8BB5D9B990115B7B59065A476CFA0D8642309A05E535E8607657B6';
wwv_flow_api.g_varchar2_table(109) := '1030C95C29313F170E46DA3C166BA03DE0123A9BDA3A761DCC51FAE1B1C9522ACC28D65E44FFBB06841B78A127BA5DEE9EED3B0607064261AC3377C1C2F351075BCCB6D3B3B3DFFDDEF7FEE66FFF1A524BECB4F8E18F7EF4B7DFFD9BEFFFE0EF63516527';
wwv_flow_api.g_varchar2_table(110) := 'CB0619209F08029F0702300476B9DCB0EBACF9339A8C8F30FBAC9F33705FD39353D35353E1056CB99BDFB57B37B88CF5836FF60BF6FD5E3A7FFEAB1F7CFDDBBFFDBBE07E7FFCC3EF43CAF8D001565918605DB0728DB4F670BA5646369B6F3501FC563B54';
wwv_flow_api.g_varchar2_table(111) := 'F75A6497FD30A8CBA5A2C49AEFCA2D9F852653854C878FFE9FDE660F77CAB0AC3468A9C22AAB1D034B593C0D3A96636C6659CCD743DCEFABC75ADBC8325E9BB5FBC8F6A68ECE7B8B4C74EC4A5DFB0E4994043DDFE473B51CDAC5B1BAB6F680DBEDD79B8C';
wwv_flow_api.g_varchar2_table(112) := '1AE5482A83B242538E8A855D5DA9CD6373FA1B4D26B798CAD8708C0F6FB408BA7C5ABFA3DB96D237DE3A75594F2571DC943A6061ADAF938A0D81566F8397957D623ECFCA9CD56ADABFBD3D66DC367FEB94DB618E7326F0B476875EAB134C266309FC72A1';
wwv_flow_api.g_varchar2_table(113) := '08BBE83A87A3E3E55D2CAD6F6C75EA8C30E3542636E404F2598F9EF237B57BFDEE42CEA4ACA51996170B66BDA6D1E7E9DABD339496AD4E1DD46AD007EA95D3C0611180835F681D965B261BA3E16CB0A4CD962C365D734BB3C9E54B702CD87A84199E8AA6';
wwv_flow_api.g_varchar2_table(114) := '831336BB399FD7821110CC30C9E3B00B3C5FA47399ACB2F7B6AA862091C01ED19B376F6A39ED810307E6E783E3E3638F7D22091A00AC0A0B2236023F3094AD4AADEC94A59E9686333783DEC23DADB31566E137C623A5F04D87CB9BC4365931DB5CE7F736';
wwv_flow_api.g_varchar2_table(115) := 'F938AAAE201695FB5A64CAED35727A9B45D0C36A182292688A4D2597CA5F19D8490C8F2C8A736336AF279FCBF238BB580BD0949D98E802768BA6BEA9D9EDAD83709711331046E8341A8B03266A4A3BC7EAD9AA2FBCF7DA4B1F7CF04B47DE7A57969D345D';
wwv_flow_api.g_varchar2_table(116) := '14AC06B41C8DD56CA0325D3B5FEA9B13E706CF1B61DBACD1AB4A33C43271C5F78EED45AC136F7F8561BC5081190D729D53D8BE7BFFE4923631D6EFF43BF2251C4892740A0E8D566B360BA86E43B16036193B9AFDDEB6ED660D1BA8F3BBACA6D69D47AEDF';
wwv_flow_api.g_varchar2_table(117) := '4B8646B0431862160A472F59AD668E37A90C2B7E8B25C967D7B2DEEED0C4083A0F5792700503380D2889D199D0A0D5900F4066A8D1D1D1D07C08E65BD84876ABB7175A62D4F283001BBA8A0539ABEBFC34AE1B88CF88A5C2D70EB0BFFB1A6337D23A458F';
wwv_flow_api.g_varchar2_table(118) := '059BAE158B2A3D8CB4EDC6D8DC5C349E96C428CF72DD075AE60BF6FEF367B1FBC0A4D3F8ED8E9EC33D4C6BDBD8E46C0AF37F2A9D4AA5EEDE1D120A21D6EECDE472E09B9BBB1AEA6CBEA4D329E7B236BB8ED36087811196B3565AF6B7607169CDE75C38B3';
wwv_flow_api.g_varchar2_table(119) := '0E35BA98CC0A4E2DC7F05986BD7BEEB6DD54E0041B6CD49502295214CAC8C93D3BF70C0C4FCBD9859985F46CEF6D8FCF26A22D8AF986769FD71B08E81CCEFA068BCDA99C8C204A2683A1D16F6DDE7650D6F0D82AA075B826E617D391F9782A3D776FDAE6';
wwv_flow_api.g_varchar2_table(120) := '15349CB6A53BE0B17AE238313B8F9D7ECA406A110C4693956294035A2D5A4DD2679D1D1CABB350074E1CC28936E0F12D4E0B0FA183D58285AC60E5B5BCD9C46B71644D3A9BB2D7B9B41ACEACA889A0B75F36D1E1B55AD064B4383DABB66E90DEC2E2C2DD';
wwv_flow_api.g_varchar2_table(121) := 'BB77BBB675373537F5DEEAC57EE0CD8FE62A39D47D78742114A1840FDE357477A0932AACEACA0783023696964A59A3D9C860312E956C263BABD599055EE9747CA9B1CD077373AA047DAB696787DFDAB00718828691D75AAD16D89023EF6057EF4D2C4693';
wwv_flow_api.g_varchar2_table(122) := '73308888856626C7C75929EB6A706838C12118221979E862AFC3CAB206612991B45179EC1941B3D731525B9DCBE9F7B31A673E9BC3D00A03F5DD1DD0C5EFA4704D0CA5F0C7EFBCBCFD830FBE76F44B5FD1F02E65964162D5335CD98D1F1D2B9B8DA6637B';
wwv_flow_api.g_varchar2_table(123) := '3AF4DE4EECB38520434C260EF4040C2D87A7FBC768390B6BF7468FB979C73199D1D535D479AD6EE7F6B6EB97061AF461C6DACAB379A7D5BC7DC70ECEDC68B31A9C757ED87C2BBD4C96EA7D75D74617EAF261ADA7D594CFE190A19EAE46ABBFDDAE659C6E';
wwv_flow_api.g_varchar2_table(124) := '9FC7AAB705BA46A717C4C46C79CA80A808630CCEC242037F00352A2E97CF615782C928ECDBB77F667A6A626A0283D5CAAA58FF4D102062A4FEFEEFE56F7D8BDAB74FF93B768CFAEA57A9AF7D4D86FDB3C351731FD2BD60646A2671FAF495F9C2CC68EF9D';
wwv_flow_api.g_varchar2_table(125) := '5426EE6A70613C85D99BD3A873D4C31EE1664B833C53B0CF0FDE0CD4BB44D104D1E0368FE06EDB0109662C29D1D114A4B1C850A144EBF9629DC7BE77FF41D9E0711BD17A75168795C6D69AF29389670E76B83D07DFEEBF3C26151382416EF238B6BFF4E6';
wwv_flow_api.g_varchar2_table(126) := 'DDC96276BCDF13F0E6B359A9586CEB72E82C019C6DC0D94056C67D00AD3697B7A1DD65F665D28FC63AAE0FD317F7054DF1F6ED3B0B8B8B6FBEF97A5E146F5CBF01CDEDE693472B86054D637D1DC65618BED96D36D8ECB89D4E4C01CA64B0F2C1C8838B26';
wwv_flow_api.g_varchar2_table(127) := '93C914B67ED014B60D51BB77F9C3B2FBEEB98B5A26ABE50DE8D554513C7EA05BF6EF0F4E0C412EAC2E365692216FEB22809E8B5DBB30E3ECD9D1E3AF0BDCECED8548E251075B6CB66C08347CEB37BEF5EDDFFCF6C9936FA191FFCA2FFFF26FFEEBDFFCD5';
wwv_flow_api.g_varchar2_table(128) := '6F7CD3AA1C6FB662025D372BE40341E0A922808607A3869AE7C9B9DF52A9D8D6DA7EEAB3CF7EF883BFFFC1F7FF0E86871F7CF0F5DFFBB77FF0342897FAEFDEFDE55FFD667B672714CBEF7CF9CB2DAD6D77EFF48191D9181845247E9F07864B7951160BCB';
wwv_flow_api.g_varchar2_table(129) := 'CFC671F1F521D4ABE3ABA4551FD55D3B665787BEEF568C7CEC0D97ACBFFBE1D88D341768B736A4B4899184B6B3AEBBD1C1A632F9FB0197FFC5CAF7CE647082BAEC977346D7415E484B45AAAEC1169DF0E4D3458DAEE8B3F0372C1DB6F405BBD5D3B8479F';
wwv_flow_api.g_varchar2_table(130) := 'BC3B0B1E8CD35058DD520C8EED918C060858D90257373932B5CDD308552ECE5BC10D21D81FAD37686D4E7E584C9D3B775D2C32BBF7DB12699DCCE619835ECF949206C7C4F8F8F61DAE120EAA86299B1E96A725BDA0C772C7EDEB128BB1822461DB277615';
wwv_flow_api.g_varchar2_table(131) := '6A4AB45D30B5D6D92F4FA617AF9C8987B28676637D836724E4003FA8657446834153122089514A25C906A396D341B72FC1AA89A365A3CD1C9135B0C76DEFF62DDCB64A62DE201B77B4365CBF38E8CA9EDBB1AD4B30DB478687ECB690C960E6FD9E3BE7EE';
wwv_flow_api.g_varchar2_table(132) := 'CD652F89F9A477FF76F360AE08D349963219B18914FA385421B8FCA286960D265381A223F13C76B772ACCCDBAD995C79E9583D31E2D09A687C6A7AF2D04B875B5B5BCF9E3F8B730B9B9B9B97D1DFF43F9827C01F96177F98CDC1973D58F6556828F33DCB';
wwv_flow_api.g_varchar2_table(133) := '184D068FC7265346778331ADE3B1B5120AC462418B65AECE6A06CC5AC1288BB2D1824DD53AF0428C463BBF94BD72FD562E933F7CC03BC7F96E2D08C6DEB32686C2F9CF46832587C39C39091B140D16A749434534D6F9A9110BF6856B34263D44252C10C6';
wwv_flow_api.g_varchar2_table(134) := '8E5E83AFB1BFF7A23573353A37C9ECEE449F004C46DE50A4251C03869B28603AE6B1DB7AFB32FAD4697DB460EEE80987137AE5CC33DAC4CB770BEEF0F8907FFB6E650B16AF2B8255C789AC52096934BBCC497B4F3E97644D5686E2B29A124F492693CDD1';
wwv_flow_api.g_varchar2_table(135) := 'ECBD79612675EE4A269A36B4585ABAFDD9E9795D41C41E481EBB51353CCC2473B98409C7A6E1B0358C1932DDE032367977421884834001A18E91F5261B44F94D8D9EB1C929AE58E05D4238BC241416612A0146A180A370572E95B0ECC746A696D6D6970F';
wwv_flow_api.g_varchar2_table(136) := 'BF0CB5E1D5EB57BBB66D83BDE526B5FAF96C4674FDCAF74717AC777EFCE5D6579D7AD34C69295E6C7AA72BC0D13870F7C1112FA84D6C2CB676052EDEBCA2318A1E7D58EFDA919BC8528CA4914C8166DBD8A213103112B76F7BE0D2A9E96B97AE62FF4357';
wwv_flow_api.g_varchar2_table(137) := 'B303C29F6241E3E0D02B2C609235B441924B1683CEEF142E8D5B83174EE7D36CE79ECE5C9163344AE18C56EC76E728A3B0ABD175FB13267CF54C534373414717E982B2D15A27609B310D537A230F43C2A63AFD8067279FB8549275798D64A025A3054229';
wwv_flow_api.g_varchar2_table(138) := 'AE543E1DDA60455A1A340D8EB77438DCB38B36ECA5D768DD68BA3838705BABF3F29CEFF2956B254E60E251F71B7BCD23C803644F92DDC8CBAC1663AB9EA57777374288A69CB62FCBB8C86DCFEE6DD7CF5F342F5C4A974AFBFC022E01BB7221654A9C6B48';
wwv_flow_api.g_varchar2_table(139) := 'A7B7EDDF7FF9CAF4F9ABD78A25CB4B6E2EDFD87DE3F22987743DB614D2B09D5A1D06264E30398B721ECDAFDC776A4750E813C6C6C620CDC1466EB120FEE2A35F4C4C4EECDDBD77339B611EF43B598E84B3F48103FE6F7D85554E2C579EDA1E2A5366ADE4';
wwv_flow_api.g_varchar2_table(140) := 'F0755EEABB10984E38B66DEB1F2A662E5CCD670B870E7A9612666CC517B4B23FD0952F4DC9C5A216F654E5A9A6CD0F6DE11E8869C070E6290DB3187CE7EDE3664FFB7C86095DF869299B989D8F5DB97255CCA57C3BB70F84B113BE60124C754EDB644A77';
wwv_flow_api.g_varchar2_table(141) := 'FEB3ABF5CD1E83A14E6310E89204EB658799F7D57588A5205D2A717CF95C685A36197412AB2F77D2126B508EE6C6D54E3C0E5380F18722CA920D36088C701A90D4E4B3EDDDB34B32B8D1C2940188A1C667A389A5A14C9E6DABF3F08EC044D097CF67345A';
wwv_flow_api.g_varchar2_table(142) := '1CF00DAE5E5F924ADDF5BE4F6E180E1CF45AADFAF9BADD857C8AE66DB8A2CF6C405341DF5716AC48C5EDB55ECE70CD1D1A3D6FADDF569FCD062D9852B45ABD41697BB823A058C8F0989BB17309A2440D9DA4F96C2683419E5358E1E5C11098E348B36030';
wwv_flow_api.g_varchar2_table(143) := '78F4D8517F9D1F9B81070707EBEBEB950436F380C57DFB6DEABFFC17FAE449EAB77E8B8245742C061B7AEA3BDFA17125D29FFC89C21E573DB89AEEDF7EE390D6BF2F5E92CFFEE8B3835EF1F479D19DBC9A4D2EE8B56D4D6D0D43573E6A7EB96B18BB80A5';
wwv_flow_api.g_varchar2_table(144) := '122B974C0E07C46AB020C760A4D3321E8B657A97E7F4A99B0D7E7B7BD7BE85FAC318E218C116F07B7F76C759B8703EB9C8F09D8AC52F301A9D8987676FA48B6C4F8B4FEB735F77EFC2BE56DEABA7B3DAAC16461F94C9E633701A5A6FD351B26D5FF3D953';
wwv_flow_api.g_varchar2_table(145) := 'D7FCBED9FA1DBB0D4EE51069BD09724B6355DEB78613BB436FDEECDDB76FEF89E3C7AE5DBB71E5FAB59D3B77C04663B3B99724D8C3BBDDAEE9995908496783F382C988A56A476BF3D59B7D354430B5E738EEEAAD21876551E76992CDB65C3ACF70455A6F';
wwv_flow_api.g_varchar2_table(146) := 'E0307AD8CC3363A329933EBA309ACB483DCD1D12B6E8AF9C1A6A0892D71A04D03D87878761A5FCD69B5F4AA6921F7DFC613814C6A2E8D1065B49162C42B7BD1BC30066742CF9945D4866E586761C9F81B1AB2651F24A10D8BA08E0849D6F7DFBDB105B43';
wwv_flow_api.g_varchar2_table(147) := '4E8D5260DD8F5D5A38A7F3C94B84CEF81BFFFADBD868066E0ED4A0C2F9F2FB5FC54183CAAA7BC347ED61CA12E77E5FAB38104F75E3B776FD739F26FB877FF887F7DD6BFF8BC895475161940FDA829605930134CF5ADD46F714235584C446AD6667F75C26';
wwv_flow_api.g_varchar2_table(148) := '7476EEC695D09DABA1DB1AAEF0DB0776B80C383C23B522550D1B1E095B8D256FC0DFB1BD55C7DB6D5E1B0EA1C2B94426AB172B69684EF466ABC761F2B87D8CDEE2739A18DEA1D34866337C5C46B35BCB699C368B115B736C757A9E376176A735462D63C1';
wwv_flow_api.g_varchar2_table(149) := '36329DCE22804DB1FA7DF512CDB6782D9EB69D3019E6296C05693023BCDD0946D524280A43ACB44D2EAC0FB456B7D966C32AA0014258BD9E6FF0D8F58E16B3A6D4B9A3DDEDF0187D3E4E96BA3B1ACCBE0EB7C3A813DC1A4682C2C7EBB69B6C6E0D6EE529';
wwv_flow_api.g_varchar2_table(150) := '3FD0AB98EC5687C3A683C211867256DBD45CAC8E4FB677EFA1F52E1D5B320B267FC0C5DB033C4DD96C5687D3C57082D765B23AEADC4E9BC1E2C505813BDB037A679BD7AC87CACCA4E39C36281B958B9DA0BBD018058749EBAB6F5A1259331D33DA3C004A';
wwv_flow_api.g_varchar2_table(151) := 'CB2BBA1DB4242CB52BD5AFBEE218B7BA401D5A599DAFCEE1748235AF0450338C5AC6CDB14EA8E9EEB7AA4A35C1260172D35C368B7B0BF18B738B707CE5BDB111BB22C9B65587C732104B43BBDB0EF142477D00EB5181C7A92BBE7AAF1D8BCE3A9BB6BEAB';
wwv_flow_api.g_varchar2_table(152) := '5B305BAC3E17C7E9AC2E41B00AD83017A74C52FC9EDFDF8E2D889640B7A0D7F04E974BAFE9ECDA6EB4E0CE08A7C7EFA1F5E680153AF66EA351D03BDC02AFF1FBEAF482DD69B382CB32E83416ABD361B7826B05E3825DAC3BB7D5CB3A3B349A36B3592F38';
wwv_flow_api.g_varchar2_table(153) := 'A167869ADD68B7B9EC66DEEED2526CF7F646BDBD01E726794CDA86CE5D46039A8E4739D6CAA42CD7A07B37585C38B6089214D4A31DA79A7BBC58C143C11B08783516A7DBC0B5776C079226AB47ABA17ABA9B2DEE967A9FB7C4E2D4360AE76A389C0EA3C5';
wwv_flow_api.g_varchar2_table(154) := '09DB5D581378CDDA40E71E46A36CFA05BA801A521B155E68B4AC760FAEF6D172B4D761E305BB15E5E78C48D70C9D21C72BD5A454E60A7103AAA9ADB50DB6007687BDCEE78700087C54A5BEE040781C7189DA510516954F481D1B4DEDE68043F05C0BF75D';
wwv_flow_api.g_varchar2_table(155) := '09DDBE1CBC7D3B32F252A3F7977A1AB2B9348E275B91964C055C56DAE07418A8CE1D3B399323972D183552FBCE369FCFAF135CD024A28BB96D567F7D63A1C47A6C5C9DBFD9E909C834DF566F7735B43904A3C50C0DA1CE6B352398A5CE0F9EA6A5D1EB0A';
wwv_flow_api.g_varchar2_table(156) := 'B40866BD01D5074B079F1DC78659B047D66E367A0238BBDD63175042566277B406CCEE469FC3069D2C5A1B7A13C430D0FA7ADC5E97C7AD73BB1D5ABAA373BBC5E672A15AB5BCCD6BD59904AB1194BD1E978D353939F42F6CA736E028081A47DFF91A1BA0';
wwv_flow_api.g_varchar2_table(157) := '62B79BB43D3D9D9C25E03468AC563B36AA230B08A3D88E287A5B2C6B962B0888610704FA174CDBDC368BBFADC58E03EE1C3E3D2577F6B49AED1E479D8FA675750E5343F77693412868040AA7B8CB85A6409DE0F2EAF53ABDD98C2A84DC07772FA36B56EA';
wwv_flow_api.g_varchar2_table(158) := '427580C734EA8D1DED1D06A509F2D02D58CC160EEAF8AA75142A1157C6E3173BF0ABBB1BF26632EAB560FE6177CEB02D6FECB037BBA0FA559A4BB9C180874FA571E2E072E381C984DB6DA5758251876A7238DC2DF8D21E70DA1A7A6C46C8A9DCD8E7EBF2';
wwv_flow_api.g_varchar2_table(159) := '7B6556073B05D415B4BE0A1ACB2D56C91064382E3B6F717A39DC6C66E09C4EFF4C8ED115630DFE86EED680CDDB26F89CB84A68477BA3CDDD505707C51707B30EAFDB090316D8065BED76D8F7381B1AB02D03C7D40149082A90393BEAC7E281204B11F359';
wwv_flow_api.g_varchar2_table(160) := '9D0CAE8FD350569B1BF23114067BD0EDA856830922210BC658DCA9765FE98AB2F2821159F47B2CF5ED1DD818C20976ECA3B4084637D46D3617CBA17DB1FE7A0CAC3EC8622CBE3AC88F04A3DE6EB37A5D2E9D1EDC9D52E340122C7783CF6DF63681A1ADF3';
wwv_flow_api.g_varchar2_table(161) := 'B88BB4CEA4636D368BDDE1E0718E0805038282DB8C61B74E07C8F1C0FC1E338D725AB442A1F260B46C6A6EF262B86068BFDF8FBBB831D856BEAA0E0CCFE835F7ABA5EA23BC9A9AA8BE3E30BAB2C1407FE73BD43FFFB3722130B48EEFBC43FD87FFA05844';
wwv_flow_api.g_varchar2_table(162) := '573D16A3DE5317806E5000980DDE169755EB6AB168A57D7BB699BC2D663DE7F535DABDB0A332EA6C0E9781EDDAB5C76C76D8BD1E1CBB6836EA2D4E575B53BDA431D904BE29E0B535346374B009A6409DCBE3F3B3B2BC7F778BBBA50B2C33EA486F15F0D5';
wwv_flow_api.g_varchar2_table(163) := 'EF346FDBB7C36EB61911402A3AAC42534B036D72D45B755DDB77596D0EBBC38BFC34FB9D25CE6233E97C3876A229C09BF4162B6A18F3D7F2C107558578D69D68C63DDBBBD1FBFC501AFA03300D586DA4871103F78DD594045D752E1C82FA17B270A9288D';
wwv_flow_api.g_varchar2_table(164) := '4D4CE09056B4070C4EE84BC1F990DD66AFDE328A5661750838C011A7F17B9D4E8BD7AF08BE1919A6213A93D7E680950967B239317E36069CBE96B692B4A2E1D5A44E5ED74400C28BCE8E4E9C63876B7EEB030D10D5E15A849AC116A764414A8FD1784D0A';
wwv_flow_api.g_varchar2_table(165) := '8AE7F290889D6E4B77FBEFBEFACAABCAADA42B8DA7D68D4B3E1004B61402585BE250216C16C0A5BBE87000004000494441541F1CCAE887F9F2891F2C4BD4BB8BAA29ADF6A9FE0A37622D8482903B29EB29ACA8EE3FC8159CF8C5408D07C1AA1F95087C14';
wwv_flow_api.g_varchar2_table(166) := '0AD54BA80AF58A271C58FCA98FCAF482EF05530ED61C0F8E34360AB64AAC351D0007FB0C9D564B812D5E5FB8339B099B39E36E67975BEB588AA5B09D5ACDC7725C1CAB7376ACC996F4ECDC5DC0991E5877C210B32C942F5F36C22ACB2FD8FD2A167DB053';
wwv_flow_api.g_varchar2_table(167) := '53EC825046AC23A19058E622905E398AB2F9021CB3320C81FB57DC280922E23B5E7100609914EE15C0361B16D1410D4940C9703F0A5653CA3E43C50E19B92807433D0304DCB4A3E8221450E472E220A5E084FF9019ACC89733A39C93BCBC6E56328CC8F8';
wwv_flow_api.g_varchar2_table(168) := '29A77E652C9CB875E6D889833A7B23385435FFE50C28C6BC5053201CF6732A392913018058F8A999446D82AA6209AB7C525A1E8A8322A8E51E0D65ED8529ABBF53C9517961B8BA6DAA4D01B92FC755DE547775F5418F3D3939D1D9D985F256FBC38D8635';
wwv_flow_api.g_varchar2_table(169) := '3C3438D07FA72E10504D64D1D860DC77F8C851B747396EA73A7C1979259FCBC803052CFA65094D13B9036465449671C647947474B19419FA70F7E1D720EB56EABAA68A41115A97B2C173B9CE954B387130B8B2322F63ABFCE25E6C869D8E6787EFDE2E65';
wwv_flow_api.g_varchar2_table(170) := '327EB6D079E2A82C61B1B59C0D50A8640C5DA48CB9D200A0AF56EAA2A4086E9104720D4F1447CDBC120B2F4AEB42BDA39E9526A4D61AEAA0D284147F252FCAAC085D2F622BF75BC0038F429645DA304640128ACFCAA74C5F695AF046BE142A48B46CBFAA';
wwv_flow_api.g_varchar2_table(171) := '045F2B4A39A47256139E1A77853686009CCCD1D4D48CBAAB78AA0EC4C249B676B379363B7F6B69205DCC068CDE7DCE6E1CBC1D8B2BDB2F6BC2033720566EB1D0E3A21E151C5040E4B9D2F881091A955247287BF97017743724B4DCCC503D38C3AADC8CD5';
wwv_flow_api.g_varchar2_table(172) := '6E55EE7CE89B2860B98CCB9D05384B2ACEA0AF9896AAC0E2B017457FAE347B1593323EB894B78414CB19536A4569046AAB533A8BD2496A72A8964B294E798BAC5A840AE66AF6CA19AA014079557305876200893A45E8F22D2648A25C7016E540152FA4C4';
wwv_flow_api.g_varchar2_table(173) := 'A1DE3E89CED90DF4CE5DFB71EC9692A572CF455C755853C8AD7C96AB5BEDDA6AD597DD9550C8F0DCDC1CAA1212A8EA9E8B4AF038AD46A33E9BCDC158C6EA548FE7415E9466850727A4CF87969043F515BF4AF1513568BDC5E591104921E74A1F2DD7C503';
wwv_flow_api.g_varchar2_table(174) := '7CD66BB1E5568AD0200AE1E3F9F1B8217A63CFBEE3CACDE8E51155AD35B40F0440CE95A112CDBB5C1D6AB74245610041665430955C55D1443728A3AAF82A11CB8F12A05CC3E5AF4A46557F25AED2F094C1506978B0B95D3120979B8442095D5BE95AE57A';
wwv_flow_api.g_varchar2_table(175) := '530243A88B9296C93F20A5B4816510961B3390591EC39539455147972B1494CA23030AA5A0B6E2417EF06C3CD8A2DDD6D779AAAA650505AAB757390BFACC1945F78B40D037BEFA2AF5EFFF3DD5DEBE321C797B561080A4697A2E5C931BB481FE817E9BC5';
wwv_flow_api.g_varchar2_table(176) := '8C1D344BD198D224D056192650E75D8844216AECEC6883E6102DAA12519DF7D5F68986575ED154AF55B0F4542E464280F234FD20628502716C8C006646652028635EEDAEC4C2603233336DC03DE3B8A27955EFAE0483038352229E803516AE63803678E3';
wwv_flow_api.g_varchar2_table(177) := 'C0D511899B204010783C0430B7DEEDBB81E91BA2433C9052A90F24D260CE2B2C31BAB6FA9467E3E5F50FDC48748D391BBE95DE0B07466AF5C1200BEE7725035C340AAB0EFE5D551410C14244AFD39AF44656A35CB59B8676299B818548EDAC8FBB825279';
wwv_flow_api.g_varchar2_table(178) := '8E9596CDE156917A0E3C80FBF462C22247CDCE7A85597B7A0F68E5B1E19A2A4046F38454376080917FC83F224B91F242B69C0E640E2CE374BA959B5D369C241E9A2BA508B007CE27F57A23389E87865F2F0032898343C2E1795E12EB70A10E8743945EDC';
wwv_flow_api.g_varchar2_table(179) := 'F5013AFF7A0C300044F784E8CC68D01B743A2CB24A052999CD80875A0F5BE2BF190430B2A5F2D2E2FC3C6ECCA97339641E86A62B64439B21B26618ACC9D6668071C03BECC2755A5CE38488B87F0E35AB8EF22A1D5C431A8BA7AA7DD6A4FFD89E28725A94';
wwv_flow_api.g_varchar2_table(180) := '98620E53D1D31DD91E3B4B5B22E2431860F450B0BE376FD263638ACD336E45DAB3A7FAF0E72D51C6172A9310E54CCFD632C0400093E6D29272181EA4DB154030D5820D4697C1814C58B1A1CF563E11C7BF38029B67809155F0C0D08F61854C2AF15FBCE2';
wwv_flow_api.g_varchar2_table(181) := '48065E0404B098B9D37703A27695FBADF0C09B67806B35428F8F1A789775866EE41232B6344E9C84456539010CF2582DD572BFF884EDB2266C1A7AC0813F7E7E9ED598181C1B5C669CC7846A7BBA7904FC38324AA6B05B6F9D9AD8747AA81CA898D61CC7';
wwv_flow_api.g_varchar2_table(182) := 'E109E94A1D0E8C59F9C01FCF4ABF477E538A80B501F6FB5509C21F994A99A983B9B5A529808606F1CD9303F218797876A2A03FA136159386B51E744F1C62164BA4E2B4B21F41A9C2958CD35A9188DF4310405730E918737300582A960E4F89FB2D578E62';
wwv_flow_api.g_varchar2_table(183) := '478007D55A9D091825E0BE65FCA99EC9F4B2A33ACCE7C7FD96334661B309A55D61985D9D3A71AF8900E4536B4C855541696CE97FED35E58F3C5B01018CB38AF9C0AA290CB7B5E36FBD123C9509743DE2C4FF311150ACD220A1DA942C1E8B9682B47C4CFA';
wwv_flow_api.g_varchar2_table(184) := '632647A2110408028F8AC0867CC7C65CC9536380D7E77F974B53BDF6DA60BE7F42CEE751A1FB17095F9E1A9F32F7AB16A4DC12562C8B1FAF808C8671389C352BEC0AA9CF75AA5672BF6AE950497AF30E40517388F1E6E33E6F21651C19EB8431FF7AE552';
wwv_flow_api.g_varchar2_table(185) := '3EDCFF5876DF7F592F02F1DF04029F530B44EFC3DDA15861AFE47F3791A1CF3FC8D31A7F3EFF9C3E2B290031986A3D2BB921F9782A08D03436F9677362CD3A67E3A5D85349991079BA0840722908666563307908020481E70E81A7D6B1952D6D64D9FCBC';
wwv_flow_api.g_varchar2_table(186) := 'B40F5869D5EC477A5E4AF62296030B2FD4E6F36C56F122D52A6A13A63E4A6D96D9CD17A9E8CF5D5995032B2883FE4977AC3C77B86CED022926CDBC2E9B7FC8F9A55BBB902F46EEA18FC1F95864B07D316A9B94F28543E0E930C05015562B785F38149FC7';
wwv_flow_api.g_varchar2_table(187) := '022BCB6B68638950E3B9A85CC22C3D17D5B85C88E5DA24DD73AB572A431B94D3BEB55BBD1C35F947FB5C6EA2351FB6DA2BACD31F2FCB388F1DC728E4080FFC78F03D4BB19E8F96FC2C214AF2421078561078220618CCD1FDDD4B844F7A566AF469E683D4';
wwv_flow_api.g_varchar2_table(188) := 'EAD344F319A1854A7D0A46F2CF48615EE86C28DD93D4E6966C029017E3C81C5C308E0BFCB0C7704B96619D4C8361989C9C7C6CD6711DAAFF02DE38F513971EE134D1C7481B7770386C42349EC63D17EA91E38F41844479C6102083ED335621243B2F3602';
wwv_flow_api.g_varchar2_table(189) := 'CA34FA64CBD9C7678031CFE130435C20F86257C10B507A45D1F484CDEC0540698B159154E816ABB00DB34B6A7343789EBD8FD8C2ADC575D838B4F071758CCF5E99967384FB113FFAE8A3F6AD7F4BD3D4D4D41B6FBCA1DC5FFD580F4E2275DAD99C582816';
wwv_flow_api.g_varchar2_table(190) := '8A0A0F4C9EE7040132D83E2715498AB1F511C089FAB8B9F6F1CBF1F80C30D2C45E179B4578FCC4494C82004180204010200810049E1704A038B5D96C274E9CD8EA053A7FFE3CEE287A925240B76FD4B394FE496890B804018200418020B0360260429F64';
wwv_flow_api.g_varchar2_table(191) := '8C7E220678ED1C3D47BEE56DB0D80A4BC4B7CF51A592A210040802040182C0E7834009971CAC9C31F345391109B99C768A5DDEED0C917D7421EEB071B4C6F084B948E68B4C2661C44D51148D84229145AA907739044E6FD924E544AEC0E69246AB42A13A';
wwv_flow_api.g_varchar2_table(192) := '0AEECF531F94A6E63CE7EA60C44D1020083C01028A196BD994F5096890A80481C7428030C06BC386291C13B9549270958E728DECA65860C556786D72C497204010200810040802CF35023443E5F2F99AF972249CBEFED37FFAE5AF1C33B83BD5D2A729EA';
wwv_flow_api.g_varchar2_table(193) := 'E30FAF7CFDA45BE3DAF58478DC9D4F68EE9EDAFFCE3B14C50FCEC407AF9DE68AD2B1979A5DCDFB37391DF74E2D59C62FEEFAD2BB14557B1F5532958A259258A0731A8E42D9C8431020083C5504700C3EB681E0AA65E5BA6522677AAAD812620F458030C0';
wwv_flow_api.g_varchar2_table(194) := '6B4004A6B7502C158BD8BA83CB9D36FD10FE77D350918004018200418020F09C2140CB34E4C6D58582B2777864222F69A647073BDDED79898E8422293A1F9A5F584898ACDA88DEE2588C67CD5C3E5EE0C474DCAAD7B016D7527091628AAC54F478DD794A';
wwv_flow_api.g_varchar2_table(195) := '1B5958A24A59AFC392A60DA9A505AC5A9C1E6B34CB669742C150DCB1B484935090EAEDC1A99DE66CE0D8D7B4A944AE28C72211AA5470BB845451978C2DE9E982C5E35B5848D1C594DD6949E6D9746CC92E68535931170ECFCC054D2C63F5F8B0B5AB92FF';
wwv_flow_api.g_varchar2_table(196) := '9999396C32B3DBED269386A69F60AB59852271100408025508288345A94417680DCB6A3856A3D1102552153C5BCF29CB52512AE257916930B522C567AD3C8401AEAD111870E545B1587AC4D98E70BFB54092778200418020401078A11188E4656966E4D8';
wwv_flow_api.g_varchar2_table(197) := '975F19FAF44ADBFEE8488CBFFDC9675A1B5BCC45AF86DB1BC64EEF38F9FED96B23AF3465CECDDBA76E7FFC9293B7BFFDCB1F7FEFE79E76433218F995AF1D1D493B072E5FD071C59347BACF4F1BA6AFFD82A799B73FD87771C45898BA1294742E4D11CA5E';
wwv_flow_api.g_varchar2_table(198) := 'AC9B9B5BDC93D7586678A0BDB5A56F3676F317FF4489E2D7DE6C19E70E5C39F5B123137CE7DBBFFEE37FEE6FD4DEDBFECAF1DEFE483A32FD529753C3B54E2F6422977B8DD199777FED9758DEA35618CC328706FB398EB3DB1D4435F542376252F8CD23B0';
wwv_flow_api.g_varchar2_table(199) := '999530FA2A82553DD86728968A30B884F188967BD6B9A6AA8C13E7030424B9144D876399703C13118B39A3CE6A333A6D468F51B7D9DD280F687D51AE2F8201C6B1901AC876D8C7B420C2A11A8F77510422428B0BEB65DC4900C1122085707AE35337D1FD';
wwv_flow_api.g_varchar2_table(200) := '60C1B536F70B530D9A46B755ECBB56F65EA5B288D8EA8B6AB2241D82004180204010D812080C4CC6B5F9595D69CFBD14159D1E1808790E7829F3D1AF4CDEF9CBDD01F9C6198D3534A68D4F6BDD2F198221DE621B1E9FDC938D68B24BEFBE79F2AF7F3635';
wwv_flow_api.g_varchar2_table(201) := '3B3D7EB177E6BDDD7260EFD7631475E5AFBEDB694F6575F5E393A1587FEC377EFDE8F76E6BA4F17F041498810FB779EE7227CF5DBE2A2726AF4702DAE4141BD8393F1762FC05A7D33076A594498CA713E957DE69BA9AF3E7877EFECD7FF35B1467EABF13';
wwv_flow_api.g_varchar2_table(202) := 'F4E8E4636FBFF13FFEEC27626454EF5F66804133964860B227DCEF9668692493CF04020F5B092B67EA14245A03DBE71541F182C303F2F902044F5C79B9BE41719652F2624A5E8E4FD32E136535AEA0B641DCCAA75C349A1C1B83FE193E58D17382606E6F';
wwv_flow_api.g_varchar2_table(203) := '6737C17E830550B880B51E641ECF5A5FD6F5C3497BF1783C9BCD2284200856AB75DDA014353D3D8DF0480258D1953C2045F02692E472B9CC66F306D1954F50CE2612A5684C2E887863B43AD66EA385871F668C1BDD380E86306B97AE50CA4F2E0E9E1BF9';
wwv_flow_api.g_varchar2_table(204) := '878985FE583A2C16B382DE6E337876351E3BD8F296C304CB9AB5233E24B79FF3E7CF9D018EC713B76EDFEEEAEC70BB5C8F511651141716171D763BCFF38F143D1A8DCDCCCE4563315437DA44432080CA4BA6D2FE3AD4C4BA8F088E794DDD2F4DE1328374';
wwv_flow_api.g_varchar2_table(205) := '260B26DE6834321A660D1EB84C55992FAB6A1AAD45E928E5533454C7BA69577F402CB46FC5476D3488FA79B61E85B692647516AADD9552547B3E895B15215403F524D496E32E835603945AA81A4FB5B82B6AEA3132A0D6B552164087010817839547A2F5';
wwv_flow_api.g_varchar2_table(206) := 'DAC68A24D41C29982B30E05F34D4E5E86521CB6A6A4A2D28A5B91F458243A6D56B54147FF21004080204816708819C448D0C0E184A54DFB59BB22C8E0F8F092E473241D3F110C62EBF81EE6BDB75EEC73F7BE560EB98E808F7FEB0ED48CFFC5292964A56';
wwv_flow_api.g_varchar2_table(207) := 'C1C2EBF57A93BE94A38C267D22970906E778BBD96A363635781D0DDDACC33D72F76C309A94458EA615A3658C8DF34B29874E0CB475CF8DFDB3606E74D5B91A76B69B1C965FFCE4D2F61EED82BB51A2688386D59A046D8E6278C3EC7CC466CE3152D1E5B5';
wwv_flow_api.g_varchar2_table(208) := '1B7903CB9BA43C94C90F9E55D3C6834FC4451020083C32023455124B63F7EE3537356871C3F6AA750BD64179B1A861585C93BE01F1D303C51F5F2FC25A5AE10219EEFD9DF257F6631C7810633D3EAD1222BBB434F1D77F3DF1A77F2A6532AAA7BEBDBDF3';
wwv_flow_api.g_varchar2_table(209) := '8FFEC87BE4C8C63C305892B1B131E8D29044351BACBE42D3D6DADAAAEADB2A696DE048A55283838357AF5E0D0683A079E4C8917794E30CD67DFEF22FFF0A8CAE115CAB564BB16C39518902D3522CCE86E7DF7FFFFDE3C78FAF1B191F24A93837973F773E';
wwv_flow_api.g_varchar2_table(210) := '7DF55A29068922C53A1DC603FBF9978FB23EEF4611296A3112B1DBAC6B3262D0FDF6CF5EFED1B5FF3A1B1DC548CC300A9F0C6D7024159C8A0C0663935FDDF7FB76E303C1E2C609A533994C3A6377D871C2F3C6219FFCEBE7CB002712C99F7FF8F1858B97';
wwv_flow_api.g_varchar2_table(211) := '7FFFF77EFBF11860F0A313F726A3D1785B6BF39AD0AF094124B28474A76766D5F641D38CC7E332180C68AFDFF8FAD7D68C024FB4BF82B8D691DAE8573235363A3E353D0D7EA3A3A3BDB1A15E617B563EE87EE98294595A72BBAD1070E13B4220FF4A2365';
wwv_flow_api.g_varchar2_table(212) := '19B12871A0A3AAC1F141EDAB2A8D6A3768D2140464A958DC6A36301A6D322BB2C5B441B080C75212AC8E52792DC75AF1554D420DAC7C283F6A4270567D45B68B2599924496D32E135F0EBD9C49842D144A60F969965D8EA806A8265E4D195F2B255ACB1F';
wwv_flow_api.g_varchar2_table(213) := '6CDE7C5CE4F24B76974761F32B8157A6ABBCA9495407A82658E58F5224F31295490A36F3324DC465A8584AD44B399D70DF06A34C1081E39922574819ACD6324B793FA1EA9CAB99A94A42F550720B2234952F48B95452F8FFD97BEFE0BAB2F43EF0E6FB72';
wwv_flow_api.g_varchar2_table(214) := '8E780F2FE0211024488201CCB1A33A4DCF8CA4D148634B5AC992A575F8C3A5AA5DD7DA65D5965425BBA4A992764B5BAEB5B5F22894C61334A15B9D9BDD4D3623889C819773CEE9C6FD2EC006411004D981D33D33F790F570C3B927FCEE39E77EF9E83585';
wwv_flow_api.g_varchar2_table(215) := '7293405911C1C0705E890B06930516A63B406DB4FFCE935BFE40210252697668B4ABD2EA602D2D545A7CBBA6A44983C9C08944B158E579464F636A83495240ACD7D886D155AF9B744A94A0BA2C522A97519ED56B150A8DFE4EABB6D4201FCA08C808C808';
wwv_flow_api.g_varchar2_table(216) := '7CBE08B418D18CB55EFEFACB98B6375CE1E3D77ED4E7B2DD5A9A53DFBAE63483C39F3630E0BC3D49F70C0C49E4AEC9598D26ED0EA38A529B7B6CB07C5B0C2A935A7FB87F74FA8DB794996BCF9E1A3E78EE78E8FA1BB9E6D2C9514EBBE7F0D5F7DEE669F3';
wwv_flow_api.g_varchar2_table(217) := 'BAE32E066B64ACDC8A4E5C43C5F685236305C3E0E46BC1D6C2E2FE41BBC5E34C26562C3A4441EB9D3DA8886BF6BBD419FFE807EF5D3DBEDF61D30C2A2D509DD8E33461AA4F1B95FAF3055CAE5D46E00B8AC03AA1077EA1D972FE473F7AE557BFFE359FD7';
wwv_flow_api.g_varchar2_table(218) := '23D93C4373EF259320F62CC3B13430780F4EA5A698A9085A2542E34893E3AFAE7067FA19AD12E3A508F422B82DD0C05D3F3881EE37F8D77F5DF8E33FB6974A1B9503A7C5A6526B7FF007E29FFEA9F3F46930197DD0D3D96CF6CFFFFCCF378C5281B48704';
wwv_flow_api.g_varchar2_table(219) := '39A55A37B413A2F8877FF887361BAC270F4FCD66F3FDF7DF7FF3CD37C12E1598BE62B1F8D05DC7ABCDC6F1BDFB2DA1A4D6E5A2ED96F5D007587D2DCCB59A25A51A82F6ED5E2B9BCEB4FFE6EF9BB7C781615ECF89F285BCB016E2E371F5AFFF066E36EDF2';
wwv_flow_api.g_varchar2_table(220) := '3858D43EE86EB612FBC1EDBF4C9457695C01BC04408AC13F881D8853BCC85F5F7BC5A4B2BF70E8B7487CB797B259F8CCF4ECC4F4CC37BEFECBBB2BC337F37F9A8307BEE64F53E8C6B3F57AE3ED4BEFDDBC35FEEC334FF5F7F77DB202954A85CFEF0B8723';
wwv_flow_api.g_varchar2_table(221) := 'E148C4EFF33D0A0F0C1602AFBEF6C6EA5AF0A5179E1B1E862F2B3A3337FFB77FFFED42A1F4D4C5F3BB3483030EF80E3F744F2E98B930526F4F4D9F3E750286E9F8AD716080EFC9B17E0215252AECE207D77FE9E5933C6146319113B0D5603C60A19416F7';
wwv_flow_api.g_varchar2_table(222) := '62281BD0D5D5F6414494E63CC49796C41BF0D917119E13244916F0C6EB8A62183885261F999B3F717C9F4829E6C3450F9E500F1D05FE0A07336C0297720992B988C0730449C0194C41160A1179082320CD43E0C63014862BE403E67FA3A9908987A73896';
wwv_flow_api.g_varchar2_table(223) := 'C030110A8106E098D45D518855783EFA41E0C0791487F120CD67F8815B1CD488213C45CF4D87024E44DFE3078523CB423340C683AF67943243C91C0F3D624908E387E3128602D8950810CE80E7C0308323807B06919E14EC00FEB32A05F9C14AC99479F3';
wwv_flow_api.g_varchar2_table(224) := 'B9977FADC311500B98C3400C848D7570BD9D22F883480F11044C26A9192882935032802AB23C4429E15182049D3C346F832D87FE2EC62BA6FA8AD67C42E411801E2488044ECE4713035CD871F03C88C8A05D12990580A0D84C30EBC7332AE398C071EBD7';
wwv_flow_api.g_varchar2_table(225) := '24FA495AC77849F18E4A8D85FFD02938955E0D48DD2498D7ED4CE00047B050AEDD8DCD3B460ECC4E4D3B2D1A1EC35B5DBE91CF5D3C36829BDCF0281405DDDA78C5F05782693D6D2C94994A7B6A717950D7DC73E464B488CCCD2EEA28A6DDE64F8FF9739C';
wwv_flow_api.g_varchar2_table(226) := '65797A96D0AB54ADDA91B1514469C450B1C18BA16032B5B6F4CCD98398B16725592A44E7098AD6A2ECC1B1232206F611EB1217A8047A72DFEF7AE5771AB0D10CF9574640464046E0B122A0A7D0E79E3E83D1122DEBD5E33D4F3C47D30AFB575EC2F8364D';
wwv_flow_api.g_varchar2_table(227) := '02F54A0EA2B8EF377E1557502E147DF9CBCF626C9352AA80FA74BFF414D8245E3CE4C511B78DA47ABFF202CF34151AE53987B2EAFA4591EBEAD4F4735E757DF86B2A1A3E89405791B0B61FEAB30C9A9FA2095EAD33DA10D4FD8B2F73DD964649BAF668BA';
wwv_flow_api.g_varchar2_table(228) := 'CD004591B452F1DC733C7C8F481C79E1C2917AB55FA3C03CB41AF158E13BFAFC734728F8EAC849464046E033450048138101EA4FA20D17E6171ACDD6FCC2A2D56A01EA1428379C007AEB1EE204BC811FCA2A010DBBAF4734AB9150410C668599D5D2013F';
wwv_flow_api.g_varchar2_table(229) := '2D8812A906BAE5DD19E0C83FFC43E52FFE020C4BD95A8DF603598B72990CA843C87A3DFA277FA2FEE6378DC3C30F020034C0A55209AC4AA10A3018DDD82A1C586E6089C1D9138C9937AE3CE8F1CDEBC04A5CBD7AF57BDFFB1E4551BFFFFBBF3F3939F9CA';
wwv_flow_api.g_varchar2_table(230) := '2BAFEC6EC00CA423E0655369CB7FFB7D71FF7EED707F627CBCF7CCA9D8777F68B218F4CF9E5E2762376BB8EF80E3DAAFFE53EBC6750E27303548FA509163315A2728E8EEFC1276E5B2E6C51725E5CDC74CC0885C5EFD41BCB40A84B5DDE06B742B0CDBF1';
wwv_flow_api.g_varchar2_table(231) := '59F6CE27AF79CDC3A56606BC823F58F9C751EF399F75DFA3949D2B1662F164BBD3DDCD16FC510A7A843C8F8B0106EDEB8F5F7D6D6169F985E79E3DB06F6F269BDB680C0C73B053874FD12E6D83D70C06F1C08C6EE4D1EB757EBF37148A349BEDFE409FC1';
wwv_flow_api.g_varchar2_table(232) := 'F09136EF0145ACAD856E4F4CFDEBDFFFDD8181006461BA4CAD5A331A8C2449194DBB410A4CD78E4502B3373B371F8FC5562C26D0E82E2DAFC6E309105FED642C2D966B9DD9F9B5423D7868D09C46DD6F5DBADAECA37D074FBDFEFEE46973EAC013A66834';
wwv_flow_api.g_varchar2_table(233) := '8F614CA3CD9A2971E0C048ACC0C7C2CB068C77F579E399DADE3EBBA8D6872271BF85265586749D6B66228E937D7389CADAF42DACD9B870769FE0181A7FF526A5E78B85F241AF3A70F4D44A96599C9CC0BA85E3A3810A1540E353EEA3C72FBF3F756248AD';
wwv_flow_api.g_varchar2_table(234) := 'ED1D014619606F71C8AD99C56A62CDA924FACF1E9FFE307EEEB87DAA482A7393AF64ECADB7FFEBAFFFAE2AB0EF188F92E0E8CC20D8B5D970796DC6D3A3560F1EF99B6F7DEFEC1EF6A56FFCF3E5863E387143ADC3881A76EA5C3FA5F7A28890AC7293376E';
wwv_flow_api.g_varchar2_table(235) := '70EDA2554D9C3E7D72ADAD8DDCF82754A93F7678E0F664B15A8D3929FED4334F1718C5EDAB93F55A6AAC4FCBB1011EB4ED3C7A6D66AD145BB210F8F127C730CA0E4C7A8345AE4E2CB7B36B3E3D3174E689ABE3917A6E0198D9F3A3835DEBF0ECB5373B98';
wwv_flow_api.g_varchar2_table(236) := '0ACBE65CA383C1485ED3293CF1C4594C632F324833B6B2F748EFE26A9A406ADD2EA6C085FE3D1E0E820CF25CB1C3A5D78208267A41A1E0EC8D3778241BEA39B36F2DD960AA518E11877C9632AAAF24C2184EB459AEDFAA52DBBC896CA35A4E4170069FDF';
wwv_flow_api.g_varchar2_table(237) := '98AA914EB4C659BC99D5D5A17E779BD2A5C291035EFDEDB52C514F3B878F991DAE428718BF7A03B8E078244373E50647EA08C6EBED65294DAD541705302E00AE5C04152E8BA9EB35E8280E5203300A985F4D0C296B8133CFBC3F195F59584D21CD031EDA';
wwv_flow_api.g_varchar2_table(238) := 'BEEFF86B1F2C66E2AB65D4D16F53D6091DC177184E0489444B44C32BCBCF8EDA44E7C1375FBBEC48844A4D85DD63CAC5F2568FBD18CB983CCE4A3CA9ECF130991861F770D96860B85FE0810C7DC80AB9E3F8972FCA08C808C8083C3A021B5A11C80F024A';
wwv_flow_api.g_varchar2_table(239) := 'FC23550C30A8C0FDC245BD1A7EEF383401B50532EE8D92752A58A0EEA87D7085448751C0A7AEC764D669801EBE4312831534F821498583CEF85E6280C671DA74973CD04145525D52527CE4594783CE683D51386ADEA407D6C93E7A9D51DFB80BBFBB870B';
wwv_flow_api.g_varchar2_table(240) := 'D9CC261FC808C808EC820008DF5986BB397E3B168DEB74DA5ABDFE6BBFFAB5A9A999B7DEB954AFD55C2ED7F163630A0505BCF16602FD10A45D2620D0750E9D78AA9F5F48E167FAF97F6C10EF2F01D91A0295805AA970D91EE26ED9FCB33FF37CF9CBC4B9';
wwv_flow_api.g_varchar2_table(241) := '73A5FFF25F8CFFF6DF36DB6DF1EDB7B5870F67924987CD567AE79D5D18606815B0BEA0AA7DE18517401B7CF9F26558EECE9F3F0FB1E27FFCE31F037BBCB9FA6D7667EB01E851F3F97C341A9D9E9E06CB6750AD81BDF4E2E2622291B0DBEDC78F1FDF9A79';
wwv_flow_api.g_varchar2_table(242) := 'DB3190F1A0B86AA302D5D76779F69CEDFCF1B564A8E7979E5F9A9D03F3C72EC74A318A1E9C40FDDBBA710371BB1546A3E2C821D02975E7E648707BD66B31A5B2F9EA6B8A53A709ABE5C105EC7CA7D9ADCEC7AF022CA055B6E97A7B89814A2BFFC2E86F83';
wwv_flow_api.g_varchar2_table(243) := '42F858E0993767FF1614468D4E792AF6FE2332C0674F9DDC333864B59877AEEF33BDFAB818E01B37C7AF5DBF05BC6B34128B4663923E51528A2110EBFCCB2FBFB0BB39340C111000302CB3291492D498285A2895140AFAA10C70AE508097E1F379EE0085';
wwv_flow_api.g_varchar2_table(244) := '224EA7F3A5177F01887FDBAE13635D83B603BA20305E5C5A8AC5131B6C7CA7D38EC6E38140DF0E0C308A325D5E418A852E119C98329EB453944205DF554834AD52D02C4ECDCDAEECED4534B6A195E598D51C5E4D2A8442D0E20A00A7D66E75407E55EC20';
wwv_flow_api.g_varchar2_table(245) := 'DD62C63EEA4250229ACAF76818426B63325942E467326DFFD4DBFA67862FFFF8C6F35FF3AA8C964BD7E78D01E7BB6FA46CCA7809314CDC7877F0B4EDC3E5B8A78B56A3CBF881B3B5468B67DA7A35311EE18393EFD99CBD538B498B7D36D5D27E707D3C5D';
wwv_flow_api.g_varchar2_table(246) := '228F0FB05AB51257AB6885A6CB098D469D84089DA4E6D28D99C3BA3C491980AA50AB353A2D5710E85B6F5F0B78C4B6DA78E53B97C7461594C10FBCF5DB57578CC505A367CFC46AB14FFFEE8AF1F9D0AD374EBDF40D1653B07C1B34A7AF5F5D393AD67F69';
wwv_flow_api.g_varchar2_table(247) := '4DA32BAEE96D3DD26B15403F8C4FC6EA0B372FB97BECB3C1A2C732E939F51CE87D6F2E876AD1099BC38351FC64B8129BBA1AD8EB8A56C8A96B97EC17DC573EBCF4D4F9D3EFE5C4ECABDFF39D7CF6F64461B46FD13EEA8C272B3605439A9D8B376E0F18EB';
wwv_flow_api.g_varchar2_table(248) := '2AFB503896B3EAC318A60787ED48BA568B85EDFD7E604141359C48E77B8C18A932773365D0E9468A6D0B192C1A87D3ABCBC32343154EB1BA12F6AB0C8B8B61B799CF7414C8F22AD1B3673192424B9CA29527086FACC2688592DE318A170BE05BAEA08816';
wwv_flow_api.g_varchar2_table(249) := '4A2ECEAD0EF72A48BB7FE18DD9BDFAA2DAB96F2D5C321021DA3F5AAED6454E0A720014A1110CDB95AA7E8F35D946914E11F06937AA468702B4FA7A8DA692E23A585BEDD112A2A8D0EBEAED346CF6019A7EBB41A9EEEB0B8632B0C6B51011671B0A750F88';
wwv_flow_api.g_varchar2_table(250) := '3BE1DD746B204E01E31FBEDD8217C8B7DB1DF8ED763AB82074DA6D9A13BA6DA809C6979C6404640464041E2F02202F06AA6E6E6E4EB2790161362808D6D3E3ADF531940EF1668090780C05CB45CA08FC1C21002E69B02628683A1A8B0147F0E4C58B7BF6';
wwv_flow_api.g_varchar2_table(251) := '0C00D7F7F63B970A85629FDF07B36C3DE2CD5DEEED41A4F856D43A1C6C398E1A9482458380306B214BAABB299AE27A6CE0FBFF10DE490A2FF0C4135593491819116C36A65C167C3EC1E9642B95AEC5227EE415BCB5BACD6358D0E018185D60832F5EBC08';
wwv_flow_api.g_varchar2_table(252) := '4541FB81715D5E5E868B1B773733DF7F0079606D7CE79D776079014E07F4C6E006FCEAABAF42F8ABA79F7EDAEBF5DEFFC8DD2B28CA76BBA94AE5C0B317147DBD6018DB73F17C3214328D1DE49AED5C318B017DF9E024B6C1CFAEA53C344AFABCA4C7C357';
wwv_flow_api.g_varchar2_table(253) := 'AA62A743F5F9B84C8E08B8B97259EC761EFCF403EFB4D966B99D976C9E713C5B8D1EF53FADA275E0FA7BA0F74C1762FDB7F260F70E1BCB66AAB1071671EF8DC5A59599D9799BD56234EEA6B0BCF7A14F78F6B81860B305FCA575C022EAF55A8D46FBD1B0';
wwv_flow_api.g_varchar2_table(254) := '9034F814F89AEE9A4082A2562B29169CDAEFB0C0EBC19C05080DB7E1C7BB797DC76280D984EAC01A01CC1220039C1ED8BF0F4AB83D39B5BB5F01EC61B86381C0357519163EE2A0FE850CB03D3018E5EED806E0F0B50A7C646FA069B3645F5D18B1E236AB';
wwv_flow_api.g_varchar2_table(255) := '6DD0AFD13A7B4D96E4601F2FE8ED94C80FF8DCBAE1D174112DA5E356EB817AD70836D06A0ADD3FD28F29A948B462A35A94C1061EC595647CEF1E3B78E036BB1C49E31C4D97934B80A68E244F9D1E462C07FFF760279E8AAE4D4EB94EE970D2998F179F33';
wwv_flow_api.g_varchar2_table(256) := '726F798EBDF7E36FFDCB5F394AF40C5FBB3455C9AE9CDA6F5A58757492119737D01271B150387CF6CC7FFFBF6E3E6B61477EEDB7E3419A8F3B7D7B0ECF27EB3357AE9A558DD1E327FABD2E30E92051D66952F6FB46C60E218BA2130FFFE573BFF30729CC';
wwv_flow_api.g_varchar2_table(257) := '7EFB1F16C13E184C97EB28BE3ABDFA1FBEE633EFFB8594369558F8CFE2F15F0898E973A74E878A884887140C91E80A8D4AFED67CEEFFBCE050EF7D5664DAEF7F9840097429582847827EBF87C18852A6E807C65B502E2E2D7EC58BF65D7CB6C3B07FF5CA';
wwv_flow_api.g_varchar2_table(258) := 'FCB0957FEAD9E7A70BC4F5BF7E5F5FCDDBD4C2C5C323698386FAA7C9A79F381D5C422AF984098CC693E9434EA3882BC0E4DA67D39B87FAD30DB29A5B4271AD28881615C91A2C080BDE21788315AAA9C4FE017B172C94113008C7C118BD5EAB223AD604BA';
wwv_flow_api.g_varchar2_table(259) := 'F13E9F86515F7B3BA129974AD9A4DFE6A4956423C71C3DA27A356A522CCF5C78FA98406B93C988D7AA542BF5261BAF6E692C0E47A425D26CD51FE8EBE21A4CE4BD56A36928102991E5EC9CB30F0477B06AC2BAB96E59BEEEA3BC6E122E0DB7F53107D6EB';
wwv_flow_api.g_varchar2_table(260) := '92D93A2C884A507DB0C00B437EB8C8D324E91BF2919205390470013B6D69F18547D61DC2051E94DAACA0D7E23627C45DC0B4FB34044518F60E621465D8B3079CBA853DC3E0302C6A867949FD2B27190119011981C788002C5BF0D90DF4F7B7D6839AC229';
wwv_flow_api.g_varchar2_table(261) := '9077603C556FD4B759393EC6467C4645C37E104A856A4376FF191529172323F073888008DA8EC3870E02CDFCC1E50F753A0D2C0B06BD1EA4F34F3D79E1E891C3C00C7FC420DC01E74184F82676604997AF63B763A85D2F7EB082941A4857D0C62AA45D55';
wwv_flow_api.g_varchar2_table(262) := '3934D4FFD0E04984D3295AAD4C3A8DECDF8F6B346C30882A14A25249AA54F1BFFF7BDFCB2F6F5674FF01AC6FE08909FEBADFFDEE7721E8D499336720CFC4C4C46BAFBD56ABD52044EEEE7BD6406741D30B941E70C2700CCF42DFF57AFD934F3E79E1C205';
wwv_flow_api.g_varchar2_table(263) := 'E056EEAFF1DE2BE24A70F5C893CF1432B977BEF783DE80BF94480F9F3B55D328324B13A05FBC37F33D67606B2E8223653C2111906065DE6CB2E934AAD288DDB8D86C48DCEFAE8FDF53D6961330CFA470BACBB641D39BAF2721D8958254DF08BEF6E2A1DF';
wwv_flow_api.g_varchar2_table(264) := '9989BECFF10C8141F42554013E2F8F961ACD66BE50E4F80D2FE5477BE693E67A5C0CF0B1A347C0C4F5DDF73E007F9E73674E81E5C3660B77641D37EFC2010C20B7CBB57905C60AC4730646C5D9EB8018CE0F7DDCE376911475FDC6F8F973A73778602861';
wwv_flow_api.g_varchar2_table(265) := '6171E5B5D7DFFAB5AFFFF266B1F71F809A19D9D9085A1AA4C0426F540D8C30849EBBFF71B802BC160E16C4F00331B004C91B01CA2B579B6AB603E2F04AB5AD05836C11A9B5DA9D7C996B9455BD2A4C4B3306DB7228A9A75856EDB639ADB564FCB0CB82E2';
wwv_flow_api.g_varchar2_table(266) := '8A54BEA913CB1AEBE14C93BF323E7B585FE51984C3BB40497411A6582A566B193D52D46AFD6ABBB9D3EC684D4CDFA1D3F9AE46D19A317A7A52F5AEA109B6DF5A4AB0D22A9D4DA70AE34AB6D31EF29B35FD434BC958C0A16AA1DD463183A0BDA53A5FAF14';
wwv_flow_api.g_varchar2_table(267) := 'D51465B39921FE2678D8EEB1685712C6ABB76E7A06031C86E58A45DCD6ACB168321A4F5268B35342F1BE2BB3B1BDB696D66888C4521D73BA5D48AB81CF14453589F108B1B0924A2D2E589D6630DD05664EAD564553119D29A513DA60C80106E7169D324A';
wwv_flow_api.g_varchar2_table(268) := 'A93AED56C0A573EE0F4C2E64AC7855A5D1C593514532098E5E7A2D9D4BB2C06D668BB44EA944485A4783A3B3D2AA411576378780EB08860968AACE51F59C7164B8057ED0A2D86C3368B9DE6D5469B31AEC45606B39252EEAADE668AA4AF3251ED51BF8AA';
wwv_flow_api.g_varchar2_table(269) := 'D6DA9FEA208948A4D7A100E186484AC1CF3AAC506BB60B554E4D0B4AA58AA095B023969142F4FDBE5C59D0625D440D88B69A34DB29A46C877AC02719E28749DBD709A05FC5141444E5834062D249BDC3889526DFACD046F53AE70B9AE6F521036B8F24D6';
wwv_flow_api.g_varchar2_table(270) := '919861682A6847C0B3D96831C74B39B2522C14F2833675B365C86593BCA1C195B246BF319DADF7E8C19DD908CF4045F0F150A208A131E772455E2853DDAAA8F5E63205A34D5BCE560D76432D57D1DA8C10818FB2D8B8521E37DAF872BEC7E30293A21D07';
wwv_flow_api.g_varchar2_table(271) := 'AD7C514640464046E033424084CFF7FE03A3B052C13A07BFF97C0E14C210D2797DDDFB8C2AF98914039F7B7050A415342CD33F910AE54A64047E3611801984E3C4BEBDC397DEFB606171692D1886958161D9BDC3C3E099B84E26DFDB71987B1F69BFEEBD';
wwv_flow_api.g_varchar2_table(272) := '71E70C9C61190E198F622A4A6CC14EE3929699AE0A2E0F599588F5DD272C6C35DCD313F9F6B7996894F4F9F2B55A2918144B25249FCF5CB9A2595C34FFEEEFEE58E9C64588CC14080482C1602C16FBCE77BE034EBFD09737DE78035862605FF7EEDD0BBA';
wwv_flow_api.g_varchar2_table(273) := 'DC5D1E079604F2ECD9B30734C0EB8B240A7EBF2FBEF822C47FDEDD0178A34C585D33E9F47422D68B9258B6185A8E58FCDE0E89CFAE053986DDDD6205D3EB48AB8D5D5B63A351C2EBC5C0F704F8F09969AE007E9851B2A7076401BBB4FC41B7D4B4D6AA73';
wwv_flow_api.g_varchar2_table(274) := '575B0502A3DA4CBDD62EB69946A4B00065676B5170F18607C19206FC811F54C2B6EBA307F63B1D76100A6CBBFE384E1F1703AC56A9CE9D390D2AD34B1F5C86E1F8E273CF8268E4D13BB039FA37B8DF642265B55B3D9EDEDD55B81BE5DBEDB613C78E7C78';
wwv_flow_api.g_varchar2_table(275) := 'ED3A385C7A7ADD5002982EDF9E9884C77B9CBBED8104E21386DD41EA00C31418EF62C907722CA882637993C178FFA4858FA49244217837848006359ECE6A8670538E1EE75A6AD5D19FF17B6CD148B01FB67F40D1957851ACCC18B08AC17B74325215DB35';
wwv_flow_api.g_varchar2_table(276) := '1D84F6A5B4A9545E2028155F34D84780294BC6B33E9B122734F01D26510163BB1EABD5A00C801AB1CD61D727160BD5D44907D7EB1A3A7ED1D85ABE0D119CF416CB5ABEEBEAAC9DFECA8B57DF1B1FCA068F8D1E4290002C0863AA663D7B04184F8312E92A';
wwv_flow_api.g_varchar2_table(277) := '34D1EB335F7D7AEF87613CBC30E93DE05F1007A22B937B0F9FF13C7112B8B34CAB1B0C4ED3645B6F76D084D23EE89E8ECC9FDB9B593CF8D4A577C619679A64EB0849CD86F37BC9E2A90BA3B7AEC6E9E25B4A46EC3BFF549EC355D65E60ED002E087D00FC';
wwv_flow_api.g_varchar2_table(278) := 'DFC040AF42A9BF783470EBC37934FDD6C980D1AADBA7E32DFD43D674EC98207654B4A0371BAFDEAEABC9A5E3879EBCF58378FCAD77FA2DE8D8E1E72E453DEFBCFB7E8D535C3C704400F6CEE212115C4BE3A4D90ABECD10C29D3298C2D1820BB4BF4A0861';
wwv_flow_api.g_varchar2_table(279) := '073A782C91AF116C48CD574DEE3E4D82A7447DBED6613A75354DD03AED4A34B7CFA110C13F17C2804911AE50A38A5469CD3504AD74855024516C62FD1E9DCD64F18295BB58068E165CD756F3AD7E0DD7768F42A440B69336131D851E1A206A685CA93348';
wwv_flow_api.g_varchar2_table(280) := 'C1F81114060F08D8100A05C56CB2D844849091A8583C5E5C14ED66031807C0E0917850723DFA3F2A6A95248DE9C1DD65C0635D6DE4575756B502627779094E1B99CF55D6421E0DABB106A6A71356424BEB4C10F4DF68D409842449F307FCA1F422555BF1';
wwv_flow_api.g_varchar2_table(281) := '3BD4A2AA27B1344DE9894C3A4B1A14995406D52B73998C46A3EF64529442CF64D23D3E3B223CAEC9BE31EFE45F1901190119014000F846307A84032062552AF5C0E02084037CA07DD517193229E0245095B06C4B22CB2F724BE5B6C9087CC111004158A3';
wwv_flow_api.g_varchar2_table(282) := '5E07F746834E0FAE76F00F2E180C3BEC5B0BF15977EF8B5587784C10CB151402A84E81D49BDD528513D4A680DB0BDA25A0F9777B1C450D5FF94AF68FFF989F9840CDE6AE42015A3A3693E92A95BA6ED7FFA52FE94E9CD8E5718D4603DA5AE84B2E074456';
wwv_flow_api.g_varchar2_table(283) := 'E6FBDFFF3E64063B17B04E055F4BB80546D1BB3C0EB7E029585246474781674E2693232323E042FCD0A736CA040698C0B1C9E929FDC953A3CF3F9B1F9FB69D3FB1542D67B340EF3D84C3C20C06D5B973AD1FFE90ED74D89515892B45D1E66BAF431C599C';
wwv_flow_api.g_varchar2_table(284) := 'E7D55FFF15B0BCDDBDE53BDEA508E53ED7C9506E0EA8601C256E47DF65C19453E4DE5BFA6EAA122170821359ABC63DE83CB2E3E3F75FCCE5F32022F1FB7DD423ECC97CFFE31FEBCA63A489C15FF7C2B9D3107DF7D6EDC963478EF8FD9F045C88A896CFE5';
wwv_flow_api.g_varchar2_table(285) := 'AD368BB7D7FD28DC2F741EEC0A2E9E3F07EF34180C47A251088C0E161110B7196238EF3E443078060733D4EDDE92C0C61F3F3E76E72B2EA12B827C027606DA06B42820560DA93E3CC2204A8B0AD582D1304FED1F741734A057A60E067405F200B0C61A54';
wwv_flow_api.g_varchar2_table(286) := 'B0DA6CB8CAE8EA77515AABDB5EADE34DBF9BB2DA5DB8AE192BB65D6615A1D297C1E6BA51B28FB83811372BC417CE8DD5622B27B5BA5E5B7F9EE78DB4B2C7EFB756A8BDFBFC24A13F7950B504C19AF832A5D039959476EC9CC1E3668EE18812A442101359';
wwv_flow_api.g_varchar2_table(287) := '6AAADB488F1E39D548AF8012554190C70F0E39BD3DC74D1852A46D1AE4D8F9E7D5DA1A2FA03C6CB083881A1CEBDB3B28D6E243BEBDA4D23176B89BD48E1995AA03C7F7456E57BBADA6CF41504AFBF9835A85D67A4267D1624F34B2E1FE5EB3CA3534DC10';
wwv_flow_api.g_varchar2_table(288) := '88E32F718C303A605270A7E976F5AB438384C9765C69D6B24FD40B299DC37E486BC41D63561D7D78EC6435BEA422A185C4E8B0C388D09A1EBD78E142B910763828A75175E6A9F399E0ECA092F4EFDF5315F0C3279FE308B5CF8061478F095D7EECA88B20';
wwv_flow_api.g_varchar2_table(289) := 'EDC272CA3EE004E75E10B540286D8B458D69D4861E23A534F7D9BBE021828AAA1ACED88D2261B210B179F3402F686EF514B2777890E934F6793193D65B28F32635AED7816D0EE67418211AD650C0552A5010970B222B78CD845D19E095A63C092628D9FD';
wwv_flow_api.g_varchar2_table(290) := '1EB38029418FEDD129316A8815091D8EFAFAFD22A5062B6588676D37AA38BDD6EC36D01A0B30E53A2970CB1DFA695D3C096A62B4DFAAA6C400CB62760D860EF6772A39B34705F9EDB090F40F30EDBACBE74015FAA13E9ED692C06CD304BA77B80F82C680';
wwv_flow_api.g_varchar2_table(291) := 'F1795F8F368D07C013D861B37024D9DFEFD5AA54FE3E1F089EC8800F884EA5DF4FAA959C2F80C35E9ABE3E917F8C337DDB44904F650464046404D611C0207E04A4CDD5EFA7101649FD0B1AA65D35523F85DD929B2C23F0134500ADD51B7D7D7DE090E876';
wwv_flow_api.g_varchar2_table(292) := 'BB52E92C680360A718C921ECBE043BA4ED3EDF8EFA80EF953C1CE1619898734BD51F2F25BC2394DF65C531D0586DA7E1B7D5A07BE699816A35F3CD6FB6A6A78130DA08AF071B9C785E7ED9F6EFFF3D8498DA967FEB29346CFFFEFD40C58D8F8F8316B75E';
wwv_flow_api.g_varchar2_table(293) := 'AFC3DDDEF574ECD8B1C1C1C1DD5B0EF17D676666CC6633A87C417BFCF6DB6F9F3C79F211B95FA808BA068AA556B3717D7272A0D7238CED9D6D5543F12845931DD84E66D78EA304A1BC701EADD79A376EB2E0F1CBC2E69D60A15AA6CC66D5F973F4F16320';
wwv_flow_api.g_varchar2_table(294) := 'EBDBDAD36DC7EB84EBB66BD229483BC7FCCFAC65A7169237A1845861092EC26EEBCBE9DB7020888292D25C18FE25BBCE23E57E8404E1966E8E4F9C397D02BC671F21FBA7CA72CF56CE9B256D76150EA4D1B49E40AC0266C090C0781D3C6C3B9D0E8831E0';
wwv_flow_api.g_varchar2_table(295) := '7D6F3EB5E341ABD59E9A9EE9EF0F804FF38E1976BF0875C1FECB10AF7CF7B0E6F71702A18080FB055372982110FB0AA61CF006F767DB7605F6F869335D49DA7B6F02793648B537AF01930CC06C9E6E1E48B3113C3921163BE804C1B914AC4EC14817C7C1';
wwv_flow_api.g_varchar2_table(296) := '4816CCC1605697597CFED2BB47C73C943900A6B3A0C3849D83A49CB073100F3BE960F14CD5A664289DA5C1F2B574A6C76D16A5E909B22E1CE434D27BE1C54497B9FDD76FFEE2EF1DE77107BC0EF014852947523091C122178C80611280172AEC9004AEE7';
wwv_flow_api.g_varchar2_table(297) := '60907B97515FDFA648DA5848AA0B4359698F6218BF84B483919419987FD813E84EE74950776338383C83B1B2B4BD1101134CB83AB1C21443F54E7740C3EE3FFF02843690C22C8B3C64865E40ED5002EC7B0C1B07C153D07702443870CA0B500C3405BCB8';
wwv_flow_api.g_varchar2_table(298) := '011F2853E2C951296E133409584DE816CB497B1D819F2B74075A0E5725EB621E7C74A5AAA1CD200A9150C5A1B5D05F0968B80DE1DC5B2C5A4E43003D2384966AE3D8D4CDF963FD346919846C50AF147619B24AAF437A7F9596D02EA6AC4E2B041883B706';
wwv_flow_api.g_varchar2_table(299) := '0318A083DA21C752AA4AE516070F1E6511129E855EC1AD75D93FCC616991863600B650653A9676DA151801924BB80EFFA00478BF50082CBD2274FBD6F8E2291F89D9F708D08775E9C3E608D97A206945244368692049ED587FFCCEE97AC360200168D006';
wwv_flow_api.g_varchar2_table(300) := 'C9EE19FEAF37783D3ABA740C1841D5607E0DB7200F70C85267EFFD5DDF84092A91AE436BB7D62E1FCB08C808C808C808C808C808C8083C6E0480C081DD83805CB15AA4DD8F809E820858409158CCE64D7663A30D40EB2A1534E4DFBD49EB84D07A161459';
wwv_flow_api.g_varchar2_table(301) := '0B555E7D3B766254E172803A1707B3EA87EEC42B304CF51FFFB1F4ED6FC3C14645B4C361F957FF4A75084C261F9E80B687B8CD9040150CB941C6072C308486DEA0187779BE52A9ACAEAE7A3C1EF004868E2F2C2CB8DDEE4737F7FDABBFFA2B509B4BE431';
wwv_flow_api.g_varchar2_table(302) := 'C751B40288C67AB50ABBEA80DA0F586BD03F1F7A58FBC120B63B3EDE595A169AD2A6C1984EA7181EA68F1EC51F167519A20B1BF5FA0DAFD2FB3BB89CBAFDD6C2DFAD66263B6C4B2235E1D54AAF10356AEC2702CF5D1CFE9A4EB2D07CA41489C652A9F4A1';
wwv_flow_api.g_varchar2_table(303) := 'D1038F2217805D94811505F53B3866437EF88504B6E8C0304253011649AD098ACDF5042D921AB59E360E1E3B03FC483DFEC2648211D9E9026308E1921E4B9B80356E562B6A0DEC5D08DB33EC50078C98F5ABD20FBCA1F5666CCFC60848235B323BB42278';
wwv_flow_api.g_varchar2_table(304) := '9CEE54C863693AAC58081A4E16BAB59C9A143D5E2F4AE93674CB8FA9BA472F761328E059EBF5266CED08CCF08390D9CC7C6FF96807ACDF999652AD017EF1DE5BDBCF1E50C29D6CF03898F66861012741E0B2FDDD6D2F4B3E971190119011901190119011';
wwv_flow_api.g_varchar2_table(305) := '9011F819470048A70D8E03E8A2ADC777BB0D9C0AEC9A025CCBDD4B8F70D4EDF2955A47A7B9A3C00466E7511466C0FA761717059605820F1A4498CDB027F023D476370BF00BC009C339D408FDB97BE3C1471B8AC3CD6057A0567CF467A15460B941150407';
wwv_flow_api.g_varchar2_table(306) := '501B8800A076E0EE36508563D862F6511C8921443097CF03AB03E5602A256EB5A28F606CBC11B50B5ABB63E700897869653AFA7EACB45C6AE6BA6C0B385E93C639EC1C3BD07B56AB34EEF8D4A7BF2833C09F1EC37B4A806104CE9C0CC76DE8DCEEB9F790';
wwv_flow_api.g_varchar2_table(307) := '1369563F24CBBD4ABC8766DE3103D401DA60F01DFDC9F357925A18C5A19F207F02E5E48ECDFB7C2FC2FCDCD4917EAC96ACAF5F77F4B11FEBC1FB33AFB7012E7F11F1B9BFB5F2151901190119011901190119011981CF110150D481DB27A8ED3EC736C855';
wwv_flow_api.g_varchar2_table(308) := '7F1A045A4C3D5F4B945B3986ED00D36B54DBAD5A178E3DC617FA2919E0C7D8B24F83E3E7F82C702F605000021DE0F180959292D49AF59FDD9B25F1BF0FCF767FF4ACDD4BBDFF2ED40116CEF75FFF095C014365607E7F02157DE22A3E31BC77DEF327AE78';
wwv_flow_api.g_varchar2_table(309) := 'CB839FB80D5BCA900F65046404640464046404640464047E86119054C1A03F05EE77C360F567B8AB3FF35D53515AAF65D88B3C6AC0E7CF1D109901DEE115000F0C7B10AFEBF1401F0C0CF08663E60E39E54B320232023202320232023202320232023202';
wwv_flow_api.g_varchar2_table(310) := '32021F0B017007064A5B6280A53F3B9BD77EAC02E5CC32028F8E80CC00EF8C1508A5C00F01820BEDE885BBF333F255190119011901190119011901190119011901198147404052013F9A03ED231426679111F81808C80CF06E607D34311FEED9BB5B29F2';
wwv_flow_api.g_varchar2_table(311) := '3D1901190119011901190119011901190119011901190119812F0002B2C9C117E025C84D90119011901190119011901190119011901190119011901178FC08C80CF0E3C758AE414640464046404640464046404640464046404640464046E00B8080CC00';
wwv_flow_api.g_varchar2_table(312) := '7F015E82DC04190119011901190119011901190119011901190119011981C78F80EC03FCF831FE62D7C0170BD28ED83BB9398B8288A9D5B8F171ED61FD898111CB65B1D3D979D7655144554AD460F8C485FFD43F285410A189600A0433FFD4F7E5D37540';
wwv_flow_api.g_varchar2_table(313) := '2C57C4765BDA33FEFE248F93FB3159BFD2E40446802DAC51258E2A705942FA0098E4CB3F5D0874BB483EFFC026C312E1744238DA0766F879BC21B2CDB6286D7C28255C41E334BD71FCF9FEC2CE1C5D86D971634A0CC7688AFA7C9BF739D7DEE908A5F2CE';
wwv_flow_api.g_varchar2_table(314) := '9F3C6819C459B6591F78F7736EBA5CBD8CC04F1A81C7C5000BD35348A58C9D382526134238841D3C8492047F7B1C75B9B1A13D3F995EB2B56984DF42FEC2FEB9184E68F6A1B8F227D3809F8A5ACADFFA9BEEC2026CFA747F6B4541509F3E6DF8CDDFBCFF';
wwv_flow_api.g_varchar2_table(315) := 'D6E77BA5FBBD1F72D3332849DEDF0C916189B1238ADFF8C6FDB77E96AF487B43C30ECDD308B320FDE732086E44F4FF2B42F87E967BFDB0BE75BFFF436E6A5A1E270FC3E9CE7D4610E72AEDC57ABBDCE13014B12AA9830665BF4601C79F5782CDD81B8D26';
wwv_flow_api.g_varchar2_table(316) := '0C6EB55A4DEE34DF3FAF867DA1EA5D595969341A10B2113633EFE9E971381C5FA8E67D211A130A21DFFCE66E2DF9D33F45F4FADD32FCDCDC1379107D33D568B253ABAB480CC5089EE5BB88A0B5DB34369B2477FE1C570404892753B95C1E783918ED77DE';
wwv_flow_api.g_varchar2_table(317) := '8988C04EB2B05B252C11FD7D7D1AF5CF2F81C7ADAC75FEEB7F47E9074801140AF51FFE1FC8CFB98CE0E76622CB1D7D28028F8B01E6BEF36D61668AFEFFBEC57D7089FFDB6F517FF427A24EC7FEE73FC29FFFD28E0C302F22D56ADDA4A711F40153F7A15D';
wwv_flow_api.g_varchar2_table(318) := 'B92F03937B952070E07AEFDC41519EA961A41957F9B7E5E505A4DD68697420E084FC9F65627844E8D6152A0D7C365801C966F35CB769D1D01A0BD0281F83AEECF2F06C4E605A36A392E1B55AB588D3EACFA4A1CD37DF68BCF12642EDC04C82A015418447';
wwv_flow_api.g_varchar2_table(319) := '61805B6D96C239845266E339AB89A2D48F5701CB5EFE90F9D12B0810C492AA6A4B02361EDACCB2C8178F01866F75ABD556C106D3A4624B8B3FF5218CB07809C954105F0FA2FE16527F0561338858431025421F4534BE6D15403392E912DBAD191494D161';
wwv_flow_api.g_varchar2_table(320) := 'CF57DB56358E108F9762C8943B0453B2D8ED9BF3ABC3893CD354AB600CEF3C0B9A0C9FCFE44481B1EB0895C9B5AD178F78CA7E7085F9E12BD2D8DE719C8052E8BE7152A833F5624A4D6336670F82ECB63C0292ED5647412018B5FD85D63B7C319F4178CE';
wwv_flow_api.g_varchar2_table(321) := 'AA53AA4D40323E2435AB6DA50A361FFFD80A96368708F5B2DA6868F1682E95D420BCA517B0FA248B1870BF97728DD7539548A3D3E578E0A6B424315D51BDECD21D31A93F5A43EF7484E545A6D5526B61D8608D0EA381351BFBCCD6ED8D3A80BA85047C5D';
wwv_flow_api.g_varchar2_table(322) := 'B158842B3C2F188D86F5B0FC3B0F9852AD63507018052BED9D04DDC0388652AB3EBAF009FFC2DA2B7EB48633D21A9EE3BB2D875EA530DA1A5DAE90C96122D36333884A43329555891D93A3275DAC09DD8688604A42B4C3B0C7EF79B3E546C7A0C40A0DE6';
wwv_flow_api.g_varchar2_table(323) := 'B39A7AD7AE5DF3783C0441CCCECE9A4CA60B172E3C88072E35984A31A7C30418272C8F71F5A6D2B0F31CE41184A9D5955A1582DE194EB0D496CB55B39682E5821544B1D5A6349F1CDB729331D03CBA65E5812BD542065EBACBAAA1D4E65697179B35B5E9';
wwv_flow_api.g_varchar2_table(324) := '33B23F4AA590FFF6DFA41100AF4373779020990CD2047B190CF9A33FDAC600770524934A8B5CD763D763CA8734031A8BB41AB456BB6D90712292CD9798564D8563F65EF8E83F649A309CC0375B4AFDCE2F655BE1DB4EABA5BA5E4FC16093D69F4CAAC7A2';
wwv_flow_api.g_varchar2_table(325) := 'A1340F69F6B612364E61D5CDAF85DB8592DA66C2D54A0CC35196EB54EBB995B028201AA77DDB0C6C72482E19D713A8C9E5BC7FF1A937180AE9D01ADD8E756DBDC80908D3AEAB547787DCD6BB9BC7C150A4D668F438ECCD662B5F28C2B054D094D36EE305';
wwv_flow_api.g_varchar2_table(326) := '31964859CCC6FB19E074A9D1AE166C3A4A6386555D4AC572CBA44150520533BA552E1A4C3A3881EBCD364B706D5A7BB7B5955A43AFC237066AA9DAD1D31CAED8327ED64B839F46BDAB54203849B73B1CCE7729B5BAD9E509A6466BB7BF0298595D902C6C';
wwv_flow_api.g_varchar2_table(327) := '9959F038F4A2536F28D5348AED40897D54C9C3FF0AF144F75B7F87A894B062DE931B6C1C40FDAB37A8FEC3FF86DECB00C3EBCBA793A8C0791D4684963A0E83B95DAD194C3098B16AA3AB40DAB446A2E8A091F5524D0F54FABD0BDA3D15AD9FB4195E6C35';
wwv_flow_api.g_varchar2_table(328) := '540628EDCE60E97008D728680CA6BB04F9FD8FC95764047EB208EC46E17D9A96607607EAF1C17A80198DA2CF8B289528A5403D01C462DDB1D85C57B8F6E6FBCF9C1DD638033B66F8041705264B2ADD77E71B860BED92C0D5EF270FAB1D7E697CF1D41303';
wwv_flow_api.g_varchar2_table(329) := '087277E17BF41A8B952ECDD734E61DBA966E8ACDD55B7B0F9D46303AD3466E7EF896306F44840000400049444154466B217B0CEB0CF0A3D780442BDCECF5F7351ABD6AC0DCE47B95D867C60023382E48DB90E3283009B04AC2C6E43C8780E9231CF3048A';
wwv_flow_api.g_varchar2_table(330) := 'DD8FD60ECD5E0956FAF4F930DD979F1AD78FED79DC0CB0D4369A064D2F06BA8E4D31308A0AF138373EF9712D7CAA5DA4554939ED409D6CA3F377E8E9C6A57CB1AD219A4ABD65338720226BA9C2608F1A4C47372F6E3D007E696E75F5B09D201D7BB75EFF';
wwv_flow_api.g_varchar2_table(331) := 'B4C7AB19643C22F1780E1B82A991E608A2F3229D0F11BE850812E7B0358135DBD24A2A135DE40401BEE9670D44AECC5BC1B06D0B19BA35FF6772DCE491A9C9895EA368B1998098CE94EB76B219EBDAEAD1D923878F22C8CEDFFBD56879EDFA758D4313E4';
wwv_flow_api.g_varchar2_table(332) := 'BBA37B6A16DFF027690CD0B5304E8EED384E26A4417E6F4A14BB0BD3B778B60582B3C16ADA3B781879303902D4C0D25274D08668DC43F716834CC6AB95E94B0AAD3D282247F67B0CAEBB195811C9C5722E2F5045773A0EE5CC5D0B8D1C52A9EDFE6DE5EC';
wwv_flow_api.g_varchar2_table(333) := '7E9A28B517A6664C6CF9E8B34FA60A7C7075196D7287999C2500A87EEC34596AFECF78395D6F5B69BC8BE25596AFB1EC5AADFD3F05C146135EF53D2C5CA1C6C4A6168F5FDCC723CAA950EA8C074534DE8F5DE5831F002B47482CCB761956A3D3C11CEFB2';
wwv_flow_api.g_varchar2_table(334) := '4C13382E9A82B58A24B67FB63A2272F9C6D4A896F19E38B3398B63C986B214EA3D7AF8C1F53CD29D7443EC066F0D8D9E85C1906E22B72FBFA5D2DBA22873EEDC89D528B276EB86C5AA36A802917433B536A3C1891125168AD7526B6B24D7EAEB77D82DFA';
wwv_flow_api.g_varchar2_table(335) := 'ADF422BCEE4BB3E12F8F687265D24A4ACCE4233562D74CB55AEDD0A143C000CFCFCF0368C00F9F3871C20936BDF7A59B33E96EEE368D284F21F9A6F160FECAEC8117779E83351E89DD9A38706E1425EFE845BB08F2CA9B534F8FF03DFB2E963A4C7B6AD1';
wwv_flow_api.g_varchar2_table(336) := '77E6D026DA5D11A9A58356871BBE74F755BBC385F71633CFF75668FB818D7BB03CDE5E4B74D7AE221A7B7C553C7670B04139C57C516D02CA7B1BC3B543690FBF049F0C1C475E7A0939754AB276DE4C3333C8C40472F9F2DDEFC8FAAD0EAC5A73A14A6619';
wwv_flow_api.g_varchar2_table(337) := 'F49FF9343EBA772FA9DF4DAF9EAC32E2DCADC0B90B9B806CD4506C2357AF5FD751C0D7D3DE427CF8C02104BF2B3548266B76234FA8EEF248E952A7393EBBF7F9139B0D7C940368EDCC42303F3FFFFC8B073A4ADFF8DC4A2D15AD6AF9FDA7CE60F4C7566B';
wwv_flow_api.g_varchar2_table(338) := 'D733E95ABA64EDF72A3414213940E148A743680D75AA985B5E531835A4F22E0708536F6662AD5A5D065EF99899441420E5BC27551B8C4EA86E63805752C5410738E9009F7F3795BB4872717274FF0842039BF4C0D468B69C763BFCAF35EA2011ABD61A1E';
wwv_flow_api.g_varchar2_table(339) := '778F822641F4039AE16E97DDF6E46AA21C5C18177821A2C4F7FB4A56DF4883472E5D9D38EF16AD07CF665BC8F85BEF7CE9C97DB8751F3C78F9567440190E8C3D09EF1186F4CC7CB8B43673FED488C216985BCBDE9E9C79794C6FF01DDB56059CCE866B83';
wwv_flow_api.g_varchar2_table(340) := 'DA88D93F76792EE56BCF0E9E7D6126560CB4A66D079FDE961904631169661D44C9BB7A8236822CDF9A3974A21F513D5C60BAADC07B4E61AE809D637F00DB33B4851042C57A9D9F9C44F0ED53A9C9229393F3CD720CC189529638B07704D758170BEDEC7B';
wwv_flow_api.g_varchar2_table(341) := '6F3CF9D2454265BDBE52E82DBFB7F789AF8180A050E73E7CF3EA979E1FC07512955EACB6355C8D366F7FE370ABD9E5C0125B658071728780049177AB9CD5E80D1285292719812F0602DB2989CFAA55B9179E695F38EE552BCA63E78BEE1197D7A5A1BAF8';
wwv_flow_api.g_varchar2_table(342) := 'BFFE15CCBCB3322718AFE54BB9C81A32E2F47718A15D6F14EA35878ED09A7A9AD57AB9CB815EA6CFEB60704D2C9C51E32D676F8FE4E5B86B02591AB6D5DA1903766E67F96B9B15A2ABC9E3173CE556AB55AA6B151C4B1BBB8574AFD759E7690E8487C566';
wwv_flow_api.g_varchar2_table(343) := '8F8E505B9D0D06492462269CB579BD75066BD74B68A77373A5A969CC9CB978A14E5AF3F1A053A7D0D85C4D46484513A9368AA4569151E97B566A235475C577E08846A72CB538A65953215DCAE48CC6D31AA1E9F2F6B64505D32AE74B2DB75599AD0934DF';
wwv_flow_api.g_varchar2_table(344) := '70B8818197DE51AECEA9D994DF7740A557336514949FF552ABC634AD6AAC8E6ACBA9788F45AB7A045DD3FD808938AEF985E7708BB9F5EE25FAC001D2EB6D5DB9021EB6CA13277870B505A2614B0232A5596AD541FD53CEFBDD564C6148979B9D52321AAA';
wwv_flow_api.g_varchar2_table(345) := '99BD8D3792C870691921F6578AAD6AA76CA1F132AAC16AD91E8F0B5C8862992ADB2C043CD6BAA869D58A0A8E51DA5CB1585245323ACAA0B11A0A0DAE9289BA4C1AA569375263A339D48573F46FFD3AD26C89E00E041412B874825C1F15DB7FF1970888A9';
wwv_flow_api.g_varchar2_table(346) := 'EF4DF91A53CA26AD465AC4546693BAC3937C23CF9386542AE5341053254572EAD2CB174F10D640229CD461ACD5DB5B6CF262A7D16934F4365B2E9D7583D65E674EE51AED4AD66E377C783BE74416474F9FCF9451AE5BF6F718E35DED0FDEBDFADB676C46';
wwv_flow_api.g_varchar2_table(347) := 'FFF178AA84B5CA30E631F20E751B4E559076291A0B8EA8CC1D4D43AB203AA8026D1559CA08A2759046BB6DEA549951A36D5B4F6FABD9ADB599460510B6E08ABBDFC87BFBF4D159308FB43A48218D4C7691451D921F445E0A20079548E547EB56D11F655B';
wwv_flow_api.g_varchar2_table(348) := 'FF9B2CB512E313DEFD4E8CD6B20C278A18B012D58EA0E28BA4DADC68B455340A145B3D93E8ED31A31A633C91C5DA35A7DBD915512D8555594A213671A54E68D52A2C552EA49D3A0CD5F6601C2803F59556572D34488DE4780C04592C9A52630D57AF6739';
wwv_flow_api.g_varchar2_table(349) := '2F4426DE1A7AE61918C970FDFDDBB347C958D6FD7C261D35869C160DA2B3F95A1C928AC64DB46872F76ED0BBC56C5DC7B5BDDE9170BE716B6EE1A2D59628F2145F75F738AB0C66A00591D2D47255BD45BBA3F5FE66B7A9F367E9DFFE75A4DD16257386CD';
wwv_flow_api.g_varchar2_table(350) := '7182B4FFEFFF0701C38F2D09E8FBE99BD35622A7F3EDEBF0E88DA93987D3D6E1EC4DB661D45030018546D9E5B4521A43B6D2A9E49276BB3695CCFB2984750FC130D6211D6BAF67438D10CB3707C9B2C1773C5C6C2DDD9A1E73B8122958C22ABE1E63B4A6';
wwv_flow_api.g_varchar2_table(351) := 'BCF2FAE5AF7C7910D5EE49A7D3469A35BBBDC9959CD1466175DEDF634254A668BC8032658FC388A92D897C95AF65BD2E4797D2C522499D8273F4C0122AAD091C0FBEF08D66317714615418EAED75ADE5C5D4F4A54FC000B738E1F54C2DDE681FD0D3A0F8';
wwv_flow_api.g_varchar2_table(352) := '055DCA8D7CDDA5A6F71B94EF169A97F38D5E95C4796EA2556BF1C95012B9380C97A285DA1987D815BC91581A0680DBE3EEA0CA6EB3922F75DC1622DB4049B6D6E3768B2819CF94917AD1ED7562D43D84EF66B19B071CCF83F1336878E00D51348D8A08D7';
wwv_flow_api.g_varchar2_table(353) := 'EED4EB0D8DA0A628E27E063853E12AA5D444BAE33D5444686BBECE54B2B144B4AEAFA5F5DEB2CEAA6B3018C28292466C16B20E93566D71B4AAF50A4C817AC9EDED4170653053C59A39BFCBDAC00DE968C4AA220C3DEE46574847E3F13646A55787464F43';
wwv_flow_api.g_varchar2_table(354) := 'F34A1D44D158F38F8EBD7D7BE154255CCCDA2D08E3F1EFE3958689ABD3C76C0C69EA073BCC5E8725132EEADA15BBD3B3C910A64A8D4E31E974DAE6E2852F0FB004EE4448BCC188C978C2AC412C7678AD9F903404D657A3D1C02F689B4170100A8580DFFA';
wwv_flow_api.g_varchar2_table(355) := 'EA57BFBA89E7E6412A5C1AF3E0735D776E714238BA2FBD10197CFE40229CA78976AFBBA7C351CD66A75CCDF798545D8D2DB31ADC7B666F2E9D771A484C6900656628549A16E3D6DEE18668A886E3BE3387F3B54E2D937459F5094237F3F63F9D3875C160';
wwv_flow_api.g_varchar2_table(356) := 'B3AA74F67CA563510B5D544132CD36A94B45221A85D8D3DB0B2EF9D55A1DD63E00E139733155EAE8F88AC6EA802F4B2E971B51B3A4DFB716292CDC9AF79D31C2D330329391948A625DAE1E50BDC512594A6CEA69BDD67A4765B7D9B5871C80B9C78B2F22';
wwv_flow_api.g_varchar2_table(357) := 'FFF13F22D7AE21F1F8DDCC23231257FCEFFE9D6437B42505D3D5DCF48DC1237B50523D1FCE1BD7167A87F5A57A4789B67995B1944D9B690216AB2E8F46A3290DD92D23063EB8163877315D69B5F309B7DD44E924F168A58BB0D5A86FEC4493552F2DCCBB';
wwv_flow_api.g_varchar2_table(358) := '6D615617C8A7D3163DAE36F5BCF5DEC2317F71E0C8F94481413A4598F2B536195F88D3233D66056AB0F566CBDD4A1196591416C9729BCB27634E208A6C9E780E2C5572F081D8E06F619A74BA4C24521441C18F22CB2BF3A746FAD7AEDC1E1AC92AAC1F9B';
wwv_flow_api.g_varchar2_table(359) := '012EAF86CDDE805AA78BBDF1B6EBC4215C6BACCDCEB218693B75B4994935521963A07F13AA0A87ACDDBE7AECAC1F231CA28083223C14CFAA84BA0316EA8AC8F03582C731050D1FB54697A996B27D4E7D4E347DFFDD1BFFE2B84ED93B9648E50D0ADEBEBE';
wwv_flow_api.g_varchar2_table(360) := 'A6C15720110B8E0E07905D452860ED0C8B03C7B24C97D1EBB406BD1EE4950CC703270C76229B0DDB3880E6CD5DBB15F02094C1976B0BB76E2F3CEF71670BCA6A39B7506B9EDF7FB0CAE91697A7874CC4DE6786F25D6CF9E68CE9403BB0EE610C6312DA9C';
wwv_flow_api.g_varchar2_table(361) := '4BA6D9BA4B610384F9C56CFDA96A133EC94D464CC5E33A05AED7510AADA4F9A862447A7EDAE03F72652145B5AE06CE3E159C4EEE1DE192E54EB390E83128355657A5D569952B8C124FAF85F79EDE932B14EC46225542C5565EDDEB4807A3668F86C0EA2E';
wwv_flow_api.g_varchar2_table(362) := '9F0B885BA0AC1AB9A4D3ACD5589C4003C362D5A915031E3B426EB732B8A7CB8280057C8A7FF37BA8C12856AA7778601CC34C26F6ED77BB3FFEA76D829EE568A1199EF61DD827E2AAD9D59439B8E439688D0673F562B1140FDA86ACB15A39F7C178FFD805';
wwv_flow_api.g_varchar2_table(363) := '52E78AC4B34B732B2F3D2DF51724B937A6562DB5A5910B4F7750AC5B6A186CFA54BA49200DAFDB8AA34A8C243B8CE4C052AB94DC361D4A19494A017AE06E073E0D5DBB92D1DA7A9BAC908A24744A5467522B2531D0DD4FCC3D9D924F64041E0F021221F5';
wwv_flow_api.g_varchar2_table(364) := '38D2B7CBD34BA5D87F1E1A78B368FEF19AEEDF38A9D3E84227FF2D923E442392A46D6BAA73483B3877FA99D3C99BD3235C6D2D87C5AEBC8D3AAD996A75F489D3572E2FAA548D420BA3ABE982732474FD8301BFC3E986AFCB4318E0F52A60117BA4498563';
wwv_flow_api.g_varchar2_table(365) := '6893417EF4DE948F6AD73A1D87451B4F3574427C0E3FD29E7D8B51F5E4B9F2C88953D7D78A4C2942F1C251BEB48CEEA94EBCE5F5F9C2714E575EDD7368643993CCC5C231923F75FEF4B5A5969059CCB31AA7D0DA107A81E4ABD641B299AC5361BCBCAAA2';
wwv_flow_api.g_varchar2_table(366) := '2297F60DF58513CD4636448808D1CD962D6391ABEFB05A7B74A6841A4CD562FE39AAA3B0ED818E80F54AB9C16532599BC1995AA968AD862B1F4475AA78B76F201A5FCDE532792D7FFCC2454CB59BE8742BE6778F154AF3AFFF060A363EE066F7E4536CA9';
wwv_flow_api.g_varchar2_table(367) := '440F0E76E7E74DBFF55BD5EF7E576834EEE65CB781B97C7945A94A54794ACCC6742363E35727D5CA66315DE7DCE64432B39F6ED751F2C6AB57F55E61B1DC55D9CCD954E149A25111BDD373B3ED569EC818E28EFDCDA9778607032B05311BBE451A0C9A58';
wwv_flow_api.g_varchar2_table(368) := 'A5FFCB4FCD4DCE019B9AD5A0A7CE9D475512F5F0A0842A95D4FFF2CFC44C5E3270057D3590E6EB318DA85FFD15C5EFFD0EFBF6A5AD0F7604E4D6F894584F91FBFA82C9CE13A3D670DD81A4E772B8B3129ED71C0C24F2BA5070ADBADF0F8E45A1A5659C6D';
wwv_flow_api.g_varchar2_table(369) := '3D4594DE8C99DCE5C9ACA0EDD12E175A643B56728F3D7FFDC62D33D1D4A8F7ADC5730CBBBAF7D00150016552D3624C551938B51A8C947D9D32E95B9C986D37EBA79A21B724FD45E753F5955B1F6AD5CA6A26CDEC732FADAC9CF46AD3D400B6F87ED6FE4C';
wwv_flow_api.g_varchar2_table(370) := '65EAAD8EC6119B2D733A53B79C7BFA09FCC64253ACAC9611059B0A0F9F3D87A0BB92032481D44AC8DF7E1F51A890604132E72B1991FFF7B790CE0A826D1F0C4BF1925F9BF7EF7F6E622644B44B3CEA5A4EA4100B22C453FD172FCC2D045D567229582A15';
wwv_flow_api.g_varchar2_table(371) := 'D3AD14D27FFA99A568BA1C5A3B3A92A821A6BD4ED5785ED15799C20E3C4F46270AFAC30B338B49B16C3D7406E4F623679F9A988C1C735781010646F3D674B89E5D45509E6F9773A29FAD6535A0EC420930D90D46E2362C443A806C6E0415A148293FF69C';
wwv_flow_api.g_varchar2_table(372) := '7671A5140B2FAB84F613173B0ACB20BC3E52143D4ECBC0E080D987BCF15AAC534ECE87B06E66E6F4FEBEA4680BE025217024383971ECC249947EE03A802A15D4AF7F43CC17981FFC78739C807918FDF55F56FCCBDF66DFBA679C00A9CAE4E6479F3F4959';
wwv_flow_api.g_varchar2_table(373) := '8760D5B819EC960BC11BB78B365B563D3CB21A6FE657E68FF4AB4DC3E76F4D2CA0DD9246E106FF380EC517C2F1D0CC84D8619F10CB06EF51683CA896FB5C66CBD0808D45DEFCEB04686557637C2635C3C75479D7A1E5B5483D47A154FFD44250D1483DF1';
wwv_flow_api.g_varchar2_table(374) := '2CDAC0F1D05A88D137BB89D0E0F9B34BB1623D31C5B87496D1B357DFB9EDB6B5EC56CDD45235169BA3DB8D8BA70FEADD12442E9362EFE8A1B5CB304345A75969320E86F311951684EE8FBAE86D4E9312C32E56BB369218D42A6F161A760539A8571E32A9';
wwv_flow_api.g_varchar2_table(375) := '68E889204E965BBFD46B546CD11E6004162AD62F5FB92E888A4A2C291E18B93E1F6B24177011C19BA9BAF364E8C377789D3D3C5D248DC652A1F80B74372B3AE66EDD6E376AC7400878F4D94DCDC0661BEE39008E97173AAD96108F30B50AF8B60A2A8DD8';
wwv_flow_api.g_varchar2_table(376) := 'EBA79434216EFF6601CD1B8F244EEE75CCC4844636C139ADB7AEDE22F06A36D955EAC4E9F9953327BD6B71A58E099549DBF2E48C57CB8F3DF5FCE5ABB30AAA562CF35A215DD41F9A9BBC6EA011B3919E0B6652D1551DDA39717EECC61A2BE656328CCA8B';
wwv_flow_api.g_varchar2_table(377) := 'DE8925012B4DAD2D245219605010A55EC49042ADA5C964AC36ADC9622EE42B5E5D43ADF6F5E9C8B49BB1543B2EAFA42A81942EB7A7AFDFA6B1069810E3382688E842B2E033E96ECF97D289050DDFBE78E1A8DAEA5BCFFB497E80E385C7400F0C6C24E87E';
wwv_flow_api.g_varchar2_table(378) := '2740ABB95312302C5BAC71684EE9B235410086E30C82CE2E25997AF099238319452072ED7DC6A4AEAD945C175E104922142DA7C309DBB13E6080451EE9B368454BFFF2AD69EDD1E3184EE69BDDA91B93A55206961C6EE0C45A30ECEC1D2824C2819317DF';
wwv_flow_api.g_varchar2_table(379) := 'BB3EFB9C1F5B530E399A4BAB3553B31C01D688165AF1B625317D7D64A48722B07C835B084F1CEC516D30C00A52EC773B55830380C39B3F7EDD584E13E9BCE8E89D5D8C08CDC49363FB92A4333C799DB668F195F2C56F9CC1A81D544F3B757AFD1AC8499F';
wwv_flow_api.g_varchar2_table(380) := '7D16B45DC89FFD1902E6D09B697414F94FFF09397A14010E794B5A4B16F6596AFDFB40C58D54C8DED8CA2BCD602ABE3877605F4FD7A29C9E595430CD679FC76EC5C94A78C66551E00E154290C95A67EEF6B56AA954B1D2874F5F045E055E8BCD400F0D04';
wwv_flow_api.g_varchar2_table(381) := '445C972F48A6C208EE99985936099543E74FAF46534E34DA37726439DEAC4427BB3D5AB4EF44B252A5E32B917CEBF45924DD302CCD2CC4B8CAD92F696E5EAFF08D69DD606F4530DE9E9C6EB6725C5C3B74E11C82D00A0C39BA3F109ECA42750406D2665D';
wwv_flow_api.g_varchar2_table(382) := 'B95236C1947D98A4694B8FEF1EA2F5B6CE65674BD5E2A50FC85C4A5419DBB373F4C81EF4EC71A3D3CA97AB77B34A9E3688DEE94866DAFBFB1954699C8FE5A3F3130E2D4E1AF5575E9BEE1F21C4AEC1E55007639D7A7CAAAB5675639C387074350C1F546D';
wwv_flow_api.g_varchar2_table(383) := 'A163CB2ECDEC1974813E17BE0E502CD0395B0BDFF1189C92D3D91C01B30845D55AB5C04B09C7895024D261BAA013DEFA54B226685A2B078EFC7384D07B04E47F2CA7B95A2A95505F38D83B176D318504AAD8EB722897B2D840A7BC1A14ACDA0E8203870B';
wwv_flow_api.g_varchar2_table(384) := '8B0A4EA3C8A1117F2B96D870A0D93F607B373682A0CBC0FB5D9E5A41B22B3C6DF4E0A1FD4FFE3368F8804F3FFD2169AFE5FAF05A13F3E74A597D35D4D08DDEBA7D4BC1B773287B740CB9B25CD71516ECFB86C10B371CAD6422497EBFFFE6B5A55E03D167';
wwv_flow_api.g_varchar2_table(385) := 'D7E51934140C96EAE43348B66C38BA70F33A22B0F920B6FF0CF9E1D51505592D7670BC10F71D0723979DCDA6A48EB31CFDD52FE3FBF777FEE22FC50A44C3C2248E17C38853C7E97FF19BDCC2222CAC5BF10927D2A7BC0AE7F041B898166CA9C4EB2A70CD';
wwv_flow_api.g_varchar2_table(386) := 'A8067B9F7C26159AB40DF1169A2BE85DE99515EB21472116B65A4CC27AED603A1E8965ABC5A0F5D0D8ECD4A24B4DA8F40717D6D28DD2325970B0DE43622A1F03C79CA95B5D85864DD515C3CF7285589DEE59BAFA0EA6B107ABB98BCFA9AF4E97C5CC2243';
wwv_flow_api.g_varchar2_table(387) := '6ADD9AE2E899173F733F9AAD3D958F6504EE47E0E1CBCDFDCF3CCA956C2D1F2DC5399E2D35C4D52CDFEC80175753282E0ACD2DDF9E8F0A0A15BBC9D094C832F349A6935DCC3638261D1AF079E66BDA546A35158EB9F4A8BB2F70793193074EAB99950C39';
wwv_flow_api.g_varchar2_table(388) := 'A4CFFD2748EB26BE3B3D07EB26D8CEAC86931E8FA65020F45C49B0070AC18968B143346203014FA64C86E7568A6BE13D7D1E95B77FF5CA72BC5CA61A296B4FAFD366E9F37AF2886DE2C3B74BA5F21A08CA0AC9CAC252FF8047EFEE15385891A5E6821EA3';
wwv_flow_api.g_varchar2_table(389) := 'C3F00C0B3156D9954C43036A37A32B3E171AF2DB6C7D03CB57C3D972BE9B0BFB7C3D4B8B259F936E719A5A3276A7B1A2086E1520F464053EBE98E976AB8995B4CB8085BABAB9AB6F14AB6590FA0B9DF24E3D7BD8350CA3037D284E40E00BAAD7DD9E9B53';
wwv_flow_api.g_varchar2_table(390) := '8E8DD17D7ECC62E946226086B8F579F82C4497D236BAEB0FF4CF46CA8B6B2B6626D2D73788ABAD4A9CB75A6D0EA7A34DA8B30B21AFCB1529B65C54B9AEF66672911BD743B1C5897CA9145B0E27F205752745D9DDB38B4B036EB5B9C79F59492F64CBF337';
wwv_flow_api.g_varchar2_table(391) := 'DF2D566A2B6120770A5B2BBDFF18552B89FD23CC3FFE9079ED75E6BD0F984BEFC36FF7073F66DF7C873C7D0255505B1FE124DD4216DCDD281CEDB0582A1A4BC463308272E51ADAADC280709A74BD6E2761F15EFDE07221170EA5F3D5D8EA42BC6C21EB98';
wwv_flow_api.g_varchar2_table(392) := 'C6D90C859D014F32B1DA6A3573C5148AB23481B86D266FAF87A7CD75D028158A93D7E67AD41DABB3C7ECEBBF361349AE4DA4CA95CCDA327C47E1C52F8EC73C06CE1F0888849A13D124789D752B5516A92697E265462C457AFDEEA5F9BCDFA505F17F359F';
wwv_flow_api.g_varchar2_table(393) := '4CA50B16AC3110085C59AB21EDF4D6BEDC7F1C1BB4169418321F46C657907205613A22DB8D114353AA6F1488A16DF99B5D56A580F89938389A4DAD25C44666269657E3DD9944AD9089D581C02B76966EBC99AB55232BCBAD7AA59E6B86F3D5F0ECE56A8D';
wwv_flow_api.g_varchar2_table(394) := '0FAF8513A00A0F2752B178BBDB6EB69AF54AFEDDA938D18EC622CD6C295B8BAC91EBAE537541CCCD2E0CF539CDBEC1B5A96593124C0E2D4A0B5876894A02713AEC5EAF0357E9709EEFF33BE7AB9A443274E3CABBA5523A984837F3779433801BBF4ED303';
wwv_flow_api.g_varchar2_table(395) := '834FE1143856B5EAF995787179711A27F0702C914964844E110437DBFAB8F514E2811307B78F13E607AFB06FBD439E3AB96D9C00814E100CB1EE880B852A356A16E152CB49974D2150FA5AAE1E2D3696663F0CAF44E96A7C68B04F6BB08928D2E0882BB7';
wwv_flow_api.g_varchar2_table(396) := 'E78BC9E05A0644E64B9BB50BD29B879683F88DE8B262AD51CA168BD3D7E69C7A0EC83D9DBDAFDEEA346BD9F1954C36B900E5D87564FFC0C05CBC5ECFC75A8D523453BA3EB5D069574B19E09545B047BDF2FAED4A211A8D656BE93B6B02898390FDCE506F';
wwv_flow_api.g_varchar2_table(397) := 'F2D8F2C292BE1EED3978F211457E9B4D8583362FD639CEA100411C526458A78A7CC2A1F7AB1589260BF4740D569EF5EE6C3E020D66617167DA1D58CD38B6C30AB199C8A0CFDAD337B87C3396ABE41AD948BFD7B1B45CF1D8C90E6AA82462E34BD1C4F2CD';
wwv_flow_api.g_varchar2_table(398) := '54A59C5C5B42449894BB25C9D7175499EF5D12FFE67F60DFF93BF4BB7F277EEB5BE2EB6FA10C87DD1780077CD8C6A7E741B1506B09A9D072A8D0C16BC1FE403F98A0C394AF707C26144EC6A314CA14AADD5CB5313B35DBAC17E2A1B84BC5113D81D8C2D2';
wwv_flow_api.g_varchar2_table(399) := 'CC78286060FC7D0339513FFEC1EBA54A3E144FA4D2D1DAF252FFA047EFF288BC24628316C3C000E33EB04AB0B692A4AE9717B85697E180E814C513070679BD777639554ECC434ED061035DBED9C91BAB59BB900C0C0ED21A23ACB4A0A95A88E6ABB5D287';
wwv_flow_api.g_varchar2_table(400) := 'AFDFAC5452D150BA5D7CC84CDF2C6A97039FCF77ECD8B1A3478F82167AC76C0222565B1D232994AB048A7460F56BB69846BB108A64A38B0B2598E79964BFDF1F59A873ED72B8CC4D7E70C5E5D4E20A50CE48DF3012E10E1CD9B756422BB139E0604121B6';
wwv_flow_api.g_varchar2_table(401) := '78FD8D7CAD120EAE1970DEDD63E9F179421932B2B65A2925E36BC9246803BB7C37393DD0EF55D9FC6BCBF3B084908DA2D1E66A71D4D5CBE34EAAACB13A379A0A00839DEAFFCFDE9B00C9755509DA2FF77DDFB3D6ACBD4AA5D262495E2479378DC1EE061A';
wwv_flow_api.g_varchar2_table(402) := 'A6039A69869FA18799A081EE09F83BFE9989F04074FC31313D41C01F0CA63D2CDD2C6E37061A638C6DC0968D24CBDAF7B5A4924A526D52ED5BEEF97F59B7F4F42A332B2B4B654BB2FD6E4859F7DD77EE39E79E7BEEBDE7DCED11CFCF1018F5C353F1D1F3';
wwv_flow_api.g_varchar2_table(403) := 'E7A6E3B31353C3A7BB077A8E9F3874F24C63205755DDD87BE6AA949E2859C04513C1CE6EA69FFE54EAE9C9FBBAF2BF37DF94B66DE3A04441467A488B797EF793D562D499744303E3A6E91157303A399618B93275E8ECD9BEDEE317F7D2D10523D50D392D';
wwv_flow_api.g_varchar2_table(404) := '9345B9031747BAF7BF36383A71F66CB7949C1638F31B92325934C7A03364729A8999197A8343872F64272E54058375B57571AD636A7CE8D2E0F01B074EE85363465DA6A1A66E408AF69F3B34339DEF66B71DEE4D0C9F1AEA1FD12426D9E07AF0E8C0F9A3';
wwv_flow_api.g_varchar2_table(405) := 'FB878747CF9F38C7F174A8D0263807CB2BE2B333099608D3E9ECACCE924ECE14946BE9C79C64C05FC2BBD46B8CC180C6E9D298B4FA905FEBB2A13C7A8B49B3700BABD320ADB9FBEE599DFB8DFD6726074F9EDC7DB6B9D6565DDF3CADB15C3D753E1C0E0D';
wwv_flow_api.g_varchar2_table(406) := '5EC94E7222B96FCC9E1C61503BDC97F2A62F0522D5BEBAFA81F1647EAC5F8870690E35942E736578C4E1B4A330744416B399D17962327F0F5C4176CE159B8C69499F9F24356925B3CD3A399B3C7AF0682235393C951C3A7B1A0BB8DE6F3147EB18F2A67B';
wwv_flow_api.g_varchar2_table(407) := '8F459A6BA4D43C12FEC852CD6747E375F9FE762291EB3D70A2A529A4F1570FF59E16D65D84BD78AE9A83874F6CAE9A4E346C3E7E607F2812EFEDD3B93323CDCDCDE35977DFD1D3170707A2CEB4C313383F1ADFFFFA8EAAA8634AE71A19B9C47D5EF42FE9';
wwv_flow_api.g_varchar2_table(408) := '5CB6D66FD506EB078E1D3F7A7934A219686E6DEE4DBB2F5E3A75B9E762D496A96B6A7AFDC415295178B24959E45C2663D8B83E73FC44E2A73F4BBE3A6F1A257FFBFBC43F3DAD8D447475B5F2B5DEE4A245A77369B379BEAFB05A2C3A83EEE4B9A1D1A133';
wwv_flow_api.g_varchar2_table(409) := 'E94CFAE8A93C2DD6F457AFAB3F77317EFA6C8FCF306A76574182BC46AD140EFB9A6BA3718B67E46277B436309B35B171F3C2A52B27F61D9D981C1FEEBD3C3036619AECAB6E885D3CD337383A76B5EFECF0546AB2FF5C537DA867DA383478B67FFF89A6E6';
wwv_flow_api.g_varchar2_table(410) := 'A8C65F3378B147CA2D3035958552E3AA04DE2609BC5D0EF0475A1FF8E2868FDB8DAE479A124F3C32DBC95288ADCDB2F12BC6FA8F1594844678AEE792A4C90E5E1AC879CD27F69C34E5661D66BBC7E1960C565C3EAB4EE774BADC4ED76C5ADBE0B1781BBA';
wwv_flow_api.g_varchar2_table(411) := '4E5CB8929EB8548067A9477A18CC95E9CC4C4F3124836326CB4C62CEE3B134B53584ACC1683014AC6F4E271398096EBBC9ED76EA8C6C8C4E6A5229B7D36676B852F134365A43CCEB6731DAE7B159ED199D5133936CA80FAEEA5A9DB58572E9B8DBEFD69B';
wwv_flow_api.g_varchar2_table(412) := 'E9A3E7CD20B690B5844DF76EDDE2ACE96249A3BE216CF586338994C76EB139DD589270515FEB6A8A355A1CE186A61A8F3F9A9ECD1B04043625AEAA716EDDBAC5156C222FA01E8DB6B63126199D864CBCA931DABA66FDB8C67DFAF4F1E1F1C9B3DDB89353';
wwv_flow_api.g_varchar2_table(413) := 'BD17CF924F642FF78B3B3E3030F6FCF3E3CF3D97BADC67EDEA9A79F3CDF495ABF1BD7B678F1DCB5FAEA8083CE8F45A3BE270B958FB9A9D9D75E8350E9727A7359A74399BCBED0FF8B57A7B95C35EDBD4EE0E3A1A231E5775633C979D8AA7FC56A9A3B121';
wwv_flow_api.g_varchar2_table(414) := 'BA9613B0C6C6069FC51F4966531EA469776AF5063C7B432AD318ABEE58BDA6FCF22FEC70D533CB7AFA0DEBF5B198CEEFD70502F9DFE626FDBAAECCD9F3B985739CCC8E77B4B74F1943C33D475A5A1A4EF48E67AF5CA86B6E6EA9AF4DBBABFBCE1DF15BB3';
wwv_flow_api.g_varchar2_table(415) := '16875367B2266666EA42CEAED5CDF66887C1906B69ABAE0E55056C81BA16EC1BBD539F6AEBECBC38659ABED21DF0B99D4E47F7482E3B72ACB6BE712421F9CC59ABCB67B258F009824E43476B2CD4925F0C44BD135CF7E2A08A9D59CEC46BB861D3D67F65';
wwv_flow_api.g_varchar2_table(416) := '8CD34ACC66305E37D47962750D3667B0A9A9CEED8EE0C032F18CC27B5DAE24066776891AFCE790F9079B5BB3EB3BF3A4A8ACF56DC73EB5EAFF1DDFF6C4ECC49BD7144FAEC0BA80FB789F61BCEF6C5395DFE4ADCA6553687EC467355635EE7A7D777BAD2E';
wwv_flow_api.g_varchar2_table(417) := '650A9973F1D6869AD8EA4D672F25F42317C3CD0DB313A391BADAE317FA5B75B343E10DE3875F3584DA2F1DDFDD54ED1A330483DA5173CB86433BF736D7194D9E0668C1314736DD768B15AD4EA59C3653D0639F3B21CF6775248FCF6FB558996C09471D8D';
wwv_flow_api.g_varchar2_table(418) := '0D0DD3E1C6C4CC783A91601BF9EA351D165F4C708B3B3A36393D3C3272E0E019B65C774F1A9D1C33AB6BBD3A3ED558EBBD12775C3A73A8B5A35EA35F30D92197544472EC711DBC32A727F5D7F5A4A951BF764DE6DCF95C6A811BC6F53193DAD8C963C787';
wwv_flow_api.g_varchar2_table(419) := '47864FF70E9A074E587C0D3EADB6B6B9B16F529FEDEFA9696D98986653FCB83593F4B85D7AA3954E239BCBC627535501C79A55CDEEAAF9D3DDB8EEA31353578747F61E3C53EF1B3E336ECF8D1CABCFEB89C66FCF399C3EAE51397EF24CCC99D1FAEB2727';
wwv_flow_api.g_varchar2_table(420) := '4631296C0E076D8A5587539746F4578E56C59A2F4F4B0E73A6657DFBA5A1E4F0C58BA9D44C2CE45EB3A6CD55552717937E001630808F1C1BBA7AE1484D9D57630D5E189E193E73E0FCF0D448F7A10BC3E3F12BE764F8C522DCD0E3D0EB86937481B98D3E';
wwv_flow_api.g_varchar2_table(421) := '4793C332B7263C3B867599CDB9D975BCD0B2CCA5B331BF63CB96BBB76ED9ECAE6E65BF723695A41FB3BADC49AE8BCD6498CD696C68B2D9C30D0D35FE403415D7CC24527EBBAEBDA521DABA694993170FE852A2F7C2AF7FA4DFB57F42E39C74B90D9A7DA6';
wwv_flow_api.g_varchar2_table(422) := '73DF314F1E94B4852BC0DDC37169B867702CADD1C74F9D1E981E1D309B726E975732982DDA4C7D6BD38EC3973CD3DDDA50FD8543279B9AAAD21A673C3E1D326B1A1A1BB12927C7A5F1B1718749C72093D19A32F19986DA4067D76A8DAB868DD76E9FDB60';
wwv_flow_api.g_varchar2_table(423) := 'B6E1CC8A8D44D8D3AD61D3430FDC77351518EB3F63C8669BA3FE86D59D19A393DEA37D55CD187B85CE1F45CE2CC9D24FCB02E772358B21E1747BB9320DB5C9BFD660F24ADC89D814F1AE5EDF9E764471F0462726CE9C397E656CF27C2FBDF702FD94512D';
wwv_flow_api.g_varchar2_table(424) := '19617FE8623078601DB148A479F5C593031A69963E63DFB9BE40AECF176D1A9F9E31A5E2B5D128BD742E194EA5E28944663C316DC23CD6E54D64BAB264265BEDD487D6ACDD77A03B93188EA7336629D5D250D3D4B5DEEDF33A1C2EBFDD606E5D7B66EF9E';
wwv_flow_api.g_varchar2_table(425) := '4DED8D07127EEFD07E43B45D4A4DB3CBC76C77325560CEA46B2311172A91D64E4FCDE873193DF7C8CD056E561BE1A6A591917DFB8FAC71A6D3262F63F6DEEECB51EB943BD2303EC9B9C2B8C76567BCD01B8CC3495DEFB1FDC33389CBC7F6F54D25877B0E';
wwv_flow_api.g_varchar2_table(426) := '2E56E4F97414982FE77DFAD3D2AA5512E75AE57F0F3D243DFA28F7132A0E4CE67344FDBE3D67B3C3FD3D832323E78F1D0E3B9DEC028F4523A640D5E95DC76335D6AC23303E36CA612DB7C36A7338331A2DF605BB64ED52AEA521D6BC6AADBC5595B16F78';
wwv_flow_api.g_varchar2_table(427) := '6CE4D4F92B53FD87AC81E061A67DAB2C1A7B489B9CF27ABC7687FDF495946EE0605543733FEB04C96983DEC4C65EBDC5313C9DEE3FBEABA9C63D6E0CE626873BBAAAD3B6AADEE3E76612130C37ED8DB1FA3B5633988A02523B79BDD2E406C61399FE4B9D';
wwv_flow_api.g_varchar2_table(428) := 'AB5A7B279C835787CE1D3B3C36337DFEE8C19199D981B3078BCF07CDCB47FE839CA40CE70DA81DFB5D1B8C77AEB36D5C6BD8BC3115F04EB275758AA9B60526C1544A3266C7D77536F627ACE3970E333B80BD6477B0EF5ACFD27EA88AB9752B1930243072';
wwv_flow_api.g_varchar2_table(429) := '5C980D5A13475D6C6E9FD96C6AA9091B232D3DE7CE66674664FA9544D8F35C150933F1C41C136EDBE4D4B4C1680CFA4B7CF62FECD0F64E87997C674BEFC19317C28981D3130ECDD4C5BE512E3A481F3F76293D3B66C925636D4DDB5E3B11B28ED87CF5F4';
wwv_flow_api.g_varchar2_table(430) := '66320F48952E9E20529030AD9A66AB4F67DDACB0DB6C1A16AEE75E5A3452B8AE7AFF2B07238D9E605BEDE1578FF843DE4CCE60D166DD6E57FEB6AD44D26ED53535561BDDFEF86C7A2C41454B7E8B29D6B1E6F4D0ECF8E0F99049D3106BAC696A9C1AE544';
wwv_flow_api.g_varchar2_table(431) := '49D2ACCBB9DDEEACC1924E73C2454BEFE471BAE239DD12B3875A4DE6529FAEB646BF7AF5FC9017F0EB2211FDE6BBB851303B32A2BCD5857A09F982FB4E0E8F0C5EEC1F1EE93F71D0E9F433B91CD7EAC6FA2F5FD558FB4E1ECF68324D5EF398A7EEC8CB2F';
wwv_flow_api.g_varchar2_table(432) := 'B77644323996FCF3DD9A412379FD1C57B36974A670D012696CDCDB3BEB4A9E0BD53473BE8FFB66A973B336DB5815696C69C8A41D9914C79C5910C8D655399B1A9A2DA1AAF8E4984E4ABBFD1EEE88E580FE0DCCDBCAD5A4465409DC98040A8D891BC3529C';
wwv_flow_api.g_varchar2_table(433) := 'AB67ACEFFC44FFC6EA3BDAB2CF35277668B39F92D24EDDE47E0DB371D25D4A78E67CB3A9C907B6AED7B963A1FA74CFBE43BEF4F8C5B1D99937F7B5E9A7435577EEC9F5BD71E4824633B2B9CD9FD2BB6766BA3997285F4DA94455229EB7DB447FCD2D7771';
wwv_flow_api.g_varchar2_table(434) := '7CBD1CDF460A3D5E0069D26B7C01CC3C7D34C0EE17BDC76BD1598C0E43D6E2E1A4B1747660AA77E71EBF65A2BEE39E9E4CFF1FDE38C0BACE9DF7D4C70D4E23FB4725C9E3B79F3E3B7DD76C4F6CF5668EA2182CFA10DFA1AD6DD8B963CF4CD6559FEF97F3';
wwv_flow_api.g_varchar2_table(435) := '53B336BDA4F357198D4C366BC22E93D1CA1625C9D954F387378F6BF5DDEB3684AFDAFC769695F21755BAA4ACC1ED3019AFDD606137692DDE1079D9EFEB0DBB8C06FC476746676E0B18273BB6A493499BC73A9BB35CBC7CC160F75FBE7C3E600A4E0DF5D7';
wwv_flow_api.g_varchar2_table(436) := 'D6D408D205E5553E6A92C9ABDFFC26E77EB3E36323DFFB3F8648D5F41B3B357AC3CC9E3DC99327B5F76E5502CF75F59ADDA72F4BBD89CE6A87A5A965F7AB63FD7B76623919ACB52187C16076B1BFCF1DE59448CECF1D804687CB2CD925D7DA4DB14B07FB';
wwv_flow_api.g_varchar2_table(437) := '72E9948B7B00537643D6CF80118B356D3F7048724D6B7253ED21E774F3460EF6189D5CB9B9D4C53053D3F11F3F63FAE0FB353E5F6E7A6A6E0BB4A4713A74ADADF1EF3C959FE957047AEB9494E1F642AD39531D766C7B55BFA57AD6E80CA40659BA98D2BA';
wwv_flow_api.g_varchar2_table(438) := '333EBB613A659AE939BA6AC396CCD829767DDA5CCE883B2199B3B694C6E8F5324BE4F687B31C664C4A9C7ED569FCDEA0E3ECC1319FE37C22A10F187386BA1AADDEE877BB7A8F1D5DDB76E7E0C9FE6C3A69CF5F91955FA08C6DA8D9BFA7DB39B4D76DCC58';
wwv_flow_api.g_varchar2_table(439) := '6D365FB8FA0FC7B7CD5A0FD5B9031EABC19C0EB235C01F628D8541CE62E4FA46EDC4DED3FDC6A137EFA93549D6B0A22825A22753A957FCD6E62F7EF403FFF8A2E4B4ECFA37B1A7D6F63C33F687646AF811FB7DD2C2B3962D51E758C3A65DFB0F6B34264E';
wwv_flow_api.g_varchar2_table(440) := 'EE6AED6D114F526730B636868F5C3810698D25665CC996BB385CE58878131ADB9436E332E982E1FA9AA8E3A035D41EB4C48DADB9FEC32E5F10516812B9C61A9F994612AD7AEDF5DFDCFD17F7892BDC9D1A8DB9A561C7CEC369937E4D47ADDE6AB37A8262';
wwv_flow_api.g_varchar2_table(441) := '018D02F8BC9E63BBE34EFF8077EE3EBCB0D318F1D85BD76D49C7CF597592C5C60EDE7CB078ACA70E4F5ED9B94B9B4DAE6F6FECCE0566A6A5884B677756BBADFA195BBD6DF837DE9A4DD75AB7C854F43B3D157F1A3D7954E3F332FC5FD793F6B6F8934F15';
wwv_flow_api.g_varchar2_table(442) := 'B86156ADD47EC7FA53277777EFDC851FD809E3CE5A6FB49F2DE8AC3A4E69736E7DCE19AD8F3557EF1E1AB9B27DD7C63531AFC7E172E8D7AFEE98EE8FEB7219AB737ECFB9DB663E743A69997D4397CCACD9D0D16374C46773C1604E5F576DD45BB26E477F';
wwv_flow_api.g_varchar2_table(443) := 'F7116D2E909E95EA7C08C7E10D390FF50D6AC6DE5C153626FDB5B353477D3E6D26569DCBE967E2E9B1A949B751B7E6DED5E991730E4BC67C4D4494D66CD27AFC688EFEF2A5E1ECD8E4E17303AD5393A3DEE6CCA5EE2BBA1AA9AF7B50EBF764FBCC81FCC4';
wwv_flow_api.g_varchar2_table(444) := '4499E035EA3B5DE6ED57A6CE4F25BB3C9623A333FB47A65904C2D6CD6AB47778580213BDE83C0EB341130C72DB3B1D98D1EF71986D7A4F93E50F6F1ED519CEAD5EEF9B70044C9E004E5E20943FA8E9B099AC7AFB9AAADADEC9187EB223FF8DEED2EB9332';
wwv_flow_api.g_varchar2_table(445) := '875A49BB77F6E0D9D0256DF2CED736FE85CEAAFD8027DEACFD895EF77C5A7A48061391C191A93FDA187536DCD1AC9176EDD0761947766623936FEECA4DA6AC352E6FD8BF276BDFCAFE030BFD70C6904BD4D6440C062EE7F6B29E65A69FF5065A9B62BB0E';
wwv_flow_api.g_varchar2_table(446) := 'ECF05DD9B97E7D67F3FA07D2E90183555BE5731FAE6E7A63E79EC994A3D99F6FCB90B319A48CB72AE6B7F534ACEDBB70D8E6EA3A7D7C7A78F7DE8DAB6B2F8E3B06CF1F376713AEA62620ED769345BA7EFC724373F0C84EC7A59DDB37DDB1AADACF89386B';
wwv_flow_api.g_varchar2_table(447) := 'C49371D9ED9D9BD72692973DD65C4A6F3D7BA9C7EB725CBED42B59FDC383FDF55C9D50F61E72A51C946B5F65F691DAFCB643E7866D8307DAD7A08A0E77C433A033C467B361B7C1698B9AAD26A3CF4787E9E16A04BD695D6BD4BCAAEED8F1F33EA7D556B5';
wwv_flow_api.g_varchar2_table(448) := '8AB9E000E3634ED7110B1E395CAFD55F6C0F3AA7DAE82EE2560F537C868431D673E44CEB86ADFB4F308D5B7566623C9CEEC7C73B6D6FDDB173572A63B9BBA36570DA6FE1B3F392D410346D6D7AF8CC80CEDA7DA27ECDDD58C026AB7B4FF701D3E82EBD94';
wwv_flow_api.g_varchar2_table(449) := '6D5BD7DA9D71587DFE9C46978C67235E93DF1D36871B761CDF6318DEAFCB8E4EA40CA33DDDDE68F3C48533BA40ABADBFDB175BAB1448619C35DEE79F979E7842FACFFF599A50AC1E732934ABC1AC032F5C046E8DBA87621BDED87B88796D472E5153BB7E';
wwv_flow_api.g_varchar2_table(450) := '2AAB37A65D8C80335ABD2B97A80B0799D7F374566DDF71A4BAFA92ABBE2BE30BACA9F11EA95F9F49252C9C459ABB6B970BD24752F69D6F1EC8262CCDF55677B8367374249748D746DDDC7DE5ADF69EEED9636FBB1A4F18BC3A4DB2BE9A3B90676CB6D7F7';
wwv_flow_api.g_varchar2_table(451) := 'EE734DA5C2ED6B4FF71FD6C4E966FD92D5971EC90C4DCC468CE9CE5591D31331765EB8B8745A714026E07772C356D463ECF54576EE3A50EBCDE9DC6D97F7ED3184A303E7BB35D1D8D4E5B3E1060EA031A0950B3A9F7BB8E762D66CB272F5C04C3281DB67';
wwv_flow_api.g_varchar2_table(452) := '3466B5E6C9FE2BA981216F6B6167728CBD5EC3976BAC717BB0B96E6D60C79E3D51FF485DD75A4F356680C6C5F706F21E8EE6D0C5ABB6EC9BAD9E9CC15B1F765F3A77EC582EE667D9D697C2EF5F306497632EEF91663D2E5734C2DAF255AE0318BA7285E9';
wwv_flow_api.g_varchar2_table(453) := '481CD3585DCDD5D1C24D707EA354B7E1EE03670EE4CE0C73BDE7FAB6F0C909F303F7C46C91CE7A493AFC7A5617BF6A614E31EAD8E3AFAD8B792F65DD99499AED7C77971FFA3D0EBD79DE208960B659DCDC83EE6E6DD8B5F3E815C91BE3D4C7DCE42019D8';
wwv_flow_api.g_varchar2_table(454) := 'FE16B0619935D56A2C076DC1B03FA4B579DF785537B4739725335BB5697DF7F909C9985FEF5EDB12B176C64E9C3CDFAA332752DAD4E4984157E50DFAB33AB3856F32F803AB229E43272D96ED3B83A95CB47AC381DCD5378EF5EA0CE35B9B3DF4B865E483';
wwv_flow_api.g_varchar2_table(455) := 'E5C6C7FF741DEDE6CFFF87ECC050BEAA51599DDED0D5997AEEF9F4A933EC4350666FAF0BBE71B969E79E7D583A7E6DD21DDEE81DBAB066F33D9C9936B86BFAAE9E0DF85D5687ABDA5B3BDA677585DBBCDE739010183C1EE7A123C935A3173D81B0C44DAA';
wwv_flow_api.g_varchar2_table(456) := '3A5D3C9E0B06B4969A6A8BC9A4F3B8B516B3C1C53496E40EF82C1693CE1590D83E3777558DCF69F1BBBCB68EE89BBB0EF44F3BAAD87BB4708E55C9A41A5725F0364940F7044342D9909FFEBA16E87A08F9231773979430E8FA7C2566DDC0F79D033FDBD6';
wwv_flow_api.g_varchar2_table(457) := 'BBEFF1963F720FFE34D3FD434DF87E8C8FCCE1FF473259B5E1C79404699E26A3A12156E374611BBB8D2EE7D46C4E3F78DED7D0B4BAA3461FACBBB8FF50A4211C72BB3AD6AD9A4E5B34F1B1AEA61A1717AB2EB5732631F4BCC160CA2F736593FC66D293DC';
wwv_flow_api.g_varchar2_table(458) := '57443333FADE57D0D8B0EE9C4E562F1C1E47FE9FC56AB17B9C568BD9E9709D1CD15765CF3A024DAB5AEB3CD17AA7C7C34C5ECC67AE5DB5D66AB6BA5D0E83C569B11A3113B18A2CD56DC9E9299BD55C130E387D21B6C7C522EEDAD6568B357FF79D412B39';
wwv_flow_api.g_varchar2_table(459) := '1D4E73FE5A7C8DD3A2F7B99C66B39DAB0B671399081B2057AF315B980EB69BAD2E87DDEC74F3D6C29CA99EB39D58BA7AF262687249B5C6EA343B7D2E2E7F70F85C2E9B45E3F0A6E3B3CC43070281FC4D026E8FDD6AF3B83C0EABC566732C39DA8DFFF087';
wwv_flow_api.g_varchar2_table(460) := '535806B92C770726CE74C70F1DCA0C8F64AF5E4DF7F5693269CB1D7738B823E45A6071EFDC8EEE48BBCDE7F074AD69757A43198BC32C255A1BF3C2713B6C3E0C218BDDE986030EBD5AED4E0F23BAC766ABAE0925D2663D9787E52FC0663EDD65B238F526';
wwv_flow_api.g_varchar2_table(461) := 'EB95AB6353F1D9A839D975E7068D3394894FBBEC163FDB6517BF7D175EE8E253BF7929974A69F86402B3B3E21FDF627AE5D5E4F3BFD135371B1FFFC03596F3BB90C7C6A702E65C4BE7DAAB33FADE6327B7DC53AB77D68E4FC55D9A44DBAA2E7730A4D39A';
wwv_flow_api.g_varchar2_table(462) := '02565DA8A573860FDB18F5E100D5E2F73A1D266AC46DB7DA6D0E6BFE130AE353530D3E737DCB6AABDBCB5C7033571639AA3DC674437B8BC71F7458ED78AFB1D696D9AC5EAFC9857C0EB3C347EFEFF759134993DB2C75AC6A72FB22769F3F9196EAFCB658';
wwv_flow_api.g_varchar2_table(463) := '438BCB1B6029997A763A2C0E97D36246539C177BFA434EADDF17E85CDB26361FCA65298E30F09FC8A48FD407EF5CDBFEDABD99FFD576ECA5C4A104E7A2A5EC638ECD1BCDCDCA2C26BDD613F2B39DD86CD2B5D786ECA17A97D5E4753899B10F79ACEE60BD';
wwv_flow_api.g_varchar2_table(464) := 'CB66CED93CD9E46CC06D8BD6D6260D968045DBD2DCECF2864C766FB4CA936F20DE903FE433D8039A74AAB939E20ED5F55E9ED48EF6ACB973239709412EBF69C2E799994D473DFAD6555D2CA039EC4EABC3271AACCD62C9A40D3555AE802F847E3A2CA6A8';
wwv_flow_api.g_varchar2_table(465) := 'C7698FD4C5A7A7AD665328E867B21C2446B35EA3D75BACFAAEA668A87135EBC9899C3DE2D4C5DA5B1239DBB11317D787139E860DB2A5A22CA61C4FFCE2B9D40B737A6229D0936DE889B6B9C9A4D0136A8AC570EEA0D2A4B885CED9C1A7CBF5AC3659EC5E';
wwv_flow_api.g_varchar2_table(466) := '569DAC69A3D96D90DA9B9B22B5F55AB357CA262341B73710C108F084238814173112F4E8CDB450C96AD4E73446BBD9D4D954ED8D75BA2C868CCEEE3165D013DC7E2E2C72EBD3D1587B22A969A87255353486B840DEE1B0EB355D5DCDDE60554AE3F09BB3';
wwv_flow_api.g_varchar2_table(467) := '4D9DCDAC9B4F8E4DC7EA3C4D6D6DEE60786A3AC9477983CCE85FFB049A41A771BB61D2C1BE0C8389FD07461AA03F1474F0A134B7CFE9B0D95D3E16A87466FA817281C3CC369DF6EC4CFAE234CB7ED9D393F191547A866BE0729A2E9FFD4F6BDCCC0E2AF3';
wwv_flow_api.g_varchar2_table(468) := 'B3FBDA3547976F6BD8CC46979D13B0C19964366CD7B5D08F599DB87674560EBBC58956D391B2B2100AC6B306A609825E87C589655C36E4A437AEEE3A65E9CB863EF0BAEDEEDE4CA0AD3ED15EBD4B63AD96AC7FCC8DF5CACC9C106EAC8B3245455332797D';
wwv_flow_api.g_varchar2_table(469) := '75ECB9F7D4E9D233ED8D517F7593C3493FE4ACAE8FD86C4EEE4ED267D26D8DB59E50350BEE36B7872946B8AC69A8E26A239B211B8B062CD1C6387DB8C55413093802E1F44CBCA1CA5BD3D24C679F1F3B98B2A4C1DABD0E97CDA837FA423E496F444BAB42';
wwv_flow_api.g_varchar2_table(470) := '5E33A7DF67661BC3D6BA9635745F66B3DEE971F23514C1AA9FEBCBCC2E632E110E05E8DFA81BB7C311F2BA9DFE007D8EC3A263CB112BA83EB7CB6EB5BAE9C36DECC15FBAF716C877EEDCD9D8D8188F73683A1FB814FAF8F1E3EC85564A49C44D5C66A6D3';
wwv_flow_api.g_varchar2_table(471) := '869DE6B6751D06A3D3E1B1D6D48613695395CF54DDDCE284AEC765B2D32ECD6E9F8BE138D658CF45DF3E97416FE51B54527E6062D8D21B9C1E5F28EC097273BEDD934DCC7A9C965030AC35FB68B5D555218B2B140EBBBC56BB271C65D8B2F87C8C505541';
wwv_flow_api.g_varchar2_table(472) := '6763FB2A236AC19D72361B8DA2B13AA873575B3529BB378083445D3048327EACEF6CE063106C2966F88B5445F0976B02D69AE61687373878759AA3033EED6CCB8675769BCBE1F5212EA7D74F2E93637EFAA9B8D4F9940B17F2DE2FD75F71A9787EAB856E';
wwv_flow_api.g_varchar2_table(473) := 'FEDF9E3DD233CF48070F4A5FFEB2F2F34816A336180ECD269254F31D9D0DB6400C93DEE975329CE18BB305A9A32E54555DEF8B56CFCEA43D4E13FE989DCE3DEC4F9BDDB9D4ACC765F378034CD333E86BF516A35E57EB7530BF66E443490E5726956EA80B';
wwv_flow_api.g_varchar2_table(474) := '866A620E66AFD8445017CA98A33E53A6A9B329EC0D925363D0743406ABEA9B99CEA69B6D698E846AEA27A725A721B56A5D7BA4AA269EB3E02FFB5DB6B9AFACE59B03FF6D7693CBED72DA6D2697379B8C77B547FCD146B3D1E8F2FAAC569BCBE363EB8D05';
wwv_flow_api.g_varchar2_table(475) := '292DE569E88DA6ABE7FB98CC7646420C4D7A9A109FBE31183902A4B7E803CD8DECD892854C8B88A7F59A4CBCADDA1F6C5AE3F7BB67131A97551B0D859D7E9FCD63375B8C3484CBDD635CDFE90904D6AE693439F88898C598CBEAED5E7336D9D9D66A0BD6';
wwv_flow_api.g_varchar2_table(476) := 'C015B7300C9EDDDFD2D8C8BE36197F71E4D4E9B3C1407E01797A6A7A70E8CAC8E8385BA069E488A07F6088EF21A1B7722EA6F0A2213797A7EA73C9F6BA4075FB1A94ACB6AECAED0B7A59D577FB434E6EB70CD312FC515AA6CF68C40EA4EFA2D9CE4B952B';
wwv_flow_api.g_varchar2_table(477) := '23D8F2C60640703A2C7ABFCB8585A3319A4686AECE4CC79B42C660C35A2152B3D95855EDF1F8ABD833CEFC5AB82A8A8DC6F1195D2EDE5E1F61FB92D564C2F2411F18F1628D7559C966B3EA92594D47952BDAB4CA4E8FE4C9F748F4E711CE5A33E064136D';
wwv_flow_api.g_varchar2_table(478) := '1C12AB6AB870F070B42E18747BB08135C6729D79A6BB27FEAD2773C3231A3E3148E1856984CD7EE468E2D95F600999FFE367358AF31176EEF10AB1EF2CE1B418D777359B7D5CF660ACAAAF71B259C5EB355B2D419F8F2D4B2C3F476B235827733AE6D4CC';
wwv_flow_api.g_varchar2_table(479) := '6D29B79A8D29C950E3B779FD51F42BE0B227B2E6B04B5FD7DAEAF6F9EC6E87D3CB7F97D1C2FE4894DAE3420F5C5C5BE634DB30348C01A62D2C9EB12B43339389BAA8A92AC6F9EA05CEB95C896A4495C06212387BF62C3B9E38F2C31D90E297888E2B01E6';
wwv_flow_api.g_varchar2_table(480) := '7E990B16015F550E02158F44301EE656F516A297138908A757F8BD50222493C94422C1700BEA9696968559E79F5EBDB077707AE4D1A6FB5D53BB332347B591F7713343EEF2731A67B326F050C92C72E2D10BA3CEF37B6AEF7B1F29539274FC855737DEDF';
wwv_flow_api.g_varchar2_table(481) := 'A1B12EE7C68B395C33E7FF3F04219BC839B6C6262774A6A8B9FADF2D3906C8CC6C3B39BC563AE06E7B584E7997452E3CF6C1A9175FD4984BDC24949D9EF1FEE567A3DFF907B9C8F8556F3CBBEFEE4702DC282127DE70E4F4C5914BDD279299F8DA3A57B8';
wwv_flow_api.g_varchar2_table(482) := 'F90EB9A6964438F9E9FFC07780356C40527EE413659D99CD4D4E71C591FDDBDF2846C2A69CD7779E0E25BB3B376F655DAA18E07648E11C0CD7C9AE8D594D9105BEEB62BC4D67B3BB9289D3E9D4C376E72F27FFF5A723BF3D9F1A1DCA4EFAB4C6EF87FFEF';
wwv_flow_api.g_varchar2_table(483) := 'C7ED258CE0C550DD587ADF78EAD0F6DDEB9BB4A1567676E4FB94B73BEC3B3B347E62EFE6CDAB4D1E3638940B93FFD7E792BFF895C6B1889EFCD947ED4F7EB35CFEF7D23B4EF9EE189EFE5DFFF8B9C9F87822CDD15FA7C9D0E9B13D1A76AE765996B299DF';
wwv_flow_api.g_varchar2_table(484) := '6A49F10192D1C397667AECF1B6FE894846D2DE11BCD86A7B3D67A8CF5A1E6183F45B4DEF9D8DEFD9679FE5C3BF0CF9A2180CD02323231FFAD087DED9A52AE2BE6770F2C289A3F1CC6C5BD058DF7997B836A9086A9184575E91D8ED4CC00156EE3062CD90';
wwv_flow_api.g_varchar2_table(485) := 'FBB17009F08D590D5643FEFC707AF4FCA5C495313DEB997C464EA3E5ABED3353339C17F534D4E43FE55A740C6149B1EDDE7EB6359A7035CC1F1229093F382B5D38F0F2A6F5EB2573B945CED7FEB093ADCF98767C0D383EB79B8038D382F8C3533333F76C';
wwv_flow_api.g_varchar2_table(486) := 'DAC0644449FC6F55225B240E7573D4FF0CE7E036AD8A7A6ADADED6816F5A928EBDB86DC33DCD5A275B429608C9175E9AFCC4BFC32ED2D87180AFF793F98F20CCCE6AF896FADEEDF96583DB23BC796A203E703A339D5AB3BADA57832B7133EC87DBA3E82A';
wwv_flow_api.g_varchar2_table(487) := '176F8D045E7EF9655C51E625CD2C1832D73E178CEC953599843F4CE74050BAC182B0708017CCEBBF351CCD617960EE36D47CD4BB45E7DD22306B1A3F2722E57FEB82769D7DBD80C12D6BD9D89533DA6EA06518838F4959765B5DCF4A69357A3E96733DA5';
wwv_flow_api.g_varchar2_table(488) := '3C27BCEDAAE683E565F7562D89E2F60670FCC99F985A5BE46D2D4A66E934AD7C355111E850576D69D258AE4F002B5E2E3B6AB71A7D7EAFD79A0DD7E3EC2DA3520C8F3CA4AD8AE4792E98BED168989B37ACEB2AC90A3B8DEB838EDAD0A6DBD6FB856D266C';
wwv_flow_api.g_varchar2_table(489) := '5ADB1BF46C10AF2CD8B4DA87CC9607250B0BDD1F326D5AE5AF3E9EBC74317D25AAF3142CFF56866FD950DC6BB5AA391A6AE6269B4A795E368D85197C7673E3C60E93A77A617289A7BC9E44C3CBD5931288DE03492C026FF6D9B836EAC464627836A9D368';
wwv_flow_api.g_varchar2_table(490) := '4216E36AB7B9864F63DDA48A55485923ADF6AC5EEDEDCA2F61E4676819ADB032DB60247FAD981A164AE0EEBBEF9E9E9E16233A6F1019F7EE2C0479373CD9CC7AAF8FD556475D7D6C79DE2FA5E734D017BFB8A814983BB86DBC824599BC592F38F9E08BD5';
wwv_flow_api.g_varchar2_table(491) := 'CC58AD935706B3D3B39C84484B7CACD8E889D6199D560EAFDF400B6C5D15B118D940562EB88D92A97DBD6428B7FC4BFE96E6C6FEA1214D4EC391E2795B8E759A5C96BD00756693C773FDDC4139622B7847F1D979A7F3F9FC2EB3A7A6FEED1EF8F236F01D';
wwv_flow_api.g_varchar2_table(492) := '5D0B666D16675E17AB33FFC7BF643745A1694416EACD6CCACFF5DC36C1EB30C593DE609DC55753F7768BF1B629B4CAC86D2481B76B05F8362AA2CA4A590964A7A7F2B701951CD3389761346A6F3FCB20C79D258BF34C17CFF5BF650BFD6E7E399B4D2472';
wwv_flow_api.g_varchar2_table(493) := '69A3466FD5165E6DFA6E2E76A9B2A97A524A2A4BA4B1059A2F440364D472440FD3BE00004000494441546AA364BFB00406F5B52A81DB4E02DC6CB4F0937E851CB232AC58312B7CFB5E7AE64C11C565533A9BFDA45486596FEEB0D69AD83CAF636E25DF23';
wwv_flow_api.g_varchar2_table(494) := 'DC880BFC9649101E58A3065D9ECB6B01AE78E4C348F23E886B6FDE5B7F3917567CA39B42041A0DDFC9BBA5D5A760468DAA1258A9046ED315E095164BCD7FB324A055DCA973B368AE94CEEDB38767A525791BF25BB4DCBEF35E777D855C553DB901FDE2EC';
wwv_flow_api.g_varchar2_table(495) := 'A5AA3D37203735CB6D2D01D678F3B7AFA9616909E0FA0A203DF778CD5D322D6FA59577192C8DE56D838087C5BEF2F5B6D17CC720CE9FEF65615C0DAA045409542001B967AB0056055125A04A4095802A015502AA045409A8125025A04A4095802A015502';
wwv_flow_api.g_varchar2_table(496) := 'EF5809A80EF03BB6EA54C65509A8125025A04A4095802A015502AA045409A8125025A04A6039125891037C3BEC87594E6155585502AA045409A8125025A04A4095802A015502AA045409A81278074B60854EE88A6E81E62A82F1B1F179E171B05EFD3AC5';
wwv_flow_api.g_varchar2_table(497) := '0D285226B3E032871BC0A0665125A04AE0A649405CB772D3C8A9845409A8125025A04A4095802A015502AA04164A208303B582B02207988F034F4E4DE6A96B75B94B17B3BFFDDD0A38794F66E563CD1FFBA8643295B8B3FE3D290FB5D0AA046EAD0496E8';
wwv_flow_api.g_varchar2_table(498) := '4F73129F40375BF832851A5409A8125025A04A4095802A015502AA046E8D049630D896626A450E30DF1776B95C7C824D32E8B3FBF626FED7DF2F454E7DBF500226B3F9139FD0F0010664A8065502AA046EB50412C944991D197C6D92AFAEDB6C36F175DA';
wwv_flow_api.g_varchar2_table(499) := '5BCDAC4A5F95802A015502AA045409A8125025F09E9300FB9F6FE51668685B2C96BC2D683064B45AEDE8E87BAE065658608B85D5A4FCC75AB2D9156252B3AB125025B0720968755A36B694C1333D3D4DA7571EA64C76E52BFA4F7ACDE21E1CE4C5F80598';
wwv_flow_api.g_varchar2_table(500) := 'EA782B05A8C65509A8125025A04A4095802A815B28018C935B6299603E115652F015AD004398628B92B382A92E622EBB26B4DABCF4C4BF65675633A8125025F0164B40F46632D2829E7DBEAFA3C12E0C801116A6E59F8AFD58190678EE50B87CF9723299';
wwv_flow_api.g_varchar2_table(501) := '94138940C2E7F3F9FD7E655E014C8AD1682CE05099578DAB125025A04A4095802A015502AA046E8E04304E3817A6E738A74E57C638119EAAD2AA59397B65C855887CA50E70856454305502AA045409BCB32440CF9E4AA50C0643F97E16B0D9D95956860B';
wwv_flow_api.g_varchar2_table(502) := '4A679D0B65F2CECCCC1C3C78B0AEAE4E392A3096F4F5F53DF4D043CA443093CE71171CE0022AC58FF0436219BAC559DEBE1498B9859CDC42EAB790B4B236975486DB844F25CF6ABCBC0496ACD3F2D9D5B7B2045449CAA25023EF0209B0A34CD2E9240C80';
wwv_flow_api.g_varchar2_table(503) := '6C3697BF5E77C14CBDB2AB57C617169C6D69183C692957B80F4E99451927FBD4D414E7C2708017A25AF084818425804DB420759107F00B12C278108F0516D122599797AC3AC0CB93970AAD4A4095C07B41024C58E2A09E3D7BB6BABADAE3F194EF7C8F1D';
wwv_flow_api.g_varchar2_table(504) := '3BC60C68815858DABDE38E3B16DBA2C368217CDAD5AB5713111D3DC0939393AFBFFE7A712E00583116A3420121E5237C02460A7E3BBFC02BDF2E2B2EF20AC69695510053043821505284730378C872C3FC9311D24C1920871B467203A51659E09C8A1033';
wwv_flow_api.g_varchar2_table(505) := 'E2C5A5801F42798D52922EC6A07C5B262E94818A283989030F60464BA91DE265F0DC9C57A298822B7EA9BBE256701338810D82A8BB32E4808149A1DE25A54722415401D88897C156F92BF0302B0775D1C02BCF883CC92B5A22D92BCF580C29B2533B8BE1';
wwv_flow_api.g_varchar2_table(506) := '211D5A0807728055AEEAC5B448217B812608FC82BA2C5891581243492472D5C0247119CF6218D4745502B7B304F07E5363A3E9D3A7992CCF399DA696561D0754AF9DE7A2F9136847F41B683BDD3E93E9E8BC6844D7CA451F95495E7D4D676BD799C3B9DC';
wwv_flow_api.g_varchar2_table(507) := 'F50B9645769185B868DAA2930489E891AE2129F1179837DF7C93FB531E7EF8E1928391328F40383C3C1C080444CF89F34C605B9C12EC2D89AF68FFF45BC2818A4495802A015502B79504E882E9704F9E3C79E6CC199CDBD1D1515216E39021A4A7A72714';
wwv_flow_api.g_varchar2_table(508) := '0A85C3E1C85C205255554522E3C462B9C0393232C2C801212C30265009CC8F72C078315A8BA5CB240080E8EEDDBB8F1C39C2A2F4A54B97989A255104C0AE45AFA7281395712018AE604FCE2253A924C2400B03886EFFFEFDDDDDDDC2BE14A89454042A39';
wwv_flow_api.g_varchar2_table(509) := '5D7E45768473FEFC7924A37C5B096981843985D3A74F1F3870A0BFBF1F6CCA521097E9CA14951165FC06A8438ECA7DF9E597911EFC5FB87081B15CC90382659A43A4085ACA5F9922116050A113274EDC80814E76A66FF6ECD94315204C81965FB974C411';
wwv_flow_api.g_varchar2_table(510) := 'CEA14387E45AE695FC568E94CC380738AF4ECAB812BF48AFF09792A227B4383010A7FA30980AB41754821965A4645CB0215EF15B798034FB2FD05B654194D80403FC02363E3E4E13A336E54408C9712A8EA60DC2DEDE5EAA5B4E17CC143C56C821B94045';
wwv_flow_api.g_varchar2_table(511) := 'EBA6D6262626402EF014E024518950C05CBC78117932A987ED2B03C811257CF93844A929B49A08900518C4232D97B2537084035101C62BF1B63CFEE2B7478F1EBD72E58A4C0E9B18BD45A54924081319698BFE565091098947701E3E7C58B0217EE9B441';
wwv_flow_api.g_varchar2_table(512) := 'BB6FDF3EBA087A2A181E1B1B13246406E4BC728A1A5125707B4A4078BF33CFFE2CF1D4F712DF7E2AF9D4F7675F7A31C3E9AA392516DABE77EFDE73E7CED1521817889F3A75AAA02C1AAD3E39712CD9FDD5E4C0D339893EE4FA4049465A0AFD3359687D0C';
wwv_flow_api.g_varchar2_table(513) := '2B3428508986267E0BB0153C32080E0D0D2DF4B70B40E61FC14637F5873FFC81818F249AE7AE5DBBE8F16E60102C4D4091AA3AC00A61A8515502AA045409CC59751870F4EFF8B1F830189DE5A542B70E2421180CE209B3685C5353C3DEE692030389B81C';
wwv_flow_api.g_varchar2_table(514) := 'AFBCF20ADD3A66F40B2FBC80A52826532B191ECA7042762C727EED763B548419CA236581221999BBC5B5204E847185146C3E1E456179648C211D13995C98B90C75E0210B03122965482B5F91458CB2A0851370428E5F1E4105451E212A70028C952CC789';
wwv_flow_api.g_varchar2_table(515) := 'C0003018B858B4CC16C30C19A10EA4924A9938C2C4400703D4E58283045482BA280B4C82845F18201DDE80814F026C0860411D862BA70E24C6F4CE9D3BB130E0845A8013F0532ED01241B038A550116821011BC4E18A380E83200D8090CCF1E3C701205E';
wwv_flow_api.g_varchar2_table(516) := '7915000F303E4FBE30D92CF338A4C00048604FC89F47D2F98549517660788BC478048600C364E791205E894A240E7EB912291462E41529BC12954804849507CEC36FDFBE5D941D53E98D37DE803730834DB02D2812072789B02748405700C02A0C10E715';
wwv_flow_api.g_varchar2_table(517) := '30027E596C004CED10A8054883077EA0052A10825FC89057708B038C7E0AFC8249008800033093201870C80D606008E21511B0212EC0F8E511E00A03C05419B99826E317CCB047F141489CB28B2A908B0F3F4208B0413F06B7B004E7408A120129221532';
wwv_flow_api.g_varchar2_table(518) := '0018F028362282348FB0C12F8408F00021CA85CE530B90E31743998203433A8148E581F28201FDA72B802E8F900309BD1C6D0A25191C1CE49152502288F296384280378009A2FA48C48016ECC1270C00093C2B5AF4ED60234E7D895710121151A79573AB';
wwv_flow_api.g_varchar2_table(519) := '42AA12B85512A06DCCBEFA9AE6F997AC168739A3B14ADAF44F9E4D1C3CC8960F58A275E0F4D236E937D073B49DD9765A31BD1C6D649E67B6AB645289CB3F31D96B5223AFA6A64E6B34D7B7343346909746448322EE703868920C73D7B3972D396D6AD3A6';
wwv_flow_api.g_varchar2_table(520) := '4D5BB76E252FF1B2B0F91E86AEC36C363304D0F69909855576E1416BC9BCE53117BF2DDCB6570CA1A6A8125025A04AE03D25010C207CA7F6F676B97F5FB2E7C5C6A273676861510237D8E9743636369252526E0C450303036D6D6DB5B5B557AF5EC58CEB';
wwv_flow_api.g_varchar2_table(521) := 'E8E810A66449F80A1305B770CE662193C9044B14042F08379BB5E5969616061252A0CEE7EBE033168BE1A8B352CA484616FC76CC6B064B32C20F2B240C930C7B389360461A2059520E825596A7C875DF7DF72107C84114CB9BA1178BB3B3B393B213C772';
wwv_flow_api.g_varchar2_table(522) := '65CA80D572A696B1CED7AE5D4B3ADC62A7D6D7D70B3CC03004324E339B00AB95CB81711ABAD16894A11AC1429D322213CA0515F65611C788072DC5441A708270283B00302F24D6DADACA9C378FD414755A61D9611271216D38A77E05CF384B580F1467FD';
wwv_flow_api.g_varchar2_table(523) := 'FAF5AC3B6173537086790098EAC6322005F13215823EB8DDEE0D1B36C01EACC2215A4465C1C99D77DE497554C806604815691361BE1F0C982CC876D5AA5562010DEA5845140DF1221FC0D0818686060C0E04E2F57AC9C22B984180381577DD7517B3F820';
wwv_flow_api.g_varchar2_table(524) := '21236805129C04B2201CA487A0D028B815EE0A7BFBD19F0AB9454A149F5FD05264A481C503B7340D7412B541FD84CF43CDC212B509F2AEAE2E8A000C2545E0384B3440F0C021F508FF823DF459D442F95FC8515E0A4B71F012910C85A2CA48A48C084768';
wwv_flow_api.g_varchar2_table(525) := '88A844CA4510E620DCA2EDA83AC5A7D221471170CFA868C44876EA1AC5060612B432C48B325095A282F8055579DEE4B79488D2819F62821996F8A5BD30EFC6C2356F892307349F5F6A043B92EA800D149E16C1CC0B9B54900C25E2B23D644B3705C20A19';
wwv_flow_api.g_varchar2_table(526) := '807FCA85E429238A8A4CD09C356BD6202E4A41BD809F08B503C3481218526095F6052DBA26A45A3939DA114D00862908454362B456CA452225A257415BD04CF0530A1EA18840F069E1108521855643A36E6E6E06156D904714839AA2BC605BB76E1DFA83';
wwv_flow_api.g_varchar2_table(527) := '00455E0445ED905D0899552F20692FB2F0D5882A81DB5602E93FECB44CCE9856776A3F144BEDD9AF3F7824B97B9F75EB56DA21DA4E3F00E7E839AD80B6C0504277448FCAF878ADEDEB3253877223BFB2DEF5ABD4F1AFA4FA7E6468F92A4319535E64A44B';
wwv_flow_api.g_varchar2_table(528) := 'A4D9D264E8DEE999C942DE6B199716091419F1E97F18EF8897CFC85B5AF4FDF7DFFFBBDFFDEEA5975EE2F1EEBBEFA693A1F3299F71693E8A206ECD0A30122DF9AF88BDD260226F31B09C522140310F0203E995876224CBCA5E3921155295802A819B2601';
wwv_flow_api.g_varchar2_table(529) := 'FA7ACC350C29112AA14B07CDE8B26DDBB6175F7C911DB03896185274F7C579311FF1C1380F432FCFCC6885067A319EE2145061146220620B3256611DE2CF60E46186628C62FFC124F63A9E0C797964180380B1904D4D00C03305C73E06804188D1117310';
wwv_flow_api.g_varchar2_table(530) := '9B9252942C483103A400899380DD297C272C6F90E099307062BCE2E311208160591D123E155C018F314D22032D14E19F4472C139FCE330307857C8037971452007424C73CA480179A43A88E08A60F2428EC212013925C5DB84373C137E5999C7F6852E6E';
wwv_flow_api.g_varchar2_table(531) := '30563B9048B26449174B649CC6E2C74BE19233E2B804089980232AA615502DC40203D405BFB044490954016E091E1D89908619AA03EB9FA551C4824016A3589C8EAC70CF901BA8305FE08408D4510FE48FA20A1E308C283B6A83AD4FA9715DA8146A0100';
wwv_flow_api.g_varchar2_table(532) := 'FC01A88301D25413010B06185200134878051871844C75232876E0537DF8814056CEB0B06C987140207008E7B83DD4230BE954102C4102AD860751716826950B1B4809CED10DC89191EC3CC2129A4FC662B194494162A807CE366D130CB04441900CD280';
wwv_flow_api.g_varchar2_table(533) := '0A02E11781C0009B90A9535091820AE179224C026C5077628B328FE8157991397CD2D61035954E164A41A228024DA30C4B05AF6009BF8E44B2A315702B5A078F149F2A40819139B2824900507E1A1ABFD0021856054B140A65833412035E08BF8056C947';
wwv_flow_api.g_varchar2_table(534) := '8029085408A80D1584881005A54675C189C65270AA0F129414912231A84348CC6D9152213920E1017238F3E815B54901C143FD821C240408F14879A18E2AC20600B4748A4679C98B1C609557F448541308E1968C140469D0E9A1304C4F408BB250E9FC52';
wwv_flow_api.g_varchar2_table(535) := 'D1681AD9911B19051B25A5A126AA12B87D24A0C9E634F8AB46BDC6ED92745A9A193710C01EDA8E1A338F43BB604A8E2E88E6C31887FEA3EDB27A73E2373DF06353AE3795983068E2DA9167D3D3E7388F220A48BBA6A5D083818D36455B06C9B28645BA6B';
wwv_flow_api.g_varchar2_table(536) := 'BA717AC84A240657A2B7A41BA78DD36B51844A322E17661903EA72512F06AFE164736B6B897FB198C6E7C37A92336AAAAA74EDED2520C9DED424994C32E482082BF700B4B428512D00301A750D0D25D0B2E0130E8356D7D6A6AD64B5C160D032E15D5C16';
wwv_flow_api.g_varchar2_table(537) := 'F0442279EA155CD9BA80B1653ED089CBEABBCCAC2AB82A81DB5102E87341B8F95C0A060AE8964C54C2D018E9DCC5C20BA621DD3D8F242A61947110F296B0246665AEF2710627C624564A09D8793080CBC710C2A2070B2FA460DCE363B06E834744224320';
wwv_flow_api.g_varchar2_table(538) := '36253C30BDCA120A9C60AAB2B8C75B5C1D5C38125959220B8FE001B23C03F25B462C98C1D007276327B3BF4458D5443ED8A68C9D20672D14EA98CBF0067EEC7548B06CC8236C030336EC5A0C5C166A708740489049948F2007867C98C71B813A65DFB871';
wwv_flow_api.g_varchar2_table(539) := '234828329819F81956F905096E1B0B4470024BE2D232D8C0CD800DC6607EB118E0AD3CB982B7489E40792908760365C746C71F66DE1DE78AC53702F2C792C0462782778A9F801058D762D91C18FC162A8B825317C21C17FC542E01588207702261D6B540';
wwv_flow_api.g_varchar2_table(540) := '288842887466E2A95CAA835FCACE2B68914E65515E584262B8E22211D2880E31C20992412C8811095322D6ED1117C845356163110727F5880E1488A5FC23D4A1C22F2E34ECC10035854B83FA519594825728369505661843AAD40B05449198EF8025EA94';
wwv_flow_api.g_varchar2_table(541) := '1A8779CA85B7837881178A549EB4780B242D17A56591935A432C9000332D022A680B35421C5901435B98D3C71CAF80841FF8A4ECD417D491156E15624744B00D27A83D79E10D95200B0D0DB6A1C823542A614FC05076B11882E7095DBC3B48A3BA080AE1';
wwv_flow_api.g_varchar2_table(542) := 'A3C0280FE4E04DF00C75DE224F22D46CBE6BA8A911B5461F0587955B96F0891B89974B31913CEE22DA025748065A4448A7BC5416750703A4D3D520076408576805B9E0ADC2F2024601998442EBC848D5D01B30A140B3427A880E12B4178A8C4CA87D1840';
wwv_flow_api.g_varchar2_table(543) := 'EC00D0D2218A1F8B334C5D202EDA3872A60DC209FA2F2A8E5F1446D41771C8C972235DD41D14452F2184AFFEAA12B86D2560D8B431C3C988D36767FFCF3FE68686B281A061DD3A1A270CD359D1FAC47844EF4D9C964B0BA2B1A0F90070F3736AFC8076F4';
wwv_flow_api.g_varchar2_table(544) := 'E7467D2E33FC823633604AF7A606FF8593C004206935F47B44C460DAD4D4447F42EBE06D2502810A7D0EC39FE836CB670127EC31F5C924D4830F3E487FC288C04029582D9F77B96F6FEE1668F6FC3CF490E1FEFBA5AA2AE62516F08A1C3978363898E168';
wwv_flow_api.g_varchar2_table(545) := '35ABDE57AE5069C68F7F5CBB6103C3F802481E006677DFEEDDA95FFD2ADBD3A37C0B522C1DE397BE44AEE4D7BF9ED9B74FF996383BC00C8F3CA25DBF9E6B520B78A02693DFFC66D66A353DF144F6F8F1C457BF5A9057F9884219DEFF7EEDC68D793F7C61';
wwv_flow_api.g_varchar2_table(546) := '59306C934F3E99D1EBF18D33A74E71124B9971597131C582AA15D73D298CA968B3186C64B468588152929DB7A40B18199B400E1E01C0DBE21419AD1A5125F0764B00BD656691A50C59DBB1DB3059DE6EBA4AFCF080B145FF5BD08860094B112B5F092CE2';
wwv_flow_api.g_varchar2_table(547) := '40F2968101000C32024D925FC60C9A6731BC9C8B2609A468748B812D2B1D4EC0C9B0043F58A2D8EB308C0988798AED8B0BC180073918238019F6C43787F161305579C4B2242FC0E0C1AC641D0F331DBB904AA12E2A6486FE043CF5F5F52C78627A4217D3';
wwv_flow_api.g_varchar2_table(548) := '1CBA0C69745962F40539D82004CF989B18D3A4C30C59C88E1B237A36221447D8A96080B74A7880794C67EC66505164EA02FC50C72666E4C6BD612D140E113E90B0075A2C662C7B00F0C1701884C480C1D5C16E2E59EF8B710236301328020E8F58772282';
wwv_flow_api.g_varchar2_table(549) := '390E3F0884B2B3880A5A083129FE810F7CE037BFF90D22A25258CAFBED6F7F8BFAE14DC13348B039600961B25AB579F3663801C962A495E9B0216A01539E1AC4ED2105194208C580372C7B1EC942D959AC435CC80AFCFC92284B8614E2E836C0D4057584';
wwv_flow_api.g_varchar2_table(550) := 'C4608CBA23809357E818FE09AB0AB04A8385430080E4AD92A5F271B2200130202878A6F860C6DD451A14844A843A145118BC3E98071849C20C7471CCE001351612C356E3683D9E2118106079BAE22D6821045A244F49F19784FC5978A438F86F080D3D44';
wwv_flow_api.g_varchar2_table(551) := '3F511260C4140089B08196EED8B10318BA0E140F0102C92B60D034444D401AACD622493C2ED80606E1902EAAA0120E050CCB923422F02304CA0E45E2D420D5848D889253D12047AFD061224800720881081800A35CC88A0895CE1EF20AD54950A7ECE80F';
wwv_flow_api.g_varchar2_table(552) := '7D0B8F888BD6011B68266D8A0A42027414B0843029179545751041AB85470A183323BCAD44319015354E719018C8699E10A58AC5E295A859F8A1C8A4439A65762A02AF9EBAA0FAD0430A4E61A911E2C85F9C01A15E280259F8C537867FC12775C12B1A26';
wwv_flow_api.g_varchar2_table(553) := '2468A4B08D9C71E9D9A103B01A5409DCD612607AEBE1FB535747E3C78E4B23631A9D41F7B10F9BD6AF65168AE646FFCF504E27C988839ED36C49A46BA559CD377F8D3E3DBECF904D24A58036793593311BF5DEECC49B2CF76253D093D057507C1A14ED8E';
wwv_flow_api.g_varchar2_table(554) := '2E5174AAF42115CA04727405001321946FFE00D0B7D0D1D13BD1FA6886ECAAC33284615E5548B14230DD134F3C511E145EE580B008149EC0500137A22BC173CA9D3993F9C94FCAA1B2D98C7FF117A6BFF91BFD7DF771AD0A1D249B63AEFF339B597DD0DD';
wwv_flow_api.g_varchar2_table(555) := '7187E1C107359C303972843B134C7FFBB7C68F7C04C798A5FCEB90E4329BB54D4DFA3FFA23C86776ECE0D66F99AE16CBE96B5F33FED99F31FFAFE1F0D26BAFE59861BDF65AB77EBDF96FFFD6F06FFFAD960BB5676717E0645E90F1EF97BF0483E5EB5FA7';
wwv_flow_api.g_varchar2_table(556) := '44A91FFCE05ABE057F19D2755D5DE62F7FD9F0E94F6B5931460E46A31215BE77EAB9E7981ED7DD7557DE51EFEE5E905FF96034EABFF425F216B8D00284018079680C0BFA6EA13D7256244F17CF18CF2BB4900A12AF48C710E74C1DA3050616BF8C46C030';
wwv_flow_api.g_varchar2_table(557) := '46A2B58C0D2813C6041D3DF06818231383286A0D06C86179909721814622D35223EF0509D0AED181B7BC7FA95C7490464BD9264ADF226C357A18A6FF45972DF3069F824939A572129540821F2B8D801984FD2A071A0EA3080306ED8E26A344053FD85EA4';
wwv_flow_api.g_varchar2_table(558) := 'C33FB61A0D105F9185325A1F4D8900AB05F08C28585A98A710A26707000F878213114D153391473997100EBC616D1760936144444012A767A6A5E3D69285918FD62DBC4AF8A133A1D3C0ECE315FE0608E187264F47410AB930FE00001221F048D13043F1';
wwv_flow_api.g_varchar2_table(559) := '49482F20B7D823E46000E9C1331830B821CA23962525A57E410E03043A1FD231A9C10F24FD15BD13CE3042463EB08740D0041E2B1F6EE10ABA18C7140DAB17E3187EA0024B10022D25E217AE2832050733F885FF03455E21310A4B7583845F7886D5C50A';
wwv_flow_api.g_varchar2_table(560) := '5B9C0E3910521C0278281AB4400557D4081541A17885B6200A0A0B0F2412A808F8041E939D8C880BB9C100A5203B7997C586A86848C00F85A236510FB02173217F0088201604026F14138AC81F18200123178F820DA404CF70883303ABBCE291B7E08761';
wwv_flow_api.g_varchar2_table(561) := 'EA885740522808411124CBE5168450A1526089E2F30B129A1E7C12871F00901501F19228D840676006A7177200F00A4EF0C4708061AFB876164B415B20C15485F0B800C3FF011B489837E191EE884738A43A846C81874352E801A04E2D53B388945E0BAD';
wwv_flow_api.g_varchar2_table(562) := '43268011012192814F64052A215851460A5B3993540ABD109A403BC51C04A7DC3AA8024ACD23FC10445B831F788367E091A710AF8001097584274FBD2F26908274A80B05A6F89408B45484A08566428B5F1409B4149F38442923452617C2A17D5147642C';
wwv_flow_api.g_varchar2_table(563) := '405BE6913E9072910B95030FB2429EF04FBD438E4AA7503C428E66CB2B7EC1060F50A7CB82BA506C6A043EC5B405428031EA1AB1234030C01E3C831C84C0930B84C819EA9494470A5E8649F5952A81DB410274F1DAC6189B4FB5ABDBB5776E306EB95B6B';
wwv_flow_api.g_varchar2_table(564) := 'B30ACF024DC6E9A53BA209A0FFC4C5C888C25FE31C0D4F49D656C9755FD6B24E635BAD71DDA575DCA1B3758856CF2C12D9193D695958388C8FB4411EC10300BD0D0D9C167A0D5BE15F6038D08B0F8261438B2B7C5DF40C3C7C6244D148E92D456F432B26';
wwv_flow_api.g_varchar2_table(565) := '5D09CB236E0EA58334CD5FFC128184F8A55D8B00A41C04061E8994F6C52995002242EF2002641001811E87AE96EE0C14F44D7960A331F3EB5F271F7B4CC95C415CFFC00396EF7E57C3AD9E3FFE71FAB7BFE566D202002607741D1DC6CF7C46DBD292F82F';
wwv_flow_api.g_varchar2_table(566) := 'FF25F1D453D65FFED2F0D863B35FF8427ACF9E05E5667E3A1AC5D1D5D4D6CE3CFE787ADBB679544C3AFED55F99FEEEEFB2FBF7B3C0ABEDEC8CFFCDDF249F7A6ADEBD7438AC4F3DA5FFC84732AFBC92FAF18F39A152C0400E03E5C409FDE6CDB6EDDBD3AF';
wwv_flow_api.g_varchar2_table(567) := 'BF3E7DDF7D0500F38F7CAAE41BDF30FCF99F67B66FCFE3E1A0D1DC36031998A2658F1E65F336C34B96EA295A859621259B8D1B2A70E38B57B9912D62FFC10F7EC0EEB82F7EF18B74C4489E44AA5364478999BCF8EC673FCBD60220454DF116257BFEF9E7';
wwv_flow_api.g_varchar2_table(568) := '19B9993DC5A0213CF2C8237C59148340C0606FBDEF7DEF43997EF18B5FFCE8473FFACC673EF3E8A38F8A2AE691C4AF7DED6B4CBD50DDD7F95463EF5E09A0332C1DA01EA804F58E59936FD1A502EA879D475788DD80A1808581DA9402CC2F1FB1250F8DC5';
wwv_flow_api.g_varchar2_table(569) := '92580CA62023C8B19BB9100803941E062D25FBAF7FFD6BEE3FC0AC0109892CA6A1D574E2A4E037D2FFD2D395E1963E0A3050C1CF6260056C4094160415B214BCA2238634AFE8FA0BB061DA62A6330660EC5270EC42EC4EB8C5EAC2802B684A9494F1E387';
wwv_flow_api.g_varchar2_table(570) := '3FFCA1307C6112630E735634705E31C0B02A880526332084030092AF449EB04716919D088FCA1419AD1C59C95B194941A4802E8F702E7325808B61E08457225D46589E3D19AC6444A0E27731EACA5C829092AB95901698650640558C4DF956C017C3902E';
wwv_flow_api.g_varchar2_table(571) := 'C094AC2E37AE2C54415EF995682605B40A1ECB30233897B111292054E1A392E292D894C082378C13F6BDD37CEEB9E79E4A1A8B92AB026C5CD5CE12046D99748654FA4976F1151B70C54C2AF188B89CA27C9413953C2C1957CA1960A5C228E38BE1817FD6';
wwv_flow_api.g_varchar2_table(572) := '4559D26182007376B9225A0CAD32BD64B92AE14D8964B138780AFAF302720584C463014C49E40530C5844AE652135509DC2E12A0CBA5D3650825C2485A64C8090D5FA4459053F4D858FE183F22BEC0C0931B88B289D11899C7C75FC5EC217D3151B04F04';
wwv_flow_api.g_varchar2_table(573) := '53873EB9B8FF2C9945A6C55BE2FC1623271D8B11CB10DB0CEA4C6CF14BC0B2120EB97083A1089304E009829C88DCAC2DD0AC807FEC63DABABAC4D7BE16FFD6B798592D59E62CBEE2D898F9BBDF357CF6B3C99FFF5CD41F17F9A577ED9AE7FA5A361C415C';
wwv_flow_api.g_varchar2_table(574) := '596347074BC1D2350798055EC3E73EC70460FC7FFC0F0DB39EDFFA96F1F39FCFB0A674E810F9F41B36E81F7F9C7B2D124F3C91D9BB97BD01D7902DEFAFAEB151FFE10F4B6C3DFACE77D2DBB717FAAE42BE6C5D3B7D9A8DF825FCFCCAA8513DEC4963F997';
wwv_flow_api.g_varchar2_table(575) := '08AAC3B431111408EB9CB95BE61DA8666A94AA15E33DCE005395A80836F7BDF7DE8B05C002EF962D5BB0C8D9404F60FB1C863BE63B5B8698F8F9E0073F880B8DD5CE2BC0505FC8910B5506BF508ECA3855A1DED9124067502A1C5AA6C0D1280A83ED885E';
wwv_flow_api.g_varchar2_table(576) := '1178459C4E8474E238605881584E786B680B6E1BC0BCC2C123882CA4D01FD101B19B007515EE1FAFCACB08E40426F0982084229385CC2972F68314D20515F4196F162F1D179114549480F5065770489C44807924972007245E687D7DBD6012185128F176';
wwv_flow_api.g_varchar2_table(577) := 'B1DF3CDEB9A004003369CA14651CBF54B43EF8A1C589EC78F2E442324A48E224C2218EBD5C10DA3289304946BA72660D0A72F11691CAD2284058FCA86495BC002853CAC32FF76D31BC4829A0CB63310FC530CABC32E6E28CF2AB2523824419EA4A0C8290';
wwv_flow_api.g_varchar2_table(578) := '92AB959016986506782CC6A67C2BE08B6148176002E0C67E95852AC020BF2A66A624E9C59829965E01A10A1F95F865DE16CBAB04966118E018ECE4C7CA2305D89877A6DD91480027C32E8DB4181B6F4954569C481190222EA7281FE5C4629C655294722E';
wwv_flow_api.g_varchar2_table(579) := 'A0ABE461310C10A5144C5F622ABC1DDE2F744B96AB12DE16E359990E9E02FC058F0584C463018C12A11C2F8029262443AA115502B7A304E88884073AD723157328347C9116414E91193B478E2FC02137106513239155136C30F9ED823CD71E986E036049';
wwv_flow_api.g_varchar2_table(580) := '53F01AF8823EA43C6639CB0D446E9603CC92F4BDF7E69DC6EF7F7F31EF17EEF3FBFF5E7AC9C8D71A3A3BF3F75109DB11FB9BBB0DE5C7B952E6EFC7C2F54DA5B2972E8962B38E6AFCE21775CDCDC96F7F3BFDBBDFB1E53CF5C823C64F7FDAF8577FC53A70';
wwv_flow_api.g_varchar2_table(581) := '7662820DC95897C9175EC09DBE0149C9593845CC7619364AEAEFBF3F5FA822B3980F8F24FFF7FFCEAF035FBD2AE75A6E84218A1BDBF049B82A965361AC08616473FA85ADFC4C48F396ED01682186320E2D8E2BDE088F8C6778081C7617CB65DC0FC1F8FD';
wwv_flow_api.g_varchar2_table(582) := 'CFFFFCCFF8158F3DF61800045C0BF0B02C0C12A6B77118C4C4362794B0BC63B1D8DBA76DCB15820A7F7324408DB3C78C8DBBB85838994CBB601BA16038B1AC0CA384F8A2F8BDDC4980B6E0A0A26638C06C2BC05BE38C281BF571A101630199ECDCCE22FC';
wwv_flow_api.g_varchar2_table(583) := '5EC0C8CEEA28EA87E295D42B94904D2C6C73106F79C46DC66B05C9E73FFF791E8504443AA4F1BD21041BCCFBF0CB8E7D26716811CC104188F91D6670B86C466CCE01275908B41A969789703F0A3C97E46425A256DA9194145490C837B6A2CE4150611840';
wwv_flow_api.g_varchar2_table(584) := '5632C5627E94080518038C402BE75223B75C025A8DA45F7456E4E67197CE495961BADC3C9AB729259A12431E7D17FC1537A2E5328D9708420219595260E389882F17CF6D058F5828172CBD0BCA725B0956654695C07B50027423CCE02F597061C02C0976';
wwv_flow_api.g_varchar2_table(585) := '93016E9603CCE2064755D9D43732B24409D91ACD5125EEBAB8B68CC33886736BFACC67A4B9031EF9ECEC04AEAAD27675A59E7F3EBFDB792E18FEF44F0D8F3F9EE54BCDDFFE36F7333064E185EAB76E357CF8C3E9575E49723E79EEC4767691C56781A4A2';
wwv_flow_api.g_varchar2_table(586) := '5F8703302D173C70C4B778698BEF793CFB6CC1A6E88AD02A80B09BB1D77180B19219CB9F79E6198EEFB279003B1E6F810DCCB82B62F4C26B65518E57CAD95C5E31C8895FDC091C0376816273E300E0E1E0E770D2923800AC563153CE23F77CE272E01E70';
wwv_flow_api.g_varchar2_table(587) := '7986C0AC60478DBECB258027C9652D62728ED557DC48E27458E2761322AC7EE000E367B23B402C4E328DC274092E31332F4257515A8E6AA0A27898A8198AC721581639CB5B8DE402064F1B8DC5CB251081047E2C8BD2B2030987E82DAA8EAB8CAEB2DC8A';
wwv_flow_api.g_varchar2_table(588) := '930C1518800D5497791F9688C571418ED762E189BC20C455A699B098033F704B64851A2E1AD70A7502242BC4A066BFB512D069A4BE59CDAE31D6ED6F252378675B3CD9802997517DE05B590F2A6D5502AA045409A812B8791290EDC31B2679B31CE0B9BB';
wwv_flow_api.g_varchar2_table(589) := 'A07477DFADDDBC39F3E28B650C066E57D65457E73088F952A558FF61FB2566F7850B266E5D5EBD9AA272F3334B4BE99FFC24F1E493C2A16555D6F8852FE02A279F798623C42C8F02C636E9ECE5CBFAE666D397BE94D9BD3B77F22489862D5B52FFF00F2C';
wwv_flow_api.g_varchar2_table(590) := '0897E1A1BC3473DC46C8A7A5A7A612DFFE3617AD14E3C9ECD9C3AD32E591947F8BFBC1D219EBBAF81278179C0964A73BABB538BA4C6FE363E09360F163C7B378CBEC0B7E32E905DB2621817E808A9DF1ACCB617013278BD8470ABC700340FBFDEF7FFFF7';
wwv_flow_api.g_varchar2_table(591) := 'BFFF3D291C715CA16F50BE5CEADBDB53022806BBFBF030F13939C28A4AB08340281EBB097020712CD1A5871E7A089798F56174890917BED7C2DE045C50748675609C4C9682C9C5EE7A1032AB82532D569229F5627A85D2B25CFCF8E38F0B1868E16373D9';
wwv_flow_api.g_varchar2_table(592) := 'CC830F3E585F5FCF748F2C31749E091AA843884DFE20040C87F6FEFBEF67333F1E325C9185B99E7FFDD77F250EBCC84B1CDD1685E20CB38CF0062208014248E306F2AA59DE6512306AA5B393FA1FF5DAAE6D53B835E563EDB7463B63B565D2EA8CCAADA9';
wwv_flow_api.g_varchar2_table(593) := '0195AA2A015502AA045409DC02096040AEC40DBE590E301723FFFCE7FA7BEEC117CDCDCEB24ECB6FA1B458AC89C58CFFE93FB1BD39F58FFF280D0DCD3BC06C9E1C1D4D7DF7BB39BE82F0852FE045E7F89ADCBFFC0B3769896F2071DC97BBAF749C1EFCA7';
wwv_flow_api.g_varchar2_table(594) := '7F4AFFEA57C6FFFA5FB9802ABF33796EE99823895C2E6DFCDCE752DFFF7EF6D831DDBDF71AFFFDBF4F6122F7F703B08007B2309DCE2F01A366916B3FB93D2B7BF0A0A6A545C30512BFFF3D5FBECFE72A08E4BD511F5818D978BC2C73B1A486F98E77C17A';
wwv_flow_api.g_varchar2_table(595) := '97705CD98CFAE28B2FBEF6DA6BAC0C0BC7032701F795656171925030422E34835F5C684E1B6EDFBE1D8799C55E16D658E3E53C30AB670060CDB3568607F2B39FFDEC539FFA1430783E8BF92A0545541FDF1D12A0BA9922C10166DB30EA811B8C178AE2B1';
wwv_flow_api.g_varchar2_table(596) := '724B20CE4529F89938BAA819BB097026F16F71025F7DF5551ED993CC8E7A9661511EB1F68B570C2A5A33AF5066FC55BE3621265F4A4A8C5C9C210192A560AE2587DC030F3C80BFCAB2330A2CB491B7D0C2A3861F818A5FB1E04C5BC0AD851C8C71941D48';
wwv_flow_api.g_varchar2_table(597) := '22722EC0202ACEA8900E58491E2A4C042DF871AD05FE0A73A960EF4A0970DCAADAAAFD642D234651FF7F130BCCE013B2E8E081EF2ADC44B22A295502AA045409A812502570CB2480314658893176B31C602EA7F9E52F530F3EC8B78BB8A22B73E0009FFC';
wwv_flow_api.g_varchar2_table(598) := '5DE07F328C9B4CBA356BF8507066DB36BEA3CB4789E61DE039F1E6BF51F4F39FE7464670A1F181F50F3E98FF54D2850BBCD4FFC99F183EFAD12CC6F137BFC97777D32FBC2071F876CE29E50A1A76297395B4E1939FE4834989AF7FDDFCDFFFBBF1AFFF5A';
wwv_flow_api.g_varchar2_table(599) := 'CBCDC9DC023D3333EFEE8A1AD4E9F20BC573DF76D756579B3EFFF9056F050CABCAA74EC5BFF94DF37FFB6FDCB0C552333708153AF35CACCF2D942FBF3C7F8659645CCE2FDB47D986FAE10F7F9835376A9715E0279F7C1207987DCBDCDFC8FE67BC563C58';
wwv_flow_api.g_varchar2_table(600) := 'DC127C633C16B6AD72EE91B52FA10AFCE23CF056E807775CE13C705A922C78BC1CC864251918CE52E2F9E015B0CAC726525C6BE0715DC82BF02C876515F61D2C01BC5F5C47264438678E46E1EB1267FE0555615F315E28710ED9B2C0CB9E791675F15139';
wwv_flow_api.g_varchar2_table(601) := '2BCE7231DA82D6B1EA8B3F0C306AC9493916697153D152265C984F614919D194D1285E410EDDE317F54645A1C2B40E74C103420008CCEFA0FF046E536033361BA159EFA569C00690A8312CA1BA28B9D06491859BA85072315B444B59B9EF8A47BDE845D9';
wwv_flow_api.g_varchar2_table(602) := '62EE4C2842F1A4D83B584154D64B4800AF3726E59A3DB7D2FB156CA57366266E4BB0A826A9125025A04A4095802A8177A304301A57B8A451DA7BC67614E22282712902E629B62901A316C314270DF298CE79E00A3E830442DDC68DA6BFFC4BEDBA75AC9D';
wwv_flow_api.g_varchar2_table(603) := 'E69DC36B54F2B48883686404DF986F0BE56F57D66A2D4F3F6D78F8E1E98F7F3CFDF2CBF2F0AEDBB4C9F4D77F8D9FCC0A70E2EFFF9ECBA8ACDFFB1ECBBFF1FFF93F93DFF8467ED597F3C32E97E01F9C6CFC357DF293A6AF7C25BD6347FC2B5FD13FFAA8E1';
wwv_flow_api.g_varchar2_table(604) := 'D147B50D0DF09C3FA9ABB4596767E35FFE72E6DC39DB6F7E933FB1CC6E49E55B8131958AFFDDDFE1CCE372F36F1E8FB22080219CAF7E357F12B8E802D879AEE43FA53E838454112F4BBEC81667435401678031FAC9C7D66822ACADE118B020864D8FE9CF';
wwv_flow_api.g_varchar2_table(605) := 'A22EABB8F2C16030B026C6354580A11F3CE2A2704D11DE0208F15858730315FE0CB589DBC05BFC0D804964090E3746D095D95423EF6E09E49BF0DC8679514C9C4C7446F88A6888328EFBC723813E810E0118148C088157A23312D965481E01AB4480B081';
wwv_flow_api.g_varchar2_table(606) := '26E330831F7848E078E390CBD96106185C5C818D2E485C8205756679588226425E600406C0445CFE25457E259014FC428226C6F45341C70A06BC6BCE0FF30AC79EC7051961981476948826CF3A332BCF227101DC8D3F088AE599BF71EC6F5B4E21F9B70D';
wwv_flow_api.g_varchar2_table(607) := 'BD8A78451278872AD58ACA7C1B67561BCB6D5C392A6BAA045409DC5E12C01C5AE167906EAA038CF0B47C92A4B3531B0AF19DE30259B2F49A3D7F9E2FE8CE5FECACD5B2720B7CEAB9E7485702EB3A3BB98119FB123F999564C3873EC4C74F52BFFC657E55';
wwv_flow_api.g_varchar2_table(608) := 'B954E00669BE99844D9DFCD9CFA4A9A93C039C34F67AB1F195E01CEB4D3DF30C562CF76969DC6EE5FAB30CC6E15E16A2D9F68C9BCD7AB52616C399BF7E5FD71C1C0BC2A95FFC826F20C9B9168D9472800530FE030E80305048E15169AC8857328C784BA2';
wwv_flow_api.g_varchar2_table(609) := '4C08CD109E8948118F222EA3058074E133C8C0324E19951A5125707324803632F5C3348DD0641E599166FD566E054A3678CBDA2F0E30596273A12498324B25F11B718071743319BA2F3A10B17F243F0767B3692C961297E42D6482521064CE455C7E9461';
wwv_flow_api.g_varchar2_table(610) := '49A7983455A6AE8ADFCA6095476079B1BDE078F665AE14CEB37B8D6111598C1FDEBEB53C972C1DF730D3B18BD90879925440528A85B314F308F205A0FC7301E609F2A39C380FBAF00F60002BD38A53946F6FF338CCD382E8F995676704CFC5E52A4EB9DD';
wwv_flow_api.g_varchar2_table(611) := '4A5792C39289B71BE7821F5A3733D1CCE22DA963EFA042DD9EA256B95225A04AE05D20017AC2779803FC160B5DD8310B8D92722480AF1CB81CA2B7E8DDE20EF05B444045A34AE09D24017A3482CC71DE3B59BCC1CA6F31E2E52C2B8C2CDB01865BBCDFB1';
wwv_flow_api.g_varchar2_table(612) := 'B1546F2F1F654A736B17D75957571BD7ADD3C7625AE6D198655BA40894942270EE9A7DE6AC66B3C2CC516A0E268874654148E1DA6DD6D2D99AA19CE712304C5A2985462268E5C570251E1187E5785A9A4C96F60F2D3AC9612ACD3254900F3B4758060715';
wwv_flow_api.g_varchar2_table(613) := '3BD5D9782266DF4A51C96F3CC107A6444A9EA92CB9E2E4BC4A8062546552C61212B71F9B38E89D9312D905FB80DD268953B10B1C5629BFFE2F7630099C6C9F91F717C8548021C88F4478449E5CCF46F1E57412393850EC3D8290579451092CE7AA24A214';
wwv_flow_api.g_varchar2_table(614) := '5149780008378C5FE004C3C8C808DC520AB8950911A7A4289B0C4684999782C917EA0E0C002319657619CF0D47901E61592A013CD50ADB4A4E600F7F920D23722260A2B1C86CF308211940C9B3289D7845461E29A912A0923819099594058173991F0797';
wwv_flow_api.g_varchar2_table(615) := '0A8099A4A01D2969A1B4EC0203AD32515407790593702B18269D228852005F805C89A1641C240243712DF34ACEB25CB4724635A24A4095802A811B93007DE00A1DE0054BA037C6C4ADCCA518B62B6263B9F0152155815409A812786B24A0B4D596C49837';
wwv_flow_api.g_varchar2_table(616) := '2D175A814B6679EB01E0786626DDD333FBF4D3891D3B327D7DF88EBA5028BD6993E5139F307474E47D602CC5A29E07CEC9CA2906BE76461C2B137F8647BEDDCDD987CAF9242F07A7B19E651B9708763F37846137973CCF6FD04A7BAF4A2F9C97A256E9FA';
wwv_flow_api.g_varchar2_table(617) := 'A611B6E748D270426A70497FDE26258A4C7D0861E672053D67BC59968743CE4D609D73185B94A5129E81C4E1E710B558D8E71E6FAC796C6B7C6999FF4AF008189CB6EF1D93AECC489BC2F984835724FD759B5CFAFC1AC96729143C72866D2E66832E02E7';
wwv_flow_api.g_varchar2_table(618) := 'E03A930E4AE981074FAFC0AD856D4EB973AE8474E2C0C02DB970EF39302273CE2BCAC2CDFC386320A9AFAF27457E9B67B1B2802354CC839C159C7C0F0C7EC4557337805F46551C01396A2318E02D8F5437EA84934C4905BC28143705E070A260A4E345BF';
wwv_flow_api.g_varchar2_table(619) := '556C809C7A611B08F326B85815A225179332889D6A250E9F64141B109427839866E22A0DC0F08A696528039F4643F74A6E334108948EA3466083258E6630DDB32C4F0F4E50126A0A010A375208B0F25F4A015D0A8528E47271A3077A4810C2219D88A80E';
wwv_flow_api.g_varchar2_table(620) := '514D00C33CEA8A3BCDE41ABA4441E004C8651D6E021EEA34588480B2C186A008FF90A0F6D176D0C209055C9664CA480012A2A4C028E365B2A8AF5409A812502570031278873BC0375062358B2A015502AA04DE2A09B0E432329278EDB5999FFE347BED23';
wwv_flow_api.g_varchar2_table(621) := 'E7D9D1D1745F9FD6EFC713D672D643B1542293C5C8C3B2DCB66D1B16F9D6AD5BB9281BA37FEFDEBDDCADCDC967826C6BCA59168BBCFEFAEBD8BB98A402009314BF8EA3FE58C077DE79278F051959171D4948BFEF953EDE26456CF31B9EC93C9D967E7E2E';
wwv_flow_api.g_varchar2_table(622) := 'EF31B2AFB838C030262FDFC1E25E31BE97C623F714F0B12BBC02CCEE62F892293089458EFBB176ED5A961FF115F19FF12EC0868740164C6A60C4AF9000AF08A4142384D59F9F917A26F2EEFABAA0D43F2D19F338F201DF38FF5DDCEBEB9A2239FF0B7E4C';
wwv_flow_api.g_varchar2_table(623) := '79C482A7877382D8B1E0614940089BBB40F8300024BF4A431FFF0A079E5B184446DE5210260880243BB2C23384106FF10D200A00E9148492F2CBA348E197B7E29540C529749C6756F944DDF18A207209008ECAE3B6918B4490CF61CA4F4F002608C98942';
wwv_flow_api.g_varchar2_table(624) := '6EB26C01101816FB051562213B1A481C4EF8E800972652CB3CCAD92929B58FDC9000E962CA86B70468F10B5D382108AE6406001681740200009322204981314A0D7288829F5700887481843829046511C88EB6E3DDC917D49191142A575E530506D791DB';
wwv_flow_api.g_varchar2_table(625) := '3470ADF184D9524133E1E679C1066F85AC88809C02E2F9732F06AE23E9B044DBC40954322F18009E20B8928B0906B111006560568BEFB7F1AA40CF0B8AA02C8E1C072D8AC40584720AB448817F84232772C107150145BA14A8705501DF50441AB8AF742F';
wwv_flow_api.g_varchar2_table(626) := '1C24E1153717024F767E290598097025C7656C22022479995C038629030485B8481412E0979D20340126DA0412F18BAC285719B405540A1E412BCA0221F05070B9FA0A20D5475502AA045409AC5002AA03BC4201AAD95509A81278AF4A80B5A664926B05';
wwv_flow_api.g_varchar2_table(627) := 'E2AFBC227BBF42167CAA2DFEFBDF9B1F7F9C75A8823B020400161E462A862C375463BC62B3727935E6FBD34F3F8D5BC89D5E18B2958815931133970042014F46566C58DAE2B22E3E81568C249991BA7CD296A8349394DAAA25BE672B5CC537FAA598537A';
wwv_flow_api.g_varchar2_table(628) := '5F9D942AE16CE6AF2160910D86B9968C1533E8721D374BA9F8DEB885C27928A6559082518BB78C97485E6C6BEC725805333CE36F008CE387118FBB052DBC47FC529C16D69985EF51E033E0A73F542B0D4C4B6B02D22A9F64D1E7F73C8B4089785CE024CD';
wwv_flow_api.g_varchar2_table(629) := 'BD80102E2B014F9EABEF217AE6CC19BE68CD3AA1B0DDF10A28DA3C966B7F48219DBC58FC444432F0A45C03C9FF85737C063C37E2C2B3C24920C2E7C4A8203C2E5C2FE224F28B6B44768A2FFC34FC1979E51F4896A9B9C510171A8AACE0213472E16C2013';
wwv_flow_api.g_varchar2_table(630) := '6AF6E0C1837FFCC77F8C8870F0F0541111F5C25236F5020F50C46DC369212F38510C9C0A11874A810C95FC131725C5DF4309F9E5FB029408A2605342527602B336F00945D8C32BC3638701D8438DE13CAF94838308164F0C2143974A844F263EC08C034F';
wwv_flow_api.g_varchar2_table(631) := '3A45A08A910385453862B516CC60836D16BA2935C8C988D8511B1271E7F0E5D09C828280938C1453A45310520A2A08EA08B3ABAB0B8DDAB97327CE158FA0A28C708256904B2C99A2815410CBAA628E031545CF790B3FD4177CC22D2CC14F7F7F3F122005';
wwv_flow_api.g_varchar2_table(632) := '99230D20C183C4F0B4A14EED5016348D623227054BCC290818AABEA0084A09CB71510A8A265244639133C2007CD2949848822524C63596C89F86F9FEF7BF9F8912209118931A081CAE2826DA85C2504078A37454077AC55B59B12124D4806908EA912649';
wwv_flow_api.g_varchar2_table(633) := 'F6DDBB7713410D2087F4981A40CD8890080F088762F22A168B411D391047C921A1442B176AB10874C1C9B646EA91BC6023653160355D95802A0155022B9180EA00AF447A6A5E5502AA04DED31260718ABDB099818162299088F73B7F2F74D16B0C3B5C05';
wwv_flow_api.g_varchar2_table(634) := 'ECE6871F7EF885175EE0E3C998AA187C58ABC28C2EB0DD8B105C4FC0262660868A24618F62E662D75E0752C4581A8DDAA53F6FCFEF1FFEE171A9C39FDFFCDC332E5D9894FE4D8B7447504A173B8E8AED88C2A2855B8C724A0139D91C5710291D0512B318';
wwv_flow_api.g_varchar2_table(635) := '4F06CF0D631DE79F08C62E2E04D636D8307FB1B61102B63B0E3CAE35AE11363A2E50098C1AE9033169369D5FC7CE6425B759BAB6009C87959DE1828CC80A6F046F4DF85150C4A5C11142E0F88798EF258B432205174120A4F84A4898C7BB8067D032B581';
wwv_flow_api.g_varchar2_table(636) := 'FC21C1256DD40260B83D3872004082B708812253529C1660703F84DF283C407C1E010963C083073703274754288E0701B70D57077E788B1B830B8757831724D6E41126DE1D24280EC0870E1DA274782FCC3B28792E908C78A420D4087B1370F6C0F0C10F';
wwv_flow_api.g_varchar2_table(637) := '7E906A22AE0406063CC2F1C651619113FF07C712BA54AB80A496F187E119F78F20F41969E31523220AC84C015E22A24038A0A20A9889C08D04397504DBE8003E9BF03CF15D6917E803BEF4430F3D44F195FC10871F6A0481880282448ECB9024C2121581';
wwv_flow_api.g_varchar2_table(638) := 'C0218DEE119030847047C574037322D4CB837C6731938134848061D2079690060716100E4560D7065A44053153000C420003750430E9E4456294054D46325004150E3F45807F9A0C7200E7FFCFDE7D7DF77564F9A1FF014C209833C54C3149A2122551A2';
wwv_flow_api.g_varchar2_table(639) := '1245B5A4915ADD3D7DADBE33DD5EF62CC7755F6CBFF90FE8573FF8611E7C5FEC719AB167DD5933DDEEA4D4522B07063188A228E69CC000100491C3FD805B2A1DFDF0230882A149A0CEC23AA853B56B87EFA953B577559DF31BC8339EEC0A2B925D128A9C';
wwv_flow_api.g_varchar2_table(640) := '4117CA23D081981CA115FE1476A6433478FA4484EC6962323DADE83207B0DA0F73CA0272F8E36F020562DA9886A4A23BC53A45E4B21A6775D98839D002703757F8ADB17972DDD0ABED1FACFA9ACAD190340F6D1892E9F6E5444620239011B88E087CED33';
wwv_flow_api.g_varchar2_table(641) := '5D478E99554620239011181608D88769E3AEDF829A31A3CC5E2164F5CC995576C0F6F1D4839273C9B9E74C0B995E78E105FEA5908333CD7194AFB48C613F97FC4E6E623A844FDCF1B49C58B1A21878E5F4D24F9797B69DE90D7D2DA2BE7FACB46E7EE999';
wwv_flow_api.g_varchar2_table(642) := '7915564D93C28219AEF0A79F7E2ADC725814E2DD8A4978C315A5F4CD64174B851F42267531E4A3F3A7C584F24508DC71CA0B4E24F8E80206EE35B71EABBE98C0C846EE5FEE2D6DAD2BEDAA2FBD77A4F4C1B16FFF04C697D30B4462C5175F7CF14FFEE44F';
wwv_flow_api.g_varchar2_table(643) := 'C421FC754B9D0EC109F0FBAA9D72589A8E941909F912D496104B583C649A83432F7062DAA38F3E8AB9D8C9E298C801A552677679F19BD5D61EE5BB74432DD0D9BE2E87F9AAC021D62ADD65518136235AC347608C272491598A6497F6235ED5AEAC4312AA';
wwv_flow_api.g_varchar2_table(644) := 'AEA045ACA20A59653A57BCA40035C4A562363ADB8C20E6A15291988D44E04C1C4DC478D13604BD045155A9D04BA04525C18C1C1ACA342F2021F47273C5FC2240165152754AE216303A932EE202022834368BD86E99EDF7022D5582ACA852A441A1C821D1';
wwv_flow_api.g_varchar2_table(645) := 'B7548E22D6D18AE8886009D5F68479A11E4D002B8644C93453060239F46AB90B695E497522604E99356BD688D904A24C53CBED76F73D80763E335C456ABB17F898B340E39119E0BD4826609B8E942911378B7A6E100069E5700B5861C119749E1D3AA84B';
wwv_flow_api.g_varchar2_table(646) := 'F330D023EC05041A8A5A998952A95ACE8973621B86BB94C01F3230C1D3FC854CF4DA30B66E8A87FADE7BEF35FDE1D1669D4B2A619B780E2481A77BE1A6BBD78F3CF2088903A99569320219818CC02010C8FDCB2040CB55320219818C402F02D641AAC78F';
wwv_flow_api.g_varchar2_table(647) := 'AF79F6D98EEDDBBDAE172E646FF4CBFB5FB7AEF70B58DFBC5C5A861757CF9BB45EDF151E8891AC38FDEE77BFF3BE2547D3F6425E75197D3F9716767A35F9C67FE574E210EF0097C52D45263DDDA54766956A46F66E78EE19D1FB09E575F34AA346F42EA5';
wwv_flow_api.g_varchar2_table(648) := '563CA8C475161151D8A2251A8E2F57DEE29E18B26F8C5491894C7AF2CBBDEA2C4E13750419AF579C203610DD89E87EF39BDF082A04126206CEBAB02A2A86CFFD2DE79ED2EF0E94F637F4BEB4BC7A76E95C6BEF76EE38DC82DE1F73EA75D12B1FA21707A1';
wwv_flow_api.g_varchar2_table(649) := 'E234008AC7E02686E1C133AA4C904B060AF362990B4756305F66E28EC6DA9798D021F01375E02F013422441ACC41C352065A6614F5290D1D084D3103CE0E93026C878F3856A02232170FC8C7417509B10111C22A75058A44D08D3230B4DE185116024691';
wwv_flow_api.g_varchar2_table(650) := 'E22C535CA47A52B8620241DC4A819F5AEE1132CA172D951364EEA3F049E82E8726C27ED6514CF01C6195790DED9968D5A14A014AD20D26EA9A49D19CD8A8D4191FE7D050BB95091C20A8A2AE400BFE04B1DDB9EF41BA184FF5E0804C1599454A9931ABE2';
wwv_flow_api.g_varchar2_table(651) := '46134149AD97C214D3AA3506011ED0E42875E0400146D1C4256E8A40CD22778120D832100D8BDC26774DBE27453ED09C49A47CB481B80BD1CE05CC0379C655279A56CEC9AE8845C32E99F0C44A682DE61497124761A53481A173288F954CF45A291A4CC2';
wwv_flow_api.g_varchar2_table(652) := '1CF6CA41C6C022564A1581C5E60B3810E13161BE1B0D673CE5844ACEAABB7D60C1967472032589A02972EE3F8DADBE8B68E2A4FB27CEA519818C404660D008E40078D0D0E58A19818CC0B047C06FDE4C9D5AF3CC335D870FB77DF249D789137CCC913367';
wwv_flow_api.g_varchar2_table(653) := '8EE2D9BFF452B5DF341223558A3AB89BD6852C827DF4D147D691F88B9C4B4EB360523C3C70CF0F9FB56BD70AC6C2C1753FE47046F9F4FC543EF7E5EE9048684475EF67934F36F7FE249258B16644454DBF65C097155A7370F9D9C471B80575B65CA210A6';
wwv_flow_api.g_varchar2_table(654) := '728207E2EC328D6E7C6E4B49E8F9E272B0B27DD42510E42812440915841072842B44F465CEA3FFC19D5F7F05FAEEA9A5DA91DFF97C57C57780BF35E6528A689AAC5BB7EED77E6DBEDB2FD0F7EEE47CF9E597CBC8148961A8A1340512F41141290A620976';
wwv_flow_api.g_varchar2_table(655) := '7997DBB2AD1C6C0125CE416631D094416C7246C3BF47238490564BE86B8593A5885DA267BB9660BDD11489860110219078206451400B21C27E690106C51C4247E10726EA0607FC350369F7454C1E8932BBFA5E22137B3824AC4BBB055A11B92C9513F412';
wwv_flow_api.g_varchar2_table(656) := '745874E920511B235415823403282975D7B4493AB391096C07356EF8A8224C5ABC78B166EFBEBBC489080AAB85B933280028F452918DD6038160B7AD488C387CCA348FFB682E0041BA41C8305194D4A624A0A02D536C0F3182A84D1F58856E8258BA892A';
wwv_flow_api.g_varchar2_table(657) := '0902BB1BE17E890629A9595A970E55499160382B345D55188B0FFB3B72FE00004000494441547B6532CA1C87B565B55C520043FAB853DA58E0E39C202D33275DA2015118252D5F154CF0273D2EA5D9A2B5D05CA68DE804794E510A563542C0A29488678D';
wwv_flow_api.g_varchar2_table(658) := 'D58AB44973101EE4B82F304F4223419C77BCCDBCE08C9E08E881CBED8021AC24D8AB22CE98282597B14C961F28111D7A9631EFFF1267F33EFDD3E4D28C40462023708D0854EE82F577C15742FF15873ECE90E0D0AD1BDB0CDBBA48DD682FB159CFDFFEB6';
wwv_flow_api.g_varchar2_table(659) := 'FD473FBA466D865D7563D7E1C35566D0BFF1A2861D02D9E08CC0AD8480FE4DB4C02F0CAF31A9A697E3C70B6F14F171530FD94BA07FACAFF7719BCE4D9B3A0F1EE4A28EF03BC0F6EF2D5DEAD1AEF805AC60ABFFE4B27B0D0F4F7239E2385B79E3B67E87FF';
wwv_flow_api.g_varchar2_table(660) := 'A5552F7108B752116949AB48F03B8B39D8468F2D51C6A748266DE1F4FFDDD6BB79D831ADA6F4EF1FEE8D21CBB997D551EB9BC528096381F727AD3E59C1161E1475235DB8185150311F3F45B1D48603A328C9F6082D38D3DC6B1EBFAED188A3A22297C0EF';
wwv_flow_api.g_varchar2_table(661) := 'A348EFFAEE9996526777AFDA1DDDA5667B9EBF21523467DC777E15E99B920AFF816F3592389A106459B22F6E34A1066D537DCA232E460E817C18A2C8212661881B248E326246A40A138B99EC128AD8D96BFD30A20BF42117AAA0A395DB8D83E059AC2B08';
wwv_flow_api.g_varchar2_table(662) := 'A421E96802100C3121D40A30650812A7A92BA1481A07C4681048C3569452D45F3EFD23224AF9C11F9F944304DD842529070D2B70265729259562059F502682766411F845A0251314E851C2532DFAE0C01CED0107C44A1561AEC8D982AD848AE26A5861AE';
wwv_flow_api.g_varchar2_table(663) := '56DF190A8A31109F8028F42445DDE2D381B31B811238225E978042863955E5B0DA83C62E159546F02FB2C5107300D2D3AD81309564521E8D4C456A61EE0C2B3CA94A196438CB24143D1B412107E6DAB944A8EA0C3A2DC70E087253A60495882E52525E5D';
wwv_flow_api.g_varchar2_table(664) := '402532E9686081150E94A486BA7183A26D8342C2997A08E84C790786F42C320CCEC93AFA034726F0114BD0163DAD9C31641D9ED271E3282381D20D2D6A9E14CE898C40462023708D08E870AEF177802B7B48A9CF92D099C6A1EBD4CD39F4AA7A372307F1';
wwv_flow_api.g_varchar2_table(665) := '5F07C0C6339FD9F84FFFE91AED1976D5478E1CF51FFE4315A7A430100E3B10B2C119815B0601FDDB5507C06212B11327D50ECCE666A6F8D28E88A1F7AFCFBA4A99A1BA50DEAD3058A7CAAB8E05B1D4FD168975B9FA610E6EC5D222E5C0D33CE8D32DA5C3';
wwv_flow_api.g_varchar2_table(666) := '177A770BFB8E9488B1E0540F880DFD21669F24C79DF265BA314A698AEB8A1C554CC491E66D2390E9881CE7C82912179948C797AE228CF83620B844D4FB3348033E084DB421375D1613C5A26295224D5F43949665061F99B16FD68AAE9B9B182A0D021511';
wwv_flow_api.g_varchar2_table(667) := '582EB6B25A8C3F952694FA322F160565517A525591B6A728429A941F89A480CBA45891263827E2A091E990C99C102AE1F2720AF4AD556418DCC21CD304A010B659B7B4241B6C83B8780EE9915351EDD0044170408F2CA91A12A3B49896139491A98A23A4';
wwv_flow_api.g_varchar2_table(668) := '1473121F45291D158338E517394411FF4A2C5A3162C421559748A28B99212EB10DA1497470505ACC89CBC8A9C8137FA50E89225C919FA4F7655BA64CA2CC898C4046202370BD10D0355D63005CBEEF65909AF982C2B265A37EFEF341561FB6D5DC40F3A9';
wwv_flow_api.g_varchar2_table(669) := 'DF0CA5C316866C7846E0B646C0224895AF075BA58C2DC72E8573DF755B2B1AC87714D32EBEF4912704BCCCCB79A21661145DAEB422F32B6672E167D6F686BEBDA27B2EFD70EE15EB7C97803E567E7CD3484FD657B75815EC9B8F473133D2C5902672124D';
wwv_flow_api.g_varchar2_table(670) := '4A7C5778EFD55545B97DABA79CF0F2D3E5E512FD6892AAF43544515966F09169D6C059F093AA4B280D02692B6F82A2B8FB89264A134D19F3E010C4415324283211FA5ECEF0C43CD197258A04292D91D245A1C574E293282F55FA760202411415F32D516A';
wwv_flow_api.g_varchar2_table(671) := '69222B6854E4166C13CF24A52C515637E853665162315D51A52431094D7C14A5742A0DFA941F97E9CCB4B2A5F85454C621E51713656CA34AAA78B984FC5454E496D2650489382582325D46A24C99C42D27320219818CC0AD83C0750A80CD140AE42EBDEB';
wwv_flow_api.g_varchar2_table(672) := '72EBD8761B6822F4FDEE7EA7DB40E7AC62466018232060A81C3344EE7777230F10A7A2BF5899F9A5A5980172BB2A326147FAD1A30104EC9579C7824FDFB2CBD9D29772D8E608EAFAB7DDFA390271C58D00B3B83DB87F35FEE8A5F647D8F71B50FCD195B9';
wwv_flow_api.g_varchar2_table(673) := '110ADC88FB7B23F4CC3C330219818CC0AD80C0B5F79957187DAFC248B1DC77A7B1AFA26E26CD0864043202B73C023A5C7B7AEDC3BCE535CD0A6604320219818C40462023901118B208583CB89630F8FA05C04316E16C584620239011E8452036F8D9B09A';
wwv_flow_api.g_varchar2_table(674) := 'B6FC655C3202FD236078EE3B426B3FB909F58F5B2ECD086404320219818CC0E5108881F55A46D2E115005F7245BEFE9EC4250FE43BEF1D5D0EE59C9F11C80864040201DB7DED4ABDC679C70CE6B50C5AB70B7A861BFB057C22D8C7C08A3ACBB7A1D73778';
wwv_flow_api.g_varchar2_table(675) := 'B5A5C0E1DA07F222FF9CCE086404320219818CC0D046C0001A43E7A0CD1C2E013098125212DC8E4B19BD09C7A0E1CB15330219816185807E23BADDF824CFB0B2FD7A196BFA406478396EA9A30E82DBB47F66851F4AF0E1623F7BE30BDE456315799DD52F';
wwv_flow_api.g_varchar2_table(676) := 'A63AE21DE0F808D66DF4466ED19C9CCE086404320219818CC04D46C048EAB816A1C322000E87F552A8FB6DB81BD8C51C7CF12334D78266AE9B11C8080C0704F42342971CB10CEE5E8B7EE377442B565754CCBFE267A28AC4B748DAE0624C3972E4889FD4';
wwv_flow_api.g_varchar2_table(677) := 'AA18EA5FFAF9D5265FC9F6CBCF74F6F3AADA52D90FC3DE22B66435320219818C4046202330F410B85101708497F08AB07370C045708FC3E0AA47ADD0843B52C62714539AC2E3014A09AD8238F12C669615F5C356AD228794EEA7CACD2F2A9A766B6A3868';
wwv_flow_api.g_varchar2_table(678) := '4C6E0BFC076D5DAE78A311283E1A375AD630E15F5F5F1FBF301FF6EA70EC16F6534045F3F5D8316559C43F754D31A7992E8B15A5557194CD78CAA9482F5F1545BD752ED512A606250EFD0B12D30A8005F34116A213374C7C4AEDF0E1C37E06094F7BA4FD';
wwv_flow_api.g_varchar2_table(679) := 'D091D27410271DA22333E4A67C6C8320F253C5944894120E64FD5026824BB45F1317D3896D4A2895BE1CCF4456315156D7E5E5F804E54004A10CE2B29B5B51818A9989432F5257E375845C55CA12A4C8B9C4ACB20F13A5A14CAA5B51B7C40A9963703656';
wwv_flow_api.g_varchar2_table(680) := '6C33B85D95B197532FE7670432021981DB0B81DE41F4BA1FFA5903BF779FCC7363AE87BD2A11AAF309D43277DEDCDC7C8DBD336E460B4C24CA3489CB706506A8616815A6152BD293C976B2716B78338E813064601AC98AE981D41D084D5F93FBE65C910F';
wwv_flow_api.g_varchar2_table(681) := '5B62BD827565005EB1EE8D20604219DB4118858326515C6B2AA6CBF8F7BD84435F35FA92E59CE1808050C703629BABC353EC31490FF57030FF7AD9E899F20C9E3E7DBAD8C948CB919F322576EEDC096763C4C99327CF9D3B77EAD429A1667402903F74E8';
wwv_flow_api.g_varchar2_table(682) := '903B92E88BEAC9D475EFDEBDBBF8F0EA072A76D7884F9C38813F417AF56DDBB6B9B3EFBCF3CEEF7FFFFBAD5BB7628B0F6E9713248C372884208BD8691DDBAAAF2ACE8A1A1A1AF0C4AA8C894B12D928A151310702F47429539A99660A2043F3B2BA616F50';
wwv_flow_api.g_varchar2_table(683) := '2226A5B1B1F1ECD9B3C1AD8846A423FCAEABABA3AD3459D294579120FBB769D257841CA58EBE457D4594E5A8C2A854D725A12CAAC88A8134BF1CCE89B3BAF4A72D4BFB7FFAD8986A95253CC52075C7E55754A68C3E5D8692AA5035EE88DB2AE14C1FCA27';
wwv_flow_api.g_varchar2_table(684) := 'CA62C20D8573CA51B738F593F22381D87D9446E6D6476328A3A1406A667D8BA2BD3110F8D288E34C286E65F4F932239011C8080C7904CA63896B3758C7AAA7E625FCD55FFDD55FFFF55FEFD8B123C636BD2DE6D1ED8614390E39293F72540F87C60B54BF';
wwv_flow_api.g_varchar2_table(685) := 'FEF5AF0D4B911FE7449C7AF09493B805FFC84716FD3BB6313845A97C43668C40D28E54EB720934866DBBDABEFCF2CB5DBB76EDDBB72FC6127ECC575F7DC551E08AF18A5C9E3F7F3E18F6D5393147C0405A49388E1F3FAE5698503444515258E212EDD7A7';
wwv_flow_api.g_varchar2_table(686) := '2259625B4C609EFC8CA86B30EE67942DD68D3449070F1EFCFCF3CF996CBDC2882EA728B778594C87B8C4242E1138229D98C8A9988EBA65676D094A69F80F6E72985946D9FFA58A5C13372B1AA7EACC645DD244F532C582A14C072F44B394E85F4A2E1DF2';
wwv_flow_api.g_varchar2_table(687) := '08F0DD376FDEAC21099638979AE2B163C7F8D09E32C79037FFFA1AE8B1D28B4E9C38D107A2E29096E3C14C823C749F7EFAA91C31A467D648212775081E67E1710C19AA2872445D8FB6C30DDAB0614344418A2474893AF314035CAAF1751FB577EF5E7753';
wwv_flow_api.g_varchar2_table(688) := '50A196D0D778B17EFD7A553EFEF86341C8962D5BDCE8A04F52929E18269EF32E1D2E2DF32E5CB89069CEF8D036D11713246EDFBEDD98C2467DAF907ECF9E3D619421C325B9AFBEFAEAFBEFBFFFD1471F01ADAF743990A1BCC188BD1F7EF8A1B0B6229931';
wwv_flow_api.g_varchar2_table(689) := '42E9BBEFBE2BAA672062966ACFD8329F8888FC8BEA49539E1A0E90629BCE124A232732CB2A46DD2FBEF8E2EDB7DF46E63028FFE217BF8027FA38A24AE0431F0DC0E883324A25CA7846D17BEFBDF7D65B6FB935187EC3E96B6582C0D92DD0ED975577A948';
wwv_flow_api.g_varchar2_table(690) := '2D8663E200458C0B458968A824A7ACBA9C03070EF00ADC2C2E0130DD65B749A65BE0920945C723AAE3A67FF8CD6F7E431F1CDC71CD89D714332372103824E230420181FECE1B376E7419F9A17C28460A2F42BA4CC3B8347C53C60D559D681CDC7AE2FEF0';
wwv_flow_api.g_varchar2_table(691) := '873FB8548B3894C1F692F0AFA557E49633330219818CC0ED8E40796F7E8DF6E8377984BA75E390218447F8BFFFF7FF8E097BBDADEE5B1F1D09FDAC8461CF402BAD3B96365A4B18307EF9CB5F2A155E1AE923E8E2A6481BA183D8A58AFC920841D552AA7A';
wwv_flow_api.g_varchar2_table(692) := '10272B1087934131A5066C94D2F271E03F85938A464EAAD54FC22842E8A44993786618BA6411EF8462346129050C66891B1A07FEF219682C273DF84B0898C165EC7198BDA6928A18A2E4EE208318B691902FE1AC88DACC47466E70AB784660240E4C70A6';
wwv_flow_api.g_varchar2_table(693) := '390454AC485C3193023C7B233A93D50DAD584455F44CA00929E92E48475145CD69CB5E9A38BB5FEA465AADB82F6114942A2A1399967DA8847F20A98DF1F3D8D84F95B22215DD11E03B343397E4028A5620920ECE0CA1585C823D1A123D25DC2CF7BA7F3D';
wwv_flow_api.g_varchar2_table(694) := 'CB84E6CB21898036A3F90969C68C19E3C1F720F341352AEEAFEE456B716854D1CF386B3357D5568724689733CA43ED71D399140F39F25315CFA6A712C8D10F7830E5F0E361FBC9279F08E43C9B88DD14BEBE402BF57EA29137DE784360E9B976D7102388';
wwv_flow_api.g_varchar2_table(695) := '5930C38D7CBD8A1C216554C1841A6E5FF40FEEA97C8256AD5AE54613A7330C4A1D82A0E2CD37DFD4A7E9D092AA1234D779DAE7EC5D5F6D4345099BBA9DCB288BB530ACADAD35771CD3ACDE0D8EB68415117A2A6A6B4873E6CCA176C5210073E6087A2180';
wwv_flow_api.g_varchar2_table(696) := 'DBECD9B353879904452FF7C1071F3073EEDCB92482C888264D229444E03ED33561C28422FE519D2DD4701720000AF7025090776B14B9657228196356921809BA1124EE0260F03185449C520AC7EDA35BA485DF68E2BBEBBA6B6CA3432EF20CD36005E7F8';
wwv_flow_api.g_varchar2_table(697) := 'AE18B9CCC74A5D8A814845669222F0366414AB4B13A794393367CE746B3EFBEC3380BB5938E04362F06132FC03B7C481399A930058822100476FEE001482D569D3A64D9D3A154A6518620237F4826DCC292C00E63549532FF0A43988584D7FF940A0E4EB';
wwv_flow_api.g_varchar2_table(698) := 'AFBFAEAE033E610832AD5D2743E75FFDEA57D82A4DEA49508C32A25FCA68332861C5164D9DE6DCAD90A89DA868700F90B1D5E6552CB2CAE98C40462023306410B8CEEF00C7D8C6CF78E595579E7DF65943E07FFC8FFF31BA7583CA4F7EF213C3095FE1E5';
wwv_flow_api.g_varchar2_table(699) := '975F96E0AC18C51F7BEC312E85DED9586E0C7EFAE9A775F142CAC58B172F59B2448F8CA7D1054FA397E1EDA5975ED235BBD49B9B705DB162C5BA75EB382E66CAE5FCF8C73F762E0E36293D79F264219C4162D1A2450609093E2B8941503666F4BDC108D4';
wwv_flow_api.g_varchar2_table(700) := '3246DE75D75DE14F30819E22614EC3FCF9F38D52C62173FDEAB2CBB0E7D228E59221461D681853490F970243A2A984188D716EFAF4E9463846C5188615C71AC1F2E5CB0D90A4C0C4D0A5A241DAD068ACC24A2688FA2A2C876E5C0D1C2C389082834194D5';
wwv_flow_api.g_varchar2_table(701) := '09938AB5CA32E94C04F4C21570661489E11B19E98DF7F4E17C809414CC5D7A6D8FB8A4F99D77DEC92E456C44AF8845D2D8D2501A3D7BA519C56A120DF9659AB82457286E84C6CA58CE417147F0E11AF625EE27077AD4E0EA61A5C1A08C9BCB21209DB6F2';
wwv_flow_api.g_varchar2_table(702) := 'E3DE41D82D8321DF8868F7D499C76091845CC0F62325170D0704E241F65869FCD271A925732875023C484D0B0E7A2A7DA076AE75556CDBC301AB2BDAE8B976802E2803CCB25A9E5C7191CECD2CC382050B3C92020C0EBD07566CE92EE88A2D06EAA95477';
wwv_flow_api.g_varchar2_table(703) := '0B742CFA55EBC67A7BF74275228497D12379DEF1D7B1A8281AD417E9B53CEC32550FD1D1C13AEB9D0C5B7A00434014A13130A9A8CB92C639F2E3EC9202F471A9BB105130AD68609138A599F3E0830F1A110C854F3DF514CE9477E86305A52E83839E39E2';
wwv_flow_api.g_varchar2_table(704) := 'BD32A1C187320E342C5291C2D82611124A7583BAB27FF48FFE11258DAABA65A12F40746B10C3D679E5CA9598F41511CC812FCC43065BAD1A142FBEF8A24101B6316DBA66CD9AB2BA2E111B23C47E6BD7AE75130DA9B025DD4DA1E4238F3CE25E9861F44C';
wwv_flow_api.g_varchar2_table(705) := '511E6271568ABF5BF3E4934FBA89455BC21C94F4A7181FC3804BABFBEFBF5FA661DA5945C30D180D1CFA7CDA16159346006DBAA9ABF1B09A5381CC10B07AF56A8BFF6E9FB654F6463ACEE062322469E52E33C41DD78A3CFB121EFC08E0CB14468C068006';
wwv_flow_api.g_varchar2_table(706) := '1DE268CE5EE6335C987DF7DD776BCC9B366DD2CEE9004645C63B6ED2F3CF3F6F78D212C0F2D0430F91623022C5F8CBD7827FD9A80410F498409B0E546597BB032552E46045877BEEB9472311876B15D2EC92A6E1030F3C5004AACC8A7C9911C80864046E';
wwv_flow_api.g_varchar2_table(707) := '53042A074E833646576B18887ED998CAD5133CE87CC50F425C3D3E1FC5D43B37C2DE66032737D1562E31CC6BAFBDA6B70D0F524F6DA2DDA1679769CC432306361EF020ED5352DDD9C861D85091446793A951BDA83C7DE2520F1E918C8EDE7068D0C58D6E';
wwv_flow_api.g_varchar2_table(708) := '29704A94C5EA65E9F0098C7F862287D1D4D9C88D3397C8C029E108AFC2994F060463ADB4218A0823ABD151C211838A3155A623825EF8481B44A94749DA020725EF048C008498222325F3654A6055A667BAA4A1B130A41B1D69C85F34AE27822B263027C5';
wwv_flow_api.g_varchar2_table(709) := '9DE27C7059DC14C3B31C501B47DD1AEA61482563B31BC15E08B8DD842AC25F63A039A082920EEC021A5880CF4F322F408A0428D05CD1286A70FBC8A2007A588963FB01A1A28D5A0EC0291009FAC0D625ADE4508909BC16E6B87447621A9E1466F269D808';
wwv_flow_api.g_varchar2_table(710) := '5BAE4945E63973F820A04968E15ABBCE4123D165E9BE342751848E421BE36B6AABDABC56148D4AE9F0C167109682B4789471D01942583FE6A98F3015FEBA171D94C0E9B9E79ED3258A1F748F62C8881571D35F19357EF0831F70E879F69E62910C0E9E6E';
wwv_flow_api.g_varchar2_table(711) := '73976660EFBDF75E5D105F5F5786D23D0A1DDC416922A2DB775B05093295524CD7A74BA48F28516F50710042AF6FD16990A85674FB6546F5BD24540F434F5D50F4FF5A91430343AC94929A16A111C057E4001616E9AC50EA2DE95924A30C43F472081888';
wwv_flow_api.g_varchar2_table(712) := '270D453E4628AB82F205573AD858270C7B8BD5430D6D1E866C144DE996690579D3136E90AE9ED0CBD94B90B10C01D01053D59C85488CAACE46191D7BDC5F83A0695F18B2DD4864E9B8E210C604032E1A6328130C7C4CE03F187DC0E82E1B82DD2CC387A3';
wwv_flow_api.g_varchar2_table(713) := 'E28DD0303CC5CEE60BE8632D17B69C04BE073D3DBC9A53A854C401BD7B44BA160801CC294F6769001AD4CCCED30ABCC55AD29041AC2EA3E866969C5DCCA42D1064D29C5C3705B6F8E0CF222AA96216260665C8504C29D320A6957245CA04B9A49E5209FC';
wwv_flow_api.g_varchar2_table(714) := 'DD6EA2B172D710B3345C17371AF226082843160CDD201A5EEE0EF6959273320219818CC06D844079A77C8DAAEB2B0DC9FA7ABDA78E952362CC366644CFAE17E6291A309C4D641AF6CC6BEA978D461C082E8884BE58C21CADB9D818740DD2FA653ECABFFE';
wwv_flow_api.g_varchar2_table(715) := 'D7FFDAA062DA18676E0A02EE0EB7D2A0A58AB95E4E8691A0680259C14426DD623C3306A81ED16F74EE6850162BF64DA334C6308D3ECE9C097291B1D780649C88E14742298634715E7AE9C0DC300F042196B423E4AA6E4C350BEB88919539FC9E9838600E';
wwv_flow_api.g_varchar2_table(716) := '55D160E81C55B87746444241C10ACAA04936222B1EAAA0E40A401EB012155D876295B2340E98AB451926435ED01B86A00C65D018EFD90B5EA3388BA84422B58B9AABE5B61A7785975C4F944C36D8AB0E58075818852760FB374A45AC400A79ACCA74EEFF';
wwv_flow_api.g_varchar2_table(717) := '92390471DA48E19760420755808915E4DD23F9F477EB28E9128D5A0EE60420FC06B79B9FD4BFAC5C3AE411D0963469CB2FA64EB40DF6CAD14EB44C8D449B37A1A35D694B1A92451ECFA0C49087651006420F5C3A19CFA3382A0E69398EC036D87A54EFBB';
wwv_flow_api.g_varchar2_table(718) := 'EF3E2382AE4611B43D9B3A04CB65665701AE2372A90F71538404EE48F430D669CD449022B4102C2193D631EA0D78FC62890806700B416E9C08C4DE66B19035403D068696D1DC71EB81E48A4CBC32AA4BD46B49EBD96426DBE94C046256E8526271359827';
wwv_flow_api.g_varchar2_table(719) := '1189B898502A8AA3A4A54EB190BE1793C71F7F7CDDBA75463A4A324D246F040CACFA724363F0D5D2F4638F3EFAA8D608993232B0500F99C81F3D890C89E900B6E0AC9BFDDEF7BE174BEB45BB4255D6C5E12E88F420E0A6809DA5C67703BA74D1A8629AB8';
wwv_flow_api.g_varchar2_table(720) := 'E83F4D6DABEE2EC85151F76B1603C838E87B8D74218274619E3B8500595F6530072FB81E7EF8610D402DABCA1C0CE663AE160DD9EB918CB1A30C8AD02D862D37516380986E1F078F3662B7004F4619A1248AB6486B8470039A5209D3F43494E9AE7151D8';
wwv_flow_api.g_varchar2_table(721) := '42F98A12D535F4BB35E611F40C40D01455A4B0F6EF12862CA289819EFE1AB383EB0204BA2942A02568A826B849771895CA3474C9A930EFEF5E03C4ED76DF8953171A4A4D4650C3CC8506A0085B22884340933263F3654620239011181A085CC562E0400C';
wwv_flow_api.g_varchar2_table(722) := 'D669EA58C5A2BFFBDDEFB81A065153C83FFBD9CF6208F93FFFE7FF446C63B044264816EF19D1F5E946295DBFB1F699679ED1591B8CADE81A458C497C17C4E63B8D07181A8442134394A0CB68A74FE712C574A9F146974D8DA0D1B917074B9702C265CB96';
wwv_flow_api.g_varchar2_table(723) := '1963B0751964D44B55FA31D3106BD8A6B6B32A14367E6045077A522FCED8E28658BE918F1782C6253D196E8852378936A89B912514994C4326430C45465C43117A9904B9541D59542408BDE1CA1CAD795CE9CBA98D9EC9C648083BA2FAE5882BE6D35675';
wwv_flow_api.g_varchar2_table(724) := '22CC59E040437641CF48AF08F2066FC333BB8CAFEEA0526AB3378673C3BF9C3039A487C7A90A266E7D10B0421581349A9878C6A4A23E32D1401E3EAA5C8EE672F934093F553B715FD845678E11784DD63001732D509A1AACC387C29491C37C7E096F43A3';
wwv_flow_api.g_varchar2_table(725) := '7247F051F1728272FE70404013D2063445C66A4B9AB4A622539BE1683A7B2E3C08F14404D970806570367ABE4C207AB28ABDB11CF989A1C753E8EBEC81852D6011BBF4387BBDD38810A19780C7F30B79F742A95ECB40E349D7D92AE2D9BB3BD23A3145CE';
wwv_flow_api.g_varchar2_table(726) := '620C2FE3E8CA0C5E3AA5C45315838E0EC17AB22E0B73458261F9181AE37402B16028FCD33390985445A9492040ACDB3160E9AF74777A6F675A25CA6202A54BF3BCE8A964AB94D8465A58480DB2A881AD4B1263B1CE7B43FAD8C40407C325B5434F03967E';
wwv_flow_api.g_varchar2_table(727) := '3582C944234101FD1B2B2CD80AFE356331A74E1E2B80E8E204F9C66BF883882D6575B56DADDDE1EEB04887ACA24C7CC8FAED6F7FAB0AF08BB5221DB7034F9CE92FC2E406B88F02753AABC546485A384563F0C2DF19B0464677DC48D1173AB500625C56C5';
wwv_flow_api.g_varchar2_table(728) := '991A3685B9A7EEA68AE869E876C30D38264A84CA0C2CF261087A2BAB94C4CA8C15D0C4B426DFB50723A0A91046514CFB51B15897084E85E9151611AD018BEAF17113F10488DB57A40F1C80037FBE8D2A90D73690C190CB14430C4CDC71A6C9A71E103091';
wwv_flow_api.g_varchar2_table(729) := '26CE9DE5234960AE2DF11054D7BD30DFADA7AD5A21C5591A6E6E0AEBF0018527081A063BC4748EDB1466BA056E3AB9ACA04C914F62981319818C404660082030E2E73FFF79FF66F4F6F4DF1C7A43876ED7A11B3596E834CBAAEBD3F5B6BA51C3952144EF';
wwv_flow_api.g_varchar2_table(730) := '6C3435A1A8578D81413F6E9657B71BC106C7C55CA6796E9CCD445A13D689ABAE83D665AB655C34E6F166782788BD036C1813FB19DBE8C51B30D7CB45A08FEA0636C3495125E31C3D51A64C6380CC741904A4A79CCB25F0C15C08C4A7A180F1895D866776';
wwv_flow_api.g_varchar2_table(731) := 'C1015BCA18BC83159DB9680C01824CA58613C406571589C04D456686C2D20630A5BC01F3BB887969C62108B8446C84E3648408D539554C066604E197D339F2CB4CEE9FB8AC94FE4659079548A421BB0C991228DD656906BAA14C704F69A801280DCDD124';
wwv_flow_api.g_varchar2_table(732) := 'CD0DDE6C77FB0493016058E4EEB09D08913F298C4AA3729932C54B7C8A97034C43129EC4694BC077009C62CCA4B09B4B73C8E34649ADD72D600E00DD4A86BB838CD5443141D3B7FD0F508D4C766B22E0E17567B564EDA44C43ED4DDB88E7548B8D672A1E';
wwv_flow_api.g_varchar2_table(733) := '4C2D16B11CCD49D38A4327A95D69D5D16C34244F7A5096711E6E97408EE1A3CC706082C8C3D5DBDD148E70D013B1AED563E816200135CCA1AA96584287EC70A7742C860F238BCE272A7A8A3DD74A8D476A21D6036045284A1D8E7C09A14874C86A91A24A';
wwv_flow_api.g_varchar2_table(734) := '8C5FC6356C31219738FC831B3EEEB27C310F7D42169EFA13614974295A82514667A2738B1E52A0AE556830F4619D3E1341B143D3CC8C6B8C72E833E9C94C94AA246014499325E4A355C247429FA69BC25CA9B4B667594FDD228DB45A622DB783621240A0';
wwv_flow_api.g_varchar2_table(735) := '246D113390926E930095757D2BD256EF070A3A400CA42EA1E42C476FC952095694D5751964D48661D4A2218906050ACB646FF4BDA42363BB4C88815A74D7D75E3CA1E1F1549D62B4521D993982B824919264398391A545ADE02033BC02B22CB6E34696DB';
wwv_flow_api.g_varchar2_table(736) := '275FB8183A8866E9D957BAEAF82BD2188893A0B61C6DC07DD430E417C5498744B240449056E7EED05F8B25540207F91268600B106C036D40C9672063DD65F788922668646AED0E9465E2307713E92F1F809AB41CD529A99160486DD53D11B8690C44CB64';
wwv_flow_api.g_varchar2_table(737) := '29D1542DE3962F330219818CC01F1D013D98E95D0396DECC601D6709FD619C75E971A04C47A8ED52E23B9161B22775791246C73888D1393A8C43FA686336167ACC449CAA132990307CAA6876D9F82DAC95564B6F6E48D0BDAA2BA0C54A9F2ED378A954DA';
wwv_flow_api.g_varchar2_table(738) := '10A5FF157BE89A1D4644BD307BCC771A4EF4EC0824226841296108218B3E3A6B9D78993E04D147661C49C95EE3BF39E8A6B45874B9B41A215D82324C0BBB8C1F72E840E700CA38443D4E803B1146451CAB16E2E08F5EA9C365A4DDC2E08F33CAE0C946C3';
wwv_flow_api.g_varchar2_table(739) := '363215A144847C08AB8286A0012A7F39A3FACFA70FB9A4BBF524528C21AC76D7681269371481525A21A615CC5D26CDD58ABAF28993EFD2EDA6BC341158B98F91569DBD37CE28A2A911778114D2A9A7294AB0912DEE020399567649F3B81108A88A86AAFD';
wwv_flow_api.g_varchar2_table(740) := 'A3974B6F2F04DC71AFFCE98EA2A126E5B5133E31DF5111EFD9ADD762F54B892027068E0090F5633AB18157190865304CFD46D9250E728AA5299D981709FACF8CD2242225225FE3119F583FD41FCAD1BD381B0E42A266638C70169308AE10EB795CEA55A2';
wwv_flow_api.g_varchar2_table(741) := 'BAB3EE140DFAD40E3539F971299F44392E2550A68A91C04D3E9C1148CB94EE6B6F109315DCF089B404E6C5FC32FE2ECB342145ADC8B46A6A4ADAD8272A332B1D9A173920A38C23D5924640A23355237D89A4D703A19EB4D2200B822243E96015996135E2';
wwv_flow_api.g_varchar2_table(742) := '4020F8048173205356DD65D82B1158210B7D020D15B1A58CCBBE75A37AD21C0DA157AC120CCBD0D00CD425C8990E5851C325B2489352D44D3A8AD0044415354416B627138298E6E8131399D28903E28AC6E6CC8C40462023F0C745404F65DF0DD79D5BCE';
wwv_flow_api.g_varchar2_table(743) := '1F134D383BF8F6C65C1DA9DE4CA7E7D0433AD03B42E7487CEB10142DD1F3C66574C43A41873E51CFEBB86200AC6E0893406FE0A7478CEEF8288AEE955A084244312DD3A57C474562AA477E2482A75A8ED471C7659C9139A4312CCB8FCCB2FC224DDF3456';
wwv_flow_api.g_varchar2_table(744) := 'A4F72A77E9402047B262220CA161DF5A45FA623A51AA15F9893F29294D076934211AE50D3A9244FC235D142D2D3FA91AC8A4CB54B7A839FA320E41A65631FF069913563827DC42BAB3437E282F51342D5DAA1515CB4A11E4630820A0BFEA3F00B6FB2302';
wwv_flow_api.g_varchar2_table(745) := '608F76B4812160F54D36C123A6A38EC7ED268BBE69E2F4121A923DD286BFD41F8674451A8F313B3EFDE0D23194D0F0E28FC3B4AF1DE33102DE34D8B3A08C404620239011180E081834BD29732D01F0B7EF565D5FBC521441C5586A4BA169DF04D12933D4';
wwv_flow_api.g_varchar2_table(746) := '48977D1308B80B919F1289ACA215C8E4D3C45146A0284ACBF2FBB9445F262E71E89B48947D6B1191E88BE9324A978EA44F4A278453D10D4A248949C9A2E8621A65B23788FBD60D258BB52E97BE41E6242B12FF50D2391229BFA898CCFE2F53AD9C18DA08';
wwv_flow_api.g_varchar2_table(747) := '68E17610B0B1ACB50C6DABAFBB757DBBE2EB2EE28FCB908136918A7EED5D324297296337814DADCED196CA4A6FF74BBBA96DB2F58030DF71BB9B93F5CF086404320219815B10816B74C36E54007CAB21052647785DCED2348CF3ADA66AD627239011B865';
wwv_flow_api.g_varchar2_table(748) := '11D069F0E973D771CBDEA05B4731038D28D78B396541A07C1BB4E49B532BCE18DE3A9ADF044D18EEB00C7E1364651119818C4046202330C41048A1DCA0ED1A2E01700094E3DE4137945C312390118040442F198A8CC0401010E8FA56425F4A23510C467D';
wwv_flow_api.g_varchar2_table(749) := '8B86498E49016F3EFB0CC430B1379B9911C80864043202D71701AFD8786D6DD03C8757003C689872C58C404620230001EFFD7AA7A36C3F7C4626239011B82A043C411EA5E277BFAEAA7A26CE08640432021981618E8005896B412007C0D7825EAE9B11C8';
wwv_flow_api.g_varchar2_table(750) := '080C3B0486F9DADDB0BBDFD9E01B8000C7C516E8FC36C10D8036B3CC0864043202431F81BC057AE8DFE36C614620239011C80864048618021681ED5ECB9B2986D86DCDE66404320219819B80C01F3F00BEF42AD3B7DF28BE0936671119818C4046202390';
wwv_flow_api.g_varchar2_table(751) := '11C8086404320219818C40462023901118040283DF022DF83677EB571CF286C041E09EAB64043202B720027EB17C805AE9007D80C1364E1DA0B423AF650D10BA4C9611C8086404320219818C4046E08F88C040BDBDBE2A26B78FE7D7B734E76404320219';
wwv_flow_api.g_varchar2_table(752) := '81A18A804ECF8FBBEED8B1E3AEBBEEF26BAE67CF9E3515E8E74FC5C343D5E46C5746E04623D03B8DF4CD44924F645D717F5991DE6C9419A8FEA7E38BF4D7680BF51C98C41458FFDC505ED196FE3944E9259903153A108683A6094D18D57F8F57347C2037';
wwv_flow_api.g_varchar2_table(753) := 'A81F7D92ED6808755951F4354AE947815C9411C8080C3104061F0003C2703276ECD8BCEE31C4DA44362723306C1118F827F5DBDADAFEFEEFFFFE4FFFF44F9F7AEAA9E3C78F9F397366D1A245819B2E315C6D977C4469E7C8E4B7C9BCA2A71E7CF2392330';
wwv_flow_api.g_varchar2_table(754) := '7C10F098F826968924BF8DE479B970E1424D4D8D78E6720824FAF8A1A973E7CEF969E5FEE9854CCDCDCDC82EC77380F9445FBC78D1B497C779C68C193E0B4FE17EEAD6D7D7F394FC2656FF64FD7088A2868686C6C64636CE9C39D35E956BE47645719723';
wwv_flow_api.g_varchar2_table(755) := '6075535313C07DC49B26D0A848898CE1EE4E04A5A74E9D9A3C79B22A83501B2B86339F2CE92953A6C07FEAD4A965A25D9E3E7DDA8CA49633082915ADC89919818CC05045E09A0260A0E45E66A8B68C6C57462023D00F02112A1F387060C9922556833964';
wwv_flow_api.g_varchar2_table(756) := '7ED774FDFAF5BAC4FBEFBF9FBB565757C7FF5BBC78F18913277881F7DD771FAFF18B2FBEE0C0DD7BEFBD1CE2DC79F6036F2E1A860878823EFDF4D355AB569921FAFCF3CF9F78E209C1CCE51E13D18E2079FFFEFD8F3CF288F4C68D1B1F7BECB149932645';
wwv_flow_api.g_varchar2_table(757) := '0C2C96F6A0A53402A197E8FACB2FBF7CF8E18785AC4AC5C3984B28958E9072805360C78E1D3B78F0606D6DAD38D0E31C82A89DB8057F9C1D7A03971E796912632E2C88E32CD371C53BFED5575F81082B86DC79E79D8462888323DEDD6045AFBC4B873486';
wwv_flow_api.g_varchar2_table(758) := '41238D267453C8466755642A2AF2B9A20E2AEAC76C7E09866E90090B9C55C48A15B8B98C5237C54D8C190DE1AB6E10F28393AB83DDB56B97F3C2850BC5B7E7CF9F170027CD49BC04614F4C10B82FF4A16A52491A01AD0682F31541C80419818CC01040E0';
wwv_flow_api.g_varchar2_table(759) := '5A03E02100413621239011C8085C2D025CAB050B162C5DBAF4830F3EE09371C57857BB77EF3E7CF830FF8CB7B777EF5E2B1EFBF6EDE3AAEEDCB913E5279F7CC271142DF3C51F7AE8211CAE5668A6CF080C61043C179E8E77DF7D5794122B87FD182BA411';
wwv_flow_api.g_varchar2_table(760) := '075A578CE8EBD0A1439E29D53D80724C3C89854E9E3C69DD75FEFCF9E2617355967FCD46E169BF86F55BAB97E2378FAA5A16151589CDE6CD9B17D154FFA20560E23A9CB76DDBA61FA0B02D21D3A74F37ED859B8428D1599A92EC7220A0AD085045712C89';
wwv_flow_api.g_varchar2_table(761) := '26C8A4E929600B2BFA11AA7B41A9ABC153F8AD3F210B9F69D3A609AD99AFEEAC59B38488240A71EFB8E30E1031CA254B89208E0EBA9D3973E660228057511550984A104FC29C947E7488A23D7BF604C25025024F384B60056D36B25DD7377BF6EC23478E';
wwv_flow_api.g_varchar2_table(762) := '4046294101825B406DCA50895C16D1DF9A7CFF71A95270D110E708805564887B0701B31EF4C71FE014A3835909A56451493E05D8AB5B46E9B27F5957343F13640432024303811C000F8DFB98ADC80864046E36021C298BBDFC48DE274F9A57ED35602E1A';
wwv_flow_api.g_varchar2_table(763) := '7F8B03CA637BF2C9277FF5AB5F397343799F5BB76EE5B672311DD909BBD9772BCBBBB511F044888B8437BFFEF5AF4553AFBCF28AA8C993D28FD6669D84580266618FE7CBE5E6CD9BAD090B7EC439AA7BE2443ECF3FFFBC6753D02860732958B232294612';
wwv_flow_api.g_varchar2_table(764) := '50590D7EEBADB7BCC9AFBAF5558FA7E090F47E8446111AA12C29840A862D4E0A860563A6BD4811FBC55E6B7209A29EE88B020ED5BD2B217EB36EFCF1C71FAF5BB74E3CB962C58A7ED6BA934476E1C02E4A8A33B76FDFCE1C511F71B69608DD057836A144';
wwv_flow_api.g_varchar2_table(765) := '6C899892A60368A8FFD15329424C1F1C54079DDD2BD12F0962F557D03005D07FD7E48EE8EE5E78E185885A49D9B2658B189B2C9CE9608DDD7D2457208A9B3DC9478F1E5DB9722533A98D18FE00B1CE6FEE40FCEF50B77FA1D136EC36871BEB7080B38AF6';
wwv_flow_api.g_varchar2_table(766) := '0BB0C8ACA2B3B8FA99679E31CD21A2DEB06183525AA1540B38AC03DDD34F3F0DA22BDEDC4C9011C8080C07047A37AEE423239011C8086404AE1601CE1FB775CD9A357C6E3E1C074B82BB197C385EE1AA729491711CF97FDC62CE9F7509F4572B2ED36704';
wwv_flow_api.g_varchar2_table(767) := '8630029E08AB979EA0071F7C50B4265E72D9FF63222E72C024E264519C00D853E9B0BA1891A700CC2BFAA23201A778CFE3297EB353436C864080240214918A5A31C101B7FE85C62D20578C27DCB2D4ACA2692F013029223404D8862041A66850182C5FBC';
wwv_flow_api.g_varchar2_table(768) := '87331166C7D0AB2E9332CEFA84302498F7735657A4277417724B6018ABA0AA3341297B69220824DADC9C5EE89E7BEE41294A8F193AA1B8E81744A4A0A780093B0A2070D98FE854840CBD4BD205990499382054070810930224A2C11632E61A049F1684D9';
wwv_flow_api.g_varchar2_table(769) := 'CB6A6A43C64C0188284C0DE7C4B99F0403718B0373413526180AB9996CE6114326C83729E02C00362F60528356D26E3DF32350EF474A2ECA086404860F02790578F8DCEB6C69462023707D10E08DF123B9E95C31BE97846D9096441C5618EC79E6D55900';
wwv_flow_api.g_varchar2_table(770) := '71F0AD8994C309F33A1C079D0F17EEE3F5512573C9080C15043C4D822501B0B8C8F2A627A57FCB3C869EBBB56BD77AA02C09A297135B6A6D00F66E8287CE232922C2301D787A304547E6A7446B424487B8D432A9F04CF0A64AFF72A3D4932EEA33992586';
wwv_flow_api.g_varchar2_table(771) := '2494E6D4C0538E0055C2FAA4F3EAD5AB85886245A5F4B1564967C19BD72214591115420B9207622C6D7535E23DB303CCD105590E35B986A730D8DC0143849764E1A6D4741B40509A830BE9AC569D743A0808BDA0A1AE527CA87AC5E55F86E3C340C1BC90';
wwv_flow_api.g_varchar2_table(772) := '9214970E09073EA487443AB87443955220A25C452E01454F10D181028C72B354BF22E6AA0719E6D2E831A1BF3395DC35375191831A661BC91521AB121A3A5F514426C8086404860F0239001E3EF73A5B9A11C8085C3704C2B50D87CCD6BBF0BA5E7CF145';
wwv_flow_api.g_varchar2_table(773) := '6E1F7796EF153977DF7D3791F658F2C9223CE614F28307E2F05D375D33A38CC02D8F8090C6832326F4645156426814714E45DD158963456E1E3469B1A850D0C65A2B81421D4CC445E22E519618496827D40C7A01A720D063A8A2B75EC54E9ED608925D12';
wwv_flow_api.g_varchar2_table(774) := '5A515C59A6254D21960DDBF8842C098BCCA2508F3671119A622E4D13CFBECFE059ECA5AA2E42BE90D5EC9845DA30A18C7FDF4BDA46B04AFF4D9B36A9CB4C9A074A8452495A8EA812080F3CF0804057706EA19BAA4A09223D5EF465AFEA3A227C62519A9E';
wwv_flow_api.g_varchar2_table(775) := 'FAA8BE72FBE6D8CF2C0016848BB1ADFD461C4BBD980E5024B667237198EBFAD828D8861571CB972FA7A18A64D1416280D30D3487330424684E96BA2EC92588F9826AED87A50C3129E91C6428AD035B9A26778006F63539E764043202430F81113FFFF9CF';
wwv_flow_api.g_varchar2_table(776) := 'FBB74A77930EBD8C433FE288F1C3645EFFD573694620239011B85D10D0BFD91269E5845F55A63397CE3A4FBCDAA70841F295C3D992C303E3644BF0B4B85F9140EC525A820FC74DCF7E5819B6F972B821E041B31F55F0C3BB48B67B64229C9323118F4C2A';
wwv_flow_api.g_varchar2_table(777) := '2D4BA88826A23E6941A6D04E2CE4E192B03C6BB51381184C6824DF432A3A123D2A12892992F044ABE899E5D208A8962D5B866151A532A17189C083EC61A7214354C7107F723171C92E47C49CF2E392B324ADA24B9482371C9C9131BCA2A0B24CB5A28789';
wwv_flow_api.g_varchar2_table(778) := 'EAF8E8949C0965354B5DDAFDEB8D62B633191965485424C15E67C4F271962F2885801E091AF8605E26B1E225FA0030D6BD9DD9054691300E9807ECC864023FD4B0CCAB540E63C9520A3DA502D48A52CA3261CE3A26608E03DCB00D8B28C32E673CE563EE';
wwv_flow_api.g_varchar2_table(779) := '2C8D926EC8ECA577980D118DA3BCE2FD2D139D2F330219815B10011D88172B74DD9E745D509C25748671D651C481321D61884B89CADF1E481D8484FE3D8E087AC5BDE6ED4C19C6DB14B6F625E25B10A0AC524620239011183802FA376B38D62BF49BC55A';
wwv_flow_api.g_varchar2_table(780) := '7A391E95E50B45566F72A7570427A73302578B8068C412A847897771B5758BF49ED3E010096E4DCC2E7157221DDE8B2A5CA2E4CFA041EFD2F31E159D652256B1C8FF72E9F09FA21F28A63171197CA41138E4C4590E86843A27B99748BE9D05B89C44F9C1';
wwv_flow_api.g_varchar2_table(781) := '27D54DB27008CE167EBD87FCE8A38FA2094382461A4D480C6D9DE392AA1229DD8FF4625154C133E11CE9D02D718B8473D4258B5C2A210EB9F2070878702843202EE39C6405676755C832A169B15A7B1309DBDF8E3858E573462023705B23E059F69E8B80';
wwv_flow_api.g_varchar2_table(782) := 'D4CC9A793D337ACE0E3365E6B9221ED60338740E0EF48E30391237760B74880C79FA23BDDEC0E1A65FD0632211E981574F94894FCAC9898C404620239011C80864046E2304BE715DBEA3B2482AF2BF4908C9BEFE92139FA1B3F3DBE8BAB3F3EB8F2DA117';
wwv_flow_api.g_varchar2_table(783) := 'E7FAC3483A2A3A07F165A47C47A88BA243524CA7708EE311315822BEA4CFB75F998AD244532EA0D2751214B5922CB4115473FE2C7216F38BE9A8154C9C93688994AE24B6425EB14A5FBB12B748A44B8C8AC445DD2AC8A89415CA2B099E7119E7A2AC2491';
wwv_flow_api.g_varchar2_table(784) := '08AEB0C5676EA465E170262B31CE7919818CC0B043E00606C0FA1A5F62DC7FE995183B55AC158BC853FF7545A4636A56FFE5237E762E89E9075E3731D70FA62D8B293327320219818CC0A01188B9C34157CF153302198178889C233110405A3A7BBE0D67';
wwv_flow_api.g_varchar2_table(785) := '0752E13AD158D21D3BA2741593F7D749EE20D800D33AE7203CA541C8BA5DAA5817B2379BB6116F0FBCBDDD2E06663D3302C313816B7F966F54002CFAB5C1C9571005AE66257D05C1E61CBF321733703AE83415976C10ACCA742395CA8CDFB5D39BEBB6A2';
wwv_flow_api.g_varchar2_table(786) := '438F5204281138E2AE47695C4AC7656A10BE8C2FF0A643597E22C8898C40462023304004743EDEFE18207126CB080C5B04FA1F704D701BD93D4A1EA88140D4DD53FACBC3639A3AAB4A3779076B4F69C1D8AE7F35B7BDB3E7260B1E082A9926239011C808';
wwv_flow_api.g_varchar2_table(787) := '0C5F04FA1F65AE88CB8D0A8009F68B0246383F9229F8B48AFBD1471FF9FE844F11F80A82AF14F8D182F85E9F0FF4F934A20F2198A5F3C54294F1E18477DE79C7A2B15F3888793B9FB347E9450E5F35F0269EAF38FAB6A18A5EECF1E945F951AA48F534A6';
wwv_flow_api.g_varchar2_table(788) := '8A9945BF84D2E18A5864828C40462023D00F0266D938EE36B6F443938B320219014F4AFF5F54F21CF15DE23C10B87A4AD5174B232E94AA6FF6526C4FA9A5A7AAA7BBB56B4071FA404CC93419818C40462023706504D2F2E7E54853AC773982FEF36F4800';
wwv_flow_api.g_varchar2_table(789) := '6CF0A396AF11FAEEBF4FF3B1C1C7067D1CDFEFD1FB413CBFF2675DD7A5225F94F1152F977EF44F54BC61C306E1AB6FF7ABE28801F2F3CF3FF7F28605616BC8BE97B863C70E34426501B65FA2F3C17D978A7CFADF9B1EDE872E4E09D0045B5206FEA1C5FE';
wwv_flow_api.g_varchar2_table(790) := 'F1CAA519818CC0704640BF64BA6D3823906DCF085C110153CFFD8FB9F110F101AEC82A11FCFBF1A3BA6FF6FA6FAFF05155DDB5D5237A7F9A291F19818C4046202370B3108860F072D2C477061A2ED9E508AE987F430260216844A1F4735022CE12DEC8A5';
wwv_flow_api.g_varchar2_table(791) := 'AE4B7B9F24B66EDD2A2D821506FBC14C73C62A0A592DF35A13F6C93E03A42AE25BEF12BFF4D24B42DC37DE784314ED33D4DE2BB6BC6C1DD8A2B108D952B0AF1D94ADF4E2E60D1022E0886D6875455032414620239011A88880CE24BD8B110472CA28FBE6';
wwv_flow_api.g_varchar2_table(792) := '24025D50EE85121A39315411F08C78FBA97FEBC4C086ECFE698AA5738B173735EDD3CD03FA81DC9BAA54169611C80864048634028244BB842E67A251A61F5FEB72B58AF937240026C087A7FD16B96DC9F6390B4AC5B7D666A5E58845C5B4DE10A6BA03A5';
wwv_flow_api.g_varchar2_table(793) := 'B36DCCF12B23A2594BBE02DDD032398B682247A01B6941B2EDCDC25A9CFD9A9C1DD4A41850FDFE7BAA159AA01142E31F1CF239239011C8085C17046C75D19B61A5CF89DD387176593C82C0D9B298FE50D1354A8F203C445C23AB5C3D23702310D038D3A8';
wwv_flow_api.g_varchar2_table(794) := '8DBF74B1D917D337427AE69911C80864043202B7350265C3C4751F446E54004C6F9FE3B7F7F8E38F3F167F8A7B85A6625D91ADDFA9F3121D074E287BFFFDF7DBBA2CCAB7088C60F7EEDD61303BFD8CBB4BFEA2C0D51E69EF037FF6D9672EADFD8A75D58A';
wwv_flow_api.g_varchar2_table(795) := 'C19537C9E324C84BC215E7039452C0DBC22612AEEA33D4B775BBC9CA67043202371A015D90EE48CF337BF66C1D571C3A9CBE89C8B45D455F676F8BF3B5E846AE1ECFD99699AB5A431B84D0E866593488BAB94A462010D08ACC530FEEA71C328619818C40';
wwv_flow_api.g_varchar2_table(796) := '46202330CC1110DF71B7AEEF20720303605B941F7BEC315B970D7E5683AD939C3C79D24AAFB056D4FACC33CF884B1DC645DBA1D92653151FAC52CBBE653BA27D3B5ACCBC6AD52A640F3DF490285A106B5FF4942953C4C0D8BAF476B166C13F83CBA2458B';
wwv_flow_api.g_varchar2_table(797) := '962E5DCAD72C6B28E25EA5FC5415CB8AF2654620239011183402E1D6EB76704851624AE88BA23B12F1EAE27CB6C0771022A40C89D288150599844B47E407A54BC49113099B687C43C1161845E610D58A8A984838F7ADAE235537026F340890A99EF28B99';
wwv_flow_api.g_varchar2_table(798) := '4A5DA24763EF8C747C8D5F4E3E3202578B80F663C3976F82F80AA6E96C8DEA6A3964FA8C40462023901118B608184444BFBE9D3C6BD62C6FBC5EAF41E44605C0EE13EF8AA236274B73BCEC6D16855AC215DFC65D0C1BC4B7418CDEEEE59456D122301A55';
wwv_flow_api.g_varchar2_table(799) := '14A9FBC8238FA45228482B8D8474EC9AAE880B7F4E684D077C50E623239011C8085C2F04C49065CBB0D1CF38EB8EE240A3073713172168885664EE4F48505F5F1F2F6898A4C3CA54A0E942ABBB2ED198FEC3CACCA02854457CF6ECD9A33BD53DDA08E39B';
wwv_flow_api.g_varchar2_table(800) := '828AECA9416F1F8D4566D37C22E490A5226E5EB68CC05BA78A3F717E1C4EFCAC8AB0044F9D677C543F088C3408749B4488B431F1B5051B76AE176299CFF041402BD2966CFB32FDADB5A72F7D0C1F04B2A519818C404620233068040C223C226E8FF5547B';
wwv_flow_api.g_varchar2_table(801) := 'DF2CA37275B8258366982ADE589F868AA1250362A9B66F14CAC34BDA14D3A96E704897411C99D27D13895B4AA0B1A49C28537E4E640432021981EB8E80AEC6A1378BB384839462F4EB525CAA4F17127CF2C927E60145AD82043DBB7054CE0B2FBCE0DBF8';
wwv_flow_api.g_varchar2_table(802) := 'C8ACF10A214E9D3A65170C3E78FA0AA0BA626671B55A3E25286475181814095655379968D94DB86BB30C628BCF5E03112D8B7B7D64C1C2B5BA78DA6523C0C66AF3E6CD58099EE9E365131DA6EAE61C45C8E216DC7C8F90E8EB8E556638B41130F4DB44E0';
wwv_flow_api.g_varchar2_table(803) := 'EC0B20DA7F7C8C63E00DE9C8B9E6D307767557F5CC993862CE9295A5AA417A2CBEDBBE6BD7C179E3DA27CF5B3EB401CFD6650432021981218600E784D3E25D3343094F869B745D0C1CE4703208D965CEDF20385C4B15A839AE8543AE9B11C80864040688';
wwv_flow_api.g_varchar2_table(804) := '00173FBCFC3847AD625A776491D6BAAB5F7413DF0A5CC599D6782DED8A724F9C38E1937E663DADBB8A8A85A9D666A307738E573944ADD27E11DD782040F58608569860A52E7AF9369DC6DE2181C781030744BF64194844B9F6D408B011C85445146D7421';
wwv_flow_api.g_varchar2_table(805) := '4BF8EDFCECB3CF7A57C50AB3B805BDB5E2011A9EC93202450434667BB8ECC08A4CAD3126838A34D2DAAAFD0ED1C2D1D87A20BDE7D4C5CD1FFF61DE84119DE3A7D59F3E3367E1B2D2A8417A2C2DA5D25B1F6D7D695E7D0E80CB90CF9719818C4046E05646';
wwv_flow_api.g_varchar2_table(806) := '80E364467EC58A158686BE6ED5B5683EC8E1E45A44E6BA19818C4046604822A077E6DF3B22912E23C7A5230C97B03C2B4CF50BE72B57AE149D0A687DE0207EE6CD82B0555C0BB6DE22F9C31FFE60F555A48A89BAC6001185C0D8CAAD5945ABBBD6729189';
wwv_flow_api.g_varchar2_table(807) := '31F0141B6FDCB8513C2C0646A3A2E059986DFC20CB66693BA2E50B7A63D1182B87655EF9BEA1A008379AE013EFFDA2549DAAFDFC1AC190BC95D9A8EB8580E65464951E8162A636F6DE7BEF69CC1AF9F2E5CBB5E7AEEA116FAEFF6AFE996DF73EFDAFDA46';
wwv_flow_api.g_varchar2_table(808) := 'D454B53476578DDC7BA4FEC2D943E3BA3AE7DFB7FCABAF4E56779C6F6B2FAD583869D21DCBF61E3CD3D8707C7275C7CCE52BBFDA7D7064C785595327349426B7359C9C38B27DFA3DABCE9C6B6C9B78AE2834A7330219818C4046E0D64780035354B2E220';
wwv_flow_api.g_varchar2_table(809) := '52241860BAF74B27F9C8086404320219816B41408F2C1C1525F2E01DD27119399176262296B92490596EB566EBF510D1A698534CCBF5C7CA64A740548E6F1CB89C376F5EACA1455D8BB7C60369B562AD4CF060D15890ACBA28427521ABC896146FFF3A5B';
wwv_flow_api.g_varchar2_table(810) := '5E13CA62E873FADE01466F2998DC2D5BB66CDAB4891A764A0B895551D176235FEFAFABABC3C7DAAF58DA3AB3C01B9F7C6404068E8026EA28A3AF9869A6C64603ADD12E06DBDB7CA5ADADABB4FBC0E1FB164F3ED3317EE3E62FF76DD97CF8CCD9D75F7D67';
wwv_flow_api.g_varchar2_table(811) := 'FBCEADAFBFFED6DE2F37BDFDDEFAD3BB377DB2FBCCF60F7F7BE0C4D9B75FFBFDB62FBE78ED8D370EECDAF6FA1F3E3EBD6B8307B2B1AD7BEB57077EF7DB375ACFEC1FE10714731B2EBB19F932239011C808DCC208541C2F2A660EC288BC023C08D072958C';
wwv_flow_api.g_varchar2_table(812) := '40462023F01D047AA3DEC2A14CB82B764D7902C80880533545024E1F0514F7C6C79C45CB3627DBF96C3DF6A9A79E12AFE2E083F9025DF1AA777731B1717AD9B2659848583A56A4AE255C2184355EE1F4134F3C213CB67A8C40A86C5DD725CEA42010067B';
wwv_flow_api.g_varchar2_table(813) := '55183791AD681943ABBE12327D498B5C5A09B691390B45D4B52E2D1AA749D23C2732025744808FA299998E29A3D490343347315F4B7BEEB9E7B4408DD90F288A54C5CDA3478F39D77061E6C8EA33553507DFF960C9AC3927B6AD5FF5D3C78F564D6C6DAD';
wwv_flow_api.g_varchar2_table(814) := '3A5F7F76C9DD93F68CB8F7D047BF383BFFC4E9AFD63FF3931F1C1F35BAB9ADF3FCF9732B1F99557DC7F2B3EF6F9A3CA966E3E98ED6BA3DF4294ACCE98C404620239011B89511D0699BBB3723DFB7F78E15826B543E07C0D70860AE9E11C8080C6B04448C';
wwv_flow_api.g_varchar2_table(815) := 'EC17613A9705BD11FDCA978860B888941CC1A70D9FEA0A41A3BAA05730808F55DFA8EE37E414F92455705024E88D88D4FA301AEFEEA2518A8F88D73A301AB1AE5A32630DF9D1471F4DD5ADEB1A4E42551FD6922FED979C22AEF60230D13E7F150C052A68';
wwv_flow_api.g_varchar2_table(816) := '101054543EA73302FD23A08D0968B92F657B073424F33EDE2D2FAB6EA6E6A5975EF22BD9DAB0A23155A5A757ADD8B279F7A347B69BA519337AE4E4F1B52327CFE86EBA307BEE9DD3674DABAADA3666CCE83123C68AB1278F1F5D357E6A55EBF97977CC9D';
wwv_flow_api.g_varchar2_table(817) := '3073F688EAD28409B5FB5AAA3EF9F08355ABE6F58C1AD9DDD15EEA1100E7499C32D4F3654620239011B845113088F83C84CD683CA5A28A06115BD5384BC5CC41A4BFC37410F573958C40462023306C11D041EB8B233E9470443C0990B84C676180741950';
wwv_flow_api.g_varchar2_table(818) := '1164067114251A3C232712825E4BBB911342A555770E115154949E72248A0B7111AB4769CA8F4C9CAD242F59B224E56398D251259F3302034440A38A7655A42F36D762BE07E4BEFBEE33B31399A3AA4AEB1E58F849CF0B7E427852E7E879CFAE593A7F51';
wwv_flow_api.g_varchar2_table(819) := 'FD8B2FF6B41F1E59D53365DCD8C756AF1A3FA7F69EAAB1D58F3EB7FCCE3B5ABFF77277E94C4D75F7F409639F5CFDD0E8E953E7D456AF5AF3F0F409D5DF7B6CDCA4198B1F7DB073FAE4DE5F4FCC474620239011C808DC1608C42092FCA2A47359489CF2AF';
wwv_flow_api.g_varchar2_table(820) := '2A71F30260C31BEF8A722C09BF6D208AA28C5A0321BE6569C2DE2B1A92200A43AE0AA81B61FB00D5BE11A233CF8CC06D848047351C7D89E2C104E1ABE748A6749C076DD7153B9041734E15A96AFDCDDCEA35AA9A18E6C47046205A6C59BB2DBB2CE293A2';
wwv_flow_api.g_varchar2_table(821) := 'DFC89C3876E433ABEF69699A575DEAA9AD1935AA66DC7F7727120000400049444154B34FAC6CB9B8704455D7B8F1E39E5B3BAB6654D543A551A5D9FF574DEDF8756B1F6ABDD834AABA67ECF8F1CF3FF344CDE8EAB12347FCC9F36B7B3A9A7DD8ADA666CC';
wwv_flow_api.g_varchar2_table(822) := 'BA193DA34794CF4015A5E7744620239011C808DC5208541C442236B9763D6F5200CC06BFC3E11BA412B63FF1B1FA37206CF675163FC5613962F5EAD582C3FEAB5C3B1637828311DDCF93F8B6876D8DEBD6ADF3565E452B22F40591D7FFB89ECC37BDE1E3';
wwv_flow_api.g_varchar2_table(823) := '99B119EC4628D63F4FFAD875F0C1071FD0DF2B88761A6487B87FC472E9B045C0A3515C0186430A7A15393CF2723C53D21551EA5BD4374745DD42C5DEA322CF4167127113A40C5ABD5C7158215033B2AA66F2D73FA1C4F09A51D53593270602F1CB5CBD6F';
wwv_flow_api.g_varchar2_table(824) := '128F9AE03476F488B1A3BFA61C57FBB56333B1D66EEADE0DD58E6FF2E22A9F330219818C4046605823703302607E1BFFCFCF7BECD8B1435CF7A31FFDC8872EAEE863A9E587407EF5AB5FFDE0073FF042DA6D7A9738B23B77EEFC9FFFF37F7AD3CF0E4601';
wwv_flow_api.g_varchar2_table(825) := '705F43D0D8E60E9C3D7BF6F815501FC394E313353E63236696BE22567D795E638EB85700FCB77FFBB72270DBD244EFD7C83057CF080C61048A01F0A598F7EB13938B97150360999E358F58DAD2839B17717DDED9B31FA0E90C7DDDCA04996F53490F6124';
wwv_flow_api.g_varchar2_table(826) := 'B36919818C404620239011C80864046E34023729003E73E6CCABAFBE7AE0C001DE9E8F8BFAE22837EE8A719D77CFAC88FA718E1B8DC28DE3CF4CEE2C2BF8AF15A5F0717D2AF3D7BFFEF5BBEFBEEBB710059CE1F5B25D155F82FD632D0253DBB7D79CAF78';
wwv_flow_api.g_varchar2_table(827) := '9B2ADA95333302C304017D9AC7C416680987E7C511E938C341C219598A69031C9726BFFC54AF8F60997592A9C73005E6C78163C348D495E98788F4A2BE7795F8CB8C238462E552DA194DB00AB9212B9F330219818C404620239011C80864042070330260';
wwv_flow_api.g_varchar2_table(828) := '9ED9F6EDDBFD50871FED3872E4C8E6CD9BAD78842777C57B101EDE15C96E7182CB59219FE67E72F317BFF885385FB8BB6AD52A6BBFFC57C1B015A1E4CBDE7C0343E7D0F0E64BCF123302B70B029E56D16F4C150938E3901939CE0C91999EE5884E93753A';
wwv_flow_api.g_varchar2_table(829) := '463F35E4F51021AE5FE8B5C6AB6F141523B32B44C2AF10F93095D9439FC9F563BF7E28D51CA29FF345EFD3D0A6CFFC721282FDFBF7ABEE13D058F9C523D5957A7F241448E27222239011C8086404320219818CC03047E08607C0DC3E2B999F7EFA293FCC';
wwv_flow_api.g_varchar2_table(830) := '9A865DCD7ECDD2FA865F41E01416D1EF3FE2521A8B276A250F3265CA0917339824B6158913659045DD5445A24C130471F42D925314519140663F07D7D9ABCE7C59BF53F2CFFED93FBBE38E3B2C0411671548481C8B42513D191B97DF28F5F5EF3A94E98C';
wwv_flow_api.g_varchar2_table(831) := 'A6A858AC0E4566C0A83A0239152B868874469334491553694E6404863302E949F44039D2254CA49D233F9E3B8F52112BBDA2B71E1E7FFC71E1ABC36F176DD8B0E1F9E79FB7EF43E8AB6788DF40321DA637F0EB44D68A759E58F992822F0BF88D22F97A54';
wwv_flow_api.g_varchar2_table(832) := '3F1EA36BD5D3FAE119E95DBB76F990557E73A108754E6704320219818C40462023901108046E7800CC57B3EACB69E3DB89F1ECAADDB871A378D8A795AC7086834815643CB9C3870F5B0FB1FBD786C0BBEEBA2B398B4AF7EDDBB777EF5E2B1B0F3FFC30DF';
wwv_flow_api.g_varchar2_table(833) := '4E45A5287981D63DFC82A5B50EFE9F77E73894D64054F1E926F97E3E04B14BAEE1679F7DA62E0E287D5ECB4F14628886B8A2264AE91CAFE35252AC8E797A434FB06A35C6EA0A9EDED353E46B557C5C565049424504CCB15063F5265951B1CDA1270E0D97';
wwv_flow_api.g_varchar2_table(834) := '97C2E24C3994F1B6B0A3A8957DD4DC5F4B4062E6580202A98A41838922A2214C31EB48EC621D6E2EBD5D0C40DAD2078C28FD16E882050BD445606B25CE1C6E1A72AC55543DB4C55F75C67EF9E5970858AA94DCA45845A3726646609820A05BD0FF083E3D';
wwv_flow_api.g_varchar2_table(835) := '951E8AE2E1C902423127825839018EBAFA193B3E3C74BA2C0FF5F7BEF73DDF0BD02F0581E8D7E2307AB1B1B0D693489675608FB3855F4FBA0D239E712F50A84EDCC2850B9D3DD7EFBDF79ECE445C9D977F87493BCC666604320219818C40462023307004';
wwv_flow_api.g_varchar2_table(836) := '6E78004C15FB9F4F9D3A65F9973F6717B488D4D63EA19ADD7AE19F89B2C46F5E82E5B7D9E0C787B376B176ED5A8E209F0F070422DBFFFEDFFFBB9D7ED648635F9F4C91DBDFFCCDDF38FFBB7FF7EF707BF3CD37AD9FD85F1D2FAF722B1F7BEC31DFDCC20D';
wwv_flow_api.g_varchar2_table(837) := 'F1F1E3C7FFEB7FFDAFBC4C31B020DCB2092792FBE80B5B7FF6677F26A8239738D57DFD1881509C532BC7F7ABFECDBFF937A247DAFAA4B3AF79398BBD5DE246C4CB2FBFCCDDE4A7E260D1E6F5D75F17645AC2A5ED9A356B3021BDE22D514594CBA3B50B9A';
wwv_flow_api.g_varchar2_table(838) := '53FB9BDFFCC62E681B2063113839CA741075B34EB46F2D8814B54C10F83C983816738EF56BAFBD4634E5A54914D213FDC31FFE9086B8D976FE777FF777DC65A12C7719F8FFFC9FFF7388014AAD8F3EFAC874804FEC6005907FF24FFE8935A850588E5989';
wwv_flow_api.g_varchar2_table(839) := 'B7DE7A0B99BA02604CFEFCCFFF9C92D4A86854CECC080C1F04E2A57DF3474593D3931B9971E9EC61D417A5521D882751D4EA29F38C9BE18A955BEBBA8A7453E84D1D7A243D7A269E3CD77A1EF12DA19838EB57F50CBA269DAADE4C450FBE99BE9892D357';
wwv_flow_api.g_varchar2_table(840) := '28CACF69F1D6E4744620239011C8086404320219811B1B0073EC04B1EBD7AF97103871E9045DE23D1F4616154BBB018A9CD1FCF55FFFB5F50D9F3E9E356B562CED0A59F9857193B8891C3E719A8A4B972E554B5C2790E6115A1BC13362398EA3AF165B5A';
wwv_flow_api.g_varchar2_table(841) := 'E10EE2F9F77FFFF71633C581E845A4E243619E00152B5FA216398BEB849DF616FEE99FFE29596A791D57A829C2C4875BA996E05C54A9D4222A2545AAD69005F3565D44A4024BE27EF2939FA8429F20501701D7D3D20DA161631852765664315CC0BC75EB';
wwv_flow_api.g_varchar2_table(842) := '56AC241EB874A84E220E0808F2356C212EDFD7A7A4198EECEDB7DF66CBBFFDB7FF968FCB7516B1CB879E3318ADB15B5C82E40B2FBC40220E1C65EEB52ABC6AE16BB8C8C8CC20A0B432EC4D4212D54D0B502E192EFA0597EF9631C412BA8F99612B06A658';
wwv_flow_api.g_varchar2_table(843) := '72E5CB8CCA971981E18080F6EFD9D73579220662AFE7C87A6F44A41E1F0F9A07535D7C3CB67A304FA2DECCCC9DBE51A6DE0C735D90B0D96C9A4BF9AAEB00754D247AA8558C594564D15DE8C474509E5C01F000151B88F2992623F04747E062B3E1B8B9AA';
wwv_flow_api.g_varchar2_table(844) := 'BB73FCB8B1A3C78EBBBEFA34B775953A9B6BC78DEBECAE6E696E9A503BA6A9BDAAADF942A9BB6BD2F831236B265C6C6E1B5DDD35AAA6F6FACACDDC320219818C4046E0E62370630360CE9970518C2AE212D671E9AC9472CE2C6B08BD2C335AB2E0080ABA';
wwv_flow_api.g_varchar2_table(845) := '44A116435E7CF1C59FFEF4A742569E9C80F0BFFC97FF12CE22CFCF3E644BB5E249F9DFFFFEF7B9923C3CF198B3A54ECBC2C2D4679F7D56882820C4534CE88CAD1017DB10C45BE5268AC3FFF13FFEC7A4585771F9E1871F0A95D1D86D88A12A080478424D';
wwv_flow_api.g_varchar2_table(846) := 'DE2AD1FC4841234A91B31566A1F2CF7EF633FEA80519FEE85FFEE55F0A9805B1D69011308D9EFFF25FFE4B0A5340CCFC9FFFF37FC6E472B736DCD9BFF88BBF0011E9EFBCF30E0305E716CCED1867A62874DBB66DBFFDED6FD9F82FFEC5BFB0FA2DC7EA34';
wwv_flow_api.g_varchar2_table(847) := 'DFD7CA2DB9606497B3EFE258FF2194636D068156167E6DAA442FD3BD6088757596B24BA6E5A37FF8877F104B3FF7DC73AFBCF20AFEC878CFCE495B0EBA8A6E0A73CC17606BB11ADB1FFFF8C7504A6439911118B608789A4C270DC47C1DA023517A06CDDC';
wwv_flow_api.g_varchar2_table(848) := 'E99A74021E617D976D1D7A214FBD84524F747459CE2E55348DE891240E1F152D0BEB9A04CC4A4D7EE90C3D95D298E0E932FACF2431273202B72F029DA5D21F3EDE3BA27E6B69FABCDAF3754FBFF4EC889AAF5FD5199C51F5ADDD170FEF9AB76C49A9AAF7';
wwv_flow_api.g_varchar2_table(849) := 'B782DFDF7DBAB4FFDD977EF4F2D1A689EB7FFFD64F5F78E0B52FBAC79FDAD033694EEDC5334FBEF8BDB7DF3F72DFA4E38B1F7FA9AF384FF5A9D30DD3C6748F9AF8F54F06EE3A757EC5B4EAD2C8DE89AA73675B6ABA9B6B675C9DB61D66B80E1F9B3D7B4A';
wwv_flow_api.g_varchar2_table(850) := 'F5E8DE90FBAB9317964D6819316E665FE9D725C78F6D341E393A63FE5CAB12FD303C79B16762DBB1DAA9F3FAA11944919BBB71D381495D07EF7E6875D5A8F183E0D0B7CAD996CE11678F4F9EB72015B5F794367FFE554DCBA9071F5A551AFDF50F4AA752';
wwv_flow_api.g_varchar2_table(851) := '8933E75AC6B4364E9833A009CD62C5483777F534EE393EFBAED9A552EF27FDAFF6D8B6FF74C3C1AD8FAE9C7772E492FDDB3E5EBD72DEC4594BAF96C9E0E835E063A7CFCD9B322A5AECE098E45A1981DB0B81AFD7576F84D2E228819F95495BF22CB15A20';
wwv_flow_api.g_varchar2_table(852) := '1571459AEB6635D2DE5AC115774D38E7921B27B20D974E746A33B0602F3970AA0B2CED06144EDB0EADA205492BAEFC3F81A24B9E9F77DE2C8C906285D9DAAC181873D1B5B02D0CC48D687132CE2885AFC272CE25569C4587B03CD64FEC2E16F2616EED05';
wwv_flow_api.g_varchar2_table(853) := 'B17057F42896C62782400BA1964605ED443BE3A0A2D56912C5A2D64B99A3BA68DF714578ADE1FCD37FFA4F6D4B16AF62682BB8FDDE22730AF374C9251D0266136CC0B6142C24C6932B2C7C05325884EBDC622FF7C244086D3A8026D0A66D04B4F850E9A5';
wwv_flow_api.g_varchar2_table(854) := '975EE2738B9385EB5EEB05943522CBD714088579E16E5672D3812314B73E0C2E38F0BFC9F532703FFBBAAF686C26C8080C25043C2C9ED3811CE9B162BEB430D5C3E8F995D6E359FB7516FDBAD49B79DE3DA4660CCDE8E985824C1599426EA5E8CD9AA982';
wwv_flow_api.g_varchar2_table(855) := '1BE97A1B947A2ABD813E04814451E250C23CDB320C11F0CACDC6AD07BB8FED1C396DFA5B6FAC6F3BBBBFBDBB74BCEECCF9BA537E62ACB5AB74B2EEECA993271BEBCF74767634D437F574B535B7775D6C68F0B435B5751B1C2F9C3F0BB7FA8B1D274F9CA8';
wwv_flow_api.g_varchar2_table(856) := 'AF3FF7F18E43EFFCE66F9B4E1DF200C9DF7CF0FCE6F51F967A9A4F5FECF9E0934F4B174F7EB4FD78CFD93D63A74D7FF5F79B9A1BF76EDA7AB86EF716949DDD257E4577474BBA0BEAEFD87378EFAE2F7DA5BDBBA3ED547DD3FFF7D6A707776EBC70EAF8D9';
wwv_flow_api.g_varchar2_table(857) := 'E6B6F73FF862CB3BEF9F3A76A0ABA3F5425BE751A1C6C95EA16DDDA543478F9F3874B0A7B319ABE68E9EC68673A18CCB230DED5F7EB1B5A7AB57CAD98E9E2D9BB776B73736B5771F3C78FCC4B143A5EEF6CEAEEEBAFA8B870F1DEA6CE9FD7E475347E9E0';
wwv_flow_api.g_varchar2_table(858) := 'C14317CF1EA7CCE9BA86524F7B634B57532FC36F27DD909D6C6C3B78F0404F6BC3C58E52E3993A39E7CE5F6CB9D8B8FDE8D9F75F7BEDE0815D6D177A512A1EA7CE371FDABFBFF9DCE9A68EAEB737EDDFFCF16BC70F1D2C755E6CA5BFCFB61C3A74E12C3E';
wwv_flow_api.g_varchar2_table(859) := 'BD18A6E34C7DEBFEFD07DB2EF6B2BAD8D07AFCCCB9E3470FF5AAD4DA75E0C0D1BAE3874B3DBD5ED9E9C6B6FD070E369FAF53F9C4B9E68D1F7CD07EFEA47C8BF1FB0F9F385777AC4C79450DAD9D07F61FB850D74B76A6A9EDD0BE7D6D0D67BBBA4BA7CE34';
wwv_flow_api.g_varchar2_table(860) := '9E3D73BAEEF4E9CEE6F38A30FC60C791E6BA3D36C6D49F6F3C74F0686773A38588D3F58DEF6FDCDCD37804CDC58E9E83870E9F3E7AA4D4D3FB5B9B82F0CF361F683F77A4B3A774F4649D2FB974B436E0D374B1E9E0D1534DA78EA3D1E4F61FAB3B7BE230';
wwv_flow_api.g_varchar2_table(861) := 'C5CE353475BB9FDDA5F375A7B540A59FEF3B7F76CFB6E68E8ECE967A971D3D254DAEB9E9A2B47BD0D8DC7AE1ECF99E2E6178A9A9A5B5D4D52E3F1D177A4ADBDFF55E5E5D677B53535BD7FB3B0E1FDAD3EB70223E5A577FECD0BE9ECE96E6B68EEEF6DE1F';
wwv_flow_api.g_varchar2_table(862) := 'D46CEDEC69BBD8CB361D0DCD1D070E1C3973925DBD9A34B4761F3878F0C21900222EED3F70BCEE84A2CE16E943C71ACE5CB2A5ADE3E8D9C693870E7677B71FA96B7CF59D8F0E7EB1B1F1F489B25B9944E4444660882170035780C55D06098128C804A5FF';
wwv_flow_api.g_varchar2_table(863) := 'E37FFC8FC02E76D82AF2166E2C7488EEC472FC3931278F8D33E7CC81E3D225B86522B6F74FD82606B636E26C48135E0ACC900977BDBB2B32C45F288B9E0841A074315AE35FF21A438A5A44A01125A217340A65C9F5D22FDFD1926F928EC672B183511410';
wwv_flow_api.g_varchar2_table(864) := '7646113E3C54A53C4EE2C4C03C54BB169562E84C1C82084113B7BE097CF8B52273A12658AC240B626DC6B62D99532BE027428C2DE44619D5190531FC5DDAD8FCFEFBEF0BBFC1486D34D68709653BBF39E8E9831529120E0CEDB7440C735E786496292693';
wwv_flow_api.g_varchar2_table(865) := '39E9A6A8828333FE8E32E27C99111826085CC7C61FAC9CEDBF809E8E28E554043389D6E1E8039DF50341999EF48A15736646E06622901AEA75146A5DD25EA68BED9D635A9AEE5CB1A073D4F84F37EF6F39B7ABF944E3334F2FDADE38A7E3C0070DA3EE18';
wwv_flow_api.g_varchar2_table(866) := '7376FB9AEFFFF89D3776BFF2FDB9DBEA67756E79FB9E1FFD68FD86ED55CDA79A1B5A1F7CECC14DDB77CFA9E99AB960C98E5DC72FECDA7AF6C8DAF1B317E36DE1B3AA9A90DEC33057EAB9F4667E7B674D47D392450B7A9725AB4E79654BE9E9D6D23BAFBF';
wwv_flow_api.g_varchar2_table(867) := 'F6E327EF1AB7E0A14BE4BDA7C3679A0F1FDD3466D2C9350FCEADAB9EB365CB670F748EB97FF9880B8B6B376FFB7C7AEBE1EA6955B51327BCB9F1D8D8867DADA5B617D63EFC65FDCC039BDF5E3071CAAC198F568DACDD51D77AEAE35FFEF0FFFE59A9AA77';
wwv_flow_api.g_varchar2_table(868) := '47C9F6DDC7E6D7B4568FEE4DEF3CD030A9E9D888710F34B4746DF8ECCBEAAE33EB1EBDFBEC88F95B3EFC70644DD53DD33A173DFEFDCDDB0E9FD8FFD994313D8F3DF1E0E62D9DAB16557DDC34EEE151276A273D2E22AB2EF57E3AA4AEB9E7A34D9BDB4F1F';
wwv_flow_api.g_varchar2_table(869) := '3E396BFCFCFB9FDEBD69C3BD0FDDB3E583BA071E9BF2F9EEB6039B378F9C397ED283778F9E30ADA35DC7D23D7AD4C8F3ED3DEFBCBE69C28863ABEF59D13672E296AD3BCE356EEDEA993573DA231B779E6F3CF6D117A73A7F7867F5CA17FEAC17C34BC7C9';
wwv_flow_api.g_varchar2_table(870) := '0BED9F7EBCB9A3B9AEAE76F483CFAD79F3777B6B679D6C68E878E9913BCF4C58B969E3E7A3AA1ABFF7D87DEDD3967FB8714B4FE3892757CE993969E6C3AB17BDFBE58C8E96165EE907BB8ED6EDDC58D3D1FEBD271E9CBC6045B075AE6FEB59FFDEB6D6A6';
wwv_flow_api.g_varchar2_table(871) := 'BD0FCE9FDB5A3B6DC3BB9B3A5A8ECF99307AD28A07D6FF614BE7988BA3C7543D7BE7D8B90FBF72B2B9D4B07BEBE4E7EEDA79AAE9AB77DEB471BD715ADBCA275E58FDE0DD7B8E1E2BB59A16297DB2FD78C3EEB797CC9A3B63F6C4D2C831871ABB9BF66E9A';
wwv_flow_api.g_varchar2_table(872) := 'F0D033A2E12F761D3C737CDF835326CD7EEED977DEFC70D4C89EDAD60B6B5F787C7BC3B83D9B3F1ED1D9B66E4DE3DE864973BBB79C1FB3A67464CB037FB2EE62D788831BD6BFB06AFCFE731DD34E7DD231794DFBD89EE39BFF3066E29205CBEE1859D5B1';
wwv_flow_api.g_varchar2_table(873) := 'EBB373EDA3BB1E5D5CD535F7A1AD9BBE78E6D105A5115FAFE79F3CDFFEE6479F1DDEF4D6932F3D3476D2AC3B6BC6CC5CF97843F347E2DFBD271B766C785FB4BCF2FCFED6518BA78FE83C3F6E8A299EC9753BE6AD7E312173B2A175CBFAADB5239B9F7DF2';
wwv_flow_api.g_varchar2_table(874) := 'C1AA192B366CDCD87CE6C8030BA78D9936F7836D071AF76C9B3777ECA49953DFDB71FCCC9E4D5EA7F9DE738F6D3FDC75E4E0E7233BBB1F693AB0BB79A11996594D352B3B464D9C313DDDCAC43F273202430F811B1B005BD7F579182B93BC347B83635014';
wwv_flow_api.g_varchar2_table(875) := '98093B4568B6137B43D50A8652B1967C4771E0949910971FDBA7C587826ACB9236E2F2F9ACFA5AF440196F11EBE22D08A314E959DEB4645A64885B5F29490426E14DF60E7E973914599A1679267733188A1205A8614584888981CC321D529144D227EAE2';
wwv_flow_api.g_varchar2_table(876) := 'C3156685B79D296FCB770AD705FF363C17E5626BC116136BC5DE3DB648BB7AF56AD8B25DFC2C4A2F938BAD15DDC824172B69091CCA2893863C6C472A4D5B3113414E64048615029E6E4FC17537B9FFC7B0AF38F4F10E427A36FBD2E49C8CC01F0B01A3C6';
wwv_flow_api.g_varchar2_table(877) := '75176DCED5D7E2CEB6751E5EBF7BF5ECAEFAD1B35EFB875FAEB8B3F1D8D1B659539ADEDCBFEFA78B4FD74D5AB5F3B5BFBAEBC9A7D67FBCE3C76B471C383DBE6BF3672D0FAE79E7F557EF5E3EF3C89E73E367D66E58BFE9FEC9557317CF1F3B614AF5B8EA';
wwv_flow_api.g_varchar2_table(878) := '0933EC77ED1D0447F81107FF2F392155848D101097EA9BDAF66CFEEAC9699D63272E28F5EC89DDC1A3AA4B93264EAC1A3536D9A85E674FF5A2F1234FCC587474DFA6F98FAE987AC7C2454B474F983567D4D8D1F3E72CB8A3AD7BD6DC456DD5355F7DB5FB';
wwv_flow_api.g_varchar2_table(879) := '470F8CFEB87ED1A93D9B76B53D7DEAC8C13BEE9FD4D3DD3B4F5D33B27AFC84C9A14C5D5B4FCB973BEF79F9AEAA11352D5D3D87B7ED59B7626EF5E889478FD7EFDDB1ABA5FDDC82B1172FCC1C573A7278C10B6BBF78F50FA525A7DF79F3B5B1239A76B736';
wwv_flow_api.g_varchar2_table(880) := 'ADBAB37AC2CC277EF9FB37C64E6E1DB7F6B9BAE6EE4F3ED930B3EBF4136B9FDC7260C4A6F7DE18573BF6C881B6FFE7C1FBCF8F99F1DFFEE1D5B513A78D1DB770C1BCAEF63B662F5ABC4CF45BDF51DAF0FE96EED6132F3CF540D3A839BBB6EE5B755F2777';
wwv_flow_api.g_varchar2_table(881) := '61DCE8EA3B162C5A747EF69C858BBA47D57EFAEEE6E5338EED3E3576CC122E532F8671ECDD5FDF75F4E092D577BFFDE9F185E776EFDE70F8E5BF185B3B7E615747D591330D7BBFDADDDC7C7EE9948EA61993AB4F1E5CB87245EDA429EA4F9D32AE66FCA4';
wwv_flow_api.g_varchar2_table(882) := 'EA52757D57E937FFDF87774CD87DB1AEE7A17935C500F8F3132DDDC7B62E5E75DF842953779C6AAA3AF2E1C2C75ED8BDF9E0A8A62FDA8F1CDB316DE4F2C923CE1CDE31E7E15776ED3E79EFB8B6DA994B0F7D71B6E5E0EE3B5FFAE18E4F5FBD6BE57D53A7';
wwv_flow_api.g_varchar2_table(883) := '2F1D3B7E8AA90E7778DB813363EB8ECE9F33B7E47B0BA5D2975FECBE6751F7E8A9F3CFB576EDDA7DA4FECCA1AE0F1A9F7CEAA1C3DB773EFFA3B59B76B41EDFBBEDB7DB6B6A4F6EAA6BAEB96B7AE7D4A5DFFFD57B67C737FEF2F927EE1731EE3FD930ADEA';
wwv_flow_api.g_varchar2_table(884) := 'C0D4A57FFEE5C9AE535B8F9C9FEA2B86A34E9E6D686A387AEAECC9E973AA9BF73677AEBEFBE0CE2DDD6397371DDA555AB3F41BC04AED5DDD274ED6578D6C18593DBA7A740D9C274D9D5EAAB7BC51B5E1ABA32B6AEADB66DCBFF3F38FC74C1A71B2D47EB6';
wwv_flow_api.g_varchar2_table(885) := '6D67CDF4D98F940EA6EA6C3978AA7EFFEE3DCD4DE7EF9B5DAAEB5978FEF8B6652B1E9A306DC28996AE235B36ACBA7FF194A9E34FB554FFF6EFDE993BF548FB89CE47EE9FB167C7B80535F517173EB8E3CD7797BC72F7ECB9F3172D1D3769A6A9D8CB3AC0';
wwv_flow_api.g_varchar2_table(886) := '49624E6404860002D7DF930B50F867824941A93549FB66BD371B1E9E52090BC2FFEB7FFD2FE1B118CF765CF1AA9546EBAB36458BF78283EDBBB6462788F9795C4FBBA07DC4D8DAAF8DBE0E9B7531C7D04AA6E55FD5BD7CEBF55DFB9C0DC0563853F58124';
wwv_flow_api.g_varchar2_table(887) := 'D4B21F185B8AC54FFE442D81A24360E9B0C62B62F7D26C91A1522BB12CB56E2C0C16B55AB90D0F40A64BC16D913EA5696ECDC7023804B8B30111335DAA6EFDD6C1DB8E18588ED85E949BAA932BD3C2B5E55FABC4DEE385334DF0015145CF38654A88B431';
wwv_flow_api.g_varchar2_table(888) := 'F7A5315B7D6C818E22676C93889CC808640412029E0EB348B1EB3865E6444620235086408C656599D77EC9A9583E6B7CE33DAB37BCFEDF46DFF5D5D99327EE5C3D6DEEB247C68EA9AADFB8FE8E87279DBA63DE819163478FA8EAAA196BE76ADBC5E6513D';
wwv_flow_api.g_varchar2_table(889) := 'DD758D2DED0DA7562CBA7FE19C15B367CF78F8B19A2F366E5AB873FD8C192F9C1B3D7AE2B429F1C6E6DC19930E7556375F68B47D6AE6C8EED2B8695D1DC796CD9D3C75E9A31B7EF937F79CDAD3DD536A6BEB68F543833D236C861A51F3ED9BFF06F87123';
wwv_flow_api.g_varchar2_table(890) := '3A1EBE67D997F31EE9FEE4E3C5B3A74E9A7BE7E2B91D6367CF9B5E3376FEC22533CE36CE59B8F44255EDE4492396DCB570DBF669AD4D3B572E9D38B1FDC96DA7CFAF3AB96BE2D23B268CA92ECD985DAAEA9D3BD8BCF3E49DE31B6B66DC29BDEF74EBA486';
wwv_flow_api.g_varchar2_table(891) := '2FEE58FA43E98F761D5E3AB5E140F58AC673FB474FED5A3263861F69DCDBF96E7347E7C80B4DF73DB5ACBABA66FCF485E3DB27D4B7B54DEF689C30694A7DA97AB4B9EF11A37B4A554D17DBE6D4B62C7D604DEDA852EDF809A3C74DAB6B689E386FCAF809';
wwv_flow_api.g_varchar2_table(892) := 'E3974F9C7066ECECA577FAE9B5A9F6EE5AFBEDEEE193544F1833F2F167EFAB6F3EB375CFBEEFAFBC6BFEB265B3F68E9DB76449E7E89AB6EE0B8DED556B17D7CE5BB51A86FBCEB65DDCF9D9FD4F3D72F162E79431DD4B962FFBC5FAFAF68E0B33478D5A79';
wwv_flow_api.g_varchar2_table(893) := 'CFDDD5B54B3BDB3B3EF9DDC695F3476C3FBBB8E9FC99F3A39AA7F6742C5FB6B4C67B1F3624B7B435B7B4B4B63477747756D79F5FB56A41CFF2E993172C66F5C75F9E58D47974CEFDABEB1ABB66F4D42D5DBEDC47C91AF75E9836EAE29DCB977FFED9E991';
wwv_flow_api.g_varchar2_table(894) := 'E7CFDD337FCEA11913174D1FDD75725F7377E9D8CE2F7EF4D8D252D5A8D1A5AE2533A7F8ED90CF3F1DD5D5D3DEDAD2D6D2C22FEB1AD7D3F9C88A990D13D66C395AFFC8D90327274F6D3CFCD9C2E7BDB056BDF35843A9F1F0F295F7D56D7FDB16F4F9E36B';
wwv_flow_api.g_varchar2_table(895) := '962C5FF2E111DBEBCED856FEE89D333B6A97CE5A30AB67E284F3EDB5A3DBEA264D9FD0531AB9E5CB7DCFAD9C533566D2F4DAB6DFED1ABDFC9993BB3E6959B666DEF19317A61DBFB8B9B5F6E9098766DDF7A34F5E3FD8B369FD9A7B6795467DBBC371F6C4';
wwv_flow_api.g_varchar2_table(896) := 'D10FAF7DACE5FCCE556B9FA91A3DAEB5A3BBE562536B734B677BEB85E6D685B3C7352C5A7E60FDBB33668EFBEAC0B145E35A377ED5F2FDE766B6F494B67EB265D58A89D55397ACFF6AD7438B6B371D9AD076FECCB9E6CE515D17972D5D326654CD89F6AA';
wwv_flow_api.g_varchar2_table(897) := 'EEBA33CB97AD1D3176D2D1D691A31ACE3FB46671D5B249E366CC1FD37E76C5F2057BE72E6CB8D8BE64E1F4E973EE58F4FFB3F766B17125E9BDE7C97DDF989964724FEE8B488A8B488A5AAB24D5DEED6EDBED99EBB181998107B8800D78BCBECD43BFCD93';
wwv_flow_api.g_varchar2_table(898) := '0163001B860D0333F0BDD7F6BDBE7DABDD55A5526D924AFBBE52142552A4B8EF4B72C93DCFFC52A13ACAA2542A4AA5AAD61201EA284EC4175F7CF13F274E7EFF1371228A2DF6101F813FFBB7575C44192402CF1B02DF170186C5410599904C84CF5319E9';
wwv_flow_api.g_varchar2_table(899) := 'D548203F8DCC16E63357A82683C00C5A328CC92C5CA616B3D4132C14FA07A963B125B859EE600BDE27B3FE9824CC08309384194346AD586C19CEC6346034C327E1A8C41979A6F6CDFF0C631E55339ECC47CB7C730BCD866CF3AD1D0AA9882F93F90C8F65';
wwv_flow_api.g_varchar2_table(900) := '66E08A2C2EC58F1F36433EA917A28E4F8C55B8C58841DA8500AC955F6BA625D32E24BFE9C24371A98B416C3833470CA63A3430911B0D0C359302C967F233CDE1C36356FCE26501D6F2080746B288238C186F0178894045ACBC05B68FA91419C0C4660CE6';
wwv_flow_api.g_varchar2_table(901) := '1D04AB4FB359148D42096C1C0A4DD637192CD32502AF32027476BE967F9511906D97086C0601F1ADD366243729C30863BEDF19F0166CEDAEBD7EB6293576B3FDF5F684CA42E8FACA92E09696B633772E4D2E9C5533A93C8BA9B2ADF6F28D8164DC102808';
wwv_flow_api.g_varchar2_table(902) := '5696E6CDB77627E3698F5BE770F8029E355BC0AF8B456A8B5D47FDADE37DFDE55D0C029B76D4F8120D3BCE9CEE5B5CD61FD8D1A6D88B0ABD7379BE8296D6DA1B476A876EF686F2F3C7D6CDC6B367994B7AE5FAA5FA40ABC5979D8145C0B63CB7DDE0603E';
wwv_flow_api.g_varchar2_table(903) := 'B2AAF7F059BE5A93EF3DF4F991ADB5C9DADD7B7DC59EF337E6E3C73EAAEDDE3FBD9639F8F131255558B0BB636435BA1E892D0FDC55BBB3EFB54797935357CF37B7B72CC54DF3FD67BABB4A159D8D4F4CFBAE5DEF6EB0EB1C4164EC66AB62B496048D2E7B';
wwv_flow_api.g_varchar2_table(904) := 'F99A417FF2C64891EF606DA7271C0CD66CDD954C4DFAA0D1BEA2BE8F877E6B6FF3B965DBDDEB57AA771E786F6F57D64A456909AF47CB9B528944D8EB9B89DA528317FFF7DF7ABBEFF468E1449FABB86BCE5572E8934F5E6B6FC9AB68DBB737BBDE07617D';
wwv_flow_api.g_varchar2_table(905) := '2D9D4AC7C726A62A3D6B7C901A0E18AE7E615EFFEC93AD07B69B7D89898568D03D3FD63F56BDA3EECE426CE6F8C9965D4DA595DE937DD6E98387B698563DBEBD818201556F4195C16CB259AD8AC150566C73788AFCD5C1137DA6998387F634973AEBBACF';
wwv_flow_api.g_varchar2_table(906) := '9EBEC1C7C1672F2577870ADADFEC8EAEF4070269475E768D839337264CB17310E09622EB19B564F1E0C74C816EA8DC763C59377EF023B761B5A8A1D932BE92EFB1B96C6687A7A07764B9C03CEC29FF1965D33AE385FEC989C3071B6A422967E1F1F3D716';
wwv_flow_api.g_varchar2_table(907) := '866E7EA95AF617D519D7D34B0B6BEB4323AAA1EAF2C054384FB1FBAA286236190C66BDD3A9375555E9F4D63B73EB9F1E3AE44FC78AAB76F4A8F1E84434A0261CBEC20B03E3EF5466569DBFD97FE1BCDB1252E7EE146ECFBE0808382D71A7BDA13CD8776E';
wwv_flow_api.g_varchar2_table(908) := 'AA3C60ED5FD4D7541A07471DB6E068BED594CEAFD45FF830B4FF7FC91D33371BF5C13C57ACA8D0E9CEFEB85C1A5E18BF7622B636565F72B1B1A2F4E3F39795818FAACB3CE6FACAC11B572A77B49EFED519B3B77349554E9DBCDCE02F71E65539589C3CAA';
wwv_flow_api.g_varchar2_table(909) := '2B2F751A3D96C6A0F5A05AF4F1279FB4850345CDFBD49286831F7F51521C68ECDED9B2BF2BBA3E120AA80E4FDE9A6EF1D089ABA6D2F99EFDB5AAA2F7BABD1F7F7ABEA35DA9EEDA4977C00C1924022F3702DF0B018647811A840DBA089B654D63485AEEB8';
wwv_flow_api.g_varchar2_table(910) := '224C8FD5A710806A321A0CF562F92BA8176B5041FF60920843F3188F6514572B8812865861800C2C33DE0BC1230E5B438023B54035594599EF783985780BFA2A6635630F948F3881887651D109C52551A4B0A92F8B2443CED93F09DB98BC4D2EF27FF887';
wwv_flow_api.g_varchar2_table(911) := '7F08017EF3CD3751CE5CEE7FFCC77F847843CEA91AB2CDA468182306B3C4140418F2F9F77FFFF7184F41DC6586A9C141AB42AB9A0840119067EC1A85627157083CCC1FF6CBEE4DD06CAA002BB61A86F36315A00931DC0B4C62B52D868ED97509D28B0015';
wwv_flow_api.g_varchar2_table(912) := '010B01A072DB85124E396AB513A7C69FFDEC670CC5F31A8201646D0569265A8B01616C06C65CB8880BB5B9899A4E199108BCF4083C7CE7D39548D4D21F8E808948A4B3F368E2F8D2A3241BF88A23A0F5826788036F91F7EFAE2D30E5E799743FFAD1BE82';
wwv_flow_api.g_varchar2_table(913) := 'CC6438503D3138A0D7A5DD6EC78FF676CF0C39A331DD44DAE434A67F74A06DF9AE3D6836F95B4B4BF37DCA5BEFAE4C0D3A6C3AB3DD9AE7B6BDB7BBA5BE2CA0F882F1377FCB68E693CF6C97ACF0999537DE9CB93BD0EA4FD7D56F57F4F677BA2A4B58C4C3';
wwv_flow_api.g_varchar2_table(914) := '62F88D9FEC73A90BFB0A7D9105B7D9A0781DA68EF60EB3F7FE6C35CA52BEA9B6CC664D87217A94559477B686FB130DCC7F265E5F9DB7B2D46151F984D8E0B0981C4E77535971B062CB44FF82DF65D9B277ABB3AC15B1728F29AFAD1BFE154BA6EB4B6088';
wwv_flow_api.g_varchar2_table(915) := 'D9D7D0ACBA546C592D6C8593648DFC515BF8666A7BC89F2A0C555EB99B76B91C451E47535B97D5E16CDED5367A23613419F97AB9A6CC57DB54A15FB29A676E514A0B9505F699C69D6B93B715939189DC2D0D55E1BAA64CC66F30AEB80CCAB6FD9DCBC397';
wwv_flow_api.g_varchar2_table(916) := 'F4A62C59D58241AF982DA66DF5455BAA8B159D9D91CBF5B6FDD6D8387BB76512F1F5D5F585D5588B7758D991AACCB38676EF50144B758125D2D1BE3079BBBDB5D2ED2A6F79CBA83332CC9E6DC06F6CAB1FBCBC521DD017852A3C21EF62E7F6A5995B7ABE';
wwv_flow_api.g_varchar2_table(917) := 'DC5515AFD5D2B9B3CB63CDD80CA6DD3D0D37CF464CA675DA42C11D8D45C529B8A552E337ADEED93F3F78C564B516056CB3BB77AF8C5CDFB2A5DA56569F092DEDB71AF3CC7A7BC11B7373D1F6965AC590259346BDE2726751EA68EDCC587C6EAB6557FB96';
wwv_flow_api.g_varchar2_table(918) := 'EC2401BD91D1E1A23CC7F6F21E83BF41373ED3DCD0A618EC14D95AE44C76EEB6EA22453F7D3D69F439ED1687C3DD53157615546FB325AE2422A67884A778A1C7541EEE5E7756CEEA97E7D6D23B6A0BF5AEEC0B11B7C5F0C68FDB0A43EEB77E142E29B2EC';
wwv_flow_api.g_varchar2_table(919) := 'B2182A5CEB6F145A0B5C65CC2D6EAD2CD659BA3396E099F34391F9DBECD1C1B2371DB5BE92C28E7427571FEF54C764F8EECA8031ED3598AD6DD585EB0BDB1CD1C9D6B6CEB83B60DBD1595455FD3B6F1874EE72ABA2F4EC68B3065C469DF2E3EDCD63D713';
wwv_flow_api.g_varchar2_table(920) := 'DD414BB028ECF118DBBB5F5BBA73C564B1D359F61EE8BC73E53CD322316C574FD3C0650682E378C156A3CEEA7557177B2BB675EA147D4F73E3ADC4BAC9FA60623F6D914122F01223F0B56F6EB5766ABF5E44A08822E0E7C188088C34326EC9202D9E1C43';
wwv_flow_api.g_varchar2_table(921) := 'B29AB0569C748AFCCBBFFC0B940C6E067B848F91A209C0D0D8F2E7EFFEEEEFE0907FF4477F047765E812DAC9BE3E3031122B2A2AA07C90BD4F3FFD94CF7DD9FE4730310ADEBD7B979D87D89207993FFDD33F653406C3A811D2F8E1871F5284ED34E172CC';
wwv_flow_api.g_varchar2_table(922) := '5226914D6EB1F02FFEE22F98BD0C71FDABBFFA2BA610FFE55FFE259FDA620FECF4C89123ACB70CDB241155B48585B5187CE61B5A14A201160DFFFC9DDFF91D3450048E0DF7E6EB62782F76C24559F28A81688828654106720E09C748CA427DE1CC4832C4';
wwv_flow_api.g_varchar2_table(923) := '8AB57FF6677F86B65CB890814FB2A32F1F3643AD9124170BD18942D8B83089B6F39A00B58C27631EA518ACE6435F66445335AD80F7B234340DE4BA904E224B82813FE0FFC99FFC0946C29CDF7FFF7D70FEE33FFE63CC1636A0878BC88837D78271608AC0';
wwv_flow_api.g_varchar2_table(924) := 'A541E6A73FFD697B7B3B6DFCEBBFFE6B94FFF99FFF393C9CB6033EC27FF3377F435B48442D89DA35951189C04B8000CF37BE59E0F142A7CB6D0E5D861B9EE5F198762156B913B9F45FA6BA883E45772020A945886BF49844BA275D49CEA0CE0556C65F4A';
wwv_flow_api.g_varchar2_table(925) := '04B8F399A3C44A16FCA8F14393DB463A025D801F470438E6667DF7F895F9CCF17FF8BFFFE3FFF1DBC640FD77D7F6CC35ACA795C13B03CD9541C5F060FAEBC3B5C413E97422667742C67410E0D4DAACDDE9E7B3D50D922323CBCED8425E6DC586F41FE634';
wwv_flow_api.g_varchar2_table(926) := 'AE2AA78F5F89AE4CE84C86EE9A726FB8FAF9993ABBBCBCEE761A74862C931F9E5B71CEDF0DD4353D061648E75C241A74F201F2D7C83F451653CAF2F5CBE1D6EC1B8AC784B9B594C71433999D8F91C9CD62C8E5E4A9C1C85C5F76DD3535D35DEF0F54F3EE';
wwv_flow_api.g_varchar2_table(927) := 'E0870B3479E0CA647999C1ECFBBE36D6FAE11A236B7A491180CDC16EA03FB08FDC26F2FB020962DC11CE08ED825871CA18244702C30C7019C80B8E190509B873047E89B41F2311F95E083086F223C798247E24DC321C0E6BB58A3670CA8F1F140B779335';
wwv_flow_api.g_varchar2_table(928) := '9CE16CA4E34A326F19FF1243F95DA420A7622C3457030E2505C5F827337835CD4460D1304F481DBC11B59CC2EBE0932C1F0D168CAC529008938D410A04A9487CB2CB298980851924022803B9184F2BF07A3106F6AB598E5AC6A5A18BD4482E5FD2529D30';
wwv_flow_api.g_varchar2_table(929) := '83234528CB05433F4D600E335570097905401528177A728FB48879D40C7DA39374AE1F057111B86C28119214A45D906424A9820BCCB03983CCC82040BD8C9FD3762CA72004153116C1C2305C769A8C490C32331ACFA93055A8254E15082380770E02548D';
wwv_flow_api.g_varchar2_table(930) := '5A0117EE0B02A047331113B590485B4814550B3DF228117839107852028C7F2F562EE0F14547A69FD23D35D24BAF21A093BE43E0B1C0BBB9BABA3A0D2BB278A1465FE6B9C7038AC917742E2DF7E1080F01BA39A598A3C13A05BC90A2ABF2A68C9ECBAB37';
wwv_flow_api.g_varchar2_table(931) := '34ECDCB993F93514448687274F15D6C9C71E5E72F140234EEF7E58AD4C91083C5B04B8ED7F2D04783E96991BE8ADA92ED35B1FC7309F6D639F481BC8DC7B21F0B597024FA44113BEE71DDC5FC6524BFC21236C3E944E25617046D3F33B63F63BA294F5C0';
wwv_flow_api.g_varchar2_table(932) := 'BE5A2BF419628BDA14CB8ADD5BFC0CB5465C74C3F7321FF33136676F45B2BFFE7EEA31F2324B22F00323F0A2126060D20812EED7C3A8E10E0A364827C46514025A1191A89D6ED0F04DE99A4EB45104FDA48838472D97EAD02F6ADC202312396A5510CF95';
wwv_flow_api.g_varchar2_table(933) := 'E754D3238437E46E28FBB019A2D486A3668648CFC5245732D7AA0D32B9563D5CA9A67F039242B996CBA9A6565398DB402DF1917A724D957189C08B8800BCF1894680E19C4C5AE14D1C6F917885047D85094353693B5D89975944785BC71B34DE2269DC55';
wwv_flow_api.g_varchar2_table(934) := '4306F2CC24175E8DF1EA8AF91DCC7661D686284B5FD3C4B4081AD8091CD2CBA41866AFF0728D822CA3C0BB33DE4C613CEFBFF810037918354B09F0628BC91AD4C2FC9AECAB51AB959935B98F114DB38C48049E2102DCFCBF1602FC0C9B20554904240212';
wwv_flow_api.g_varchar2_table(935) := '0189C0AF1181EF9B007F8FEF9C1ECF91F8817C586043CA8653ED327C53FA069D3037AD08910DB9226B838C26FF4D557C931EAD20910D65BFA98ADC229B91795873AE860DADDBA070C3696E41E28FCCDDA050147964E2066DF25422F0AA21400F62289887';
wwv_flow_api.g_varchar2_table(936) := '351C18164A80EE32422BA826E98CD01220ABB9C8F0A060FD762834DF1D30084C2E04958933CCE660AC98C9D2906172D14C29A6F420830043B8CC40A10A26C8B0761D63BC4C6CA1082B1130C5E3BFFC97FFC20833AFB4582080C92968A32C473651E3538E';
wwv_flow_api.g_varchar2_table(937) := 'BFFDDBBFA52EF13507AAD0CC241134304D864944CC97D9B3674FAE85322E119008480424021201898044E0E543E01133725FBE46CA16490424021281EF1501066CE190E22B063E3D81DC92024D653458CCB0E0E51121D7064E118318C348F9B69FA9CB7C';
wwv_flow_api.g_varchar2_table(938) := '5DCC72007CBC4059962180FD92CEBA06240A2A0BFB155F5230CE8C0C2C574C9F868133F68B1EBEE660EC17660BA7E54B7E945323A714C43C22506B0420CCF0732645333A0D01A622C6EB182ECE354FC625021201898044402220119008BC94087C8F23C0';
wwv_flow_api.g_varchar2_table(939) := '2F255EB2511201898044201701782C1497215F066989D8AC16E62E47D6D6DD2E07DF79446371120511DD40804964EE34DC95915B882E6B0DF06D3F149AF50B58DF9EE5D961A71B8A502FA49A233AC557C71057782F9FFB724A1643D0ACEE4E2E32A46876';
wwv_flow_api.g_varchar2_table(940) := 'A28A38AC98450119F5A552E651535098CD6830C6B3CD9B262F23120189804440222011900848045E560424017E59AFAC6C97444022F00321C0602C2496A3C56C9E5F57C617527505F6C1E98CDDAC060399EC329FF70C81A0423B37D8442952E0BD228B59';
wwv_flow_api.g_varchar2_table(941) := 'D3AC75C7E7BB441813669C965C21230A122720CCA02EDF0F33C2CC5A8830586653436861D4ACD24745626541C184598A8F4DDD18E985E2A290BA20C0505F8682194066423523C97063F663931B806FB83AF2F4B94280E53BD2AC1B947D7D637C7855E4EF';
wwv_flow_api.g_varchar2_table(942) := '682AF33358C08E1543E970A84A6754BD92D1E9BFB6FAA856053D8825461EBF80D03D1994C979761A6C322211900848049E170424017E5EAE84B4432220117841118091329C3BB594BA35A55C1B4D45A299A662D3D9BBC9A575656B89A13AA8FA6C191D1E';
wwv_flow_api.g_varchar2_table(943) := '75E66B53A0692CA3B5A2C9D051867F89A38A915B066CE1A29052466BF9189874048424539D99DB0CB3E5C82AD0C8545454F065EF679F7D86C3CD97C0105D9420CC7468168826C2DAEFACD4C55831B9449877CDC032149A1A311BF22C22C88B2AE45122F0';
wwv_flow_api.g_varchar2_table(944) := '1C22C0921EC7CF0FC7677B15BB2B684C6EEDD9AE333E6EC9F46F6D4234A52696E63C7E9FA2CB3A42BD936BD74F7EB2674BB0A861D76C347DE4B3130DB695A603FBD9994153B5124DE9638B194FF0DC91D3DB9B02F6FC5A2D6B4384CFFD8F9EBED21E8CFB';
wwv_flow_api.g_varchar2_table(945) := '6BB2DB02E786483C3339326A48AD9597844CAEBC89E9B5A5B9D18A529FCD5DC076B2B3A3035EB32158517E7778494D2EA4545DA1CFEAC92F15B43C578F8C4B042402120189C053232009F05343270B4A042402120110505763EAF93BB1ABA3C9BB7369BB';
wwv_flow_api.g_varchar2_table(946) := '59D7106267C774A15B9D5CCC7CDEA75C1B536A0B94FA828CA26E5C0F9FB15981A0B63F1903BF505FD259501A1E0BB325E4A2CC464A0CD8920279861E23CFEC65C25B6FBD853C1FFA12843C893D3D3DC421CFFBF6ED63589808A3C49A3631799BA9D71424';
wwv_flow_api.g_varchar2_table(947) := 'B068969625231281E70D01A6FE7F79EA764DF28CA5E7DD73BFF8B4B626680B6D65E139B35E355AACD0E3782CA153F9A8DE60309A52A9B4C9A84FB3CF4B3A653099D2AA128FAE5BCC4683D19C4C2BC9F83A1DE7D2E8CAD2C97F7DE3377F6672B13798EEC6';
wwv_flow_api.g_varchar2_table(948) := 'C4DAFBBFFCD03EE5FF8D86F6CB43D1F77FF1CB6471BAE9C0EE8C628DADC72C264535588F5C1E0A4E7E51FCF6FFF6F9E11375EE6A83ABD462B530C6CB8E368978CC62D41BCCD98D64E3A9CC722276E8D8B9B2E6A8BB629B91A1E29C4D6E6E4E2CDF38F4B9';
wwv_flow_api.g_varchar2_table(949) := '35E8591CBD5CD4F6E6F12F2FA7D4E599DB6AD3DED72E5CBE198FCC9438EDBE70E1C09D99B3D74F871DEB7BBA5B3DF96C989C7DAB2583444022201190083C130424017E26304A25120189C02B8B803A1D49FDF3A9D8FCAA5A5BA0FB718BAE3CA0F03D6E77';
wwv_flow_api.g_varchar2_table(950) := '45A6C4AB7C76433977577773526768550A7578E95F0B628A3249B8E32203F60B11655CF76B72392714D14A69C3C2E46B714D159C567C7B4CEE3D8E9C75CDB55C4DA5A64D8B685932221178AE10E03B77A749F1E5E70FB95D6C667875707666BC4FBFB8D2';
wwv_flow_api.g_varchar2_table(951) := 'BDA3E6D68A7FAEFF4454E77225C69B77ED3F7FF2EEBE5DC1FE4820D577BA7EFFEB577AEFAECF0DEB5399E6F6AD17FA471C89C5BC82A293D726978F7FB1A5AEAEBCDBAF28A654325DEC77F74FA656676EDFE88D071C89846A8BABEAF5FE91C8F8602A1DAF';
wwv_flow_api.g_varchar2_table(952) := 'AAADFDF2E4A9F2C9C3B686DDF174FADAED89F4D4A9B64A9BB7BAF3D4893E559D36AFA53A7A1AD6EDC5274E9EB6E8620B9323EB4DA18F8F9EDD96BF5AD8FCA686E4CCF26A7E66D9DEB0FDFC17FFB9C294EF498E855A3ACF5F18760F9CBF76E97A774B7961';
wwv_flow_api.g_varchar2_table(953) := '45B55167AAAA08FED773EE3DC5114F3E734024FBD5F093118980444022F00C109004F81980285548042402AF2C027C9568D667C2018509CE89B43234AF9A0D99F23C7576591D9E53D6123AB7452DF4A41DE6742A9ACECE727E6CA8AFAF87B83E5644664A';
wwv_flow_api.g_varchar2_table(954) := '045E5104784733BA121F3C7CBEB9DA16B197BCFF4F477CB6A199D115A779E69389E04EDBAD29EFEEAB5F7C5AB465CBE787CEEF6969EA9B30278F7D19AB6FFEE8830F425E7576782963513FF9F45C9B4F29F8D17B3A3D8BBFA58DD98F0BB23D2E9356AB43';
wwv_flow_api.g_varchar2_table(955) := 'AE1547F8F4F173B171B5A6A94E3F3A3DB890F8D52F0FE65B5706A7D67ED71235188D36ABDE64352BAACE61339F9A4B1BC67EE135965E3FFCABAE77777C717ED696FE74B464DFDD739F77EF3DA032B35AD5B1375A2619CDBD60AAA29F5C5C0BCC0C959455';
wwv_flow_api.g_varchar2_table(956) := '2CAD460ED4BB024D5B6EC57DFA997F2AAEDE36BFBE6819190D95E45557E6E715955797ABDE82F2DCE2322E11900848042402DF1D01B93CC377C7506A900848045E5D0452AA9267CFFCACC3F093569DCFAE9E1EC81CBCAE32DFF8D8A0F2E56D3CEBCCFEDA';
wwv_flow_api.g_varchar2_table(957) := 'C48F1BE3E5DE6432BD7104F861D470F125017E181699221100814C3A53ECB3B942E1A1D1E989999991DEDEAD1579DD07F6A5EC65A377FA3A6AF2AB9BB7653216BDA22674BA743A914CA4999D7C7B3AB23AD6BFADA5BA6BF74E9F37D0D8D43ABC6A5E18BF';
wwv_flow_api.g_varchar2_table(958) := '152A2C29709A8A6B6B14253B12C0F7091E43B2B6ADF5E3230325A6D1BCEA36DE6D8D2EC66786AEB63694ECDCB53B3F54EA2D2C2FC933F9C3D5BA54BAA5BAD05DD53C3D353C3CB9608B8D766FEF48E6574F0E0FF70F4F151A22ED5DDD664FBE514D6CA9A9';
wwv_flow_api.g_varchar2_table(959) := '7015D6E75E3E5602585B4FDA53A99EEEDD064F38B296E4B9B03AB798EFB2BFB66767A86CCBA7976EAF8E5DC8B637C5B07476D5771924021201898044E0D9222009F0B3C5536A930848045E2D04D40C1FF766421E756795F293AD99BDB5AADF89E7ACF86C';
wwv_flow_api.g_varchar2_table(960) := '6A6779FADD2D899D95A90257CAA0B0F8D4A3097082B996395B0413276503888F4CDC20234F25022F31028CD23AECA6A23CEFBE7DDB8612052BB7CE5477D4C7638ACD61AEAA282DADA83D7973E6CEF5D38A9AF2598D81DAF0F92B23CBA37D66A7ADBEC015';
wwv_flow_api.g_varchar2_table(961) := 'AA6A8CAFC743414BC05750100A2EE9CCCB6383E50596054BE558EF0D36170337AB516FB6DAB73696AE1AF29B6BF2ED9E62B3CD52E6B195D737C76289128FD11708951787466381B9815B6EBA375F1EEB55ABCD5157E64BFAB630EDD9BD70ABAEBDB5365C';
wwv_flow_api.g_varchar2_table(962) := '3C99F69D3D73DA9A594B5BDC977A6F2F8F5ECBBD2E0E93B2ABBD7ADF81F702C575E5A5E5270633873EF8C83B73535FBABBF7DA95A5C961AB95A5AFB2CBC53BAC268331FBE5820C12018980444022F06C1130FCFCE73F7FBC461C2F2DB0CA28013F8EC010';
wwv_flow_api.g_varchar2_table(963) := '0723156CFEF1F8E232572220119008BC2808F07C637320360A7A781896A5925981996D87587A4A6B0EFBEE2E2F2FB360D5C2C2223B0C31CFD96388784D2BA9F89A53B752E48A59D555D259FF99619FAC80C3C1F6455A712268181A1AE241AA7D82CB2AD0';
wwv_flow_api.g_varchar2_table(964) := 'FDFDFD2C76A5A520462DEC152C365BCA2D2EE31281E713016EE3F9F9795EE56CE84AB813ACD3C6165F08707C22E32D26636971A0B0B8C4E40C84BDA68AADEDE994CE643456157AF34AAAD9907B55352EF45F3DF07AB7B7B4962F7E0BF2DC9535E1FABA1A';
wwv_flow_api.g_varchar2_table(965) := 'ABB740974ED9AD26BB37A0C6D76BC2A196E62DA1E20AC5EA0FD82DEE82105B6B9B0CBA029FB32C1C76B8F35A1AABECEE5030CF59535BE1CA2BC2E9B19ACCA190DF1F0CE98DCE7C8F23BFB0B0B4A4D4EAF416E5B9EA1A9A0CF650261DABCDF7D4776DCB0F';
wwv_flow_api.g_varchar2_table(966) := '16E88C0EBB59A92C0D85ABEA923A6B91CFEAF0DF5FEE8EF61AF53ABFD7E10C669F036E972D12D5A9EBCB1D5B4A6CA5CD131393A9D8DAD68AFC92BA6E16D462D1AEF2029FC5C927CA32480424021281570B016826DB3AB28145AE2F2420607D13F67A6413';
wwv_flow_api.g_varchar2_table(967) := '47D8285B5A702A8E4458E8441C292502BF415A10C5392522BF017EB5EE27D95A898044E01922C06314CE8C97BFB0B0108D46D94988633A954C194D89443C613293C5431CCE0C49C6F57FB8EAB9B939C82D0F719830C26840E1F0F070434303CF7D125910';
wwv_flow_api.g_varchar2_table(968) := '8B27FBD8D8188F75E837FA59D10A0A813001E52CECCC539E9D936014087384AB5317B9DA8AD00FD72B5324022F16022C13D7D5C6D7B0FC29AF7554290A7F8A1A0EE9E8563A5D2B2431BCCF3A959839F6915E6FE8A829506B0AB48FE9B73755A96A557643';
wwv_flow_api.g_varchar2_table(969) := '6E9DAE385420BC1F8AEFDFD5A975CABA42875298DDB2E8C0CE468ED5FC0B6517516FAB2B55EB4A1555A5142CB6F4F53DC4CBABB3BA9BF857FC0E87AE6D95AA5A293EDECF47ED1ED466E5C92A0C73F85A280BB89440B60A82CBA8DBBFB359559B84F0FE5D';
wwv_flow_api.g_varchar2_table(970) := '5D246AE6ED644179853F1924021201898044E019232009F0330654AA930848045E290404ADE58D23B4133A0A17558C26782C9C9638BE2CF415EE8A1841736D3588464646CACBCBA7A7A7C7C7C7191F86BED6D4D4200FD1651C18AE5B515101256677DF6D';
wwv_flow_api.g_varchar2_table(971) := 'DBB64195272626D05C57573738388836E4C5C64877EEDC413F349B2208A01F93C41EC25A5D32221178C910C852CC9C45E3CADC867DEFBE67706449A3C67E4593EF4909F1AFE5E494FE466C36D4925BA35666839E877BBA26F9704413D6220FCBC8148980';
wwv_flow_api.g_varchar2_table(972) := '4440222011788608C86F809F21985295444022F06A2180C30A539D999961D63423AE6214171ACCE02DD494015B8EA4435C19E9E514929C0BD0CACA0A89F9F9F910608A30C39979CE08A31685C451051966F817664B40063D0303030C38C39CAD562B63CB';
wwv_flow_api.g_varchar2_table(973) := '505FC83047669C329B9A2A60CE8C2143C273EB927189C04B8F40C86E68EFD9A1B7CB39C32FFDA5960D940848042402DF09013902FC9DE0938525021281571901D826C3AD376EB08E4E363006AB1DB508890CE112989F9C97979795FB2A30EACB27C10CD5';
wwv_flow_api.g_varchar2_table(974) := '220395E59B16E8AE1086BE565656F2413263BF535353555555A4F3C50BBB044374C55033DF245316EACBFC67C870717131C5A905524D0D728186AF6096FF4B04240212018980444022201178808024C00FB090318980444022F0440830BD391C0E433EBF';
wwv_flow_api.g_varchar2_table(975) := '75EE2214978F75372CA0C5D0714B4B0B3532599A38441AFA0A71652E34891461DD2CD82FB45630670693A1C12C1D04F12697F15EE83733A8916758983855A0A7A4A404310A1279A2E64861898044402220119008480424022F3D029200BFF49758365022';
wwv_flow_api.g_varchar2_table(976) := '2011F8BE1080B896DE0B4F5101A3B8D05AB1102EFC9905AB18F5E5AB5DD82C9FF8A219965B5B5B4B1611025534363632D8CB915208200F03E7236172C5046C8461E31467EA35E129AC924524021201898044402220119008BCDC084802FC725F5FD93A89';
wwv_flow_api.g_varchar2_table(977) := '8044E0394500A6CA2467782CF6B1721503BF9C0A5B99E74C04F6CB916F8C99E72CD2B5115DC82D83C9CC8BD6D679262E64E451222011F8211150138B6A6A395BA3D1A337CB8D217F48EC655D1201898044E029119004F8298193C52402120189C0774180';
wwv_flow_api.g_varchar2_table(978) := '89CD1A7D85D972FA486D8F5CCB0A61168B66F8F7914564A244E0E54380CFEB47E6D6C7FB2FB2CF637591CF5B569F88C6AC56B3A27BB09667465112D1B8D56A54748FEE4D1A2CD3ABA9A1DE0B7C6610B25BC32D6C4AF4B5D5E9105B4D2B372F5E6AA9099A';
wwv_flow_api.g_varchar2_table(979) := 'BD8FFB8E20B3369859B9AE4BAF2B7A9DAA77A8CE4683E3FEABA8445A892C2DE8D4B4DFEF5174E6682AB3B6B090E7B5E9CD8E584A8D2C2EF8DC1693C5A999442496481BD27183CD1E8DAE3BB24DDBAC870638C968D26CA3D5F7D148AA4A6421A2D3275912';
wwv_flow_api.g_varchar2_table(980) := 'DEE3309B6DAEDC8A9E6DFCD2EDF9507ABCB0BE259E52571697DC4E83D9F6643B3C3F5B7BA4368980444022F0AD083CF8E5F85651292011900848042402DF07020CE7F2F5EFE635336ECCEA5992006F1E3129F9A223B09C547EF5D99791E1731955595959';
wwv_flow_api.g_varchar2_table(981) := '1F988F1E3FF8A1125FC86DD7E84AFAC8471FA5562673131F8ECFC7D2870E9F5A1CB99649A7234BEB90C787651653CA271F1F8E4EF73F9CA5A5A8A9D5D4D8FFAB5BFE5C17BBA65BBFA65BFA223DF6FFA9C91521301B538E9F3AFBD1E747A6AE9D8F6552C7';
wwv_flow_api.g_varchar2_table(982) := '4FDCFEE2F3CFFB2F1D4DC4D72EDF99FCE093C3E73FFD281D5FD4B41139DE3B73FBD8C773A9C4E18F3E49AFCCE4663D3ECEAA77570FF5A6930FD000AEA327AFFEF33FFDE2D087EFCF8FDD7C7CF1EF983B30BEBC38368492D9B5E4AF3E39DD7FFC235630F8';
wwv_flow_api.g_varchar2_table(983) := '8E3A65718980444022F0BD22B0D9F78BDFAB1152B9444022201178211060E929D69AE2F842582B8D9408FC5A10F83E3A4834AD5CBFD15F593A57575D92367B0E9EB836F8D12F6ACADDC960CBC2F47826BAD6D85479ECFACAF983FFA32AA0A62B0DC6A9E1';
wwv_flow_api.g_varchar2_table(984) := 'D2CECE4B27FAEBABEDA36BD6D5C9DB019FA7A6BE4ED15BCF0C2E8E9E3FF41B7FF0537749FBCA4A7C3969B87AE98621B5E036991ADAB6CCAC5B07AE9E994B19662607D54CC3D8426C6CF0A62EB9565F5D7C794AA9368E1537EE12A866A213CAE47F36387D';
wwv_flow_api.g_varchar2_table(985) := '8AFEDE406E662DBDB6982EFC9F8DA62D0858D783E91E0000400049444154F48AD9E9191F9B1FBF726626D4B87EFBB8BEB4FCFD4327FE637EC8A0FA0B82FE2B47CEB4B48F3A8A1ECC9A3E36B8B06BEEF242FDB6A1935757BA6A6F4E6666067B6B43F6605D';
wwv_flow_api.g_varchar2_table(986) := 'E7F2C0D5CAAD6D538B496564D8DC5077F1E2157B72A9A3B95EE72E3CDB3B3C31766BFE97E7DADFF93D450908DB8C3AC5EF771FFBEF8B6FBF65375B9D9158FAEAA57EFDCA44D3B6AAD161F3DDF9DB6EAB41AFAE75B6B69D1BCBC466AE3B54B5637BD7F8BA';
wwv_flow_api.g_varchar2_table(987) := 'F9C6C55379C64447D7D63BD1C0E2EDF30B8B89BA3273E996AE6357EFEAA7071A2BF25D552DFDBD176797D3B6E5C59E7D6D77563C23B72FB4346487D02D069D9A9737D67BAEF98DCCADA1489E6EC11FAE3A7B75685B85C5E02A1286C9A34440222011781E';
wwv_flow_api.g_varchar2_table(988) := '109004F879B80AD206898044E0C54080D595F9FEF6FBF0EF5F8CF64B2B2502BF2604DC4665D7CE9D7DD70F4FFCE2DFDFDBDB158DA775BA5566FCC655F5D2B591E11BE77D6A7D2CB94DCDACE8CC864B038BB63387829DAD9F7D7CD6FA5EE0A37371DFFAE5';
wwv_flow_api.g_varchar2_table(989) := '7D6FBEC19C67CCEF1F5DF41B97BCA5754C9FF6786C1F9E1B1D3DFED996EE960F8EF67B1C6B5FCE169BFB8EEA6A5ED329A9E5B4FEE0A7E7E2E3E7665713EAAC73C4DE13B28C6900A8E955257E5751187016AE548A49CC4A0AABB22160538A2BEBC7C66613';
wwv_flow_api.g_varchar2_table(990) := '99D9A189E5A07B7EBD68472AEA5B9F9EDBDABE65D4175C38D7ABFFEAF37E51C46DD699CAAA677B2F969537F64FC76E0E0FFAEDBA93B7665F775F3D7E7E345C153C715BDFBA78F550C478EBB35FAEC712B6C498A3EADDE1EB579D5EE64B1B725FCB794DCA';
wwv_flow_api.g_varchar2_table(991) := 'CE1D2D973EB8BBA7DB632D6DF8F058FF990F7E91CEC452B1CB03775AA75237F58698DF11AF2AB07D7026F95AC1F89519A7DDDB7B7BC9608BCEDCC9380B2E1FBB683F60BC70C452D93332B7184AC7CFDD1C593CFFC57A55AA3DF47F9D3976381CAE985DB5';
wwv_flow_api.g_varchar2_table(992) := 'C6230C537BD6F4A64832C2A86FD069EAD8DD397DF712CD61347E7EE4583A503AD477755B78AB68A03C4A0424021281E704013905FA39B910D20C898044E0C54000F69B1B5878F9918159CA0F075A985B56C625022F2B02CFBC335B74CABBBB9A77BDF193';
wwv_flow_api.g_varchar2_table(993) := '33C3E93BA73E2FAA28F7DB8DF9D5F583A31305EED89A316F6968A0B832ECB39B2A5BEA63695B2C1251157D24B26EC8448B4205F349D7ECC41D35B186615EA76D29964AAFCE134F66944B57EE162B533D3B768D24BD1303372EDDB8D598AFB6EFDC6EB2F9';
wwv_flow_api.g_varchar2_table(994) := 'A6A2E96B274F57E5EB9A5ADB2D4E5F5B552850F180CBE92C05AAAD21A3C4547D22FBA7C6547B9DCE12D2DAEEB2E8C3D545B7672D6A7CF9FAE072C0180F159419F5C6F984E1C49133DB7695587C659A3091BC4C2A5411AE09BAD285E57727A682CAC28FDF';
wwv_flow_api.g_varchar2_table(995) := '7D6BD1D9629DEF33865BEFDEBAB5323992DF5275FDC2EDF6B0ADB9B5CBE0080C0D2C345892AFBFFDB6D95DAC303B3C27A414259D4E2553296678F7DDBA5D138CB7F4745A9C21FD4ABCA2A2D21DCAF71596AEAECC27F5F17DAFEF3297F7DC1A1A5B9A1C7C';
wwv_flow_api.g_varchar2_table(996) := 'FBF5F640E73BA33787E2C9787DA9E39D77F7566ED9717726E19D1CABEAEC1C9D1D4FACADD9F56B07BA1A77BDF7B6C11EAA29B0D576EF8FDD7F0590ADDEA8D7298AAEA6226F3A6A1E1DBED954E23038E5F06FCE859151898044E03940E0FB22C07884387F';
wwv_flow_api.g_varchar2_table(997) := '1B1AF8C8C40D324F714A4568D60A12678518426EA296FBAD910DDABE553E5720B76C6E3C57E6F1714A09E3893C5EF29B72BF279073ABD310C6D4DCF4278A3F1D3E54B1196434189FFA3678A2B648E15713013A0203C28B8B8BF3F3F373F7027BF04E4F4F';
wwv_flow_api.g_varchar2_table(998) := 'B301EFE4E4E4F8F8F8D8D8D8E8E8E8C8C8C8DDBB77878787D9B6777D7D7DC37389531679266C487F224829FB749D719355A35FEB7754B4C1DA0DB5738A40AE3DB929228E80D6C0DC5C12376992565C465E110416A3995B7DD7F5F1E57CBBDBEC7017F92C';
wwv_flow_api.g_varchar2_table(999) := 'AB96B25B7D03C74F5C4CAD0E5B2CB654DA50E8D1ADDB2A467B6F1504CD5349CBF54BE7D4D4825967280BE72FE9BD7D17CFA909BEF855B6D7F875C55DC78E7C79FEDCB9A14B976BABDDE349CFB9B367F3D585FCB2DA507EF0C6E4FAADAB179474DC653114';
wwv_flow_api.g_varchar2_table(1000) := '955724E2BA42B725106EBC71777621E77B5ABDA5405FFE7FA65CDD71A72FEEF025DD9DFAB23FD1DBEE93BDF148FA4EFFF5CCF292DBE3AE2FF12DAFFAB31FCA5A66ADC5F9FFE9D32BFD27FE7D6A3D155D78F0B9725A5152914838E8A8DFDAB39A3179EC99';
wwv_flow_api.g_varchar2_table(1001) := 'A988F9E38F8FE8C72ED9BD25DB3A4A0E9D8B6C310CDA0B5AEA2A0349A3336449874B2A2D41F78D89D9E3278FC5A2535F2D80F5E08ED0DDE3A2381395154506BBD7AAA44BAB9ADC468BD5E97679DC26B3C5A0D747E2BAA3472FA4872E569494E85C05874E';
wwv_flow_api.g_varchar2_table(1002) := '5C193AF389AF3868D01BDD018F51D197057D8B51E3E4F05876FF719B8B41749FD7A0373B19EFB5B8F2AF8C456E9E3F7EED4AFFC4CDCB1391F5F3474F5D19B83374F568892B930CED983C7FBCA2A65AD16F5C63EC8189322611900848047E1D08187EFEF3';
wwv_flow_api.g_varchar2_table(1003) := '9F3FBEDEDCF7D3787B043E8123B089258E0B5B773C5C9C7436A58C4422ECF3A1E592481136B164C30F2DF19944A848101EB41189C7E3131313CBCBCBD49EEB666DB2AE9595154DDB268B08311A48A5C0C5CA34C4B18AE3131940BDE0238C072502DA3669';
wwv_flow_api.g_varchar2_table(1004) := '0375098F736D6D0D273B17F94D6AD8A4181571F571F171FA990BEA747E6D11CB6F55421B91A15D0B0B0BC2D3FDD622B902DC7E5C2010167A72B3B4381622030F81990005BBAA3E46582B2523120110E00613B70D77D10640F0FDFC7E3F7794B65A1532EC';
wwv_flow_api.g_varchar2_table(1005) := '51C49D261673CE3E1C3319ED8149FCDE9332FBA814018E4C11F6FED5FA357726CF2B8831772C5DE9E96E5474A264767656336C83E58F3CA51466C0CFE9C8147C4CD564D110F144254E2BE8FE742BF1C011B9281120A09686A39607112DE294DAA908FE0F';
wwv_flow_api.g_varchar2_table(1006) := '746C5F4C9C370268F3783C64218072218F199CF2D6606969E9A9D178646365E20F8F00179ABB024F40DC039A01A473AB7027F0F32136C1D6B21E1F89A795D1B1F1646CB5D46B6DDFD1991708C575AE7CAB3E505804C30C0503B555E525E1EA84D1EDD767';
wwv_flow_api.g_varchar2_table(1007) := 'CA6AAB63AAD16CCA14E5E71555D7C4A2E9E280BDA9B62258DEA03398FD0E932358B6B2B890CEA86E8352DB5AB79676A8C9D5C6226F7D7BA72F2F7F653D6933EA8AF383AD4D0D79C5B58944CA6C3214047DD36BBA42D3AAAFB84698CA7B219DA346B55628';
wwv_flow_api.g_varchar2_table(1008) := 'F64A9DAB47EFFB9F0CF9EFEA8D7691BBB0961E1AE877ACAFF6ECEA282C29CD58F396E7C7B6D6E7E7D7B6F70D4C857D9994D1192E70593C055AC353B14459B1D760F5A7D2E9AA4AEF7A2A2FB230D1586CA96CEA723B5C530B89D65A87C35FE5F4BAA66722';
wwv_flow_api.g_varchar2_table(1009) := '9654B2BCA4C05D523C3E3F6F33C4AB4B4A4B1A2A757A9BA68D889A4A975505CC769FCBE99B5D5EE1BCA224CFEA2CF09778033E57BECFEFF0043FB83259A59BAC2F0C6EE9D8A6B3E74D8C8C070DD1D6ED5D7A6BB0C0A9D8BCC5E8B198F54B195DC094AEAC';
wwv_flow_api.g_varchar2_table(1010) := '2E0D95361A0DC660415867CCD6758795AFA6071C264B89DF9371174CDC1A303BCD21AF21ED2C1A9C9C0E2CF5D576EF950438F7A2C8B8444022B01904709C7006F0251EF64FA00FC16010CF01FF0146C0A9381211EFE839524A047E83B420EAE59448D607';
wwv_flow_api.g_varchar2_table(1011) := '7AD80E2D9148D6A7BB17A846B871FCA4E16FC5623154B071A526ACE9A1CA2B57AE0C0E0EBEF3CE3B303104484118CFF2ECD9B3FBF6EDC350B40983442E658968714EA9935364282B7249112E17E9C4451691CF3EFBACBDBD1DB712317CACAB57AF8217A6';
wwv_flow_api.g_varchar2_table(1012) := '3635351517178BE264891ABF499BA6F98B2FBE686E6ECECFCF17B550709301CDD7AE5DA3EA9E9E1E78EC850B173A3A3A043F14AA1020421011D40A63444B890B7C443AA76D6D6D348A666A5869AD4646941266734ABD50CAD2D2527C532E4D5959998057';
wwv_flow_api.g_varchar2_table(1013) := '934421299C620065B553A187F4CD0461CCE5CB9771FAE10394A5A2BABA3AB4DD6BD9FDA611D7F044865208A09F7486C558F0969D5DFAFBFB298B2724B2C8CDBD409C0AC336E8E1FA9E387162CF9E3D681035A21C49E4911445E800C78F1FA722D0030A3A';
wwv_flow_api.g_varchar2_table(1014) := '094892A8D94041514A18264AA141068900CF8D3B77EEC0F1B4DB5260C23D03E563635EB2D8A49753D2B97F783AC33C1B1B1BB97BB99128256E4B724544DC6964114133FA5B5A5A70FD1140986E7BEAD4298EDC9F5D5D5D3C7644BD8809014AA1997B9B08';
wwv_flow_api.g_varchar2_table(1015) := '89A25E6484186AC942804707CAB76DDB26AC428C44E20424B5AE212294A23AB2680B0F64DEB8BDFEFAEB3CC9D14F2DC86B65912105F34E9F3ECD33FFADB7DEA222E2FC04602ADD908A78D6F140B879F3E61FFCC11F88EAFAFAFAAE5FBF4EC11D3B768015';
wwv_flow_api.g_varchar2_table(1016) := '911B376E88142AE2CDE0A54B97A88BE2E4620C96F3E4A4ABEEDDBB97E3F9F3E7B1813E8B49E4A25386171101AEDD2DA6ECAEAC7003E4DA4F3A2F92D8F78BFB4ADBD73A57E09BE24CEF8DC5E36A3A6536EA4D962CF58A25D3FA74426734271371BC9D7B8E';
wwv_flow_api.g_varchar2_table(1017) := '8F2996CCE89231B3DD164FA432A904548DEF6C13F124DB1159AD169DE1C1D403BEA155D349B3416FB2DA50954EC4AC16C42DF4ED682CA15393068309DEABEA0CD1F5B8A226AD164B4AD11B94B4C1F8B5F1CC6CAFCCB00C339DCD9ADBD8445A8DAEAF9A15';
wwv_flow_api.g_varchar2_table(1018) := 'D5965DE05DC79CEBE4DAAACB69CB18CCD1589CB5045435E3B0990DA607E304A954DA68D0F165722A95311A54AC8E45575D7693DE64C3AA44226932608189F8CA5A4C978ADBED5683C9B2168DE9D594C564D331F938076DC45289347D5DA7CF7E1EBCB61E';
wwv_flow_api.g_varchar2_table(1019) := '4D27130EBB59A798D5EC0FB2A253D4B594EEBF9FB8F0DBCD5EBBBBC468B1A754656D75CD66489BEDEE5446D5AB69FD5788ADC4930620B29B61B35C051E26E845C97A229D8E33B15C07788AD91A5F5B634728B33E7375626DBEEF587773A52FDC91AD4A06';
wwv_flow_api.g_varchar2_table(1020) := '8980444022F0240830C0C0F0007423FBB4C9093C72A196F85DD001BC117804A790028E04B809C387820F5390804741E0D9A83D1E45E4C18F418EF2EF14452FCECDEDDBB7719578D35F5F5F8FADBCEFC74D84BD0C0C0C6CDFBE1D1998215E203F8198CE74';
wwv_flow_api.g_varchar2_table(1021) := '417E1443A11076E350E203D16C7C23DA832A283E92ECF981034A1C3F8C2C4AD16C480EADE257B6A1A141B407A420C06FBEF9264580805C5E421318A90E040214A12EB2D0004CF87F54845A2819AA308F1F66E0E6889786BC18AFD83C1C340A5F70CB962D';
wwv_flow_api.g_varchar2_table(1022) := 'B880B40293F0ED681ACE22831BE8E492502F115A2A7C470CA069988A189C9952F0760AF6F6F6728ABF8803C1500938E06812C1784648F05F690247E82EDAD000B054FD939FFC445C6F34D01C7231BEA8A808FD88A11C6DB40B3DE40205E9C04E91EC4FF8';
wwv_flow_api.g_varchar2_table(1023) := '2602785211EE2CEE298D05587C5971E1A891EB452D5805A4CC05E5525217C8532F4E364DA6C8E1C387CBCBCBF1F539151572C9B83DB804E202714B10B087066298B82E3490B2C8830390C243889008980216B2A81190691146021191AAAA2A72B1100E5C';
wwv_flow_api.g_varchar2_table(1024) := '5151C1CD23D0A66AEE048471F469026860F32611D8044852E4D542403C5E79DC71537197D2437946010177178F29EE7F22043A087726110D1D4EE9E6DC81BC29A314A7DCD58C9422130E8791A7B712788B472FE0D6E5F516373CB924D2D1B863B975E9C5';
wwv_flow_api.g_varchar2_table(1025) := 'A473038BAAE94A047A22DD87470AB66118CF019E69F44A1EC8DCF67458F82A4578BED1477871A609D004BA0C3D5133925AD0438D5444220F5B0CABAEAE3E77EE1C7C9B8AB007DBE865A4234C43E0BABCDBC20C5AC7C38714F82D6C969F00D83EFAE9BFD4';
wwv_flow_api.g_varchar2_table(1026) := '4811F80FB9305E1EE03C7879B0F0ACA0B7A296A719453433644422C0645EBB95E9630F669059A183A62C13367D35E84ADC6AD22BA6EC18ACD56C52F8BB178CF6AFF94F22D1CE46BB5F6DFF7B4F9543A4C3D572B3B2A7F6FBF5DEFBD1DAA88A3B5F317C6D';
wwv_flow_api.g_varchar2_table(1027) := 'DC55E8311B74E69CBDCDAC4683F5DEAC0758A3838664DBB231307A219278614BC462E6EFFE86BA9861F9AA39C4DD0E68F37DE6ECB03DA0D0B91A113399EF2B24EEB463E4463BED3AE5BD8E46B7DBA2E8B258B176B4C7751F877B9FF23E70115D1693C29F';
wwv_flow_api.g_varchar2_table(1028) := '08C6AF228043155F1949A6D97D7F3BB7229FBEBCB9C517AE93ECF73E68F23F898044E07942E0C1D3ED5959851B87AB84B3859384B7C4F0209E102E0EBE1111BC2568274EDE810307608938437848501A380FA5B66EDDFAE9A79F4217F1C938650001470D';
wwv_flow_api.g_varchar2_table(1029) := '3243593C399812A3CAE8C7656C6D6DBD78F1220AF9EDE14822F62306EDC1B1A338EF06F0A220457863A45323DAA805378B4A71BF1834FEFCF3CF1924ACA9A94121BC0E2578720823831EAADEBF7F3F115236030E6E22D40E0B4F9E3C89D3B973E74EDC3E';
wwv_flow_api.g_varchar2_table(1030) := '0C806EE177523BA778A5C08249B41A28A0B878B7D8805F4B2BA8F7C73FFE31595447BD070F1EA43863E90CBC603963358C9040EFB11F3F155F19FF153794B258488B809186087C702291A739580592104EC66D885329811704A8C5481C681C74DCF4CD34';
wwv_flow_api.g_varchar2_table(1031) := '1019D0C6781C6EAE1495E2A663331748F0495E7630AE8B55B408FD58221A8ECD5C11EAE2CA7221284871AC85F462309E2E4DC054DE8CD0A8A3478F8209CD8163E3AC0311D7911707C4298801E2350AAD4015B70102C0821B7DE6CC19C694C4F5E26E4109';
wwv_flow_api.g_varchar2_table(1032) := '50D364AAE0A2E0D373A42CA578C580AB4D29ACE22EE22DC3269B2FC524020F23C06D4922773BE48D8E40E036A64FC151E9B6DC72DCAB9C12B81BB5E2DCC9DCB4305BD82F1D872288D1B9E85028A46FD2B998DB0293249D9B1C3D0C1D73C3A381270CB540';
wwv_flow_api.g_varchar2_table(1033) := '4AC5A392374DDCEA3C57E9503C3FE1BAD4FBDE7BEF5123CF0A9E039CF21CE6FEE7BD244AE0E7C78E1D83FAF250421B55F0CCE1F940F74100CD184607218BAE478D743DB82E4F4B0CA32C5D8CCE850DA845805C9EA51F7FFC31B9348A1AE9CB745E9AF0C9';
wwv_flow_api.g_varchar2_table(1034) := '279FA0041C68387A7810FDC33FFC03AFA288F3644003AD46213F13BFFFFBBF8F1E28312918C303845C14525C06898044E0FB4300A29DEF79B2EF9836694CB1DFA9F8EB37292CC52402120189C00F8C4096373EF300D3C339C36FC3B3C11F82EAE0A2E181';
wwv_flow_api.g_varchar2_table(1035) := 'C1CAA80B42C8581C5E91188580AB10F0992042829F304081F327C6467089885316AF0BA70D968857049D8674511CEE4A2E5E97709538E21142F6F0B4E0510843C3B001FDF05B3C4BB831C27878D485B74A0ACE165C1D85544A2D7890980D55638C822210';
wwv_flow_api.g_varchar2_table(1036) := 'A427020727186A8761F8A0349326E065A20A6B6174044CC200BC5EF041393E22A31C4862390870140660033412AF1131C118714971199167C49F74D003194E6929E49052D80FBB665014A8196E255090AAF18C21A548620392B8DAACC7C329368000B580';
wwv_flow_api.g_varchar2_table(1037) := 'C9E6DB888534019089602465410F3F98A6D11C9AC64B0A22305EB00576DE71600646D23A1C5C60C1422E197E33EE3805F1EC71D3795B0174DC36DC2DD80926A8C56CB82BAF00104646184915341F3D34843632A6843DB4050328CB4D82614212F38813B8';
wwv_flow_api.g_varchar2_table(1038) := '9AC04541ECA12C971E018AA019481113F86F1E04292911D88000772F03B0E22EE596A35F10E86EDC72F45C48DDBD3B71239D23911B92524450C8ADC8FB2C6E6C3EC120422785D3D27FE917F052E23C48851EBA307D10796E7EFA0E02E2C9492FA3AF319A';
wwv_flow_api.g_varchar2_table(1039) := 'CA295D031BE84D148470F2A0A3375184441E1148621E66D30BE84DBCB923970EC50393670236C34B45C0305A41CF2282B5D843119EAEE4529C40CF429500843816528B48179D8E53912ED0C0008445298EC47910DDD3A4A7161E98BC05E0814C5D225768';
wwv_flow_api.g_varchar2_table(1040) := '964789804440222011900848042402CF0A81674C807159E021901F1C1A9C333C1E9C363C399C2A5EFC337288DDD06058105E0E711271A728C518206E109E225C8E44982D0E10BC056DF052881CF409170D311C4D26CE918E30E99025123538A897F1BDEE';
wwv_flow_api.g_varchar2_table(1041) := 'EE6E6AC799A3083620C090058E174E2192102A1C44DC326115FC07CE866387EF058D444C1880638A9BF8444E183633D248412CC441A42E9C51DA029DA32DC2C92351788468A63A248547880CA642E484182661189623463A9A29883D904612A905A0084C';
wwv_flow_api.g_varchar2_table(1042) := 'B706076827348F61137C59218F8F4B33810E7F1A3D10694E45BB0010A84109790AA270F36DC436AAC6ABC618ACA28D5C08CC40035924620C47AEB8809DC12522F8E85C749A462BB0936B411390C757A699580525E6489CB260429C6BC135E23EA109B49A';
wwv_flow_api.g_varchar2_table(1043) := '9B842C021A80975C0211DE652000CDE696A316DA28C438522F47A08612A007E5D886006DC7CFC63098301E3F644358AE15941189C05320C0662336ABDDE574738FD9AC3625C30C471B777B61A8B0285464B76767158ADE219473F3C31BE9F5CC41A01BD2';
wwv_flow_api.g_varchar2_table(1044) := 'A77864717B93C2B38E3E4B9C7EC1F3013ACA340D3A32CF3A5E2771D38A1740E29D17CF40BA303A452F86E8D223E892DCF08CE2D243D1439747215D06CDBC9EA333D2C5C4DB4994938525BCB9FBE8A38FE853645144306DD48A082922914AE93B3C4F60E0';
wwv_flow_api.g_varchar2_table(1045) := '744C5E75898E46D3788EF1B4C73CFA1776D2259184C963034F3F483BEF9B783B4907248B375080430AAA68236F1B11C03C9A237A2BD66EFEB924209547898044402220119008480424029B41E0191360B8043E0D0E1093EBA0581C71B3706BF0F0709518';
wwv_flow_api.g_varchar2_table(1046) := 'D3C3FBC1DFC293C3EDC3D1C10762F802F728D756CDD9A220EE20A3015059647007213C785AF846F86188A1845156C89E288EC304F5625091410F28169214C1243C30DC350648614A086875E1DB419090C40C4A612143D3820E096FEFE93C309C481010B4';
wwv_flow_api.g_varchar2_table(1047) := '10E3215A5882D309DF66D813AF144A263473A422ECE1482ECE1FFE22AF06084C3804259490AB41870C7AF03B7158E1D5A8C5FBC483C4A1240588702B85C32ADC53F02100380D14ADA6222AA5D5204959FC544A6DBE9914C751868E32AF1230F9A017028C';
wwv_flow_api.g_varchar2_table(1048) := '9B8B7EFC57AE0506A0168F9623557099B8CA505950157581B618FBC51E1221C394A28114478F309223ADC02AD1528801D745184911B4712331004E2ECDE4125329EC9A5718B44B6B26F72130D27CC4780DC1181A3228413332D0097C6E00843068A5B4DA';
wwv_flow_api.g_varchar2_table(1049) := '654422F0A408A886D4627232AA2C43564D767D4499552DCC16B62EC716C622834BEBB32C9225FA66AE667A134F27FA110F0AEE6D660E33F597A92E4C39A64FD1FDB9397947834E7A13DD9FAEC7138C87007732A7305BBA245D8CEECFFB2C7A3A59DCD5C8';
wwv_flow_api.g_varchar2_table(1050) := 'A38DC782E8894C45E66E87EBF2A8A420111E1A14A493A21F0338C27B49E72D124A90218B8012E2188C7EDE7C11876C43ADE1F89D9D9D82CA2243600C9923EC97DE8A12BE47A0BF33DD9AAE8A729E6CB48B5F016659D3640690E98CE4D27351C2B70F3499';
wwv_flow_api.g_varchar2_table(1051) := 'B2F4535AC71309FBD12FBA6A2E5C322E119008480424021201898044E0BB23F08CB741C207827C8A010AB82B2E1A0E137C152F07A6846B85AF0663811FE28A317A89007C06570C61C80C5E144DC269C3D3C28D83D2E069E136519C5CD814DAA802B70FE2';
wwv_flow_api.g_varchar2_table(1052) := '840CAE184E129E1F92E8A42C6C07C78B23440BFDD01BE24852350418570C270F9DB8899841BD0C4A93450A83C3D422283792A4E017520B912745193D988A557890A8C5006AC1BFC42446A4A9945A38C560526897D04FBBC00DE70FA02822DE23E074820C';
wwv_flow_api.g_varchar2_table(1053) := '4E21AAB0193F126B310C614E693B5E237C1BAA0CB0B89E027334934263A90E63C01F1C288555A25D44F0A481825248E2DD6EB28DD4C8251363E968A67578D25C0E2E194672C9681AC072CA6515B05317468ADA455DD8492235022F06602497152870F469';
wwv_flow_api.g_varchar2_table(1054) := '26CA298E6DB49444ECA45134013E40ED04980047800255AE3BB978DBA8E272832D6A010700D1893D8000D7A5F994C2069ACF75E1DD01ADE05D0359E236D864F3A5D84B8F00B71077B2B87B3734961B921E4A1637B9C8E20EA71744A3319FDF736AE4E385';
wwv_flow_api.g_varchar2_table(1055) := 'E8F4D8CAA0C564B9317F762DB934171B67F1D68B938757624B132BC3015B51646955A75378BC881B95DB98FB901B921B958EC0FD4C7F27CEADCECDCCBD4A84236C908A4497478053CC104F2ACAD247381248873073E481402085E23C5E90A422F48B0EC5';
wwv_flow_api.g_varchar2_table(1056) := '746822F40B5E50924B77C3069E18E8A79B88148AF080A2B7F24E0A011A4BC74421E914A4672186856451238998877EAA1610D17F6905CD216009D6A2871474D24F6902BD9B473D5D4F68A02CB9C890720FCF28FD9A38666FB804F2F4054280CBC7B39D07';
wwv_flow_api.g_varchar2_table(1057) := '2FB747AED9A4735770D7711B70CCCD92718980444022201190080804700CA08A82F76DC004E70112C4D8183E09148653712422780447BC1A11F80DD282D0C32991FB03621B546B9E07117C3511A8066B08824BE0A9A002274913164AA019A27A4EC9420C';
wwv_flow_api.g_varchar2_table(1058) := '178D22F03A7EF6C812744BA4A3815F41481489384F1C05F3A12C4570CB10A0FD18C02F256591241D49E1D5914511116827A590440623711CA146A4E0B012288B06EC817D01101A08A22EAA20904E29A11601B4D110340BB5E8D97CC042A181225848A578';
wwv_flow_api.g_varchar2_table(1059) := 'A2184004DA46228020C029D65285A61933288BFD548AEBC04031540D7F11DB44116CA608A794A57594150A7143294B418E48228324D70B4952C8A50ACD2A221484221250025068D36CD864847A818B2A78DDC065C299066452C425A6755C6E71270029D7';
wwv_flow_api.g_varchar2_table(1060) := '9A20AE08329485336B77AD20FC5842597209A2990888468106000AC33015FBB9701C69172D6598974175962BD37885682CF6A00134B8EE4490A45E810FA7CC3BC0725617C36B7F8AE66F122529F6C221C0EDC73C5EDEE26DE8F8A2C7F1068A2CEE3471CF';
wwv_flow_api.g_varchar2_table(1061) := '703BD1C117E617FCE5CE7FB9F4FFBC59FD7B33ABA36683F5D8F02FF3EC8566BDA5DABBF5B3A17F297657EB54FD6B65BF3937B6AC33E818E6E506D690A1221E0E9C928842FA0E71CCA00AB2B86F3925912CEE5BE2A413279D5CE2048A93254E73B3449C5C';
wwv_flow_api.g_varchar2_table(1062) := '4D0F11A184443468A55082669128E29C6E0842093A8585C25A4D2189A4A0815268E609831E5248E7943829A24604442E6DA438592297A3D08012E2E46E30409EBE580870B999FF257E95722D279D7722BC25C1ADE1989BF5F838F7E8EDA1B9C8DC5D3A41';
wwv_flow_api.g_varchar2_table(1063) := '719EA3B0AA967BF6F1459E287739A1F65FBB515F627317546A05872623E6C844715D35BD306BC0D8BC5F9DF1973668024F11C976B64C9AAD89B2FF330D2D45E7A5F7653B7EF2DE3648BCEF7A582D597A1D9DFD9E5832856FC2CBDE5CB1EC14934CF61141';
wwv_flow_api.g_varchar2_table(1064) := '8F4703BB46E1B13D2C86007B2CF138C117238E984EE1F46BAA34B5F444BABC3855332ADB1E633C6A49E25DB52626231201898044E09923004961221B83A0C2B5D0F4F35CC2B767AED973B70D127448B3924727AC46D88AB9229D5322229D08CE103F875A';
wwv_flow_api.g_varchar2_table(1065) := '1662424044880BFE2612B517C69CA29C4109ADA088E05109794E45112A2268A78FAC0B4941B1845A5150B34468DEFC110484068AC0AF44D5222597C891FEF045D5D0A0690C838852B936D340D16A9195AB1FAA29EA121EE40649CD2A11817012843CC727';
wwv_flow_api.g_varchar2_table(1066) := '0D5A43180B129688DAD1C329018A4B10A75A5DB83E582538A7708249D9902BCC438C40F1DCC672CA45E7BA108813F09861204CAA641009552291234A08E25478FC6813581161880FB78C5228CF2DA515971189C0E611C02F5C8D2D67D44C85B701D2BBB8';
wwv_flow_api.g_varchar2_table(1067) := '3E57EE6D4824634BF1B9D5F852D8DD48D6627C7A39CE7415BD927DF87D2D70076A37211D875B5ACBD6D237B041C490D172C51D2E4E73B3449C5C2140112DA295D522B9B99A01B9114DBF6621FA35855848DFD4B40919523401AD143AB5F8C3F2A46889B9';
wwv_flow_api.g_varchar2_table(1068) := 'B5CBB8448037229F1DEBF72C1D37D674F41E3BF61FFEC066F1849F08960B8373C1B59B652DBB1E59EAF2E8CA2FFEF9BFFDEE76DFF69FFD117457C89CEC9BF5F47E525CC7F225D994C357EE76240F7F17021C89A72FDF1A53C74FEE7DFDED84C577F0C835';
wwv_flow_api.g_varchar2_table(1069) := 'DDCA6071C0DBB6A3BB6F3CD177E174A13DBD7D778FC172DFB7A1527A7BEFE4CAED2B67AB7C8686CE1D578617477A2F36F8AD755DDBF5C60733D4CEDE9C9CBF732991CC94F9AD4D3D7B4F9CBDBD3A3754EBB7D7F7ECD0191EAC937263323278F69CCD1CD9';
wwv_flow_api.g_varchar2_table(1070) := 'DEB125632B3D7B76C09F1A6F7BEB356D5325D1702A3DDF37B7387AE2CD7DAF2946CF8DF9F8E8179F1E78A77DDE5874F1E489D86A647743D85FB36503091765E55122201190083CFF087CEFEFF08413268EB970E4A63C32AE256A118AE7C61F3E15FA1F2F';
wwv_flow_api.g_varchar2_table(1071) := '939BFBC8B896A84572CDDE4C3CB7606EFC9B0CDEA05314C92D981BDFA024372B372E74E6A6687111D14E37D4BEC9D3878B6F48C93DCD8D6BF66B895AE4619B35E15CAB72E561D17C2BC80B0E5CEDDCF4DCB8565624E29143B97B7A7A384A575B0347469E';
wwv_flow_api.g_varchar2_table(1072) := '1A81B49A7199F26C46C7A9918373EB53A5EE5AABDE99D1A523B1C5686ADD6A744653ABB0DF7822A6666C627BCFA7AE4B169408BCB20840C9262617ABECABCEC696831F7C9E5A995ED4158F0CDD742762152DB503A36BC995096621D82DBAA8A277AAEBF5';
wwv_flow_api.g_varchar2_table(1073) := '5B9A22AAF356EF954C325E5FE25C75D6FCDBC7471A574FFE34188A79CA47FBFA8DFAF896BAB0C19E7DFFCE6BA72B97FA9CE6D8D96B63DD6F8F29CEF0EDD1F9A589C11B57461A674710B8707B3CB338D67BED465D68667072912C9FD958545B3B3832B3BA';
wwv_flow_api.g_varchar2_table(1074) := '385B53E43105AB6EDDEA37C4D7ABAA4AC6234A64FA6E45A16F26E3F5C4474B6A5BB5C1EAF9F5F4E4DCECC8A5737BBBB7AE9B7C67CFF476D7AE1B8C790CAFAEACAE988CBA4B17471BC37E5FF576ED424FAFA52E9D3FE7C8AC190CDE99D5F4E9B397CBBDBA';
wwv_flow_api.g_varchar2_table(1075) := '9357170A8A6FE5956FD5C40C061DB3006FCF2CD9967A479B779CBF70B4A228FFDAA9BEEAAD752657B126F6E5F5BBDEA9EBD3A64069DF4D5B45DED8CCFCDDF317DADEEA84004FAE24677A7BB776D5297ADBDD48FCEC97A7EF2E5D7C73D79688EAF9F2ECB9';
wwv_flow_api.g_varchar2_table(1076) := 'C88553BBBA0A750545CC59195A4A864E7CEEAF6124FCD143C75A75322211900848049E4F04E4C3EBF9BC2ED2AA4D21C0702EE3CC1BD8EFB79664845C8C4E7FABA41490087C2B024C25769AF33A0AF7AD255661C2858EB0CF1A749A7D6DF97B2B3D2D6E53';
wwv_flow_api.g_varchar2_table(1077) := '9ECBE86B0FECF3590A52E907A3BB0FABE5367E389114D2C56C8847E66E26F1BB6B10B57C931ED2090F5B82D98F4C7F587243CA3D7DD983A68108DD361787CDA7081B1E9617FA45D51B72B3753FAA451BEC7CCC29C5356B897C476D8FA9E8D5C9E20E6346';
wwv_flow_api.g_varchar2_table(1078) := 'FDE8527CE8C285CECEB2B8A3E8C343E72F5F3AFDEF1F1DBE7DE9C8A727AE0E9FFBECECE0DCE71FFEB7E9E9D1F73F3CB130D177F4EAD0C8A52F8616D63FFFE8C395D991B9F9C56874792916FFF8F0996B678FFEDBA113C3978F3031020C67A3EA78EFA5B6';
wwv_flow_api.g_varchar2_table(1079) := 'AD158311C7E2ADF353B1CC271F1C599C1B89ADCC5B8CCAADB9F8D14F3F5E599A5E5989E82DB693D7472F1C7C3F1E8D9CBC397DE2F047272F5CFEF4171F1CBF7CF9E8AFFE7579E2EED052EC97FFF5C391BE0B9974ECCA9DB9D1BEB38A9AAD42048F45DFD2';
wwv_flow_api.g_varchar2_table(1080) := '103607CAD5549239D00E071B2218744A4249A61B8A7D7BDFD86FB6043289EC16125AB831BDBE70FD0BB3DEA48F2756E289C8D47463B8B077DDBA38D1A7C910E9AA2BDCFBC69BC5C15047E71683D1E4F0D88CA6942B606145BB5C319FDD6CB4AA4E3E9933';
wwv_flow_api.g_varchar2_table(1081) := 'BB5D2E5B734FA39A619E5AF68B8389E5E4A5E31795F45A34AD5C3CD7DB581C3715B7F1003AD73B59181B2F6BDDCA570B41AB12083798D34A32DBA807EDCAAD42C62502120189C0F38F8024C0CFFF3592163E0E81470EF63EAEC0BDBCA72BF5AD6AA5C02B';
wwv_flow_api.g_varchar2_table(1082) := '8800F7522A990C2A15E586961A47472292C94B9717EB1A0B953A63CCD690D7D5E4DFD9E0EB362BB6543AEB653E32A0449B2DAC0930438174BEA567B564E24F47A228C587342C26A7A97DBA087AB084D59B37F41DD81D8B118AE506723523CFF7D27CE1AF';
wwv_flow_api.g_varchar2_table(1083) := 'F1C0DCDCC7C491E7BB060AF29DFFC8C8085F8A427D5913810F4A594E4F14C406B258629A75F8042C1C89B31C00DF0B6935B2B9148BD5F3BD031A48670B287010F2E8A10A16020076B4B10ABDD0465904A8941A35C9C758FBC82C0AB2E28056175503DD53';
wwv_flow_api.g_varchar2_table(1084) := '6B7B6415AF602223C0590E6C31CCCEC58CE9A5E984E9DCA75F1639339ED292682C31353D5FE688994A1B17A6EF36D5866F2F3966A7478E9DBDD610C83475759DBEB4E48A0E390BC2D545EE98A7FAC491C3F9CE78B0A0782D81D62C8BBB3C386B8CF4BB7D';
wwv_flow_api.g_varchar2_table(1085) := 'F91967DE95CB37EECC2DCE5E3FD9BD7D4B20BC45AF339EB933A74EF476766EF316D7D229E796D77C9985AA96B6CF2F4F24A76F969515674C6E25B91E59374C4C4DA7624BA98C717C66696D69AABED4535CD3A60DFF52519EDD98170C646F5183D1AA577A';
wwv_flow_api.g_varchar2_table(1086) := '7A9A4CD6FCA3977A95F91B2687F3C8899B75857157099F372BA9340F960491A985983F3363B47B2EF40E309E5CDDD8343C389C8E4D8AAF7013C974E6AB376B57C722C6D96BF9359D89B5B42765B0D99CA3195B6A6D8146C61329BE10A6A9F1B598C7E94C';
wwv_flow_api.g_varchar2_table(1087) := '5A1D732B73AC58EF0804F4D951DCEC64C090DBD8D4DDAC18ECFDF389F3070F2E2596C66E0F5DBB7CF6E0078713CBD3B786A7D87D4151D7E0D3A1A07D64D5AE24EF6FC04159192402120189C08B858024C02FD6F592D64A042402CF1102B01AE813246A6D';
wwv_flow_api.g_varchar2_table(1088) := '7D6D7D25B6BC18999D9B6559AC642C1D595C5D585C585E8AC4D752E94406F6FB3089A538AE308135DBC45E5F5A0A892C8307B72445706391C551B45F932422E25A84B2C88844E23040981E29C409A47F930691AB15BC279E3D88B21803A91389420971B8';
wwv_flow_api.g_varchar2_table(1089) := '25FC5C2C53919B4563594E0CCB85368E22A2C968A722A21D2988B50002DD650F39C83008C35D59480F8E0AD34603DC9846C12A49A70A5220F96CF5442978327152B016920C11255D1CD1803C65A98B52905EB649E3EB65E2D44229F4934B5990A72231E6';
wwv_flow_api.g_varchar2_table(1090) := 'CCA9061D71CA128888209014475288080174D2104E31121C443A02227743441497C76F450054EB838E9EB7F61DED5D9DEC3D6E7659CD9954757D65415976552A879D614D863D4D6E873363B51B3229AFC73DB7129F9998F0BAF44E4F5EC0EF5D584DA757';
wwv_flow_api.g_varchar2_table(1091) := '176D762B4B396DAB0DF94BEBE17E8CB71E3D76A5AD4CD750DF5EDFB3E7E28D093532A9EA6C539353B155969CCC588CBA68DA343535935C5FA1BBF355AEC767325B5D0E3B4B96640ABD8EC6AD95756595050D1D277AEF2813579A3B5B0716F503178F2E2C';
wwv_flow_api.g_varchar2_table(1092) := '47D69666596C546BDA6A42B9D93730393E39C85D918E865C0E7F6149DAE048EB32EF9FBA73EEC37FB3B9589E33FBA6ECC4C0C2F983EF2B4AACD063B1984A43015BD26AF2A8899ACAA2D594D25198C82BAEE60EFBD591EB93973F473E9252CF9FBFD0DC10';
wwv_flow_api.g_varchar2_table(1093) := '502C05F3AB89D8C242417EC9D4843EB5BAB4A62AFFE917C757EF5E46ECD6D452D0694D7A8A6616A7175663B7AEF68FCD8F4F0F0FF02280D701F3D3F38A9A64F5D196AD754943FEFADA4A32BAB6B5BAC0E82F5D5B594DC4638BEB19DDFA5C3054188DC299';
wwv_flow_api.g_varchar2_table(1094) := '1FACBBA13550462402120189C00B81C077FA0618378A1FF47BAF655F88C63E3B23F90D64F1441924021281571E01C17358E41C2A45E0BB74026BB0118741091EC567EA6635BB847B2E5A70217817949225E518BD84A7A1848262EC91ADC2D8229B15D159';
wwv_flow_api.g_varchar2_table(1095) := '359A999F50267826448E95DB58798EB2ACE5465914B2DB10B40DBE47BDC823C3910D87E07B10396C201047120D50449609646D794E2905EBC62A34600905A9251C0E1321603FDFC9334CCA512CB14E71569B23056A4A152CE18B7E064B3103013830712A';
wwv_flow_api.g_varchar2_table(1096) := '62D13EC418FE453F2D1234984A8933804C75D4C23648088BD5B63186B6B009136AD9D8000B21B7DAE2ED9841634961D3324674D1CFA9D040E48B2FBE10986309918E8E0EB61406736C461825EC53F0E5975F523520B07513F2542A161FE6A2B01C179C8A';
wwv_flow_api.g_varchar2_table(1097) := 'B654545460189B15A30464B09395EDB1877A294B73C4760BB448588EF1106634001DFC9C2218438D4822431697EC1EF0060CE3BA700A1BA7690840898197EB4811AEB580170D323C1E01061E5B9B8AFD8E5449B9E7C6AEB7F3F4336FFC64AF7E6558C737';
wwv_flow_api.g_varchar2_table(1098) := '080E5B475395A7C059E333FB3B7698ADF69D5B2BFD21D37B85D5E317265393E3FBF76F71E657BFD6129F4D6EF3A617DE79E74D75AA57A766EC56D64AD4A554A5D265DAD670A0B4AC7CBFB3F8CA684F85D7DAF4FA9B53130B55015359615B7E5528BE75E7';
wwv_flow_api.g_varchar2_table(1099) := 'E4D4744BB1ADB0A22361081679BBB0F647DD5503FA5D8C09DB1CFAA462AC2D717B4D5DB660B16F35B3ABABA52C3F7123AEF3AD2C296A263B787D2F4453EAECD878D01B9C988D96A4137747E6575707F73694EBFDF5F3E7862A8A9D534953E5F2ACC35F1A';
wwv_flow_api.g_varchar2_table(1100) := '657FEEB51548667391F3EC96FD43776EB794FBCDFEB2D8D0AA519FDED55EED0E54F14059598B271D6BE88EA732A52E5DB8A9871655E4DB26EA5A8706875E6F2BB404AA62AAB21C594F27B32B47BFBEAD76E8CABCD731DAB2AD2712D52F8D8EFA1A020B93';
wwv_flow_api.g_varchar2_table(1101) := 'D305E14C2C95599E5F6279BDBA80B1EA777FB21ECFC0935B3A02CDD6E25826CDDE91ADC5F6F9946D6864CCB2BAF2C61BED8A31FB1891412220119008BC88083C3D016614219652AF8CACB1F6E78BD8F2A7B6399D514A7CE6800B775672E0A74651169408';
wwv_flow_api.g_varchar2_table(1102) := 'BC2408881160480E0BA1439FE051A4C0D0A0370441A838153489886836594420875029781AA544401EDE051D159294827042A220C68C58429511A3202C8BC14CB813146E70709075D13942F0E087503528165FB9134192886062702D66080B26B667CF1E';
wwv_flow_api.g_varchar2_table(1103) := '2243434328C76C681EF41BE20A8BA608FC0D428E55D4086183D7918561F03722D0728CA1382C0EFBA1AFC8632D062043758CA3528A56C0E111A35EF82DA642AD99905C555505BDC46094632DA6B2DC7D96704722E881DB0B1A0CB78479629BC04D180353';
wwv_flow_api.g_varchar2_table(1104) := 'A52029446814F65311C8533B88010E6214011C64A0C1D4C5DAEF22970865318F74F61CA614C7AB57AF22892AEA421BF41B19982A0D84B1830963D1008E316CB706F50528F00107AAA375B76FDFA65202325C504EA1B5C8D0408A736591E1DAB19B1DEF0E';
wwv_flow_api.g_varchar2_table(1105) := '08E402110012014906ABA91DE5E894E15B11A0E7ECDB5567D357C0597FFAC6364B6AB5DE95B73057ACCF245D5ECF1BBB420E6383D3604FBFFD5B36BBE7370FB47AECBA26B323647F4B4D4683BE56BDC5BDAD32B3E0792FCFA1DB5396B7381BD26752AE3C';
wwv_flow_api.g_varchar2_table(1106) := '36D8D39915E5676FB5B95DD9BEC94ACBF9BFF9538FCFF2E63BA5B1A5F926B3C966E27B5AE7DB6F1D48C5969B9A4D769BA9486735A5B3AB343797790B5D3F4AAC2F7BECC6A4D1E534547636D5985C7ECFFC22C3D27E7F5E28A937A7828AEEC166874E93B2';
wwv_flow_api.g_varchar2_table(1107) := '6D4B756743D8C49A55066B437D919A72848B024CA2FEE9F68A4CCBEFF046C6E1CF6EA0B0A3C6A72BF9096B53051CFAAEBDED2BD3F925053E96EC0A87CC258EE6D29262C568E721F2E3D7B6388D35C8BB8DFADD5D1D265776738722B779CFCECE95C5E9E2';
wwv_flow_api.g_varchar2_table(1108) := '0297C915D4ABCAEFFDD64EEC437E575D68DCD66337C542C52591987E776783BEA7CE6D26C750E33794FEF65B8AD1C5C3CB6C34190DCABB9D8D469B51D1B3E591B1ADA5C16ED6AB19437343AD434D15844BD8C483BA649008480424022F22024F4F807944';
wwv_flow_api.g_varchar2_table(1109) := '2EACC6FFF5D4C83D47EE456CFB53DA1C4F66FE434FC16B8D72079DA70450169308BC340840F0E042A74F9F86C9D028C14E398A538E224E848000244A44C411C2462224104604FB621C155244049226D82602102404185F85C8312C894231C60847650974';
wwv_flow_api.g_varchar2_table(1110) := '38245BE131A4097363D41772058784896115346CC78E1D103F182CF40C0D14C400B2A0CD303128199C9952703F5288C399290B87A45EC63621AE6C7D4C717211C6306C402D1B686315FC90E6534A0C446324649852C78F1FC77E082DCC16460DBDC40678';
wwv_flow_api.g_varchar2_table(1111) := '20461267EF3E982145B0A7A2A202771FB6091BA414D62240A50CE46AB8512394126B057B44212416D0E0CFC8302C8C0020509023E928240583C59153DA8E9DE492821E80C254E4C9429E803008A0ADAEAE0E494C052512B9048C4BF3A281D70440079D06';
wwv_flow_api.g_varchar2_table(1112) := '3AF0813CC3E7B916404133E1BA420FF244A802FD14473F6DA152AE08D708482902C9479E2623037316C2A2B83C3E1E01289AD7CDAE3FD98D7FF25CF72345A1A028E5BDB7ED5D969059B2AB3AFBBDD99B8450107CB09F90C5A82F2CC8E6120A430522C2D1';
wwv_flow_api.g_varchar2_table(1113) := 'A453FCC1FB5BCD9BD85E313F1BF7A2CB5EA4C9047DBCA7B8FFAAE2DE9E42D9FA3029E8732AFCDD0B3ED77D015B61BE48C92A51EED728526C265DB8F4C19ACCE5A5E8C90A40BE4B83DC48F7EF2552DC369362BB3FC41A705A03CE6AA1A1D0EF56F8BB1730';
wwv_flow_api.g_varchar2_table(1114) := 'C0EF85F166492FF3B42D9EEC56882214F81D05FE4A1187F81604EE37D062D05556148A74E0745796DE2F00B2D90AB31B378AC0F43E9F238B36818A98EF4D840A5CE50F8ADCCB94078980444022F0E221F0F40418078ED5111B42A6EC24E85729B09684DB';
wwv_flow_api.g_varchar2_table(1115) := '948EC5A22C9EF22AB55BB65522F0F22300FFD97C23B3CF408B051AC39821A5C4A0AE282EF8AD4814E9F02B281C1451F02E12918147412FE157502FE8139C100A0A5D4498B2904CC81832C4A14FCCDD65C49553D8235C141E28681BEC116DA4A3104B1875';
wwv_flow_api.g_varchar2_table(1116) := '244243E0B128873D522329C843C6E081D80091A3522C17AC183688069443E7C885BC31228A068A10A114B48D81DCE6E666C448645C14E5F040581C36904B3A4A3012610A328A2B865B91A40A5A840001BE873C2D65F4955650116DA40AE419CBC524EC47';
wwv_flow_api.g_varchar2_table(1117) := '3389182C90E4489C2C22544411DE11D05878298C14A64D3A3A21990C2FC3FF692C0620434320A8588855F0585210C006EC67249CB608FD184CD3D0065D471BF82003A45404C786096B6218093E5C44083C9630E22DB4218012E2E2A50059A4708AD9E04F';
wwv_flow_api.g_varchar2_table(1118) := 'BBC8056ACA528408F600352DE2650156810363E3C88B8AE4512220119008480424021281EF1B8127F0F63698C2FC5FAFDDF4BFEE0A6D487F154E554565AAE3ABD052D94689C02B85C093F210B80D63A41098CDA00431D3A81DEC8800CB82EFC10F191584';
wwv_flow_api.g_varchar2_table(1119) := 'C2C1BE6086F043064BE160304CE82BC49291617814AC95F14F6AA42EE825840D4A8CC1F040681E9C9038C521CF1C51C83C61F833B5A019564C80E0718A184A50CBF7B11054D4565454500511D249442DC49E2AA8143E49EB606BF046026545BDD4027FC3';
wwv_flow_api.g_varchar2_table(1120) := '720639A19A44C4B828478CC74EE6FD5216A24E592C410955534A0C992223E2242286315D5D5DB05F282BFAA985749A4915A25E882815411D4981EE924BA3408F1609AB38254E13D04C0A06208900605235168A5C5A0A50E26289C66230D5511C724E71B2';
wwv_flow_api.g_varchar2_table(1121) := '10A6ED0CF9A28A53E0E5941AB19C23DAA0D908730A68348DBA48270274B059AE32D74ED482CDD4484BB11FD2CB29AA3805166A14E45CD82F4C924789804440222011900848047E0004EEFB191B6AE2E75CA410E1D75A04DC147EF5097806FC72E3AB918B';
wwv_flow_api.g_varchar2_table(1122) := '93B1A1AC3C9508FCFFECBD57905C479AEF77CA5775D9AEAAF6DE1BB481B7043D68866666C8D9D95DDDD1DD2B3D6C6843371471A527BD4D48AF1B21DDABBB2F52C844ECDCDDD9992187B3F4044110DE9B06D0688FF6DDD5BEBABABCD5EF748207350D4312';
wwv_flow_api.g_varchar2_table(1123) := '040812C81CCC619ECC2FBFFCF27F4E9FCA7F7E69240212811F29027021F8150C50F04CAD157CEBA034705DB2A03DDA1712018A1034C97B4428955F10493EA47C517181C20085EF51446065F028D49228181AB7D039E4B915F4955CD81D578AF389463365';
wwv_flow_api.g_varchar2_table(1124) := '912168C5F146922EF81B1AF874131083AD0979F4F3614703B7C491411893504B402DC20840F6A814964B0A668B7A85240AA98E40962885014CCFC6E9CAAD504B841AE1B7F8B777EFDE8D066E9117CE52CA8A146E71C642D4A99414029688C6121150C0CC';
wwv_flow_api.g_varchar2_table(1125) := 'D18F42EA15350A4A89E5D8093EDC924B5CB457C08B124A91CB00046A452EB6918B1811B2D086182D85668B710AAA400053A99AFDB1F6ECD943EDF055666B7385D952172DE5954027294C26470F4A28820D9482518303FAB9250B1B84FDA480B9D08F12AD';
wwv_flow_api.g_varchar2_table(1126) := 'BD6A9B1F97009EF8B719C1A1EDF96D229D0102061770A48B2186FC5C199708480424021201890008D025A03FC624B20D3F91FC80F2BBC9722AD616F133CAEF35B7FCA47225F0FBCBEF2CFD0A7EDC2948E04799C02F91F6632422F7EF01168F073BE47392';
wwv_flow_api.g_varchar2_table(1127) := '08480424028F0702DAF7F19B37876FE07D7F06F94CF3BD161A888B4AA1529AC27C8F315F73BEE95A16C2C2CD480A1F77511601BEFE9A8CE07BE296EB865C8AF09BC15508887A89F38321B4890857A82FC8405D44BA566FBE42AD1406406C844E4A091B28';
wwv_flow_api.g_varchar2_table(1128) := 'C8EC5F6E692FFC935CE29A1E6103595A4151114D165928D7CC13899A5A5489E623834251AF90113F84A410F2D113B91880FDE8CF3752008E3CE9A238111A0EDD4539554089190101375117F2788C853066E4B70819A18D5C146AC6884A49D19E3E023248';
wwv_flow_api.g_varchar2_table(1129) := '04240212018980444022F0BD21F05D09F0F766A8AC4822201190083C7E0808AE95DFAEFC94FC3832F7BE154AF265F2E3B7E76E5078BBB028727BC17CC9FCB8269F9FA8C5C5F257D8EF1DC56EAF4513BB6396A6365FECF6C4FC94FC787E29E277CB12E950';
wwv_flow_api.g_varchar2_table(1130) := '56A637C36FB92508E7B6180E60063BED121A4821375FF31D6FF313F3E3F905655C222011900848042402128187878024C00F0F5BA95922201178DC10C05B28C2E3D6B087DF1EE1A77DF8F53C941A34FF36DA37344423B11BD21F8A1D3F1EA5DA7C810765';
wwv_flow_api.g_varchar2_table(1131) := '32430B0B4B91E8DA9292CBF8DC054E2F3B2DDF9A5CCDB0CAF4D4B2CBBCE629AECE4FFFE6B5A37F6631940A7312588E03878CB65B1B329335BB18F2D9B2919C55175E2E547790BE394BE29BEB979212018980444022F0C3414012E01FCEB3909648042402';
wwv_flow_api.g_varchar2_table(1132) := '3F740460BFF80335CEF3433757DA27117844083057FCC1D60CC53D747CC0B2725E5FDE64981D7FE5ED974D8E9BC7F950D1D5D9C8954F3F7F7E5FA9A798ADCBEE879D26B3CA1F0E5F69350C074D1553D7834F1D785131DD3C138896BC77F8DA1B2D91615D';
wwv_flow_api.g_varchar2_table(1133) := '6BC1C817BB7EF6D7F757C57D0002F7BE341E9CE93BBBBDD157DAB8ED3E347C6D115A377971A26E2B33F96F1EE3F4B5453481C04CA420177255DC7A105AD6778C0C8F2ED714A74DF69B074A7D476DB2B84440222011D8808024C01B0091B71201898044E0';
wwv_flow_api.g_varchar2_table(1134) := 'AE084080F39D81779593191281271881873142C402F4DEFED9BD9671DBBE970EBEFBF10B2FB425CC65B3D3134E25ED282DFDEC786FF8F2B1979E7D3BA3E8A7A603E958B8B2DC174A5A22ABF33606AD3CDEB5E08A3E932D2BF74FAD6672ABF3A53E77CAE1';
wwv_flow_api.g_varchar2_table(1135) := '0BCE4D2BA96C59A9DB545008C1BED43BF1D4D660D8BFF7F3773EDBB7AF7D32AC24A28BC59C05565679A17FEA59CF72BAB885C3BC980430B5B0160F06FC9E8250CA54EED2A76CFE60603AA3331418B2DE128EC6B8B9263F91CC2E84C2CBB3E3D545764F69';
wwv_flow_api.g_varchar2_table(1136) := '7D20940A8CF655169AFDD5ADF96F47389A5A098596E7A7EB4A5DAEE2DA91857064F6464B4D91C55DB646AB2F9CB6E742B98C3B91CB8D0C8FD9326B75CDCD419A169C5B0C04EBCBCC0525F57373A16070D661CC5437342DC78DE3C3033585466F45C3722C';
wwv_flow_api.g_varchar2_table(1137) := '1B59995B990F3654DAEDFE1AADD2E5B5B0C798D4DBBCA17826999CBBF4697FC2ED2F489AAB5B1B938AB56F78C2955DAD6B6A8A250D530B2BC9E54013D5386F1EB92C94AC25B3C3432303A78677379AAC151C607EC3125DAD6D6F8EAC25DD6E9BCE680DAE';
wwv_flow_api.g_varchar2_table(1138) := 'C54C4A3214C9CC2D2F543B8DDEAAFA704A77636840978A97BBED86B2EAF0D2D2F2FC4A63A5DDECAFE91B0B188281BAEA329BB7643A949A1F1B3C73B4FFDFBE5D15B7148FF60F179BD3A5CD4DDFDBA08386928C480424028F310292003FC60F57364D2220';
wwv_flow_api.g_varchar2_table(1139) := '1178E808E0E912B33D45A75FEBFADF7E0B79669F273951F6A13F1259C1E38800D39D8D26C3522CE39A9AE8DC5C9BB4FA0E1FBF965CED0B4F0777EDAA5C984A15280983DE76BA3F307BE5D04ADCDCEA51E6DDB5C9EBA7B7EDDA39B1921EFFFCBD6D7B364F';
wwv_flow_api.g_varchar2_table(1140) := 'AFC687FAFB334AB22A13B4EF7AF9CA9FDEDBBCB5A9C8D3050146BFDEA89F5F81F4CDD5D7570C2CE57A0E7FE16DF45C195878F6F56D66B341D119E2C9B42B1BBB31173D7EF0705DA5C5A42FFFF8FCFC8192A5A5C6D7460E7E68F0D4551897F7BDF153CE29';
wwv_flow_api.g_varchar2_table(1141) := '134F602A943D72E80B9735B97021D6F596FFC2F99E64686E662CBB5F1F3396748756962D26C55358787D3A7CE3FCC716A7237343F13F5D78E4F8E9E4D2C4D4B06DEF81573E3D3B3972FA8FFB773C65F796F60CCF5E3BF665369D7C2D353A607F69E9D807';
wwv_flow_api.g_varchar2_table(1142) := '7A57F5E24274EB5EDF07074F56F9D772419DC5EE3E39BA1AB87EFA922EF3D7AFA7CF2F97C5CE7C987255AD0653FBF6172DAE65F5C988C7E31C989CA9332CAD29E5733A7D49FAD2F07CD2786524B4EAFC9963F952A2BDEFD491743CF64A7A7925D7D077E1';
wwv_flow_api.g_varchar2_table(1143) := '44CE6AD1057BDA9FF9372B91742A1274D94C0647E1914B23A9F9EB93C393DB6AAA7B8766C67ACEE914732CB5105FB1F91BABB2FACCE24AC8A18F5E38BD6C2BCBCDC4165FFCA9E3D295F4EACCD5B36391BF6AC8CE24DF8C9CFA4018B6F3E9A22BA37391BE';
wwv_flow_api.g_varchar2_table(1144) := '53F15973EDDE5F9CBD742D179A0F8CDD48E64ACE7D39343E76DA9A8CBCAC048A9A9F7D1CDF6BD926898044E0D12070739CF2D1542E6B9508480424023F6604D8829FB376390996B37008ECD74F2065663D70EA0F81E37FD8CA9F70FDFA75247FCCCD95B6';
wwv_flow_api.g_varchar2_table(1145) := '4B041E19024C06D6E5144E5F1CBC3A5D648F2EEA0BBFF8D3E1F8F2542014492E4DBBBC859E029BDD57F6DE916B0B2397C3D1E8C4C4ECD0E8986169B8A4BA66622513BAD153515F73F8CCCC4CCF89B558627A6666726E7169F052754DB1C9AE4E75463F35';
wwv_flow_api.g_varchar2_table(1146) := 'C453A94A87EEE59FBC746228ADCC9F6B6A6E3A3E169FBA7E4ADD19DDA09F58589B1DED3BD93B911A3DCE49D79EA2CA35C579EAC2C50B672F6597A62B2B8ABD25E59AFB17753391CCF2E28DCECE8E99EB9991D9B9E4F4A52DDDDD2BB6CAD99E0BD3A1F8A1';
wwv_flow_api.g_varchar2_table(1147) := '43277BCE9D54B291C072C2100D747576E1FEBD34B23C7CF1C8DA5AB877645C49AFC553ECCA1E66DFF294623874AA2738D93FBD1C5E99BC3E1D4C59A333DD5B5A5CA5F5914476616262536B7555437B20943BFCF9F17868B67734905A9D1A5F8ABBD2B35D';
wwv_flow_api.g_varchar2_table(1148) := '9BDB0AFC35F14CEECB2B374E7EF9596C7932B496BE787DBEAFE7E4C8D098CE9035E8756DB5E5614FC5E2E89983C706C2D37D93F330F51BB3932B45B1D5D28EAEA9B14B4A2E7D616CF18B435F0406CF073399C92FAF6E6E6FA86CEC8C641C03833D1DE5E6';
wwv_flow_api.g_varchar2_table(1149) := 'DAEE2DFD47C7278603574686FB4EC43C2F2400004000494441549D999C9B8DC657C3D767BADA5BA722D1442470AD6722119C5B89841D7EDBC462DA950A746F6EC72FBD124ECD0D8F0542E16B57BE981C9FCACE0E6EE9DAE4AB6C9E4B984E7CF1E1DACAE4';
wwv_flow_api.g_varchar2_table(1150) := 'D8C2C2EACC88FA7C649008480424020F088187E801C601227C200FC854A94622201190087C27041EF8FE551CEEBABABACAB6C0620760F1D1BB639C442439E7569C9A4333D80FF9FCF9F31066AC2A2E2E269DD386BC5EEF7DB7105F746F6FEFF4F4746B6B';
wwv_flow_api.g_varchar2_table(1151) := '6B757535E7D07274D0D76ABB7AF52A5B1C8BF37BEE280C6FA7811ECFAD3D81F2C502810067BD4206F213BF36CE01B99CA6CB29411CAE2B8E62BA63118E011C1B1B03E4CD9B3787C3E1B367CF02DA8E1D3B8431347068680860BBBBBB45718C01528E99DD';
wwv_flow_api.g_varchar2_table(1152) := 'B56B97F0B423D0D7D7575B5BDBD9D9C908C5C58B1745A5E22424C626400CCCD129E23C88AD5BB7CA59EE777C1C8F3C9137BCA5D81EDBB9FFD86FFEB3B9E97C22112BB2597CBBBA2B2B2DC61593D5A0B33ADDB178D2A24FB6B5D55A75E989D1646991C9ED';
wwv_flow_api.g_varchar2_table(1153) := '2FCBEAE27EAFE22FAD4C6527AD4A72536D59417DE994BEC0E3564ACB2B148B5D342D9B4AB5D716373FBD57D1E9B3FD57F44A566F30E88C8A01FE99CEE632EA31603985239DD3BA548A2C6A7C6A5FD7EFFFF367AEF94F7FF2F31DD336BF2E1ECADF822B99';
wwv_flow_api.g_varchar2_table(1154) := 'CD959614B6D4375ED00D6533A9543663301AC2C9744EC9D98C869262BFDB0DEF365872D9E2F2AA869A3AA546D77721E02BC8D5D55497BA0ADC4EFFEE7D35EED9B2FD2F3D17B396E812D74A8B7C35A575C54DC5D950AEBEC15F5F4B196522982A71BAAA6B';
wwv_flow_api.g_varchar2_table(1155) := 'EB95DAE2C1C564813E515356DA5C5B682B6AD42FE41A1A4BAAEB6AA82691C915BBEDE64C89C1CC8999A6D37D0B9BB759A64EF5DAF776172981C6F6AE8B89647A3562D2A5CB8BDDB5EEBADABADAD55E7D437979AAA97EE27C86ADD20BED167D49B1D5E94A';
wwv_flow_api.g_varchar2_table(1156) := 'E2430F478D06FD7C24D1AEA4B3699D5EA7A4159D399D9AF6943926AF9A74DEE9F1B1AEDA6D55B6606D63F3D99E33995432638ECECC04B796D88B1A3B94615D7D53714D5D754EA93E351C8C0DF497EF6C08F79D8FA762C924105AA2E1602E5B64B664ABCA';
wwv_flow_api.g_varchar2_table(1157) := '0A6DCEE2E2866FF78579E4EFAA3440222011F88123F0B008301D417A2AB21BF1037FFCD23C89C09383001F25C8D283FD28A1903DB1E06390DB542A05B9A28F8E5B1854C982DAB95C2E2204582EE9E46A808BF141081E62F02E786643430367EA6816224C';
wwv_flow_api.g_varchar2_table(1158) := '9C8214119F5341B005B5BBBD3950DFF1F171EC8137CECFCF4317DF7CF34D6189E07BC4F34B89F8993367608CD880919A18716A1102172E5CE0C45A8D008B2CCD24225AD8F0CDA7B848A1095A5B48E1164E4B29BCE2353535B45A68405E34565308AAD41E';
wwv_flow_api.g_varchar2_table(1159) := '0A8520C01075060BB0E4F2E5CBCF3EFB2C32B068DA488A20C054415B300FD25B5A5A5A5757178944E0C334ADA7A78736C2847946E0CC41BE8D8D8D3C8ED3A74FF3C84861E8E1D2A54B480E0E0EF22CB04AB341467E2008305DADA9BED8EF6CACECA81C68';
wwv_flow_api.g_varchar2_table(1160) := '7FCABAB6FCCC6B7BADBA59A5C0E6F279EBCBF4F644AB4E31BCFE54477C70C662B614BB6D0D69BB37A1AEB6ADF25A8D4D8C92E89EDBDF32766197D56C72B91C9596425B6B27E73D8B0642E13A1B2B9CFEB84EA7872EEEEDACB93AB57DB07F705F8DB9AA6D';
wwv_flow_api.g_varchar2_table(1161) := 'D7A6B959A7DF599372FA63AD2D9BAACE8EED1AEC1F68AF2BEBA8ECFA97E2CEC289F72ABBFFF6CC89B55C7852D9B14351D4F3A509FE0283AEAC8A7A4B9B8B1B4A3CE3BECEF3972EB9E3B1D25D5BDD6E4BC50B7B6F8AB9637623FB4851AD6E739D37B96997';
wwv_flow_api.g_varchar2_table(1162) := 'CD642977B975469BC3A42FAB6AD31BAD16BDEEE91D9D4B37A2B05747615985CE68D7B1DFB5BA11B6CDA8ABAAC1F3AC36A4D4697CEAE9DDB9D59972B30DCF7695276BCDDE1483AE3FDBCDDF9AFAE756148F95175B6A5AB68D5D396DB3FA2B5A738ABEA0D4';
wwv_flow_api.g_varchar2_table(1163) := '6D74599A5FA86B5DB83EE7315B5C6E9FBFCC58902986AF1755B453D5B65A9F52FB3CC523999C6B5BC3E52B97BC4E7B51494983B9FAF2D563D9F18BDBF657E91C2DF6DE6163DBB6D4F94F5CBED2A29628F21525651983276B5E64078594621DBFD45B595D';
wwv_flow_api.g_varchar2_table(1164) := '664DDD34CC6B3717D5D556177A751DBB2B2A4BFB86E707FAAE54149B2A3CEEED4FBD9A0EF7385D4E87DB871E192402120189C08342E06111607A21746558F0F6A00C957A2402120189C07744005FA5462FBFA32AAD38B48D386C0AE5F02B22B03BC14271';
wwv_flow_api.g_varchar2_table(1165) := 'AB920B31835812C8D54A11210547256E4C48F2962D5BDE7DF7DD818181919191BABABAB6B63658193E491CB9B867616E0B0B0B382A29C29CEA975F7E99565CBB760D97664B4B8BC6D6F091C218F7EFDF5F5252F2F1C71FBFF3CE3B5D5D5DE88763435FA9';
wwv_flow_api.g_varchar2_table(1166) := 'EBD4A95368409570A29E3B770E53A1CA705DE825FC192F3459478E1C319BCDA8BD71E3060290EADDBB776330DC153A4A2B6811441DF3F6EEDD2B582B33BE878787219C151515F85AF9F843C2219F70D79D3B77C254695A7B7B3B80C033E1A2C850167BD0';
wwv_flow_api.g_varchar2_table(1167) := '4FD5DC529C46A176656585E218505959C92F4855551545A89D564083F145FFE637BF79E699679081AF2283535DD840DB097FFDD77F7DE2C409182F30D22274BEF1C61BBFFFFDEF31666A6AEA6FFFF66F21C9A88200831EE0BCF5D65B9841BB28FB8B5FFC';
wwv_flow_api.g_varchar2_table(1168) := 'E2F0E1C3B45A8334FF79C9F8A3458039C82FEC6F711B2AED7AE5A7AF3EE5CC2C377BCAE7A667F5B9A4B1C0F74C9755DFF41A9D8E6737D74CF95ECD24223EAFEDE9D2427B469DB9B0ADD6ABF3BEA5CB19F7749497B95E4CC7567C4E6B85C7937CE96DC5EC';
wwv_flow_api.g_varchar2_table(1169) := '14ED823EBEFD4297D7A1BA796195AD156EFB4B2F24628BDB18962AA97AF3696F913DBD33673757BDE12EF5D9DF78391E5930D96D9160B0D06EDEBEBBD3602BDDDB15B7A6D948F926FB454FBDC750D9BE051F6FF7CB6D3E8F75D7EEBD2B1303555E8BBBA6';
wwv_flow_api.g_varchar2_table(1170) := '4D542AAE4D552E7DA663BD5AB8BA39B2657F747EDCEAB491E23329F62D2F2B26BB51A7746DAA18317764E26B3A53C1E672ABAD789728EEB11AB6ED86C9AB7E6C9745BFA3BB6BF286D5A57A640D5BAB0B5CB9EDF97589785591CDF1F27E5F71D96B6FD91D';
wwv_flow_api.g_varchar2_table(1171) := '96E2CDAFF81543416755CE997DB6BBA06420B5D51C0BEA4DB6E656B739EBCCB15079CB4F145CE15F05BB41F7E2FECEE529EBBE6D450E4EC2B63B2DBAADD6F85A5D47933BEDC8BA9E319555B6795E757B4A6D071C00BB79D3165301DB1FCC4692E9B5F950';
wwv_flow_api.g_varchar2_table(1172) := 'DC65DCB6AFC091BD6958434941FCD5A71DD125FFE69F3A7DC57B77ED5462335BBB4B1C2EC7D63DB6C9C1A4D990CB192D5F552EFF2B11900848041E0002B7BE680F40D99FAB109D983F4F93771201898044E07143806F1D2E4446FD60BF5C2199C2150C57';
wwv_flow_api.g_varchar2_table(1173) := '849EC11BA1B8A4089E76B7C6930B0783BBC2C79087BE42CFE08A3FFDE94FE16CD0E043870E411A59608CE314E10F3EF800F608F3FCC94F7E825314495CA99055E81F1E510824241CC3209F274F9E64ED31ECF1B3CF3E838E42D48F1D3BB669D3260821BE';
wwv_flow_api.g_varchar2_table(1174) := '508C440C3B290883858A7FF4D1472FBDF412B9504131959AEA301BDE7BF4E8D16DDBB6412FA90BCD705766596303CC1923A9172361EF540D3F875A8B2100AAA3383522DFDFDFBF6FDF3E982D9C135F2B849686304519790A42CEF1C142C841002E0D6F27';
wwv_flow_api.g_varchar2_table(1175) := '8BD6511C64A8179DDA3A6AD83266C06305A4B48B14AA763A9D584E22924545457060BCC41809BCE4922272192F403F0F0BCD50624CFDFCF3CF9944FD5D66A10B4BE4F561200029AD28752B0AFF949A1268ADCA6C3D4D75A2AE52F5041FF5FF5683D2585B';
wwv_flow_api.g_varchar2_table(1176) := '2912555145E5B77EA74571AA92F4781AAB3959E7ABC3750A6A4914010F706DF92D37237CBBB69ADB9B29B565EA3A6128A9E2AEE15253C952052FD339FAAE0E7578121DFB7F8203B6B218AEE712DAC4D569D12B165583AF52B5B69E9386FCF0E18DC1A592';
wwv_flow_api.g_varchar2_table(1177) := 'C45B6B1F5AAB7C0AFFD603CDB1FA6E36C76152BADB9B45FA3A1DBCB92DB3D9A8F317DF2A5EE2B2946C860FABC1AFAE81F8B3DD9BD793155439AA6A891734A8CDF155A92DF3AAC2E5D0F7AD9B1A8911D4D4F50DBD6C3EFCD87F16AA7C8E2ADFCDB6A814F7';
wwv_flow_api.g_varchar2_table(1178) := '2BC37CDCD4AE3F945AD5D56CAD542DF515FA7023EFEEAE0F7A537683BEA98335177847D6D53360A05736D7E300BF79965273AD0A93A8CC6F52FC9BBBFFAC62792311900848041E04027213AC0781A2D4211190083CC108402053C9142C9100298506C324';
wwv_flow_api.g_varchar2_table(1179) := '2196D02D87033AE624023C706304EE861359CDCDCD070E1C8067423EA3D1287E4ED6D6A20792493AB4108A8823170E0C61C3FFC9025AC160E17ED4482D4F3FFD348C116F27FE4F9CC3D0578CC1278C5B15C308D060F8272E65AA80913297182E0A954539';
wwv_flow_api.g_varchar2_table(1180) := 'E9CC31C6480C10AE6958F773CF3D271612C333294E157883618CF848A91DDA8C3016520B89D0660824BE5FB825AE6C9AF3CA2BAFC08D3106572D749438EB93691AA5D0867E2828AC15320C2C58AEE1A345901471ACC512DCCE507D54510B45B45C5CCD34';
wwv_flow_api.g_varchar2_table(1181) := '017B48C418582E74975100083329042645C37589601B8311000231A61429688387C3FC1971A09918A916904122F0B508E4148E537A76FF567779CBD7CA3EE10278B0B7B756BE78E0853DCF3F672F867533A0218344402220117864084802FCC8A097154B';
wwv_flow_api.g_varchar2_table(1182) := '0424028F0F029C0162C5F7E8C07F08A963B6A083656B2E8FC369B71498F506753D2DAEE0DBDB0B6D833F930E3D136E6408334A206C703CAE7826492717A288279308F24C0CC6470AF3847612A0C7DBB76F87FEE186855E42F0085059BCA904EAA52C5550';
wwv_flow_api.g_varchar2_table(1183) := '1C0E498DC4D18C33168F2EB9D048E2A8450C3B11835D53299E5204A0859064E606A31FC360955848ED58425C588E4E5A2DE288E1CE85CD5EB972E5E0C183504A9A80F316C735117CD4D05D2A15549922107536C4429E7AB9DD10B04A0C1F680042BC9167';
wwv_flow_api.g_varchar2_table(1184) := '2A3892D48B1944A80B348830F71BD2CBDC6F6AC15AC8ED279F7C82188E6B783871E65AC3DE71B3D328CA7EFAE9A71806578736539C22DF76432F4AC9F0642200A9AB2E2FF69543E76457EAC97C0564AB250212811F2B02865FFFFAD7F7B69D6E8716E851';
wwv_flow_api.g_varchar2_table(1185) := '11E8BB10E83351906ED01D8B53848E0B3D8C3BE6CA448980444022F0FD2300A5C4EF778F7AF96AE10E854312D92006D9C3F7081B144C4FE4E2C6C4A3E8F3FB2642FDE36BFD2BC9F9624FF962726A2E311A5556DDB6C2A1852B632B7D2BD1798FB96835B8';
wwv_flow_api.g_varchar2_table(1186) := '4AEDF0D50D9A5128BCACE8872292CBCC5E0CC00CA826CE49E8286E493EAACC0A4603C250385CBEC21812A18EB044BEC9D04B78206E5E12B945120D4490C77B0CDF836722C9979915B95050BEE77889A1A094A246E2884117E18A58829B944F3DAA108049';
wwv_flow_api.g_varchar2_table(1187) := '124121F62309514489308C5F01CCA3155C298BC190498AA01FB5DCA287AAD95D99EA80ABA3A3038730B39D51482D045A4A2E0823805A9403050AC5532005493CBAB48EDA71D5C2B1F1F10A560FD52791A746EDCCA966AA338D85C462308DA52CC2348A16';
wwv_flow_api.g_varchar2_table(1188) := '61270E647CE6DC8A5C52843CD692856DF8992925EADDF098E4EDB74280470FF2BC091BC0E435E691813C025CBF954E292C119008480424024F0802745DF865A7AB43BF624393E951D007601C9C2E0A5D1A6EC595087D2471A59408FC066941E8E196888E';
wwv_flow_api.g_varchar2_table(1189) := '5FA30D7AB9D51289D0231141905E0CE2278D6E1F7D2F72E9C7DC5E9C1484A9407450EE2820132502120189C0F78C003D72E1B4BC5BBD7C2EF107E2B424922FC3B70E9E869F102E07BFD2B2606581D94059ADFF9DABFF678DBB6525BE58E1A83F3FF3B9D7';
wwv_flow_api.g_varchar2_table(1190) := '5666D499EADC9B8E8CBF53EE68E463BBB7E2B5F9C9658BCD8273522B4E447C6CF95AF29915DF6822D4CE95CF2C9F723EEBC88814F1D516B77C8AA11008E4B788CF323A617D5C111015F135163F094444BB504E0AC589A09F4411173F1B425E684009FA11';
wwv_flow_api.g_varchar2_table(1191) := '10656FB704934814D70D62FC52508AE25C0958C5958A48A176E2C88B1611274558BBE18A7282D08C42F123A795D5726908AA0820800CDA48A11402A450355968264E1B092257A488060A6BA1F41B0C90B7F78100B0D36B61F60193F305F29A1290677483';
wwv_flow_api.g_varchar2_table(1192) := '9E03A31E8C6B68E932221190084804240212010D013C16F4C75899B5A17BC0EF0BBFE90CE2B371093FDC8CA872CB6F3757023FE8C225C00F3D0509F404086AFF60BD1B807E1151278FC92011900848042402F78700E7822E46E756A2736FB7FDDD6C683C';
wwv_flow_api.g_varchar2_table(1193) := '185F3228C658728DA1C5A86DCDA03347536B1C94194D8459017C7B15DA17990FB4C81511AE1A1913329AC0CD6FF73A91DBA090AFBF9642BE886B117E09448A88401435E1FCB826B65EC34D2522F18E96884471CD17E37728BF3AE2B72BDC20A0D9A34550';
wwv_flow_api.g_varchar2_table(1194) := 'AB69D600D12CD47235703404440A025A29746EC8CD4FD1ACD5AA9691878A00A318F45D1E6A1552B944402220119008FC481160B4F4A15A2E09F04385572A970848041E7304982463C819A1C10B91D9B9C894456FF5DB2A63A9B589B5419FA5ACC85699CC';
wwv_flow_api.g_varchar2_table(1195) := '4467C3378289455D56DD6555068980448081093A374C079050480424021201898044E0FB474012E0EF1F7359A3444022F0F820C07E086E4B4583A7A37FFE5C24196EF66EB19B5D564301FE5EB7A548C9E90A0CCEB43D63D1D963999B73921F9FC6CB9648';
wwv_flow_api.g_varchar2_table(1196) := '04EE17015CF477DCF6EC7EF5C97212018980444022F0F820F0B0A7084902FCF8BC2BB225120189C0F78F40369735E64C9DDEFD81D044A5CB556828D59B2D2BB179BFBDC66F2BF399D742C9A56A7B9BC75414CAA81B177FDBC04C5156C2B00259CC04FEB6';
wwv_flow_api.g_varchar2_table(1197) := 'C59147034B79BF3BD910EB69F367140B63F895C2B6FC49D4F74EFFDA26E0184421F3A56938339399F04C0A3B5451B53687995B12D9944BAB975B569C92A24D66669529EBA8D969090D44B805462D173348412775096D5AAE704E7E17C4A80ED8599B442D';
wwv_flow_api.g_varchar2_table(1198) := 'C4698B366DFB6B9BFF2408F02E418081E54968AC6CA3444022201190087C5B04F84DFFB645BE95FC9F6DF4F2AD4A3E3C617E1AD919E69BEB57E5956F21FFCD354B498980444022F0B5082453C96C4CE7C956D8151FBB64A5C34AA1526149BAD656C32E83';
wwv_flow_api.g_varchar2_table(1199) := 'B7AAA0D56B2ECB646055EA464D77D40687645FE20D59A8622721B82B7B77AD7FE536E47FD35B68213B497C53E9BBCBB1E3175B25DF6EC9F4F4341B3EDF5E8E53946098B7A77F6D0A5B3BB2F723271573A03120203F343444D5BDBDBD50626E818B1DA149';
wwv_flow_api.g_varchar2_table(1200) := 'E1F426610F280D0C0C502329C491419214511079E21C9ECC01C8A2766438A9F8ECD9B344782E1424571C1985000729B1F18690BCBF2B0D17870C4383B1E161FF90DF9F91B2944440222011900848049E4C041E19014EE794A9C0D2E8E8D8E2EC542E9BD0';
wwv_flow_api.g_varchar2_table(1201) := 'D0674F8CF70E5E9CB9FAA59672EFC87252F9DD9F3E8F4D5FBDB798CC9508480424020F1C01082DF409B5E94C7A2DB2BAB0380F4B5C0BAFC593B195D565FC8A338199D9B9E9B548080A2424F36D807DB1E3344C69767696936C61AA6C53CCF940D03F8813';
wwv_flow_api.g_varchar2_table(1202) := '5C4E7027E1B484D141CCD0293488B270636E514E3AA5B8525C502F9821A41A01D58C9919C488A00187A46603F41279EAD2EA250BBA8825944592E21A8985E852116A4914741D93280E53E5160DA2768AA3845BE471F191451B49A41604282BCCC37EE2D8';
wwv_flow_api.g_varchar2_table(1203) := '4C8474611E71744280710FA2810896502387F772361215218F2448E2E92505E22AB825AAC090142AA5083208A38A1430240B3B89A350306A7432B800E9C530E2429B760BBB460376524AD8060814A416D28185B26471E5560BC8A08A660A97AF706F0A84';
wwv_flow_api.g_varchar2_table(1204) := '71FFA247802F404318CB41861746D3202312018980444022201190087C0F083C9A0948B36BE923478E4E0FF51A0D599F5EF7CBFFEA15B3B759B496BEE4DC623069579D21D74603F5F6704171E33D8048E594B9B9C574523D3C53068980444022F03D2300';
wwv_flow_api.g_varchar2_table(1205) := 'E78106337B16CE06F3E11603A0ACDC920EBFCAF7FAE6C791C4310B41E2645A88101CB5B1B19149B33836E148C47142A287436EE148CCE3C53F4971CEBE83ADC1B2E0849028A82044911A51851E66ED42F6C8EDECEC4427E4130DC23608181A6098CC22E6';
wwv_flow_api.g_varchar2_table(1206) := '245ECCC36D0B5D640A31A560922847557D7D3DD5C1EE484739C5D1D6DDDD8DB5F037CEE0C5710AC314B391A1E8E8A116C1452184303DCC463F6670902F75611876721C3187F45EBB760D498A631E02304C9473F83045382E9814CEEF258E3D94C56CDCB6';
wwv_flow_api.g_varchar2_table(1207) := '348DAA6932CA31464C7826C261543410FD0252DAC2A97B180FEF457F616121299CB2430A46A29353822982F1B4825CD82927039385729A409C26A3166D706CF02F2D2DE58950905C0E07BE74E9128F000C6B6B6BB9C2844100B840469B958D7B99866327';
wwv_flow_api.g_varchar2_table(1208) := 'B908934BA590EAAAAA2A4C22822AF4632111DA4B8D54A41D68FC3DBFB73FFCEA5845CFEB91CB6678587AFD9D4FC97A50ADE08F369BC91AF008E838818C396859FD575BA6DFAD0AA428F3B562772BFEADD2F94BE44595B3E8BF156852582220119008DC03';
wwv_flow_api.g_varchar2_table(1209) := '8147E0018E6495DF7E70A6EFCBDF977ACD35B5B58525658ACE34B71CA103383A39935C9ED9DDD55858DB3DBC14F9BF7FFBEEA94F7EB71260303E174A640786C767C686956C3CA32893732B385BC687C76CE9D0DE5DDD566F358953F3C1FE81C1C5E95125';
wwv_flow_api.g_varchar2_table(1210) := 'C79D0C1201898044E0E122009381DD41592163301FE82E6E3D980F244A44E8C1930845844A2109C5D20CA2474B3AD40825F0432813340F1968210AC92205BA883CCC9080A460BFA4C0B4E172F02B046071085323A491E2306A38271C0C864C0A32EBFC41';
wwv_flow_api.g_varchar2_table(1211) := '0FD7A508CA716F4283A91DD72824139D24621E116E21C9B4053D50712A453F848D26C0D6E0A5B03E0438C7954015544A29C11B11462DF2303DCC837FC26C29089D4692AAE18D68A620C860C3F5EBD749470CE3A1B5274F9EA45D44A80E3A0A2654277AFC';
wwv_flow_api.g_varchar2_table(1212) := 'C8D304744235A90231723118772E273393450A980B6E2C6E49A16A918212E2229D2B5C825C8828FAD123E268A35EE83789A007FB4512836920960329B9D0661E13B95068F0A1E1584E161A440061311E0156B49A5CACE2A971E62D4A68054300E887578B';
wwv_flow_api.g_varchar2_table(1213) := '5620C63BF35569F9DF8D085C1D5F3CFCC9C153E72F9C397C281D5DD898FD40EF5762CAA7474FA7178760B5E78602D78F1FE28FECDE35F44E864E1F3BAA64BE0F073E6F9198C4716F9364AE444022201190087C43041E8107B86F217EF6FD77FEE75F6D6A';
wwv_flow_api.g_varchar2_table(1214) := '7FF1DF184C7696C631ECFAC74FFAD2E77ED7BC679BB1B1EAE89773EEAE951EAFFBF4B1239E9A44557377CA51FAE5E153A9D0443496DDD3E4A97FEAB5FFE7C353CDC96B95759D7A47E7FB5F9E6977D6062DE5274F9C8B8517D656167FF14247E9A6E7BF21';
wwv_flow_api.g_varchar2_table(1215) := '04524C2220119008DC1F02502C380F1454D02AA1046E4944BB8A0802B828A17F5A45B02FA8112C0EE284AF127607BDBC7AF52A94156A045F421EF226581C140ECE06BD248522F02804A0645029882E59705D6E7B7A7AF018C33391877D41A1E1B4F04C6C';
wwv_flow_api.g_varchar2_table(1216) := '409EB2381E3180FEB410209752303A34104186B2105AA81A24104E0B89BD7CF932E970729C9FE8A12075612D9C10DB68115C119E4F732842ED3401EE27CC830C13419E365205A5A88552988D7928A72EDA8B3D3049DCC2704EAA805B6A48520AB60911ED';
wwv_flow_api.g_varchar2_table(1217) := 'EAEA420CC28C42C1C3F178531DAA502EAAA0386A6926B6D134CC80B2621EB98000DB844533CA405BA89A2A7828E887ACE26A461BF623C070004C18DF2CCDE7B9F02CA8029B514233B184228C0ED0108D4E0B6B49A72CDAC4CBC02D60528A566315F58AB6';
wwv_flow_api.g_varchar2_table(1218) := 'E3DBA7B1F019F04439A6E2224658287932AF3C5670E015E2E9836D4B4B0BF19ED1B9F8E9232D3FFB8BCF3E3C5E57AA2FDDF462349E34E4D20CC370EA582C96D0E73266AB25C329DBD9AC5EC95A2C664567486672A944CC6AD41BCCD674269B4EA778CC66';
wwv_flow_api.g_varchar2_table(1219) := '93516F34A5324A2A113519F4268B3596CCE8D209ABCD4211305F8E299F1D39FD5245B352D4726168CE77E9B38E67F62433E634AACC269DD144753AAA339B0C4613BEDF782C7E796461F1D8977BF734650CEE78346631EA8C666B2A956135845197D59B6C';
wwv_flow_api.g_varchar2_table(1220) := '8944CCA0532CEAD1DCF7F370C55B040E448085B71A3BF9EBE325E48D229114D249E4E5E115E56D244E8AF813E02F8BBF14D2892029FE428500F214278BCF082F3C4550C895779EF79C80980C1201898044E0F146E01110E0EB53116FFC7AD7D37FA798D5';
wwv_flow_api.g_varchar2_table(1221) := '53318D46F5B37E7E70C17AF6E82BBF7CD95C587EFCF8E1BD8E99BAC6376D6E6F6365DC535AF3E9A5A973FFFA4FDB77775D9FD74F9FF8E0DF776E3972E9468DEB7CED8137A306F7E7C7CFFE877D197DF93336933163B11EEA9969485D7B75D3B3F8091EEF';
wwv_flow_api.g_varchar2_table(1222) := '87275B271190083C5A04E85C32C916AEF5B50486FE2584163AA4194C0ADD507AB4744FE9F413870690485715A6440A3D5AC82D0C13EE043D834DE135851C2246A57033681BA588A31319AE746AD140716EA155381EB18D4A8506482002B062A820540D47';
wwv_flow_api.g_varchar2_table(1223) := '2B5C1A96080FA73A683C3D60B81F29304C7ADE188C4E8A43D8E84C5335CD44987AC594669824A5D0492DC2438B3CFA71F0C2B4B11F2534872E354A280B41459E26B7B6B6D24DC7540448A769BB77EFC63C08210549440F815A284BEF1C9D706954C1CCB1';
wwv_flow_api.g_varchar2_table(1224) := '19C3B09F2B33B7C10102CC54646061123289184FC399F00C7AF8ABC101F4504E2E641B0136D38200532F566124AD83B512479E074A5DA021C803160A173A6D4415549C8218803640803F00B530952B96A341202C482F8689A703D7C554DA8EB5D40BFE94';
wwv_flow_api.g_varchar2_table(1225) := 'A508A0214F2D246A7A9EC0082FDEF1E3C719E000875DBB76B534AB4BA2D2D99C49C916167A9CBC3C39DDD0F4EAD48DDE5434D6D1E09ECE9687C6AF95163ADDB58DE74F5CF37BD3C1B06E6B8DDD5EBFFDDC856BA6246EF9ECB6EED69E994C72F272C2EC2B';
wwv_flow_api.g_varchar2_table(1226) := 'D2AF35EE78EAEC95615B62A9BABCD8E4ABBDDE3F908D871BFCC6FAAE3D8A9E73BC95643A3336BB64308FAD2D07FCB96C389EBE70B92F935C70A6E2AD4FEDEAEB0DAC4616BD4AB87BCFD367869692B37D93236BB664349ED35DEB1B8F06C618D2D9BEB9ED';
wwv_flow_api.g_varchar2_table(1227) := 'CBDEA03D395E5151391F3328A1B932BFB7A9A35DD1DBEEE399F247C17BC21F292F33B0F04E8212B336F8F3E1AF803859BC6068E6C5E3ED6A6B6B23CE388298B84122AFA8182D62408174468B1060B2037F56FCE572E555279D3F3104F8F361208C3F6466';
wwv_flow_api.g_varchar2_table(1228) := '55480E7C1FCF4B16910848047E5C083C02026C32EAA20943221CB4A81DB69BC1A8E4DACACA1ADB36AF297683812E91A1ADDC612F2CDDD2182FAEED38FAFE417F72DC5FF25A7B8192C96E4AA77226836E4B77635543EBF0DA3A85D61BC7A75662A180CFEF';
wwv_flow_api.g_varchar2_table(1229) := 'B217964D8FB2271633E56ECD36FCAA1EF95F8980444022F0C010A0630AA521DC9F46A82FAC12C723EC8B7E27ECABBDBD9D8E2F2C14DE4B3794CE2E5D527ABA102D12713F220305A5F34A7F97EE2F1A205710339CC3F04656ABD2694609F2303D7AB75848';
wwv_flow_api.g_varchar2_table(1230) := '3717BA8542C818B9503E526089829442C0A0C7F480217594A2DF4C1632503834D32EB230031A29BAC57057EA1544119344752817BC11191A028FC548CAA20DD68A914460BC74E20974DFB1163DC2F38CD9082380B5706FD0D0C0443FB6610F8D85A6621E';
wwv_flow_api.g_varchar2_table(1231) := '54965C9A834EC83F65A9113B1143213214073114520BBD7F2AC57234D00A7249A75DC2FD8B0696EC0A34288B5AB0C25AE4C91260423390C166C4C01C4879D69007012071283D6C1F064B2ED6E2D7C51E5AC71523C181B8C001191E137A800E036808AC1B';
wwv_flow_api.g_varchar2_table(1232) := 'DC7801A84B6BF29319010D5ECE43870EF18078D662612DFD80602A77E6CC952A77C45CD5F4D13BE70CD1CBC198253797BE6CE8340C1E7C7EFFEEC578C397074FFCDBBFAC3FB75C929CF8C213F3F49E39B477DF9EC33D538EE4E7E7C3CD65A3A7A29DBFEC';
wwv_flow_api.g_varchar2_table(1233) := '3BF9477D69D5E1C3C75B6C6BE555078E9CE80D5C3F92737AC2CA7C6D739BBEC00FEC78956717564D96402CB4AC331B2EDF5838FAE927EE2A576E62ACA2A574299ABB7C65C83A73A5B0B6FACB4F2EBFD86D305B5C069D6E683EFED927874A6DC91B73E132';
wwv_flow_api.g_varchar2_table(1234) := '47FCF35391D7AA2612B58D873F3B5E129B2A79F5B9EFF240A1B5BC210CB8F07AF3B630E8C35679BCC0BC57EB7F49056239037F08FC198A8A60C8BCF3BC54D066061478FD60B6BC9CFC71F1D2F286A38DBF110A6EDBB64D0CA8F14252FCF4E9D3BCF6BCFF';
wwv_flow_api.g_varchar2_table(1235) := 'E452E977315B969508480424023F7C041E0101DE5AED7CAF6CF7077F7C77CB0B36ABD3978AC5AB2A7D3A25673732F1C6C440ECFA7C1F75668F4E31049656EBC3CB1E87359DD555F81C6595C5AECE6AA3AB8C994DD6F52316F9D5A2639136E9FEF0E1D5D2';
wwv_flow_api.g_varchar2_table(1236) := 'B18FEA7FF5DF31F5886348D49F33192402120189C00F15013AA3B03E823050B04DE2B81C3593A16D5A1C9240D06EE1575A2E5D5B91BE818A43C9443A3D6022503BADB88834343488083D6682880BCE465C5882E308028CB5221755822E720B5D11895CE9';
wwv_flow_api.g_varchar2_table(1237) := 'A38B38464214E9A673CB55B301DE4863359BA1DF04AD38116821368882225DF8AC8813D1E202B1FC3EBAA83A5F46002588AE5045B79E20E2022568A750057A1A80305EF80062B4572B4E22503075598000C1C672462510C39F06FD20C2355F0F29501452';
wwv_flow_api.g_varchar2_table(1238) := '2015C4B96ADA347835C41078C2030FFDA9A79E62408489EEDA3BCCC45F8FCDE0A9AE193DDC3BB33837DA37F8CA1683B96EB72BBAD8E12C1B5CAA1E1A9AA9AE9C6711424773C5954CE3DCC9CF56A6E60A924BDBB6751D1CD52D4E1FCC3AEAABBDA6F8A6AD';
wwv_flow_api.g_varchar2_table(1239) := '439FFE5F05C92073EC27AF5D1E9E181ABC126BB2856B773C6F590DB0EB15E0ABFD8D5CAEAEDCC7DE68F6914826ACDC082C1B8393BB5FFD79B0BC7A7832B5323354555736D47F756A2910191BDDF2AB17FAF425A11B472717E3CB93FD07DE78AAA4DEA773';
wwv_flow_api.g_varchar2_table(1240) := '5833C9BEF6FAD2C2A6B6CE8EE0C0D9D88DD1A1E6E6569DFD7E3CC0BCE1BC6FEC1BC7CBC68BC4E0174354441829A0CFC3CBC34406FED0788DE1B1FBF6ED13AF107F920CCA30904410A309DCC26F29C22B0ABF65C08B08EF332F24C78051902F09AF316C79';
wwv_flow_api.g_varchar2_table(1241) := 'EFDEBDBCEA8CD13CE16FA36CBE444022F02420F008BE74F51ED35B7FF317E73FFBEDD01FDE75B83D45065DE57FFD9AABC0C22C377E86F82DF2780A4C56077D90CE8ECD5FF40D565E39FAD3DD7B3E18DA7FA1E78AA3B0B4AB867D444C850EBBC1AC763B58';
wwv_flow_api.g_varchar2_table(1242) := '3FEC753B75469BB7D0BE32645D599CF139CC051975D05D0689804440222011F8EE08084EF8CDF5C0FD6E17A6430F75BC3D3D3F05576DFEEDF71FBFA301B873E1FC50084180995CAD01829F590C1C88AC7C83612677D4962F23E31A028C0B1C3870003035';
wwv_flow_api.g_varchar2_table(1243) := '24AD66A3CBEDDCB3A3A3F7F2E8E4A5736D9D55A9ECB45D972BAD28CAEA9C138515D337AED5264251BDFEF4C5A17060756B7B8B6153E38599BE33A7CE39A2F30D5DDBC7662DC6ACD3A45398EC6B329A8B8B1CFD267B646AB2A36B676C2A6ACAA58ACB4BF4';
wwv_flow_api.g_varchar2_table(1244) := '66F59533EA1597D35652E433969414FAE7ACF305B515FE95F2062519F39714CE25ECD343C30DBBB7D81D1EBFBDC0DBD474F6D2C8DA52B0A0C05AE377963774C5E2C952B7C9E92B733A27F5162597568A7CAE3E9777617248C9A8DBB6DD4760D00406CB0A';
wwv_flow_api.g_varchar2_table(1245) := 'FCE79F7F1E06CB2D43034C2280C18215A33967CE9C6174895B060E60C2A20AD82C1334E0B18C6DE1FB1533F9191BC22D8C739877127ECBFB2CFE4251884B99212D5E6346C728C55FE81DFF78EFC37E59442220119008FC901130FCFAD7BFBEB77DFCEA6B';
wwv_flow_api.g_varchar2_table(1246) := '818143028388621C91828C47DEB13845F819CB1FCBD7C4D816A2A9D2E728AA35B228CEE9A82A2BAEAA6FB4DA5C8DD545FE9A7A16EEDAADE6C6E66AA7BFAAA4B858672EA82DF7B5B5B63A4BEA32A984CB66AEAA2875F9CB9C56736B7DA5D5530E612EB45B';
wwv_flow_api.g_varchar2_table(1247) := '3635365434361B2CF692420BCB8718222DAE69946B8035CC654422201100017A78C223773734F86AE169A197A9F5C23549380F148E7EE406BFA5262023F74600007FA47D6B6803C4407B25A0B51A0126510BF76EFE93960BF5C263993F77402040DF80D7';
wwv_flow_api.g_varchar2_table(1248) := '809E03021BFA0FFC65C1CD34A0D8ADAAC4EFA9A8AAB4798A8AADFAE6CD5D595D014BA8FC1E472C632E7699DADB1B0DFEFA9E2FCF7674FA2A4B2A376FDB5C5A5E65B015EA32C986B2C2A68E6D16ABBDA2C4EB2EAAF03BADEE92DA5C2A5E57E9DFDCD656D3';
wwv_flow_api.g_varchar2_table(1249) := 'DEA5180B4C869CD769757A8BD9078B8E84BBC05C5555A1B7159A0DBA8A226F535B8BDEEE3728D9028BB9BEBACCE929F6BA1CB53595CD4D4DEEF22A162897F89C0D0DB52DCDF50E5F05E72159CCA6E2221F5BD1D55596E46CBEC8CA5275A9A7ABBDC555DA';
wwv_flow_api.g_varchar2_table(1250) := 'A0BBDF339C78EBE0AB50533198028F054F01201C982CA63020036EDA84083E5FA4339D845208438F29055BE6A5E5EB07F24C8E409E08BC173732FE613E890890C2C70DFCD17CEF8FA4F680644422201190083C3C04F87CF14163F88F0FE0865AF8CA315A';
wwv_flow_api.g_varchar2_table(1251) := 'CA820ED8285F2D6EC595089F2F71A59408DA6F3411A1474498F57387A9C25A2211417A05EFC51A025F55B6EEE05B496EFE14B87CFBB0890AB451C9FC2C199708480424028F04017AE41A75B9A3017C2E39E78655B844F205F8D6D1D164752B1A6E9F489C';
wwv_flow_api.g_varchar2_table(1252) := '2F29E3120189007F2F7412D8364CEC6B950F087D09D81A3D07BA3577EB3FE4CBDF3BDEBB90F8F07FFB877FFF3F3D5BE0DB7A6F49992B119008480424023F220418B3A33FC6028D0D4372FCBEE05E65AF9313274E404819BCE396313EAE04FA784C84117C';
wwv_flow_api.g_varchar2_table(1253) := '9882847C1A2C9A2F08F0239802FD23425F9A2A1190084804F211E0CBCB20209DF8FC4419970848041E0902A50EC30B6F3C67B6DFE72E748FC46659A9444022201190083C720424017EE48F401A20119008FC98108003E79BBBC1579C9FA5C5B5893730E7';
wwv_flow_api.g_varchar2_table(1254) := '0DC535191991084804BE2D023E9BD1B767CBB72D25E525021201898044E009474012E027FC0590CD97084804EE1301682DDE60D6A8C06945D0F82DB722FE55CECD5B369B61DDDD2D07325B0443A71FB83F19B5E8FC73A27E9F8DCC2FC6B47096D06432F9';
wwv_flow_api.g_varchar2_table(1255) := '695F1F07A6F57D65719D7F8D499AFE3B16D172459542067C512B02470A1B0C24701AB2BA89B3915D26D6E3F9B9C082FDB7E7DE5421FF2311900848042402120189C0E38FC09FAD737BFC9B2B5B2811900848041E1C022C74140B86A15404A158905EE244';
wwv_flow_api.g_varchar2_table(1256) := 'C47E81622F564EEF24DCF218EBF5B94020B7B2A2B2CA0718A875664649241EB05AAC0D8572B3B3DFCE529A9648647A7B3303038279DEB538DC756D2DB7B0A04074C1ADAF2F3334A4D2F8757054364BED7373371B4522630F57AF664646547902D74824DD';
wwv_flow_api.g_varchar2_table(1257) := 'D3939B9AE2D0217233D7AE65C7C76FC98BDCB93948B2C2E6403D3DD9D151C1CCEF6A92CC9008480424021201898044E07144407A801FC7A72ADB241190087C2F08C06CA907BF2E740CE209B9E52A1CBC44042B1629821E6FD85F3ABBBCCC5EF93AAF57B7';
wwv_flow_api.g_varchar2_table(1258) := 'CEE29054592271AEC28BCBF1A4C27D4A4546A35002AB569961BE9B1742C83F91984A65E7E7F5050568BEE971D50AA2043729FA75BA9B4AD6B3D438C585C798DC750FAA90544D5A3F14975629D1687671D1C059C4EB0DBBA941E09CA707FDAA7036AB5AAE';
wwv_flow_api.g_varchar2_table(1259) := 'D3651616D2972EE596974D2FBE68686FCF610396A31699AF02A434333E9E3E7C98D3842D7FF5579973E7D2172EA88DDDBF5FCF51C63A5D766A2AF5FEFBBA9A1AD3ABAF0A8832972E65AE5F276E7AFD751D26A552E9D3A7B393935983C1F48B5F64CE9CC9';
wwv_flow_api.g_varchar2_table(1260) := '8C8DDDCC2D29A1BAD4A1434A28C4DE8CE69FFD2C7DF6ACCA8D39DCF8E73FD71517AB0A659008480424021201898044E08941407A809F98472D1B2A1190083C0404D86310ADABABAB7877D9D896083E6102877372C408DBF18B1D0885E31787F02D136078';
wwv_flow_api.g_varchar2_table(1261) := '06834A531389F4E5CB99C141D573CB3127EB7ECEDCD212A736A9BCEECA15D57D0A0964C7FFE161C42072B05355201A55C924FF6231E1498667A24DC771BBEB56A95C1AAE3B3595BE7891B26AA9603073E346FAFC79251C86A9A2932CD5B91A0890A2525C';
wwv_flow_api.g_varchar2_table(1262) := '7823CC133E3F37871B36373D4D0A36A8AC98DD149D4EEACD4E4CA00155AA24013DD0D7F5145CB870D7DCE2A2EA655D6F1434D8D0D5454390C952041BE6E7D5B2D826FE61E13AF32731373C0CE186DCEA1B1A749595F05855065F3AB851046490A4D2783C';
wwv_flow_api.g_varchar2_table(1263) := '7DE48871EB560605D2E7CEA9339F1717A1B5C6EDDBD5065EBC98EEED357477EB2C166CD0994CB4253B32A2DFB143595BCB80E79933C66DDB684E069A9D77EECEAD47236312018980444022201190083CBE08480FF0E3FB6C65CB24021281878F00E40D26';
wwv_flow_api.g_varchar2_table(1264) := '0BD1E5C417D603E31326706652281462137F5CBE905E6ED9A9FFD6D2DF75AB2803B385E9E5FAFBB34343BA921288A5E92FFE2273E488F957BFC26BAA2B2F8794664E9DA202F3DB6FA7DE7B4F5F58A8783C081B5F7905F2A66F6FD7C15A21782B2BB9C949';
wwv_flow_api.g_varchar2_table(1265) := 'C373CF657B7A745555D05A6361A1BA38361ED7F9FDD9402075FC380CDCF4EFFE5DFA8B2F38A02607CD0E040CDBB7A73FFF1CEE9EBD71435F5B9B9D9ED671AE3B7EECBA3AEA4DFEEE77FACACAECCC8CBEBC1C07ACEA37369B73ABABAAB563633A56328F8C';
wwv_flow_api.g_varchar2_table(1266) := 'E06B85A0521C63E0A514878EE2DAD5FBFD99D1511CB9862D5B546D1C63D0D6A62F2AC2C76B7AE30D98AAA1B9393B3C4C8D20A1F7F90CFBF6618061C78ECCC993506ABCC478B0F106A74F9E3441775148EE9E3DE0A322C7580064389381D01AE2F12C2C9D';
wwv_flow_api.g_varchar2_table(1267) := 'B0B000ED8700E34906559DD369801E5B2C28C4428600F4555586CE4E9A83D9AAF3D9E361E88176AD3F0A799108480424021201898044E00942407A809FA0872D9B2A1190083C0C04E096F05B02CA61B9F947B1C37EB519D11BAB36185886AABA58FBFBE1';
wwv_flow_api.g_varchar2_table(1268) := '66FA754EA8FA606168B834A7A7E1A83046661DE319CECECE66AF5E558A8A0C4D4D4CEECD4D4CA87C55A74B7DFC311C0F5E0AB5C31D8A981A672630C4FBE2C5D4679F6597965497722894BE7E1D9E0C87D497959976EF86A9AAB388CF9FCF86427048E837';
wwv_flow_api.g_varchar2_table(1269) := 'F1CCE9D362CAB1CA9027260C1D1D104B7D69A9CEE7CB0E0CA8EC7761010D2A4145C3B163B0653CA899A347219CC6DDBB75B06E1609433809B873C58C6B9A393CAC6F69D13534403861EF340D497CC2AA57195733DE5DFCBAC2950D467A3D33A5314F7553';
wwv_flow_api.g_varchar2_table(1270) := 'C37EC53FE83702881148119AA905EFB1098EACA32ED5D34BE6FABC6B5592544AAD1757C70288904B8ACD062D4F7FFA292E715CC4EB1A55AD32FC2810580E2787074632D1E50765EDD452A4BFBF7F74B03F1D0D7E179DD34B6BABF3E3F91A581D317C636E';
wwv_flow_api.g_varchar2_table(1271) := '2530CA900ED3FD6F4C2DC6D616A71757C38B93F9625F1B5F4D28038343837DFDA1C0BDC66B789327E783E1A57BC968750DCF0657E7194EBAF5FAAFC63393E3934A26A6C9C8884440222011788C119004F8317EB8B269120189C0F784403693B5DB1C2EA7';
wwv_flow_api.g_varchar2_table(1272) := '7BDDD96B5772BA029BBDB0B0B0ACB4ACACB4DC6655B931EB843758A36EC8047923DD6C86AFA933A22D16DC9BECED94C5A50967C3F9595A0A3DC61B0CD93334361A5A5A0CE5E5305B7D63A35258886353575AAAE05E869A8E8EB2FA1702492D2AFB832D93';
wwv_flow_api.g_varchar2_table(1273) := '9BCD32E3D75057A7D6C5EC68D6069BCD2A71659A3462763B3AF59B378BBA980BAD4E1BFEE4935C24C2C25ABCD3FA8A0A7D7D3D0E5895CD0AFE99CB19F0C7B29A17B733BC7ADD418D9D98872F1ACEAC30471A4A4F29BF5FCD5D9FC80D2FC57D6DA8A949FD';
wwv_flow_api.g_varchar2_table(1274) := 'EBBFE213D61515DDD4860DEB6455BDC531BBCE5461CBFAE262C8364C35CB5E56F89FD7A15017EBEAF5107B15C6548A35C0F8BD556F334303F4E5A1F77D7DB8BB55642211E208E85B5B539F7E8A2B589D058DCF796C8C8106FDA64D34937F54A4562AC38F';
wwv_flow_api.g_varchar2_table(1275) := '0401E8DAF16B53FFF49BDF04AE1FFFEE26A3AD6762F9C891C38B731381D9B9C8DACA3D74AE24943327CF2BC9C5BBC91CBE3C317CE60346C0348189B5EC3FBFF3F1C98F7EA7A482C99CF2EEA19E85D19E431787272F1FD464BE36B218CD7C7EE4E4CCF0A5';
wwv_flow_api.g_varchar2_table(1276) := '8585C585D900EB03EE5684E67C7E7164EAF2677713207D6C29D177EA0C9FA26357A7E6467AF225071762073FFA4449CCE5276E8853C5E8C00D2511DA902E6F2502120189C08F0E01E343B298FE0AAE0FA6023E24FD52AD4440222011F8B608E032FCB645';
wwv_flow_api.g_varchar2_table(1277) := 'BEA17C52179B898D59F4B622776528BE3C1F9E2E30390A4DEE85F0EC7274CE61F2F80A4A7105DFC100B3D9D0DACAC2549DC7A3EE1DE5F1E86B6AF0C4424D21BDC6FDFB339393382DF52E179C9359BB39B69B62BAF2E5CB4C9686CD1A5F7A090B59FA4B56';
wwv_flow_api.g_varchar2_table(1278) := 'E6C409C4746E379396A1C4B05658658E75C2B0CD8202C3B66D3A9B8D04B64756AC56E3534F41442199AA72AF9799C3EAB258BEDB4343B044A628C36055FA5D5505AD55A7469795A9571CB4990CD3AA61AA2CB28551C3BA55234F9EA476F8AA3A1F9BEDAF';
wwv_flow_api.g_varchar2_table(1279) := 'EC76583D5863219415AAA9BA9429BB6913B51B366F566927845CECEFC575FDB9E016866CE3105657085BAD868606D3BE7DE96BD7A80EB3D5ADC2D8DA9A18B3B22B2A98119D3E718299D8B07748B2CAD5F11B8380D76BC4C1CB0AE4F5B5C1C6EEEEE43FFF';
wwv_flow_api.g_varchar2_table(1280) := 'B3F1E597D515C5C803637333BB5233BF5A9D9EDDD6A6526E197E24088432CA9533979663E18BE7CE576C795E31387A279763732375454E774DEBB5FEA95C64A6ADB638E6A81DEBBB6ED2C7DB1AAA66128EF9D1EB6EBBB9B2BEA1BF7F4E97596AAE2EB2F9';
wwv_flow_api.g_varchar2_table(1281) := '6A687138A37C70F054B76DB8ADF5E7A9ACCD6833CDAEC4A786076DBA446B5B5DDCE2BFC1AC87745C9F4ED635D61C1D881FFF97778B2CBB72C5BBC2CBF3AC1C6F6C6AE81F5C49C6662B5DF692E6B61B8160F1EA00AFBC86E5C5DE403830786629FADC4CAF';
wwv_flow_api.g_varchar2_table(1282) := '52FD54EFC84CB846199ECEB4188779E7AEF74E2663812A97DD5ADF3C373058DF50D91F88579957620535D9A5F1F28666A1EAC8D5E985AB9FED79F30D93A75649A5876656A3F393668BBEB9A9BE6F7C2DB53A535BECF054365F1E9EC904A72F5EBCDC5137';
wwv_flow_api.g_varchar2_table(1283) := '11CF29437D3752F1E0A6BAA240B668756A2891CBFA2D397F6DD3275FF4AE9D7CC75755906507389DB2184E4E0C0C1B94784B7DE94AD439D43F94CAEC19E89B4E6158A967764D57EB4A3ACB5A458BF8FB3DD53F73FC5F7EDFDD59D5B1A9D953B765666E72';
wwv_flow_api.g_varchar2_table(1284) := '7A2458E90E5574ED094DCE96D4968FCF47AA1DA935B3FFFCA5AB7E25D8C527C2AC7E34649008480424023F34041E1601A697425337AC79FBA1355EDA231190084804BE3302BA64267E7AF2139CC0F174B4A568FBD0C22526ECF205E4CCD99EC051ABD1C9';
wwv_flow_api.g_varchar2_table(1285) := 'F77067D9013E8AAA27530441352311238B515B5BF53833E199ECC964B59A7EFE7375B7A71D3B7093B2A0178E87E7136DA6B7DE52BC5EB671CA8D8FAB64D8E3513DA2FCA3A7EC72995E7945DD168BE9CA1E8F019D3878934935CB6C36BDF9A602D185153B';
wwv_flow_api.g_varchar2_table(1286) := '1CDCC29F0D3E9FAEB9193ECCE25B953C234FED9B36611FB7D04B8575B97BF772CBBA5C9564D6D4282422C38ECAF06A286B3A6DFAE52F15F824CB77E1C6EB0515B837F4180EDFD2C27C69D6FDAAFB339B4C7AB8B7D3491134ABBC9D56E046DEB953DD3D4C';
wwv_flow_api.g_varchar2_table(1287) := '04A0614D2F8D258B6153F45454A865FD7E7D4787EAB26686734D8DBA01359C9CBDACDC6E08B06A767131BE628509E46E3720A8271B55562A2C00DEB347CFCE616431371BF65B52627CFAE9DC8D1B28C11B0CB054ADABAB53AD921EE0AF1EC20FFFBF03F3';
wwv_flow_api.g_varchar2_table(1288) := '89C4744FF7EE9D3D278EBD1A9A1E4B551F3CF879579921E1AC39D53B3570EC60734B7130EE3872F142E2C6D9F15026BCC57F75DE6B0BF66CDEB9EB447FE0FC7BEFEFD851922E77071682FA4438EEF04D5EBFFE777F53EF2DA9A1EDAB29E5B377BEF41967';
wwv_flow_api.g_varchar2_table(1289) := '9613F6E8E4B0FFF9D73FFCE8835D6DE5276E247F1E1D5D8C342F2D2CC4A2A163576632D73FD8F1F4FEB303B6912F4E146D2ABD76F4CA4F7FA9E735D71B4DC1483CB2BCEC73D9F46EEF954B97B736D94FCF948E5CBAD054B3CFC8FC0EBD6234B016DFD43B';
wwv_flow_api.g_varchar2_table(1290) := 'B972F1F3CF4B3ACA7A8F5EE97A2D71E2A3333F7F7BFB1F0E2EFDA4F8EA42E5DB851327CDBEB2E45AC8EF735D189838E0CD96376DE585C5C8DF7E78CD78FDBD1DCF3E7BAECF7AF9C4A9B821379E9D6A7CF157470F7DD15AED0BB1EEC0643B757D62E2D867';
wwv_flow_api.g_varchar2_table(1291) := '9309636C343D51F2DCC2E98F2ABBBB4E9FBAFED67FA3CC0796934B8BC95838B89A4A3BD732D9DCE8E4D2E048AF71DE6068F80BB3C5D43F1B79FFDD93DB3A6D5EEFD65317875C35518D0053FB52383EB73017983337D6940422B9239F7CEE731505022163';
wwv_flow_api.g_varchar2_table(1292) := '75EDE8997325D5AF9C1E9C2DA9091E5E88F51DFF229D8CDB94B5A61DAF30F0F5C37FB5A485120189C09386C0C322C0E0C8E6A826B9C1E693F642C9F64A047EC008DCE29F0FCE48BAA58B9140DFDCC5D75BFE66766D6235B238B070C9575066D299972DF3';
wwv_flow_api.g_varchar2_table(1293) := '834B572A5D8D2CB58BA5A3B94C5667F88A00735AD2D5ABFA9212758F2848E9B66DF848618CD8C5D6530A7ED7754EC8AD8ECD9C08E9B4CA8421D5ACEF5D5830BEF002EC544D17010729746EDD67AB323AFCAE1AAF63532B585FADEA0DC661ABAFAEC601AB';
wwv_flow_api.g_varchar2_table(1294) := 'CE408667C23929D2D0A0667DF54F75F312FF4A89CA48D73DBA6A75A41344BD1051D44277E1D55CEBEB59E24B0406AECA602D36C099D103EF5D27AE6A71F691667EB270BA0A6DAAF4CDA04ECFA68DC8435C4511E23E9F5A902AA0F4E4522F249C8AD6C9B9';
wwv_flow_api.g_varchar2_table(1295) := 'AA9F56D01C8C648A35AEE9F51AE1F6BAEDDB455CF584230FEF853913414375B50AC87AFCABCAE57F7FE808E0353D7771C8610CFA5DCE0B09D7DCF8950B61AB6EE4DCF637FF0783DDFBC5FFFBE54EFD8DCDDB5E0FA41C5F1EFA4F3F69D12F17562F4553C9';
wwv_flow_api.g_varchar2_table(1296) := '68743EB0D6B61688598A9652B1E5998970DBA6C9D5454370BAB0D5CCD2F064421D27228CAF65FA4F1DFA0FFFFDF3C7575B8EFDF67F7F65E7AEF99989CE9F6CFED3946E76F093EA1DBB7BAC8EFAE6A67F3AA4AB892DB66FEAFC3FFE707553AA6FFBF637FE';
wwv_flow_api.g_varchar2_table(1297) := '9783815D43E70DC60696982F06A3B383C3D6BAA265C51E1ABDECDE59E888165EEC3DDBFC0AC77DC303B3FCD1A6F5868B57C64B12D7B76F7FF37F3D34DF78E3E27CC67EE5F2E5F45CEEEAEA6268F9CC814AC3EC6238343EE2ECACD5736A358B08D499CF6A';
wwv_flow_api.g_varchar2_table(1298) := '6F6D6221BC29B9DCD6D6F99FFEE5A27DF2827FFB4BA9A585233DA386B9EBDBDFFA1F3FEC4F865303078F5FD914192B2ADB134CCECF2EAEE856E73675B67EFCDBCB3F5F1D2BA9A94F5F731457358EFC2BE005D2CBABFAD462386B19BC78D155F79A5EA74B';
wwv_flow_api.g_varchar2_table(1299) := 'A4B2C1746A617AAEA9B1A5A3B9DEE5BB353F02CBB7B6952F34B4BDF47467616D5B5FD460082F3EF3C6333756CD09C51C5CDFBB7E7E391C295E3B75EADA267B2C60290947C24C4F5947575E2402120189C00F0B8187488069A838F9E387D562698D444022';
wwv_flow_api.g_varchar2_table(1300) := '2011787008E4B2B968628D6D6E2A1C8DB98C6E35BE5857D89E48C7999AB99658A973776473E9A5F82CF3A2F17AE6F706D96E4ACFF940C209097F23FBC001D5AE0D9372B58524EBAC0F8A687AEE393CC31BC5F24B6DE0965A16FB4B41A7BF720EDFA1AEFC';
wwv_flow_api.g_varchar2_table(1301) := 'DA8512F82481B8A6538B08B558955F4AC89342BAC882308B882A775BEB44A2B8A21949E45122F48838B944341B84366E356484707E292D9782C24E528418DAD0906F52BE0D32FE4345602E92BD76E6C8AF3A2A4B9B5ACE76262E9D3C63EA6E4B664CCBCB';
wwv_flow_api.g_varchar2_table(1302) := '2B2E9DD16236865773C195E59C496732B3895C7A575BA5D3697597BBDE9B5F3873FCCBE7DF6E9EEEDA72FA8B8F5BCA2F9574BDAA77E85C8E82A6CE8E2F2E5FDBEBEDCDE5AC49B3DDE2702CAF46E2A19542AF35A7B3EA0D7A8FC759E030C497D6CA3DF69C';
wwv_flow_api.g_varchar2_table(1303) := 'C5115E0BE9329E42BBDDE128B43B2079C6E595950263D2E2F0A61738AC2BE57658F5D59556B7FDF085F11AC3544BF7ABF15AFBE9FFEFCCF2E400449051AF7496F730536033C7D2A6E595659B2151E6F39575D59F38FC8F079E6AFFE44A8B73F058CD4BFF';
wwv_flow_api.g_varchar2_table(1304) := '6DD86A775455986CCE1DAD35570F5AEB2E1F37B96A0B8C7AA32EA96E33E0F098CCE64C5A575F5C602BDF1B0C9A83498E090BA69309259D31190D4A36DD5DE7F3584AFAA70B9C66A3B7D01337172889B0B7D833A1D327A2617652CFEA74872E8E144E5F72';
wwv_flow_api.g_varchar2_table(1305) := '7ABAA32319472EC1BA814AB765D3B6CD173F7DAFCC713153D7918EDF5AD2CC7B5168B7A60DFEE9F945AB6F39AB384B2A5DDEA2126FA96B32A5CCAF99AE5CEB9D1FEE37B495173ACC0EB3BDDB5954C76897726B9EC70FF5CD9276490424024F2202865FFF';
wwv_flow_api.g_varchar2_table(1306) := 'FAD7F76E3793F7B4C09466028B7B09624317D7FAAAB0DB355004678B95232E659008480424023F0C043897481CDB7B3773F86AD18FE4ECA2DB7DC566B3D9E7F391E584B2AE0764E2F1783812F1FBFDC34BD7C2C9D5D1955E97C5174FC5D299CC4274CA67';
wwv_flow_api.g_varchar2_table(1307) := '55E70667B2E9F9E864ADAB2317351A8C7843CBF88AA280E9BBAABB55636588A2199E76CFA0FA36718A6AA5EE29BC31932AF0B2C2096590083C6404E8032C2D2D25D5B5A67FF6BE91CE7EE9F41CD822E46EFD873B9AB614492F4D8DBCF66C77495D97CEE6';
wwv_flow_api.g_varchar2_table(1308) := 'C92C2F75EFDC3417B3EA93418F455F5CDDB0B090D41962958516ABBFC6908E16383C1EB72391D5DB6D868A429BB3ACD1A4640A4CF6CE8EDACAC636B7D76B359BFD3EDFE44A5A490423ABE1BA3287DE551B5AE678EDF09ECD75F6AA4D899585CEB696C574';
wwv_flow_api.g_varchar2_table(1309) := '41BD2351D3B6331849FA6D599DCD5FE5D65735B7DB5DAEE5C5543C17ADB5E83A76EF0A264C2C7FAD6FDF59E8F39A0A1CBD43B35B2B948E3D2F788B8B1702B1FA4A7B5CEFEAA8F1244DBEC6425D75FB8EF979B56C8D59E9DCB35BEF288A2C2CBCF8DCA685';
wwv_flow_api.g_varchar2_table(1310) := '6C759D3BD2B1EB59A7CB831EA3C556E471ACE4DC89C5C948346387DD3ADCD58E5C45D3A602BB2311D3B90AAD4EABADBEA9667135ADCFB1D437BBADA9B4A2656B3ABA66731516392C1927D3FDE355ADEDCBF3916D6D45F6B2C66068A5A2CC99501C2DE5B6';
wwv_flow_api.g_varchar2_table(1311) := '5441B95D89B9FCC5951EBBAFB9531F8F56D45567629902B3ADAEB1F6C6E26AB535E22A57A7A588C0839C8D18A666478A6D59BBBFDA900A9595D72A7A13F35A4680626114A8B7B637988BABD796570A145D754D85D951F85569F95F8980444022F02D1080';
wwv_flow_api.g_varchar2_table(1312) := '66D21F8B4422B73B53396BA3A8A86872721236CA5C636EC535FF0C0E4A89C06F901644F5DC12C1EB7087FE969648649DF3DEE4BD5843E0272D9148D0F323B792D97A770AD844056EB7FB4E99324D22201190083C0204E891C363EF51319FCBD1D1D1C5C5';
wwv_flow_api.g_varchar2_table(1313) := '4522F9627CEBF0BB34374CBE4524000040004944415437930583155F483E717C9D0381404B4B73DFDC854078C2A4B3B4F8B64DAC0E04638B26BDB9D2D134BD7623925A23BDB97073606AD166B36ED9B2E50EBB030A92B0E16BAC310722F7C778451B28FE';
wwv_flow_api.g_varchar2_table(1314) := '1D35DC5B0F5861F906E32972B7F47C64EF18170585061A8E6652041A9AE7963DB4086469C808192D0579523499DB358814A17F83368198284B5C18A055AD2ABD4B100535936E971226917E0F99DB4B7D9394FCAAA9059B454ABED9A4F30F973859C212D1';
wwv_flow_api.g_varchar2_table(1315) := '7CA19F14D2F3E5BF49BD7791A1D3303838C8E1D8A2ABA14991CE40123D07BA3577EB3F68C2F9916832135C5A2AF3D975667B389189AD2C15957AE65732B1D0BCCF6129F095CECE0633C96099CF91B2FA1767A70DB994DBE35A8D64B3A94851A1239CB387';
wwv_flow_api.g_varchar2_table(1316) := '57E6ED66435169112BE335CD73ABF17870DEA4CF969614C5141B3B2D5B75A9D28AE284CE165A9AF717BA96A28A35B36A2F2C995F0AE95321BDD565CE259D85DEACA29F9B0BA5622B3EA7CDEE2B5E0AC5ACD935BBA748ED5629CADCE29AD394B0BB7D5945';
wwv_flow_api.g_varchar2_table(1317) := '37BF1072DB32A184A19045B169039CD3EAF2CFCE8792D115FF7AD968321B5C5E2CF33B17C28A39B3E6F1F9F9E3D12C0C27734B7333BA4CCAEFB6478D0E4B3AE22C54D5CECDAD2663417781D95D5C32331FCE26826693C9E3301B1CBEC0EC7C26192D7617';
wwv_flow_api.g_varchar2_table(1318) := 'C4CD1E7D6CD5EEF52ECE87FC2E83627505E6E6DDE65C5C57E03465D226FBCAFC3C2BFA1D6693C159180BAD1AADD695E5559B21EB2B295E0A463D968CC58931B7C2522C13981C2F77E921C0A958C8EE702A3AF52F7192639466C75DA53EAFA320A62B181B';
wwv_flow_api.g_varchar2_table(1319) := '9B3427D6AAAA4ACD4EEFADC232261190084804BE3102782CE88FCDCDCD6DF05BD001C3BDDADEDE7EE2C409082923AADCDAE85DAD07FA78168B45F0610A12F269B0A85C12E06FFC10A4A0444022F05820F03008F0ECEC6C4343039A23F1B0DD6A4F25D3EA';
wwv_flow_api.g_varchar2_table(1320) := 'FF322C2CD4998D5687A320954DB2F48F6DB1C6C6C71C0EC79D09303C04E2B161D304880A67EA723230BB5EB13C189206ABF9B6010D6C8DC3D6562C36BE8FE25A75B023CE169A9D55F54093B4C06CD389097519334B73F3491DDB62B17F357B597F4B7F35';
wwv_flow_api.g_varchar2_table(1321) := '072665D8AD8A79DA6633148A35C32C03E6CC5EB66E66776B75A3696A6722D2D9B39C90CCA1501C6BC42D07FC72E811629C93AC1ED1B4CEEBD84C5B5D2FBD73270533FDFD998101F5CC27F6FA5AE778EC80CD715346E6847394F1B9739C2045418AF3E38A';
wwv_flow_api.g_varchar2_table(1322) := 'EF92439554B545451CCBCC64752C31EEDAA51E58758F00D41CDABCB474D7D3958C463630837F72CA947ADEF2FA7954F7D0F72DB2A87A6E8EDAD5D64131C7C7D9214C89C532131346D6427FC56C910122E333CF707E15E0808361FDF466F5C560A3B54020';
wwv_flow_api.g_varchar2_table(1323) := '4B578369F95FEDCBFD2D0CB84DF48113E0DB6A900912018980444022F0D822F0B009F0AD51C6C71642D9308980444022F07010601C11BAC4BC18A6464756A32B2B414EEB5C5E5A4E44532B4BC1951556080623A15832914AA55350820DDE3095CBF10F0E';
wwv_flow_api.g_varchar2_table(1324) := 'B9B898E6305B412C45228C6E6080237055F6029D1389E22ADA22588D96BEE1362F1DA697BE7C592D24129114419321B2A1B8B8D5AEC8EBF5D0AAEC8D1B2A0FD70A226030C02D555E477ABE3CB09C3D7BCB722DEBF6BA346DEB110E1CCE724C5138CC79BF';
wwv_flow_api.g_varchar2_table(1325) := 'E98F3E8295A136F5D1474A349AFAFC73F5DC2654C5E39C960CC14B7DFCB1CA66B16D75357DEC18149D9390B26B6B2AA41313E99E1E782C671143835563843CE742A1810772FC78FA8F7FCCC5E32A635C5C647B6D0E73CA71D212DA060773B3B36928223B';
wwv_flow_api.g_varchar2_table(1326) := '697378D5F272EA4F7F528727B4561021E45B2EB248141ED4FC2C115F974F9F3F8FE52AC7D604349D1B1422A06589B82640440421B0AE4AD529AA4E26E1F334367DE408A72EDFB4079773389C3E7326F59BDFA84519CB585B634335CEDF525BB19E92FEE2';
wwv_flow_api.g_varchar2_table(1327) := '8BF4E1C32A0232480424021201898044E0B146E0E16E82F55843271B27119008480454F604AD65120E1166E330F70650988493CD65997BC31450AE4CCE5153F21DA408E1B59B9E4E5FB8804F1502993A7C985D13546F2764952D8E77EF4EBDFF3EEE50D3';
wwv_flow_api.g_varchar2_table(1328) := '5FFE25EB7E498110662726383458DFAA9ECC897F3573E142CE60E0185E785AA6AF4F5DDFCB5140B84F390768F76E0E2252BD7CE82C2CD4B1912CFCE8DC3908213B3FAB5E534228040984701A9F7D164BE0DBF85D392E085F28D4884D75300CFF27FB3CAB';
wwv_flow_api.g_varchar2_table(1329) := '5B67B1ACA5BF9FDA55C7296A395E68DFBE0C740E6729870F6DDBA692C6B939D585881FB5BD9D1389B00A4BD2070FAABB4FB7B4E00A86D9E6D6D9A9EA84C4BC4B97D43396DADAD4767574A0961DAAF1576797978D65657ACCE3DCE3F5C39CA0C1FA030754';
wwv_flow_api.g_varchar2_table(1330) := '64A0AFB49D13679E7A0A93127FFFF7EA845EB01D1AE24063D32F7E91F8877F501DE6DDDDE9EBD7F10FE3B68DFFFDDF03232E6235F73FFE479CA2B8D3E19F9CB4C47A1E9830710E73D2F1F07EFF7BE81F431A1C866C7AE105CC531DEEB4C268C4C2140D89';
wwv_flow_api.g_varchar2_table(1331) := '468DCF3FCF83505DB8B5B52A0FC7D7EAF5E297566DA32C9B93F1B0209FC78FA3D9B07D3B0F2575E8104F9682AA57796D0D77346D6413A2F4A143AA1EAF97138C559B715C73C6150EE4A626F5C912A9AB037C011A7AD433ABE6E7C18D1700CE8A6DE0CFB1';
wwv_flow_api.g_varchar2_table(1332) := 'C6F05ED066736C52748C470C0DD1580EB252CF913A73461D83580F64E92A2A18295029B1DB6D7AFDF56C4F0F673E0B01F57C6936DF9E99D1E4452979950848042402120189C0E387C057AE80C7AF65B2451201898044E0E12300AD654D2F8B4CE0C0EC8F';
wwv_flow_api.g_varchar2_table(1333) := '4560B530749708BC9739CF2C4B81210BF60B19D62C22118F5CE6DA3595AE10C4FCE4781C3F67F277BF839988749510F6F6720BC5521DC888E176C61D7AE488EAF1C3E779F060667C3C73F42867F9229CFAECB3E4BBEF3257599D240CDB4418E526131431';
wwv_flow_api.g_varchar2_table(1334) := 'F95FFE0B2C2EF18FFFA852356A4780C34B7096CECD11578D9C99416D76604065B673730853059ED55C380C1F83BCC1A05427215E5384F1915EB8803DF055D50F4C5BFAFAA0702AAF83430E0CA8A701434DFBFA921F7E98C4D7BAB444D3D47A2F5FCE0C0E';
wwv_flow_api.g_varchar2_table(1335) := 'A6DF7F3F4DFA1FFE4075EA40C0FBEF67A7A761B6E92B570C1CCE64B7737AB09E4395D61D9B1C0D95E59064BF9F0D94A85A1D11C04F7BF5AA61D72ED5318B31CCFEADAC5477116358019EC915A2C861C23E9FCAB40707D53390D1C958030DD1EB395B98B2';
wwv_flow_api.g_varchar2_table(1336) := '62D731F50C648B05194343033238454967F2B38A1B387FF0018308705A5D3AADCEC41E1EC6ED0C98F04915AE4F3EC1CB4AEDC2778A279F2103704BFDF18FC98F3F4E7DF8217454754DF3D480687050B77EEA15AE694613B01F4BF0D3AAF8734D26E1B7D4';
wwv_flow_api.g_varchar2_table(1337) := '0E19C64F8B92E46F7E03324420A569062F98B73C34A4BE0F03033C65462252478F42A149C99C3881CB9A270E9957E78A73783263197BF6A80762ADBF302A680E8771CB16F55065DCCF1C28859E8505752864FDF553730193968AF7507D23659008480424';
wwv_flow_api.g_varchar2_table(1338) := '02120189C0E3898024C08FE77395AD92084804BE0704D87230140A9D3E7DFAF2E5CB57AF5EED5D0FD7AF5FBF76ED5ADF7A601FA0818101927B7A7A58270C1FD6FCC0303B0EBC55179D86C3B8138D3B76E0FF4CF7F6AA2CC5ED86ED70489291138FBC5E75';
wwv_flow_api.g_varchar2_table(1339) := '19307E5DAB151F26DE42A607AB446B74D4FCD65BC637DEC8328B75DDF7A8EFEECE0602866DDB60DBB84C59496B7AE925D3CB2F0BBAA8924088F0EEDDB04A14C254E151A6A79F46099363F17FA2DCB8772F3C13D20B5134ECDD8B0FD3FCB39F41B1E081D9';
wwv_flow_api.g_varchar2_table(1340) := '6BD7F4EB27FDC2728D6FBD657AF1451897DEED36BFFDB64A5359411A8B619BE9D5575537E6C282BAA41677F1C4049CD9B069538E59CDEC8C8823F4F5D7E1B7703C6AA781B83D556A5A590939D77776AA1C1E67EFE6CDAA5F97538EF05E4265A1ACF8B159';
wwv_flow_api.g_varchar2_table(1341) := 'DCDBD0901B1981D0D25E083F59A6679EA1514C51C6090C26EA136735322C8E16918E25F8E771807B3C2A692725148219C218559A877E410E71E4C2AED94972F76E96BFAA4C9875B022806428841938608D070E183A3B69B5FA68BABB75A5A54C508745AB';
wwv_flow_api.g_varchar2_table(1342) := '7386A1DC8C6D608CCDC62DAE6C1D0F94E5B52C818688B20A97E680F9D0108E6E359E48A8AEF5DA5AC0A7692AF505645ABA1E61B08359F53C29DCBF98CDCB607CE925986A0687EDF8388BA21971C0452F9E0BCC1685EAB46A5CD9B1984AFEE1B778A75969';
wwv_flow_api.g_varchar2_table(1343) := '8C7F5B343091000AB5F9544DA0221603F34039141A7B40463D695641832A2F834440222011900848041E770424017EDC9FB06C9F444022F0701080C132E1D9E3F1B0069809C2305B52A80A679BD875104E44603742C408C5C5C51C987493008B8597CC58';
wwv_flow_api.g_varchar2_table(1344) := '1E1F57BDAF4E27EE4448266C569D850B27C44BE972B1A255A5346C63C8E1491C9CF2E187CC34C619C8BC5CA6BCA63EFD3473EC984A171166066C2AA54E2AC606B6DF379BF54545B873535F7E09DD524911EED0C24208A171F36678325B4631179765AE2C';
wwv_flow_api.g_varchar2_table(1345) := 'AFC52B88DDF8634964B6B33A57B6A444F58BFAFDD0332600C339314FDD60C962A1DECC279F60184E5AF4A8CB74619E78B699438BFCFFCFDE7B364972A469629119A9B5D6A2324B6B5DADBBD1000698D999DDDB9D3DEEADEDDD2E6F8E347E59A319FF00CD';
wwv_flow_api.g_varchar2_table(1346) := '66FF003F9046233F90BC5D3B726F6677248041030DB4EEAEEAD25A6489ACCAAACCAC4AAD654466F0898A46A2D0DDE899E9696020D2AD2CCAD3C3FDF5D79F50FEF8FBBA3B34415BB078954E47A0BAE363105D9040E88353757835DFB8018A4BBADDACB730';
wwv_flow_api.g_varchar2_table(1347) := 'B052AB911F3C197C9B6DDAC2026BB6457E8E89014A0E2850D6548A75B7C6D4E25FFD0AE653763E7022C1CEF28521F4673F233D1EAC6845FDEA57E0E4F8C3BC5F18846B5353F43BEF08FAFB49D842D3E9EAAF7E054EC83718E89B3759DE787AA958AD8241';
wwv_flow_api.g_varchar2_table(1348) := '80008B378CCFAC691764DB6E7F421D910706D2536A0A1B6F1DA0E114F051A97099E042CCCA00A33EB5A9C28CCCCAC4CEA7000A7AE3DA9F5A6231DC404F4E8270C27C8DE10C96D5E32C4CD3FBFBF4071FC0AE0EF9184460CDC58B8B20AEB82EEC59AC5085';
wwv_flow_api.g_varchar2_table(1349) := 'E22882D5C520737414665EF6D2C0E31AAEDDDFFD2E3C9CA10C4CD030FCB2A41A324F672FB38ED330FC7201CD844D786F8FE5E4DC126BA7CDC15464D65C1C0EC35CCC9AB53736908D2DC11D9F146EFE6B22D044A0894013812602DF4C049A7380BF99D7B5';
wwv_flow_api.g_varchar2_table(1350) := 'D9AA26024D04BE0404C05CDADBDB5B6070FB6C7842DBCE248223C15C0C77688E24B3FC0A7FE0BA160B0C9B048E6E377826F9DA6B30F6624E298CA27CAC4E0C0769A1909D40DBD646EEEE8203B3BB07C3C8A9D562122C680C08AAF0FA75D60F56A3015385';
wwv_flow_api.g_varchar2_table(1351) := '172B3B81F674DD63104B963F83F0D8EDD0927548DEDF67CD952051E0B4A0B2E3E3ACE36E2422C4D2CAFDFD2042A08E98680A57649040907076562A4DB3D3899349905B3EECA83C1EA6EFB28C1DB370B102734B4B2D1A65A7A4629E30C482784B243093D6';
wwv_flow_api.g_varchar2_table(1352) := '8E8ED839BA14055324CBD3301FF5EDB7590B30C818A6B682E27676921835C09460B041A42B95A21FFD8886432FA6C2C20CCB05866199A44E07FB2D483E64B206F381011AEAA1B2FE7E3878C32D9980DFB24CC677BB6139676720C3DC6A30F0A0555F1FF8';
wwv_flow_api.g_varchar2_table(1353) := '398BC6D5AB183E606DE6810090210014E7E88B265CBAC44ED985051EE0C3068BF5B7C03FE1800D0259A9B05741A311BCF926A83E66F0C2CF993526B7B4C0EC0C168A4AC9CB9761A1851080C31A8D6128D6EB49704818EDE1A28CA6C1BD1C6658D8BD31B3';
wwv_flow_api.g_varchar2_table(1354) := '3A1E17C0DCCAB150F07098C7E1B48CB1035C4DB4F4CA158C65805743139ED78BAA598B3A0829E82ED68B060D0725C6A46218CC91A852B150E35A5CB800DF69D6C87CF1226E247636359087211A55E3EE824D1B57010313B0AB8BC5ECD80CA6947FEF7B38';
wwv_flow_api.g_varchar2_table(1355) := 'CB5E4AB3996D91584CC2CE0C5F7A14916217D71176A8821B7DE0AEC257EC58A8D4F2A9A4492FE309E5AF44B55491CA2722423E6332EAF8A2979799CA9725F5BC54F5E9A641987B1D8BE594E28A4C6500F8F1645E2323F21429E395C48ADF6373A0224524';
wwv_flow_api.g_varchar2_table(1356) := 'A2C70282B218343CB1AAD1EA5C99AEE5921A838EE07DDA91CB956B742EAAD51B09FEA7898D22CD48138126024D049A087008B04B983E8B45231111D82BB80013070C1D08CD7D809F45AC99D244A089C0571F8157BB0D12D7DE67B9EE0B7068BC5AB93C20';
wwv_flow_api.g_varchar2_table(1357) := '39AC7916F65ED860F379501A360293A0548A0878081B870D1024161C0699B10414081B28CDE952CCAC2BEFA935121C92252D1CDD421E14C14E36B05BC27DF7D444C9560709E078F077158BC100219BE5457027A669964D7175818C2914205A5CA3F0F667';
wwv_flow_api.g_varchar2_table(1358) := 'A932DC9BA351D64A69B371CC8A2D756AE965E934AA83A32FB22133F4C49463D0486C47847D9B4ECD89AC0ED0562C868117AB7009FFEAAFD8B26805C4E214D43E3557B22AC1CE1C89B00CF0130E06FACDCA44BBE09D0B7C40CB6532D62B1829680B5A0D51';
wwv_flow_api.g_varchar2_table(1359) := '5018141A04EF340FC821AB0352D03AE886B670138341440B05B6A5A79EC038CB4670F674CB1F167C4883D853AACF0A817A10020CA10344A1A5F8033EB0F742010E5E808938E6D322DB2956C0E72CB06CD3A03F54857A18BC80AF38ACC1B05DC32FE0DFFE';
wwv_flow_api.g_varchar2_table(1360) := '5B361D937B6FDCC0D80456EDE21CB9593332A7392E37AA834F35AE14264EDFBD8BCB2DF8FEF79FB077F68AA2010C8B2194399D670EC5D8E5C4803CF759C7D953E559AD38F5908235BDA00CD00038C8063B3F943CBD79586968F2E9ADC589FF438EE836BC';
wwv_flow_api.g_varchar2_table(1361) := 'DA7D8039656EAD04573FF8977FFFFD2163EFEB7F887A5C597FAC383F376B1417310BBCAFDBA3B6783E4F669E26029B5BBD5D1642A8796E9E5F3EDA6E2B3EEEFFCE7FC0600597215426FEF53FFF7CD810BDF6C3BFADF015FFF8F3873FE825A662EA41FE46';
wwv_flow_api.g_varchar2_table(1362) := 'FBE57FF75C21CF26A6CBF55B8F97F5E5408E54DBF9C9E1CBDF6970E0C9BD4475EED7AFFDF02F09217B5773E1E176AAB8F4D3B7FEE26F08E1A754F993939FFE8FC68A92725AE5B471498164D92988F3550EFCCC50443611745AEC78737C5AE0B7C5D08F0C';
wwv_flow_api.g_varchar2_table(1363) := '059206755DA2618700A2E53AEF78DFE869FD6DE55EFE7C703DE2E8C1C32E7D81082C689EDE0F983DAEDFAB2D2F10D83835B71B2D6D2F4E5CE8136B01543334116822F0EA11F8A2B7416A8E11BEFA6BD694D844A089C0B70701B086976E2CCB0339FA017E';
wwv_flow_api.g_varchar2_table(1364) := 'F289DF2FCC8CAC408805EFC16EAE9C7C6480DDF2B36B147D9A132CEB34B0D4110CEA139538BEF7A904D485BF53E16CDF1632C1F44E7FE2F0441A1241814E034B3E910E8E0DEA8B008A781A58AD1040CCCEA8C465463274606796C2A2781A9EE880B6C03A';
wwv_flow_api.g_varchar2_table(1365) := '3A34C4D608B32DCE72AD3B95C3663C55860441E5AC975C59503B04548408070BB29D36F089D8C6D9469ED3B673B496A576A719580960BC90C09DE5CCB050958B409353628CBC4F00E7D43BAD9D8514E9B852F8438002A7299F267232B94B0042CEE53903';
wwv_flow_api.g_varchar2_table(1366) := '2CA739CFE36179321CDA61B9859F39B2413D0C2BF4F4B07ED1A8A271DD5145A33A687E3AA6F0C4228D229F5C0514790A43DC42AC89F813E4D9B35C03A115A71E524E6FA127F7092BE2F44EE32238CB01CEFDFCEA1D8B0C3133B5E6DFDD5E9D2DBEDE7391';
wwv_flow_api.g_varchar2_table(1367) := 'E04922997231796C548A15065B309AAD15E236A3B226339E048FC5FCAAD562CCD092E4C9910C1302AC96503857A732568352A460495AA94EFCE6EE9C31BFE0BAF4669D91906259AE528B858F253CCAE6B45479D278344653152143E9CDA6397FE1E1BFFE';
wwv_flow_api.g_varchar2_table(1368) := 'DAF0B71302E368192317046DB399C39112554C1A555299C1B276109367E74F09F013E01677523B6BB33945E6C2B55DDA3834BD7270C540AC1E981CE4320870E824532D264D2A29A9B7E422277A83269AAB69C82225D2D6F349B5C188AB0B4153BEE8FEE3';
wwv_flow_api.g_varchar2_table(1369) := 'F7877E703D4A9ADEFFC5A2CB3EC7B75F28E692620C655478F55A95E10B22F16C299714F07906B59C62F8748D2ED3F5542C5665AA649D76588DD11C4F5CCB9ECA7CF2A2383848D5FC6BFAA1ACDB6648D7E5EFDE993B2FD9B076BEA673B9275783876B77AE';
wwv_flow_api.g_varchar2_table(1370) := '8F8CB8DC2D75A9220254D3316FAB932751EE0792A5FC71AB5D27D1582B35221D3E36D9343C927D2E52A5FAD2F4FA1B57F1A230E03531B97E3440ED685BBC7B8108518AB7D80C0295259E2EA562476695506B692931BC839D432C4F6F696F0F4633563955';
wwv_flow_api.g_varchar2_table(1371) := '12994AD1B0D1663A6BD0CE549890DF67530B95B6D6E3C398C32E8F9744FC623C4A0B1FFCD70FCFFFA50B445D63655D241A219229C58FFC66B554E370CFF9A3FBEFBD33FCC665AFCD2CD1D976FD51AA1C534AC54EA79D107CCA9C93453AB8EF77E9051A8B';
wwv_flow_api.g_varchar2_table(1372) := '379DA9E48A99623AD6EEB1E15AF80FC2824AD2E3B60964BA748508ED6FEBC5754B4B5BA94A2FCFECB55BA416AD9D6288ED83B0B29E71B1CFB8A4A10922259AF06F1FCA44454F6B4BB62A0E6CEFE9D58CCDE58D642B95644C28210555C2E8B2628AC3D952';
wwv_flow_api.g_varchar2_table(1373) := 'CD78138126025F02024D02FC2580DCACA28940138126029F83C0276495E3666CA646CA0BE29CB0B339B99417177936FFD994B3F186B4E756D4C8D9883C95BFC1C11AFA9CAEF805E76476E9A94678AA387E3E95D2C8D990D3889CCDD98837225CC117FF7C';
wwv_flow_api.g_varchar2_table(1374) := '81F0B3A79E2BEA0589CF9EE2D4C011CCD660C032602C0BE520C2445F6C6A0553F959C420E1ACE6E0C070F9C6726860FE67D9EF732B3A5B90CBF0D4B191A111792AC357F8E77E8A2E1F2E8D5FBFB6B43477BD7012A66D1FDE7ED0AAAC485BECFE9C686DEA';
wwv_flow_api.g_varchar2_table(1375) := 'A1CB2155485A163793A583E570A176A947BB95D488339B6D9DDD4779DECAED7B5DDD1A83AC932295BC1A9526241B730BFFF35F9A6C1DFD6874B14E7CFCF192B87C90AF8A7B0FB6E4E3AFDDF8CD7B5D2EED7AA8FA9D41ED7ECCBAB7BB938CD85742C6EACE';
wwv_flow_api.g_varchar2_table(1376) := 'BDEE91816485D87AB0A076CB57FCC9EB7F7A8E1492F0A9AF5035AA5C9488048458B2B2B072A947B510B51C2ECF39BE338489FC3C7833F0F9A440B01BCD2F7E785BED56AEEF275ADF1C59F870F6ED3F19FED78789EBFAED84E5BBCAA3C9EEEB3FA8576989';
wwv_flow_api.g_varchar2_table(1377) := '5434BD71704E9B6BED9B0063FBA5BAEDC0371F4E3A8A2B3787C74628A145C0AB86B2F4FDF7EF191DA2ADB5F0773AD54CEB1598F18FF3B50F7F71B3BD5FBBB39DFA3717AC8F62766B6EE1D29FFD05413CA167C94ADDBFB2A025F3E5E332E97973737D5B25';
wwv_flow_api.g_varchar2_table(1378) := 'DBE28B5C32AB797BF7607F6BCB2D179BB5AAF9C34C6C750E6BA60B8ABBC2AEEF3DB87D5BAB611CEA5E10E0689978F4CB0FFE9B1F5D23955EA0B7759894167D122DBB7A5C026BB1F9968CD7BC9898BEB87B5C3A9CCFB8D5DED1EFFEF2CE824510F6E7F957';
wwv_flow_api.g_varchar2_table(1379) := 'BF2F5ADEAAEF6C3E1655F36F32273B45572ABF99D6F7EAA39B06DBB542B146554A4A99A822923D9E5D3BDE9B55096BD7AF675736482655795C568E89E33B8C796B6B53BD9E57F12B6A6B5B3E5F01EB57CAC43581F4A347EBD2F4BCA4A3576E736C1D44F7';
wwv_flow_api.g_varchar2_table(1380) := 'B736150EAD55CEAC9555878F27B18DB821BBE4FCD1FFD820C0E0D8771736E8D8EE1E8F78EB2AEFE3254A969FC956A4B2444C7BF1EAFC76900A2DD3698B7BE4EDB9C58D74C8D7699459DCEEB136D3B163A89C6577655BD88FAD3FBE5FAB94DE28C6BCFD17';
wwv_flow_api.g_varchar2_table(1381) := '31D3008908180878B0BA9FDB58345A4456B7F5DEEC6125BC8E11B20B54FD962F5509AE90C2BA9E51FFE97FFB1641EAB922CD63138126025F1A024D02FC9250C3EC83BD4F5EB2F0D7AD181A8BF0125AC3A280FD60707C89B2CD224D04BE8208E066E6C257';
wwv_flow_api.g_varchar2_table(1382) := '50B7AFB44A7881C00809DB3222DFDA1702DA0EEB316740E670C0F1132BF7E7C2823C80AE61CDFE9AA00717E8577B4342DCEC5A90570EA9659D6B492211DA98CF8A524BF73C7FF7D7129DF1E6BBCB9EEC62CB95FF9012E8DEFFE027C3EA54B0A8DD936576';
wwv_flow_api.g_varchar2_table(1383) := '43AA7A74DDEB32F9739A85CD0DA34257EAE8DCD93C10A6439AEE5E4CE89270867D8238CC31B31FBFFFB7FF6E683EDB72EBA3FFEFB58E9EF5B5E5B706DEFC970D41E7EA7D63F77F9489E426BB6D65B26C3DDA70FCE04F7E72EFC07632D372FDBFFB3F6E1C';
wwv_flow_api.g_varchar2_table(1384) := '7475CC0A48AC8EC63B8C64C29BABBD1E63C5DE15DE5EE8EE14F252F2A5E56DE7F50201FA4BD4F12DAC9182C9D580283CE3B9FEDFFF9F1F06548EE9CD60C1B5B6B8BF5ED1ABD79351EB79596AFB309EDDDF1E1CF056690A7B88C3AD1A2642814854A168DF';
wwv_flow_api.g_varchar2_table(1385) := '51CC7AB26E70FCD9E47685F42D67BDE1D4C6DDF12BFFC36F3E0E0F093783BAB19C6FD976E987BED9F5D7DE7AFD833BF5ED8793A60BFF5E2DC6526A4FCCBFB82E00D324E31BBABAF667FEF1D2D09B8EF68E7E79D6DADE21154A5ABC6D74DAD5D1372056EB';
wwv_flow_api.g_varchar2_table(1386) := 'FDCB7B1DFC1CD37DD937FD2F2EF7F5787CD7A4B5D62896F58949C20C0FEA533B6AB1461C6D2DBF3964E58959676C9F3FDE23292ACDAD9102BDB7BB574BC50B09BFB675CC173CBCFE76FBCF6F651C07BEFBB7F6054CB050150E1F941C7D031F2E95E48BBF';
wwv_flow_api.g_varchar2_table(1387) := 'E8FCEEEB354238BF7E70BCB7746DD459B09C7B74EB03B58C3A2A17AFF4CACDAED77F71F3D73A6D56FB9D3F6F27F57BC696FEFE0E8DB5052B9B4FCDEE6713EB6F8EB5CA5C43BE50A2475CC1B2E6425EADB3D5CAD81D3D7DFD52ADF9F1465E185ACCEA469C';
wwv_flow_api.g_varchar2_table(1388) := '748C38B55A73F7E749BA1ADCDAFACE95AE9B5BD55860DEBF6F7BC359B0B58E13854A3C53D9DFD9A5B27125B54FBACF05FCCB97067B752A0D5C47A42281542AE7F3ABE818BD7F6755115989D3EA6E3DEDEDFF6409030C0450C4E1DCDC9571974CA34FD624';
wwv_flow_api.g_varchar2_table(1389) := '87F756DEF88BD6D9437261632372525590B55A2C152465443545489B0498BB1ACD6313812F0F8126017E49ACE19B8E49D12F470B5FB2CA3F5231F4632A95CAA78BF7FCCE6A8027A02C268D635BD4DFB95033631381AF3402B8ABB1AAF3575AC5A6724D04';
wwv_flow_api.g_varchar2_table(1390) := 'FED808E0CB8837FFABD5225E669626EFBFD161B03A5C73ED03ABD3F379979BAC94954A055F22CBA5F3521EA550AA7255492E9BD4D9C9EB7D7D2A85406E537D7C2FB3307D7FF00D67747C6261E9A1C7B62CB78D9135A5462A347BBC534B0717AD41BA2EC9';
wwv_flow_api.g_varchar2_table(1391) := '54F8F55A4525170B29459DA019CC7F270987DD2C37C0E5366E34AAF92219969C23189E49A5B458DD152A24E6D3D8EEBB2E0439ADD198334ED322A140AE5408C4928F57C396AADFD5F5E719B362E537CBAF85B7D9EE0253A7F151ACD7CA555AC9AF2994CA';
wwv_flow_api.g_varchar2_table(1392) := '9A9034897886FEC1478F7EFD5A87776EAF55B279DBF3777F9E108A6A4A0556901F6C77AEDEAD0F047D27A45910F73BCE0D309B3CBB49ACB7B8783B018C8DE48B15922AAA554A31BEB3EC6A584863C06F31B1DBE5B04864F56474DD29E189EB980EF0E948';
wwv_flow_api.g_varchar2_table(1393) := 'B490A23B5C5E755FEFD21C63500A4D0E8734372F53A9254281CBED0A6E2A542A052992C849C6A2D34555CA124FA893323DA3A3A1482CB03AABF38C08787CA94206A7795CE5CD484959F5EB7A7E88380CE9818DB51F0C780981CC17C90A8273D6A1F3A1C5';
wwv_flow_api.g_varchar2_table(1394) := '59345AAA946AB5461EBF586340C58BAD4EBD50EB34B5DA3302218FE2F1E92AC9AED4C6934BB1B4BE5A289253754654ADB5F53BC562A5C2D2CECB92757E5D5CAF894881C7AC9569ED6AB9502CC5240E9E52814B810B2485B3FFB9DE9664945E58DFEAEB6D';
wwv_flow_api.g_varchar2_table(1395) := '69713BFC0283462D134AE482723A4755745472F0FC1B8440122912BE87B7AF5EEDA6EB5A82AAEA342A9ACAD4CB6525C96F6D6FD7783AEB35E6A3B5A834B6ACEBBE903B7858A5AA957251A351CAE420C0FC54A6944C27538A94B99C23AA25AF4DDDAEEE6C';
wwv_flow_api.g_varchar2_table(1396) := 'E98007B860F930471E4CF55D7D0D6B065412192DEE3395264FF0997245A755D4C2BC52BEA8D7CB1D3A37B4DFAA989EE3D6F16A9F9CA6B426024D049E874093003F0F95DF21AD582C7E4B781DD63C4357069DFEA7D83E98C0D914F6D3FAD91424A0ECB707';
wwv_flow_api.g_varchar2_table(1397) := 'A8DFE1AE6966F9DA2380DB1EEEA85FFB66341BD044E08B44E0ECA7E155D5932D524A267FEDF284AA77F49032C4E77E3AE295DE708F2CCCCF75795BAE5D1DDCBB7BB2B430D3D1DA7AF5DAF55A6A594CD6D54A45B9403ADD56713EC9E3F3EC066559E304C5';
wwv_flow_api.g_varchar2_table(1398) := '7575B909C20D96F8676F5D9C7D4C8BE7E78484D4DBD7DA7BF93BB3AB87C54AEEDAD51199D2E872BA0852E6D4F135A4DBA153387A7AF777234EB55BCB7381F15E39DFB17DA37B7E7EEE9CB96EED1837170B1ABED36DD6B8CDE3A071B1F9C573FD8ED1894B';
wwv_flow_api.g_varchar2_table(1399) := 'A6B224B2B49A4FA7DA9C7AA9B266D363EF6CEB851ED7DC4EEFFCFCFC98A16EEF9EE88DA9A7D7D4E7C6DDDBB4DC943AD1DADBF45213E13601BA2B02EAFDD0F5F985A58CC0F8468FCADA7ECE7C12520AA100A1570A497B8BABD5FEC03AB0B2305FCE860516';
wwv_flow_api.g_varchar2_table(1400) := '422F1749EC1EB95864F73A099ED86151E9EA2D3B47096B6AAB7D78086651EE72A85562A9C12064089DD1453064AB55F970A6D6C3DCBFF8F635B35C4B33DA8737EFBFF6E6C53221B83DB3294BE62F8C0E946AE26C897F1CCB0B546CBF314B115BF36BE3E7';
wwv_flow_api.g_varchar2_table(1401) := '2D65A1717573E76AAB8D2762CD98EB873903B1AB69FD4BC45552815C6F32F10592AE76BE507618CDDDBF796B48AAF0B65C1F3C6F2E9E4C0A0846A1D34F6EC7AEBA8509CB0F77361E9DB778C6FA9C04FE402569A67BEC1A55F32B48014F65DC7E74F417AF';
wwv_flow_api.g_varchar2_table(1402) := '0D4C6754479BEBAD66A762D875EBDE834B4369EFE80F2E8CC30D1B7F441E2BAF670BB9645A57C23C6D01C871DEE8BD75FBFEDBE7FA954543BC2A28E6E3ABFBA463209E2E1BD6E697AF9E335B3466A9D97DF3A387BA12ADBF38668A337C118B121F9B9D29';
wwv_flow_api.g_varchar2_table(1403) := '8572ADC92A128A5B3BEC3AA9C8D079F3CED4804DD5FFFAF71756C3E1D8069F2ABAC2EEEB57FB8F57135A9A52296000E7FB2345C1CA7CDFD58B7A8148D53D7CEBF6BCC9B677FEFA75D958E7471F4D61DDBDE1F1AEF5544529E78B0C35635945909F99368C';
wwv_flow_api.g_varchar2_table(1404) := 'AA9BA1894013812F0101F2C73FFEF18BABC197AC11D8B14B8C5E9E066E7C57C52DF5F18C0814414F1166C367CE7C1312D0BA42A120C3DE1BDF8280C6C2D91B171A6D45D71F4128C0C0344666EB520C170BF0C70682C432B035895882D556D8694EA70117';
wwv_flow_api.g_varchar2_table(1405) := '1B65BF252305DF843BFB9BDE06386EE0C67C412BF1D64AA7D318B541E4A96C70E6D7EBF5E572191BFF9E3D853B1C01EFC3C611110CFD70474410E0438180089E143C47678B37E34D04BE9108E0FEC7A2EBB8E79F7A94F041C1A7131F1464F8BCFEC3F301';
wwv_flow_api.g_varchar2_table(1406) := '61EA3683DAE96DC366453A9554A33575B4DA5446D7E9E24F8AD6AE56B1DC2011F19D268DB3AD8F214532B1D060326092B543271E1E1961E43651BD32D0D3E2E91BE291EC8ECD78C24189E53A2BACBA2AA5D46D8759D7837DB25D4679CFE8084C8B669DC6';
wwv_flow_api.g_varchar2_table(1407) := '60B16BD54ABBD56A32DB747ABD4C2AF5386D4EA743A1D199F54A91D2202399E1FE369DB34D2D155BAD56991ACB6BF14080E502EC5CE695AB0D32015F6730998C5A9BD5823F93D168355B6C0E87586590A26C9F57E76AD7C82516B3D1EB6DD7198D1D6D2D';
wwv_flow_api.g_varchar2_table(1408) := '1A13B8EB93B78452429AED8E5A9D30A9C4A3234302854925434536A9DAA0100BAC6693C5E1AE4965B97C25140A5C1DB4B9BAC76C668BD16C339BF5068B55A7513BDC569D09497A950EBA3D118B9DB9D406158CD54AB946AE326A95F24A4DA95791269B0D';
wwv_flow_api.g_varchar2_table(1409) := '666E89582564689BC37298AC6A6A99AE7667CFE0F9222329A6E35E93BA6F644C28D3622EAB5A2935D8AC559E24978EF5B7B7926225503D8EE4BBAC84DCD889B8562EA4A506B390EE1AEDA345A6AD838311877674BC5763F6288D8662A1882E84DD6A6448';
wwv_flow_api.g_varchar2_table(1410) := '59571B7CAB5B883AA3C7064E24BBEC1C8284CF13EB0DD57C4E097CAC66922FEAEC76A935165C2FADD1A0B468E92A65D52B95062C5EFDE4758D69B7C978D6A0A88FF6F7286D5E312CD4062DBF5A765A0D9B615E38B05CA62B58677F686808DA6A955293CD';
wwv_flow_api.g_varchar2_table(1411) := '2193C8D44A0D552C4FF45BCDDE01855CA2D5694821BB44964E29A98AB47629D136D467D019E53A07DCE1B0BC96CEEACC64AA062369C035B518ACCED66C819109EAB8BC2285462CE45B0C6A8DD92EE49146ABA15CAA695462B7C3AE319AAB85524FABBEBD';
wwv_flow_api.g_varchar2_table(1412) := '6F482E57990D3A8DDE84BB41AD5113FC274D3E6D77F3D044A089008B00BA55E88F816D3DDB6B4257CA68341E1D1D818FC23E879FDC1111F4F1B863839FE11BD4081CB2F889C8678C78DC091CF189E2E28870A497E3BDD00681EBCFA12388B30E075E3DCF';
wwv_flow_api.g_varchar2_table(1413) := '09D00915A83F595AF33939BECE4968782C167BAA1FFC756ED08B74C7E5CEE572068301F700F2E1B2C6F2D5EDADED8360A0D3AA64F8EC7702B752BACAE492E11EA7B5ADAB8B2FC1D2B56C667471C0254C267624BB199A08FCD111F8C3B7414AA5526E37CC';
wwv_flow_api.g_varchar2_table(1414) := '474F02686D2412418F114F07F7B6C489469C4BE18E4804FDC60B136FED4F4AB3FF91CEBD9ACF267E397154FDEC77E5B7568D52C8F37B15E41078F1D0C3B362F111412DDC87EAD9B36753CEC67FABFECD0C5F0202B8E2E8B57C11DB207D09CA7FBDAA4895';
wwv_flow_api.g_varchar2_table(1415) := 'EB5B5B5B592C5E9CD8FFCE9571A9E9334B22FF816DD93F8A38E48C506779811C90F362A5A294C26ACAB2EB62B12A116308FC69EF42AC8C75183E186E8569F7E9532F10FE0A4F2DEEA6A2812511AFD6EA54BABCC30D9AFD0AAB688A6A22D044E01522D0DC';
wwv_flow_api.g_varchar2_table(1416) := '06E953300B153A9D486047488D4E53A519954C42904FFC793ECDF4D9187A6AB95C512DC796989F0EB0D10C41170B12F967A6C49C2D57AAD0223E4D0ABF99E6EBB32D7D8938CDF0A6B6024C686F3718B189B5B45007AE8B6EEA49AE968A0405183F17301D';
wwv_flow_api.g_varchar2_table(1417) := 'FD13C8F612C29B459A087CBD10E086873016861EFFB3016D0137433AC7D0B2D92C18F859028CE277EEDC696F6FF77ABDCF6D380AE21BF045F85060646A6F6FAFA7A7E7C5BCF429AD30003A35358541D9FEFEFE969696A7CE367E225B381C46BFFCCD37DF';
wwv_flow_api.g_varchar2_table(1418) := '048F9D9999393E3E1E1919E19A899440208031C4E1E161D8D5510A6D9C9C9CC4F1EAD5AB9C5510404D4F4F8BC5E26BD7AE211D7140313131C10D3B663219A88182C88F51B6070F1E00E4D75F7FFD8B00AAD1A866A489C0571001119FD0A9943A2969EF77';
wwv_flow_api.g_varchar2_table(1419) := '4AF5CF3748BCB4DA1E2796CEFA2D81E413D858A8914926FBB4AFD54844442FE5E95B3D6753BEE4F8709B9668BBFE2557DAACAE89401381AF2C024FFC61BEB2FA9D556C6B2FB93435EBDFDE29E652897492A995CF9EE5E2C1508AA8E51BE9099A7870772A';
wwv_flow_api.g_varchar2_table(1420) := '7F7CD84841244511FE85059827CF269E8D6F1DA43291FDB329CD780301AACE9BDE0A08A984C3A0A309EC38CA9A83B05C844CC01875BA4086F1FB374816DB26016E60D68C7C6311002B83B38D42A100A9039B85130E8C96887301EC0EEE0F60BC5C00B543';
wwv_flow_api.g_varchar2_table(1421) := 'FA592CC003FD7E3F8A80BFC1A706BC913B0BB1B02D239ECFE7C1FD1AE948E14EA12E2E270A22278EF8C9C59101111C91D228C8A5802B2291930CCB6AC38A0B695CFEB3323955718A2B8523E24844040418FCB3D196B3653909C8737070F0CE3BEFE027DA';
wwv_flow_api.g_varchar2_table(1422) := 'E8F3F95017A83E5735CE6E6E6EA25D6832971FEC17A30308A0B25CCAFDFBF72116423636369039994CA2D2959515EEECE2E222DC52608D47047240E641891F3D7AC49D6D1E9B087C7B10908BF89D5E676767A7E255B3DF6F0F86CD9636116822F02D44E0';
wwv_flow_api.g_varchar2_table(1423) := '8FE38BF2724047C369BD80363BEC22A942582BD518325FCC57D305994691486654821A4F6DBA7D77E9ED73A4D9739EF36FD90BE5E3899383BD4A9FAD852204C7C1B8845F2CA8CD11BFBFFDCA783212331B948932598805CD3A25E6E4C432A54AE6F8603F';
wwv_flow_api.g_varchar2_table(1424) := '6574E6748EEE97D3F39B5E8A29D3759988DFAA37DCDB3E9ED0C7247AEF6A386BAA85ADCECE48B854AD273956FC4DC7A1D9BE26022C021CF9041B047F03454400CD03F585DD12731D910E160A628C80539C432F071CD2C1D940DE60B704913B3C3C842BF5';
wwv_flow_api.g_varchar2_table(1425) := 'E5CB97612C4580091413D540FC7EF18B5F803FC3E2CA95020F84411595C21C0AD6873930E0812E97ABAFAF6F7F7F1F465D9BCDE6F178401D3B3A3AE6E6E6900D7654104B50D093931324A2227871C3EC0C81F05305C38404D881616B454E8E9D42547777';
wwv_flow_api.g_varchar2_table(1426) := 'B7542A5D5E5EC6CC46586E210A12CE9F3F3F363606CE8F6C501EDAA26C341A753A9DC16010AD831CC4B923478C610A86FEDFFFFEF7FFE11FFE017C1E55E02CACC7D09CCB0088D6D7D7FFE66FFE06327FFAD39FA26920C6A0CD7FFFF77F8FDAC17E9172FD';
wwv_flow_api.g_varchar2_table(1427) := '3A6BBAB971E3066A4436947DFBEDB791F24FFFF44F00EDAFFFFAAFD1907FFEE77F7EEBADB738949AC726024D049A0834116822D044A089C0E721F07522C0987E9ACA956489845CAF0B45A232A96C6A66C12E2772424B31BEDBE9341122D5F6DEE180B56E';
wwv_flow_api.g_varchar2_table(1428) := '728DF04851A946E4F73627AE8E0497B6FBAAE9CD94F46866D2EBD249546A586D367722D5E37D42D8EFDBDECDC42236B5D0DE3DB6B4B4AD901492C739BEF333EBDC7C1E7CDFC27458975472E1505F17A1EBFA382AE8F5C454ADC3BBC48983CEF70D0EE6D5';
wwv_flow_api.g_varchar2_table(1429) := '857A24CF6EC4D00C4D04BE350880F8C1351784161417A40E5C17D4173F41D5C0609182BD52C0FA9EC5034C12EC37140AC1460A0920A8888031C2BC89F4A5A5A5D6D656442010F4726D6D0D4414B3F16108C5C463C80479061504E3051705B1043F043D06';
wwv_flow_api.g_varchar2_table(1430) := 'F7FED18F7E0421988189551838CA7DEBD62DF81BC7E3715050105AF06D4E0E8CD2B0A0825D83DFC21D1A5394C13C7776765029745B585880811AF2A121C7A5D10A4806650513FEF5AF7F8D384EA1993A9D0EA57016A5CC6633740309471CDCD562B1C017';
wwv_flow_api.g_varchar2_table(1431) := '1A165D548D820001CD41436043C659FC043ED0193562E000941B2980916B35E470306AB55A44B8E288203F10867CC00B4A7CF7EE5DD060EEECB32037539A0834116822D044A08940138126026711F83AB940D7F8BC5CA15429970B95FAFE51285F28C48E';
wwv_flow_api.g_varchar2_table(1432) := 'F64D36D5718E574E2508868F3DEC4C06ACDAE8E0E60607B3F4C9FE2A8FA176235431B21DC9D0B94C88E1633704BEEFA470B4346B321BD6228C6FEE6E3C95DEDBDFDDD80FA8CB870E975720D3C2A9F72C4CCD780301F4A7B11DC5C2CAD6E2E252E66877D5';
wwv_flow_api.g_varchar2_table(1433) := '77846E7A646F7DD71F44647773855FC93656B06C946A469A087C8311C04301F20636873F903710C27CBE80084829282848A658C4CE9103D3E3281F0705F81B78200CAAC809FEF6BDEF7D0F14143363210D765A5838C16661DA8525B6ABAB0BAC0F266548';
wwv_flow_api.g_varchar2_table(1434) := '06AD055F85091776570844040511011105C3041B8429183582317EFCF1C7030303B0A68227A320D2C15A412C3157160A20118C116241BC9162B7DB614F0643861C10D4EF7EF7BBD00DB5A32E248288424F4E145A8A74C8E9EDEDC5230F7B32D443BBB800';
wwv_flow_api.g_varchar2_table(1435) := 'C9887047445005346C6B6B83791C8EE248412D388B7A71444BA10617201C01E9B0E5A20AE447A330100064001422681D247066761C81068E20E73071830FC3600E4A0F99CDD044A08940138126024D049A0834117831025F270BB088AA75743A5B2E5C8C';
wwv_flow_api.g_varchar2_table(1436) := '51D83D8EED4B1A74129BA3A557203C213A767CE16B5D1E9546AF5062721BDB2E7FF084A855A2C118A316AD2FEE782F74F3DBFA77C2A95E6BA850A915AB3985545C48F34534E5F1B8D4625E88915B448C56672404318649BF18B86FEF5986C0A217D88682';
wwv_flow_api.g_varchar2_table(1437) := '104BC54AB5565B27A5529946A7A69552B95CA191D4A928BAFADF5E7C9A2DFF5622002E2790F0846229B610C15671C56A412952A8956AA15858AA160109C7061BD36E3990F013340F26D3DDDDDDF7DF7F1FE4106ECF30AB82C122038828A81DF827BC9441';
wwv_flow_api.g_varchar2_table(1438) := '89910D54F0673FFB198A8057835DE327F8270CBFB0B2C2A918715047CE160D42085A0BFF611048CC43065F45C059ECE484E288433E844301A4200E6E8923ACC1B039C310FDC1071F605621ECB13008432B505CB83A431A16B242368EC482D9C2F40A8767';
wwv_flow_api.g_varchar2_table(1439) := '304FE80C04700A472E8238AAC611D571CD848B35782C941C1F1F473A5A078B319CBD210D24FFA38F3E427E30767871A35DB045BFFBEEBBE0C318148099F7DEBD7B100BCA0D33381A082830A318EA5DB972058D821CE8CFE906C9CDF00D46A0566730C740';
wwv_flow_api.g_varchar2_table(1440) := '2A1110BC57D37BA9D688722147F218995CCAE3FF9665355F006C95AA9104D6CE7CB21C540D9EFC25CC99AF62912A09FBB8BD1A634305B530B44024AE612DCF4A598C1D6BF9CF712D39AB67B94A8B4886FFDB560C3D5BE45B15C7701D3B58292409DE6F41';
wwv_flow_api.g_varchar2_table(1441) := 'F21B030B9A5C295312118F38ED2A7FF9EDA2D17DA7287C1CF1C5F8F26BFF96D4583F7D4588245894EEE9974F95AEF3EB788D3C7FBDBA6F093E68E6D3B87C955BAE5249945AAD488C371589DDED444291165D377C05EBF574B95CA3F3789AE566DDF6969F';
wwv_flow_api.g_varchar2_table(1442) := 'A816F18453C5DCA5F37DADAD9D6F5C1C3AA9199872AA54AE33B93436673BD7E336F79FDB5CDFED561574DE519A820546DADD62F5E5344BF353E2EA8958AEFD2A43F147D40DBD5C874EA1D6C0E751279062273D393AD052B95A299722C5A4D1A8D50670E4';
wwv_flow_api.g_varchar2_table(1443) := '3FA286CDAA9B087CC908C0F41B2C6EFBD2333BD9798182483047416A23446F9599E2EAF1E462F8EE5A64AA522D71A6D1B3BA813DC2F48AC0D978C163E1390CD32B9E2990409061703CF03A7048FC441CA411064FD063D054904608443AACBBA3A3A32885';
wwv_flow_api.g_varchar2_table(1444) := '9C1CC1463A64FEE0073F4011186FE12D8C39B4888009231B8AC01A8C2A60DD059904D1854AE09998A90B2A0B220DB20D9930DE2220DB1B6FBC812260A7AFBFFE3A9E71C8E1F83948386A444071A4401FB402C65EF06AAE8D7FF2277F828288430E28376C';
wwv_flow_api.g_varchar2_table(1445) := 'C8A0A95C59B07714844C4E43F058C42110AD837C445E7BED35B41AA666CC5506EF4571A88A382CDBC870E1C205A4200EB5211C55406D28C0D5DB3C7E831158F4277EF6CFFF9A0B2CBD9236C60BF4ED9995B999474B33338544E805322B75221CC6903A3B';
wwv_flow_api.g_varchar2_table(1446) := '98F5DC707FEDC83FF72146BAB8B387E9CA6F7EF1E1ECF4A3FDF505E2790B763E57C86F4DBCB51CDC9CB903178A4086B879E35795E4FE8B8BE0D978F7FE7AC23FF7E26CCF9E2DD1442474086E982CD6A3813D3CC467F3244AF5C5D5F59D9565A69A3D9BFE';
wwv_flow_api.g_varchar2_table(1447) := '543C15CA10F527CBF53D75AAF11378A542B0373CBD286924472DAFAC2EAFC0D96C892EA61AF97FF708ABE4F24A68731D703D552A9CADD4E1AA761A7235E2EEC3E96A3AF0549E97F8797094AA159268C9FE61F02C32798A383E3E801AB11C9D08E092A1D1';
wwv_flow_api.g_varchar2_table(1448) := 'BF25C086E0DB8BC2CF2EB8BDF12C38670B678B152AFFA2ABC065CEE44B7431C7C5B1BEE2BBBF9967D2B8AC2F13528572357BFC7B952CD2443E136F14D93C292DDCBD4F10CF59C8B691E70591629DF0EF1D11D54FD7BB7D41E6DFEBD451B284F941A798BF';
wwv_flow_api.g_varchar2_table(1449) := 'E8BE0DA530D1EFB728EF8FE4361697AAB9C4B30AE469E2602F80DD684EAF726C777DA97EDA96402CBFB2BC48173E05EAD9B24FA500D8E58D9DBDF545A2567AEA548C22A6DEB941D0CF5160DA97DC9979F4BBDC870D9981603AFF05AC0D0C04367CC74B8B';
wwv_flow_api.g_varchar2_table(1450) := '0BF9D84BDE8D0D0D5F2242FEF8C73F7E7131F4A51A013D1204B65B74EA3B87825C6FE659092882017BF4699E3DF5D229307828354AA15446F208A54CA251A9D113922BB5D9222DA8157A7B5A945AA75481D588699DD18C45B08402D2EB76A834062DD832';
wwv_flow_api.g_varchar2_table(1451) := '4C31023143977ABC369DBD5DA756BADA3C5485EFB5AB18B5A35ECEABE4528FCB4649D462A6DCE671E82C2D02113B1BEDF302DCF65E6DEB3EAFA23F7A3AAE35C647D187C6358532240F7B4793B1D0713E9FE3550ABC3A932F51D5428657AB61FB28B29CE9';
wwv_flow_api.g_varchar2_table(1452) := '6F73CBB4165C7F64C6DD829E34BAAA7FF456341568220004E0370B6BE10BA0C05B0B8EC778BA11792A1B781DD820DC74C1C41AA7607E2CE40B20BD377D3FD1884DF1C2316EF8878177F1822C54722441DE0BFC824F08B3D59455EEC9674A02213B45B651';
wwv_flow_api.g_varchar2_table(1453) := '1C6F3004A8C42D3405F60B8A0BF978DC4065C148A1060CADE0A51CB345415050B05F304344609E05F1BB78F122722203F833F82D52F0C4210E85E1210CD28B2A605005E7443AB82572A221609E108B9718E4A0161CC14E419BA10027077990019C13BA41';
wwv_flow_api.g_varchar2_table(1454) := '022A8526380B095C1194821A60A1D00A752111013F39D28BB3D00475E127B24131D4882A2016A7D06428862324A314746BC847F3510572A26AE8833C5012C870B5A3A5388B8670204038BE41108E06226703D866E48F8E001E04B821E0DB81CB7D56197C';
wwv_flow_api.g_varchar2_table(1455) := '47707BE3AA21C3E7F51FCEE63F1B479FF45FDE9F9BB9F78E5B9677F4C28F802C54EBB94C8AAC53308A66E177914B8BB1A4BA40944AE56A5451241656EBFC4C3A4D57CB62892893AB940A19119FE10BD8319A2A43BC737F39B3FBC8E97489C552AD56C597';
wwv_flow_api.g_varchar2_table(1456) := 'AA33A92C5D2E88A5A21AC3679DF34B45BA82C756B816CADFFEE5AF3A9C82BA485F2EE135800E80305BA00BB98C9057E709453FBDBBA1387ADF3BFA1667D45A89141FFFD33F0E5C6A55CB7542A58EA896F82249A150E431D532C59420A2501409311F4B50';
wwv_flow_api.g_varchar2_table(1457) := 'A6EA708260A83206F7198297C914CBA5AC4448523C413A95067916B213289E60F89F3FDA521CDEEA9C786D2BCDFFF0BFFC2F5706DC42BD2795C9D3A53C742E55196C085C4363615BE3F1B3F94A269FFDBF7F767F581D367847B3F972319F950A79953A89';
wwv_flow_api.g_varchar2_table(1458) := '79118552492CE0654B742997C1A353AAD404FC1AE73D0770D0B1BEF960DA2E2DDEDECE2AE2CB464F07D0E6AE45AACADCBEF9381BDB248A55478BB92A90C7A3515EA58479F958203387896AB99454260EE5AA8F7EF24069AAC0622114CBC1A813D1131141';
wwv_flow_api.g_varchar2_table(1459) := '91222996CACC6433743927868F49BA38FD5FEFAB9D7521F60E166173CA27E13843CD2DAFAC4D7DA812F04D766B9527025CD85E11A56A3C61BE54C666207219EB0890C30699D12816E6E4093E35E0E7EBC4833BCBE9E3E54020A59766A53A7BAE50CD2593';
wwv_flow_api.g_varchar2_table(1460) := '52B12057657EF270DD58F691A44A249784E225DFCA6C6FAB91941961578FC4534C058A61FD42265D2817D249A954C4E393A825158BF2E98A905DA7E033B734A731BA47F75723BC93C928DFBA37FD1B6C6DC7133DE9F964ABC4FD9B0FCD7AFAD16C5255DC';
wwv_flow_api.g_varchar2_table(1461) := 'D6B8DBA3B15CA9909289481E294C64F3F96402D7822F646F4B2E14B0E6DF3F3DAAF20E777DC74E3D2D949B0B452A954E8AC93A2910A732E54C2A2E97F1F355FEE4E266F56843A8504925229A204FE2295E352F92B2DB7C267315649308986C95FF687A99';
wwv_flow_api.g_varchar2_table(1462) := '88EF0B640AB14472922BCF3D5898E851F2E4168CECC463F1D322F24A8D2995CAD95412CE1067B70EFD44A927FF67F642CAC81DB96D10BFD1EA782A57C90125094CE865488B449972512C93C573956C322EAC538C44BAB89B3C5AFE8875111491344FB4EA';
wwv_flow_api.g_varchar2_table(1463) := '0FD5825B1E2C25430833253A938848D92B292ED3B54C3257AB6481FF7341E634583EAE2EDFBBE1520925A73B5403CC6221258757085FC0AE631B8B8AF1E9158A53B9723E1997E18EE70BD2453A95880A99B2402CA36A442C96AC96B35289F8ACD93F90A6';
wwv_flow_api.g_varchar2_table(1464) := '1E7DF071A17022ADD7CC2E479EE227A311115127C5921214C32BA5921549E5B154EE5FEECE79C4199227C1C070294F25736982C6F32BCD15E9442C2616D4B08BEACE7166FEE623878256DADC4F01387754DABCF79ECBA012AA0D2BBEE8C6ECDD76A746A4';
wwv_flow_api.g_varchar2_table(1465) := '34F9A3D95FDD9EEAD317E4062F804DA4B3A554522A97C2BB44C0C3BB810FCB2D51A3F89F7CE9F0067B30B777B2337598C8CACBC772B3B75CC17CD08C94A408A1642F923D9E7ED835D1C5E32B0B5526198F63FEA888479718F1ECDA9EA614B2B677C151A5';
wwv_flow_api.g_varchar2_table(1466) := '582AA793698074F6F1794AE1024DDC7934533A58737663B85C8097463211832881488247261A059839A9544C13FC482C495005B14406661B4FA68B99B4140F267B935772A99898CF22D3108E36CE6E85B71F3D28D1059B9A2FD3399E3C1772719D210B45';
wwv_flow_api.g_varchar2_table(1467) := 'DC8FF55C368D09658DFE4FA32C3EFDE80C600D143014744BF0933B22829E007744292EE01BD4089C04FC44E4D538113574FA422346239CF4F047E03EB79D762265523B7EB6D9D46DB631AE6AAF494698269EC42D3A2E82D7B6D7C1763A5D56139722B3B3';
wwv_flow_api.g_varchar2_table(1468) := '05BBFADA70ECC13BCA759E4B1F68B51204FE9AE17311E0F398D1566B522BC1C8EE009F5763C087EB7D7C5E9DE0C12D1D2F71AD4E87C4DF6B6CE9732B6B9E6822F0954700633DC94234558A8DF65E0F67F6115108B575A69E292773E5B452A0AF312C192E';
wwv_flow_api.g_varchar2_table(1469) := '5433DC10D2D906716F612E05AF6F2ED248E42278839F2D82385EEE5C0A4820B8C4D9828D3897A151F62999DCCF171C1B721AACB291D210852ACEC6B91ACF1E1BF21B0A9F2DD228CB451A791AE98D14946AA8D138DB48E1BE7067EB6DC6BFA9081C65EBC5';
wwv_flow_api.g_varchar2_table(1470) := 'BDA5B1EB57E6D737CE15A371C6727772D62ACCB43BAC5979CBEAECACD5C0EB6A736E2724A5E046B4C88CB6A9FD19053FB36B77B8EA2AFBD6E345BB5BDADBEA94195AF1854A957953F71EFF4F6F4ADBCE5D066225BAFE6866A79EDDAB52826E8B54DC337E';
wwv_flow_api.g_varchar2_table(1471) := 'F7C6872EA3EC205ABD32605C0DAA67A6A6AF8F4AFD2165E960D6DBEE555A3C5B531B3233C93FC94FBC314AE03945870E72D9D1FFD32BC060C9119801C89D6825B2F871D7C485CDC5E5C1918E8733270661222730B488329EF3AFDF7DBCABE69D64D2C468';
wwv_flow_api.g_varchar2_table(1472) := '9FF184673D9A9F73B5A83C9D5DEBFE0C95384AE44B6F4D7814D65E08C6CD8FBDCB4289C2D2D28A3FC5AF5355543ABF1D4B8656CB99CA68BBBC6E1EDDDFDC8BC523D7FBB469C3E8CAAD7B0AB3880A1FF1499B3F963B5C9ACDD4796D8A52DE32E69FB9E369';
wwv_flow_api.g_varchar2_table(1473) := '314B35F6C3ED158BDE64F6BAEFDFDFFDC17995A6E549574A4A1272B3FB3737666BD294E9F225BC75B8D71754D80BE7D3DB2B6FFC9B7332A981122AE767F693D145594D3876DE3B1BD3D7F6A6F335FA4A8F7B95B64C3E98648CCEB1DE3663EFEB8B2BDBF1';
wwv_flow_api.g_varchar2_table(1474) := 'E08656464C8C4FBCBF9297E75761F47AEDE2D0628437F5E021DF1D1DEF6AB7765DF9A416C2AC123A7BFB93733FEF1CFECB8A58BBB8B4FEE6907336AEB2271FFB85C3C58307659A3F6AD2190647671FEDE7337E8F81D773EE125F8CF138B6FFB19BACA58E';
wwv_flow_api.g_varchar2_table(1475) := '96AEBD36B81A164D2DCF764A9DBEF9353E4176DB89B2B9FFFEA329833DD2DBCEEF7EE3F2DEF631BF98610811AEDED4CE71627B11FD9A0BA31DE18C6A776B89A1E90B1D625DDF5B0FEE6E31555F9FCDE61E3DF779DCACC5A1BD3755162DFEFCFC8896102B';
wwv_flow_api.g_varchar2_table(1476) := 'B9C510A08C5CC4931B5A7E7EE3918212EADF9ED88A96B66FDFD51A8497C7FBE28469F2D6B48ACC8E8FF5ABEC6D8D2215AC2BB11B1DF961D7CF6E4552FECD63A67D7F76B2A2203A9584B2F3E2D2F41A5D4B7669557577D7C3E9F996E23EFA60E3E7CE2D9F';
wwv_flow_api.g_varchar2_table(1477) := 'D081F55970CE7684F5A80000400049444154ABE3DD05997B6E7A962CA7AE8DB5ED572C0F1FCF4445E94186191CBFE03F8851A20C96C381297861752B7EE49390C4C591D6C59CBBB8FA518E2718318A3D97DEF83C82104EE5DDD99DD35B9CD83D4EFA16A7';
wwv_flow_api.g_varchar2_table(1478) := '78356AB04D63ECBC323F73908C2DB5A975DD572F6F84D269DFB459CCF39E1F9D59382A6E3CA26BA24BE7070A8AB6F0C19E5BC90A8815EAF3D3935421E9D00A3A462EDD9E0B093207F54AFEF56BE7A4460F57C5534758F3A33B7B18CDDDF51F8CB6752D1C';
wwv_flow_api.g_varchar2_table(1479) := '168373333205FDC6C59128AD9B9F9CE3572217467A28A57BEEF16AB57CDC6B9718875E7BF4789A29A4473B74D6CECB8B07B1E3B987569B7C02937124DA4F6E39DEE27A449E3F1CBAF4A6522C4F5705B30F972BB980492AECBE30716F394AA60F884AFED2';
wwv_flow_api.g_varchar2_table(1480) := 'B54BEB87B9070F1FB697B57D9DB4A87BF8F1CF1E8A5C5569B5DA3B76717E2554CE042D52C1E8A5518F59B52D7764C319EB28DB82462D18C54BECEEF215AA83BDDD3E576B7BAB617F4357C966E436C26D50A454ADD9EC01888A3F98D95C9CE4D1D5AE765D';
wwv_flow_api.g_varchar2_table(1481) := '896732A964F0594FA6F34E7E56DD3A0C7190992AD55757D7FEFCBC3DC477ADDDF938618C2416A72952A95757462E5EF5EF1D9255BC81F8E51A31B5B088D57DA3BB273F7CDB9D315E8B9FECF3DCB831795BD1FCF6C33B0C296C3791FDE7AF117C8CB53D27';
wwv_flow_api.g_varchar2_table(1482) := '449245099DF5E5F917D2FEB8B8FBF1EC523D737CBEDB6A6C1B7BEC3B4EAE2FE88D8273172F4C1D9463BE79094D5D99E88B0B2D8B93F7F524FFFCC58134ED9C7C785B4AD017FAED6AD948E326CFD6788B4BCB97DC024DC7B0422B5B3C4C05E767696175C2';
wwv_flow_api.g_varchar2_table(1483) := '69E6797B1EBDF7F0EADB231889798E42AF28E90B14FD8A34FC8A8A613F45DF9A806BD0682BE26221CF6631D86C769305C6210BAC4C66442C16BBCDA63759617B671FACD3F015BD784DB59A08BC3A04B0D2938010F2185E387310CAF8E1F5A0975A0584F8';
wwv_flow_api.g_varchar2_table(1484) := '387F902AC7F4322BAFCE3FCEF9D3E5C4E99ED9AFAE628280511483A0AF526253561381AF2A02E8F1CD6F47ABE95DAD5AB513AE64A2DB0B7BF1BDA98FF43A8D40A1BEF968B5E49FD4E9F42942F1CEFBB70E36E76657B65656E71F4F2E2D4E4EF2AAA9E540';
wwv_flow_api.g_varchar2_table(1485) := 'FAF683BBE9A3358A2017D7FDAB8F1FE7B2F14A2E63323D593BEDB8CCBB77E37D9DAC1CE36B6FFFE65632139D9E7AA0258B53C1EAFEE2474A19291189957ADDD46EE6707552ADD1DC9A3948FBEEC37FE1C6ECD1F1F61C4932A0A3FEE3F4F483C7C9C00E66';
wwv_flow_api.g_varchar2_table(1486) := 'E6966BBCF849AC944FC9C5E4E45EF6673FF9572AB24D49E4930FE78499DD8A427BFFC6C375FFCED2CD0FF53AC1465AF4F8EE878B5B07F71FDE2BC5F676E2B5F7DE7B3FB0B7FE687E3DBCB7B6B8139C9F99A4B361ACC091AB5493C978369EE411B5749DF7';
wwv_flow_api.g_varchar2_table(1487) := '9BF766F656A7177DBB3BF38F2AB572E0E8F8C1CCCACEC2DD070BFEE8C6A441AFE50B2414C3BF39E75B7DFCD1D6CEFEDCCCECBAFF68697A4AA7116EC7A8FB1F7D1C3FD8E4F1190126C19E196B1391C485E18E0F96331D845FEF1D2ED7F91FCC6FDFFEE09D';
wwv_flow_api.g_varchar2_table(1488) := '42CC1F0DA57B0C0A4FFBA0D9E18CD6A481850F2D166386D4ECDE5D5C3D0CAA6B2715A1717FD36755498C1A93C36193AA8C812CF3F1FBEF6E6E6CDC9F7C948F6DDFDD3AD4ABAAB1A438B1B5EBD4C80C6A93CDEE9028F5702ABDF360EBC30FDE2F9E6CAB24';
wwv_flow_api.g_varchar2_table(1489) := 'A4C5E6D06BD556A74D24911F474AB1C8BEDFB72FE2D7EEEFA779E95D95D97267617FE3E0E0EE3B3F5DF1F9661FDCAC55138B1B9177DEFD30E49B3E4E944C56C6DD36D0D1D7B353D6EC074354784F6B31AE2C2CA984058DD9E1B09B5546138F204D0645BE';
wwv_flow_api.g_varchar2_table(1490) := 'C2A70AB93243CCCDAC5B8D82BCD4BCB3BDB8BD1E124402758339B071A74A300B8FB74AE96386873E338C5BCF09E8F60CB4A88364576CF1BDAEF18B3581F4D1DAFECD77DE89FA56309A3070A9EFE3C968BBE658DBD2EB8B5402BEFBFC7A01DF8E688E5A9F';
wwv_flow_api.g_varchar2_table(1491) := '5D666A98C1C7F282D9E5E07BEFDD38D99DC71867A65E5F5FF7592519ADA363EF309FDBD9319B4D0C215E5B0D91A923F4B96EAEC55544CC62B5DBAD269DDE9C6384BFB831B5BDF2F8F6D45224B0B4B11C16E58F2D16AB40ACD44885F03C725A4D1ABD11E6';
wwv_flow_api.g_varchar2_table(1492) := '50A35AB65B9512A558BC42F8D7A7AD267952643A5A9CDA086778D175A1D6B434E7C788D0731A799A44B2AC8A7507805BFCF4C6815190909AAD9B738B07F1ECF1DAACC56C52EA0D14C3DB3B88AEAFAFDD9DBA234C6E5A1C3AB3516FB238489102B796CC60';
wwv_flow_api.g_varchar2_table(1493) := '0AA4E1D65E5908159893798BC5B67994C1A2B66B9B3B462D154E4A52A12704FB591D525522E99FD55B4C3BBBFBD9427A6966C9AC214C260B2110CFEE4525F12DB3CD0643F7A38DE0F4AD5F2F6EF956263FCC5395B585C56A2A04BB22405E0D241281691E';
wwv_flow_api.g_varchar2_table(1494) := 'EB75CF448AF577EF4C4FDF7AAF5C8AA77742437D2D9876A335DBB613B5C2D62D88F207AB875BBB9C62C1A4241DF499B44AB5D1627659656A6DAC40EF3D5E331B7422B9EE20984AFB7C70BA7A1860D2A135A34AC2F6874F972A88976A373E987B78E70360';
wwv_flow_api.g_varchar2_table(1495) := '1E2913F98319A5CDB5EDDB262A19A0A5329831568696EA95128DC90E4F00DC614B1B9B867A446BB52EDDDB3AF4ED2E6FFBD7A6A6760F034439BC7B527CEFBD8F5766EF950B79314379FB06467BDA32159B2F18CE1FAC98AD8612A9C44A0136A32AEEAFC3';
wwv_flow_api.g_varchar2_table(1496) := 'EF350B37E9B98F4BC5F8E15200F391B073785D6D0BA7E1685DDF8B15525BAB72936163D74754D9F5299F1BD6024135932A08D4C75B9BBB7BC9CAE19ED56216CB35299AD8989EB558547ABD395D17FEF2A70F7D1BB3930FE73381D5C36465657DADC61499';
wwv_flow_api.g_varchar2_table(1497) := '3A7352C662C38F9972A6CEC054464C6F1E7DF8EE3B918DC51485C538237DE7069D2E37A934CE7DBC6956941546F39DF9BD58E4F8686A4B2AA470BDBEB8F04D20C00008FB6360BDD12F0EA66725C33AC12E5AFA2D0870F2848F01EB0BF64940142BB516E0';
wwv_flow_api.g_varchar2_table(1498) := 'FAF9D9C0FD2E9DC989B267CD38CFC2D84C6922F07547002F1FB5C4D8AE1FDC8E2F268AC70AA146448AE5229547DD6390588584582E54BB553D72BEAA56C317B7199A0834117819043214B13035D9E356B458AC84BDCBB730771C4DCA0A89B6F636A9C971';
wwv_flow_api.g_varchar2_table(1499) := '7410B1484AAD6D1D15A1297CB86BD789DFBC346E72F58D8DF6E694AD6B4BB3ED6AAA73E2DCFA66EC787B13C3B3D04021249416DBF2FA3E5DC9168BD568365F4A1E77B418D58ED6783653A769019FE8F03A64264F2E7E62356B852299C56CA81322AB5AE1';
wwv_flow_api.g_varchar2_table(1500) := 'F1749E242A7A49B1ADBD3D2790570A49F44330F8C50EFC821E20CE304AB236D8DB666AE937EB541570AAAD6D15C188D53A3E51B7E9957AA73B5F28A7F3055E2EDEDEE6141BECC993C490D7E81C1A595B39F46D6177C6BD5687F68D2BE745BA1668CBE95C';
null;
end;
/
begin
wwv_flow_api.g_varchar2_table(1501) := 'A76A368D6C6868D0D33B04EFCD1C550BEE1F3955FC0B17C794CE8107731B1A32A2323A2327A94830AA1795DBDADA09898EAE31FBA1989CC95C1AEDF2F45DA079428D44D8D1D9D6DBE66C19BCBAB09FC81EAC789C26919C5D0F8F0BE8A7CE2D1EF5DBAA87';
wwv_flow_api.g_varchar2_table(1502) := '3C773EB20DE3361F2E98A07FA08C62D1712A512DA6B0CF5B916604C5E3C1811EB1A5251DCC4AA5F591214CC79F2832BC014CDDD0B7F475B8F58EEE6CB92ECC2547467AC7C6AF902A3B2966C647FB2DF6DE6A961AF05A8C5A777F778BC6DA010CF93CB6A5';
wwv_flow_api.g_varchar2_table(1503) := '70F7841AB53AB6E3A811745D2920BAFA7B57578FECFC90A96DACCC303DED0E67C72066F9A68A45AD203936DED733F11A29D1027AC08FA0550A0BD13A55499F9CC42CBCB45028ED779BB0A83DEE22B74E6AF0F474B84C8E9E5E9210B5B6191546371CD369';
wwv_flow_api.g_varchar2_table(1504) := 'A65ECAE4867B9D1A5B573A9E1495E8118FAB636CA25C2D4908E6C2D54E85A577F1204CD069184EE796762B898327607DF26F275AD4A4366583E70F9777883A0D35E09F82237AF1AB0B7BE36DB2C3AAB29438E8304AFA2F5F891689987FD3A8169FBF3691';
wwv_flow_api.g_varchar2_table(1505) := '1058F68F76B06811F4676F203033FC6115238619E9B4A9BD43822AD5EEB05D1C1E6D1FBD9C49D79D3A11769D3CAE089D9ABABBA5CB6BB1793B7B69BEB4923819EEB45D3D3FA136B747C299162539303828565B3D2685D3D1DE66B7BBDB7AE1FFDFEE3088';
wwv_flow_api.g_varchar2_table(1506) := '4D2D58FB065E0F4439310853B8A523134DF1C9DA40AFB567E05C96AF46B73A98A96D2DCE11F5E227ED7BF21F7A5134BBC91F53AF6572B95EA7D6DE3D92CA54D2798A2C078606FBAC9DDDA19220BBB03230DC952064B24AAABDAFC36E52F50CF48954263C';
wwv_flow_api.g_varchar2_table(1507) := '77784EE13B50A3A9449EB6C9AABD43C3294659CEE4B41A120FACCE3358A28031B1BA1B49063085FB33E130960F458E6327479BC16222B6970F9CF4759A7AFA0678626D289177A90B7D23A332BD2D9ECDB975D4C4F8B077E4AA522C3E3F7E4E666BF7CF1F';
wwv_flow_api.g_varchar2_table(1508) := 'F298FC805BEF19BB148CA4F3D123F6C666F93C7BDF61D9C693134C62C28A4274AA5CD3F1D203C34394D8588867B55ADED868B7CE3344D1A56EAF53E368EDEFF0E85A5A198A68512A470786272E5C2EF3553A41657864202BD4E38550ABD52BD50A80024A';
wwv_flow_api.g_varchar2_table(1509) := 'B8A0EC9545250CE10F25C2B148FA24B012C85792BB54AD5EADB03B47E07A636D300A37224563A6693693EAB0AB5CFDC3A5385D12CA0F8F0FB391E44E30AC32E2213D7506E1F1C5223ECD672AE9E861A228E5470952D1D9AE9F181B9C18BB2820E5DD6D76';
wwv_flow_api.g_varchar2_table(1510) := '81C48CAB0C4FE27C9926A8F2E56B5D2AD7A8414EBADABB31A7A05EA3844CADCFA6EB3B374E60F5BE5A255101555E212A9F59031803436B737BD154A490C8EE0682A948D44A56878706D5664FA14E50A1D0D020965AEAAB1012FA243ADAE5BE74F99CD2E2';
wwv_flow_api.g_varchar2_table(1511) := '75EA6523E3970E195D32B46594F2262E5EA32596C042809D907F7A930311118FC956F87844D1FC5ABD960FA67B3A0CCEB6FE2378F6970BED2AAD52213D35177FE60678853FBE4E73803FAFD9F39B273BEBF3C9A323A351448A4EFD2A4EB3566B4CA55282';
wwv_flow_api.g_varchar2_table(1512) := '7338EEBDCF2BFB72E978A3C1010F5FBB972BFEF52A8537381A8B26BF84DA280517CD26077E09E89A45BE0804BE8839C09833ACD7E8E58C16739DACF256ADC02CAACB199A308ADC2689472DD1097862A7A2532332A5D229CC833D3B07F8776923869FB078';
wwv_flow_api.g_varchar2_table(1513) := '3266C9BEDC33882AB869FC7FF86308272E00D8F0856E288F712EBC0C1B3EC967D351E4D9F44686CF8B60E2282710236C9C873352B016341068D48E699380058D6AB40B6A60A96A54D748C1CE49C806E8200463954F9D45ED9080D9CB10FB9434200669DC';
wwv_flow_api.g_varchar2_table(1514) := '5E4D10824A51BC51F5E7A98D74E889B142D4F87979900162D13AD488AAA1D8E7E5FCC3D35111AA43DF020DC78540750D990016ADE62E0D9479EE656D647EB908EA7DB5738083596AFAF6ADBF7BABB373FCAD485D91F72D774F0C6E1FE5F8B58CB45E6554';
wwv_flow_api.g_varchar2_table(1515) := 'A6D0DE3156A1D049984C4DA6AA6774468B01BB140865D16C819FF6B774F69669DED16E64A845DE3B71C9EC744A24328154B1BA1BAE95D391D0895123485714D96424168A0DB965AA8EF1FD8DE50BC3BD2B5181BBBEEF1CBCBEB57D685352A192DC4AC43B';
wwv_flow_api.g_varchar2_table(1516) := '4626CA3CE1F15E24435444D1C8B96B13DB49BEB37E3878F16D87CB29D5E82339FA60715965915319CA9FA30A7BB383E7C64307317BAB7EF2F1A1A01A89E6895E0BD5317A7D2F5AA14B8958E0E4C280556CEC2C14F3919DF0D0909312A8B46246ABD23A9C';
wwv_flow_api.g_varchar2_table(1517) := '36CC80B7D99D7CB1726137D62A8CF65D783D559787D7272F8F0F24F956199392EB4C568BFEF16646471C5262934B58D60C5C08EEEDD705F5437FF062BF4168EDA6E2477AABDDA694C5C5267E6477ECE258A6C0CFE7D3A19313B7453ABB9EED329765FA16';
wwv_flow_api.g_varchar2_table(1518) := 'EE72478ACCFD5B1FFDD535CF9EAC8FDA5DF274B5B6D92D9EB64E914C0B023C170845C3FEF451D0DDA2F11D0A8E8ED6133B81E1716B9434F5E99878DD4C1642B6D6F695A35C2030ADE465B5566F325A15884A5A95CADDDAB97494BADAAE098549ADA8A86E';
wwv_flow_api.g_varchar2_table(1519) := '6D59F4C7C3C1398DA0A435B85BDCC6B6B6769182A5E2698A486FCFF48C8C13A45CAE92DEF870E95C0FA973F47FE44B177CF713C7C5218BC4817DDAA21581B8E6719AF556AFD5A4EEEC6C531A1C98EBEBDB4C1E1EADA5C281F39DE63069DF7CF830524C78';
wwv_flow_api.g_varchar2_table(1520) := 'F05E6E1F3ACA1081B9197E36AB6CB13F98DA595F98E255621EB7752F270EADAE848F0283AD669A369A344CC5E8E285E7D46D5743C1F04E20504E064647062852FEBFFF5F1F0D297C4AD748E3E9806BEBDDFBDB7DCA43E7C51F2E3F5CE8EE30785C686BA7';
wwv_flow_api.g_varchar2_table(1521) := 'DC600E17A8855BF7FEE2BB9D5B35AFFC7891D2398347F175DFF6885D46E9BA8E8E0E36B7775D1ACAE9EDB55BB41D1D6D0ABD0DE6D7E2F2D19FFEA74B067B3F66679E1C6755F582B1D34B0AC80CC9DF58DBDC0B059DF554CFF0F0494134373F572BC55D76';
wwv_flow_api.g_varchar2_table(1522) := '63AE26A897B246A1A8B5A3BD2856AD2F6F862221ABA206DA7994A82E2C2DF2A984C16CBDB51C589D7DA8CC45DC5EA72F520FECED440FF6C6FAACB8D3DBA5D18AAA271D3EE8EEF72EC6851FFF3FFFDBE5AB3D84E0D3652FD05E5F34EF9FBF7F92ACEB8495';
wwv_flow_api.g_varchar2_table(1523) := 'B254BFB2B27A1408B9F58CBB677C7337160CFA98785C6A732C4C6EBA2C6485478EB49AEBAAF6B9C72BA9E390C3283EAE296FDFBD7FBCB36211302657CBCCDADE7138C42F9FF40C8E9C648A7D1EC36194675516D526CF7FF9784BB2FFBE6B0033143EED7F';
wwv_flow_api.g_varchar2_table(1524) := '2EED1E7905299BB7272577B64A8E92A29EC0C64A387ADC6A5194788AB5B5CD48286C54F0C41A33BC244811D9E97108D4CE8350786B3FA48C1DB55F1CDB8B968F02C781DD8DD1EE16BDD9D9D1E270783A0442F8188B67B67CB817E944C4E2B22FAF2742E1';
wwv_flow_api.g_varchar2_table(1525) := '835A32DC7DAE2F96A74E15E35B940595C9B31688A756E765359A6734577C61EFA536922FA449C1B26FFFF0C82FC90447C7FA97F7A985C70FF39943BB5D6630DA31FCE06A696384F2A5ADBD0E45D5D6D29194599C92E39543D1DAC264AD1875DB35D32166';
wwv_flow_api.g_varchar2_table(1526) := '61F20E190FB458F565A1657D7D2BE00FB65BE85AE7446573D1303071B0BEF8DAE531BDCED2D1E135DBDD7CA1389029FAD79683C1C3C116494E3360238E74AE01B1809FADF16F7DBCE05B9B91CBB352BD6B76758F4A472889A4CB2EF1153493F76EA5035B';
wwv_flow_api.g_varchar2_table(1527) := '0EB9A4AA50AB7271497B5FE668A7ADD51B2614FFEFFFFA8FAF8DA8F80A7BE3C686C93A39FDA8FBC2B8D66CA6F3296B47DBEA4628781CD00A0A4A837D2B900FFBD7D3A99316A7294E094595BC564D7AB06D44910C1F1CF9D67747DCFCBAA627183A5CDFD9';
wwv_flow_api.g_varchar2_table(1528) := '77D4B2CEE1618751DBD6D9A9305AB10642A2C4F32FAD1E9D84CDE26C54E93C585FF20542A30642E9ECA20F93CEF3AD897816C6B6673F94F8CAFFE17380BF0904F8C3FB3B0661F0282FD3560E54B64E0AC6600A1B63F0F793F4E1CEA2D9A881CB07467830';
wwv_flow_api.g_varchar2_table(1529) := '6AC50E2CE24182DF09C1C3B008763E802307E67053D848831D9EE183D1622482606890BEC6E57F6E04D703FDA16F4340670E019DA7970858BD06103D17C0666213812F1F812F820083C9C815F25CA628A8CA247CF9E9E22E35194F4D54488AAA2A255AB5';
wwv_flow_api.g_varchar2_table(1530) := '502FE6CB30A6CBE694CB9F4B804154C052305A741613503E30311015EC8484E58210397BF6778FA35E6C3E8445A77EF722CFCD09AA8F5D82B132D6539A1C1C1C80F59D5D1B8C2B8E2D8B41F85F62B1C0FDFD7D4840F3B1E91156C902689B9B9B6805F667';
wwv_flow_api.g_varchar2_table(1531) := '82C7295E29800B7990823C6817F401D9DBDADA025080915B330C2AF97C3E7030303148C059EC1B8C9FC09FCBEFF7FB21160B71A32EA88AD635CA462211C4B145130A221D4471676707F33D9E0BCBD944548AFC58A6EB6CE2D938367942ED8011DC1BD91A';
wwv_flow_api.g_varchar2_table(1532) := '5CFD6C1EC4A1278E7FE0CB133B450310DCF3882060F931AE3AD4BEB2B28265C610500BB69E463600FB940E7FE0CF574E80E95ADDA014757475F125300DC8140A756F974BAC71F2EA558352D6D6D3C9083442B2E63629619EA1EA98AA23D01BB4158AB06B';
wwv_flow_api.g_varchar2_table(1533) := '44C3830375855348177B3ADD1D43C370D1404F00F6189759CB5718B0B2915424F43A4D26575BA55CB7AA85831323628551AF948176CA954AA7C56071B660D73FB944E4B0595D0EABC608B75F354FA41110D5E12EA7A5BD4F2A123B2C46A5DEC675D6B1BC';
wwv_flow_api.g_varchar2_table(1534) := '11563CC78249525016B9BCCB2CEB9FB844CA94329D6A666AA3C75E737BBA87C7468D26A7DC60AA5154AB59D53F3E96289272A2D8DBD33E303CA0B578715763E577B3D920943C19D99789052EAB011E985832C9A455785A5AED1E0F8D9565F88CC3AC73B8';
wwv_flow_api.g_varchar2_table(1535) := 'DC1289C261D67A5BDB3C9D1DF07D950B796D6D0E6F2BD6C6F33242059A6CD4C88C169BDDA83559EDA9425D4865073A9DDEEE113E2975D9594F4EEEBA9728462F2E760E8EA8B456A642596C4682F7E453AE929242ADA5944D2B487E5B8B8DD47B72E9589B';
wwv_flow_api.g_varchar2_table(1536) := '51D57171422254E8354A91140BC54BB198BBD8A829E4B266ADD866F7D4E5DA422626150B9D769B5CAEB46955706CD6181432B54AA85715B319AB5EAED0B30F6323A057A65680DA3BC0EB1ECFAE55732717463B8572CBDDDD84ADBCED323BC62E0EABB596';
wwv_flow_api.g_varchar2_table(1537) := 'B25059C9A70C6A99CE64E33C4E21015EC7A4469F4FC53B6CCAB6A1F3BE931275B4E5729BC746C7B1A0944125C9666BECF882DB150D67B42A121ABB1D368DD9998A65DD26C1C0F018B6B1531B9458465F8D417CB5FD3814D54BE989A12E8DB9757D3FB63E';
wwv_flow_api.g_varchar2_table(1538) := 'FBE052BF596EC3DCEC27012E88F55C7EB01FCCC45524040E18DAC44FAE5AB95A37C8E8B69E01A5DA8A9BB02AD35593B18E165BF7C0488E902543E136BBBC6F6058C2D2FE272F790C8CC9FE7FF6DE3438AE64BBF3BBB5EF3B6AC3BE1324006E20D86C924D';
wwv_flow_api.g_varchar2_table(1539) := '367B7FEFF59364699E3472843D614578BCE8B3E5F03745D8E12F3331768415316347581E2B2646962CBD67BDD7AF3736BBB92FE0061224F67D5F0B40A1AA5085DAFC2B26FB120F04D124C8DE80CC60DFCE9B79F2E439FF5BB837FFF7E4CDB49ADC615628';
wwv_flow_api.g_varchar2_table(1540) := '2CBCB73218B46CF169F1146E2C6EB72591D26A33B19347EAADFE4ABBCDB29CC9390DE98AF2329B37BC188999956C696928501A5C49E8945CAC3CE43139FCFCF4A26B698F39EF2F2E1B5B4854D932567B515D45485754135B5A6E0898EA5A4E988D4C4777';
wwv_flow_api.g_varchar2_table(1541) := '186D1EA7CD6C70792EDEE8324C3E6C7DE398A22F6CCBA726BDCE904A6B0C3A4349C01DAEAC9E8DE602FAD4C1D656AF27A87305E3CB119FD90CB5CE7A7CC6D595C6BD5581E26A504CE59DACDB5C5E1A58D5B99291A9129FC767E76D45C5A2E235AC2E1DD9';
wwv_flow_api.g_varchar2_table(1542) := '575D54B9D76A34F9DC6EA3C9EA75DB07A2FABB57AF358672C50D7C97FEE4D94778F6405DA8A46A5FA8B4D4ADCD84EB1A9797E24643AEA234581408C414BB2619E52F31545EBEBCC627B4097E574677F1F4D45491257FE8E8017B51D9F8425C9F98DDB7A7';
wwv_flow_api.g_varchar2_table(1543) := '9E9762EC5EA8FA15705B52464F2EBEE4B5996B6ACB93E6402636B7BFAEAC785FB3CD68F6B9D983C6EA71DBCD5627CB30C69612218FC55752EA70589D61BE3CD73A587B4A676145D8A3CD25C1AA03D3F3AC93977005BD25018FC51D527B61152BEE18E1CA';
wwv_flow_api.g_varchar2_table(1544) := '865049099F5E47E3469735EF70BB4A8BFD33296B58BBE476054A434581CADA4822ED5452878E1F761595FBF49AD2A67DA51663B8B246FD52D7A0651D62EFC262BCDC996F3C76DC62761639AD7C4A405FECEE36373E17A8B43AED765B51C9AD5B1DF9D5C8';
wwv_flow_api.g_varchar2_table(1545) := 'CC42B4A5429F70EC31C567825E7FC0EB0C9494BAF0C6E3B59B4C664FD18D077D8BBDED275F6FD6DA9E180CA52AF5E4EAF71F292B0D990C8EF2CAD09AC6990664BFD3E30BDBFDFEE8E292CDAAAB2A2FE15DCFD2DC92D5982B6651869471796E8A6F7EEB0F';
wwv_flow_api.g_varchar2_table(1546) := 'B4C435F6C8F478A9DF76B095F9088C431E5F4DBD46614ECD722CABC927CBFD0E260E2C2FACBA2CB913AFEDD73BC34EB7D9E27344224BE23DF813001FE55E090166052338E1C6A41692E1F5B0480CC5B81D93187CF0769C37E2D4B2F6E6C6C68FCEC5B86D';
wwv_flow_api.g_varchar2_table(1547) := '8B71C0A6ADB657F8D77F77FB64DDDCDD68F8846DCCB5FF034618B1B9C986AAE0F969DBD895BFFDF9FB6F1BB4DA92FAE61BF7465A4BB593BA902B363EA771CD0CF5865DA6D23DCDC393D1D9D18152973EB8AFE966D7A439BEACA423478E1CD6DB1F7F1AB4';
wwv_flow_api.g_varchar2_table(1548) := '3DAB642B898044E0878600BC82F7385B58C58B2D98157C60C31B47EE757021F6078217F1E5ADAA014E058F62956328137C0C31C6FD1C617D227208DBE14ECD30987E272727615F6C3EA43647180AC70B26D4D22FBB19C1794460939BE7F5EBD76948A7A8';
wwv_flow_api.g_varchar2_table(1549) := 'A2214C86EE3043AC9D2BDAA21F06C83D995AEEBAF40507A377E828F76DFCC5186ED7F0373631A239B56846ADB00101F4F026150DD84FEFD024EEED34A104828431D072C194A0A374C75E47B422432B9E4C08C03359FC99459B51857EBAC600ECB972E50A';
wwv_flow_api.g_varchar2_table(1550) := 'FB15518225144223914733BD208F305E63301417619CC23C0CA3BCADAD8D2DA0E8857D89D1505959C99EC08073EBD62DF61066D1012C84B6718D6EDEBCC9664B600B59C53C6C60CFE463C78E41E7E0B46800377C67AB279E0B20D9DEDE7EE2C4096A7990';
wwv_flow_api.g_varchar2_table(1551) := 'C17E6FDFBEFD8B5FFC026B594C12F3A87DE79D77380579E8EEC3870F59611BFBB1EAE2C58B274F9EA447DA0A2FB86A988A255C115CC07874020B855C117E42788D300E423E29075804AE5EBDCAD26598CD7E51ECE10402887145D0865A70401EB4818EB6';
wwv_flow_api.g_varchar2_table(1552) := '402D7EAE5C447E2734A7232E87E88BCB8D4E4CC24DAAC8A3015518CCC5C5667AA110F390C41720152F41583CFCDAB56B6C4305206866DB0F5A01B2B8AC5C1A7E0934C1005491A8557F30EA4F77EB0C6A31864BC0CF03DFD70BE32F56317240E059E387F5';
wwv_flow_api.g_varchar2_table(1553) := 'F23B2C3F9355FEE67FF93FFE8BB73D45877EB1C35CFBF6DC594AE5BEBC74BB359C2BDB7748D118BFE85978DD3B67F3B386F0F3A6DEC9883F35EBA97A8126CF52CD88F946F7B87EEEC1C196D7F4D6C21AF83B322DAF29572EB51D0A6BC37BF783F977EF63';
wwv_flow_api.g_varchar2_table(1554) := 'FBF8CAD283EB478FEEB57A8946FECE3DE4BB37E647DDE3723277E1D2955C62CE63D61D39BCD7E6AFDFD41DA63A5FBA76A7D216AFDBD7A2187EE75DFCA6F2DF41210F44C6450CAE783AAFEF8EE70B8F691EA03C2819A8F04CE494871447120F4D9EA70C33';
wwv_flow_api.g_varchar2_table(1555) := '7898D290C45392C493487D1889CCE3D544D7ABFED1E5F9AEAE7F684AABCB693DDEBBA373DD173E4DA4B5D9F907E6F277AD169BDE68EBBCDFAF71F93A7A1E56C48DBD765D5172ECEEC0ADE4D2F2902E71D0646DBB726F753536AE5939E9735D6BEF7F7FAF';
wwv_flow_api.g_varchar2_table(1556) := '951D3CAB277A037B2401FED1FD16A4C11281EF1A01EEC5DC4CA119DC61213F8CEF29E116CCCD9712F85EE1A6FB8803A81961226290670286303A8810140E62831EF809B40A720289420F4C0C19980F3C13857018B822FC045E8718198E94A30A3DDCF789';
wwv_flow_api.g_varchar2_table(1557) := 'EF61C3810307E05D34A4049D3C0304538529F184A09626F488305D50427364603B6C298419B4A521CAA9A5C9A14387B016CE49A6BFBF1F428E4E9E3A7048DCC47882AE94D39CA70E6DF7EFDF8F72780ECF243443752075ECAED4D1D1412196B011310298';
wwv_flow_api.g_varchar2_table(1558) := '4717502F9AE02625503E8E68C647BAC065FA25D11CAB3006AB408F23915B5A2129B0E51909C746155416F3206F848B91A9AAAA8212530B5DE7142369452DCE4244090BA31C2868883CD6A20DAAC933157B68482D6DB10A9B69C891EBC22319CC21DBF885';
wwv_flow_api.g_varchar2_table(1559) := 'B534C71D68245DA001B8C01F19CAB11947F082AB46A75C500CC678F1AE81172234E794AEB1130DC850055D47121BB00A559884E3800F5CC0CB8B00982DC41E37191F70EDE88B4E3106FCE91131BA13255C08F453CE6522891F1EBF134CC5354EA9421E07';
wwv_flow_api.g_varchar2_table(1560) := 'F939A10D617EC328E432D11708603F5DE097682B8F2F898053A3BCF7DE1BB6F03327C9BFA4FE1DD9DC61D4BC77BCD94EBCEC5114FACD5AAF4EF33B9372BFD1EBDA908770F2378A3D8F0054EC6075C8545BB43E78F83C0D7F5C320E8372E6F87EDEDC12DB';
wwv_flow_api.g_varchar2_table(1561) := 'FC5E2CDF1BB269FD6F184C4F22B4DF8B193BA0539759FBEEA9634C8C6597168399C92F9B2793463979789F8535CAB4BB65DAE6F7F3CBDE1CFEED961A947C6D25130A1AFBBB89F9CFF935D1C3ADADBED2FAB2A0BFA2A6B2B2B676ADA861A8FD6E7DB1EFFE';
wwv_flow_api.g_varchar2_table(1562) := '92D13CD5997056E4E7460EB71CA8DE7B7066D5A85D1C3872A4A9B2F16046B1580DDAC347F6586B8F2E2F45B66B8E6C27119008EC16042039500808836047E461111C215164E024D01832C4D6A03A3016B8840A0D0C04B643210C077E0B7F23D44613122C';
wwv_flow_api.g_varchar2_table(1563) := '8E269488D9BC10249A530E2B8390A0019D84346141501DE26C5050980FA485AE2169CC49864141F62054501DC81E5DC075B11381F1F171D811BDD3106DF0526C401E6D180011C278783B9C934ED14F434EE181B020120248621816D290E638857E1080AD';
wwv_flow_api.g_varchar2_table(1564) := '510E81471E9B098C6327F640B1E81AFBD12CB81953B22157D88C12408077F12A178686A97407F10358081847348321798819BD93C77D0AD18F24CC4DF03ACA45060D0261E4459E237954514E5E103F3420CF5108E3297414728B25A007CEF488240D810B';
wwv_flow_api.g_varchar2_table(1565) := '319A032F4D38A56B1829C6E01A09D7C09F420400161C782F005FC53B0AF11D19D10B6DD9D91860C5E586187381001031F0C7062E169022CF7511170EB4C59B05F153210FC8984A43F4602A7D89DF1E85FC60089ED39C770762D23B970633B010D22B7E39';
wwv_flow_api.g_varchar2_table(1566) := '58826B2A4AB4E2A2738A0C9786C4B5C3665CC617AE0EDD09C4840BF2F8920858B4CA81FD7B2DFEEA97D4B3AB9A73FFB25BCDEAB85CCFF9377DA4B6019F470B1DFD4E106983C00B9D9A8DFA9DCD7E4183D9F216B6F6FD9ED82F06F021AB64BF2FF4B3DC42';
wwv_flow_api.g_varchar2_table(1567) := '984F0F785E6CC17E69CBB39010AAFA57B685B61D53B51308300399E9F968647AD2E5315407BC5A67793E952C2A0A3BECCED9081B0ADC2FDB5B3A3713D9BFA77ADE18082A0BA5A132A7BF86C54ADC4E474549C81E6E4825131EB7C362F73A5C96C212876C';
wwv_flow_api.g_varchar2_table(1568) := 'DCBC6E47F21D73B1A523120189C0AB45002E8142580A74147242B493042D81048A040F81A741333822096F510D80534187E051F0228E702AB4D11C1932D00F68128C0B7222D808C7C233CC6040333C165A02CF21097EC2CC55980CCC190A4A09CD056344';
wwv_flow_api.g_varchar2_table(1569) := '801E2921D68A36E816936F21459884009D2200C941860C6690C730C185A04C58C829DAD02C0292E4096392C860124622205AC11BE99D42E81CDD610FA40E0E8C0CB48A72F8987001799AE329914F8E1806F1A3962362703F8112629C126E853943A78102';
wwv_flow_api.g_varchar2_table(1570) := '1E8EFB503E82B7A88273E205A0E13E32B044841103766AE16F2410A3960CB598815390BDF5FA298746E23EDA680E81842E22207A27037AF88880B8169884311CB9A6BC0BC011128090C71184E90561A0668A2FDEA10D496C060A80856393308356B84C43';
wwv_flow_api.g_varchar2_table(1571) := '5AD11706D38423D0A9971E496420D858059E82FFE311FA69853DB88F063AA21784B15F5C0E2E014652CB8B0694A399238E639BF0083B495C2062FE8F3C786C0C0623CCCF0333A8021C2C1770C9A34440222011900848047606023B610A348BAEAF4C2D7B';
wwv_flow_api.g_varchar2_table(1572) := 'F4B93DCDCD697B28BB7C241B9B672BF4B0535F53B3379F4BD77ACDBAC3AFFB7CEE23759680D660779B6B0F1D8B2F0C3303ACD26D881D3E1E9BEBE7E587D3A439D250A3E4AD0D418D2F57B7332EB0F442222011F8F61080404212A02BD0A1AD7B816CC079';
wwv_flow_api.g_varchar2_table(1573) := 'E030AA1884048E01F740091A28271208A5A1101202C381E710248452520BB784D2C0FA2087884162E13C8470514B1E556454CD10397814FC07C2033B421BA742038C081B6062101B2C87E740AE90A43BB4C18E98D90B5784096389B056704BAC422D6E8A';
wwv_flow_api.g_varchar2_table(1574) := '7EF105BE07CFA415BDD39CB63882005594C39C0543C32A8819365005BF451E1BE811794A4482BBF2AD2F4702A710390A852F1800083427B6C92B063AA2530830A7BC0220A44C21F6E00573B38105B8A8C2655E4640D7E98B0C339FF11DE5D4821E60F241';
wwv_flow_api.g_varchar2_table(1575) := '2CC41BA28855184915AAC0046DB840A7B80F9EA8A2962350C042510568CC1EE7A8BA86A9E8A41528D10453D12F182FD60A3D825EF20601F68B3B9CD2053A99EACCBB12A0A32D96D0115E73A5D006D4E28D0341690A0505A553CA398506C3F9798BC1A527';
wwv_flow_api.g_varchar2_table(1576) := '8FFBF4452B9AF0652FBEE02057415C147E36584547D05AE82ED60A234109B5D8833134A716F729C4481CE11A5148128C5A5C0E79940848042402120189C0CE406027AC021D2AB29795979796951A6C6E664D94150718F1383C41834ECBC6DF364FC8ACD3';
wwv_flow_api.g_varchar2_table(1577) := '06836CFF6DF47B2C16B79FA505437E776969592054ACD71B59CBB1ACB4BC2854C2B020E875F39189D766B0D877ECDA063BE3872BBD90086C0301480EC4638B86F019E67F42AE540EA60A0B5A021F104445942306E181953D4FA221A44B5548067B602050';
wwv_flow_api.g_varchar2_table(1578) := '35C1F46059F0100812DA202A14220F3BA22104891B148484EE28A78472580A7C8945B9B08D72D80B8C0BB51030683302825DC39AA04368A02FB80D326840985EA0B5D02A3208208C0C7C1231B489E024622474D20485D84306498C812921A376872528C1';
wwv_flow_api.g_varchar2_table(1579) := '12E411C0293493A789A0DF305EA8235C14F3F08E42C4E80B9E46C20BC0A4840C85A825612A3A518200A6D2A3E0D5A210FD980114D46239627827C83C66800002644489E0A25885CD022EF4D3044F05BFA59044219700DB308626D48A842456A113AC4439';
wwv_flow_api.g_varchar2_table(1580) := '7AE81D311E3720831866D02347012C6AD1C311CB41151C309E26A25FC4D40B84CB480A371140150E222FF0449E42F4D02FD0D11026CF07CC344721C2788D30CD11100EF203165E538E5358CE5138824E54A190EB08550637D117A7D88918FAB90A68A68A';
wwv_flow_api.g_varchar2_table(1581) := '5F3B2E633C7E61C60B257E9CBC49819F03D1FA86588BA9748A00C7F555322F11900848042402120181004F22C6633CA778906DC0844712A308DEF9F2D8E201C7A93892E101278EB4128967909A841E4EC9EC8455A037E0224F2502120189C0A608302217';
wwv_flow_api.g_varchar2_table(1582) := '2467D35A0AB95D123525684666BD0CA3768801E138E2A5D095F555BB210F57E181C143E5399D8538096EBC5E9E69C0E0CFB24CEB0B37E4D530F286F2EFEC1403788E6EB8FAAFA4F757A5996BC187BEAC65BD8555C8E002E3802D64A8829D22F38D625B2B';
wwv_flow_api.g_varchar2_table(1583) := 'D9B496BF17462D44E099B92D861AAA182F71782303A94680A35AFEA219663CE4F385E9FA5B372C4C8CC8E7F8861BB147599A30F4F91D4EBEB5066AB359A6E2176E0EDF28F942029D638B25864557A87A432BE6733CB2F1C58CDCA0449E4A04240212811F';
wwv_flow_api.g_varchar2_table(1584) := '35024408188FF1DDD3868714CF1706182FBF0AF42BBEA1FFA8B196C64B042402120189C0D3088877AB4F973FABE469F68B24B487F8E4B39A887222931BF8D2D6F2AFBC16035E39CF515D7B259A190AF0E0DFDA71AED78611C3A6F2BC0C7A1EB14DDB7EEF';
wwv_flow_api.g_varchar2_table(1585) := '85830B895FFDE6E3D9DE6B4F5B12CFE43FFEFC4E62AE9FAAEEA9E57FFCF5474BC3B7C94F2EADFDFAE38B83972EF07DF7D3AD362D4965956BEDBD1FFFF69FEEDEB8A0E4E29BCAA885EC1C3374AD17BEAC966CC82C2572E36D05AB44BA3DB4B830FAE0EBB3';
wwv_flow_api.g_varchar2_table(1586) := 'C7FF67578BAFAEF65DFDF41FB3AB0B1BAA9E75DA39B93CD759C061229EEF6BBFA428996749CA7289804440222011100848022C7F0912018980444022F0AD23002B96535E5F1E655834939F5F5ECF8F51C3C472F68BAFCE3FBC08175DD1289AE165CD64DF';
wwv_flow_api.g_varchar2_table(1587) := 'CDA71D19598C3FB8DF31D177952A42A91DD3E985815B05314D7E2199ED39771F8A0803BEFE70F48B2FCEAE4C76CF2572D1A94E02C4D1B4323BF650C93F61B0D747E2DD6DE7587218D89399FCC3DEA94BD7AE76B45DCCE75607226B672F5E1BEDBEA5E433';
wwv_flow_api.g_varchar2_table(1588) := 'AB79E5FCAD9E8F7EF349CFE75FC0AEEFF54F5E3D7F767561249ECA770C4E9EFBEAABE9DE5BF389CCAFBEBCF6CB7FFFFF5C39FFD95A6460606E75BAE7B6FE11155FCD2937DA1F7CF9E5978B13F06725ABD53EB8F3706D6986FCF8C2EAD9B3D7EFB75D50D2';
wwv_flow_api.g_varchar2_table(1589) := '314E374D33B1EC950B6DEC6975B76761A6FFDE682471EEC2D5EE5B17946C7C6C39FDA0B3F3DCD9CBF3C3F747E6965767BAF16DB0732C1D7B5E76BD698FB2502220119008FCD81178DE296D3F763FA5FD1201898044E0E511600227DFA5BCBC1EA94122B0';
wwv_flow_api.g_varchar2_table(1590) := '8311608ADA2BF72E9657EE5CBA954AC0EF4C0EEBE5EA231FEC3FF14EB677948E60B313538BF1E5D9B2A0D3E6090F754EBFF35659CFFDF1BAA30B7BC2BEBAD6B7324B7F8F5889CB74ECC4B1C13B93B4783811EF7978CBA4CD5DBCB5146AB658866FA7E61D';
wwv_flow_api.g_varchar2_table(1591) := '0A9F3F0FDEB214558D4FCE3935C97065E5BDF6D19325BAC33FFBB9A2E8A7E2D94FCFFEB6BE321D8968BDC51567EF0C2DF4DE6CCF67FF1BB7FEE67CF1F4D03D369076A7123DF3CBE73FF924119FCE45EEFA8EFED99717BE0A38F3898E95C37F5ABA108946';
wwv_flow_api.g_varchar2_table(1592) := '17F92F924BAFAE66B36BE9543E5D58943B93571EF64D4EF4DDCE7677BFFB5F078F1FAF8D3CACCBAE65F1EBFCFDA1C49D2FDCAF1FDE226A5D1376FE7DC2119D1B9D1A583850593697D05CBFDD61C92C14FBF2B7560EAC5DFE245FB4E7C1E0BC31689BED6D';
wwv_flow_api.g_varchar2_table(1593) := 'AFFB5975677B7B49B049B117165493492220119008EC4E042401DE9DD75D7A2D1190086C070146F6106068F0761ACB36120189C07611985F5362835FFEE44FFFD99D695BCF27FF587E24A7D36A59EA127DFC350E4D4466863A5DBAB28C237CE7ABEB2DAD';
wwv_flow_api.g_varchar2_table(1594) := 'D90B9DB36F8FB559AA7E42F0D6F8480C49BE8C6676387B2177F5CF357893B5AD3FFDF7BFBE168A0E76756A564BDBEDE974B1DFB294CC77740F94EA9783E5C1D5E945FF9122D82F6D53997C6665F18DD74F44663D3371DDD8BDB6A66AD7F0BC2609E9FDA2';
wwv_flow_api.g_varchar2_table(1595) := 'FBF73E080E297B57FEE36FDB8666B4B30F830DADABA9E1B978529B5E78FBCD3FFCE87F3EEFD52DBFD6D232F770FCC49BEF19ADB6DABC31B0FF4C3AF51B344F2C25B3CB8B81D2B29E730FDFF9974BAC34C7D4741675A1CA6CD0B82ABCE96C269B5AD5199C';
wwv_flow_api.g_varchar2_table(1596) := '996C5E4B8458F73B23B7904DEF2DADE9EAE837AC25FD35CD771E4C147B95F671CFF2F0C388B9A9C995AA7AEFE4CC42C46275DE8C1A6C63A341BFCEE890EC17746592084804762F02720AF4EEBDF6D273898044601B086C886EF1CDEA86C480FB5909C96D';
wwv_flow_api.g_varchar2_table(1597) := 'F4289B48042402468D92D639C626672263E356B7797A2935DCD7DD3F32159919D128B9B290BBA1A1DEEE0D758CAE98F4936B699BABCC35F4606432121D1FE8E9199E8A2E8C2FC6527D3D032373E3F3A37D16AB8E80EDD0D8B87E6529E4B6DF1BD51717C5';
wwv_flow_api.g_varchar2_table(1598) := 'BAEFCF5B8D8AD362DC5B5B51525DAFD59A8BAA0377EE8E7574DC1D1BEAD567937E87D7ED0D563794BA037E97DDE0B0DADE6828B3056AD6B4CAECDC5CFFD86436137198CC56B3AFC869AF6B3A993738BD7E4FC0E7D7699D3A25EFF53816F29AA9F1A15C72';
wwv_flow_api.g_varchar2_table(1599) := '7921B6B6343BD9373A1B9D1B1B5E482C4C773B3DEE4C3697CEE7FA0726C726C68706FBF2C9E5D2A0376A2AB97EA32D19296C247EB96BEED667FFA0287C29FC2419B44AF5BEE6F377062A342B794F655F778F5B9BD02AF6CC5A1AE25F5CEE0FB8DDCD35D5';
wwv_flow_api.g_varchar2_table(1600) := 'C5C1227B456DCFDD9BFB9AAB3446B9FEF61300654E222011D88508FCCE7BC45DE8BF745922201190086C0F01D82CD160B663A539AC98B0B07A24239228FCFA2CCFC2FD7C07BB3E800C55160B11A10AB16D5B8292179D9B8DFD6261E76FEC1A49EC64BF01';
wwv_flow_api.g_varchar2_table(1601) := 'CCA389705CB596D3F5BD3FAD5694204F476A2D2B150B67D7D752C2024E1CBFD124D1561E770F025E83126E7CB7AFFF2EE4AEFE9D83532B99EC5CDF52D6B53C37E10D965695FA14FE11E39D9EFFD9BB47AB9A8FD6CFC5B2233DB34B716B6C7866CD195B9C';
wwv_flow_api.g_varchar2_table(1602) := '5A73B816C746F31596C8D47063DDE99B03C1E5DEDE960AAB3F585B7168B5A1C43C569FF03AB32EB3A1794F8D00F6ADD6B25BF186DEDEBEB280BBBE28505D5FC1A6545405EDBAA6D6E36B0B9366767BD699F69C69E8EFE8B3BB674B0ED4052BC3D7EA5FCB';
wwv_flow_api.g_varchar2_table(1603) := 'E7623AA339EC34EA4BAB30AAFA7089D6E40C9A0DE60355437DDD9545D699B8C9121D9A5D73AE2C4ED678F7CFD73678ECFAC0A99635C53136326E729AC76617AA53D1784A63CC2B1595F53A9B772D9BBFD337EDB8F1E5D19F7EC81F8A7AE979A95657EBE9';
wwv_flow_api.g_varchar2_table(1604) := 'BD5BDAD8E0D2694C8DCDD5CA64FCC81EBFA32C5865325BD2B54232BB9649EB1D9AD4ACCD5FA2B695198980444022B03B11900478775E77E9B5444022F00A1060BF1FF64C627F5AD81D440E66CB91BC483046F5942A3601E2947D6B55020CAB8CC5622323';
wwv_flow_api.g_varchar2_table(1605) := '232C3ECCEE4A704B1ABEA859E864B70094B321ADAAF91B95D00AF3FAFBFBA19A6C2A0BED7C56D748B25F0E3C9F8D613198DD8CD8CE176B59D48A26A21610D8E0974E55B5F8C256B4C8534847EC88237C149D22565D5D2DE43100333000794A90442DEB45';
wwv_flow_api.g_varchar2_table(1606) := '43AA9F65126232ED3604CC1AE5E8F1FA99318357AF29622BB268FAADD7F6E794835E378CF4C9C48AE6728749D3C26ED4B5259694C7B69ACBFFE4E4E19C72C4E9B3668DA61347F76A8ED77BCD3A8FD7AC7FE3F5B5C46C65894F67F6FCECFD033E8BF6C39F';
wwv_flow_api.g_varchar2_table(1607) := '695CA6DFF9BAA1CA67B2BEFBE6F2F488C36A7458AC2DAF35312B19E46D06CD6B075BE6A7030ED67CD699DED8EB9EB0BE15F0588C1A87C5693D7AE6687C61CAE9B307DC86E27D07786B74F0BD069DD9E0D3E9CF7CD09A5E9CD2D97D2526F34F4E1EC23097';
wwv_flow_api.g_varchar2_table(1608) := 'D752ECB518DF7853978F7B9ABC069DA3B136D750F1138336AB37BB6B824A9971AF9B6DB97D25438B195B6CACF5CD7714A5B061F5FA14B2687EEFFDB78ADC85A9DEAF1FDC1B29B2BB3C36B7D3723867B1E45B84E4CDA18595A97B675A8E283AC7FAB6322F';
wwv_flow_api.g_varchar2_table(1609) := '11900848047621029200EFC28B2E5D960848045E0D029037385E3018249E09F984B3712441F038724AEDA382C71B96C254A9127D5305ABBC72E50A9C104922C3E8118C11B5C890279117715AC450A5960BAA297A84A0CECDCD4120458FF046A10161D506';
wwv_flow_api.g_varchar2_table(1610) := '0AC973448F50C89EC6C3C3C36C250FF9648B639AA0931E1110168ABED8CA1523B1FCE73FFF393BF25DBF7E1D33C6C7C7DF79E71DE4A9BD73E74E4747C79FFFF99F0BF9070F1E08124B2F707264EEDFBF2F4A2C160B9D76767662307BF0C0A251353030D0';
wwv_flow_api.g_varchar2_table(1611) := 'DDDD9D4824E89ACD72DBDBDB85D70D0D0D9200AB17426640C065D4B86A0AEF4D487EA7C9EF7C1CDB1425E2E870C0870B415AA39E79BE36A85EC0FD44CC5557A90A9797B815857F8514F2B838FA0ADC76630A3A4D4167BD2875389F304F9F5DEFAB25BA5B';
wwv_flow_api.g_varchar2_table(1612) := '485662B0358FF39C96163915FE3D4A267D816D3A7C36715AEA732AFC2386CC3F579D28E4585142C1E354591EC06A7152E9C7D5C77CD5A8CB1D6D081D3C4074FA8919428CCF9A43C1C76B83BB2D7A77DD63631EB57C6C89C3AC6FA9F697D7C3871FDF82BE';
wwv_flow_api.g_varchar2_table(1613) := 'EE50FE5F2220119008EC3A042401DE75975C3A2C119008BC4204606B685B5A5A82BCD9ED2CA393262C4C0934D266B3B1630D2C4E4D1BB825BC311E8F1F3F7E9C26D04568216C1019A2A3A84527F16168EDE8E828FC10BA68B55AA9A59C04754439441461';
wwv_flow_api.g_varchar2_table(1614) := '182CFC1903229108E1597826AD1080F1428C89D942AD3166707090F8737171715757175504AE21999070E2B76CD2EB72B930835384553BB11C5F706A7A7A9A4C4F4F0F815F22C6172F5EC472742240473058882E796C80DFEEDDBB170B1F3E7C88193845';
wwv_flow_api.g_varchar2_table(1615) := 'C9FEFDFB21CF972F5F86481F3E7C78727212A28BE5D4DEBC79F3B5D75EC371ACC280929212D4DEBB770FDBE85126898044402050E23494B43E0EE76E0393D62A9F5275721B0D65138980444022B0F310900478E75D53E991444022F0DD21202822F14CC8';
wwv_flow_api.g_varchar2_table(1616) := '2AAC8F382A74110AC729748E4409C418EE0A5154CD822E22363B3BDBDADA4A9814C249EDEDDBB761892884C7D6D6D67EFEF9E7757575346F6B6B430FCC16A288864B972ED19CBEF8A2985E28872BC284E9E5934F3E814052C2746587C34186B66886B532';
wwv_flow_api.g_varchar2_table(1617) := 'CD1802DCD2D23234344444B7B1B1912EE0ABA150086A4D5CF7CC9933305534D323515C3A8248631ED49A2353AC85FD988736882B541637E90542FBD1471F514E5B58313AF7EDDB47A4F7B3CF3E43098C1AB24D841982FD6FFFEDBFC523E831685CBB768D';
wwv_flow_api.g_varchar2_table(1618) := '8ED083557FF6677F068050624A5042BFB88342152E9991084804240212018980444022F0AA1028C42E6492084804240212816D2340B4960F5CA1855044E81F7A045784F89111446E039D13A7F03D84A17C1CE1C3CC256E6E6E3E72E40819F82DE416AE48';
wwv_flow_api.g_varchar2_table(1619) := '1C153E4C7C585050144292E1CC9440410F1E3C2802A7847921C9485202AB24F08B00D39B056D2E2D2DC530482647C4440655D44280E1CC449821A204788B8A8A281749188979C2424EA1AF68B87BF72E5DE09D404CD48A3C3290794AC860001954093711';
wwv_flow_api.g_varchar2_table(1620) := 'A0845332D4AACDA905404A8863C3E4710497A95DAF56289747898044402220119008480424022F8F808C006F134331CEE3B8CDF6BBA6991804EF1A77A5A3BB14817C2E6FB3D88D06132CAE7057C829769BC3EE2040EAA40A8EC74C6195070A8C90640E33';
wwv_flow_api.g_varchar2_table(1621) := '515FE81FAC92402B25B0532822C1526460B90472A182847661B024A2B8FC4151C81A51448F4539341861411799DE4C2BCAE1CFD0540AE914228D66D184CF71DF7BEF3D582EB3AF0F1D3A04EB46215D90FFE52F7F4958985EA0CD2AF9E4162792A0C43484';
wwv_flow_api.g_varchar2_table(1622) := '301343A61782BD706682C3F44E2FE821808C23F44E860870555515739E99058D2473A43189C9DE8476E99A5A54D19C170718C68467CA41835834F3B1F9321926ACDA20E0924789804440222011900848042402AF04014980B70923E33CC68EDB6CFCA36A';
wwv_flow_api.g_varchar2_table(1623) := 'C6C0174F1F0DEB5F8CED337EA52D61312634FEA83C96C64A045E1881354D6232396CD45942DE8AE5E4FCECCAB8D9E0F01ADD33D1D14862D66E70F96DA58F82C14FFE88F8EB205A7BE3C60DA6FEF2F775F4E85162BFE2EB5C58256C906F71219F7C3D0B6B';
wwv_flow_api.g_varchar2_table(1624) := '8561326D98B82E7F4D046CA1AC1048F19705CFE4AF8C425185240B3253C257BB4C4EEEEBEB836313498666D30A86CC9F33415A64E8141BC4EC6B9AF379F09E3D7BE0B1485205041CC99381A6C278694EA098A0319660390D21AB426D53531319282E4782';
wwv_flow_api.g_varchar2_table(1625) := 'D81060F4BCF5D65BCCE2A62125106018FEB163C7F89E99F9D5307CFC85E8E223AC187994632DCAA1EB7C900C21C7B617BE0CB281444022201190084804240212816F424012E06F42E819F5C43418623EA372471533CC252AC590978CEA5861CA66619623';
wwv_flow_api.g_varchar2_table(1626) := 'FF7B3CA07F348B7343498100039424C02A6E32B31311D0A432AB57473E6105E5D5B558B228DE3B7747AF651DDA7C4EC9B44F5DB0193DC4808F86DF2314BC3EAAC95F0724F6E4C993AC08C5CD044EC8F7B462592902A1505FFEE890210FABE4EF88C82AAC';
wwv_flow_api.g_varchar2_table(1627) := '983C55C8331B196DF0C613274E5075E0C001E4394280099FC23FE196704E6A8915F3B530AAE0D262B322BEC84515F2906714D204AEFB877FF887FCA9F2674E1098B06DE16F9BB0F523868C7EC8397DC18469C20C6AC2B69061CAA1D318C302D16444D816';
wwv_flow_api.g_varchar2_table(1628) := 'B5F48E2ADCC13B8E744AD41A63F0112A4E730AF19D4E514848990CF2F05E8C4133198CA7EB9DF86B913EBD140291D85A74618A459083E1229DF1F1D2CA2FA591F5EA14657676D96BCD99EC8F17527E49852FDF3C9E56D20BD3EE106B41CBEFD45E1E4EA9';
wwv_flow_api.g_varchar2_table(1629) := '4122201190086C444012E08D883CCF39E34286890CDA9E47F8C72E83B30C6719B3AAE351AD46D16875E96CCEA083083FDE50011E4C2C892132ABF9A8AC18DF1916FFD81190F64B04B640803F8085C474EFDCDDDFDFFB2FA7A2A3D1E4D240E4A1CF12D269';
wwv_flow_api.g_varchar2_table(1630) := '0C8BA6B9C1A5CE12470D7F44C9CC2A6C5253F8937992F89B8213420E118085F2E703ADA59A3C475822E564E09C705DEE39E2941232506591A1397AC4F6C268234F43AA047F86FAC230698B06C2BC64A8124DC8C360851251885A1279214646240C8330A3';
wwv_flow_api.g_varchar2_table(1631) := '19AECB0257C860219455748166282E4DE8FD91823C049B0C2582C79287F7D29C12282E1A44FE6979BC80FD8ADAAF3B97FF97083C4660702E71FFE625B729A3CBD81CB6ACA3A8FA25A1E91A9C0FE9A6CD154D67BFBAF76EB312DE77EAF9152EA695D4485F';
wwv_flow_api.g_varchar2_table(1632) := '516DDDBD9EDE83C5769DA3F8F9DB0A49FED2AEDC196A0EA45DA5F5E3CB99FBD7CFB754BB837547A81D5DC9CF9EFDF4F47FF60BB61C7E51B5525E22201190084804BE11014980BF11222950186D8B0416447AA3C9DCE8F8D8F0C45843C891D359A96604BC';
wwv_flow_api.g_varchar2_table(1633) := '94CCC596A61A4A8381920A456FA650022711D80D0810D75D4DC5F38A26602B4B67D6A2C9C52A771331E1B9C4E44A72A9C6D59CC9A56793E3CBAB0BB9BC5EFBD49F05648FA40225A8AF38E58F4E64D617AA926AAD68BEFE28AAC4B1A0FD6BFD2AAD554B54';
wwv_flow_api.g_varchar2_table(1634) := '25A8550BD52ED667442DF2EA2B2DF224212334AB1A5483D51ED556C8ABF9A7E529510BD7F72EF31281784EF9E4FCADD2D8BDCA377E96CDD874464B34999D9D9C306B32A565A178DE1A999DCC66322625132C295E5C55124BB3BC7DF55975AE50F16A4633';
wwv_flow_api.g_varchar2_table(1635) := '3931695156C3C5E19CC13A3E31A324637A97F3FFFBE4AB564BEFE15F14F381BE4ED1A7F3CAC4C44C36B552EA77EA9C8199A9D94C3AA549678A8B7D718D353933132C2F5234854D864913ABB9A5DB37235AEF4CDFF57CE8CD7846E91F18F21B53C5953519';
wwv_flow_api.g_varchar2_table(1636) := '8DA17F60D2928C5434D4243596E585B9D9B9E572A7DE555AF9A8E9E3C35C3A7FF3DA7DFBBEA583C51599BCB67766D59BEC0CD61D4E64340303C3A65894E76D3495CF24E6BD9EA2F85A4E135B367ABDDDFD13D6FC72756D8D6AC97A9D322F119008480424';
wwv_flow_api.g_varchar2_table(1637) := '02CF838024C09BA094C9E6749A3C41CE4DEA767D5136AF6DEB1F4D8C76DF1E1875A58AD2461F333D59B0752C9A5998EA4A472B1BD6562BEA0F649E1AE8EF7AE424003B13816C3EEB34F91D46D7D591DFF2B96FA57BAF49676620BE964964B26B46AD2597';
wwv_flow_api.g_varchar2_table(1638) := 'CF25D3AB996CBAF087A297131A77E6CF407AF56D231059553ADA6FFDF1EF97F86B1BE90BC2F9F957EDCEF4E07CCC7460B23B5773EAEAAF7FD95057DD3114F9C59B556D9160E6E1C74AF1E1FC44C7077FF207971FC4A2E3F797A289B7F6BB679D87A7EE7C';
wwv_flow_api.g_varchar2_table(1639) := '1A2EA935E5C203435DA58ED1547C259D5A533486B68199F9BB9F6B9CA5430F26F61D3FFDDB8F6FD485B57DF3BAD3B59995F0E9F1DF9CFD83FFF603451F129EA6F39ABEA19990F9EEE186EABCBDE472C7F0C8FD4B9A4CFAC3B713F3A9D25B97AF2AC9E8DB';
wwv_flow_api.g_varchar2_table(1640) := 'AB03C9BD1F5EFBED3987DB31935E7AF30353CAE05F8D45AD669DD5EEEA195839B0C73436A1698ACF95394B9A8EBDB5F6F0FFE44D542AA3599C9F08ACC2B47391747EE07ADBDBEFBE7167385D136BEF5CD83F7AE362361137C52225875E5714394AF9B67F';
wwv_flow_api.g_varchar2_table(1641) := '77527C2A43BD0000400049444154BF444022B0331190A3B14DAE6BEFF0D2F2ECD02615B288E84D5E73F9C1A02935571628CAE988F41640C92B798749172CF20F2DE77AFB1E689535756AB4C44C22B0B311C8657336BDBB35FC2ED1CE224B49B1ADC6670A';
wwv_flow_api.g_varchar2_table(1642) := 'DB0DEE43FE3335EE036E53C0A1F71DF1BFE33586D3D9C20E49CF4A4CA3D85045892814C70DB5CF7FFA48CD46E5CFDF5C957C969E2DCAD5B62F94110AD5236DD7E785AA6F2C5105C86CA161536D6A5BB5A1107B99E3B7A753355274218C54BB23A39AFD74';
wwv_flow_api.g_varchar2_table(1643) := 'E1FA5A55EC879949F3497D26C147E3C2BCF158BAEDD3F3B5A596B8A3F2CBAF2ECECDCF0EF6B457841CED739AE1CE6BFDE30BD9E94E6749795BFB9DE1B1C1739F9E5F9EE99F5E5A191D1EF8CDB93BDEFC7465756DC0EFB7D89DC57EABC1E9E9E8185D9A9F';
wwv_flow_api.g_varchar2_table(1644) := 'FCF4F2035F6EA2A4B6F6C28DFEC9FE5B5D5DBDC5F6F494C6D779ED13973917AC28C97F1DFEC5068D56D3391ACB4E75042B9BE379DDE75FDC589919E81B9D9D9E1EB9D4D63E3B787B38B23835D0B9B09A4E8D0DEF6FAC1B8C29B1A9BEEEF1C5CF3FFFAAEF';
wwv_flow_api.g_varchar2_table(1645) := 'C1CDAC92BD77BE5D975BB83994591CBDABD36ACC568B56C777551A8B5E5BD7503D3FC0D70A1987513331AF595E181CED1ED23AB5677F753732DE393139BF30CA1045BE66FE61FE54A555120189C08F0081DD4880D7B2F9F9C8622CB2C0976EC94C6E3595';
wwv_flow_api.g_varchar2_table(1646) := '8ACC2F32CD88CB154BA6230B73FDC393B185C91FC1D5FB3E4C6425DB6872CD6250AA43BE3B93C94C6C828FFAFA175299E868B82898528C89B5A4580BEBFBB04EF62911F8AE11E0EDCFDA5ADA990B95EBF6575B0E2696538EB5E2325D933F5FA3240CF5EE';
wwv_flow_api.g_varchar2_table(1647) := 'C3FBFD6FD4BB5B748AF1D1E7F19B9BC7BC5F76D6DD50C754614835E56C1184C0F6B80AAD58AD6A6A6A6A83F2173D450F8BE1B15E973AED5968E0CF9FB5A9D97F7883799CB2F8166B7721F0427D21CFE2D22C07CDF64E6CFBB4B2B2C217C8A8621D695690';
wwv_flow_api.g_varchar2_table(1648) := 'A6773483065B3151C24AD7A25F8EE4D940180BC99390191919A1842D97D049392B6C83836A0F5DB044360823C9864CAA3604E8941EC554ED68344A1E852FE4C506617402051672357181FC7A4B36083FE7292601D1C0C000F2E08FFD7881CD94D305BF19';
wwv_flow_api.g_varchar2_table(1649) := 'FA625D6E30C4470AB1016011C36BAA282121C67C7532CFD9E9F728E63629C5957BAEDEEF5F9819991E9F8FC716F3D9B4D9A8D7194DDA2C54506BD2EB4A8AC32647516C699E79495E873E5C569ECAE712F1E564345164D1BE76B0C95773706565D5A0554C';
wwv_flow_api.g_varchar2_table(1650) := '6693C76EB138430522ABD3D39E7F9974C6A0D31A4DA6ACA2D1B116BA261F0E785C81E2E8F2BC369735984DA0A822C0CFA6C46B4C392A3A6E5FCEAD258CF9645589EFE4FEBDC1E2866C3E5D12B41D6AAA296B3AA9C92B7EBBD964B7A7F48535D56D6683CF';
wwv_flow_api.g_varchar2_table(1651) := 'E7B5D95DE3CBD9C5B9AEA5A564DE671AE9EC8925D7E66666E6234BD1A579AD92B3988CB1ACB23C3FED33642B0E1F3E7FA937AC0C3A2A0EEA92A98A80BB657F7DA8B149867FD56B2133120189C08E4760C3D8E3E5FD7D72377F795D3F160D2B6BF9877D83';
wwv_flow_api.g_varchar2_table(1652) := '37AEB727E7FBDB0697DBAF5DB9FDA073F8EECD4822D176E35E6F6FC7C244BF56914B376D7E3D19EEDB2DC6BD7BAA9A1B1BA7B5DEDA8091BD4333AE52AF5DC3DA3615B50DF9C2CA9C4FBE69DC5C8B2C9508EC0804600E8C83B3D90C946631B2041584E4CC';
wwv_flow_api.g_varchar2_table(1653) := 'CFCFC556E2F373F3F30BF370A7C58545884A2693467283D33417F774F6FE81AD895A51C25899FD7855EA2528CAFA0780DA5654A9A74286539250089D833A8A536AD572B50431F24F371485420C7BF04EEC7B84A42A4CDB09BE9B9C9941803CE5C893205D';
wwv_flow_api.g_varchar2_table(1654) := '70335C7E24FBB853CAD5866A5E18C9A9C8C0C780028646776C8F044DA5494F4F0F47B81C8C0E496460E3A29C3C5DE323F48F3CEC0EB491A139A4173D94C081D97249C8F33A805ACCA396FDA510A09C42A823928240E291B8225C560C80252283793424AD';
wwv_flow_api.g_varchar2_table(1655) := 'CF0B9B5517A8258FC023C1C779D11088D0066FE728AC15C242F2699D946FD023E4D7F785CB4084D7C26570E302F1BE009B05D9E6BA43FB714AD8809B64F08E5A40C3475CA3848E4842B3C888DED54251F5FD1EDD06E5E7EF9E9A3354777577F1BAA2D810';
wwv_flow_api.g_varchar2_table(1656) := '3FFCFE9B5DC351E342DF99D3273C3E7F6D5D83A233EF2DF7798BF7C0123DE57B6D5AA5BEA1B1D4EF7FE39D37CCAE327868C81F7AFFCCE1C9B4B7AFAB5B9B88B41C3E1033D6AC2DCDEFDB57EAF606DF3BD13493F30F77779F3C5C19AE6DA9ABABD0D9BC15';
wwv_flow_api.g_varchar2_table(1657) := '3E4B69FDE1483C3BD13398CF15F6DC16C9A1D39C3EDEB8F7C4E9FEE9982939FBD699A30607E1647391D37DACE5A0BBB8CE66B5B87D2CE3AC1B988ADEBD73B321A0D843350DA5EEF7DF3F53DBD4BA124BB71E0C1F7EFDCC1FBD7F3263D933BD1C9B1FB837';
wwv_flow_api.g_varchar2_table(1658) := '1DD58C0F4286935DB7BB13BED448771713A21BEBFC534BB6DA0A97C5E079E367072CF62A97CBE2F07AF93D7E6D8BFCBF4440222011D89908F018E219C7D6B3249ED74F8FA3B6EDF66EFC06782D931D1F898C8C0DD4BB463AD6DE6E9A1FB4EF3D7EBBFD41';
wwv_flow_api.g_varchar2_table(1659) := '85735C13E9F5EC6B56746925CFEC239936418015A0E3C9744FFF94C6A55D9D9BE8372DD9B2BD0B139189EC9CB1B7777C32596E6088201FCC9B40278B762402DC8E610BAC870CA7E2EECC3AC99C325193BB361C03B60321118E0B491504C4A02BF034963E';
wwv_flow_api.g_varchar2_table(1660) := 'E6085D644D669A5388242B36C3FA587D9D1D7105B784DEA08D059C59D519253441925ED827897E39A52DF2442C59B69D7D8C44E0973CEBD58BC706CC07A6C47644420302706C54218C2AE810F9EAEA6AE813097758E719798EECE52B1823925050A29738';
wwv_flow_api.g_varchar2_table(1661) := '48211C12224AD7EC9C44211A7844B15E34A714A28DB68297B2E033CB56630085385E5555859DF0524E0381C0C2C202FE528B61F848A728013712FD224F2F2C670D9D130415406A6A6AA8824F72C46B7A478CDD89CF9F3F8F852009B503ABDADADAB367CF';
wwv_flow_api.g_varchar2_table(1662) := '924786377488E12988210CECA047421B8B6F03D1952B5778D0023E325878F3E64D8C44150A7B7B7B819142FC021CF2F8883DC8E302C8230920A25F54B110372E601EF8D31D3A21C0188379A044D728E1FA0A28C8830066008220AEC8A3817ED92C0A7C40';
wwv_flow_api.g_varchar2_table(1663) := '065868C5AADA182C30A409893C25887169F00EE838C55F00077CAE35AA441332A8A210B53070BA432DBD90E1B7872328C736AA58D31B612CA1474C12CDE9E8FB4DEC3ED05A1B0C38DE5F5D9C34291ABFCBFBFEE9D299316FB592AEAC2A8EE66DFE9FFCBE';
wwv_flow_api.g_varchar2_table(1664) := 'CE5AF4E1318757170C6B3DD6F4CF0C56E5A71FFE2781A0F7DDA0636AD8A353924EA7F7ED7060C467D4ADC5D97BEBADD6C062D86837597EF6C1118F5BF7BACD376A7927978C951FAED17B4ADEFFE04D5391E375A7491FFE538DD317FEE0B446EB56412836';
wwv_flow_api.g_varchar2_table(1665) := '2BE9965657D0A7D7BD69326A5B1ACB06F4796B26AED51B1B1B7C86DC816C2AA6315A0DF97C69D857160E375406B4F6B0DABCD469286F3DE60C05583C3A6277664DFA96BA50AEE63D87DB626035F892A2BA3F3AE5B2F05249E731EA4E9F69091615A2CF27';
wwv_flow_api.g_varchar2_table(1666) := '9B4B7B959451BBA8D13D9E0AAE2A94198980444022B0F310E001B4BACA5865229E48783D6E1E4F3C705F899BBB8E00138219E81EAF7464E7CAEAA20B6D1AA7A6AE3664DFBBEF6ED7A467215261D796D734DCE862DA5461F426D32608C08029D5E9F85132';
wwv_flow_api.g_varchar2_table(1667) := '4B4CFF28C3FFB48A2EAF3094D2E5984A86C4E370C2260A649144602721005580F5F1D387FC083A24381BDC033745093C8742FE646074EBE9049C16E20453424024089E2884623D22803A682A7C863C7445EC948B243D429F2078C8C3CDE81A9EC936BF10';
wwv_flow_api.g_varchar2_table(1668) := '45C80C85101BE819AC8F84193427984CC093530C460FFAA1675035ECC40602A4F01F98187A288459C1A0E817FE43DC952A7A442D8CA8BDBD9D26284418FE4C15E59844433453853DC5C5C590318EC042BF4CD0C542E81F2156F60A462D0F307AC435FA02';
wwv_flow_api.g_varchar2_table(1669) := '19CCA64784E98E5A68307662246C0DB8500B794661C119A391128E344103F2384243681B5DA0963711027318234F4A1A424105E7449253CA311E25B0414AC8708A0BF48BC182B1A30A47A84233093B9101580AC11083319B5700788A013808561472E160';
wwv_flow_api.g_varchar2_table(1670) := 'E91D1D1DA825C148C104AFD1205E55801E40712AAE207E714D694B1417E28A0DF40244B059E4B9821843A714DEBB770F2FC8202C9EFD7841154009C68B24D78223A071A5A0B8BC370125AE0E7DA97F6EB405460C0019C4C0BCB9B9191BC8D010A70817F3';
wwv_flow_api.g_varchar2_table(1671) := '6B441E3310E00706086AF31F42A622E852F8F7281103F5EEA911798A5CE5D5E42B838C8D5C85BF3DA5B0C557456515C7426D432123D29EEA7291F12B8A7F4F2D79C7D7C4B6BEAAECB150E1C55029F99085C685CDC914C7130D9CD9F41A251824535F5638';
wwv_flow_api.g_varchar2_table(1672) := '168C39B88F0C8971D5C1A606912F4D64CA3E7C3B4074FA7793DB61541CC4870BCB58F98305CC43870EAA222D879FC823B0B7E6F1CA5B0E9876CB23635451999108480424023B17019E8C3333B3E7BEBC14F007EE2EDFFBF0C30F78CEBE9207D3AE23C03C';
wwv_flow_api.g_varchar2_table(1673) := 'CC9713595D72D1E7AC3499BC4EABDE6477E5738AC365A908783AEFCECDDEB8AC8D2F19CC3C1965DA0C81BC12745B4B4B2D7A67857930551AD259CB2BEFC7168299998A8AF2886ED5BAB2A4E49F0CB9365321CB24023B0401780EECF1DAB56BDC8EC51D59';
wwv_flow_api.g_varchar2_table(1674) := '64C41186839FE4450602437C558809FF2118F013F81519F824B4846F56E154B01A129C04C6056783D14151E033D015580AF2D03F48CE8913276029172E5C808CC19768083B2532097BC12A6295A74E9D82CF40CCE84E7030A291B0419E28E821C477E0C0';
wwv_flow_api.g_varchar2_table(1675) := '015A89CF44F996011205058265610F7A3009BE4A730C801FC2A6D08325ADADAD702DE81FEE37353511DBC42964E063704808958831B2F72F36C0DC785CD11714113B09C3425631864414978638483A77EEDC9B6FBE091AD42283B0800EB646096EC224F1';
wwv_flow_api.g_varchar2_table(1676) := '1AB609C5A54A045709C9228047800362E08C6B9408CA4A2B4E1116B564288104228F25A20B0A810204F085AB8301984A40183C0101128B30F93D7BF6800336E31A40A11F49BAABACAC240F62E0CCE7B568A37740A623BA005B32E80713F2E8410C9D5885';
wwv_flow_api.g_varchar2_table(1677) := 'CBE8041F74E214580120BF108EE8A4093663C6A54B9790E114F7B144FC78E81ACC6905B644D14958C5754186DF0CAC1B88E80B07551FE991B6A8420CFD5C114CC2547CE427C7290640AAB97C18009290704E458F74875F326D0F81A055AF3CC57EB7A74A';
wwv_flow_api.g_varchar2_table(1678) := 'B6920848042402BB0D019E62B373B3F158EAA7FFE2277FF1DFFF0FCDCD7B787AF278E551251E88DB0664D7116026111D682E19EA5D0C9A8DA1C089A33A97CD54C38647471BAAAB42AEC594591B1F3DB2BFDA117C325569DBE0EEC88666BD72A8AAAC6BF8';
wwv_flow_api.g_varchar2_table(1679) := '81DED015CE2FF54DAF19E35DC6E5C4424EE9EAEC662CD9505F9961A9CC1F56D860475E0AE9D4F78C00375F580A94039E0097D8FA5E4C2D64035E21C830A482126824B40A8227E807D13912326823719787A5208330C409EA023B253809F9818BC28D21BA';
wwv_flow_api.g_varchar2_table(1680) := '3C1BA09D08C3EB781E08A2058FC2309AC01289BE02131A20693C332042E81704157B60BCF01C849181BF6109241CFE43A7E8844741B1483848132618938759D12FBDA30D495A514B34952AE4E90826891988710A19839E11F9A4962A182C816B7A81FAA2';
wwv_flow_api.g_varchar2_table(1681) := '10E3F191BE08564365E1DBD045ECC41E012636D08A230C103B698E2A88372010FF84EF01056E92875E3E7894700403B01093A0B23441805AA2AC2434D31618F10549349300163B619B68430053E9855A1CE4EAE00846720AAA94500586C23B8449744739';
wwv_flow_api.g_varchar2_table(1682) := 'B5D84C2D24934B0CB64004F868268319008BBFE28A23468626F48506F827D78E2B48B9D0C61101E1BBE88BB6E8A4230CA69C42DCA7100D1CC104B479EB41D7CC4B87C963B048C8D3116C19A2CE5B0CC1FF1FFDD0A63009197AC766C444475C200A410F61';
wwv_flow_api.g_varchar2_table(1683) := '90112F051EEB92FF930848042402120189C07788000FB8443C1908063FF8E0EDFFEE2FF86067C86673301EE0F9C5831543C468611B16ED3A02CCABEC52AFA5F458AB00ABBEF0BFC2E0664F796128D0DA58C19CA942994CCF4040ABE45FDB533AEDD029D9';
wwv_flow_api.g_varchar2_table(1684) := '544D8D2697671C9F2370C2BC67E25C368336581C66AF60B90ED633F093C53B0A01A8053C04F2F63C5E210CDB11376B8E24A814AC068606F381A4C1826086F0438284D0548461981CF9B8144202BDE1A60F81810541C9206C040FE142F40E6F84BD90A739';
wwv_flow_api.g_varchar2_table(1685) := '4A202DE88441C1736802C3219C0B6786A9F22CC154C1AF787EC03C292424488F48D217D14B282B02748449C8A30D33B050F040D12F6C8A5A74D28A0C6F019047003E862A34D4D7D7D316016CA3105A2B983FAAF005D2CE291C1810C8D01079D8388C8B0C';
wwv_flow_api.g_varchar2_table(1686) := '8E508E9DA882AF528B5FD80956400129C53C0197308CAE810BCB3186234DD08C24508030DED110F4B019ACA805409443F9F0055598073E984173C4304F5C2654C10C9107496A3905496CC312CCE36AA20D25F8820036A0843C1A104600F7514E081D0468';
wwv_flow_api.g_varchar2_table(1687) := '884EEC4109E04056710D31BC801ED39C4B89BCD0893DE0260CA30BECA147DAD235BF0D3C4239DDF1D284F702F882EFE8A41634A8A523FC45393E92E7F78942B491472DE588D117096B91C76C4A00073328143F154A508BEF38881E992402120189804440';
wwv_flow_api.g_varchar2_table(1688) := '22F0BD20C030E151BF7983D13C31393B38F45191AFF0D45BE0C3D58A729E86DBB3EAF13863436331F8A0900CCF4B917834F20C26F1D0E5890EF3A69687E586B6E214619EC70C7A36ADFDB117E238032386983F76479EC77E2E37433A0670FC0C843C0108';
wwv_flow_api.g_varchar2_table(1689) := '620A9BB665D0CAA5E777236A195D31A66400B7A9B02C94087CC708C0AFA0015B74CA709FA8296C64C3B89F3F7941D2A8823772AA2AE146A7E6BF31B3BE21C2DC4E29819FA0843F1CF2F44B062244090901610925949328A44414F2F7C529DC86BF4DB52D';
wwv_flow_api.g_varchar2_table(1690) := 'F9F5CD29E794BE6842736A69428990570D10C6208331A2174A840C47EE005441D5C8532EFA15926A7754A199447350826B2149A20B0AE911E24A64F8F5D75F4792531A22495EF882366E353CD2E0D2C260DA0A6B85E508534E2223AA843194708A8C5028';
wwv_flow_api.g_varchar2_table(1691) := 'C0242F4AC888125A91C08A5624D1A910E3942A8ED80973E655020FD482D0A3722129B421203CE2885A04D697732ACC431B9224A11FFA4ABFFC7E0A1A37D3892490AA3A3945ACD0FE6B0DE841277DF1DCE1378C24CF56C8331921890009799ECB00CEB389';
wwv_flow_api.g_varchar2_table(1692) := '72514B86861C499408DB788293E0C994D08A2634176294082F9027432125DB4828242E0D6347FFFAE69473891939F06878D6F861BDBCCC4B042402120189C02E4480F7B08CC7F840A9ADEDE6D878E47FFF77FFE6177FFC67A7DE78ED1F7EF9ABE6E6C6EE';
wwv_flow_api.g_varchar2_table(1693) := 'AE1E9BCDDC7AE4504BCB215ED7F25A99073789311EEF8579E6F28CE611269E623CC87812A90F2391D97511E057F51B0259866BAF4ADB0F590F2333862C8C9638BEA89DB4DDF6F8E945FB92F21281EF0501C12BB6D735B711B521B769915FFF27A30AD00B';
wwv_flow_api.g_varchar2_table(1694) := 'E5EBAB10E616CF91AA4737F602CD7874B77FF2724A6D2E34AFAF7DFC00586780AA4DED45C87024FC2B3A127A84E486EE84B028E41D817ABB10360825E4B1812A61F37AF32841AD880C8B5E380A4BD6FB2EF26A952A294A54CB4586A3C8ACD7802524D150';
wwv_flow_api.g_varchar2_table(1695) := 'D472AA5AC29B3E844908AC2F17FA452BD57DA1472811F2342C74F9356914D7743D7ACFA95368563B557542CEC51B1C71444C48AA5716015A09FB854942E09160C16B611B2E10DD15621CD5E60888A402F27581FCBF444022201190084804BE3B047836F1';
wwv_flow_api.g_varchar2_table(1696) := 'C696B7BFBC01E691CC8CAEAAAA8A3FFD4F7F313631FBA77FFA07FFD3FFF8AF5B0E373F7CD8D1D4B4577DE4BD90714F865F2FD46C970B3398E065837867BFE3A1C059DEA61022D886A70CB69856B78D86B289444022F0C341E0459F2E2AFB555D40030164';
wwv_flow_api.g_varchar2_table(1697) := 'D2D355AA0C99AD6BD74B7E4BF917F5F479CC78853A61AD2AC5DD54EDA6854F1BF99C624F37FCDE4B52997C22B6CCC0C5EEB06974851740AF302552699336AB336C7342DD2BB444AA920848042402BB190106034C6862F6D9F4CCF4CA4A8CD7BABC94E683';
wwv_flow_api.g_varchar2_table(1698) := '28ABD5525A1A2E2D0E1F3F71ECF73E7CFFDAF5EB0423B7F7449304789B3F303821EFC8B707FA36BBFC5E9BE1A98824BCA8153292F0A28849F91F3202FC15F05AE77BE7693F64889E659B883DEE9E7BE6B37078C97215C0EDDD905FB2F7E76C8E6DDFC6DF';
wwv_flow_api.g_varchar2_table(1699) := 'C87C3C73A7FD9E363665CC995B8ED6D87C55CFB2279156966726C2253E45F34C361B5BCBAFCE8EF94B8A154D6120C4C4FA8F6FF4BDE69A2A3BF0F6B3D4CA7289804440222011F80E1020C4C8B220172F5EBA7AED4622BE120C5533EFE9ED774E592DE637';
wwv_flow_api.g_varchar2_table(1700) := '4F1F87081F3FD6AAD1F2B9D0F6DF9B4B02BCCDEBC8035E52BB6D62279B49047EB408C83FFC1FEDA593867FA7086C6FD2D0162626F3CAE7571FE8C62ED5341DD165CD8A56BF96CD2F2F2D19355997D7BD96D3AFC656E8D4A4CD991DAE5BFD91FE73FFF4C7';
wwv_flow_api.g_varchar2_table(1701) := '7F7CCA1E685A8E25D75657BC2E5B4E6749B007582E63D42A36BBF35AF7D4F295BFFDE93FFB63ABBF92D8025FF85CB83F5455FC10024C7E299AC8A6E2858D126D9E5822995E4BE63359A7CDACB7D856D3595645D7EB142B0B0A98ADE96482B8C44A3263D1';
wwv_flow_api.g_varchar2_table(1702) := '66D614637C79D9A0CBBB3C2E8DD6B0144D665231BD5EEBB0597446CB6234965B5BF57A1CC98C41594B581CEC54FC78363E8E475399D8EC8CDF6DD33BDCAC66165D883ACC699BFBF10EC05B2023AB2402120189C04E4280F7BC2C36D5F1E0E1BDFBDD5595';
wwv_flow_api.g_varchar2_table(1703) := 'B597AF5CF2F858DFD170FAD4EB30AF232D07F88EEAD8B196AEAEBE97F15A12E097414FB6950848047617021060F161E7EE725B7A2B11F8BE1188AC2A57AF5EF98B338EF2A327B12599CD9DBFDDAF5BEE5D49180E5459D3C52DB7CFFE535938343CB57CE6';
wwv_flow_api.g_varchar2_table(1704) := '68657B57AEB7EDD6E9D7C3734A657FC7B5442A17D6A71C8D47DBBFB812AAF7CE0ECD9E7A6DCF9DCE68FCEED5A3ADADA53E9613D3F379B4EA22EB5D8CCC44664607344B63273F78FFF32B23EE647F445B5CAE9D6E7AFBC32F2FF75B736C12956E34AD6A5E';
wwv_flow_api.g_varchar2_table(1705) := '7B77E2C6973FFFD93BBF6D9B7ADD3566287BA3B77B607676FA4CA32B163A76E7EC0577D830F270EAA76F562C3AF74D3CBCB194D4EE2DD22EDA6A359DB74EFCF39F294A61536BD24A2ADB76B13B1A192875E66B4EBE71F56AA726B56C4A444EFFE41DA3AB';
wwv_flow_api.g_varchar2_table(1706) := '58C8C8A34440222011D82508F0F5EFDCEC5C2C9EFACBBFFCAFF635362E2DADE0B8883B329B8CBB352B8AA8F3A1B687C9933BFEF6DACB56120189804460D722C0FD97F5E1C42E326C24C3C2B62CF94B62F15BBE5D21B1B72D89B585457AE561B15D8BBC74';
wwv_flow_api.g_varchar2_table(1707) := 'FC878CC04B8E4B36756D35A3ACC622453E9FA89D8CE7CFFFFA4BBF233D95F39CFBFCECE4CC5CFB8D8B3EBB72A13F3ADB75C161B75A8C267B91FFE3DBA3F7AE9C1D1C19BB77FDEEF0C4C8FDCB37DC1EFDF59B53D3EDD7AD6E87DBAED5D8BD57EFF575DDBB';
wwv_flow_api.g_varchar2_table(1708) := '9E4FAD289AC7232216675F5CCEF40E8F7E74EEDAE274F7CD7B03B9E98E05BDF7CAC54FFAC7466F7DF959914F3F10D1F6DD681B9A8FDEBC794D49C7AF764DCE0CDC4D65D2E3E3B3D7EE74F5DC3C7FE9EED0EC832BFEA2A2CB0FE66686BB7E7DF941CFED8B';
wwv_flow_api.g_varchar2_table(1709) := 'BD83231D376E1B95A8D1CCEA184F06600FA613177FFD77DD83FD376F5C9E5F981D7A783F1432760D29F1F9814DD190851201898044600723A0D3B1A562593CBE7CE776FBBFF8CFFFF99FFCC9EF3FED2CCB633D5DF8FC253202FCFC5849498980444022F0';
wwv_flow_api.g_varchar2_table(1710) := '3B08B0FAC2F4F4342BEF33E227F1DDE3D347B510862C36595555C087C5B634BCCF14AF36694E9019013E80212F16FBE5149A4D9E2AB45125F262ED07312B1B0D62593E758D629A10AC166AC9B36C81DAAFDA0B25224F5B348BF836AD2814BD8826EB55A9';
wwv_flow_api.g_varchar2_table(1711) := '4D842534518D54F5CB8C44E09523E0342AEE60D9DDCEFEA3D54BA98C759179C9F37335658DF7F3E553B7D899396D3268EAAA2B0D9E5C72B13B74D03F68B616058A86BF5CAACA2D1F38D8905B0A2F691C4E25BFA7A142A79F589D1B08D485968C064FD03F';
wwv_flow_api.g_varchar2_table(1712) := '3612D3283A0DB3A0F9E37AB477F4E062AAE7EAE5B26AFBD5BC736D7996AFCCCAFC96545D63DB47D1D9A5A5ECFC7475E5078EFEB5DC988EC540F2D95C727535954CADA53597EE74BB957147B06C76F6D69C762EAC4F565757E91D45E95C62647CEE846175';
wwv_flow_api.g_varchar2_table(1713) := '7FEB7E7D62D1E3746B4A5957F209015E5C4D3B75F34D2DC7AC4AADC6E80DFAF5475A9B6F3EF4ADA523AF1C49A9502220119008FCC01160C4D2D0B0A7E550F37FF88F7F5B5A5A7CEAD4F1A70D9E9B9B57F2850DFC9EAE7A9E1249809F0725292311900848';
wwv_flow_api.g_varchar2_table(1714) := '043641006648BC97FD54618CEB13A2EB4F61B99420C93EB7EA06B9943C78F080DD71A1C12CEDFBCE3BEF0C0C0C8C8E8E9E3A750A0A7AFDFA75767CADAFAF6F6868E8EEEE664B55F6D37EEDB5D70607073B3B3BD906960D75AF5DBB469099F8F3DEBD7B2B';
wwv_flow_api.g_varchar2_table(1715) := '2A2A6882AAA3478FB2974F171FC7F4F5555757373636DEBE7D7B7C7CBCAAAAEAC08103ECD0DBD3D3535C5CCC29F6A08ABE5A5A5ADADBDBD9A4173BD9B30703D08CA9870F1F86B1B311DFC3870F916F6A6AC2664E89661F3A74A8A3A30383F1FDF8F1E392';
wwv_flow_api.g_varchar2_table(1716) := '03838C4CDF2A021E93F293774E3FBC753677ED8A26ED286B2EAE7DE3D8D53B23F1C5C553ADFB730E76820CE4147DD06D35DBBCA501BB31503ED83570AAA9716EB53A97590BF9CD797B91C75F94577445450EB3CB5713B45D703646067A8F1F7983B9756C';
wwv_flow_api.g_varchar2_table(1717) := 'C41CF2D84622F9CC8D1B19B3756671AE52632D0BFBF546BBDF93D1DBBC565DCEE70F55FA5DF76B0FDDBAFE60795229D1E5EA02F6FB457537EF3E74E7564C6EFFDC42C29E59097843CED540537359EF58E8EECDB65C6CC6AC779D3AB22FDFDDAFC967C261';
wwv_flow_api.g_varchar2_table(1718) := '47CF8CA26DBF5B7BA441511E6F4BBE2F645D683C9D5A8D9784FD36BBDB5DE455723AB7CBC027C8DF2AAA52B94440222011F8A121205EEB33E63975EA0463A47FFD6FFEB792D2929AEA8AF576F2BEF2E2A54B660BEFFCB7B91D80EE2FFFF22FD76B7C3ABF';
wwv_flow_api.g_varchar2_table(1719) := '7E18477F2406492431978F6D2D9E6E4209AD7080C0C8A6B5B25022201190087CF708C015E17B5BF4CB5D0B7647A896CC0631389ECFE7635D7EB1ADABA8E5146176AFE5483C568482C9709FE40EC929FC90239B81B1711A84933B27F774D1969B24149786';
wwv_flow_api.g_varchar2_table(1720) := '30496420B177EEDCB978F1222C971B3A8165E64E4356619E57AF5EB5D96CB050082DCA21BD376FDE841893412124B6A4A40479F4A38D2316A20783E90B4BC86306BBC9D31CB10B172EF06E15B590E1F3E7CF5302019E9D9D85CCF3A4011FACC51238F6E4';
wwv_flow_api.g_varchar2_table(1721) := 'E424C75BB76E612AAAE0D5F4FEEB5FFF1A6EBC7FFFFECF3EFB8C283185D069812A62F48E77849D990D0E023802E6B422F334A41B1096A73B09017E1BFCBCB9F41BAE3B3F12FE16183920F0ACF1C3A63868354A59C0A3B30794EC9AD564A82E0F852AAAD9';
wwv_flow_api.g_varchar2_table(1722) := '9FBECC633E74F430D39D036E7BB0A4DCE1B0978783A192329BC3EDB4989A1A6A158B5F93CBFADC96A25049D0EF09949438EDF6B2AA307F3568F35A0CCE4090602C7FF02EABC96673E80DC6AA80D35FBDC76136EDAD29AFA8ACF178FD25A5C50E4F20E475';
wwv_flow_api.g_varchar2_table(1723) := 'D554D75B82C5A964B27364BAD9BF76E8E4DB564750AFD33454866A6AEBCACBAB8C264769D05D4DBEAE4E67B42E273263830FDE6BAD69387C22A3B3EB95BCDF67B338031E9BC157CAB7C78F6F470E933E6D7125A38B1E87391C2EB5DBEC2EB78FBFC4229F';
wwv_flow_api.g_varchar2_table(1724) := '4B6F62AD2C992402120189C02E42403C381848302FA7BDFDFEC4C46C5575A5CFE711102493A9CF3FFFEAAFFFAFFFFBD0C12606336C10C81883810789D1883812191609556A12CD39252323C0BBE8F7245D950848045E39020CE8D1091185FB31A667C40F';
wwv_flow_api.g_varchar2_table(1725) := '93847C8A0F8329A18A5B3325E4C56D57D8409E986A6D6D2D7CF28D37DEE04E5D575707B34521F9CACA4AB82B149707003A7FFAD39FFEF55FFF358C949830C412628C4242AFD4427A09F3FEE637BF3973E68CA0BB306A682D92F07342C744713FF8E0837F';
wwv_flow_api.g_varchar2_table(1726) := 'F8877FA03961324E11C306C2CEE5E5E58494C913D115C643BFDBDADA0E1E3C48C9DFFCCDDFA08AE83162A8A215215FCC868DD344705A0A85533427D44C041B8FE8026A0D67865A9341F8EDB7DF86F690914922B06D040C5AA5654F99A2F0AF902AED4AA5';
wwv_flow_api.g_varchar2_table(1727) := 'BF55E4592B3974E828F923750E45099339D6427CB5905E3BB84F6438868F1EE478E8E0E3B0EAC99646B58A5974876AC30AFF1E25B8A99A0E780B595EF6971C39B99653D632F339AD614FD0D8D47ADAA8311CDD5FAD28FC2BA422FE2BFBFA2BE5E58C4E9F';
wwv_flow_api.g_varchar2_table(1728) := '43FECDFD7E4FF561B359F7FA91438FA41408B75256B0564DCCC06EDD57A6F0EF51B2961714D656F19DB04C1201898044603722C0408861435555F5FBEF9DB97CA5ED5FFDABFFF5273F792F1C0EC563F1EE9E9E73E7BEF27AECF5F575BCD05F3FB27A7EA4';
wwv_flow_api.g_varchar2_table(1729) := '24017E7EACA4A44440222011D804016EBE1E8F07A20BF58510C20CB96B435329218ACB9148D7B322CF90525E5E322F1A01482FB416028C42A267C3C3C3504D6A790C7CF2C927333333904CBA6012326282C412FE25DE8BFE7038CCBC655E7CD22F949586';
wwv_flow_api.g_varchar2_table(1730) := '4495A1D3B0DC3D7BF66034325065E2C64483455BAAE0A88200234086B6946033939FE91447E81403D0F6E5975FD28A30322C1D9BB104860CDD657A7659591913B0A1DCC4A83183A711FC9C44609CC2BB77EF4283B7F77CDA046B592411F8BE1120D26033';
wwv_flow_api.g_varchar2_table(1731) := '1BDF7B7D7F711DD47AE35411D53A9D56212451E236ED697CCFECFB9DC97BAA8CCC48042402120189C0B310605CC44065DFBEBD0C482E5CB8F28FBFFC55D01F8827E2F3F3737BF7D6BA9C7C2EE26638B4BD018624C0CF82FD1BCA19A43204E4F80D723BA2';
wwv_flow_api.g_varchar2_table(1732) := '7ADB6EF2A3DCF64F734720279DD81508F03B27DE9BCFE595BC42B4169F590C2BBD9676381DB0C76C26CB8C1C642090DCC4372002A564020F549372A8B2A0A6DC5BA0C44C33E6B35EF824DFEE127A4533241649482CB39761B9B06E262DB7B6168260C830';
wwv_flow_api.g_varchar2_table(1733) := '57998DE361B0D060FA7DF7DD77FFEAAFFE8A53A63723C0C2D4C466452F1C45A23BF1D7CD11BE0D95C54E265EC27B8915632D3D22C9F7C94CC3E68B65A82F4169BA3E7DFA3473B6497FFFF77F1F894420FC737373F44BA41A79C2CE7C8A8C24AE11A6A66B';
wwv_flow_api.g_varchar2_table(1734) := 'C2E3A87DDCABFC9F44E0478B007B081F591785DEC28FA0431F3C7C600B015925119008480424025B20C08084310FE390A6A6468FC715892C6632398FC7D6D458FFD65B6758EB04868CCCF6488A24C05B20BF5515E35D46AB5B49EC943ADC24E84434E945';
wwv_flow_api.g_varchar2_table(1735) := '7F6162C44F4C89F0D14E0143FA2111D81C814280D798331BCD668B990512626B519BC9E274B874066D5A93D2295AFE7CF8537A9A00433BA188AA52582232504A56A5829D428339E50F90237154D82CE5446861C5BCF824A24BB958550B1918324414524A';
wwv_flow_api.g_varchar2_table(1736) := '2D1FFAFEF6B7BF8521438C2F5FBEFCE9A79F6221E1593AE29D94DA1D858297621B939CF94898AA7DFBF6319919AECBCC67BE933C7BF62CAA20CF4CB4666E33BD73F783EB1270E67B69E489F4DEBB770FAE8B126662A38457B65074883751622669DFBF7F';
wwv_flow_api.g_varchar2_table(1737) := '1F3EAC762A33120189804440222011900848049E07013830EFF4EBEAEA890D302E825C30D461E04100008AC1E9F328795A4612E0A73179AE12869EBB84D7F16BE317A64EB954D1D9F0D2A5F0037CEA350C23F2DD03948A8CCCEC360472F9DC48AC736665';
wwv_flow_api.g_varchar2_table(1738) := '4CA7D1EFF1B7CC2E0F47D6660CEC9092DB3F30F5209E5A36E96DFB8A5A377D85C467C0EA9D043A7AF2E449E8ABB8CB734A109853FE0639426559920AE6891E6635C34521BD82EE02B850CE5464E651C38A11807FB2523424B6B9B999159EF9AC5770DD9A';
wwv_flow_api.g_varchar2_table(1739) := '9A1AF502A144049FF973666E33FAA94200664BD81626CC9B57782F5F29B33434F1616A61BF047B590F0CABE814FB45901976CDC4692645538E1802188CB574FAFEFBEF73AA762A33120189804440222011900848049E0701C62762E423862B0C3C88C9C1';
wwv_flow_api.g_varchar2_table(1740) := '4A18EA3C4FF367C96C1E38166329DA90613423126FF7214224580D032FC205D4327EDA5435C2582C86539B0AFCA80B719C2120D1951FB517CF693CD79AA130F321F91988265AAD46A3D5C5536B76132F501EFFFEB279762E4D1201631627BF1A21C9381E';
wwv_flow_api.g_varchar2_table(1741) := '02CCF8F839FB926212816F15013EAC5D1FFF7CBA2FEEA77C614BF472C38D953F79682ACB4A410521996A43C2A15353D3C10AEF3FDEFF77F5BE834BABF3017BD9F5D14F7C96B0516BA9F6347E31F877A58E5A76F93D51FAE1ECF802776D38ADDA7C8B0C3D';
wwv_flow_api.g_varchar2_table(1742) := '52CB5D94E3FABC3815E51B9A23B6BE7CFDE9FAFC8656CF3A5DDF647D5E95A790FCFA1E39550BD5266A466D28333B1E012E3A917F66C2F3ECD8F00BE139C2DB10460E083C6BFCB0E3F1910E4A042402120189C0D608F0B69DF1181F64110C582FC9F385A1';
wwv_flow_api.g_varchar2_table(1743) := '142FE8AF5CB92226BE71CAAB768E24C678040CA0CA70661A9218CE917812A90F23919111E0F5A8BE589E6BF0620D768434BF9BD968AAA7BB67687CA421ECCC6B0BDFF531485F4AE55616A7F69585EBF636E8CC1E9503EF08A7A51312816722A0C92B91F8';
wwv_flow_api.g_varchar2_table(1744) := 'CC7272A125FCD644743092987199FCDC1C9653F3D1E492C714CCE5B32BC9A595E472FE45BE9950EFD474BC3EFFF4A96AD916621BAAD4265B64D637599F579B6C5DA8D6AA19B5A1CC4804B68D000F5D3EAAD728798635FC616C5BCFA60DC5337D7BBFD847';
wwv_flow_api.g_varchar2_table(1745) := 'C301DE40A1F8155BB5A9A9B250222011900848045E0681970A1FBF4CC7CF6ACBE36D2596CCE70A0BC93C4F4A65F28944FCD1A2334A2CB1CA0E814FB742677C7535974E3E5DB5694962359D595BDDB44A1666F29A6BDD2391A9E1A1C9E9F8D25C341A63A9';
wwv_flow_api.g_varchar2_table(1746) := '9B95587436129D9C9EE81B991AEAEFD26918E9CB4180FCB1EC0A0498F160D49AB58A7678B16B64B19B0097DBECD76B8CD3B191A5E4ACD71C50F29AC995A1686A6177BE32DB153F02E9E47782406C2D7FE35EF7B5AB17EE5CB991589ED8A2CF5456595A5C';
wwv_flow_api.g_varchar2_table(1747) := '54B61C482433F96824A2E433420FD396BE6C1F9AEDBFB585DA4DAB22CB896C323615CB5CF8EA6A7EB5B0E0DCB3D2D4E2EA705F7F6E2DFA2C01592E11900848042402DF0D023F38020C736A6F1FCEAF4E6FE1FFC0CCB2925A1402634BE9FEFE2E45C92473';
wwv_flow_api.g_varchar2_table(1748) := 'CADDEE7E2531F77443087057FF607A71787DD5F8D44A3AF158C9FA72F23D23CBD1D9A10D85F2542090C969AEF78C18D6E64B7DDEB46254F25986F5D96CDEAACBF9BDBED1687E68A04BA7A4255C12815D82402E9F21E4BBC7777820F2602939EF347ACD5A';
wwv_flow_api.g_varchar2_table(1749) := 'ABDDE8AA71ED0F58CAF55AB3DDE0AE76EDB7E9DC99ECE3A1F62E4146BA2911788508ACE5950B77FAFBEF9C33E8F9C64697CDA479B2A7D6785BFD68DDF5BCC2B6634C87CB65D608C6764DAC9CFBE8934C621203D2D91C1FF228ACD28E4C264B13D1F6DED8';
wwv_flow_api.g_varchar2_table(1750) := 'D28DCFFEDF4C6118802685B1C7C76D7D935D97559B0B92E9827216674F6732ECF1CDF2EE9CB2DC3B4BCEB1E7772E978DA6B31F7DD4B63078776225FDD9675FA5A2A3C8A190F762B9C2329905CD224D2CA5AFDCBC75B7E341D7A56B4A8EB7F63249042402';
wwv_flow_api.g_varchar2_table(1751) := '120189C0F786C00F6E0A348F9781C199E3FBDC8AAD1C16353D3E9FCBAC9404DD798B676274CEA2895B7DFE8FAF3DFCA3EA95D0BED35ABD793E915D9C18D9BF7FDF5ACE383431F97AA93EAEF5C4565675ABD1607958D199C7A69795E4E2C8D8E05E872711';
wwv_flow_api.g_varchar2_table(1752) := '5B8BCC4C7B1C1AAB277CFE5AF791D2F93D874E2DA48CB1D9D1B0CF6972F96796E2A9A5A9E1E1657F59CCBBF9D7CDDFDBA5FA8174CC20622D93B71A7535FEA2F3DD53AF15CD9A7DB5F727A281DC447159C3CCE46A8A899EBB7272F80FE4024933BE630408';
wwv_flow_api.g_varchar2_table(1753) := 'F96A72BA06E7B1E9955187D5E550FCA5465D24391BB0D6F80C41AF2B1C5D8B54DB6D4EBD6F293BFAB46DBC3F628B2096342C4CE97C945028968E5B3F1593C517587681EF90D7173EADEDE912B4F1B125CB323F5D052BA077BE9979BA6AEB129678C0C2F5';
wwv_flow_api.g_varchar2_table(1754) := '3A211E588817F882237C8DC3F7FF7C714D09CB68D10B8B2650AE2E85C5A7A12CEAC807D57C99432DAAF08E9267F58B723E07123DA29953B1A0D7B3E4B728A72330142B8D81009D32870588C808FD1B10431E3B6982FDF8C2914FC4E97DA7AE70B10574DF';
wwv_flow_api.g_varchar2_table(1755) := '6FD5E29A72EEFCA5FFF2A066EFF1D3D99C3E9B4BDFEE9D5A1EEBCAA573871A4271CF9ECEAB5F38ECD69568FCC8E1BA4BB7A2BD5F7E7960AFD9BD27D4DBF520165BA9721B0CE58D9D576F5B03E65464B9E5E0DE8B6D632BE73F6BA8AD296B7D4B4C594AA5';
wwv_flow_api.g_varchar2_table(1756) := '0BDC18373339A56B786E7EAA57B71C6F3E5AD73E90D2AD0CC4B28E6A67BAA6F5545BC7F85AA43F9AC8563BB4F1B2C6AF3EFECA9FB6385F2F5B4CA4DA3AFA56D38B279ACBEEC48BDC73D7F61F7F4FD116FEBEE0C19DDD53B6E874D25FF1ABDFFC725F4B58';
wwv_flow_api.g_varchar2_table(1757) := 'E37EAEB500BE5FCC65EF120189804460A722F0838B0003344322F16D0FAF4F0746166EDDBB3F7EE76EFFC2F2839BD717A6C663AB8981D1F1E9E10182BE08F3019E565B183832E356ABD1AEE6B4176E750DF5B4DF793010196EEF9B59E9B87B636078343A';
wwv_flow_api.g_varchar2_table(1758) := '37AD33E81713D98ECEBE3B576FAE44A687C6A62646FAA7232B0FEFDFBEF7F041477BDBD4ECECDDB6F6B1B141E6F7EA0AAF8365DA0401B63A75D80C079AF6ECDF7F20ED2AD95759C44E27D6E2FA929063FF81FDD50D4D79939377ED9BB4944512811D8700';
wwv_flow_api.g_varchar2_table(1759) := 'BC08FE462C289DC8DAD37E43DA3E3F3FB71ACD38B3416DC2B4B4B46C526C016305EC17D208B37A1A00F8153B21A144AD82DD75777723AF969061B52D76DF7D51F64B43C81B2B33AF57A5E6A71F2571CAB2CF48AA555B679ED639353505DD451FFB276127';
wwv_flow_api.g_varchar2_table(1760) := 'EE0C0E0EB2F474676727249312B62BC02964D00C5BA616AACC2249904F5C43860DFDB6E89415AD49ECCC840CE4F9591E6DA14154611896407739EDEBEBC30070C67896D910A6528E776CA7ACAA826F534BEF77EEDCE162B12133B5582B94A86232F36D23';
wwv_flow_api.g_varchar2_table(1761) := '104B2ACB0B139515258AA2D76995F935EDA7BF3E6FCECDF64494F3673F1D9D9EBB78EE634326FADBDB63530FCEB3F1B64EA3D55BAC67EF8D5FF9E23737DB3B2E7E7CB66F64F0EA275F69F4F1735F754DB55FD61AF466632EA5355FBBD7D775AF4D598B69';
wwv_flow_api.g_varchar2_table(1762) := '69F4C88DE944E657BF3C7FFFEEB5B3E72F0FDCBBFCD5F58EE5DE6B0331C385CF7E353C3571E1E3CF8D9AD8ED81C58E73E7B4868C2EFDFFB3F75E5F721D799EDFBD37BDCFACCCF2DE7B87AA0250702408B09BA6CD6CF74CCFEEEC9C1D492F521F49472FFA';
wwv_flow_api.g_varchar2_table(1763) := '0774F4AA17BDECD13CCD596925ED6EAB7B86EDC86E12B4F0A82AA0BCF7DE66557A9FFA645D30510D47022441988853B8881BF18B5FFCE27B4DC6F7FEC2A4CD2683A2D1F2781B4DFA8FFB57A76E7C1C8846427E6FF65B300FF3C1D6865E4E7B0CFE79677E';
wwv_flow_api.g_varchar2_table(1764) := 'DAB7F95DC325F40B040402020181C06310781E0930E6B25C1747B6DADD0F79D777F64607C6767C073EDF7A4A916D46ADDB9D5B545A22EB0E975FD228F221593D64CD7234292FACAC97E428B6CACAF1FEA5C9C199425BBCBCB242D25A524989FD2BF7FD7B';
wwv_flow_api.g_varchar2_table(1765) := 'C3238B71FF629E3BB7BCAC7464573339F0E99EF7606E617E7C6EC9195D2C2DAFD15A72D25FCE0B7A0C76AF661697C6178CF70F8EDFBE3DB0BF323334B198D93274767466767560E0F6ECD8A012F57DEB6B93BC9A508B56BF1008A8DC95018FA148D0BBBF';
wwv_flow_api.g_varchar2_table(1766) := '072F8A44C2F1648CD9F1382DD737D637B737FC413F3C0A02FC2083855C41FF547F29040F42080126822474110E492E3840F9F832482E29EC128C2A78206E5524E19308204C1C86A6F24935423A848D451129482EAE4B5270DE1287F12249C060F4CCCCCC';
wwv_flow_api.g_varchar2_table(1767) := '0C0F0F63B0CA57B18A76218918FC9008E45665C8A4B330234B2CA2938214C760CC2305AB30033194C0EAD9A60F1922D880EF1701082706A05CA5FD10636C23A093769145596CA33A5451239228274E8D0072EBD62D12A9119388601B45504511955A9302';
wwv_flow_api.g_varchar2_table(1768) := '383413764DA20A1D8928A714C21C49A7460C8300234CD5F875D9C349D5ACB68E82D8803C20533BB9F8C9B946B065F833A72A200888F0CC1030EB25A3CD35BFB82431082929ADFB22BB9353A73A2A3DF5DD53332B896840AFC43BDBEA93AECAF0F67C4959';
wwv_flow_api.g_varchar2_table(1769) := '91C36CADA8AFEB9BDAB625B6CE9E3856DAD81949E9CCC9785777434A2EE6FE28A8ACC8B76B8AEAEBE30C9E8E33709A41D277D7AED80AA7160687DACB5DC7CEBFAEB717266291DA025345DBF18DBDCDC5CD8DE8F264EF89666769732292AC28739BCD9EC6';
wwv_flow_api.g_varchar2_table(1770) := 'CA62ADA3D0A4A4BADA6A5296B2E5A5F5FA7C6369ED3149B93BC88E9E56406F5A5A1A2F769A5DB6A2B446F7CC70131509040402020181C083083C7743A031319648790FFC3A797F682321FBA68BCAAAB6EFDC69B3CBD1DAD689E59DBAAA756B4E9ED91C97';
wwv_flow_api.g_varchar2_table(1771) := 'E48CE3D769D12EEF86BDDB6BEB31973EB82F1B1B4D3AC9E9B0EF298E83683A168EE4E43308CF919294602C35363F5D55681AD82990630187ABDC6209C5921A433C595151E634CAAB92355F2BD91C2E49D948A7329D4E111E44802E825623D93C4EC96035';
wwv_flow_api.g_varchar2_table(1772) := 'DA5DECEEA961E8A053712537AD36BB2D624E27329D6C110402AF0802F49BA1A60CA0E50847E294A02EC10F67839D7224800647648EC282242490DD9560659034A7D3095D64717F96EF877AE193649C2D0112088B6B6868E008D5E494DD772727272172D4';
wwv_flow_api.g_varchar2_table(1773) := '88644E4E0EDC12E53052E89C4AFC187E8C0054908D9720963037F86D4F4F0FC48F7A6171C893C229037AD1AC9261CC80E611D00C5D44A1BAFF1E0C10E1AEAE2ED2559D7844696665652506D0B4DCDC5C8EF9F9F91C298886E2E2628AD3229ACCDE5134E4';
wwv_flow_api.g_varchar2_table(1774) := 'DAB56B6A9339A55E64D000B9C57E861663249E5504B09C7DD730981DD4C8C2369A0C38684306A8A1BBC421B16C350CBB868E6215CD1C1A1A621833E994221133D0A0BAD319F3CC36C5E08C00B0801E555017AD030A983095620C749AD6B179323E6AF658';
wwv_flow_api.g_varchar2_table(1775) := '46ACAAAA8AA6418FB92EE422CFE63D608555472FA5887FD708E418A4D7CF9DBD36F9A9EFDA174ADCECAACA2F6A6FF962606E777BBFABA59ACFD626A319E7B0DDA455145D81DB9CB0BAE7C6263B2BAB82FB79722A56516E5F32E69ACD7C3757D82F43D118';
wwv_flow_api.g_varchar2_table(1776) := '4ADDE66B4AF9DEF4D8C9B6138A542BE9B456A366662310BB7EC39263AF605E5534686715BB628F41EF550C46830607AF39DF6ED2E7575FBF76E7605D93AB4D9B25D9D3583E3ABB60CE59B39A2D69A65DE9355A8D717275DFB5DE575C5523C919AECB635F';
wwv_flow_api.g_varchar2_table(1777) := '5E593A3A6C1B9DDAEF32EC29AE13DF355C42BF404020201010083C0681E78E00F33BA1B3996E0DCD3A1CA1B4BB2A11959DFAB4B1B4349992C3E1783A7820499A22B76572A6AFABDC2F1B5D8536CD94A7EE56FFD041DCDA5A6453ACEE7052BA3D341B52B6';
wwv_flow_api.g_varchar2_table(1778) := '8F1D2B5C36D70EF55DB5ECF43BF5498DC9814B037A5D946FD79B5DEE0217CECBFAE650B2BA8B552B8C4E47537EC1ED25D7CEC075632262B0143E06B557398BAF0E256E9BCDAE074F9DD167B746744EA761576B4D6426C5E5C6E3F6983B2D2B47D6FE7895';
wwv_flow_api.g_varchar2_table(1779) := 'D1126D7FC9118043C2B2709FE227A4A91CE154D9A39AC229948C74248FEE214C2E248A5C95EC118189DDB871037205878439C3C4606B54C1985B761D878292821286E3C2C1A064ADADAD703948237A3885222250545434323202A785EB22494164E0A8B0';
wwv_flow_api.g_varchar2_table(1780) := '62956C1387E9A91706168A49048825622452D7F1E3C731185E4AD5104B1CB9B76FDF3E7BF62C633DA81DAE88C1F049DCB35044A625DFB97307C60883A538967354112042227112693EDA0868C01234603011F450230D4112C68B852A77C518DA027DA520';
wwv_flow_api.g_varchar2_table(1781) := 'FE5E783515417D31061E8EFDA4602134187E0B414518DC3089B6D06AD0C3E78C36227C32408006521D95F2ED00720B13C60634A30DAA8C0C4C1EFDD8008C645DBF7E1D4B28A5CE164633DF29A88E4611A0C16A4BD553717C06081814E907BDAD83365D32';
wwv_flow_api.g_varchar2_table(1782) := 'B4A59552250EE35B3F7E7D6F71ACB53075ACF12DAF2D47FF837735E69CB78F6B4B747A4B81EDFCDB6FA595D80FBBCA46F56FC9E984C1A4D4E65B9D3FFE814172FEF0CDE6324789A9D01EBDF00BF653D2EBE808650630BF73A23EBD994AA6924516F9273F';
wwv_flow_api.g_varchar2_table(1783) := 'BB70B03CC63D6DD11BDF3CDB9EEBA8D0E528F6B77F515D5CF6C64FDE8AFBE6C3E165BBC76091B4EFFCF47862CB5C6C51DE7AFB0DC550F083538E62C5B863B1DAE28CD6BEF7C1ABA7DA913EF54E646BE6C2EBDDB2B9F4192026AA10080804040202814721';
wwv_flow_api.g_varchar2_table(1784) := 'F0DC11607E6F8E7755F9B7158B5E6A2C73CDA57A8D69AFABAA2AA57514E4D88ACADBF439D5A76B93017D933AB8C8A6958E1DEF589DD5E5CAC9FA868A9DCC1C1CC5E5F1949AEC85750D4E9D55EB6BD125F71BEBCA1C9EBCD3EDB27749EE2A35DAF38ADA3C';
wwv_flow_api.g_varchar2_table(1785) := '8E6D7D53459E3971ECC4C1EA94DE60AEC8B5F88F75A60E162A4B5DB682FC4741F68AA7EBB5524F4DF9EAE2A846BB5A630AAD1DE8748935672C124A99F11D191389C6FA9A04AB430B06FC8ADF28AF46F3E169903A9818CD85AA3DE6080F84596557815225';
wwv_flow_api.g_varchar2_table(1786) := '7964607468E0147E0B0924C0AC708D725A5A5A0A618303C3E870FFA2818AD0001943000E860C0589A8AE54681EBC17728825B84C51857E681B71789D5A35712822C40FDA89CF137E8B060CC06FACB23BCAA2F0D0100D71A8202C1412889D1C21CF0C3046';
wwv_flow_api.g_varchar2_table(1787) := '27A5A88844ACC22F0A1D2585C02901333009499839D5513B71F4A30A93D0096E68438CA016449E82242243BBE0EDF0528C043458280C5995C72402D414318C84DF72AA52563EC091021557DDBCD4025CE82491B6632AAC9E386511A008549C2A48C4794E';
wwv_flow_api.g_varchar2_table(1788) := '59E461C820535B5B0B1A906195D843BC31034C3095748AE07FA6397CAD502D17C7678680C3A09CEB6A4AA51AA8919BB6D52EA54ACF282C04222BAC9F567AE602E9AFB73925A98CC8C5D7BAF816C5A08BD74EF76622325F6794F20BA7C93A73E6EE9A7017';
wwv_flow_api.g_varchar2_table(1789) := '5F3F79B8B073E601E4DFB9D6F2544B194F32337DDCB29CAACACDC415E594877CC9254995AFBF1B63056AB32F1C3295D8A596D61E59D2773714A6EA0B988B555208E395CE767228ABE250F3177788552B9F3FD5904ED52A5F2E7787880802018180404020';
wwv_flow_api.g_varchar2_table(1790) := 'F0BD20F0DC1160DC078D151E89BFC3D0D9CA8FCEDD50D495F9612194B8B492AB478D732C72EAB359DAA85455E8E9385621E9F3C8A26F75AC3DF34BA486CA7CA932BF5B8DD35FCB6FCD286C60D854C9DDF148AD550592C49F088F44404EA78E5517785D26';
wwv_flow_api.g_varchar2_table(1791) := 'B6586C5394248B62A5532D993E88C29E1046ADE270B9E86C0802FC480445C64B840024B0A6A60636F5287F60361D9E06A78268655B0F6FC49BCAB85C5210832BAABE4A9818549614D81ABC0BBA05F582109292E18B26133E5E8E503B881C6A715D4265C9';
wwv_flow_api.g_varchar2_table(1792) := '45982AD0C3A85DF8247E6912E17EC4118073E237865B421A912440ADBBBBBB617D106C9557630932F05594A31655C86386CA6F310C8391810772C448B2B09974949342C04E12310FDE4B16F5620C66602ADC1BCB21A51D1D1D48622AC61341391C032514';
wwv_flow_api.g_varchar2_table(1793) := 'C1180C837392824EE2B07D6C506B8473A20749482C05318038F8C38D11A62E54A97C180D9841A3A811A28B1E4CC221CC2905ABABAB61FEB48522885129D5A119318AABCA69FEE0E02068200F620CE726821968800F53238C9A14119E3D025CAC6CA50ABC';
wwv_flow_api.g_varchar2_table(1794) := 'F3D17BCEC37E91CC481C29922DAB66C1A48FA664D61F391CC540E2D17856066DE833689437BA6B2B9A5BD4DA33925F2364740BF6FB358012220201818040E0BB46E0B923C0DFB0C1369DD4D154CF349C6FA847143F8A00FD5735A889068D5C984F07F421';
wwv_flow_api.g_varchar2_table(1795) := '3FF9F46733DFDA33720FC93DAA53C405022F01023C17B822094FD116B816840D1EA896851B43D8605F5035FCBD506BE816D41AAAA65241C418BE0B9D83F8210373836D12818911271722073153B9190C16BE87615808AF63FEAA3AA218850C15A608D491';
wwv_flow_api.g_varchar2_table(1796) := '22E4428FD149BDF87521848C6A860FA384B2306434537B7D7D3DC250593C9FD05114724A22B56327BC143DA41020B11C2985365CBE54873C1C55E5B1AA6DA84506FD540A99A146147244186ACA77018A5029B9F04F3CB459FDD4880316A054D0A8025560';
wwv_flow_api.g_varchar2_table(1797) := '858B183DD8D0DCDC4C04CF390A310C6D0883B33A6A1A56ACB256CC5603206012E00017C50110FB557E85797C1D5089B74AD1B1992CAAE39304E960458A08AF1A023A453ADE888739E3641641202010100808045E50043253B31E343D9B48849E811AE827';
wwv_flow_api.g_varchar2_table(1798) := 'F1099FC0E7703A0A7453C8553F903FA80161FA1347DD1D0FCA7C5B29CCBA4B26921A39AD689FDDCA8AF846E8636581FAB6DAF21CEAE18AD33FA6C3F7148DA5EF4E97918EEC73D82E61D22B8800D40566F5988673BBE2A284E6A92C282BC9CD0F7D8271C1';
wwv_flow_api.g_varchar2_table(1799) := 'B5548E97CD7AEA083A794FAA64525D89EAA1AF531E408CB9CF1E9E2CFC93F061B8E2A30CE0BD4DD67D051F25FC35D31F34064B684296003F5E0FEDA5D56A931F2F99CD7D22FDD9520F8DA00A56FCD02C35F1BB40EC31D5BDC4595C657E35185BAE2E9076';
wwv_flow_api.g_varchar2_table(1800) := 'B4A580CC871E6E75041E7AC31F15167181804040202010783511E0CB35FD31BE9EAB9FF8B320F0FB42CF872FD757AE5C8190F2319A533E6A7324D0C7E3BB36BFF5F434284838EC40653E91673B2A6AE465F000F78D6F0636476DB2B6BDBB466FCD0C5453';
wwv_flow_api.g_varchar2_table(1801) := '4334914EC44296C3551FBF4CFBD6FE077170CFA2F9ADE97DFE1471F7D0586EB8A7308D5B909BF2290A8A220281971E01DE1E592AC808DB4731D5ACCC514048848D3F9ECE3D4AE1513D4F1A7FD098C7DB709F7E5E26F7A57CE5E913E97FBCB6AF54F55D20';
wwv_flow_api.g_varchar2_table(1802) := 'F6789344AE4040202010100808040402CF1E819781008F8CADD73AF6E6C3B905137DA5DDC5ECA2948A3388CEB0B49FD89BBB73ACBD55A3332B8A36994AB3C93D340EAF774256E291B041A751B4FA444ACAC4F55A1CC8B82712EC8C2427B4FA47FA55D48B';
wwv_flow_api.g_varchar2_table(1803) := 'C4378607FB82CFFEFA3DFF358A3EE5F37F8D84854F8AC0D37D0F7A4C2DEA77A22752AB0E247EA2228F31406409040402020181804040202010784510781908B0944CE5B96D6B3EA7920EFA22F199D9D9E0D66A4355C19D4DEBCA952FDC563DE3F38AEB5A';
wwv_flow_api.g_varchar2_table(1804) := 'AF0F2E1D2F91D734058EC0CAB6ECD8989F2AB41B4A1B5A17D60E3697E64A1D9A82A6D69BE36BC6D08114DBEDEEEED2D9721F7F13086AF7787C44AE40E0E54300C2C948DA97AF5DA245020181804040202010100808045E11045E06021C4B4B33F3EB9DF1';
wwv_flow_api.g_varchar2_table(1805) := '147D00004000494441548A26CD0AA4779677263E7F3F94D0A6F6C64CA56F32765767B08E0E4ECB4ECFE8D46865503F6DD578A22B03D37D519F6F51130A1B2D37AFDC8986436B8AEF74AEEBFAE0CC0F9BCCA36BE9EAD5E9BC86AF20C0AFC82D229A291010';
wwv_flow_api.g_varchar2_table(1806) := '086411600623F36085DF350B888808049E190289B4343EB716D89A37A6358D2D1546FB2317E24EA5A5443C96D9E0974DE91F119049C6623A76F63B94D90A24E7C7EFC42351454E592C86F6C66AC9F894AB5724E2498DF2150B3E33182D198F6BB46C7B76';
wwv_flow_api.g_varchar2_table(1807) := 'CFC2442CAECDD87C6F09C950349E88046D56B3ACB97FF1026F545A19BDDED2D220EBD9F9490481804040202010780204EEBD799FA0D07326AA97A5BA8AC2CA86E6D9F1AD65B69A94035DDDC73D25F5650579E59595E5EC7891DB387F67A0BED833E83398';
wwv_flow_api.g_varchar2_table(1808) := 'D6C7438E0A796FA9ABABADBAA9732B62D01ECC77F534573477A6D226B35E39D65D6FADEED9F76576FB104120201010087C730498EEAB866FAE4A681008BC9A082425E9C6C4FAED2B1F24C20781403C160D3C068785BDE8E50F3F96123B8F9199DA0A0F7C';
wwv_flow_api.g_varchar2_table(1809) := 'F23B2919546560A49164E24F1F0D4D5DBD944C30CAE31E0B7D8C9287664D0E6D0437561E9A954D8C4AD2D8C0482A78AFA7B11A4A4E0DDD96D2B1AC0C91F115EFAFDFFB837FB1FF68A21A0F26A59989D174FC71383C584AA4080404020201810008BC0C1E';
wwv_flow_api.g_varchar2_table(1810) := '6045AF59DBF6457CAB856EA321DFBD69AF4845C3EEB28290CDB6B51FDE9E192C831BFFF18BF35D27FE7067B73A39682C285DCFAB8DC6226EAB2DAF38FFA0A821160DE53BED466B0E7B5BB0C39FCEC027D9FBBFB68ADB452020101008DC8700DE60761582';
wwv_flow_api.g_varchar2_table(1811) := 'DCE21326E01F5623F7C5D553D640661B1EE6EE727A9F9EAF3C55F9B3BA4C7156985918F7A5A8590813798A5AB29A454420F0BC217010933EF8E8F2BB45FBDDA77E1E499875BAE8E4EAFEF6C2B836996C6B2A393096CE0EDED0EB34C948A4A1B9E6D28DBD';
wwv_flow_api.g_varchar2_table(1812) := '89DFFEB6B2389EDFF8D6D4CC6CD0B75FE931CBB9D5B383A31A9B2C85428D8D751F5E5B3CF8E8D725059EE28E73D0DD3C8BC6D4DDF5FBDF2E1469D7ABDB8F7D766BBAB7697F3555EC5FB8A3F794EC2C2F28ACFB910875B5377B65E7E2E44828146DADCE9D';
wwv_flow_api.g_varchar2_table(1813) := 'DD313A024B3527BB25E9EE02E337E777DFFFD56F6BCBE25DC7EB6B8EBD36B61E599B1CACCD33E6D5764EDC19EE6ECF1F9C33E629CB23C99C2F7EF5FFCDCFD776B6359435F52425CDD0CC5AEEDE724CEE98B83DB3E2DB2848873B4E77990DDAF9B0D1BF36';
wwv_flow_api.g_varchar2_table(1814) := '62AFEA5DF727860607EC617F6757753AA762E0DA583AB42729BA7852EA9F5C0D6C4DD8E564F7C9138AE1DE66E3CFDB4514F6080404020281E70481978100B73717F9D67D39BA547D7B4BDC5A903CE84A04B6D3925C64D3D654373112AAC66DD21CEBCD71';
wwv_flow_api.g_varchar2_table(1815) := 'BB8ED7990B1483D569F0769C08ECCE33D0A8C2A50F749EF66F4D13B71BE59EA66A49B634E5CB39A9BAE7E40A093304020281E7130178261BC2EDEDEDB14F2C16AAECF73E0E0C43260B2E8A307BA7B10C32BBDDAA895FBF519465DB39C27D1BCBB1AB1374';
wwv_flow_api.g_varchar2_table(1816) := 'FABED5F810668319CCC8EE30FCF52B12920281E716818388B4BE3CD5F6468BD6E860EFECDD88E68FEF7FD05EB83FB4EBF0AD8DDA8EFFFCD207FF72FEDCE9DFF5ADFFD7CA5A38521D8FC5D3B2F4F9D8D6EC17BF8F68ECF3A19DD2B77EF4D96FFFDCFBF363';
wwv_flow_api.g_varchar2_table(1817) := '57FE3CE14AEE8463B92929148EA5C7E756AC5228B37DB4CECC13CAF61969ADFE52DF7471DC775D3A631DF9F8A0E5DDB58F7F7FEACDF3EFDF9ACB51BCD74335D1890F170ECCD10579DFD59DBF335973F258163796D24CF1AD2B914AA7D26BFEE41F3FBC94';
wwv_flow_api.g_varchar2_table(1818) := 'D89CEE4BC67FF9EF8CAB0711DFB54FF7E772737BAD29C97528C6FB21B334A73F9ADA1E1E3F73B63A24EB3FFE5D7F55B766642D5AEC1E6C6C3D5FDD71361DFF1DFAFD716960643CB9B1E692462ADEFC9F521A29BC1F4D27E3A194F4BB2B03BD05BB7353C9';
wwv_flow_api.g_varchar2_table(1819) := 'BAE25C674D67D6181111080804040202818722F03210E0CEBABC746D6EC6E521CB06493A75AC29D3DD3C3C3DD5D542DF93F4B6D646121A2ACC92E422D2D958964E971E8AC89D0DC5E9FA2235DE52C50FAB54E5E150C13F110402020181C0631080CAD263';
wwv_flow_api.g_varchar2_table(1820) := '8600C384E19C70518E048AF016228BA0A6E0AD25857DED20A859852422403A29EC77073726D0795605904461E66D26CB6C4DBCBCBC7CF2E44952384527E9FDFDFDC78F1FF7783CACCBC5A9BACD0F3A272626B0A7A3A3033155090A3155A5CA0853296254';
wwv_flow_api.g_varchar2_table(1821) := 'A49A9AB547440402CF2D025A8DA4D11BB777B6CA0F4D5C0EC4166FF5FFF7FFCB85F5C5FABEDFFCAFA79ABC89F07E574BCD7F1CD506576F96559FDD355B2A1B1BFFF13FAD56FB16EACEFE4D78C11C0827659FBFABABEE837FDE39989BCD6FEE8EDF510A1B';
wwv_flow_api.g_varchar2_table(1822) := '1A6FCF7893E9DDD29242B5EDE9946453E4A2DABA8F6FFC6A579FF8599DEBFD84599F089E3EDEF5DE70727AE2C617EBC1773C4167DB7125B2D958EDB1157548D2BDFDBD8E577A96EBBACF75C6F3BB4E5F5F884417874F9E689BDD4E58B5E9DAF6CE7FFF4F';
wwv_flow_api.g_varchar2_table(1823) := '37FF367FBFA8E1BF31C8A69DAA8677DF3CA5CFABA5EF32B4B057A9D9B3159ED89624FD4EE4ED73177E7D39B03D793DBF35D3B1C1F78C6D4B331B0DB6F4ACA5716DFE770D9274EE5CE3A5C952392D455352301EBC78BEE7BD9DB07F6BCF59F3DC5E436198';
wwv_flow_api.g_varchar2_table(1824) := '4040202010785E107819083058D2C93B8AE85F9CFE655656ECA8CCD1785640440402020181C0D74100F2190804F0D05A2C167826115E2944D8DC4825B408A007C2A946549D50505CB853535376BBBDBABAFA830F3E70B95C6FBDF516A72A7145E7E0E020';
wwv_flow_api.g_varchar2_table(1825) := 'A7EC124C7C6B6B0B063B3A3A4AA4A4A4A4A6A66663636372729294D6D656EA1A1E1EF6FBFDF05E847D3E1F3610F00623C0B66DF5F5F5D3D3D358D5D2D2B2B6B63637378786A2A222C181BFCE251632DF3B026EA374FCC4C94F27AE361B2F6B924663A9C7';
wwv_flow_api.g_varchar2_table(1826) := '5D51DE3FB6E2DD8A355416A50D761D8F875E6F32E813B188C76D0D69AD4B73B3E5EEA2E8B2499B8AD6D4E72D1A3C068DAC63FF438D21194F15BA2DFD89DCFDC59986AA66BD942B690FB7AC67AF4439AD91D2278FD5FCFB0FB4ADD681AA7FF8A5725BB71D';
wwv_flow_api.g_varchar2_table(1827) := '8EDDEC1FB206D60A9A6A8BA5FC806FBCD826959615CF6C265151D6C117F6BBBD294596341EC7D5C1CB6D9A784E51B73D37FFE0207CCC6D8B3A2A57AE8CF63616EDF9B5AB63FDCE9633078AE7D2D5BE8E669FBDB26B69F4D68FDA8B249D8375592271F9F3';
wwv_flow_api.g_varchar2_table(1828) := 'EBC3F16DBFABBE74706E6B66E0EA95F4D4F9D289A5E5786A75599BEF50741A5F42BA757364726EF6769FA9A8FDBCD5EE305AED7A2DFEE497A453F7BDDF6FC200818040E0E54640BC2B5FEEEB2B5A271010087CE708C0330D06035413DA897F15A20B130E';
wwv_flow_api.g_varchar2_table(1829) := '854230618E9C321A9914ECB88F00E3A7BD7DFB36057FFEF39F33409AB2B1D8DD2570D079E3C60D982A4BD92F2C2CD4D5D54162D7D7D76FDDBA45CAF6F63647B82B7E6324298573187E0BD7A516C830EC9A74E82E5E6208335EE2C5C5C5CB972F37353561';
wwv_flow_api.g_varchar2_table(1830) := 'D5471F7D64341A61D1C87CE7E8880A0402DF0602668DF4CE6B3DFDFDDA03DFAE01426BC97DE3A76F1C2C0E57984227BBDFF4BADD27CEBCA131BA5E6F4F15EACEDA0A6D1BE7DF8804D3EF1EAF18522EA453B241AF54E5DA0C17CEE825FBB933F5856E8FA5';
wwv_flow_api.g_varchar2_table(1831) := 'D8E13BFD57B168B2D869535DB8F487CEF6D69659EC7C54AFC9351A72AAABF27C3A57753AB5154FA40FFC7B679BF31ABABB355586E5417F2A99369A74CA814686F21E59318B93C6EED2812F1C41FF6EBD5BD774EC8C7779429B4A2764AD2119FAD9EBC7FA';
wwv_flow_api.g_varchar2_table(1832) := '264D91E088514AD71DEF589BBA1C0D1E6CEC468AB5DB8EEA77C1894F65FB91D8EEEE4A43496E416BC7DC5CA4C410084A65F168A0ABB37A3CDE546CB756E4BF09D30D7A037915C5BE40B45A8A9F6AAA92246B4DA3C6E6CE8C621341202010100808041E8F';
wwv_flow_api.g_varchar2_table(1833) := '8020C08FC747E40A0404020281AF40001A09E1C4FFA4925E9591423E21996A16E521AB84A38A106001ADBCBC3C382ACCB9E230E4E4E4A824995C9CC33FFDE94FBD5E6F5F5F1F6551A5BA8B2F5EBC08379E99992105D7715959D9871F7EB8B2B242417CC8';
wwv_flow_api.g_varchar2_table(1834) := '8C94C6B54B459CE20A863C238F5AD2C9C54ED5306C83991FB547C40502CF39028576FDC5B3C7A3213F1D178BD57CD2A50D94BAF472CA64B538534AD9C577B506C3DBDD4E9D5CAED169DE79EB8C9C8C992C56CF1B1713919049AF280673C58F2EEA25FDC5';
wwv_flow_api.g_varchar2_table(1835) := '8BCD3A25A5D1EBDEFAC1055D8A4F4E77B7C360E9CB0B6F3469E58648521E9E5AACB587DB4FBF29C966399D2AF7384FF7769B0C1E9DC1DC66659ED45BA978D46CD279CA0C4AAA9861CB47A1AB2FB516BCFBB6518E19B586B35D2DC1BA12A39C36E94D27CF';
wwv_flow_api.g_varchar2_table(1836) := '741B2C9613DDCC85706A24E54C5749A0FA2D9B41F646E496AE93EA6E46283A75B2A6E74285C3E2D6986C1D55B1D6A27752926237EB5C064B69CE9B26AD6C34EA921AE9FCE916E974A3464A596DD60BAD2C43A034B63B344A66B0890802018180404020F0';
wwv_flow_api.g_varchar2_table(1837) := '780404017E3C3E225720201010087C0D04D292C56C351A4CC110BB92C812D308AD76ABCD62B3DA98AECB923869E9EE1AD1AA2EB82B0415420B2365462EA414272D5C175FAE4A9B1183F4E21686C422A09E9285FF7673731379B7DB4D2211D51BBCBABACA';
wwv_flow_api.g_varchar2_table(1838) := '806A882EB496001B1F1A1AA20A2606B34C17920CC686000F0C0C9497973734347CF2C92754DDD8D88830B92208045E08048CD03F3B1EDA4CE0A970D832032B085A45D21A3363988D7AD86CA6636336C22533BCD462D04A86BB45B4266346C67897F15A4D';
wwv_flow_api.g_varchar2_table(1839) := '7765485483D19059CC399E90C291D8B963C5450D2739EDAE706875E7EDF65C4657A86256337A32AA0EBB50F72600ABB99CE738F02A678249279972322B8F103487C340F4788C2D193F2D561873325BF816641A51C33F02EB94F4FEA4C3E1B9EB94B661A1';
wwv_flow_api.g_varchar2_table(1840) := 'E9DE76C439CE2F1BC2722619C7F5DD60383441AB13033ABE4444FC2F10100808041E8B8020C08F8547640A0404020281AF8140440EAC85E6F58AA9D85DE50D6D6F06964D3AAB4BE758DD5FF08637CC5A6781B50CAA09EFCD2A83D6C25759DDAAB9B9196A';
wwv_flow_api.g_varchar2_table(1841) := '4AC0D30B0766D22F928CA96E6B6BC3CDCB3069782C896CA184BF7769690966CB296E5E182FE416EACBFC5E865833259823445AE5C6F064568DAEADAD450915555656A2AAB0B010160DA966E12EE2F739A5B3B6898840E05546C0A8954E36969BB4E5B236';
wwv_flow_api.g_varchar2_table(1842) := '43A18FD7E4C8556F64373AFA4E91A14FE628CCB0621104020201818040E0BB434010E0EF0E5BA15920201078251088244297E77FAFD71802311FF1F1ED5B468D352DA592A9E4C0DAC70E436E229DB0EA9C8C80CEF25F382DA1BDBD9D09BAB059757F23D5';
wwv_flow_api.g_varchar2_table(1843) := '5BCB2C5F08300B5F4171E1BA387889C37E71E1B2E9D1D9B367710BE7E6E632AFB8A7A787F9C3F88411C09DAB06D82F11706770350A095062C836B5300198236561C24C0066052CE1FE7D256E50D1C8274480CF54870EE4BBC5B4F86C95BBDBFC3EA12621';
wwv_flow_api.g_varchar2_table(1844) := '2E10100808040402CF230282003F8F5745D824101008BC3008A4E59DE0FACCEEC85F37FD72DDBF148CF956F6675CA63C45D21C1876567CB3490641A752D17888ED41A5CC7A39770389D051682D4C58F5C4E2A45567EA720AD765496735828B9815B018D5';
wwv_flow_api.g_varchar2_table(1845) := '0C5F553DB744D4E23067BCCA2A8FADAAAA4235E92824C252586A04BFB19A0E3726974045A4504A15202E824040202010100808040402028157040141805F910B2D9A291010087C4708A4A3B130BC36C754108A05FCD1834A574B241EDC0C2EFBA2DE2A67';
wwv_flow_api.g_varchar2_table(1846) := '6B3C15D9882CED4776A5B4FEE81068AC51E968D62C5681C62B5B5A9AD9A29C80EF17DECB8865C62A33D7574D84B512D438C5D5887ACCCAA8A759729B4DCFCA67538E16177181804040202010100808040402AF02028200BF0A5759B451202010F8AE1080';
wwv_flow_api.g_varchar2_table(1847) := '8EDA0D790E83FBF2E21FF6C33B95CE26BD6C48C8F1642A01E13428468EC864FE25932C15FD783B1026A8324CDC65F4323C96828F2F2572050202018180404020201010080804BE26025FD11BFB9A5A8498404020201078351180DA5AB48E9E8237D7FCF3';
wwv_flow_api.g_varchar2_table(1848) := '05E6F2624B351B842AE9CD0ECFF9125BCD7A604127EF77E55D74E90BD6929B3A75D5D8AF87D45132FCF54A7CCF52EAD2D65923A0EE598FF7D178568088EAA6CE8A1DCD7AD2B85AFBD7579895BCCFEC27AD57C83F1B04F82C34BBB0EBDB5DE2AEF1380CE5';
wwv_flow_api.g_varchar2_table(1849) := '35754FB72A153304E4CC6EBB0AEBB2B37DD9D31A8F867BD3191EAA841B8CC0B47F76497BA8C0838999B90B47ACE20DC07EDE772B22EFCB25046802D64B0F537BB4C8D1F80375DDB5FFB0426A798885D4C2F3C9D371F880107D94D8A1CD8762D95A0E8BB2';
wwv_flow_api.g_varchar2_table(1850) := '739B9229750841364B440402020181C0F3808020C0CFC3551036080404022F2402875DC3742C1AB3A6F2CA3436A6DDFABD615B22DFA2E4D2F74D86946A473BFF4389691E9B213DD8484623B37A336B5C31C557CD65203429EABA566A0AB5B0D8159B0623';
wwv_flow_api.g_varchar2_table(1851) := '46FC41258F4961BD2B865233AC1A7B8E8AD1E565016A125527B33A283A6BC351C9FBE218100E87299BD5490AEB726136F396D98E982363B6A99465A819BF5D5151C1F6C8CC6D468C59CA2CCA45A59C22C31EC52C5BCD299393590C0C49BAECF755C72905';
wwv_flow_api.g_varchar2_table(1852) := '59B69AE6B370972A405D241EB51625B494EA1023C20260593DB494E5B2D55A38521081B9B939E2F8D899538D7256D266F0399693982D2822CF1502DC19972E4F5AF62EE7361DBB39BCF5E3D07649DBB9EC16BE983AB8B897E39F2C6DE97D8CD90CA5B839';
wwv_flow_api.g_varchar2_table(1853) := 'B6B43E7547938E341514A4EBBA72C38BAED2E6C714B92F2B144D8E4FAC8416C6CFBE7B42D2BAB85D3EBDB5509C1EABEBF98124DFEB502DEF45063EBDA231843B6B0B8BEB3AB376862569F9F254DD9992C30D8FFE4277209EBE756334BCB370A2BDD851D1';
wwv_flow_api.g_varchar2_table(1854) := '716774756B71A0A9CA5352DB3DB5151E1FEA7BB73DDF50D8B2BA1B1DEEBFE2D484BB4F74E9AC055915BC63069776D686FBEB73AD55DD3DD36B91E9D11B85866067EF1B1AE3DDCD93100E86E3B70717B4BB7327DF3E15936CFD6373EB73139D65D6CAF65E';
wwv_flow_api.g_varchar2_table(1855) := '49BEB7D0D7EC7A60F8CA35AB317AFC584DC25D33707D281A586F2BCE2D6DEF92E4BBDB3ED1F6A5ADD0D8E0F55434D473AC6E665DEA2C8A2CCBB5A9E9BE445DCB74FF402ABC53E8B0F49CE8D6D9EED9993558440402020181C0F788C0433EFB7D8FD688AA';
wwv_flow_api.g_varchar2_table(1856) := '0502020181C08B85009429954E058301762482F26D6D6D6E6D6FC1A960743B3BDB9CB25751281C8AC5630F922BB899CFE783EEC2CA6835439D89C045A7A7A7112690C29144B4B14312113545850836A88E8E263D1BCF724822504418299C505595CD524B';
wwv_flow_api.g_varchar2_table(1857) := 'A1139A4A590236204944350349E2190BBE1C809DAD9774E8228C970862048A2C2E2EB218356D61676354D104F65EA22C1417F2393B3BABF270F6708200B3B81740914E2994501C424B9359AA3A5B1D8968562B05250AA25FCDE514FEAC82A6CA208C7EAA';
wwv_flow_api.g_varchar2_table(1858) := 'A65E141290C91627A29A47229204BE26A80418494EB1646C6C0C94B2028752E2F07C21C07DB6BAEACD937D5DC7BAE2CE9A3FFFF1E3707063686CBEBF7F60636A74C31FFECD9F2E7FFCC75FFBD667F622C981DBA3C38303B1C0D6E0C4DADEEA343ECA6C63';
wwv_flow_api.g_varchar2_table(1859) := 'B8E8C32BDEF5C10F155919D988F6F77D71E9A3ABFB4B03F1B434BEB229A543EB2BBED0EE4E56FEBE882F185F5FDDBAF1C1ED747497AC918DC0179FDC9C1DBB2AA563472517D7FCCB7DA3A994FACD4B1E5EDCFDE8E3CFF656266352FAE61FC7AEDEE91BBD';
wwv_flow_api.g_varchar2_table(1860) := 'FAB9940A1E2DE28B49B1D0FE765C99B8FEE9D46E7069E0664C49FFF3A5EB07EBE36B9BBB1F0ECF055607A392747B604809ADCF07E4A5A11B3C25590D9BBEF89DCB77D272EAFDCF06F71607FC7B3EDE281FF4AD07D74790199ADFD9599820E2F5C5D6B676';
wwv_flow_api.g_varchar2_table(1861) := '6EFDA95F4A79232929E4DB09CB4ADF1F6FA462BBE8BA33B3E95B9B416C76D6BB76678C471C07F6F05A68FCF627FBD1E4D8E52B9214C9D6184CA43FF86C20E65D00DE5042BA343CB53E7E6B7A7EB9EF8B5B8AE4DF8CC8A3B73E50A468D6719D2D28220201';
wwv_flow_api.g_varchar2_table(1862) := '818040E07B47E0DE07CBEFDD9417CB00BA62AACFE4C532FBE9ACA5B14F5790AE065D70B597F9741A442981C0738E80FA74A89E4C6898D96CE68667175FCC86D1E1FC8456A98FC0439F23C8243E58D8179C103156BDC227C9BB8500CD8319969595E15886';
wwv_flow_api.g_varchar2_table(1863) := 'EFD5D5D541D570BDA2165F282954178BC5F015E3BA5485D94C18D28812581F1AF06A22D6D8D848410226E18385F7529DEAF8C524B8254560AA90763CB1180C2BA68AF2F272982A9C962AD04F3ACF32BB0A63123AD951090E4916D6C26911632F62F4D07C';
wwv_flow_api.g_varchar2_table(1864) := '8E14A48A53A74E5DBF7E1DF60BE1ECEDEDC500382A0561DA2C5EADD648D3288B66D4A28D441AA56EF88461C0889F9986D0EA8E8E0E9548D376D832A8A2848F02B8A355F047474789800030A2935AD4F6A21003B00AB3D9020AB554470022F5D2A007D731';
wwv_flow_api.g_varchar2_table(1865) := 'B53CE7779A304FA391AD66536E8EABBDADF59F3FFDF5BF09ACEDF86D234353EEC074EFDFFCFDDAE64E5E74D71F0A5D1EE98FCEF6CFFB923FEACEE9DF2E3116EFE614B3107AE66307BECB934D6533DE33F5B363D5BD67AFDFF16F4C2E5A4AF394A5ADEEBF';
wwv_flow_api.g_varchar2_table(1866) := 'AFFDD3EDA9C6E2EAF1C14043FE81D9ED7928E026A3A6B9A36CE64F85723AB1174E8EF4DD68AE77EAD2C547393605138954221AE72D6031186677A31F5CFA3CB63DED1BD29FFF6FEDCB0741E79A6F6E355D90AB75D7E2AFCE1846B069A5D7CFB45C5F53E2';
wwv_flow_api.g_varchar2_table(1867) := '9FDFBA3EEFAFB17913AEB39BBB33E1F5A5C68AD396D2E6446232CE5780CDF9F3D596D574EDF4E07FAE3EF523B52CC7E5BD80737BB9EAC4894BB7E776D7271B1A9B1A9BDFBC35FAE7442440EECD89CD5EED88A7A2C162D2B69CACDDFC68584A27F41AA9B7';
wwv_flow_api.g_varchar2_table(1868) := 'A56A39D171FDC61D9A0301BE36B2EACA5BB217D568D8FA49A74D6B1269396DD06A0C76835E9730E7188F8EBB5EDC8F878686BAFF870B57AE6DEE79F79D2EDDC49AD65C32B1E92E6BCA55C267DF98D9FCEDC9731724BDD8D6387B954444202010785E1010';
wwv_flow_api.g_varchar2_table(1869) := '04F829AF04EE087A540FEDD13EA5C6E7B518CDA46F4A97FA291A4B11BAB0F4899FD7C609BB0402DF14018813E4905B1D2EA73E263C3228659F5E8E6A0AB93C44A4C315B3F5C1D3788DE04A85D9C2E8A09D704E58252C0EFE091D852E42F6A06AD03F4A31';
wwv_flow_api.g_varchar2_table(1870) := '5E17960B45A414CA2902F9440911D8ECF8F838CAD7D7D7A1B8C8A80C16A734C5A1B5B840294B5D48E29B25512D8B3C15C19349214026A99481D630C6F9F97918293C96BD9A285B5151815A2491E7A146675F5F1FDA68209412DB683E95623CA6D258B825';
wwv_flow_api.g_varchar2_table(1871) := '5930674A1121A007ACA802D60A9BE5488DB0506AC418CA520B249644E8281561337C1B3D18891ED44E4C4C00082904E4693B4AD6D6D68837343470A41660C46C0CE0149490442DBC97E2F067CCE3D8D5D58566583A0AB19CB6887714F8BC1041F5E2B3FB';
wwv_flow_api.g_varchar2_table(1872) := 'B5434AEDC79403DF8E62D00FDF997F37BE65CBAFA88EDF8EBA6A3FFDF87F7FA75EE3D5950543F1F686FC1C474E9664DE6DE3973F66EC3F56E936D75CECFDEC9FFEDC193B58C56B2AF3B52514B71E20194F24B50A8CEFEE885FB5ACC3AC93CDF90A93F9F5';
wwv_flow_api.g_varchar2_table(1873) := '86FEE9FDF94FFF50D07B7A6172B1A375D8537D328B21A4D6A0D368B57A46238CCF78035323356D15E1155F3215B6E894531D4D97B49AADC99143027CB790CD20CF6EE8D6AF7F78FE44CFED7DCDE2E676A965AFAAAC10325D9C972369CD5A8D06465DDBDC';
wwv_flow_api.g_varchar2_table(1874) := '36B630E88DCF954A7FE1408EA4539BDBEB35FEF9DC8ACA447A4F9F63FFF8E6E8C902AFADF8752A68ADF478947A222EBB216C3768B05FD11A15695D760E7C76A3EBB52A59EFC6E68EDA7CBB35F3F1AEB62627BCD5B21038B00F5DD597FFD8AEF072D3AE26';
wwv_flow_api.g_varchar2_table(1875) := 'B5E94840369A1020F82389DC70D4E02A98F6EFA467C7F2ED65267B45892739B2AD95D8F58D19C408A5EFF9A80F0B89834040202010782E101004F8692E03BF9E74E3E805D2037B9AF22F54197AED7428E9207ED9677802EBE9860294E85C3E016442F485';
wwv_flow_api.g_varchar2_table(1876) := '4200B6068FC2CF0991E301519F1135725F9C53E819BC0B49B5897033BCBEB81F61653C623031BCA3D04575AC2F9AE1C32A63C4990921E46D8313158F288C91C70A3D388779B83EFFFC73C4208D9CF2C431FD757878985326D90E0D0D714412260C758400';
wwv_flow_api.g_varchar2_table(1877) := 'C36CF11853053E52CC4033FE61360AE614BAC83B0D7EDBDADA4A3A8C9A531CAA959595F84E6198584B637120AB5391518B851800E76C6B6BA381A4A8ADC6782C513F0DA0817AC9A26A4832C2A8A5B1AAAB96E6D3761510B2288831A4C078B11C3B09D488';
wwv_flow_api.g_varchar2_table(1878) := 'F1D07B1510D44259018DBAA8852C3E01208F42C081D3529C22274F9E040A8002B4EEEE6ED086FA4E4E4E52239268C0AA4F3EF904612A55CD7EA16EBD57D1D8642ABDE90DCCCCCF0FDD9E3EDB5A3A1D760F7DF21FAA4FB4CEA7B59A64C493EBF1CDA61321';
wwv_flow_api.g_varchar2_table(1879) := '9F4EAFD3A4E23D0D252E8769D11B8BE97081C2C5EEFD5867EE5336E526352D5554BA3DEEC2A4C5AA61C87F4A1EBC333DB3B075AA2A3369F60FD766BBCC2BA55DE78F960DC55313332BEBDE9595F919ABD254D5D2B615D6057C078948E8E82591E3899EDA';
wwv_flow_api.g_varchar2_table(1880) := 'B2EEB7DF62F6AF717BD361B6B96CF68AD3458AA940134FAEEF8563E1A02DCF7154F36A20FE9FFFDFF7CB92B783DABF6EC9D70F7E906838168EAD26AC6EE7E4CAEEDECAEC6C72F558D36E4D45F5C0FAAA6BD75FD5D878E8D2BE5BADDB669B53CCBDA1A815';
wwv_flow_api.g_varchar2_table(1881) := '4E6A77FFB17F76E08FFFE1C7A78F45A249BEBAED07A35125F3C8FBA3C9C9E945C6856F2CCC9A8BF3FFCF7FB9A99FBDD4F993D79391B06C3679FD91B8C68F98C9A0545415ECACD91967EEF3FA74617F5E71EFE59B4B72CC2719339F9308C54EFD407EFEEA';
wwv_flow_api.g_varchar2_table(1882) := '709FD5E309EC27A3BED00FCF376AB4AED5A121291266A9B1C311E04F397C4CAD421C0502020181C077848020C04F092C9D30D529F194E55FA862F41DE9BBD38555AD664027DE955832A5D3DC9B43CEAF1C53F6348A26914C653FFAD265A7D7FB42B55518';
wwv_flow_api.g_varchar2_table(1883) := '2B10780204E0997817F1003FE65B984AAE38AACEC6EC7304798358422FC9E211C39939323202CDE3C5C2298F18C40C3E4C04497CA4BC73A0A03061D2A98E806F93B218000BC5118A66AA80EF3184180D9485AFE25EE61B96CA5A514E295828C2AA371832';
wwv_flow_api.g_varchar2_table(1884) := '4C2998211AF00CA31C1A0C7F8637C272298E30AA682666F012A0148D4527F5728A424C4226FB3244988012082AF41B3D106C183BCC93829055A8359552FCB0059969C66826CE117F323C1C7BB09F1A319BF1E1E8A1F96471A446FCD2E4622D2DA2767CE3';
wwv_flow_api.g_varchar2_table(1885) := 'D84C3A9870D9D449C5A4C36FF14BE3BE4609C6A8AD001C04CE9D3B07A926826D4047596C50CD7E820B2F449F3902FCD8B43695A4F76A961797EA6CD113277FB82CE7565795E5E5383A8F75EBED79E75A0A3602C76CD1EDB77F78515E1FD24849ABC5B833';
wwv_flow_api.g_varchar2_table(1886) := '1B88E8BDF7195B916773A759984AAACCD1D974B53A59AAA92D31196C5D95E533332365C58AB9A038124F5EED9B2BCCB9794880EF290825D38BD3ABEE1AF3C6C266D7B9AEF68ABF5DDC4F1D946A72AB320AB3212FC7ACAD625C742634D7B80FDA3B93A903';
wwv_flow_api.g_varchar2_table(1887) := 'A3216D548CD6E6E2C9A98502A336B7E1B82AA01E7DE1782AB467AA285B585AEF3E5511397B71716DA5A540672B6DB932B657AD3D580F9893216F4232699389E6224B515BF7D1E2154EFDC90B17E696679BAD7E4FE5B9CDCF160B6DC6AD90AE7C77D5965B';
wwv_flow_api.g_varchar2_table(1888) := 'BA73100E6BF6900F4493EBD34BAE3ADBD6F2566E6E34E8DD2A2B762E6C1C54957B35E69C6D6F30AADD476C2F109F989831C9B186CE1307B6BCDBCBB5AB5393AFF7D448A67B23C30BADDAC6377B27676F6A037B55E5F9FBBA3C87C39D549C4DA56E496BCB';
wwv_flow_api.g_varchar2_table(1889) := '91A5F2DA6E29E3B4164120201010083C77080802FCF497846ED3D3177E714ADED74CBAAAFE68627169696175A9A1C096D2648637F3697D3F9AF2EFAF371417149494CB3ADCC519B67C5FD917A7D1C25281C05723A012273C960C0FE6B9787C0184216904';
wwv_flow_api.g_varchar2_table(1890) := 'F5A1401E1A06EF8295519053D2A1B8F061860A338C594DACA9A9811042FFA07070394EF158522332089002D9C3ED492EFC50D54C3A049552B05C94E36E2505CF337C8F82F83F61DAF04302C6C0004967962C7417BA081B4412564929D422490A017B5088';
wwv_flow_api.g_varchar2_table(1891) := '87191934C03F39C554B2E0A8944515C66080EAA9261D1BE0A828C1067442F589C05DD189639696720AB905017261BF68A32C2419CDE8E148A3703B83924A533192749A80E5E4D25E2CC1270C744C3F461823B1815CC48005C3681A0AE1DBD48218F6938E';
wwv_flow_api.g_varchar2_table(1892) := '0DA4032395AA55830F7A809482C445783E11A0B372F14C5D28989B4E26DC7693D9995B9B965C3FF9919C0CEBEA5BF439B61EB769DBF2E31CABFC7A856777234F4EC53D39F61F9ED5DAF4CC9CBDF7AD96D675567874C5F866A5F622A321795CAB917A7A9B';
wwv_flow_api.g_varchar2_table(1893) := 'B55AD30FBB6BF7364DF9768BC9E69CDE0AD6E9F64B581BF988EB982216ADD2D158D6D9926BD1F00DC8ACD718AB0D52C27E5663CA8CD2CF868A129B94CBE2D2997A0BEDDADE935D3EEF9ACBA63549F21B7FD519F21717E7980CAED2AC3C9122ABFE5FFFDD';
wwv_flow_api.g_varchar2_table(1894) := '5B4C1D36686597C97CFCE431DFBAB3A2C8A998731B8AB58D6F9D91D38AD6E2CE9174757535E50556A323FF6871AB4EBAD0DDB0B96C2AC9B3E86D853FEAD6451AFE0147B7D59D9995F083AE32AB9CF1DCDA8CDA9EE62AB9BDC4AE93AC06E33FFCAB53A948';
wwv_flow_api.g_varchar2_table(1895) := '5023A7B46637B6BEDD5BE3D49621966BD3B7B434B86C4A7E7179AEA4184EF74602DBD565B9920EAFF5DDC01539D95AB9E4D46B6281FC7C774243E318552DBDD3014F564AD252FE8977A5C31EC29725C4FF0201818040E0794120D3EB7AD0966C2211BA1A';
wwv_flow_api.g_varchar2_table(1896) := '6AA06F41AF8540D781BE08FD1272F9A2FF60715210A6C34107E5A1B9CF7922337F180DA5681EF9758086335A8F8ED473DE906FC53C2E378E20BAE0DC06284C49CA67A3F3E1E5C9BEB9E58BF5EE848EEFC16CF42731B969776DACA1ACA2BEBAA4BCAE2D99';
wwv_flow_api.g_varchar2_table(1897) := 'E277303340910E28FDDD6FC512A14420F00D11C03B0A377B8C1298123E46182091A3623CF2B035481D590CCDE5349BCB8B2E1BFFCA48B620A5B24F16A5060707E19C10B9AC00119E38C418930C6DA3764ED544981B6FE01B376E30F098B7906A80FA9656';
wwv_flow_api.g_varchar2_table(1898) := 'E3184F806AAA05D1AFE6928880AA0725596B49218B23B94478C91341E0A831AA66746227C690452091C1D5EAD8694EB30A49E7945F0194A805D1499C5F0DC827D4F7A8B0AA87A36A836A06A5885004FD548743985302E9AA61C455790A9242D544082412';
wwv_flow_api.g_varchar2_table(1899) := '478CDA9151E73073D1C9CA9A4744FD8552551D4D17F16F0B01C0C7F3CF6F877A0364D592CE470A7A0E0C0E7A54FF212BFC3D46E6B783F185F1BAEE36497EDC1BE37BB450542D10100808045E6204E82DD01F639499FA139F6D29BFE67409983276E5CA15';
wwv_flow_api.g_varchar2_table(1900) := 'FA517C91E7948FE01C09FCDCD34BA1F3C377790A12E81510F825CAFE18A9914772BC6C4DAF60646A71BFD8EC7516D6BC826DFFCA26C753D2E5D1F953C6EDB23C4F5A63C8AC73C1CD284B56BDA2F3E4CFEFA794E991EABAA6A4243A0D5F89A510781910B8';
wwv_flow_api.g_varchar2_table(1901) := '8F597DCD26518AD7B4FA5D8977B1EA44E51D0D31533590C88B9B381417616803713591236F765CA6BCF789AB0664E5D5E2C833D395AC0773A94595C91ED514F588BC5AAF5A509541B91A51FDAB599D24D2044ED594AC42F5F4A81E35CE4F94EA3DCE4A12';
wwv_flow_api.g_varchar2_table(1902) := '5195AB0D39DA0AB548567F364B557ED466551B0204358E0C0204BCC7C409476B247ED4B6FBB2C4A94000042A732D52EE5F8C3116B008040402020181C04B83C0AB4880A389F4C1BED72825ED6E573821A793F1902F98E334287AAB8F917101EFECFCB6A3';
wwv_flow_api.g_varchar2_table(1903) := '684F10E087DEE574247D91B8D12A55B93C7D8B3BADAE7D83B3746A2B9893DC2C2C28DF5C8B84A2EC1378B713FF500D225120F0A223F020A17A8A1665951081E6A10137E9837AB294389B853CD44EF59EA9C4389B7534F260C1A3B94F177F50E783298FD1';
wwv_flow_api.g_varchar2_table(1904) := '9C6DF26364EECB7A22FDF795E5F41B167F50A1481108080404020201818040E04547E05524C081787A6C7A2EBEEB3D73B2F4C66E9E7E6D2020196B2D497B73CF9D5BA366BD6F77D5A714BD9083B79FC1ED8823CA6AD236D55749390D7F5A1DA9CEDFB157';
wwv_flow_api.g_varchar2_table(1905) := '378D453772125B8D8D4D7BE6507ACB2BA5EEF7B73C03C3441502816780003EC643CFE2FD4ED46750B5A84220F0A220C0978E877ECD7951EC17760A040402020181C0CB8DC0AB488023F1C4DAF2DEC2D27CA36B693476B17567D1DE74BAEFF650857D45E3';
wwv_flow_api.g_varchar2_table(1906) := '9DF634B74B0B4929F51057CCCB7D2B7CCDD6C98A148A2627A6E7D37639B8B93CA33DB0242677577797135B3AEBE4F26AA8CC109498139C19B0298240E065430002CCDC9297AD55A23D02816F15014180BF5538853281804040202010F8961178E5083063';
wwv_flow_api.g_varchar2_table(1907) := '73E72657CAACC9ADB29AFDDD1BB28D0DDFF3CD0D0DFD63CB397BBBAC93585A51AB190BA753DBDF32D22F8B3A26D3312151D2E99848A8810AE833B790460B27D0498AA2D5E92526040B07F0CB72B9453BEE4340F500DF97284E05020281A3083CC558F7A3';
wwv_flow_api.g_varchar2_table(1908) := 'C5455C202010100808040402DF2902AF1C01064D5F28A589EE7BEC152683DB61D1E96D0E3925391C968A7CF7E8C0EEF6ADCB9AE081EECBADDEBF53F45F44E538770B9D96A22293C656A29F0D17E7C9C6D252BB7FCF93586752E2AE1C3107BD2C0E2B38F0';
wwv_flow_api.g_varchar2_table(1909) := '8B787185CD0201818040E0F94480CFAA7BDEA059891A1C39EB5B070E6DD09A53F4A4A6B257D8F68637C796365ADD2CE8E8DDDD73D98DDE40CCAE8F1B6D995D829E2260D8D6B6DF639334C6BFD809E92954892202018180404020F06C1078E566B2B1AC6A';
wwv_flow_api.g_varchar2_table(1910) := '475B89B5A8B6A5D052D070F67885D3925B6BD448271AAB2ACB4A8B5BDA0C7A7D4F47B5BDA0FED95C8017AE16BD227556954E2E042627278AD3DE99CDD8E4E4A4FE60C9EB57262626E5DDD986F28AA4C4D6A3C20BFCC25D5B61F0D320C032544C773C1AD8';
wwv_flow_api.g_varchar2_table(1911) := 'FDEB6860997E3590283C634F03B1282310385C59F1D21793ABB73F9BDA0EFDF1B7BFF5AF4D3C052A73DEC4FFF57FBF377EF9F792143F884AEFFDE1F3BDAD994BD706BCB3379E48DBB63F1ADA5E578BB0F2F89F3E9D09AD8D3F9186AC30B3858697B72429';
wwv_flow_api.g_varchar2_table(1912) := '944D512391B474B96FE8FDF7DF9FB8F5B1946269491104020201818040E05B43E055F40017BB8CC527EE6E6F509B41D2CCBFDAD2028E5D8D6592C49F088F444023A74ED4956EDA7552325257ABA4D2ECC292AAA996F1FAC204CC3A25BF203F99A24B2008';
wwv_flow_api.g_varchar2_table(1913) := 'F0233114192F0D02705AB6046753226E7EC82D6B0E7354C3D138B99C225C5A5ACA2EB82F4DF345430402CF0C0188E2E8F89A3367647C3BCFB63566CDE98EA7A5B5D5752911292D74CB06FBF2C67E3ABC5BE076C40C39073B1B8944DC904E159416CA1AA3';
wwv_flow_api.g_varchar2_table(1914) := '6A24BF49FD232B0B53B7AF86A58EB3AF055215B7FAC7DEEA32C5E3723C29AD6C6C153AF4119D33B8B5EACECB5DDE0D29C1DDC2028F2F6554821BAEBC1249BEBB75F64E20F6E1D5DB057B13E5C78E5755952FEDA77636E7E5747E222DADEE06A4C0865667';
wwv_flow_api.g_varchar2_table(1915) := '364A717771F9CCA63FBEB3585751A0B1785676FDFB2B73E5F939D682D2838380C3ACF525749A847F713BF89F3EFC4C399E5F9C5BED2CA9C8E279909086073E2A72B8938E4CE7440481804040202010F81611781509F0B708DF2BA28A798F6A50DB6B31C8';
wwv_flow_api.g_varchar2_table(1916) := '3595A58F6A7B324947859EC6BD0D391F2529D205022F3A029148C4EBF5B28B2F0F08BC9705A239AA64989D66B371D82FA748EEECEC3C4880111B1F1F6F6868A0B80A0829B894E1D5A8BD0FA2C1C1C1AAAA2A9BEDE9075BC2C3979696CACBCBD17F9FF26F';
wwv_flow_api.g_varchar2_table(1917) := '72BAB0B0C02EC1DFC4B06F52BB28FB2A20A0D5EB6ECDEFEF47FFF43FFFFD295351E395D1E58389CB2B07F26B95A65465F7D88DBE8894AA36EC6A9ADF19F9D37FA9696E5A5ADCBFD89DE3AA399B8C462D664350314CDE1E387FAAAA7F22B83B755BD35891';
wwv_flow_api.g_varchar2_table(1918) := 'D90E5A96A3B1784452BEF87CE4DDAAF06CEEB9DD2FFE58DC76666A72361E0F37BBE2DB053DD6D93F9CF9D97F9725C007A1F8F8E48C776F4271BBABCAF2D7F61201E940D2E40593D27FF9A4CFE31F33C87269DA5EF863E7E56BD7E2DED5AD654753CFB9BE';
wwv_flow_api.g_varchar2_table(1919) := 'CF46D2899DBD39B9F3826E7874A3B7CE79C79757E2EB9B0F78A6C6C767ACBBF646B3CF52307BE73ABB2854B8D3A6BA33E1B02F61B599ACD6B4A4BDFF45F02A5C6FD1468180404020F09D21F06D7680BE33239F3BC5F44AE93BD28F7CEE2CFB0E0C52C776';
wwv_flow_api.g_varchar2_table(1920) := '46A3513AE54FAA1E88323D0C1104022F2902705D5E0510BFFBDAC7C3A23E2F0890C59197068FD2435F1A645DB972A5B6B6364B80918712D7D4D498CD99F129474356F3D1C4278AEFEFEF8F8D8D41809FA8D4570A0F0D0DB5B5B50902FC95400981A74340';
wwv_flow_api.g_varchar2_table(1921) := '6580E14822160BC4D2B17032F5DEA5FEA6C4B0375D3E93DE995B9192535F28651DDAD082C6B9BD32D97FF19DF3D767926357BEF068AB834BF35D9D55F3E9FCBDA521536F5138951C1B1CA9AD7F4756E4685A333A3DF57AAEBC13EBB93D7075C6632F8A6C';
wwv_flow_api.g_varchar2_table(1922) := '7EF8F9947EFB7ABAA86E656FB9B8BCCB98CFC3726FBE98DBAAAFAEAD29DB0956D737CB3A4B455E6AD358160B6C4793D2DCDAAADD261923535BCB1D5383D30BFD5F18EDAEB86F5B53D260D9B959FEFACFFA3F192F5E5E5E5DF7CAE5CAB22FC7B33553DBD2';
wwv_flow_api.g_varchar2_table(1923) := '965B5ED5D259EEF4944FF8E2B7FAFBD80E5C53953E5EDFD3D2F9E6FEDEE6B5CF278B8BF30CEEC3F16A4F879D2825101008080404027F898020C07F89C7D73EA3634A77F66B8BBFC08274CA8D46A33A9EF3499B41CFDE62B13C6929212F1078811050896E';
wwv_flow_api.g_varchar2_table(1924) := 'D660F594232496A3FAE0A804F841F6EBF7FB6FDCB8C133B2B5B585707F7F3FECB4A2A2C26432FDE637BF397118464747C3E1F0D9B36761984D4D4DEA4725FCC024F26CF2225A59593979F22491DBB76FE3648685E6E6E6C2A8A9DAE57251845AEEDCB9E3';
wwv_flow_api.g_varchar2_table(1925) := '70383A3A3AF47AFDC8C8487E7EFEE2E2E2CCCC0CCE6414565656F2A16A7878B8BABAFAEAD5AB9058DCD4F5F5F5707B6A21701A0A85B0A4B3B3736A6A0AB594E50508F3E7D3185967CE9C09068334817A917990B767F1111181C0D321C0F7D7442CD153ED';
wwv_flow_api.g_varchar2_table(1926) := '9AB49D7CEFBD3FFFD4DDE40F04EDB664755BA3559F1CECF3BA92B1B6BA62A39CBFA4356A14855B3DADD36AE23A8BC9203B6C69ADE1932B5335E6BDE2CA77AAD2E1BE9BBF2AF1AE2618AF947952259394EC39D5FCA7FFE37DEBFC073FF977676FFD3E51A2';
wwv_flow_api.g_varchar2_table(1927) := 'C41A1BABDC4AB1466BD0194C476D769A758505A53AEF14F7795A56749AB4C668D9DE5B310403EE1C6B5989CB1DDB5A59F3246391027BBAA4B6B6D865DA579CDA74D462B34592EC11988CC774CB1BBBCBD3D16E3BE3B7F34CAE7C8B41AF35981CB2A6A6AA';
wwv_flow_api.g_varchar2_table(1928) := '2A999672F2248346EA6869D90B94FFB1EFB7C9D82EF3B48EDA20E202018180404020F04D101004F829D17B6A4EF894F57DAFC5323FF34FEEFEC564D555FEBDDA2E2A17083C5304B8E755EACB23A33E354723E466AD211D5EBAB1B1515858087B84CD4283';
wwv_flow_api.g_varchar2_table(1929) := 'FBFAFAA0A6172F5E84BE663AE6CC7B1C1D9D9F9F2F2A2A9A9E9E86A97EF4D1472CB77EE9D22588AE4A59290537EEEDED9D9D9D25852265656510547CBC9F7EFA29C3B329B2BABA8A429836149761D8DDDDDDBFFAD5AF60089C4E4C4CF080C36619174D16';
wwv_flow_api.g_varchar2_table(1930) := '0C1C49F4E07F2605BAEBF3F960CECC5E8669C3A519F58DA9EFBDF7DE1B6FBCF1E1871F928586BABA3A2834E938AE5B5A5AB26D141181C0B785004F4E51A1A3CA555677FCEC7FF9A759DFDCC85BE7DAD3B37B692955E8D09D3DDB3DFFD9AE948CD9ED0EBD';
wwv_flow_api.g_varchar2_table(1931) := 'C6EC0DC6FBFB0673128196D3E7F2CA8BA4F222D694F26F8FBEDDDD70ACEB84B62CFED1F47032B057555164343BCA4BF235D6744799E5A382A6EAC49DE2AAB6B367631B831BE978CC51E818F3C64DD303F5DDAF1D6D4881DBFED94E3272EDD30B172E5C9F';
wwv_flow_api.g_varchar2_table(1932) := '092A2BB7070EBCC772E7CAF2DC0EBB628997380BED0D1D950307ADC944CC6370E517E57DA4695EFBE8A31C633CAFB4DBBE17BE3C704917B79ACBF374B254999BFBE947B77A3B9385EDA78D3D3D4C21B21BA5B064BC76A73FB432D5DDEAD43B2B8FD62EE2';
wwv_flow_api.g_varchar2_table(1933) := '02018180404020F00D111004F8E90114837B9F1E3B515220F032227094F11287C16603E490F8D197063C13AE7BFAF469FCB19F7FFEF9EEEE2E8CB4B9B919F289C7B5BDBD1DAF2F1414BA8B0F16F209E385C11E1C1C405651857B787979995C882E2BB143';
wwv_flow_api.g_varchar2_table(1934) := '71E1B18D8D8DF0619CBACC283E75EA14439D038100EE62183505A1DFD4989797871E0A521DE4162730FC19672FC4F5830F3EF8BBBFFB3B2C472147C830065010460DC58512FFE33FFEE32F7FF9CB8C6F2D9D3E7FFE3C6210603CC0AC0486720CA3390683';
wwv_flow_api.g_varchar2_table(1935) := '013ECF27429CC3A8A59938B45FC6AB2DDAF44C11A0B372E15C834757E4C8B7FCF4AF7FC698E5D292FA5987468A871C39F65305656EED0F12D11D578E35EAD59B4D4A7171416B8323AFAE49B592A9383FEAADAFCAA9E6B43647A7F9AB1FE7E5197FFA8E27';
wwv_flow_api.g_varchar2_table(1936) := 'A7C0FEA3D70B9D8EB4512BFDED5F9DCB4DD46B0DF9E7BB3593F68BA9F0AECDE16CCDF56872DE9264DDD1D6D615DBF64E9FB4C73665ADDE634BFDAB930DBAB4EC76582F7614B140A42E5DC074F8BC2297AFED7464734667B5153BF51DAF9FF52D0C379515';
wwv_flow_api.g_varchar2_table(1937) := 'D89C455D9DF105B9B53BD79E5BE440EF3BDD8D4B8688D1EEB019B4B6D2BBEB6B8493526E8E1D76DFD15EA735E51FAD5DC405020201818040E01B222008F037045014170808040402128410143866192F11528E9E12870667C1226EB7DBA1BB9B9B9BC4A1';
wwv_flow_api.g_varchar2_table(1938) := '910C81868E12D7E97408E30D867CE295855B92A292612834B5783C1EABD50A4F26C033E19CF067BCBEA4C34E9D4EE7DCDC1C62904F4EF11BEFEDED91C8886574B6B6B6A29071CE8CBE46FE17BFF8C5679F7D0609C7C7AB26C25DA90E3B3186085E5FD82F';
wwv_flow_api.g_varchar2_table(1939) := '470CA02CF630049A00ADC577CD114BA80B9D0448382E621AC5D06B3CC3C5C5C5547DECD8B16CAB454420F07408E001AEA9F048127F52474DA124F12775B63666B5B5B53053973F292FEEEF3AD6D9C55DA7B1677371B47634DCE596268DD4DC544196C395';
wwv_flow_api.g_varchar2_table(1940) := 'C9AFB7DE5D98BDBD0A9E99A19A66ADD49911E0EF30E4DE7F03A3E17C1755676A3F59EB906AEF12D48C7199E0711C2E0B70B2B94CE2EF3074D6E44BFC1D8612BBAEE45CAF1AE758956FADCA3F9B3D55235471AAE36E15F765895381804040202010F88608';
wwv_flow_api.g_varchar2_table(1941) := 'DCEB8D7D4345A2B8404020201078651150D9A6EA9BCD925EF8A79A4284448E47F181E8C227A18BF84B7B7A7A70CCE2CB854FE2B985B5E26E8573E2D165EE2E03953955BDC7B885A1A9D04B544150A1D07051223869294E1C1FB25A0AEF2E9A11C6554B5D';
wwv_flow_api.g_varchar2_table(1942) := '0452E0A88CA6E648BD44D459C11C99F10BEF652E31DE667CC8584B7570663CC9E442B3311E9A0D5B8612A313FF3306A8F384712633EB9845BC702C437A298BE397EA68054A08475B2DE20281EF1A81F612D3E91FFC5C924DDF754542BF40402020101008';
wwv_flow_api.g_varchar2_table(1943) := 'BCA008080FF00B7AE184D9020181C0738100D49700EBE38841440830CC6C22714820C3925581A346E39B855B920B5724BCFDF6DBE4E244A508DC18DE8B7315DF2CCC1376CA6C5E6460B31C59680A19882E3C9322288173FEF0873F240E0B85F7A204572D';
wwv_flow_api.g_varchar2_table(1944) := 'BC14B24A2EAE5A2461E3A84512B1AEAE2E4EA1B8C4A1DC682342297259490B3AAD8A41770964A107310428882A5CBB24326A9A5CE837C521F0B1580C97328C9D39C61487392349D5488A2010786608B870E09A2B9E5975A2228180404020201078E11010';
wwv_flow_api.g_varchar2_table(1945) := '04F885BB64C260818040E0394200BAAB725D3582659C66038990404EF1A0121EB41BBA984DC49D9B8D432CD52C9CBA6A223498887A5449A9CA5149A40A8ED9E25404DF269719B9B065B2E0C01C8F86AC3089AA362230584C8515E3E0552971B6082C1DF6';
wwv_flow_api.g_varchar2_table(1946) := 'CBA96A809AAE16547DBCAA0D70724ED594ACDAAC121111080804040202018180404020F0BD232008F0F77E098401020181C08B8D00AE5408276D80EEAA011A498414B8A84A86D5F467D34E98F36BAFBD46BD38909FA8460651E36786BE3EDDB255506EC2';
wwv_flow_api.g_varchar2_table(1947) := '13D52884050202018180404020201010083C63044467E519032EAA130808045E2A0454660BD1CD525C95F4AAA71C21A2A4E020E5F86C5A4E5D0C847E8ABAF0D90AB7ED53E0268A0804040202018180404020F002212008F00B74B184A9020181C0F38880';
wwv_flow_api.g_varchar2_table(1948) := 'BAD25596F16623D89A8DAB91E7D17A619340E045408019F6D1685C2B27B57AE393DA9B48A5639188C9A89315D1E77952F084BC4040202010780911103F064F7951F1F7D0EB95A4CCCA315F1E9F529528F682201091A40D26783ECC5A6660E64A12DDB287';
wwv_flow_api.g_varchar2_table(1949) := 'E63EACC48B99C60057757AE78B69FEB76F3513655566CBDB40F5F452C783A49714D211F8F62D101A0502AF06023C429F5D9DA933AD549E7CF3EBB77865CB976B8CADA66CC31F7CF4A377DB34B6F2AF5FD61F8C69C241B3E7EE24FC9D60DC25F93496CC06';
wwv_flow_api.g_varchar2_table(1950) := '4791A414F0EF799C4CE07FB245CEBDBB21B33E61B06566FBEF049396C4AEC991F7F54D7A22495E37DED5839C02A3A4C92C1FF0A8C0E48DE0F68E33976502BEE56D4166D60FA2EB73B5B5657ADBE1AE508FB2E06BA7C724C9BFB4EB2E03F67B7DD7D59DD0';
wwv_flow_api.g_varchar2_table(1951) := 'EED2545D7581D151F0A026AED48ED75B92639194CC6A084F11967603A53649D65BB95E8BD3E3258EA4BBB26D667235DF18759567B6957E5488A6A5B9F1C52247DA515C81CCC8F26E7267A1ADB15236E62CEF04F716A7EA2A3C2677E9D1E28C111A99DB28';
wwv_flow_api.g_varchar2_table(1952) := '37059C8535DCF0B32B3BF1DDB986BA1AC574FF220E474B89B8404020F01408DC7B893C45E157A308AFDCE883149775560F9BBFCFFB8A1EEFAB01C5ABDC4A7A06B0DF3E26753E8002DD0CA8EFFFC82E9592C437919739B0E5ECD1C5935EE6A67EEDB6416B';
wwv_flow_api.g_varchar2_table(1953) := '1FF40053FA3E1AAC0E81BE6F65A9AF5D89101408BCEA08F0E6BDD63F6F710DA804981FDD7D6F404E469C4E9BAC35441292FFC06BD6A6B41687CF17D0A4130EBBD997D4FFF6BD6BE7EBC3E9DA73FEDD03594E469319319D9C7238EDD1942E1AF225E229A3';
wwv_flow_api.g_varchar2_table(1954) := '22999CF65028A14DC70D16567A53BF6B4B4B2BBEC4EC4441578DDB610B4BFA4B7DB31D9AE1BCDAB356B77B74697F76F4F2B9CE66774EA16C34F902B144E020373747D61976BDE168D8EB7198F51667222D457C7E8BCD282B99A5D483F1F4EDBEA993AD56';
wwv_flow_api.g_varchar2_table(1955) := 'C9668FA7A5C11BB39DE5FB7A47DEF6AE4F8AFA3D2EABC6E40845127E9FD76E92CD360F3F27DB9B5EB31471E4177AFD61872191D4DA42FB3E87CB2CC9F73A6F9194B4B7B9E1342926671E98B81CDA70C2908AF87D69E5DA6FAE75FD20CF935F6C7142B3EF';
wwv_flow_api.g_varchar2_table(1956) := 'B60B4B02D1846F67CB66D4597272667682F37FFEA8E35CB7DBE536585DDBBBC164EC80C5F3729C7649738F344612E99DAD6DB75531D93D9148221C8F4503FBF9B9CEA4C6BCBDBBAFC4831E975D63B44138F7B6B7CD9A84D393BBEB8F8E7C3AE45642051D';
wwv_flow_api.g_varchar2_table(1957) := 'A7F9995CDF0B18123E776EDE51E331862BBBB9EED56922B91E775CD26F6D6C5B8C29674EEE7E3825450E14AD9EAB69B1B35EBD3CB614D48DDE76959D8B84A2FB01BFCB209B1C6E5F2876FDF6644E6AB3A4BB805AB6B6FDA9843FCF65C318944F6CF9FD13';
wwv_flow_api.g_varchar2_table(1958) := '03C5AF9DDEDB0F4582FB6EBBC16873C723B19D70D4140F3AF3F872ADD90B44E2BE9DBC3C4F28A557620193D5EE3D0839CC92A2336FC7D27706EE949DA99524EBF0AD65DFFE544E85CD25A5D7B60FE616C6CEE8939682BA18D7FB20ECD2A74CAE2FF7813E';
wwv_flow_api.g_varchar2_table(1959) := 'EC0A4C2D2D5DBF7CABCB1C3EF6F71513EBC1F13B9F27D2FAF4EA7AC96BA7FA3F1D5674FB5B6B6317CEBFA1580B7DC1884597D6E84DA38B3B9706464E18E74FFFA86A6E23387AE57AC21C09FAD67A7A2F2634D6B08F6DEDF498C5CD1FF4872D99DB8ABE87';
wwv_flow_api.g_varchar2_table(1960) := 'E40F444DDAA4D69859A4309A48C54341AB8D3B44934849E1A0DF7A2807327E7FC462C8D4829808020181C0BD77A8C0E21108DC91A40FEFCBC291138D862C169D2C6F4AD2F543027CEFA7E53E6171FAB220702049AB0F23C0B48FF996FF96F5718FF6305E';
wwv_flow_api.g_varchar2_table(1961) := '9656DF6B074CEFCBEF3EF712450C5808D05D3502206A244B80D5537502B020C0E28611087C7304E8CDDF9EDAD81C1ED03A4DF9E978E5C9E31F0FAED98373D585B9B6AAD6C9B995ADCDF57A5B4CAA3B71EBF2AD8264BABAB8C5A8C8518DF1F2C0847E6F72';
wwv_flow_api.g_varchar2_table(1962) := '2F6D6D2F94839E63339FFDDE595CB1BFB27AF1EDCE4F6F252AD233AD6FBD9B75EA6EF9E25397AFE625761B3C92527EEACAF5FEA8B6BF396AAFE93DD137343176F3AA2B1EE8397E722A6E5DBBD32FA79463353A53CDEB573EBFAE517CA7DBAB20C0BB51E9';
wwv_flow_api.g_varchar2_table(1963) := 'EAAFDE7FF76FBAF48E8CAB706E2B105ABA6D38F50EF18D83F8DEFCB0B1B915FA3738BD1ADE18AB2EB056B49EFAFDD5294762C114D19CB8706261553733755B170D1E3F5E3A11CACB0F4E058A3A9263FDC7DE389396155E34B2A2C46479786C6175F68E4D';
wwv_flow_api.g_varchar2_table(1964) := '9BEA39DE3830AAB438FD03FAC286F8C2B45278F5F295A4B3A8BBB5A6B2E302C3507851298A9C9094CB0373F18D818692E2F29C13FD132B13572E27CCA9DEF6FA60A265E88B6BFBC9A83334F393BFFE7BC974D7731B4A48578667FD2BE3F47ACE9C6CBF3A';
wwv_flow_api.g_varchar2_table(1965) := '9996BC7DFEA8F678BECB7DE2D4C0C4727C7BAAB6D851DB71F6F6E4C2D6FC58954BEF3C75BEBAD03E652AF16F1CE0999DDAF48FDDB9218503DDCDA5A5B56DAC3DAFDE065CCA9BD31BDB77069C6ED979B6F7F2C4A66F7A50A74B77B534FE61D66FD91BD6CB';
wwv_flow_api.g_varchar2_table(1966) := 'DABCA4E1F4DFFE309CB64EDDE83B5596F426B49FFDEE53C5117525C2BDE74E14B9F32C259581ED3914CE7A63C39F7C61B125CF75374180716E0F5C9B395F1A4D2BBA99A5B595E93B0556B9EBB553973F5FF6275775A1D8999EE298BB6DE07A7F24B0DE5A';
wwv_flow_api.g_varchar2_table(1967) := '61934B4EEE5CEE2B38D3393830FAF6F172C5593632B9630DAE46F5C76EDC98F9F4B7FFD2D8A037D6F76825A5A1BEE4D78B5B65D30345B9759FFFF90BD6FEB3C5023D6F9C185A4AC6F6E6F569A9A9A9027E2AF341616A1EC306AF2D943AA23301F7E7572F';
wwv_flow_api.g_varchar2_table(1968) := 'B5E4E7B8A2E3DED2DECF7FFDEB930D95B6DAC25F7D71E7AFAA62EEBA737C68D75B5D2BEB37F919F96262BDDDE4ED93EB363EFB55575BC7B6C9FAC9AF2EFDDDDFB64BB6F2705A7AFFFD1B6F9FB0DACABB01F0B71F8DBF5EBA55DCF5032A1A534F60930000';
wwv_flow_api.g_varchar2_table(1969) := '400049444154DD8ECE5F7AFFE77FF7034976AE87A52BEFFFEE176F9F916D65DC66FFF2FEE08F5B22AEA6D754E4C55120F08A232008F057DE00B724E97F7B90D8F043A2D3417A710E87BF52851078D911E0832CBF5C8C857BC91F28B8DCCB7E299FAC7D10';
wwv_flow_api.g_varchar2_table(1970) := 'DA4824B2BDBD7D7415685052D92FBAB2349838FE737553A227AB43480B0404027F894020257DF8E1B513968554F5C53FFCC7F75E77186EFD69E05FBF5B6B71B859696E65D3373C36B5B33FF7664BB35131795C5A9F649CBE33B6B4D3F1F1879FFDDB73AE';
wwv_flow_api.g_varchar2_table(1971) := '097FD9171FFC3F8ED7F3666F7E7AEE1F7EF9CF83D32D15FB7AFDEBDAD45D56A6D6C6CA75064DCC56503039F22F27EABAF20A8BCBB44B39F9053A8DBEA0306F3B3F2FBFB44C6FB28E4D6E7BF6168D4DBD63FD1F94171C1F1FBBD95AED4AA54A51C2EEDA3A';
wwv_flow_api.g_varchar2_table(1972) := 'A34186AC4A122EDFC9B1C9E30D668D2D8FD7E8C4DC6A6D45D49C5776104BDD995C8CAD4CACCE469CC5B5D7C627FFABD3AE8F6E2473E7273FFA6C3BE21D0DC4B525963957DB3F7CDAEFD50DFEE64C676D24ADBDD63F9A5A9FEBED69DAF3D4FEE9FD0F7489';
wwv_flow_api.g_varchar2_table(1973) := 'AD6038D254E0B3E6BCF9BBCF6FC98E1BDD675E2BD45A739D05E565C55657414292AFF7CDEF6F8D9F6A2DB596B65D195EFCFFD97BCFE0B8B22CCFEFA4F70E99402291F0DE108E006D914553AE6BA6A77B7767A267B5D32B6DEC6E48B1DF14923E2B3AA4CF';
wwv_flow_api.g_varchar2_table(1974) := '922256BB8A8D0D6942A18D9D594D6CABA75D992E6FE81D0880000810DE7B9F09A4D5EFE1B2B250208BC5623992FD6E301EEFBBF7DC73CEFDBFC47BEFFFCE3575E6C96449315BB4450BBCABA1FC6871A9DD9577712E36337C792BAFD532DF23E6CFC3BF8B';
wwv_flow_api.g_varchar2_table(1975) := '9BC93B5DBD279B0BAE4C64EAC66EDEBE5BD4E99908179FDEDD4A6CEDA46EF78FECCEF52F4F267D65CDFD7D5D87CAF37DBE0011C890C716C82F3418A6E9EF6F3EEE4F0EBCB79AF678D33325354D3902BC9E96BE2B375ACB9DAE40605DACFD7FB87DF405DF';
wwv_flow_api.g_varchar2_table(1976) := 'C092ED7A7777D754ACCEB2E6D8198D8DD7BFF0B38DE915A32BD61F69FCF1F0AE0C7FD277E69F1FE9BB3A5E3772B7B02D1A2C2C94D949401E5DCB8C0C7CD27AB83993D546634D2C263C8BF72AFEE4E46EDA34303C35D9DFD7BFB251DB11B9FDC9D40BE793';
wwv_flow_api.g_varchar2_table(1977) := 'E399E8F00737270F877ADEFD75CA1B90D9B9137FD5762DE6BEF9F7FFA1BEA4D860ADDFDCCD4CF70CBEDE594E947B66756B3B3E6936D6D8EC4E2EE7C2AE21B1BB687738D7D23274ABFBFC8FCF74DD59AF18E9E91AF56F8D5E73A5A42662A9A93DD9572AC6';
wwv_flow_api.g_varchar2_table(1978) := '7B0C12948DBBF3DBADE6507A75A1B4607C62AED0B299CEEC866CC55BEB09E2D476DE264DBC45C8A1B2D0E0B63DB5FC2104787065B3C91473A6F9F538933B3B0687D8EC1631F29AA185F26D569A68EF1BE4AD16A626DDFFE99A8D069BD5A6FDF2F6DE486C';
wwv_flow_api.g_varchar2_table(1979) := '4C98DFFBF971BAD7E4391FA44637F5A423F098083CE7EFEB8F89C223C5A0B88C737E48525CC06890CC372005DCA6949E5CE62196BEBDA26FCB8AF6F559BB5D7F9E1E2CA1EE89CDA98626A336B81C8481686F12E5E7E61E9AA3150961326C8CCA65C9F0D9';
wwv_flow_api.g_varchar2_table(1980) := '73EF09013F550E2382AB396D9AF2BD269ADC5EA261AEF6B3B2AFFC7FCFB026F50D7E0A5F69441778FA1060CD64A86F7777B70AF3E63E10A84CEE480626ECF178729BFA3E7D5DD13DD21178DA11609805D30DF88BDB15C3F2C27CC95173B2B27A6537B5B8';
wwv_flow_api.g_varchar2_table(1981) := 'BA92999FAAAE386BCD2B7BE7F6547AA2BBB0A478667420DF95B47B434579E905973F934E31EE37B6BC58595A7F67A57CFAC32D6F2AE17364EA6A6BD2AE8B9BB39391469F3753A41E170A08533ADD58525E7AF4D8C5FE5F45BCA6686D6D55BC3752DB60B6';
wwv_flow_api.g_varchar2_table(1982) := '986B6A6AE6C6C2F58DB5664781233BDF5C59B451DFD077F38D767BE6E8C9CEADC4CE547F4FB0BCD56E3245CBA3468BB61BD9F06AD2B0D41DFDC94B98584FC9D240EF0BE7EBC5601F5C88DBA6AF97B61EEEBF782995D8F278ED879A5BDEEA9ADEDE598EAF';
wwv_flow_api.g_varchar2_table(1983) := '4D3757E54B5E55B0D4610978B6130ED7426F7E5187C16031F29033997898C59292595D693B51CB10594F4141D0EA5BD8CD54C6E7FDC1FC8037FF7AB0BCA12AE22CACE3A9481313F15F83C16C94136D15C94D53CFC45C63C362436DF18237DAD45865B5E7';
wwv_flow_api.g_varchar2_table(1984) := 'EF4EAEA66437624B9D3CF7BA583C6BBB32D275A3BDA56437E537C4365B0F9DBCB4108FAD0EB80D91C6BADA82C68EDDEDC495A92DEFF26D67F391F99B9F6EEF30CC78A9B9E198C551C448DD642A9DD8D94DDA13D9746A7D71A5336A31863B4AA32EBE140F';
wwv_flow_api.g_varchar2_table(1985) := '2FC4D393B76B3BDA63595B7C72E6D09F9C3179CA178DE6F4D25A4B4BFBF81DDB625F4FD0E7AD2AA9F7C696C667A23CCCAFDF9D38D6103479C2D9F574B1C5D97CA8B9A77B2B1D8BA7D299C4EE4E2291CCA493957E8BE1F4A9D5ADC4FC606F59415D7FEF50';
wwv_flow_api.g_varchar2_table(1986) := '7B8D59EC91B9CDECDCD4EDB6D69A4FDEEC4EEEACF853A6B6A6F2E599C2F8D0E5A5B5DDA82D1BEE3852ECDAF4B9DD597F6865643CDA5C65B2FB0727360BE2837925FF80E77AE7D1EACDDEDA932F1CF544AAB89AB787E79A3D6BA5357F3296960AED921DBA';
wwv_flow_api.g_varchar2_table(1987) := '34154FEF2EF8DC618BDFEF4C33E3D88163BB895D9E1038160FFBD6262F549FFCC9E0E2061BAD0F7CB4F952877D3EE8B7DA2D282F0B076C6EED652595CED293EC6E329D4AFBEDD6A9DE99EA3F3D3F30E616B39181FA25E54562D206304382A3C5F9668736';
wwv_flow_api.g_varchar2_table(1988) := 'B59BE6A551BF3DA07D6421F9EDA6741970697CD86192E2E262316B43A3A92E2B0E58BD5F6F633C4DA39E74049E53049E76020CFF995F5ACB6CAE1614062D0E6DDD885C5ADBDEF1734BD89BA3B29DC86476D63D5E9646B87F17C8891DC8689322E2DB1E87';
wwv_flow_api.g_varchar2_table(1989) := '368F622B9E34A5E2068B9D19261687768F7858CA719B875452B71A130F5FE5F680E414FA94CE880956FC455AF590C67B77AEADB8B8B9539999C5212E47EE53DD43C5BF69217DE7C541BB677E05485F61286B90D88AD8BD5A6755A2B3BB2B4CA3FABC2150';
wwv_flow_api.g_varchar2_table(1990) := '30FA28B52D766ED78F82F0F326B91C1F14E25BE274C9F89CF86CB2BAA11DFDE1FB5F0A72620732BC0C6CC6C49C129B9B094EB2BCD7D61F1143461206D95911B74F739829DDDBCBE2F70BBDE015622DAECDDF55AB8A6A6E9A646D89F9597CBC3EA05E3FD5';
wwv_flow_api.g_varchar2_table(1991) := '11780802369B8DBD7389EB7EE5D8663830EF3D3A017E08887A918EC06320C0FD3910704F6E9AAE5DBE5C1609769E3AD2357CD578F1E2A943E1C6FA96BEC6F885CB77AA2A12CB9B8E9DF5B940A42253986FCB9A2B3B6AFA67AE068BA77D05A19280BBBAFD';
wwv_flow_api.g_varchar2_table(1992) := 'C8E55B63CBBB89A3C7DBE281702298CF07D3709ED7E2CFF40ECC57A77BA2871A730F48B7D5E80C314754DC9E90648CC579E6F7DF8835A4DE3D7AF6B8CF16D88ED9DFFFEDBB274E1D4D9BCC1F5CBB67DE78B3A9B93A69706CA66C7786A7C2FE251A6E2619';
wwv_flow_api.g_varchar2_table(1993) := 'FB7AABA9D195B1E5DFEA1F6B8ABA4DAE121E975D63CB11DBA6338C2D9E4A5053A32F2B452525268B7D7A75E79DDFBD5B93B654961D99EB0CA7D6BB9CC6545E51E9C7238B478289D8A17F70EBE6CD33AF549E3D72887821CD4349A96B26C239E375982DC1';
wwv_flow_api.g_varchar2_table(1994) := 'F25B1F8DFF694BA8CF5437DA75B3F2C5974D0D456FBC7FF568F35245FBCB278F5488F04F1BB4668F27C6A7574C0C1BCE1E711864C9157DF3AD775E3CDCE44D17DFDD369AE647473DC5A5C995E5DDBC0BEF5F68AD7E31E80A994345BFFFFD87D6A564FE4B';
wwv_flow_api.g_varchar2_table(1995) := '4D81358769EF796F735959DD8067699ED1902D2EC9F7DA4DDECADFBF73A1AEC0DF74FAA5EBB719FF7B33E65C0B1F8A9E3E56BB3E301E48ED1484F0C1DC3FB391BCF0416D4783CF64735636BDF5E69540E148C7A9E3D6B6EA377EFFC9E296E96875E9C686';
wwv_flow_api.g_varchar2_table(1996) := 'D9E5B4B84CF9DEA06B7233BB3971B7F447AD503B26B7DE5BD97EF7ED3782B6CDBCCA17EE8CAE0CDCB8B61C1B2B1EBDB6E339BCBE63BB333472F8906B7633199BBA55FCDA61303618B2BCF2594C89E2F2B0D1E25D49CDBFF1EED51DA3E7F0D946472072B7';
wwv_flow_api.g_varchar2_table(1997) := 'A835B5B315AA2C9D5CCE38E6FB7EF4D37F7AA3672C58363EDCBF78BAC96B7004F8EDE5E7B92391A2FCC2B0C5AE71C8D8FAFAF1E64AABBFD8109391C5F8DB6FBDE1DFDD2C283FDEBE93972C3499B3E20C14DE195F19EEBE66DB583C327CB5ED4CD3C807F9';
wwv_flow_api.g_varchar2_table(1998) := '5D77275A02C6CA43F5F3B76786EEF4FB036BDEA26368BBDC3F5E93DD71856B6ECF6C8EDCF8D838B93CD973EDA586BA9EB1E2F8DD5B951579564FFE5C2A7BFD52CFD11697D88384656EDD1CAAF67BEDC1329A5FBF3D555835E32FD37E4E531B89C1ABB7DA';
wwv_flow_api.g_varchar2_table(1999) := 'B9D606E76A426EDCBC71B83A4FEC79D0EB2B37C7AB0929476A11D3938E808E80E917BFF8C5A351E0BD2D97D4703E26B391F6D640962F5B118726BC11DAEDDA04FD6F9226E637067B6EAD2C2FF96D19A79F0506B81169898F5EEFDD1EAB0DEC8A5563C5EB';
wwv_flow_api.g_varchar2_table(2000) := '3BE9D8DA9CD70703FB8C93ED89A9C3F0E2B64F368C568DE26E24A5F7CE9DD23C9B589C7C264C6FAD4EB3CAC1F2B4BBE0CB5662648AEFDBFB94DDCFC66242E7CC2679AB4F4A8D62DFE37E7C8B9D5C94A057EE2D8B23ADD12A158A8477696149E895F6C556';
wwv_flow_api.g_varchar2_table(2001) := 'D34039A7EB0919BC2AC545C2ECD2C15B122DD4E8BC12D61E29C63D86891CB76E429AB4DDEBBDA641FB9CBB87C29E3BA8D55AEDA143867FA4FB8594EEE5395D8CC958BF44436280B123B3A759AB4660AF95D290D346F97D6D7C6BDEF3875EE00977D5916B';
wwv_flow_api.g_varchar2_table(2002) := '1289F240D91330C8464606DF946883E6244DD083C2D179166C94101F828D9AE71A027CAFF82C369B33AA59A116FDAACB22E3ABB27A4F76DCD27D55D20699BC2733D35214109B670F873DFDB4DA9FD03C3427372F8B7D5742C53230252377656952821ED9';
wwv_flow_api.g_varchar2_table(2003) := 'B5C9F51E99EA92AA7A6146D68D1B3230204D559281E21AE497EF4B604B588811EBBB19E695C9C045A92813E3D7FBE53254ECAFF8C0FA253384F77BFA6CE719EEFB641BCC3E25DD8EC7E38F5EC59ABBD6DADA5A2C167B90D0C27283C12008C06373DD418C';
wwv_flow_api.g_varchar2_table(2004) := 'D3E86324BEC4E7E7E7F3B2986BAB6774049E630488D32E2F2F2712CC51DD7B6E7DD655DE0D9C4E276F0E087CD9FBC367B25FF81F2D2CE7E30EF82D167381D755D15897E0A5C09E3DDC792852521D2828CA66B20197B5ACA2DCEE0B85FDAE9ABAAA485159';
wwv_flow_api.g_varchar2_table(2005) := '5E61D86432178783E148B4A2321A8C94271399A280A3A3E3B0D3575890E70D454A89FB9594965A5CA182A0C317FE3C080C61F2075CEE80CF6D777A03D180D7BDBE6DF1DAD29192A8D3E6301A9D99F87671B4E0DE4ACAB83C51591E6EEF3C1137FA166767';
wwv_flow_api.g_varchar2_table(2006) := '4A7CD696CEA3766F3E8F42733A55545E9434B926A7A73BEACAACAE208350A726171ACB3CAEBC627AE8779AE3567F5E66A7BEBDCEE429BE7467A83964EA6CAD0F5734384391F5F555B3C15052148AA5ED87CAFD7995F5BBF16484D795CF1676769AC4EC0F';
wwv_flow_api.g_varchar2_table(2007) := '6EADAFD8CCA6E292F06ECCD0D65CE42CA8342562C1C2B0A320B0BDB5591860A52D1E4FF72F045C68666AD96F8D7536D607CA6A6D0653D6E74F6C6F9416F847966D237D571399547C63BEF3F0A1ACD567C9A64ACA8BB9620E976F6B65BDBD069ED5697738';
wwv_flow_api.g_varchar2_table(2008) := '4241AF998FCDF8EFB1C54CDEB03155D75E5F5C5864F5176D6F6C069DC65071F9C2D28ED319F787F38A0B8391CA9AC50DB1A6E345E190CD1B4C73B11C8682D272A6F8FA0A431BAB5B0E87A1AAB4D85D10DE5C5EAD2C72B61EEE70B9FD25A1BC80BF20102E';
wwv_flow_api.g_varchar2_table(2009) := '5EB53BA3B216A969E37D61753733F4EEAD92667F475355A0AC696963D79AD8F0E6E79784BD315B38B638531909351F3EB290B4075233D1C60E38B3D362B058F38CA9AD86FA9AFCB2AAEE8F26F24B938DE54515ED27035ECFA6E6D77A24E4353982618FA1';
wwv_flow_api.g_varchar2_table(2010) := 'B6B9259EB0B83CE6F4DA6CFD914E83595B4C0BEC5C0E9B2F18349AB5B82BD1DD68D06571055792327AF96A6179F8784369B0AC25E47787C3E1FC70D86C772DAFC76DE9F582CA68B4C0535559BD255E477AE3F489D660B8CCE40F6636974FB4D77BA375E8';
wwv_flow_api.g_varchar2_table(2011) := '465B5981D7EA0E2D6D251C3B8B9170349CE7ABAEADE687E14AAD1D3D7ACCEA29E2058ADF524959584574D95CBEB828CFECD4C8793295290EBB1C81308EA5B3E23267A3A551DEF3B49F9FA44A8A8B0D66276244954B223EABF7F395BA90D7938EC0538B00';
wwv_flow_api.g_varchar2_table(2012) := '3493F731969E79F0C5891D4978A19A9C9C848D32108F5375543B95A823AD54E219944BAAB39C9231F0347AB0F3B94232B9396C8AF4E2108F3426B3F12248AD36BEE26109610CF87C84649F3CE1D9DBD786BD539FE637BFC0CDC1E48B185371A7CBBBBC19';
wwv_flow_api.g_varchar2_table(2013) := 'CFB367FF97377B7F5E2F0973A8389ABF9A76A637660A0A8B679763B1B5F9D248C0E20C4C2D6F27D7E7F202DEFF7869E695C058E5E1F3269B672E26EFBEF3DB9F9F6B166FF9E2DA8E7577EDD6E076496A3C78ECB46173C11D8E4ECF2C9976368A4A8B0C66';
wwv_flow_api.g_varchar2_table(2014) := 'C581FE3791FFEE401FC06C71518B225A2DF23FBF253F0B8AC1270C4EB9B924173E919F9F93FFD0232F98A5F984ECC4646D471C7C638E482CAB1139BF455C016D68AEC7235727F88E27C7FE4CBAA62436282D2765665E5C19099709438FB20956539468BE';
wwv_flow_api.g_varchar2_table(2015) := '1659DD88CBECB4E4FB44FBF8B82B66AFC4D7350D103F02ADD33362884B4989A42C12DB909D6D71FB656E513C26CD6EDA2253D3628E4B1C667E597EFCB2CC67656556A241711208DDE3A5D34B125F95B288649D328D5769292F91A451626BB21997904B96';
wwv_flow_api.g_varchar2_table(2016) := '337C3396200370CCD23326B1BB5AEFB693ACC3292521D9F0C8C5FF497EFA0B199F97D4A6944725EB928FAE492D9DAD90A55929C8134F9E16D7DD48B0ACA3A6DC6095F955892F4B51586206F15984A52CB33BE20DCA5B97A4C2225D3B62EC9296D7259D94';
wwv_flow_api.g_varchar2_table(2017) := 'EB5DF27A9B58CAD879427657251A15B34323C3EA814EC498EC9D29B9FEB13485E4F8EB323429A998F48C4A8B51422FCAD56B327D5DFEE5BF9299845CBF28B7A7E47FFC4B49BB647245FE8FFF207F552735AF4A6A5D8C6EB9D6273DEFC93FFF2BB1F2DDFF';
wwv_flow_api.g_varchar2_table(2018) := '217F19077E08B953AECAEF455E142DC0FC3C276E46055FFAA9E819E8386FE48F9E85CBED72747474696989CCFEFE70AF83F9D7D6D6AEAEAE12F2DD5FA5E7750474040E20C0DF0B6F2D8383839B9B9BEA552327C01B051F92787340E0CBDE1F72C2CF4466';
wwv_flow_api.g_varchar2_table(2019) := '6074AED8B2ED2ED646C67E5962F8D5F2C666D8C747716D09DFADF54D8F0BEAA751A9FD69392EBD4303675A4A45B4EFF5DF7FEA1E5D1BEABEC028DAF22267D3A1136265B8F253915662699761DBB6370C707927BDFCE99DDA979BF8D2FE08E7D6E349677A';
wwv_flow_api.g_varchar2_table(2020) := 'C5E2D668E1FEC4437AE0DD819617C362BDBFC1D5FEDA5C9E1792CCE6ACD317C9953C34B39C90B5EEEB559D9D0FADD50B750474049E18012216BC8FCDCFCF1F885BF07C21BCDAD8D878E1C20508295F543975381C1C49BCE331344FF1611A92F6D360E58C';
wwv_flow_api.g_varchar2_table(2021) := '7A2A3DD543A06135C1806B79C2E35C5F7197D4F72EA76DCBFDF5CD473FBD3BF3E3F254222963F72657CDB14C6C6627D4965D99CF98FD5DDD03B1ADB9C4B8DDDD7AA4B7A7C72549B3B168747A7E6A7DB8ACE9380498CE33DC48C5525796B73DF125B3D5B9';
wwv_flow_api.g_varchar2_table(2022) := '1ECF4E0E0C5759561692D67B3DDD2C226F4C4C44EACFDC27588FB87A842E3372EFAEC4DC929E96B9A08C0CCB62838C4C0B8BEE1534C8ADB7C5572DB125397D54C6B6582C41DAEA65332D8965A93A2CB3C3F2628BEC1864765C18B112334ACF80ECCCCA9F';
wwv_flow_api.g_varchar2_table(2023) := 'BD2C1FAE897B5412168DF71E3EAC11B385690964850FA05B736223FABA2ADE56491BE5CE80CC0F6B9E26E6C5D62ED7DE91EA22C9D6C9EDBB62589173A765C52877AF4BC821FE462D64BDB8231706253E2D531639F39298E081ABD2D525B69446B0874665';
wwv_flow_api.g_varchar2_table(2024) := '694C123C5696C45A27D77EC387021958174BA12C4CC98F4E892B2AA31372BA81DDEA647558925E591B94B273C2120CD331B97A4153529A2FAB7C959C96E257E4EEB2DCE892484A3A7E2C9F5E10974D16B7C4BC2CA606E9B9A18D37AE898AA9407C29994C';
wwv_flow_api.g_varchar2_table(2025) := '4B935D123C701725FF944CFE416A76355593C884C51196F76F896353B6E39282751F919EDB12DFD02660D7144B51B9D44565B95EB218CE4A45A16C67A46F581C3EF159A5AD451687B42B15744AEB61E9DDD0AEE8564A6606A5B65A78A4F25964BB471A5E';
wwv_flow_api.g_varchar2_table(2026) := '948E4332DAF38D26753FE2C7A2573D1F0870F37D3E3AA2F742474047E09B23505B1EDE5B4AE2519A98761BF66BAF1F243EAD797DF7F3AA2477CC73C8A9438C50FDC2D7B75CEDF7903954E1AF2E7C49B269A7B6DED2E78B607D0FA61F6D228F48B7DC9F04';
wwv_flow_api.g_varchar2_table(2027) := '97673705CE1DFA4A947C0E66971D64BF58A15787CED56AA3D11E999860275FC57E5190679500AF687AD211D01178D61078AA093060369616DCD96EBD373B1EE8BBB1E868752ECE40F5EECDAC4B389E4D9BC3054EABBF62A4EB82A12E6A5C9B5DD8CA1BED';
wwv_flow_api.g_varchar2_table(2028) := 'BE610FBA46179206C90B995623956D3EAF3B2F6FBBA4B0C4BC3773E3FE05D2A287B2B012CF6CCC6783551FDC1A3C7522EEAD6FFEE8FA507AA277D792B730BA10A927A0F715B748B856362D6CB1EEA9922BD7E45089E447A5B05882535266D706DF2EF64B';
wwv_flow_api.g_varchar2_table(2029) := 'C74B729B7529476485926D8D7A330BD7E693A9457133262622536B625C9340874C6CCBE6A2DC9D95E3433294951309A96C91AB5DE2BD2757FFA00DD3DD98979656B9B229E937E5F51F69138FB75372774C8E4425E3D3E8E5E10AD998929293B292668E8A';
wwv_flow_api.g_varchar2_table(2030) := 'DC1BD18655AF1AA532247925B2B9B71C207CF2D615297609E3914E1D17A35706FA8431310C608E3B647E441A2B65DBA50D3FAE09CADA3D693C2F1FBD2BAF55CB1566CCCECB06537FD784B9B553DDE2DF94AAA372F56309CF69E39C37766563498AF2B481';
wwv_flow_api.g_varchar2_table(2031) := 'D0F726A598AFDB2ED99CD4A6E6CE754BC551991E97F31DE288C8C52EF19964B44BD21EB124A4B352DE7C5BC20EF1BE26BD1312F68AC727058512612AB5435696A4BA58AC7E199D92D7081797CBE03B1239C4B01F49EC6A037E520C293388CDAC8DFA5669';
wwv_flow_api.g_varchar2_table(2032) := '2D292377246A964226C564C4F2D977761E796C9BC74565FCF3A56BB23328A990161EAF6910F7DEB7609B457D1BB9AF47FF4F47E00002B05F35FBE340B97EAA23A0239043E08FEA2391B61ED557BE2AE4A079640645442B1E29F2DD5662DBE9F87AF37FBE';
wwv_flow_api.g_varchar2_table(2033) := '5B871EA65D839B4956DF2019BF59F3FD9635677ED04BB6DF193DAF23A023F0F8083CD5049838CBDA76BC3A62DF32D64C0EFCDAD5DEB4BEB1B9B4B2B4BBB2CC5DDA60C878BDF684DBBD9C3598D9DD8EE51013298F315D56561A725A7AA7249A9776BADCDC';
wwv_flow_api.g_varchar2_table(2034) := 'CDBD813CBB73E6FE4255223BC9F4CACA9A35E5914C8A21E02C2C19DFD93566580DCBB6B3B35BE4B53AA3650561062071677B8C04BDAC95DD52B97047CEDBC5E615B753FC016DFD3DEE8AD02DB7572C0E493230B85AB6D765B85B9AE09036999894CABDD9';
wwv_flow_api.g_varchar2_table(2035) := '1CC37D52912F598F0C5C9190592661AAEB62F28B2FC8DA1BDA181F62DDD95D2D526A2D163B5BB09B6537BEA761565BE98FD1D4AC9E95F5CA6E5A63E36541615904466247AC325920CBEB12B3883B2A2EAF6CA5B5F58DD925C29991CA52B19864C324BBA3';
wwv_flow_api.g_varchar2_table(2036) := 'C27CE60223D3B9256E964C52F35FDC926019C39414FBA4B85A02BD521515CB9A36C0776E501A0BB529B23C7F5C1EF17A246DD282ABB0D0028754366A2B57954CCBC6B4B41FD2867FF70E6911E9EBC3B2B3C3D414CD8D944B76D94839AE6D9E1BA99642B7';
wwv_flow_api.g_varchar2_table(2037) := '369B2991D24C67CC323B212F548BC5AC61989F11834DD23BDAC06F22BD56AB66CEE8D3BA80C5CFE370FC50F812C18123C3968C72B34B2C2B5255277C08B1EFD57EBEB033AE32042DCD5A68DA549A8579F1C7A536210C4663990C64D5C2D18F71E175913F';
wwv_flow_api.g_varchar2_table(2038) := '460418C00901FEA37ABFFF63BCCC7A9F7504740474047404740474049E5F049E6A020C015D8BA77B7AFB5971ABA4ACCC95EFF934E9EFBD7A3D688A1BEDE150C0D47B6F62C378F5506D64DA15CAACA4EAEAF277E7AB92C994C7EE6868AF1CBC39337FFDEA';
wwv_flow_api.g_varchar2_table(2039) := '0B2DE5E5E1F0D0E07241E58AD517B1112434BBAE76DD8D8616DCF632BBDFEFB35B5F3FD3B96273CC0CF5B73454AE0CAF66D349A71776F6D504185616F16AF35189414682E2716A4B3A6B036BC3327A539B15BC96904F6F486A454A8ECA725A5656259492';
wwv_flow_api.g_varchar2_table(2040) := 'ED1D599E97644CA2CDDA82523B73527C7C8F9A9A649BA520F3181FC51A0B726F5A46B724EA96AA6A193FA1113628F1EC86D49A24F3B28C4C0AFBC29579A4A4582EF66823908F47C4E5D3429A9040D829D1E612BF1647159F5CED91F0B4440F8BC72F2505';
wwv_flow_api.g_varchar2_table(2041) := '52562FBB2929B44ACC2C5B3352D920FD1FCBE4A772F298B88AE4D24DD9B54A539138F2C44FF38CE4F9345659E4961D93A4662472E4FEEE4477E664FA9254BA8459368122968590F8AED6D9D93509B1755D5823BA9055686559853699888D10AFF4893123';
wwv_flow_api.g_varchar2_table(2042) := '272B44AAA47746D2AC62962FC3D3F252BB8CEE4A4F9F78D3E22FD2D0F0B24E994B5BC39929CDC984580D1AC837FB647752EA3BB4BD00B83C0C6637EECD61E604F60B75674D3456E19E1E11378B42DF91A64D296BD5660BE705B575B6F08441E0913CED0F';
wwv_flow_api.g_varchar2_table(2043) := 'FA4487A4631AFFAF88CBB649E25352C4D0B3AC045924EC6BFF59409CF5F4C78BC063F2E1039321FF78F1D27BAE23A023A023A023A023A023A023F0C321F0B5DFF4BF67578B02CE5841D499D928AFAD34BB1D87DA8E65D626A3757E832FFF5CB37977913D';
wwv_flow_api.g_varchar2_table(2044) := '00B6022515FD77178B0C96B2882FD6DCBABD3E6575389ACAFC92E84CAC4F99ACAE63158185548B616F57778F558E3637C697A7DC4E93AF30683304FD26BB23EA5C33BA927323A5E5C583E9782ABE69BABF02D65774179E76BE4E1831C46A58A79BC4E596';
wwv_flow_api.g_varchar2_table(2045) := 'B36D624FC9B1A8CCC4B4F5A2C2660985B495A8F24A25B6205511A92E15178384DD92CFC4DA90466B6BCB34DA06D33BDC26C30E6D407551A1A46E4A41BE36529A01C92E16763A2613439A7E887971831882B2BEA02D43EDB1495B540620F571696890A453';
wwv_flow_api.g_varchar2_table(2046) := '82ED5A24F348A34C18A4CA29917261F56B435AECDB12A4791DD3AAA5A34D1626840932019BB82BC45320D956896D8A93E9B2ED32422C3423750DB26311EF59B166E450833614F914AC9528AE555B8D19C267CF682B33C3C90F61C2250DE7B588772820F5';
wwv_flow_api.g_varchar2_table(2047) := '47D89941B43DEDCCDA949DF39DB23A2555B5E28C68FAC3616D526E55936498EE7B44D667B5ED8E4A1C52EC95FC944C4C493DC1708BC6E1EB23E20E6A6CB9A6518B7B1398B5583464586FACB25E0B5F1F6DBF1F0466009AB60E5646CA084DEFF1FF8EC3B2';
wwv_flow_api.g_varchar2_table(2048) := 'B9A695A89DB31C4639DCB9B7EC33516B8B307B28639510B0F8E494475C490DB754ADA6043ACD5580787F49E2C3C28323AF0083CF2AD06B3DFDD121A0562964890522C3D0607524A3D2FE53153A8E4422AC7C4BAD428A86ACD0409E550311F85AF0D150E9';
wwv_flow_api.g_varchar2_table(2049) := 'A7156B1EC2AE39458F5AF241E9A49012F214AA8C32A164944B8FA6E5FB6B736E2B250F3D228F33C0925B454C81B3DFFA431BEA853A023A023A023A023A023A023A02DF0F024FF52AD08F0941EFD8EAE49D6B279A4AFDE5F58FD9E4EB88FDAF22FFFD0179';
wwv_flow_api.g_varchar2_table(2050) := '5E5FD52AD0D04093D197C96AA48830A3B60330E3813961ECAE51A6B765FAEFE5D8CF359EC65BA836EB44AD95C17EBC10B6C4FDA1BF141396A4151A684582D1FDED75799589BB651A2B830DAAB65A1DA750AD3DFDA8552FD26A060A92D4A201AE98935732';
wwv_flow_api.g_varchar2_table(2051) := '4A4009F39A9D9B2B4B1E5B5AC4786FF6AC4623F7346047BD8DA38D61D59ACEACB66684365039A3B1FDAC496E5D90129714B669BDD6FC41C39E57B4DDDDDD63848CCFA6D59E660AD7B372E75D39765C4C8C9AA6C9BE2A658EEEC753DA02158A63724A4FB5';
wwv_flow_api.g_varchar2_table(2052) := 'BE13F1DE43ECA31BF24A9546FE39557D41767FA20908539B330A24A041311DDC23025A7F11D31CD84BCA4A0E37CA68ABDCBB2F71FF3F34459993BEE71CF903894953FFAD08FB1910A57E9E93BE0A340B444362151584ECB1C8EDCCCC8C2AA150315275E4';
wwv_flow_api.g_varchar2_table(2053) := '9404F1E394C4CF626161212F2F8FA5A4D52C629821AB520F0C0C20565F5FCFD2B8641EF3D783E99191119AB00913AB20F6F7F7AFAFAF171515D5D4D4503E3535C55A88E5E5E5B8575959C9A2FD94949696C27BD14F5B360F181E1E66396B6A956F0FB58B';
wwv_flow_api.g_varchar2_table(2054) := '24AB5E2BF2CC9155FD1F21AC34B383D4AD5BB75A5A5A008AE6741FD3D5D5D56C14F5F8BD7BA8337AE1B385003F95EF621568F5A1C9C48D5B3D2C9F2D50746F75047404740474041E0F813FEA55A01F0F22F1BBADBEC60A3FBB007D27895D014F6ABCEA60';
wwv_flow_api.g_varchar2_table(2055) := '623E2C6F9315E90CCBDF435BB3ACC644522C8B0C4157361B769FD74AD46B6D8E7451AB45DE6D5AB9151DD0BCBDB61A83D5A2351A493B5BA3C52A734C6F7F5B4D82B427793FBB2F0F5FD52A3F23780F0A68B5FBE5BFE8B676B6BF762F0F0BD58AF7C60FD3';
wwv_flow_api.g_varchar2_table(2056) := '69CDDBB41698B5193FEF9DB2ABDA12AAD5F4ECD30C7CEC43A76DC8C79CDECFF4E7329AF63DFD0C50CF35547C5E2BDF9307B18E3A2D6E0CCD569AF71A7DE170A049AE4EF3F733A338AFAE94AACD35B9EFFF3EC95CF3BD0C562B459ABF58A8CE50CF55641F';
wwv_flow_api.g_varchar2_table(2057) := 'E9CF6C3C4C482F7B2E1180E011F064E3C7077B07DF234103545281D0FD3B0CB34CFFDDBB777B7A7A680E594580841E35C718B54A2734F2D2A54B75757539FE49097BA8BEFFFEFB6D6D6DC78E1DDBDADABA7AF56A2010B877EF1E041B61BC821BC387AF5D';
wwv_flow_api.g_varchar2_table(2058) := 'BB06439E9B9B838A608286E8842A777575C18AD92DA0A2A222170DA60A07D08C98B28EE7636363F849218C1AE5F408318E8A1523AFF234C128A7F06AF62D805AB33FC1A1438760E0EC610007FE8BBFF88B476F40A53AAB1F7504BE0C01EEDB43D3AB0BF7';
wwv_flow_api.g_varchar2_table(2059) := '6E582DF6CA48A08005271EF25CFEB2D65F511E4B646626A6031E0986F9D0B9F71DFA912D781ECCCC2F9B121B914891B680C497A49D9D94319DB0BA9C6BB1A4D5905C585E37A476F99C9CE777ADED98B389F554D690EFB55A7D8533738BD9DDAD6881D7E6';
wwv_flow_api.g_varchar2_table(2060) := '610BBECF93E6D8E48CCBBA5358C82837D6E7F8D6D26642B69726C2F9F906162911195F580BDB93EC5DFCAD19D015E908E808E8083CC5083CED43A01F07BA62B6A90DD53C8EE413C99C6033A6030D798D349962C4394598235BFD65848C974D5B405BFCE9';
wwv_flow_api.g_varchar2_table(2061) := '0992DFAA055D9FACED13987B822636BBC643BF968776A736F7F889A3A46CA1B4CB7BC713E1F9041D7CA00911ED47FCBD68603CD0E4792B80F63C6F5DFAB6FB93A388B047F2D0422CA8BC62B639839046B82881D9C3870F4353890613C8A5497B7B3B38DF';
wwv_flow_api.g_varchar2_table(2062) := 'B97387D02EDBD9113EFD9BBFF99B3367CEBCFEFAEBEC45AC54114C2603D5ECE8E8604B768FC7F3EAABAFFEFEF7BF271C4D94FE85175E80FD4298D929FED34F3F450FFC191E8B698C223031310123A504F2BCB2B2323D3D4D101BF720ABC78F1F871BDFBE';
wwv_flow_api.g_varchar2_table(2063) := '7D9BDAA6A626366B85B86242F15B84F10DAF300479A62123BA21BD9413C48621BFF3CE3B98BE7EFD3ADCFBC489136CF4DADADAFA6FFFEDBFC5D0D70A71E750D2333A020A81F5A4FCFA0F1FB6DB86ED55A776B50789F629339D4C582DE6ACC1984D67186B';
wwv_flow_api.g_varchar2_table(2064) := 'C1A3998F4846A3990F35D94C9A0906C954DA90CD982D16153AE6AF46DDC48C6ABCD09E6A767CFDE0DA606CE20EAB3FBC7CBCC95F5C97CAB012087F7D56D6824C2676F9464D1E62CC5D7E77376162A094C53A34313BDE77ED9FFEE97153A80135BBC9B421';
wwv_flow_api.g_varchar2_table(2065) := '936403CAFDB47C6464D5BB315D7CBCEDBDA19523EE99EEF19DD1BE1BE55E6B5B47E7F08AFD6AF7B562C7F69923CD6BA9C0858F3F0CD8CD5386F4E9D75F32D8EFBF72E0D8873787135303F9FE6438E885006B56D249AB7D6F6DC76C269148D9F0C66CE1FB';
wwv_flow_api.g_varchar2_table(2066) := '93813911D8CE02827167376131644D561B3864B219368DB4F1AD9D7D233E4BCBF1CCADBB23B35D7FF8D96BC76D91C33D638B1FDEBC7D3EB8DC74E667E848A4D2F4DF64309A598E528FB47F069AFEBF8E808EC0F384C0E737C4E7A957DF6A5FCA44F87730';
wwv_flow_api.g_varchar2_table(2067) := '399D89148B3E691C907F0F4F5A1D4FA4274A7B43269FA8E5F7D5E8093C7C8226FB7BF30D9BEF57F54479AEE7935ECE27B2F7143662C3F1A7D0ABA7CA2518A6E2A8505912BE714A52C152559273984262B31C3B3B3B218DB04DA826090EFCCB5FFE120249';
wwv_flow_api.g_varchar2_table(2068) := 'EC146EBCB197A89D9D9D25360B6766E0344C151E3B3E3EEE76BBA1B87057ACC09031017986919E3E7D1AB590CF929212C624137C86AF12C84561414101149708AD8A24C39F3965F834CE4059A1CD5071E2C65062B82EDEE2A14AA8A59C60F2071F7C00F5';
wwv_flow_api.g_varchar2_table(2069) := 'C50D2CE2066CF9C30F3F7CF9E597A1F40CABE688B7FC5A0A0B0B91C161ECE67AAD6774049E0001B639189F9CAE0FAFB516057CF9C56B3BD981FEBED8DA62C46D0A541FBA76E176BE3FE30E475746874FBCD0D13367722F74DB6A3AA7076F6F6CA78FD686';
wwv_flow_api.g_varchar2_table(2070) := '8662C1D591AE6824CF1C2C9AEEE97FF99536B1316C474B935BC9D99E0B9D870FF52EC8E8DDCBF60DEFECDCC8CAF6EAE9DA90A1EC58D7A5CBC99DED93B5E5BEEAFA9B634B63B7AF57854C2DC74F178783976E3BD3EB3310E0E9AD64CFADEECCD6FC89BACA';
wwv_flow_api.g_varchar2_table(2071) := '40259FE3EF7F289C5ADCDEB971733B607FFFCAF88963F1D292B66B97B75FA8307B83F9C576CB7FBC606FF72FB843455DAB496372A9AAE9D45B7FF7F1C953A3E6CF08705C63E63D7F1A5E292A3D6A303B9737766F5DBF63D89EED6C2F5BF5358EDF78632D';
wwv_flow_api.g_varchar2_table(2072) := 'EE2EB7EE843B8ECDF78EB79E6AEC9F48040DD3197749F7F5CB1E63BCA3A371305EB8DA77617523535B6E6D6C3D99DBDA379DC95A0D89D1E5CDE4DA1804782799DACA58C6A7869B98A9B191B876F9EAC6E642616AF7EC3FFA91C1B2B743A0424A3FEA08E8';
wwv_flow_api.g_varchar2_table(2073) := '08E8083C2F08E804F809AFA4C361E575F3091BEBCD74049E4D046041CFA6E3DF93D78ADF727C3071BBA0F0801FB065982144510D15FEC94F7E42A494402E015BE2B4A74E9DFADBBFFD5BA6C1403889F4427DE1A5905502AD972F5F266ECC545E78E66BAF';
wwv_flow_api.g_varchar2_table(2074) := 'BD46F418060B1386EB6205197412E9422D43A3E1B13064E2BA34272CCCA8E9F3E7CFF7F6F63258BAB9B999AA73E7CEFDBB7FF7EFB0C2F58551C36619954D909931D5048169AEDC268366A6F8D244C5A8B145281899AAAAAABFFEEBBF264A4C069D1060C6';
wwv_flow_api.g_varchar2_table(2075) := '4EC3A561BF64CE9E3D8B6FFA0DF3C0D5D74FBF16022CD9F8F2F9B343D7DF19FBFF7EFF4F5EEDBC92AEBEF5C6AF6C2E8F7365A9EDCFED7FF8DD07FFEC2F1B32A6F2772FDE2D2FB2BE7FD374CC3E7063D66219796F7CDD695F70DCB2B4A56FBD5FF6577F11';
wwv_flow_api.g_varchar2_table(2076) := '4F1AD6565624C324A6FB697C2579C835DE76F45F649764E9D37757BA26AC5B77981EB0B5B2918EA4AF5CED5B5B9BF40E0D35FDABF2AE0FBB2385598BD54E38B5BA349217AD66AB0ADE037EFBE1D0C495DF121C768C0FBDF05F977E786BDAB63C78A4A329';
wwv_flow_api.g_varchar2_table(2077) := '6BB50E4F2F670706366767DCD6A2604D7951B4A4AE3EE4292C8156868AABEBABB381489561637B6D6B776D66A6B8C06BB4F9AE0C2FAE0DDD385416C8AB3B5A5F55BCB9BAB5383B1E2D8A7E706DFCD65B7FCF421CEEAD1BDBA7AAC7AEBD15EDF8C7EB3B99';
wwv_flow_api.g_varchar2_table(2078) := '40227E7D68B0A625AFAF6FB9A570EBE3AE95C94B6FEDA4A5C43676DBF65F38EF5C74D5BEB8B0B15393495CEB9B8E8FF77534D7048B6B3B1BAB6FF456AA7B524B59FEE096253B788BF0EF9DE1D5B9AE5BB379FECD99DEB3F2CA6720E9FFEB08E808E8083C';
wwv_flow_api.g_varchar2_table(2079) := '5708E804F8C92FA74E069E1C3BBDA58EC073878022BDD03C12F9DC71AF40FB58063FA47C7FBFA194CCE33D79F2E4E2E222F71322B4C46909CF22437C9531C314C236199F0C1D65622DC38C21CCC4695560160162C2B05F287163632384538D9186BE52C2';
wwv_flow_api.g_varchar2_table(2080) := '325457AE5C4139CB6241988F1E3DDAD0D04043C2C9548542214650C3AE514EC817624C130833315E282B3238A01C56FDC20D46351325861E23008B661232449A5AB5DE151417EBD43A1C0E8419388D7202C50484E91489F203DDDF0F859ED711783402C6';
wwv_flow_api.g_varchar2_table(2081) := '74F6E58EAAB142FFFFFED7BF19B8F8E9ED7C876965F4C4D97FBA39BDB29BB1B99389F6D6DA4C5EA5B7AAF3DD4F2FEFCC19233F3B71F3FFBDFB97E586F2D6E34EC3C6EE4CBACA656D38D436B76174B61D12337B14DC4F36B36133CD0885646C2B6D329A4D';
wwv_flow_api.g_varchar2_table(2082) := 'A9746B45B4E2D557B756D67E3B305B13342C971C9BB97CAD28B923F726FFF49FFD236D6BC1BDC41FB9C9C44E05327E6BB2BDD4698B1C0B30F8DA60DE49246527C6D06373DA5C190DF13DCB33EF4867E2496D867F3A95E47F2DA5D9E0511B47A60D9A5EDF';
wwv_flow_api.g_varchar2_table(2083) := '4EECC6375F3DD768F456ECCE2CC5997490DC75180D7F76AA79E4AEEBDAC58FF3ECB727A762AD65166BE551AF6B73359525107DE6FC0BABDBBB2E4BD65F5E397C6FD4B2BDE52D3C34F9E185A3CD953147A9D59B4E6DA75A6AFC353F3A3BBFBE9D355A1289';
wwv_flow_api.g_varchar2_table(2084) := 'F46E3CA60D6F368AD568E566A42D27C65C2DAB99E03033FAC9AF6C6DA536D74AAAF33B9A5F3458FC9A7B7AD211D011D01178EE10D009F0737749F50EE908E8087CEF082896CB11CBB9FC7EEAAB864673CCB906BD646D644823E390619BAC0ECD645AF28C';
wwv_flow_api.g_varchar2_table(2085) := '7FA69041CBBC1D1350A58AF02FC15E1A220387641032515FC8301A2E5EBC881582AE106094D38439C31054566F46396D2967CC33915802C8344709641B01382AAD20DB344103555056C2C53064A2BBC4750908AB68335690A121A3AC9121C88C5A682D03';
wwv_flow_api.g_varchar2_table(2086) := 'ADE1E4E459520B124E09794A14D1657C3563B9A1EB449E61ECB06BCA737DD7333A025F1701C63CDFBDD36D964C89CFED29B03745F38643A592DAA928F3AE7A0ABC767BC66CE385A6B9BDEE57FFE71B678A2C85658D4DB5899DD84CD86D2CC92BB02D9B5D';
wwv_flow_api.g_varchar2_table(2087) := '0E667018A757E3C3376ED7D7F8C4729F0357E7D97E6D3C94FAED5B6B5BA6CE86C3891D97C5AD6DB6E0C9F32F6E2CBBB766DDE132BBC7EF6635B870F077BFFEA0BCC85FD776E252F7C8D89D6BEFAD275FF455B61C29CF4C4FD9245152576633585FEDA835';
wwv_flow_api.g_varchar2_table(2088) := '642AACDAECE4E9EAD2C2FAFA86FC318B9806E93254D360D466E393EC663E7069EF602C25D7D954FCF2F9D76C0E0F67C7AA0B3265AF59CDC6ED8CF4DE1ADE894DEEA4ED0649D5D7956FF48E9953BB4515B53359B337CF0D750EB8B4C90535D5F517DFF9FB';
wwv_flow_api.g_varchar2_table(2089) := '63456E7FA8A8BEA23611EBF55AD3C1E243967BE208682436ECD336F73BD15C9E6D88E2582C25976F744FDDEDFB386B7BAD78E6E68AFBEEF50FBD53132D7D37CC4EDFE8CA5ADE607FD657934D2559108F867AD211D011D01178CE10D06F6DCFD905D5BBA3';
wwv_flow_api.g_varchar2_table(2090) := '23A023F0BD22A0A29A0F25BD54E5CA61A730C9FDC3466095045429418C5A782FCC16D7619854319F9623E39C89A94253994C0BF9841E23402B682AE5941C397224B76233559863052CD82F6A09C94262A9554C182B34C710C15ED83579D4A28453AA9851';
wwv_flow_api.g_varchar2_table(2091) := '0C59C50A79083079F82AE3A8694E130A518E1EE421DE9C2280871075ACE006015E22C9C8B0E415BE51CEAA5D1C5F7AE92565943CB57AD211786204AC16A3C1644BEF6E9DEF286E385C5DEA2AF227FF4C129B16BBB12CCF71E6A72F196DDA62ECED15A19D';
wwv_flow_api.g_varchar2_table(2092) := '575F6D8D58DC2EDF3F3CDF31DD9F22446B75D84FB51406CACFB290A1C76ECE2F0C8BE9F349E961A7B1F5D8D1C5BEEBB585D6B2DA4E832DE9F3C4959FAFB5160FED1C0904ED85AFBE18B23A3B5EEE98EEEBCAEC7D0F62D5ADF6F282949D3F8FCC0B2F5675';
wwv_flow_api.g_varchar2_table(2093) := 'BF37CFAE616A4D103B01D5BD15132BCA03F6BD153A5FAACE73E4D53233F8487BAB2374DFF42B6D25790148ACD4E65BC57258B15F4E6D66A398F7BE16B1CA570A6BC9232D4525875A9DA9BC5B6BF399640C999A3CB3ADFE55E524C7D222F77C656D4DA5D3';
wwv_flow_api.g_varchar2_table(2094) := '61B61CEB6CE8EF5ACA64532C79D75EEAF1A5DA73623616B5E21F5EA6B40129479AEAC569D6761BCC669BF28C16F711560EDBDE49E5F9ED198BB7EFCA40C3F175B3F224A742CFE808E808E8083C17083C0FFB003F171742EF848E808EC0778E00814AD8DA';
wwv_flow_api.g_varchar2_table(2095) := '23CCC01B1918CC98DEFD4C1579281F148E302955303D45086186CCD425A04AB493802A6239BABB3FA3CA393214196E09A7553C96123470CC6953467931A59C84124A542D194E737932FBF33925649024E5046895D346AD4AB8412186D429C23451923901';
wwv_flow_api.g_varchar2_table(2096) := 'A54159518539973855BE71249FD3A6F4A82608AB53954172BF2AA5503F3EC70870C589FC33A89E1FC0FE6E52CED07D86EB337D9DE3FEAAAFCCEFFD8832B94D80F92A93E1A392B625F097AE4ECF660A90BA5C9347986034B21935DA8EF65F48A974868596';
wwv_flow_api.g_varchar2_table(2097) := '732610331AB2469399726D07436D7740CD83BDF90D9AA19CE417B43CE909E333E8654E2D2B5D6BE3AE59C3FA81E518A8D95BDA5AB394E24F3B9B3533D0F9CBD7704686151DD08E98B66FA2B613200AB29F0C2E2DDC7CDF60B5543AED2D2FBD68B27D3E56';
wwv_flow_api.g_varchar2_table(2098) := 'FC493BA1B7D311D011D011F8DA08E8FB007F6DC8F4063A023A023A02DF1B02BC02F34E9F4B9C2A62992B5119C53055B436E7DB7E4E986B482D791219DA2AE11C59DD5F7820AF2495399557C79CB65CE17E6DB956649451326ACC734E5E650EB8F468DF94';
wwv_flow_api.g_varchar2_table(2099) := 'F083860EE8D44F75041E1F813D82F739418558F3F1E5D1CDB529AE5F25A3349835FAFB90A4D1C87D292776A09C6F4A8FDC276F9F8AAF9335130DDEB72F31D41796FA500539F64BADF931BAAC6494AEBD2EDE1F0FD85995BFEC3E67CC24C2057E9DFD3E14';
wwv_flow_api.g_varchar2_table(2100) := '6ABD50474047E03940401F02FD1C5C44BD0B3A023A023F1802F040E8A2628C8A7CE68EF80403840AEE2FF9C11CD50DEB08E808E8087C15024E8BD1595CF855527ABD8E808E808EC0B38DC0C33F253EDB7DD2BDD711D011D011F8BE10C8F15B4583735C97';
wwv_flow_api.g_varchar2_table(2101) := '0C251060121955FE08A70E8C1445529528FD8F68F838552A1EFB38928F9679A81E0A1F5A8EAA2F2B7FB415D5F00020C0B85F1B78527240CF8112E4F797ECCFD310FD39850F6AA34A25AA943F076C3DF494264AFEA1B5AA10193288A9CC43250FF4FDA132';
wwv_flow_api.g_varchar2_table(2102) := '8F53A8BA40C7F7DBCAFDAE721A1EC72584BF2DAF7276F58C8E808E808E808E808EC00F82801E01FE4160D78DEA08E8083C0F08281295E3B7B01A9560148A6E7D56A0FD7F8080EDEF3FB54C0C66F9A8FD85AC9FAC064EB3FC320B5091DF5FFB98793C646F';
wwv_flow_api.g_varchar2_table(2103) := '61E62AA3E1319B3C540C3D4CDA641235F336F71321BC622B2646A2B297D27E9685129692665D6896923E50FE50FDB94214B218985A8C9AB5AF31C72AD664D85B984296F552988C8E8E32EF1AE56A1E292E21C3EA5FACE9C54AD458045264589DABA8A888';
wwv_flow_api.g_varchar2_table(2104) := '3D9FD8DF181C902F2D2D55B508032CF3BA513832328236BC55BDC3160D2961B62A621CD9868A65AE1F7105F11F1F98F28A15B51E58AE47B98CC28A59E8AC8F8D247DA1470F05070146CB7FE5F8DE9CE60733D8E2A2D30BAAB86A18C27F0A39C53458E124';
wwv_flow_api.g_varchar2_table(2105) := '4B73639D53126B9E711DD512DF40F7A042F5237FF414FA075BE9253A023A023A023A023A024F21023A017EC28BC2DB2AE9091BEBCD74049E4D04580498F46CFAFE5D79ADD814F480CC83A4577109757C28D5A1A1E22AB03EF60B854429617066B322D661';
wwv_flow_api.g_varchar2_table(2106) := '66AD66B5CA94D28F408E17D1965398124D941B9C92C9C9287FA037D03FA81DF248AA859D8103317513530A11DEAF0D3D3846214712552CF7852AE825CC905A3CE48800DB17439FF0933CFA95B7E4F19F9D96308A98324106819C7B54E106554A8026CA25';
wwv_flow_api.g_varchar2_table(2107) := 'BCADA8A88085DEBD7B17CA0AA725033783A6928769F36900613AC2324BAC5C8D2708630E46870C749756D039582B4B970D0D0DE1FFC4C4040DC9C36629C422B5ECE48421481D38609A5AB65066816BF8218C917E4189710F3A7AEFDE3D2495518E34C773';
wwv_flow_api.g_varchar2_table(2108) := '75DC83475B424CFDC2D043091071AAA056B02BB8D48560BF2B769C4232070E79B42904F0875E40FBF713E91C5648628B444641AD2E22B6947B54A10A1FF01F012E0D7D999A9A0216F0A1164A0F6E74931224D5F70BBE566082562821A94EED77090DD069';
wwv_flow_api.g_varchar2_table(2109) := 'BE1768B6F79667434675593FEA08E808E808E808E8083C5B08E804F809AF97FAB2FE848DF5663A02CF2602BC6AC3409E4DDFBF2BAF154980129021EDB183FB74549DAAA36238FB9DA004D2CBB2D27021B825140BCE035D212C8912F82A3409D6040756CA';
wwv_flow_api.g_varchar2_table(2110) := '2178DC76E06FF022DAC258565656A88291425DA031F03AA80E713F680FE13EC82A85B0290AF1011948205C4E454DD140AC92125C2214892728478C9D87D10047228F33C8D31C6D1842860CBC110F29C42ECDE1A27481B02AA41185FC42E8055C1131E53C';
wwv_flow_api.g_varchar2_table(2111) := '6158F5B3C12EF44FF134781456F01FEB3058BA4F7FA1581C3736369087AAD11C92A6C818CEC04539E2064DE820DB1D43328188424E554FDBDADADE7BEF3D34600BFA072747ECEDB7DFC637C061B16EC4F0965AC81B48D21085E4D9598A9E22863902DD74';
wwv_flow_api.g_varchar2_table(2112) := '1F55780E4A58411E820D3DA6B3E0831264709B26940305DDA7968CA2D6AC5DC9C5C231283718E2244730011F658E9EE21BCD11C33A5D431273E471006021A8148224BB4CA187427C439E1F03B6FAFAFAB0C52979AE2FDA70925F0590A207547183BF5332';
wwv_flow_api.g_varchar2_table(2113) := 'EC7745138415BF553F3FD422A09054978F2F2F376FDE543F24BE35608E26FC2AB85E5C0B9493C755F55BE577452BBE140020BE299DFA51474047404740474047E019424027C04F72B178EAF306C00B0AAF474FD25E6FA323F00C22C0CF1E6AF10C3AFEDD';
wwv_flow_api.g_varchar2_table(2114) := 'BA0C4380D8402FC10752A112263FCBDEFF9F7B053290BAFDDEC06A8094401CE524158A84B9C16460209C92605388C11BE19FB00EC4A06D14C2B8E060E8842CC1D0906183258819A4945A480E8C8572F4601A660523EDEDED8589D144454D2166380353C2';
wwv_flow_api.g_varchar2_table(2115) := '079A433EB14BEC911EC100A1E57802F3A1842AE831BC0885376EDC80F9A00719A82023ABE921FA214B68C32E8E41CCA862EC3125B026249187F4C2F18809230901230FB3E2460A6E64BABABA7095AE61149D74130794F3384C73FC070D70C016197A8A06';
wwv_flow_api.g_varchar2_table(2116) := 'C2C248D2412E014C8F5AD5416400013D506895C731C4A8A55CF15E7A415B3CA415857885361C1B1818E0DE4E862A1CA33B90557CC0287D8149022C6AC14485D681050CF97E41D728014CF83C5701B5D063DA822D7DC7286D21A8CA4F4C73E12844150AC9';
wwv_flow_api.g_varchar2_table(2117) := '60088A4E4375D528C728D708B741120CB18E2DB085A372AD814E71660830AE02083DEAEEEEC64FF66A067F3A4BAFE902BED123B834AA90A4101F801D64D0C991128EC803027AF899711538E5D2C3ABB9F4740187B91C34071F80459EFCF79916B692E3BD';
wwv_flow_api.g_varchar2_table(2118) := '3D1DADC5464741FFE4B26375B8BCE5F0132CBC1C4BA4D3F14D8FDB29A62FEC88C684F23BBDE31581B8275A7FA05FABC9CCE0D53BC78E958A59FFFC77001BFD544740474047E099444027C04F7ED9BEFF378027F7556FA923F08D11506FCFDF58CD73A500';
wwv_flow_api.g_varchar2_table(2119) := 'B201F5BA7CF932744225BAF759F6FE2859750A4B84D24084C828082887884293A04C903D6830EC0802030D838FC15B8882425A54B00EFE83ADA6A626CAA1557054B8D68B2FBE080BFAE4934F908183C155AE5DBB467398155EC16621542851D49489A0D8';
wwv_flow_api.g_varchar2_table(2120) := '22840B9FA11526E069ADADADC843BD70893020B487E8227408672039186A68688065618E2A4568F1E4F8F1E3302868182E35363652455FE81702B4822C117B8447410821ED1027BA890CE48D56284403BE9188BBF2A3A2EF30BD5BB76E9D3B770E37F09C';
wwv_flow_api.g_varchar2_table(2121) := '8668533A11A0A7443B21751C093E0323853043B4C1421143156C0D31FC2441268194CED2539A70A3A609FEA09353249157A852822AA080225202B7A404A68D93A8559709B7C9C0FDF016DC708F2A82A558C72278328E1A0D40C1C702BA8972882E5C9484';
wwv_flow_api.g_varchar2_table(2122) := '72AE206AB14E436081B8224997C18ACB74ECD8312E10ADD00050C4ABE9201611808562822ACA410CC76802E664E8118168F4706970894B0FCDC61602FC14B92234C72BB4A10A19E0259FEB38CD55EF38A21F0CE93B179D5F424F4F0F76E93EAE82219238';
wwv_flow_api.g_varchar2_table(2123) := '4F0631FC04586A290110FA4E490E2585D5777A5C4FC8AFFFF069A5ABD2D7FCE35F7F72E7ACE1EA1E01FE7A3697B753173EB994DC9CAA2DF537779C11B3737FFB7BF7660B4AD71E24C0DB6943EFAD7BC73A833A01DE0F979ED711D011D011787611D009F0';
wwv_flow_api.g_varchar2_table(2124) := 'B37BED74CF750474047E60042021700F48C857FA01558030402C21304A9812481A448204E580AD419C88C84183510BD9201208F1800521069B82C1428F09E5C1D0E0BA909CFEFE7EB49147188E07F783D34241690E61A309113C1452AB3490873FD3104A';
wwv_flow_api.g_varchar2_table(2125) := '4382CC106FC43A26A04F505F489A0AF62A924939AEA28A72E42151E8A1B98A9122039FA4159E63029E06C58271214F4C1242A568272C9A26B8049B820742CC3842265188F334A1211D87DF42F33084DB082B94A8C2318C720A25C31C1842D741069A0D09';
wwv_flow_api.g_varchar2_table(2126) := 'A42125D057C8277D27C48D155A418F61DD904988250AE9147655009CB6D0C88E8E0E346388239AC10197705B4187F3EAEA286DC8D02F7A8D09182F7EE6D086DFD25F0428519795265C02504583EA386DB98E68569F33B804C8500B5F859DA213FE495257';
wwv_flow_api.g_varchar2_table(2127) := '0131F42049132E105F4C10269C8B512EB47218420B085C4D4AF8ED2924F1992F1D6082397E185C1190A11649FCE137835D42CDE08C72F59380AB23C00F982694A01685F8035694D05C7D34C1012E01AD94B7F4940C0260AEBAFCFD1CF33D961D6BF0DEAD';
wwv_flow_api.g_varchar2_table(2128) := '9E8AFA57A77B7AEDAF84AE5F1F4E24D7AAC30E7BB4F1F6AD3B66C376512434331A3FDC125836162E0CF7DABC01C3FC5CFD0B048AEF2F2FF7E1C08271B6C7535C71B37B3A5234331FDF9E5BDCB5AFAD1C3BD7D63D67591CEB3756699DDA4E66AEDFBABBB1';
wwv_flow_api.g_varchar2_table(2129) := '3812CA669ACEBC70A367322B0B62306E67E55E7FFFECC26638BDDE76F6A4C1A40D13D0938E808E808E808EC0338780E917BFF8C5A39DE6399D4BBC859078F2917858D290B7B18736A7C9FE778287CA3CBA90AFEE13D30B33D313A9CD158FCF23864771F5';
wwv_flow_api.g_varchar2_table(2130) := 'D58D9D4C7C63272186E48EC9AA3DEA56E3E971E62C2DCE390D3B16E7630D5B9A5B8B390D7183F90B0BB17E9993BCF3E5DE78BE4C462FD71178CE108081F0A6FEEC760A3AC48BFE23FCE7AE052BE0AF9BCC0131B807548A2A1854AE0A318807F140C8C057';
wwv_flow_api.g_varchar2_table(2131) := '2635F0987B23CD957E6812EC027A06D9E0A6AA58ABE2A8D012227B2A0FF7800BD110BA0263A409F2DC7B15F3C43A0DB92E8AD820462DB610A0BF9C42C320572854776F84B9778103325C50ECA29CDE91A70A6DB01DFA88210AC920891BE415D3A61CBBF8';
wwv_flow_api.g_varchar2_table(2132) := '80423A421508A0011308A3812A28990A51C245314A21020843AEF08D7ED1657CA02D38A0902A981EDEC2968131776B4515CA514B06F7C8E01E196CA193B6F48E42BA009944067C207B94A0990C5F041020628951E52A414E50429907344A000040004944';
wwv_flow_api.g_varchar2_table(2133) := '41544C95D053AE291ED247123290733E52504B434AB08E331CA9226117CF6945179493F8C0070B9AD00B0A5577001613C8AB3F169CA1FBF40E972841331AD0C975E1078018C092072BA501FF4938CF296AD1893C6208600849083C26B8227487ABAC60C4';
wwv_flow_api.g_varchar2_table(2134) := '1F3AA23E52C0FCD149D7D4931AACC8E03C4AB08B1E052CA49A42AE232E61057328C7731EEEB4C56710A010EB28A70497F0077318A52FE46988CE8726AAE0CFCAB7FD029463140D68E3B8BFEAD1799B49C6B7ED2BFD17D391DAB59B1F9EF9F1EB4393BB17';
wwv_flow_api.g_varchar2_table(2135) := '6F76C9E4654779DBFFFD1F7F53EE5EF11596FDDDDBFD15B6E15BABC1F9ABBF4978225B77EE54763488689F15F0F5F7EFF5FDF9515BD3B13F191813B371EDEA958B4E436C71DD541ECE2CA50253B7072BC31E5F69E59DF18DDE37FEB06093B9EE6B2D273B';
wwv_flow_api.g_varchar2_table(2136) := '2666B7EE2D8C9F692D5FB2047EF7B7BF0DB852D707E73BAA1C6697F6ABD6938E808E808E808EC0B78E004F22DEC77828F3C03AA09CA7124F5EBE83F368E389C6A93A92E1B1A58EB45289A75B2E293D9C927914AB3C60EF7B3EDDCEC8EDAEAB5E4BD614CC';
wwv_flow_api.g_varchar2_table(2137) := '8B94953CDAFA4E226DCCEC8E4C6E455DEB05F5CD08F7CFED2EF55CCE0B450BDD69A77C4573A5FCE2E0FC9F956C1823AD8FB6A5D7EA08E808E808E410E0569BCB7F6526471854061A43E21E4D43462053C87D19EAA2EECE1C19F39CCBC30C552B55028B80';
wwv_flow_api.g_varchar2_table(2138) := '93D090E68ADB9067A525A5843C85B01732C893E1083BDAAF811268A7128025429F282129664B399E5008CB52449D2A4E79EA28BB9CC27273E672B6E0A8F03778264F2632841C51C53389F0236D39A59CB62857AC985A145282F330CFFDA408D3D46282BE';
wwv_flow_api.g_varchar2_table(2139) := 'E7DC23064B61AE2D0DB142095D401234943CE5AABF0A5EBCCAD52AB72957AAE084CA7994F0B885A32A5B6AACAF3A7221688E4E92F20A61D05385E4E92F473C2121A37A4D09795825627C144046F9A074F2C026F28F8CF259F9CFEF811292BA6478421EAA';
wwv_flow_api.g_varchar2_table(2140) := '99FB79F04E0044C4AB9593D452A535D8B3853984B9F4240430A13C57B5EAC251AE7E63380337E64889EA14CD739D22AF0A5182E79C2A555C44B4E133AD34ABDF57E285E5706BD9EF2E78963FF8A0A5CA3E9D08A4B7AF7842E1E1EB17A3AF2C6FAC6D1C69';
wwv_flow_api.g_varchar2_table(2141) := 'A8F494D5E537EC7C7AE13F2FE5595E2E717BCACA8D36DADD9FEBABBDF218B23687F607CBBCF864DA604AAD9D6BEF5C72779AB3F387A3C1F9DA63E9ED196A67D6E25BE3E379F5CDE5C79B7D1EFFB9E3859F8C2F8829CDC60FF6D8F68FCE9C1DC8AC265767';
wwv_flow_api.g_varchar2_table(2142) := '6C052DDF57EF753B3A023A023A023A02DF26025FE3D5EDDB34FB18BA76D392DA98A8EF38E20E956DA66D1B8BD3738BF1527F7A55023B4BE32D8DD5EBE21F1A187419D66B6B6B246D15A36171693B98D0961525CD6F26F2CD5BB5F5F52EB77D3B9D1DB87D';
wwv_flow_api.g_varchar2_table(2143) := 'CF2D9B9EA2A0CF9DB7B5B1132ECA9B998B857CA9A935D3F2F470499EB1B0B26574613359B07A6F6C696B71ACB93A620F7CA36D33951BFA51474047E0F94600FEF0C41D8454D036A7419DAAA32ADF9FA72477BABF36D79C42524E86F25C9E722576A02477';
wwv_flow_api.g_varchar2_table(2144) := '9A133EA04D35847151AE084F4E5233B6CF9C3A55B570A403C294C303095A9241521D73D655092499082755AA56293C209CABDADF362749614E4065F697ECCFE79AA84C4E1B149186AAED43650E54E51AEE1746667F3979928A2AEF6F9E13DB5F98D34393';
wwv_flow_api.g_varchar2_table(2145) := '5C5E09A81298678EF1EE2F57C2AAE4402FF6ABDAAF13E68FBC6AB2BFB992DF5F4EAD3ACDA93A509B53FB9D66EAF26DBFCA6F9CB8F9DB9FFF377FF6E65472FECA47FED6933B697E542987C96473794C06C3A9CEDAFFEB5D4BE9F6C5BA7FF02F6F2D24F9EE';
wwv_flow_api.g_varchar2_table(2146) := '52D9C95786FB8BCF95D515BF79F937FE51C96CCCE4B5BD180C18ADAE40499E2D23A5DD7766FB07BAE2CEF9BCA6228B3334B6B5BA75FBE6E1D375EB31C3E5EEDEF9A13BB72FADFA8EE617F9ED6677C863DF36C8E717E83BEDB5AE5C47404740474047E05B';
wwv_flow_api.g_varchar2_table(2147) := '47E0E925C004453677CD83231395E94C5202D73FB9E00DE54FF62D8722FEB1B9EDA875DD50FDD2D0D86C7CBEDF6D4D2CEF5404CD0B66AB93D54E154626A3616679DBCCCA9C75D1AE89F8EA709FCDEBDD1C1BEA683F3C72773E5C74A4AB6FE144EDE66AA2';
wwv_flow_api.g_varchar2_table(2148) := 'A2B77F7022BDF20FC305568B692561BED175A9D09BC9946BA1153DE908E808E8083C88C00FF2F6FFA01BDF5B0931DBAF65EB41791053D1D107ABF66B7E74ED7EC9EF28FFDD39F06D698682122B7EB4B647D7E6A07B4CB19CFCE367723CF9F19B3C8EA4DB';
wwv_flow_api.g_varchar2_table(2149) := '24A74FB66F7B560AEA3B9B97FD81B6D3CEB0CF7EF65CBE2FEFDC8B47CCEE6294D4143825BFA6C2BAE6CCAF968583ABD69F6D0CBF355B93599A6F6F2D282C298AAD1E35DAB4E1F1A4B5CD1D5F289332BB523B7C24F705F32C667BA0EFCABD60DDC2F2DAC6';
wwv_flow_api.g_varchar2_table(2150) := 'E188677D25539C4D5634378BC172A82C64097C614577A5443FEA08E808E808E8083C13083CBD0498F93A8C65636515BE83C79292DA5A3A7CEEE87FFECFF113ADB2666B5C18B9E828DCF4DB76168C81F1F131B107DDD62D83E1F3151DB34C1A664E974176';
wwv_flow_api.g_varchar2_table(2151) := '0D32DBD3FF424B643BAFEE83DFFE3EB6B3BDB6B24EDC62752DB6B9C9AE954BA13CFBAD3BC69FAE8E8A212F93C9BAED46ABC399D5C63AE9494740474047E00B08F0664FA09228DC174AF5131D011D812F22F05D0C9026E47AAEA52CDBF04F8C4EC761B7B1';
wwv_flow_api.g_varchar2_table(2152) := '36EF474643CAC2842F9BFD4F5F3F6DB1997733D2373056EDDB3E7AE42531383AEB6C86AAD719B69C73ADC065F9F14B6724BE9617F0664DF6C6E63386BDADB0F87B6E6F8A34D7BCCEFB86D7690D4D240A2B6A0D4E53BE35E4733A5F3DD6623ADA60CC1A3C';
wwv_flow_api.g_varchar2_table(2153) := '0E8FF7C8610870677581D5A80D05D7938E808E808E808EC0B388C0D34B801927E73065A24505365724954947F29DF9A122877B3654E8F2882F3D6BEB9B5CB06C4D390355B19D51B72DCDDC9E6C26CB382D751932D94CD0CBAA2DD1AC383226632C918C6F';
wwv_flow_api.g_varchar2_table(2154) := 'ACC3A81D76DB6A263B3E3ABCBD34B39E708EDCB95611F5EE583CE99D582A93E736650ACBAAFAFA86CA9DDDAE426D769C9E740474047404720840809912F9C71601CE755FCFE8083C0E02FC81B0C6D5E3487E5D199BC524166D1D3E28ABD7F3F9276F8743';
wwv_flow_api.g_varchar2_table(2155) := '63B999B4C46289736D91B2F6537CE6DE13761C3091E7B28A4B5BBF0D3A6DB17ECE8D7D1EF2F74FDB4AD3A1F32F1932B1F268C8E9CBFFDC0C76F756C9B4991FB596DE018BFAA98E808E808E808EC0D386C0D34B80ED46B1872A8727160B9DBBDE7A8F2952';
wwv_flow_api.g_varchar2_table(2156) := 'C1E3AABC3420667BBEDBE68996847CAE2D4B7EB1D3160E56DAAC3EB7D594EFF638ACF797E588FA6C73D9BCD1D191C69240696BC3D8DD9B19EBB81812F91E5BA8AC746264BC30900904F3FDC18C31933A545568F2E6D7167AB2CE4C9A89C02E9BC31F78DA';
wwv_flow_api.g_varchar2_table(2157) := '2E95EE8F8E808EC00F8E000458A51FDC13DD011D81A716811FEA0B91DD24C79ACB9C965283F97366FB0428F9ED26FFA1EA2768A837D111D011D011D011782610787A09B0D3281D878FED6CAEB88C463683C8D4B5F3B9F6705B99C9612CB7B2894473C8E1';
wwv_flow_api.g_varchar2_table(2158) := '9993230E73CA9BEF3364EC6643D09B355B0DF7896B63D856D0F94236B9EBF239DA830533E6D6743A31175B7599D2275B6BB7973D0D871C8190DFEA2CDB5D9D2BF73A4D01CF4997D961CA8B66D72A02AE5069D13371FD7427750474047E400478D1677B1B';
wwv_flow_api.g_varchar2_table(2159) := '467B92D99F7029779ACB9361D9211682FA011DD64DEB083CC708F095DCE578AC8D0C9F6310F4AEE908E808E808E8087C25024F2F0166805351BE5FF8A7D2DE50259F571BCEE464F09155DB3FB0A2E20B34756F498AFB2F976E9BD15DF2F932CE15659178';
wwv_flow_api.g_varchar2_table(2160) := '56CA57D7C5E20EB9ED216F85D25AC0FA1779F7F3813D30CA8B0F8E985292FA514740474047E000026C9A3A3737C7263170609510501945803F2BD618F2D6D616CB0EB103CD01259CB25D2A23AB892D3F58C5B6374C39FE86B38E198FCAD4659C79C4A64D';
wwv_flow_api.g_varchar2_table(2161) := '30797C382080DBECC2C79E3A3907E83225EC15C40E3A0F7ABBBF840D7B61FB34A40B6CA4C452D2F89013A0CBD8CAA9C543F061EF9F5C09BB0DABAD628105A39CEED7C0291AD45E41D4E2BCCAE7F4EB191D011D011D011D011D011D011D818722F047B494';
wwv_flow_api.g_varchar2_table(2162) := '0B2F6BED0D35E20C3D14882728E4D5F0095AE94D74049E5104F41FFC83174E512F08304B1C43C0D48EB21CD9F32697D8934625A81DDBCC3EA884922B57AEC04E1F5A75EFDEBDE5E56555058D84553E54EC118568EEEEEE5E5A5AEAEFEFFF322B5CDCD1D1';
wwv_flow_api.g_varchar2_table(2163) := '5128E8013D94F7F4F4402F5539CDFBFAFADE78E38D8B172F7E992A24A91A1919F9DDEF7EA7486C5757D7DB6FBF7DE1C205B5EC303AEFDEBDFBE69B6FD21DA5162AFBF1C71FBFFBEEBBBDBDBDAA845D733FF8E08377DE79677A7A1A1A7CFDFA758CE2BFFA';
wwv_flow_api.g_varchar2_table(2164) := '11E2E7A79F7E4A09B5F886E63FFCE10FF451B5D58F3A023A023A023A023A023A023A028F40E0E98D003FC2E927AB321AC4EDFC76A2BB4424885DF0EEFB649EE8AD74049E51040E84079FD15E7CBB6E13D5B4DBEDABABABF034E2A2443BA173F034482081';
wwv_flow_api.g_varchar2_table(2165) := '5336BF85F591B8694041C91CB0BEB2B2421504EFF8F1E3D4728A12E8345156125C1A2649609612F4DFB871834C5B5B1BF9F5F57587C34150148BDC8BE0846AA3DD9C7EE8251AA0E58461219638333838D8D0D0000F471E5BD4C2CC954554218627388F2A';
wwv_flow_api.g_varchar2_table(2166) := '64308D2A4AA8A28F3052B8B78AC1A213AF7043C9A00D047276C9D0F7858585DBB76F9F3973063FA1BB6CF00B413D74E810DF050087DACB972F777474A00AF9C9C9C9B1B13176F7B975EB566565251F1468821B741625E5E5E5D4D23B4832B574E4EAD5AB';
wwv_flow_api.g_varchar2_table(2167) := 'F883331F7DF4514B4B0BDAE808E0D4D6D6E2ED7E4FF4BC8E808E808E808E808E808E808EC00104FE8808F0819E7FC353F5A6FB0D95E8CD75049E2D04BE72D4EBB3D59D6FC55B28A2D2039F54EC170E099924F849220FD5043748EC83EC970026914C6824';
wwv_flow_api.g_varchar2_table(2168) := '740ED208D983F81514141C3B76ECD2A54B343F75EA145C14E6C9295C1161E85F4949095416D2083F44606262626A6A0A1E0B39A4616E9831A16382B7B0CA13274EE49C54AEC28767676709475754542C2E2EA2E7ECD9B358C1DB9B376FC23CE9CBCB2FBF';
wwv_flow_api.g_varchar2_table(2169) := '0C6B85ACE236EEC15761DD88D5D7D74332E1B128696D6D45E1C0C040636323E690C45BDC809A722C2C2CA4162B14BEF2CA2B90D8F9F9791A725A5757970B082343AF9B9B9B8F1E3DFA377FF3377404028CB6175F7C1128288160D38BD3A74FFFEB7FFDAF';
wwv_flow_api.g_varchar2_table(2170) := 'F10404868686700FE7FFCDBFF937E0909F9F8F63FFFEDFFF7B6A7502AC2EF1F377DC49691F4A226E833BBF7874763520CBFE4875AE9BCBB1F4E2D4084B5A16053D08E4CABF7966372D1353D399F8261B331A3399D268D0E6F97A1B20EDA061722A1DDF8C';
wwv_flow_api.g_varchar2_table(2171) := 'F8ADFE48D597B934B3B265DE9C2F282B13F9FE5ECCB69299A5F199F2CA9018EF7FC352832CD41D637FFECBDCD6CB7504740474049E4504BEBFFBECB388CE237CE68D96F40801BD4A474047E08F0101DE11793156915838243C9638391151C830DD874C52';
wwv_flow_api.g_varchar2_table(2172) := 'C2DB24856490CC61025D84432209014609449431C3B422B81A8D46E1AE103CD82C550C06260FEF853D12EA84BBC278A1970C8D563412E2CA291C151A099BC504CA094A335C797C7C9C1869CEA87AAF85B232721855D0DDF6F6766C757676C22A61E99070';
wwv_flow_api.g_varchar2_table(2173) := 'F24C6C66443404988677EEDC81CF534EF4985E4083710043D7AE5D433F1DC79032A70830CE6005EEAABA4C8672862BD34110509E5088AD9C5710D79A9A1A4EF9B0887E32B8475EC105AAE4298418A38A8C8ABA6305F48005DF1802ADC0A7564FCF2502A9';
wwv_flow_api.g_varchar2_table(2174) := 'ACBC7773B42679BBF94FFECBDFFDFAA39F1E35E608F0DC66F29D8F2F959997CDCE7C5B2AE6CE677190CFFFD0F6A3C1A8AD6B17FA8E35B92DFED2FDE5FBF35B19E9B9D675B42E60F2C345259591D5F5ADEE817BD989EE9663C74A0BDDFB85BF329FC8CA3B';
wwv_flow_api.g_varchar2_table(2175) := '57074C0BB79DC1687FF7F8D9A39B79156DFB5BADA6E4DEE5CB9D476AEE4CC47DE39F169495ECAFFDAEF3EB19C3E54F7ACACB3B20C0E9AC740FCECEF6DD3ADA5A1CAC6CE91FDD1C1EB8D01C3597B79CE36FEEBBF644D7AF23A023A023F07D22A013E0EF13';
wwv_flow_api.g_varchar2_table(2176) := '6DDD968E808EC0F38900514A3A063183FE89C1087F63656827BCCDE948A7532A2AABC229B9FE734A4494382744147EA8E2AE3FFAD18FE0780CF7256C0BB19C9999410C6ACAE05E62AAB044D6D0C2165FDF88FD32B7160A4A73E831EC94F1C38A756382F1';
wwv_flow_api.g_varchar2_table(2177) := 'CF28272E4AE85873692FC11819900CC3848856575733209989B8E88124136DA69672E2AB94E03025C3C3C3E170180720D52FBCF002238DA1DCB0626A21ED447D19810C8F459E86F88F6648AFE2A818A42179B82E6C992ED00AB64CEC9A5E285BC860053A';
wwv_flow_api.g_varchar2_table(2178) := '8D4E827BC5C5C5449E51454C1B4948380AF107960B79A60A8A0B25266C4E37F144B165B4611ABA8E278A27ABCEEAC7E70C01BB590291928F7FFDAB49C35BD9D9BBFEC83FCC75F0BD9BE3DB439FD4FDF427264F912195DC486687BA070DE9B5AA48D01AAD';
wwv_flow_api.g_varchar2_table(2179) := '1CEA1F4E67622C3457575DD4BD60F9E5DFFEDAFAE3A2A3E77E3AB064D89E1F2E72D9DDD5B5A3FDC39974C2B89BA8AE2BBD3E9FF9ED2F7FE97DA9A2E9FCCF583513BB3565D18B231BD9E1FEEAFFEA67C333A9C2F5217769CDDDFE11AFD7B8B1BA914C19ED';
wwv_flow_api.g_varchar2_table(2180) := 'D9DD86A6CAB435D03B3C236B3365058140E9FD48EFD052E2E27B6FFE8B572ADDD50DFFCFBD2DF7476FB4E755CC8C4F727FB0A4772BEBAB2E0CAE5DFAE57FF29B5E4E98AA0D99DDAC98FB461662CBE32197ADA2B17E747E676B7E34914A879DA6687DD3C0';
wwv_flow_api.g_varchar2_table(2181) := 'D85A6C79A234E4D8B446322B53D58DD562B81FB98D2552A3F7A6E796A61AF29D450D6D7726D7A7EE763595B88BEB0EAF27A4EB729FC5B070ACB57ECD121C1B9EDC9A9FE9688C1AC255D76F74C736C725DBC992260B5BA94FBA7AAB64352BC5DBA94CD727';
wwv_flow_api.g_varchar2_table(2182) := '5D76DB62B68845FB1EB2385F0E7C3DA323A023A023F02C22A013E067F1AAE93EEB08E8083C5D0828F605E5733AEC99E44EC668CDEC6ED88C9B66B3D368B2A65329781D6C707F041842585454440897E02D340FA2C8E862381E615E881CA40EAE08FF847C';
wwv_flow_api.g_varchar2_table(2183) := 'BEF6DA6BB0594EA1854C7F6530300CF0ADB7DE4227639E2927920C89655C718E01628829C78C9A863093A71C6A4A041526093726A302C52AC68B5A64F00119AC832C041BF788FD32A218B24A09AC5BCDFBE594802D25B88D3C0E938157D3770A39AA0C79';
wwv_flow_api.g_varchar2_table(2184) := 'AC283E4C5F8821E32AC49E3075555515CAF10DD0A0B5387FE4C81156C0228A0B08744D45AD99178D1BF05BC8F6FBEFBF4F2D799443CB993C0CDB57FE00023DC27F02D758C4AE9E9E4B04CC06397FB8E2D247AD9FFCEE57FFC3CFCF7B224D8B6BDBA92DBE';
wwv_flow_api.g_varchar2_table(2185) := 'C804AEF78EFEE32273B8A2998E33EEE2AD8B839BB73FB1954547AFF6B6FFB9E5EF7EFFF1E966EBED818C61BE7FB9E8F4DAE4ECD6967B7861E3DDB7AF9B2D1B8EB9E9F6BFFCF3B77EF74E5B53F8D6C8CE4FE2FD8BF6538B4BB3EBEBFEF9E58D547AAD30E8';
wwv_flow_api.g_varchar2_table(2186) := '0BF83C2EAF2F63B306F2437FF7D168E5D647553FFE671FBFF1664967DDD8879FD69F3AD1D733E1C9CC4E7A0EDF78FF9D8C3159965A3EFFF37FBEB995F2D98C7DB366C7D65875D34FC51D2CAC3F3CF0C6AFDCD3739FFCDD6F0EBFD8D237B0241B130BE9EA';
wwv_flow_api.g_varchar2_table(2187) := '959589EDB5F50D473C10FFFFD97BEF27B992ECDEEF96F7BEAAABBADA3B34BA1BDE63008C0106E376874372976FC9273E91D44FFA557F81F65F50500A4648F122DEA3248A6E77963BDEC1BBEE467BEFBD37D5D565BBAC3E85C4D4F4C2CC62C7EC0098CC40';
wwv_flow_api.g_varchar2_table(2188) := '5CE4CD7BF2E439DFBC7DEB7EEF49B305F9BDFAE917F575D6F6F6F09FEA62B7165CB99E7FD7D59E6D1FEF7EDDA0FD970FFA0E3B3782274EF62D6DE6076FD737951509F06C78E7F27F5CB1D55B63B38BC75CA5ED5D43BAE4EA95F5A59FBB2C9DB18A9E2BBF';
wwv_flow_api.g_varchar2_table(2189) := '6D3E54A3E4EA7BE6C2D337AFE40C0E7D6A76DFC5602C1C09E9195591DAD8513EBC7CBBB7F3EAE1971AF41ED7E737477B6FBDFFE28B0D6E0FE3C91F1D4E7F2E6F33E994444022F02341403ED77E241D2DDD94084804BE170404DF83CBC1158D4693D590B7';
wwv_flow_api.g_varchar2_table(2190) := '45BB6C4AC8B97543BF76273F7F359BC942D2E0751C775B009384C8098AFBDA6BAF410E45E81572C82514322796282B7491402EEC0E8E070364362C5518D58C00AB4311194618E2077D451EEAC8CAC92402A42FBCF0020492235C9771CE704BB4C16FA9CE';
wwv_flow_api.g_varchar2_table(2191) := 'DC5DF4508B124C22420B0726868C0C929430AE18E5C49CB11907E1B134871955555550592ED12885478E1C21328C6134012D478080B620D528C11ED4228947988730475C409EAB5484D9021A0EC2D231893C3254C73602D4B445701B564F7358281C4421';
wwv_flow_api.g_varchar2_table(2192) := 'E3C311E32A88C19C51857E6AB12897D04C894CCF2502E1D88E2E9F569BED914842C9EE2C6D84A727C652B130B373770A23E70BC3E36379E5F6D5D6BD9EADC613C7AF8C6C6ECC0F2ECC2FEDAFB2C58CE5C35D035595268B96C10BB55DF3B9D5CE6B5EAF33';
wwv_flow_api.g_varchar2_table(2193) := '6BB26E86631B0B73CD359EB0B56CB1FF7A45C067B65AB901E7427C6D99CC2442A8E5AF800F3CAA7CD65DE5EF1A5C6C6F6B77E757A26A67766DFAC891A60D75B0FF6EF7D51BFDF9C53E4F893FADD16D6D47262666B796E68DBA7C26C7DCE4C2C0FE34AB03';
wwv_flow_api.g_varchar2_table(2194) := '6835E19D7C6C69FAF0E1BA6D4BE5547B476965C061D6D7B6EC59D9D686D667BAC65695D92E6EECC9AC77A2EBE6EAD6B625BD54DB74B87B76333C37BC93CD2CCDCDC737C3750173DDBEFD45F68BF2ED58D6BC123EFBE2994D4535333D65892DBC7EE1A515';
wwv_flow_api.g_varchar2_table(2195) := '534B78A653C9A90265068D419F8C6D6D869375E64CCB4B2FCE6F84CCB9C40B270EAEE8FC4A7E87BF49FEA2F35A83DA685429FCCDAA0D56B5C16852DDFB6B45BF4C1201898044E079424046809FA7DE94BE480424023F0002BC1BC36F396659BD261652CD';
wwv_flow_api.g_varchar2_table(2196) := '5ECA0692EAC9F772DEE379CD46C6F7025372594FB93836B86822148EC59C8AA7505092382D968B50ED03E5F04098A19084C74217A1AC9C12F5251C4A86C1C3B06B21C0112ACB512CB95C2C24038DE408C3E4283408199695A284B831A157F27066C62753';
wwv_flow_api.g_varchar2_table(2197) := '2252D118D8AC28E1D5195FBEBC7EFF7FC8B9C8B1C075F1123455E45B5A5A448691D864C47A5AA244B40E4316A71C05D115A722CC0BD916A710F20B172E88BC3C3EC7084476B21F7ED6D9A44C6B7FF69FDFFFF0BDFA431D5EE701BB52A937598FEFAFEAB8';
wwv_flow_api.g_varchar2_table(2198) := '79ABB4BF4D6729CD685516873192C8E93736ED26456BB0EA1595CB6ED5D99D91C5A4CBACD5B8DD445B35F9345B6F975974A5C78F6A2D3EB526EB74DACD3625BE1EAEB21935463B2BC1F9CB8C697D99C66007D56C3ECF472C26099CDD57DAF16143E8F207';
wwv_flow_api.g_varchar2_table(2199) := 'FFF39F9EECB095A732EAB5F59026B3612BB36BA2BAAC4A5D536237060B9F7ECACA3436B3A6C5626F2B69EEEDECB2D4E837477BCE3637872DEE4C5EBDB6B1954F6E3A3D1693DB96D57B63614655685539C568D0A6D57A9682D3A763569B33BFA3B2180D4E';
wwv_flow_api.g_varchar2_table(2200) := 'A72BA3686CAAF8C92387AE7D30537AB7ADF47C456E3BA2F0C8F97278B2269B2DB3BABCFE80C16C647E7D6227BFBCBC96DD5C55951B02364DB8BCA5ADBF7F8F3961B6BF5459EA4BF9FDAB7A5D329559DD8C6E8536E7C6A62AF6068E9F3C35B9B974E6A5B3';
wwv_flow_api.g_varchar2_table(2201) := '8AA6E4F45925DEBBE7E5F3E7348F9F2CFD1CDF6CD235898044E0B9474012E0E7BE8BA583120189C0F78800315212E4369F4DE5E32BB96C469DDACE6A1C8AB93C9F49A8929BF96434AB66C1BCC2C648DF871D3061DEB6856618A9E0B4C47EBF7D5B046F05';
wwv_flow_api.g_varchar2_table(2202) := 'D326FCFBEDB5490D12816F83402C9DD3EF842EBC7CD270F44C787A331A0E55D6DB156FE1CEBF78C8F2E9F6C599B9258379A7D26BBD70E185A536956E66E6CD53B5FEAAE6A38757D5267F73A5D9A13DECD19B4FBC75723D3C77F4A069FBCC0542C67A8DC6';
wwv_flow_api.g_varchar2_table(2203) := 'EF301F3874586B743555A84A0DA7A18BC74EBEB8195F3FEAD6314B56D85CEFB7E78F9E545406BF49557AE0D8F207D7CB9B0EDE9DD58453B999A9A903A5CAFED32F1B93C111FD462E9BD35B8C4E9BD5E928AC21C79274E75F7F7D61FAAE7E66E648503970';
wwv_flow_api.g_varchar2_table(2204) := 'F4F56B61632CADCC4ECC3539532DA72FE4EDA6C6D36FAC6FECEC09E84BD587030DFEF0C117A7A7678FFAD575475E9A9FD5054C47AC06D589C3FB1547A933993F78E440A537BB165365D656EE8DF8BE0FAACBAAD7ECAFE295AE22585B55159C58C80D0E8C';
wwv_flow_api.g_varchar2_table(2205) := 'EC31E5ECD52767A2897C2A5FE2F35B4BAA4B8D66339C58CD07AFFA78D63031395EA9CBCC4FAD5534246C7A534B25EB87E9D1C81F7C795D755EFB3BDB9BDD6F49FE2711900848049E7D0424017EF6FB507A20119008FC70081402BFA45C5E4925D413EF2A';
wwv_flow_api.g_varchar2_table(2206) := 'E6405E6DCC698C8ACEA6E452EAADFE6C2A92D16B1961F83D1160261217BD87F77E27D4572864D4311BF91695CB8C44E00744C0AED7BC7DF148A9D7A2D6EBFEFCE7179D4A61A483483EABEEA7E74F6CAD2D31D4B8C46529B37B97ACAFA83291128F436D75';
wwv_flow_api.g_varchar2_table(2207) := 'BDF39397F50EE3CB87349AE6B78C6AE39B170F27B6CACBFC9E375F7B39115E35E9D50EA7FDE24FDED03BADAFEC53F4E9FF64D5293FB970261F5B570ADFADEEA71375DEBCFFCFF36ACBD26AC4940F9F3D7640E7AA4A8F6F97B8F3CD0D0D8EC34E4749F0A8';
wwv_flow_api.g_varchar2_table(2208) := 'A22AB55D4CC7B79C5683A22ED048127FF82FEDAF5C2CB1B00D52C06335D8BCA98D90C396D9DB50C30C7DA7BFF0C7FB93D7CFEBE29BE57687BEC16771182E5E3C9708AF39F6EBECBEC0194BCA98795B6BD6FCE95B178D7A9D3692A82F7506FDEE70CA90AF';
wwv_flow_api.g_varchar2_table(2209) := '7628EAC292EF2295B94DFE570FB10BF68196A3769BF9A5177C9BABDECA12B3D15311D424AD0DB5267DBDABBA5C9FD6E97D2D7983E2DC7F5CD15B0E37541CAFF11819E7AC31FBCDAA0B87F629EAC24EDA4CA63F70F2A8C65CC8CB2411900848049E3F0424';
wwv_flow_api.g_varchar2_table(2210) := '017EFEFA547A24119008FCF1101004B8406ED5BABCDEA9243632FE73598D55A577E534A6B4D69B5519724C03FEDE22C07F3C57654B12811F0E01B35E6D0E1676962695B9217E5F713F4A1C46B5A3A2ECDEC5C2A1A2CCA328FC2B247F49615DB7420DA530';
wwv_flow_api.g_varchar2_table(2211) := 'B0DF6D352AD6C27C8112A7A27C39BED7E02B446BEFC9B0E831974C8AB320534C4CD32D7CDB5294B570BC4CBF7DE68DD71495A5C693AA387DA6B2A6465199916430725989035B8AB544060E5CEEFFCA9E0A875EF3C20B5535F58AEEFEAC81529759E15F21';
wwv_flow_api.g_varchar2_table(2212) := '15ACBCD7FAFD5D9ADC7069A5A450786F4F32BBFDBE7217FCDA5A282F26834E6DF014E2E1765B4126E0D505BC8DE26A99D358E6BC9FB714487D61AD38BDB520B6B7F62B3751E9B1DF5F468E5D8F6CCEFBE34A841279940848042402CF130292003F4FBD29';
wwv_flow_api.g_varchar2_table(2213) := '7D91084804FED80840809970CBCCDB7426AB75BF9C892CA5F51E256DC8994F6973719DB72CA732B01312C3891F9E03FC24B6A29C359659BCEA1BAFF0C43648ACD55C1C26FD248D3E5206FB719349C2F8B25B80459EB18D70F1EE42F2943337984D8C1E28';
wwv_flow_api.g_varchar2_table(2214) := 'FFBDA72C0D8D42D6C462292F66FC12D3A6845991E48B338DD9938985A9391553824573C8B0B056D153AAB3CD122B7BA18195AB8191AB624E35F2B8C34653008B3B2C8EBD5B9B408C9EC578E1320650F7F75ACEF65724B192F62385D1437971B1EE47CA3C';
wwv_flow_api.g_varchar2_table(2215) := 'B210F39867FE70451C1496176B21865FAC0AC6A5ADAD2D7CC7E587C70588DE7C12A78A9A6586FBBEC267AF751D777AFDA071A0C29EF7FC4C51FEB03BBCA9C454F7D63B8A56D24B79434904240212811F0C014980BF21F4E275E41B5696D52402CF2602F0';
wwv_flow_api.g_varchar2_table(2216) := '9987DFA49F4D57BE1BABE14E8200C3AFE0362C9A9A48D9B3B198469B4CA7355A9DDB9ED628A938744E483EAE55082AA485C590770BC0F1401B0E0693F91A4EB5BBCA23F3503876D92DAE3EF548992729845E62D2C394898D7999242CD6D9DAAD677C7C9C';
wwv_flow_api.g_varchar2_table(2217) := '0D8AFF50024C2C9D7D80E16FB4353232C27AD72CC1353C3C4C1378C172D0D0391EBF5C45923D8459EB8B55A0294186BE60F7603C65652C7A840D9328C17D56F9E22A85ECABCC7ADAC8C312D99A787A7AFAFCF9F3DCD5E8411B7B4D51579CF2DD811E614E';
wwv_flow_api.g_varchar2_table(2218) := '35E0D33496B08DD36EEF1E99470904F8919728C4185A84B43FCC631F57A5580E26D47AB82276D262F1BB00F2C2068EE08FA77CB0E053C2C37FB620303434C476D3C52664E64910F0111C56EE0F0CB6E8350A5FBBFEC064D2A94DEE3FB8D61FD888149708';
wwv_flow_api.g_varchar2_table(2219) := '480424021281AF434012E0AF43E771D7788FE1AD88975AD2E36464B944E0394380576A22630FBF493F676EFEA1EE000B55C4A320118FC12B38D5A87589749C756337761290101808248A98DBC3B153A817314C2275D015F60D822E128D8483B1B96E4F4F';
wwv_flow_api.g_varchar2_table(2220) := '0F6843F9D020A2945050A80E214D9A806F43E72887DD41FFD08025C813E72418CBC460A8D1FCFC7CC1188D868A6420785CA5BA20B1C843AB1063DD2CA2B5AC202DB6384286537422060924A0CAB2CC3CF4E09F980A57472D3AA945881501CAD149062646';
wwv_flow_api.g_varchar2_table(2221) := '45F82AA40BFEC955168286F281090228A784EA6458539A4728641558508EF1907FA0C03BECA19CBD8E7010B3059FA445168566CF64F48B102E0A41E9EAD5AB50568C11AE8155676727F6A313D70087A5ADD9311849F4B0DFD2EDDBB771130B4183ABB068';
wwv_flow_api.g_varchar2_table(2222) := '3A45D88092D6D656F685A29CBA08C399595E1B497CC7006A71892D9AF002DB040FC71E810F0660391D2DEE04BC4633BD408F4C4D4D5148450468114FD1863D6CF2049EE0861204C0932A5CA2456428C7471080F462212043F5E971C0C41D4A000D9D9844';
wwv_flow_api.g_varchar2_table(2223) := '1E0D24300740F1AD0437D9C699A5B6D18C6B180CBCDC1868A6676985DEC718DA92492220119008480424023F36042401FE863DCEABCCC391906FA84B5693083C2308F0CEFD8C58FA4732136A448263C052A02590134EA11682A2404E7850600A0C44F010';
wwv_flow_api.g_varchar2_table(2224) := '8E45CB10234409CF214C2AD80BE41001A80E74850C857C7120800925463F114BA823140B0DA8859ED11C948916D1CF55F450C256C01442CF08CC5217460D434380866044340A5523EE47090D418A606888A10D49DAA51C02890CA7A882A1419690A7221A';
wwv_flow_api.g_varchar2_table(2225) := '20B4486215F6601E7151C4E05D303D083CA40E6D703682A55035383CA7B02C1452577051982D04122686720A718428AB20C648622ACDC19FC990680B677190872DAC18F7698E12D41222C641F89E801488C4A7011C179C190648501ABE0725260FDB2471';
wwv_flow_api.g_varchar2_table(2226) := '5510603A88ABFDFDFDF885064C85F4D22EE5821642A1E93E90A49C6D87810837B9FFC11F4FE19050650A21BA204654199A8D83F42097C067747414B5907CACA26B60AA7801AA38452BF808F234049E54149F0FD0435D1422493FD21754C75A369D0228DA';
wwv_flow_api.g_varchar2_table(2227) := 'A5E2F5EBD7F148B800AA5411B5B0847B0907510BF860CBCD80317063704386BE461EB500086E680679BC2BDE8D32231190084804240212811F0F025FBD8DFD787C969E4A0424021281EF0401A805DC83502D8407D601B11189A01F3403D601FD20333939';
wwv_flow_api.g_varchar2_table(2228) := '095784E609FA2A9A865F91410384073A07E322C608CB825BC24FA02B144217A942217AA06AF025649087DBD010A78428613E90250A09ABC2FDE096F0343812548AE030914C5810640C460A8F820142CF5005F981C8C1A6504275124494E68436A8269C16';
wwv_flow_api.g_varchar2_table(2229) := 'D7A82E682AD5E172F043DCA410CDB88312AAA3134784E594C3EBB01F468A3D14D2167C15106077103068271EC12AC10432464308A099E82E048F53582232BB7B0767C10A17680885784A42036EB20514268992229D439812D492D043454A449E72D0E0B8';
wwv_flow_api.g_varchar2_table(2230) := '5B3F15710ACDF8C2553463396A91A196089EE302AEC1C36198B44BD7F069003739E229750110024C5BE4E96B5AA41FE90ED0A6AE68912E43061C209F80802A34F01D017FE1C0DC33F40806000B32B059A8BBD003F85444094DC3A581119D9076EE0A34D0';
wwv_flow_api.g_varchar2_table(2231) := '344724E9413A8B3C3613070655FA974EE4946E053D6E3604B82DE941145265370E322F1190084804240212811F09023202FC23E968E9A6444022F0DD23000F21C1E504972832AB4766E02410A7DD46C06621BA3055A80B340CDA035181D8C0A3D000B982';
wwv_flow_api.g_varchar2_table(2232) := '41514E9E12688F886DC2D008244266C45541AA2981386109C4862AB48200D451A8A28453C8152C081B044DA2047A861264902703314309A77027E8283AB15988C1C108452286A7C20C32184613180651440CCDE8A73A9C9053F250411C441506204F21F2';
wwv_flow_api.g_varchar2_table(2233) := 'E4010D312C473FAC12CE2C7829BC1D0E5C1C5C835A6A010B140EAE8B5A182036C32D090E43FEA985310048D37C83C048F4D30A30E2026AE1B178049984F541383115A790441BBEA01F3340637070902E401B74110DF40B9748A21F8B9E72095FA8283E43';
wwv_flow_api.g_varchar2_table(2234) := 'D0117057DC412DDF1DB884795CA551AAD01036D03A08406E41038558828F907C3480366208E3110934F01464A8C8D710883497D08C49F848099A912183FB24AEA2070B859168A6097CC71E24D1830056719556700D4BD08C9194D0342D620F92CF4A4A65';
wwv_flow_api.g_varchar2_table(2235) := '95CD8D75B759ADB7BAD7B6E3E6ECB6C5757F51685CD8DEC96DAD2DEB54D952D67CD659C2B19DC85648C9A55D66A3C5C31F9D2A955336D636DC36ADC15CE841305A5959CFEEC45D66836277A72261B78B5D8574DB894C746B3D9349DB4D3AA797B906853F';
wwv_flow_api.g_varchar2_table(2236) := '8D9D6C3EB4BEC96C6BAD920F94B8557ACB562C95D8DE2871DB35064B32930B6D6C3AF42AB3CB138AA5229B2B268DE2F597A8348505974991447A3BB499CBA65C168DD51D8CA5F39B2B8BEA5CD6E77144F306733EAE3639D73743D99D844E9DF3FB5C2AFD';
wwv_flow_api.g_varchar2_table(2237) := 'EF2C702D94C8633AA7D0354E87AD08EC7788C9C656DCAA4E1AEC8505C365920848047E0C08687EF9CB5F7EBD9F855FD72F53E18DE05EE840FCE453911FD44756A7063FBAFCE23EF2EA1316F2957E692D64C88435466B26AFCC2EAD3AF419D5637666E7D7';
wwv_flow_api.g_varchar2_table(2238) := '716A61D1CDF0C02F7F751ED94A32A32C2E2FB16582A2D1AF6E25535BABB11D25170DEB2D9647CA3FAE90AFECDFD2BBC76996E51281A7160108006FDE4FAD79BFD73088040CE16BC4786AC161443CED013188191C03048AF40C01B401089C849821CCB398';
wwv_flow_api.g_varchar2_table(2239) := '08D33D9C0821C28868A2A8196A8449105D2275D030488BD0095D8120F174852C510592866661182DC206E17BD84315A27F34441EB683794465792E519D42C81292F01C2CA451111F16A48856F0510CA615E40ABF28214F6C90A7375548D02422931030E4';
wwv_flow_api.g_varchar2_table(2240) := '11E012D5F909402DC40CAF3100FDFC1C102EC648C1F70869E217335AE15A5C452796907007A68A79E8876D0A1C50C82514C2AEA90565C57241326994A661C8F03A6CC3004A508B0C6DA116AF711F8E07B3850CC31811C30670801922895A04086BE32957';
wwv_flow_api.g_varchar2_table(2241) := '310CDC4884A329C40CF4030B47B0C53084C9A01077680B797A0117384521C843506988127C479EDE41985E433F20A01301FC421E4B0495157AA88B723E6D601BD0610C15B11FEF60D148E20EF167EE0434208C1728A72DBC86F673CBD144D1600C43805E';
wwv_flow_api.g_varchar2_table(2242) := 'A60454D1038628A1105FE8322C449E3C2DA2012FB0968E036D8CE42A97B0902EE6BEC2C2EF2371F37037D2D6EE1B9E86B019DF311B018E4FDE743CABBC77B92333D76EAFDAF39B776F07B433CE60E12B06693D9EB974AD23B9393EBE1CCDAE0EFBCA2B2E';
wwv_flow_api.g_varchar2_table(2243) := 'F52C4DB7BE1FCA68A7BA5AABAB7C1AA37D706DE757FFF4CFBEECB4AFA6259D57DD199C99EFBB0135CD6F856755E6DEAB1F37EFA950B4E6EB631B5D977F8D913A55C65DF8E850785CCCC5F39FFCEA37EAECE6F842646361AC22E0BA3216FBFC37FF4FAD23';
wwv_flow_api.g_varchar2_table(2244) := '610B34F4CD6DBFFB4FFFE64ECC674A1B6E5EB994DC5E8D8498850ED5BEBFA5D0ADB1B581CF7F9DD168ADEA78DA1CBCDEDA115D18E04B8ED598FB7C34645A6D4F3AEA7FFBDB0F0D99F591A5EDF86CAF3F58A6D6DD5F67EB9E7F854336AF740ECF8D765FF7';
wwv_flow_api.g_varchar2_table(2245) := '59733AABB77766A3EFCE2D9726617295748CADF6DEBDB5BC30EDF2583716566D4E6B4AA5599A9E5DD94EDCBDD331313EBC30375DE933ABF4D6BEA9CDE86497BB707B7F35FAAF7D64A1FFEEAD89F171656D29E3F6DEBED536363A1CB4E57516F762247DA3';
wwv_flow_api.g_varchar2_table(2246) := 'B57D71A8DFEBD48EAE66EEDEBA95DA1CF30502336175DBADABD3E3A37655D4E80C740CCF0EB6DD30A5A3565FA06F3674B7F5963513B27983ED9DD3969DE99C2D3036BFA855E5AE5DE99F99E875E9765266EF953B5D63FDDDCAF6822758D63EB2D6D7712B';
wwv_flow_api.g_varchar2_table(2247) := 'BBBCE0AD6415C002E01B914C32B49835D86EB675AE8CF7F84B1C1ABD259C535A3FFFB0BACCA131387939EC9EDDEABE73DDA58E2876FF8D5B03E1D9EE127F61E7B9EBFD53937D6D652E83DAE4E89BD8E86FBBE132C48D76FF7A32D579ADD3A58B6A1CDEB6';
wwv_flow_api.g_varchar2_table(2248) := 'AEC9FEEEF6B1F1B14C6CCD17604500CD67B7A72C1B5D8ECAC6DEF9AD8E3B371CAAA8D55532174AB75EBFAD89CFB25D7332ABBEDDD1B73876B7D46B53F4B6B611B2B74BD8EDCEEA9A5A8DB7DFB8694C2FDBBD413E1016BB4C66240212816F8300BF95FC22';
wwv_flow_api.g_varchar2_table(2249) := 'F3D3C92FFE037AF82DE35798EFDAFCF2F253C8A93892E107541CA92512BF41C524F4704AE6A98E0063E0CC4A349D9CAA3A56B299CC0FF70C565F687E0085E2290FC42C7B6D2ABF33B6AD78B5988964949EA1914AC71E3E12F32397CFE6A61742BECC82F5';
wwv_flow_api.g_varchar2_table(2250) := 'DEBA324531999108480424024F8200AC83F424920FC8F00886F040C06041F013E694F2E0E6990E0F84964012C4431CFA072184AB4011E12D64A0435CA52E0483E73B8407D604BD21BF6FDF3E880DD5A9851802344A75980655087B42B4604A452570277E';
wwv_flow_api.g_varchar2_table(2251) := '3F1016FC934B18C35554D1BA188ABC77EF5E1817CD611EDAE0AEA8254F2D6C16CD51858AFC02518E3C8C14EA8530470AD18666882B66602DC268C3187EDB90C130A8B5700AB287008522C109B190C4624E904650026A4EB10DA770190CE17EB4887E8C41';
wwv_flow_api.g_varchar2_table(2252) := '4608401D310F532160305E61155EC03FA92BC2BF140217E65148865F03B4E10E1AC890502B9453E5F8F1E31036D82396A3164B2864CD2D90076DC4F0029B018176C963243FDE94A3078F60F5380B11450610D00CEC50744C42984E17B701205005BF7087';
wwv_flow_api.g_varchar2_table(2253) := '2A9C220C5D274F4560040732F40B66A31933F04258CE914B459B85CB883119189D58C5E700AAA004F7F972C1258CA4CAB3920C6A65C7E0BA7CF59F574C654B03B7AC2F9C2F5A7EBD7F71A9FBB343EF5CCCA7DD1FFEE6DFCBAACB86E6F3554B3D9E17DEF8';
wwv_flow_api.g_varchar2_table(2254) := 'F56FDE3F73BC52EB286FEF9D9E18EDBD15D5359F797570D376EBD30FDF3856622BAB3064F39DEBA9E1EEBB3F7BFB9C62F00E2D44A3E33D2FBEFCA2D3C6AE57F73F96ADF1FAD1D976FED0AB7A7DC5C7EF7E5C63CF4E6CEEE9ECEADE67DD2ADDFF4A6BEF54';
wwv_flow_api.g_varchar2_table(2255) := '7BEBCDC3DA8AF986573AAE7EF0B7FFF91DB5B97CF797FAB1C5EDFC64DBC9575FB3DA0C5FF4CD6CF67EFED2CB2F2B7ABFD662E81C1FA9D0F6596A5EEFEDE87DEBD8E95CBEE2A3F7DB83815BFA8A57B4C96D67E97D068EA7A32BD1A9D6D6B423FBC9B5EBA7';
wwv_flow_api.g_varchar2_table(2256) := 'CFDABB3B86CC4AE48BF727DEFE1FAD773AD6FCD971BDAF7A2B931DB9763758EB4D28BAC9C11E4FD59ED9506CF6EAAD336F3729F9BDCB91F47BD7EF1CD9BC5B76F858682DC462F519A3DE63C8EDA433EDE38BCEF58E8A17DF195F4FCD0EDC4E38EB2C1F7D';
wwv_flow_api.g_varchar2_table(2257) := '76ECAF831F5D1A3025877526572A9FEBE99F50AF4E7F32960A388CBDD9235BA3ADDE8AE66C363DBA121BBC75D36C55DADA56F7596C5DBD33A66CB8FDCEE62BE5C1AB1F0CA4F78ED7FA1ABEE81B7EB5A674E8B3AEC673DE5C96708632BB159FFD8F6B557F';
wwv_flow_api.g_varchar2_table(2258) := '7B18D712E9CC7A3C1EBE3CD07866DF4EDE3D3E3D3F36345769DD48BB539B130319B3C53770B7EAC4EB53131BD1CD65D5BD773C36131BEC6837E543A98C637C6026343D3896CF9B721F25ABDF9C1FB995CC5BB5EF5FAB7FEBC2F08DBB6A5BEA8B2BD7DF78';
wwv_flow_api.g_varchar2_table(2259) := 'DB3DB5106EBDD3E74F9A6B2B1A933B99B6CE694F7EA9F4D573D15466667C6965663C5F9B5A896607BA6FA8B2A94B1FCE5DFC85B5EBF65A7E67E58B85AD3FB7E926730D6B237D5B7A95E6CE2557E3EBA3BD9D7C22B9FEFE17A7FECADA757548A30E7D7667';
wwv_flow_api.g_varchar2_table(2260) := 'FDE73643C2D1BC3233EDB2A9CA2A6A185050BC45654622201178DA1078AA09306099EDCEE9C9A5AA6C7C6239EB4CAF2D250C733D774BAD5A7F63D3E4C05A56B5511AF08F2F84CDE9B5DAC6E69C5ACB27EEE995C8C2C4708939D5B0EFE044489D0FCDAFAF';
wwv_flow_api.g_varchar2_table(2261) := '6F37979B9C959067151C391C8D28D954A127B2798D4A1D4B245DD99DF1A5B0657BDA59B77F64784A1DDBD8BBAF5A6FF9EA3DEC69EB36698F444022F01C2000C3210947E04E2223A894C80BCA24F2701892C87384E10892491EBE24CAE14BA4A2CC6E3249';
wwv_flow_api.g_varchar2_table(2262) := 'E1EEE64415A89710A6D162BBF0A5622119281F94559470843815DB858592C4A5229BC200AA40B428C7C8A20D7CC785F2119914F218B0DB3B0A41000B454521831E91C180A20DC2C1A2B508085F76CB08A0A0B2A23AC77BE0DD474F68800D8ACC6E4BC477';
wwv_flow_api.g_varchar2_table(2263) := '04514BB42E54157B874B45AB76EB07162E71149922B0140ACB014AB8C611CA2D9A8006C39F8B9870A98889707037985411C6147D87840B3DC5E36E9B85B0681D1F8BAD902FF660B1E2D39F61CBA1375F68FEDFDA5B3EFDF77FF99B8B07DC35C7133BE95C';
wwv_flow_api.g_varchar2_table(2264) := '3A69341AEEF44CFC2498AFDB7B2CA0A87FFD7ED5E2788F417B209C52459716F73456EBADDEEDB432D3D3FDCA99BD5D3DEBB1D9EEBBAB07F4A1A10327FF1C168AE3AA8E758D86DBF55E4C40A34E65556BAB1B66953AE5F1A7E209BD56A556F466BDBAA2AC';
wwv_flow_api.g_varchar2_table(2265) := 'A42AB8E73F2E4F0EF5B61B82E507F6358CAC64F72D4EAD4D0E965795E7552697499BD4790687C79A5AEC3A43753CB993CF30B29D8F14EA48B6302FC0A471DFEE1CFF4540A9DF7F7FF729557E826F12D860D669AAB9115C8D9FDEDE3F3B78673DB4C73EDB';
wwv_flow_api.g_varchar2_table(2266) := 'FAE27FF95971CBA56B236BA7BCF141F3D1BEEBFFE6740F96A6428E834DFFED5ACF85F5C148CCEED126DC66456DB66D4D2427D6D6D83B3C115D6828399878E95CE2F2F08B2F9FDE3196765F1AF6DBC29A6DEB724AF9EC83CBAA9D88E2508E04ACC7CEFEC9';
wwv_flow_api.g_varchar2_table(2267) := 'D8FA0B55435D0DA7CF7D3197ABF5A9D2CDA796FEFDFF9C0AC5127D574FFDD56BB37D33A94C3A978C9C3850FD4F6DAAEDD5F92DCBA1646C9329106683FADDB18DD3BE78F5F9BFF8D51783777BBA731B5B2FBE79FEEFFF71E0E0EA803E9C5FDDD1BB1616D7';
wwv_flow_api.g_varchar2_table(2268) := 'B763E95432BE15D3E89C068BC9AC531D397A30F9DBB68623C7F8A339B127505573F1DAE57FCFABB25D630BB343AD336361F71EEDECD6F089A06AA2F454EFE5FF5E71E29585B975A643A8F29A4DECBF7677ECCEAFCF1E3FABB2968C0F0C1D6D70FF664ED7';
wwv_flow_api.g_varchar2_table(2269) := '75E963654F6553A5692C52D2DED919AD0956186637EB5FBDF58F7D2F1E9BF1994B5C15B5F1D0347F33A70ED74C8E85F7E694E6C3A74329EDD8E8BC36B9C6E2EB734B5BAEF086E7C09177AF7F5231D0A1844295275EBCF5DEADF9CE8136BBFE62ADF39355';
wwv_flow_api.g_varchar2_table(2270) := '7F77C7BF95A62AAB0D997859CD17FFD4EA9B1C31C5FB9D475FBDF9AB4F57078612FBEB5BDB7AAD9AE86B17D2AEF2C23BE7D3FF97252D9408FC3811283C799FE65411B06DC4CDD1E8EAF2C4BCABC277E74EC7E040DFB55BAD6B4B036D570752D195E995F8';
wwv_flow_api.g_varchar2_table(2271) := '50FBDD5C261ECF281DC3535BE18DBECE7E46780D2D47D6C67BDB264393DDADECA4D17D778081CEC253353F67F7C2DF734BE1F599198D4133B5C1129A2CA91AEB1C9EEDEBB8DDD63D38D37DE9F706939F66DCA46D1201898044E0BB4200AE487A726DBB49';
wwv_flow_api.g_varchar2_table(2272) := '6CB116ACAFBABABA78FAC8CC232B3E52F27B2AFCFE0C78A466F82DD1EFAFF7E59115BFBECAF37A55AFC9E774B6EDF09685494C79F5F0EC6A77FBED647825956656391F2054446C557A035C4BC9AB925965687CC9AD8B994B2AC656E2DBF3BD46B325A218';
wwv_flow_api.g_varchar2_table(2273) := '463A7A93C9884E9351BE9A4EA52AF014F5FD3B3C9365BA6E3C97CFAE6CEFB4B777AD8C0D281AA60CABF28C42464AABCEA715567BDF57E9C87A1ABFB872D3939BF3D5EC4BA5F30783F657DFFAB3BE4DE36F7FFD417463666062BEB7FD4E2AB2AA52ABD219';
wwv_flow_api.g_varchar2_table(2274) := '2593D949E5B33196A9333EF8D902B505D54CA4E7A0D131F7DCEB34BB0A6328EE87A0B938178E6F46B70C895899CFBFB611DA0A85D4DBD3B9DAC69D78FCD4B16AA3B3E6CEF84A72FA5A52E31D9D9B986A1FD29814BD496D290CD1677882A56B36D17DF9A3';
wwv_flow_api.g_varchar2_table(2275) := '80DD32BF9998999F492E4DAFC754D97472757DD9A8CB9B4C1693D1A03399346A4DDFF4C6E0A5CFF71CF6CE85F50DC60D4760EFE47C746D6E2291D35CBA3DE0080D782BEAEEA1A5661835EC7D391CAFDBE37158EDC6408D4197517425FDED1DA1EC7A3A1D';
wwv_flow_api.g_varchar2_table(2276) := 'F799B5B6DAA6F9C9098D920B04AC0DAF1C5C8E2BBD9DB7D5B998D562361ACC3A63E1CB9A51AFE51B9B56674CE654BD77475A6AEDD54D87B51AA3BFB2FCEE62627674201DDBD2E4B375F54CC75067933146FA4562198D12626C4946D1AC260990AC360494';
wwv_flow_api.g_varchar2_table(2277) := '44AC2A32BFB8B49E7267D6F3F5E5CB2BA1E54C389BD80CDAAA72F1744D4D3D93C655EA02A4055FCD6693D1A437986C064D734B95CD5B179ADB4A46236BABB9FCFAB8ADA576757D7B4389CC2EADEC29754736CDF3F1D0CAC29AD79031E8EC91F0DA3AB3BE';
wwv_flow_api.g_varchar2_table(2278) := '1333C99AC68DB5D05A2EB2BEBE5AEF0B6C6F19A65756D616E6BAFBA657277B25FB056A9924024F2D024F3B0176EA154DE9BEC19E41577A29E16E5819EBACA92AB39504594653134FEEDBBFC7E22C290BFA732AD34E32B51D8B6F85B78DEB2B2F9E3E616F';
wwv_flow_api.g_varchar2_table(2279) := '3AB33834BECDAF855373ECF4B1A1A859491586DB910A6F72BAC22F5032994BC7E339ADFA5AD7B83F3B1BD873686864BCC49428ADADCEE688A8147E9264920848042402BB1160ACA94CDF0001C2950CD9FD06159FE32A905BE2EDCF9F83BBFF5EBEAB3C6B';
wwv_flow_api.g_varchar2_table(2280) := '4D7D7A63A83A357EECAD9F7F746D32B23C6436E82D565683D31D68AA1C98896F2E8D0FCD6EB8A3D381EAE6543657EBD11E3A7BF6EE507471ACF772DBD01E57B8A2AAB9F2C0F1DBBD937B1DC915C53BDD7F97A1E0EB8BAB798591EC9950683B16D94A6752';
wwv_flow_api.g_varchar2_table(2281) := 'B0EB3D8D750E5F995EAB26A2AE379AF3392599CE6C47634333ABDAB5D1FAFD8DC9ACDEA949571F3A74ED4ADF812A8DCA569E4BA742DBF1138D9E9653AF4C4E2552E1058BC960614D388D0E46ED34E51AF7D4BBDCA57BEBABDA2743EB73436BABA1EDAD8D';
wwv_flow_api.g_varchar2_table(2282) := '9C9261417646AFA7D299AD70A46F6A2DBFD257D578D4A0D7EAEF0DAA2FA257E9B24C8FAC949719F306BDD3EF9B5C5BB51B750145AFD35B0FD6B88F1F3FBDA1F56757C7E74C7AF5C6CC4A44AB55E7145D61E277EEDECEE4A944DA556A5D0C2B8B8BF3D1F5';
wwv_flow_api.g_varchar2_table(2283) := '95A6A0D51FACAFAC6954342CD492CBE6736C5A4E5BD95CDE69D5A77496A5F5D5524B7E3AEFD56E8C3B820DB1444AAB649D4EC7762C13DF64E9B5DCE9FDE5172EBE6909EEAF7299460737175757E27383FB2ABC754DCD91B4A6C9B66DF556E67752B555A5';
wwv_flow_api.g_varchar2_table(2284) := 'B32155323CEBB0E9CFBE7AC05E71686E6623954B6D6C86B7635BD1AD8D94925B5F5E5B595C55A958CA5ED908273D767B22AF53A7C32D757BB4CE3A2514A9AC08E415BDDDA64FABCD1BEB9B6E75F2C4B963FBF794BE70F1BCA7A42C93B465D6970D66A727';
wwv_flow_api.g_varchar2_table(2285) := '90CAD5546ECD0DDB2ACA4C19BDDF5F323A90A8B0AB15A7DE68316C4512F47628BC954E84F19495FB84CB669D7A4F4379B0AA5ECDCC039F63697BC96C37E8F3E66099776A5C5FA25A535B1C0EBFC66370AC2F2C969499CD36BDDA1B5C5899B6DB3CA51975';
wwv_flow_api.g_varchar2_table(2286) := '49B0646254556E89ABEC568353DF3632D158A1D3587C2CC256EC3B99910848049E42041EF125F2A9B212825EBBAFECCA7FFDE42717ABD54E9F5EE7D1683295A53E8BA7C6A95DD7591CEEBC61C6EEEDEFE93C6DB2A8B42A83411FD31846472763F15C99CB';
wwv_flow_api.g_varchar2_table(2287) := 'CE129B25653EB3CE94B298944C61434EC86F389E1E1C9970DA224AAEB056A72A9F0B7AED5B69FDFA7C61D34B25A2719B75FE2AA65A3DED5F079EAA9E92C648047E0C08C05598DBF963F054FA2811F8C608F067F28DEB3EAE6228915D1C1B7DFB68B5E1EC';
wwv_flow_api.g_varchar2_table(2288) := '5BFFF7CCD6E6EC60E3A9FD4A65610CFF8543CE4F974FDD657C73D6F1C6F1D292EA43BEF90577AA62FF9EC0F5C65393E323E9C5C0D99387F61F3D9109A6DA26DB0EF894D573EF740D74D95772A57ABD2FB887C599EFF68E073C9B10C3397BB0BB6FACCCB3';
wwv_flow_api.g_varchar2_table(2289) := 'DA74E898FFC421F46F8673EE604DD7F8CA563AF5E2C1928A43677DED09BBD1EFDF5BD9595AD3B4BF796CD4EB51CA16B793E191AE6CD67CEA7083CD5BE575962BB5E554F7DB928BD6AA9EDE41B8E29B27F77F113BD9D1D1A135F89B19FAEB6751E3329341';
wwv_flow_api.g_varchar2_table(2290) := 'E3290F760D2D2FA5536FEC77F99BCFDDBAB6E699196C3C43EBF7E769BFBCD777736CDFF0704FBD4FD5D8DC323B1BEDE8D93A610DDB4B4FDE1A585A98BCBBD7980D369CD7CD464BB5BA289B9F6D4C298474B52A5F1593B9B447ABACB57FF20EFAD7D697CB';
wwv_flow_api.g_varchar2_table(2291) := 'CAAB7756577D3A8BDD6A546759225BEDB5E82DDEC23C73BB41D574FCE04EDD3B97FF6DFD65F376EFA157BEB8D14E20D55E555EA3B29FDA7BEEDD407E7DF9335FAD62CB07C5AC87737B4A6E0ED8462F7F5AAD539556BC34331C5254E9F3872B1DCE3A47D9';
wwv_flow_api.g_varchar2_table(2292) := '5685D3642D6D0C46BB5763DA5B57EF46D3A173470E6EA52D3DDDB7B7F491C99EEEBD2FD58F2E472707DAF79E6471524B497DD5D5CBB7731A97BDD2C3E2F2EA6CAEDAA2AD3FFA4A22AFBFD3DABD125AE9EECDBE5E51E6305779FDD53A230B25A84F1D689E';
wwv_flow_api.g_varchar2_table(2293) := 'EF9989F475BDF6625579594BEFE763BDFDE3C783E6CAE6BD2BFD6B433DC315A5296B59F5CDE1A5B5B901557EE3C0429FBBFEACD7633267EF4F00E1764D6552564DAEA6C439D472E0EEE876AD7AA7A9E9FCF47CD9C272A72A15AE7CF5E4CBA9E0C05270B3';
wwv_flow_api.g_varchar2_table(2294) := 'AFE3545395BA6EEFB599D9CEDEC5170299BA9A3DF5CDA9B1C971533E5BBAEF256FF7963A676CA8B7983C4C45E1AFE0FEB002B0954922201178AA1078AA57811648D94C1AD64BDCB7D76F7305D279A392654E8E3E50EACBA734FE5A6F24A9DA5A5CF1B8CC';
wwv_flow_api.g_varchar2_table(2295) := 'E555957CEFAC2FF76D66F4B1D0AA391F6BDCD79CD538CAED6ABDCDC7522835A52E4563E669B41966A383B04EC9DA9C1EBB8DC5499D4D55BEB83568486CFAABF624130995465DEAB51AACF7A7693DB2C3582B8568C6232FC94289C0F38A002BCA16A7623E';
wwv_flow_api.g_varchar2_table(2296) := '8B3EB20414B352BFC6723E88B158117FDD857122BF9B78DB63102F13594180A99B85D08A4C120189C063108054B058DA77B80A74269BF75A554D075A3C0E8F8B3700A7D5EC2CCCE025394C5A4FB0822866C0613A7AECA9C3B1820000400049444154B0DA';
wwv_flow_api.g_varchar2_table(2297) := 'E8B69B0D81D2A0C3E97307BC4E87B92E5856CD4A696687D3ACF138031515DEAA9AFA9C8621B03ABFD719089696787C26B3D56133579595FAFCA546A3C561373BDDDE7BA3AA158346E16FDF64B3071C9623270FE9AC01BB591728F17ABC25E5417F4575AD';
wwv_flow_api.g_varchar2_table(2298) := 'D3E1282B0F98DDDE5C2AE3B2188E1E6DB4076A8BE4C766D6393D7E42FD2E9BA5AAB2C25B5AC5906BABD9545A5AE22F2909064AED4E8FCFEB3699ED41B7E5D8D1635A4B091160BFDFC59271C50FF12E8B3E6F71DBF3F193C70EB9BC156CEEA449C74E9EDA';
wwv_flow_api.g_varchar2_table(2299) := '67F1D56E6D27D5F9C4C97D55AEF2FD3687BE869D9402656E8BDDEEF1EB346A8FCFEEF0B90D3ABDC361F3BA9D01BFDF5B1AB4DBECBE6009821EB7CF6C755A8C7A762237DABD261D2BF3D982BC519554963A4CFEB2AA782253E93335ECDDEBF00498DC5F5E';
wwv_flow_api.g_varchar2_table(2300) := '136440B5AFC4CF7C7D9DA930FFDF69D165AD4E53367EF45093D957B7B915B1A993078F1CD31A3C36A7C9E1633531678DCB62F154C4C2D16ABF79FFD1A36995391DDBAE6D604B298F37509154190D89AD43670FE84C1EAFCB96D9C91E6929F75737E7B5A6';
wwv_flow_api.g_varchar2_table(2301) := '4868B3A9CA15683C945554F1D076B0DCE3F6784A4B837A239DE5B2D87DECADE629B1C733EA46AF61CFE133254EFB8EDAE1D6A74E9E3E6277FA755E8F2E153D7564BFC95B1D8E267C0E7549556599DF6DB0FBAD66BDC7EF32D8EC136BF1D66B9742F3534D';
wwv_flow_api.g_varchar2_table(2302) := '2DA581F24ABDBD44958C9D3EDEE0F2D73BCBBCF158FCD89E325FDD6197C39C548C414B6EFF91D35EB747A5775954F1E3678E5A6CA58E325F2A1A3DD952EBADDEE77338D33BE9963DA581EA7D06D3574B27DCBB4FE541222011F80310F8BE57812E6CE4F8';
wwv_flow_api.g_varchar2_table(2303) := 'B039C54232C55F37DEF9B086C44F1A03867815E62A6B573E5C9D128479832CAE8FF24899272F8CEDEC58B46C5CA44B64D8086E8339384E873D9D628A8B2E99CE6F87B6CC4695D5EE4CEC64F8929A4CABB643219B3167B27B13E99C41C5CE49FAE44ECAC4';
wwv_flow_api.g_varchar2_table(2304) := '1A1A2A0DDE6EC792A978946938468B5DAD52E5546AAD92CBA8794E86CD7647682BC2C418A7CDA8337EB5DECC03A6E2B8D89AE28172792A1178BE11801C16D7347A163DE58DBCB856D323ED67482A5BB6B203CD03132FF99387F7B2283197584C88D362F5';
wwv_flow_api.g_varchar2_table(2305) := 'DD790A1F382D8A91E19148DA5D22F31281E71501DE1CD86F9975CB1FB8E729874CF2E6C0B7A4C7BD3F3CAF9848BF9E420426D6E3A3EDD7FC66DDC1D34734FAAF96CD7B0A4D952649047E540810B1E07D4CEC41B8DB71DEB20840B2EFC3CD9B3721A4AC0A';
wwv_flow_api.g_varchar2_table(2306) := 'C9295F18399278C763A14756A364D615010F12AF73A47BEF5FF75FC0C4AFD2D33E045AF86CF9728D5393563131D4E85ED2DF5BA9D4A85319D9F8FE5E321596C1508C3AE5AB121DC3980B23884C86FBE388F0DE61312AFCFB32DD8B0769A8A9B3173E67BA';
wwv_flow_api.g_varchar2_table(2307) := '9DF0DEC752DF2F2BC9FF250212018980C2D6387C14E0D9CA1399377B8EBB330FE41166F55D163AA6FC5B622796FF155F277FAF2AF1E8E7A3E4EF95FC3E04C4CF8F88997F27FAF9E9C2A3A23BE82FE677EBDF2D266CE0EB2DC817EDA11632FC4C52C8A5DD';
wwv_flow_api.g_varchar2_table(2308) := '751FCED322683F5CFE7D97ECB6FC3B698B3BE7F73AFB4043F84E097091A1FA037089AB457038C56671672229D26E855CA2707789CC4B047E4004EABCE6BA37DFF8010D904D4B0424023F0802CF0601FE41A0F99A46C5C7037EC845E66B24E52589C07383';
wwv_flow_api.g_varchar2_table(2309) := '807C6D7DA02BF9F3672C0CEBE8889830F888977BF1D22F4E458938127F863F10FEFA4319C803ED72CA1C423E73B20D0FBBE67CFD5388AB0C57115B10FD203D3838388801EC4FCBCE40DFDE00DCE18B035BDAD6D6D60A6D939393C160506C3E54048A4BEC';
wwv_flow_api.g_varchar2_table(2310) := '094CB8BEBABA1A4A860D80CFB6BD7C7D407E7A7A9A8D7F19CBC007E6DBB76FF3FD984B740DDD54D4B03B437FF1119A5E16646FF7A5EF358F17030303DC6098C77AD18F33EFC96DE013CCD0D0100319E0A84F580B1B808B9B8D3D90C1B0ABAB0BDC0E1C38';
wwv_flow_api.g_varchar2_table(2311) := '203E3A60D2FCFC3CB0B0999360C8CBCBCB2323236C5C4C098326B8F4C0FD89C2E2364E4F688314930848042402120189C0778B8024C0DF104F5E0878F77DE0A7FD1BEA92D52402CF0202BCB972DB3F0B96FEF16CE4A51FE2042560DA3079F08112087E0B';
wwv_flow_api.g_varchar2_table(2312) := '5CB03206E4504E214C80CC03B38B29E49288986134A7D412C2E2482119714964108687C08BD8531766F2C61B6F508B422AD22E195A116AC5D38923B487192B1492470C812240C893A75C34C725042844983C85788780D04C21198411E01202224F156438';
wwv_flow_api.g_varchar2_table(2313) := '45A078890C5729842061F0D2D2D25FFFF55F8BEA0FD88018AD50C855612425E827A14498871ED18A3086672F19E0451206FBD65B6F31E409790A491442F8AF5FBF0E4F868641C9FAFBD91B8F697AD173E7CEB5B5B521C9E9EBAFBF0E555B5858001C2834';
wwv_flow_api.g_varchar2_table(2314) := 'AC8C24CC169E8A16D186C0DDBB777FFAD39F8A70B130061992F005192A922715CD10C670448CAB940B881026E16C518053F2D44512316103A7ABABAB584E09E985175EA00A6E228C18AA28141A8A25C21E714A756450850C9242275EC3F9290170C428DF';
wwv_flow_api.g_varchar2_table(2315) := '6D12A724A1B3A8796E6EEE830F3E80F102D1AD5BB7F8AC303333C3B70CB1AB3077E0A54B9738ADA9A9A12ECABBBBBBC199AF0C7FF9977F4939FA772B147981C6C3E5B2442220119008480424027F1C042401FE8638F36D9BD7CA6F58595693083C9B083C';
wwv_flow_api.g_varchar2_table(2316) := '10677B369DF8EEAD866CC06C79FB67160A2C057A06151153530839C201201BBCF47309C962F30810572456D6D7D7C711FE001973BBDD5EAF17FE505757C791BAC430A9B8B8B8588C7932EF855338090268E6080F2142D8D2D2C2841926C6700AF780B6D1';
wwv_flow_api.g_varchar2_table(2317) := '16DA90A1E3E0843D3D3D1072829F82177195129A20D12E3A8934B270436F6F2F51D6C6C646EADEB97307BF8E1F3F8E4E482C8D620C733BF18B86D089F1361B6B099A882B4296262626604A180F7343090A0F1E3C4821AC89E9A098473C131B2817360014';
wwv_flow_api.g_varchar2_table(2318) := 'F161C292ACC08F42282B0210BFFAFA7A428EC41B31925690A715811E55048382CA6239A0019D20F908E32CC620C0914E4118DA863DF8F2E9A79F62151F295E79E5957FFCC77FC4299839CA29411E22FDF2CB2F43D73100330093E83A9AD189CBF8427F81';
wwv_flow_api.g_varchar2_table(2319) := '0C47A2D95481570308708127FD383C3C0C8678011504310CA32262380BB0306DB4610655884BA3E4C891235CC23CC410C00086068C8F8FF35D0361300137C410C672AE0220F2F423ED72157CC43D83BF0231D09B9D9DC56B6A013883EDB97350C8DDC8CD';
wwv_flow_api.g_varchar2_table(2320) := '409741EF81110C61BF84C4C10DCD7428B5E81A11A5C7C8A2F1B4255A8475A31330C7C6C6FEEEEFFE0EC64B7F317D171F71106D80233A052331E6EDB7DF7EF7DD77E9118CC1BB4726143EB25C164A0424021201898044E08F808024C0DF10645E0E48DFB0';
wwv_flow_api.g_varchar2_table(2321) := 'B2AC261190083C4708404260173007D814EFFD10038810AFF8E4059D80BCF1C90C8F8B04982A902B581392D7AE5D3B7FFE3CB135881FFC8172A8DADFFCCDDFC04EA902C58258C231E03C5C4203AD501D52C42388728293B40EF74098230CEAB3CF3EBB78';
wwv_flow_api.g_varchar2_table(2322) := 'F122DAA84BA40E52471E3E0C9F847721467561C9AF7FFDEBD3A74FC367A0BB702D080F2CEEE38F3F86CFA0EAA5975E826CC3F76891802ADA44EBE8C15A6815EC975A3037A811A7EFBFFF3ED13FA838B64193A8287811FCEAC2850BD03C0C83A74123A15E';
wwv_flow_api.g_varchar2_table(2323) := 'D8095058826194A0072F60C808E3D7952B577EF18B5F601EA4148646BB046F914733540DFE8666D81DD6529D4288A5800BB646B0141B8E1E3D0A6E5C0264E00567483B4E0123E410FB61B9E049060A876688253A21FCB40EE3055542C49408B8C86003DF';
wwv_flow_api.g_varchar2_table(2324) := '1A60A750CA868686CB972F43D16914846FDCB88123180650D04EEAD22F54A42D482FB084C3612C79E79D77AE5EBD0A50580BD5044FFA8518358E6036E30820E1DC27DC0F7C44A0399470E4D3031C1B198E9D9D9DDC21D04E64FEE22FFE42FC06610F7157';
wwv_flow_api.g_varchar2_table(2325) := '1AE2082FA537D18FC29FFDEC679F7FFE39806318769E3C79127FE9475A44928618484FA3027C711F823997F82E40BB38428B1CF91640B7623FED722F9117B0001A9DC89D43EFE32C02906A64E85CBE8608C42897492220119008480424024F1B02855F77';
wwv_flow_api.g_varchar2_table(2326) := '9924021201898044E01B2300F9A12E6FFC82F1429F6065E4A104501412191805F4637713F03D4E89493295177A4314112EC11196057B819C4051A049F019027A101B3490606BC41809E5C191A82E82878C01869251174E0581C11E9440AEA07CC224681E';
wwv_flow_api.g_varchar2_table(2327) := '66085A056F1166A00DAA43201416840D7063582883ABB11F02830C06C370A808C582E62103C183FF6027340C9645EB90E443870EC15A398570427A219F907FE4A948EBC8C388685A0CFF26FA0AFFC4546103C6400E216F7C29401BFA096CBEF9E69BB053';
wwv_flow_api.g_varchar2_table(2328) := 'E4399E3A750AC3B854341B63681DAA7CF8F0615831ADA04A74C13D840A317632425E2026E28DB883306A11005B9C05963FF9933FC17E46F9E229B0C339C116EA0B69C424A156984AA37CC880ED4302E95F34C3EAA92282C6D80C57C4E0A225D4E296A016';
wwv_flow_api.g_varchar2_table(2329) := '90020B7D81428C8799E32F7C1BF0E95C04F09A726E121AA53A704147C18D7BE3D5575F85BDF3C501C4C00DF368E5273FF909802020DA421E33F81801DA34CABD847E34E0298E13E3A5E3A885FBF42C8D021DF70923BA518819E8C429BE986027D505861C';
wwv_flow_api.g_varchar2_table(2330) := 'C9A39F8C40928F2374046C1C1F410F55282415FB45DCF0945351804CE63B4CD9BCC2288B5CA630FA3D9966AF86D86EE5E9BCB21DE1EEDC56F285DB3B95C946A3F1C8F67666A7300E82C4DF1EF0E7325F8DDB8AC693DC00E9442C9DCBB1AF85922FFC79A6';
wwv_flow_api.g_varchar2_table(2331) := 'B3B9582CBEBD1D49C6D17F7FBCC6BDA677B623915804FD0507D18F8FF95C212FAE8A8676324C3E8FC43123F7D5D86F744663894884B60AE3CF7732D9742AC9A7AC787227128946D199FBCA2A04649208480424021281EF1B011901FEBE1196FA25021281';
wwv_flow_api.g_varchar2_table(2332) := 'E71F017802AC80319F5023C2B4100387530F09A1309B29C4848180A3E015E4C94065A185444A99C7CB305D0283905886F512A524ECF9AB5FFD0A8A021BFC877FF8070827A4173602A1225191381B7C895660D1901C7814348680249788B2521185B48E3D';
wwv_flow_api.g_varchar2_table(2333) := 'C40C11A32EC152284A7B7B3B613D6A514882D5409F681A0A0489420C6AC455F4C303C943DB886742BF21B4C427D10F6F8407228C17F049482F4AA84809CE5202D782B7C3ACA8488642881FFE623908301617E60025E394421225F88212EC218323047811';
wwv_flow_api.g_varchar2_table(2334) := '4015CDA19F0830C69347805AB445421ECA4D89605CE811E50888BBED9EEEC2BC627832E4105FB09061E4ADADAD50748CC40B3824096711A009C821798E7072D0232FB409CD780475C41DC1FD608FE4C187E610E08B03CCB0282F32D88012104600528A30';
wwv_flow_api.g_varchar2_table(2335) := '50E31A06D02E90E214572981B51289A55DFC42866EA21780822F0BB442D348428FD1860CF8D05F48D20A4DD0CBDC1E44A4F91801E0F88530770EADA099530AB19C3B011E8E259410AA4509F72AB0603F0264E826F2E814FE724439251C05F2B80C5D0728';
wwv_flow_api.g_varchar2_table(2336) := '9AE33B0B4D60AAB88A18B1652EA11984319892EF36C5D3CA2757BB5B6C9B35A75EFBF0F39E63A5EB9587EE2FDE0B85BDD33D910F8F27B3FA03E5BACAE6D3ADC3CB5B4337754EBF7D2774F2D5973446CF4C3873E93F3E38BFCF5C73E4F59CA21A9A0F2DF4';
wwv_flow_api.g_varchar2_table(2337) := 'DFD2EA8C151653A272EF4ACFCD8B17CE2A7A57C7F4F65CC7C76EB7A72AE0AC6F39A4A80A9F5796E3B95B1F7CEE75A9E2295D4DD0D4BCFFF09DF1F8C4EDF7DE39D7ECAE3F35B116BBF1E147676BCCFE93AFB57774A9E2EB369DEED0F1037A0BBBF81652F7';
wwv_flow_api.g_varchar2_table(2338) := 'F4E642FB67265F40BBBDF9E2ABC76FCD99ACABB71B4FBCFEDBCF6E9519B7E32A6BAD2DB9E7C88B1AC323B69F98DB886ECE0EEFAD2E31B82A8536716404F9C4C05C855FB17A2B7697CBBC444022201190083C09023202FC242849198980444022F0750840';
wwv_flow_api.g_varchar2_table(2339) := '42A04C569BDDE3B47A745B1EA7D99B9B316EDC496F8CA633851DD4E17EB0084845510B250C4685B57284994027E02D0C588517118DA404760187811543806186900AC28024680654047E080F4198F82D21627808140B464D5DCAC943F6688B72EAD22E36';
wwv_flow_api.g_varchar2_table(2340) := '50056DF01C5491E0600C8BC50C94408A605C64C4A8570AE15A1C494D4D4D784688123B518EC1288455D22ED6C28830099D5CA59056F0824629C106781A844A949081ABC366710AD7A0AF5484CE61330A095492C160F8A718F40B5FA575C4E069980DF146';
wwv_flow_api.g_varchar2_table(2341) := '9E534C05104617D334D15706E8622AC2903D1826440E6D18003FA4168E9F387102E4A94BA49712A0E31303F41E0D107B112A270E8C240A311249D4E21A2E8312A7384545FC453947BA0617A88B790082424A08C9622125B48E8558823DDC1564CE9C3983';
wwv_flow_api.g_varchar2_table(2342) := '063443659127430F0ACE890D14D25F740D8D621596238C72F0C460F83F68304C1D4908307569050C092363B0300FB3815ADC3698472DD1EFB44E39550010FD0005264471690E0BA1DC088039F709DD44BB8C050028FA5A20C9559AC0234CA5D3C9102F45';
wwv_flow_api.g_varchar2_table(2343) := '337A308FFE45985A5C051C6CA60431B441B6F9BE40A720FC1D268D5A998FAA2E7DFE717B6F7FCFB5CB5ACDFDF02C4DB48DAD0F5CFFC861D565CDF68F3F698DAC4D768CAF6E0D5FD3D9ED9F7C7E27BA388868EBE0E28D6B975BBFB8A464C3539BA9CB9F7C';
wwv_flow_api.g_varchar2_table(2344) := '6ACA86ECDC2D46CBF04AECCE8DCB4ABAE05DE7CCD648D755BBC3663459F8B021EC5F4AE65BAF5DB669226A9BFDC34FBBD746DBFA67363EF9F48BFE5B9F29F9F49DBEF98F3FFC70B6EB76D762E8F6A7EFDACD3993C596CB7FF572D53B1B5AECFE827BE68B';
wwv_flow_api.g_varchar2_table(2345) := '9B031B23B73B66C283ED57233B3B97AEB4D9F2EB7AABFDA35BC38B833776D2D94424CA87B222684BD16CD795BBD30BD3976EDFCAC796895047A271259B225E3C3A3077FD72E74CDBED7BB1ED620D99910848042402128127424046809F08262924119008';
wwv_flow_api.g_varchar2_table(2346) := '48041E89001C80728EF7923A97DC52CD7CA4F21EE698B5D5E763ABD9CA20E3440597E05854027F8087308C165A0269E112115A781747480B635F050565382E0412A2484015720593810E91A110C2495D4E218DF028E8197519CBCAD563C78EA104610408';
wwv_flow_api.g_varchar2_table(2347) := 'D6A1162606F9E1C88C4D8813D6C25518B84B067245150C83FC207FF6EC5982B4224F454AD04C7388415C215A18035BC6789A834C228C18F24420B104E2C455082DF6230FE985EFE12CFA05494621858CF1A604EA05E5160AA9059387DCC2AF2887712129';
wwv_flow_api.g_varchar2_table(2348) := '382106302B9812F4C0D370844B388E066AD1102C54F0674A206388610662F8852A783E6C161940660C36440EC300076E4C941519981B23C6D1491EC24F73D46204B2083263211D843C91798E3019F470C41EC12AA94B82018203B0C34E31838419C0CB28';
wwv_flow_api.g_varchar2_table(2349) := '6E582B46622AF220497394539D2362B40574080B5FA0D3247086CD02056D41320119BFA0BE5CA23AF64398B190E6701CB4B94F3009FBC14730793E0A8000D511C67E9CE226E17EE3C83469649007252E510B4B5E7BED358CE1B460FABD5B9A1631924F33';
wwv_flow_api.g_varchar2_table(2350) := 'E294EEC354B4E10B6B740185B88A9148D21DD84F759C4586768577F7947D0707B35679EDA523FF6DE0E6CCBFFEF35B2DA5C1E6178BFA2FDF1D3B6BDB387EEA5C2867F85F2FF72F8DDD55ABF62AAABC45AD2AA92AD7A80DB18C32D9D57DFE4CC3C04828B9';
wwv_flow_api.g_varchar2_table(2351) := 'D8D7BAD29898BE7DE617FF8BDA5A95CD296D5D6BF92F473B170CCD2B5A95A2D7B241342456FC752B664DE660534D3670E2D29DE5A1F6366DC96B7B1AAAFAA7E34D1BF3732383257E574EA5CF29B98DC84E34BC166CAAD55BEE6FF7CD1F3CA313B8170CF9';
wwv_flow_api.g_varchar2_table(2352) := '7C695550AD612D809C688E927D7BABB4D5C76F8E84473A3E59B61CDEBE73FDC27F795551B9045EB7A7C3AECCD49667FFF54B1FBCD458B1531778F7DD6B7FFB6685CADBC2D7058DCDB136C3A87508F35764FB3B005AAA9008480424023F02042401FE1174';
wwv_flow_api.g_varchar2_table(2353) := 'B27451222011F8DE1080B7902000BCE76673A97C3AA6DE1ACBD9EAD4D185BCD6AAA84D4C3BE4859784184C63B7219004A26D9443BD28E7851E6A016FA10466224AB88418E5D00CD80E1A1020833032E2084521031BE12AACA6A8908A82CAC2BB1026FC48';
wwv_flow_api.g_varchar2_table(2354) := '091C06EA823C6418D64A2D140AABE066D4458071B90890685464047BE42A24875A14D216C4150E8C85102A32302B7189AB90258EC863B970040206B784D7514845581CE5C863185C1A614E71043A07DFC32A14123B8504220F61A69C0C62B44215F28809';
wwv_flow_api.g_varchar2_table(2355) := 'B3C9234F12A7E20844982A6C8081E338029CD222CD5185842AF2C8D37DB84C8660268651883038089C8591D415C4950C9202432C1138A00D882081A8222F6C1047F0111D444551AB888910A01CC658CC0B643000CDE04F390A859DA00A80021FBCE32A7E';
wwv_flow_api.g_varchar2_table(2356) := '710B21236E24244507518206CC4339F6735790E12ABD20B4891221833057C52560E7B4982817B70719600413AA93473332BBAF0A5485B3C83CA0A7A8F0DB64024E5DCA5446B4B7E2D53D79B569706635BE38D2D254BF158E7ACAE8478345ADE46C9EE8F6';
wwv_flow_api.g_varchar2_table(2357) := '0C7F66EBF1FC76E748B5336729ADEBDFDC599BEC6A3E5DBE9EDE9EEAEA5937076DFAB4DAE2C61802CB1C8A56A915552C99DDDC58F65A74CBDBC9A9FE811A975E1D68CA2BEA6C3A6B502906BB3D1649E4BC9983F5DEC935FBF59B772CF18540EDBE747AE1';
wwv_flow_api.g_varchar2_table(2358) := '449973F9C29F5D1BB83B3EF49BBFFA9FFE8789F57C667D765F4B032330B67654ED7D63DEFCA667CFC5EC7C61A83989DB88E121FCE51B1D9EC45CD4ADCAF3594BF9EA139932BC1C3DA64DE4C39980DB130D47F843D2EB18CDA1E6BD6D4F73C5E8465E3538';
wwv_flow_api.g_varchar2_table(2359) := '2654C9A344402220119008FC41084802FC07C125852502120189C08308F0BA0F29C8A5A3AAC5AB7963009E91D1B9B4D66A08B13ADC974D6C66750E26562204C37CA0328594402444391991174771893C1C86689E90815AEC96210F8D795C75181DE36005';
wwv_flow_api.g_varchar2_table(2360) := 'A31332047E614D427381B7EF6A5D080893447EB76651C25114D22E31617829744EB0AFA24051864CD15431D9951629817D11BE16F2B8536C85F02F1009ABC810CD16F2E409720A794A8485BBED14971E388AA629DC2DB93B8F40B169512E029BC200BE17';
wwv_flow_api.g_varchar2_table(2361) := '30945754176245E1624342032162960D8313C2211F2753AC42A66858B170B755450DBBCD13556805562C30E1D300945B68132542DBC3B5769788867637273453777761D130A15F9CEE1628D62A66C4D5DD6DED56F2EDF37CBDB8D9315B9A18F7BDF4D6D5';
wwv_flow_api.g_varchar2_table(2362) := '3BE3654766558A49AD52732B37D4064747AE1F882ECFA5DDE6D07449597D6A225FE3D51B0F1FEDF9D5FF7B6675F6C6B0B9C2B816283B5F52EF6DEDF9A2F68DF3ED3BE6CDD9217BD991446C27AFEC30B68060B7EADE7C7D97557BE060332BD085F38559F7';
wwv_flow_api.g_varchar2_table(2363) := '8A5A05E3CFE6B2FC5DCF861299A5B1DA33D5A329834F9F4DEE3BF4F97BFFFCE767BD1D3BD5D9A5E96C2AF5D3179B3FF5955EFADFFF8F3FDB98542BB5FCD52B8A2A9BCB076DAADAA347AEFCD3D4FAE4904A5525B0A251EEBFA5EDF4C6544FE5DE6687C366';
wwv_flow_api.g_varchar2_table(2364) := 'AEAE50F28622072E7198666F2F9D7ADBBCB4E9D11909492B35D5A58AA1306D9BB1103B3B69765DE3DB8F5A2337A4F8F6F797D420119008FCB81078F06DECC7E5BDF45622201190087C3B047897857EF01ECA3BA97ABD5F518F666CB58C87CC6A8C8A5A9F';
wwv_flow_api.g_varchar2_table(2365) := '531B0B6FCE6A686E21FEF68D9BA2EE37A80E1B816A427777D7C5D86F6CC6EE8A2817D1540A77EBDF2DB33B0F892509BE5470E6516814838DA2A208E192A7D6F71151DC6D9EC86380B090D327040A791183A54A91BB3EACF93B29D91D3AA6ADEFBBB9EFC4';
wwv_flow_api.g_varchar2_table(2366) := 'E6EF4AC97A3CD3D3DE7971AFC3F8D2CFFEBFBFFFEFABE3779B8FFF5CA92E8C02B878D4F1C5E2BE3BAD7716529EF3CD667FDD51EBE28ACFE3DE7764CFAD2BCD433D6D8B93819F1EA93B79EA6CBC24DEF97FB5BFEA492F1C79E3F69D6E6759CAADD2385C95';
wwv_flow_api.g_varchar2_table(2367) := '2A83E34EC7A0CFBDEED23B1206C7E8F85CC0B55DD7B4BFF4746134FB7A28A7B795DC1D9E5BCDA48E57EBAA8E9EB57664CD56FB81FD75ED1F3B5B5A1AC7263CB684736A23B633DBA34D5B9A1BAA2DCE92FDDE4AA5A1307ADCA28FDB7DDEE3FBEBAED71DEB';
wwv_flow_api.g_varchar2_table(2368) := 'BFDBE50896D89D5E8D4A6DF33ABB4697D6675A8FBAB7EB8EBFDEBE9608B776EC3D5DC5B87E6A915EAC735CF3368CCC8D7A755BB6D293A1BC72BB6DE07475BDCA1AEC1E5A1DEB6FB5ACCFB78C77061A5F10F2F228119008480424024F8880E697BFFCE5D7';
wwv_flow_api.g_varchar2_table(2369) := '8BF2EB5E4CE2AD45FCEE8A9703DEAE1E599D2ABC75311AEA91579F8F427C7C3E1C915E48049E100111397C42E1A7508C599A04D0BEC6301C645228C3861FF614EEC1F84F2E89C1A8284186E58558A797A1A1E9542A9D55E5D42686D9A6DC47533A5F2E93';
wwv_flow_api.g_varchar2_table(2370) := 'CA68CC29DFE98C2998CD163827B32E19012BC600EFB64150C1DD2D52B2FB54083FB270B79EC7E5BFD72795F875785CD33F927201C2F78AF33387A4B8AB1F673657798578DCFBC3236BEDA4F366D5CE9123FBFC817293D3EB7718AC9EC2287A92C7AAB7F8';
wwv_flow_api.g_varchar2_table(2371) := 'CAD33B4997597BEAC44183A3CCA4D396FA7DBE92328BC7EBB0682BBC81C67D4D26BBD769D5D98DAE86BA40795D4B2A9DD7A8555E87B9A43CE8B639747AB3D5A42D2FF5BB5C5EADD66835E95CDE124555785CE8348ADD6AD599AD2E83F6C4A903165F2DFA';
wwv_flow_api.g_varchar2_table(2372) := '833E972F5006CD6ED8DB68B1B82ACA3C7AB73FB11D316BD4C70ED57AAB9A445DAA1BF5DA80CFED2BADB07B3C0EABBE8215CECA4A7DFE329BDD6A325A2D46DD99A32DB6C05E02C276BDAAA49A41EF85590324B74993B779B3918DD3071B6CC1963CD39A53';
wwv_flow_api.g_varchar2_table(2373) := '999ACA1295C1BEB6193728115F853F58E2B2B80BABC7C92411900848049E2704F88DE07D8C6D020B23717E37F1319D79432C120921E5B58A537124C33B9E38524B24DEA68A49A8E194CCA397A928FE9093E1874A249AC11A12D3B1585084373FAE8A194A';
wwv_flow_api.g_varchar2_table(2374) := 'BF6B58E10C611A603CD8C3979E8F12DC078AE7C317E98544E00911E0B1F24C7FD562892611437B9CBF3C2EA7A6A658C587CC6E199E75CC1765002A9760B0E209C9238EB9ACECFBC2A062CA792A1A4DE6447227934E11B3CCE5553C88599598CD427984A2';
wwv_flow_api.g_varchar2_table(2375) := '8DE57C21CF0CFDDD1DCC24CF02C24CFB045B64D0C90396C73A836F8B3650C88ACDF0E7C73D6F779B2AF31281A70181AFFF7DE4B6E76B94BC9F9F869E9236480424021281A710017E23781F63238607E216BC80F122CA9293376FDEE47D8991629C320589';
wwv_flow_api.g_varchar2_table(2376) := '2389773C4672093E4C45D26E1A2CDCE49D8A8C1C02FD4D3A1DF4F92601BEDFA4B2AC2311786611E0B6E7F9F2CC9AFFBD18CED380C41731C8B026C2E626CC272C2C5F0C563C8893F128CF5F1EC7E4050DDE6D04CF653E70B2BD0D04985A249E2A30071643';
wwv_flow_api.g_varchar2_table(2377) := '66022A195102376639621EF4688039A090121A4580239A799A532E842911CC196124773727F312018980444022201190084804240292007FC37B80774D8239E22BC2375421AB49049E290404CD7BA64CFE63180B2C34C36C586827EC173ACA298C577C77';
wwv_flow_api.g_varchar2_table(2378) := '147C18BECA1383F2879F18847F59D497E82E5B137115022C160186D0F2ED13124B28183ACD2E3BACE44C045B7C0D851EB30B0E0418FDC833D686F032A762312A945091161113EDFE3180906D480424021201898044402220117816109004F85BF59278F7';
wwv_flow_api.g_varchar2_table(2379) := 'FD562A6465898044E0594680C02C515CF82A0418DE0BF31449E4E1AE3C25904180A318E72CDC85EE32C28729C46C0E343C3C0CB96528F5E8E8286C16558C7986008BA1D1905E2AB26B112C9711D7CC4316790663D30AE16226218F8C8C908727B332334A';
wwv_flow_api.g_varchar2_table(2380) := 'E0C0353535F201F52CDF59D2768980444022201190084804BE17042401FE5E60954A250212811F0302C47B19EADCDADA0AD51409AFBFCC1622C3C53CAC98992ACC5A2123902144CCC06662B69413A765852DB62C82CD12D44506CDF06194C384C5246154';
wwv_flow_api.g_varchar2_table(2381) := '31589A1D65E1B7620906768565DECB8D1B37A84E089A4B64D81DA7A7A78772F6C829B6F563E80BE9A3444022201190084804240212812741E06921C0895CBEFDEE8836B55A62B3D43637A975F7B701F8BD3E30AC70713D323F3EAA51760E36561B5CA50C';
wwv_flow_api.g_varchar2_table(2382) := '337C64AD5426A7C92535FAAF3447534A7879ACACAC52D1181E5945164A0424021281AF41009A0ACF24BAFBF0D8E6076A415FE1BA846A8BA414122B02B65CA23A11E0BEBE3EA2B82C8D8B5A82C02404C47866682DE49691D2305B64B884FE999919EA6200';
wwv_flow_api.g_varchar2_table(2383) := '0B7489E510891E4392591D91561853FDF08AD30F58254F25021201898044402220119008FCD810785A0870249DEFEB1E3BDCAC1F99D8713AC6DD95FBD95A52AD2EACE0421885A5A8D585EDEE0BCC962DE989AA88F73F4E973692A3777B8C56565C55C7E3';
wwv_flow_api.g_varchar2_table(2384) := '09830B012A6445DD827C2EAF56B17D807A6C79DB17E9F2ED7DF9DE94BD7BCA7731E58258E1959265B1515FD88384C4B94C1201898044E09108403E791011A765B0F1230576170A61A2BE6428E7F1026D6680B4D842965331679801CC10608EA28475A791';
wwv_flow_api.g_varchar2_table(2385) := '67C0339210E0C6C64668B390A169125499A574A1C48CAF169AD1432D948BD3DD36C8BC44E0D945803F9BC2CFF397BFCBDCDEC5DFE8DFCD235290FD1A4FC5AF3C7F3E5F23232F49042402120189C0738CC0D3428033D9BCD7A879E1ECE9F7AEAEADAF4CCC';
wwv_flow_api.g_varchar2_table(2386) := '67DCC9A599BA4A8F3D58DF3B30930F2F2A56DBFE0A4BD25E333A31A389AD3456056DFECABCA21E9D5AF0AB375B4E5DC8AB2D85884A3435343CA24F6CEEA9F6E9FD7BA7C6866389AC39B5597FE8E8CDEEA1C0CCA72F95344C85543B4BD375551E5DA0016A';
wwv_flow_api.g_varchar2_table(2387) := 'BDBC9D595C184F845301E376C581177A87A793DBAB47F7969B3C55CF71C74BD724021281EF040108E793EB29925232847621CF821233C597E9BE7BF7EE150B3BC36911A8ABABE3159F51D05C15716316B5A29C17779E758482591F0B6E2C2EC18DB9242C';
wwv_flow_api.g_varchar2_table(2388) := '11C480D362B4F9C92D94921281A71381785AB9DDDED3608D97ED3F75EDCE589373B5B4E99C30F5E6C8B27DB57BDFB957DAC7B60DEB7D878E9F527496C77931321F9EEBBB6B7018ECE94CCBA9435A83F39192B16446938919AD8FDDCA713B9A3469D221B5';
wwv_flow_api.g_varchar2_table(2389) := '6DF0DA959387AB4CDEDFFF156C7743EBD1942EB1E2F0068BDB05EFBEFA84F9686CC76CC8ABB58F5E993F99C9E7D271B389516F85CF018B9B515574C35F5AA2D6991EA73F9D5332F1A8C90A7A5FF705E171D565B94440222011785610785ABE8012E05D89';
wwv_flow_api.g_varchar2_table(2390) := '24DB6E77AAB7A6EC5EFFC25AEC7A6B4F7FEB2733734BF343FDBCF0758CAC4697FAAFF42D75DCBA7CF556475FEB4D259F622EDD6678ADA6D6A1D25AF8986B321BFBFAE6B291B98C5A33D439BCBCB6DAD9D9A9CE6C744E8713CBC35AAD9E1D92558A7A7E2D';
wwv_flow_api.g_varchar2_table(2391) := '7AED4EF740EBC71BE1D8CC44DFFCC6765F47A7A249B5F72FAEADCF77B4B56522ABC5CFCCCF4A474A3B250212811F040178E693A7DD16428009F6C251A91E0C06BD5E2F315EF2C888A3C830B99700EFEE72F25062E8316161519D125251F903A7C5729991';
wwv_flow_api.g_varchar2_table(2392) := '083CD30874CF46AE7CF2EB81C9A96B1F7F96496E167D598D65DE7BEFF2CC44CFC79FDE8C2D0DC2DDD8412C934EDF1B3DA6301A2297CD1485BBA742FD5F7CCCC0B08FBEE85E1FEFE08F2593E57A4120CDBE63196A29E9BC72A5737CB2F5A37CAEB0787B3A';
wwv_flow_api.g_varchar2_table(2393) := '0D95BCAF219DCDA1399ECEBE77F5EEF2C0F578263B3F3B9F4F4544F5CCBDEAFC29F2678D0DA2DDC25FF89733FF1123CD6DED5CEF1C6CBDF4CF4A2A2C4A90E7CF5EE4C59113EA65515258D1BDD03A4F87D4CE8E72CF245E7E7652E93B6D53F1CD292EA5D2';
wwv_flow_api.g_varchar2_table(2394) := '5916D9A3C66E0DE39BE9DEA1DE542ACE9838CAC716B6AEFCF64A6CA9204FDA4965A823F2D99C52587A209BD9482BA3ADAD3495C96075A1964C1201898044E0B944E0698900036E329D8B4636EBFC25194B99617DB4FEE0C195E9CF7273F3B5CEFCC17367';
wwv_flow_api.g_varchar2_table(2395) := 'BA3F1A4AA5FBC646970F3977F275878CC60C1C15FAAED55A971717EBEAF9F560087472656AE5E7AF9528DEE31FFCD7F72DEB6B3643EEC491C6317E4142B72BAA2F345BCAA3BA80716DAAFED0E1D5C98FFCF16861F25E36E7B16A5E3875F0EF97F59AD842';
wwv_flow_api.g_varchar2_table(2396) := 'D3DE5A45AD24C2EB2677E573D9E5D229898044E05B22C08BE9B7D440F5A2123262203404F861B50F17224F8C97F9BD64648CF761C464C90F8E407170F277688945A79C3B75F8D77D9766FFED5F0EF9D5C1A6B345E567F606EF7A0EFCEBBF7EE051A90EFC';
wwv_flow_api.g_varchar2_table(2397) := 'EC3FF5CEC44253D71D2E77456D754FD7BCC9106DAEF238CA5B847C329D35E452BED2C0D64E6E7B2BD47F67541B9FA90A96A4ACA54BA33D598DA129A04B961CF9F4D2E5433BEDA5FB4E2FC675A1F9A96C3675EAF09EB1986D71B83368D5265D959F7E7EC9';
wwv_flow_api.g_varchar2_table(2398) := '5A13DE5B7AC064D669F586FEF9EDD5B12E552EDF58E1345636B7DFBA6D37E4C391D4C9FD952331976DE57ACBD93F5554F7DFB8589124AFCA4FCF0C2B3B5B8AC11D53948F3F6A7BFBB84D5FD25C740A6EDAD63EB0B5346730AB8CBAFCB1E3A75B7B97A38B';
wwv_flow_api.g_varchar2_table(2399) := '038D659EAA23A73AA7D796C7FABAAE0C9FAC3AB060A9EFEFEC55E2ABA79BEAB3DE8AB585399E4F3EAB6A39EEEFEAEA5E5FDAAA7368F79E3A1BF45886B7CD9195555B65F3E05278B4B30D3F4E1F3DA0382A6E758DC496C6CEED2BDB0E1C5D191D9D397172';
wwv_flow_api.g_varchar2_table(2400) := 'FA66DB99D30D5A4745D11E99910848042402CF13024F0D01CEE7CBDCE613A79BCCC6E0C06A766A7C2C78A456D1E95D1ECBFC862677F3567C33AEF1ABEAAADC3B4B56A72A5D1108B0D7266374EAAB2BFA3A26566FDF3669B455E525CE0AF79D9E519DF9A6';
wwv_flow_api.g_varchar2_table(2401) := 'DB993438DC4EBB51A5B1984CACB1A53299F4435329BB77667A722270A8861D4B54F91CE30F5162F7D8558A4E6D31E8949862B2F775F6576B1477CD91E7A9A7A52F120189C0B74780377B1E1A72F6E0B747F2FF67EF3D9FE3CAD234BF9B3E136981CC84F7';
wwv_flow_api.g_varchar2_table(2402) := '04E841EF8A641559BEBABA6ABA5B3DDBBD333DBDD244ACB4135228A4FDAE0FFD457F8022A4D9188534BB13D313BB3DA3ED992EC3A2297A10000910DE7BEF814426D25BFD128795CC0249348B5544B1C87303BC3CF79CF7BCE6B926CF73DF7BCF951A5E6E';
wwv_flow_api.g_varchar2_table(2403) := '047898FF3B0F7057B92568AD9D6EF92F7FFE3FFE446D74F64D2C86E687F7ECACCCCF2D7656EFABFF87CFFEEAC35263D1EECBFFF166A4F7C2071FBD3BB890FF2F9F5C78EB98796FD57B4333DEA5A9C17D554E9D46590D26A6C686DF3854E8A83DF637FFCF';
wwv_flow_api.g_varchar2_table(2404) := 'FD33EE8182D23FB970A5E188656A3EF7F8EC1F3E3FF567A54995DA6452C67CCAC50B177215EFF0FCBAC3B076A5C7B8D731A3CDAD536B348954D2A8D7FA939A81EEBE33A7CA2F7E3979C839B964D839FEC595D33FB55FB972E55F9DDF7BB93BE508F6F9AA';
wwv_flow_api.g_varchar2_table(2405) := '3E52AD2EA613BC5F3D565C966B4CECDBDFD0E512595FEE7B2D2CAD25235F7B9922A4284D8D5DAAE8B256EDD53B722D8EDCD5EE4E4B51714FE754DCE21E191CC8B39A8C2633F3C57F7A6378B2E9D348246A991EC9FDF017EDCD2D8994EA7099A22E7E3F1A';
wwv_flow_api.g_varchar2_table(2406) := '0818F4FA6BADB3D5B54335C5077A4B6B52293F39EEDBCDFDE506DF6CD83234705FC9D52D0EF7E4E559545A1D73ADF4CC0596AE7E51C22D3EF5AEEF7C0F4A851201898044E00541E04521C066ADFAD0A15A8B351F5A5BE288971FD96F50876BF69F28ACAA';
wwv_flow_api.g_varchar2_table(2407) := '0A8775A1F5C55870DD60B29CA829198CEF522503E9492E36969A527B2472D43B3BA455C773720CFBEB0A06DA3C4A38B8FBF00E7D61813EBA4F51EBF714A92DC9BDD5B9A6E1FC43C596E4DA917D7A55B8B8EE14FCD850BD4F63B72674B5BCF172A2CAA5B6';
wwv_flow_api.g_varchar2_table(2408) := '59D41ECF91EAC2BCCAE217640F49372402128117070108308F2EBF38FE484F24022F20023C98C023B5DFB963DD432BCEC84CCE81939DBDD315A79663B144341CE271DD196FCC33D173FC445DCFBCF7B599DE3D95F9CD0B355393A3D5B9C515FB77CFCCF5';
wwv_flow_api.g_varchar2_table(2409) := '2E4ECCC44A0A78739EA77C93298DD5A8DE5959E6AE3B907216C5D6EFEC3FEAB6D7EC1FF8DBCFFFEACF2BBB4B5FFBC3EF7EF7B1613DB7A8AA56D3B3AC2D9DEABBFFC6CFDE70563A975586B1E6FABFFC9F0F38F79FF4241483CD5553110CE61505FD7E4F38';
wwv_flow_api.g_varchar2_table(2410) := '3AD535F0EFFEA7AA7EDBD9DF5DF9F478605949440EEFA9FAE715C3FCD4DF1E386536584E66BFEBABD7A8B47A5D7AB2AE8D1904F80AC5C923B51AAB3E1B311E7276E9E2AEEA3DF1D0BC3FC7313E3BBFCBBCB8FFA3FFE1B7FFEFD589E189DCF8DAFBEF7C34';
wwv_flow_api.g_varchar2_table(2411) := '3C743BAA56C65A268F579B357927CD46C5174A4ECFCC70C77F478E3A5918AF2CB4BFFBEE1B2D7DF58948FA89719E19D1A8351060CFE4ECBFFBABBA9B7335D34D7F935C99DB6B4E1CFEE003045643CAAC2FE6EF6DF8F82F7EA9B59664FB23CB1201898044';
wwv_flow_api.g_varchar2_table(2412) := 'E06542E04521C0569D6ACFFE1DDC7204DC3CB3F6FC99C34A22A6D769FC314D52A34495648D439353B833D766CC3F739C269DF6C1BD52A34639B2B33452E1A6A7DEA02F575405674F226030F29BA272D4EC65FEE7DD85E8DD6D51A95D6F9DD66995FCA22A';
wwv_flow_api.g_varchar2_table(2413) := 'A13CA5D23AED7BD2469D16D6C776B8B17EDC5EA856923AC3E367957899F6BD8C45222011F8A608408059BE692F292F1178A510781E8F482C0762D7AF36BE5614339CFBD5677FF39F4EF4DFD97DE0A354696E52AFBD76B9BF20D2FFA35FFDFA3FFCF6465B';
wwv_flow_api.g_varchar2_table(2414) := 'C3B5A25DEF189C258303D7F6EEDF5756527CAFBB636D72E8D0F173D5F927F43AB57A68CA6D33575656288AD9C73F23D38390EB556AF7D4DDEB1F9A5D68D8BF27CF64E511E9D850AFAE2238555AB32B1C8A54380D79A5E5257B77DFED9DAD8C3456ECDF57';
wwv_flow_api.g_varchar2_table(2415) := '5C5C3638D5EA5A9D35E498720DBAF203BBEFF64C2C19EA8FD6146AEDC5BC9FAF687466BD56AD330ECD781CB34D253507C4088723613190BCDBD03038BAD8D2D272ECAC53A5B5DEBC37E65E5F2E3FF3CBECE3C469C1338BA2C90BA9D46579D6CE71D7F467';
wwv_flow_api.g_varchar2_table(2416) := '9F69C34BC55547EA9B3DB7AF5F0F2D4FE893BBEB8E5726E6A6AC9A48F9AE4A9FD576E2F8715E092B71AB267486B1A5E8950B9777EABC9ADCD38DCD633D832DEA68F87C5591ADA4F8C2676D33D1E1E34E67C4E5EEAEEF99BBF0C5C9BDC5EAFC8347ABF354';
wwv_flow_api.g_varchar2_table(2417) := '078ED4B70EBC692E92538166EF0E59960848045E26045E14020CA6D93F9906AD5AD1A6BFCDCBBC10894452AB521DAFAB3038D22FE51A788089BFAC85D1A8D19016164BB6806AE33B07E92F286D506BBD3E1DAF3EFDEA705A7E63189BA6DCA255BD31AE35';
wwv_flow_api.g_varchar2_table(2418) := '18BE761776A355AE2402120189C0631020D3150A85B227AF22C792BDD027B34999777D99D1EA318A6495444022B0250290BA233B1CA7767EA8AFAA5CFFE8272AA34FCF7D70AD8647858BCC9AB31FBE5359B5EBA71FEBB5EB43EA44E2CCDEE2BCBA9FEBF3';
wwv_flow_api.g_varchar2_table(2419) := '779584E73EFAF0ED9ADD45BCA7ABD3A67FF30F56E6A6DE798F410065EE73BFF7569DA32C61D5281FBF73667E505BA48EEDFDF87D438EEBADC3A619CD7B3B7315DD8F3F0ECC8EF0B254B1C5F8D14FCE2F0C7730C1964995FAC95B272353C6026DF2CDF7DF';
wwv_flow_api.g_varchar2_table(2420) := '75B92B7EF423DBFC90BE3091D8FFC13B6A77D1BB6FBFADB115BFB94F5350FDE1AAC962751665CFABCCD3D039A9D8FE436FC61533A39CB995E0E0F060A4E2AB07DB367060EEE6DD87EA74569B9270152AAA4AA7C513754697060F1FA92CDFBD736E5D9D0C';
wwv_flow_api.g_varchar2_table(2421) := '4E9D3BB72FC75671E6F582AE2FE752AA3554553A732ACF9FDB50A0A8D7933395BBE3D1F553A777E82C25F1C4E48EFD4EBD31C19CF2AF9FD83DD2E4A9B0C676D69D88398AD796F787FDD3CCB895A7574E9F3B69DCB5BFABA9414E822560946B898044E0A5';
wwv_flow_api.g_varchar2_table(2422) := '4480EFEA7DED9A2B82CC5452608427160679BCD5C3C2072779BA89A78968E5731D8FC50561F22476FB133F21F0D85E8F56E21CB32032866402E7ECDF8F4725B7B966717191D959652E689B6197E6BE470438DFFD7E7F7E3EEF29FC50979595153E9CBB85';
wwv_flow_api.g_varchar2_table(2423) := 'F7DC861B1B1B5B5E5ECEBE1F873CB19BCD66BEAFEBF178F81651460397C1D9D9592E055C24C5D532B3160571F114E5F5F5752E984CF89CE9CE8594378A99D23953F3BC0BD0751838D131FFDFEAEA6A5E5EDE164F74FB7C3E84593679C561008C19248962';
wwv_flow_api.g_varchar2_table(2424) := '6D6D8D19ADF932D326C94D9BFC7650434700595A5A4273F66F84F876F126B57CE729E3005F8462713A9D8026FCE78642461EE5EC1D214F2B659467FA6EF2446E3E5704D8BF1CED5B98600771283E69FCF0D88E0C55188F881393C7835549DED215F7AF99';
wwv_flow_api.g_varchar2_table(2425) := '1739A9D67C55DE3811718031032FDD326AD1706F5BFDF0A6797AC4F3B56F083FFC6E3077DB550AAA1E9C8F099E96E62965959AC9A1192A69360621CCCA9C9E3D64A38CFC860B0F9E0A4937294C2C92EE8E03D4622B3DC64A97D0B371CB7D2336B6184A6D';
wwv_flow_api.g_varchar2_table(2426) := '8C1FD27E764DAC4D74DE7CFBF44193B3EA6BB1A7FBA72BC4FF8994928C45753CC6A65233AB743219D36A1FBC8E118B2795545C0B4DCF8A948EB804ADD5E9115331B133B35353A9052B959A89A3B56A824D6B601668A6BFD669D57417FE52A3512511A355';
wwv_flow_api.g_varchar2_table(2427) := '2E120189804460FB11E03782F1D8C2C202BFF8D9D6B946F188CDDEBD7BEFDCB9C3EF7E4E4E0E9B0C3F58B33024E0779F810D232B3AB2F0ABC192BE4C7F75111685ED1B78657BFFF4652EFE1BD4F7E97B6C9324F8F2139E41739BAC4A331281EF0F012E3A';
wwv_flow_api.g_varchar2_table(2428) := '924E6C821FEEC7351A4E0B382CB466D61B15E91B8814C40D4124218AD904B8ADADADB0B0B0B2B27293DAE7B1890F434343C3C3C367CE9C8125DEBD7B777A7A1AEB67CF9E7D1203471E013E50BCC99FD1D151A2E0BB4DA21E9D9D9D9D56ABF5473FFA113F';
wwv_flow_api.g_varchar2_table(2429) := '369B84339B737373F7EEDDE3EB4DFBF7EFA74B636323F714DE7FFF7D6E1F20C37D049400051F436693AB2B1FB1C381DADADA13274EA016F49A9A9A6666668E1E3D8A8C289797979F3A758ADF36E8447373F3C8C808F2478E1CE9EEEE1E1818802ABFF9E6';
wwv_flow_api.g_varchar2_table(2430) := '9B19869CF144167E88083074D9F8F243DAF7342DFB8AFDA68B5FB1DF8D6A460D0F0EC28DF1C3E6410E95D95C74634494AE6361A424743FD84C3F3C966E6218256A36CA0F6536E4332D1BC472C335AAC4D840D812EB87721BF6D33CF6ABA5C469DE71E6A4';
wwv_flow_api.g_varchar2_table(2431) := '298F2CF1D79774CFF422FE67C64ECD57F7EF885EAD7E381901DC953B4B42387B9DE6BA9A07F5DAB40C7F0F165E31CB00B521F5409BF07C03D187C25F7592FF4B04240212819704818797E09724A0ED0A83A11B43B4EDB226ED48045E0804B6C816BE10FE';
wwv_flow_api.g_varchar2_table(2432) := '7D1F4EC0CDA058E41BB92070598089C18A7104EACB8D49F1A55FC82735DC9BA432DBC7FEFE7E36617DF3F3F3C8C02A197D420561A4642F59A336180C42355145F2939C2D3C13BEC71A5E4DFE997AA1503C98E3F57A617DDC0AA5178C11A24B228E4AF2F6';
wwv_flow_api.g_varchar2_table(2433) := '384966BBB7B7F7E0C18374877FC2247905F1F0E1C3D8C23A6E234C1712BF98400FBB9B5EE47B719BA68282024195A9A4807E149283A54C138CF4E4C993C4CB5D12ACD397253B5834747474A079DFBE7DF5F5F57CC689A861AA3058C468050D5409020C5B';
wwv_flow_api.g_varchar2_table(2434) := '86FDE236B416CE4C01424BD29802377D897A7070B0AAAA8A2E305EB7DB4D13F2E8A406468D30927D7D7DD8FA4669C66C87655922B03D08E459E0A88FB0DFEDB12DAD48042402128157120149809F71B733506379C6CEB29B444022F0B22090790C040A07';
wwv_flow_api.g_varchar2_table(2435) := '238588B2C075E1AB5041D6704BF1708EA0C19BE2861092B7ECEAEA827FBEFEFAEB50C7FBF7EFC348E19C6FBFFD36CFFFC0EB60803C7DDDDEDE0E9585EFF1FE05A41173B03E089E5008F19B9C9C8415E30F1D2F5DBA046D4618CE49DA19AE485E74CF9E3D';
wwv_flow_api.g_varchar2_table(2436) := '6843333270480A505991B345E6FAF5EBD82504BCE559F10F3FFC10160A7BBC76ED1A6298C307C833E660C8648649E7E2CF810307AAABAB5105FB25A50CE9C525D2CB98837F120E4D08B040EF49D88AC43821FCE217BF408CD8050126CF4C98B48A70300D';
wwv_flow_api.g_varchar2_table(2437) := 'ADFDE0830F080ADA0F9B9D9898A8A9A93976ECD85FFFF55F030511BDF5D65B7FF8C31F842462E87FEFBDF7FEEEEFFE8E04355003E6F8F83877132401DE74C8C94D898044402220119008BCE208C8475C5EF10340862F1190087C2B04E06C22254BE211DE';
wwv_flow_api.g_varchar2_table(2438) := 'C5C2AD3108B0C87F8A4C2C6961786086DD65EC4144A9BF79F3263415064B3A94942C640FEE0A7B142F1893B385EF4114C9974220C9D0C27BA1762CD90FA1C00021B1903D9129EDE9E94109FC19E51042C82AC2BCF12B6EDB91BC25C10BB184640A255059';
wwv_flow_api.g_varchar2_table(2439) := '9135858AD391CC33E670069D1072283D395E18B2F01CDFE0C398A02FB11317BC9A0795492CD34447C184891D31169112071FA835F1D205667EF1E245B2B899DB07B466B2D958C122C21448AA0BA3009BA9C15B52CDA2156C2910111A28A01088C01FFDB8';
wwv_flow_api.g_varchar2_table(2440) := '21FACAB5444022201190084804240212810C023287998142162402120189C03322006123950A434BB35C951ACAC7EC32569B1556178FA759A2E0BA22DD9AB1011B6481D032B1163955160824A94B9198854992DEE41165881C3412464D0A97354957C827';
wwv_flow_api.g_varchar2_table(2441) := '0A79C135A30ABB105792B4705D38216584AF5EBD0AABE451677A417D85399C81D6C227CF9D3BC703C6D06312BF38460EB6AEAE8E376F794717D322798B153433DB04BE7DF6D9673CF34C478451423296D92920B13C78CC268678961B85B76FDF465E70DD';
wwv_flow_api.g_varchar2_table(2442) := '341A5FBD174D81BEF84081AC2FEC1AFE5C56563635350565853CD34A1302907914E203A9661EC0C679D2BF18C51C0C9FFB0284890C56C854930AE60601218009096AC2A4066FD924030FC347A75C5E40043836C4E1F102FA265D9208480424021281971B';
wwv_flow_api.g_varchar2_table(2443) := '0149805FEEFD2BA393084804B60301481AB94AF89DC1A04FC58249B52915F118921EB5CAA0D5E9988A165E07C183D7657B036D236F09C515C4922C2BA95112ADB041411479821A7A493D8F1093F2BD70E1021C954785C9EB520F6FCC68831F922586B5F2';
wwv_flow_api.g_varchar2_table(2444) := '522E995E0830EC42F4223B8A30CC901A2C521093994156E1ED780EEB8624D3056D624D2C2451C912234C0D65FCC10DFC14549F4D483E1966482F41518675A316F2D9D0D0C06C58A8823CB320C95AF829DE10A60C03A717EEC1D249711311218B642F4E32';
wwv_flow_api.g_varchar2_table(2445) := '451638C0CCC9E292F4062272E33C597DEBD62D52D3BC240C083CE37DF9F2659A709287B4FFF44FFF9470A8C14952E8506200397EFC384C589896EB170A010E094E070ED717CA2BE98C44402220119008BC22084802FC8AEC6819A6444022F05C1010592C';
wwv_flow_api.g_varchar2_table(2446) := '88220B8F391BD5E1D4CAFDA47D97B27227A1D227BDB644E17948200B237ED866B61362022A38248F1943206105A44699E489CC274960B2A3CCD80C7D25E50B0FE4AD5AE640C60A2950D6643B7986998E38000984EFB1260D0B518467228C367AD1970C33';
wwv_flow_api.g_varchar2_table(2447) := 'AD82851E3A748856C4102089CA5BB558C72BB834AC1219E411867F92C23D7FFE3C5C9A576DC5D78678C31613F8060D8612E3033958DCA0D7AE5DBBD82434082D05D82C6562216A0AC422A216CA29238351A82CEC1A27853CCED004318645938EC64392C3';
wwv_flow_api.g_varchar2_table(2448) := 'E49971980C39249978C98453035586DC42F809070ECC1A0F49689328260AE11B3268104F4D0BEB72FDE220C041CB61B3E97ED08BE39EF44422201190084804BE5F04183F8871CB737223FD78DBA3AA339514D203B78D85D11B4334163200DCEF671046EB';
wwv_flow_api.g_varchar2_table(2449) := '93E6174118BFC9363CAA5CD6480424021281EF0581EFFC3BC0BC8CCA344B10399EE6E51DDFA4A255D68655DDFF215178463DFC9F13AE1349B53152FB177C0789EB21294D982724708BD849F392ED140F45C33C1F95E4AA7BE3C60D2EBF4C1045384CE6CC';
wwv_flow_api.g_varchar2_table(2450) := 'E5999C275766C824FCF3D12EDF610D56B00E73FEF5AF7FBD89CC7F8756A4AA1F3A021CA5DCAAD8220ACE17EEEC3C69FCB04547D92411900848042402AF0202FC46F094D9ABFB1DE057611FCB18250212811F2E02F0CFF4CD41DE5F4D4452EBB3D060756C';
wwv_flow_api.g_varchar2_table(2451) := '3DA1B32BE68A543CAC8A2DA7C2BE849AF99CD23713FF6898A446496092021573233F569E8C28941B464D7AF6DD77DF45864C1A0F156F0323C5281C1E66BE0DB61E1BBBAC94084804240212018980444022F02D11908F407F4B006577898044E09546E0AB';
wwv_flow_api.g_varchar2_table(2452) := 'C76452A9684833F62F4A4E514A9D93549914AD5949C4346B7D89883F6ED0F3EEEFD3106072625BA7C5A0A0BCAF2B1087F7C296459924F036EC069E8E3E7DFAF436189226240212018980444022201190083C270424017E4EC04AB5120189C02B81000498';
wwv_flow_api.g_varchar2_table(2453) := '0C306960456D881B0B54116FBCE88D84CEAC32B8921A63CC901FD798924C82F57404F895804C0629119008480424021201898044E0FB43E06B53927E7F6E48CB1201898044E0878700F9580830D3227856571796573D8EB3F3C6C3B3AA9AC59069C6706C';
wwv_flow_api.g_varchar2_table(2454) := '51531B28FA20A9E8371872FA49E9678890091798FBEA69B2C74F52CE0BC3BC2DFCA4D6A7AFE7BD4D5E4E26DE4D5D78FAFAB12F7C326333B3586F127E9A4DF1F5230CF17EB598289877ADF9DE12EF0265BA333F163598C8D450E65BCAD991F211293E6E2C';
wwv_flow_api.g_varchar2_table(2455) := '34508F3CD36865E4D96B7C5F8A9D82A14DDA0462044B5FC0671750CE74DCA2C0479BF87AD3160204C2B285C0939AF0E4B11D413E1B16BAB39BC401C37E619E3030E44DAA47D5F23AF7E2E2E2A3F5DF4B0DBB40ECA66CEB33ABFE8E8EEECECECE89A15E25';
wwv_flow_api.g_varchar2_table(2456) := '19C96EFAF6E5B5506270684889FAF88AF4D0F8DCCAE4302F296CAD767C617D767C0880B716CBB4CEAC86C786069554980EC3E33311CF6C3CA5740DCF3045F9FCC4402299EA1F9B8E796732F2B22011900848042402DB868024C0DB06B53424119008BC84';
wwv_flow_api.g_varchar2_table(2457) := '0830768744C1435696973DBEF052D0B8BCEAF7AEAD2DF992AB518B3FC4B75E02900D16482C84F9B1104051202A9B9AA05270182A216058D9D4FAF49BF8C6FC5B4F2FFF2449D823CCEAD1562AA19A8FD6C3BE20638FD66F5D034ACC040673664A67E6B806';
wwv_flow_api.g_varchar2_table(2458) := '0162E7434DB062B1A63B804068458DB8AD006585FDE2216B5A91812EE200C4958F2AC14B61C230643E0ECC8EA09535F57C3989021AE0901842BF709870E8383434842A7832DC0CB55BBB2D5A7115F92749D2CA941EB8FD24812DEA9978ECB11DF17F9345';
wwv_flow_api.g_varchar2_table(2459) := '00040D6C113E20D02A20DAA49C8E4F19D4A68ECF69B3A9A98918B35DBD3F327FFFF2C5C995E52B176F79E79E0AFF2D7C5B8E292D0D4DC9E0833B41939EC4E52B5794C03C7BEBCB86AED1BBD77844638BEE3435F42DB5D57FA928E1ADC5446B2CA9DCB8D7';
wwv_flow_api.g_varchar2_table(2460) := 'B73CDA1A4924EFF54E7EF2C9BF04A63AE209656A76697861F1F2A7D762FEC9CE295F77D36D2521BF05F534884A198980444022F05D22201F81FE2ED194BA24021281570D01F80664834FE042962291B04A49C8D97C1500004000494441546AB51A3EFC03';
wwv_flow_api.g_varchar2_table(2461) := 'F14825E3ABAB2BBCA9CB277998350AC94DE0404DE15A7CC8076E061F3B79F224EFF442BD980A8B0FD8767474A096EF0C51C9CBB7E4EB20787CEF874FDDA287BE706694F31D230CA341B801E7619E2A3E2384036438A9C434C2748151D3EA76BB993D8B4D';
wwv_flow_api.g_varchar2_table(2462) := 'C8062413CA870604A0944832FF16326CA2936F23A19639B7B0881EB431B13F5C9D021ED20B57E18DB88100DDE15D504DDE46C649D81A0BFE43F930C40CD59491C72BACF0E923282EB4133DF883151C460F1DF10755B8813698276EE02A927C118A0F44D1';
wwv_flow_api.g_varchar2_table(2463) := '0B7FA8E14D69F45CBD7A1522073808E01858B5B4B4E03F3E101A382006CBC5346AF968131AF081AF22A3815E844977F4F0C52990644A6DC4B8494142980F41B1472823C61AFD04422F11356E008588177F3087F38489456C2126A22E2E2E6693BB0F6237';
wwv_flow_api.g_varchar2_table(2464) := '113B91F24927F4E32DDF9462D7B34FD18609347384D044773CA41E54598B8307FD7CF909E47118D038C0842ADCE3534FC00EDA840380404D2B9FAA82DF32E538D1218F00471AEEE1126EA3075B68C0D68BB07074B19B009C0F83319339B0E0D5E25A50B7';
wwv_flow_api.g_varchar2_table(2465) := '365FB9674FE3A5B6F58549B5EBE0C8C8B02EE2AFA9298CE80B46870652B1905E9DACACAE989C8B95BB126163FECAC8E8CEFDA5733EC3E2449F41A3ECDA513AB2A60D2C8C9A8CA681A072FF0FBFB7A5CED5BE765EA536AF4792935353F1B02F1A8F4FCD2E';
wwv_flow_api.g_varchar2_table(2466) := 'D69AB8B3A31E995B5B5F18775AF545E53B7AC797928195429BB6A07AF7F0C4AA7F65A6BF77A226C0DE498DCFAF79E6260BED1A7BF18E91D199783C50E1B2ACA91CDEF909A7CD505EB583B72166FCD1C9D6C6F77EB63394308C8ECD0F0D0F448F596D6A65';
wwv_flow_api.g_varchar2_table(2467) := 'FF8E92A9B0F3B3CFEF26FDB32515FBEEFEE3857DC7A6F4CE5D2FC25E903E48042402128157070149805F9D7D2D2395084804BE7B0418BBC35E2021901CC88960B9D0128807C6A8614D93A05214321E20498E0E12C2176EA1435014D8175C057202934103';
wwv_flow_api.g_varchar2_table(2468) := '44054E4519EA8B7E12923061C10D9084DEA013FDC8608B56BEA34B19E24725622466219074A4156DB04A3EB084B7D060C8243548A2199D98461BEC8802F5502961110138307AA0556886EB32FB34929461658861945E78087D25161C461B9C0D264F14B0';
wwv_flow_api.g_varchar2_table(2469) := '38989820C95887F841E9A19A7033BC42394C954076EEDC49171040067374C41C5F0666C11670E1336C13068836F45303AB2428B822640FC4A8C10A7D05A54415356803583137181691440058001CC7E8555D5D2D0061A7D04AFA11BBA825764080960B78';
wwv_flow_api.g_varchar2_table(2470) := '4947C33CE1A8800302784EA45059BEB74C0D4497EE274E9C20340284AE639D85C7AD51422F5C82D7416E8902164D2010663C271C760478B6B5B509BA8B3CDD3187F3C08212BA830C8670099C01E4FAF5EB507A36B93F027A44217A518066E3336A993F9C';
wwv_flow_api.g_varchar2_table(2471) := '32B1E324F5F05E02C122BB09B54007C23451663F62EB4558F090D8D91DACA1E8E220D768D46B3165A8B367EF0EABA568C7F5C6FE95A9269F2F1E9AD3AE16BFB9D67A5557BA7FA4E5E62F7FF1C1956BDE9FBE165DCE3FDBFAF995BC8A1F5FBA3567F276CF';
wwv_flow_api.g_varchar2_table(2472) := 'CC277CC7CBEF4D454A124BB5878E2D2E6BBCBEC580CFCF2D2A42D6A8945852D3DA3D1AB62763EB4B7ABB6E702974F3EA9786943FB0B0F617BF7A7BC56F1EEE1DB2AC8E9FFD57C62FAF74ECAC50226B1EBD4933B61CBE71B55E9308B47817CFBF73FE9FBF';
wwv_flow_api.g_varchar2_table(2473) := 'E83E5515D31A5FBB79A3B5D0B86C3F72483C4A3DB9162A482CBA2B7F1AD46876D65434D5BB1545A5552B51B56E71AC6F47994DA3CFAD2BB4DD54E7AF2F4C3B25017E118E42E983444022F02A21F07034F62A452D63950848042402DF0102D00F78052FF5';
wwv_flow_api.g_varchar2_table(2474) := 'F1F42CAC035207D380C3C079A019702AD8230528138FE042C9A03119AB0CFAE14E903A9830048C741F0B140B9E030D80DEC09D603B82614296E848720C19E46147A8853A92A884834174D1863005BAD3175B3803C78308C182300411A25E5059419B7118';
wwv_flow_api.g_varchar2_table(2475) := 'B2B16BD72E88161D2163B0535CA50C4D82D3528054D30BB204B3C21FE22528ECA21957F1845E303AD81D38C05BA8876DE21E0EA081BE34411AB14E50C8A310F20C2CA04481262AF18AEC2B0415346089281128D19702DA880E6A8A2161942E440703C779';
wwv_flow_api.g_varchar2_table(2476) := '5C62133141E7E842B0D45010F56CB2883B1154A247D45366111D7106FF890BACD00C92A8A509492C22062024A5F150C0C85E2058F081D0122961528600D34BDC4DC0223B029EC942981BA6D229741006072AE92EB2D6440726105A71D80008F2780B9B85';
wwv_flow_api.g_varchar2_table(2477) := '1BA3874DC027678E12948B44313702D8774203A6518269FCC713CAF8CC1105AAEC02C1DBD9D7B80ABC08A08DC30685A04A8C2FC882FF1CAB75757582FDE215CE69B4EAC5D590125A091A73EE5C6FB2245679FEC11B48DD6EE9AE36796A0E1DA6351CF44E';
wwv_flow_api.g_varchar2_table(2478) := 'CFADC582ABC1586A697A6162C9DB7AE7765E8E62CB737902B1542C3C3DB39A8C2CB9DD853693AE7A6795A236A7434E9F7E8AD6A0D3730345A3D16A54F78617677A1BDDF90E8DC93EEB590F2DCE6BF4EA8EC1A58EFE0E4F5FDBE123B58E925DF469195E9E';
wwv_flow_api.g_varchar2_table(2479) := 'EABA9DEFB226F579EBFE00F731F6975BAD453BA291F8F4BC27E45F4E25D2F7BCA289A4519B4CA90D395AC555909F52E9D3D305702F4CA5D8AD86754D4ED8BB6C542B7C202D12968F40A777885C2402120189C076222009F076A22D6D490424022F150222';
wwv_flow_api.g_varchar2_table(2480) := '2749468E4C5D66816388054E05FD608193C05218D9C321B3E3273F09D581C1A207920911857FC2D0189CC376904703F574A19202C40619B28B2814640601081202904364500535A2AF608CE2B158581C0BAD2CF02B1814EE41F3D0805794615968403929';
wwv_flow_api.g_varchar2_table(2481) := '5CB4B1097782BFB1C09AD884B3090E8618141149EC528673D21D3A47190203E9423FA6216688D11DDE8E306524A967A123F2885189032000ABC42E3540813CFE130B0A59709B2E2270C4281011E1E30C771C904486107A7B7BD103FEDC7D40399AB901C1';
wwv_flow_api.g_varchar2_table(2482) := '63DE68234C34D30A2D877F6202AF446259E8273A182CDAA0B8D4A01F0DC8635AB0562AF1814DF6A3D889D4C04EA981B2B28F088D85FB14940592A8020D36E19F0249762B9C9F8E1C0098E080C12B7AA1992E19CD74C479BAE0003B5A6042CA1A7CC49183';
wwv_flow_api.g_varchar2_table(2483) := '0071618BDDC4423838895A16512FA066937D8D0F22284C003535706660A49540580821DDF305588882879F3FFCF0439E4DE090131EC592C90293E68DB7CE762FE7F4B7D4EBF4497D32515D5E58BE739F566BF0066301EF8A96872F349A1CB763666E6D69';
wwv_flow_api.g_varchar2_table(2484) := '6E52A54449ED6AB47A5D2A55B7BFBCB2ACAAAEEED07422AFEB6EBDDB188EEBF2D6BD3E25953EA1D8BD7A55F2C8BEEABA23470C967C3EE46DD080A4D661D21F3E5A3BB29EDBD970D56E488554BA54349248693D2BDE6828904A26C8B9A7D45A87597B686F';
wwv_flow_api.g_varchar2_table(2485) := 'ADD651C2E3078EBC3CA7C978E048DD6C22AFA3E1562A9C9EF8CD9563980D1962BEF44EE7D5DF38AC38995C6532F89525BBAB6062299808ADCCF893BAC0BCD9F1B56B82885DAE25021201898044E0B922A0F9CD6F7EB3B5013108106B7E2F59367EEE13FC';
wwv_flow_api.g_varchar2_table(2486) := 'F4D2313352D9A404797EDAC500655393DC940848042402DF0B022251B68569AE5A1036B801854D625008480854445008D10AC78050910F24B3C7420E90C41A0B8547179827DC265B2DB6E0968CF8D1009314C409BA42811AEAE1667481D590938438E118';
wwv_flow_api.g_varchar2_table(2487) := '6524A19AC8D09D88504B197A4325648932AE621DFA8400740E0FD1890684E94E3DD111084FDE420B7100BA8518CA29938DE4EA0D79836571A987E9C1C4A8A189C42CDD29A396267A09F64B8D78A81887B9E6630501BCE2D701CACAA62087E8848E8A1F05';
wwv_flow_api.g_varchar2_table(2488) := '329040474714D28ADB24B709902799F13CF3B3826930C77F94B01005695864E88B3F8449253C10BE8DDB824602175D841E810F81935F8578A30D9F41892C2E5410EBD4D0CA9A561C0301BA608E70D84DD4B317F8A5635318A54C9692A050823CC2ACF11F';
wwv_flow_api.g_varchar2_table(2489) := '01010202608B4E54E11E81082B94710F31682AD051A6230BDE42DAD9238443FE1679F60BD1718CC1E741894D4CD38B10842A9199A7233A71922E14F08135BDD04C8CB8813C3EB04633516002BB004877F635F1A299487135FB80FC0ECB58D9421B03099C';
wwv_flow_api.g_varchar2_table(2490) := 'CCEC6840C349760AB1677AF902913C75A4EEF8D1D5B8252FBA58B6F7A05A51EB4C96D23CA33DBF726DCDBB9ED04E0FF4BE71B8565DB42BB6BEAA56695D66FD819307527A97491D35E6586C666B34A9E498F5154E73ED9E7D6B5183439B2C282F5554FA50';
wwv_flow_api.g_varchar2_table(2491) := '3C950879EA76ED48181C6B1E5FA5CB54B5EF7034A1224B9CA3D7E4E416C643EC7D97C99873FCC89EA0D6A98EC37E53D5C5B97B0F1E8E260D56932647A375141585839143BB4BC3C602FFCABCC5622A779A4B77EE57690D46BDB665C4939B982EA8A88D26';
wwv_flow_api.g_varchar2_table(2492) := '7541EFCAA19D25217BC544CFA037E02BB7A96A8F1CBBD9B352121BDA7FEA0D956E23299D895C162402120189C02B8F00BF11FCC8F243CC2FD7263018393038E1D793DF35063F6C8A35057E44C49A5E62E1F725B3083D6C5248E71936E9653353496183F3';
wwv_flow_api.g_varchar2_table(2493) := '3EE0BD78C3C20F1BBFA9FC7CD2FAA49F4F7CC240E656EEA326648D4440222011D86604E09382363CC92E974B92A8D0420AD9325CEB205A5014A81A0C2DBBE9DB94A17C5038788B60B318C53D2AD984B1701DC71C7631C1263F03D01BA80E626C7251A695';
wwv_flow_api.g_varchar2_table(2494) := '327C8F6B329B102A045048777A71058644D1179AC105992ED01E5A055F1235087049478348AE0A12C5B51DB5FC84709DA7173C8A8E688359A10D7961170E864B28C42E62D4F30B84CFF80023852DA324E3249AC9C78A598E0801328CCFF06714B2891864';
wwv_flow_api.g_varchar2_table(2495) := '8C9F3A415C11A69E05D3E864A1805AE2E237850256A821044C101DAA5028640013CFF10A04409226FC441E5759609274411279F629358889D8D914169117C48C5642030D3CC45511200ED01D4FD029F83FB1238621C490411B350258B11784E708F3834D';
wwv_flow_api.g_varchar2_table(2496) := '1386889490518287BC3C7CF4E851111A4D1CA2020DF480093E90EEE67716E5B8271C263A30618F204338F4A2CC1A25199F314D995EF84F3D8E611431A8BB28831238239606FABB5E708663660BAD784E144F1A3F888EBE50541D5AB7E4E5F124B32AB06A';
wwv_flow_api.g_varchar2_table(2497) := 'CA73AE2CFB52F1507E6E4ECA98BBB4BCBA1009FF7F7FFD7FFFFB3F3F6DDEF32E878E469DD4EBB4B94EC77A44EB5B5DD02A71B3D5EE0B84D589A8D361D6E53898554B13F63A0B9C10E0703C15F0AE3A1D96A4861B497E932A6AB2E7ADAC4742BE659356B1';
wwv_flow_api.g_varchar2_table(2498) := '3BDDCB9EB02A1EE0D9680E076F3019595FD3E83439069DC59EB7EA8F06BD4B66ADCA9CE7F4FA422EBB3EACCAF12C2EAA5331A7C3AACB493FBF406EBD6D78D1B436BCF7C8E198625AF378F2CCDAB8C1BA32BF9C4A861D16A3CEEE6AEE18DE630BE4551D60';
wwv_flow_api.g_varchar2_table(2499) := '24B60556B2492220119008BC8208F01BC1788CE104BFB6D9E1F3FBC26FAE98D552FCF28A41086B167ED7F8C9E32752D060FAF22BC9C2CF1F8BD0230A920067A32ACB120189C0CB8CC08B46805F56AC0525DB141D3F633067DE19DE549FBDF9D88ED902CF';
wwv_flow_api.g_varchar2_table(2500) := 'BBFCFC1C78AC6648298F4633CDD5F38E6B9BF513ECB727C07FD4E7958472F39F3F79E744B5AD7CFF1F15FE5E0412C9A486B77E9FC06FB9D3C1B0EC7B714C1A9508480424022F3802CF9B00CB59A05FF00340BA2711900848047E600864EEB366FB4D9E99';
wwv_flow_api.g_varchar2_table(2501) := 'F46C76CDA3E5C7767C54ECF9D53C3F071EAB991C2FCF543FBF705E6ECD76B5F2F6BBE72D390F9E1778018325F5B0855792FD6E018E6C920848042402CF1581ED26C0DE40A8BE7B703D1C79EC68E07984CAADE8CA02E7C95DD5DB66F1794421754A042402';
wwv_flow_api.g_varchar2_table(2502) := '2F08025C525E104F7E586EF024128B442F7BAF41817858EBE5C3647B22D232A3B2FDC17C69D9A8CAB2444022201190084804B64660BB09F0F0ECFCFFF1D98D6832B56DAFBCF02ACECEFCDCC33B2A0CBAED0E766BE865AB444022F0834380A716797DF107';
wwv_flow_api.g_varchar2_table(2503) := 'E7B6745822201190084804240212018980444020B0DD9C707ED537B2E8B15AACE263F1DBB01B924AAA6B6296693F2401DE06B4A50989C0CB8D00A92DE65EDA9E04D7CB8DA48C4E222011900848042402120189C0F782C0761360782F7371F1B76DD1AA98';
wwv_flow_api.g_varchar2_table(2504) := '7F22A1C86716B70D70694822F04A210019167C58AC1F1BBB68E22D0C3115E1636564A54440222011900848042402120189C03620B0FD04781B8292262402120189C07620C0E3D07CF046BCDA0ACBE50169D64F2A202CBE048B18CE2196E9F89DF82A0836';
wwv_flow_api.g_varchar2_table(2505) := '096AB4F101003679F2052B4F520E1B179E6C12C02BA144D4B38924358F15CEEE9BE988BC286777C125FCC9C8238087D9E97404681532C268B6FFD9F2D9E58C425990084804240212018980444022F034086C3545E1D3F497321201898044E0D54400FEC6';
wwv_flow_api.g_varchar2_table(2506) := '9772F9BEABF8FA1CB3196D2A884DD6A289EFB2667F6118BE373939097F46CFB70710AAC9479EDADBDBD106FF6C6969B974E992F8F4EB6395C33C474646F03FDB3A65587A67676786B8C29FBBBABA2E5EBCC8D76851FB5855A292AFE3F6F6F68A6F084F4C';
wwv_flow_api.g_varchar2_table(2507) := '4C7CF9E597E3E3E319E5D4E3126B218CFEB6B6B69B376FF2215CD422C6D7FC1A1B1B1B1A1A70891A7CB872E50AAD4203F2D4DCB871434444F9DAB56B40B7B54B5B782B9B2402120189804440222011786511D86A40B3CDA090A72057F1E474C513DD4977';
wwv_flow_api.g_varchar2_table(2508) := '7C62A36C900848042402CF0B0168243CD6ED769BCDE69C9C9CDCDC5CBEF463B3D9ECCC4E6BB3515F595959B1B1545757BB5C2E685E8613F2B9F6FBF7EF4F4D4DA18194260B5ED22ACA82DAB166735339C3FA32AAA8F1FBFD77EFDEFDF4D34FD1B6B4B404';
wwv_flow_api.g_varchar2_table(2509) := '6BE5BBBBCDCDCD4286754695D00FA5C419F8ADA817D671801A3EBE47811A3E250F1F8657CFCDCD757777A3848526E180D8146B702096EBD7AF4359F104AECB67606FDDBA852A04B00537FEA77FFA279AE8CB02F3C7C3F9F9F98E8E0EE1434F4FCFE8E828';
wwv_flow_api.g_varchar2_table(2510) := '9C9C35AD7D7D7D186D6A6AA23B9E80527F7F3F9FCCA5865E9067BCC262764A19C7E422119008480424021201898044E08F22F0A23C029D4829395AC5A037F0686020124F25D34FF13DCDC270CCA85527154D241E574922FC34904919898044E03B454090';
wwv_flow_api.g_varchar2_table(2511) := '4612BCD06058A5C861421D4D26134DD03FC1E2B21FE8C53E95D04592A2B044181D1D8F1D3B0693BC77EF1E1D61CB656565C3C3C38B8B8B7C2A96F2C0C0003CB0BCBC1C99DADA5AAC90022D292911A1C02A61DD505F0A1E8F071E0EF726212CE8E5F4F434';
wwv_flow_api.g_varchar2_table(2512) := 'B95354D5D4D49098A575DFBE7D30707CC3047969BC3D7EFC38357487BAD30B3720B1FBF7EF3F74E890C562A13BECB4B0B010563C3434049F275E111A51D38B4FDA8A60B182B68F3FFEF81FFEE11F20E1388FC3E824554EBDF0167EBB67CF1E8222B74CD4';
wwv_flow_api.g_varchar2_table(2513) := 'D81D1C1C3C71E20402105D4CE07C5555151ADE7CF34DEE2CDCB973A7AEAE2E2F2F8FB436E974DC387DFAF46F7FFB5BFA52891BDFE9FE94CA5E080446E6D79646FA75466D696E4E41F56E6EBC7C23B766BC91C99E0EBD519D8C26F7ED2CCAC92BE59CCB68';
wwv_flow_api.g_varchar2_table(2514) := '60C8918845F57C1B42F5CDD466343CA9C0AD19CECDE2E2E22709BC68F59C745C1FB84DC759BCB56F5C0438C7B9CDC719CD5D2A4E526E6C51E694E434E719102E625CB8B656F234AD60883318DA248C75EE8BF145712C6E6A929B1201898044E01B21F047';
wwv_flow_api.g_varchar2_table(2515) := 'AE77DF48D7330B27534AB139F5ABD3D56F1DDCF3DEE1DD2E7B7922A9F02E1D7FE8E49F288B4C6FA64C2FDE6F33C4E2BFDC5F76EEE8F1688CB1A61C063DF34E901D250212816744002A0B4524514986538C0245EE140249BA92111BF52257C9002EDB0683';
wwv_flow_api.g_varchar2_table(2516) := '3C1632A56221294A5693878D61B63CE20BAF8340DEBE7D9B442E23549EFB6560CD701331282B3528C7340A9184611E387000BB9471064998647E7E3EFAA9247F4BAE15CD3C578C571063C6B2F058CA57AF5EC51C8C1485648F19C2928C65005A5F5F0FC5';
wwv_flow_api.g_varchar2_table(2517) := 'E5F96D7C46ECE0C183E466C9C1B2C0998988C795711BF7E0DB9880273360C53A5D50827242460C58F001FA0A3FCF848F75F82D63656A70157996D2D25268033C995E784E2BD49756BC421BCC9F812FD49D2E74E75E004ED22B1B4F59FE8122C00E855071';
wwv_flow_api.g_varchar2_table(2518) := '04B25B395F388A08A47574B1F3FA159E546028F00C710D2C06EF5CFA3C11F6F54E7B6E5EB91AF3CD662B195F0ADDB97E4349AC65577E57E5CC71FE5D297CAE7AB88600B8B8926C6D88CB117B07197115A2170498357B8D2B1297112E0E5B6B78CA56AC70';
wwv_flow_api.g_varchar2_table(2519) := '717B541827B90DC735F6D12659231190084804BE11022F4406389A487DB0CBFAD1B9D7FEAF9BA32AEF2253A36854C93C8B29A16856C351BB26A5371A9981C51F89E994B85E6FD46934DE70CCA024A8B704A21FED2E19CC3D54DF369554C74291B8FAEB43';
wwv_flow_api.g_varchar2_table(2520) := 'CC6F048714960848042402DF1481CC0812CA271EFA153418FE46A682C122249031B118D6672B171D21B4F03D182CDD49F3FEF8C73F8643FEFDDFFF3D040FE6B96BD72E0A0CFB209934412649B142086186E481D12046DBAC05C7460022415696D428A482';
wwv_flow_api.g_varchar2_table(2521) := '24339AD103B724E3FAFBDFFFFE57BFFA154F4AC35A7195E40FEE917AC54F069D22BD0CFFC44972C582CAA216EECAF45D0C49710F3750454498462CE30062F8803624C926611A2A4B2A1B6D744152F80908784E2FB82B659A588B327DF107A3A8A22C6458';
wwv_flow_api.g_varchar2_table(2522) := '238F7BA4CA69420040400C40D049EA58A8A52C971F2E021C2ADC8811B73376EFDE5D5050402CBE50441F5EAFAE2EB7E5D857A3A9C1B62E953AE8D6EB4AF7ED6DE99A5147E64BDC8ED59835EA9B89AB38C2C229953D15F51DAEABD259D3D9D7F548221558';
wwv_flow_api.g_varchar2_table(2523) := '3AB26FA7BEC2FCBBFFF36FEB76B6079CFAC0F2B42A1EAEDE5973E3DECCC8B54BBBCA35AAFC63F39313D1706457A5DD51549B9D257E7A3C79F282E390B318064881A39A6398472D38743959B891244E1F2E081CB19C8C3CC2801827141DB9D1C3C2DD2584';
wwv_flow_api.g_varchar2_table(2524) := 'B985C46D20CE1DCE447A7119E198E774E61466E1D57ABA7362D20BB6490DC29C204FEF674692B3929B0E744715AE8AD310E7F10D67F08458B83EB0C945037F587361E1EC431825388F7BAC3979C9032386ABE2D4CE98A0C0393B363686877447806B0E6B';
wwv_flow_api.g_varchar2_table(2525) := '1E5AE1D20467C601600113F4A31967C4250B6D5C8B681218A2043410E3E2834502C750B61559960848042402CF80C00B4180F1DBA8D5E4182D0EBBBD616864D1EF3BBF23A7B8AAAE40A3FA64296E9A9FDC5D925FEEB65F9E0C9686070ED4BD36B8181C9A';
wwv_flow_api.g_varchar2_table(2526) := '9F3D599EBB9430AC8FAFA4E2BA2287E6E787CB12CECA7FACEF8F7B1778DFED19B0905D2402120189C0B321C0C80CCE09DF63ECC854D0F037BDDE60B1F062B0399148D339D4B2462C5B3F9B8C0EC96AC227798498A428833CF2AB8CF6A861BC486276EFDE';
wwv_flow_api.g_varchar2_table(2527) := 'BD8C14A1A08C8379529A6122D9D44F3EF984342F65BA333045A7D02C14427AE9C24093D12D291A86920C7059E321B658338CCE0C64198B631A6DB8477E18E52824102C92E3C504E36C86CBB4C2B7C94B333E7EFDF5D719B062540CBEC55AC48503784EAA';
wwv_flow_api.g_varchar2_table(2528) := '16E719FA23FCF9E79FFFE4273F4146F8C6F895C9AE60C864A13101D58106E0300512DDA8150F57437191C437324B8C958F1E3D4A061B274186A1395180064C18DFB2F194E51F28021C0978CE730A30C0B367CF8A238A5B2CCBC1786F4FDFFEDAB23B533A';
wwv_flow_api.g_varchar2_table(2529) := 'EFBD9B45270EB55C6AFB136BE2935B53A71D6325EEF72FB78C5684EFC54B0F4FDEBE71E4AD379A9B7BCB0C8B45477F8636946878835EA5DE55921B31167B966613B94AFFD8F46077D75FE6F8A3115B22CA319CE246CBE4DC727BF7A0321F39F9D36A45F5';
wwv_flow_api.g_varchar2_table(2530) := '2C8322CE7A981E8725E72F6B181AFC90538F631E6E8F27DCC1114F6470F621CC81CD0985004D9C23305BCE02D19D839CB39E93978E645C41069D870F1FE6B90CCE62164E96D6D65634B3D0FA6CA7001E0A7F78F540F07634734A72F2F29C084E7211C03A';
wwv_flow_api.g_varchar2_table(2531) := '671F2660F25050716889AB8DD841AC21B438064765BE034210F59983901DCA794AA560CB682346AE6F9CFEC0251E18213AA0E0290FF4ECDCB9931B5BF8C305074F20C65412265640097FB8B040CB850F192BB22011900848049E0181178228EA35CAE703';
wwv_flow_api.g_varchar2_table(2532) := 'DE0B37EE9E2BCEF9EF3F385B5C54F16FCFED3FB86FDF6B3BCADEAADBAD36D90F153B3FAAAB3D7BF4C8B19ADCF74E1E0C04951F15D9CE1C3B36B99658F37B55EAA43FA12A0A86FFCDEBFB0A1DB51B43CD67804276910848042402CF8800C40C1A69B5D99D';
wwv_flow_api.g_varchar2_table(2533) := '76B353B3E472185DC911C372436CA52F164FC03619E431E8CC1E2052C9800F5E7AF2E4494699B4320AA4CC6091A11E54104E08FB2505042925EDC3B8901121C36246CFF4859A3234647C49DE06A24B9941366FC6D2442FFCA1895764A914AC1213D05ADE';
wwv_flow_api.g_varchar2_table(2534) := 'BCC51392368C3EA19A8CB6198CE215E3573C4109834BD6C8B06097712723519168A53B6F0EE309BDA8A4895E2C0C9D410D25306486E374C4490418B523495CB4E2D5A953A71858B3C9C2ABC5C82326F836C23C414DE687BE283972E408350C97CF9C3923';
wwv_flow_api.g_varchar2_table(2535) := 'FA020BF2B07A74A20A0E80665E5AC634DE3EE33E93DD5E1804E0456FBFFD368725EC970C30FB1AD7D8AF397A8DC3E1520CE68EB68132D3DAF11327063CDAA5F17EDFBA7F77B9B56CC7BE157FB2D8AE2AACD9199C09EEA92B0E28D6B5B9E94C58692D3AED';
wwv_flow_api.g_varchar2_table(2536) := '6220A90B2FC7CD8E859171974D3B17B12456468BCB8A6C2663F18E9DC3131E93E253ECAEE9A14125F5F0335D19254F5310C40C6AC7E9C6A907C5E5AE0DE70B2717C73C3524783950799483DC26C1A293138D3388328C8E5395BB45BC65403DC736DD69E5';
wwv_flow_api.g_varchar2_table(2537) := 'B48558B2262F4A2BD70404000701CE14B0E2D47BE6835F505CD82FFA71038BD057CA38CC29CC15865860A15C91B8158521B147382B91C449D6E29AC01A793685C0266ACA832AF425FDCB792A48329726D4C2B1E94838B452E6324899AB01A08115170760';
wwv_flow_api.g_varchar2_table(2538) := 'E12AC126573F2E5374E72A876F34E1124D4FB353A48C4440222011D8028167B9D9B985BA676FD299FFAE7DEAE7F32B7FF5EB3FB9391CDF556A689E53B5B774BB4B72DF3FE08AEA9D6B9EF5027759CA6F5C4BA8DA87467E71303766B2350E2F14AF4CEBB5';
wwv_flow_api.g_varchar2_table(2539) := 'BBE67DC9B19EB9026DC261C81BCF9AE8E2D9FD913D2502120189C05320C0189425CDEA5852EA64785535F185E23AA21AFF3C69DB990A2C264CE5C98D077A6177629828B432DC64D8C79091E11DE496561834EC8E1C088496512304F8DCB973D450CFC01A';
wwv_flow_api.g_varchar2_table(2540) := '36C8D811E247A6941ADEF885109213C6BA783996C1E2FBEFBF8F3CC3E5F3E7CFF34029F5C228AE3178C53A94187972A76C4289194D3224A54CC6895686ECBC840C37C68A186B228306311EC56D72BFA8A2860134845604C2260B4A700985E861984E0D03';
wwv_flow_api.g_varchar2_table(2541) := '6B043EF8E0036A08F6BDF7DE230A6ADE79E71DD11D5785E7B844D36BAFBD26BC429E6031442B1D29101AE628A393356C19D0200658113EC8F50F1D01728C1CBD1CF61C4222163E0A916FD5D71DD81757F425E50B73037A7D5B479139EC28D8A955A64C39';
wwv_flow_api.g_varchar2_table(2542) := '56EEBA68D58A4E6F88AA357AB5466BD26BB57A1EBC15DDD52AC5175377F40F0CCC0E1FAA5099CA0FDCFE8FD78EEFD46A0CDA5434EA2EB644B4393393134DEDF1E240A7DEB4279E601ACD67BC99C2890397E32105683C6725C7332711949273909391639B';
wwv_flow_api.g_varchar2_table(2543) := '09D239D961BFD0579A84879C656438450DEF3520CCF10F9FE4EC2077CA3314826472B2538F30C9524E040A28843623095D7CB6FD8E42EE64F19E3F379B5082C3680379D472CAB31798030F5E8A69E65DC77361453CA28C6FDCA4838E72F6E12AF7B020C0';
wwv_flow_api.g_varchar2_table(2544) := 'F84647422622C4B89B46172E6B28C45B2E6514D0C669CB150F4992DEE8A19E6B0B65FCA11765482FA96952BE880114BC17E5686313F4800857B93E3C5BD4B2974440222011C820F04210E0782275A2DC11B4571A7DCBF7E756C7E6A6AF76A9F58EEA682C';
wwv_flow_api.g_varchar2_table(2545) := 'B5EEF59FA8B60E278C6B41CF5ACA9B0AC51757BD316DB27E6AE5F4DAFC8747CA43A3CA9C3FE153BC112539BDBA1E8DF1D58D4C74B22011900848049E2F02D033C664703985C9EB13F1542CA4F68E266C7B34A1E594CEA1A80DC97834994A5F9590649C97';
wwv_flow_api.g_varchar2_table(2546) := 'F1865E0C0DD9A420B822033B067C8831C6E5BD5C3619110A012A196B3282C410CF0693C865D8CA00B4AAAA0A019A10668C48016D088B4136E54D16194067EC0AA68100350C4CD14099440DCF1B33F266408F665421C6820C9B88097F58434459672F8423';
wwv_flow_api.g_varchar2_table(2547) := 'C420AED45366112E5110E36CAC5040AD088D02B684B0E8450DC28C86A9A42C2C5260D02C6A708671B328B396CBCB81000706F75C5867C2D95FE63224CEB2C930E5AD537BFB52FEA0DFFFFEE9DD453B0EBE79D26249332CE54C5D79915517B55B12EFBF61';
wwv_flow_api.g_varchar2_table(2548) := 'D6E59E39BED7999F4E51B2EC7099E267DEF407924E2552F7E19BE6C2EA13A7D772B5EB6F9B538E0A93ADD4BE74F65C2CA23E7DA02CBE7AC4A5B11657BFA3A89F7D44042114494E42E0A01569558E6441E468E51E13473EC95BCE41E121E73262D473B493';
wwv_flow_api.g_varchar2_table(2549) := '8CE5F616CC93F382FB535C0720D564621186F571CC7353495C1C500577C5164A502E543DC31A56C9D5037E8E72EE3EF0440939582E29F88CFF98E32CE382C3A586CB91D0CF198A3C7E72A1C049AC33F9334D50651E69C6734E52B871469E3B6264921100';
wwv_flow_api.g_varchar2_table(2550) := '13CC11111D8991058A8B24D7100C4180A1C7048506F0A11EE6CCF587EB09EC5774276A418C4908A347F823D71201898044E09911783081CAA6FE5C01450D05461E62E1CAC8F59A85CB315725AEBFB472D1DCD4576C22CC254F0C59B2053EBFDBFEBFFEA7';
wwv_flow_api.g_varchar2_table(2551) := '3F582DDCBB7D78AB15027CA4CC96EB2AD2C7138B294DEBE0548D5DA92D2F8D45932BC1A8391130395C7A557232A25605671D8E92A6C1095B347C6477694C635AF1841D9AB84767F68FCEEC3958DC3412F27867D4DCFBFD6AC18C2111FDF27FFFF716D383';
wwv_flow_api.g_varchar2_table(2552) := '5F9DAF5AE4FF120189C0AB85008F200ABAF5A4B019D23192E3E1DB4D234BAE751039C6793431921357482E71647B48DDF06070341A4BC6FCAAE9AB4963917AE8B7D11DBFD24C5D4CF112A26FD47FF07F4BE81C6A958AC720B1CE43BC8F5247E10F0AB9AE';
wwv_flow_api.g_varchar2_table(2553) := '32166498C8C5930BEF63FD6480C8B098612BF24822833F62E4FA58F9A7AC441B8E619DF12BE18B189FB2AF1493086C4280A1C2A69AEC4D71A43D69FC20246389A42A11D3EA1F7CF026148E2562E11C935EAD35842331031F30D2E822B184569550D4BA44';
wwv_flow_api.g_varchar2_table(2554) := '34AA33E8A2B1844E9D52A7F3C04A22C904E3512656D3AB55861C3335288847C35A8D5ACF3FAD3E1489695231B5DE180985D5AA948E33EA2B5BD9AE3E65599C83E8E0B4A5CC89C9B90C08B038F824F1B216432964844E21002BE674634C858C28D31D7E88';
wwv_flow_api.g_varchar2_table(2555) := '86CCBD21719A73E2739222835AE4E9F52DA9A0F00A675088576C32BA136AA9A180392E2C198785246E532368BCE848BD60E978458C449AB9CC723DA1864D11023A33B61016E008192EB0420F6E087984B185034221E58C2A1C43582E120189C04B8C0057';
wwv_flow_api.g_varchar2_table(2556) := '06C663BCFD21AE1E9948B94272FDE1E135BE8FC895874B229B5C0C59B370F51017162E537464E14AC2C2452373DD108567BFDF9971E5DB17B41A55FBB42F35E54D3FBC9C52346AD5C8B232BC34C0E646854A195F86C7A66F753293CA782FD1AC2AAA4BDD';
wwv_flow_api.g_varchar2_table(2557) := '935C03F983ADA7AF856AD5E8FD218DFA5BDD13FDF6B1480D120189C02B850063328674713E5D9E4869560715F570DC5A9354E9551A93A2D1277436DEFC4DBFFF4B82F80984360397B8AC731DA7B085B048B020B3B55846ED5316D0C640936543F1C31B94';
wwv_flow_api.g_varchar2_table(2558) := '4FD95D8A4904BE5B0474FC9C6B1EB05F349B8C3A85BF8DC568785030E8B80194BE07A431A6250DFA871951061239262A1F6AE003128A2ECDB2C4624A2B49EBD19A9FF141E2AF34A5FF6744258822232D51CF502C23C06945796318F6D0C36C01466C2C42';
wwv_flow_api.g_varchar2_table(2559) := '1E55820D66BA8B42A61243C2D626816FBA29BCA297D0963EF937FCCCD464178472243309DEEC56C1781F25E48FD63C6A2B5B063D429530970D517659B4CAB544402220117866045E08028CF71B39DB87B7F43632B80F37F971C98A30FD6BC736F7701F54';
wwv_flow_api.g_varchar2_table(2560) := '7ED5A8D67C55CA9296458980444022F0FC10802E92A388F1855EA6B82A3CAFF826E3D61D09AD536DD9AB24C24AC5A9983A27198F31A8456C0B371010CC93B510A38602BD20C3DCC5149BD46404B6D096DD84BCD0905DF9D8F21FD58C9ECCF83EA34170F5';
wwv_flow_api.g_varchar2_table(2561) := 'A7AFCF747C52412864A0CC8D05A266C131F242D464ACD0245243991A7A89DC11F242330219195AB955CCF83E238F18AD69ED2A55FA0EC6C6C3DEA25520463D7AA8077C6A321D9FE436F52844520CF11F2B86360450F8D8D62D2A854B8F767CD422928443';
wwv_flow_api.g_varchar2_table(2562) := 'A4D8A280DB62D9A41C31169A36D5CB4D898044402220119008BCF408C81FBF977E17CB0025021281E785001C091601B3E2E1EAF9B9B93555E99CE1E86CC0B4E409CE2AB50B86C311F38E0DA29126C9109247FD48D3AF0D26C6438FA2954D51E0F91F34C3';
wwv_flow_api.g_varchar2_table(2563) := '619828152554669A32929B6A1E2BC33B7B4C339BE9220A99754643A69069A290A9A4C013984C438D27994A04A0644C4E9379683CBB895716310DC5CAAE7C52396314853CF2C4EB88BCEACC34394C11440D53E3F0922493CA82061A0093A9C2D8C49F8C42';
wwv_flow_api.g_varchar2_table(2564) := 'CA7C5786E7CC450D92BC7F88069E51C767EA99A7870FBA88566A98B087598B50C58224AD421B0258A71561760AE0B3A6FBA3E4331B1FCA448A24CE8B58328E650A08A096B8A8C9546602DFD42BBB1E6110E618CBA6D654A210840930BB2F7701F099830D';
wwv_flow_api.g_varchar2_table(2565) := 'FC898BBDC38194B6F7D571853065F001C36C2BB22C11900848042402128157040149805F911D2DC3940848049E0B02502916DE6783AA2D2F2DAC2E2FACADAE30C3CBCAF282D7B3BC303FCB94CE5047F8C6A304988E5026C19F217882EE228C36280AA40B';
wwv_flow_api.g_varchar2_table(2566) := 'E2870CD48B4D781A4DD01B1186E82BB88DC8F5D18BD66C19DE9A631104180DA235E3063574411E555466EC0A6D74A4807EEC6211AE05D1628A1A41F368A5922604040116BD08076D68265EE6B64118015199111021B0493D0E50A046B8475F6A04CD064F';
wwv_flow_api.g_varchar2_table(2567) := 'F81B6B2A0187E73F61A4BC748D2476A1823C390907A62FF830652E58F12E104671921A413579AC1425B04738211A809456A101228A5AE10C7E220921242ECA3840017344412A95FDC29B484852107DC59E620D68C800056B8118A6D14039030508B00890';
wwv_flow_api.g_varchar2_table(2568) := 'D18CF3027602A7924D84A911BB154936A9178ED1CA421371B1C62292D86211FAB10514420FCE208C87F8801EA26313FFD9C416AD42277A30010E04451979D672910848042402120189C0AB83C0763F02CD4F6D7A1C907A4C26E439812E5F657B4EC04AB5';
wwv_flow_api.g_varchar2_table(2569) := '1201890008704163CD74A95011F88978918F35B4841AE80A6BE887A031D9648332AC8C8421F39D4292E1694CB20A85A3127A535959093F41099F27A12F1A1080D5303F2A13B1D217BE0785A31E49E449F721C96B722219CB1CADA431A1A6F01FF1EA2032';
wwv_flow_api.g_varchar2_table(2570) := '2884F9F00A1F33A9A20101381EEE5555556114E568E333BC904C928D044514F8CF2B7968833B412929A0139F31442F141232C2842F98275698BE8BD9C2F00719C28186A18459A999E29510D0860C53CBE23C1D418F5970A1D6CC430B3964AE57BCA21279';
wwv_flow_api.g_varchar2_table(2571) := '24F11C97F0100A07DD652D0E390A4C3F8BC35056848905DF30C7F75A40126A870F44C424BA78F2D9679F09709833834C38F8E0096A69655E590A68236A6E13089249777CA006B68C397826C05289F3A0473D4A2093B88D03E25B3538D3D7D78703E2F548';
wwv_flow_api.g_varchar2_table(2572) := '84455F76162180006B012C0A99F2177F30815A763DBB00FF810857D9D1E29607CA01070F815A4CBA8669844959030BFB02C031CD2E207C1682020194D32AA608463F7D4115CDC88336322252CA34618B45E029D712018980444022201178A510D86E029C';
wwv_flow_api.g_varchar2_table(2573) := 'EF7054B9721F7C15645B90E65B82B5F96E667DDC166BD288444022F06A2100C180AB40EA085BE4E2E054540AB606FF849FC0942030704536B3D1814CC236E139B03BB1D0117202B7813251232828A408CD5881FAC2B2D00C2B83FBF13511ECC2AFE07BF0';
wwv_flow_api.g_varchar2_table(2574) := '1FF121134165F9BC0ACC0A1A0953121C125BF03D41B0E145788206D6B041B2ACF4824D418DA079C8E3156C1C0DD036B2AC706C281F9EE355575717F48C024E8AEF15A3190A072DC4312CC28A514514F8832A7442C6605FE23B2E7CC21701182014110206';
wwv_flow_api.g_varchar2_table(2575) := '268212B7B4B4400809133DC425983F4D6886BF11357AC4263514F0501066510920C00555662DE20570711B0255E00FED6447508345C45840862682A22CB41126F8F0215362C7224D980625E2C55542460CA0D81D9411207C026117204F50CCEF8D1BC810';
wwv_flow_api.g_varchar2_table(2576) := '3B6260CB261C187C8011B7A9645FE303D0B1BFA8C75B58379FFF015E34E02761620B61C4A0BBACB92940137AF093BD8315BA0011E1601D0D448A2D8C427D79901B6FC1960F3E830C4E8212807090D01D7F0019FF4103B7A9CF3E1A655922201190084804';
wwv_flow_api.g_varchar2_table(2577) := '2402AF0802DB4D80779616FC2F1FBFE90F87F981DF1E881925541638191F6C8F3969452220117875108063403F5A5B5BB9CE1035EBC716443DE40A7E989D7623B9C7A509CA040B6581B5A20A6E0351817AC152A037702D34C351616B301C780BBC0BEA02';
wwv_flow_api.g_varchar2_table(2578) := '658267621DC608ABA13B1C09E6035F221B09958276C2AC50020542039B105472BF3040F4A3071A860034955E7888369C81EEC20C5105D9C631D292E231635893205DA437318157702AE4A176F031FC4103EC8E88A0CD70751C63935EC8F04151B81F0284';
wwv_flow_api.g_varchar2_table(2579) := '8303E47B49B71211CA090A4C106E6F6F7FE38D3700875B00741428A1965F0A2C122CF95BD6D03CA260C16768BFA0A6B06B52AFAC891A55740122A82356E88B30ADC442E028672F403E811A7F847ED4C2720110288005E7F9AE958828B34F8982A851887E';
wwv_flow_api.g_varchar2_table(2580) := '3A4295D14F08E47EB923805A42E3B6028C54DC17202830243A760D216302FCF101B828B073B1059B254CDC431B76818526B0C25B16FA767676B2C7318D4B24B7B18B516A00136F39F6008135F5F8494434718F0367701E01F011BB801A5CE5A3ACD4638E';
wwv_flow_api.g_varchar2_table(2581) := '32F41867D85374948B4440222011900848045E3504B69B00DB724C1F9D3CF0AAA12CE3950848045E3E0404218183915BFBA3D1210C27117948210C1BA1239C0AC206ED819E4165D984F090B883D8C0A9E0AE7021CAB02958105C0B25F01FC8188407A20B';
wwv_flow_api.g_varchar2_table(2582) := '83824AC16AE07590281814D494327DD109AF8356096D420356A064D04258109E435029A013BA45E613EB68A615A28557A8C26DB4510367460386781017BB28A11566C52C53ACF1102BF42228E4514B52944D41B66162F883427820F354A10A368B2D9CA7';
wwv_flow_api.g_varchar2_table(2583) := '17F1220F3D2340D823FAA9410F28A1018B620D6BC5108C8EA044C69BBE706FE4A9E1996A22C5198459A076223A28310240049924C00D6A6981D2831EFEE015BB40E463711B6DE04001FD048E7E5AC59A4DB8251E42DAA18E7888F3A00D74E814F8E3303A';
wwv_flow_api.g_varchar2_table(2584) := '81020CD149176E25A081FD02214706619403383850A023F29061D2B6084083D18CC374A48910C89923C98D06FC441516C11C856CE200E6B0250AB84D2502A845273E8B565421833610605F20C37E213A10004CC41046F287BEACAC87CCAAA8D162630FFC';
wwv_flow_api.g_varchar2_table(2585) := 'D06391FE4B045E7C04B8E5B6E60B3872342AEDC36F7D7D5F6EC7924A68CD637558546A99E8FABE76C20FD2AEE637BFF9CDD68EF30B9A591894B0F02BCBC28F3A1D19063DB63B5D323FC38F1590951201898044609B11805DC043B630CA550B1202437B94';
wwv_flow_api.g_varchar2_table(2586) := '184024200F344145321A10834EC0B5FEE802038189619D6B23DD857E8825D485CC2A09432A616EC8C088A0672C5C5DB9D2C29A30C1A6A0527018162AE94238826ED11192C3C2267A10460F02901C7A518038E13C46B9804399D8A40B0C195BC8230C7182';
wwv_flow_api.g_varchar2_table(2587) := '20A10167102046AC4090A84792AB3D05418091412D6E63857050886634A4CD5B2C08D31DC7C82723C326FA514566985878BE1749E4D944216A710F2BB84D9A1467E8087B14BDE8483D9EA09602AD04028C58A4865E58A73B0214F00D1914B223A80164A8';
wwv_flow_api.g_varchar2_table(2588) := '321A10202200C4195A49D2123BADD4D08A219064139F853640202E5AA9A4955D809F6C22802A36498C53A6201C00520C09848527C80B6069A2CC1ACF91217CA2060A3C41154AD8A40CF5E5B60826F0130D604B174174C593EA1C90444D1381E31205FA0A';
wwv_flow_api.g_varchar2_table(2589) := 'A8D1CF266BE459A31C105025EA29E327C2B847259A89115B08132632F88900E680E23B5FF0760B9DB4B23BB0BE85CC5336713AFDD7DB03765F775E49ED3313605F3475AFA52D4FB5A4B6150C8F8CFBFD5EFFCC82CDEDE0087AAC1BCB81F89D5BCDC6C8B4';
wwv_flow_api.g_varchar2_table(2590) := 'CD5D82D1FEC59043F1A8F5E98735BAA71663DEE99589F9DC028EB1873986D5506A6EBC67792D668CADA92CF6A6BBC343FD2D768DD7642F9CF7C7EFDD6F2DCD896872D2D781B9F5F858CB5D77A12DA132B40ECD87A7EFE516940793EADB2D7D53FDAD767D';
wwv_flow_api.g_varchar2_table(2591) := 'D468732D0494BB8D0D29EF485E61E9D872ACA5A97E7D7ABCA0D8BE12D137DC6C9B18E976E8221ABBFB6E6B775F577BCA37935758A4A834234BFEC5AE7657A97B2D8CB68EB99E0EB74D1B32381AEFB54EF575B96C44903B38EB6B6BBAE9D0FAB48EA23BAD';
wwv_flow_api.g_varchar2_table(2592) := 'C3C3BDAD232363B98688D1E6EE9B5EEDB857EF32C60C56D7522879FBEEFDD0E2487E71E1F05CA8B5BED1105BB6BA0B3D91445B7DBB5D1730D8F288C51F57EEDFBF5F688AA68C8ED6FEC9E18E867CBB2E95E3B8D7D6D3DBD966D746CC0EF7723081CF81F9';
wwv_flow_api.g_varchar2_table(2593) := 'A1FC625754A5BFDBD63B3FD452E4B68734E6BB2DEDFD3D9D4E63DC687336764FF577DCF32ECF1616BB265712F7EA9B7D8B7D8585CED185F8FDC6A6F1F1A1F0C2ACBBD49552E95A3BA734DE518BB3686235D4D87037E99B7515162C0454779B1A427343EE';
wwv_flow_api.g_varchar2_table(2594) := 'C2025F42D758DF3D35D6EECA89E92D2EF660DBC8527CA9CFEE2A6AEF5DE868BDA78B4C39DCA52BE154E3EDCEF9C98E825C7D54676B6AEB19EB6ACB35C60D3657FBA4A7F35E83CB14335A5D6BE12460E6AB560D3677DBC87C6F6BE3C8D804C786C9557EB7';
wwv_flow_api.g_varchar2_table(2595) := '6574A2F77E81D3A031DA8627E682FE65CFE492239FE3E4E181B1164DCDF60DCF0682C6E8AAC1923E00BED1E28DA66E37778EF476C63D53AEA2224F44159D9F36DAD2D7B7A75C26E67CFEA5E9C9A5D57CB35AF93AA10DC45377EF77DAE3337A47F1D0D854';
wwv_flow_api.g_varchar2_table(2596) := 'C0EFF14E2FD8F3ED4945F3CFD73BF638021AB39BF3BC7F66D9CDAFA2EAA9F8273F3977EF8DF4735CF1004B6CC5EEE242FDE02CE3B77160D6DB76B73EBA3CEB2E76652B9C9FF66AA27E5DCE633ED9BD9A505AFEEBA7D57B5C2AAD3594527837C6EC4887BF';
wwv_flow_api.g_varchar2_table(2597) := '124A2C0C0CCFF80396C49A2E8773F9E132B516BBDB70C7185DB4B98AF07B7225D8D1D652E1367853E689B16E9F27A40E2E71C83DECA02823B39EC0CAD8D29437CFA557D4E9DF59B164CE6B537C2D64B2DF6DE81A1AE8547B97ED854573EBC9E6FB2D25E6';
wwv_flow_api.g_varchar2_table(2598) := 'A8C6941B48288D4D3DFEE94E77A14B95F579F3E18540EBDDFA91B191D5B1315791A37378B5ABAD797A72B428DFD43DE8CB53AFCEC5AD7383BD1AB3F9CEADF6E1915E93E2B7E416748EAF74B43469FCD38ABDA8A9B96D64A0676A7824D79032DAF27AA6D7';
wwv_flow_api.g_varchar2_table(2599) := '8363BD8EC2C2E1597F6C6E58939BDFDD319063D5DC6B191DEAEFC03147D143C009219C48DE6B1C34C6E6CC79EE784AD53D3A1E097803D393D67C37C87C15A5D2BFE00FAC0C2F4D30838646AD3565EA83096562B8CFBB1E4A7896727201F96197594F7865';
wwv_flow_api.g_varchar2_table(2600) := '6C64DABBEE36C45793E6E9F16ECF4A883D9EB2E4B5DC1BD0AC4D59F3F1E4A17C4667A6C06F043F7FDC05E6173353290AFC743296E0D6393FACFCC6B129D614F899136B7A8985DFB8CC22BAB349E1E149B849BBDC94084804240212813F8A0057D83F2A93';
wwv_flow_api.g_varchar2_table(2601) := '11805689B228C0A6324D3CBF2A2AA1255C9D45994CA928B08620658429C076206FA2063246212393E9CE03B74240308DAA8D3993448D5863541420632CA20C031405D4A2937A683F615266C168C6AE5028CC65C80C1414BA05CB82E4B066DE2C7AD19D94';
wwv_flow_api.g_varchar2_table(2602) := '263495AC26BF6A34612563084A8CC5CACA4A6AE8827CC62B0A08A3938230042DA40C4A19314C23930DA6C00A8548B26434884D38B67089024D840345A406FD22FB2DCA4221A6D914512090314425CF3F0B49D63052B1A68015212FCC111DBDF8151778C2';
wwv_flow_api.g_varchar2_table(2603) := '4BC5BEE6779AD780314D5659C04BECA4B2D143470132D497E820ABFCCC639D4D5A815168A65E14C49AA66C9F85E700452B478B0019990DE0D3BB588423CC65EB7931CB8CB33D6BEBB148201E49E4DA0D663BC74C7A10C3BF5038AA98E3E17872697ED9A0';
wwv_flow_api.g_varchar2_table(2604) := '89E4E717322AF5AF2ED84C1A87BBD8174A847C9E683C6631A872F3DC8BBE88551D32D91E1CE422D8F189B5898EEE3A772DE3B9DBCD4D05D61CF5C062E9DECAA5F5D4CAFC94DB9C741657CF7963BEC529A75EE3AAA8882753830BEB9A89B6923DC717D622';
wwv_flow_api.g_varchar2_table(2605) := 'FF78BDE5E3FCD9A28AE38555659FB68E9D320D2DB72E541D28492986A565BFC308CBCA9DF02A63CD9F0512C7DFA80814179407FCE1E5F5C08DEBA31FFDB2AC6B2870B1A9E3A0D1E172564753CAC5F681D8A54FF7EDCB1F086BDAFB069DB39F54EF3B9E52';
wwv_flow_api.g_varchar2_table(2606) := '6CFE60786DC9B7BCDAFCF14F2BDA1AC6839ED14BE3D19F19B561FBB1A07FBD79C957645B99CDFDB0FBF2FDDAD79CF168C41355BA9A2F15E41544E0782AC51B4A7ED9D06CA9BFB3FBD49E96C1E589AE7AB5DE65ED6AAA78BD2410082E2D042CF72E94BEF9';
wwv_flow_api.g_varchar2_table(2607) := '6FBB6F37A7F4CB17EA27FE1BABDD1B0845BD6B03E34BD59695755DE578CFDD68389A8C47E1458D38B93A1BC933AE04A3776E779A634BBDEB0B39F925C3CB6B8D77DA5D21ABADA4865DD6D2377FEDF32B75BFD83319718D343528D6E450775BED29673014';
wwv_flow_api.g_varchar2_table(2608) := '9A5D0F24AEDCFAD17F573CBAAC599B1F1B5BF716176AA7D47BE67ADAD7F54955D3B5DD6FFC842BCF9437A0FBF2C6D95F97DC691CA8C99D36E94A62A9E4C5BB7D8EA5FE999852EAB4440CFBD7BCBE95446475B86DEFA97D23CBA94FAFDDFCC8BD6AD971E8';
wwv_flow_api.g_varchar2_table(2609) := '664B8FD637DD39AB2E28764DAFBA980CBE7761B52CDF702BBA6FB5FD46AAA0D0B07AEFE4CF77CCFAD59F7FDA70B06CA46C671D6F9FAC07FC976F4DFE6571D1B5B19C484F7D2CD799AF6DF7151B061B1AB56E9BB17DA8CC58D2DB719BAFBBDFFC6CE647FF';
wwv_flow_api.g_varchar2_table(2610) := '3AA76B5AF345734F7928B2AB64AF3F1CE35587F1A584656D66C9B067B4A7D3909318BCDFBEEFAD825BADDD65168FF7BEBF72FF4F15E561E2742AA80C7D563FB2ABF4E7EE1583BBD2EF650E425FA9DD607217CE2EADF957E68B0BECD6DC2218D4ECF89826';
wwv_flow_api.g_varchar2_table(2611) := '19CFB3E6380A8B87E7D6F4A1A5F28AB244D234EE098CFFCB8D5FFCD95E5F2476AB7DCCD07363D7F9B72B4BF2E306FBD8F88C451B292E2B5F0924C29E15BD51A5841577A97B7A39125C9D29711ACDCEF2FB9DF3764F5B7330B9FFA70714A363C11BB4AB82';
wwv_flow_api.g_varchar2_table(2612) := 'DC64E1D4989A5D1FBDDFBDE7EDB24852B9D5DC52624BC5BA3C65FB4AA71703AB73134A6A1779B0D1A9F9DF5DB9FDAB130505AE1DB6C292D9558EECE9F2F2E298C6BCB2BC6A48C5C3AA54699ED5AFB6CC4F8C9A358AABBC78DD1FF9BC7160AF756587F32C';
wwv_flow_api.g_varchar2_table(2613) := '13F14DCD2E283E4F7955E962D2D2D17049AF55C21A1BD3F7ACAC075D666D20A4D2A96283DD0B76DD9CBDBCA8ACB238ECD7AE04BD397A753C1676E5178C4EFBD657988722154928ADE3F373973E3BF8EE9B1585AEF1A07DFAC2EDFE1DA5FF6D853FC75511';
wwv_flow_api.g_varchar2_table(2614) := '8CA5222B8BB985DC97D1B54D8766BB6FD7E49DE66733AA281D4383A9997EE550F94C28D970F7B64D5376C8BE925358B31608AD2DCE96B82D20DED03B5112BA3ED55950B3F3F594C6B2B8ECE75688DEE218F328932D9FADC78EBF5B1B5AB79577D4DF29AA';
wwv_flow_api.g_varchar2_table(2615) := '767E3930F0B3C29CAE05DBA5A6F643394E7B5E5567CFC4D248CF9012D7272FEE3CF3A719CE1F8A2707E7BDABDD5F9E3E7E26994AAC07239CA4274A9291A3B5376E74380FC5DBCCB6F5F69B07B5FAE1C6CEC23A6722661BF5C49BEF373AD4B188D9904829';
wwv_flow_api.g_varchar2_table(2616) := '8B3E7F6743FD91527BA2A6289C523A3B06B58BF7CBF794748CF9F37ABFAC74555DA9BFFBB1FD40C79DD6A24AEBE5FEC15F97F078D883E770017F6C74E97E739FCAB5E4DEB12B9AD27F72B7E38853A71FE82EDEB72FFB87E0CAC06AF57AD35247B0ACFCBC';
wwv_flow_api.g_varchar2_table(2617) := 'CFA773E4E9921A233F6AFE94FE6ED325A375677964D55555853F4BAB6B6E1E8A32587B277CE1EBB73B0B5CFBCE178F68DD3DCDB70CB1923315A182C21D332BA1B1AEFB7F5653A118D2B7C9BEAFE51B0CDDBEA98BFCACCA452220119008BC20084042BEE9';
wwv_flow_api.g_varchar2_table(2618) := '45EC69E4BF51749B1466F7C5BDCC66A69C29D031D3FAA4424626D36B93E493EA3789656FA2935ED027728FD4674C0819A170935A64E06C19E18C0C4C0FC229D8EF263D429BE8082BA320964C7DB6B9C7969117F58F5D3FDA2AF4E39B68CA3829F2AB28C9';
wwv_flow_api.g_varchar2_table(2619) := 'EE42392390A9CFAE1446334D6C0A79512FACA099DBD2991A0A705A2A497D67546DEA28360113AA8C0C0B35624DE1D125BBE949C2D932C2316A7E104B5851BEB8DE7EFFEA8596FEE1DB9F5F88079785DB20928A27E21AD5B5A6C1965BD796A64766BDC19B';
wwv_flow_api.g_varchar2_table(2620) := '376E0FF4F75CAB6FF48CDDBF37B17EF1F34F7B46FABEF8FDE5F5A5F18B2D43539DD7B2438EC49373D35307CBDCD6D203AA94E2CCB3E7E7C1948B42494D7DF3BDF67B0D9EF9210E8189B5C8BDE6D63B37EB0373AD8CCBEB5E3F190AB05F52739E60574767';
wwv_flow_api.g_varchar2_table(2621) := '4777D7EC403FF3A6E5DBAD79AE427739B7ABD209B14FAFF6ADF43551306855CE7C57A1338FFC219987B25DA59184C1BB105452B1429B369E5B110E7A88A57FD4939CEF355A6D89489C4705CACA8A03D1A8928898B44A4569A93FAA5DF32D2F06638BB35D';
wwv_flow_api.g_varchar2_table(2622) := 'DC641959B58E35DFAE7019D5AE2AAFC71F0D2D87A309FFA257AF4F986D661EA6F7791712B1A82DFD4483B6B167C2119D53C2DC354B25A27143903C9629A2D65AB5295BC90E7F2415253DBC10B22427728B0FB60DAC0626FBCE1DA93D79EE9D02A7CB5E54';
wwv_flow_api.g_varchar2_table(2623) := 'DAD535B5303948EAC798631CF326865B2EABE309BB56B71848053AFBCFBE7974D49FB336D5C50D026B517970353D67DEC47264AEBFD15258A9C483FDD36B05D1FEDA536FDEEB18D186960A2B76A6147D606541958C394DDA77DE3E1675EFF0CE8E370DCE';
wwv_flow_api.g_varchar2_table(2624) := '1CA8B6F975BBDA1B9ACDC94041C52E1E1309AE2EA694F8EA8A4F4984DD56ADA2E269FFB04E1F34A80CF188525D647EF7DD375CB9BB4B2B0B7CA99CEE86EE8212553CAC598BA7C6FB07DE7C6DCF940FCF52870000400049444154523A37D05E6056BDFDFA';
wwv_flow_api.g_varchar2_table(2625) := '9925EBBEF58511B0551BC23CC0CB5B05DCF2B8DFDD97670AADA948CC46CB6B0B15BDC3B3105162E15834A63104997D3E113746E27C994C9532181346C3E8D07241D45B5E5ED3D83B1999EF7418D55A77B5D7EF27E4233B0ACFBDFBAE3BBF2ABFAC66A07B';
wwv_flow_api.g_varchar2_table(2626) := '618735507BE24C73F3A012F7381D16B733D7E9E6A6E7D732A5464DCAE5CECD77BB4DB9EE316FECD2E75F7675F5B436DE4C855646E6561B9AEEB55EB91D0E7BEEB7CC0C7634FDE72FEF4EB75FED9FF73536D55F6FB837D4DD6CD7478E1D3BE0483877F262';
wwv_flow_api.g_varchar2_table(2627) := '7F48DBD1D3DFD9D9353CD09B0C7B6E0F2DDE6D6EBC71BD617EA0F77AF3C095CB17BFF8E2F3C6CBB796D7176FD5DFE8E96C0F78A6F039D7ACCB75BAC8E42BBAF40DB5CFEE8F4EB55FA6108D2779DDE640A12DB7FC08176567AED59D979B9B5F985274530B';
wwv_flow_api.g_varchar2_table(2628) := 'AB9AD8AA5A4992CEED1F9BEDEAEAECEB68F7CE4ECC79434DF577EFDC6BECBB7FA97568FCF2A5CB172F5CB878EB5A60AEB3A97BE97ED3B5F9D1215D2A72FA44B592BFE7E8AEFCB23D278626BC6D8D8DAD9DDDA36DB7C2A9C8D8F050BE5D5373E0405C65BA';
wwv_flow_api.g_varchar2_table(2629) := 'D83EA2C41787FA57964746E603E1AEEE9E968EDE91AE5B376FF65FB878F9C2C52FEED45F08AF0CCD4C2F28C1FF9FBDF76C6E2C3BD304AFC785F720000224416F93DEA5ADCAAAAC2CAF6AA935ABD9EE89DE9D9998DED88FFB0BFA17ECA7DE99883533BB33';
wwv_flow_api.g_varchar2_table(2630) := '11B3D32B75AB4A25A95C563A66924CFAA4F7A02740C27B732FEE3E976092CC2C554A6A554A2D354E30C06B8E7D8FB9E739AFA32592CE88C4DCCAFEFCDCECE2E26C36EA5332B4C56AB2DAAC987168CE56447CFCF1A78414C3752895EFF5A85D0D3857A263';
wwv_flow_api.g_varchar2_table(2631) := 'E97C2CB077ADAB8E50DA1414E4A79C650E93DAECD88A0A5FDCBB3B353F35FDD53D49881BB50A8BC566C37922A3C43CFDF9578BA155795EF3AC64B65A1C6613ABB5E060C84AA5FBAF5EDE22344270CBA965F2FACA5C2A922810EBABF34DF5E643D636FBF9';
wwv_flow_api.g_varchar2_table(2632) := '24D8AE48580C753675EBE59B4EB5D077F31ACF1BDB9B5D5AA7F34A9B3DAB71A884A3B9A024EECF891A3E1604FF395A74A013CF4B87DECD4A1D5BD9D265E0D981CB3D3AB379B0BF5EEFAA3B8E0946E258D25A03DB5E5288ECA5D9A395495AC545A2211B93';
wwv_flow_api.g_varchar2_table(2633) := '1BB87A799B52E7025BCF0A97FF2B19CA51EB8E1FC30F9F48494499D164B19A0DE515C5E3C5B39846156BB638EC95E512A71B9B3DC8F8E64319696A6A969192568BC96E32694C323B372B113FB93B9AF62D22A156415B6C16F90456A151E2E0C35C8E7328';
wwv_flow_api.g_varchar2_table(2634) := '85DE0EA9B08EBE8600C7678238430106FF838557C501C626065F771C0FE023FD076B5CA9E012054A142851A04481DF9902BFED32FE4D64851C00F68AACDA9754E79B095F12F955BC7A7515F866CEA0094E16C0C5FDE6AB8B4D7BF9DB8B31FFB4AFB1D59E';
wwv_flow_api.g_varchar2_table(2635) := '9EDF78DBB2A1EEBAF1C54FEF0C5EAED65741484F0EB31B47AD858DA74965666EB4DA3E30B216F24EDCF9F0477FF1C9F096EBD197EB957FE15B9C6DBFD6F1C97F191F6C9BB6EA3B94DC736C87C5C3783AB45CDED64CC3F19644DCE81B50B24CA18E100966';
wwv_flow_api.g_varchar2_table(2636) := 'C7BB6BC9FB04C1214885BDDDD0FEEEC64234D15DE573397A74066D5A160594CA0C4A4B656DA39BB5D7D44268F3FD4E8F8E2D2FC8C71A005484CDA465B5A83BE13110EEDE0F4842A7E024C0091E674A0C9BD670742676A9B6919B095234D872C43FFCECC1';
wwv_flow_api.g_varchar2_table(2637) := '60657C95501E78771A063C19BA2E380A6E210966057412941CCB884230143D269261EF71438531EB977806509657737CC8273AEB999A1B970E129185D9F1C61BE58D1DB712F1C8E493B5386F1DBDFBE9F58ECAB91C11F4ED28388328F1B94CBA90156942';
wwv_flow_api.g_varchar2_table(2638) := '82D501B5924987F5BED03123263587E16A57593296B6AAF9A9FD948B3932B86FAFDE7DECE0E84086F28E8D6ED65A95E125B2B6757E79A3D3615796599FCE4C2603412A6BABAAAE1F9B17A9E401186BBFFCF91387B820697B777617EDF5C4326352CECF66';
wwv_flow_api.g_varchar2_table(2639) := '630142CCF330EFC7527185219F08D7586DCB7B4643E49EB9AF6D7324D6910C9B151691D6104296E34D5A8E8E303A3A15E9EDAF97A285D1C535BBCB6EE0D4B97C219DCF8A628EE7A884A0CEACCFB67DD8FAF94CF868EA6BCBD5EEDD8DEDCAF8B1D95C363F';
wwv_flow_api.g_varchar2_table(2640) := 'B51C894B995CA6C9AD9FD925AC05AFD6D5AC8D127181CE6453848A7BBA195CFEFCE7EE81F6BD2D5F32B8ABD435B314A3306A93B1809EB344043A9F05B0827F3B8AD0529924A0B326990EC70352B9DECB355489F1705BB75DB59EA504999FA4E6D9C3344F';
wwv_flow_api.g_varchar2_table(2641) := 'FBD72A6E5F3FA0155B5319D5DA782C9CA10AA9EB5DAD2AB620B8104D1E1867C1ADA2ECEF5F6FD2A88C8CB0E4CF25BC6B6D1F7D6FECC9933A9F777D5B3C38DC0F2C05DADF681B7B14A8311E6C05D57C33FBC988373BF72841991C5CA4AEBD5B0F35119546';
wwv_flow_api.g_varchar2_table(2642) := 'A9D1EAD2ACC753A50C39AA6AEAB2BCFEB37F7864A316E211BAC9AAD809AA346252388AA51836163FDE5F5FAF03EACABB3080BB2E3959C9E4A218422D23732B4CF53032625C3E4E877D8BADF51E5AA1C188BDD1DBA364A9820727949CCB6A78C45A84E411';
wwv_flow_api.g_varchar2_table(2643) := '125457D8ADE55575CDE53A9BEBCE7A70E1F12F48935D9598CF5659C878E83026909C2979EC5DF25BE9F051C6ED264541ABE1956A9D4EAB66959AB9D5D16A459870F73CFDE5D0BB9DE1E681DB7BA1ADF4C8932BAFF74F6E1DFF651F7D78C029781F019511';
wwv_flow_api.g_varchar2_table(2644) := '2DA7ACAB5F1CB9BBEF4FE74CD9403C62D74B85E07A9D6B60749792F24928DC5457DB59A7B3AEAE99D35A3D6ABAE2BD1BF56A959E951536952C6980582F29A31E1AF350A3E4941AC0AFA74FF74C64C668AF2428B65C4318FBAF2938D8C020EE1D0881FDE5';
wwv_flow_api.g_varchar2_table(2645) := '6BD7DF98FFBF47FBDF0F5D6EAE52E19CA94649D0B200B0D5ACE5D4F2F9A9C74055605E4B3A5E41ECE5899D60861F1B69779226675399B95C317D445287E09F1F65E25B8164ADDD9A1982A415D0E6A9F00ECF525A9D5EADE435D0CA810CB792506BB47A5D';
wwv_flow_api.g_varchar2_table(2646) := '3E42711E2717E72B9C848F5439C47C96C679987C3A4C561BD98E4BFD5BC7FB89478F6FBCF9BA4E6BD6A8D43ABD96E6F8F5797FE26827AEAE989B5F3497D52A6A1A73FB07D5B5554236BC13CA2AC6463A1C94D2DE8C6A17030EF0AA3CD64D9C2CAD039613';
wwv_flow_api.g_varchar2_table(2647) := '1C4D7C38D0A18398404DE3198FBA18F376A345450E4A0D14A752A795BB5B8B5389E6DAFCFEA671F052DFE577385A49C9C490C5E1EC2603D8BFB869AED25396EBD530FFA1246B24C2D57F8D6514FC491B1C2665A5A77A7166A1CB5A49B0CFADC6C5E27E3F';
wwv_flow_api.g_varchar2_table(2648) := 'BFAF1000A301309859FA78FF7E3AB2544A8902250ABC84021031C5A9DC1927ED25315FFEAA98C96F0B085F9EE73FABB7BF7B17FCE991EB4F922660F57FE73D4593A456A960F58602259285F3B3754C6EF8CB1AE8A879146E981C5ACCB6DB68096E93CD84';
wwv_flow_api.g_varchar2_table(2649) := '22924FE5C08FD72B98DAEA8A346F4AC64326B782634F75078A3554B03403415541E64560676C329CE861AA094823775D6A0FFAB42B4FBC96964BDBC3F32D1EE3BD0D75367A9013A56824164F25D38988C36036BBEBCCFA80A1CC4E4874991EFA81CA67FB';
wwv_flow_api.g_varchar2_table(2650) := '5BE4C633BCACEA0C162EA197C5D111202868A0A5DEDEB6FFBA7F50481E47794F3A1E4DC4128A74464166A28472776FC9BFAF7108F958240DF9E45422A1608D2615D9DEDFF3F517DE2B543271242A752185A94599E5D3B9425785311DEB3C9CF979E3FBE4';
wwv_flow_api.g_varchar2_table(2651) := 'EBEFF58E6E8536A63EEEBA911DE8EB3F8E27BEFE3F7E6AEB3C34AB685F86D8F26F4703873BBE645D79265C7D6DEFC97FCEE5121E3D4B0FF4AEFEE739BB5A98598BDCFE80F226746A0D17CC169E8E0DFD8B169744430C8169326B02353DDBBFF83FF90641';
wwv_flow_api.g_varchar2_table(2652) := '4B68BBDBEB7EFEE5A13EE36F78BDE3707D4CC14A5A734522958585F7443A99CD26E95C84545976B6777722DB7D57387FEDB5F0E176A5590B269241CA75F775FC7F53814236B47C98F8FAE3CFDACB72BCD56360D683BBFBCED7BB7D5E5E94689B52ECE8EF';
wwv_flow_api.g_varchar2_table(2653) := 'FEF47FF711B9D08DCEC668CAF25F7EF6792AB8BDBC4BFCABCEEACFB6CC3BFB0BCE8E1B130B7B6EDD91C6F17E6AF94865D56CEDC7E9DD1D6526D8D7DB76303F6AA10E6C8EDAA583D49DCF3FE9710A0A43D5D4ECF13533156E18981AFEBCB9C26F502B0E8F';
wwv_flow_api.g_varchar2_table(2654) := 'D3FBDB3BE9F03EABACE9EBA89D092453E1EDA77B96771DFC9AAD7769EB9E92B257F10975C795DD9F7D6CBC52EF9BDD691BB8C26F52AC968AA7F3C958340178994D899C6A6C68B1D19E663565CDCD5C34581B881F57D8CD04AB379DA082E2C0C089C8D8F0';
wwv_flow_api.g_varchar2_table(2655) := '529B2BABABE8E069822F33C98841564A8C55183516973333AD3A8CA43737B67A5A6B67A623623691A793C154E18A9B2D6FBB92FE59B0AE8CE51D2D355546515260242652090C2183C651E9F1A4E68C65303AC0AA8948B2B1D3CE34382C35559AACBFBEAA';
wwv_flow_api.g_varchar2_table(2656) := 'A6E03DDA105D1A22DBDD3D108A07D646579D4DDD7A1D78728A336D0A9386E7687982286852C19FCE0B001B5351E3464D60E699752A4E678D44035621E3713BD55687C36A541A4DB18D4019CB385A5A3DE6666F565D5D53CEF859B2C2024B7F5DB5C623BA';
wwv_flow_api.g_varchar2_table(2657) := '77722BD05BBBC1965B64D7F6A23C8733E994D5C00976D77CAC408BB9C18E06EFA1E9938F7FDAD900837F8A803FB2BE9BABAE4F298482C36C2994D97D346982AD414F5D583C32B14241C8DA8DF2888A47A2FAB27C9DA73CCC599D4E2BA3D4D398713693AC';
wwv_flow_api.g_varchar2_table(2658) := '9172124067704A314365AD09E0FE67EB07E07E0EE05F94D72B9C25F186533C9615922EA7A9A3AD7DAEB02915722660539C413D3BBB3019958C52C67C2A9C019CCDEBAC040C0938DA5EEB61CCB5D164369588623638C44C2EA523A40D8DB3597420D57322';
wwv_flow_api.g_varchar2_table(2659) := '0090438269A5628DE4E913471A382CC8D164B0BBBE5C621CBB738F7100575F6EEBECEF3368D40C2D0DF4362D6D9B3FFD7FFFE16AA7ABE03443A7482AC80D985CF5964583098579F370C7CEF31D6E1741F50453B154E258C1506A95BAA3B68A33D7CAED7F';
wwv_flow_api.g_varchar2_table(2660) := '16D2592116891552901F49C0F06699F16424CA189F00E37AFAF14C7F9386B3D45A35A8F3E9B2D9D5563E76574F4C8EBED6EE82451183E119514E40B3D9A0255939BD164B9ED2547C87D1A5D29F035DACB58290E7D52A9CEC2544626664A2B7D9A430553F';
wwv_flow_api.g_varchar2_table(2661) := 'ABD4EFE9FF2B04C010F7C2082FED147F4F3D592AA6448112055E4A8122067E69945FFF120018B6167E7DBC528C1205FE1953009F7ED8DCFA6E09805D6B81A4E6B682AAF1B12B9D1695ADBE983F9E437B1B1B44254994DB9D622C3E586F9B0CF73E199B30';
wwv_flow_api.g_varchar2_table(2662) := 'E4C2F557AEEFA7547947B954A02ADC664E470D6F1EE8F895B2DA9EB3EA35DB3547E6BA244C289DB346E4976281C8E43387E1B8251160489A33C04610575769559A98837861E1D1483C1CD97CFAB065F0BD4B6EFDA347D1B6C8FD9E776E126411CBC83960';
wwv_flow_api.g_varchar2_table(2663) := '8F3D357F50D9E03354B5CAF7CF42AA400C8F2DC4E33B03B526CA583DB4B0431ECC4DC702379BBD3FFADE6B69319E39CE55D4D7EEC6A8F9B14747617A616EBABECF3CF4702157D8EBAFAF74DA9C2DCD9D1BB105617BB2FA4ADFFC417C6B724849E59A5E1B';
wwv_flow_api.g_varchar2_table(2664) := '3C8889934313D16CE472FBA5A4A47E323D9D3EDCBED46268F6D4D88CD5C97C2ADF9630D93DAE02B3EE63F8AD9986869A4056313432CE658FDBAE36395CE5FBB5ED0BDB5B36326EF4DC5A8C64DC6CD8DEFC3E2A3ED8D3BA321925228F3B3A9BB576EDE39A';
wwv_flow_api.g_varchar2_table(2665) := 'EB4F1E3DAAD28BBCA542D8134889E9ECA8D63A3DA34B0787DBB392E4ABDB7FFADE87039978EC487B54ADA34956438BA29D219A06AF6539D3C8F04CFE686BA045CF1AABC79FF8F69626CCC6C6F2F5A5B75AAB9763F6E3F9C9AE96AA046D181A1E27428757';
wwv_flow_api.g_varchar2_table(2666) := '3AEDA2A6627C68331C5EEE7628B5654DE5AEF0F4D2BC9ACB9455D4E50932BCB9D7DFDF4530DAB73BA9A8E783D57086CE1C2BF5655212B6C372BD7526ABBBE5DE13B0522782EAAE83F9C5BAAAEACD61BDE49D6FA8AB68AF71569AFF6C2D90D73331B5A566';
wwv_flow_api.g_varchar2_table(2667) := '747EE7686BA649C71A2A7AAB49DDCA349F1597DAAA3D92C1BCB0A28D2FCC54D597D91BDD87FB8DE32BC16608483B5EBFB779246C8DAF08D14BFB2B055727135E6B7E6700F811DB5F5122C1B6ECB9D94E50CF59A5C2A0FDFBA1794BEB3A00F0B34171F29F';
wwv_flow_api.g_varchar2_table(2668) := 'A29F7A83D1BB5FD65AF2468747A3F6B19C54DD5C23103A56BB13F067CDB0F134BFF9DA60DBEE64B542C859F5A64481999A9A8BD0A19589A98E1B55768DE2534127DDFFEACD1BFD03EF74E7F626D59CA03519CCC69C5A9DA14C8245D40AA2325D88ECC2EA';
wwv_flow_api.g_varchar2_table(2669) := '950049F56740F0593DA6BD47666ECE56D7D760531DDB1BE3FBAB8E538DD1D31840EF4F16B6C3EBD30F23F9F7CA77584B7D85C972E78BE9FE4BF981FA8EE9F57E2197D21ADCE6BC51CD244C794682273F85998CA5E2D19470E093D83A64E4342A155A2370';
wwv_flow_api.g_varchar2_table(2670) := '75B5A771687C8BD8FEA2A94F17254C8F9F8C4BA9604DB986D338AAADF4DD87238534ADD2552858CDF0F8A156F8AA7DC0BD3B6A25F51C5DC8EBE87C9265461F2D1D16B6A79E64AEDD2AD72BCAFCDAF23B77BEBAD57F49EF6E7FD626F9FF514A5A9B98BC74';
wwv_flow_api.g_varchar2_table(2671) := 'BD812064505C54B5010BF4D225F7A7BE25221322F49E8BF1750A1242E95045B694EB6159FFE22B906C7A6EBF5A3CD655B45C7CAE04346DAF1EB8751B4810875C430BDBE4FEFC74ECD8D9BEDDD7DE72BCB8179D9BB9F9064A393B6D90532B59C2682B4712';
wwv_flow_api.g_varchar2_table(2672) := '20E3A985FDA46F7F942EB456F8152AAEB2421FA3D4EA35188AD42EC57D89C7C383AD155C79C7C3E1291C093556DBC05D6724C26636310A6D4A22D4E9C4E0ED6B19D63E370A3F054765269E73D52CCDACF01CDF7FC9D87F52B18B15C6F5C67E7C6D769C02';
wwv_flow_api.g_varchar2_table(2673) := 'AF7E65BAB2E316087316214F123FFEF99366056FB63C87991D1AB660AA542EDDB1BCF7AFCE22172FF21231B6B0D66334F3E6E788F942B4B440ECEFFBBFFF5E1BC118A0B9FDE34F1E34A82BAC7F3200B8D85AEC385F6876E9B6448112054A14F8E3A50000';
wwv_flow_api.g_varchar2_table(2674) := '30C21F6FFD4B352F51E0F7408157F1E9C7A65392049B9977392DB53D1FECA4D4470B4FC042D2F0053A7AA45469688E69AF71DB3BEBCBEB1A955A7BF4D05B5BE1B436B6F6858982E6B692567FFFBD5EBB8D1CB03136E61CA316A9A1D218C6E6C74CB5533A';
wwv_flow_api.g_varchar2_table(2675) := '77D7197D28925029F93A87B9B1BFCEA032DC78AF27B24CDC749ACDB6B6204D3694E90AB6D7780D184AD41BF5E6A7C17E150D38811DF579C006E84A6F95DE742AAA7DF64296C084A029AD1FECACA335E57AF5EE47FDF50AA941CD2BAD56E858DA4D0A8DDD';
wwv_flow_api.g_varchar2_table(2676) := 'AEDF4B71F54E7DADE5CF547A0D6C9BEAC1A9A48C7DED8DACD270F95AD7E274BE4B9FB1D50D1E1D648C067D8D99A9EC1838881106BDAE42AD68ECE948510A48991A7286AECE4695C109061ED84CB67FA985C3F12E2D23240774597F6BD7B5302CF9408C52';
wwv_flow_api.g_varchar2_table(2677) := '129ABB3B1995AEE7B5EB072BE39DDD0D8CB1DA14C95EB9729D54C836EA5A9B1CD944B32A7E5033D8CEA8F8966B570E57C6DB6BCBB0D3551DEF9719D57D9D4D8CDAAC5565067B6B18BA0A96E9AD761B61B7F1165739539554C04C395FEE32792EF5262554';
wwv_flow_api.g_varchar2_table(2678) := '4C45CB156BA294658D0EC9F9676FE3748353AADBAB1DE9441F97DC69EBE98CD3BC41A75110C6EE9E56D95E9736CA1086DE26B7C65CF54EAF6D6932D568126B1ABB80C7FA9A2B8C35327BCA6651DB2C1E5B9E901C6A85D6AC60F366ADA6A3CDC36A9D4DCE';
wwv_flow_api.g_varchar2_table(2679) := '7DC7DB1F92342C5D6BDE6C768E1FF730A4BFFF520367B4998DB00B45242A354AA353ABDAC9198C9D8D90EB6E794B5F988E76A9B85047FBA50C6F052B9E08EEB577F4A9CB6CB1811BFE8DD9FE2BAD94D6ADE58FDFEDA8620B15B442C592C4956B2DBC1512';
wwv_flow_api.g_varchar2_table(2680) := 'A4B2348146C53B20887BA9F3843776D6FFC4D256504B1FAAAC2FB2BC189284AAADC364EC6E76F365AE5BD707D2C1B5960F5B3943B9949F4E2633E154B6D3B4DB79ED8D6CB88F89ED93908B25892AA3A6F207AFA9741C0C7D5759149D6F5CE6A39B0CCD5D';
wwv_flow_api.g_varchar2_table(2681) := 'EDAD98CB87944C1436EE7B9BAAD58C40D8B2659292D3D26A65B6C3E36C6FE803D7F3BC5A2757571A9D65D4E930D6A83593DB4756EF98D18398A701A35AAB56DCE86A82197E9A81043AF16E4FE3CED324BC0B34D835B1FE9EE8DE32642A1AEC563AAF3565';
wwv_flow_api.g_varchar2_table(2682) := '318B380363F6EF50E516ED60D50067950F83DEEE72DB94B2A8C5A506673ED5CD46FCED7D4D690643512332624FA35BEB6C7D87496DCD073B2F69CCE5158D2264235A2DEA6C6D63B78E2F907A42909C2C29F11C6109442F7FD4AFE72180CB9858A2FFD640';
wwv_flow_api.g_varchar2_table(2683) := '62FB297DC2847C5665F9BF534B29AF5F254819FD82208FE70FF9B25177731F455090F1FE7A74E18D5BE5840A8AACA7A1D1AA10959D344175BCDB422B9E3BBF28CE6B9DE554A0E3590AA21CCAF87DFDA7B798E36AFECF061A78A211D4E8EFAE9C103B5BC8';
wwv_flow_api.g_varchar2_table(2684) := 'A8A3A3EFDE93B96C681FC57285426F676DB9A9CE70ED0368B623A15ECDBD39D8AB40A37856DF81D33405CEF5DA9BBB58864F65A12C13E1142A74B951AF9132C2B54BD58CA50E607AA0B79733CAACD6B77BEB3C4D688242C9410A669B3141DC9A68AB74D0';
wwv_flow_api.g_varchar2_table(2685) := '799EAC40ADE5B019CCAE4E3D220B0278E0654A465B5DDFD1E0A49ACC9C6C82FE7C6F0334BEB4BA6BD7C659434D31E1D92F4B11DD75159C719060CE99BAC5B7180CAF77B72ACC2F0EAAB3B4B8C8C036DEE8A2221E84B23D6EA797F79D2A81D39E53FE62E4';
wwv_flow_api.g_varchar2_table(2686) := '577A7D6A6BF48532CED8B6B8C0516E3140A717424D08F0A080C35D8837E32D8C52BE90B6745BA2408902250AFC9152001B77AFD71B08045ED8C163AD83855E58EB857F5758723A6B1DD646D829C52F2220E002AF8AD7177FF1B0F80A9678614DEA2C79E9';
wwv_flow_api.g_varchar2_table(2687) := 'A244813F490A60F0C39EF64B9A567479F55BED1F90DD7FFABF3EF9A82E5271FDAF90F30694DD36E76073C5B7BF133F08FDF0CFFA0D15E7D8F52545FFCA57301E3335363C50AFD65774FFCA08A587250A7C871498F50688A3A72D1D3D2F20AB83788E3958';
wwv_flow_api.g_varchar2_table(2688) := 'B3353CC75744B9B2C8F493C564649F62A9DEDA0A7D0590F373472DDF61DD2E66154E8A63A3A3BD1EDA543D70F1F91FFBF5F2517679E48BAE5A4B45CB804450CB7BC1FDE5E937075B08B58C185F698035EF2763D33200A6194E10FBBAEBB50E9925FE7B0B';
wwv_flow_api.g_varchar2_table(2689) := '9B81ECCAE443124618E1E28167BB6EF4BE209E50AC09B63213CB3B86EC765D734F51A4F9BBAA2100F0C8D0829D09360D5C86DAF3D0FCBE2BBF5BD9DA41B12FC266B845C47ECCEFF7BFA02584EF0B5C2AC047C6E3C78F8B2EFD700B831AF845809F05ECB2';
wwv_flow_api.g_varchar2_table(2690) := '8A5E91901001DB39848BDC8B221BA30480BFAB3E2DE553A24089027FF414C02AF95B01609C03EEEFEF176D3B61512E22E1B35F9003E786785EFC8DC562F04C837046A6422442320C79E238E7ECE1777521C106A128C277EDEF92A104787F7404BFB494F5';
wwv_flow_api.g_varchar2_table(2691) := '19170BAA5BFBFBA452493DF39684FCA5741A101FD1BEAD2CE02150873AF1BE7B310EF28771D5B3E7A870E1F090C0270B5E7C5FCA6997601A37972B924EDCDD4564FAC269ACFC16365B9FD50745C09E29A9D552A6D3136B444041B8C543B9D0DD5DD2683C';
wwv_flow_api.g_varchar2_table(2692) := 'AF4631BE5E4FC95C33516E2F2870E2ABE962E54BD7DF4681570180A1E1B6B9B95FAEC9AA6DD8FD9F086E4A1224EED6367735F9486513786EE7CE39BFAD622F790E0E33F6432F1F752F495E7A55A2C06F4E819381268FB8DF3C0962E2CB8204E4EF57B2F2';
wwv_flow_api.g_varchar2_table(2693) := '4F755E4078848452856C5D4E0E38C33E31CF54BC7BB5BF28EB4C0519B8ECB71D06BF63E5D0A1F816173379F970C232FE8AE4DD2EE67CF1FA85A6BD6A00FCAA74805F6846E9B6448112054A14F8D3A3405116A6E89DB5B88EE3B718D0D82212C66DF10268';
wwv_flow_api.g_varchar2_table(2694) := '391A8D3E07800F0F49958A7E3500B8100E035EFE5A002CC154E1F131FDBC93E1D39E02743F38C84F4E02DFF21F7E28A34708A12E2FE7A7A6001AF90F3E28E249716323FBE8115355C5DDB8F16D5D0C142DC19FC93700B05CC944E2ECB9140CE69E3C21A2';
wwv_flow_api.g_varchar2_table(2695) := '51EEEDB7E90B4E925FC856DCDECE8F8C903A9DE2DD77859595DCE3C730A9A178EB2DBAAA0A31C5BDBDFCE3C794DD5EAC0FA82FCCCCE417172938737AF75D6066545E98981036372133C77FFFFBC84A4447B0ACE2BDF7D01DC8213F3A2A6C6FD35A2DF7E6';
wwv_flow_api.g_varchar2_table(2696) := '9BE2FA7A7E6E0E95E7DF7BEFFC14E0850A956E5F3D05B059A9AF3E3F3CC2D60D6095238996DA0A82C0DFEF1A8A19FEAEB994D29728F01B50E0E4704F1E71BF55C0F9EC6F15FF3B89FCA73A2F64E0499CD3F3F7867EE552D1FD2F3DDEFD4E3AEEDB3241BB';
wwv_flow_api.g_varchar2_table(2697) := '7FC3339457847E51B18B395FBCFEB63ABFA2E7E7DDFF8A0A28655BA2408902250AFC095300DC4A08DBC0E51BC02D043B817221FC89108944A030A2817F0AE8BEC1E7875A8D6840C2174901D04540221AA87263036C46308401B40AD128E20016CA6C4C40';
wwv_flow_api.g_varchar2_table(2698) := '35BC028713703A14127D3EA03B99DD5A8C908130911C8AA9000BC168453EC5F8C85C8673807FCF32971179348A1CF00BF827ACAD2121005EF6934F0A81800C0B117367E7EC705AFE4C299540B680AF482517944EE78686E88A0A22161316655F7FC587E2';
wwv_flow_api.g_varchar2_table(2699) := 'FC7C7E7EBE782B97128BC9A584C3482878BD72861C47F23C98D2856050585DC54531B2CC00572AA56C160F45BF1F87D38CCB55482400AA91899C39E870D2DED3CC4FFEE109E2E767667097FBFA6BCA6603AB36FBC517A77190DBFA3A5A57BC9562B1DCBD';
wwv_flow_api.g_varchar2_table(2700) := '7B4C6525C802F48E875220909F9D055A4629F9A74FF3D3D334DE1E1E024BE32DAA0D848FF8C2CE0EDEE61E3D427B518DE2DBD3224AFF4A142851A0448112054A142851E08F9602250EF01F6DD7952A5EA2408902FF042870767E994824807EA1918200C4';
wwv_flow_api.g_varchar2_table(2701) := '8B5BE8A20018438416B708B8388B5CACB8B0B5057899DBDE1680C7AC56405CC5071FE4878715DFFB9E8CCA1C0EC8EE823F29310CD88F999FFD0C3C4CB03DC1C3E4AE5F4704A6BE5EC6961405DC9BF9E94F21A35BE4A60AFBFBFC0F7E404422780586AA30';
wwv_flow_api.g_varchar2_table(2702) := '3F4FDB6C409EFC5FFE65EEB3CF08A592EDE89059A03E1F7FFBB6CCBF1D1B63AF5F27F7F79127F8A58ADBB70129C153056A056F56989BA3CBCB8BAC518043204FD55FFF356E650EEA49A0ABAB99D6D6225EC503B094337FFFF7B4D90C504D5A2C85BD3DF2';
wwv_flow_api.g_varchar2_table(2703) := '9D77C4508862983C40E6E22240AF68B52ADE79478E1C8DCA6DF47AC5CD4DE6D225B6B313DEF398A626C411C6C7B99B37C1DD655A5AE4D381A323C4070F96EBEF075E65BBBA0062F1A4E0F7A3C280D0A97FFFEF718B409597B3BDBD4852BC057F1BB89A7B';
wwv_flow_api.g_varchar2_table(2704) := 'ED3550A9E0F3E121403E903F77F5AA04AC3B3222F38AAF5C410EE2EA2A2A007168CA68E4AE5D4364616101689C696BC3D904CE1788AB578B79967E4B142851A0448112054A142851E08F9702250EF01F6FDF956A5EA24089027F780A40C21992695AAD16';
wwv_flow_api.g_varchar2_table(2705) := '3C5E405C04707A8B3618F01C6010013C51846FD615D014A2B602B0AECB05D8268B16C7E345562A002198A8E06AE657561041F47A01D5089E0716452A304B650E672E97F9F8E3FCFDFB3247776909B010C2BA24B06B365B00A4047E039B17995754500E47';
wwv_flow_api.g_varchar2_table(2706) := '6E72126AB1C85C162D06B3D7EB05BA435678C5B8DDB4C592FEC94F006E212D0C9E309E23E7C2098604B2953575C18E86E492201499B72418D7CFE4F100868BF0B8D840C4442694CB05362C3C38A0CE00BD05D404555A5B038E056ECF7EFE79313244AC65';
wwv_flow_api.g_varchar2_table(2707) := 'C6ECCA4A211E97E5B2280AAD468501AAF34B4B40AA482233C97339B90EA9142EE46AE020003903FCC39E677F7FE6B3CF642968EE540514AC665937F8E42D22A03EA7D5433EB46C3946CE47F6BB48C0142F8E0C101F97729C13D7B540BCC4892034220387';
wwv_flow_api.g_varchar2_table(2708) := 'B32D2DD98F3F061A3F6BAF9CB0144A142851A0448112054A142851E08F9602AF96038CADE11F2D654A152F51A044813F350ABCC080FD0E9B076560C84243DA19480AD9C28B3DC3725AAD4EAD56C27A3ECA4500368677F4E70A05C48205E96452E6E50286';
wwv_flow_api.g_varchar2_table(2709) := 'C12006C4A4A351604EF05A8103F1CB363400CE15F56FD9F67608EE02A6E6EEDCC15BD26090611B701D493215153253F4F163F03021E20B5C47300CA49A01E7147575B204328A3EB18905EE68EECB2F2133CC545783014B5FBF8E6B9880922211BC923136';
wwv_flow_api.g_varchar2_table(2710) := '38CF27A091A469E403EE68F697BF2C00A8A386E93478B0B24434D8A466338490999A1AD89192F1E409C29705863D1ECAE94435F2E3E34C7333DE8A5B5BA770B45060EAEAD88181E4DFFE2D38B705084203F44A122283199E03566F6F2F1AAFA2CACAC086';
wwv_flow_api.g_varchar2_table(2711) := 'CDFCE21740C260268BC8BCF83539FBA6C0BAD80988652F5F8690336C5C816F2CCB6F53946C0D0BF14FEA035AA16EE07E830F2C027B5754400A1A5C74594E1B0FB7B765DE35D8CBE1308E185073087883FB9D7BF810DC78B0B2E9C6461C2B64EFDD03631C';
wwv_flow_api.g_varchar2_table(2712) := '047FAEEF4A377F080AC0BB262CA368784624D9820017B0249C8290CFBCB6146B9487A885840143302CA69B3C1F8B01666F4E925034AC5D514C3A9D91C4BC46C511B4023B15DC2A39B8FB9567682295E1C83CA77CCE5B525628E43329948599CCABF8740E';
wwv_flow_api.g_varchar2_table(2713) := 'A5086481E0D57C3E4FB08C542099422E0F6F4C50142888399E635885329B2B643329386BA139356A8EE18E6AF02C1CA3F078C552798A510862812C8814CBE6737996A1E4D4F98C8A636885EC19E52CA092C9549A2544854A83EB7C1E0B0B7CED4814CD9E';
wwv_flow_api.g_varchar2_table(2714) := 'C5C18520B7138E80D014FACCC60F9E23099432400EF03D28062741E794116597B5022CDE809848270A3999A62421D14C2695567214C9FC0ADBF53843CA26934AB96DAC705219E855C231CE7395813365B9C5B2E31974D6D92B3C922B73527F8262D3E9AC';
wwv_flow_api.g_varchar2_table(2715) := '24E6D42A9EA45944CEA432BCE2595FA473AC944393CFD216DB5210042CB9C53C656A64732C4B17474212B90959188515243A9F4DE3640DE3019A28F01254CC04ABC8C96A4C1524345210252A934ECB3E75D46AA14066D229D8C855AB55888F9CB3993CAF';
wwv_flow_api.g_varchar2_table(2716) := '808F561A23043D8E240A86A2147C3A95C178E239966015E9548A210B4A352A79DEC66259C94C5EC960B87168F219618BC3ECAC45D04491FB471EB1CFF58BDC93387394A9F42261F3183318E48404FF58F0362C1504F438C3A09E542A9D512B6850F22CFF';
wwv_flow_api.g_varchar2_table(2717) := 'B30B3435974EABD40A34B9200ABF7AFA0822AC437D73FAC88304E30A1539192417A78F80DE849D08A5EC8709652552690525B2FCF35D86B68822DC369D9108845528A00DCBA0F1A9449222E43E4A65D0AE1C888CB9C8F118FFA7F494C75041C0E8423510';
wwv_flow_api.g_varchar2_table(2718) := '335F20B3E9144B4BBC4A9313245C73B4A450C91316230E131587D0204B3A99A6D0D082A452B0058A432F13E859A54220992C7A9C28F0B2018EE7BAEC24B7A45AC5C14B916CC152A6FFAF58647279116490E92F7FD3CF739067DFB3A9F4E2BA2413165D25';
wwv_flow_api.g_varchar2_table(2719) := 'D12C2377381C1191244B53680B46A94A8529763A3ECFFA0B17B9022166124AA54A1E07BF7E5E3F37FBCEE6354A4172CC654A125518D8149DC5BD90E1143CC6804CFF78123ED6E088EC62D1B84E6704219F56623831F0C724C2D1143EA798E619A12064D3';
wwv_flow_api.g_varchar2_table(2720) := '98A42CA7CCE4B15CA5391A2E9B941857E94C1A8B09CF322CAF0481B06451A2C029F97456A0F1DDC5EAC761369C178427524184A9669011CB3BFA08EDC4C4E3D4E7715EA8D577754BFFCDDFFCCDCBF3C200380B276C0C8C613960F14242983FFDB6E427AB';
wwv_flow_api.g_varchar2_table(2721) := 'DBF9B0F8B668A5E7250A942850A2C0EF8102C575ECE576440053A1BB0BCF46B878A14A9067861323B0730DB00CFC2C00F742D4D962B1203E3E842CCB29385AC1881C36C5529297E214AB82B7032C9A283D0431600AC8EEDC7960FEC913F063498E93CD2C';
wwv_flow_api.g_varchar2_table(2722) := '0502008A8AF7DF17A6A6648DDC5088696F073495A12CCB423C180C5BAEB797D4EB21AC0B84A6F8E823404406080D3ABA30F81C0CCAA2C23B3B4C4303C01E18A4C856E6859224D8B9C81C501052C790E395E59F5757813F655CED7422BEAC466BB100D902';
wwv_flow_api.g_varchar2_table(2723) := '8A038103B5020A226700457056655DDF548AEBE941F5C0F895712FD8A1B11877F9726E64049012F9000FE353C75EBA94FEF18F01E651796075C04BC057A4055245426075206A8076C6E3C94F4C30B5B540AD681A147AB1F507431BEC6534107AC8722956';
wwv_flow_api.g_varchar2_table(2724) := '2B089A1F1A924D4F190CB27A33E880CD97560B448A6F364038B8E56C4F0F2496C1EB06CC565CBF0E7E32914C82490E02CAA2D4CDCD3285ED76A4CD2F2FA314AEBB1B3CF0620DF30B0B00D58A9B3765ED5FA0625154DCB8014972C85D43165AF07A516145';
wwv_flow_api.g_varchar2_table(2725) := '7FBFDC34749CDB8DB4F2714329FC66148022C04B22622F811DC24BF60FBF322DF6FB8BBB47D3C30FEBCBB5DE8472E9C1D852ECA89C3CE674CF392FF9726E271F58DC9A5876D55B8ADE358BB91D248895A9AF760E72DAF4DE91C27EFF8B9FAD6D6E88814D';
wwv_flow_api.g_varchar2_table(2726) := '7379E5E27EECF30743F5AA086774EDF8122343F70F7797CACC1A4E793ED9D78F330FEFDF9D9B789C38D8B3D82DC30B3BF7EFDE210EBDF63AD757435E5B6E6B93B0AF8CDE5599F4BFFCC9C8F6C1929A4CD03AFBA391E5C5D9094D7E9736D5DC1F191F1B79';
wwv_flow_api.g_varchar2_table(2727) := 'E45B5F36330585ADFCE1E82271306372D74E7A23D1A743BCABF6ABAF47ADC6FC9DAF973637E68E3736DC95168A3DB7AC7E10CA0E3D7AB8B938ED3429526AF3F867639B99287B3C63B03FE746657A2FE1F73ED998F43ACB085A796AF61C1480FF95B1F1F1';
wwv_flow_api.g_varchar2_table(2728) := '503094DED930B9614EEC5C0070DD9FD9191D9D0D84ABD8C0116D9F9DBAEBDB8B2BE29BB4ADF2DEA3B19C7FD9568E49F7E2EE7C763BB632FA73B7C39C50E866BF78B29F8F0BFE55A3BDF2ACEFD05F13D3BB91C3B5B9F5AD5AA78660CEA7CF51569CF9726C';
wwv_flow_api.g_varchar2_table(2729) := '2D1DD6C717A3CAEACFFFDB573B7B4B5274576F776DF8028F7EF1B84C195759CAD742E9E1A191E0FAB245CB713AD96D6C31C425626362DA62D392B48CCC1359F1ABAF9EB8D4014EE7DC09C487471EED2C2E38CCDC46987A78F7C1FCC4783CEEF7B8ED0473';
wwv_flow_api.g_varchar2_table(2730) := 'BAA58EE5C4E5994547B9DA1B6152FE99952D62E2D13DEFDABA53975E4E189F7CFDF1D6CE2E4FC48D66EB518E19BEFBA04247E4D5A6874F669E3C7AB8BB3A6F28E47659E3C8E77FB7BF75602473CB697AF2EB4F76F777B56C426B80F9FA53C262495C3F8C';
wwv_flow_api.g_varchar2_table(2731) := '7E363C6ECF6F69CBAA3723E2F2ECFDBDAD9826B7A7B29C3B1045B491D9B55868737B7ACB556B24C8736730C13CB1706778291E57C7B7B456F7B3D6CBFF9F3C3D0CEDAFAD7A673C0EF3AC9F3A5ABBBB3C1F7399325985E9D3074F35F179A3DD7356936242';
wwv_flow_api.g_varchar2_table(2732) := 'A08B8915DFFED870459D653D48AF0C4D2C467D2E3AC86A9F9B3E5FCC6E0981A5ED892557039E9F1F7C2C07F29B8B0FB7D7C336F6789FC0F4F964CDBB290537D5B68AB9C583E92F1FD4D5A9488571FB30F178E8FED1C1529949C72ACFDDE74632C2CAD325';
wwv_flow_api.g_varchar2_table(2733) := '473930AA8CCC8FF2C4F02FEF38F4054A6B59583E9A1CBF77B8B753E1D60F4F061E8D3CD8587EAA25E326BBEB6CD46D470BD19D4983C5B9EE8B10C73B4F7C9985E12FBDDE758B8A99D889CD0D7F7970B86BD614945ADBF25172FDEE2FCA6B9C215139747F';
wwv_flow_api.g_varchar2_table(2734) := '6CECD1E3BDED55BB895ED923C71FDCDDDDDFAAB4B223EBF999D1AF0EBD3B0656509BE0E6FAB4CB8036C796B69E8C8E8847EB7657F95694DA7A343C1B8A3A0A3E85E19C4A408CF7EFAEC45287BB1B136E7715307C91C2F85DDC8D1FCECD4CFBF63C7C9C56';
wwv_flow_api.g_varchar2_table(2735) := 'DBCE9EE3E2F3A9954CE4E0706AC6595F35BD1E3B5E9D9FDEF3D6E90BBB79FDBD7BF7CBA9186F4611CF6D3C50D0F0C47E60E36B5745E583AD6C6C674C9ED7768AE62FCC853C313E31160C84B27B1B26D773F37ACD97DE1B7D327B1CAAD2641682DCC8979F';
wwv_flow_api.g_varchar2_table(2736) := '6DAE6FA88950416DBB3FB7BD3973AFDEE31019D5F4BC0F233B1FDBB6C29A06733EFC7C89ECF0FDE9D595191B17DA109CECF15395A97C6973AF100FFDECE9CEEEFC68707FAFDC615DF2E546471FF9C666AA1BAC2B317EF8F3FFB6B7B5A72BA45476D7FCDA';
wwv_flow_api.g_varchar2_table(2737) := 'F1F8C8DDD0D6A6CAACB93FBD313972FFD0BB645116D466D4F334ECC6C42DEF9CC38291CF4473C49D4758231F28637E5D4D454EA0E29130F4C8BEB96DC376CB6AB5EEE2EB7F227377B2FB62F18B8073B1E22F521503764167A1582A6E7171DE6DCF2AF3DD';
wwv_flow_api.g_varchar2_table(2738) := 'FC2FCAFB953C5E7E37D42CE552A2408902DF0505B092CA4C83EF3400D9223F648BA51667999C94248E9E14F48D44F09148290B31AD68BF595C0F8B2BF559E1E03102A401B9716D6D106F2EB273015CF9EF7D0F62C00069500F26DCEEDCF030B81558AFF9';
wwv_flow_api.g_varchar2_table(2739) := '8F3E224D26A05F68AE02A04268F92C2B1AEE7CFAFBC1FC040B5746B08D8DB2ACEFC9122F9597832B0BAC08880B6009C557A4821AAD9CA74603F40B7162EE8D3764B077F52ACA929B7301FCD36565E006A32634D8C83058A5D301BEC2113C04B6213BCD75';
wwv_flow_api.g_varchar2_table(2740) := '76CAECDF13E8CB9C58E4422660D89257AE2013A6A707789574BB816665FE2D7495E19A0876BF0882FFF33FC749002A09AD63F942A1005486B031E29CB294F171AAAD854674D116343730001E2C12CA62D227D5A36B6AC0B5C6134068545EAEA1C723677E';
wwv_flow_api.g_varchar2_table(2741) := '22980D905CF45A840642C557F1E69B3940EEA62659DEBBA101EAD6C4E5CB281A2582DF0BDC9B9B9A624F003F5034C4B6710C21BF6D6BC371837C8EA0D1B0ADAD17DD3EC9E596C2EF9D029869F31B9B362908EE962F9CDE1C5D3C6C375FD6505163E78A77';
wwv_flow_api.g_varchar2_table(2742) := '33B4BFDE605357B50F8E6C1CB3AA75FFD3E381F73BC1357934BEDD6C8C986BDBFD496273ED71AE70B5B232B1A3BE943B5E36D5F4FEE2E17C5DEB4E30C28F7A836F59F799CA81B1A7AB463A39BE9FD73CFCF9C047FFD3195B062C8E9C4AE37D38D4F8DE0F';
wwv_flow_api.g_varchar2_table(2743) := 'A1D0AE502A86E67607DFAA4891F4E2D46C593CBB672DDB5B07F028DB7AB4D4F4413976586BC799A7538FDBEBADAC520336A452A55A5ADF7CB35E47F35DA184B0BDB3E14FEE56F70437F783D2E804DBD03636BF5AEB0CF957F6EBBA3D43735BEDDB13C6C6';
wwv_flow_api.g_varchar2_table(2744) := '77CEC89C4DE7344A7629A8DA5F1AD558EB571F2F67AEBACA8879A2FD3C0E222F1DA594BB2B91B9FCA51E13204A639321CBE062D7E5B2CCAF2E3875C66C385A3BD81F1688F90793D706DD84CAB6134C27C7E7C7AB5C6F98693FD73EB7BA64642AAC9688AE';
wwv_flow_api.g_varchar2_table(2745) := 'F51AD86A5FCD4CB5F6F710C4334768CF2A3437B653ADC960CAC644627D7821CB7A989CD7D872CDBBB0E03F8E56ABC5BAFECB2B8B3E33B7351D49DEEE73110AF3C4FC7E157764A9EF0CE50AEB234BD1416783762DA4B91E9EDAB07CAF6EF4FE84BDBA3616';
wwv_flow_api.g_varchar2_table(2746) := 'CDAD6E1CB5E92386C6DEF107CB6665746A3B970B7CF2D6BFFE9F09F2148F25256279EA6953AB93E0E4F5672F10F702D9B0C95657F7D8D2667A7BB2A2AA0BAC7585C4440B8AE3C74B8D2DB72FA2C158A6303BB5D2D567DB89F08A9DD9AD4DC1C0257718FB';
wwv_flow_api.g_varchar2_table(2747) := 'D2DDBB6BAD4E556495AFB9FAE8C9BCA34CBB1D71EFEC6E6DA9D31565151A957265FFB8CF186695ED2BBE58647D48DDF22100CBF2DEA129B95128BBFAF8CB27DFFBEFCB59DD29B8C5700D4413AB47D1A6FCAAB3ED8DDDA8B0BAB6C88B2E3721981B069E51';
wwv_flow_api.g_varchar2_table(2748) := '51FE8F03821A9DFF7824DFF56ED3DCEA56B75B1BE3CCF18DE594B3C63BB2B0DE51ED361C389B0677A2A27FE9516F6F0F41ABD7578F0D05AF2FB5F67A4FCBCA11ADDB7EE29D6B1D681529636D41A55C1879E2E9BA4E10E7270E28452088C9D5CD01256C28';
wwv_flow_api.g_varchar2_table(2749) := '32BE50C63BBA70D866BCA6571CAB1A17573732A1839EC63273D5A5D175BF42B371347BD4FFE12018BE0F479607AA48B5A36133940F6C2E16628E76B3CA5B6815034BFA9AFE5F0ECDFD9BBAFA44283F3DBCF9CE6D5B5EE5199F5931B2E97BAB4975F6E77D';
wwv_flow_api.g_varchar2_table(2750) := '1FFCF519B68CA4C4B9E9A5CE3E7BB1562B3B898D5DAFDD926C70D63DFEE5A4CBE5571B1AC01055ABD88523A195D964F9A68B5DB61B2D90AB53558D3D9BBE4821B0B628381A9589D5946BE2C9933D56EB968EA28AB6F12F1EDCFAABCA95CDE0CECA7643F7';
wwv_flow_api.g_varchar2_table(2751) := '2A63EF8704D6BDE1BDB7DFD1D3AC6275EE30B5BB636DF2C8045F38A8A002A2AEE1CED0E48F9C465275DA65009C522EA1D56826EF4EB4B6371C262A8FC6E6A6EB3D037C86A8EC92BBEA24E053B438B6E56A2F08C1D9FACE9BA99D797773E75128CB448EF6';
wwv_flow_api.g_varchar2_table(2752) := '226C7E7E75CEC0BC5166256CADDE70EE686EB2FFDA2582540FAFEE5F29CB6466E7BADF7BD3BB1D5378D76615B977AB5956EB09C4C9F57B4F7BEA5E74429E85EFB791F9CE5EB0D6A9C9DD484D7425389BEB1F30AFEC2783BEA5C4F1D1B58EDA94B11E053A';
wwv_flow_api.g_varchar2_table(2753) := '34B65C2C5C333010CE4B0B0F27AF5EAE2494D6EDA3547A627EBCD2F566456ED3C72AE2BE8CBB6E74F84EBFD9138D479F2E6CBC7FA3C357306F4DDCD7D8CD3F7B34EF50D3B68EB79FB59218F746F7569ED436D7417A65E130C547662C35BD2B5B87D56C7C';
wwv_flow_api.g_varchar2_table(2754) := '6839FC9E25BEB414EE6CDEE7B94A9D46BDFA8BE5D7DF3D5A8F69036BF75C2DDF03ABFB2825DCBF3FD6E8CAAA390B43B35A15FFC8BBF36E3D47739D6745E0623F26AEAF2E7636E2888D87A4439E558ECEAEBED6684EC12DDD0BE70117937D17D7AF0A0063';
wwv_flow_api.g_varchar2_table(2755) := '1785ED205C127F17952CE551A2408902250A7C07140000FE0E72F9461658EE006E21DC5380C85C3A42ED0FC96242DB5F4AB63E890C0B1601AE7381608B30F82C75FEE1434826C3DA3069360371210BD81CC65B307EF177160D9E7B8AD7E0DCE2026C5878';
wwv_flow_api.g_varchar2_table(2756) := 'F481D9A78B30150850E6B562ABEE91BFEE807CC524F895B9B510B6CA66E524381CADADC52D80344A3C8B73E6BEE8E2C3E25BA6A3037FC5EB6211B8567CF8E1E9DBB6B6E205F070F1021AB9B8A04F248364562DCA92A5DC5E0C90D6C623F075E18C1722D6';
wwv_flow_api.g_varchar2_table(2757) := '902E3E13D72B36414E009EFBE5CBA729BF910940B58CAB5116A06F5555311A148F4F2FE0B3F7C46D2F70329EC8C70A677586B4395241EDF999E727549E3FABFFE0E00B6F21238DBF62B6A5DF3F2005B0195ADF0A72A9E337AEF5112ABBC79C31DDEACFB8';
wwv_flow_api.g_varchar2_table(2758) := 'F41AA3B4102B3C7C7CAFCAA19FF862CD5D5FF7668BBB46A5A9B0640852E6DFCE2DF9DD55BB00C04E2DA1EE7D9390AA8DFAFC9A20E994ACC96C6159334B896D15266BCDA50239111388B5A3BD1F36396622E2E1FA1C0629064BB1D5D5163E7BED7576E9D3';
wwv_flow_api.g_varchar2_table(2759) := 'FE9BD709DAD0DB6EFDA4AAB9E35A3DD0478D2DBF2EDA2DFE195B557536953C391483D02AA9E2591E0AF224A150C367177175B06B7D75F9CA158BA6A6757CDDDFE16467E32DD19D55A35273ECA83D9C7E52DBE0CEA6436A8E325BCCAC250CF9EA8BC169E4';
wwv_flow_api.g_varchar2_table(2760) := 'CB6F5CDFBCB72A4A4FF41471E57677A1DAE492C0BF7A2EB4976B55C62B39B7C41A5DC3235BE5DA759FF1F5AD91D1861FBD3BD8D36DE6356C0A50884D142480C06B5D1A00E01A9B92787DD068B37036D1C112977BAE6B799D8515B081BBD6D7B9E18FEE2F';
wwv_flow_api.g_varchar2_table(2761) := '2D9637E388ED744787BED8DA0F690EBC7DFFE6754663D717889E5B3DF91A5B99E8D84F13435FDEAF6CACBAB77658DF5CD9D5E1D6720603646415723D97378F0D9A5500E032053DF8564FDE63B630E5816C5ECBB19632B34FC92908A1C1E958696A95C40D';
wwv_flow_api.g_varchar2_table(2762) := '887CE4D697DC1FD6AD850FC777236F151210562F361515289E88E116D7CB5EDFADAB158B4FFD2D193FAF50C529954EAB6459BEC166885CBEBA39EBEDC7911CF19C44E5E96A0C694BA940170A469D3666301129AC55D2605B55D9E537FFB7FFF073DFE66E';
wwv_flow_api.g_varchar2_table(2763) := '249BEBED69DBF46ED4A54357BA5B96B77D83E57BF6962E71F2E0646CC8277B3C95BFD1534F75DCFE0F9FFBD281ED33008CBCEAECFADA8676E17807F5F4181963CF0D9ED699B4A8F273A1BFADD6AE2E8F2B21F8A95B585BABA3994D8D26B7365D5755DDF5';
wwv_flow_api.g_varchar2_table(2764) := '669FDB5D6657B891C09F1297169EF676B70100F7B4DA558CAAAE504370963627ABD5BFE1B23B599396A588B7AF36DF9B69DE5EDDA8ACAD27A8538A01CA2E6DF8D454B4FBE600C1183C96B4F5ADFE0C868A899AF286571F3D66DD8EA5C9CFAFBA1BDF68AD';
wwv_flow_api.g_varchar2_table(2765) := 'AA551BE4E943A83150A6E6773AB532006EB0B09ECE1B5441A32C630B918256C98143CE3266B582686BAF9CF9BC5A12896886580FEEFEA011DCC2B47FEDEE09894E99ABA8BF2CFF7A12B21211597ADA7DAD676771B631132E68D52443EBF46A966407BA2B';
wwv_flow_api.g_varchar2_table(2766) := 'C7C3423F53A8C478BB1090127D8507908E46D74395C064D0EA183BCE76F58ADCCDAE36BFFBF6C7FFCB5A77FC4075B8E9BAF9DEEECC70D7873DD76F74CDFE72E7E6151B6B6F10C46924C7871859A90A851B032D4CCD6BFFEBDFFE2721B8C13E03C02C49F4';
wwv_flow_api.g_varchar2_table(2767) := '3757F93DF577C6E7D1B51506D671F3B2D96ED5189F936741936EDCA8D7B9193263CF118AC78F56FFBBEAF2D18D4C4F7EB1B9F6BA78B9A75CC32B2C32E50F12F9D5D9F9FEAB0DF808BDD55EE7311604A313B3AFBDC6C096759743B458AF2F5753AF5FBB3C';
wwv_flow_api.g_varchar2_table(2768) := 'FBC9E735BE15A3BDE1ACD1F902F8C907559A6047FFF7084A7DA5AA50265DC9B8244EEFFAFCA1CFE91F0A112EFBD7E3D53FAAB9DCDD63E4F58A0C3A99890BF2BCBEDA630000AE73A8E4796D3533268ED84B1A35CAB4DD1CF5F3260D3B78A97666159853D8';
wwv_flow_api.g_varchar2_table(2769) := '0E4B5A665B59DE959FDE3E5EF5DB3A4E287D520915E4FB15A286A158A54E0CE1E0F9A4FB64ED22F48004B0AAA20021C946A7B6D67923F8305BC893272E8EE56E222972EF38AEDEDBBDFDAF7F84D5124F6E9A9D0B1B2BD7FB548AAA4B676DC405323DDB1A';
wwv_flow_api.g_varchar2_table(2770) := 'E938A2BBBB7D767AA661A0FB589EB038AC7985E15501E05758E552D6250A942850A2C03F190A60ED965542A08F2A64A4D8AE08F9B77C52644D054D8D24E4C9DCB1948B15289CC423E273FB5919F7427EF81923171F66302A2FC2DA5FD9444835431A196C';
wwv_flow_api.g_varchar2_table(2771) := 'D25FF9F69B0F6559689D8E05B756DE02FED30A32F3191CE36740F49F56E54AB5F9274601EC93FC810423E68A52CD4083CEEBA7E744E1ED9C864EBD7DEBFB3F7EF095980E5F6F6824083B21430659A0B0A7BD5CAF97D511ED6AC2DE72A3D82C6923BBED8F';
wwv_flow_api.g_varchar2_table(2772) := 'E58CBBEF5FAD62F455664A25D13C07410E92388EA5235B5B35EE362E881DD87373164AC7D0669035F14E042C3067510020B2515B609D9566329848C4846CC2A80600D3739CD26DE5A3FD578F7D070F3F1DFAE8AFCC795D05D60AE8EEA22D23B35EDBD1D3';
wwv_flow_api.g_varchar2_table(2773) := 'FD4CD98A2072EE96BA3A279B116D066B26BE799410F676BD57AB54BAAABE626D8BBFAC927DB0B0A90E4FBAAF0C6A49A2F5B5E2F15339DEA20EC97852AB64A0ACDB66C76A737A32E56A2E7837E7FD96FD463B1459F9AE96F393353D4DF40EB6124A5990C4';
wwv_flow_api.g_varchar2_table(2774) := '635512D62ECF4931383CB3B79E9E79E101F68816832EB2BF59DE9C17255ED61554C9A504224985982814E4932BA071FD8D6212E776483408D9B7DEB8FAB79F8C108983D6369C28392A4F72C64F5BBDDDC4C9DB4E938232BD56AC8CABB019DD0DC54DBB5B';
wwv_flow_api.g_varchar2_table(2775) := '03D7DB34663798BA247B009D61F4DD513613DC5DA870D4CC449CD0DE7C968DFC1F3A83D489DDBBA8484C8FCC323589A7EBD1B7B6D57D2DAFCFE42ECFEE85C4D8A73DB7FF4728278B05240436B80080A118222BD0D2D0BC86D66C96A45636F66CB564D3CD';
wwv_flow_api.g_varchar2_table(2776) := '3796F70082D03F040316562C3FBE3C576FA1D66757AFF678D4556527CA7F7235709E69D5AB343A2D033DD568128206004594C49DE83BCBD54340FD2D060DA5C8417406B7957ABA527F4ED81CD47113718D4E055999AE8693F51CB60B08C2E5AADCDE9FF0';
wwv_flow_api.g_varchar2_table(2777) := '2B7475568391638D373AE5133B02A889706A68AEA3AF780CD1DC524610F89343B37CE079CDFDEC9BC04188475116F2FB2B6B6B00A23209B034F902C51C1EC539D04192BBCC6D5112D74E07432CB0D9A253186EDFDEFCFB07442173A31182B88EE2F441D4';
wwv_flow_api.g_varchar2_table(2778) := 'C1CE1AFE84F75F67E608F369122994DE3E8A65F676DEBDEAE18D9510C221A12FCE426D9B388A6662DB5BB59E36260E042853F22C404A0AE79AB80D6588F9B9D19A8C7D7E7CF3CDABCBD7DFED3A5ACB3D58D8B5E6771CBD3F14D167F2887E3EC8CADAE844';
wwv_flow_api.g_varchar2_table(2779) := '1252CAC8269323B656B78C365DF740DFD70B33B2E63A6025AD58DA4BACCC3FE6E11C607CA5EBED409E2B83B205661CC61C2311068B5EABD142340059CB5D02B1245A06736725A1A3F673CA470F47FBAEB8187DB91B4604AE76553F7B9DCE17A47452A5D3';
wwv_flow_api.g_varchar2_table(2780) := '60F6775C2D92BB12C8386BA93FD85C091D30A63E3B6FD382F1EB7996C4ADE354BD9D45B1F61B2D27F3C029BFACAB062634543D8BA656D229833615F50100C3B800914D28B53A91200F02312BFE6378A123AAA070DA469C64BD973878BF4A7FEC7C6BE73F';
wwv_flow_api.g_varchar2_table(2781) := 'FEF8122D74B69EF354F52CD933D8469CC8487B6C2AC2763AAF05696D65E7D86ED81EB8F2BA4E67C9E565E309B20A12CE8FF6539DF54735E5E5A2182F12A658AF5E8F816BBF721889667F79976A7D0FBACD789EC1090449C05C82566F8B86A13515D5629F';
wwv_flow_api.g_varchar2_table(2782) := 'C3B058D82412071384458FBA635EF099A4A0837504FA540C0189A1769E170499FA17022A00630504290F0C39145755B9C5AF3CA0B6A550A2408902250A9428F08FA4401100174418CBC811DB3FA7F6EE1518AD80459F5190D908195D177369C06319FE5E';
wwv_flow_api.g_varchar2_table(2783) := 'F8D0A23038DA614E18A1A7054394B001E7C4BF66E10777970597F23716E4861E2CD468B9D75E03FBF71FD9C257960C7563FBFA7E6D935F59F9A58CFF982880CD4AB5C72228F484F0A21C078CF3182C2635AF6668FEB91DF7C9067C6B2F9C0E1DBED05444';
wwv_flow_api.g_varchar2_table(2784) := 'AB739B063ABB1A067A244A35BCB27FB8383131B34647BC3556C75EF0289538B056021C9E89269C66206B3C90B2659AC9A7AB07DEA5F9919974329ECB1EF5D419CB5A7BD2E9386CC66012174D9A8763A9742499E1A8FD9D482113C3DC46721A8EA873447A';
wwv_flow_api.g_varchar2_table(2785) := '795157EEB639CA764399C8F15E9D39D7D03720508A54FCC865E43B3B3B077A2E53AAE7B8BBE31BE19FFEE7FF870A6D070FA22788EEBC4D1095FCF14F47A26B0FCF1F9D5C0D7A8CD37157EAE9D75503BD67ACEC629C7441DADA3C2072E0B3BE2C640BC441';
wwv_flow_api.g_varchar2_table(2786) := '385CDE006691324B127FF7C9D7D18D6134A4AADC9CE54C12F91C670C198135576E52322ABD8E57C8B47A3EECFB63A90078A7CF054A2C545BF53D1D3DF5EDD7054E3BBDB8B7BA3835B1B244FA16C5AA46FFEA5E3C98E904C8A6E5538C6280199EDD8878EF';
wwv_flow_api.g_varchar2_table(2787) := 'C1F0D8E8D0ECBAD7CE1C32BC0DC45C5B0B0460EB2E9708A685A3E32D42E6A1A3162FD603F67EE2BCF6AB2F4677C7EF984C0E0549B5357B2EF7F5EA5D9DB01BF46461EB8B7BF74D8A5098D318D23E8D569731D7FBF71630024F32927F803101C328F0B948';
wwv_flow_api.g_varchar2_table(2788) := '3225D08FA756BF7EF0A0BA26AB2AF33CABA3FC7F6A3BB4363D323FBF19DA593E4DFDECF57EB2F00F7FF78918DF7BF640FE8F221A6B1D13BB647263C455DB7C118DE06D2423EDEDC1AD3A034017A4000040004944415470E0CB420A15CC1C54D64307980B';
wwv_flow_api.g_varchar2_table(2789) := '14889FFCDD67F9C032C6719DA72C43AA01715F48AC2224B3C1CCAB15D09C7C815420DFE6EE713E117821094AA87715A74F6F52523D1E5EF2FA96A6A766B452C063B2EF858E12C16D5B253460CF3F3AE0F16E1E47EFDE7DB438F960636D4BCB483AB596AB';
wwv_flow_api.g_varchar2_table(2790) := '6DF3AE6C6682DBB444850EE2B1883C4F25E0BD6F0C1D9B965E8DB05FDFFDFA706DD2E42A5350647773ED95C16E63A52798A2EE8FCD8D3C7850D3A5DB594F98EC96722515377B52079B275F5354564690C8942EF61894C625E2D1E4D2E32FEED5AB25D682';
wwv_flow_api.g_varchar2_table(2791) := 'F3B2D3901289FFF8D3E1857B3F0DE6C94CE4C5562F1DE7EEFCF8C78488D9771E80DB3A06EB3E1BF235325EBEACE5FCC5C955382DEC7A777F6D97C5E239FD71DCE8A843A2457FE6EE3FFC574288E124A6BECA914EA28473885ECC1F46ECCC36AB9AE7205C';
wwv_flow_api.g_varchar2_table(2792) := 'F2428998D7DB9BFB442EF5C27318CF6BA9750E76F756D6750752E4A3B1A983CDD5F9B1A76E5D329CB4E7035BA97CD856FBDC82133C4EE433F91849FB7643157A716C4FB87BF7EBF4F1AAC16E85908B3C0100790972FB28F1E0DE2396F5D3BC467E8EA7B2';
wwv_flow_api.g_varchar2_table(2793) := '1A3C5966D6EE988D5F7E7D67FCFEBD7CDC271F39C8DD8ABFE7022CCAADEC84EFDE1B5A9F1E8A67B23333737BDED5B5B1195266FF9E74E073D1BFCB9BF3D1F95DE65ACAAB448112054A14F867430159FE19DC095221AADC64FA5070DC9418BDA8B04A90E7';
wwv_flow_api.g_varchar2_table(2794) := 'D33608D00416057CC110ED9F0D494A0D2D51E0BBA780D5AC867575EFB6B74A5F4D72E7D6A1CAB5B4D6530F265CC315CF45F330A8013650B2053A9907F85C70E9284D7B9FEB44FA007333104BB71BF319CAC96413B7AF774C3C8E6852FE866B6FEEFB2330';
wwv_flow_api.g_varchar2_table(2795) := 'C12A332524A9CCAC332B8C8D5D5709CC6870B122B1EE1A6324445844A1BCA689871827CBD755D4E8796EAD81F6FB7C1E2B2BE9E1B02C2810E1CB6F75337A3752B53737284CEA648178ABDBDE71FBCD709EDD9C9810B98CDA62E4F42A8FD5C8319D4E9BCD';
wwv_flow_api.g_varchar2_table(2796) := '5DE1015E0DA5F2F1A01F129FD8336A680A266CEBCBF4ACC19E08626B8ECC4E03DE821F3B3235FBAE4765206E3D7B2CFFD72B697B6D9DDB1756E8AA2F3EC73520DC8929D317F7A317A3E525C2BBEF8FFBB60D8E5B305173184E8D8F3E7DBBBAC2D840580D';
wwv_flow_api.g_varchar2_table(2797) := 'AA84CE74B8BD56516F838AE0592A9B82D4B4B44153BFA5DA456A5EDC619E688ABCD817363DA7B9D9E9705516F7BBA158CA669604C64A6462EFBFD5B1F855589B0B5EBBDC7BE0CB09B9E393F33249635495D537FAFC3B864CDEA436BD7BBBAFB269B0CE9F';
wwv_flow_api.g_varchar2_table(2798) := '4E1D2E479319BFDFEF5616DADADFC5F985DDA0E02E836FC905C2A964344852B27CBA4E4DB577351FCE8ED934898AEAD7A05C5D536955DB5C6845935DB5B1EAA60247D7061AFC8AF23FBF95B3B5DDB25ECA72A1FB78DB56E3D6EA65CBAFD556DD12DF22F8';
wwv_flow_api.g_varchar2_table(2799) := '7DB566556D79C5D68643153CBEFA7667923247B7F7C01F46291A9E0EC50B4E2AC2E82AF3A9E7786B9001D83E0C8FCF3EF98B8F9A095D15323C0B7635657235BA722B9C5166EC5E0C40F29035FA2684B818072CDFE59D20595833D9DE1549663F101A1B9F';
wwv_flow_api.g_varchar2_table(2800) := 'F9976F9A58A2D56ED3E544C6BFB553566F27E8536976A475B9F506731538A8150D97CF44A68B796270C0A63A747B2E1681EB0A3DADEDE82F3F993EF8AC1D1FC76A3A8CE134AD14B2B76F744E8F441DD27175EF1BDB8741329792AD284B924A6FB2D756FA';
wwv_flow_api.g_varchar2_table(2801) := 'FC3E6521A9B2977DFFED2B8ED6014F2827AC4F07C291A8CFDFE754392F0D20F38E4A838506F827F64309311E947B5C92AC2AA5B16ED0BFB7D8A067CD9EA68E42A4CA61204D0E4C038FABD6B7E833F0818E5BFD6B1BD14B03EF43A8BFAC66AF40C6D1C88E';
wwv_flow_api.g_varchar2_table(2802) := 'CBB58C4E56147735956D4ED349FF9198B33736D9FDCB2A6BE0E88DCB3D47294D26B073520814DE39B83AA86AAE3A8E8B62F6B983B6AC28AD6E870EC61E13FF03C6D573A1CEA25DB67BEAEB52673A0267AF31CBE4EFBE2C76FDAD219E2D2C6FEC58726195';
wwv_flow_api.g_varchar2_table(2803) := 'CE911189E5ADA3C385E1F7848F6846EF34EB9F06F8A3C3759BA31976E4CFB2B8E231B1862A132CA50F36BC70B08581776A54FC2CF6C945ADC3E0B476991D15B8CB8A623418EE72DBA211B15199BFF9DE7B87DEA1A6724659DFBEB3BB5734DBAEA4C84496';
wwv_flow_api.g_varchar2_table(2804) := 'F5FB033495E9797BD0EA2EDB7574FA7D3B6D6EBDBDAAA6793D7DE45BAA7399CD158DDE087B7C1CBC74D5C1EA9D952233AB6D3FF2FB3C3AAEB28E6FBF75D5B7F44422E292E0C15AD0D1D4C09AB864BE707C74448910849775FA1D5AABDD56E9F705A08160';
wwv_flow_api.g_varchar2_table(2805) := 'C25629166DAB7126026907CC645F384079BE35DFCD1D56F55FD131670F7151645CE017BD88E51201D61D61FB14D650F1D6F54CE7EA85EA20323E197ABDFE85E7A5DB12054A142851E00F4581603008C5D297940ECB055EAF371008E0E26234AC7570F35B';
wwv_flow_api.g_varchar2_table(2806) := '5F5F1F0E872B4F545B8B6F63B1D8D6D6169EC0767436975330522E1EC8536A8962894C9422726A63B94471F02480F5707B7B1B76A42F5D7A4E01E6B494E23AFC02FBF7E421648CA02B4B3735C907AEFFA8002D29B856929D03FD6E01F6B70A3E9F2CB1FC';
wwv_flow_api.g_varchar2_table(2807) := '7C4D6423CC2C5B343A75B104F939CFC386F3C587BFC9358C39CB9AC37ABDB8B202F3CB944E0743CDF9C949087EC390959C832441B7196E8D64BF50279B303C939D1E2F2E22C2997C386C4DA30EDCE020EA26EB4ECFCFC396D5A9C2307A349582356C98CE';
wwv_flow_api.g_varchar2_table(2808) := '46E5E18119459CE5568844E0140A7942591A8E88C19947E6B0712D17FDD200774A30C12D3BB5FA96201BAF8619B3588CAEAF2FDA03FB9688FFC8C730A90D0FD2BF51E6185D2F8CB79332611E1CC20C30390EE0085983B3EE835530717F1FE6D38AAAD7E8';
wwv_flow_api.g_varchar2_table(2809) := '02D9FBF4CA0A0C77BF301E900DA81B8F63C7FFAD011EA9E113E8DBF60FDF960C7BFFA1D9B5F8DAF8FBB7AE913AF759346CFAE1F686E314D9544EA1847C2236F3E72199CAF38C405F70BC817748428A1978EA28C6030026B3302D4C19754A28EC06831115';
wwv_flow_api.g_varchar2_table(2810) := '9563F4B647A333A9632FBC06B16261B0BB4EEB6A16B229050F004C862371683D406B536B32C26D11CB81F94CE6F370204446A3195148E9C067546823210C24C16C54339CECBB087B271EBE8F0856CA273885FC2407694EB2009F47B0EC9583A394428EC0';
wwv_flow_api.g_varchar2_table(2811) := 'F201DF6604F1F420B9393D04DF4AE82B37CFD55DEDCFC826D505354B6B4C30EF7C0A4B90C993E5DDBD9987EFBED6A9B2CBC8E16248C1FB889879C18D1022809899441A3687D0BA8BF12F5EC370F49D07C36C74F3DD0FBF47D0DAFB8B07F1C987AFBFD9A5';
wwv_flow_api.g_varchar2_table(2812) := '71C823FCAB890362EFF31BAFDDE60CB218763100DA49D90C0B01C81CC88E4389E7324F65F21C29C080D8B3E8F27FF8E681A53D562937196D894453422E89B169D07034AF07B852D159DE6479F06029195D077921757EA5CD499A2F655331900D6E5DE072';
wwv_flow_api.g_varchar2_table(2813) := '05FE585034F6A7D91C8E2C620A9A309861039C46E6222C20A81413F3FEBDB549D924BF44B4B91857DBAD7030AA51121ABD399785833A789392AB9A11A458244C4B82D96A4AE74888F1C0923F92405E995168D0288E8234B1025E64A2913021E60D7074C7';
wwv_flow_api.g_varchar2_table(2814) := '6B62A110CF487A9379713FB1363E4CD13938E3A9B4F09597FA0AE85F82D2A9394E2523E7620093F6DE831936397BEBF57748D58984F1B357F81FCF080A21CD6964D8763160D0E63349D99F93CC2AFED5015DF693AFA75B85A9EE77FE12D5BF37362BEE2D';
wwv_flow_api.g_varchar2_table(2815) := 'BC7DEB3AA52D87D8C217234B66FFC2E5F75F27B8735E5F3E5FA0E0D08BE3C46C0A8EBBCEC6150A4077245359780A2B8A0D9F15991709AA90A14FA60F0652E8384652594A224C469D482B0281B08ECDE755B6FB8FC7C9D83EC49355A2D83FD89EE36D4226';
wwv_flow_api.g_varchar2_table(2816) := 'C1B32454E2397063191EF0359BCEA6B219219BD1B0B4DA240BE4C3AD0E4B08305B75677627B5350D76224064579543D3D49B8E048C6A96D3183339010487032DC44F64F2896858A3A034064B3A9B51C29514C542F21D2E7F6896CBA472F80AA1308816C7';
wwv_flow_api.g_varchar2_table(2817) := 'B1AAA3678D9A0CC123898A2CA82DB6E1B1ADD0C12C29FB4693BA6AF5D0862DE4B230EB61D6AB6985E6ACC9E19CF4F5979375B4B7FDEDF72FDA9647045029914CAB39927AB69E9CA582A0BB9081DF29AC33DFDA655B91FC9DCFBF7CAB8CAA78FDEDE31CF9';
wwv_flow_api.g_varchar2_table(2818) := 'E0CE904773D07DE503080F43B2E3B38FE71CBAB9FEABEF11DC399E4AE544250D47585C21936565FF49E701633583CAA8D98BB6A9F11A6B0BFC2252ACBCFF01988F84230C213080692643BA40C70247662DBF9351CF8F7E4D029A4A6419CFB40E7425E046';
wwv_flow_api.g_varchar2_table(2819) := '0AD2FE663D4E4C701E27C48366BD8AE675A1785A48C60C5A9E53EB01DAE3C180C9C0D39C26073DF0485812723AA582D7197082160C8638316F34EB4986CF64B147220E52F4D8C8632613C1C9884192FA5E1B481494187BB07DC0EBCC91688C2C60952035';
wwv_flow_api.g_varchar2_table(2820) := '6623FCC96D79BD38CF7AC176297A0A16A69A9B9B1F3F7E0C400AF793B855C2EFD949C01E0F06985958033DB1085D34508A1D9DBC743CFBE4152F9E5B9BCE4958BA2A51A0448112054A14F80D2880B5187801DB7DF84352C039649ACA0B518E65B1D673D8';
wwv_flow_api.g_varchar2_table(2821) := '937119F8CCC3428C0517C78867EBEF0B19CB8E7F7D3E5904FA42806B5C582486A22C1CD2E2E37CE1CD6F770948063CF3BB03E0C2DE1E70E037DDE18AF021A4D5BE08804196B1B1A24DACDFAEBAD8E0CFCD01C2159696720F1E287FF84342ABCD7DFE39E8';
wwv_flow_api.g_varchar2_table(2822) := '9C5D5D85D16614048200AFC2F3131C142BFFEDBF95FD15C7E3F97BF7647753A110FC1E41F319283A3736068890A369189186C72680C3CCA79FAAFEDDBF03BA863D6A78F785D56B6D4D8D04479A30C7150CE6E271FE073F9037821B1B80C7C07B8AD7FF7F';
wwv_flow_api.g_varchar2_table(2823) := 'F6DE3B38F223BBF37CE50D0AA80250F0DEDB6E34DA3BFAE10C3943EE489A3869674E3A69157171EB22766337EEFEBA8B50C4DDFFBBB7DADBD8D0C649A7D54A1A69569CE170487637D9BE816E34BCF7DE7B5700CAD77DB27E40016D8743B2C93195D12C66';
wwv_flow_api.g_varchar2_table(2824) := 'A579F9F2E5AF7EC86FBE97EFBD462FFC75FBDE7FFFB300602E7A03719E39DF286E5761968FEE319FD9FA735520261547F1E727DF279F10F04945873E9AE0B0AD8D474505499E9B03CFDB7EF003EA41C544BA20E32758D4B7BF0D740F6F6FFB3EFC10B04D';
wwv_flow_api.g_varchar2_table(2825) := '0C67247694C68BCB836BF12333C3C6D77CB83165381CFF08EE9370CFC656FD89A430DE1396CCAACB814B277AB8C1BD47EE88A6A7AA531B766FD919A9013BC0565D153427B8B8AA66B0DAA9A277AA0B7CB20F5188BB412162E727AFA8A532E27E5546C621';
wwv_flow_api.g_varchar2_table(2826) := 'D2A081358A6CD5B63DBAB7A6C4421CDD83040C3ECA46AADD18CECB651FCF03936A3438EC092A6AF1130922E92E47F56B17EC19C54F548A9D2DA73C222EAD0D232580FF9E9B8C7AA9C8CBCCC3D9B2414D27C79590F9AD8B8E74A544229DAACD5AB19FD15B';
wwv_flow_api.g_varchar2_table(2827) := '944062495D778D7A3F5501729F4878057B722DD40DC028FAA539BD939D103CA4999EA670231708B33393FDCE7C4E6D50085A129DF644ABF0EF486268603023388F441085B8D1AE9AA525DB0D85F95CF9459F9E986CB098B84DB2BF3466E0F24102B45BDD';
wwv_flow_api.g_varchar2_table(2828) := 'FBB1A3886BAB71A2AE2347D72B3629746FE907CD68644B57C88D946C371514E4EAB0EA8E48AAC394E24890C4A79C00C26A455E6A61DA379E44BF1049B4B264FBCF4F94EAFE070FADC97EA86C3F5A15CB43F944416A59FA5B68D79855517A4A41D94BA05F';
wwv_flow_api.g_varchar2_table(2829) := '1A98F572AEB6783B8987F811C8C4E9259534786C292961DE8E47F19536900A577CA043269B165D23AD8AAF1984B4011606253F2B4DE7E232B5DE120E13A437313181B5D19A699F0C6CB3113E167E0ED11D51B235AD664E8AC31F2E50E774E1882D053772';
wwv_flow_api.g_varchar2_table(2830) := 'FAA48CFDC04204D98ED171584D0EEB7E39B04B2B37A99F12FFC47AF093B1990DB6F4FD1587898434B564FCB27071E53017A8A72A12494CB6399D48FE29C2B7E8A5AE34ADB4986B4A8FFF6A9052E291472EC618195CC79B89BBFBDC9468D65FAC2FCD2BE0';
wwv_flow_api.g_varchar2_table(2831) := '1C4467D34B7D6976096EA2A2576791CB9957CBFD8BDC7B7EE4876FE7FC207A0FCAF0C4EAF0AC3EF5771D7DB7288190F0BDA5AD91F69533435B343A6362245490C74D74E5A420C9C8EEC3919074B85E29BC48EDFB5609298936E15F34590D623D78FEE12B';
wwv_flow_api.g_varchar2_table(2832) := '2D55ADBE96B0E2CE3CF233B15AD42C124CE1C2DC4C7D2089172BA22116B1DB72287377CAE1EF05C1BED074F80CBDD061E2C4E312884B202E815F4B0968377B3971E42412FD0FCA51D02F0791E8B8B09BDC585FE7E891134A4E25B596478540B85A700590';
wwv_flow_api.g_varchar2_table(2833) := '1267C8FE5BB7ACBFFFFBA0BB607B3BAE29808EDE7FF807F089F5777E072F5628D9506F06474600C91A4E06D6FA9B9A500B9B016900C2D15128D39238BA10412F07842300127F25F529292AE412D80625DEE2A28930BF5125365A17102678C9F2C61B201C';
wwv_flow_api.g_varchar2_table(2834) := '14A42A9AEE2BAF84969715F8E12A5D5515318469CC655DBA07FBFB094A04560F34348030CD2FBF8CDB6A220F0335018764980E5173F1F08C5616F618147E7C9F7E2A04523A71823CDA54C8E2B31A8F5CE80FD1E2A2DD85385093B1020F1F92876D46476D';
wwv_flow_api.g_varchar2_table(2835) := '1B595C147413BBBBFCD1C6F135C075F7CFFE8C5E0A69EB74662E0FA39DF8F7FF1E452573E4B000D598EDDD7777FFFAAFE1814050A1DE5E636E2EE3EEFDE55F2A9887E6ED9D7776FFCB7F01C6AB104AA815EC762034BC3117E209835DBD3FF909CD389646';
wwv_flow_api.g_varchar2_table(2836) := 'D470A839D046F2FC190E0C0E0298E9A5664D5C65C24A656511C52A88723E3D1D07DD817EA2986EB2942A2E54384C63289B2E5E44078E04408CC49AA2171A69E5E21B6FE47A3D31964198442DC635B7E2AAB494B92B005F58A8043B3F8F4C0843C5A22334';
wwv_flow_api.g_varchar2_table(2837) := '34B1A653A768AF46292CD49EA2D0F83842566B4A24ADF676A4C76211B4098110599A5A451CCD3F331A194173CB5A236A4A08E9E4F9D33F7584C338005741A159416256A5A5817B09C1C5C56C625E07BBBA0251D0CB58C4493666661ACF9CD9FBCFFF19BF';
wwv_flow_api.g_varchar2_table(2838) := '65F86FE3C1636A68B351BAE1AF5BE3E72BF84CB61993ABCBBF82811882DD5B75097A66FEC5122AABAF2EE5BA4CB9AEEA47C77B3A03C599E007FE3DBDF6510ABFC0371CB8579615463B28CA65F8D156D8607F9414ABA454D7C46AA39917F5C156B5AAE2D0';
wwv_flow_api.g_varchar2_table(2839) := 'EDD3E718B420C75190A3711B63F24B161774B3922D59C92C1908620C1F5E22CDB1C18E66CC12292D0180551C2DFC52F20AA755E46BA4787396173E62F893EEB4A41FABFC5206FAB944EC4639515128C2BFCF99AA7253847F2F32F16E2F2D6221F6CF2F9E';
wwv_flow_api.g_varchar2_table(2840) := '3314AEDFCA08D5F30252AADD907A70F6CDA5014779C9D141725C1671D51D2D7971F9B40443DAB1C77E235FFE682EABBEFEAB7A873F9FFB38007EBE7CE2B57109C4251097C0F324C0B131D5205E802EAA60BE0274B1BA21819728A156CBD3804C8C16ED40';
wwv_flow_api.g_varchar2_table(2841) := 'BF4A378B4A10D4B7BEAE9487D8F0118C776343156E6F134D4E219CE96994964A0587FAC8AFBCCE80641476DDD909D3FECE1DF4A2DE0F3F04C7027502805EFC69E5E703C914DA214430D692160BCA3AEF8F7F0C3643BF9AF0AFFF35902CD8D40422C5D258';
wwv_flow_api.g_varchar2_table(2842) := '6169A20DC339381C54B3B7079AE2F837383C0CEE0A82A38A8AD4BD228C845F7A89E84DC024465498F9EE5D8887272775757581A626CA61C07FF5AAED8FFF18C84AE860A54D1D19019363816C7EEB2DF4A846A05A4B0BE831D8D9E96F6D45796B359998A0';
wwv_flow_api.g_varchar2_table(2843) := '02CF93930A06F7F4109708B46C3A7F1E224A5C9108C1870995AC773AF5A03B703E2A26105A4F0FD4A04009104E5F5C0C59A50D5E5E1600F0CA0ACA4975B88002BCAB8B184EF08C71326052C546E288E1D557BD57AFB25E744119A4A03EE39ACD60454A94';
wwv_flow_api.g_varchar2_table(2844) := '653507185EAFEFEA55E3BFFC97B2B585DDB23A5CC8CDF5FDEC67EAA4E09BDF5472BB7307C04963FFC71F1BD8C4B0401E0F134108AC5DC4E35133BA770F3CCF4E0B491AF3F2688F04E09905356667B370B6DFFD5DDF8D1BF6FCFCC8C2829AB2C9E47BEF3D';
wwv_flow_api.g_varchar2_table(2845) := '1559ABA7C7F2BDEF29E5736DADBFAB0B522C22F60634405C605DF5A8449F1CC44BD4419600110156915E8005753842F7EE210466116C69B17CF7BB110E5C1A1A647737E15FFC0B66841697C62872C98477766CDFFB5E0041151571C480B4595FC40B9F24';
wwv_flow_api.g_varchar2_table(2846) := 'CE4488930C72C6EC9CA70EE1330BD4E374D71AFCEA7FE258683506ED9E361D7EE68344FF798E29E3D37AC5CB7E3325805DF04391F1A80EF5A912E0717A59E47F7F6A5DBC302E81B804BE0209C401F05720E4F8107109C425F0EB29018012D780DBB8417A';
wwv_flow_api.g_varchar2_table(2847) := 'E0E00A4045D2BE6A79F03049CB971C095F043C066E0174D17302F02267CE986A6AD0D91219D8BFB101EEE54A2A4192742E57046DDEE8283A3782D96AE6BBEAFA656FAF1D60E6F7EFFCA7FF6479F34D90AAB1BE1E440ABA035BA2C7A381EDB77E4B979C0C';
wwv_flow_api.g_varchar2_table(2848) := '3A523AC0810145F3F469800DBDD87F8176D067A24E04E8A257B4FDC11F60E1ECBB7205D88356137522D0C8F2FDEFEFFEC7FFA8EE21478D9F61191359FB3FFFE7684D5193629E0D4BBB2B2B0AF4AFAE420AD5EBEE5FFD15D01D95A6F5ADB7500EA36CD47B';
wwv_flow_api.g_varchar2_table(2849) := 'BD803D0C6E81DFE046456D7010FDAA524483E7753A90E7CEBFFB77F67FFB6F3948084F4C587FFBB7F71F97A8AB49A861050DE634969541168180F0D142F3A92218837835ABE3DD5D7A215214920A2522F3E8618152C96A2540695A82F0D1FAD24C73CA0D';
wwv_flow_api.g_varchar2_table(2850) := 'CAF5FB41C8C07E13D75901C09D9D4A491BBDE78CA534925479ACF45E7FDD6FB1845174CFCD59DE7D978553D7924B4B41CE806D34D5B6CB97610F6B788028C70AC81054C9BA2BBC0D93C4E220803342C011D0C60676E3C69C1CCB77BE13FC0FFF01440A68';
wwv_flow_api.g_varchar2_table(2851) := '677DD5F560967E6C4C5D6F3E770EAC0EEA66A5CCDFF846F8673F630539B060CA9C6BA09166C595BAB8A606F37AEFF5EBB67FF5AFBC3FFA11AB009A45BC4C90A5E1C883950D7BBD7AA225E7E7B31C30EC45259E9CCC62595F7FDD77ED1AE245B03C84EA3C';
wwv_flow_api.g_varchar2_table(2852) := '05ABEFB7DEE2C4018C8DE100BAE57D19320DAF17F1EA112679AC1B889F71F0CCFF5AFCB641BF7FCAEDCB672316204D6F14007394114F71093C47023C213C2D2B58A83CA7D151A3DFE7368B57C6251097C00B91401C00BF10B1C689C6251097C06F8204B0';
wwv_flow_api.g_varchar2_table(2853) := '7CC639167EB34086DA7C4107B1891FCD8310F180E53E88FAABDA44811FE0D3DFDC0CEA08A3395C5840A7A72F2850F12DB930EC72A13E35D005EA0909009BC0C000B80B6363435A1AB80EE355A51D2D2C04A181B230F4E5A62B7A4265928A852A1815D89C';
wwv_flow_api.g_varchar2_table(2854) := '9CACF00C4832AA3E05C0E0230A4D2FD80C0A9052C006BD25A0666060DF88D768D49795E9939351A86AF6C64023F4A2E637DFC43C5891057DA155E6EA2C389C5E1E0F930711A16545F7885533AA4E0C8C31940D37362AE5248D419B88281452ED7777F5B8';
wwv_flow_api.g_varchar2_table(2855) := '807238948BAC8C0C6A2188761138A734D2C9C98A672DA9FB7AB89FF1A31AD5A3D4EDEB0BADAF077FF21320BAFFFA756CBF81F4F083BA155367C09E3F3D5D18D7E9C49A1AE08D8A1BCE95EAB2B434D0D10108075EC2157D2D6FBFCD08E076B8E2F6356A5E';
wwv_flow_api.g_varchar2_table(2856) := 'DC3B814B95592F90353F5F311CAD0597AA0CAA7C7029A6C2285451E963571C0A29544F74651A84424A5C20C6D95924893E9939320B8656D6C2361B0A55403E235285DE587541EF0D5A6605991D8B9592E243E91A759185E696A5512B5558083F1C8E202B';
wwv_flow_api.g_varchar2_table(2857) := '74C898C42B7165AA5B58D06444882073C1283A2545F9A642198EFB49D69A59ECECA805E55020CA000F15B3E0C883E315EE3CAB0706A5F7D818E2E21F581AC52FFCA887841313303FCF0C97CF1716224B4B4C539F9D8DD61ADC6BC4D67D76169C6FD2C24A';
wwv_flow_api.g_varchar2_table(2858) := '23995F93B426F29751D0B2FF437E625A2C3BC61787BFEE271AC40BE212F88524F0AC27ED1722126F1C97405C029F53025F03006647E3D9F3867C1C274712AC26B3ED29EE199E3F1B6F586E3FEC3B9F1370E67D4596F1CFE7275E1B97405C02BF9912C0BB';
wwv_flow_api.g_varchar2_table(2859) := '556565E56774668B974247D482F750563E1F88917B9E005A8007F847DDF3DCDA02CE013900B468714168C6E26274744050F0B0C2C640562C842F5D0A0D0DED5F2E452387BB2CB801FDA2573E750AEC6A361A417DFACD4D1C1D03A5304846B9AA3039C006';
wwv_flow_api.g_varchar2_table(2860) := 'DD5D2080C25359BA6E6D613B1D292F8738EA65EC5AD1FB296A0E87520C12C9F1C40994C67C0565411C2B6885573D1E756B14EC0A4B19193A2E8802BDD0D35A2CCA6732CE814F9DA2B19A0598CAED46D50CA64215497B9A2135602D96CF142A96C261FB3F';
wwv_flow_api.g_varchar2_table(2861) := 'FB67E89603E8A88FC446C662196C06A2C609B6C2C6763B1798BD1F7D84ADB82E3B1BBDABDEE35137573D1EF4990AC20D0F2B3FCFF87C9E9D457FEE5D5840710D74840D90331344B5CB2C8218F1AAF3079DF9F4698515B7B60081A1D5551DEAD6B535053B';
wwv_flow_api.g_varchar2_table(2862) := 'D1730683CA417462A2BAC7CBB867CE84C7C7E985D61A975AAC9ABAC97CE20425986A2BF57BD43DB502A508B6B2124DBE02A2361B5FC1A50670E3C404041955A15F9024379FE7E6908606C261927BBF0AEE9695A1A4E552B1B652A068F851E372FB7A63C3';
wwv_flow_api.g_varchar2_table(2863) := '74F9B2922A0713180EB0341899272440106AEA6B450587264062B50468AAB99E8D19736929F2D78E1BB0B8E6814109AF3D36005D0652FA675845F53D38C8BAA878D17B7B9CCBB028E66F7D8B230F0E38B04D407A982170011825B3D2C92340D61A2385C7';
wwv_flow_api.g_varchar2_table(2864) := 'DC6851F12B9940B6782F7BB603B35FC949C599FE6596401C00FF32AF4E9CB75F7F0928C7DF4FCE3256484659EF4513467D1C8293BE6018A4EDA0FC3F3FBA91B8D822E644B74DBEF58D575C7955FC317D928D6795AC07E49FFF9FFFEFFFF5B2A7E41BFF6A';
wwv_flow_api.g_varchar2_table(2865) := '7E6133D51E3427EDFB767B569778795C027109C425F0A58741FA8222451908AA515E8B1313D1CA823D8055E0227014A80F60C36D526EAE9201E770ED937BC2604E8007CDC027D42A1D20EA4A4C67D118836C09C3C3055D947E403834B451E367A533A4D6';
wwv_flow_api.g_varchar2_table(2866) := '6E07C70277A1ACAC67C1AB8C3535455FA023C6B76A5C148F682F71230C48C36A17EFD30E07F8109AE02E40A69A2F97810FC6852546C44E9B8E50803158051DA1E655E6C4108932A918B65A8318EEDEBD8BB536A00E4886E653691AC36135C1A8BA1BFB5B';
wwv_flow_api.g_varchar2_table(2867) := '65FA0B928C7A916528D498403565C01C751FA5C070D4511333652ED83983BE80823463CAB451519A9006D6B951FDB66A830F2D949F70B5B90971F49FAA767353D951431F956F52128A4D864677AA4D592D07509FDAED6D35101273B95829A5D445599A91';
wwv_flow_api.g_varchar2_table(2868) := 'A1A6CC4106177151D8E2940BFCAF79EA46E61812731881601191DFAFAD1D8A7D450113F19C1C785697A597966CBFFFFBAABBC7E36B6C04AB336BD6429D3B389D6AA5A20F06179E99AF32DBB658381D5036ED38A9E6C138484AF78EACF83BCD4AB1047CC5';
wwv_flow_api.g_varchar2_table(2869) := 'C13586DF6633A3807E31E7B6FDE37FCCFAAA05C57E1B81B0B8688FA30EB1144B387CE6B96216981B4C4D294FD7C807C7D72C0DB81DF532C2410228F3A3DCF20C287E903C93453FCF88640ECC1F0EF8521CBD883048E38B5B6BB363267DB8A634D763726F';
wwv_flow_api.g_varchar2_table(2870) := 'CF2F866DFA2C87DE948003D5C334B5BA9510DE0AEE84330A32A29126F7AB7602B2BD3C15D127B82C215BF2BEDB58AD6E69B5CB107C6D37B4969B2EEBDB84CF8DF9B895E54D49B3EFBB2EDE5C179B919DCBE1589F25C7F5E2AD4521C28B169E69711397CE';
wwv_flow_api.g_varchar2_table(2871) := '624CF82C5DBFCC367B41E91F924CBD647F795E90880464C191EF81C506ECA2251FE8119749F2393DC3C9EF13696547128262C363D7E74ACCC2BB29CAAE452F4333E25B92CA12D934C9FA8094D63C16C5F6F101563DB23C2CE5D5AAD98A47C68625CB2979';
wwv_flow_api.g_varchar2_table(2872) := '3CE322C3BD92EB9624DC6C89CCAC4A70560A6BF7F99F5816C2D14483041F12C4C479685232F49292475019595B54F19E784C12D36578568CBB5254FA945D2DCA9B912E29CE176B8A4C4FBD634BF80B43C8939A5E784857647D2FE4DD9C89846CEE243D7B';
wwv_flow_api.g_varchar2_table(2873) := 'E45815AEC0A7171713706AEDDB73E6160C4F2D6D2F4D67B9F439C5355EBD79B46BA230DB90E0CEA3FDE8FCDACEFC4855698E2949599D68898DFEE8C4EAE6EA94C5A4ABAE289C580DE6397CDBC6ACC0F2744641CEE25624BC3291555CE417E3C8E08C7767';
wwv_flow_api.g_varchar2_table(2874) := 'D96631545594AEEE869D06AF31E1900D8DDA4E50468706837B9E9C247B4659E5E4B2677562A0283D39A9A074756D3D3DC9BAA3B30557169D19E9B3EB5ECBF6BC3BBFD01794EDB575773AAF2FE51E7C7A7577617224C31ECA2FAF5EF2887E6FD1EFB56465';
wwv_flow_api.g_varchar2_table(2875) := 'DB75A6C35F17FE3396A69671876C0CF9533338F23B7C9E56B6FDE1ADD53D83E43A2D06DBA1A32C96727E72496FC76BB9C79956B0B8BA630C6EEF86227919AEC51DC3CAF4484D59CED17842FBD211E99F5A4B082CE697944FCE79EC465F20B49B9D8EF3F3';
wwv_flow_api.g_varchar2_table(2876) := '43F77E3C784BCB73569DC9610C24B8B3631DC92CAEEF1AFCAB01AF292BCF35B1125C9D1E7258C2E565A53A8B6B78C963DC98282A29C3F3F6DC867761B4A73CCFE548E7E1D84F04C55D5F59C9CD74717B676A652BD114999C9E0B7B77F35312538ACB7AC6';
wwv_flow_api.g_varchar2_table(2877) := '97422B5330EFCE2F5DDD93C9E13E7BC857595D3CB1635D9D1A3446822539A909E98523B32B3BB3631525B9FEA4CCCDE9D1FCA2FC658FCEA9DB343B0E5F8C9EBD60786F332985DFAA7EC31B1EE5E43AE0C9769A538BAB36A73652F35DB34BDB6E5B60C96F';
wwv_flow_api.g_varchar2_table(2878) := '5B9A1C24A45B59794124D1BD36B94034EF040924A6AA23572DF12C2D2E6F1B233B7B81485E66F2E1BB12A3FF60646D6641EC46B7C9674B7EC401DBCCFA9E25B812DC91ACBCD4759F39B0BAE8359972930C5E73EAC0F06875A6D99AAC9EDEA389507998D7';
wwv_flow_api.g_varchar2_table(2879) := 'BDB83048863FF9933F393ADE9379FE92C5520C096B6098C64947FE181FED4B17CED7710C73B450CBAF05E4FFF8BFFFFE98BEDF9E5971B363C6B17CB3FCD46BF8F826AED4F6FA0A21C2F446F5CCAD7BBC5BAB2B263DD1C9AC5BEBDB665CA91B8C9BBB8188';
wwv_flow_api.g_varchar2_table(2880) := 'D7E33759FEF2C777DF2EF084334FFFD55F5F757A479252B34C363B5D3657578C44995311117E0144FD2493F192B804E212F8F59300EF5376F5CF99176F2D22FAEE02759ED8D3E3C6191B66E29FBB7EF1C0B6CF1A11C0A3C02AB8911716EA53F08FD9AC4A';
wwv_flow_api.g_varchar2_table(2881) := 'C0B7513BD57DB88BD69706A0AF68156D14E4C0A71686AF5AAC759033409136601B10328A47000FAA42A0A6CB054ADCAF05504101F07650A2DC4AE1541980AD8DABB99882146ABD68A1A269B16874C8AB7464DC7D96A2C329AEA283F2DE5716C29A00A33C';
wwv_flow_api.g_varchar2_table(2882) := 'A8A9D1064068B7A34F56B323E17A2A6A36ACC1630A94321CC5E6118DA2A2195D2FC5039CA3ED8CCA81E9A8BEA9A97CAAD945096A6D5477164F1329F365A71CE504AED44CA116FDCBA41880147FA1F80A8A3EA0063254AC6AB5513CAFBED2264A4A898E5E';
wwv_flow_api.g_varchar2_table(2883) := '94685CC5960F8767D11129D7448DD815C3566B8C73A586059D6E6CA8D30134FCC0666882B40301AAD452B270084A5B478D32D832BA0A84C154D6CB3535B1A0C7FB1C6A323F185D13179FCAF71AE6CD5E2FC60528EA957CA2525523F23C300B66C48AF3F0';
wwv_flow_api.g_varchar2_table(2884) := '90D1C64A4850C2D7E6158DEAAC444782B8265E9A45850987FB93A52FB37EE297A2F1C641B99679EA277B09787CD6FEE1A95D28FCD9ED21DF4A2736E6F999AE810D73EF4FAF7778572A4C4BD6D447FCA6FEB7C621C35AD7F0DDAEB2B3C5DE2D9DC9AA0F46';
wwv_flow_api.g_varchar2_table(2885) := 'F401DFEEC4B6A1F7DEDF4CCCE89376275DF965BE60D88F729B683D3ADDADFBE39B137F766F3874AA54DAF0BCB62B21405A82AC6CCAD506490E287843ECD6C69B0A711183892D06D12F57316627A4AF4DB9455E5814CF9624F0D344831E90C09E442322A9';
wwv_flow_api.g_varchar2_table(2886) := 'A98CAEC974B7E412C1C7209EB0B4DE90C22CD9D3CB126ECE7DCA083D18168F4F5123FC8DC1241EBF2C2F081E9801975B6B62B5C9F69E847D870435F92C6DC8D6AA8A451231A811D7D7C4E7513C6FFB64795121512D3ED19A47D69755081CBF411E0EC8CA';
wwv_flow_api.g_varchar2_table(2887) := '7529BFC4432C5B3EC50061578E6CF235C24284E365A6899DBE450863BCBA22C4310DE9647B4702BB58F0A99839446005F8353D902C5E36A00DAFAC2D117249024669E996B9D628CE34CBAE4F161684D8C6EA57A55391A51EDE1537AF0AA71A7DC7234462';
wwv_flow_api.g_varchar2_table(2888) := '0AEB08A34ABC50219E0AD3F785657141F41CE3D8658D13074C5EC2B2B3A9E440EA9F90DD31492B908DA03CF848F505B86E18A4FB81F8D624B340457886FFED55215CEED180D0EB7EE96995071F4B6D85189CD23321134332D127F9B932B324F76E887543';
wwv_flow_api.g_varchar2_table(2889) := 'B22A657E4B3ABA64E823A9BDA89672C527EFFD7705B9B18689C0A7470C84A4314ACFACB4B4497852F26B64C92B4DD7656159645632CAA56F4EBA1F0A38CB147DCFEDCB34FABF8E05996C90823C0927C995BF72AD1B4F6F8DDEC92B3FBBB7EB5B5ADF34F8';
wwv_flow_api.g_varchar2_table(2890) := '76CCB6848773BE918E8FC60737B26D2BF6F46222BE06F7764C66F35E48F7C34FEF86B7D7365A1BD3EACF7E70BD29B439DEDD3F9B95AC9B9D0F37DC6C73F9A7D34AAB2657BC5DB71BD6BCABF3739345799811EDBFCDF8355EFB9BD66078021BCC9C1CF77B';
wwv_flow_api.g_varchar2_table(2891) := '1F74679AC6BBF6F2361EFE7D7E6D6D63CBD2F4D09DB2FCB480C5D9DE377DEFF68729C6BDC292D2FB43D3E9FE114B4AF1D159909FD88AB47FF2E704C74AD2CB4E62E6FDAB3777771667C76692DC896D83936569C6C99073F6EE8DAC8AF26B9D737B1DD773';
wwv_flow_api.g_varchar2_table(2892) := '2BCB57F68C1DF75A4A2BC0D2D6A5DDF0ED074DBEAD256B7837232FFF66FFC6F6D8879D8D5BD59506BDED10B3616772EBAF6F2FEAB656C7BAB28A2B43019FD168269E6D24E06F1BDB9A7FD8D0B8387B2269D7E8CADFF182EE08D46CA1CBA7FFF5E6986EC7';
wwv_flow_api.g_varchar2_table(2893) := '387B2FBBE4CCAD86F1ADA9EE7B4393674A92167CF65B0D4D85C6593B8BF4686295EFDFF938C9184ACBC9FFE01F7A773C934343F76BCA4BBD61DBD6CECED6DAB2C36E9ADB33FDECE627BB4B1BA6A5BED49263440AF26C792C661D0FD9271D137BD39FF4DC';
wwv_flow_api.g_varchar2_table(2894) := '5BABA94FFDB07DD937797F6871CFE15BF6266434740DF7B4DF3B539DBB1671B65C6FDADA9B1D9A9C2ACB74EAADFB27408417BE7DEB764D8E75D79C7CE383BBC144FDF0839F0971BEF9F9A5E6FCD76B0FAC5B53D3235319B919AD9DFD9B8BA3A15D6F417E';
wwv_flow_api.g_varchar2_table(2895) := 'FAF896E1D6B57B3B13DD45C55973BEC4B69B37B73D1BDBF3133BA6C46B3FBD72BADA7977DA94BED9623B82B4C7E63D8BC31D59059C8918377CE13B6D7DFD576F1617D94CD9255D3F6C319739FB9BBBB233EC7787E677461A75111B51C7D62CCEE6BFBE3A';
wwv_flow_api.g_varchar2_table(2896) := '6EF01A16FA320A0FBD4303806FDC18DC581C7A3830525F964EE86C824E858904BDE59B0F869AFFEE7A6F683B6BABCD99578F94B6B73CD6A894FEAE6D2E34FF60E0CE40755D5AC7AC79FA934F1AD6374FD8577CCEA25B1D43E6FEAECC9A0AFEDE1C5D19FE';
wwv_flow_api.g_varchar2_table(2897) := '46B01FDBE1809BADC5A30973B7B4B4B4E9E969D0A816F257FBA49C3D9EF6492F2DF1972A9634327C25F338D147877821DF909D2D14FEEE6BF53FF8FE3F3655BC32D0719B3B5E2D430B573FBE72EDC6ED1B1F7EE0F3CC774FAE7FF8FE4FAF5FBFDE7FEFDE';
wwv_flow_api.g_varchar2_table(2898) := '5AC4FFF77FF19167BE0B6E7ED232D5FAF18FCC7AEE4CE9834663CBE0FCFBEF7FF4E9D58F17FA3BDB27963F7CFF67D7AE5FEF7C785BC2CA5D473CC5251097405C027109FC9248007C859BAE5F1266BE2E36D03C5B5E7D55B358D6783062B39DFD883EE129';
wwv_flow_api.g_varchar2_table(2899) := 'BC11CA181F69D8277FC6C45EA0B69668469677DED14E0D3E53BF6740D9CFD4F72B693431B5B6B13CB3E3D90E077D8670D8AA27C2ABDDF80480D3EB70896DB524D80311C383A6A1C8EEDCCC7A707CA0531709025C6D46B33E1A07B57F71EF3EE6F411F6CC';
wwv_flow_api.g_varchar2_table(2900) := '6220B4B041A707CBE964605A1A9AE4D35BB2302DC353D2785F5A9B64694C2656A5B1499AEECBC4806C7BE5FA0D697F2837EE8A6F4386D6E4FE0DE9ED16F41BA4B65969BAB12F11B071F7802472ED3A7AE10CF56064550C406B8F343F94FB0DB2392F93EB';
wwv_flow_api.g_varchar2_table(2901) := 'F2C90D79D8269D3715BC6CEF94870FA5F9BE78B6A5F981AC4CC8F51ED99CDD27A8FD6F60591A1E4853AB74B62BACFEE903E968949B8DB2BE288B5BF2A055EE35CAEEB22C7AE4FE7D696F95ED45B11B044BF9B5490544B7FDD2D4270F5AE4D63DF16F3D42';
wwv_flow_api.g_varchar2_table(2902) := '190DEDDDFBD2DC2C6BF332BB21F71AE461B30C34088AD0AB3F93F73F94EB1FCB74BFEA32B921DBC36273C9D0A2DCB8294DEDD2735B2C2129AF952D8F04BDC2F697515AEEC9D4E8BE83ED854DC58035493C2169EB94FB0F64B25FE6B7E5CA4FA3DDEFCB9E';
wwv_flow_api.g_varchar2_table(2903) := '577A87A4E5A1E27F73413AA96D95867199EA5523E2BB0F21138079664D7EF2910CDE17834F9D47604B587852AEB42B1BF69609B9735D519EE993B975B9D520B76FCB608BE8C292E2881E136C28526E879CAD97952DF1CC2B8DA4395956910CB2D189CB2D';
wwv_flow_api.g_varchar2_table(2904) := '2BB3EAC4C11F96963E89ECCABCF2AFA7EE7F5FBB2D2BD1B9F39CA0C4E6688052CA39EC00A81BA21BEAF26C85E13726B18350BD6209E4D93626A539624B55272636A522B2F0986E47E4DA874D0FDB1E34DEBE19F4702B842326ABCD6ED11B9502E9C1E87A';
wwv_flow_api.g_varchar2_table(2905) := 'C7AD6BEA3C83334F83D96A33736D7037C4D9C1DAE91345635B994BE30356AA129CAB537023778657B24C4B1E73414363576073EE707450EBE0C2D6FA123F9FBD70606B786564737B716464777776756337B83EBAA74F5A9E1A273E53218A447DB08AE040';
wwv_flow_api.g_varchar2_table(2906) := 'C684D9E595E0E64C8C482CB3E1D3CD4DF479B6B6C3BEBD86B115FB66C7A933672683A9831D1D738BF312F46C8564657272C3EF372C4FCC869C7B8B83DE906E760A7ED42D83ED80F4F5F63A031BF9159551AD7D188C6435D8749C7F1C49C88FA31683C962';
wwv_flow_api.g_varchar2_table(2907) := 'B659E73CC17E7E879160C7C4CACEFC9089286C2653826DBF4B63DF4AFF27EFB31874518245AE1C9F447FD7267EEF51555C66A239312D7FA26D2212467F7F98E833BD1972FAC7F34A78C112DD3862B6586C84FBD61B6EF72D3FB87715D83CDFDE1CD18551';
wwv_flow_api.g_varchar2_table(2908) := 'CED988266C49A0F3A23FF2B3BFBF2E3B4AC25C13B15A0C68A2F9912F6D6CD697A644526A867B07717A91919C30B41996C076EF925FB686ADAEE2C6D6E98DC99ED8F036936E7E2DBC363130B8EA8FCCB5AD4712E727BA11AC9FD3FA5078656BE3F8F1F2B1';
wwv_flow_api.g_varchar2_table(2909) := '15DFCEC65CCFC0406073B6B2B2482CAEC254021EE764988C89E985B706E68B6D2B27CE9D6D5F354FF4B5A3089CEF1F9ADDF478371E7965AC7B82AB2C8D72CF262E8B3EB7B0D8B01CCE2C2EF18B61B877B66FB03BC3113427A64F2F2CAE2F4EEC6C6D71E8';
wwv_flow_api.g_varchar2_table(2910) := 'CA63CAE9A0DE6AE36421C6301984AC5E98268BDE66F3878DED77DB831B0BD33BE189A63B065DC8AA33D8B8CB1395FF6A40DEFBC94DD9519C7054C0B36B7558B947456467AB01AF9E76563CC120E515A5FDDD5BE1D06694F6D1A15E6C3EFA4A7EB1433C4E';
wwv_flow_api.g_varchar2_table(2911) := '1DDC1DD0EB5B7B266CBA7B86858EDA33DF580A58FFFA6FDF2B320E98B26A3FBEFA9043A89FCD576CDDFCD1E5777ED764766C84E4EA0777BFFB6A2829FFEC8DDE45FFC0F593BFFB4F80EFFA88B89C76A49C9E2CF694D4BFB8DE1F68F8EFE7DFFD9EC18605';
wwv_flow_api.g_varchar2_table(2912) := '05AF97788A4B202E81B804BE7C0960DEF2E513FD4DA0887611B3EADF70E9A113C6C89CE58EC901B5F0D1AF4F7D12F883979EFEF39BC5FAD21E0D73F4EBD722F01734A8C1C8C689AD978E7F25E9D6DC772F459C2085C77F8FEFD417269B3243C51183DE35';
wwv_flow_api.g_varchar2_table(2913) := 'B737B23239361234A6ADCC95559F4EBFF0AE415C5693EA62D4A3C0066328D472E6A4DD1CB1E7E97D212C1542526A97119BCC0F497A85B83325AF401CA9CA68392B4DF29304EB69F6F7A33DF2EA25B93226A7C6643C49A686A4EEECFEAA9A50631CEC1817';
wwv_flow_api.g_varchar2_table(2914) := '7725382815EFA80D204AE3D17E397F42EDF9A727A5BF4776F7A4C4217325323D2EB81503AA990AE4C655B19A64D02B35956248961F7F2C5697D85E8EADAECA3475484E501273E43EA6BF25D2DD2FEF148ACE21DE804C6E4A7FBFAC6DC9A90CB96991348F';
wwv_flow_api.g_varchar2_table(2915) := 'A4E68B2591F94A76BA7447358240EE4F3F9664349C1B72B952CC8766F532C86D8065C92B177BA2B40FAA58B6B9C7E4261A5DCC866730D0950CA7CCA2F93C29FDBD525B2AC664E99B928D69397E563EB92575E7253343AC1819B00F8B48E7A8B8174557A4';
wwv_flow_api.g_varchar2_table(2916) := '76B608BD7F8CC8B462770339A4AF53767CA2C3D8F85D996B920B7F28BD5725B150AE7E2A864DD9F44955AA24A7C847D725E490B2336AD623CB62DB95EC6A195E136E6FA024E31FA009D43ABDBE7F73627042DC1B62AB92BE36C974A83302835F6AD2A4A2';
wwv_flow_api.g_varchar2_table(2917) := '5E124E48025ECCD9BE8B94644B279A64AB38DDE2C891E165308D1A22930635D295A0B4C7A879FB3E92E2B33236217B9B6249164B54C34FB3DA6C6173BF0DB0074B5BE4FC453163D61E7D123392A4BA52DA7AE41B056239623B3C38273BD3927F59990CF0';
wwv_flow_api.g_varchar2_table(2918) := 'CCBDFC8F322C2995A660E14A283278A7FFB53FAA69EE98BFB8D8773CFBCD70D2AB7ABD25117B0010A011D8A51E26AB5EBE7BB19E38D884A3DD0B631410EAE81828497465E595A697E776CFFA7513633C6443AB9EE2C8AE692F92E64AD9DBD90540C61236';
wwv_flow_api.g_varchar2_table(2919) := '3734503B70E20367256C5833B3F7E60DEED2C1B14DFFCE842EA97C68B027A3E6425A9A33393939CD9D8696DF00D0D73FA294D3A801F9F0A3874A1C72C38BEBDF2BB2E4E61527E4E917A76F1A13B95DA237E89095B16D663B71B57BD97D7EB2B539F1F53A';
wwv_flow_api.g_varchar2_table(2920) := 'BD8119A99F5BBA5D7FBCAA6E61654ADFDE79E172C2B952B72DFCED92D244BD4361FE5872885C7AF7ACDE653546CA360DE6FEC1E5CA1333FDDDF3D5F5BA9A426724F542851548A508629562B2A8279BDDFF4BDF3DA74FB125840BF87AE6542EBF807CA600';
wwv_flow_api.g_varchar2_table(2921) := 'F2D21B4E579676F44D164F0EA414D5C44659F785069ABB4F1715B852F12FA87BF59B1580DF48A45A4CCE3B63836F84263C4997076F749EAFBFF0EEA5F34956B325A2F085FA8963F01015CEC5AADC0479ABB8D8113125F883A35D7DE37A8BBDA8A2223B19';
wwv_flow_api.g_varchar2_table(2922) := '5B11D7C78D0F391A9959F7990C9EF0D24E7E967B7B7D27F65C241A7579D5F513133F9EDAAD3E763C65CE96CECB5B814586E03AD15EA8ABABC76DDD49497157D79D591AEB68EF1CBA6C8F2467D4A4A6A4A7F9DDE684E489B5D13FACCB32E5E7EF6686B6E6';
wwv_flow_api.g_varchar2_table(2923) := 'AF1DAF2E9CDA3447C233FAE4474E13D44A2A3DAA1297D5A8CB70A72E24A53852D23959E9DFF2DADB1B5FFDC1FFA4B724500DBA6278AC78538C72EE1F5D0EA56079551C131719DA9CBF506436727B4067B03A7A16A46C7EA0D96F2DDF1B2FB4BFEAF8AD4B';
wwv_flow_api.g_varchar2_table(2924) := 'BA649B53574E4B6661B3F29B518FD0DB35E989FA0BA1729E8CA4AA1C9DBCF56A9123C162C3A0428EE7BBC7CB6B467A9ACB8FBDF173AE311CE5E30BE7BF06000CCF019D0C4ECECFAC365BE69B2FFEF1BFE95ED7F7DEBD7DE1774B8CA9296979057EAF2F2F';
wwv_flow_api.g_varchar2_table(2925) := 'D5319C56B0B1BE6ECD75E3665269B15912F540B0348834FA0A0B878E5764B9520BCED61A332BEB7287BA17D373B6D75713318879548DFE85A514271097405C027109280960BA19C0AD513CC5251097C0572E818488EE5C7D7972FE795362121EB81C7987';
wwv_flow_api.g_varchar2_table(2926) := 'F77857BC91A9AECEFABA029D25392F05154D82DA0B8B541E2FEB19BABDE9EB3B7BA2C46E36D953F3625C3B6D4663AE3208A42435852D9ABA7D887E2AD12867AB14E80A774B69BE64E62BCC66CB13A349F2F2A5C82EB9C532E7970CB7549D904F6664CF23';
wwv_flow_api.g_varchar2_table(2927) := '255C3CBF2C2BDBB2342279A9928A55B3F2D5AD527BBF94B9C41CDDF04E6D887E51322FA80DCC8301A92D90CE65D9599540B1E4644965955CBD2D9BBB62D991FAD7D431BE235192326569534E2489435D5A97DE49716C4AC171216AF8A57C7155C9AD2665';
wwv_flow_api.g_varchar2_table(2928) := 'F186317BDD090981CC03327257EA4AE46ABF78D765C228C71D52522B26A382A37B7EF1639EED979D3D7104E454BD70B3D194A4F801A9668594052F779EDD6C498F8BD1205BDD92952895B5F2518B14EF4969A5D230A764299DF3C28EECCE4AFEDB8A2B5F';
wwv_flow_api.g_varchar2_table(2929) := '440A730565DE879FF2868C8E121DC8A693D395B2EB92F109A92E979D24591D90CB6FA87D71C3886459C593272B03521294228754D448EFC7EA4420B82A75B512029A668AC1252B70B52D69E90AB6F5B6CA69B6E266C94D91139715E0ACBDA0AE9462E63D';
wwv_flow_api.g_varchar2_table(2930) := '332CDFE100C22AB6881C2B94AD4A05B0F38DC29D4743401CCC51C7250CF1F9B97380FB77E99E91BBD7E49552B1A74B30A442B08393C3DC3A352811D12C189035406F4466970568B98D517AB26467EEDF5EC66A1D47AE7E751D5E2C26B11CDAED2AF50B42';
wwv_flow_api.g_varchar2_table(2931) := 'E02A039B56F2DD3C12B051A88C0B788434BFE93C6DE979803D209E231C88E4E8AD674E9DEC5FDA0DEE6E2483E86C870FB63BD16CCEC24284AB08929716BDECEA50070704D6D385222F9DCA4A2BA90B04C33EAFCFEF0F84837E778265B26BB6FCDDD79B17';
wwv_flow_api.g_varchar2_table(2932) := '9D4656FD20C1498A5E77E15C5D82BBCC6F72592D9EBCFC6396FC60F7CDCDC5A161C30262767906A62EBEB3E6F5A5727FC1EBF7DA712C11C1A540C0E7F361E31A85AFFBE41060798EEDF4A5CB495653C6906FA1CF5BECDFD95B9BCF71D9277C91BDDDAD79';
wwv_flow_api.g_varchar2_table(2933) := 'DFA6D16E18EE1A4AF06C078DD34DF3ABDFBABCE20FE140C0A7D7F9124CA6372E9E1899CEFAEF7FFBD39A82C4B40A9E895C39B8163E30B1E6F48E66559E817B77DE3E544452AEB2E32D0FBA730D0147CE6B4ABE9CA31CA40CA7CD91AD7EDA7449CBD7CA95';
wwv_flow_api.g_varchar2_table(2934) := '9ED69DAA5E05D137816A1A0C87D5E154144D4CAEECF9273BCAF0B9A83321A808C6F4CC4A6748CF3EE083075B173E515938EB3E397EA3DF6A08E7A61D8E6833702EC69D1185BAD39D689BED094EF53BE2EC8FA39ECA6C6BF9C9FA70C4E8F5B15FF0059069';
wwv_flow_api.g_varchar2_table(2935) := 'A2A96F70E5CD774CD37B6EAB9D86FB093C73AC2AABB1D368F634E65FAA9F8A484DBEE3D8A5CB4E9B795B1DF685F702A1E5B90D5D78EFFCB1B29974E70F3F682C705C297657FBFC4417F486438134BB7D6E622B39D76B5A1BB5DA1C3C3FD6DCE2F99B2DBA';
wwv_flow_api.g_varchar2_table(2936) := '338F6C5418D21F08227F0EFE7446B39735F67BB12A0F9B2289265DD89431DAD65D7239DD6E0E9DAF2B75555CB6BA9CEA14235F7B14953057BD9189F68EFA93057A4B8A3B4D09553B372BBF74B2BBEF7A30D29A7FE294556FB2E6693F06564C5D6AC8CFCB';
wwv_flow_api.g_varchar2_table(2937) := '14A3D2C6E7B878E0F70F38A202E3246D3F8542115D30C42D57D666CD179E6C6BAFAB2FD45B530FEA5FD4FF0F7F1E2F6A84A7D1B58422AF9CA958CA7DE3CA7B9BE37DFDFA13C7B9319C6C33A5E5E5666764E415BAB997966CFCDED5DB6DF33D7FF9FD8A8A';
wwv_flow_api.g_varchar2_table(2938) := '3D876B6576DE5CB6EB999FD5F18C460F1379C878743840F4ECEC78BDBE6F9DCE1974FEEE9586D685F6BFF8B735C57A7BC1D3468E97C5251097405C029F5F02FC75E3CEC90B52707D7EB6E23DE312F80D908021D1DA35349FB2D6F6F2996AB3A5E8E88CD7';
wwv_flow_api.g_varchar2_table(2939) := '23F2A31F7E5C97FF8621F3ECD1F2D26CD78F9B2D05C1F1A4DC7347CBC9CF6CFA96DBDA2B4F96A2A58856EDEF4A53713F67579763953119B021493EBEAEE065C57949CC937B4DB26D97CC6332B1291F7D209978B43A2B133ED9D893DE113917BD373DBE26';
wwv_flow_api.g_varchar2_table(2940) := 'DE6EA9A813CC89D787040FE8403EAEBF36F7CAE91C3146C9620FC14E393753C12A369A5DE362FE58CE240B41A3672A151E4B7789CF26C39FC86FBD292D0B32D72F79A7A5634432271400AEA895A606D12D48A543DD684D612F898105D890FBFB1665185C';
wwv_flow_api.g_varchar2_table(2941) := '88EFBC24B99C298D7764E28A9C3FA620C6DD4F6592ABB0F725FFB870A76FD72F055C0F8F6E63B91E7C3AA000705196B436CBD2CF5497C23269FF54C63F96E35649CE94C89AE87C823EC81892F661294DDF772704FF2D43828FB1577364CB264D8CB8206D';
wwv_flow_api.g_varchar2_table(2942) := '0FE5DC6BB21B94C92509A0558E48FB84645BC49EA1A40AAB5C2A4E738A3E5BDD61EEC6E4F85329AA90BC5CA93AA6649560141B1AEC26F966998C26495FB3A49C91D08A649F57DDB137CE4A17639624452121F79973ED52C6058BA89C6FB688714B6AAA25';
wwv_flow_api.g_varchar2_table(2943) := '2345CEE18D3E24C956D9D3C9DD0659DB95F62E79A948D94B6F0FC8649A64CFCB724406DAC5B82AF543622993FB376531286D4D527B52327E4BA6B725B427385AE2F9E8E855D78F93F2656451FA1FCADEBC0C744AED69C5522CB12FE552F12BE56226FA9B';
wwv_flow_api.g_varchar2_table(2944) := 'C8F576B9EC93B38552912D373224BC136BB8FFBC610F9A9CE1C4A8C169C78E36FA70C49AE09D6B61C7D6DF517CAC4A3BA989D554E5A57CE795F3E228545C75CD8DF6B7AC6DCFD68CB7BF515ED5D45F343ADA9DE30CDA5239DFD94FA882832E7B7BF748B2';
wwv_flow_api.g_varchar2_table(2945) := '7BBBF4D449A34D5F959DBAA54B0848F7F6D6DA9B178F87ECD9AD6B3ACFF65A47EFDAF2DC52535BFF6B59C77426D7ED8E29E7FC950B274B9CF9B507C4048BE5394F426B4B4B559AEB95B2D3D71E662FFCED7FCBB6D88F9D39BF3EB1F5E1DDEEB5D0585D59';
wwv_flow_api.g_varchar2_table(2946) := '71EAF864F9F997224667BB29283B8B8B7EF9F8CAEDFC94A4C2BACBF75B07439EC5AC7487C112C341FBE4EF8F6DA6F7FFDD772A4F69EA4AAD140D58596DC1FB7FDEFAFD3709FF16FD99C5B8C1EFDAF466E670735EFD23BFFD23F5FBD9990D4F6EC2524AE1';
wwv_flow_api.g_varchar2_table(2947) := 'EFF07D683534F4FEDF941D2B49B1A4179FACDD6ABE19D58E3FD229CD6135DA5C8063473A4CB2B087692320AD8DDD678FD9E5084E632DF2526D6F5F7CD998A31ED3794FE8DEFD26FFE24CE703F3B1570BA7F38E0DCE4D240636528A78231CA662A7E19AED';
wwv_flow_api.g_varchar2_table(2948) := '588EE7B623F39BF625DDF0A6859873C772DCD6DA73C70BD3DEF9E6AB7FB6DD393F3333E50B6C2D8CA726782DC9D9DDF39E8989CE4070AA7CB2FBE5CAA2BB1FB73A763EACB5ED26E4D6993DB3B979F93E5F9BF1E0FAB73692C5661E98DBF65FF9F4585E42';
wwv_flow_api.g_varchar2_table(2949) := '42D96B6D6D1D4BFEA5F1CE87A9A7BF7DB63423EF95631DD76EA5178F98ACCECED18EB4ED9673178FDB2C05875C8AAC05E5277FF3D363C56F99331E79979E294AFCDB0729B589FDCECC4B47DB93C7E771D3C3DE8BD58F48E9B1367CDD8C88BE7FB2EC8FDE';
wwv_flow_api.g_varchar2_table(2950) := 'E505B6198AFCED8FAFD4E4BF66CEB9F864CB2FB7E46B00C03C2236A3BEBC20E7ECE5D3B35BFABF7DFF3FFC517EE9D96FBDDD3FD9EEB18F245B0DC6AA9281C1F9DD85312E3247F4264E668B5F3EF7FE8DF74E843FF42D8D1A13945ADF8C2D949EF7BCE4D4';
wwv_flow_api.g_varchar2_table(2951) := '965C6DF989ADBC6166D7B5B538CD319552B67396134F7109C4251097C08B9780E61AF0F9E3688019D326DC332803A7788A4B202E815F5C02E74F172C8FAE194D1882298BB058F24630C7ED7526788FFA23D56A9D16DDB1CADA3C339EDE9446E268CA4932';
wwv_flow_api.g_varchar2_table(2952) := '3B4FD43D6671C796A816E3C72429C16D76996A7EBE46FA717D143527ACAD11DF8E523EE182182B656EC6D59F17679EE817C46191D74E4B769DEA52902CC11A95415357952B09BDD6BA9C000040004944415451258A5F24392CC5275539E9DD3332DE2E27';
wwv_flow_api.g_varchar2_table(2953) := 'DD929B2DB33BCA7C37C92AA74E2B44577D4916469471253AC3F222A986668618D45565A92EC4F3A8CA5CAC945680A55FCE9D549760CF309C52D22847C4972FCA6C97BC5E2E290592992A7BEBA25F56FE9C78F1A498E5D43B4A0F99992435F5FBA3682FA4';
wwv_flow_api.g_varchar2_table(2954) := '132592195214AAB265E79CACE386CA205585B25D275B2B72FE650967482845820078DC6E8565754EA9AC355080692DFC27DBE4EC050998B86128272F8915EFE0B8D142059422394467C3CDEDB4541F4CFF5BD5D2B52E692E492E953542B3A1EF4598A7C4';
wwv_flow_api.g_varchar2_table(2955) := 'E992131765B47BFF3E2DEAF4E3B9926A160F0AED5DA9ADE2FEA362925408C1036ADC0116160B1D9E52958ADE2A45C9525BAF74FAA9D55A73D963E7699297DF562EBE11EC7156ED9B1251CEFE9426B9BA440C25EA9E36D2C047D7A57FA4A48A6BDECC7429';
wwv_flow_api.g_varchar2_table(2956) := '0C497581246628E2C7AB2429CA00A39423906425CCC752F3B02CCE882D8A16C1C9DC31B6A0B58EA69C5479705F2E3925099DAEA2A7924BAF3BF6F609ACB94F94955B7090FD682A4D67CB7B5CA9B98F248C144E1DABD62CD7F973C2BEF74475A64997CC25';
wwv_flow_api.g_varchar2_table(2957) := 'E1AA9CA4ED97DED89DEF397DE6E2C359D91ABB8601652414AECC709D7AAB6A6319977F06173BF0B3683ECDE8E34E9CAD2BDCF51CAF2BC480DEE82CD49B77936DDBAF9C7FC992A4FCDBD597144CEF9E31EB8C6B4153F38DE648681D29736DB5AAB6B2A4FE';
wwv_flow_api.g_varchar2_table(2958) := 'DB21EF9EC1642A765BE75EFBC6ED9FFC7DA97B4D17F29C3956D31BDC3965DC2DAE3E95993A55505689B1B02BC39D6895B3E74D91AD6993198B4EEE399B08E9F7EE2B1549799CCD1CA6A975605977B13AD1793CE171FACCF99369F98F9F11D0AE3C3729D1';
wwv_flow_api.g_varchar2_table(2959) := '72F0343CDE6FFFFBC4CA6E4F67EB6FE7AA57C79A5FC6FBBB13DD0800C0202956B9B7A4B3B73FA8AEC7D4FE50D4DFAA4AB326D9B28C46E7374E3C7600E134C98973356249393A1AA4CF55E4E99DD11F12A4F53A14F8EF5C3E634AB466DA7567DF786D76F0';
wwv_flow_api.g_varchar2_table(2960) := 'E1F973790BC6E2A11BB724C4398FA4990DF517EB5FBE54E5F4E05330B92C45EFABFB0E560AC01FA7595EAFAB72D89DDF79F7A22DBC6A5CDAC313E72BE5E979C7CF6D2FEB4E9DC8B184DD7AA3A9263779EBCCB9F0EAD0A9E3B5FE84A2C8B6CB95647FFBE5';
wwv_flow_api.g_varchar2_table(2961) := '939E545DF39D0746DF16EEA9522291DCFABA8ABA137AFFA6D16486B142B7BDF0DDCB066312C6FE356FD6E69564852EBF6A30F8EB2BCA6702EBB8CDD4EC9663B3439BDCD733926AD98BE029E1D184D974FDC98A3C332E3CA3EFA023B50E839C3E4D5887C7';
wwv_flow_api.g_varchar2_table(2962) := '0F2C8E34912D7FE446637B8E7313608701CE40CF5062222F5CA5347ED1E9EB088314927FF8E0DEEFD499938ACE2EEE86AFFEF483B7EA53D6128EB7DEBB6588E0FBDB76F2A5571E8E6DCFF53498F4FA5355F985B5675A27B77A6E5F29CDB44D87922B4D6B';
wwv_flow_api.g_varchar2_table(2963) := 'B56FFEF6DF5D6D7EABC8975AFED29D8185B1C68F5E3A513427B9B3431D2643E8644576116631F8288CA7B804E212884BE08804BE7818A49595952CE2EE1C5CE0C4BC099AB81CA484A42987B5FCD1AF8064BE6272949D9D8D2B69BE1E61EA912C9B9558AD';
wwv_flow_api.g_varchar2_table(2964) := '0695E9F8488BCFFC45ED7BA249EBF12C6AB11101E7F04F63AD2399D8D0B1369F79F0471A3E6BE8C7CAF9CA40F4D4D87884C4A35FB4669AA034B7DE9A84B556476B29D1C8329798606940A156F2E4A047DB3F59FB2823F16FCF94000E3C9F59C735A84000';
wwv_flow_api.g_varchar2_table(2965) := '272F9F3180F673E8685500E07B0FDA8A1CDE92AA9312751DF473BB3CD1A057E455919527CA9F5EB0E193C531A9E09A9BDA3F3F33ED7AD1BB893D0ABDD941FAD6C4F1C88679BFE3E08ABAF5CA55DE5FA1B4B021998094E8695EF7A2B8BCEAA6F47312AF3C';
wwv_flow_api.g_varchar2_table(2966) := 'BC6427DA15147F2CCDAF8AB7571ED58A3DD6447DC5153617067F6EF8A88171C935AB6BBD5F57BAD72FBB13F2C6AB6683CD8447E8A53E397766DF707AC6239D1FCBA5F3E2CAE3ADFEDB22FFED853279AB7F7E63B089D71DEFBEE359A945E72EEF2FD82F3E';
wwv_flow_api.g_varchar2_table(2967) := 'EA920F4FD7F722C1552CAFED00B30B7506D7E17A33998EE1A589BE07E72B33B22A1E510FFEA2438DAFFAC65A6E9F3B55EC7097FEA27D9FDF7E78D1D3D974F79D7379D68CDA659F74DE6D385E664DCF3F01D2E372FEF5C6D65CF3669D12D1D17BD3CF27F9';
wwv_flow_api.g_varchar2_table(2968) := '396B4756FCBD4D3774211F7FDB33ACA6F3AF9D134EE8BEEC34EB893435DC317AD701C0E991C8B937CE1B1C199F7B10CEEFEE36F49558D70A4E9CE6E2EFE7A6F36447DEA557EE3C78D9EDCDAE7FD92BFA078D3D398EC5B2EA0B184EBFE830485F030066FE';
wwv_flow_api.g_varchar2_table(2969) := 'C150187F0C9A217E20849D7B88630C32A180DF64E4A2813914C6CFB99F2B2846DCF047933F103260324384A470486F3040810BE22854A8F4FB83465CABE88DAA0BB72CA20E03B45EF1CFB804E212884B2026812F1700838EB6B6B6E6E6E6D8C76B004CC3';
wwv_flow_api.g_varchar2_table(2970) := '547CC69256AE412F5A3A9DCEAAAAAA676103805F5F5F5F656525A7E3105F5E5E86F3F4F4F418728B4D44CB40E74995328DA1C351F1E0E060464606419B60066A5A7827D07B8C0885047C5A5A5ACACBCBA30D43C31B60BEB7B717940E71AD9CAA999919D8';
wwv_flow_api.g_varchar2_table(2971) := 'C0B32EF958F758861149748C951CCDB0FD5A585800FCE7E7E7D32C56C5E8535353F0CF2830CCD7F5F5F5CECE4EE67EFEFC790DC4C61A1FCDD07892F0C87A7D717131FC77747440F6C48913090909B0472DA11160BEA2A282BC363A532364424D0D6A3285';
wwv_flow_api.g_varchar2_table(2972) := '87092D482A2C2C2C2D2DE544A3BDBD9DF94281EE47DBD7D6D6C212F491615D5D1D1D8FB211CF3F5F02CF7AC8B55E5F2E00E6A1E401B3A06D8C6E099ECFD8336A01C0AF89A85FDC33125B16B68F878A299EE547F5D0CFE8F7198AB99D4B422DF92B9AE01F';
wwv_flow_api.g_varchar2_table(2973) := 'DE3FF7EF43BD54D4EDCB2F67F630A34ED1BE3E61FA703E2E06A3095D62462024FAF0BEF980363DAF5799A9EB09A6247522BFFFE5CCF91954BC815024087251CA66B6D65F646F8C54B966ACD6292A5A2BF79E35B7E607437374EADBDBB3B0813FD8B41FD4';
wwv_flow_api.g_varchar2_table(2974) := 'FC62FF0F3252D0FF45587DD678500E07FC7878A64174109F96D7DAFB71591EF69BBF12F80027016E904713BF7A5C561F35F6D6CABFF827970EB8F1AB5D1AE51761397046F5B929FB7C018B855FA9FA797D8989B5E0ED8D1B6D4E13A36FF280C584172EF5';
wwv_flow_api.g_varchar2_table(2975) := '3A78D100F8E95B962F716E4F25C575FA58396EE6348192311D9C2BA0A037A867E23099D5D575251165E0822DC2110A66BCEF4593E15157DD5A61FC332E81B804E212784112007A69F181095507DCB2582C7C6A5B7FADCA6EB703ABC8039FD8F4D3EC288E';
wwv_flow_api.g_varchar2_table(2976) := '22AF812E1A00BDE84B1B58254F021F420AA5319F34A3B1462736979E9E9EB2B23287C3A1D5524E9BEDEDEDA6A6A66F7FFBDB5A2FE8D00B740AD09D9D9DD5B03A2DE9C22723B6B5B5016EF90BF4DE7BEFFDD37FFA4FA1D6DDDDFDF2CB2F5305351219063A';
wwv_flow_api.g_varchar2_table(2977) := '77EE1C08532BA42F892A6DC4CDCD4D10697D7D3DB59430A256AB7DD28C8CD651ABD246D7286B14C85305DA24CCF2C0C000C8163EE15FEBCB2729D66B7E7EFEF6EDDB005AE60E637CE5CF24DD2FE145174FAE8B8BB76EDD62BEC05D260E918686064035A8';
wwv_flow_api.g_varchar2_table(2978) := '982EE07F96A0B1B1919308A4C4C4F96450444D1E280E29102FD2181A1AE2F8805AF20C41C45A86D326C828F1F44B25011E0E0B2191BF50C2AEF24D2EA33D0339F16361E3F192BA477B90BE2CF40BBD5F5DE8AB09E30BF2AF7EDCD1CDDD8168BFD0FFBF20';
wwv_flow_api.g_varchar2_table(2979) := '335F68EC6867B061743E18CD26C7F6AD31B2D1883C7CE3897A648B1B6BF02566AC0C8FCBE92F2321559BED790CB3807615EBF98B265C34A928DB2F2029CA0718213AC823A398D19EBDF815D1A60527C62F4356CF171237F3ED8FC2A8E7B7FFB9B596E893';
wwv_flow_api.g_varchar2_table(2980) := 'FD739BFDA20D580B825669BDA26FF2AFCE7AF7EB01C0BFA880E2EDE312884B202E815F4E0980EE608CA3568FC763B3D940B0E4516C029C34F40B6A029E514295D6589B08CDD00903F65A5A5A5045524B027F520B0844E90A20CCCCCC04923D78F0000408';
wwv_flow_api.g_varchar2_table(2981) := '714D27896AD7ED76038C7FFAD39F9E3C79F29BDFFC26BA59B4AC20B79C9C1C549A3FFCE10F416B8C0EF0438D0CA0852C79580206035681B2E86381EEF442890D8205E3C11B5F21450C0C1A6B53002B3234A892CFD1D1516021EA50460149C236BCA13486';
wwv_flow_api.g_varchar2_table(2982) := 'FECD9B37292F28286052348307B80534A2687DE9A597E80B598880C0D7D6D600B7A867198EF302902A43A383856051511143232E260E708543502B9C242626825A110B0C035C21C52703D192B12E5CB880DC1E3E7C0844871AB58CCB441814B193615D7E';
wwv_flow_api.g_varchar2_table(2983) := 'EFF77E0F540CF3D004EB42E7ADB7DEFAF18F7F8CAE1B39FFE11FFEE1279F7C32323202FF308988BEFFFDEF538B9C61F8073FF801CD504D33D33800D61EDD5FC7CF3491FF55D92B3F33B137C3E2F929F70F9FD9235E1197405C027109C425F0CB2A813800';
wwv_flow_api.g_varchar2_table(2984) := 'FE655D99385F7109C425F02B2201B01608133488452E2013AE81616036B02585A0262099866C6300982E340362510EBE052E629E9D9292024803F20129E94209B05003C32061301E3AC9BB77EF82CA808EAFBDF61A4450724207A407869C9898005B3284';
wwv_flow_api.g_varchar2_table(2985) := '86D32045033EC18AD007F50174BBBABAE80BF0D6C027600FCA80648C8441920057A801AD01A550067F0217E101D48A9A1455AAC62190128CFAE9A79F421300095734665CD860FA404D9024681C5B6E6AC7C6C6E00740CB273012F08CCEB9A4A484BED087';
wwv_flow_api.g_varchar2_table(2986) := '0D060527C306B0965EA86151D54284964CF9CC9933A05C66017160FFE5CB9719AEBCBC1CD1313BB031F4C1BD1A42860DFA520B8E652294C339AA5D003FD486878721C2708585852C10E5B0076E675C2833296A991713812C689C3CCDFAFBFB5908E8500B';
wwv_flow_api.g_varchar2_table(2987) := 'CD78FA359500CA2B5476F11497405C027109C425F01B2181F85FF4DF88658E4F322E81B8045E9C044062A03B3E8179A04D4020780CB5A4A6900444910156696035C6061A5A402058178489FA913BBADC4405678206A9FACE77BE0396832C0A5B40207017';
wwv_flow_api.g_varchar2_table(2988) := 'E2C030BE62DC0BD00521A3E6BD78F122AA5A80378D512383E2F8045E023E21050207CABEFEFAEBA861352C07A005E8A276661400335817AD32081C225C730510828D296416F08F81F1E9D3A7191A4C0E29D23BEFBC037A8432B010DC4817B025231E3B76';
wwv_flow_api.g_varchar2_table(2989) := '0C66B459334DBA80219917B77961005224688272618606DA85640445A1C639346943950680112638990610D1648B0029447A642821C3D7E3C78F23162685C42005112850A209198641AD70C5ECF884618E00580BACC429E16C0226694363F29A18A98502';
wwv_flow_api.g_varchar2_table(2990) := '2594838D4F9D3A05AB9C3890675C8D6CFC332E81B804E212884B202E81B8047EA5251007C0BFD2CB17673E2E81B804BE640980739E959E3F12BA5C10AC3B2D2D3925C5A20C8953525392DDEE34B48BE839E91B0366E419026C068E4525CBED59948D804C';
wwv_flow_api.g_varchar2_table(2991) := '0D65A16545E578E3C60D0DA761158CB6B3B9B9196006DAA4162C079A652C3E5B5B5B51DEA205A51C4C0B350AA18CDE984FC605277391157365E0255D0081E401C0005D14BFC04BE02E795028CC3022BA5354A3B007BC8426D6BF0C0DC390E593CBB73406';
wwv_flow_api.g_varchar2_table(2992) := '25A250E52B9C807E99381011FD2A2D81A0304C09033134BD20454B12689FB1C0998055DAA3DD65CA8C020AD538A725001ED00B7DB4B86898C1B74C818E10A4197A6CE86804E948A256C3EAC81039A028A62F6DB45A0C9BC940105280640E053EFAE82366';
wwv_flow_api.g_varchar2_table(2993) := '8A5D34259C1A80DBA1F6E1871FA2168637B4E80C04CD2B57AE2007A038796604CFD047806A1AF1F4754B005B02E2F0F054B17624FEFF18475A79B4EAB19A832ED16712579A41B5A6EABC83A40E3E0E9E55AAC2A1A7984353ACBA100568BFCBE1E8B89C51';
wwv_flow_api.g_varchar2_table(2994) := '2738D15E348BE6D531CD6309FF3750888455556C94E8B06A16FC8729052F8A10BCA99BFF6AA07074AE5A266A4A81331F4291ABF9AB2E073C0702C15090E968354A06D43E965429E54F54458945AB9E2BCC6857AD99E0A99483A8C7E8C7BE22CBE8299536';
wwv_flow_api.g_varchar2_table(2995) := 'DA7E9758AD9651A54F65463118AD8A4E86696141A27541129C23EEE7952F71CA1F9F26D2D96FA05A1ED66A73A44ACD3E2A81A8605563BE314A24BC3F8AE20AFF08EA43FDA7041B5282251F4BACDDBE590BBC452952A575D45650BDED0F3839DA2BB6FA6A';
wwv_flow_api.g_varchar2_table(2996) := '890F1E3F48ABB944A7A62843FAE0098C4AE2694B76444A31FA5AE6D95DB49AFD89ED378B72AD7E5307136465A3CFDE23F355B38B4E905EB1968F8DFBD4AFD1F64FAD79A4F0F9CDB45A3EB5F448CFE897FDF2E8C22DEF044787FB258CCB2E95A2D3E1F2D1';
wwv_flow_api.g_varchar2_table(2997) := 'E1AF9B09ECFFCAD41A3D3E4DADD7639FAACBC183470F867BAC41EC2B55816090D78756C23A465779BFBDF2F5ABCE671FEFAE3D4E3122B10C7C424DFDAEA323F290C69E9F589B58E6A95CED4B26DA683FFF04F3DA8C9EDA3D46FC6826DA727F0A9FBD17BF';
wwv_flow_api.g_varchar2_table(2998) := 'B481B119EFFAF451525F6FDEF0277FF227CFE7401399F6C91340E26DA45E48D15376B6384FED4E7B761EDA9EE9A90DE2857109C4251097C0572C014DD1F79C41796B69180C6C06948A2520106F3300AAA636D428D0187444098891967431992D7693D87C';
wwv_flow_api.g_varchar2_table(2999) := 'D3764772C24EBFC1331A0AEC054DEA5E2BAF44F4B7740473F216D52880AFD034E27F18FA00338C7B416BDC8F059AA278A40475AB0650819A1462000C08A40B4361A3CBA014023581886CB8E11C8C87F9315C4119B8CB58A04D2C8D19113ADC80A51628A8';
wwv_flow_api.g_varchar2_table(3000) := '5DDC451F4B7B18D3A038C39107F4A2CB851A50902E205598270322A5195C810C69836698A1990573070C032901E78C024DB8625C260241D8202137A8916803B710842BFE829061E2B487F3EAEA6A7A81FCC1CF34A31700951BCED4D292F9F2B7063A7467';
null;
end;
/
begin
wwv_flow_api.g_varchar2_table(3001) := '503AB21C8C050F4C8781E007104B63F881796A99ECE8E828520239A336CFCDCD65D61C25A0B586371866EEA07744C7F101CD103B06E1346368DA23794AA8E26C82F302F4E4DA92C53F3FA304620FF953DB53CBB23E6BFFF0D42E14B2E71A9C5B6DBD7FAF';
wwv_flow_api.g_varchar2_table(3002) := '34DB3EB56B1B7AD031BCB59C212B264734D2EE41B73B83B3FE95C1E9CE912CA2C1EA0E23762CECC868D7DDD945BF7D6F7ED59C76E7FA95C1E161DDC6547256DEE082E7FADD8622DB96D99935BBEA6DBC7B6769BA37C3ED345A0E2FFDAE78439FBCD73836';
wwv_flow_api.g_varchar2_table(3003) := 'D1ED5D9ECEC8C9581773D3270DE9893EB32375693770FD7EEB4477BBC5BBE973A47EF293C6B1A95E6B64CB9596C9058503BE64626DE7EE9DC6D991EEB484F064C0DE70EBF6F4E84066B26D6845377DFF6A765949E3C86AC8337FBB65A0B7AD61657A342B';
wwv_flow_api.g_varchar2_table(3004) := 'C5E6B324DF7DD099EA5FB4A6640ECF6E5DFFE4F668DFC36C97A16D56D6871BD2F38BBA466708CED931B1DBD2D8B8BB3A989D93D9BB145E9E6A99EC9A4E4B252EF2A1DBEA9D90747476AEADAE7B67275D598F32B6BC37DBD6DEBFBA9EA95F333AB80EBD9F';
wwv_flow_api.g_varchar2_table(3005) := 'B879DF75A77BC9B7B13337969291DB0E076BA393DDB3D9058EA1C560FBB59B79793683E5F14DA02F240D0F067CD37DEEFCDCCEDEA5CDA5B181F1E98234BB8A207C90967DE1EE3B1DE37B1BF6ADA18494FC8362F5FFFBE36B3B0B5D139D933979D64F4776';
wwv_flow_api.g_varchar2_table(3006) := 'FB1AAFF133CC34F90316D78387A3F35D0FF3CAB37C11CB83BED18E9607F6BD4D677A9A161084BEA0D686CEA10C595B0E3B47EEDECB2C48D61114389A26362343F7AEE516A6DF6B9A72866675CE8C863BED89BCABDDB96D7D8B0FEFDD5A9A1AC8CE702E05';
wwv_flow_api.g_varchar2_table(3007) := 'ED5B83DDE1D4F4AE8E07E929B6D6A18DB607F775DB236999B9B1E09A809B87AD930F9AEE0DF6774576D636C37ABB77CEE0481B6C1C77A447B8A4D2D7DD38373B5594E9D099F79F1F1EDDF98DBDC6A607133DDD994EDD9A21F5D68D4F878606432BA3AEEC';
wwv_flow_api.g_varchar2_table(3008) := '82875D33DD2DB7F6E667DDD969D7BB67DBEFDF191DE8B0F8D774EEFCC1BBED23DB5B56CFB423E5D0813F136AEB5F5C9F1F1F9DEAC94B751230469B239FDB0169EC6CF7AC6EEC8EF624E715C5CAC9DC1B59F22EF54E768C6517264DAEEB879B3A873797B2';
wwv_flow_api.g_varchar2_table(3009) := 'F5EB9BA6B46B779AD27CF3F63486D00DCC7BEEDCB89EA25B4E743FB22E23AB81A9A1FBD3139B49FA554BD223BFB8A3A33C966F189ECB27FEF5919FE1630DF84A24D8C587C32E823E3F230D364CB8B374778657F95DCF748D6416F3881E3ABD9BF71038FA';
wwv_flow_api.g_varchar2_table(3010) := 'CECCA2DFB6376F4BC998F244865B6E969716F0F4AF7BFC0D8DDD8B236D06BB63AC672A3337C92BA6E6A67E62D63634B674F774E739BC1627BF859F9358F1BB0D8339D6A570425AE783DE14DB9ED11E8D07FD44BFBB7D73DD8D9FCE4E4DE6673A26F7126E';
wwv_flow_api.g_varchar2_table(3011) := 'DCBC3E3A3C60F3AEBB3233C7D7FDF7EE376DCC0EE6E5A6A958D507694ABD706E4CF50CB89D216BE2E1AF8F43971BCD83032DF776D726B3B3338656430FEF348E8DF6A6593C3657CE41EFFDFF03F727061F2627D87547DC9EF173B8DB3B639CED4ACA2A98';
wwv_flow_api.g_varchar2_table(3012) := 'F344067AEE2DCD6D9B76A6EDA92A0E752CB50D4D6FAD8D4D75CF64E73B8E32166BF058A67FC113996A4948CF9FDE0E2FF5DD4DCDCA3DFA967BAC71EC2B3F819BCD3D79E6155B6A61ACF0F919FE46B0E560F3C3DEE3B196FCADE7EF3E7B1B36036C0FF8AA';
wwv_flow_api.g_varchar2_table(3013) := '7D92D136157CD24B4B6CD56249A3C35732F13BC08F4935FE352E81B8047E7325C0BE1C88A5691A1F93022FD6C74AB4AF8046121D558AE8C3BBABBA890F2369A775E3EF475CD511CF72C85ECCB1212F5CDED4DA6B57EB487390DE37BEF10D301856CDDA0B';
wwv_flow_api.g_varchar2_table(3014) := '5AD37962420CAEA6964181BB54F13700484609F80DB44609AF7B902AE013B0C75B1E500720A401D45E7DF55558A2017F03980EE5B40773322E25C04870202811FD272CD1520B3BC41F1B00275C91D114BC50D000277D1902040B44A41694081138675046';
wwv_flow_api.g_varchar2_table(3015) := '87263EA518026E499A5A15404B39C4A140554C74140244F9CA8C600377D3C07E129C33043893067005347AFBEDB7350A0C8732962E506374386446005D2D834D35EB05AB8CC840340048F3A7918C66BCAD390C833E14E013F960D80CB86508280083694F';
wwv_flow_api.g_varchar2_table(3016) := '2DB817E1438712A6AFF1034DD02F538037468FCD229EF95A24C0B951F7C8B86B774627C76756F7866FB42E1C4BA9371A42CE9AB1D9D9E5A9C1CAACC4DCCA3337FAE62EDB7A979A97EA5FAF8CE89CAD5DB3A5CE2D5741D5ECB60C757FEA8B5CCA28D89EB4';
wwv_flow_api.g_varchar2_table(3017) := '54AE4F76B88BEB3FB8D5FB2FCA8A16964DB706662E3BA74CB9F52D1D4356FF4AD37CC8EAFFF0F4DB7F1CDBDB2D790293777A2ADF296878305859EC1E96AADEC19E647B565D46C9CDBB23DEC50E7772964E2F733076B3B3F23BF9BA479F97DD88DCFEA425';
wwv_flow_api.g_varchar2_table(3018) := '5137627466FA74FAC61B9D6EEBEA5CC0D5D7766B3E726AF4EAC3BA8BE5D706C2FF247F7257EF1A68BDF9CDCB17899633BFB2373832EC98F59D2FADE021EC9BDDCCDDB8A9BB7CB2AD6BDE3A73A7B4FA78EBE05486D1FCF1BDF5FAA435A3814DB9BE736EC7';
wwv_flow_api.g_varchar2_table(3019) := '3AD9B9D61DA8A932999D87186627280FBB5A731253D237376DC5E5BAB5B5B4E282F1155F967E696CC9B97DE7614B41DE19AB4E32AABAE7B61337070AAB4E7B44D775BD437F3133737BB4F4F8B9E6A1A962CBC0F42DDDE997B3F57AE783E99D93932DEE5A';
wwv_flow_api.g_varchar2_table(3020) := 'B6BF8FA425AF8C8F746655A4121DA9AB6326C534D6BEBEFB525DFAE292AE7F66CEBC3A7BE67CF56A24A3E7D3F6CDF359D9F6C1B4D2CB8BDBA1F5BED6CA73C7B135B935B276CCDFB5D8BA73E662FAF5FEC0CB81E9297F79C3ADC6BA6FA72FACAD2D5FEBB8';
wwv_flow_api.g_varchar2_table(3021) := 'F0EE898945D34CFF43A323F983F71BFFE7749325AB5EE38037CDC276B063A26932692D6F654AA73B19E3AC6F3930F1F0464175616B5377C629BD35B97260B8DFBB1C7CABE2F840DB6C6278E5C19AA5A8F793E5D21F78BBDAF4FEA4F0C6E8FC6EF9B5BB4D';
wwv_flow_api.g_varchar2_table(3022) := 'F5E97EBD12EC61E275C6EEBA7D6627DBDB5D53FCEDEE89398779D09154D471B5D75D53D1757D28BF7659EC39876FBD68D7877DA37B63CD1999953ABD617C3DBC34DE965D5477A561D09F9237D631E44E33768FADA46676990CB96D931BB5A10786B23F58';
wwv_flow_api.g_varchar2_table(3023) := '0D48FFF59691BAE294E4D98CD2C3B940AFBB7B21393CB4B83B74BCB86875663EBFB0783B6CF50C4FE94AF26EB4F5D6A726B967FB8A2EBEBEEA97B1F6AE33F5F96276DD1C583C6BE85E685E3FF55AE1E4B26EFC66EB5C8DF38CC5A67755AFFA75BD575B5F';
wwv_flow_api.g_varchar2_table(3024) := 'A9428C2A48FAF48E616EB835ABF2F2E19C397B5AF1ADF4B58536B30A2D366F72F5E2D4C8FCF4DC89129BABE8CCE0D0FCFAFA4442D877E2F4E9D56042674B539A61BBFCD4F9F6C1F9FFEFFD8FBD2793ABF26B738E9FEA1A5BD89CE8AA2DCF4DCEAD5AD88E';
wwv_flow_api.g_varchar2_table(3025) := 'F4B435A6877D59274F5E691E5DFAD147A7BD67CED6168ABBEA41E770C2EECCA913C7F409EE8EF1E5F991AEE91F77559CFAADEBBD2B2FDBFB169B174EBC7E2CA24B68ED9A294BF638F32A673D32D2737D2F74D95DE031161CEB6A6D4EF26FF0DB0984E576';
wwv_flow_api.g_varchar2_table(3026) := 'E7847E692221C5E8D5E9EEB6761EAF314FE84A47EE7F5A5AF17B80A6EE45FFC5A9B6555B99DB3761CFA9991C5BD2EB3C6E87CDEACEDAF405C3F393F6C29207CDFDE1B5C9EABC8CB95D436B4B4BCEA9F4898ED6EA924B9DE32B0B235DA688BFBE2ECFB392';
wwv_flow_api.g_varchar2_table(3027) := '9A5B9534B31E70EB36DA4697CB42CBDD23AEAAA4A6E19CB78687BBF2F34BFAEFB5A4565737B70C987C6B46A795006AC3F31B6BE36386D0724DFD99C6E6B1C4F5890D6B5EF327775FFE1FF31E742FED2D8FA6584365F5671FF60E1F37CE19334B3D61FDAD';
wwv_flow_api.g_varchar2_table(3028) := '3B7733BD0BC664377FE67AE6B7CB1D9E3D63FADED86C464D7ED7F0D2F0707770FCBDA23FFCDFFA26C373C33D9599BA82DACB5BBBD23330E65DEFCDE57E93C7D1D2DD9AA4CF4F4CDF76979F3EBAB22D4393C5D6E1D9DB72EAE5BC8945DFFCDC6C6069FDF4';
wwv_flow_api.g_varchar2_table(3029) := 'C962A3BBA0A579D4B33176F144F1AADF9DEE0C581D29CB6BFE81912943CFC3EFD6D4B70FECA44C76651EBBDCD1D29BE45D3E7EE1F862206979B263613150ED36651F3B393CB335D6DB5999672EAC39DBD1BBB2363EA02BA960E895BD50474387CDB271B1';
wwv_flow_api.g_varchar2_table(3030) := 'BE56F705A2131F9DC5E7C83F7D4BF73908C5BBC4251097405C02BFEA1200E400F39E350B80D9935580280D9829141CF447FC5EFDF654C85567F07B227BCBA2338702BE08FBE2A80D1588EE310A8037BA83BB2827033C832085604EBEF2A70E135F0D6702';
wwv_flow_api.g_varchar2_table(3031) := '0EB5662860A9D26A633A349027984D2B8F0178AD0D60954C6C5C34A228578179A888198B7206D54687C8D10CB531FA50A01725684D41E0880241C19E36A2062FB5BE50A31056F9A4C16353A69051F8444D8D6219A8C95750342524AD2F19486914C80065';
wwv_flow_api.g_varchar2_table(3032) := 'F93C9AA049A219A855EB0B63B1591CADA50DB0212631DA5302E558098D910385246D74F8D16AA1C9BC98A6567B948178FEAB9700CFC4E4EC86CEB3F0E6E5D39290959BB4EBB85CB753E04A704786B62237EFDCC8701A3D9D0399854517CAB2CB122C998E';
wwv_flow_api.g_varchar2_table(3033) := '5DD129E56453C7ACBB601A009C9120E6131722E1B22497DF178CB8134DD905059D2D0B46F15766BB930B8E85C26D9B01195898FC1FAA723BB783337D574EBFCDB3B7AF6BE2797011B6BAA8606C74CE170EAC0F0FD45FAC9F1E1BCCDDDA9EEFBCF3BD77AB';
wwv_flow_api.g_varchar2_table(3034) := 'FB96AC5BEB6B21079E0088E0F5B884E6F72438D1F0EEFFF23B2657E58C3F6218FDF377FECDB787FD995D3FFA539B75D1915331333CEEF5A7E526195EA9B8E81FFAE0A5972E4972C16CDBD8A5CA8CC1C9DDD39B73A5D925E5A74E564FB72765575B436DF6';
wwv_flow_api.g_varchar2_table(3035) := 'B4DC99F18950D8A70F9B889DEA107F7A76A6E82D15E962B79FF1A545CC89EAD828966C7A39555B936A4FB2EE8596F7F46BEDCDC98519AD2D63DFAAD8C8776784CE9DB466A659D2D50BA163C6933B791F00CC99D9890B5591F2B4245F0AE57525595936A3';
wwv_flow_api.g_varchar2_table(3036) := '3B6C91FF9FBDF70CB2E3D8F2FCAAEA7AEFFB76DFF6DEA2BB611A1E0408829EC337CFECECCC687677463B1BB1ABD1677DD1074D842214A108C546683F28562133A1D5EC6846DA5DEEE37B241F3D614878A08106D0DD68EFBDBDA6AFBFFADDCEE645B301E2';
wwv_flow_api.g_varchar2_table(3037) := '912048026066200A599927CF39F9CFDB55F5AF9395A9391A82B6D6174E8C8DFE9DAD6CCEE26687E4AD14CB287706A7AA2BF48D070E67157D6B53D069B25A52E91CF1DBCF26D6E72EAFA52C658E0FBC9D7FBEE7E8AE54BDDFAFCBC7FD6622D991CF2F341D';
wwv_flow_api.g_varchar2_table(3038) := 'A88700EFAFF4546AFBCA9C29C51848A6C7CA83EE78A63C3C336AB71A771D6AFCF4E39B5C4A2707978359C5112CBAB4716763B6AF4080B9CE3ED7DEF0BFFF6D8FF5DAAF7FF65FFF0B45772F801FD9489654862E5C1BAE0829EB06C7EAC4D8EE5DA5BD93D1';
wwv_flow_api.g_varchar2_table(3039) := '44784697CA9597FA06A28154A28760E5F5BED966F3CDE3270FCD18BDD95CD2A9CBFA8A438AEE5EC8112B07F654748773ADE148CBDEA35F7C72FD93AB372C0BBED9D1EBAA569762F4F397BEFCACD5AFFE0AD46456292E7219EDDEF472CE6BD3975556F6F5';
wwv_flow_api.g_varchar2_table(3040) := '2C7F3130D71588ED7FFDCFDEBA3C3730FAF1C9D70EF52F1C3C941CAAEC38B69050DA0EB707AA4B8ACC3B23AE9D8D7EAB4E5F99294D9BBC173EBF59EC3676C74A9D7D676B9AFEE4487B7BB5C76221CCC8C6D689DCF9F3D7BBDA9C10E083B54575A67D25F6';
wwv_flow_api.g_varchar2_table(3041) := 'B8A2792B3D9AFB48674385D3E857ED46E5E5A35D676F4F2DCE0EF883BC11B44F1F3995EB1DDD1AD12FFFABF6184ADB0EA819873364BABE941AFCF87D5349D9992B832FF82B7EF7E9A596F2F585254379F9E2D599B1E8CCDD05D56AD47F16C95512C18B2C';
wwv_flow_api.g_varchar2_table(3042) := '2BE9A258FF7CF4D377DF8B45A797C62EBFF84781EB17E6234BC34E9B93379A2B6BE135C4C22BD974C999DB93D74FBF978AC5CC99455FF3CB3DD7AEE9B5683CBCC6DCE1C30D257536E3E6DF75FE6DE685EB9345B53310E0A05531771ECAA6EB3CDE2431CF';
wwv_flow_api.g_varchar2_table(3043) := '8D68D49E8C2A996444552E7ED173B47A3199292DB2E9145FF1FCE8605FCA535F9229F2F84E9D383A699ECB667E3B1BC94C5DB8DEF9CBDAEB370682FE2421E2054FC46832DA47CECD46ECF3633DE170DAD83FF9DC3FFF27FFF91FEE8E7CF0C181364FD85E';
wwv_flow_api.g_varchar2_table(3044) := '7EFDD3FF60305A863EB85ADB70BCE7BDF9B286E69EB1F07EC32D4D5F53E9F32DA60399F83CBB40A7322993AA1A5575329A19BFF641436BBBB6C194E6CCA717EF96ADDF9CD359D3DAD5BB2353FFED9BBB178BF7FF1FFFC3FFE61B1C1ABD79615D576CE83E';
wwv_flow_api.g_varchar2_table(3045) := 'D7C4E6F616B392D12949FDC8722C3E73FBE01FBEF4D9ADB54C6CE1C391A2B2F2C1399B67EEE31BC95267FFB90B615BCE100D47B2BAD367CED8C3630DFE1682F9238BEBFB1CE11163FBC6DC60B17DCF9E5D07ED26B7CF4268F92BA9A3365462310732869C';
wwv_flow_api.g_varchar2_table(3046) := 'E6FAFCC635F3DC9584AEAA667A707ECD3672FBA6E6542E9FBBB5620D3557694AEAEECABAD7115EBC9371AECE4FCC8ECC75D6D59C3B3DD873E9D35C22E2D08D8D95FF62F293B7CC15CF0D86C3EEDAC68F2FDE324F5F68283984331B89543A1ECF6CA4B9C4';
wwv_flow_api.g_varchar2_table(3047) := '9CBE30A8CC0E4CE90DD6F8F5DDA74E3C7C82C0577C7DAC2792003F5638A532898044E0294700B6F36D7B001BCC7F11C70D77E2FD9CA5040D19A34BB196E732692DDC974DAC64F46E9E877880160C73BB7E61AE60B4705AC810C024C80993142493725185';
wwv_flow_api.g_varchar2_table(3048) := '924246282C9C16324266FBA99084FD0AB2F7750D0B4D0A192409ED12BC854392E88B50BE4343A1B0D0B09011920501C2AD5053F8A750F5757A0AADB6670A3AC96CCFEF5022AA3645B6C6F481253B34EC902FD46E7740E67F780418C2F1A955532AA16CCE';
wwv_flow_api.g_varchar2_table(3049) := 'B92DF75BCB5ED8A732CD4D5516C652FAF4F28B2FFCD1AFFFFB4F331BCBA75AEA756A49AE4A55542A953D6D252E4F7EF26DC8AE94B49FD2141D7F4DCA6872707A35D2D7F7FAA13283ABA204A664B41BF45429B3EB1B0BC3A335A126FD22D314B75D0D346D';
wwv_flow_api.g_varchar2_table(3050) := '6C35E2EEBBD5D5E24D78EA6F5CFBDBDA6A7FFFC581BA8E614B72C5172C4A2D456F5C1E68AFA8B3998D468359CBBF4EBAC78088C638CC0B06577EF2612AA7DAD52C9CC4AE53739A9EEFFC1AAA8AC6A2A6CCDA8CA25A32F9CF15736A3613673EF08DDE16D3';
wwv_flow_api.g_varchar2_table(3051) := '54DF447A69301DDC5BCB9F8CB6F9360D7A555D57353E1DCE44577D66E72BC7762FF4DF3CF3D9C5578F6BBB2BDB5565B7D290DF060C5BC97456C743B4DE603728FB3BBB88EFE1D55C52E94D9AC666A7959511A3A7B9D665564EECAFD3747A2DDFDFD690CD';
wwv_flow_api.g_varchar2_table(3052) := '6D2146A4F22EB0E3C53D9B41C10ACABB1A2B34B5BCBC2C0F2CA7953ED3DCAD4CCD6A9E00F36D339F271A8C8658469D199B690C025D5EA87337D24A35EE6ADAF254EFB11A57B7EFD8C2DDFF71CF41D5F7E25E558F8B55A80ADA74FAAEBDB05FF227EABD9A';
wwv_flow_api.g_varchar2_table(3053) := 'E2566A55ECA6B3A3B7FA46ED5EF781935D4E87DBE150B51CEF108D1BA9D4DCD8E2DE3297ADA1369B59A75521B1B7DA4A5CF12457F496AF6C289A4965EA2B2A16E30643B06E3E3A3F3870B3545D181D49CE352B297DC9F9DB63B1D86DDF9F742D11FF9C8B';
wwv_flow_api.g_varchar2_table(3054) := '3446667596632193FAD273071607FB4EBF7BFA95378DB6E27CF0AA9036A7FDE4E1620CEDEC81CB628706DE66E6D98EC5C5B6734606A0200C08FB5BEBBAE307AF0CAE28D17774B57F3432B79EEEBBF3F2BEC0FBB94A87718ED0ABD96ADDC87F792C2614E5';
wwv_flow_api.g_varchar2_table(3055) := '9BFA4D8AEF54573357C9CDE904DC65D829DE98DF8E55DDB52BA42A250C6646D5E2BEBAD9F1A191E5F4A92ABB43A73FB5B74DC70F3F5787069F49DDB7AF4D31E467C29F6C0C6A6A203F189A5651A4E45ED89BFFF3C9DB511C46355D1A589E1DF6071BF084';
wwv_flow_api.g_varchar2_table(3056) := '0F1D378BF3BFFE64326DD429AA4EDF14C09B7DFC49698ABA3E102F3687F7BD78FC7FFEBB4F8F2C8CF0F9CDD183BB965743319D6E6CF8EA1F1F6DBA946E9CF8E0DFEEFF27A7DEEDE93CF572A9C9D5F6F7DDCBCACC8DD25D87D3898995586A69F8CA6B7FB0';
wwv_flow_api.g_varchar2_table(3057) := 'C7EAACD65B2D87F6758C9E1F3CF1C2AB26B3F58BDF9E69342EACB99A63C9CCFAF052D9C64AE71FBEFAD6998D6C3A73AA25B4F577BDB973F6DEB690D3977F5B5DEA504A779D52153D9E655565DFE143039F0C301D3E9A55B28B73CE4345B787D48AFEEBB5';
wwv_flow_api.g_varchar2_table(3058) := '4DBB7B47DE0A67AC87DADAD89A9077D119666C65B3A53EEBE98435303E1A3047CCEEEA9E9BBD89A9E194BDFA4830DDFF61FF2F7F56D29F685AFBBFDF2AB5EB7DB507D73FFB9FAA7FFEDFDCCD18A6876F5434ECA90E786C458DCB9317552DB3B4164DDB56';
wwv_flow_api.g_varchar2_table(3059) := 'E269ADFBC6C0DCE248E0109C5CB39B8D1E933196B52DADAEDBE25366C70BDD0377CB46EF44A3F1835DA567D35DBD57FE3F9E3874BCF1D62929CD7C77763D367D53AD2E6FACA8B2D9BD077635AE8F26AE5F192D61E760ABD1E40F4CA5A2CB773F9ED11AB4';
wwv_flow_api.g_varchar2_table(3060) := '340B66A891F9E5DED9E93A7DAFFBD5BFBAF60FE7F92C3F6063E18FD2F02A2F88935FDC190F0D5F1B501B460CB1A6573A4BF9F3CF5F11F9A714FE6039ED6AACD2B4CAF27295DF52787DF570B9D9D8F68239393B707EA63DA42B3D7CF27FFDDBCFBCC145EB';
wwv_flow_api.g_varchar2_table(3061) := 'F0FAF462AAD835DD545C369B68ECBB35644A46DDB5FBBBFF97F74BED915871453C1659DF48850CAB7B9F3FB8B4B4C228B91C9AB722188DACE5521BBB5B8A27A63BB2B128FC7BF2B3DEBFF857F5B7A235A7DFFBCDEE17A2CF2001E60A7EFF9B7BF147258F';
wwv_flow_api.g_varchar2_table(3062) := '1201898044E0D940803BE82601CEB0988E6E6D4C591B4D3B9B79B6D5F496AC6AC8998A32599557BE3C776E677ADFBCEF3CFC88A0F46364622244FC6D151602CB8FD6911D5DFEB63E405A7638FC6D4BEE97DFEED2C36BB74BCAFC8F82004F6D15659EEE15';
wwv_flow_api.g_varchar2_table(3063) := 'BB92E2D3D4CD4760FDD67C0A7E90BE22AFCFEDD76B84EBB37A5DFEA93EFF94B7C95FE797A335FA55F2F9673FDD1629E2054E55B1B3A9B9A5BEAA38A773F44D2E2D8CF50DAC4E75B6CE856C9E70A437EB8FBB830490EF4DD960E1AD90C3DADADC5C59527C';
wwv_flow_api.g_varchar2_table(3064) := '7351D5256226BD2E5E5C9F99B9A356EDEFBE7AD1E1695FD24CBCF672994DCCABB73A601DC28BBC27C49FCF66EBAF9E3967F186026581596759F7850BA339B7CBA6A673F680391A29AE9EF9F43F686A1BAC23BF888E9A1B5A49A97377738DA5467B7A7866';
wwv_flow_api.g_varchar2_table(3065) := '4C598E4C0C0D1B67171A56A672995C89DF743351BA78EB4AF268A53595719787AE5D1988344FBAAA3BB6BBFD79EF8267EA74E72BBF54F31F406C75A7C8AC581BBB2E7CF07E6B75C0E4ACC8BBA9D76F72A1BCC3CB91B4B6320F78305DDD16C8F9724197D4';
wwv_flow_api.g_varchar2_table(3066) := '2FE32673ABA990CB60F1E4C3BFBD0B89B18F7FF3C6AF4E59759E506528B5364927F24D36C702CD302A6756F1074B1C0EB792CBA04E6710CEE435C7D2D9D5392CE679977E739CC89020782DB565C1DAD6E2EACAB58D4C5FFFC8D4CAD4D460AFB76277DF85';
wwv_flow_api.g_varchar2_table(3067) := 'F086A6B7C5A226DFBDEF2189D79FB9327CC4B5B8D1F0EAD573670FBCF886A2DFFA44793E1ADF63CA1E6CEB383F6BB87DF7863A386FE828B1064C939353A6B4B7A2BEEAF3D195993BFDB90347DB6B7D117BEDD5F31F35EC3D65CFA989F2D08D4FAF9D3832';
wwv_flow_api.g_varchar2_table(3068) := 'B583001756E432E95227F6D53BF6BEB8F06992658A9864525CE4B3D8827C832A7A218E2C795FE6770C2EA427C64EDBAB7E5EE1B7EF6A6969A82A9E9DB5F47D703AE5BCBA3CB4BCA7C40330F90BECE61B46A0510DF7C685AF5BBB7FFD9B3FFCD501D55206';
wwv_flow_api.g_varchar2_table(3069) := '2716BF2E4663DF918633BF190858AE040EBC8C2D3E82CC5BCCE3AA2432B9B9B965255B469ED73B28CF977EF5CF87D3582A6B985EF59DAC13AF36B8186E4AE587F0D71FDE3C56BA58D2F9D266EB7BCD1306DDC0F0442099502D76BFD5EEF416397DC15506';
wwv_flow_api.g_varchar2_table(3070) := '50B30C4D2DCCC4D50A9B8900A6DE641F1E982CABF0BACD8EB825E0B6996B6BF7E86CDE84921B9998F4D994CAA65AB7C3B6A468A323FDB515E5481822E65A9FA3BEAEA667C5B4120EDF1D1D5B5D9F86D0DFF7771DA935EDFCBB8E247233539393338BC343';
wwv_flow_api.g_varchar2_table(3071) := '03EE1AA7B32260B77B0C36476C6DBCED50D1DFBD9709145DF355FED1C25A66716664756A42AB741439F4BEBAA61B97AFBD72B861CC587573FCEC9BBB0DFFE795A157FEB13B65D04F4DCFF4AD1A8AB5306FB04BEB438181B46A2F49AF669752F65C7FEFBE';
wwv_flow_api.g_varchar2_table(3072) := 'A632ABDE19B69BBABB6F8DF72C2A0715932ED7DA5C3D72539D191F568AF7B8ED267F49496FF76C95216531D7167B8C134E676A23A2B35AA65696222B631545DEF8AAEDF2E51B8960A6DD1D8E5843536B9A75BC3778A08117154EBBD9525A3A35BC5C6C37';
wwv_flow_api.g_varchar2_table(3073) := 'DECD8586BBAFB8ECA558E705CBEDBEE95BBAEE507651D38CBC070B0F8E8697564C4A265451D777F7F6CA952F8AF6756E0C76ABC1725FDCD83F37DE9C5AD58CF9791C228DAC65EEBCF3F69BBF3CAA5A8AC51F297FD78C9ECD9A63E14E879F370B7546C7E0';
wwv_flow_api.g_varchar2_table(3074) := 'EC722C3A386257D67CA5CD93E7CF986B7E3E74F7ED931D6515CE5DA77FFB3707CB5D2647A9D3E3B61A62454167694BFB6024172AB1B99D2EFE31DF21142CEAEF9B5EBA70BAA57DDFF48A616E6EE66E74B5B36142F3D847C6E627A3AAD7CA9FEC9717942F';
wwv_flow_api.g_varchar2_table(3075) := '7DFBC1FEFF1E0DF337CC73E10FD613694822201190083C1C811D0CEAE1C2DFB0169D5CE812ECF7CB17C0C1E721C049475D56E7D56CAD6A2696F31D496B362E853C493CFC7A783F01134F21B4E24D22B3760B0F25DFD0B1821897629C2C3CFB52FE683888';
wwv_flow_api.g_varchar2_table(3076) := '4B3A7A7678927F5CE3B1675BB84398BEDF6EC1A587FB201AD265E67EE7435E9BDFDFF25134516B317D9AE654810CB1686A0BE698562DBE49A68338C977CE244A90C98F5122B15D5E0888EEECD04673D12934D35018DD0EA0B078FF116192988C7D7F2D25';
wwv_flow_api.g_varchar2_table(3077) := '0FC7E4814D44E1D735C41C55605568CB29BD16117E01209EDFEFBCE8E3FDE5053D4F5A8647F2B290EBE26DF3FCCC64C05DAFEAF32BAB8B54ECD059CA6B606BB5FBCA744CBED89668B5BABA91B47F2548487DB15D73EEE9AA6C6A22CFCF777C315C6F5C5B';
wwv_flow_api.g_varchar2_table(3078) := '4AB974B1E5579EEB18E88E694B638D078EAFACC7B34C8AE4B7C2EED08A6EFF895DF58DBBE016DADCDC1F9EDC5FBEE750685FCA397DE9C0F3FBEE9C5F5196876A2ADD6E8F2F5BE11F1C1E72E84A3467301B8FE5B9482EE73619DB8FBD3A72E7AA6D6D30E4';
wwv_flow_api.g_varchar2_table(3079) := 'D61A8E770E767F9EB5AC77ED3EBCBCEEF7A98BDED2D2BD3521CD1274E895FAA67D8AD9935CCBFCC1C1CA9A43AFD7ADA6B3939FADAEC7AD8970D45E170F2FD4D7F97D4E7395AB363A559130FB476ECEA792E36D6D65AECAAF4429E3E9DCD581A9B23B673A';
wwv_flow_api.g_varchar2_table(3080) := '5FF95981FCD065FE661A1B4ABA7BCC55B5958A766F72AF406E2D9EB2869737DF1E6C112151BEFD184BA46F0F4C7604CC6617E15F656866E5E2E9D36FFC6CAFD5E8292B0F0D0C47A32B4B362F81F7AD3F4F1495D7070CCE5C89457556756D57453E9E52C2';
wwv_flow_api.g_varchar2_table(3081) := 'F93502F35792EDE94095B7B5A64BEFAFA3903DD6174626FDCD9EA5E985A6FDC6E5432747A6E78E561A14DFAEC5C5E5FC08D14383928EAD9C7C6EFF5CA06DF4D377975620566CCC9EAF2C35275D5E1ED60325C9D46CA0789FCB56F7E2EB2D51353674A1D6';
wwv_flow_api.g_varchar2_table(3082) := 'E86E692ED1B53A933D1F072C59FFE1DDB9C67DFD973E2C8B4546466653E9E97D479A0C819AA5C55545CD87688D5ACEE1743616DB836EE2A54A75514067ACA5BCBA3364638A6967E9D0F080D399AC2A7547A23935977F0CE6EF7376293A3334143230B827';
wwv_flow_api.g_varchar2_table(3083) := '53765370CFBEBA26564350F78694CF8A770D0D0F955BF4D58DF9C07B53A9C791DEFAAAB980067C7B7C3976F1838FDE7CBD5A67C913DA426A701B7BBCD50D452306BBBF502832898CBAB2B2AA64F3BBD37F5D4A6573C373AB96F9295FF025C62B9A60E5A1';
wwv_flow_api.g_varchar2_table(3084) := '65473ADF24124F7D7CB1B7B9631402BCBD39580F4F2F459D4327DB83565F4D5D3D9315F2932C9868DCD4D232D87FD9941D69DCDFA557B4430D95430317DDA699FD8DE5E75B8EE6B2CB0C92D7AAAB6CDB3F3271236D4A55349416D9DDCEAEFAB1E1C12ABF';
wwv_flow_api.g_varchar2_table(3085) := 'F5C491A6BB17A775B9AC41A7AFA9F14F0EFA1766C65BF657E94C5FF90C1BB49757E3295778BB57E437D2B9E5E949BDC9353DB558D1903A70FCD0E0C0D5225DB8BCA9C36ED38A6ABAEA3CC37A4730B7A68E8C2D3598E7DD555D1B4C27D0D9D2F10547E98B';
wwv_flow_api.g_varchar2_table(3086) := '8194B1A93C58D65CD93A37E4B297343D5F3BDCD3C78F53C9F033CE95D9B56C7B7E366F3296B41AAD1E87EECE727CFFF8A5CA13CD13C3176B7D264BA0A2DDE2D95DDE150EF9A20B67AA5CEA94DE373134B4FB6079595168AEEBE5A1A1BE06B7E6A96E5DED';
wwv_flow_api.g_varchar2_table(3087) := 'B933B03CECF29AF61EEC72AFDBCF7FF26B5DF76F5F3EBEEB744CC7628F56BBF5EAF0485DE7E4286B6E4C0CEE6A75353637ADAB15A303A773E9B8B3B6FDB9906FF23397D53E57B6A7D15B1CFAC8DEAE9F9CAC6BDE9BD63913A909E2F9D5ED8DA9B4F978B3';
wwv_flow_api.g_varchar2_table(3088) := 'A3E3E80B8B49E3D8AD4F73D954E18F991FF1E8E2DA99D367DF7CBD51B1DC5B038C4E56F351928B0EE7535367C9AD338E85A1A1E71BBC86FA863B23CD2DBB2BAECE3798DDBEFA12D74071454BB3C7A4E9F71D393E7BF734BF4FE6BD94B9CCCE32A672E413';
wwv_flow_api.g_varchar2_table(3089) := '97856822E5D4EBCA1BF62806FBF4DCBC211B9B4B6495C842F38BBB866F9D49A9B1E7773728DAD77E7426F47C7FC79DEFD485A5C2E391B84772432571A3E5398CC43D55ECB8482DCB933CD0398429E763B307D6CA428980444022F0C323C08ABE50A087D8';
wwv_flow_api.g_varchar2_table(3090) := '2D5CFA1E28C36590959C89ED08319E8AD957967592ABABAB598E188666E54D733C91E6336095AB3F8B4219DC2E07E10E1AA290B585B924EED850072554715DE5A22AD6A91225984021FC840C5BE9B2A6B1E02ADB3D2C48A2A1902F644421A738C90AC938';
wwv_flow_api.g_varchar2_table(3091) := '294A7EAF861DDA843C7AD824896EA267BB09BCA25F50443EE8159205FDEC33CCC7B4ACEA4CF70B4A504EDA7E5A90175590559676243E4C667838BF3E3393C00707F9A4288C1516A386EC0117BB2E7127625A38DF240B0D0833BE7CB4CCDA607808096457';
wwv_flow_api.g_varchar2_table(3092) := '24BE5BE63363860C7996DD429E5AE100CB59B3EF314B70238C24DA181DB650A696C5A811864EB3DA163AF9481849BEC1C66EC17332DB71208FC37CF006DADC167754098B08B06635D414B53427892E3F5098C2ED0278CB297D11F756F20890708F35B429';
wwv_flow_api.g_varchar2_table(3093) := '4715A71CF921B155153F1860043400C17FBA26B4892392F49755B2990C2F7C78EC47B07A884E46879FF7D73D3F7C5D43347E78F54EA4EF8B5FBEF1A2E6AA2C8841F332C998CD6A8DAE6C585D0655BBF73A0099A5950D873169B47D8518D3444B458C96AD';
wwv_flow_api.g_varchar2_table(3094) := '4794F1857525BA44C8B3A4888F173C1393334EDD86BDB8EAE3B3576373C38441F5E9CCE1AE0687B7DEE2E6C35835BC91B4A871BDD999E2EBDB70D8E2748CCFAD65228BC4AF8C9EA299C9C5742A1C705BBF184F84072FB1E8119340F65615971F38363EB6';
wwv_flow_api.g_varchar2_table(3095) := 'A865D74A026EC5EA9F189D76985345A1F28D8DAC41492916CBF2FC4291D796D659E39115E67D84931AB3A28D566F1A2B1B2B1B19CBDAE2BCA2E54ABCB694E6B418B3699D39BCB8E4F438A6A75733E9B0D765F1F8F353AC0B697839FDD1BB6F1DADD2B71C';
wwv_flow_api.g_varchar2_table(3096) := '7D733B014600309767978AFC96ED6B088B86AB2C5D9F5CB3B9F25FE77E5DEA995C7BFFEFDFFECB5F56BAAB9F5B492AEF7CF0717162F2D49B3F530CEE850DE5BDB7DEED28CA749C3A25789150128B24CC2625A19A74C915E8C376CD0C477275C9E9CFC73F';
wwv_flow_api.g_varchar2_table(3097) := 'B797AFC4926E6386E99F144693D9F9C919559FB6EB73FE50D9FC7A26BC305551E2E99B53EF5C3AA3D7137D559B4AD4D2B6637EB72BA31A17E617BFE81BCBCE0E2AF9E14B77B43694D5371A4C566CAD47C36E3D3F093FCFA9894844C9E9CC262D6B342596';
wwv_flow_api.g_varchar2_table(3098) := 'C2068F251BDB30DB1D732B04F694F9F958361329F63B96B2AE0B1F7EA6D3AD67B25AD09E3EF6DCF1A8CE6FCCC54D167B34C18F21A919EDD1D50D8B53BFB0928CAECD13384F5B3C972F5CD427D79959CA7CE5BAC35D6C0FCF360125A565CCE3579261D397';
wwv_flow_api.g_varchar2_table(3099) := '3FBFC548727D6E22E4B7F336819E86E3294B2EAAB77C85F26DE494B7DFBFEE99BA70EABFF8B966BE475A045C4B6B31BB163739EE85F844799E6E2CAFF8BCB6FB5F7308018EF3B1DC3FBCF7C9B1D454E71FFF0954FDC6C4DA07EFBDF76A75A4EDC5BFBC32';
wwv_flow_api.g_varchar2_table(3100) := 'BC78F5E3B77F71BC31D070A4204FE6FC7822D9FDEF2BDA4E5495077206472C1CB33BB8B1E6C72E9656A6A7A63CFA84AF94BF505D389E59989A0A38F48EA2D00C0BFA2ECE781C165FB02496D166A726AD9954B032A46AA6B9B5D8C6D27459D0ADDAFCE3D3';
wwv_flow_api.g_varchar2_table(3101) := '4B5A6CA524E8353ABC53734BBA6CD46DF6985C1655FB4AC46E6925E634A50DD6AD08BF702F96CACDCF4C29D9B4C9A095848AE359E3E4C41443EA0B4255D485F5B8331BE51D05E33E31BEE4B3841D812A16971EB971E6B9165F75CBD18CA2AD2F2CE7F770';
wwv_flow_api.g_varchar2_table(3102) := '588BB99CA6B8669D99185F8F67221FDF39FA572F26324625BE62B279861613FFEFBFFFBFF4F165B341F967BF38982D796E7D6ADCE377D8CCE668D6E8D067129A39B5113618ADD3730BBA44B4ACBC48333AD61299A5C9B112D8BFBBF8FF79FFFC91C0BAA7';
wwv_flow_api.g_varchar2_table(3103) := 'ACD5172C4DE6D48BB787BB3FFA5D5B9D376A6FBD75F91D9DA255F9959FFFE24F26E20E2DBA581AF4EA8999E79499C96935BD51127081D2E4F89CC79E31EBDD2697756C7ED5918CD8FD364DEF9C9E5F4A6F844301BB660B663696AC761F0F1FF1E8AAD56C';
wwv_flow_api.g_varchar2_table(3104) := '2D7CC7BE9E56DEFDE4AC7365F0B59FBDA198EFAD3B0D86511E63F439D5C0552E3F017E6A6625B5B15C551648199CEB8BAB1E9F757529CE0E8C59CDB8B8B01670E954A31DC76627A7B3A98DF2A02765F2E893AB86CDBF6EAE5A1373CB2C931EF43B6DAEA2';
wwv_flow_api.g_varchar2_table(3105) := 'E9F9B5647485DB1ABF7316D39E1A9D311B12A132AE573B5FC089A1E4C83D626464847BDF8E17B5DCC578AFCD12959F7FFE3937321E9C38E5998123893B2C8F793C27F0C0404312775E52FE7EF9E5D40691F9CAEFA960F5B1643080E1C7A24A2A91084804';
wwv_flow_api.g_varchar2_table(3106) := '2402DF1D81C2E5EFBBAB2A68108C82077A7808748BCB317C8FEB2FA71C131B61AEBC5C9AB91C0B1A5C684886129A50058D814843B110867771E1A609AC8FAB390B202380E768A64A5CDC39A52D26C840EAC8C337485C72111332E81702B02094D7D4D4D0';
wwv_flow_api.g_varchar2_table(3107) := '9C5A34A39F5ADA629D5668A017E429E75E42092C8B1E615D58C4011CE33EC40D8986281476058D816EF1B0CE4ACE9C16F4938180C15DF1016D18A5099A91C1493463912AF2A0246CC1DC70803C2C91559A59FE1A0ACD7ACEF037A81A44179ACA2986D023';
wwv_flow_api.g_varchar2_table(3108) := 'FA08AD85E9A10D660E4785E8D29623EB36E3151AC8002356D8F708BA851EC8279C109720AB9CB2FE36AAB04B8242C3247115CF618CA8C21C7DA72F907C00C42EF8704A73000176BCC57F34E03CA724F45045D7C803ACC8031A0D698566F400350D31442D';
wwv_flow_api.g_varchar2_table(3109) := '852824C3A91832218C42810C55F82F7666623868C82960D20AD8C960115BE8A156E8A40413C00556F88F3C9E43E9056862AC11402704180DE2378CDD273CF1ABEDA8AB1D4C44B6877FF1D9ACE703C0FCBA38364FFEB96D47F2E53F00CE63BB3D6D36B9F7';
wwv_flow_api.g_varchar2_table(3110) := '82BE22E054F8F765AA292F210B79F0B81CD68C4FE173DE4CD662B55BDC792B24878587B6FC739B41550CCEBC9E8AA04BE1DF66AAE40B4B25BF6A917B79D6E4F3333B8225E0CD0E27CF43D5953C6E6E3D71D6D66C91557E08621E605151BE8A6EDA1D797E';
wwv_flow_api.g_varchar2_table(3111) := '98E7144A9ED2E4FB67F530A1D6E3A8E094245EE3A1D05494A7A955955B16372BEF1DCC06F5604B79CBAEB61DC41209AC14153F98E2BA2D7AC5F2E0AA826AD6387A696F8DABBC3DAF4A539A42DECEDA26D82FA7018BD2D1B1DB169FD861D40AA11423A1FF';
wwv_flow_api.g_varchar2_table(3112) := '0AFBA590E130FB77462F29F758EF3D1CDB8C5A754DFE458F48454E7D91B386BCCD14F6FBBC3A3D7BACAA0E97EAF7E0437E7675A0C8EF9F8B64D2F90581797F11F03A61BFC8E76DB9B6C61A31EB97AB1EE6C7C0B7F993B0E78F414FFE585DC5314F4A23EB';
wwv_flow_api.g_varchar2_table(3113) := '49BFDFA3690626FA382D1955677498F3034595CDB4F563E0CBE97C431F41E9FCDBC69948C6E775EB53C6AC9A5F8DADD8E7568AB7EC6E02B1690B39BEF5B51BFDF6DACD6CFEE08057F115F45713EED5046C6D7B5FBB9FFD22E873D1B507FCF84D9A62CABF';
wwv_flow_api.g_varchar2_table(3114) := '56785802ACB6325F534DD566A05A6164F7D405CB1AF2236B371B5E3DDA1668D8BBA37DBD4F6F3EF2A2DD574E396FDDEC8E7BA6AD7AA5AEF2DE3039CC3A47EDD68FB6843F1F779D50C527AF351590D2AD14C47FD756557588DFDED6CFAF34782FFFA5ECD6';
wwv_flow_api.g_varchar2_table(3115) := 'FFBE07FDB15B0D6AD536B5669D525775CF998093BF21FEE5997A55C59666A745BFBB3A58DDB89BE837E59E40FE2FCEEDDBFAADD654558413D98D530CB1DE44B52D0F66B1DB74FCB923C9B5850A8FD159B9971921EE3C7AF9B439A8061A9B6C9BBF9FB27B';
wwv_flow_api.g_varchar2_table(3116) := 'AF2A5C269DAB36FF8B857E13F9ACF01AB876706A5495436D3526ED0DDDEA505D7591D378524DC55A2A7D7A5759B50B74B77E092655A92ABFF77AABBA32FFB314A9AA524D1741000040004944415408992DB1CAD0B64B813D0F23BF1CABED2B3F27AE27B5';
wwv_flow_api.g_varchar2_table(3117) := '45AE8E7D2777B05F846D9BB721A116DB65F939F9F92ED37F3FAFED189840FE4F129D4581ADCB1D8E557EE9187F12CA977FDD58A92E06CCAD973221DE2D2AF7DE42D654E7AFB13F6ECA7B2B93444022201190083C1A02823CC097202A701241630429825A';
wwv_flow_api.g_varchar2_table(3118) := '4063500B398184204949C10A79381B01435816DB0BC14608A2D21CAA069381F7520B6321820AE721C1D6E039504A580DAA20877018348B7022C2EC0C04DB217A8918714E4835094F48C2135EA652858C889122496C19B204338498A1136FABABABE18D54';
wwv_flow_api.g_varchar2_table(3119) := '518EAB3424419368080166112C0C411DA176F04C1823B544C5E199288762710A1D1562D033C4709BEE40FF8806C357010A160DBFC504441AFFD143809A2394157228B6F345183D68C02EC08203471230E2155D20548B9F28C7222580860916D682090BDE';
wwv_flow_api.g_varchar2_table(3120) := '4BD7408688F16F7EF31B34E321BDA09BE81741696AFBFAFAD08F4E0117B5986044A0AF788872348B202A85D4528E87BC4D00797654A6234081038076E7CE1D4C307CC008EC4215EB6FE315C8505555554539B6E81AFEA096716128B1422BA0A347D0543A';
wwv_flow_api.g_varchar2_table(3121) := '825186128B307FBA03C3E777C50F80A1BF7AF52A98601D856880AEE3305D400C9DE8014F3C471B864098B7068C29891F98E0E49480006E630B616C3D5D29E432850EEFFF617C863C1CEE6C6226E0239B3B585FACF0EFC74B21872EB4E7E0F761BFB6C8A6';
wwv_flow_api.g_varchar2_table(3122) := '146D450599B3BD6F0FFCE15EEA68E5E9F6077AC0AD09396A4247EFD9FE32C795E2B95D55309D2F0BBED3FF41A73178F2DBFDF04AECBA92A307BE93D56D8DA1195D7B1BB6153CB6ACC7A43E7FA0B3A0AE3E68ABE75B9ECDD4147229A107F4DACF5C675B9E';
wwv_flow_api.g_varchar2_table(3123) := 'FD3E03A9B3CCA5941D7E48471C26CDD1788F452369D32B8777B73EA4C9C3ABF86556E489FDBDC4BD767F0BAF09F26F0ACA4BEE31DB7B128F35C7DB87AECEFC0B8E9F7882C6CB24119008480424028F8200E447B00B48177442903128101485A3206F6420';
wwv_flow_api.g_varchar2_table(3124) := '24500E24616EC20C9294434B0429822691A08BC840662096B0174EA18B301F1817BC0849281062701B2825C4097E051D22C289725A11D8A41C9D54414A05B382EC610B9A0421847FA29672C80FD6C9A00A9685F3D49281F4A20D5528A40A1607D1E28857';
wwv_flow_api.g_varchar2_table(3125) := '34A40497882B5248C21F0AA17394D329410BF107BE0761832DC3AB318418796C0102569027038B8631528E72F818405DBE7C999EE2007A20FFC21670E13CDA20C0E81171634A28C7430CC13CC9D33B3A4E2D5548D2354AF0993C7AD0491EB649392558A1';
wwv_flow_api.g_varchar2_table(3126) := '9684AB1CF19C23CAF1044E0B8724F00BCEC85385302F1A4407190BBA03CFC443C61A7374842E801800D21C7070833EC2ABE92055BCD400223A28868086F07C7C80DC32A00C07A494860C1CB618743646A61C131C69D2DDDD8D663A4843A8327EE20C3F00';
wwv_flow_api.g_varchar2_table(3127) := '34C3BD11A09C81C6046870E4F780F354218633788830323870EBD62D8695727E1EE0266A811D259896492220119008480424023F29042401FE490DB7ECAC444022F03811809CC079AE5FBFDED3D373F3E64D6806BC8ED4DBDB0B9981084117E13970244E';
wwv_flow_api.g_varchar2_table(3128) := '61C5D03F1176838CC13DA088D02A38098484441EE22402B9702D7811091A83C7B01A881CF409DA06FF813841EA204524AA6032105D12C489C026A7D4620E228736C1DF606B640832431AC9438A504213E4057547151C98563846505AD8226E89759CC131';
wwv_flow_api.g_varchar2_table(3129) := 'BC453302E8240986491052704B5AA18A56740DE5D4A2043648138819A794C3C710A04705F708A86254740A524D399C13E5B8843C6D518B9F443B711BEA48DF2172F0551835E0409505294503AC927EA18126408A155A5148AF452D23452D38C33091D9AE';
wwv_flow_api.g_varchar2_table(3130) := '1F6D804FAC1501C8244E621A01FACE91C440830FFEE31EA748321C7842F7E1E7249833ADF0905A8CA20DB800048491819DC254F18712F40B0CF1072B686650E80BA708F00B8187031D1AE826B5F05E140A60819A11A13B62E0C4D063113F196B2C228C33';
wwv_flow_api.g_varchar2_table(3131) := '9420434FD1464FF11964304D9019B7C9A30D0DA2771C65920848042402120189C04F0A013905FA2735DCB2B3120189C06343009A01218175402AA0190FD78B303C10D621E80AC28262417B48502041E4A046E884688923213B88105C0E4E08898260A304';
wwv_flow_api.g_varchar2_table(3132) := '56090BA204820D51842F619D266880DB200FF3818F4178044BA439DA8406B8105C0B4A4968116246F8910C3409E676FBF66DACA399129AE0217A04958280E1241AE057F040ECA2044334A715A411FD58E448A7C8C096451015976888CFA8C249DCE3ED00';
wwv_flow_api.g_varchar2_table(3133) := '253031F228879D9260922C46054524A11F3CD18303A8A216B5B8472453382F30A1093A09B1E215254C6F86F4E20C9E9328675C3842115148FEC68D1BD40AB7791901C3C41F58223D8267A28D3C7A308D5ABA866F404AADF001617ACD1030BB1B34100379';
wwv_flow_api.g_varchar2_table(3134) := 'E0420C619CA495E80EDE82211DA10B98A3219222C2CCE8A30D78F14A58A1964EF1BA047918BEE0C6741C6788D3628B91C22EAD28410F476A710C07846F2083124E8521D4528E006278824B08E0068C1D4394302E0C076F641835D4D20A49992402120189';
wwv_flow_api.g_varchar2_table(3135) := '80444022F0934240F7D77FFDD70FEF3077D042E28E4EE2364CE2C98686DC591FD89C26DC5979107960AD2C9408480424023F3C02100FB8CA23DBE5B28606084F41035739E296D0D7DF9B609B700FACA384E68278C0A028819CA0840C5C053AC7A5157A86';
wwv_flow_api.g_varchar2_table(3136) := 'B0B8BA4257C888B654C16D203914C2A6E0305C63898272A49004C34139940F7904E03CD02132102702AD98E0D28D15BA4013C4C4651C6104C8530E571402B02391D0492B94E3151A9021C608E3E294F82477047C268F004A10268112740E61F2F4143D84';
wwv_flow_api.g_varchar2_table(3137) := '1C71061E082DC7134C238F5A64A8C522F29CD290EED04A204C397D472D196A21EAC00880F820D8A9F04738432B64F01FCD18C5047D478012940857811A7362D430010820CF296D5182304E0AE4B14221B568C31C796A811DB5E451485B74A284A11708E3';
wwv_flow_api.g_varchar2_table(3138) := '2716911783885AE124C0D26B7C439256C2103D021374C2BD410F0DF889213164284115502006DF2643092ED11C19EC0A97E80B9E6005D308502B10234F8910C65BDCA623FC5A308721DAE2120278C5113F05DA8FF7C80FE3210AA9C5079C7F888CAC9208';
wwv_flow_api.g_varchar2_table(3139) := '4804240212819F2C02DC237829CCBB72EE863B4010377D5EC17363E586C8A9388ADBAB38D24A24EE718524F4704AE6C1CB3F8A4734AAC970A31209337843E2E9875B296FF1A9E59EBDC32D718A3006B8E93EB056164A04240212811F1E012278308487D8';
wwv_flow_api.g_varchar2_table(3140) := '2D5CFA1E28C39590489D988CBA5D405C4CB7973C307FBF72AECE48524E12F942434AC8A3990C474C178445A1A815CD45ABED4A0ACD85C0760DDB9B505E10282811198E8556F052AC039D70E681AD2814466948DC1266B55D985AE2B104690F1E3CC84D84';
wwv_flow_api.g_varchar2_table(3141) := 'EE5042425888712471AB83CE8972AA302ACA0BE0081C282CC888FC767C84E70599ED1AC88B5AE485FEED9EA09349C830466E9F480AEB141694D344E4B7EBA490532156F04A640AE6C8D0351829145438C0913CC17C22BDFBF7EF2F342F342423D4E21244';
wwv_flow_api.g_varchar2_table(3142) := '5720C0B1E0001A7624E477F8BC5D5868A6848CC8D39CD31D4A1ED729A3FC1055F07C7E545FF7FCF0908685AA4822135B5EC99A34BF45DBB161CCEC5AD4928D64E28AB7C4BBB6A166C2AB499D1AB41B22AA736A62A421E4D22CF93D452607274BFD46B387';
wwv_flow_api.g_varchar2_table(3143) := '4553659208480424021281270B01EE11DC1FF9EE49DC370BCE71A7E366FA446F8354F055662402120189C0338C0097E347EBDD76FAB13D5FD026348B6341A060AE9029C8176444494160878682FC0E8142F9F6E6E8E466438910E628328592EDC2224F8C';
wwv_flow_api.g_varchar2_table(3144) := '51785210867111BF85DC0AF62BDADEAFA7D050E82974A790A1BCA059C80855857251283417F43FB0B65058709212C1DB45C3ED86EE77A0D09C0C6987C5EDA6457EBBE68230FD25F4CD69A14464B62B4466B33EFF1B136E6C77266F7B5BBADFE782F076CD';
wwv_flow_api.g_varchar2_table(3145) := '85FCB6A64F7A96FEE7D29970326DCCC42D0EE7D0627CF49D738B95967F54AB77D6BD9061A7DC64D264D4B325C93BD7475BF483CBB7965EFF977F787B4C4BF57C71D7AAFE79BB37E23BF2F98D61D368ACFA85D75239DDF5BE9945F3C481E75FB97F23DC27';
wwv_flow_api.g_varchar2_table(3146) := '1D0BE99F444022201190087C3704768695BF9B36D95A222011900848049E35040A04EC1B76AC40BA0AF268605E2EB38BEFAF2AC8907978ED76C9EF298F03DF1339BC5F338678B3C07CE987F7E5FE860F977F566BD9B2E9C285FE0FCE9CFEE8B7BF8B2FF6';
wwv_flow_api.g_varchar2_table(3147) := '2692D9D40A61E09C9249D2E59170E69DB7DE57524BE417A3ECC59D4A26F2E5C9782A1DD94830E72093761A9540A8A2F7E214CB7BB3A94C5175D9D0E4B0925C7D561193FD9208480424021281AF43E0C95D042B91CA98743936A017AEE7970465938CFBA6';
wwv_flow_api.g_varchar2_table(3148) := '2FF256783D12B5EA3206CB37FD9A2895CAE8B41C5BA37F1D28B25C22201190083C10012299627EEC036B65E1EF45404CE5FDBD623F2981670F136ED70F9F02FD08E39B5294CB9F0C34ED89F6C7CD4BFD1FD675FC55E91F1CCD04EC366B3E369EC92A7C9B';
wwv_flow_api.g_varchar2_table(3149) := 'C5FFE4FFA0B3AAC41CA8AD6076B7ABA532ADB80ED5D9CC46BBCEA4570EB4D5BC7F6B78ACEF4265D373BB9A4B96276AFBAE5D6D3AEC56B4FCB2613249042402120189C04F0481278304328170C73A1C39E5E6D84257309D7394A90AB73775299E8EDFEEAF';
wwv_flow_api.g_varchar2_table(3150) := 'D8D70A27162562849623A92B17AFEDAF36796AF6330B6DA79EFB86115D63A32B414FDCE17FF0D7CBF7B590051201898044600B014180251C120189C043108000B350C843041EADCA1CC99DDADF1A9E2B898CFCEB52BB5E69A92AE8F19BB5D6F61645CBAF';
wwv_flow_api.g_varchar2_table(3151) := '92DD52CA0E4F1EC597AF2CF2E8144F45418C39068A8185E8E0C96A2E9B7F5E60312EB2F704644E222011900848047E0208FC080478261C9FEEBD138DC75BAA3DAE50C38D5B93AB8BA3F545968AD6DDAA666042D3E5DEB1CCC2C88DD968D7C9B26BF3C6C4';
wwv_flow_api.g_varchar2_table(3152) := 'DCDDA6AAE0B539E3CC6FDEFF79B97D346C4CCE0F365495B8437590E1D337C6FB3F3FDD56BC7FF0CEC4FAFC70BDCFEC69DA935D9A751697DF9D5CAAF6E46E0D6EC412535E35D3B8BBF3F6E4C6DAE89DB9E19563CF974902FC13F879CB2E4A041E33021060';
wwv_flow_api.g_varchar2_table(3153) := 'D263562AD549042402DF00019FD39233D82D5AD660D9B9BEE6DC46F6EAA5EE5DCD1E459FE7C05F97561359DBC84CE53FFD1904389A55122B334DAFBEACA8B6AF9397E512018980444022F04C22F02310E0D1A5D87CCF557D4DD3E8D8902BEB981EB865F1';
wwv_flow_api.g_varchar2_table(3154) := 'DABB6F4E145715991C5523CBC991DB57CB8A9C898D04B1DEA9D544EFD9CB897197AEF990CA8AA92C253A1FBDF3E9C5489BFFE49BE5ECAF9188261BCA8B96D4D064FF2D87C7DA7D7B7A973FA04C4DBA8ACB6F8ECE05F5B96B57661B1A33A34BEB6C2472F3';
wwv_flow_api.g_varchar2_table(3155) := 'F26CA52F914CA5D4FC0B60992402120189C0774280E5EE59A49723212F92F85C53E4C591120C14CAD9788685A0BE9349D95822F09344802DA73A5E6CD2ACAE9662A3D7716A07064EA35A555DA1680FDB797121963977E97A8323C2168DB1AC72E58BDB5A';
wwv_flow_api.g_varchar2_table(3156) := '32A599BFE9C7533B2CCA5389804440222011787A11F81116C14AA5530D01E3BEA387537ADBE4D454B57DE3D4C9E756B48A44781E1C871612A5A6E523C79FB7F8AB561219FBE272FDAEA689D9645DA5B9A3B15971971BD723658DBB4616524A7603F9C662';
wwv_flow_api.g_varchar2_table(3157) := '5FCBAEB6C5A8BDD2187BE1C4F12573757C6D22B511674AD3FA5A2C9349BAB4DCD103FB02354D139361CBDCDCD1E78F7BCADB726939E5E9E9FDD14ACF25024F0A02CCF3648D7EF6746173B84212BBC4B1511C8BF893D8FF86C4CE40D3D3D38B8B8BF7BB0E';
wwv_flow_api.g_varchar2_table(3158) := '556683DCFBCBBF6109CD21E1706C1C181D1D6567BC873444869D9C68B243862F36E9C8F672BC650702E47748DE7FCA46B5A221BDC081ED1F7F52CED653DB9B4C4D4DA179BBA1F1F171760312326C8ACBA9786B400962C8176AC94C4E4E6E6FBB5DB3CC3F';
wwv_flow_api.g_varchar2_table(3159) := 'DB08F0B6BEFE40A5667257FBACAE8AAE1D9D2DB369275E3CAA1898FCFCB529955174A970E30BAD8A62C8BF025F0FB736B62AC69DC1E4AF6D2F2B24021201898044E05941E04788001BF5AAC365D5E9753693D16A710D8D8FAF9D3EEBCAAD1B2C8DA0EAB7';
wwv_flow_api.g_varchar2_table(3160) := 'EB07A2864BE72EA4579762D98AA1A1D18A2A356CB1995575389CB44E0F4D0C8EBA2BF439B325FFC5EF66D232395F917DA83FBB7EE6AC2B197138AAAEDC1A593D7776636E4153EA9C66B36630998DA69C4517B1D82E9CBFB036B3A636163F2B2328FB2111';
wwv_flow_api.g_varchar2_table(3161) := '9008FC6808407D09FFFA7C3E8E38C1ECE802791319D81A895AAA2087D0E0EDBEC2182977BBDDEFBDF7DE9FFEE99F6EAFFAE67948F5071F7CF0AB5FFD8A5D767B7A7AD6D7D74F9E3CC966C50FD400A185E8B223D18E5A3A02732EAC48CC29AAE0AE4D4D4D';
wwv_flow_api.g_varchar2_table(3162) := '7BF6ECD9215C38A53B57AF5E857EBFF2CA2BD83D7FFE3C841F3DC78E1D4306DA7FEBD62DF4FCE55FFEA56832343474FDFA75BA7CF8F061E1E1E0E0A0283971E2047BFD5DBC7891560D0D0DBB77EFA609AAAE5DBBC6AB84E3C78FC3AB2F5CB8405BFCA9A9';
wwv_flow_api.g_varchar2_table(3163) := 'A929F8203312816F8880DFAAFBD9F3FB3D0E0B7FA9564D3979BCD5693528DAC33606FF869AA598444022201190083C5D08FC0811E090D3EA286BE41614280AD55696DB4AEB23E1484793D7EC2C07BBA6A0D95FD94EB8A4ADD2E3751557EC6EB0E98C6D9D';
wwv_flow_api.g_varchar2_table(3164) := 'F55EABD75E57E5D432351D755EB3A9BDB541D1D0A11417D9BCC5A1DA32AFA31C3DD18E3A57A0A8DA5E519B88463A9B4BCCCEA2EA6616BBD2FB3DEECAAA6055574B3412AD2CB3D8BCA1A76B9CA4B7120189C09389004BF8C2DCA082445689FDC200575757';
wwv_flow_api.g_varchar2_table(3165) := '61B6244E2D160B5BDD904C2613CB4717E8317D210FBB3B7BF62CD4F1CA952BC436C7C6C644395499E82B02703FF4DCBD7B17B514123B4500760A6F449E3CECBAAFAFEFE6CD9B305BDCA8AAAA62B7A13B77EE5045829AD284982AACB2BFBF3F168B21834B';
wwv_flow_api.g_varchar2_table(3166) := '68C0E8F0F0F0ECECAC90A41778481ECDD054D866281462075A8C2289159AD041215C38E221F41B79046888B7D5D5D558C71032D4E2009C965A4ED179E3C68D6030C88EB8382C4A4000434C0B470C260C50CC128754638EE614528B63C8A3167F4A4B4BA9';
wwv_flow_api.g_varchar2_table(3167) := '150A0B6EC88C44E09B2060643D2C974B305E1D2B44BB1DAAF16153A6BF894E2923119008480424024F23023F4204B8CC6353DDAD8AAA584A2A79EA7AEEE0AE74BCCE6A33B1021608DA0CEAD1AECE4C226A624B7B83E1B9AE22355E6EB098743AC373475A';
wwv_flow_api.g_varchar2_table(3168) := '4D5AD653A2CB256B4D6693D821A9B8880FEA36F51C6A4F25EBEC56CA0D47F734E4E2A546AB59A7EA6A77F1ECA505037E168F3EECF5246B8B4C069D7EF351EF691C30E9B3444022F04421404C127FB894C1FA60BC3037B8288C0EEE47827912FEE514DA29';
wwv_flow_api.g_varchar2_table(3169) := 'E2C005E72178B05C26FD12D2A4496F6F2F215CA3D18812881F7411B24A9E202AC412FA0A7F868BBEF6DA6B10D7DBB76F63F7E5975F66FA31166B6B6B510E7524840BDD2D7C664C4896B6C8949595317F98E6757575306A9C397DFA3444149F5F7FFD754E';
wwv_flow_api.g_varchar2_table(3170) := '71060702810084BCBCBCBCA2A2A2B2B212DF88155FBA7489882EE41C3D68C334FC1352BA7FFF7E341C38700085748A9EC2BDD18F515E07E003A77BF7EE7DFBEDB791C75BDAE2C01B6FBC012CBFFDED6F6982759CEFEAEA825AFFCDDFFC0D3AFFE22FFE02';
wwv_flow_api.g_varchar2_table(3171) := '0480858E4386B145649B5831B15F0021328C6F7858C05066240212018980444022201190087C5B047E8408B0C6A390A6E399914746DC858EDA1C76C17E85F766836AB3DBF5062626A916BD66B6DB61BF54598C7A4D6F341B74169BADB08BAFA6B136D6A6';
wwv_flow_api.g_varchar2_table(3172) := '1EA3C6D318EC1749B35EB5D08A3D845555A7CBD762146D060DCD36BD8997BEF96756992402120189C077440076C72508B247220F1135180CB0388E3058982D894218E60E43B482AFC25D096C524B6C1331E82E8473606000C2090F64BA327491B02A614F';
wwv_flow_api.g_varchar2_table(3173) := 'A2BB304662B6EFBFFF3E715DC2C2C445DF7DF75DDA424D21CF18823172DAD2D2226C21E3F7FB31C497B44C668639435661C8105402C84C2486918A6F74219C44A121A208E039CD91C17F5A4183318703A2835881B592904133E4990C9E437DF1E1934F3E';
wwv_flow_api.g_varchar2_table(3174) := '21584DB9A82D50714E4988A1935438159258C46D9C11A6452C1A194875FE76A169940314B3A93FFFFC734C532834C8A3444022201190084804240212816F8B40FE31452689804440222011F82E08400B89D0C2F7885B1A8C264E0D46B3D3ED2D0A0661B9';
wwv_flow_api.g_varchar2_table(3175) := 'B044381BF46FBB09781DA4D7E572C1F7680B6B657A30338A61B994B7B5B511D1451E9A4A9EB77BCDCDCD4468E1A5905528315FC9620BCA0D4386CD425C2F5FBE0CB985B2C230F97A16D60A65DDB56B17C2D0E0F6F6768489A3A213B649801749A190F82A';
wwv_flow_api.g_varchar2_table(3176) := '85B4E263660A99F60CF384C7E218263A3B3BF944190FF1848648A287444624FA45397395E1A890589460051A4F2D62C2227C1E27518887107B3AC884674C40DD29A7B0B5B515860F45C76D1A820333C989F7D2110444F7C107BA4E77B60CCBFF24021201';
wwv_flow_api.g_varchar2_table(3177) := '8980444022201190087C7B047E8429D0DFDE49D94222201190083CD10808120B15341B0DB96424A377E636160C89A99C21C43787D94D8A084BDCCE1BE90FBC94C82A415D41EAA079B06208339FF5A28AC5B1443415F22C968C723A9D1E8FE7E8D1A3F040';
wwv_flow_api.g_varchar2_table(3178) := 'B4D10A4E8824EC9749CE2C85451E7A2CA2B8505654A1105A8E064CD316428B5ABC15EB6041BF09AE1237865D234073316D1B7902ADB0599C84D6BEF3CE3B1063DA524EA210B5A22FD066583447783B01643443B921BD7CB2CB1C69C420B11CE92353A0A9';
wwv_flow_api.g_varchar2_table(3179) := 'FAE28B2F107EFEF9E7891513FA6E6C6C3C77EE1C1996C5C234B419B5107EC2CE5861EA35215F7A4A06AA8C00924CBAA64A26898044402220119008480424028F868024C08F869B6C251190084804F208147820344FD3319737929BFD22EB6E56E7CE660C';
wwv_flow_api.g_varchar2_table(3180) := 'F6ECDADD6CE814140E49E8A598E25B000E5A0B278434F2652F857CE38A0CD494002C7C12A2485014FD08C00F11802EC28161B0DDDDDD48C26C21C094136146D5BE7DFB9884CC29441A520A5345156D09F6228C366C89803302942309ADA52D0D89D0D204';
wwv_flow_api.g_varchar2_table(3181) := 'F738122B460C122BA637339DFBE73FFF39E5C813E6157169F2106C8E0499694E434CC04EB1482C17A60AFB15326FBEF92619E1034A8860D304B7F9F219FE0F6F0736329440D7A1DC707E418011C39CF8B418164DD7F08A123041A14C128102022BF1EC9D';
wwv_flow_api.g_varchar2_table(3182) := 'EEEE80535B4F68F53ED555B1AB50F5F0CCEDE9E8DAC8B5C3FBDB15838B290DD707678BD3A3A126DEB0EC9C631F4DE6B2E11587D7A5A8BA4456595A58F2397426AB9B491D8B0B6B767DC2E6297AB82D592B119008480424024F0E02F9B0C0FDDE140AC9F0';
wwv_flow_api.g_varchar2_table(3183) := 'E82612CF373C129198DD479081D7F9D4F2F8727F734A10E6F18BE79507D6CA428980444022F0C32340E0143AF710BB854BDF0365B812128784CB156A39E5F35AC2A7C44BF3D749559F5B1DD27AFE4DA6E479EDEEBFCB783BB20667A2EECFB3D9FCF590A9';
wwv_flow_api.g_varchar2_table(3184) := 'BF5056E865A1F913920196DFFDEE77D06FD6A37A425C926E3CD508F077C44B90877481BF17DE747CDDF3C3431A528572310D4188F104F3D1ED85BBBFFED747DFF8C53B9FDCFEC76D1BB5A7FED5FD620FD4F949FFCAF2D5DFFEEA57AF28C6402697FB37FF';
wwv_flow_api.g_varchar2_table(3185) := 'E952D7C67B47FFECBFDB4180E723E9DBB76F44AFF4BEF62F4EA5F5C557FA8767866F0755C39EA3BB07A77513FD574DC6C481CE6A47C93725DE0F7446164A042402120189400101EE116225145EDF170AC9700B603E1A5F8D31410C422A3E3DE37D3D8524';
wwv_flow_api.g_varchar2_table(3186) := '9EF178BFCF4B79DED1D390940F4EB05ED466127AC41D444680B7A32AF31201898044E0DB21C0B538FF7290EF7BD3F1DCDA50463391491BBD3A475D2E9B56C36399C45A4E67E3C35BC4BE9DEA1F4A9AFB04A1E0279099FF5000483B4F01024945B97CB55F';
wwv_flow_api.g_varchar2_table(3187) := '8B4C25355B9129D9B4779FAACB2FC0B6B2A19CBF78D9347BD7A437AC13A84D44E763E93BD76FEAB3D180CDE4AD6F1EBC7CA7FD60CDD55B0B8DB6F092B7C934DF57DBB197190CB465354E9BC994D48C5F5CEB37C4E6067BFB3BCB377AC757E2BDDDBB5F66';
wwv_flow_api.g_varchar2_table(3188) := '0A835DE092486713D968FF95F157FFE9F262C2DF7FE5467DA3F7C3FF7CDBEE8C0F4E6AE5C5A6F7EE266DF3BF3DF4CF9A85DAA7004DE9A24440222011F869232017C1FA698FBFECBD444022F0DD1020EE0BB3CD6672E9544219FB9D36F949D6E0CEA8A69C';
wwv_flow_api.g_varchar2_table(3189) := 'DE9A27C0D1C95C6A037A8C1854F9BB99FABE5A335587FD8A764CCFFEBE8C49BD1281474220AE281F9EBE3E7DF3F46226F7DEDBA7379687B6D4A8CC386325F62C7B3EA89A9AD5EB3FB9343AD67D762397FBCD27D7A6C77A3E387D717CE8F63BA72FDE38FB';
wwv_flow_api.g_varchar2_table(3190) := 'F1859BFDF3FDF9E5D9449A58494C0C0EDC1A5B3AFFC9FB5A269AC8E4749A6E399C58189F62E3EA2FA59480DDD0BA7BB7CD1D5072DAF25A521D097BACBAACDF37323195494F64AC76AFDF397D8BCF1CF24BA3CB24119008480424024F3E0292003FF96324';
wwv_flow_api.g_varchar2_table(3191) := '3D940848049E6804F20438C7B3B329E3A8CD6533E99293790E6C0EA66D151B656FA6351B65A4273602FC44832B9D93086C22C0DBA368345EEF37B61FDA3F369F4AACCC0A60BC66C55B56137269A1860625AB4B6AEAAD6B238DCE48D7B1A3FD6B46736422';
wwv_flow_api.g_varchar2_table(3192) := 'E32DBD72F6529143EB5ED0CDDE385F59CD67F35B73DF62894C3CBA7E636CC9B43A7AF0E8016F79532695AA2AB6D7EFDFCD768A05E0F31B2B9A1D6A96ED1AF58A5E37B6BCA6DF98F156D5E82DA6E1F9ECC6C2784D79506F703235AFD04466240212018980';
wwv_flow_api.g_varchar2_table(3193) := '44E049464012E0277974A46F120189C0138D005F9210D7E583C6A5C5C5B9B9C5657BD78CEDE84CB67C3EA24E9A0FCC9BF6C48B8E67555D9E216FA6AFEB0C4AA8DF514B21890517D807E8FEDA1DC20F39E5431AB1A8F24364BE49151FDBB098332EED1066';
wwv_flow_api.g_varchar2_table(3194) := 'F167B62CDA51C8299F16B3E4D5FDE5BFB78455ACF9829457062CCDC52258C8638295B1F9DC5A58E7C85E4D94B05B52411B7996B316CB808942B65062316AF1312A3B2AF7F6F6166AD120BE2F626884366A0BDA58818C3C98534517E848C1CA2367583503';
wwv_flow_api.g_varchar2_table(3195) := 'EB4227A6F1E79155151A322240C429F8E33F79F19205B7D94D0A0031045085372F0246F69A2A94E0063D7D2CCE14BCFA9E322C4BC596D077C6576F9E3F5F5F9AB178EEAD3FA253D82D5AC70F938FBDF8C4BFB63134B862BC76FE7C95315652511D6A68ED';
wwv_flow_api.g_varchar2_table(3196) := 'EF1B3AD9129A71D63916EE1435EC2978C8D761342CF559D635EFE54BD7134B937A937162213A7CBD475108396FA5E544EE8BD3D7061786AE5FFC2260DD30B68406A622DAC2787D6DADC5DA185E9C9B1E19ADEC7228CAC3D617F85299FC5F222011900848';
wwv_flow_api.g_varchar2_table(3197) := '047E7C04BEC76F80B9D3F35CF8E377517A201190084804BE5CAEF9B12301D98069C0D3205AACBD108FF341F01AEB2FC4E30983D198D2C77870E7235BD660E09228965EB8DF0718172CABA2A2627B157C8F151D585A19FDDBCBBF6D1EC75849422CE3FC6D';
wwv_flow_api.g_varchar2_table(3198) := 'DB6E97C74308B058777A7B39FC9C6527589B7A7B21B00C0C0CB03CD8F6C26F92879B41E458D41AD27EF3E64DD6E562890B782C8B420308EB5733619B9702AC178D24E5AC8F0DBC00D8DFDF4F063AC742D9E006D9430FB0C33CEBEAEA7046E8C14FBCA5ED';
wwv_flow_api.g_varchar2_table(3199) := 'E0E0204D30442B8471180E79F0E041A682638891624CE92CDC124FD8DCF89B38FF1019A083AFA29365B41991A1A1A1FB917C48F3075689B7006CAACC626C6082DBF4512CB5CDA0F0CBA18FBC05A08F2C048206C4400331F0613D6DF10A80CDB4F8653E50';
wwv_flow_api.g_varchar2_table(3200) := 'FF1355C87B1716BF4A6633EE54FC95D78F47CCE5B3A3A3905E8F5DBFB7D66335FDDCA4E98F1F6E0F94C45F08D6DF321ECAC6365E3FD1E608B61D6E5726932F3536379CB266CA5633295BC5D4E44C2E1537E8D5F6A03975ECF9E6FAF2F873A7E2F1F0F1D6';
wwv_flow_api.g_varchar2_table(3201) := '604579F18A419F75F0F5EFBDF040465133D18DE6E38D1B4983DF9479F9A5E377AF5D3858ABD63674BEEA30F6DE4854EBE24D478F1702CB4F146ED21989804440222011B81F81EF8B00F3D8C1431B0F253C55DC6F55964804240212811F1E81AFE39FDFC5';
wwv_flow_api.g_varchar2_table(3202) := '13416B6114BCEFE3A24748496734B00821148BFCEACA0A1743C81BA46B07CDE0DA082199999981B041C0EEDEBD0BF5420F748B269016E81F7A3A3B3B39E239313D42A33031B11111C48CB6785E535303F9819DD20A4974A2847D83A03AB0201A621ADE85';
wwv_flow_api.g_varchar2_table(3203) := '393440BDD8738844431C8641E13314086D288726B1EB2F79E8256C0DC7C8C039214BC843A5D8A98888280C0AD2482B489DE802028437B9E09390413F4A70004F88376202B759A41187F3B0E874B4450F8147F440D8E83E0B02E32D79FA82272C494D060F';
wwv_flow_api.g_varchar2_table(3204) := '7103CF2961C9471C403F04984EB116376DD9FA58A02AE865474707FB0C0B0460BF788EA1B367CFE2064A58E8EBB3CF3E035E1823DDC11F1820FE800F5B2BA11349F1D216A028618B669A2306B6449BE196A04ABFE8290A795B81C3382960A79C2608030E';
wwv_flow_api.g_varchar2_table(3205) := '6AD90E8A5D9761B9184209CAD14913DC838D032C445D8C38AD1814FCC70D1C4339CD692564186BF4508B7E80452DAAA825D14D1C0064104006497A47211802149E800FBF28D147D144885DBE7C19EB0C19AE629484064A40066CF9E1154C88564FC8916E';
wwv_flow_api.g_varchar2_table(3206) := '9B0D6A677D49E3B1C3FCCEEFCE6DCC4C4CE4B28AAEC8BCBFBE5DA9F9159FEF3E7FA443A7291E4D173C7128974EB214A8AAE9DB424ACBEB6F82C6CB5E4553CBD793FAF199D96C6CDD6AD43A77356955CFEBF4FA574F1CC8A4137A22C83AAD4CD12915AFB2';
wwv_flow_api.g_varchar2_table(3207) := '4256A1E35EA3F2D2F1BDAAB647638EB5D1DC51A9ABF79FB499759ADE545FA594169D32EB727A93B5202F3312018980444022F08423F07D1160EEA03C16F0DCB3E399EF098743BA271190083C9308882B9288833DDE0EC2AC205182A38A2B1E2518226194';
wwv_flow_api.g_varchar2_table(3208) := '12718A512E891416AC530E41120C13DE45420F0956038D4192B61CA17C7027980CC2902204D0002D24F8090D43061E45860827040F3A04F1839511FD8305510B6D83E1F0F40FBDB975EB166DD17FE2C40934434DA15590730818B150D8112C8872A82934';
wwv_flow_api.g_varchar2_table(3209) := '0C0DA8824D21CF11F7286787DE9E9E1E9CA1154E1260A415EC9A56B88757704EE2A8478E1CA19508AE62172B1CE18138005D87CEE11541691AE22A5C17552817E47C7C7C1CFE8C00741155A084CF1033B83A20D3534EC96011F7E084642881A322837512';
wwv_flow_api.g_varchar2_table(3210) := '20500267AEAFAF176C993C0C1C9DD4E20C3C1340F0E7C68D1BE8675CE82CFE6017AC401BFD34C4377A049314D1669C017F9A008528A73B380068449511C628405188724177C147B05FF1424188D116C9FCAB82580C5830CD08D27DD4D217AC601A873972';
wwv_flow_api.g_varchar2_table(3211) := 'CAB830AC18E5B7C4EB03C2DD0201CCE130A4B7C096052DA71583CE9B05DE9BE039AF33A0EE98130907F0963C7E2286425E2B001DDAB0C84F8B0E62E84BF127EB7FF6AD7EE1687BA9BFCE64B6E099DF6E305756F2E370DBF43ABD41046CF5FAADBF2F9341';
wwv_flow_api.g_varchar2_table(3212) := 'A718F262244D55B4BC005FEF723098F54A55692897F621A237D9D4CDEDAC89061BF4F73EFAA541BEE59729BF58B4ED5E2D6A1CF62DBA4B98D86EDD32F4A5B8FC5F222011900848049E7404BE72957FBCCEF254F1C4DE4A1F6F4FA536898044E0C947E0FB';
wwv_flow_api.g_varchar2_table(3213) := 'B81C4151E036840AC59B3ED814893C470029E40B2510920250F803458175C07C44C894A01C3C16AA061B8111C152E033504D981294065BD0158EC8437BA091AFBDF61A79E296442621A51C613BB442091A20C0478F1E85F2418DB0853C7A083FC2366985';
wwv_flow_api.g_varchar2_table(3214) := '5D28255B1F210F118202315D191918172C8856F0CF6BD7AE3536367EF8E1877036A28548725527F3CA2BAF4011E19F38432B581C1D44396C101FCE9C3903B3C501569626B44B137A8166AAC84377A9851FC29021C368C673BA4FF4F2D8B163E4E163FBF7';
wwv_flow_api.g_varchar2_table(3215) := 'B3034D3E01204D90C75B7080D9528B6F7407FA475BC8213E9011B0D0044F441E19381E25681032E4D183E7741F43E4C530718A368E74164970232A8BCF845BF110EB3067AAE82FBD00ABD6D656B83AF28C02928C140244B0819D429C611CA9C213346005';
wwv_flow_api.g_varchar2_table(3216) := '37D00959C5734AA0C45431F4E8041FD043B378798124E676EDDA25E834589D3B770E8BFCC6C09981A321BD2051C81B07ACC3E7811AB7F10DCDFC78C840E3E1BA88617D533C9FA1B3A0C78F819165A4688836DE5F208FB7F886E7D8A510C444AB27EA0801';
wwv_flow_api.g_varchar2_table(3217) := '7EEEE0AE82675EBBD16BFFCA2703DFD05B0870798875B06492084804240212819F2E02DF2301E6F9E3A78BABECB9444022F08421F07D5C91605344F0E0303B940B66550080537805340F0E592824035DA12DEC0B7A03BB830E414A099C0A196895882E72';
wwv_flow_api.g_varchar2_table(3218) := '0A5F82BAC01B212A1C2130D4C282500B55C33A6EC05B5005BD81ED90A709CDE1A59C22863C9149CAA16A901F281C94124604E91284076D502C1891D049D760C2B4825CE11B3489A0229E1081445294439928A71607508E27104B41C6688E0CD40E139031';
wwv_flow_api.g_varchar2_table(3219) := '742283273079E4E9387A288110D223483519CAC9E01549202060A4158EF1EE0073503528BA889AC20F690263847902082B60091E8B039480367EA201FD7C6D4B30166C7183B604CF992C8D096AE93BB0F3E2405050F2C8E01EBEE121DE4226E917BDA36B';
wwv_flow_api.g_varchar2_table(3220) := '14822A0D1947D48AD1470C9D1CF153808C301C18F4F08DE82EDD07703E66A6A11847DA92C8A39342F27882182008736806048ED45282187E12B8C60A25A250C496310A2C04F3D1868C78F1C16F005785249AF1871F0F449D5F0EAA1862FC8193F34BA309';
wwv_flow_api.g_varchar2_table(3221) := '0208D323804586B6148AB64FDA9177EA4F9A4BD21F89804440222011781A11F81E09307014EEC14F2334D2678980444022F07004A016C4F1886D3E5C8C2B213403F652A076421EEA224826E4070602BB839D42C050080783AB5022980F5C853020BC0576';
wwv_flow_api.g_varchar2_table(3222) := '872AA811F37BA185E4E181041E05FFA139ADA046502924A17354A1193E46420376C56599230D219C28E17B5A6A510E9B826742A2D08FB7042D91A796869034681EA7F49753246902C1A639B684B7F40EEBF800AB470F26288704A28D5825FD826C234F97';
wwv_flow_api.g_varchar2_table(3223) := '9111CC4DE0401F0F1D3A049716616151C8111C308A5A7A4443F2D033782C6DD10C7A28A416CDB84A6791114D700C8B905E4AF00461083F1D440F4AE08128C728015E1C064304000A6194C0A505F3C4164DA08B8C32F2F417228D6912A7140AAE883CE000';
wwv_flow_api.g_varchar2_table(3224) := '170270D402C878850C6EA01688E0C6B412A718459253DCA68A5350C20DB82E3A69854EF2C2046A711E611CE6F74097C9F383E12741C09651C679A0C367BC450F0285E5B5D04C1FC56F06FDF8491E315E8B90184A548944F7D18980F8797C592CFF970848';
wwv_flow_api.g_varchar2_table(3225) := '042402120189C0338840FEB1ECFE6E150AC970171789BB3E7756128F1DDC7779F54E2DCF31F73797251201898044E06944A070E97BA0F35C09213310C207D63E42212484CB29AC03AA431E0D820B417EE033101E988F08FA51C25517FE23CA39C5556A91';
wwv_flow_api.g_varchar2_table(3226) := '81D17159E694B65C961113CD6132823841BDF09C429A538B184A4409113F2EEC68E00877A20A3E0917A22D9A514B2B3C84D409368B87341476711B6D24644868805CD10A1F089C82124DF00A1364D00CD92650492014EB744A584480538E10782421AE30';
wwv_flow_api.g_varchar2_table(3227) := '43840598984627890CF86085BE605158C1133453822A94204307F15FC8534213BA40EF10A315B5706FF248528B095CC51364A8421B25744DF040F294A30101E13FAD704CB84D0986C8E31270E10F25022E9A204939638A5A9A88570098163A2914D69141';
wwv_flow_api.g_varchar2_table(3228) := '123161972390A29326A84261A123F849A29C8120A28E24DAC46B17610B9DB8413947DA8A37179C022C1D177DA4835409313228046A0685E8372419CA4D95F829D2F03B26EC8ADFDED7E9C1163ECBE787AFC347964B04240212819F3802DC2398D525BEFF';
wwv_flow_api.g_varchar2_table(3229) := 'DA0E05F7176E6A7C11F6F9E79F7307E41980531E213892B8B17287E576C9BD35FFF4B0F95822EED1DC55851E919104783BAA322F119008FCA411E0C2FA90FE43211E2F017E88AD67AF8AB030E8F111F2B3D7B51FAC47046F0B2F3508FC7E77BB7C484CC0';
wwv_flow_api.g_varchar2_table(3230) := '9FB5CD786EF8EEDA0A1A24012E40213312018980444022F008087CDF04F8FB9D02FD081D964D24021201898044E0D94300C2C674E267AF5F3F648F884E931EA34582C0A4C7CB7E1FA37BDF50552CADF4F5DD75199249D554EED2ECC17B4BCD7D430D886D';
wwv_flow_api.g_varchar2_table(3231) := '2E5BC79C82DFFFFD3353057AFAA64BAD617F453D33D3D7E2D9B181BB6DF501CDFC805712E934DBA129AA965F813A9D55B2A984D164E443846FEE98949408480424021281C78E8024C08F1D52A9502220117896111073659FE51E7E6F7D631A9244EF7B43';
wwv_flow_api.g_varchar2_table(3232) := 'F75114335B8C664FFBA0F44C866F7CF4D6FEE74F9CBED0F3B3A6C4A311E04BBDF381C8604DD7A1DFCB4EA1CADD77262DC5F3FE8A06D09B8FAB6FFFF6D3E67F7E600701466C6431DC7DE5F2E1D278F1AED722C9DC17DDBDE9E9C17D8D1545CD6D7C45FE28';
wwv_flow_api.g_varchar2_table(3233) := '0326DB48042402120189C0E340405E821F078A5287444022F0D34000AAC0F7933F8DBECA5E4A041E1181877F4AF0684AF9C4B9B76F2C1D994BA474A51E5D4563ABA2E6BF155FDE503EFDFC526EE88AE18517A616D692A5E1483A77AB67408D2F95FB9DD6';
wwv_flow_api.g_varchar2_table(3234) := 'F2BAC99EBBF51D157D832BE596E8BAB35A5B1CAA686C867F425017A399B1FE9B9A92F5077C6FBF7DB53272F18F2B8BA386E2F1E14187BA51DDDCDC3FB6948B2E2692D972B7B9B4098BF947261AB2C7B7D9609C8F26876FDE198F266686FBA3898EC1EE9E';
wwv_flow_api.g_varchar2_table(3235) := 'A6A0DE5E82F27C426C76397C7B62A96AFD0204F8CEE0F2CA486FD662FFCD5BEFFE97152ED5562DC4E451222011900848047E78042401FEE131971625021281A715019EEC59A6E8FB78BE7F5A11917E4B047E1004128AF2DE67DDB5993B99BAC3774E5FFC';
wwv_flow_api.g_varchar2_table(3236) := 'B37FE930B9F3539D99901C654F2F9565C3743ABDC67E5C676ECECC5FFE34505D7DE3DAEDC32FA6DFFDF0FC3FF2C5DFFA68E025CFDC58F54B55B39F573436D11082FAC9A5E1E9336FED39B2CFEDF3ACCD2FC7958DA544EC938FCF65A2134B8B4B3F4B2DBD';
wwv_flow_api.g_varchar2_table(3237) := '7733D694E98F571EBE7BF6C33F2E711ADD79D64AC385C5F5A877FDDCA53ED3E8E57577A529958C668D576FDC296B37170830B39CABFDF6B2A6BDB9D98B3499181DAFB0EBE3C59EBFFF3CF117ABA39200FF20BF1A694422201190083C1881DFFFB9CB83DB';
wwv_flow_api.g_varchar2_table(3238) := 'C95289804440222011D89C3E4A4C5824D6B6158995090B8965780BE9699F6B2A075C22F06321C0BC8B85F9E54A47AAF5E0DE9EC1486C615478E2352B9ED2DA129756525BAF66F429BD7AF1F3BE6AE3C2DEC387AFCE6495A5FE55CD7A9D107126766D343C';
wwv_flow_api.g_varchar2_table(3239) := '76FD42918FE5BEB69619B7A8E9A5A4796966DA694CBA7DA1BA807BD55176FDB34F2A7C3A7F69553C95989D5FAC71A79B0E1EB835B0B6F1A5C57C68776E7D7675E9E6B9EE8E6A535BD7C18CC165D5A5F7B437DB837C15BC9520C0255EA7CEE23268649558';
wwv_flow_api.g_varchar2_table(3240) := '263B3631E457D7F5A58DB98C9C45F2254CF27F8980444022F063202023C03F06EAD2A6444022F04C2000CB65E71E3EA484D91216E62832E44922564C469423CC82437EBF9FD347E83D0BF7A36A7BC3FB4B44AD58E25F087F9DCC763D322F1178F2118044';
wwv_flow_api.g_varchar2_table(3241) := 'B294D4FC6A5C3F321AF024CD56AFF01976A9697A55C9EA8C860C3B6365B25EBF737159B38F8D79D464493010AC77779FF9B7A75E7FF33F769BCA86CF95FDF17F251AA2B0B13A30D0D07EFEEABB5DBBFCEED2AAE5A14430B6663139F4D954535585B7DCA9';
wwv_flow_api.g_varchar2_table(3242) := '690BB3AB1B89E1619F576FB4DD5B7E8CDD3458D9CA6C35CF2E2E841D53D96C32955560CB75F6FC37D585343ABF3E39D0639E59AC9C1F7394944CF4AC4513E6FAD4BAE66A2FC8C88C44402220119008FCF0084802FCC3632E2D4A042402CF0202704B42BB';
wwv_flow_api.g_varchar2_table(3243) := '6C4BC376A6B04D91B613604AC4A960BCECB90A5B66C3D507126042C762C3BAFBA1C1101BC0B2058ED8FA550850C81E36A15088EDEF305468C54253F3F3F344A44B4A4A3074F3E6CDDADA5AF677DD2E5310961989C0D38480A62EAC6F78E6665F797177D6';
wwv_flow_api.g_varchar2_table(3244) := '55B3BCB2C274648B516B2D73DAF7BE605074FB3A1BFDA1D8C9B6C6814B734BB3332F77557ACADAF766F5E36B7B3B9AEBC60CE9AAF988E6AD5F595B2706CBE6CDA944ACBDD2536B3AE22AAA3F72B0625ADB559CDB78FE0FDED052635A2E6BB2DA21DD58B4';
wwv_flow_api.g_varchar2_table(3245) := 'CECFBEF8F2DE8C5358CC198CBABD1DE595E5BE6355E56B8397F5AB0B470F772896503872239DFC4A6877612DEE4ECEC56C4D1B6B8BFB1B3A72B3A7A627975FDE53AA3A6B9E26D8A5AF1201898044E099434012E0676E486587240212811F0A011826E15F';
wwv_flow_api.g_varchar2_table(3246) := '36F8894422C47BD97E9D23E413FB5471CA16ED8206C357890047A35132DBBDA39612366DEFE9E9410F21E20253A51C251CD9CF1DE60CDDADACACA44434A1BCBBBBDBE1704080C953484233C230ED582C26540979CA452D92DBADCBBC44E029424053328D';
wwv_flow_api.g_varchar2_table(3247) := 'D5EEFACE368FDB7177293BDD7B953F86BA62CBA1C64EADFA4FCC3ADD4B27F6DA0CD980D95E7CE2443611F638AD9AD1B9AF4AD9E5FF95D3617FD3A798B225E1A4A5FBF6D55C6CD56AD61AEA6AFC8E3A4767A3CDEDDF9B556A7DAF796C86174E3A5616CBF4';
wwv_flow_api.g_varchar2_table(3248) := '4A4A73BA99C6515F15ACD9BBCBE7B6DD9ECFCDDDBD9ECD662A02B6978EB7D80CBA90D1BA5AE2D4AB59DDBE769BCDFEDA29B7C3FC95CFCAAA838E929387B2CA5197CB6471EA0F1FDC9B8E2C84CA028A6A7D8A6097AE4A0424021281670F0149809FBD3195';
wwv_flow_api.g_varchar2_table(3249) := '3D920848047E380404B184DCC281E1A264080BC342C9B0BD2A7C984468971262BCD0D1826722547BEBD62DC4DADADA3EFAE823B678FDC52F7EC166B982F7CECECE5EBB76CDE97412E6A56D3C1E47D5A54B9756565682C1606767272C97E6F06D9A33B3FA';
wwv_flow_api.g_varchar2_table(3250) := 'C68D1B54EDDEBD1B317CC010BEC1C0B14ED5E4E4244D08566FF7A1E08CCC48049E70044C8A72686F634D49A93F588CAB3653CCE3F5F0CEC76237D9CD46C59CA7942EC716B10C786C88881E99F58AD99D9F2FEDCA577A5349C5EB7266CD9AD9A0B233B562';
wwv_flow_api.g_varchar2_table(3251) := '720931A3A614F9B736F22D0EE633714539B2A7A5B632E52F0A726A3745931E376FB66C768BCB81F2FCD6BE4545F7F6FE75BBB63E2D160A39FA9D16C55951380DFAAD8ABFB2702A3312018980444022F063212009F08F85BCB42B1190083C23084065A1A9';
wwv_flow_api.g_varchar2_table(3252) := '82FA8AF02FB15F2828949553E828715A9BCD26A872A1CFB4A20914776161C1EBF54253778467CF9F3F4F099C767A7ABABDBD1D0A3D363676F7EE5D42BBA3A3A3E884CAAEADAD61EBFAF5EBC78F1FEFEDED85E85218080468887E8E4C8186039F3B770E76';
wwv_flow_api.g_varchar2_table(3253) := 'BD437FC1139991083CF90840805F3CB6DBACDF7A8554E1B356F8763F82DB0EA3D2D99ADFBFF7F7262CBEFADC7E4B7EBFA47CAA0ED8AA039D222F8F12018980444022F05423F095E93A4F754FA4F31201898044E0C74280082DA6E1BA905EF24C75E6A837';
wwv_flow_api.g_varchar2_table(3254) := '18209F24B82BEC7707014600EADBD2D2025325965B575777F0E041B144164C15E63C3131F1FAEBAF77747488702E85232323C5C5C56FBCF10647E639D3B0B5B5F5A5975E822433419A0F7DD1C664690C51C5C7C938435B28717373F3FFCFDE7B06477264';
wwv_flow_api.g_varchar2_table(3255) := '6982915A4BA402329148682D0A5585D25A4B166537BBA7A7A76766A767776E77E6ECCEEEC7ADD9DA99DD999DD99ED9AD98B91BBBDD9E9E56249BA2C86269AD750105AD450209209148ADB5B82F328A5968946876915364B3DC094679783C7FFEFCCBCC08';
wwv_flow_api.g_varchar2_table(3256) := 'FFE2B93F072B868FFA9BC287B44B10F88A0860EEBE442CE4F05FDEE461B428A55B147D45CB497582004180204010F8B621403CC0DFB64F84D843102008FC512200A28BC9CC48209C8846CBE3F3A422A148AAC8666827300A19E730D337B059A4A9A92938';
wwv_flow_api.g_varchar2_table(3257) := '81415C918787166B7A31451953A0210387307CBCD7AE5D432DB05994400673A1EFDDBB77E6CC195059705ACC6A862B186E61D066948012631531961343182B93E10D8606E84175D876FDFA755CAAABA377402589204010200810040802040182C02B8BC0';
wwv_flow_api.g_varchar2_table(3258) := '5725C01893BDB2D8918E13040802DF3104963969BF7CEFB0FA97A6BE394A9A0AE7BC23595919E5EEC946C2E9A831A3A8475C2CB0D0A5CA19276D7575F5C4C40496E6C2A38B7BA9C7E3814F18096C1973AAE110865F178E5C5C02C5C5B1A2A202A4D7EBF5';
wwv_flow_api.g_varchar2_table(3259) := '621634026261FE337CBFA0BE58F70B8A8BEA70355B2C16D485E5700563763454210F6F339CC3686EA90D5FBE774492204010200810040802040182C0770681AF44803196C204BBEF0C16A423040182C02B8E008FCBFD435FEAE13688041F2F7DCC717211';
wwv_flow_api.g_varchar2_table(3260) := '376BFA4C56BB8A35752CAB6ACA453C19490D582823B354394AE0C52D2F2F87B716C415C8633233F8EDC8C808BCBE700583F4C27F8BD9D4CC0466788621B669D32626BC16DCB958180C660BE5CC02E31D3B76403F78383423036F30DCC5E0C05860CCCCAC';
wwv_flow_api.g_varchar2_table(3261) := '0649C6A557FC2326DD2708100408020401820041E01547E0C509301C1A2E5FE0C30B37970EE95E713449F7090204813F6A04FEF2AD830AD91FB6656E81DC82FF6653A15C32C10ECF67D42BD9E9442EE6A6D8BC4C2A9EA1E8805420C90CD165200217C529';
wwv_flow_api.g_varchar2_table(3262) := 'E63FE394E1A5702333F1AB700A2F2EBCBB508EED7CB1D017B75990619C82D022A10AF2A88E54A80E1A5CD00C7924D0E3E6E6E6C226C0508BC4C8902341E03B8380CD155471223235A243932969DF994F9574842040102008FC0B22F0E20498C366F983C1';
wwv_flow_api.g_varchar2_table(3263) := '7FFCF0389698FD0B1A48541304080204819785C0F7F6EF502964F0E6FE410DC2619BC6ECE7648435732A2732209BE1CA298991CAA6D8BEA16CA93FCB536669924B3B66976A5E4647C169B112180E5BC8E0125CBE66B31914172E629067A6E2D22A4BF34C';
wwv_flow_api.g_varchar2_table(3264) := '9582725C42ADCD9B37C3518C3C52E112C91004BE4B08E09B7DF1E1F426F98C6CDDC1A7F6CB9BA466077A5A9BCA29FEA31D8F9E2AF6250B3DF1CC837BDDFCA47BCBBAD6ACC4D0D53B1B981D6A6F30682ADB26ECE189BE9B35466165E3468ACD1DB7C7E6C7';
wwv_flow_api.g_varchar2_table(3265) := 'EF6C5DDFEE49C9BABBBAA8907B7573A9A8A4F16EBF35BC30B6A1A14C51D67077D4EE9D78A891B157AFE918730AC6BBEFC9F8A98ED50DA2A2B2502277E3F6BD6D4D2AAEBAA673C01A981BAE3628CA5A57CDFA296BDFF50DAD1582A2AAF9506AE85E172BEB';
wwv_flow_api.g_varchar2_table(3266) := '5FD75819D754DE3D7F9FC7F13494E94D8DED8E40BAF74177A934D8D00163481CAF2FF9F11231820041E05541E0C5093010C2982ABD645BCB570533D24F8200418020F0050260AD48B92CA640539CB09D15B465948D19B60091A7B26C1E4B529AC9B1D399';
wwv_flow_api.g_varchar2_table(3267) := '34E301FEA2D233FF65B43197417D998856287C6685675F00D986AFF81B64BF30A040BC19E65F3865AC2EBC0E5856FEEC3E7D6D5796D9B3D4D4AFAD0DA2E86B45006F80161C9E542C904A66B54A814A6FA4A87C7038B492C9628284D31F8DFA5D98F55024';
wwv_flow_api.g_varchar2_table(3268) := 'E6AA8D6573CE702CB0A89008EE3BA9879F7D6210EEE495AE722FB878AC74A9511365CBBD0E7B329B12B1B3A5A69234573C3BB79809FBCC264D4A503437372BCE240C6693DD1DD2F0E312CDE3BD7C178389B87F76CC11AB12DE4B36EC1AEBEEC6D28481AE';
wwv_flow_api.g_varchar2_table(3269) := 'E17AB5A9FFE6105F1C3C71D7F6136C9D64D978FB5AF7C0D4F5AD1DA50F8713F33D0F72DA12F5E0554EA6C436FE502C11DFBB31B2B3C4787778B63C38999554B228D670AFC3373E26A92FC3EF063FF8AEC1B9A3E7AEADD65547F855774FDD2AAB15DEE99B';
wwv_flow_api.g_varchar2_table(3270) := '56998B87E7583D3D7D6D9A2008F0F97EBB60E24E5455AEBF7987BDA378E44277E36EB8C173BE24D575A73F1373E52418E3FDCE4BB7AFF53321CA0802040182C01F2B025F8900A3D3F49D95DC5DFF583F7D6237418020F055110079830338168D22D2335B';
wwv_flow_api.g_varchar2_table(3271) := 'B7231BB0A6649559B68A2D6D6167C29466731A4C18D7F293969FDA1886EC4CAC66E62AA310EC77292B03076666501748E353552D2B842A24E8873778D9259C325E65348DFC3242F8A4F0D292277532BC1DAD607D3224C1DB5182E85C28414209F24C306A';
wwv_flow_api.g_varchar2_table(3272) := 'D4C5294C824C2C16431E2520EA308661FB28793241062017049E6A2D13660C9AA18A99255ED0C398C74C174721B4A16928846D9044456C16B5F423285424996F0F02718A3A7DB9BB3839963636E7AE0F1FFCFE01BE0C1C98C2F7291A4BE20DD4AD91B9DC';
wwv_flow_api.g_varchar2_table(3273) := 'D00956C9AAD8FCD0865DBB3FBD38D05A14E6D7B55AE7D3F3F699B07B5162484F4E3BA7A647F73608029603374F9CA96FB34C76CD7DEF50F338BBCC76E7B8D158A5568B6E3C70C4BD8341576CC30A43D7226F83DA51B1F187051CD422CEDECDAB8FDEF187';
wwv_flow_api.g_varchar2_table(3274) := 'DC77BDEEA824E468DEB7FFD42F4EA7C68773A9E9D2D28E2B83B7E7077B3CA9F262EE6CBFA19ECAA529163BCB1652021E5BA2185B08ABB39E9AD6F5FFF4DFCFEE8C39D2986C92490959820C8B8B2F642699E5F2532CBE68DC1E0DD9EE2BCA1B32AC6C0E1B';
wwv_flow_api.g_varchar2_table(3275) := '84F378F4CF4322E5B2D9E54582D1E2EA4CC20393B8AC1C4BC4920AD22C0E2F9BA1D2496432220967CE9B1AEA7B58572BE2B28DF4BC9382F52443102008100408027904C8EC65F2452008100408022F8800C35141BAFC7EBFDBED0CB2744EE10A7754E0F3';
wwv_flow_api.g_varchar2_table(3276) := '8717298B4BD89E149AF29B2231146CB92317D541BDB095112819F24C823684862E94C0329433BB1C81AA31324C61215F38653238321908208834F6135E5A91B90436E8CC27C8E02AF423215FA848ABC837BDAC10A7C160B0A01332A80E4D083A8D45CBD8';
wwv_flow_api.g_varchar2_table(3277) := '7B69616101251040BF464747414711D71A1B3E218F8AA88E126C688CAD8FC7C6C610D11AC1ABB15F31F2A0A0B88A946F99EE3593C7116276BB9D792900E5D083D860F9EB8F0E800B7A5011E5088EBDD472C8C324D8860C632D9A1B1E1E46BC3114A222AE';
wwv_flow_api.g_varchar2_table(3278) := '3E7CF890B18D699A1CBF850860A3EDD18959456AA1A4B6F276E76CD4355E3072D0EAF42F4E4F2D04729E117569D5ADFE29AF6D68CEE31B1B1AC884BDAAA2229958A033953A0289886FCEE68E8EDFBBEB0C066D632355E5DADEE9D4DC44EFB95B83D2B8AD';
wwv_flow_api.g_varchar2_table(3279) := 'AAAED6CB535FFEFC0A1571C42976C4BD682ED62E75FFA245834C301290F09C23252B5A4D6A494EA91D1DEE49F923C17062211A08CEDA1BCB75A30BC94B9F9D4CB0BCAE85E0D4700F971BE1C82856361B5AE0541B05E19C617AB82FCE8BB133C9B50D65BC';
wwv_flow_api.g_varchar2_table(3280) := 'A2AADEBE05D7485F7D4BB1A6B67AC499181DBC77E2C4ED90AD2B92480CF60FA7820BC2A21CBDB0C2CB02CDAD3797B0850A0E9B03E6AF4A517C8E209ECDBAD8D099A7000040004944415439598394AADFB5C293E4DFE9ECF62F2E08721E814C75B5D31E71';
wwv_flow_api.g_varchar2_table(3281) := '8E168022198200418020401060102004987C130802040182C08B23000605760BEF4D241275BB16035E6728E8872334E8F784FC6EC7C23CC821C81E682DC4184657688CA176E0A850029F24981B2A4215D8234AC0E5C0AB710AE6863D7E71096C192528C7';
wwv_flow_api.g_varchar2_table(3282) := '55E451115590871E86F8815B420F1A6232A094369B0D79503E5464282E14228F12D03F10CBBCE5116C260C0A8A3CEA32923012A7D00666880C8EC8337413E6A104F6C0001C510525B80401D809260CDB4071B19E19D417C4159B39213635244183E17405';
wwv_flow_api.g_varchar2_table(3283) := '5385D928472DB8B590180DB01640A1756085D6A11C8DE212BA0F2E8D230308F38200AA90810CE4194BFAFAFAA0164AC09321CC8083BEC354705D98840CD442187A18836115CC46A338853C6A153E1A92F9B62180F722083882C9CEC9644A244C71E0535D';
wwv_flow_api.g_varchar2_table(3284) := '92703547651512A14E6F48E4D80A56787DC78A09BF78ACF35EB14690E38A9399DC85FB934977BF5C5314F025B2B98498CB31183419B1221C0E2592F879E67FC8592A914AAA04EC96B65A7D7933BDB2E17717200C38C21F7E7052C671B1A5BA9222A1AEA1';
wwv_flow_api.g_varchar2_table(3285) := '3618CD9514CB2B2BAAFDF349A938944664BB228949238B64155EA73DE277DBE75C665EACB4B2667E74AAC6C02932958713E955463625D696EB65F52DAD09812CE1F3146B85AD2BEAB3B22ABFD3AD9567B9CA72EFA2D3E7763A7D619E63BAB9B6C6E54BC5';
wwv_flow_api.g_varchar2_table(3286) := 'BC0B7637EE310B730E573A1E1C99749AE51CB9B16572D02DE6C45B5755AA4A1BE617D3127E5A281157575479E28A54C8BD04279225081004080204011A81AF3A059AA04810200810045E6504C03F419C106919540AE40A50A004136B197F2678174EC1E2';
wwv_flow_api.g_varchar2_table(3287) := '707C2A4A608CA5A5A520C92084D8A608A40E9BFD4215E314455C68C4C1427530556C170C4208319C5656568261A25DC863BB23C4CD0221847E048206C38400F2E081E096E087EDEDED60868B8B8B3006BB018312A3965EAF472BE084F036A30A982A1820';
wwv_flow_api.g_varchar2_table(3288) := '9A8625681A1AB0D53008334832A38A690B1B2FA18F285CB56A159CA8B804F3C027A1103B2DE11451AC7144458861DB61980D3BD10AE4C1877B7A7A8003BA80D0D6E09C28878570C022E4358C41EF18D737704009905128144080E1DE08098616012C3688';
wwv_flow_api.g_varchar2_table(3289) := '72381CB0073B21335C1AF6A30A832432301E3AD11128478FD0772847BB681155C6C7C7997DA16021C081DA92921218C98006E349FAD6229063B1A79D21F9F8D8F68D95425D4D0A6F34729880403557EA14865C6556A511344979545B533D25D16B92EC9A';
wwv_flow_api.g_varchar2_table(3290) := 'E6668D2A0E27EE58F346973BA05368152C53B9586994340B65E2DAC67A36256CAE2B292A16EE6D6C9AEF9C9E1A1DABA8ABD876682B959CA07259814C363B3653965E5C0A88D5156107E76222A373D66A5694A4D219019BD7B0ADA1C45432BF6EF34C785A';
wwv_flow_api.g_varchar2_table(3291) := '930D746CD8BC5252928C279C4253459322E9334C754FF1A6869B3634A62971261B157373AB3B9A28816E68743632D55D69486BEB574FB8A3635D7DCA5CBA6EE5EA165D4532B6C26B74B6ABCBF9C5A67973EBC4D0484BAD9CAF29EBB3B94471DFA8935D13';
wwv_flow_api.g_varchar2_table(3292) := '7636B79B6C43D319C7D89A554D8194B0A76F2092F46D68AB3696164FD67774760FB597B1C4BADAA5F6933C4180204010200800014280C9D7802040102008BC20020C5305F562BC8B20510CDD05B962F2CC2938181A80A711B4B3D012EA82738294EA743A';
wwv_flow_api.g_varchar2_table(3293) := '3043D048D0B3EEEE6E3049B03B0883C2818582C5413F789D4C26034D05A504FF04E9058D040D4621BCA32072A0B520E1B88A4D830706064014B10112348012A31CEC1732A80285282CF073387ED17A4D4D0D34C31EF058E8696A6A823033311B66180C06';
wwv_flow_api.g_varchar2_table(3294) := 'CC5E5EB972E5E0E020982DFA022A0B9DE093E5E5E5C8F4F7F783D0C24E6800EB46078106F2C8809AA283CCBB00348A1274194AD0045A846DB884864053D1651803220AEA0B5A0B85F024A321E8019B65F631462F4056D110C3F3D1168C81183CCF20F9B0';
wwv_flow_api.g_varchar2_table(3295) := '046C163220F0680250E31432B093A9855E4006E419B8E145006004190620E0D830A3F0B990CCB71601CCB4309748CAAB2D25DAD699107F71E23E7E6F16ADE8F0862AB5A042418945A9833C09E7C8813D129120E38F9616359B4B341C9174DFBEDDE2B4F7';
wwv_flow_api.g_varchar2_table(3296) := '50A3CEE7D2E01BAA1034B0952AD3BEBD3C8EF2C8AE668D3855A1D0D9A4AFE5A201B54CB67F9BD931A761E592729566FB5A959A8FD5C78F53A3415AF68383F8A12B5402CC433668944245AEB2A686E2F03A36AC989F14946BF98A923ABA82827A6BB34422';
wwv_flow_api.g_varchar2_table(3297) := 'E734698502CE5A6EC8535D579EE2498A755A395B64AC6EC0EA01935A96CC5A2A4A54625DB9DA1DA928371B34425D59151DDF4B2A79AD43A9E1997842C9AA9DEBC3F6A972BD5A5C642E8E380F6C5D8F77015CA17C738B6E82BB9A9D0D36D65AFC3989C55C';
wwv_flow_api.g_varchar2_table(3298) := '22E217D55497535CC9BA15AD8B33926A935CA0343EB69EE408020401820041208F0021C0E48B4010200810045E10019031103C2C7C65EA83EE22832393987CA18461689894CB0883F2819182DA4109E4E1ED04AD0513037346C2EC5CD0425041103C5056';
wwv_flow_api.g_varchar2_table(3299) := '706354843CF82A582E1826AAC39389BAF0FD823C33AE51D045B40293D00498241CAA702F43181C12CA7104C5056B855AE4D1169CAB50089E0961288436507794A03A64C01E611E28229A80A717DA405F415C918700AAE31232609BB5B5B5E8025A673A0E';
wwv_flow_api.g_varchar2_table(3300) := '63D01084A11F54166DC14286D0827F32FC19941E3238A20A94E008B20DC20C8391077785D9680B19F417FA194090874ED07E980A9D6802D682D9821283C7A21C0418E841155A813B1A19249061F40E73BCC1E141862189EAB016258CC18C0D3083A46F2D';
wwv_flow_api.g_varchar2_table(3301) := '0218ACB4D699B179507155358CE424235C1E17DF1D7C0F4B74D8DF8823A64DA70FA692121C55AA22BA209F2CC54A8AC21FA596D3DB6E33496EA4C54A8B55CC6985092FA7E8F7533C8A9255963185A6C7E24C0155A19550DAE6472714D55885DF02FD7340';
wwv_flow_api.g_varchar2_table(3302) := 'D249B9BAD61626CF1C4B94F4D6DC78F1D3540D85B44EBC6869AE03BF7D94EA4D6A0A7FF964D260E2F4EF542F96C1167AEBA64A839232B43362B5661D85BF7C0226CD8DE54C9EEE616B0D93C7D1A41699D48FED2C94930C4180204010200800014280C9D7';
wwv_flow_api.g_varchar2_table(3303) := '802040102008BC0802604D607AA0A638824D2D53B1AC04AC0C1417ACACC0B5E0A804276C6C6C4409E819F2434343A0AF90012D84365401C70363C4101F44146260A73882AC829AE22A5CA638624A30E81F7CA7608CA80BE20A8E8772D04294A022542183';
wwv_flow_api.g_varchar2_table(3304) := '0403A00A1AE032850670CBBABA3A9C327E57F899C148210F8F2E84C172E12305574447D02214C2367886C1C35111A7609B301BFE55A82DF058C69B8A4B209F7044A3E9AAAA2A08631930948330C3C30C1F359480EB0237B40EE3D10434E02AFA8BA6511D';
wwv_flow_api.g_varchar2_table(3305) := '25C8805A83FCC366B4884B1006FB05BDC729F4A022744212A7E80E18329CC9500BABA019E0306F0AF09A8029842B1B1CDE62B1801283D2037F40874B3012AD430332247D6B11C056B67BB6AE540AE885DC48E55A49B9B683C99323418020401020081004';
wwv_flow_api.g_varchar2_table(3306) := 'FE20041EEFD3B8B41AC619CC293218BB300943168C48903008C31024934E0D4E4CFFE47FFB4F1C0E091CB2143C9227081004FE5811B8F6CBFF6A2ED6E5372D7A4A17702704A7824BB370877C8AD0972EC25D14EC0E3C1384ADB3B313440E8B6641C340C9';
wwv_flow_api.g_varchar2_table(3307) := 'C0CD70044FC3259040B82BC14BD13A4A700766A8DAAD5BB7409E414D19CE093108309718F7267CA1E0840C01464570456843097DF7CE6490418B48C8E3121820344015CC87303827E8256EF5A8029DB0079750112C1DDC124E57C618E4E1DD05FF043766';
wwv_flow_api.g_varchar2_table(3308) := '30810C344039EA420F0450113683BEC22AD402A906ED44BB10C029D359C8A3091C21864248A25D0820033ECFBC14801228847218C6B4CE98843C2C6434208F162183EA10C6299A83B5A882427413E6411B54A1B39081060631BC118025E835C448FA5A10';
wwv_flow_api.g_varchar2_table(3309) := '00C8CFD183CF0298E39BF01C197289204010200810045E5904F08CC0DB798C64963D9A31D8C0131FEB98300AC23801A3179CE2698E23121EE5180660F080873B2A22E1598F941FEF3C7254200F54C93BEF57F6AB453A4E1020087C9308E01E0D572DF392';
wwv_flow_api.g_varchar2_table(3310) := '113C16A770A5828EA20437741C5108FB705BC7CD1A5C0E7986C8E114440ECC16FE5E384B510597902974067521C328471EE550C85CC5291E0CC833E5C8E014CF0C9CA275A6106A1901A61C79C61E9C82FC2F3506F228C103A6A00D324C5DA82DE8810094';
wwv_flow_api.g_varchar2_table(3311) := 'A31CA6A23B0501A842454639735CDA0B4615DCB67874410C4A1840904709632D1E75D0C62864C02958C20883EE16CCC3E3105631AA0AB631D599D6993C391204080204018200418020F0DD468010E0EFF6E74B7A471020087C7B1100378371A06458F80A';
wwv_flow_api.g_varchar2_table(3312) := '52C7B05FA6A4704479A1030CBBC3115C0E1389C19919F65B105E2A097A89C49430159FCC2FAD5890795606E54F1AC3746169BBCFC92FAD5E689A696EE9B1A00199A5FA0B862DABCBC82FBD5A10585ABD50B834F3D4BA4C21391204080204018200418020';
wwv_flow_api.g_varchar2_table(3313) := 'F09D448010E0EFE4C74A3A45102008FC3121002A0BFEB68CC23DA70360B670A57E79F9E7A8229708020401820041802040102008BC52081002FC4A7DDCA4B3040182C05742003E4C660AF157D2422A1304BED308E0D5CCF3D700FF51F43E104D71127EA9';
wwv_flow_api.g_varchar2_table(3314) := '524DB19EBE381CCB127CBEB0909590281F479C66BA8685075E7F58908B4BE960D4CB23E42DEB3ED630F8BC0109372392D311A15359CAEFF1A9157C0E9F5EBB4E12418020401020087CED081002FCB5434A1412040802DF650498B049DFE51E92BE1104BE';
wwv_flow_api.g_varchar2_table(3315) := '1A02DF8DB909E7FB1615A3BFD8FDE3FF39BF7BD153104952D46F4FDDD9289F6C3DFCD3652C179CF6A3B35D1DBCFE956FFE9B65979E5414A1A8F73FB97CA03A52B9ED4F70D597A2FEDB2F8FFFEDEB1659E59665C2BD73A107E73ED62904870FECCE083417';
wwv_flow_api.g_varchar2_table(3316) := 'AE8EA9A3C31D077733FB3FDD1B760966EFB4EDDEB718E19C3C7FF1CD6699B26A5DFF4CE0D69973157AFFCEDD87D912C3E75D5677CFA5EFEDEDE01B5B3E39D7959CEDDCB5BAAAA475C7C5AE716BD715B392B3F7F0E19190EACEB9A3AC64E0C0FA4A6DDD8E';
wwv_flow_api.g_varchar2_table(3317) := '14459D3FFD706569C8D0BCE5EAFDD9E187573BAA322B777EFF529F67FCFE85D5A5FC957BDE08A5851F9DBFAB0D8D1C7EE3D0844F72EDF86936D7A7E7F0F6BFB13D22327D74FEBEC237F8C6A11D94D47CE1A675B1F7F2A1FD2B3996B6E3272E4A0213FB0E';
wwv_flow_api.g_varchar2_table(3318) := 'EFE7C8CDD70616C473A7D7EE7C9BE2D1B10F3AA7C3C1910BDBF7ECB44764674E1E2F172C6E3FF8F64C5C79EDE4C75422F8CEFE0D025DEDC5AE497BD7B93D1B9B0C0D5BEEDBC20F2E1DC7A6CE35AB76F6CD27EE5F386AE267F7BCB16B21AD3BFBC90576D2';
wwv_flow_api.g_varchar2_table(3319) := 'B6B3A3D6D8B6E5E24DEBE4C0B5CD0D3CE3DA1F9C3D7B21EC9A1571B3BBD6D46BEB364EF972A3378FEEDBB621232D3E7D69D83F7EEBF0BE958AB21537861CA3B74FEC5D596C5A71F0A1D5DB79E16C8521B763D73E9648ED4AE66E1EBF7C6847859D577EF5';
wwv_flow_api.g_varchar2_table(3320) := '44DEB07D1B84FABA3B238BBD57CF3598059BF61C18F670AF9F3F5E998E6C7F7B5F4262F8E4D45D9D6F78EF9BFBB242C3BD8185D8D0EDED6FEF9C0B4BCF9D3ECB893AB0B3D7BB07D6B92435A73F3867113BB71FD94BF1B5CBBE03E494204010F85A1078BC';
wwv_flow_api.g_varchar2_table(3321) := 'BAEC6B51F747A7249DC954988A2BCD4664961ACFBCC0FEF63CC573D9DC931626E9A0A6C9443299C9D2C62360776141E0D2BEFCDE3C347F7B7AFA7BAD250204816F1081C2AADA6FD006D23441E01544000FB905976FC6661B1F9D0879169622E0F084ACB6';
wwv_flow_api.g_varchar2_table(3322) := 'B9D1F18988DB86D8D3569B736C74D43F3F8BADC4C2C9ECD8C4F4C4C4B8D33643E51291343536313537334565E3050DDE707264DCEAB24D046331D7BC2347251DAE60C4EBF245E3B6D9B9F1D131D7B4354365D0FAF4CC8C757CD261774C58AD7E879543E5';
wwv_flow_api.g_varchar2_table(3323) := 'AA2D06ADB93A96654D586D931363543A3CEF0C8F8E8E875DB6AA32ADC6528B90E4D38EC0E8C868C8358F1617BDE119DBECC4F858C4632F180047444D9551596201D59CB43A4647C666AD13B17878D6E14A86DD053164D4625E637DDD6C5466BD7F6B7CC6';
wwv_flow_api.g_varchar2_table(3324) := 'BD383FDD7B6D94A282B834174A7F7CF5CA4CE7ED1495BEDF37D663732E58E9FDC9D5525E4B73D5785033D57367603E1C1F3FA7ACAE3BFEEBDBACD85CB5A9C858D3F4E1BDC954D03165EDAF2FE65AAA1B298EB0CF1E51A6AC0D4D2D2225BDD1F7DD49D7E5';
wwv_flow_api.g_varchar2_table(3325) := '3B175CC303F604F5E0EED9FA3A4D676F2A681F2951895B9AEA4F5859C1A93B97BBAD8664B7936BBE7FEC8C5498AEAC2AD59455CFF43B92E9D8C99B43A0AF15758D1457D639B298B5F5D7B7D673659ADBB787D4E1D96C71F554EFFD114760D6363234F820';
wwv_flow_api.g_varchar2_table(3326) := '1771A2C58544F6EA67572E0D7465E2E19BF7EF57C88236AE796AF8869447D55595A7B4355DC72E44D3F1F882476A2E3B7D73C0ED728C749EAEAD509D3BBFE019B9A312739AEA6BA629CDD4ED8F9DFE64B2D7D6D8D220D11AC7BC99FECE33B58DA577EE07';
wwv_flow_api.g_varchar2_table(3327) := '7381B1B2D2E2AAAACAD9302FE1EA8E65A84BA71E3C78703F179DBF371A08CEF41657573DBC33124E7AE33373BA0ACB87E7A7223EEBA797EED659B8D376AE73A8075FC88B7787FBCF1F0F395C8F0CD3D4C2304F267EEAF2B5FA1AC5C4546A76CA7AF3FAED';
wwv_flow_api.g_varchar2_table(3328) := '5A55AC37AD734FDD3971C3A6494D3A8596EB1F7C36E3F6CC0F0EF5DF9AA4926E318F556929315556D9A69DB194FFD4995E8B321810EA87EF3C40E840004212418020F0B523F0AA136090468D4AA553D3DB5A16C0051B140905AB5B1A047C3A6468A19CC9';
wwv_flow_api.g_varchar2_table(3329) := 'A084219CCBCA5FEC14AA9E6C62992AD8A654C81A2B2D0553502293880F6C59FF57EF1CFED1E1BD95A5A6743A53A456D6969781052FABFE9C53348D30E1CDD51512111D06F63992E412418020F0240298E769B7DBB1172E769D45BC7EEC763B3E3E8E0D78';
wwv_flow_api.g_varchar2_table(3330) := '878787B1A92F36C2EDEBEBEBE9E9E9EEEEEEEAEAC2F00AFBE83EA9849410040802BF17811845BDF7D9CD5B9FFEE6EEE8F4673FFF5532602B54F9EF677B6F9EFCE7872393BF78EFBDB477D2E50BDF1F9AFAE837BF0ABB473EBD30D077E3DCB9AEA1637FFF';
wwv_flow_api.g_varchar2_table(3331) := '8FFEB0F3E8F9DBC35D977FF9E125EBED3378690C0D9E58F61FDE3F3B7AEF6CC8EBE8B1F94FFCECBD2CE5FDE044CFF8D5937C21DBE18A8D596DEF7FF0A975E8EAFB9FDDECBDF8C9B15B239FFEFAEFBB0707DFFBE7DF845D6343130BAE85D16397066F7DFE';
wwv_flow_api.g_varchar2_table(3332) := '2B97C33E30E7F9CD3F7D383BFE2012F50D4DD823F3FDF7A603273F3E3A313DFA9BF74FBB6DFD476F0EDE3FF9B36BDD139F7CF02B2AE662BA00DEDB3F3415774F9EEB735EFEEC13AB6D9CEBF3F852BC9F7D7CC63D78A9D04D64D4728135C8094D748BD502';
wwv_flow_api.g_varchar2_table(3333) := 'A35EDEB465653A8600EF19B0F9FBE77B3657B3786A339762C1D92931B724D2504CC995A20947DC3B392C51A967FBED95C5E6B42F39E8B17143769E54DDF960B4885A640984EE50EA6E67DFA27D1AF1D6931956DFF8DC54D743019F9A8F65E6AEDE59B3B1';
wwv_flow_api.g_varchar2_table(3334) := '2E9B1183E6A94B4A4787FB4C629640A4566B15BDFD5EAE77202B290ADE9AAC6E59E1B1B9ADF6412D3FD6D1D12C57543535E99D7CA36BE842FF943F30D09FE3B32F8CDA1DEEE991E1CE2C159B75D9EB4AB9124B6BE783C15255BAADAD258329DF99244630';
wwv_flow_api.g_varchar2_table(3335) := 'B71F0C3457443986159974CE619F6EA92EE116D5CCF45E550A28674E39F7F081524F0939FC0D6BEBAB566CF166F86EBBD31065CB55A5E3EE85A06340A7E0F5FB599E8187524D51324B8DCC2D0E0FDCE5E5824A215B6A308D0F759914428944D15A5F53DA';
wwv_flow_api.g_varchar2_table(3336) := 'DA512A8AEA1A77DE1F5D28118DEA1AD7B3B839E76CB0941D2B6F6DEE1A9EE7476656AFAE6E5BBB3E14530A384993453738395B24B24BB59A4E9B5FB83854DBB429936229F894938261F715869C88CDD79B8A87C7267472B7422535161B47FBC3F29C33AD';
wwv_flow_api.g_varchar2_table(3337) := '2ACFF6F595D53478C2EE6BF356BD38B6626B5B26ADA4322918D6D1DAA03436B5560859EA9AD0036B73B33EABB20C3EECA6287A63399208020481AF1D81579E00D33B46B2B0AE6F29F90315944B2587B76FC0DE52C8E3127DCCF3431CB1C95489F6F1A494';
wwv_flow_api.g_varchar2_table(3338) := 'FC954757998F873EC93E2A7E5C922FC069E12A9DA7A8628D46221681872FBBF4A8625E1E1E5AA35EB373FD2A544639D8AF4A2EFF1F7EF0668DA5D4E1F6C1F8BFF9C11BCDB595255ACD968E15E9F45354A1514621D3CA23E57993B055D6DE4D6B9572398C';
wwv_flow_api.g_varchar2_table(3339) := '2EC8900C418020F06510C03E758140003BEE60571EECAC83844D718BBE48D8A908591CD56A3532F8C1611FDD2FA3F6856540C841BC5F6C26C80B374A2A12045E0202E0454EA7A75A9B695BB7A2772A1D768E318DE2D9B6E00C962BD91D6B578D2EA61747';
wwv_flow_api.g_varchar2_table(3340) := '3B5DA9F4A26D7E64667A6A6260ACF3E6BA666D45F33A8F3B31E5F45EBF72CDEB756653118F27C0F8D6D23976201A19E8E9662782C154D663775054DAE909C77CEE2C2B675273D7AC5EE3E39AC71E3C747B1D95451976716DD433DBDC503BB4C08E06E63C';
wwv_flow_api.g_varchar2_table(3341) := 'FE502CEC8D86E29DC38B699F3591CA4D058213839D6C8AEDF18582B1C0ED5BE3A6F4F49AD5EB86128AD9E1FB6E6FD0288E953676F44DCEA502F051D3095D737BFCBE78F0E195DE7A4DB4636D4746AE977353EFECDBA2AA5AC7C830472197D55C53A6AD5B';
wwv_flow_api.g_varchar2_table(3342) := '3339B12813E7A4456A1607BB9A71AF8E047AEF7C9E4AF347AD73CE8941BD5ACA17CA98A5CB220EABADC9AC6B593B6D1F8BF8C3FD03D61A5940DAB62A138B1AD5E2356BDB3D5971DA39FADAD64D6B77BF3934C7758E746EAD94EC39F2A72C53CBBD4F2EBD';
wwv_flow_api.g_varchar2_table(3343) := '77A10B3E514F881A199F0A3867338B6EB3A5CC1ACEC402F30A017B557B8DC0D8343D71DFE58A8F0FF4B634EAD2457A4E2E458985E3DDBD2DAB4B3C097164766C6D73E914AB68A6F3BC7576AEAE524299DBFBBBEFD7D5567CD4ED1BB87D4E4485E502BE52';
wwv_flow_api.g_varchar2_table(3344) := '59C4E1F2591C76D742AAFBB747D3DCECBCD5EE9EED2EAD6AFEEDE91E77FF3D1E27C3615135666DF39A35DD332C4ECEC392CB2FDFBCBBB5961F151886C7BD6CF703D3C6CDC94C46C066B5579B4DCD6B466E3BABB5AC77FEDDEB124BC7CD3BF752311FCBE5';
wwv_flow_api.g_varchar2_table(3345) := '2D2DAF9AF2C5D2E105A150D039325FA36705E435E77E7E949D8BD8ECDEC9BEBEDA7A6977207DEBDCAF59D10C97CD12A814672E75EE68A4526213C7EEAB34EB27D34AABC773FCD4692A353BE78BF48F0C70D2A1DA526DF3DAB57DD3EC4CCCC377072D65C6';
wwv_flow_api.g_varchar2_table(3346) := '9184241A76BAFD8132B33294912FCE4D07E281B1C17BED95F288BE49CC492A0D456C2E9FC20894457145828703C34D557A114F61D9D6F4DB93B73DC3E7408D977EFA244F1020087C8D08BCEA04F8A950E2818A8D938B144A704B0EFE63512A855C299781';
wwv_flow_api.g_varchar2_table(3347) := 'D66202646599F1F55D5BE032455DF86FE512B146AD84AF98710BE308EFB1A6482914F0696ACDA2EF6DD88759A594A30AAE2A64125CE5F3B8D96C4E2A121ED9B9B9D662667338B804672C2E296452F061D880239A562B150AA994CFE7C100C65AF05490F3';
wwv_flow_api.g_varchar2_table(3348) := '2C95FDF0F4A51B0F7B4E5EBBDD3930AC57AB043CAE522ECD51F46469A958A4295289847CC62AB05CA62E764561F260D10AA958A35262B368955CC6E36227CFA782410A09020481672280DF11AE61F75AC464460213461E7BCF22830456ACD56A417D71D4';
wwv_flow_api.g_varchar2_table(3349) := 'EBF5D86C16FBF73E53D71F72C166B3399DF45CC165091C3B1C0E33562DBB444E0902DF0802081A57485F71FD7C8E62C542297F382560BB047C29D31D0498CAB0D9F158D41F4E08D2E9E140AEF3D8B1152B4D19AE2C150FC543543C1A4BA493541693A3D9';
wwv_flow_api.g_varchar2_table(3350) := '543AD956A63AF2E67E636D3BB3B25721A0BEB77F33A77CD3A963D78549BB9FCDF3BADC71AF1F73A9F0180E8742D1782C120B4815D2743A2717725874BB787A4AE3142F9B4AA4B3594E2AB1736D45ED8E2367AE772BDD0FDE7AF3C05CA2E4F6F133D95C88';
wwv_flow_api.g_varchar2_table(3351) := '9DC9B20482703C9D666558A1A8502449E7B2223E472A53C492C95C125E6D3AE1D99BC9E0919E4E6659E168144AD3915822931B1A9F89F9E61819E6184FA475528EBCC8140D671229CA07FE1D0E44837E1D3F5751DFE00E653C1E4F3CE40F4493A1802F18';
wwv_flow_api.g_varchar2_table(3352) := '0CA613D15432AD570A851A532612E657E879E945B6A93937EBCB49559C74C26C298EB28B72E98451AB2AADA84EC560454825A22CE5951CB536100ED62945D2F23AB7D3EFF57B1DC148241B686CA89F5794FB9DB3C948A2D428CFC8CB84F178B256AD4E05';
wwv_flow_api.g_varchar2_table(3353) := '12D262519CCAF124B747BCDA689FBCA24D2CA054BC12B3B128235326BD4E935EA5D38AC51A8BC71B683217EDDABE47272D339A4A9259A137100806C3816040CACED4ACACF146F93ECF623CE85C5F6759B7758F8C5F6428ED88A7734A5E4E6B2A8B0658B1';
wwv_flow_api.g_varchar2_table(3354) := '2CE783133774BECEB29AD542953429F0A90D6589858050A20A273246194751561A8F47C57CAAB2D6C8539A229ED862309AA0028D758D56A929EA9CB58533D3DDB7EADBDA59594E439B31CA52B9DD8B018FDBA2E3EFD8B7436E596F322AB222F3CF2F3C90';
wwv_flow_api.g_varchar2_table(3355) := 'CC5DAE6E6FF1A5B80BB38BF58D1562699D736AAEDE589211E89C1E97DFEB4DA4928ABC61E1202B904CB8E75D0D8D353C7ED5D4842BE419ABAFD7282BEB53F69E7955A9960A45F9164BC09E62AB3CDE50381C0807FC542ED33D1765CDDF296958CFA658EB';
wwv_flow_api.g_varchar2_table(3356) := '56976EDEBA2FAEA86CA8400435C1D22F00C913045E290430A4C17826EFAD5B7EF8EA38902058CFC410B0A7D2E9B7F76D87845A2E532AA477BA0746A66CAF6DDFBCB2B11637EBCF2F5E6FACAEDDDAB1028FAE7426FDF9E59B93B6B9EA32F35B7BB6E20373';
wwv_flow_api.g_varchar2_table(3357) := '797D6291F8ECCD3BE6627D635505F8F0B507DD7C1E7F637B33AE26D3998FCF5E5ED7DAB8674347894E134F2567ED8BEFECDB2E934841B87B47C72FDCBACFE7F3DFDCB5ADB4588B479C44282C2C3E14F0786B5A1B7FF1D9E979A79BCFA327699FBE76174F';
wwv_flow_api.g_varchar2_table(3358) := 'D0A62A0B1EA4996C766D5BD396D52BE02E46FEE495DB0B6EF7EB3B377F78E612EC948925AFEDD8F8ABCFCF74B4346E5FBB3212C5D820269588F28FE06742412E10040802CF42003F4CFC064147E3F1383CC0C964321A8D4218CE5810609D4E87ABC83362';
wwv_flow_api.g_varchar2_table(3359) := 'C82FD373FFFEFD5028D4DEDE0ED731264EA7522993C98479D49148A4A3A3035CBA203F3636363D3D5D5E5E5E565676E1C205DC468E1C3982977420C3A8B572E54AEC798B56E07006CDC0D4EBC5C5C5D5AB57C3A48206922108BC6404F08564BED5C86062';
wwv_flow_api.g_varchar2_table(3360) := '02DE01555656E2ABFB0266D09194D99CAE698FE2D6A543BB5A44C54D05256C0EABD7EA93DFB87A78638DB16DFBD8F849F7E2624D7999495FBA6E5FD9DDB1F33EEE6D9638575324D875E8F5A1E91BD244B7B9D9C2C4A64A6428EBF48C98936A5A595B5B59';
wwv_flow_api.g_varchar2_table(3361) := '39D2BEEAE6A5EE323DA5365798D5920155FDD56B37D695C5EA36BC36121E1014454B79FC4C4DB3802F68AA2F134AB5356532913A3E35E7E4C75C2B6A2C202DCE91A91285AC6E9525E4102AA4A943ED551743ABAE9CBBB4AD8A6569DB561E9D9709AA0542';
wwv_flow_api.g_varchar2_table(3362) := '56437D134F42C77C4602C5A9A934A955E91D7B568C9D1F0BDFBAD1DC64A0C4FA05CF7CBA040EDEC7A973CAD77BE1B7168170D5A19D53EECC954F4EFB449E87972EAC3CF067E6D7F67A7399D94C5A5FDD7EB4DB961BBEF020E3A96E7E38CDA9B97DFC53BD';
wwv_flow_api.g_varchar2_table(3363) := '81D7B47B6F4AAA3B3AB1EACCA9D3075799A2CAEAA3BFBC938C0D1E6AAFE496B49EB835E67A78A1B5585F54BEE5CE5CA4F3ECE7266170CD913D025D55A2A1A4C4199199A41526739FBEF9A38FAFB61B25BAEABD17EE5827FB2FB655AB2CEDAFEFAA955D3D';
wwv_flow_api.g_varchar2_table(3364) := '3EC6B79F7F77CFBA2C57161D1BEAD8B48225D0987254E9F6373F3C7ABAA24858BA61EFFEA8E6D37313F2CCB1D7F6AC7144F9D76F76D64B538DBB8F3842BC2BA7CF2C7AA84B57EEEE7FAB5CFFDAFE683A1314A84A1ACCBDF6E8838BB7DACD8AD2D63DE3AE';
wwv_flow_api.g_varchar2_table(3365) := 'D49593C734D1F0C137D6DA63726B4F7F113F70E9B38BFBBE77A074CDCE8FCEDF6ED5880C0D07AF5BFDFD173FA9546657BF79C4EAA5CE7F7496CBF1BEB975A3C0A0ED54357FFCF1B9F5A55279D9FE494F785D294B626811B0A9FD07B765709B969B6B6A58';
wwv_flow_api.g_varchar2_table(3366) := 'E18CE856E7A02439BFFBF50DDE9CD236D0A50885CF9FBF72E010A76A5DFBC7472F16C9052BF66D699399B2A92639CBD652939908492F1FFFA0281A3EF0FA1AB5545BD2D6F4F1C7D78BD592FA963D7E55F2931BA78B45A3F57BF6519CC67BBFB58AE7CE1D';
wwv_flow_api.g_varchar2_table(3367) := 'D9DBB198909DFEE0945FBC70E7E2D55DDFAFB4CD47B7AEAAE6C94AF0614FB963F76FDE6EABD254AFDEFAAC006C8FBF13244710F88E2280F112FC0A1847619CB3B48B28073F5A5AF2627942809F831B0B04727563EDBCCBFDC9D9AB1A95E28787768F5A6D';
wwv_flow_api.g_varchar2_table(3368) := '3D23A31AA5FC41DFB05AA53CB263F3C7E72E395CDE35AD0D6FEFDDFEFFBC77F4DD03BBA6EDF69B5D7D6546C3BFFFAB1FDD7CD85B596AAC2D2FFD87DF1CF5F88387B66DB878FB81CBE7FFC91B0751A57B647C9B7DB17B68CC36EF00D3CEA4B31F9C3AA752';
wwv_flow_api.g_varchar2_table(3369) := '28DED9B36D6266DEA055D75598DF3F7901C1AE7E7C64BF4C22C26B107C0B30311B5E62EBDC02175C99456160118C4633E90C3278676DD0A8BFB777FBE91B772767E6DB1B6AFEE4F0EE9F7D7C626553DDC7E7AE403F78F8AAC67AB0E2B7F66E3F7EE9FACC';
wwv_flow_api.g_varchar2_table(3370) := 'BC6375737D7E09F18B8C489E831DB94410784510C0EF0E7767D04E97CB85E9D0E0A2B83B8376C21583129FCF87713FA640C321BC0C1088DDBA756B6262022EE2A3478FBEFDF6DB3FFFF9CFF7EDDB07028C75C5A0BB20B45BB66C616ACDCFCF5FBD7A1574';
wwv_flow_api.g_varchar2_table(3371) := '1A84191C1B9E64240CD84E9C3881C2858505E8AFABAB435B586F8C5D85AF5FBF0EAABCAC45724A1078C908E0D78169FF1F7DF411BE9942A1F0473FFA114A5ECC06DA4D9A4EAC6928B26CDBAA9609BAE793D3DD9F824A379A655424DC5A5D52B77D4B915C';
wwv_flow_api.g_varchar2_table(3372) := 'C89315BDFDCE61562EC95ACFD2A8C46B74BC50C9CEE39DB6B20A9154AADDB3561AA92DE2B0B1945478EEF8394E32A4920B37B534E79A2C2AA9402857BF75643B958CAC65735462BE51206BF8F1BFC2EF5B2AC8C9342547F6CA55A2EC56963C67FC53B94C';
wwv_flow_api.g_varchar2_table(3373) := 'FEEE1BBB542AC1C16D5909B7C19011D49A64123E9B23C58B2C137B6D0B7EF1BA584EC66EE02944870EEEC8254352015F24D71E5C2B95B34BB322CEDB6FBF73773A3A7FE9189B9D6E31698E1CD80CE50ABEAA46F106979DCB6DA0542AF99BF20A95F477E0';
wwv_flow_api.g_varchar2_table(3374) := '6A2A55980E1E5061465871093741BDF3DA568A5AA71473447C914823C5BB2EE3DE3D42A9624B3D7F8DE12D6E2EA7D6AB842CA916A64B384A6D31C5E21EDCB5351174990D2A1647BC6B670B95B118F56AAE40B1B1C59234BFA655C8F8324D132763DCB743';
wwv_flow_api.g_varchar2_table(3375) := 'C1CB6A4A8C149B2F938A5629556C934220161FDCBE32E82FD5CA796295B1A335D258BE5F8FA966AAE22605A53ABC9F9789688CC5398ABD619D4525B7E015838845AD5B5555633AA29670451A537386AD8285B998D65822CEF00FEED9AC16B164BA126E9A';
wwv_flow_api.g_varchar2_table(3376) := '7A7DF7C6ECD65522214F28560A257CBC1B7867DB1AA14C58C3CE685FDB0D27B6405E6416E40EECDA2ECE650CE6E2688EF7D73F39CC662579394AAED2EF5C53EAB314E9157C815CDFCA4E97EFDF0B3FB6BAD8C44FB20FEEDFC4E3A674250616577078F7EA';
wwv_flow_api.g_varchar2_table(3377) := '48D0A253E27BA2AFE366B81B414A451807ABF32F0AF7AC974A85149FC5DEBD7995886AD695142728F64FDF3EC8CA2439EC9C42A38552AF592C13B355C50013EF26A4EB77CA24C29C84E23386E94B8BD1CAC1CD8D81FA228594ABD6956C9053B5EA23725E';
wwv_flow_api.g_varchar2_table(3378) := '5A5E626C6309746FED13E4C2069321CEE21EDEBF26BBB7492EC00468F9963A899ABF8D9EA44051B506896EDF1EBD4A2254E95EECC7426A1104BE03083043A927C74EE8DA0B3F4796C2F20D1060F8B311F769A911F05B629E30123D0BE877EEF6988A0C9F';
wwv_flow_api.g_varchar2_table(3379) := '062D4BCF47CAD2339331AB18A7B412CC4FFA421832983702B59845BC543353AB20966F04D7E9B6968A3D330F33D92C1054ABDD3EB3E0F8D16B7B84028175D6E1AE0F8ED9660F6E5E5F6E32C07FAB2B522965B2969A0AF05573B1F6179F9D9A5B743A9C1E';
wwv_flow_api.g_varchar2_table(3380) := 'BBD3431B4CB1C6A66787AD337C2E7768D25A59662A331683A63A5C2A1BE241F8FDD3F3F6682CBEBDA3FD56777F534D2597CD29D1699B6B2A8BB5EAC109EBC0F824AC78D03FBC69550B54E5ADA7D1CB62C96EA117F89AD093A6E9C2E6EACA583C7903511A';
wwv_flow_api.g_varchar2_table(3381) := 'D3697720B073FDEAF2D212E8C45548A0E31855579599C09D6F3D1C486386742E7770CB06C00C0192080204813F1401FCF8F0B3C2F81EAF24910729051F063B851B16FE2E0CFA71098C1432707C2D7D91897210DD75EBD66182F4B973E7E0B00579862B18';
wwv_flow_api.g_varchar2_table(3382) := '2C1AE55EAF776E6EAE600C7CBF20BA9B366D9A9A9A82CBB7A6A6069A9937A370148F8C8C381C0E10601880EA681AC6403F141634900C41E0E523802F646B6B2BBEB1F8861F3A74A8B6B6F6C5DCBFB01C8395E63AB3B94C5162A443139B5909F58A15184A';
wwv_flow_api.g_varchar2_table(3383) := 'A865BC96F9398B816B32C17B463FC88AF59A424F47466DFE89612327B6EBC85BA0194A2E4729A6AB4B12D955AD0DAC6C5AC86717EB41661EF9130C5AB0C8479326B0CC496E321554E93474B90AFF8B8B7130E869FFAD36EFC4451C2A4AF568B286B4F811';
wwv_flow_api.g_varchar2_table(3384) := '69D1D2CBA4E8854B255A0545E18F4E5A25B6F6A577F715E90D2C5E44AF6A6351D922A9509E570E4625311AF282F4C128A42597A62229BF485AC19480AA492B1F9B874240C455D20D99D4124A5DC988C1BDACC2ECB02F92492BA7F0974F1633A2993C0A68';
wwv_flow_api.g_varchar2_table(3385) := '62D42828FCE55391985B545EC6E499A388CBA6E4F455BD46A2D7943385C53A2985BF7C8213B5C2F4A8E3F80C8AB48FCA715129E62A2B1ED92CE05095A5347A48520E252D2F65F2E0A0E5E6DFE90B94686574F755528EAADAC288812BCA2D66260FCC2B2B';
wwv_flow_api.g_varchar2_table(3386) := '1E57D1F0288DF491984ECAD37D9197F22978AE992A3816EB6414FEF2498E5645BFC3309512FA33C357A1DCF4C848A05751F6B83A3E6DF51230212C95D35394A151F6856138D52A445AC5239494424A59FEC866889697A145BA51B45451FEF8B346E0AE7C';
wwv_flow_api.g_varchar2_table(3387) := '19AE506A094FFD0562F4394904815715010C6630767AB2F778B23C59F88796E086F952131E7E882F7560F33A3848E9785034A5637903A163976F6452E91F1EDE8385B290A1FBCB62770F8E5CBADB95C1B4DE747A6563DDB6B5EDBFFCFCACDBEB43159954';
wwv_flow_api.g_varchar2_table(3388) := '7264FB46848602AB83FFC5EB0F750E8E3454961D3D7F35164FA004BD829E8A52D3FECD6BA4623156C682048E4ECF4ED8E6D164EFD01823F37B3B8FC9E79E4010012DE03E4DA632582B0B372CAD3A9DC5A2DC7024964A65B0F81633A24F5FBF0B616CE316';
wwv_flow_api.g_varchar2_table(3389) := '8A44C07BC3F158281AA147C6B96C201C054145A0A97D9BD721A4E4BCD7EDF6F959EC7C402CDA4EBA9640C07779FD7C0E17A6DEE8EAB1CECDD75798A7E71CE83E3AE30F87E86D90D073160B1DC45FA95EB7E006C1A6C7DC58518CA0D0CC34792003877034';
wwv_flow_api.g_varchar2_table(3390) := '1E1709048160183418339C21C33064F417D663589E48A6628938F83CBA104DC4E9CF8124820041E0451100B305CBC5CD9AC3C54F9895CBA485F013606D309F47DF2CF209DC188B210B2DA00A7E97081F8D7752F09261F1307EDD701DDFBB770FCC76C58A';
wwv_flow_api.g_varchar2_table(3391) := '1598535D100697860C58317872717131C82D28716363232608C1BD8C99D208C7F5C9279FAC5AB58AB10433A2EFDEBD5B5282807D8F23F615B4910C41E0E520806FB84422D9BF7F3F663E373737E337829FC28B358D853A8776AE91F3D34C758D4C5024A1';
wwv_flow_api.g_varchar2_table(3392) := '491A7E356F6E552978750CFB5DA6BCB55C9BD2AEE573B03400E4E5F1FB7199802D01E3CABFBD828A65B55ECEA95625D128C1E372F4542E9208020401820041E00904F01079A2ECEB29A089E24B4BE8062230FDEB77DFD8BD714D24160F44A2A1702C1889';
wwv_flow_api.g_varchar2_table(3393) := '365597FF2F7FFE034B69C96B3B36E1E9083EEC09841155E1A7DF7FBDA5B61A4E0C8495F9EB77314568FD0FF6EFC2D3130B5FFFE6876F6C5ADD168A26A004146ED1EB93CB2407B76FC4F89279BAC2F75BACD3FCAF3FFD53A35EEF0B867CC1B037185EF478';
wwv_flow_api.g_varchar2_table(3394) := 'E9585358B3F7259E37B4EF967EB8B2214DD3433899E165066D655118E372B8ECA9B979785C318DF9EA831E305504A0C26ADB742ADD565F0DEF74B5B9B4CE5206D68A671B54A4B399528306819A2FDCEEEC1A18C6339B5EBE0B7F2C86AB5C76241A5B4474';
wwv_flow_api.g_varchar2_table(3395) := 'C848F4EABDEEBBDD834009647B6ED1556D317121C0663757952366151CDF30299648DDEB1B3CBC63A34A2A035CF4E37FF7B65DEBD7604C8CA05D33764759B14EAB52A552698BB11831BA266DF398F90CBA9ECCA4A110D3A7E178C62C6E8D5289CD932C46';
wwv_flow_api.g_varchar2_table(3396) := '43B9C948BBD749220810045E14018CEC31D097CA646A8554C58B2815F2229643E079908939F1660ABF4DB0DF65BAF1BBDEB8712378EC993367D6AC59031EDBD6D606998A8A0A105DB0DFFAFAFA3C71A60F709D612210263C4300E560B6700563963584A1';
wwv_flow_api.g_varchar2_table(3397) := '0793A80D06DA99803C8EA8DBDFDF8FFB2D6653E3942482C0378800BEBD78B983173A5F85FDC27E7CB3356A395F9A77B9E6C92EBEED487802EA5412013DFFF729492B17E1C7A2818F97437BEA9626FAD19CAFBEB4F065E6310C41FBB0E19B62E02FB3B3A4';
wwv_flow_api.g_varchar2_table(3398) := '2D8200418020F0AD42E0A57A8041B71AAB2C3BD6B5FF87FFF2332CA6656EFA18A515A9E4FFE7FFF8AFB776B4039A0B77BAE2F104F818FC966FEEDE622E31DCE919F8F1E13D3C2EEF3FFED37B7FF383D73BFB873CC1F0CE35ABFEFD7FFE6F23D699FC030C';
wwv_flow_api.g_varchar2_table(3399) := '03BE24765103D9C3B390C117846E5B47FB8ABAEACF2EDF002BCE3FEA58A9740651AC78BCFCDAD9E77E0E988C0DCE0C7E1B0C855299FC344216150845406823D1A856AD7863E7D6DB3DFD8313D37F7A780F6647579BCD8313538B1EDF07A72EEE5EDFD15C';
wwv_flow_api.g_varchar2_table(3400) := '53855EF8C31134128EC5C087796CAEDDE509456287B66F404C4AB8C1A7E6EC58B80B87F6814DEB23D1042AEEDDB8462D97C2852B138B175CEEEB0F627FF1F6A1BF78E32048BBB9A478C1E563D68780981FBB74E34F0EEEF9773F7A7BCEE154CA240AB9EC';
wwv_flow_api.g_varchar2_table(3401) := 'FD13E7150A199CBA2393D3C353333F7DE7B0757EA1A6DC7CF14EE7C4CC1C6671FFE59B87C666664D7A4D30140149EE1A1CFF576F1F9C5D70594C069B7D01F83C170F7291204010783A02CCEB491CE99B0F7C39091FD7FA69A6A895357729A3A865790793';
wwv_flow_api.g_varchar2_table(3402) := '553F020740E5651E609460687EF0E041ACE9057D053D401E85168BE5F5D75F875B18B4E1B3CF3EC3FA5E6846C98E1D3B30BD194B0CE10DC60CE777DF7D17DE5D7883717F63882E13460B7AE046DEB97327EE8D9835FD74A3492941E02522805F07BE8DCC';
wwv_flow_api.g_varchar2_table(3403) := '2FE525364B9A220810040802040182C0D31178A904189E10A9442C118AC667E61C1E2F07DE5484B500C90C473043179196C19031163CB273537B7DAD3714EC1A1CBDDB3BB0B6B5E98DDD5B8F5FBA1982B3379AF8BB3FFBFEFFF7D1316C3534393B078F2E';
wwv_flow_api.g_varchar2_table(3404) := '2636C33D0E8A487B49B274DC66FCE1618B99C9D87008531143A130D86C1643D354CE17082692881C031FF0D3E1604AF1A8F687C3EF9D3C07551F9EB96C77BA518217B588DBEC707B1289E4FBC72F70B81CB0D98FCE5EC266BC20E7E76FDFC3E46AB05C34';
wwv_flow_api.g_varchar2_table(3405) := '75EADA1DACE94558FC75EDCD10BED5350097334FC0F307C3FF74F484C9A0457F07C7A722B118562C9FB87ABBA1C2924C25EFF70DA383D89768D6E14244E850145B2FC47FF3F9B952832E9648DEEB1F826D30227F64BBBDFEF74F9D671CBCD376C7EC02FE';
wwv_flow_api.g_varchar2_table(3406) := '9CF250D81FC04686D98FCF5EC14A63895070FEC63D905EE0F3E9856B759566BC34EF1D9DB87CEF215CC1472F5CA9B198791CCEC0C414CAB1551DBCC7CF03855C230810049E4000D414C37A24F878F3A109709F89B20313395935C7DD83E8F0198919F724';
wwv_flow_api.g_varchar2_table(3407) := '08401237A8650A50080E5C288423177910DAD2527A691C6AAD5DBB16739B2106FF3016FD3202B884B9D688055DA808D28B3C5831C26EC1990C49E2FB2D8043322F1F017C63919ED3EEF3AF3EA722B944102008100408020481AF8EC04B25C098383C363D';
wwv_flow_api.g_varchar2_table(3408) := '0FCFE4FFF4E7EF9EBA7A1BC33B4C27C6DAD4554D75D81FE87EFF10B614C23E73D801A8ADBEC6ACD7FF87BFFF1998E4DFFDF8ED1B9D7DDE40F0CDDD5BE1E16CA82CDFBCB26D7A7EE1DFFEC95BE76FDDA775B058A0B5728904FBD9AE5FD10C1A09A208228A';
wwv_flow_api.g_varchar2_table(3409) := '25B598622D120AA7C627597494A71CF6EE13F205A0B5F9F953CF440FCFED642A3D366583EE09DB1CA69FD34F721645AF1FA6034DE53A8746B86C2E286E3C91441B20E108D44C07E5A2B2C55A4DB9B178CC3A632AD18F4FCFDAB1A3603C091311CB0B15A1';
wwv_flow_api.g_varchar2_table(3410) := '0D4C3583058208DA8CC5CB1CF6FCA20B7662C2762A9341C82B2C27C61B01CC7F468BC06772CE3EE77421E2174A18F6CB188D2E3B3D3EAF3F88C9D2D086AB280F84C2F0EE62CA34C24D07C3A360D7E829C25CA1A2CB1FF0F70E71581CD88CBA50EEF1053B';
wwv_flow_api.g_varchar2_table(3411) := 'C3C3F99214335079EE708569961C0902AF3A0220BAD868B78002D8297E64F47E9BE94C2E1DA742D33916627A2A53C20A76E90FD9C1B19C773CA17367D888E6426F6787B4B47A41CFB332580C8C84AB68E5F756C46BBA0D1B366026F6EF957C5673A49C20';
wwv_flow_api.g_varchar2_table(3412) := 'F07521809FC6735491F06CCF01875C22081004080204817F69045E2A01C67A577F20F09F7EF1E19E8D1D07B7ACA7D96F9E5B2693A9FFF2AB8FE0C9BCD33788E9C15D43E3FFFBFFFBCFD855C8A02DC27811FCF097C7CE8463D1070323786AD6575AD6B636';
wwv_flow_api.g_varchar2_table(3413) := 'FEFAF8B915F53507B76EC4B0922678BEC0B5073D0363D65DEB5621E00C50C39CDE3337EEFD5F3F7F1FDBFCAC696B424BF0998C5AA77B86C7BF14A67049D3B6D1A1A368F69B4F60B0C8E38F8E564DD12BFA401AC17C9314BDC927F2990C1DBFCA170C6089';
wwv_flow_api.g_varchar2_table(3414) := 'F0D08415D3BCE109A6093ADDD1477AE2C904483B9F8F1D0A72088E83AB8964123C562C14C0D38B3F5A6BBE49A66DB8C4A10D254CEB8C25F9A659E8692A91C807C6A2D932225A61A53196FEA23E267B27F35B8F32AA689B718D4523F3A81779CB5379CB61';
wwv_flow_api.g_varchar2_table(3415) := '0F49040182C0EF4500BF2C1051BFDFFFE8274A47B0CB22001536F2C50F10E1E558ECA21C9BCBB27C2FC75152FA8D94AA859589E7D8228401C0EF54AFD783A3621AF3EF6DE88505A01FC6BC7075529120F0B520403FDD9E98EFB054335E2461A6C3D21292';
wwv_flow_api.g_varchar2_table(3416) := '270810040802040182C04B43E0A51260F40A13017B47C6E7179D88C9941F44D21418D37D175D1E0CDDFEE1D79F30D3A13143D8170CA2043BFAFCFD7B47B1D2154F538F2F003A8AC5B1C353D34EAFBF6778422997D0048FC58297151ED1FFF8F3F711A519';
wwv_flow_api.g_varchar2_table(3417) := '8DE4E163C1B99A48A530C5175B91E45B660542519A0632A4F0D918A32D448ADAB96ED5D91BF740BCF3F193E9A0D178A06355B04EADC2364570F98E4ECFE052DE314B6F820233547239026ECD39DC58640B229ACAA6615D2E936386BFA0CD1CAC3EC60E01';
wwv_flow_api.g_varchar2_table(3418) := '0A39225AC3C97CF2EA6D7A002D11BDBE630BDCB6D833147392EFF60DC1730B23256211941875DAF252C3E5BB0FC17101084246D3E1A3F39B1EA14514E2B502B63242CC2D6CA10433AE3FE886B79C89EE8153348D081B592A07DB4442FEBCC38D7ED355F2';
wwv_flow_api.g_varchar2_table(3419) := 'A31398930F2ECD5AB67DD4B3B121570802AF3402F86162092ECD769F9E98CD3FB0550A7D67C37E1679A967093F5D052925087CE711C0BB6CBC4BFAB6753396A65CF3B366A38AE23EDEC5A760E4C0A8CBBD305C67121AAA3AFAAC4E9F6D4C2EA256343752';
wwv_flow_api.g_varchar2_table(3420) := '22D5C8B8D324F74BF535EE686670604092F0B7B53770255A6F2CDB77BF47250A54D63626FD6C7599CA19CE09D23E8592C4662FE04A320401820041E01B40E06513600C09C1D61C1E1FE245E507884C9FE9C12256C8CD2C2C4200434C9CCF2F7A9001C5C3';
wwv_flow_api.g_varchar2_table(3421) := 'F45DAC15A673606E2C2A9E4A5BE7162112066DF6781E29A12F520877CCA87B7444612E67B33B1F17E6C3393F3E7D460EAD9B0C3A6C04575AACC7C2DDA61A0B4AACB30B28811958786CD46A5C3E7FA9DED0525F699DB5E3515E515A02BEBD6B7D073CC0F0';
wwv_flow_api.g_varchar2_table(3422) := 'FA969716579A8CC393D320B158F43BB7E08A2512D87D1751BB308F1A9B1ED555967B7D017D91DAE5F78B0542AD5A89C0CE1B56B4088582059707C1AB30C77B55733DD6FA62C76058DD545D81D61173ABDC68C0EC658D5A01A771301CC67B84CE8151AC52';
wwv_flow_api.g_varchar2_table(3423) := '6EA82A0727B72F3A797C3EE26383D04ECEDA5B6BABEC8BEE45AF37148EB6D455CD2F3837AC6C968844BD2313B5F4FE7B2CEB9CBDA1CA82970E0F87C6E859D9BFEFD5C0330023C50481570501FC46109EEAD904F855C181F49320F05510A05F19FF81094F';
wwv_flow_api.g_varchar2_table(3424) := '61CC96C28A7ACC6E928A051C3EBD652B93E2C93418352B97924A65C1688A9D8A48A5128AC30FC7D3997818DB04F205FC64861270A90CC5CBA6E202A12043B18381908447F1C5B2643A17098704DCDC83F9D4EDF7DEFBB77FBD83AF69A5B2193E96D6E723';
wwv_flow_api.g_varchar2_table(3425) := '95A0954E5B60E0CE35A55A9008C71115F3FCC5BE06AD9D4F61017FD615A76EDCB95ECF0F6DFCBEE5EE6C62BCEBAA5C549C76F4D7BCF157BFFDCD651D7F915B2C99F385178F0D6FF9BB03F7171206F7DD55EB10EE2E3F6AF9A20BE45F8200418020401078';
wwv_flow_api.g_varchar2_table(3426) := '9908BC6C028CBEE1AEFF04D17AF424283C10E80CFD3F3DCEA423652D49F94B7814D2939C9714E7B34F14A0A5E5325FE21C7EDACDAB5A67169C5B3BDA30655A2C444C66175620F78D4D8049B6D555FB02A1EA323318E9D4AC1DDBED1AF55A6CB9A42F5261';
wwv_flow_api.g_varchar2_table(3427) := '29B22F14DED8DE1C8EC647ACB6356D8DA0A993B6B92A8B09CD629233182F4EF51A355E7E4713899DEB571EBB7803F3AA7545CA4AB3C9E9F5E25269B10EDAE85D8B92296C8F045FB7542C42A3FDE3531DCDF526BDF693735760D8B5CEEEF52B5AEFF50EAE';
wwv_flow_api.g_varchar2_table(3428) := '6E69F8ECC2D581D1C9158D35E5A612B9540AB68CCD7D41AAE1FA1EB5CE60C638F6583214A9742A154832C2446F5DDD8658D370411BF53A918027E4F3053C1E08F097C0868810045E75047057A26F4C24110408022F11812845FDFAE3EB127F5F5C5E067E';
wwv_flow_api.g_varchar2_table(3429) := 'B9EFDD773842DA8F8A9FE2CF4E750B16AE353634AACB9A3AEFF4C452C1766D4AB5FAF5E3274E69F859BC0B7E6767EB95D1E8BB6DFC21D9AED9F3FF70F8073FBEDAEDF6CE0E5241C7A6DDEB2FDD0A4A73D3D5959ACE69F9D8F8E8709F7A4224E68C7EFECE';
wwv_flow_api.g_varchar2_table(3430) := '9FFD1B8AFF687725573CBB3037B2B17EBDA17A055AF4FAC2096924298E23BFB81836164907C2D98DE1697FBCA4B55C29ADDF36FF9BFF9AB487B4C9AE2D077FC217F2E752C2BBBD275317CFDC994C1EB02C7929FF1201244D1104080204018240018165EC';
wwv_flow_api.g_varchar2_table(3431) := 'B250FEEA663025D86CD0837FCF2E2C0285DA8A320E1B51A6734A9994C7E161E02BE2F341CE2562814C2241E42AB14858556A047B04A50C846398592C158B45027E2A99A2B765A228B87F31E5180288CE555D56CAA6D815A692DE91C9582C8E585FA0E81C';
wwv_flow_api.g_varchar2_table(3432) := '0A11AD02371FF65EEFECC502DD326331FCB70AA9241C8D423F225747633190672894888560CEBE60249E4CC2B38DD8D1D82B58A3906192B35AA5989A9DC7F46C389FF97C1E22F260CD33F66D9A9E774845A2D54DF5D639874A21E573B95839AC90C9D004';
wwv_flow_api.g_varchar2_table(3433) := '226FE10F64DEA0D128653232A67F75BFF4A4E70401820041E0DB8D00264C5B67ECE5E270DBD675373B7D21FB70C1DE619BC72C08D734B71FBBD0373F7475DE191818EC3D79B953ED1BDEB075CB4284ED73CE4E4CCFA7820E4F343B3F33366AF75EFAFCF3';
wwv_flow_api.g_varchar2_table(3434) := '80676E70C631D479F7DEE088776EC06C2C2EAB2A5788A4D58DF58D969286151B28EE6327F3CA5259DB9A0D57FAEDBDE7DF6367523C364720C09B63015675F55947546C77362AF00C8F8B44D4C93BE3373FF979DBC6AA81394C0DE36B8B4B142A0D8BC34B';
wwv_flow_api.g_varchar2_table(3435) := '23E8473A914E25C9760B850F8E640802040182C03785C037E001FEA6BAFA65DBCDE5F83CDEA5BB9DD88BC81F0C615AB246AD4430EACEC19162AD1A2B81B12311682A1624637D726D5929627721AE35B825D62D835BC2D17AAF770833995B6A2ABB87C731';
wwv_flow_api.g_varchar2_table(3436) := '2F2B100E63DB273058388AE998D2ACDCE0D8142624632ED7DD9E41119F174924BA064610B29AC7E38E4CDA6897B24133EFF4B87D3E8D52615B703A418223D1FA2A4BDFC8B85020C46CAF81712BC2650D8D4F47A3B1B1E939B0E85034DA506959F4F90646';
wwv_flow_api.g_varchar2_table(3437) := '69E58840326A9D852B1B71AAFBC7276512F19C6331934923AE587D4519E669375555805D8F4DDBEA2BCB31931CB1AC5FCC5BFE655125720481EF220285C92C787F8425FAE8E2F363FFBC000668E2592FA7E8F92DBF7BB5600FAE3026E18854689711C091';
wwv_flow_api.g_varchar2_table(3438) := 'B1933985C0D28A8C70A1162E15F2053DCFCF14D43E5F6CD9D5276BE59B86D472FBE9A2259D5AA6A7708A4F04624F4A422D12C40A1F16738AE332E165A705CD4C66993C34422B6D17BDD6860EFB8F53147E5182101258C583053E8F6338E0DD25D6043D9A';
wwv_flow_api.g_varchar2_table(3439) := 'A894AFF89C6EE53FEEBCB665767C715A1060143E47D51735E87F6961D8B4B4289F678C67C24D30175102839187CD8512D444F9B2EA5F5C67A4BEB623426B49F01E5AA14965A2F80617F466D219BD4AA628D2BB1DFE8D3A6EF3E17DE9E8C65FDF73197291';
wwv_flow_api.g_varchar2_table(3440) := '22AD3EC7E673D8D809919B4A205A08265FA783894CDAE5DCF3BD5D61F16B3A718457ADBC7EE6A36B1F9E90EFFB2166562B15D285308F8D29D64B7AA5157137AC5B335117B8F17FBFD7B46D4C2DE2AF5BDFC6155746B9D2AE5B932EDEE8944F66537073C2';
wwv_flow_api.g_varchar2_table(3441) := '752B1A4ABCF10ADBE003ED56CED803DFCA6480E22BB04F5A759162EDDA8D36692C19BF52B09C6408020401820041E08511609EDD2F569D10607A735D10C5C2A38EC3E1CE3A16E1B0053F0471A5F719CA6071B2C3A8D5F2F89C39870B9412886365503693';
wwv_flow_api.g_varchar2_table(3442) := 'B32D3AF044C5300B62589E84B1049CBD887E852356198136432D5CCA883E8D5D7611BB0B9E5BB436BDB0E8090611CE0A8F62CC73066D7E30380CD68D6144EFD838540B46B928C6D5199E23914C81CD3A5C6EA1808F10D968174EE09E91718410E9191BC7';
wwv_flow_api.g_varchar2_table(3443) := '922854414CE9E9B9052C1886D991781C71B3314AC1AA6304C0C2A591291B4ED10B6F203469B363EF25F8961D6E2F4652B0074B9A71292F4C8F6C4822081004BE0C0258093C3F3F7FEEDC394CB5D8BF7F3FF6E99D9898E8EFEFDFB97327E2423F9F387D19';
wwv_flow_api.g_varchar2_table(3444) := 'FD05994824827D7D19765D284406B78B18A2FC8523F22225C33720E3F1784E9F3E8D5BC7BE7DFBB45AED2F7EF18B4422515B5BBB6DDB365C3D7F139BB7B300001C5A49444154FEFCF8F8386C1389443FF8C10FB06F30225A4F4F4FB7B4B43C7CF810B560';
wwv_flow_api.g_varchar2_table(3445) := 'F9D5AB57D1DCEEDDBB4D2613C30F9F65C0526396E6D1504F4FCFC8C8C8E1C387D1D0978402B5801E363A2E2E2E66AA8058B98351AD3093E3CB70B3629E7357AE5C191A1AD2E974D8EED8E170AC5CB99259928DABB0F6D2A54B2897CBE5D080BD918F1D3B';
wwv_flow_api.g_varchar2_table(3446) := '868D94F1D12CB50192D8A1677070107D4737D16B7C82D079E1C20584E93E78F020A2139F3A750A1FEE1B6FBC01630A2479691F914F657351AF5FA955C0349CE2E3F086333FBF1BE0D27107A9832DD26A2D3F9ECE7ED61B9AF36510BDE2AD769951C9FDC7';
wwv_flow_api.g_varchar2_table(3447) := '1BBE2DD5E20603BD6FF3B82B796934F297EB95F154F637F743A178B6B984BFAB41F254F68836D0622C99930BD94B78D963A30A022A31A76B26C6E3B25A4C424C057A2CF1440E36A732B9FBD6787DB1402DC1CB82C71288D6680FA4FBED89034D522C91C5';
wwv_flow_api.g_varchar2_table(3448) := '0508C3CE818564FF7CE2276B1578A6A0533D7389F343519584FD4EBB0CEF7F7E7633104FE7FE7C9D4223C33AF9C7DABE961C3A88CD1CAEF6CF0BB31F6D5FAD949A5A18B528D7AB245C890AA3999DFBD68D9C73A7EEDEA92A29DAB5B6EED6B1D2D3C78F65';
wwv_flow_api.g_varchar2_table(3449) := '020B45024B656BC7D9BE5361D525954ADB60940F6DDE7FE7E198541E93B4973967A6846CAE5AA7B5988A6E95D6DEBFDD6BC51AE3B12BB50D3514E79113B8CF1AB87AFC788CF236D5097942AD8F9AFFD507E74C1A75E5865D9B8AFC6D7BFECC99E1C4FA6F';
wwv_flow_api.g_varchar2_table(3450) := 'F2731173A95153B5F9CC07F6370D91CF753BFEF3DFFFD2ACC9346CD85D54A2512AE53AB540E87F34ADFA6B818528210810040802AF3802CCF0E049109E55CE487E15028CE70EFEFEB813465D083A85ED70690E9C4FF4633E9142CFB0C618439FB1E959BC';
wwv_flow_api.g_varchar2_table(3451) := 'C8074D9D493B308A4AA4D274D867E6D1CEA2B0E4378F2F3DBE7A94A141A1618980AC4217336E48E05D3516F4D2322803B585BF97012F5F40C1999C97A5E2747C8D5C9496A4ABC693D8A497CEA5E2499AFD32A518F8E6E5218C82FC91057F32E248336607';
wwv_flow_api.g_varchar2_table(3452) := '22917CBBB0938E6B050A8D53A6390C98613C424307C28F641201F87E9FB6A09AAE4312418020F07404F09BC78EBBBB76EDBA75EB1658E5EAD5ABC12441AB366FDE8C1F1DC3B89001BFC24D06A7B89980684117F20CE962640ADA196114326290411E3726';
wwv_flow_api.g_varchar2_table(3453) := '30D2F5EBD783C5E1CD1753F24515962F94084EDA947A6526FF1347399480012E2C2C80D175747460CBA5BD7BF7A22E5A47DD8686068BC5026B2100968B42D063E441F96C36DBD6AD5BBBBABA2003627CF2E4C9BFFDDBBF8DC7E368149C933100FA61158E';
wwv_flow_api.g_varchar2_table(3454) := 'A848DF31BFF07817AC82300C40F98D1B37F6ECD9030ACAC84398A9C548A290C1041974165518F360094E8D4623530B37AA11BB5BA78FE6F84DB8054203F483B5AE5BB70EBC14DB2383AEA32E63152A4227983C6274A33A14827B83513737372B954AA639';
wwv_flow_api.g_varchar2_table(3455) := '483209FB244F4D4DB95C2E800361248D4603BACEF05E7C8EF86481DED9B3677FF2939F149A80F1D0C39CA2D578266B1B9D56E99B73197CAC393C16BCB18C3F9AFD8BF58A797FFAF3BEF09F76C8EF4EC571733DD222B2F953670723E0C053EEB42318FA3F';
wwv_flow_api.g_varchar2_table(3456) := '0E0B207F7934D23B978CA6B227FB2265453C4B1117FC161F3B87C3022F45887EC820E1E18235387C2ECB19C85E190BFF70B5029D06B3C583268F2BED58C6C72BE0B2E6FCE96BE3D11FAF55DAFC19318FD56E46455A03B4C1EEFC5A1E7A1B3C78710B1571';
wwv_flow_api.g_varchar2_table(3457) := '69C2932AD3F0B42C761C8DD21F1F5D055F3EF465C89E78AD59967CF4C0A322096ACA9542A768020CB558EF23E01C5921BD3A169D70A55CA14CB1922B13B04FF4877FBA499948D39E6D188016D1977C5768CD2F9CF0D4CD51A9B69AA2CAAD5B5462F68093';
wwv_flow_api.g_varchar2_table(3458) := '3DDB7F0A6EE07AA3F82F0E346904F56862634B599DF66D0E27A3100BB87295F987DF8BB3B2D77B6758E9E89B9B1B122D6A1657C0CF351729F46FBCA64E866BB91CB65C25DB2C4B6D6AAF54897902A5EACF7F7C58C64F967215ACF27728AEAC60AD452FDE';
wwv_flow_api.g_varchar2_table(3459) := 'BF6F538E95D22B21A7F9F1EBABD3618B88CF916B0D15AF1F92EB4B10E723AA92A68432416693582E3EFCF6219D427A78B736E4B688F919B5AEB8F8FB8898C5DB64E108321B1F3D8F0BDA4986204010200810045E2E022F4E80F1B0F91A9E692FB7B74FB6';
wwv_flow_api.g_varchar2_table(3460) := '8691D9EC021D9182C37EBC30A7D02F8C75E068A5AF72E0D7CD679821C9170FF34723147AD8C9E8FEE2DFFC48B4D05CBEB4204353D12F2A3E1229547B42B2D0D2E336508791FF9DE3129D8F071BF9DA05E5F98A0C3D7FAC6D9925059B4986204010780E02';
wwv_flow_api.g_varchar2_table(3461) := 'A043A0583E9F0F19903110307060302E502FD4C2AF1D6E46504770C88D1B378E8E8E5AADD6D6D6D6FAFA7AB02CB03890529C225359590949F81B7109BC1124100C167CECD34F3F55A954A061172F5E845F17BC1A57653219BCCD20A86814BF6BCCFC4CC6';
wwv_flow_api.g_varchar2_table(3462) := '62851F389A86F3138E5F28F47ABD3003ADC3470DFA0A9729681EB31131DCB33B76EC28D809BE07F67BE4C8115404C34495FFBFBDF3FD8DEA4AEFF8FCF0FC1EFFC4D878C0D806C29200294B924DB554558594DD6A53369BA66C5345BB9B97F917F2A27DD1';
wwv_flow_api.g_varchar2_table(3463) := 'AA51D5567D51556AA5AA2FFAA24A54552549ABE645802E2C2401925DA05B421C1C8CB1596CEC183CFE31BF3CEEE7CE333EDC8C27839DAC125CBE57E8F8B9E79EF39CE77CAE997BBFF739734DF07D7D7D34C0B876ED1A01A318F7EDDB77E1C285DEDE5EA2';
wwv_flow_api.g_varchar2_table(3464) := '7AF7DD771988F42982993F3B4C9BC3870FD3F1F8F1E3C8D7FEFE7E32B1030303B43975EA143EC98ADFB871E3C30F3F445D9319466FA3544998D31168685426CB106CF877CC11C0738552B09CF33E3197D3897843D5339D99991932C0FC9974A60334C83C';
wwv_flow_api.g_varchar2_table(3465) := 'F7DC732022F58D7A27AA175E788129BCF3CE3BA02054A43E04980525F031C887BB0F656433A712029C534285F6A64D9BDE7FFF7D26C59302C6223F3C3F3F4F7E18390D7C824494E6E761B51C19FA1C41180DEDEC8A6EED885C9B2A5E18CD7F3C997FF1C9';
wwv_flow_api.g_varchar2_table(3466) := 'B68E74087D3B387167E856614B7BD3CD3B8BE33325AE24B3F9A59ED6F0D8F4E2ADD9C5C3FBD3A8C44239C0438E23BFC88EDC2AA513C1179E68F9C5687E68B24832F6F7F6A43EBC597CFD83D9DE8E485F5BE4D8E03C9FF387F6A62EFD2A3F3C551ABB53FA';
wwv_flow_api.g_varchar2_table(3467) := 'FEDED485B1C2910F66B7F3DE27961755E2E2E3FEED4BB3E747F2E954E80FBED93CB3503EFED17CB650FED1B75AC9DFFEEBCFB32475178A48E2C099E1DCB96BB9AEE6F0A1BDE9B3C3B9B3D7729110730B9EFE640131FC9B030994795B22F8EDED89A39779';
wwv_flow_api.g_varchar2_table(3468) := '1D95B7715A7ADBC3E958E8F490F74BD81C0F4DCD2F66734BCD092FFD4B0DF37AFDFC2CCD0E3FD6DC9608A384ADE3172BB9426FDED8DE37D0BF75ABF74BD23E35B7D893E15C34B7C73775B50782DECD0C823CDD8FCEAC6E035B33D972606BEF9648B2D8DD';
wwv_flow_api.g_varchar2_table(3469) := '1A0FB4F62F1F09746F880636A46C3755FDE9EDF56DE9AAB6E9B8AB7EA9694D465A77F6570F05020319FED419FF2A5BA53FC3B76CE8ACEC7BE9FDDE8CF782AE9E0EFE6DAF54F21A4CEFE78624F3B0BF8E56ADD60F1110011110812F4FC05DD057E96A0D02';
wwv_flow_api.g_varchar2_table(3470) := 'D8B9C6F06CFEADFF8D39B0D69879FCBF98CDFA3F1F9A8108DC1F04105AD50FBA4AC2137DBB322EF415EA115D84A6E2281ACC9F69449B21F09E7EFA69E4252216D53739398934E5A11B89477429C28C2424928F4A242E520DB9C840C82DE419820DF58B24';
wwv_flow_api.g_varchar2_table(3471) := '7BE8A187C879A29069C64A661A98005B8EE7339FC31C45618E8F8FA330516E88403CA3576D978E04431B642AC1132D1B2B9C51D468786C7C5EBF7E1D8D87FC237E0810C0EEDDBB1F7FFCF1898909D420A21D872855964C630F0E0E122AED11B7C661FFFE';
wwv_flow_api.g_varchar2_table(3472) := 'FD2466D1CF7441392326091BE70C87C8DCB973E76BAFBDC6EA6BB42B221985CC33026342C6F8CD37DFA4D9F2BCDCCFBB132442B0F028812110B184047366C44301FAC2937858143D3A3A0A619C731291CA3B76EC208B8E30664610608380658FB1F1C934';
wwv_flow_api.g_varchar2_table(3473) := '39839C4A9CF3D6068E828EF34589071AC0736868E899679E2133ECC25A69788156824D4482ADC9F074AECCB565634BB8B0B8948E0663A1C05CC1331EDD1265E530C36EDB18B93E5D9A2B2C22865B12E1D97C391D0B9E1ECA6517CA3F7C227DF2E3DC7B57';
wwv_flow_api.g_varchar2_table(3474) := '73A3774AC968F0E0CE24EA747F6F7CF796D89E4DB1BF3B41EEBF9C5D58DA980A4DCC96DB92C1DFE94A9E1BC9FDC6E6F81E1A6462E3594FA3723A47A60B1F8C16FEE85B649E8B472FCF7DE7E1D478B6F4F1ADE2137DF9B1E9E2B6CE0882FCDFCF6727664B';
wwv_flow_api.g_varchar2_table(3475) := 'FF72361B8F043FB89E6B4D84AFDC2A20AD7F79234FAFB6440861EFAD5B08049AC2C1D678F5F96AE551B0F70AC7377F39D71E0F23FBCF8D2CCCE511BEE54C6B841EBCDC7164AA383459205D9C8A79EB02580541C929E6BF009C57026C5C930804FEF099DF';
wwv_flow_api.g_varchar2_table(3476) := 'EE88573BF6B425BB520FD385A84CFDD6ED9E0C057EF483A73A935F4A7BD7F5AC4A111001111081AF804083FB31BB4F73776BCE202A6C57D60DB2CE5D5DDD76E6A8EEA1F55E29E9BBDECFA0E217815F2F012410A291B5CD28435413B9D943870ED5683324';
wwv_flow_api.g_varchar2_table(3477) := '139F8A245711456827D29834A8C8846A2CEC22F9FAFBFB49756EDBB60D41885BE465269341079E387182C6282E2401259FEF6483919AE44869866C63FD30E2F0D9679F251B4C1792B7C8061432D28E1C6C4D303624AE88046D8972E6CBB444487A1905CB';
wwv_flow_api.g_varchar2_table(3478) := '5C50B9F8C70F721171CB1026DA298990B1C89AA296F1600B8C59FDCBC4A94728A22411CCC8CB81810112A4685D7438DEF0C921BAD3F2CC9933AC0627458C107DF1C517D1A5844D1B52A9C86382617138934209132A34688FB03F70E00010C8DFA26677ED';
wwv_flow_api.g_varchar2_table(3479) := 'DAC563023FC095E79459138F2DE4E68900D0889FE9304D3CA0CF8984B14074F6EC5902801831130CDF8BA60112DDF977009917CDD0BA844A069B60C81E333520A3F3198E21983E496CD2DDFC3E10BCA15B191E35647113D1E0E874E9CA44E1BB8FA48627';
wwv_flow_api.g_varchar2_table(3480) := '8BC8C8C77AE3E3D9C54FE7170FB4345DBE59D8B739F65F97E6587B7CF89B2DD726B36DC9F0CD99D24476B1331D9A9E5F9CC89653B1D09ECDF12B13C5997C39160EEED81819E88CBC7775A1331DEE488549D2DE5E287F7F6F3A150F6D6A69FAEFCB733B3A';
wwv_flow_api.g_varchar2_table(3481) := '639BDB9BCE0DD32044834C9B97808D8603D1583857E46B3BE5BDBDF1F25270E4D3E2EB17660F6C4F46C328D532DAFBB776247B5A9A624D21D2B684FDFBFBD2DC3390E98D84837B33B1A9D9F2C7134506E56BBDF62A2CDC6250A27E2767D1EDC10B6339BE';
wwv_flow_api.g_varchar2_table(3482) := '91FCD423890DA9D0A92BB9EFED49E1F09F4EDF7EEAE1044E7676C79EDEB3747C703E194D254AB75ADADA49B3F3FBC0731F7E9FEB026C5049E634D37D37778AFFC8F217741BF7DADC6D89D906AD74480444400444E07E24C0C368D67959168127A75C8279';
wwv_flow_api.g_varchar2_table(3483) := '3D87055A57E2AE5EAEAE5600BBC1DC7818928EF7E32F8B62120111F872045038A82CE41C9943D42F59CD95FE504DE7CE9DE3ABB618ACE3B5060824F7B18881AC4268E181AC2C729ABC286ED196A4132D498B1878F5D557D1997CA995D4E55B6FBD856844';
wwv_flow_api.g_varchar2_table(3484) := '1E5383DC42E0E11C81CD0A61D2ADACC8E5D39F8B810B86C79BBC5DEFEE6E30483C5C2AF8822B9A8DA858B88B1E6650B2AC88E7E79F7F9EF432BBAE0B06FE59748D0026614BCC4C19ED87AA6420E42233620A1CC5217A1E858C6224C5CA2162E3285A9AA8';
wwv_flow_api.g_varchar2_table(3485) := '3090D610A381F5C23333BA78F1227E508FA0A00D954C8D8EC86672C8274F9EE4C10136B219E54986DC3F3B1AF33D63BE2E82619B79263C74290331342551518F7F82C739DA15022487D965441C5A3DCC81C0E300277DE94E24C48C43965593584642239E';
wwv_flow_api.g_varchar2_table(3486) := '51E99C2386E059007D71CE51A2E5942192D9B5603CF8CB6F8EB09A6853E8F278FE2FDF9EE649C8AE4D51FE91FBFDB79F678F5F66D5F1D2635BE23DAD4DF4EA6E6922ADCA02E3AE16661744D03EB92DF10F276F93E9DDDE15D993891E399FFF8BB7A64817';
wwv_flow_api.g_varchar2_table(3487) := 'FFF0F1F499ABB96818047C8337D8910C5D9D2AFDF4CA020B924F7F924B47033FD8D79C88866211BEC8620DC2AC973E7639C757795FBF38F7D144E9B1DE180BB05FF98F29D2C107BF913C3138FFB3A179BE69DC140A3C3990F8C753B7BB9B9B5802BDA52D';
wwv_flow_api.g_varchar2_table(3488) := '4218C73E9A6719F373FBD2EF8FE4FEEAE8345F334E444217C7F2CC78736B92B9304DE28F45027C219935D2BC9F7170A2385F289331FEF6B6C4AEEEC87FFECF2C8BC051E34D44B4C412E8E299E185F119DE01B674F4D8D1EFFEEEF778C470F0E0C137DE78';
wwv_flow_api.g_varchar2_table(3489) := 'E3A5975E32682A45400444400444E0F3087023C4E3722EEBAC9B43FD723FC675DFAEE318B671A5B6CD9CF8EDCF734B7DED5F7DB0A6EE1A8FC1306C18DC1412071B4FD9D9D8F9DFA1E19FFCF15F873F7B13D060301D1201111081FB99C0897FFEDBAD3D7C';
wwv_flow_api.g_varchar2_table(3490) := '5DD65BAB499E8A3B75B29D7CE6DA47222595A4163168C0FA5EE4250212658BF4A2D2F2AB66230B592D8C92E4F313458A30231549429284309FA5E82E84289ED945C2A1C148516223D2306849AE9812CFC842FCD080B1506574E1C31D86140BFC5551D2B0';
wwv_flow_api.g_varchar2_table(3491) := '1B5A972A0B87A9B7909076F425DF8BEA43D471F14007A2DFF08632246D8B5C245ADA937C46DD210B991711E21F714B775AD28C3648441672933BB5842A6110182A9D36F8A79E68990E5953A6C910ECB2A89BF76CB1F098A34C9CA3485C8E12033E39C414';
wwv_flow_api.g_varchar2_table(3492) := 'A844709A5B32C3C4C9950592240629199709B29A762A3B57790B748B9776ACACC385060215C2F4256032D210C303FA99A709A485018E67C6222DCCE92048CE14315B4A9C59100913070B28982654D1C9B8B205D576AE7960412F3C3010E3323B7C828267';
wwv_flow_api.g_varchar2_table(3493) := '1378B6F0BC7732DF9E69DD00A5E5D35158E2B5C9ACC74DC602031D51D6FDB204FAD2CD020A331C5A7AA427866E1CBB5DCCB444F8FA2AD2BE23191E992EF6B547C8D30EDEE28DFE814C6B38D3DA74F5D3E254B69C8E071EEE8EFF2A5BE4B552F14868EC4E';
wwv_flow_api.g_varchar2_table(3494) := 'B1AF23727134C74B9E9B63E12B93BC9A2AF8505764A1C8C2E9301AF846A5C1F9EB3972B66866DEB68566DED6D984F3B14F4BA944F01BDDB18999E2D89D45566867DA22BC25EBC2589E905A6241BEB47CF34EE96676912E8F6E8E1124AA1531CC14E2BCA4';
wwv_flow_api.g_varchar2_table(3495) := 'AC22DA2D09CC72E8C189C2A39928596EBEAE4C26399BF74E8EF765E068F8A3716F0DF440671331C08D84F69589523412D8BD297A7DE41AE782D3C429E674F01F81DF3DDE344E336D22200222200222504380EB32B70A547239E6AEE3C891233CAC67B198';
wwv_flow_api.g_varchar2_table(3496) := '35E33ACE52326EB4B80DE096C6362ED95CD0D9B8527397C2559B8D9678A064737D31EE2D80B9D873C7C0461C6C26801912E3D295AB3FFE93BF094B001B5195222002EB9CC07BAFFE7D5FA61B01CC3CF8AC64C52672CB7D68F261884C422E9A04B20F463E';
wwv_flow_api.g_varchar2_table(3497) := '58F984B51A4AD7180FB64B8D7D7E5A4B6C0CDEC08454E359264A8C066C54F2016B47D9C5C62D95360A35185663635549233E963FD3A9A10D47D9E8685DA8E4326095D4605056FB567EB81AFABA2E0CE4DAD0804338A4C63CD8AEDF9BF9A79E8E7EFFCC82';
wwv_flow_api.g_varchar2_table(3498) := '43168CBF1E9BC61CE5105DCCAEE9CB70A8DECFC4BA8CD462B3C86B4A0EE10DFFE6D606A58D75F1C7E0EF481736BAD8342D6CE3E6855179FE6BA13A5756EF7758193A50E68DD095D72CDB99E14BCD20401547C2D5F5C37EFCD6861AAEF25E472F914BFC5E';
wwv_flow_api.g_varchar2_table(3499) := '17675B7BE78D513815A58A1E8535800C91BF012963DED1454BEF64F0CAE8723524EAA8B75E2C63A69E5E885E3C6030285DF8334EFCA83663BFE2DD7F166CA04A5BAF17617BAD8241B2CAE6B0F2F62CEABCF93282D1E0179336C69C43DC422080791EE1B5';
wwv_flow_api.g_varchar2_table(3500) := 'D326022220022220029F25C045996BB1D571F9E07E8C67E85CA6ED2A4C0DAFBDE43AC24373142F0218F54B59D1BFDEDA34361AB3B93B10BA386F186B5B02EDEFE9B9292F16A6C7B9D1B27A9522200222B0AE091C7BFBED8D1DBCB1C9BBA7AFBBF1181249';
wwv_flow_api.g_varchar2_table(3501) := 'EC5741759B35AEE4539885C46CA4C2BEA4ABC603E9A808DC9F04B8AD410393B4BF3FC353542220022220025F2F01F2AC68E0063190E645F17243652AD79E5F5B7BA7751B745F8300C69D7FE3B9FD52A930377C6959513718458744400444601D10F8F33F';
wwv_flow_api.g_varchar2_table(3502) := 'FBD348D3DDE4674DC488556EDCF9A8ADA9D7AE0888C09A08F05F898DDB9735F5526311100111108107844063F50B84975F7E996F2A714B66E2D432BD26839D5C3556ECAE84B65A01ECEFECFCB29EA99C9B5BE9543522200222B01E090C5FFD643D86AD98';
wwv_flow_api.g_varchar2_table(3503) := '45400444400444400444E0C121408A9875CE285E34301B1337F56BA571F0ABD71A32AB15C074F37BC13B8F6F7B3299575E798508D8488CF80D84BB6D95E7BCD5A2666CED8A800888800888800888800888800888800888809F80094F24A7655E3110BA56';
wwv_flow_api.g_varchar2_table(3504) := '227DED2597DE977D2B3298926634B0C6D6D7EFADC65ED54BB04CBF2271D1B4A675790B345FE0A1E4255D66782F86AE549A0CB692F6F4A23B060363D40CAF5D1110011110011110011110011110011110011170049CEE3565EBE579C36184AEBDE499BFA0';
wwv_flow_api.g_varchar2_table(3505) := 'C18BAFD8D8B5373F637B6AB8B2D1D2A432DE30289D2436630D19600BC845530923CCF0685D1B8CE111C3285E94B0E96414AF09604A371F1922200222200222200222200222200222200222F07904109B55BDBABCDA19C969029892CDD42895183841EB3A';
wwv_flow_api.g_varchar2_table(3506) := 'B9EB146F5DE76B10C038C2A9E5722BFEBD4CB465771918C346B29206A67E4DFA5A2F8B80FABAA1A8520444400444400444400444400444400444E081258096345D89C166AA93D212AE267751BF6ED71AB08B61ED1D3A769DED37EE2180AD9B0BC2B42BDE';
wwv_flow_api.g_varchar2_table(3507) := '314CFD62B0E1D1C6A3745A1CD16B9BB5B1D23FB66C11100111100111100111100111100111100111F013406FB26B25EA12C334A69595047055035B8D89564AB7396FD438DB8C7B08E09AD6EC320625CA165F8482DAAE6963952C8146F19A00A68189647F';
wwv_flow_api.g_varchar2_table(3508) := '59D34BBB2220022220022220022220022220022220020F2C012756CDA064435DB261A0432D036C8625814D005B5969EE158D01D6CAD7BAADF18276A5646C342D6D18A3A625476D60D63CD38680284D03D352D2B706977645400444400444400444400444';
wwv_flow_api.g_varchar2_table(3509) := '4004444004561230114BE936946645087BA96027839DED9AE1CA6FAFF44CCDAA04B0F5C497198C84CAA5741E3964DAD80CD3BD9466D00CC3359621022220022220022220022220022220022220029F47C0B4271A9306D8A63D91BE2683CDA0D2A962D3A1';
wwv_flow_api.g_varchar2_table(3510) := 'EC5A47EBE56CFF28AB12C0D6D3442C4E49ED5A697170941A2BA9B1B75E515A7B0E319E04B01FBA6C11100111100111100111100111100111108106044C84223C6943C9468D194EFAB26B9A14C3EFCAFAFA6B9C7D8FBF034C3BA75D9D94C5A092CD54AEED';
wwv_flow_api.g_varchar2_table(3511) := '529AF4C560B38E18347383C91001111001111001111001111001111001111081D51030C54B4B13B4685DA7816B0CDBA5749BEBE506E290575957A0D654DA2EA5339CB2F56B606B60A5696006705DCC70C3CB100111100111100111100111100111100111';
wwv_flow_api.g_varchar2_table(3512) := '10811A022662ADB2AA5A9DAEAD189607B63ACBFD5A1ED8B5F2F775CE398ABDAA25D0FEFEE8587A320C062A9791ACC6F4AD13C6B64B69861BD58CBA95356DB42B0222200222200222200222200222200222F080103081EA9FACD5B8D20CA428069B495F2B';
wwv_flow_api.g_varchar2_table(3513) := 'E9458D2BFD86DFA1575F578BAEAC74352EB54B672A9DE265D76CD7D21AB812439B08888008888008888008888008888008888008DC9380095A9AD51826805DBDDBB59A1A19EC1FA57AC8AF57DDE1069576C83530C354B1ABC44F8D4E769E658880088880';
wwv_flow_api.g_varchar2_table(3514) := '08888008888008888008888008884063024EF7D2CCA579AD0B876C6317C35FE96C33FCA5B55C6D06989E7E7D8BEDDF35BF5623E9EBA72C5B0444400444400444400444400444400444E08B1170FA96EE2B45AFF3E957C8FE2EAE8175F7CA953A96DABA95';
wwv_flow_api.g_varchar2_table(3515) := 'D6D97F08DBBF6B0D5636F3D7CB16011110011110011110011110011110011110813511A82B6B9D2476AEEA36B3A37668CD0298CE75456F450BEB2F1E39F2324440044440044440044440044440044440047EFD04FCF95EBFF706EA97665F5C00D3B9AE06';
wwv_flow_api.g_varchar2_table(3516) := 'F68F2D5B04444004444004444004444004444004444004BE02028DA5AF05606DD6F06790FC71AF66007F7BD922200222200222200222200222200222200222F0F512087DBDC36B7411100111100111100111100111100111100111F86A0848007F359C35';
wwv_flow_api.g_varchar2_table(3517) := '8A0888800888800888800888800888800888C0D74CE0FF00CB09527D8D1218E70000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(5237764397387831)
,p_file_name=>'nafpeobdfpjcaijo.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/files/image002_png
begin
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000003A20000010A080300000148F12889000000017352474200AECE1CE90000000467414D410000B18F0BFC6105000002E5504C5445F7F7F7EFEFEFCECECEFFFFFFFFE7B58B6652527BB5E7FFFFFFFFD6FFCE94';
wwv_flow_api.g_varchar2_table(2) := '5252527E7E6B52529CD6FFFFE7B57B529CD6D38A5E62566F94CEFF7BB5E7FFFFE7B16C5F9CD6FFE7FFCEADE7FFFFD69C529CC6EFAD632184CE73314A9F2E4FEFFFFF6384ADEAE0B763ADEFB5E7FF7BB5D6B5EFFFEFA55AFFEFB5637BB57BB5EFD6B475FF';
wwv_flow_api.g_varchar2_table(3) := 'FFCED6FFD6A4DED2FFF7F7CEFFFFEFFFEFFFCEB5CE734ABDBDBDEFEFE7D2D2A4616B77FFEFCECEE7ADFFFFEFADE7EF21212184CEFF84ADDE8C2D2D2163ADFFCE842121849A62336BA5DE842184FFE7AD622D15292121212163CE8421FFDEA58531132984';
wwv_flow_api.g_varchar2_table(4) := 'C6FFF7C6EFF7F7C360206B295A6363ADEFE7AD6F98988E63696384CEEFAD846321847F256784CECE8463AD21636384CEEF63639CA28E98CEFFEFD6FFEFDEBD94F3C57FADCEAD84ADAD63ADAD8484CEAB8B6D2184ADF7BD842184BD9CD6EFAAA4A7EFFFD6';
wwv_flow_api.g_varchar2_table(5) := 'FFEFE7527B9CCEFFCE8D8D99CEF7F763ADCEDEDEDEE7E7E76394CE636394D6D6D6FFE7DEEFDECEEFC6ADF7BD9CEFB594F7B594F7C6ADF7B58CEFA57BF7A073F0986BEB8852EF9254EF844AEF945AE77B42EF7B42E77B39E77331E76B29E76321E76318E7';
wwv_flow_api.g_varchar2_table(6) := '6B21EF7B393921184A294AEFBD94DE6B10B44106D65208D64A00D65A21E75A10D65A18E75A08DE4A00DE5200E75208DE5208E75200E75A18C4B0A1F7C6A5396886FFD6C6FFD6BDEFBD7BDEB594E7844AEF6B29DA4A08DE6318DE5A08EF7331BA4220DE84';
wwv_flow_api.g_varchar2_table(7) := '3DD65210C1693E962969D6EFE7FFEFEF7B529C4A7BA5EF8439D64A14D67B4AE77339DE5210E74A00E76310DE4A10EFAD8CE78439F5B17DF3984AF7BD94733139EFBD9CB5EFEFF78C42DA5A10E74A08EF8C4ADE6308EF7B31E76B18EF7321EF8442E97B2B';
wwv_flow_api.g_varchar2_table(8) := 'F79C4AD67310F7AD63EF8C427B98B9EF7329DE5A18E75A00D65218DA6F32EF6318EF6B21FFE7D6D64208F7AD8CEF6321F7A57BF7BD8CFFDECEFFDED6EF7339F7CEADFFF7DEFBB56FB1B1E23984B5FFD694F7A55A739CCEEF8431B1D6B1F7CEA5529C9CB5';
wwv_flow_api.g_varchar2_table(9) := 'EFD6B5D6FFEFD69C00000099E567A4000000F774524E53FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF';
wwv_flow_api.g_varchar2_table(10) := 'FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF';
wwv_flow_api.g_varchar2_table(11) := 'FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00EE663693000000097048597300000EC400000EC401952B0E1B0000727F49';
wwv_flow_api.g_varchar2_table(12) := '444154785EEDBD6D6C5B577A2E1A798106BD2D4262007A288B096F89315D799F9AB13D55CA6C42A26951D7A2D0D84E1CDA33C7D1346DDAD43929EEF8D4E7B4B62407B22803FCC11F37A026262002F2A08D07F9A138C628417C28F94750DE2208CEB047C5';
wwv_flow_api.g_varchar2_table(13) := '012EF4A3E6204190836903DC33FD7F9FE75D9B5F966CCB8E6DC9F27E24EEBDD7DA6BAFAF77BDEBF35DEF7A46116EC3E8340C65EC50414329C3DB030B79F188A04355CA6FDF055EFBFEC8500BF5F1C2CE61D5E95129C3ABFC034A2D594AED81E550A45F29';
wwv_flow_api.g_varchar2_table(14) := '988FC55550C55414D6408897D74C950AABB047A9A415156B8F4AF01A0BE26A59CA1FC6CF1C88047DF087DF240EAA6E151BF028D8ABBE67DADAE4ABC78B67E6D72554FBFE7821A1463B4DE5EB6D170B7546F5EAE49F7D67441DD8428B77C4FC10B14E690D';
wwv_flow_api.g_varchar2_table(15) := 'AE89AEE9C94C269B6DF9CF8CDAEF1E003A54A3F38F3A5919A1F49B5263083BE051A9727E162814AAD5CB852B8B33D5422E975B2C5DA956F325BE982D166717660BC52F0A335F14677399EC44B85C1E3F1F88982A7E8C3E91EDD4E7117A05B84FC2E7E0BD';
wwv_flow_api.g_varchar2_table(16) := '72B873B6905D439ACE8D952FBC3BFE6E79F94A75A1B0B0305B2A16F18F08CD566D17ADA8853AA48EC6BA948A2062E64105DE8EA993EAE062C98D77DDEA483FD26DFACF1D44BD31141912E7FABB6EB94EC97509493B264F4C9ADF0F3FD42C9E5049F8D52E';
wwv_flow_api.g_varchar2_table(17) := '153ABAA47CC7034A3D67878AD7046B1F5D03E9DBF99BCA8AC019D16C6F43AAA956D0A3253EE8D011EA98FD2038C80B3CBC6B0E7F305BC864D3E979DBF820A866ED8716D8A1B2FA4424AD01B63DC8C1D34813F8777EB25A45499A9D917283FFC2EC95DCF2';
wwv_flow_api.g_varchar2_table(18) := '7431932E7F791E65E37F160B330B856C76BAC25F667FE646652E33FD712253C94EFF4BE506CA7D690A3E99A8CD5B708FD2741B46C77F53C9E4AAB96A0151613C101396621B57AA57F228E2F95CB58AA76AEE4A3537617FD98AFB0BF56141876A6CEBF4A1';
wwv_flow_api.g_varchar2_table(19) := '659286ED71603DD3AA7E4FDF0052FF91A325AD3DF6FD91633D73D8DBF9A9E13DA476AA983BA4BA2371B17C8458D7D2F498A143BDDE9952C69E88BAFADC7EF736E542436BC583EAE0D0EBA8204F1E55C77A52F3BBDBD49B31F5F612DB9AA8D4E2DF034F5F';
wwv_flow_api.g_varchar2_table(20) := '0E1B9DCAE841D37BD41C92DEFBA3C63AA5B5EDACFDA4B6F182CE94577588F911629DC639EB142A2EAE6D57BD3D3D2ABACDD8CAB1BAABC7D869B053F5A8A00B5317EA85C7887529C112A86BBFB1CD5086A1928138BAB3E876C754EC7576659281686808ED';
wwv_flow_api.g_varchar2_table(21) := '0F06EE1115C4C0FCD85E74AFFFCA5A8AA0977E0CC3EE9E8009C71CA024D0B1F477B28B8E01BBEE1704FE38C4873754026DD8E17E33E06167D9C288595E3F5E3CF3386AA1DBB16E34FD7D53A5BCAEDE9D346F1951BD5BD4763E6278BE25A8304A3F601B1F';
wwv_flow_api.g_varchar2_table(22) := '1AD627A56B2A48DFA4B3B70DD0B395C9072F8212E873A8F07DCAA39232243CD5750283AC40246A86C10DD7398C992D9416395CC92D564B798CCE6F2E5EF9ACA007351CA71731E82A2D148A851B994ABA5C4E7F17A8F5F206ED3B3CD7F0A1A23B75F7EC9D';
wwv_flow_api.g_varchar2_table(23) := '2F15162FEEB50D77C16879BC7C61BC8C615F01E3BEC202628281567176A1F8B5EDA2053A50193E2F61887B2AA022033FD9A1D4273F456ACFCFA27A0CA867D5C05458C5439C9B88057EC7217244BD2EA3EB242F3652A1FAD8796058A5A4EE9EABC20D93CD';
wwv_flow_api.g_varchar2_table(24) := 'F17F4AA184C2D0DF92D2C3F8E9BA4486D86A362D3781B697AB7EB9269C2FE062350FFF71B1EE9ABD85422E93497F8F391DA516EC7B0B24D03ECEEA58435D0AFD4FB57B20DC25AF40FBF267570A5FCC16F47C0E2F85C5CBF9EFAE57A7C6DF28D3490E05AC';
wwv_flow_api.g_varchar2_table(25) := 'F87E26BBCCC23DF72F958FF64F5F9FCE64BFAC745EAA7CFC512533572D853CF1DDD24C2640341B772F48B7E15C792C73237B4586E60B28D59CCB59680CCD17F2B93C8A783E9F8393124A7AFECADCCBF6A72DB8AF401F1624D0E7D46EDF7EDCBB928FB0BB';
wwv_flow_api.g_varchar2_table(26) := 'D084F54BA9E637A4B59D933C8F1E12E8235FBEB80DEB97BD2EF48F7EE035DA39C3C3CA63408576D1FE51C10EF4F1623DB3B7AB031DC7C8EF71DAFBF4EE4E75B4030DC6A9C89232D90EF60FE1123CA4063D09BF8A1CD6D3E1DF07EB97D2C70D09F439E536';
wwv_flow_api.g_varchar2_table(27) := '3AFCED87D0981F945584478CF549A93D3E6DACE23ED2F55C0D09F4B15783EB3212B7EF4A754E745D350CAFE1FD610F477E6ED511FC6F2AE2E130506D535EEF4E58B7FB4DE4FEE369741F36D6A5F4AE0B1A297571B10DB0590625DA44971C6D5D9F749223';
wwv_flow_api.g_varchar2_table(28) := 'B8E8A578D54F6B41AD473FCC8EBBED40C56A4B8BB41944E51DE9C3F3D2DB218B9E588970ADB30ED732E631C36EB4A84B96C74AE00B8B2B66FD4B47D52BD6E1833204C277121057F8EAFDF6FA3A4BD80AE02BF869E26E99287016C61A5154721EC61D98C2';
wwv_flow_api.g_varchar2_table(29) := '77165866EFEA4C73DBB4801D4063F8751B6A9E60C007AC9C53A80DE30849E9ED4E9A1D20A5F65DDD73D670B7BEDDBBE543E5B01ED5C33AE08E34DD74103E3DDBAB7E5F199D31C3ABBCD1EED7BCAE5A07F4C076F52A6EBD67B7B49DF5F61ED09632EF7380';
wwv_flow_api.g_varchar2_table(30) := '93025E66522F86D75B7AD581BFAD4D046D503C45756F9B5A75B0BCF9D0A8915C5ED58991D47E4ADA79BA23561095BDA58E99CA544B01D494FD27F014F2AB4032A2827115092B9FF29F5227FD2175353D79EDC39B3325CE57E93991D9E2024C0258D46725';
wwv_flow_api.g_varchar2_table(31) := '38B9C6998A99997C71397BFDF4F3C3E9C171637A64387D7AF0F4BF2F0DBC658E241028461468568682961A40F0494EBFB0720EB4EFA11C8A3A941C3986CAD93FE451C1767FC8549E134AE6663CC9584285F126C8AA78AF72AB93433F967ECE71157FA6AD';
wwv_flow_api.g_varchar2_table(32) := '260C86A1DB7DF70ACF651625F685422997B9F5956D7B4FCC8F4D64B2D56AA1B0C0C417BE28CC162820B4303BB3009B05E446A93977C41543992950E2A2B0F045A95828E68B8BD5C9BBD5A6B74D987E0F3EDDF74F88D187DF6B3EEDBEB06F6C6CECC238FF';
wwv_flow_api.g_varchar2_table(33) := '701B2F8F4D4C2DCF162EDA2FEF8D969406F5E829A486BAD9902F59CA4FDA47D4003A2F7E1FDFD91D29F41FB2B30599AA23B4ED80EA8E739A266E8662A6890E338A584C0586446809E894EBB1107A21A110BA0F6115E91E42FF656028A2DCF85842371972';
wwv_flow_api.g_varchar2_table(34) := 'F8B7A7422880B153C754BF4FB997D09BFA895BBDAE547B3F22D2AFBB6670909E2DCA233E53AC6FE46326E064984F9F242D8F9E7A0E9C7C709A8E2D14D66349E7362CCE66ECA77BA229A531E4F5125AD2E7D07DE47885BDC91DECCC7AAC61744A3B86436D';
wwv_flow_api.g_varchar2_table(35) := 'CA12074ABDA4D4475FCCCEB076919950306A61A6949BCE66121F65AAB9B9EC74258F3E679FA5764957D68A472C0F28A383081E1C46BE83329A0452E190A0A6F8DED133986287912B70006373B89D7D48F8143BAAE6696075F90A5E166613DA0FD443DAF7';
wwv_flow_api.g_varchar2_table(36) := 'C84BC1C6CA413356D0F4CECB0436F74B2FBE8628E3CB89E0F2E9A94CE7358A69510AAB9ACFEBDAC606B343EA5D00554A2E9FCFDFCC95641D84603564DFEDCB8CFEA05E2DE1419E6B15B9E42F5D2EDFDE7F06EA238C167C8F1AE941317AB172AD52A95CBA';
wwv_flow_api.g_varchar2_table(37) := '94CD6432F865B39D97B29732155C2A1558653297FE31F3EE1A1666EE0F8D94A23D35FEC8ED6DFF7487F21B284B5DD154E0FBCAAA6C2434A5D4BE6F56AC43E95D2734D1F4BAEAFAC03561B0AFE472193D5B557B90837CF5B6BC7EE2F134D274B3A391D2E7';
wwv_flow_api.g_varchar2_table(38) := '0CD56918D16D9D2EAFB7C3F7C14E74F1427E14DF88278E6E5DD43C89BE9D2C8B3FA1704AAFA0DEF07C20BD73EB73740E0F2B8FF5ADC5995174B6AD84854EDAB73D6EB7E5F6C368C1EEF0305CF56398691E4EC1690FBE0BA27C5853EB3C21DE482906A732';
wwv_flow_api.g_varchar2_table(39) := 'D8689AE66CEA69BD60DFEF0BDF7B51EE61E2692CBD9C5D8919FB8D43870C73A771481D51CFAAA5A113F698F5C947534AF5ED31ACEFAD0F9EA2D2DB56132B466FB0336918B1AD4667172B5B1F8559DC6A5BA7CFE04C5AB334D91389464A373B9EA92F4005';
wwv_flow_api.g_varchar2_table(40) := 'B76EF78864B111DDAA0CEF0E63778FE17279C5E05246575774AB61B81FB9C0FCA342834DFDCF6EE5D624F7D54ED73E65B4B7771907623E97970663EB0BE6EEABAE7D6627F7DC3D9968AE8F0E6DDE6AB735A19B1A4F6142835BE5167D566EC421CEB59AAA';
wwv_flow_api.g_varchar2_table(41) := 'FF73DEC2E89B1FBE6D7D9E2B3E32A92F086981E478BD3F65C268F1937E3580115F9F070381A588ACEAC9642CA7E2029CC4F7C82CAA95E0C6883EFC11E1941553226331550B146F051839DAD3C002B1C6C51E5CC0435CDE0EE163C4DD7E978A3427D4300C';
wwv_flow_api.g_varchar2_table(42) := 'BFE132F0DF212B0F26C30FB2FEB1D40E442B89BEBE0EC08C4B14421EE5F3C9DC0B60F5AB140703F19F59012B1966523829DCED3355FBC040B7FB549F8AA8785F2C2E155A7277283490B05E8959DD614B8582AA1BD9266B0A879013432A104E229A76F36D';
wwv_flow_api.g_varchar2_table(43) := 'AADF0D1F56F12882084642ED18322050534562ED092BAE4ED2858C48E28A1B4D120118FEEA3595441C8F513A24913AE863434A272DB8DB5A5B83A2F4FFC1A165FD5BB15A8B8E44AD98B41632D5B0724A7BF58EC1FAECB85A073809DD6C787A126ADF373D';
wwv_flow_api.g_varchar2_table(44) := '24A1BD674DE58A6CF7BE8A5ABBD7F0F5347A82AFF68E780F50C248F5B6FDA8B15873C6EB7DF56FFF56A9B323A8A30FB4F5FEE2475ED4D50F5D43CCC3844D5153BDBED5DFFBFA6BD242B9EB6DC8993372430ACE6E47626B78555BAB7949DB8103D1EDB4F0';
wwv_flow_api.g_varchar2_table(45) := '36B9D87878BA8AEED300A779B97F7C5D1E9FC85C6ADD1EBACA7F36933E6F7FF138D14828EA54BF61A8EDE83C9ACA74072CF5BA7530A43ABA292917C2D865003DFB2EF4D37FA64EBEED1171A3732FC45434D517FAE6E2E2675ABB0EF7F0D9621AFAA9F6BC';
wwv_flow_api.g_varchar2_table(46) := '407116510434539C29163FFE2C772493EE2D8F0CFEC3E0D4F5EF7E71A4FC9CF73C863B89D0C18475A20DE39AB84AED47A8083E180C51E600F1FAA9891E72BF0A8C7042C7E4E0296406C391253534E409B35F1C491D3CA90E9AA158EC840FA30A8C400E45';
wwv_flow_api.g_varchar2_table(47) := 'D4097544F9DE6C2414FD7EBFABA3874B694CC540446B563A84A15414230526341688C33F53254ED155023EC79ECFE44A220D38535C28150AA52B9F5DCE57678B33F95CEEF262EEE31C4D57F237F3B98F3FAEE2927BFF4A55EF7E2D88308F7C89A4EB5C29';
wwv_flow_api.g_varchar2_table(48) := 'C07606C6E2CD85D962FED75F4E6733BE74BA5C3EF37C6F5A3682620418EB5FD29B2BEDD1E071CAEA0061B503038024E2874C89A91353EF29750AF61875F61F492A7F73D1159D11F785F2726106712D14F2B9B98B6B17A1DB579ECC66AB228F23A56081FB';
wwv_flow_api.g_varchar2_table(49) := '390BB211B9480141290676461459006668852283ACA4B362A9502CE50B8BFFED3EA4F6BE4FAD3B7A05D12CE532171E0ECFED1BBF70E1C2BB6363E50B63B72E5C98A8A004E4F2CC05525AE70AAFFA57A0DEB2E2830A08DE1F2651D6D6B473FBE1E0DC68F9';
wwv_flow_api.g_varchar2_table(50) := 'C2F8BBA363CC8AB1D15BB7502A0AC5C5358BEE35121AE0460BF48902CA4C902597D44E376B00CA35A2B883257CCF81339218308329426A72B698DB87370354DD86C1FC89366A8B90698588B937A205BA382C068763904E3937F11D76B65AB521E56136AD';
wwv_flow_api.g_varchar2_table(51) := '188127503F444F920FF9BAB62DA43643F333652E9D50D1101CEC2BD88AD9225CF37CBB9180134C00F7F26BBF611F6E2414355963438BDF836858E239128A8BC58422810C1E71F7ABD1D9D94C1B3D6A4754EB3338F4E128D5DB452212312674C88E22AA0D';
wwv_flow_api.g_varchar2_table(52) := '814E283FC18BDDF15008F700EA8C97F16D9C313C99F0BFA0AC13014E2FA066C5BB3072127908240E9B51358CCC0C592794AA166BBAE0F019E2528FBFF207399BF58A2586D684B648FDA9B076A28256E363A52CCE6771064CA9E5621ED7A048423721657F';
wwv_flow_api.g_varchar2_table(53) := 'A761E9D801F587FB0073E9EEC81673FAC10DAAB42680DA4635FAF0D4FDE03C9A9B5DB69FD611E9D992FD744F3C7042E78AA8706F643299C9747A5DBA3AC4ADBAB4F23DD154745FD4BCDC4F210B507B78C7B0B286C14A16CAC492D5C54D67B245AD1F05B4';
wwv_flow_api.g_varchar2_table(54) := '438D4A630748BB57401FA1FAD9F2FE4CA692C9ECDF9FF897EC2FFF1E7E58DF9A7D3D28EC96B2962CB4E0F5EA6249047229B10B0887F3913ADAFAC9B9A85A020376D93B2CD3BD409CAFDE634114AE9BDA018A16676DD10B1673F13DD561895FB7A385A276';
wwv_flow_api.g_varchar2_table(55) := '6504AF8E7AD4B047C5DDA8F2A694E7F56EB0BAA7DF5763473DDDBA2F9DCDE56EA2A59366CD6EE5F1CF8799D985D9994269A698FFAC5ACA7D345DA9200726C7C7CB2317BE918FD5DB689EA40B502C2E16A7AF676E14A76FDC6057B872A37AE4A3CC74E2A3';
wwv_flow_api.g_varchar2_table(56) := 'CA5CE5C8F5CB957FC922F7B2BFCE662AD3D72BD395CCF54CE5FAE2258ABF66970BB31F47E25600E90E46EA15A2E4E50A34128AEC5889BBF7F897D84124F6952FA411309AF82BF93C7547EA6E8F6EDD35987EEE200128CB9CBBB248A964310378A9459479';
wwv_flow_api.g_varchar2_table(57) := 'A959EAAF2503C5CE56E552B3220A4DBA496A48AD6CB08007E6D17B62DFD8850B6393950AC6339773F92BECE508A841A4C8EE1E7BFAD2CB23E489101320D9257A360B57902FD52B257494908DB05CCC5745D7472E57D96707766F3CBA84DE09E7D253972A';
wwv_flow_api.g_varchar2_table(58) := '954AB6722D738D05905C8DCBA5CECCA54EB9D038B9AAB69BEF83C79FD0754223A1188F1A1D863BD5AD3AF71BE8EE44FC4FEC32FE6A682414356EC74EBFE793768A7B32A1A107E9CD6C583C85457793E3E94C6887E8BA03A4871415E9D680BBA1F8EA4946';
wwv_flow_api.g_varchar2_table(59) := '534223AAA3C3B3A3D387FAD7636C73ABA84B12DA4E05394F3E562BBAEC20CB44D966DA2DED54469B0D4F61426549C2FD29C53B95D7B027B377297329A0E64D15F0C8DC98BD1DFA094423A16852D0E7F3FED01F8C9E563B90D0983291C0A44CCC0D9FC23B';
wwv_flow_api.g_varchar2_table(60) := '8C589FDC5EA1C3A39B0D4F7D424530655E36ED031D7AADC152014BF57D1BB33C565099CA9ADA61A90EEA8F3A68F558C183B0FE967BB6E04059DB3A70F9D683CB14BE3B687243FF7AA229A111E5EF315CDC1561247C866B676897DB6FB8B61AA143AA43EF';
wwv_flow_api.g_varchar2_table(61) := '9F35A36F052329F59E5B1F91934C74C465222A3C809ACA1C54FE843ABA27E656EF59C1FEEE7ED665703494080C4D0DF473AD723DD14251A646CBDFD617A99A9605565F21B8F7BAC1C6D8A8E654469B0D4F6142D10574F93C467C1BBB813CDECFCD8137FA';
wwv_flow_api.g_varchar2_table(62) := '454D73FD4F301A096517D0EB57C93DDCC8C303A8A26A1725F0375D4237399C846E36AC2A0BD838278C5B54A44F20FB5C9E643425145D40A363C2ADBCBB0EA99DDE5D7E651846BB11DA21727F21BDB0FCE462558A6E463809DD6C40426F57BFEBF2B8B776';
wwv_flow_api.g_varchar2_table(63) := 'F5B8B71AE82C793132F576EEEAEA711946DC081AEE76B39D3ABC0CC31554AEA02BE855F69BAB1D1386F1075B95B7EB87E2BAD3503EBF9C094BAC2A20E1E051E00EED6897B430DE7B8D36A32B1DDCB75A50070F174F4DCFE8A98143D1CD0687A29B0DAB50';
wwv_flow_api.g_varchar2_table(64) := 'D4E5317FDF3476A68C43FBB7C794DAF352BBEA36D0CF313C86F1A9CF38C4DE4E7264E450DC8A84AD83CA829B63DC0910A420FA802D7A6E46B4AA84800AE2DED7AF3AAD10ECA26F9B217DF8BA3AEE533FB1FCCA3A1C1DB154D8F2F0D4EA4199CED7DB05C4';
wwv_flow_api.g_varchar2_table(65) := '07D9A01FEFC4B3E5E953835D9EB0A2C201BEE51501C7A6942F4A79F8D755141108C6CC9191C000C20DE15FA9A3D153BED728854BD7D1883F9938A8DE840F08C30AA53C2A048FBB8703E64F119390B2C407E9C7454FD5FA73A63FACB782C491CAB00A0793';
wwv_flow_api.g_varchar2_table(66) := '1ED3AFFE3CE5A3BA061B43083C02CF6251668772FBD1158105BC8B85FD489C425000623160F9CDB72CCABFF7FE25320F36F8476A649752D49F9288AAA312E1A8BFDB23275A84546049F2828943BE279774BEBFCE54D001DEC561E14316B2AFDBD6BA79A4';
wwv_flow_api.g_varchar2_table(67) := 'F3775763CA6C3782073A1131B35D75EE3094617A315CE51AB12CCB508CFA04FCE1DCBEF679482523091DAF7EB51451B1B8E4393285493C863703A6BF4F9D44EECAEE0364470C193FA40E47E1493F1C0EA9941C33A24ED67DE01E120676268284A57E1A4A';
wwv_flow_api.g_varchar2_table(68) := '4506EBC4EC63361F53A130FCA3D53195405909A8DD41F5FA401439B0DBA3C21E78ECE3690992EE7635940C0EA9100832A0A6E0D399CE97E0713878D48C2024B8C13FC9C8B873171C8F3C54D158B7DE98F0EF48A53B165642D1981A22956C0A0C49B4427D';
wwv_flow_api.g_varchar2_table(69) := '7C200251FF49ED4DECA8244E53548A7C002EDDA776FB43C744D2BB1D9F2207F06178870A25FD923D082FEC41A15AC253186F99B73CC43A85C421DF53480539E51853A111F818BE83A2210ED3DAEEB91BC9659074EB807BAFEC38B80DCFBCDC36FFB48CBD';
wwv_flow_api.g_varchar2_table(70) := '9F0E8047836D4FC9C1214F07D656EB3A7872E08C5E361B5A296A6EBD4D84C41BF5B1AB1A7CC8737B67796ED70B6D6757D19763B7E91B5A93CE864683A254E963FEBEDABD53F562D4D26BFE0D9E305671B72B6FAFBB57258DD76C8735BC8A6FDEE9EDFD91';
wwv_flow_api.g_varchar2_table(71) := 'FA5B50A1ED801A5107D4CBAA6D3B1E546F2F2E2DE83DABCE6CEFEDDDA20E6C096A8AC225E9D6B67DFB8F0EA803087D8B3A33A25EC0B767F41B070F02A7D6DD6C7028BAD9E05074B341462FCE0CC326C233F36D2FAF4AD1CE15EA292C15FEC3DA16CBE17E';
wwv_flow_api.g_varchar2_table(72) := 'CE2B06F5F963B4B6029C66FFDC920963F741356CE1FF3027EF790C4A62D78BE22068E1463796070ED4546CCAB2A8BE65CADA11B7FA5FB4AC1D7DFFF781F4F0FEE5F7DF5F7C7FA6502C1666674AA599223574E16981D799852F8AA5129554DD2C15166859';
wwv_flow_api.g_varchar2_table(73) := '9829CE2C14670B05BC2D2E144A859B055E6760539C29CDE2EB427E31B73C477527C3EF97CFCF23CA01D5FF9C8A866476B48E61C406085B4CA669670092D8AED47B5AE58C15526EC4382EEFE00380D47721994B21D56571F2F673CBDA3568C5FAD4A009EF';
wwv_flow_api.g_varchar2_table(74) := '129687D3FF4BBBCC8EAED8A025DF0DEFB07D68CA3F0041C0BA4BAC1092A7EB25D9643F2C73E5662C80CC53781B94B500F81D5AB2FAC39125F8BF0B99CEB87771154478B475CEC8A5AE474051BFD1B327E6FEB4D3EF93680465194475E1C674B7B7E6858A';
wwv_flow_api.g_varchar2_table(75) := '76A8FE254FE230C8F75E982B1BD1432A8C780C72EA9B73D32A410754E134A594FB141D9CE06629FF1FEF193DF3F3CAF5B95F17170BFA0857AA1DABABE10044DD06558D2D803A7440031DD4546D14E0746601B633249FB6038AC5E2C20C95D7D14A7E3C1A';
wwv_flow_api.g_varchar2_table(76) := '76767601E521BF58ADE6173F2EE42E2F16507C16F3A5E2C7D5C5E29552AE54CDCF2CFFBC325DB9F6DD7795EB89CC74A672A4426D11BC5CCF547C17D3A3E7D590BD422448A29CAA90FAEB5362C7F36203EAB593F117916A9E73DEAFCCC850D2DC15D24B4B';
wwv_flow_api.g_varchar2_table(77) := '32315F477BF276993C59C8D074DD1D945D1A362CBC39A106FA6575CB8DEC3FA93AFF351AE1D2C2524C1D411492417F0014A5A45133F4D893EB2E2DB0973CEE8AFBDD10712E5DA992463AA345374A019459FCA7E5ECA54A66EA627AECC2E8BBE5F1F1F172';
wwv_flow_api.g_varchar2_table(78) := '796CB43C5E1E1D2D8F95C72E94CBE5F1315C781F1F1D83E1DD0BE50B634B63A3F83B5EE6FBCF474FFF021F8D97C7E0309DBE98FD6E2E5795536A17345DE55048A2A1CEA501BCB7F5B43062008B8A36C20225AC7013960B60FEC26275B19ABB72E54A3587';
wwv_flow_api.g_varchar2_table(79) := '12922F1572B9EAF2F2F2B54A85CA1E2BD4F758D1A06A1B40CE789C4CA3541C59BDB11B52EA157FB372F91AD6B86A018AAECF4CFD57E94C4E331C73B750AD7E989D9A4C8368E71FF19CE4B97D63E5F4C5A9ECA50CD54E653A797E66866A5B2E653AB5F6A0';
wwv_flow_api.g_varchar2_table(80) := 'EC8DE55CBE74A5CA0347F55F0E04BB820B1FA8D886354189E71B4B05D0F8936AE00EB05F14E554641A4A7317D77CD8F27D607DFABA5FA53F043591321E223DF6D593B652804231363E7601BFDF5C9C62296051B80696BC742DD359C92EA34054F3280454';
wwv_flow_api.g_varchar2_table(81) := '4724E5A07A9905025C4C5B291464F899D9B94770C0F47A5074DFE422EBB4D272E6C2574FED22C1D71996E9ECC3E7D2D528AA97E5FB53720EFCB0184268CD87D492F926ADB8601F449F150D2B5B6515471B1BFAC18E01B514F50FB0DD4F58219FEA967ABF';
wwv_flow_api.g_varchar2_table(82) := 'D10B08DABD89F9A9CB28A28BD934BA9C3A24ADE1F2A0763A249F51AC24ACC2D13F67E37DF5A004C10E9919715B969B96BAA3C6DE59400DBDC6BE9F58088231DD51D5711F0C86E06E2F3AAC07A3316EA6641008794075FF0A3DD8387A1BA1843A69524825';
wwv_flow_api.g_varchar2_table(83) := 'EAA71042F7CB2A26B189BF143623081BAE2D3564BEE989F7C3ED004538FAE1E0753E50ED25BF0B9E4C79C2CA17DEAB7CAA8F9D98B01ADC1B48E0C9F49B9183A163DD4B7B87D00B0A890FC3EAE5EF50FF162779504A38A20F28A9775668089A212DE0C3E3';
wwv_flow_api.g_varchar2_table(84) := '4734058E4A1C6040067FF2664A3135018903605991904AACAEE9517B1ED3BEF7499508AB25C4CD92A366D16BEE57C9FFC03C148A529C060E86ADE051240D2123C0845685695992F3F6F12C12B74994CD52566B45833592FE13790E31671A14C518C2E2D1';
wwv_flow_api.g_varchar2_table(85) := '2A401FFAEB0802E630B207B7254B8E8207300CC24861480D82D0DA42AED4A40A688ABE8EC80D620001EF28DFB38B4120DEC88D303D7E4B25FA435D962477F02FFDA615E290AA0F23111624F8E86376F3F419A41E63AEB8E561F714B9316805C218CE2011';
wwv_flow_api.g_varchar2_table(86) := 'F86E88325356F45034C0328142DAEDB1C5A610634FC2C20D4C11841B3F7C60D4AE5E0645E7CEB55074B747B9A5DFCCEFA82611B029CA0CEEE7281140061F534914470C886271161F6645E49FA9D1F1B1D7BAFB96D1A75D3E679B9E6AA06CCF14266DC343';
wwv_flow_api.g_varchar2_table(87) := 'C363A7E8BB39F687B2E8C073A4FF5463FC0A485AB10D0F0D8F9DA2E7A6F498855D7D76F64B20F0622E9FCBE7ABCB373080D37A6C395EDBF4041FAB22076A2A9F1F1A566F474D7F488DA02FD0E5E1296681011542EF62096D7D8243D701F425FCD275D0F3';
wwv_flow_api.g_varchar2_table(88) := '2629340311B80AD105E570D1C8F95E0B47D1C0D007203060EE50A15424A6963CF327F39D85C59A267676E3F5F80C5752B9203344B42E14A9E1BF3443DDB43213582CCC143E2E1672CBD76F70A07E6326333731F1CBE7C7C75100A6CEBFC04886D03C220E';
wwv_flow_api.g_varchar2_table(89) := '2796184FA4228C98310E832A186A5727F18A51EED83791C97EF9EB1BB9E94476793A939BBE363DDC971EFC8FF3716B9765058256075A2AF9CE4E7D40447D7F1061CB18A017FD6C51B75A917695FA019A71347268D412E8B4BD6D86D08EB201FC73CBB364';
wwv_flow_api.g_varchar2_table(90) := '46A26F46CCD812DB557661D0FA01DDE6AE78E2E0D7C3D31CD596D449B6F27F69ED7AD1EA30D1C2F659EA136B072930155143494F12B9C6365E37B4F7C6BD7B4662A0D5904A0565761329A2A075C08D9E2D611E82033336805485450E9714A5906C4AFA3A';
wwv_flow_api.g_varchar2_table(91) := 'BA658F6BA5E64BF539AFF05763DD23174647D2135399EF2ABFCE605C5FFD1823388CDF41DF19D294B348E0E642C13E8E40E6006F839E32048AC552A930C3F95E9E6250B8F2318684B942E97235979BEB9CBEA56798D2691480B22F476FEB7F9C0EA60F9C';
wwv_flow_api.g_varchar2_table(92) := '034261E26CF2ECC2020A9A9422C4A7849CC713A793D16270A688FA7165EA18919C592895F015230D838EE61733B3288EF09BD397A5859BC5023C28C1DFD9E2CCEC1754BEFB45A1C4B9ABEBDF7C4AE95F76D5D89F4A79A2A776235BC5880E938DEF4BD1FB';
wwv_flow_api.g_varchar2_table(93) := '4150BAA68F00E73EE01C5EB97CE1C238C02B4F1C284F4C66AE61A48EFF2A47EA3C75010494217B6D568628CE707E97D333B53FFB2D32BE5E0604FC50C3FEDCBEC9F1156292AFF92F6FF46B5186AD1F6A1FF05EA83D6B5BFC1A4AA16BDFD43E84DB5C767C';
wwv_flow_api.g_varchar2_table(94) := '8D4DCB7DE4F2636F471F11CEED2B8F8F81ECA4FC855B20FC5486737B9CD0B9319743250F7ED794D705804771308B61E20B64FB170B70223FE6BD3CE1BE60DB68E7C56A267D6B8CE58B250D4FE363651EF5411B5A22F80B17CAE55BFA76811142953086C2';
wwv_flow_api.g_varchar2_table(95) := 'C85249278C207FE5B1D147A4F37EB350D4410D77A4E8EF75246B4A68092E97DA1BB6077771B49E92C540071B0EAB5054AF8F76757CD0E1F24CEC303A5D9C39EBF4EB2D4C402A62BE110CD98B810E361A56A1E8AAB2B98FAA03E4E061C36947371B1C8A6E';
wwv_flow_api.g_varchar2_table(96) := '363814DD6C58AD67E4624B6A187FD4E136BCEEF6D4A7DD3B948A1B7F60186EE3D36D86816E93BBDD340C3F7B4AC12067C59AD6261DAC3356A1E87311926A5BC7EE9D9D7E9FC7F7C97ED199D7B5D3E771F9F7757DBAA747A968FB75BF4B28CAF9AB215B72';
wwv_flow_api.g_varchar2_table(97) := 'CDC146C06A3C6ADF5745977D529A838D0AA71DDD6C7028BAD970478AD67649A456A966DD568FDA46F1FF0045A4F84F75440153646F54D0EAA083A50E58CBAA9083C78955DB517B978432AE1A6ACF21E5323C5EB7B7D34F359D7A3237E937DF36FD7ACB83';
wwv_flow_api.g_varchar2_table(98) := 'FB509F5E0945F7883B218256B0BFCB1A52C110C5F81D3C6EAC42D17BEFD05FCB94A0336DB84E70DAD1CD0687A29B0D0E45371B56EB19C92C60A761A02714491946246EC4D0BF353EF5457C11C3687FC56B1CA7C673C3308D9DAEBD3E63477C3B7B4CC99D';
wwv_flow_api.g_varchar2_table(99) := 'B5A9418A3A0D5307635C295C5EC1CB7E0AB1F7A7444765FF31A5E241381081295CB9A7A15F9D18A010DD80B252FE84884EB9FDF89E2A3C6525B63FAE9241BF8A2DA97E0A5289943EBEED578925DC03F4183E7430C4A71AAB5054CF0276FED0F752FBB60E';
wwv_flow_api.g_varchar2_table(100) := '57C405E3FF824514BD5D97C7F018C98E3D3D5C00578632DBBDCA1B6DDFD673F587A068876F973D3538BC5751B3272EDC1FCB4D0527D00F0E86A231663C651DBB22740027E81253168E4E0754BC0DEF0FC63D204A3CC26DC3E8405309A809FAC1C151F6AD';
wwv_flow_api.g_varchar2_table(101) := '13EC41F7A990DB1F66EF0BD643085BAB331D50016A51D53B289E52ACC6A372B57704771AA0958327084E3BBAD9E05074B3E17E28CA7552C0B402DCDB67A23362ED507D16FA358DD3AA1CAC37566D47F52C60D230767A95B1AD71228F3DD51B0F500F7BC0';
wwv_flow_api.g_varchar2_table(102) := '8C0C591EEE0E8EE88EA7830D815528DA3A0BA847230E9E1838EDE8668343D1CD8667DA7ED5D676D63638D8045845E7983D0BE88AF1CC1E65186ABF710837F6675D4664FF76B6ACA6D1815751AF7128BE9D738286CF08498BCBFDC00ED613AB50D49E05F4';
wwv_flow_api.g_varchar2_table(103) := 'BB7966CFEE8E6D3DA0DCD51F76FE90228026F5047236C96C7781A286D9BEADA773870F5FE86D31B21FD8C17A62351EB5EF0E9E483C639D6D335A29EAE089C633A4E616FDACB17BAB72050DA31D4D6747E7F667D18E7261CD670495BABAC387565496D960';
wwv_flow_api.g_varchar2_table(104) := 'F983ADEEAD7060BFE9F4EF367ADCB29C26AE5D685A7B5CC636D111DBAC53D4C1A305462F6D6DAB5054B9F6C43EE8E8F48372DC39BA1BE435B6EED9E1F3B8FE83E1D7E73BBB4951CE2CC91B52DA700545E04C5CF744F19D3D3DE850F4F141C6A32D14953E';
wwv_flow_api.g_varchar2_table(105) := '0E7AB9DB3AAE82A25D3D3ED288BD24A5F6ECB81E717994B16DAB6A33D04FDA0D8AF2CC43BEE9EA3082077CBB5CBF438F495CBB22E832BBFE5078F4295F847EAC5885A2848C44920FB023A259D1F2FDEA4F76F03070678ABA8DD609DEB56185EA6C078F19';
wwv_flow_api.g_varchar2_table(106) := '77A0A88327160E45371B1C8A6E363814DD6C7028BAD9B092A2BBB7AAE79BB721F964245343B7EECBF6D91A3981BE79EA109583828001A5D58BBB2DEDB05FE46845B2F636D81E685DE60065726D9D95E243D4F6819ACA572AC3EA93B729ADF65C1D548C83';
wwv_flow_api.g_varchar2_table(107) := 'A8B88C2554DF6E5A1F843F01651D8CF6AB1045B5812E7DA3DF70C9D0446F386C0710D1234AE2AA6271ABDFCD7FFBF0A3007EE23CEE51B12E7F48B50F5A56DC1F8E886A55015D223CDB046845E380F8289F1296A515A2B640B4A82FE9A8E96CECB318779E';
wwv_flow_api.g_varchar2_table(108) := '5C8527B19613AF00248E673530E4619D660D3BBCC183AB5134B955B93C2E99E9F392985E5F2468183BA95563BBF18261ECE128B5FDA77BB4EAF808B33F19E4094D4B483722ACA3666BDB408E214D0C7A84740930465AC96834E237970E53E5BCCF0A5121';
wwv_flow_api.g_varchar2_table(109) := '3D129392FDA676A2E983D6DD1AF0E3B9DF3C948A1D53A1A8DE93AA699CF40C51143B8184EC0E52272E421B78E90D3332A5E25799C3297F22FA6788D294383FEEA34EDCF020680497966A47FC10F29F236ABE97E372FA177D1032CB990482A3769258DC62';
wwv_flow_api.g_varchar2_table(110) := '2C1CC7D44935F517FFB6A3415115538843F75E9EAA45E351FC90BB712B32A40E8BB67D71CBAC78EBB01AB062A6150B0F26228883948301D99BC96D07BA9C9BFE6E124EEF42A09378302085028963BE1FD3F98E34D307C4141C836201EE486A3DF5B7F3A8';
wwv_flow_api.g_varchar2_table(111) := '2B68F4EC318C1D5E657C9A0235AFC63EE87019C6B69E377A64294DF10C291EEFC0B452A21D1EC68425B83A1A67248EBD4D05FC7CC93B17D9CC08D5C60ED68A5558B59B9178D4EF7E96470050EE3E86D7A4D66F631279DB0720707CA01BF18D077888404A';
wwv_flow_api.g_varchar2_table(112) := '73E57C94052B19148A92BEBB83664422F49344D2B40EA9019E0276D0EC193CE70F852486E086A4E7986A0F83BE66240A166CDF1EA6C72175A80F8EC37B25AECCDAA32A88DCB745F313D17E0AEA338941E45F08B138A9C2718F5F348E68E0F301D57D1855';
wwv_flow_api.g_varchar2_table(113) := '93D41DFDCA87D2412A0D917591F3B26C0C42F33801C476402D7527DB4EB11A4092B9A940286A9FA0C523CAC0F3EE983AD8CDCC8C5A6F71632E9E7E924831DF8FA18420AEA92053211F702F76E4053F98E719D5B637D8DA8ECA4AA7EB0FB7EAB39E65D6AF';
wwv_flow_api.g_varchar2_table(114) := 'E36A87EB77DF6CEBD9F3C34EFF556625EAAB6424ECE9C42392CE6D10317522FAB69CA516F6040F223CD19F8262DEA0E8513360FA032A2C85A25D0D3175A1B01F898D8332F4C1141EF5A3C81D84BFF809BB06CC0116D51343EA040F89D0EC299534793400';
wwv_flow_api.g_varchar2_table(115) := 'FF6095F4444F2DF1F48576B5FB0791047C4386F7C73DE1A83F1DD213CB29C4A29DDB714E72A70D821A88BC9384C72813032886681A9016614CC41DACFAB26E1A127AEB85E651EED62145195FF29DE629A61B147D31A609838F7DA412BC19DA8DD4C0B1F0';
wwv_flow_api.g_varchar2_table(116) := 'E8142B31A16842BDD79D7A61077C4C21EF4ECA661170F31488CEECD15B3D504D84F0C40AF544F494EC2539A692AF44C241D4558C2BBE658611432FC4C21194ED21D4BA6D6D77EC19355ABFDD779E10D48EF495D46B855DCE9B21515B158DF06C30BFEF05';
wwv_flow_api.g_varchar2_table(117) := '7CD4580DAC25F076E88C0690B3600356697798A3BC930F806E0C5B23294AC1093B0E77385E8AD5E22A401C9A18BD19B6FB0738E008147DF9E53B51B406F3812604BF3F56CF860D858D77A6D433EAE5E0DE7B51D4C1138467F606DB1C8A6E26DCB51D75F0';
wwv_flow_api.g_varchar2_table(118) := '04E21935BFD7E1D1CD846782F30E8F6E2AB0AF7BDB78D4C1130D52D4E1D1CD0467ED65B3C1A1E866432B455DB579741BC9D7DC325B64EFD7FF9E684C018DE0B73DBA7DB5A2B45DDF9C42F6A0A85374FB76E4E5718F7AD1DB1EF41A9DDBBDDCA196DCA97C';
wwv_flow_api.g_varchar2_table(119) := '7E6FAFDB6BA4BCB74F408EA8B367D501973AFB2B7540A9335ED5EB0539CE440FFC080FBDAFDAAE6A38A30E9C5523DB83080BE4E45BB8D574EB3D7B60FB1975A6971E1C402C7AF17FC6A1E883A2C1A3BD515034A85CAAD3DF8BDFF1FFEC526AF77F55BEC8';
wwv_flow_api.g_varchar2_table(120) := '1E23E6F3ABE3BD74D48CB3DBCFA21C8C9C1979E70CE8F3023C39701C54A26FEFB078DC863374BD65E4CC16D21FE6ED4A0F9B7A7B7B0FA8036D2FA87754F4EC16B57DCBF6EDBF7278F4C1D1A028B251B982A0E0F12029EA8A1C074577467B933B3B9FEDF4';
wwv_flow_api.g_varchar2_table(121) := 'FB2821DF8AED6DA011C8B865843B8AB7FCE847EA4767A8C4E1855507B867A2E051DCDACEB4919A23751EA517F8DB82BFB3C133F015EFCFB27C3878203CEC9E912347BFDE78D81475B0DE7028BAD9E05074B3C1A1E86683B33EBAD9E05074B3E199F920E7';
wwv_flow_api.g_varchar2_table(122) := '713616E6CF8F8EA7D3139399CE4C259BF9FEA84C4EA4BFF9DAF67CB3E399E0DEF955D747574C284C0554FF73F6F38B9687F2A24B71D1E609EB294B75591D412B209B2412BB5EB4022F5A967FC9DA45D97AF741354C07A1CFF116FE58563F1C28BCB2AC40';
wwv_flow_api.g_varchar2_table(123) := 'D08AD9C73A0D5B874DEBFF2C7F397DE3FDE9CBA56269716666B638333B3B33539C29164AF8CD144AC562A13033BB30B35028CECEC2305B5C28CE940AA59BC58542A15480C502EC71A5337CF345092E0B856A752E0BC24EFDE28C90D652E13FDC51DF1761';
wwv_flow_api.g_varchar2_table(124) := 'C3B42C9102D55B0EB45830E5C9931ED5F592D63EC0C4C582019145A60F00523F6845289B3D4851D6A0651DECB22CB3A32B366CC5DC563FD21C091EE4BE922E4BBE330F2BDB8746FE01A9973A683DA815A4C6FBD57B22396AC644DE7478492D2176FA547C';
wwv_flow_api.g_varchar2_table(125) := '9A2D0B21790E06FBE3B2B741E23EA8C291A195B5EE2B5E8331F59AC6CEB8B153798D43DD22ACFB13A50203DC054032253DDC5130D4E5414C69ADE44400396A201EECFA5944A48AA7D451F7298AC7F24C01D30F07B0E681A58ADA5C8FF2C800E58EF8D4A0';
wwv_flow_api.g_varchar2_table(126) := '195B9AFFBBD1F4C5CCF5EFF62F570BA0DF2C50046DE4618157D28FFFFA95FDA66E633F8801175E5114EAAF67670BA473B194CF5DAE16F7673217D3D77EF3C67783E9CF87877FF9DDF069D77383E5C1C1F1F448FABBE13D95F17DE7B803C0DA3170D8725B';
wwv_flow_api.g_varchar2_table(127) := '1137322B1589A9F02E156EA3E86F30D4CE4D1F613362A7FE18523684B46B8171A4724A2547463A906A0A30C7832AFEA7DC57824C939590A3F04424B28752C1A3EA73FA10EC570822486B2D5AEC42AE2D05FF2F6B97E90F31E4936114BE84EA8A44FD2971';
wwv_flow_api.g_varchar2_table(128) := '81D268FAD59BF101647912A5C01D435EFA870EFD78E58AF7EE9D514ECA7BF7538D8DCBE38D6A6E15217D94438FEC86E08E0B31AB797D4BA86E4F3FA5F955D21FE0CE1514B080EA4B21235437CB7BF4101C88F43528CAD297484690DE936AE0EFBE9B786B';
wwv_flow_api.g_varchar2_table(129) := 'BA3257BD0CAE2B90F3C077428C02284BEAD24EC803E2F2021441536146FE81BC057C292FE8A0086A16674BF28C17B84A11A197B8318C62E14A3577A55AAAE68B8BD5F7DFBF5C2A95F2EF57AB8BB9FCC7B99BD5EA47CBFBB3373EAA7CF4D197FF94FDEE46';
wwv_flow_api.g_varchar2_table(130) := '65EE5AB692CD56805F672BD353174FEF3BC72D023AE10477190DA9708267620845C32A69EE0AB1A0A7FA49D101157BED645C6FEB693D7B2C15BC7D05244E7ED27B83547B43741C21587E958C986F78C40E5988CCF4077CB209C02245BBD5B1CE7F8DA21D';
wwv_flow_api.g_varchar2_table(131) := 'BD9DA2ED5D3B71F36A45710A149DA8F12861464EB8DF664564CBCFA3940220AF9CF1700214FD29DCD008E6EC07F9F44E1D158D2550389998806C026094869479E0E2E2F267F952F10B4D1DFC830220102BDBC222B23C9F2BE467AAF99B8B97AB97F3F92B';
wwv_flow_api.g_varchar2_table(132) := 'A041AE5A28E1B95AC82DE666173FAB7EBC58FDA89AAF56F31F57732550A5582D952E97F81E9FE716F3B92BA875EDC2502C08C3CBF3ED802B89029E8A378B5FA09E07E55179A308100B78BC890ABC7439979BCBEEAFDCA8A0819E4EA7CBE5F2F1F4787A29';
wwv_flow_api.g_varchar2_table(133) := '7DF5974B6368FECBDE6FCE75B3B292AA4B0DCB9636D5CE7D25F65AA5A6A8BD51EEAFB56563EF01AC51EB1F97E7D735453F17FA9285921115DA2D7B1284A2A8EB3445C34150B45D0DF95414E3D1DBF6BD7C407A36DAD1BAD0B8C46F256C1E7D20CC8F4EE6';
wwv_flow_api.g_varchar2_table(134) := '164BA4A1909199BD80FCAB5EAECEDD40AF68327DBA3C3E3E5E2E8FE23A7EA10C43F95679BC3C863FDCCAE55B7882DD78F9025E8F977B79EB863DDEF7969F3FCD277E561EBF98B9B19CCB2D925D49210486E084BFF928F7BA49684A9AEB07401EEC42C0FA';
wwv_flow_api.g_varchar2_table(135) := '437B83461BD7D26235B7585DCCE74BD52BE07A16A16AF53BB07306BF1B60EC6C16BD3BFE81CB7537ED4665F2E2E9F2372F36B15F33608D76F59E0A33EF98EFCFA86070FEB65A9757E38E9B531E16E6F74D64AB259D3FC082D03297CBDD989A287F70CE76';
wwv_flow_api.g_varchar2_table(136) := 'F4C0B87DF7C2DEF3A363E98BE83DCF2D2FE7410E4D5AB020EF30901779677B8B7FB1933FFBFF0E608BDD0092802B7E0B33E235D234BB50C2534942A4C748F00C4229E4E62E8D3F9ADE3728BA2EE3D1F9D1A91C3BA64C271298CF2DDFB876113C398636EA';
wwv_flow_api.g_varchar2_table(137) := 'D18223A38B994CE7258E8CC044973846C2330CB0C25F265BCD55C16D5772F8D77FA8FC51AFC358CD2F92E836C3AEA035E80BD6973E59EB5FA9512720C12C07206A66F4FB547077C23ACD027E3599CDA3929DC15F75397B6D72A2FCC829791F383F7AA13C';
wwv_flow_api.g_varchar2_table(138) := '3E861FEAF2F10B63B72EE036060B54EFE5F46F3A2B73CB68CF7368E1AB288C00995AC64BC2DD9ACA4276A17C8DFCBCD79E05A51B1FD8013E4CAC0B45E7CB993CD38D1CF8A7CAC4371B88966BC3F95136D5E3172EA427D03082B933972EE1016C9F01CB57';
wwv_flow_api.g_varchar2_table(139) := 'E672EC4883AD7105575F410B8E1BCA0046C5686FF3579076217E7ED2F6F061623D283A3F912D6104B100F6CCA49F3872DE1368B2416CF4D8C678BB307E0B0CCE7B19D731402AFD6C955321CB8F20F5EB40D1F95FCEA190160BD5CAD33335B7126590B490';
wwv_flow_api.g_varchar2_table(140) := '4BDBA6878855288A01CE49993E0886F46C57D7B36135FC57B1903A21FA1FB8453D7E9C0322196B72803900072F46E2911FECE18C48D48FFF2E76964DCFF0DE131F73FB33B7EB0343F15DF3E9394E19CC14C7BFA6171CE1AAEED4B37C0A5023854AFD34E4';
wwv_flow_api.g_varchar2_table(141) := '8E4C7942010CDCF851B44782E8E6386E8083280EBFF5EC0BC7C46144C847EB7A101CBDD97187C7BBE112EE6A83411B484363F8AE93D1C0CA7145348671B80A2DCDFB4C3F5CEB0FB8E11E689E6B100C8895A815204E9C84FB93EA9028C948600CEEA70E81';
wwv_flow_api.g_varchar2_table(142) := 'E0247321D354A44F7CACE6F5B0F4760A740B05BA7EE60705381B890C76FF7E3C147D4362A2A72DF04DCA1F068156A128D57404D590E7040DA6A4AEFB65CE5C0563C332C181A8FE24AEAE22B03A45BBA327918A50272EA0A86521CCFAFC485D4C37F603A6';
wwv_flow_api.g_varchar2_table(143) := '69DF74019DFBDCC5AFE0AD58A7C44177440FBC254D6604AF022A949041B0159120A84362400D5B721C6983A270F926E7396B19082C91C04AB9652E36195AE2E07C77504D45129C7E6410F8C81D510739D5114845C220987F983BFA7D8AB3292135B4570A';
wwv_flow_api.g_varchar2_table(144) := 'D76115A23A90617C1050B1BE766505A7DC3B199D21CF496A9760223974F4A97ED37F4C05A2FE10F2DB14FD1A81642C8CACE001F603F1B7929EFE18431E5253D19D1164EB3E7689973F4821DEC8C9613DDC9278335B5F8615E74B913D92B0302860FA556C';
wwv_flow_api.g_varchar2_table(145) := 'F87518E0ABFB95BF782D8CD434286A1D1C52D153AB52F49FE56AE78A86647D0809647E834783A2A2E3A8AD5446180854889EB22C3256F4599622290A9A0B6DB8A888637E6A71B654584EB3708AB7CC6B60AA79502DC53EA02CCE41D108EE4310A08BF028';
wwv_flow_api.g_varchar2_table(146) := '49AF151B688A06517D344516298E348DA6539E297E09860AC33D67D401440E5F8454EC3D1508738636C8724285180CB9EE1D328B14650CA2A790FA046A805892FA3B38C94AEE1FF4205BF19D8A45110BA53E7D99E9D015C2EE60FC054DD14470C86DABE7';
wwv_flow_api.g_varchar2_table(147) := '1852BF850F7C9A43DF28779A4F0DE87075BEE8906DD00A14D5144006BB8354ABD4DFC2A3DD70B12A45F10E18D2BE6B1EC57720A2BF5B678765FDA947B5932B74D0612BD21D5454EAE44772348FEA65062A59E25D7F4745276A740E65339796911808D2ED';
wwv_flow_api.g_varchar2_table(148) := '47D5CCE7293DF115B47994A1C4E2F2354A3C8308738D8627EFC582D6619BA24B567F0A6F6329AE73D022AE39D5D60A24714F7AC2C124D8DC0AC10713F142104822CA1C82504B870351AB9333B3486ED2F2513B14424662D4107951751F0EA8BE793A40EA';
wwv_flow_api.g_varchar2_table(149) := '4DAD7A09CC3C64F993F81CFFACD1F11DE204FF132034A2C042DA0F6BC9EC3EAB3F8AD8F51DA6DD129799FA256AD3ECF24ED678546BE60007A242880BC3DA144D4A92C832C8CC9AF22E0B05F4F5985AD271E04CB02CC120D2ABE833827BFB61355852A134';
wwv_flow_api.g_varchar2_table(150) := 'B06469DAAD023895B208474D9FFC6611C3968AF4F1E2FD2ACA8FEF16DEA0BDC2B512614BAF7A3523B8C2A619DD775064F2209066AE09A2F7E7369087EF82892BA8762B2D7DC3444CC551EDDF8B0276B6D6015AEB2F9857AB50F4D1626AB6B850B8681B9E';
wwv_flow_api.g_varchar2_table(151) := '6AECFB1065BBFA8D6D7A6878EC14CDCC168B8B13B6E1A9C67C76A158CC956DD343C37A5074F6FFCD6527D3A34FEF58D406B3E2E18F481F3B452F727661A15058CCCD65B32245343991E66A59F9A99B6EE82C8047C76DC343C363A768F943CEE8125C61E4';
wwv_flow_api.g_varchar2_table(152) := '2213A8CBA5C55C752EDB5927F0D340DFCC4271B6FA3828EAB628A7043424A4A6D00F5FEA400F9966137D4C3380E1CC618E2B0051461B3203C19885FEF320BB5EEE7E1532AD40AB8C9588427DFD79AE24CB8AB2B024A01098582C500CAC50FC79A93A93AF';
wwv_flow_api.g_varchar2_table(153) := '16A733996CB698CDED072F7F94F928F32F99EC7462D277FAEF6CA5ADE80563986AC761CA92485A0731CAEA4F6939AF96542CC57799B10087A37A04605BDB68745DED91A81A68C4BD1B238A54876A97117F5C99BBEC9EA546D8DAC1B10E6E7A14CA5EAF1E';
wwv_flow_api.g_varchar2_table(154) := 'B4F5CD9B7FE6373168F2DB13562D9262A0288A73A92C23CC1AEACF8DB823D790F55DCDB1BD2B56A128066B27C36ABF15A22093D9A1BA3983B3B417E3EE5094219A916464FF10C7F9321C175194011537BB31120BA8E89FECC060D1FD672A74645E892814';
wwv_flow_api.g_varchar2_table(155) := '860D6684B3112730C0EF575D6F5C9F3B72130C3A3B430292A4206809899307B9F0BEF005498C673A019D8B2510BCB858BA5CFD79E552269BA954AE4F1EBFF5FCD55F0A4B7BBFC6A079A97BAF4C5625233296402A4072C60183BEA15490E36F46B9FBDCF8';
wwv_flow_api.g_varchar2_table(156) := '642673FD7AE5FA74E6E3E9EB95E944757A7A4F65F02C0A04466394B673A36834528F1C39EE53ED032A658544096D3C685AB1AEC44150AABD2F1AC290347A0ADF58A104888FB041FAF0300AF5804A9C507DC110468FF02340493B2030A0FED2FACF5DC397';
wwv_flow_api.g_varchar2_table(157) := '91B0FC3BA6BFCBDA154F88B824BE81C7E6D261C61DC354CAA821D758CC605E1B565214A9205AE78C30420E86D48FFD24D03994C88019E9B7275824FEAFABE40F223152348CF13728EA0F85A810B78EDD4D1252F35FBD9B9ECCE42FE7F2D5FCC757B8C658';
wwv_flow_api.g_varchar2_table(158) := 'A2C026453685A402212DA96B9B485C3E087B970A5FC0945F2C2DDECC97F2D54554D93337FEFBF4FE2F41A8CAF56C36339916DCFAF2F448BAB502473D113E7DE30A3C985D6065514069A18051E1FDE9238B37B259D40CD3D3FB3FAA4C732D1C3E018B896C';
wwv_flow_api.g_varchar2_table(159) := '65FF5C66FA7AF6BBE9E9FF5E59BE56F96EFF47D9E27795B9ECB5EBD767E6AE577E9D98439FE0BB1B99CA7416E1572A73FBAB954A257F2353BD5E797FEEFA5CE7A5B9B9FDFBB9A4AEE5531295EC6779D64959900EB50A6775C8F8EDC8F5256A6C6D45F46D';
wwv_flow_api.g_varchar2_table(160) := '113E5A1356E751A03667245263DD9CA109A963A2A61874744754A8366526C2634BAACF8C7492A2AFE339DE264A6D959E78D73304B74B48CDFFCFD1F2F0F885E5B15BBF9944959AC866E772A51CDA53CA8970ED182C6B8B79A12626554BB30B4558B35E16';
wwv_flow_api.g_varchar2_table(161) := '4AA3EF5F0451C0E8253A2E91EA60E5D9123E2E2CCE966455BAB4B898CBCDCDBDA5293C5E9EF8653AFDEB1BBA29AF2D3F1744AA80724EB8A368DD845F28620CBEB0B0404152929E4BD8C52F38193B33FB45A158924F8A33054667760645A324DD8212AA9B';
wwv_flow_api.g_varchar2_table(162) := '12BE2FA28ED1963AB65F303D7041293678C4A4A118FDFCE2D4EBCC26C97370F23194B8F76A146D54B4DF8F476D8AAE804CBBDD0F6C519FA8E6F91500A1C92FB609383FCA15C43408CC4EF0DC72359797F5625086FFE068D29BB906207F98B5C2B6F267A3';
wwv_flow_api.g_varchar2_table(163) := 'F6803B6D25DF5944E085C89714F279F821EFF41FFDA01429729914E61D04E2D74270A91AB4D1F6DAF69900A1ED27B1ACBDA06FDA5ADB4A646D48D0BA14E07F71726DFD3FB46B436BDD6BBD0A45EF13F74DE9B5E1FC37B746CBE5F285F1D1F1D1D1510A0C';
wwv_flow_api.g_varchar2_table(164) := '50E42FFD9B4C76EE9FAE8097738B14F911892FE4BA643CB2898D7373066A80CF66604B02C091F088CE7D4DD0BA41C8C91B6CF8190DB6EFF8B7DFD0352B0BF94A7FAE0904B6E40343C14F33218947778812989F36B84821423D52CA4DEEB3537B77DC5716';
wwv_flow_api.g_varchar2_table(165) := '7F7F8A3E769C1FA53CC0D82D90778ACDDC25B44E3796295849C9AE9C96FF2141F43F991A645E015DF302F587D54132E87F5C0A8BBABED09507FE6C7932091C0F348B484AA37E61DD90AF5EBE421163A96FD8B4209AB91B93638F6284F6045274559CFF66';
wwv_flow_api.g_varchar2_table(166) := '6C6CFCDD0B65FECA6394FBD0B854A9649749600AF690D1EC075ED139AA71382B7336DEF2438B294F6C39B52D1F69CA2D5F1C1BBBC080C6CAEFA28D78771CCF655C4645B26CAC8C0AE5C2D8184C63E55B63E39416866BFC2ED0E9D828AEFCBD8B22F91024';
wwv_flow_api.g_varchar2_table(167) := '5857C766A1E85DB0F7AB311098A25D19CE60F047E3252D155FB986FE6C27EE7C054760780A7C5EFA4798FF11B637D03BAD64AEC1BE333335B1EF7639E08D87A780A24F191C8A6E36DC91A22E39EDA50E1846F5A1DCA9838A5B3E65B3A4838D879514D5FB';
wwv_flow_api.g_varchar2_table(168) := '47B719ED2EE53376F8222E0F49EB5586D1E392198513CAA706E314DA70B001B192A2F6FE5143B9DC5B95B1EDD957FF936C3EECF46FEBD1DB344EA881FEEEA9843D61E4608361158AEAFDA306D8D21B6D8FF67A0CCEDF79AFFEB0B3CEA353EAA819B95DD2';
wwv_flow_api.g_varchar2_table(169) := 'C6C1C6C04A8ADAFB47573B30EA516CA572F090B192A2A93BCCC33A7832B092A20E9E6C3814DD6C7028BAD9E05074B3C1A1E866C31D297ADB2C20D0A44AC98781A9FDDA522AB1561118078F012B29BAFA2CA061B88C677D86C7304858D81ADE6D32700D2B';
wwv_flow_api.g_varchar2_table(170) := '3362EF0873B011B092A2ABCE02BA0DBFBB3D69181D542CA7D4F59F7D5AE3D16E95DCB3DAC62C07EB845528BAEA2CA032A2EDA657ED3282060C3E8FD7ACF3A88AC93E79071B032B297A9759C0BD243411744E01D9B05849D1BBCF026A8A3AD8B858495107';
wwv_flow_api.g_varchar2_table(171) := '4F361C8A6E363814DD6C7028BAD9E05074B3E18E14ADCD01BAEC7B33129652833C24C1B4B81177C7B756BFB22CD567ED48591DEA738B0E82969A6AD939EBE0F16025456B6749C4B71B1E9FB1C7F8D465ECD8BFDD5071DC8C881EBD983C3440947F85D5B0';
wwv_flow_api.g_varchar2_table(172) := '0A71375B48F6C42DA97E3342ED4F31D936AD15C339789C5849D1DA59125DA1AB3D460706A0A6B1B57397CFEFC583B155BB39AAFAF0D3074324B885F83DA5E2913637CF8BF86D2CEE19EC8F5117171D3878CC5885A2F659125D3D570F29DF2E4379776FED';
wwv_flow_api.g_varchar2_table(173) := 'F4FBFC868A1AEA77C2A3C364C6939A45D509EEF23D88478F32630975D2F4C783B407451D165D07ACA4A83D0BD8D8B3F8801B441FD1BE5207F7C04A8A3AB2804F365652D4C1930D87A29B0D0E45371B1C8A6E363814DD6CB84F8A6ED3BB8231C6D13D62FB';
wwv_flow_api.g_varchar2_table(174) := '26A0B63B3D77E8D69AC7A73811B8439932456859FDA6D62EA8FA3CDF5243F961B745773259C8F9C2C4AE046E89C33CE0F45BABFF5BCBF2E0DF6DEDA02242BCF9968618F58BF7C1D741F82A1EAB29F8A53D4EEC527D3C5E5522F1B46225456BB380C6CE94';
wwv_flow_api.g_varchar2_table(175) := 'D1AE5CF819225A64BCD0EE6EDFB6DD88B85C7CD71137622E23D9E136B859F853B870ED7519DE3DA2A34C0DB8634B2A44FD7201D57F4C51AD7CD4DF1D3CC1D9C23F7DC5A3543F1D501916270B07F0E449F11CDA807B573C76D47D4AB464F9F8FD80B264A7';
wwv_flow_api.g_varchar2_table(176) := '6A3C1850ED3EB5140CC43D32DD084CF1BBBF8AC5C2EA4FE971F267917FDE2BF3914F335652B4360B486940230943A7C1830E0D3C81A23DE6563995F4839D2EB808253B5CC13D3B78F62C28EADE5A9BDF4FF9DD87FAC06EA0C8C1252AEA4FFA5542C52307';
wwv_flow_api.g_varchar2_table(177) := '91DFC110F5F2BF178503CE36D99385FA1CDA7830B52718EBA3B2FDF75414D7A4FFF5005C24F834641D4B5909D5BF149CA7EF47452161D27F2218E349B641941F339208C2E9D32DC8B60A456D59C0A8D71731DCED1FB49FEE70D3DEE7F79AEDF1AD133DCF';
wwv_flow_api.g_varchar2_table(178) := '817EBDBB77AA6D1DCAF5473B3BFD70A6291AF59ADE0972883BA65291DF067111A281A25D91E829F05582192F67679CE88AC43DF19785D93859D8F5D328280AC7B17884E7D0AA83242388B324272DD0073D8F1C3D859B798ABA43A90902D6549629CCAFCC';
wwv_flow_api.g_varchar2_table(179) := '48985F854578F169C54A8A369F280B668ADA93F340932E1FBC5831CB175CDF89BF750D7C03612545ED59C05EB9EA36D4C11384951475F064C3A1E8668343D1CD0687A29B0D0E45371BEE83A2B52DC27D94F5EB507D3C1F4499566080B3040E360A5652D4';
wwv_flow_api.g_varchar2_table(180) := '9E05340CB7F129AE214E1FF80C8FCBF019873894E1540E8F0AF5C7542C19C128DFA1E886C24A8AD667015D86D1B9ABAB0714FDC030761A87A2368F2A8B148D73C6B59F33350E45371456A1A82D0BA85CBFDB27CA0095E1F6AADF29578453BD44CA0F8A0E';
wwv_flow_api.g_varchar2_table(181) := 'A87030168E0C3A14DD605849D15659C0AEDAF219D09867DBF8BABD9F5EACA468AB2C60BC89A20E9E04ACA4A883271B0E45371B1C8A6E363814DD6C78A6ADED6C9B43D14D8467DAFE4BDB9D295A17FD5B5DED0DD5030AB6F574739E09C0F8D4C1BAE219B0';
wwv_flow_api.g_varchar2_table(182) := '682B459B6701BB0EC58D9D9463D82FB20CA6D1AEBC06A5FD5C46FC503CE4DB6EE065BB71A8EBDF0CA39BF6D188B365749DB192479B6701E33DD403D869F8F574914BEDF77BDD9C0C3442DB7AB6F5F83C2207E86EEFEAF1694A869B357C3A580FA01DBD9D';
wwv_flow_api.g_varchar2_table(183) := 'A24DB3805D9C0304E5FC5ADACF1771057B85A2CAF5471D577FE87BD6453940777BBCA7D32F92BAAF3B3382EB8D95B5EE8A1DC14ABD60DF0947E46E836365AD7BEF1DC12B55403AD838101E3D601B1C6C023CD3666D39DBC2A30E9E6CAC6C471D3CD97846';
wwv_flow_api.g_varchar2_table(184) := 'A1AF2BBF3B9375F7735B83CAFDFCD66097B135B8CDE8D8EDEA50578D0ED569C80444D4D7EEE9C2238C6EDFFF01477A5A62C2D811F579FDBB5D5B7FCF85EFD56E5748757AFD9D1CEDD233FEE843B4E51B03FED69D7A77B95DDE5DDBF0120EB4DF3FF47977';
wwv_flow_api.g_varchar2_table(185) := '3148EF2EFE145E349AFD70C07E70E060F3A0C6A2EA2E35AF9B2C46BE24B380B3F618CFAAE4736051AF5F255DED11B0121FC13F7454C355B268BBC77CBEDD03EE357AF6C84C94F82557FEF0A5DAEDD5A32542BEF1FA6DA7CF6FC5975E3FF9B7C9EF2EC3F8';
wwv_flow_api.g_varchar2_table(186) := 'B4C69EA832C44EA3DB6151079B0FB29626B85BE7082C46AE89E36680A160EC05C390C1A23EC3BBDDEBC7CDD86E1C522FBA0C83DC03D458D4D5FE47B0FC34488E024BD1E5A7680E8D5E2F59D4AF94C96FF414225A5E1A776C13A7BB5DE23783DB0E3615BF';
wwv_flow_api.g_varchar2_table(187) := '5FC2E70820E9427BCAA778BD15EDB600E79012079B0D6B63511B6C45357433F618204CECC0C1D38BFB62D1F580B32AE0E0E9C6866751070E9E6E382CEAC0C18686C3A20E1C6C68382CEAC0C186C65A5834E5FAD4A34C5E5647B7D1FE7DD49E9A7DB179FB';
wwv_flow_api.g_varchar2_table(188) := 'F1FE116E52A23BD5FF7074752242EBB1773D7EF07B2A8F8D3FAC75E168422B47FE3E6826CCFDE1C1F3C11CF89E39F85870BFC56B2D2CFA8177EBCBB6CCC16A48B95E75EDBC43A01444B01F01D3F59A9AD87EFBDAE5BC3EDCBDAB5DFC5F6A794D424F3513';
wwv_flow_api.g_varchar2_table(189) := '7B29A45227EA84308FD2F7A1FB5B0D0DFFF893E694B87DCFDA4F75D412D328F32D824B4B1D2AD9888320FE1F5F5B5301697193428A919E56ECA52DA19D268F79DCBEADC1F8F610CCC23AE64FF69C42B528DFC5512985436E6672381454E6C9A6CCBE2D99';
wwv_flow_api.g_varchar2_table(190) := 'C47C53F092B6782D749DC7789D3AC68FB41C762D5F1187A6ACD03176DB9B618036B0F42992A2A90CE8980CC5A2BE1D12D5E4EB76ECE2DE5874E478246927B2154DB45F8DC39756A9826FA37D5376C60F330A2D197E07D4DC844348C850C387EE40738EEE';
wwv_flow_api.g_varchar2_table(191) := '956436E2851C41688D7C202D9662D144AC11A64D396D50F5344B3ED5E9DC007D68422D37D6C2A23501C01784DF3ED0420B9DB2310D88FAB67A268C67C57E8FD10163709BD1B3CDD8A9F61BCF0A8B5EAD2DA7A65E8BBF79E8DB10794C47E77389858E4BF2';
wwv_flow_api.g_varchar2_table(192) := '7589602DCF7511E2256C5987296D44205DE1FEA5589B6DD45FDA9FCC4B1E808EF09FB9848F9181E110CA5BB8A9624EBEC67C36874341F01DFEA33EBF3BF136F395719A6288F496C4A997CB54FB9025142792C7240E4135D45FCFE478204E1E62B6C3073C';
wwv_flow_api.g_varchar2_table(193) := 'C10B460721C5DFB6DD10669F65D50B7B72500C28C25156133665536008D60262E4C5FCE49537FF22F51A1EDDA0BFEAF4D3B21B998208997DB8467DFFC917218B36135927B36B3036CF641ED4DF8A9F0C2F712A790C090F8758316A07285CE6C05B3A2B75';
wwv_flow_api.g_varchar2_table(194) := '41641A01F928AEE542107F893EBEE54D901AB4E07CE8CDC146CA6CC22CBDF91AAEA09F6521ABA4B887639DEFBCD4E927D7AF841052D723E150EA3D38873F752E89F707E348345F239D5DBA925C8AB1D1AD53AEC152760CCD612132C8CDB2C3AAE4A43F7C';
wwv_flow_api.g_varchar2_table(195) := 'F08F064FF9FCDDA120990E2E75E9D2896EB028028A1F7CAB6ED4C99CD2F96E17CDB8D5C87016A504C9D9C8069B7276794F0DC658E46A99237446981207813B6185743587A097986B123805002903D8F6F29D59D4746DF508078AF09D96CE539DBD766674';
wwv_flow_api.g_varchar2_table(196) := '1AC84657BB87F6C9E728C04BC2526AAFDBE8696D45516C9836A68E196D7EA2D3A7590C25BF662075E8A8CE22423579E86346D4D2542B09BA28496DCFEFE19A1FF0EB64EFED4D09F281B9AC1D447D31D2D26E486BD5BDC4A1257C725B230EA07A531C0470';
wwv_flow_api.g_varchar2_table(197) := '19FEF14044B76D307E8A94323A42F6D4608397015D140032343E24CB1C472ED901B01DE363ED8766135FA7DAFF0A2506A583BCA20B015E92E2F1FE177CCFBA3FD94329AB7A846BC9647250B4192F963DFA67D7FBE6C01FFEC15F8463768C795B028BFE4C';
wwv_flow_api.g_varchar2_table(198) := '1771BBB44AEE4A1C08A947189E07BEB7F6D5C01E2445A3BFA309331463A0DDA82425519A45C5DE26F66DD0849400BBFF7C182EEB61132CE9A0949DC66E5D9A87DE242733FA42B9C607368568812FB4BD5C8790E6D4B1177C2FD9B54CAD1D14EE411C58D5';
wwv_flow_api.g_varchar2_table(199) := '09DC09A474C8661A817622BEC4FB5F46108862A3DD465F301C6222EB85C364E14BB633C6F8886996C8DBE51DD46FAEE934A602D184AE9E75CD3114D02C1A6C9B7FF9AEBB232800F82C3E12E13B4AE77DAA65F7806D22274B69765B2C50E4F4FC5D6864D9';
wwv_flow_api.g_varchar2_table(200) := '7A52526FC2F8A138D511C405F52AAB3E16B69862757178075B14943C31F8713BFC5640B31C62297530EE6C0ACD61BB1613E84A130E509B75691F348BA22E830FEC184ACD16D7F51121D91C0FD00D628260FFDAB7C32E7C0C1D21D13B89C3C137EA0D20AA';
wwv_flow_api.g_varchar2_table(201) := '506988250E7FD5A7E3106EC81B32654B784729C418061BA84B0EC12356C26C44EAA13392F5D26DB7A26899FED2E767FBDA4805F2061CAF2928652F4916555D27848760CFA82277E4466226071146A30DD1F2CAF140ADA166B49877E21CDCCB5615A12019';
wwv_flow_api.g_varchar2_table(202) := 'FA95ED0041A03D95660F497B8589B64BB026192389706A6530C5409135920F884A4340BB3E0241D341FEA9B3A8144FB02893894756773568DADBF9006EA7EF34D51B2A461C3166B9819768CF1023D405A7E1919D1D4D6DA04419B4D074E60D60B0482C58';
wwv_flow_api.g_varchar2_table(203) := 'F44F7C7E9D0F36C3D8ECA7E300132F74C0976210CAD9198E9CED67478E19CABEA438405459386C7702A988D05AEACCB369A183900C60552FAF34186178FE5BCBFA734457AA6DE6AEDD8AE2FF6E2CBA463C36B1C006EA4DD2DD3055CFB487892512662341';
wwv_flow_api.g_varchar2_table(204) := '6AC056D8A307F4E9C4F818B126C234559D0F0336236E32D82C3A1F74F6183A70B0114116DD8B8EAEC3A20E1C6C489045C19F7BEF3E1675E0C0C13AC1EEE8BE3CEFB0A803071B1164D1E07CDBCB6845CF3E25F8DB0DF3EFC0C1BD61B3E85E47259503071B';
wwv_flow_api.g_varchar2_table(205) := '127647F71EEBA20E1C385827D82CEAB4A20E1C6C4C389BD11C38D8D0B80B8B9A2EAFE1BDD3F6162285F7DE6619DCFBC296DAD1C28F00ABFAFDB76778DDDEA6CE787B7B91DA9135554A67CFD464F689B57DE3C0C1C3C3ED2CDA76C6BBBD77BBB7370A163D';
wwv_flow_api.g_varchar2_table(206) := 'BEAAAC730349D77F2523D7B838EAAB49D66F4C9CD52CAAD499B3F8B5A977D6C46E6D0E8B3A5857AC6C4547C0A2EFF081AD68EFBF457DED11D3F537914EEF5F5365660CB6FEB8D64E9D7271E78ADEF2826B8D45E35E5B6AFE4E68039B8C6C393BA2B68C28';
wwv_flow_api.g_varchar2_table(207) := '7560CB96036D07CE6C5123601CB1C1FB1F8195B6A857CF4BA3D77B00366DA833B473F1E24E98DF82A86F6F83DF64A6333F7AE7AC1A392E0C09161DA1FC3A59B477FB19785767510677A6ED8017EDEB16843B8F90E0EA57DBE53672065C1AC5C778D9D6C6';
wwv_flow_api.g_varchar2_table(208) := 'D6D78183C789553ABA67B79359D88AB27D4CBAA8DBBAD72F9C888BE96A8FECF69237C1A2684577BBB6FEE0B8D73F61C4C0A2BBC0C43DF2C55DB16564CB8120D9E86FC57806EDDB992DFAACA0E881DE2D6433F2E2ABFF45B3283E903A634DCDDEC816B025';
wwv_flow_api.g_varchar2_table(209) := '19EA576284BF67476003FCE80C98AFEDD579B6A25BD0A2D65A44B1478007A2F89D0557DAAF46DAF85DDB9917A4DE88B6F1EAB4A20E1E37EE36161516C5CDF0FE4D44379664D1E37F1349D65A5134B37805BE34B67B9F55A9E3464F1C56D2B8DE15EF8043';
wwv_flow_api.g_varchar2_table(210) := 'C046EA9DDEEDBD60A8EDBF92060BD8020B5612BDAC26701B39F323B2A8D8A06B2ACEEF81EDE075F669B7E313301E7EEF0883F3159A4FDCCEA075DED2ABDE81F15536AC6DF07604ECD9263F18B6A803B8A2A1458FE2C099972556071887330E8B3A78DCB8';
wwv_flow_api.g_varchar2_table(211) := '0B8B3A70E060FDE1B0A803071B1A0E8B3A70B0A1E1B0A803071B1AB60020E0B0A803071B10368BE2DF6151070E36209C9D2E0F82F9AFCF7F337A7A3C9DDE40FFE5D16FCE7FFDE06AFD1D6C549045E783DCEAB24616DD6F3C0A6D7A1B19F3C290E9F4C58B';
wwv_flow_api.g_varchar2_table(212) := '93D94C2593C9666E6497E772B96A75317779B19ACB1772F855F357785B7CDCCF577262B852CD0173372A99C9C98BBF9C48DF9361DD89864ACDEF85F8C1C7ADF5F12903593438CFFF87D68A9A27A92A311C481EADE990AFC15692AF351A2F859A0EEF0807';
wwv_flow_api.g_varchar2_table(213) := '52706DFEC463F6C5DC8918359253A5B276D975028520FC77D4C0F8328AD6296ADCB71D84436A28A455A04E351C3469ED9F0A21A07080DE682D967BC507953A61EB828503BC368FFA190A1C88A6CBF9737FBF6FF4EAF3BFEC7E7E62E262E65AFE48353793';
wwv_flow_api.g_varchar2_table(214) := '2F148BA56261B6806B11D7D9E2ECCCEC6CA9388B87D9C26CB1B8305B98292C68B3BE14692ACC682BB128CCE00E5B31E06BB15BE03F9E6C577C84CFBCE35338171BFD93673846780BB0A8BDE18BC2ECEC178C56BE50AAE6C9B0FF34979DFB68F9E3EB60DA';
wwv_flow_api.g_varchar2_table(215) := '8989D360DAF8C95F81696B84D159525313BE027BE76B0A9B0166751DABAAC24C51D92F72F5A71F37D46EDA7A3AB53AFE55C86D434728D90E7207409B25541D54C36BAB9E26ECE069C33347D2DB632FEA382C85742DA41D989FEC395573C092B654F321A5';
wwv_flow_api.g_varchar2_table(216) := 'D50FB7C6E1CE11B2535173D07CA6875BF44FB724D33CB963C82E5FB6818A82835DEFF9E3FDAF5065BE2E5EB68397ED6CFD016DA6FEC66F9E69B795ABDAEAF56BF91EFEF12728DEAFC381DDD1BDEB7ED194B7FDFF497A3FD5D1E8F4BE649F1BB1536D1305';
wwv_flow_api.g_varchar2_table(217) := 'D7A7B42EFADA19FBA264BD869A6A575B0FB75642AE950BDB8EA8CABF09A20F5974EE77531130A81BA6EE6139CD0049D05AFBE16C005C2BA72500241D68DBECA0A6B55F9712D1FB6C47463BF83C104436C20807E4F6836F85E65F3C32F8CEE974657878FA';
wwv_flow_api.g_varchar2_table(218) := '7A7679B99AFB2C57CDDF7CFF7DB025F84AF840F8423F912B609227324BEDBD7EC57F7CF5856DABEDC876B651FEEB6EED07DB685FC1863507606430319EF9507FCDB708438CB4D1175C590B48BD5000CF1651B32C168A1F8369ABB9CBCBD9EC8D0A91A95C';
wwv_flow_api.g_varchar2_table(219) := 'AB5EBF861EC197FB6F646EFCFAFAB54BB9C4F2F4F56262F17AF6F2FEECA51BE82FBC7F3D031EBF76E99F12372AEF4FFB321727BE1C49B3DE9A3E33F13FBCDDD3AF7EE9FABC773C3DF1FC2FD3E317FEF578BA9C1E1F4B97C7CBB82F3FF7463A5D5E3E731A';
wwv_flow_api.g_varchar2_table(220) := '5DF0F277BFFFD5D7B5123124C779D88616DAF3FC0461066AAB9E0A451354F76CA3894593FACC1151884D45DABA0468079D7EB40EE2E07488FAC19BF45E3729016F453834DFAC127EB563637EAB4B8FA0B97A4A0EC6E619635B7379F3A12428E172EA0F2F';
wwv_flow_api.g_varchar2_table(221) := '7FDC7AEE444D4BFED1DF21C22F8D8CFCCAE5A1EE6E7C3CA4CBAC769092F33EC4C15AC6A2295787A234BD18A8855E9F1BF12CCF7909767A77C9B13F0DEC6E6251B204A8822A43B3A8D4B5B6FEEF554015E9929D76423487C190402A6C2DDF3CBB43729C14';
wwv_flow_api.g_varchar2_table(222) := 'BBCA2CC503B57A371CD47DA01340B368BC766CC3E701D1B7CE1C0907CE9DFFF723AEC9C92FAF2F1E59CE2D7E96BF5C40CB8816092C03B660B1D72C506728328BDD6A95660B8505B8A7198D2BADD8508A1D9ADB1958C833FC9AC11F3E85C54DD8B2ED2DD1';
wwv_flow_api.g_varchar2_table(223) := '6AA6444FF8631B2CAED916C280ABFC696FE00322C5D6169FB1ADC42BFDEE0BDC66180E5B64CDC49A9F517348238D3FFD5F605D0377450677137160A88C14FC8691EFF18788233D129A3C93DD2543664B8BB34BA5EACDC5C59BD55CFE66FE66A9942F7D86';
wwv_flow_api.g_varchar2_table(224) := '3E77A9CADEFE4DB4DBEC6ECB0FB6B8163E66E7BB3A9B5B9ECB66755BFEE5C869B27499FC9C2EBF8BCEB82649ADF606C85871B25F8395B5EE77A1A67DE648835584CEE2401FA5613BB8ED448A3BB228F8BAFB1E23B7E643795A581441D81D85DB512BE16C';
wwv_flow_api.g_varchar2_table(225) := '19DD0994BBA5FAB913D123F24E22D489261915C4B7BA9402AC6A2441529E0FFBC5C15AC6A2BB5D8621C742106C450DC3FB3BF50D2CD127E9ECF59345EB472B21749E416283BC8054E8032078B400F922699FBE2068AE492593FB835AE7BEAD805F2BDB07';
wwv_flow_api.g_varchar2_table(226) := '983BF40129B4339CCAFB914BFC88C96E3888DAEE3487DA0E348736F4F90FC5E65FFCAE77B2B2FC616E6666A658426965432745BA7E150BFCC04B85D9999BEFA30F393BF3FE67B9DCF2E2F4F4F5CCB5CABF4C7FB4BF92F9EE5FC47493D74CE54BDE2A304C';
wwv_flow_api.g_varchar2_table(227) := '4FEFBFC1CBB5CC8D4CA50ABB9FC375E6524EDE74662B992FF76732BF9E9E4E642A79B96632972E652E75FEE3A59F27AE652EC158C95CCBC271429C5DFFA892799FA6CE6C719A3EE123182A1998AE67E6DE9F7EFF087AB92572FD2C58999C6E37FBFCD9FF';
wwv_flow_api.g_varchar2_table(228) := '60B69A4573EBCDE79A3DBF6225A4ADB417E24CDFF8C77CB19FD199E09D8FE0781D5E3D27F12C16E0F5C5526171B198BF0C0E274B73F09C9F3992C5F0399B4156CC1DB986517E167987BCC93253602923FF4A763951999CCC4C0F0E0F8E7CDE7B6B2CFD79';
wwv_flow_api.g_varchar2_table(229) := 'EF55315C3DC26B3A3D5EF1A6C7AE3EFF8B74F9D6F5CEDED317C6FF47EFBF1E3F8D3AC09E4B83EBC1C1DEF3B5B6BCF9940A14B326035B79FBA901CD86AC35C8504D2C8AA6A88945BB5B5B51C02EEFB5732734E420183935A2FF05F69ADD3EBF6E45EDB654';
wwv_flow_api.g_varchar2_table(230) := 'B3A894DCF8DBE2802CAA575DEECCA2499EB8A4D41EF0A4F1D7B5D6F42E08DBBDCC8D8BF973E7474F5FECCCA2929706424A15FE592CA53502BE4093260D5961B1BA5C5D466999BC389106FDC7C6C7CAFBF69D7F8493A7A9C1A60C6C1E37C8192796743056';
wwv_flow_api.g_varchar2_table(231) := '60EFD7E7F78D8EDDFACDC5C9CC54E546760E550F1BB66ABE00A095178EAD759E75A34B93B6A1A96653BBDE66AB3FD4FDE89A497E9A11E5A1F6AB5B48475C989D1EE1469FEC1FE223B1929104EA1544135D0234E1B090FE867433507B92428B054E9235FE';
wwv_flow_api.g_varchar2_table(232) := '9930A4EE32AEB69DCCDCC18C777842B71E4FA599F781CF4AECE5E79697B3A8293393DF0D9E395F6BD3EE8DE4A0B05EED7490D38D2366EE0B423869A0EE1B762B7A776DF4FAB8C94D82F91747D3D2765675179325479755F9139644D9C6B04DE66F272727';
wwv_flow_api.g_varchar2_table(233) := 'D363EF7E75CEFEFA89C1B9F31F8C96C7CA6873262E5ECCA03DCE2ECF61808DA22D659A4F2CE8D29889995731D51E69B27FF92B57C023CC22F6AFC132E025FCEB0B7AE5B4177E134B6DAC5F17C081C29E77FC6922D47EECD6F38E6BAD25B7EB16DA483D8A';
wwv_flow_api.g_varchar2_table(234) := 'B69A7EE2476BFD7DA3BF60FF84A8781277F2C0B8970AF9CB1F6632E96FBE7E524AB5CDA24F89AAEBF9AF464F67AE7D886152BD20E8A2843E5835B7FCE15CF6DAD4C5C9895B6C25EBA3A44D02696547C7C76E95C72E8CBF8BBE4019FF17C6F187FFB1B10B';
wwv_flow_api.g_varchar2_table(235) := '781E1F7B777CBC0C7BF4132E5C28E3DDBB6958C3DD787AE2379353E074D45A9D59DCF8AB5CCA5CC38DB34EB044B7B4F31280D797E8A6C23E6A272A3A59A0CAA1914436D7589AB9CE56F436F68455F31D007B83C91B2E9A7F77B2BFED577FC0101E775C0A';
wwv_flow_api.g_varchar2_table(236) := 'B38B1FCE5D2C7FD5D43DD9C0789A6474CFED4B4F66D1F1FB02E492DA97B56C01AC8991CEC4F8183BAF6BEF0039582BCE9DDFF7CD58FAD66FD00117D6CE82A92B1841676FE8CE78BDA5AE35D8B8B31F430B7451A555675FBDD62CCB43BDB9E6AD66A96D6A';
wwv_flow_api.g_varchar2_table(237) := 'C6A6B77C602B4BA69607F49CAB95F2DFDB31DCD8786A58140DE824C69E20106B65524A069995C9F4BECDD65E3E3160BB5E46335DBE80561B7DF271B4EE172E8CA2FD1ED3CF68F0D1C68F97D3B738C2CE5CBAC1B69B6D7516CDF4B50C1B6D30FBA54C8637';
wwv_flow_api.g_varchar2_table(238) := 'CE2E491BCF492654019760CF165FAA83B91B731F2EB302105E078B2E147299F1274218EB2961D1F97DE5A91B0559650083824AD2764E8C7EE3B0E75302B4E5A363E5F1898B9565DD8E7E51A86646ED971B1A6B635177C2E221CF3D949CB0B114F8D3C62C';
wwv_flow_api.g_varchar2_table(239) := '73B8FF95F7FCB2BA41074B164F9C8D37CF5FD9422C7ABA9BB35BFA40EEFAF418574DCD815DDA071E7E2C52654BB8CACCB5159383E143BC1EA67C87069CE3BBD47B2F3584D9CCE1D8525DD6A31649306866B9CA55022E5A96BE3C52999A1AFCBB66CD7E32';
wwv_flow_api.g_varchar2_table(240) := '093D25A9B0A1936483411C927871626F4A1286883526F7F84A4B2699039129469579C64974391A3BC68FF0ADACFFD4B34D9F362F098CD1907A4F9F51CD0527A442DC104B8166A19866838E646DCE57FBD7D5B22C7D1B6CA770B96245AF710AFE2A0031EF';
wwv_flow_api.g_varchar2_table(241) := 'F6BA0EAE69C1A1A6BDA67323A31A8B8A78535BA4D6B86BE084441779286B188D250C1BB6100B8A145EC1813DFD4AA030E28A78D588F5753A9B93514EA1B03CB93A8F7649899242DF80CD03AB142F0D5D7A487B49BA14D36FC5A02125B883D238665FC75E';
wwv_flow_api.g_varchar2_table(242) := '35450742FB1E2D335003BE61E94716C26F267B6D2C1A270B9827FDFC62FF885EEA0C757175D81CE6ABB0AC25F32DD768835C7D86C19DE8D73ABEEA6BB9FBFD78B0176FF995BE0376E1D63ED02F7722A6E2A13FA50B590575FBF8915C9B05B2E871EA44A4';
wwv_flow_api.g_varchar2_table(243) := 'B6540CC74719C9144506510E8724925F754F5FAF96D8B70559166FEEAF9C61DBD9F8065F7D42FA85036EA6E2CD41E66BB7BD3C2EF2260802BED1428446280AC118F3E87C815B27A9910AFD2DAFFA89C911D4E527809AF01D85316060E2B56B2479074D36';
wwv_flow_api.g_varchar2_table(244) := '9642AFB40765251F9110035C0C73319CF9EE51A96343F6BA9A75F0A72C08A08F9D0A58EAC2AB0B688343D5D49FF7D1014A3513C18F116B54274CA68F37161FC481258B5191F8D050CFB6F85F26F02D632CE9EEE391F2A858E2720A7E34D11FECEEF720BB';
wwv_flow_api.g_varchar2_table(245) := 'EA192569B34B8F8E09570C9976F1DC0ECF768008F50775799684D6BF21E0656A2B03D7468065845242C941293DB288B9C4AC8E4A71A9C54122F9757A790635F56C69F6E3B989AF10AEA4282C8D822ECE88B5C89ED50324E28C82E601F3932569296C1ED0';
wwv_flow_api.g_varchar2_table(246) := '3E681EE886AB25B4505268E194F9209FDB25D81C187969E48D804ABE963C469208ED19BD3AB481BC6133DC5A58B455460F45DB2E48B7836D842497B932F4E393FE545DC443974684AE3F8D0B656CB93C82F1C22BED83B81992BC6661B2599425CDED7BB6';
wwv_flow_api.g_varchar2_table(247) := 'E5B328DAB65501FFEAE97E319DA9EAF9DBC2E28799C9D1DA0AF6549DC42D625FDDA1BDCD22614D60AB202E997FE1BFB6450E6D3049B5548088225CC1F7DA4D5D54C6169411307184545543166BE7661F6F4373925AC13574160D2DD2A8339D66CA273738';
wwv_flow_api.g_varchar2_table(248) := '0AB07D97F2CE0B7EBAD6A7EB30321C35EA9296B4D4A93DECAF4788EEA547506FA1746CE8A011AF70BF079C01DABF84C28BE63E7C30D26D6794CE54568C4CB7947E4A9EF12BF95E87673BE846402C235DDA850EC096188AD31979037ED4A6F798DFE6C01B';
wwv_flow_api.g_varchar2_table(249) := 'FD9E7028D5BEE7ED6053FD2BED458D58E2FEEBC9658C7950204ABF5ED1D56D9D2F44FD600F57C1038D459AD634B7801167D8520096C8033536D725D8FCC95F254E255F63666832D09B16BFB4816C8E8A9F6ED6D88AD2371BAD2CAA2B4F8D6EF66F09E64A';
wwv_flow_api.g_varchar2_table(250) := 'EA98A7898124CBE4338998DA4629E2A65694CD1E8CFA25DD85FB83A424AB9ADB58B46967455367100837758155F78F3FB123F3F57836CFA5F1D9D9C50FB3E9AFEA33049A41D89766C6D98E0114D766166D62DF7AB25949504AB8A9CF83241CF59311512D';
wwv_flow_api.g_varchar2_table(251) := '221F1067F37F0963DA1FD5BCB1C54D05B57224F900D6E88BED6DCA59A22549E17A9280E67C67D1151695DC93765EE2A065B7254F25F8A8C880DB65404712318C26A4E54B0D8628D78254D871806FF1C3FE3A0DB5371202EED2F28A3F08450474A41EA70F';
wwv_flow_api.g_varchar2_table(252) := 'F4F598C78DEFE0032CE81D09A5F31B6996086AB17B66237A01528A757874D07522A21301BF5E62E6D855BDDD8547D1D0563ABD029691F970874A22CDF041C602769633CEB538D8B9D63D9D97B59ED2E28DF47CB2D68A32C4E66C45201220728686261EA0';
wwv_flow_api.g_varchar2_table(253) := '774D6C65B7C382B0CD035268517A1B3CA04BB05433C9D7F7C056F259DA9B555834F9DE2E855E088BCB1A59B4D98F56AC69524C47BB86D69AEAEE78C1BEDBDFDCEDD31452B5125F973339D0A3305B285427CB8DD88A9C1552A629A34BE583E32EF1BAF30A';
wwv_flow_api.g_varchar2_table(254) := '796BAE6853AB47146EBE03EE9189BAB26B815DF1DC85962BC0B8B710F82ECBFDF72808767D54AB969AD0E86B11AB39A835444D68B5BB7366045B73593BFC66F2C312E78C660BB9A9D156BF5B52A14725513DD3713FF9B63AEE41B2DB504FE1DA58F411A2';
wwv_flow_api.g_varchar2_table(255) := '35871E3EBE999C2B68D192D526F0A2F6DDC186C1A32E10C0D763D7AAA8B68B18F9DC487F655BAEC4FDB1D41DB1D604DDA98E5B77167DD42867AA6842C9A2D909DBCAC1D30E8E4659280AB373531B7EE165D3B3683AC30A934BD5D54AFA347511D82F1C3C';
wwv_flow_api.g_varchar2_table(256) := 'C54857F2943143D7AA52B6AD362C363D8B8E667E2D53030B188C52A46C395B999A9C48738F52ED4F94883CA45E8D832702E35961D1C26C35E3B0E87AE3AB8B3744FB00D9547ED4425058E476160A8016AAB9CB5530EEDC8DACC87D5FA21429B71FD799D8';
wwv_flow_api.g_varchar2_table(257) := '61E04D88F1ECA248ED16163B6FD9561B169B9E45F7EE9BC8CA94AEBD238A777B07A3FD2B704322C50217B88B52F62C92891717ABD41B86865733B016FE6C65DF7BFD9547DF75B4F26D44E88E6EB150BC6B4777AA69856CFDB0361615D50DB6EA241BAB68';
wwv_flow_api.g_varchar2_table(258) := '670A533E85DAC1B860456D5D5C7F157051E373A437FED72E7CA317AC5A163A44230ADE50FA2F661E6DFFA9E23ABC5E380DFF98AB967B4FE3ABA8CFCB606AB23AF7D0106507FE55F7F3D77E7E395F28CC803DC18AE04AE9FAEA9FFEC7456F80B00D7AA722';
wwv_flow_api.g_varchar2_table(259) := '7FF6FE64DC006A13599C2DE5F333DC3B2C9B306EE2BF4403B8B954BC9C2F7DBC582D7D5C82099799CBB9DC91E56AE2E2E4676F3571EE78FAC8C8E837DFBE3DCF4C68C9077BD95472B22745A14A5A483EA44EFCC991FA4A4A8B4EABD67CD0861AB144C115';
wwv_flow_api.g_varchar2_table(260) := '100E891EC3727A7CFCCB57FFF1B9379AE2D2F82B7FF9CEE8ED3D86DBD7A3685E25DFBB437AE113C4A2B853B0B144C127ED89C87CAD04ADE16849CB0668291F114DA8A32EF8D20035E24C05D43F07107E1B5751F1B6B6D6AAD112C9EE40EABDDFD9CFC0FC';
wwv_flow_api.g_varchar2_table(261) := 'C5E545B2285AD18FDEA053DBFE9EB83DDF290058533666AFE5AEDDB335626D2CDA5D57BDA2EEA2212A2CABE178208B0EC5CCE1376B4B3B2411CA99F9130F7212C59002229426A9CBBEE8EC97A5A054FB0F06FEF74F3C5C1F9375DDD46BB22E2FA537EAFB';
wwv_flow_api.g_varchar2_table(262) := '4FBE4877E8E5B896E15D05FF1CB2D7883586B8B2357FEEFCBEF2ADC9C94C263BB75CCD173EE60E25BD9D6956140DC91A9930A4FC341BDB3FCDB9E069FC738744896AF9642B9BBCC4031A61ED145F8A593F375490144BE0EB9912799AFFD5EAE262E97295';
wwv_flow_api.g_varchar2_table(263) := 'AA55801B54AA327D5DEFD2CA4C1587DF4ADFA262AE89E77F911F29DF4A2F8D8C97977BD3DCD8591EDDD7CA40CCD6A682DBBC845E434D0A63EADF46D3994A2E97E3A6AFC54275B158BCBCB87079B1F471BEF459A954CA5F9EBD5CCD152FA3C3F0EBEB99C9';
wwv_flow_api.g_varchar2_table(264) := '0F8FA7A79E7F235D3E5DBE4AED61E9B9576F9D3E3232FEE508B58995CB7871213D7E75FA0CBA13E3DC723ABEFC96EF0D58878F97E7CE9CFEE7E3D77F41B524E3E9F4F55F5406870787FFE18DF4F2E03FFCE234EAA671A46C6A78E4F472EFB7BE378A239F';
wwv_flow_api.g_varchar2_table(265) := 'F78E9D3E323872BADC3DFC0FBF48C3FB376E956F8D5DF8D7E3AC4DF0F9F219D41C23A75183D0233C2C3FF7CBF4972363DDCF0F9D194B5FF8D7E11104441FCAB7BA8FDF4290DDC74F1FC157A7CBE5D3E3344BDD932E8F5F18BBF5F9E02F6E2DBF35F17EE7';
wwv_flow_api.g_varchar2_table(266) := '8D45D1C984FFE5E54FB9FC2939D91F8C1F7E89D563D89624627974277A443C633814D42D86C0AE485AF000EBCE6BC2DA58B479211CBCA32BC515A8BB028B06BB0FFB99686D617F2092F3313278D4F76C8B27BAF5102BD11D957CADC6A2B6A2A51A8B3E6B';
wwv_flow_api.g_varchar2_table(267) := 'FE648FAC2437F41EB6E2AEEAA2F69EFB6A74ACE2BAC8CDC9DC70FC8F97F2FB3BB9E998FA087237F3970B971765C392B0AF56C2D0BCA398FC264FF67653F9D9EDAC7E6DDBF03DFFEB8DB69408B1E7B8B8C0365B9484CD80AB1108D579B1C38D2EF662B194';
wwv_flow_api.g_varchar2_table(268) := '9BBD4C0D5D851206CCC5DC2238876A3FD06657973F5CAE08335FCA320173D7AF5D96FD56998B9313A7471B9AF6EAA8B168E6CC44968A1324268885F4FB19B7A23D0010D5043A59C5D26CFE4A7E167D038CD445D550FE66FE0A62B07813D1BA89A13B87F1';
wwv_flow_api.g_varchar2_table(269) := '8BC831C40F1CCFC1C0EC65BABF5C7CFFFD9F7FF6F162699115D20CA25D42B702BD0D6A24ABE667A89DAC9A9F85837CB558CADFC46B24F5B33C7B22F48E0ED01DE10083FA1751A1DDC49748BF84032FE02D3B280CBB7019B1C8CF7C3C53CAA18681CB7CFE';
wwv_flow_api.g_varchar2_table(270) := '33CE2FE46F16110FE9D85C4187865FB28783700BA818F3F90242D1C31DE4FCE5A97FF7BD449135CD5775F6D212AA1405923289F606B77B309FDD34AC138BDE450050E48E356C16252382A7BA2DABAE3A4D7F207C889A895C775B2BAA768BFC2BEDB4F722';
wwv_flow_api.g_varchar2_table(271) := '084D1695AA0B6C4BD7210A002607437F6CEF1EB1715775512B0A2DDA64D691669FC44EF859948894D3CFBF31863ABD9C4EFFE6E2E454A6FAD17E6A141006661901996FBEFFF3F73FA37E3C2A1B03FBE25FF4FEC9063718D82483F81CF962545BE46BCD06';
wwv_flow_api.g_varchar2_table(272) := '6400D1F9232CA06F4D8696B17183E385B3EBF662666008B224A36684027B3E150BA50238E8FDEB735999F5D27F78AA7CF7D10D79CA1FA92ED2136148E9194898C293353BFB4D6181E5572A19FB35AF76B4C45AFFC103985A9519C95BBED2F79A057E7606';
wwv_flow_api.g_varchar2_table(273) := 'F0A5D8E1C2079B57B41D9F515BF11DFEE50DB58DDAEFF8C04069E68FD9A1BFD6EFE5A9F656D2A72B48F98676F59FFD5F5AFCCC377AAE4BE4FBF43E029BBD588263B26B079C4AF17EBB4C364A56B346CE1A6CAE686ECE1E0AD6C6A2B7EDCB593B64F755F3';
wwv_flow_api.g_varchar2_table(274) := 'FEB1DB210D6BF39E85FB475CB64EAC15B6BAA8B8A565276BBA78EF8CBD5F9FFFE01B6A0B19A3F690F4C4C4147ACCD4B74724F078E95246F4D64D831B641FF1257205B71CDBED73A94A959DB30534525A31279EBF40F1B10BB25D94584C51CE44BEBBFEE3';
wwv_flow_api.g_varchar2_table(275) := 'D56EDBC45C7B16037F2CA7C25878C79FDDEEA341FE02DE1610D84201ED368265AFBED6FCEB0F68E6DDF6D32EC9F51BEF3597755BB9D6D956E28DBFD6B7FC8877B195E6BA9128F9886E6CB3FE49B26C63C376F51FAEE25CF70368D5F4B6E671DD6AC14E24';
wwv_flow_api.g_varchar2_table(276) := 'EA4FDCF5335EB02EADDEF81FEFFEFDC39BCBABED7ABBD310EC81B1361675F060D84BA52060EBDF90ABA535BBA615FB50294815DC8BDEA368AE6367917D336AEB130D3F64E92FE42AE50917721E4A184A679D4FED2B8B1C0A5F8B45EDA7FF350734AC1AEF';
wwv_flow_api.g_varchar2_table(277) := '6B6C5A7BD1FAAB339FFD6B756C47C3B6E05333F7C95B469A69204B482AF82F8FDADE5670A2FF6A2E711507FADFFE041779ABFDA051EB32D346716FBBB49F7588FAD9FE563F2C70C1AD7A6D2AFDEE574FC45A9AC3A2EB0474AEBF29A359A6AEAF0BE50BA3';
wwv_flow_api.g_varchar2_table(278) := '54E275EBD66FB4861F698339C444AB4C453F1C3767B3C2D7EC7093A1656CA69F0AF80750F8A455C5ADC1359A9DEDD6564CF891D5C9D4D210D56CD05FB6DD36BED6BF953677FAB55C118F6AEE4656AA24510E9CA9E8B4D4F58F5DBA840E076EEC7D20BD4C';
wwv_flow_api.g_varchar2_table(279) := 'ABADE9442F71E1271ACC38DAA6A6133CE1255CC8705CB287FFA26F975E653BFF91DED10619A8BDC37B3CB16E945770293A1D47BF3AF7A4AC753B2CFAE440B7C954E33B7E614CFECBE3E360F0F1B1741A83E71B733999F5A26E2E992591467A254B6B1B2D';
wwv_flow_api.g_varchar2_table(280) := 'B971451AF19A1BDED89637B9B73DD2B7163B7ED8EC589EF52BB97EB85C992A7FF3C42937DD78705874D3402BEB1A2FA34D160D9C17C67887110D755D6F17B97BF402ECE804065B63E7056AF992361D036E5B7127DA757A46F55F1C85536D273581C103AA';
wwv_flow_api.g_varchar2_table(281) := 'EF1C7FF716BD802BBC18E5332B0DAA058333382ABFFBCDBEF3E7564ED639B85F382CEAC0C186C6FDB368F77BDE3F73EDB40DB7C33E7D346E346F5E77E0C0C103E3BE59B4CBE8E0212F771F6BB7B068CB318B943810954A0E1C38580BD6C2A22DE78BC6C1';
wwv_flow_api.g_varchar2_table(282) := 'A2BB9FEB50FBBD72225AA7D7BFC7688F74DA07A7C1D865F4A84EE3876E57E37C264A2F9AFA98C57F6E3D39D281030777C79A58B4F97C511EFB8B56D4ED0253EE3176B85DFFDFF1FFFDFCAB2E5BB2617F2F99164D6DFD2843822CEA4EF47BD450286EC5E6';
wwv_flow_api.g_varchar2_table(283) := '6D7963070E1CDC1B6B61D196F345C9A29A670DC3BB4BA9AB30F3A701FEE48BEDC6A1462B2AFA7CEBC72C5241AAECE670E0C0C11AB01616B5879E72BEE81D65EDE4AD3349E4C0C143C69AA68B9CD52D070ED60B6B6251070E1CAC171C1675E06043C36151';
wwv_flow_api.g_varchar2_table(284) := '070E36341C1675E06043E3FE59F4AE028077839BBAC180FDFAE6C0818335E0BE59740D0280669360D12AA06C431D4BA13035AA2D75A8269D650E1C38A8612D2CBA7601C0946BAB47CD9BCFB747A2BE4F83A78D9E2E636B306EE83697024AF8CA745148B0';
wwv_flow_api.g_varchar2_table(285) := '49E35100DF1D0B76F72FC59ACFCD76E0C001B126165DBB00E0DEFD86D1C356F4037C035012D0FDBCE65FB7AFFD3FB87E3FD8DA8A6A16A54E30FB3441070E1C34632D2CBA7601C0145CA21D8D1BC68E17F1E8FD5D17658EEC97EEEBED91DD5EC3BBBDB915';
wwv_flow_api.g_varchar2_table(286) := 'E529D154B0D6278A381D3870701BD6C2A26B17005CF1D696A747DB6A18CF8A8D03070EEE076B9A2EB21B50070E1C3C76AC89451D3870B05E7058D481830D0D87451D38D8D07058D481830D8DFB66515BC79F03070E1E0BBE772BBAA7554DD11DF16D682F';
wwv_flow_api.g_varchar2_table(287) := '8F646D1C033B15526D8A5AC7EC035CED73A7F4C152E6009DB913B1799E37A50F761CEAA06BFB8461023E3870B0D9B116166D1100ECF4FAB7193BD1983EDB29EDE98466D1946BA78205058B28220877ED11D851D0A18E78BF27EA1BE12171408D15234ACD';
wwv_flow_api.g_varchar2_table(288) := 'CBB96B3C3E0EB7B01CA4C6B30AC197C16E5E53ED43D6617F3411B30FB9B559F4A19F12E7C0C106C49A58B4590070BF56C3C9C633E532DA2357F13061BC468140D12DE6DD051714A5AF8923D520EC25C7A4F2C475AD4B570EF5E641C15A863EEA13F106E1';
wwv_flow_api.g_varchar2_table(289) := '5BB2205F4713A7EA27B1AAE8718A2069166D3A33D98183CD8BB5B0688B0020F8B0CB38C4C6B3532486A23E63EB2B2EA3D7BB35B8BF5724EB296844197BBCDED16845E520D1504D0FA0E62F7DEC3E1B4E7481F595EEC0B23C7E15CEF4F1AB34E1159A597E';
wwv_flow_api.g_varchar2_table(290) := '659F30EC70A883A7036B61D166014047C79F03078F156B9A2E7204001D38582FAC89451D3870B05E7058D481830D0D87451D38D8D07058D481830D8D47CBA22B8F024EB93E6D3A74A9D55447CDDAD115E8C0C1A365D16D2BA503EF6776B845CB513C341F';
wwv_flow_api.g_varchar2_table(291) := '3F18A18C03A505FB3D6A2946BFF8A4967ADBC5DF2E2D5EF86D402D85DADCBE1D7569C12607B6BC21D0ECA0264ED845198AA9BFD3C21314B4580AED45980C251CAA0929020D8945ADBC504B2C12291D04BCC31B2DB1C89BED40C7D07D1CD6527BC9418EA9';
wwv_flow_api.g_varchar2_table(292) := '1389537692EA1192389847FDF37876E4A89E66AC85455B0400F71BA76C51FAD3C6A1A8AF7D574A64FE626E5FBB6EF9F88EB248FC6D333EF56C33767EE0FDD43361FC75D4E7DDB1DBD5F101DB489171501F3CB7B3A64AD0962AA4172AA5350C5257E055E3';
wwv_flow_api.g_varchar2_table(293) := '8762256029D6D28261AA237B9B720C07A52027C981615BFF91F04EDC3E239105DE3CE94F351CB8C5075BD2493B00840DC4413411B365997C3B54F25830DCBF44E54AFCD41652D441D0D0A310321DD8128BDA07C673A8FF05F05D92225522C5A81D340420';
wwv_flow_api.g_varchar2_table(294) := '29CFA8A62442DD0135140B4A92E80523E44E9C621C96DE1CE4B7DD2214E9E0E9C49A58B45900902D5B17458B7A92AE0E6AEB046F46F653D1988DDD2EA3FD4FF6B77BF08587A282E6F35B7F0F1E7483D7F02D5854EDED3460DF65189FE285A8129C3076D4';
wwv_flow_api.g_varchar2_table(295) := 'A40A890FBC3BDDCF6FF5B4B6A25A8290D282D2D2D94C05F6FB83610A2EB1ACEB724F27F2B0440728F0668B8378FFCB226F88475106AC59B426AC144D9C4AD0353891CD1F38EB6DBAE46B69AF9111A846E887B8F6EDB01DD0A423641B741B1BF5F96D2946';
wwv_flow_api.g_varchar2_table(296) := '9AC2A1BA00E490AE40E85A34AC097F6B1F1021CA6001B121B8D4ADBBAE341C3C85580B8BB60A0052C66887FAAD61F482DBB61986777BFB7F16C9232DEAA7C502F109ECD182023B61A296C01EB21CF8FA03AA097C4114085295A7A812D4077BDB22F9E23E';
wwv_flow_api.g_varchar2_table(297) := '491FA8A4B7D68ADA12845A4E106D12A505876AE709A78E05ED37C2A128D2604B44080E346FB215B51DA04DC2CDE61A2D4EC8260CB01D6886D00E82F0881E68B94470532308DBB5565E684B2C6A3BB4D3875167D9128B4979653BD00290B482C37A786845';
wwv_flow_api.g_varchar2_table(298) := '9B92C408D94C091338B49E4C074F21D6C2A22D0280AD2D1B50E32BF67181EFA7E7CF646D70575DF60E1C3C5D58D37491DD803A70E0E0B1634D2CEAC08183F582C3A20E1C6C68382CEAC0C18686C3A20E1C6C68382CEAC0C186C6A361D1A8C80ED5E0D64B';
wwv_flow_api.g_varchar2_table(299) := '90512DCDA3E23B8F47B87E1F0CF707CDE18EDA122017F41D3870701BD6C2A2B7090086C06C5B83DB8C9E6D78DC6FFC3065F45018D72D96878439DD3EEF2E1156D0885B0777E9557B2BA4CC4F82BF0DC8627D38A0C221AEB85238CEB244E4D68103072D58';
wwv_flow_api.g_varchar2_table(300) := '138B8A0C509300E06ED74E0AC0F1B18B2771539AEF87B625058E3E7DA1A51525CCA37E5BBF9F4809C5D0689A7D87289ECA974E2BEAC0C11DB01616BD5D03A05272BE2F78CE30B653F496B71E6DF912C5F97EC74F7AEAB27BD24852E615B79008CFA58E79';
wwv_flow_api.g_varchar2_table(301) := 'D08A529A953AFE025AD6CD6151070E56622D2C7A370D806C421D3870F0C8B0A6E9226790E8C0C17A614D2CEAC08183F582C3A20E1C6C68382CEAC0C186C6335BEAB06D1C3870B081F04C5BDB7C9BE0FE5974A57E3F6055CB55407D2AF6630DA78D9DF693';
wwv_flow_api.g_varchar2_table(302) := '03070E6C804581FFF2402CBA8A7E3F5AAE9145AFAFA65CA1557250A9F08F3F71A6931D3CD5580B8BDE4900B0CBE8A196A1B8682D62ABD885779D36DFD2CC0381ED7381B515F98F8C0D3E8EFA8CFFD4D0FCD7A3CF0EEEE1F9A44D92835DAFD93ABB1C3878';
wwv_flow_api.g_varchar2_table(303) := '5AA159F4ECDD59F40E028060D13DC6B3CAFDFCD657C88B5EBF2D1128EE92AE8E97E17817EC1A4D23B5FEBD8266168EA26C456DCD7F9DC68EE87E72788FE6E21A441E49B4833970F0B4622D2C7A270140DD1E52F51F9A44AAEBD312817613484D61EDA268';
wwv_flow_api.g_varchar2_table(304) := 'B3C6A23C15D8FB3B5B5E906E6B9AFFC8A2B64ACFA4CBE8A9EBCE15BD7CB64669070E9E4E681625EECCA27713005C0DA2C7B355E236255CEE289A74E0E07EB19656D4110074E060DDB09656D4810307EB8667ACB6B356DB01C36151070E3624EC56143D5D';
wwv_flow_api.g_varchar2_table(305) := '87451D38D87050EAFF07D84F266D9B2188E00000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_api.create_app_static_file(
 p_id=>wwv_flow_api.id(5238075924394903)
,p_file_name=>'image002.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_api.varchar2_to_blob(wwv_flow_api.g_varchar2_table)
);
null;
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(804621206458721)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(92008920644572450)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(99844462046888906)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176128547219506818)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(592235709571709447)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2560293801380540643)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2573352228768076373)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(4323576260494847496)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(4390226133792129319)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(4476138239762075339)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_edit
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(438801654750439842)
,p_name=>'Flow: EDIT'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'EDIT'
,p_error_message=>'You are not authorized to edit applications'
,p_reference_id=>786942708067207200
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_admin
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(477032281289042219)
,p_name=>'Flow: ADMIN'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'ADMIN'
,p_error_message=>'You are not authorized to administer applications'
,p_reference_id=>12511219858301010
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/dashboard_access
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(477074727917083066)
,p_name=>'Dashboard access'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return',
'    wwv_flow_authorization.is_authorized_developer(',
'        p_developer_authorization => ''ADMIN''',
'    )',
'    or wwv_flow_authorization.is_authorized_developer(',
'        p_developer_authorization => ''EDIT''',
'    );'))
,p_error_message=>'You are not authorized to access Dashboards and Monitor Activity.'
,p_reference_id=>786936829326142579
,p_caching=>'BY_USER_BY_SESSION'
,p_comments=>'Used to control access to Dashboards and Monitor Activity under Administration. Developers will have access when Builder is enabled, while Admins will always have access. Prompted by Bug 13859631.'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_app_builder_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(477075720994096449)
,p_name=>'APEX 5.0 App Builder Enabled'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'EDIT'
,p_error_message=>'No privilege for attempted operation'
,p_reference_id=>786516029127697713
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_restful
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(477076806710096450)
,p_name=>'Flow: RESTFUL'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'RESTFUL'
,p_error_message=>'No privilege for attempted operation'
,p_reference_id=>786519856057734816
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_sql_workshop_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(477077192833096450)
,p_name=>'APEX 5.0 SQL Workshop Enabled'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'SQL'
,p_error_message=>'You are not authorized to use SQL Workshop'
,p_reference_id=>786516265251697717
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_team_development_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(477077791361096450)
,p_name=>'APEX 5.0 Team development enabled'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_companies w, ',
'        wwv_flow_fnd_user u',
'where nvl(w.ALLOW_TEAM_DEVELOPMENT_YN,''Y'') = ''Y'' and ',
'      w.PROVISIONING_COMPANY_ID = :flow_security_group_id and',
'      u.security_group_id = :flow_security_group_id and',
'      u.USER_NAME = upper(:app_user) and',
'      nvl(u.ALLOW_TEAM_DEVELOPMENT_YN,''Y'') = ''Y'''))
,p_error_message=>'Team development not enabled for this workspace'
,p_reference_id=>786516861027697723
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_websheets_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(477078061640096451)
,p_name=>'APEX 5.0 Websheets Enabled'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_companies w, wwv_flow_fnd_user u',
'where nvl(w.ALLOW_WEBSHEET_DEV_YN,''Y'') = ''Y'' and ',
'      w.PROVISIONING_COMPANY_ID = :flow_security_group_id and',
'      u.security_group_id = :flow_security_group_id and',
'      u.USER_NAME = upper(:app_user) and',
'      nvl(u.ALLOW_WEBSHEET_DEV_YN,''Y'') = ''Y'''))
,p_error_message=>'No privilege for attempted operation'
,p_reference_id=>786517166823697723
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_create
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(2876432045198950826)
,p_name=>'Flow: CREATE'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'CREATE'
,p_error_message=>'You are not allowed to create or delete applications'
,p_reference_id=>786942708067207200
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/workspace_requests_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(3069175640501838711)
,p_name=>'Workspace Requests Enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(wwv_flow_platform.get_preference(''SERVICE_REQUEST_FLOW''),''MANUAL'') in (''EMAIL'',''4700'') then',
'    return TRUE;',
'else',
'    return FALSE;',
'end if;'))
,p_error_message=>'Workspace requests are not enabled.'
,p_reference_id=>786950454140282960
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_processes/set_translatable_text_strings
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(2621206058206470363)
,p_process_sequence=>1
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set translatable text strings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- Set globals used to select features',
':f01 := wwv_flow_lang.custom_runtime_message (''CA.ACCESS.CONTROL.DESC'');',
':f02 := wwv_flow_lang.custom_runtime_message (''CA.USER.PROFILES.DESC'');',
':f03 := wwv_flow_lang.custom_runtime_message (''CA.TIME.ZONE.SUPPORT.DESC'');',
':f04 := wwv_flow_lang.custom_runtime_message (''CA.APPLICATION.SETTINGS.DESC'');',
':f05 := wwv_flow_lang.custom_runtime_message (''CA.HELP.PAGE.DESC'');',
':f06 := wwv_flow_lang.custom_runtime_message (''CA.FEEDBACK.DESC'');',
':f07 := wwv_flow_lang.custom_runtime_message (''CA.THEME.SELECTOR.DESC'');',
':f08 := wwv_flow_lang.custom_runtime_message (''CA.ERROR.REPORTING.DESC'');',
':f09 := wwv_flow_lang.custom_runtime_message (''CA.GLOBAL.SEARCH.DESC'');',
':f10 := wwv_flow_lang.custom_runtime_message (''CA.NOTIFICATION.DESC'');',
':f11 := wwv_flow_lang.custom_runtime_message (''CA.CONFIGURATION.SETTINGS.DESC'');',
':f12 := wwv_flow_lang.custom_runtime_message (''CA.ACTIVITY.REPORTING.DESC'');',
':f13 := wwv_flow_lang.custom_runtime_message (''CA.EMAIL.DESC'');',
':f14 := wwv_flow_lang.custom_runtime_message (''CA.PWA.DESC'');'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/shared_components/logic/application_items/a1
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584216820885702150)
,p_name=>'A1'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/a10
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584218615128709924)
,p_name=>'A10'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/a2
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584217023655702873)
,p_name=>'A2'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/a3
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584217226079703596)
,p_name=>'A3'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/a4
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584217429542704562)
,p_name=>'A4'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/a5
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584217633005705638)
,p_name=>'A5'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/a6
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584217835776706395)
,p_name=>'A6'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/a7
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584218038893707321)
,p_name=>'A7'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/a8
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584218240970707886)
,p_name=>'A8'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/a9
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584218443395708587)
,p_name=>'A9'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/agreement_accepted
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2702550841505091143)
,p_name=>'AGREEMENT_ACCEPTED'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/company
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2902063034370738006)
,p_name=>'COMPANY'
,p_scope=>'GLOBAL'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f01
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2620215367360222577)
,p_name=>'F01'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f02
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2620215652031223082)
,p_name=>'F02'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f03
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2620215829177223685)
,p_name=>'F03'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f04
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2620216091988224476)
,p_name=>'F04'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f05
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2620216456074224980)
,p_name=>'F05'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f06
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2620216646666227625)
,p_name=>'F06'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f07
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2620217066393228071)
,p_name=>'F07'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f08
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2620217228781228533)
,p_name=>'F08'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f09
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2620217428034229023)
,p_name=>'F09'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f10
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2620217784983229567)
,p_name=>'F10'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f11
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2620219234048254897)
,p_name=>'F11'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f12
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2620219635595255705)
,p_name=>'F12'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f13
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2620219819242256225)
,p_name=>'F13'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f14
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2620220096038256766)
,p_name=>'F14'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f15
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2620220261351257355)
,p_name=>'F15'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f16
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2620220436881257902)
,p_name=>'F16'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f17
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2620220658380258493)
,p_name=>'F17'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f18
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2620220815400259098)
,p_name=>'F18'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f19
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2620221028508259608)
,p_name=>'F19'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f20
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2620221249854260094)
,p_name=>'F20'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f21
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2620221440494260571)
,p_name=>'F21'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f4700_req_new_schema
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2661750939169313165)
,p_name=>'F4700_REQ_NEW_SCHEMA'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/fb_flow_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2927198502727722283)
,p_name=>'FB_FLOW_ID'
,p_data_type=>'NUMBER'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/help_page
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2558503632761292870)
,p_name=>'HELP_PAGE'
,p_escape_on_http_output=>'N'
,p_item_comment=>'flow page that you would like help for.'
);
end;
/
prompt --application/shared_components/logic/application_items/login_message
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2567087316471967564)
,p_name=>'LOGIN_MESSAGE'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/lov_1
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584285823811390169)
,p_name=>'LOV_1'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/lov_10
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584297318990615933)
,p_name=>'LOV_10'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/lov_2
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584295638252612025)
,p_name=>'LOV_2'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/lov_3
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584295939638612442)
,p_name=>'LOV_3'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/lov_4
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584296141369612948)
,p_name=>'LOV_4'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/lov_5
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584296343101613453)
,p_name=>'LOV_5'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/lov_6
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584296544832613908)
,p_name=>'LOV_6'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/lov_7
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584296714142614506)
,p_name=>'LOV_7'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/lov_8
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584296915873614982)
,p_name=>'LOV_8'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/lov_9
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584297117605615467)
,p_name=>'LOV_9'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/pages_visited
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2567136018491564134)
,p_name=>'PAGES_VISITED'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/q1
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584203839503026155)
,p_name=>'Q1'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/q10
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584205636863034871)
,p_name=>'Q10'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/q2
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584204043312027280)
,p_name=>'Q2'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/q3
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584204245736027992)
,p_name=>'Q3'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/q4
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584204416085028877)
,p_name=>'Q4'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/q5
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584204619202029839)
,p_name=>'Q5'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/q6
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584204829591032793)
,p_name=>'Q6'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/q7
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584205031322033327)
,p_name=>'Q7'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/q8
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584205233054033832)
,p_name=>'Q8'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/q9
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2584205434786034333)
,p_name=>'Q9'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_computations/pages_visited
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(2567153515861648505)
,p_computation_sequence=>1
,p_computation_item=>'PAGES_VISITED'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if instr(:PAGES_VISITED,'':''||wwv_flow.g_flow_step_id) > 0 then',
'   return :PAGES_VISITED;',
'else',
'   return :PAGES_VISITED||'':''||wwv_flow.g_flow_step_id;',
'end if;'))
);
end;
/
prompt --application/shared_components/logic/application_computations/company
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(2902063566051747804)
,p_computation_sequence=>10
,p_computation_item=>'COMPANY'
,p_computation_point=>'AFTER_LOGIN'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'wwv_flow.get_company_name'
,p_compute_when=>'COMPANY'
,p_compute_when_type=>'ITEM_IS_NULL'
,p_computation_error_message=>'Unable to compute workspace name.'
);
end;
/
prompt --application/shared_components/logic/application_computations/f4700_req_new_schema
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(2661751515882325367)
,p_computation_sequence=>10
,p_computation_item=>'F4700_REQ_NEW_SCHEMA'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'wwv_flow_platform.get_preference(''REQ_NEW_SCHEMA'')'
,p_compute_when=>'nvl(wwv_flow_platform.get_preference(''SERVICE_REQUEST_FLOW''),''MANUAL'') <> ''MANUAL'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
wwv_flow_api.create_toplevel_tab(
 p_id=>wwv_flow_api.id(2569953317150029943)
,p_tab_set=>'TOP'
,p_tab_sequence=>20
,p_tab_name=>'T_TOP'
,p_tab_text=>'&PRODUCT_NAME.'
,p_tab_target=>'f?p=&APP_ID.:10:&SESSION.:'
,p_current_on_tabset=>'HOME'
);
end;
/
prompt --application/shared_components/user_interface/lovs/accept_terms
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2638960435990153554)
,p_lov_name=>'ACCEPT TERMS'
,p_lov_query=>'.'||wwv_flow_api.id(2638960435990153554)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2638960640110153556)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'I accept the terms'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_item_protection_level
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3348521895514426469)
,p_lov_name=>'APP ITEM PROTECTION LEVEL'
,p_lov_query=>'.'||wwv_flow_api.id(3348521895514426469)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3348522133089426483)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unrestricted'
,p_lov_return_value=>'UNRESTRICTED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3348522559714426488)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Restricted - May not be set from browser'
,p_lov_return_value=>'RESTRICTED_NO_SET_FROM_BROWSER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_features
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2584581350475987525)
,p_lov_name=>'APPLICATION FEATURES'
,p_lov_query=>'.'||wwv_flow_api.id(2584581350475987525)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8201117263399665)
,p_lov_disp_sequence=>0
,p_lov_disp_value=>'Install Progressive Web App'
,p_lov_return_value=>'PWA'
,p_lov_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-CBList-icon fa fa-package"></span>',
'<span class="a-CBList-details">',
'  <span class="a-CBList-title">#DISPLAY_VALUE#</span>',
'  <span class="a-CBList-desc">&F14.</span>',
'</span>'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2584585288683050797)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'About Page'
,p_lov_return_value=>'HELP_PAGE'
,p_lov_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-CBList-icon fa fa-question-circle-o"></span>',
'<span class="a-CBList-details">',
'  <span class="a-CBList-title">#DISPLAY_VALUE#</span>',
'  <span class="a-CBList-desc">&F05.</span>',
'</span>'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2584581554892987529)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Access Control'
,p_lov_return_value=>'ACCESS_CONTROL'
,p_lov_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-CBList-icon fa fa-key"></span>',
'<span class="a-CBList-details">',
'  <span class="a-CBList-title">#DISPLAY_VALUE#</span>',
'  <span class="a-CBList-desc">&F01.</span>',
'</span>'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2595265355306643813)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Activity Reporting'
,p_lov_return_value=>'ACTIVITY_REPORTING'
,p_lov_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-CBList-icon fa fa-user-chart"></span>',
'<span class="a-CBList-details">',
'  <span class="a-CBList-title">#DISPLAY_VALUE#</span>',
'  <span class="a-CBList-desc">&F12.</span>',
'</span>'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2595262246977607538)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Application Settings'
,p_lov_return_value=>'RENAME_APP'
,p_lov_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-CBList-icon fa fa-window-wrench"></span>',
'<span class="a-CBList-details">',
'  <span class="a-CBList-title">#DISPLAY_VALUE#</span>',
'  <span class="a-CBList-desc">&F04.</span>',
'</span>'))
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2595261094105593761)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Configuration Options'
,p_lov_return_value=>'BUILD_OPTIONS'
,p_lov_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-CBList-icon fa fa-sliders"></span>',
'<span class="a-CBList-details">',
'  <span class="a-CBList-title">#DISPLAY_VALUE#</span>',
'  <span class="a-CBList-desc">&F11.</span>',
'</span>'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2588944153945294189)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Email Framework'
,p_lov_return_value=>'EMAIL_FRAMEWORK'
,p_lov_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-CBList-icon fa fa-envelope-o"></span>',
'<span class="a-CBList-details">',
'  <span class="a-CBList-title">#DISPLAY_VALUE#</span>',
'  <span class="a-CBList-desc">&F13.</span>',
'</span>'))
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2588943841508289264)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Feedback'
,p_lov_return_value=>'APP_FEEDBACK'
,p_lov_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-CBList-icon fa fa-comment-o"></span>',
'<span class="a-CBList-details">',
'  <span class="a-CBList-title">#DISPLAY_VALUE#</span>',
'  <span class="a-CBList-desc">&F06.</span>',
'</span>'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2584585688224050797)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Global Search'
,p_lov_return_value=>'GLOBAL_SEARCH'
,p_lov_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-CBList-icon fa fa-search"></span>',
'<span class="a-CBList-details">',
'  <span class="a-CBList-title">#DISPLAY_VALUE#</span>',
'  <span class="a-CBList-desc">&F09.</span>',
'</span>'))
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2588944406109298885)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Notifications'
,p_lov_return_value=>'APP_NOTIFICATIONS'
,p_lov_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-CBList-icon fa fa-bullhorn"></span>',
'<span class="a-CBList-details">',
'  <span class="a-CBList-title">#DISPLAY_VALUE#</span>',
'  <span class="a-CBList-desc">&F10.</span>',
'</span>'))
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2588945090900315875)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Theme Style Selection'
,p_lov_return_value=>'THEME_SELECTOR'
,p_lov_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-CBList-icon fa fa-paint-brush"></span>',
'<span class="a-CBList-details">',
'  <span class="a-CBList-title">#DISPLAY_VALUE#</span>',
'  <span class="a-CBList-desc">&F07.</span>',
'</span>'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2588944772713304631)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Time Zone Support'
,p_lov_return_value=>'TIMEZONE'
,p_lov_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-CBList-icon fa fa-globe"></span>',
'<span class="a-CBList-details">',
'  <span class="a-CBList-title">#DISPLAY_VALUE#</span>',
'  <span class="a-CBList-desc">&F03.</span>',
'</span>'))
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2584586099877050798)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'User Profiles'
,p_lov_return_value=>'USER_PROFILES'
,p_lov_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="a-CBList-icon fa fa-user"></span>',
'<span class="a-CBList-details">',
'  <span class="a-CBList-title">#DISPLAY_VALUE#</span>',
'  <span class="a-CBList-desc">&F02.</span>',
'</span>'))
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/attribute_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3174322299274441758)
,p_lov_name=>'ATTRIBUTE_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(3174322299274441758)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3174322524978441759)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Application Item'
,p_lov_return_value=>'APPLICATION_ITEM'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sc-app-item'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3174323392321441760)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'List of Values'
,p_lov_return_value=>'LOV'
,p_lov_template=>'#DISPLAY_VALUE#| icon-region-native-list'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3398687230162762158)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Table'
,p_lov_return_value=>'TABLE'
,p_lov_template=>'#DISPLAY_VALUE#| icon-region-native-sql-report'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3174322962526441760)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Table Column'
,p_lov_return_value=>'TABLE_COLUMN'
,p_lov_template=>'#DISPLAY_VALUE#| icon-item-native-text-field'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3174324146228441761)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Report Defaults'
,p_lov_return_value=>'REPORT'
,p_lov_template=>'#DISPLAY_VALUE#| icon-region-native-sql-report'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3174323770579441760)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Interactive Report'
,p_lov_return_value=>'IR'
,p_lov_template=>'#DISPLAY_VALUE#| icon-region-native-ir'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3398698226509801187)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Metric'
,p_lov_return_value=>'METRIC'
,p_lov_template=>'#DISPLAY_VALUE#| icon-region-native-sql-report'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/authentication_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2935038601795333561)
,p_lov_name=>'AUTHENTICATION.OPTIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''AUTHENTICATION_NAME.''|| name_with_prefix) as d,',
'       name_with_prefix      as r',
'  from wwv_flow_native_plugins',
' where plugin_type = ''AUTHENTICATION TYPE''',
'   and (          name_with_prefix = ''NATIVE_APEX_ACCOUNTS''',
'         or (     name_with_prefix = ''NATIVE_IAS_SSO''',
'              and wwv_flow_authentication_dev.can_use_sso_yn = ''Y'' )',
'         or (     name_with_prefix = ''NATIVE_SAML'' )',
'         or (     name_with_prefix = ''NATIVE_DB_ACCOUNTS''',
'              and wwv_flow_authentication_dev.get_internal_authentication <> ''CLOUD_IDM'' ) )',
'union all',
'select wwv_flow_lang.system_message(''AUTHENTICATION_NAME.NATIVE_CLOUD_IDM'') d,',
'       ''NATIVE_CLOUD_IDM'' r',
'  from sys.dual',
' where wwv_flow_authentication_dev.get_internal_authentication = ''CLOUD_IDM'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/available_table_views
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2922437884276753046)
,p_lov_name=>'AVAILABLE_TABLE_VIEWS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/cards_layout_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(13522227592838689)
,p_lov_name=>'CARDS_LAYOUT_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(13522227592838689)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(13522936345838714)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Grid'
,p_lov_return_value=>'GRID'
,p_lov_template=>'#DISPLAY_VALUE#|card-grid'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(13523313089838714)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Float'
,p_lov_return_value=>'FLOAT'
,p_lov_template=>'#DISPLAY_VALUE#|card-float'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(13522520247838713)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Masonry'
,p_lov_return_value=>'MASONRY'
,p_lov_template=>'#DISPLAY_VALUE#|card-masonry'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(13523710239838714)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Horizontal (Row)'
,p_lov_return_value=>'ROW'
,p_lov_template=>'#DISPLAY_VALUE#|card-row'
);
end;
/
prompt --application/shared_components/user_interface/lovs/card_link
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3407941302600627214)
,p_lov_name=>'CARD_LINK'
,p_lov_query=>'.'||wwv_flow_api.id(3407941302600627214)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3407941652601627216)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Full Card'
,p_lov_return_value=>'FULL_CARD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(667437918766960672)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Title'
,p_lov_return_value=>'TITLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_aggregations
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2647168809994648252)
,p_lov_name=>'CHART_AGGREGATIONS'
,p_lov_query=>'.'||wwv_flow_api.id(2647168809994648252)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2647169148117648254)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Column Value'
,p_lov_return_value=>'COLVALUE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2647169545024648256)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Sum'
,p_lov_return_value=>'SUM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2647169964630648256)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Count'
,p_lov_return_value=>'COUNT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/content_delivery_network
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3052348132285494888)
,p_lov_name=>'CONTENT DELIVERY NETWORK'
,p_reference_id=>16362507680404890
,p_lov_query=>'.'||wwv_flow_api.id(3052348132285494888)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3052350732124494891)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Google'
,p_lov_return_value=>'GOOGLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3052351106236494891)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Microsoft'
,p_lov_return_value=>'MICROSOFT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3052351554849494891)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'jQuery'
,p_lov_return_value=>'JQUERY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/default_error_display_location
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3022423575129113550)
,p_lov_name=>'DEFAULT_ERROR_DISPLAY_LOCATION'
,p_lov_query=>'.'||wwv_flow_api.id(3022423575129113550)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3022423851399113560)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Inline with Field and in Notification'
,p_lov_return_value=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3022424234362113562)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Inline with Field'
,p_lov_return_value=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3022424644160115611)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Inline in Notification'
,p_lov_return_value=>'INLINE_WITH_FIELD'
);
end;
/
prompt --application/shared_components/user_interface/lovs/event_name
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3407942220250638520)
,p_lov_name=>'EVENT_NAME'
,p_lov_query=>'.'||wwv_flow_api.id(3407942220250638520)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3407942559318638520)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Event Name'
,p_lov_return_value=>'EVENT_TITLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3661865821826250603)
,p_lov_name=>'FORMAT MASK DYNAMIC'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'from wwv_flow_format_masks'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/form_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2942439030918347706)
,p_lov_name=>'FORM_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(2942439030918347706)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2942440176587347735)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Side by Side'
,p_lov_return_value=>'MD_ON_TABLE_WITH_SELECTOR'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-side-md'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3314917601050455348)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Stacked'
,p_lov_return_value=>'MD_GRID'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-one-md'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_iana_charset
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3032407450767161075)
,p_lov_name=>'I18N_IANA_CHARSET'
,p_reference_id=>144796827445692396
,p_lov_query=>'.'||wwv_flow_api.id(3032407450767161075)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032428899875161137)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unicode UTF-16 Little Endian'
,p_lov_return_value=>'utf-16le'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032429263656161137)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unicode UTF-16 Big Endian'
,p_lov_return_value=>'utf-16be'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032429694795161137)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'US-ASCII'
,p_lov_return_value=>'us-ascii'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032430094554161138)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Arabic ISO-8859-6'
,p_lov_return_value=>'iso-8859-6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032430415842161138)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Arabic Windows 1256'
,p_lov_return_value=>'windows-1256'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032430845699161138)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Chinese Big5'
,p_lov_return_value=>'big5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032431286916161138)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Chinese GBK'
,p_lov_return_value=>'gbk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032431625249161139)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrilic ISO-8859-5'
,p_lov_return_value=>'iso-8859-5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032432039358161139)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrilic KOI8-R'
,p_lov_return_value=>'koi8-r'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032432431696161139)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrilic KOI8-U'
,p_lov_return_value=>'koi8-u'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032432804722161139)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrilic Windows 1251'
,p_lov_return_value=>'windows-1251'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032433258813161140)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Eastern European ISO-8859-2'
,p_lov_return_value=>'iso-8859-2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032433604528161140)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Eastern European Windows 1250'
,p_lov_return_value=>'windows-1250'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032434018695161140)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Greek ISO-8859-7'
,p_lov_return_value=>'iso-8859-7'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032434461200161140)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Greek Windows 1253'
,p_lov_return_value=>'windows-1253'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032434883722161141)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Hebrew ISO-8859-8-i'
,p_lov_return_value=>'iso-8859-8-i'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032435277346161141)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Hebrew Windows 1255'
,p_lov_return_value=>'windows-1255'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032435678437161141)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Japanese EUC'
,p_lov_return_value=>'euc-jp'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032436066715161141)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Japanese Shift JIS'
,p_lov_return_value=>'shift_jis'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032436419408161142)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Korean EUC'
,p_lov_return_value=>'euc-kr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032436830183161142)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Northern European ISO-8859-4'
,p_lov_return_value=>'iso-8859-4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032437259126161142)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Northern European Windows 1257'
,p_lov_return_value=>'windows-1257'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032437659909161143)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Southern European ISO-8859-3'
,p_lov_return_value=>'iso-8859-3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032438037143161143)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Thai TIS-620'
,p_lov_return_value=>'tis-620'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032438462570161143)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Turkish ISO-8859-9'
,p_lov_return_value=>'iso-8859-9'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032438818622161143)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Turkish Windows 1254'
,p_lov_return_value=>'windows-1254'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032439229309161144)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unicode UTF-8'
,p_lov_return_value=>'utf-8'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032439689379161144)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Vietnamese Windows 1258'
,p_lov_return_value=>'windows-1258'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032440086280161144)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Western European ISO-8859-1'
,p_lov_return_value=>'iso-8859-1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3032440420737161144)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Western European Windows 1252'
,p_lov_return_value=>'windows-1252'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_languages_locales
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(261035724719892504)
,p_lov_name=>'I18N_LANGUAGES_LOCALES'
,p_reference_id=>107899321117195063
,p_lov_query=>'.'||wwv_flow_api.id(261035724719892504)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698883713289179941)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Azerbaijani (az)'
,p_lov_return_value=>'az'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698884126619179942)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Afrikaans (af)'
,p_lov_return_value=>'af'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698884565244179942)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (ar)'
,p_lov_return_value=>'ar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698884924134179942)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Algeria) (ar-dz)'
,p_lov_return_value=>'ar-dz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698885318864179942)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Bahrain) (ar-bh)'
,p_lov_return_value=>'ar-bh'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698885766887179943)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Egypt) (ar-eg)'
,p_lov_return_value=>'ar-eg'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698886108263179943)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Iraq) (ar-iq)'
,p_lov_return_value=>'ar-iq'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698886545881179943)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Jordan) (ar-jo)'
,p_lov_return_value=>'ar-jo'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698886921018179943)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Kuwait) (ar-kw)'
,p_lov_return_value=>'ar-kw'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698887365957179944)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Lebanon) (ar-lb)'
,p_lov_return_value=>'ar-lb'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698887727399179944)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Libya) (ar-ly)'
,p_lov_return_value=>'ar-ly'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698888113690179944)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Morocco) (ar-ma)'
,p_lov_return_value=>'ar-ma'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698888532027179944)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Oman) (ar-om)'
,p_lov_return_value=>'ar-om'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698888913277179944)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Qatar) (ar-qa)'
,p_lov_return_value=>'ar-qa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698889384107179945)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Saudi Arabia) (ar-sa)'
,p_lov_return_value=>'ar-sa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698889722411179945)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Syria) (ar-sy)'
,p_lov_return_value=>'ar-sy'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698890160425179945)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Tunisia) (ar-tn)'
,p_lov_return_value=>'ar-tn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698890523219179945)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (U.A.E.) (ar-ae)'
,p_lov_return_value=>'ar-ae'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698890950741179946)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Yemen) (ar-ye)'
,p_lov_return_value=>'ar-ye'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698891320266179946)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Assamese (as)'
,p_lov_return_value=>'as'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698891715182179946)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Basque (eu)'
,p_lov_return_value=>'eu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698892149923179946)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Belarusian (be)'
,p_lov_return_value=>'be'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698892562723179947)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bengali (bn)'
,p_lov_return_value=>'bn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698892921433179947)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bulgarian (bg)'
,p_lov_return_value=>'bg'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698893393986179947)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Catalan (ca)'
,p_lov_return_value=>'ca'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698893787129179947)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (zh)'
,p_lov_return_value=>'zh'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698894178492179947)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (China) (zh-cn)'
,p_lov_return_value=>'zh-cn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698894581951179948)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (Hong Kong SAR) (zh-hk)'
,p_lov_return_value=>'zh-hk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698894957707179948)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (Macau SAR) (zh-mo)'
,p_lov_return_value=>'zh-mo'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698895331642179948)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (Singapore) (zh-sg)'
,p_lov_return_value=>'zh-sg'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698895764458179948)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (Taiwan) (zh-tw)'
,p_lov_return_value=>'zh-tw'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698896174577179949)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Croatian (hr)'
,p_lov_return_value=>'hr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698896507626179949)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Czech (cs)'
,p_lov_return_value=>'cs'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698896934202179949)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Danish (da)'
,p_lov_return_value=>'da'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698897308037179949)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Dutch (Belgium) (nl-be)'
,p_lov_return_value=>'nl-be'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698897764862179949)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Dutch (Netherlands) (nl)'
,p_lov_return_value=>'nl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698898198702179950)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (en)'
,p_lov_return_value=>'en'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698898563982179950)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Australia) (en-au)'
,p_lov_return_value=>'en-au'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698898964515179950)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Belize) (en-bz)'
,p_lov_return_value=>'en-bz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698899303545179950)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Canada) (en-ca)'
,p_lov_return_value=>'en-ca'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698899789641179951)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Ireland) (en-ie)'
,p_lov_return_value=>'en-ie'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698900147536179951)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Jamaica) (en-jm)'
,p_lov_return_value=>'en-jm'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698900587369179951)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (New Zealand) (en-nz)'
,p_lov_return_value=>'en-nz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698900925652179951)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Philippines) (en-ph)'
,p_lov_return_value=>'en-ph'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698901376681179951)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (South Africa) (en-za)'
,p_lov_return_value=>'en-za'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698901701857179952)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Trinidad) (en-tt)'
,p_lov_return_value=>'en-tt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698902138960179952)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (United Kingdom) (en-gb)'
,p_lov_return_value=>'en-gb'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698902559619179952)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (United States) (en-us)'
,p_lov_return_value=>'en-us'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698902952613179952)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Zimbabwe) (en-zw)'
,p_lov_return_value=>'en-zw'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698903363355179953)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Estonian (et)'
,p_lov_return_value=>'et'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698903759460179953)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'FYRO Macedonian (mk)'
,p_lov_return_value=>'mk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698904125547179953)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Faeroese (fo)'
,p_lov_return_value=>'fo'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698904583222179953)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Farsi (fa)'
,p_lov_return_value=>'fa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698904951521179954)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French (Switzerland) (fr-ch)'
,p_lov_return_value=>'fr-ch'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698905355527179954)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Finnish (fi)'
,p_lov_return_value=>'fi'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698905780550179954)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French (Belgium) (fr-be)'
,p_lov_return_value=>'fr-be'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698906104962179954)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French (Canada) (fr-ca)'
,p_lov_return_value=>'fr-ca'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698906552426179956)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French (France) (fr)'
,p_lov_return_value=>'fr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698906978320179956)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French (Luxembourg) (fr-lu)'
,p_lov_return_value=>'fr-lu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698907342846179956)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French (Monaco) (fr-mc)'
,p_lov_return_value=>'fr-mc'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698907754177179956)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Gaelic (gd)'
,p_lov_return_value=>'gd'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698908113975179957)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Galician (gl)'
,p_lov_return_value=>'gl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698908532895179957)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'German (Austria) (de-at)'
,p_lov_return_value=>'de-at'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698908910242179957)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'German (Germany) (de)'
,p_lov_return_value=>'de'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698909392615179957)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'German (Liechtenstein) (de-li)'
,p_lov_return_value=>'de-li'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698909777265179958)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'German (Luxemgourg) (de-lu)'
,p_lov_return_value=>'de-lu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698910143726179958)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'German (Switzerland) (de-ch)'
,p_lov_return_value=>'de-ch'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698910501253179958)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Greek (el)'
,p_lov_return_value=>'el'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698910916781179958)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Gujarati (gu)'
,p_lov_return_value=>'gu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698911366329179958)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hebrew (he)'
,p_lov_return_value=>'he'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698911707115179959)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hindi (hi)'
,p_lov_return_value=>'hi'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698912139872179959)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hungarian (hu)'
,p_lov_return_value=>'hu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698912538551179959)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Icelandic (is)'
,p_lov_return_value=>'is'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698912985780179959)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Indonesian (id)'
,p_lov_return_value=>'id'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698913394987179960)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italian (Italy) (it)'
,p_lov_return_value=>'it'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698913744652179960)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italian (Switzerland) (it-ch)'
,p_lov_return_value=>'it-ch'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698914118619179960)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Japanese (ja)'
,p_lov_return_value=>'ja'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698914556956179960)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kannada (kn)'
,p_lov_return_value=>'kn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698914999046179961)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kazakh (kk)'
,p_lov_return_value=>'kk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698915329936179961)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Konkani (kok)'
,p_lov_return_value=>'kok'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698915752211179961)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Korean (ko)'
,p_lov_return_value=>'ko'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698916194109179961)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kyrgyz (kz)'
,p_lov_return_value=>'kz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698916565719179961)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Latvian (lv)'
,p_lov_return_value=>'lv'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698916984728179962)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lithuanian (lt)'
,p_lov_return_value=>'lt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698917365042179962)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Malay (Malaysia) (ms)'
,p_lov_return_value=>'ms'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698917756432179962)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Malayalam (ml)'
,p_lov_return_value=>'ml'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698918186430179962)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Maltese (mt)'
,p_lov_return_value=>'mt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698918528206179963)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Marathi (mr)'
,p_lov_return_value=>'mr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698918903873179963)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Nepali (India) (ne)'
,p_lov_return_value=>'ne'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698919374435179963)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Norwegian (Bokmal) (nb-no)'
,p_lov_return_value=>'nb-no'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698919716607179963)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Norwegian (Bokmal) (no)'
,p_lov_return_value=>'no'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698920168842179964)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Norwegian (Nynorsk) (nn-no)'
,p_lov_return_value=>'nn-no'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698920524856179964)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Oriya (or)'
,p_lov_return_value=>'or'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698920926726179964)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Polish (pl)'
,p_lov_return_value=>'pl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698921316735179964)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Portuguese (Brazil) (pt-br)'
,p_lov_return_value=>'pt-br'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698921760269179964)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Portuguese (Portugal) (pt)'
,p_lov_return_value=>'pt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698922109878179965)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Punjabi (pa)'
,p_lov_return_value=>'pa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698922512073179965)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Romanian (ro)'
,p_lov_return_value=>'ro'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698922992444179965)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Russian (ru)'
,p_lov_return_value=>'ru'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698923353711179965)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Russian (Moldova) (ru-md)'
,p_lov_return_value=>'ru-md'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698923782122179966)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Serbian (sr)'
,p_lov_return_value=>'sr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698924130152179966)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Slovak (sk)'
,p_lov_return_value=>'sk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698924543081179966)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Slovenian (sl)'
,p_lov_return_value=>'sl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698924977947179967)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Argentina) (es-ar)'
,p_lov_return_value=>'es-ar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698925338639179967)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Bolivia) (es-bo)'
,p_lov_return_value=>'es-bo'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698925713684179967)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Chile) (es-cl)'
,p_lov_return_value=>'es-cl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698926177585179967)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Colombia) (es-co)'
,p_lov_return_value=>'es-co'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698926587236179967)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Costa Rica) (es-cr)'
,p_lov_return_value=>'es-cr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698926914058179968)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Dominican Republic) (es-do)'
,p_lov_return_value=>'es-do'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698927318637179968)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Ecuador) (es-ec)'
,p_lov_return_value=>'es-ec'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698927737159179968)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (El Salvador) (es-sv)'
,p_lov_return_value=>'es-sv'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698928109603179968)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Guatemala) (es-gt)'
,p_lov_return_value=>'es-gt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698928508849179969)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Honduras) (es-hn)'
,p_lov_return_value=>'es-hn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698928952284179969)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Mexico) (es-mx)'
,p_lov_return_value=>'es-mx'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698929341044179969)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Nicaragua) (es-ni)'
,p_lov_return_value=>'es-ni'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698929700283179969)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Panama) (es-pa)'
,p_lov_return_value=>'es-pa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698930111118179970)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Paraguay) (es-py)'
,p_lov_return_value=>'es-py'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698930553605179970)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Peru) (es-pe)'
,p_lov_return_value=>'es-pe'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698930938034179970)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Puerto Rico) (es-pr)'
,p_lov_return_value=>'es-pr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698931394992179970)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Traditional Sort) (es)'
,p_lov_return_value=>'es'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698931743130179970)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (United States) (es-us)'
,p_lov_return_value=>'es-us'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698932191621179971)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Uruguay) (es-uy)'
,p_lov_return_value=>'es-uy'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698932521498179971)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Venezuela) (es-ve)'
,p_lov_return_value=>'es-ve'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698932948369179971)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Swedish (sv)'
,p_lov_return_value=>'sv'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698933249493179971)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Swedish (Finland) (sv-fi)'
,p_lov_return_value=>'sv-fi'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698933608506179971)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tamil (ta)'
,p_lov_return_value=>'ta'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698934056501179972)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Telugu (te)'
,p_lov_return_value=>'te'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698934436991179972)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Thai (th)'
,p_lov_return_value=>'th'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698934811700179972)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Turkish (tr)'
,p_lov_return_value=>'tr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698935235483179972)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ukrainian (uk)'
,p_lov_return_value=>'uk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698935620939179973)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Urdu (ur)'
,p_lov_return_value=>'ur'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698936051330179973)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Uzbek (uz)'
,p_lov_return_value=>'uz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698936467742179973)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Vietnamese (vi)'
,p_lov_return_value=>'vi'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698936864835179973)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Irish (ga)'
,p_lov_return_value=>'ga'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698937247802179973)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Welsh (cy)'
,p_lov_return_value=>'cy'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698937616681179974)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Swahili (sw)'
,p_lov_return_value=>'sw'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698938064029179974)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Albanian'
,p_lov_return_value=>'sq'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698938437113179974)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Armenian'
,p_lov_return_value=>'hy'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_form_y
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2595628838376488076)
,p_lov_name=>'INCLUDE_FORM_Y'
,p_lov_query=>'.'||wwv_flow_api.id(2595628838376488076)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2595629167546488077)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Include Form'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_report_y
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(353723515527117365)
,p_lov_name=>'INCLUDE_REPORT_Y'
,p_lov_query=>'.'||wwv_flow_api.id(353723515527117365)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(353723818904117366)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Include Report'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/is_administrative
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2996645622600931087)
,p_lov_name=>'IS ADMINISTRATIVE'
,p_lov_query=>'.'||wwv_flow_api.id(2996645622600931087)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2996645967177931093)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Set as Administration Page'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/is_homepage
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2639480030873536264)
,p_lov_name=>'IS_HOMEPAGE'
,p_lov_query=>'.'||wwv_flow_api.id(2639480030873536264)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2639480370023536266)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Set as Home Page'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_display_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3428075204157397882)
,p_lov_name=>'ITEM_DISPLAY_TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name d, name_with_prefix r',
'from wwv_flow_native_plugins',
'where plugin_type = ''ITEM TYPE''',
'and name_with_prefix in (',
'    ''NATIVE_TEXT_FIELD'',',
'    ''NATIVE_TEXTAREA'',',
'    ''NATIVE_SELECT_LIST'',',
'    ''NATIVE_POPUP_LOV'',',
'    ''NATIVE_RADIOGROUP'',',
'    ''NATIVE_CHECKBOX'',',
'    ''NATIVE_YES_NO'',',
'    ''NATIVE_HIDDEN'',',
'    ''NATIVE_DATE_PICKER_JET'',',
'    ''NATIVE_NUMBER_FIELD'',',
'    ''NATIVE_TEXTAREA'',',
'    ''NATIVE_FILE'')',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/jet_chart_gallery
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2639572067402672315)
,p_lov_name=>'JET_CHART_GALLERY'
,p_lov_query=>'.'||wwv_flow_api.id(2639572067402672315)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2639572308217672319)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Area'
,p_lov_return_value=>'area'
,p_lov_template=>'#DISPLAY_VALUE#|chart-area'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2639572724969672320)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Bar'
,p_lov_return_value=>'bar'
,p_lov_template=>'#DISPLAY_VALUE#|chart-bar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2639574313919672321)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Donut'
,p_lov_return_value=>'donut'
,p_lov_template=>'#DISPLAY_VALUE#|chart-donut'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2639575505658672323)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Line'
,p_lov_return_value=>'line'
,p_lov_template=>'#DISPLAY_VALUE#|chart-line'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2639575903894672325)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Line with Area'
,p_lov_return_value=>'lineWithArea'
,p_lov_template=>'#DISPLAY_VALUE#|chart-line-area'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2639576794816672326)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Pie'
,p_lov_return_value=>'pie'
,p_lov_template=>'#DISPLAY_VALUE#|chart-pie'
);
end;
/
prompt --application/shared_components/user_interface/lovs/jet_chart_gallery_select
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2646907365505462337)
,p_lov_name=>'JET_CHART_GALLERY_SELECT'
,p_lov_query=>'.'||wwv_flow_api.id(2646907365505462337)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2646907697589462341)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Area'
,p_lov_return_value=>'area'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2646908033307462344)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Bar'
,p_lov_return_value=>'bar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2646908742159462345)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Line'
,p_lov_return_value=>'line'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2646909596402462345)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Pie'
,p_lov_return_value=>'pie'
);
end;
/
prompt --application/shared_components/user_interface/lovs/language_derived_from
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3030571620235275777)
,p_lov_name=>'LANGUAGE_DERIVED_FROM'
,p_lov_query=>'.'||wwv_flow_api.id(3030571620235275777)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3030571910025275781)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'No NLS (Application not translated)'
,p_lov_return_value=>'0'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3030572315095275783)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Application Primary Language'
,p_lov_return_value=>'FLOW_PRIMARY_LANGUAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3030572762231275784)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Browser (use browser language preference)'
,p_lov_return_value=>'BROWSER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3030573197044275784)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Application Preference (use FSP_LANGUAGE_PREFERENCE)'
,p_lov_return_value=>'FLOW_PREFERENCE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3030573587174275784)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Item Preference (use item containing preference)'
,p_lov_return_value=>'ITEM_PREFERENCE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3030573997459275784)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Session'
,p_lov_return_value=>'SESSION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_flows
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3674102416840483201)
,p_lov_name=>'LIST FLOWS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_available_schemas
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2583404809878256688)
,p_lov_name=>'LIST_AVAILABLE_SCHEMAS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(schema) a, schema b',
'from   wwv_flow_company_schemas',
'where  security_group_id = :flow_security_group_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/lov_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3363550887091219855)
,p_lov_name=>'LOV TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(3363550887091219855)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3363551930042219856)
,p_lov_disp_sequence=>0
,p_lov_disp_value=>'Structured'
,p_lov_return_value=>'STRUCTURED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3363551185259219856)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Dynamic'
,p_lov_return_value=>'DYNAMIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3363551549294219856)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Static'
,p_lov_return_value=>'STATIC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/map_region_geometry_column_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4053243666374435)
,p_lov_name=>'MAP_REGION_GEOMETRY_COLUMN_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(4053243666374435)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4053546899374449)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Geometry Column'
,p_lov_return_value=>'GEOMETRY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4053958565374450)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Two Numeric Columns'
,p_lov_return_value=>'NUMBER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/map_region_layer_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3749589329218593)
,p_lov_name=>'MAP_REGION_LAYER_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(3749589329218593)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3749817614218609)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Points'
,p_lov_return_value=>'POINT'
,p_lov_template=>'#DISPLAY_VALUE#|map-points'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3750211117218610)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Lines'
,p_lov_return_value=>'LINE'
,p_lov_template=>'#DISPLAY_VALUE#|map-lines'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3750605580218610)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Polygons'
,p_lov_return_value=>'POLYGON'
,p_lov_template=>'#DISPLAY_VALUE#|map-polygons'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3751020180218610)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Heat Map'
,p_lov_return_value=>'HEATMAP'
,p_lov_template=>'#DISPLAY_VALUE#|map-heatmap'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3751473242218610)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Extruded Polygons'
,p_lov_return_value=>'POLYGON_3D'
,p_lov_template=>'#DISPLAY_VALUE#|map-extruded-polgygons'
);
end;
/
prompt --application/shared_components/user_interface/lovs/nav_position
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2595597506957104820)
,p_lov_name=>'NAV_POSITION'
,p_lov_query=>'.'||wwv_flow_api.id(2595597506957104820)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2595597823255104834)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Side'
,p_lov_return_value=>'SIDE'
,p_lov_template=>'<span class="a-Icon icon-nav-side" aria-hidden="true"></span> #DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2595598259378104835)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Top'
,p_lov_return_value=>'TOP'
,p_lov_template=>'<span class="a-Icon icon-nav-top" aria-hidden="true"></span> #DISPLAY_VALUE#'
);
end;
/
prompt --application/shared_components/user_interface/lovs/new_or_existing_schema
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2709274728272946842)
,p_lov_name=>'NEW_OR_EXISTING_SCHEMA'
,p_lov_query=>'.'||wwv_flow_api.id(2709274728272946842)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2709275016281946843)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Use an existing schema from the database'
,p_lov_return_value=>'NO'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_lov_disp_cond=>'F4700_REQ_NEW_SCHEMA'
,p_lov_disp_cond2=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2709275215977946843)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Request a new schema'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1000_more_page_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(599910129386444402)
,p_lov_name=>'P1000_MORE_PAGE_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(599910129386444402)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(599919494157448944)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Classic Report'
,p_lov_return_value=>'CLASSIC_REPORT'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-classic-rpt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3900754663275661)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Multiple Reports'
,p_lov_return_value=>'MULTI_RPT'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-interactive-rpt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(599914473819444406)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Timeline'
,p_lov_return_value=>'TIMELINE'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-timeline'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_lov_disp_cond=>':P1_THEME_TYPE'
,p_lov_disp_cond2=>'CUSTOM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4839782074400363)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Wizard'
,p_lov_return_value=>'WIZARD'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-wizard'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1000_page_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2595619325504357130)
,p_lov_name=>'P1000_PAGE_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(2595619325504357130)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2595619721367357132)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Blank'
,p_lov_return_value=>'BLANK'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-blank'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2595622554281357135)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Calendar'
,p_lov_return_value=>'CALENDAR'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-calendar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3314495786637316189)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Cards'
,p_lov_return_value=>'CARDS'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-cards'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_lov_disp_cond=>'P1_THEME_TYPE'
,p_lov_disp_cond2=>'CUSTOM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2595620547567357132)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Chart'
,p_lov_return_value=>'CHART'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-chart'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2595620169572357132)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Dashboard'
,p_lov_return_value=>'DASHBOARD'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-dashboard'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(599817715593042666)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Faceted Search'
,p_lov_return_value=>'FACETED_SEARCH'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-faceted-search'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4838887966389682)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Smart Filters'
,p_lov_return_value=>'SMART_FILTERS'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-smart-filters'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3314495333442316187)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Form'
,p_lov_return_value=>'FORM'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-form'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2595621784230357135)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Interactive Grid'
,p_lov_return_value=>'INTERACTIVE_GRID'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-interactive-grid'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2595621327200357134)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Interactive Report'
,p_lov_return_value=>'REPORT'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-interactive-rpt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3755880118235168)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Map'
,p_lov_return_value=>'MAP'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-map'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2595622950759357135)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Master Detail'
,p_lov_return_value=>'MASTER_DETAIL'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-master-detail'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1020_fk_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(193526090453792695)
,p_lov_name=>'P1020_FK_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.child_column, c.position',
'from wwv_dictionary_cache_fkcon c',
'where c.child_table = :P1020_TABLE',
'and c.child_owner = :P1_SCHEMA',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'CHILD_COLUMN'
,p_display_column_name=>'CHILD_COLUMN'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'POSITION'
,p_default_sort_direction=>'ASC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1040_detail_tables
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(193968510657395041)
,p_lov_name=>'P1040_DETAIL_TABLES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select child_table',
'from wwv_dictionary_cache_fkcon c',
'where c.parent_table = :P1040_TABLE',
'and c.parent_owner = :P1_SCHEMA',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'CHILD_TABLE'
,p_display_column_name=>'CHILD_TABLE'
,p_default_sort_column_name=>'CHILD_TABLE'
,p_default_sort_direction=>'ASC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1140_report_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(599933630533543253)
,p_lov_name=>'P1140_REPORT_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(599933630533543253)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(599934700887543254)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Report'
,p_lov_return_value=>'CR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(599935195629543254)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Cards'
,p_lov_return_value=>'CARD'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p120_app_colors
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2698004887684998460)
,p_lov_name=>'P120_APP_COLORS'
,p_lov_query=>'.'||wwv_flow_api.id(2698004887684998460)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2698005120905998460)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Blue'
,p_lov_return_value=>'#309FDB'
,p_lov_template=>'<span class="app-color app-color-1" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2698005566340998461)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Light Blue'
,p_lov_return_value=>'#2EBFBC'
,p_lov_template=>'<span class="app-color app-color-2" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2698005902074998461)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Green'
,p_lov_return_value=>'#81BB5F'
,p_lov_template=>'<span class="app-color app-color-3" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2698006373906998463)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Orange'
,p_lov_return_value=>'#ED813E'
,p_lov_template=>'<span class="app-color app-color-4" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2698006700015998463)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Red'
,p_lov_return_value=>'#E95B54'
,p_lov_template=>'<span class="app-color app-color-5" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2698008277439008881)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Pink'
,p_lov_return_value=>'#CA589D'
,p_lov_template=>'<span class="app-color app-color-6" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2698008693252008882)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Purple'
,p_lov_return_value=>'#5A68AD'
,p_lov_template=>'<span class="app-color app-color-7" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2698009071872008882)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Grey'
,p_lov_return_value=>'#6E8598'
,p_lov_template=>'<span class="app-color app-color-8" aria-label="#DISPLAY_VALUE#"></span>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p120_app_icons
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2672360045214033881)
,p_lov_name=>'P120_APP_ICONS'
,p_lov_query=>'.'||wwv_flow_api.id(2672360045214033881)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2672360783542033891)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Folder'
,p_lov_return_value=>'folder'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-folder'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2672361118269033891)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Spreadsheet'
,p_lov_return_value=>'spreadsheet'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-spreadsheet'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2672361590756033892)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Messages'
,p_lov_return_value=>'talk-bubbles'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-talk-bubbles'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2699145586411626416)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Analytics'
,p_lov_return_value=>'analytics'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-analytics'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2699146013974630462)
,p_lov_disp_sequence=>24
,p_lov_disp_value=>'Bar Chart'
,p_lov_return_value=>'bar-line-chart'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-bar-line-chart'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2699146300507631479)
,p_lov_disp_sequence=>34
,p_lov_disp_value=>'Calendar'
,p_lov_return_value=>'calendar'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-calendar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2699147272435638605)
,p_lov_disp_sequence=>44
,p_lov_disp_value=>'Cloud'
,p_lov_return_value=>'cloud'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-cloud'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2699147530894639704)
,p_lov_disp_sequence=>54
,p_lov_disp_value=>'Cubes'
,p_lov_return_value=>'cubes'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-cubes'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2672360336003033886)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Mail'
,p_lov_return_value=>'email'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-email'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2699147943869640428)
,p_lov_disp_sequence=>64
,p_lov_disp_value=>'Database'
,p_lov_return_value=>'database'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-database'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2699148332077641373)
,p_lov_disp_sequence=>74
,p_lov_disp_value=>'Gear'
,p_lov_return_value=>'gear'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-gear'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2699148765248642204)
,p_lov_disp_sequence=>84
,p_lov_disp_value=>'Graphs'
,p_lov_return_value=>'graphs'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-graphs'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2699149018852643303)
,p_lov_disp_sequence=>94
,p_lov_disp_value=>'Map'
,p_lov_return_value=>'map'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-map'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2699149413407644014)
,p_lov_disp_sequence=>104
,p_lov_disp_value=>'People'
,p_lov_return_value=>'people'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-people'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2699150110351645207)
,p_lov_disp_sequence=>114
,p_lov_disp_value=>'Smiley'
,p_lov_return_value=>'smiley'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-smiley'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2699150731371656095)
,p_lov_disp_sequence=>124
,p_lov_disp_value=>'To Do'
,p_lov_return_value=>'todo'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-todo'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2702987570335615680)
,p_lov_disp_sequence=>134
,p_lov_disp_value=>'Bug'
,p_lov_return_value=>'bug'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-bug'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2702988039145618805)
,p_lov_disp_sequence=>144
,p_lov_disp_value=>'Dots'
,p_lov_return_value=>'dots'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-dots'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2702988335963620469)
,p_lov_disp_sequence=>154
,p_lov_disp_value=>'Gauge'
,p_lov_return_value=>'gauge'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-gauge'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2702989530631642963)
,p_lov_disp_sequence=>164
,p_lov_disp_value=>'Grid'
,p_lov_return_value=>'grid'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-grid'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2702990096402645004)
,p_lov_disp_sequence=>174
,p_lov_disp_value=>'Pencil and Paper'
,p_lov_return_value=>'pencil-paper'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-pencil-paper'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2702990316302646280)
,p_lov_disp_sequence=>184
,p_lov_disp_value=>'Toolbox'
,p_lov_return_value=>'toolbox'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-toolbox'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2702990629320647262)
,p_lov_disp_sequence=>194
,p_lov_disp_value=>'Wrench'
,p_lov_return_value=>'wrench'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-wrench'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2702994227074670326)
,p_lov_disp_sequence=>204
,p_lov_disp_value=>'Activity'
,p_lov_return_value=>'activity'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-activity'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174262117726416555)
,p_lov_disp_sequence=>300
,p_lov_disp_value=>'Stopwatch'
,p_lov_return_value=>'stopwatch'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-stopwatch'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174262563826416555)
,p_lov_disp_sequence=>301
,p_lov_disp_value=>'Pie Chart'
,p_lov_return_value=>'pie-chart'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-pie-chart'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174262934715416555)
,p_lov_disp_sequence=>302
,p_lov_disp_value=>'Checkmark'
,p_lov_return_value=>'check-circle'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-check-circle'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174263328775416556)
,p_lov_disp_sequence=>303
,p_lov_disp_value=>'Rocket'
,p_lov_return_value=>'rocket'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-rocket'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174263755285416556)
,p_lov_disp_sequence=>304
,p_lov_disp_value=>'Shield'
,p_lov_return_value=>'shield'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-shield'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174264105771416556)
,p_lov_disp_sequence=>305
,p_lov_disp_value=>'Lightbulb'
,p_lov_return_value=>'lightbulb'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-lightbulb'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174264503042416556)
,p_lov_disp_sequence=>306
,p_lov_disp_value=>'Lock'
,p_lov_return_value=>'lock'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-lock'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174264993774416557)
,p_lov_disp_sequence=>307
,p_lov_disp_value=>'Ship'
,p_lov_return_value=>'ship'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-ship'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1_navigation_position
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2621239147915611502)
,p_lov_name=>'P1_NAVIGATION_POSITION'
,p_lov_query=>'.'||wwv_flow_api.id(2621239147915611502)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2621239461519611503)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Side Menu'
,p_lov_return_value=>'SIDE'
,p_lov_template=>'#DISPLAY_VALUE# | ca-Icon nav-icon nav-side'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2621239868592611505)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Top Menu'
,p_lov_return_value=>'TOP'
,p_lov_template=>'#DISPLAY_VALUE# | ca-Icon nav-icon nav-top'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(253970343865000428)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Mega Menu'
,p_lov_return_value=>'MEGA'
,p_lov_template=>'#DISPLAY_VALUE# | ca-Icon nav-icon nav-mega-menu'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1_theme_styles
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2595731361215290332)
,p_lov_name=>'P1_THEME_STYLES'
,p_lov_query=>'.'||wwv_flow_api.id(2595731361215290332)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2595731647478290334)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Vita'
,p_lov_return_value=>'Vita'
,p_lov_template=>'#DISPLAY_VALUE# | theme-icon theme-vita'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2595732072323290334)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Vita - Dark'
,p_lov_return_value=>'Vita - Dark'
,p_lov_template=>'#DISPLAY_VALUE# | theme-icon theme-vita-dark'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2595732485910290335)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Redwood Light'
,p_lov_return_value=>'Redwood Light'
,p_lov_template=>'#DISPLAY_VALUE# | theme-icon theme-redwood'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3286815898649753964)
,p_lov_name=>'PAGE_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(3286815898649753964)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3286816136407753971)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Blank'
,p_lov_return_value=>'BLANK'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-blank'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3286816423426753976)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Dashboard'
,p_lov_return_value=>'DASHBOARD'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-dashboard'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2595567847775637051)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Chart'
,p_lov_return_value=>'CHART'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-dashboard'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2561899148127324757)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Classic Report'
,p_lov_return_value=>'CLASSIC_RPT'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-classic-rpt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2561902001788398153)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Interactive Report'
,p_lov_return_value=>'INTERACTIVE_RPT'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-interactive-rpt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2577864430538034696)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Interactive Grid'
,p_lov_return_value=>'INTERACTIVE_GRID'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-interactive-grid'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2577864810590034698)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Faceted Search'
,p_lov_return_value=>'FACETED_SEARCH'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-card-faceted-search'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2588628706152153910)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Calendar'
,p_lov_return_value=>'CALENDAR'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-calendar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2588629041652155067)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Form'
,p_lov_return_value=>'FORM'
,p_lov_template=>'#DISPLAY_VALUE#| page-icon page-form'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3345504345772661039)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Master Detail'
,p_lov_return_value=>'MASTER_DETAIL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3447755827550882639)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Cards'
,p_lov_return_value=>'CARDS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3447756177637884382)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Timeline'
,p_lov_return_value=>'TIMELINE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3447917238443966847)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'Wizard'
,p_lov_return_value=>'WIZARD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5000408550056154)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'Map'
,p_lov_return_value=>'MAP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4851809191812526)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'Smart Filters'
,p_lov_return_value=>'SMART_FILTERS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pagination
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3348566714295666169)
,p_lov_name=>'PAGINATION'
,p_lov_query=>'.'||wwv_flow_api.id(3348566714295666169)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3348567074901666172)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Row Ranges X to Y of Z'
,p_lov_return_value=>'ROWS_X_TO_Y_OF_Z'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3348567471986666172)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>'Row Ranges X to Y'
,p_lov_return_value=>'ROWS_X_TO_Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2595616854306352005)
,p_lov_name=>'REPORT_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(2595616854306352005)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2595617121416352006)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Interactive Report'
,p_lov_return_value=>'INTERACTIVE_RPT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2595617998727352007)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Classic Report'
,p_lov_return_value=>'CLASSIC_RPT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/right_to_left
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(560908550288645029)
,p_lov_name=>'RIGHT-TO-LEFT'
,p_lov_query=>'.'||wwv_flow_api.id(560908550288645029)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(560908890865645033)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Left-To-Right'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(560909229625645034)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Right-To-Left'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/run_when_creating_app
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3011477941821019938)
,p_lov_name=>'RUN WHEN CREATING APP'
,p_lov_query=>'.'||wwv_flow_api.id(3011477941821019938)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3011478276914019939)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Run when creating application'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/seconds
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3052299639682461644)
,p_lov_name=>'SECONDS'
,p_reference_id=>218750809842831008
,p_lov_query=>'.'||wwv_flow_api.id(3052299639682461644)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3052313333207461705)
,p_lov_disp_sequence=>0
,p_lov_disp_value=>'10 seconds'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3052313763928461705)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'1 minute'
,p_lov_return_value=>'60'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3052314194318461706)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'10 minutes'
,p_lov_return_value=>'600'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3052314561907461706)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'30 minutes'
,p_lov_return_value=>'1800'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3052314905802461706)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'1 hour'
,p_lov_return_value=>'3600'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3052315380890461706)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'2 hours'
,p_lov_return_value=>'7200'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3052315720757461707)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'3 hours'
,p_lov_return_value=>'10800'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3052316192741461707)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'4 hours'
,p_lov_return_value=>'14400'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3052316593027461707)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'6 hours'
,p_lov_return_value=>'21600'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3052316902496461707)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'12 hours'
,p_lov_return_value=>'43200'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3052317383400461708)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'1 day'
,p_lov_return_value=>'86400'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3052317744167461708)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'2 days'
,p_lov_return_value=>'172800'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3052318196277461708)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'3 days'
,p_lov_return_value=>'259200'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3052318503570461709)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'4 days'
,p_lov_return_value=>'345600'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3052318964100461709)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'1 week'
,p_lov_return_value=>'604800'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3052319386375461709)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'2 weeks'
,p_lov_return_value=>'1209600'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3052319724314461709)
,p_lov_disp_sequence=>155
,p_lov_disp_value=>'4 Weeks'
,p_lov_return_value=>'2419200'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3052320114213461710)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'10 Weeks'
,p_lov_return_value=>'6048000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3052320587074461710)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'1 Year'
,p_lov_return_value=>'31536000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/source_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2593539478572840546)
,p_lov_name=>'SOURCE_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(2593539478572840546)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2593540111329840547)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Table or View'
,p_lov_return_value=>'TABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2593539775589840547)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'SQL Query'
,p_lov_return_value=>'SQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/translations
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2928230523118997204)
,p_lov_name=>'TRANSLATIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.translated_lang_name as lang_name, f.flow_language',
'from ( select flow_language',
'          from wwv_flows f',
'         where id = :APP_ID',
'         union',
'        select flow_language',
'          from wwv_flows f',
'         where id in ( select translation_flow_id',
'                         from wwv_flow_language_map',
'                        where primary_language_flow_id = :APP_ID )',
'      ) f,',
'      wwv_flow_languages l',
'where f.flow_language = l.lang_id',
'order by nlssort( l.translated_lang_name, ''NLS_SORT=binary'' )'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/wizard_page_mode
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3315174268901073640)
,p_lov_name=>'WIZARD_PAGE_MODE'
,p_lov_query=>'.'||wwv_flow_api.id(3315174268901073640)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3315174580312073643)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Modal Dialog'
,p_lov_return_value=>'MODAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3315174903811073644)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Normal Page'
,p_lov_return_value=>'NORMAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2660244068801532757)
,p_lov_name=>'YES_NO'
,p_lov_query=>'.'||wwv_flow_api.id(2660244068801532757)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2660244358492532761)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2660244720718532764)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(2704744005996589822)
,p_theme_id=>101
,p_name=>'APEX 5.0 - Dialog'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'<!--[if lt IE 9]><script src="#IMAGE_PREFIX#libraries/apex/html5_ie.js"></script><![endif]-->',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140009111066349550)
,p_page_template_id=>wwv_flow_api.id(2704744005996589822)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140009254080349550)
,p_page_template_id=>wwv_flow_api.id(2704744005996589822)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140009388504349550)
,p_page_template_id=>wwv_flow_api.id(2704744005996589822)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(2970811450590621114)
,p_theme_id=>101
,p_name=>'APEX 5.0 - Right Side Bar'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'<!--[if lt IE 9]><script src="#IMAGE_PREFIX#libraries/apex/html5_ie.js"></script><![endif]-->',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(4482336506897000055)
,p_page_template_id=>wwv_flow_api.id(2970811450590621114)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(4482336688063000055)
,p_page_template_id=>wwv_flow_api.id(2970811450590621114)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(4482336765466000055)
,p_page_template_id=>wwv_flow_api.id(2970811450590621114)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(4482336872711000055)
,p_page_template_id=>wwv_flow_api.id(2970811450590621114)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(4482336976448000055)
,p_page_template_id=>wwv_flow_api.id(2970811450590621114)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(4482337049696000055)
,p_page_template_id=>wwv_flow_api.id(2970811450590621114)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(4482337131179000055)
,p_page_template_id=>wwv_flow_api.id(2970811450590621114)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(3221353480673840388)
,p_theme_id=>101
,p_name=>'APEX 5.0 - No Side Bar'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'<!--[if lt IE 9]><script src="#IMAGE_PREFIX#libraries/apex/html5_ie.js"></script><![endif]-->',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140009486353349549)
,p_page_template_id=>wwv_flow_api.id(3221353480673840388)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140009566990349549)
,p_page_template_id=>wwv_flow_api.id(3221353480673840388)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140009668886349549)
,p_page_template_id=>wwv_flow_api.id(3221353480673840388)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140009754714349549)
,p_page_template_id=>wwv_flow_api.id(3221353480673840388)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140009871222349549)
,p_page_template_id=>wwv_flow_api.id(3221353480673840388)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140009900987349548)
,p_page_template_id=>wwv_flow_api.id(3221353480673840388)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140010023262349548)
,p_page_template_id=>wwv_flow_api.id(3221353480673840388)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(3272976625713321802)
,p_theme_id=>101
,p_name=>'APEX 5.1.1 - Page Wizard Dialog'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7]><html class="no-js lt-ie10 lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7]><html class="no-js lt-ie10 lt-ie9 lt-ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8]><html class="no-js lt-ie10 lt-ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9]><html class="no-js lt-ie10" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if gt IE 9]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'',
'<head>',
'',
'  <meta charset="utf-8">  ',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'#TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'#PAGE_CSS#',
'',
'    ',
'#APEX_JAVASCRIPT# ',
'<!--[if lt IE 9]><script src="#IMAGE_PREFIX#libraries/apex/html5_ie.js"></script><![endif]-->',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'    ',
'    ',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'auto'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140017184587349540)
,p_page_template_id=>wwv_flow_api.id(3272976625713321802)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140017222963349540)
,p_page_template_id=>wwv_flow_api.id(3272976625713321802)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140017317670349539)
,p_page_template_id=>wwv_flow_api.id(3272976625713321802)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(3273510885686244662)
,p_theme_id=>101
,p_name=>'APEX 5.0 - Edit Screen'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'<!--[if lt IE 9]><script src="#IMAGE_PREFIX#libraries/apex/html5_ie.js"></script><![endif]-->',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140010110573349548)
,p_page_template_id=>wwv_flow_api.id(3273510885686244662)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140010286995349548)
,p_page_template_id=>wwv_flow_api.id(3273510885686244662)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140010363230349548)
,p_page_template_id=>wwv_flow_api.id(3273510885686244662)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140010465886349548)
,p_page_template_id=>wwv_flow_api.id(3273510885686244662)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140010553081349548)
,p_page_template_id=>wwv_flow_api.id(3273510885686244662)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140010682984349547)
,p_page_template_id=>wwv_flow_api.id(3273510885686244662)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(4482336307736000055)
,p_page_template_id=>wwv_flow_api.id(3273510885686244662)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(4482336471391000055)
,p_page_template_id=>wwv_flow_api.id(3273510885686244662)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(3286599848719423369)
,p_theme_id=>101
,p_name=>'APEX 5.0 - Wizard Page'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'<!--[if lt IE 9]><script src="#IMAGE_PREFIX#libraries/apex/html5_ie.js"></script><![endif]-->',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140014072912349543)
,p_page_template_id=>wwv_flow_api.id(3286599848719423369)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140014167954349543)
,p_page_template_id=>wwv_flow_api.id(3286599848719423369)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140014204985349543)
,p_page_template_id=>wwv_flow_api.id(3286599848719423369)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140014308671349543)
,p_page_template_id=>wwv_flow_api.id(3286599848719423369)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140014466429349543)
,p_page_template_id=>wwv_flow_api.id(3286599848719423369)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140014598179349543)
,p_page_template_id=>wwv_flow_api.id(3286599848719423369)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140014692418349543)
,p_page_template_id=>wwv_flow_api.id(3286599848719423369)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(3286607596938476944)
,p_theme_id=>101
,p_name=>'APEX 5.0 - Sign Up Wizard'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'<!--[if lt IE 9]><script src="#IMAGE_PREFIX#libraries/apex/html5_ie.js"></script><![endif]-->',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140016104078349541)
,p_page_template_id=>wwv_flow_api.id(3286607596938476944)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140016229105349541)
,p_page_template_id=>wwv_flow_api.id(3286607596938476944)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140016397711349541)
,p_page_template_id=>wwv_flow_api.id(3286607596938476944)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140016488324349540)
,p_page_template_id=>wwv_flow_api.id(3286607596938476944)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140016507421349540)
,p_page_template_id=>wwv_flow_api.id(3286607596938476944)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140016651339349540)
,p_page_template_id=>wwv_flow_api.id(3286607596938476944)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140016745201349540)
,p_page_template_id=>wwv_flow_api.id(3286607596938476944)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_workspace_login
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(3365548215818617994)
,p_theme_id=>101
,p_name=>'APEX 5.0 - Workspace Login'
,p_internal_name=>'APEX_5.0_WORKSPACE_LOGIN'
,p_is_popup=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$(function() {',
'  $(''a[href*="#"]:not([href="#"])'').click(function() {',
'    if (location.pathname.replace(/^\//,'''') == this.pathname.replace(/^\//,'''') && location.hostname == this.hostname) {',
'      var target = $(this.hash);',
'      target = target.length ? target : $(''[name='' + this.hash.slice(1) +'']'');',
'      if (target.length) {',
'        $(''html,body'').animate({',
'          scrollTop: target.offset().top',
'        }, 500);',
'        return false;',
'      }',
'    }',
'  });',
'});'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'  ',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'<!--[if lt IE 9]><script src="#IMAGE_PREFIX#libraries/apex/html5_ie.js"></script><![endif]-->',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--login #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'<div class="u-Layout u-Layout--centerVertically a-Login-slide" id="top">',
'  #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'  <div class="a-Login-container">',
'  #BODY#',
'  </div>',
'  <div class="a-Login-slideNav a-Login-slideNav--down">',
'    <a href="#info" class="a-Login-slideNavLink"><span class="a-Icon icon-shuttle-down"></span></a>',
'  </div>',
'</div>',
'<div class="u-Layout u-Layout--centerVertically a-Login-slide a-Login-slide--secondary" id="info">',
'  <div class="a-Login-secondaryContent">',
'  #REGION_POSITION_03#',
'  </div>',
'  <div class="a-Login-slideNav  a-Login-slideNav--up">',
'    <a href="#top" class="a-Login-slideNavLink"><span class="a-Icon icon-shuttle-up"></span></a>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140018123210349539)
,p_page_template_id=>wwv_flow_api.id(3365548215818617994)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140018293454349538)
,p_page_template_id=>wwv_flow_api.id(3365548215818617994)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140018300560349538)
,p_page_template_id=>wwv_flow_api.id(3365548215818617994)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140018486692349538)
,p_page_template_id=>wwv_flow_api.id(3365548215818617994)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140018525249349538)
,p_page_template_id=>wwv_flow_api.id(3365548215818617994)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(2583919293963280507)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>101
);
end;
/
prompt --application/shared_components/user_interface/templates/button/a_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(2610383412116095734)
,p_template_name=>'<a> button'
,p_internal_name=>'<A>_BUTTON'
,p_template=>'<a href="#LINK#" title="#LABEL!ATTR#" style="font-size:10px;margin:2px;">#LABEL!HTML#</a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>0
,p_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="xpbutton" cellspacing="0" cellpadding="0" border="0"  summary="">',
'<tbody class="FFFFFF">',
'<tr>',
'<td class="L" width="4"><img src="#IMAGE_PREFIX#1px_trans.gif" alt="" height="1" width="4"/></td>',
'<td class="C"><a href="#LINK#">#LABEL#</a></td>',
'<td class="R" width="4"><img src="#IMAGE_PREFIX#1px_trans.gif" alt="" height="1" width="4"/></td>',
'</tr>',
'</tbody>',
'</table>'))
,p_theme_id=>101
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(2758666493011882367)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>101
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_4_1_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(2859691107686228274)
,p_template_name=>'APEX 4.1 - Button'
,p_internal_name=>'APEX_4.1_BUTTON'
,p_template=>'<button class="aButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span>#LABEL!HTML#</span></button> '
,p_hot_template=>'<button class="aButton hotButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span>#LABEL!HTML#</span></button> '
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="button-gray" role="button" title="#LABEL#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span>#LABEL#</span></a> ',
'',
'',
'<a href="#LINK#" class="button-orange" role="button" title="#LABEL#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span>#LABEL#</span></a> '))
,p_theme_id=>101
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(2937736309958680193)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>101
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(2988804730938183125)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>101
);
end;
/
prompt --application/shared_components/user_interface/templates/button/dialog_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(3012517609439119859)
,p_template_name=>'Dialog Button'
,p_internal_name=>'DIALOG_BUTTON'
,p_template=>'"#LABEL!ATTR#":#BUTTON_ATTRIBUTES#'
,p_translate_this_template=>'N'
,p_theme_class_id=>6
,p_theme_id=>101
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_badge_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(3214935748485245802)
,p_template_name=>'APEX 5.0 - Icon Badge Menu Button'
,p_internal_name=>'APEX_5.0_ICON_BADGE_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#"></span><span class="a-Button-badge"></span><span class="a-Icon icon-menu-drop-down"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#"></span><span class="a-Button-badge"></span><span class="a-Icon icon-menu-drop-down"></span></button>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>101
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_badge_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(3214935870969250916)
,p_template_name=>'APEX 5.0 - Icon Badge Button'
,p_internal_name=>'APEX_5.0_ICON_BADGE_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#"></span><span class="a-But'
||'ton-badge"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#"></span><spa'
||'n class="a-Button-badge"></span></button>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>101
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_text_link
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(3365552764774679721)
,p_template_name=>'APEX 5.0 - Text Link'
,p_internal_name=>'APEX_5.0_TEXT_LINK'
,p_template=>'<a href="#LINK#" class="#BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</a>'
,p_hot_template=>'<a href="#LINK#" class="#BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>101
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_1_1_page_wizard_section
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2584574193315975428)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-PageWizard-section #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2>#TITLE##HELP#</h2>',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.1.1 - Page Wizard Section'
,p_internal_name=>'APEX_5.1.1_PAGE_WIZARD_SECTION'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140435053356344581)
,p_plug_template_id=>wwv_flow_api.id(2584574193315975428)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140435119121344581)
,p_plug_template_id=>wwv_flow_api.id(2584574193315975428)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140435294393344581)
,p_plug_template_id=>wwv_flow_api.id(2584574193315975428)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_div_with_id_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2586890391916064979)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'APEX 4.0 - Div with ID and Region Attributes'
,p_internal_name=>'APEX_4.0_DIV_WITH_ID_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>101
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140435368710344581)
,p_plug_template_id=>wwv_flow_api.id(2586890391916064979)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140435470197344581)
,p_plug_template_id=>wwv_flow_api.id(2586890391916064979)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_anchors
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2601269795393996833)
,p_layout=>'TABLE'
,p_template=>'<div class="a-PageAnchors #COMPONENT_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Page Anchors'
,p_internal_name=>'APEX_5.0_PAGE_ANCHORS'
,p_plug_table_bgcolor=>'white'
,p_theme_id=>101
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'white'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140435559273344581)
,p_plug_template_id=>wwv_flow_api.id(2601269795393996833)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140435650936344581)
,p_plug_template_id=>wwv_flow_api.id(2601269795393996833)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/top_bar_c_htmldbtopbarm
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2601271888770996836)
,p_layout=>'TABLE'
,p_template=>'<table class="TopBarUIFix" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_STATIC_ID#" width="100%"><tbody class="GreenBar"><tr><td valign="middle" class="L">#BODY#</td><td width="30" class="C"><br /></td><td valign="middle" class="'
||'R" align="right"><span style="margin-right:10px;">#CLOSE#</span>#COPY##DELETE##CHANGE##EDIT##PREVIOUS##NEXT##CREATE##EXPAND#</td></tr></tbody></table>'
,p_page_plug_template_name=>'Top Bar (c:htmldbTopBarM)'
,p_internal_name=>'TOP_BAR_C:HTMLDBTOPBARM'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_translate_this_template=>'N'
,p_template_comment=>'<table class="TopBarUIFix" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_STATIC_ID#" width="100%"><tbody class="GreenBar"><tr><td width="10"><img src="#IMAGE_PREFIX#htmldb/builder/bar_top.png" width="10" height="8" alt="" /></td><'
||'td rowspan="3" valign="middle" class="L">#BODY#</td><td rowspan="3" width="30" class="C"><br /></td><td rowspan="3" valign="middle" class="R" align="right" style="white-space:nowrap;"><span style="margin-right:10px;">#CLOSE#</span>#COPY##DELETE##CHAN'
||'GE##EDIT##PREVIOUS##NEXT##CREATE##EXPAND#</td></tr><tr><td style="background-image:url(#IMAGE_PREFIX#htmldb/builder/bar_bg.png)"><br /></td></tr><tr><td><img src="#IMAGE_PREFIX#htmldb/builder/bar_bottom.png" width="10" height="8"  alt="" /></td></tr>'
||'</tbody></table>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140401248312344617)
,p_plug_template_id=>wwv_flow_api.id(2601271888770996836)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140401369721344616)
,p_plug_template_id=>wwv_flow_api.id(2601271888770996836)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140401446083344616)
,p_plug_template_id=>wwv_flow_api.id(2601271888770996836)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140401531370344616)
,p_plug_template_id=>wwv_flow_api.id(2601271888770996836)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140401613032344616)
,p_plug_template_id=>wwv_flow_api.id(2601271888770996836)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140401753481344616)
,p_plug_template_id=>wwv_flow_api.id(2601271888770996836)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140401802162344616)
,p_plug_template_id=>wwv_flow_api.id(2601271888770996836)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140401908131344616)
,p_plug_template_id=>wwv_flow_api.id(2601271888770996836)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140402015028344616)
,p_plug_template_id=>wwv_flow_api.id(2601271888770996836)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140402188313344616)
,p_plug_template_id=>wwv_flow_api.id(2601271888770996836)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140402229484344616)
,p_plug_template_id=>wwv_flow_api.id(2601271888770996836)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/top_bar_white_collapsed
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2601501911896508337)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#" class="top-bar" #REGION_ATTRIBUTES#><div style="float: left">#BODY#</div><div style="float: left">#CLOSE##EDIT##DELETE##CREATE##CREATE2##PREVIOUS##NEXT#</div></div>',
''))
,p_page_plug_template_name=>'Top Bar (white) (collapsed)'
,p_internal_name=>'TOP_BAR_WHITE_COLLAPSED'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>101
,p_theme_class_id=>21
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140402314967344615)
,p_plug_template_id=>wwv_flow_api.id(2601501911896508337)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140402447324344615)
,p_plug_template_id=>wwv_flow_api.id(2601501911896508337)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140402549787344615)
,p_plug_template_id=>wwv_flow_api.id(2601501911896508337)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140402683877344615)
,p_plug_template_id=>wwv_flow_api.id(2601501911896508337)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140402769291344615)
,p_plug_template_id=>wwv_flow_api.id(2601501911896508337)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140402891040344615)
,p_plug_template_id=>wwv_flow_api.id(2601501911896508337)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140402955385344615)
,p_plug_template_id=>wwv_flow_api.id(2601501911896508337)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140403094816344615)
,p_plug_template_id=>wwv_flow_api.id(2601501911896508337)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140403145441344615)
,p_plug_template_id=>wwv_flow_api.id(2601501911896508337)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/dhtml_hidden_with_id_c_htmldbhid
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2602459589575700630)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" style="display:none;">#BODY#</div>'
,p_page_plug_template_name=>'(DHTML) Hidden with ID (c:htmldbHID)'
,p_internal_name=>'DHTML_HIDDEN_WITH_ID_C:HTMLDBHID'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>101
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140403233362344614)
,p_plug_template_id=>wwv_flow_api.id(2602459589575700630)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140403394869344614)
,p_plug_template_id=>wwv_flow_api.id(2602459589575700630)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_message_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2613249515740447736)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-SystemMessage #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Message Region'
,p_internal_name=>'APEX_5.0_MESSAGE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>101
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140403495031344614)
,p_plug_template_id=>wwv_flow_api.id(2613249515740447736)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140403540235344614)
,p_plug_template_id=>wwv_flow_api.id(2613249515740447736)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2626126299499639372)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>101
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140403678191344614)
,p_plug_template_id=>wwv_flow_api.id(2626126299499639372)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140403748462344614)
,p_plug_template_id=>wwv_flow_api.id(2626126299499639372)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/ppr_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2664982500969247843)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_ID#"><htmldb:PPR_#REGION_ID#>#BODY#</htmldb:PPR_#REGION_ID#></div>'
,p_page_plug_template_name=>'PPR Region'
,p_internal_name=>'PPR_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>101
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140403881070344614)
,p_plug_template_id=>wwv_flow_api.id(2664982500969247843)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140403971650344614)
,p_plug_template_id=>wwv_flow_api.id(2664982500969247843)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/no_buttons_no_title
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2674461889133348159)
,p_layout=>'TABLE'
,p_template=>'<table class="htmldbRR" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_STATIC_ID#"><tbody><tr><td colspan="2" class="B">#BODY#</td></tr></tbody></table>'
,p_page_plug_template_name=>'No Buttons No Title'
,p_internal_name=>'NO_BUTTONS_NO_TITLE'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>101
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140404055860344614)
,p_plug_template_id=>wwv_flow_api.id(2674461889133348159)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140404116459344614)
,p_plug_template_id=>wwv_flow_api.id(2674461889133348159)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/popup_dialog
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2724541718684288181)
,p_layout=>'TABLE'
,p_template=>'<table style="display:none;position:absolute;background-color:#EEEEEE;border:#000000 solid 1px;padding:0px;text-align:center;font-size:12px;color:#000000;" summary="" cellpadding="0" cellspacing="0" border="0" id="#REGION_STATIC_ID#"><tr><td class="h'
||'tmldbWizardHeader"><h2>#TITLE#</h2></td><td class="htmldbWizardHeader" align="right"><span onClick="dhtml_CloseDialog(this);"><img src="#IMAGE_PREFIX#qb/vertical_close.png" /></span></td></tr><tr><td colspan="2" class="htmldbWizardBody">#BODY#</td></'
||'tr><tr><td colspan="2" align="right">#CLOSE#&nbsp;&nbsp;&nbsp;#DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#</td></tr></table>'
,p_page_plug_template_name=>'Popup Dialog'
,p_internal_name=>'POPUP_DIALOG'
,p_theme_id=>101
,p_theme_class_id=>7
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140404233735344613)
,p_plug_template_id=>wwv_flow_api.id(2724541718684288181)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140404301852344613)
,p_plug_template_id=>wwv_flow_api.id(2724541718684288181)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140404486637344613)
,p_plug_template_id=>wwv_flow_api.id(2724541718684288181)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140404599326344613)
,p_plug_template_id=>wwv_flow_api.id(2724541718684288181)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140404649127344613)
,p_plug_template_id=>wwv_flow_api.id(2724541718684288181)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140404779895344613)
,p_plug_template_id=>wwv_flow_api.id(2724541718684288181)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140404884704344613)
,p_plug_template_id=>wwv_flow_api.id(2724541718684288181)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140404965289344613)
,p_plug_template_id=>wwv_flow_api.id(2724541718684288181)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140405032559344613)
,p_plug_template_id=>wwv_flow_api.id(2724541718684288181)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/horizontal_body_and_button_positions
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2733855215457005326)
,p_layout=>'TABLE'
,p_template=>'<table  cellpadding="0" cellspacing="0" border="0" summary="" class="htmldbButtonPositionsOnly" id="#REGION_STATIC_ID#"><tbody><tr><td>#BODY#</td><td style="padding-right:25px;">#CLOSE#</td><td>#PREVIOUS#</td><td>#NEXT#</td><td>#DELETE#</td><td>#CHAN'
||'GE##EDIT#</td><td>#CREATE#</td><td>#CREATE2#</td><td>#HELP#</td></tr></tbody></table>'
,p_page_plug_template_name=>'Horizontal Body and Button Positions'
,p_internal_name=>'HORIZONTAL_BODY_AND_BUTTON_POSITIONS'
,p_theme_id=>101
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140405107932344612)
,p_plug_template_id=>wwv_flow_api.id(2733855215457005326)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140405253990344612)
,p_plug_template_id=>wwv_flow_api.id(2733855215457005326)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140405356240344612)
,p_plug_template_id=>wwv_flow_api.id(2733855215457005326)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140405405672344612)
,p_plug_template_id=>wwv_flow_api.id(2733855215457005326)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140405587689344612)
,p_plug_template_id=>wwv_flow_api.id(2733855215457005326)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140405603168344612)
,p_plug_template_id=>wwv_flow_api.id(2733855215457005326)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140405785007344612)
,p_plug_template_id=>wwv_flow_api.id(2733855215457005326)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140405852976344612)
,p_plug_template_id=>wwv_flow_api.id(2733855215457005326)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140405910290344612)
,p_plug_template_id=>wwv_flow_api.id(2733855215457005326)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140406029620344612)
,p_plug_template_id=>wwv_flow_api.id(2733855215457005326)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140406183416344611)
,p_plug_template_id=>wwv_flow_api.id(2733855215457005326)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_designer_column
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2758528811846759332)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-PageColumn #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-PageColumn-header">',
'    <h2 class="a-PageColumn-heading">#TITLE#</h2>',
'  </div>',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Page Designer Column'
,p_internal_name=>'APEX_5.0_PAGE_DESIGNER_COLUMN'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140406219377344611)
,p_plug_template_id=>wwv_flow_api.id(2758528811846759332)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140406337654344611)
,p_plug_template_id=>wwv_flow_api.id(2758528811846759332)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_toolbar
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2758529294157796426)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Toolbar #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Toolbar-items a-Toolbar-items--left">#PREVIOUS#</div>',
'  <div class="a-Toolbar-items a-Toolbar-items--right">#NEXT#</div>',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Toolbar'
,p_internal_name=>'APEX_5.0_TOOLBAR'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140406474237344611)
,p_plug_template_id=>wwv_flow_api.id(2758529294157796426)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140406534357344611)
,p_plug_template_id=>wwv_flow_api.id(2758529294157796426)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140406671488344611)
,p_plug_template_id=>wwv_flow_api.id(2758529294157796426)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140406796980344611)
,p_plug_template_id=>wwv_flow_api.id(2758529294157796426)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_toolbar_items_left
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2758544003863874977)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Toolbar-items a-Toolbar-items--left #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'  #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Toolbar Items (Left)'
,p_internal_name=>'APEX_5.0_TOOLBAR_ITEMS_LEFT'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140406874628344611)
,p_plug_template_id=>wwv_flow_api.id(2758544003863874977)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140406985760344611)
,p_plug_template_id=>wwv_flow_api.id(2758544003863874977)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140407062313344610)
,p_plug_template_id=>wwv_flow_api.id(2758544003863874977)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140407124252344610)
,p_plug_template_id=>wwv_flow_api.id(2758544003863874977)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140407214909344610)
,p_plug_template_id=>wwv_flow_api.id(2758544003863874977)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140407324831344610)
,p_plug_template_id=>wwv_flow_api.id(2758544003863874977)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140407472607344610)
,p_plug_template_id=>wwv_flow_api.id(2758544003863874977)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140407561391344610)
,p_plug_template_id=>wwv_flow_api.id(2758544003863874977)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140407634733344610)
,p_plug_template_id=>wwv_flow_api.id(2758544003863874977)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140407775102344610)
,p_plug_template_id=>wwv_flow_api.id(2758544003863874977)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140407854126344610)
,p_plug_template_id=>wwv_flow_api.id(2758544003863874977)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140407931559344610)
,p_plug_template_id=>wwv_flow_api.id(2758544003863874977)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140408088125344609)
,p_plug_template_id=>wwv_flow_api.id(2758544003863874977)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_toolbar_items_right
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2758544719016898298)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Toolbar-items a-Toolbar-items--right #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'  #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Toolbar Items (Right)'
,p_internal_name=>'APEX_5.0_TOOLBAR_ITEMS_RIGHT'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140408192648344609)
,p_plug_template_id=>wwv_flow_api.id(2758544719016898298)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140408215033344609)
,p_plug_template_id=>wwv_flow_api.id(2758544719016898298)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140408385373344609)
,p_plug_template_id=>wwv_flow_api.id(2758544719016898298)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140408466505344609)
,p_plug_template_id=>wwv_flow_api.id(2758544719016898298)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140408560671344609)
,p_plug_template_id=>wwv_flow_api.id(2758544719016898298)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140408643190344609)
,p_plug_template_id=>wwv_flow_api.id(2758544719016898298)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140408727007344609)
,p_plug_template_id=>wwv_flow_api.id(2758544719016898298)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140408828363344609)
,p_plug_template_id=>wwv_flow_api.id(2758544719016898298)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140408944593344609)
,p_plug_template_id=>wwv_flow_api.id(2758544719016898298)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140409003096344608)
,p_plug_template_id=>wwv_flow_api.id(2758544719016898298)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140409122947344608)
,p_plug_template_id=>wwv_flow_api.id(2758544719016898298)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140409256702344608)
,p_plug_template_id=>wwv_flow_api.id(2758544719016898298)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140409301939344608)
,p_plug_template_id=>wwv_flow_api.id(2758544719016898298)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_designer_column_body
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2758545604256903488)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-PageColumn-body #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Page Designer Column (Body)'
,p_internal_name=>'APEX_5.0_PAGE_DESIGNER_COLUMN_BODY'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140409484559344608)
,p_plug_template_id=>wwv_flow_api.id(2758545604256903488)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140409536347344608)
,p_plug_template_id=>wwv_flow_api.id(2758545604256903488)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_accordion
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2758661890054767997)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Accordion #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #SUBREGIONS#',
'</div>',
'<script type="text/javascript">',
'  apex.jQuery( "#accordion" ).accordion({',
'    icons: false,',
'    header: ".a-Region-header",',
'    heightStyle: ''content'',',
'    collapsible: true',
'  });',
'</script>'))
,p_sub_plug_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Accordion-item">',
'#SUB_REGION#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Accordion'
,p_internal_name=>'APEX_5.0_ACCORDION'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140409600026344608)
,p_plug_template_id=>wwv_flow_api.id(2758661890054767997)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140409706303344608)
,p_plug_template_id=>wwv_flow_api.id(2758661890054767997)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2758664310411868479)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>101
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140409820289344608)
,p_plug_template_id=>wwv_flow_api.id(2758664310411868479)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140409934407344607)
,p_plug_template_id=>wwv_flow_api.id(2758664310411868479)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140410066199344607)
,p_plug_template_id=>wwv_flow_api.id(2758664310411868479)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140410161004344607)
,p_plug_template_id=>wwv_flow_api.id(2758664310411868479)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140410216468344607)
,p_plug_template_id=>wwv_flow_api.id(2758664310411868479)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140410313615344607)
,p_plug_template_id=>wwv_flow_api.id(2758664310411868479)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140410400198344607)
,p_plug_template_id=>wwv_flow_api.id(2758664310411868479)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140410583003344607)
,p_plug_template_id=>wwv_flow_api.id(2758664310411868479)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140410664455344607)
,p_plug_template_id=>wwv_flow_api.id(2758664310411868479)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140410741184344607)
,p_plug_template_id=>wwv_flow_api.id(2758664310411868479)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140410813407344607)
,p_plug_template_id=>wwv_flow_api.id(2758664310411868479)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140410994735344606)
,p_plug_template_id=>wwv_flow_api.id(2758664310411868479)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140411057158344606)
,p_plug_template_id=>wwv_flow_api.id(2758664310411868479)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_tabs
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2767126796965963192)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #SUB_REGION_HEADERS#',
'  #SUB_REGIONS#',
'</div>',
'<script type="text/javascript">',
'    $("##REGION_STATIC_ID#").tabs({',
'      create: function() {',
'        $(this).addClass(''ui-tabs--simpleInset'')',
'      }',
'    });',
'</script>'))
,p_sub_plug_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'#ENTRIES#',
'</ul>'))
,p_sub_plug_header_entry_templ=>'<li><a href="##SUB_REGION_ID#">#SUB_REGION_TITLE#</a></li>'
,p_sub_plug_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer-item" id="#SUB_REGION_ID#">',
'#SUB_REGION#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Tabs'
,p_internal_name=>'APEX_5.0_TABS'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140411101963344606)
,p_plug_template_id=>wwv_flow_api.id(2767126796965963192)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140411254904344606)
,p_plug_template_id=>wwv_flow_api.id(2767126796965963192)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/tree_context_menu
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2789923400863815363)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'var #REGION_STATIC_ID#=#BODY#;',
'</script>'))
,p_page_plug_template_name=>'Tree Context Menu'
,p_internal_name=>'TREE_CONTEXT_MENU'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140411369095344606)
,p_plug_template_id=>wwv_flow_api.id(2789923400863815363)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140411456657344606)
,p_plug_template_id=>wwv_flow_api.id(2789923400863815363)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/loading_region_hidden_by_default
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2811142913752487499)
,p_layout=>'TABLE'
,p_template=>'<div class="htmldbLoadingRegion" id="#REGION_STATIC_ID#" style="display:none;">#BODY#<br /><img src="#IMAGE_PREFIX#htmldb/icons/wait.gif"  id="loadingIcon" alt="" /></div>'
,p_page_plug_template_name=>'Loading Region (Hidden by Default)'
,p_internal_name=>'LOADING_REGION_HIDDEN_BY_DEFAULT'
,p_theme_id=>101
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140411564253344606)
,p_plug_template_id=>wwv_flow_api.id(2811142913752487499)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140411691431344606)
,p_plug_template_id=>wwv_flow_api.id(2811142913752487499)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/4500_results_region_template
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2938888314478328196)
,p_layout=>'TABLE'
,p_template=>'<table cellspacing="2" cellpadding="2" border="0" width="100%" bgcolor="#C5D5C5" summary="" id="#REGION_STATIC_ID#"><tr><td align=left bgcolor="#C5D5C5"><font class="regionheader" face=aria color=white>&nbsp;<h2>#TITLE#</h2></font></td><td width="1%"'
||' align="right"  bgcolor="#C5D5C5">#EXPAND#</td><td width="1%" align="right"  bgcolor="#C5D5C5">#CLOSE#</td></tr></table>#BODY#<p/>'
,p_page_plug_template_name=>'(4500) results_region_template'
,p_internal_name=>'4500_RESULTS_REGION_TEMPLATE'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>101
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140450552938344565)
,p_plug_template_id=>wwv_flow_api.id(2938888314478328196)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140450616808344565)
,p_plug_template_id=>wwv_flow_api.id(2938888314478328196)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140450786554344565)
,p_plug_template_id=>wwv_flow_api.id(2938888314478328196)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140450883331344565)
,p_plug_template_id=>wwv_flow_api.id(2938888314478328196)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/4500_simple_small_box
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2938888500664328199)
,p_layout=>'TABLE'
,p_template=>'<table width="400" summary="" cellpadding="0" cellspacing="0" border="0" id="#REGION_STATIC_ID#"><tr><td>#BODY#</td></tr></table>'
,p_page_plug_template_name=>'(4500) simple small box'
,p_internal_name=>'4500_SIMPLE_SMALL_BOX'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>101
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_translate_this_template=>'N'
,p_template_comment=>'No region formatting'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140450900077344565)
,p_plug_template_id=>wwv_flow_api.id(2938888500664328199)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140451080381344565)
,p_plug_template_id=>wwv_flow_api.id(2938888500664328199)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2983766147992137991)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>101
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140451169464344565)
,p_plug_template_id=>wwv_flow_api.id(2983766147992137991)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140451273288344565)
,p_plug_template_id=>wwv_flow_api.id(2983766147992137991)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140451393564344564)
,p_plug_template_id=>wwv_flow_api.id(2983766147992137991)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140451456837344564)
,p_plug_template_id=>wwv_flow_api.id(2983766147992137991)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140451508107344564)
,p_plug_template_id=>wwv_flow_api.id(2983766147992137991)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140451647855344564)
,p_plug_template_id=>wwv_flow_api.id(2983766147992137991)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140451749878344564)
,p_plug_template_id=>wwv_flow_api.id(2983766147992137991)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140451873991344564)
,p_plug_template_id=>wwv_flow_api.id(2983766147992137991)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140451958769344564)
,p_plug_template_id=>wwv_flow_api.id(2983766147992137991)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140452088286344564)
,p_plug_template_id=>wwv_flow_api.id(2983766147992137991)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140452142356344564)
,p_plug_template_id=>wwv_flow_api.id(2983766147992137991)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140452282159344564)
,p_plug_template_id=>wwv_flow_api.id(2983766147992137991)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_dialog
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(3012513290302116971)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#"  class="a-DialogRegion js-regionDialog #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# style="display:none" title="#TITLE#">',
'  <div class="a-DialogRegion-body">',
'#BODY#',
'  </div>',
'  <div class="a-DialogRegion-buttons">',
'     <div class="a-ButtonRegion a-ButtonRegion--dialogRegion">',
'       <div class="a-ButtonRegion-wrap">',
'         <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'         <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'       </div>',
'     </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region Dialog'
,p_internal_name=>'APEX_5.0_REGION_DIALOG'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_template_options=>'js-draggable:js-modal:js-resizable'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140452341121344563)
,p_plug_template_id=>wwv_flow_api.id(3012513290302116971)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140452496511344563)
,p_plug_template_id=>wwv_flow_api.id(3012513290302116971)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140452559435344563)
,p_plug_template_id=>wwv_flow_api.id(3012513290302116971)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140452631357344563)
,p_plug_template_id=>wwv_flow_api.id(3012513290302116971)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140452740683344563)
,p_plug_template_id=>wwv_flow_api.id(3012513290302116971)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140452890833344563)
,p_plug_template_id=>wwv_flow_api.id(3012513290302116971)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140452914324344563)
,p_plug_template_id=>wwv_flow_api.id(3012513290302116971)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140453089252344563)
,p_plug_template_id=>wwv_flow_api.id(3012513290302116971)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(3262269949210718587)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>101
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140453169731344563)
,p_plug_template_id=>wwv_flow_api.id(3262269949210718587)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140453223772344562)
,p_plug_template_id=>wwv_flow_api.id(3262269949210718587)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140453378872344562)
,p_plug_template_id=>wwv_flow_api.id(3262269949210718587)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140453475865344562)
,p_plug_template_id=>wwv_flow_api.id(3262269949210718587)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(3271069058970016268)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140453516249344562)
,p_plug_template_id=>wwv_flow_api.id(3271069058970016268)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140453632311344562)
,p_plug_template_id=>wwv_flow_api.id(3271069058970016268)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140453710990344562)
,p_plug_template_id=>wwv_flow_api.id(3271069058970016268)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140453800684344562)
,p_plug_template_id=>wwv_flow_api.id(3271069058970016268)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140453972223344562)
,p_plug_template_id=>wwv_flow_api.id(3271069058970016268)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140454083807344562)
,p_plug_template_id=>wwv_flow_api.id(3271069058970016268)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140454185645344562)
,p_plug_template_id=>wwv_flow_api.id(3271069058970016268)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140454248865344561)
,p_plug_template_id=>wwv_flow_api.id(3271069058970016268)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140454313998344561)
,p_plug_template_id=>wwv_flow_api.id(3271069058970016268)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(3273871575473525717)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140454630881344561)
,p_plug_template_id=>wwv_flow_api.id(3273871575473525717)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140454782970344561)
,p_plug_template_id=>wwv_flow_api.id(3273871575473525717)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140454877178344561)
,p_plug_template_id=>wwv_flow_api.id(3273871575473525717)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140454989023344561)
,p_plug_template_id=>wwv_flow_api.id(3273871575473525717)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140455067044344561)
,p_plug_template_id=>wwv_flow_api.id(3273871575473525717)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140455174710344561)
,p_plug_template_id=>wwv_flow_api.id(3273871575473525717)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140455209433344560)
,p_plug_template_id=>wwv_flow_api.id(3273871575473525717)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140455306869344560)
,p_plug_template_id=>wwv_flow_api.id(3273871575473525717)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140455473173344560)
,p_plug_template_id=>wwv_flow_api.id(3273871575473525717)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140455510187344560)
,p_plug_template_id=>wwv_flow_api.id(3273871575473525717)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140455684744344560)
,p_plug_template_id=>wwv_flow_api.id(3273871575473525717)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140455731627344560)
,p_plug_template_id=>wwv_flow_api.id(3273871575473525717)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140455805939344560)
,p_plug_template_id=>wwv_flow_api.id(3273871575473525717)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_with_icon
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(3282744828018275829)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hasIcon #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'    <div class="a-RegionMedia">',
'      <div class="a-RegionMedia-graphic">',
'        <span class="a-Icon a-Icon--regionIcon #ICON_CSS_CLASSES#"></span>',
'      </div>',
'      <div class="a-RegionMedia-content">',
'        #BODY#',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region with Icon'
,p_internal_name=>'APEX_5.0_REGION_WITH_ICON'
,p_theme_id=>101
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140455903161344560)
,p_plug_template_id=>wwv_flow_api.id(3282744828018275829)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140456031310344560)
,p_plug_template_id=>wwv_flow_api.id(3282744828018275829)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140456118101344559)
,p_plug_template_id=>wwv_flow_api.id(3282744828018275829)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140456264279344559)
,p_plug_template_id=>wwv_flow_api.id(3282744828018275829)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140456316925344559)
,p_plug_template_id=>wwv_flow_api.id(3282744828018275829)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140456487077344559)
,p_plug_template_id=>wwv_flow_api.id(3282744828018275829)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140456554852344559)
,p_plug_template_id=>wwv_flow_api.id(3282744828018275829)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140456605206344559)
,p_plug_template_id=>wwv_flow_api.id(3282744828018275829)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140456754404344559)
,p_plug_template_id=>wwv_flow_api.id(3282744828018275829)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140456838211344559)
,p_plug_template_id=>wwv_flow_api.id(3282744828018275829)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140456963637344559)
,p_plug_template_id=>wwv_flow_api.id(3282744828018275829)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140457000876344559)
,p_plug_template_id=>wwv_flow_api.id(3282744828018275829)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140457195239344559)
,p_plug_template_id=>wwv_flow_api.id(3282744828018275829)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(3286693190338347807)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140454425903344561)
,p_plug_template_id=>wwv_flow_api.id(3286693190338347807)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140454573482344561)
,p_plug_template_id=>wwv_flow_api.id(3286693190338347807)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(3287384588973547661)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>101
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140457205630344558)
,p_plug_template_id=>wwv_flow_api.id(3287384588973547661)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140457331699344558)
,p_plug_template_id=>wwv_flow_api.id(3287384588973547661)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(3300810815961795652)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>101
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>208928010704475743
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140457415831344558)
,p_plug_template_id=>wwv_flow_api.id(3300810815961795652)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140457588423344558)
,p_plug_template_id=>wwv_flow_api.id(3300810815961795652)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140457641785344558)
,p_plug_template_id=>wwv_flow_api.id(3300810815961795652)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140457745806344558)
,p_plug_template_id=>wwv_flow_api.id(3300810815961795652)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_hidden_heading
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(3301748405466464586)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region (Hidden Heading)'
,p_internal_name=>'APEX_5.0_REGION_HIDDEN_HEADING'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140457893097344558)
,p_plug_template_id=>wwv_flow_api.id(3301748405466464586)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140457966162344558)
,p_plug_template_id=>wwv_flow_api.id(3301748405466464586)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_iframe_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(3321664782165928798)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--iframe #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'  <div class="a-Region-iframeButtons">',
'    <div class="a-ButtonRegion">',
'      <div class="a-ButtonRegion-wrap">',
'        <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'        <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'          <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'        </div>',
'        <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - iFrame Region'
,p_internal_name=>'APEX_5.0_IFRAME_REGION'
,p_theme_id=>101
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--paddedBody'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140458031481344558)
,p_plug_template_id=>wwv_flow_api.id(3321664782165928798)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140458126177344557)
,p_plug_template_id=>wwv_flow_api.id(3321664782165928798)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140458292748344557)
,p_plug_template_id=>wwv_flow_api.id(3321664782165928798)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140458329039344557)
,p_plug_template_id=>wwv_flow_api.id(3321664782165928798)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140458425479344557)
,p_plug_template_id=>wwv_flow_api.id(3321664782165928798)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140458553392344557)
,p_plug_template_id=>wwv_flow_api.id(3321664782165928798)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140458637273344557)
,p_plug_template_id=>wwv_flow_api.id(3321664782165928798)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140458717780344557)
,p_plug_template_id=>wwv_flow_api.id(3321664782165928798)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140458845126344557)
,p_plug_template_id=>wwv_flow_api.id(3321664782165928798)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(3330277939666606656)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>101
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140458912875344557)
,p_plug_template_id=>wwv_flow_api.id(3330277939666606656)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140459085118344557)
,p_plug_template_id=>wwv_flow_api.id(3330277939666606656)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140459129040344556)
,p_plug_template_id=>wwv_flow_api.id(3330277939666606656)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140459204889344556)
,p_plug_template_id=>wwv_flow_api.id(3330277939666606656)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140459372291344556)
,p_plug_template_id=>wwv_flow_api.id(3330277939666606656)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140459485853344556)
,p_plug_template_id=>wwv_flow_api.id(3330277939666606656)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_accordion_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(3331511935591010485)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Accordion Region'
,p_internal_name=>'APEX_5.0_ACCORDION_REGION'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140459518026344556)
,p_plug_template_id=>wwv_flow_api.id(3331511935591010485)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140459641146344556)
,p_plug_template_id=>wwv_flow_api.id(3331511935591010485)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140459755556344556)
,p_plug_template_id=>wwv_flow_api.id(3331511935591010485)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140459881438344556)
,p_plug_template_id=>wwv_flow_api.id(3331511935591010485)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140459911650344556)
,p_plug_template_id=>wwv_flow_api.id(3331511935591010485)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140460045690344556)
,p_plug_template_id=>wwv_flow_api.id(3331511935591010485)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140460124205344555)
,p_plug_template_id=>wwv_flow_api.id(3331511935591010485)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140460251347344555)
,p_plug_template_id=>wwv_flow_api.id(3331511935591010485)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140460364359344555)
,p_plug_template_id=>wwv_flow_api.id(3331511935591010485)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140460442147344555)
,p_plug_template_id=>wwv_flow_api.id(3331511935591010485)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140460577177344555)
,p_plug_template_id=>wwv_flow_api.id(3331511935591010485)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140460683723344555)
,p_plug_template_id=>wwv_flow_api.id(3331511935591010485)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140460721420344555)
,p_plug_template_id=>wwv_flow_api.id(3331511935591010485)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_workspace_login_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(3365552953046687584)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Login-region a-Form--stretchInputs #REGION_CSS_CLASSES#" id="#REGION_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Login-header">',
'    <span class="a-Login-logo gi-icon-apex-logo-icon"></span>',
'    <h1 class="a-Login-title">#TITLE#</h1>',
'  </div>',
'  <div class="a-Login-body">',
'    #BODY#',
'  </div>',
'  <div class="a-Login-buttons">',
'    #NEXT#',
'  </div>',
'  <div class="a-Login-links">',
'    #EDIT##CREATE#',
'  </div>',
'  #SUB_REGIONS#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Workspace Login Region'
,p_internal_name=>'APEX_5.0_WORKSPACE_LOGIN_REGION'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140460857282344555)
,p_plug_template_id=>wwv_flow_api.id(3365552953046687584)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140460935793344555)
,p_plug_template_id=>wwv_flow_api.id(3365552953046687584)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140461053436344555)
,p_plug_template_id=>wwv_flow_api.id(3365552953046687584)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140461166047344554)
,p_plug_template_id=>wwv_flow_api.id(3365552953046687584)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140461286327344554)
,p_plug_template_id=>wwv_flow_api.id(3365552953046687584)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_workspace_login_content_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(3365628682004899102)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Login-infoRegion #REGION_CSS_CLASSES#" id="#REGION_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Login-infoRegion-header">',
'    <h2 class="a-Login-infoRegion-title">#TITLE#</h2>',
'  </div>',
'  <div class="a-Login-infoRegion-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Workspace Login Content Region'
,p_internal_name=>'APEX_5.0_WORKSPACE_LOGIN_CONTENT_REGION'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140461358684344554)
,p_plug_template_id=>wwv_flow_api.id(3365628682004899102)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140461427600344554)
,p_plug_template_id=>wwv_flow_api.id(3365628682004899102)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_1_tabs_with_icons_text
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(3678578060703653018)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Tabs-toolbar a-Toolbar">',
'    #SUB_REGION_HEADERS#',
'    <div class="a-Toolbar-items a-Toolbar-items--right">#NEXT#</div>',
'  </div>',
'  #SUB_REGIONS#',
'</div>'))
,p_sub_plug_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'#ENTRIES#',
'</ul>'))
,p_sub_plug_header_entry_templ=>'<li><a href="##SUB_REGION_ID#"><span title="#SUB_REGION_TITLE#" class="a-Icon #SUB_REGION_ICON_CSS_CLASSES#"></span><span class="a-Tabs-label">#SUB_REGION_TITLE#</span></a></li>'
,p_sub_plug_template=>'#SUB_REGION#'
,p_page_plug_template_name=>'APEX 5.1 - Tabs with Icons + Text'
,p_internal_name=>'APEX_5.1_TABS_WITH_ICONS_+_TEXT'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140461590448344554)
,p_plug_template_id=>wwv_flow_api.id(3678578060703653018)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140461634031344554)
,p_plug_template_id=>wwv_flow_api.id(3678578060703653018)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140461741310344554)
,p_plug_template_id=>wwv_flow_api.id(3678578060703653018)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(3731195891703350618)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140461848018344554)
,p_plug_template_id=>wwv_flow_api.id(3731195891703350618)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140461958023344554)
,p_plug_template_id=>wwv_flow_api.id(3731195891703350618)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_grouping_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(3741609957292929669)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#" role="group" aria-labelledby="#REGION_STATIC_ID#_label">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title" id="#REGION_STATIC_ID#_label">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Grouping Region'
,p_internal_name=>'APEX_5.0_GROUPING_REGION'
,p_theme_id=>101
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--paddedBody:a-Region--simple'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140462312319344553)
,p_plug_template_id=>wwv_flow_api.id(3741609957292929669)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140462454938344553)
,p_plug_template_id=>wwv_flow_api.id(3741609957292929669)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140462503695344553)
,p_plug_template_id=>wwv_flow_api.id(3741609957292929669)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140462658589344553)
,p_plug_template_id=>wwv_flow_api.id(3741609957292929669)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140462766541344553)
,p_plug_template_id=>wwv_flow_api.id(3741609957292929669)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140462846938344553)
,p_plug_template_id=>wwv_flow_api.id(3741609957292929669)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140462922950344553)
,p_plug_template_id=>wwv_flow_api.id(3741609957292929669)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140463020053344552)
,p_plug_template_id=>wwv_flow_api.id(3741609957292929669)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140463179593344552)
,p_plug_template_id=>wwv_flow_api.id(3741609957292929669)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140463283408344552)
,p_plug_template_id=>wwv_flow_api.id(3741609957292929669)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140463304082344552)
,p_plug_template_id=>wwv_flow_api.id(3741609957292929669)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140463442168344552)
,p_plug_template_id=>wwv_flow_api.id(3741609957292929669)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140463596056344552)
,p_plug_template_id=>wwv_flow_api.id(3741609957292929669)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_designer_tree_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(4077427275300064682)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#" class="a-PageDesigner-treeRegion resize #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>',
'  <div class="a-Toolbar a-Toolbar-pageColumn a-Toolbar--treeRegion">',
'    <div class="a-Toolbar-items a-Toolbar-items--left">',
'      <h3 class="a-PageDesigner-treeTitle">#TITLE#</h3>',
'    </div>',
'    <div class="a-Toolbar-items a-Toolbar-items--right">#NEXT#</div>',
'  </div>',
'  <div class="a-PageDesigner-treeWrap u-ScrollingViewport resize">',
'    #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Page Designer Tree Region'
,p_internal_name=>'APEX_5.0_PAGE_DESIGNER_TREE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>101
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140462090869344554)
,p_plug_template_id=>wwv_flow_api.id(4077427275300064682)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140462102388344553)
,p_plug_template_id=>wwv_flow_api.id(4077427275300064682)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140462245205344553)
,p_plug_template_id=>wwv_flow_api.id(4077427275300064682)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_tabs_with_icons
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(4630165380147676460)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Tabs-toolbar a-Toolbar">',
'    #SUB_REGION_HEADERS#',
'    <div class="a-Toolbar-items a-Toolbar-items--right">#NEXT#</div>',
'  </div>',
'  #SUB_REGIONS#',
'</div>'))
,p_sub_plug_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'#ENTRIES#',
'</ul>'))
,p_sub_plug_header_entry_templ=>'<li><a href="##SUB_REGION_ID#"><span title="#SUB_REGION_TITLE#" class="a-Icon #SUB_REGION_ICON_CSS_CLASSES#"></span><span class="u-VisuallyHidden">#SUB_REGION_TITLE#</span></a></li>'
,p_sub_plug_template=>'#SUB_REGION#'
,p_page_plug_template_name=>'APEX 5.0 - Tabs with Icons'
,p_internal_name=>'APEX_5.0_TABS_WITH_ICONS'
,p_theme_id=>101
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140463654152344552)
,p_plug_template_id=>wwv_flow_api.id(4630165380147676460)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140463711686344552)
,p_plug_template_id=>wwv_flow_api.id(4630165380147676460)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140463847921344552)
,p_plug_template_id=>wwv_flow_api.id(4630165380147676460)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/done_standard_list_table_based
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(2601300913516285374)
,p_list_template_current=>'<tr><td class="htmldbStandardList1"><a href="#LINK#" class="itemLink" title="#TEXT_ESC_SC#">#TEXT#</a></td></tr>'
,p_list_template_noncurrent=>'<tr><td class="htmldbStandardList2"><a href="#LINK#" class="itemLink" title="#TEXT_ESC_SC#">#TEXT#</a></td></tr>'
,p_list_template_name=>'(Done) Standard List (Table Based)'
,p_internal_name=>'DONE_STANDARD_LIST_TABLE_BASED'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbStandardList" cellpadding="0" cellspacing="0" border="0" summary="">',
'<tbody>'))
,p_list_template_after_rows=>'</tbody></table>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/dhtml_list_button_with_sublist
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(2602098713851789269)
,p_list_template_current=>'<li>#TEXT#</li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#" class="dList" title="#TEXT_ESC_SC#">#TEXT#</a></li>'
,p_list_template_name=>'DHTML List Button with Sublist'
,p_internal_name=>'DHTML_LIST_BUTTON_WITH_SUBLIST'
,p_theme_id=>101
,p_theme_class_id=>10
,p_list_template_before_rows=>'<ul class="dList">'
,p_list_template_after_rows=>'</ul>'
,p_item_templ_curr_w_child=>'<li>#TEXT#</li>'
,p_item_templ_noncurr_w_child=>'<li><a href="#LINK#" class="dList" title="#TEXT_ESC_SC#">#TEXT#</a></li>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/done_page_tab_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(2602893399962651103)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="current"><div class="tbl"><a href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a></div><div class="tbr"><img src="#IMAGE_PREFIX#1px_trans.gif"></div></div>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="non-current"><div class="tbl"><a href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a></div><div class="tbr"><img src="#IMAGE_PREFIX#1px_trans.gif"></div></div>',
''))
,p_list_template_name=>'(Done) Page Tab Navigation'
,p_internal_name=>'DONE_PAGE_TAB_NAVIGATION'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>'<div id="tabs">'
,p_list_template_after_rows=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_large_icons_list_5_icons
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(2604064395384974004)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX#f_spacer.gif" #IMAGE_ATTR# class="gi-Icon-#IMAGE#" alt="" /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX#f_spacer.gif" #IMAGE_ATTR# class="gi-Icon-#IMAGE#" alt="" /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
,p_list_template_name=>'[EBA] Large Icons List (5 icons)'
,p_internal_name=>'[EBA]_LARGE_ICONS_LIST_5_ICONS'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>'<table class="ebaLargeIcons" width="100%" cellspacing="0" cellpadding="0" border="0" summary=""><tr>'
,p_list_template_after_rows=>'</tr></table>'
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/simple_image_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(2616337216247383620)
,p_list_template_current=>'<li><a href="#LINK#" title="#TEXT#">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#" title="#TEXT#">#TEXT#</a></li>'
,p_list_template_name=>'Simple Image List'
,p_internal_name=>'SIMPLE_IMAGE_LIST'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="listwithicon">'
,p_list_template_after_rows=>'</ul>'
,p_list_template_comment=>'<img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_4_0_wizard_progress_sidebar
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(2644133919427537952)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-wiz-current"><span>#TEXT#</span></div>',
''))
,p_list_template_noncurrent=>'<div class="apex-wiz-non"><span>#TEXT#</span></div>'
,p_list_template_name=>'APEX 4. 0 - Wizard Progress Sidebar'
,p_internal_name=>'APEX_4._0_WIZARD_PROGRESS_SIDEBAR'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>'<div class="apex-wiz-bar">'
,p_list_template_after_rows=>'</div>'
,p_between_items=>'<div class="apex-wiz-arrow"></div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(2644135096780537975)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>101
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083
);
end;
/
prompt --application/shared_components/user_interface/templates/list/done_quick_items
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(2667754110651746870)
,p_list_template_current=>'<div><a href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a></div>'
,p_list_template_noncurrent=>'<div><a href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a></div>'
,p_list_template_name=>'(Done) Quick Items'
,p_internal_name=>'DONE_QUICK_ITEMS'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>'<div class="htmldbQuickItems">'
,p_list_template_after_rows=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/done_simple_tabbed_navigation_list_ppr
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(2692764710625953880)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="javascript:ob_PPR_TAB(''#LINK#'')" class="tabcurrent" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="javascript:ob_PPR_TAB(''#LINK#'')" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
'',
''))
,p_list_template_name=>'(Done) Simple Tabbed Navigation List (PPR)'
,p_internal_name=>'DONE_SIMPLE_TABBED_NAVIGATION_LIST_PPR'
,p_theme_id=>101
,p_theme_class_id=>7
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbTabbedNavigationList" border="0" cellpadding="0" cellspacing="0" summary=""><tr>',
'',
''))
,p_list_template_after_rows=>'<td width="100%"><br /></td></tr></table>'
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="#LINK#" class="tabcurrent" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="#LINK#" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
''))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/done_simple_tabbed_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(2692769817191963631)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="#LINK#" class="tabcurrent" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
'',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="#LINK#" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
''))
,p_list_template_name=>'(Done) Simple Tabbed Navigation List'
,p_internal_name=>'DONE_SIMPLE_TABBED_NAVIGATION_LIST'
,p_theme_id=>101
,p_theme_class_id=>7
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbTabbedNavigationList" border="0" cellpadding="0" cellspacing="0"><tr>',
'',
''))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td width="100%"><br /></td></tr></table>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="#LINK#" class="tabcurrent" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
'',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td valign="bottom"><a href="#LINK#" #A01# title="#TEXT_ESC_SC#">#TEXT#</a></td>',
''))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_sub_tabs
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(2752624110726590597)
,p_list_template_current=>'<li class="a-Tabs-item is-active" aria-current="page"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li class="a-Tabs-item"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_name=>'APEX 5.0 - Sub Tabs'
,p_internal_name=>'APEX_5.0_SUB_TABS'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer a-TabsContainer--subTabs">',
'  <ul class="a-Tabs a-Tabs--subTabButtons">'))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  </ul>',
'</div>'))
,p_reference_id=>168708522102193705
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aSubTabs"><ul>',
'<li class="active"><a href="#LINK#" title="#TEXT_ESC_SC#"><span>#TEXT#</span></a></li>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/tree_context_menu
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(2789926011585822220)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_ATTR#:{',
'  is_separator:true,',
'  visible:#A01#',
'}',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_ATTR#:{',
'  label:"#TEXT#", ',
'  icon: "#IMAGE#",',
'  visible:#A01#,',
'  action: #LINK#',
'}',
''))
,p_list_template_name=>'Tree Context Menu'
,p_internal_name=>'TREE_CONTEXT_MENU'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>'{items:{create:false,rename:false,remove:false,'
,p_list_template_after_rows=>'}}'
,p_between_items=>','
);
end;
/
prompt --application/shared_components/user_interface/templates/list/image_list_legend
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(2821773603397513050)
,p_list_template_current=>'<li><img src="#IMAGE_PREFIX##IMAGE#" style="margin-right:10px;" alt="" />#TEXT#</li>'
,p_list_template_noncurrent=>'<li><img src="#IMAGE_PREFIX##IMAGE#" style="margin-right:10px;" alt="" />#TEXT#</li>'
,p_list_template_name=>'Image List (Legend)'
,p_internal_name=>'IMAGE_LIST_LEGEND'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="htmldbSessionLegend">'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_4_0_wizard_progress_sidebar_clickable
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(2824062405654685023)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-wiz-current">',
'  <div class="apex-wiz-top"></div>',
'  <div class="apex-wiz-body">#TEXT#</div>',
'</div>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-wiz-non">',
'  <div class="apex-wiz-top"></div>',
'  <div class="apex-wiz-body"><a href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a></div>',
'</div>'))
,p_list_template_name=>'APEX 4. 0 - Wizard Progress Sidebar (Clickable)'
,p_internal_name=>'APEX_4._0_WIZARD_PROGRESS_SIDEBAR_CLICKABLE'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>'<div class="apex-wiz-bar">'
,p_list_template_after_rows=>'</div>'
,p_between_items=>'<div class="apex-wiz-arrow-small"></div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/horizontal_list_with_images_30px_c_htmldblistimages30px
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(2922135290041147207)
,p_list_template_current=>'<td align="center" valign="top"><a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# class="htmldbGreenIcon" /></a><a href="#LINK#" class="noVisit" title="#TEXT_ESC_SC#">#TEXT#</a></td>'
,p_list_template_noncurrent=>'<td align="center" valign="top"><a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# class="htmldbGreenIcon"/></a><a href="#LINK#" class="noVisit" title="#TEXT_ESC_SC#">#TEXT#</a></td>'
,p_list_template_name=>'Horizontal List with Images 30px (c:htmldbListImages30px)'
,p_internal_name=>'HORIZONTAL_LIST_WITH_IMAGES_30PX_C:HTMLDBLISTIMAGES30PX'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>'<table cellspacing="0" cellpadding="0" border="0" class="htmldbListImages30px" summary=""><tr>'
,p_list_template_after_rows=>'</tr></table>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/done_unordered_list_omit_current
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(2937959307089632175)
,p_list_template_current=>' '
,p_list_template_noncurrent=>'<li><a href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a></li>'
,p_list_template_name=>'(Done) Unordered List  (Omit Current)'
,p_internal_name=>'DONE_UNORDERED_LIST_OMIT_CURRENT'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="noIndent">'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(3065206012515940400)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(3157523106769548315)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>101
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(3271817654182082202)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>101
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(3276636485845180952)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>101
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(3331503598779942021)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>101
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_bar
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(3509379333604010550)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_name=>'APEX 5.0 - Menu Bar'
,p_internal_name=>'APEX_5.0_MENU_BAR'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menubar", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup( e );',
'}',
'e.menu({',
'  behaveLikeTabs: e.hasClass("js-tablike"),',
'  menubarShowSubMenuIcon: e.hasClass("js-showSubMenuIcon") || null,',
'  slide: e.hasClass("js-slide"),',
'  menubar: true,',
'});',
''))
,p_theme_id=>101
,p_theme_class_id=>7
,p_default_template_options=>'js-tabLike'
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menubar" class="#COMPONENT_CSS_CLASSES#"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_websheets_menu
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(3510331064015224024)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Websheets Menu'
,p_internal_name=>'APEX_5.0_WEBSHEETS_MENU'
,p_theme_id=>101
,p_theme_class_id=>7
,p_list_template_before_rows=>' '
,p_list_template_after_rows=>' '
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_app_cards
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(3516165623956683100)
,p_list_template_name=>'APEX 5.0 - App Cards'
,p_internal_name=>'APEX_5.0_APP_CARDS'
,p_theme_id=>101
,p_theme_class_id=>9
,p_list_template_before_rows=>' '
,p_list_template_after_rows=>' '
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_basic_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(3725901971624487519)
,p_list_template_current=>'<li class="a-List-item is-current"><a href="#LINK#" class="a-Links-link" #A02#>#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li class="a-List-item"><a href="#LINK#" class="a-Links-link" #A02#>#TEXT#</a></li>'
,p_list_template_name=>'APEX 5.0 - Basic List'
,p_internal_name=>'APEX_5.0_BASIC_LIST'
,p_theme_id=>101
,p_theme_class_id=>1
,p_list_template_before_rows=>'<ul class="a-List #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_basic_list_no_links
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(3725904394519503812)
,p_list_template_current=>'<li class="a-List-item is-current">#TEXT#</li>'
,p_list_template_noncurrent=>'<li class="a-List-item">#TEXT#</li>'
,p_list_template_name=>'APEX 5.0 - Basic List (no links)'
,p_internal_name=>'APEX_5.0_BASIC_LIST_NO_LINKS'
,p_theme_id=>101
,p_theme_class_id=>1
,p_list_template_before_rows=>'<ul class="a-List a-List--basic #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_sql_workshop_buttons_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(3825565596067563070)
,p_list_template_current=>'<button type="button" onclick="apex.navigation.redirect(''#LINK#'')" class="a-Button">#TEXT#</button>'
,p_list_template_noncurrent=>'<button type="button" onclick="apex.navigation.redirect(''#LINK#'')" class="a-Button">#TEXT#</button>'
,p_list_template_name=>'APEX 5.0 - SQL Workshop Buttons List'
,p_internal_name=>'APEX_5.0_SQL_WORKSHOP_BUTTONS_LIST'
,p_theme_id=>101
,p_theme_class_id=>0
,p_list_template_before_rows=>'<div class="a-Button-list">'
,p_list_template_after_rows=>'</div>'
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aSubTabs"><ul>',
'<li class="active"><a href="#LINK#" title="#TEXT_ESC_SC#"><span>#TEXT#</span></a></li>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/report/pages
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(2583678044278335201)
,p_row_template_name=>'Pages'
,p_internal_name=>'PAGES'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-PWList-item #PAGE_LI_CLASS# #PAGE_DRAGGABLE#" data-seq="#SORT_ORDER#">',
'  <span class="a-PWList-icon">#PAGE_ICON#</span>',
'  <span class="a-PWList-name">#PAGE_TITLE#</span>',
'  <span class="a-PWList-desc">#PAGE_DESC#</span>',
'  <span class="a-PWList-actions">#PAGE_ACTIONS#</span>',
'  #PAGE_DRAG_HANDLE#',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-PWList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>101
,p_theme_class_id=>7
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(2601299300702281738)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>101
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/eba_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(2604243400441774005)
,p_row_template_name=>'[EBA] Standard Report'
,p_internal_name=>'[EBA]_STANDARD_REPORT'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" border="0" cellspacing="0" summary="" #REPORT_ATTRIBUTES# id="report_#REGION_STATIC_ID#">#TOP_PAGINATION#',
'<tr>',
'<td><table class="ebaStandardReport" cellspacing="0" cellpadding="0" summary="#REGION_TITLE#" width="100%">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table><div class="CSV">#EXTERNAL_LINK##CSV_LINK#</div></td>',
'</tr>',
'#PAGINATION#',
'</table>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_next_page_template=>'<a href="#LINK#" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_page_template=>'<a href="#LINK#" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_next_set_template=>'<a href="#LINK#" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="#LINK#" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>101
,p_theme_class_id=>7
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(2626935888845593317)
,p_row_template_name=>'APEX 5.0 - Portlet Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>101
,p_theme_class_id=>0
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(2630679288769520822)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>101
,p_theme_class_id=>7
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/vertical_standard_c_htmldbverticalregion2
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(2665894019428237001)
,p_row_template_name=>'Vertical Standard (c:htmldbVerticalRegion2)'
,p_internal_name=>'VERTICAL_STANDARD_C:HTMLDBVERTICALREGION2'
,p_row_template1=>'<tr><td scope="row" class="label">#COLUMN_HEADER#</td><td class="data">#COLUMN_VALUE#</td></tr>'
,p_row_template_before_rows=>'#CSV_LINK#<table class="htmldbVerticalRegion2"  summary="#REGION_TITLE#" cellpadding="0" cellspacing="0" border="0">'
,p_row_template_after_rows=>'</table>'
,p_row_template_before_first=>' '
,p_row_template_after_last=>'<tr><td class="blank"><br /></td><td class="blank"><br /></td></tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>101
,p_theme_class_id=>0
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(2707641403506668051)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>101
,p_theme_class_id=>7
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/icon_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(2718432304985775346)
,p_row_template_name=>'Icon Report'
,p_internal_name=>'ICON_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100" style="float:left;margin:10px;">',
'<tr><td align="center"><a href="#3#"><img src="#IMAGE_PREFIX##1#" title="#2#" alt="#2#" style="display:block;"/></a></td></tr>',
'<tr><td align="center"><a href="#3#" class="htmldbIconName">#4#</a></td></tr>',
'</table>',
'<br style="clear:both;" />'))
,p_row_template_condition1=>'mod (#ROWNUM#, 5) = 0'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100" style="float:left;margin:10px;">',
'<tr><td align="center"><a href="#3#"><img src="#IMAGE_PREFIX##1#" title="#2#" alt="#2#" style="display:block;"/></a></td></tr>',
'<tr><td align="center"><a href="#3#" class="htmldbIconName">#4#</a></td></tr>',
'</table>'))
,p_row_template_before_rows=>'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table class="htmldbListIconHolder" border="0" cellpadding="0" cellpadding="0" summary="">#TOP_PAGINATION#<tr><td>'
,p_row_template_after_rows=>'</td></tr>#PAGINATION#</table></htmldb:#REGION_ID#></div>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_theme_id=>101
,p_theme_class_id=>7
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/vertical_no_background
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(2756563315870700241)
,p_row_template_name=>'Vertical - No Background'
,p_internal_name=>'VERTICAL_NO_BACKGROUND'
,p_row_template1=>'<tr><th scope="row" align="right">#COLUMN_HEADER#</th><td>#COLUMN_VALUE#</td></tr>'
,p_row_template_before_rows=>'#CSV_LINK#<table class="htmldbVerticalRptPlain" summary="#REGION_TITLE#" cellpadding="0" cellspacing="0" border="0">'
,p_row_template_after_rows=>'</table>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>101
,p_theme_class_id=>0
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/no_background
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(2821784192166554137)
,p_row_template_name=>'No Background'
,p_internal_name=>'NO_BACKGROUND'
,p_row_template1=>'<td#ALIGNMENT# id="td#ROWNUM#_#COLNUM#" headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" class="htmldbRptNoBackground" summary="#REGION_TITLE#">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table>'))
,p_row_template_before_first=>'<tr id="row#ROWNUM#">'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>101
,p_theme_class_id=>7
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/4500_database_browser_trigger_body
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(2938873490424743044)
,p_row_template_name=>'(4500) Database Browser Trigger Body'
,p_internal_name=>'4500_DATABASE_BROWSER_TRIGGER_BODY'
,p_row_template1=>'<pre>#TRIGGER_BODY#</pre>'
,p_row_template_before_rows=>'<table><tr><td>'
,p_row_template_after_rows=>'</td></tr></table>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>101
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(3072403539858088941)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>101
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(3272975836994283240)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>101
,p_theme_class_id=>6
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(3516183932083974422)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AppCards a-AppCards--slim  a-AppCards--stacked">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>101
,p_theme_class_id=>7
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_vertical_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(3710840215749602833)
,p_row_template_name=>'APEX 5.0 - Vertical Report'
,p_internal_name=>'APEX_5.0_VERTICAL_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<tr>',
'  <td class="a-Report-cell a-Report-cell--header" scope="row">#COLUMN_HEADER#</td>',
'  <td class="a-Report-cell">#COLUMN_VALUE#</td>',
'</tr>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report a-Report--vertical a-Report--staticRowColors #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" summary="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>' '
,p_row_template_after_last=>' '
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>101
,p_theme_class_id=>7
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/outline_label_optional
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(2584586946052082315)
,p_template_name=>'Outline Label - Optional'
,p_internal_name=>'OUTLINE_LABEL_OPTIONAL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="field-label__container field-col-3">',
'<label class="field-label" id="#CURRENT_ITEM_ID#_LABEL" for="#CURRENT_ITEM_NAME#">',
'<label for="#CURRENT_ITEM_NAME#" tabindex="999">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="field field--style--boxed #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="field-input__container field-col-9">',
'<div class="field-input__wrap">'))
,p_after_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</div>',
'</div>',
'#ERROR_TEMPLATE#',
'#HELP_TEMPLATE#',
'#INLINE_HELP_TEMPLATE#'))
,p_inline_help_text=>'<span class="inline-help">#CURRENT_ITEM_INLINE_HELP_TEXT#</span>'
,p_error_template=>'<div class="field-error-message">#ERROR_MESSAGE#</div>'
,p_theme_id=>101
,p_theme_class_id=>3
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(2588818597804368344)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>101
,p_theme_class_id=>13
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/outline_label_required
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(2716804030064502999)
,p_template_name=>'Outline Label - Required'
,p_internal_name=>'OUTLINE_LABEL_-_REQUIRED'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="field-label__container field-col-3">',
'<label class="field-label" id="#CURRENT_ITEM_ID#_LABEL" for="#CURRENT_ITEM_NAME#">',
'<label for="#CURRENT_ITEM_NAME#" tabindex="999">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="field field--style--boxed field--required #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="field-input__container field-col-9">',
'<div class="field-input__wrap">'))
,p_after_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</div>',
'</div>',
'#ERROR_TEMPLATE#',
'#HELP_TEMPLATE#',
'#INLINE_HELP_TEMPLATE#'))
,p_inline_help_text=>'<span class="inline-help">#CURRENT_ITEM_INLINE_HELP_TEXT#</span>'
,p_error_template=>'<div class="field-error-message">#ERROR_MESSAGE#</div>'
,p_theme_id=>101
,p_theme_class_id=>3
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(2764373305086284113)
,p_template_name=>'Dynamic Attribute'
,p_internal_name=>'DYNAMIC_ATTRIBUTE'
,p_template_body1=>'<em>*</em><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="aLabel aRequired"><a href="javascript:apex.builder.dynamicAttributes.help(''&FB_FLOW_ID.'',''#CURRENT_ITEM_NAME#'');" tabindex="999">'
,p_template_body2=>' <span class="hideMeButHearMe">(#VALUE_REQUIRED#)</span></a></label>'
,p_theme_id=>101
,p_theme_class_id=>1
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/formfield_optional_with_br
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(2771230409799238960)
,p_template_name=>'FormField_Optional with BR'
,p_internal_name=>'FORMFIELD_OPTIONAL_WITH_BR'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#"><a class="help optional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label><br />&nbsp;'
,p_theme_id=>101
,p_theme_class_id=>1
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/formfield_required_with_br
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(2771230604641238960)
,p_template_name=>'FormField_Required with BR'
,p_internal_name=>'FORMFIELD_REQUIRED_WITH_BR'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#"><a class="help required" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999"><img alt="#VALUE_REQUIRED#" src="#IMAGE_PREFIX#requiredicon_status2.gif" />'
,p_template_body2=>'</a></label><br />&nbsp;'
,p_theme_id=>101
,p_theme_class_id=>2
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(3071359248210082306)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>101
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(3071359888141100707)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>101
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(3076592553081438826)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>101
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(3076592627306440115)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>101
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(3271822809773116508)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>101
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(3276597163598826691)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="" aria-label="" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span>'
||'</button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>101
,p_theme_class_id=>1
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_workspace_login_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(3365552608730662744)
,p_template_name=>'APEX 5.0 - Workspace Login Label'
,p_internal_name=>'APEX_5.0_WORKSPACE_LOGIN_LABEL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Icon a-Login-iconLabel">'
,p_template_body2=>'</label>'
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#"><div class="a-Form-inputContainer">'
,p_after_item=>'</div></div>'
,p_after_element=>'<span class="a-Login-iconValidation a-Icon icon-check"></span>#ERROR_TEMPLATE#'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span class="u-VisuallyHidden">#CURRENT_ITE'
||'M_HELP_LABEL#</span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>101
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader_with_span
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(3835008919990537112)
,p_template_name=>'Hidden label, read by screen reader with SPAN'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER_WITH_SPAN'
,p_template_body1=>'<span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label></span>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>101
,p_theme_class_id=>13
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(3273201397272801603)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>101
,p_theme_class_id=>1
,p_reference_id=>689285808648404711
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(2601258703618978764)
,p_page_name=>'winlov'
,p_page_title=>'Search Dialog'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>'Search'
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>'Close'
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>'Next &gt;'
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>'&lt; Previous'
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>101
,p_theme_class_id=>1
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(2937825491492752143)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table> ',
' <tr>',
'   <td> ',
'     <table width="100%" class="htmldbGrayBox" cellspacing="0" cellpadding="0" border="0" summary="layout">',
'       <tr><td align="center" class="htmldbGrayBoxHeader">#IMONTH#</td></td></tr>',
'     </table>',
'   </td>',
' </tr>'))
,p_month_open_format=>'<table summary="#CALENDAR_TITLE# #IMONTH# #YYYY#"  border="0" cellpadding="0" cellspacing="0" class="htmldbRowWithBorders" width="100%"><tr>'
,p_month_close_format=>'</tr></table></table>'
,p_day_title_format=>'<div class="calday">#DD#</div>'
,p_day_open_format=>'<td valign="top" class="calweekday">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="caltoday" style="background:#c5d5c5">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="calday">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="calweekend">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'&nbsp;'
,p_nonday_open_format=>'<td class="calnotmonth">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</td></tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>101
,p_theme_class_id=>1
,p_reference_id=>0
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/htmldb_calendar_from_4350
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(2937840903200925859)
,p_cal_template_name=>'HTMLDB Calendar from 4350'
,p_internal_name=>'HTMLDB_CALENDAR_FROM_4350'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>101
,p_theme_class_id=>1
,p_reference_id=>0
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/subscribe_of_htmldb_calendar_from_4350
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(2938985015947681963)
,p_cal_template_name=>'subscribe of HTMLDB Calendar from 4350'
,p_internal_name=>'SUBSCRIBE_OF_HTMLDB_CALENDAR_FROM_4350'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>101
,p_theme_class_id=>1
,p_reference_id=>0
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
wwv_flow_api.create_theme(
 p_id=>wwv_flow_api.id(2659055193535481590)
,p_theme_id=>101
,p_theme_name=>'APEX 5.0'
,p_theme_internal_name=>'APEX_5.0'
,p_ui_type_name=>'DESKTOP'
,p_navigation_type=>'T'
,p_nav_bar_type=>'NAVBAR'
,p_is_locked=>false
,p_default_page_template=>wwv_flow_api.id(3221353480673840388)
,p_default_dialog_template=>wwv_flow_api.id(3272976625713321802)
,p_default_nav_list_position=>'TOP'
,p_default_dialogbtnr_template=>wwv_flow_api.id(3271069058970016268)
,p_default_dialogr_template=>wwv_flow_api.id(3300810815961795652)
,p_default_page_transition=>'NONE'
,p_default_popup_transition=>'NONE'
,p_theme_description=>'APEX 5.0 - Builder Theme'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_theme_file_prefix(101),'')
,p_css_file_urls=>'#IMAGE_PREFIX#libraries/oracle-fonts/oraclesans-apex#MIN#.css?v=#APEX_VERSION#'
);
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(72329795312505899)
,p_theme_id=>101
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(556395613003092800)
,p_theme_id=>101
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(556395924287093657)
,p_theme_id=>101
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(2787940904864180601)
,p_theme_id=>101
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3272947108403853347)
,p_theme_id=>101
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3272948091579864086)
,p_theme_id=>101
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3272952033767924344)
,p_theme_id=>101
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3272954073059959815)
,p_theme_id=>101
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3272956807976997233)
,p_theme_id=>101
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3272957635263003437)
,p_theme_id=>101
,p_name=>'MIN_HEIGHT'
,p_display_name=>'Min Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'No Min Height'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3272957927201004807)
,p_theme_id=>101
,p_name=>'MAX_HEIGHT'
,p_display_name=>'Max Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'No Max Height'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3272966786960085403)
,p_theme_id=>101
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3272966998825101372)
,p_theme_id=>101
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3272967382281109834)
,p_theme_id=>101
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3272969904335143676)
,p_theme_id=>101
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3272971965975243949)
,p_theme_id=>101
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3272972266905244890)
,p_theme_id=>101
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3273503711535111804)
,p_theme_id=>101
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3273504100166113788)
,p_theme_id=>101
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3273504670519116433)
,p_theme_id=>101
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3273504927909124382)
,p_theme_id=>101
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3273505268873125534)
,p_theme_id=>101
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3273505950760134683)
,p_theme_id=>101
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3273878259726558568)
,p_theme_id=>101
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3276635722597176199)
,p_theme_id=>101
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3280531346127474880)
,p_theme_id=>101
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3281138953904089269)
,p_theme_id=>101
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3286594514783296583)
,p_theme_id=>101
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3286594887959299057)
,p_theme_id=>101
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3286595166349303494)
,p_theme_id=>101
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3286597037907377132)
,p_theme_id=>101
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3286597541894380105)
,p_theme_id=>101
,p_name=>'TEXT_ALIGNMENT'
,p_display_name=>'Text Alignment'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3330283282906664432)
,p_theme_id=>101
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3554578106749597184)
,p_theme_id=>101
,p_name=>'FORM_ITEM_ALIGNMENT'
,p_display_name=>'Form Item Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'This option controls how form items are aligned.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(3725370028670731644)
,p_theme_id=>101
,p_name=>'DIALOG_SIZE'
,p_display_name=>'Dialog Size'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Predefined dialog sizes'
,p_null_text=>'Default Size'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3262270231652718591)
,p_theme_id=>101
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(3262269949210718587)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3262270571570718591)
,p_theme_id=>101
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3262269949210718587)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272945950492849549)
,p_theme_id=>101
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3271069058970016268)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272947553810857499)
,p_theme_id=>101
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3271069058970016268)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(3272947108403853347)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272947826253860428)
,p_theme_id=>101
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3271069058970016268)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(3272947108403853347)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272948903374868569)
,p_theme_id=>101
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3271069058970016268)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272949699167870094)
,p_theme_id=>101
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3271069058970016268)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272950049203873528)
,p_theme_id=>101
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3271069058970016268)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272951079760914115)
,p_theme_id=>101
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(2758664310411868479)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272951692319920329)
,p_theme_id=>101
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(2758664310411868479)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272952701469928429)
,p_theme_id=>101
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(2758664310411868479)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(3272952033767924344)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272952954669936274)
,p_theme_id=>101
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(2758664310411868479)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(3272947108403853347)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272954255910963039)
,p_theme_id=>101
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(2758664310411868479)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(3272954073059959815)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272954430217969881)
,p_theme_id=>101
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(2758664310411868479)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(3272954073059959815)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272961138986029754)
,p_theme_id=>101
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(3272956807976997233)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272961370887030558)
,p_theme_id=>101
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(3272956807976997233)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272961542151031342)
,p_theme_id=>101
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(3272956807976997233)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272962358006037974)
,p_theme_id=>101
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(3272956807976997233)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272962503845038900)
,p_theme_id=>101
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(3272956807976997233)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272962747536039753)
,p_theme_id=>101
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(3272956807976997233)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272967834831123581)
,p_theme_id=>101
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(2707641403506668051)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(3272966998825101372)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272968057448126165)
,p_theme_id=>101
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(2707641403506668051)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(3272967382281109834)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272968191501129345)
,p_theme_id=>101
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(2707641403506668051)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(3272966786960085403)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272968445819130771)
,p_theme_id=>101
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(2707641403506668051)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(3272966786960085403)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272968608246132125)
,p_theme_id=>101
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(2707641403506668051)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(3272966786960085403)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272968919298136815)
,p_theme_id=>101
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(2707641403506668051)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272970278790147380)
,p_theme_id=>101
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(2707641403506668051)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(3272969904335143676)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272972869034260434)
,p_theme_id=>101
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(3272971965975243949)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272973086671262192)
,p_theme_id=>101
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(3272971965975243949)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272973253261263303)
,p_theme_id=>101
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(3272971965975243949)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272973474743265141)
,p_theme_id=>101
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(3272971965975243949)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272973618033266123)
,p_theme_id=>101
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(3272971965975243949)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272973800081267332)
,p_theme_id=>101
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(3272971965975243949)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272974009431268450)
,p_theme_id=>101
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(3272971965975243949)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272974260327270307)
,p_theme_id=>101
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(3272971965975243949)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272974443197272653)
,p_theme_id=>101
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(3272972266905244890)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272974653554274369)
,p_theme_id=>101
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(3272972266905244890)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272974882723275389)
,p_theme_id=>101
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(3272972266905244890)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272975023683276305)
,p_theme_id=>101
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(3272972266905244890)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3272975227337277311)
,p_theme_id=>101
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(3072403539858088941)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(3272972266905244890)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3273718461755706170)
,p_theme_id=>101
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(3273503711535111804)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3273718623962707342)
,p_theme_id=>101
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(3273503711535111804)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3273718890233708711)
,p_theme_id=>101
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(3273503711535111804)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3273719305891709940)
,p_theme_id=>101
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(3273504100166113788)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3273719586640711433)
,p_theme_id=>101
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(3273504100166113788)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3273719839810712886)
,p_theme_id=>101
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(3273504670519116433)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3273720340946719858)
,p_theme_id=>101
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(3273504927909124382)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3273720525579721240)
,p_theme_id=>101
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(3273504927909124382)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3273720760921722468)
,p_theme_id=>101
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(3273505268873125534)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3273720931877723703)
,p_theme_id=>101
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(3273505268873125534)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3273721140780728323)
,p_theme_id=>101
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3273871817323525718)
,p_theme_id=>101
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3273871575473525717)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3273872411843525718)
,p_theme_id=>101
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3273871575473525717)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3273872723948525718)
,p_theme_id=>101
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3273871575473525717)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3273873057755525719)
,p_theme_id=>101
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3273871575473525717)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3273873290844525719)
,p_theme_id=>101
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3273871575473525717)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(3272952033767924344)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3273873638536525720)
,p_theme_id=>101
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3273871575473525717)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(3272947108403853347)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3273875126148525721)
,p_theme_id=>101
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3273871575473525717)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(3272954073059959815)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3273875409775525721)
,p_theme_id=>101
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3273871575473525717)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(3272954073059959815)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3273878789688562715)
,p_theme_id=>101
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(3273871575473525717)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(3273878259726558568)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3273879016540564402)
,p_theme_id=>101
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3273871575473525717)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(3273878259726558568)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3276607386083938689)
,p_theme_id=>101
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(3271817654182082202)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3276636838044198487)
,p_theme_id=>101
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(3276636485845180952)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(3276635722597176199)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3276637064796202531)
,p_theme_id=>101
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(3276636485845180952)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(3276635722597176199)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3276637209671203375)
,p_theme_id=>101
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(3276636485845180952)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(3276635722597176199)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3276637476000204461)
,p_theme_id=>101
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(3276636485845180952)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(3276635722597176199)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3276637736156208731)
,p_theme_id=>101
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(3276636485845180952)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(3276635722597176199)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3276637961098212818)
,p_theme_id=>101
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(3276636485845180952)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3276638122293218782)
,p_theme_id=>101
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(3276636485845180952)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3276638304849219441)
,p_theme_id=>101
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(3276636485845180952)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3276638548238221517)
,p_theme_id=>101
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(3276636485845180952)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3277479810838089753)
,p_theme_id=>101
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(2758664310411868479)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(3272948091579864086)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3280532169788485511)
,p_theme_id=>101
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3271069058970016268)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(3280531346127474880)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3280694720327105304)
,p_theme_id=>101
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3271069058970016268)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(3280531346127474880)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3280963863176791327)
,p_theme_id=>101
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(2758664310411868479)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(3280531346127474880)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3280964065307793861)
,p_theme_id=>101
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(2758664310411868479)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(3280531346127474880)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3281117036334023852)
,p_theme_id=>101
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(3276636485845180952)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3281139167748092929)
,p_theme_id=>101
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(2644135096780537975)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3281139506990094782)
,p_theme_id=>101
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(2644135096780537975)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3281140071999096157)
,p_theme_id=>101
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(2644135096780537975)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3281141078804098444)
,p_theme_id=>101
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(2644135096780537975)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3281141213641100590)
,p_theme_id=>101
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(2644135096780537975)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(3281138953904089269)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3281141448555102030)
,p_theme_id=>101
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(2644135096780537975)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(3281138953904089269)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3281266536726867367)
,p_theme_id=>101
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(2601299300702281738)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3281266773648869208)
,p_theme_id=>101
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(2601299300702281738)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3281266966728871945)
,p_theme_id=>101
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(2601299300702281738)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3282714713448775707)
,p_theme_id=>101
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3282745129348275835)
,p_theme_id=>101
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3282744828018275829)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(3280531346127474880)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3282746679230275837)
,p_theme_id=>101
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3282744828018275829)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(3272954073059959815)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3282746942441275837)
,p_theme_id=>101
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3282744828018275829)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(3272947108403853347)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3282747278902275837)
,p_theme_id=>101
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(3282744828018275829)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(3272948091579864086)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3282747839142275838)
,p_theme_id=>101
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3282744828018275829)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(3280531346127474880)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3282748118484275838)
,p_theme_id=>101
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(3282744828018275829)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3282748411243275838)
,p_theme_id=>101
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3282744828018275829)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(3272954073059959815)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3282749059124275838)
,p_theme_id=>101
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3282744828018275829)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(3272952033767924344)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3282749318955275838)
,p_theme_id=>101
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(3282744828018275829)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3282842053625616201)
,p_theme_id=>101
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3286595597781327418)
,p_theme_id=>101
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(3286594514783296583)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3286595827879334751)
,p_theme_id=>101
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(3286595166349303494)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3286596084244340067)
,p_theme_id=>101
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(3286594887959299057)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3286596280219344757)
,p_theme_id=>101
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(3286594887959299057)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3286596436853346451)
,p_theme_id=>101
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(3286594887959299057)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3286596758659356442)
,p_theme_id=>101
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(3286594887959299057)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3286598178674389540)
,p_theme_id=>101
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(3286597037907377132)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3321665041873928813)
,p_theme_id=>101
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3321664782165928798)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(3280531346127474880)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3321665488779928817)
,p_theme_id=>101
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3321664782165928798)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(3272954073059959815)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3321665693602928818)
,p_theme_id=>101
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(3321664782165928798)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(3272948091579864086)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3321665940405928818)
,p_theme_id=>101
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3321664782165928798)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(3280531346127474880)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3321666009451928818)
,p_theme_id=>101
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(3321664782165928798)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3321666098572928818)
,p_theme_id=>101
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3321664782165928798)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(3272954073059959815)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3321666463761928818)
,p_theme_id=>101
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(3321664782165928798)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3324985134819362058)
,p_theme_id=>101
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3262269949210718587)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3330280566372621950)
,p_theme_id=>101
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3330277939666606656)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3330280598646623793)
,p_theme_id=>101
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3330277939666606656)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3330280783108625349)
,p_theme_id=>101
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3330277939666606656)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3330284462355675023)
,p_theme_id=>101
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3330277939666606656)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(3330283282906664432)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3330284727365676939)
,p_theme_id=>101
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3330277939666606656)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(3330283282906664432)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3330285032641678042)
,p_theme_id=>101
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3330277939666606656)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(3330283282906664432)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3330285174248679384)
,p_theme_id=>101
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3330277939666606656)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(3330283282906664432)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3330286246965689845)
,p_theme_id=>101
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3330277939666606656)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(3273878259726558568)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3330286358960690808)
,p_theme_id=>101
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3330277939666606656)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(3273878259726558568)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3331512237109010498)
,p_theme_id=>101
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3331511935591010485)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(3280531346127474880)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3331512316830010502)
,p_theme_id=>101
,p_name=>'ADDBOTTOMBORDER'
,p_display_name=>'Add Bottom Border'
,p_display_sequence=>13
,p_region_template_id=>wwv_flow_api.id(3331511935591010485)
,p_css_classes=>'a-Region--bottomBorder'
,p_template_types=>'REGION'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3331512405035010502)
,p_theme_id=>101
,p_name=>'ADDLEFTBORDER'
,p_display_name=>'Add Left Border'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(3331511935591010485)
,p_css_classes=>'a-Region--borderLeft'
,p_template_types=>'REGION'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3331512520332010502)
,p_theme_id=>101
,p_name=>'ADDRIGHTBORDER'
,p_display_name=>'Add Right Border'
,p_display_sequence=>11
,p_region_template_id=>wwv_flow_api.id(3331511935591010485)
,p_css_classes=>'a-Region--rightBorder'
,p_template_types=>'REGION'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3331512588720010502)
,p_theme_id=>101
,p_name=>'ADDTOPBORDER'
,p_display_name=>'Add Top Border'
,p_display_sequence=>12
,p_region_template_id=>wwv_flow_api.id(3331511935591010485)
,p_css_classes=>'a-Region--borderTop'
,p_template_types=>'REGION'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3331512751548010502)
,p_theme_id=>101
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3331511935591010485)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(3272954073059959815)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3331512886222010502)
,p_theme_id=>101
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3331511935591010485)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(3272947108403853347)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3331512929493010502)
,p_theme_id=>101
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(3331511935591010485)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(3272948091579864086)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3331513066778010502)
,p_theme_id=>101
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3331511935591010485)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3331513163911010502)
,p_theme_id=>101
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3331511935591010485)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(3280531346127474880)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3331513197967010502)
,p_theme_id=>101
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(3331511935591010485)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3331513365716010502)
,p_theme_id=>101
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3331511935591010485)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(3272954073059959815)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3331513444572010502)
,p_theme_id=>101
,p_name=>'SHOWTOPBUTTON'
,p_display_name=>'Show Top Button'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3331511935591010485)
,p_css_classes=>'a-Region--showTopButton'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3334695364652936397)
,p_theme_id=>101
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(2758664310411868479)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3335163087575149954)
,p_theme_id=>101
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3282744828018275829)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3342634157267201409)
,p_theme_id=>101
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(2988804730938183125)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(3273505950760134683)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3509387538140015679)
,p_theme_id=>101
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(3509379333604010550)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3509387639047016742)
,p_theme_id=>101
,p_name=>'BEHAVE_LIKE_TABS'
,p_display_name=>'Behave Like Tabs'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(3509379333604010550)
,p_css_classes=>'js-tabLike'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3509387743072017994)
,p_theme_id=>101
,p_name=>'SHOW_SUB_MENU_ICON'
,p_display_name=>'Show Sub Menu Icon'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(3509379333604010550)
,p_css_classes=>'js-showSubMenuIcon'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3509387792807019253)
,p_theme_id=>101
,p_name=>'ENABLE_SLIDE_ANIMATION'
,p_display_name=>'Enable Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(3509379333604010550)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3509438556564410728)
,p_theme_id=>101
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(3331503598779942021)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3509438684549411763)
,p_theme_id=>101
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(3331503598779942021)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3554588139973710662)
,p_theme_id=>101
,p_name=>'FLOAT_ITEMS_LEFT'
,p_display_name=>'Float Items Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--floatFieldsLeft'
,p_group_id=>wwv_flow_api.id(3554578106749597184)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to float fields within a region to the left. The width of the field container will be calculated automatically. This option will allow you to position a button or other items immediately after other items.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3554588421152717051)
,p_theme_id=>101
,p_name=>'FLOAT_COLUMNS_LEFT'
,p_display_name=>'Float Columns Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--floatColsLeft'
,p_group_id=>wwv_flow_api.id(3554578106749597184)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to align grid columns within the region to the left. This option will allow you to align multiple columns of items next to each other.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3557616757869674565)
,p_theme_id=>101
,p_name=>'INLINE_FIELD'
,p_display_name=>'Inline Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--floatLeft'
,p_template_types=>'FIELD'
,p_help_text=>'Makes the field container for this item appear inline, so buttons or other objects immediately after show up on same line.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3650400464957171179)
,p_theme_id=>101
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(2758664310411868479)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(3272947108403853347)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3710840678302602842)
,p_theme_id=>101
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(3710840215749602833)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(3272967382281109834)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3710840717632602842)
,p_theme_id=>101
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(3710840215749602833)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(3272966786960085403)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3710840865939602843)
,p_theme_id=>101
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(3710840215749602833)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3710840901494602844)
,p_theme_id=>101
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(3710840215749602833)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(3272966786960085403)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3710841004886602845)
,p_theme_id=>101
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(3710840215749602833)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(3272969904335143676)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3710841122695602846)
,p_theme_id=>101
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(3710840215749602833)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(3272966786960085403)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3721723635433266832)
,p_theme_id=>101
,p_name=>'RESIZABLE'
,p_display_name=>'Resizable'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(3012513290302116971)
,p_css_classes=>'js-resizable'
,p_template_types=>'REGION'
,p_help_text=>'Allow dialog to be resized.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3721729533748272817)
,p_theme_id=>101
,p_name=>'DRAGGABLE'
,p_display_name=>'Draggable'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3012513290302116971)
,p_css_classes=>'js-draggable'
,p_template_types=>'REGION'
,p_help_text=>'Allow dialog to be moved.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3725370863738746403)
,p_theme_id=>101
,p_name=>'SMALL_480X320'
,p_display_name=>'Small (480x320)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3012513290302116971)
,p_css_classes=>'js-dialog-size480x320'
,p_group_id=>wwv_flow_api.id(3725370028670731644)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3725371274535749580)
,p_theme_id=>101
,p_name=>'LARGE_720X480'
,p_display_name=>'Large (720x480)'
,p_display_sequence=>3
,p_region_template_id=>wwv_flow_api.id(3012513290302116971)
,p_css_classes=>'js-dialog-size720x480'
,p_group_id=>wwv_flow_api.id(3725370028670731644)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3725374150645793950)
,p_theme_id=>101
,p_name=>'MODAL'
,p_display_name=>'Modal'
,p_display_sequence=>3
,p_region_template_id=>wwv_flow_api.id(3012513290302116971)
,p_css_classes=>'js-modal'
,p_template_types=>'REGION'
,p_help_text=>'Display as modal.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3726150615094251075)
,p_theme_id=>101
,p_name=>'MEDIUM_600X400'
,p_display_name=>'Medium (600x400)'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(3012513290302116971)
,p_css_classes=>'js-dialog-size600x400'
,p_group_id=>wwv_flow_api.id(3725370028670731644)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3741610224559929677)
,p_theme_id=>101
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3741609957292929669)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(3280531346127474880)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3741610384701929678)
,p_theme_id=>101
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3741609957292929669)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(3272954073059959815)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3741610396048929678)
,p_theme_id=>101
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3741609957292929669)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(3272947108403853347)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3741610528314929678)
,p_theme_id=>101
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(3741609957292929669)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(3272948091579864086)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3741610624572929678)
,p_theme_id=>101
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3741609957292929669)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(3280531346127474880)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3741610694805929678)
,p_theme_id=>101
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(3741609957292929669)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3741610807878929679)
,p_theme_id=>101
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3741609957292929669)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3741610894122929679)
,p_theme_id=>101
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3741609957292929669)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(3272954073059959815)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3741611021915929679)
,p_theme_id=>101
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3741609957292929669)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(3272952033767924344)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3741611178660929679)
,p_theme_id=>101
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3741609957292929669)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(3272947108403853347)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3741611246435929679)
,p_theme_id=>101
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(3741609957292929669)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(3272948091579864086)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(3825581410111791772)
,p_theme_id=>101
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(3731195891703350618)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
wwv_flow_api.create_language_map(
 p_id=>wwv_flow_api.id(2630752535760111599)
,p_translation_flow_id=>4021
,p_translation_flow_language_cd=>'es'
,p_direction_right_to_left=>'N'
);
wwv_flow_api.create_language_map(
 p_id=>wwv_flow_api.id(2630752645278111599)
,p_translation_flow_id=>4022
,p_translation_flow_language_cd=>'fr'
,p_direction_right_to_left=>'N'
);
wwv_flow_api.create_language_map(
 p_id=>wwv_flow_api.id(2630752735909111599)
,p_translation_flow_id=>4023
,p_translation_flow_language_cd=>'de'
,p_direction_right_to_left=>'N'
);
wwv_flow_api.create_language_map(
 p_id=>wwv_flow_api.id(2630752838102111599)
,p_translation_flow_id=>4024
,p_translation_flow_language_cd=>'it'
,p_direction_right_to_left=>'N'
);
wwv_flow_api.create_language_map(
 p_id=>wwv_flow_api.id(2630752930302111599)
,p_translation_flow_id=>4025
,p_translation_flow_language_cd=>'pt-br'
,p_direction_right_to_left=>'N'
);
wwv_flow_api.create_language_map(
 p_id=>wwv_flow_api.id(2630753022663111599)
,p_translation_flow_id=>4026
,p_translation_flow_language_cd=>'zh-cn'
,p_direction_right_to_left=>'N'
);
wwv_flow_api.create_language_map(
 p_id=>wwv_flow_api.id(2630753118245111599)
,p_translation_flow_id=>4027
,p_translation_flow_language_cd=>'zh-tw'
,p_direction_right_to_left=>'N'
);
wwv_flow_api.create_language_map(
 p_id=>wwv_flow_api.id(2630753225782111599)
,p_translation_flow_id=>4028
,p_translation_flow_language_cd=>'ko'
,p_direction_right_to_left=>'N'
);
wwv_flow_api.create_language_map(
 p_id=>wwv_flow_api.id(2630753343539111600)
,p_translation_flow_id=>4029
,p_translation_flow_language_cd=>'ja'
,p_direction_right_to_left=>'N'
);
end;
/
prompt --application/shared_components/logic/build_options
begin
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(246928993153707476)
,p_build_option_name=>'NEVER'
,p_build_option_status=>'EXCLUDE'
,p_default_on_export=>'EXCLUDE'
,p_on_upgrade_keep_status=>true
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(366100516974803533)
,p_build_option_name=>'email style master detail'
,p_build_option_status=>'INCLUDE'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(641974235841696132)
,p_build_option_name=>'Enable APEX Internal Feedback'
,p_build_option_status=>'EXCLUDE'
,p_default_on_export=>'EXCLUDE'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(2605452072303844293)
,p_build_option_name=>'company address'
,p_build_option_status=>'EXCLUDE'
,p_build_option_comment=>'we can avoid asking internal Oracle folks for address info'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(2698024371153404344)
,p_build_option_name=>'Advanced Form'
,p_build_option_status=>'INCLUDE'
,p_build_option_comment=>'Include the ability to define advanced master detail forms.'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(2698024578226405812)
,p_build_option_name=>'Language Selection'
,p_build_option_status=>'INCLUDE'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(2698024775220408056)
,p_build_option_name=>'Authentication Selection'
,p_build_option_status=>'INCLUDE'
,p_build_option_comment=>'Allow developer to select application at time of application creation'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(2746942411136297678)
,p_build_option_name=>'Dashboard'
,p_build_option_status=>'INCLUDE'
,p_build_option_comment=>'Include the ability to create dashboard pages.'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(3027829547778015556)
,p_build_option_name=>'Advanced Application Settings'
,p_build_option_status=>'INCLUDE'
,p_build_option_comment=>'Include the advanced application options as part of the create application wizard.'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(3027830547707021532)
,p_build_option_name=>'application defaults'
,p_build_option_status=>'INCLUDE'
,p_on_upgrade_keep_status=>true
,p_build_option_comment=>'ability to specify user interface defaults, lists of values etc.'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(3027985170417035432)
,p_build_option_name=>'Blueprints'
,p_build_option_status=>'INCLUDE'
,p_build_option_comment=>'Allow for viewing and editing of application blue prints.'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(3124271964326242195)
,p_build_option_name=>'supporting objects'
,p_build_option_status=>'EXCLUDE'
,p_build_option_comment=>'when creating a new application, allow the inclusion of supporting object scripts'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(3145295462075987142)
,p_build_option_name=>'drill down reporting'
,p_build_option_status=>'INCLUDE'
,p_build_option_comment=>'ability to link a column on one report to another report'
);
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(3302267091071310861)
,p_name=>'ADMINISTRATORS'
,p_message_text=>'Administrators'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(3302269296296316452)
,p_name=>'ALL_USERS'
,p_message_text=>'All Users'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(79657768024939288)
,p_name=>'CREATE.APP.SELECT_AT_LEAST_ONE_TABLE'
,p_message_text=>'Please select at least one table name to add the page.'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(3351293939745557004)
,p_name=>'REPORT'
,p_message_text=>'Report'
);
null;
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/user_interface/shortcuts/delete_page_confirm_msg
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(2647222231143044328)
,p_shortcut_name=>'DELETE_PAGE_CONFIRM_MSG'
,p_shortcut_type=>'FUNCTION_BODY'
,p_shortcut_language=>'PLSQL'
,p_shortcut=>'return replace( wwv_flow_lang.custom_runtime_message( p_name => ''CA.DELETE.CONFIRM'' ),'''''''',''\'''''');'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/creating_application
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(2717735057626016839)
,p_shortcut_name=>'CREATING_APPLICATION'
,p_shortcut_type=>'FUNCTION_BODY'
,p_shortcut_language=>'PLSQL'
,p_shortcut=>'return replace( wwv_flow_lang.custom_runtime_message( p_name => ''CA.CREATING.APPLICATION'' ),'''''''',''\'''''');'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/item_help
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(2745706623582705225)
,p_shortcut_name=>'ITEM_HELP'
,p_shortcut_type=>'HTML_TEXT'
,p_error_text=>'Unable to show help.'
,p_reference_id=>24184979678
,p_shortcut=>'<a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999" title="Help on this item."><img src="#IMAGE_PREFIX#infoicon_status_gray.gif" width="16" height="16" /></a>'
);
end;
/
prompt --application/shared_components/security/authentications/internal_authentication
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(3324722473421190676)
,p_name=>'Internal Authentication'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'
,p_invalid_session_type=>'LOGIN'
,p_logout_url=>'f?p=4550:8:&SESSION.'
,p_cookie_name=>'ORA_WWV_USER_&INSTANCE_ID.'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_reference_id=>540226219724705040
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_saml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(44506065542251869)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_display_name=>'INTERNAL SAML'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'),'')
,p_api_version=>2
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_saml'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_saml'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_saml'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_saml'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_saml'
,p_substitute_attributes=>true
,p_reference_id=>77082398185639908
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_social
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(118549832896910933)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'
,p_display_name=>'INTERNAL Social Sign-In'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'),'')
,p_api_version=>2
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_social'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_social'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_social'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_social'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_social'
,p_substitute_attributes=>true
,p_reference_id=>117694777698093086
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328087019040426980)
,p_plugin_id=>wwv_flow_api.id(118549832896910933)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Authentication Provider'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OPENID_CONNECT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328087480710426980)
,p_plugin_attribute_id=>wwv_flow_api.id(328087019040426980)
,p_display_sequence=>10
,p_display_value=>'OpenID Connect Provider'
,p_return_value=>'OPENID_CONNECT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328087987694426981)
,p_plugin_attribute_id=>wwv_flow_api.id(328087019040426980)
,p_display_sequence=>20
,p_display_value=>'Generic OAuth2 Provider'
,p_return_value=>'OAUTH2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328088486533426981)
,p_plugin_attribute_id=>wwv_flow_api.id(328087019040426980)
,p_display_sequence=>30
,p_display_value=>'Google'
,p_return_value=>'GOOGLE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328088978696426981)
,p_plugin_attribute_id=>wwv_flow_api.id(328087019040426980)
,p_display_sequence=>40
,p_display_value=>'Facebook'
,p_return_value=>'FACEBOOK'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328089416217426981)
,p_plugin_id=>wwv_flow_api.id(118549832896910933)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Discovery URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(328087019040426980)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OPENID_CONNECT'
,p_examples=>'https://accounts.example.com/.well-known/openid-configuration'
,p_help_text=>'Enter the OpenID Connect provider''s discovery URL.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328089831254426984)
,p_plugin_id=>wwv_flow_api.id(118549832896910933)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Authorization Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(328087019040426980)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s authorization endpoint URL.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328090207305426984)
,p_plugin_id=>wwv_flow_api.id(118549832896910933)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Token Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(328087019040426980)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s token endpoint URL.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328090618203426984)
,p_plugin_id=>wwv_flow_api.id(118549832896910933)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'User Info Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(328087019040426980)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s user info endpoint URL.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328091042716426984)
,p_plugin_id=>wwv_flow_api.id(118549832896910933)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Scope'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'profile'
,p_is_translatable=>false
,p_help_text=>'Enter a comma separated list of permissions to request for the user who is logging in. The acceptable values depend on your authentication provider. For OpenID Connect and Google, Application Express automatically adds the "openid" scope. The authent'
||'ication provider returns user attributes based on these permissions. You can use a Post Authentication procedure to process these attributes, using the APEX_JSON.GET_% functions.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328091492986426985)
,p_plugin_id=>wwv_flow_api.id(118549832896910933)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Authentication URI Parameters'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter optional parameters for the authentication URI. Consult the authentication provider''s documentation for supported parameters.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328091806624426985)
,p_plugin_id=>wwv_flow_api.id(118549832896910933)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Username Attribute'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'email'
,p_is_translatable=>false
,p_help_text=>'Enter the attribute which contains the username. Consult the authentication provider''s documentation for supported attributes.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328092284296426985)
,p_plugin_id=>wwv_flow_api.id(118549832896910933)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Additional User Attributes'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter a comma separated list of additional user data attributes. Consult the authentication provider''s documentation for supported attributes.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328092688948426985)
,p_plugin_id=>wwv_flow_api.id(118549832896910933)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Logout URL'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Use this attribute to specify a URL to log out from your authentication provider.',
'For <em>OpenID Connect</em>, &PRODUCT_NAME. automatically uses the <em>end_session</em> endpoint, if that is defined in the <em>Discovery URL</em>.',
'For others, you can use #ID_TOKEN# and #REDIRECT_URI# in the URL, to substitute the ID token that was returned when logging in and the full URL to /apex on your instance, e.g. https://www.example.com/apex/apex.',
'Note that the redirect URI often has to be registered with your authentication provider.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328093008988426985)
,p_plugin_id=>wwv_flow_api.id(118549832896910933)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>'Token Authentication Method'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BASIC_AND_CLID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(328087019040426980)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_lov_type=>'STATIC'
,p_help_text=>'Enter how the credential''s client ID and client secret should be passed to the server.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328093412310426986)
,p_plugin_attribute_id=>wwv_flow_api.id(328093008988426985)
,p_display_sequence=>10
,p_display_value=>'Basic Authentication'
,p_return_value=>'BASIC'
,p_help_text=>'Send client id and client secret in a Basic Authentication header.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328093989420426986)
,p_plugin_attribute_id=>wwv_flow_api.id(328093008988426985)
,p_display_sequence=>20
,p_display_value=>'Basic Authentication and Client ID in Body'
,p_return_value=>'BASIC_AND_CLID'
,p_help_text=>'Send client id and client secret in a Basic Authentication header, but also send client it in the request body.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328094423237426986)
,p_plugin_attribute_id=>wwv_flow_api.id(328093008988426985)
,p_display_sequence=>30
,p_display_value=>'Client ID and Client Secret in Body'
,p_return_value=>'BODY'
,p_help_text=>'Send client id and client secret in the request body.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328094956540426986)
,p_plugin_attribute_id=>wwv_flow_api.id(328093008988426985)
,p_display_sequence=>40
,p_display_value=>'Client ID in Body'
,p_return_value=>'CLID'
,p_help_text=>'Only send client id in the request body.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328095484145426987)
,p_plugin_id=>wwv_flow_api.id(118549832896910933)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>91
,p_prompt=>'Verify Username'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'If enabled, &PRODUCT_NAME. will look for an attribute "#username#_verified" (e.g. "email_verified" for Username Attribute "email"). If this is set to "false", the username will not be accepted.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/com_oracle_apex_add_checkall_checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(505938009162025794)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
,p_display_name=>'Add Check All Checkbox'
,p_category=>'MISC'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_add_check_all_checkbox'
,p_standard_attributes=>'ONLOAD'
,p_substitute_attributes=>true
,p_reference_id=>1223290239742970512
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The "Add Check All Checkbox" dynamic action turns a column heading containing the #CHECK_ALL_CHECKBOX# string into an accessible check all style checkbox, that will check and uncheck all the checkboxes in its corresponding column.<p>',
'<p>',
'To use this plug-in, please ensure the following attributes are set:',
'<ol>',
'<li>In the report column, defined ''#CHECK_ALL_CHECKBOX#'' as the Heading value.</li>',
'<li>For the Dynamic Action When attribute, select the report region containing the column.</li>',
'<li>Define the Dynamic Action to fire ''After Refresh'', and the Action to ''Fire on Page Load''. (Both will default appropriately if the Dynamic Action is created by selecting the region in the ''Rendering'' section of Page Designer and creating the Dynam'
||'ic Action from there.</li>',
'<li>This will not handle the accessibility of the checkboxes rendered on each row, this must be done separately in the region source. (See 4000:656 ''Regions'' region for an example).</li>',
'</ol>',
'</p>'))
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/com_oracle_apex_developer_authorization
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2876432243634950829)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_display_name=>'Developer Authorization'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'),'')
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function is_authorized (',
'    p_authorization in wwv_flow_plugin_api.t_authorization,',
'    p_plugin        in wwv_flow_plugin_api.t_plugin )',
'    return wwv_flow_plugin_api.t_authorization_exec_result',
'is',
'    l_result               wwv_flow_plugin_api.t_authorization_exec_result;',
'begin',
'    l_result.is_authorized := wwv_flow_authorization.is_authorized_developer ( ',
'                                  p_developer_authorization => p_authorization.attribute_01 );',
'    return l_result;',
'exception',
'    when no_data_found then',
'        l_result.is_authorized := false;',
'        return l_result;',
'end;'))
,p_api_version=>1
,p_execution_function=>'is_authorized'
,p_substitute_attributes=>true
,p_reference_id=>12457518297512494
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(651568216479363800)
,p_plugin_id=>wwv_flow_api.id(2876432243634950829)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Developer Role'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651568640837363805)
,p_plugin_attribute_id=>wwv_flow_api.id(651568216479363800)
,p_display_sequence=>10
,p_display_value=>'ADMIN: Ability to manage flow developer privileges'
,p_return_value=>'ADMIN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651569103104363805)
,p_plugin_attribute_id=>wwv_flow_api.id(651568216479363800)
,p_display_sequence=>20
,p_display_value=>'EDIT: Ability change all attributes of specified flow(s)'
,p_return_value=>'EDIT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651569636632363806)
,p_plugin_attribute_id=>wwv_flow_api.id(651568216479363800)
,p_display_sequence=>30
,p_display_value=>'HELP: Ability edit help page for a given company'
,p_return_value=>'HELP'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651570188440363806)
,p_plugin_attribute_id=>wwv_flow_api.id(651568216479363800)
,p_display_sequence=>40
,p_display_value=>'BROWSE: Access to Oracle data dictionary browser'
,p_return_value=>'BROWSE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651570612706363806)
,p_plugin_attribute_id=>wwv_flow_api.id(651568216479363800)
,p_display_sequence=>50
,p_display_value=>'CREATE: Ability to create new flows'
,p_return_value=>'CREATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651571169148363806)
,p_plugin_attribute_id=>wwv_flow_api.id(651568216479363800)
,p_display_sequence=>60
,p_display_value=>'MONITOR: Ability to monitor flow activity'
,p_return_value=>'MONITOR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651571661042363807)
,p_plugin_attribute_id=>wwv_flow_api.id(651568216479363800)
,p_display_sequence=>70
,p_display_value=>'DB_MONITOR: Ability to monitor Oracle database attributes'
,p_return_value=>'DB_MONITOR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651572189512363807)
,p_plugin_attribute_id=>wwv_flow_api.id(651568216479363800)
,p_display_sequence=>80
,p_display_value=>'SQL: Ability to issues SQL statements'
,p_return_value=>'SQL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651572640436363807)
,p_plugin_attribute_id=>wwv_flow_api.id(651568216479363800)
,p_display_sequence=>90
,p_display_value=>'USER_MANAGER: Manage user accounts for cookie based authentication'
,p_return_value=>'USER_MANAGER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651573142782363808)
,p_plugin_attribute_id=>wwv_flow_api.id(651568216479363800)
,p_display_sequence=>100
,p_display_value=>'DATA_LOADER: Data Workshop'
,p_return_value=>'DATA_LOADER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651573646173363808)
,p_plugin_attribute_id=>wwv_flow_api.id(651568216479363800)
,p_display_sequence=>110
,p_display_value=>'RESTFUL: Ability to enable RESTful Services'
,p_return_value=>'RESTFUL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651574173944363808)
,p_plugin_attribute_id=>wwv_flow_api.id(651568216479363800)
,p_display_sequence=>130
,p_display_value=>'EDIT or SQL'
,p_return_value=>'EDIT:SQL'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_code_editor
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2985465796466205447)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.CODE_EDITOR'
,p_display_name=>'Code Editor'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.CODE_EDITOR'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_code_editor'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_code_editor'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:HEIGHT:ENCRYPT'
,p_substitute_attributes=>true
,p_reference_id=>1114646612921244845
,p_subscribe_plugin_settings=>true
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(752211225977115056)
,p_plugin_id=>wwv_flow_api.id(2985465796466205447)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Mode'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SQL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752212032747115065)
,p_plugin_attribute_id=>wwv_flow_api.id(752211225977115056)
,p_display_sequence=>10
,p_display_value=>'SQL'
,p_return_value=>'SQL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752211543655115064)
,p_plugin_attribute_id=>wwv_flow_api.id(752211225977115056)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTMLMIXED'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752216561773115069)
,p_plugin_attribute_id=>wwv_flow_api.id(752211225977115056)
,p_display_sequence=>30
,p_display_value=>'CSS'
,p_return_value=>'CSS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752212529101115067)
,p_plugin_attribute_id=>wwv_flow_api.id(752211225977115056)
,p_display_sequence=>40
,p_display_value=>'JavaScript'
,p_return_value=>'JAVASCRIPT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752217094333115070)
,p_plugin_attribute_id=>wwv_flow_api.id(752211225977115056)
,p_display_sequence=>42
,p_display_value=>'JSON'
,p_return_value=>'json'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752213048092115067)
,p_plugin_attribute_id=>wwv_flow_api.id(752211225977115056)
,p_display_sequence=>45
,p_display_value=>'DDL'
,p_return_value=>'DDL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752213580904115068)
,p_plugin_attribute_id=>wwv_flow_api.id(752211225977115056)
,p_display_sequence=>50
,p_display_value=>'PL/SQL Block'
,p_return_value=>'PLSQL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752214006240115068)
,p_plugin_attribute_id=>wwv_flow_api.id(752211225977115056)
,p_display_sequence=>60
,p_display_value=>'PL/SQL Functions/Procedures'
,p_return_value=>'PLSQL_FUNCTIONS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752214553994115068)
,p_plugin_attribute_id=>wwv_flow_api.id(752211225977115056)
,p_display_sequence=>70
,p_display_value=>'PL/SQL Expression'
,p_return_value=>'PLSQL_EXPRESSION'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752215017331115068)
,p_plugin_attribute_id=>wwv_flow_api.id(752211225977115056)
,p_display_sequence=>80
,p_display_value=>'PL/SQL Function Body'
,p_return_value=>'PLSQL_FUNCTION_BODY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752215519891115069)
,p_plugin_attribute_id=>wwv_flow_api.id(752211225977115056)
,p_display_sequence=>90
,p_display_value=>'Based on Page Item'
,p_return_value=>'PAGE_ITEM'
,p_help_text=>'The language will be dynamically set by the value of a Page Item.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752216097631115069)
,p_plugin_attribute_id=>wwv_flow_api.id(752211225977115056)
,p_display_sequence=>100
,p_display_value=>'MLE - JavaScript'
,p_return_value=>'mle-javascript'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(752217507889115073)
,p_plugin_id=>wwv_flow_api.id(2985465796466205447)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Return Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(752211225977115056)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PLSQL_EXPRESSION,PLSQL_FUNCTION_BODY'
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752217980402115074)
,p_plugin_attribute_id=>wwv_flow_api.id(752217507889115073)
,p_display_sequence=>10
,p_display_value=>'VARCHAR2'
,p_return_value=>'VARCHAR2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752218429817115074)
,p_plugin_attribute_id=>wwv_flow_api.id(752217507889115073)
,p_display_sequence=>20
,p_display_value=>'BOOLEAN'
,p_return_value=>'BOOLEAN'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(752218943435115076)
,p_plugin_id=>wwv_flow_api.id(2985465796466205447)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Show Query Builder'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(752211225977115056)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(752219394780115077)
,p_plugin_id=>wwv_flow_api.id(2985465796466205447)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Adjustable Height'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>'If Yes the user can adjust the height of the code editor.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(752219700691115077)
,p_plugin_id=>wwv_flow_api.id(2985465796466205447)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Remote  Database ID item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>'Specify a page item containing the remote database ID to use for code validation.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(752220130799115077)
,p_plugin_id=>wwv_flow_api.id(2985465796466205447)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>15
,p_prompt=>'Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(752211225977115056)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Choose a page item whose value will decide the language (mode) of the editor.</p>',
'',
'<p>An event listener will be placed on this item, so when its value changes, the editor will change accordingly.</p>',
'',
'<p>Possible values for this item are the exact language identifiers the Monaco Editor supports, such as: <code>javascript</code>, <code>html</code>, <code>css</code>, <code>json</code>, <code>sql</code> or others.</p>',
'',
'<p>Note that changing the language will not change the editor''s value, so an extra Set Value dynamic action will be required to clear the contents.</p>'))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_apex
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3324699829921132577)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'
,p_display_name=>'INTERNAL Application Express Accounts'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_apex'
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113737019268347425
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_db
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3324700073692132611)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.DB'
,p_display_name=>'INTERNAL Database Accounts'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.DB'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_db'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113749511183746276
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_header
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3324700335694132612)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.HEADER'
,p_display_name=>'INTERNAL HTTP Header Variable'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.HEADER'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_header'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_header'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_header'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_header'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_header'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>708795120396802284
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(43174877830381410)
,p_plugin_id=>wwv_flow_api.id(3324700335694132612)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'HTTP Header Variable Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'OAM_REMOTE_USER'
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specifies the name of the HTTP header variable which contains the username.',
'The default OAM_REMOTE_USER is used by Oracle Access Manager and has to be changed',
'if another authentication provider is used.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(43175444783381410)
,p_plugin_id=>wwv_flow_api.id(3324700335694132612)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Action if Username is Empty'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BUILTIN_URL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies the action which should be performed if the username stored in the HTTP header variable is empty. The following options are available:',
'</p>',
'<p>',
'<ul>',
'  <li><strong>Redirect to Built-In URL</strong> to initiate a login by the web server. This Built-In URL has to be setup to be protected by the web server, in order to force a login when called. After login, the web server must store the validated us'
||'ername in the HTTP header variable, so it is available to the authentication scheme. The Built-In URL is',
'<pre>/apex/apex_authentication.callback</pre>',
'The prefix <code>/apex/</code> depends on your server configuration.',
'</li>',
'  <li><strong>Redirect to URL</strong> to initiate a login on an external server which then sets the validated username in the HTTP header variable. The external server should redirect back to the application using the URL generated by the <code>#CAL'
||'LBACK#</code> placeholder to complete authentication in the application.</li>',
'  <li><strong>Display Error</strong> will display the specified error message and no login will be performed in the application.</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(43175869385381410)
,p_plugin_attribute_id=>wwv_flow_api.id(43175444783381410)
,p_display_sequence=>10
,p_display_value=>'Redirect to Built-In URL'
,p_return_value=>'BUILTIN_URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(43176340853381410)
,p_plugin_attribute_id=>wwv_flow_api.id(43175444783381410)
,p_display_sequence=>20
,p_display_value=>'Redirect to URL'
,p_return_value=>'URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(43176822360381411)
,p_plugin_attribute_id=>wwv_flow_api.id(43175444783381410)
,p_display_sequence=>30
,p_display_value=>'Display Error'
,p_return_value=>'ERROR'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(43182040186381411)
,p_plugin_id=>wwv_flow_api.id(3324700335694132612)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(43175444783381410)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_examples=>'http://sso.example.com/?success=#CALLBACK#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies the URL of an external login server which sets the validated username in the HTTP header variable. The external server should redirect back to the application using the URL generated by the <code>#CALLBACK#</code> placeholder to complete au'
||'thentication in the application.',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(43183908752381412)
,p_plugin_id=>wwv_flow_api.id(3324700335694132612)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Error Message'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(43175444783381410)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ERROR'
,p_help_text=>'Specifies the error message to be displayed if the HTTP header variable does not contain a value or the HTTP header variable does not exist.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(43186227297381412)
,p_plugin_id=>wwv_flow_api.id(3324700335694132612)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Verify Username'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALWAYS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(43175444783381410)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'BUILTIN_URL,URL'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies how often the username stored in the HTTP header variable is verified. The following options are available:',
'</p>',
'<p>',
'<ul>',
'  <li><strong>Each Request</strong> will expect that the CGI variable is always set as soon as the login has been performed by the web server. If the username is not identical to the one stored in the current &PRODUCT_NAME. session, the session will '
||'be invalidated and a new login will be initiated. This is the most secure option because it detects logouts or username changes.',
'  </li>',
'  <li><strong>After Login</strong> will only verify and store the username in the &PRODUCT_NAME. session after the web server has performed the login and calls the callback to complete authentication in the application. For callback see "Action if Us'
||'ername is Empty" configuration.',
'  </li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(43187933736381412)
,p_plugin_attribute_id=>wwv_flow_api.id(43186227297381412)
,p_display_sequence=>10
,p_display_value=>'Each Request'
,p_return_value=>'ALWAYS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(43190383583381412)
,p_plugin_attribute_id=>wwv_flow_api.id(43186227297381412)
,p_display_sequence=>20
,p_display_value=>'After Login'
,p_return_value=>'CALLBACK'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(43192489555381413)
,p_plugin_id=>wwv_flow_api.id(3324700335694132612)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Logout URL of SSO Server'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If the authentication scheme is based on Oracle Access Manager or similar servers,',
'you can use this attribute to specify a URL to log out of the central single sign-on server.',
'<p/>',
'For Oracle Access Manager based SSO, enter for example',
'<pre>',
'/oamsso/logout.html?end_url=%POST_LOGOUT_URL%',
'</pre>',
'The substitution parameter <strong>%POST_LOGOUT_URL%</strong> will be replaced by an encoded URL to the login page of your application.'))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_ldap
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3324706481652132628)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.LDAP'
,p_display_name=>'INTERNAL LDAP Directory'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.LDAP'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_ldap'
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>863910941135523528
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the username and password for authentication against the LDAP directory identified on the login page. Remember, passwords may be case sensitive.</p>',
''))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3324706669002132628)
,p_plugin_id=>wwv_flow_api.id(3324706481652132628)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Host'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'The hostname of your LDAP directory server.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3324707056596132628)
,p_plugin_id=>wwv_flow_api.id(3324706481652132628)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Port'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>6
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>'The port number of your LDAP directory host. The default is 389.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3324707506505132629)
,p_plugin_id=>wwv_flow_api.id(3324706481652132628)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Use SSL'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Choose whether to use SSL to bind to the LDAP directory. If SSL with Authentication is chosen, a wallet must be configured for the &PRODUCT_NAME. instance.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3324707815545132629)
,p_plugin_attribute_id=>wwv_flow_api.id(3324707506505132629)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3324708404097132631)
,p_plugin_attribute_id=>wwv_flow_api.id(3324707506505132629)
,p_display_sequence=>20
,p_display_value=>'SSL with Authentication'
,p_return_value=>'SSL_AUTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3324708840184132631)
,p_plugin_attribute_id=>wwv_flow_api.id(3324707506505132629)
,p_display_sequence=>30
,p_display_value=>'No SSL'
,p_return_value=>'NO_SSL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3324709400834132631)
,p_plugin_id=>wwv_flow_api.id(3324706481652132628)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Distinguished Name (DN) String'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the pattern used to construct the fully qualified distinguished name (DN) string to DBMS_LDAP.SIMPLE_BIND_S if using exact DN or the search base if using non-exact DN. Use <strong>%LDAP_USER%</strong> as a placeholder for the username.  For exa'
||'mple:',
'<p>',
'<strong>Exact DN</strong>',
'</p>',
'<p>',
'cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com',
'</p>',
'<p>',
'<strong>Non-Exact DN (Search Base)</strong>',
'</p>',
'<p>',
'dc=yourdomain,dc=com',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3324709739771132632)
,p_plugin_id=>wwv_flow_api.id(3324706481652132628)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Use Exact Distinguished Name (DN)'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Choose whether the LDAP Distinguished Name (DN) String is exact or non-exact. If non-exact, LDAP Distinguished Name (DN) is the search base and you must supply a Search Filter.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3324710148854132632)
,p_plugin_id=>wwv_flow_api.id(3324706481652132628)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Search Filter'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3324709739771132632)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the search filter when not using an exact distinguished name (DN). Use <strong>%LDAP_USER%</strong> as a place-holder for the username. For example:',
'</p>',
'<p><pre>cn=%LDAP_USER%</pre></p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3324710599897132632)
,p_plugin_id=>wwv_flow_api.id(3324706481652132628)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'LDAP Username Edit Function'
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'You may provide additional code to be executed to transform the username into a format perfectly suited to the LDAP directory entry or LDAP username.',
'The bind variable :USERNAME contains the name the end user specified.',
'For example, the following code calls a function which replaces all "."''s with "_"''s in the DN string:</p>',
'',
'<p><pre>',
'return apex_custom_auth.ldap_dnprep(p_username => :USERNAME);',
'</pre></p>',
'',
'<p>&PRODUCT_NAME. will escape the returned username based on the authentication attribute <strong>Username Escaping</strong>.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3324710980739132632)
,p_plugin_id=>wwv_flow_api.id(3324706481652132628)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Username Escaping'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Before replacing <strong>%LDAP_USER%</strong> in the LDAP distinguished name and search string,',
'&PRODUCT_NAME. can automatically escape special characters in the username.',
'<p/>',
'The possible rules for escaping are:',
'<ul>',
'<li><strong>Standard</strong>:',
'Escape special characters based on RFC 4514 (for distinguished names) and RFC 4515 (for search strings).',
'Additionally, escape unicode characters.',
'This is the most secure setting, but may cause problems with some LDAP servers.</li>',
'<li><strong>Only special characters</strong>:',
'Escape special characters based on RFC 4514 (for distinguished names) and RFC 4515 (for search strings).',
'Do not escape unicode characters.</li>',
'<li><strong>No escaping</strong>:',
'Do not escape any characters.',
'This setting is potentially insecure,',
'unless a <strong>Username Edit Function</strong> is employed that already',
'escapes the username (for example with apex_escape.ldap_dn or apex_escape.ldap_search_filter).</li>',
'</ul>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3324711316335132633)
,p_plugin_attribute_id=>wwv_flow_api.id(3324710980739132632)
,p_display_sequence=>10
,p_display_value=>'Standard'
,p_return_value=>'STD'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3324711846150132633)
,p_plugin_attribute_id=>wwv_flow_api.id(3324710980739132632)
,p_display_sequence=>20
,p_display_value=>'Only special characters'
,p_return_value=>'ONLY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3324712402550132633)
,p_plugin_attribute_id=>wwv_flow_api.id(3324710980739132632)
,p_display_sequence=>30
,p_display_value=>'No Escaping'
,p_return_value=>'NO'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_sso
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3324713153644132635)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SSO'
,p_display_name=>'INTERNAL Oracle Application Server Single Sign-On'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SSO'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_osso'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_osso'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_osso'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_osso'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_osso'
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113750429890071859
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_cloud_idm
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3324713486560132636)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.CLOUD_IDM'
,p_display_name=>'INTERNAL Oracle Cloud Identity Management'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.CLOUD_IDM'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_cloud'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_cloud'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_cloud'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_cloud'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_cloud'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113749806821809026
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_wizard_selection
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3364064701836787185)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.WIZARD_SELECTION'
,p_display_name=>'Wizard Selection'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.WIZARD_SELECTION'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_wizard_selection'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_wizard_selection'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:SOURCE:ELEMENT:LOV:CASCADING_LOV'
,p_substitute_attributes=>true
,p_reference_id=>805558538998648898
,p_subscribe_plugin_settings=>true
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3364064996228787343)
,p_plugin_id=>wwv_flow_api.id(3364064701836787185)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Icon Size'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'S'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3364065405041787344)
,p_plugin_attribute_id=>wwv_flow_api.id(3364064996228787343)
,p_display_sequence=>10
,p_display_value=>'Small'
,p_return_value=>'S'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3364065866700787344)
,p_plugin_attribute_id=>wwv_flow_api.id(3364064996228787343)
,p_display_sequence=>20
,p_display_value=>'Medium'
,p_return_value=>'M'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3364066315358787344)
,p_plugin_attribute_id=>wwv_flow_api.id(3364064996228787343)
,p_display_sequence=>30
,p_display_value=>'Large'
,p_return_value=>'L'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3364066821322787346)
,p_plugin_id=>wwv_flow_api.id(3364064701836787185)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Submit Page'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>'Select whether or not to submit the page when making a selection'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(3403659208803969971)
,p_plugin_id=>wwv_flow_api.id(3364064701836787185)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
);
end;
/
prompt --application/shared_components/plugins/region_type/com_oracle_apex_clob_code_editor
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3503624151937027104)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_display_name=>'CLOB Code Editor'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.ORACLE.APEX.CLOB_CODE_EDITOR'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_clob_code_editor'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_clob_code_editor'
,p_standard_attributes=>'SOURCE_SQL:NO_DATA_FOUND_MESSAGE'
,p_substitute_attributes=>true
,p_reference_id=>1127739634804688041
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(729258200595345784)
,p_plugin_id=>wwv_flow_api.id(3503624151937027104)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Mode'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SQL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729258633313345785)
,p_plugin_attribute_id=>wwv_flow_api.id(729258200595345784)
,p_display_sequence=>10
,p_display_value=>'SQL'
,p_return_value=>'SQL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729259157580345785)
,p_plugin_attribute_id=>wwv_flow_api.id(729258200595345784)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTMLMIXED'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729259605403345785)
,p_plugin_attribute_id=>wwv_flow_api.id(729258200595345784)
,p_display_sequence=>30
,p_display_value=>'CSS'
,p_return_value=>'CSS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729260159754345785)
,p_plugin_attribute_id=>wwv_flow_api.id(729258200595345784)
,p_display_sequence=>40
,p_display_value=>'JavaScript'
,p_return_value=>'JAVASCRIPT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729263617066345790)
,p_plugin_attribute_id=>wwv_flow_api.id(729258200595345784)
,p_display_sequence=>42
,p_display_value=>'JSON'
,p_return_value=>'json'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729260683571345786)
,p_plugin_attribute_id=>wwv_flow_api.id(729258200595345784)
,p_display_sequence=>45
,p_display_value=>'DDL'
,p_return_value=>'DDL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729261170088345786)
,p_plugin_attribute_id=>wwv_flow_api.id(729258200595345784)
,p_display_sequence=>50
,p_display_value=>'PL/SQL Block'
,p_return_value=>'PLSQL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729261681594345786)
,p_plugin_attribute_id=>wwv_flow_api.id(729258200595345784)
,p_display_sequence=>70
,p_display_value=>'PL/SQL Expression'
,p_return_value=>'PLSQL_EXPRESSION'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729262170462345787)
,p_plugin_attribute_id=>wwv_flow_api.id(729258200595345784)
,p_display_sequence=>80
,p_display_value=>'PL/SQL Function Body'
,p_return_value=>'PL/SQL_FUNCTION_BODY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729262611054345789)
,p_plugin_attribute_id=>wwv_flow_api.id(729258200595345784)
,p_display_sequence=>90
,p_display_value=>'Based on Page Item'
,p_return_value=>'PAGE_ITEM'
,p_help_text=>'The language will be dynamically set by the value of a Page Item.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729263153906345789)
,p_plugin_attribute_id=>wwv_flow_api.id(729258200595345784)
,p_display_sequence=>100
,p_display_value=>'MLE - JavaScript'
,p_return_value=>'mle-javascript'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(729264153239345790)
,p_plugin_id=>wwv_flow_api.id(3503624151937027104)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Height'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729264514671345790)
,p_plugin_attribute_id=>wwv_flow_api.id(729264153239345790)
,p_display_sequence=>1
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729265001406345790)
,p_plugin_attribute_id=>wwv_flow_api.id(729264153239345790)
,p_display_sequence=>2
,p_display_value=>'10'
,p_return_value=>'10'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729265581017345791)
,p_plugin_attribute_id=>wwv_flow_api.id(729264153239345790)
,p_display_sequence=>3
,p_display_value=>'20'
,p_return_value=>'20'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729266080799345791)
,p_plugin_attribute_id=>wwv_flow_api.id(729264153239345790)
,p_display_sequence=>10
,p_display_value=>'30'
,p_return_value=>'30'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729266570877345791)
,p_plugin_attribute_id=>wwv_flow_api.id(729264153239345790)
,p_display_sequence=>20
,p_display_value=>'60'
,p_return_value=>'60'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729267093106345791)
,p_plugin_attribute_id=>wwv_flow_api.id(729264153239345790)
,p_display_sequence=>25
,p_display_value=>'80'
,p_return_value=>'80'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729267547636345792)
,p_plugin_attribute_id=>wwv_flow_api.id(729264153239345790)
,p_display_sequence=>30
,p_display_value=>'Automatic'
,p_return_value=>'AUTO'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(729268072607345792)
,p_plugin_id=>wwv_flow_api.id(3503624151937027104)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Read Only'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(729268436152345792)
,p_plugin_id=>wwv_flow_api.id(3503624151937027104)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>15
,p_prompt=>'Return Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(729258200595345784)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PLSQL_EXPRESSION,PLSQL_FUNCTION_BODY'
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729268876587345792)
,p_plugin_attribute_id=>wwv_flow_api.id(729268436152345792)
,p_display_sequence=>10
,p_display_value=>'VARCHAR2'
,p_return_value=>'VARCHAR2'
,p_help_text=>'VARCHAR2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729269374135345793)
,p_plugin_attribute_id=>wwv_flow_api.id(729268436152345792)
,p_display_sequence=>20
,p_display_value=>'BOOLEAN'
,p_return_value=>'BOOLEAN'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(729269885352345793)
,p_plugin_id=>wwv_flow_api.id(3503624151937027104)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Remote Database ID item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>'Specify the an item containing the ID of the remote database to use for code validation.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(729270205235345793)
,p_plugin_id=>wwv_flow_api.id(3503624151937027104)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>15
,p_prompt=>'Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(729258200595345784)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Choose a page item whose value will decide the language (mode) of the editor.</p>',
'<p>An event listener will further be placed on this item, so that when its value changes, the editor will change accordingly.</p>',
'<p>Possible values for this item are the exact language identifiers the Monaco Editor supports, such as: <code>javascript</code>, <code>html</code>, <code>css</code>, <code>json</code>, <code>sql</code> or others.</p>',
'<p>Note that changing the language will not change the editor''s value, so an extra Set Value dynamic action will be required to clear the contents.</p>'))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(729272172158345795)
,p_plugin_id=>wwv_flow_api.id(3503624151937027104)
,p_name=>'SOURCE_SQL'
,p_is_required=>false
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select clob_content',
'from demo_scripts'))
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(2563473516491437785)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Desktop'
,p_display_seq=>10
,p_use_auto_detect=>true
,p_is_default=>true
,p_theme_id=>101
,p_home_url=>'f?p=4020:1:&SESSION.'
,p_login_url=>'f?p=4550:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_global_page_id=>0
,p_nav_list_template_options=>'#DEFAULT#'
,p_css_file_urls=>'#IMAGE_PREFIX#libraries/font-apex/2.2.1/css/font-apex.min.css'
,p_javascript_file_urls=>'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#ui.core#MIN#.js'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00000
begin
wwv_flow_api.create_page(
 p_id=>0
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'0'
,p_step_title=>'0'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(3286607596938476944)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210830113236'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2943195795875068280)
,p_plug_name=>'APEX 5 - Header Old'
,p_region_css_classes=>'a-Header'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_07'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="f?p=4000:1500:&APP_SESSION." class="a-Header-logo" title="Home">',
'  <span class="a-Header-apexLogo"></span>',
'</a>'))
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6545080822676071207)
,p_plug_name=>'APEX 5 - Header'
,p_region_css_classes=>'a-Header apex-app-builder'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_07'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6545081024953071207)
,p_plug_name=>'APEX 5 - Header Left'
,p_parent_plug_id=>wwv_flow_api.id(6545080822676071207)
,p_region_css_classes=>'a-Header-col a-Header-col--left'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6163005498826978606)
,p_plug_name=>'APEX Tabs'
,p_region_name=>'a_Header_menu'
,p_parent_plug_id=>wwv_flow_api.id(6545081024953071207)
,p_region_css_classes=>'a-Header-tabsContainer'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(3078141213440643205)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(3157523106769548315)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6545081194689071207)
,p_plug_name=>'APEX 5 - Logo'
,p_parent_plug_id=>wwv_flow_api.id(6545081024953071207)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'sys.htp.p(''<a href="f?p=4500:1000:''||:APP_SESSION||''::''||:DEBUG||''::::" class="a-Header-logo" title="''||wwv_flow_lang.system_message(''HOME_NAV'')||''"><span class="a-Header-apexLogo"></span></a>'');'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6545081398411071208)
,p_plug_name=>'APEX 5 - Home Link'
,p_parent_plug_id=>wwv_flow_api.id(6545081024953071207)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6545081643308071208)
,p_plug_name=>'APEX 5 - Header Right'
,p_parent_plug_id=>wwv_flow_api.id(6545080822676071207)
,p_region_css_classes=>'a-Header-col a-Header-col--right'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6545081864584071208)
,p_plug_name=>'APEX 5 - Search'
,p_parent_plug_id=>wwv_flow_api.id(6545081643308071208)
,p_region_css_classes=>'a-Header-search'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<div class="a-SearchBox a-SearchBox--noGoButton a-SearchBox--autoExpand a-SearchBox--fill">'');',
'sys.htp.p(''  <div class="a-SearchBox-field">'');',
'sys.htp.p(''    <span class="a-SearchBox-icon"><span class="a-Icon icon-search"></span></span>'');',
'sys.htp.p(''    <label for="P0_SEARCH" class="visuallyhidden">Search</label>'');',
'sys.htp.p(''    <input type="text" class="a-SearchBox-input" id="P0_SEARCH" placeholder="''||wwv_flow_lang.system_message(''WWV_FLOW_QUICK_FLOW.SEARCH'')||''">'');',
'sys.htp.p(''  </div>'');',
'sys.htp.p(''</div>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6545082010678071208)
,p_plug_name=>'APEX 5 - Header Navigation Links'
,p_parent_plug_id=>wwv_flow_api.id(6545081643308071208)
,p_region_css_classes=>'a-Header-navLinks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>70
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6545117961709147215)
,p_plug_name=>'APEX 5 - Administration Menu'
,p_region_name=>'adminMenu'
,p_parent_plug_id=>wwv_flow_api.id(6545082010678071208)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>120
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(3078131037146643152)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(3331503598779942021)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6643087951170591881)
,p_plug_name=>'APEX 5 - Help Menu'
,p_region_name=>'helpMenu'
,p_parent_plug_id=>wwv_flow_api.id(6545082010678071208)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>130
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(3078138630465643203)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(3331503598779942021)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6545082204037071208)
,p_plug_name=>'APEX 5 - Header Account'
,p_parent_plug_id=>wwv_flow_api.id(6545081643308071208)
,p_region_css_classes=>'a-Header-account'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>80
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4000_ui.account_mega_menu (',
'    p_username          => :APP_USER,',
'    p_workspace_id      => :WORKSPACE_ID,',
'    p_session           => :APP_SESSION,',
'    p_logout_url        => :LOGOUT_URL',
');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(735034611616168741)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(6545082010678071208)
,p_button_name=>'UPGRADE_AVAILABLE'
,p_button_static_id=>'header-upgradeAvailable'
,p_button_action=>'REDIRECT_APP'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Upgrade Available'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4000:78:&SESSION.:UPGRADE_AVAILABLE:&DEBUG.:78::'
,p_button_condition=>'wwv_flow_cloud_db_services.get_upgrade_status().state = ''SCHEDULED'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-calendar u-info-text'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3078194876396647079)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(6545081398411071208)
,p_button_name=>'Home'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Home'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4500:1000:&SESSION.::&DEBUG.::::'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-home'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(735034521230168740)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(6545082010678071208)
,p_button_name=>'UPGRADE_IN_PROGRESS'
,p_button_static_id=>'header-upgradeInProgress'
,p_button_action=>'REDIRECT_APP'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Upgrade In Progress'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4000:78:&SESSION.:UPGRADE_IN_PROGRESS:&DEBUG.:78::'
,p_button_condition=>'wwv_flow_cloud_db_services.get_upgrade_status().state = ''RUNNING'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-warning u-danger-text'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3078196131874647081)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(6545082010678071208)
,p_button_name=>'Administration'
,p_button_static_id=>'header-adminMenu'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2583919293963280507)
,p_button_image_alt=>'Administration'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-gears-alt'
,p_button_cattributes=>'data-menu="adminMenu_menu"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3078196573562647081)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(6545082010678071208)
,p_button_name=>'Feedback'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Feedback'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4750:11001:&SESSION.::&DEBUG.:RP,11001:P11001_APPLICATION_ID,P11001_PAGE_ID:&APP_ID.,&APP_PAGE_ID.:'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-comments'
,p_required_patch=>wwv_flow_api.id(641974235841696132)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3078196996191647082)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(6545082010678071208)
,p_button_name=>'Help'
,p_button_static_id=>'header-helpMenu'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2583919293963280507)
,p_button_image_alt=>'Help'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-help'
,p_button_cattributes=>'data-menu="helpMenu_menu"'
);
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Create Application'
,p_step_title=>'Create Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.stickyWidget#MIN#.js?v=#APEX_VERSION#',
''))
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var MSG_CREATING_APPLICATION = ''"CREATING_APPLICATION"'';',
'',
'(function( $ ){',
'    apex.create_app_wizard = apex.create_app_wizard || {};',
'',
'    apex.create_app_wizard.pageSort = function () {',
'        var prevSeq,',
'            currentSeq,',
'            moveCount,',
'            action,',
'            pageId;',
'',
'        var getSeq = function ( elem$ ) {',
'            return $( ''li.a-PWList-item'' ).index( elem$ );',
'        };',
'',
'        var move = function( page_id, move_count, v_action ) {',
'            apex.server.process( ''sortPage'', {',
'                x01: page_id,',
'                x02: move_count,',
'                x03: v_action',
'            }, {',
'                success: function( pData ) {',
'                    $( ''#pages'' ).trigger( ''apexrefresh'' );',
'                },',
'                error: function( pData ) {',
'                    alert( pData.responseText );',
'                }',
'            });',
'        };',
'',
'        $(".a-PWList").sortable({',
'            handle: ".a-PWList-dragHandle",',
'            items: "> li.is-draggable",',
'            placeholder: "a-PWList-item is-placeholder",',
'',
'            activate: function( event, ui ) {',
'                pageId = prevSeq = getSeq( ui.item.first() );',
'            },',
'',
'            update: function( event, ui ) {',
'                currentSeq = getSeq( ui.item.first() );',
'',
'                if ( currentSeq > prevSeq ) {',
'                    action = ''down'';',
'                    moveCount = currentSeq - prevSeq;',
'                } else {',
'                    action = ''up'';',
'                    moveCount = prevSeq - currentSeq;',
'                }',
'',
'                move(pageId, moveCount, action );',
'            }',
'',
'        });',
'',
'    };',
'})( apex.jQuery );'))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(function( $ ){',
'    $("#choose_icon").appendTo(".a-PageWizard-appIconContainer .a-Form-inputContainer");',
'})( apex.jQuery );',
'',
'apex.item( "P1_STATUS" ).setValue( "" );',
'apex.item( "P1_PCT_COMPLETE" ).setValue( "" );',
'apex.item( "P1_CURRENT_STATUS" ).setValue( "" );',
'',
'apex.jQuery(".a-PageWizard-buttons")',
'    .stickyWidget({',
'        isFooter: true, ',
'        toggleWidth: true',
'    });'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.field.item-app-name {',
'  margin-bottom: 0;',
'}',
'',
'.field--style--boxed .display_only {',
'  line-height: 24px;',
'  white-space: nowrap;',
'  overflow: hidden;',
'  text-overflow: ellipsis;',
'}',
'',
'.apex-col .field.field-item-button-grouping {',
'  margin-right: -1px;',
'}',
'',
'.lang-button {',
'  padding-top: 19px;',
'  padding-bottom: 19px;',
'  width: calc(100% - 16px);',
'  margin-right: 16px;',
'}',
'',
'.advanced-button {',
'  padding-top: 19px;',
'  padding-bottom: 19px;',
'  width: calc(100% - 16px);',
'  margin-right: 16px;',
'}',
'',
'.attribute-button {',
'  padding-top: 19px;',
'  padding-bottom: 19px;',
'  width: calc(100% - 16px);',
'  margin-right: 16px;',
'}',
'',
'.a-BoxedForms .field-item-button-grouping .field-input__wrap {',
'  border-radius: 2px 0 0 2px;',
'}',
'',
'html.no-js .a-BoxedForms .field--style--boxed.label-only .field-label {',
'  padding-top: 1.8rem;',
'  padding-bottom: 1.8rem;',
'}',
'',
'.page-source-table {',
'  font-family: monospace;',
'  font-size: 11px;',
'  line-height: 21px;',
'  margin: 0 4px;',
'}',
'',
'.features-checkbox .apex-item-grid {',
'  width: 100%;',
'  table-layout: fixed;',
'}',
'',
'.field--style--boxed.last-item {',
'  margin-right: 16px !important;',
'}',
'',
'.a-PageWizard-buttons {',
'  margin-top: 0;',
'  padding-top: 32px;',
'  padding-bottom: 16px;',
'}',
'',
'.a-PWList-item--add {',
'  position: relative;',
'}',
'',
'.a-PWList-item--add .a-PWList-name a:before {',
'  position: absolute;',
'  top: 0;',
'  left: 0;',
'  right: 0;',
'  bottom: 0;',
'  content: '''';',
'  display: block;',
'}'))
,p_step_template=>wwv_flow_api.id(3221353480673840388)
,p_page_css_classes=>'a-PageWizard-page'
,p_page_template_options=>'#DEFAULT#'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210818095729'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1007567025794031530)
,p_plug_name=>'Create Application Progress'
,p_region_name=>'createAppProgress'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3012513290302116971)
,p_plug_display_sequence=>30
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8119582015725719321)
,p_plug_name=>'Create an Application'
,p_region_css_classes=>'a-PageWizard '
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2588924839213150542)
,p_plug_name=>'Appearance'
,p_region_name=>'appearance'
,p_parent_plug_id=>wwv_flow_api.id(8119582015725719321)
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display:none;"'
,p_plug_template=>wwv_flow_api.id(2584574193315975428)
,p_plug_display_sequence=>70
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(5170953344043764457)
,p_name=>'Pages'
,p_region_name=>'pages'
,p_parent_plug_id=>wwv_flow_api.id(8119582015725719321)
,p_template=>wwv_flow_api.id(2584574193315975428)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  0 sort_order,',
'  null id,',
'  ''a-PWList-item--add is-not-draggable'' page_li_class,',
'  ''<span data-href="''||apex_page.get_url(p_page => 1000, p_clear_cache => 1000)||''" class="a-PageWizard-icon page-icon page-add" aria-hidden="true"></span>'' page_icon,',
'  ''<a href="''||apex_page.get_url(p_page => 1000, p_clear_cache => 1000)||''">'' || wwv_flow_lang.custom_runtime_message(''CA.ADD.PAGE'') || ''</a>'' page_title,',
'  '' '' page_desc,',
'  null edit_link,',
'  '' '' page_actions,',
'  apex_page.get_url(p_page => 1000, p_clear_cache => 1000) page_link,',
'  ''n'' admin_page_yn,',
'  ''n'' homepage_yn,',
'  '' '' drag_icon,',
'  '' '' page_draggable,',
'  '' '' page_drag_handle',
'from sys.dual ',
'union all',
'select',
'  seq_id sort_order,',
'  seq_id id,',
'  case when c015 = ''Y'' then ''is-admin-page''',
'       else '' ''',
'  end page_li_class,',
'  ''<span class="a-PageWizard-icon page-icon page-'' || replace(lower(c002), ''_'', ''-'')||''"></span>'' page_icon,',
'  ''<span class="a-PWList-navIcon fa ''|| wwv_flow_escape.html( c013 ) ||''" aria-hidden="true"></span> ''|| wwv_flow_escape.html( c001 ) page_title,',
'  case when c012 = ''Y'' then',
'      wwv_flow_lang.custom_runtime_message(''CA.REPORT.N.WITH.FORM'', apex_item.text_from_lov( p_value => c002, p_lov => ''PAGE_TYPES'') )',
'  else',
'      apex_item.text_from_lov( p_value => c002, p_lov => ''PAGE_TYPES'')',
'  end||',
'  case when c003 = ''TABLE'' then '' (<span class="page-source-table">''',
'            || wwv_flow_escape.html( lower(c005) )',
'            || wwv_flow_escape.html( nvl2(c025, ''; '' || lower(c025), null) )',
'            || wwv_flow_escape.html( nvl2(c026, '' ...'', null) )',
'            || ''</span>)''',
'       when c003 = ''SQL'' then '' (<span class="page-source-table">''||wwv_flow_lang.custom_runtime_message(''CA.CUSTOM.QRY'')||''</span>)''',
'       when c015 = ''Y'' then '' (''||wwv_flow_lang.custom_runtime_message(''CA.ADMIN.PAGE'')||'')''',
'  end page_desc,',
'  case when c002 = ''BLANK'' then ',
'           apex_page.get_url(p_page => 1010, p_items => ''P1010_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1010'')',
'       when c002 in ( ''INTERACTIVE_RPT'', ''CLASSIC_RPT'' ) then',
'           apex_page.get_url(p_page => 1020, p_items => ''P1020_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1020'')',
'       when c002 = ''FACETED_SEARCH'' then',
'           apex_page.get_url(p_page => 1140, p_items => ''P1140_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1140'')',
'       when c002 = ''INTERACTIVE_GRID'' then',
'           apex_page.get_url(p_page => 1030, p_items => ''P1030_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1030'')',
'       when c002 = ''FORM'' then',
'           apex_page.get_url(p_page => 1100, p_items => ''P1100_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1100'')',
'       when c002 = ''MASTER_DETAIL'' then',
'           apex_page.get_url(p_page => 1040, p_items => ''P1040_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1040'')',
'       when c002 = ''CHART'' then',
'           apex_page.get_url(p_page => 1050, p_items => ''P1050_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1050'')',
'       when c002 = ''DASHBOARD'' then',
'           apex_page.get_url(p_page => 1060, p_items => ''P1060_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1060'')',
'       when c002 = ''CALENDAR'' then',
'           apex_page.get_url(p_page => 1070, p_items => ''P1070_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1070'')',
'       when c002 = ''CARDS'' then',
'           apex_page.get_url(p_page => 1090, p_items => ''P1090_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1090'')',
'       when c002 = ''TIMELINE'' then',
'           apex_page.get_url(p_page => 1110, p_items => ''P1110_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1110'')',
'       when c002 = ''WIZARD'' then',
'           apex_page.get_url(p_page => 1120, p_items => ''P1120_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1120'')',
'       when c002 = ''MAP'' then',
'           apex_page.get_url(p_page => 1150, p_items => ''P1150_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1150'')',
'       when c002 = ''SMART_FILTERS'' then',
'           apex_page.get_url(p_page => 1160, p_items => ''P1160_SEQ_ID'', p_values => seq_id, p_clear_cache => ''1160'')',
'  end edit_link,',
'  '''' page_actions,',
'  '' '' page_link,',
'  c015 admin_page_yn,',
'  c010 homepage_yn,',
'  case when c015 = ''Y'' then ''<span class="fa fa-wrench" aria-hidden="true" title="''||wwv_flow_lang.custom_runtime_message(''CA.ADMIN.PAGE'')||''"></span>'' -- is admin page',
'       when c010 = ''Y'' then ''<span class="fa fa-home" aria-hidden="true" title="''||wwv_flow_lang.custom_runtime_message(''CA.HOME.PAGE'')||''"></span>'' -- is homepage',
'       else ''<span class="fa fa-bars" aria-hidden="true" title="''||wwv_flow_lang.custom_runtime_message(''CA.DRAG.TO.REORDER'')||''"></span>''',
'  end drag_icon,',
'  case c015 when ''Y'' then ''is-not-draggable''',
'            else case c010 when ''Y'' then ''is-not-draggable'' ',
'                 else ''is-draggable'' ',
'            end',
'  end page_draggable,',
'  '' '' page_drag_handle',
'from apex_collections',
'where collection_name = ''APEX$CREATE_APP_PAGE''',
'order by sort_order'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(2583678044278335201)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2592733388174337004)
,p_query_column_id=>1
,p_column_alias=>'SORT_ORDER'
,p_column_display_sequence=>6
,p_column_heading=>'Sort order'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2592730594146337001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>8
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2592728590024336998)
,p_query_column_id=>3
,p_column_alias=>'PAGE_LI_CLASS'
,p_column_display_sequence=>1
,p_column_heading=>'Page li class'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2592728956532337000)
,p_query_column_id=>4
,p_column_alias=>'PAGE_ICON'
,p_column_display_sequence=>2
,p_column_heading=>'Page icon'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2592729394433337000)
,p_query_column_id=>5
,p_column_alias=>'PAGE_TITLE'
,p_column_display_sequence=>3
,p_column_heading=>'Page title'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2592729720491337001)
,p_query_column_id=>6
,p_column_alias=>'PAGE_DESC'
,p_column_display_sequence=>4
,p_column_heading=>'Page desc'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2592731346485337002)
,p_query_column_id=>7
,p_column_alias=>'EDIT_LINK'
,p_column_display_sequence=>10
,p_column_heading=>'Edit link'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2592730198916337001)
,p_query_column_id=>8
,p_column_alias=>'PAGE_ACTIONS'
,p_column_display_sequence=>5
,p_column_heading=>'Page actions'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<button class="a-Button" type="button" onclick="#EDIT_LINK#">Edit</button>'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2592732981583337004)
,p_query_column_id=>9
,p_column_alias=>'PAGE_LINK'
,p_column_display_sequence=>7
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2934949213997675417)
,p_query_column_id=>10
,p_column_alias=>'ADMIN_PAGE_YN'
,p_column_display_sequence=>14
,p_column_heading=>'Administration page'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2592730987527337002)
,p_query_column_id=>11
,p_column_alias=>'HOMEPAGE_YN'
,p_column_display_sequence=>9
,p_column_heading=>'Home page'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2592732119674337003)
,p_query_column_id=>12
,p_column_alias=>'DRAG_ICON'
,p_column_display_sequence=>12
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2592732504457337003)
,p_query_column_id=>13
,p_column_alias=>'PAGE_DRAGGABLE'
,p_column_display_sequence=>13
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2592731761742337003)
,p_query_column_id=>14
,p_column_alias=>'PAGE_DRAG_HANDLE'
,p_column_display_sequence=>11
,p_column_heading=>'Page drag handle'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<span class="a-PWList-dragHandle #PAGE_DRAGGABLE#">#DRAG_ICON#</span>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5170954103611764465)
,p_plug_name=>'Wizard Header'
,p_parent_plug_id=>wwv_flow_api.id(8119582015725719321)
,p_region_css_classes=>'a-PageWizard-header'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_blueprint_count number := 0;',
'begin',
'',
'    -- get count of blueprints',
'    select count(*)',
'    into l_blueprint_count',
'    from WWV_FLOW_BLUEPRINT_REPO',
'    where created_by = :APP_USER and security_group_id = :FLOW_SECURITY_GROUP_ID;',
'',
'    sys.htp.p(''<div class="a-PageWizard-preview">'');',
'    -- sys.htp.prn(''<a href="''||apex_util.prepare_url(''f?p=4020:900:''||:APP_SESSION||''::::P900_HELP_SECTION:INTRO'')||''">'');',
'    -- sys.htp.prn(wwv_flow_lang.custom_runtime_message(''CA.ABOUT.THIS.PREVIEW.RELEASE''));',
'    -- sys.htp.prn(''</a>'');',
'    sys.htp.prn(''<a href="''||apex_util.prepare_url(''f?p=4020:150:''||:APP_SESSION||'':LOAD_CURRENT::150'')||''" id="view_blueprint">'');',
'    sys.htp.prn(wwv_flow_lang.custom_runtime_message(''CA.VIEW.BLUEPRINT''));',
'    sys.htp.prn(''</a>'');',
'    if l_blueprint_count > 0 then',
'      sys.htp.prn(''<a href="''||apex_page.get_url(p_page => 160, p_session => :APP_SESSION, p_request => ''LOAD'', p_items => ''P160_RETURN_TYPE'', p_values => ''LOAD'')||''" class="a-PageWizard-returnLink" id="load_blueprint">'');',
'      sys.htp.prn(wwv_flow_lang.custom_runtime_message(''CA.LOAD.BLUEPRINT''));',
'      sys.htp.prn(''</a>'');',
'    end if;',
'    sys.htp.prn(''</div><h1>''||wwv_flow_lang.custom_runtime_message(''CA.CREATE.APPLICATION'')||''</h1>'');',
'    exception when others then null;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5170954341225764467)
,p_plug_name=>'Features'
,p_region_name=>'features'
,p_parent_plug_id=>wwv_flow_api.id(8119582015725719321)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(2584574193315975428)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5170955245543764476)
,p_plug_name=>'Misc'
,p_parent_plug_id=>wwv_flow_api.id(8119582015725719321)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7754217211232429554)
,p_plug_name=>'Settings'
,p_region_name=>'advanced'
,p_parent_plug_id=>wwv_flow_api.id(8119582015725719321)
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(2584574193315975428)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8119582248366719323)
,p_plug_name=>'Application'
,p_region_name=>'app_info'
,p_parent_plug_id=>wwv_flow_api.id(8119582015725719321)
,p_region_css_classes=>'a-BoxedForms a-BoxedForms--large'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8119582824709719329)
,p_plug_name=>'Wizard Buttons'
,p_parent_plug_id=>wwv_flow_api.id(8119582015725719321)
,p_region_css_classes=>'a-PageWizard-buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(161343362574782313)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(8119582248366719323)
,p_button_name=>'SET_UI'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Set Appearance'
,p_button_redirect_url=>'f?p=&APP_ID.:170:&SESSION.::&DEBUG.:RP::'
,p_button_css_classes=>'lang-button'
,p_icon_css_classes=>'icon-open-in-dialog'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>1
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2929370093940839432)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(7754217211232429554)
,p_button_name=>'SELECT_ADV_SETTINGS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Define Advanced Settings'
,p_button_redirect_url=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:RP::'
,p_button_css_classes=>'advanced-button'
,p_icon_css_classes=>'icon-open-in-dialog'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>1
,p_required_patch=>wwv_flow_api.id(3027829547778015556)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2929370286352839434)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_api.id(7754217211232429554)
,p_button_name=>'SELECT_ATT_DEF'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Define Attribute Defaults'
,p_button_execute_validations=>'N'
,p_button_css_classes=>'attribute-button is-last'
,p_icon_css_classes=>'icon-open-in-dialog'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>1
,p_required_patch=>wwv_flow_api.id(3027830547707021532)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2796574865702751032)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_api.id(7754217211232429554)
,p_button_name=>'SET_SUPOBJ'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Set Supporting Objects'
,p_button_redirect_url=>'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:RP::'
,p_button_css_classes=>'lang-button'
,p_icon_css_classes=>'icon-open-in-dialog'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>1
,p_required_patch=>wwv_flow_api.id(3124271964326242195)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2588925400019150548)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(7754217211232429554)
,p_button_name=>'HELP_SETTINGS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'View Help for Settings'
,p_button_position=>'HELP'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:SETTINGS'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2595754447069422204)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2588924839213150542)
,p_button_name=>'HELP_UI'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'View Help for Settings'
,p_button_position=>'HELP'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:UI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2595754509287422205)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(5170954341225764467)
,p_button_name=>'HELP_FEATURES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'View Help for Features'
,p_button_position=>'HELP'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:FEATURES'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2595755773975422217)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(5170953344043764457)
,p_button_name=>'HELP_PAGES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'View Help for Pages'
,p_button_position=>'HELP'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:PAGES'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2816364410490843901)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(5170954341225764467)
,p_button_name=>'CHECK_ALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Check All'
,p_button_position=>'HELP'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2698020678343126341)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(8119582824709719329)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_APP'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=4000:1500:&SESSION.::&DEBUG.:RP::'
,p_button_css_classes=>'a-Button--xlarge'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2592727824404336994)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(8119582824709719329)
,p_button_name=>'CREATE_APPLICATION'
,p_button_static_id=>'CREATE_APP'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Application'
,p_button_position=>'PREVIOUS'
,p_button_css_classes=>'a-Button--xlarge a-Button--createApp'
,p_button_cattributes=>'disabled'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(63351936853934416)
,p_branch_name=>'Create Application Error'
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CREATE_APP_ERROR'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2878625357225257309)
,p_branch_name=>'sup obj install failed'
,p_branch_action=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:RP::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_collections',
'where collection_name = ''APEX_DEPLOYMENT_LOG_''||:P1_APP_ID',
'and c002 = ''FAIL'''))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2592737935823337026)
,p_branch_name=>'application home'
,p_branch_action=>'f?p=4000:1:&SESSION.::&DEBUG.:RP:FB_FLOW_ID,F4000_P1_FLOW:&P1_APP_ID.,&P1_APP_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'NOT_EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_collections',
'where collection_name = ''APEX_DEPLOYMENT_LOG_''||:P1_APP_ID',
'and c002 = ''FAIL'''))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3398688211863765508)
,p_branch_name=>'attribute defaults'
,p_branch_action=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.:RP,::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2929370286352839434)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1699270756214123)
,p_name=>'P1_NEW_TABLE_NAME'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(7754217211232429554)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33865378214899629)
,p_name=>'P1_SAMPLE_JSON_ID'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(7754217211232429554)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63351407823934411)
,p_name=>'P1_STATUS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(8119582824709719329)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63351684305934413)
,p_name=>'P1_CURRENT_STATUS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(8119582824709719329)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63351739164934414)
,p_name=>'P1_PCT_COMPLETE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(8119582824709719329)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63351864236934415)
,p_name=>'P1_ERROR_MESSAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(8119582824709719329)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(69711388331469934)
,p_name=>'P1_SCRIPT_FILE_ID'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(7754217211232429554)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(84648867843905208)
,p_name=>'P1_THEME_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(2588924839213150542)
,p_item_default=>'UT'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
,p_item_comment=>'UT, CUSTOM or CUSTOM_UT'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(84648983889905209)
,p_name=>'P1_THEME_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2588924839213150542)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(101210628211869202)
,p_name=>'P1_THEME_STYLE_CLASS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2588924839213150542)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
,p_item_comment=>'Set in DA, used on Page 1 and 1000'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(161343206126782312)
,p_name=>'P1_APPEARANCE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(8119582248366719323)
,p_prompt=>'Appearance'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field-item-button-grouping'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2574074743958843405)
,p_name=>'P1_AUTHENTICATION'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(7754217211232429554)
,p_prompt=>'Authentication'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_default_auth_scheme varchar2(4000) := null;',
'begin',
'    if wwv_flow_authentication_dev.get_internal_authentication in (''CLOUD_IDM'', ''SSO'') then',
'        l_default_auth_scheme := wwv_flow_authentication_dev.get_internal_authentication;',
'    else',
'        l_default_auth_scheme := :PRODUCT_NAME;',
'    end if;',
'      ',
'    return l_default_auth_scheme;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AUTHENTICATION.OPTIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''AUTHENTICATION_NAME.''|| name_with_prefix) as d,',
'       name_with_prefix      as r',
'  from wwv_flow_native_plugins',
' where plugin_type = ''AUTHENTICATION TYPE''',
'   and (          name_with_prefix = ''NATIVE_APEX_ACCOUNTS''',
'         or (     name_with_prefix = ''NATIVE_IAS_SSO''',
'              and wwv_flow_authentication_dev.can_use_sso_yn = ''Y'' )',
'         or (     name_with_prefix = ''NATIVE_SAML'' )',
'         or (     name_with_prefix = ''NATIVE_DB_ACCOUNTS''',
'              and wwv_flow_authentication_dev.get_internal_authentication <> ''CLOUD_IDM'' ) )',
'union all',
'select wwv_flow_lang.system_message(''AUTHENTICATION_NAME.NATIVE_CLOUD_IDM'') d,',
'       ''NATIVE_CLOUD_IDM'' r',
'  from sys.dual',
' where wwv_flow_authentication_dev.get_internal_authentication = ''CLOUD_IDM'''))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'last-item'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_api.id(2698024775220408056)
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2588924959567150543)
,p_name=>'P1_NAV_POSITION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(2588924839213150542)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2592720665139336973)
,p_name=>'P1_FEATURES'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(5170954341225764467)
,p_prompt=>'Features'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'APPLICATION FEATURES'
,p_lov=>'.'||wwv_flow_api.id(2584581350475987525)||'.'
,p_tag_css_classes=>'features-checkbox'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_css_classes=>'a-CBList'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_attribute_01=>'3'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2592721384721336981)
,p_name=>'P1_REMEMBER_WIZARD'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(5170955245543764476)
,p_prompt=>'Remember Wizard'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC:Use this wizard next time I create an application;Y'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2592722076041336984)
,p_name=>'P1_APP_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(7754217211232429554)
,p_prompt=>'Application ID'
,p_source=>'wwv_flow_utilities.minimum_free_flow'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>12
,p_colspan=>4
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_03=>'left'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2592722446739336985)
,p_name=>'P1_PRIMARY_LANGUAGE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(7754217211232429554)
,p_item_default=>':BROWSER_LANGUAGE'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Language'
,p_source=>':BROWSER_LANGUAGE'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_LANGUAGES_LOCALES'
,p_lov=>'.'||wwv_flow_api.id(261035724719892504)||'.'
,p_cHeight=>1
,p_colspan=>4
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_api.id(2698024578226405812)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the primary language for this application.<br /><br />',
'This attribute identifies the language in which an application is developed. This language is the base language from which all translations are made. '))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2592723726162336986)
,p_name=>'P1_SCHEMA'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(7754217211232429554)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(schema) a, schema b',
'from   wwv_flow_company_schemas',
'where  security_group_id = :flow_security_group_id',
'order by 1'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_colspan=>4
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2592725816442336990)
,p_name=>'P1_APP_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(8119582248366719323)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_colspan=>7
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_css_classes=>'item-app-name'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2592726222702336990)
,p_name=>'P1_THEME_APP_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(8119582248366719323)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_theme_app_id number;',
'begin  ',
'    for c1 in (select t.id id',
'                from wwv_flows f, wwv_flow_user_interfaces ui, wwv_flow_app_build_pref p, wwv_flow_themes t',
'               where f.security_group_id = 12',
'                 and p.security_group_id = :flow_security_group_id',
'                 and f.application_type = ''THEME''',
'                 and f.id = ui.flow_id',
'                 and f.id = t.flow_id',
'                 and ui.theme_id = t.theme_id       ',
'                 and ui.ui_type_id = 1',
'                 and ui.theme_id = p.default_application_theme  )',
'    loop   ',
'        l_theme_app_id := c1.id;',
'    end loop;',
'    ',
'    if l_theme_app_id is null then',
'        for c2 in (select t.id id',
'                    from wwv_flows f, wwv_flow_user_interfaces ui, wwv_flow_themes t',
'                   where f.security_group_id = 12',
'                     and f.application_type = ''THEME''',
'                     and f.id = ui.flow_id',
'                     and f.id = t.flow_id',
'                     and ui.theme_id = t.theme_id',
'                     and ui.ui_type_id = 1',
'                     and instr('',''||wwv_flow_platform.get_preference(''DEFAULT_THEMES'')||'','','',''||t.theme_id||'','') > 0 )',
'        loop',
'            l_theme_app_id := c2.id;',
'        end loop;',
'    end if;',
'    ',
'    return l_theme_app_id;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2592726600519336991)
,p_name=>'P1_THEME_STYLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2588924839213150542)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2647105299483258112)
,p_name=>'P1_APP_COLOR_CLASS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(2588924839213150542)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'B'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2698020232651126337)
,p_name=>'P1_APP_COLOR_HEX'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(2588924839213150542)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2698020453382126339)
,p_name=>'P1_APP_ICON_CLASS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(2588924839213150542)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2796574722343751031)
,p_name=>'P1_SUPPORTING_OBJS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(7754217211232429554)
,p_item_default=>'None'
,p_prompt=>'Supporting Objects'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field-item-button-grouping'
,p_item_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3124271964326242195)
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2927879450766772209)
,p_name=>'P1_TRANSLATED_LANGS'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(7754217211232429554)
,p_display_as=>'NATIVE_HIDDEN'
,p_required_patch=>wwv_flow_api.id(2698024578226405812)
,p_help_text=>'Optionally identify additional languages you would like to translate this application into. '
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2929369916090839431)
,p_name=>'P1_ADVANCED_SETTINGS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(7754217211232429554)
,p_prompt=>'Advanced Settings'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field-item-button-grouping label-only'
,p_item_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3027829547778015556)
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2929370181863839433)
,p_name=>'P1_APP_DEFAULTS'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(7754217211232429554)
,p_prompt=>'User Interface Defaults'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field-item-button-grouping label-only'
,p_item_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3027830547707021532)
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3396254935956246644)
,p_name=>'P1_NAV_POSITION_DISP'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(2588924839213150542)
,p_item_default=>'SIDE'
,p_prompt=>'New'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P1_NAVIGATION_POSITION'
,p_lov=>'.'||wwv_flow_api.id(2621239147915611502)||'.'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
,p_item_comment=>'Used in DA "Set Appearance" to get displayed value only. Not saved.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4032943218417342948)
,p_name=>'P1_SCRIPT_RESULT_ID'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(7754217211232429554)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3773582095982301543)
,p_computation_sequence=>10
,p_computation_item=>'P1_THEME_STYLE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Vita'
,p_compute_when=>'P1_THEME_STYLE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3773582128939301544)
,p_computation_sequence=>20
,p_computation_item=>'P1_NAV_POSITION'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'SIDE'
,p_compute_when=>'P1_NAV_POSITION'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2647106702696258127)
,p_computation_sequence=>30
,p_computation_item=>'P1_APP_ICON_CLASS'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'app-icon-rocket'
,p_compute_when=>'P1_APP_ICON_CLASS'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2647106838317258128)
,p_computation_sequence=>40
,p_computation_item=>'P1_APP_COLOR_CLASS'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>'SELECT ''app-color-'' || round( dbms_random.value( 1,8 ) ) as color_class FROM sys.dual;'
,p_compute_when=>'P1_APP_COLOR_CLASS'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2707858906190463440)
,p_computation_sequence=>50
,p_computation_item=>'P1_APP_COLOR_HEX'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select return_value ',
'from apex_application_lov_entries ',
'where application_id = :APP_ID and',
'      list_of_values_name = ''P120_APP_COLORS'' and',
'      display_sequence = replace(:P1_APP_COLOR_CLASS, ''app-color-'');'))
,p_compute_when=>'P1_APP_COLOR_HEX'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2934949192969675416)
,p_computation_sequence=>60
,p_computation_item=>'P1_PRIMARY_LANGUAGE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>':BROWSER_LANGUAGE'
,p_compute_when=>'P1_PRIMARY_LANGUAGE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2796575014459751034)
,p_computation_sequence=>70
,p_computation_item=>'P1_SUPPORTING_OBJS'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>'select dbms_lob.substr(clob001,30,1) x from apex_collections where collection_name = ''APEX$CREATEAPPSUPPOBJ'''
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3674119010657496428)
,p_computation_sequence=>10
,p_computation_item=>'P1_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select run_as',
'from wwv_flow_sw_results',
'where id = :P1_SCRIPT_RESULT_ID',
'and security_group_id = :flow_security_group_id'))
,p_compute_when=>'P1_SCRIPT_RESULT_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(63352257772934419)
,p_validation_name=>'Validate application ID'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_application_id (',
'         p_name => :P1_APP_ID);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'CREATE_APP_ERROR'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_associated_item=>wwv_flow_api.id(2592722076041336984)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(63352379251934420)
,p_validation_name=>'Application ID available'
,p_validation_sequence=>20
,p_validation=>'select 1 from wwv_flows where id = :P1_APP_ID'
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Application ID already exists, or is reserved for another application.'
,p_validation_condition=>'CREATE_APP_ERROR'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_associated_item=>wwv_flow_api.id(2592722076041336984)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(63352452742934421)
,p_validation_name=>'Validate Application Name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_application_name (',
'  p_name => :P1_APP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'CREATE_APP_ERROR'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_associated_item=>wwv_flow_api.id(2592725816442336990)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(63352073466934417)
,p_validation_name=>'Create Application Error'
,p_validation_sequence=>60
,p_validation=>'return false;'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'&P1_ERROR_MESSAGE.'
,p_validation_condition=>'CREATE_APP_ORA_ERROR'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2592736931000337018)
,p_name=>'Refresh Pages on Dialog Close'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(5170953344043764457)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2592737489815337024)
,p_event_id=>wwv_flow_api.id(2592736931000337018)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(5170953344043764457)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2588921638137150510)
,p_name=>'Toggle Create App Btn and Sortable'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(5170953344043764457)
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$(".a-PWList-item").length > 1'
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2588921719428150511)
,p_event_id=>wwv_flow_api.id(2588921638137150510)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(2592727824404336994)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2588921847590150512)
,p_event_id=>wwv_flow_api.id(2588921638137150510)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(2592727824404336994)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2025750319577536748)
,p_event_id=>wwv_flow_api.id(2588921638137150510)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.create_app_wizard.pageSort();'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1917402761781338048)
,p_name=>'Save Schema in Session'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1_SCHEMA'
,p_bind_type=>'bind'
,p_bind_event_type=>'focusout'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1917402832990338049)
,p_event_id=>wwv_flow_api.id(1917402761781338048)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'apex_util.set_session_state(''P1_SCHEMA'', :P1_SCHEMA);'
,p_attribute_02=>'P1_SCHEMA'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2595755989816422219)
,p_name=>'Set Appearance and Toggle Features'
,p_event_sequence=>50
,p_triggering_element_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_element=>'window'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'( this.data && this.data.dialogPageId === 160 ) || ( this.data && this.data.dialogPageId === 170 ) || !this.data'
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2595756028896422220)
,p_event_id=>wwv_flow_api.id(2595755989816422219)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var $ = apex.jQuery,',
'    ajaxData = this.data,',
'    themeType = $v(''P1_THEME_TYPE''),',
'    isCustomTheme = themeType === ''CUSTOM'',',
'    isCustomUT = themeType === ''CUSTOM_UT'',',
'    theme,',
'    nav,',
'    output,',
'    blueprintActions$ = $( ''.a-PageWizard-preview'' ),',
'    features$ = $( ''#features'' ),',
'    page$ = $( ''#pages'' ),',
'    tMapping = {',
'		"Vita": "theme-vita",',
'		"Vita - Slate": "theme-vita-slate",',
'		"Vita - Red": "theme-vita-red",',
'		"Vita - Dark": "theme-vita-dark",',
'        "Redwood Light": "theme-redwood",',
'		"Vista": "theme-vista",',
'	},',
'    // For P1_THEME_STYLE_CLASS that is used on both Page 1 and 1000',
'    themeClass,',
'    defaultThemeClass = tMapping.Vita;',
'',
'var getNavDisp = function( val ){',
'    var txt = $(''#P1_NAV_POSITION_DISP input'').filter(function(){ ',
'                  return this.value === val;',
'              }).next().text();',
'    ',
'    return txt.substr( 0, txt.indexOf(''|'') - 1 ); // remove everything after ''|''',
'};',
'',
'if ( ajaxData ) {',
'    theme = ajaxData.P170_THEME_STYLE;',
'    nav   = ajaxData.P170_NAV_POSITION;',
'    if ( ajaxData.P170_CUSTOM_THEME_YN === ''Y'' ) {',
'        theme = '''',',
'        nav = '''',',
'        isCustomTheme = true;',
'        isCustomUT = ajaxData.P1_THEME_TYPE === ''CUSTOM_UT''',
'    } else {',
'    	isCustomTheme = false;',
'    	isCustomUT = false;',
'    }',
'    ',
'} else {',
'    theme = $v( ''P1_THEME_STYLE'' );',
'    nav   = $v( ''P1_NAV_POSITION'' );',
'}',
'',
'// Display value of P1_APPEARANCE',
'if ( isCustomTheme ) {',
'    output = apex.lang.getMessage( ''CA.CUSTOM_THEME'' );',
'    if (!isCustomUT) {',
'        // clear all feature choices',
'        $( "[name=''P1_FEATURES'']" ).prop( ''checked'', false );',
'        features$.hide();',
'        blueprintActions$.hide();',
'        ',
'    } else {',
'        features$.show();',
'        blueprintActions$.show();',
'    }',
'} else {',
'	$s( ''P1_THEME_TYPE'', ''UT'' );',
'    output = theme + '', '' + getNavDisp( nav ); ',
'    features$.show();',
'    blueprintActions$.show();',
'}',
'',
'// Set P1_APPEARANCE',
'$s( ''P1_APPEARANCE'', output );',
'',
'// Save the class to be reused on Page 1',
'themeClass = tMapping[ theme ] || defaultThemeClass;',
'$s(''P1_THEME_STYLE'', theme );',
'$s(''P1_THEME_STYLE_CLASS'', themeClass );',
'',
'// Update icon theme in "Pages" Region',
'page$',
'	.removeClass( page$.attr(''class'').split('' '').pop() )',
'	.addClass( themeClass );'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2647107076010258130)
,p_name=>'Click Create Application Button'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2592727824404336994)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2647107184363258131)
,p_event_id=>wwv_flow_api.id(2647107076010258130)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(2592727824404336994)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2647107202426258132)
,p_event_id=>wwv_flow_api.id(2647107076010258130)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lProgressTxt, lProgressPct, lLastProgressTxt, lLastProgressPct, lOverlay$,lMessage$, lComplete$,',
'    $ = apex.jQuery,',
'    statusUpdCnt = 0;',
'',
'$(window).scrollTop(0);',
'',
'function updatePageItems(items) {',
'    var i, item;',
'    for (i = 0; i < items.length; i++) {',
'        item = items[i];',
'        $s(item.id, item.value, null, true );',
'    }',
'}',
'',
'var createApp = apex.server.process("createApplication", {',
'    pageItems:["P1_STATUS","P1_APP_ID","P1_APP_NAME","P1_SCHEMA","P1_PRIMARY_LANGUAGE","P1_AUTHENTICATION","P1_FEATURES","P1_TRANSLATED_LANGS"]',
'',
'});',
'',
'// add overlay',
'var lHtml =',
'    ''<div class="a-PWWait-overlay" id="progress_overlay" role="progressbar" aria-busy="true" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" tabindex="-1">''+',
'        ''<div class="a-PWWait-body">''+',
'            ''<div class="a-PWWait-progress">''+',
'                ''<span class="a-PWWait-bar" id="pct_complete"></span>''+',
'            ''</div>''+',
'        ''<div class="a-PWWait-label" id="progress_messages"></div>''+',
'    ''</div>'';',
'',
'$("body").append( lHtml );',
'',
'lOverlay$ = $( ''#progress_overlay'' );',
'lMessage$ = $( ''#progress_messages'', lOverlay$ );',
'lComplete$ = $( ''#pct_complete'', lOverlay$ );',
'',
'// set focus to overlay, this gives better results with screen readers in announcing the progress',
'lOverlay$.focus();',
'',
'createApp.done(function(data) {',
'    if (data && data.items) {',
'        updatePageItems(data.items);',
'    }',
'    currentStatus = $v("P1_STATUS");',
'',
'    if (currentStatus===''DONE'') {',
'        setTimeout(function(){ apex.submit(''CREATE_APP''); }, 500);',
'    } else {',
'        if (currentStatus===''ERROR'') {',
'            apex.submit(''CREATE_APP_ERROR'');',
'        } else {',
'            apex.submit(''CREATE_APP_ORA_ERROR'');',
'        }',
'    }',
'});',
'',
'function waitForStatus() {',
'    setTimeout(function(){',
'        statusUpdCnt = statusUpdCnt + 1;',
'',
'        var getCurrent = apex.server.process("getCurrentStatus", {',
'            pageItems:["P1_PCT_COMPLETE"]',
'        });',
'',
'        getCurrent.done(function(data) {',
'            var currentStatus;',
'',
'            if (data && data.items) {',
'                updatePageItems(data.items);',
'            }',
'',
'            lLastProgressTxt = lProgressTxt;',
'            lLastProgressPct = lProgressPct;',
'',
'            currentStatus = $v("P1_STATUS");',
'            lProgressTxt = $v("P1_CURRENT_STATUS");',
'            lProgressPct = $v("P1_PCT_COMPLETE");',
'',
'            if ((currentStatus!==''DONE'')&&(statusUpdCnt<20)) {',
'',
'                if ((currentStatus===''ERROR'')||(currentStatus===''ORA_ERROR'')) {',
'                    console.log("Error creating application...");',
'                } else {',
'                    waitForStatus();',
'',
'                    // Only update text if text has changed',
'                    if ( lLastProgressTxt !== lProgressTxt ) {',
'                        lMessage$.text( lProgressTxt );',
'                        lOverlay$.attr( ''aria-valuetext'', lProgressTxt );',
'                    }',
'',
'                    // Only update percent complete if it has changed',
'                    if ( lLastProgressPct !== lProgressPct ) {',
'                        lComplete$.css("width",lProgressPct + ''%'');',
'                        lOverlay$.attr( ''aria-valuenow'', lProgressPct );',
'                    }',
'                }',
'            } else {',
'                lMessage$.text($v("P1_CURRENT_STATUS"));',
'                lComplete$.css("width",''100%'');',
'                lOverlay$',
'                    .attr( ''aria-valuenow'', $v("P1_PCT_COMPLETE"))',
'                    .attr( ''aria-valuetext'', ''100'');',
'            }',
'        });',
'    },500);',
'}',
'',
'waitForStatus();',
''))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2816374247679877703)
,p_name=>'Toggle All Features'
,p_event_sequence=>70
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2816364410490843901)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2816374331769877704)
,p_event_id=>wwv_flow_api.id(2816374247679877703)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var flag = apex.create_app_wizard.all_feature_checked;',
'',
'(function( $ ){',
'var c$ = $("[name=''P1_FEATURES'']");',
'	if ( typeof flag === ''undefined'' || !flag ) {',
'		c$.prop(''checked'', true);',
'	    apex.create_app_wizard.all_feature_checked = true;',
'	} else {',
'		c$.prop(''checked'', false);',
'		apex.create_app_wizard.all_feature_checked = false;',
'	}',
'})( apex.jQuery );'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2796575266245751036)
,p_name=>'View Blueprint'
,p_event_sequence=>100
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#view_blueprint'
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2796575328637751037)
,p_event_id=>wwv_flow_api.id(2796575266245751036)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'null;'
,p_attribute_02=>'P1_FEATURES,P1_NAV_POSITION,P1_APP_NAME,P1_AUTHENTICATION'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3055104896529555207)
,p_name=>'Update Supporting Objects'
,p_event_sequence=>110
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2796574865702751032)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3055104988372555208)
,p_event_id=>wwv_flow_api.id(3055104896529555207)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1_SUPPORTING_OBJS'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>'select dbms_lob.substr(clob001,30,1) x from apex_collections where collection_name = ''APEX$CREATEAPPSUPPOBJ'''
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(883418702322822207)
,p_name=>'on lang change, set right-to-left'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1_PRIMARY_LANGUAGE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(883418890017822208)
,p_event_id=>wwv_flow_api.id(883418702322822207)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_direction_right_to_left varchar2(1) := ''N'';',
'begin',
'    for l_lang in (',
'        select distinct direction_right_to_left',
'          from wwv_flow_language_map',
'          where translation_flow_language_code like substr( :P1_PRIMARY_LANGUAGE, 1, 2 )||''%'' )',
'    loop',
'        l_direction_right_to_left := l_lang.direction_right_to_left;',
'        exit;',
'    end loop;',
'',
'    :P5_DOCUMENT_DIRECTION := l_direction_right_to_left;',
'end;',
'    '))
,p_attribute_02=>'P1_PRIMARY_LANGUAGE'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2594843814366086027)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'initialize the wizard'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.init_wizard;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'NEW'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4032943314209342949)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add pages from script result'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.add_page_from_script(',
'    p_schema             => :P1_SCHEMA,',
'    p_script_result_id   => :P1_SCRIPT_RESULT_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':P1_SCRIPT_RESULT_ID is not null and :REQUEST = ''NEW'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69711448639469935)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add pages from script file'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.add_page_from_script(',
'    p_schema  => coalesce( :P1_SCHEMA, wwv_flow_user_api.get_default_schema),',
'    p_file_id => :P1_SCRIPT_FILE_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':P1_SCRIPT_FILE_ID is not null and :REQUEST = ''NEW'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1699344666214124)
,p_process_sequence=>60
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add pages with new table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.add_page_with_new_table(',
'    p_schema     => :P1_SCHEMA,',
'    p_table_name => :P1_NEW_TABLE_NAME,',
'    -- out',
'    p_app_name   => :P1_APP_NAME );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':P1_NEW_TABLE_NAME is not null and :REQUEST = ''NEW'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(33865293426899628)
,p_process_sequence=>70
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add pages from sample JSON'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.add_page_from_sample_json(',
'    p_json_id               => :p1_sample_json_id,',
'    p_built_with_love       => :p5_built_with_love,',
'    p_learn_app_def         => :p5_learn_ui_def_yn,',
'    p_app_name              => :p1_app_name,',
'    p_app_short_desc        => :p5_app_short_desc,',
'    p_app_desc              => :p5_app_desc,',
'    p_features              => :p1_features,',
'    p_theme_style           => :p170_theme_style,',
'    p_nav_position          => :p170_nav_position,',
'    p_app_icon_class        => :p1_app_icon_class,',
'    p_app_color_class       => :p1_app_color_class,',
'    p_app_color_hex         => :p1_app_color_hex,',
'    p_base_table_prefix     => :p5_base_table_prefix,',
'    p_primary_language      => :p1_primary_language,',
'    p_translated_langs      => :p1_translated_langs,',
'    p_authentication        => :p1_authentication,',
'    p_app_version           => :p5_app_version,',
'    p_app_logging           => :p5_app_logging,',
'    p_app_debugging         => :p5_app_debugging,',
'    p_document_direction    => :p5_document_direction,',
'    p_date_format           => :p5_date_format,',
'    p_date_time_format      => :p5_date_time_format,',
'    p_timestamp_format      => :p5_timestamp_format,',
'    p_timestamp_tz_format   => :p5_timestamp_tz_format,',
'    p_deep_linking          => :p5_deep_linking,',
'    p_max_session_length    => :p5_max_session_length,',
'    p_max_session_idle_time => :p5_max_session_idle_time );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':P1_SAMPLE_JSON_ID is not null and :REQUEST = ''NEW'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2025750408723536749)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sortPage'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_internal_page_id number;',
'    l_page_id        number         := apex_application.g_x01;',
'    l_moves_count    number         := apex_application.g_x02;',
'    l_action         varchar2(10)   := apex_application.g_x03;',
'    ',
'begin',
'    l_internal_page_id := wwv_flow_define_app_v3.get_internal_page_id( p_page_id => l_page_id );',
'    ',
'    if l_action = ''up'' then',
'    ',
'        for i in 1..l_moves_count',
'        loop',
'           wwv_flow_define_app_v3.move_page_up( p_page_id => l_page_id );',
'           l_page_id := wwv_flow_define_app_v3.get_page_id( p_internal_page_id => l_internal_page_id );',
'        end loop;',
'        sys.htp.p( ''{"moved_up":'' || l_moves_count ||''}'');',
'',
'    elsif l_action = ''down'' then',
'    ',
'        for j in 1..l_moves_count',
'        loop',
'           wwv_flow_define_app_v3.move_page_down( p_page_id => l_page_id );',
'           l_page_id := wwv_flow_define_app_v3.get_page_id( p_internal_page_id => l_internal_page_id );',
'        end loop;',
'        sys.htp.p( ''{"moved_down":'' || l_moves_count ||''}'');',
'        ',
'    end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_comment=>'Called in JavaScript apex.create_app_wizard.pageSort() to allow user to drag and drop to sort pages.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(63351383807934410)
,p_process_sequence=>20
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'createApplication'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_theme  wwv_flow_create_app_v3.t_theme;',
'begin',
'    l_theme.theme_type  := coalesce(:P1_THEME_TYPE, ''UT'');',
'    l_theme.id          := :P1_THEME_ID;',
'    l_theme.theme_style := :P1_THEME_STYLE;',
'    ',
'    wwv_flow_create_app_v3.create_app (',
'        p_app_id                   => :P1_APP_ID,',
'        p_app_name                 => :P1_APP_NAME,',
'        p_parsing_schema           => :P1_SCHEMA,',
'        p_app_language             => :P1_PRIMARY_LANGUAGE,',
'        p_theme                    => l_theme,',
'        p_authentication_name      => nvl(:P1_AUTHENTICATION, wwv_flow_authentication_api.c_type_apex_accounts),',
'        p_base_table_prefix        => :P5_BASE_TABLE_PREFIX,',
'        p_features                 => :P1_FEATURES,',
'        p_translated_langs         => :P1_TRANSLATED_LANGS,',
'        -- appearance',
'        p_nav_position             => :P1_NAV_POSITION,',
'        p_app_icon_class           => :P1_APP_ICON_CLASS,',
'        p_app_color_class          => :P1_APP_COLOR_CLASS,',
'        p_app_icon_color_hex       => :P1_APP_COLOR_HEX,',
'        -- advanced general',
'        p_built_with_love          => ( nvl(:P5_BUILT_WITH_LOVE, ''N'') = ''Y'' ),',
'        p_learn_app_def            => ( nvl(:P5_LEARN_UI_DEF_YN, ''N'') = ''Y'' ),',
'        p_learn_existing_apps      => ( nvl(:P5_LEARN_YN,''N'') = ''Y'' ),',
'        p_seed_from_app_id         => :P5_SEED_FROM_APP,',
'        p_short_description        => :P5_APP_SHORT_DESC,',
'        p_long_description         => :P5_APP_DESC,',
'        p_app_version              => :P5_APP_VERSION,',
'        p_app_logging              => ( coalesce(:P5_APP_LOGGING, ''Y'') = ''Y'' ),',
'        p_app_debugging            => ( coalesce(:P5_APP_DEBUGGING, ''Y'') = ''Y'' ),',
'        -- advanced security',
'        p_deep_linking             => ( coalesce(:P5_DEEP_LINKING, ''N'') = ''Y'' ),',
'        p_max_session_length_sec   => :P5_MAX_SESSION_LENGTH,',
'        p_max_session_idle_sec     => :P5_MAX_SESSION_IDLE_TIME,',
'        -- advanced globalization',
'        p_document_direction       => coalesce(:P5_DOCUMENT_DIRECTION, ''N''),',
'        p_date_format              => :P5_DATE_FORMAT,',
'        p_date_time_format         => :P5_DATE_TIME_FORMAT,',
'        p_timestamp_format         => :P5_TIMESTAMP_FORMAT,',
'        p_timestamp_tz_format      => :P5_TIMESTAMP_TZ_FORMAT );',
'',
'    htmldb_util.clear_app_cache(',
'        p_app_id => :P1_APP_ID);',
'',
'    if wwv_flow_error.have_errors_occurred then',
'        wwv_flow_debug.info(''... create_app input validation failed'');',
'        apex_json.open_object;',
'        apex_json.open_array(''items'');',
'        apex_json.open_object;',
'        apex_json.write(''id'', ''P1_STATUS'');',
'        apex_json.write(''value'', ''ERROR'');',
'        apex_json.close_object;',
'        apex_json.open_object;',
'        apex_json.write(''id'', ''P1_ERROR_MESSAGE'');',
'        apex_json.write(''value'', ''Error creating application.'');',
'        apex_json.close_object;',
'        apex_json.close_array;',
'        apex_json.close_object;',
'',
'    else',
'        apex_json.open_object;',
'        apex_json.open_array(''items'');',
'        apex_json.open_object;',
'        apex_json.write(''id'', ''P1_STATUS'');',
'        apex_json.write(''value'', ''DONE'');',
'        apex_json.close_object;',
'        apex_json.close_array;',
'        apex_json.close_object;',
'    end if;',
'',
'exception',
'    when others then',
'        apex_json.open_object;',
'        apex_json.open_array(''items'');',
'        apex_json.open_object;',
'        apex_json.write(''id'', ''P1_STATUS'');',
'        apex_json.write(''value'', ''ORA_ERROR'');',
'        apex_json.close_object;',
'        apex_json.open_object;',
'        apex_json.write(''id'', ''P1_ERROR_MESSAGE'');',
'        apex_json.write(''value'', sqlerrm||'' ''||sys.dbms_utility.format_error_backtrace);',
'        apex_json.close_object;',
'        apex_json.close_array;',
'        apex_json.close_object;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(63351586647934412)
,p_process_sequence=>30
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getCurrentStatus'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_percent_comp    number;',
'    l_last_event_name varchar2(4000);',
'',
'begin',
'',
'    wwv_flow_create_app_log_v3.get_progress(',
'        p_last_event_name  => l_last_event_name,',
'        p_percent_complete => l_percent_comp ',
'    );',
'',
'    apex_json.open_object;',
'    apex_json.open_array(''items'');',
'    apex_json.open_object;',
'    apex_json.write(''id'', ''P1_CURRENT_STATUS'');',
'    apex_json.write(''value'', wwv_flow_lang.custom_runtime_message(l_last_event_name));',
'    apex_json.close_object;',
'    apex_json.open_object;',
'    apex_json.write(''id'', ''P1_PCT_COMPLETE'');',
'    apex_json.write(''value'', trunc(l_percent_comp));',
'    apex_json.close_object;',
'    apex_json.close_array;',
'    apex_json.close_object;',
'end;',
'  '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00002
begin
wwv_flow_api.create_page(
 p_id=>2
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Application Created with Errors'
,p_step_title=>'Application Created with Errors'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(3286599848719423369)
,p_page_template_options=>'#DEFAULT#'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210525100106'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2878225923368187963)
,p_plug_name=>'Error Installing Supporting Objects'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(3330277939666606656)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_collections',
'where collection_name = ''APEX_DEPLOYMENT_LOG_''||:P1_APP_ID',
'and c001 = ''PREREQ_CHECK'''))
,p_plug_header=>'The application created.  However, installation of database objects and seed data has failed.'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(2878624699511257302)
,p_name=>'Supporting Object Install Summary'
,p_parent_plug_id=>wwv_flow_api.id(2878225923368187963)
,p_template=>wwv_flow_api.id(2983766147992137991)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="margin-top:16px"'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 script_name, ',
'       decode(c002, ''SUCCESS'', ',
'                    wwv_flow_lang.system_message(''INSTALLER.SCRIPT.SUCCESS''),',
'                    ''FAIL'',',
'                    wwv_flow_lang.system_message(''INSTALLER.SCRIPT.FAIL'')) status,        ',
'       to_number(nvl(c003,0)) fail_count,',
'       to_number(nvl(c004,0)) success_count,',
'       c003 + c004 total_count',
'  from wwv_flow_collections',
' where collection_name = ''APEX_DEPLOYMENT_LOG_''||:P1_APP_ID',
' and c001 != ''PREREQ_CHECK'''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(2707641403506668051)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No install results found'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2878624700494257303)
,p_query_column_id=>1
,p_column_alias=>'SCRIPT_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Script name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2878624845839257304)
,p_query_column_id=>2
,p_column_alias=>'STATUS'
,p_column_display_sequence=>2
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2878624983291257305)
,p_query_column_id=>3
,p_column_alias=>'FAIL_COUNT'
,p_column_display_sequence=>3
,p_column_heading=>'Fail count'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2878625003191257306)
,p_query_column_id=>4
,p_column_alias=>'SUCCESS_COUNT'
,p_column_display_sequence=>4
,p_column_heading=>'Success count'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2878625138395257307)
,p_query_column_id=>5
,p_column_alias=>'TOTAL_COUNT'
,p_column_display_sequence=>5
,p_column_heading=>'Total count'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2878625282128257308)
,p_plug_name=>'Errors'
,p_parent_plug_id=>wwv_flow_api.id(2878225923368187963)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(2983766147992137991)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select c001 script_name, clob001 errors ',
'           from wwv_flow_collections ',
'           where collection_name = ''APEX_DEPLOYMENT_LOG_''||:P1_APP_ID',
'           and c001 != ''PREREQ_CHECK''',
'           and length(clob001) > 0)',
'loop',
'  sys.htp.p(''<strong>''||wwv_flow_escape.html(c1.script_name)||''</strong>'');',
'  sys.htp.p(''<pre>'');',
'  wwv_flow_sw_script.escape_sc_clob(c1.errors);',
'  sys.htp.p(''</pre>'');',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2878226271378193901)
,p_plug_name=>'Prerequisite Check Failed'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(3330277939666606656)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_collections',
'where collection_name = ''APEX_DEPLOYMENT_LOG_''||:P1_APP_ID',
'and c001 = ''PREREQ_CHECK'''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2878624552166257301)
,p_plug_name=>'Errors'
,p_parent_plug_id=>wwv_flow_api.id(2878226271378193901)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3286693190338347807)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select c001 script_name, clob001 errors ',
'           from wwv_flow_collections ',
'           where collection_name = ''APEX_DEPLOYMENT_LOG_''||:P1_APP_ID',
'           and c001 = ''PREREQ_CHECK''',
'           and length(clob001) > 0)',
'loop',
'    -- note: populates message is formatted with HTML tag if prerequisite check fails, don''t escape',
'    sys.htp.p( c1.errors );',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2796572679532751010)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2878225923368187963)
,p_button_name=>'GO_TO_APP'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Continue to Application'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2881063456729709562)
,p_branch_name=>'Redirect to Application Home'
,p_branch_action=>'f?p=4000:1:&SESSION.::&DEBUG.:RP:FB_FLOW_ID,F4000_P1_FLOW:&P1_APP_ID.,&P1_APP_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2796572679532751010)
,p_branch_sequence=>20
);
end;
/
prompt --application/pages/page_00005
begin
wwv_flow_api.create_page(
 p_id=>5
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Advanced Settings'
,p_page_mode=>'MODAL'
,p_step_title=>'Advanced Settings'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.field.item-app-name {margin-bottom:0;}',
'.field--style--boxed .display_only {',
'    line-height: 24px;',
'}',
'.apex-col .field.field-item-button-grouping {',
'    margin-right: -1px;',
'}',
'.lang-button {',
'    padding-top: 19px;',
'    padding-bottom: 19px;',
'    width: calc(100% - 16px);',
'    margin-right: 16px;',
'}',
'',
'.a-BoxedForms .field-item-button-grouping .field-input__wrap {',
'    border-radius: 2px 0 0 2px;',
'}'))
,p_step_template=>wwv_flow_api.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-page'
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3027829547778015556)
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210526080606'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2929370393401839435)
,p_plug_name=>'Security'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(2758664310411868479)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2929371486458839446)
,p_plug_name=>'Globalization'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(2758664310411868479)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2940046733568003236)
,p_plug_name=>'Settings'
,p_region_name=>'general'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(2758664310411868479)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3504377147071326201)
,p_plug_name=>'User Interface Attributes'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(2758664310411868479)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Copy attributes (such as labels, list of values, format masks and more) from other apps within your workspace and apply them to this application.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3504377748981326207)
,p_plug_name=>'Description'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(2758664310411868479)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11817120097807501405)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3025635143275097802)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(11817120097807501405)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3025635596494097804)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(11817120097807501405)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3025635979593097804)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(11817120097807501405)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP:P900_HELP_SECTION:ADVANCED'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33865152934899627)
,p_name=>'P5_BUILT_WITH_LOVE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2940046733568003236)
,p_item_default=>'N'
,p_prompt=>'Add "Built with APEX" to Footer'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'When set to <strong>On</strong>, Oracle Application Express will add the text "Built with Love using Oracle APEX" to the footer of every page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2929369566225839427)
,p_name=>'P5_APP_SHORT_DESC'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3504377748981326207)
,p_prompt=>'Short Description'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(2698024775220408056)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter text to be displayed as a subtitle, under the application name on the home page.</p>',
'<p><em><strong>Note:</strong> This setting requires the <strong>Application Settings</strong> feature to be selected. If it is not selected then the subtitle will not be displayed.</em></p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2929369611036839428)
,p_name=>'P5_APP_DESC'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3504377748981326207)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(2698024775220408056)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter text to be displayed on the <strong>About This Application</strong> page, accessed from the help icon in the navigation bar.</p>  ',
'<p><em><strong>Note:</strong> This setting requires the <strong>Help Pages</strong> feature to be selected. If it is not selected the about page will not be generated.</em></p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2929370594430839437)
,p_name=>'P5_DEEP_LINKING'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2929370393401839435)
,p_item_default=>'N'
,p_prompt=>'Deep Linking'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_css_classes=>'item-app-name'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This attribute enables or prevents deep linking to an application. Options include:</p>',
'<ul>',
'<li><strong>Enabled</strong> - The URL to a specific page ultimately redirects there, possibly after the user has to logged in.</li>',
'<li><strong>Disabled</strong> - If the URL does not contain a valid session ID, &PRODUCT_NAME. redirects to the application''s home page.</li>',
'</ul>',
'<p>For example, browsers often save the URLs of opened tabs and try to restore the sessions after a restart, causing a deep link. This behavior may be undesirable (for example if a URL points to a page in the middle of a multi-step wizard). By select'
||'ing Disable, &PRODUCT_NAME. starts a new session and redirects to the application''s home page.</p>',
'<p>Note you can override this application setting at page-level.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2929370739829839439)
,p_name=>'P5_MAX_SESSION_LENGTH'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2929370393401839435)
,p_prompt=>'Maximum session length in seconds'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS'
,p_lov=>'.'||wwv_flow_api.id(3052299639682461644)||'.'
,p_lov_display_null=>'YES'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Defines how long (in seconds) sessions can exist and be used by this application.',
'',
'<ul>',
'    <li>Enter a positive integer to control how long a session can exist.</li>',
'    <li>Enter 0 to have sessions exist indefinitely.</li>',
'    <li>Leave the value empty in order to use the session duration defined at the workspace level or the instance level.</li>',
'</ul>',
'<br />',
'',
'The session duration may be superseded by the operation of the hourly database job, which deletes sessions older than 12 hours.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2929370850688839440)
,p_name=>'P5_MAX_SESSION_IDLE_TIME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2929370393401839435)
,p_prompt=>'Maximum session idle time in seconds'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS'
,p_lov=>'.'||wwv_flow_api.id(3052299639682461644)||'.'
,p_lov_display_null=>'YES'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The Session Idle Time is the time between the last page request and the next page request.',
'<ul>',
'    <li>Enter a positive integer to control the idle time for sessions used by this application.</li>',
'    <li>Set the value to 0 to prevent session idle time checks from being performed.</li>',
'    <li>Leave the value empty in order to use the idle time defined at the workspace level or the instance level.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2929371132330839443)
,p_name=>'P5_APP_VERSION'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(2940046733568003236)
,p_item_default=>'Release 1.0'
,p_prompt=>'Version'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(2698024775220408056)
,p_help_text=>'<p>Enter the application version. The version is displayed by default on the bottom of each page.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2929371618618839448)
,p_name=>'P5_DOCUMENT_DIRECTION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2929371486458839446)
,p_item_default=>'N'
,p_prompt=>'Document Direction'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RIGHT-TO-LEFT'
,p_lov=>'.'||wwv_flow_api.id(560908550288645029)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Set document direction left-to-right or right-to-left.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2929371717725839449)
,p_name=>'P5_DATE_FORMAT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2929371486458839446)
,p_prompt=>'Date Format'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Determines the date format to be used in the application.</p>',
'<p>This date format is used to alter the <code>NLS_DATE_FORMAT</code> database session setting prior to showing or submitting any page in the application. This value can be a literal string containing a valid Oracle date format mask or an item refere'
||'nce using substitution syntax. If no value is specified, the default date format is derived from the database session at runtime.</p>',
'Examples:',
'<ul>',
'<li><code>Month DD, YYYY</code></li>',
'<li><code>&amp;MY_DATE_FORMAT.</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2929371865789839450)
,p_name=>'P5_DATE_TIME_FORMAT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(2929371486458839446)
,p_prompt=>'Date Time Format'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the date time format to be used in the application.</p>',
'<p>This date time format can be referenced in an application using the substitution reference <code>&amp;APP_DATE_TIME_FORMAT.</code>, or in PL/SQL via the function <code>v(''APP_DATE_TIME_FORMAT'')</code>.  This attribute does not alter any NLS settin'
||'gs.  This value can be a literal string containing a valid Oracle date format mask or an item reference using substitution syntax.  If this attribute value is not specified, then a reference to <code>APP_DATE_TIME_FORMAT</code> will return the NLS da'
||'tabase session date format and the NLS time format.</p>',
'Examples:',
'<ul>',
'<li><code>Month DD, RRRR HH24:MI</code></li>',
'<li><code>&amp;MY_DATE_TIME_FORMAT.</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2940046641169003235)
,p_name=>'P5_APP_DEBUGGING'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(2940046733568003236)
,p_item_default=>'Y'
,p_prompt=>'Debugging'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_css_classes=>'item-app-name'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether debug mode can be enabled via the browser. Available options include:<p>',
'<ul>',
'<li><strong>On</strong>. Enables the application to enable debug mode via the browser at runtime.</li>',
'<li><strong>Off</strong>. Disables the application from enabling in debug from a browser.</li>',
'</ul>',
'<p>Running an application in debug mode is useful when an application is under development. However, for a production application, it is a good idea to disable debugging and thus prevent users from viewing application logic.</p>',
'<p>Debug can be enabled programmatically regardless of this debug setting.</p>',
'<p>If the application is run from the &PRODUCT_NAME. development environment, debugging can always be enabled.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2940046874787003237)
,p_name=>'P5_COMPATABILITY'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(2940046733568003236)
,p_prompt=>'Compatibility Mode'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_default_auth_scheme varchar2(4000) := null;',
'begin',
'    if wwv_flow_authentication_dev.get_internal_authentication in (''CLOUD_IDM'', ''SSO'') then',
'        l_default_auth_scheme := wwv_flow_authentication_dev.get_internal_authentication;',
'    else',
'        l_default_auth_scheme := :PRODUCT_NAME;',
'    end if;',
'      ',
'    return l_default_auth_scheme;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:5.1;5.1;,Default;DEFAULT'
,p_cHeight=>1
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_api.id(2698024775220408056)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'This attribute controls the compatibility mode of the Oracle Application Express runtime engine. Certain runtime behaviors are changed from release to release. Use this attribute to obtain specific application behavior. To realize new behavior in an '
||'application, set the compatibility mode of the application to the current version.',
'</p>',
'<p>',
'For details see chapter ''Changed Behavior - Compatibility Mode'' in the Release Notes.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3022411239924971763)
,p_name=>'P5_APP_LOGGING'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(2940046733568003236)
,p_item_default=>'Y'
,p_prompt=>'Logging'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_css_classes=>'item-app-name'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Determines whether or not user activity is recorded in the activity log. When set to <strong>On</strong>, every page view is logged, enabling an administrator to monitor user activity for each application.<p/>',
'<p>',
'Disabling logging may be advisable for high volume applications.',
'</p>',
'<p>',
'This attribute can only be modified if the feature configuration "Application Activity Logging" in &PRODUCT_NAME. internal administration is set to "Use Application Setting".',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3028031392407628902)
,p_name=>'P5_TIMESTAMP_FORMAT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(2929371486458839446)
,p_prompt=>'Timestamp Format'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Determines the timestamp format to be used in the application.</p>',
'<p>This timestamp format is used to alter the <code>NLS_TIMESTAMP_FORMAT</code> database session setting prior to showing or submitting any page in the application. This value can be a literal string containing a valid Oracle timestamp format mask or'
||' an item reference using substitution syntax. If no value is specified, the default timestamp format is derived from the database session at runtime.</p>',
'Examples:',
'<ul>',
'<li><code>DD-MON-RR HH.MI.SSXFF AM</code></li>',
'<li><code>&amp;MY_TIMESTAMP_FORMAT.</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3028031441279628903)
,p_name=>'P5_TIMESTAMP_TZ_FORMAT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(2929371486458839446)
,p_prompt=>'Timestamp with Timezone Format'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Determines the timestamp with time zone format to be used in the application.</p>',
'<p>This date format is used to alter the <code>NLS_TIMESTAMP_TZ_FORMAT</code> database session setting prior to showing or submitting any page in the application. This value can be a literal string containing a valid Oracle timestamp with time zone f'
||'ormat mask or an item reference using substitution syntax. If no value is specified, the default timestamp with time zone format is derived from the database session at runtime.</p>',
'Examples:',
'<ul>',
'<li><code>DD-MON-RR HH.MI.SSXFF AM TZR</code></li>',
'<li><code>&amp;MY_TIMESTAMP_TZ_FORMAT.</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3398688067867765506)
,p_name=>'P5_BASE_TABLE_PREFIX'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3504377147071326201)
,p_prompt=>'Table Prefixes'
,p_placeholder=>'HR_, OE_'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(2698024775220408056)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter table prefixes currently used by existing database tables on which pages are based.  These prefixes may be different from the framework table prefix (for database objects created by this application when generated).</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3504377278993326202)
,p_name=>'P5_LEARN_YN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3504377147071326201)
,p_item_default=>'N'
,p_prompt=>'Copy from Existing Apps'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select <strong>On</strong> if you want the attribute defaults to be based on existing <u>Form</u> pages, based on the same table, in current applications defined within this workspace.</p>',
'<p>For example, if you have an application with a form page based on <code>APEX$DEMO_PROJ_TASKS</code> and you define a report on the same table, then the attribute defaults will be based on the item definitions on that form page, if this option is s'
||'et to <strong>On</strong>.</p>',
'<p><em><strong>Note:</strong> If there are multiple form pages based on the same table, then the definitions from the most recently updated page will be utilized.</em></p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3504378824056326218)
,p_name=>'P5_SEED_FROM_APP'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3504377147071326201)
,p_prompt=>'Copy Attributes from'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'All Applications'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_required_patch=>wwv_flow_api.id(2698024775220408056)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this application to copy meta data.</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3504379001911326220)
,p_name=>'P5_LEARN_UI_DEF_YN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3504377147071326201)
,p_item_default=>'N'
,p_prompt=>'Apply User Interface Defaults'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select <strong>On</strong> if you want the attribute defaults to be based on existing User Interface Defaults defined within this workspace.</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3035688212550083801)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3025635143275097802)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3035688338214083802)
,p_event_id=>wwv_flow_api.id(3035688212550083801)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2934952434131675449)
,p_name=>'if learn, show copy from app'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P5_LEARN_YN'
,p_condition_element=>'P5_LEARN_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2934952547911675450)
,p_event_id=>wwv_flow_api.id(2934952434131675449)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P5_SEED_FROM_APP'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3674116303730496401)
,p_event_id=>wwv_flow_api.id(2934952434131675449)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P5_SEED_FROM_APP'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3035688413773083803)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00110
begin
wwv_flow_api.create_page(
 p_id=>110
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Select Icon'
,p_page_mode=>'MODAL'
,p_step_title=>'Select Icon'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* Init Modal */',
'initWizardModal = function() {',
'    function _initDialog() {',
'        var headerheight = $(''.a-Dialog-wizardSteps'').height(),',
'            footerheight = $(''.a-Dialog-footer'').height();',
'        $(''.a-Dialog-body'').css({',
'            ''top'':headerheight,',
'            ''bottom'':footerheight',
'        });',
'    }',
'    $(window).bind(''apexwindowresized'', function() {',
'        _initDialog();',
'    });',
'    _initDialog();',
'};',
'',
'',
'apex.create_app_wizard = apex.create_app_wizard || {};',
'',
'(function( $ ){',
'',
'	var icons = {},',
'		iconCont$;',
'',
'	var getIcons = function (){',
'        var data = {},',
'            links$ = $( ''a.a-PWIconPicker-link'' );',
'',
'        links$.each(function( index ) {',
'            var that$ = $( this )',
'            data[ that$.attr( ''id'' ) ] = that$.data( ''filters'' );',
'        });',
'',
'        return data;',
'    };',
'',
'    var search = function( key ){',
'    	var key = key.trim().toLowerCase(),',
'    		keyLen = key.length;',
'',
'    	var resetList = function(){',
'    		iconCont$',
'    			.removeClass( ''js-searching'' )',
'    			.find( ''.js-hit'' )',
'    			.removeClass( ''js-hit'' );',
'    	};',
'',
'    	resetList();',
'',
'    	if ( key.length >= 2 ) {',
'',
'    		iconCont$.addClass( ''js-searching'' );',
'',
'	    	for ( var k in icons ) {',
'	    		if ( icons.hasOwnProperty(k) ) {',
'	    			if ( k.indexOf( key ) != -1 || icons[k].indexOf( key ) != -1 ) {',
'	    				$( ''#'' + k )',
'	    					.parent()',
'	    					.addClass( ''js-hit'' );',
'	    			}',
'	    		}',
'	    	}',
'    	}',
'    };',
'',
'    var passBack = function( icon, passToUi, passToSave ) {',
'        ',
'        var jQueryInOtherDialog$ = parent.window.frames[0].apex.jQuery,',
'        	iconSpan$ = jQueryInOtherDialog$( ''#'' + passToUi ).find( ''span.a-Icon'' ),',
'        	lastClass = iconSpan$.attr(''class'').split('' '').pop();',
'',
'        iconSpan$',
'            .removeClass( lastClass )',
'            .addClass( ''fa '' + icon );',
'',
'        jQueryInOtherDialog$( ''#'' + passToSave ).val( icon );',
'        apex.util.getTopApex().navigation.dialog.cancel(true);',
'    };',
'',
'	apex.create_app_wizard.initIconSearch = function( options ){',
'',
'		icons = getIcons(),',
'',
'		iconCont$ = $( ''#'' + options.container || ''icons'' );',
'',
'		iconCont$.on( ''click'', ''a.a-PWIconPicker-link'', function(){',
'	        var iconName = $( this ).attr( ''id'' );',
'	        passBack( iconName, options.passToUi, options.passToSave );',
'	    } );',
'	    ',
'	    $( ''#'' + options.searchField ).on( ''keyup'', function(){',
'	    	var k = this.value;',
'		    setTimeout(function() {',
'	        	search( k );',
'	        }, 500);',
'	    })',
'	};',
'',
'})( apex.jQuery );'))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'initWizardModal();',
'',
'apex.create_app_wizard.initIconSearch({',
'    "container":     "icons",',
'    "searchField":   "P110_SEARCH",',
'    "passToUi":      "&P110_PASS_BACK_TO_UI.",',
'    "passToSave":    "&P110_PASS_BACK_TO_SAVE."',
'});'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.js-searching li {',
'    display: none;',
'}',
'',
'.js-searching li.js-hit {',
'    display: block;',
'}'))
,p_page_css_classes=>'a-PageWizard-dialog a-PageWizard-dialog--icons'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'440'
,p_dialog_width=>'400'
,p_dialog_attributes=>'resizable:true'
,p_dialog_chained=>'N'
,p_browser_cache=>'Y'
,p_cache_mode=>'CACHE'
,p_cache_timeout_seconds=>21600
,p_page_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#themes/theme_42/1.1/demo/demo#MIN#.js',
'#IMAGE_PREFIX#themes/theme_42/1.1/js/demo/icons#MIN#.js'))
,p_last_upd_yyyymmddhh24miss=>'20170421040630'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2025750057378536745)
,p_plug_name=>'Search Bar'
,p_region_css_classes=>'a-PWIconPicker-search'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2647104751646258107)
,p_plug_name=>'Icon List - PLSQL'
,p_region_name=>'icons'
,p_region_css_classes=>'icon-list'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'',
'    sys.htp.p( ''<ul class="a-PWIconPicker">'' );',
'    ',
'    for c1 in ( ',
'        select icon_name, icon_filters',
'          from wwv_flow_standard_icons',
'         where icon_library = ''FONTAPEX''',
'         order by icon_name )',
'    loop',
'',
'        sys.htp.p( ''<li class="a-PWIconPicker-item"><a href="javascript:void(0)" class="a-PWIconPicker-link" id="'' || c1.icon_name || ''" data-filters="'' || c1.icon_filters || ''">''',
'                    || ''<span class="t-Icon fa '' || c1.icon_name || ''" aria-hidden="true"></span>''',
'                    || ''</a></li>'' );',
'    end loop;',
'    ',
'    sys.htp.p( ''</ul>'' );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_caching=>'CACHE'
,p_plug_caching_max_age_in_sec=>21600
,p_plug_cache_depends_on_items=>'APP_REQUEST_DATA_HASH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2025750167049536746)
,p_name=>'P110_SEARCH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2025750057378536745)
,p_prompt=>'Search Icons'
,p_placeholder=>'Search all &P110_COUNT. icons ...'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_tag_css_classes=>'a-PWIconPicker-searchInput'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2593478457378715617)
,p_name=>'P110_SELECTED_ICON'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(2025750057378536745)
,p_item_default=>'fa-cloud'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2647104883557258108)
,p_name=>'P110_COUNT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2025750057378536745)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
' from wwv_flow_standard_icons',
'where icon_library = ''FONTAPEX'''))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2647105031292258110)
,p_name=>'P110_PASS_BACK_TO_UI'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2025750057378536745)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2647105144549258111)
,p_name=>'P110_PASS_BACK_TO_SAVE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2025750057378536745)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2595754895632422208)
,p_name=>'Cancel Enter'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P110_SEARCH'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'this.browserEvent.which === 13'
,p_bind_type=>'bind'
,p_bind_event_type=>'keypress'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2595754930833422209)
,p_event_id=>wwv_flow_api.id(2595754895632422208)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CANCEL_EVENT'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2593478751056715620)
,p_name=>'Close Dialog on Icon Selection'
,p_event_sequence=>20
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.a-PWIconPicker-link'
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
,p_display_when_type=>'NEVER'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2593478824500715621)
,p_event_id=>wwv_flow_api.id(2593478751056715620)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
,p_attribute_01=>'P110_SELECTED_ICON'
);
end;
/
prompt --application/pages/page_00120
begin
wwv_flow_api.create_page(
 p_id=>120
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Choose Application Icon'
,p_page_mode=>'MODAL'
,p_step_title=>'Choose Application Icon'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$.fn.removeClassWithPrefix = function (prefix) {',
'  $(this).removeClass(function (index, className) {',
'    return (className.match(new RegExp("\\S*" + prefix + "\\S*", ''g'')) || []).join('' '')',
'  });',
'  return this;',
'};'))
,p_page_css_classes=>'a-PageWizard-dialog a-PageWizard-dialog--appIconPicker'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'580'
,p_dialog_width=>'760'
,p_dialog_attributes=>'resizable:true'
,p_dialog_chained=>'N'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210514144523'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2595758406326422244)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2661566014835000912)
,p_plug_name=>'Icons'
,p_region_name=>'app_icons_gallery'
,p_region_css_classes=>'a-PageWizard-appIcons &P170_APP_COLOR_CLASS.'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2661566271179000914)
,p_plug_name=>'Icon Preview'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display: none"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<div id="app_icon_preview" class="a-PageWizard-appIcon a-PageWizard-appIcon--preview &P170_APP_COLOR_CLASS. &P170_APP_ICON_CLASS."></div>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2595758618998422246)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2595758406326422244)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2595758599738422245)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2595758406326422244)
,p_button_name=>'SET_APP_ICON'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set Application Icon'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2647106546767258125)
,p_name=>'P120_ICON_CLASS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2661566014835000912)
,p_source=>'P170_APP_ICON_CLASS'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'B'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2661566112535000913)
,p_name=>'P120_ICON_PICKER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2661566014835000912)
,p_prompt=>'Icon Picker'
,p_source=>'select replace( :P170_APP_ICON_CLASS, ''app-icon-'', null) as icon from dual;'
,p_source_type=>'QUERY'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'P120_APP_ICONS'
,p_lov=>'.'||wwv_flow_api.id(2672360045214033881)||'.'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_css_classes=>'a-IconList--AppIcons'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_protection_level=>'B'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2661569781624000949)
,p_name=>'P120_ICON_COLOR'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2661566014835000912)
,p_prompt=>'Icon Color'
,p_source=>'P170_APP_COLOR_HEX'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P120_APP_COLORS'
,p_lov=>'.'||wwv_flow_api.id(2698004887684998460)||'.'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_css_classes=>'a-PageWizard-appIconColorPicker'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_protection_level=>'B'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'8'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2698019345534126328)
,p_name=>'P120_ICON_COLOR_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2661566014835000912)
,p_source=>'P170_APP_COLOR_CLASS'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'B'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2595758737946422247)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2595758618998422246)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2595758864422422248)
,p_event_id=>wwv_flow_api.id(2595758737946422247)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2698019626181126331)
,p_name=>'Set Color on Page Load'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2698019765387126332)
,p_event_id=>wwv_flow_api.id(2698019626181126331)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(function( $ ){',
'    var iconColor = $v(''P120_ICON_COLOR_CLASS'');    ',
'    ',
'    $("#P120_ICON_COLOR span.app-color").each(function(){',
'      var curItem$ = $(this);',
'      if (curItem$.hasClass( iconColor )) {',
'        curItem$.parent().prev().prop("checked",true);',
'      }',
'    });',
'',
'})( apex.jQuery );'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2698019869993126333)
,p_name=>'Change Color'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P120_ICON_COLOR'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2698019975244126334)
,p_event_id=>wwv_flow_api.id(2698019869993126333)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(function( $, that ){',
'    var colorClass = $(that.triggeringElement).find("input[type=''radio'']:checked + label span").attr("class").split(" ").pop();',
'    ',
'    /*',
'    $("#app_icon_preview")',
'        .removeClassWithPrefix("app-color")',
'        .addClass(colorClass);',
'    */',
'    ',
'    $("#app_icons_gallery")',
'        .removeClassWithPrefix("app-color")',
'        .addClass(colorClass);',
'    ',
'    $("#P120_ICON_COLOR_CLASS").val( colorClass );',
'})( apex.jQuery, this );'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2698020086425126335)
,p_name=>'Change Icon'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P120_ICON_PICKER'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2698020187827126336)
,p_event_id=>wwv_flow_api.id(2698020086425126335)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(function( $, that ){',
'    var iconClass = ''app-icon-'' + $v(that.triggeringElement);',
'    ',
'    /*$("#app_icon_preview")',
'        .removeClassWithPrefix("app-icon-")',
'        .addClass(iconClass);',
'        */',
'    ',
'    $("#P120_ICON_CLASS").val( iconClass );',
'})( apex.jQuery, this );'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2647105680018258116)
,p_name=>'Get App Icon'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2595758599738422245)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2647105755022258117)
,p_event_id=>wwv_flow_api.id(2647105680018258116)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(function( $ ){',
'',
'	var top$ = window.parent.frames[0].apex.jQuery;  //apex.util.getTopApex().jQuery;',
'',
'	var iconClass = ''app-icon-'' + $v(''P120_ICON_PICKER''),',
'		appColorClass = $v(''P120_ICON_COLOR_CLASS''),',
'		hexColor = $( ''#P120_ICON_COLOR'' ).find( ''.'' + appColorClass ).parent().prev().val();',
'',
'	top$( ''#P170_APP_COLOR_CLASS'' ).val( appColorClass );',
'	top$( ''#P170_APP_ICON_CLASS'' ).val( iconClass );',
'	top$( ''#P170_APP_COLOR_HEX'' ).val( hexColor );',
'',
'	top$( ''#app_icon'' )',
'		.removeClass()',
'		.addClass( ''a-PageWizard-appIcon '' + iconClass  + '' '' + appColorClass );',
'    ',
'    apex.submit();',
'    ',
'})( apex.jQuery );'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2647106425624258124)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Page 170 App Icon'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P170_APP_COLOR_CLASS := :P120_ICON_COLOR_CLASS;',
':P170_APP_ICON_CLASS  := :P120_ICON_PICKER;',
':P170_APP_COLOR_HEX   := :P120_ICON_COLOR;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2647106282983258122)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00130
begin
wwv_flow_api.create_page(
 p_id=>130
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Application Languages'
,p_page_mode=>'MODAL'
,p_step_title=>'Application Languages'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'fieldset.checkbox_group {',
'    width: 100%;',
'}',
'fieldset.checkbox_group table {',
'    width: 100%;',
'}',
'p.note {',
'margin: 0 8px;',
'color: #707070;',
'font-size: 11px;}',
'',
'.is-disabled {',
'    opacity: .5;',
'    pointer-events: none;',
'    cursor: not-allowed;',
'  }'))
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(2698024578226405812)
,p_dialog_height=>'360'
,p_last_upd_yyyymmddhh24miss=>'20171009062401'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2796572808670751012)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2796573006579751014)
,p_plug_name=>'Primary Language'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2796573473167751018)
,p_plug_name=>'Translations'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p class="note">Your application will be displayed in the language(s) selected. If more than one language is selected, users will be be provided links for the different languages on the Sign In page.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2796573782624751021)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2796572808670751012)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2796572933171751013)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(2796572808670751012)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2996641060711931005)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2796572808670751012)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP:P900_HELP_SECTION:LANG'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2796573199336751015)
,p_name=>'P130_TRANSLATED_LANGS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2796573473167751018)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Translations'
,p_source=>'P1_TRANSLATED_LANGS'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'TRANSLATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.translated_lang_name as lang_name, f.flow_language',
'from ( select flow_language',
'          from wwv_flows f',
'         where id = :APP_ID',
'         union',
'        select flow_language',
'          from wwv_flows f',
'         where id in ( select translation_flow_id',
'                         from wwv_flow_language_map',
'                        where primary_language_flow_id = :APP_ID )',
'      ) f,',
'      wwv_flow_languages l',
'where f.flow_language = l.lang_id',
'order by nlssort( l.translated_lang_name, ''NLS_SORT=binary'' )'))
,p_field_template=>wwv_flow_api.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
,p_item_comment=>'P1_TRANSLATED_LANGS'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2939579793710578577)
,p_name=>'P130_PRIMARY_LANGUAGE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2796573006579751014)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&BROWSER_LANGUAGE.'
,p_prompt=>'Primary Language'
,p_source=>'P1_PRIMARY_LANGUAGE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TRANSLATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.translated_lang_name as lang_name, f.flow_language',
'from ( select flow_language',
'          from wwv_flows f',
'         where id = :APP_ID',
'         union',
'        select flow_language',
'          from wwv_flows f',
'         where id in ( select translation_flow_id',
'                         from wwv_flow_language_map',
'                        where primary_language_flow_id = :APP_ID )',
'      ) f,',
'      wwv_flow_languages l',
'where f.flow_language = l.lang_id',
'order by nlssort( l.translated_lang_name, ''NLS_SORT=binary'' )'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_inline_help_text=>'This language is used for development, and controls the text for a variety of components in your application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2796573588692751019)
,p_name=>'Toggle Language in Translations'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P130_PRIMARY_LANGUAGE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2796573610505751020)
,p_event_id=>wwv_flow_api.id(2796573588692751019)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var $ = apex.jQuery,',
'    priLang = $(this.triggeringElement).val().toUpperCase(),',
'	transLang$ = $(''#P130_TRANSLATED_LANGS'');',
'',
'// Uncheck and make primary language in the translations item',
'transLang$',
'    .find(''input[type=checkbox]'')',
'    .each(function(){',
'        var that$ = $(this);',
'        if ( that$.hasClass(''is-disabled'') ){',
'            that$',
'                .prop(''checked'',false)',
'                .removeClass(''is-disabled'');',
'        }',
'});',
'',
'transLang$',
'    .find(''input[value='' + priLang + '']'')',
'	.prop(''checked'', true)',
'	.addClass(''is-disabled'');'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2796573852364751022)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2796573782624751021)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2796573988240751023)
,p_event_id=>wwv_flow_api.id(2796573852364751022)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2796574456153751028)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Language Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1_TRANSLATED_LANGS := :P130_TRANSLATED_LANGS;',
':P1_PRIMARY_LANGUAGE := :P130_PRIMARY_LANGUAGE;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2796574031129751024)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'P130_TRANSLATED_LANGS,P130_PRIMARY_LANGUAGE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00140
begin
wwv_flow_api.create_page(
 p_id=>140
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Supporting Objects'
,p_page_mode=>'MODAL'
,p_step_title=>'Supporting Objects'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'fieldset.checkbox_group {',
'    width: 100%;',
'}',
'fieldset.checkbox_group table {',
'    width: 100%;',
'}',
'p.note {',
'margin: 0 8px;',
'color: #707070;',
'font-size: 11px;}'))
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3124271964326242195)
,p_dialog_height=>'580'
,p_last_upd_yyyymmddhh24miss=>'20200907060028'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5781861774452699579)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5781862438949699585)
,p_plug_name=>'Supporting Objects'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2985289632294948581)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(5781861774452699579)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2985290062912948582)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(5781861774452699579)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3035688502253083804)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(5781861774452699579)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP:P900_HELP_SECTION:SUPP_OBJS'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2796574958721751033)
,p_name=>'P140_DEINSTALL_SCRIPT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(5781862438949699585)
,p_prompt=>'Deinstallation Script'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2940046372472003232)
,p_name=>'P140_RUN_SCRIPT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(5781862438949699585)
,p_prompt=>'Run when creating application'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RUN WHEN CREATING APP'
,p_lov=>'.'||wwv_flow_api.id(3011477941821019938)||'.'
,p_lov_display_null=>'YES'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--floatLeft:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2985291424860948594)
,p_name=>'P140_INSTALL_SCRIPT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(5781862438949699585)
,p_prompt=>'Installation Script'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cHeight=>7
,p_field_template=>wwv_flow_api.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2985292689933948614)
,p_name=>'Toggle Language in Translations'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P140_PRIMARY_LANGUAGE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2985293156154948616)
,p_event_id=>wwv_flow_api.id(2985292689933948614)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* Cache Elements */',
'var priLang = $(this.triggeringElement).val().toUpperCase();',
'var translatedItem$ = $(''#P140_TRANSLATED_LANGS'').find(''input[type=checkbox]'');',
'var translatedLangItem$ = $(''#P140_TRANSLATED_LANGS'').find(''input[value=''+priLang+'']'');',
'',
'/* Uncheck and make primary language in the translations item */',
'translatedItem$.each(function(){',
'  if ($(this).prop("disabled") === true){',
'    $(this).prop("checked",false);',
'    $(this).prop("disabled",false);',
'  }',
'});',
'translatedLangItem$.prop(''checked'',true).prop(''disabled'',true);'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2985293424223948616)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2985289632294948581)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2985293903138948617)
,p_event_id=>wwv_flow_api.id(2985293424223948616)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2940046107772003230)
,p_process_sequence=>40
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Values from Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_install   clob;',
'   l_deinstall clob;',
'begin',
'    :P140_INSTALL_SCRIPT := null;',
'    :P140_DEINSTALL_SCRIPT := null;',
'    if APEX_COLLECTION.COLLECTION_EXISTS(p_collection_name => ''APEX$CREATEAPPSUPPOBJ'') then',
'       for c1 in (select CLOB001 from apex_collections where collection_name = ''APEX$CREATEAPPSUPPOBJ'' and c001 = ''Install Script'') loop',
'            l_install := c1.CLOB001;',
'            :P140_INSTALL_SCRIPT := l_install;',
'       end loop;',
'       for c1 in (select CLOB001 from apex_collections where collection_name = ''APEX$CREATEAPPSUPPOBJ'' and c001 = ''Deinstall Script'') loop',
'            l_deinstall := c1.CLOB001;',
'            :P140_DEINSTALL_SCRIPT := l_deinstall;',
'       end loop;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2940045987556003228)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_install   clob;',
'   l_deinstall clob;',
'begin',
'    APEX_COLLECTION.CREATE_OR_TRUNCATE_COLLECTION(p_collection_name => ''APEX$CREATEAPPSUPPOBJ'');',
'    l_install := :P140_INSTALL_SCRIPT;',
'    l_deinstall := :P140_DEINSTALL_SCRIPT;',
'    APEX_COLLECTION.ADD_MEMBER (p_collection_name => ''APEX$CREATEAPPSUPPOBJ'', p_c001=>''Install Script'', p_clob001 => l_install);',
'    APEX_COLLECTION.ADD_MEMBER (p_collection_name => ''APEX$CREATEAPPSUPPOBJ'', p_c001=>''Deinstall Script'', p_clob001 => l_deinstall);',
'end;',
'        '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2985291821695948611)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'P140_INSTALL_SCRIPT'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00150
begin
wwv_flow_api.create_page(
 p_id=>150
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Application Blueprint'
,p_page_mode=>'MODAL'
,p_step_title=>'Application Blueprint'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function pageSubmit(req) {',
'  apex.builder.plugin.codeEditor.saveSubmit("#codeEditor_widget", "f01", {request: req, showWait: true});',
'}'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'fieldset.checkbox_group {',
'    width: 100%;',
'}',
'fieldset.checkbox_group table {',
'    width: 100%;',
'}',
'p.note {',
'margin: 0 8px;',
'color: #707070;',
'font-size: 11px;}'))
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3027985170417035432)
,p_dialog_height=>'660'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210526080144'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2934952369704675448)
,p_plug_name=>'Edit Blueprint'
,p_region_name=>'codeEditor'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select clob001',
'from wwv_flow_collections',
'where collection_name = ''TEMP_JSON'''))
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'json'
,p_attribute_02=>'30'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8791485212424403619)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3009625244862704074)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(8791485212424403619)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3009625633237704076)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(8791485212424403619)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Blueprint'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3092828517095849801)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(8791485212424403619)
,p_button_name=>'LOAD_BLUEPRINT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Load a Previous Blueprint'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:160:&SESSION.::&DEBUG.:RP,160::'
,p_button_css_classes=>'a-Button--noUI'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2796575665900751040)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(8791485212424403619)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP:P900_HELP_SECTION:BLUEPRINT'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2940046237103003231)
,p_branch_name=>'Reload Home Page'
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(3009625633237704076)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3096983880958966805)
,p_name=>'P150_BLUEPRINT_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2934952369704675448)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3009628557773704106)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3009625244862704074)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3009629083477704108)
,p_event_id=>wwv_flow_api.id(3009628557773704106)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3096983605390966803)
,p_name=>'Submit Page on Dialog Close'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3092828517095849801)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3172047783258109033)
,p_event_id=>wwv_flow_api.id(3096983605390966803)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P150_BLUEPRINT_ID'
,p_attribute_01=>'DIALOG_RETURN_ITEM'
,p_attribute_09=>'N'
,p_attribute_10=>'P160_BLUEPRINT_ID'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3172047817701109034)
,p_event_id=>wwv_flow_api.id(3096983605390966803)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'null;'
,p_attribute_02=>'P150_BLUEPRINT_ID'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3172047405728109030)
,p_event_id=>wwv_flow_api.id(3096983605390966803)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3172047168618109027)
,p_name=>'Save Blueprint'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3009625633237704076)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3172047232011109028)
,p_event_id=>wwv_flow_api.id(3172047168618109027)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'pageSubmit("SAVE");'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2940046596425003234)
,p_process_sequence=>40
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Blueprint JSON into collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_json_collection constant varchar2(255) := ''TEMP_JSON'';',
'    l_json            clob;',
'begin',
'    if :P150_BLUEPRINT_ID is null then',
'        l_json := wwv_flow_blueprint_v3.gen_json (',
'                    p_built_with_love       =>  :P5_BUILT_WITH_LOVE,',
'                    p_learn_app_def         =>  :P5_LEARN_UI_DEF_YN,',
'                    P_APP_NAME              =>  :P1_APP_NAME,',
'                    P_APP_SHORT_DESC        =>  :P5_APP_SHORT_DESC,',
'                    P_APP_DESC              =>  :P5_APP_DESC,',
'                    P_FEATURES              =>  :P1_FEATURES,',
'                    P_THEME_STYLE           =>  nvl(:P170_THEME_STYLE, :P1_THEME_STYLE),',
'                    P_NAV_POSITION          =>  nvl(:P170_NAV_POSITION, :P1_NAV_POSITION),',
'                    P_APP_ICON_CLASS        =>  :P1_APP_ICON_CLASS,',
'                    P_APP_COLOR_CLASS       =>  :P1_APP_COLOR_CLASS,',
'                    P_APP_COLOR_HEX         =>  :P1_APP_COLOR_HEX,',
'                    P_BASE_TABLE_PREFIX     =>  :P5_BASE_TABLE_PREFIX,',
'                    P_PRIMARY_LANGUAGE      =>  :P1_PRIMARY_LANGUAGE,',
'                    P_TRANSLATED_LANGS      =>  :P1_TRANSLATED_LANGS,',
'                    P_AUTHENTICATION        =>  :P1_AUTHENTICATION,',
'                    P_APP_VERSION           =>  :P5_APP_VERSION,',
'                    P_APP_LOGGING           =>  :P5_APP_LOGGING,',
'                    P_APP_DEBUGGING         =>  :P5_APP_DEBUGGING,',
'                    P_DOCUMENT_DIRECTION    =>  :P5_DOCUMENT_DIRECTION,',
'                    P_DATE_FORMAT           =>  :P5_DATE_FORMAT,',
'                    P_DATE_TIME_FORMAT      =>  :P5_DATE_TIME_FORMAT,',
'                    P_TIMESTAMP_FORMAT      =>  :P5_TIMESTAMP_FORMAT,',
'                    P_TIMESTAMP_TZ_FORMAT   =>  :P5_TIMESTAMP_TZ_FORMAT,',
'                    P_DEEP_LINKING          =>  :P5_DEEP_LINKING,',
'                    P_MAX_SESSION_LENGTH    =>  :P5_MAX_SESSION_LENGTH,',
'                    P_MAX_SESSION_IDLE_TIME =>  :P5_MAX_SESSION_IDLE_TIME,',
'                    p_schema                =>  :P1_SCHEMA',
'                    );',
'    else',
'        l_json := wwv_flow_blueprint_v3.load_named_blueprint(',
'	                p_blueprint_id => :P150_BLUEPRINT_ID,',
'	                p_app_user     => :APP_USER,',
'                    p_security_group_id => :FLOW_SECURITY_GROUP_ID);',
'    end if;',
'',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => c_json_collection );',
'',
'    wwv_flow_collection.add_member(',
'        p_collection_name => c_json_collection,',
'        p_clob001         => l_json );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3009626050886704100)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Parse JSON and Set Values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_json clob;',
'begin    ',
'    sys.dbms_lob.createtemporary( l_json, false, sys.dbms_lob.SESSION );',
'   ',
'    for i in 1..wwv_flow.g_f01.count loop ',
'        sys.dbms_lob.writeappend( l_json, length(wwv_flow.g_f01(i)), wwv_flow.g_f01(i) );        ',
'    end loop;        ',
'    ',
'    wwv_flow_blueprint_v3.get_session_state_from_json (',
'    	P_JSON_BLUEPRINT        => l_json,',
'        p_schema                => :P1_SCHEMA,',
'        p_built_with_love       => :P5_BUILT_WITH_LOVE,',
'        p_learn_app_def         => :P5_LEARN_UI_DEF_YN,',
'        P_APP_NAME              => :P1_APP_NAME,',
'        P_APP_SHORT_DESC        => :P5_APP_SHORT_DESC,',
'        P_APP_DESC              => :P5_APP_DESC,',
'        P_FEATURES              => :P1_FEATURES,',
'        P_THEME_STYLE           => :P170_THEME_STYLE,',
'        P_NAV_POSITION          => :P170_NAV_POSITION,',
'        P_APP_ICON_CLASS        => :P1_APP_ICON_CLASS,',
'        P_APP_COLOR_CLASS       => :P1_APP_COLOR_CLASS,',
'        P_APP_COLOR_HEX         => :P1_APP_COLOR_HEX,',
'        P_BASE_TABLE_PREFIX     => :P5_BASE_TABLE_PREFIX,',
'        P_PRIMARY_LANGUAGE      => :P1_PRIMARY_LANGUAGE,',
'        P_TRANSLATED_LANGS      => :P1_TRANSLATED_LANGS,',
'        P_AUTHENTICATION        => :P1_AUTHENTICATION,',
'        P_APP_VERSION           => :P5_APP_VERSION,',
'        P_APP_LOGGING           => :P5_APP_LOGGING,',
'        P_APP_DEBUGGING         => :P5_APP_DEBUGGING,',
'        P_DOCUMENT_DIRECTION    => :P5_DOCUMENT_DIRECTION,',
'        P_DATE_FORMAT           => :P5_DATE_FORMAT,',
'        P_DATE_TIME_FORMAT      => :P5_DATE_TIME_FORMAT,',
'        P_TIMESTAMP_FORMAT      => :P5_TIMESTAMP_FORMAT,',
'        P_TIMESTAMP_TZ_FORMAT   => :P5_TIMESTAMP_TZ_FORMAT,',
'        P_DEEP_LINKING          => :P5_DEEP_LINKING,',
'        P_MAX_SESSION_LENGTH    => :P5_MAX_SESSION_LENGTH,',
'        P_MAX_SESSION_IDLE_TIME => :P5_MAX_SESSION_IDLE_TIME',
'        );',
'       ',
'    :P1_THEME_STYLE := :P170_THEME_STYLE;',
'    :P1_NAV_POSITION := :P170_NAV_POSITION;',
'    ',
'    wwv_flow_app_def_v3.sync_app_defaults (',
'        p_schema              => :P1_SCHEMA,',
'        p_learn_app_def       => ( nvl(:P5_LEARN_UI_DEF_YN, ''N'') = ''Y'' ),',
'        p_learn_existing_apps => ( nvl(:P5_LEARN_YN,''N'') = ''Y'' ),',
'        p_base_table_prefix   => :P5_BASE_TABLE_PREFIX );',
'        ',
'    :P130_PRIMARY_LANGUAGE := :P1_PRIMARY_LANGUAGE;',
'    :P130_TRANSLATED_LANGS := :P1_TRANSLATED_LANGS;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Unable to save blueprint values into APEX session.',
'#SQLERRM#'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3009625633237704076)
);
end;
/
prompt --application/pages/page_00160
begin
wwv_flow_api.create_page(
 p_id=>160
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Load Blueprint'
,p_page_mode=>'MODAL'
,p_step_title=>'Load Blueprint'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.icon-preview {',
'  width: 24px;',
'  height: 24px;',
'  display: block;',
'  border-radius: 2px;',
'  background-color: currentColor;',
'}',
'',
'.a-Report-cell {',
'  line-height: 24px;',
'}',
'',
'.delete-button {',
'  color: var(--a-palette-danger);',
'}',
'',
'.nodatafound {',
'  text-align: center;',
'  padding: 64px 16px;',
'  font-size: 16px;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'400'
,p_dialog_width=>'640'
,p_dialog_chained=>'N'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210708041833'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(3092828716344849803)
,p_name=>'Blueprints'
,p_region_name=>'blueprints_report'
,p_template=>wwv_flow_api.id(3300810815961795652)
,p_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  id,',
'  icon_class icon,',
'  icon_color_class,',
'  name,',
'  page_count,',
'  feature_count,',
'  created_on created,',
'  null select_action,',
'  null load_action,',
'  null delete_action,',
'  name clean_name',
'from WWV_FLOW_BLUEPRINT_REPO',
'where created_by = :APP_USER and security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by created_on desc'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(2707641403506668051)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No Blueprints Found'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2940047222737003241)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>7
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3092828828392849804)
,p_query_column_id=>2
,p_column_alias=>'ICON'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3092828993907849805)
,p_query_column_id=>3
,p_column_alias=>'ICON_COLOR_CLASS'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3092829049410849806)
,p_query_column_id=>4
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-MediaBlock">',
'  <div class="a-MediaBlock-graphic icon-preview #ICON# #ICON_COLOR_CLASS#"></div>',
'  <div class="a-MediaBlock-content">#NAME#</div>',
'</div>'))
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2940047394433003242)
,p_query_column_id=>5
,p_column_alias=>'PAGE_COUNT'
,p_column_display_sequence=>4
,p_column_heading=>'Page count'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3040394562753894745)
,p_query_column_id=>6
,p_column_alias=>'FEATURE_COUNT'
,p_column_display_sequence=>5
,p_column_heading=>'Features'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3092829341232849809)
,p_query_column_id=>7
,p_column_alias=>'CREATED'
,p_column_display_sequence=>6
,p_column_heading=>'Created'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3040394614917894746)
,p_query_column_id=>8
,p_column_alias=>'SELECT_ACTION'
,p_column_display_sequence=>8
,p_column_heading=>'<span class="u-VisuallyHidden">Select Blueprint</span>'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<button type="button" class="a-Button a-Button--small select-button" data-id="#ID#">Select</button>'
,p_column_alignment=>'CENTER'
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_condition=>'P160_RETURN_TYPE'
,p_display_when_condition2=>'LOAD'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>24
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3210720416272760404)
,p_query_column_id=>9
,p_column_alias=>'LOAD_ACTION'
,p_column_display_sequence=>9
,p_column_heading=>'<span class="u-VisuallyHidden">Load Blueprint</span>'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<button type="button" class="a-Button a-Button--small load-button" data-id="#ID#">Load</button>'
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P160_RETURN_TYPE'
,p_display_when_condition2=>'LOAD'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3040394722705894747)
,p_query_column_id=>10
,p_column_alias=>'DELETE_ACTION'
,p_column_display_sequence=>10
,p_column_heading=>'<span class="u-VisuallyHidden">Delete Blueprint</span>'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<button type="button" title="Delete Blueprint #CLEAN_NAME#" class="a-Button a-Button--small a-Button--noUI delete-button" data-id="#ID#"><span class="a-Icon icon-remove" aria-hidden="true"></span></button>'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>24
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3217864403847443003)
,p_query_column_id=>11
,p_column_alias=>'CLEAN_NAME'
,p_column_display_sequence=>11
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3210721976980760419)
,p_branch_name=>'Go to Create Wizard Home Page'
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'LOAD_BLUEPRINT'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3040395074343894750)
,p_name=>'P160_BLUEPRINT_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3092828716344849803)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3217864528853443004)
,p_name=>'P160_RETURN_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3092828716344849803)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3040394824972894748)
,p_name=>'Send Blueprint Back to Page'
,p_event_sequence=>10
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.select-button'
,p_bind_type=>'live'
,p_bind_event_type=>'click'
,p_display_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_display_when_cond=>'LOAD'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3040394906737894749)
,p_event_id=>wwv_flow_api.id(3040394824972894748)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P160_BLUEPRINT_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$(this.triggeringElement).data("id");'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3172047584383109031)
,p_event_id=>wwv_flow_api.id(3040394824972894748)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
,p_attribute_01=>'P160_BLUEPRINT_ID'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3210720549847760405)
,p_name=>'Load Blueprint'
,p_event_sequence=>20
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.load-button'
,p_bind_type=>'live'
,p_bind_event_type=>'click'
,p_display_when_type=>'REQUEST_EQUALS_CONDITION'
,p_display_when_cond=>'LOAD'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3210720684856760406)
,p_event_id=>wwv_flow_api.id(3210720549847760405)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P160_BLUEPRINT_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$(this.triggeringElement).data("id");'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3210720871116760408)
,p_event_id=>wwv_flow_api.id(3210720549847760405)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'LOAD_BLUEPRINT'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3096984274263966809)
,p_name=>'Delete Blueprint (Refresh Report)'
,p_event_sequence=>30
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.delete-button'
,p_bind_type=>'live'
,p_bind_event_type=>'click'
,p_display_when_type=>'NEVER'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3096984318923966810)
,p_event_id=>wwv_flow_api.id(3096984274263966809)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P160_BLUEPRINT_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$(this.triggeringElement).data("id");'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3217864239961443001)
,p_event_id=>wwv_flow_api.id(3096984274263966809)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_blueprint_v3.remove_blueprint (',
'	p_blueprint_id => :P160_BLUEPRINT_ID, ',
'	p_app_user => :APP_USER,',
'    p_security_group_id => :FLOW_SECURITY_GROUP_ID);'))
,p_attribute_02=>'P160_BLUEPRINT_ID'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3217864378761443002)
,p_event_id=>wwv_flow_api.id(3096984274263966809)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3092828716344849803)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3217864682642443005)
,p_name=>'Delete Blueprint (AJAX)'
,p_event_sequence=>40
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.delete-button'
,p_bind_type=>'live'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3217864778596443006)
,p_event_id=>wwv_flow_api.id(3217864682642443005)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// cache common elements',
'var blueprint$    = $(this.triggeringElement),',
'    blueprintId   = blueprint$.data("id"),',
'    blueprintRow$ = blueprint$.parents("tr");',
'',
'// hide blueprint from UI',
'blueprint$.parents("tr").addClass("is-disabled");',
'',
'// run ajax process to remove blueprint',
'apex.server.process( "removeBlueprint", {',
'    x01: blueprintId',
'}, {',
'    success: function( commentID ) {',
'        blueprintRow$.remove();',
'    }',
'});'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3210720931436760409)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Blueprint'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_blueprint clob;',
'begin',
'',
'l_blueprint := wwv_flow_blueprint_v3.load_named_blueprint(',
'	p_blueprint_id => :P160_BLUEPRINT_ID,',
'	p_app_user=> :APP_USER,',
'    p_security_group_id => :FLOW_SECURITY_GROUP_ID);',
'	',
'wwv_flow_blueprint_v3.get_session_state_from_json (',
'    P_JSON_BLUEPRINT        => l_blueprint,',
'    p_schema                => :P1_SCHEMA,',
'    p_built_with_love       => :P5_BUILT_WITH_LOVE,',
'    p_learn_app_def         => :P5_LEARN_UI_DEF_YN,',
'    P_APP_NAME              => :P1_APP_NAME,',
'    P_APP_SHORT_DESC        => :P5_APP_SHORT_DESC,',
'    P_APP_DESC              => :P5_APP_DESC,',
'    P_FEATURES              => :P1_FEATURES,',
'    P_THEME_STYLE           => :P170_THEME_STYLE,',
'    P_NAV_POSITION          => :P170_NAV_POSITION,',
'    P_APP_ICON_CLASS        => :P1_APP_ICON_CLASS,',
'    P_APP_COLOR_CLASS       => :P1_APP_COLOR_CLASS,',
'    P_APP_COLOR_HEX         => :P1_APP_COLOR_HEX,',
'    P_BASE_TABLE_PREFIX     => :P5_BASE_TABLE_PREFIX,',
'    P_PRIMARY_LANGUAGE      => :P1_PRIMARY_LANGUAGE,',
'    P_TRANSLATED_LANGS      => :P1_TRANSLATED_LANGS,',
'    P_AUTHENTICATION        => :P1_AUTHENTICATION,',
'    P_APP_VERSION           => :P5_APP_VERSION,',
'    P_APP_LOGGING           => :P5_APP_LOGGING,',
'    P_APP_DEBUGGING         => :P5_APP_DEBUGGING,',
'    P_DOCUMENT_DIRECTION    => :P5_DOCUMENT_DIRECTION,',
'    P_DATE_FORMAT           => :P5_DATE_FORMAT,',
'    P_DATE_TIME_FORMAT      => :P5_DATE_TIME_FORMAT,',
'    P_TIMESTAMP_FORMAT      => :P5_TIMESTAMP_FORMAT,',
'    P_TIMESTAMP_TZ_FORMAT   => :P5_TIMESTAMP_TZ_FORMAT,',
'    P_DEEP_LINKING          => :P5_DEEP_LINKING,',
'    P_MAX_SESSION_LENGTH    => :P5_MAX_SESSION_LENGTH,',
'    P_MAX_SESSION_IDLE_TIME => :P5_MAX_SESSION_IDLE_TIME',
'    );',
'    ',
'    :P1_THEME_STYLE := :P170_THEME_STYLE;',
'    :P1_NAV_POSITION := :P170_NAV_POSITION;',
'',
'exception when others then null;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error Loading Blueprint'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'LOAD_BLUEPRINT'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3117408439825935021)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Blueprint'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_blueprint_v3.remove_blueprint (',
'	p_blueprint_id => :P160_BLUEPRINT_ID, ',
'	p_app_user => :APP_USER,',
'    p_security_group_id => :FLOW_SECURITY_GROUP_ID);'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_type=>'NEVER'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3217865010876443009)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'removeBlueprint'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'',
'  	wwv_flow_blueprint_v3.remove_blueprint (',
'    	p_blueprint_id => apex_application.g_x01, ',
'    	p_app_user => :APP_USER,',
'    	p_security_group_id => :FLOW_SECURITY_GROUP_ID);',
'		',
'	apex_plugin_util.print_json_http_header;',
'	apex_json.open_object;',
'	apex_json.write(''status'',''deleted'');',
'    apex_json.close_object;',
'	',
'exception when others then ',
'',
'	apex_plugin_util.print_json_http_header;',
'	apex_json.open_object;',
'	apex_json.write(''error'',''unable to delete blueprint ''||sqlerrm );',
'    apex_json.close_object;',
'	rollback;',
'	',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00170
begin
wwv_flow_api.create_page(
 p_id=>170
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Appearance'
,p_page_mode=>'MODAL'
,p_step_title=>'Appearance'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code_onload=>'apex.jQuery("#choose_icon").appendTo(".a-PageWizard-appIconContainer .a-Form-inputContainer");'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.field.item-app-name { margin-bottom: 0; }',
'.field--style--boxed .display_only { line-height: 24px; white-space: nowrap; overflow: hidden; text-overflow: ellipsis; }',
'.apex-col .field.field-item-button-grouping { margin-right: -1px; }',
'.lang-button { padding-top: 19px; padding-bottom: 19px; width: calc(100% - 16px); margin-right: 16px; }',
'.advanced-button { padding-top: 19px; padding-bottom: 19px; width: calc(100% - 16px); margin-right: 16px; }',
'.attribute-button { padding-top: 19px; padding-bottom: 19px; width: calc(100% - 16px); margin-right: 16px; }',
'.a-BoxedForms .field-item-button-grouping .field-input__wrap { border-radius: 2px 0 0 2px; }',
'html.no-js .a-BoxedForms .field--style--boxed.label-only .field-label { padding-top: 1.8rem; padding-bottom: 1.8rem; }',
'.page-source-table { font-family: monospace; font-size: 11px; line-height: 21px; margin: 0 4px; }'))
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'550'
,p_dialog_width=>'880'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210514150911'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(52409446028114501)
,p_plug_name=>'Appearance - Custom Theme'
,p_plug_display_sequence=>30
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P170_CUSTOM_THEME_YN'
,p_plug_display_when_cond2=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(52409790570114504)
,p_plug_name=>'Hidden Items'
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3718779288454226401)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6307699474464365654)
,p_plug_name=>'Appearance - UT'
,p_region_name=>'appearance'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P170_CUSTOM_THEME_YN'
,p_plug_display_when_cond2=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3718774912062215130)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(6307699474464365654)
,p_button_name=>'CHOOSE_ICON'
,p_button_static_id=>'choose_icon'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Choose New Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:120:&SESSION.::&DEBUG.:RP,120:P120_ICON_CLASS,P120_ICON_COLOR,P120_ICON_COLOR_CLASS:&P170_APP_ICON_CLASS.,&P170_APP_COLOR_HEX.,&P170_APP_COLOR_CLASS.'
,p_button_css_classes=>'a-Button--chooseIcon'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3396254080746246635)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(3718779288454226401)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--gapRight'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(645332378727941501)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(3718779288454226401)
,p_button_name=>'CUSTOM_THEME'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Use Custom Theme'
,p_button_position=>'NEXT'
,p_button_condition=>'P170_CUSTOM_THEME_YN'
,p_button_condition2=>'N'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(52410326133114510)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(3718779288454226401)
,p_button_name=>'UNIVERSAL_THEME'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Use Universal Theme'
,p_button_position=>'NEXT'
,p_button_condition=>'P170_CUSTOM_THEME_YN'
,p_button_condition2=>'Y'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3396253804956246633)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(3718779288454226401)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3718775307196215133)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(3718779288454226401)
,p_button_name=>'HELP_UI'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'View Help for Appearance'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:UI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(52410470000114511)
,p_branch_name=>'Reload Page'
,p_branch_action=>'f?p=&APP_ID.:170:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'CUSTOM_THEME,UNIVERSAL_THEME'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(52409521057114502)
,p_name=>'P170_CUSTOM_THEME_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(52409446028114501)
,p_prompt=>'Workspace Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'       t.theme_name,',
'       t.id',
'  from wwv_flow_themes t',
' where theme_security_group_id = :WORKSPACE_ID',
'   and security_group_id = 11'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Custom Theme -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(3071359248210082306)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a workspace theme to use when generating the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(52409663240114503)
,p_name=>'P170_CUSTOM_THEME_STYLE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(52409446028114501)
,p_prompt=>'Theme Style'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'   s.name || ',
'       case is_accessible',
'           when ''Y'' then '' ('' || wwv_flow_lang.system_message(''ACCESSIBILITY_TESTED'') || '')''',
'           else ''''',
'        end name,   ',
'   s.id ',
'from wwv_flow_themes t, wwv_flow_theme_styles s',
'where t.id = :P170_CUSTOM_THEME_ID',
'and t.theme_id = s.theme_id',
'and t.flow_id = s.flow_id',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Theme Style -'
,p_lov_cascade_parent_items=>'P170_CUSTOM_THEME_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'If supported by the custom theme, select the style to be used when generating the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(52409875575114505)
,p_name=>'P170_CUSTOM_THEME_YN'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(52409790570114504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3396254608905246641)
,p_name=>'P170_NAV_POSITION_DISP'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(6307699474464365654)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3718775740605215139)
,p_name=>'P170_THEME_STYLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(6307699474464365654)
,p_prompt=>'Theme Style'
,p_source=>'P1_THEME_STYLE'
,p_source_type=>'ITEM'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'P1_THEME_STYLES'
,p_lov=>'.'||wwv_flow_api.id(2595731361215290332)||'.'
,p_field_template=>wwv_flow_api.id(3076592553081438826)
,p_item_css_classes=>'a-IconList--PageWizard a-IconList--LargeIcons'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3718776124351215148)
,p_name=>'P170_NAV_POSITION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(6307699474464365654)
,p_prompt=>'Navigation'
,p_source=>'P1_NAV_POSITION'
,p_source_type=>'ITEM'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'P1_NAVIGATION_POSITION'
,p_lov=>'.'||wwv_flow_api.id(2621239147915611502)||'.'
,p_colspan=>6
,p_field_template=>wwv_flow_api.id(3076592553081438826)
,p_item_css_classes=>'a-IconList--PageWizard a-IconList--SmallIcons'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3718776562268215148)
,p_name=>'P170_APP_COLOR_CLASS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(6307699474464365654)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'B'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3718776912614215148)
,p_name=>'P170_APP_ICON_CLASS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(6307699474464365654)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3718777733090215149)
,p_name=>'P170_APP_ICON'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(6307699474464365654)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application Icon'
,p_source=>'<div class="a-PageWizard-appIcon &P170_APP_ICON_CLASS. &P170_APP_COLOR_CLASS." id="app_icon"></div>'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(3076592553081438826)
,p_item_css_classes=>'a-PageWizard-appIconContainer'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3733042812981281369)
,p_name=>'P170_APP_COLOR_HEX'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(6307699474464365654)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(52410594310114512)
,p_computation_sequence=>10
,p_computation_item=>'P170_CUSTOM_THEME_YN'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( :P1_THEME_TYPE in (''CUSTOM'',''CUSTOM_UT'') ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_compute_when=>'P170_CUSTOM_THEME_YN'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(101210759019869203)
,p_validation_name=>'Custom Theme not null'
,p_validation_sequence=>10
,p_validation=>'P170_CUSTOM_THEME_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P170_CUSTOM_THEME_YN'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(3396253804956246633)
,p_associated_item=>wwv_flow_api.id(52409521057114502)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3396254181242246636)
,p_name=>'Cancel'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3396254080746246635)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1156925167756672917)
,p_event_id=>wwv_flow_api.id(3396254181242246636)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>':P170_CUSTOM_THEME_YN := null;'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3396254200111246637)
,p_event_id=>wwv_flow_api.id(3396254181242246636)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3396254707676246642)
,p_name=>'Get Displayed Value'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P170_NAV_POSITION'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3396254800162246643)
,p_event_id=>wwv_flow_api.id(3396254707676246642)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>':P170_NAV_POSITION_DISP := initCap( lower(:P170_NAV_POSITION) );'
,p_attribute_02=>'P170_NAV_POSITION'
,p_attribute_03=>'P170_NAV_POSITION_DISP'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(52410061763114507)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Use Custom Theme'
,p_process_sql_clob=>':P170_CUSTOM_THEME_YN := ''Y'';'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(645332378727941501)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(52410267134114509)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Use Universal Theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P170_CUSTOM_THEME_YN := ''N'';',
'-- Avoid empty values',
':P170_NAV_POSITION    := ''SIDE'';',
':P170_APP_ICON_CLASS  := ''app-icon-rocket'';',
'-- The default value logic from P1_APP_COLOR_CLASS',
'select ''app-color-'' || round( dbms_random.value( 1,8 ) ) as color_class',
'  into :P170_APP_COLOR_CLASS',
'  from sys.dual;',
'-- The default value logic from P1_APP_COLOR_HEX',
'select return_value',
'  into :P170_APP_COLOR_HEX',
'  from apex_application_lov_entries ',
' where application_id = :APP_ID and',
'      list_of_values_name = ''P120_APP_COLORS'' and',
'      display_sequence = replace(:P170_APP_COLOR_CLASS, ''app-color-'');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(52410326133114510)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3396254345369246638)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Page 1 Item Values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P170_CUSTOM_THEME_YN = ''N'' then',
'',
'    :P1_THEME_TYPE      := ''UT'';',
'    :P1_THEME_STYLE     := :P170_THEME_STYLE;',
'    ',
'    :P1_NAV_POSITION    := :P170_NAV_POSITION;',
'    :P1_APP_COLOR_CLASS := :P170_APP_COLOR_CLASS;',
'    :P1_APP_ICON_CLASS  := :P170_APP_ICON_CLASS;',
'    :P1_APP_COLOR_HEX   := :P170_APP_COLOR_HEX;',
'',
'elsif :P170_CUSTOM_THEME_YN = ''Y'' then',
'',
'    if wwv_flow_theme_dev.is_universal_theme ( p_theme_id => :P170_CUSTOM_THEME_ID ) then',
'        :P1_THEME_TYPE  := ''CUSTOM_UT'';',
'    else',
'        :P1_THEME_TYPE  := ''CUSTOM'';',
'    end if;',
'    ',
'    :P1_THEME_ID    := :P170_CUSTOM_THEME_ID;',
'    :P1_THEME_STYLE := :P170_CUSTOM_THEME_STYLE_ID;',
'',
'    -- clean up',
'    :P170_NAV_POSITION      := '''';',
'    :P170_APP_COLOR_CLASS   := '''';',
'    :P170_APP_ICON_CLASS    := '''';',
'    :P170_APP_COLOR_HEX     := '''';',
'',
'    :P1_NAV_POSITION        := '''';',
'    :P1_APP_COLOR_CLASS     := '''';',
'    :P1_APP_ICON_CLASS      := '''';',
'    :P1_APP_COLOR_HEX       := '''';',
'    ',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3396253804956246633)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3396253968011246634)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog for UT'
,p_attribute_01=>'P170_THEME_STYLE,P170_NAV_POSITION,P170_CUSTOM_THEME_YN,P1_THEME_TYPE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3396253804956246633)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1156925230446672918)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Icon Attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P170_APP_ICON_CLASS is null then',
'    :P170_APP_ICON_CLASS := :P1_APP_ICON_CLASS;',
'end if;',
'',
'if :P170_APP_COLOR_CLASS is null then',
'    :P170_APP_COLOR_CLASS := :P1_APP_COLOR_CLASS;',
'end if;',
'',
'if :P170_APP_COLOR_HEX is null then',
'    :P170_APP_COLOR_HEX := :P1_APP_COLOR_HEX;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00250
begin
wwv_flow_api.create_page(
 p_id=>250
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Attribute Defaults'
,p_page_mode=>'MODAL'
,p_step_title=>'Attribute Defaults'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function pageSubmit(req) {',
'  apex.builder.plugin.codeEditor.saveSubmit("#codeEditor_widget", "f01", {request: req, showWait: true});',
'}'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'fieldset.checkbox_group {',
'    width: 100%;',
'}',
'fieldset.checkbox_group table {',
'    width: 100%;',
'}',
'p.note {',
'margin: 0 8px;',
'color: #707070;',
'font-size: 11px;}'))
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3027830547707021532)
,p_dialog_height=>'650'
,p_last_upd_yyyymmddhh24miss=>'20200828054248'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11817121936578509579)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11817122601075509585)
,p_plug_name=>'Edit Attribute Defaults'
,p_region_name=>'codeEditor'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select clob001',
'from wwv_flow_collections',
'where collection_name = ''TEMP_JSON'''))
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'SQL'
,p_attribute_02=>'30'
,p_attribute_03=>'N'
,p_attribute_04=>'VARCHAR2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3025638933882105990)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(11817121936578509579)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP:P900_HELP_SECTION:DEFAULTS'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3025638183876105989)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(11817121936578509579)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3025638589266105990)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(11817121936578509579)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Attribute Defaults'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3025642886946106023)
,p_branch_name=>'Reload attribute values page'
,p_branch_action=>'f?p=&APP_ID.:250:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'NEVER'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3025640911556106018)
,p_name=>'Toggle Language in Translations'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P250_PRIMARY_LANGUAGE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3025641493679106020)
,p_event_id=>wwv_flow_api.id(3025640911556106018)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* Cache Elements */',
'var priLang = $(this.triggeringElement).val().toUpperCase();',
'var translatedItem$ = $(''#P250_TRANSLATED_LANGS'').find(''input[type=checkbox]'');',
'var translatedLangItem$ = $(''#P250_TRANSLATED_LANGS'').find(''input[value=''+priLang+'']'');',
'',
'/* Uncheck and make primary language in the translations item */',
'translatedItem$.each(function(){',
'  if ($(this).prop("disabled") === true){',
'    $(this).prop("checked",false);',
'    $(this).prop("disabled",false);',
'  }',
'});',
'translatedLangItem$.prop(''checked'',true).prop(''disabled'',true);'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3025641847966106021)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3025638183876105989)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3025642367939106021)
,p_event_id=>wwv_flow_api.id(3025641847966106021)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3172047965255109035)
,p_name=>'Save App Defaults'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3025638589266105990)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3172048020273109036)
,p_event_id=>wwv_flow_api.id(3172047965255109035)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'pageSubmit("SAVE");'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3025639737610106015)
,p_process_sequence=>40
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load app def JSON into collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_json_collection constant varchar2(255) := ''TEMP_JSON'';',
'    l_json            clob;',
'begin',
'    l_json := wwv_flow_app_def_v3.gen_app_defaults_from_coll;',
'',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => c_json_collection );',
'',
'    wwv_flow_collection.add_member(',
'        p_collection_name => c_json_collection,',
'        p_clob001         => l_json );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3025640182714106016)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Parse JSON and Set Values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_json clob;',
'begin',
'    sys.dbms_lob.createtemporary( l_json, false, sys.dbms_lob.SESSION );',
'    for i in 1..wwv_flow.g_f01.count loop ',
'        sys.dbms_lob.writeappend( l_json, length(wwv_flow.g_f01(i)), wwv_flow.g_f01(i) );        ',
'    end loop;',
'    ',
'    wwv_flow_app_def_v3.gen_apply_app_defaults_sql(',
'        p_app_defaults => l_json );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to save attribute defaults to collection.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3025640544461106016)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00260
begin
wwv_flow_api.create_page(
 p_id=>260
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'User Interface Defaults'
,p_step_title=>'User Interface Defaults'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-IRR-table tr:nth-child(even) td {',
'    background-color: inherit;',
'}',
'.a-IRR-table tr:hover td  .a-AVPList--blocks .a-AVPList-item, ',
'.a-IRR-table tr:nth-child(even):hover td .a-AVPList--blocks .a-AVPList-item,',
'.a-AVPList--blocks .a-AVPList-item:hover {',
'  background-color: #FFF;',
'}',
'',
'td[headers=attr_id],',
'td[headers=attr_settings] {',
'    padding: 0;',
'    vertical-align: top;',
'}',
'',
'.a-AVPList.a-AVPList--blocks {',
'    display: flex;',
'    flex-wrap: wrap;',
'    margin: 4px 0 0 4px;',
'}',
'',
'.a-AVPList--blocks .a-AVPList-item {',
'    display: block;',
'    padding: 8px;',
'    box-shadow: none;',
'    width: 160px;',
'    margin: 0 4px 4px 0;',
'    border-radius: 2px;',
'    background: #F8F8F8;',
'}',
'.a-AVPList--blocks .a-AVPList-item:last-child {',
'  margin-right: 0;',
'  border-right-width: 0;',
'}',
'',
'.a-AVPList--blocks .a-AVPList-label, ',
'.a-AVPList--blocks .a-AVPList-value {',
'    display: block;',
'    padding: 0;',
'    text-align: left;',
'}',
'',
'.a-AVPList--blocks .a-AVPList-label {',
'    font-size: 11px;',
'    color: #707070;',
'}',
'',
'.a-AVPList--blocks .a-AVPList-value {',
'    color: #404040;',
'    white-space: nowrap;',
'    text-overflow: ellipsis;',
'    overflow: hidden;',
'    font-family: monospace;',
'}',
'',
'/* Enable filtering / searching of settings, but do not allow click on header */',
'th#attr_settings > a {',
'    pointer-events: none;',
'    color: #404040;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_last_upd_yyyymmddhh24miss=>'20210812003731'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3145297382377009606)
,p_plug_name=>'Application Defaults'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with lbls as (',
'    select ',
'        wwv_flow_lang.custom_runtime_message(''CA.table'')                  table_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.itemName'')               itemName_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.identification'')         identification_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.column'')                 column_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.name'')                   name_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.description'')            description_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.scope'')                  scope_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.dataType'')               dataType_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.sessionStateProtection'') sessionStateProtection_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.comments'')               comments_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.label'')                  label_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.formControl'')            formControl_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.includeOnForms'')         includeOnForms_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.includeOnReports'')       includeOnReports_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.listOfValues'')           listOfValues_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.formatMask'')             formatMask_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.staticDefault'')          staticDefault_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.type'')                   type_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.definition'')             definition_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.rowsPerPage'')            rowsPerPage_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.paginationMethod'')       paginationMeth_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.numberFormatMask'')       numberFormatMask_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.dateFormatMask'')         dateFormatMask_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.primaryDisplayColumn'')   primaryDisplayColumn_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.secondaryDisplayColumn'') secondaryDisplayColumn_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.suggestedVisulization'')  suggestedVisulization_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.labelSingular'')          labelSingular_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.labelPlural'')            labelPlural_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.primaryKeyColumn'')       primaryKeyColumn_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.labelColumn'')            labelColumn_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.primaryUse'')             primaryUse_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.primaryParentTable'')     primaryParentTable_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.tableColumn'')            tableColumn_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.general'')                general_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.displayColumn'')          displayColumn_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.keyColumn'')              keyColumn_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.function'')               function_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.valueColumn'')            valueColumn_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.maximumRows'')            maximumRows_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.query'')                  query_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.Form'')                   form_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.Reports'')                report_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.Metric'')                 metric_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.ApplicationItem'')        applicationItem_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.HELP'')                   help_l,',
'        wwv_flow_lang.custom_runtime_message(''CA.REQUIRED'')               required_l,',
'        --',
'       ''<span class="a-AVPList-item"><span class="a-AVPList-label">'' o1,',
'       ''</span>'' c1,',
'       ''<span class="a-AVPList-value">'' o2,',
'       ''</span></span>'' c2',
'    from dual',
')',
'select',
'    attribute_type,',
'    attribute_settings,',
'    last_updated,',
'    apex_page.get_url(p_page => edit_page, p_items => ''P''||edit_page||''_ID'', p_values => seq_id, p_clear_cache => edit_page) edit_link,',
'    OB,',
'    c040 sourced_from,',
'    wwv_flow_lang.system_message(''EDIT_LINK_TEXT'', wwv_flow_escape.html(attribute_type)) link_text',
'from (',
'    select ',
'        decode(upper(c002), ',
'              ''APPLICATION_ITEM'',l.applicationItem_l,',
'              ''TABLE_COLUMN'',l.tablecolumn_l,',
'              ''TABLE'',l.table_l,',
'              ''METRIC'',l.metric_l,',
'              ''LOV'',l.listOfValues_l,',
'              ''REPORT'',l.report_l,',
'              ''FORM'',l.form_l,',
'              apex_escape.html(c002)) attribute_type,',
'        decode(upper(c002), ',
'              ''APPLICATION_ITEM'',',
'                l.o1||l.itemName_l||l.c1||l.o2||apex_escape.html(c003)||l.c2||',
'                l.o1||l.scope_l||l.c1||l.o2||apex_escape.html(c004)||l.c2||',
'                l.o1||l.dataType_l||l.c1||l.o2||apex_escape.html(c005)||l.c2||',
'                l.o1||l.sessionStateProtection_l||l.c1||l.o2||apex_escape.html(c006)||l.c2||',
'                decode(trim(c007),null,null,l.o1||l.comments_l||l.c1||l.o2||apex_escape.html(c007)||l.c2),',
'              ''FORM'',',
'                l.o1||l.type_l||l.c1||l.o2||l.general_l||l.c2,',
'              ''TABLE_COLUMN'',',
'                l.o1||l.table_l||l.c1||l.o2||apex_escape.html(c003)||l.c2||',
'                l.o1||l.column_l||l.c1||l.o2||apex_escape.html(c004)||l.c2||',
'                l.o1||l.label_l||l.c1||l.o2||apex_escape.html(c005)||l.c2||',
'                decode(trim(c006),null,null,l.o1||l.formControl_l||l.c1||l.o2||apex_escape.html( wwv_flow_app_def_v3.get_json_page_component_name(c006) )||l.c2)||',
'                l.o1||l.includeOnForms_l||l.c1||l.o2||apex_escape.html(decode(c007,''Y'',''true'',''N'',''false'',c007))||l.c2||',
'                l.o1||l.includeOnReports_l||l.c1||l.o2||apex_escape.html(decode(c008,''Y'',''true'',''N'',''false'',c008))||l.c2||',
'                decode(trim(c009),null,null,l.o1||l.listOfValues_l||l.c1||l.o2||apex_escape.html(c009)||l.c2)||',
'                decode(trim(c010),null,null,l.o1||l.formatMask_l||l.c1||l.o2||apex_escape.html(c010)||l.c2)||',
'                decode(trim(c011),null,null,l.o1||l.staticDefault_l||l.c1||l.o2||apex_escape.html(c011)||l.c2)||',
'                decode(trim(c016),null,null,l.o1||l.required_l||l.c1||l.o2||apex_escape.html(decode(c016,''Y'',''true'',''N'',''false'',c016))||l.c2)||',
'                decode(trim(c014),null,null,l.o1||l.help_l||l.c1||l.o2||apex_escape.html(c014)||l.c2),',
'              ''LOV'',',
'                l.o1||l.name_l||l.c1||l.o2||apex_escape.html(c003)||l.c1||l.c1||',
'                l.o1||l.type_l||l.c1||l.o2||apex_escape.html(lower(c004))||l.c2||',
'                decode(trim(c005),null,null,l.o1||l.definition_l||l.c1||l.o2||apex_escape.html(c005)||l.c2)||',
'                decode(trim(c006),null,null,l.o1||l.table_l||l.c1||l.o2||apex_escape.html(c006)||l.c2)||',
'                decode(trim(c007),null,null,l.o1||l.displayColumn_l||l.c1||l.o2||apex_escape.html(c007)||l.c2)||',
'                decode(trim(c008),null,null,l.o1||l.keycolumn_l||l.c1||l.o2||apex_escape.html(c008)||l.c2),',
'              ''REPORT'',',
'                l.o1||l.rowsPerPage_l||l.c1||l.o2||apex_escape.html(c003)||l.c2||',
'                l.o1||l.paginationMeth_l||l.c1||l.o2||apex_escape.html(wwv_flow_app_def_v3.get_JSON_pagniation_type(c005))||l.c2||',
'                decode(trim(c006),null,null,l.o1||l.numberFormatMask_l||l.c1||l.o2||apex_escape.html(c006)||l.c2)||',
'                decode(trim(c009),null,null,l.o1||l.dateFormatMask_l||l.c1||l.o2||apex_escape.html(c009)||l.c2),',
'              ''TABLE'',',
'                l.o1||l.table_l||l.c1||l.o2||apex_escape.html(c003)||l.c2||',
'                l.o1||l.labelSingular_l||l.c1||l.o2||apex_escape.html(c004)||l.c2||',
'                l.o1||l.labelPlural_l||l.c1||l.o2||apex_escape.html(c005)||l.c2||',
'                decode(trim(c006),null,null,l.o1||l.primaryDisplayColumn_l||l.c1||l.o2||apex_escape.html(c006)||l.c2)||',
'                decode(trim(c007),null,null,l.o1||l.secondaryDisplayColumn_l||l.c1||l.o2||apex_escape.html(c007)||l.c2)||',
'                decode(trim(c008),null,null,l.o1||l.primaryKeyColumn_l||l.c1||l.o2||apex_escape.html(c008)||l.c2),',
'                --decode(trim(c009),null,null,l.o1||l.primaryParentTable_l||l.c1||l.o2||apex_escape.html(c009)||l.c2),',
'              ''METRIC'',',
'                l.o1||l.name_l||l.c1||l.o2||apex_escape.html(c003)||l.c2||',
'                l.o1||l.type_l||l.c1||l.o2||apex_escape.html(c004)||l.c2||',
'                l.o1||l.suggestedVisulization_l||l.c1||l.o2||apex_escape.html(c005)||l.c2||',
'                decode(trim(c006),null,null,l.o1||l.table_l||l.c1||l.o2||apex_escape.html(c006)||l.c2)||',
'                decode(trim(c007),null,null,l.o1||l.labelColumn_l||l.c1||l.o2||apex_escape.html(c007)||l.c2)||',
'                decode(trim(c008),null,null,l.o1||l.function_l||l.c1||l.o2||apex_escape.html(c008)||l.c2)||',
'                decode(trim(c009),null,null,l.o1||l.valueColumn_l||l.c1||l.o2||apex_escape.html(c009)||l.c2)||',
'                decode(trim(c010),null,null,l.o1||l.maximumRows_l||l.c1||l.o2||apex_escape.html(c010)||l.c2)||',
'                decode(trim(c011),null,null,l.o1||l.query_l||l.c1||l.o2||apex_escape.html(c011)||l.c2),',
'              c003) attribute_settings,',
'        decode(upper(c002), ',
'              ''DESCRIPTION'',''360'',',
'              ''APPLICATION_ITEM'',''350'',',
'              ''TABLE_COLUMN'', ''310'',',
'              ''LOV'',''320'',',
'              ''REPORT'',''340'',',
'              ''METRIC'',''370'',',
'              ''TABLE'',''430'',',
'              ''#'') edit_page,',
'        d001 last_updated,',
'        seq_id,',
'        decode(upper(c002), ',
'            ''TABLE'', ''01''||c003,',
'            ''TABLE_COLUMN'',''01''||c003||''.''||c004,',
'            ''02''||c002||''.''||c003) OB,',
'        c040',
'    from apex_collections c, lbls l',
'    where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and ',
'          c002 != ''DESCRIPTION'' and ',
'          c002 != ''LOV_DATA''',
') c',
'order by 5',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(3145297412606009607)
,p_max_row_count=>'1000000'
,p_max_rows_per_page=>'100000'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>3145297412606009607
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2940047455175003243)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>10
,p_column_identifier=>'V'
,p_column_label=>'<span class="u-VisuallyHidden">Edit</span>'
,p_column_link=>'#EDIT_LINK#'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#app_ui/img/icons/apex-edit-pencil.png" class="apex-edit-pencil" alt="#LINK_TEXT#">'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3145299438285009627)
,p_db_column_name=>'ATTRIBUTE_SETTINGS'
,p_display_order=>30
,p_column_identifier=>'R'
,p_column_label=>'Settings'
,p_column_html_expression=>'<div class="a-AVPList a-AVPList--blocks">#ATTRIBUTE_SETTINGS#</div>'
,p_allow_sorting=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_static_id=>'attr_settings'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3145299737570009630)
,p_db_column_name=>'ATTRIBUTE_TYPE'
,p_display_order=>50
,p_column_identifier=>'U'
,p_column_label=>'Attribute'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3302183738582908704)
,p_db_column_name=>'LAST_UPDATED'
,p_display_order=>60
,p_column_identifier=>'W'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3504378962894326219)
,p_db_column_name=>'OB'
,p_display_order=>70
,p_column_identifier=>'X'
,p_column_label=>'Object Name'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3504379178256326221)
,p_db_column_name=>'SOURCED_FROM'
,p_display_order=>80
,p_column_identifier=>'Y'
,p_column_label=>'Sourced from'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(247044351762377608)
,p_db_column_name=>'LINK_TEXT'
,p_display_order=>90
,p_column_identifier=>'Z'
,p_column_label=>'Link Text'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_rpt(
 p_id=>wwv_flow_api.id(3157538733289778409)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'31575388'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'EDIT_LINK:ATTRIBUTE_TYPE:ATTRIBUTE_SETTINGS:LINK_TEXT'
,p_sort_column_1=>'OB'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'ATTRIBUTE_TYPE'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'ATTRIBTE_IDENTIFICATION'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3145298064428009613)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--slimPadding:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3302186513250908732)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(3145298064428009613)
,p_button_name=>'EDIT_DEFAULTS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Edit Defaults'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:360:&SESSION.::&DEBUG.:RP,360:P360_ID:1'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3775764374844368406)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(3145298064428009613)
,p_button_name=>'VIEW_JSON'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'View JSON'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:250:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3504377853063326208)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(3145298064428009613)
,p_button_name=>'Reset'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3171727377240100414)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(3145298064428009613)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Component'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3165201469772852632)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(3145298064428009613)
,p_button_name=>'RETURN'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(2988804730938183125)
,p_button_image_alt=>'Return to Create App Wizard'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3311213706143042513)
,p_name=>'Refresh on Add / Edit JSON'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(3145298064428009613)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3311213808853042514)
,p_event_id=>wwv_flow_api.id(3311213706143042513)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3145297382377009606)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3311213930056042515)
,p_name=>'Refresh on Edit'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(3145297382377009606)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3311214084567042516)
,p_event_id=>wwv_flow_api.id(3311213930056042515)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3145297382377009606)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3504378201458326212)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Reset App Defaults'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_app_def_v3.gen_apply_app_defaults_sql(',
'        p_app_defaults => wwv_flow_app_def_v3.gen_sample_app_defaults );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3504377853063326208)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3398687947504765505)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sync_app_defaults'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_app_def_v3.sync_app_defaults (',
'    p_schema              => :P1_SCHEMA,',
'    p_learn_app_def       => ( nvl(:P5_LEARN_UI_DEF_YN, ''N'') = ''Y'' ),',
'    p_learn_existing_apps => ( nvl(:P5_LEARN_YN,''N'') = ''Y'' ),',
'    p_base_table_prefix   => :P5_BASE_TABLE_PREFIX,',
'    p_seed_from_app_id    => :P5_SEED_FROM_APP  );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00300
begin
wwv_flow_api.create_page(
 p_id=>300
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Add Shared Component'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Shared Component'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_last_upd_yyyymmddhh24miss=>'20170501070953'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3165201010909852628)
,p_plug_name=>'Form'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3165201347779852631)
,p_branch_name=>'Branch to Page Item Attribute'
,p_branch_action=>'f?p=&APP_ID.:310:&SESSION.::&DEBUG.:RP,310::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P300_ATTRIBUTE_TYPE'
,p_branch_condition_text=>'TABLE_COLUMN'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3302185675220908723)
,p_branch_name=>'Branch to LOV'
,p_branch_action=>'f?p=&APP_ID.:320:&SESSION.::&DEBUG.:RP,320::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P300_ATTRIBUTE_TYPE'
,p_branch_condition_text=>'LOV'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3302185749229908724)
,p_branch_name=>'Branch to application item'
,p_branch_action=>'f?p=&APP_ID.:350:&SESSION.::&DEBUG.:RP,350::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P300_ATTRIBUTE_TYPE'
,p_branch_condition_text=>'APPLICATION_ITEM'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3302185966975908726)
,p_branch_name=>'Branch to report'
,p_branch_action=>'f?p=&APP_ID.:340:&SESSION.::&DEBUG.:RP,340::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P300_ATTRIBUTE_TYPE'
,p_branch_condition_text=>'REPORT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3398687563428765501)
,p_branch_name=>'Branch to table'
,p_branch_action=>'f?p=&APP_ID.:430:&SESSION.::&DEBUG.:RP,430::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P300_ATTRIBUTE_TYPE'
,p_branch_condition_text=>'TABLE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3398687621164765502)
,p_branch_name=>'Branch to metrics'
,p_branch_action=>'f?p=&APP_ID.:370:&SESSION.::&DEBUG.:RP,370::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P300_ATTRIBUTE_TYPE'
,p_branch_condition_text=>'METRIC'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3165201104877852629)
,p_name=>'P300_ATTRIBUTE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3165201010909852628)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Attribute Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'ATTRIBUTE_TYPES'
,p_lov=>'.'||wwv_flow_api.id(3174322299274441758)||'.'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'Y'
);
end;
/
prompt --application/pages/page_00310
begin
wwv_flow_api.create_page(
 p_id=>310
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Table Column Attribute'
,p_page_mode=>'MODAL'
,p_step_title=>'Table Column Attribute'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'640'
,p_last_upd_yyyymmddhh24miss=>'20210225130545'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3165199154732852609)
,p_plug_name=>'Identification'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3165199598158852613)
,p_plug_name=>'Settings'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3165200470552852622)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3348512942953385903)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(3165200470552852622)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:TABLE_COLUMN_ATTRIBUTE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3165200574372852623)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(3165200470552852622)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P310_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3413428923693144818)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(3165200470552852622)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Attribute Default'
,p_button_position=>'NEXT'
,p_button_condition=>'P310_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3413425189221121582)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(3165200470552852622)
,p_button_name=>'PREV'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:RP::'
,p_button_condition=>'P310_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3165200697778852624)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(3165200470552852622)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3399173947389626661)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(3165200470552852622)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Delete Attribute'
,p_button_position=>'PREVIOUS'
,p_button_condition_type=>'NEVER'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3165199280082852610)
,p_name=>'P310_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3165199154732852609)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3165199343513852611)
,p_name=>'P310_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3165199154732852609)
,p_prompt=>'Table'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3165199490675852612)
,p_name=>'P310_COLUMN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3165199154732852609)
,p_prompt=>'Column'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P310_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id'))
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3165199779910852615)
,p_name=>'P310_LABEL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3165199598158852613)
,p_prompt=>'Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3165199881527852616)
,p_name=>'P310_FORM_CONTROL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3165199598158852613)
,p_item_default=>'TEXT'
,p_prompt=>'Form Control'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ITEM_DISPLAY_TYPES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name d, name_with_prefix r',
'from wwv_flow_native_plugins',
'where plugin_type = ''ITEM TYPE''',
'and name_with_prefix in (',
'    ''NATIVE_TEXT_FIELD'',',
'    ''NATIVE_TEXTAREA'',',
'    ''NATIVE_SELECT_LIST'',',
'    ''NATIVE_POPUP_LOV'',',
'    ''NATIVE_RADIOGROUP'',',
'    ''NATIVE_CHECKBOX'',',
'    ''NATIVE_YES_NO'',',
'    ''NATIVE_HIDDEN'',',
'    ''NATIVE_DATE_PICKER_JET'',',
'    ''NATIVE_NUMBER_FIELD'',',
'    ''NATIVE_TEXTAREA'',',
'    ''NATIVE_FILE'')',
'order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3165199918382852617)
,p_name=>'P310_INCLUDE_ON_FORMS'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(3165199598158852613)
,p_item_default=>'Y'
,p_prompt=>'Include on Forms'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3165200005104852618)
,p_name=>'P310_INCLUDE_ON_REPORTS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(3165199598158852613)
,p_item_default=>'Y'
,p_prompt=>'Include on Reports'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3165200188885852619)
,p_name=>'P310_LIST_OF_VALUES'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3165199598158852613)
,p_item_default=>'0'
,p_prompt=>'List of Values'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c003||'' - ''||c004 d,',
'       c003 r',
'from apex_collections ',
'where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and',
'      c002 = ''LOV''',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Not Specified or Not Applicable -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3165200278962852620)
,p_name=>'P310_FORMAT_MASK'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3165199598158852613)
,p_prompt=>'Format Mask'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT MASK DYNAMIC'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'from wwv_flow_format_masks'))
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3165200367649852621)
,p_name=>'P310_STATIC_DEFAULT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(3165199598158852613)
,p_prompt=>'Static Default Value'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3302186977757908736)
,p_name=>'P310_COMMENTS'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(3165199598158852613)
,p_prompt=>'Comments'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>5
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3302187004171908737)
,p_name=>'P310_HELP'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(3165199598158852613)
,p_prompt=>'Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3302187144353908738)
,p_name=>'P310_WIDTH'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(3165199598158852613)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3302187242801908739)
,p_name=>'P310_MAXIMUM_WIDTH'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(3165199598158852613)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3302187326328908740)
,p_name=>'P310_REQUIRED'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(3165199598158852613)
,p_item_default=>'N'
,p_prompt=>'Required'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3172048171795109037)
,p_validation_name=>'lov required'
,p_validation_sequence=>10
,p_validation=>'P310_LIST_OF_VALUES'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified'
,p_validation_condition=>':P310_FORM_CONTROL in (wwv_flow_native_item.c_select_list, wwv_flow_native_item.c_popup_lov, wwv_flow_native_item.c_yes_no, wwv_flow_native_item.c_radiogroup, wwv_flow_native_item.c_checkbox )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3165200716200852625)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3165200697778852624)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3165200807942852626)
,p_event_id=>wwv_flow_api.id(3165200716200852625)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3171727591584100416)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save back to collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_name varchar2(4000) := null;',
'begin',
'    for c1 in (select c001 ',
'               from apex_collections ',
'               where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P310_ID) loop',
'       l_name := c1.c001;',
'    end loop;',
'    ',
'    if :REQUEST = ''DELETE'' then',
'        APEX_COLLECTION.DELETE_MEMBER (',
'            p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'            p_seq             => :P320_ID);',
'    else',
'        if :P310_ID is not null then',
'      ',
'            APEX_COLLECTION.UPDATE_MEMBER (',
'                p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'                p_seq             => :P310_ID,',
'                p_c001            => l_name,',
'                p_c002            => ''TABLE_COLUMN'',',
'                p_c003            => :P310_TABLE ,',
'                p_c004            => :p310_column,',
'                p_c005            => :p310_label,',
'                p_c006            => :p310_form_CONTROL,',
'                p_c007            => :P310_include_on_forms,',
'                p_c008            => :P310_include_on_reports,',
'                p_c009            => :P310_LIST_OF_VALUES,',
'                p_c010            => :p310_format_mask,',
'                p_c011            => :p310_static_default,',
'                p_c012            => :p310_comments,',
'                p_c013            => :p310_help,',
'                p_c014            => :P310_WIDTH,',
'                p_c015            => :P310_MAXIMUM_WIDTH,',
'                p_c016            => :P310_REQUIRED,',
'                p_d001            => sysdate',
'                );',
'                ',
'        else',
'        ',
'            APEX_COLLECTION.ADD_MEMBER (',
'                p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'                p_c001            => ''attribute defaults'',',
'                p_c002            => ''PAGE_ITEM'',',
'                p_c003            => :P310_TABLE ,',
'                p_c004            => :p310_column,',
'                p_c005            => :p310_label,',
'                p_c006            => :p310_form_CONTROL,',
'                p_c007            => :P310_include_on_forms,',
'                p_c008            => :P310_include_on_reports,',
'                p_c009            => :P310_LIST_OF_VALUES,',
'                p_c010            => :p310_format_mask,',
'                p_c011            => :p310_static_default,',
'                p_c012            => :p310_comments,',
'                p_c013            => :p310_help,',
'                p_c014            => :P310_WIDTH,',
'                p_c015            => :P310_MAXIMUM_WIDTH,',
'                 --p_c016            => :P310_REQUIRED,',
'                p_d001            => sysdate',
'                );',
'                ',
'        end if;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3311214178033042517)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3171727440794100415)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch data from collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select * ',
'           from apex_collections ',
'           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P310_ID) loop',
'   :P310_TABLE              := C1.C003;',
'   :P310_COLUMN             := C1.C004;',
'   :P310_LABEL              := C1.C005;',
'   :P310_FORM_CONTROL       := C1.C006;',
'   :P310_INCLUDE_ON_FORMS   := C1.C007;',
'   :P310_INCLUDE_ON_REPORTS := C1.C008;',
'   :P310_LIST_OF_VALUES     := C1.C009;',
'   :P310_FORMAT_MASK        := C1.C010;',
'   :P310_STATIC_DEFAULT     := C1.C011;',
'   :P310_COMMENTS           := C1.C012;',
'   :P310_HELP               := C1.C013;',
'   :P310_WIDTH              := C1.C014;',
'   :P310_MAXIMUM_WIDTH      := C1.C015;',
'   :P310_required           := NVL(C1.C016,''N'');',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00320
begin
wwv_flow_api.create_page(
 p_id=>320
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'List of Values Attribute'
,p_page_mode=>'MODAL'
,p_step_title=>'List of Values Attribute'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(function( $ ){',
'',
'    var notAdded = function( elem ) {',
'        return $( elem ).closest( ''tr'' ).next()[0] ? false : true;',
'    };',
'',
'    var addRow = function( elem ){',
'        var tr$ = $( elem ).parent().parent(),',
'            seq = parseInt( tr$.find( ''[name=f01]'' ).val() );',
'        tr$',
'            .clone()',
'            .appendTo( tr$.parent() )',
'            .find( ''input'' )',
'            .val('''')',
'            .first()',
'            .val( seq + 10 );',
'    };',
'    // add row if return value field has value',
'    $( ''#static_lov_region'' )',
'        .on( ''input'', ''[name=f03]'', function(){',
'            if ( notAdded( this ) ) {',
'                addRow( this );',
'            }',
'        });',
'})( apex.jQuery );'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.stretch-input {',
'    width: 100%;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'640'
,p_last_upd_yyyymmddhh24miss=>'20200831023101'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(160013862315808234)
,p_name=>'Static LOV'
,p_region_name=>'static_lov_region'
,p_template=>wwv_flow_api.id(3300810815961795652)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="margin: 12px 24px"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       APEX_ITEM.TEXT(p_idx => 1, p_value => NVL(n002,10), p_attributes => ''class="stretch-input u-tE"'') display_sequence, ',
'       APEX_ITEM.TEXT(p_idx => 2, p_value => c005, p_attributes => ''class="stretch-input"'') display_value, ',
'       APEX_ITEM.TEXT(p_idx => 3, p_value => c006, p_attributes => ''class="stretch-input"'') return_value',
'from   apex_collections ',
'where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and',
'      c002 = ''LOV_DATA'' and',
'      n001 in (',
'          select n001',
'            from apex_collections ',
'           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and',
'                 c002 = ''LOV'' and',
'                 seq_id = :P320_ID)',
'union all',
'-- extra row to add a new lov entry member',
'select ',
'       APEX_ITEM.TEXT(p_idx => 1, p_value => NVL( (select max(n002) + 10 from apex_collections ',
'               where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and',
'                     c002 = ''LOV_DATA'' and',
'                     n001 in (',
'                          select n001',
'                            from apex_collections ',
'                           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and',
'                                 c002 = ''LOV'' and',
'                                 seq_id = :P320_ID)), 10 ), p_attributes => ''class="stretch-input u-tE"'')   display_sequence,',
'       APEX_ITEM.TEXT(p_idx => 2, p_value => null, p_attributes => ''class="stretch-input"'') display_value,',
'       APEX_ITEM.TEXT(p_idx => 3, p_value => null, p_attributes => ''class="stretch-input"'') return_value',
'from  dual',
'order by 1, 2'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(2707641403506668051)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3504378521998326215)
,p_query_column_id=>1
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>64
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3504378620602326216)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Display Value'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(160014072843808236)
,p_query_column_id=>3
,p_column_alias=>'RETURN_VALUE'
,p_column_display_sequence=>3
,p_column_heading=>'Return Value'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3661793287320803714)
,p_plug_name=>'Structured LOV'
,p_region_template_options=>'#DEFAULT#:a-Form--leftLabels:a-Form--fixedLabels'
,p_region_attributes=>'style="margin: 12px 16px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6512260336253636702)
,p_plug_name=>'List of Values'
,p_region_template_options=>'#DEFAULT#:a-Form--autoWidthLabels'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6512261652073636715)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3348520762265408138)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(6512261652073636715)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:LOV_ATTRIBUTE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3347065349315784120)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(6512261652073636715)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P320_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3398990882243869202)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(6512261652073636715)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Attribute Default'
,p_button_position=>'NEXT'
,p_button_condition=>'P320_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3347064994581784118)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(6512261652073636715)
,p_button_name=>'PREV'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:RP::'
,p_button_condition=>'P320_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3347065773578784121)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(6512261652073636715)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3398990937748869203)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(6512261652073636715)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Delete Attribute'
,p_button_position=>'PREVIOUS'
,p_button_condition=>'P320_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3302184199465908708)
,p_name=>'P320_STATIC_VALUES'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(6512260336253636702)
,p_item_default=>'static2:Display1,Value1;Display2,Value2'
,p_prompt=>'Static List of Values'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cHeight=>5
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(3076592627306440115)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3302184241493908709)
,p_name=>'P320_LOV_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(6512260336253636702)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359248210082306)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3302185246688908719)
,p_name=>'P320_TABLE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(3661793287320803714)
,p_prompt=>'Table'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(3071359248210082306)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3302185342889908720)
,p_name=>'P320_DISPLAY_COLUMN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(3661793287320803714)
,p_prompt=>'Display Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P320_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P320_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(3071359248210082306)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3302185412215908721)
,p_name=>'P320_ID_COLUMN'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(3661793287320803714)
,p_prompt=>'Key Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P320_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P320_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(3071359248210082306)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3347061847342784108)
,p_name=>'P320_SQL_QUERY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(6512260336253636702)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ename as d, empno as r',
'from emp',
'order by 1'))
,p_prompt=>'SQL Query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cHeight=>5
,p_tag_attributes=>'style="margin-top: 12px;"'
,p_field_template=>wwv_flow_api.id(3076592627306440115)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3347066430417784121)
,p_name=>'P320_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(6512260336253636702)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3347066894559784122)
,p_name=>'P320_LOV_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(6512260336253636702)
,p_item_default=>'STRUCTURED'
,p_prompt=>'Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'LOV TYPE'
,p_lov=>'.'||wwv_flow_api.id(3363550887091219855)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3661792982676803711)
,p_name=>'P320_ORDER_COLUMN'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(3661793287320803714)
,p_prompt=>'Order By Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P320_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Order by Display Column'
,p_lov_null_value=>'0'
,p_lov_cascade_parent_items=>'P320_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(3071359248210082306)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3414639042759610188)
,p_validation_name=>'Check for Duplicate structured LOVs'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_error_msg varchar2(255) := wwv_flow_lang.custom_runtime_message(''CA.ATTR.DEFAULT.DUPLICATE'',''structured list of values on this table'');',
'begin',
'  for c1 in (select c001',
'             from apex_collections ',
'             where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' ',
'             and   c004 = ''structured''',
'             and   c006 = :P320_TABLE',
'             and   seq_id <> nvl(:P430_ID,0)',
'            ) loop',
'     return l_error_msg; ',
'  end loop;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_associated_item=>wwv_flow_api.id(3302185246688908719)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3019481208024899637)
,p_validation_name=>'Table NN for Structured'
,p_validation_sequence=>20
,p_validation=>'P320_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P320_LOV_TYPE'
,p_validation_condition2=>'STRUCTURED'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(3302185246688908719)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3019481303250899638)
,p_validation_name=>'Display Column NN for Structured'
,p_validation_sequence=>40
,p_validation=>'P320_DISPLAY_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P320_LOV_TYPE'
,p_validation_condition2=>'STRUCTURED'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(3302185342889908720)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3019481407358899639)
,p_validation_name=>'Key Column NN for Structured'
,p_validation_sequence=>50
,p_validation=>'P320_ID_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P320_LOV_TYPE'
,p_validation_condition2=>'STRUCTURED'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(3302185412215908721)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3019481544009899640)
,p_validation_name=>'SQL Query NN for Dynamic'
,p_validation_sequence=>60
,p_validation=>'P320_SQL_QUERY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P320_LOV_TYPE'
,p_validation_condition2=>'DYNAMIC'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(3347061847342784108)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3019481631577899641)
,p_validation_name=>'Static Values NN for Static Values'
,p_validation_sequence=>70
,p_validation=>'P320_STATIC_VALUES'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition_type=>'NEVER'
,p_associated_item=>wwv_flow_api.id(3302184199465908708)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3347068736917784138)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3347065773578784121)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3347069231858784141)
,p_event_id=>wwv_flow_api.id(3347068736917784138)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3661791977005803701)
,p_name=>'Handle LOV Type'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P320_LOV_TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3661792000458803702)
,p_event_id=>wwv_flow_api.id(3661791977005803701)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lovType = $v(''P320_LOV_TYPE'');',
'var stuctured_lov$ = $(''#P320_TABLE_CONTAINER, #P320_DISPLAY_COLUMN_CONTAINER, #P320_ID_COLUMN_CONTAINER, #P320_ORDER_COLUMN_CONTAINER'');',
'var dynamic_lov$ = $(''#P320_SQL_QUERY_CONTAINER'');',
'var static_lov$ = $(''#static_lov_region'');',
'',
'stuctured_lov$.hide();',
'dynamic_lov$.hide();',
'static_lov$.hide();',
'',
'if (lovType === ''STRUCTURED'') {',
'  stuctured_lov$.show();',
'} else if (lovType === ''DYNAMIC'') {',
'  dynamic_lov$.show();',
'} else if (lovType === ''STATIC'') {',
'  static_lov$.show();',
'}'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3347067944610784136)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save back to collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_name           varchar2(4000) := null;',
'   l_lov            varchar2(32767) := null;',
'   l_n001           number := null;',
'   l_disp_seq       integer := 0;',
'   l_order_by       varchar2(255);',
'begin',
'for c1 in (select c001, n001',
'           from apex_collections ',
'           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P320_ID) loop',
'   l_name := c1.c001;',
'   l_n001 := c1.n001;',
'end loop;',
'',
'if :REQUEST = ''DELETE'' then',
'    APEX_COLLECTION.DELETE_MEMBER (',
'        p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'        p_seq             => :P320_ID);',
'else',
'    -- determine lov attributes',
'    if lower(:P320_LOV_TYPE) = ''dynamic'' then',
'       l_lov := :P320_SQL_QUERY;',
'    end if;',
'    ',
'    -- set collection values',
'    if lower(:P320_LOV_TYPE) = ''static'' then',
'        if :P320_ID is not null then',
'            -- remove existing static list of values collection members',
'            for c2 in (',
'               select seq_id ',
'               from  apex_collections ',
'               where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and ',
'                     c002 = ''LOV_DATA'' and ',
'                     n001 = l_n001) loop',
'                   APEX_COLLECTION.DELETE_MEMBER(p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'', p_seq=>c2.seq_id);',
'            end loop;',
'        end if;',
'        ',
'        -- add new static values',
'        if :P320_ID is null then',
'            -- add parent lov collection member',
'            l_n001 := wwv_flow_id.next_val;',
'            APEX_COLLECTION.ADD_MEMBER (',
'                p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'                p_c001            => l_name,',
'                p_c002            => ''LOV'',',
'                p_c003            => upper(:P320_LOV_NAME),',
'                p_c004            => ''STATIC'',',
'                p_c005            => null,',
'                P_c006            => null,',
'                p_c007            => null,',
'                p_c008            => null,',
'                p_n001            => l_n001, -- lov join key to join parent lov name with child lov entries',
'                p_d001            => sysdate',
'                );',
'        else',
'            APEX_COLLECTION.UPDATE_MEMBER (',
'                p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'                p_seq             => :P320_ID,',
'                p_c001            => l_name,',
'                p_c002            => ''LOV'',',
'                p_c003            => upper(:P320_LOV_NAME),',
'                p_c004            => ''STATIC'',',
'                p_c005            => null,',
'                P_c006            => null,',
'                p_c007            => null,',
'                p_c008            => null,',
'                p_n001            => l_n001,',
'                p_d001            => sysdate',
'                );',
'        end if;',
'        ',
'        for i in 1..wwv_flow.g_f01.count loop',
'            l_disp_seq := l_disp_seq + 10;',
'            -- add lov member child rows',
'            if apex_application.g_f03(i) is not null and apex_application.g_f02(i) is not null then',
'                apex_collection.add_member (',
'                    p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'                    p_c001 => l_name,',
'                    p_c002 => ''LOV_DATA'',',
'                    p_c005 => apex_application.g_f02(i),',
'                    p_c006 => apex_application.g_f03(i),',
'                    p_n001 => l_n001,',
'                    p_n002 => l_disp_seq,',
'                    p_d001 => sysdate',
'                    );',
'            end if;',
'        end loop;',
'    else',
'        if :P320_ID is not null then',
'            APEX_COLLECTION.UPDATE_MEMBER (',
'                p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'                p_seq             => :P320_ID,',
'                p_c001            => l_name,',
'                p_c002            => ''LOV'',',
'                p_c003            => upper(:P320_LOV_NAME),',
'                p_c004            => :P320_LOV_TYPE,',
'                p_c005            => l_lov,',
'                P_c006            => :P320_TABLE,',
'                p_c007            => :P320_DISPLAY_COLUMN,',
'                p_c008            => :P320_ID_COLUMN,',
'                p_c009            => :P320_ORDER_COLUMN,',
'                p_d001            => sysdate',
'                );',
'        else',
'            APEX_COLLECTION.ADD_MEMBER (',
'                p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'                p_c001            => l_name,',
'                p_c002            => ''LOV'',',
'                p_c003            => upper(:P320_LOV_NAME),',
'                p_c004            => :P320_LOV_TYPE,',
'                p_c005            => l_lov,',
'                P_c006            => :P320_TABLE,',
'                p_c007            => :P320_DISPLAY_COLUMN,',
'                p_c008            => :P320_ID_COLUMN,',
'                p_c009            => :P320_ORDER_COLUMN,',
'                p_d001            => sysdate',
'                );',
'        end if;',
'    end if;',
'',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3347068302818784137)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3347067640770784135)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch data from collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select * ',
'    from apex_collections ',
'    where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and ',
'          seq_id = :P320_ID) loop',
'          ',
'   :P320_LOV_NAME := C1.C003; ',
'   :P320_LOV_TYPE := upper(C1.C004);',
'   if lower(C1.C004) = ''static'' then ',
'      --:P320_STATIC_VALUES         := C1.C005;',
'      :P320_SQL_QUERY             := null;',
'   elsif lower(C1.C004) = ''dynamic'' then ',
'      --:P320_STATIC_VALUES         := null;',
'      :P320_SQL_QUERY             := C1.C005;',
'   else',
'      :P320_TABLE                 := c1.c006;',
'      :P320_DISPLAY_COLUMN        := c1.c007;',
'      :P320_ID_COLUMN             := c1.c008;',
'      :P320_ORDER_COLUMN          := c1.c009;',
'   end if;',
'   ',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00340
begin
wwv_flow_api.create_page(
 p_id=>340
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Report Attributes'
,p_page_mode=>'MODAL'
,p_step_title=>'Report Attributes'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'640'
,p_last_upd_yyyymmddhh24miss=>'20171009062401'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16557748491182994796)
,p_plug_name=>'Reports'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16557749807002994809)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3413432445171186417)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(16557749807002994809)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:REPORT_ATTRIBUTE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3348535073365543309)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(16557749807002994809)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P340_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3413434096915203320)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(16557749807002994809)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Attribute Default'
,p_button_position=>'NEXT'
,p_button_condition=>'P340_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3348535876220543315)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(16557749807002994809)
,p_button_name=>'PREV'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:RP::'
,p_button_condition=>'P340_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3348535421704543314)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(16557749807002994809)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3399172753722601202)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(16557749807002994809)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Delete Attribute'
,p_button_position=>'PREVIOUS'
,p_button_condition_type=>'NEVER'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3302184569021908712)
,p_name=>'P340_NUMERIC_FORMAT_MASK'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(16557748491182994796)
,p_item_default=>'VARCHAR'
,p_prompt=>'Numeric Format Mask'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3302184673340908713)
,p_name=>'P340_DATE_FORMAT_MASK'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(16557748491182994796)
,p_item_default=>'VARCHAR'
,p_prompt=>'Date Format Mask'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3348536510841543325)
,p_name=>'P340_ROWS_PER_PAGE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(16557748491182994796)
,p_prompt=>'Rows Per Page'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3348536955681543334)
,p_name=>'P340_PAGINATION_METHOD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(16557748491182994796)
,p_item_default=>'NEXT_PREVIOUS_LINKS'
,p_prompt=>'Pagination Method'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGINATION'
,p_lov=>'.'||wwv_flow_api.id(3348566714295666169)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3348538127232543336)
,p_name=>'P340_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(16557748491182994796)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3348539709689543350)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3348535421704543314)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3348540225331543354)
,p_event_id=>wwv_flow_api.id(3348539709689543350)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3348538994862543348)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save back to collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_name varchar2(4000) := null;',
'begin',
'for c1 in (select c001',
'           from apex_collections ',
'           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P340_ID) loop',
'   l_name := c1.c001;',
'end loop;',
'',
'if :REQUEST = ''DELETE'' then',
'    APEX_COLLECTION.DELETE_MEMBER (',
'        p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'        p_seq             => :P320_ID);',
'else',
'    if :P340_ID is not null then',
'        APEX_COLLECTION.UPDATE_MEMBER (',
'            p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'            p_seq             => :P340_ID,',
'            p_c001            => l_name,',
'            p_c002            => ''REPORT'',',
'            p_c003            => :P340_ROWS_PER_PAGE,',
'            p_c005            => :P340_PAGINATION_METHOD,',
'            p_c006            => :P340_NUMERIC_FORMAT_MASK,',
'            p_c009            => :P340_DATE_FORMAT_MASK,',
'            p_d001            => sysdate',
'            );',
'            ',
'    else',
'    ',
'        APEX_COLLECTION.ADD_MEMBER (',
'            p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'            p_c001            => l_name,',
'            p_c002            => ''REPORT'',',
'            p_c003            => :P340_ROWS_PER_PAGE,',
'            p_c005            => :P340_PAGINATION_METHOD,',
'            p_c006            => :P340_NUMERIC_FORMAT_MASK,',
'            p_c009            => :P340_DATE_FORMAT_MASK,',
'            p_d001            => sysdate',
'            );',
'    end if;',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3348539352524543349)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3348538515225543345)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch data from collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select * ',
'           from apex_collections ',
'           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P340_ID) loop',
'   :P340_ROWS_PER_PAGE          := C1.C003; ',
'   :P340_PAGINATION_METHOD      := C1.C005;',
'   :P340_NUMERIC_FORMAT_MASK    := C1.C006;',
'   :P340_DATE_FORMAT_MASK       := C1.C009;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00350
begin
wwv_flow_api.create_page(
 p_id=>350
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Application Item Attribute'
,p_page_mode=>'MODAL'
,p_step_title=>'Application Item Attribute'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'fieldset.textarea {',
'    width: 100%;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'640'
,p_last_upd_yyyymmddhh24miss=>'20171009062401'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13209214060330451553)
,p_plug_name=>'Identification'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13209215376150451566)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3413435103918209273)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(13209215376150451566)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:APP_ITEM_ATTRIBUTE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3348482906620943332)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(13209215376150451566)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P350_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3413435465052210463)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(13209215376150451566)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Attribute Default'
,p_button_position=>'NEXT'
,p_button_condition=>'P350_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3413434588859206469)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(13209215376150451566)
,p_button_name=>'PREV'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:RP::'
,p_button_condition=>'P350_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3348483347387943333)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(13209215376150451566)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3399171947930582197)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(13209215376150451566)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Delete Attribute'
,p_button_position=>'PREVIOUS'
,p_button_condition=>'P350_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3302184386601908710)
,p_name=>'P350_PROTECTION_LEVEL'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(13209214060330451553)
,p_item_default=>'RESTRICTED_NO_SET_FROM_BROWSER'
,p_prompt=>'Name'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP ITEM PROTECTION LEVEL'
,p_lov=>'.'||wwv_flow_api.id(3348521895514426469)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3302184404464908711)
,p_name=>'P350_DATA_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(13209214060330451553)
,p_item_default=>'VARCHAR'
,p_prompt=>'Name'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC2:NUMBER;NUMBER,VARCHAR;VARCHAR'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3348484492788943334)
,p_name=>'P350_DESCRIPTION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(13209214060330451553)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3348485161446943335)
,p_name=>'P350_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(13209214060330451553)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359248210082306)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3348485563930943336)
,p_name=>'P350_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(13209214060330451553)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3348487139406943338)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3348483347387943333)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3348487623366943338)
,p_event_id=>wwv_flow_api.id(3348487139406943338)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3348486307197943337)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save back to collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_name varchar2(4000) := null;',
'begin',
'for c1 in (select c001',
'           from apex_collections ',
'           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P350_ID) loop',
'   l_name := c1.c001;',
'end loop;',
'',
'if :REQUEST = ''DELETE'' then',
'    APEX_COLLECTION.DELETE_MEMBER (',
'        p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'        p_seq             => :P320_ID);',
'else',
'    if l_name is not null then',
'        APEX_COLLECTION.UPDATE_MEMBER (',
'            p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'            p_seq             => :P350_ID,',
'            p_c001            => l_name,',
'            p_c002            => ''APPLICATION_ITEM'',',
'            p_c003            => :P350_NAME ,',
'            p_c004            => :P350_DESCRIPTION,',
'            p_c005            => :P350_DATA_TYPE,',
'            p_c006            => :P350_PROTECTION_LEVEL,',
'            p_d001            => sysdate',
'            );',
'    else',
'        APEX_COLLECTION.ADD_MEMBER (',
'            p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'            p_c001            => l_name,',
'            p_c002            => ''APPLICATION_ITEM'',',
'            p_c003            => :P350_NAME ,',
'            p_c004            => :P350_DESCRIPTION,',
'            p_c005            => :P350_DATA_TYPE,',
'            p_c006            => :P350_PROTECTION_LEVEL,',
'            p_d001            => sysdate',
'            );',
'            ',
'    end if;',
'end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3348486702879943337)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3348485937407943337)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch data from collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select * ',
'           from apex_collections ',
'           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P350_ID) loop',
'   :P350_NAME              := C1.C003; ',
'   :P350_DESCRIPTION       := C1.C004;',
'   :P350_PROTECTION_LEVEL  := c1.C006;',
'   :P350_DATA_TYPE         := c1.C005;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00360
begin
wwv_flow_api.create_page(
 p_id=>360
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Attribute Defaults'
,p_page_mode=>'MODAL'
,p_step_title=>'Attribute Defaults'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'fieldset.textarea {',
'    width: 100%;',
'}'))
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'640'
,p_last_upd_yyyymmddhh24miss=>'20171009062401'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9860731784394508223)
,p_plug_name=>'Application Defaults'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9860733100214508236)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3348472554245871537)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(9860733100214508236)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3348472124424871535)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(9860733100214508236)
,p_button_name=>'PREV'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:RP::'
,p_button_condition_type=>'NEVER'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3348472949876871537)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(9860733100214508236)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3348473679834871547)
,p_name=>'P360_DESCRIPTION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(9860731784394508223)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3348474395392871549)
,p_name=>'P360_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(9860731784394508223)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359248210082306)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3348474768226871550)
,p_name=>'P360_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(9860731784394508223)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3398688431885765510)
,p_name=>'P360_TABLE_PREFIX'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(9860731784394508223)
,p_prompt=>'Table Prefixes'
,p_placeholder=>'HR_, OE_'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3348477337785871572)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3348472949876871537)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3348477811897871574)
,p_event_id=>wwv_flow_api.id(3348477337785871572)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3348476532811871570)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save back to collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_name varchar2(4000) := null;',
'begin',
'for c1 in (select c001',
'           from apex_collections ',
'           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P360_ID) loop',
'   l_name := c1.c001;',
'end loop;',
'',
'',
'if l_name is not null then',
'    APEX_COLLECTION.UPDATE_MEMBER (',
'        p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'        p_seq             => :P360_ID,',
'        p_c001            => l_name,',
'        p_c002            => ''DESCRIPTION'',',
'        p_c003            => :P360_NAME ,',
'        p_c004            => :P360_DESCRIPTION,',
'        p_c005            => :P360_TABLE_PREFIX,',
'        p_d001            => sysdate',
'        );',
'        ',
'else',
'    APEX_COLLECTION.ADD_MEMBER (',
'        p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'        p_c001            => l_name,',
'        p_c002            => ''DESCRIPTION'',',
'        p_c003            => :P360_NAME ,',
'        p_c004            => :P360_DESCRIPTION,',
'        p_c005            => :P360_TABLE_PREFIX,',
'        p_d001            => sysdate',
'        );',
'        ',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3348476925784871570)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3348476235977871569)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch data from collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select * ',
'           from apex_collections ',
'           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P360_ID) loop',
'   :P360_NAME         := C1.C003; ',
'   :P360_DESCRIPTION  := C1.C004;',
'   :P360_TABLE_PREFIX := c1.c005;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00370
begin
wwv_flow_api.create_page(
 p_id=>370
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Metric Attribute'
,p_page_mode=>'MODAL'
,p_step_title=>'Metric Attribute'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'fieldset.textarea {',
'    width: 100%;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'640'
,p_last_upd_yyyymmddhh24miss=>'20200907060048'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19986845055119921212)
,p_plug_name=>'Identification'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19986846370939921225)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3413437829392225465)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(19986846370939921225)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:METRIC_ATTRIBUTE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3390655510072107123)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(19986846370939921225)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P370_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3413438184903226621)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(19986846370939921225)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Attribute Default'
,p_button_position=>'NEXT'
,p_button_condition=>'P370_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3390656395943107125)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(19986846370939921225)
,p_button_name=>'PREV'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:RP::'
,p_button_condition=>'P370_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3390655951355107124)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(19986846370939921225)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3413437554209224194)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(19986846370939921225)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Delete Attribute'
,p_button_position=>'PREVIOUS'
,p_button_condition=>'P370_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3302186616857908733)
,p_name=>'P370_MAX_ROWS'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(19986845055119921212)
,p_item_default=>'RESTRICTED_NO_SET_FROM_BROWSER'
,p_prompt=>'Maximum Rows'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3302186769395908734)
,p_name=>'P370_QUERY'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(19986845055119921212)
,p_prompt=>'Query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cHeight=>5
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3390657024350107137)
,p_name=>'P370_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(19986845055119921212)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359248210082306)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3390657483773107143)
,p_name=>'P370_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(19986845055119921212)
,p_item_default=>'VARCHAR'
,p_prompt=>'Type'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3390657834687107144)
,p_name=>'P370_VISUAL'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(19986845055119921212)
,p_item_default=>'RESTRICTED_NO_SET_FROM_BROWSER'
,p_prompt=>'Suggested Visualization'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3390658259292107144)
,p_name=>'P370_TABLE'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(19986845055119921212)
,p_item_default=>'RESTRICTED_NO_SET_FROM_BROWSER'
,p_prompt=>'Table'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3390658672796107144)
,p_name=>'P370_LABEL_COLUMN'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(19986845055119921212)
,p_item_default=>'RESTRICTED_NO_SET_FROM_BROWSER'
,p_prompt=>'Label Column'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3390659000295107145)
,p_name=>'P370_FUNCTION'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(19986845055119921212)
,p_item_default=>'RESTRICTED_NO_SET_FROM_BROWSER'
,p_prompt=>'Function'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3390659475333107145)
,p_name=>'P370_VALUE_COLUMN'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(19986845055119921212)
,p_item_default=>'RESTRICTED_NO_SET_FROM_BROWSER'
,p_prompt=>'Value Column'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3390659860641107145)
,p_name=>'P370_DESCRIPTION'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(19986845055119921212)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3390660238480107146)
,p_name=>'P370_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(19986845055119921212)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3390661800831107158)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3390655951355107124)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3390662387399107162)
,p_event_id=>wwv_flow_api.id(3390661800831107158)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3390661080178107156)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save back to collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_name varchar2(4000) := null;',
'begin',
'for c1 in (select c001',
'           from apex_collections ',
'           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P370_ID) loop',
'   l_name := c1.c001;',
'end loop;',
'',
'if :P370_ID is not null then',
'    APEX_COLLECTION.UPDATE_MEMBER (',
'        p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'        p_seq             => :P370_ID,',
'        p_c001            => l_name,',
'        p_c002            => ''METRIC'',',
'        p_c003            => :P370_NAME ,',
'        p_c004            => :P370_TYPE,',
'        p_c005            => :P370_VISUAL,',
'        p_c006            => :P370_TABLE,',
'        p_c007            => :P370_LABEL_COLUMN,',
'        p_c008            => :P370_FUNCTION,',
'        p_c009            => :P370_VALUE_COLUMN,',
'        p_c010            => :P370_max_rows,',
'        p_c011            => :P370_query,',
'        p_c012            => :P370_DESCRIPTION,',
'        p_d001            => sysdate',
'        );',
'        ',
'else',
'',
'    APEX_COLLECTION.ADD_MEMBER (',
'        p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'        p_c001            => l_name,',
'        p_c002            => ''METRIC'',',
'        p_c003            => :P370_NAME ,',
'        p_c004            => :P370_TYPE,',
'        p_c005            => :P370_VISUAL,',
'        p_c006            => :P370_TABLE,',
'        p_c007            => :P370_LABEL_COLUMN,',
'        p_c008            => :P370_FUNCTION,',
'        p_c009            => :P370_VALUE_COLUMN,',
'        p_c010            => :P370_max_rows,',
'        p_c011            => :P370_query,',
'        p_c012            => :P370_DESCRIPTION,',
'        p_d001            => sysdate',
'        );',
'        ',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3390661441567107156)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3390660616365107155)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch data from collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select * ',
'           from apex_collections ',
'           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P370_ID) loop',
'   :P370_NAME                := C1.C003; ',
'   :P370_TYPE                := C1.C004;',
'   :P370_VISUAL              := c1.C005;',
'   :P370_TABLE               := c1.C006;',
'   :P370_LABEL_COLUMN        := c1.C007;',
'   :P370_FUNCTION            := c1.C008;',
'   :P370_VALUE_COLUMN        := c1.C009;',
'   :P370_max_rows            := c1.C010;',
'   :P370_query               := c1.C011;',
'   :P370_DESCRIPTION         := c1.C012;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00430
begin
wwv_flow_api.create_page(
 p_id=>430
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Table Attributes'
,p_page_mode=>'MODAL'
,p_step_title=>'Table Attributes'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'fieldset.textarea {',
'    width: 100%;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'640'
,p_last_upd_yyyymmddhh24miss=>'20171009062401'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16596190157842814110)
,p_plug_name=>'Identification'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16596191473662814123)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3413432138761184593)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(16596191473662814123)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:TABLE_ATTRIBUTE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3386976797955362578)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(16596191473662814123)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P430_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3413430002096162654)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(16596191473662814123)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Attribute Default'
,p_button_position=>'NEXT'
,p_button_condition=>'P430_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3413429752498161137)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(16596191473662814123)
,p_button_name=>'PREV'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:300:&SESSION.::&DEBUG.:RP::'
,p_button_condition=>'P430_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3386977162047362581)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(16596191473662814123)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3399173202354615854)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(16596191473662814123)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Delete Attribute'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_button_condition_type=>'NEVER'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3302186049381908727)
,p_name=>'P430_PRIMARY_DISP_COL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(16596190157842814110)
,p_prompt=>'Primary Display Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P430_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P430_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3302186179851908728)
,p_name=>'P430_SECONDARY_DISP_COL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(16596190157842814110)
,p_prompt=>'Secondary Display Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P430_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P430_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3302186202907908729)
,p_name=>'P430_PRIMARY_KEY_COL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(16596190157842814110)
,p_prompt=>'Primary Key Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P430_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P430_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3302186390183908730)
,p_name=>'P430_PRIMARY_PARENT_TAB'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(16596190157842814110)
,p_prompt=>'Primary Parent Table'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_cHeight=>1
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3386978206250362593)
,p_name=>'P430_TABLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(16596190157842814110)
,p_prompt=>'Table'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3386978692839362596)
,p_name=>'P430_LABEL_SINGULAR'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(16596190157842814110)
,p_prompt=>'Label, Singular'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359248210082306)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3386979044174362597)
,p_name=>'P430_LABEL_PLURAL'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(16596190157842814110)
,p_prompt=>'Label, Plural'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(3071359248210082306)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3386979477235362598)
,p_name=>'P430_DESCRIPTION'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(16596190157842814110)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3386979869914362599)
,p_name=>'P430_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(16596190157842814110)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3019481184533899636)
,p_validation_name=>'Check for Duplicate table names'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_error_msg varchar2(255) := wwv_flow_lang.custom_runtime_message(''CA.ATTR.DEFAULT.DUPLICATE'',''table'');',
'begin',
'  for c1 in (select c001',
'             from apex_collections ',
'             where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' ',
'             and   c002 = ''TABLE''',
'             and   c003 = :P430_TABLE',
'             and   seq_id <> nvl(:P430_ID,0)',
'            ) loop',
'     return l_error_msg; ',
'  end loop;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3386981448432362612)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3386977162047362581)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3386981912464362614)
,p_event_id=>wwv_flow_api.id(3386981448432362612)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3386980650627362609)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save back to collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_name varchar2(4000) := null;',
'begin',
'for c1 in (select c001',
'           from apex_collections ',
'           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P430_ID) loop',
'   l_name := c1.c001;',
'end loop;',
'',
'if :REQUEST = ''DELETE'' then',
'    APEX_COLLECTION.DELETE_MEMBER (',
'        p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'        p_seq             => :P320_ID);',
'else',
'    if :P430_ID is not null then',
'        APEX_COLLECTION.UPDATE_MEMBER (',
'            p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'            p_seq             => :P430_ID,',
'            p_c001            => l_name,',
'            p_c002            => ''TABLE'',',
'            p_c003            => :P430_TABLE ,',
'            p_c004            => :P430_LABEL_SINGULAR,',
'            p_c005            => :P430_LABEL_PLURAL,',
'            p_c006            => :P430_PRIMARY_DISP_COL,',
'            p_c007            => :P430_SECONDARY_DISP_COL,',
'            p_c008            => :P430_PRIMARY_KEY_COL,',
'            p_c009            => :P430_PRIMARY_PARENT_TAB,',
'            p_c011            => :P430_DESCRIPTION,',
'            p_d001            => sysdate',
'            );',
'            ',
'    else',
'    ',
'        APEX_COLLECTION.ADD_MEMBER (',
'            p_collection_name => ''APEX$ATTRIBUTE_DEFAULTS'',',
'            p_c001            => l_name,',
'            p_c002            => ''TABLE'',',
'            p_c003            => :P430_TABLE ,',
'            p_c004            => :P430_LABEL_SINGULAR,',
'            p_c005            => :P430_LABEL_PLURAL,',
'            p_c006            => :P430_PRIMARY_DISP_COL,',
'            p_c007            => :P430_SECONDARY_DISP_COL,',
'            p_c008            => :P430_PRIMARY_KEY_COL,',
'            p_c009            => :P430_PRIMARY_PARENT_TAB,',
'            p_c011            => :P430_DESCRIPTION,',
'            p_d001            => sysdate',
'            );',
'    end if;',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3386981046942362610)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3386980239265362609)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch data from collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select * ',
'           from apex_collections ',
'           where collection_name = ''APEX$ATTRIBUTE_DEFAULTS'' and seq_id = :P430_ID) loop',
'   :P430_TABLE               := C1.C003; ',
'   :P430_LABEL_SINGULAR      := C1.C004;',
'   :P430_LABEL_PLURAL        := c1.C005;',
'   :P430_PRIMARY_DISP_COL    := c1.C006;',
'   :P430_SECONDARY_DISP_COL  := c1.C007;',
'   :P430_PRIMARY_KEY_COL     := c1.C008;',
'   :P430_PRIMARY_PARENT_TAB  := c1.C009;',
'   :P430_DESCRIPTION         := c1.C011;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00900
begin
wwv_flow_api.create_page(
 p_id=>900
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Help'
,p_page_mode=>'MODAL'
,p_step_title=>'Help'
,p_autocomplete_on_off=>'OFF'
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true'
,p_dialog_chained=>'N'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210615050952'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(784428987692840031)
,p_plug_name=>'Intro Help'
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.INTRO.TITLE'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.INTRO.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.INTRO.HOWTO.TITLE'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.INTRO.HOWTO.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.INTRO.RELEASE.TITLE'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.INTRO.RELEASE.DETAIL'',:RELEASE_DATE));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.INTRO.KNOWN.ISSUES.TITLE'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.INTRO.KNOWN.ISSUES.DETAIL''));',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'INTRO'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2588925584975150549)
,p_plug_name=>'Settings Help'
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.SETTINGS'')||''</h3>'');',
'sys.htp.p(''<p>''||wwv_flow_lang.custom_runtime_message(''CA.SETTINGS.DESC'')||''</p>'');',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.APPLICATION.ID'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.APPLICATION.ID.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.SCHEMA'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.SCHEMA.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.LANGUAGE'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.LANGUAGE.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.AUTHENTICATION'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.AUTHENTICATION.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.ADVANCED.SETTINGS'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.ADVANCED.SETTINGS.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.UI.DEFAULTS'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.UI.DEFAULTS.DETAIL''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'SETTINGS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2588925676389150550)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2595754206267422202)
,p_plug_name=>'Appearance Help'
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.APPEARANCE'')||''</h3>'');',
'sys.htp.p(''<p>''||wwv_flow_lang.custom_runtime_message(''CA.APPEARANCE.DESC'')||''</p>'');',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.THEME.STYLE'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.THEME.STYLE.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.NAVIGATION'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.NAVIGATION.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.APPLICATION.ICON'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.APPLICATION.ICON.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.CUSTOM.THEME'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.CUSTOM.THEME.DETAIL''));',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'UI'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2595754351455422203)
,p_plug_name=>'Features Help'
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.FEATURES'')||''</h3>'');',
'sys.htp.p(''<p>''||wwv_flow_lang.custom_runtime_message(''CA.FEATURES.DESC'')||''</p>'');',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.PWA'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.PWA.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.ABOUT.PAGE'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ABOUT.PAGE.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.ACCESS.CONTROL'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.ACCESS.CONTROL.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.ACTIVITY.REPORTING'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ACTIVITY.REPORTING.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.CONFIGURATION.SETTINGS'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.CONFIGURATION.SETTINGS.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.FEEDBACK'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.FEEDBACK.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.THEME.SELECTOR'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.THEME.SELECTOR.DETAIL''));',
'',
'',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'FEATURES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2595755838165422218)
,p_plug_name=>'Pages Help'
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.PAGES'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.PAGES.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.ADDING.PAGES'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ADDING.PAGES.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.ORGANIZING.PAGES'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ORGANIZING.PAGES.DETAIL''));',
'',
'sys.htp.p(''<h4>''||wwv_flow_lang.custom_runtime_message(''CA.REMOVING.PAGES'')||''</h4>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.REMOVING.PAGES.DETAIL''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'PAGES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2698018669168126321)
,p_plug_name=>'Page Level Help'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57830928122033942)
,p_plug_name=>'Multiple Reports Page Help'
,p_parent_plug_id=>wwv_flow_api.id(2698018669168126321)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>130
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.MULTIPLE.REPORTS'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.MULTIPLE.REPORTS.DETAILS''));',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'MULTIPLE_REPORTS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2698017996079126314)
,p_plug_name=>'Blank Page Help'
,p_parent_plug_id=>wwv_flow_api.id(2698018669168126321)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.BLANK'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.BLANK.DETAILS''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ADVANCED''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'BLANK_PAGE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2698018731554126322)
,p_plug_name=>'Chart Page Help'
,p_parent_plug_id=>wwv_flow_api.id(2698018669168126321)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.CHART'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.CHART.DETAILS''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ADVANCED''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.CHART.EXAMPLES''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'CHART_PAGE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2698018814955126323)
,p_plug_name=>'Report Page Help'
,p_parent_plug_id=>wwv_flow_api.id(2698018669168126321)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>100
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.REPORT'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.REPORT.DETAILS''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.DRILL.DOWN.LINK''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.LOOKUP.COLUMNS''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ADVANCED''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'REPORT_PAGE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2698019051695126325)
,p_plug_name=>'Interactive Grid Page Help'
,p_parent_plug_id=>wwv_flow_api.id(2698018669168126321)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>90
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.GRID'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.GRID.DETAILS''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ADVANCED''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'IG_PAGE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2698019116640126326)
,p_plug_name=>'Calendar Page Help'
,p_parent_plug_id=>wwv_flow_api.id(2698018669168126321)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.CALENDAR'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.CALENDAR.DETAILS''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ADVANCED''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'CALENDAR_PAGE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2698019235455126327)
,p_plug_name=>'Dashboard Page Help'
,p_parent_plug_id=>wwv_flow_api.id(2698018669168126321)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.DASHBOARD'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.DASHBOARD.DETAILS''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ADVANCED''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'DASHBOARD_PAGE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2707858861836463439)
,p_plug_name=>'Form Page Help'
,p_parent_plug_id=>wwv_flow_api.id(2698018669168126321)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>70
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.FORM'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.FORM.DETAILS''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'FORM_PAGE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3019481736029899642)
,p_plug_name=>'Card Page Help'
,p_parent_plug_id=>wwv_flow_api.id(2698018669168126321)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.CARD'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.CARD.DETAILS''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.DRILL.DOWN.LINK''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ADVANCED''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'CARD_PAGE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3019481836722899643)
,p_plug_name=>'Timeline Page Help'
,p_parent_plug_id=>wwv_flow_api.id(2698018669168126321)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>110
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.TIMELINE'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.TIMELINE.DETAILS''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.DRILL.DOWN.LINK''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ADVANCED''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'TIMELINE_PAGE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3019481930301899644)
,p_plug_name=>'Master Detail Page Help'
,p_parent_plug_id=>wwv_flow_api.id(2698018669168126321)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>80
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.MASTER'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.MASTER.DETAILS''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ADVANCED.PAGE_HELP''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'MASTER_DETAIL_PAGE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3613185396099513507)
,p_plug_name=>'Wizard Page Help'
,p_parent_plug_id=>wwv_flow_api.id(2698018669168126321)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>120
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.WIZARD'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.WIZARD.DETAILS''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.ADVANCED''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'WIZARD_PAGE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2796575515210751039)
,p_plug_name=>'Blueprint Help'
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.BLUEPRINT'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message(''CA.BLUEPRINT.DETAIL''));',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'BLUEPRINT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3019480338579899628)
,p_plug_name=>'Languages Help'
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.LANGUAGE'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.LANGUAGE.DETAIL''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.LANGUAGE.PAGE''));',
'',
'',
'',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3034953264948022701)
,p_plug_name=>'Advanced Settings Help'
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.ADVANCED.SETTINGS'')||''</h3>'');',
'sys.htp.p(''<p>''||wwv_flow_lang.custom_runtime_message(''CA.ADVANCED.SETTINGS.DETAIL'')||''</p>'');',
'sys.htp.p(''<p>''||wwv_flow_lang.custom_runtime_message(''CA.ADVANCED.SETTINGS.PAGE'')||''</p>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'ADVANCED'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3035688619153083805)
,p_plug_name=>'Supporting Objects Help'
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.SUPPORTING.OBJECTS'')||''</h3>'');',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.SUPPORTING.OBJECTS.DETAIL''));',
'sys.htp.p(wwv_flow_lang.custom_runtime_message (''CA.SUPPORTING.OBJECTS.PAGE''));',
'',
'',
'',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3613185016564513504)
,p_plug_name=>'Application Defaults Level'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3034953327661022702)
,p_plug_name=>'Application Defaults Help'
,p_parent_plug_id=>wwv_flow_api.id(3613185016564513504)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.DEFAULTS'')||''</h3>'');',
'sys.htp.p(''<p>''||wwv_flow_lang.custom_runtime_message(''CA.DEFAULTS.DETAIL'')||''</p>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'DEFAULTS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3348513411644390602)
,p_plug_name=>'Table Column Attribute Help'
,p_parent_plug_id=>wwv_flow_api.id(3613185016564513504)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.DEFAULTS.TABLE.COLUMN'')||''</h3>'');',
'sys.htp.p(''<p>''||wwv_flow_lang.custom_runtime_message(''CA.DEFAULTS.TABLE.COLUMN.DETAIL'')||''</p>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'TABLE_COLUMN_ATTRIBUTE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3348513524697390603)
,p_plug_name=>'LOV Attribute Help'
,p_parent_plug_id=>wwv_flow_api.id(3613185016564513504)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.DEFAULTS.LOV'')||''</h3>'');',
'sys.htp.p(''<p>''||wwv_flow_lang.custom_runtime_message(''CA.DEFAULTS.LOV.DETAIL'')||''</p>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'LOV_ATTRIBUTE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3613185101621513505)
,p_plug_name=>'Table Attribute Help'
,p_parent_plug_id=>wwv_flow_api.id(3613185016564513504)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.DEFAULTS.TABLE'')||''</h3>'');',
'sys.htp.p(''<p>''||wwv_flow_lang.custom_runtime_message(''CA.DEFAULTS.TABLE.DETAIL'')||''</p>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'TABLE_ATTRIBUTE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3613185249191513506)
,p_plug_name=>'Report Attribute Help'
,p_parent_plug_id=>wwv_flow_api.id(3613185016564513504)
,p_region_css_classes=>'a-PageWizard-dialogHelp'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<h3>''||wwv_flow_lang.custom_runtime_message(''CA.DEFAULTS.REPORT'')||''</h3>'');',
'sys.htp.p(''<p>''||wwv_flow_lang.custom_runtime_message(''CA.DEFAULTS.REPORT.DETAIL'')||''</p>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P900_HELP_SECTION'
,p_plug_display_when_cond2=>'REPORT_ATTRIBUTE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2595754126973422201)
,p_name=>'P900_HELP_SECTION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2588925676389150550)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_01000
begin
wwv_flow_api.create_page(
 p_id=>1000
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Create Page Wizard'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-WizardSteps-step.is-active .a-WizardSteps-label {',
'    display: block;',
'}',
'.a-WizardSteps-step .a-WizardSteps-label {',
'    display: none;',
'}',
'.a-PageWizard-dialog--startWizard .a-Dialog-body {display: block;}'))
,p_step_template=>wwv_flow_api.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog a-PageWizard-dialog--startWizard a-PageWizard-dialog--centeredContent'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'640'
,p_dialog_width=>'800'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210902083311'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(597621241273219128)
,p_plug_name=>'Additional Pages'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_api.id(3273871575473525717)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5521047782961084873)
,p_plug_name=>'Wizard Form'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3286693190338347807)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2578235721023427523)
,p_branch_name=>'Create Blank Page'
,p_branch_action=>'f?p=&APP_ID.:1010:&SESSION.::&DEBUG.:RP,1010::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_PAGE_TYPE'
,p_branch_condition_text=>'BLANK'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2698020755463126342)
,p_branch_name=>'Create Faceted Search Page'
,p_branch_action=>'f?p=&APP_ID.:1140:&SESSION.::&DEBUG.:RP,1140::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_PAGE_TYPE'
,p_branch_condition_text=>'FACETED_SEARCH'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2588921964261150513)
,p_branch_name=>'Create Interactive Report Page'
,p_branch_action=>'f?p=&APP_ID.:1020:&SESSION.::&DEBUG.:RP,1020:P1020_PAGE_TYPE:&P1000_PAGE_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_PAGE_TYPE'
,p_branch_condition_text=>'REPORT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(597621458148219130)
,p_branch_name=>'Create Classic Report Page'
,p_branch_action=>'f?p=&APP_ID.:1020:&SESSION.::&DEBUG.:RP,1020:P1020_PAGE_TYPE,P1020_REPORT_TYPE:REPORT,CLASSIC_RPT&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_ADDITIONAL_PAGE_TYPES'
,p_branch_condition_text=>'CLASSIC_REPORT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2594841882553086007)
,p_branch_name=>'Create Interactive Grid Page'
,p_branch_action=>'f?p=&APP_ID.:1030:&SESSION.::&DEBUG.:RP,1030:P1030_PAGE_TYPE:&P1000_PAGE_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_PAGE_TYPE'
,p_branch_condition_text=>'INTERACTIVE_GRID'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2594841993570086008)
,p_branch_name=>'Create Master Detail Page'
,p_branch_action=>'f?p=&APP_ID.:1040:&SESSION.::&DEBUG.:RP,1040:P1040_PAGE_TYPE:&P1000_PAGE_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_PAGE_TYPE'
,p_branch_condition_text=>'MASTER_DETAIL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3314909449082435901)
,p_branch_name=>'Create Form Page'
,p_branch_action=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:RP,1100:P1100_PAGE_TYPE,P1100_FORM_TYPE:&P1000_PAGE_TYPE.,FORM_ON_PAGE&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_PAGE_TYPE'
,p_branch_condition_text=>'FORM'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3314909517129435902)
,p_branch_name=>'Create Cards Page'
,p_branch_action=>'f?p=&APP_ID.:1090:&SESSION.::&DEBUG.:RP,1090:P1090_PAGE_TYPE:&P1000_PAGE_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>80
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_PAGE_TYPE'
,p_branch_condition_text=>'CARDS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2594842391030086012)
,p_branch_name=>'Create Chart Page'
,p_branch_action=>'f?p=&APP_ID.:1050:&SESSION.::&DEBUG.:RP,1050:P1050_PAGE_TYPE:&P1000_PAGE_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_PAGE_TYPE'
,p_branch_condition_text=>'CHART'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2595755545557422215)
,p_branch_name=>'Create Dashboard Page'
,p_branch_action=>'f?p=&APP_ID.:1060:&SESSION.::&DEBUG.:RP,1060:P1060_PAGE_TYPE:&P1000_PAGE_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>100
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_PAGE_TYPE'
,p_branch_condition_text=>'DASHBOARD'
,p_required_patch=>wwv_flow_api.id(2746942411136297678)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2593478104225715614)
,p_branch_name=>'Create Calendar Page'
,p_branch_action=>'f?p=&APP_ID.:1070:&SESSION.::&DEBUG.:RP,1070:P1070_PAGE_TYPE:&P1000_PAGE_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>110
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_PAGE_TYPE'
,p_branch_condition_text=>'CALENDAR'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3800179275245101)
,p_branch_name=>'Create Map Page'
,p_branch_action=>'f?p=&APP_ID.:1150:&SESSION.::&DEBUG.:RP,1150:P1150_PAGE_TYPE:&P1000_PAGE_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>120
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_PAGE_TYPE'
,p_branch_condition_text=>'MAP'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3315107867862942902)
,p_branch_name=>'Create Wizard Page'
,p_branch_action=>'f?p=&APP_ID.:1120:&SESSION.::&DEBUG.:RP,1120:P1120_PAGE_TYPE:&P1000_ADDITIONAL_PAGE_TYPES.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>130
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_ADDITIONAL_PAGE_TYPES'
,p_branch_condition_text=>'WIZARD'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3315107717051942901)
,p_branch_name=>'Create Timeline Page'
,p_branch_action=>'f?p=&APP_ID.:1110:&SESSION.::&DEBUG.:RP,1110:P1110_PAGE_TYPE:&P1000_ADDITIONAL_PAGE_TYPES.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>140
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_ADDITIONAL_PAGE_TYPES'
,p_branch_condition_text=>'TIMELINE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4212071896991544845)
,p_branch_name=>'Create Multiple Report Pages'
,p_branch_action=>'f?p=&APP_ID.:1130:&SESSION.::&DEBUG.:RP,1130::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>150
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_ADDITIONAL_PAGE_TYPES'
,p_branch_condition_text=>'MULTI_RPT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4841891610495601)
,p_branch_name=>'Create Smart Filters Page'
,p_branch_action=>'f?p=&APP_ID.:1160:&SESSION.::&DEBUG.:1160::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>160
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1000_PAGE_TYPE'
,p_branch_condition_text=>'SMART_FILTERS'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(597621334457219129)
,p_name=>'P1000_ADDITIONAL_PAGE_TYPES'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(597621241273219128)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Additional Page Types'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'P1000_MORE_PAGE_TYPES'
,p_lov=>'.'||wwv_flow_api.id(599910129386444402)||'.'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_css_classes=>'a-IconList--LargeIcons a-IconList--PageWizard a-IconList--AddPage'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2577830533539778509)
,p_name=>'P1000_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(5521047782961084873)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'P1000_PAGE_TYPES'
,p_lov=>'.'||wwv_flow_api.id(2595619325504357130)||'.'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_css_classes=>'a-IconList--LargeIcons a-IconList--PageWizard a-IconList--AddPage'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2647104303557258103)
,p_name=>'Set Theme'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2647104482047258104)
,p_event_id=>wwv_flow_api.id(2647104303557258103)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery( ''.a-IconList--wizard'' ).addClass( apex.util.getTopApex().jQuery( ''#P1_THEME_STYLE_CLASS'' ).val() );'
);
end;
/
prompt --application/pages/page_01010
begin
wwv_flow_api.create_page(
 p_id=>1010
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Create Blank Page'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Blank Page'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_PAGE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_api.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_last_upd_yyyymmddhh24miss=>'20190509085830'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2714282414911099412)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_api.id(3273871575473525717)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8109678764558259639)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8109679340901259645)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2595756247498422222)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(8109678764558259639)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1010_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1010_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2595754753405422207)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(8109679340901259645)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1010_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7261709060772831)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(8109679340901259645)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P1010_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2595756425669422224)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(8109679340901259645)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:BLANK_PAGE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2578237017465427536)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(8109679340901259645)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1010_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2588632343330174811)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(8109679340901259645)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1010_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2588632773127174813)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(8109679340901259645)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1010_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2588633535842174842)
,p_branch_name=>'Redirect to Login Page'
,p_branch_action=>'f?p=4550:1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2588632773127174813)
,p_branch_sequence=>1
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2578235418160427520)
,p_name=>'P1010_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(8109678764558259639)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2578236174264427527)
,p_name=>'P1010_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2714282414911099412)
,p_prompt=>'Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1010_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS_HOMEPAGE'
,p_lov=>'.'||wwv_flow_api.id(2639480030873536264)||'.'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1010_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2578236647392427532)
,p_name=>'P1010_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(8109678764558259639)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2595756375058422223)
,p_name=>'P1010_PAGE_ICON'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(8109678764558259639)
,p_item_default=>'fa-file-o'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2940045201067003221)
,p_name=>'P1010_ADMIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2714282414911099412)
,p_prompt=>'Administrative'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS ADMINISTRATIVE'
,p_lov=>'.'||wwv_flow_api.id(2996645622600931087)||'.'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3165198319373852601)
,p_name=>'P1010_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2714282414911099412)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2578238416659427550)
,p_name=>'Focus on Page Load'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2588920766832150501)
,p_event_id=>wwv_flow_api.id(2578238416659427550)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1010_PAGE_NAME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2647104509836258105)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2595754753405422207)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2647104607860258106)
,p_event_id=>wwv_flow_api.id(2647104509836258105)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(784429169065840033)
,p_name=>'Disable Admin'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1010_HOMEPAGE'
,p_condition_element=>'P1010_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(784429296653840034)
,p_event_id=>wwv_flow_api.id(784429169065840033)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1010_ADMIN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(784429321110840035)
,p_event_id=>wwv_flow_api.id(784429169065840033)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1010_ADMIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(784430362487840045)
,p_name=>'Disable Home Page'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1010_ADMIN'
,p_condition_element=>'P1010_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(784430410144840046)
,p_event_id=>wwv_flow_api.id(784430362487840045)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1010_HOMEPAGE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(784430522821840047)
,p_event_id=>wwv_flow_api.id(784430362487840045)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1010_HOMEPAGE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(7261168887772825)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.add_page(',
'    p_page_name        => :P1010_PAGE_NAME,',
'    p_page_type        => wwv_flow_define_app_v3.c_page_blank,',
'    p_page_icon        => :P1010_PAGE_ICON,',
'    p_is_homepage      => ( :P1010_HOMEPAGE = ''Y'' ),',
'    p_is_admin_page    => ( :P1010_ADMIN = ''Y''),',
'    p_page_help        => :P1010_PAGE_HELP);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2588632343330174811)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2578237153283427537)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.edit_page(',
'    p_page_id          => :P1010_SEQ_ID,',
'    p_page_name        => :P1010_PAGE_NAME,',
'    p_page_type        => wwv_flow_define_app_v3.c_page_blank,',
'    p_page_icon        => :P1010_PAGE_ICON,',
'    p_is_homepage      => ( :P1010_HOMEPAGE = ''Y'' ),',
'    p_is_admin_page    => ( :P1010_ADMIN = ''Y'' ),',
'    p_page_help        => :P1010_PAGE_HELP);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2578237017465427536)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(7261877275772832)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1010_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(7261709060772831)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2588921336190150507)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2650783314597687601)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Page Attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select c001 page_name,',
'                      c002 page_type,',
'                      c013 page_icon,',
'                      c015 is_admin_page,',
'                      c040 help',
'               from apex_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1010_SEQ_ID )',
'loop',
'    :P1010_PAGE_NAME := l_page.page_name;',
'    :P1010_PAGE_ICON := l_page.page_icon;',
'    :P1010_ADMIN     := l_page.is_admin_page;',
'    :P1010_PAGE_HELP := l_page.help;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1010_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2816364515854843902)
,p_process_sequence=>60
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Home Page Defaults'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1010_PAGE_NAME := ''Home'';',
':P1010_PAGE_ICON := ''fa-home'';'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1010_SEQ_ID ) ',
'   and :P1010_PAGE_NAME is null ',
'then',
'    return true;',
'else',
'    return false;',
'end if;'))
,p_process_when_type=>'FUNCTION_BODY'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_01020
begin
wwv_flow_api.create_page(
 p_id=>1020
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Create Report Page'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Report Page'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-PageWizard-dialog .a-PageWizard--collapsibleRegion.a-Region--hideShow.a-BoxedForms .a-Region-body {',
'    margin: -12px 12px 0 12px;',
'    padding-bottom: 24px;',
'}',
'.a-Region.a-BoxedForms .a-Region-body {',
'   	color: #000;',
'}'))
,p_step_template=>wwv_flow_api.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_last_upd_yyyymmddhh24miss=>'20200907060120'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(161342234287782302)
,p_plug_name=>'Lookup Columns'
,p_region_name=>'lookup_column_region'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion a-BoxedForms'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3273871575473525717)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2588922374251150517)
,p_plug_name=>'SQL Form Container'
,p_region_name=>'page_source_sql'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 12px 16px 0 16px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2588922563259150519)
,p_plug_name=>'Table or View'
,p_region_name=>'page_source_table'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2588925184942150545)
,p_plug_name=>'Table Container'
,p_parent_plug_id=>wwv_flow_api.id(2588922563259150519)
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2588925205406150546)
,p_plug_name=>'Include Form'
,p_parent_plug_id=>wwv_flow_api.id(2588922563259150519)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2588922930744150523)
,p_plug_name=>'Page Source Container'
,p_region_css_classes=>'a-BoxedLabels'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noPadding'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3096986813591966835)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3273871575473525717)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3210720104674760401)
,p_plug_name=>'Drill Down Link'
,p_region_name=>'drill_down_link_region'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion a-BoxedForms'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_api.id(3273871575473525717)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_collections',
'where collection_name = ''APEX$CREATE_APP_PAGE'' and',
'    c002 in ( ''INTERACTIVE_RPT'',  ''MASTER_DETAIL'' )'))
,p_required_patch=>wwv_flow_api.id(3145295462075987142)
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10702437105165739245)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10702437681508739251)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2671764041415861323)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(10702437105165739245)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1020_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1020_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2698016791258126302)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(10702437681508739251)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1020_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7261489151772828)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(10702437681508739251)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_condition=>'P1020_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2698315076305799695)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(10702437681508739251)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:REPORT_PAGE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2592760790910479646)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(10702437681508739251)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1020_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2592761156064479648)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(10702437681508739251)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1020_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2592761502988479649)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(10702437681508739251)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1020_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7261992641772833)
,p_name=>'P1020_REPORT_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2588922930744150523)
,p_item_default=>'INTERACTIVE_RPT'
,p_prompt=>'Report Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'REPORT_TYPES'
,p_lov=>'.'||wwv_flow_api.id(2595616854306352005)||'.'
,p_tag_css_classes=>'apex-button-group report-type'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_css_classes=>'page-source-field'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7262007597772834)
,p_name=>'P1020_INCLUDE_FORM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2588925205406150546)
,p_prompt=>'Include form'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'INCLUDE_FORM_Y'
,p_lov=>'.'||wwv_flow_api.id(2595628838376488076)||'.'
,p_tag_attributes=>'disabled'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164836609452930746)
,p_name=>'P1020_FK_COUNT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2588925184942150545)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'field--marginTop field--noBottomPadding'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2588922023118150514)
,p_name=>'P1020_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(10702437105165739245)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2588922105431150515)
,p_name=>'P1020_PAGE_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2588922930744150523)
,p_item_default=>'TABLE'
,p_prompt=>'Page Source'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SOURCE_TYPE'
,p_lov=>'.'||wwv_flow_api.id(2593539478572840546)||'.'
,p_tag_css_classes=>'apex-button-group page-source'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_css_classes=>'page-source-field'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2588922280227150516)
,p_name=>'P1020_SQL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2588922374251150517)
,p_prompt=>'SQL Query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cHeight=>14
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2588922436215150518)
,p_name=>'P1020_TABLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2588925184942150545)
,p_prompt=>'Table or View'
,p_placeholder=>'- Select Table or View -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_css_classes=>'field--marginTop field--noBottomPadding field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_item_comment=>'field--marginTop field--noBottomPadding'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2592759016419479632)
,p_name=>'P1020_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3096986813591966835)
,p_prompt=>'Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1020_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS_HOMEPAGE'
,p_lov=>'.'||wwv_flow_api.id(2639480030873536264)||'.'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1020_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2592759685908479645)
,p_name=>'P1020_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(10702437105165739245)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2592760051591479645)
,p_name=>'P1020_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(10702437105165739245)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2671764303864862891)
,p_name=>'P1020_PAGE_ICON'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(10702437105165739245)
,p_item_default=>'fa-table'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2714284610729099434)
,p_name=>'P1020_OBJ_TYPE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(10702437105165739245)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2940045540690003224)
,p_name=>'P1020_ADMIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3096986813591966835)
,p_prompt=>'Administrative'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS ADMINISTRATIVE'
,p_lov=>'.'||wwv_flow_api.id(2996645622600931087)||'.'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3145293105679922083)
,p_name=>'P1020_LINK_COLUMN'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3210720104674760401)
,p_prompt=>'Link Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1020_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1020_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_api.id(3145295462075987142)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3145296910442009602)
,p_name=>'P1020_LINK_TO_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3210720104674760401)
,p_prompt=>'Link to Page'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, n002 r ',
'from apex_collections ',
'where collection_name = ''APEX$CREATE_APP_PAGE''',
'and (   ( c002 = ''INTERACTIVE_RPT'' )',
'     or ( c002 = ''MASTER_DETAIL'' and c014 =''MD_ON_TABLE_WITH_SELECTOR'' )',
'    )',
'and ( seq_id !=  :P1020_SEQ_ID or :P1020_SEQ_ID is null )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Page -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_api.id(3145295462075987142)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3145297198215009604)
,p_name=>'P1020_LINK_KEY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3210720104674760401)
,p_prompt=>'Link Key'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1020_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT''))',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1020_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_api.id(3145295462075987142)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3145297249722009605)
,p_name=>'P1020_LINK_TARGET_KEY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3210720104674760401)
,p_prompt=>'Target Key'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (',
'    select wwv_flow_escape.html(column_name) d, column_name r, column_id n',
'    from sys.dba_tab_columns',
'    where  owner = :P1_SCHEMA and',
'           owner in (select schema',
'                     from wwv_flow_company_schemas',
'                     where security_group_id = :flow_security_group_id) and',
'           table_name = (',
'                     select max(c005) table_name',
'                     from apex_collections ',
'                     where collection_name = ''APEX$CREATE_APP_PAGE''',
'                     and n002 = :P1020_LINK_TO_PAGE',
'                     and c002 = ''INTERACTIVE_RPT''',
'                     and c003 = ''TABLE''',
'           ) and ',
'           (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE''))',
'    union all',
'    -- drill down to master detail',
'    select wwv_flow_escape.html(column_name) d, column_name r, column_id n',
'    from sys.dba_tab_columns',
'    where  owner = :P1_SCHEMA and',
'           owner in (select schema',
'                     from wwv_flow_company_schemas',
'                     where security_group_id = :flow_security_group_id) and',
'           table_name = (',
'                     select max(c005) table_name',
'                     from apex_collections ',
'                     where collection_name = ''APEX$CREATE_APP_PAGE''',
'                     and n002 = :P1020_LINK_TO_PAGE',
'                     and c002 = ''MASTER_DETAIL''',
'                     and c003 = ''TABLE''',
'           ) and ',
'           (data_type in (''CHAR'',''NCHAR'',''VARCHAR2'',''NVARCHAR2'',''NUMBER'',''BINARY_FLOAT'',''BINARY_DOUBLE''))',
'    union all ',
'    -- drill down to IR on SQL',
'    select wwv_flow_escape.html(c005) d, c005 r, seq_id n',
'    from apex_collections ',
'    where collection_name = ''APEX$CREATE_APP_PAGE_COLUMN''',
'    and n002 = :P1020_LINK_TO_PAGE',
'    and c002 = ''INTERACTIVE_RPT''',
'    and c006 in (''VARCHAR2'',''NUMBER'',''DATE'')',
'    and c003 = ''SQL'' ) x',
'order by x.n'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1020_LINK_TO_PAGE'
,p_ajax_items_to_submit=>'P1020_LINK_TO_PAGE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_api.id(3145295462075987142)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3165198538983852603)
,p_name=>'P1020_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3096986813591966835)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3692630755407728891)
,p_name=>'P1020_FK1_COL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(161342234287782302)
,p_prompt=>'Lookup Key 1'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1020_FK_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.child_column, c.position',
'from wwv_dictionary_cache_fkcon c',
'where c.child_table = :P1020_TABLE',
'and c.child_owner = :P1_SCHEMA',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1020_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3692670700243918901)
,p_name=>'P1020_FK1_DISPLAY'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(161342234287782302)
,p_prompt=>'Display Column 1'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select col.table_name||''.''||col.column_name d, col.table_name||''.''||col.column_name r',
'from sys.dba_tab_columns col,  wwv_dictionary_cache_fkcon p',
'where col.owner = p.parent_owner',
'and col.table_name = p.parent_table',
'and p.security_group_id = :flow_security_group_id',
'and p.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)',
'and p.child_owner = :P1_SCHEMA',
'and p.child_table = :P1020_TABLE',
'and p.child_column = :P1020_FK1_COL',
'order by col.column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1020_FK1_COL'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3692670801628918902)
,p_name=>'P1020_FK2_COL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(161342234287782302)
,p_prompt=>'Lookup Key 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1020_FK_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.child_column, c.position',
'from wwv_dictionary_cache_fkcon c',
'where c.child_table = :P1020_TABLE',
'and c.child_owner = :P1_SCHEMA',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1020_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3692670984817918903)
,p_name=>'P1020_FK2_DISPLAY'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(161342234287782302)
,p_prompt=>'Display Column 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select col.table_name||''.''||col.column_name d, col.table_name||''.''||col.column_name r',
'from sys.dba_tab_columns col,  wwv_dictionary_cache_fkcon p',
'where col.owner = p.parent_owner',
'and col.table_name = p.parent_table',
'and p.security_group_id = :flow_security_group_id',
'and p.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)',
'and p.child_owner = :P1_SCHEMA',
'and p.child_table = :P1020_TABLE',
'and p.child_column = :P1020_FK2_COL',
'order by col.column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1020_TABLE,P1020_FK2_COL'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4069895283933556140)
,p_name=>'P1020_FK3_COL'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(161342234287782302)
,p_prompt=>'Lookup Key 3'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1020_FK_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.child_column, c.position',
'from wwv_dictionary_cache_fkcon c',
'where c.child_table = :P1020_TABLE',
'and c.child_owner = :P1_SCHEMA',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1020_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4069895336869556141)
,p_name=>'P1020_FK3_DISPLAY'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(161342234287782302)
,p_prompt=>'Display Column 3'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select col.table_name||''.''||col.column_name d, col.table_name||''.''||col.column_name r',
'from sys.dba_tab_columns col,  wwv_dictionary_cache_fkcon p',
'where col.owner = p.parent_owner',
'and col.table_name = p.parent_table',
'and p.security_group_id = :flow_security_group_id',
'and p.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)',
'and p.child_owner = :P1_SCHEMA',
'and p.child_table = :P1020_TABLE',
'and p.child_column = :P1020_FK3_COL',
'order by col.column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1020_TABLE,P1020_FK3_COL'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4069895460860556142)
,p_name=>'P1020_FK4_COL'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(161342234287782302)
,p_prompt=>'Lookup Key 4'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1020_FK_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.child_column, c.position',
'from wwv_dictionary_cache_fkcon c',
'where c.child_table = :P1020_TABLE',
'and c.child_owner = :P1_SCHEMA',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1020_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4069895531601556143)
,p_name=>'P1020_FK4_DISPLAY'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(161342234287782302)
,p_prompt=>'Display Column 4'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select col.table_name||''.''||col.column_name d, col.table_name||''.''||col.column_name r',
'from sys.dba_tab_columns col,  wwv_dictionary_cache_fkcon p',
'where col.owner = p.parent_owner',
'and col.table_name = p.parent_table',
'and p.security_group_id = :flow_security_group_id',
'and p.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)',
'and p.child_owner = :P1_SCHEMA',
'and p.child_table = :P1020_TABLE',
'and p.child_column = :P1020_FK4_COL',
'order by col.column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1020_TABLE,P1020_FK4_COL'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1917402362739338044)
,p_validation_name=>'SQL Not Null'
,p_validation_sequence=>10
,p_validation=>'P1020_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Report SQL must be specified.'
,p_validation_condition=>'P1020_PAGE_SOURCE'
,p_validation_condition2=>'SQL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(2588922280227150516)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2594841332254086002)
,p_validation_name=>'valid query'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'    l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                            p_location             => wwv_flow_exec_api.c_location_local_db,',
'                            p_query_type           => wwv_flow_exec_api.c_query_type_sql_query,',
'                            p_sql_query            => :P1020_SQL,',
'                            p_application_id       => null,',
'                            p_parse_as_schema      => :P1_SCHEMA );',
'                            ',
'    return l_describe_result.error_message;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P1020_PAGE_SOURCE = ''SQL'' and :P1020_SQL is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2594841230551086001)
,p_validation_name=>'P1020_TABLE not null'
,p_validation_sequence=>40
,p_validation=>'P1020_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Table name must be specified.'
,p_validation_condition=>'P1020_PAGE_SOURCE'
,p_validation_condition2=>'TABLE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3674116603524496404)
,p_validation_name=>'P1020_FK1_DISPLAY not null'
,p_validation_sequence=>60
,p_validation=>'P1020_FK1_DISPLAY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P1020_FK1_COL'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3674116739747496405)
,p_validation_name=>'P1020_FK2_DISPLAY not null'
,p_validation_sequence=>90
,p_validation=>'P1020_FK2_DISPLAY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P1020_FK2_COL'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2934951585068675440)
,p_validation_name=>'P1020_LINK_COLUMN not null'
,p_validation_sequence=>100
,p_validation=>'P1020_LINK_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1020_LINK_KEY is not null or',
':P1020_LINK_TO_PAGE is not null or',
':P1020_LINK_TARGET_KEY is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3172045030132109006)
,p_validation_name=>'P1020_LINK_KEY not null'
,p_validation_sequence=>110
,p_validation=>'P1020_LINK_KEY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1020_LINK_COLUMN is not null or',
':P1020_LINK_TO_PAGE is not null or',
':P1020_LINK_TARGET_KEY is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3172045192137109007)
,p_validation_name=>'P1020_LINK_TO_PAGE not null'
,p_validation_sequence=>120
,p_validation=>'P1020_LINK_TO_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1020_LINK_COLUMN is not null or',
':P1020_LINK_KEY is not null or',
':P1020_LINK_TARGET_KEY is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3172045272382109008)
,p_validation_name=>'P1020_LINK_TARGET_KEY not null'
,p_validation_sequence=>130
,p_validation=>'P1020_LINK_TARGET_KEY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1020_LINK_COLUMN is not null or',
':P1020_LINK_KEY is not null or',
':P1020_LINK_TO_PAGE is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(524767556610188203)
,p_validation_name=>'P1020_FK3_DISPLAY not null'
,p_validation_sequence=>140
,p_validation=>'P1020_FK3_DISPLAY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P1020_FK3_COL'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(4069895336869556141)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(524767657574188204)
,p_validation_name=>'P1020_FK4_DISPLAY not null'
,p_validation_sequence=>150
,p_validation=>'P1020_FK4_DISPLAY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P1020_FK4_COL'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(4069895531601556143)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2592763122022479681)
,p_name=>'Initialize Page'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4028879176364133401)
,p_event_id=>wwv_flow_api.id(2592763122022479681)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1020_FK_COUNT'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'from wwv_dictionary_cache_fkcon c',
'where c.child_table = :P1020_TABLE',
'and c.child_owner = :P1_SCHEMA',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_attribute_07=>'P1020_TABLE'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2588922623166150520)
,p_name=>'Show Page Source'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1020_PAGE_SOURCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2588922714412150521)
,p_event_id=>wwv_flow_api.id(2588922623166150520)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var page_source_sql$ = $("#page_source_sql"),',
'    page_source_table$ = $("#page_source_table"),',
'    drill_down_link_region$ = $("#drill_down_link_region"),',
'    lookup_column_region$ = $("#lookup_column_region"),',
'    rptType = $v(''P1020_REPORT_TYPE''),',
'    pageType = $v(''P1020_PAGE_SOURCE''),',
'    fkCount = $v(''P1020_FK_COUNT'');',
'',
'if (pageType === ''SQL'') {',
'    page_source_sql$.show();',
'    page_source_table$.hide();',
'    drill_down_link_region$.hide();',
'    lookup_column_region$.hide();',
'} else if (pageType === ''TABLE'') {',
'    page_source_sql$.hide();',
'    page_source_table$.show();',
'	if (rptType === ''INTERACTIVE_RPT'') {',
'		drill_down_link_region$.show();',
'	} else {',
'		drill_down_link_region$.hide();',
'	}',
'    if (fkCount === ''0'') {',
'        lookup_column_region$.hide();',
'    } else {',
'        lookup_column_region$.show();',
'    }',
'}'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2714284462652099432)
,p_name=>'Check Object Type'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1020_TABLE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2714284589477099433)
,p_event_id=>wwv_flow_api.id(2714284462652099432)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select object_type ',
'from sys.dba_objects ',
'where owner = :P1_SCHEMA ',
'      and object_name = :P1020_TABLE',
') loop',
'    :P1020_OBJ_TYPE := c1.object_type;',
'end loop;'))
,p_attribute_02=>'P1020_TABLE'
,p_attribute_03=>'P1020_OBJ_TYPE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2698016887785126303)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2698016791258126302)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2698016913389126304)
,p_event_id=>wwv_flow_api.id(2698016887785126303)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2714285100069099439)
,p_name=>'Enable or Disable Include Form'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1020_OBJ_TYPE'
,p_condition_element=>'P1020_OBJ_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2714285223777099440)
,p_event_id=>wwv_flow_api.id(2714285100069099439)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1020_INCLUDE_FORM'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2714285556367099443)
,p_event_id=>wwv_flow_api.id(2714285100069099439)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1020_INCLUDE_FORM'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2714285429349099442)
,p_event_id=>wwv_flow_api.id(2714285100069099439)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1020_INCLUDE_FORM'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(784430682090840048)
,p_name=>'Disable Admin'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1020_HOMEPAGE'
,p_condition_element=>'P1020_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(784430732956840049)
,p_event_id=>wwv_flow_api.id(784430682090840048)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1020_ADMIN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(784430879070840050)
,p_event_id=>wwv_flow_api.id(784430682090840048)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1020_ADMIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3019477620145899601)
,p_name=>'Disable Home Page'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1020_ADMIN'
,p_condition_element=>'P1020_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3019477752300899602)
,p_event_id=>wwv_flow_api.id(3019477620145899601)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1020_HOMEPAGE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3019477891506899603)
,p_event_id=>wwv_flow_api.id(3019477620145899601)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1020_HOMEPAGE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3210720298049760402)
,p_name=>'Show or Hide Drill Down'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1020_REPORT_TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3210720372779760403)
,p_event_id=>wwv_flow_api.id(3210720298049760402)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var curItem = $v(this.triggeringElement);',
'var curType = $v(''P1020_PAGE_SOURCE'');',
'var drill_down_link_region$ = $("#drill_down_link_region");',
'',
'if (curType === ''TABLE'') {',
'	if (curItem === ''INTERACTIVE_RPT'') {',
'		drill_down_link_region$.show();',
'	} else {',
'		drill_down_link_region$.hide();',
'	}',
'}'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3674117008533496408)
,p_name=>'show hide lookup columns'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1020_TABLE'
,p_condition_element=>'P1020_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(193529846293845802)
,p_event_id=>wwv_flow_api.id(3674117008533496408)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_workspace_name varchar2(255);',
'begin',
'    l_workspace_name := htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID );',
'    wwv_dictionary_cache_dev.set_dictionary_table_cache(',
'        p_workspace_name           => l_workspace_name,',
'        p_schema                   => :P1_SCHEMA,',
'        p_table_name               => :P1020_TABLE,',
'        p_cache_fk_references     => true );',
'end;'))
,p_attribute_02=>'P1020_TABLE'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3674117138145496409)
,p_event_id=>wwv_flow_api.id(3674117008533496408)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1020_FK_COUNT'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'from wwv_dictionary_cache_fkcon c',
'where c.child_table = :P1020_TABLE',
'and c.child_owner = :P1_SCHEMA',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_attribute_07=>'P1020_TABLE'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(164836447770930744)
,p_event_id=>wwv_flow_api.id(3674117008533496408)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(161342234287782302)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775764773992368410)
,p_event_id=>wwv_flow_api.id(3674117008533496408)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1020_FK_COUNT'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'N'
,p_wait_for_result=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3775764849188368411)
,p_name=>'Display Lookup Columns'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1020_FK_COUNT'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v("P1020_FK_COUNT") > 0 '
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775764944238368412)
,p_event_id=>wwv_flow_api.id(3775764849188368411)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(161342234287782302)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775765184854368414)
,p_event_id=>wwv_flow_api.id(3775764849188368411)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(161342234287782302)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(484259742902237704)
,p_name=>'show hide lookup'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1020_REPORT_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v("P1020_FK_COUNT") > 0'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(484259864213237705)
,p_event_id=>wwv_flow_api.id(484259742902237704)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(161342234287782302)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(484259965230237706)
,p_event_id=>wwv_flow_api.id(484259742902237704)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(161342234287782302)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2592761932386479677)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_fk_list   wwv_flow_define_app_v3.t_fk_list;',
'begin',
'    if :P1020_FK1_COL is not null and :P1020_FK1_DISPLAY is not null then',
'        l_fk_list(l_fk_list.count + 1).fk_column := :P1020_FK1_COL;',
'        l_fk_list(l_fk_list.count).detail_table_display_col := :P1020_FK1_DISPLAY;',
'    end if;',
'    if :P1020_FK2_COL is not null and :P1020_FK2_DISPLAY is not null then',
'        l_fk_list(l_fk_list.count + 1).fk_column := :P1020_FK2_COL;',
'        l_fk_list(l_fk_list.count).detail_table_display_col := :P1020_FK2_DISPLAY;',
'    end if;',
'    if :P1020_FK3_COL is not null and :P1020_FK3_DISPLAY is not null then',
'        l_fk_list(l_fk_list.count + 1).fk_column := :P1020_FK3_COL;',
'        l_fk_list(l_fk_list.count).detail_table_display_col := :P1020_FK3_DISPLAY;',
'    end if;',
'    if :P1020_FK4_COL is not null and :P1020_FK4_DISPLAY is not null then',
'        l_fk_list(l_fk_list.count + 1).fk_column := :P1020_FK4_COL;',
'        l_fk_list(l_fk_list.count).detail_table_display_col := :P1020_FK4_DISPLAY;',
'    end if;',
'',
'    wwv_flow_define_app_v3.add_page(',
'         p_page_name        => :P1020_PAGE_NAME,',
'         p_page_type        => :P1020_REPORT_TYPE,',
'         p_page_icon        => :P1020_PAGE_ICON,',
'         p_schema           => :P1_SCHEMA,',
'         p_source_type      => :P1020_PAGE_SOURCE,',
'         p_source           => ( case when :P1020_PAGE_SOURCE = ''SQL'' then :P1020_SQL end ),',
'         p_table_name       => ( case when :P1020_PAGE_SOURCE = ''TABLE'' then :P1020_TABLE end ),',
'         p_include_form     => ( case when :P1020_PAGE_SOURCE = ''TABLE'' then :P1020_INCLUDE_FORM = ''Y'' end ),',
'         p_is_homepage      => ( :P1020_HOMEPAGE = ''Y'' ),',
'         p_is_admin_page    => ( :P1020_ADMIN = ''Y''),',
'         p_fk_list          => l_fk_list,',
'         --',
'         p_link_column      => :P1020_LINK_COLUMN,',
'         p_link_key         => :P1020_LINK_KEY,',
'         p_link_to_page     => :P1020_LINK_TO_PAGE,',
'         p_link_target_key  => :P1020_LINK_TARGET_KEY,',
'         p_page_help        => :P1020_PAGE_HELP );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2592761156064479648)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2592762301456479678)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_fk_list   wwv_flow_define_app_v3.t_fk_list;',
'begin',
'    if :P1020_FK1_COL is not null and :P1020_FK1_DISPLAY is not null then',
'        l_fk_list(l_fk_list.count + 1).fk_column := :P1020_FK1_COL;',
'        l_fk_list(l_fk_list.count).detail_table_display_col := :P1020_FK1_DISPLAY;',
'    end if;',
'    if :P1020_FK2_COL is not null and :P1020_FK2_DISPLAY is not null then',
'        l_fk_list(l_fk_list.count + 1).fk_column := :P1020_FK2_COL;',
'        l_fk_list(l_fk_list.count).detail_table_display_col := :P1020_FK2_DISPLAY;',
'    end if;',
'    if :P1020_FK3_COL is not null and :P1020_FK3_DISPLAY is not null then',
'        l_fk_list(l_fk_list.count + 1).fk_column := :P1020_FK3_COL;',
'        l_fk_list(l_fk_list.count).detail_table_display_col := :P1020_FK3_DISPLAY;',
'    end if;',
'    if :P1020_FK4_COL is not null and :P1020_FK4_DISPLAY is not null then',
'        l_fk_list(l_fk_list.count + 1).fk_column := :P1020_FK4_COL;',
'        l_fk_list(l_fk_list.count).detail_table_display_col := :P1020_FK4_DISPLAY;',
'    end if;',
'',
'    wwv_flow_define_app_v3.edit_page(',
'        p_page_id          => :P1020_SEQ_ID,',
'        p_page_name        => :P1020_PAGE_NAME,',
'        p_page_type        => :P1020_REPORT_TYPE,',
'        p_page_icon        => :P1020_PAGE_ICON,',
'        p_schema           => :P1_SCHEMA,',
'        p_source_type      => :P1020_PAGE_SOURCE,',
'        p_source           => ( case when :P1020_PAGE_SOURCE = ''SQL''   then :P1020_SQL end ),',
'        p_table_name       => ( case when :P1020_PAGE_SOURCE = ''TABLE'' then :P1020_TABLE end ),',
'        p_include_form     => ( case when :P1020_PAGE_SOURCE = ''TABLE'' then :P1020_INCLUDE_FORM = ''Y'' end ),',
'        p_is_homepage      => ( :P1020_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page    => ( :P1020_ADMIN = ''Y''),',
'        p_fk_list          => l_fk_list,',
'        --',
'        p_link_column      => :P1020_LINK_COLUMN,',
'        p_link_key         => :P1020_LINK_KEY,',
'        p_link_to_page     => :P1020_LINK_TO_PAGE,',
'        p_link_target_key  => :P1020_LINK_TARGET_KEY,',
'        --',
'        p_page_help        => :P1020_PAGE_HELP);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2592760790910479646)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(7261597284772829)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1020_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(7261489151772828)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2592762751551479678)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1917402084172338041)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Page Attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_cnt  pls_integer := 0;',
'begin',
'    for l_page in (select c001 page_name,',
'                          c002 page_type,',
'                          c003 source_type,',
'                          c005 table_name,',
'                          c013 page_icon,',
'                          C011 ig_is_editable,',
'                          c012 include_form,',
'                          c015 is_admin_page,',
'                          c040 help,',
'                          c041 link_column,',
'                          c042 link_key,',
'                          c043 link_to_page,',
'                          c044 link_target_key,',
'                          clob001 source,',
'                          n002    internal_page_id',
'                   from apex_collections',
'                   where collection_name = ''APEX$CREATE_APP_PAGE''',
'                   and seq_id = :P1020_SEQ_ID )',
'    loop',
'        :P1020_PAGE_NAME := l_page.page_name;',
'        :P1020_PAGE_TYPE := l_page.page_type;',
'        :P1020_REPORT_TYPE := l_page.page_type;',
'        :P1020_PAGE_ICON := l_page.page_icon;',
'        :P1020_PAGE_SOURCE := l_page.source_type;',
'        if l_page.source_type = ''TABLE'' then',
'            :P1020_TABLE := l_page.table_name;',
'            :P1020_INCLUDE_FORM := l_page.include_form;',
'        else',
'            :P1020_SQL := l_page.source;',
'        end if;',
'        :P1020_ADMIN := l_page.is_admin_page;',
'        -- drill down',
'        :P1020_LINK_COLUMN     := l_page.link_column;',
'        :P1020_LINK_KEY        := l_page.link_key;',
'        :P1020_LINK_TO_PAGE    := l_page.link_to_page;',
'        :P1020_LINK_TARGET_KEY := l_page.link_target_key;',
'        :P1020_PAGE_HELP       := l_page.help;',
'        ',
'        -- set object type (used for Include Form item)',
'        for l_obj in (',
'            select object_type ',
'            from sys.dba_objects ',
'            where owner = :P1_SCHEMA ',
'            and object_name = l_page.table_name )',
'        loop',
'            :P1020_OBJ_TYPE := l_obj.object_type;',
'        end loop;',
'    ',
'        for l_fk in (',
'            select c003            fk_column,',
'                   c005||''.''||C007 display_column',
'            from wwv_flow_collections',
'            where collection_name = ''APEX$CREATE_APP_PAGE_FK''',
'            and n002 = l_page.internal_page_id',
'            order by seq_id )',
'        loop',
'            l_cnt := l_cnt + 1;',
'            if l_cnt = 1 then',
'                :P1020_FK1_COL := l_fk.fk_column;',
'                :P1020_FK1_DISPLAY := l_fk.display_column;',
'            elsif l_cnt = 2 then',
'                :P1020_FK2_COL := l_fk.fk_column;',
'                :P1020_FK2_DISPLAY := l_fk.display_column;',
'            elsif l_cnt = 3 then',
'                :P1020_FK3_COL := l_fk.fk_column;',
'                :P1020_FK3_DISPLAY := l_fk.display_column;',
'            elsif l_cnt = 4 then',
'                :P1020_FK4_COL := l_fk.fk_column;',
'                :P1020_FK4_DISPLAY := l_fk.display_column;',
'            end if;',
'        end loop;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1020_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_01030
begin
wwv_flow_api.create_page(
 p_id=>1030
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Create Interactive Grid Page'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Interactive Grid Page'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-WizardSteps-step.is-active .a-WizardSteps-label {',
'    display: block;',
'}',
'.a-WizardSteps-step .a-WizardSteps-label {',
'    display: none;',
'}'))
,p_step_template=>wwv_flow_api.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_last_upd_yyyymmddhh24miss=>'20200907060142'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3096986940908966836)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3273871575473525717)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5209282746703118901)
,p_plug_name=>'SQL Form Container'
,p_region_name=>'page_source_sql'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 12px 16px 0 16px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5209283303196118907)
,p_plug_name=>'Page Source Container'
,p_region_css_classes=>'a-BoxedLabels'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noPadding'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5209285557394118929)
,p_plug_name=>'Table Container'
,p_region_name=>'page_source_table'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13322797477617707629)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13322798053960707635)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2671789543360157933)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(13322797477617707629)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1030_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1030_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2698017027394126305)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(13322798053960707635)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1030_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2620363606665968428)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(13322798053960707635)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_condition=>'P1030_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2698315796021803108)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(13322798053960707635)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:IG_PAGE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2620363965012968430)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(13322798053960707635)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1030_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2620364307266968431)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(13322798053960707635)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1030_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2620364759002968431)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(13322798053960707635)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1030_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2620376281143968497)
,p_branch_name=>'Redirect to Login Page'
,p_branch_action=>'f?p=4550:1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2620364759002968431)
,p_branch_sequence=>1
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2620361070869968411)
,p_name=>'P1030_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3096986940908966836)
,p_prompt=>'Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1030_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS_HOMEPAGE'
,p_lov=>'.'||wwv_flow_api.id(2639480030873536264)||'.'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1030_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2620361747958968424)
,p_name=>'P1030_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(13322797477617707629)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2620362127911968425)
,p_name=>'P1030_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(13322797477617707629)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2620362596892968425)
,p_name=>'P1030_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(13322797477617707629)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2620365401635968434)
,p_name=>'P1030_SQL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(5209282746703118901)
,p_prompt=>'SQL Query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cHeight=>14
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2620366463781968436)
,p_name=>'P1030_TABLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(5209285557394118929)
,p_prompt=>'Table or View'
,p_placeholder=>'- Select Table or View -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2620367820576968439)
,p_name=>'P1030_PAGE_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(5209283303196118907)
,p_item_default=>'TABLE'
,p_prompt=>'Page Source'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SOURCE_TYPE'
,p_lov=>'.'||wwv_flow_api.id(2593539478572840546)||'.'
,p_tag_css_classes=>'apex-button-group page-source'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_css_classes=>'page-source-field'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2620368548967968440)
,p_name=>'P1030_IG_EDITABLE_YN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(5209283303196118907)
,p_item_default=>'Y'
,p_prompt=>'Data Editing'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:&APP_TEXT$IG_ALLOW_EDITING.;Y,&APP_TEXT$IG_READ_ONLY.;N'
,p_tag_css_classes=>'apex-button-group'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_css_classes=>'page-source-field '
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2671789034358154476)
,p_name=>'P1030_PAGE_ICON'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(13322797477617707629)
,p_item_default=>'fa-table-pointer'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2940045628659003225)
,p_name=>'P1030_ADMIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3096986940908966836)
,p_prompt=>'Administrative'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS ADMINISTRATIVE'
,p_lov=>'.'||wwv_flow_api.id(2996645622600931087)||'.'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3165198615195852604)
,p_name=>'P1030_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3096986940908966836)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2620369451280968470)
,p_validation_name=>'SQL Not Null'
,p_validation_sequence=>10
,p_validation=>'P1030_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Report SQL must be specified.'
,p_validation_condition=>'P1030_PAGE_SOURCE'
,p_validation_condition2=>'SQL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(2620365401635968434)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2620370612340968476)
,p_validation_name=>'valid query'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'    l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                            p_location             => wwv_flow_exec_api.c_location_local_db,',
'                            p_query_type           => wwv_flow_exec_api.c_query_type_sql_query,',
'                            p_sql_query            => :P1030_SQL,',
'                            p_application_id       => null,',
'                            p_parse_as_schema      => :P1_SCHEMA );',
'                            ',
'    return l_describe_result.error_message;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P1030_PAGE_SOURCE = ''SQL'' and :P1030_SQL is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2620370256129968476)
,p_validation_name=>'P1030_TABLE not null'
,p_validation_sequence=>40
,p_validation=>'P1030_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Table name must be specified.'
,p_validation_condition=>'P1030_PAGE_SOURCE'
,p_validation_condition2=>'TABLE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2620374385077968493)
,p_name=>'Initialize Page'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2620374812216968493)
,p_event_id=>wwv_flow_api.id(2620374385077968493)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1030_PAGE_NAME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2620375219790968493)
,p_name=>'Show Page Source'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1030_PAGE_SOURCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2620375713529968494)
,p_event_id=>wwv_flow_api.id(2620375219790968493)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($v(this.triggeringElement) === ''SQL'') {',
'    $("#page_source_sql").show();',
'    $("#page_source_table").hide();',
'} else if ($v(this.triggeringElement) === ''TABLE'') {',
'    $("#page_source_sql").hide();',
'    $("#page_source_table").show();',
'}'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2698017159231126306)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2698017027394126305)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2698017213884126307)
,p_event_id=>wwv_flow_api.id(2698017159231126306)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3019477985806899604)
,p_name=>'Disable Admin'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1030_HOMEPAGE'
,p_condition_element=>'P1030_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3019478057964899605)
,p_event_id=>wwv_flow_api.id(3019477985806899604)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1030_ADMIN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3019478137839899606)
,p_event_id=>wwv_flow_api.id(3019477985806899604)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1030_ADMIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3019478223224899607)
,p_name=>'Disable Home Page'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1030_ADMIN'
,p_condition_element=>'P1030_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3019478333617899608)
,p_event_id=>wwv_flow_api.id(3019478223224899607)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1030_HOMEPAGE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3019478491854899609)
,p_event_id=>wwv_flow_api.id(3019478223224899607)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1030_HOMEPAGE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2620371727718968477)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_page_id   number;',
'begin',
'    l_page_id := wwv_flow_define_app_v3.add_page(',
'                     p_page_name        => :P1030_PAGE_NAME,',
'                     p_page_type        => :P1030_PAGE_TYPE,',
'                     p_page_icon        => :P1030_PAGE_ICON,',
'                     p_schema           => :P1_SCHEMA,',
'                     p_source_type      => :P1030_PAGE_SOURCE,',
'                     p_source           => ( case when :P1030_PAGE_SOURCE = ''SQL'' then :P1030_SQL end ),',
'                     p_table_name       => ( case when :P1030_PAGE_SOURCE = ''TABLE'' then :P1030_TABLE end ),',
'                     p_ig_is_editable   => ( :P1030_IG_EDITABLE_YN = ''Y'' ),',
'                     p_is_homepage      => ( :P1030_HOMEPAGE = ''Y'' ),',
'                     p_is_admin_page    => ( :P1030_ADMIN = ''Y''),',
'                     p_page_help        => :P1030_PAGE_HELP );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2620364307266968431)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2620372135306968478)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.edit_page(',
'    p_page_id          => :P1030_SEQ_ID,',
'    p_page_name        => :P1030_PAGE_NAME,',
'    p_page_type        => :P1030_PAGE_TYPE,',
'    p_page_icon        => :P1030_PAGE_ICON,',
'    p_schema           => :P1_SCHEMA,',
'    p_source_type      => :P1030_PAGE_SOURCE,',
'    p_source           => ( case when :P1030_PAGE_SOURCE = ''SQL'' then :P1030_SQL end ),',
'    p_table_name       => ( case when :P1030_PAGE_SOURCE = ''TABLE'' then :P1030_TABLE end ),',
'    p_ig_is_editable   => ( :P1030_IG_EDITABLE_YN = ''Y'' ),',
'    p_is_homepage      => ( :P1030_HOMEPAGE = ''Y'' ),',
'    p_is_admin_page    => ( :P1030_ADMIN = ''Y''),',
'    p_page_help        => :P1030_PAGE_HELP);',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2620363965012968430)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2620370923417968477)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1030_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2620363606665968428)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2620372574722968478)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2620371358169968477)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select c001 page_name,',
'                      c002 page_type,',
'                      c003 source_type,',
'                      c005 table_name,',
'                      c011 ig_is_editable,',
'                      c012 include_form,',
'                      c013 page_icon,',
'                      c015 is_admin_page,',
'                      c040 help,',
'                      clob001 source',
'               from apex_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1030_SEQ_ID )',
'loop',
'    :P1030_PAGE_NAME := l_page.page_name;',
'    :P1030_PAGE_TYPE := l_page.page_type;',
'    :P1030_PAGE_ICON := l_page.page_icon;',
'    :P1030_PAGE_SOURCE := l_page.source_type;',
'    if l_page.source_type = ''TABLE'' then',
'        :P1030_TABLE := l_page.table_name;',
'    else',
'        :P1030_SQL := l_page.source;',
'    end if;',
'    :P1030_IG_EDITABLE_YN := l_page.ig_is_editable;',
'    :P1030_ADMIN := l_page.is_admin_page;',
'    :P1030_PAGE_HELP := l_page.help;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1030_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_01040
begin
wwv_flow_api.create_page(
 p_id=>1040
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Master Detail Page'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Master Detail Page'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.apex-button-group table {',
'    border-spacing: 0;',
'}'))
,p_step_template=>wwv_flow_api.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'520'
,p_dialog_width=>'800'
,p_dialog_attributes=>'resizable:true'
,p_last_upd_yyyymmddhh24miss=>'20200902161156'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2940043412213003203)
,p_plug_name=>'Component Type'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin-left: 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_grid_column_span=>4
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_required_patch=>wwv_flow_api.id(366100516974803533)
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3096987050948966837)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3273871575473525717)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7848768047077673684)
,p_plug_name=>'Table Container'
,p_region_name=>'page_source_table'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3055104276958555201)
,p_plug_name=>'Switch Container'
,p_parent_plug_id=>wwv_flow_api.id(7848768047077673684)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3055104370263555202)
,p_plug_name=>'Form Container'
,p_parent_plug_id=>wwv_flow_api.id(7848768047077673684)
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15962279967301262384)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15962280543644262390)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2671801985743376320)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(15962279967301262384)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1040_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1040_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2698017645866126311)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(15962280543644262390)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1040_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2639485336716554781)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(15962280543644262390)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_condition=>'P1040_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2698316230651804379)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(15962280543644262390)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:MASTER_DETAIL_PAGE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2639485718498554783)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(15962280543644262390)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1040_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2639486124889554784)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(15962280543644262390)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1040_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2639486580151554784)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(15962280543644262390)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1040_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2639495883273554816)
,p_branch_name=>'Redirect to Login Page'
,p_branch_action=>'f?p=4550:1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2639486580151554784)
,p_branch_sequence=>1
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2574075162235843409)
,p_name=>'P1040_OPTION'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(3055104276958555201)
,p_item_default=>'EDIT_ONLY'
,p_prompt=>'Option'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC:Edit Only;EDIT_ONLY,Read and Edit;READ_AND_EDIT'
,p_tag_css_classes=>'apex-button-group report-type'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(2588818597804368344)
,p_item_css_classes=>'page-source-field'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_required_patch=>wwv_flow_api.id(2698024371153404344)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2594842701044086016)
,p_name=>'P1040_PAGE_SOURCE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(15962279967301262384)
,p_item_default=>'TABLE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2639483117670554773)
,p_name=>'P1040_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3096987050948966837)
,p_prompt=>'Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1040_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS_HOMEPAGE'
,p_lov=>'.'||wwv_flow_api.id(2639480030873536264)||'.'
,p_display_when_type=>'NEVER'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1040_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2639483839061554780)
,p_name=>'P1040_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(15962279967301262384)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2639484261945554780)
,p_name=>'P1040_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(15962279967301262384)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2639484696211554780)
,p_name=>'P1040_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(15962279967301262384)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2639488256403554787)
,p_name=>'P1040_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3055104370263555202)
,p_prompt=>'Table'
,p_placeholder=>'- Select Table or View -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table -'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2671801686921375222)
,p_name=>'P1040_PAGE_ICON'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(15962279967301262384)
,p_item_default=>'fa-layout-header-sidebar-left'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2927878671232772201)
,p_name=>'P1040_DETAIL_1'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3055104370263555202)
,p_prompt=>'Detail Table'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1040_DETAIL_TABLES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select child_table',
'from wwv_dictionary_cache_fkcon c',
'where c.parent_table = :P1040_TABLE',
'and c.parent_owner = :P1_SCHEMA',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table -'
,p_lov_cascade_parent_items=>'P1040_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2927878762313772202)
,p_name=>'P1040_DETAIL_2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(3055104370263555202)
,p_prompt=>'Detail Table 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1040_DETAIL_TABLES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select child_table',
'from wwv_dictionary_cache_fkcon c',
'where c.parent_table = :P1040_TABLE',
'and c.parent_owner = :P1_SCHEMA',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table -'
,p_lov_cascade_parent_items=>'P1040_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2927878857943772203)
,p_name=>'P1040_DETAIL_3'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(3055104370263555202)
,p_prompt=>'Detail Table 3'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1040_DETAIL_TABLES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select child_table',
'from wwv_dictionary_cache_fkcon c',
'where c.parent_table = :P1040_TABLE',
'and c.parent_owner = :P1_SCHEMA',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table -'
,p_lov_cascade_parent_items=>'P1040_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2927878904909772204)
,p_name=>'P1040_DETAIL_4'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(3055104370263555202)
,p_prompt=>'Detail Table 4'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1040_DETAIL_TABLES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select child_table',
'from wwv_dictionary_cache_fkcon c',
'where c.parent_table = :P1040_TABLE',
'and c.parent_owner = :P1_SCHEMA',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table -'
,p_lov_cascade_parent_items=>'P1040_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2940043313717003202)
,p_name=>'P1040_FORM_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2940043412213003203)
,p_item_default=>'MD_ON_TABLE_WITH_SELECTOR'
,p_prompt=>'Form Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'FORM_TYPES'
,p_lov=>'.'||wwv_flow_api.id(2942439030918347706)||'.'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_css_classes=>'a-IconList--SmallWizard a-IconList--stackedItems a-Form-fieldContainer--noPadding'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2940045864148003227)
,p_name=>'P1040_ADMIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3096987050948966837)
,p_prompt=>'Administrative'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS ADMINISTRATIVE'
,p_lov=>'.'||wwv_flow_api.id(2996645622600931087)||'.'
,p_begin_on_new_line=>'N'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2940047004127003239)
,p_name=>'P1040_PRIMARY_LABEL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3055104370263555202)
,p_prompt=>'Primary Display Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1040_TABLE',
'  and (data_type in (''VARCHAR2'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Label Column -'
,p_lov_cascade_parent_items=>'P1040_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_api.id(366100516974803533)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2940047166449003240)
,p_name=>'P1040_SECONDARY_LABEL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3055104370263555202)
,p_prompt=>'Secondary Display Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1040_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Label Column -'
,p_lov_cascade_parent_items=>'P1040_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_api.id(366100516974803533)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3165198702245852605)
,p_name=>'P1040_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3096987050948966837)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2639491275696554805)
,p_validation_name=>'P1040_TABLE not null'
,p_validation_sequence=>40
,p_validation=>'P1040_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Table name must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3096987439653966841)
,p_validation_name=>'Primary Label cannot be null'
,p_validation_sequence=>60
,p_validation=>'P1040_PRIMARY_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Primary Display Column cannot be null'
,p_validation_condition=>'P1040_FORM_TYPE'
,p_validation_condition2=>'MD_ON_TABLE_WITH_SELECTOR'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(2940047004127003239)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3096987600561966843)
,p_validation_name=>'Secondary Label cannot be null'
,p_validation_sequence=>70
,p_validation=>'P1040_SECONDARY_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Secondary Display Column cannot be null'
,p_validation_condition=>'P1040_FORM_TYPE'
,p_validation_condition2=>'MD_ON_TABLE_WITH_SELECTOR'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(2940047166449003240)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2934950514946675430)
,p_validation_name=>'detail table not null'
,p_validation_sequence=>80
,p_validation=>'P1040_DETAIL_1'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2639493996827554812)
,p_name=>'Initialize Page'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2639494408792554814)
,p_event_id=>wwv_flow_api.id(2639493996827554812)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_PAGE_NAME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2639494863780554815)
,p_name=>'Show Page Source'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1040_PAGE_SOURCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2639495382898554815)
,p_event_id=>wwv_flow_api.id(2639494863780554815)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($v(this.triggeringElement) === ''SQL'') {',
'    $("#page_source_sql").show();',
'    $("#page_source_table").hide();',
'} else if ($v(this.triggeringElement) === ''TABLE'') {',
'    $("#page_source_sql").hide();',
'    $("#page_source_table").show();',
'}'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2698017785855126312)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2698017645866126311)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2698017852618126313)
,p_event_id=>wwv_flow_api.id(2698017785855126312)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2934948644852675411)
,p_name=>'Handle MD Type'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1040_FORM_TYPE'
,p_condition_element=>'P1040_FORM_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'MD_GRID'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_required_patch=>wwv_flow_api.id(366100516974803533)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2934948736100675412)
,p_event_id=>wwv_flow_api.id(2934948644852675411)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_PRIMARY_LABEL,P1040_SECONDARY_LABEL,P1040_DETAIL_2,P1040_DETAIL_3,P1040_DETAIL_4'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2934948808362675413)
,p_event_id=>wwv_flow_api.id(2934948644852675411)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_PRIMARY_LABEL,P1040_SECONDARY_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3454843493582233103)
,p_event_id=>wwv_flow_api.id(2934948644852675411)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_DETAIL_2,P1040_DETAIL_3,P1040_DETAIL_4'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3019478590222899610)
,p_name=>'Disable Admin'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1040_HOMEPAGE'
,p_condition_element=>'P1040_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3019478626438899611)
,p_event_id=>wwv_flow_api.id(3019478590222899610)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_ADMIN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3019478790621899612)
,p_event_id=>wwv_flow_api.id(3019478590222899610)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_ADMIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3019478806723899613)
,p_name=>'Disable Home Page'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1040_ADMIN'
,p_condition_element=>'P1040_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3019478947984899614)
,p_event_id=>wwv_flow_api.id(3019478806723899613)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_HOMEPAGE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3019479049588899615)
,p_event_id=>wwv_flow_api.id(3019478806723899613)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_HOMEPAGE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2996641202568931007)
,p_name=>'Toggle Details 2'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1040_DETAIL_1'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v(''P1040_DETAIL_1'') !== '''' && $v(''P1040_FORM_TYPE'') !== ''MD_GRID'''
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2996641341760931008)
,p_event_id=>wwv_flow_api.id(2996641202568931007)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_DETAIL_2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2996641405213931009)
,p_event_id=>wwv_flow_api.id(2996641202568931007)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_DETAIL_2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2996641754503931012)
,p_name=>'Toggle Details 3'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1040_DETAIL_2'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v(''P1040_DETAIL_2'') !== '''' && $v(''P1040_FORM_TYPE'') !== ''MD_GRID'''
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2996641876475931013)
,p_event_id=>wwv_flow_api.id(2996641754503931012)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_DETAIL_3'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2996641955014931014)
,p_event_id=>wwv_flow_api.id(2996641754503931012)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_DETAIL_3'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2996642030588931015)
,p_name=>'Toggle Details 4'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1040_DETAIL_3'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v(''P1040_DETAIL_3'') !== '''' && $v(''P1040_FORM_TYPE'') !== ''MD_GRID'''
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2996642147835931016)
,p_event_id=>wwv_flow_api.id(2996642030588931015)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_DETAIL_4'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2996642233838931017)
,p_event_id=>wwv_flow_api.id(2996642030588931015)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_DETAIL_4'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(193529976800845803)
,p_name=>'Set data dictionary cache if table chang'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1040_TABLE'
,p_condition_element=>'P1040_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(193530037006845804)
,p_event_id=>wwv_flow_api.id(193529976800845803)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_workspace_name varchar2(255);',
'begin',
'    l_workspace_name := htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID );',
'    wwv_dictionary_cache_dev.set_dictionary_table_cache(',
'        p_workspace_name           => l_workspace_name,',
'        p_schema                   => :P1_SCHEMA,',
'        p_table_name               => :P1040_TABLE,',
'        p_cache_fk_references      => true,',
'        p_cache_child_tables       => true );',
'end;'))
,p_attribute_02=>'P1040_TABLE'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(632193606778032127)
,p_event_id=>wwv_flow_api.id(193529976800845803)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1040_DETAIL_1,P1040_DETAIL_2,P1040_DETAIL_3,P1040_DETAIL_4'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2639492727480554810)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_page_id           number;',
'    l_md                wwv_flow_define_app_v3.t_md;',
'    l_detail_table_list wwv_flow_define_app_v3.t_table_list;',
'begin',
'    l_md.primary_label_column := :P1040_PRIMARY_LABEL;',
'    l_md.secondary_label_column := :P1040_SECONDARY_LABEL;',
'    ',
'    l_detail_table_list(l_detail_table_list.count + 1) := :P1040_DETAIL_1;',
'    if :P1040_DETAIL_2 != :P1040_DETAIL_1 or :P1040_DETAIL_2 != :P1040_DETAIL_3 or :P1040_DETAIL_2 != :P1040_DETAIL_4 then',
'        l_detail_table_list(l_detail_table_list.count + 1) := :P1040_DETAIL_2;',
'    end if;',
'    if :P1040_DETAIL_3 != :P1040_DETAIL_1 or :P1040_DETAIL_3 != :P1040_DETAIL_2 or :P1040_DETAIL_3 != :P1040_DETAIL_4 then',
'        l_detail_table_list(l_detail_table_list.count + 1) := :P1040_DETAIL_3;',
'    end if;',
'    if :P1040_DETAIL_4 != :P1040_DETAIL_1 or :P1040_DETAIL_4 != :P1040_DETAIL_2 or :P1040_DETAIL_4 != :P1040_DETAIL_3 then',
'        l_detail_table_list(l_detail_table_list.count + 1) := :P1040_DETAIL_4;',
'    end if;',
'    ',
'    l_page_id := wwv_flow_define_app_v3.add_page(',
'                     p_page_name         => :P1040_PAGE_NAME,',
'                     p_page_type         => :P1040_PAGE_TYPE,',
'                     p_page_icon         => :P1040_PAGE_ICON,',
'                     p_schema            => :P1_SCHEMA,',
'                     p_source_type       => :P1040_PAGE_SOURCE,',
'                     p_table_name        => ( case when :P1040_PAGE_SOURCE = ''TABLE'' then :P1040_TABLE end ),',
'                     p_is_homepage       => ( :P1040_HOMEPAGE = ''Y'' ),',
'                     p_is_admin_page     => ( :P1040_ADMIN = ''Y''),',
'                     p_form_type         => :P1040_FORM_TYPE,',
'                     p_md                => l_md,',
'                     p_detail_table_list => l_detail_table_list,',
'                     p_page_help         => :P1040_PAGE_HELP);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2639486124889554784)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2639493194754554810)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_detail_table_list wwv_flow_define_app_v3.t_table_list;',
'    l_md                wwv_flow_define_app_v3.t_md;',
'begin',
'    l_md.primary_label_column   := :P1040_PRIMARY_LABEL;',
'    l_md.secondary_label_column := :P1040_SECONDARY_LABEL;',
'    --insert into x (m) values (''l_md.secondary_label_column=''||l_md.secondary_label_column);',
'    ',
'    l_detail_table_list(l_detail_table_list.count + 1) := :P1040_DETAIL_1;',
'    if :P1040_DETAIL_2 != :P1040_DETAIL_1 or :P1040_DETAIL_2 != :P1040_DETAIL_3 or :P1040_DETAIL_2 != :P1040_DETAIL_4 then',
'        l_detail_table_list(l_detail_table_list.count + 1) := :P1040_DETAIL_2;',
'    end if;',
'    if :P1040_DETAIL_3 != :P1040_DETAIL_1 or :P1040_DETAIL_3 != :P1040_DETAIL_2 or :P1040_DETAIL_3 != :P1040_DETAIL_4 then',
'        l_detail_table_list(l_detail_table_list.count + 1) := :P1040_DETAIL_3;',
'    end if;',
'    if :P1040_DETAIL_4 != :P1040_DETAIL_1 or :P1040_DETAIL_4 != :P1040_DETAIL_2 or :P1040_DETAIL_4 != :P1040_DETAIL_3 then',
'        l_detail_table_list(l_detail_table_list.count + 1) := :P1040_DETAIL_4;',
'    end if;',
'    ',
'    wwv_flow_define_app_v3.edit_page(',
'        p_page_id           => :P1040_SEQ_ID,',
'        p_page_name         => :P1040_PAGE_NAME,',
'        p_page_type         => :P1040_PAGE_TYPE,',
'        p_page_icon         => :P1040_PAGE_ICON,',
'        p_schema            => :P1_SCHEMA,',
'        p_source_type       => :P1040_PAGE_SOURCE,',
'        p_table_name        => :P1040_TABLE,',
'        p_is_homepage       => ( :P1040_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page     => ( :P1040_ADMIN = ''Y'' ),',
'        p_form_type         => :P1040_FORM_TYPE,',
'        p_md                => l_md,',
'        p_detail_table_list => l_detail_table_list,',
'        p_page_help         => :P1040_PAGE_HELP);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2639485718498554783)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2639491965325554808)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1040_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2639485336716554781)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2639493564646554811)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2639492378581554808)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select c001 page_name,',
'                      c002 page_type,',
'                      ''TABLE'' source_type,',
'                      c005 table_name,',
'                      c013 page_icon,',
'                      c014 form_type,',
'                      c015 is_admin_page,',
'                      c016 primary_label_col,',
'                      c017 secondary_label_col,',
'                      c025 detail_1,',
'                      c026 detail_2,',
'                      c027 detail_3,',
'                      c028 detail_4,',
'                      c040 help',
'               from apex_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1040_SEQ_ID )',
'loop',
'    :P1040_PAGE_NAME := l_page.page_name;',
'    :P1040_PAGE_TYPE := l_page.page_type;',
'    :P1040_PAGE_SOURCE := l_page.source_type;',
'    :P1040_TABLE := l_page.table_name;',
'    :P1040_PAGE_ICON := l_page.page_icon;',
'    :P1040_FORM_TYPE := l_page.form_type;',
'    ',
'    :P1040_PRIMARY_LABEL := l_page.primary_label_col;',
'    :P1040_SECONDARY_LABEL := l_page.secondary_label_col;',
'    ',
'    :P1040_DETAIL_1 := l_page.detail_1;',
'    :P1040_DETAIL_2 := l_page.detail_2;',
'    :P1040_DETAIL_3 := l_page.detail_3;',
'    :P1040_DETAIL_4 := l_page.detail_4;',
'    ',
'    :P1040_ADMIN := l_page.is_admin_page;',
'    :P1040_PAGE_HELP := l_page.help;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1040_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_01050
begin
wwv_flow_api.create_page(
 p_id=>1050
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Create Chart Page'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Chart Page'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'initWizardModal = function() {',
'    function _initDialog() {',
'        var headerheight = $(''.a-Dialog-wizardSteps'').height(),',
'            footerheight = $(''.a-Dialog-footer'').height();',
'        $(''.a-Dialog-body'').css({',
'            ''top'':headerheight,',
'            ''bottom'':footerheight',
'        });',
'    }',
'    $(window).bind(''apexwindowresized'', function() {',
'        _initDialog();',
'    });',
'    _initDialog();',
'};'))
,p_javascript_code_onload=>'initWizardModal();'
,p_step_template=>wwv_flow_api.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'520'
,p_dialog_width=>'800'
,p_last_upd_yyyymmddhh24miss=>'20190603034432'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2594842049919086009)
,p_plug_name=>'Chart Type'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin-left: 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3096987189025966838)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3273871575473525717)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10488286239238324054)
,p_plug_name=>'Chart Items'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin-right: 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_grid_column_span=>8
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18601798159461912754)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18601798735804912760)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2671803432393386955)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(18601798159461912754)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1050_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1050_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2593477821069715611)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(18601798735804912760)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1050_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2639521574533650398)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(18601798735804912760)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_condition=>'P1050_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2698316596757805321)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(18601798735804912760)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:CHART_PAGE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2639521904729650400)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(18601798735804912760)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1050_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2639522360799650400)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(18601798735804912760)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1050_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2639522706259650400)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(18601798735804912760)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1050_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2639528374900650428)
,p_branch_name=>'Redirect to Login Page'
,p_branch_action=>'f?p=4550:1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2639522706259650400)
,p_branch_sequence=>1
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2594842156498086010)
,p_name=>'P1050_CHART_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2594842049919086009)
,p_item_default=>'area'
,p_prompt=>'Chart Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'JET_CHART_GALLERY'
,p_lov=>'.'||wwv_flow_api.id(2639572067402672315)||'.'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_css_classes=>'a-IconList--SmallWizard a-Form-fieldContainer--noPadding'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2594842456077086013)
,p_name=>'P1050_LABEL_COL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(10488286239238324054)
,p_prompt=>'Label Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1050_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1050_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2594842500048086014)
,p_name=>'P1050_VALUE_COL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(10488286239238324054)
,p_prompt=>'Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1050_TABLE',
'  and data_type in (''NUMBER'',''FLOAT'')',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1050_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2594842862730086017)
,p_name=>'P1050_PAGE_SOURCE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(18601798159461912754)
,p_item_default=>'TABLE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2594843297167086021)
,p_name=>'P1050_VALUE_COL_COUNT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(10488286239238324054)
,p_prompt=>'Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1050_TABLE',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'All Columns'
,p_lov_null_value=>'ALL$COL'
,p_lov_cascade_parent_items=>'P1050_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2595756113911422221)
,p_name=>'P1050_AGGREGATE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(10488286239238324054)
,p_prompt=>'Aggregate'
,p_source=>'COLVALUE'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CHART_AGGREGATIONS'
,p_lov=>'.'||wwv_flow_api.id(2647168809994648252)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_css_classes=>'a-Form-fieldContainer--withOutlineFields'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2639518926167650387)
,p_name=>'P1050_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3096987189025966838)
,p_prompt=>'Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1050_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS_HOMEPAGE'
,p_lov=>'.'||wwv_flow_api.id(2639480030873536264)||'.'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1050_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2639520021600650396)
,p_name=>'P1050_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(18601798159461912754)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2639520496632650397)
,p_name=>'P1050_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(18601798159461912754)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2639520816555650397)
,p_name=>'P1050_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(18601798159461912754)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2639523780856650402)
,p_name=>'P1050_TABLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(10488286239238324054)
,p_prompt=>'Table or View'
,p_placeholder=>'- Select Table or View -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2671803192866385840)
,p_name=>'P1050_PAGE_ICON'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(18601798159461912754)
,p_item_default=>'fa-area-chart'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2940045451585003223)
,p_name=>'P1050_ADMIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3096987189025966838)
,p_prompt=>'Administrative'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS ADMINISTRATIVE'
,p_lov=>'.'||wwv_flow_api.id(2996645622600931087)||'.'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3165198803153852606)
,p_name=>'P1050_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3096987189025966838)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2594842989466086018)
,p_validation_name=>'table not null'
,p_validation_sequence=>10
,p_validation=>'P1050_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2594843059697086019)
,p_validation_name=>'value column not null'
,p_validation_sequence=>20
,p_validation=>'P1050_VALUE_COL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1050_AGGREGATE != ''COUNT'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2594843115955086020)
,p_validation_name=>'label column not null'
,p_validation_sequence=>30
,p_validation=>'P1050_LABEL_COL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2639527328628650427)
,p_name=>'Initialize Page'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2639527850148650427)
,p_event_id=>wwv_flow_api.id(2639527328628650427)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1050_PAGE_NAME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2639526447938650424)
,p_name=>'Show Page Source'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1050_PAGE_SOURCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2639526976903650426)
,p_event_id=>wwv_flow_api.id(2639526447938650424)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($v(this.triggeringElement) === ''SQL'') {',
'    $("#page_source_sql").show();',
'    $("#page_source_table").hide();',
'} else if ($v(this.triggeringElement) === ''TABLE'') {',
'    $("#page_source_sql").hide();',
'    $("#page_source_table").show();',
'}'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2593477900416715612)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2593477821069715611)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2593478072345715613)
,p_event_id=>wwv_flow_api.id(2593477900416715612)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2594843352995086022)
,p_name=>'show value column count'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1050_AGGREGATE'
,p_condition_element=>'P1050_AGGREGATE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'COUNT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2594843410985086023)
,p_event_id=>wwv_flow_api.id(2594843352995086022)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1050_VALUE_COL_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2594843552744086024)
,p_event_id=>wwv_flow_api.id(2594843352995086022)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1050_VALUE_COL_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2594843615287086025)
,p_event_id=>wwv_flow_api.id(2594843352995086022)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1050_VALUE_COL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2594843746146086026)
,p_event_id=>wwv_flow_api.id(2594843352995086022)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1050_VALUE_COL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3019479100725899616)
,p_name=>'Disable Admin'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1050_HOMEPAGE'
,p_condition_element=>'P1050_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3019479243195899617)
,p_event_id=>wwv_flow_api.id(3019479100725899616)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1050_ADMIN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3019479387309899618)
,p_event_id=>wwv_flow_api.id(3019479100725899616)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1050_ADMIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3019479447877899619)
,p_name=>'Disable Home Page'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1050_ADMIN'
,p_condition_element=>'P1050_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3019479501463899620)
,p_event_id=>wwv_flow_api.id(3019479447877899619)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1050_HOMEPAGE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3019479683459899621)
,p_event_id=>wwv_flow_api.id(3019479447877899619)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1050_HOMEPAGE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2639525258409650421)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_page_id    number;',
'    l_chart_list wwv_flow_define_app_v3.t_chart_list;',
'begin',
'    l_chart_list(1).chart_type := :P1050_CHART_TYPE;',
'    l_chart_list(1).label_column := :P1050_LABEL_COL;',
'    l_chart_list(1).value_column := ( case when :P1050_AGGREGATE = ''COUNT'' then :P1050_VALUE_COL_COUNT else :P1050_VALUE_COL end );',
'    l_chart_list(1).value_function := :P1050_AGGREGATE;',
'',
'    l_page_id := wwv_flow_define_app_v3.add_page(',
'                     p_page_name   => :P1050_PAGE_NAME,',
'                     p_page_type   => :P1050_PAGE_TYPE,',
'                     p_page_icon   => :P1050_PAGE_ICON,',
'                     p_schema      => :P1_SCHEMA,',
'                     p_source_type => :P1050_PAGE_SOURCE,',
'                     p_table_name  => ( case when :P1050_PAGE_SOURCE = ''TABLE'' then :P1050_TABLE end ),',
'                     p_is_homepage => ( :P1050_HOMEPAGE = ''Y'' ),',
'                     p_is_admin_page => ( :P1050_ADMIN = ''Y'' ),',
'                     p_chart_list    => l_chart_list,',
'                     p_page_help     => :P1050_PAGE_HELP);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2639522360799650400)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2639525682626650422)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_chart_list    wwv_flow_define_app_v3.t_chart_list;',
'begin',
'    l_chart_list(1).chart_type := :P1050_CHART_TYPE;',
'    l_chart_list(1).label_column := :P1050_LABEL_COL;',
'    l_chart_list(1).value_column := ( case when :P1050_AGGREGATE = ''COUNT'' then :P1050_VALUE_COL_COUNT else :P1050_VALUE_COL end );',
'    l_chart_list(1).value_function := :P1050_AGGREGATE;',
'',
'    wwv_flow_define_app_v3.edit_page(',
'        p_page_id      => :P1050_SEQ_ID,',
'        p_page_name    => :P1050_PAGE_NAME,',
'        p_page_type    => :P1050_PAGE_TYPE,',
'        p_page_icon    => :P1050_PAGE_ICON,',
'        p_schema       => :P1_SCHEMA,',
'        p_source_type  => :P1050_PAGE_SOURCE,',
'        p_table_name   => ( case when :P1050_PAGE_SOURCE = ''TABLE'' then :P1050_TABLE end ),',
'        p_is_homepage  => ( :P1050_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page => ( :P1050_ADMIN = ''Y'' ),',
'        p_chart_list    => l_chart_list,',
'        p_page_help     => :P1050_PAGE_HELP );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2639521904729650400)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2639524499585650421)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1050_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2639521574533650398)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2639526017877650422)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2639524836075650421)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select seq_id,',
'                      n002 internal_page_id,',
'                      c001 page_name,',
'                      c002 page_type,',
'                      ''TABLE'' source_type,',
'                      c005 table_name,',
'                      c013 page_icon,',
'                      c015 is_admin_page,',
'                      c025 chart_type,',
'                      c026 label_column,',
'                      c027 value_column,',
'                      c028 value_function,',
'                      c040 help',
'               from apex_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1050_SEQ_ID )',
'loop',
'    :P1050_PAGE_NAME := l_page.page_name;',
'    :P1050_PAGE_TYPE := l_page.page_type;',
'    :P1050_PAGE_SOURCE := l_page.source_type;',
'    :P1050_TABLE := l_page.table_name;',
'    :P1050_PAGE_ICON := l_page.page_icon;    ',
'',
'    :P1050_CHART_TYPE := l_page.chart_type;',
'    :P1050_LABEL_COL := l_page.label_column;',
'    :P1050_AGGREGATE := l_page.value_function;',
'    if l_page.value_function = ''COUNT'' then',
'        :P1050_VALUE_COL_COUNT := l_page.value_column;',
'    else',
'        :P1050_VALUE_COL := l_page.value_column;',
'    end if;',
'    :P1050_ADMIN := l_page.is_admin_page;',
'    :P1060_PAGE_HELP := l_page.help;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1050_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_01060
begin
wwv_flow_api.create_page(
 p_id=>1060
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Create Dashboard Page'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Dashboard Page'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'initWizardModal = function() {',
'    function _initDialog() {',
'        var headerheight = $(''.a-Dialog-wizardSteps'').height(),',
'            footerheight = $(''.a-Dialog-footer'').height();',
'        $(''.a-Dialog-body'').css({',
'            ''top'':headerheight,',
'            ''bottom'':footerheight',
'        });',
'    }',
'    $(window).bind(''apexwindowresized'', function() {',
'        _initDialog();',
'    });',
'    _initDialog();',
'};'))
,p_javascript_code_onload=>'initWizardModal();'
,p_step_template=>wwv_flow_api.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog a-PageWizard-dialog--dashboard'
,p_page_template_options=>'#DEFAULT#'
,p_last_upd_yyyymmddhh24miss=>'20190603034432'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2593479581440715628)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2593481794265715650)
,p_plug_name=>'Chart 1'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5308969562394168086)
,p_plug_name=>'Chart Type'
,p_parent_plug_id=>wwv_flow_api.id(2593481794265715650)
,p_region_css_classes=>'a-PageWizard-dialogDashboardType'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13202411519473405102)
,p_plug_name=>'Chart Items'
,p_parent_plug_id=>wwv_flow_api.id(2593481794265715650)
,p_region_css_classes=>'a-BoxedForms a-PageWizard-dialogDashboardItems'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_grid_column_span=>8
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2707855318607463404)
,p_plug_name=>'Chart 3'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2707855428793463405)
,p_plug_name=>'Chart Type'
,p_parent_plug_id=>wwv_flow_api.id(2707855318607463404)
,p_region_css_classes=>'a-PageWizard-dialogDashboardType'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2707855635559463407)
,p_plug_name=>'Chart Items'
,p_parent_plug_id=>wwv_flow_api.id(2707855318607463404)
,p_region_css_classes=>'a-BoxedForms a-PageWizard-dialogDashboardItems'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_grid_column_span=>8
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2707856130870463412)
,p_plug_name=>'Chart 4'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2707856276658463413)
,p_plug_name=>'Chart Type'
,p_parent_plug_id=>wwv_flow_api.id(2707856130870463412)
,p_region_css_classes=>'a-PageWizard-dialogDashboardType'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2707856468726463415)
,p_plug_name=>'Chart Items'
,p_parent_plug_id=>wwv_flow_api.id(2707856130870463412)
,p_region_css_classes=>'a-BoxedForms a-PageWizard-dialogDashboardItems'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_grid_column_span=>8
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2714281532692099403)
,p_plug_name=>'Chart 2'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2714281678979099404)
,p_plug_name=>'Chart Items'
,p_parent_plug_id=>wwv_flow_api.id(2714281532692099403)
,p_region_css_classes=>'a-BoxedForms a-PageWizard-dialogDashboardItems'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_grid_column_span=>8
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2714282293366099410)
,p_plug_name=>'Chart Type'
,p_parent_plug_id=>wwv_flow_api.id(2714281532692099403)
,p_region_css_classes=>'a-PageWizard-dialogDashboardType'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3096987286892966839)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3273871575473525717)
,p_plug_display_sequence=>70
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21248689087502320587)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21248689663845320593)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2671804802505402186)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(21248689087502320587)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1060_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1060_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2646894890426407959)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(21248689663845320593)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1060_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2646895667231407965)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(21248689663845320593)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_condition=>'P1060_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2698316879439806458)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(21248689663845320593)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:DASHBOARD_PAGE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2646895254841407964)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(21248689663845320593)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1060_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2646896051751407965)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(21248689663845320593)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1060_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2646896431495407966)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(21248689663845320593)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1060_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2646904682195408048)
,p_branch_name=>'Redirect to Login Page'
,p_branch_action=>'f?p=4550:1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2646896431495407966)
,p_branch_sequence=>1
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2594844614787086035)
,p_name=>'P1060_CHART_2_VALUE_COUNT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(2714281678979099404)
,p_prompt=>'Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1060_CHART_2_TABLE',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'All Columns'
,p_lov_null_value=>'ALL$COL'
,p_lov_cascade_parent_items=>'P1060_CHART_2_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2594844785140086036)
,p_name=>'P1060_CHART_3_VALUE_COUNT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(2707855635559463407)
,p_prompt=>'Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1060_CHART_3_TABLE',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'All Columns'
,p_lov_null_value=>'ALL$COL'
,p_lov_cascade_parent_items=>'P1060_CHART_3_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2594844838720086037)
,p_name=>'P1060_CHART_4_VALUE_COUNT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(2707856468726463415)
,p_prompt=>'Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1060_CHART_4_TABLE',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'All Columns'
,p_lov_null_value=>'ALL$COL'
,p_lov_cascade_parent_items=>'P1060_CHART_4_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2646892278266407954)
,p_name=>'P1060_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3096987286892966839)
,p_prompt=>'Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1060_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS_HOMEPAGE'
,p_lov=>'.'||wwv_flow_api.id(2639480030873536264)||'.'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1060_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2646892922846407956)
,p_name=>'P1060_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(21248689087502320587)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2646893315172407957)
,p_name=>'P1060_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(21248689087502320587)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2646893793432407957)
,p_name=>'P1060_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(21248689087502320587)
,p_item_default=>'wwv_flow_lang.system_message(p_name => ''CA.ADMIN.DASHBOARD'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_css_classes=>'field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2646894115973407958)
,p_name=>'P1060_PAGE_SOURCE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(21248689087502320587)
,p_item_default=>'TABLE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2671804547208400973)
,p_name=>'P1060_PAGE_ICON'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(21248689087502320587)
,p_item_default=>'fa-dashboard'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2707855554456463406)
,p_name=>'P1060_CHART_3_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2707855428793463405)
,p_item_default=>'line'
,p_prompt=>'Chart 3 Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'JET_CHART_GALLERY'
,p_lov=>'.'||wwv_flow_api.id(2639572067402672315)||'.'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_css_classes=>'a-IconList--SmallWizard a-Form-fieldContainer--noPadding'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2707855758652463408)
,p_name=>'P1060_CHART_3_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2707855635559463407)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lang.system_message(',
'    p_name => ''CA.DASHBOARD.CHART.N'',',
'    p0     => ''3'' )'))
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Chart Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2707855807689463409)
,p_name=>'P1060_CHART_3_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2707855635559463407)
,p_prompt=>'Table or View'
,p_placeholder=>'- Select Table or View -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Sample Data'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2707855928039463410)
,p_name=>'P1060_CHART_3_LABEL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2707855635559463407)
,p_prompt=>'Label Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1060_CHART_3_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Label Column -'
,p_lov_cascade_parent_items=>'P1060_CHART_3_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2707856007509463411)
,p_name=>'P1060_CHART_3_VALUE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(2707855635559463407)
,p_prompt=>'Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1060_CHART_3_TABLE',
'  and data_type in (''NUMBER'',''FLOAT'')',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value Column -'
,p_lov_cascade_parent_items=>'P1060_CHART_3_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2707856324771463414)
,p_name=>'P1060_CHART_4_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2707856276658463413)
,p_item_default=>'pie'
,p_prompt=>'Chart 4 Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'JET_CHART_GALLERY'
,p_lov=>'.'||wwv_flow_api.id(2639572067402672315)||'.'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_css_classes=>'a-IconList--SmallWizard a-Form-fieldContainer--noPadding'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2707856506168463416)
,p_name=>'P1060_CHART_4_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2707856468726463415)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lang.system_message(',
'    p_name => ''CA.DASHBOARD.CHART.N'',',
'    p0     => ''4'' )'))
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Chart Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2707856613115463417)
,p_name=>'P1060_CHART_4_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2707856468726463415)
,p_prompt=>'Table or View'
,p_placeholder=>'- Select Table or View -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Sample Data'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2707856781516463418)
,p_name=>'P1060_CHART_4_LABEL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2707856468726463415)
,p_prompt=>'Label Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1060_CHART_4_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Label Column -'
,p_lov_cascade_parent_items=>'P1060_CHART_4_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2707856813162463419)
,p_name=>'P1060_CHART_4_VALUE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(2707856468726463415)
,p_prompt=>'Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1060_CHART_4_TABLE',
'  and data_type in (''NUMBER'',''FLOAT'')',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value Column -'
,p_lov_cascade_parent_items=>'P1060_CHART_4_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2714125537468081057)
,p_name=>'P1060_CHART_1_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(13202411519473405102)
,p_prompt=>'Table or View'
,p_placeholder=>'- Select Table or View -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Sample Data'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2714125948732081059)
,p_name=>'P1060_CHART_1_LABEL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(13202411519473405102)
,p_prompt=>'Label Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1060_CHART_1_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Label Column -'
,p_lov_cascade_parent_items=>'P1060_CHART_1_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2714126793128081060)
,p_name=>'P1060_CHART_1_VALUE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(13202411519473405102)
,p_prompt=>'Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1060_CHART_1_TABLE',
'  and data_type in (''NUMBER'',''FLOAT'')',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value Column -'
,p_lov_cascade_parent_items=>'P1060_CHART_1_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2714127897478082077)
,p_name=>'P1060_CHART_1_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(5308969562394168086)
,p_item_default=>'area'
,p_prompt=>'Chart 1 Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'JET_CHART_GALLERY'
,p_lov=>'.'||wwv_flow_api.id(2639572067402672315)||'.'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_css_classes=>'a-IconList--SmallWizard a-Form-fieldContainer--noPadding'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2714281305832099401)
,p_name=>'P1060_CHART_1_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(13202411519473405102)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lang.system_message(',
'    p_name => ''CA.DASHBOARD.CHART.N'',',
'    p0     => ''1'' )'))
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Chart Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2714281797967099405)
,p_name=>'P1060_CHART_2_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2714281678979099404)
,p_prompt=>'Table or View'
,p_placeholder=>'- Select Table or View -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Sample Data'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2714281886161099406)
,p_name=>'P1060_CHART_2_LABEL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2714281678979099404)
,p_prompt=>'Label Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1060_CHART_2_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Label Column -'
,p_lov_cascade_parent_items=>'P1060_CHART_2_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2714281907095099407)
,p_name=>'P1060_CHART_2_VALUE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(2714281678979099404)
,p_prompt=>'Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1060_CHART_2_TABLE',
'  and data_type in (''NUMBER'',''FLOAT'')',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value Column -'
,p_lov_cascade_parent_items=>'P1060_CHART_2_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2714282119933099409)
,p_name=>'P1060_CHART_2_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2714281678979099404)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lang.system_message(',
'    p_name => ''CA.DASHBOARD.CHART.N'',',
'    p0     => ''2'' )'))
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Chart Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2714282307261099411)
,p_name=>'P1060_CHART_2_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2714282293366099410)
,p_item_default=>'bar'
,p_prompt=>'Chart 2 Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'JET_CHART_GALLERY'
,p_lov=>'.'||wwv_flow_api.id(2639572067402672315)||'.'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_css_classes=>'a-IconList--SmallWizard a-Form-fieldContainer--noPadding'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2928043282080578616)
,p_name=>'P1060_CHART_1_AGG'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(13202411519473405102)
,p_prompt=>'Aggregate'
,p_source=>'COLVALUE'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CHART_AGGREGATIONS'
,p_lov=>'.'||wwv_flow_api.id(2647168809994648252)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_css_classes=>'a-Form-fieldContainer--withOutlineFields'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2928044683501623808)
,p_name=>'P1060_CHART_2_AGG'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2714281678979099404)
,p_prompt=>'Aggregate'
,p_source=>'COLVALUE'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CHART_AGGREGATIONS'
,p_lov=>'.'||wwv_flow_api.id(2647168809994648252)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_css_classes=>'a-Form-fieldContainer--withOutlineFields'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2928044787933623809)
,p_name=>'P1060_CHART_3_AGG'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2707855635559463407)
,p_prompt=>'Aggregate'
,p_source=>'COLVALUE'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CHART_AGGREGATIONS'
,p_lov=>'.'||wwv_flow_api.id(2647168809994648252)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_css_classes=>'a-Form-fieldContainer--withOutlineFields'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2928044896798623810)
,p_name=>'P1060_CHART_4_AGG'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2707856468726463415)
,p_prompt=>'Aggregate'
,p_source=>'COLVALUE'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CHART_AGGREGATIONS'
,p_lov=>'.'||wwv_flow_api.id(2647168809994648252)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_css_classes=>'a-Form-fieldContainer--withOutlineFields'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2934916327383378883)
,p_name=>'P1060_CHART_1_VALUE_COUNT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(13202411519473405102)
,p_prompt=>'Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1060_CHART_1_TABLE',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'All Columns'
,p_lov_null_value=>'ALL$COL'
,p_lov_cascade_parent_items=>'P1060_CHART_1_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2940045399375003222)
,p_name=>'P1060_ADMIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3096987286892966839)
,p_prompt=>'Administrative'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS ADMINISTRATIVE'
,p_lov=>'.'||wwv_flow_api.id(2996645622600931087)||'.'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3165198487374852602)
,p_name=>'P1060_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3096987286892966839)
,p_prompt=>'Page help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2646899146783408028)
,p_validation_name=>'chart 1 value column not null'
,p_validation_sequence=>20
,p_validation=>'P1060_CHART_1_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Chart 1 value column must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1060_CHART_1_TABLE is not null and :P1060_CHART_1_AGG != ''COUNT'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2594844086207086029)
,p_validation_name=>'chart 2 value column not null'
,p_validation_sequence=>30
,p_validation=>'P1060_CHART_2_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Chart 2 value column must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1060_CHART_2_TABLE is not null and :P1060_CHART_2_AGG != ''COUNT'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2594844156498086030)
,p_validation_name=>'chart 3 value column not null'
,p_validation_sequence=>40
,p_validation=>'P1060_CHART_3_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Chart 3 value column must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1060_CHART_3_TABLE is not null and :P1060_CHART_3_AGG != ''COUNT'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2594844205097086031)
,p_validation_name=>'chart 4 value column not null'
,p_validation_sequence=>50
,p_validation=>'P1060_CHART_4_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Chart 4 value column must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1060_CHART_4_TABLE is not null and :P1060_CHART_4_AGG != ''COUNT'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2646899528210408028)
,p_validation_name=>'chart 1 label column not null'
,p_validation_sequence=>60
,p_validation=>'P1060_CHART_1_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Chart 1 label column must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1060_CHART_1_TABLE is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2594844364429086032)
,p_validation_name=>'chart 2 label column not null'
,p_validation_sequence=>70
,p_validation=>'P1060_CHART_2_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Chart 2 label column must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1060_CHART_2_TABLE is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2594844482726086033)
,p_validation_name=>'chart 3 label column not null'
,p_validation_sequence=>80
,p_validation=>'P1060_CHART_3_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Chart 3 label column must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1060_CHART_3_TABLE is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2594844531124086034)
,p_validation_name=>'chart 4 label column not null'
,p_validation_sequence=>90
,p_validation=>'P1060_CHART_4_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Chart 4 label column must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1060_CHART_4_TABLE is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2646902720515408045)
,p_name=>'Initialize Page'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2646903273441408045)
,p_event_id=>wwv_flow_api.id(2646902720515408045)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_PAGE_NAME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2646901833828408039)
,p_name=>'Show Page Source'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1060_PAGE_SOURCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2646902357097408042)
,p_event_id=>wwv_flow_api.id(2646901833828408039)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($v(this.triggeringElement) === ''SQL'') {',
'    $("#page_source_sql").show();',
'    $("#page_source_table").hide();',
'} else if ($v(this.triggeringElement) === ''TABLE'') {',
'    $("#page_source_sql").hide();',
'    $("#page_source_table").show();',
'}'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2646903627217408045)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2646894890426407959)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2646904125113408046)
,p_event_id=>wwv_flow_api.id(2646903627217408045)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2707857450888463425)
,p_name=>'Chart 1 - Show Cols when Table Selected'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1060_CHART_1_TABLE'
,p_condition_element=>'P1060_CHART_1_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2707857571528463426)
,p_event_id=>wwv_flow_api.id(2707857450888463425)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_1_LABEL,P1060_CHART_1_VALUE,P1060_CHART_1_AGG'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2707857660707463427)
,p_event_id=>wwv_flow_api.id(2707857450888463425)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_1_LABEL,P1060_CHART_1_VALUE,P1060_CHART_1_AGG,P1060_CHART_1_VALUE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3096987836300966845)
,p_event_id=>wwv_flow_api.id(2707857450888463425)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_1_AGG'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'COLVALUE'
,p_attribute_09=>'N'
,p_wait_for_result=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2707857777845463428)
,p_name=>'Chart 2 - Show Cols when Table Selected'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1060_CHART_2_TABLE'
,p_condition_element=>'P1060_CHART_2_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2707857840034463429)
,p_event_id=>wwv_flow_api.id(2707857777845463428)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_2_LABEL,P1060_CHART_2_VALUE,P1060_CHART_2_AGG'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2707857937380463430)
,p_event_id=>wwv_flow_api.id(2707857777845463428)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_2_LABEL,P1060_CHART_2_VALUE,P1060_CHART_2_AGG,P1060_CHART_2_VALUE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3096987991633966846)
,p_event_id=>wwv_flow_api.id(2707857777845463428)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_2_AGG'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'COLVALUE'
,p_attribute_09=>'N'
,p_wait_for_result=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2707858041112463431)
,p_name=>'Chart 3 - Show Cols when Table Selected'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1060_CHART_3_TABLE'
,p_condition_element=>'P1060_CHART_3_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2707858119407463432)
,p_event_id=>wwv_flow_api.id(2707858041112463431)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_3_LABEL,P1060_CHART_3_VALUE,P1060_CHART_3_AGG'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2707858243354463433)
,p_event_id=>wwv_flow_api.id(2707858041112463431)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_3_LABEL,P1060_CHART_3_VALUE,P1060_CHART_3_AGG,P1060_CHART_3_VALUE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3096988039282966847)
,p_event_id=>wwv_flow_api.id(2707858041112463431)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_3_AGG'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'COLVALUE'
,p_attribute_09=>'N'
,p_wait_for_result=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2707858393690463434)
,p_name=>'Chart 4 - Show Cols when Table Selected'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1060_CHART_4_TABLE'
,p_condition_element=>'P1060_CHART_4_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2707858468022463435)
,p_event_id=>wwv_flow_api.id(2707858393690463434)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_4_LABEL,P1060_CHART_4_VALUE,P1060_CHART_4_AGG'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2707858548483463436)
,p_event_id=>wwv_flow_api.id(2707858393690463434)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_4_LABEL,P1060_CHART_4_VALUE,P1060_CHART_4_AGG,P1060_CHART_4_VALUE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3096988115205966848)
,p_event_id=>wwv_flow_api.id(2707858393690463434)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_4_AGG'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'COLVALUE'
,p_attribute_09=>'N'
,p_wait_for_result=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2594844973566086038)
,p_name=>'show chart 1 value column count'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1060_CHART_1_AGG'
,p_condition_element=>'P1060_CHART_1_AGG'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'COUNT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2594845059368086039)
,p_event_id=>wwv_flow_api.id(2594844973566086038)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_1_VALUE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2594845103431086040)
,p_event_id=>wwv_flow_api.id(2594844973566086038)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_1_VALUE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2594845204754086041)
,p_event_id=>wwv_flow_api.id(2594844973566086038)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_1_VALUE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2594845341410086042)
,p_event_id=>wwv_flow_api.id(2594844973566086038)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_1_VALUE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2594845480053086043)
,p_name=>'show chart 2 value column count'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1060_CHART_2_AGG'
,p_condition_element=>'P1060_CHART_2_AGG'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'COUNT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2594845508618086044)
,p_event_id=>wwv_flow_api.id(2594845480053086043)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_2_VALUE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2594845613489086045)
,p_event_id=>wwv_flow_api.id(2594845480053086043)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_2_VALUE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2594845742004086046)
,p_event_id=>wwv_flow_api.id(2594845480053086043)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_2_VALUE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2594845884816086047)
,p_event_id=>wwv_flow_api.id(2594845480053086043)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_2_VALUE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2594845943262086048)
,p_name=>'show chart 3 value column count'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1060_CHART_3_AGG'
,p_condition_element=>'P1060_CHART_3_AGG'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'COUNT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2594846051763086049)
,p_event_id=>wwv_flow_api.id(2594845943262086048)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_3_VALUE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2594846154164086050)
,p_event_id=>wwv_flow_api.id(2594845943262086048)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_3_VALUE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2934947678029675401)
,p_event_id=>wwv_flow_api.id(2594845943262086048)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_3_VALUE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2934947752485675402)
,p_event_id=>wwv_flow_api.id(2594845943262086048)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_3_VALUE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2934947882288675403)
,p_name=>'show chart 4 value column count'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1060_CHART_4_AGG'
,p_condition_element=>'P1060_CHART_4_AGG'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'COUNT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2934947931675675404)
,p_event_id=>wwv_flow_api.id(2934947882288675403)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_4_VALUE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2934948014983675405)
,p_event_id=>wwv_flow_api.id(2934947882288675403)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_4_VALUE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2934948169714675406)
,p_event_id=>wwv_flow_api.id(2934947882288675403)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_4_VALUE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2934948238765675407)
,p_event_id=>wwv_flow_api.id(2934947882288675403)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_CHART_4_VALUE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(784429773886840039)
,p_name=>'Disable Admin'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1060_HOMEPAGE'
,p_condition_element=>'P1060_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(784429816739840040)
,p_event_id=>wwv_flow_api.id(784429773886840039)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_ADMIN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(784429929217840041)
,p_event_id=>wwv_flow_api.id(784429773886840039)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_ADMIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(784430053816840042)
,p_name=>'Disable Home Page'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1060_ADMIN'
,p_condition_element=>'P1060_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(784430165989840043)
,p_event_id=>wwv_flow_api.id(784430053816840042)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_HOMEPAGE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(784430286239840044)
,p_event_id=>wwv_flow_api.id(784430053816840042)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1060_HOMEPAGE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2646900616539408032)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_page_id    number;',
'    l_chart_list wwv_flow_define_app_v3.t_chart_list;',
'begin',
'    l_chart_list(1).chart_name     := :P1060_CHART_1_NAME;',
'    l_chart_list(1).chart_type     := :P1060_CHART_1_TYPE;',
'    l_chart_list(1).table_name     := :P1060_CHART_1_TABLE;',
'    l_chart_list(1).label_column   := :P1060_CHART_1_LABEL;',
'    l_chart_list(1).value_column   := ( case when :P1060_CHART_1_AGG = ''COUNT'' then :P1060_CHART_1_VALUE_COUNT else :P1060_CHART_1_VALUE end );',
'    l_chart_list(1).value_function := :P1060_CHART_1_AGG;',
'',
'    l_chart_list(2).chart_name     := :P1060_CHART_2_NAME;',
'    l_chart_list(2).chart_type     := :P1060_CHART_2_TYPE;',
'    l_chart_list(2).table_name     := :P1060_CHART_2_TABLE;',
'    l_chart_list(2).label_column   := :P1060_CHART_2_LABEL;',
'    l_chart_list(2).value_column   := ( case when :P1060_CHART_2_AGG = ''COUNT'' then :P1060_CHART_2_VALUE_COUNT else :P1060_CHART_2_VALUE end );',
'    l_chart_list(2).value_function := :P1060_CHART_2_AGG;',
'',
'    l_chart_list(3).chart_name     := :P1060_CHART_3_NAME;',
'    l_chart_list(3).chart_type     := :P1060_CHART_3_TYPE;',
'    l_chart_list(3).table_name     := :P1060_CHART_3_TABLE;',
'    l_chart_list(3).label_column   := :P1060_CHART_3_LABEL;',
'    l_chart_list(3).value_column   := ( case when :P1060_CHART_3_AGG = ''COUNT'' then :P1060_CHART_3_VALUE_COUNT else :P1060_CHART_3_VALUE end );',
'    l_chart_list(3).value_function := :P1060_CHART_3_AGG;',
'',
'    l_chart_list(4).chart_name     := :P1060_CHART_4_NAME;',
'    l_chart_list(4).chart_type     := :P1060_CHART_4_TYPE;',
'    l_chart_list(4).table_name     := :P1060_CHART_4_TABLE;',
'    l_chart_list(4).label_column   := :P1060_CHART_4_LABEL;',
'    l_chart_list(4).value_column   := ( case when :P1060_CHART_4_AGG = ''COUNT'' then :P1060_CHART_4_VALUE_COUNT else :P1060_CHART_4_VALUE end );',
'    l_chart_list(4).value_function := :P1060_CHART_4_AGG;',
'',
'    l_page_id := wwv_flow_define_app_v3.add_page(',
'                     p_page_name        => :P1060_PAGE_NAME,',
'                     p_page_type        => :P1060_PAGE_TYPE,',
'                     p_page_icon        => :P1060_PAGE_ICON,',
'                     p_schema           => :P1_SCHEMA,',
'                     p_is_homepage      => ( :P1060_HOMEPAGE = ''Y'' ),',
'                     p_is_admin_page    => ( :P1060_ADMIN = ''Y''),',
'                     p_chart_list       => l_chart_list,',
'                     p_page_help        => :P1060_PAGE_HELP);',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2646896051751407965)
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2646901087005408036)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_chart_list wwv_flow_define_app_v3.t_chart_list;',
'begin',
'    l_chart_list(1).chart_name     := :P1060_CHART_1_NAME;',
'    l_chart_list(1).chart_type     := :P1060_CHART_1_TYPE;',
'    l_chart_list(1).table_name     := :P1060_CHART_1_TABLE;',
'    l_chart_list(1).label_column   := :P1060_CHART_1_LABEL;',
'    l_chart_list(1).value_column   := ( case when :P1060_CHART_1_AGG = ''COUNT'' then :P1060_CHART_1_VALUE_COUNT else :P1060_CHART_1_VALUE end );',
'    l_chart_list(1).value_function := :P1060_CHART_1_AGG;',
'',
'    l_chart_list(2).chart_name     := :P1060_CHART_2_NAME;',
'    l_chart_list(2).chart_type     := :P1060_CHART_2_TYPE;',
'    l_chart_list(2).table_name     := :P1060_CHART_2_TABLE;',
'    l_chart_list(2).label_column   := :P1060_CHART_2_LABEL;',
'    l_chart_list(2).value_column   := ( case when :P1060_CHART_2_AGG = ''COUNT'' then :P1060_CHART_2_VALUE_COUNT else :P1060_CHART_2_VALUE end );',
'    l_chart_list(2).value_function := :P1060_CHART_2_AGG;',
'',
'    l_chart_list(3).chart_name     := :P1060_CHART_3_NAME;',
'    l_chart_list(3).chart_type     := :P1060_CHART_3_TYPE;',
'    l_chart_list(3).table_name     := :P1060_CHART_3_TABLE;',
'    l_chart_list(3).label_column   := :P1060_CHART_3_LABEL;',
'    l_chart_list(3).value_column   := ( case when :P1060_CHART_3_AGG = ''COUNT'' then :P1060_CHART_3_VALUE_COUNT else :P1060_CHART_3_VALUE end );',
'    l_chart_list(3).value_function := :P1060_CHART_3_AGG;',
'',
'    l_chart_list(4).chart_name     := :P1060_CHART_4_NAME;',
'    l_chart_list(4).chart_type     := :P1060_CHART_4_TYPE;',
'    l_chart_list(4).table_name     := :P1060_CHART_4_TABLE;',
'    l_chart_list(4).label_column   := :P1060_CHART_4_LABEL;',
'    l_chart_list(4).value_column   := ( case when :P1060_CHART_4_AGG = ''COUNT'' then :P1060_CHART_4_VALUE_COUNT else :P1060_CHART_4_VALUE end );',
'    l_chart_list(4).value_function := :P1060_CHART_4_AGG;',
'',
'    wwv_flow_define_app_v3.edit_page(',
'        p_page_id          => :P1060_SEQ_ID,',
'        p_page_name        => :P1060_PAGE_NAME,',
'        p_page_type        => :P1060_PAGE_TYPE,',
'        p_page_icon        => :P1060_PAGE_ICON,',
'        p_schema           => :P1_SCHEMA,',
'        p_is_homepage      => ( :P1060_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page    => ( :P1060_ADMIN = ''Y'' ),',
'        p_chart_list       => l_chart_list,',
'        p_page_help        => :P1060_PAGE_HELP);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2646895254841407964)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2646899880434408028)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1060_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2646895667231407965)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2646901492499408037)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2646900204603408032)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_cnt pls_integer := 0;',
'begin',
'    for l_page in (select seq_id id,',
'                          n002 internal_page_id,',
'                          c001 page_name,',
'                          c002 page_type,',
'                          c013 page_icon,',
'                          c015 is_admin_page,',
'                          c040 help',
'                   from apex_collections',
'                   where collection_name = ''APEX$CREATE_APP_PAGE''',
'                   and seq_id = :P1060_SEQ_ID )',
'    loop',
'        :P1060_PAGE_NAME := l_page.page_name;',
'        :P1060_PAGE_TYPE := l_page.page_type;',
'        :P1060_PAGE_ICON := l_page.page_icon;',
'        :P1060_ADMIN     := l_page.is_admin_page;',
'        :P1060_PAGE_HELP := l_page.help;',
'    ',
'        for l_chart in (select seq_id,',
'                               c001 chart_name,',
'                               c002 chart_type,',
'                               c003 table_name,',
'                               c004 label_col,',
'                               c005 value_col,',
'                               c006 value_function',
'                        from apex_collections',
'                        where collection_name = ''APEX$CREATE_APP_PAGE_CHART''',
'                        and n001 = l_page.id',
'                        and n002 = l_page.internal_page_id',
'                        order by seq_id  )',
'        loop',
'            l_cnt := l_cnt + 1;',
'            if l_cnt = 1 then',
'                :P1060_CHART_1_NAME  := l_chart.chart_name;',
'                :P1060_CHART_1_TYPE  := l_chart.chart_type;',
'                :P1060_CHART_1_TABLE := l_chart.table_name;',
'                :P1060_CHART_1_LABEL := l_chart.label_col;',
'                if l_chart.value_function = ''COUNT'' then',
'                    :P1060_CHART_1_VALUE_COUNT := l_chart.value_col;',
'                else',
'                    :P1060_CHART_1_VALUE := l_chart.value_col;',
'                end if;',
'                :P1060_CHART_1_AGG   := l_chart.value_function;',
'            end if;',
'        ',
'            if l_cnt = 2 then',
'                :P1060_CHART_2_NAME  := l_chart.chart_name;',
'                :P1060_CHART_2_TYPE  := l_chart.chart_type;',
'                :P1060_CHART_2_TABLE := l_chart.table_name;',
'                :P1060_CHART_2_LABEL := l_chart.label_col;',
'                if l_chart.value_function = ''COUNT'' then',
'                    :P1060_CHART_2_VALUE_COUNT := l_chart.value_col;',
'                else',
'                    :P1060_CHART_2_VALUE := l_chart.value_col;',
'                end if;',
'                :P1060_CHART_2_AGG   := l_chart.value_function;',
'            end if;',
'        ',
'            if l_cnt = 3 then',
'                :P1060_CHART_3_NAME  := l_chart.chart_name;',
'                :P1060_CHART_3_TYPE  := l_chart.chart_type;',
'                :P1060_CHART_3_TABLE := l_chart.table_name;',
'                :P1060_CHART_3_LABEL := l_chart.label_col;',
'                if l_chart.value_function = ''COUNT'' then',
'                    :P1060_CHART_3_VALUE_COUNT := l_chart.value_col;',
'                else',
'                    :P1060_CHART_3_VALUE := l_chart.value_col;',
'                end if;',
'                :P1060_CHART_3_AGG   := l_chart.value_function;',
'            end if;',
'        ',
'            if l_cnt = 4 then',
'                :P1060_CHART_4_NAME  := l_chart.chart_name;',
'                :P1060_CHART_4_TYPE  := l_chart.chart_type;',
'                :P1060_CHART_4_TABLE := l_chart.table_name;',
'                :P1060_CHART_4_LABEL := l_chart.label_col;',
'                if l_chart.value_function = ''COUNT'' then',
'                    :P1060_CHART_4_VALUE_COUNT := l_chart.value_col;',
'                else',
'                    :P1060_CHART_4_VALUE := l_chart.value_col;',
'                end if;',
'                :P1060_CHART_4_AGG   := l_chart.value_function;',
'            end if;',
'        end loop;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1060_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_01061
begin
wwv_flow_api.create_page(
 p_id=>1061
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Create Dashboard Page'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Dashboard Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog a-PageWizard-dialog--centeredContent'
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>-wwv_flow_api.id(2746942411136297678)
,p_last_upd_yyyymmddhh24miss=>'20171009062400'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13567353174284584354)
,p_plug_name=>'Coming Soon!'
,p_region_css_classes=>'a-Alert--comingSoon'
,p_icon_css_classes=>'fa fa-clock-o'
,p_region_template_options=>'a-Alert--info:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3330277939666606656)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'We''re still working on the finishing touches!'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13567353750627584360)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2750397042704325449)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(13567353750627584360)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1061_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2750401550974325457)
,p_branch_name=>'Redirect to Login Page'
,p_branch_action=>'f?p=4550:1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2750397042704325449)
,p_branch_sequence=>1
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2750397718142325450)
,p_name=>'P1061_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(13567353174284584354)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2750398194257325454)
,p_name=>'P1061_PAGE_ICON'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(13567353174284584354)
,p_item_default=>'fa-file-o'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2750400539692325456)
,p_name=>'Focus on Page Load'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2750401024165325456)
,p_event_id=>wwv_flow_api.id(2750400539692325456)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1061_PAGE_NAME'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2750398581550325454)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.add_page(',
'    p_page_name        => :P1061_PAGE_NAME,',
'    p_page_type        => wwv_flow_define_app_v3.c_page_blank,',
'    p_page_icon       => :P1061_PAGE_ICON,',
'    p_is_homepage      => ( :P1061_HOMEPAGE = ''Y'' ) );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2750399394869325455)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.edit_page(',
'    p_page_id          => :P1061_SEQ_ID,',
'    p_page_name        => :P1061_PAGE_NAME,',
'    p_page_type        => wwv_flow_define_app_v3.c_page_blank,',
'    p_page_icon        => :P1061_PAGE_ICON,',
'    p_is_homepage      => ( :P1061_HOMEPAGE = ''Y'' ) );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2750398999555325455)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1061_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2750399750791325455)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2750400184752325455)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select c001 page_name,',
'                      c002 page_type,',
'                      c013 page_icon',
'               from apex_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1061_SEQ_ID )',
'loop',
'    :P1061_PAGE_NAME := l_page.page_name;',
'    :P1061_PAGE_ICON := l_page.page_icon;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1061_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_01070
begin
wwv_flow_api.create_page(
 p_id=>1070
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Create Calendar Page'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Calendar Page'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'initWizardModal = function() {',
'    function _initDialog() {',
'        var headerheight = $(''.a-Dialog-wizardSteps'').height(),',
'            footerheight = $(''.a-Dialog-footer'').height();',
'        $(''.a-Dialog-body'').css({',
'            ''top'':headerheight,',
'            ''bottom'':footerheight',
'        });',
'    }',
'    $(window).bind(''apexwindowresized'', function() {',
'        _initDialog();',
'    });',
'    _initDialog();',
'};'))
,p_javascript_code_onload=>'initWizardModal();'
,p_step_template=>wwv_flow_api.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_last_upd_yyyymmddhh24miss=>'20190603034432'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3096987315318966840)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3273871575473525717)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10508080234298704472)
,p_plug_name=>'Table Container'
,p_region_css_classes=>'a-BoxedForms a-PageWizard-region'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18621592154522293172)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18621592730865293178)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2671805636387411310)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(18621592154522293172)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1070_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1070_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2698017377448126308)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(18621592730865293178)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1070_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2659314770638030824)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(18621592730865293178)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_condition=>'P1070_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2698324017500897718)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(18621592730865293178)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:CALENDAR_PAGE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2659315104992030825)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(18621592730865293178)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1070_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2659315588213030826)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(18621592730865293178)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1070_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2659315944231030826)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(18621592730865293178)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1070_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2659322052210030863)
,p_branch_name=>'Redirect to Login Page'
,p_branch_action=>'f?p=4550:1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2659315944231030826)
,p_branch_sequence=>1
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2593478213418715615)
,p_name=>'P1070_DISPLAY_COL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(18621592154522293172)
,p_prompt=>'Display Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1070_TABLE',
'  and (data_type in (''VARCHAR2'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Display Column -'
,p_lov_cascade_parent_items=>'P1070_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2593479126866715624)
,p_name=>'P1070_START_DATE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(18621592154522293172)
,p_prompt=>'Start Date Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1070_TABLE',
'  and (data_type in (''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Start Date -'
,p_lov_cascade_parent_items=>'P1070_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2593479379176715626)
,p_name=>'P1070_END_DATE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(18621592154522293172)
,p_prompt=>'End Date Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1070_TABLE',
'  and (data_type in (''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select End Date -'
,p_lov_cascade_parent_items=>'P1070_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_inline_help_text=>'Select this column to show events that span multiple days.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2593479463664715627)
,p_name=>'P1070_SHOW_TIME_YN'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(18621592154522293172)
,p_item_default=>'N'
,p_prompt=>'Show Time'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO'
,p_lov=>'.'||wwv_flow_api.id(2660244068801532757)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2659312827404030812)
,p_name=>'P1070_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(18621592154522293172)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2659313297848030815)
,p_name=>'P1070_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(18621592154522293172)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2659313625666030815)
,p_name=>'P1070_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(18621592154522293172)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2659314097451030815)
,p_name=>'P1070_PAGE_SOURCE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(18621592154522293172)
,p_item_default=>'TABLE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2659316383857030827)
,p_name=>'P1070_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3096987315318966840)
,p_prompt=>'Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1070_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS_HOMEPAGE'
,p_lov=>'.'||wwv_flow_api.id(2639480030873536264)||'.'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1070_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2659317337078030831)
,p_name=>'P1070_TABLE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(18621592154522293172)
,p_prompt=>'Table or View'
,p_placeholder=>'- Select Table or View -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2671805395057410150)
,p_name=>'P1070_PAGE_ICON'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(18621592154522293172)
,p_item_default=>'fa-calendar-o'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2940045709486003226)
,p_name=>'P1070_ADMIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3096987315318966840)
,p_prompt=>'Administrative'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS ADMINISTRATIVE'
,p_lov=>'.'||wwv_flow_api.id(2996645622600931087)||'.'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3165198978345852607)
,p_name=>'P1070_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3096987315318966840)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2659317868568030855)
,p_validation_name=>'P1070_TABLE not null'
,p_validation_sequence=>40
,p_validation=>'P1070_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2934950030132675425)
,p_validation_name=>'display column not null'
,p_validation_sequence=>50
,p_validation=>'P1070_DISPLAY_COL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2934950134523675426)
,p_validation_name=>'start date column not null'
,p_validation_sequence=>60
,p_validation=>'P1070_START_DATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2659321029873030861)
,p_name=>'Initialize Page'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2659321525605030861)
,p_event_id=>wwv_flow_api.id(2659321029873030861)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1070_PAGE_NAME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2659320101071030858)
,p_name=>'Show Page Source'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1070_PAGE_SOURCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2659320616579030861)
,p_event_id=>wwv_flow_api.id(2659320101071030858)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($v(this.triggeringElement) === ''SQL'') {',
'    $("#page_source_sql").show();',
'    $("#page_source_table").hide();',
'} else if ($v(this.triggeringElement) === ''TABLE'') {',
'    $("#page_source_sql").hide();',
'    $("#page_source_table").show();',
'}'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2698017422394126309)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2698017377448126308)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2698017536263126310)
,p_event_id=>wwv_flow_api.id(2698017422394126309)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3019479715146899622)
,p_name=>'Disable Admin'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1070_HOMEPAGE'
,p_condition_element=>'P1070_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3019479809615899623)
,p_event_id=>wwv_flow_api.id(3019479715146899622)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1070_ADMIN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3019479914995899624)
,p_event_id=>wwv_flow_api.id(3019479715146899622)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1070_ADMIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3019480067678899625)
,p_name=>'Disable Home Page'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1070_ADMIN'
,p_condition_element=>'P1070_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3019480154520899626)
,p_event_id=>wwv_flow_api.id(3019480067678899625)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1070_HOMEPAGE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3019480205629899627)
,p_event_id=>wwv_flow_api.id(3019480067678899625)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1070_HOMEPAGE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2659318919200030856)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_page_id number;',
'    l_calendar wwv_flow_define_app_v3.t_calendar;',
'begin',
'    l_calendar.display_column := :P1070_DISPLAY_COL;',
'    l_calendar.start_date_column := :P1070_START_DATE;',
'    l_calendar.end_date_column := :P1070_END_DATE;',
'    l_calendar.show_time := :P1070_SHOW_TIME_YN;',
'',
'    l_page_id := wwv_flow_define_app_v3.add_page(',
'                     p_page_name        => :P1070_PAGE_NAME,',
'                     p_page_type        => :P1070_PAGE_TYPE,',
'                     p_page_icon        => :P1070_PAGE_ICON,',
'                     p_schema           => :P1_SCHEMA,',
'                     p_source_type      => :P1070_PAGE_SOURCE,',
'                     p_table_name       => ( case when :P1070_PAGE_SOURCE = ''TABLE'' then :P1070_TABLE end ),',
'                     p_is_homepage      => ( :P1070_HOMEPAGE = ''Y'' ),',
'                     p_is_admin_page    => ( :P1070_ADMIN = ''Y''),',
'                     p_calendar         => l_calendar,',
'                     p_page_help        => :P1070_PAGE_HELP);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2659315588213030826)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2659319353958030857)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_page_id number;',
'    l_calendar wwv_flow_define_app_v3.t_calendar;',
'begin',
'    l_calendar.display_column := :P1070_DISPLAY_COL;',
'    l_calendar.start_date_column := :P1070_START_DATE;',
'    l_calendar.end_date_column := :P1070_END_DATE;',
'    l_calendar.show_time := :P1070_SHOW_TIME_YN;',
'',
'    wwv_flow_define_app_v3.edit_page(',
'        p_page_id          => :P1070_SEQ_ID,',
'        p_page_name        => :P1070_PAGE_NAME,',
'        p_page_type        => :P1070_PAGE_TYPE,',
'        p_page_icon        => :P1070_PAGE_ICON,',
'        p_schema           => :P1_SCHEMA,',
'        p_source_type      => :P1070_PAGE_SOURCE,',
'        p_table_name       => :P1070_TABLE,',
'        p_is_homepage      => ( :P1070_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page    => ( :P1070_ADMIN = ''Y'' ),',
'        p_calendar         => l_calendar,',
'        p_page_help        => :P1070_PAGE_HELP);',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2659315104992030825)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2659318190271030855)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1070_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2659314770638030824)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2659319712486030857)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2659318556722030856)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select c001 page_name,',
'                      c002 page_type,',
'                      ''TABLE'' source_type,',
'                      c005 table_name,',
'                      c013 page_icon,',
'                      c015 is_admin_page,',
'                      c025 display_column,',
'                      c026 start_date_column,',
'                      c027 end_date_column,',
'                      c028 show_time,',
'                      c040 help',
'               from apex_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1070_SEQ_ID )',
'loop',
'    :P1070_PAGE_NAME := l_page.page_name;',
'    :P1070_PAGE_TYPE := l_page.page_type;',
'    :P1070_PAGE_SOURCE := l_page.source_type;',
'    :P1070_TABLE := l_page.table_name;',
'    :P1070_PAGE_ICON := l_page.page_icon;',
'',
'    :P1070_DISPLAY_COL := l_page.display_column;',
'    :P1070_START_DATE := l_page.start_date_column;',
'    :P1070_END_DATE := l_page.end_date_column;',
'    :P1070_SHOW_TIME_YN := l_page.show_time;',
'    :P1070_ADMIN := l_page.is_admin_page;',
'    :P1070_PAGE_HELP := l_page.help;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1070_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_01090
begin
wwv_flow_api.create_page(
 p_id=>1090
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Add Cards Page'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Cards Page'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_PAGE_CONFIRM_MSG"'';'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-PageWizard-dialog .a-PageWizard--collapsibleRegion.a-Region--hideShow.a-BoxedForms .a-Region-body {',
'    margin: -12px 12px 0 12px;',
'    padding-bottom: 24px;',
'}',
'.a-Region.a-BoxedForms .a-Region-body {',
'   	color: #000;',
'}'))
,p_step_template=>wwv_flow_api.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'520'
,p_dialog_width=>'800'
,p_last_upd_yyyymmddhh24miss=>'20200903091504'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6412055982372737385)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3273871575473525717)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6571976926738979190)
,p_plug_name=>'Drill Down Link'
,p_region_name=>'drill_down_link_region'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion a-BoxedForms'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_api.id(3273871575473525717)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1090_HAS_DRILLDOWN'
,p_plug_display_when_cond2=>'Y'
,p_required_patch=>wwv_flow_api.id(3145295462075987142)
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13803355032585094601)
,p_plug_name=>'Cards'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13427405318384615)
,p_plug_name=>'Card Columns'
,p_region_name=>'card-columns'
,p_parent_plug_id=>wwv_flow_api.id(13803355032585094601)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>35
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21916866952808683301)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21916867529151683307)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3315072439421770578)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(21916866952808683301)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1090_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1090_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3315075933210770583)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(21916867529151683307)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1090_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3315076380769770584)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(21916867529151683307)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P1090_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3315075145784770583)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(21916867529151683307)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:CARD_PAGE'
,p_button_condition_type=>'NEVER'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3315075571323770583)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(21916867529151683307)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1090_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3315076728337770584)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(21916867529151683307)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1090_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3315077192826770584)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(21916867529151683307)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1090_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13427126749384612)
,p_name=>'P1090_LAYOUT_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(13803355032585094601)
,p_item_default=>'GRID'
,p_prompt=>'Layout Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'CARDS_LAYOUT_TYPE'
,p_lov=>'.'||wwv_flow_api.id(13522227592838689)||'.'
,p_grid_column=>4
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13427236036384613)
,p_name=>'P1090_BADGE_COLUMN'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(13427405318384615)
,p_prompt=>'Badge Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1090_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1090_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3314909601952435903)
,p_name=>'P1090_ICON_COLUMN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(13427405318384615)
,p_prompt=>'Icon Initials Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1090_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1090_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315070129719770574)
,p_name=>'P1090_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(13803355032585094601)
,p_prompt=>'Table or View'
,p_placeholder=>'- Select Table or View -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315070518628770576)
,p_name=>'P1090_TITLE_COLUMN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(13427405318384615)
,p_prompt=>'Title Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1090_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1090_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315071324821770577)
,p_name=>'P1090_BODY_COLUMN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(13427405318384615)
,p_prompt=>'Body Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1090_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1090_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315072892160770579)
,p_name=>'P1090_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(21916866952808683301)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315073242679770579)
,p_name=>'P1090_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(21916866952808683301)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315073633463770580)
,p_name=>'P1090_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(21916866952808683301)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315074021686770580)
,p_name=>'P1090_PAGE_SOURCE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(21916866952808683301)
,p_item_default=>'TABLE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315074463580770580)
,p_name=>'P1090_PAGE_ICON'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(21916866952808683301)
,p_item_default=>'fa-cards'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315077752338770585)
,p_name=>'P1090_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(6412055982372737385)
,p_prompt=>'Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1090_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS_HOMEPAGE'
,p_lov=>'.'||wwv_flow_api.id(2639480030873536264)||'.'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1090_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315078124605770586)
,p_name=>'P1090_ADMIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(6412055982372737385)
,p_prompt=>'Administrative'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS ADMINISTRATIVE'
,p_lov=>'.'||wwv_flow_api.id(2996645622600931087)||'.'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315078526162770587)
,p_name=>'P1090_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(6412055982372737385)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3361257124596218807)
,p_name=>'P1090_LINK_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(6571976926738979190)
,p_prompt=>'Link Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CARD_LINK'
,p_lov=>'.'||wwv_flow_api.id(3407941302600627214)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Type -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_api.id(3145295462075987142)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3361257541240218810)
,p_name=>'P1090_LINK_KEY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(6571976926738979190)
,p_prompt=>'Link Key'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1090_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT''))',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_cascade_parent_items=>'P1090_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_required_patch=>wwv_flow_api.id(3145295462075987142)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3361257973662218810)
,p_name=>'P1090_LINK_TO_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(6571976926738979190)
,p_prompt=>'Link to Page'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, n002 r ',
'from apex_collections ',
'where collection_name = ''APEX$CREATE_APP_PAGE''',
'and (   ( c002 = ''INTERACTIVE_RPT'' )',
'     or ( c002 = ''MASTER_DETAIL'' and c014 =''MD_ON_TABLE_WITH_SELECTOR'' )',
'    )',
'and ( seq_id !=  :P1090_SEQ_ID or :P1090_SEQ_ID is null )',
'',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Page -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_api.id(3145295462075987142)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3361258332680218810)
,p_name=>'P1090_LINK_TARGET_KEY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(6571976926738979190)
,p_prompt=>'Target Key'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (',
'    select wwv_flow_escape.html(column_name) d, column_name r, column_id n',
'    from sys.dba_tab_columns',
'    where  owner = :P1_SCHEMA and',
'           owner in (select schema',
'                     from wwv_flow_company_schemas',
'                     where security_group_id = :flow_security_group_id) and',
'           table_name = (',
'                     select max(c005) table_name',
'                     from apex_collections ',
'                     where collection_name = ''APEX$CREATE_APP_PAGE''',
'                     and n002 = :P1090_LINK_TO_PAGE',
'                     and c002 = ''INTERACTIVE_RPT''',
'                     and c003 = ''TABLE''',
'           ) and ',
'           (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE''))',
'    union all ',
'    -- drill down to master detail',
'    select wwv_flow_escape.html(column_name) d, column_name r, column_id n',
'    from sys.dba_tab_columns',
'    where  owner = :P1_SCHEMA and',
'           owner in (select schema',
'                     from wwv_flow_company_schemas',
'                     where security_group_id = :flow_security_group_id) and',
'           table_name = (',
'                     select max(c005) table_name',
'                     from apex_collections ',
'                     where collection_name = ''APEX$CREATE_APP_PAGE''',
'                     and n002 = :P1090_LINK_TO_PAGE',
'                     and c002 = ''MASTER_DETAIL''',
'                     and c003 = ''TABLE''',
'           ) and ',
'           (data_type in (''CHAR'',''NCHAR'',''VARCHAR2'',''NVARCHAR2'',''NUMBER'',''BINARY_FLOAT'',''BINARY_DOUBLE''))',
'    union all ',
'    -- drill down to IR on SQL',
'    select wwv_flow_escape.html(c005) d, c005 r, seq_id n',
'    from apex_collections ',
'    where collection_name = ''APEX$CREATE_APP_PAGE_COLUMN''',
'    and n002 = :P1090_LINK_TO_PAGE',
'    and c002 = ''INTERACTIVE_RPT''',
'    and c006 in (''VARCHAR2'',''NUMBER'',''DATE'')',
'    and c003 = ''SQL'' ) x',
'order by x.n'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1090_LINK_TO_PAGE'
,p_ajax_items_to_submit=>'P1090_LINK_TO_PAGE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_api.id(3145295462075987142)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4052496154736255103)
,p_name=>'P1090_HAS_DRILLDOWN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(21916866952808683301)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(4052496218308255104)
,p_computation_sequence=>10
,p_computation_item=>'P1090_HAS_DRILLDOWN'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''Y''',
'from wwv_flow_collections',
'where collection_name = ''APEX$CREATE_APP_PAGE'' and',
'    c002 in ( ''INTERACTIVE_RPT'',  ''MASTER_DETAIL'' )'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3315079028450770597)
,p_validation_name=>'table not null'
,p_validation_sequence=>10
,p_validation=>'P1090_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2934949443116675419)
,p_validation_name=>'cart title not null'
,p_validation_sequence=>20
,p_validation=>'P1090_TITLE_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2934951487720675439)
,p_validation_name=>'P1090_LINK_TO_PAGE not null'
,p_validation_sequence=>50
,p_validation=>'P1090_LINK_TO_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1090_HAS_DRILLDOWN = ''Y'' and (',
':P1090_LINK_KEY is not null or',
':P1090_LINK_TARGET_KEY is not null )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(3361257973662218810)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2934950739796675432)
,p_validation_name=>'P1090_LINK_TARGET_KEY not null'
,p_validation_sequence=>60
,p_validation=>'P1090_LINK_TARGET_KEY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1090_HAS_DRILLDOWN = ''Y'' and (',
':P1090_LINK_TO_PAGE is not null or',
':P1090_LINK_KEY is not null )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(3361258332680218810)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(632193570339032126)
,p_validation_name=>'P1090_LINK_TYPE not null'
,p_validation_sequence=>70
,p_validation=>'P1090_LINK_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1090_LINK_KEY is not null or',
':P1090_LINK_TO_PAGE is not null or',
':P1090_LINK_TARGET_KEY is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3315083949350770606)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3315075933210770583)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3315084472817770607)
,p_event_id=>wwv_flow_api.id(3315083949350770606)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3315087230908770610)
,p_name=>'Disable Admin'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1090_HOMEPAGE'
,p_condition_element=>'P1090_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3315087770096770610)
,p_event_id=>wwv_flow_api.id(3315087230908770610)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1090_ADMIN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3315088251425770611)
,p_event_id=>wwv_flow_api.id(3315087230908770610)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1090_ADMIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3315088671727770611)
,p_name=>'Disable Home Page'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1090_ADMIN'
,p_condition_element=>'P1090_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3315089165238770611)
,p_event_id=>wwv_flow_api.id(3315088671727770611)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1090_HOMEPAGE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3315089681396770612)
,p_event_id=>wwv_flow_api.id(3315088671727770611)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1090_HOMEPAGE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(13427534702384616)
,p_name=>'show card columns'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1090_TABLE'
,p_condition_element=>'P1090_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(629617727580772002)
,p_event_id=>wwv_flow_api.id(13427534702384616)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_workspace_name varchar2(255);',
'begin',
'    l_workspace_name := htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID );',
'    wwv_dictionary_cache_dev.set_dictionary_table_cache(',
'        p_workspace_name           => l_workspace_name,',
'        p_schema                   => :P1_SCHEMA,',
'        p_table_name               => :P1090_TABLE,',
'        p_cache_fk_references     => true );',
'end;'))
,p_attribute_02=>'P1090_TABLE'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(629617892452772003)
,p_event_id=>wwv_flow_api.id(13427534702384616)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1090_TITLE_COLUMN,P1090_BODY_COLUMN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(629617987997772004)
,p_name=>'Get Card Title'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1090_TITLE_COLUMN'
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(629618010115772005)
,p_event_id=>wwv_flow_api.id(629617987997772004)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select display_col_1 as title',
'      from wwv_dictionary_cache_obj',
'     where object_owner = :P1_SCHEMA',
'       and object_name = :P1090_TABLE',
'       and security_group_id = :WORKSPACE_ID',
')',
'loop',
'    :P1090_TITLE_COLUMN := c1.title;',
'end loop;'))
,p_attribute_03=>'P1090_TITLE_COLUMN'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
end;
/
begin
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(629618129656772006)
,p_name=>'Get Card Body Column'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1090_BODY_COLUMN'
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(629618281619772007)
,p_event_id=>wwv_flow_api.id(629618129656772006)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select display_col_2 as description',
'      from wwv_dictionary_cache_obj',
'     where object_owner = :P1_SCHEMA',
'       and object_name = :P1090_TABLE',
'       and security_group_id = :WORKSPACE_ID',
')',
'loop',
'    :P1090_BODY_COLUMN  := c1.description;',
'end loop;'))
,p_attribute_03=>'P1090_BODY_COLUMN'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3315080965743770599)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_card       wwv_flow_define_app_v3.t_card;',
'begin',
'    l_card.layout_type    := :P1090_LAYOUT_TYPE;',
'    l_card.title_column   := :P1090_TITLE_COLUMN;',
'    l_card.body_column    := :P1090_BODY_COLUMN;',
'    l_card.icon_column    := :P1090_ICON_COLUMN;',
'    l_card.badge_column   := :P1090_BADGE_COLUMN;',
'',
'    wwv_flow_define_app_v3.add_page(',
'        p_page_name       => :P1090_PAGE_NAME,',
'        p_page_type       => :P1090_PAGE_TYPE,',
'        p_page_icon       => :P1090_PAGE_ICON,',
'        p_schema          => :P1_SCHEMA,',
'        p_source_type     => ''TABLE'',',
'        p_table_name      => :P1090_TABLE,',
'        p_is_homepage     => ( :P1090_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page   => ( :P1090_ADMIN = ''Y'' ),',
'        p_card            => l_card,',
'        p_page_help       => :P1090_PAGE_HELP,',
'        p_link_column     => :P1090_LINK_TYPE,',
'        p_link_key        => :P1090_LINK_KEY,',
'        p_link_to_page    => :P1090_LINK_TO_PAGE,',
'        p_link_target_key => :P1090_LINK_TARGET_KEY );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3315076728337770584)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3315081334815770600)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_card       wwv_flow_define_app_v3.t_card;',
'begin',
'    l_card.layout_type    := :P1090_LAYOUT_TYPE;',
'    l_card.title_column   := :P1090_TITLE_COLUMN;',
'    l_card.body_column    := :P1090_BODY_COLUMN;',
'    l_card.icon_column    := :P1090_ICON_COLUMN;',
'    l_card.badge_column   := :P1090_BADGE_COLUMN;',
'    ',
'    wwv_flow_define_app_v3.edit_page(',
'        p_page_id         => :P1090_SEQ_ID,',
'        p_page_name       => :P1090_PAGE_NAME,',
'        p_page_type       => :P1090_PAGE_TYPE,',
'        p_page_icon       => :P1090_PAGE_ICON,',
'        p_schema          => :P1_SCHEMA,',
'        p_source_type     => ''TABLE'',',
'        p_table_name      => :P1090_TABLE,',
'        p_is_homepage     => ( :P1090_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page   => ( :P1090_ADMIN = ''Y'' ),',
'        p_card            => l_card,',
'        p_page_help       => :P1090_PAGE_HELP,',
'        p_link_column     => :P1090_LINK_TYPE,',
'        p_link_key        => :P1090_LINK_KEY,',
'        p_link_to_page    => :P1090_LINK_TO_PAGE,',
'        p_link_target_key => :P1090_LINK_TARGET_KEY );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3315075571323770583)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3315080146927770599)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1090_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3315076380769770584)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3315081787795770601)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3315080565973770599)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select seq_id,',
'                      n002 internal_page_id,',
'                      c001 page_name,',
'                      c002 page_type,',
'                      ''TABLE'' source_type,',
'                      c005 table_name,',
'                      c013 page_icon,',
'                      c015 is_admin_page,',
'                      c016 layout_type,',
'                      c017 title_column,',
'                      c018 body_column,',
'                      c019 icon_column,',
'                      c020 badge_column,',
'                      c040 help,',
'                      c041 link_type,',
'                      c042 link_key,',
'                      c043 link_to_page,',
'                      c044 link_target_key',
'               from apex_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1090_SEQ_ID )',
'loop',
'    :P1090_PAGE_NAME := l_page.page_name;',
'    :P1090_PAGE_TYPE := l_page.page_type;',
'    :P1090_PAGE_SOURCE := l_page.source_type;',
'    :P1090_TABLE := l_page.table_name;',
'    :P1090_PAGE_ICON := l_page.page_icon;    ',
'',
'    :P1090_LAYOUT_TYPE  := l_page.layout_type;',
'    :P1090_TITLE_COLUMN := l_page.title_column;',
'    :P1090_BODY_COLUMN  := l_page.body_column;',
'    :P1090_ICON_COLUMN  := l_page.icon_column;',
'    :P1090_BADGE_COLUMN := l_page.badge_column;',
'',
'    :P1090_LINK_TYPE := l_page.link_type;',
'    :P1090_LINK_KEY := l_page.link_key;',
'    :P1090_LINK_TO_PAGE := l_page.link_to_page;',
'    :P1090_LINK_TARGET_KEY := l_page.link_target_key;',
'    ',
'    :P1090_ADMIN := l_page.is_admin_page;',
'    :P1060_PAGE_HELP := l_page.help;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1090_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_01100
begin
wwv_flow_api.create_page(
 p_id=>1100
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Create Form Page'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Form Page'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.apex-button-group table {',
'    border-spacing: 0;',
'}'))
,p_step_template=>wwv_flow_api.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'520'
,p_dialog_width=>'800'
,p_dialog_attributes=>'resizable:true'
,p_last_upd_yyyymmddhh24miss=>'20190603034432'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6411863642286386018)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3273871575473525717)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11163644638415092865)
,p_plug_name=>'Table Container'
,p_region_name=>'page_source_table'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2942643391689249188)
,p_plug_name=>'Include Report'
,p_parent_plug_id=>wwv_flow_api.id(11163644638415092865)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6369980961600974383)
,p_plug_name=>'Form Container'
,p_parent_plug_id=>wwv_flow_api.id(11163644638415092865)
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19277156558638681565)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19277157134981681571)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3314882086365419193)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(19277156558638681565)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1100_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1100_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3314884773135419195)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(19277157134981681571)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1100_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3314885194186419196)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(19277157134981681571)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_condition=>'P1100_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3314885569453419196)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(19277157134981681571)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:FORM_PAGE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3314885986098419196)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(19277157134981681571)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1100_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3314886328123419197)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(19277157134981681571)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1100_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3314886741033419197)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(19277157134981681571)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1100_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(353718430581098652)
,p_name=>'P1100_INCLUDE_REPORT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2942643391689249188)
,p_prompt=>'Include report'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'INCLUDE_REPORT_Y'
,p_lov=>'.'||wwv_flow_api.id(353723515527117365)||'.'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3314878938317419189)
,p_name=>'P1100_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(6369980961600974383)
,p_prompt=>'Table'
,p_placeholder=>'- Select Table or View -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table -'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3314882480517419193)
,p_name=>'P1100_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(19277156558638681565)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3314882827576419194)
,p_name=>'P1100_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(19277156558638681565)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3314883251386419194)
,p_name=>'P1100_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(19277156558638681565)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3314883619464419194)
,p_name=>'P1100_PAGE_SOURCE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(19277156558638681565)
,p_item_default=>'TABLE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3314884053168419195)
,p_name=>'P1100_PAGE_ICON'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(19277156558638681565)
,p_item_default=>'fa-forms'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3314887445076419198)
,p_name=>'P1100_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(6411863642286386018)
,p_prompt=>'Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1100_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS_HOMEPAGE'
,p_lov=>'.'||wwv_flow_api.id(2639480030873536264)||'.'
,p_display_when_type=>'NEVER'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1100_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3314887808299419200)
,p_name=>'P1100_ADMIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(6411863642286386018)
,p_prompt=>'Administrative'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS ADMINISTRATIVE'
,p_lov=>'.'||wwv_flow_api.id(2996645622600931087)||'.'
,p_begin_on_new_line=>'N'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3314888218957419201)
,p_name=>'P1100_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(6411863642286386018)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3314920902353478248)
,p_name=>'P1100_FORM_TYPE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(11163644638415092865)
,p_item_default=>'MD_ON_TABLE_WITH_SELECTOR'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3314888792221419202)
,p_validation_name=>'P1100_TABLE not null'
,p_validation_sequence=>40
,p_validation=>'P1100_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Table name must be specified.'
,p_when_button_pressed=>wwv_flow_api.id(3314886328123419197)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3314891801429419206)
,p_name=>'Initialize Page'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3314892313511419206)
,p_event_id=>wwv_flow_api.id(3314891801429419206)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_PAGE_NAME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3314892770864419207)
,p_name=>'Show Page Source'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1100_PAGE_SOURCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3314893286994419209)
,p_event_id=>wwv_flow_api.id(3314892770864419207)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($v(this.triggeringElement) === ''SQL'') {',
'    $("#page_source_sql").show();',
'    $("#page_source_table").hide();',
'} else if ($v(this.triggeringElement) === ''TABLE'') {',
'    $("#page_source_sql").hide();',
'    $("#page_source_table").show();',
'}'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3314893613018419209)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3314884773135419195)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3314894120904419209)
,p_event_id=>wwv_flow_api.id(3314893613018419209)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3314895975111419211)
,p_name=>'Disable Admin'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1100_HOMEPAGE'
,p_condition_element=>'P1100_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3314896420319419211)
,p_event_id=>wwv_flow_api.id(3314895975111419211)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_ADMIN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3314896927364419212)
,p_event_id=>wwv_flow_api.id(3314895975111419211)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_ADMIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3314897315556419212)
,p_name=>'Disable Home Page'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1100_ADMIN'
,p_condition_element=>'P1100_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3314897846261419212)
,p_event_id=>wwv_flow_api.id(3314897315556419212)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_HOMEPAGE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3314898357158419213)
,p_event_id=>wwv_flow_api.id(3314897315556419212)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_HOMEPAGE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3314898752379419213)
,p_name=>'Toggle Details 2'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1100_DETAIL_1'
,p_condition_element=>'P1100_DETAIL_1'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3314899246647419213)
,p_event_id=>wwv_flow_api.id(3314898752379419213)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_DETAIL_2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3314899773115419214)
,p_event_id=>wwv_flow_api.id(3314898752379419213)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_DETAIL_2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3314900133566419214)
,p_name=>'Toggle Details 3'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1100_DETAIL_2'
,p_condition_element=>'P1100_DETAIL_2'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3314900664010419214)
,p_event_id=>wwv_flow_api.id(3314900133566419214)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_DETAIL_3'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3314901101359419215)
,p_event_id=>wwv_flow_api.id(3314900133566419214)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_DETAIL_3'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3314901591522419215)
,p_name=>'Toggle Details 4'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1100_DETAIL_3'
,p_condition_element=>'P1100_DETAIL_3'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3314902042570419215)
,p_event_id=>wwv_flow_api.id(3314901591522419215)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_DETAIL_4'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3314902549862419216)
,p_event_id=>wwv_flow_api.id(3314901591522419215)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1100_DETAIL_4'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3314890693375419205)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_page_id           number;',
'begin',
'',
'    l_page_id := wwv_flow_define_app_v3.add_page(',
'                     p_page_name         => :P1100_PAGE_NAME,',
'                     p_page_type         => :P1100_PAGE_TYPE,',
'                     p_page_icon         => :P1100_PAGE_ICON,',
'                     p_schema            => :P1_SCHEMA,',
'                     p_source_type       => :P1100_PAGE_SOURCE,',
'                     p_table_name        => ( case when :P1100_PAGE_SOURCE = ''TABLE'' then :P1100_TABLE end ),',
'                     p_include_report    => ( :P1100_INCLUDE_REPORT = ''Y'' ),',
'                     p_is_homepage       => ( :P1100_HOMEPAGE = ''Y'' ),',
'                     p_is_admin_page     => ( :P1100_ADMIN = ''Y''),',
'                     p_form_type         => :P1100_FORM_TYPE,',
'                     p_page_help         => :P1100_PAGE_HELP);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3314886328123419197)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3314891046972419205)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_define_app_v3.edit_page(',
'        p_page_id           => :P1100_SEQ_ID,',
'        p_page_name         => :P1100_PAGE_NAME,',
'        p_page_type         => :P1100_PAGE_TYPE,',
'        p_page_icon         => :P1100_PAGE_ICON,',
'        p_schema            => :P1_SCHEMA,',
'        p_source_type       => :P1100_PAGE_SOURCE,',
'        p_table_name        => :P1100_TABLE,',
'        p_include_report    => ( :P1100_INCLUDE_REPORT = ''Y'' ),',
'        p_is_homepage       => ( :P1100_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page     => ( :P1100_ADMIN = ''Y'' ),',
'        p_form_type         => :P1100_FORM_TYPE,',
'        p_page_help         => :P1100_PAGE_HELP);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3314885986098419196)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3314889896608419204)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1100_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3314885194186419196)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3314891403945419206)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3314890208990419205)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select c001 page_name,',
'                      c002 page_type,',
'                      ''TABLE'' source_type,',
'                      c005 table_name,',
'                      c030 include_report,',
'                      c013 page_icon,',
'                      c014 form_type,',
'                      c015 is_admin_page,',
'                      c016 primary_label_col,',
'                      c017 secondary_label_col,',
'                      c025 detail_1,',
'                      c026 detail_2,',
'                      c027 detail_3,',
'                      c028 detail_4,',
'                      c040 help',
'               from apex_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1100_SEQ_ID )',
'loop',
'    :P1100_PAGE_NAME := l_page.page_name;',
'    :P1100_PAGE_TYPE := l_page.page_type;',
'    :P1100_PAGE_SOURCE := l_page.source_type;',
'	:P1100_FORM_TYPE := l_page.form_type;',
'    :P1100_TABLE := l_page.table_name;',
'    :P1100_INCLUDE_REPORT := l_page.include_report;',
'    :P1100_PAGE_ICON := l_page.page_icon;    ',
'    :P1100_ADMIN := l_page.is_admin_page;',
'    :P1100_PAGE_HELP := l_page.help;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1100_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_01110
begin
wwv_flow_api.create_page(
 p_id=>1110
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Create Timeline Page'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Timeline Page'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-PageWizard-dialog .a-PageWizard--collapsibleRegion.a-Region--hideShow.a-BoxedForms .a-Region-body {',
'    margin: -12px 12px 0 12px;',
'    padding-bottom: 24px;',
'}',
'.a-Region.a-BoxedForms .a-Region-body {',
'   	color: #000;',
'}',
'.a-Button.a-PWIconPicker-pickerButton--inline  {',
'     width: calc(100% - 16px);',
'	     padding-left: 36px;',
'	     text-align: left;',
'}'))
,p_step_template=>wwv_flow_api.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'520'
,p_dialog_width=>'800'
,p_last_upd_yyyymmddhh24miss=>'20190603034432'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9727170382582688517)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3273871575473525717)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9934464922380461272)
,p_plug_name=>'Drill Down Link'
,p_region_name=>'drill_down_link_region'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion a-BoxedForms'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_api.id(3273871575473525717)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1110_HAS_DRILLDOWN'
,p_plug_display_when_cond2=>'Y'
,p_required_patch=>wwv_flow_api.id(3145295462075987142)
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17118469432795045733)
,p_plug_name=>'Card Items'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(25231981353018634433)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(25231981929361634439)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3315116967854951159)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(25231981353018634433)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1110_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1110_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3315120412069951164)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(25231981929361634439)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1110_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3315120842117951164)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(25231981929361634439)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_condition=>'P1110_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3315119628353951163)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(25231981929361634439)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:TIMELINE_PAGE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3315120034382951164)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(25231981929361634439)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1110_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3315121221162951164)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(25231981929361634439)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1110_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3315121616605951166)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(25231981929361634439)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1110_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315108010290942904)
,p_name=>'P1110_EVENT_DESC'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(17118469432795045733)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1110_TABLE',
'  and (data_type in (''VARCHAR2'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1110_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315108105129942905)
,p_name=>'P1110_EVENT_DATE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(17118469432795045733)
,p_prompt=>'Date'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1110_TABLE',
'  and (data_type in (''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1110_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315115189488951151)
,p_name=>'P1110_TABLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(17118469432795045733)
,p_prompt=>'Table or View'
,p_placeholder=>'- Select Table or View -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_css_classes=>'field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315115594638951153)
,p_name=>'P1110_USER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(17118469432795045733)
,p_prompt=>'User Name'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1110_TABLE',
'  and (data_type in (''VARCHAR2''))',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1110_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315115907964951153)
,p_name=>'P1110_EVENT_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(17118469432795045733)
,p_prompt=>'Event Name'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1110_TABLE',
'  and (data_type in (''VARCHAR2''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1110_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315117300510951160)
,p_name=>'P1110_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(25231981353018634433)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315117733702951160)
,p_name=>'P1110_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(25231981353018634433)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315118149304951161)
,p_name=>'P1110_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(25231981353018634433)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315118575131951161)
,p_name=>'P1110_PAGE_SOURCE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(25231981353018634433)
,p_item_default=>'TABLE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315118970275951161)
,p_name=>'P1110_PAGE_ICON'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(25231981353018634433)
,p_item_default=>'fa-history'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315122343330951166)
,p_name=>'P1110_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(9727170382582688517)
,p_prompt=>'Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1110_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS_HOMEPAGE'
,p_lov=>'.'||wwv_flow_api.id(2639480030873536264)||'.'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1110_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315122728664951168)
,p_name=>'P1110_ADMIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(9727170382582688517)
,p_prompt=>'Administrative'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS ADMINISTRATIVE'
,p_lov=>'.'||wwv_flow_api.id(2996645622600931087)||'.'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315123125267951168)
,p_name=>'P1110_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(9727170382582688517)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3362488202696482094)
,p_name=>'P1110_LINK_COLUMN'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(9934464922380461272)
,p_item_default=>'EVENT_TITLE'
,p_prompt=>'Link Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'EVENT_NAME'
,p_lov=>'.'||wwv_flow_api.id(3407942220250638520)||'.'
,p_cHeight=>1
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_api.id(3145295462075987142)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3362488540549482098)
,p_name=>'P1110_LINK_KEY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(9934464922380461272)
,p_prompt=>'Link Key'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1110_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1110_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_api.id(3145295462075987142)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3362488924075482098)
,p_name=>'P1110_LINK_TO_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(9934464922380461272)
,p_prompt=>'Link to Page'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, n002 r ',
'from apex_collections ',
'where collection_name = ''APEX$CREATE_APP_PAGE''',
'and (   ( c002 = ''INTERACTIVE_RPT'' )',
'     or ( c002 = ''MASTER_DETAIL'' and c014 =''MD_ON_TABLE_WITH_SELECTOR'' )',
'    )',
'and ( seq_id !=  :P1110_SEQ_ID or :P1110_SEQ_ID is null )',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Page -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_api.id(3145295462075987142)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3362489357583482098)
,p_name=>'P1110_LINK_TARGET_KEY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(9934464922380461272)
,p_prompt=>'Target Key'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (',
'    select wwv_flow_escape.html(column_name) d, column_name r, column_id n',
'    from sys.dba_tab_columns',
'    where  owner = :P1_SCHEMA and',
'           --:P1110_SEQ_ID is null and',
'           owner in (select schema',
'                     from wwv_flow_company_schemas',
'                     where security_group_id = :flow_security_group_id) and',
'           table_name = (',
'                     select max(c005) table_name',
'                     from apex_collections ',
'                     where collection_name = ''APEX$CREATE_APP_PAGE''',
'                     and n002 = :P1110_LINK_TO_PAGE',
'                     and c002 = ''INTERACTIVE_RPT''',
'                     and c003 = ''TABLE''',
'           ) and ',
'           (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE''))',
'    union all ',
'    -- drill down to master detail',
'    select wwv_flow_escape.html(column_name) d, column_name r, column_id n',
'    from sys.dba_tab_columns',
'    where  owner = :P1_SCHEMA and',
'           owner in (select schema',
'                     from wwv_flow_company_schemas',
'                     where security_group_id = :flow_security_group_id) and',
'           table_name = (',
'                     select max(c005) table_name',
'                     from apex_collections ',
'                     where collection_name = ''APEX$CREATE_APP_PAGE''',
'                     and n002 = :P1110_LINK_TO_PAGE',
'                     and c002 = ''MASTER_DETAIL''',
'                     and c003 = ''TABLE''',
'           ) and ',
'           (data_type in (''CHAR'',''NCHAR'',''VARCHAR2'',''NVARCHAR2'',''NUMBER'',''BINARY_FLOAT'',''BINARY_DOUBLE''))',
'    union all  ',
'    -- drill down to IR on SQL',
'    select wwv_flow_escape.html(c005) d, c005 r, seq_id n',
'    from apex_collections ',
'    where collection_name = ''APEX$CREATE_APP_PAGE_COLUMN''',
'    and n002 = :P1110_LINK_TO_PAGE',
'    and c002 = ''INTERACTIVE_RPT''',
'    and c006 in (''VARCHAR2'',''NUMBER'',''DATE'')',
'    and c003 = ''SQL'' ) x',
'order by x.n'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1110_LINK_TO_PAGE'
,p_ajax_items_to_submit=>'P1110_LINK_TO_PAGE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_css_classes=>'field--marginTop field--noBottomPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_api.id(3145295462075987142)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4053364638768613001)
,p_name=>'P1110_HAS_DRILLDOWN'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(25231981353018634433)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(4053364749481613002)
,p_computation_sequence=>10
,p_computation_item=>'P1110_HAS_DRILLDOWN'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''Y''',
'from wwv_flow_collections',
'where collection_name = ''APEX$CREATE_APP_PAGE'' and',
'    c002 in ( ''INTERACTIVE_RPT'',  ''MASTER_DETAIL'' )'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3315123645199951191)
,p_validation_name=>'table not null'
,p_validation_sequence=>10
,p_validation=>'P1110_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2934949791560675422)
,p_validation_name=>'user name not null'
,p_validation_sequence=>20
,p_validation=>'P1110_USER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2934949878085675423)
,p_validation_name=>'date not null'
,p_validation_sequence=>30
,p_validation=>'P1110_EVENT_DATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2934949933031675424)
,p_validation_name=>'event name not null'
,p_validation_sequence=>40
,p_validation=>'P1110_EVENT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2934950918882675434)
,p_validation_name=>'P1110_LINK_KEY not null'
,p_validation_sequence=>50
,p_validation=>'P1110_LINK_KEY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1110_HAS_DRILLDOWN = ''Y'' and (',
'    :P1110_LINK_TO_PAGE is not null or',
'    :P1110_LINK_TARGET_KEY is not null )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2934951364555675438)
,p_validation_name=>'P1110_LINK_TO_PAGE not null'
,p_validation_sequence=>60
,p_validation=>'P1110_LINK_TO_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1110_HAS_DRILLDOWN = ''Y'' and (',
'    :P1110_LINK_KEY is not null or',
'    :P1110_LINK_TARGET_KEY is not null )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2934951218986675437)
,p_validation_name=>'P1110_LINK_TARGET_KEY not null'
,p_validation_sequence=>70
,p_validation=>'P1110_LINK_TARGET_KEY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1110_HAS_DRILLDOWN = ''Y'' and (',
'    :P1110_LINK_TO_PAGE is not null or',
'    :P1110_LINK_KEY is not null )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3315127725600951200)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3315120412069951164)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3315128245308951200)
,p_event_id=>wwv_flow_api.id(3315127725600951200)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3315131087942951202)
,p_name=>'Disable Admin'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1110_HOMEPAGE'
,p_condition_element=>'P1110_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3315131598827951202)
,p_event_id=>wwv_flow_api.id(3315131087942951202)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1110_ADMIN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3315132028664951203)
,p_event_id=>wwv_flow_api.id(3315131087942951202)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1110_ADMIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3315132424232951204)
,p_name=>'Disable Home Page'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1110_ADMIN'
,p_condition_element=>'P1110_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3315132956745951204)
,p_event_id=>wwv_flow_api.id(3315132424232951204)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1110_HOMEPAGE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3315133440762951205)
,p_event_id=>wwv_flow_api.id(3315132424232951204)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1110_HOMEPAGE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3315124700583951192)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_timeline wwv_flow_define_app_v3.t_timeline;',
'begin',
'    l_timeline.username_column := :P1110_USER;',
'    l_timeline.date_column := :P1110_EVENT_DATE;',
'    l_timeline.event_name_column := :P1110_EVENT_NAME;',
'    l_timeline.desc_column := :P1110_EVENT_DESC;',
'',
'    wwv_flow_define_app_v3.add_page(',
'        p_page_name       => :P1110_PAGE_NAME,',
'        p_page_type       => :P1110_PAGE_TYPE,',
'        p_page_icon       => :P1110_PAGE_ICON,',
'        p_schema          => :P1_SCHEMA,',
'        p_source_type     => ''TABLE'',',
'        p_table_name      => :P1110_TABLE,',
'        p_is_homepage     => ( :P1110_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page   => ( :P1110_ADMIN = ''Y'' ),',
'        p_timeline        => l_timeline,',
'        p_page_help       => :P1110_PAGE_HELP,',
'        p_link_column     => :P1110_LINK_COLUMN,',
'        p_link_key        => :P1110_LINK_KEY,',
'        p_link_to_page    => :P1110_LINK_TO_PAGE,',
'        p_link_target_key => :P1110_LINK_TARGET_KEY );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3315121221162951164)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3315125151526951195)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_timeline wwv_flow_define_app_v3.t_timeline;',
'begin',
'    l_timeline.username_column := :P1110_USER;',
'    l_timeline.date_column := :P1110_EVENT_DATE;',
'    l_timeline.event_name_column := :P1110_EVENT_NAME;',
'    l_timeline.desc_column := :P1110_EVENT_DESC;',
'',
'    wwv_flow_define_app_v3.edit_page(',
'        p_page_id         => :P1110_SEQ_ID,',
'        p_page_name       => :P1110_PAGE_NAME,',
'        p_page_type       => :P1110_PAGE_TYPE,',
'        p_page_icon       => :P1110_PAGE_ICON,',
'        p_schema          => :P1_SCHEMA,',
'        p_source_type     => ''TABLE'',',
'        p_table_name      => :P1110_TABLE,',
'        p_is_homepage     => ( :P1110_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page   => ( :P1110_ADMIN = ''Y'' ),',
'        p_timeline        => l_timeline,',
'        p_page_help       => :P1110_PAGE_HELP,',
'        p_link_column     => :P1110_LINK_COLUMN,',
'        p_link_key        => :P1110_LINK_KEY,',
'        p_link_to_page    => :P1110_LINK_TO_PAGE,',
'        p_link_target_key => :P1110_LINK_TARGET_KEY );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3315120034382951164)
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3315123948369951192)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1110_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3315120842117951164)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3315125543820951195)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3315124362001951192)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select seq_id,',
'                      n002 internal_page_id,',
'                      c001 page_name,',
'                      c002 page_type,',
'                      ''TABLE'' source_type,',
'                      c005 table_name,',
'                      c013 page_icon,',
'                      c015 is_admin_page,',
'                      --',
'                      c016 username_col,',
'                      c017 event_date_col,',
'                      c018 event_name_col,',
'                      c019 event_desc_col,',
'                      --',
'                      c040 help,',
'                      --',
'                      c041 link_col,',
'                      c042 link_key,',
'                      c043 link_to_page,',
'                      c044 link_target_key',
'               from apex_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1110_SEQ_ID )',
'loop',
'    :P1110_PAGE_NAME := l_page.page_name;',
'    :P1110_PAGE_TYPE := l_page.page_type;',
'    :P1110_PAGE_SOURCE := l_page.source_type;',
'    :P1110_TABLE := l_page.table_name;',
'    :P1110_PAGE_ICON := l_page.page_icon;    ',
'',
'    :P1110_USER := l_page.username_col;',
'    :P1110_EVENT_DATE := l_page.event_date_col;',
'    :P1110_EVENT_NAME := l_page.event_name_col;',
'    :P1110_EVENT_DESC := l_page.event_desc_col;',
'',
'    :P1110_LINK_COLUMN := l_page.link_col;',
'    :P1110_LINK_KEY := l_page.link_key;',
'    :P1110_LINK_TO_PAGE := l_page.link_to_page;',
'    :P1110_LINK_TARGET_KEY := l_page.link_target_key;',
'',
'    :P1110_ADMIN := l_page.is_admin_page;',
'    :P1060_PAGE_HELP := l_page.help;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1110_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_01120
begin
wwv_flow_api.create_page(
 p_id=>1120
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Create Wizard Pages'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Wizard Pages'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'initWizardModal = function() {',
'    function _initDialog() {',
'        var headerheight = $(''.a-Dialog-wizardSteps'').height(),',
'            footerheight = $(''.a-Dialog-footer'').height();',
'        $(''.a-Dialog-body'').css({',
'            ''top'':headerheight,',
'            ''bottom'':footerheight',
'        });',
'    }',
'    $(window).bind(''apexwindowresized'', function() {',
'        _initDialog();',
'    });',
'    _initDialog();',
'};'))
,p_javascript_code_onload=>'initWizardModal();'
,p_step_template=>wwv_flow_api.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'520'
,p_dialog_width=>'800'
,p_last_upd_yyyymmddhh24miss=>'20180213155040'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3398990797712869201)
,p_plug_name=>'Items'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 16px 8px 16px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13042305435186644880)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3273871575473525717)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20433604485399002096)
,p_plug_name=>'Items'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(28547116405622590796)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(28547116981965590802)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3315139146989956369)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(28547116405622590796)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1120_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1120_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3315142668733956373)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(28547116981965590802)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1120_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3315143034235956374)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(28547116981965590802)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_condition=>'P1120_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3315141834544956373)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(28547116981965590802)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:WIZARD_PAGE'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3315142257278956373)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(28547116981965590802)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1120_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3315143452750956374)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(28547116981965590802)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1120_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3315143822412956374)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(28547116981965590802)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1120_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3315154608148956385)
,p_branch_name=>'Redirect to Login Page'
,p_branch_action=>'f?p=4550:1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(3315143822412956374)
,p_branch_sequence=>1
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315108253332942906)
,p_name=>'P1120_PAGE_MODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3398990797712869201)
,p_item_default=>'MODAL'
,p_prompt=>'Page Mode'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD_PAGE_MODE'
,p_lov=>'.'||wwv_flow_api.id(3315174268901073640)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315108318250942907)
,p_name=>'P1120_STEP_1'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(20433604485399002096)
,p_prompt=>'Step 1'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315108410895942908)
,p_name=>'P1120_STEP_2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(20433604485399002096)
,p_prompt=>'Step 2'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315108538632942909)
,p_name=>'P1120_STEP_3'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(20433604485399002096)
,p_prompt=>'Step 3'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315108659665942910)
,p_name=>'P1120_STEP_4'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(20433604485399002096)
,p_prompt=>'Step 4'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315108729582942911)
,p_name=>'P1120_STEP_5'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(20433604485399002096)
,p_prompt=>'Step 5'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315108865844942912)
,p_name=>'P1120_NUM_STEPS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(20433604485399002096)
,p_prompt=>'Number of Steps'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:Display1;Return1,Display2;Return2'
,p_lov_display_null=>'YES'
,p_cHeight=>1
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315108965374942913)
,p_name=>'P1120_STEP_6'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(20433604485399002096)
,p_prompt=>'Step 6'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315109029456942914)
,p_name=>'P1120_STEP_7'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(20433604485399002096)
,p_prompt=>'Step 7'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315109107204942915)
,p_name=>'P1120_STEP_8'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(20433604485399002096)
,p_prompt=>'Step 8'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315135720945956365)
,p_name=>'P1120_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(13042305435186644880)
,p_prompt=>'Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1120_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS_HOMEPAGE'
,p_lov=>'.'||wwv_flow_api.id(2639480030873536264)||'.'
,p_display_when_type=>'NEVER'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1120_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315136134402956366)
,p_name=>'P1120_ADMIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(13042305435186644880)
,p_prompt=>'Administrative'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS ADMINISTRATIVE'
,p_lov=>'.'||wwv_flow_api.id(2996645622600931087)||'.'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315136597850956366)
,p_name=>'P1120_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(13042305435186644880)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315139593972956370)
,p_name=>'P1120_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(28547116405622590796)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315139956976956371)
,p_name=>'P1120_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(28547116405622590796)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315140305757956371)
,p_name=>'P1120_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(28547116405622590796)
,p_prompt=>'Wizard Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315141179283956372)
,p_name=>'P1120_PAGE_ICON'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(28547116405622590796)
,p_item_default=>'fa-magic'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3315147579038956378)
,p_name=>'Initialize Page'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3315148056940956378)
,p_event_id=>wwv_flow_api.id(3315147579038956378)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_PAGE_NAME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3019482085105899645)
,p_name=>'Initialize Step 5 and 6'
,p_event_sequence=>20
,p_condition_element=>'P1120_STEP_5'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3019482264333899647)
,p_event_id=>wwv_flow_api.id(3019482085105899645)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_STEP_5,P1120_STEP_6'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3019482573000899650)
,p_name=>'Initialize Step 7 and 8'
,p_event_sequence=>40
,p_condition_element=>'P1120_STEP_7'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3613184770663513501)
,p_event_id=>wwv_flow_api.id(3019482573000899650)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_STEP_7,P1120_STEP_8'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3315146623568956377)
,p_name=>'Show Page Source'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1120_PAGE_SOURCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3315147155671956377)
,p_event_id=>wwv_flow_api.id(3315146623568956377)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($v(this.triggeringElement) === ''SQL'') {',
'    $("#page_source_sql").show();',
'    $("#page_source_table").hide();',
'} else if ($v(this.triggeringElement) === ''TABLE'') {',
'    $("#page_source_sql").hide();',
'    $("#page_source_table").show();',
'}'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3315148450270956378)
,p_name=>'Cancel Dialog'
,p_event_sequence=>70
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3315142668733956373)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3315148978147956379)
,p_event_id=>wwv_flow_api.id(3315148450270956378)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3315149342648956380)
,p_name=>'show value column count'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1120_AGGREGATE'
,p_condition_element=>'P1120_AGGREGATE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'COUNT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3315149817154956381)
,p_event_id=>wwv_flow_api.id(3315149342648956380)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_VALUE_COL_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3315150304030956381)
,p_event_id=>wwv_flow_api.id(3315149342648956380)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_VALUE_COL_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3315150812795956382)
,p_event_id=>wwv_flow_api.id(3315149342648956380)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_VALUE_COL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3315151311119956382)
,p_event_id=>wwv_flow_api.id(3315149342648956380)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_VALUE_COL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3315151776228956382)
,p_name=>'Disable Admin'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1120_HOMEPAGE'
,p_condition_element=>'P1120_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3315152229710956383)
,p_event_id=>wwv_flow_api.id(3315151776228956382)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_ADMIN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3315152787409956383)
,p_event_id=>wwv_flow_api.id(3315151776228956382)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_ADMIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3315153159093956383)
,p_name=>'Disable Home Page'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1120_ADMIN'
,p_condition_element=>'P1120_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3315153675261956384)
,p_event_id=>wwv_flow_api.id(3315153159093956383)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_HOMEPAGE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3315154180989956384)
,p_event_id=>wwv_flow_api.id(3315153159093956383)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_HOMEPAGE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3361781368765335801)
,p_name=>'Show Step 5'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1120_STEP_4'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$(this.triggeringElement).val().length > 0'
,p_bind_type=>'bind'
,p_bind_event_type=>'keyup'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3361781433472335802)
,p_event_id=>wwv_flow_api.id(3361781368765335801)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_STEP_5'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3361782134361335809)
,p_name=>'Show Step 6'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1120_STEP_5'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$(this.triggeringElement).val().length > 0'
,p_bind_type=>'bind'
,p_bind_event_type=>'keyup'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3361782219248335810)
,p_event_id=>wwv_flow_api.id(3361782134361335809)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_STEP_6'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3361782507610335813)
,p_name=>'Show Step 7'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1120_STEP_6'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$(this.triggeringElement).val().length > 0'
,p_bind_type=>'bind'
,p_bind_event_type=>'keyup'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3361782660288335814)
,p_event_id=>wwv_flow_api.id(3361782507610335813)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_STEP_7'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3361782962378335817)
,p_name=>'Show Step 8'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1120_STEP_7'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$(this.triggeringElement).val().length > 0'
,p_bind_type=>'bind'
,p_bind_event_type=>'keyup'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3361783016076335818)
,p_event_id=>wwv_flow_api.id(3361782962378335817)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1120_STEP_8'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3315145462753956376)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_wizard wwv_flow_define_app_v3.t_wizard;',
'begin',
'    l_wizard.page_mode   := :P1120_PAGE_MODE;',
'    l_wizard.page_name_1 := :P1120_STEP_1;',
'    l_wizard.page_name_2 := :P1120_STEP_2;',
'    l_wizard.page_name_3 := :P1120_STEP_3;',
'    l_wizard.page_name_4 := :P1120_STEP_4;',
'    l_wizard.page_name_5 := :P1120_STEP_5;',
'    l_wizard.page_name_6 := :P1120_STEP_6;',
'    l_wizard.page_name_7 := :P1120_STEP_7;',
'    l_wizard.page_name_8 := :P1120_STEP_8;',
'',
'    wwv_flow_define_app_v3.add_page(',
'        p_page_name     => :P1120_PAGE_NAME,',
'        p_page_type     => :P1120_PAGE_TYPE,',
'        p_page_icon     => :P1120_PAGE_ICON,',
'        p_schema        => :P1_SCHEMA,',
'        p_is_homepage   => ( :P1120_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page => ( :P1120_ADMIN = ''Y'' ),',
'        p_wizard        => l_wizard,',
'        p_page_help     => :P1120_PAGE_HELP);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3315143452750956374)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3315145833332956376)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_wizard wwv_flow_define_app_v3.t_wizard;',
'begin',
'    l_wizard.page_mode   := :P1120_PAGE_MODE;',
'    l_wizard.page_name_1 := :P1120_STEP_1;',
'    l_wizard.page_name_2 := :P1120_STEP_2;',
'    l_wizard.page_name_3 := :P1120_STEP_3;',
'    l_wizard.page_name_4 := :P1120_STEP_4;',
'    l_wizard.page_name_5 := :P1120_STEP_5;',
'    l_wizard.page_name_6 := :P1120_STEP_6;',
'    l_wizard.page_name_7 := :P1120_STEP_7;',
'    l_wizard.page_name_8 := :P1120_STEP_8;',
'',
'    wwv_flow_define_app_v3.edit_page(',
'        p_page_id      => :P1120_SEQ_ID,',
'        p_page_name    => :P1120_PAGE_NAME,',
'        p_page_type    => :P1120_PAGE_TYPE,',
'        p_page_icon    => :P1120_PAGE_ICON,',
'        p_schema       => :P1_SCHEMA,',
'        p_is_homepage  => ( :P1120_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page => ( :P1120_ADMIN = ''Y'' ),',
'        p_wizard        => l_wizard,',
'        p_page_help     => :P1120_PAGE_HELP );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3315142257278956373)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3315144652345956375)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1120_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3315143034235956374)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3315146226576956377)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3315145046240956376)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select seq_id,',
'                      n002 internal_page_id,',
'                      c001 page_name,',
'                      c002 page_type,',
'                      c013 page_icon,',
'                      c015 is_admin_page,',
'                      --',
'                      c016 page_mode,',
'                      c017 step_1,',
'                      c018 step_2,',
'                      c019 step_3,',
'                      c020 step_4,',
'                      c021 step_5,',
'                      c022 step_6,',
'                      c023 step_7,',
'                      c024 step_8,',
'                      --',
'                      c040 help',
'               from apex_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1120_SEQ_ID )',
'loop',
'    :P1120_PAGE_NAME := l_page.page_name;',
'    :P1120_PAGE_TYPE := l_page.page_type;',
'    :P1120_PAGE_ICON := l_page.page_icon; ',
'    :P1120_ADMIN     := l_page.is_admin_page;',
'    :P1120_PAGE_HELP := l_page.help;',
'',
'    :P1120_PAGE_MODE := l_page.page_mode;',
'    :P1120_STEP_1    := l_page.step_1;',
'    :P1120_STEP_2    := l_page.step_2;',
'    :P1120_STEP_3    := l_page.step_3;',
'    :P1120_STEP_4    := l_page.step_4;',
'    :P1120_STEP_5    := l_page.step_5;',
'    :P1120_STEP_6    := l_page.step_6;',
'    :P1120_STEP_7    := l_page.step_7;',
'    :P1120_STEP_8    := l_page.step_8;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1120_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_01130
begin
wwv_flow_api.create_page(
 p_id=>1130
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Add Multiple Reports'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Multiple Reports'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(function($) {',
'    // do this after the page loads but before the IG is initialized to catch the initial events',
'    $(function() {',
'        // listen for view change events to find out when grid views are created ',
'        $("#validTables").on("interactivegridviewchange", function(event, data) {',
'            if ( data.view === "grid" && data.created ) {',
'                // no single declarative or advanced option will turn off the column header menu',
'                // because on IG init, reset or change report it gets added back.',
'                // this is what it takes to turn it off',
'                apex.region("validTables").call("getCurrentView").view$',
'                    .grid("option", "activateColumnHeader", null);',
'            }',
'        });',
'    });',
'})(apex.jQuery);',
''))
,p_step_template=>wwv_flow_api.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210622100007'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(79626216072002201)
,p_plug_name=>'Available Tables'
,p_region_name=>'validTables'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3262269949210718587)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_id,',
'       object_name table_name',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and object_name not in (select c005 table_name',
'                           from wwv_flow_collections',
'                           where collection_name = ''APEX$CREATE_APP_PAGE''',
'                           and c002 = ''INTERACTIVE_RPT''',
'                           and c003 = ''TABLE'')',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)'))
,p_plug_source_type=>'NATIVE_IG'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Available Tables'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(79626483697002203)
,p_name=>'OBJECT_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'OBJECT_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(79626557637002204)
,p_name=>'TABLE_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TABLE_NAME'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Table Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(79626756910002206)
,p_name=>'APEX$ROW_SELECTOR'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
);
wwv_flow_api.create_interactive_grid(
 p_id=>wwv_flow_api.id(79626328415002202)
,p_internal_uid=>79626328415002202
,p_is_editable=>true
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>true
,p_requires_filter=>false
,p_select_first_row=>true
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_FIELD:RESET'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_fixed_header=>'REGION'
,p_fixed_header_max_height=>518
,p_show_icon_view=>false
,p_show_detail_view=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function(config) {',
'    config.defaultGridViewOptions = {',
'        activateColumnHeader: null,',
'        reorderColumns: false,',
'        resizeColumns: false,',
'        persistSelection: true,',
'        pagination: {',
'            virtual: true',
'        }',
'    };',
'    config.defaultModelOptions = {',
'        pageSize: 500',
'    };',
'    return config;',
'}'))
);
wwv_flow_api.create_ig_report(
 p_id=>wwv_flow_api.id(79632265457995706)
,p_interactive_grid_id=>wwv_flow_api.id(79626328415002202)
,p_static_id=>'796323'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_rows_per_page=>100
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_api.create_ig_report_view(
 p_id=>wwv_flow_api.id(79632438323995706)
,p_report_id=>wwv_flow_api.id(79632265457995706)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_api.create_ig_report_column(
 p_id=>wwv_flow_api.id(79632978605995704)
,p_view_id=>wwv_flow_api.id(79632438323995706)
,p_display_seq=>1
,p_column_id=>wwv_flow_api.id(79626483697002203)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_api.create_ig_report_column(
 p_id=>wwv_flow_api.id(79633832570995698)
,p_view_id=>wwv_flow_api.id(79632438323995706)
,p_display_seq=>2
,p_column_id=>wwv_flow_api.id(79626557637002204)
,p_is_visible=>true
,p_is_frozen=>false
,p_sort_order=>1
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14050749179235766488)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(110401630005485833)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(14050749179235766488)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:MULTIPLE_REPORTS'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4212071953625544846)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(14050749179235766488)
,p_button_name=>'ADD_PAGES'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Pages'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(483397257373182151)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(14050749179235766488)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(79627128214002210)
,p_name=>'P1130_SELECTED_ROWS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(79626216072002201)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(79626958911002208)
,p_name=>'Save Selected Rows'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4212071953625544846)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(79627079658002209)
,p_event_id=>wwv_flow_api.id(79626958911002208)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Clear previous selections, if any',
'$s("P1130_SELECTED_ROWS", "");',
'',
'let gridView = apex.region("validTables").call("getViews").grid,',
'    records = gridView.getSelectedRecords(),',
'    tableName,',
'    selRecords,',
'    selRecordsJSON;',
'',
'if (records.length > 0) {',
'    selRecords  = {',
'        rows: records.map( r => gridView.model.getValue( r, "TABLE_NAME") )',
'    };',
'	// convert JSON into string',
'	selRecordsJSON = JSON.stringify( selRecords );',
'	apex.page.submit({',
'		request: "ADD_PAGES",',
'		set: {',
'			"P1130_SELECTED_ROWS": selRecordsJSON',
'		},',
'		showWait: true',
'	});',
'} else {',
'	apex.message.alert( apex.lang.getMessage("CREATE.APP.SELECT_AT_LEAST_ONE_TABLE") );',
'}'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(79627232136002211)
,p_name=>'Focus, resize Available Tables IG'
,p_event_sequence=>60
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(79627356760002212)
,p_event_id=>wwv_flow_api.id(79627232136002211)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let validTables = apex.region("validTables");',
'',
'// set focus on IG',
'validTables.call("focus");',
'',
'// the dialog seems to take a moment to get sized right so delay sizing IG region just a bit',
'setTimeout(function() {',
'    validTables.widget().height($(".a-Dialog-body").height());',
'}, 0);'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3674119118132496429)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add multiple report pages'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.add_ir_pages(',
'    p_schema              => :P1_SCHEMA,',
'    p_selected_rows_json  => :P1130_SELECTED_ROWS );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(4212071953625544846)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(483398895373182165)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_01140
begin
wwv_flow_api.create_page(
 p_id=>1140
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Add Faceted Search Page'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Faceted Search Page'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_PAGE_CONFIRM_MSG"'';'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-PageWizard-dialog .a-PageWizard--collapsibleRegion.a-Region--hideShow.a-BoxedForms .a-Region-body {',
'    margin: -12px 12px 0 12px;',
'    padding-bottom: 24px;',
'}',
'.a-Region.a-BoxedForms .a-Region-body {',
'   	color: #000;',
'}'))
,p_step_template=>wwv_flow_api.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'520'
,p_dialog_width=>'800'
,p_last_upd_yyyymmddhh24miss=>'20201202144845'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(597620541688219121)
,p_plug_name=>'Report Source Container'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(597619783321219113)
,p_plug_name=>'Table or View'
,p_parent_plug_id=>wwv_flow_api.id(597620541688219121)
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(597620272474219118)
,p_plug_name=>'Include Form'
,p_region_name=>'reg_include_form'
,p_parent_plug_id=>wwv_flow_api.id(597620541688219121)
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(598174350262635603)
,p_plug_name=>'Card Page'
,p_region_name=>'reg_cards_form'
,p_region_css_classes=>'margin-top-md'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display: none"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13816932270841065363)
,p_plug_name=>'Card Columns'
,p_region_name=>'reg_card_cols'
,p_parent_plug_id=>wwv_flow_api.id(598174350262635603)
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px; display: none;"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(598174468843635604)
,p_plug_name=>'Classic Report Page'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(2586890391916064979)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(598174545583635605)
,p_plug_name=>'Faceted Search Type'
,p_region_css_classes=>'a-BoxedLabels a-BoxedForms margin-md margin-top-none'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noPadding'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7011877070127798069)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3273871575473525717)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22516688040563743985)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22516688616906743991)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(599826999140060723)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(22516688040563743985)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1140_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1140_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(599830061458060730)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(22516688616906743991)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1140_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(599830415982060732)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(22516688616906743991)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P1140_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(599830831720060733)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(22516688616906743991)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Help'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:RP,900:P900_HELP_SECTION:CARD_PAGE'
,p_button_condition_type=>'NEVER'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(599831211883060733)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(22516688616906743991)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1140_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(599831639690060733)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(22516688616906743991)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1140_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(599832024596060734)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(22516688616906743991)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1140_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13577954947970770)
,p_name=>'P1140_LAYOUT_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(597619783321219113)
,p_item_default=>'GRID'
,p_prompt=>'Layout Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'CARDS_LAYOUT_TYPE'
,p_lov=>'.'||wwv_flow_api.id(13522227592838689)||'.'
,p_grid_column=>4
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13578312329970770)
,p_name=>'P1140_TITLE_COLUMN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(13816932270841065363)
,p_prompt=>'Title Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1140_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1140_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13578717566970770)
,p_name=>'P1140_BODY_COLUMN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(13816932270841065363)
,p_prompt=>'Body Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1140_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1140_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13579135759970770)
,p_name=>'P1140_ICON_COLUMN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(13816932270841065363)
,p_prompt=>'Icon Initials Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1140_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1140_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13579522236970771)
,p_name=>'P1140_BADGE_COLUMN'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(13816932270841065363)
,p_prompt=>'Badge Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1140_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1140_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(597620403327219120)
,p_name=>'P1140_INCLUDE_FORM'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(597620272474219118)
,p_prompt=>'Include Form'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'INCLUDE_FORM_Y'
,p_lov=>'.'||wwv_flow_api.id(2595628838376488076)||'.'
,p_tag_attributes=>'disabled'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(598174603004635606)
,p_name=>'P1140_REPORT_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(598174545583635605)
,p_item_default=>'CR'
,p_prompt=>'Report Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P1140_REPORT_TYPES'
,p_lov=>'.'||wwv_flow_api.id(599933630533543253)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(599821678943060708)
,p_name=>'P1140_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(7011877070127798069)
,p_prompt=>'Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1140_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS_HOMEPAGE'
,p_lov=>'.'||wwv_flow_api.id(2639480030873536264)||'.'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1140_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(599822421465060712)
,p_name=>'P1140_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(7011877070127798069)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(599825078086060719)
,p_name=>'P1140_TABLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(597619783321219113)
,p_prompt=>'Table'
,p_placeholder=>'- Select Table -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_css_classes=>'field--marginTop field--noBottomPadding field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
,p_attribute_07=>'Select Table'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(599827399665060727)
,p_name=>'P1140_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(22516688040563743985)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(599827796968060728)
,p_name=>'P1140_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(22516688040563743985)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(599828140398060728)
,p_name=>'P1140_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(22516688040563743985)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(599828537718060729)
,p_name=>'P1140_PAGE_SOURCE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(22516688040563743985)
,p_item_default=>'TABLE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(599828917752060729)
,p_name=>'P1140_PAGE_ICON'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(22516688040563743985)
,p_item_default=>'fa-table-search'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(599829399260060729)
,p_name=>'P1140_HAS_DRILLDOWN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(22516688040563743985)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(876906373199696724)
,p_name=>'P1140_OBJ_TYPE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(22516688040563743985)
,p_display_as=>'NATIVE_HIDDEN'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(599832501490060748)
,p_computation_sequence=>10
,p_computation_item=>'P1140_HAS_DRILLDOWN'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''Y''',
'from wwv_flow_collections',
'where collection_name = ''APEX$CREATE_APP_PAGE'' and',
'    c002 in ( ''INTERACTIVE_RPT'',  ''MASTER_DETAIL'' )'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(599834913431060754)
,p_validation_name=>'Table cannot be null'
,p_validation_sequence=>10
,p_validation=>'P1140_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(649585402986583201)
,p_validation_name=>'is valid faceted search source'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_is_valid_filter_source  boolean;',
'    l_top5_facet_column_names wwv_flow_t_varchar2;',
'begin',
'    l_top5_facet_column_names := wwv_flow_faceted_search_dev.get_top5_facet_columns(',
'                                     p_table_owner    => :P1_SCHEMA,',
'                                     p_table_name     => :P1140_TABLE );',
'    ',
'    l_is_valid_filter_source := wwv_flow_faceted_search_dev.valid_faceted_search_source(',
'        p_parse_as_schema      => :P1_SCHEMA,',
'        p_location             => wwv_flow_exec_api.c_location_local_db,',
'        p_query_type           => wwv_flow_exec_api.c_query_type_table, ',
'        p_table_owner          => :P1_SCHEMA,',
'        p_table_name           => :P1140_TABLE,',
'        p_facet_columns        => l_top5_facet_column_names );',
'',
'    if l_is_valid_filter_source then',
'        return true;',
'    else',
'        -- raise validation error if not valid',
'        return false;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The wizard cannot create a faceted search using the report source.  There are no columns to search.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1140_TABLE is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(13218885055147305)
,p_validation_name=>'card layout type not null'
,p_validation_sequence=>80
,p_validation=>'P1140_LAYOUT_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1140_REPORT_TYPE = ''CARD'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(13577954947970770)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(13427899978384619)
,p_validation_name=>'card title not null'
,p_validation_sequence=>90
,p_validation=>'P1140_TITLE_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1140_REPORT_TYPE = ''CARD'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(13578312329970770)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(599837250841060757)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(599830061458060730)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(599837764916060758)
,p_event_id=>wwv_flow_api.id(599837250841060757)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(599838141158060759)
,p_name=>'Disable Admin'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1140_HOMEPAGE'
,p_condition_element=>'P1140_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(599838624143060759)
,p_event_id=>wwv_flow_api.id(599838141158060759)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1140_ADMIN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(599839149269060759)
,p_event_id=>wwv_flow_api.id(599838141158060759)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1140_ADMIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(599839504180060760)
,p_name=>'Disable Home Page'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1140_ADMIN'
,p_condition_element=>'P1140_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(599840027926060760)
,p_event_id=>wwv_flow_api.id(599839504180060760)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1140_HOMEPAGE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(599840570414060760)
,p_event_id=>wwv_flow_api.id(599839504180060760)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1140_HOMEPAGE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(597620634470219122)
,p_name=>'Toggle Cards or Reports'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1140_REPORT_TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(597621525200219131)
,p_event_id=>wwv_flow_api.id(597620634470219122)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var reportType = $v(''P1140_REPORT_TYPE''),',
'    pageIcon = $v(''P1140_PAGE_ICON''),',
'    iconPicker$ = $("#icon_picker .a-Icon"),',
'    cardsIcon = ''fa-cards'',',
'    reportIcon = ''fa-table-search'',',
'    includeFormRegion$ = $("#reg_include_form"),',
'    cardsFormRegion$ = $("#reg_cards_form");',
'',
'// Hide Impacted Regions',
'includeFormRegion$.hide();',
'cardsFormRegion$.hide();',
'',
'if (reportType === ''CR'') {',
'    includeFormRegion$.show();',
'    if (pageIcon === cardsIcon) {',
'        iconPicker$.removeClass(cardsIcon).addClass(reportIcon);',
'        $s(''P1140_PAGE_ICON'',reportIcon);',
'    }',
'} else if (reportType === ''CARD'') {',
'    cardsFormRegion$.show();',
'    if (pageIcon === reportIcon) {',
'        iconPicker$.removeClass(reportIcon).addClass(cardsIcon);',
'        $s(''P1140_PAGE_ICON'',cardsIcon);',
'    }',
'}'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(601373136772988615)
,p_name=>'Get Card Title'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1140_TITLE_COLUMN'
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(601373270391988616)
,p_event_id=>wwv_flow_api.id(601373136772988615)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select display_col_1 as title',
'      from wwv_dictionary_cache_obj',
'     where object_owner = :P1_SCHEMA',
'       and object_name = :P1140_TABLE',
'       and security_group_id = :WORKSPACE_ID',
')',
'loop',
'    :P1140_TITLE_COLUMN := c1.title;',
'end loop;'))
,p_attribute_03=>'P1140_TITLE_COLUMN'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(601373811781988622)
,p_name=>'Get Card Description'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1140_BODY_COLUMN'
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(601373928331988623)
,p_event_id=>wwv_flow_api.id(601373811781988622)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select display_col_2 as description',
'      from wwv_dictionary_cache_obj',
'     where object_owner = :P1_SCHEMA',
'       and object_name = :P1140_TABLE',
'       and security_group_id = :WORKSPACE_ID',
')',
'loop',
'    :P1140_BODY_COLUMN  := c1.description;',
'end loop;'))
,p_attribute_03=>'P1140_BODY_COLUMN'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(579566279113721530)
,p_name=>'set table cache'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1140_TABLE'
,p_condition_element=>'P1140_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(579566318010721531)
,p_event_id=>wwv_flow_api.id(579566279113721530)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_workspace_name varchar2(255);',
'begin',
'    l_workspace_name := htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID );',
'    wwv_dictionary_cache_dev.set_dictionary_table_cache(',
'        p_workspace_name           => l_workspace_name,',
'        p_schema                   => :P1_SCHEMA,',
'        p_table_name               => :P1140_TABLE,',
'        p_cache_fk_references     => true );',
'end;'))
,p_attribute_02=>'P1140_TABLE'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(601373730031988621)
,p_event_id=>wwv_flow_api.id(579566279113721530)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1140_TITLE_COLUMN,P1140_BODY_COLUMN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(876906762849699545)
,p_name=>'Enable or Disable Include Form'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1140_OBJ_TYPE'
,p_condition_element=>'P1140_OBJ_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(876907164929699548)
,p_event_id=>wwv_flow_api.id(876906762849699545)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1140_INCLUDE_FORM'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(876907629593699548)
,p_event_id=>wwv_flow_api.id(876906762849699545)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1140_INCLUDE_FORM'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(876908125797699549)
,p_event_id=>wwv_flow_api.id(876906762849699545)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1140_INCLUDE_FORM'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(876908598747702563)
,p_name=>'Get Object Type'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1140_TABLE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(876908994862702563)
,p_event_id=>wwv_flow_api.id(876908598747702563)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select object_type ',
'from sys.dba_objects ',
'where owner = :P1_SCHEMA ',
'      and object_name = :P1140_TABLE',
') loop',
'    :P1140_OBJ_TYPE := c1.object_type;',
'end loop;'))
,p_attribute_02=>'P1140_TABLE'
,p_attribute_03=>'P1140_OBJ_TYPE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(632191061786032101)
,p_name=>'show/hide card attr'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1140_REPORT_TYPE'
,p_condition_element=>'P1140_REPORT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CARD'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(632191109860032102)
,p_event_id=>wwv_flow_api.id(632191061786032101)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1140_LAYOUT_TYPE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(597621744704219133)
,p_event_id=>wwv_flow_api.id(632191061786032101)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#reg_card_cols'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(632191285105032103)
,p_event_id=>wwv_flow_api.id(632191061786032101)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1140_LAYOUT_TYPE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(597621889165219134)
,p_event_id=>wwv_flow_api.id(632191061786032101)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#reg_card_cols'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(599836045385060756)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_card       wwv_flow_define_app_v3.t_card;',
'    l_facet_type varchar2(255) := :P1140_REPORT_TYPE;',
'begin',
'    if :P1140_REPORT_TYPE = ''CARD'' then',
'        l_card.layout_type    := :P1140_LAYOUT_TYPE;',
'        l_card.title_column   := :P1140_TITLE_COLUMN;',
'        l_card.body_column    := :P1140_BODY_COLUMN;',
'        l_card.icon_column    := :P1140_ICON_COLUMN;',
'        l_card.badge_column   := :P1140_BADGE_COLUMN;',
'    end if;',
'',
'    wwv_flow_define_app_v3.add_page(',
'        p_page_name       => :P1140_PAGE_NAME,',
'        p_page_type       => wwv_flow_define_app_v3.c_page_faceted_search,',
'        p_page_icon       => :P1140_PAGE_ICON,',
'        p_schema          => :P1_SCHEMA,',
'        p_source_type     => ''TABLE'',',
'        p_table_name      => :P1140_TABLE,',
'        p_is_homepage     => ( :P1140_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page   => ( :P1140_ADMIN = ''Y'' ),',
'        p_fs_report_type  => :P1140_REPORT_TYPE,',
'        p_card            => case when l_facet_type = ''CARD'' then l_card else null end,',
'        p_page_help       => :P1140_PAGE_HELP,',
'        p_include_form     => ( :P1140_INCLUDE_FORM = ''Y'' ) );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(599831639690060733)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(599836404251060756)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_card       wwv_flow_define_app_v3.t_card;',
'begin',
'    if :P1140_REPORT_TYPE = ''CARD'' then',
'        l_card.layout_type    := :P1140_LAYOUT_TYPE;',
'        l_card.title_column   := :P1140_TITLE_COLUMN;',
'        l_card.body_column    := :P1140_BODY_COLUMN;',
'        l_card.icon_column    := :P1140_ICON_COLUMN;',
'        l_card.badge_column   := :P1140_BADGE_COLUMN;',
'    end if;',
'',
'    wwv_flow_define_app_v3.edit_page(',
'        p_page_id         => :P1140_SEQ_ID,',
'        p_page_name       => :P1140_PAGE_NAME,',
'        p_page_type       => wwv_flow_define_app_v3.c_page_faceted_search,',
'        p_page_icon       => :P1140_PAGE_ICON,',
'        p_schema          => :P1_SCHEMA,',
'        p_source_type     => ''TABLE'',',
'        p_table_name      => :P1140_TABLE,',
'        p_is_homepage     => ( :P1140_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page   => ( :P1140_ADMIN = ''Y'' ),',
'        p_fs_report_type  => :P1140_REPORT_TYPE,',
'        p_card            => l_card,',
'        p_page_help       => :P1140_PAGE_HELP,',
'        p_include_form     => ( :P1140_INCLUDE_FORM = ''Y'' ) );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(599831211883060733)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(599835231239060754)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1140_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(599830415982060732)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(599836885761060757)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(599835694409060754)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select seq_id,',
'                      n002 internal_page_id,',
'                      c001 page_name,',
'                      c002 page_type,',
'                      ''TABLE'' source_type,',
'                      c005 table_name,',
'                      c013 page_icon,',
'                      c012 include_form,',
'                      c015 is_admin_page,',
'                      c016 layout_type,',
'                      c017 title_column,',
'                      c018 body_column,',
'                      c019 icon_column,',
'                      c020 badge_column,',
'                      c031 fs_report_type,',
'                      c040 help',
'               from apex_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1140_SEQ_ID )',
'loop',
'    :P1140_PAGE_NAME := l_page.page_name;',
'    :P1140_PAGE_TYPE := l_page.page_type;',
'    :P1140_PAGE_SOURCE := l_page.source_type;',
'    :P1140_TABLE := l_page.table_name;',
'    :P1140_PAGE_ICON := l_page.page_icon;',
'    ',
'    :P1140_REPORT_TYPE := l_page.fs_report_type;',
'    :P1140_INCLUDE_FORM := l_page.include_form;',
'    ',
'    if l_page.fs_report_type = ''CARD'' then',
'        :P1140_LAYOUT_TYPE  := l_page.layout_type;',
'        :P1140_TITLE_COLUMN := l_page.title_column;',
'        :P1140_BODY_COLUMN  := l_page.body_column;',
'        :P1140_ICON_COLUMN  := l_page.icon_column;',
'        :P1140_BADGE_COLUMN := l_page.badge_column;',
'    end if;',
'',
'    :P1140_PAGE_HELP := l_page.help;',
'    ',
'    -- set object type (used for Include Form item)',
'    for l_obj in (',
'        select object_type ',
'        from sys.dba_objects ',
'        where owner = :P1_SCHEMA ',
'        and object_name = l_page.table_name )',
'    loop',
'        :P1140_OBJ_TYPE := l_obj.object_type;',
'    end loop;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1140_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_01150
begin
wwv_flow_api.create_page(
 p_id=>1150
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Create Map Page'
,p_alias=>'CREATE-MAP-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Map Page'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-PageWizard-dialog .a-PageWizard--collapsibleRegion.a-Region--hideShow.a-BoxedForms .a-Region-body {',
'    margin: -12px 12px 0 12px;',
'    padding-bottom: 24px;',
'}',
'.a-Region.a-BoxedForms .a-Region-body {',
'   	color: #000;',
'}'))
,p_step_template=>wwv_flow_api.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'520'
,p_dialog_width=>'800'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210519130216'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3802851654245128)
,p_plug_name=>'Layer Type'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(601020734473382940)
,p_plug_name=>'Map Source'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7015377219709967515)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3273871575473525717)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22519989627857903240)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22520288724559916920)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3301856841159279)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(22519989627857903240)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1150_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1150_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3600454290172970)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(22520288724559916920)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1150_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3600882245172971)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(22520288724559916920)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P1150_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3601600683172972)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(22520288724559916920)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1150_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3602048392172972)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(22520288724559916920)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1150_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3602410675172972)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(22520288724559916920)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1150_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3302215827159283)
,p_name=>'P1150_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(22519989627857903240)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3302694877159285)
,p_name=>'P1150_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(22519989627857903240)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3303030698159285)
,p_name=>'P1150_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(22519989627857903240)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3303464317159285)
,p_name=>'P1150_PAGE_SOURCE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(22519989627857903240)
,p_item_default=>'TABLE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3303814188159285)
,p_name=>'P1150_PAGE_ICON'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(22519989627857903240)
,p_item_default=>'fa-map-marker'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3400738384163847)
,p_name=>'P1150_TABLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3802851654245128)
,p_prompt=>'Table'
,p_placeholder=>'- Select Table -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
,p_attribute_07=>'Select Table'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3401168750163849)
,p_name=>'P1150_LAYER_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3802851654245128)
,p_item_default=>'POINT'
,p_prompt=>'Layer Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'MAP_REGION_LAYER_TYPE'
,p_lov=>'.'||wwv_flow_api.id(3749589329218593)||'.'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3500467148169480)
,p_name=>'P1150_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(7015377219709967515)
,p_prompt=>'Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1150_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS_HOMEPAGE'
,p_lov=>'.'||wwv_flow_api.id(2639480030873536264)||'.'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1150_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3500871641169482)
,p_name=>'P1150_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(7015377219709967515)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3800471518245104)
,p_name=>'P1150_GEOMETRY_COLUMN_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(601020734473382940)
,p_item_default=>'GEOMETRY'
,p_prompt=>'Geometry Column Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'MAP_REGION_GEOMETRY_COLUMN_TYPE'
,p_lov=>'.'||wwv_flow_api.id(4053243666374435)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(3071359888141100707)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3800655351245106)
,p_name=>'P1150_GEOM_COLUMN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(601020734473382940)
,p_prompt=>'Geometry Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1150_TABLE',
'  and data_type in (''CLOB'', ''VARCHAR2'', ''SDO_GEOMETRY'' )',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1150_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3800753486245107)
,p_name=>'P1150_LON_COLUMN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(601020734473382940)
,p_prompt=>'Longitude Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1150_TABLE',
'  and data_type = ''NUMBER'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1150_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3800841041245108)
,p_name=>'P1150_LAT_COLUMN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(601020734473382940)
,p_prompt=>'Latitude Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1150_TABLE',
'  and data_type = ''NUMBER'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1150_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3800911929245109)
,p_name=>'P1150_3D_VALUE_COLUMN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(601020734473382940)
,p_prompt=>'Extrusion Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1150_TABLE',
'  and data_type = ''NUMBER'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1150_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3801001591245110)
,p_name=>'P1150_VALUE_COLUMN'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(601020734473382940)
,p_prompt=>'Color Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1150_TABLE',
'  and data_type = ''NUMBER'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1150_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3801102417245111)
,p_name=>'P1150_HEAT_VALUE_COLUMN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(601020734473382940)
,p_prompt=>'Color Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1150_TABLE',
'  and data_type = ''NUMBER'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1150_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3801242705245112)
,p_name=>'P1150_TOOLTIP_COLUMN'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(601020734473382940)
,p_prompt=>'Tooltip Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1150_TABLE',
'order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1150_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4611639347161305)
,p_validation_name=>'Table cannot be null'
,p_validation_sequence=>10
,p_validation=>'P1150_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_associated_item=>wwv_flow_api.id(3400738384163847)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4611762141161306)
,p_validation_name=>'Geometry Column NOT NULL'
,p_validation_sequence=>20
,p_validation=>'P1150_GEOM_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1150_GEOMETRY_COLUMN_TYPE = ''GEOMETRY'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(3800655351245106)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4611823227161307)
,p_validation_name=>'Longitude Column NOT NULL'
,p_validation_sequence=>30
,p_validation=>'P1150_LON_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1150_GEOMETRY_COLUMN_TYPE = ''NUMBER'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(3800753486245107)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4611991542161308)
,p_validation_name=>'Latitude Column NOT NULL'
,p_validation_sequence=>40
,p_validation=>'P1150_LAT_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1150_GEOMETRY_COLUMN_TYPE = ''NUMBER'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(3800841041245108)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4612139308161310)
,p_validation_name=>'3D Value Column NOT NULL'
,p_validation_sequence=>50
,p_validation=>'P1150_3D_VALUE_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1150_LAYER_TYPE = ''POLYGON_3D'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(3800911929245109)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3801381918245113)
,p_name=>'Polygon/Line Layer'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1150_LAYER_TYPE'
,p_condition_element=>'P1150_LAYER_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'LINE,POLYGON'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3801457282245114)
,p_event_id=>wwv_flow_api.id(3801381918245113)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_GEOMETRY_COLUMN_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'GEOMETRY'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3801534476245115)
,p_event_id=>wwv_flow_api.id(3801381918245113)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_GEOMETRY_COLUMN_TYPE,P1150_3D_VALUE_COLUMN,P1150_HEAT_VALUE_COLUMN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3801640037245116)
,p_event_id=>wwv_flow_api.id(3801381918245113)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_VALUE_COLUMN,P1150_TOOLTIP_COLUMN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4611264989161301)
,p_name=>'Line Layer'
,p_event_sequence=>15
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1150_LAYER_TYPE'
,p_condition_element=>'P1150_LAYER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LINE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4611340754161302)
,p_event_id=>wwv_flow_api.id(4611264989161301)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_VALUE_COLUMN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3801712304245117)
,p_name=>'3D Polygon Layer'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1150_LAYER_TYPE'
,p_condition_element=>'P1150_LAYER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'POLYGON_3D'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3801840095245118)
,p_event_id=>wwv_flow_api.id(3801712304245117)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_GEOMETRY_COLUMN_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'GEOMETRY'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3801929883245119)
,p_event_id=>wwv_flow_api.id(3801712304245117)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_GEOMETRY_COLUMN_TYPE,P1150_HEAT_VALUE_COLUMN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3802004717245120)
,p_event_id=>wwv_flow_api.id(3801712304245117)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_3D_VALUE_COLUMN,P1150_VALUE_COLUMN,P1150_TOOLTIP_COLUMN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3802113049245121)
,p_name=>'Point Layer'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1150_LAYER_TYPE'
,p_condition_element=>'P1150_LAYER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'POINT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3802218260245122)
,p_event_id=>wwv_flow_api.id(3802113049245121)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_GEOMETRY_COLUMN_TYPE,P1150_TOOLTIP_COLUMN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3802319580245123)
,p_event_id=>wwv_flow_api.id(3802113049245121)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_3D_VALUE_COLUMN,P1150_HEAT_VALUE_COLUMN,P1150_VALUE_COLUMN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3802432466245124)
,p_name=>'Heatmap Layer'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1150_LAYER_TYPE'
,p_condition_element=>'P1150_LAYER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HEATMAP'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3802520283245125)
,p_event_id=>wwv_flow_api.id(3802432466245124)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_GEOMETRY_COLUMN_TYPE,P1150_HEAT_VALUE_COLUMN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3802692377245126)
,p_event_id=>wwv_flow_api.id(3802432466245124)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_3D_VALUE_COLUMN,P1150_VALUE_COLUMN,P1150_TOOLTIP_COLUMN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3802999867245129)
,p_name=>'Geometry Column Type'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1150_GEOMETRY_COLUMN_TYPE'
,p_condition_element=>'P1150_GEOMETRY_COLUMN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'GEOMETRY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3803059472245130)
,p_event_id=>wwv_flow_api.id(3802999867245129)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_GEOM_COLUMN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3803384241245133)
,p_event_id=>wwv_flow_api.id(3802999867245129)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_LAT_COLUMN,P1150_LON_COLUMN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3803181887245131)
,p_event_id=>wwv_flow_api.id(3802999867245129)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_GEOM_COLUMN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3803245447245132)
,p_event_id=>wwv_flow_api.id(3802999867245129)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1150_LAT_COLUMN,P1150_LON_COLUMN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3803627614245136)
,p_name=>'Cancel Dialog'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3600454290172970)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3803722804245137)
,p_event_id=>wwv_flow_api.id(3803627614245136)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4602612581701101)
,p_name=>'set table cache'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1150_TABLE'
,p_condition_element=>'P1150_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4602756096701102)
,p_event_id=>wwv_flow_api.id(4602612581701101)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_workspace_name varchar2(255);',
'begin',
'    l_workspace_name := htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID );',
'    wwv_dictionary_cache_dev.set_dictionary_table_cache(',
'        p_workspace_name           => l_workspace_name,',
'        p_schema                   => :P1_SCHEMA,',
'        p_table_name               => :P1150_TABLE,',
'        p_cache_fk_references      => true );',
'',
'    select case geometry_type',
'           when ''UNKNOWN'' then ''POINT''',
'           else geometry_type',
'           end',
'      into :P1150_LAYER_TYPE',
'      from wwv_dictionary_cache_obj',
'     where object_owner      = :P1_SCHEMA',
'       and object_name       = :P1150_TABLE',
'       and security_group_id = :WORKSPACE_ID;',
'exception',
'    when NO_DATA_FOUND then',
'        :P1150_LAYER_TYPE := ''POINT'';',
'end;'))
,p_attribute_02=>'P1150_TABLE'
,p_attribute_03=>'P1150_LAYER_TYPE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4619081291196647)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_map       wwv_flow_define_app_v3.t_map;',
'begin',
'    l_map.layer_type             := :P1150_LAYER_TYPE;',
'    l_map.geometry_column_type   := :P1150_GEOMETRY_COLUMN_TYPE;',
'    l_map.geometry_column        := :P1150_GEOM_COLUMN;',
'    l_map.longitude_column       := :P1150_LON_COLUMN;',
'    l_map.latitude_column        := :P1150_LAT_COLUMN;',
'    l_map.extrusion_value_column := :P1150_3D_VALUE_COLUMN;',
'    l_map.value_column           := :P1150_VALUE_COLUMN;',
'    l_map.heat_value_column      := :P1150_HEAT_VALUE_COLUMN;',
'    l_map.tooltip_column         := :P1150_TOOLTIP_COLUMN;',
'',
'    wwv_flow_define_app_v3.add_page(',
'        p_page_name       => :P1150_PAGE_NAME,',
'        p_page_type       => wwv_flow_define_app_v3.c_page_map,',
'        p_page_icon       => :P1150_PAGE_ICON,',
'        p_schema          => :P1_SCHEMA,',
'        p_source_type     => ''TABLE'',',
'        p_table_name      => :P1150_TABLE,',
'        p_is_homepage     => ( :P1150_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page   => ( :P1150_ADMIN = ''Y'' ),',
'        p_map             => l_map,',
'        p_page_help       => :P1150_PAGE_HELP );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3602048392172972)
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4619335407197905)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_map       wwv_flow_define_app_v3.t_map;',
'begin',
'    l_map.layer_type             := :P1150_LAYER_TYPE;',
'    l_map.geometry_column_type   := :P1150_GEOMETRY_COLUMN_TYPE;',
'    l_map.geometry_column        := :P1150_GEOM_COLUMN;',
'    l_map.longitude_column       := :P1150_LON_COLUMN;',
'    l_map.latitude_column        := :P1150_LAT_COLUMN;',
'    l_map.extrusion_value_column := :P1150_3D_VALUE_COLUMN;',
'    l_map.value_column           := :P1150_VALUE_COLUMN;',
'    l_map.heat_value_column      := :P1150_HEAT_VALUE_COLUMN;',
'    l_map.tooltip_column         := :P1150_TOOLTIP_COLUMN;',
'',
'    wwv_flow_define_app_v3.edit_page(',
'        p_page_id         => :P1150_SEQ_ID,',
'        p_page_name       => :P1150_PAGE_NAME,',
'        p_page_type       => wwv_flow_define_app_v3.c_page_map,',
'        p_page_icon       => :P1150_PAGE_ICON,',
'        p_schema          => :P1_SCHEMA,',
'        p_source_type     => ''TABLE'',',
'        p_table_name      => :P1150_TABLE,',
'        p_is_homepage     => ( :P1150_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page   => ( :P1150_ADMIN = ''Y'' ),',
'        p_map             => l_map,',
'        p_page_help       => :P1150_PAGE_HELP );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3601600683172972)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4619631855199387)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1150_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3600882245172971)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4619920946201686)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4627312625003033)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select seq_id,',
'                      n002 internal_page_id,',
'                      c001 page_name,',
'                      c002 page_type,',
'                      ''TABLE'' source_type,',
'                      c005 table_name,',
'                      c013 page_icon,',
'                      c012 include_form,',
'                      c015 is_admin_page,',
'                      c016 layer_type,',
'                      c017 geometry_column_type,',
'                      c018 geometry_column,',
'                      c019 longitude_column,',
'                      c020 latitude_column,',
'                      c021 extrusion_value_column,',
'                      c022 value_column,',
'                      c023 heat_value_column,',
'                      c024 tooltip_column,',
'                      c040 help',
'               from apex_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1150_SEQ_ID )',
'loop',
'    :P1150_PAGE_NAME := l_page.page_name;',
'    :P1150_PAGE_TYPE := l_page.page_type;',
'    :P1150_PAGE_SOURCE := l_page.source_type;',
'    :P1150_TABLE := l_page.table_name;',
'    :P1150_PAGE_ICON := l_page.page_icon;',
'    ',
'    :P1150_LAYER_TYPE           := l_page.layer_type;',
'    :P1150_GEOMETRY_COLUMN_TYPE := l_page.geometry_column_type;',
'    :P1150_GEOM_COLUMN          := l_page.geometry_column;',
'    :P1150_LON_COLUMN           := l_page.longitude_column;',
'    :P1150_LAT_COLUMN           := l_page.latitude_column;',
'    :P1150_3D_VALUE_COLUMN      := l_page.extrusion_value_column;',
'    :P1150_VALUE_COLUMN         := l_page.value_column;',
'    :P1150_HEAT_VALUE_COLUMN    := l_page.heat_value_column;',
'    :P1150_TOOLTIP_COLUMN       := l_page.tooltip_column;',
'',
'    :P1150_PAGE_HELP := l_page.help;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1150_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_01160
begin
wwv_flow_api.create_page(
 p_id=>1160
,p_user_interface_id=>wwv_flow_api.id(2563473516491437785)
,p_name=>'Add Smart Filters Page'
,p_alias=>'ADD-SMART-FILTERS-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Smart Filters Page'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_PAGE_CONFIRM_MSG"'';'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-PageWizard-dialog .a-PageWizard--collapsibleRegion.a-Region--hideShow.a-BoxedForms .a-Region-body {',
'    margin: -12px 12px 0 12px;',
'    padding-bottom: 24px;',
'}',
'.a-Region.a-BoxedForms .a-Region-body {',
'   	color: #000;',
'}'))
,p_step_template=>wwv_flow_api.id(3272976625713321802)
,p_page_css_classes=>'a-PageWizard-dialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'520'
,p_dialog_width=>'800'
,p_last_updated_by=>''
,p_last_upd_yyyymmddhh24miss=>'20210806052543'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(602425565337582495)
,p_plug_name=>'Report Source Container'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(602424806970582487)
,p_plug_name=>'Table or View'
,p_parent_plug_id=>wwv_flow_api.id(602425565337582495)
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(602425296123582492)
,p_plug_name=>'Include Form'
,p_region_name=>'reg_include_form'
,p_parent_plug_id=>wwv_flow_api.id(602425565337582495)
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(602979373911998977)
,p_plug_name=>'Card Page'
,p_region_name=>'reg_cards_form'
,p_region_css_classes=>'margin-top-md'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display: none"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13821737294490428737)
,p_plug_name=>'Card Columns'
,p_region_name=>'reg_card_cols'
,p_parent_plug_id=>wwv_flow_api.id(602979373911998977)
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px; display: none;"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(602979492492998978)
,p_plug_name=>'Classic Report Page'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(2586890391916064979)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(602979569232998979)
,p_plug_name=>'Result Region Type'
,p_region_css_classes=>'a-BoxedLabels a-BoxedForms margin-md margin-top-none'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noPadding'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7016682093777161443)
,p_plug_name=>'Advanced'
,p_region_css_classes=>'a-PageWizard--collapsibleRegion'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin: 0 16px"'
,p_plug_template=>wwv_flow_api.id(3273871575473525717)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22521493064213107359)
,p_plug_name=>'Page Name and Icon Container'
,p_region_css_classes=>'a-BoxedForms'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 24px"'
,p_plug_template=>wwv_flow_api.id(3300810815961795652)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22521493640556107365)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3271069058970016268)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4812077941363415)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(22521493064213107359)
,p_button_name=>'SET_ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(2988804730938183125)
,p_button_image_alt=>'Set Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:RP:P110_PASS_BACK_TO_UI,P110_PASS_BACK_TO_SAVE:icon_picker,P1160_PAGE_ICON'
,p_button_css_classes=>'a-PWIconPicker-pickerButton'
,p_icon_css_classes=>'fa &P1160_PAGE_ICON.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_grid_column_span=>2
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4815547868363419)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(22521493640556107365)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1160_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4815948157363419)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(22521493640556107365)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P1160_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4816745857363420)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(22521493640556107365)
,p_button_name=>'SAVE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1160_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4817127380363420)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(22521493640556107365)
,p_button_name=>'CREATE'
,p_button_static_id=>'P1_NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(2758666493011882367)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P1160_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4817588275363420)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(22521493640556107365)
,p_button_name=>'PREVIOUS'
,p_button_static_id=>'P1_CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(2937736309958680193)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:RP,1000::'
,p_button_condition=>'P1160_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4805929940363405)
,p_name=>'P1160_TABLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(602424806970582487)
,p_prompt=>'Table'
,p_placeholder=>'- Select Table -'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'AVAILABLE_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name v',
'  from sys.dba_objects',
' where object_type in (''TABLE'',''VIEW'')',
'   and object_name not like ''BIN$%''',
'   and owner = :P1_SCHEMA',
'   and owner in (select schema',
'                     from wwv_flow_company_schemas',
'                    where security_group_id = :flow_security_group_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_css_classes=>'field--marginTop field--noBottomPadding field--noPadding'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
,p_attribute_07=>'Select Table'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4806373120363410)
,p_name=>'P1160_LAYOUT_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(602424806970582487)
,p_item_default=>'GRID'
,p_prompt=>'Layout Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'CARDS_LAYOUT_TYPE'
,p_lov=>'.'||wwv_flow_api.id(13522227592838689)||'.'
,p_grid_column=>4
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4807097552363410)
,p_name=>'P1160_INCLUDE_FORM'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(602425296123582492)
,p_prompt=>'Include Form'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'INCLUDE_FORM_Y'
,p_lov=>'.'||wwv_flow_api.id(2595628838376488076)||'.'
,p_tag_attributes=>'disabled'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4808010728363412)
,p_name=>'P1160_TITLE_COLUMN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(13821737294490428737)
,p_prompt=>'Title Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1160_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1160_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4808494254363412)
,p_name=>'P1160_BODY_COLUMN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(13821737294490428737)
,p_prompt=>'Body Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1160_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1160_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4808883215363412)
,p_name=>'P1160_ICON_COLUMN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(13821737294490428737)
,p_prompt=>'Icon Initials Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1160_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1160_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4809239153363412)
,p_name=>'P1160_BADGE_COLUMN'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(13821737294490428737)
,p_prompt=>'Badge Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(column_name) D, column_name R',
'from sys.dba_tab_columns',
'where  owner = :P1_SCHEMA',
'and owner in (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :flow_security_group_id)',
'  and table_name = :P1160_TABLE',
'  and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id  '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1160_TABLE'
,p_ajax_items_to_submit=>'P1_SCHEMA'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(2584586946052082315)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4810299762363413)
,p_name=>'P1160_REPORT_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(602979569232998979)
,p_item_default=>'CR'
,p_prompt=>'Report Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P1140_REPORT_TYPES'
,p_lov=>'.'||wwv_flow_api.id(599933630533543253)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4810917271363414)
,p_name=>'P1160_HOMEPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(7016682093777161443)
,p_prompt=>'Home Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_define_app_v3.is_home_page( p_page_id => :P1160_SEQ_ID ) then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IS_HOMEPAGE'
,p_lov=>'.'||wwv_flow_api.id(2639480030873536264)||'.'
,p_read_only_when=>'return wwv_flow_define_app_v3.is_home_page( p_page_id => :P1160_SEQ_ID );'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(3271822809773116508)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4811315719363415)
,p_name=>'P1160_PAGE_HELP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(7016682093777161443)
,p_prompt=>'Page Help'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(3076592553081438826)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4812402283363417)
,p_name=>'P1160_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(22521493064213107359)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4812894499363418)
,p_name=>'P1160_PAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(22521493064213107359)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4813231579363418)
,p_name=>'P1160_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(22521493064213107359)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(2716804030064502999)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4813665278363418)
,p_name=>'P1160_PAGE_SOURCE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(22521493064213107359)
,p_item_default=>'TABLE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4814085822363418)
,p_name=>'P1160_PAGE_ICON'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(22521493064213107359)
,p_item_default=>'fa-table-search'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4814841316363418)
,p_name=>'P1160_OBJ_TYPE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(22521493064213107359)
,p_display_as=>'NATIVE_HIDDEN'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4819210388363441)
,p_validation_name=>'Table cannot be null'
,p_validation_sequence=>10
,p_validation=>'P1160_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4819612958363441)
,p_validation_name=>'is valid smart filter source'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_is_valid_filter_source  boolean;',
'    l_top5_facet_column_names wwv_flow_t_varchar2;',
'begin',
'    l_top5_facet_column_names := wwv_flow_faceted_search_dev.get_top5_facet_columns(',
'                                     p_table_owner    => :P1_SCHEMA,',
'                                     p_table_name     => :P1160_TABLE );',
'    ',
'    l_is_valid_filter_source := wwv_flow_faceted_search_dev.valid_faceted_search_source(',
'        p_parse_as_schema      => :P1_SCHEMA,',
'        p_location             => wwv_flow_exec_api.c_location_local_db,',
'        p_query_type           => wwv_flow_exec_api.c_query_type_table, ',
'        p_table_owner          => :P1_SCHEMA,',
'        p_table_name           => :P1160_TABLE,',
'        p_facet_columns        => l_top5_facet_column_names );',
'',
'    if l_is_valid_filter_source then',
'        return true;',
'    else',
'        -- raise validation error if not valid',
'        return false;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The wizard cannot create a smart filters using the report source.  There are no columns to search.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1160_TABLE is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4818472649363440)
,p_validation_name=>'card layout type not null'
,p_validation_sequence=>80
,p_validation=>'P1160_LAYOUT_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1160_REPORT_TYPE = ''CARD'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(4806373120363410)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4818824054363440)
,p_validation_name=>'card title not null'
,p_validation_sequence=>90
,p_validation=>'P1160_TITLE_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1160_REPORT_TYPE = ''CARD'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(4808010728363412)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4821986179363443)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4815547868363419)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4822435578363446)
,p_event_id=>wwv_flow_api.id(4821986179363443)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4822873245363446)
,p_name=>'Disable Admin'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1160_HOMEPAGE'
,p_condition_element=>'P1160_HOMEPAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4823347672363446)
,p_event_id=>wwv_flow_api.id(4822873245363446)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1160_ADMIN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4823862577363446)
,p_event_id=>wwv_flow_api.id(4822873245363446)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1160_ADMIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4824274270363447)
,p_name=>'Disable Home Page'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1160_ADMIN'
,p_condition_element=>'P1160_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4824786351363447)
,p_event_id=>wwv_flow_api.id(4824274270363447)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1160_HOMEPAGE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4825266842363447)
,p_event_id=>wwv_flow_api.id(4824274270363447)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1160_HOMEPAGE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4825658999363447)
,p_name=>'Toggle Cards or Reports'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1160_REPORT_TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4826180204363448)
,p_event_id=>wwv_flow_api.id(4825658999363447)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var reportType = $v(''P1160_REPORT_TYPE''),',
'    pageIcon = $v(''P1160_PAGE_ICON''),',
'    iconPicker$ = $("#icon_picker .a-Icon"),',
'    cardsIcon = ''fa-cards'',',
'    reportIcon = ''fa-table-search'',',
'    includeFormRegion$ = $("#reg_include_form"),',
'    cardsFormRegion$ = $("#reg_cards_form");',
'',
'// Hide Impacted Regions',
'includeFormRegion$.hide();',
'cardsFormRegion$.hide();',
'',
'if (reportType === ''CR'') {',
'    includeFormRegion$.show();',
'    if (pageIcon === cardsIcon) {',
'        iconPicker$.removeClass(cardsIcon).addClass(reportIcon);',
'        $s(''P1160_PAGE_ICON'',reportIcon);',
'    }',
'} else if (reportType === ''CARD'') {',
'    cardsFormRegion$.show();',
'    if (pageIcon === reportIcon) {',
'        iconPicker$.removeClass(reportIcon).addClass(cardsIcon);',
'        $s(''P1160_PAGE_ICON'',cardsIcon);',
'    }',
'}'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4826578679363448)
,p_name=>'Get Card Title'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1160_TITLE_COLUMN'
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4827061493363448)
,p_event_id=>wwv_flow_api.id(4826578679363448)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select display_col_1 as title',
'      from wwv_dictionary_cache_obj',
'     where object_owner = :P1_SCHEMA',
'       and object_name = :P1160_TABLE',
'       and security_group_id = :WORKSPACE_ID',
')',
'loop',
'    :P1160_TITLE_COLUMN := c1.title;',
'end loop;'))
,p_attribute_03=>'P1160_TITLE_COLUMN'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4827479800363448)
,p_name=>'Get Card Description'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1160_BODY_COLUMN'
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4827924026363448)
,p_event_id=>wwv_flow_api.id(4827479800363448)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select display_col_2 as description',
'      from wwv_dictionary_cache_obj',
'     where object_owner = :P1_SCHEMA',
'       and object_name = :P1160_TABLE',
'       and security_group_id = :WORKSPACE_ID',
')',
'loop',
'    :P1160_BODY_COLUMN  := c1.description;',
'end loop;'))
,p_attribute_03=>'P1160_BODY_COLUMN'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4828333012363448)
,p_name=>'set table cache'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1160_TABLE'
,p_condition_element=>'P1160_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4828863312363449)
,p_event_id=>wwv_flow_api.id(4828333012363448)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_workspace_name varchar2(255);',
'begin',
'    l_workspace_name := htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID );',
'    wwv_dictionary_cache_dev.set_dictionary_table_cache(',
'        p_workspace_name           => l_workspace_name,',
'        p_schema                   => :P1_SCHEMA,',
'        p_table_name               => :P1160_TABLE,',
'        p_cache_fk_references     => true );',
'end;'))
,p_attribute_02=>'P1160_TABLE'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4829367827363449)
,p_event_id=>wwv_flow_api.id(4828333012363448)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1160_TITLE_COLUMN,P1160_BODY_COLUMN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4829703065363449)
,p_name=>'Enable or Disable Include Form'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1160_OBJ_TYPE'
,p_condition_element=>'P1160_OBJ_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4830294754363449)
,p_event_id=>wwv_flow_api.id(4829703065363449)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1160_INCLUDE_FORM'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4830716977363449)
,p_event_id=>wwv_flow_api.id(4829703065363449)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1160_INCLUDE_FORM'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4831279592363450)
,p_event_id=>wwv_flow_api.id(4829703065363449)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1160_INCLUDE_FORM'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4831661448363451)
,p_name=>'Get Object Type'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1160_TABLE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4832193814363451)
,p_event_id=>wwv_flow_api.id(4831661448363451)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select object_type ',
'from sys.dba_objects ',
'where owner = :P1_SCHEMA ',
'      and object_name = :P1160_TABLE',
') loop',
'    :P1160_OBJ_TYPE := c1.object_type;',
'end loop;'))
,p_attribute_02=>'P1160_TABLE'
,p_attribute_03=>'P1160_OBJ_TYPE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
end;
/
begin
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4832583833363451)
,p_name=>'show/hide card attr'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1160_REPORT_TYPE'
,p_condition_element=>'P1160_REPORT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CARD'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4833082504363451)
,p_event_id=>wwv_flow_api.id(4832583833363451)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1160_LAYOUT_TYPE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4833547225363451)
,p_event_id=>wwv_flow_api.id(4832583833363451)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#reg_card_cols'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4834074587363451)
,p_event_id=>wwv_flow_api.id(4832583833363451)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1160_LAYOUT_TYPE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4834521988363452)
,p_event_id=>wwv_flow_api.id(4832583833363451)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#reg_card_cols'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4820769444363442)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_card       wwv_flow_define_app_v3.t_card;',
'    l_facet_type varchar2(255) := :P1160_REPORT_TYPE;',
'begin',
'    if :P1160_REPORT_TYPE = ''CARD'' then',
'        l_card.layout_type    := :P1160_LAYOUT_TYPE;',
'        l_card.title_column   := :P1160_TITLE_COLUMN;',
'        l_card.body_column    := :P1160_BODY_COLUMN;',
'        l_card.icon_column    := :P1160_ICON_COLUMN;',
'        l_card.badge_column   := :P1160_BADGE_COLUMN;',
'    end if;',
'',
'    wwv_flow_define_app_v3.add_page(',
'        p_page_name       => :P1160_PAGE_NAME,',
'        p_page_type       => wwv_flow_define_app_v3.c_page_smart_filters,',
'        p_page_icon       => :P1160_PAGE_ICON,',
'        p_schema          => :P1_SCHEMA,',
'        p_source_type     => ''TABLE'',',
'        p_table_name      => :P1160_TABLE,',
'        p_is_homepage     => ( :P1160_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page   => ( :P1160_ADMIN = ''Y'' ),',
'        p_fs_report_type  => :P1160_REPORT_TYPE,',
'        p_card            => case when l_facet_type = ''CARD'' then l_card else null end,',
'        p_page_help       => :P1160_PAGE_HELP,',
'        p_include_form     => ( :P1160_INCLUDE_FORM = ''Y'' ) );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error adding page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(4817127380363420)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4821179934363443)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Edit Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_card       wwv_flow_define_app_v3.t_card;',
'begin',
'    if :P1160_REPORT_TYPE = ''CARD'' then',
'        l_card.layout_type    := :P1160_LAYOUT_TYPE;',
'        l_card.title_column   := :P1160_TITLE_COLUMN;',
'        l_card.body_column    := :P1160_BODY_COLUMN;',
'        l_card.icon_column    := :P1160_ICON_COLUMN;',
'        l_card.badge_column   := :P1160_BADGE_COLUMN;',
'    end if;',
'',
'    wwv_flow_define_app_v3.edit_page(',
'        p_page_id         => :P1160_SEQ_ID,',
'        p_page_name       => :P1160_PAGE_NAME,',
'        p_page_type       => wwv_flow_define_app_v3.c_page_smart_filters,',
'        p_page_icon       => :P1160_PAGE_ICON,',
'        p_schema          => :P1_SCHEMA,',
'        p_source_type     => ''TABLE'',',
'        p_table_name      => :P1160_TABLE,',
'        p_is_homepage     => ( :P1160_HOMEPAGE = ''Y'' ),',
'        p_is_admin_page   => ( :P1160_ADMIN = ''Y'' ),',
'        p_fs_report_type  => :P1160_REPORT_TYPE,',
'        p_card            => l_card,',
'        p_page_help       => :P1160_PAGE_HELP,',
'        p_include_form     => ( :P1160_INCLUDE_FORM = ''Y'' ) );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'error editing page #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(4816745857363420)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4819923666363441)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_define_app_v3.delete_page(',
'    p_page_id => :P1160_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(4815948157363419)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4821581610363443)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4820379609363442)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_page in (select seq_id,',
'                      n002 internal_page_id,',
'                      c001 page_name,',
'                      c002 page_type,',
'                      ''TABLE'' source_type,',
'                      c005 table_name,',
'                      c013 page_icon,',
'                      c012 include_form,',
'                      c015 is_admin_page,',
'                      c016 layout_type,',
'                      c017 title_column,',
'                      c018 body_column,',
'                      c019 icon_column,',
'                      c020 badge_column,',
'                      c031 fs_report_type,',
'                      c040 help',
'               from apex_collections',
'               where collection_name = ''APEX$CREATE_APP_PAGE''',
'               and seq_id = :P1160_SEQ_ID )',
'loop',
'    :P1160_PAGE_NAME := l_page.page_name;',
'    :P1160_PAGE_TYPE := l_page.page_type;',
'    :P1160_PAGE_SOURCE := l_page.source_type;',
'    :P1160_TABLE := l_page.table_name;',
'    :P1160_PAGE_ICON := l_page.page_icon;',
'    ',
'    :P1160_REPORT_TYPE := l_page.fs_report_type;',
'    :P1160_INCLUDE_FORM := l_page.include_form;',
'    ',
'    if l_page.fs_report_type = ''CARD'' then',
'        :P1160_LAYOUT_TYPE  := l_page.layout_type;',
'        :P1160_TITLE_COLUMN := l_page.title_column;',
'        :P1160_BODY_COLUMN  := l_page.body_column;',
'        :P1160_ICON_COLUMN  := l_page.icon_column;',
'        :P1160_BADGE_COLUMN := l_page.badge_column;',
'    end if;',
'',
'    :P1160_PAGE_HELP := l_page.help;',
'    ',
'    -- set object type (used for Include Form item)',
'    for l_obj in (',
'        select object_type ',
'        from sys.dba_objects ',
'        where owner = :P1_SCHEMA ',
'        and object_name = l_page.table_name )',
'    loop',
'        :P1160_OBJ_TYPE := l_obj.object_type;',
'    end loop;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1160_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/deployment/definition
begin
wwv_flow_api.create_install(
 p_id=>wwv_flow_api.id(2593465981597452926)
);
end;
/
prompt --application/deployment/checks
begin
null;
end;
/
prompt --application/deployment/buildoptions
begin
null;
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
