prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4541
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4541 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4541
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116101814034403532')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'fi'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4541)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113350'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4541)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4541)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4541)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4541)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4541)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4541)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4541)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4541)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4541)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4541)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4541)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4541)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4541)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.fi'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4541
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4541)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4541)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4541)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4541)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4541)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4541)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4541)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.fi'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4541
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4541)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4541)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4541)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4541)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4541)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4541)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4541)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.fi'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4541
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4541)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4541)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4541)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4541)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4541)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4541)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4541)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4541)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4541)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4541)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4541)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4541)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4541)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4541)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4541)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4541)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4541)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.fi'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4541
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4541)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4541)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4541)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4541)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4541)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4541)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4541)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4541)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4541)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4541)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4541)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4541)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4541)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4541)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4541)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.fi'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4541
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4541)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4541)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4541)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4541)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4541)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4541)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4541)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4541)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4541)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4541)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4541)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4541)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4541)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4541)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4541)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.fi'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4541
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4541)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4541)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4541)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4541)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4541)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4541)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4541)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4541)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4541)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4541)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4541)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4541)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4541)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4541)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4541)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.fi'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4541
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4541)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4541)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4541)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4541)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4541)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4541)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4541)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4541)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4541)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4541)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4541)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4541)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4541)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4541)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4541)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4541
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4541)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4541
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4541)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4541
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4541)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4541
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4541)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4541
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4541)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4541
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4541)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4541
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4541)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4541)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4541)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4541)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4541)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4541)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4541)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4541)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4541)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4541)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4541)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4541)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4541)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4541)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4541)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4541)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4541)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4541)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4541)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4541)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4541)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4541)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4541)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4541)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4541)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4541)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4541)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4541
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4541)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4541)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4541)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4541)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4541)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4541)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4541)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4541)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4541)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4541
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4541)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4541)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4541)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4541)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4541)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4541)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4541)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4541)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4541)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4541)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4541)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4541)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4541)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4541)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4541)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4541)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4541)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4541)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4541)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4541)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4541)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4541)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4541)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4541)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4541)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4541
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4541)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4541)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4541)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4541)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4541)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4541)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4541)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4541)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4541)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4541)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4541)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4541)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4541)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4541)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4541)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4541)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4541)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4541)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4541)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4541
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4541)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4541)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4541)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4541)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4541)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4541
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4541)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4541)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4541)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4541)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4541)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4541)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4541)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4541)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4541)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4541)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4541)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4541)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4541)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4541
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4541)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4541)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4541)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4541)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4541)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4541
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4541)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4541)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4541)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4541)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4541)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4541
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4541)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4541)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4541)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4541)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4541)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4541)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4541)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4541)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4541)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4541
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4541)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4541)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4541)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4541)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4541)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4541)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4541)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4541)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4541)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4541)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4541)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4541)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4541)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4541)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4541)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4541)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4541)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4541)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4541)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4541)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4541)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4541)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4541)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4541)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4541)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4541)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4541)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4541
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4541)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4541)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4541)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4541)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4541)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4541
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4541)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4541
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4541)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4541
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4541)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4541
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4541)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4541
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4541)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4541
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4541)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4541
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4541)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4541
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4541)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4541
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4541)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4541
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4541)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4541
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4541)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4541
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4541)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4541
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4541)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4541
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4541)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4541
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4541)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4541
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4541)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4541
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4541)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4541
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4541)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4541
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4541)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4541
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4541)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4541
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4541)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4541
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4541)
,p_page_name=>'winlov'
,p_page_title=>'Hakuvalintaikkuna'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>'Haku'
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>'Sulje'
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>'Seuraava &gt;'
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>'&lt; Edellinen'
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Rivit #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4541
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4541)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4541
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4541)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4541)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4541)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4541)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4541)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4541)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4541)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4541)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4541)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4541)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4541)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4541)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4541)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4541)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4541)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4541)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4541)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4541)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4541)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4541)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4541)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4541)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4541)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4541)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4541)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4541)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4541)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4541)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4541)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4541)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4541)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4541)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4541)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4541)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4541)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4541)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4541)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4541)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4541)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4541)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4541)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4541)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4541)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4541)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4541)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4541)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4541)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4541)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4541)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4541)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4541)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4541)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4541)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4541)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4541)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4541)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4541)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4541)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4541)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4541)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4541)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4541)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4541)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4541)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4541)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4541)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4541)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4541)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4541)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4541)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4541)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4541)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4541)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4541)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4541)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4541)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4541)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4541)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4541)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4541)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4541)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4541)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4541)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4541)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4541)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4541)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4541)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4541)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4541)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4541)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4541)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4541)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4541)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4541)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4541)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4541)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4541)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4541)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4541)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4541)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4541)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4541)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4541)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4541)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4541)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4541)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4541)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4541)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4541)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4541)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4541)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4541)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4541)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4541)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4541)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4541)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4541)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4541)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4541)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4541)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4541)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4541)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4541)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4541)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4541)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4541)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4541)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4541)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4541)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4541)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4541)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4541)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4541)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4541)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4541)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4541)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4541)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4541)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4541)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4541)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4541)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4541)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4541)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4541)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4541)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4541)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4541)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4541)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4541)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4541)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4541)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4541)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4541)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4541)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4541)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4541)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4541)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4541)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4541)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4541)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4541)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4541)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4541)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4541)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4541)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4541)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4541)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4541)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4541)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4541)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4541)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4541)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4541)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4541)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4541)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4541)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4541)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4541)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4541)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4541)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4541)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4541)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4541)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4541)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4541)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4541)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4541)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4541)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4541)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4541)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4541)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4541)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4541)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4541)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4541)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4541)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4541)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4541)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4541)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4541)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4541)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4541)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4541)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4541)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4541)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4541)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4541)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4541)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4541)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4541)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4541)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4541)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4541)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4541)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4541)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4541)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4541)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4541)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4541)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4541)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4541)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4541)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4541)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4541)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4541)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4541)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4541)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4541)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4541)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4541)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4541)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4541)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4541)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4541)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4541)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4541)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4541)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4541)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4541)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4541)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4541)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111633638964399540)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'fi'
,p_message_text=>'Sarake %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111620798328399531)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'fi'
,p_message_text=>unistr('J\00E4rjestelm\00E4nvalvoja')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111620618963399531)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4ytt\00E4j\00E4tunnus')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111677912629399574)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'fi'
,p_message_text=>unistr('Ei k\00E4ytt\00F6oikeutta')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111637603017399543)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'fi'
,p_message_text=>'%0 -tilisi on luotu.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111623270299399533)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'fi'
,p_message_text=>'Tili on lukittu.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111613131301399525)
,p_name=>'AM_PM'
,p_message_language=>'fi'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111747592756399624)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'fi'
,p_message_text=>'Vaihda %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111755689397399630)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'fi'
,p_message_text=>'(Aktiivinen)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111725136052399608)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'fi'
,p_message_text=>'Ajax-kutsu palautti palvelinvirheen %0 kohteelle %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111655961393399558)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'fi'
,p_message_text=>unistr('Sovelluksen aliasta %0 ei voi muuntaa yksil\00F6iv\00E4ksi sovelluksen tunnisteeksi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111656014820399558)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'fi'
,p_message_text=>'Sovellusta, jonka alias on %0, ei ole.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111645619813399550)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'fi'
,p_message_text=>'ERR-1816 Odottamaton virhe muunnettaessa sovelluksen aliasta p_flow_alias_or_id (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111738556027399617)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'fi'
,p_message_text=>unistr('Sovelluksen tarkistussumman avulla voi helposti tarkistaa, onko sovellus otettu k\00E4ytt\00F6\00F6n useissa ty\00F6tiloissa. Voit vertailla tarkistussummia ja katsoa, l\00F6ytyyk\00F6 toisiaan vastaavia summia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111631464906399539)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('Virhe k\00E4sitelt\00E4ess\00E4 todennustoimintoa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111616878240399528)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('Virhe k\00E4sitelt\00E4ess\00E4 todennustoimintoa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111780301093399648)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'fi'
,p_message_text=>unistr('Oracle Cloud Identity Managementin palauttamalla asiakkaan nimell\00E4 ei ole valtuuksia toimialueen %1! k\00E4ytt\00F6\00F6n.<br/><a href="&LOGOUT_URL.">Kirjaudu uudelleen sis\00E4\00E4n</a> ja m\00E4\00E4rit\00E4 valtuutettu asiakkaan nimi tai vaihda Web-osoitetta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111614521990399526)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'fi'
,p_message_text=>unistr('Tilill\00E4si %0 ei ole tarvittavia oikeuksia (DB_DEVELOPER tai DB_ADMINISTRATOR) ty\00F6tilan %1 kehitykseen<br/>. <a href="&LOGOUT_URL.">Kirjaudu uudelleen sis\00E4\00E4n</a> oikeuksien my\00F6nt\00E4misen j\00E4lkeen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111613696387399526)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'fi'
,p_message_text=>unistr('Oracle Cloud Identity Managementin palauttamalla asiakkaan nimell\00E4 ei ole valtuuksia nykyisen ty\00F6tilan k\00E4ytt\00F6\00F6n.<br/><a href="&LOGOUT_URL.">Kirjaudu uudelleen sis\00E4\00E4n</a> m\00E4\00E4rit\00E4 valtuutettu asiakkaan nimi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111614689212399527)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4m\00E4n ty\00F6tilan sovellusten k\00E4ytt\00E4minen Web-osoitteen toimialueen kautta ei ole sallittua turvallisuussyist\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111631157516399539)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'fi'
,p_message_text=>unistr('Pyyd\00E4 tietokannan p\00E4\00E4k\00E4ytt\00E4j\00E4\00E4 ajamaan $OH/rdbms/admin/catldap.sql.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111631065874399539)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'fi'
,p_message_text=>'Pakettia SYS.DBMS_LDAP ei ole, tai se on virheellinen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111630930424399538)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('Virhe k\00E4sitelt\00E4ess\00E4 LDAP-k\00E4ytt\00E4j\00E4n toimintoa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111631200977399539)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('Virhe k\00E4sitelt\00E4ess\00E4 LDAP-todennusta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111632066136399539)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'fi'
,p_message_text=>'Virhe argumentissa p_flow_page proseduurille login_page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111631662575399539)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'fi'
,p_message_text=>'Virheellinen p_session kohteessa wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111679517308399575)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'fi'
,p_message_text=>unistr('V\00E4\00E4rin muodostettu argumentti kohteelle wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111631761178399539)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'fi'
,p_message_text=>unistr('Sis\00E4\00E4nkirjaukseen v\00E4litettiin tyhj\00E4 k\00E4ytt\00E4j\00E4nimi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111620535661399531)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'fi'
,p_message_text=>unistr('Odota <span id="apex_login_throttle_sec">%0</span> sekuntia ja kirjaudu sis\00E4\00E4n uudelleen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111621881302399532)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('Sis\00E4\00E4nkirjausyritys on estetty.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111677338959399573)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'fi'
,p_message_text=>unistr('Todennusta %0 ei l\00F6ydy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111622127350399532)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'fi'
,p_message_text=>unistr('Suojausryhm\00E4n tunniste on tyhj\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111631562537399539)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('Virhe k\00E4sitelt\00E4ess\00E4 j\00E4lkitodennusprosessia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111631384715399539)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('Virhe k\00E4sitelt\00E4ess\00E4 esitodennusprosessia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111632588154399540)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Avaa Web-osoite samassa selaimessa, jossa aloitit salasanan nollauspyynn\00F6n. Jos napsautat salasanan nollauksen Web-osoitetta ja sinut ohjataan '),
'',
unistr('uudelleen sis\00E4\00E4nkirjaussivulle, aloita salasanan nollaus uudelleen '),
'',
unistr('ja j\00E4t\00E4 selain avoimeksi.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111777823972399646)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'fi'
,p_message_text=>'Salasanan nollauksen Web-osoite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111614863702399527)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'fi'
,p_message_text=>unistr('Resurssienhallinnan kuluttajaryhm\00E4n %0 k\00E4ytt\00F6oikeutta ei ole my\00F6nnetty kohteelle %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111614975315399527)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'fi'
,p_message_text=>unistr('My\00F6nn\00E4 puuttuvat k\00E4ytt\00F6oikeudet kohteen DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP avulla.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111642941306399548)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('Virhe k\00E4sitelt\00E4ess\00E4 istunnon valvontatoimintoa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111643080767399548)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('Virhe k\00E4sitelt\00E4ess\00E4 istunnon tarkistustoimintoa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111643248658399548)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'fi'
,p_message_text=>unistr('Pyyd\00E4 kohteen %0 j\00E4rjestelm\00E4nvalvojaa konfiguroimaan Oracle Application Server Single Sign-On -ohjelma.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111652767462399555)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'fi'
,p_message_text=>unistr('Virheellinen %0 %1 kertakirjauksen palauttamassa merkiss\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111631902722399539)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'fi'
,p_message_text=>unistr('Muokkaa todennuskaavaa ja lis\00E4\00E4 sovelluksen nimi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111652482834399555)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'fi'
,p_message_text=>'Virheellinen %0-proseduurin yhteydenottaja:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111652611341399555)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'fi'
,p_message_text=>unistr('Virheellinen sovelluksen istunto URLC-merkiss\00E4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111652229011399555)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'fi'
,p_message_text=>unistr('Virhe kohteessa portal_sso_redirect: sovelluksen rekister\00F6intitiedot puuttuvat: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111643105200399548)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'fi'
,p_message_text=>'Pakettia WWSEC_SSO_ENABLER_PRIVATE ei ole, tai se on virheellinen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111631817405399539)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'fi'
,p_message_text=>unistr('Todennuskaavasta ei l\00F6ydy rekister\00F6idyn kumppanisovelluksen nime\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111652342697399555)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'fi'
,p_message_text=>unistr('Rekister\00F6i t\00E4m\00E4 sovellus asennusoppaassa kuvatulla tavalla.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111643363461399548)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('Virhe k\00E4sitelt\00E4ess\00E4 SSO-todennusta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111752720045399628)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'fi'
,p_message_text=>'Luvaton Web-osoite: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111642735966399547)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('Virhe k\00E4sitelt\00E4ess\00E4 todennusta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111614766727399527)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'fi'
,p_message_text=>unistr('Ty\00F6tila %0 ei ole k\00E4yt\00F6ss\00E4. Ota yhteytt\00E4 j\00E4rjestelm\00E4nvalvojaan.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111615159313399527)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'fi'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111621535800399532)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'fi'
,p_message_text=>unistr('Sovelluksen suojaustarkistus esti k\00E4yt\00F6n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111621643304399532)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'fi'
,p_message_text=>unistr('Sivun suojaustarkistus esti k\00E4yt\00F6n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111621768527399532)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('Virhe k\00E4sitelt\00E4ess\00E4 valtuutusta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111685140656399579)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'fi'
,p_message_text=>unistr('Luotu %0 k\00E4ytt\00E4m\00E4ll\00E4 ohjelmaa %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111685258255399579)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'fi'
,p_message_text=>'rakkaudella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111743009534399621)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'fi'
,p_message_text=>'Tapahtuman kuvaus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111742852257399621)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'fi'
,p_message_text=>unistr('P\00E4\00E4ttymisp\00E4iv\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111743151802399621)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'fi'
,p_message_text=>'Tapahtuman tunnus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111742795272399621)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'fi'
,p_message_text=>unistr('Alkamisp\00E4iv\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111742976450399621)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'fi'
,p_message_text=>'Tapahtuman otsikko'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111633549726399540)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('Tarkistussumman sis\00E4lt\00F6virhe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111633469438399540)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'fi'
,p_message_text=>'Tarkistussumman muotovirhe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111697413197399588)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'fi'
,p_message_text=>unistr('Kopioitu leikep\00F6yd\00E4lle.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111697199189399588)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4m\00E4 selain ei tue kopiointia painikkeesta tai valikosta. Kokeile k\00E4ytt\00E4m\00E4ll\00E4 n\00E4pp\00E4inyhdistelm\00E4\00E4 Ctrl+C tai komento+C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111685649519399579)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'fi'
,p_message_text=>'Sulje ilmoitus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111741618655399620)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'fi'
,p_message_text=>'Kontrasti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111736159557399616)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'fi'
,p_message_text=>'Nykyinen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111736024145399616)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'fi'
,p_message_text=>unistr('Alkuper\00E4inen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111740248073399619)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'fi'
,p_message_text=>unistr('Kohteen #LABEL# on oltava sallittu v\00E4ri. Esimerkki: %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111735929204399615)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'fi'
,p_message_text=>unistr('Valitse v\00E4ri')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111736286468399616)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'fi'
,p_message_text=>unistr('Vaihda v\00E4rimuotoa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111775487652399645)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'fi'
,p_message_text=>'Arvoluettelo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111775517754399645)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'fi'
,p_message_text=>'Avaa kohteen %0 luettelo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111755789443399630)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'fi'
,p_message_text=>'(Valmis)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111648000194399551)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'fi'
,p_message_text=>unistr('Ota yhteytt\00E4 sovelluksen j\00E4rjestelm\00E4nvalvojaan.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111662429645399562)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ota yhteys sovelluksen j\00E4rjestelm\00E4nvalvojaan.'),
'Ongelman tiedot ovat saatavilla ohjelmavirheiden korjaustunnisteella %0.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111740585010399619)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'fi'
,p_message_text=>'Korjaa virheet ennen tallennusta.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111686500666399580)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'fi'
,p_message_text=>unistr('L\00F6ytyi %0 osumaa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111686472651399580)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'fi'
,p_message_text=>'Ei osumia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111756277028399631)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'fi'
,p_message_text=>'Etenemisvaihe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111740949943399619)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'fi'
,p_message_text=>unistr('Kohteessa %0 m\00E4\00E4ritetty\00E4 tiedostoa ei ole kohteessa APEX_APPLICATION_TEMP_FILES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111729477572399611)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'fi'
,p_message_text=>unistr('Tietokannan tietojen nykyinen versio on muuttunut sen j\00E4lkeen, kun k\00E4ytt\00E4j\00E4 k\00E4ynnisti p\00E4ivitysprosessin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111698502192399589)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'fi'
,p_message_text=>unistr('\00C4l\00E4 lataa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111745521550399623)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'fi'
,p_message_text=>unistr('Esik\00E4sittelyvirhe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111745326133399623)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'fi'
,p_message_text=>unistr('Lis\00E4\00E4 rivi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111759440223399633)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'fi'
,p_message_text=>unistr('J\00E4rjestys : toiminto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111745423347399623)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'fi'
,p_message_text=>unistr('P\00E4ivit\00E4 rivi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111686906500399580)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'fi'
,p_message_text=>'Ponnahduskalenteri: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111609542385399523)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'fi'
,p_message_text=>'Seuraava'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111609616054399523)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'fi'
,p_message_text=>'Edellinen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111745758335399623)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'fi'
,p_message_text=>'Kohteella #LABEL# on oltava jokin arvo.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111745653822399623)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'fi'
,p_message_text=>unistr('Kohteen #LABEL# on oltava sallittu p\00E4iv\00E4m\00E4\00E4r\00E4, esimerkiksi %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111613232021399526)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'fi'
,p_message_text=>unistr('Arvon #LABEL# on oltava %0\2013%1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111613388043399526)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'fi'
,p_message_text=>'Arvon #LABEL# on oltava aikaisintaan %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111613466535399526)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'fi'
,p_message_text=>unistr('Arvon #LABEL# on oltava viimeist\00E4\00E4n %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111690403889399583)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'fi'
,p_message_text=>unistr('#LABEL# on suurempi kuin m\00E4\00E4ritetty suurin p\00E4iv\00E4m\00E4\00E4r\00E4 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111690883911399583)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'fi'
,p_message_text=>'#LABEL# ei vastaa muotoa %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111690389878399583)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'fi'
,p_message_text=>unistr('#LABEL# on pienempi kuin m\00E4\00E4ritetty pienin p\00E4iv\00E4m\00E4\00E4r\00E4 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111690503640399583)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'fi'
,p_message_text=>'#LABEL# ei ole sallitulla alueella %0 - %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111690732517399583)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'fi'
,p_message_text=>'#LABEL# ei ole sallitulla vuosialueella %0 - %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111740805683399619)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'fi'
,p_message_text=>'Peruuta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111768032152399639)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'fi'
,p_message_text=>'Sulje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111770011174399641)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'fi'
,p_message_text=>'Ohje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111740680548399619)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'fi'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111740771188399619)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'fi'
,p_message_text=>'Tallenna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111646911022399551)
,p_name=>'APEX.ERROR'
,p_message_language=>'fi'
,p_message_text=>'Virhe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111614300749399526)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'fi'
,p_message_text=>unistr('Seuraava virhe havaittiin suoritettaessa virhett\00E4 k\00E4sittelev\00E4\00E4 vastakutsua: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111623069904399533)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'fi'
,p_message_text=>'Virhe maalattaessa virhesivua: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111615035573399527)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'fi'
,p_message_text=>unistr('Sis\00E4inen virhe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111754896491399630)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ota yhteys j\00E4rjestelm\00E4nvalvojaan.'),
'Ongelman tiedot ovat saatavilla ohjelmavirheiden korjaustunnisteella %0.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111749119400399625)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'fi'
,p_message_text=>'Tietokanta on avattu vain lukua varten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111779785174399648)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'fi'
,p_message_text=>unistr('ORA-28353: Lompakon avaus ep\00E4onnistui. Sovelluksen tiedot eiv\00E4t ole k\00E4ytett\00E4viss\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111749264668399625)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4m\00E4 sivu ei ole k\00E4ytett\00E4viss\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111616718794399528)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'fi'
,p_message_text=>unistr('Teknisi\00E4 tietoja (n\00E4kyy vain kehitt\00E4jille)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111712896761399599)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'fi'
,p_message_text=>'Virhesanoma'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111726728891399609)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'fi'
,p_message_text=>'Odotettu muoto: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111693486429399585)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4ytt\00E4j\00E4 on jo k\00E4ytt\00F6oikeusluettelossa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111693395992399585)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'fi'
,p_message_text=>unistr('Vahvista seuraavien %0 k\00E4ytt\00E4j\00E4n lis\00E4\00E4minen k\00E4ytt\00F6oikeusluetteloon <strong>%1</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111693852456399585)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4ytt\00E4j\00E4st\00E4 on kaksoiskappale')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111693584862399585)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'fi'
,p_message_text=>unistr('S\00E4hk\00F6postiosoitteesta puuttuu at-merkki (@)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111693618506399585)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'fi'
,p_message_text=>unistr('S\00E4hk\00F6postiosoitteesta puuttuu piste (.)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111693759685399585)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4ytt\00E4j\00E4tunnus on liian pitk\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111694044147399585)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'fi'
,p_message_text=>unistr('Vain sovelluksen k\00E4ytt\00F6oikeusluettelossa m\00E4\00E4ritetyt k\00E4ytt\00E4j\00E4t voivat k\00E4ytt\00E4\00E4 t\00E4t\00E4 sovellusta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111694113690399585)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'fi'
,p_message_text=>unistr('Odottamaton k\00E4ytt\00F6oikeusasetuksen arvo: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111693992977399585)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'fi'
,p_message_text=>unistr('Vain todennetut k\00E4ytt\00E4j\00E4t voivat k\00E4ytt\00E4\00E4 t\00E4t\00E4 sovellusta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111736741100399616)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'fi'
,p_message_text=>unistr('Ei k\00E4yt\00F6ss\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111736693017399616)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4yt\00F6ss\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111736939973399616)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'fi'
,p_message_text=>unistr('%0: on poistettu k\00E4yt\00F6st\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111736892025399616)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'fi'
,p_message_text=>unistr('%0: on k\00E4yt\00F6ss\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111736563122399616)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'fi'
,p_message_text=>unistr('ei m\00E4\00E4ritetty')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111729680965399611)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'fi'
,p_message_text=>'Nouda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111686163777399580)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4ytetty suodatin %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111727255585399609)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4yt\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111612103925399525)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'fi'
,p_message_text=>unistr('Pylv\00E4skaavio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111739947022399618)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'fi'
,p_message_text=>'Muut'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111612205497399525)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'fi'
,p_message_text=>unistr('Ympyr\00E4kaavio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111738652764399617)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'fi'
,p_message_text=>'Kaavio'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111611959756399525)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'fi'
,p_message_text=>unistr('M\00E4\00E4r\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111727780178399610)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'fi'
,p_message_text=>unistr('Tyhjenn\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111727823982399610)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'fi'
,p_message_text=>unistr('Tyhjenn\00E4 kaikki')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111727995579399610)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'fi'
,p_message_text=>unistr('Tyhjenn\00E4 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111745183423399622)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'fi'
,p_message_text=>unistr('Sarake %1, johon kohdistus %0 viittaa, ei ole k\00E4ytett\00E4viss\00E4, tai se on valtuuttamaton.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111602383459399517)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'fi'
,p_message_text=>unistr('Valitse n\00E4ytett\00E4v\00E4t suodattimet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111684362572399578)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'fi'
,p_message_text=>'%0 tulosta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111684484290399578)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'fi'
,p_message_text=>'%0 valittu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111687004022399580)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'fi'
,p_message_text=>'Nykyiset suodattimet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111603824445399519)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'fi'
,p_message_text=>'Suodatinlista'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111743637947399621)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'fi'
,p_message_text=>'Erillisen arvon raja (%0) ylitetty kohdistuksessa %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111729277913399611)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'fi'
,p_message_text=>'Kohdistusta %0 ei tueta tyypin DATE tai TIMESTAMP sarakkeissa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111727366802399609)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'fi'
,p_message_text=>'Suodatin %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111727492188399609)
,p_name=>'APEX.FS.GO'
,p_message_language=>'fi'
,p_message_text=>'Suorita'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111728879760399610)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'fi'
,p_message_text=>unistr('yht\00E4 suuri kuin%0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111612947293399525)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'fi'
,p_message_text=>unistr('sis\00E4lt\00E4\00E4: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111612664965399525)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'fi'
,p_message_text=>'suurempi kuin %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111612736054399525)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'fi'
,p_message_text=>unistr('suurempi tai yht\00E4 suuri kuin %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111612423411399525)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'fi'
,p_message_text=>'alle %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111612551879399525)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'fi'
,p_message_text=>unistr('pienempi tai yht\00E4 suuri kuin %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111612861964399525)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'fi'
,p_message_text=>'alkaa: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111615363794399527)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'fi'
,p_message_text=>unistr('Tietotyyppi\00E4 %0 (%1) ei tueta sy\00F6tt\00F6kent\00E4n kohdistukselle.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111605569003399520)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'fi'
,p_message_text=>unistr('Usean arvon kohdistuksiin vaaditaan tietokantaversio 12.2 tai sit\00E4 uudempi versio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111729046266399611)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'fi'
,p_message_text=>unistr('Kohdistukselle %0 ei ole m\00E4\00E4ritetty hakusarakkeita')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111602451050399518)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'fi'
,p_message_text=>unistr('Lis\00E4\00E4 suodattimia')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111684582843399579)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'fi'
,p_message_text=>'Alueen alku'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111728504188399610)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'fi'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111728640278399610)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'fi'
,p_message_text=>'Yli %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111728700749399610)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'fi'
,p_message_text=>'Alle %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111684655813399579)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'fi'
,p_message_text=>'Alueen loppu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111747477661399624)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'fi'
,p_message_text=>unistr('Valintalistan kohde #%2 (%1) v\00E4lin kohdistukselle %0 on virheellinen (erotin | puuttuu).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111728902182399610)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'fi'
,p_message_text=>unistr('Manuaalista sy\00F6tt\00F6\00E4 v\00E4lin kohdistukseen %0 ei tueta, koska sarake on tyyppi\00E4 DATE tai TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111728293563399610)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'fi'
,p_message_text=>'-'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111612014547399525)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'fi'
,p_message_text=>'Poista kaavio'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111681158740399576)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'fi'
,p_message_text=>'Nollaa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111727687469399610)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'fi'
,p_message_text=>'Haku'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111727502574399609)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'fi'
,p_message_text=>'Hae...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111728406326399610)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'fi'
,p_message_text=>'- Valitse -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111611834211399524)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4yt\00E4 kaavio')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111728057391399610)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4yt\00E4 v\00E4hemm\00E4n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111728104515399610)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4yt\00E4 lis\00E4\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111728373335399610)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'fi'
,p_message_text=>unistr('V\00E4hint\00E4\00E4n %0 t\00E4hte\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111686001717399580)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'fi'
,p_message_text=>'Suodatusehdotukset'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111729148993399611)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'fi'
,p_message_text=>unistr('Tekstikent\00E4n kohdistusta %0 tuetaan vain tyypin NUMBER sarakkeissa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111602277891399517)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'fi'
,p_message_text=>unistr('Rivien kokonaism\00E4\00E4r\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111745284410399622)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'fi'
,p_message_text=>unistr('Tietotyyppi\00E4 %0 (%1) ei tueta kohdistetuissa hauissa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111737127381399616)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'fi'
,p_message_text=>'Siirry virheeseen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111694785999399586)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'fi'
,p_message_text=>'Kooste.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111702399643399591)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'fi'
,p_message_text=>unistr('Tiivist\00E4 ryhm\00E4katko')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111694832368399586)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'fi'
,p_message_text=>unistr('Ryhm\00E4katko.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111702275843399591)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'fi'
,p_message_text=>unistr('Laajenna ryhm\00E4katko')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111780985991399649)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'fi'
,p_message_text=>'Sarake %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111702089869399591)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 rivi\00E4 poistettu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111772476645399642)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'fi'
,p_message_text=>unistr('Henkil\00F6llisyyden kaksoiskappale')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111691720143399584)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'fi'
,p_message_text=>unistr('Ensimm\00E4inen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111695043945399586)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'fi'
,p_message_text=>unistr('Ryhm\00E4n otsikko.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111694944998399586)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'fi'
,p_message_text=>'Otsikko.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111691814410399584)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'fi'
,p_message_text=>'Viimeinen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111711819422399598)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'fi'
,p_message_text=>unistr('Lataa lis\00E4\00E4 rivej\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111691570510399584)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'fi'
,p_message_text=>'Seuraava'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111695169464399586)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'fi'
,p_message_text=>'Sivun rivit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111691938957399584)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'fi'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111692094842399584)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'fi'
,p_message_text=>'%0 - %1 / %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111748017327399625)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'fi'
,p_message_text=>'Sivun valinta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111691649977399584)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'fi'
,p_message_text=>'Edellinen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111772238963399642)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'fi'
,p_message_text=>unistr('Lis\00E4tty')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111772331602399642)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'fi'
,p_message_text=>'Muutettu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111780702068399648)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'fi'
,p_message_text=>'Rivi %0, sarake %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111780812763399648)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'fi'
,p_message_text=>'Rivi %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111772112046399642)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'fi'
,p_message_text=>'Poistettu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111695366857399586)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'fi'
,p_message_text=>'Rivin otsikko'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111690997897399583)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'fi'
,p_message_text=>'%0 solua valittu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111692150100399584)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 rivi\00E4 valittu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111732474480399613)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'fi'
,p_message_text=>'Valitse kaikki'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111702153152399591)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'fi'
,p_message_text=>'Sivu %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111695202461399586)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'fi'
,p_message_text=>'Valitse rivi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111695478465399586)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'fi'
,p_message_text=>'Lajiteltu nousevasti %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111695549911399586)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'fi'
,p_message_text=>'Lajiteltu laskevasti %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111691019347399583)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'fi'
,p_message_text=>unistr('Nouseva j\00E4rjestys')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111691379485399583)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'fi'
,p_message_text=>unistr('Nouseva j\00E4rjestys %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111691103063399583)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'fi'
,p_message_text=>unistr('Laskeva j\00E4rjestys')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111691462639399584)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'fi'
,p_message_text=>unistr('Laskeva j\00E4rjestys %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111691233704399583)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'fi'
,p_message_text=>unistr('\00C4l\00E4 lajittele')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111701924901399591)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'fi'
,p_message_text=>unistr('Yhteens\00E4 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111628304056399537)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'fi'
,p_message_text=>unistr('HTTP-pyynt\00F6 kohteelle %0 ep\00E4onnistui.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111769618188399640)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'fi'
,p_message_text=>unistr('Ruudukon valintaluettelossa %0 saraketta ja %1 rivi\00E4. K\00E4yt\00E4 nuolin\00E4pp\00E4imi\00E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111701831801399591)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'fi'
,p_message_text=>unistr('Valitse luettelon %0 rivit. K\00E4yt\00E4 nuolin\00E4pp\00E4imi\00E4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111780507200399648)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'fi'
,p_message_text=>'Interaktiivinen ruudukko %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111688661855399581)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'fi'
,p_message_text=>'Toiminnot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111689651813399582)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'fi'
,p_message_text=>unistr('Lis\00E4\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111689535120399582)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'fi'
,p_message_text=>unistr('Lis\00E4\00E4 rivi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111774047037399644)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'fi'
,p_message_text=>'Kooste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111759592524399633)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'fi'
,p_message_text=>'Kooste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111761248157399634)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'fi'
,p_message_text=>'Kaikki'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111717652958399602)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'fi'
,p_message_text=>'Kaikki tekstisarakkeet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111718835420399603)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'fi'
,p_message_text=>'Vaihtoehtoinen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111719936376399604)
,p_name=>'APEX.IG.AND'
,p_message_language=>'fi'
,p_message_text=>'ja'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111739364622399618)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'fi'
,p_message_text=>'Laske erillisten keskiarvo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111775080996399644)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'fi'
,p_message_text=>unistr('Erillisten kok. m\00E4\00E4r\00E4n keskiarvo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111758169342399632)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'fi'
,p_message_text=>'Alue'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111760092958399633)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'fi'
,p_message_text=>'Nouseva'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111718905600399603)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'fi'
,p_message_text=>'Valtuutus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111774148100399644)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'fi'
,p_message_text=>'Automaattinen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111739778276399618)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'fi'
,p_message_text=>'Keskiarvo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111774791153399644)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'fi'
,p_message_text=>'Kokonaiskeskiarvo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111757679403399632)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'fi'
,p_message_text=>'Nimen akselin otsikko'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111757829976399632)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'fi'
,p_message_text=>unistr('Desimaalien m\00E4\00E4r\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111757748088399632)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'fi'
,p_message_text=>'Arvon akselin otsikko'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111763899411399636)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'fi'
,p_message_text=>unistr('Taustav\00E4ri')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111758280281399632)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'fi'
,p_message_text=>unistr('Pylv\00E4s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111714211829399600)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'fi'
,p_message_text=>unistr('v\00E4lill\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111765094228399637)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'fi'
,p_message_text=>'Molemmat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111758384976399632)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'fi'
,p_message_text=>'Kupla'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111689889374399582)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'fi'
,p_message_text=>'Peruuta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111719812560399604)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'fi'
,p_message_text=>'Kirjainkoosta riippuva'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111775646828399645)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'fi'
,p_message_text=>'(Kirjainkoosta riippuva)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111746580197399623)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'fi'
,p_message_text=>'Muutokset tallennettu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111690217768399583)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'fi'
,p_message_text=>unistr('Vaihda n\00E4kym\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111720957673399605)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'fi'
,p_message_text=>'Kaavio'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111717486516399602)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'fi'
,p_message_text=>unistr('Kysely ylitt\00E4\00E4 kaaviokohtaisen arvopisteiden maksimim\00E4\00E4r\00E4n %0. Pienenn\00E4 peruskyselyn tietuem\00E4\00E4r\00E4\00E4 k\00E4ytt\00E4m\00E4ll\00E4 suodatinta.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111688529500399581)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'fi'
,p_message_text=>unistr('Kaavion\00E4kym\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111695806738399587)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'fi'
,p_message_text=>unistr('Tyhjenn\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111757127713399631)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'fi'
,p_message_text=>'Sulje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111764070189399636)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'fi'
,p_message_text=>unistr('V\00E4rit')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111740116546399619)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'fi'
,p_message_text=>'Esikatselu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111719200758399604)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'fi'
,p_message_text=>'Sarake'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111688737377399582)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'fi'
,p_message_text=>'Sarakkeet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111765898449399638)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'fi'
,p_message_text=>'Sarakkeen tarkoitus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111719350497399604)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'fi'
,p_message_text=>'Monimutkainen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111688983278399582)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'fi'
,p_message_text=>'Laske'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111714890870399600)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'fi'
,p_message_text=>unistr('sis\00E4lt\00E4\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111721129775399605)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'fi'
,p_message_text=>unistr('Ryhm\00E4katko')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111695674959399587)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'fi'
,p_message_text=>unistr('Kopioi leikep\00F6yd\00E4lle')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111695785095399587)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'fi'
,p_message_text=>'Kopiointi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111739140177399618)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'fi'
,p_message_text=>'Laske'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111739292410399618)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'fi'
,p_message_text=>'Laske erilliset'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111774909276399644)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'fi'
,p_message_text=>unistr('Erillisten kokonaism\00E4\00E4r\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111774866312399644)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'fi'
,p_message_text=>unistr('Kokonaism\00E4\00E4r\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111772586955399642)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'fi'
,p_message_text=>'Luo %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111717834142399603)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'fi'
,p_message_text=>'Tiedot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111765651420399637)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'fi'
,p_message_text=>'Tietotyyppi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111765257302399637)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'fi'
,p_message_text=>unistr('P\00E4iv\00E4m\00E4\00E4r\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111746371443399623)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'fi'
,p_message_text=>unistr('Virheellinen p\00E4iv\00E4m\00E4\00E4r\00E4n arvo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111715516666399601)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'fi'
,p_message_text=>unistr('p\00E4iv\00E4\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111718525257399603)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'fi'
,p_message_text=>'Oletusasetukset'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111718376508399603)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'fi'
,p_message_text=>'Oletustyyppi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111689743559399582)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'fi'
,p_message_text=>'Poista'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111766822002399638)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'fi'
,p_message_text=>unistr('Haluatko varmasti poistaa t\00E4m\00E4n raportin?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111722974164399606)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'fi'
,p_message_text=>'Poista rivi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111721795550399605)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'fi'
,p_message_text=>'Poista rivit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111760157892399634)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'fi'
,p_message_text=>'Laskeva'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111720609292399605)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'fi'
,p_message_text=>'Tiedot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111688295271399581)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'fi'
,p_message_text=>unistr('Tieton\00E4kym\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111748806409399625)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'fi'
,p_message_text=>'Suunta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111720353724399604)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'fi'
,p_message_text=>unistr('Ei k\00E4yt\00F6ss\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111714950479399601)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'fi'
,p_message_text=>unistr('ei sis\00E4ll\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111715183505399601)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'fi'
,p_message_text=>'ei ala'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111758489923399632)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'fi'
,p_message_text=>'Rengas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111721367594399605)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'fi'
,p_message_text=>'Nouda'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111620069348399530)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'fi'
,p_message_text=>'Vain tiedot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111767854904399639)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'fi'
,p_message_text=>'Valitse muoto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111632690166399540)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'fi'
,p_message_text=>unistr('Noutomuoto %0 ei ole k\00E4yt\00F6ss\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111760865319399634)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'fi'
,p_message_text=>'Koosteen kaksoiskappale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111760999158399634)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'fi'
,p_message_text=>unistr('Ryhm\00E4katkon kaksoiskappale')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111722891996399606)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'fi'
,p_message_text=>'Toistuva rivi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111721650082399605)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'fi'
,p_message_text=>'Kopioi rivit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111689337231399582)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'fi'
,p_message_text=>'Muokkaa'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111759943922399633)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'fi'
,p_message_text=>'Muokkaa kaaviota'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111771461078399642)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'fi'
,p_message_text=>unistr('Ryhm\00E4n muokkausperuste')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111767486455399639)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'fi'
,p_message_text=>'Piilokopio (bcc)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111767606991399639)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'fi'
,p_message_text=>'Viesti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111767378095399639)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'fi'
,p_message_text=>'Kopio (cc)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111767031929399638)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'fi'
,p_message_text=>unistr('S\00E4hk\00F6postiviesti on l\00E4hetetty.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111767550458399639)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'fi'
,p_message_text=>'Aihe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111767252555399639)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'fi'
,p_message_text=>'Vastaanottaja (to)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111720086115399604)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4yt\00F6ss\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111713233851399599)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'fi'
,p_message_text=>'vastaa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111766457716399638)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'fi'
,p_message_text=>'Esimerkki'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111720144117399604)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'fi'
,p_message_text=>'Lauseke'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111766387932399638)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'fi'
,p_message_text=>'Tyyppi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111732397854399613)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'fi'
,p_message_text=>'Tiedosto valmisteltu. Aloitetaan nouto.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111695948095399587)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4yt\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111697028443399588)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4yt\00E4 valintaan')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111696912041399587)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4yt\00E4 valinta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111688843675399582)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'fi'
,p_message_text=>'Suodatin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111719405040399604)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'fi'
,p_message_text=>'Suodattimet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111774483964399644)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'fi'
,p_message_text=>'Suodata...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111760344377399634)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'fi'
,p_message_text=>unistr('Ensimm\00E4inen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111689071903399582)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'fi'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111717986036399603)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'fi'
,p_message_text=>'Muotoilu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111764998561399637)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'fi'
,p_message_text=>'Muotomaski'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111766783926399638)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'fi'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111766672287399638)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'fi'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111679435048399575)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'fi'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111618783593399530)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'fi'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111722550868399606)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'fi'
,p_message_text=>'Lukitse'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111720241142399604)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'fi'
,p_message_text=>'Funktiot ja operaattorit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111758577982399632)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'fi'
,p_message_text=>'Suppilo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111739014075399618)
,p_name=>'APEX.IG.GO'
,p_message_language=>'fi'
,p_message_text=>'Suorita'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111713861739399600)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'fi'
,p_message_text=>'suurempi kuin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111713902171399600)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'fi'
,p_message_text=>unistr('suurempi tai yht\00E4 suuri kuin')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111720583734399605)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'fi'
,p_message_text=>'Ruudukko'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111688033275399581)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'fi'
,p_message_text=>unistr('Ruudukkon\00E4kym\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111761154452399634)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'fi'
,p_message_text=>unistr('Ryhm\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111720712770399605)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'fi'
,p_message_text=>'Ryhmittely'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111688310790399581)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'fi'
,p_message_text=>unistr('Ryhmittelyn\00E4kym\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111765599534399637)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'fi'
,p_message_text=>'Ehtotyyppi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111764476412399637)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'fi'
,p_message_text=>'Otsikko'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111764644415399637)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'fi'
,p_message_text=>'Otsikon kohdistus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111774389004399644)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'fi'
,p_message_text=>'Ohje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111769878922399640)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Voit lis\00E4t\00E4, p\00E4ivitt\00E4\00E4 ja poistaa tietoja suoraan t\00E4ss\00E4 interaktiivisessa ruudukossa.</p>'),
'',
unistr('<p>Lis\00E4\00E4 uusi rivi napsauttamalla Lis\00E4\00E4 rivi -painiketta.</p>'),
'',
unistr('<p>Voit muokata nykyisi\00E4 tietoja kaksoisnapsauttamalla valittua solua. Jos haluat tehd\00E4 suurempia muokkauksia, vaihda muokkaustilaan valitsemalla Muokkaa. Muokkaustilassa voit muokata valitsemiasi soluja yhdell\00E4 napsautuksella tai n\00E4pp\00E4imist\00F6n avulla')
||'.</p>',
'',
unistr('<p>Muutosvalikossa voit kopioida ja poistaa rivej\00E4. Avaa muutosvalikko valitsemalla yhden tai useamman rivin valintaruutu.</p>'),
'',
'<p>Voit kopioida valitun rivin napsauttamalla muutosvalikkoa ja valitsemalla Kopioi rivit. Voit poistaa valitun rivin napsauttamalla muutosvalikkoa ja valitsemalla Poista rivi.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111771956723399642)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'fi'
,p_message_text=>'Muokkauksen ominaisuudet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111772056042399642)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Interaktiivinen ruudukko n\00E4ytt\00E4\00E4 tietojoukon raporttina, johon voit tehd\00E4 hakuja ja jota voit mukauttaa. Voit rajoittaa palautettavien tietueiden m\00E4\00E4r\00E4\00E4 useilla eri toiminnoilla ja muuttaa tietojen n\00E4ytt\00F6tapaa.</p>'),
'',
unistr('<p>Hakukent\00E4n avulla voit suodattaa palautettavia tietueita. Valitsemalla Toiminnot voit muokata raportin asettelua eri toiminnoilla. Sarakeotsikoiden valikoissa voit m\00E4\00E4ritt\00E4\00E4 n\00E4ytettyj\00E4 sarakkeita.</p>'),
'',
unistr('<p>Raporttiasetuksissa voit tallentaa raporttiin tekem\00E4si mukautukset. Voit my\00F6s ladata raportin tiedot ulkoiseen tiedostoon tai l\00E4hett\00E4\00E4 ne s\00E4hk\00F6postilla itsellesi tai muille.</p>'),
'',
unistr('<p>Lis\00E4tietoja on <em>Oracle Application Express End User''s Guide</em> -oppaan kohdassa Interaktiivisten ruudukkojen k\00E4ytt\00F6.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111771707862399642)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'fi'
,p_message_text=>'Yleiskatsaus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111769736507399640)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Voit mukauttaa interaktiivisen ruudukon valmiiden ominaisuuksien avulla ja esitt\00E4\00E4 tietoja useilla eri tavoilla.</p>'),
'',
unistr('<p>Sarakeotsikoiden valikoissa tai Toiminnot-valikossa voit m\00E4\00E4ritt\00E4\00E4 n\00E4ytett\00E4v\00E4t sarakkeet ja niiden j\00E4rjestyksen sek\00E4 lukita sarakkeita. Voit my\00F6s m\00E4\00E4ritt\00E4\00E4 erilaisia tietosuodattimia ja lajitella palautettavia tietoja.</p>'),
'',
unistr('<p>N\00E4kym\00E4-painikkeella (hakukent\00E4n vieress\00E4) saat n\00E4kyviin muita, sovelluksen kehitt\00E4j\00E4n mahdollisesti m\00E4\00E4ritt\00E4mi\00E4 tieton\00E4kymi\00E4. Voit my\00F6s luoda kaavion tai tarkastella olemassa olevaa kaaviota.</p>  '),
'',
unistr('<p><em>Huomautus: napsauttamalla <strong>Ohje</strong>-kohtaa interaktiivisen ruudukon valintaikkunoissa saat n\00E4kyviin lis\00E4tietoja valitusta toiminnosta .</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111771806837399642)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'fi'
,p_message_text=>'Raportoinnin ominaisuudet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111721575952399605)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'fi'
,p_message_text=>'Interaktiivisen ruudukon ohje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111768689767399640)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>T\00E4ss\00E4 valintaikkunassa voit koostaa sarakkeita. Koosteet n\00E4ytet\00E4\00E4n tietojen lopussa tai kunkin ryhm\00E4katkon lopussa, jos ryhm\00E4katkoja on m\00E4\00E4ritetty.</p>'),
'',
'<p><strong>Koostelista</strong><br>',
unistr('Koostelistassa n\00E4ytet\00E4\00E4n m\00E4\00E4ritetyt koosteet. Poista kooste k\00E4yt\00F6st\00E4 poistamalla sen valinta.<br>'),
unistr('Luo uusi kooste valitsemalla Lis\00E4\00E4 ( &plus; ) tai poista kooste valitsemalla Poista ( &minus; ).</p>'),
'',
'<p><strong>Koosteasetukset</strong><br>',
unistr('M\00E4\00E4rit\00E4 kooste oikealla olevassa n\00E4yt\00F6ss\00E4.<br>'),
'Valitse sarakkeen nimi ja koosteen tyyppi.<br>',
unistr('Halutessasi voit my\00F6s lis\00E4t\00E4 koosteeseen ty\00F6kaluvihjeen.<br>'),
unistr('Jos olet m\00E4\00E4ritt\00E4nyt ryhm\00E4katkon, vaihtoehto <strong>N\00E4yt\00E4 kokonaisarvo</strong> n\00E4ytt\00E4\00E4 kokonaiskeskiarvon, kokonaism\00E4\00E4r\00E4n tai vastaavan arvon tietojen lopussa.</p>'),
'',
'<p><em>Huomautus: voit avata Kooste-valintaikkunan Toiminnot-valikosta tai napsauttamalla sarakeotsikkoa ja summaa ( &sum; ).</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111770862323399641)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'fi'
,p_message_text=>'Koosteiden ohje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111769383821399640)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>T\00E4ss\00E4 valintaikkunassa voit m\00E4\00E4ritt\00E4\00E4 kaavion, joka n\00E4ytet\00E4\00E4n erillisen\00E4 tieton\00E4kym\00E4n\00E4.<br>'),
unistr('Valitse kaavion tyyppi ja m\00E4\00E4ritteet.</p>'),
unistr('<p><strong>Kaavion m\00E4\00E4ritteet</strong></br>'),
unistr('K\00E4ytett\00E4viss\00E4 olevat kaavion m\00E4\00E4ritteet vaihtelevat kaavion tyypin mukaan.</p>'),
'<p>',
'<ul>',
unistr('  <li>Valitse sarake, jossa on m\00E4\00E4ritteen arvo:'),
'    <ul>',
'      <li>Nimi - kunkin arvopisteen teksti.</li>',
unistr('      <li>Arvo - esitett\00E4v\00E4t tiedot.</li>'),
unistr('      <li>Sarja - usean sarjan dynaamisen kyselyn m\00E4\00E4rityst\00E4 varten.</li>'),
unistr('      <li>Avaus - p\00F6rssin p\00E4ivitt\00E4inen avaushinta (vain p\00F6rssi).</li>'),
unistr('      <li>P\00E4\00E4t\00F6s - p\00F6rssin p\00E4ivitt\00E4inen p\00E4\00E4t\00F6shinta (vain p\00F6rssi).</li>'),
unistr('      <li>Suurin - suurin arvo (vain v\00E4li ja p\00F6rssi).</li>'),
unistr('      <li>Pienin - pienin arvo (vain v\00E4li ja p\00F6rssi).</li>'),
unistr('      <li>M\00E4\00E4r\00E4 - p\00E4ivitt\00E4inen osakem\00E4\00E4r\00E4 (vain p\00F6rssi).</li>'),
'      <li>Kohde - Kohdearvo (vain suppilo).</li>',
'      <li>X - x-akselin arvo (vain kupla- ja piste).</li>',
'      <li>Y - y-akseli (vain kupla- ja piste).</li>',
unistr('      <li>Z - pylv\00E4\00E4n leveys tai kuplan s\00E4de (vain pylv\00E4s-, kupla- ja v\00E4li).</li>'),
'    </ul>',
'  </li>',
'  <li>Suunta - pysty- tai vaakasuunta.</li>',
'  <li>Kooste - valitse, miten kaavion arvot koostetaan.</li>',
'  <li>Pino - valitse, pinotaanko tietokohteet.</li>',
'  <li>Lajitteluperuste - lajittele nimen vai arvojen perusteella.',
'    <ul>',
unistr('      <li>J\00E4rjestys - lajittele arvot nousevassa tai laskevassa j\00E4rjestyksess\00E4.</li>'),
unistr('      <li>Tyhj\00E4t - m\00E4\00E4rit\00E4, miten tyhji\00E4 arvoja sis\00E4lt\00E4v\00E4t tietueet lajitellaan suhteessa muihin tietueisiin.</li>'),
'    </ul>',
'  </li>',
'  <li>Desimaalit</li>',
'  <li>Nimen akselin otsikko</li>',
'  <li>Arvon akselin otsikko</li>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111771257794399641)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'fi'
,p_message_text=>'Kaavioiden ohje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111768359634399639)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>T\00E4ss\00E4 valintaikkunassa voit valita n\00E4ytett\00E4v\00E4t sarakkeet ja niiden j\00E4rjestyksen.</p>'),
'',
'<p>Piilota sarake poistamalla sen valinta.<br>',
unistr('J\00E4rjest\00E4 sarakkeet uudelleen valitsemalla Siirr\00E4 yl\00F6s ( &uarr; ) tai Siirr\00E4 alas ( &darr; ).<br>'),
unistr('Avattavalla valitsimella voit valita kaikki sarakkeet, n\00E4ytetyt sarakkeet tai ei n\00E4ytetyt sarakkeet.</p>'),
'',
unistr('<p>N\00E4yt\00F6n avulla voit halutessasi m\00E4\00E4ritt\00E4\00E4 sarakkeiden v\00E4himm\00E4isleveyden kuvapistein\00E4.</p>'),
'',
unistr('<p><em>Huomautus: Voit my\00F6s j\00E4rjest\00E4\00E4 n\00E4ytettyj\00E4 sarakkeita uudelleen napsauttamalla vetokahvaa (sarakeotsikon edell\00E4) ja vet\00E4m\00E4ll\00E4 saraketta vasemmalle tai oikealle. Voit my\00F6s muuttaa n\00E4ytettyjen sarakkeiden leveytt\00E4 napsauttamalla otsikoiden v\00E4liss')
||unistr('\00E4 olevaa sarakkeiden erotinta ja siirt\00E4m\00E4ll\00E4 sit\00E4 vasemmalle tai oikealle.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111771149480399641)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'fi'
,p_message_text=>'Sarakkeiden ohje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111768777097399640)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>T\00E4ss\00E4 valintaikkunassa voit m\00E4\00E4ritt\00E4\00E4 lis\00E4sarakkeita olemassa oleviin sarakkeisiin tehtyjen matemaattisten laskelmien tai funktiolaskelmien perusteella.</p>'),
'',
'<p><strong>Laskentalista</strong><br>',
unistr('Laskentalista n\00E4ytt\00E4\00E4 m\00E4\00E4ritetyt laskennat. Poista laskenta k\00E4yt\00F6st\00E4 poistamalla sen valinta.<br>'),
unistr('Luo uusi laskenta valitsemalla Lis\00E4\00E4 ( &plus; ) tai poista laskenta valitsemalla Poista ( &minus; ).</p>'),
'',
'<p><strong>Laskenta-asetukset</strong><br>',
unistr('N\00E4yt\00F6n avulla voit m\00E4\00E4ritt\00E4\00E4 laskennan.<br>'),
unistr('Sy\00F6t\00E4 sarakkeen tiedot, kuten otsikko tai nimi, ja valitse kohdistusasetukset.<br> '),
unistr('Sy\00F6t\00E4 laskennan sarake tai sarakkeet sek\00E4 liittyv\00E4t funktiot Lauseke-tekstialueelle.<br>'),
unistr('Valitse uuden sarakkeen tietotyyppi ja halutessasi muotom\00E4\00E4ritys.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111770725973399641)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'fi'
,p_message_text=>'Laskennan ohje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111769025333399640)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>T\00E4ss\00E4 valintaikkunassa voit m\00E4\00E4ritt\00E4\00E4 ryhm\00E4katkon yhteen tai useampaan sarakkeeseen.</p>'),
'',
unistr('<p><strong>Ryhm\00E4katkolista</strong><br>'),
unistr('Ryhm\00E4katkolista n\00E4ytt\00E4\00E4 m\00E4\00E4ritetyt ryhm\00E4katkot. Poista ryhm\00E4katko k\00E4yt\00F6st\00E4 poistamalla sen valinta.<br>'),
unistr('Lis\00E4\00E4 ryhm\00E4katkoon uusi sarake valitsemalla Lis\00E4\00E4 ( &plus; ) tai poista sarake ryhm\00E4katkosta valitsemalla Poista ( &minus; ).<br>'),
unistr('Voit muuttaa sarakkeiden j\00E4rjestyst\00E4 siirt\00E4m\00E4ll\00E4 valittua saraketta muiden sarakkeiden yl\00E4- tai alapuolelle valitsemalla Siirr\00E4 yl\00F6s ( &uarr; ) tai Siirr\00E4 alas ( &darr; ).</p>'),
'',
unistr('<p><strong>Ryhm\00E4katkoasetukset</strong><br>'),
unistr('N\00E4yt\00F6n avulla voit m\00E4\00E4ritt\00E4\00E4 ryhm\00E4katkosarakkeen.<br>'),
unistr('Valitse ryhm\00E4katkosarake, lajittelusuunta ja tyhjien sarakkeiden (sarakkeet, joissa ei ole arvoa) j\00E4rjestys.</p>'),
'',
unistr('<p><em>Huomautus: interaktiivista ruudukkoa tarkastellessasi voit m\00E4\00E4ritt\00E4\00E4 ryhm\00E4katkon napsauttamalla sarakeotsikkoa ja ryhm\00E4katkokuvaketta.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111770436234399641)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'fi'
,p_message_text=>unistr('Ryhm\00E4katkojen ohje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111769289931399640)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>T\00E4ss\00E4 valintaikkunassa voit ladata kaikki nykyiset rivit ulkoiseen tiedostoon. Tiedosto sis\00E4lt\00E4\00E4 vain nykyiset n\00E4ytetyt sarakkeet ja k\00E4yt\00F6ss\00E4 olevien suodattimien ja lajittelujen mukaiset tiedot.</p>'),
'',
'<p>Valitse tiedostomuoto ja valitse Lataa.<br>',
unistr('Huomautus: CSV-tiedosto ei sis\00E4ll\00E4 tekstimuotoiluja, kuten koosteita ja ryhm\00E4katkoja.</p>'),
'',
unistr('<p>Voit l\00E4hett\00E4\00E4 tiedoston s\00E4hk\00F6postilla valitsemalla L\00E4het\00E4 s\00E4hk\00F6postiviestin\00E4 ja sy\00F6tt\00E4m\00E4ll\00E4 tarvittavat tiedot (vastaanottaja, aihe ja viesti).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111770227974399641)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'fi'
,p_message_text=>'Noutoa koskeva ohje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111768468951399639)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>T\00E4ss\00E4 valintaikkunassa voit konfiguroida tietojen suodattimia, jotka rajoittavat palautettavien rivien m\00E4\00E4r\00E4\00E4.</p>'),
'',
'<p><strong>Suodatinlista</strong><br>',
unistr('Suodatinlistassa n\00E4kyv\00E4t m\00E4\00E4ritetyt suodattimet. Poista suodatin k\00E4yt\00F6st\00E4 poistamalla sen valinta.<br>'),
unistr('Luo uusi suodatin valitsemalla Lis\00E4\00E4 ( &plus; ) tai poista suodatin valitsemalla Poista ( &minus; ).</p>'),
'',
'<p><strong>Suodatinasetukset</strong><br>',
unistr('N\00E4yt\00F6n avulla voit m\00E4\00E4ritt\00E4\00E4 suodattimen ominaisuudet.<br>'),
'Valitse haluamasi suodatintyyppi:<br>',
unistr('&nbsp;&nbsp;&nbsp;Rivi - suodata k\00E4ytt\00E4en hakuehtoa miss\00E4 tahansa suodatettavassa sarakkeessa.<br>'),
unistr('&nbsp;&nbsp;&nbsp;Sarake - suodata tietyss\00E4 sarakkeessa k\00E4ytt\00E4en m\00E4\00E4ritetty\00E4 operaattoria ja arvoa.</p>'),
'',
unistr('<p><em>Huomautus: Interaktiivista ruudukkoa tarkastellessasi voit m\00E4\00E4ritt\00E4\00E4 rivisuodattimia kirjoittamalla suoraan hakukentt\00E4\00E4n. Voit rajoittaa haun tiettyyn sarakkeeseen valitsemalla Valitse etsitt\00E4v\00E4t sarakkeet. Voit my\00F6s avata sarakeotsikon valiko')
||'n ja luoda sarakesuodattimen valitsemalla arvon.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111771003166399641)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'fi'
,p_message_text=>'Suodattimien ohje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111768875469399640)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>T\00E4ss\00E4 valintaikkunassa voit tarkastella tietoja sellaisina kuin ne olivat aiempana ajankohtana.</p>'),
unistr('<p>Suorita flashback-kysely sy\00F6tt\00E4m\00E4ll\00E4 minuuttim\00E4\00E4r\00E4 ajassa taaksep\00E4in.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111770662097399641)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'fi'
,p_message_text=>'Flashback-ohje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111771364937399642)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'fi'
,p_message_text=>'Ryhmittelyn ohje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111768902361399640)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>T\00E4ss\00E4 valintaikkunassa voit korostaa tietorivej\00E4 tai -sarakkeita sy\00F6tetyn ehdon perusteella.</p>'),
'',
'<p><strong>Korostuslista</strong><br>',
unistr('Korostuslista n\00E4ytt\00E4\00E4 m\00E4\00E4ritetyt korostukset. Poista korostus k\00E4yt\00F6st\00E4 poistamalla sen valinta.<br>'),
unistr('Luo uusi korostus valitsemalla Lis\00E4\00E4 ( &plus; ) tai poista korostus valitsemalla Poista ( &minus; ).</p>'),
'',
'<p><strong>Korostusasetukset</strong><br>',
unistr('N\00E4yt\00F6n avulla voit m\00E4\00E4ritt\00E4 korostuksen ominaisuudet.<br>'),
unistr('Sy\00F6t\00E4 nimi, valitse rivi tai sarake ja valitse taustan ja tekstin HTML-v\00E4rikoodit.<br>'),
unistr('Korosta m\00E4\00E4ritetyt tiedot valitsemalla haluamasi <strong>Ehtotyyppi</strong>:<br>'),
unistr('&nbsp;&nbsp;&nbsp;Rivi - korosta ehto miss\00E4 tahansa sarakkeessa.<br>'),
unistr('&nbsp;&nbsp;&nbsp;Sarake - korosta tietyss\00E4 sarakkeessa m\00E4\00E4ritetyn operaattorin ja arvon perusteella.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111770547350399641)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'fi'
,p_message_text=>'Korostusten ohje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111769170789399640)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>T\00E4ss\00E4 valintaikkunassa voit tallentaa nykyisen ruudukon asetteluun ja m\00E4\00E4rityksiin tekem\00E4si muutokset.<br>'),
unistr('Sovelluskehitt\00E4j\00E4t voivat m\00E4\00E4ritt\00E4\00E4 useita vaihtoehtoisia raporttiasetteluja. Jos sallittua, k\00E4ytt\00E4j\00E4n\00E4 voit tallentaa raportin julkisena, jolloin se on kaikkien ruudukon k\00E4ytt\00E4jien k\00E4ytett\00E4viss\00E4. Voit my\00F6s tallentaa raportin yksityisen\00E4, jolloin vai')
||unistr('n sin\00E4 voit tarkastella sit\00E4.</p>'),
unistr('<p>Valitse raportin tyyppi k\00E4ytett\00E4viss\00E4 olevista tyypeist\00E4 ja anna tallennettavalle raportille nimi.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111770300146399641)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Raporttien ohje',
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111768541870399640)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>T\00E4ss\00E4 valintaikkunassa voit m\00E4\00E4ritt\00E4\00E4 n\00E4ytt\00F6j\00E4rjestyksen.</p>'),
'',
'<p><strong>Lajittelulista</strong><br>',
unistr('Lajittelu-valintaikkunassa n\00E4ytet\00E4\00E4n konfiguroitujen lajittelus\00E4\00E4nt\00F6jen lista.<br>'),
unistr('Luo lajittelusarake valitsemalla Lis\00E4\00E4 ( &plus; ) tai poista lajittelusarake valitsemalla Poista ( &minus; ).<br>'),
unistr('Voit siirt\00E4\00E4 valittua lajittelusaraketta muiden sarakkeiden yl\00E4- tai alapuolelle valitsemalla Siirr\00E4 yl\00F6s ( &uarr; ) tai Siirr\00E4 alas ( &darr; ).</p>'),
'',
'<p><strong>Lajitteluasetukset</strong><br>',
unistr('Valitse lajittelusarake, lajittelusuunta ja tyhjien sarakkeiden (sarakkeet, joissa ei ole arvoa) j\00E4rjestys.</p>'),
'',
unistr('<p><em>Huomautus: Tietoja voi lajitella sellaisten sarakkeiden mukaan, joita ei n\00E4ytet\00E4. Kaikki sarakkeet eiv\00E4t kuitenkaan aina ole lajiteltavissa.</em><br>'),
unistr('<em>N\00E4ytettyjen sarakkeiden j\00E4rjestyst\00E4 voi muuttaa sarakeotsikoiden j\00E4ljess\00E4 olevilla yl\00E4- ja alanuolilla (nouseva/laskeva). Voit lis\00E4t\00E4 my\00F6hemm\00E4n sarakkeen olemassa olevaan lajitteluun pit\00E4m\00E4ll\00E4 vaihton\00E4pp\00E4imen painettuna ja napsauttamalla yl\00E4- tai')
||' alanuolta.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111770953513399641)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'fi'
,p_message_text=>'Lajittelun ohje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111770134935399641)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'fi'
,p_message_text=>'Tilauksen ohje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111722474538399606)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'fi'
,p_message_text=>'Piilota'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111689262274399582)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'fi'
,p_message_text=>'Korostus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111757261281399631)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'fi'
,p_message_text=>'Korkea'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111758065943399632)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'fi'
,p_message_text=>'Vaaka'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111715409966399601)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'fi'
,p_message_text=>'tuntia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111720458843399604)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'fi'
,p_message_text=>'Kuvake'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111688142749399581)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'fi'
,p_message_text=>unistr('Kuvaken\00E4kym\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111713649720399600)
,p_name=>'APEX.IG.IN'
,p_message_language=>'fi'
,p_message_text=>unistr('sis\00E4ltyy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111722035351399606)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'fi'
,p_message_text=>'Ei-aktiivinen asetus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111722121365399606)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'fi'
,p_message_text=>'Ei-aktiiviset asetukset'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111729749248399611)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('Sis\00E4inen virhe k\00E4sitelt\00E4ess\00E4 interaktiivisen ruudukon pyynt\00F6\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111625577042399534)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'fi'
,p_message_text=>unistr('Sarakkeen suodatintyyppi\00E4 %0 ei tueta sarakkeessa %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111769907949399641)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'fi'
,p_message_text=>unistr('Virheellinen p\00E4iv\00E4m\00E4\00E4r\00E4n muoto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111744166719399622)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'fi'
,p_message_text=>unistr('Interaktiivinen ruudukko ei tue suodattimen m\00E4\00E4rityst\00E4 sarakkeelle %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111744047514399622)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 ei ole sallittu suodatintyyppi interaktiivisen ruudukon suodattimen m\00E4\00E4ritykseen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111630649092399538)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'fi'
,p_message_text=>'Virheellinen numeron muoto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111772697949399643)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'fi'
,p_message_text=>'Virheellinen asetus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111772790940399643)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'fi'
,p_message_text=>'Virheelliset asetukset'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111763786831399636)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'fi'
,p_message_text=>unistr('Lajitteluperusteeksi on m\00E4\00E4ritetty %0, mutta kohteelle %0 ei ole valittu yht\00E4\00E4n saraketta.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111761031319399634)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'fi'
,p_message_text=>'Virheellinen arvo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111756193874399631)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'fi'
,p_message_text=>unistr('Ei n\00E4ytet\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111714468167399600)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'fi'
,p_message_text=>unistr('edellisess\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111714698036399600)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'fi'
,p_message_text=>'seuraavana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111713540828399600)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'fi'
,p_message_text=>unistr('ei ole tyhj\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111713468327399599)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'fi'
,p_message_text=>unistr('on tyhj\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111764544727399637)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'fi'
,p_message_text=>'Nimi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111756552899399631)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'fi'
,p_message_text=>'Nimi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111760454211399634)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'fi'
,p_message_text=>'Viimeinen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111703721647399592)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'fi'
,p_message_text=>unistr('Viime p\00E4iv\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111703972402399593)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'fi'
,p_message_text=>'Viimeinen tunti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111704409110399593)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'fi'
,p_message_text=>'Edellinen minuutti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111703443036399592)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'fi'
,p_message_text=>'Edellinen kuukausi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111703592462399592)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'fi'
,p_message_text=>'Edellinen viikko'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111703682393399592)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'fi'
,p_message_text=>unistr('Edelliset %0 p\00E4iv\00E4\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111703817381399593)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'fi'
,p_message_text=>'Edelliset %0 tuntia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111704579420399593)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'fi'
,p_message_text=>'Edelliset %0 minuuttia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111704374693399593)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'fi'
,p_message_text=>'Edelliset %0 kuukautta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111704286046399593)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'fi'
,p_message_text=>'Edelliset %0 viikkoa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111703233480399592)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'fi'
,p_message_text=>'Edelliset %0 vuotta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111703302423399592)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'fi'
,p_message_text=>'Edellinen vuosi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111764756848399637)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'fi'
,p_message_text=>'Solun kohdistus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111764867847399637)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'fi'
,p_message_text=>unistr('Ryhm\00E4n k\00E4ytt\00F6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111714093711399600)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'fi'
,p_message_text=>'pienempi kuin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111714156299399600)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'fi'
,p_message_text=>unistr('pienempi tai yht\00E4 suuri kuin')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111758683244399632)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'fi'
,p_message_text=>'Viiva'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111758732791399632)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'fi'
,p_message_text=>'Viiva ja alue'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111765184255399637)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'fi'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111757306249399631)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'fi'
,p_message_text=>'Matala'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111767702540399639)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'fi'
,p_message_text=>'Erota osoitteet toisistaan pilkulla'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111715252744399601)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'fi'
,p_message_text=>unistr('vastaa s\00E4\00E4nn\00F6llist\00E4 lauseketta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111739689243399618)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'fi'
,p_message_text=>'Maksimi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111775231393399644)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'fi'
,p_message_text=>'Kokonaismaksimi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111739844039399618)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'fi'
,p_message_text=>'Mediaani'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111775335529399644)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'fi'
,p_message_text=>'Kokonaismediaani'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111739570664399618)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'fi'
,p_message_text=>'Minimi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111715302443399601)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'fi'
,p_message_text=>'minuuttia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111740310617399619)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'fi'
,p_message_text=>'Minuuttia sitten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111775189090399644)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'fi'
,p_message_text=>'Kokonaisminimi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111715782243399601)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'fi'
,p_message_text=>'kuukautta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111722382895399606)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4iss\00E4 tiedoissa on yli %0 rivi\00E4, mik\00E4 ylitt\00E4\00E4 sallitun maksimim\00E4\00E4r\00E4n. Ota k\00E4ytt\00F6\00F6n lis\00E4\00E4 suodattimia, jotta saat tulokset n\00E4kyviin.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111749057195399625)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'fi'
,p_message_text=>unistr('Alueen staattinen tunniste on m\00E4\00E4ritett\00E4v\00E4, koska sivulla on useita interaktiivisia ruudukkoja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111718457531399603)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'fi'
,p_message_text=>'Nimi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111718667470399603)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'fi'
,p_message_text=>'Nimetty raportti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111702602726399592)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'fi'
,p_message_text=>unistr('Seuraava p\00E4iv\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111702439058399592)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'fi'
,p_message_text=>'Seuraava tunti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111704622445399593)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'fi'
,p_message_text=>'Edellinen minuutti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111702989226399592)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'fi'
,p_message_text=>'Seuraava kuukausi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111702851452399592)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'fi'
,p_message_text=>'Seuraava viikko'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111702706147399592)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'fi'
,p_message_text=>unistr('Seuraavat %0 p\00E4iv\00E4\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111702537336399592)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'fi'
,p_message_text=>'Seuraavat %0 tuntia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111704724020399593)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'fi'
,p_message_text=>'Seuraavat %0 minuuttia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111704036692399593)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'fi'
,p_message_text=>'Seuraavat %0 kuukautta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111704171238399593)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'fi'
,p_message_text=>'Seuraavat %0 viikkoa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111703127831399592)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'fi'
,p_message_text=>'Seuraavat %0 vuotta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111703037889399592)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'fi'
,p_message_text=>'Seuraava vuosi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111714380213399600)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'fi'
,p_message_text=>unistr('ei v\00E4lill\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111713305914399599)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'fi'
,p_message_text=>'eri suuri kuin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111779517714399647)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'fi'
,p_message_text=>unistr('Alue, jonka tunniste on %0, ei ole interaktiivisen ruudukon alue, tai sit\00E4 ei ole sovelluksessa %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111713735346399600)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'fi'
,p_message_text=>unistr('ei sis\00E4lly')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111714554541399600)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'fi'
,p_message_text=>unistr('ei edellisess\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111714728870399600)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'fi'
,p_message_text=>'ei seuraavassa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111722272922399606)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'fi'
,p_message_text=>unistr('Tietoja ei l\00F6ytynyt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111760251909399634)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'fi'
,p_message_text=>unistr('Tyhj\00E4t')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111765395014399637)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'fi'
,p_message_text=>'Numero'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111760575867399634)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'fi'
,p_message_text=>unistr('Ei k\00E4yt\00F6ss\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111760645220399634)
,p_name=>'APEX.IG.ON'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4yt\00F6ss\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111712574781399599)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'fi'
,p_message_text=>'1 minuutti sitten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111768271696399639)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'fi'
,p_message_text=>unistr('Avaa v\00E4rin valitsin: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111757082853399631)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'fi'
,p_message_text=>'Avaa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111719528577399604)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'fi'
,p_message_text=>'Operaattori'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111756473105399631)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'fi'
,p_message_text=>'Suunta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111758882519399633)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'fi'
,p_message_text=>unistr('Ympyr\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111720811928399605)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'fi'
,p_message_text=>'Pivot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111688433206399581)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'fi'
,p_message_text=>unistr('Pivot-n\00E4kym\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111768148443399639)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4yt\00E4 arvojen erottimena merkki\00E4 "%0"')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111758966313399633)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'fi'
,p_message_text=>'Polaarinen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111764241152399637)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'fi'
,p_message_text=>'Keskikohta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111764355833399637)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'fi'
,p_message_text=>'Loppu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111764189031399636)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'fi'
,p_message_text=>'Alku'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111718719878399603)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'fi'
,p_message_text=>'Ensisijainen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111719013034399603)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'fi'
,p_message_text=>'Ensisijainen oletus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111735522870399615)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'fi'
,p_message_text=>'Ensisijainen raportti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111617740067399529)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'fi'
,p_message_text=>unistr('Sis\00E4llyt\00E4 helppok\00E4ytt\00F6isyystunnisteet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111616478077399528)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'fi'
,p_message_text=>'Vaaka'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111616519414399528)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'fi'
,p_message_text=>'Pysty'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111616304510399528)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'fi'
,p_message_text=>'Sivun suunta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111616266641399528)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'fi'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111616175863399528)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'fi'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111617873465399529)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'fi'
,p_message_text=>'Mukautettu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111615945161399528)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'fi'
,p_message_text=>'Legal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111615880970399527)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'fi'
,p_message_text=>'Letter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111616065546399528)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'fi'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111615776853399527)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'fi'
,p_message_text=>'Sivun koko'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111605941050399520)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'fi'
,p_message_text=>'Poista Rich Text'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111759015612399633)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'fi'
,p_message_text=>unistr('S\00E4teitt\00E4inen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111759175301399633)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'fi'
,p_message_text=>'Alue'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111769476547399640)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'fi'
,p_message_text=>unistr('P\00E4ivit\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111723013323399606)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'fi'
,p_message_text=>unistr('P\00E4ivit\00E4 rivi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111721843089399605)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'fi'
,p_message_text=>unistr('P\00E4ivit\00E4 rivit')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111727046808399609)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'fi'
,p_message_text=>'Interaktiivisen ruudukon alue puuttuu sovelluksesta %0, sivusta %1 ja alueesta %2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111689973569399582)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'fi'
,p_message_text=>'Poista %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111718107698399603)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'fi'
,p_message_text=>'Raportti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111778778165399647)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'fi'
,p_message_text=>'Raportti poistettu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111778447405399647)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'fi'
,p_message_text=>unistr('Vaihtoehtoinen raportti tallennettu kaikille k\00E4ytt\00E4jille')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111778389269399647)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'fi'
,p_message_text=>unistr('Oletusraportti tallennettu kaikille k\00E4ytt\00E4jille')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111778604634399647)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'fi'
,p_message_text=>'Yksityinen raportti tallennettu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111778561422399647)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'fi'
,p_message_text=>unistr('Julkinen raportti tallennettu kaikille k\00E4ytt\00E4jille')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111727146716399609)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'fi'
,p_message_text=>'Tallennettua interaktiivista ruudukkoa, jonka nimi on %0, ei ole.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111712463728399599)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'fi'
,p_message_text=>'Raportin tiedot %0 minuuttia sitten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111712317793399599)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'fi'
,p_message_text=>'Raportin tiedot 1 minuutti sitten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111652015069399555)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'fi'
,p_message_text=>'Interaktiivista ruudukkoraporttia ei ole.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111771616735399642)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'fi'
,p_message_text=>'Raportti - Muokkaa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111726951411399609)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'fi'
,p_message_text=>'Tallennettua interaktiivista ruudukkoa, jonka tunniste on %0, ei ole.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111771515767399642)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'fi'
,p_message_text=>unistr('Raportti - Tallenna nimell\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111690099243399582)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'fi'
,p_message_text=>'Raporttiasetukset'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111779622582399648)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'fi'
,p_message_text=>'Tallennettua interaktiivista ruudukkoa, jonka staattinen tunniste on %0, ei ole.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111774525283399644)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'fi'
,p_message_text=>unistr('Raporttin\00E4kym\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111689161426399582)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'fi'
,p_message_text=>'Nollaa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111723182501399606)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'fi'
,p_message_text=>'Palauta muutokset'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111721932837399606)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'fi'
,p_message_text=>'Palauta rivit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111719163465399604)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'fi'
,p_message_text=>'Rivi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111718051730399603)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'fi'
,p_message_text=>unistr('Rivej\00E4 sivulla')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111779297602399647)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'fi'
,p_message_text=>'Rivin toiminnot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111780410296399648)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'fi'
,p_message_text=>'Rivin %0 toiminnot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111689468871399582)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'fi'
,p_message_text=>'Tallenna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111732140885399613)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'fi'
,p_message_text=>'tallennettu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111687660127399581)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'fi'
,p_message_text=>'Tallennetut raportit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111687780729399581)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'fi'
,p_message_text=>'Oletus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111662217513399562)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'fi'
,p_message_text=>unistr('Tallennettu raportti, jonka nimi on %0, on jo olemassa. Sy\00F6t\00E4 uusi nimi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111687849243399581)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'fi'
,p_message_text=>'Yksityinen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111687927421399581)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'fi'
,p_message_text=>'Julkinen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111774224339399644)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'fi'
,p_message_text=>unistr('Tallenna nimell\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111721221934399605)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'fi'
,p_message_text=>'Tallenna raporttiasetukset'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111759283518399633)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'fi'
,p_message_text=>'Piste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111687563637399581)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'fi'
,p_message_text=>'Haku'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111766537992399638)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'fi'
,p_message_text=>'Haku: kaikki tekstisarakkeet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111687449904399581)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'fi'
,p_message_text=>'Hae: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111765777114399638)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'fi'
,p_message_text=>'Haku: koko teksti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111712260348399599)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'fi'
,p_message_text=>'Hae kohdetta %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111755809435399630)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'fi'
,p_message_text=>'- Valitse -'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111696057940399587)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'fi'
,p_message_text=>'Valinta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111748797687399625)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'fi'
,p_message_text=>unistr('Valitse 1 rivi p\00E4\00E4alueelta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111687391904399581)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'fi'
,p_message_text=>unistr('Valitse etsitt\00E4v\00E4t sarakkeet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111778983275399647)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'fi'
,p_message_text=>'Valinnan toiminnot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111696294240399587)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'fi'
,p_message_text=>'Solujen valinta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111696156929399587)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'fi'
,p_message_text=>'Rivin valinta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111767153053399639)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'fi'
,p_message_text=>unistr('L\00E4het\00E4 s\00E4hk\00F6postina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111759632177399633)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'fi'
,p_message_text=>'Sarja'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111685316975399579)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4yt\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111737994221399617)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4yt\00E4 kokonaisarvo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111722788262399606)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'fi'
,p_message_text=>unistr('Yhden rivin n\00E4kym\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111721093686399605)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'fi'
,p_message_text=>'Lajittelu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111759717278399633)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'fi'
,p_message_text=>'Lajitteluperuste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111779372686399647)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'fi'
,p_message_text=>unistr('Kullekin sarakkeelle voi m\00E4\00E4ritt\00E4\00E4 vain yhden lajittelun.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111779101099399647)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'fi'
,p_message_text=>'Muutosvalikko'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111760772695399634)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'fi'
,p_message_text=>'Pino'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111715007241399601)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'fi'
,p_message_text=>'alkaa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111759302084399633)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'fi'
,p_message_text=>'Varasto'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111680313239399575)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'fi'
,p_message_text=>unistr('Venyt\00E4 sarakeleveyksi\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111721431167399605)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'fi'
,p_message_text=>'Tilaus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111739431257399618)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'fi'
,p_message_text=>'Summa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111780675248399648)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'fi'
,p_message_text=>unistr('Interaktiivinen ruudukko. Raportti: %0, n\00E4kym\00E4: %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111774671629399644)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'fi'
,p_message_text=>'Kokonaissumma'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111757526486399632)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'fi'
,p_message_text=>'Kohde'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111763998774399636)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'fi'
,p_message_text=>unistr('Tekstin v\00E4ri')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111690127746399583)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'fi'
,p_message_text=>'Vaihda'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111737884098399617)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'fi'
,p_message_text=>unistr('Ty\00F6kaluvihje')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111718229163399603)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'fi'
,p_message_text=>'Tyyppi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111722646642399606)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'fi'
,p_message_text=>'Avaa lukitus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111719785526399604)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'fi'
,p_message_text=>unistr('Yksikk\00F6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111766953529399638)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'fi'
,p_message_text=>'Muutoksia ei ole tallennettu. Haluatko jatkaa?'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111719660144399604)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'fi'
,p_message_text=>'Arvo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111756611961399631)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'fi'
,p_message_text=>'Arvo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111761512329399635)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'fi'
,p_message_text=>'Arvo on pakollinen.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111746499412399623)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'fi'
,p_message_text=>unistr('Arvo (aikavy\00F6hykett\00E4 ei voi vaihtaa)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111765446549399637)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'fi'
,p_message_text=>'Teksti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111757923507399632)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'fi'
,p_message_text=>'Pysty'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111717761462399603)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4yt\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111755982588399630)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4ytetty')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111757413796399632)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'fi'
,p_message_text=>unistr('M\00E4\00E4r\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111715657415399601)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'fi'
,p_message_text=>'viikkoa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111756074302399631)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'fi'
,p_message_text=>unistr('Sarakkeen minimileveys (pikseli\00E4)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111706862798399595)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 v\00E4lill\00E4 %1 - %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111706555035399595)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 sis\00E4lt\00E4\00E4 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111706625562399595)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 ei sis\00E4ll\00E4 kohdetta %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111684765449399579)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'fi'
,p_message_text=>'%0 ei ala merkkijonolla %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111705367316399594)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 yht\00E4 suuri kuin %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111705580462399594)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'fi'
,p_message_text=>'%0 suurempi kuin %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111705659170399594)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 suurempi tai yht\00E4 suuri kuin %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111706332473399594)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'fi'
,p_message_text=>'%0 kohteessa %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111707525566399595)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 edellisten %1 p\00E4iv\00E4n aikana')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111707329946399595)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'fi'
,p_message_text=>'%0 edellisten %1 tunnin aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111707114386399595)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'fi'
,p_message_text=>'%0 edellisten %1 minuutin aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111707937608399596)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'fi'
,p_message_text=>'%0 edellisten %1 kuukauden aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111707739596399595)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'fi'
,p_message_text=>'%0 edellisten %1 viikon aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111708143817399596)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'fi'
,p_message_text=>'%0 edellisten %1 vuoden aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111707400078399595)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 edellisen\00E4 p\00E4iv\00E4n\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111707264886399595)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'fi'
,p_message_text=>'%0 edellisen tunnin aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111707046466399595)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'fi'
,p_message_text=>'%0 edellisen minuutin aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111707827516399595)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'fi'
,p_message_text=>'%0 edellisen kuukauden aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111707645661399595)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'fi'
,p_message_text=>'%0 edellisen viikon aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111708001835399596)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'fi'
,p_message_text=>'%0 edellisen vuoden aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111709918272399597)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 seuraavien %1 p\00E4iv\00E4n aikana')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111709721473399597)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'fi'
,p_message_text=>'%0 seuraavien %1 tunnin aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111709510311399597)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'fi'
,p_message_text=>'%0 seuraavien %1 minuutin aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111710317655399597)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'fi'
,p_message_text=>'%0 seuraavien %1 kuukauden aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111710120256399597)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'fi'
,p_message_text=>'%0 seuraavien %1 viikon aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111710578108399597)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'fi'
,p_message_text=>'%0 seuraavien %1 vuoden aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111709841272399597)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 seuraavana p\00E4iv\00E4n\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111709657299399597)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'fi'
,p_message_text=>'%0 seuraavan tunnin aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111709421271399597)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'fi'
,p_message_text=>'%0 seuraavan minuutin aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111710230715399597)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'fi'
,p_message_text=>'%0 seuraavan kuukauden aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111710027685399597)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'fi'
,p_message_text=>'%0 seuraavan viikon aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111710499716399597)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'fi'
,p_message_text=>'%0 seuraavan vuoden aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111706042617399594)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 ei ole tyhj\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111705965166399594)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 on tyhj\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111705762863399594)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'fi'
,p_message_text=>'%0 pienempi kuin %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111705854944399594)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 pienempi tai yht\00E4 suuri kuin %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111706101152399594)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'fi'
,p_message_text=>'%0 kuin %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111706791950399595)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 vastaa s\00E4\00E4nn\00F6llist\00E4 lauseketta %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111712650653399599)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'fi'
,p_message_text=>'%0 minuuttia sitten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111706928177399595)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 ei ole v\00E4lill\00E4 %1 - %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111705454813399594)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'fi'
,p_message_text=>'%0 eri suuri kuin %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111706461860399594)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'fi'
,p_message_text=>'%0 ei kohteessa %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111708735084399596)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 ei edellisten %1 p\00E4iv\00E4n aikana')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111708595061399596)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'fi'
,p_message_text=>'%0 ei edellisten %1 tunnin aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111708306364399596)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'fi'
,p_message_text=>'%0 ei edellisten %1 minuutin aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111709134531399596)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'fi'
,p_message_text=>'%0 ei edellisten %1 kuukauden aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111708998491399596)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'fi'
,p_message_text=>'%0 ei edellisten %1 viikon aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111709372965399597)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'fi'
,p_message_text=>'%0 ei edellisten %1 vuoden aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111708614367399596)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 ei edellisen\00E4 p\00E4iv\00E4n\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111708414530399596)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'fi'
,p_message_text=>'%0 ei edellisen tunnin aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111708205477399596)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'fi'
,p_message_text=>'%0 ei edellisen minuutin aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111709072231399596)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'fi'
,p_message_text=>'%0 ei edellisen kuukauden aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111708883780399596)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'fi'
,p_message_text=>'%0 ei edellisen viikon aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111709276343399596)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'fi'
,p_message_text=>'%0 ei edellisen vuoden aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111711175485399598)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 ei seuraavien %1 p\00E4iv\00E4n aikana')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111710940977399598)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'fi'
,p_message_text=>'%0 ei seuraavien %1 tunnin aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111710759754399598)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'fi'
,p_message_text=>'%0 ei seuraavien %1 minuutin aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111711513421399598)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'fi'
,p_message_text=>'%0 ei seuraavien %1 kuukauden aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111711380721399598)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'fi'
,p_message_text=>'%0 ei seuraavien %1 viikon aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111711779794399598)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'fi'
,p_message_text=>'%0 ei seuraavien %1 vuoden aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111711091136399598)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 ei seuraavana p\00E4iv\00E4n\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111710886189399598)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'fi'
,p_message_text=>'%0 ei seuraavan tunnin aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111710671607399598)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'fi'
,p_message_text=>'%0 ei seuraavan minuutin aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111711448762399598)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'fi'
,p_message_text=>'%0 ei seuraavan kuukauden aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111711222954399598)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'fi'
,p_message_text=>'%0 ei seuraavan viikon aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111711627507399598)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'fi'
,p_message_text=>'%0 ei seuraavan vuoden aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111706201063399594)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'fi'
,p_message_text=>'%0 ei kuin %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111713136340399599)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'fi'
,p_message_text=>'%0 alkaa %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111756757705399631)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'fi'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111715893310399601)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'fi'
,p_message_text=>'vuotta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111756884449399631)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'fi'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111756924913399631)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'fi'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111765949625399638)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'fi'
,p_message_text=>'Maanantai 12. tammikuuta 2016'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111766035256399638)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'fi'
,p_message_text=>'Tammikuu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111766146868399638)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'fi'
,p_message_text=>'16 tuntia sitten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111766293561399638)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'fi'
,p_message_text=>'16 tunnin aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111621202557399531)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'fi'
,p_message_text=>unistr('Virheellinen tiedostotyyppi. Tuettuja tiedostotyyppej\00E4 ovat %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111748197062399625)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'fi'
,p_message_text=>'Selaa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111747877808399624)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'fi'
,p_message_text=>'Valitse tiedosto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111747986696399625)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'fi'
,p_message_text=>'Valitse tiedostot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111621013866399531)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'fi'
,p_message_text=>unistr('Ved\00E4 ja pudota')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111621476341399531)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'fi'
,p_message_text=>unistr('Ved\00E4 ja pudota tiedostoja')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111622671303399532)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'fi'
,p_message_text=>unistr('Valitse tiedosto tai ved\00E4 se t\00E4h\00E4n.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111622732727399532)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'fi'
,p_message_text=>unistr('Valitse tai pudota tiedostot t\00E4h\00E4n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111622895025399533)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'fi'
,p_message_text=>unistr('Valitse tiedosto tai ved\00E4 se t\00E4h\00E4n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111622970984399533)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'fi'
,p_message_text=>unistr('Valitse tai pudota tiedostot t\00E4h\00E4n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111621383721399531)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'fi'
,p_message_text=>'%0 tiedostoa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111621159757399531)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'fi'
,p_message_text=>'Tiedosto on liian suuri. Tiedoston maksimikoko on %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111608965591399522)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'fi'
,p_message_text=>'Osoite on pakollinen.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111607843404399522)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'fi'
,p_message_text=>'Kaupunki'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111608292324399522)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'fi'
,p_message_text=>'Maakoodi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111607945694399522)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'fi'
,p_message_text=>'Talon numero'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111608896831399522)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'fi'
,p_message_text=>'Leveysaste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111608765637399522)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'fi'
,p_message_text=>'Pituusaste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111608649374399522)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4ytt\00F6 kartalla')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111608368265399522)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'fi'
,p_message_text=>'Tulos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111608055007399522)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'fi'
,p_message_text=>'Postinumero'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111608130762399522)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'fi'
,p_message_text=>'Osavaltio'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111607700177399521)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'fi'
,p_message_text=>'Katuosoite'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111607695420399521)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'fi'
,p_message_text=>'Geokoodaustulokset'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111620236302399531)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'fi'
,p_message_text=>'Geokoodattu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111620320685399531)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'fi'
,p_message_text=>'Ei geokoodattu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111608508071399522)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'fi'
,p_message_text=>'Kartta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111608408849399522)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'fi'
,p_message_text=>unistr('Osoitteita ei l\00F6ydy.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111609008946399522)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'fi'
,p_message_text=>'%0 on pakollinen.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111778899332399647)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'fi'
,p_message_text=>'Ohjeteksti: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111672273971399569)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'fi'
,p_message_text=>'Valittu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111672358225399570)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'fi'
,p_message_text=>'Ei valittu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111618272866399529)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'fi'
,p_message_text=>'#LABEL# ei ole sallitulla alueella %0 - %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111618324827399529)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'fi'
,p_message_text=>'#LABEL# ei ole arvon %0 monikerta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111617954586399529)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'fi'
,p_message_text=>'Kohteen #LABEL# on vastattava arvoja %0 ja %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111618131660399529)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'fi'
,p_message_text=>'Ei'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111696434825399587)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'fi'
,p_message_text=>unistr('Ei k\00E4yt\00F6ss\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111696546051399587)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4yt\00F6ss\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111618052966399529)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'fi'
,p_message_text=>unistr('Kyll\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111601446501399517)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'fi'
,p_message_text=>unistr('Lis\00E4\00E4 merkint\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111730636151399612)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'fi'
,p_message_text=>unistr('Lis\00E4\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111730710668399612)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'fi'
,p_message_text=>'Poista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111601532158399517)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'fi'
,p_message_text=>unistr('Valitut sy\00F6tteet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111734434405399614)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'fi'
,p_message_text=>unistr('Lis\00E4asetukset')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111734790361399615)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'fi'
,p_message_text=>'Peruuta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111734582481399614)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'fi'
,p_message_text=>'Yleiset'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111734853700399615)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4yt\00F6ss\00E4 olevan mallin asetukset')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111735422457399615)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'fi'
,p_message_text=>unistr('Mallivaihtoehdot eiv\00E4t ole k\00E4ytett\00E4viss\00E4, koska t\00E4t\00E4 komponenttia ei ole muodostettu sivulla.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111734335987399614)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'fi'
,p_message_text=>unistr('Mallivaihtoehtoja ei l\00F6ydy.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111734621159399615)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'fi'
,p_message_text=>'Tallenna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111609900842399523)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'fi'
,p_message_text=>unistr('Tyhjenn\00E4 ympyr\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111611746049399524)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'fi'
,p_message_text=>'Mukautetut tyylit ei ole sallittu JSON.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111610283157399523)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'fi'
,p_message_text=>unistr('Et\00E4isyysty\00F6kalu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111610041989399523)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'fi'
,p_message_text=>unistr('Piirr\00E4 ympyr\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111602633534399518)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'fi'
,p_message_text=>unistr('Kohdistettu haku edellytt\00E4\00E4 aluetason tietol\00E4hdett\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111605257687399520)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'fi'
,p_message_text=>'Nykyinen sijainti'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111606393264399520)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'fi'
,p_message_text=>'Aloituskohdan koordinaatit ovat virheelliset.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111603727884399518)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'fi'
,p_message_text=>'Aloituskohdan on oltava pistegeometria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111606114427399520)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'fi'
,p_message_text=>'km'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111604766568399519)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'fi'
,p_message_text=>'Taso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111738001353399617)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'fi'
,p_message_text=>'Kerros: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111609395521399523)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'fi'
,p_message_text=>'Kartta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111602504712399518)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'fi'
,p_message_text=>'Viestit'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111606229506399520)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'fi'
,p_message_text=>'mailia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111737039729399616)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4iss\00E4 tiedoissa on yli %0 rivi\00E4, mik\00E4 ylitt\00E4\00E4 sallitun enimm\00E4ism\00E4\00E4r\00E4n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111604524019399519)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'fi'
,p_message_text=>unistr('&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">Ehdot</a> &nbsp;&nbsp; Map data &copy; 2017 T\00C4H\00C4N')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111603431643399518)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'fi'
,p_message_text=>unistr('Tietotyyppi SDO_GEOMETRY ei ole k\00E4ytett\00E4viss\00E4 t\00E4ss\00E4 tietokannassa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111604688655399519)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'fi'
,p_message_text=>unistr('<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; OpenStreetMap-sis\00E4ll\00F6ntuottajat </a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111604852019399519)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'fi'
,p_message_text=>'Pisteet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111738133522399617)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 pistett\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111610199928399523)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'fi'
,p_message_text=>'Zoomaa suorakulmioon'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111609823031399523)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'fi'
,p_message_text=>'Poista'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111605189148399520)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'fi'
,p_message_text=>'Palauta suuntima pohjoiseen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111685443121399579)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'fi'
,p_message_text=>'Vaihda 2D-tilaan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111685590263399579)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'fi'
,p_message_text=>'Vaihda 3D-tilaan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111609790726399523)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'fi'
,p_message_text=>unistr('Vaihda tekij\00E4noikeuksia koskevaa ilmoitusta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111610339259399523)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'fi'
,p_message_text=>unistr('Kokonaiset\00E4isyys')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111604944560399519)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'fi'
,p_message_text=>unistr('L\00E4henn\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111605036453399519)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'fi'
,p_message_text=>'Loitonna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111732590762399613)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'fi'
,p_message_text=>'Lihavointi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111733434860399614)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'fi'
,p_message_text=>'Kuva'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111733063660399613)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'fi'
,p_message_text=>unistr('Sis\00E4inen koodi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111746646348399624)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'fi'
,p_message_text=>unistr('Lis\00E4\00E4 kuva')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111746739707399624)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'fi'
,p_message_text=>unistr('Linkin lis\00E4ys')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111732648725399613)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'fi'
,p_message_text=>'Kursivointi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111747301939399624)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'fi'
,p_message_text=>'Linkki'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111733325615399614)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'fi'
,p_message_text=>'Luettelo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111733270040399614)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'fi'
,p_message_text=>unistr('J\00E4rjestetty lista')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111732783709399613)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'fi'
,p_message_text=>'Esikatselu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111732899833399613)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'fi'
,p_message_text=>'Ei esikatseltavia kohteita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111732925373399613)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'fi'
,p_message_text=>'Yliviivaus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111733166434399613)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'fi'
,p_message_text=>unistr('J\00E4rjest\00E4m\00E4t\00F6n lista')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111712075112399599)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'fi'
,p_message_text=>'nykyinen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111769581675399640)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'fi'
,p_message_text=>unistr('Lis\00E4\00E4...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111711907492399598)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'fi'
,p_message_text=>'Ladataan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111743708946399621)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'fi'
,p_message_text=>'Ilmoitusviesti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111717017360399602)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'fi'
,p_message_text=>unistr('Kohteen #LABEL# on oltava numero, joka on pienempi tai yht\00E4 suuri kuin %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111717184199399602)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'fi'
,p_message_text=>'Kohteen #LABEL# on oltava sallittu numero.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111717298317399602)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'fi'
,p_message_text=>'#LABEL# ei vastaa numeromuotoa %0 (esimerkki: %1).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111716927143399602)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'fi'
,p_message_text=>unistr('Kohteen #LABEL# on oltava numero, joka on suurempi tai yht\00E4 suuri kuin %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111716830421399602)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'fi'
,p_message_text=>'Kohteen %#LABEL# on oltava numero %0 - %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111712158764399599)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'fi'
,p_message_text=>'avautuu uuteen ikkunaan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111665343264399564)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4m\00E4 sivu on jo l\00E4hetetty, eik\00E4 sit\00E4 voi l\00E4hett\00E4\00E4 uudelleen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111647926832399551)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'fi'
,p_message_text=>unistr('Sovelluksen %0 sivua %1 ei l\00F6ydy.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111681768233399576)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'fi'
,p_message_text=>'Kohteella #LABEL# on oltava jokin arvo.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111625061563399534)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'fi'
,p_message_text=>'Haku'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111731001331399612)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'fi'
,p_message_text=>'Sulje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111730980074399612)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'fi'
,p_message_text=>'Etsi%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111731284266399612)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'fi'
,p_message_text=>'Seuraava'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111731196453399612)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'fi'
,p_message_text=>'Edellinen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111617186250399528)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'fi'
,p_message_text=>unistr('Sy\00F6t\00E4 v\00E4hint\00E4\00E4n %0 merkin mittainen hakuehto.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111686615543399580)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'fi'
,p_message_text=>'Avattava valintalista: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111617267482399528)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'fi'
,p_message_text=>'Anna hakuehto.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111617005170399528)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'fi'
,p_message_text=>'Ei tuloksia.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111616991846399528)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'fi'
,p_message_text=>'Poista %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111704834869399593)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'fi'
,p_message_text=>'Hakuehto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111730855952399612)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'fi'
,p_message_text=>'Haku'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111741578647399620)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4sitell\00E4\00E4n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111615573237399527)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'fi'
,p_message_text=>unistr('Lis\00E4\00E4 aloitusn\00E4ytt\00F6\00F6n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111611503631399524)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ilmeisesti laitteesi tai selaimesi ei t\00E4ll\00E4 hetkell\00E4 tue Progressive-verkkosovellusten asennusta.</p>'),
unistr('    <p class="a-pwaDialog-intro">Jos t\00E4m\00E4 sovellus on jo asennettu laitteeseesi, avaa se aloitusn\00E4yt\00F6st\00E4.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111611141195399524)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">T\00E4t\00E4 sivustoa voi k\00E4ytt\00E4\00E4 sovelluksena. Voit k\00E4ytt\00E4\00E4 sit\00E4 koko n\00E4yt\00F6n tilassa lis\00E4\00E4m\00E4ll\00E4 sen aloitusn\00E4ytt\00F6\00F6n.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Napauta alareunan siirtymisalueen <strong>Valikko</strong>-kuvaketta</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Valitse <strong>Asenna</strong></p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Vahvista valitsemalla <strong>Lis\00E4\00E4</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111611224786399524)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">T\00E4t\00E4 sivustoa voi k\00E4ytt\00E4\00E4 sovelluksena, joka toimii parhaiten Chrome- tai Edge-selaimessa.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Napauta osoiterivin vieress\00E4 olevaa <strong>Valikko</strong>-kuvaketta</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">2. Valitse <strong>Asenna</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111610829462399524)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">T\00E4t\00E4 sivustoa voi k\00E4ytt\00E4\00E4 sovelluksena, joka toimii parhaiten Safari-selaimessa.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Napauta alareunan siirtymisalueen <strong>Jaa</strong>-kuvaketta</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Valitse <strong>Avaa Safarissa</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111610505988399524)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">T\00E4t\00E4 sivustoa voi k\00E4ytt\00E4\00E4 sovelluksena. Paranna k\00E4ytt\00F6kokemusta lis\00E4\00E4m\00E4ll\00E4 se aloitusn\00E4ytt\00F6\00F6n.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Napauta osoiterivin vieress\00E4 olevaa <strong>Jaa</strong>-kuvaketta</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Valitse <strong>Lis\00E4\00E4 aloitusn\00E4ytt\00F6\00F6n</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Vahvista valitsemalla <strong style="color:#007AE1;">Lis\00E4\00E4</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111610487465399523)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">T\00E4t\00E4 sivustoa voi k\00E4ytt\00E4\00E4 sovelluksena. Paranna k\00E4ytt\00F6kokemusta lis\00E4\00E4m\00E4ll\00E4 se aloitusn\00E4ytt\00F6\00F6n.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Napauta alareunan siirtymisalueen <strong>Jaa</strong>-kuvaketta</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Selaa alasp\00E4in ja valitse <strong>Lis\00E4\00E4 aloitusn\00E4ytt\00F6\00F6n</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Vahvista valitsemalla <strong style="color:#007AE1;">Lis\00E4\00E4</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111605413237399520)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">T\00E4t\00E4 sivustoa voi k\00E4ytt\00E4\00E4 sovelluksena. Paranna k\00E4ytt\00F6kokemusta lis\00E4\00E4m\00E4ll\00E4 se aloitusn\00E4ytt\00F6\00F6n.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Napauta osoiterivin vieress\00E4 olevaa <strong>Lis\00E4\00E4</strong>-kuvaketta</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Valitse <strong>Lis\00E4\00E4 aloitusn\00E4ytt\00F6\00F6n</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Vahvista valitsemalla <strong style="color:#007AE1;">Lis\00E4\00E4</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111610713884399524)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">T\00E4t\00E4 sivustoa voi k\00E4ytt\00E4\00E4 sovelluksena. Paranna k\00E4ytt\00F6kokemusta lis\00E4\00E4m\00E4ll\00E4 se aloitusn\00E4ytt\00F6\00F6n.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Napauta osoiterivin vieress\00E4 olevaa <strong>Jaa</strong>-kuvaketta</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
'        <p class="a-pwaDialog-stepText">Valitse <strong>Avaa Safarissa</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111610644112399524)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">T\00E4t\00E4 sivustoa voi k\00E4ytt\00E4\00E4 sovelluksena. Paranna k\00E4ytt\00F6kokemusta lis\00E4\00E4m\00E4ll\00E4 se aloitusn\00E4ytt\00F6\00F6n.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
'        <p class="a-pwaDialog-stepText">Napauta alareunan siirtymisalueen <strong>Jaa</strong>-kuvaketta</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
'        <p class="a-pwaDialog-stepText">Valitse <strong>Avaa Safarissa</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111611478281399524)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">T\00E4t\00E4 sivustoa voi k\00E4ytt\00E4\00E4 sovelluksena, joka toimii parhaiten Chrome-selaimessa.</p>'),
'    <p class="a-pwaDialog-intro">Firefox ei toistaiseksi tue verkkosovellusten asennusta.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111610906407399524)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">T\00E4t\00E4 sivustoa voi k\00E4ytt\00E4\00E4 sovelluksena, joka toimii parhaiten Chrome- tai Edge-selaimessa.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox ei toistaiseksi tue verkkosovellusten asennusta macOS-k\00E4ytt\00F6j\00E4rjestelm\00E4ss\00E4.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111611044759399524)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">T\00E4t\00E4 sivustoa voi k\00E4ytt\00E4\00E4 sovelluksena, joka toimii parhaiten Chrome- tai Edge-selaimessa.</p>'),
unistr('    <p class="a-pwaDialog-intro">Safari ei toistaiseksi tue verkkosovellusten asennusta macOS-k\00E4ytt\00F6j\00E4rjestelm\00E4ss\00E4.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111611389649399524)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">T\00E4t\00E4 sivustoa voi k\00E4ytt\00E4\00E4 sovelluksena, joka toimii parhaiten Chrome- tai Edge-selaimessa.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox ei toistaiseksi tue verkkosovellusten asennusta Windows-k\00E4ytt\00F6j\00E4rjestelm\00E4ss\00E4.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111613889551399526)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
unistr('    <h1>Yhteytt\00E4 ei voi muodostaa</h1>'),
unistr('    <p>T\00E4m\00E4n sovelluksen k\00E4ytt\00F6 vaatii Internet-yhteyden.</p>'),
unistr('    <button type="button">Yrit\00E4 uudelleen</button>'),
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111613764036399526)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'fi'
,p_message_text=>unistr('Yhteytt\00E4 ei voi muodostaa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111753539865399629)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'fi'
,p_message_text=>unistr('Lis\00E4\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111697929656399588)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'fi'
,p_message_text=>unistr('Koko p\00E4iv\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111776835719399646)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'fi'
,p_message_text=>unistr('L\00E4het\00E4 kutsu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111776600542399645)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'fi'
,p_message_text=>'Valinnat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111699707015399590)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'fi'
,p_message_text=>unistr('P\00E4iv\00E4n\00E4kym\00E4 kaikille p\00E4iville')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111699592694399589)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'fi'
,p_message_text=>unistr('P\00E4iv\00E4n\00E4kym\00E4 aikatietoja sis\00E4lt\00E4ville tiedoille')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111744440925399622)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'fi'
,p_message_text=>unistr('P\00E4iv\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111738880330399618)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'fi'
,p_message_text=>'Kuvaus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111629437189399537)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'fi'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111629229141399537)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'fi'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111629170918399537)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'fi'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111629376430399537)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'fi'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111628892214399537)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'fi'
,p_message_text=>unistr('P\00E4\00E4ttymisp\00E4iv\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111629063656399537)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'fi'
,p_message_text=>'Tapahtuman nimi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111776744923399645)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'fi'
,p_message_text=>'Kutsu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111744562835399622)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'fi'
,p_message_text=>'Luettelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111744279082399622)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'fi'
,p_message_text=>'Kuukausi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111747083971399624)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'fi'
,p_message_text=>'Seuraava'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111761378591399634)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'fi'
,p_message_text=>'Ei tapahtumia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111777091297399646)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'fi'
,p_message_text=>'Muokkaa olemassa olevaa tapahtumaa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111776920680399646)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'fi'
,p_message_text=>unistr('Kutsu l\00E4hetet\00E4\00E4n s\00E4hk\00F6postiviestin\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111747151248399624)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'fi'
,p_message_text=>'Edellinen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111755167480399630)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'fi'
,p_message_text=>unistr('L\00E4het\00E4 s\00E4hk\00F6postiviesti')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111754988848399630)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'fi'
,p_message_text=>unistr('L\00E4het\00E4 s\00E4hk\00F6postiviesti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111777734356399646)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'fi'
,p_message_text=>unistr('Kaikki kent\00E4t ovat pakollisia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111777618167399646)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'fi'
,p_message_text=>unistr('L\00E4het\00E4 kutsu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111776546466399645)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'fi'
,p_message_text=>'Aihe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111755055690399630)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'fi'
,p_message_text=>'Vastaanottaja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111628938393399537)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'fi'
,p_message_text=>unistr('Alkamisp\00E4iv\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111752886162399628)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4ytt\00F6 kohteessa %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111699367969399589)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'fi'
,p_message_text=>'Aika'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111747245580399624)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4n\00E4\00E4n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111745077494399622)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4yt\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111744324326399622)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'fi'
,p_message_text=>'Viikko'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111699690237399590)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'fi'
,p_message_text=>unistr('Viikkon\00E4kym\00E4 kaikille p\00E4iville')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111699445251399589)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'fi'
,p_message_text=>unistr('Viikkon\00E4kym\00E4 aikatietoja sis\00E4lt\00E4ville tiedoille')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111744912915399622)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'fi'
,p_message_text=>'Vuosi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111744654349399622)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'fi'
,p_message_text=>'Sarakkeet...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111744782362399622)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'fi'
,p_message_text=>unistr('Lataa lis\00E4\00E4...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111676857845399573)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'fi'
,p_message_text=>'Edellinen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111623181157399533)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'fi'
,p_message_text=>unistr('Lataa lis\00E4\00E4...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111625274990399534)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'fi'
,p_message_text=>'Hae...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111744890969399622)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'fi'
,p_message_text=>unistr('Lataa lis\00E4\00E4...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111746927060399624)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'fi'
,p_message_text=>unistr('Alueen tunnistetta %0 ei l\00F6ydy.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111625108757399534)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'fi'
,p_message_text=>unistr('Tietoja ei l\00F6ydy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111649270709399552)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'fi'
,p_message_text=>'Alueen sivutuksen nollaus ei onnistu.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111617453230399529)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('Virhe m\00E4\00E4ritett\00E4ess\00E4 alueen sivutusta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111738289717399617)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'fi'
,p_message_text=>'Sarakkeet...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111746888665399624)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'fi'
,p_message_text=>unistr('Alueen tyyppi\00E4 %0 ei tueta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111617382954399529)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'fi'
,p_message_text=>'Virhe alueen #COMPONENT_NAME# muodostuksen aikana.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111681882567399577)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'fi'
,p_message_text=>'Kohteella #COLUMN_HEADER# on oltava jokin arvo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111776141864399645)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'fi'
,p_message_text=>'%0, rich text -editori'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111683934622399578)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'fi'
,p_message_text=>unistr('Rich Text HTML -koodi ylitt\00E4\00E4 kohteen enimm\00E4ispituuden (merkkim\00E4\00E4r\00E4: %0, sallittu merkkim\00E4\00E4r\00E4: %1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111743823059399621)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'fi'
,p_message_text=>'Poista'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111735634388399615)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'fi'
,p_message_text=>'Kopioi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111733949278399614)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4ytetyt sarakkeet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111733805022399614)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'fi'
,p_message_text=>unistr('J\00E4t\00E4 pois tyhj\00E4t arvot')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111743972629399621)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'fi'
,p_message_text=>unistr('Lis\00E4\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111697584207399588)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'fi'
,p_message_text=>unistr('Siirr\00E4 alas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111697691052399588)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'fi'
,p_message_text=>unistr('Siirr\00E4 yl\00F6s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111733692672399614)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'fi'
,p_message_text=>'Seuraava'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111734270735399614)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'fi'
,p_message_text=>'Muut sarakkeet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111733731767399614)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'fi'
,p_message_text=>'Edellinen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111734069839399614)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'fi'
,p_message_text=>'Rivi %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111734157683399614)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'fi'
,p_message_text=>'Rivi %0/%1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111735768031399615)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'fi'
,p_message_text=>unistr('P\00E4ivit\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111735814677399615)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'fi'
,p_message_text=>'Palauta muutokset'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111733519721399614)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'fi'
,p_message_text=>'Asetukset-valikko'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111694551778399586)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'fi'
,p_message_text=>'Esimerkki: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111602082263399517)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'fi'
,p_message_text=>'Kirjaudu uudelleen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111601987932399517)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'fi'
,p_message_text=>unistr('Istuntosi on p\00E4\00E4ttynyt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111602195619399517)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'fi'
,p_message_text=>unistr('Pidenn\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111601728448399517)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'fi'
,p_message_text=>unistr('Istuntosi p\00E4\00E4ttyy %0. Haluatko pident\00E4\00E4 sit\00E4?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111601835845399517)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'fi'
,p_message_text=>unistr('Istuntosi p\00E4\00E4ttyy klo %0, eik\00E4 sit\00E4 voi pident\00E4\00E4. Tallenna ty\00F6si nyt, jotta et menet\00E4 tietoja.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111754797879399630)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('Virhe k\00E4sitelt\00E4ess\00E4 tietokantaistunnon puhdistuskoodia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111647815345399551)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('Virhe k\00E4sitelt\00E4ess\00E4 tietokantaistunnon m\00E4\00E4rityskoodia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111621991534399532)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'fi'
,p_message_text=>unistr('Istuntosi on p\00E4\00E4ttynyt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111753661760399629)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'fi'
,p_message_text=>unistr('Sulje t\00E4m\00E4 valintaikkuna ja aloita uusi istunto napsauttamalla selaimen uudelleenlatauspainiketta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111772904416399643)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'fi'
,p_message_text=>unistr('Luo uusi istunto napsauttamalla <a href="%0">t\00E4t\00E4</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111659552478399560)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'fi'
,p_message_text=>'Istunto ei sallittu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111699017131399589)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'fi'
,p_message_text=>unistr('Dynaamisia rooleja ei voitu ottaa k\00E4ytt\00F6\00F6n Real Application Security -istunnon k\00E4ytt\00E4j\00E4lle %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111645756749399550)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('ERR-99900 Yksil\00F6iv\00E4\00E4 istunnon tunnistetta ei voitu luoda: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111662032772399562)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'fi'
,p_message_text=>unistr('Istunnon tilan suojausvirhe: Syyn\00E4 voi olla se, ett\00E4 suojattua sivun kohdetta 0% on muutettu manuaalisesti. Jos et ole varma, mist\00E4 virhe johtuu, ota yhteys sovelluksen j\00E4rjestelm\00E4nvalvojaan.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111781183767399649)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'fi'
,p_message_text=>unistr('Sivun suojausvirhe: Syyn\00E4 voi olla se, ett\00E4 l\00E4hetetyn sivun lataus ei ollut viel\00E4 valmis, tai se, ett\00E4 suojattuja sivun kohteita on muutettu manuaalisesti. Ota yhteys sovelluksen j\00E4rjestelm\00E4nvalvojaan.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111780145907399648)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 sis\00E4lt\00E4\00E4 jonkin seuraavista virheellisist\00E4 merkeist\00E4: &<>"/;,*|=% tai --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111780206507399648)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 sis\00E4lt\00E4\00E4 uuden rivin tai jonkin seuraavista virheellisist\00E4 merkeist\00E4: &<>"/;,*|=% tai --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111779965850399648)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 sis\00E4lt\00E4\00E4 erikoismerkkej\00E4. Vain merkit a - Z, 0 - 9 ja v\00E4lily\00F6nnit ovat sallittuja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111780002052399648)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 sis\00E4lt\00E4\00E4 virheellisen merkin <, > tai ".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111624195394399533)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'fi'
,p_message_text=>unistr('Tarkistussumma-arvo puuttuu. Se vaaditaan, jotta voidaan n\00E4ytt\00E4\00E4 sellaisen sivun k\00E4sittely, joka edellytt\00E4\00E4 tarkistussummaa, kun yksi tai useampi pyynn\00F6n, v\00E4limuistin tyhjennyksen tai argumentin arvo v\00E4litet\00E4\00E4n parametrina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111656905096399558)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'fi'
,p_message_text=>unistr('Istunnon tilan suojausvirhe: Syyn\00E4 voi olla se, ett\00E4 tarkistussumman sis\00E4lt\00E4v\00E4\00E4 Web-osoitetta on muutettu manuaalisesti, tai se, ett\00E4 on k\00E4ytetty linkki\00E4, jossa on virheellinen tai puuttuva tarkistussumma. Jos et ole varma, mist\00E4 virhe johtuu, ota yh')
||unistr('teys sovelluksen j\00E4rjestelm\00E4nvalvojaan.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111734902937399615)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'fi'
,p_message_text=>unistr('Poista suuren kontrastin tila k\00E4yt\00F6st\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111735035830399615)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'fi'
,p_message_text=>unistr('Ota suuren kontrastin tila k\00E4ytt\00F6\00F6n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111653609791399556)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'fi'
,p_message_text=>'Alin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111653841104399556)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'fi'
,p_message_text=>'Alas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111653995010399556)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'fi'
,p_message_text=>unistr('Siirr\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111654082758399556)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'fi'
,p_message_text=>unistr('Siirr\00E4 kaikki')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111654155626399556)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'fi'
,p_message_text=>'Poista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111654274365399556)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'fi'
,p_message_text=>'Poista kaikki'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111654362955399556)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'fi'
,p_message_text=>'Nollaa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111653584671399556)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'fi'
,p_message_text=>'Ylin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111653742682399556)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'fi'
,p_message_text=>unistr('Yl\00F6s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111762667810399635)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'fi'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111763310978399636)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 p\00E4iv\00E4n aikana')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111762542824399635)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'fi'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111763489075399636)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'fi'
,p_message_text=>'%0 tunnin aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111762329876399635)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'fi'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111763573046399636)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'fi'
,p_message_text=>'%0 min aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111762961162399636)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'fi'
,p_message_text=>'%0 kk'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111763120071399636)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'fi'
,p_message_text=>'%0 kk aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111762467014399635)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'fi'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111763240365399636)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'fi'
,p_message_text=>'%0 s aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111762799625399635)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'fi'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111763669730399636)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'fi'
,p_message_text=>'%0 viikon aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111762849297399636)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'fi'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111763047162399636)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'fi'
,p_message_text=>'%0 vuoden aikana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111602907622399518)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'fi'
,p_message_text=>'[Rivi]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111603349605399518)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'fi'
,p_message_text=>unistr('[Useita rivej\00E4]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111603147729399518)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'fi'
,p_message_text=>unistr('[Useita pisteit\00E4]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111603501172399518)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'fi'
,p_message_text=>'[Useita monikulmioita]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111603684959399518)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'fi'
,p_message_text=>'[Geometriaobjekti]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111602842242399518)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'fi'
,p_message_text=>'[Piste (%0,%1)]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111603002685399518)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'fi'
,p_message_text=>'[Monikulmio]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111680254087399575)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'fi'
,p_message_text=>unistr('Tiivist\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111680161764399575)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'fi'
,p_message_text=>'Palauta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111726647660399609)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'fi'
,p_message_text=>unistr('Tyhjenn\00E4 arvio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111716585024399602)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'fi'
,p_message_text=>'%0 ei ole sallitulla arviointialueella 1 - %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111716631504399602)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'fi'
,p_message_text=>'%0 ei ole numeerinen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111712702277399599)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'fi'
,p_message_text=>'Onnistumisviesti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111775829462399645)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'fi'
,p_message_text=>'Seuraava'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111775707601399645)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'fi'
,p_message_text=>'Edellinen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111761444825399635)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'fi'
,p_message_text=>unistr('Ty\00F6kalurivi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111776214004399645)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'fi'
,p_message_text=>unistr('Laajenna/tiivist\00E4 navigointi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111776326008399645)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'fi'
,p_message_text=>unistr('Laajenna/tiivist\00E4 sivusarake')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111685943517399580)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'fi'
,p_message_text=>unistr('P\00E4\00E4navigointi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111692984872399585)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'fi'
,p_message_text=>unistr('1 p\00E4iv\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111692744287399584)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'fi'
,p_message_text=>'1 tunti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111693034676399585)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 p\00E4iv\00E4\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111692875941399585)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'fi'
,p_message_text=>'%0 tuntia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111692686295399584)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'fi'
,p_message_text=>'%0 minuuttia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111693288763399585)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'fi'
,p_message_text=>'%0 viikkoa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111693101746399585)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'fi'
,p_message_text=>'1 viikko'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111779420895399647)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'fi'
,p_message_text=>'Sivun alku'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111641448306399546)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4yt\00F6ss\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111615246309399527)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('Virhe k\00E4sitelt\00E4ess\00E4 pyynt\00F6\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111694621054399586)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'fi'
,p_message_text=>'Pakollinen arvo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111777533981399646)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'fi'
,p_message_text=>unistr('Odota, kunnes sivu on latautunut kokonaan, ja yrit\00E4 sitten uudelleen.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111737707469399617)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4ll\00E4 sivulla on tallentamattomia muutoksia.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111618604660399529)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'fi'
,p_message_text=>unistr('Ty\00F6kirjassa ei ole aktiivista ty\00F6arkkia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111618510094399529)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'fi'
,p_message_text=>unistr('Ty\00F6kirjaa ei ole alustettu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111618497283399529)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('Sis\00E4inen virhe luotaessa XLSX-tiedostoa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111620914143399531)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'fi'
,p_message_text=>'Arkki'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111752618028399628)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'fi'
,p_message_text=>'Toiminnot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111670116546399568)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'fi'
,p_message_text=>'Toiminnot-valikko'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111665896436399565)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'fi'
,p_message_text=>unistr('Lis\00E4\00E4 funktio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111665720252399565)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'fi'
,p_message_text=>unistr('Lis\00E4\00E4 ryhmittelyn sarake')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111699967262399590)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'fi'
,p_message_text=>unistr('Lis\00E4\00E4 Pivot-sarake')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111700000027399590)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'fi'
,p_message_text=>unistr('Lis\00E4\00E4 rivin sarake')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111640221238399545)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'fi'
,p_message_text=>'Kooste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111676309869399572)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'fi'
,p_message_text=>'Kooste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111657419725399559)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'fi'
,p_message_text=>'Keskiarvo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111661725651399562)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'fi'
,p_message_text=>unistr('M\00E4\00E4r\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111657557281399559)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'fi'
,p_message_text=>'Maksimi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111657775283399559)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'fi'
,p_message_text=>'Mediaani'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111657660996399559)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'fi'
,p_message_text=>'Minimi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111657360005399559)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'fi'
,p_message_text=>'Summa %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111658416787399559)
,p_name=>'APEXIR_ALL'
,p_message_language=>'fi'
,p_message_text=>'Kaikki'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111639515548399545)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'fi'
,p_message_text=>'Kaikki sarakkeet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111622065712399532)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'fi'
,p_message_text=>'Kaikki rivit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111749679110399626)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'fi'
,p_message_text=>'Vaihtoehtoinen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111751208314399627)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'fi'
,p_message_text=>'Vaihtoehtoinen oletus: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111652127928399555)
,p_name=>'APEXIR_AND'
,p_message_language=>'fi'
,p_message_text=>'ja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111641686901399547)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4yt\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111635363796399542)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'fi'
,p_message_text=>'Nouseva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111654992523399557)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'fi'
,p_message_text=>'Tilanne %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111751848612399627)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'fi'
,p_message_text=>'Keskiarvo %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111743258302399621)
,p_name=>'APEXIR_BAR'
,p_message_language=>'fi'
,p_message_text=>unistr('Pylv\00E4s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111641079584399546)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'fi'
,p_message_text=>unistr('v\00E4lill\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111634119939399541)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'fi'
,p_message_text=>unistr('Taustav\00E4ri')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111636007542399542)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'fi'
,p_message_text=>'sininen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111667785171399566)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'fi'
,p_message_text=>'Alin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111636653101399543)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'fi'
,p_message_text=>'Peruuta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111642560686399547)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'fi'
,p_message_text=>'Luokka'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111634059379399541)
,p_name=>'APEXIR_CELL'
,p_message_language=>'fi'
,p_message_text=>'Solu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111658384257399559)
,p_name=>'APEXIR_CHART'
,p_message_language=>'fi'
,p_message_text=>'Kaavio'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111668637899399567)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'fi'
,p_message_text=>'Alustetaan...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111704992669399593)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'fi'
,p_message_text=>unistr('Kaavion nimi on m\00E4\00E4ritett\00E4v\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111717364431399602)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'fi'
,p_message_text=>unistr('Kysely ylitt\00E4\00E4 kaaviokohtaisen arvopisteiden maksimim\00E4\00E4r\00E4n %0. Pienenn\00E4 peruskyselyn tietuem\00E4\00E4r\00E4\00E4 k\00E4ytt\00E4m\00E4ll\00E4 suodatinta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111716210877399601)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Kaaviokyselyn rivien maksimim\00E4\00E4r\00E4 rajoittaa peruskyselyn rivien m\00E4\00E4r\00E4\00E4 mutta ei n\00E4ytett\00E4vien rivien m\00E4\00E4r\00E4\00E4.  '),
unistr('Peruskyselyss\00E4 on maksimim\00E4\00E4r\00E4\00E4 %0 enemm\00E4n rivej\00E4. V\00E4henn\00E4 peruskyselyll\00E4 saatavien tietueiden m\00E4\00E4r\00E4\00E4 k\00E4ytt\00E4m\00E4ll\00E4 suodatinta.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111639636774399545)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'fi'
,p_message_text=>'Kaaviotyyppi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111712942062399599)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'fi'
,p_message_text=>'Valitse kaikki'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111655309349399557)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'fi'
,p_message_text=>'Valitse raporttimuoto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111662799390399562)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'fi'
,p_message_text=>unistr('tyhjenn\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111636581308399543)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'fi'
,p_message_text=>'Sarake'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111673957662399571)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'fi'
,p_message_text=>'Sarakkeet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111746217679399623)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'fi'
,p_message_text=>'Suodata...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111664737028399564)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'fi'
,p_message_text=>'Sarakeotsikon valikko'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111668481669399567)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'fi'
,p_message_text=>'Sarakkeen tiedot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111748511805399625)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'fi'
,p_message_text=>'Sarakeotsikko'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111666165800399565)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'fi'
,p_message_text=>'Sarake %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111650200442399553)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'fi'
,p_message_text=>unistr('sis\00E4lt\00E4\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111651191757399554)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'fi'
,p_message_text=>unistr('ei sis\00E4ll\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111635064673399541)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'fi'
,p_message_text=>unistr('sis\00E4ltyy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111651381670399554)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'fi'
,p_message_text=>unistr('ei ole edellisell\00E4 aikav\00E4lill\00E4:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111659809332399560)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'fi'
,p_message_text=>unistr('ei ole seuraavalla aikav\00E4lill\00E4:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111651246383399554)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'fi'
,p_message_text=>unistr('on edellisell\00E4 aikav\00E4lill\00E4:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111659704275399560)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'fi'
,p_message_text=>unistr('on seuraavalla aikav\00E4lill\00E4:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111634938895399541)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'fi'
,p_message_text=>unistr('ei ole tyhj\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111634813363399541)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'fi'
,p_message_text=>unistr('on tyhj\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111634689080399541)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'fi'
,p_message_text=>'kuin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111635101207399542)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'fi'
,p_message_text=>unistr('ei sis\00E4lly')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111634726162399541)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'fi'
,p_message_text=>'ei kuin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111650594871399553)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'fi'
,p_message_text=>unistr('vastaa s\00E4\00E4nn\00F6llist\00E4 lauseketta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111655227067399557)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'fi'
,p_message_text=>'Laskenta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111715960132399601)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'fi'
,p_message_text=>'Laskentalauseke'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111674210170399571)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'fi'
,p_message_text=>'Luo laskenta sarakkeen aliasten pohjalta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111674388975399571)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'fi'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111674433577399571)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'fi'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111674543244399571)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'fi'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111620489297399531)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'fi'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111659187313399560)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'fi'
,p_message_text=>'Laske'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111666770165399565)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'fi'
,p_message_text=>unistr('Ryhm\00E4katko')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111669745882399568)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'fi'
,p_message_text=>unistr('Ryhm\00E4katkot')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111754181045399629)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'fi'
,p_message_text=>unistr('Ryhm\00E4katkon sarakkeet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111617534212399529)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'fi'
,p_message_text=>'Laske erilliset'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111752310768399628)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'fi'
,p_message_text=>'Laske erilliset'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111752241633399628)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'fi'
,p_message_text=>unistr('M\00E4\00E4r\00E4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111724331036399607)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'fi'
,p_message_text=>unistr('P\00E4ivitt\00E4inen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111779020670399647)
,p_name=>'APEXIR_DATA'
,p_message_language=>'fi'
,p_message_text=>'Tiedot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111668546373399567)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'fi'
,p_message_text=>'Raportin tiedot %0 minuuttia sitten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111742073790399620)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'fi'
,p_message_text=>'Tietoruudukon ohje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111640340882399545)
,p_name=>'APEXIR_DATE'
,p_message_language=>'fi'
,p_message_text=>unistr('P\00E4iv\00E4m\00E4\00E4r\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111672428218399570)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'fi'
,p_message_text=>'Oletus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111749431115399626)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'fi'
,p_message_text=>'Oletusraporttityyppi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111636707755399543)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'fi'
,p_message_text=>'Poista'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111640658784399546)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'fi'
,p_message_text=>unistr('Haluatko poistaa n\00E4m\00E4 raporttiasetukset?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111735377008399615)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'fi'
,p_message_text=>'Poista oletusraportti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111666493987399565)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'fi'
,p_message_text=>'Poista raportti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111635449361399542)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'fi'
,p_message_text=>'Laskeva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111642633797399547)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'fi'
,p_message_text=>'Kuvaus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111664692567399564)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'fi'
,p_message_text=>unistr('Yhden rivin n\00E4kym\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111672956698399570)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'fi'
,p_message_text=>'Suunta %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111673839829399571)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'fi'
,p_message_text=>unistr('Ei k\00E4yt\00F6ss\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111636255750399542)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4ytetty')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111639402849399545)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4ytetyt sarakkeet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111672865280399570)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4yt\00E4 raportissa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111667648705399566)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'fi'
,p_message_text=>'Alas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111659290594399560)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'fi'
,p_message_text=>'Nouda'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111672758257399570)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'fi'
,p_message_text=>unistr('\00C4l\00E4 n\00E4yt\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111738702245399618)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'fi'
,p_message_text=>'Korostus, jolla on sama ehto, on jo olemassa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111754322235399629)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'fi'
,p_message_text=>unistr('Pivot-sarakkeen kaksoiskappale. Pivot-sarakkeen luettelon on oltava yksil\00F6iv\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111754511589399629)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'fi'
,p_message_text=>'Muokkaa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111668706566399567)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'fi'
,p_message_text=>'Muokkaa kaavion asetuksia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111675301542399572)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'fi'
,p_message_text=>'Muokkaa kaaviota'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111675729241399572)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'fi'
,p_message_text=>'Muokkaa suodatinta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111730161435399611)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'fi'
,p_message_text=>unistr('Ryhm\00E4n muokkausperuste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111675662934399572)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'fi'
,p_message_text=>'Muokkaa korostusta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111700254285399590)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'fi'
,p_message_text=>'Muokkaa Pivot-taulukkoa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111749799801399626)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'fi'
,p_message_text=>unistr('S\00E4hk\00F6posti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111628422870399537)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'fi'
,p_message_text=>unistr('S\00E4hk\00F6postiosoite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111750036237399626)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'fi'
,p_message_text=>'Piilokopio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111750258160399626)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'fi'
,p_message_text=>'Teksti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111749945477399626)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'fi'
,p_message_text=>'Kopio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111750765555399627)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'fi'
,p_message_text=>unistr('Toistov\00E4li')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111632127504399539)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4lle sovellukselle ei ole m\00E4\00E4ritetty s\00E4hk\00F6postia. Ota yhteys j\00E4rjestelm\00E4nvalvojaan.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111723685372399607)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'fi'
,p_message_text=>unistr('S\00E4hk\00F6postiosoite on annettava.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111750386147399626)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'fi'
,p_message_text=>'Katso liite'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111750188010399626)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'fi'
,p_message_text=>'Aihe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111724633828399607)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'fi'
,p_message_text=>unistr('S\00E4hk\00F6postiviestille on annettava aihe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111749812741399626)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'fi'
,p_message_text=>'Vastaanottaja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111633836472399541)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4yt\00F6ss\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111675547393399572)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'fi'
,p_message_text=>unistr('Ota k\00E4ytt\00F6\00F6n/poista k\00E4yt\00F6st\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111675028311399572)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'fi'
,p_message_text=>'Virhe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111674641623399571)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'fi'
,p_message_text=>unistr('Esimerkkej\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111675419837399572)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'fi'
,p_message_text=>unistr('Esimerkkej\00E4:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111639317952399545)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'fi'
,p_message_text=>unistr('J\00E4t\00E4 pois tyhj\00E4t arvot')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111676047878399572)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'fi'
,p_message_text=>unistr('Laajenna/tiivist\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111673642969399571)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'fi'
,p_message_text=>'Lauseke'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111658711148399560)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'fi'
,p_message_text=>'Suodatin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111669600467399568)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'fi'
,p_message_text=>'Suodattimet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111679969889399575)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'fi'
,p_message_text=>'Suodattimen lauseke'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111776403818399645)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'fi'
,p_message_text=>unistr('Suodatinlauseke on liian pitk\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111679868915399575)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'fi'
,p_message_text=>'Suodatintyyppi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111676254310399572)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'fi'
,p_message_text=>unistr('Valitse etsitt\00E4v\00E4t sarakkeet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111659095468399560)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'fi'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111673431649399570)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'fi'
,p_message_text=>unistr('Flashback-kyselyll\00E4 voit tarkastella tietoja sellaisina kuin ne olivat aiempana ajankohtana.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111724067846399607)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'fi'
,p_message_text=>'Flashback-kesto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111725447521399608)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'fi'
,p_message_text=>'Muotoilu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111655191931399557)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'fi'
,p_message_text=>'Muotomaski %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111666372842399565)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'fi'
,p_message_text=>'Funktio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111674193428399571)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'fi'
,p_message_text=>'Funktiot %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111749308083399626)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'fi'
,p_message_text=>'Funktiot/operaattorit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111666038765399565)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'fi'
,p_message_text=>'Funktio %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111658574912399559)
,p_name=>'APEXIR_GO'
,p_message_language=>'fi'
,p_message_text=>'Suorita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111634381328399541)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'fi'
,p_message_text=>unistr('vihre\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111617675376399529)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'fi'
,p_message_text=>'Ryhmittely'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111750493454399626)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'fi'
,p_message_text=>'Ryhmittelyn sarake %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111705062310399593)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'fi'
,p_message_text=>unistr('Ryhmittelyn sarake on m\00E4\00E4ritett\00E4v\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111716104067399601)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'fi'
,p_message_text=>unistr('Ryhmittelykyselyn rivien maksimim\00E4\00E4r\00E4 rajoittaa peruskyselyn rivien m\00E4\00E4r\00E4\00E4 mutta ei n\00E4ytett\00E4vien rivien m\00E4\00E4r\00E4\00E4. Peruskyselyss\00E4 on maksimim\00E4\00E4r\00E4\00E4 %0 enemm\00E4n rivej\00E4. V\00E4henn\00E4 peruskyselyll\00E4 saatavien tietueiden m\00E4\00E4r\00E4\00E4 k\00E4ytt\00E4m\00E4ll\00E4 suodatinta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111696783442399587)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'fi'
,p_message_text=>'Ryhmittelyn lajittelu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111754263417399629)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'fi'
,p_message_text=>unistr('Ryhmittelyn lajitteluj\00E4rjestys')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111639701999399545)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'fi'
,p_message_text=>unistr('Vaakasuora pylv\00E4s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111671364985399569)
,p_name=>'APEXIR_HELP'
,p_message_language=>'fi'
,p_message_text=>'Ohje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111663169637399563)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Interaktiivisten raporttien avulla loppuk\00E4ytt\00E4j\00E4t voivat mukauttaa raportteja. K\00E4ytt\00E4j\00E4t voivat muuttaa raportin tietojen asettelua valitsemalla sarakkeita, k\00E4ytt\00E4m\00E4ll\00E4 suodattimia sek\00E4 korostamalla ja lajittelemalla. Lis\00E4ksi k\00E4ytt\00E4j\00E4t voivat m\00E4\00E4ritt')
||unistr('\00E4\00E4 katkoja, koosteita, kaavioita, ryhmittelyj\00E4 ja lis\00E4\00E4 omia laskentojaan. K\00E4ytt\00E4j\00E4t voivat my\00F6s m\00E4\00E4ritt\00E4\00E4 itselleen tilauksen, jolloin raportti l\00E4hetet\00E4\00E4n heille s\00E4hk\00F6postitse HTML-muodossa tietyin v\00E4liajoin. K\00E4ytt\00E4j\00E4t voivat luoda raporteista useit')
||unistr('a versioita ja tallentaa ne nimettyin\00E4 raportteina joko julkiseen tai yksityiseen k\00E4ytt\00F6\00F6n. '),
'<p/>',
unistr('Seuraavissa osioissa on yhteenveto interaktiivisen raportin mukautusmahdollisuuksista. Lis\00E4tietoja on <i>Oracle Application Express End User''s Guide</i> -oppaan kohdassa "Using Interactive Reports"</a>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111670218336399568)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'fi'
,p_message_text=>unistr('Toiminnot-valikko n\00E4kyy hakupalkissa Suorita-painikkeen oikealla puolella. T\00E4m\00E4n valikon vaihtoehdoilla voit mukauttaa interaktiivisia raportteja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111663941490399563)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Koosteet ovat sarakkeessa teht\00E4vi\00E4 matemaattisia laskelmia. Koosteet n\00E4kyv\00E4t jokaisen ryhm\00E4katkon j\00E4lkeen ja aina raportin lopussa siin\00E4 sarakkeessa, johon ne on m\00E4\00E4ritetty. K\00E4ytett\00E4viss\00E4 on seuraavat vaihtoehdot:'),
'<p>',
'</p><ul>',
unistr('<li><strong>Kooste</strong> mahdollistaa aiemmin m\00E4\00E4ritetyn koosteen'),
'valinnan ja muokkauksen.</li>',
'<li><strong>Funktio</strong> on suoritettava funktio (esimerkiksi SUM, MIN).</li>',
'<li><strong>Sarake</strong> valitsee sarakkeen, jossa matemaattinen funktio suoritetaan. Vain',
unistr('numeromuotoiset sarakkeet n\00E4kyv\00E4t.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111664061676399563)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Voit m\00E4\00E4ritt\00E4\00E4 jokaiseen tallennettuun raporttiin yhden kaavion. Kun'),
unistr('kaavio on m\00E4\00E4ritetty, voit siirty\00E4 kaavio- ja raporttin\00E4kymien v\00E4lill\00E4 hakupalkin n\00E4kym\00E4kuvakkeiden avulla.'),
unistr('K\00E4ytett\00E4viss\00E4 ovat seuraavat vaihtoehdot:  '),
'<p>',
'</p><ul>',
unistr('<li><strong>Kaaviotyyppi</strong> m\00E4\00E4ritt\00E4\00E4 sis\00E4llytett\00E4v\00E4n kaaviotyypin.'),
unistr('Valitse joko vaakasuora pylv\00E4s, pystysuora pylv\00E4s, ympyr\00E4 tai viiva.</li>'),
unistr('<li><strong>Nimi</strong>-asetuksella valitaan nimen\00E4 k\00E4ytett\00E4v\00E4 sarake.</li>'),
unistr('<li><strong>Nimen akselin otsikko</strong> on otsikko, joka n\00E4kyy Nimi-asetukseksi'),
unistr('valitun sarakkeen akselilla. T\00E4m\00E4 vaihtoehto ei ole k\00E4ytett\00E4viss\00E4 ympyr\00E4kaavioissa.</li>'),
unistr('<li><strong>Arvo</strong>-asetuksella valitaan arvona k\00E4ytett\00E4v\00E4 sarake. Jos k\00E4ytt\00E4m\00E4si funktio'),
unistr('on COUNT-tyyppi\00E4, Arvo-asetusta ei tarvitse valita.</li>'),
unistr('<li><strong>Arvon akselin otsikko</strong> on otsikko, joka n\00E4kyy Arvo-asetukseksi valitun'),
unistr('sarakkeen akselilla. T\00E4m\00E4 vaihtoehto ei ole k\00E4ytett\00E4viss\00E4 ympyr\00E4kaavioissa.</li>'),
'<li><strong>Funktio</strong> on valinnainen funktio, joka suoritetaan Arvo-asetukseksi valitulle sarakkeelle.</li>',
'<li><strong>Lajittelu</strong> lajittelee valmiin tulosjoukon.</li></ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111663386707399563)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Sarakeotsikon valikko avataan napsauttamalla mit\00E4 tahansa sarakeotsikkoa. Se sis\00E4lt\00E4\00E4 esimerkiksi seuraavat vaihtoehdot:'),
'<p></p>',
'<ul>',
unistr('<li><strong>Nouseva j\00E4rjestys</strong> -kuvake lajittelee raportin ko. sarakkeen mukaan nousevassa j\00E4rjestyksess\00E4.</li>'),
unistr('<li><strong>Laskeva j\00E4rjestys</strong> -kuvake lajittelee raportin ko. sarakkeen mukaan laskevassa j\00E4rjestyksess\00E4.</li>'),
unistr('<li><strong>Piilota sarake</strong> piilottaa sarakkeen. Kaikkia sarakkeita ei voi piilottaa. Jos saraketta ei voi piilottaa, Piilota sarake -kuvake ei n\00E4y.</li>'),
unistr('<li><strong>Sarakekatko</strong> luo sarakkeeseen katkosryhm\00E4n. T\00E4ll\00F6in sarake katsotaan p\00E4\00E4tietueeksi, ja se j\00E4\00E4 pois raportista.</li>'),
unistr('<li><strong>Sarakkeen tiedot</strong> n\00E4ytt\00E4\00E4 saraketta koskevan mahdollisen ohjetekstin.</li>'),
unistr('<li><strong>Tekstialue</strong> on tarkoitettu hakuehtojen sy\00F6tt\00E4miseen (kirjainkoko ei ole merkitsev\00E4).'),
unistr('Yleismerkkej\00E4 ei tarvita. Arvon sy\00F6tt\00E4minen rajaa valikon'),
unistr('alareunassa n\00E4kyv\00E4\00E4 arvoluetteloa. T\00E4m\00E4n j\00E4lkeen voit valita arvon, josta luodaan suodatin lis\00E4\00E4m\00E4ll\00E4 siihen =-merkki'),
unistr('(esimerkiksi <code>column = ''ABC''</code>). Vaihtoehtoisesti voit napsauttaa taskulamppukuvaketta ja sy\00F6tt\00E4\00E4 suodattimena k\00E4ytett\00E4v\00E4n arvon LIKE-tekij\00E4n kanssa'),
'(esimerkiksi <code>column LIKE ''%ABC%''</code>).</li>',
unistr('<li><b>Yksil\00F6ivien arvojen luettelo</b> sis\00E4lt\00E4\00E4 ensimm\00E4iset 500 yksil\00F6iv\00E4\00E4'),
unistr('arvoa, jotka vastaavat antamiasi suodatusehtoja. Jos kyseess\00E4 on p\00E4iv\00E4m\00E4\00E4r\00E4sarake, t\00E4ss\00E4 n\00E4ytet\00E4\00E4n luettelo'),
unistr('p\00E4iv\00E4m\00E4\00E4r\00E4alueista. Valitsemastasi arvosta luodaan suodatin lis\00E4\00E4m\00E4ll\00E4 siihen =-merkki (esimerkiksi <code>column = ''ABC''</code>).</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111663836983399563)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('T\00E4ss\00E4 voit lis\00E4t\00E4 raporttiin laskettuja sarakkeita. K\00E4ytett\00E4viss\00E4 ovat sek\00E4 matemaattiset laskennat (esimerkiksi <code>NBR_HOURS/24</code>) ett\00E4 vakiomuotoiset Oracle-funktiot,'),
unistr('joita k\00E4ytet\00E4\00E4n olemassa olevissa sarakkeissa. Osa on esitetty esimerkkein\00E4, mutta my\00F6s muita (kuten <code>TO_DATE</code>) voi k\00E4ytt\00E4\00E4. K\00E4ytett\00E4viss\00E4 ovat mm. seuraavat vaihtoehdot:'),
'<p></p>',
'<ul>',
unistr('<li><strong>Laskenta</strong> mahdollistaa aiemmin m\00E4\00E4ritettyjen laskentojen valinnan ja muokkauksen.</li>'),
'<li><strong>Sarakeotsikko</strong> on uuden sarakkeen sarakeotsikko.</li>',
'<li><strong>Muotomaski</strong> on sarakkeeseen sovellettava Oracle-muotomaski (esimerkiksi S9999).</li>',
unistr('<li><strong>Laskenta</strong> on suoritettava laskenta. Sarakkeisiin viitataan laskennassa niiden n\00E4ytett\00E4vill\00E4 aliaksilla.</li>'),
'</ul>',
unistr('<p>Laskennan alapuolella n\00E4ytet\00E4\00E4n laatimasi kyselyn sarakkeet'),
unistr('ja niihin liittyv\00E4t aliakset. Sarakkeet lis\00E4t\00E4\00E4n laskentaan napsauttamalla niiden'),
unistr('nimi\00E4 tai aliaksia. Sarakkeiden vieress\00E4 on n\00E4pp\00E4imist\00F6. N\00E4pp\00E4imist\00F6\00E4 voi k\00E4ytt\00E4\00E4 yleisten'),
unistr('n\00E4pp\00E4inten pikavalintaan. Funktiot n\00E4kyv\00E4t n\00E4yt\00F6n oikeassa reunassa.</p>'),
unistr('<p>Seuraavassa esimerkkilaskelmassa selvitet\00E4\00E4n kokonaispalkka:</p>'),
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
'(jossa A on ORGANISAATIO, B on PALKKA ja C on PROVISIO)</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111670346751399568)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4t\00E4 k\00E4ytet\00E4\00E4n katkoryhm\00E4n luomiseen yhteen tai useampaan sarakkeeseen. N\00E4it\00E4 sarakkeita ei en\00E4\00E4 sis\00E4llytet\00E4 interaktiiviseen raporttiin, vaan ne n\00E4ytet\00E4\00E4n p\00E4\00E4tietueena.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111664548412399564)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'fi'
,p_message_text=>unistr('Jos haluat tarkastella tietoja yksi rivi kerrallaan, napsauta yhden rivin n\00E4kym\00E4n kuvaketta rivill\00E4, jota haluat tarkastella. Mik\00E4li mahdollista, yhden rivin n\00E4kym\00E4 on aina ensimm\00E4isess\00E4 sarakkeessa. Interaktiivisen raportin mukautuksesta riippuen yh')
||unistr('den rivin n\00E4kym\00E4 voi olla vakion\00E4kym\00E4 tai p\00E4ivitykset mahdollistava mukautettu sivu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111664465935399564)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Mahdollistaa nykyisen tulosjoukon noudon.',
unistr('K\00E4ytett\00E4viss\00E4 on asennuksesta ja raportin m\00E4\00E4ritelm\00E4st\00E4 riippuen'),
unistr('erilaisia noutomuotoja, kuten CSV, HTML, s\00E4hk\00F6postiviesti, XLS, PDF tai RTF.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111663518913399563)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Rajaa raporttia lis\00E4\00E4m\00E4ll\00E4 tai muokkaamalla kyselyn<code>WHERE</code>-lausetta. Voit k\00E4ytt\00E4\00E4 suodattimena saraketta tai rivi\00E4.  '),
unistr('<p>Jos haluat k\00E4ytt\00E4\00E4 suodattimena saraketta, valitse ensin sopiva sarake (joka voi olla'),
unistr('piilotettu sarake), valitse sitten vakiomuotoinen Oracle-operaattori (=, !=, ei sis\00E4lly, v\00E4lill\00E4) ja anna vertailuun k\00E4ytett\00E4v\00E4 lauseke. Lausekkeissa kirjainkoko on merkitsev\00E4. Yleismerkkin\00E4 toimii % (esimerkiksi <code>STATE_NAME'),
'kuin A%)</code>.</p>',
unistr('<p>Jos haluat k\00E4ytt\00E4\00E4 suodattimena rivi\00E4, voit luoda monimutkaisia <code>WHERE</code>-lauseita k\00E4ytt\00E4m\00E4ll\00E4'),
unistr('sarakkeiden aliaksia ja mit\00E4 tahansa Oracle-funktioita tai -operaattoreita (esimerkiksi <code>G = ''VA'' tai G = ''CT''</code>, jossa'),
'<code>G</code> on alias sarakkeelle <code>CUSTOMER_STATE</code>).</p>',
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111664120355399564)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Flashback-kyselyll\00E4 voit tarkastella tietoja siin\00E4 muodossa kuin ne olivat aiempana'),
'ajankohtana. Flashback-toiminnon oletusarvoinen aika-asetus on 3 tuntia (eli 180 minuuttia)',
unistr('taaksep\00E4in, mutta todellinen arvo vaihtelee tietokannan mukaan.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111725330326399608)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Muotoilu-kohdassa voit mukauttaa raportin esitystapaa.',
unistr('Muotoilu sis\00E4lt\00E4\00E4 seuraavat alivalikot:</p>'),
'<ul><li>Lajittelu</li>',
unistr('<li>Ryhm\00E4katko</li>'),
'<li>Korostus</li>',
'<li>Laskenta</li>',
'<li>Kooste</li>',
'<li>Kaavio</li>',
'<li>Ryhmittely</li>',
'<li>Pivot</li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111723539325399607)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Voit m\00E4\00E4ritt\00E4\00E4 jokaiseen tallennettuun raporttiin yhden ryhmittelyn\00E4kym\00E4n. Kun n\00E4kym\00E4 on m\00E4\00E4ritetty, voit siirty\00E4 ryhmittely- ja raporttin\00E4kym\00E4n v\00E4lill\00E4 hakupalkin kuvakkeiden avulla. Luo ryhmittelyn\00E4kym\00E4 valitsemalla '),
'<p></p>',
'<ul>',
unistr('<li>ryhmittelyn perusteena k\00E4ytett\00E4v\00E4t sarakkeet</li>'),
unistr('<li>koosteeseen k\00E4ytett\00E4v\00E4t sarakkeet sek\00E4 suoritettava funktio (keskiarvo, summa, laskenta jne.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111663704422399563)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>T\00E4ss\00E4 voit m\00E4\00E4ritt\00E4\00E4 suodattimen. Suodatinehtoja vastaavat rivit n\00E4kyv\00E4t korostettuina suodattimeen liittyv\00E4n ominaisuuden mukaan. Mahdollisia vaihtoehtoja ovat:</p>'),
'<ul>',
unistr('<li><strong>Nimi</strong>: vain n\00E4ytt\00E4mist\00E4 varten.</li>'),
unistr('<li><strong>J\00E4rjestys</strong>: m\00E4\00E4ritt\00E4\00E4 s\00E4\00E4nt\00F6jen arviointij\00E4rjestyksen.</li>'),
unistr('<li><strong>K\00E4yt\00F6ss\00E4</strong>: m\00E4\00E4ritt\00E4\00E4, onko s\00E4\00E4nt\00F6 k\00E4yt\00F6ss\00E4 vai ei.</li>'),
unistr('<li><strong>Korostustyyppi</strong>: m\00E4\00E4ritt\00E4\00E4, korostetaanko rivi vai solu.'),
'Jos valinta on Solu, Korostusehto-asetuksen',
'mukainen sarake korostetaan.</li>',
unistr('<li><strong>Taustav\00E4ri</strong>:korostetun alueen uusi taustav\00E4ri.</li>'),
unistr('<li><strong>Tekstin v\00E4ri</strong>: korostetun alueen tekstin uusi v\00E4ri.</li>'),
unistr('<li><strong>Korostusehto</strong>: m\00E4\00E4ritt\00E4\00E4 suodatinehdon.</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111601310717399517)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Voit m\00E4\00E4ritt\00E4\00E4 jokaiseen tallennettuun raporttiin yhden Pivot-n\00E4kym\00E4n. Kun n\00E4kym\00E4 on m\00E4\00E4ritetty, voit siirty\00E4 Pivot- ja raporttin\00E4kym\00E4n v\00E4lill\00E4 hakupalkin kuvakkeiden avulla. Luo Pivot-n\00E4kym\00E4 valitsemalla ensin '),
'<p></p>',
'<ul>',
unistr('<li>k\00E4\00E4nt\00E4misen tukipisteen\00E4 k\00E4ytett\00E4v\00E4t sarakkeet</li>'),
unistr('<li>rivein\00E4 n\00E4ytett\00E4v\00E4t sarakkeet</li>'),
unistr('<li>koosteeseen sis\00E4llytett\00E4v\00E4t sarakkeet sek\00E4 suoritettava funktio (keskiarvo, summa, laskenta jne.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111674846172399571)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Kun mukautat interaktiivista raporttia, raportin asetukset',
unistr('n\00E4kyv\00E4t hakupalkin alapuolella ja raportin yl\00E4puolella. T\00E4m\00E4n alueen voi tiivist\00E4\00E4 tai laajentaa n\00E4yt\00F6n vasemmassa reunassa olevalla kuvakkeella.'),
'<p>',
unistr('Kunkin raportin asetuksen kohdalla voit tehd\00E4 seuraavaa:'),
'</p><ul>',
unistr('<li>Voit muokata asetusta napsauttamalla sen nime\00E4.</li>'),
unistr('<li>Voit ottaa asetuksen k\00E4ytt\00F6\00F6n tai pois k\00E4yt\00F6st\00E4 valitsemalla Ei k\00E4yt\00F6ss\00E4-/K\00E4yt\00F6ss\00E4-valintaruudun tai poistamalla valinnan. T\00E4ll\00E4 tavoin voit tilap\00E4isesti ottaa asetuksen k\00E4ytt\00F6\00F6n tai pois k\00E4yt\00F6st\00E4.</li>'),
'<li>Voit poistaa asetuksen napsauttamalla Poista-kuvaketta.</li>',
'</ul>',
'<p>Jos olet luonut kaavion, ryhmittelyn tai pivot-taulukon,',
unistr('voit siirty\00E4 niiden ja perusraportin v\00E4lill\00E4 n\00E4yt\00F6n oikeassa reunassa olevien Raporttin\00E4kym\00E4n, Kaavion\00E4kym\00E4n, Ryhmittelyn\00E4kym\00E4n ja'),
unistr('Pivot-n\00E4kym\00E4n linkkien avulla. Kun tarkastelet kaaviota, ryhmittely\00E4 tai pivot-taulukkoa, voit my\00F6s muokata asetuksia'),
unistr('napsauttamalla Muokkaa-linkki\00E4.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111664317263399564)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'fi'
,p_message_text=>'Palauttaa raportin asetukset oletusasetuksiin ja poistaa kaikki siihen mahdollisesti tehdyt mukautukset.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111725693249399608)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'fi'
,p_message_text=>unistr('M\00E4\00E4ritt\00E4\00E4 yhdell\00E4 sivulla n\00E4ytett\00E4vien tietueiden m\00E4\00E4r\00E4n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111664248443399564)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Tallentaa mukautetun raportin my\00F6hemp\00E4\00E4 k\00E4ytt\00F6\00E4 varten. Voit antaa raportille nimen ja valinnaisen kuvauksen ja julkaista sen yleisesti saataville (jolloin kaikki k\00E4ytt\00E4j\00E4t, joilla on k\00E4ytt\00F6oikeudet ensisijaiseen oletusraporttiin, voivat tarkastel')
||unistr('la sit\00E4). Tallennettavia interaktiivisia raporttityyppej\00E4 on nelj\00E4:</p>'),
'<ul>',
unistr('<li><strong>Ensisijainen oletus</strong> (vain kehitt\00E4jille). Ensisijainen oletus on aina ensimm\00E4isen\00E4 tarjottava oletusraportti. Ensisijaisia oletusraportteja ei voi poistaa tai nimet\00E4 uudelleen.</li>'),
unistr('<li><strong>Vaihtoehtoinen raportti</strong> (vain kehitt\00E4jille). T\00E4m\00E4n raporttityypin avulla kehitt\00E4j\00E4t voivat luoda erilaisia raporttiasetteluita. Vain kehitt\00E4j\00E4t voivat tallentaa, poistaa tai nimet\00E4 uudelleen vaihtoehtoisia raportteja.</li>'),
unistr('<li><strong>Julkinen raportti</strong> (loppuk\00E4ytt\00E4j\00E4). T\00E4m\00E4n raportin luonut loppuk\00E4ytt\00E4j\00E4 voi tallentaa, poistaa tai nimet\00E4 sen uudelleen. Muut k\00E4ytt\00E4j\00E4t voivat tarkastella raporttia ja tallentaa sen asettelun uutena raporttina.</li>'),
unistr('<li><strong>Yksityinen raportti</strong> (loppuk\00E4ytt\00E4j\00E4). Vain t\00E4m\00E4n raportin luonut loppuk\00E4ytt\00E4j\00E4 voi tallentaa, poistaa tai nimet\00E4 sen uudelleen.</li>'),
'</ul>',
unistr('<p>Jos tallennat mukautettuja raportteja, hakupalkissa n\00E4kyy rivivalitsimen vasemmalla puolella raporttivalitsin (mik\00E4li t\00E4m\00E4 toiminto on k\00E4yt\00F6ss\00E4).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111663236520399563)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'fi'
,p_message_text=>unistr('Raportin jokaisen sivun yl\00E4osassa on hakualue. T\00E4ll\00E4 alueella (hakupalkissa) on seuraavat toiminnot:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111726250297399609)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'fi'
,p_message_text=>unistr('<li><strong>Toiminnot-valikossa</strong> voit mukauttaa raporttia. Lis\00E4tietoja on j\00E4ljemp\00E4n\00E4.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111725712272399608)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'fi'
,p_message_text=>'<li><strong>Sarakkeiden valintakuvakkeella</strong> voit valita sarakkeet, joihin haku kohdistuu (tai valita kaikki sarakkeet).</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111726096388399608)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'fi'
,p_message_text=>unistr('<li><strong>Raportit</strong> n\00E4ytt\00E4\00E4 vaihtoehtoiset oletusraportit sek\00E4 tallennetut yksityiset tai julkiset raportit.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111725989292399608)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'fi'
,p_message_text=>unistr('<li><strong>Rivit</strong> m\00E4\00E4ritt\00E4\00E4 yhdell\00E4 sivulla n\00E4ytett\00E4vien tietueiden m\00E4\00E4r\00E4n.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111725817504399608)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li><strong>Tekstialueelle</strong> voit sy\00F6tt\00E4\00E4 hakuehtoja (kirjainkoko ei ole merkitsev\00E4). Yleismerkit ovat oletusarvoisesti k\00E4yt\00F6ss\00E4.</li>'),
unistr('<li><strong>Suorita-painike</strong> k\00E4ynnist\00E4\00E4 haun. Haun voi k\00E4ynnist\00E4\00E4 my\00F6s painamalla Enter-n\00E4pp\00E4int\00E4, kun kohdistin on haun tekstialueella.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111726170647399608)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'fi'
,p_message_text=>unistr('<li><strong>N\00E4kym\00E4kuvakkeilla</strong> voit siirty\00E4 raportin raportti-, tieto-, kaavio-, ryhmittely- ja pivot-n\00E4kymien v\00E4lill\00E4, mik\00E4li ne on m\00E4\00E4ritetty.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111742147102399620)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'fi'
,p_message_text=>unistr('<li><strong>Hallinta</strong>-valikossa voit hallita ominaisuuksia, sarakkeita ja rivej\00E4 sek\00E4 tarkastella raportin tai tietoruudukon historiaa.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111663448194399563)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4ytet\00E4\00E4n n\00E4ytett\00E4vien sarakkeiden muokkaukseen. Oikealla olevat sarakkeet n\00E4ytet\00E4\00E4n. Vasemmalla olevat sarakkeet piilotetaan. Voit j\00E4rjestell\00E4 n\00E4ytett\00E4vi\00E4 sarakkeita n\00E4yt\00F6n oikeassa reunassa olevilla nuolilla. Laskettujen sarakkeiden edess\00E4 on <stro')
||'ng>**</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111663611922399563)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>K\00E4ytet\00E4\00E4n lajitteluun k\00E4ytett\00E4vien sarakkeiden vaihtoon. M\00E4\00E4r\00E4\00E4, tehd\00E4\00E4nk\00F6 '),
'',
unistr('lajittelu nousevassa vai laskevassa j\00E4rjestyksess\00E4. Voit my\00F6s m\00E4\00E4ritt\00E4\00E4, miten'),
unistr('<code>NULL</code>-arvoja k\00E4sitell\00E4\00E4n. Oletusasetus on, ett\00E4 <code>NULL</code>-arvot n\00E4ytet\00E4\00E4n aina tulosten aluksi tai aina tulosten lopuksi. Lajittelun tulokset tulevat n\00E4kyviin raportin sarakeotsikkojen oikealle'),
'puolelle.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111723324015399607)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'fi'
,p_message_text=>unistr('Kun lis\00E4\00E4t tilauksen, sinua pyydet\00E4\00E4n antamaan s\00E4hk\00F6postiosoite (tai useita osoitteita pilkulla erotettuina), s\00E4hk\00F6postiviestin aihe, l\00E4hetystiheys ja alkamis- ja p\00E4\00E4ttymisp\00E4iv\00E4t. Valmiisiin s\00E4hk\00F6postiviesteihin sis\00E4ltyy HTML-versio interaktiivisesta')
||unistr(' raportista, joka kattaa nykyiset tiedot niiden raporttiasetusten mukaisesti, jotka olivat k\00E4yt\00F6ss\00E4 tilauksen lis\00E4\00E4misajankohtana.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111741964135399620)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Tietoruudukot ovat k\00E4yt\00E4nn\00F6ss\00E4 muokattavia raportteja, jotka ovat eritt\00E4in pitk\00E4lle mukautettavia. K\00E4ytt\00E4j\00E4t voivat muokata raporttitietojen asettelua valitsemalla sarakkeita, k\00E4ytt\00E4m\00E4ll\00E4 suodattimia, korostamalla ja lajittelemalla. K\00E4ytt\00E4j\00E4t voivat ')
||unistr('my\00F6s m\00E4\00E4ritt\00E4\00E4 katkoja, koosteita, kaavioita, ja ryhmittelyj\00E4 sek\00E4 lis\00E4t\00E4 omia laskentojaan. K\00E4ytt\00E4j\00E4t voivat luoda samasta raportista useita muunnelmia ja tallentaa ne nimettyin\00E4 raportteina yksityist\00E4 tarkastelua varten. '),
'<p/>',
unistr('Tietoruudukkoa voi mukauttaa k\00E4ytt\00E4m\00E4ll\00E4 hakupalkkia, Toiminnot-valikkoa, Hallinta-valikkoa tai Sarakeotsikko-valikkoa.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111753746252399629)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'fi'
,p_message_text=>unistr('Toiminnot-valikko n\00E4kyy hakupalkissa Suorita-painikkeen oikealla puolella. T\00E4m\00E4n valikon vaihtoehdoilla voit mukauttaa tietoruudukkoraportteja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111742445630399620)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'fi'
,p_message_text=>unistr('Rivin lis\00E4ys-/muokkaussivu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111742519753399620)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Lis\00E4\00E4 tietoruudukkoon uusi rivi valitsemalla Lis\00E4\00E4 rivi. Jos haluat muokata rivin tietoja, napsauta muokattavan rivin muokkauskuvaketta (ensimm\00E4inen sarake). T\00E4ll\00F6in tietoruudukon sarakkeet sis\00E4lt\00E4v\00E4 rivin lis\00E4ys-/muokkaussivu avautuu. </p>'),
'',
unistr('<p>Rivi\00E4 voi muokata seuraavilla toiminnoilla:</p>'),
'',
'<p><ul>',
'<li><strong>Poista</strong> poistaa rivin.</li>',
unistr('<li><strong>K\00E4yt\00E4 muutoksia</strong> tallentaa riviin tehdyt muutokset.</li>'),
unistr('<li>Kohdassa <strong>Toiminnot</strong> voit lis\00E4t\00E4 rivin, tiedostoja, huomautuksia, linkkej\00E4 tai tunnisteita ja tarkastella historiaa.</li>'),
unistr('<li>Voit siirty\00E4 riveille <strong>Seuraava ja Edellinen</strong>.</li>'),
unistr('<li>Kohdassa <strong>Hallinta</strong> voit m\00E4\00E4ritt\00E4\00E4 sarakkeiden ominaisuudet ja ryhm\00E4t sek\00E4 tarkistukset ja arvoluettelot.</li>'),
'</ul></p>',
'',
unistr('<p>Sivun alareunan Huomautukset-alueella n\00E4kyv\00E4t kaikki nykyiseen riviin liittyv\00E4t tiedostot, huomautukset, linkit tai tunnisteet.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111753840467399629)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4t\00E4 k\00E4ytet\00E4\00E4n katkoryhm\00E4n luontiin yhteen tai useampaan sarakkeeseen. N\00E4it\00E4 sarakkeita ei en\00E4\00E4 sis\00E4llytet\00E4 tietoruudukkoon, vaan ne n\00E4ytet\00E4\00E4n p\00E4\00E4tietueena.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111742392890399620)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Mahdollistaa nykyisen tulosjoukon noudon. Mahdollisia noutomuotoja',
unistr('ovat mm. CSV, HTML ja s\00E4hk\00F6postiviesti.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111753963128399629)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Kun mukautat tietoruudukkoraporttia, raportin asetukset',
unistr('n\00E4kyv\00E4t hakupalkin alapuolella ja raportin yl\00E4puolella. T\00E4m\00E4n alueen voi tiivist\00E4\00E4 tai laajentaa n\00E4yt\00F6n vasemmassa reunassa olevalla kuvakkeella.'),
'<p>',
unistr('Kunkin raportin asetuksen kohdalla voit tehd\00E4 seuraavaa:'),
'</p><ul>',
unistr('<li>Voit muokata asetusta napsauttamalla sen nime\00E4.</li>'),
unistr('<li>Voit ottaa asetuksen k\00E4ytt\00F6\00F6n tai pois k\00E4yt\00F6st\00E4 valitsemalla Ei k\00E4yt\00F6ss\00E4-/K\00E4yt\00F6ss\00E4-valintaruudun tai poistamalla valinnan. T\00E4ll\00E4 tavoin voit tilap\00E4isesti ottaa asetuksen k\00E4ytt\00F6\00F6n tai poistaa sen k\00E4yt\00F6st\00E4.</li>'),
'<li>Voit poistaa asetuksen napsauttamalla Poista-kuvaketta.</li>',
'</ul>',
unistr('<p>Jos olet luonut kaavion tai ryhmittelyn, voit siirty\00E4 niiden ja perusraportin'),
unistr('v\00E4lill\00E4 n\00E4yt\00F6n oikeassa reunassa olevien Raporttin\00E4kym\00E4n, Kaavion\00E4kym\00E4n ja Ryhmittelyn\00E4kym\00E4n'),
unistr('linkkien avulla. Kun tarkastelet kaaviota tai ryhmittely\00E4, voit my\00F6s muokata asetuksia'),
unistr('napsauttamalla Muokkaa-linkki\00E4.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111742216274399620)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Tallentaa mukautetun tietoruudukkoraportin asettelun my\00F6hemp\00E4\00E4 k\00E4ytt\00F6\00E4 varten. Voit antaa asettelulle nimen ja valinnaisen kuvauksen. Tallennettavia tietoruudukkoraportin asettelutyyppej\00E4 on kolme:</p>'),
'<ul>',
unistr('<li><strong>Ensisijainen oletus</strong> (vain j\00E4rjestelm\00E4nvalvojille). Ensisijainen oletus on aina ensimm\00E4isen\00E4 tarjottava oletusasettelu. Ensisijaisia oletusraportteja ei voi poistaa tai nimet\00E4 uudelleen.</li>'),
unistr('<li><strong>Vaihtoehtoinen raportti</strong> (vain j\00E4rjestelm\00E4nvalvojille). T\00E4m\00E4n raporttityypin avulla j\00E4rjestelm\00E4nvalvojat voivat luoda erilaisia raporttiasetteluita. Vain j\00E4rjestelm\00E4nvalvojat voivat tallentaa, poistaa tai nimet\00E4 uudelleen vaihtoeh')
||'toisia raportteja.</li>',
unistr('<li><strong>Yksityinen raportti</strong> (kaikille k\00E4ytt\00E4jille). Raporttiasettelun luonut k\00E4ytt\00E4j\00E4 voi tarkastella raporttia sek\00E4 tallentaa, poistaa tai nimet\00E4 sen uudelleen.</li>'),
'</ul>',
unistr('<p>Jos tallennat mukautettuja raportteja, hakupalkissa n\00E4kyy rivivalitsimen vasemmalla puolella raporttivalitsin (mik\00E4li t\00E4m\00E4 toiminto on k\00E4yt\00F6ss\00E4).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111668343703399567)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'fi'
,p_message_text=>'Piilota sarake'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111658909221399560)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'fi'
,p_message_text=>'Korostus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111669812648399568)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'fi'
,p_message_text=>'Korostukset'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111674913138399571)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'fi'
,p_message_text=>'Korostusehto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111723907222399607)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'fi'
,p_message_text=>'Korostuksen tyyli'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111633936603399541)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'fi'
,p_message_text=>'Korostustyyppi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111743442539399621)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'fi'
,p_message_text=>'Vaaka'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111773033039399643)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'fi'
,p_message_text=>'1 ei-aktiivinen asetus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111773135850399643)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'fi'
,p_message_text=>'%0 ei-aktiivista asetusta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111664995833399564)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'fi'
,p_message_text=>'Interaktiivisen raportin ohje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111675950258399572)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'fi'
,p_message_text=>'Virheellinen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111669324032399567)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'fi'
,p_message_text=>'Virheellinen laskentalauseke. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111628744641399537)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'fi'
,p_message_text=>unistr('P\00E4\00E4ttymisp\00E4iv\00E4m\00E4\00E4r\00E4n on oltava alkamisp\00E4iv\00E4m\00E4\00E4r\00E4n j\00E4lkeen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111683606044399578)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'fi'
,p_message_text=>'Virheellinen suodatinlauseke. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111751457994399627)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'fi'
,p_message_text=>'Virheellinen suodatinkysely'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111773290431399643)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'fi'
,p_message_text=>'1 virheellinen asetus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111773375348399643)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 virheellist\00E4 asetusta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111724195366399607)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'fi'
,p_message_text=>'(minuutteina)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111741122736399619)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 on edellisell\00E4 aikav\00E4lill\00E4: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111741397314399619)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 on seuraavalla aikav\00E4lill\00E4: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111741280524399619)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 ei ole edellisell\00E4 aikav\00E4lill\00E4: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111741435180399620)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 ei ole seuraavalla aikav\00E4lill\00E4: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111674017718399571)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4pp\00E4imist\00F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111640114814399545)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'fi'
,p_message_text=>'Nimi %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111667949892399566)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'fi'
,p_message_text=>'Nimen akselin otsikko'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111660417471399561)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'fi'
,p_message_text=>unistr('Viime p\00E4iv\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111660699692399561)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'fi'
,p_message_text=>'Viimeinen tunti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111660194741399561)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'fi'
,p_message_text=>'Edellinen kuukausi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111660216776399561)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'fi'
,p_message_text=>'Edellinen viikko'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111660357484399561)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'fi'
,p_message_text=>unistr('Edelliset %0 p\00E4iv\00E4\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111660570693399561)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'fi'
,p_message_text=>'Edelliset %0 tuntia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111659956174399560)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'fi'
,p_message_text=>'Edelliset %0 vuotta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111660089537399561)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'fi'
,p_message_text=>'Edellinen vuosi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111640058567399545)
,p_name=>'APEXIR_LINE'
,p_message_language=>'fi'
,p_message_text=>'Viiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111636806829399543)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'fi'
,p_message_text=>'Viiva ja alue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111751351217399627)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4yt\00E4 kartalla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111668836940399567)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'fi'
,p_message_text=>unistr('Kyselyn arvioidaan ylitt\00E4v\00E4n resurssien sallitun maksimim\00E4\00E4r\00E4n. Muokkaa raportin asetuksia ja yrit\00E4 uudelleen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111651050312399554)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4m\00E4n raportin maksimirivim\00E4\00E4r\00E4 on %0. Pienenn\00E4 kyselyn tietuem\00E4\00E4r\00E4\00E4 k\00E4ytt\00E4m\00E4ll\00E4 suodatinta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111751921882399628)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'fi'
,p_message_text=>'Maksimi %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111752135433399628)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'fi'
,p_message_text=>'Mediaani %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111655032098399557)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'fi'
,p_message_text=>'%0 minuuttia sitten'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111752058758399628)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'fi'
,p_message_text=>'Minimi %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111751053504399627)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'fi'
,p_message_text=>'Kuukausi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111724551891399607)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'fi'
,p_message_text=>'Kuukausittainen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111667123108399566)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'fi'
,p_message_text=>unistr('Siirr\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111667038794399566)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'fi'
,p_message_text=>unistr('Siirr\00E4 kaikki')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111778251602399647)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'fi'
,p_message_text=>unistr('Alueen staattinen tunniste on m\00E4\00E4ritett\00E4v\00E4, koska sivulla on useita interaktiivisia raportteja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111635591275399542)
,p_name=>'APEXIR_NAME'
,p_message_language=>'fi'
,p_message_text=>'Nimi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111662909505399563)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'fi'
,p_message_text=>'Uusi kooste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111773984767399643)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'fi'
,p_message_text=>'Uusi luokka'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111663006891399563)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'fi'
,p_message_text=>'Uusi laskenta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111657875835399559)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'fi'
,p_message_text=>'Seuraava'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111660953456399561)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'fi'
,p_message_text=>unistr('Seuraava p\00E4iv\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111660772367399561)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'fi'
,p_message_text=>'Seuraava tunti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111661221196399561)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'fi'
,p_message_text=>'Seuraava kuukausi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111661165856399561)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'fi'
,p_message_text=>'Seuraava viikko'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111661019266399561)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'fi'
,p_message_text=>unistr('Seuraavat %0 p\00E4iv\00E4\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111660851483399561)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'fi'
,p_message_text=>'Seuraavat %0 tuntia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111661488866399562)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'fi'
,p_message_text=>'Seuraavat %0 vuotta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111661356750399561)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'fi'
,p_message_text=>'Seuraava vuosi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111635863474399542)
,p_name=>'APEXIR_NO'
,p_message_language=>'fi'
,p_message_text=>'Ei'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111676109698399572)
,p_name=>'APEXIR_NONE'
,p_message_language=>'fi'
,p_message_text=>unistr('- Ei mit\00E4\00E4n -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111723786907399607)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'fi'
,p_message_text=>unistr('S\00E4hk\00F6postiosoite ei ole kelvollinen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111672613617399570)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'fi'
,p_message_text=>unistr('Tyhj\00E4t aina alussa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111672552278399570)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'fi'
,p_message_text=>unistr('Tyhj\00E4t aina lopussa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111673023734399570)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'fi'
,p_message_text=>'Tyhjien lajittelu %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111669421426399567)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'fi'
,p_message_text=>'Flashback-ajan on oltava numeerinen arvo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111669051596399567)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'fi'
,p_message_text=>unistr('J\00E4rjestysarvon on oltava numeerinen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111673504311399570)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'fi'
,p_message_text=>'Operaattori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111634456045399541)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'fi'
,p_message_text=>'oranssi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111743317320399621)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'fi'
,p_message_text=>'Suunta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111636368431399542)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'fi'
,p_message_text=>'Muu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111619128097399530)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'fi'
,p_message_text=>'Sivun suunta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111619891763399530)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'fi'
,p_message_text=>'Vaaka'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111619932554399530)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'fi'
,p_message_text=>'Pysty'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111619001031399530)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'fi'
,p_message_text=>'Sivun koko'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111619690956399530)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'fi'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111619593522399530)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'fi'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111619770933399530)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'fi'
,p_message_text=>'Mukautettu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111619371749399530)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'fi'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111619288096399530)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'fi'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111619481348399530)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'fi'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111752419991399628)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'fi'
,p_message_text=>unistr('Prosenttiosuus kokonaism\00E4\00E4r\00E4st\00E4 %0 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111751610827399627)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'fi'
,p_message_text=>'Prosenttiosuus kokonaissummasta %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111750657975399627)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'fi'
,p_message_text=>unistr('Prosenttiosuus kokonaism\00E4\00E4r\00E4st\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111750576002399626)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'fi'
,p_message_text=>'Prosenttiosuus kokonaissummasta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111639973986399545)
,p_name=>'APEXIR_PIE'
,p_message_language=>'fi'
,p_message_text=>unistr('Ympyr\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111699872956399590)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'fi'
,p_message_text=>'Pivot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111701357478399591)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'fi'
,p_message_text=>unistr('Kooste on m\00E4\00E4ritett\00E4v\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111701549072399591)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'fi'
,p_message_text=>unistr('Koostetta ei voi tehd\00E4 rivin sarakkeeksi valitusta sarakkeesta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111700784067399590)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'fi'
,p_message_text=>'Pivot-sarakkeet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111700537466399590)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'fi'
,p_message_text=>'Pivot-sarake %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111701175278399591)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'fi'
,p_message_text=>unistr('Pivot-sarake on m\00E4\00E4ritett\00E4v\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111601217678399517)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'fi'
,p_message_text=>unistr('Pivot-kyselyn rivien maksimim\00E4\00E4r\00E4 rajoittaa peruskyselyn rivien m\00E4\00E4r\00E4\00E4 mutta ei n\00E4ytett\00E4vien rivien m\00E4\00E4r\00E4\00E4. Peruskyselyss\00E4 on maksimim\00E4\00E4r\00E4\00E4 %0 enemm\00E4n rivej\00E4. V\00E4henn\00E4 peruskyselyll\00E4 saatavien tietueiden m\00E4\00E4r\00E4\00E4 k\00E4ytt\00E4m\00E4ll\00E4 suodatinta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111701091965399591)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'fi'
,p_message_text=>'Pivot-lajittelu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111670490085399568)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'fi'
,p_message_text=>unistr('Pivot-sarakkeessa on liian monta erillist\00E4 arvoa - Pivot SQL -kysely\00E4 ei voi luoda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111723856969399607)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'fi'
,p_message_text=>'Esikatselu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111657959541399559)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'fi'
,p_message_text=>'Edellinen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111749593525399626)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'fi'
,p_message_text=>'Ensisijainen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111724849457399608)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'fi'
,p_message_text=>'Ensisijainen raportti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111618911356399530)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'fi'
,p_message_text=>unistr('Sis\00E4llyt\00E4 helppok\00E4ytt\00F6isyystunnisteet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111605875730399520)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'fi'
,p_message_text=>'Poista Rich Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111682628376399577)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'fi'
,p_message_text=>'Yksityinen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111640582428399546)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'fi'
,p_message_text=>'Julkinen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111636132523399542)
,p_name=>'APEXIR_RED'
,p_message_language=>'fi'
,p_message_text=>'punainen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111778136548399646)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'fi'
,p_message_text=>'Alueen staattista tunnistetta %0 ei ole olemassa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111667218120399566)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'fi'
,p_message_text=>'Poista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111667399472399566)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'fi'
,p_message_text=>'Poista kaikki'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111773472691399643)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'fi'
,p_message_text=>'Poista kaavio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111666890584399566)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'fi'
,p_message_text=>unistr('Poista ryhm\00E4katko')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111666536886399565)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'fi'
,p_message_text=>'Poista suodatin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111666693168399565)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'fi'
,p_message_text=>'Poista Flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111773573161399643)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'fi'
,p_message_text=>'Poista ryhmittely'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111666992367399566)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'fi'
,p_message_text=>'Poista korostus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111773685084399643)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'fi'
,p_message_text=>'Poista Pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111754683360399630)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'fi'
,p_message_text=>'Poista raportti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111735242980399615)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'fi'
,p_message_text=>unistr('Nime\00E4 oletusraportti uudelleen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111676492022399573)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'fi'
,p_message_text=>unistr('Nime\00E4 raportti uudelleen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111658222873399559)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'fi'
,p_message_text=>'Raportti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111752500728399628)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'fi'
,p_message_text=>'Raportit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111632765653399540)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'fi'
,p_message_text=>unistr('Tallennettua interaktiivista raporttia, jonka alias on %0, ei l\00F6ydy.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111682972825399577)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'fi'
,p_message_text=>'Raporttia ei ole.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111632822718399540)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'fi'
,p_message_text=>unistr('Tallennettua interaktiivista raporttia, jonka tunniste on %0, ei l\00F6ydy.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111674758164399571)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'fi'
,p_message_text=>'Raporttiasetukset'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111655553699399557)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'fi'
,p_message_text=>unistr('Raporttin\00E4kym\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111659405755399560)
,p_name=>'APEXIR_RESET'
,p_message_language=>'fi'
,p_message_text=>'Nollaa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111640712895399546)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'fi'
,p_message_text=>'Palauta raportin oletusasetukset.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111635935472399542)
,p_name=>'APEXIR_ROW'
,p_message_language=>'fi'
,p_message_text=>'Rivi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111748620111399625)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'fi'
,p_message_text=>unistr('ROWID ei voi olla REST-tietol\00E4hteen perusavaimen sarake.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111665984510399565)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'fi'
,p_message_text=>'Rivit'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111725549000399608)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'fi'
,p_message_text=>unistr('Rivej\00E4 sivulla')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111700887507399590)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'fi'
,p_message_text=>'Rivin sarakkeet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111700645004399590)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'fi'
,p_message_text=>'Rivin sarake %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111701295009399591)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'fi'
,p_message_text=>unistr('Rivin sarake on m\00E4\00E4ritett\00E4v\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111701473698399591)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'fi'
,p_message_text=>'Rivin sarake ei saa olla sama kuin pivot-sarake.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111680025967399575)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'fi'
,p_message_text=>'Rivisuodatin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111655642349399557)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'fi'
,p_message_text=>'Rivi %0/%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111659622275399560)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'fi'
,p_message_text=>unistr('Rivin teksti sis\00E4lt\00E4\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111635240231399542)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'fi'
,p_message_text=>'Tallenna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111670032438399568)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'fi'
,p_message_text=>'Tallennettu raportti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111669907454399568)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'fi'
,p_message_text=>'Tallennettu raportti = "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111672122859399569)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'fi'
,p_message_text=>unistr('Nykyisi\00E4 raportin asetuksia k\00E4ytet\00E4\00E4n oletusarvoina kaikille k\00E4ytt\00E4jille.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111735169985399615)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'fi'
,p_message_text=>'Tallenna oletusraportti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111659372004399560)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'fi'
,p_message_text=>'Tallenna raportti'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111773815196399643)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'fi'
,p_message_text=>'Tallenna raportti *'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111726577987399609)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'fi'
,p_message_text=>'Haku'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111664813957399564)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'fi'
,p_message_text=>'Hakupalkki'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111773770067399643)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'fi'
,p_message_text=>'Haku: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111732053488399613)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'fi'
,p_message_text=>'Hae raportti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111716086134399601)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'fi'
,p_message_text=>'Valitut sarakkeet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111636931909399543)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'fi'
,p_message_text=>'- Valitse sarake -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111658624589399560)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'fi'
,p_message_text=>'Sarakkeiden valinta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111640476272399546)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'fi'
,p_message_text=>'- Valitse toiminto -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111665698652399565)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'fi'
,p_message_text=>'- Valitse ryhmittelyn sarake -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111700335141399590)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'fi'
,p_message_text=>'- Valitse Pivot-sarake -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111751521748399627)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'fi'
,p_message_text=>'Valitse rivi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111700413856399590)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'fi'
,p_message_text=>'- Valitse rivin sarake -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111609190064399522)
,p_name=>'APEXIR_SEND'
,p_message_language=>'fi'
,p_message_text=>unistr('L\00E4het\00E4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111615459462399527)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'fi'
,p_message_text=>unistr('L\00E4het\00E4 s\00E4hk\00F6postiviestin\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111635606705399542)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'fi'
,p_message_text=>unistr('J\00E4rjestys')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111658867386399560)
,p_name=>'APEXIR_SORT'
,p_message_language=>'fi'
,p_message_text=>'Lajittelu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111668160692399567)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'fi'
,p_message_text=>unistr('Nouseva j\00E4rjestys')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111668222405399567)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'fi'
,p_message_text=>unistr('Laskeva j\00E4rjestys')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111754075637399629)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'fi'
,p_message_text=>unistr('Lajitteluj\00E4rjestys')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111662643234399562)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'fi'
,p_message_text=>unistr('v\00E4li')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111673709337399571)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'fi'
,p_message_text=>'Tila %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111724281676399607)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'fi'
,p_message_text=>'Tilaus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111750979100399627)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'fi'
,p_message_text=>unistr('P\00E4\00E4ttyy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111605377554399520)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'fi'
,p_message_text=>unistr('Ohita, jos tietoja ei l\00F6ydy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111750811435399627)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'fi'
,p_message_text=>'Alkaa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111751798383399627)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'fi'
,p_message_text=>'Summa %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111741738990399620)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'fi'
,p_message_text=>unistr('Alue = %0, Raportti = %1, Tarkastelu = %2, N\00E4kyvien rivien alku = %3, N\00E4kyvien rivien loppu = %4, Rivej\00E4 yhteens\00E4 = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111662331219399562)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'fi'
,p_message_text=>unistr('Alue = %0, Raportti = %1, Tarkastelu = %2, N\00E4kyvien rivien alku = %3, N\00E4kyvien rivien loppu = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111634507629399541)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'fi'
,p_message_text=>unistr('Tekstin v\00E4ri')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111651696206399554)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'fi'
,p_message_text=>unistr('p\00E4iv\00E4\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111651572264399554)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'fi'
,p_message_text=>'tuntia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111651460000399554)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'fi'
,p_message_text=>'minuuttia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111651854641399554)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'fi'
,p_message_text=>'kuukautta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111651742690399554)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'fi'
,p_message_text=>'viikkoa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111651949832399554)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'fi'
,p_message_text=>'vuotta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111754406101399629)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'fi'
,p_message_text=>'Vaihda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111667464531399566)
,p_name=>'APEXIR_TOP'
,p_message_language=>'fi'
,p_message_text=>'Ylin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111747665326399624)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'fi'
,p_message_text=>unistr('Ryhmittelem\00E4t\00F6n sarake')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111668984613399567)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'fi'
,p_message_text=>unistr('Korostuksen nimen on oltava yksil\00F6iv\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111639221862399545)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'fi'
,p_message_text=>unistr('tietotyyppi\00E4 ei tueta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111667588864399566)
,p_name=>'APEXIR_UP'
,p_message_language=>'fi'
,p_message_text=>unistr('Yl\00F6s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111669103830399567)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'fi'
,p_message_text=>unistr('Anna sallittu v\00E4ri.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111669248968399567)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'fi'
,p_message_text=>'Anna sallittu muotomaski.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111636438644399543)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'fi'
,p_message_text=>'Arvo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111668001246399566)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'fi'
,p_message_text=>'Arvon akselin otsikko'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111675848793399572)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'fi'
,p_message_text=>'Pakollinen arvo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111639818118399545)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'fi'
,p_message_text=>unistr('Pystysuora pylv\00E4s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111743505465399621)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'fi'
,p_message_text=>'Pysty'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111675109780399572)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4yt\00E4 kaavio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111730318517399611)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'fi'
,p_message_text=>'Katso tiedot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111775995618399645)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'fi'
,p_message_text=>unistr('Raporttiin ei ole m\00E4\00E4ritetty n\00E4kym\00E4\00E4 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111730420655399612)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4yt\00E4 ryhmittely')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111730285280399611)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4yt\00E4 kuvakkeet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111700180277399590)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4yt\00E4 Pivot')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111675207530399572)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'fi'
,p_message_text=>'Katso raportti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111724499653399607)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'fi'
,p_message_text=>'Viikoittainen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111658129304399559)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'fi'
,p_message_text=>unistr('Ty\00F6raportti')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111753116081399628)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 p\00E4iv\00E4\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111753027809399628)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'fi'
,p_message_text=>'%0 tuntia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111752991193399628)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'fi'
,p_message_text=>'%0 minuuttia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111753315105399629)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'fi'
,p_message_text=>'%0 kuukautta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111753234100399628)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'fi'
,p_message_text=>'%0 viikkoa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111753407164399629)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'fi'
,p_message_text=>'%0 vuotta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111751182456399627)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'fi'
,p_message_text=>'Vuosi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111634220841399541)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'fi'
,p_message_text=>'keltainen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111635749422399542)
,p_name=>'APEXIR_YES'
,p_message_language=>'fi'
,p_message_text=>unistr('Kyll\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111667817902399566)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 sis\00E4lt\00E4\00E4 virheellisen merkin < tai >.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111690642301399583)
,p_name=>'APEX_REGION'
,p_message_language=>'fi'
,p_message_text=>'Alue'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111618812236399530)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'fi'
,p_message_text=>'API-ennakkoehtoa rikottu'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111638304896399544)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'fi'
,p_message_text=>unistr('Sovellusasetuksen %0 arvoa ei voi noutaa, koska siihen liittyv\00E4 koontiversiovaihtoehto on poistettu k\00E4yt\00F6st\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111638296950399544)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'fi'
,p_message_text=>unistr('Sovellusasetukselle %0 ei voi asettaa arvoa, koska siihen liittyv\00E4 koontiversiovaihtoehto on poistettu k\00E4yt\00F6st\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111745948992399623)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'fi'
,p_message_text=>'Sovellusasetuksen %0 arvo on virheellinen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111745808805399623)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'fi'
,p_message_text=>unistr('Pyydetty\00E4 sovellusasetusta %0 ei ole m\00E4\00E4ritetty')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111746073772399623)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'fi'
,p_message_text=>unistr('Sovellusasetuksen %0 arvoksi ei voi m\00E4\00E4ritt\00E4\00E4 tyhj\00E4\00E4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111626972651399536)
,p_name=>'BACK'
,p_message_language=>'fi'
,p_message_text=>'Edellinen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111613900865399526)
,p_name=>'BUILDER'
,p_message_language=>'fi'
,p_message_text=>'Luontiohjelma'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111678019453399574)
,p_name=>'BUTTON LABEL'
,p_message_language=>'fi'
,p_message_text=>'Painikkeen nimi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111613065353399525)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'fi'
,p_message_text=>'Painikkeen CSS-luokat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111642205040399547)
,p_name=>'BUTTON_ID'
,p_message_language=>'fi'
,p_message_text=>unistr('Luodun painikkeen tunnisteena k\00E4ytet\00E4\00E4n joko painikkeen staattista tunnistetta, jos sellainen on m\00E4\00E4ritetty, tai muussa tapauksessa sis\00E4isesti luotua tunnistetta muodossa ''B'' | [Sis\00E4inen painikkeen tunniste]')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111605710510399520)
,p_name=>'CANDLESTICK'
,p_message_language=>'fi'
,p_message_text=>unistr('Kynttil\00E4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111687270844399580)
,p_name=>'CENTER'
,p_message_language=>'fi'
,p_message_text=>unistr('Keskell\00E4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111637218986399543)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'fi'
,p_message_text=>unistr('Tyypin %0 pyynt\00F6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111628654423399537)
,p_name=>'CHECK$'
,p_message_language=>'fi'
,p_message_text=>'rivin valitsin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111747731494399624)
,p_name=>'CHECKED'
,p_message_language=>'fi'
,p_message_text=>'valittu'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111723270890399606)
,p_name=>'COLUMN'
,p_message_language=>'fi'
,p_message_text=>'Sarake'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111683703982399578)
,p_name=>'COMMENTS'
,p_message_language=>'fi'
,p_message_text=>'Kommentit'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111665269164399564)
,p_name=>'CONTINUE'
,p_message_language=>'fi'
,p_message_text=>'Jatka'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111627238087399536)
,p_name=>'COPYRIGHT'
,p_message_language=>'fi'
,p_message_text=>unistr('Copyright &copy %0. Kaikki oikeudet pid\00E4tet\00E4\00E4n.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111670911215399569)
,p_name=>'COUNT'
,p_message_language=>'fi'
,p_message_text=>'Laske'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111677602570399573)
,p_name=>'CREATE'
,p_message_language=>'fi'
,p_message_text=>'Luo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111729936288399611)
,p_name=>'CREATED'
,p_message_language=>'fi'
,p_message_text=>'Luotu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111730098859399611)
,p_name=>'CREATED_BY'
,p_message_language=>'fi'
,p_message_text=>'Luonut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111654891977399557)
,p_name=>'CREATED_ON'
,p_message_language=>'fi'
,p_message_text=>'Luotu'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111665441208399564)
,p_name=>'CUSTOM'
,p_message_language=>'fi'
,p_message_text=>'Mukautettu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111676618307399573)
,p_name=>'CUSTOMIZE'
,p_message_language=>'fi'
,p_message_text=>'Mukauta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111678234991399574)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4ytt\00E4j\00E4n %0 sivum\00E4\00E4ritykset on nollattu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111678358345399574)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4ytt\00E4j\00E4n %0 m\00E4\00E4rityksi\00E4 on muokattu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111678151994399574)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4ytt\00E4j\00E4n %0 sivum\00E4\00E4ritykset on nollattu.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111641942187399547)
,p_name=>'DAILY'
,p_message_language=>'fi'
,p_message_text=>unistr('P\00E4ivitt\00E4in')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111613505171399526)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'fi'
,p_message_text=>unistr('Ladattu tiedosto on virheellinen tai sen tiedostotunniste on v\00E4\00E4r\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111637474852399543)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4ytetty XML- tai JSON-valitsin on virheellinen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111606721965399521)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'fi'
,p_message_text=>unistr('Tietoprofiili ja ladattu tiedosto eiv\00E4t sis\00E4ll\00E4 yht\00E4\00E4n kohdetaulukon saraketta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111692479366399584)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'fi'
,p_message_text=>unistr('Ladatusta tiedostosta ei l\00F6ytynyt tietoja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111692518073399584)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'fi'
,p_message_text=>unistr('Ty\00F6alustasta "%0" ei l\00F6ytynyt tietoja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111612377384399525)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'fi'
,p_message_text=>unistr('M\00E4\00E4ritetty tiedosto ei ole XLSX-tiedosto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111602797064399518)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'fi'
,p_message_text=>unistr('Tiedot on ladattu: %0 rivi\00E4 k\00E4sitelty.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111603926417399519)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'fi'
,p_message_text=>unistr('Tiedot on ladattu: %0 rivi\00E4 k\00E4sitelty, 1 virhe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111604216180399519)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'fi'
,p_message_text=>unistr('Tiedot on ladattu: %0 rivi\00E4 k\00E4sitelty, %1 virhett\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111604054241399519)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'fi'
,p_message_text=>unistr('Tiedot on ladattu: 1 rivi k\00E4sitelty.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111607003805399521)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'fi'
,p_message_text=>unistr('Tiedot on ladattu: 1 rivi k\00E4sitelty, 1 virhe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111604129192399519)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'fi'
,p_message_text=>unistr('Tiedot on ladattu: 1 rivi k\00E4sitelty, ei virheit\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111697770767399588)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'fi'
,p_message_text=>'Kohdesarake'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111697821321399588)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'fi'
,p_message_text=>unistr('L\00E4hdesarake')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111698670847399589)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'fi'
,p_message_text=>unistr('P\00E4iv\00E4m\00E4\00E4r\00E4n/numeron muoto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111762061533399635)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'fi'
,p_message_text=>unistr('Valinnan arvon haku ep\00E4onnistui.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111730574962399612)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'fi'
,p_message_text=>'Tietojen/taulukon kartoitus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111698740200399589)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'fi'
,p_message_text=>'Rivi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111694275580399586)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'fi'
,p_message_text=>unistr('Muuntos\00E4\00E4nt\00F6 ep\00E4onnistui')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111670586814399568)
,p_name=>'DATE'
,p_message_language=>'fi'
,p_message_text=>unistr('P\00E4iv\00E4m\00E4\00E4r\00E4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111644697702399549)
,p_name=>'DAY'
,p_message_language=>'fi'
,p_message_text=>unistr('p\00E4iv\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111644798930399549)
,p_name=>'DAYS'
,p_message_language=>'fi'
,p_message_text=>unistr('p\00E4iv\00E4\00E4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111683417927399578)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'fi'
,p_message_text=>unistr('Virheenetsint\00E4\00E4 ei ole otettu k\00E4ytt\00F6\00F6n t\00E4lle sovellukselle.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111732235841399613)
,p_name=>'DEFAULT'
,p_message_language=>'fi'
,p_message_text=>'Oletus'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111645418878399549)
,p_name=>'DELETE'
,p_message_language=>'fi'
,p_message_text=>'poista'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111605607128399520)
,p_name=>'DIAL_PCT'
,p_message_language=>'fi'
,p_message_text=>'Valitsin (prosenttia)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111620126046399531)
,p_name=>'DOWNLOAD'
,p_message_language=>'fi'
,p_message_text=>'Nouda'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111731300042399612)
,p_name=>'DUP_USER'
,p_message_language=>'fi'
,p_message_text=>unistr('Luettelossa on k\00E4ytt\00E4j\00E4tunnuksen kaksoiskappaleita.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111627789677399536)
,p_name=>'EDIT'
,p_message_language=>'fi'
,p_message_text=>'Muokkaa'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111637135475399543)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'fi'
,p_message_text=>unistr('S\00E4hk\00F6postiosoitetta "%0" ei l\00F6ytynyt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111622276797399532)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4m\00E4n s\00E4hk\00F6postiviestin l\00E4hetti %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111731517414399612)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'fi'
,p_message_text=>unistr('S\00E4hk\00F6postiosoite on liian pitk\00E4, maksimipituus on 240 merkki\00E4.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111665183216399564)
,p_name=>'ERROR'
,p_message_language=>'fi'
,p_message_text=>'Virhe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111694350974399586)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'fi'
,p_message_text=>unistr('Sivun osittaiselle p\00E4ivitysalueelle ei voi m\00E4\00E4ritt\00E4\00E4 sivukohteen l\00E4hteen arvoa')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111656617260399558)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'fi'
,p_message_text=>'Luonut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111622563487399532)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'fi'
,p_message_text=>'Vanhentunut salasana'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111616685732399528)
,p_name=>'FILE_EMPTY'
,p_message_language=>'fi'
,p_message_text=>unistr('Tiedosto on tyhj\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111696890688399587)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'fi'
,p_message_text=>'Ladatun tiedoston koko oli yli %0 Mt. Lataa pienempi tiedosto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111624680634399534)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4ytt\00E4j\00E4n todennus ep\00E4onnistui, ja v\00E4hint\00E4\00E4n yht\00E4 tiedostoa ei ladattu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111624716053399534)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('Todentamattomat k\00E4ytt\00E4j\00E4t eiv\00E4t saa ladata tiedostoja t\00E4ss\00E4 instanssissa.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111677740355399574)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'fi'
,p_message_text=>'On tapahtunut 1 virhe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111676924041399573)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('On tapahtunut %0 virhett\00E4')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111627177286399536)
,p_name=>'FORM_OF'
,p_message_language=>'fi'
,p_message_text=>'%0 / %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111661845300399562)
,p_name=>'GO'
,p_message_language=>'fi'
,p_message_text=>'Suorita'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111761693799399635)
,p_name=>'HELP'
,p_message_language=>'fi'
,p_message_text=>'Ohje'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111614085542399526)
,p_name=>'HOME'
,p_message_language=>'fi'
,p_message_text=>'Aloitus'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111644454571399549)
,p_name=>'HOUR'
,p_message_language=>'fi'
,p_message_text=>'tunti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111644513782399549)
,p_name=>'HOURS'
,p_message_language=>'fi'
,p_message_text=>'tuntia'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111628530461399537)
,p_name=>'ICON'
,p_message_language=>'fi'
,p_message_text=>'Kuvake %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111678560251399574)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'fi'
,p_message_text=>'Virheelliset kirjautumistiedot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111778050082399646)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'fi'
,p_message_text=>'Parametrin %0 arvo on virheellinen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111673226971399570)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'fi'
,p_message_text=>'Raportin oletusasetuksina'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111673331240399570)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'fi'
,p_message_text=>unistr('Nimettyn\00E4 raporttina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111655715412399557)
,p_name=>'IR_ERROR'
,p_message_language=>'fi'
,p_message_text=>'%0 virhe. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111655407136399557)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('Lomakkeen siirtymist\00E4 ei voi laskea. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111633073860399540)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'fi'
,p_message_text=>unistr('Interaktiivista raporttia ei l\00F6ydy.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111632428389399540)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'fi'
,p_message_text=>'Interaktiivisen raportin alue puuttuu sovelluksesta %0, sivusta %1 ja alueesta %2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111673135719399570)
,p_name=>'IR_STAR'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4kyy vain kehitt\00E4jille')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111661579804399562)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('Raporttikyselyss\00E4 on oltava yksil\00F6iv\00E4 avain kunkin rivin tunnistukseen. Annettu avain ei sovi t\00E4lle kyselylle. M\00E4\00E4rit\00E4 yksil\00F6iv\00E4 avainsarake. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111661688473399562)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'fi'
,p_message_text=>unistr('Raporttikyselyss\00E4 on oltava yksil\00F6iv\00E4 avain kunkin rivin tunnistukseen. Annettu avain ei sovi t\00E4lle kyselylle. M\00E4\00E4rit\00E4 yksil\00F6iv\00E4 avainsarake muokkaamalla raportin m\00E4\00E4ritteit\00E4. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111698946912399589)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'fi'
,p_message_text=>'Valitse tiedosto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111698809334399589)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'fi'
,p_message_text=>unistr('Ved\00E4 ja pudota tiedosto t\00E4h\00E4n tai')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111627410685399536)
,p_name=>'ITEMS'
,p_message_language=>'fi'
,p_message_text=>'Kohteet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111656850485399558)
,p_name=>'ITEM_VALUE'
,p_message_language=>'fi'
,p_message_text=>'Kohteen arvo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111671228183399569)
,p_name=>'LABEL'
,p_message_language=>'fi'
,p_message_text=>'Nimi'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111683334985399578)
,p_name=>'LANGUAGE'
,p_message_language=>'fi'
,p_message_text=>'Kieli'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111645191045399549)
,p_name=>'LAST'
,p_message_language=>'fi'
,p_message_text=>'edellinen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111624532098399534)
,p_name=>'LENGTH'
,p_message_language=>'fi'
,p_message_text=>'Pituus'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111677805761399574)
,p_name=>'LOGIN'
,p_message_language=>'fi'
,p_message_text=>unistr('Kirjaudu sis\00E4\00E4n')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111716454540399602)
,p_name=>'MANAGE'
,p_message_language=>'fi'
,p_message_text=>'Hallinta'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111781069650399649)
,p_name=>'MAXIMIZE'
,p_message_language=>'fi'
,p_message_text=>'Suurenna'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111644267999399549)
,p_name=>'MINUTE'
,p_message_language=>'fi'
,p_message_text=>'minuutti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111644321320399549)
,p_name=>'MINUTES'
,p_message_language=>'fi'
,p_message_text=>'minuuttia'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111731743803399612)
,p_name=>'MISSING_AT'
,p_message_language=>'fi'
,p_message_text=>unistr('S\00E4hk\00F6postiosoitteesta puuttuu "@".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111731910333399613)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'fi'
,p_message_text=>unistr('Varoitus: Sovelluksen %1 valintaikkunasivulle %0 ei ole m\00E4\00E4ritetty valintaikkunasivun mallia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111731653097399612)
,p_name=>'MISSING_DOT'
,p_message_language=>'fi'
,p_message_text=>unistr('S\00E4hk\00F6postiosoitteen toimialueesta puuttuu ".".')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111680829981399576)
,p_name=>'MODULE'
,p_message_language=>'fi'
,p_message_text=>'Moduuli'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111637986328399544)
,p_name=>'MONTH'
,p_message_language=>'fi'
,p_message_text=>'Kuukausi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111641726774399547)
,p_name=>'MONTHLY'
,p_message_language=>'fi'
,p_message_text=>'Kuukausittain'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111638093226399544)
,p_name=>'MONTHS'
,p_message_language=>'fi'
,p_message_text=>'kuukautta'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111670810483399568)
,p_name=>'MOVE'
,p_message_language=>'fi'
,p_message_text=>unistr('Siirr\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111738387594399617)
,p_name=>'MOVE_FROM'
,p_message_language=>'fi'
,p_message_text=>unistr('Siirr\00E4 kohteesta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111738470796399617)
,p_name=>'MOVE_TO'
,p_message_language=>'fi'
,p_message_text=>unistr('Siirr\00E4 kohteeseen')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111658095320399559)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'fi'
,p_message_text=>'Virhe monen rivin poistotoiminnossa: rivi= %0, %1, %2'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111657050523399558)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'fi'
,p_message_text=>unistr('Ei saa olla julkinen k\00E4ytt\00E4j\00E4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111614269038399526)
,p_name=>'NAME'
,p_message_language=>'fi'
,p_message_text=>'Nimi'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111671076905399569)
,p_name=>'NEW'
,p_message_language=>'fi'
,p_message_text=>'Uusi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111637760806399544)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'fi'
,p_message_text=>'Voit kirjautua %0 -tilillesi osoitteessa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111637883310399544)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'fi'
,p_message_text=>unistr('Ilmoitus uudesta %0 -tilist\00E4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111761892607399635)
,p_name=>'NEXT'
,p_message_language=>'fi'
,p_message_text=>'Seuraava'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111680733963399576)
,p_name=>'NO'
,p_message_language=>'fi'
,p_message_text=>'Ei'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111776036458399645)
,p_name=>'NOBODY'
,p_message_language=>'fi'
,p_message_text=>'ei kukaan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111645511899399550)
,p_name=>'NOT'
,p_message_language=>'fi'
,p_message_text=>'Ei'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111686386511399580)
,p_name=>'NOT_NULL'
,p_message_language=>'fi'
,p_message_text=>unistr('Ei-tyhj\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111657184575399558)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'fi'
,p_message_text=>'Ei %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111676755123399573)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'fi'
,p_message_text=>unistr('tietoja ei l\00F6ydy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111685802827399579)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'fi'
,p_message_text=>unistr('P\00E4ivitett\00E4v\00E4\00E4 raporttia ei l\00F6ydy. Usean rivin p\00E4ivitys- ja poistotoimintoja voi tehd\00E4 vain taulukkomuotoisille lomakkeille, joiden tyyppi on P\00E4ivitett\00E4v\00E4 raportti.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111686744096399580)
,p_name=>'OK'
,p_message_language=>'fi'
,p_message_text=>'OK'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111682486175399577)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'fi'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111779809601399648)
,p_name=>'ORA_06550'
,p_message_language=>'fi'
,p_message_text=>'ORA-06550: rivi %0, sarake %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111729361410399611)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4ytt\00E4m\00E4si selain on vanhentunut. Luettelo tuetuista selaimista on Oracle Application Express Installation Guide -asennusoppaassa.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111630721547399538)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'fi'
,p_message_text=>unistr('Pyydetty rivijoukko on virheellinen, sill\00E4 raportin l\00E4hdetietoja on muokattu.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111650843803399554)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'fi'
,p_message_text=>'Sallittu sivun numero on annettava, esimerkiksi p?n=1234.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111654483418399556)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'fi'
,p_message_text=>'Seuraava'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111654504659399556)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'fi'
,p_message_text=>'Seuraava joukko'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111654636598399557)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'fi'
,p_message_text=>'Edellinen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111654742805399557)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'fi'
,p_message_text=>'Edellinen joukko'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111761781967399635)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'fi'
,p_message_text=>'Valitse sivutus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111692326409399584)
,p_name=>'PASSWORD'
,p_message_language=>'fi'
,p_message_text=>'Salasana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111637094708399543)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'fi'
,p_message_text=>'Salasanasi kohteeseen %0 on vaihdettu.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111626807093399535)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('Salasana ei ole t\00E4m\00E4n sivuston salasanan monimutkaisuuss\00E4\00E4nt\00F6jen mukainen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111625934138399535)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('Uudessa salasanassa on oltava v\00E4hint\00E4\00E4n %0 eri merkki\00E4 kuin vanhassa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111626505724399535)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('Salasana ei saa sis\00E4lt\00E4\00E4 k\00E4ytt\00E4j\00E4tunnusta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111626784284399535)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('Salasana sis\00E4lt\00E4\00E4 kielletyn yksinkertaisen sanan.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111626677164399535)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('Salasana ei saa sis\00E4lt\00E4\00E4 ty\00F6tilan nime\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111625886466399535)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('Salasanassa on oltava v\00E4hint\00E4\00E4n %0 merkki\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111626061690399535)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'fi'
,p_message_text=>'Salasanassa on oltava ainakin yksi aakkosmerkki (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111626436474399535)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('Salasanassa on oltava v\00E4hint\00E4\00E4n yksi pieni aakkosmerkki.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111626104924399535)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'fi'
,p_message_text=>'Salasanassa olisi oltava ainakin yksi numero (0123456789).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111626212219399535)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('Salasanassa on oltava ainakin yksi v\00E4limerkki (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111626382989399535)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('Salasanassa on oltava v\00E4hint\00E4\00E4n yksi iso aakkosmerkki.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111637535664399543)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'fi'
,p_message_text=>'Salasanan nollausilmoitus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111624883364399534)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4t\00E4 salasanaa ei voi k\00E4ytt\00E4\00E4, koska se on jo ollut k\00E4yt\00F6ss\00E4 edellisten %0 p\00E4iv\00E4n aikana.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111705162550399594)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'fi'
,p_message_text=>'Kohteet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111705201760399594)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'fi'
,p_message_text=>'Kohde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111682257186399577)
,p_name=>'PERCENT'
,p_message_language=>'fi'
,p_message_text=>'Prosentti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111652515949399555)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'fi'
,p_message_text=>unistr('Ota yhteys j\00E4rjestelm\00E4nvalvojaan.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111761946653399635)
,p_name=>'PREVIOUS'
,p_message_language=>'fi'
,p_message_text=>'Edellinen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111697361645399588)
,p_name=>'PRINT'
,p_message_language=>'fi'
,p_message_text=>'Tulosta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111681098143399576)
,p_name=>'PRIVILEGES'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4ytt\00F6oikeudet')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111650930239399554)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'fi'
,p_message_text=>'Alueviitteet'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111671191295399569)
,p_name=>'REPORT'
,p_message_language=>'fi'
,p_message_text=>'Raportti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111680958045399576)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'fi'
,p_message_text=>'Raportointikausi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111762163228399635)
,p_name=>'REPORT_LABEL'
,p_message_language=>'fi'
,p_message_text=>'Raportti: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111681624163399576)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'fi'
,p_message_text=>unistr('Raportti yhteens\00E4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111630889360399538)
,p_name=>'RESET'
,p_message_language=>'fi'
,p_message_text=>'Nollaa sivutus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111656785576399558)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'fi'
,p_message_text=>'Nollaa sivutus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111685780462399579)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'fi'
,p_message_text=>'Nollaa salasana'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111662530673399562)
,p_name=>'RESTORE'
,p_message_language=>'fi'
,p_message_text=>'Palauta'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111694404901399586)
,p_name=>'RESULTS'
,p_message_language=>'fi'
,p_message_text=>'Tulokset'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111686810517399580)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'fi'
,p_message_text=>'Palaa sovellukseen.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111687151309399580)
,p_name=>'RIGHT'
,p_message_language=>'fi'
,p_message_text=>'Oikea'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111716787212399602)
,p_name=>'ROW'
,p_message_language=>'fi'
,p_message_text=>'Rivi %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111670728050399568)
,p_name=>'ROW_COUNT'
,p_message_language=>'fi'
,p_message_text=>unistr('Rivien m\00E4\00E4r\00E4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111686270274399580)
,p_name=>'SAVE'
,p_message_language=>'fi'
,p_message_text=>'Tallenna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111682845246399577)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'fi'
,p_message_text=>'Vaihtoehtoinen oletus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111683254909399578)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'fi'
,p_message_text=>'Kuvaus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111682735970399577)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'fi'
,p_message_text=>'Ensisijainen oletus'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111683580277399578)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'fi'
,p_message_text=>unistr('Yli %0 rivi\00E4 k\00E4ytett\00E4viss\00E4. Tuo enemm\00E4n rivej\00E4 n\00E4kyviin laajentamalla rivivalitsinta.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111748983474399625)
,p_name=>'SEARCH'
,p_message_language=>'fi'
,p_message_text=>'Haku'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111644107849399548)
,p_name=>'SECONDS'
,p_message_language=>'fi'
,p_message_text=>'sekuntia'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111682394483399577)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'fi'
,p_message_text=>'Katso liite'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111740059965399618)
,p_name=>'SELECT_ROW'
,p_message_language=>'fi'
,p_message_text=>'Valitse rivi'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111682097715399577)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'fi'
,p_message_text=>unistr('Poista n\00E4yt\00F6nlukijatila k\00E4yt\00F6st\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111682114117399577)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'fi'
,p_message_text=>unistr('Ota n\00E4yt\00F6nlukijatila k\00E4ytt\00F6\00F6n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111678404943399574)
,p_name=>'SHOW'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4yt\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111741855592399620)
,p_name=>'SHOW_ALL'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4yt\00E4 kaikki')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111767946909399639)
,p_name=>'SIGN_IN'
,p_message_language=>'fi'
,p_message_text=>unistr('Kirjaudu sis\00E4\00E4n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111717549162399602)
,p_name=>'SIGN_OUT'
,p_message_language=>'fi'
,p_message_text=>'Kirjaudu ulos'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111671742080399569)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 p\00E4iv\00E4\00E4 sitten')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111678901399399574)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 p\00E4iv\00E4n kuluttua')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111671606744399569)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'fi'
,p_message_text=>'%0 tuntia sitten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111678812416399574)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'fi'
,p_message_text=>'%0 tunnin kuluttua'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111671598585399569)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'fi'
,p_message_text=>'%0 minuuttia sitten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111678707159399574)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'fi'
,p_message_text=>'%0 minuutin kuluttua'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111671985181399569)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'fi'
,p_message_text=>'%0 kuukautta sitten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111679198328399575)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'fi'
,p_message_text=>'%0 kuukauden kuluttua'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111679367419399575)
,p_name=>'SINCE_NOW'
,p_message_language=>'fi'
,p_message_text=>'Nyt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111671477437399569)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'fi'
,p_message_text=>'%0 sekuntia sitten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111678632810399574)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'fi'
,p_message_text=>'%0 sekunnin kuluttua'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111671823396399569)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'fi'
,p_message_text=>'%0 viikkoa sitten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111679075512399574)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'fi'
,p_message_text=>'%0 viikon kuluttua'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111672040951399569)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'fi'
,p_message_text=>'%0 vuotta sitten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111679258099399575)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'fi'
,p_message_text=>'%0 vuoden kuluttua'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111665529014399565)
,p_name=>'STANDARD'
,p_message_language=>'fi'
,p_message_text=>'Vakio'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111681940776399577)
,p_name=>'START_DATE'
,p_message_language=>'fi'
,p_message_text=>unistr('Alkamisp\00E4iv\00E4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111622458361399532)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4m\00E4 s\00E4hk\00F6postiviesti on l\00E4hetetty interaktiivisten raporttien tilauksesta, jonka on luonut %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111777135067399646)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'fi'
,p_message_text=>'Tilaukset'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111725207870399608)
,p_name=>'TAB'
,p_message_language=>'fi'
,p_message_text=>unistr('V\00E4lilehti')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111644027658399548)
,p_name=>'TITLE'
,p_message_language=>'fi'
,p_message_text=>'Otsikko'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111627042280399536)
,p_name=>'TODAY'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4n\00E4\00E4n')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111681535648399576)
,p_name=>'TOTAL'
,p_message_language=>'fi'
,p_message_text=>unistr('Yhteens\00E4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111628053079399536)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'fi'
,p_message_text=>unistr('Enint\00E4\00E4n %0 saraketta voidaan valita.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111606590434399521)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'fi'
,p_message_text=>unistr('Tiivist\00E4 kaikki')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111606834780399521)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'fi'
,p_message_text=>unistr('Tiivist\00E4 kaikki alle')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111606445116399520)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'fi'
,p_message_text=>'Laajenna kaikki'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111606640964399521)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'fi'
,p_message_text=>'Laajenna kaikki alle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111606971631399521)
,p_name=>'TREE.REPARENT'
,p_message_language=>'fi'
,p_message_text=>unistr('Luo p\00E4\00E4taso uudelleen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111699103245399589)
,p_name=>'TREES'
,p_message_language=>'fi'
,p_message_text=>'Puut'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111742652045399620)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'fi'
,p_message_text=>'Pakollinen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111666225859399565)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'fi'
,p_message_text=>'Luvaton'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111713022740399599)
,p_name=>'UNAVAILABLE'
,p_message_language=>'fi'
,p_message_text=>unistr('Ei k\00E4ytett\00E4viss\00E4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111679746363399575)
,p_name=>'UNKNOWN'
,p_message_language=>'fi'
,p_message_text=>'Tuntematon'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111623311110399533)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'fi'
,p_message_text=>'Tuntematon todennusvirhe.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111625329301399534)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'fi'
,p_message_text=>unistr('Jos et en\00E4\00E4 halua saada s\00E4hk\00F6postiviestej\00E4, voit muokata tilaustasi valitsemalla <a href="%0">peruuta tilaus</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111622357942399532)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'fi'
,p_message_text=>unistr('Jos et en\00E4\00E4 halua saada s\00E4hk\00F6postiviestej\00E4, voit muokata tilaustasi seuraavassa osoitteessa:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111657206155399558)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'fi'
,p_message_text=>unistr('tietotyyppi\00E4 ei tueta')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111645375139399549)
,p_name=>'UPDATE'
,p_message_language=>'fi'
,p_message_text=>unistr('p\00E4ivit\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111643962813399548)
,p_name=>'UPDATED'
,p_message_language=>'fi'
,p_message_text=>unistr('P\00E4ivitetty')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111650663148399553)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'fi'
,p_message_text=>unistr('Pyydetty URL on estetty. Ota yhteytt\00E4 j\00E4rjestelm\00E4nvalvojaan.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111670604703399568)
,p_name=>'USER'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4ytt\00E4j\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111692249714399584)
,p_name=>'USERNAME'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4ytt\00E4j\00E4tunnus')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111731858924399613)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4ytt\00E4j\00E4tunnus on liian pitk\00E4, maksimipituus on %0 merkki\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111677455122399573)
,p_name=>'USERS'
,p_message_language=>'fi'
,p_message_text=>unistr('k\00E4ytt\00E4j\00E4t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111731408888399612)
,p_name=>'USER_EXISTS'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4ytt\00E4j\00E4tunnus on jo olemassa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111746147326399623)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4ytt\00E4j\00E4n %0 profiilikuva')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111633736045399540)
,p_name=>'VALID'
,p_message_language=>'fi'
,p_message_text=>'Sallittu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111627393975399536)
,p_name=>'VALIDATIONS'
,p_message_language=>'fi'
,p_message_text=>'Tarkistukset'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111683071685399577)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'fi'
,p_message_text=>unistr('Arvo on m\00E4\00E4ritett\00E4v\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111726407231399609)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'fi'
,p_message_text=>unistr('Kohteelle %0 on m\00E4\00E4ritett\00E4v\00E4 arvo')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111652945478399555)
,p_name=>'VERTICAL'
,p_message_language=>'fi'
,p_message_text=>'pysty'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111645298156399549)
,p_name=>'VIEW'
,p_message_language=>'fi'
,p_message_text=>unistr('n\00E4yt\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111677538140399573)
,p_name=>'VIEWS'
,p_message_language=>'fi'
,p_message_text=>unistr('n\00E4kym\00E4t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111683855247399578)
,p_name=>'VIEW_ALL'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4yt\00E4 kaikki')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111665023398399564)
,p_name=>'WARNING'
,p_message_language=>'fi'
,p_message_text=>'Varoitus'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111644825020399549)
,p_name=>'WEEK'
,p_message_language=>'fi'
,p_message_text=>'viikko'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111641801643399547)
,p_name=>'WEEKLY'
,p_message_language=>'fi'
,p_message_text=>'Viikoittain'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111644942867399549)
,p_name=>'WEEKS'
,p_message_language=>'fi'
,p_message_text=>'viikkoa'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111683192601399577)
,p_name=>'WELCOME_USER'
,p_message_language=>'fi'
,p_message_text=>'Tervetuloa: %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111681315543399576)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'fi'
,p_message_text=>unistr('Virheellinen arvo l\00F6ydetty, tarkista annetut tiedot.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111681439103399576)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'fi'
,p_message_text=>unistr('Virheellinen arvo l\00F6ydetty, tarkista annetut tiedot.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111624449345399534)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'fi'
,p_message_text=>unistr('Virheellinen p\00E4iv\00E4m\00E4\00E4r\00E4n muoto l\00F6ydetty, tarkista p\00E4iv\00E4m\00E4\00E4r\00E4n muoto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111681261020399576)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'fi'
,p_message_text=>unistr('Virheellinen numeroarvo l\00F6ydetty, tarkista numeron n\00E4ytt\00F6muoto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111633391881399540)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'fi'
,p_message_text=>unistr('Virheellinen aikaleiman arvo l\00F6ydetty, tarkista aikaleiman muoto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111655834708399557)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('Ei voi sitoa kohdetta "%0". K\00E4yt\00E4 monitavuisissa kohteissa lainausmerkkej\00E4 tai varmista, ett\00E4 kohteen pituus on enint\00E4\00E4n 30 tavua. K\00E4yt\00E4 yli 30 tavun mittaisiin kohteisiin viitatessa syntaksia v().')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111646395193399550)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'fi'
,p_message_text=>unistr('Suojaustarkistus %0 esti k\00E4yt\00F6n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111648864741399552)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'fi'
,p_message_text=>unistr('Sovellus ei k\00E4ytett\00E4viss\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111647294546399551)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('ERR-1014 Sovellusta ei l\00F6ydy.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111647333503399551)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('sovellus=%0  ty\00F6tila=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111647762324399551)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4m\00E4n sovelluksen k\00E4ytt\00F6oikeuksia on rajoitettu. Yrit\00E4 my\00F6hemmin uudelleen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111647658347399551)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'fi'
,p_message_text=>unistr('Vain sovelluskehitt\00E4j\00E4t saavat k\00E4ytt\00E4\00E4 t\00E4t\00E4 sovellusta. Yrit\00E4 my\00F6hemmin uudelleen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111646896983399551)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('ERR-7744 Haarasta toimintoon -paluun URL-osoitetta ei voi k\00E4sitell\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111646746876399550)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('ERR-7744 Haarasta toimintoon -paluusivua ei voi k\00E4sitell\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111647049572399551)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('ERR-1430 Sivulta n\00E4ytt\00E4misen kutsuprosessia ei tueta: G_FLOW_STEP_ID (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111648133350399552)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('ERR-1018 Virhe tyhjennett\00E4ess\00E4 vaiheen v\00E4limuistia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111646541784399550)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'fi'
,p_message_text=>'ERR-1005 Tuntematon laskentatyyppi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111647401848399551)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('ERR-1201 Istunnon tunnistetta ei m\00E4\00E4ritetty mukautetun todennuksen yhteydess\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111647594988399551)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'fi'
,p_message_text=>'sivu=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111647163477399551)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('ERR-7620 Sovelluksen ty\00F6tilaa ei voitu m\00E4\00E4ritt\00E4\00E4 (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111629573503399537)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'fi'
,p_message_text=>'Muokkaa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111646296416399550)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'fi'
,p_message_text=>unistr('ERR-1802 Kohteen tunnistetta "%0" ei l\00F6ydy')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111645996695399550)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('ERR-1002 Kohteen tunnistetta ei l\00F6ydy sovelluksen "%1" kohteelle "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111646004379399550)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'fi'
,p_message_text=>unistr('Odottamaton virhe. Kohteen nime\00E4 ei l\00F6ydy sovelluksen tai sivun tasolta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111646421337399550)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('Olet jo tietojen ensimm\00E4isell\00E4 sivulla.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111661936431399562)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'fi'
,p_message_text=>unistr('Tunnistetta (%0) vastaavaa kohdetta ei ole m\00E4\00E4ritetty nykyisell\00E4 sivulla.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111624000791399533)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'fi'
,p_message_text=>unistr('Kohdetta ei voi m\00E4\00E4ritt\00E4\00E4 v\00E4litt\00E4m\00E4ll\00E4 argumentteja sovellukselle.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111624373127399534)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'fi'
,p_message_text=>'(Tarkistussumma-arvo puuttuu)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111623810273399533)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'fi'
,p_message_text=>unistr('Kohteen voi m\00E4\00E4ritt\00E4\00E4, kun siihen liittyy tarkistussumma-arvo "k\00E4ytt\00E4j\00E4tason kirjanmerkki".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111623760917399533)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'fi'
,p_message_text=>unistr('Kohteen voi m\00E4\00E4ritt\00E4\00E4, kun siihen liittyy tarkistussumma-arvo "sovellustason kirjanmerkki".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111623956738399533)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'fi'
,p_message_text=>unistr('Kohteen voi m\00E4\00E4ritt\00E4\00E4, kun siihen liittyy tarkistussumma-arvo "istunto".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111623663920399533)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'fi'
,p_message_text=>'Kohdetta ei ole suojattu.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111648292779399552)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'fi'
,p_message_text=>'Sivulle ei ole saatavana ohjetta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111637327919399543)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'fi'
,p_message_text=>unistr('Ty\00F6tilan %0 k\00E4ytt\00F6oikeudet eiv\00E4t riit\00E4 j\00E4sennykseen rakenteena %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111646668341399550)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('ERR-1010 Haarasta sivulle -hyv\00E4ksynt\00E4k\00E4sittelyn rekursioraja on ylittynyt. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111624201989399534)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4t\00E4 sivua ei voi avata k\00E4ytt\00E4m\00E4ll\00E4 URL-osoitetta tai GET- tai POST-toimintoa n\00E4ytt\00E4misen aliohjelmassa. Se on kutsuttava k\00E4ytt\00E4m\00E4ll\00E4 haaratyyppi\00E4 "Haarasta sivulle".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111700943955399590)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('Virhe yritett\00E4ess\00E4 tallentaa ei-numeerista arvoa kohteelle %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111639065328399545)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'fi'
,p_message_text=>unistr('Sovelluksen j\00E4sennyskaavaa "%0" ei ole tietokannassa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111639102246399545)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'fi'
,p_message_text=>unistr('SIS\00C4ISEN ty\00F6tilan tileill\00E4 voi k\00E4ytt\00E4\00E4 vain tuotetta &PRODUCT_NAME. <a href="%0">Administration Services</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111645862474399550)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'fi'
,p_message_text=>'ERR-1029 Istunnon tietoja ei voi tallentaa. Istunto=%0 kohde=%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111648925933399552)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('J\00E4ljityst\00E4 ei voi pys\00E4ytt\00E4\00E4: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111646103499399550)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'fi'
,p_message_text=>'Odottamaton virhe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111656170825399558)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'fi'
,p_message_text=>'Virhe kohteessa update_substitution_cache: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111649015278399552)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'fi'
,p_message_text=>'Ohjeen tarkastelua varten on annettava sovellus ja sivu.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111669560354399568)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'fi'
,p_message_text=>unistr('Automaatiota ei l\00F6ydy.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111650113328399553)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'fi'
,p_message_text=>'Tuhottu %0 istuntoa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111609455218399523)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'fi'
,p_message_text=>unistr('Koodia %0 ei voi suorittaa! Tietokanta ei tue sit\00E4 tai sit\00E4 ei ole otettu k\00E4ytt\00F6\00F6n instanssiparametrilla MLE_LANGUAGES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111609254583399523)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'fi'
,p_message_text=>unistr('Multi Lingual Engine ei ole k\00E4ytett\00E4viss\00E4 t\00E4ss\00E4 tietokantaversiossa!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111630084032399538)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'fi'
,p_message_text=>unistr('Sovelluskokoelman matriisi ei saa olla tyhj\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111629854897399538)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'fi'
,p_message_text=>unistr('Annettu j\00E4senm\00E4\00E4ritteen numero %0 on virheellinen. M\00E4\00E4ritteen numeron on oltava 1 - %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111630378420399538)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'fi'
,p_message_text=>'Sovelluskokoelma on olemassa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111630135651399538)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'fi'
,p_message_text=>unistr('Kokoelman nimi ei voi olla tyhj\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111630230842399538)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'fi'
,p_message_text=>unistr('Kokoelman nimen maksimipituus on 225 merkki\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111629664183399537)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'fi'
,p_message_text=>'Sovelluskokoelmaa %0 ei ole'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111630448834399538)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'fi'
,p_message_text=>unistr('Kohdistin ei ole viel\00E4 avoinna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111629797994399538)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Sovelluskokoelmassa %1 ei ole j\00E4senj\00E4rjestyst\00E4 %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111629941380399538)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'fi'
,p_message_text=>unistr('Sovelluskokoelmassa "%1" ei ole j\00E4senj\00E4rjestyst\00E4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111701792235399591)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'fi'
,p_message_text=>unistr('Salaustoimintoa "%0" ei tueta t\00E4ss\00E4 j\00E4rjestelm\00E4ss\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111755208523399630)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'fi'
,p_message_text=>unistr('Helppok\00E4ytt\00F6isyys testattu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111649687909399553)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'fi'
,p_message_text=>'Sulje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111649774428399553)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'fi'
,p_message_text=>'Sivun mukautusvalinnat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111649858929399553)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'fi'
,p_message_text=>'Oletus'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111649922398399553)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'fi'
,p_message_text=>unistr('N\00E4ytet\00E4\00E4n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111650043203399553)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'fi'
,p_message_text=>'Piilotettu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111649498724399553)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'fi'
,p_message_text=>unistr('Valitse alueet, jotka haluat sis\00E4llytt\00E4\00E4 t\00E4lle sivulle. Valitut alueet eiv\00E4t ehk\00E4 n\00E4y, jos sovelluskonteksti ei ole oikea tai jos k\00E4ytt\00F6oikeutesi eiv\00E4t riit\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111649593475399553)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4m\00E4 sivu ei ole mukautettava.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111755597514399630)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'fi'
,p_message_text=>unistr('Voit personoida t\00E4m\00E4n sovelluksen ulkoasua vaihtamalla teeman tyyli\00E4. Valitse haluamasi teeman tyyli alla olevasta luettelosta ja valitse K\00E4yt\00E4 muutoksia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111756301223399631)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'fi'
,p_message_text=>unistr('Aluen\00E4ytt\00F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111755409014399630)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4yt\00E4 sovelluksen oletustyyli\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111755305085399630)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'fi'
,p_message_text=>'Ulkoasu '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111698372867399589)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'fi'
,p_message_text=>unistr('Sarakeindeksi\00E4, johon kooste %0 viittaa, ei ole olemassa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111601691373399517)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'fi'
,p_message_text=>'Muoto %0 ei tue CLOB-tulostusta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111698097079399588)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'fi'
,p_message_text=>'Sarakekatkon on oltava sarakematriisin alussa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111698196736399588)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'fi'
,p_message_text=>unistr('Sarakeryhm\00E4n indeksi\00E4, johon %0 viittaa, ei ole olemassa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111615612487399527)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'fi'
,p_message_text=>'vienti'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111620867967399531)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'fi'
,p_message_text=>'Vientimuodon on oltava XML ja tulostuspalvelimen on oltava ORDS.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111698436431399589)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'fi'
,p_message_text=>unistr('Sarakeindeksi\00E4, johon korostus %0 viittaa, ei ole olemassa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111614171870399526)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'fi'
,p_message_text=>'Virheellinen vientimuoto: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111698265113399588)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'fi'
,p_message_text=>unistr('P\00E4\00E4ryhm\00E4n indeksi\00E4, johon %0 viittaa, ei ole olemassa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111723483917399607)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'fi'
,p_message_text=>unistr('Taulukon %0 sarake %1 on aina LUODAAN AINA -tunnistussarake. Tarkista m\00E4\00E4ritysvalintaikkunasta, ettei mit\00E4\00E4n l\00E4hdesaraketta ole m\00E4\00E4ritetty sarakkeeseen %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111640817701399546)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'fi'
,p_message_text=>unistr('M\00E4\00E4ritetty sitoumusv\00E4li on liian lyhyt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111640940265399546)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'fi'
,p_message_text=>unistr('Tietojen lataamista varten ei ole annettu yht\00E4\00E4n saraketta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111642152098399547)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'fi'
,p_message_text=>unistr('Rivin valitsinta "%0" vastaavia sarakkeita ei l\00F6ytynyt. Kokeile automaattista tunnistusta tai tarkista JSON-rakenne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111650478523399553)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'fi'
,p_message_text=>unistr('XLSX-tiedostossa ei ole ty\00F6alustoja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111650362463399553)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'fi'
,p_message_text=>unistr('M\00E4\00E4ritetty\00E4 ty\00F6alustaa ei ole XLSX-tiedostossa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111630547454399538)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'fi'
,p_message_text=>unistr('Tietokannan tietojen nykyinen versio on muuttunut sen j\00E4lkeen, kun k\00E4ytt\00E4j\00E4 k\00E4ynnisti p\00E4ivitysprosessin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111632970091399540)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'fi'
,p_message_text=>unistr('Virhe p\00E4ivitett\00E4ess\00E4 raportin sarakkeita: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111737642376399617)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'fi'
,p_message_text=>'Kohdetta %0 ei voi muuntaa kohteeksi SDO_GEOMETRY.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111677117565399573)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'fi'
,p_message_text=>unistr('Sarakkeen %0 tietotyyppi on %1, eik\00E4 sit\00E4 voi muuntaa tyypiksi VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111684125268399578)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'fi'
,p_message_text=>unistr('M\00E4\00E4ritteelle "%1" m\00E4\00E4ritetty\00E4 saraketta "%0" ei l\00F6ytynyt tietol\00E4hteest\00E4!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111625417890399534)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'fi'
,p_message_text=>unistr('Suodatintyyppi\00E4 %0 ei tueta moniarvosarakkeille.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111741042291399619)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'fi'
,p_message_text=>unistr('Virheellinen "v\00E4lill\00E4"-suodatin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111607543086399521)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'fi'
,p_message_text=>unistr('M\00E4\00E4ritetty LOV-tyyppi on virheellinen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111607490393399521)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'fi'
,p_message_text=>unistr('Virheellinen kyselytyyppi. Sallittuja kyselytyyppej\00E4 ovat Taulukko, SQL-kysely tai PL/SQL-funktio, joka palauttaa SQL-kyselyn.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111677273874399573)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SQL-kysely\00E4 ei voitu j\00E4sent\00E4\00E4!'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111684241023399578)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'fi'
,p_message_text=>unistr('M\00E4\00E4ritteelle "%1" m\00E4\00E4ritetty\00E4 sarakekohtaa %0 ei l\00F6ytynyt SQL-lauseesta!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111606070351399520)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'fi'
,p_message_text=>'Moniarvoisessa suodattimessa on liian monta kohdetta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111684028186399578)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'fi'
,p_message_text=>unistr('M\00E4\00E4ritteelle "%0" ei ole m\00E4\00E4ritetty yht\00E4\00E4n saraketta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111607379618399521)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'fi'
,p_message_text=>'PL/SQL-funktion runko ei palauttanut arvoa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111697202075399588)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'fi'
,p_message_text=>unistr('REST-tietol\00E4hde ei sis\00E4ll\00E4 ty\00F6vaihetta pyydetyn DML-toiminnon k\00E4sittelyyn.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111603264116399518)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'fi'
,p_message_text=>unistr('Muunnos GeoJSON-muodosta SDO_GEOMETRY-muotoon (sarake %0) ei ole k\00E4ytett\00E4viss\00E4 t\00E4ss\00E4 tietokannassa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111604344202399519)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'fi'
,p_message_text=>unistr('SDO_GEOMETRY-muunnosta (sarake %0) ei tueta XML-tietol\00E4hteille.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111611601139399524)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'fi'
,p_message_text=>unistr('Merkki\00E4 %0 ei tueta usean arvon erottimena.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111738937945399618)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4t\00E4 funktiota ei voi k\00E4ytt\00E4\00E4 kyselykontekstissa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111604412697399519)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'fi'
,p_message_text=>unistr('Sarakkeen tietotyypit eiv\00E4t vastaa toisiaan.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111607225567399521)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'fi'
,p_message_text=>unistr('Sis\00E4isen ORDS OUT -sidoksen rajat ovat ylittyneet. V\00E4henn\00E4 DML-rivien m\00E4\00E4r\00E4\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111685029701399579)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Et\00E4palvelimen JSON-vastausta ei voitu j\00E4sent\00E4\00E4: '),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111607167392399521)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('Tuntematon tai v\00E4\00E4r\00E4 kontekstityyppi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111701605893399591)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'fi'
,p_message_text=>unistr('J\00E4sent\00E4j\00E4 ei tue t\00E4t\00E4 tiedostotyyppi\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111656260749399558)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4ytt\00F6oikeutta ei ole (wwv_flow_api.set_credentials on m\00E4\00E4ritt\00E4m\00E4tt\00E4).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111633241101399540)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'fi'
,p_message_text=>unistr('Ty\00F6tilaa ei luotu, koska se on jo olemassa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111633192362399540)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4ytt\00E4j\00E4ryhm\00E4\00E4 ei luotu, koska se on jo olemassa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111643404948399548)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4ytt\00E4j\00E4tunnukselle %0 l\00F6ytyi kaksoiskappale.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111643583830399548)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('Virhe ladattaessa k\00E4ytt\00E4ji\00E4. Virhe k\00E4ytt\00E4j\00E4n %0 kohdalla.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111653416026399556)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'fi'
,p_message_text=>unistr('%0 k\00E4ytt\00E4j\00E4\00E4 olisi ladattu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111653223754399555)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'fi'
,p_message_text=>'Salasana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111653377786399556)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4ytt\00F6oikeudet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111653000467399555)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4ytt\00E4j\00E4tunnus')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111729512439399611)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'fi'
,p_message_text=>'Virhe sivukohteen #COMPONENT_NAME# muodostuksessa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111649134015399552)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('Sivukohdetta ei voi n\00E4ytt\00E4\00E4, koska HTML-lomaketta ei ole viel\00E4 avattu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111614476507399526)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'fi'
,p_message_text=>'Virhe laskettaessa sivukohteen #COMPONENT_NAME# oletusarvoa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111648436662399552)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('Virhe sivukohteen #COMPONENT_NAME# j\00E4lkilaskennassa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111648386256399552)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('Virhe laskettaessa sivukohteen #COMPONENT_NAME# l\00E4hteen arvoa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111628104199399536)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'fi'
,p_message_text=>unistr('K\00E4ytt\00F6oikeutta ei ole.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111648680201399552)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'fi'
,p_message_text=>'Ei JavaScript-tukea.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111648718889399552)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'fi'
,p_message_text=>'Luettelo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111649355231399552)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'fi'
,p_message_text=>unistr('Kysely\00E4 ei voi alustaa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111656531682399558)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('Kohteen %0 p\00E4ivityst\00E4 ei tueta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111650706356399554)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'fi'
,p_message_text=>'Virheellinen kohteen tunniste: %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111677053345399573)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4lle kohteelle ei ole ohjetta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111641549078399546)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'fi'
,p_message_text=>unistr('Kaaviokyselyn luonti ep\00E4onnistui. Tarkista l\00E4hteen ja sarakkeiden m\00E4\00E4rityksen asetukset.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111736311542399616)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'fi'
,p_message_text=>unistr('Liitetiedoston koko %0 Mt ylitt\00E4\00E4 liitetiedostojen maksimikoon %1 Mt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111642434646399547)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'fi'
,p_message_text=>'Virheellinen arvo parametrille p_mail_id: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111759891095399633)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'fi'
,p_message_text=>unistr('Olet ylitt\00E4nyt s\00E4hk\00F6postiviestien ty\00F6tilakohtaisen maksimim\00E4\00E4r\00E4n. Ota yhteytt\00E4 j\00E4rjestelm\00E4nvalvojaan.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111623416408399533)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4m\00E4 aliohjelma on k\00E4ynnistett\00E4v\00E4 sovellusistunnosta k\00E4sin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111642356037399547)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'fi'
,p_message_text=>unistr('Tyhj\00E4 arvo on m\00E4\00E4ritetty parametrille %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111696329845399587)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'fi'
,p_message_text=>unistr('S\00E4hk\00F6postimallia "%0" ei l\00F6ydy sovelluksesta %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111772824340399643)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'fi'
,p_message_text=>unistr('S\00E4hk\00F6postiviestien l\00E4hett\00E4minen vaatii instanssiparametrin SMTP_HOST_ADDRESS m\00E4\00E4ritt\00E4mist\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111642023247399547)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'fi'
,p_message_text=>unistr('M\00E4\00E4rit\00E4 viestin vastaanottaja s\00E4hk\00F6postin l\00E4hetyst\00E4 varten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111762290600399635)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'fi'
,p_message_text=>unistr('SMTP-yhteytt\00E4 ei voi muodostaa m\00E4\00E4ritetyll\00E4 s\00E4hk\00F6postipalvelimella.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111736444983399616)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'fi'
,p_message_text=>'Virheellinen Ajax-kutsu!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111627836726399536)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'fi'
,p_message_text=>unistr('Liit\00E4nn\00E4iselle %0 ei ole m\00E4\00E4ritetty Ajax-toimintoa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111726820059399609)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'fi'
,p_message_text=>unistr('Liit\00E4nn\00E4iselle %0 ei ole m\00E4\00E4ritetty suoritustoimintoa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111627914126399536)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'fi'
,p_message_text=>unistr('Liit\00E4nn\00E4iselle %0 ei ole m\00E4\00E4ritetty muodostustoimintoa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111737397966399616)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'fi'
,p_message_text=>unistr('REST-tietol\00E4hteen liit\00E4nn\00E4inen "%0" ei sis\00E4ll\00E4 Ominaisuudet-toimintoa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111737261574399616)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'fi'
,p_message_text=>unistr('REST-tietol\00E4hteen liit\00E4nn\00E4inen "%0" ei sis\00E4ll\00E4 DML-toimintoa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111737407623399617)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'fi'
,p_message_text=>unistr('REST-tietol\00E4hteen liit\00E4nn\00E4inen "%0" ei sis\00E4ll\00E4 suoritustoimintoa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111737542591399617)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'fi'
,p_message_text=>unistr('REST-tietol\00E4hteen liit\00E4nn\00E4inen "%0" ei sis\00E4ll\00E4 noutotoimintoa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111625696643399535)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('Virhe liit\00E4nn\00E4isen k\00E4sittelyn yhteydess\00E4 ilmenneess\00E4 PLSQL-koodissa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111632215065399539)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'fi'
,p_message_text=>unistr('Arvo on m\00E4\00E4ritett\00E4v\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111662883059399563)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'fi'
,p_message_text=>unistr('Tietotyyppi\00E4 %0 ei voi muuntaa tyypiksi VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111748486636399625)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'fi'
,p_message_text=>unistr('M\00E4\00E4ritteelle "%1" m\00E4\00E4ritetty\00E4 saraketta "%0" ei l\00F6ytynyt SQL-lauseesta!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111724724401399608)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'fi'
,p_message_text=>unistr('Kohteelle %0 on m\00E4\00E4ritett\00E4v\00E4 valintaluettelo (LOV) -kysely tai nimetty valintaluettelo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111726394920399609)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'fi'
,p_message_text=>unistr('Kohteen %0 LOV-SQL-kyselyss\00E4 valittu sarakem\00E4\00E4r\00E4 on virheellinen. Tutustu sallittuihin esimerkkilauseisiin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111748280853399625)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'fi'
,p_message_text=>unistr('M\00E4\00E4ritteelle "%0" ei ole m\00E4\00E4ritetty yht\00E4\00E4n saraketta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111777997010399646)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'fi'
,p_message_text=>unistr('M\00E4\00E4ritteelle "%1" annettu arvo %0 ei ole numero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111729874520399611)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'fi'
,p_message_text=>unistr('Kohteen %0 SQL-lauseessa on v\00E4\00E4r\00E4 tietotyyppi. Sarake nro %1 on %2, mutta odotettu arvo on %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111748358679399625)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'fi'
,p_message_text=>unistr('M\00E4\00E4ritteelle "%1" m\00E4\00E4ritetyn sarakkeen "%0" tietotyyppi on %2, vaikka sen pit\00E4isi olla %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111624937826399534)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'fi'
,p_message_text=>unistr('Raportin asettelua ei l\00F6ydy.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111684964785399579)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'fi'
,p_message_text=>unistr('Summan laskutoimintoa ei voi k\00E4ytt\00E4\00E4 REST-tietol\00E4hteeseen perustuvissa raporteissa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111648501567399552)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'fi'
,p_message_text=>unistr('ERR-2904 Pikavalinnan arvon m\00E4\00E4ritys ei onnistu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111652869754399555)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'fi'
,p_message_text=>'Virhe: tuntematon pikavalintatyyppi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111642826582399547)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'fi'
,p_message_text=>'Todennuskaavaa ei voi hakea sovelluksessa %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111716321472399602)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4m\00E4 asiakkaan tunniste on jo olemassa nykyisess\00E4 istunnossa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111653190053399555)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'fi'
,p_message_text=>unistr('S\00E4hk\00F6postiosoite')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111777351505399646)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'fi'
,p_message_text=>unistr('Todennus ep\00E4onnistui.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111679645836399575)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'fi'
,p_message_text=>unistr('Ainakin yksi kohteessa apex_util.g_request_cookies asetetuista ev\00E4steist\00E4 sis\00E4lt\00E4\00E4 virheellisen arvon.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111662144392399562)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'fi'
,p_message_text=>'UDDI-rekisterin vastaus oli virheellinen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111625717972399535)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'fi'
,p_message_text=>'Annettu URL ei palauttanut kelvollista WSDL-asiakirjaa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111628211252399536)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'fi'
,p_message_text=>unistr('WSDL-asiakirjassa on useita SOAP-sidoksia. &PRODUCT_NAME. tukee vain sellaisia WSDL-asiakirjoja, joissa on yksi SOAP-sidos. Voit jatkaa viitteen luomista t\00E4lle palvelulle valitsemalla Luo verkkopalvelun viite manuaalisesti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111696661030399587)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'fi'
,p_message_text=>'Palvelun vastaus ei ollut XML-muodossa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111777282978399646)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'fi'
,p_message_text=>unistr('OAuth-k\00E4ytt\00F6oikeustietue puuttuu tai se on vanhentunut.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111740490038399619)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'fi'
,p_message_text=>unistr('Olet ylitt\00E4nyt web-palvelupyynt\00F6jen ty\00F6tilakohtaisen maksimim\00E4\00E4r\00E4n. Ota yhteytt\00E4 j\00E4rjestelm\00E4nvalvojaan.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111777432740399646)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'fi'
,p_message_text=>'Palvelimen vastaus oli OAuth-varaustunnus, jota ei tueta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111627615172399536)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'fi'
,p_message_text=>unistr('WSDL-asiakirjasta puuttui viitteen lis\00E4\00E4miseen vaadittava SOAP-sidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111623513728399533)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4m\00E4 WSDL edellytt\00E4\00E4 todennusvaltuuksia. Anna seuraavassa k\00E4ytt\00E4j\00E4tunnus ja salasana.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111632327905399539)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'fi'
,p_message_text=>unistr('Muodostusohjelma ei voinut k\00E4sitell\00E4 WSDL-asiakirjaa. Voit jatkaa viitteen luomista t\00E4lle palvelulle valitsemalla Luo verkkopalvelun viite manuaalisesti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111699291793399589)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'fi'
,p_message_text=>unistr('P\00E4ivityst\00E4 ei voi k\00E4sitell\00E4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111725015210399608)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'fi'
,p_message_text=>unistr('Valintaluettelon palautus- ja n\00E4ytt\00F6sarakkeet ovat sama sarake!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111724961185399608)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'fi'
,p_message_text=>'Valintaluettelossa ei ole palautussaraketta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111656476205399558)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'fi'
,p_message_text=>'Virhe haettaessa sarakkeen arvoa: %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111680471805399575)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'fi'
,p_message_text=>unistr('Nykyiset taulukkomuotoiset tiedot ovat liian vanhoja; l\00E4hdetietoja on muokattu.<br/> Voit hyl\00E4t\00E4 tekem\00E4si muutokset ja ladata tiedot uudelleen tietokannasta napsauttamalla <strong><a href="%0">t\00E4t\00E4</a></strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111638537877399544)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'fi'
,p_message_text=>unistr('Virhe m\00E4\00E4ritett\00E4ess\00E4 sivutuksen merkkijonoa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111638465459399544)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('kyselyn otsikoita ei voi m\00E4\00E4ritt\00E4\00E4:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111638670518399544)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'fi'
,p_message_text=>'virhe suoritettaessa raportin loppuviitteen korvauksia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111638715137399544)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SQL-kysely\00E4 ei voitu j\00E4sent\00E4\00E4:'),
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111643744733399548)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'fi'
,p_message_text=>unistr('Pienin pyydetty rivi: %0, n\00E4ytt\00E4m\00E4tt\00F6m\00E4t l\00F6ydetyt rivit: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111641269351399546)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'fi'
,p_message_text=>unistr('kyselyn sarake #%0 (%1) on virheellinen: HTML:\00E4\00E4 k\00E4ytt\00E4vill\00E4 sarakkeilla on oltava aliasnimet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111656349110399558)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'fi'
,p_message_text=>'Virhe haettaessa kyselyn tuloksia: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111638802322399544)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'raportoi virhe:',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111676588926399573)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'fi'
,p_message_text=>unistr('Lajittele t\00E4m\00E4n sarakkeen mukaan')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111641379978399546)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'fi'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Kysely\00E4 ei voi j\00E4sent\00E4\00E4. Tarkista kyselyn syntaksi.'),
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111680562994399576)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'fi'
,p_message_text=>unistr('T\00E4ss\00E4 lomakkeessa on tallentamattomia muutoksia. Valitse Ok, jos haluat jatkaa tallentamatta muutoksia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111684835702399579)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'fi'
,p_message_text=>unistr('Raportin sivutuskaavaa (%0) ei tueta valitun tietol\00E4hteen kanssa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111641192117399546)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'fi'
,p_message_text=>unistr('kyselyn sarake #%0 (%1) on virheellinen, k\00E4yt\00E4 sarakkeen aliasta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111643852976399548)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'fi'
,p_message_text=>unistr('rivit %0 - %1 yli %2 rivist\00E4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111682544777399577)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'fi'
,p_message_text=>'%0 - %1 yli %2 kohteesta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111643622641399548)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'fi'
,p_message_text=>'%0 - %1 / %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111627559249399536)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'fi'
,p_message_text=>'%0 - %1 / %2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111638967635399544)
,p_name=>'Y'
,p_message_language=>'fi'
,p_message_text=>'K'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111645033901399549)
,p_name=>'YEAR'
,p_message_language=>'fi'
,p_message_text=>'vuosi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111638135870399544)
,p_name=>'YEARS'
,p_message_language=>'fi'
,p_message_text=>'vuotta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111680678570399576)
,p_name=>'YES'
,p_message_language=>'fi'
,p_message_text=>unistr('Kyll\00E4')
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4541)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4541)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>unistr('Ty\00F6p\00F6yt\00E4')
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4541
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4541)
,p_name=>'Viestit'
,p_alias=>'MESSAGES'
,p_step_title=>'Viestit'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
