prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4497
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4497 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4497
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116102049625403567')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'fr-ca'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4497)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113350'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4497)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4497)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4497)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4497)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4497)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4497)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4497)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4497)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4497)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4497)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4497)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4497)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4497)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.fr-ca'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4497
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4497)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4497)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4497)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4497)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4497)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4497)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4497)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.fr-ca'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4497
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4497)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4497)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4497)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4497)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4497)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4497)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4497)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.fr-ca'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4497
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4497)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4497)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4497)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4497)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4497)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4497)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4497)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4497)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4497)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4497)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4497)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4497)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4497)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4497)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4497)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4497)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4497)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.fr-ca'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4497
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4497)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4497)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4497)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4497)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4497)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4497)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4497)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4497)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4497)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4497)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4497)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4497)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4497)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4497)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4497)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.fr-ca'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4497
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4497)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4497)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4497)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4497)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4497)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4497)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4497)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4497)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4497)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4497)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4497)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4497)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4497)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4497)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4497)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.fr-ca'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4497
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4497)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4497)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4497)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4497)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4497)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4497)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4497)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4497)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4497)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4497)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4497)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4497)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4497)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4497)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4497)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.fr-ca'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4497
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4497)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4497)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4497)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4497)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4497)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4497)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4497)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4497)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4497)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4497)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4497)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4497)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4497)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4497)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4497)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4497
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4497)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4497
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4497)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4497
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4497)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4497
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4497)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4497
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4497)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4497
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4497)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4497
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4497)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4497)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4497)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4497)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4497)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4497)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4497)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4497)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4497)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4497)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4497)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4497)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4497)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4497)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4497)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4497)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4497)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4497)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4497)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4497)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4497)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4497)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4497)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4497)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4497)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4497)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4497)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4497
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4497)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4497)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4497)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4497)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4497)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4497)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4497)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4497)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4497)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4497
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4497)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4497)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4497)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4497)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4497)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4497)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4497)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4497)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4497)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4497)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4497)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4497)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4497)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4497)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4497)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4497)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4497)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4497)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4497)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4497)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4497)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4497)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4497)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4497)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4497)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4497
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4497)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4497)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4497)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4497)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4497)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4497)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4497)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4497)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4497)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4497)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4497)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4497)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4497)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4497)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4497)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4497)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4497)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4497)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4497)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4497
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4497)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4497)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4497)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4497)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4497)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4497
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4497)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4497)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4497)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4497)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4497)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4497)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4497)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4497)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4497)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4497)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4497)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4497)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4497)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4497
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4497)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4497)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4497)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4497)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4497)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4497
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4497)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4497)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4497)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4497)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4497)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4497
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4497)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4497)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4497)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4497)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4497)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4497)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4497)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4497)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4497)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4497
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4497)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4497)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4497)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4497)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4497)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4497)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4497)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4497)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4497)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4497)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4497)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4497)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4497)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4497)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4497)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4497)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4497)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4497)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4497)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4497)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4497)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4497)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4497)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4497)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4497)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4497)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4497)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4497
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4497)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4497)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4497)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4497)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4497)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4497
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4497)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4497
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4497)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4497
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4497)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4497
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4497)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4497
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4497)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4497
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4497)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4497
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4497)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4497
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4497)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4497
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4497)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4497
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4497)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4497
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4497)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4497
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4497)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4497
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4497)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4497
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4497)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4497
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4497)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4497
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4497)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4497
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4497)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4497
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4497)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4497
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4497)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4497
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4497)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4497
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4497)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4497
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4497)
,p_page_name=>'winlov'
,p_page_title=>unistr('Bo\00EEte de dialogue de recherche')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>'Rechercher'
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>'Fermer'
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>'Suivant &gt;'
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>unistr('&lt; Pr\00E9c\00E9dent')
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4497
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4497)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4497
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4497)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4497)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4497)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4497)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4497)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4497)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4497)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4497)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4497)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4497)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4497)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4497)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4497)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4497)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4497)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4497)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4497)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4497)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4497)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4497)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4497)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4497)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4497)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4497)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4497)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4497)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4497)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4497)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4497)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4497)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4497)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4497)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4497)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4497)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4497)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4497)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4497)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4497)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4497)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4497)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4497)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4497)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4497)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4497)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4497)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4497)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4497)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4497)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4497)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4497)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4497)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4497)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4497)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4497)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4497)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4497)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4497)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4497)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4497)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4497)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4497)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4497)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4497)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4497)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4497)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4497)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4497)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4497)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4497)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4497)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4497)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4497)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4497)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4497)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4497)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4497)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4497)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4497)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4497)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4497)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4497)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4497)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4497)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4497)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4497)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4497)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4497)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4497)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4497)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4497)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4497)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4497)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4497)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4497)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4497)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4497)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4497)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4497)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4497)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4497)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4497)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4497)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4497)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4497)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4497)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4497)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4497)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4497)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4497)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4497)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4497)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4497)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4497)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4497)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4497)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4497)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4497)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4497)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4497)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4497)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4497)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4497)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4497)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4497)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4497)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4497)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4497)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4497)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4497)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4497)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4497)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4497)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4497)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4497)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4497)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4497)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4497)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4497)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4497)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4497)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4497)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4497)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4497)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4497)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4497)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4497)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4497)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4497)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4497)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4497)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4497)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4497)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4497)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4497)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4497)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4497)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4497)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4497)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4497)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4497)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4497)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4497)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4497)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4497)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4497)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4497)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4497)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4497)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4497)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4497)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4497)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4497)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4497)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4497)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4497)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4497)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4497)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4497)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4497)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4497)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4497)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4497)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4497)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4497)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4497)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4497)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4497)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4497)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4497)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4497)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4497)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4497)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4497)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4497)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4497)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4497)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4497)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4497)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4497)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4497)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4497)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4497)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4497)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4497)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4497)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4497)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4497)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4497)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4497)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4497)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4497)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4497)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4497)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4497)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4497)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4497)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4497)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4497)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4497)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4497)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4497)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4497)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4497)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4497)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4497)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4497)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4497)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4497)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4497)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4497)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4497)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4497)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4497)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4497)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4497)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4497)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4497)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4497)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4497)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4497)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4497)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111993607641399818)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'fr-ca'
,p_message_text=>'Colonne %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111980787927399807)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'fr-ca'
,p_message_text=>'Administrateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111980642564399807)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'fr-ca'
,p_message_text=>'Nom d''utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112037993263399851)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Acc\00E8s refus\00E9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111997627118399821)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Votre compte %0 a \00E9t\00E9 cr\00E9\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111983267863399809)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le compte est verrouill\00E9.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111973147373399802)
,p_name=>'AM_PM'
,p_message_language=>'fr-ca'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112107530519399901)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Activer/d\00E9sactiver %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112115655339399907)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'fr-ca'
,p_message_text=>'(Actif)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112085193258399885)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''appel Ajax a retourn\00E9 une erreur de serveur %0 pour %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112015926635399835)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''alias d''application "%0" ne peut pas \00EAtre converti en ID d''application unique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112016043279399835)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'fr-ca'
,p_message_text=>'L''application portant l''alias "%0" n''existe pas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112005657777399827)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>'ERR-1816 Erreur inattendue lors de la conversion de l''alias d''application p_flow_alias_or_id (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112098584182399895)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La somme de contr\00F4le d''une application permet de voir facilement si la m\00EAme application est d\00E9ploy\00E9e dans plusieurs espaces de travail. Vous pouvez comparer cette somme de contr\00F4le pour d\00E9terminer s''il y a une correspondance. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111991430791399817)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>'Erreur lors du traitement de la fonction d''authentification.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111976895367399805)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>'Erreur lors du traitement de la fonction d''authentification.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112140362443399925)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le nom de locataire %0 retourn\00E9 par Oracle Cloud Identity Management n''est pas autoris\00E9 pour le domaine %1.<br/><a href="&LOGOUT_URL.">Reconnectez-vous</a>, puis indiquez un nom de locataire autoris\00E9 ou modifiez l''URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111974502802399803)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le compte "%0" ne dispose pas des privil\00E8ges de d\00E9veloppement n\00E9cessaires (DB_DEVELOPER ou DB_ADMINISTRATOR)<br/>pour l''espace de travail "%1". <a href="&LOGOUT_URL.">Reconnectez-vous</a> une fois les privil\00E8ges obtenus.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111973610475399802)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le nom de locataire retourn\00E9 par Oracle Cloud Identity Management n''est pas autoris\00E9 pour l''espace de travail courant.<br/><a href="&LOGOUT_URL.">Reconnectez-vous</a> et sp\00E9cifiez un nom de locataire autoris\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111974683147399803)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Pour des raisons de s\00E9curit\00E9, l''ex\00E9cution des applications de cet espace de travail au moyen du domaine de l''URL n''est pas autoris\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111991144084399817)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Demandez \00E0 votre administrateur de base de donn\00E9es d''ex\00E9cuter $OH/rdbms/admin/catldap.sql.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111991096030399816)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'fr-ca'
,p_message_text=>'L''ensemble SYS.DBMS_LDAP n''existe pas ou n''est pas valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111990939605399816)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>'Erreur lors du traitement de la fonction de modification de  l''utilisateur LDAP.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111991261666399817)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>'Erreur lors du traitement de l''authentification LDAP.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111992024660399817)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Erreur dans l''argument p_flow_page pour la proc\00E9dure login_page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111991660207399817)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'fr-ca'
,p_message_text=>'Argument p_session non valide dans wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112039508646399852)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'fr-ca'
,p_message_text=>'Argument incorrect pour wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111991734938399817)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Nom d''utilisateur nul transmis \00E0 la proc\00E9dure de connexion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111980570328399807)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'fr-ca'
,p_message_text=>'Patientez pendant <span id="apex_login_throttle_sec">%0</span> secondes avant de vous reconnecter.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111981854136399808)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La tentative de connexion a \00E9t\00E9 bloqu\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112037376174399850)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'fr-ca'
,p_message_text=>'Authentification "%0" introuvable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111982121309399808)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''ID groupe de s\00E9curit\00E9 est nul.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111991558560399817)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Erreur lors de l''ex\00E9cution du processus de post-authentification.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111991371122399817)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Erreur lors du traitement du processus de pr\00E9-authentification.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111992533581399818)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ouvrez l''URL dans le navigateur que vous avez utilis\00E9 pour lancer la demande de r\00E9initialisation de mot de passe. Si vous cliquez sur l''URL de r\00E9initialisation de mot de passe et que vous \00EAtes redirig\00E9 vers la page de connexion, lancez \00E0 nouveau la r')
||unistr('\00E9initialisation du mot de passe et laissez le navigateur ouvert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112137867656399923)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('URL de r\00E9initialisation du mot de passe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111974841082399803)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le %0 de groupe de consommateurs Gestionnaire de ressources n''a pas \00E9t\00E9 accord\00E9 \00E0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111974977973399803)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Utilisez DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP pour accorder le privil\00E8ge manquant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112002909080399825)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>'Erreur lors du traitement de la fonction de drapeau de session.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112003080433399825)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Erreur lors du traitement de la fonction de v\00E9rification de session.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112003260709399826)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Demandez \00E0 l''administrateur %0 de configurer le moteur pour l''authentification unique pour Oracle Application Server.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112012778481399832)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 non valide dans le jeton %1 retourn\00E9 par l''authentification unique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111991980805399817)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Modifiez le mod\00E8le d''authentification et ajoutez le nom de l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112012447035399832)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Appelant de la proc\00E9dure %0 non valide :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112012631636399832)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'fr-ca'
,p_message_text=>'Session d''application non valide dans le jeton URLC : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112012205608399832)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'fr-ca'
,p_message_text=>'Erreur dans portal_sso_redirect : informations d''enregistrement d''application manquantes :'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112003130663399826)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'fr-ca'
,p_message_text=>'L''ensemble WWSEC_SSO_ENABLER_PRIVATE n''existe pas ou n''est pas valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111991828075399817)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Impossible de trouver le nom de l''application de partenaire enregistr\00E9 dans le mod\00E8le d''authentification.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112012371026399832)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Enregistrez cette application comme indiqu\00E9 dans le guide d''installation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112003311302399826)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>'Erreur lors du traitement de l''authentification unique.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112112704578399905)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('URL non autoris\00E9e : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112002786913399825)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>'Erreur lors du traitement de l''authentification.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111974737485399803)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'fr-ca'
,p_message_text=>'L''espace de travail "%0" est inactif. Communiquez avec l''administrateur.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111975165101399803)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'fr-ca'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111981596677399808)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Acc\00E8s refus\00E9 par le contr\00F4le de s\00E9curit\00E9 de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111981683653399808)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Acc\00E8s refus\00E9 par le contr\00F4le de s\00E9curit\00E9 de la page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111981706082399808)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>'Erreur lors du traitement de l''autorisation.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112045158254399856)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Cr\00E9\00E9 avec %0 \00E0 l''aide de %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112045205057399856)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'fr-ca'
,p_message_text=>'amour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112103055326399898)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Description de l''\00E9v\00E9nement')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112102833208399898)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'fr-ca'
,p_message_text=>'Date de fin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112103127103399898)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('ID \00E9v\00E9nement')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112102728528399898)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Date de d\00E9but')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112102903813399898)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Titre de l''\00E9v\00E9nement')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111993576009399818)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Erreur de contenu de somme de contr\00F4le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111993491701399818)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Erreur de format de somme de contr\00F4le')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112057426700399865)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Copi\00E9 dans le presse-papiers.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112057121088399865)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ce navigateur ne prend pas en charge la copie \00E0 partir d''un bouton ou d''un menu. Essayez Ctrl+C ou Commande+C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112045670531399856)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'fr-ca'
,p_message_text=>'Fermer l''avis'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112101672412399897)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'fr-ca'
,p_message_text=>'Contraste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112096174168399893)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'fr-ca'
,p_message_text=>'Courant'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112096011136399893)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'fr-ca'
,p_message_text=>'Initial'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112100201433399896)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La valeur pour #LABEL# doit \00EAtre une couleur valide. Exemple : %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112095903599399893)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Choisir une couleur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112096227310399893)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Modifier le format de couleur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112135459688399921)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'fr-ca'
,p_message_text=>'Liste de valeurs'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112135559239399922)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'fr-ca'
,p_message_text=>'Ouvrir la liste pour : %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112115723965399907)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('(Termin\00E9)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112008063529399829)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'fr-ca'
,p_message_text=>'Communiquez avec l''administrateur de l''application.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112022461361399839)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Communiquez avec l''administrateur de l''application.',
unistr('Les d\00E9tails de cet incident sont disponibles au moyen de l''ID d\00E9bogage "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112100597082399896)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'fr-ca'
,p_message_text=>'Corrigez les erreurs avant d''enregistrer.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112046562079399857)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 correspondances trouv\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112046427389399857)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aucune correspondance n''a \00E9t\00E9 trouv\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112116282523399908)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'fr-ca'
,p_message_text=>'Progression courante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112100973474399897)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le fichier sp\00E9cifi\00E9 dans l''\00E9l\00E9ment %0 n''existe pas dans APEX_APPLICATION_TEMP_FILES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112089429193399888)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La version courante des donn\00E9es dans la base de donn\00E9es a chang\00E9 depuis le lancement de la mise \00E0 jour par l''utilisateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112058592742399866)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'fr-ca'
,p_message_text=>'Ne pas charger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112105568593399900)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Erreur de pr\00E9traitement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112105324684399900)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ins\00E9rer une rang\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112119419895399910)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9quence : Action')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112105465934399900)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Mettre \00E0 jour la rang\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112046965379399857)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'fr-ca'
,p_message_text=>'Calendrier contextuel : %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111969576427399799)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'fr-ca'
,p_message_text=>'Suivant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111969623628399799)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112105784573399900)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Une valeur doit \00EAtre indiqu\00E9e pour #LABEL#.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112105611545399900)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La valeur pour #LABEL# doit \00EAtre une date valide, par exemple %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111973270291399802)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La valeur de #LABEL# doit \00EAtre comprise entre %0 et %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111973388195399802)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La valeur de #LABEL# doit \00EAtre identique ou post\00E9rieure \00E0 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111973487550399802)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La valeur de #LABEL# doit \00EAtre identique ou ant\00E9rieure \00E0 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112050498919399860)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La valeur #LABEL# est post\00E9rieure \00E0 la date maximale indiqu\00E9e %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112050860799399860)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'fr-ca'
,p_message_text=>'#LABEL# ne correspond pas au format %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112050383595399860)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La valeur #LABEL# est ant\00E9rieure \00E0 la date minimale indiqu\00E9e %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112050565454399860)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'fr-ca'
,p_message_text=>'La valeur #LABEL# ne figure pas dans l''intervalle valide compris entre %0 et %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112050742058399860)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La valeur #LABEL# ne figure pas dans l''intervalle d''ann\00E9es valide compris entre %0 et %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112100843587399897)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'fr-ca'
,p_message_text=>'Annuler'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112128049570399916)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'fr-ca'
,p_message_text=>'Fermer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112130048959399918)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'fr-ca'
,p_message_text=>'Aide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112100629129399896)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'fr-ca'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112100758815399897)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'fr-ca'
,p_message_text=>'Enregistrer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112006949281399828)
,p_name=>'APEX.ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>'Erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111974348243399803)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''erreur suivante est survenue lors de l''ex\00E9cution du rappel de traitement d''erreur : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111983047114399809)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>'Erreur lors de l''affichage de la page d''erreur : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111975034034399803)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'fr-ca'
,p_message_text=>'Erreur interne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112114825831399907)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Communiquez avec l''administrateur.',
unistr('Les d\00E9tails de cet incident sont disponibles au moyen de l''ID d\00E9bogage "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112109192561399903)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La base de donn\00E9es est ouverte pour acc\00E8s en lecture seule.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112139728065399925)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('ORA-28353 : \00C9chec de l''ouverture du portefeuille. Les donn\00E9es d''application sont actuellement inaccessibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112109244481399903)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Cette page n''est pas disponible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111976731328399805)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Informations techniques (visibles uniquement pour les d\00E9veloppeurs)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112072859808399876)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'fr-ca'
,p_message_text=>'Message d''erreur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112086714033399886)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'fr-ca'
,p_message_text=>'Format attendu : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112053409552399862)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('L''utilisateur figure d\00E9j\00E0 dans la liste de contr\00F4le d''acc\00E8s'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112053351212399862)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Confirmez l''ajout des %0 utilisateurs suivants \00E0 la liste de contr\00F4le d''acc\00E8s <strong>%1</strong>.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112053893331399862)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'fr-ca'
,p_message_text=>'Il existe un utilisateur en double'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112053538600399862)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'fr-ca'
,p_message_text=>'A commercial (@) manquant dans l''adresse de courriel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112053618057399862)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'fr-ca'
,p_message_text=>'Point manquant (.) dans l''adresse de courriel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112053794873399862)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'fr-ca'
,p_message_text=>'Le nom d''utilisateur est trop long'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112054015452399863)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Seuls les utilisateurs d\00E9finis dans la liste de contr\00F4le d''acc\00E8s de l''application peuvent acc\00E9der \00E0 cette application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112054154750399863)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Valeur inattendue pour le param\00E8tre de contr\00F4le d''acc\00E8s : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112053986404399862)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Tous les utilisateurs authentifi\00E9s peuvent acc\00E9der \00E0 cette application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112096746637399893)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9sactiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112096635777399893)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Activ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112096992927399894)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 : Est d\00E9sactiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112096840923399894)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 : Est activ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112096548926399893)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('non identifi\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112089663996399888)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('T\00E9l\00E9charger')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112046132176399857)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Filtre appliqu\00E9 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112087203259399887)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'fr-ca'
,p_message_text=>'Appliquer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111972106017399801)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Graphique \00E0 barres')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112099994458399896)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'fr-ca'
,p_message_text=>'Autres'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111972247397399801)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Graphique \00E0 secteurs')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112098652781399895)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Graphique'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111971923969399801)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>'Nombre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112087707970399887)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'fr-ca'
,p_message_text=>'Effacer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112087861722399887)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'fr-ca'
,p_message_text=>'Tout effacer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112087922868399887)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'fr-ca'
,p_message_text=>'Effacer %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112105124980399900)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La colonne %1, r\00E9f\00E9renc\00E9e par la facette %0, n''est pas disponible ou n''est pas autoris\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111962315992399794)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9lectionner les filtres \00E0 afficher')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112044304917399855)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 r\00E9sultats')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112044417301399856)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 s\00E9lectionn\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112047036887399857)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'fr-ca'
,p_message_text=>'Filtres courants'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111963804785399795)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'fr-ca'
,p_message_text=>'Liste de filtres'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112103696280399899)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Nombre limite de valeurs distinctes (%0) d\00E9pass\00E9 pour la facette %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112089267859399888)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'fr-ca'
,p_message_text=>'La facette %0 n''est pas prise en charge pour les colonnes DATE ou TIMESTAMP.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112087360734399887)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'fr-ca'
,p_message_text=>'Filtrer %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112087446888399887)
,p_name=>'APEX.FS.GO'
,p_message_language=>'fr-ca'
,p_message_text=>'Aller'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112088870636399888)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('\00E9gal \00E0 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111972901645399802)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'fr-ca'
,p_message_text=>'contient %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111972640851399801)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('sup\00E9rieur \00E0 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111972793619399802)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('sup\00E9rieur ou \00E9gal \00E0 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111972414553399801)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('inf\00E9rieur \00E0 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111972546714399801)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('inf\00E9rieur ou \00E9gal \00E0 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111972806713399802)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'fr-ca'
,p_message_text=>'commence par %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111975362506399803)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le type de donn\00E9es %0 (%1) n''est pas pris en charge pour la facette Champ d''entr\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111965568604399796)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Les facettes \00E0 plusieurs valeurs n\00E9cessitent des bases de donn\00E9es version 12.2 ou sup\00E9rieure.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112089050551399888)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aucune colonne de recherche n''a \00E9t\00E9 fournie pour la facette %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111962437362399794)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'fr-ca'
,p_message_text=>'Plus de filtres'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112044556688399856)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9but de l''intervalle')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112088546107399888)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 \00E0 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112088669045399888)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Sup\00E9rieur \00E0 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112088766652399888)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Inf\00E9rieur \00E0 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112044618171399856)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'fr-ca'
,p_message_text=>'Fin de l''intervalle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112107490114399901)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''\00E9l\00E9ment de LDV #%2 ("%1") de la facette d''intervalle %0 n''est pas valide (s\00E9parateur "|" manquant).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112088917283399888)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''entr\00E9e manuelle n''est actuellement pas prise en charge pour la facette d''intervalle %0, car la colonne est de type DATE ou TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112088216581399887)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('\00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111972080239399801)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'fr-ca'
,p_message_text=>'Supprimer le graphique'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112041144695399853)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('R\00E9initialiser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112087685075399887)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>'Rechercher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112087515379399887)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'fr-ca'
,p_message_text=>'Rechercher...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112088419801399887)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('- S\00E9lectionner -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111971854698399801)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'fr-ca'
,p_message_text=>'Afficher le graphique'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112088040273399887)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'fr-ca'
,p_message_text=>'Afficher moins'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112088197347399887)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'fr-ca'
,p_message_text=>'Afficher plus'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112088346101399887)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 \00E9toiles et plus')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112046033788399857)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'fr-ca'
,p_message_text=>'Filtrer les suggestions'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112089165905399888)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'fr-ca'
,p_message_text=>'La facette Champ de texte %0 n''est actuellement prise en charge que pour les colonnes de type NUMBER.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111962258679399794)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Nombre total de rang\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112105266187399900)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le type de donn\00E9es %0 (%1) n''est pas pris en charge pour la recherche \00E0 facettes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112097117616399894)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Acc\00E9der \00E0 l''erreur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112054741541399863)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Agr\00E9ger.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112062398027399869)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('R\00E9duire la commande BREAK')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112054876384399863)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'fr-ca'
,p_message_text=>'Commande BREAK.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112062229813399869)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9velopper la commande BREAK')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112140991655399925)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'fr-ca'
,p_message_text=>'Colonne %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112062042814399868)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 rang\00E9es supprim\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112132440488399919)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Identit\00E9 en double')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112051777307399861)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'fr-ca'
,p_message_text=>'Premier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112055074980399863)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('En-t\00EAte de groupe.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112054908861399863)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('En-t\00EAte.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112051810155399861)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'fr-ca'
,p_message_text=>'Dernier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112071882104399876)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Charger d''autres lignes',
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112051508963399861)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'fr-ca'
,p_message_text=>'Suivant'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112055130835399863)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Rang\00E9es de page')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112051917554399861)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112052006717399861)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 - %1 de %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112108038872399902)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9lection de page')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112051610859399861)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112132237460399919)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ajout\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112132347927399919)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Modifi\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112140731770399925)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Rang\00E9e : %0, Colonne : %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112140832606399925)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Rang\00E9e %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112132102409399919)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Supprim\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112055364929399863)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('En-t\00EAte de rang\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112050956891399860)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 cellules s\00E9lectionn\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112052119786399861)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 rang\00E9es s\00E9lectionn\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112092496425399890)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Tout s\00E9lectionner')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112062121028399868)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'fr-ca'
,p_message_text=>'Page %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112055258006399863)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9lectionner une rang\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112055416626399864)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Tri\00E9 par ordre croissant %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112055595046399864)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Tri\00E9 par ordre d\00E9croissant %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112051026302399860)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'fr-ca'
,p_message_text=>'Trier par ordre croissant'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112051381173399861)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'fr-ca'
,p_message_text=>'Trier par ordre croissant %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112051155987399860)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Trier par ordre d\00E9croissant')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112051455907399861)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Trier par ordre d\00E9croissant %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112051231527399861)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'fr-ca'
,p_message_text=>'Ne pas trier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112061911432399868)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'fr-ca'
,p_message_text=>'Total %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111988355615399813)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La demande HTTP pour "%0" a \00E9chou\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112129607483399917)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 colonnes et %1 rang\00E9es de la liste de s\00E9lection de grille. Utilisez les touches fl\00E9ch\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112061892939399868)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 rang\00E9es de la liste de s\00E9lection. Utilisez les touches fl\00E9ch\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112140576646399925)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>'Grille interactive %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112048658631399859)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'fr-ca'
,p_message_text=>'Actions'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112049624008399859)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'fr-ca'
,p_message_text=>'Ajouter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112049525721399859)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ajouter une rang\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112134013082399920)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Agr\00E9ger')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112119593932399910)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Agr\00E9gation')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112121287102399911)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'fr-ca'
,p_message_text=>'Tout'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112077637431399880)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'fr-ca'
,p_message_text=>'Toutes les colonnes de texte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112078897449399880)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'fr-ca'
,p_message_text=>'Alternatif'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112079957828399881)
,p_name=>'APEX.IG.AND'
,p_message_language=>'fr-ca'
,p_message_text=>'et'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112099338187399895)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'fr-ca'
,p_message_text=>'Nombre approximatif de valeurs distinctes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112135050378399921)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'fr-ca'
,p_message_text=>'Nombre global approximatif de valeurs distinctes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112118153482399909)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'fr-ca'
,p_message_text=>'Aires'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112120060709399910)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'fr-ca'
,p_message_text=>'Croissant'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112078908949399881)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'fr-ca'
,p_message_text=>'Autorisation'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112134127926399921)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'fr-ca'
,p_message_text=>'Automatique'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112099726158399896)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'fr-ca'
,p_message_text=>'Moyenne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112134757086399921)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'fr-ca'
,p_message_text=>'Moyenne globale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112117673607399909)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Titre de l''axe des \00E9tiquettes')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112117808992399909)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Nombre de d\00E9cimales')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112117765658399909)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Titre de l''axe des valeurs'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112123846110399913)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Couleur d''arri\00E8re-plan')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112118272612399909)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'fr-ca'
,p_message_text=>'Barres'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112074262417399877)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'fr-ca'
,p_message_text=>'compris entre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112125008953399914)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'fr-ca'
,p_message_text=>'Les deux'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112118305196399909)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Bulles'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112049822025399859)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'fr-ca'
,p_message_text=>'Annuler'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112079835028399881)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Sensible \00E0 la casse')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112135648713399922)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('(Sensible \00E0 la casse)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112106585760399901)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Modifications enregistr\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112050272093399860)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'fr-ca'
,p_message_text=>'Modifier la vue'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112080924883399882)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'fr-ca'
,p_message_text=>'Graphique'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112077470491399879)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Votre interrogation d\00E9passe le maximum de %0 points de donn\00E9es par graphique. Appliquez un filtre pour r\00E9duire le nombre d''enregistrements de votre interrogation de base.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112048599223399859)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'fr-ca'
,p_message_text=>'Vue de graphique'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112055873338399864)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'fr-ca'
,p_message_text=>'Effacer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112117171306399908)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>'Fermer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112124033232399913)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'fr-ca'
,p_message_text=>'Couleurs'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112100140997399896)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aper\00E7u')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112079232839399881)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>'Colonne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112048737696399859)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'fr-ca'
,p_message_text=>'Colonnes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112125842805399914)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'fr-ca'
,p_message_text=>'Objet de la colonne'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112079309794399881)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'fr-ca'
,p_message_text=>'Complexe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112048969736399859)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'fr-ca'
,p_message_text=>'Calculer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112074883034399878)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'fr-ca'
,p_message_text=>'contient'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112081162735399882)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'fr-ca'
,p_message_text=>'Commande BREAK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112055646022399864)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'fr-ca'
,p_message_text=>'Copier dans le presse-papiers'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112055704820399864)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'fr-ca'
,p_message_text=>'Copier en-dessous'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112099126580399895)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'fr-ca'
,p_message_text=>'Nombre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112099250347399895)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'fr-ca'
,p_message_text=>'Nombre de valeurs distinctes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112134918304399921)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'fr-ca'
,p_message_text=>'Nombre global de valeurs distinctes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112134845809399921)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'fr-ca'
,p_message_text=>'Nombre global'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112132540220399919)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Cr\00E9er %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112077869728399880)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Donn\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112125625784399914)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Type de donn\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112125296653399914)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'fr-ca'
,p_message_text=>'Date'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112106337096399901)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'fr-ca'
,p_message_text=>'Valeur de date non valide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112075505186399878)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'fr-ca'
,p_message_text=>'jours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112078517190399880)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Param\00E8tres par d\00E9faut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112078327526399880)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Type par d\00E9faut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112049774744399859)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'fr-ca'
,p_message_text=>'Supprimer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112126807742399915)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'fr-ca'
,p_message_text=>'Voulez-vous supprimer ce rapport?'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112082962481399883)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Supprimer la rang\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112081778401399883)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Supprimer les rang\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112120144082399910)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9croissant')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112080640852399882)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9tails')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112048250342399858)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vue d\00E9taill\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112108849513399902)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'fr-ca'
,p_message_text=>'Sens'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112080381604399882)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9sactiv\00E9')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112074913528399878)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'fr-ca'
,p_message_text=>'ne contient pas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112075127882399878)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'fr-ca'
,p_message_text=>'ne commence pas par'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112118435992399909)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'fr-ca'
,p_message_text=>'Torique'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112081348959399882)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('T\00E9l\00E9charger')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111980024856399807)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Donn\00E9es uniquement')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112127829518399916)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9lectionner un format')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111992698356399818)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le format de t\00E9l\00E9chargement %0 n''est pas activ\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112120884779399911)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Agr\00E9gation en double')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112120927553399911)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'fr-ca'
,p_message_text=>'Commande BREAK en double'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112082898310399883)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Dupliquer la rang\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112081603419399882)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Rang\00E9es en double')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112049305760399859)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'fr-ca'
,p_message_text=>'Modifier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112119982502399910)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'fr-ca'
,p_message_text=>'Modifier le graphique'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112131416953399919)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'fr-ca'
,p_message_text=>'Modifier le regroupement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112127452898399916)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'fr-ca'
,p_message_text=>'Copie conforme invisible (Cci)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112127687608399916)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'fr-ca'
,p_message_text=>'Message'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112127394397399916)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'fr-ca'
,p_message_text=>'Copie (Cc)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112127076792399915)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Courriel envoy\00E9.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112127586341399916)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'fr-ca'
,p_message_text=>'Objet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112127265409399915)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Destinataire (\00C0)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112080060091399881)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Activ\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112073203974399877)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('\00E9gal \00E0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112126483936399915)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Exemple'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112080151268399881)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'fr-ca'
,p_message_text=>'Expression'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112126399338399915)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'fr-ca'
,p_message_text=>'Type'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112092337375399890)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Fichier pr\00E9par\00E9. D\00E9but du t\00E9l\00E9chargement.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112055992846399864)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'fr-ca'
,p_message_text=>'Remplir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112057016294399865)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Remplir la s\00E9lection avec')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112056919330399865)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Remplir la s\00E9lection')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112048824371399859)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'fr-ca'
,p_message_text=>'Filtrer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112079428981399881)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'fr-ca'
,p_message_text=>'Filtres'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112134496251399921)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'fr-ca'
,p_message_text=>'Filtrer...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112120348035399911)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'fr-ca'
,p_message_text=>'Premier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112049034701399859)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'fr-ca'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112077966291399880)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'fr-ca'
,p_message_text=>'Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112124927445399914)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'fr-ca'
,p_message_text=>'Masque de format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112126790261399915)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'fr-ca'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112126676044399915)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'fr-ca'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112039419544399852)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'fr-ca'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111978755389399806)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'fr-ca'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112082564653399883)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'fr-ca'
,p_message_text=>'Geler'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112080269279399881)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Fonctions et op\00E9rateurs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112118501333399909)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'fr-ca'
,p_message_text=>'Entonnoir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112099046240399895)
,p_name=>'APEX.IG.GO'
,p_message_language=>'fr-ca'
,p_message_text=>'Aller'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112073810786399877)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('sup\00E9rieur \00E0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112073996464399877)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('sup\00E9rieur ou \00E9gal \00E0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112080532979399882)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'fr-ca'
,p_message_text=>'Grille'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112048054855399858)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'fr-ca'
,p_message_text=>'Vue de grille'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112121125985399911)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'fr-ca'
,p_message_text=>'Groupe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112080741342399882)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'fr-ca'
,p_message_text=>'Regroupement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112048392158399858)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'fr-ca'
,p_message_text=>'Vue de regroupement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112125548805399914)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'fr-ca'
,p_message_text=>'Type de condition'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112124401802399913)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('En-t\00EAte')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112124640994399914)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Alignement de l''en-t\00EAte')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112134373035399921)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'fr-ca'
,p_message_text=>'Aide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112129855921399917)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Vous pouvez ins\00E9rer, mettre \00E0 jour et supprimer des donn\00E9es directement dans cette grille interactive.</p>'),
'',
unistr('<p>Ins\00E9rez une nouvelle rang\00E9e en cliquant sur le bouton Ajouter une rang\00E9e.</p>'),
'',
unistr('<p>Modifiez des donn\00E9es existantes en cliquant deux fois sur une cellule sp\00E9cifique. Pour des travaux de modification plus importants, cliquez sur Modifier pour passer en mode de modification. En mode de modification, vous pouvez cliquer une seule fo')
||unistr('is sur une cellule ou utiliser le clavier pour modifier des cellules sp\00E9cifiques.</p>'),
'',
unistr('<p>Utilisez le menu Modifier pour dupliquer et supprimer des rang\00E9es. Pour activer le menu Modifier, utilisez les cases \00E0 cocher pour s\00E9lectionner une ou plusieurs rang\00E9es.</p>'),
'',
unistr('<p>Dupliquez une rang\00E9e s\00E9lectionn\00E9e en cliquant sur le menu Modifier et en s\00E9lectionnant Dupliquer les rang\00E9es. Supprimez une rang\00E9e s\00E9lectionn\00E9e en cliquant sur le menu Modifier et en s\00E9lectionnant Supprimer la rang\00E9e.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112131947615399919)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Fonctionnalit\00E9s de modification')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112132062154399919)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Une grille interactive pr\00E9sente un jeu de donn\00E9es dans un rapport interrogeable et personnalisable. Vous pouvez effectuer de nombreuses op\00E9rations pour limiter les enregistrements retourn\00E9s et modifier le mode d''affichage des donn\00E9es.</p>'),
'',
unistr('<p>Utilisez le champ de recherche pour filtrer les enregistrements retourn\00E9s. Cliquez sur Actions pour acc\00E9der aux nombreuses options permettant de modifier la disposition du rapport, ou utilisez les menus d''en-t\00EAte de colonne sur les colonnes affich')
||unistr('\00E9es.</p>'),
'',
unistr('<p>Utilisez les param\00E8tres de rapport pour enregistrer vos personnalisations dans un rapport. Vous pouvez \00E9galement t\00E9l\00E9charger les donn\00E9es du rapport vers un fichier externe ou les envoyer par courriel \00E0 vous-m\00EAme ou \00E0 d''autres personnes.</p>'),
'',
'<p>Pour en savoir plus, consultez la section "Utilisation des rapports interactifs" dans le <em>Guide de l''utilisateur final d''Oracle Application Express</em>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112131764007399919)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aper\00E7u')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112129797514399917)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Vous pouvez personnaliser la grille interactive de sorte qu''elle affiche les donn\00E9es de diverses fa\00E7ons \00E0 l''aide des fonctionnalit\00E9s int\00E9gr\00E9es.</p>'),
'',
unistr('<p>Utilisez les menus d''en-t\00EAte de colonne ou le menu Actions pour d\00E9terminer les colonnes \00E0 afficher, dans quel ordre, et pour figer les colonnes. Vous pouvez \00E9galement d\00E9finir divers filtres de donn\00E9es et trier les donn\00E9es retourn\00E9es.</p>'),
'',
unistr('<p>Utilisez le bouton Vue (adjacent au champ de recherche) pour acc\00E9der \00E0 d''autres vues de donn\00E9es qui peuvent avoir \00E9t\00E9 d\00E9finies par le d\00E9veloppeur d''application. Vous pouvez \00E9galement cr\00E9er un graphique ou visualiser un graphique existant.</p>  '),
'',
unistr('<p><em>Note : Cliquez sur <strong>Aide</strong> dans les bo\00EEtes de dialogue de la grille interactive pour obtenir des informations plus d\00E9taill\00E9es sur la fonction s\00E9lectionn\00E9e.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112131894483399919)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Fonctionnalit\00E9s de production de rapports')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112081594053399882)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Aide sur la grille interactive'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112128602937399916)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette bo\00EEte de dialogue pour agr\00E9ger des colonnes. Les valeurs agr\00E9g\00E9es s''affichent en bas des donn\00E9es ou, si des commandes BREAK sont d\00E9finies, en bas de chaque commande.</p>'),
'',
unistr('<p><strong>Liste d''agr\00E9gations</strong><br>'),
unistr('La liste Agr\00E9gation affiche les agr\00E9gations d\00E9finies. D\00E9sactivez une agr\00E9gation existante en la d\00E9s\00E9lectionnant.<br>'),
unistr('Cliquez sur Ajouter ( &plus; ) pour cr\00E9er une agr\00E9gation ou sur Supprimer ( &minus; ) pour retirer une agr\00E9gation existante.</p>'),
'',
unistr('<p><strong>Param\00E8tres d''agr\00E9gation</strong><br>'),
unistr('Utilisez le formulaire \00E0 droite pour d\00E9finir l''agr\00E9gation.<br>'),
unistr('S\00E9lectionnez le nom de colonne et le type d''agr\00E9gation.<br>'),
unistr('Saisissez \00E9ventuellement une infobulle pour l''agr\00E9gation.<br>'),
unistr('Si vous avez d\00E9fini une commande BREAK, la s\00E9lection de <strong>Afficher la valeur globale</strong> affiche la moyenne globale, le total ou une valeur similaire en bas des donn\00E9es.</p>'),
'',
unistr('<p><em>Note : Acc\00E9dez \00E0 la bo\00EEte de dialogue Agr\00E9gation dans le menu Actions ou en cliquant sur l''en-t\00EAte de colonne et la somme ( &sum; ).</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112130802759399918)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aide sur l''agr\00E9gation')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112129396008399917)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette bo\00EEte de dialogue pour d\00E9finir un graphique qui s''affiche en tant que vue de donn\00E9es distincte.<br>'),
unistr('S\00E9lectionnez un type de graphique et des attributs de graphique.</p>'),
'<p><strong>Attributs de graphique</strong></br>',
'Les attributs de graphique disponibles varient selon le type de graphique.</p>',
'<p>',
'<ul>',
unistr('  <li>S\00E9lectionnez la colonne contenant la valeur pour l''attribut :'),
'    <ul>',
unistr('      <li>\00C9tiquette - Texte pour chaque point de donn\00E9es.</li>'),
unistr('      <li>Valeur - Donn\00E9es \00E0 tracer.</li>'),
unistr('      <li>S\00E9rie - Pour d\00E9finir votre interrogation dynamique \00E0 plusieurs s\00E9ries.</li>'),
unistr('      <li>Ouverture - Prix d''ouverture boursi\00E8re quotidien (graphique boursier uniquement).</li>'),
unistr('      <li>Cl\00F4ture - Prix de cl\00F4ture boursi\00E8re quotidien (graphique boursier uniquement).</li>'),
unistr('      <li>\00C9lev\00E9 - Valeur \00E9lev\00E9e (graphiques \00E0 intervalles et boursiers uniquement).</li>'),
unistr('      <li>Faible - Valeur basse (graphiques \00E0 intervalles et boursiers uniquement).</li>'),
'      <li>Volume - Volume boursier quotidien (graphiques boursiers uniquement).</li>',
'      <li>Cible : Valeur cible (graphique en entonnoir uniquement).</li>',
unistr('      <li>X - Valeur de l''axe des X (graphiques \00E0 bulles et en nuage de points uniquement).</li>'),
unistr('      <li>Y - Valeur de l''axe des Y (graphiques \00E0 bulles et en nuage de points uniquement).</li>'),
unistr('      <li>Z - Largeur des barres ou rayon des bulles (graphiques \00E0 barres, \00E0 bulles et \00E0 intervalles uniquement).</li>'),
'    </ul>',
'  </li>',
'  <li>Orientation - Verticale ou horizontale.</li>',
unistr('  <li>Agr\00E9gation - S\00E9lectionnez le mode d''agr\00E9gation des valeurs du graphique.</li>'),
unistr('  <li>Pile - Sp\00E9cifiez si les \00E9l\00E9ments de donn\00E9es sont empil\00E9s.</li>'),
unistr('  <li>Trier par - Indiquez si le graphique est tri\00E9 par \00E9tiquette ou valeur.'),
'    <ul>',
unistr('      <li>Sens - Indiquez si les donn\00E9es sont tri\00E9es par ordre croissant ou d\00E9croissant de valeurs.</li>'),
unistr('      <li>Valeurs nulles - Indiquez la fa\00E7on dont vous voulez que les enregistrements avec des valeurs nulles soient tri\00E9s par rapport aux enregistrements avec des valeurs non nulles.</li>'),
'    </ul>',
'  </li>',
unistr('  <li>Nombre de d\00E9cimales</li>'),
unistr('  <li>Titre de l''axe des \00E9tiquettes</li>'),
'  <li>Titre de l''axe des valeurs</li>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112131223786399918)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Aide sur le graphique'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112128306563399916)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette bo\00EEte de dialogue pour s\00E9lectionner les colonnes \00E0 afficher et leur ordre d''affichage.</p>'),
'',
unistr('<p>Masquez une colonne en la d\00E9s\00E9lectionnant.<br>'),
unistr('R\00E9organisez les colonnes en cliquant sur D\00E9placer vers le haut ( &uarr; ) ou D\00E9placer vers le bas ( &darr; ).<br>'),
unistr('Utilisez le s\00E9lecteur de la liste d\00E9roulante pour r\00E9pertorier toutes les colonnes, les colonnes affich\00E9es ou les colonnes non affich\00E9es.</p>'),
'',
unistr('<p>Utilisez \00E9ventuellement le formulaire pour indiquer la largeur minimale d''une colonne en pixels.</p>'),
'',
unistr('<p><em>Note : Vous pouvez \00E9galement r\00E9organiser les colonnes affich\00E9es en cliquant sur la poign\00E9e de glissement (au d\00E9but de l''en-t\00EAte de colonne) et en d\00E9pla\00E7ant la colonne \00E0 gauche ou \00E0 droite. Vous pouvez aussi modifier la largeur des colonnes aff')
||unistr('ich\00E9es en s\00E9lectionnant le s\00E9parateur de colonnes, entre les en-t\00EAtes, et en le d\00E9pla\00E7ant vers la gauche ou la droite.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112131198828399918)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Aide sur les colonnes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112128720548399917)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette bo\00EEte de dialogue pour d\00E9finir des colonnes suppl\00E9mentaires en fonction de calculs math\00E9matiques et fonctionnels r\00E9alis\00E9s sur les colonnes existantes.</p>'),
'',
unistr('<p><strong>Liste de calculs</strong><br>La liste Calcul affiche les calculs d\00E9finis. D\00E9sactivez un calcul existant en le d\00E9s\00E9lectionnant.<br>'),
'Cliquez sur Ajouter ( &plus; ) pour ajouter un nouveau calcul ou sur Supprimer ( &minus; ) pour retirer un calcul existant.</p>',
'',
unistr('<p><strong>Param\00E8tres de calcul</strong><br>Utilisez le formulaire pour d\00E9finir le calcul.<br>'),
unistr('Entrez les d\00E9tails de colonne, tels qu''un en-t\00EAte ou une \00E9tiquette et s\00E9lectionnez des param\00E8tres d''alignement.<br> '),
unistr('Utilisez la zone de texte Expression pour entrer les colonnes et les fonctions associ\00E9es pour le calcul.<br>'),
unistr('S\00E9lectionnez le type de donn\00E9es appropri\00E9 et \00E9ventuellement un masque de format pour la nouvelle colonne.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112130750932399918)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Aide sur le calcul'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112129037285399917)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette bo\00EEte de dialogue pour d\00E9finir une commande BREAK sur des colonnes.</p>'),
'',
'<p><strong>Liste de commandes BREAK</strong><br>',
unistr('La liste Commande BREAK affiche les commandes BREAK d\00E9finies. D\00E9sactivez une colonne de commande BREAK existante en la d\00E9s\00E9lectionnant.<br>'),
'Cliquez sur Ajouter ( &plus; ) pour inclure une nouvelle colonne dans la commande BREAK ou sur Supprimer ( &minus; ) pour retirer une colonne existante de la commande BREAK.<br>',
unistr('Pour r\00E9organiser les colonnes, cliquez sur D\00E9placer vers le haut ( &uarr; ) ou D\00E9placer vers le bas ( &darr; ) pour d\00E9placer la colonne s\00E9lectionn\00E9e vers le haut et vers le bas par rapport aux autres colonnes.</p>'),
'',
unistr('<p><strong>Param\00E8tres de commande BREAK</strong><br>'),
unistr('Utilisez le formulaire pour d\00E9finir la colonne de commande BREAK.<br>'),
unistr('S\00E9lectionnez une colonne de commande BREAK, le sens de tri et le mode d''organisation des colonnes nulles (colonnes sans valeur).</p>'),
'',
unistr('<p><em>Note : Lorsque vous affichez la grille interactive, vous pouvez d\00E9finir une commande BREAK en cliquant sur un en-t\00EAte de colonne et en s\00E9lectionnant l''ic\00F4ne de commande BREAK.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112130444045399918)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Aide sur la commande BREAK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112129249319399917)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette bo\00EEte de dialogue pour t\00E9l\00E9charger toutes les rang\00E9es courantes dans un fichier externe. Le fichier comportera uniquement les colonnes actuellement affich\00E9es, \00E0 l''aide de tous les filtres et tris appliqu\00E9s aux donn\00E9es.</p>'),
'',
unistr('<p>S\00E9lectionnez le format de fichier et cliquez sur T\00E9l\00E9charger.<br>'),
unistr('Note : Le format CSV n''inclura pas le formatage de texte tel que les agr\00E9gats et les commandes BREAK.</p>'),
'',
unistr('<p>Pour envoyer le fichier par courriel, s\00E9lectionnez Envoyer en tant que courriel et entrez les d\00E9tails de courriel (Destinataire, Objet et Message).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112130207809399918)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aide sur le t\00E9l\00E9chargement')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112128485305399916)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette bo\00EEte de dialogue pour configurer des filtres de donn\00E9es qui limitent le nombre de rang\00E9es retourn\00E9es.</p>'),
'',
'<p><strong>Liste de filtres</strong><br>',
unistr('La liste Filtre affiche les filtres d\00E9finis. D\00E9sactivez un filtre existant en le d\00E9s\00E9lectionnant.<br>'),
unistr('Cliquez sur Ajouter ( &plus; ) pour cr\00E9er un filtre ou sur Supprimer ( &minus; ) pour retirer un filtre existant.</p>'),
'',
unistr('<p><strong>Param\00E8tres de filtre</strong><br>'),
unistr('Utilisez le formulaire pour d\00E9finir les propri\00E9t\00E9s de filtre.<br>'),
unistr('S\00E9lectionnez le type de filtre appropri\00E9 :<br>'),
unistr('&nbsp;&nbsp;&nbsp;Rang\00E9e - Filtrer un terme dans toute colonne filtrable.<br>'),
unistr('&nbsp;&nbsp;&nbsp;Colonne : Filtrer une colonne sp\00E9cifique avec un op\00E9rateur et une valeur sp\00E9cifi\00E9s.</p>'),
'',
unistr('<p><em>Note : Lorsque vous affichez une grille interactive, vous pouvez d\00E9finir des filtres de rang\00E9e en les saisissant directement dans le champ de recherche. Cliquez sur S\00E9lectionner les colonnes \00E0 rechercher pour limiter la recherche \00E0 une colonne')
||unistr(' sp\00E9cifique. Vous pouvez \00E9galement ouvrir un menu En-t\00EAte de colonne et s\00E9lectionner une valeur pour cr\00E9er un filtre de colonne.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112131029139399918)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Aide sur le filtrage'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112128844068399917)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette bo\00EEte de dialogue pour voir les donn\00E9es telles qu''elles existaient \00E0 un moment donn\00E9 pr\00E9c\00E9dent.</p>'),
unistr('<p>Entrez le nombre de minutes dans le pass\00E9 pour ex\00E9cuter l''interrogation Flashback.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112130641811399918)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Aide sur Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112131319391399918)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Aide sur le regroupement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112128946210399917)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette bo\00EEte de dialogue pour mettre en surbrillance des rang\00E9es ou des colonnes de donn\00E9es en fonction de la condition entr\00E9e.</p>'),
'',
'<p><strong>Liste de mises en surbrillance</strong><br>',
unistr('La liste Mise en surbrillance affiche les mises en surbrillance d\00E9finies. D\00E9sactivez une mise en surbrillance existante en la d\00E9s\00E9lectionnant.<br>Cliquez sur Ajouter ( &plus; ) pour cr\00E9er une mise en surbrillance ou sur Supprimer ( &minus; ) pour ret')
||'irer une mise en surbrillance existante.</p>',
'',
unistr('<p><strong>Param\00E8tres de mise en surbrillance</strong><br>'),
unistr('Utilisez le formulaire pour d\00E9finir les propri\00E9t\00E9s de mise en surbrillance.<br>'),
unistr('Entrez le nom, s\00E9lectionnez Rang\00E9e ou Colonne, puis s\00E9lectionnez les codes couleur HTML pour le texte et l''arri\00E8re-plan.<br>'),
unistr('S\00E9lectionnez le <strong>type de condition</strong> appropri\00E9 pour mettre en surbrillance des donn\00E9es sp\00E9cifiques :<br>'),
unistr('&nbsp;&nbsp;&nbsp;Rang\00E9e - mise en surbrillance du terme dans toute colonne.<br>'),
unistr('&nbsp;&nbsp;&nbsp;Colonne - mise en surbrillance dans une colonne sp\00E9cifique selon l''op\00E9rateur et la valeur sp\00E9cifi\00E9s.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112130565898399918)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Aide sur la mise en surbrillance'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112129122339399917)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette bo\00EEte de dialogue pour enregistrer les modifications que vous avez apport\00E9es \00E0 la disposition et \00E0 la configuration courantes de la grille.<br>'),
unistr('Les d\00E9veloppeurs d''application peuvent d\00E9finir plusieurs dispositions de rapports alternatifs. Lorsque cela est autoris\00E9, vous et les autres utilisateurs finaux pouvez enregistrer un rapport comme public, ce qui rend le rapport accessible \00E0 tous les ')
||unistr('autres utilisateurs de la grille. Vous pouvez \00E9galement enregistrer un rapport en tant que rapport priv\00E9 que vous seul pouvez consulter.</p>'),
unistr('<p>Effectuez une s\00E9lection parmi les types disponibles et entrez un nom pour le rapport enregistr\00E9.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112130315116399918)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Aide sur le rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112128582189399916)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette bo\00EEte de dialogue pour d\00E9finir l''ordre d''affichage.</p>'),
'',
'<p><strong>Liste de tris</strong><br>',
unistr('La bo\00EEte de dialogue Tri affiche une liste des r\00E8gles de tri configur\00E9es.<br>'),
unistr('Cliquez sur Ajouter ( &plus ; ) pour cr\00E9er une colonne de tri ou sur Supprimer ( &minus ; ) pour retirer une colonne de tri.<br>'),
unistr('Cliquez sur D\00E9placer vers le haut ( &uarr ; ) et D\00E9placer vers le bas ( &darr ; ) pour d\00E9placer la colonne de tri s\00E9lectionn\00E9e vers le haut et vers le bas par rapport aux autres colonnes de tri.</p>'),
'',
unistr('<p><strong>Param\00E8tres de tri</strong><br>'),
unistr('S\00E9lectionnez une colonne de tri, le sens du tri et le mode d''organisation des colonnes nulles (colonnes sans valeur).</p>'),
'',
unistr('<p><em>Note : Les donn\00E9es peuvent \00EAtre tri\00E9es en fonction de colonnes qui ne sont pas affich\00E9es. Cependant, toutes les colonnes ne sont pas forc\00E9ment triables.</em><br>'),
unistr('<em>Vous pouvez trier les colonnes affich\00E9es en cliquant sur les fl\00E8ches vers le haut (par ordre croissant) ou vers le bas (par ordre d\00E9croissant) \00E0 la fin des en-t\00EAtes de colonne. Pour ajouter une autre colonne \00E0 un tri existant, maintenez la touche')
||unistr(' Maj enfonc\00E9e et cliquez sur la fl\00E8che vers le haut ou vers le bas.</em></p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112130942438399918)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Aide sur le tri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112130158474399918)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Aide sur l''abonnement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112082478050399883)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'fr-ca'
,p_message_text=>'Masquer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112049206587399859)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'fr-ca'
,p_message_text=>'Mettre en surbrillance'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112117292271399908)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('\00C9lev\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112118000959399909)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'fr-ca'
,p_message_text=>'Horizontal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112075438026399878)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'fr-ca'
,p_message_text=>'heures'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112080413901399882)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ic\00F4ne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112048166292399858)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vue Ic\00F4ne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112073693261399877)
,p_name=>'APEX.IG.IN'
,p_message_language=>'fr-ca'
,p_message_text=>'dans'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112082090585399883)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Param\00E8tre inactif')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112082118165399883)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Param\00E8tres inactifs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112089738579399888)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>'Une erreur interne est survenue lors du traitement de la demande de grille interactive.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111985510003399811)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'fr-ca'
,p_message_text=>'Le type de filtre de colonne "%0" n''est pas pris en charge pour la colonne "%1".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112129973932399917)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'fr-ca'
,p_message_text=>'Format de date non valide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112104164603399899)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La grille interactive ne prend pas en charge la d\00E9finition d''un filtre sur la colonne %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112104033921399899)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 n''est pas un type de filtre valide pour d\00E9finir un filtre de grille interactive.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111990681663399815)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Format num\00E9rique non valide')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112132624380399919)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Param\00E8tre non valide')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112132750105399920)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Param\00E8tres non valides')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112123703560399913)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''option Trier par a \00E9t\00E9 r\00E9gl\00E9e \00E0 %0, mais aucune colonne n''a \00E9t\00E9 s\00E9lectionn\00E9e pour %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112121029287399911)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'fr-ca'
,p_message_text=>'Valeur non valide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112116143786399908)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Non affich\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112074435808399877)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'fr-ca'
,p_message_text=>'dans le dernier intervalle de'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112074602617399878)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'fr-ca'
,p_message_text=>'dans le prochain intervalle de'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112073556193399877)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'fr-ca'
,p_message_text=>'n''est pas vide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112073451544399877)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'fr-ca'
,p_message_text=>'est vide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112124588495399914)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('\00C9tiquette')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112116577377399908)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('\00C9tiquette')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112120438472399911)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'fr-ca'
,p_message_text=>'Dernier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112063753516399870)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'fr-ca'
,p_message_text=>'Dernier jour'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112063985571399870)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Derni\00E8re heure')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112064473822399870)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Derni\00E8re minute')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112063430224399869)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'fr-ca'
,p_message_text=>'Mois dernier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112063530203399870)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Semaine derni\00E8re')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112063608168399870)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 derniers jours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112063800135399870)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 derni\00E8res heures')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112064588297399870)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 derni\00E8res minutes')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112064301231399870)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 derniers mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112064218975399870)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 derni\00E8res semaines')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112063238699399869)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 derni\00E8res ann\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112063393749399869)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ann\00E9e derni\00E8re')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112124797838399914)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'fr-ca'
,p_message_text=>'Alignement des cellules'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112124829885399914)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'fr-ca'
,p_message_text=>'Utiliser le groupe pour'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112074092515399877)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('inf\00E9rieur \00E0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112074168811399877)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('inf\00E9rieur ou \00E9gal \00E0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112118670347399909)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Lin\00E9aire')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112118793837399909)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Lin\00E9aire avec aire')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112125178039399914)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'fr-ca'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112117323268399908)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>'Faible'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112127759004399916)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9parez les diff\00E9rentes adresses par des virgules')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112075291557399878)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('correspond \00E0 l''expression rationnelle')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112099697317399896)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'fr-ca'
,p_message_text=>'Maximum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112135205046399921)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'fr-ca'
,p_message_text=>'Maximum global'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112099886033399896)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('M\00E9diane')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112135316898399921)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('M\00E9diane globale')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112099523788399896)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'fr-ca'
,p_message_text=>'Minimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112075369779399878)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'fr-ca'
,p_message_text=>'minutes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112100382224399896)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'fr-ca'
,p_message_text=>'Minutes auparavant'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112135150917399921)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'fr-ca'
,p_message_text=>'Minimum global'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112075794911399878)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'fr-ca'
,p_message_text=>'mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112082366197399883)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Les donn\00E9es contiennent plus de %0 rang\00E9es, ce qui d\00E9passe le maximum autoris\00E9. Appliquez des filtres suppl\00E9mentaires pour voir les r\00E9sultats.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112109018275399902)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''ID statique de la r\00E9gion doit \00EAtre sp\00E9cifi\00E9 car la page contient plusieurs grilles interactives.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112078468928399880)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'fr-ca'
,p_message_text=>'Nom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112078686031399880)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Rapport nomm\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112062663269399869)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'fr-ca'
,p_message_text=>'Prochain jour'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112062413725399869)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'fr-ca'
,p_message_text=>'Prochaine heure'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112064641033399870)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'fr-ca'
,p_message_text=>'Prochaine minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112062976361399869)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'fr-ca'
,p_message_text=>'Mois prochain'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112062889123399869)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'fr-ca'
,p_message_text=>'Semaine prochaine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112062774843399869)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 prochains jours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112062501328399869)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 prochaines heures'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112064755917399870)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 prochaines minutes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112064030557399870)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 prochains mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112064105634399870)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 prochaines semaines'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112063181142399869)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 prochaines ann\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112063067047399869)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ann\00E9e prochaine')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112074326162399877)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'fr-ca'
,p_message_text=>'non compris entre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112073300486399877)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('diff\00E9rent de')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112139507397399924)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La r\00E9gion portant l''ID %0 n''est pas une r\00E9gion de grille interactive ou n''existe pas dans l''application %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112073728127399877)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'fr-ca'
,p_message_text=>'pas dans'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112074533170399877)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'fr-ca'
,p_message_text=>'pas dans le dernier intervalle de'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112074705811399878)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'fr-ca'
,p_message_text=>'pas dans le prochain intervalle de'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112082220243399883)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aucune donn\00E9e trouv\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112120270151399910)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'fr-ca'
,p_message_text=>'Valeurs nulles'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112125336615399914)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Num\00E9rique')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112120519203399911)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9sactiv\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112120687268399911)
,p_name=>'APEX.IG.ON'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Activ\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112072582353399876)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'fr-ca'
,p_message_text=>'Il y a 1 minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112128202129399916)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ouvrir le s\00E9lecteur de couleur : %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112117020509399908)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>'Ouvrir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112079501513399881)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Op\00E9rateur')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112116421035399908)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'fr-ca'
,p_message_text=>'Orientation'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112118814900399910)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'fr-ca'
,p_message_text=>'Secteurs'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112080860899399882)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Tableau crois\00E9 dynamique')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112048474149399858)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vue de tableau crois\00E9 dynamique')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112128105875399916)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9parer les valeurs par "%0"')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112118900678399910)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'fr-ca'
,p_message_text=>'Polaire'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112124210875399913)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'fr-ca'
,p_message_text=>'Centre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112124316551399913)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'fr-ca'
,p_message_text=>'Fin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112124136848399913)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9but')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112078726040399880)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'fr-ca'
,p_message_text=>'Principal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112079043839399881)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Principal par d\00E9faut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112095564105399893)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'fr-ca'
,p_message_text=>'Rapport principal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111977781642399805)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Inclure des balises d''accessibilit\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111976496156399804)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'fr-ca'
,p_message_text=>'Paysage'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111976597110399804)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'fr-ca'
,p_message_text=>'Portrait'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111976389004399804)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'fr-ca'
,p_message_text=>'Orientation de la page'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111976278814399804)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'fr-ca'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111976129101399804)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'fr-ca'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111977835131399805)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Personnalis\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111975935816399804)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'fr-ca'
,p_message_text=>'Grand format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111975808515399804)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'fr-ca'
,p_message_text=>'Lettre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111976069120399804)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Tablo\00EFd')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111975713426399804)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'fr-ca'
,p_message_text=>'Taille de la page'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111965937507399797)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'fr-ca'
,p_message_text=>'Supprimer le texte enrichi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112119098001399910)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'fr-ca'
,p_message_text=>'Radar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112119128227399910)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'fr-ca'
,p_message_text=>'Intervalle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112129409677399917)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'fr-ca'
,p_message_text=>'Actualiser'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112083097437399883)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Actualiser la rang\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112081891906399883)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Actualiser les rang\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112087075271399886)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La r\00E9gion de la grille interactive n''existe pas dans l''application %0, la page %1 et la r\00E9gion %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112049984185399860)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'fr-ca'
,p_message_text=>'Supprimer %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112078102183399880)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'fr-ca'
,p_message_text=>'Rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112138786270399924)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Rapport supprim\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112138448275399924)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Rapport alternatif enregistr\00E9 pour tous les utilisateurs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112138302150399924)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Rapport par d\00E9faut enregistr\00E9 pour tous les utilisateurs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112138610597399924)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Rapport priv\00E9 enregistr\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112138595202399924)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Rapport public enregistr\00E9 pour tous les utilisateurs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112087120958399887)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La grille interactive enregistr\00E9e avec le nom %0 n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112072435813399876)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Donn\00E9es du rapport il y a %0 minutes')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112072308195399876)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Donn\00E9es du rapport il y a 1 minute')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112012074957399832)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'fr-ca'
,p_message_text=>'Le rapport de grille interactive n''existe pas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112131665830399919)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'fr-ca'
,p_message_text=>'Rapport - Modifier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112086921727399886)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La grille interactive enregistr\00E9e avec l''ID %0 n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112131575514399919)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'fr-ca'
,p_message_text=>'Rapport - Enregistrer sous'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112050021707399860)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Param\00E8tres de rapport')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112139640497399924)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La grille interactive enregistr\00E9e avec l''ID statique %0 n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112134503303399921)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'fr-ca'
,p_message_text=>'Vue de rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112049117749399859)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('R\00E9initialiser')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112083174343399884)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'fr-ca'
,p_message_text=>'Annuler les modifications'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112081989833399883)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('R\00E9tablir les rang\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112079113449399881)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Rang\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112078022755399880)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Rang\00E9es par page')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112139213262399924)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Actions de rang\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112140445167399925)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Actions pour la rang\00E9e %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112049457961399859)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'fr-ca'
,p_message_text=>'Enregistrer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112092125268399890)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('enregistr\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112047639536399858)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Rapports enregistr\00E9s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112047727098399858)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Par d\00E9faut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112022240292399839)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Un rapport enregistr\00E9 nomm\00E9 %0 existe d\00E9j\00E0. Entrez un nouveau nom.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112047862207399858)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Priv\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112047924840399858)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'fr-ca'
,p_message_text=>'Public'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112134295689399921)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'fr-ca'
,p_message_text=>'Enregistrer sous'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112081212725399882)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Enregistrer les param\00E8tres du rapport')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112119252155399910)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'fr-ca'
,p_message_text=>'Nuage de points'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112047507528399858)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'fr-ca'
,p_message_text=>'Rechercher'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112126566905399915)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'fr-ca'
,p_message_text=>'Rechercher : Toutes les colonnes de texte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112047462085399858)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>'Rechercher : %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112125755263399914)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Rechercher : Texte int\00E9gral')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112072217670399876)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'fr-ca'
,p_message_text=>'Rechercher ''%0'''
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112115891790399907)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('- S\00E9lectionner -')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112056026540399864)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9lection')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112108741852399902)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9lectionner 1 rang\00E9e dans la r\00E9gion principale')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112047331784399858)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9lectionner les colonnes \00E0 rechercher')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112138917702399924)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Actions de s\00E9lection')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112056297316399864)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9lection de cellule')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112056159513399864)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9lection de rang\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112127157042399915)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'fr-ca'
,p_message_text=>'Envoyer en tant que courriel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112119629882399910)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9rie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112045375053399856)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'fr-ca'
,p_message_text=>'Afficher'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112097988915399894)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'fr-ca'
,p_message_text=>'Afficher la valeur globale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112082770583399883)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vue d''une seule rang\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112081053685399882)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'fr-ca'
,p_message_text=>'Trier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112119718782399910)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'fr-ca'
,p_message_text=>'Trier par'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112139328852399924)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vous ne pouvez d\00E9finir qu''un seul tri par colonne.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112139158998399924)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'fr-ca'
,p_message_text=>'Changer de menu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112120768733399911)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'fr-ca'
,p_message_text=>'Empiler'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112075064688399878)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'fr-ca'
,p_message_text=>'commence par'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112119372016399910)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'fr-ca'
,p_message_text=>'Boursier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112040385337399853)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('\00C9tirer les colonnes en largeur')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112081477422399882)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'fr-ca'
,p_message_text=>'Abonnement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112099494313399896)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'fr-ca'
,p_message_text=>'Somme'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112140687913399925)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'fr-ca'
,p_message_text=>'Grille interactive. Rapport : %0, Vue : %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112134661452399921)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'fr-ca'
,p_message_text=>'Somme globale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112117549898399909)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>'Cible'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112123928577399913)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'fr-ca'
,p_message_text=>'Couleur du texte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112050111848399860)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Activer/d\00E9sactiver')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112097807597399894)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'fr-ca'
,p_message_text=>'Infobulle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112078227035399880)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'fr-ca'
,p_message_text=>'Type'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112082689764399883)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9geler')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112079720709399881)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Unit\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112126912741399915)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Des modifications ne sont pas enregistr\00E9es. Voulez-vous continuer?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112079631507399881)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'fr-ca'
,p_message_text=>'Valeur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112116606369399908)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>'Valeur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112121592270399911)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'fr-ca'
,p_message_text=>'La valeur est obligatoire.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112106422552399901)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Valeur (le fuseau horaire ne peut pas \00EAtre modifi\00E9)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112125469795399914)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'fr-ca'
,p_message_text=>'Texte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112117987330399909)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'fr-ca'
,p_message_text=>'Vertical'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112077708999399880)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'fr-ca'
,p_message_text=>'Voir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112115996847399907)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Affich\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112117484837399909)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>'Volume'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112075629865399878)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'fr-ca'
,p_message_text=>'semaines'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112116060365399908)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'fr-ca'
,p_message_text=>'Largeur de colonne minimale (pixel)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112066867298399872)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 compris entre %1 et %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112066550882399872)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 contient %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112066656535399872)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 ne contient pas %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112044707468399856)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 ne commence pas par %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112065374841399871)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 \00E9gal \00E0 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112065565296399871)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 sup\00E9rieur \00E0 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112065642799399871)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 sup\00E9rieur ou \00E9gal \00E0 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112066330899399872)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 dans %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112067518762399872)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 au cours des %1 derniers jours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112067329088399872)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 au cours des %1 derni\00E8res heures')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112067163283399872)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 au cours des %1 derni\00E8res minutes')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112067927205399873)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 au cours des %1 derniers mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112067765525399873)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 au cours des %1 derni\00E8res semaines')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112068143167399873)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 au cours des %1 derni\00E8res ann\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112067470704399872)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 au cours du dernier jour'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112067290070399872)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 au cours de la derni\00E8re heure')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112067072257399872)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 au cours de la derni\00E8re minute')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112067851865399873)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 au cours du mois dernier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112067622245399873)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 au cours de la semaine derni\00E8re')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112068023901399873)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 au cours de la derni\00E8re semaine')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112069917168399874)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 au cours des %1 prochains jours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112069701242399874)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 au cours des %1 prochaines heures'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112069558825399874)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 au cours des %1 prochaines minutes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112070328026399874)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 au cours des %1 prochains mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112070121943399874)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 au cours des %1 prochaines semaines'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112070527501399875)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 au cours des %1 prochaines ann\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112069817830399874)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 au cours du prochain jour'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112069644636399874)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 au cours de la prochaine heure'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112069446672399874)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 au cours de la prochaine minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112070225616399874)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 au cours du prochain mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112070051342399874)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 au cours de la semaine prochaine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112070413973399875)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 au cours de l''ann\00E9e prochaine')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112066032338399871)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 n''est pas vide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112065971551399871)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 est vide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112065704295399871)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 inf\00E9rieur \00E0 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112065891376399871)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 inf\00E9rieur ou \00E9gal \00E0 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112066182676399871)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 semblable \00E0 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112066700208399872)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 correspond \00E0 l''expression rationnelle %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112072654858399876)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'fr-ca'
,p_message_text=>'Il y a %0 minutes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112066939822399872)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 non compris entre %1 et %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112065429350399871)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 diff\00E9rent de %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112066423915399872)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 pas dans %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112068759393399873)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 pas au cours des %1 derniers jours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112068526186399873)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 pas au cours des %1 derni\00E8res heures')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112068300499399873)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 pas au cours des %1 derni\00E8res minutes')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112069198394399874)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 pas au cours des %1 derniers mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112068995144399873)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 pas au cours des %1 derni\00E8res semaines')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112069363178399874)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 pas au cours des %1 derni\00E8res ann\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112068683444399873)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 pas au cours du dernier jour'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112068485938399873)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 pas au cours de la derni\00E8re heure')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112068202534399873)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 pas au cours de la derni\00E8re minute')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112069046490399874)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 pas au cours du mois dernier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112068806941399873)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 pas au cours de la semaine derni\00E8re')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112069299443399874)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 pas au cours de la derni\00E8re ann\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112071112478399875)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 pas au cours des %1 prochains jours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112070981205399875)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 pas au cours des %1 prochaines heures'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112070797103399875)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 pas au cours des %1 prochaines minutes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112071578635399875)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 pas au cours des %1 prochains mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112071376378399875)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 pas au cours des %1 prochaines semaines'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112071726055399875)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 pas au cours des %1 prochaines ann\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112071099076399875)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 pas au cours du prochain jour'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112070872344399875)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 pas au cours de la prochaine heure'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112070672127399875)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 pas au cours de la prochaine minute'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112071471191399875)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 pas au cours du prochain mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112071231526399875)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 pas au cours de la semaine prochaine'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112071688394399875)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 pas au cours de l''ann\00E9e prochaine')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112066298211399872)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 non semblable \00E0 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112073158043399876)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 commence par %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112116742126399908)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112075880119399878)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('ann\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112116895291399908)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112116943156399908)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112125933705399915)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'fr-ca'
,p_message_text=>'Lundi 12 Janvier 2016'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112126011012399915)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'fr-ca'
,p_message_text=>'Janvier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112126192651399915)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'fr-ca'
,p_message_text=>'Il y a 16 heures'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112126220624399915)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'fr-ca'
,p_message_text=>'dans 16 heures'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111981290658399808)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'fr-ca'
,p_message_text=>'Type de fichier non valide. Types de fichier pris en charge : %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112108157613399902)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'fr-ca'
,p_message_text=>'Parcourir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112107892068399902)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9lectionner un fichier')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112107922628399902)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9lectionner des fichiers')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111981043933399808)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Glisser-d\00E9poser')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111981487996399808)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Glisser-d\00E9poser les fichiers')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111982637954399809)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9lectionner un fichier ou d\00E9poser un fichier ici.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111982781905399809)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9lectionner des fichiers ou d\00E9poser des fichiers ici.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111982898984399809)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9lectionner un fichier ou d\00E9poser un fichier ici.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111982971641399809)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9lectionner des fichiers ou d\00E9poser des fichiers ici.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111981362720399808)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 fichiers'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111981172626399808)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'fr-ca'
,p_message_text=>'Fichier trop volumineux. La taille maximale de fichier est %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111968972105399799)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'fr-ca'
,p_message_text=>'Adresse obligatoire.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111967890078399798)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'fr-ca'
,p_message_text=>'Ville'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111968230484399798)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'fr-ca'
,p_message_text=>'Code de pays'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111967976250399798)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Num\00E9ro de maison')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111968823733399799)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'fr-ca'
,p_message_text=>'Latitude'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111968789849399799)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'fr-ca'
,p_message_text=>'Longitude'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111968653968399799)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'fr-ca'
,p_message_text=>'Aff. sur la carte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111968317394399798)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'fr-ca'
,p_message_text=>'Score'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111968051235399798)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'fr-ca'
,p_message_text=>'Code postal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111968150334399798)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('\00C9tat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111967787265399798)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'fr-ca'
,p_message_text=>'Rue'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111967679254399798)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('R\00E9sultats du g\00E9ocodage')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111980272739399807)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('G\00E9ocod\00E9')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111980300054399807)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Non g\00E9ocod\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111968551408399798)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Carte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111968497997399798)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aucune adresse trouv\00E9e.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111969026273399799)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 obligatoire.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112138841180399924)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'fr-ca'
,p_message_text=>'Texte d''aide : %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112032229490399847)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9lectionn\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112032313903399847)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9s\00E9lectionn\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111978295296399806)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'fr-ca'
,p_message_text=>'La valeur #LABEL# ne figure pas dans l''intervalle valide compris entre %0 et %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111978327768399806)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'fr-ca'
,p_message_text=>'#LABEL# n''est pas un multiple de %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111977930621399805)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'fr-ca'
,p_message_text=>'#LABEL# doit correspondre aux valeurs %0 et %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111978163567399806)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>'Non'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112056496086399864)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9sactiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112056578653399864)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Activ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111978007357399805)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>'Oui'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111961456199399793)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ajouter une entr\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112090645473399889)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'fr-ca'
,p_message_text=>'Ajouter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112090712507399889)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'fr-ca'
,p_message_text=>'Supprimer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111961578049399793)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Entr\00E9es s\00E9lectionn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112094489041399892)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Avanc\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112094783219399892)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'fr-ca'
,p_message_text=>'Annuler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112094540214399892)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'fr-ca'
,p_message_text=>'Commun'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112094838507399892)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Options de mod\00E8le en direct')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112095483969399893)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Les options de mod\00E8le ne sont pas disponibles car ce composant n''est pas affich\00E9 sur la page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112094396091399892)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aucune option de mod\00E8le n''a \00E9t\00E9 trouv\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112094606435399892)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'fr-ca'
,p_message_text=>'Enregistrer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111969926175399799)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Effacer le cercle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111971738052399801)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le fichier de styles personnalis\00E9s n''est pas un fichier JSON valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111970218381399800)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'fr-ca'
,p_message_text=>'Outil Distance'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111970068407399800)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Dessiner un cercle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111962625898399794)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La recherche \00E0 facettes n\00E9cessite une source de donn\00E9es au niveau de la r\00E9gion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111965257329399796)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'fr-ca'
,p_message_text=>'Emplacement courant'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111966351381399797)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Les coordonn\00E9es de la position initiale ne sont pas valides.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111963735202399795)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La position initiale doit \00EAtre une g\00E9om\00E9trie de type point.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111966118303399797)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'fr-ca'
,p_message_text=>'km'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111964794717399796)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'fr-ca'
,p_message_text=>'Couche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112098063877399894)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'fr-ca'
,p_message_text=>'Couche : %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111969338978399799)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'fr-ca'
,p_message_text=>'Carte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111962565591399794)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'fr-ca'
,p_message_text=>'Messages'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111966236225399797)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'fr-ca'
,p_message_text=>'miles'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112097080663399894)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Les donn\00E9es contiennent plus de %0 rang\00E9es, ce qui d\00E9passe le nombre maximal autoris\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111964564194399796)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">Conditions</a> &nbsp;&nbsp; Donn\00E9es de la carte &copy; 2017 HERE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111963488759399795)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le type de donn\00E9es SDO_GEOMETRY n''est pas disponible dans cette base de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111964616390399796)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'fr-ca'
,p_message_text=>'<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; contributeurs OpenStreetMap</a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111964812581399796)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'fr-ca'
,p_message_text=>'Points'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112098132357399895)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 points'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111970197458399800)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'fr-ca'
,p_message_text=>'Zoom sur le rectangle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111969868296399799)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'fr-ca'
,p_message_text=>'Supprimer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111965115381399796)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('R\00E9initialiser l''azimut \00E0 Nord')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112045425741399856)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'fr-ca'
,p_message_text=>'Basculer en mode 2D'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112045558230399856)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'fr-ca'
,p_message_text=>'Basculer en mode 3D'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111969730642399799)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Activer/d\00E9sactiver l''avis de droit d''auteur')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111970360430399800)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'fr-ca'
,p_message_text=>'Distance totale'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111964986436399796)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'fr-ca'
,p_message_text=>'Zoom avant'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111965067824399796)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Zoom arri\00E8re')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112092576910399890)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'fr-ca'
,p_message_text=>'Gras'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112093446251399891)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'fr-ca'
,p_message_text=>'Image'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112093000530399891)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Code ins\00E9r\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112106677992399901)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ins\00E9rer une image')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112106762818399901)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ins\00E9rer un lien')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112092636239399891)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'fr-ca'
,p_message_text=>'Italique'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112107369721399901)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'fr-ca'
,p_message_text=>'Lien'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112093310436399891)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'fr-ca'
,p_message_text=>'Liste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112093243048399891)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Liste tri\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112092702961399891)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aper\00E7u')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112092846074399891)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Il n''y a rien \00E0 pr\00E9visualiser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112092931188399891)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Barr\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112093125927399891)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Liste non tri\00E9e')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112072031984399876)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'fr-ca'
,p_message_text=>'courant'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112129517193399917)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>'Plus...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112071992574399876)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'fr-ca'
,p_message_text=>'Chargement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112103714815399899)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'fr-ca'
,p_message_text=>'Message d''avis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112077095038399879)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La valeur pour #LABEL# doit \00EAtre un nombre inf\00E9rieur ou \00E9gal \00E0 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112077135909399879)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La valeur pour #LABEL# doit \00EAtre un nombre valide.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112077290106399879)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La valeur pour #LABEL# ne correspond pas au format num\00E9rique %0 (exemple : %1).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112076995440399879)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La valeur pour #LABEL# doit \00EAtre un nombre sup\00E9rieur ou \00E9gal \00E0 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112076896687399879)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La valeur pour #LABEL# doit \00EAtre un nombre compris entre %0 et %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112072123531399876)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('s''ouvre dans une nouvelle fen\00EAtre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112025362144399842)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Cette page a d\00E9j\00E0 \00E9t\00E9 soumise et ne peut pas \00EAtre soumise \00E0 nouveau.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112007939087399829)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'fr-ca'
,p_message_text=>'L''application "%0", page "%1", est introuvable.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112041729207399853)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Une valeur doit \00EAtre indiqu\00E9e pour #LABEL#.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111985055242399811)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'fr-ca'
,p_message_text=>'Rechercher'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112091095246399889)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'fr-ca'
,p_message_text=>'Fermer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112090931004399889)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'fr-ca'
,p_message_text=>'Rechercher %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112091299791399890)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'fr-ca'
,p_message_text=>'Suivant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112091187892399889)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111977195168399805)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Entrez un terme de recherche comportant au moins %0 caract\00E8res.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112046681811399857)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'fr-ca'
,p_message_text=>'Liste de valeurs contextuelle : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111977259883399805)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'fr-ca'
,p_message_text=>'Entrez un terme de recherche.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111977095299399805)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aucun r\00E9sultat trouv\00E9.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111976921041399805)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'fr-ca'
,p_message_text=>'Supprimer %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112064889163399870)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'fr-ca'
,p_message_text=>'Terme de recherche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112090833787399889)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Rechercher'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112101583564399897)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'fr-ca'
,p_message_text=>'Traitement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111975592408399804)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ajouter \00E0 \00E9cran d''accueil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111971524640399801)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
'    <p class="a-pwaDialog-intro">Votre appareil ou votre navigateur ne semble pas prendre en charge l''installation des applications Web progressives pour le moment.</p>',
unistr('    <p class="a-pwaDialog-intro">Si cette application est d\00E9j\00E0 install\00E9e sur votre appareil, ouvrez-la \00E0 partir de votre \00E9cran d''accueil.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111971191549399800)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ce site Web dispose d''une fonctionnalit\00E9 d''application. Ajoutez-la \00E0 votre \00E9cran d''accueil pour l''utiliser en plein \00E9cran.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Touchez l''ic\00F4ne <strong>Menu</strong> dans la navigation du bas</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Touchez <strong>Installer</strong></p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Touchez <strong>Ajouter</strong> pour confirmer</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111971263700399800)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ce site Web dispose d''une fonctionnalit\00E9 d''application qui offre une exp\00E9rience optimale dans Chrome ou Edge.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Touchez l''ic\00F4ne <strong>Menu</strong> \00E0 c\00F4t\00E9 de la barre d''adresse</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">2. Touchez <strong>Installer</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111970841441399800)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ce site Web dispose d''une fonctionnalit\00E9 d''application qui offre une exp\00E9rience optimale dans Safari.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Touchez l''ic\00F4ne <strong>Partager</strong> dans la navigation du bas</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Touchez <strong>Ouvrir dans Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111970541668399800)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ce site Web dispose d''une fonctionnalit\00E9 d''application. Ajoutez-la \00E0 votre \00E9cran d''accueil pour une exp\00E9rience optimale.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Touchez l''ic\00F4ne <strong>Partager</strong> \00E0 c\00F4t\00E9 de la barre d''adresse</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Touchez <strong>Ajouter \00E0 \00E9cran d''accueil</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Touchez <strong style="color:#007AE1;">Ajoute</strong> pour confirmer</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111970475655399800)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ce site Web dispose d''une fonctionnalit\00E9 d''application. Ajoutez-la \00E0 votre \00E9cran d''accueil pour une exp\00E9rience optimale.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Touchez l''ic\00F4ne <strong>Partager</strong> dans la navigation du bas</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Faites d\00E9filer l''\00E9cran et touchez <strong>Ajouter \00E0 \00E9cran d''accueil</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Touchez <strong style="color:#007AE1;">Ajouter</strong> pour confirmer</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111965463162399796)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ce site Web dispose d''une fonctionnalit\00E9 d''application. Ajoutez-la \00E0 votre \00E9cran d''accueil pour une exp\00E9rience optimale.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Touchez l''ic\00F4ne <strong>Plus</strong> \00E0 c\00F4t\00E9 de la barre d''adresse</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Touchez <strong>Ajouter \00E0 \00E9cran d''accueil</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Touchez <strong style="color:#007AE1;">Ajouter</strong> pour confirmer</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111970740532399800)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ce site Web dispose d''une fonctionnalit\00E9 d''application. Ajoutez-la \00E0 votre \00E9cran d''accueil pour une exp\00E9rience optimale.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Touchez l''ic\00F4ne <strong>Partager</strong> \00E0 c\00F4t\00E9 de la barre d''adresse</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
'        <p class="a-pwaDialog-stepText">Touchez <strong>Ouvrir dans Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111970660897399800)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ce site Web dispose d''une fonctionnalit\00E9 d''application. Ajoutez-la \00E0 votre \00E9cran d''accueil pour une exp\00E9rience optimale.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Touchez l''ic\00F4ne <strong>Partager</strong> dans la navigation du bas</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
'        <p class="a-pwaDialog-stepText">Touchez <strong>Ouvrir dans Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111971468627399801)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ce site Web dispose d''une fonctionnalit\00E9 d''application qui offre une exp\00E9rience optimale dans Chrome.</p>'),
'    <p class="a-pwaDialog-intro">Firefox ne prend actuellement pas en charge l''installation d''applications Web.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111970937933399800)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ce site Web dispose d''une fonctionnalit\00E9 d''application qui offre une exp\00E9rience optimale dans Chrome ou Edge.</p>'),
'    <p class="a-pwaDialog-intro">Firefox ne prend actuellement pas en charge l''installation d''applications Web sur macOS.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111971035848399800)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ce site Web dispose d''une fonctionnalit\00E9 d''application qui offre une exp\00E9rience optimale dans Chrome ou Edge.</p>'),
'    <p class="a-pwaDialog-intro">Safari ne prend actuellement pas en charge l''installation d''applications Web sur macOS.</p>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111971361374399800)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Ce site Web dispose d''une fonctionnalit\00E9 d''application qui offre une exp\00E9rience optimale dans Chrome ou Edge.</p>'),
'    <p class="a-pwaDialog-intro">Firefox ne prend actuellement pas en charge l''installation d''applications Web sur Windows.</p>',
'</div>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111973838249399802)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
'    <h1>Connexion impossible</h1>',
'    <p>Vous avez besoin d''une connexion Internet pour utiliser cette application.</p>',
unistr('    <button type="button">R\00E9essayer</button>'),
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111973795395399802)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Connexion impossible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112113565091399906)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'fr-ca'
,p_message_text=>'Ajouter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112057992045399865)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Toute la journ\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112136830373399922)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'fr-ca'
,p_message_text=>'Envoyer une invitation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112136674561399922)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'fr-ca'
,p_message_text=>'Options'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112059755785399867)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vue quotidienne pour toute la journ\00E9e ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112059590719399866)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vue quotidienne pour les donn\00E9es avec l''heure')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112104460306399899)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'fr-ca'
,p_message_text=>'Jour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112098871755399895)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'fr-ca'
,p_message_text=>'Description'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111989417183399814)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'fr-ca'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111989228302399814)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'fr-ca'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111989173216399814)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'fr-ca'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111989318516399814)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'fr-ca'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111988809335399813)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'fr-ca'
,p_message_text=>'Date de fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111989033942399814)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Nom de l''\00E9v\00E9nement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112136762944399922)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'fr-ca'
,p_message_text=>'Invitation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112104573702399899)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'fr-ca'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112104251760399899)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'fr-ca'
,p_message_text=>'Mois'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112107002108399901)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'fr-ca'
,p_message_text=>'Suivant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112121337566399911)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aucun \00E9v\00E9nement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112137028049399923)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Modifier un \00E9v\00E9nement existant.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112136944185399923)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'fr-ca'
,p_message_text=>'Envoi d''une invitation par courriel.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112107146853399901)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112115199444399907)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'fr-ca'
,p_message_text=>'Envoyer un courriel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112114967500399907)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'fr-ca'
,p_message_text=>'Envoyer un courriel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112137763310399923)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'fr-ca'
,p_message_text=>'Tous les champs sont obligatoires.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112137618609399923)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Envoyer une invitation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112136531583399922)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'fr-ca'
,p_message_text=>'Objet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112115082667399907)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('\00C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111988925556399813)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Date de d\00E9but')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112112874624399905)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'fr-ca'
,p_message_text=>'Formulaire sur %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112059371646399866)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'fr-ca'
,p_message_text=>'Heure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112107202391399901)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'fr-ca'
,p_message_text=>'Aujourd''hui'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112105036526399900)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'fr-ca'
,p_message_text=>'Voir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112104356437399899)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'fr-ca'
,p_message_text=>'Semaine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112059685730399867)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vue hebdomadaire pour toute la journ\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112059450502399866)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vue hebdomadaire pour les donn\00E9es avec l''heure')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112104922879399900)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ann\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112104684740399899)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'fr-ca'
,p_message_text=>'Colonnes...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112104760027399899)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'fr-ca'
,p_message_text=>'Charger plus...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112036886230399850)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111983141084399809)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'fr-ca'
,p_message_text=>'Charger plus...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111985240946399811)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'fr-ca'
,p_message_text=>'Rechercher...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112104864287399899)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'fr-ca'
,p_message_text=>'Charger plus...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112106923623399901)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('ID r\00E9gion %0 introuvable.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111985116066399811)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aucune donn\00E9e d\00E9tect\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112009235793399830)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Impossible de r\00E9initialiser la pagination de r\00E9gion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111977449922399805)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Erreur lors de la d\00E9finition de pagination de r\00E9gion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112098205747399895)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'fr-ca'
,p_message_text=>'Colonnes...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112106817940399901)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le type de r\00E9gion %0 n''est pas pris en charge.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111977335465399805)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Erreur lors du rendu de la r\00E9gion "#COMPONENT_NAME#".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112041825537399854)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Une valeur doit \00EAtre indiqu\00E9e pour #COLUMN_HEADER#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112136193793399922)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0, \00E9diteur de texte enrichi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112043944175399855)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le balisage HTML de texte enrichi d\00E9passe la longueur maximale de l''\00E9l\00E9ment (r\00E9elle : %0, autoris\00E9e : %1 caract\00E8res)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112103874897399899)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'fr-ca'
,p_message_text=>'Supprimer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112095644837399893)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'fr-ca'
,p_message_text=>'En double'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112093900488399891)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Colonnes affich\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112093811495399891)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'fr-ca'
,p_message_text=>'Exclure les valeurs nulles'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112103916576399899)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'fr-ca'
,p_message_text=>'Ajouter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112057580717399865)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9placer vers le bas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112057615222399865)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9placer vers le haut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112093661394399891)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'fr-ca'
,p_message_text=>'Suivant'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112094288074399892)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>'Autres colonnes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112093707231399891)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112094054685399892)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Rang\00E9e %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112094126701399892)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Rang\00E9e %0 de %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112095717172399893)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'fr-ca'
,p_message_text=>'Actualiser'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112095891898399893)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'fr-ca'
,p_message_text=>'Annuler les modifications'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112093540008399891)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Menu Param\00E8tres')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112054586217399863)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'fr-ca'
,p_message_text=>'Par exemple, %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111962014705399794)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'fr-ca'
,p_message_text=>'Se reconnecter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111961928338399794)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'fr-ca'
,p_message_text=>'Votre session a pris fin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111962159519399794)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('\00C9tendre')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111961708757399794)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Votre session se terminera \00E0 %0. Souhaitez-vous la prolonger?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111961833334399794)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Votre session se terminera \00E0 %0 et ne pourra pas \00EAtre prolong\00E9e. Enregistrez votre travail maintenant pour \00E9viter de perdre des donn\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112114758728399907)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Erreur lors du traitement du code de nettoyage de session de base de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112007829690399829)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Erreur lors du traitement du code de configuration de session de base de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111981969990399808)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'fr-ca'
,p_message_text=>'Votre session a pris fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112113633174399906)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Fermez cette bo\00EEte de dialogue et cliquez sur le bouton Recharger de votre navigateur pour obtenir une nouvelle session.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112132962711399920)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Cliquez <a href="%0">ici</a> pour cr\00E9er une nouvelle session.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112019568555399837)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'fr-ca'
,p_message_text=>'Session non valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112059085925399866)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aucun r\00F4le dynamique n''a pu \00EAtre activ\00E9 dans la session Real Application Security pour l''utilisateur "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112005786406399827)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('ERR-99900 Impossible de cr\00E9er l''ID session unique : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112022024524399839)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Violation de protection de l''\00E9tat de session. Cause possible : modification manuelle de l''\00E9l\00E9ment de page prot\00E9g\00E9 %0. Si vous n''\00EAtes pas s\00FBr de la cause de l''erreur, communiquez avec votre administrateur pour obtenir de l''aide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112141167132399926)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Violation de protection de page. Cause possible : soumission d''une page dont le chargement n''est pas encore termin\00E9 ou modification manuelle d''\00E9l\00E9ments de page prot\00E9g\00E9s. Pour obtenir de l''aide, communiquez avec l''administrateur de l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112140127333399925)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 contient l''un des caract\00E8res non valides suivants : &<>"/;,*|=% ou --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112140275493399925)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 contient l''un des caract\00E8res non valides suivants : &<>"/;,*|=% ou -- ou un saut de ligne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112139972312399925)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 contient des caract\00E8res sp\00E9ciaux. Seuls les caract\00E8res a-Z, 0-9 et les espaces sont autoris\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112140044601399925)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 contient <, > ou ", qui ne sont pas des caract\00E8res valides.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111984172751399810)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aucune somme de contr\00F4le n''a \00E9t\00E9 fournie au traitement de l''affichage d''une page exigeant une somme de contr\00F4le lorsqu''une ou plusieurs valeurs de demande, de vidage de cache ou d''argument sont transmises en tant que param\00E8tres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112016991895399835)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Violation de protection de l''\00E9tat de session. Cause possible : modification manuelle d''une URL contenant une somme de contr\00F4le ou utilisation d''un lien dont la somme de contr\00F4le est incorrecte ou manquante. Si vous n''\00EAtes pas s\00FBr de la cause de l''err')
||'eur, communiquez avec votre administrateur pour obtenir de l''aide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112094907496399892)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9sactiver le mode de contraste \00E9lev\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112095010921399892)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Activer le mode de contraste \00E9lev\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112013609227399833)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'fr-ca'
,p_message_text=>'Bas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112013871081399833)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'fr-ca'
,p_message_text=>'Vers le bas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112013998215399833)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9placer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112014047513399833)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Tout d\00E9placer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112014129513399833)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'fr-ca'
,p_message_text=>'Supprimer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112014223976399833)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'fr-ca'
,p_message_text=>'Tout supprimer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112014383733399834)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('R\00E9initialiser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112013590843399833)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'fr-ca'
,p_message_text=>'Haut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112013710526399833)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'fr-ca'
,p_message_text=>'Vers le haut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112122655602399912)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'fr-ca'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112123386491399913)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'fr-ca'
,p_message_text=>'dans %0 jour(s)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112122586741399912)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'fr-ca'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112123471829399913)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'fr-ca'
,p_message_text=>'dans %0 heure(s)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112122326678399912)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'fr-ca'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112123543800399913)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'fr-ca'
,p_message_text=>'dans %0 minute(s)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112122905708399912)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112123111397399913)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'fr-ca'
,p_message_text=>'dans %0 mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112122422439399912)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'fr-ca'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112123234314399913)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'fr-ca'
,p_message_text=>'dans %0 seconde(s)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112122797184399912)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'fr-ca'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112123642630399913)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'fr-ca'
,p_message_text=>'dans %0 semaine(s)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112122833472399912)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'fr-ca'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112123093230399913)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('dans %0 ann\00E9e(s)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111962935929399795)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'fr-ca'
,p_message_text=>'[Ligne]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111963342100399795)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'fr-ca'
,p_message_text=>'[Lignes multiples]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111963163280399795)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'fr-ca'
,p_message_text=>'[Points multiples]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111963560299399795)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'fr-ca'
,p_message_text=>'[Polygones multiples]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111963694480399795)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('[Objet de g\00E9om\00E9trie]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111962865357399794)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'fr-ca'
,p_message_text=>'[Point (%0,%1)]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111963066018399795)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'fr-ca'
,p_message_text=>'[Polygone]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112040262300399852)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('R\00E9duire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112040117391399852)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'fr-ca'
,p_message_text=>'Restaurer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112086657474399886)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'fr-ca'
,p_message_text=>'Effacer la notation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112076568185399879)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'fr-ca'
,p_message_text=>'La valeur %0 ne figure pas dans l''intervalle de notation valide compris entre 1 et %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112076627402399879)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 n''est pas une valeur num\00E9rique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112072713108399876)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Message de r\00E9ussite')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112135814877399922)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'fr-ca'
,p_message_text=>'Suivant'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112135759430399922)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112121495343399911)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'fr-ca'
,p_message_text=>'Barre d''outils'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112136204332399922)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9velopper/R\00E9duire la navigation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112136307455399922)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9velopper/R\00E9duire la colonne lat\00E9rale')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112045920218399857)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>'Navigation principale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112052938119399862)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'fr-ca'
,p_message_text=>'1 jour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112052751621399862)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'fr-ca'
,p_message_text=>'1 heure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112053061389399862)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 jours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112052875965399862)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 heures'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112052632335399862)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 minutes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112053260006399862)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 semaines'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112053126332399862)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'fr-ca'
,p_message_text=>'1 semaine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112139487327399924)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9but de la page')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112001405652399824)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Activ\00E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111975298894399803)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>'Erreur lors du traitement de la demande.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112054644373399863)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'fr-ca'
,p_message_text=>'Valeur obligatoire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112137592459399923)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Attendez que la page soit compl\00E8tement charg\00E9e et r\00E9essayez.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112097798458399894)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Cette page comporte des modifications non enregistr\00E9es.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111978665670399806)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'fr-ca'
,p_message_text=>'Le classeur ne contient aucune feuille de calcul active.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111978508894399806)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le classeur n''a pas \00E9t\00E9 initialis\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111978494543399806)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Une erreur interne est survenue lors de la cr\00E9ation du fichier XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111980907250399808)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'fr-ca'
,p_message_text=>'Feuille'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112112609707399905)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'fr-ca'
,p_message_text=>'Actions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112030152553399845)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'fr-ca'
,p_message_text=>'Menu Actions'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112025818094399842)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'fr-ca'
,p_message_text=>'Ajouter une fonction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112025778934399842)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>'Ajouter une colonne de regroupement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112059913421399867)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>'Ajouter une colonne de pivotement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112060084670399867)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ajouter une colonne de rang\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112000281826399823)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Agr\00E9ger')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112036365794399850)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Agr\00E9gation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112017435154399836)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'fr-ca'
,p_message_text=>'Moyenne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112021786072399839)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'fr-ca'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112017565880399836)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'fr-ca'
,p_message_text=>'Maximum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112017744892399836)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('M\00E9diane')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112017616922399836)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'fr-ca'
,p_message_text=>'Minimum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112017384981399836)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'fr-ca'
,p_message_text=>'Somme de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112018452963399837)
,p_name=>'APEXIR_ALL'
,p_message_language=>'fr-ca'
,p_message_text=>'Tout'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111999513756399823)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'fr-ca'
,p_message_text=>'Toutes les colonnes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111982079402399808)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Toutes les rang\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112109699103399903)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'fr-ca'
,p_message_text=>'Alternatif'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112111270865399904)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Valeur par d\00E9faut de remplacement :  %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112012151286399832)
,p_name=>'APEXIR_AND'
,p_message_language=>'fr-ca'
,p_message_text=>'et'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112001601813399824)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'fr-ca'
,p_message_text=>'Appliquer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111995349257399820)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'fr-ca'
,p_message_text=>'Croissant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112014974659399834)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'fr-ca'
,p_message_text=>'En date du %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112111895263399904)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'fr-ca'
,p_message_text=>'Moyenne de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112103244851399898)
,p_name=>'APEXIR_BAR'
,p_message_language=>'fr-ca'
,p_message_text=>'Barres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112001084401399824)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'fr-ca'
,p_message_text=>'compris entre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111994166122399819)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Couleur d''arri\00E8re-plan')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111996074788399820)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'fr-ca'
,p_message_text=>'bleu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112027752038399843)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'fr-ca'
,p_message_text=>'Bas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111996644606399821)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'fr-ca'
,p_message_text=>'Annuler'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112002587789399825)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Cat\00E9gorie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111994022927399819)
,p_name=>'APEXIR_CELL'
,p_message_language=>'fr-ca'
,p_message_text=>'Cellule'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112018317494399836)
,p_name=>'APEXIR_CHART'
,p_message_language=>'fr-ca'
,p_message_text=>'Graphique'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112028624902399844)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'fr-ca'
,p_message_text=>'Initialisation...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112064927530399871)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vous devez sp\00E9cifier une \00E9tiquette de graphique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112077323024399879)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Votre interrogation d\00E9passe le maximum de %0 points de donn\00E9es par graphique. Appliquez un filtre pour r\00E9duire le nombre d''enregistrements de votre interrogation de base.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112076272080399879)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le nombre maximal de rang\00E9es d''une interrogation de graphique limite le nombre de rang\00E9es de l''interrogation de base, et non le nombre de rang\00E9es affich\00E9es. Votre interrogation de base d\00E9passe le nombre maximal de rang\00E9es de %0. Appliquez un filtre p')
||unistr('our r\00E9duire le nombre d''enregistrements de votre interrogation de base.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111999674712399823)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'fr-ca'
,p_message_text=>'Type de graphique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112072995103399876)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Tout s\00E9lectionner')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112015376574399834)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9lectionner un format de rapport')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112022704609399840)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'fr-ca'
,p_message_text=>'effacer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111996587937399821)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>'Colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112033912815399848)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'fr-ca'
,p_message_text=>'Colonnes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112106285531399900)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'fr-ca'
,p_message_text=>'Filtrer...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112024762539399841)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Menu d''en-t\00EAte de colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112028466683399844)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'fr-ca'
,p_message_text=>'Informations sur la colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112108530350399902)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('\00C9tiquette de colonne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112026184484399842)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'fr-ca'
,p_message_text=>'Colonne %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112010262392399831)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'fr-ca'
,p_message_text=>'contient'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112011123134399831)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'fr-ca'
,p_message_text=>'ne contient pas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111995083827399820)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'fr-ca'
,p_message_text=>'dans'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112011393012399831)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'fr-ca'
,p_message_text=>'ne se situe pas dans le dernier intervalle de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112019883575399838)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'fr-ca'
,p_message_text=>'ne se situe dans le prochain intervalle de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112011233884399831)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'fr-ca'
,p_message_text=>'se situe dans le dernier intervalle de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112019755216399837)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'fr-ca'
,p_message_text=>'se situe dans le prochain intervalle de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111994982995399819)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'fr-ca'
,p_message_text=>'n''est pas null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111994892189399819)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'fr-ca'
,p_message_text=>'est nul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111994623025399819)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('semblable \00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111995168916399820)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'fr-ca'
,p_message_text=>'pas dans'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111994731184399819)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('non semblable \00E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112010572276399831)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('correspond \00E0 l''expression rationnelle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112015261343399834)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'fr-ca'
,p_message_text=>'Calcul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112075965502399878)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'fr-ca'
,p_message_text=>'Expression de calcul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112034248646399848)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Cr\00E9er un calcul \00E0 l''aide d''alias de colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112034333158399848)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'fr-ca'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112034443119399848)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'fr-ca'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112034598469399848)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'fr-ca'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111980438545399807)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'fr-ca'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112019126319399837)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'fr-ca'
,p_message_text=>'Calculer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112026794420399843)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'fr-ca'
,p_message_text=>'Commande BREAK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112029729294399845)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'fr-ca'
,p_message_text=>'Commandes BREAK'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112114133282399906)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'fr-ca'
,p_message_text=>'Colonnes de commande BREAK'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111977563607399805)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'fr-ca'
,p_message_text=>'Nombre de valeurs distinctes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112112316061399905)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'fr-ca'
,p_message_text=>'Nombre de valeurs distinctes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112112228330399905)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'fr-ca'
,p_message_text=>'Nombre de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112084328266399884)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'fr-ca'
,p_message_text=>'Tous les jours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112139083541399924)
,p_name=>'APEXIR_DATA'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Donn\00E9es')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112028512823399844)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Donn\00E9es du rapport il y a %0 minutes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112102025116399897)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aide sur la grille de donn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112000378578399823)
,p_name=>'APEXIR_DATE'
,p_message_language=>'fr-ca'
,p_message_text=>'Date'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112032429534399847)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112109491188399903)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Type de rapport par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111996773864399821)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'fr-ca'
,p_message_text=>'Supprimer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112000673374399824)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Voulez-vous supprimer ces param\00E8tres de rapport?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112095323779399892)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Supprimer le rapport par d\00E9faut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112026465473399842)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'fr-ca'
,p_message_text=>'Supprimer le rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111995430850399820)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9croissant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112002601049399825)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'fr-ca'
,p_message_text=>'Description'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112024692239399841)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vue d''une seule rang\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112032946692399847)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'fr-ca'
,p_message_text=>'Sens %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112033811232399848)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9sactiv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111996286547399820)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Affich\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111999400717399823)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Colonnes affich\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112032813272399847)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'fr-ca'
,p_message_text=>'Afficher dans le rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112027615123399843)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'fr-ca'
,p_message_text=>'Vers le bas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112019206173399837)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('T\00E9l\00E9charger')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112032733513399847)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'fr-ca'
,p_message_text=>'Ne pas afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112098707530399895)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Il existe d\00E9j\00E0 une mise en surbrillance avec la m\00EAme condition')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112114363732399906)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>'Colonne de pivotement. La liste des colonnes de pivotement doit contenir des valeurs uniques.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112114592829399906)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'fr-ca'
,p_message_text=>'Modifier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112028794844399844)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Modifier les param\00E8tres du graphique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112035330743399849)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'fr-ca'
,p_message_text=>'Modifier le graphique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112035777499399849)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'fr-ca'
,p_message_text=>'Modifier le filtre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112090145129399889)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'fr-ca'
,p_message_text=>'Modifier le regroupement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112035699616399849)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'fr-ca'
,p_message_text=>'Modifier la mise en surbrillance'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112060207129399867)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Modifier le tableau crois\00E9 dynamique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112109769185399903)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'fr-ca'
,p_message_text=>'Courriel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111988421150399813)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'fr-ca'
,p_message_text=>'Adresse de courriel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112110018337399903)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'fr-ca'
,p_message_text=>'Cci'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112110224650399903)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'fr-ca'
,p_message_text=>'Corps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112109922454399903)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'fr-ca'
,p_message_text=>'Cc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112110775384399904)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Fr\00E9quence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111992122920399817)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le courriel n''a pas \00E9t\00E9 configur\00E9 pour cette application. Communiquez avec l''administrateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112083614804399884)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vous devez sp\00E9cifier une adresse de courriel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112110317236399903)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'fr-ca'
,p_message_text=>'Voir le fichier joint'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112110178993399903)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'fr-ca'
,p_message_text=>'Objet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112084604277399885)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vous devez sp\00E9cifier un objet pour le courriel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112109836302399903)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('\00C0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111993800634399819)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Activ\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112035577412399849)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Activer/D\00E9sactiver')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112035037106399849)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>'Erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112034635217399848)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'fr-ca'
,p_message_text=>'Exemples'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112035443976399849)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'fr-ca'
,p_message_text=>'Exemples :'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111999311587399823)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'fr-ca'
,p_message_text=>'Exclure les valeurs nulles'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112036093278399849)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9velopper/R\00E9duire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112033679761399848)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'fr-ca'
,p_message_text=>'Expression'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112018768084399837)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'fr-ca'
,p_message_text=>'Filtrer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112029691069399845)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'fr-ca'
,p_message_text=>'Filtres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112039956243399852)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'fr-ca'
,p_message_text=>'Expression de filtre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112136424203399922)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'fr-ca'
,p_message_text=>'L''expression de filtre est trop longue.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112039886855399852)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'fr-ca'
,p_message_text=>'Type de filtre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112036237150399850)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9lectionner les colonnes \00E0 rechercher')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112019013982399837)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'fr-ca'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112033445478399847)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Une interrogation Flashback permet de voir les donn\00E9es telles qu''elles existaient \00E0 un moment donn\00E9 pr\00E9c\00E9dent.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112084065283399884)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Dur\00E9e de l''op\00E9ration Flashback')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112085449774399885)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'fr-ca'
,p_message_text=>'Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112015132633399834)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'fr-ca'
,p_message_text=>'Masque de format %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112026347254399842)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'fr-ca'
,p_message_text=>'Fonction'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112034169166399848)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'fr-ca'
,p_message_text=>'Fonctions %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112109374855399903)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Fonctions / Op\00E9rateurs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112026041276399842)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'fr-ca'
,p_message_text=>'Fonction %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112018590975399837)
,p_name=>'APEXIR_GO'
,p_message_language=>'fr-ca'
,p_message_text=>'Aller'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111994369669399819)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'fr-ca'
,p_message_text=>'vert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111977634523399805)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'fr-ca'
,p_message_text=>'Regroupement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112110492662399904)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>'Colonne de regroupement %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112065061467399871)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vous devez sp\00E9cifier une colonne de regroupement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112076181854399879)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le nombre maximal de rang\00E9es d''une interrogation de regroupement limite le nombre de rang\00E9es de l''interrogation de base, et non le nombre de rang\00E9es affich\00E9es. Votre interrogation de base d\00E9passe le nombre maximal de rang\00E9es de %0. Appliquez un filtr')
||unistr('e pour r\00E9duire le nombre d''enregistrements de votre interrogation de base.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112056706054399865)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'fr-ca'
,p_message_text=>'Tri de regroupement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112114211247399906)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'fr-ca'
,p_message_text=>'Ordre de tri du regroupement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111999738509399823)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>'Colonne horizontale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112031325024399846)
,p_name=>'APEXIR_HELP'
,p_message_language=>'fr-ca'
,p_message_text=>'Aide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112023169652399840)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Les rapports interactifs permettent aux utilisateurs finaux de personnaliser les rapports. Les utilisateurs peuvent modifier la disposition des donn\00E9es du rapport en s\00E9lectionnant des colonnes, en appliquant des filtres, en mettant en surbrillance de')
||unistr('s valeurs et en les triant. En outre, ils peuvent d\00E9finir des sections, des agr\00E9gations, des graphiques, des regroupements et ajouter des calculs personnalis\00E9s. Ils peuvent \00E9galement configurer un abonnement afin qu''une version HTML du rapport leur s')
||unistr('oit envoy\00E9e par courriel selon une fr\00E9quence d\00E9termin\00E9e. Les utilisateurs peuvent cr\00E9er plusieurs variantes d''un rapport et les enregistrer en tant que rapports nomm\00E9s, pour une consultation publique ou priv\00E9e. '),
'<p/>',
unistr('Les sections qui suivent r\00E9capitulent les modes de personnalisation d''un rapport interactif. Pour en savoir plus, consultez la section "Utilisation des rapports interactifs" dans le <i>Guide de l''utilisateur final d''Oracle Application Express</i></a>')
||'.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112030291113399845)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le menu Actions appara\00EEt \00E0 droite du bouton Aller de la barre de recherche. Utilisez ce menu pour personnaliser un rapport interactif.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112023901062399841)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Les agr\00E9gats sont des calculs math\00E9matiques effectu\00E9s sur une colonne. Ils s''affichent apr\00E8s chaque commande BREAK et \00E0 la fin du rapport dans la colonne dans laquelle ils sont d\00E9finis. Les options sont les suivantes : <p> </p><ul> <li><strong>Agr\00E9ga')
||unistr('tion</strong> permet de s\00E9lectionner une agr\00E9gation pr\00E9c\00E9demment d\00E9finie pour la modifier.</li> <li><strong>Fonction</strong> est la fonction \00E0 ex\00E9cuter (par exemple, SUM, MIN).</li> <li><strong>Colonne</strong> permet de s\00E9lectionner la colonne \00E0 la')
||unistr('quelle appliquer la fonction math\00E9matique. Seules les colonnes num\00E9riques s''affichent.</li> </ul>')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112024058366399841)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Vous pouvez d\00E9finir un graphique par rapport enregistr\00E9. Une fois qu''il est d\00E9fini, vous pouvez passer de la vue de graphique \00E0 la vue de rapport \00E0 l''aide des ic\00F4nes de vue de la barre de recherche.'),
'Les options sont les suivantes :  ',
'<p>',
'</p><ul>',
unistr('<li><strong>Type de graphique</strong> identifie le type de graphique \00E0 inclure. S\00E9lectionnez une option parmi Barres horizontales, Barres verticales, Secteurs ou Lin\00E9aire.</li> <li><strong>\00C9tiquette</strong> permet de s\00E9lectionner la colonne \00E0 utili')
||unistr('ser comme \00E9tiquette.</li> <li><strong>Titre de l''axe pour l''\00E9tiquette</strong> est le titre qui s''affiche sur l''axe associ\00E9 \00E0 la colonne s\00E9lectionn\00E9e pour l''\00E9tiquette. Cette option n''est pas disponible pour les graphiques \00E0 secteurs.</li> <li><strong')
||unistr('>Valeur</strong> permet de s\00E9lectionner la colonne \00E0 utiliser comme valeur. Si votre fonction est de type COUNT, il n''est pas n\00E9cessaire de s\00E9lectionner une valeur.</li> <li><strong>Titre de l''axe pour la valeur</strong> est le titre qui s''affiche su')
||unistr('r l''axe associ\00E9 \00E0 la colonne s\00E9lectionn\00E9e pour la valeur. Cette option n''est pas disponible pour les graphiques \00E0 secteurs.</li> <li><strong>Fonction</strong> est une fonction facultative \00E0 ex\00E9cuter sur la colonne s\00E9lectionn\00E9e pour Valeur.</li> <li><')
||unistr('strong>Trier</strong> permet de trier votre jeu de r\00E9sultats.</li></ul>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112023303199399840)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si vous cliquez sur un en-t\00EAte de colonne, vous obtenez un menu proposant les options suivantes : <p></p> <ul> <li>L''ic\00F4ne <strong>Trier par ordre croissant</strong> permet de trier le rapport selon la colonne dans l''ordre croissant.</li> <li>L''ic\00F4ne')
||unistr(' <strong>Trier par ordre d\00E9croissant</strong> permet de trier le rapport selon la colonne dans l''ordre d\00E9croissant.</li> <li>L''ic\00F4ne <strong>Masquer la colonne</strong> permet de masquer la colonne. Les colonnes ne peuvent pas toutes \00EAtre masqu\00E9es. S')
||unistr('i une colonne ne peut pas l''\00EAtre, cette ic\00F4ne n''est pas disponible.</li> <li><strong>Colonne de section</strong> permet de cr\00E9er un groupe de section pour la colonne. Cela permet d''extraire la colonne du rapport en tant qu''enregistrement ma\00EEtre.</li>')
||unistr(' <li><strong>Informations sur la colonne</strong> permet d''afficher un texte d''aide sur la colonne, s''il est disponible.</li> <li><strong>Zone de texte</strong> permet d''entrer des crit\00E8res de recherche non sensibles \00E0 la casse (pas besoin de caract\00E8')
||unistr('res g\00E9n\00E9riques). La saisie d''une valeur r\00E9duit la liste de choix au bas du menu. Vous pouvez alors s\00E9lectionner une valeur au bas du menu et celle-ci est utilis\00E9e comme filtre avec l''op\00E9rateur ''='' (par exemple, <code>column = ''ABC''</code>). Vous pouv')
||unistr('ez \00E9galement cliquer sur l''ic\00F4ne en forme de lampe torche et entrer une valeur \00E0 utiliser comme filtre avec le modificateur ''LIKE''. (par exemple, <code>column LIKE ''%ABC%''</code>).</li> <li><b>Liste des valeurs uniques</b> affiche les 500 premi\00E8res v')
||unistr('aleurs uniques qui r\00E9pondent \00E0 vos crit\00E8res de filtrage. Si la colonne est de type date, une liste d''intervalle de dates s''affiche \00E0 la place. Si vous s\00E9lectionnez une valeur, un filtre est cr\00E9\00E9 avec l''op\00E9rateur ''='' (par exemple, <code>column = ''ABC''')
||'</code>).</li> </ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112023842124399841)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Permet d''ajouter des colonnes calcul\00E9es \00E0 votre rapport. Il peut s''agir de calculs math\00E9matiques (par exemple, <code>NBR_HOURS/24</code>) ou de fonctions Oracle standard appliqu\00E9es \00E0 des colonnes existantes. Certaines s''affichent \00E0 titre d''exemple et')
||unistr(' d''autres (telles que <code>TO_DATE)</code> peuvent \00E9galement \00EAtre utilis\00E9es). Les options sont les suivantes : <p></p> <ul> <li><strong>Calcul</strong> permet de s\00E9lectionner un calcul pr\00E9c\00E9demment d\00E9fini pour le modifier.</li> <li><strong>En-t\00EAte d')
||unistr('e colonne</strong> d\00E9signe l''en-t\00EAte de la nouvelle colonne.</li> <li><strong>Masque de format</strong> repr\00E9sente un masque de format Oracle \00E0 appliquer \00E0 la colonne (par exemple, S9999).</li> <li><strong>Calcul</strong> correspond au calcul \00E0 effec')
||unistr('tuer. Dans le calcul, les colonnes sont r\00E9f\00E9renc\00E9es \00E0 l''aide des alias affich\00E9s.</li> </ul> <p>Sous le calcul, les colonnes de votre interrogation s''affichent avec les alias qui leur sont associ\00E9s. En cliquant sur le nom ou l''alias d''une colonne, vou')
||unistr('s incluez celle-ci dans le calcul. \00C0 c\00F4t\00E9 de Colonnes se trouve un clavier virtuel qui fournit des raccourcis vers les touches couramment utilis\00E9es. \00C0 l''extr\00EAme droite se trouvent les fonctions.</p> </p>L''exemple de calcul suivant montre comment affi')
||unistr('cher la r\00E9mun\00E9ration totale :</p> <pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre> (o\00F9 A est l''ORGANISATION, B le SALAIRE et C la COMMISSION)</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112030375036399845)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Sert \00E0 cr\00E9er un groupe de section pour une ou plusieurs colonnes. Cela permet d''extraire les colonnes du rapport interactif et de les afficher sous forme d''enregistrement ma\00EEtre.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112024562917399841)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Pour voir les d\00E9tails d''une seule rang\00E9e \00E0 la fois, cliquez sur l''ic\00F4ne Vue d''une seule rang\00E9e pour la rang\00E9e que vous voulez voir. Si elle est disponible, la vue d''une seule rang\00E9e affiche toujours la premi\00E8re colonne. Selon la personnalisation du r')
||unistr('apport interactif, la vue d''une seule rang\00E9e peut \00EAtre la vue standard ou une page personnalis\00E9e pouvant permettre la mise \00E0 jour.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112024419322399841)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Permet de t\00E9l\00E9charger le jeu de r\00E9sultats courant. Les formats de t\00E9l\00E9chargement diff\00E8rent selon l''installation et la d\00E9finition du rapport, mais peuvent inclure CSV, HTML, Courriel, XLS, PDF ou RTF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112023510669399840)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Permet de restreindre le rapport en ajoutant ou en modifiant la clause <code>WHERE</code> dans l''interrogation. Vous pouvez effectuer le filtrage par colonne ou par rang\00E9e. <p>Si vous filtrez par colonne, s\00E9lectionnez une colonne (il n''est pas n\00E9cess')
||unistr('aire que ce soit une colonne affich\00E9e), s\00E9lectionnez un op\00E9rateur Oracle standard (=, !=, pas dans, compris entre), et entrez une expression de comparaison. Les expressions sont sensibles \00E0 la casse. Utilisez % comme caract\00E8re g\00E9n\00E9rique (par exemple,')
||unistr(' <code>STATE_NAME like A%)</code>.</p> <p>Si vous filtrez par rang\00E9e, vous pouvez cr\00E9er des clauses <code>WHERE</code> complexes \00E0 l''aide des alias de colonnes et des fonctions ou op\00E9rateurs Oracle standard (par exemple, <code>G = ''VA'' or G = ''CT''</c')
||unistr('ode>, o\00F9 <code>G</code> est l''alias de <code>CUSTOMER_STATE</code>).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112024119954399841)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Une interrogation Flashback permet de visualiser les donn\00E9es telles qu''elles existaient \00E0 un moment donn\00E9 pr\00E9c\00E9dent. Par d\00E9faut, la dur\00E9e du retour en arri\00E8re est de 3 heures (ou 180 minutes), mais la dur\00E9e r\00E9elle diff\00E8re pour chaque base de donn\00E9es.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112085373263399885)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Le menu Format vous permet de personnaliser l''affichage du rapport.',
'Il contient les sous-menus suivants :</p>',
'<ul><li>Trier</li>',
'<li>Commande BREAK</li>',
'<li>Mettre en surbrillance</li>',
'<li>Calculer</li>',
unistr('<li>Agr\00E9ger</li>'),
'<li>Graphique</li>',
'<li>Regroupement</li>',
unistr('<li>Tableau crois\00E9 dynamique</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112083509564399884)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vous pouvez d\00E9finir une vue de regroupement par rapport enregistr\00E9. Lorsqu''elle est d\00E9finie, vous pouvez passer de la vue de regroupement \00E0 la vue de rapport \00E0 l''aide des ic\00F4nes de vue de la barre de recherche. Pour cr\00E9er une vue de regroupement, vou')
||unistr('s s\00E9lectionnez : <p></p><ul> <li>les colonnes sur lesquelles effectuer le regroupement</li> <li>les colonnes \00E0 agr\00E9ger ainsi que la fonction \00E0 ex\00E9cuter (moyenne, somme, nombre, etc.)</li> </ul>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112023784313399840)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('<p>Permet de d\00E9finir un filtre. Les rang\00E9es qui r\00E9pondent aux crit\00E8res du filtre s''affichent en surbrillance avec les caract\00E9ristiques associ\00E9es au filtre. Les options sont les suivantes :</p> <ul> <li><strong>Nom</strong> est utilis\00E9 uniquement pour')
||unistr(' l''affichage.</li> <li><strong>S\00E9quence</strong> indique l''ordre dans laquelle les r\00E8gles sont \00E9valu\00E9es.</li> <li><strong>Activ\00E9</strong> indique si une r\00E8gle est activ\00E9e ou d\00E9sactiv\00E9e.</li> <li><strong>Type de mise en \00E9vidence</strong> indique si la')
||unistr(' rang\00E9e ou la cellule doit \00EAtre mise en \00E9vidence. Si la valeur Cellule est s\00E9lectionn\00E9e, la colonne r\00E9f\00E9renc\00E9e dans la condition de mise en \00E9vidence est en surbrillance.</li> <li><strong>Couleur d''arri\00E8re-plan</strong> est la nouvelle couleur de l''ar')
||unistr('ri\00E8re-plan de la zone en surbrillance.</li> <li><strong>Couleur du texte</strong> est la nouvelle couleur du texte de la zone en surbrillance.</li> <li><strong>Condition de mise en \00E9vidence</strong> d\00E9finit votre condition de filtre.</li> </ul>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111961311046399793)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Vous pouvez d\00E9finir une vue de tableau crois\00E9 dynamique par rapport enregistr\00E9. Une fois qu''elle est d\00E9finie, vous pouvez passer d''une vue de tableau crois\00E9 dynamique \00E0 une vue de rapport \00E0 l''aide des ic\00F4nes de vue de la barre de recherche. Pour cr\00E9e')
||unistr('r une vue de tableau crois\00E9 dynamique, vous s\00E9lectionnez :'),
'<p></p>',
'<ul>',
unistr('<li>les colonnes pour le tableau crois\00E9 dynamique</li>'),
unistr('<li>les colonnes \00E0 afficher en tant que rang\00E9es</li>'),
unistr('<li>les colonnes \00E0 agr\00E9ger ainsi que la fonction \00E0 ex\00E9cuter (moyenne, somme, nombre, etc.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112034879285399849)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Lorsque vous personnalisez un rapport interactif, les param\00E8tres du rapport s''affichent sous la barre de recherche et au-dessus du rapport. Cette zone peut \00EAtre r\00E9duite et d\00E9velopp\00E9e \00E0 l''aide de l''ic\00F4ne situ\00E9e \00E0 gauche. <p> Pour chaque param\00E8tre de r')
||unistr('apport, vous pouvez : </p><ul> <li>Modifier le param\00E8tre en cliquant sur son nom.</li> <li>D\00E9sactiver/activer le param\00E8tre en d\00E9s\00E9lectionnant ou en cochant la case Activer/D\00E9sactiver. Utilisez cette commande pour d\00E9sactiver et activer temporairement ')
||unistr('un param\00E8tre.</li> <li>Supprimer le param\00E8tre en cliquant sur l''ic\00F4ne Supprimer.</li> </ul> <p>Si vous avez cr\00E9\00E9 un graphique, un regroupement ou un tableau crois\00E9 dynamique, vous pouvez passer de ceux-ci au rapport de base \00E0 l''aide des liens Vue de ')
||unistr('rapport, Vue de graphique, Vue de regroupement et Vue de tableau crois\00E9 dynamique affich\00E9s sur la droite. Lorsque vous visualisez le graphique, le regroupement ou le tableau crois\00E9 dynamique, vous pouvez \00E9galement utiliser le lien Modifier pour modif')
||unistr('ier les param\00E8tres.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112024337071399841)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('R\00E9tablit les param\00E8tres par d\00E9faut du rapport, en supprimant toutes les personnalisations que vous avez effectu\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112085608959399885)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9finit le nombre d''enregistrements \00E0 afficher par page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112024283409399841)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Enregistre le rapport personnalis\00E9 pour une utilisation ult\00E9rieure. Vous fournissez un nom et une description facultative et pouvez rendre le rapport accessible au public (c''est-\00E0-dire \00E0 tous les utilisateurs qui peuvent acc\00E9der au rapport princip')
||unistr('al par d\00E9faut). Vous pouvez enregistrer quatre types de rapport interactif :</p> <ul> <li><strong>Principal par d\00E9faut</strong> (d\00E9veloppeur uniquement). Le rapport principal par d\00E9faut est le rapport qui s''affiche initialement. Il ne peut pas \00EAtre p')
||unistr('as \00EAtre renomm\00E9 ni supprim\00E9.</li> <li><strong>Rapport alternatif</strong> (d\00E9veloppeur uniquement). Permet aux d\00E9veloppeurs de cr\00E9er plusieurs dispositions de rapport. Seuls les d\00E9veloppeurs peuvent enregistrer, renommer ou supprimer un rapport alter')
||unistr('natif.</li> <li><strong>Rapport public</strong> (utilisateur final). Peut \00EAtre enregistr\00E9, renomm\00E9 ou supprim\00E9 par l''utilisateur final qui l''a cr\00E9\00E9. Les autres utilisateurs peuvent le visualiser et enregistrer la disposition pour un autre rapport.</l')
||unistr('i> <li><strong>Rapport priv\00E9</strong> (utilisateur final). Seul l''utilisateur final qui a cr\00E9\00E9 le rapport peut visualiser, enregistrer, renommer ou supprimer le rapport.</li> </ul> <p>Si vous enregistrez des rapports personnalis\00E9s, un s\00E9lecteur de ra')
||unistr('pport s''affiche dans la barre de recherche \00E0 gauche du s\00E9lecteur de rang\00E9e (si cette fonction est activ\00E9e).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112023299771399840)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('En haut de chaque page de rapport se trouve une r\00E9gion de recherche. Cette r\00E9gion (ou barre de recherche) pr\00E9sente les fonctions suivantes :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112086232050399886)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'fr-ca'
,p_message_text=>'Le <li><strong>menu Actions</strong> permet de personnaliser un rapport. Voir les sections qui suivent.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112085782764399886)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('<li><strong>L''ic\00F4ne S\00E9lectionner des colonnes</strong> vous permet d''identifier la colonne \00E0 rechercher (ou toutes).</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112086063895399886)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('<li>L''option <strong>Rapports</strong> affiche d''autres rapports priv\00E9s ou publics par d\00E9faut et enregistr\00E9s.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112085926124399886)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('<li>L''option <strong>Rang\00E9es</strong> d\00E9finit le nombre d''enregistrements \00E0 afficher par page.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112085816628399886)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li>La <strong>Zone de texte</strong> vous permet d''entrer des crit\00E8res de recherche non sensibles \00E0 la casse (les caract\00E8res g\00E9n\00E9riques sont implicites).</li>'),
unistr('<li>Le <strong>bouton Aller</strong> permet de lancer la recherche. Si vous appuyez sur la touche Entr\00E9e, vous lancez \00E9galement la recherche lorsque le curseur se trouve dans la zone de texte de recherche.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112086156360399886)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Les <li><strong>Ic\00F4nes de vue</strong> permettent de basculer entre les diff\00E9rentes vues d\00E9finies pour le rapport : ic\00F4ne, rapport, d\00E9tails, graphique, regroupement et tableau crois\00E9 dynamique.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112102198749399898)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('<li>L''option <strong>G\00E9rer</strong> permet de g\00E9rer les propri\00E9t\00E9s, les colonnes, les rang\00E9es et l''historique de vue du rapport ou de la grille de donn\00E9es.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112023420299399840)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Permet de modifier les colonnes affich\00E9es. Les colonnes de droite sont affich\00E9es. Les colonnes de gauche sont masqu\00E9es. Vous pouvez r\00E9organiser les colonnes affich\00E9es \00E0 l''aide des fl\00E8ches situ\00E9es \00E0 l''extr\00EAme droite. Les colonnes calcul\00E9es sont pr\00E9fix')
||unistr('\00E9es par <strong>**</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112023654420399840)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Permet de modifier les colonnes sur lesquelles effectuer le tri et d\00E9termine si'),
unistr('le tri doit se faire par ordre croissant ou d\00E9croissant. Vous pouvez \00E9galement sp\00E9cifier comment traiter les valeurs <code>NULL</code>. Le param\00E8tre par d\00E9faut affiche toujours les valeurs <code>NULL</code> en dernier ou les affiche toujours en premi')
||unistr('er. Le tri r\00E9sultant s''affiche \00E0 droite des'),
unistr('en-t\00EAtes de colonne dans le rapport.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112083386029399884)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Lorsque vous ajoutez un abonnement, vous indiquez une adresse de courriel (ou plusieurs adresses de courriel, s\00E9par\00E9es par des virgules), l''objet du message, la fr\00E9quence et les dates de d\00E9but et de fin. Les courriels r\00E9sultants comprennent une versi')
||unistr('on HTML du rapport interactif qui contient les donn\00E9es courantes avec les param\00E8tres de rapport qui \00E9taient pr\00E9sents au moment de l''ajout de l''abonnement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112101978747399897)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Les grilles de donn\00E9es sont essentiellement des rapports modifiables dont la plupart des \00E9l\00E9ments peuvent \00EAtre personnalis\00E9s. Les utilisateurs peuvent modifier la disposition des donn\00E9es du rapport en s\00E9lectionnant des colonnes, en appliquant des fil')
||unistr('tres, en mettant des valeurs en surbrillance et en les triant. En outre, ils peuvent d\00E9finir des sections, des agr\00E9gations, des graphiques, des regroupements et ajouter des calculs personnalis\00E9s. Les utilisateurs peuvent cr\00E9er plusieurs variantes d''u')
||unistr('n rapport et les enregistrer en tant que rapports nomm\00E9s, pour une consultation priv\00E9e. '),
'<p/>',
unistr('Une grille de donn\00E9es peut \00EAtre personnalis\00E9e \00E0 l''aide de la barre de recherche, du menu Actions, du menu G\00E9rer ou du menu En-t\00EAte de colonne.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112113720960399906)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le menu Actions appara\00EEt \00E0 droite du bouton Aller de la barre de recherche. Utilisez ce menu pour personnaliser un rapport de type grille de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112102454186399898)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Page Ajouter/Modifier une rang\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112102545019399898)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Pour ajouter une rang\00E9e \00E0 la grille de donn\00E9es, cliquez sur Ajouter une rang\00E9e. Pour modifier les d\00E9tails d''une rang\00E9e, cliquez sur l''ic\00F4ne de modification associ\00E9e, dans la premi\00E8re colonne. La page Ajouter/Modifier une rang\00E9e s''affiche et pr\00E9sen')
||unistr('te les colonnes de la grille de donn\00E9es. </p>  <p>Lorsque vous modifiez une rang\00E9e, vous pouvez :</p>  <p><ul> <li><strong>Supprimer</strong> la rang\00E9e.</li> <li><strong>Appliquer les modifications</strong> pour enregistrer les modifications apport\00E9e')
||unistr('s \00E0 la rang\00E9e.</li> <li>Dans le menu <strong>Actions</strong>, ajouter une rang\00E9e, ajouter des fichiers, des notes, des liens ou des balises, et consulter l''historique.</li> <li>Naviguer vers les rang\00E9es <strong>suivante et pr\00E9c\00E9dente</strong>.</li> ')
||unistr('<li>Sous <strong>G\00E9rer</strong>, d\00E9finir les propri\00E9t\00E9s des colonnes, les groupes de colonnes, les validations et les listes de valeurs.</li> </ul></p>  </p>La r\00E9gion Annotations en bas de la page affichera tous les fichiers, notes, liens ou balises ')
||unistr('associ\00E9s \00E0 la rang\00E9e courante.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112113876790399906)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Sert \00E0 cr\00E9er un groupe de section pour une ou plusieurs colonnes. Cela permet d''extraire les colonnes de la grille de donn\00E9es et de les afficher sous forme d''enregistrement ma\00EEtre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112102385379399898)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Permet de t\00E9l\00E9charger le jeu de r\00E9sultats courant. Les formats de t\00E9l\00E9chargement'),
'incluent CSV, HTML ou Courriel.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112113965014399906)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si vous personnalisez un rapport de type grille de donn\00E9es, les param\00E8tres du rapport s''affichent'),
unistr('sous la barre de recherche et au-dessus du rapport. Cette zone peut \00EAtre r\00E9duite et d\00E9velopp\00E9e \00E0 l''aide de l''ic\00F4ne situ\00E9e \00E0 gauche.'),
'<p>',
unistr('Pour chaque param\00E8tre de rapport, vous pouvez :'),
'</p><ul>',
unistr('<li>Modifier un param\00E8tre en cliquant sur son nom.</li>'),
unistr('<li>D\00E9sactiver/activer un param\00E8tre en d\00E9s\00E9lectionnant ou en cochant la case Activer/D\00E9sactiver. Utilisez cette commande pour d\00E9sactiver et activer temporairement un param\00E8tre.</li>'),
unistr('<li>Supprimer un param\00E8tre en cliquant sur l''ic\00F4ne Supprimer.</li>'),
'</ul>',
unistr('<p>Si vous avez cr\00E9\00E9 un graphique ou un regroupement, vous pouvez passer de celui-ci au rapport de base \00E0 l''aide des liens Vue de rapport, Vue de graphique et Vue de regroupement affich\00E9s sur la droite. Si vous visualisez le graphique ou le regroupem')
||'ent, vous',
unistr('pouvez \00E9galement utiliser le lien Modifier pour modifier les param\00E8tres.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112102234616399898)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Enregistre la disposition personnalis\00E9e du rapport de grille de donn\00E9es pour une utilisation ult\00E9rieure. Vous fournissez un nom et une description facultative. Vous pouvez enregistrer trois types de disposition de rapport de type grille de donn\00E9es')
||' :</p>',
'<ul>',
unistr('<li><strong>Principal par d\00E9faut</strong> (administrateur uniquement). Le rapport principal par d\00E9faut est la disposition qui s''affiche initialement. Les rapports principaux par d\00E9faut ne peuvent pas \00EAtre renomm\00E9s ou supprim\00E9s.</li>'),
unistr('<li><strong>Rapport alternatif</strong> (administrateur uniquement). Permet aux administrateurs de cr\00E9er plusieurs dispositions de rapport. Seuls les administrateurs peuvent enregistrer, renommer ou supprimer un rapport alternatif.</li>'),
unistr('<li><strong>Rapport priv\00E9</strong> (Tous les utilisateurs). L''utilisateur qui a cr\00E9\00E9 la disposition du rapport peut visualiser, enregistrer, renommer ou supprimer le rapport.</li>'),
'</ul>',
unistr('<p>Si vous enregistrez des rapports personnalis\00E9s, un s\00E9lecteur de rapport s''affiche dans la barre de recherche \00E0 gauche du s\00E9lecteur de rang\00E9e (si cette fonction est activ\00E9e).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112028307536399844)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>'Masquer la colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112018949570399837)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'fr-ca'
,p_message_text=>'Mettre en surbrillance'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112029806434399845)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'fr-ca'
,p_message_text=>'Mises en surbrillance'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112034981219399849)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'fr-ca'
,p_message_text=>'Condition de mise en surbrillance'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112083933118399884)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Style de mise en surbrillance'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111993907747399819)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'fr-ca'
,p_message_text=>'Type de mise en surbrillance'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112103405068399898)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'fr-ca'
,p_message_text=>'Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112133091902399920)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('1 param\00E8tre inactif')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112133161708399920)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 param\00E8tres inactifs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112024990649399841)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'fr-ca'
,p_message_text=>'Aide sur le rapport interactif'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112035958235399849)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'fr-ca'
,p_message_text=>'Non valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112029358200399845)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'fr-ca'
,p_message_text=>'Expression de calcul non valide. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111988745026399813)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La date de fin doit \00EAtre post\00E9rieure \00E0 la date de d\00E9but.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112043660306399855)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'fr-ca'
,p_message_text=>'Expression de filtre non valide. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112111458091399904)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'fr-ca'
,p_message_text=>'Interrogation de filtrage non valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112133295776399920)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('1 param\00E8tre non valide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112133397187399920)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 param\00E8tres non valides')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112084191120399884)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'fr-ca'
,p_message_text=>'(en minutes)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112101176917399897)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 se situe dans le dernier intervalle de %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112101327113399897)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 se situe dans le prochain intervalle de %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112101231643399897)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 ne se situe pas dans le dernier intervalle de %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112101479873399897)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 ne se situe pas dans le prochain intervalle de %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112034071993399848)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'fr-ca'
,p_message_text=>'Clavier virtuel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112000187158399823)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('\00C9tiquette %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112027920123399843)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Titre de l''axe pour l''\00E9tiquette')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112020429125399838)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'fr-ca'
,p_message_text=>'Dernier jour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112020634519399838)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Derni\00E8re heure')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112020192872399838)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'fr-ca'
,p_message_text=>'Mois dernier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112020203440399838)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Semaine derni\00E8re')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112020314526399838)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 derniers jours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112020588864399838)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 derni\00E8res heures')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112019908217399838)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 derni\00E8res ann\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112020052189399838)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ann\00E9e derni\00E8re')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112000082955399823)
,p_name=>'APEXIR_LINE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Lin\00E9aire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111996803596399821)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Lin\00E9aire avec aire')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112111387906399904)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'fr-ca'
,p_message_text=>'Mapper'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112028884725399844)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Selon les estimations, l''interrogation d\00E9passe les ressources maximales autoris\00E9es. Modifiez les param\00E8tres de votre rapport et r\00E9essayez.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112011012358399831)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le nombre maximal de rang\00E9es pour ce rapport est de %0 rang\00E9es. Appliquez un filtre pour r\00E9duire le nombre d''enregistrements de votre interrogation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112111945914399905)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'fr-ca'
,p_message_text=>'Maximum de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112112174511399905)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('M\00E9diane de %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112015026490399834)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'fr-ca'
,p_message_text=>'Il y a %0 minutes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112112065433399905)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'fr-ca'
,p_message_text=>'Minimum de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112111098336399904)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'fr-ca'
,p_message_text=>'Mois'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112084565572399885)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'fr-ca'
,p_message_text=>'Tous les mois'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112027124729399843)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9placer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112027091120399843)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Tout d\00E9placer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112138292210399923)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''ID statique de la r\00E9gion doit \00EAtre sp\00E9cifi\00E9 car la page contient plusieurs rapports interactifs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111995565327399820)
,p_name=>'APEXIR_NAME'
,p_message_language=>'fr-ca'
,p_message_text=>'Nom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112022904039399840)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Nouvelle agr\00E9gation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112133996451399920)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Nouvelle cat\00E9gorie')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112023080704399840)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'fr-ca'
,p_message_text=>'Nouveau calcul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112017858428399836)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'fr-ca'
,p_message_text=>'Suivant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112020961053399838)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'fr-ca'
,p_message_text=>'Prochain jour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112020758236399838)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'fr-ca'
,p_message_text=>'Prochaine heure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112021208183399839)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'fr-ca'
,p_message_text=>'Mois prochain'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112021171917399839)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'fr-ca'
,p_message_text=>'Semaine prochaine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112021057795399838)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 prochains jours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112020819775399838)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 prochaines heures'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112021480176399839)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 prochaines ann\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112021320145399839)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ann\00E9e prochaine')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111995840724399820)
,p_name=>'APEXIR_NO'
,p_message_language=>'fr-ca'
,p_message_text=>'Non'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112036197652399849)
,p_name=>'APEXIR_NONE'
,p_message_language=>'fr-ca'
,p_message_text=>'- Aucun -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112083717213399884)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'fr-ca'
,p_message_text=>'L''adresse de courriel n''est pas valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112032625689399847)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'fr-ca'
,p_message_text=>'Valeurs nulles toujours en premier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112032520482399847)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'fr-ca'
,p_message_text=>'Valeurs nulles toujours en dernier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112033051436399847)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'fr-ca'
,p_message_text=>'Tri des valeurs nulles %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112029469581399845)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La dur\00E9e de l''op\00E9ration Flashback doit \00EAtre une valeur num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112029053405399844)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La s\00E9quence doit \00EAtre num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112033515402399847)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Op\00E9rateur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111994425918399819)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'fr-ca'
,p_message_text=>'orange'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112103323456399898)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'fr-ca'
,p_message_text=>'Orientation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111996373136399820)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'fr-ca'
,p_message_text=>'Autre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111979164146399806)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'fr-ca'
,p_message_text=>'Orientation de la page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111979870810399807)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'fr-ca'
,p_message_text=>'Paysage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111979956842399807)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'fr-ca'
,p_message_text=>'Portrait'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111979077514399806)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'fr-ca'
,p_message_text=>'Taille de la page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111979644512399807)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'fr-ca'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111979595991399807)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'fr-ca'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111979704937399807)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Personnalis\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111979304418399806)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'fr-ca'
,p_message_text=>'Grand format'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111979276885399806)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'fr-ca'
,p_message_text=>'Lettre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111979428291399806)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Tablo\00EFd')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112112484375399905)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'fr-ca'
,p_message_text=>'Pourcentage du nombre total de %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112111658306399904)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'fr-ca'
,p_message_text=>'Pourcentage de la somme totale %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112110690468399904)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'fr-ca'
,p_message_text=>'Pourcentage du nombre total'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112110571179399904)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'fr-ca'
,p_message_text=>'Pourcentage de la somme totale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111999937013399823)
,p_name=>'APEXIR_PIE'
,p_message_language=>'fr-ca'
,p_message_text=>'Secteurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112059879175399867)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Tableau crois\00E9 dynamique')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112061340802399868)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vous devez sp\00E9cifier un agr\00E9gat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112061570590399868)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vous ne pouvez pas effectuer une agr\00E9gation sur une colonne s\00E9lectionn\00E9e en tant que colonne de rang\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112060757271399867)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'fr-ca'
,p_message_text=>'Colonnes de pivotement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112060509548399867)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'fr-ca'
,p_message_text=>'Colonne de pivotement %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112061164040399868)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vous devez sp\00E9cifier une colonne de pivotement')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111961203996399793)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le nombre maximal de rang\00E9es d''une interrogation de tableau crois\00E9 dynamique limite le nombre de rang\00E9es de l''interrogation de base, et non le nombre de rang\00E9es affich\00E9es. Votre interrogation de base d\00E9passe le nombre maximal de rang\00E9es de %0. Appliq')
||unistr('uez un filtre pour r\00E9duire le nombre d''enregistrements de votre interrogation de base.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112061040097399868)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Tri de tableau crois\00E9 dynamique')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112030464401399845)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La colonne de pivotement contient trop de valeurs distinctes - le SQL du tableau crois\00E9 dynamique ne peut pas \00EAtre g\00E9n\00E9r\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112083880595399884)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aper\00E7u')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112017914119399836)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112109586975399903)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'fr-ca'
,p_message_text=>'Principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112084823403399885)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'fr-ca'
,p_message_text=>'Rapport principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111978954425399806)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Inclure des balises d''accessibilit\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111965879660399797)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'fr-ca'
,p_message_text=>'Supprimer le texte enrichi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112042665173399854)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Priv\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112000547350399824)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'fr-ca'
,p_message_text=>'Public'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111996135755399820)
,p_name=>'APEXIR_RED'
,p_message_language=>'fr-ca'
,p_message_text=>'rouge'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112138189187399923)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''ID statique de la r\00E9gion %0 n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112027214054399843)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'fr-ca'
,p_message_text=>'Supprimer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112027318339399843)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'fr-ca'
,p_message_text=>'Tout supprimer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112133481597399920)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'fr-ca'
,p_message_text=>'Supprimer le graphique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112026875965399843)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'fr-ca'
,p_message_text=>'Supprimer la commande BREAK'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112026521847399842)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'fr-ca'
,p_message_text=>'Supprimer le filtre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112026625751399843)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Supprimer l''op\00E9ration Flashback')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112133547874399920)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'fr-ca'
,p_message_text=>'Supprimer le regroupement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112026902107399843)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'fr-ca'
,p_message_text=>'Supprimer la mise en surbrillance'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112133696251399920)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Supprimer le tableau crois\00E9 dynamique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112114604863399907)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'fr-ca'
,p_message_text=>'Supprimer le rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112095290769399892)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Renommer le rapport par d\00E9faut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112036491517399850)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'fr-ca'
,p_message_text=>'Renommer le rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112018261612399836)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'fr-ca'
,p_message_text=>'Rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112112574256399905)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'fr-ca'
,p_message_text=>'Rapports'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111992711549399818)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le rapport interactif enregistr\00E9 portant l''alias %0 n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112042963232399854)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'fr-ca'
,p_message_text=>'Le rapport n''existe pas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111992868050399818)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le rapport interactif enregistr\00E9 portant l''ID %0 n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112034734851399848)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Param\00E8tres de rapport')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112015536960399834)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'fr-ca'
,p_message_text=>'Vue de rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112019466185399837)
,p_name=>'APEXIR_RESET'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('R\00E9initialiser')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112000701715399824)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('R\00E9tablir les param\00E8tres par d\00E9faut pour le rapport.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111995906102399820)
,p_name=>'APEXIR_ROW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Rang\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112108637876399902)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vous ne pouvez pas utiliser ROWID comme colonne de cl\00E9 primaire pour une source de donn\00E9es REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112025957067399842)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Rang\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112085586144399885)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Rang\00E9es par page')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112060836598399867)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Colonnes de rang\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112060647723399867)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Colonne de rang\00E9e %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112061237873399868)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vous devez sp\00E9cifier une colonne de rang\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112061405999399868)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La colonne de rang\00E9e doit \00EAtre diff\00E9rente de la colonne de pivotement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112040096655399852)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Filtre de rang\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112015677080399835)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Rang\00E9e %0 de %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112019678509399837)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le texte de la rang\00E9e contient')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111995245396399820)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'fr-ca'
,p_message_text=>'Enregistrer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112030071749399845)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Rapport enregistr\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112029902462399845)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Rapport enregistr\00E9 = "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112032139787399846)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Les param\00E8tres du rapport courant seront utilis\00E9s par d\00E9faut pour tous les utilisateurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112095113126399892)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Enregistrer le rapport par d\00E9faut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112019358671399837)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'fr-ca'
,p_message_text=>'Enregistrer le rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112133801970399920)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'fr-ca'
,p_message_text=>'Enregistrer le rapport *'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112086596247399886)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'fr-ca'
,p_message_text=>'Rechercher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112024854682399841)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'fr-ca'
,p_message_text=>'Barre de recherche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112133795648399920)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>'Rechercher : %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112092026243399890)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'fr-ca'
,p_message_text=>'Rechercher un rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112076046695399879)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Colonnes s\00E9lectionn\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111996966048399821)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('- S\00E9lectionner une colonne -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112018658840399837)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9lectionner des colonnes')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112000431087399824)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('- S\00E9lectionner une fonction -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112025617937399842)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('- S\00E9lectionner une colonne de regroupement -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112060390798399867)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('- S\00E9lectionner une colonne de pivotement -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112111559721399904)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9lectionner une rang\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112060408828399867)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('- S\00E9lectionner une colonne de rang\00E9e -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111969126581399799)
,p_name=>'APEXIR_SEND'
,p_message_language=>'fr-ca'
,p_message_text=>'Envoyer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111975403235399804)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'fr-ca'
,p_message_text=>'Envoyer en tant que courriel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111995621522399820)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9quence')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112018841523399837)
,p_name=>'APEXIR_SORT'
,p_message_language=>'fr-ca'
,p_message_text=>'Trier'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112028141051399844)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'fr-ca'
,p_message_text=>'Trier par ordre croissant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112028229424399844)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Trier par ordre d\00E9croissant')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112114018019399906)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'fr-ca'
,p_message_text=>'Ordre de tri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112022643774399840)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'fr-ca'
,p_message_text=>'espace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112033779442399848)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'fr-ca'
,p_message_text=>'Statut %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112084274192399884)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'fr-ca'
,p_message_text=>'Abonnement'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112110978688399904)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'fr-ca'
,p_message_text=>'Fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111965369822399796)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ignorer si aucune donn\00E9e trouv\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112110865901399904)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('\00C0 partir de')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112111723006399904)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'fr-ca'
,p_message_text=>'Somme de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112101754220399897)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('R\00E9gion = %0, Rapport = %1, Vue = %2, D\00E9but des rang\00E9es affich\00E9es = %3, Fin des rang\00E9es affich\00E9es = %4, Nombre total de rang\00E9es = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112022360128399839)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('R\00E9gion = %0, Rapport = %1, Vue = %2, D\00E9but des rang\00E9es affich\00E9es = %3, Fin des rang\00E9es affich\00E9es = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111994570737399819)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'fr-ca'
,p_message_text=>'Couleur du texte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112011609030399832)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'fr-ca'
,p_message_text=>'jours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112011598110399831)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'fr-ca'
,p_message_text=>'heures'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112011402584399831)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'fr-ca'
,p_message_text=>'minutes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112011830168399832)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'fr-ca'
,p_message_text=>'mois'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112011730912399832)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'fr-ca'
,p_message_text=>'semaines'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112011922847399832)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('ann\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112114433747399906)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Activer/d\00E9sactiver')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112027411204399843)
,p_name=>'APEXIR_TOP'
,p_message_language=>'fr-ca'
,p_message_text=>'Haut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112107663044399901)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Colonne non regroup\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112028998205399844)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le nom de la mise en surbrillance doit \00EAtre unique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111999255556399823)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('type de donn\00E9es non pris en charge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112027543140399843)
,p_name=>'APEXIR_UP'
,p_message_language=>'fr-ca'
,p_message_text=>'Vers le haut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112029125171399844)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'fr-ca'
,p_message_text=>'Entrez une couleur valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112029299550399844)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'fr-ca'
,p_message_text=>'Entrez un masque de format valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111996454249399821)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'fr-ca'
,p_message_text=>'Valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112028014698399844)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Titre de l''axe pour la valeur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112035810249399849)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'fr-ca'
,p_message_text=>'Valeur obligatoire'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111999812316399823)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>'Colonne verticale'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112103512483399899)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'fr-ca'
,p_message_text=>'Vertical'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112035139655399849)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'fr-ca'
,p_message_text=>'Voir le graphique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112090384853399889)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Voir les d\00E9tails')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112135988388399922)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aucune vue %0 n''est d\00E9finie pour le rapport.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112090407498399889)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'fr-ca'
,p_message_text=>'Voir le regroupement'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112090293844399889)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ic\00F4nes de vue')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112060197818399867)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Voir le tableau crois\00E9 dynamique')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112035251171399849)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'fr-ca'
,p_message_text=>'Voir le rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112084489612399885)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'fr-ca'
,p_message_text=>'Toutes les semaines'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112018169523399836)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'fr-ca'
,p_message_text=>'Rapport de travail'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112113102529399905)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 jours'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112113052612399905)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 heures'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112112948322399905)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 minutes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112113336118399906)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 mois'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112113201909399906)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 semaines'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112113476430399906)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 ann\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112111182641399904)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ann\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111994211778399819)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'fr-ca'
,p_message_text=>'jaune'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111995740953399820)
,p_name=>'APEXIR_YES'
,p_message_language=>'fr-ca'
,p_message_text=>'Oui'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112027870579399843)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 contient < or > qui sont des caract\00E8res non valides.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112050634586399860)
,p_name=>'APEX_REGION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('R\00E9gion')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111978874928399806)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Violation de pr\00E9condition d''API ')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111998320884399822)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Impossible d''obtenir la valeur du param\00E8tre d''application %0 car l''option de compilation associ\00E9e est d\00E9sactiv\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111998237834399822)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Impossible de d\00E9finir la valeur du param\00E8tre d''application %0 car l''option de compilation associ\00E9e est d\00E9sactiv\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112105913022399900)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La valeur du param\00E8tre d''application %0 n''est pas valide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112105855870399900)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le param\00E8tre d''application demand\00E9 %0 n''est pas d\00E9fini')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112106069811399900)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le param\00E8tre d''application %0 ne peut pas \00EAtre r\00E9gl\00E9 \00E0 une valeur nulle')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111986905876399812)
,p_name=>'BACK'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111973988951399802)
,p_name=>'BUILDER'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('G\00E9n\00E9rateur')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112038058885399851)
,p_name=>'BUTTON LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('\00C9tiquette de bouton')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111973056267399802)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'fr-ca'
,p_message_text=>'Classes CSS de bouton'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112002282226399825)
,p_name=>'BUTTON_ID'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''ID du bouton g\00E9n\00E9r\00E9 sera l''ID statique du bouton, s''il est d\00E9fini. S''il ne l''est pas, il s''agira d''un ID g\00E9n\00E9r\00E9 \00E0 l''interne dans le format ''B'' || [ID du bouton interne].')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111965752603399796)
,p_name=>'CANDLESTICK'
,p_message_language=>'fr-ca'
,p_message_text=>'Bougies'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112047230428399858)
,p_name=>'CENTER'
,p_message_language=>'fr-ca'
,p_message_text=>'Centre'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111997205147399821)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'fr-ca'
,p_message_text=>'Demande %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111988653331399813)
,p_name=>'CHECK$'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('s\00E9lecteur de rang\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112107757842399902)
,p_name=>'CHECKED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('s\00E9lectionn\00E9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112083253807399884)
,p_name=>'COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>'Colonne'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112043744720399855)
,p_name=>'COMMENTS'
,p_message_language=>'fr-ca'
,p_message_text=>'Commentaires'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112025280064399842)
,p_name=>'CONTINUE'
,p_message_language=>'fr-ca'
,p_message_text=>'Continuer'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111987238833399812)
,p_name=>'COPYRIGHT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Copyright &copy; %0, Tous droits r\00E9serv\00E9s.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112030983817399846)
,p_name=>'COUNT'
,p_message_language=>'fr-ca'
,p_message_text=>'Nombre'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112037645309399851)
,p_name=>'CREATE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Cr\00E9er')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112089965631399889)
,p_name=>'CREATED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Cr\00E9ation')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112090040375399889)
,p_name=>'CREATED_BY'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Cr\00E9ation par')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112014873616399834)
,p_name=>'CREATED_ON'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Cr\00E9ation le')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112025437882399842)
,p_name=>'CUSTOM'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Personnalis\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112036663249399850)
,p_name=>'CUSTOMIZE'
,p_message_language=>'fr-ca'
,p_message_text=>'Personnaliser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112038240997399851)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('R\00E9initialisation des pr\00E9f\00E9rences de page pour l''utilisateur %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112038396820399851)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Pr\00E9f\00E9rences modifi\00E9es pour l''utilisateur %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112038162955399851)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('R\00E9initialisation des pr\00E9f\00E9rences de page pour l''utilisateur %0.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112001913559399825)
,p_name=>'DAILY'
,p_message_language=>'fr-ca'
,p_message_text=>'Tous les jours'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111973535600399802)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le fichier charg\00E9 n''est pas valide ou comporte une extension incorrecte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111997467856399821)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Utilisation d''un s\00E9lecteur XML ou JSON non valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111966798805399797)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le profil de donn\00E9es et le fichier charg\00E9 ne contiennent aucune colonne de la table cible.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112052491776399861)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aucune donn\00E9e trouv\00E9e dans le fichier charg\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112052590564399861)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aucune donn\00E9e trouv\00E9e dans la feuille de calcul "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111972357483399801)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le fichier sp\00E9cifi\00E9 n''est pas un fichier XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111962773381399794)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Chargement des donn\00E9es termin\00E9 : %0 rang\00E9es trait\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111963938282399795)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Chargement des donn\00E9es termin\00E9 : %0 rang\00E9es trait\00E9es avec 1 erreur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111964229166399795)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Chargement des donn\00E9es termin\00E9 : %0 rang\00E9es trait\00E9es avec %1 erreurs.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111964019538399795)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Chargement des donn\00E9es termin\00E9 : 1 rang\00E9e trait\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111967094967399797)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Chargement des donn\00E9es termin\00E9 : 1 rang\00E9e trait\00E9e avec erreur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111964147506399795)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Chargement des donn\00E9es termin\00E9 : 1 rang\00E9e trait\00E9e sans erreur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112057722777399865)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'fr-ca'
,p_message_text=>'Colonne cible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112057833044399865)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'fr-ca'
,p_message_text=>'Colonne source'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112058672199399866)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'fr-ca'
,p_message_text=>'Format de date / nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112122091162399912)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('\00C9chec de l''extraction de la valeur de consultation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112090595267399889)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Mappage donn\00E9es / table')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112058783945399866)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Rang\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112054230218399863)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La r\00E8gle de transformation a \00E9chou\00E9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112030535655399845)
,p_name=>'DATE'
,p_message_language=>'fr-ca'
,p_message_text=>'Date'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112004665842399827)
,p_name=>'DAY'
,p_message_language=>'fr-ca'
,p_message_text=>'jour'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112004700223399827)
,p_name=>'DAYS'
,p_message_language=>'fr-ca'
,p_message_text=>'jours'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112043446808399855)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le d\00E9bogage n''est pas activ\00E9 pour cette application.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112092291079399890)
,p_name=>'DEFAULT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Par d\00E9faut')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112005444070399827)
,p_name=>'DELETE'
,p_message_language=>'fr-ca'
,p_message_text=>'supprimer'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111965668053399796)
,p_name=>'DIAL_PCT'
,p_message_language=>'fr-ca'
,p_message_text=>'Cadran (pourcentage)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111980103717399807)
,p_name=>'DOWNLOAD'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('T\00E9l\00E9charger')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112091378904399890)
,p_name=>'DUP_USER'
,p_message_language=>'fr-ca'
,p_message_text=>'Nom d''utilisateur en double dans la liste.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111987750590399813)
,p_name=>'EDIT'
,p_message_language=>'fr-ca'
,p_message_text=>'Modifier'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111997158501399821)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'fr-ca'
,p_message_text=>'Adresse de courriel "%0" introuvable.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111982253873399809)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ce courriel a \00E9t\00E9 envoy\00E9 par %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112091515023399890)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''adresse de courriel est trop longue. La limite est 240 caract\00E8res.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112025149186399841)
,p_name=>'ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>'Erreur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112054327977399863)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Impossible de d\00E9finir la valeur source de l''\00E9l\00E9ment de page pour la r\00E9gion d''actualisation de page partielle')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112016618268399835)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Cr\00E9ation par')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111982562894399809)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Mot de passe expir\00E9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111976613564399804)
,p_name=>'FILE_EMPTY'
,p_message_language=>'fr-ca'
,p_message_text=>'Le fichier est vide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112056807037399865)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La taille du fichier charg\00E9 \00E9tait sup\00E9rieure \00E0 %0 Mo. Chargez un fichier plus petit.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111984684536399810)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''authentification de l''utilisateur a \00E9chou\00E9 et un ou plusieurs fichiers n''ont pas \00E9t\00E9 charg\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111984701568399810)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Cette instance ne permet pas aux utilisateurs non authentifi\00E9s de charger des fichiers.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112037755063399851)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>'1 erreur est survenue'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112036953137399850)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 erreurs sont survenues'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111987131689399812)
,p_name=>'FORM_OF'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 de %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112021876523399839)
,p_name=>'GO'
,p_message_language=>'fr-ca'
,p_message_text=>'Aller'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112121681121399911)
,p_name=>'HELP'
,p_message_language=>'fr-ca'
,p_message_text=>'Aide'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111974058725399803)
,p_name=>'HOME'
,p_message_language=>'fr-ca'
,p_message_text=>'Accueil'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112004488217399826)
,p_name=>'HOUR'
,p_message_language=>'fr-ca'
,p_message_text=>'heure'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112004568335399826)
,p_name=>'HOURS'
,p_message_language=>'fr-ca'
,p_message_text=>'heures'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111988574336399813)
,p_name=>'ICON'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ic\00F4ne %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112038537553399851)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Donn\00E9es d''identification de connexion non valides')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112138095764399923)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Valeur non valide pour le param\00E8tre : %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112033272192399847)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Comme param\00E8tres de rapport par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112033386947399847)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Comme rapport nomm\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112015718416399835)
,p_name=>'IR_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>'Erreur %0. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112015468925399834)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>'Impossible de calculer la navigation du formulaire. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111993023465399818)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'fr-ca'
,p_message_text=>'Rapport interactif introuvable.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111992413860399818)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La r\00E9gion du rapport interactif n''existe pas dans l''application %0, la page %1 et la r\00E9gion %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112033123073399847)
,p_name=>'IR_STAR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Affich\00E9 uniquement pour les d\00E9veloppeurs')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112021508613399839)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''interrogation du rapport n\00E9cessite une cl\00E9 unique pour identifier chaque rang\00E9e. La cl\00E9 fournie ne peut pas \00EAtre utilis\00E9e pour cette interrogation. D\00E9finissez une colonne de cl\00E9 unique. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112021643096399839)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''interrogation du rapport n\00E9cessite une cl\00E9 unique pour identifier chaque rang\00E9e. La cl\00E9 fournie ne peut pas \00EAtre utilis\00E9e pour cette interrogation. Modifiez les attributs du rapport pour d\00E9finir une colonne de cl\00E9 unique. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112058912519399866)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9lectionner un fichier')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112058846715399866)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Glisser-d\00E9poser le fichier ici ou')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111987458973399812)
,p_name=>'ITEMS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('\00C9l\00E9ments')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112016871930399835)
,p_name=>'ITEM_VALUE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Valeur d''\00E9l\00E9ment')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112031200733399846)
,p_name=>'LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('\00C9tiquette')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112043337987399855)
,p_name=>'LANGUAGE'
,p_message_language=>'fr-ca'
,p_message_text=>'Langue'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112005132187399827)
,p_name=>'LAST'
,p_message_language=>'fr-ca'
,p_message_text=>'dernier'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111984572477399810)
,p_name=>'LENGTH'
,p_message_language=>'fr-ca'
,p_message_text=>'Longueur'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112037805512399851)
,p_name=>'LOGIN'
,p_message_language=>'fr-ca'
,p_message_text=>'Connexion'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112076447776399879)
,p_name=>'MANAGE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('G\00E9rer')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112141049470399925)
,p_name=>'MAXIMIZE'
,p_message_language=>'fr-ca'
,p_message_text=>'Agrandir'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112004225293399826)
,p_name=>'MINUTE'
,p_message_language=>'fr-ca'
,p_message_text=>'minute'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112004302346399826)
,p_name=>'MINUTES'
,p_message_language=>'fr-ca'
,p_message_text=>'minutes'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112091717612399890)
,p_name=>'MISSING_AT'
,p_message_language=>'fr-ca'
,p_message_text=>'"@" manquante dans l''adresse de courriel.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112091976926399890)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Avertissement : Aucun mod\00E8le de page de bo\00EEte de dialogue n''a \00E9t\00E9 d\00E9fini pour la page de bo\00EEte de dialogue %0 dans l''application %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112091650914399890)
,p_name=>'MISSING_DOT'
,p_message_language=>'fr-ca'
,p_message_text=>'"." manquant dans le domaine de l''adresse de courriel.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112040855752399853)
,p_name=>'MODULE'
,p_message_language=>'fr-ca'
,p_message_text=>'Module'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111997981487399822)
,p_name=>'MONTH'
,p_message_language=>'fr-ca'
,p_message_text=>'Mois'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112001753625399825)
,p_name=>'MONTHLY'
,p_message_language=>'fr-ca'
,p_message_text=>'Tous les mois'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111998073180399822)
,p_name=>'MONTHS'
,p_message_language=>'fr-ca'
,p_message_text=>'mois'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112030874578399846)
,p_name=>'MOVE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9placer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112098395131399895)
,p_name=>'MOVE_FROM'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9placer depuis')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112098484038399895)
,p_name=>'MOVE_TO'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9placer vers')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112018013377399836)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Erreur dans l''op\00E9ration de suppression de plusieurs rang\00E9es : rang\00E9e= %0, %1, %2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112017070612399836)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ne doit pas \00EAtre un utilisateur public')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111974223240399803)
,p_name=>'NAME'
,p_message_language=>'fr-ca'
,p_message_text=>'Nom'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112031019597399846)
,p_name=>'NEW'
,p_message_language=>'fr-ca'
,p_message_text=>'Nouveau'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111997773365399822)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vous pouvez vous connecter \00E0 %0 en allant \00E0 :')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111997807448399822)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'fr-ca'
,p_message_text=>'Avis de nouveau compte %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112121890276399912)
,p_name=>'NEXT'
,p_message_language=>'fr-ca'
,p_message_text=>'Suivant'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112040733842399853)
,p_name=>'NO'
,p_message_language=>'fr-ca'
,p_message_text=>'Non'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112136088372399922)
,p_name=>'NOBODY'
,p_message_language=>'fr-ca'
,p_message_text=>'personne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112005583050399827)
,p_name=>'NOT'
,p_message_language=>'fr-ca'
,p_message_text=>'N''est pas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112046336406399857)
,p_name=>'NOT_NULL'
,p_message_language=>'fr-ca'
,p_message_text=>'Non nul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112017121293399836)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'fr-ca'
,p_message_text=>'N''est pas %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112036718260399850)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('aucune donn\00E9e trouv\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112045854471399857)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aucun rapport actualisable n''a \00E9t\00E9 trouv\00E9. Les op\00E9rations de mise \00E0 jour et de suppression de plusieurs rang\00E9es ne peuvent \00EAtre effectu\00E9es que sur des formulaires tabulaires de type "rapport actualisable".')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112046789949399857)
,p_name=>'OK'
,p_message_language=>'fr-ca'
,p_message_text=>'OK'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112042476863399854)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'fr-ca'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112139896549399925)
,p_name=>'ORA_06550'
,p_message_language=>'fr-ca'
,p_message_text=>'ORA-06550 : ligne %0, colonne %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112089387842399888)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vous utilisez un navigateur Web obsol\00E8te. Pour obtenir la liste des navigateurs pris en charge, consultez le guide d''installation d''Oracle Application Express.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111990775538399815)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Jeu de rang\00E9es non valide demand\00E9. Les donn\00E9es sources du rapport ont \00E9t\00E9 modifi\00E9es.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112010897600399831)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Un num\00E9ro de page valide doit \00EAtre sp\00E9cifi\00E9, par exemple p?n=1234.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112014465560399834)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'fr-ca'
,p_message_text=>'Suivant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112014553013399834)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'fr-ca'
,p_message_text=>'Jeu suivant'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112014664826399834)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112014730231399834)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Jeu pr\00E9c\00E9dent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112121739997399912)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9lectionner une pagination')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112052395998399861)
,p_name=>'PASSWORD'
,p_message_language=>'fr-ca'
,p_message_text=>'Mot de passe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111997030773399821)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Votre mot de passe pour %0 a \00E9t\00E9 modifi\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111986898404399812)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le mot de passe n''est pas conforme aux r\00E8gles de complexit\00E9 de mot de passe de ce site.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111985955484399811)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Le nouveau mot de passe doit comporter au moins {0} caract\00E8res diff\00E9rents de ceux du mot de passe pr\00E9c\00E9dent.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111986583795399812)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>'Le mot de passe ne doit pas contenir de nom d''utilisateur.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111986784723399812)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le mot de passe contient un mot simple non autoris\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111986645823399812)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>'Le mot de passe ne doit pas contenir de nom d''espace de travail.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111985864431399811)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le mot de passe doit contenir au moins %0 caract\00E8res.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111986063851399811)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le mot de passe doit contenir au moins un caract\00E8re alphab\00E9tique (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111986420692399812)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le mot de passe doit contenir au moins un caract\00E8re alphab\00E9tique minuscule.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111986167789399811)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le mot de passe doit contenir au moins un caract\00E8re num\00E9rique (0123456789).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111986211158399811)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le mot de passe doit contenir au moins un caract\00E8re de ponctuation (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111986355552399812)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le mot de passe doit contenir au moins un caract\00E8re alphab\00E9tique majuscule.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111997573102399821)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Avis de r\00E9initialisation de mot de passe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111984891632399810)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le mot de passe ne peut pas \00EAtre utilis\00E9, car il a \00E9t\00E9 utilis\00E9 au cours des %0 derniers jours.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112065193747399871)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('\00C9l\00E9ments')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112065230819399871)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('\00C9l\00E9ment')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112042237420399854)
,p_name=>'PERCENT'
,p_message_language=>'fr-ca'
,p_message_text=>'Pourcentage'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112012581577399832)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'fr-ca'
,p_message_text=>'Communiquez avec l''administrateur.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112121990095399912)
,p_name=>'PREVIOUS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Pr\00E9c\00E9dent')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112057352723399865)
,p_name=>'PRINT'
,p_message_language=>'fr-ca'
,p_message_text=>'Imprimer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112041048593399853)
,p_name=>'PRIVILEGES'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Privil\00E8ges')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112010921631399831)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('R\00E9f\00E9rences de r\00E9gion')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112031169441399846)
,p_name=>'REPORT'
,p_message_language=>'fr-ca'
,p_message_text=>'Rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112040923116399853)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('P\00E9riode de rapport')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112122115765399912)
,p_name=>'REPORT_LABEL'
,p_message_language=>'fr-ca'
,p_message_text=>'Rapport : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112041671547399853)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'fr-ca'
,p_message_text=>'Total du rapport'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111990814031399815)
,p_name=>'RESET'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('R\00E9initialiser la pagination')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112016764994399835)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('R\00E9initialiser la pagination')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112045747022399856)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('R\00E9initialiser le mot de passe')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112022580064399840)
,p_name=>'RESTORE'
,p_message_language=>'fr-ca'
,p_message_text=>'Restaurer'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112054492839399863)
,p_name=>'RESULTS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('R\00E9sultats')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112046826159399857)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Retour \00E0 l''application.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112047110499399858)
,p_name=>'RIGHT'
,p_message_language=>'fr-ca'
,p_message_text=>'Droite'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112076773304399879)
,p_name=>'ROW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Rang\00E9e %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112030751871399845)
,p_name=>'ROW_COUNT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Nombre de rang\00E9es')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112046293774399857)
,p_name=>'SAVE'
,p_message_language=>'fr-ca'
,p_message_text=>'Enregistrer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112042893586399854)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Alternatif par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112043219131399855)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'fr-ca'
,p_message_text=>'Description'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112042795406399854)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Principal par d\00E9faut')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112043506629399855)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Plus de %0 rang\00E9es sont disponibles. Augmentez la valeur du s\00E9lecteur de rang\00E9e pour voir plus de rang\00E9es.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112108917220399902)
,p_name=>'SEARCH'
,p_message_language=>'fr-ca'
,p_message_text=>'Rechercher'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112004188378399826)
,p_name=>'SECONDS'
,p_message_language=>'fr-ca'
,p_message_text=>'secondes'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112042338324399854)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'fr-ca'
,p_message_text=>'Voir le fichier joint'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112100090170399896)
,p_name=>'SELECT_ROW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('S\00E9lectionner une rang\00E9e')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112042025241399854)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9sactiver le mode Lecteur d''\00E9cran')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112042120182399854)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Activer le mode Lecteur d''\00E9cran')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112038469309399851)
,p_name=>'SHOW'
,p_message_language=>'fr-ca'
,p_message_text=>'Afficher'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112101831095399897)
,p_name=>'SHOW_ALL'
,p_message_language=>'fr-ca'
,p_message_text=>'Tout afficher'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112127972013399916)
,p_name=>'SIGN_IN'
,p_message_language=>'fr-ca'
,p_message_text=>'Connexion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112077523734399880)
,p_name=>'SIGN_OUT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9connexion')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112031702887399846)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'fr-ca'
,p_message_text=>'Il y a %0 jours'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112038929328399852)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 jours \00E0 partir de maintenant')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112031673018399846)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'fr-ca'
,p_message_text=>'Il y a %0 heures'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112038819520399851)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 heures \00E0 partir de maintenant')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112031557838399846)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'fr-ca'
,p_message_text=>'Il y a %0 minutes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112038721360399851)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 minutes \00E0 partir de maintenant')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112031910829399846)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'fr-ca'
,p_message_text=>'Il y a %0 mois'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112039194510399852)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 mois \00E0 partir de maintenant')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112039348681399852)
,p_name=>'SINCE_NOW'
,p_message_language=>'fr-ca'
,p_message_text=>'Maintenant'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112031420175399846)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'fr-ca'
,p_message_text=>'Il y a %0 secondes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112038652723399851)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 secondes \00E0 partir de maintenant')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112031855874399846)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'fr-ca'
,p_message_text=>'Il y a %0 semaines'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112039020772399852)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 semaines \00E0 partir de maintenant')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112032075261399846)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'fr-ca'
,p_message_text=>'Il y a %0 ans'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112039277812399852)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 ans \00E0 partir de maintenant')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112025564582399842)
,p_name=>'STANDARD'
,p_message_language=>'fr-ca'
,p_message_text=>'Standard'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112041937753399854)
,p_name=>'START_DATE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Date de d\00E9but')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111982485996399809)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vous recevez ce courriel \00E0 partir de l''abonnement au rapport interactif cr\00E9\00E9 par %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112137125885399923)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'fr-ca'
,p_message_text=>'Abonnements'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112085245587399885)
,p_name=>'TAB'
,p_message_language=>'fr-ca'
,p_message_text=>'Onglet'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112004077800399826)
,p_name=>'TITLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Titre'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111987034476399812)
,p_name=>'TODAY'
,p_message_language=>'fr-ca'
,p_message_text=>'Aujourd''hui'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112041556870399853)
,p_name=>'TOTAL'
,p_message_language=>'fr-ca'
,p_message_text=>'Total'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111988072394399813)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vous pouvez s\00E9lectionner un maximum de %0 colonnes.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111966522681399797)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Tout r\00E9duire')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111966898127399797)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('R\00E9duire tous les \00E9l\00E9ments en dessous')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111966473175399797)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Tout d\00E9velopper')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111966651582399797)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9velopper tous les \00E9l\00E9ments en dessous')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111966901045399797)
,p_name=>'TREE.REPARENT'
,p_message_language=>'fr-ca'
,p_message_text=>'Affecter un nouveau parent'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112059100086399866)
,p_name=>'TREES'
,p_message_language=>'fr-ca'
,p_message_text=>'Arbres'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112102633567399898)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'fr-ca'
,p_message_text=>'Obligatoire'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112026216987399842)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Non autoris\00E9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112073096861399876)
,p_name=>'UNAVAILABLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Non disponible'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112039739481399852)
,p_name=>'UNKNOWN'
,p_message_language=>'fr-ca'
,p_message_text=>'Inconnu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111983330875399809)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>'Une erreur d''authentification non reconnue est survenue.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111985333633399811)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Si vous ne souhaitez plus recevoir de courriels, cliquez sur <a href="%0">Se d\00E9sabonner</a> pour g\00E9rer votre abonnement.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111982372190399809)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Si vous ne souhaitez plus recevoir de courriels, allez \00E0 l''URL suivante pour g\00E9rer votre abonnement :')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112017269321399836)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('type de donn\00E9es non pris en charge')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112005390136399827)
,p_name=>'UPDATE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('mettre \00E0 jour')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112003940852399826)
,p_name=>'UPDATED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Mis \00E0 jour')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112010681735399831)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''URL demand\00E9e n''est pas autoris\00E9e. Communiquez avec l''administrateur.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112030626133399845)
,p_name=>'USER'
,p_message_language=>'fr-ca'
,p_message_text=>'Utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112052247129399861)
,p_name=>'USERNAME'
,p_message_language=>'fr-ca'
,p_message_text=>'Nom d''utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112091842357399890)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le nom d''utilisateur est trop long. La limite est %0 caract\00E8res.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112037472600399850)
,p_name=>'USERS'
,p_message_language=>'fr-ca'
,p_message_text=>'utilisateurs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112091406372399890)
,p_name=>'USER_EXISTS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le nom d''utilisateur existe d\00E9j\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112106172227399900)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'fr-ca'
,p_message_text=>'Image de profil pour l''utilisateur %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111993737198399819)
,p_name=>'VALID'
,p_message_language=>'fr-ca'
,p_message_text=>'Valide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111987372037399812)
,p_name=>'VALIDATIONS'
,p_message_language=>'fr-ca'
,p_message_text=>'Validations'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112043092602399855)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vous devez sp\00E9cifier une valeur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112086438210399886)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Une valeur doit \00EAtre sp\00E9cifi\00E9e pour %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112012913509399832)
,p_name=>'VERTICAL'
,p_message_language=>'fr-ca'
,p_message_text=>'vertical'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112005254115399827)
,p_name=>'VIEW'
,p_message_language=>'fr-ca'
,p_message_text=>'voir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112037574255399850)
,p_name=>'VIEWS'
,p_message_language=>'fr-ca'
,p_message_text=>'vues'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112043829859399855)
,p_name=>'VIEW_ALL'
,p_message_language=>'fr-ca'
,p_message_text=>'Tout voir'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112025098275399841)
,p_name=>'WARNING'
,p_message_language=>'fr-ca'
,p_message_text=>'Avertissement'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112004837435399827)
,p_name=>'WEEK'
,p_message_language=>'fr-ca'
,p_message_text=>'semaine'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112001843778399825)
,p_name=>'WEEKLY'
,p_message_language=>'fr-ca'
,p_message_text=>'Toutes les semaines'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112004968361399827)
,p_name=>'WEEKS'
,p_message_language=>'fr-ca'
,p_message_text=>'semaines'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112043145818399855)
,p_name=>'WELCOME_USER'
,p_message_language=>'fr-ca'
,p_message_text=>'Bienvenue : %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112041331313399853)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Valeur non valide trouv\00E9e. V\00E9rifiez les donn\00E9es entr\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112041432652399853)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Valeur non valide trouv\00E9e. V\00E9rifiez les donn\00E9es entr\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111984497927399810)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Valeur de date non valide trouv\00E9e. V\00E9rifiez le format de date.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112041231509399853)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Valeur num\00E9rique non valide trouv\00E9e. V\00E9rifiez le format de nombre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111993347434399818)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Valeur d''horodatage non valide trouv\00E9e. V\00E9rifiez le format d''horodatage.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112015800906399835)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Impossible de lier "%0". Utilisez des guillemets doubles pour les \00E9l\00E9ments multioctets, ou v\00E9rifiez que la longueur de l''\00E9l\00E9ment est \00E9gale ou inf\00E9rieure \00E0 30 octets. Utilisez la syntaxe v() pour r\00E9f\00E9rencer des \00E9l\00E9ments de plus de 30 octets.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112006319649399828)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Acc\00E8s refus\00E9 par le contr\00F4le de s\00E9curit\00E9 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112008832460399830)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Application non disponible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112007220888399828)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>'ERR-1014 Application introuvable.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112007397255399828)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>'application=%0  espace de travail=%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112007753029399829)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''acc\00E8s \00E0 cette application est restreint. R\00E9essayez plus tard.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112007696738399829)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('L''acc\00E8s \00E0 cette application est r\00E9serv\00E9 aux d\00E9veloppeurs d''application. R\00E9essayez plus tard.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112006862816399828)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>'ERR-7744 Impossible de traiter le branchement pour une fonction renvoyant une URL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112006765138399828)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>'ERR-7744 Impossible de traiter le branchement pour une fonction renvoyant une page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112007075908399828)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>'ERR-1430 L''appel de l''affichage depuis le processus de page n''est pas pris en charge : G_FLOW_STEP_ID (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112008100227399829)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('ERR-1018 Erreur lors de l''effacement du cache d''\00E9tape.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112006517407399828)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>'ERR-1005 Type de calcul inconnu.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112007410727399829)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('ERR-1201 ID session non d\00E9fini pour l''authentification personnalis\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112007574274399829)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>'page=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112007128312399828)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('ERR-7620 Impossible de d\00E9terminer l''espace de travail pour l''application (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111989505909399814)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'fr-ca'
,p_message_text=>'Modifier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112006261058399828)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('ERR-1802 ID \00E9l\00E9ment "%0" introuvable')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112005978813399827)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('ERR-1002 ID introuvable pour l''\00E9l\00E9ment "%0" dans l''application "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112006072267399828)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Erreur inattendue. Impossible de trouver le nom de l''\00E9l\00E9ment au niveau de l''application ou de la page.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112006458450399828)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vous \00EAtes d\00E9j\00E0 sur la premi\00E8re page de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112021948599399839)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''ID \00E9l\00E9ment (%0) n''est pas un \00E9l\00E9ment d\00E9fini dans la page courante.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111984008180399810)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Impossible de d\00E9finir l''\00E9l\00E9ment en transmettant des arguments \00E0 l''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111984390558399810)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('(Aucune somme de contr\00F4le n''a \00E9t\00E9 fournie)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111983860450399810)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''\00E9l\00E9ment peut \00EAtre d\00E9fini s''il est accompagn\00E9 d''une somme de contr\00F4le de type "signet de niveau utilisateur".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111983702123399810)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''\00E9l\00E9ment peut \00EAtre d\00E9fini s''il est accompagn\00E9 d''une somme de contr\00F4le de type "signet de niveau application".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111983950057399810)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''\00E9l\00E9ment peut \00EAtre d\00E9fini s''il est accompagn\00E9 d''une somme de contr\00F4le de type "session".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111983635720399810)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''\00E9l\00E9ment n''a aucune protection.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112008266515399829)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'fr-ca'
,p_message_text=>'Aucune aide disponible sur la page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111997381327399821)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''espace de travail %0 n''a pas les privil\00E8ges n\00E9cessaires pour effectuer une analyse en tant que sch\00E9ma %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112006658409399828)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('ERR-1010 D\00E9passement de la limite de r\00E9cursivit\00E9 du traitement d''acceptation de branchement vers une page. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111984200216399810)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Cette page ne peut pas \00EAtre appel\00E9e \00E0 l''aide d''une URL ou d''une commande GET ou POST vers la proc\00E9dure d''affichage. Elle doit \00EAtre appel\00E9e \00E0 l''aide d''un branchement de type "Branchement vers une page".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112060973864399868)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Erreur lors de la tentative d''enregistrement d''une valeur non num\00E9rique dans l''\00E9l\00E9ment %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111999036651399823)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le sch\00E9ma d''analyse de l''application "%0" n''existe pas dans la base de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111999142624399823)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Les comptes de l''espace de travail INTERNAL ne peuvent \00EAtre utilis\00E9s que pour acc\00E9der \00E0 &PRODUCT_NAME. <a href="%0">Services d''administration</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112005828783399827)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('ERR-1029 Impossible de stocker les informations de session. session=%0 \00E9l\00E9ment=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112008900759399830)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Impossible d''arr\00EAter la trace : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112006117579399828)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>'Erreur inattendue'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112016153559399835)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>'Erreur dans update_substitution_cache : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112009047628399830)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Pour afficher l''aide, l''application et la page doivent \00EAtre indiqu\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112029518441399845)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'fr-ca'
,p_message_text=>'Automatisation introuvable.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112010160576399830)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Sessions %0 \00E9pur\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111969434497399799)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Impossible d''ex\00E9cuter le code %0. Il n''est pas pris en charge par la base de donn\00E9es ou n''est pas activ\00E9 par le param\00E8tre d''instance MLE_LANGUAGES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111969298007399799)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le moteur multilingue n''est pas disponible pour cette version de base de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111990003836399814)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le tableau de la collection d''applications ne doit pas \00EAtre vide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111989890032399814)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le num\00E9ro d''attribut de membre %0 sp\00E9cifi\00E9 n''est pas valide. Le num\00E9ro d''attribut doit \00EAtre compris entre 1 et %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111990344764399815)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La collection d''applications existe d\00E9j\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111990107230399814)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le nom de la collection ne peut pas \00EAtre nul')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111990255844399814)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le nom de la collection ne peut pas comporter plus de 255 caract\00E8res')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111989663392399814)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'fr-ca'
,p_message_text=>'La collection d''applications %0 n''existe pas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111990469249399815)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'fr-ca'
,p_message_text=>'Le curseur n''est pas encore ouvert'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111989733725399814)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La s\00E9quence de membre %0 n''existe pas dans la collection d''applications %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111989956875399814)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La s\00E9quence de membre %0 n''existe pas dans la collection d''applications "%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112061730184399868)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La fonction cryptographique "%0" n''est pas prise en charge par ce syst\00E8me.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112115246140399907)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Accessibilit\00E9 test\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112009633663399830)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'fr-ca'
,p_message_text=>'Fermer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112009744690399830)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'fr-ca'
,p_message_text=>'Options de personnalisation de page'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112009843604399830)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Par d\00E9faut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112009940430399830)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Affich\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112010003527399830)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Masqu\00E9 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112009419773399830)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Cochez les r\00E9gions que vous souhaitez voir figurer sur cette page. Les r\00E9gions coch\00E9es peuvent ne pas s''afficher si vous n''\00EAtes pas dans le bon contexte d''application ou si vous ne disposez pas des privil\00E8ges appropri\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112009597985399830)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'fr-ca'
,p_message_text=>'Cette page n''est pas personnalisable.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112115563027399907)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vous pouvez personnaliser l''apparence de cette application en modifiant le style du th\00E8me. S\00E9lectionnez un style de th\00E8me dans la liste ci-dessous et cliquez sur Appliquer les modifications.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112116324854399908)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Affichage de la r\00E9gion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112115472821399907)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Utiliser le style par d\00E9faut de l''application')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112115326596399907)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'fr-ca'
,p_message_text=>'Apparence'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112058309839399866)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''index de colonne r\00E9f\00E9renc\00E9 dans l''agr\00E9gat %0 n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111961616672399794)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'fr-ca'
,p_message_text=>'La sortie CLOB n''est pas prise en charge pour le format %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112058068063399865)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La section de colonne doit appara\00EEtre au d\00E9but du tableau de colonnes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112058188695399865)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''index de groupe de colonnes r\00E9f\00E9renc\00E9 dans %0 n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111975645265399804)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'fr-ca'
,p_message_text=>'exportation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111980878974399808)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le format d''exportation doit \00EAtre XML avec ORDS comme serveur d''impression.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112058478755399866)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''index de colonne r\00E9f\00E9renc\00E9 dans la mise en surbrillance %0 n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111974143305399803)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'fr-ca'
,p_message_text=>'Format d''exportation non valide : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112058226584399866)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''index de groupe parent r\00E9f\00E9renc\00E9 dans %0 n''existe pas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112083475966399884)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La colonne %1 de la table %0 est une colonne d''identit\00E9 "GENERATED ALWAYS". Assurez-vous qu''aucune colonne source n''est mapp\00E9e \00E0 la colonne %1 dans la bo\00EEte de dialogue Configurer.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112000852817399824)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''intervalle de validation sp\00E9cifi\00E9 est trop faible.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112000978120399824)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aucune colonne n''a \00E9t\00E9 fournie pour le chargement des donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112002180262399825)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aucune colonne trouv\00E9e pour le s\00E9lecteur de rang\00E9e "%0". Essayez la d\00E9tection automatique ou v\00E9rifiez la structure JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112010493861399831)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aucune feuille de calcul trouv\00E9e dans le fichier XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112010310499399831)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La feuille de calcul sp\00E9cifi\00E9e n''existe pas dans le fichier XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111990522947399815)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La version courante des donn\00E9es dans la base de donn\00E9es a chang\00E9 depuis le lancement de la mise \00E0 jour par l''utilisateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111992965613399818)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Erreur lors de la mise \00E0 jour des colonnes du rapport : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112097671365399894)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'fr-ca'
,p_message_text=>'Impossible de convertir %0 en SDO_GEOMETRY.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112037101024399850)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La colonne %0 qui est du type de donn\00E9es %1 ne peut pas \00EAtre convertie en VARCHAR2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112044106208399855)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La colonne "%0" sp\00E9cifi\00E9e pour l''attribut "%1" n''a pas \00E9t\00E9 trouv\00E9e dans la source de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111985421950399811)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le type de filtre %0 n''est pas pris en charge pour les colonnes \00E0 valeurs multiples.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112101062456399897)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'fr-ca'
,p_message_text=>'Filtre "compris entre" non valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111967563630399798)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Type de LDV indiqu\00E9 non valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111967415134399798)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'fr-ca'
,p_message_text=>'Type d''interrogation non valide. Le type d''interrogation doit avoir pour valeur Table, Interrogation SQL ou Fonction PL/SQL renvoyant une interrogation SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112037296704399850)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\00C9chec de l''analyse de l''interrogation SQL.'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112044237782399855)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La position de colonne %0 sp\00E9cifi\00E9e pour l''attribut "%1" n''a pas \00E9t\00E9 trouv\00E9e dans l''\00E9nonc\00E9 SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111966074104399797)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Trop d''\00E9l\00E9ments utilis\00E9s dans le filtre multivaleur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112044082965399855)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aucune colonne n''est sp\00E9cifi\00E9e pour l''attribut "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111967367397399798)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le corps de la fonction PL/SQL n''a pas retourn\00E9 de valeur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112057271981399865)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La source de donn\00E9es REST ne contient pas d''op\00E9ration permettant de traiter l''action LMD demand\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111963264055399795)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La conversion de GeoJSON en SDO_GEOMETRY (colonne %0) n''est pas disponible dans cette base de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111964336264399796)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La conversion SDO_GEOMETRY (colonne %0) n''est pas prise en charge pour les sources de donn\00E9es XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111971653030399801)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le caract\00E8re %0 n''est pas pris en charge comme s\00E9parateur de valeurs multiples.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112098913361399895)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Cette fonction ne peut pas \00EAtre utilis\00E9e dans un contexte d''interrogation.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111964444355399796)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Non-concordance de type de donn\00E9es de colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111967222770399798)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('D\00E9passement des limites de liaison ORDS OUT internes. R\00E9duisez le nombre de rang\00E9es LMD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112045053710399856)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Impossible d''analyser la r\00E9ponse JSON du serveur distant : '),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111967145751399797)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>'Type de contexte inconnu ou incorrect.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112061619834399868)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'fr-ca'
,p_message_text=>'Ce type de fichier n''est pas pris en charge par l''analyseur.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112016280494399835)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Acc\00E8s non autoris\00E9 (wwv_flow_api.set_credentials non d\00E9fini).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111993235893399818)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''espace de travail n''a pas \00E9t\00E9 cr\00E9\00E9 car il existe d\00E9j\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111993189418399818)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le groupe d''utilisateurs n''a pas \00E9t\00E9 cr\00E9\00E9 car il existe d\00E9j\00E0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112003431714399826)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Nom d''utilisateur en double trouv\00E9 pour %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112003501388399826)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Erreur lors du chargement des utilisateurs. \00C9chec pour l''utilisateur %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112013450097399833)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 utilisateurs auraient \00E9t\00E9 charg\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112013248373399833)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'fr-ca'
,p_message_text=>'Mot de passe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112013300914399833)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Privil\00E8ges')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112013013654399833)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'fr-ca'
,p_message_text=>'Nom d''utilisateur'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112089524411399888)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Erreur lors du rendu de l''\00E9l\00E9ment de page #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112009180173399830)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Impossible d''afficher l''\00E9l\00E9ment de page car le formulaire HTML n''\00E9tait pas encore ouvert.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111974471883399803)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Erreur lors du calcul de la valeur par d\00E9faut pour l''\00E9l\00E9ment de page #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112008406877399829)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Erreur lors du post-calcul de l''\00E9l\00E9ment de page #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112008368380399829)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Erreur lors du calcul de la valeur source de l''\00E9l\00E9ment de page #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111988115361399813)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Acc\00E8s non autoris\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112008663364399829)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'fr-ca'
,p_message_text=>'JavaScript non pris en charge.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112008727612399829)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'fr-ca'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112009384324399830)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'fr-ca'
,p_message_text=>'Impossible d''initialiser l''interrogation.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112016594283399835)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La mise \00E0 jour de %0 n''est pas prise en charge.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112010735838399831)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('ID \00E9l\00E9ment non valide : %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112037039777399850)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Il n''existe aucune aide pour cet \00E9l\00E9ment.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112001534158399824)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('\00C9chec de la g\00E9n\00E9ration de l''interrogation de graphique. V\00E9rifiez les param\00E8tres de mappage source-colonne.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112096353306399893)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le fichier joint dont la taille est de %0 Mo d\00E9passe la taille maximale de %1 Mo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112002489713399825)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Valeur non valide pour le param\00E8tre p_mail_id : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112119871234399910)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vous avez d\00E9pass\00E9 le nombre maximal de courriels par espace de travail. Communiquez avec l''administrateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111983460873399809)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Cette proc\00E9dure doit \00EAtre appel\00E9e \00E0 partir d''une session d''application.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112002367081399825)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Valeur nulle indiqu\00E9e pour le param\00E8tre %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112056348473399864)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Mod\00E8le de courriel "%0" introuvable dans l''application %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112132888562399920)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le param\00E8tre d''instance SMTP_HOST_ADDRESS doit \00EAtre d\00E9fini pour l''envoi de courriels.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112002021404399825)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'fr-ca'
,p_message_text=>'Vous devez indiquer au moins un destinataire pour l''envoi de courriel.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112122297797399912)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Impossible d''\00E9tablir une connexion SMTP avec le serveur de courriel configur\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112096424947399893)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'fr-ca'
,p_message_text=>'Appel Ajax non valide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111987821302399813)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aucune fonction Ajax n''a \00E9t\00E9 d\00E9finie pour le plugiciel %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112086896610399886)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aucune fonction d''ex\00E9cution n''a \00E9t\00E9 d\00E9finie pour le plugiciel %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111987965769399813)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aucune fonction de rendu n''a \00E9t\00E9 d\00E9finie pour le plugiciel %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112097377046399894)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le plugiciel de source de donn\00E9es REST "%0" ne contient pas de fonction de capacit\00E9s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112097206380399894)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le plugiciel de source de donn\00E9es REST "%0" ne contient pas de fonction LMD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112097441212399894)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le plugiciel de source de donn\00E9es REST "%0" ne contient pas de fonction d''ex\00E9cution.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112097514413399894)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le plugiciel de source de donn\00E9es REST "%0" ne contient pas de fonction d''extraction.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111985692065399811)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Erreur dans le code PLSQL g\00E9n\00E9r\00E9e pendant le traitement du plugiciel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111992251122399817)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vous devez sp\00E9cifier une valeur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112022898329399840)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le type de donn\00E9es %0 ne peut pas \00EAtre converti en VARCHAR2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112108491046399902)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La colonne "%0" sp\00E9cifi\00E9e pour l''attribut "%1" n''a pas \00E9t\00E9 trouv\00E9e dans l''\00E9nonc\00E9 SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112084738392399885)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Une interrogation de type liste de valeurs (LDV) ou liste de valeurs nomm\00E9e doit \00EAtre sp\00E9cifi\00E9e pour %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112086378590399886)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le nombre de colonnes s\00E9lectionn\00E9es dans l''interrogation SQL de LDV pour %0 est incorrect. Consultez les exemples d''\00E9nonc\00E9s valides.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112108219528399902)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Aucune colonne n''est sp\00E9cifi\00E9e pour l''attribut "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112137993372399923)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La valeur entr\00E9e %0 pour l''attribut "%1" n''est pas num\00E9rique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112089878439399889)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('%0 a un type de donn\00E9es incorrect dans l''\00E9nonc\00E9 SQL. Le num\00E9ro de colonne %1 est %2 mais %3 est attendu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112108385641399902)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La colonne "%0" sp\00E9cifi\00E9e pour l''attribut "%1" a le type de donn\00E9es %2 mais devrait avoir le type %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111984911105399810)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'fr-ca'
,p_message_text=>'Impossible de trouver la disposition du rapport.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112044939708399856)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La fonction de calcul de la somme ne peut pas \00EAtre utilis\00E9e pour les rapports bas\00E9s sur une source de donn\00E9es REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112008514892399829)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('ERR-2904 Impossible de d\00E9finir la valeur de raccourci.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112012854508399832)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>'Erreur : Type de raccourci inconnu.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112002824852399825)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Impossible d''extraire le param\00E8tre authentication_scheme dans l''application %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112076368584399879)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''ID locataire existe d\00E9j\00E0 pour la session courante.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112013170566399833)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'fr-ca'
,p_message_text=>'Courriel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112137302399399923)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('\00C9chec de l''authentification.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112039621314399852)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Un ou plusieurs t\00E9moins d\00E9finis dans apex_util.g_request_cookies contiennent une valeur non valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112022134747399839)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La r\00E9ponse du registre UDDI n''\00E9tait pas valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111985797951399811)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('L''URL fournie n''a pas retourn\00E9 de document WSDL valide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111988211655399813)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Le document WSDL contient plusieurs liaisons SOAP. &PRODUCT_NAME. ne prend en charge que les documents WSDL ayant une seule liaison SOAP. Cliquez sur Cr\00E9er manuellement une r\00E9f\00E9rence de service Web pour continuer la cr\00E9ation d''une r\00E9f\00E9rence pour ce s')
||'ervice.',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112056674542399864)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('La r\00E9ponse du service n''\00E9tait pas au format XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112137254904399923)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le jeton d''acc\00E8s OAuth n''est pas valide ou a expir\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112100410187399896)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Vous avez d\00E9pass\00E9 le nombre maximal de demandes de service Web par espace de travail. Communiquez avec l''administrateur.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112137420837399923)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le serveur a r\00E9pondu avec un type de jeton OAuth non pris en charge.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111987684737399812)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le document WSDL ne contenait pas de liaison pour SOAP, ce qui est n\00E9cessaire pour l''ajout de r\00E9f\00E9rence.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111983549913399809)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ce document WSDL n\00E9cessite des donn\00E9es d''identification pour l''authentification. Indiquez le nom d''utilisateur et le mot de passe ci-dessous.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111992319490399817)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le document WSDL n''a pas pu \00EAtre interpr\00E9t\00E9 par le moteur de rendu. Cliquez sur Cr\00E9er une r\00E9f\00E9rence de service Web manuellement pour continuer la cr\00E9ation d''une r\00E9f\00E9rence pour ce service.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112059210761399866)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Impossible de traiter la mise \00E0 jour.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112085099763399885)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'fr-ca'
,p_message_text=>'La colonne de retour et la colonne d''affichage de la liste de valeurs sont identiques.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112084994930399885)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'La liste de valeurs n''a pas de colonne de retour.',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112016408359399835)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>'Erreur lors de l''extraction de la valeur de colonne : %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112040432993399853)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Les donn\00E9es du formulaire tabulaire courant sont trop anciennes; les donn\00E9es sources ont \00E9t\00E9 modifi\00E9es.<br/>Cliquez <strong><a href="%0">ici</a></strong> pour abandonner vos modifications et recharger les donn\00E9es depuis la base de donn\00E9es.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111998519739399822)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Erreur lors de la d\00E9termination de la cha\00EEne de pagination')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111998460360399822)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('impossible de d\00E9terminer les en-t\00EAtes d''interrogation :'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111998632030399822)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'fr-ca'
,p_message_text=>'erreur lors du remplacement des pieds de page du rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111998783169399822)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\00E9chec de l''analyse de l''interrogation SQL :'),
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112003703632399826)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Nombre minimal de rang\00E9es demand\00E9es : %0, rang\00E9es trouv\00E9es mais non affich\00E9es : %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112001200410399824)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('la colonne d''interrogation #%0 (%1) n''est pas valide, les colonnes qui utilisent du HTML n\00E9cessitent des noms d''alias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112016369882399835)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Erreur lors de l''obtention des en-t\00EAtes d''interrogation : %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111998808375399822)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'erreur de rapport :',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112036552807399850)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'fr-ca'
,p_message_text=>'Trier en fonction de cette colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112001320370399824)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'fr-ca'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Impossible d''analyser l''interrogation, v\00E9rifiez la syntaxe de votre interrogation.'),
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112040535755399853)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Ce formulaire contient des modifications non enregistr\00E9es. Cliquez sur OK pour continuer sans enregistrer vos modifications. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112044894388399856)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('Le sch\00E9ma de pagination du rapport (%0) n''est pas pris en charge par la source de donn\00E9es s\00E9lectionn\00E9e.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112001171459399824)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'fr-ca'
,p_message_text=>'la colonne d''interrogation #%0 (%1) n''est pas valide, utilisez un alias de colonne'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112003858043399826)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('rang\00E9e(s) %0 - %1 de plus de %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112042572396399854)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 - %1 de plus de %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112003640779399826)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('rang\00E9e(s) %0 - %1 de %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111987592836399812)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'fr-ca'
,p_message_text=>'%0 - %1 de %2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111998976666399822)
,p_name=>'Y'
,p_message_language=>'fr-ca'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112005008506399827)
,p_name=>'YEAR'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('ann\00E9e')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111998115031399822)
,p_name=>'YEARS'
,p_message_language=>'fr-ca'
,p_message_text=>unistr('ann\00E9es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(112040643483399853)
,p_name=>'YES'
,p_message_language=>'fr-ca'
,p_message_text=>'Oui'
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4497)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4497)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Bureau'
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4497
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4497)
,p_name=>'Messages'
,p_alias=>'MESSAGES'
,p_step_title=>'Messages'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
