prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4052
,p_default_id_offset=>0
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4052 - Oracle APEX Internal Administration
--
-- Application Export:
--   Application:     4052
--   Name:            Oracle APEX Internal Administration
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                    166
--       Items:                  531
--       Computations:            51
--       Validations:            172
--       Processes:              168
--       Regions:                593
--       Buttons:                337
--       Dynamic Actions:         61
--     Shared Components:
--       Logic:
--         Items:                  5
--         Computations:           3
--         Build Options:          3
--       Navigation:
--         Lists:                 39
--         Breadcrumbs:            1
--           Entries:            153
--         NavBar Entries:         4
--       Security:
--         Authentication:         9
--         Authorization:         10
--       User Interface:
--         Templates:
--           Page:                14
--           Region:              45
--           Label:               13
--           List:                15
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           2
--           Button:              12
--           Report:              13
--         LOVs:                 120
--         Shortcuts:              5
--         Plug-ins:              13
--       Globalization:
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Internal Administration')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A110301971138356744')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'N'
,p_checksum_salt_last_reset=>'20211020110849'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'fr'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_publish_yn=>'Y'
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(540226219724705040.4052)
,p_populate_roles=>'A'
,p_application_tab_set=>1
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(1018002984071621)
,p_authorize_public_pages_yn=>'Y'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_error_handling_function=>'wwv_flow_error_dev.internal_error_handler'
,p_global_notification=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style type="text/css">',
'<!--',
'#htmldbWorkspace{display:none;}',
'-->',
'</style>'))
,p_friendly_url=>'N'
,p_substitution_string_01=>'LOGOUT'
,p_substitution_value_01=>unistr('D\00E9connexion')
,p_substitution_string_02=>'DELETE_MSG'
,p_substitution_value_02=>'Voulez-vous effectuer cette action de suppression ?'
,p_substitution_string_03=>'HELP'
,p_substitution_value_03=>'Aide'
,p_substitution_string_04=>'PRODUCT_NAME'
,p_substitution_value_04=>'Oracle APEX'
,p_substitution_string_05=>'COMPANY_NAME'
,p_substitution_value_05=>'Espace de travail'
,p_substitution_string_06=>'MSG_COMPANY'
,p_substitution_value_06=>'Espace de travail : &COMPANY.'
,p_substitution_string_07=>'MSG_LANGUAGE'
,p_substitution_value_07=>'Langue'
,p_substitution_string_08=>'MSG_COPYRIGHT'
,p_substitution_value_08=>unistr('Copyright &copy; 1999, 2021, Oracle et/ou ses affili\00E9s.')
,p_substitution_string_09=>'MSG_USER'
,p_substitution_value_09=>'Utilisateur'
,p_substitution_string_10=>'MSG_JSCRIPT'
,p_substitution_value_10=>unistr('JavaScript doit \00EAtre activ\00E9 lorsque vous ex\00E9cutez ce produit.')
,p_substitution_string_11=>'MSG_TBL_SUMMARY'
,p_substitution_value_11=>'Table de mise en page'
,p_substitution_string_12=>'EDIT'
,p_substitution_value_12=>'Modifier'
,p_substitution_string_13=>'DONE'
,p_substitution_value_13=>unistr('Termin\00E9')
,p_substitution_string_14=>'TOP'
,p_substitution_value_14=>'Haut'
,p_substitution_string_15=>'CLOSE'
,p_substitution_value_15=>'Fermer'
,p_substitution_string_16=>'DATE_FORMAT'
,p_substitution_value_16=>'dd/mm/rr'
,p_substitution_string_17=>'LONG_DATE_FORMAT'
,p_substitution_value_17=>'fmDay dd Month yyyy'
,p_substitution_string_18=>'TIME_FORMAT'
,p_substitution_value_18=>'hh24:mi:ss'
,p_substitution_string_19=>'DATE_TIME_FORMAT'
,p_substitution_value_19=>'dd/mm/rr hh24:mi:ss'
,p_substitution_string_20=>'RETURN_TO_APP'
,p_substitution_value_20=>unistr('Retour \00E0 l''application')
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020112602'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/shared_components/navigation/lists/session_state_management
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(3417102067886535.4052)
,p_name=>'session.state.management'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3439527750998023.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Derni\00E8res sessions')
,p_list_item_link_target=>'f?p=&APP_ID.:65:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-recent-sessions'
,p_list_text_01=>unistr('Passez en revue les sessions r\00E9centes dans toute l''instance, y compris le nom utilisateur et l''espace de travail.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3462301271103893.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Purger les sessions'
,p_list_item_link_target=>'f?p=&APP_ID.:66:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-purge-sessions-age'
,p_list_text_01=>unistr('Purgez les informations sur le statut de session, en fonction de l''\00E2ge de la session.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3417616612890680.4052)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Statistiques sur les statuts de session'
,p_list_item_link_target=>'f?p=&APP_ID.:64:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-session-state-statistics'
,p_list_text_01=>unistr('Statistiques sur le nombre de sessions et d''entr\00E9es en m\00E9moire cache.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/log_management
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(5021913929565780.4052)
,p_name=>'log.management'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(217657516318353638.4052)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>unistr('G\00E9rer l''intervalle de journalisation')
,p_list_item_link_target=>'f?p=&APP_ID.:119:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1218056692025697508.4052)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>unistr('Journal des activit\00E9s d''archivage')
,p_list_item_link_target=>'f?p=&APP_ID.:34:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(22612925776612371.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Journal de SQL Workshop'
,p_list_item_link_target=>'f?p=&APP_ID.:46:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'46'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(5024227220579151.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Journal des activit\00E9s de vue de page')
,p_list_item_link_target=>'f?p=&APP_ID.:61:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(5032419648605291.4052)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Journal des activit\00E9s de d\00E9veloppeur')
,p_list_item_link_target=>'f?p=&APP_ID.:19:&SESSION.::&DEBUG.::::'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(5141329999655580.4052)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Journal des clics externes'
,p_list_item_link_target=>'f?p=&APP_ID.:85:&SESSION.::&DEBUG.::::'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15382629387113488.4052)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>unistr('Journal de connexions \00E0 Access')
,p_list_item_link_target=>'f?p=&APP_ID.:31:&SESSION.::&DEBUG.::::'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(620861715997218025.4052)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>unistr('Journal des activit\00E9s de service Web')
,p_list_item_link_target=>'f?p=&APP_ID.:139:&SESSION.::&DEBUG.::::'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1415760425022980.4052)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Journal de synchronisation REST'
,p_list_item_link_target=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1592978610657004.4052)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Journal d''automatisation'
,p_list_item_link_target=>'f?p=&APP_ID.:182:&SESSION.::&DEBUG.::::'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/workspace_reports
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(10332318553893424.4052)
,p_name=>'workspace reports'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10336708903919077.4052)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Espaces de travail existants'
,p_list_item_link_target=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10338404532927250.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('D\00E9tails de l''espace de travail')
,p_list_item_link_target=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.:RP,14:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10335923317913792.4052)
,p_list_item_display_sequence=>300
,p_list_item_link_text=>unistr('Privil\00E8ges de base de donn\00E9es d''espace de travail')
,p_list_item_link_target=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168488129805460181.4052)
,p_list_item_display_sequence=>320
,p_list_item_link_text=>unistr('G\00E9rer l''utilisation de fichier')
,p_list_item_link_target=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1222568618805757405.4052)
,p_list_item_display_sequence=>330
,p_list_item_link_text=>unistr('Rechercher et envoyer par courriel le r\00E9capitulatif de l''espace de travail')
,p_list_item_link_target=>'f?p=&APP_ID.:8000:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(524767964229086348.4052)
,p_list_item_display_sequence=>340
,p_list_item_link_text=>unistr('Cache de dictionnaire de donn\00E9es')
,p_list_item_link_target=>'f?p=&APP_ID.:150:&SESSION.::&DEBUG.:RP,150:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/auto_provision_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(12048115202363924.4052)
,p_name=>'auto.provision.progress'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(12057805252417809.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Identifier un espace de travail'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'27'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(12659809588228188.4052)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>unistr('Identifier un sch\00E9ma')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'79'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(12058110447419334.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Identifier un administrateur'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'72'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(12058415642420858.4052)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Confirmer la demande'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'73'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168860731992836215.4052)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Confirmation de succ\00E8s')
,p_list_item_link_target=>'f?p=&APP_ID.:74:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'74'
);
end;
/
prompt --application/shared_components/navigation/lists/company_admin_remove
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(14571819699173520.4052)
,p_name=>'company.admin.remove'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(14575726756185055.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Identifier un espace de travail'
,p_list_item_link_target=>'f?p=&FLOW_ID.:81:&SESSION.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'81'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(14576220654192685.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('V\00E9rifier les applications')
,p_list_item_link_target=>'f?p=&FLOW_ID.:82:&SESSION.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'82'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(14576707972198542.4052)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Confirmer la suppression de l''espace de travail'
,p_list_item_link_target=>'f?p=&APP_ID.:83:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'83'
);
end;
/
prompt --application/shared_components/navigation/lists/monitor_activtiy_date_reports
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(14738731575074699.4052)
,p_name=>'monitor.activtiy.date.reports'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(14743211405087780.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Dernier espace de travail utilis\00E9')
,p_list_item_link_target=>'f?p=&APP_ID.:25:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_disp_cond_type=>'NOT_EXISTS'
,p_list_item_disp_condition=>'select 1 from wwv_flows where id = 4000 and FLOW_VERSION like ''% 2.1.%'''
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(14744721102090541.4052)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Par jour, application et utilisateur'
,p_list_item_link_target=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(14745728374092653.4052)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Par heure'
,p_list_item_link_target=>'f?p=&APP_ID.:69:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/monitor_activity_os_reports
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(14750409028115431.4052)
,p_name=>'monitor.activity.os.reports'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(14750617712115433.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Par syst\00E8me d''exploitation')
,p_list_item_link_target=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(14751517869115434.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Par navigateur'
,p_list_item_link_target=>'f?p=&APP_ID.:15:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(14750901683115434.4052)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Par agent utilisateur'
,p_list_item_link_target=>'f?p=&APP_ID.:38:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(14751217522115434.4052)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Par site externe'
,p_list_item_link_target=>'f?p=&APP_ID.:45:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/company_admin_schema
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(18701007817245520.4052)
,p_name=>'company.admin.schema'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18701529288251758.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Nouveau ou existant'
,p_list_item_link_target=>'f?p=4050:105:&SESSION.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'105'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18702119030258176.4052)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Choisir un espace de travail'
,p_list_item_link_target=>'f?p=4050:107:&SESSION.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'107'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18701805178254192.4052)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>unistr('Identifier un sch\00E9ma')
,p_list_item_link_target=>'f?p=&FLOW_ID.:106:&SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'106'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18702425610260147.4052)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Confirmer'
,p_list_item_link_target=>'f?p=4050:108:&SESSION.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'108'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_service
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(19017202882431374.4052)
,p_name=>'manage.service'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(75154318706107288.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('T\00E2ches propres au site')
,p_list_item_link_target=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.:17:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_disp_cond_type=>'NEVER'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2584422400873819.4052)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Statut de session'
,p_list_item_link_target=>'f?p=&APP_ID.:63:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(50289618943123605.4052)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'File d''attente des courriels'
,p_list_item_link_target=>'f?p=&APP_ID.:120:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2702728512959332.4052)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>unistr('G\00E9rer les demandes de t\00E9l\00E9chargement')
,p_list_item_link_target=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_disp_cond_type=>'HTTP_HOST_EQ_CONDITION'
,p_list_item_disp_condition=>'marvel.oracle.com'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3573418802449584.4052)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>unistr('Droits d''acc\00E8s de fichier')
,p_list_item_link_target=>'f?p=&APP_ID.:95:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_disp_cond_type=>'NEVER'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(201522704568695924.4052)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>unistr('Traductions install\00E9es')
,p_list_item_link_target=>'f?p=&APP_ID.:100:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(274115211211763732.4052)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>unistr('Abonnements d''\00E9tat interactif')
,p_list_item_link_target=>'f?p=&APP_ID.:129:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_workspace
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(19017606691432489.4052)
,p_name=>'Manage Workspace'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2569313499653574.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Cr\00E9er un espace de travail')
,p_list_item_link_target=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:27,79,72,73,74:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(384629092101759662.4052)
,p_list_item_display_sequence=>10.5
,p_list_item_link_text=>unistr('Cr\00E9er un espace de travail')
,p_list_item_link_target=>'f?p=&APP_ID.:142:&SESSION.::&DEBUG.:142:LAST_VIEW:10:'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_required_patch=>-wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(203140401722334966.4052)
,p_list_item_display_sequence=>11
,p_list_item_link_text=>unistr('Cr\00E9er plusieurs espaces de travail')
,p_list_item_link_target=>'f?p=&APP_ID.:115:&SESSION.::&DEBUG.:115,116,117:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(14538928292646129.4052)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Enlever un espace de travail'
,p_list_item_link_target=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:81,82:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(74659715539048394.4052)
,p_list_item_display_sequence=>45
,p_list_item_link_text=>'Verrouiller l''espace de travail'
,p_list_item_link_target=>'f?p=&APP_ID.:89:&SESSION.::&DEBUG.:89,90:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(19720903523535398.4052)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('G\00E9rer les affectations d''espaces de travail \00E0 des sch\00E9mas')
,p_list_item_link_target=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(14539719765653081.4052)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>unistr('G\00E9rer les d\00E9veloppeurs et les utilisateurs')
,p_list_item_link_target=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(173286806863766271.4052)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>unistr('G\00E9rer la disponibilit\00E9 des composants')
,p_list_item_link_target=>'f?p=&APP_ID.:52:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/workspace_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(29722514446881924.4052)
,p_name=>'Workspace Tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(29722732656881928.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Cr\00E9er un espace de travail')
,p_list_item_link_target=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:27,79,72,73,74:::'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt=""'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(385021728151143594.4052)
,p_list_item_display_sequence=>10.5
,p_list_item_link_text=>unistr('Cr\00E9er un espace de travail')
,p_list_item_link_target=>'f?p=&APP_ID.:142:&SESSION.::&DEBUG.:142:LAST_VIEW:3:'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt=""'
,p_required_patch=>-wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(203154302892486334.4052)
,p_list_item_display_sequence=>11
,p_list_item_link_text=>unistr('Cr\00E9er plusieurs espaces de travail')
,p_list_item_link_target=>'f?p=&APP_ID.:115:&SESSION.::&DEBUG.:RP,115,116,117:::'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(29758112134439446.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Rechercher un espace de travail'
,p_list_item_link_target=>'f?p=&APP_ID.:8000:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(29723016608881931.4052)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('G\00E9rer les espaces de travail')
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:81,82:::'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(46460724791484872.4052)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('Cr\00E9er un utilisateur')
,p_list_item_link_target=>'f?p=&APP_ID.:23:&SESSION.::&DEBUG.:23,EDIT_USER_PRIVS:::'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt=""'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(46461311070490353.4052)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Rechercher un utilisateur'
,p_list_item_link_target=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt=""'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168923102453062025.4052)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>unistr('R\00E9initialiser le mot de passe de l''utilisateur')
,p_list_item_link_target=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt=""'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/tabs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(40102013671283832.4052)
,p_name=>'Tabs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(40120501775346610.4052)
,p_list_item_display_sequence=>0
,p_list_item_link_text=>'Page d''accueil'
,p_list_item_link_target=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'3,8000'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(40102417827285020.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('G\00E9rer les demandes')
,p_list_item_link_target=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.::::'
,p_list_item_icon_alt_attribute=>'Analyse descendante de gestion des demandes'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4,5,6,7,8,26,28,55,56,110'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192003502869565470.4052)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Toutes les demandes'
,p_list_item_link_target=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(40102417827285020.4052)
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192008121139589728.4052)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Demandes d''espace de travail'
,p_list_item_link_target=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:RIR:::'
,p_parent_list_item_id=>wwv_flow_api.id(40102417827285020.4052)
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192008426680591330.4052)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Demandes de modification'
,p_list_item_link_target=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.:RIR:::'
,p_parent_list_item_id=>wwv_flow_api.id(40102417827285020.4052)
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168497310730577652.4052)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>unistr('G\00E9rer une instance')
,p_list_item_link_target=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.::::'
,p_list_item_icon_alt_attribute=>'Analyse descendante de gestion d''instance'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'9,16,17,18,19,42,46,47,48,51,57,58,61,62,63,64,65,66,67,70,75,85,97,100,103,109,112,120,121,125,130,131,132,133,555,104,126,127,128,129,139'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192009126119600562.4052)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>unistr('Configuration des fonctionnalit\00E9s')
,p_list_item_link_target=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.:16:::'
,p_parent_list_item_id=>wwv_flow_api.id(168497310730577652.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192009404086603691.4052)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>unistr('S\00E9curit\00E9')
,p_list_item_link_target=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:RP,130:::'
,p_parent_list_item_id=>wwv_flow_api.id(168497310730577652.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192021904535736262.4052)
,p_list_item_display_sequence=>91
,p_list_item_link_text=>unistr('...G\00E9rer la complexit\00E9 des mots de passe')
,p_list_item_link_target=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:130:::'
,p_parent_list_item_id=>wwv_flow_api.id(168497310730577652.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192009919323608095.4052)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>unistr('Param\00E8tres d''instance')
,p_list_item_link_target=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.:RP,131:::'
,p_parent_list_item_id=>wwv_flow_api.id(168497310730577652.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(505869000009873298.4052)
,p_list_item_display_sequence=>101
,p_list_item_link_text=>'Purge de l''espace de travail'
,p_list_item_link_target=>'f?p=&APP_ID.:133:&SESSION.::&DEBUG.:133:::'
,p_parent_list_item_id=>wwv_flow_api.id(168497310730577652.4052)
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192010225903610036.4052)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Message de connexion'
,p_list_item_link_target=>'f?p=&APP_ID.:41:&SESSION.::&DEBUG.:41:::'
,p_parent_list_item_id=>wwv_flow_api.id(168497310730577652.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192010501793612513.4052)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>unistr('Message du syst\00E8me')
,p_list_item_link_target=>'f?p=&APP_ID.:132:&SESSION.::&DEBUG.:132:::'
,p_parent_list_item_id=>wwv_flow_api.id(168497310730577652.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192010809065614604.4052)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'File d''attente des courriels'
,p_list_item_link_target=>'f?p=&APP_ID.:120:&SESSION.::&DEBUG.:120:::'
,p_parent_list_item_id=>wwv_flow_api.id(168497310730577652.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192011102270622092.4052)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>unistr('G\00E9rer les th\00E8mes publics')
,p_list_item_link_target=>'f?p=&APP_ID.:555:&SESSION.::&DEBUG.:555:::'
,p_parent_list_item_id=>wwv_flow_api.id(168497310730577652.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192011427682638942.4052)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>unistr('G\00E9rer les ressources propres au site')
,p_list_item_link_target=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.:RP,18,RIR:::'
,p_parent_list_item_id=>wwv_flow_api.id(168497310730577652.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192011731491640037.4052)
,p_list_item_display_sequence=>160
,p_list_item_link_text=>'Plus...'
,p_list_item_link_target=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(168497310730577652.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(40117612941330955.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('G\00E9rer les espaces de travail')
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::::'
,p_list_item_icon_alt_attribute=>'Analyse descendante de gestion des espaces de travail'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1,2,10,11,12,14,20,21,22,23,27,52,53,72,73,74,78,79,81,82,83,84,89,90,105,106,107,108,163,165,173,277,278,400,401,460,461,4001'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192012018809645759.4052)
,p_list_item_display_sequence=>170
,p_list_item_link_text=>unistr('Cr\00E9er un espace de travail')
,p_list_item_link_target=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:RP,27,79,72,73,74:::'
,p_parent_list_item_id=>wwv_flow_api.id(40117612941330955.4052)
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(384636912354118367.4052)
,p_list_item_display_sequence=>175
,p_list_item_link_text=>unistr('Cr\00E9er un espace de travail')
,p_list_item_link_target=>'f?p=&APP_ID.:142:&SESSION.::&DEBUG.:RP,142:LAST_VIEW:&APP_PAGE_ID.:'
,p_parent_list_item_id=>wwv_flow_api.id(40117612941330955.4052)
,p_required_patch=>-wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192012326774648053.4052)
,p_list_item_display_sequence=>180
,p_list_item_link_text=>'Enlever un espace de travail'
,p_list_item_link_target=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:81,82:::'
,p_parent_list_item_id=>wwv_flow_api.id(40117612941330955.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192012604395651102.4052)
,p_list_item_display_sequence=>190
,p_list_item_link_text=>'Verrouiller l''espace de travail'
,p_list_item_link_target=>'f?p=&APP_ID.:89:&SESSION.::&DEBUG.:89,90:::'
,p_parent_list_item_id=>wwv_flow_api.id(40117612941330955.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192012915477654263.4052)
,p_list_item_display_sequence=>200
,p_list_item_link_text=>unistr('G\00E9rer les affectations de sch\00E9mas')
,p_list_item_link_target=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:21:::'
,p_parent_list_item_id=>wwv_flow_api.id(40117612941330955.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192013221710656102.4052)
,p_list_item_display_sequence=>210
,p_list_item_link_text=>unistr('G\00E9rer les d\00E9veloppeurs et les utilisateurs')
,p_list_item_link_target=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:RP,RIR,12:::'
,p_parent_list_item_id=>wwv_flow_api.id(40117612941330955.4052)
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192013528290657957.4052)
,p_list_item_display_sequence=>220
,p_list_item_link_text=>unistr('Composant - Disponibilit\00E9')
,p_list_item_link_target=>'f?p=&APP_ID.:52:&SESSION.::&DEBUG.:52:::'
,p_parent_list_item_id=>wwv_flow_api.id(40117612941330955.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192013809374661985.4052)
,p_list_item_display_sequence=>230
,p_list_item_link_text=>'Importer'
,p_list_item_link_target=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:460:::'
,p_parent_list_item_id=>wwv_flow_api.id(40117612941330955.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192014115261663655.4052)
,p_list_item_display_sequence=>240
,p_list_item_link_text=>'Exporter'
,p_list_item_link_target=>'f?p=&APP_ID.:461:&SESSION.::&DEBUG.:461:::'
,p_parent_list_item_id=>wwv_flow_api.id(40117612941330955.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192037810881946241.4052)
,p_list_item_display_sequence=>245
,p_list_item_link_text=>'Rechercher un espace de travail'
,p_list_item_link_target=>'f?p=&APP_ID.:8000:&SESSION.::&DEBUG.:8000,RIR:::'
,p_parent_list_item_id=>wwv_flow_api.id(40117612941330955.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192014424612666345.4052)
,p_list_item_display_sequence=>250
,p_list_item_link_text=>'Plus...'
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(40117612941330955.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(40118231988336452.4052)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Surveiller l''activit\00E9')
,p_list_item_link_target=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.::::'
,p_list_item_icon_alt_attribute=>unistr('Analyse descendante de surveillance de l''activit\00E9')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'15,24,25,29,30,33,35,36,37,38,40,43,45,49,54,68,69,77,80,87,91,98,99,122,123,500,501,94,101'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192015123011675355.4052)
,p_list_item_display_sequence=>260
,p_list_item_link_text=>'Par vue de page'
,p_list_item_link_target=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.:30,RIR:::'
,p_parent_list_item_id=>wwv_flow_api.id(40118231988336452.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192022507006765338.4052)
,p_list_item_display_sequence=>280
,p_list_item_link_text=>'Par application et utilisateur'
,p_list_item_link_target=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.:49,RIR:::'
,p_parent_list_item_id=>wwv_flow_api.id(40118231988336452.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192023224668770519.4052)
,p_list_item_display_sequence=>290
,p_list_item_link_text=>'Par utilisateur'
,p_list_item_link_target=>'f?p=&APP_ID.:36:&SESSION.::&DEBUG.:RIR,36:::'
,p_parent_list_item_id=>wwv_flow_api.id(40118231988336452.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192023531594772458.4052)
,p_list_item_display_sequence=>300
,p_list_item_link_text=>'Par application'
,p_list_item_link_target=>'f?p=&APP_ID.:44:&SESSION.::&DEBUG.:44,RIR:::'
,p_parent_list_item_id=>wwv_flow_api.id(40118231988336452.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192023804367774121.4052)
,p_list_item_display_sequence=>310
,p_list_item_link_text=>'Par espace de travail'
,p_list_item_link_target=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.:33,RIR:::'
,p_parent_list_item_id=>wwv_flow_api.id(40118231988336452.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192024111293776033.4052)
,p_list_item_display_sequence=>320
,p_list_item_link_text=>'Par jour'
,p_list_item_link_target=>'f?p=&APP_ID.:54:&SESSION.::&DEBUG.:54,RIR:::'
,p_parent_list_item_id=>wwv_flow_api.id(40118231988336452.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(505871428238919208.4052)
,p_list_item_display_sequence=>321
,p_list_item_link_text=>'Purge de l''espace de travail'
,p_list_item_link_target=>'f?p=&APP_ID.:99:&SESSION.::&DEBUG.:RP,99:::'
,p_parent_list_item_id=>wwv_flow_api.id(40118231988336452.4052)
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192024420643778774.4052)
,p_list_item_display_sequence=>330
,p_list_item_link_text=>'Plus...'
,p_list_item_link_target=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(40118231988336452.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/workspace_import_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(44758222502979988.4052)
,p_name=>'workspace.import.progress'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(44758413648979994.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Indiquer un fichier'
,p_list_item_link_target=>'f?p=&APP_ID.:460:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(44758705753979997.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Confirmation d''import de fichier'
,p_list_item_link_target=>'f?p=&APP_ID.:163:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(44772030609546251.4052)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Installer'
,p_list_item_link_target=>'f?p=&APP_ID.:165:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/workspace_install_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(44806708563745373.4052)
,p_name=>'workspace.install.progress'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(44807506675745375.4052)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Choisir le sch\00E9ma')
,p_list_item_link_target=>'f?p=&APP_ID.:277:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(44807814227745375.4052)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Confirmation'
,p_list_item_link_target=>'f?p=&APP_ID.:278:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(44808114099745375.4052)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Installer'
,p_list_item_link_target=>'f?p=&APP_ID.:165:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_environment_settings
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(47534314618390800.4052)
,p_name=>'Manage Environment Settings'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47534823276393319.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Configuration des fonctionnalit\00E9s')
,p_list_item_link_target=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47535207130398100.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('S\00E9curit\00E9')
,p_list_item_link_target=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47556700138566373.4052)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Param\00E8tres d''instance')
,p_list_item_link_target=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(499030206357384810.4052)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Purge de l''espace de travail'
,p_list_item_link_target=>'f?p=&APP_ID.:133:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_disp_cond_type=>'NEVER'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(617444115874754241.4052)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>unistr('Param\00E8tres de purge d''espace de travail')
,p_list_item_link_target=>'f?p=&APP_ID.:133:&SESSION.::&DEBUG.:RP,133:::'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(25757200722107116.4052)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>unistr('Assistant G\00E9rer l''inscription au nouveau service')
,p_list_item_link_target=>'f?p=&APP_ID.:111:&SESSION.::&DEBUG.::P111_ID:1:'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_disp_cond_type=>'NEVER'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(182292075745555468.4052)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>unistr('D\00E9finir une banni\00E8re d''environnement')
,p_list_item_link_target=>'f?p=&APP_ID.:280:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_workspace_export_import
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(47558804136960608.4052)
,p_name=>'Manage Workspace Export Import'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47560509223960618.4052)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Importer un espace de travail'
,p_list_item_link_target=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47560826571960618.4052)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Exporter un espace de travail'
,p_list_item_link_target=>'f?p=&APP_ID.:461:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/login_attempts
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(49036204543378170.4052)
,p_name=>'Login Attempts'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(49037015450378171.4052)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Tentatives de connexion'
,p_list_item_link_target=>'f?p=&APP_ID.:24:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(49037309244378171.4052)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Derni\00E8re connexion de d\00E9veloppeur')
,p_list_item_link_target=>'f?p=&APP_ID.:35:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/export_install_navigate
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(79863815294295743.4052)
,p_name=>'export.install.navigate'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(166801801886544568.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Voir les fichiers d''export d''espace de travail import\00E9')
,p_list_item_link_target=>'f?p=&APP_ID.:173:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/workspace_app_temp_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(122623332344967000.4052)
,p_name=>'workspace_app_temp_progress'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/service_requests
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(130557109467559465.4052)
,p_name=>'Service Requests'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(132554913295711981.4052)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Nouvelles demandes de service'
,p_list_item_link_target=>'f?p=&APP_ID.:114:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(130557304381559466.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Enqu\00EAte \00E0 l''inscription')
,p_list_item_link_target=>'f?p=&APP_ID.:113:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_public_themes
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(137961006165346808.4052)
,p_name=>'Manage Public Themes'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(137961613784349078.4052)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Th\00E8mes publics')
,p_list_item_link_target=>'f?p=&APP_ID.:555:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'height="20" width="20" alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/workspace_theme_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(138045104803643281.4052)
,p_name=>'workspace theme progress'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(138155608448962419.4052)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Espace de travail'
,p_list_item_link_target=>'f?p=&APP_ID.:47:&SESSION.::&DEBUG.::::'
,p_list_item_current_for_pages=>'47'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(138156115720964594.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Application'
,p_list_item_link_target=>'f?p=&APP_ID.:57:&SESSION.::&DEBUG.::::'
,p_list_item_current_for_pages=>'57'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(138045412824643282.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Th\00E8me')
,p_list_item_link_target=>'f?p=&APP_ID.:58:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'58'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(138045720718643283.4052)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Nom'
,p_list_item_link_target=>'f?p=&APP_ID.:48:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'48'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(138046016071643283.4052)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Confirmer'
,p_list_item_link_target=>'f?p=&APP_ID.:51:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'51'
);
end;
/
prompt --application/shared_components/navigation/lists/monitor_activity_page_views
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(159973015345793688.4052)
,p_name=>'monitor.activity.page.views'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1218051315822598819.4052)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Tableau de bord'
,p_list_item_link_target=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47119805406156631.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Par vue'
,p_list_item_link_target=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(159976029543797841.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Par application et utilisateur'
,p_list_item_link_target=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(14732210619030758.4052)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Par utilisateur'
,p_list_item_link_target=>'f?p=&APP_ID.:36:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1813874215800004904.4052)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>'Vues de page par utilisateur et par jour'
,p_list_item_link_target=>'f?p=&APP_ID.:94:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(159984106949810197.4052)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Par application'
,p_list_item_link_target=>'f?p=&APP_ID.:44:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(159989500154817684.4052)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Par espace de travail'
,p_list_item_link_target=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(500564182435006003.4052)
,p_list_item_display_sequence=>51
,p_list_item_link_text=>unistr('Par recherche \00E0 facets d''un espace de travail')
,p_list_item_link_target=>'f?p=&APP_ID.:152:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47158410057668832.4052)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Par jour'
,p_list_item_link_target=>'f?p=&APP_ID.:54:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(253974113497584304.4052)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>unistr('Par acc\00E8s REST')
,p_list_item_link_target=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.:RP:IR_APPLICATION_INFO:REST access:'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_messages
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(168505619846788416.4052)
,p_name=>'Manage Messages'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168505927811790760.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('D\00E9finir le message de connexion')
,p_list_item_link_target=>'f?p=&APP_ID.:41:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168506130928791641.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('D\00E9finir le message du syst\00E8me')
,p_list_item_link_target=>'f?p=&APP_ID.:132:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168524005844973626.4052)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('G\00E9rer les ressources propres au site')
,p_list_item_link_target=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2600434502630589.4052)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('D\00E9finir une banni\00E8re d''environnement')
,p_list_item_link_target=>'f?p=&APP_ID.:280:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_service_requests
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(168703120343616153.4052)
,p_name=>'manage service requests'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168703604544621069.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Demandes ouvertes'
,p_list_item_link_target=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'5'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168704030863628594.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Toutes les demandes d''espace de travail'
,p_list_item_link_target=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'26'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168704311255632456.4052)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Toutes les demandes de modification'
,p_list_item_link_target=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'28'
);
end;
/
prompt --application/shared_components/navigation/lists/home_page_list
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(168902912946497370.4052)
,p_name=>'home page list'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168917021744935171.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('G\00E9rer les demandes')
,p_list_item_link_target=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-manage-requests'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168904404204513786.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('G\00E9rer une instance')
,p_list_item_link_target=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-manage-instance'
,p_list_item_icon_attributes=>'alt="" height="128" width="128"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168918009062940911.4052)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('G\00E9rer les espaces de travail')
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-manage-workspaces'
,p_list_item_icon_attributes=>'alt="" height="128" width="128"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168918216334942988.4052)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Surveiller l''activit\00E9')
,p_list_item_link_target=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-monitor-activity'
,p_list_item_icon_attributes=>'alt="" height="128" width="128"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/archived_activity_report
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(201292222959269624.4052)
,p_name=>'archived activity report'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(201292732309272286.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Activit\00E9 par jour')
,p_list_item_link_target=>'f?p=&APP_ID.:68:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(201293002658273224.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Activit\00E9 par application par jour')
,p_list_item_link_target=>'f?p=&APP_ID.:77:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(219090408531367773.4052)
,p_list_item_display_sequence=>22
,p_list_item_link_text=>'Hachage d''application par jour'
,p_list_item_link_target=>'f?p=&APP_ID.:141:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880162413033281115.4052)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>unistr('Activit\00E9 par application')
,p_list_item_link_target=>'f?p=&APP_ID.:50:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(201293307160274558.4052)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Activit\00E9 par espace de travail par jour')
,p_list_item_link_target=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(879916141112685248.4052)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>unistr('Activit\00E9 par espace de travail')
,p_list_item_link_target=>'f?p=&APP_ID.:32:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(491858502361188089.4052)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Graphique des \00E9v\00E9nements de page par jour')
,p_list_item_link_target=>'f?p=&APP_ID.:86:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(629291230431615041.4052)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Graphique des espaces de travail actifs par jour'
,p_list_item_link_target=>'f?p=&APP_ID.:93:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/self_service_sign_up
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(203028225668057376.4052)
,p_name=>'Self Service Sign Up'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(203028409925057378.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Assistant G\00E9rer l''inscription au nouveau service')
,p_list_item_link_target=>'f?p=&APP_ID.:111:&SESSION.::&DEBUG.::P111_ID:1:'
,p_list_item_icon=>'menu/pt_process_20.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_icon_alt_attribute=>'target="_blank"'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(203028703930057378.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Ex\00E9cuter l''assistant Inscription \00E0 un nouveau service')
,p_list_item_link_target=>'f?p=4700:2:0'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_icon_alt_attribute=>'target="_blank'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/create_multiple_workspaces
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(203141106443364145.4052)
,p_name=>'create multiple workspaces'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(203141300332364146.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Espaces de travail'
,p_list_item_link_target=>'f?p=&APP_ID.:115:&SESSION.:'
,p_list_item_current_for_pages=>'115'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(203141609069364146.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('V\00E9rifier et ajuster')
,p_list_item_link_target=>'f?p=&APP_ID.:116:&SESSION.:'
,p_list_item_current_for_pages=>'116'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(203141924809364146.4052)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Confirmer'
,p_list_item_link_target=>'f?p=&APP_ID.:117:&SESSION.:'
,p_list_item_current_for_pages=>'117'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(388185523452601754.4052)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Provisionnement termin\00E9')
,p_list_item_link_target=>'f?p=&APP_ID.:135:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/create_workspace_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(204654810731392335.4052)
,p_name=>'create workspace tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(204655032658392336.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Cr\00E9er plusieurs espaces de travail')
,p_list_item_link_target=>'f?p=&APP_ID.:115:&SESSION.::&DEBUG.:115,116,117:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/developer_activity_for_monitor_page
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(206097723808588940.4052)
,p_name=>'Developer.Activity for Monitor Page'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(206104006324621767.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Modifications d''application par d\00E9veloppeur')
,p_list_item_link_target=>'f?p=&APP_ID.:43:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(206104915674624470.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Modifications d''application par espace de travail'
,p_list_item_link_target=>'f?p=&APP_ID.:500:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(155239711934611887.4052)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Graphique d''utilisation de composants natifs'
,p_list_item_link_target=>'f?p=&APP_ID.:102:&SESSION.::&DEBUG.:RP,102:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(155378603841184844.4052)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Etat d''utilisation de composants natifs'
,p_list_item_link_target=>'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:RP,140:::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="" width="20" height="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(284069028112259316.4052)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('Travaux de chargement des donn\00E9es')
,p_list_item_link_target=>'f?p=&APP_ID.:144:&SESSION.::&DEBUG.:RP,144:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/manage_applications
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(244253103570784647.4052)
,p_name=>'Manage Applications'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(244660222438102395.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Attributs d''application'
,p_list_item_link_target=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(244256510842786771.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Statut de construction'
,p_list_item_link_target=>'f?p=&APP_ID.:400:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(244631813556033582.4052)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Sch\00E9mas d''analyse')
,p_list_item_link_target=>'f?p=&APP_ID.:401:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/workspace_tasks_002
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(254179102637013097.4052)
,p_name=>'workspace tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(254179620116013099.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Ajouter un sch\00E9ma')
,p_list_item_link_target=>'f?p=&APP_ID.:105:&SESSION.::&DEBUG.:105,106,107:P107_SGID,P107_COMPANY:&P78_PROVISIONING_COMPANY_ID.,&P78_SN.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(254179909753013099.4052)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Ajouter un utilisateur APEX'
,p_list_item_link_target=>'f?p=&APP_ID.:23:&SESSION.::&DEBUG.:23:F4050_P23_SECURITY_GROUP_ID:&P78_PROVISIONING_COMPANY_ID.:'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(254180228149013099.4052)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Visualiser le rapport d\00E9taill\00E9')
,p_list_item_link_target=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.:14:SGID:&P78_PROVISIONING_COMPANY_ID.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(44856918100412133.4052)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Exporter un espace de travail'
,p_list_item_link_target=>'f?p=&APP_ID.:461:&SESSION.:EXPORT:&DEBUG.::P461_WORKSPACE:&P78_SN.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(254179324916013098.4052)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Enlever un espace de travail'
,p_list_item_link_target=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:81,82,83:P81_COMPANY:&P78_SN.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/workspace_purge_reports
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(505826028978247783.4052)
,p_name=>'Workspace Purge Reports'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(505851803884704060.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Tableau de bord'
,p_list_item_link_target=>'f?p=&APP_ID.:99:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'99'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(505826223784247787.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Espaces de travail inactifs'
,p_list_item_link_target=>'f?p=&APP_ID.:87:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(505826523106247841.4052)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Espaces de travail purg\00E9s')
,p_list_item_link_target=>'f?p=&APP_ID.:91:&SESSION.::&DEBUG.::::'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(505826717378247841.4052)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Espaces de travail devenus actifs'
,p_list_item_link_target=>'f?p=&APP_ID.:92:&SESSION.::&DEBUG.::::'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(505827020036247842.4052)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Journal de purge d''espace de travail'
,p_list_item_link_target=>'f?p=&APP_ID.:98:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/monitor_activity_logs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(619447801744923075.4052)
,p_name=>'monitor.activity.logs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(619449225128923086.4052)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Journal des courriels'
,p_list_item_link_target=>'f?p=&APP_ID.:121:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(619989320793200782.4052)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>unistr('Journal des activit\00E9s de service Web')
,p_list_item_link_target=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1591898376570636.4052)
,p_list_item_display_sequence=>65
,p_list_item_link_text=>'Journal d''automatisation'
,p_list_item_link_target=>'f?p=&APP_ID.:181:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1393413220759055.4052)
,p_list_item_display_sequence=>65
,p_list_item_link_text=>'Journal de synchronisation REST'
,p_list_item_link_target=>'f?p=&APP_ID.:161:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(619449815929923087.4052)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Travaux'
,p_list_item_link_target=>'f?p=&APP_ID.:122:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(162310507366326382.4052)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Journal de suppression de fichier automatique'
,p_list_item_link_target=>'f?p=&APP_ID.:124:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(78215125733433815.4052)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Journal de sauvegarde'
,p_list_item_link_target=>'f?p=&APP_ID.:147:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'alt="#LABEL#" height="20" width="20"'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/security_second_level_tabs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(799821322334262935.4052)
,p_name=>'Security Second Level Tabs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(799821514224262975.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Param\00E8tres de s\00E9curit\00E9')
,p_list_item_link_target=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(799821821208262984.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('URL autoris\00E9es')
,p_list_item_link_target=>'f?p=&APP_ID.:95:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/activity_detail_reports
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(831980164720776427.4052)
,p_name=>'Activity Detail Reports'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(831980344863776428.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Activit\00E9 d''espace de travail')
,p_list_item_link_target=>'f?p=&APP_ID.:153:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(832233468708869758.4052)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>unistr('Ev\00E9nements de page')
,p_list_item_link_target=>'f?p=&APP_ID.:153:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(831980793531776430.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Activit\00E9 de l''application')
,p_list_item_link_target=>'f?p=&APP_ID.:155:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(831981122169776430.4052)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Activit\00E9 de d\00E9veloppeur')
,p_list_item_link_target=>'f?p=&APP_ID.:156:&SESSION.::&DEBUG.:RP,156:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(831981576548776430.4052)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Activit\00E9 d''ex\00E9cution')
,p_list_item_link_target=>'f?p=&APP_ID.:157:&SESSION.::&DEBUG.:RP,157:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/activity_summary
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(880586104026852286.4052)
,p_name=>'Activity Summary'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880586395598852287.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Principales applications'
,p_list_item_link_target=>'f?p=&APP_ID.:71:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-top-apps'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880586795096852288.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Principaux espaces de travail'
,p_list_item_link_target=>'f?p=&APP_ID.:137:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-top-workspaces'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(880587111792852289.4052)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('R\00E9capitulatif de l''activit\00E9')
,p_list_item_link_target=>'f?p=&APP_ID.:138:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-activity-summary'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_help
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(2105958267784095383.4052)
,p_name=>'APEX 5 - Help'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2105958451628095386.4052)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Documentation'
,p_list_item_link_target=>'&SYSTEM_HELP_URL.'
,p_list_text_01=>'helpLinkNewWindow'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2105958820660095393.4052)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Forum de discussion'
,p_list_item_link_target=>'https://apex.oracle.com/forum'
,p_list_text_01=>'helpLinkForum'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2185440443171474333.4052)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'En savoir plus sur Oracle APEX'
,p_list_item_link_target=>'https://apex.oracle.com'
,p_list_text_01=>'helpLinkOTN'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(845762696461912.4052)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1710403837403748.4052)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(14858702119941037.4052)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(91988217245572387.4052)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(99844533606888906.4052)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176128658842506818.4052)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(592235878180709447.4052)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1765072144481712054.4052)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831779972543994153.4052)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1917680565173940128.4052)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_authentication
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(3699181830199.4052)
,p_name=>'APEX authentication'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_authentication_dev.get_internal_authentication = ''APEX'';'
,p_error_message=>unistr('Authentification APEX non activ\00E9e')
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/user_is_internal
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(1018002984071621.4052)
,p_name=>'user_is_internal'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_security.user_is_internal;'
,p_error_message=>unistr('impossible de d\00E9terminer si l''utilisateur est un utilisateur interne.')
,p_reference_id=>786938711256163276.4052
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/sso_authentication
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(9398622791321084.4052)
,p_name=>'SSO authentication'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_authentication_dev.get_internal_authentication not in (''APEX'',''CLOUD_IDM'',''LDAP'',''DB'');'
,p_error_message=>unistr('Le SSO du g\00E9n\00E9rateur n''est pas activ\00E9')
,p_reference_id=>6738410669854771.4052
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_admin
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(12523219193527909.4052)
,p_name=>'Flow: ADMIN'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'ADMIN'
,p_error_message=>unistr('Vous n''\00EAtes pas autoris\00E9 \00E0 administrer les applications')
,p_reference_id=>12511219858301010.4052
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/is_real_application_security_supported
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(125787708037171062.4052)
,p_name=>'Is Real Application Security supported'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return not wwv_flow_db_version.c_ver_le_12_1_0_1;'
,p_error_message=>unistr('Real Application Security est uniquement pris en charge avec la version 12.1.0.2 ou ult\00E9rieure')
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/is_dev
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(141670018067969246.4052)
,p_name=>'is_dev'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return not wwv_flow_isc.deployment_environment;'
,p_error_message=>unistr('n''est pas une instance de d\00E9veloppement')
,p_reference_id=>786949644903267343.4052
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/dashboard_access
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(517385971569230930.4052)
,p_name=>'Dashboard access'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return',
'    wwv_flow_authorization.is_authorized_developer(',
'        p_developer_authorization => ''ADMIN''',
'    )',
'    or wwv_flow_authorization.is_authorized_developer(',
'        p_developer_authorization => ''EDIT''',
'    );'))
,p_error_message=>unistr('Vous n''\00EAtes pas autoris\00E9 \00E0 acc\00E9der aux tableaux de bord ni \00E0 la surveillance de l''activit\00E9.')
,p_reference_id=>786936829326142579.4052
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/websheet_create_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(610289739776900562.4052)
,p_name=>'Websheet Create Enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce( wwv_flow_platform.get_preference(''WEBSHEET_CREATE_ENABLED''), ''N'' ) = ''Y'' then',
'    return TRUE;',
'else',
'    return FALSE;',
'end if;'))
,p_error_message=>unistr('Pour acc\00E9der \00E0 cette page, l''application Web doit \00EAtre activ\00E9e.')
,p_reference_id=>771322804043281981.4052
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/display_usage_info_questions
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(825639761147256575.4052)
,p_name=>'Display Usage Info Questions'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce( wwv_flow_platform.get_preference(''WS_REQUEST_USAGE_Q''), ''N'' ) = ''Y'' then',
'    return true;',
'else',
'    return false;',
'end if;'))
,p_error_message=>unistr('L''affichage des questions sur les informations d''utilisation est d\00E9sactiv\00E9.')
,p_reference_id=>825639089215245042.4052
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_restful
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(1137280212017725373.4052)
,p_name=>'Flow: RESTFUL'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'RESTFUL'
,p_error_message=>unistr('Vous n''\00EAtes pas autoris\00E9 \00E0 effectuer cette op\00E9ration')
,p_reference_id=>786519856057734816.4052
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(652214800522885.4052)
,p_icon_sequence=>10
,p_icon_image=>'htmldb/icons/navbarhelp_25x25.gif'
,p_icon_subtext=>'Aide'
,p_icon_target=>'&SYSTEM_HELP_URL.'
,p_icon_image_alt=>'Aide'
,p_icon_height=>25
,p_icon_width=>25
,p_nav_entry_is_feedback_yn=>'N'
,p_icon_bar_disp_cond_type=>'NEVER'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
,p_icon_bar_comment=>'Display same page with print view page template'
);
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(1365423778229905.4052)
,p_icon_sequence=>20
,p_icon_subtext=>'Bienvenue &APP_USER.'
,p_icon_target=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.::::'
,p_icon_image_alt=>'Bienvenue &APP_USER.'
,p_nav_entry_is_feedback_yn=>'N'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(333595616893904221.4052)
,p_icon_sequence=>30
,p_icon_image=>'htmldb/icons/navbarlogout_25x25.gif'
,p_icon_subtext=>'( <span style="text-decoration:underline;">Changer d''espace de travail</span> )'
,p_icon_target=>'f?p=4550:20'
,p_icon_image_alt=>'alt=""'
,p_nav_entry_is_feedback_yn=>'N'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
,p_security_scheme=>wwv_flow_api.id(9398622791321084)
);
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(24559226221.4052)
,p_icon_sequence=>40
,p_icon_image=>'htmldb/icons/navbarlogout_25x25.gif'
,p_icon_image2=>'wwv_logout24.gif'
,p_icon_subtext=>unistr('( <span style="text-decoration:underline;">D\00E9connexion</span> )')
,p_icon_target=>'&LOGOUT_URL.'
,p_icon_image_alt=>unistr('D\00E9connexion')
,p_icon_height=>25
,p_icon_width=>25
,p_icon_height2=>24
,p_icon_width2=>24
,p_nav_entry_is_feedback_yn=>'N'
,p_icon_bar_disp_cond_type=>'CURRENT_LOOK_IS_1'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
,p_icon_bar_comment=>'Navigate to Flow Attribute LOGOUT_URL when pressed.'
);
end;
/
prompt --application/shared_components/logic/application_items/company
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(24661497730.4052)
,p_name=>'COMPANY'
,p_scope=>'GLOBAL'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_item_comment=>'company logged into flow'
);
end;
/
prompt --application/shared_components/logic/application_items/f4050_password_region_title
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(341498316040067852.4052)
,p_name=>'F4050_PASSWORD_REGION_TITLE'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/fsp_after_login_url
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(69693210447779230.4052)
,p_name=>'FSP_AFTER_LOGIN_URL'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Used by Custom2 authentication for deep linking support'
);
end;
/
prompt --application/shared_components/logic/application_items/is_dev
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(144247012389386369.4052)
,p_name=>'IS_DEV'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/last_view
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(48673315869342015.4052)
,p_name=>'LAST_VIEW'
,p_data_type=>'NUMBER'
,p_escape_on_http_output=>'N'
,p_item_comment=>'used for help'
);
end;
/
prompt --application/shared_components/logic/application_computations/company
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(24663499759.4052)
,p_computation_sequence=>10
,p_computation_item=>'COMPANY'
,p_computation_point=>'AFTER_LOGIN'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'wwv_flow.get_company_name;'
,p_compute_when=>'COMPANY'
,p_compute_when_type=>'ITEM_IS_NULL'
,p_computation_error_message=>'Impossible d''obtenir le nom de l''espace de travail.'
);
end;
/
prompt --application/shared_components/logic/application_computations/f4050_password_region_title
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(341513728853071507.4052)
,p_computation_sequence=>10
,p_computation_item=>'F4050_PASSWORD_REGION_TITLE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'wwv_flow_lang.system_message(''APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.''||replace(wwv_flow_authentication_dev.get_internal_authentication,''DB'',''LDAP'')||''-AUTH'')'
,p_compute_when=>'F4050_PASSWORD_REGION_TITLE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
end;
/
prompt --application/shared_components/logic/application_computations/is_dev
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(144247705463419984.4052)
,p_computation_sequence=>10
,p_computation_item=>'IS_DEV'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_authorization_api.is_authorized(''is_dev'') then ',
'  return ''Y'';',
'else',
'  return ''N'';',
'end if;'))
);
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/shared_components/user_interface/lovs/accessibility_mode
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1141279207071321310.4052)
,p_lov_name=>'ACCESSIBILITY_MODE'
,p_lov_query=>'.'||wwv_flow_api.id(1141279207071321310.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1141279512218321311.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Lecteur d''\00E9cran')
,p_lov_return_value=>'SCREEN_READER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/account_lock_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(12506800188785204.4052)
,p_lov_name=>'ACCOUNT_LOCK_STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(12506800188785204.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(12507123798785207.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Verrouill\00E9')
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(12507312044785207.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('D\00E9verrouill\00E9')
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/activity_log_request_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1582102292640264559.4052)
,p_lov_name=>'ACTIVITY_LOG.REQUEST_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(1582102292640264559.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1582102573870264598.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Autre'
,p_lov_return_value=>'0'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1582102817593264600.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Traitement'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1582103136401264600.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Affichage'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1582103436851264600.4052)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'AJAX'
,p_lov_return_value=>'3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1582103735724264600.4052)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>unistr('D\00E9connexion')
,p_lov_return_value=>'4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1582104088572264603.4052)
,p_lov_disp_sequence=>24
,p_lov_disp_value=>'Callback d''authentification'
,p_lov_return_value=>'5'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(139570103313563167.4052)
,p_lov_name=>'APP STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(139570103313563167.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(139570418445563171.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Disponible'
,p_lov_return_value=>'AVAILABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(139570712580563173.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Bient\00F4t disponible')
,p_lov_return_value=>'COMING_SOON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(139571006146563174.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Masqu\00E9')
,p_lov_return_value=>'HIDDEN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_activity_logging
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(15203330831314824.4052)
,p_lov_name=>'APPLICATION ACTIVITY LOGGING'
,p_lov_query=>'.'||wwv_flow_api.id(15203330831314824.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15204014153314828.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Utiliser les param\00E8tres d''application (par d\00E9faut)')
,p_lov_return_value=>'U'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15203630055314827.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Toujours'
,p_lov_return_value=>'A'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15203809369314828.4052)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Jamais'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1820304753496015763.4052)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Initialement d\00E9sactiv\00E9 pour les nouvelles applications')
,p_lov_return_value=>'O'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_logo_image_or_text
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(361753932557528086.4052)
,p_lov_name=>'APPLICATION LOGO IMAGE OR TEXT'
,p_reference_id=>210991102136588089.4052
,p_lov_query=>'.'||wwv_flow_api.id(361753932557528086.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(361754906572528090.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Image'
,p_lov_return_value=>'IMAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(361755120114528090.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Texte'
,p_lov_return_value=>'TEXT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_themes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(138044801783643280.4052)
,p_lov_name=>'APPLICATION THEMES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'from   wwv_flow_themes',
'where  flow_id = :fb_flow_id',
'order by theme_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(367884303048549801.4052)
,p_lov_name=>'APPLICATION TYPE'
,p_reference_id=>183877501727908015.4052
,p_lov_query=>'.'||wwv_flow_api.id(367884303048549801.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(367885627944549803.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Afficher tout'
,p_lov_return_value=>'0'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(367885804716549803.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Feuille Web'
,p_lov_return_value=>'WEBSHEET'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(367886019467549803.4052)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Base de donn\00E9es')
,p_lov_return_value=>'CUSTOM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_type_database_or_websheet
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(844667400578458000.4052)
,p_lov_name=>'APPLICATION_TYPE_DATABASE_OR_WEBSHEET'
,p_reference_id=>461305204810840905.4052
,p_lov_query=>'.'||wwv_flow_api.id(844667400578458000.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(844668432691458020.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Base de donn\00E9es')
,p_lov_return_value=>'Database'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(844668627244458020.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Feuille Web'
,p_lov_return_value=>'Websheet'
);
end;
/
prompt --application/shared_components/user_interface/lovs/audit_naming
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(192906504723933391.4052)
,p_lov_name=>'AUDIT_NAMING'
,p_lov_query=>'.'||wwv_flow_api.id(192906504723933391.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192906720941933395.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Attributs d''application'
,p_lov_return_value=>'WWV_FLOWS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192906908350933397.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Mod\00E8le de page')
,p_lov_return_value=>'WWV_FLOW_TEMPLATES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192907100225933398.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Barre de navigation'
,p_lov_return_value=>'WWV_FLOW_ICON_BAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192907329971933398.4052)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Processus d''application'
,p_lov_return_value=>'WWV_FLOW_PROCESSING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192907525100933398.4052)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('El\00E9ment d''application')
,p_lov_return_value=>'WWV_FLOW_ITEMS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192907723181933398.4052)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Calcul d''application'
,p_lov_return_value=>'WWV_FLOW_COMPUTATIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192907918785933401.4052)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Onglets'
,p_lov_return_value=>'WWV_FLOW_TABS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192908101742933401.4052)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Onglet parent'
,p_lov_return_value=>'WWV_FLOW_TOPLEVEL_TABS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192908312729933401.4052)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Liste de valeurs (LOV)'
,p_lov_return_value=>'WWV_FLOW_LISTS_OF_VALUES$'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192908508490933401.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Valeurs de liste de valeurs (LOV) statique'
,p_lov_return_value=>'WWV_FLOW_LISTS_OF_VALUES_DATA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192908720172933401.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Entr\00E9e de chemin de navigation')
,p_lov_return_value=>'WWV_FLOW_MENU_OPTIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192917410258942992.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Th\00E8mes')
,p_lov_return_value=>'WWV_FLOW_THEMES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192908929274933402.4052)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Attributs de page'
,p_lov_return_value=>'WWV_FLOW_STEPS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192909112437933402.4052)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Bouton de page'
,p_lov_return_value=>'WWV_FLOW_STEP_BUTTONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192909326218933402.4052)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Branchement de page'
,p_lov_return_value=>'WWV_FLOW_STEP_BRANCHES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192909515542933402.4052)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Arguments de branchement de page'
,p_lov_return_value=>'WWV_FLOW_STEP_BRANCH_ARGS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192909710968933403.4052)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>unistr('El\00E9ment de page')
,p_lov_return_value=>'WWV_FLOW_STEP_ITEMS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192909909431933403.4052)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'Calcul de page'
,p_lov_return_value=>'WWV_FLOW_STEP_COMPUTATIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192910102627933403.4052)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'Validation de page'
,p_lov_return_value=>'WWV_FLOW_STEP_VALIDATIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192910304404933403.4052)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'Processus de page'
,p_lov_return_value=>'WWV_FLOW_STEP_PROCESSING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192910501092933404.4052)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>unistr('Mod\00E8le de r\00E9gion')
,p_lov_return_value=>'WWV_FLOW_PAGE_PLUG_TEMPLATES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192910701238933404.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Mod\00E8le de ligne')
,p_lov_return_value=>'WWV_FLOW_ROW_TEMPLATES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192910921309933404.4052)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>unistr('Mod\00E8le de liste')
,p_lov_return_value=>'WWV_FLOW_LIST_TEMPLATES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192911107468933404.4052)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>unistr('Attributs de r\00E9gion')
,p_lov_return_value=>'WWV_FLOW_PAGE_PLUGS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192911327453933408.4052)
,p_lov_disp_sequence=>23
,p_lov_disp_value=>'Messages'
,p_lov_return_value=>'WWV_FLOW_MESSAGES$'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192911518683933408.4052)
,p_lov_disp_sequence=>24
,p_lov_disp_value=>'Options de construction'
,p_lov_return_value=>'WWV_FLOW_PATCHES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192911719543933408.4052)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>unistr('D\00E9veloppeurs d''application (administration)')
,p_lov_return_value=>'WWV_FLOW_DEVELOPERS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192911931458933408.4052)
,p_lov_disp_sequence=>26
,p_lov_disp_value=>'Listes'
,p_lov_return_value=>'WWV_FLOW_LISTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192912106135933409.4052)
,p_lov_disp_sequence=>27
,p_lov_disp_value=>unistr('El\00E9ment de liste')
,p_lov_return_value=>'WWV_FLOW_LIST_ITEMS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192912316871933409.4052)
,p_lov_disp_sequence=>28
,p_lov_disp_value=>unistr('ID utilisateur r\00E9el (administration)')
,p_lov_return_value=>'WWV_FLOW_EFFECTIVE_USERID_MAP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192912501053933409.4052)
,p_lov_disp_sequence=>29
,p_lov_disp_value=>'Raccourcis'
,p_lov_return_value=>'WWV_FLOW_SHORTCUTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192912709920933409.4052)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Texte d''aide sur \00E9l\00E9ment de page')
,p_lov_return_value=>'WWV_FLOW_STEP_ITEM_HELP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192912922654933410.4052)
,p_lov_disp_sequence=>31
,p_lov_disp_value=>unistr('Mod\00E8les d''authentification')
,p_lov_return_value=>'WWV_FLOW_AUTHENTICATIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192913116096933410.4052)
,p_lov_disp_sequence=>32
,p_lov_disp_value=>unistr('Points d''entr\00E9e')
,p_lov_return_value=>'WWV_FLOW_ENTRY_POINTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192913326886933410.4052)
,p_lov_disp_sequence=>33
,p_lov_disp_value=>unistr('Arguments de point d''entr\00E9e')
,p_lov_return_value=>'WWV_FLOW_ENTRY_POINT_ARGS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/automation_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1581480830428587.4052)
,p_lov_name=>'AUTOMATION_STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(1581480830428587.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1581704766428589.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('En cours d''ex\00E9cution')
,p_lov_return_value=>'RUNNING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1582169050428591.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Succ\00E8s')
,p_lov_return_value=>'SUCCESS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1582581957428591.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Aucune action'
,p_lov_return_value=>'NO_ACTION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1582955319428591.4052)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Incomplet'
,p_lov_return_value=>'INCOMPLETE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1583342009428592.4052)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Echec'
,p_lov_return_value=>'FAILURE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1583720083428592.4052)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Abandonn\00E9')
,p_lov_return_value=>'ABORTED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1584187107428592.4052)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('Travail d\00E9j\00E0 en cours d''ex\00E9cution')
,p_lov_return_value=>'JOB_ALREADY_RUNNING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/auto_file_delete_file_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(164450631905355420.4052)
,p_lov_name=>'AUTO_FILE_DELETE_FILE_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(164450631905355420.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(164450903335355422.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Export d''application'
,p_lov_return_value=>'FLOW_EXPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(164451116825355423.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Export d''espace de travail'
,p_lov_return_value=>'COMPANY_EXPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(164451305638355423.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Export de page'
,p_lov_return_value=>'PAGE_EXPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(164451531888355423.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Export de feuille Web'
,p_lov_return_value=>'WEBSHEET_EXPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(164451704038355423.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Import de donn\00E9es XML')
,p_lov_return_value=>'XML_DATA_IMPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(164451927196355423.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Import de donn\00E9es')
,p_lov_return_value=>'DATA_IMPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(172380721498781950.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Module d''extension'
,p_lov_return_value=>'PLUGIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(172384726000783329.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Export de feuille de style CSS'
,p_lov_return_value=>'CSS_EXPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(172388731887784963.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Export d''images'
,p_lov_return_value=>'IMAGE_EXPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(172392705352786807.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Export de fichiers statiques'
,p_lov_return_value=>'FILE_EXPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(172396718166790478.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Scripts'
,p_lov_return_value=>'SCRIPT_FILE_EXPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(172400721975791606.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Th\00E8mes')
,p_lov_return_value=>'THEME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(172404727169793117.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Valeurs par d\00E9faut d''interface utilisateur')
,p_lov_return_value=>'UI_DEFAULTS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/bipublisher_support
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(66524307689014582.4052)
,p_lov_name=>'BIPUBLISHER_SUPPORT'
,p_lov_query=>'.'||wwv_flow_api.id(66524307689014582.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(309001880327416982.4052)
,p_lov_disp_sequence=>0
,p_lov_disp_value=>'Aucun'
,p_lov_return_value=>'NONE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8023414242765634.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Oracle REST Data Services (plus pris en charge)'
,p_lov_return_value=>'APEX_LISTENER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(66524606927014584.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Externe (Apache FOP)'
,p_lov_return_value=>'STANDARD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(66524808931014584.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Oracle BI Publisher'
,p_lov_return_value=>'ADVANCED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(665784884034387187.4052)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'APEX Office Print'
,p_lov_return_value=>'AOP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/build_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(244320808989852457.4052)
,p_lov_name=>'BUILD_STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(244320808989852457.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244321119544852463.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Ex\00E9cuter l''application uniquement')
,p_lov_return_value=>'RUN_ONLY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244321323574852464.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Ex\00E9cuter et construire l''application')
,p_lov_return_value=>'RUN_AND_BUILD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3932329947881245316.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Ex\00E9cut\00E9 et masqu\00E9')
,p_lov_return_value=>'RUN_AND_HIDDEN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/checkbox_y_noprompt
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(363978124517039324.4052)
,p_lov_name=>'CHECKBOX_Y_NOPROMPT'
,p_reference_id=>84715102189754797.4052
,p_lov_query=>'.'||wwv_flow_api.id(363978124517039324.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(363978829122039326.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'&nbsp;'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/clone_sessions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(924631310481901445.4052)
,p_lov_name=>'CLONE_SESSIONS'
,p_lov_query=>'.'||wwv_flow_api.id(924631310481901445.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(924631660343901447.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('D\00E9sactiv\00E9')
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(924632065917901449.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Activ\00E9')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/confirm_delete_denied_request
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87822015190102927.4052)
,p_lov_name=>'CONFIRM.DELETE.DENIED.REQUEST'
,p_lov_query=>'.'||wwv_flow_api.id(87822015190102927.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87822220071102927.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Supprimer cette demande en cas de refus ?'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/confirm_pwd_removal
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(35215801480283409.4052)
,p_lov_name=>'CONFIRM.PWD.REMOVAL'
,p_lov_query=>'.'||wwv_flow_api.id(35215801480283409.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(35216131980283418.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cocher pour confirmer que vous souhaitez modifier le mot de passe de portefeuille'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/confirm_removal
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87818332243088870.4052)
,p_lov_name=>'CONFIRM.REMOVAL'
,p_lov_query=>'.'||wwv_flow_api.id(87818332243088870.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87818517495088870.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Cochez pour confirmer la suppression.'
,p_lov_return_value=>'Yes'
);
end;
/
prompt --application/shared_components/user_interface/lovs/confirm_remove_request
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87819107787091340.4052)
,p_lov_name=>'CONFIRM.REMOVE.REQUEST'
,p_lov_query=>'.'||wwv_flow_api.id(87819107787091340.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87819312320091340.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Cochez si vous souhaitez \00E9galement enlever la demande pour cet espace de travail.')
,p_lov_return_value=>'Yes'
);
end;
/
prompt --application/shared_components/user_interface/lovs/confirm_smtp_pwd_removal
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(391596105997880413.4052)
,p_lov_name=>'CONFIRM.SMTP.PWD.REMOVAL'
,p_lov_query=>'.'||wwv_flow_api.id(391596105997880413.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(391596477310880416.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Cocher pour confirmer que vous voulez modifier le mot de passe associ\00E9 au nom utilisateur d''authentification SMTP')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/confirm_workspace_install
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(73876902692924600.4052)
,p_lov_name=>'CONFIRM.WORKSPACE_INSTALL'
,p_lov_query=>'.'||wwv_flow_api.id(73876902692924600.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(73877205249924603.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Cochez pour continuer l''installation de l''espace de travail qui aura totalement acc\00E8s au sch\00E9ma principal et aux sch\00E9mas suppl\00E9mentaires indiqu\00E9s.')
,p_lov_return_value=>'Yes'
);
end;
/
prompt --application/shared_components/user_interface/lovs/countries
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(825654386458276754.4052)
,p_lov_name=>'COUNTRIES'
,p_reference_id=>823478261872577596.4052
,p_lov_query=>'.'||wwv_flow_api.id(825654386458276754.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825828986618276883.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Afghanistan'
,p_lov_return_value=>'AFG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825829327821276883.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Albanie'
,p_lov_return_value=>'ALB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825829771504276883.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Alg\00E9rie')
,p_lov_return_value=>'DZA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825830143577276883.4052)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Samoa am\00E9ricaines')
,p_lov_return_value=>'ASM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825830589742276883.4052)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Andorre'
,p_lov_return_value=>'AND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825830942025276883.4052)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Angola'
,p_lov_return_value=>'AGO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825831327018276884.4052)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Anguilla'
,p_lov_return_value=>'AIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825831783243276884.4052)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Antarctique'
,p_lov_return_value=>'ATA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825832171105276884.4052)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Antigua-et-Barbuda'
,p_lov_return_value=>'ATG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825832592077276884.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Argentine'
,p_lov_return_value=>'ARG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825832902048276884.4052)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>unistr('Arm\00E9nie')
,p_lov_return_value=>'ARM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825833377631276885.4052)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Aruba'
,p_lov_return_value=>'ABW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825833706795276885.4052)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Australie'
,p_lov_return_value=>'AUS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825834127317276885.4052)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Autriche'
,p_lov_return_value=>'AUT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825834533647276885.4052)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>unistr('Azerba\00EFdjan')
,p_lov_return_value=>'AZE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825834961281276885.4052)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'Bahamas'
,p_lov_return_value=>'BHS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825835377279276886.4052)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>unistr('Bahre\00EFn')
,p_lov_return_value=>'BHR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825835787578276886.4052)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'Bangladesh'
,p_lov_return_value=>'BGD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825836191800276886.4052)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>'Barbade'
,p_lov_return_value=>'BRB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825836587620276886.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('B\00E9larus')
,p_lov_return_value=>'BLR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825836985180276886.4052)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'Belgique'
,p_lov_return_value=>'BEL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825837306454276886.4052)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>'Belize'
,p_lov_return_value=>'BLZ'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825837729129276887.4052)
,p_lov_disp_sequence=>23
,p_lov_disp_value=>unistr('B\00E9nin')
,p_lov_return_value=>'BEN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825838125317276887.4052)
,p_lov_disp_sequence=>24
,p_lov_disp_value=>'Bermudes'
,p_lov_return_value=>'BMU'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825838582461276887.4052)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>'Bhoutan'
,p_lov_return_value=>'BTN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825838990241276887.4052)
,p_lov_disp_sequence=>26
,p_lov_disp_value=>'Bolivie (Etat plurinational de)'
,p_lov_return_value=>'BOL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825839319978276887.4052)
,p_lov_disp_sequence=>27
,p_lov_disp_value=>'Bonaire, Saint-Eustache et Saba'
,p_lov_return_value=>'BES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825839734289276888.4052)
,p_lov_disp_sequence=>28
,p_lov_disp_value=>unistr('Bosnie-Herz\00E9govine')
,p_lov_return_value=>'BIH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825840195543276888.4052)
,p_lov_disp_sequence=>29
,p_lov_disp_value=>'Botswana'
,p_lov_return_value=>'BWA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825840512692276888.4052)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Ile Bouvet'
,p_lov_return_value=>'BVT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825840953474276888.4052)
,p_lov_disp_sequence=>31
,p_lov_disp_value=>unistr('Br\00E9sil')
,p_lov_return_value=>'BRA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825841315787276888.4052)
,p_lov_disp_sequence=>32
,p_lov_disp_value=>unistr('Territoire britannique de l''oc\00E9an Indien')
,p_lov_return_value=>'IOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825841782513276889.4052)
,p_lov_disp_sequence=>33
,p_lov_disp_value=>unistr('Brun\00E9i Darussalam')
,p_lov_return_value=>'BRN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825842190941276889.4052)
,p_lov_disp_sequence=>34
,p_lov_disp_value=>'Bulgarie'
,p_lov_return_value=>'BGR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825842556704276889.4052)
,p_lov_disp_sequence=>35
,p_lov_disp_value=>'Burkina Faso'
,p_lov_return_value=>'BFA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825842976244276889.4052)
,p_lov_disp_sequence=>36
,p_lov_disp_value=>'Burundi'
,p_lov_return_value=>'BDI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825843367058276889.4052)
,p_lov_disp_sequence=>37
,p_lov_disp_value=>'Cap-Vert'
,p_lov_return_value=>'CPV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825843796250276889.4052)
,p_lov_disp_sequence=>38
,p_lov_disp_value=>'Cambodge'
,p_lov_return_value=>'KHM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825844132289276890.4052)
,p_lov_disp_sequence=>39
,p_lov_disp_value=>'Cameroun'
,p_lov_return_value=>'CMR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825844566311276891.4052)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Canada'
,p_lov_return_value=>'CAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825844918384276891.4052)
,p_lov_disp_sequence=>41
,p_lov_disp_value=>unistr('Iles Ca\00EFmans')
,p_lov_return_value=>'CYM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825845383573276891.4052)
,p_lov_disp_sequence=>42
,p_lov_disp_value=>unistr('R\00E9publique centrafricaine')
,p_lov_return_value=>'CAF'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825845751840276891.4052)
,p_lov_disp_sequence=>43
,p_lov_disp_value=>'Tchad'
,p_lov_return_value=>'TCD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825846166268276891.4052)
,p_lov_disp_sequence=>44
,p_lov_disp_value=>'Chili'
,p_lov_return_value=>'CHL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825846577200276891.4052)
,p_lov_disp_sequence=>45
,p_lov_disp_value=>'Chine'
,p_lov_return_value=>'CHN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825846995553276892.4052)
,p_lov_disp_sequence=>46
,p_lov_disp_value=>'Ile Christmas'
,p_lov_return_value=>'CXR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825847352853276892.4052)
,p_lov_disp_sequence=>47
,p_lov_disp_value=>'Iles Cocos (Keeling)'
,p_lov_return_value=>'CCK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825847727858276892.4052)
,p_lov_disp_sequence=>48
,p_lov_disp_value=>'Colombie'
,p_lov_return_value=>'COL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825848132050276892.4052)
,p_lov_disp_sequence=>49
,p_lov_disp_value=>'Comores'
,p_lov_return_value=>'COM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825848551594276892.4052)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Congo'
,p_lov_return_value=>'COG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825848938265276893.4052)
,p_lov_disp_sequence=>51
,p_lov_disp_value=>unistr('Congo, R\00E9publique d\00E9mocratique')
,p_lov_return_value=>'COD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825849350304276893.4052)
,p_lov_disp_sequence=>52
,p_lov_disp_value=>'Iles Cook'
,p_lov_return_value=>'COK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825849724333276893.4052)
,p_lov_disp_sequence=>53
,p_lov_disp_value=>'Costa Rica'
,p_lov_return_value=>'CRI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825850188413276893.4052)
,p_lov_disp_sequence=>54
,p_lov_disp_value=>'Croatie'
,p_lov_return_value=>'HRV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825850540688276893.4052)
,p_lov_disp_sequence=>55
,p_lov_disp_value=>'Cuba'
,p_lov_return_value=>'CUB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825850932138276894.4052)
,p_lov_disp_sequence=>56
,p_lov_disp_value=>unistr('Cura\00E7ao')
,p_lov_return_value=>'CUW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825851308142276894.4052)
,p_lov_disp_sequence=>57
,p_lov_disp_value=>'Chypre'
,p_lov_return_value=>'CYP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825851761180276894.4052)
,p_lov_disp_sequence=>58
,p_lov_disp_value=>unistr('R\00E9publique tch\00E8que')
,p_lov_return_value=>'CZE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825852155300276894.4052)
,p_lov_disp_sequence=>59
,p_lov_disp_value=>unistr('C\00F4te d''Ivoire')
,p_lov_return_value=>'CIV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825852558437276894.4052)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Danemark'
,p_lov_return_value=>'DNK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825852946066276895.4052)
,p_lov_disp_sequence=>61
,p_lov_disp_value=>'Djibouti'
,p_lov_return_value=>'DJI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825853362054276895.4052)
,p_lov_disp_sequence=>62
,p_lov_disp_value=>'Dominique'
,p_lov_return_value=>'DMA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825853757610276895.4052)
,p_lov_disp_sequence=>63
,p_lov_disp_value=>unistr('R\00E9publique dominicaine')
,p_lov_return_value=>'DOM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825854193798276895.4052)
,p_lov_disp_sequence=>64
,p_lov_disp_value=>'Equateur'
,p_lov_return_value=>'ECU'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825854523179276895.4052)
,p_lov_disp_sequence=>65
,p_lov_disp_value=>'Egypte'
,p_lov_return_value=>'EGY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825854974439276896.4052)
,p_lov_disp_sequence=>66
,p_lov_disp_value=>'El Salvador'
,p_lov_return_value=>'SLV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825855379830276896.4052)
,p_lov_disp_sequence=>67
,p_lov_disp_value=>unistr('Guin\00E9e \00E9quatoriale')
,p_lov_return_value=>'GNQ'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825855778939276896.4052)
,p_lov_disp_sequence=>68
,p_lov_disp_value=>unistr('Erythr\00E9e')
,p_lov_return_value=>'ERI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825856175255276896.4052)
,p_lov_disp_sequence=>69
,p_lov_disp_value=>'Estonie'
,p_lov_return_value=>'EST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825856589758276896.4052)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Eswatini'
,p_lov_return_value=>'SWZ'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825856923318276896.4052)
,p_lov_disp_sequence=>71
,p_lov_disp_value=>'Ethiopie'
,p_lov_return_value=>'ETH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825857301067276897.4052)
,p_lov_disp_sequence=>72
,p_lov_disp_value=>'Iles Falkland (Malvinas)'
,p_lov_return_value=>'FLK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825857748095276897.4052)
,p_lov_disp_sequence=>73
,p_lov_disp_value=>unistr('Iles F\00E9ro\00E9')
,p_lov_return_value=>'FRO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825858169835276897.4052)
,p_lov_disp_sequence=>74
,p_lov_disp_value=>'Iles Fidji'
,p_lov_return_value=>'FJI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825858578669276897.4052)
,p_lov_disp_sequence=>75
,p_lov_disp_value=>'Finlande'
,p_lov_return_value=>'FIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825858962903276897.4052)
,p_lov_disp_sequence=>76
,p_lov_disp_value=>'France'
,p_lov_return_value=>'FRA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825859369920276898.4052)
,p_lov_disp_sequence=>77
,p_lov_disp_value=>unistr('Guyane fran\00E7aise')
,p_lov_return_value=>'GUF'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825859722685276898.4052)
,p_lov_disp_sequence=>78
,p_lov_disp_value=>unistr('Polyn\00E9sie fran\00E7aise')
,p_lov_return_value=>'PYF'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825860168382276898.4052)
,p_lov_disp_sequence=>79
,p_lov_disp_value=>unistr('Terres australes fran\00E7aises')
,p_lov_return_value=>'ATF'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825860537480276898.4052)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Gabon'
,p_lov_return_value=>'GAB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825860968028276898.4052)
,p_lov_disp_sequence=>81
,p_lov_disp_value=>'Gambie'
,p_lov_return_value=>'GMB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825861391692276898.4052)
,p_lov_disp_sequence=>82
,p_lov_disp_value=>unistr('G\00E9orgie')
,p_lov_return_value=>'GEO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825861731223276899.4052)
,p_lov_disp_sequence=>83
,p_lov_disp_value=>'Allemagne'
,p_lov_return_value=>'DEU'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825862111275276899.4052)
,p_lov_disp_sequence=>84
,p_lov_disp_value=>'Ghana'
,p_lov_return_value=>'GHA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825862578738276899.4052)
,p_lov_disp_sequence=>85
,p_lov_disp_value=>'Gibraltar'
,p_lov_return_value=>'GIB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825862936293276899.4052)
,p_lov_disp_sequence=>86
,p_lov_disp_value=>unistr('Gr\00E8ce')
,p_lov_return_value=>'GRC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825863304019276899.4052)
,p_lov_disp_sequence=>87
,p_lov_disp_value=>'Groenland'
,p_lov_return_value=>'GRL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825863700485276900.4052)
,p_lov_disp_sequence=>88
,p_lov_disp_value=>'Grenade'
,p_lov_return_value=>'GRD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825864153392276900.4052)
,p_lov_disp_sequence=>89
,p_lov_disp_value=>'Guadeloupe'
,p_lov_return_value=>'GLP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825864504580276900.4052)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Guam'
,p_lov_return_value=>'GUM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825864938354276900.4052)
,p_lov_disp_sequence=>91
,p_lov_disp_value=>'Guatemala'
,p_lov_return_value=>'GTM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825865328711276900.4052)
,p_lov_disp_sequence=>92
,p_lov_disp_value=>'Guernesey'
,p_lov_return_value=>'GGY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825865761129276901.4052)
,p_lov_disp_sequence=>93
,p_lov_disp_value=>unistr('Guin\00E9e')
,p_lov_return_value=>'GIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825866137901276901.4052)
,p_lov_disp_sequence=>94
,p_lov_disp_value=>unistr('Guin\00E9e-Bissau')
,p_lov_return_value=>'GNB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825866597136276901.4052)
,p_lov_disp_sequence=>95
,p_lov_disp_value=>'Guyane'
,p_lov_return_value=>'GUY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825866991467276901.4052)
,p_lov_disp_sequence=>96
,p_lov_disp_value=>unistr('Ha\00EFti')
,p_lov_return_value=>'HTI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825867359739276901.4052)
,p_lov_disp_sequence=>97
,p_lov_disp_value=>'Ile Heard et Iles McDonald'
,p_lov_return_value=>'HMD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825867793643276901.4052)
,p_lov_disp_sequence=>98
,p_lov_disp_value=>'Vatican'
,p_lov_return_value=>'VAT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825868116514276902.4052)
,p_lov_disp_sequence=>99
,p_lov_disp_value=>'Honduras'
,p_lov_return_value=>'HND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825868599147276902.4052)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Hong Kong'
,p_lov_return_value=>'HKG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825868929222276902.4052)
,p_lov_disp_sequence=>101
,p_lov_disp_value=>'Hongrie'
,p_lov_return_value=>'HUN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825869314307276902.4052)
,p_lov_disp_sequence=>102
,p_lov_disp_value=>'Islande'
,p_lov_return_value=>'ISL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825869788511276902.4052)
,p_lov_disp_sequence=>103
,p_lov_disp_value=>'Inde'
,p_lov_return_value=>'IND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825870107082276903.4052)
,p_lov_disp_sequence=>104
,p_lov_disp_value=>unistr('Indon\00E9sie')
,p_lov_return_value=>'IDN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825870592905276903.4052)
,p_lov_disp_sequence=>105
,p_lov_disp_value=>unistr('Iran (R\00E9publique islamique)')
,p_lov_return_value=>'IRN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825870961884276903.4052)
,p_lov_disp_sequence=>106
,p_lov_disp_value=>'Irak'
,p_lov_return_value=>'IRQ'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825871373033276903.4052)
,p_lov_disp_sequence=>107
,p_lov_disp_value=>'Irlande'
,p_lov_return_value=>'IRL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825871765525276903.4052)
,p_lov_disp_sequence=>108
,p_lov_disp_value=>'Ile de Man'
,p_lov_return_value=>'IMN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825872138253276904.4052)
,p_lov_disp_sequence=>109
,p_lov_disp_value=>unistr('Isra\00EBl')
,p_lov_return_value=>'ISR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825872519288276904.4052)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Italie'
,p_lov_return_value=>'ITA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825872986754276904.4052)
,p_lov_disp_sequence=>111
,p_lov_disp_value=>unistr('Jama\00EFque')
,p_lov_return_value=>'JAM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825873344716276904.4052)
,p_lov_disp_sequence=>112
,p_lov_disp_value=>'Japon'
,p_lov_return_value=>'JPN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825873704589276904.4052)
,p_lov_disp_sequence=>113
,p_lov_disp_value=>'Jersey'
,p_lov_return_value=>'JEY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825874131739276904.4052)
,p_lov_disp_sequence=>114
,p_lov_disp_value=>'Jordanie'
,p_lov_return_value=>'JOR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825874580186276905.4052)
,p_lov_disp_sequence=>115
,p_lov_disp_value=>'Kazakhstan'
,p_lov_return_value=>'KAZ'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825874975940276905.4052)
,p_lov_disp_sequence=>116
,p_lov_disp_value=>'Kenya'
,p_lov_return_value=>'KEN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825875365933276905.4052)
,p_lov_disp_sequence=>117
,p_lov_disp_value=>'Kiribati'
,p_lov_return_value=>'KIR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825875770424276905.4052)
,p_lov_disp_sequence=>118
,p_lov_disp_value=>unistr('Kowe\00EFt')
,p_lov_return_value=>'KWT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825876111066276905.4052)
,p_lov_disp_sequence=>119
,p_lov_disp_value=>'Kirghizistan'
,p_lov_return_value=>'KGZ'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825876586908276906.4052)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>unistr('Laos (R\00E9publique populaire d\00E9mocratique)')
,p_lov_return_value=>'LAO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825876951921276906.4052)
,p_lov_disp_sequence=>121
,p_lov_disp_value=>'Lettonie'
,p_lov_return_value=>'LVA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825877356147276906.4052)
,p_lov_disp_sequence=>122
,p_lov_disp_value=>'Liban'
,p_lov_return_value=>'LBN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825877726325276906.4052)
,p_lov_disp_sequence=>123
,p_lov_disp_value=>'Lesotho'
,p_lov_return_value=>'LSO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825878113894276906.4052)
,p_lov_disp_sequence=>124
,p_lov_disp_value=>unistr('Lib\00E9ria')
,p_lov_return_value=>'LBR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825878594036276907.4052)
,p_lov_disp_sequence=>125
,p_lov_disp_value=>'Libye'
,p_lov_return_value=>'LBY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825878909866276907.4052)
,p_lov_disp_sequence=>126
,p_lov_disp_value=>'Liechtenstein'
,p_lov_return_value=>'LIE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825879393532276907.4052)
,p_lov_disp_sequence=>127
,p_lov_disp_value=>'Lituanie'
,p_lov_return_value=>'LTU'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825879773232276907.4052)
,p_lov_disp_sequence=>128
,p_lov_disp_value=>'Luxembourg'
,p_lov_return_value=>'LUX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825880134430276907.4052)
,p_lov_disp_sequence=>129
,p_lov_disp_value=>'Macao'
,p_lov_return_value=>'MAC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825880561767276907.4052)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'Madagascar'
,p_lov_return_value=>'MDG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825880967943276908.4052)
,p_lov_disp_sequence=>131
,p_lov_disp_value=>'Malawi'
,p_lov_return_value=>'MWI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825881305433276908.4052)
,p_lov_disp_sequence=>132
,p_lov_disp_value=>'Malaisie'
,p_lov_return_value=>'MYS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825881704610276908.4052)
,p_lov_disp_sequence=>133
,p_lov_disp_value=>'Maldives'
,p_lov_return_value=>'MDV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825882119253276908.4052)
,p_lov_disp_sequence=>134
,p_lov_disp_value=>'Mali'
,p_lov_return_value=>'MLI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825882563797276908.4052)
,p_lov_disp_sequence=>135
,p_lov_disp_value=>'Malte'
,p_lov_return_value=>'MLT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825882947105276909.4052)
,p_lov_disp_sequence=>136
,p_lov_disp_value=>'Iles Marshall'
,p_lov_return_value=>'MHL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825883325187276909.4052)
,p_lov_disp_sequence=>137
,p_lov_disp_value=>'Martinique'
,p_lov_return_value=>'MTQ'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825883707866276909.4052)
,p_lov_disp_sequence=>138
,p_lov_disp_value=>'Mauritanie'
,p_lov_return_value=>'MRT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825884188442276909.4052)
,p_lov_disp_sequence=>139
,p_lov_disp_value=>'Maurice'
,p_lov_return_value=>'MUS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825884544188276909.4052)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'Mayotte'
,p_lov_return_value=>'MYT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825884930655276909.4052)
,p_lov_disp_sequence=>141
,p_lov_disp_value=>'Mexique'
,p_lov_return_value=>'MEX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825885322708276910.4052)
,p_lov_disp_sequence=>142
,p_lov_disp_value=>unistr('Micron\00E9sie (Etats f\00E9d\00E9r\00E9s de)')
,p_lov_return_value=>'FSM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825885769657276910.4052)
,p_lov_disp_sequence=>143
,p_lov_disp_value=>unistr('Moldavie (R\00E9publique de)')
,p_lov_return_value=>'MDA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825886192981276910.4052)
,p_lov_disp_sequence=>144
,p_lov_disp_value=>'Monaco'
,p_lov_return_value=>'MCO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825886582724276910.4052)
,p_lov_disp_sequence=>145
,p_lov_disp_value=>'Mongolie'
,p_lov_return_value=>'MNG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825886993780276910.4052)
,p_lov_disp_sequence=>146
,p_lov_disp_value=>unistr('Mont\00E9n\00E9gro')
,p_lov_return_value=>'MNE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825887392313276911.4052)
,p_lov_disp_sequence=>147
,p_lov_disp_value=>'Montserrat'
,p_lov_return_value=>'MSR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825887778990276911.4052)
,p_lov_disp_sequence=>148
,p_lov_disp_value=>'Maroc'
,p_lov_return_value=>'MAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825888183428276911.4052)
,p_lov_disp_sequence=>149
,p_lov_disp_value=>'Mozambique'
,p_lov_return_value=>'MOZ'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825888530594276911.4052)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'Myanmar'
,p_lov_return_value=>'MMR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825888910703276911.4052)
,p_lov_disp_sequence=>151
,p_lov_disp_value=>'Namibie'
,p_lov_return_value=>'NAM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825889307523276911.4052)
,p_lov_disp_sequence=>152
,p_lov_disp_value=>'Nauru'
,p_lov_return_value=>'NRU'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825889715474276912.4052)
,p_lov_disp_sequence=>153
,p_lov_disp_value=>unistr('N\00E9pal')
,p_lov_return_value=>'NPL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825890173081276912.4052)
,p_lov_disp_sequence=>154
,p_lov_disp_value=>'Pays-Bas'
,p_lov_return_value=>'NLD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825890583991276912.4052)
,p_lov_disp_sequence=>155
,p_lov_disp_value=>unistr('Nouvelle-Cal\00E9donie')
,p_lov_return_value=>'NCL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825890980343276912.4052)
,p_lov_disp_sequence=>156
,p_lov_disp_value=>unistr('Nouvelle-Z\00E9lande')
,p_lov_return_value=>'NZL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825891310391276912.4052)
,p_lov_disp_sequence=>157
,p_lov_disp_value=>'Nicaragua'
,p_lov_return_value=>'NIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825891764424276913.4052)
,p_lov_disp_sequence=>158
,p_lov_disp_value=>'Niger'
,p_lov_return_value=>'NER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825892178880276913.4052)
,p_lov_disp_sequence=>159
,p_lov_disp_value=>unistr('Nig\00E9ria')
,p_lov_return_value=>'NGA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825892586586276913.4052)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>unistr('Niu\00E9')
,p_lov_return_value=>'NIU'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825892932251276913.4052)
,p_lov_disp_sequence=>161
,p_lov_disp_value=>'Ile Norfolk'
,p_lov_return_value=>'NFK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825893317790276913.4052)
,p_lov_disp_sequence=>162
,p_lov_disp_value=>unistr('Cor\00E9e du Nord (R\00E9publique populaire d\00E9mocratique)')
,p_lov_return_value=>'PRK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825893763078276914.4052)
,p_lov_disp_sequence=>163
,p_lov_disp_value=>unistr('Mac\00E9doine du Nord')
,p_lov_return_value=>'MKD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825894130064276914.4052)
,p_lov_disp_sequence=>164
,p_lov_disp_value=>'Iles Mariannes du Nord'
,p_lov_return_value=>'MNP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825894506244276914.4052)
,p_lov_disp_sequence=>165
,p_lov_disp_value=>unistr('Norv\00E8ge')
,p_lov_return_value=>'NOR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825894979561276915.4052)
,p_lov_disp_sequence=>166
,p_lov_disp_value=>'Oman'
,p_lov_return_value=>'OMN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825895305615276915.4052)
,p_lov_disp_sequence=>167
,p_lov_disp_value=>'Pakistan'
,p_lov_return_value=>'PAK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825895737444276915.4052)
,p_lov_disp_sequence=>168
,p_lov_disp_value=>'Palaos'
,p_lov_return_value=>'PLW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825896173319276916.4052)
,p_lov_disp_sequence=>169
,p_lov_disp_value=>'Palestine, Etat de'
,p_lov_return_value=>'PSE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825896520712276916.4052)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>unistr('Panam\00E1')
,p_lov_return_value=>'PAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825896973195276916.4052)
,p_lov_disp_sequence=>171
,p_lov_disp_value=>unistr('Papouasie-Nouvelle Guin\00E9e')
,p_lov_return_value=>'PNG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825897330162276916.4052)
,p_lov_disp_sequence=>172
,p_lov_disp_value=>'Paraguay'
,p_lov_return_value=>'PRY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825897730820276916.4052)
,p_lov_disp_sequence=>173
,p_lov_disp_value=>unistr('P\00E9rou')
,p_lov_return_value=>'PER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825898113595276917.4052)
,p_lov_disp_sequence=>174
,p_lov_disp_value=>'Philippines'
,p_lov_return_value=>'PHL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825898521565276917.4052)
,p_lov_disp_sequence=>175
,p_lov_disp_value=>'Pitcairn'
,p_lov_return_value=>'PCN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825898923467276917.4052)
,p_lov_disp_sequence=>176
,p_lov_disp_value=>'Pologne'
,p_lov_return_value=>'POL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825899305049276917.4052)
,p_lov_disp_sequence=>177
,p_lov_disp_value=>'Portugal'
,p_lov_return_value=>'PRT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825899754328276917.4052)
,p_lov_disp_sequence=>178
,p_lov_disp_value=>'Porto Rico'
,p_lov_return_value=>'PRI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825900194972276919.4052)
,p_lov_disp_sequence=>179
,p_lov_disp_value=>'Qatar'
,p_lov_return_value=>'QAT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825900527948276919.4052)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>'Roumanie'
,p_lov_return_value=>'ROU'
);
end;
/
begin
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825900965393276920.4052)
,p_lov_disp_sequence=>181
,p_lov_disp_value=>unistr('F\00E9d\00E9ration de Russie')
,p_lov_return_value=>'RUS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825901319523276920.4052)
,p_lov_disp_sequence=>182
,p_lov_disp_value=>'Rwanda'
,p_lov_return_value=>'RWA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825901741930276920.4052)
,p_lov_disp_sequence=>183
,p_lov_disp_value=>unistr('R\00E9union')
,p_lov_return_value=>'REU'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825902186193276920.4052)
,p_lov_disp_sequence=>184
,p_lov_disp_value=>unistr('Saint-Barth\00E9lemy')
,p_lov_return_value=>'BLM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825902571781276920.4052)
,p_lov_disp_sequence=>185
,p_lov_disp_value=>unistr('Sainte-H\00E9l\00E8ne, Ascension et Tristan da Cunha')
,p_lov_return_value=>'SHN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825902987947276920.4052)
,p_lov_disp_sequence=>186
,p_lov_disp_value=>'Saint-Kitts-et-Nevis'
,p_lov_return_value=>'KNA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825903370219276921.4052)
,p_lov_disp_sequence=>187
,p_lov_disp_value=>'Sainte-Lucie'
,p_lov_return_value=>'LCA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825903723148276921.4052)
,p_lov_disp_sequence=>188
,p_lov_disp_value=>unistr('Saint Martin (partie fran\00E7aise)')
,p_lov_return_value=>'MAF'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825904147719276921.4052)
,p_lov_disp_sequence=>189
,p_lov_disp_value=>'Saint-Pierre-et-Miquelon'
,p_lov_return_value=>'SPM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825904592478276921.4052)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>'Saint-Vincent-et-les-Grenadines'
,p_lov_return_value=>'VCT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825904916537276921.4052)
,p_lov_disp_sequence=>191
,p_lov_disp_value=>'Samoa'
,p_lov_return_value=>'WSM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825905384376276922.4052)
,p_lov_disp_sequence=>192
,p_lov_disp_value=>'Saint-Marin'
,p_lov_return_value=>'SMR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825905752137276922.4052)
,p_lov_disp_sequence=>193
,p_lov_disp_value=>unistr('S\00E3o Tom\00E9-et-Principe')
,p_lov_return_value=>'STP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825906165213276922.4052)
,p_lov_disp_sequence=>194
,p_lov_disp_value=>'Arabie saoudite'
,p_lov_return_value=>'SAU'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825906527584276922.4052)
,p_lov_disp_sequence=>195
,p_lov_disp_value=>unistr('S\00E9n\00E9gal')
,p_lov_return_value=>'SEN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825906909103276922.4052)
,p_lov_disp_sequence=>196
,p_lov_disp_value=>'Serbie'
,p_lov_return_value=>'SRB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825907325092276922.4052)
,p_lov_disp_sequence=>197
,p_lov_disp_value=>'Seychelles'
,p_lov_return_value=>'SYC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825907727129276923.4052)
,p_lov_disp_sequence=>198
,p_lov_disp_value=>'Sierra Leone'
,p_lov_return_value=>'SLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825908172230276923.4052)
,p_lov_disp_sequence=>199
,p_lov_disp_value=>'Singapour'
,p_lov_return_value=>'SGP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825908590713276923.4052)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>unistr('Saint-Martin (partie n\00E9erlandaise)')
,p_lov_return_value=>'SXM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825908968311276923.4052)
,p_lov_disp_sequence=>201
,p_lov_disp_value=>'Slovaquie'
,p_lov_return_value=>'SVK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825909353469276923.4052)
,p_lov_disp_sequence=>202
,p_lov_disp_value=>unistr('Slov\00E9nie')
,p_lov_return_value=>'SVN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825909711211276924.4052)
,p_lov_disp_sequence=>203
,p_lov_disp_value=>'Iles Salomon'
,p_lov_return_value=>'SLB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825910116576276924.4052)
,p_lov_disp_sequence=>204
,p_lov_disp_value=>'Somalie'
,p_lov_return_value=>'SOM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825910507104276924.4052)
,p_lov_disp_sequence=>205
,p_lov_disp_value=>'Afrique du Sud'
,p_lov_return_value=>'ZAF'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825910923668276924.4052)
,p_lov_disp_sequence=>206
,p_lov_disp_value=>unistr('G\00E9orgie du Sud-et-les Iles Sandwich du Sud')
,p_lov_return_value=>'SGS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825911323973276924.4052)
,p_lov_disp_sequence=>207
,p_lov_disp_value=>unistr('Cor\00E9e du Sud (R\00E9publique de)')
,p_lov_return_value=>'KOR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825911777749276925.4052)
,p_lov_disp_sequence=>208
,p_lov_disp_value=>'Soudan du Sud'
,p_lov_return_value=>'SSD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825912118903276925.4052)
,p_lov_disp_sequence=>209
,p_lov_disp_value=>'Espagne'
,p_lov_return_value=>'ESP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825912561193276925.4052)
,p_lov_disp_sequence=>210
,p_lov_disp_value=>'Sri Lanka'
,p_lov_return_value=>'LKA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825912924033276925.4052)
,p_lov_disp_sequence=>211
,p_lov_disp_value=>'Soudan'
,p_lov_return_value=>'SDN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825913319072276925.4052)
,p_lov_disp_sequence=>212
,p_lov_disp_value=>'Suriname'
,p_lov_return_value=>'SUR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825913775276276926.4052)
,p_lov_disp_sequence=>213
,p_lov_disp_value=>'Svalbard et Ile Jan Mayen'
,p_lov_return_value=>'SJM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825914131489276926.4052)
,p_lov_disp_sequence=>214
,p_lov_disp_value=>unistr('Su\00E8de')
,p_lov_return_value=>'SWE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825914579565276926.4052)
,p_lov_disp_sequence=>215
,p_lov_disp_value=>'Suisse'
,p_lov_return_value=>'CHE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825914943996276926.4052)
,p_lov_disp_sequence=>216
,p_lov_disp_value=>unistr('R\00E9publique arabe syrienne')
,p_lov_return_value=>'SYR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825915320020276926.4052)
,p_lov_disp_sequence=>217
,p_lov_disp_value=>unistr('Ta\00EFwan (Province de Chine)')
,p_lov_return_value=>'TWN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825915790478276927.4052)
,p_lov_disp_sequence=>218
,p_lov_disp_value=>'Tadjikistan'
,p_lov_return_value=>'TJK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825916163490276927.4052)
,p_lov_disp_sequence=>219
,p_lov_disp_value=>unistr('Tanzanie (R\00E9publique unie de)')
,p_lov_return_value=>'TZA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825916529887276927.4052)
,p_lov_disp_sequence=>220
,p_lov_disp_value=>unistr('Tha\00EFlande')
,p_lov_return_value=>'THA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825916960711276927.4052)
,p_lov_disp_sequence=>221
,p_lov_disp_value=>'Timor oriental'
,p_lov_return_value=>'TLS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825917361523276928.4052)
,p_lov_disp_sequence=>222
,p_lov_disp_value=>'Togo'
,p_lov_return_value=>'TGO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825917781777276928.4052)
,p_lov_disp_sequence=>223
,p_lov_disp_value=>'Tokelau'
,p_lov_return_value=>'TKL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825918105350276928.4052)
,p_lov_disp_sequence=>224
,p_lov_disp_value=>'Tonga'
,p_lov_return_value=>'TON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825918560450276928.4052)
,p_lov_disp_sequence=>225
,p_lov_disp_value=>unistr('Trinit\00E9-et-Tobago')
,p_lov_return_value=>'TTO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825918990154276928.4052)
,p_lov_disp_sequence=>226
,p_lov_disp_value=>'Tunisie'
,p_lov_return_value=>'TUN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825919368202276929.4052)
,p_lov_disp_sequence=>227
,p_lov_disp_value=>'Turquie'
,p_lov_return_value=>'TUR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825919704933276929.4052)
,p_lov_disp_sequence=>228
,p_lov_disp_value=>unistr('Turkm\00E9nistan')
,p_lov_return_value=>'TKM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825920118239276929.4052)
,p_lov_disp_sequence=>229
,p_lov_disp_value=>unistr('Iles Turques-et-Ca\00EFques')
,p_lov_return_value=>'TCA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825920509259276929.4052)
,p_lov_disp_sequence=>230
,p_lov_disp_value=>'Tuvalu'
,p_lov_return_value=>'TUV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825920928756276929.4052)
,p_lov_disp_sequence=>231
,p_lov_disp_value=>'Ouganda'
,p_lov_return_value=>'UGA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825921395061276929.4052)
,p_lov_disp_sequence=>232
,p_lov_disp_value=>'Ukraine'
,p_lov_return_value=>'UKR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825921723040276930.4052)
,p_lov_disp_sequence=>233
,p_lov_disp_value=>'Emirats arabes unis'
,p_lov_return_value=>'ARE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825922100997276930.4052)
,p_lov_disp_sequence=>234
,p_lov_disp_value=>'Royaume-Uni de Grande-Bretagne et d''Irlande du Nord'
,p_lov_return_value=>'GBR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825922598731276930.4052)
,p_lov_disp_sequence=>235
,p_lov_disp_value=>unistr('Iles mineures \00E9loign\00E9es des Etats-Unis')
,p_lov_return_value=>'UMI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825922942720276930.4052)
,p_lov_disp_sequence=>236
,p_lov_disp_value=>unistr('Etats-Unis d''Am\00E9rique')
,p_lov_return_value=>'USA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825923369763276930.4052)
,p_lov_disp_sequence=>237
,p_lov_disp_value=>'Uruguay'
,p_lov_return_value=>'URY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825923723825276931.4052)
,p_lov_disp_sequence=>238
,p_lov_disp_value=>unistr('Ouzb\00E9kistan')
,p_lov_return_value=>'UZB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825924166994276931.4052)
,p_lov_disp_sequence=>239
,p_lov_disp_value=>'Vanuatu'
,p_lov_return_value=>'VUT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825924539566276931.4052)
,p_lov_disp_sequence=>240
,p_lov_disp_value=>unistr('Venezuela (R\00E9publique bolivarienne du)')
,p_lov_return_value=>'VEN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825924969601276931.4052)
,p_lov_disp_sequence=>241
,p_lov_disp_value=>unistr('Vi\00EAt Nam')
,p_lov_return_value=>'VNM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825925367357276931.4052)
,p_lov_disp_sequence=>242
,p_lov_disp_value=>'Iles vierges (Grande-Bretagne)'
,p_lov_return_value=>'VGB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825925707805276932.4052)
,p_lov_disp_sequence=>243
,p_lov_disp_value=>'Iles Vierges (Etats-Unis)'
,p_lov_return_value=>'VIR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825926101219276932.4052)
,p_lov_disp_sequence=>244
,p_lov_disp_value=>'Wallis-et-Futuna'
,p_lov_return_value=>'WLF'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825926525342276932.4052)
,p_lov_disp_sequence=>245
,p_lov_disp_value=>'Sahara occidental'
,p_lov_return_value=>'ESH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825926910133276932.4052)
,p_lov_disp_sequence=>246
,p_lov_disp_value=>unistr('Y\00E9men')
,p_lov_return_value=>'YEM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825927329247276932.4052)
,p_lov_disp_sequence=>247
,p_lov_disp_value=>'Zambie'
,p_lov_return_value=>'ZMB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825927705388276932.4052)
,p_lov_disp_sequence=>248
,p_lov_disp_value=>'Zimbabwe'
,p_lov_return_value=>'ZWE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825928166569276933.4052)
,p_lov_disp_sequence=>249
,p_lov_disp_value=>unistr('Iles \00C5land')
,p_lov_return_value=>'ALA'
);
end;
/
prompt --application/shared_components/user_interface/lovs/date_format_lov
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(847446100928128573.4052)
,p_lov_name=>'DATE_FORMAT_LOV'
,p_reference_id=>460719917105668922.4052
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r',
'  from wwv_flow_format_masks',
' where t=''D'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/db_tablespaces
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(161644121203686372.4052)
,p_lov_name=>'DB.TABLESPACES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tablespace_name tname_disp, tablespace_name tname_ret',
'  from sys.dba_tablespaces'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/default_error_display_location
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(360596400783208409.4052)
,p_lov_name=>'DEFAULT_ERROR_DISPLAY_LOCATION'
,p_reference_id=>191207805708435328.4052
,p_lov_query=>'.'||wwv_flow_api.id(360596400783208409.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(360597710469208433.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Incorporation avec un champ et dans une notification'
,p_lov_return_value=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(360597900558208433.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Incorporation avec un champ'
,p_lov_return_value=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(360598129380208433.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Incorporation dans une notification'
,p_lov_return_value=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/developer_activity_action
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(110357115975241430.4052)
,p_lov_name=>'DEVELOPER ACTIVITY ACTION'
,p_lov_query=>'.'||wwv_flow_api.id(110357115975241430.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(110357309735241430.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Cr\00E9er')
,p_lov_return_value=>'I'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(110357503716241431.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Supprimer'
,p_lov_return_value=>'D'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(110357728444241431.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Modifier'
,p_lov_return_value=>'U'
);
end;
/
prompt --application/shared_components/user_interface/lovs/developer_privs
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(182796815771077530.4052)
,p_lov_name=>'DEVELOPER.PRIVS'
,p_lov_query=>'.'||wwv_flow_api.id(182796815771077530.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87840032028448399.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Administration'
,p_lov_return_value=>'ADMIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87840228629448402.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Parcourir'
,p_lov_return_value=>'BROWSE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87840406518448402.4052)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Cr\00E9er')
,p_lov_return_value=>'CREATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87840629693448402.4052)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Programme de chargement de donn\00E9es')
,p_lov_return_value=>'DATA_LOADER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87840818626448402.4052)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Moniteur de BdD'
,p_lov_return_value=>'DB_MONITOR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87841009541448403.4052)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Modifier'
,p_lov_return_value=>'EDIT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87841204704448403.4052)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Aide'
,p_lov_return_value=>'HELP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87841420783448403.4052)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Surveiller'
,p_lov_return_value=>'MONITOR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87841623734448404.4052)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'SQL'
,p_lov_return_value=>'SQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87841806856448404.4052)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Gestionnaire d''utilisateurs'
,p_lov_return_value=>'USER_MANAGER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/enable_y_disable_n
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(484964000318931321.4052)
,p_lov_name=>'ENABLE Y, DISABLE N'
,p_lov_query=>'.'||wwv_flow_api.id(484964000318931321.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(484964223962931324.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Activer'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(484964415569931326.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('D\00E9sactiver')
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/enabled_true_false
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1351993194329853612.4052)
,p_lov_name=>'ENABLED_TRUE_FALSE'
,p_lov_query=>'.'||wwv_flow_api.id(1351993194329853612.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1351993418924853622.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'True'
,p_lov_return_value=>'TRUE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1351993885783853625.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'False'
,p_lov_return_value=>'FALSE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/exact_subs_y_n
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(370686604633893239.4052)
,p_lov_name=>'EXACT_SUBS_Y_N'
,p_reference_id=>84908521896674445.4052
,p_lov_query=>'.'||wwv_flow_api.id(370686604633893239.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(370687632719893241.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Non - Effectuer \00E9galement les substitutions non exactes')
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(370687828235893241.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Oui - Effectuer uniquement les substitutions exactes'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/export_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2046991831712786495.4052)
,p_lov_name=>'EXPORT_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(2046991831712786495.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2046992184705786498.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Complet'
,p_lov_return_value=>'FULL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2046992509267786499.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Minimal'
,p_lov_return_value=>'MIN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/file_format
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(175743214959227187.4052)
,p_lov_name=>'FILE_FORMAT'
,p_lov_query=>'.'||wwv_flow_api.id(175743214959227187.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(175743601146227192.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'UNIX'
,p_lov_return_value=>'UNIX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(175743426983227191.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'DOS'
,p_lov_return_value=>'DOS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_dates_no_since
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(348972227781434779.4052)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_DATES_NO_SINCE'
,p_reference_id=>170713321121898589.4052
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_dates_timestamps_no_since
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(348972603598434786.4052)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_DATES_TIMESTAMPS_NO_SINCE'
,p_reference_id=>170713631164901556.4052
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''T''',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_dates_timestamps_tzr_no_since
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(348973028981434786.4052)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_DATES_TIMESTAMPS_TZR_NO_SINCE'
,p_reference_id=>170713910516904980.4052
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''T''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''Z'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/geometry_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(564921851272063247.4052)
,p_lov_name=>'GEOMETRY_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(564921851272063247.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(564922134126063248.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Points'
,p_lov_return_value=>'POINT'
,p_lov_template=>'#DISPLAY_VALUE#|map-points'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(564922549275063248.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Lignes'
,p_lov_return_value=>'LINE'
,p_lov_template=>'#DISPLAY_VALUE#|map-lines'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(564922930077063248.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Polygones'
,p_lov_return_value=>'POLYGON'
,p_lov_template=>'#DISPLAY_VALUE#|map-polygons'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(564923359512063251.4052)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Carte d''activit\00E9')
,p_lov_return_value=>'HEATMAP'
,p_lov_template=>'#DISPLAY_VALUE#|map-heatmap'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(564923718918063251.4052)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Polygones extrud\00E9s')
,p_lov_return_value=>'POLYGON_3D'
,p_lov_template=>'#DISPLAY_VALUE#|map-extruded-polgygons'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(564983780209097093.4052)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Inconnu'
,p_lov_return_value=>'UNKNOWN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/hash_function
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(366796514610241309.4052)
,p_lov_name=>'HASH_FUNCTION'
,p_lov_query=>'.'||wwv_flow_api.id(366796514610241309.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(366797127072241312.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'SHA-1'
,p_lov_return_value=>'SH1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(366797426883241313.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'SHA-2, 256 bits (requiert 12c)'
,p_lov_return_value=>'SH256'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(366797730058241314.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'SHA-2, 384 bits (requiert 12c)'
,p_lov_return_value=>'SH384'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(366798016860241314.4052)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'SHA-2, 512 bits (requiert 12c)'
,p_lov_return_value=>'SH512'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(366796820622241310.4052)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('MD5 (h\00E9rit\00E9)')
,p_lov_return_value=>'MD5'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_iana_charset
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(175798011541253458.4052)
,p_lov_name=>'I18N_IANA_CHARSET'
,p_reference_id=>144796827445692396.4052
,p_lov_query=>'.'||wwv_flow_api.id(175798011541253458.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9219501049925452.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Arabe - ISO-8859-6'
,p_lov_return_value=>'iso-8859-6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9219717725925452.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Arabe - Windows 1256'
,p_lov_return_value=>'windows-1256'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9219915396925453.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Chinois - Big5'
,p_lov_return_value=>'big5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9220105075925453.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Chinois - GBK'
,p_lov_return_value=>'gbk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9220309171925453.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrillique - ISO-8859-5'
,p_lov_return_value=>'iso-8859-5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9220531506925453.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrillique - KOI8-R'
,p_lov_return_value=>'koi8-r'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9220716176925453.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrillique - KOI8-U'
,p_lov_return_value=>'koi8-u'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9220921806925453.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrillique - Windows 1251'
,p_lov_return_value=>'windows-1251'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9221127254925453.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Europe de l''Est - ISO-8859-2'
,p_lov_return_value=>'iso-8859-2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9221328423925453.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Europe de l''Est - Windows 1250'
,p_lov_return_value=>'windows-1250'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9221530241925453.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Grec - ISO-8859-7'
,p_lov_return_value=>'iso-8859-7'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9221716263925453.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Grec - Windows 1253'
,p_lov_return_value=>'windows-1253'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9221926948925453.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('H\00E9breu - ISO-8859-8-i')
,p_lov_return_value=>'iso-8859-8-i'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9222100762925453.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('H\00E9breu - Windows 1255')
,p_lov_return_value=>'windows-1255'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9222325282925453.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Japonais - EUC'
,p_lov_return_value=>'euc-jp'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9222500466925453.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Japonais - Shift JIS'
,p_lov_return_value=>'shift_jis'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9222730026925454.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Cor\00E9en - EUC')
,p_lov_return_value=>'euc-kr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9222922148925454.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Europe du Nord - ISO-8859-4'
,p_lov_return_value=>'iso-8859-4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9223125383925454.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Europe du Nord - Windows 1257'
,p_lov_return_value=>'windows-1257'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9223328804925454.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Europe du Sud - ISO-8859-3'
,p_lov_return_value=>'iso-8859-3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9223507735925454.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Tha\00EF - TIS-620')
,p_lov_return_value=>'tis-620'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9223727278925454.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Turc - ISO-8859-9'
,p_lov_return_value=>'iso-8859-9'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9223913742925454.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Turc - Windows 1254'
,p_lov_return_value=>'windows-1254'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9224108380925454.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unicode - UTF-8'
,p_lov_return_value=>'utf-8'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9224313943925454.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unicode - UTF-16 Big Endian'
,p_lov_return_value=>'utf-16be'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9224522296925454.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unicode - UTF-16 Little Endian'
,p_lov_return_value=>'utf-16le'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9224717469925454.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'US-ASCII'
,p_lov_return_value=>'us-ascii'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9224917326925454.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Vietnamien - Windows 1258'
,p_lov_return_value=>'windows-1258'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9225110387925454.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Europe de l''Ouest - ISO-8859-1'
,p_lov_return_value=>'iso-8859-1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9225332582925454.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Europe de l''Ouest - Windows 1252'
,p_lov_return_value=>'windows-1252'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_languages_locales
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(348975927644434787.4052)
,p_lov_name=>'I18N_LANGUAGES_LOCALES'
,p_reference_id=>107899321117195063.4052
,p_lov_query=>'.'||wwv_flow_api.id(348975927644434787.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698980652575180004.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Az\00E9ri (az)')
,p_lov_return_value=>'az'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698981060553180004.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Afrikaans (af)'
,p_lov_return_value=>'af'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698981482653180005.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (ar)'
,p_lov_return_value=>'ar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698981843695180005.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Arabe (Alg\00E9rie) (ar-dz)')
,p_lov_return_value=>'ar-dz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698982247284180006.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Arabe (Bahre\00EFn) (ar-bh)')
,p_lov_return_value=>'ar-bh'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698982685224180006.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (Egypte) (ar-eg)'
,p_lov_return_value=>'ar-eg'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698983034041180006.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (Iraq) (ar-iq)'
,p_lov_return_value=>'ar-iq'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698983452340180006.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (Jordanie) (ar-jo)'
,p_lov_return_value=>'ar-jo'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698983811981180006.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Arabe (Kowe\00EFt) (ar-kw)')
,p_lov_return_value=>'ar-kw'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698984287771180007.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (Liban) (ar-lb)'
,p_lov_return_value=>'ar-lb'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698984603186180007.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (Libye) (ar-ly)'
,p_lov_return_value=>'ar-ly'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698985056221180007.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (Maroc) (ar-ma)'
,p_lov_return_value=>'ar-ma'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698985436333180007.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (Oman) (ar-om)'
,p_lov_return_value=>'ar-om'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698985890903180007.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (Qatar) (ar-qa)'
,p_lov_return_value=>'ar-qa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698986218587180008.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (Arabie Saoudite) (ar-sa)'
,p_lov_return_value=>'ar-sa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698986694655180008.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (Syrie) (ar-sy)'
,p_lov_return_value=>'ar-sy'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698987026669180008.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (Tunisie) (ar-tn)'
,p_lov_return_value=>'ar-tn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698987468386180008.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabe (E.A.U.) (ar-ae)'
,p_lov_return_value=>'ar-ae'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698987847136180008.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Arabe (Y\00E9men) (ar-ye)')
,p_lov_return_value=>'ar-ye'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698988259079180009.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Assamais (as)'
,p_lov_return_value=>'as'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698988680993180009.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Basque (eu)'
,p_lov_return_value=>'eu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698989064064180009.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('B\00E9larussien (be)')
,p_lov_return_value=>'be'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698989442466180009.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bengali (bn)'
,p_lov_return_value=>'bn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698989876708180010.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bulgare (bg)'
,p_lov_return_value=>'bg'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698990212491180010.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Catalan (ca)'
,p_lov_return_value=>'ca'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698990679988180010.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinois (zh)'
,p_lov_return_value=>'zh'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698991043563180010.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinois (Chine) (zh-cn)'
,p_lov_return_value=>'zh-cn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698991467484180010.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinois (Hong Kong SAR) (zh-hk)'
,p_lov_return_value=>'zh-hk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698991894788180011.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinois (Macao SAR) (zh-mo)'
,p_lov_return_value=>'zh-mo'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698992229032180011.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinois (Singapour) (zh-sg)'
,p_lov_return_value=>'zh-sg'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698992633206180011.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinois (Taiwan) (zh-tw)'
,p_lov_return_value=>'zh-tw'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698993085891180011.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Croate (hr)'
,p_lov_return_value=>'hr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698993494764180011.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Tch\00E8que (cs)')
,p_lov_return_value=>'cs'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698993804687180012.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Danois (da)'
,p_lov_return_value=>'da'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698994284075180012.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('N\00E9erlandais (Belgique) (nl-be)')
,p_lov_return_value=>'nl-be'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698994686095180012.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('N\00E9erlandais (Pays-Bas) (nl)')
,p_lov_return_value=>'nl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698995058585180012.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Anglais (en)'
,p_lov_return_value=>'en'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698995479217180013.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Anglais (Australie) (en-au)'
,p_lov_return_value=>'en-au'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698995893960180013.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Anglais (Belize) (en-bz)'
,p_lov_return_value=>'en-bz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698996294187180013.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Anglais (Canada) (en-ca)'
,p_lov_return_value=>'en-ca'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698996662648180013.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Anglais (Irlande) (en-ie)'
,p_lov_return_value=>'en-ie'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698997058342180013.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Anglais (Jama\00EFque) (en-jm)')
,p_lov_return_value=>'en-jm'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698997421989180014.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Anglais (Nouvelle-Z\00E9lande) (en-nz)')
,p_lov_return_value=>'en-nz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698997824995180014.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Anglais (Philippines) (en-ph)'
,p_lov_return_value=>'en-ph'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698998226542180014.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Anglais (Afrique du Sud) (en-za)'
,p_lov_return_value=>'en-za'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698998692810180014.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Anglais (Trinit\00E9) (en-tt)')
,p_lov_return_value=>'en-tt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698999070042180014.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Anglais (Royaume-Uni) (en-gb)'
,p_lov_return_value=>'en-gb'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698999420730180015.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Anglais (Etats-Unis) (en-us)'
,p_lov_return_value=>'en-us'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(698999869693180015.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Anglais (Zimbabwe) (en-zw)'
,p_lov_return_value=>'en-zw'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699000296040180015.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Estonien (et)'
,p_lov_return_value=>'et'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699000661460180015.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('FYRO Mac\00E9donien (mk)')
,p_lov_return_value=>'mk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699001056125180016.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('F\00E9ro\00EFen (fo)')
,p_lov_return_value=>'fo'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699001467275180016.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Farsi (fa)'
,p_lov_return_value=>'fa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699001875056180016.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Fran\00E7ais (Suisse) (fr-ch)')
,p_lov_return_value=>'fr-ch'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699002266115180016.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Finnois (fi)'
,p_lov_return_value=>'fi'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699002624823180016.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Fran\00E7ais (Belgique) (fr-be)')
,p_lov_return_value=>'fr-be'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699003029269180017.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Fran\00E7ais (Canada) (fr-ca)')
,p_lov_return_value=>'fr-ca'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699003480368180017.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Fran\00E7ais (France) (fr)')
,p_lov_return_value=>'fr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699003872158180017.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Fran\00E7ais (Luxembourg) (fr-lu)')
,p_lov_return_value=>'fr-lu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699004228545180017.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Fran\00E7ais (Monaco) (fr-mc)')
,p_lov_return_value=>'fr-mc'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699004698644180018.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ga\00E9lique (gd)')
,p_lov_return_value=>'gd'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699005086270180018.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Galicien (gl)'
,p_lov_return_value=>'gl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699005496944180018.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Allemand (Autriche) (de-at)'
,p_lov_return_value=>'de-at'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699005888260180018.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Allemand (Allemagne) (de)'
,p_lov_return_value=>'de'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699006292651180018.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Allemand (Liechtenstein) (de-li)'
,p_lov_return_value=>'de-li'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699006603950180019.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Allemand (Luxembourg) (de-lu)'
,p_lov_return_value=>'de-lu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699007072050180019.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Allemand (Suisse) (de-ch)'
,p_lov_return_value=>'de-ch'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699007483019180019.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Grec (el)'
,p_lov_return_value=>'el'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699007855371180019.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Gujarati (gu)'
,p_lov_return_value=>'gu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699008201241180021.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('H\00E9breu (he)')
,p_lov_return_value=>'he'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699008699410180022.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hindi (hi)'
,p_lov_return_value=>'hi'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699009015461180022.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hongrois (hu)'
,p_lov_return_value=>'hu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699009475248180022.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Islandais (is)'
,p_lov_return_value=>'is'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699009868782180022.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Indon\00E9sien (id)')
,p_lov_return_value=>'id'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699010221224180023.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italien (Italie) (it)'
,p_lov_return_value=>'it'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699010624781180023.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italien (Suisse) (it-ch)'
,p_lov_return_value=>'it-ch'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699011015052180023.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Japonais (ja)'
,p_lov_return_value=>'ja'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699011418400180023.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kannada (kn)'
,p_lov_return_value=>'kn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699011831586180024.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kazakh (kk)'
,p_lov_return_value=>'kk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699012278011180024.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Konkani (kok)'
,p_lov_return_value=>'kok'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699012610528180024.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Cor\00E9en (ko)')
,p_lov_return_value=>'ko'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699013093170180024.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kirghiz (kz)'
,p_lov_return_value=>'kz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699013418073180025.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Letton (lv)'
,p_lov_return_value=>'lv'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699013826231180025.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lituanien (lt)'
,p_lov_return_value=>'lt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699014259216180025.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Malais (Malaisie) (ms)'
,p_lov_return_value=>'ms'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699014637221180025.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Malayalam (ml)'
,p_lov_return_value=>'ml'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699015047378180026.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Maltais (mt)'
,p_lov_return_value=>'mt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699015417849180026.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Marathi (mr)'
,p_lov_return_value=>'mr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699015837389180026.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('N\00E9palais (Inde) (ne)')
,p_lov_return_value=>'ne'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699016219550180026.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Norv\00E9gien (Bokmal) (nb-no)')
,p_lov_return_value=>'nb-no'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699016650282180026.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Norv\00E9gien (Bokmal) (no)')
,p_lov_return_value=>'no'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699017069718180027.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Norv\00E9gien (Nynorsk) (nn-no)')
,p_lov_return_value=>'nn-no'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699017459853180027.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Oriya (or)'
,p_lov_return_value=>'or'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699017804003180027.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Polonais (pl)'
,p_lov_return_value=>'pl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699018200480180027.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Portugais (Br\00E9sil) (pt-br)')
,p_lov_return_value=>'pt-br'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699018615797180028.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Portugais (Portugal) (pt)'
,p_lov_return_value=>'pt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699019033109180028.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Pendjabi (pa)'
,p_lov_return_value=>'pa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699019406601180028.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Roumain (ro)'
,p_lov_return_value=>'ro'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699019809056180028.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Russe (ru)'
,p_lov_return_value=>'ru'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699020294400180029.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Russe (Moldova) (ru-md)'
,p_lov_return_value=>'ru-md'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699020615658180029.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Serbe (sr)'
,p_lov_return_value=>'sr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699021086498180029.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Slovaque (sk)'
,p_lov_return_value=>'sk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699021470020180029.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Slov\00E8ne (sl)')
,p_lov_return_value=>'sl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699021856577180029.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Argentine) (es-ar)'
,p_lov_return_value=>'es-ar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699022283486180030.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Bolivie) (es-bo)'
,p_lov_return_value=>'es-bo'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699022650688180030.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Chili) (es-cl)'
,p_lov_return_value=>'es-cl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699023011653180030.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Colombie) (es-co)'
,p_lov_return_value=>'es-co'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699023499252180030.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Costa Rica) (es-cr)'
,p_lov_return_value=>'es-cr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699023824139180031.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espagnol (R\00E9publique dominicaine) (es-do)')
,p_lov_return_value=>'es-do'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699024228978180031.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Equateur) (es-ec)'
,p_lov_return_value=>'es-ec'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699024668580180031.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (El Salvador) (es-sv)'
,p_lov_return_value=>'es-sv'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699025057003180032.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Guatemala) (es-gt)'
,p_lov_return_value=>'es-gt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699025484196180032.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Honduras) (es-hn)'
,p_lov_return_value=>'es-hn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699025858584180032.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Mexique) (es-mx)'
,p_lov_return_value=>'es-mx'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699026243063180032.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Nicaragua) (es-ni)'
,p_lov_return_value=>'es-ni'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699026617351180033.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Panama) (es-pa)'
,p_lov_return_value=>'es-pa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699027088085180033.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Paraguay) (es-py)'
,p_lov_return_value=>'es-py'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699027417193180033.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espagnol (P\00E9rou) (es-pe)')
,p_lov_return_value=>'es-pe'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699027879740180033.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Porto Rico) (es-pr)'
,p_lov_return_value=>'es-pr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699028291585180034.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Traditionnel) (es)'
,p_lov_return_value=>'es'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699028663606180034.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Etats-Unis) (es-us)'
,p_lov_return_value=>'es-us'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699029093982180034.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Uruguay) (es-uy)'
,p_lov_return_value=>'es-uy'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699029477957180034.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagnol (Venezuela) (es-ve)'
,p_lov_return_value=>'es-ve'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699029836983180034.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Su\00E9dois (sv)')
,p_lov_return_value=>'sv'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699030291106180035.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Su\00E9dois (Finlande) (sv-fi)')
,p_lov_return_value=>'sv-fi'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699030638833180035.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tamoul (ta)'
,p_lov_return_value=>'ta'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699031057927180035.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('T\00E9lougou (te)')
,p_lov_return_value=>'te'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699031480481180035.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Tha\00EF (th)')
,p_lov_return_value=>'th'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699031847405180036.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Turc (tr)'
,p_lov_return_value=>'tr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699032254185180036.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ukrainien (uk)'
,p_lov_return_value=>'uk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699032603795180036.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ourdou (ur)'
,p_lov_return_value=>'ur'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699033025378180036.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ouzbek (uz)'
,p_lov_return_value=>'uz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699033427101180037.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Vietnamien (vi)'
,p_lov_return_value=>'vi'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699033825013180037.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Irlandais (ga)'
,p_lov_return_value=>'ga'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699034250948180037.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Gallois (cy)'
,p_lov_return_value=>'cy'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699034611796180037.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Swahili (sw)'
,p_lov_return_value=>'sw'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699035089043180037.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Albanais'
,p_lov_return_value=>'sq'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699035490973180038.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Arm\00E9nien')
,p_lov_return_value=>'hy'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_territories
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(788953931940024140.4052)
,p_lov_name=>'I18N_TERRITORIES'
,p_reference_id=>634612723768159258.4052
,p_lov_query=>'.'||wwv_flow_api.id(788953931940024140.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62829689894442518.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Azerba\00EFdjan')
,p_lov_return_value=>'AZERBAIJAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788980130880024177.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Alg\00E9rie')
,p_lov_return_value=>'ALGERIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788980318501024177.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Am\00E9rique')
,p_lov_return_value=>'AMERICA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788980524096024178.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Argentine'
,p_lov_return_value=>'ARGENTINA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788980702992024178.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Australie'
,p_lov_return_value=>'AUSTRALIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788980909354024178.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Autriche'
,p_lov_return_value=>'AUSTRIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788981104201024178.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Bahre\00EFn')
,p_lov_return_value=>'BAHRAIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788981314054024178.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bangladesh'
,p_lov_return_value=>'BANGLADESH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788981506304024178.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Belgique'
,p_lov_return_value=>'BELGIUM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788981731301024178.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Br\00E9sil')
,p_lov_return_value=>'BRAZIL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788981915417024179.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bulgarie'
,p_lov_return_value=>'BULGARIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788982112997024179.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Canada'
,p_lov_return_value=>'CANADA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788982320274024179.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Catalogne'
,p_lov_return_value=>'CATALONIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788982522979024182.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chili'
,p_lov_return_value=>'CHILE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788982702173024182.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chine'
,p_lov_return_value=>'CHINA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788982929275024182.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Colombie'
,p_lov_return_value=>'COLOMBIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788983110411024182.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Costa Rica'
,p_lov_return_value=>'COSTA RICA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788983318760024182.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Croatie'
,p_lov_return_value=>'CROATIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788983519697024182.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('R\00E9publique tch\00E8que')
,p_lov_return_value=>'CZECH REPUBLIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788983711192024182.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Danemark'
,p_lov_return_value=>'DENMARK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788983924185024183.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Equateur'
,p_lov_return_value=>'ECUADOR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788984103258024183.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Egypte'
,p_lov_return_value=>'EGYPT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788984330459024183.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'El Salvador'
,p_lov_return_value=>'EL SALVADOR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788984523371024183.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Estonie'
,p_lov_return_value=>'ESTONIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788984729453024183.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Finlande'
,p_lov_return_value=>'FINLAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788984900811024183.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'France'
,p_lov_return_value=>'FRANCE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788985104013024183.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Mac\00E9doine')
,p_lov_return_value=>'FYR MACEDONIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788985318698024183.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Allemagne'
,p_lov_return_value=>'GERMANY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788985511253024183.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Gr\00E8ce')
,p_lov_return_value=>'GREECE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788985730373024183.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Guatemala'
,p_lov_return_value=>'GUATEMALA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788985926875024183.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hong Kong'
,p_lov_return_value=>'HONG KONG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788986111750024187.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hongrie'
,p_lov_return_value=>'HUNGARY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788986314654024187.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Islande'
,p_lov_return_value=>'ICELAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788986518997024187.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Inde'
,p_lov_return_value=>'INDIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788986720030024188.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Indon\00E9sie')
,p_lov_return_value=>'INDONESIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788986901390024188.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Irak'
,p_lov_return_value=>'IRAQ'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788987101545024188.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Irlande'
,p_lov_return_value=>'IRELAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788987312858024188.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Isra\00EBl')
,p_lov_return_value=>'ISRAEL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788987521480024188.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italie'
,p_lov_return_value=>'ITALY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788987722466024188.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Japon'
,p_lov_return_value=>'JAPAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788987928268024188.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Jordanie'
,p_lov_return_value=>'JORDAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788988125327024189.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kazakhstan'
,p_lov_return_value=>'KAZAKHSTAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788988308841024189.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Cor\00E9e')
,p_lov_return_value=>'KOREA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788988501979024189.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Kowe\00EFt')
,p_lov_return_value=>'KUWAIT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788988722156024189.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lettonie'
,p_lov_return_value=>'LATVIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788988924887024189.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Liban'
,p_lov_return_value=>'LEBANON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788989122787024189.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Libye'
,p_lov_return_value=>'LIBYA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788989329016024189.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lituanie'
,p_lov_return_value=>'LITHUANIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788989524312024189.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Luxembourg'
,p_lov_return_value=>'LUXEMBOURG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788989725001024189.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Malaisie'
,p_lov_return_value=>'MALAYSIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788989925098024190.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Mexique'
,p_lov_return_value=>'MEXICO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788990125708024190.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Maroc'
,p_lov_return_value=>'MOROCCO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788990312872024190.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Nouvelle-Z\00E9lande')
,p_lov_return_value=>'NEW ZEALAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788990525052024190.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Nicaragua'
,p_lov_return_value=>'NICARAGUA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788990722751024190.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Norv\00E8ge')
,p_lov_return_value=>'NORWAY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788990918310024190.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Oman'
,p_lov_return_value=>'OMAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788991110230024191.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Panam\00E1')
,p_lov_return_value=>'PANAMA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788991326612024191.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('P\00E9rou')
,p_lov_return_value=>'PERU'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788991522861024191.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Philippines'
,p_lov_return_value=>'PHILIPPINES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788991728449024191.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Pologne'
,p_lov_return_value=>'POLAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788991914460024191.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Portugal'
,p_lov_return_value=>'PORTUGAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788992105229024191.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Porto Rico'
,p_lov_return_value=>'PUERTO RICO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788992322244024195.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Qatar'
,p_lov_return_value=>'QATAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788992529965024195.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Roumanie'
,p_lov_return_value=>'ROMANIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788992732431024195.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Russie'
,p_lov_return_value=>'RUSSIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788992929223024196.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabie saoudite'
,p_lov_return_value=>'SAUDI ARABIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788993122388024196.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Serbie et Mont\00E9n\00E9gro')
,p_lov_return_value=>'SERBIA AND MONTENEGRO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788993307197024196.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Singapour'
,p_lov_return_value=>'SINGAPORE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788993516987024196.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Slovaquie'
,p_lov_return_value=>'SLOVAKIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788993712467024196.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Slov\00E9nie')
,p_lov_return_value=>'SLOVENIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788993911470024196.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Afrique du Sud'
,p_lov_return_value=>'SOUTH AFRICA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788994103090024197.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espagne'
,p_lov_return_value=>'SPAIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788994318464024197.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Su\00E8de')
,p_lov_return_value=>'SWEDEN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788994513532024197.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Suisse'
,p_lov_return_value=>'SWITZERLAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788994702487024197.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Syrie'
,p_lov_return_value=>'SYRIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788994929127024197.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ta\00EFwan')
,p_lov_return_value=>'TAIWAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788995125228024197.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Tha\00EFlande')
,p_lov_return_value=>'THAILAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788995311129024198.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Pays-Bas'
,p_lov_return_value=>'THE NETHERLANDS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788995503628024198.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tunisie'
,p_lov_return_value=>'TUNISIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788995720383024198.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Turquie'
,p_lov_return_value=>'TURKEY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788995900122024198.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ukraine'
,p_lov_return_value=>'UKRAINE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788996102675024198.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Emirats arabes unis'
,p_lov_return_value=>'UNITED ARAB EMIRATES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788996309949024198.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Royaume-Uni'
,p_lov_return_value=>'UNITED KINGDOM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788996502604024198.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ouzb\00E9kistan')
,p_lov_return_value=>'UZBEKISTAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788996713482024199.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Venezuela'
,p_lov_return_value=>'VENEZUELA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788996911281024199.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Vi\00EAt Nam')
,p_lov_return_value=>'VIETNAM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788997123524024199.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Y\00E9men')
,p_lov_return_value=>'YEMEN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_notify_interval
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(274103227902682659.4052)
,p_lov_name=>'IR_NOTIFY_INTERVAL'
,p_lov_query=>'.'||wwv_flow_api.id(274103227902682659.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(274103521636682659.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Quotidien'
,p_lov_return_value=>'D'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(274103811250682659.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Hebdomadaire'
,p_lov_return_value=>'W'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(274104111453682659.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Mensuel'
,p_lov_return_value=>'M'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_notify_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(294656516286709966.4052)
,p_lov_name=>'IR_NOTIFY_STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(294656516286709966.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(294656824018709967.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Soumis'
,p_lov_return_value=>'SUBMITTED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(294657122464709967.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Envoy\00E9')
,p_lov_return_value=>'SENT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(294657432339709967.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Erreur'
,p_lov_return_value=>'ERROR'
);
end;
/
prompt --application/shared_components/user_interface/lovs/languages_installed
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(502998721971236943.4052)
,p_lov_name=>'LANGUAGES_INSTALLED'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lang_name, flow_language from ',
'(select (select max( translated_lang_name) from wwv_flow_languages l where l.lang_id = f.flow_language) lang_name, flow_language',
'  from wwv_flows f',
' where id = 4411',
'   and security_group_id = 10',
' union',
' select (select max(translated_lang_name) from wwv_flow_languages l where l.lang_id = f.flow_language) lang_name, flow_language',
'   from wwv_flows f',
'  where security_group_id = 10',
'    and id in ',
'      ( select translation_flow_id',
'          from wwv_flow_language_map',
'         where security_group_id = 10',
'           and primary_language_flow_id = 4411)',
'  order by 1)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ldap_ssl_lov
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(795103713402787381.4052)
,p_lov_name=>'LDAP_SSL_LOV'
,p_reference_id=>487674627120619297.4052
,p_lov_query=>'.'||wwv_flow_api.id(795103713402787381.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(795105028361787385.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'SSL'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(795105207558787386.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'SSL avec authentification'
,p_lov_return_value=>'A'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(795105423579787386.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Non SSL'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_workspaces
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(159434915946336703.4052)
,p_lov_name=>'LIST.WORKSPACES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name d, short_name v',
'  from wwv_flow_companies',
' where (provisioning_company_id not in (0,10,11,12))',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_all_companies
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(41061332989455513.4052)
,p_lov_name=>'LIST_ALL_COMPANIES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'wwv_flow_lang.system_message(''F4050_SHOW_ALL_WORKSPACES'')||',
''' -'' d, 0 r from dual union all',
'select short_name||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id > 0',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_all_companies_escaped
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(33198215215866564.4052)
,p_lov_name=>'LIST_ALL_COMPANIES_ESCAPED'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'wwv_flow_lang.system_message(''F4050_SHOW_ALL_WORKSPACES'')||',
''' -'' d, 0 r from dual union all',
'select wwv_flow_escape.html(short_name)||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id > 0',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_all_companies_no_null_option
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(71982116125334375.4052)
,p_lov_name=>'LIST_ALL_COMPANIES_NO_NULL_OPTION'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id > 0',
'  and  provisioning_company_id != 11',
'  and  provisioning_company_id != 12',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_developer_workspaces
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(245468425022265187.4052)
,p_lov_name=>'LIST_DEVELOPER_WORKSPACES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'wwv_flow_lang.system_message(''F4050_SHOW_ALL_WORKSPACES'')||',
''' -'' d, 0 r from dual union all',
'select short_name||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id not in (0,10,11)',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_developer_workspaces_no_null_option
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(201412507067809360.4052)
,p_lov_name=>'LIST_DEVELOPER_WORKSPACES_NO_NULL_OPTION'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id not in (0,10,11, 12)',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_flow_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(85746300886317667.4052)
,p_lov_name=>'LIST_FLOW_STATUS'
,p_reference_id=>634347472712995.4052
,p_lov_query=>'.'||wwv_flow_api.id(85746300886317667.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(741162715995290705.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Disponible'
,p_lov_return_value=>'AVAILABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(741163096116290707.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Disponible avec la barre d''outils de d\00E9veloppeur')
,p_lov_return_value=>'AVAILABLE_W_EDIT_LINK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(741163344386290707.4052)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Accessible aux d\00E9veloppeurs uniquement')
,p_lov_return_value=>'DEVELOPERS_ONLY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(741163691224290707.4052)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Acc\00E8s restreint')
,p_lov_return_value=>'RESTRICTED_ACCESS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(741163965010290707.4052)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Non disponible'
,p_lov_return_value=>'UNAVAILABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(741164248206290708.4052)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>unistr('Non disponible (statut affich\00E9 avec PL/SQL)')
,p_lov_return_value=>'UNAVAILABLE_PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(741164577629290708.4052)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>unistr('Non disponible (r\00E9acheminer vers une URL)')
,p_lov_return_value=>'UNAVAILABLE_URL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/log_names
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(220529904687804674.4052)
,p_lov_name=>'LOG NAMES'
,p_lov_query=>'.'||wwv_flow_api.id(220529904687804674.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(220530223169804674.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Journal d''acc\00E8s')
,p_lov_return_value=>'ACCESS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(220530529937804674.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Journal des activit\00E9s')
,p_lov_return_value=>'ACTIVITY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(220530813867804675.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Messages de d\00E9bogage')
,p_lov_return_value=>'DEBUG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(220531102895804675.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Journal des clics externes'
,p_lov_return_value=>'CLICKTHRU'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(642230510529647347.4052)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Service Web'
,p_lov_return_value=>'WEBSERVICE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1408552545940823.4052)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'Synchronisation REST'
,p_lov_return_value=>'WEBSOURCESYNC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1403678011163749.4052)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>'Automatisation'
,p_lov_return_value=>'AUTOMATION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/login_status_codes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(46388624571234535.4052)
,p_lov_name=>'LOGIN STATUS CODES'
,p_lov_query=>'.'||wwv_flow_api.id(46388624571234535.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(46388926156234544.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Authentification normale, r\00E9ussie')
,p_lov_return_value=>'0'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(46389114667234544.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Nom utilisateur inconnu'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(46389305475234544.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Compte verrouill\00E9')
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(46389507635234544.4052)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Compte expir\00E9')
,p_lov_return_value=>'3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(46389702262234544.4052)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Mot de passe incorrect'
,p_lov_return_value=>'4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(46389924389234544.4052)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Premi\00E8re utilisation du mot de passe')
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(46390117950234544.4052)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('Nombre maximal de tentatives de connexion d\00E9pass\00E9')
,p_lov_return_value=>'6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(46390320270234545.4052)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Erreur interne inconnue'
,p_lov_return_value=>'7'
);
end;
/
prompt --application/shared_components/user_interface/lovs/login_throttle_methods
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(244019724554013154.4052)
,p_lov_name=>'LOGIN THROTTLE METHODS'
,p_lov_query=>'.'||wwv_flow_api.id(244019724554013154.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244020024066013155.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Nom utilisateur et adresse IP client'
,p_lov_return_value=>'USERNAME_IP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244020707400018951.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Nom utilisateur'
,p_lov_return_value=>'USERNAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244021027221018951.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Adresse IP du client'
,p_lov_return_value=>'IP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(245893700052641142.4052)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Nom utilisateur ou adresse IP client'
,p_lov_return_value=>'USERNAME:IP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/login_message
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(138589612463299624.4052)
,p_lov_name=>'LOGIN_MESSAGE'
,p_lov_query=>'.'||wwv_flow_api.id(138589612463299624.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(138589828636299629.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Aucun message'
,p_lov_return_value=>'NONE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(138590030175299632.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Message personnalis\00E9')
,p_lov_return_value=>'CUSTOM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/login_remember_username
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(117703408573204417.4052)
,p_lov_name=>'LOGIN_REMEMBER_USERNAME'
,p_lov_query=>'.'||wwv_flow_api.id(117703408573204417.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(117703802213204418.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('M\00E9moriser le nom utilisateur')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/logo_attributes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(361197800293344621.4052)
,p_lov_name=>'LOGO ATTRIBUTES'
,p_reference_id=>461376702019738964.4052
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''BLACK_TEXT'') d, ''style="font-family:Arial; color:#000000; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''BLUE_TEXT'') d, ''style="font-family:Arial; color:#004C66; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''WHITE_TEXT'') d, ''style="font-family:Arial; color:#FFFFFF; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual',
'union all',
'select wwv_flow_lang.system_message(''GRAY_TEXT'') d, ''style="font-family:Arial; color:#303030; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''image_attributes'') d, ''alt="Application" title="Application"'' r from dual '))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_a
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87504531900192794.4052)
,p_lov_name=>'MAX_ROWS_A'
,p_lov_query=>'.'||wwv_flow_api.id(87504531900192794.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87504713683192797.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87504927403192799.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87505127136192799.4052)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87505325056192799.4052)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'25'
,p_lov_return_value=>'25'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87505511346192800.4052)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'30'
,p_lov_return_value=>'30'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87505729136192800.4052)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87505932223192800.4052)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87506102365192800.4052)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'200'
,p_lov_return_value=>'200'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87506312795192801.4052)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87506502410192801.4052)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87506703570192801.4052)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87506912687192801.4052)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'10000'
,p_lov_return_value=>'10000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_b
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87717417968152000.4052)
,p_lov_name=>'MAX_ROWS_B'
,p_lov_query=>'.'||wwv_flow_api.id(87717417968152000.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87717608742152001.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'1'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87717807507152001.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87718000141152003.4052)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87718209200152003.4052)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87718403676152003.4052)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87718622762152003.4052)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'30'
,p_lov_return_value=>'30'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87718817778152004.4052)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87719020177152004.4052)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87719230831152004.4052)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'200'
,p_lov_return_value=>'200'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87719426010152005.4052)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87719614892152005.4052)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87719804628152005.4052)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'2000'
,p_lov_return_value=>'2000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_c
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87727319971247226.4052)
,p_lov_name=>'MAX_ROWS_C'
,p_lov_query=>'.'||wwv_flow_api.id(87727319971247226.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87727500041247227.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'1'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87727716571247227.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87727920372247227.4052)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87728108070247227.4052)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87728307878247228.4052)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87728503519247228.4052)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'25'
,p_lov_return_value=>'25'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87728723800247228.4052)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87728931351247228.4052)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87729117092247229.4052)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'200'
,p_lov_return_value=>'200'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87729303121247229.4052)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87729526911247229.4052)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87729730366247229.4052)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_d
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87730331399250507.4052)
,p_lov_name=>'MAX_ROWS_D'
,p_lov_query=>'.'||wwv_flow_api.id(87730331399250507.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87730525692250508.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'1'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87730714234250508.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87730921624250509.4052)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87731129062250509.4052)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87731321929250509.4052)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87731521610250509.4052)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'25'
,p_lov_return_value=>'25'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87731715300250510.4052)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'30'
,p_lov_return_value=>'30'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87731919898250510.4052)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87732124808250510.4052)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87732326765250510.4052)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87732513594250511.4052)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_e
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87733213522254832.4052)
,p_lov_name=>'MAX_ROWS_E'
,p_lov_query=>'.'||wwv_flow_api.id(87733213522254832.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87733416419254833.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'1'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87733622113254833.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87733822263254833.4052)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87734024639254833.4052)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87734223358254834.4052)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87734413410254834.4052)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'25'
,p_lov_return_value=>'25'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87734626070254834.4052)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'30'
,p_lov_return_value=>'30'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87734809939254834.4052)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87735015995254834.4052)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87735225800254835.4052)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87735423051254835.4052)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87735614522254835.4052)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'10000'
,p_lov_return_value=>'10000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_f
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87736221141257059.4052)
,p_lov_name=>'MAX_ROWS_F'
,p_lov_query=>'.'||wwv_flow_api.id(87736221141257059.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87736411674257059.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'2'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87736631478257060.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87736801252257060.4052)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87737027711257060.4052)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87737221803257060.4052)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87737414548257062.4052)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'30'
,p_lov_return_value=>'30'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87737609481257062.4052)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87737813226257062.4052)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87738032062257063.4052)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87738230641257063.4052)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_g
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87738929453259457.4052)
,p_lov_name=>'MAX_ROWS_G'
,p_lov_query=>'.'||wwv_flow_api.id(87738929453259457.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87739106498259457.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'1'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87739329779259460.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87739525994259460.4052)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87739719147259460.4052)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87739911170259460.4052)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87740103875259461.4052)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'25'
,p_lov_return_value=>'25'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87740303300259461.4052)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87740516812259461.4052)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87740731715259461.4052)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'200'
,p_lov_return_value=>'200'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87740924006259462.4052)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87741116404259462.4052)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87741300621259463.4052)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/max_rows_h
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87745327899296842.4052)
,p_lov_name=>'MAX_ROWS_H'
,p_lov_query=>'.'||wwv_flow_api.id(87745327899296842.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87745524146296844.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'1'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87745725148296845.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87745929261296845.4052)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87746105830296845.4052)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87746317502296845.4052)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87746523232296846.4052)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87746716198296846.4052)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87746907159296846.4052)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87747109934296846.4052)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87747307992296846.4052)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/new_workspace_request_storage_sizes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(388034003778139782.4052)
,p_lov_name=>'NEW WORKSPACE REQUEST STORAGE SIZES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select req_size d, req_size r',
'  from wwv_flow_workspace_req_size',
' where request_type = ''C''',
'order by to_number(req_size)',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/new_or_existing
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87820927180096887.4052)
,p_lov_name=>'NEW_OR_EXISTING'
,p_lov_query=>'.'||wwv_flow_api.id(87820927180096887.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87821100243096888.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Existant'
,p_lov_return_value=>'Existing'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87821304136096888.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Nouveau'
,p_lov_return_value=>'New'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p104_report_row_per_page
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(786397812796590139.4052)
,p_lov_name=>'P104_Report Row Per Page'
,p_lov_query=>'.'||wwv_flow_api.id(786397812796590139.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(786398123613590140.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(786398320925590141.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(786398521498590141.4052)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(786398729631590141.4052)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'30'
,p_lov_return_value=>'30'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(786398928953590141.4052)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(786399112218590141.4052)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(786399324445590141.4052)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'200'
,p_lov_return_value=>'200'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(786399515204590142.4052)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(786399715492590142.4052)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(786399932299590142.4052)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p131_smtp_tls_mode
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(44180513498106696.4052)
,p_lov_name=>'P131_SMTP_TLS_MODE'
,p_lov_query=>'.'||wwv_flow_api.id(44180513498106696.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44180826675106699.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Oui'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44181001563106699.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Une fois la connexion \00E9tablie')
,p_lov_return_value=>'STARTTLS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44181213027106699.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Non'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p16_printsvr_protocol
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(41576101209699161.4052)
,p_lov_name=>'P16.PRINTSVR.PROTOCOL'
,p_lov_query=>'.'||wwv_flow_api.id(41576101209699161.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41576425139699162.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'HTTP'
,p_lov_return_value=>'http'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41576620353699162.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'HTTPS'
,p_lov_return_value=>'https'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p280_env_banner_colors
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2805702200728881.4052)
,p_lov_name=>'P280_ENV_BANNER_COLORS'
,p_lov_query=>'.'||wwv_flow_api.id(2805702200728881.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2806011133728888.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Accentuation 1'
,p_lov_return_value=>'accent-1'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--1" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2806470563728890.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Accentuation 2'
,p_lov_return_value=>'accent-2'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--2" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2806848354728890.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Accentuation 3'
,p_lov_return_value=>'accent-3'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--3" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2807223525728890.4052)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Accentuation 4'
,p_lov_return_value=>'accent-4'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--4" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2807684975728891.4052)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Accentuation 5'
,p_lov_return_value=>'accent-5'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--5" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2808012563728891.4052)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Accentuation 6'
,p_lov_return_value=>'accent-6'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--6" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2808447823728891.4052)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Accentuation 7'
,p_lov_return_value=>'accent-7'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--7" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2808838195728892.4052)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Accentuation 8'
,p_lov_return_value=>'accent-8'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--8" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1715129969025965.4052)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Accentuation 9'
,p_lov_return_value=>'accent-9'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--9" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1715437229025965.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Accentuation 10'
,p_lov_return_value=>'accent-10'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--10" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1715896618025965.4052)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Accentuation 11'
,p_lov_return_value=>'accent-11'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--11" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1716207338025965.4052)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Accentuation 12'
,p_lov_return_value=>'accent-12'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--12" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1716639869025966.4052)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Accentuation 13'
,p_lov_return_value=>'accent-13'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--13" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1717018496025966.4052)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Accentuation 14'
,p_lov_return_value=>'accent-14'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--14" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1717463920025966.4052)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Accentuation 15'
,p_lov_return_value=>'accent-15'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--15" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1717876517025966.4052)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'Accentuation 16'
,p_lov_return_value=>'accent-16'
,p_lov_template=>'<span class="a-EnvBanner-color a-EnvBanner-color--16" aria-label="#DISPLAY_VALUE#"></span>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p280_env_banner_pos
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(147094582352565991.4052)
,p_lov_name=>'P280_ENV_BANNER_POS'
,p_lov_query=>'.'||wwv_flow_api.id(147094582352565991.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(147094804613565991.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Gauche'
,p_lov_return_value=>'LEFT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(147095201995565991.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Haut'
,p_lov_return_value=>'TOP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p40_recent_time
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(858080230485699950.4052)
,p_lov_name=>'P40_RECENT_TIME'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, to_char(t) t',
'from (',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 60 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5*60 t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15*60 t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30*60 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 3600 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 2*3600  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3*3600  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4*3600  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6*3600 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8*3600 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12*3600 t from dual union all',
'select ''18 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 18*3600 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1*24*60*60 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2*24*60*60 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3*24*60*60 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4*24*60*60 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5*24*60*60 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 6*24*60*60 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7*24*60*60 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14*24*60*60 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28*24*60*60 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365*24*60*60 t from dual order by 2',
') q'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_view_mode
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(131020216973707367.4052)
,p_lov_name=>'PAGE VIEW MODE'
,p_lov_query=>'.'||wwv_flow_api.id(131020216973707367.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(131020902774707369.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page dynamique'
,p_lov_return_value=>'D'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(131020730367707369.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Traitement de page'
,p_lov_return_value=>'A'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(131020524068707368.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Page partielle'
,p_lov_return_value=>'P'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(131023120221717730.4052)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Cache cr\00E9\00E9')
,p_lov_return_value=>'C'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(131023727840719977.4052)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Page en m\00E9moire cache')
,p_lov_return_value=>'R'
);
end;
/
prompt --application/shared_components/user_interface/lovs/password_generation
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(203295405272404658.4052)
,p_lov_name=>'PASSWORD GENERATION'
,p_lov_query=>'.'||wwv_flow_api.id(203295405272404658.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(203295628313404659.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('G\00E9n\00E9r\00E9 de fa\00E7on al\00E9atoire')
,p_lov_return_value=>'RANDOM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(203295931728404663.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Valeur indiqu\00E9e fixe')
,p_lov_return_value=>'FIXED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/productivity_and_sample_application_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(255033227550969526.4052)
,p_lov_name=>'PRODUCTIVITY AND SAMPLE APPLICATION STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(255033227550969526.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(255033522048969526.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Disponible'
,p_lov_return_value=>'AVAILABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(255033800732969526.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Masqu\00E9')
,p_lov_return_value=>'HIDDEN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(255034107216969526.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Bient\00F4t disponible')
,p_lov_return_value=>'COMING_SOON'
);
end;
/
prompt --application/shared_components/user_interface/lovs/project_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87715313766122404.4052)
,p_lov_name=>'PROJECT.STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(87715313766122404.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87715507041122405.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Refus\00E9')
,p_lov_return_value=>'DECLINED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87715706617122406.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Demand\00E9')
,p_lov_return_value=>'REQUESTED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87715911749122406.4052)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Interrompu'
,p_lov_return_value=>'TERMINATED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/provisioning_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87819917137094037.4052)
,p_lov_name=>'PROVISIONING.STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(87819917137094037.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87820106497094037.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Manuel : un administrateur doit cr\00E9er manuellement chaque espace de travail')
,p_lov_return_value=>'MANUAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87820317112094038.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Demande - Lien pr\00E9sent dans la page de connexion permettant aux utilisateurs de demander des espaces de travail')
,p_lov_return_value=>'4700'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27774028242361017.4052)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Demande : lien affich\00E9 sur la page de connexion. Les demandes doivent \00EAtre approuv\00E9es par l''administrateur.')
,p_lov_return_value=>'EMAIL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5680416359052583.4052)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Automatique : lien affich\00E9 sur la page de connexion. Les demandes sont approuv\00E9es automatiquement.')
,p_lov_return_value=>'AUTO'
);
end;
/
prompt --application/shared_components/user_interface/lovs/public_theme_app_selector
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(138968902616481833.4052)
,p_lov_name=>'PUBLIC.THEME.APP.SELECTOR'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name d, id v',
'  from WWV_FLOWS',
' where security_group_id = :P47_WORKSPACE',
'   and security_group_id not in (0,10,11)',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/public_app_templates_regiontemps
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(346773209253201282.4052)
,p_lov_name=>'PUBLIC_APP_TEMPLATES_REGIONTEMPS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''NO_TEMPLATE'') d, 0 r from dual union all',
'select t.d, t.r from (',
'select wwv_flow_escape.html(page_plug_template_name) d, id r',
'from   wwv_flow_page_plug_templates',
'where  flow_id = :P125_ID and',
'       (:P125_THEME_ID is null or theme_id = :P125_THEME_ID)',
'order  by upper(page_plug_template_name) ) t'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/public_app_temp_defaults
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(340605730286750195.4052)
,p_lov_name=>'PUBLIC_APP_TEMP_DEFAULTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name, id',
'from wwv_flow_templates',
'where flow_id = :P125_ID',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/public_app_temp_fielddefs
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(340711321937795147.4052)
,p_lov_name=>'PUBLIC_APP_TEMP_FIELDDEFS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(template_name) d, id',
'from   wwv_flow_field_templates',
'where flow_id = :P125_ID',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/purge_days_list
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(615512721869254091.4052)
,p_lov_name=>'PURGE.DAYS_LIST'
,p_lov_query=>'.'||wwv_flow_api.id(615512721869254091.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615512924322254091.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'1 jour'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615513111695254091.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'2 jours'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615513323497254091.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'3 jours'
,p_lov_return_value=>'3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615513531494254114.4052)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'4 jours'
,p_lov_return_value=>'4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615513714171254114.4052)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'5 jours'
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615513926201254115.4052)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'6 jours '
,p_lov_return_value=>'6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615514125167254115.4052)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'7 jours'
,p_lov_return_value=>'7'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615514314553254115.4052)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'14 jours'
,p_lov_return_value=>'14'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615514527430254115.4052)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'28 jours'
,p_lov_return_value=>'28'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615514712006254115.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'180 jours'
,p_lov_return_value=>'180'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615514906451254115.4052)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'365 jours'
,p_lov_return_value=>'365'
);
end;
/
prompt --application/shared_components/user_interface/lovs/purge_log_codes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(615495005199220912.4052)
,p_lov_name=>'PURGE.LOG_CODES'
,p_lov_query=>'.'||wwv_flow_api.id(615495005199220912.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615495230385220912.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ajout\00E9 \00E0 la liste de purge')
,p_lov_return_value=>'NEW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615495413353220912.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Enlev\00E9 de la liste de purge')
,p_lov_return_value=>'DELETE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615495630761220912.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Courriel envoy\00E9')
,p_lov_return_value=>'EMAIL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615495829822220912.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ne pas purger'
,p_lov_return_value=>'RESPONSE_RETAIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615496013807220912.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'OK pour la purge'
,p_lov_return_value=>'RESPONSE_PURGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615496220933220912.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('D\00E9plac\00E9 vers la liste de purge')
,p_lov_return_value=>'MOVED_TO_NEW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615496401451220912.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Courriel termin\00E9')
,p_lov_return_value=>'EMAIL_COMPLETE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615496630482220913.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Courriel de rappel termin\00E9')
,p_lov_return_value=>'REMINDER_EMAIL_COMPLETE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615496832221220915.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Commencer la purge de l''espace de travail'
,p_lov_return_value=>'BEGIN_PURGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615497016409220915.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Sch\00E9ma d''espace de travail \00E9valu\00E9')
,p_lov_return_value=>'PURGE_SCHEMA_EVAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615497230209220915.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Tablespace d''espace de travail \00E9valu\00E9')
,p_lov_return_value=>'PURGE_TABLESPACE_EVAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615497410161220915.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Purge termin\00E9e')
,p_lov_return_value=>'PURGE_COMPLETE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615497604761220915.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Erreur lors de la suppression de l''utilisateur'
,p_lov_return_value=>'ERROR_DROP_USER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615497814829220915.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Erreur lors de la suppression du tablespace'
,p_lov_return_value=>'ERROR_DROP_TABLESPACE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615498029973220915.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Commencer la suppression de l''utilisateur de base de donn\00E9es')
,p_lov_return_value=>'BEGIN_DROP_USER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615500216627224175.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Terminer la suppression de l''utilisateur'
,p_lov_return_value=>'END_DROP_USER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615500722515225866.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Commencer la suppression du tablespace'
,p_lov_return_value=>'BEGIN_DROP_TABLESPACE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615504427017227199.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Terminer la suppression du tablespace'
,p_lov_return_value=>'END_DROP_TABLESPACE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615504631865228563.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Commencer la suppression de l''espace de travail'
,p_lov_return_value=>'BEGIN_DELETE_WORKSPACE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615504903599229872.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Terminer la suppression de l''espace de travail'
,p_lov_return_value=>'END_DELETE_WORKSPACE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615505608101231192.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Erreur lors de la suppression de l''espace de travail'
,p_lov_return_value=>'ERROR_DELETE_WORKSPACE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/purge_workspace_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(615479015710157661.4052)
,p_lov_name=>'PURGE.WORKSPACE_STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(615479015710157661.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615479202843157669.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Ajout\00E9 \00E0 la liste de purge')
,p_lov_return_value=>'NEW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615479403481157676.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('A purger, courriel envoy\00E9')
,p_lov_return_value=>'STAGE1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615479623663157676.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('A purger, courriel de rappel envoy\00E9')
,p_lov_return_value=>'STAGE2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615479804138157676.4052)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Conserv\00E9')
,p_lov_return_value=>'RETAIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615480031669157676.4052)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'En cours de purge'
,p_lov_return_value=>'PURGING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615480218013157676.4052)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Purg\00E9')
,p_lov_return_value=>'PURGED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/recent_time
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88332700235936298.4052)
,p_lov_name=>'RECENT_TIME'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/recent_time_archive
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(879932532606742210.4052)
,p_lov_name=>'RECENT_TIME_ARCHIVE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 30 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 186 t from dual union all',
'select ''9 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 279 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/rejoin_existing_sessions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(492748357556507488.4052)
,p_lov_name=>'REJOIN_EXISTING_SESSIONS'
,p_lov_query=>'.'||wwv_flow_api.id(492748357556507488.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(492748670516507489.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('D\00E9sactiv\00E9')
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(492748976232507489.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Activ\00E9 pour les sessions publiques')
,p_lov_return_value=>'P'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(492749211223507489.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Activ\00E9 pour toutes les sessions')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/reporting_period
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(180726228364333770.4052)
,p_lov_name=>'REPORTING PERIOD'
,p_lov_query=>'.'||wwv_flow_api.id(180726228364333770.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(180726414372333772.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Jour'
,p_lov_return_value=>'D'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(180726626461333773.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Semaine'
,p_lov_return_value=>'W'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(180726828392333773.4052)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>'2 semaines'
,p_lov_return_value=>'2W'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(180727012432333773.4052)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Mois'
,p_lov_return_value=>'M'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(180727220433333773.4052)
,p_lov_disp_sequence=>31
,p_lov_disp_value=>'2 mois'
,p_lov_return_value=>'2M'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(180727427905333773.4052)
,p_lov_disp_sequence=>31.5
,p_lov_disp_value=>'3 mois'
,p_lov_return_value=>'3M'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(180727608631333773.4052)
,p_lov_disp_sequence=>32
,p_lov_disp_value=>'6 mois'
,p_lov_return_value=>'6M'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(180727828386333774.4052)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Ann\00E9e')
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(180728029949333774.4052)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'2 ans'
,p_lov_return_value=>'2Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(180728214594333774.4052)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'5 ans'
,p_lov_return_value=>'5Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/request_status_show
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87760131282243533.4052)
,p_lov_name=>'REQUEST.STATUS.SHOW'
,p_lov_query=>'.'||wwv_flow_api.id(87760131282243533.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87760332362243533.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tout'
,p_lov_return_value=>'All'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87760505501243533.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Approuv\00E9')
,p_lov_return_value=>'Approved'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87760729237243534.4052)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Refus\00E9')
,p_lov_return_value=>'Denied'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87760900898243534.4052)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Ouvert'
,p_lov_return_value=>'Open'
);
end;
/
prompt --application/shared_components/user_interface/lovs/require_https
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(403484377450328143.4052)
,p_lov_name=>'REQUIRE_HTTPS'
,p_lov_query=>'.'||wwv_flow_api.id(403484377450328143.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(403484695431328151.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Toujours'
,p_lov_return_value=>'A'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(403484928622328157.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Pour le d\00E9veloppement et l''administration')
,p_lov_return_value=>'I'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(403485262310328157.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Pour une application sp\00E9cifique')
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/reset_password_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(25472316973371525.4052)
,p_lov_name=>'RESET PASSWORD TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(25472316973371525.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25472613858371526.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('G\00E9n\00E9r\00E9 de fa\00E7on al\00E9atoire')
,p_lov_return_value=>'G'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25472824725371527.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Fourni'
,p_lov_return_value=>'D'
);
end;
/
prompt --application/shared_components/user_interface/lovs/resource_consumer_groups_non_system
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(13874928060276355.4052)
,p_lov_name=>'RESOURCE CONSUMER GROUPS (NON  SYSTEM)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select consumer_group d, consumer_group r',
'  from sys.dba_rsrc_consumer_groups',
' where consumer_group not like ''ORA$%''',
'   and consumer_group <> ''SYS_GROUP''',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/scheduled_job_state
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1352009278507904884.4052)
,p_lov_name=>'SCHEDULED_JOB_STATE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    select wwv_flow_lang.system_message(''F4050.CHAIN_STALLED'') d,''CHAIN_STALLED'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.SUCCEEDED'') d,''SUCCEEDED'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.RETRY SCHEDULED'') d,''RETRY SCHEDULED'' r from dual where :APP_PAGE_ID <> 26',
'    union',
'    select wwv_flow_lang.system_message(''F4050.REMOTE'') d, ''REMOTE'' r  from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.FAILED'') d, ''FAILED'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.BROKEN'') d,''BROKEN'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.COMPLETED'') d, ''COMPLETED'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.RUNNING'') d, ''RUNNING'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.DISABLED'') d, ''DISABLED'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.SCHEDULED'') d, ''SCHEDULED'' r from dual'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/seconds
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(15314811390892155.4052)
,p_lov_name=>'SECONDS'
,p_lov_query=>'.'||wwv_flow_api.id(15314811390892155.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15315103445892221.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'1 minute'
,p_lov_return_value=>'60'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15315321205892225.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'5 minutes'
,p_lov_return_value=>'300'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15315517639892226.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'10 minutes'
,p_lov_return_value=>'600'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15315725224892226.4052)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'30 minutes'
,p_lov_return_value=>'1800'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15315913935892226.4052)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'1 heure'
,p_lov_return_value=>'3600'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15316108518892226.4052)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'2 heures'
,p_lov_return_value=>'7200'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15316322196892226.4052)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'5 heures'
,p_lov_return_value=>'18000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15316515182892228.4052)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'10 heures'
,p_lov_return_value=>'36000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/seconds_small
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1501535454230180.4052)
,p_lov_name=>'SECONDS_SMALL'
,p_lov_query=>'.'||wwv_flow_api.id(1501535454230180.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1501847119230194.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'1 minute'
,p_lov_return_value=>'60'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1502254509230197.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'2 minutes'
,p_lov_return_value=>'120'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1502672891230197.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'3 minutes'
,p_lov_return_value=>'180'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1503034047230197.4052)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'4 minutes'
,p_lov_return_value=>'240'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1503448296230198.4052)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'5 minutes'
,p_lov_return_value=>'300'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1503832865230198.4052)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'10 minutes'
,p_lov_return_value=>'600'
);
end;
/
prompt --application/shared_components/user_interface/lovs/service_request_name
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(110368323210290856.4052)
,p_lov_name=>'SERVICE.REQUEST.NAME'
,p_lov_query=>'.'||wwv_flow_api.id(110368323210290856.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(110368501503290856.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Nouveau sch\00E9ma')
,p_lov_return_value=>'NEW_SCHEMA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(110368723358290857.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Enlever un espace de travail'
,p_lov_return_value=>'REMOVE_EXISTING_SERVICE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(110368924348290857.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Enlever un sch\00E9ma')
,p_lov_return_value=>'REMOVE_EXISTING_SCHEMA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(110369132258290857.4052)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Demander de l''espace de stockage suppl\00E9mentaire')
,p_lov_return_value=>'CHANGE_DB_SIZE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/service_request_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87755726864223308.4052)
,p_lov_name=>'SERVICE.REQUEST.STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(87755726864223308.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87755910389223309.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Approuv\00E9')
,p_lov_return_value=>'APPROVED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87756108879223309.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Refus\00E9')
,p_lov_return_value=>'DECLINED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87756328524223309.4052)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('En cours d''ex\00E9cution')
,p_lov_return_value=>'IN_PROGRESS'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
,p_lov_disp_cond=>'26'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87756529293223310.4052)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Demand\00E9')
,p_lov_return_value=>'REQUESTED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87756716926223310.4052)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Interrompu'
,p_lov_return_value=>'TERMINATED'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
,p_lov_disp_cond=>'7'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22138608522000517.4052)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>unistr('Accept\00E9')
,p_lov_return_value=>'ACCEPTED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/service_request_status_002
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(316820619150159698.4052)
,p_lov_name=>'SERVICE_REQUEST_STATUS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    select wwv_flow_lang.system_message(''F4050.APPROVED'') d,''APPROVED'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.DECLINED'') d,''DECLINED'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.IN_PROGRESS'') d,''IN_PROGRESS'' r from dual where :APP_PAGE_ID <> 26',
'    union',
'    select wwv_flow_lang.system_message(''F4050.REQUESTED'') d, ''REQUESTED'' r  from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.TERMINATED'') d, ''TERMINATED'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.ACCEPTED_MSG'') d,''ACCEPTED'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.TERMINATION_IN_PROGRESS'') d, ''TERMINATION_IN_PROGRESS'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.TERMINATION_IN_PROGRESS'') d, ''TERMINATION_IN_PROGRESS2'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.TERMINATION_IN_PROGRESS'') d, ''TERMINATION_IN_PROGRESS3'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.TERMINATION_IN_PROGRESS'') d, ''TERMINATION_IN_PROGRESS4'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.TERMINATION_IN_PROGRESS'') d, ''TERMINATION_IN_PROGRESS5'' r from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4050.TERMINATION_IN_PROGRESS'') d, ''TERMINATION_IN_PROGRESS6'' r from dual'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/site_admin_password_option
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(25698924524085246.4052)
,p_lov_name=>'SITE ADMIN PASSWORD OPTION'
,p_lov_query=>'.'||wwv_flow_api.id(25698924524085246.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(89831430148813773.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Utiliser la strat\00E9gie indiqu\00E9e dans Strat\00E9gie de mot de passe d''espace de travail')
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25699227500085250.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Utiliser la strat\00E9gie de mot de passe renforc\00E9 par d\00E9faut')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/task_display_location
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(75242612126455451.4052)
,p_lov_name=>'TASK_DISPLAY_LOCATION'
,p_lov_query=>'.'||wwv_flow_api.id(75242612126455451.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(75243106849455455.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Connexion \00E0 l''espace de travail')
,p_lov_return_value=>'WORKSPACE_LOGIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(75242903496455454.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Page d''accueil de l''espace de travail'
,p_lov_return_value=>'WORKSPACE_HOME'
);
end;
/
prompt --application/shared_components/user_interface/lovs/team_dev_fs_limit
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(689538645438591983.4052)
,p_lov_name=>'TEAM_DEV_FS_LIMIT'
,p_reference_id=>689579484876680828.4052
,p_lov_query=>'.'||wwv_flow_api.id(689538645438591983.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(689584332672694643.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5242880'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(689584683398694643.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10485760'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(689584997130694643.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15728640'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(689585237571694643.4052)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20971520'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(689585513830694643.4052)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'25'
,p_lov_return_value=>'26214400'
);
end;
/
prompt --application/shared_components/user_interface/lovs/time_intervals
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87720511660244788.4052)
,p_lov_name=>'TIME_INTERVALS'
,p_lov_query=>'.'||wwv_flow_api.id(87720511660244788.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87720705217244789.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'1'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87720918270244790.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'2'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87721128398244790.4052)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'3'
,p_lov_return_value=>'3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87721316635244790.4052)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'4'
,p_lov_return_value=>'4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87721518511244790.4052)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87721714192244790.4052)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'6'
,p_lov_return_value=>'6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87721929981244791.4052)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'7'
,p_lov_return_value=>'7'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87722127765244791.4052)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'8'
,p_lov_return_value=>'8'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87722317438244791.4052)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'9'
,p_lov_return_value=>'9'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87722509755244791.4052)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87722724680244792.4052)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'11'
,p_lov_return_value=>'11'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87722931920244792.4052)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'12'
,p_lov_return_value=>'12'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87723110878244792.4052)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'13'
,p_lov_return_value=>'13'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87723310283244792.4052)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'14'
,p_lov_return_value=>'14'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87723528574244793.4052)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87723715299244793.4052)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'16'
,p_lov_return_value=>'16'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87723913501244793.4052)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'17'
,p_lov_return_value=>'17'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87724129057244793.4052)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>'18'
,p_lov_return_value=>'18'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87724326333244793.4052)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>'19'
,p_lov_return_value=>'19'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87724500227244794.4052)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87724715549244794.4052)
,p_lov_disp_sequence=>210
,p_lov_disp_value=>'21'
,p_lov_return_value=>'21'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87724919187244794.4052)
,p_lov_disp_sequence=>220
,p_lov_disp_value=>'22'
,p_lov_return_value=>'22'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87725132288244794.4052)
,p_lov_disp_sequence=>230
,p_lov_disp_value=>'23'
,p_lov_return_value=>'23'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87725315196244795.4052)
,p_lov_disp_sequence=>240
,p_lov_disp_value=>'24'
,p_lov_return_value=>'24'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87725519222244795.4052)
,p_lov_disp_sequence=>250
,p_lov_disp_value=>'25'
,p_lov_return_value=>'25'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87725726981244795.4052)
,p_lov_disp_sequence=>260
,p_lov_disp_value=>'26'
,p_lov_return_value=>'26'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87725929193244795.4052)
,p_lov_disp_sequence=>270
,p_lov_disp_value=>'27'
,p_lov_return_value=>'27'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87726105331244796.4052)
,p_lov_disp_sequence=>280
,p_lov_disp_value=>'28'
,p_lov_return_value=>'28'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87726330087244796.4052)
,p_lov_disp_sequence=>290
,p_lov_disp_value=>'29'
,p_lov_return_value=>'29'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87726525128244796.4052)
,p_lov_disp_sequence=>300
,p_lov_disp_value=>'30'
,p_lov_return_value=>'30'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87726708945244797.4052)
,p_lov_disp_sequence=>310
,p_lov_disp_value=>'31'
,p_lov_return_value=>'31'
);
end;
/
prompt --application/shared_components/user_interface/lovs/unhandled_errors
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(818371130728427287.4052)
,p_lov_name=>'UNHANDLED ERRORS'
,p_lov_query=>'.'||wwv_flow_api.id(818371130728427287.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(818371498373427288.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Afficher la page d''erreur'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(818371769110427289.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Renvoyer l''erreur HTTP 400'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/usage_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(825928575701276934.4052)
,p_lov_name=>'USAGE_TYPE'
,p_reference_id=>824610978117256327.4052
,p_lov_query=>'.'||wwv_flow_api.id(825928575701276934.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825930514175276935.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personnel'
,p_lov_return_value=>'PERSONAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(825930970103276935.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Organisation'
,p_lov_return_value=>'ORG'
);
end;
/
prompt --application/shared_components/user_interface/lovs/user_groups
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(161727824824923998.4052)
,p_lov_name=>'USER.GROUPS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, id r',
'from wwv_flow_fnd_user_groups_noapp',
'where security_group_id = :F4050_P23_SECURITY_GROUP_ID order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/view_as_list_or_icons
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(138021018445611867.4052)
,p_lov_name=>'VIEW AS LIST OR ICONS'
,p_lov_query=>'.'||wwv_flow_api.id(138021018445611867.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(138021303911611867.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Ic\00F4nes')
,p_lov_return_value=>'ICON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(138021517322611867.4052)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('D\00E9tails')
,p_lov_return_value=>'DETAIL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/webservice_logging
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(582428114482274404.4052)
,p_lov_name=>'WEBSERVICE LOGGING'
,p_lov_query=>'.'||wwv_flow_api.id(582428114482274404.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(582428454798274405.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Utiliser les param\00E8tres d''espace de travail (par d\00E9faut)')
,p_lov_return_value=>'U'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(582428895116274405.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Toujours'
,p_lov_return_value=>'A'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(582429260294274406.4052)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Jamais'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/websheet_authentication
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(789383217265083754.4052)
,p_lov_name=>'WEBSHEET AUTHENTICATION'
,p_reference_id=>460742018651713171.4052
,p_lov_query=>'.'||wwv_flow_api.id(789383217265083754.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(789384818977083756.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Compte Application Express'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(789385020754083756.4052)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Single Sign-On (SSO)'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(789385210266083756.4052)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'LDAP'
,p_lov_return_value=>'3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1959580205983105252.4052)
,p_lov_disp_sequence=>4.5
,p_lov_disp_value=>'Oracle Cloud Identity Management'
,p_lov_return_value=>'5'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'wwv_flow_authentication_dev.get_internal_authentication = ''CLOUD_IDM'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(789385402302083756.4052)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Personnalis\00E9')
,p_lov_return_value=>'4'
);
end;
/
prompt --application/shared_components/user_interface/lovs/workspace_name_computation
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(203194513911255730.4052)
,p_lov_name=>'WORKSPACE NAME COMPUTATION'
,p_lov_query=>'.'||wwv_flow_api.id(203194513911255730.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(203194724498255732.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Noms d''espace de travail g\00E9n\00E9r\00E9s par le syst\00E8me')
,p_lov_return_value=>'GENERATED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(203195007395255734.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Nom d''espace de travail pr\00E9c\00E9d\00E9 d''un pr\00E9fixe statique et suivi d''un suffixe entier s\00E9quentiel')
,p_lov_return_value=>'PREFIX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(203195313535255734.4052)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Nom d''espace de travail identique au nom de domaine de messagerie, suivi d''un suffixe entier s\00E9quentiel pour les doublons')
,p_lov_return_value=>'DOMAIN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/workspace_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2379160755129464721.4052)
,p_lov_name=>'WORKSPACE STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(2379160755129464721.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2379161043169464735.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Disponible'
,p_lov_return_value=>'AVAILABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2379161436349464739.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Affect\00E9')
,p_lov_return_value=>'ASSIGNED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2379161846315464740.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Suspendu'
,p_lov_return_value=>'SUSPENDED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2379162230719464740.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Interrompu'
,p_lov_return_value=>'TERMINATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2379162625399464740.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Verrouill\00E9')
,p_lov_return_value=>'ASSIGN_LCK'
);
end;
/
prompt --application/shared_components/user_interface/lovs/workspaces_returning_id
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(832231721829846651.4052)
,p_lov_name=>'WORKSPACES_RETURNING_ID'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id > 0',
'order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'R'
,p_display_column_name=>'D'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_app_acl_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(789504612333102303.4052)
,p_lov_name=>'WS_APP_ACL_TYPE'
,p_reference_id=>460746220203713213.4052
,p_lov_query=>'.'||wwv_flow_api.id(789504612333102303.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(789505600468102306.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Valeur par d\00E9faut')
,p_lov_return_value=>'DEFAULT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(789505802137102306.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Personnalis\00E9')
,p_lov_return_value=>'CUSTOM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_app_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(787558207696790415.4052)
,p_lov_name=>'WS_APP_STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(787558207696790415.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(787558503193790416.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Disponible'
,p_lov_return_value=>'AVAILABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(787558723914790416.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Non disponible'
,p_lov_return_value=>'UNAVAILABLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_logo_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(788592429400938627.4052)
,p_lov_name=>'WS_LOGO_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(788592429400938627.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788592711265938628.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Aucun'
,p_lov_return_value=>'NONE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(788592917302938628.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Texte'
,p_lov_return_value=>'TEXT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_provisioning_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(113228404836854036.4052)
,p_lov_name=>'WS_PROVISIONING_STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(113228404836854036.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(113228711736854036.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Activ\00E9')
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(113228921295854036.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('D\00E9sactiv\00E9')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_returns_yes_or_no
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(110344620122166929.4052)
,p_lov_name=>'YES NO RETURNS YES OR NO'
,p_lov_query=>'.'||wwv_flow_api.id(110344620122166929.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(110344806562166931.4052)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Oui'
,p_lov_return_value=>'YES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(110345012767166934.4052)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Non'
,p_lov_return_value=>'NO'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_returns_1_or_0
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(87817312158083090.4052)
,p_lov_name=>'YES.NO.RETURNS.1_OR_0'
,p_lov_query=>'.'||wwv_flow_api.id(87817312158083090.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87817530004083091.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Non'
,p_lov_return_value=>'0'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87817713905083091.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Oui'
,p_lov_return_value=>'1'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_returns_y_or_n
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(157992123774592395.4052)
,p_lov_name=>'YES_NO_RETURNS_Y_OR_N'
,p_lov_query=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(157992405775592399.4052)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Oui'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(157992613021592401.4052)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Non'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/internal_admin_menu
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(4585800473139662.4052)
,p_name=>'internal.admin.menu'
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1592430921650085.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Journal d''automatisation'
,p_link=>'f?p=&FLOW_ID.:181:&SESSION.'
,p_page_id=>181
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1593639653666254.4052)
,p_parent_id=>wwv_flow_api.id(168496516199569448.4052)
,p_short_name=>'Journal d''automatisation'
,p_link=>'f?p=&APP_ID.:182:&SESSION.::&DEBUG.:::'
,p_page_id=>182
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2589300985659863.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>unistr('Vues de page par syst\00E8me d''exploitation')
,p_link=>'f?p=&FLOW_ID.:13:&SESSION.'
,p_page_id=>13
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2600224886694329.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Vues de page par navigateur'
,p_link=>'f?p=&FLOW_ID.:15:&SESSION.'
,p_page_id=>15
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4586800042158416.4052)
,p_parent_id=>wwv_flow_api.id(.4052)
,p_short_name=>'<span class="u-VisuallyHidden">Page d''accueil</span><span class="a-Icon icon-breadcrumb-previous" title="Page d''accueil"></span>'
,p_link=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.:::'
,p_page_id=>3
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4587312509162011.4052)
,p_parent_id=>wwv_flow_api.id(6027506192823381.4052)
,p_short_name=>'Demandes d''espace de travail'
,p_link=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:::'
,p_page_id=>26
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4587825323165692.4052)
,p_parent_id=>wwv_flow_api.id(168496516199569448.4052)
,p_short_name=>'Statut de session'
,p_link=>'f?p=&APP_ID.:63:&SESSION.::&DEBUG.:::'
,p_page_id=>63
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4603211003239218.4052)
,p_parent_id=>wwv_flow_api.id(6027506192823381.4052)
,p_short_name=>'Demandes de modification'
,p_link=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.:::'
,p_page_id=>28
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4608012500253721.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>unistr('Cr\00E9er un espace de travail')
,p_link=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:::'
,p_page_id=>27
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4611726506262368.4052)
,p_parent_id=>wwv_flow_api.id(168496516199569448.4052)
,p_short_name=>unistr('Configuration des fonctionnalit\00E9s')
,p_link=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.:::'
,p_page_id=>16
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4617723690278867.4052)
,p_parent_id=>wwv_flow_api.id(4586800042158416.4052)
,p_short_name=>unistr('Surveiller l''activit\00E9')
,p_link=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:::'
,p_page_id=>29
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4623831010290711.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Vues de page par application'
,p_link=>'f?p=&APP_ID.:44:&SESSION.::&DEBUG.:::'
,p_page_id=>44
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4626009659300609.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Vues de page par application et utilisateur'
,p_link=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.:::'
,p_page_id=>49
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4645824047369956.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Vues de page par agent utilisateur'
,p_link=>'f?p=&APP_ID.:38:&SESSION.::&DEBUG.:::'
,p_page_id=>38
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4652116893418791.4052)
,p_parent_id=>wwv_flow_api.id(168496516199569448.4052)
,p_short_name=>unistr('Journaux des activit\00E9s de vue de page')
,p_link=>'f?p=&APP_ID.:61:&SESSION.::&DEBUG.:::'
,p_page_id=>61
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4653409561422233.4052)
,p_parent_id=>wwv_flow_api.id(4652116893418791.4052)
,p_short_name=>'Vider des journaux'
,p_link=>'f?p=&FLOW_ID.:62:&SESSION.'
,p_page_id=>62
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4720402234683880.4052)
,p_parent_id=>wwv_flow_api.id(4587825323165692.4052)
,p_short_name=>'Purger les sessions'
,p_link=>'f?p=&FLOW_ID.:66:&SESSION.'
,p_page_id=>66
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4722132186700450.4052)
,p_parent_id=>wwv_flow_api.id(4587825323165692.4052)
,p_short_name=>unistr('Derni\00E8res sessions')
,p_link=>'f?p=&FLOW_ID.:65:&SESSION.'
,p_page_id=>65
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4728709418862901.4052)
,p_parent_id=>wwv_flow_api.id(4587825323165692.4052)
,p_short_name=>'Statistiques sur les statuts de session'
,p_link=>'f?p=&FLOW_ID.:64:&SESSION.'
,p_page_id=>64
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4737627256930650.4052)
,p_parent_id=>wwv_flow_api.id(168496516199569448.4052)
,p_short_name=>'Journaux de SQL Workshop'
,p_link=>'f?p=&APP_ID.:46:&SESSION.::&DEBUG.:::'
,p_page_id=>46
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4738821217933374.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>'Espaces de travail existants'
,p_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_page_id=>1
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4742104180941272.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>unistr('D\00E9tails de l''espace de travail')
,p_link=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.:::'
,p_page_id=>14
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4747925937961632.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>unistr('G\00E9rer les d\00E9veloppeurs et les utilisateurs')
,p_link=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:::'
,p_page_id=>12
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4754008241985056.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Vues de page par espace de travail'
,p_link=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.:::'
,p_page_id=>33
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4756326991991493.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Vues de page par site externe'
,p_link=>'f?p=&APP_ID.:45:&SESSION.::&DEBUG.:::'
,p_page_id=>45
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4760620508009758.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Vues de page par jour par application et utilisateur'
,p_link=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.:::'
,p_page_id=>37
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4762212745013281.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Vues de page par vue'
,p_link=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.:::'
,p_page_id=>30
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4764402609017998.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>unistr('Ev\00E9nements de page par jour')
,p_link=>'f?p=&APP_ID.:54:&SESSION.::&DEBUG.:::'
,p_page_id=>54
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4767612301028720.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Vues de page par espace de travail et utilisateur'
,p_link=>'f?p=&APP_ID.:36:&SESSION.::&DEBUG.:::'
,p_page_id=>36
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4770921778039473.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>unistr('Modifications d''application par d\00E9veloppeur')
,p_link=>'f?p=&APP_ID.:43:&SESSION.::&DEBUG.:::'
,p_page_id=>43
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(5077608631625856.4052)
,p_parent_id=>wwv_flow_api.id(168496516199569448.4052)
,p_short_name=>unistr('Journal des activit\00E9s de d\00E9veloppeur')
,p_link=>'f?p=&APP_ID.:19:&SESSION.::&DEBUG.:::'
,p_page_id=>19
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(5087818742651531.4052)
,p_parent_id=>wwv_flow_api.id(168496516199569448.4052)
,p_short_name=>'Journal des clics externes'
,p_link=>'f?p=&APP_ID.:85:&SESSION.::&DEBUG.:::'
,p_page_id=>85
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6027506192823381.4052)
,p_parent_id=>wwv_flow_api.id(4586800042158416.4052)
,p_short_name=>unistr('G\00E9rer les demandes')
,p_link=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:::'
,p_page_id=>5
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6052324602932730.4052)
,p_parent_id=>wwv_flow_api.id(4586800042158416.4052)
,p_short_name=>unistr('G\00E9rer les espaces de travail')
,p_link=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::'
,p_page_id=>10
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(8781730446978159.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>unistr('Privil\00E8ges de base de donn\00E9es d''espace de travail')
,p_link=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:::'
,p_page_id=>22
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10132224222229347.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Vues de page par heure'
,p_link=>'f?p=&FLOW_ID.:69:&SESSION.'
,p_page_id=>69
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(12733917471664461.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Tentatives de connexion'
,p_link=>'f?p=&APP_ID.:24:&SESSION.::&DEBUG.:::'
,p_page_id=>24
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(13869232224656033.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>unistr('Cr\00E9er un espace de travail')
,p_link=>'f?p=&APP_ID.:72:&SESSION.::&DEBUG.:::'
,p_page_id=>72
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(13871226833658518.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>unistr('Cr\00E9er un espace de travail')
,p_link=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
,p_page_id=>73
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(13872723167660259.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>unistr('Cr\00E9er un espace de travail')
,p_link=>'f?p=&APP_ID.:74:&SESSION.::&DEBUG.:::'
,p_page_id=>74
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(13874119069662163.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>unistr('Cr\00E9er un espace de travail')
,p_link=>'f?p=&APP_ID.:79:&SESSION.::&DEBUG.:::'
,p_page_id=>79
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(14583119493258633.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>'Enlever un espace de travail'
,p_link=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:::'
,p_page_id=>81
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(14583529882261640.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>'Enlever un espace de travail'
,p_link=>'f?p=&APP_ID.:82:&SESSION.::&DEBUG.:::'
,p_page_id=>82
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(14583906465264336.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>'Enlever un espace de travail'
,p_link=>'f?p=&APP_ID.:83:&SESSION.::&DEBUG.:::'
,p_page_id=>83
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(14584921356268633.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>'Enlever un espace de travail'
,p_link=>'f?p=&APP_ID.:84:&SESSION.::&DEBUG.:::'
,p_page_id=>84
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(15366805621981104.4052)
,p_parent_id=>wwv_flow_api.id(168496516199569448.4052)
,p_short_name=>unistr('Journal de connexions \00E0 Access')
,p_link=>'f?p=&APP_ID.:31:&SESSION.::&DEBUG.:::'
,p_page_id=>31
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(15549610245678522.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Modifications d''application par espace de travail'
,p_link=>'f?p=&APP_ID.:500:&SESSION.::&DEBUG.:::'
,p_page_id=>500
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(18703821024277695.4052)
,p_parent_id=>wwv_flow_api.id(19718719669530547.4052)
,p_short_name=>unistr('Ajouter un sch\00E9ma')
,p_link=>'f?p=&APP_ID.:105:&SESSION.::&DEBUG.:::'
,p_page_id=>105
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(18704130374280378.4052)
,p_parent_id=>wwv_flow_api.id(19718719669530547.4052)
,p_short_name=>unistr('Ajouter un sch\00E9ma')
,p_link=>'f?p=&APP_ID.:106:&SESSION.::&DEBUG.:::'
,p_page_id=>106
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(18704412151284643.4052)
,p_parent_id=>wwv_flow_api.id(19718719669530547.4052)
,p_short_name=>unistr('Ajouter un sch\00E9ma')
,p_link=>'f?p=&APP_ID.:107:&SESSION.::&DEBUG.:::'
,p_page_id=>107
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(18704723233287852.4052)
,p_parent_id=>wwv_flow_api.id(19718719669530547.4052)
,p_short_name=>unistr('Ajouter un sch\00E9ma')
,p_link=>'f?p=&APP_ID.:108:&SESSION.::&DEBUG.:::'
,p_page_id=>108
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(19718719669530547.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>unistr('G\00E9rer les affectations d''espaces de travail \00E0 des sch\00E9mas')
,p_link=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
,p_page_id=>21
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(20501516629215230.4052)
,p_parent_id=>wwv_flow_api.id(4603211003239218.4052)
,p_short_name=>'Voir une demande de modification'
,p_link=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:110::'
,p_page_id=>110
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(22715826706534997.4052)
,p_parent_id=>wwv_flow_api.id(15549610245678522.4052)
,p_short_name=>unistr('D\00E9tails de l''activit\00E9 d''espace de travail')
,p_link=>'f?p=&APP_ID.:501:&SESSION.::&DEBUG.:::'
,p_page_id=>501
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(23596724286518552.4052)
,p_parent_id=>wwv_flow_api.id(4737627256930650.4052)
,p_short_name=>'Nettoyer les journaux'
,p_link=>'f?p=&APP_ID.:75:&SESSION.::&DEBUG.:::'
,p_page_id=>75
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(25769124953813347.4052)
,p_parent_id=>wwv_flow_api.id(168496516199569448.4052)
,p_short_name=>unistr('Assistant Inscription \00E0 un service')
,p_link=>'f?p=&APP_ID.:111:&SESSION.::&DEBUG.:::'
,p_page_id=>111
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(29801815135014216.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>'Recherche d''un espace de travail'
,p_link=>'f?p=&APP_ID.:8000:&SESSION.::&DEBUG.:::'
,p_page_id=>8000
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(29817826940342994.4052)
,p_parent_id=>wwv_flow_api.id(29801815135014216.4052)
,p_short_name=>'Espace de travail'
,p_link=>'f?p=&FLOW_ID.:8001:&SESSION.'
,p_page_id=>8001
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(39295630191089140.4052)
,p_parent_id=>wwv_flow_api.id(4747925937961632.4052)
,p_short_name=>unistr('Cr\00E9er/modifier un utilisateur')
,p_link=>'f?p=&APP_ID.:23:&SESSION.::&DEBUG.:::'
,p_page_id=>23
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(40438104699665664.4052)
,p_parent_id=>wwv_flow_api.id(4587312509162011.4052)
,p_short_name=>'Administration du provisionnement'
,p_link=>'f?p=&FLOW_ID.:4:&SESSION.'
,p_page_id=>4
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(40439200601667531.4052)
,p_parent_id=>wwv_flow_api.id(4587312509162011.4052)
,p_short_name=>'Approuver une demande de provisionnement '
,p_link=>'f?p=&FLOW_ID.:55:&SESSION.'
,p_page_id=>55
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(40440327331670342.4052)
,p_parent_id=>wwv_flow_api.id(4587312509162011.4052)
,p_short_name=>'Refuser une demande de provisionnement'
,p_link=>'f?p=&FLOW_ID.:56:&SESSION.'
,p_page_id=>56
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(40441522370672659.4052)
,p_parent_id=>wwv_flow_api.id(4587312509162011.4052)
,p_short_name=>'Demande de provisionnement'
,p_link=>'f?p=&FLOW_ID.:6:&SESSION.'
,p_page_id=>6
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(47181408364860054.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>unistr('Derni\00E8re connexion de d\00E9veloppeur')
,p_link=>'f?p=&FLOW_ID.:35:&SESSION.'
,p_page_id=>35
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(47636522749932000.4052)
,p_parent_id=>wwv_flow_api.id(168496516199569448.4052)
,p_short_name=>unistr('S\00E9curit\00E9')
,p_link=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:::'
,p_page_id=>130
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(48366213770241935.4052)
,p_parent_id=>wwv_flow_api.id(168496516199569448.4052)
,p_short_name=>'File d''attente des courriels'
,p_long_name=>'File d''attente des courriels'
,p_link=>'f?p=&APP_ID.:120:&SESSION.::&DEBUG.:::'
,p_page_id=>120
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(50513708160442260.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Journal des courriels'
,p_long_name=>'Journal des courriels'
,p_link=>'f?p=&APP_ID.:121:&SESSION.::&DEBUG.:::'
,p_page_id=>121
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(51163924477211254.4052)
,p_parent_id=>wwv_flow_api.id(168496516199569448.4052)
,p_short_name=>unistr('Param\00E8tres d''instance')
,p_link=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.:::'
,p_page_id=>131
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(51281405952355975.4052)
,p_parent_id=>wwv_flow_api.id(168496516199569448.4052)
,p_short_name=>unistr('D\00E9finir le message du syst\00E8me')
,p_link=>'f?p=&APP_ID.:132:&SESSION.::&DEBUG.:::'
,p_page_id=>132
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(63533206146931905.4052)
,p_parent_id=>wwv_flow_api.id(4747925937961632.4052)
,p_short_name=>unistr('R\00E9initialiser le mot de passe')
,p_link=>'f?p=&FLOW_ID.:53:&SESSION.'
,p_page_id=>53
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(63706904690661881.4052)
,p_parent_id=>wwv_flow_api.id(4722132186700450.4052)
,p_short_name=>unistr('D\00E9tails de session')
,p_link=>'f?p=&FLOW_ID.:67:&SESSION.'
,p_page_id=>67
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(68357616835819088.4052)
,p_parent_id=>wwv_flow_api.id(4587312509162011.4052)
,p_short_name=>'Ajuster une demande'
,p_link=>'f?p=&FLOW_ID.:7:&SESSION.::&DEBUG.:::'
,p_page_id=>7
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(68369605800844354.4052)
,p_parent_id=>wwv_flow_api.id(4587312509162011.4052)
,p_short_name=>'Supprimer une demande'
,p_link=>'f?p=&FLOW_ID.:8:&SESSION.::&DEBUG.:::'
,p_page_id=>8
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(68455820429179669.4052)
,p_parent_id=>wwv_flow_api.id(4738821217933374.4052)
,p_short_name=>'Modifier les informations d''espace de travail'
,p_link=>'f?p=&APP_ID.:78:&SESSION.::&DEBUG.:::'
,p_page_id=>78
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(74653816579025410.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>'Verrouiller l''espace de travail'
,p_link=>'f?p=&FLOW_ID.:89:&SESSION.'
,p_page_id=>89
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(74669930632071892.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>'Verrouiller l''espace de travail'
,p_link=>'f?p=&FLOW_ID.:90:&SESSION.'
,p_page_id=>90
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(75184116621221469.4052)
,p_parent_id=>wwv_flow_api.id(79867419412344264.4052)
,p_short_name=>'Installer un espace de travail'
,p_link=>'f?p=&APP_ID.:278:&SESSION.::&DEBUG.:::'
,p_page_id=>278
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(75265816075541761.4052)
,p_parent_id=>wwv_flow_api.id(75266632352546405.4052)
,p_short_name=>unistr('Cr\00E9er/Modifier une ressource propre au site')
,p_link=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:::'
,p_page_id=>17
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(75266632352546405.4052)
,p_parent_id=>wwv_flow_api.id(168496516199569448.4052)
,p_short_name=>'Ressources propres au site'
,p_link=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.:17::'
,p_page_id=>18
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(79867419412344264.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>'Importer un espace de travail'
,p_long_name=>'Importer un espace de travail'
,p_link=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:::'
,p_page_id=>460
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(79869300066366991.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>'Importer un espace de travail'
,p_link=>'f?p=&APP_ID.:163:&SESSION.::&DEBUG.:::'
,p_page_id=>163
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(79871328247384629.4052)
,p_parent_id=>wwv_flow_api.id(79867419412344264.4052)
,p_short_name=>'Installer un espace de travail'
,p_long_name=>'Installer un espace de travail'
,p_link=>'f?p=&FLOW_ID.:277:&SESSION.::&DEBUG.:::'
,p_page_id=>277
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(79871614873390258.4052)
,p_parent_id=>wwv_flow_api.id(79867419412344264.4052)
,p_short_name=>'Installer un espace de travail'
,p_long_name=>'Installer un espace de travail'
,p_link=>'f?p=&FLOW_ID.:165:&SESSION.::&DEBUG.:::'
,p_page_id=>165
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(79871930110394643.4052)
,p_parent_id=>wwv_flow_api.id(79867419412344264.4052)
,p_short_name=>unistr('Fichiers d''export d''espace de travail import\00E9')
,p_link=>'f?p=&APP_ID.:173:&SESSION.::&DEBUG.:::'
,p_page_id=>173
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(81363923500633767.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>'Exporter un espace de travail'
,p_link=>'f?p=&APP_ID.:461:&SESSION.::&DEBUG.:::'
,p_page_id=>461
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(90106925888696249.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Journal de sauvegarde'
,p_link=>'f?p=&APP_ID.:147:&SESSION.::&DEBUG.:::'
,p_page_id=>147
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(98196930690236730.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>unistr('Dernier espace de travail utilis\00E9')
,p_link=>'f?p=&APP_ID.:25:&SESSION.::&DEBUG.:::'
,p_page_id=>25
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(130330112588540496.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>unistr('Enqu\00EAte \00E0 l''inscription')
,p_link=>'f?p=&APP_ID.:113:&SESSION.::&DEBUG.:::'
,p_page_id=>113
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(132784419557719566.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Nouvelles demandes de service'
,p_link=>'f?p=&FLOW_ID.:114:&SESSION.'
,p_page_id=>114
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(138018800392611865.4052)
,p_parent_id=>wwv_flow_api.id(168496516199569448.4052)
,p_short_name=>unistr('Th\00E8mes publics')
,p_link=>'f?p=&APP_ID.:555:&SESSION.::&DEBUG.:::'
,p_page_id=>555
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(138031613241631494.4052)
,p_parent_id=>wwv_flow_api.id(138018800392611865.4052)
,p_short_name=>unistr('Modifier un th\00E8me public')
,p_link=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.:::'
,p_page_id=>42
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(138042916646643273.4052)
,p_parent_id=>wwv_flow_api.id(138018800392611865.4052)
,p_short_name=>unistr('Cr\00E9er un th\00E8me public')
,p_link=>'f?p=&APP_ID.:47:&SESSION.::&DEBUG.:::'
,p_page_id=>47
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(138053929247655080.4052)
,p_parent_id=>wwv_flow_api.id(138018800392611865.4052)
,p_short_name=>unistr('Cr\00E9er un th\00E8me public')
,p_link=>'f?p=&APP_ID.:48:&SESSION.::&DEBUG.:::'
,p_page_id=>48
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(138064613747663617.4052)
,p_parent_id=>wwv_flow_api.id(138018800392611865.4052)
,p_short_name=>unistr('Cr\00E9er un th\00E8me public')
,p_link=>'f?p=&APP_ID.:51:&SESSION.::&DEBUG.:::'
,p_page_id=>51
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(138137024290914175.4052)
,p_parent_id=>wwv_flow_api.id(138018800392611865.4052)
,p_short_name=>unistr('Cr\00E9er un th\00E8me public')
,p_link=>'f?p=&FLOW_ID.:57:&SESSION.'
,p_page_id=>57
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(138141916090918467.4052)
,p_parent_id=>wwv_flow_api.id(138018800392611865.4052)
,p_short_name=>unistr('Cr\00E9er un th\00E8me public')
,p_link=>'f?p=&FLOW_ID.:58:&SESSION.'
,p_page_id=>58
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(141709314755230984.4052)
,p_parent_id=>wwv_flow_api.id(47636522749932000.4052)
,p_short_name=>unistr('Modifier un mod\00E8le')
,p_link=>'f?p=&APP_ID.:136:&SESSION.'
,p_page_id=>136
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(155227327828557571.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Graphique d''utilisation de composants natifs'
,p_link=>'f?p=&APP_ID.:102:&SESSION.::&DEBUG.:::'
,p_page_id=>102
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(155371253393130044.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Etat d''utilisation de composants natifs'
,p_link=>'f?p=&APP_ID.:140:&SESSION.'
,p_page_id=>140
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(161279124919280651.4052)
,p_parent_id=>wwv_flow_api.id(19718719669530547.4052)
,p_short_name=>unistr('Modifier l''affectation de sch\00E9mas \00E0 des espaces de travail')
,p_link=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:::'
,p_page_id=>20
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(161577505898240777.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Journal de suppression de fichier automatique'
,p_link=>'f?p=&FLOW_ID.:124:&SESSION.'
,p_page_id=>124
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(162274419076104279.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>unistr('Journal des activit\00E9s d''archivage')
,p_link=>'f?p=&FLOW_ID.:34:&SESSION.'
,p_page_id=>34
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(168488515060465304.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>'Utilisation de fichier par espace de travail'
,p_link=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.:::'
,p_page_id=>39
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(168496516199569448.4052)
,p_parent_id=>wwv_flow_api.id(4586800042158416.4052)
,p_short_name=>unistr('G\00E9rer une instance')
,p_link=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
,p_page_id=>9
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(168519007394879035.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Tableau de bord'
,p_link=>'f?p=&FLOW_ID.:40:&SESSION.'
,p_page_id=>40
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(168811125378155218.4052)
,p_parent_id=>wwv_flow_api.id(168496516199569448.4052)
,p_short_name=>'Message de connexion'
,p_link=>'f?p=&FLOW_ID.:41:&SESSION.'
,p_page_id=>41
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(173287416442781913.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>unistr('Composant - Disponibilit\00E9')
,p_link=>'f?p=&APP_ID.:52:&SESSION.::&DEBUG.:::'
,p_page_id=>52
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(173291712511844438.4052)
,p_parent_id=>wwv_flow_api.id(173287416442781913.4052)
,p_short_name=>unistr('Param\00E8tres d''espace de travail')
,p_link=>'f?p=&APP_ID.:59:&SESSION.::&DEBUG.:::'
,p_page_id=>59
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(184032326132147079.4052)
,p_parent_id=>wwv_flow_api.id(29817826940342994.4052)
,p_short_name=>'Courriel'
,p_link=>'f?p=&FLOW_ID.:76:&SESSION.'
,p_page_id=>76
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(201319721952457221.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>unistr('Activit\00E9 par jour')
,p_link=>'f?p=&APP_ID.:68:&SESSION.::&DEBUG.:::'
,p_page_id=>68
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(201371611286583623.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>unistr('Activit\00E9 par application par jour')
,p_link=>'f?p=&APP_ID.:77:&SESSION.::&DEBUG.:::'
,p_page_id=>77
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(201377704576617189.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>unistr('Activit\00E9 par espace de travail')
,p_link=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.:::'
,p_page_id=>80
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(201525025478711489.4052)
,p_parent_id=>wwv_flow_api.id(168496516199569448.4052)
,p_short_name=>unistr('Traductions install\00E9es')
,p_link=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:::'
,p_page_id=>100
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(203154703095491475.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>unistr('Cr\00E9er plusieurs espaces de travail')
,p_link=>'f?p=&APP_ID.:115:&SESSION.::&DEBUG.:::'
,p_page_id=>115
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(204695329206748522.4052)
,p_parent_id=>wwv_flow_api.id(204699118900792039.4052)
,p_short_name=>'Modifier la demande de provisionnement de l''espace de travail'
,p_link=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:::'
,p_page_id=>118
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(204698620127790065.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>unistr('Cr\00E9er plusieurs espaces de travail')
,p_link=>'f?p=&FLOW_ID.:117:&SESSION.'
,p_page_id=>117
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(204699118900792039.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>unistr('Cr\00E9er plusieurs espaces de travail')
,p_link=>'f?p=&FLOW_ID.:116:&SESSION.'
,p_page_id=>116
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(217657129689347489.4052)
,p_parent_id=>wwv_flow_api.id(168496516199569448.4052)
,p_short_name=>unistr('G\00E9rer l''intervalle de journalisation')
,p_link=>'f?p=&APP_ID.:119:&SESSION.::&DEBUG.:::'
,p_page_id=>119
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(219091801243391095.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Hachage d''application par jour'
,p_link=>'f?p=&APP_ID.:141:&SESSION.::&DEBUG.:RP::'
,p_page_id=>141
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(244316400794845905.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>'Statut de construction'
,p_link=>'f?p=&APP_ID.:400:&SESSION.::&DEBUG.:::'
,p_page_id=>400
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(244644212695071158.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>unistr('Sch\00E9mas d''analyse')
,p_link=>'f?p=&APP_ID.:401:&SESSION.::&DEBUG.:::'
,p_page_id=>401
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(244652210402079945.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>'Attributs d''application'
,p_link=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:::'
,p_page_id=>11
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(274120800045824670.4052)
,p_parent_id=>wwv_flow_api.id(168496516199569448.4052)
,p_short_name=>unistr('Abonnements d''\00E9tat interactif')
,p_link=>'f?p=&FLOW_ID.:129:&SESSION.'
,p_page_id=>129
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(284066358933239262.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>unistr('Travaux de chargement des donn\00E9es')
,p_link=>'f?p=&FLOW_ID.:144:&SESSION.'
,p_page_id=>144
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(388179526938368968.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>unistr('Cr\00E9er plusieurs espaces de travail')
,p_link=>'f?p=&APP_ID.:135:&SESSION.'
,p_page_id=>135
);
end;
/
begin
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(491859103758196049.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>unistr('Ev\00E9nements de page par jour')
,p_link=>'f?p=&APP_ID.:86:&SESSION.::&DEBUG.:::'
,p_page_id=>86
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(499049929999448400.4052)
,p_parent_id=>wwv_flow_api.id(168496516199569448.4052)
,p_short_name=>unistr('Param\00E8tres de purge d''espace de travail')
,p_link=>'f?p=&APP_ID.:133:&SESSION.::&DEBUG.:::'
,p_page_id=>133
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(500561475728993019.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>unistr('Recherche \00E0 facets d''un espace de travail')
,p_link=>'f?p=&APP_ID.:152:&SESSION.'
,p_page_id=>152
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(505832201115288634.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Espaces de travail inactifs'
,p_link=>'f?p=&APP_ID.:87:&SESSION.::&DEBUG.:::'
,p_page_id=>87
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(505837505674514394.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>unistr('Espaces de travail purg\00E9s')
,p_link=>'f?p=&APP_ID.:91:&SESSION.::&DEBUG.:::'
,p_page_id=>91
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(505839217307524193.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Espaces de travail devenus actifs'
,p_link=>'f?p=&APP_ID.:92:&SESSION.::&DEBUG.:::'
,p_page_id=>92
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(505845507756604641.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Journal de purge d''espace de travail'
,p_link=>'f?p=&APP_ID.:98:&SESSION.::&DEBUG.:::'
,p_page_id=>98
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(505847206006635779.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Tableau de bord de purge d''espace de travail'
,p_link=>'f?p=&APP_ID.:99:&SESSION.::&DEBUG.:::'
,p_page_id=>99
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(524767132718077538.4052)
,p_parent_id=>wwv_flow_api.id(525071413296326430.4052)
,p_short_name=>'Cache d''espace de travail'
,p_link=>'f?p=&APP_ID.:148:&SESSION.::&DEBUG.:::'
,p_page_id=>148
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(524799538487232706.4052)
,p_parent_id=>wwv_flow_api.id(524767132718077538.4052)
,p_short_name=>' Cache de colonne de table'
,p_link=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:::'
,p_page_id=>149
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(525071413296326430.4052)
,p_parent_id=>wwv_flow_api.id(6052324602932730.4052)
,p_short_name=>unistr('Cache de dictionnaire de donn\00E9es')
,p_link=>'f?p=&APP_ID.:150:&SESSION.::&DEBUG.:::'
,p_page_id=>150
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(619289932752143228.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Travaux'
,p_link=>'f?p=&APP_ID.:122:&SESSION.::&DEBUG.:::'
,p_page_id=>122
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(619327423899379390.4052)
,p_parent_id=>wwv_flow_api.id(619289932752143228.4052)
,p_short_name=>unistr('D\00E9tails du travail')
,p_link=>'f?p=&FLOW_ID.:123:&SESSION.'
,p_page_id=>123
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(619970453087121945.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>unistr('Journal des activit\00E9s de service Web')
,p_link=>'f?p=&APP_ID.:101:&SESSION.'
,p_page_id=>101
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(620805257997072192.4052)
,p_parent_id=>wwv_flow_api.id(168496516199569448.4052)
,p_short_name=>unistr('G\00E9rer le journal des activit\00E9s de service Web')
,p_link=>'f?p=&APP_ID.:139:&SESSION.::&DEBUG.:::'
,p_page_id=>139
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(629290306954602539.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Espaces de travail actifs par jour'
,p_link=>'f?p=&APP_ID.:93:&SESSION.::&DEBUG.:::'
,p_page_id=>93
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(799823828864286581.4052)
,p_parent_id=>wwv_flow_api.id(168496516199569448.4052)
,p_short_name=>unistr('S\00E9curit\00E9')
,p_link=>'f?p=&FLOW_ID.:95:&SESSION.'
,p_page_id=>95
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(799824316355292355.4052)
,p_parent_id=>wwv_flow_api.id(799823828864286581.4052)
,p_short_name=>unistr('URL autoris\00E9e')
,p_link=>'f?p=&FLOW_ID.:96:&SESSION.'
,p_page_id=>96
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(831620316700274606.4052)
,p_parent_id=>wwv_flow_api.id(880634492387323345.4052)
,p_short_name=>unistr('D\00E9tail de l''utilisation active')
,p_link=>'f?p=&APP_ID.:153:&SESSION.::&DEBUG.:::'
,p_page_id=>153
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(832244909161904272.4052)
,p_parent_id=>wwv_flow_api.id(880634492387323345.4052)
,p_short_name=>unistr('D\00E9tail de l''activit\00E9 de l''application')
,p_link=>'f?p=&APP_ID.:155:&SESSION.::&DEBUG.:RP::'
,p_page_id=>155
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(832531037162024796.4052)
,p_parent_id=>wwv_flow_api.id(880634492387323345.4052)
,p_short_name=>unistr('D\00E9tail des activit\00E9s de d\00E9veloppeur')
,p_link=>'f?p=&APP_ID.:156:&SESSION.::&DEBUG.:RP::'
,p_page_id=>156
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(833032301623192501.4052)
,p_parent_id=>wwv_flow_api.id(880634492387323345.4052)
,p_short_name=>unistr('Activit\00E9 de l''application d''ex\00E9cution')
,p_link=>'f?p=&APP_ID.:157:&SESSION.::&DEBUG.:RP::'
,p_page_id=>157
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(879929448434711077.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>unistr('Activit\00E9 par espace de travail')
,p_link=>'f?p=&APP_ID.:32:&SESSION.::&DEBUG.:::'
,p_page_id=>32
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(880163125476291015.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>unistr('Activit\00E9 par application')
,p_link=>'f?p=&APP_ID.:50:&SESSION.::&DEBUG.:::'
,p_page_id=>50
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(880595981114924695.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Principales applications'
,p_link=>'f?p=&APP_ID.:71:&SESSION.::&DEBUG.:::'
,p_page_id=>71
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(880632289691302686.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Principaux espaces de travail'
,p_link=>'f?p=&APP_ID.:137:&SESSION.::&DEBUG.:::'
,p_page_id=>137
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(880634492387323345.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>unistr('R\00E9capitulatif de l''activit\00E9')
,p_link=>'f?p=&APP_ID.:138:&SESSION.::&DEBUG.:::'
,p_page_id=>138
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1813869716370998260.4052)
,p_parent_id=>wwv_flow_api.id(4617723690278867.4052)
,p_short_name=>'Vues de page par utilisateur et par jour'
,p_link=>'f?p=&APP_ID.:94:&SESSION.'
,p_page_id=>94
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_4_0_left_and_right_sidebars_from_4999
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(12930201930057128.4052)
,p_theme_id=>3
,p_name=>'APEX 4.0 (Left And Right SideBars) From 4999.fr'
,p_internal_name=>'APEX_4.0_LEFT_AND_RIGHT_SIDEBARS_FROM_4999'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="page-header">',
'  <div>',
'      <a id="apex-logo" href="#HOME_LINK#"><h1>#LOGO#</h1></a>',
'      <div class="nav-bar">#NAVIGATION_BAR#</div>',
'  </div>',
'  <div class="apex-top-bar-end">',
'    <div class="apex-top-bar">',
'       #REGION_POSITION_07#',
'    </div>',
'  </div>',
'  <div id="apex-breadcrumb-region-end">',
'    <div id="apex-breadcrumb-region">',
'      <div id="apex-breadcrumbs">#REGION_POSITION_08#</div>',
'      <div id="apex-help"><a href="&SYSTEM_HELP_URL." target="_blank"><img src="#IMAGE_PREFIX#f_spacer.gif" class="iconSmall help" alt="" /><span>&HELP.</span></a></div>',
'      <div id="apex-controls">#REGION_POSITION_06#</div>',
'    </div>',
'  </div>',
'</div>',
'',
'<div id="htmldbMessageHolder"><a name="SkipRepNav"></a>#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<div class="htmldbBodyMargin">',
'  <div id="apex-main">',
'    <div id="ContentBody">',
'      <div id="apex-two-col">',
'        <div id="apex-sidebar">#REGION_POSITION_03##REGION_POSITION_05#</div>',
'        <div id="apex-content">#REGION_POSITION_02#',
'          <div id="apex-splash">',
'            <div id="RP4">#REGION_POSITION_04#</div>',
'            <div id="BB">#BODY#</div>',
'          </div>',
'        </div>',
'      </div>',
'    </div>',
'    <div id="apex-left-sidebar">#REGION_POSITION_01#</div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="apex-footer-info">',
'  <div style="float:right;">#FLOW_VERSION#</div>',
'  <div style="float:right;">#CUSTOMIZE#</div>',
'</div>',
'<div id="apex-footer">',
'   <div class="content">',
'     <div style="float:left;">&MSG_COMPANY.&nbsp;&MSG_USER.:&nbsp;&USER.</div>',
'     <div style="float:right;">&MSG_LANGUAGE.:&nbsp;&BROWSER_LANGUAGE.&nbsp;|&nbsp;&MSG_COPYRIGHT.</div>',
'   </div>',
'</div>',
'#FORM_CLOSE# <a name="END"><br />',
'</a>',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>16
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>18525205721780073.4052
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140021425975349534.4052)
,p_page_template_id=>wwv_flow_api.id(12930201930057128.4052)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140021587584349534.4052)
,p_page_template_id=>wwv_flow_api.id(12930201930057128.4052)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140021623770349534.4052)
,p_page_template_id=>wwv_flow_api.id(12930201930057128.4052)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140021764516349534.4052)
,p_page_template_id=>wwv_flow_api.id(12930201930057128.4052)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140021850358349534.4052)
,p_page_template_id=>wwv_flow_api.id(12930201930057128.4052)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140021980690349533.4052)
,p_page_template_id=>wwv_flow_api.id(12930201930057128.4052)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140022065000349533.4052)
,p_page_template_id=>wwv_flow_api.id(12930201930057128.4052)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140022155599349533.4052)
,p_page_template_id=>wwv_flow_api.id(12930201930057128.4052)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140022299720349533.4052)
,p_page_template_id=>wwv_flow_api.id(12930201930057128.4052)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_4_0_right_sidebar_from_4999
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(19236405723931959.4052)
,p_theme_id=>3
,p_name=>'APEX 4.0 (Right SideBar) From 4999.fr'
,p_internal_name=>'APEX_4.0_RIGHT_SIDEBAR_FROM_4999'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_06#',
'',
'<div id="htmldbMessageHolder"><a name="SkipRepNav"></a>#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<div class="htmldbBodyMargin">',
'  <div>#REGION_POSITION_01#</div>',
'  <div id="ContentBody">',
'    <table id="apex-page-body" cellspacing="0" cellpadding="0" border="0" summary="">',
'      <tbody>',
'        <tr>',
'          <td class="apex-page-content" width="100%">',
'            #REGION_POSITION_02#',
'            <div id="apex-splash">#REGION_POSITION_04#<div id="BB">#BODY#</div></div>	    ',
'	      </td>',
'          <td class="apex-page-sidebar">#REGION_POSITION_03##REGION_POSITION_05#</td>     ',
'        </tr>',
'      </tbody>',
'    </table>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="apex-footer-info">',
'  <div style="float:right;">#FLOW_VERSION#</div>',
'  <div style="float:right;">#CUSTOMIZE#</div>',
'</div>',
'<div id="apex-footer">',
'   <div class="content">',
'     <div style="float:left;">&MSG_COMPANY.&nbsp;&MSG_USER.:&nbsp;&USER.</div>',
'     <div style="float:right;">&MSG_LANGUAGE.:&nbsp;&BROWSER_LANGUAGE.&nbsp;|&nbsp;&MSG_COPYRIGHT.</div>',
'   </div>',
'</div>',
'#FORM_CLOSE# <a name="END"><br />',
'</a>',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>18525411970780075.4052
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140026119720349528.4052)
,p_page_template_id=>wwv_flow_api.id(19236405723931959.4052)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140026253979349528.4052)
,p_page_template_id=>wwv_flow_api.id(19236405723931959.4052)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140026399069349528.4052)
,p_page_template_id=>wwv_flow_api.id(19236405723931959.4052)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140026468910349527.4052)
,p_page_template_id=>wwv_flow_api.id(19236405723931959.4052)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140026511595349527.4052)
,p_page_template_id=>wwv_flow_api.id(19236405723931959.4052)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140026649914349527.4052)
,p_page_template_id=>wwv_flow_api.id(19236405723931959.4052)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140026752333349527.4052)
,p_page_template_id=>wwv_flow_api.id(19236405723931959.4052)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140026801169349527.4052)
,p_page_template_id=>wwv_flow_api.id(19236405723931959.4052)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140026944711349527.4052)
,p_page_template_id=>wwv_flow_api.id(19236405723931959.4052)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/popup_info
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(20939016234587158.4052)
,p_theme_id=>3
,p_name=>'Popup Info.fr'
,p_internal_name=>'POPUP_INFO'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8">',
'    <title>#TITLE#</title>',
'    <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'    ',
'    #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body #ONLOAD# class="aPopupPage">',
'    <noscript>&MSG_JSCRIPT.</noscript>#FORM_OPEN#<a name="PAGETOP"></a>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="htmldbMessageHolder">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<div>#REGION_POSITION_02##REGION_POSITION_03##REGION_POSITION_04##REGION_POSITION_05##REGION_POSITION_06##BODY#</div>',
'<div style="text-align:middle;">#REGION_POSITION_08#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>19940022257958945.4052
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140028626722349520.4052)
,p_page_template_id=>wwv_flow_api.id(20939016234587158.4052)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140028744547349520.4052)
,p_page_template_id=>wwv_flow_api.id(20939016234587158.4052)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140028867477349520.4052)
,p_page_template_id=>wwv_flow_api.id(20939016234587158.4052)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140028935334349520.4052)
,p_page_template_id=>wwv_flow_api.id(20939016234587158.4052)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140029091727349520.4052)
,p_page_template_id=>wwv_flow_api.id(20939016234587158.4052)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140029157383349520.4052)
,p_page_template_id=>wwv_flow_api.id(20939016234587158.4052)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140029242731349520.4052)
,p_page_template_id=>wwv_flow_api.id(20939016234587158.4052)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_4_2_no_sidebar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(192017709242711618.4052)
,p_theme_id=>3
,p_name=>'APEX 4.2 - No SideBar.fr'
,p_internal_name=>'APEX_4.2_NO_SIDEBAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="page-header">',
'  <div>',
'      <a id="apex-logo" href="#HOME_LINK#"><h1>#LOGO#</h1></a>',
'      <div class="nav-bar">#NAVIGATION_BAR#</div>',
'  </div>',
'  <div class="apex-top-bar-end">',
'    <div class="apex-top-bar">',
'       #REGION_POSITION_07#',
'    </div>',
'  </div>',
'  <div id="apex-breadcrumb-region-end">',
'    <div id="apex-breadcrumb-region">',
'      <div id="apex-breadcrumbs">#REGION_POSITION_08#</div>',
'      <div id="apex-help"><a href="&SYSTEM_HELP_URL." target="_blank"><img src="#IMAGE_PREFIX#f_spacer.gif" class="iconSmall help" alt="" /><span>&HELP.</span></a></div>',
'      <div id="apex-controls">#REGION_POSITION_06#</div>',
'    </div>',
'  </div>',
'</div>',
'',
'<div id="htmldbMessageHolder"><a name="SkipRepNav"></a>#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<div class="htmldbBodyMargin">',
'  <div>#REGION_POSITION_01#</div>',
'  <div id="ContentBody">',
'    <div id="apex-content">#REGION_POSITION_02#',
'      <div id="apex-splash">#REGION_POSITION_04#<div id="BB">#BODY#</div></div>',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="apex-footer-info">',
'  <div style="float:right;">#FLOW_VERSION#</div>',
'  <div style="float:right;">#CUSTOMIZE#</div>',
'</div>',
'<div id="apex-footer">',
'   <div class="content">',
'     <div style="float:left;">&MSG_COMPANY.&nbsp;&MSG_USER.:&nbsp;&USER.</div>',
'     <div style="float:right;">&MSG_LANGUAGE.:&nbsp;&BROWSER_LANGUAGE.&nbsp;|&nbsp;&MSG_COPYRIGHT.</div>',
'   </div>',
'</div>',
'#FORM_CLOSE# <a name="END"><br />',
'</a>',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion failRegion #REGION_CSS_CLASSES#" id="ERROR">',
'  <div class="aRegionContent clearfix">',
'    <div class="aActionRegionIcon">',
'      <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'    </div>',
'    <p><strong>#MESSAGE#</strong></p>',
'    #ADDITIONAL_INFO#',
'    #TECHNICAL_INFO#',
'  </div>',
'  <span class="aButtonContainer">',
'    <button onclick="#BACK_LINK#" class="aButton hotButton"><span>#RETURN_TO_APPLICATION#</span></button>',
'  </span>',
'</section>'))
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>187453329378870285.4052
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140027031188349527.4052)
,p_page_template_id=>wwv_flow_api.id(192017709242711618.4052)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140027141716349522.4052)
,p_page_template_id=>wwv_flow_api.id(192017709242711618.4052)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140027230376349522.4052)
,p_page_template_id=>wwv_flow_api.id(192017709242711618.4052)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140027332401349522.4052)
,p_page_template_id=>wwv_flow_api.id(192017709242711618.4052)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140027436893349521.4052)
,p_page_template_id=>wwv_flow_api.id(192017709242711618.4052)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140027563430349521.4052)
,p_page_template_id=>wwv_flow_api.id(192017709242711618.4052)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140027617173349521.4052)
,p_page_template_id=>wwv_flow_api.id(192017709242711618.4052)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_4_2_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(202661821547388652.4052)
,p_theme_id=>3
,p_name=>'APEX 4.2 - Wizard .fr'
,p_internal_name=>'APEX_4.2_WIZARD_'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body #ONLOAD# class="aWizard">',
'<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="page-header">',
'  <div>',
'      <a id="apex-logo" href="#HOME_LINK#"><h1>#LOGO#</h1></a>',
'      <div class="nav-bar">#NAVIGATION_BAR#</div>',
'  </div>',
'  <div class="apex-top-bar-end">',
'    <div class="apex-top-bar">',
'       #REGION_POSITION_07#',
'    </div>',
'  </div>',
'  <div id="apex-breadcrumb-region-end">',
'    <div id="apex-breadcrumb-region">',
'      <div id="apex-breadcrumbs">#REGION_POSITION_08#</div>',
'      <div id="apex-help"><a href="&SYSTEM_HELP_URL." target="_blank"><img src="#IMAGE_PREFIX#f_spacer.gif" class="iconSmall help" alt="" /><span>&HELP.</span></a></div>',
'      <div id="apex-controls">#REGION_POSITION_06#</div>',
'    </div>',
'  </div>',
'</div>',
'<div class="wizardOuterContainer">',
'#REGION_POSITION_01#',
'<div class="wizardContainer">',
'    <h1 class="visuallyhidden">#TITLE#</h1>',
'    #REGION_POSITION_03#',
'    #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'  <div class="wizardBody">',
'    #BODY#',
'    #REGION_POSITION_04#',
'    #REGION_POSITION_05#',
'  </div>',
'</div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="apex-footer-info">',
'  <div style="float:right;">#FLOW_VERSION#</div>',
'  <div style="float:right;">#CUSTOMIZE#</div>',
'</div>',
'<div id="apex-footer">',
'   <div class="content">',
'     <div style="float:left;">&MSG_COMPANY.&nbsp;&MSG_USER.:&nbsp;&USER.</div>',
'     <div style="float:right;">&MSG_LANGUAGE.:&nbsp;&BROWSER_LANGUAGE.&nbsp;|&nbsp;&MSG_COPYRIGHT.</div>',
'   </div>',
'</div>',
'#FORM_CLOSE# <a name="END"><br />',
'</a>',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'<script>',
'function loadWizardTrain() {',
'	var currentStep = $("li.current,li.first-current,li.last-current",''div.wizardProgress'');',
'	if (currentStep.prev().length > 0) {',
'		currentStep.prevAll().find(''span'').addClass("pastCurrent");',
'	}',
'}',
'$(document).ready(function(){',
'loadWizardTrain();',
'})',
'</script>',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aWizardMessage successMessage" id="aSuccessMessage" role="alert">',
'  <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'  <a href="javascript:void(0)" onclick="$x_Remove(''aSuccessMessage'')" class="aCloseNotification"><span class="visuallyhidden">#CLOSE_NOTIFICATION#</span></a>',
'  #SUCCESS_MESSAGE#',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aWizardMessage errorMessage" id="aErrorMessage" role="alert">',
'  <a href="javascript:void(0)" onclick="$x_Remove(''aErrorMessage'')" class="aCloseNotification"><span class="visuallyhidden">#CLOSE_NOTIFICATION#</span></a>',
'  <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'  #MESSAGE#',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>16
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>42231511193339128.4052
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140029322551349519.4052)
,p_page_template_id=>wwv_flow_api.id(202661821547388652.4052)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140029414093349519.4052)
,p_page_template_id=>wwv_flow_api.id(202661821547388652.4052)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140029586382349519.4052)
,p_page_template_id=>wwv_flow_api.id(202661821547388652.4052)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140029622213349519.4052)
,p_page_template_id=>wwv_flow_api.id(202661821547388652.4052)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140029768425349519.4052)
,p_page_template_id=>wwv_flow_api.id(202661821547388652.4052)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140029853166349519.4052)
,p_page_template_id=>wwv_flow_api.id(202661821547388652.4052)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140029966778349519.4052)
,p_page_template_id=>wwv_flow_api.id(202661821547388652.4052)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140030009878349519.4052)
,p_page_template_id=>wwv_flow_api.id(202661821547388652.4052)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_4_2_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(254111717898955159.4052)
,p_theme_id=>3
,p_name=>'APEX 4.2 - Edit Screen.fr'
,p_internal_name=>'APEX_4.2_EDIT_SCREEN'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="page-header">',
'  <div>',
'      <a id="apex-logo" href="#HOME_LINK#"><h1>#LOGO#</h1></a>',
'      <div class="nav-bar">#NAVIGATION_BAR#</div>',
'  </div>',
'  <div class="apex-top-bar-end">',
'    <div class="apex-top-bar">',
'       #REGION_POSITION_07#',
'    </div>',
'  </div>',
'  <div id="apex-breadcrumb-region-end">',
'    <div id="apex-breadcrumb-region">',
'      <div id="apex-breadcrumbs">#REGION_POSITION_08#</div>',
'      <div id="apex-help"><a href="&SYSTEM_HELP_URL." target="_blank"><img src="#IMAGE_PREFIX#f_spacer.gif" class="iconSmall help" alt="" /><span>&HELP.</span></a></div>',
'      <div id="apex-controls">#REGION_POSITION_06#</div>',
'    </div>',
'  </div>',
'</div>',
'',
'<div id="htmldbMessageHolder"><a name="SkipRepNav"></a>#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<div class="htmldbBodyMargin">',
'  <div>#REGION_POSITION_01#</div>',
'  <div id="ContentBody">',
'    <div id="apex-two-col">',
'      <div id="apex-sidebar">#REGION_POSITION_03##REGION_POSITION_05#</div>',
'      <div id="apex-content">#REGION_POSITION_02#',
'        <div id="apex-edit-screen">#REGION_POSITION_04#<div id="BB">#BODY#</div></div>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="apex-footer-info">',
'  <div style="float:right;">#FLOW_VERSION#</div>',
'  <div style="float:right;">#CUSTOMIZE#</div>',
'</div>',
'<div id="apex-footer">',
'   <div class="content">',
'     <div style="float:left;">&MSG_COMPANY.&nbsp;&MSG_USER.:&nbsp;&USER.</div>',
'     <div style="float:right;">&MSG_LANGUAGE.:&nbsp;&BROWSER_LANGUAGE.&nbsp;|&nbsp;&MSG_COPYRIGHT.</div>',
'   </div>',
'</div>',
'#FORM_CLOSE# <a name="END"><br />',
'</a>',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>1
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>244139901565747496.4052
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140024927956349529.4052)
,p_page_template_id=>wwv_flow_api.id(254111717898955159.4052)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140025012084349529.4052)
,p_page_template_id=>wwv_flow_api.id(254111717898955159.4052)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140025177127349529.4052)
,p_page_template_id=>wwv_flow_api.id(254111717898955159.4052)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140025242522349529.4052)
,p_page_template_id=>wwv_flow_api.id(254111717898955159.4052)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140025332171349529.4052)
,p_page_template_id=>wwv_flow_api.id(254111717898955159.4052)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140025473002349529.4052)
,p_page_template_id=>wwv_flow_api.id(254111717898955159.4052)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140025529705349528.4052)
,p_page_template_id=>wwv_flow_api.id(254111717898955159.4052)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140025687549349528.4052)
,p_page_template_id=>wwv_flow_api.id(254111717898955159.4052)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140025792332349528.4052)
,p_page_template_id=>wwv_flow_api.id(254111717898955159.4052)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_4_0_optional_right_sidebar_table
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(472570002519580607.4052)
,p_theme_id=>3
,p_name=>'APEX 4.0 - Optional Right Sidebar (Table).fr'
,p_internal_name=>'APEX_4.0_OPTIONAL_RIGHT_SIDEBAR_TABLE'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="page-header">',
'  <div>',
'      <a id="apex-logo" href="#HOME_LINK#"><h1>#LOGO#</h1></a>',
'      <div class="nav-bar">#NAVIGATION_BAR#</div>',
'  </div>',
'  <div class="apex-top-bar-end">',
'    <div class="apex-top-bar">',
'       #REGION_POSITION_07#',
'    </div>',
'  </div>',
'  <div id="apex-breadcrumb-region-end">',
'    <div id="apex-breadcrumb-region">',
'      <div id="apex-breadcrumbs">#REGION_POSITION_08#</div>',
'      <div id="apex-help"><a href="&SYSTEM_HELP_URL." target="_blank"><img src="#IMAGE_PREFIX#f_spacer.gif" class="iconSmall help" alt="" /><span>&HELP.</span></a></div>',
'      <div id="apex-controls">#REGION_POSITION_06#</div>',
'    </div>',
'  </div>',
'</div>',
'',
'<div id="htmldbMessageHolder"><a name="SkipRepNav"></a>#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<div class="htmldbBodyMargin">',
'  <div>#REGION_POSITION_01#</div>',
'  <div id="ContentBody">',
'    <table id="apex-page-body" cellspacing="0" cellpadding="0" border="0" summary="">',
'      <tbody>',
'        <tr>',
'          <td class="apex-page-content" width="100%">',
'            #REGION_POSITION_02#',
'            <div id="apex-splash">#REGION_POSITION_04#<div id="BB">#BODY#</div></div>	    ',
'	      </td>',
'          <td class="apex-page-sidebar">#REGION_POSITION_03##REGION_POSITION_05#</td>     ',
'        </tr>',
'      </tbody>',
'    </table>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="apex-footer-info">',
'  <div style="float:right;">#FLOW_VERSION#</div>',
'  <div style="float:right;">#CUSTOMIZE#</div>',
'</div>',
'<div id="apex-footer">',
'   <div class="content">',
'     <div style="float:left;">&MSG_COMPANY.&nbsp;&MSG_USER.:&nbsp;&USER.</div>',
'     <div style="float:right;">&MSG_LANGUAGE.:&nbsp;&BROWSER_LANGUAGE.&nbsp;|&nbsp;&MSG_COPYRIGHT.</div>',
'   </div>',
'</div>',
'#FORM_CLOSE# <a name="END"><br />',
'</a>',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>450655205700156564.4052
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140027708256349521.4052)
,p_page_template_id=>wwv_flow_api.id(472570002519580607.4052)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140027801140349521.4052)
,p_page_template_id=>wwv_flow_api.id(472570002519580607.4052)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140027970340349521.4052)
,p_page_template_id=>wwv_flow_api.id(472570002519580607.4052)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140028033547349521.4052)
,p_page_template_id=>wwv_flow_api.id(472570002519580607.4052)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140028166377349521.4052)
,p_page_template_id=>wwv_flow_api.id(472570002519580607.4052)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140028290442349521.4052)
,p_page_template_id=>wwv_flow_api.id(472570002519580607.4052)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140028310079349520.4052)
,p_page_template_id=>wwv_flow_api.id(472570002519580607.4052)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140028470975349520.4052)
,p_page_template_id=>wwv_flow_api.id(472570002519580607.4052)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140028535566349520.4052)
,p_page_template_id=>wwv_flow_api.id(472570002519580607.4052)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_rw_faceted_search
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(500583153011311249.4052)
,p_theme_id=>3
,p_name=>'APEX RW - Faceted Search.fr'
,p_internal_name=>'APEX_RW_-_FACETED_SEARCH'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES# a-Page--facetedSearch" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>383682332851249713.4052
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(500590032186311315.4052)
,p_page_template_id=>wwv_flow_api.id(500583153011311249.4052)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(500590582122311316.4052)
,p_page_template_id=>wwv_flow_api.id(500583153011311249.4052)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(500591074381311316.4052)
,p_page_template_id=>wwv_flow_api.id(500583153011311249.4052)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(500591543709311316.4052)
,p_page_template_id=>wwv_flow_api.id(500583153011311249.4052)
,p_name=>'Facets'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(500592019931311316.4052)
,p_page_template_id=>wwv_flow_api.id(500583153011311249.4052)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(500592520158311316.4052)
,p_page_template_id=>wwv_flow_api.id(500583153011311249.4052)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(500593083334311317.4052)
,p_page_template_id=>wwv_flow_api.id(500583153011311249.4052)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(517336519765126407.4052)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.fr'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="alert">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="alert">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4052
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898412819287603153.4052)
,p_page_template_id=>wwv_flow_api.id(517336519765126407.4052)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898412996126603154.4052)
,p_page_template_id=>wwv_flow_api.id(517336519765126407.4052)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898413063612603154.4052)
,p_page_template_id=>wwv_flow_api.id(517336519765126407.4052)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898413155205603154.4052)
,p_page_template_id=>wwv_flow_api.id(517336519765126407.4052)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898413294817603154.4052)
,p_page_template_id=>wwv_flow_api.id(517336519765126407.4052)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898413367423603154.4052)
,p_page_template_id=>wwv_flow_api.id(517336519765126407.4052)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898413408026603154.4052)
,p_page_template_id=>wwv_flow_api.id(517336519765126407.4052)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(704456563630760825.4052)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.fr'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="alert">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="alert">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4052
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140030175734349517.4052)
,p_page_template_id=>wwv_flow_api.id(704456563630760825.4052)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140030279966349517.4052)
,p_page_template_id=>wwv_flow_api.id(704456563630760825.4052)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140030341364349517.4052)
,p_page_template_id=>wwv_flow_api.id(704456563630760825.4052)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140030448122349517.4052)
,p_page_template_id=>wwv_flow_api.id(704456563630760825.4052)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140030547290349516.4052)
,p_page_template_id=>wwv_flow_api.id(704456563630760825.4052)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140030672969349516.4052)
,p_page_template_id=>wwv_flow_api.id(704456563630760825.4052)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898413599639603154.4052)
,p_page_template_id=>wwv_flow_api.id(704456563630760825.4052)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898413688332603154.4052)
,p_page_template_id=>wwv_flow_api.id(704456563630760825.4052)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(721098050798687927.4052)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.fr'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4052
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140030788953349516.4052)
,p_page_template_id=>wwv_flow_api.id(721098050798687927.4052)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140030851576349516.4052)
,p_page_template_id=>wwv_flow_api.id(721098050798687927.4052)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140030902057349516.4052)
,p_page_template_id=>wwv_flow_api.id(721098050798687927.4052)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(721098416706687971.4052)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.fr'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4052
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140031062738349516.4052)
,p_page_template_id=>wwv_flow_api.id(721098416706687971.4052)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140031172766349516.4052)
,p_page_template_id=>wwv_flow_api.id(721098416706687971.4052)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140031279108349516.4052)
,p_page_template_id=>wwv_flow_api.id(721098416706687971.4052)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140031334569349516.4052)
,p_page_template_id=>wwv_flow_api.id(721098416706687971.4052)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140031407339349515.4052)
,p_page_template_id=>wwv_flow_api.id(721098416706687971.4052)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140031536936349515.4052)
,p_page_template_id=>wwv_flow_api.id(721098416706687971.4052)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140031648288349515.4052)
,p_page_template_id=>wwv_flow_api.id(721098416706687971.4052)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(721099117305687972.4052)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard.fr'
,p_internal_name=>'APEX_5.0_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4052
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140031761677349515.4052)
,p_page_template_id=>wwv_flow_api.id(721099117305687972.4052)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140031889545349515.4052)
,p_page_template_id=>wwv_flow_api.id(721099117305687972.4052)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140031968654349514.4052)
,p_page_template_id=>wwv_flow_api.id(721099117305687972.4052)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898412455616603153.4052)
,p_page_template_id=>wwv_flow_api.id(721099117305687972.4052)
,p_name=>'Wizard Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898412520151603153.4052)
,p_page_template_id=>wwv_flow_api.id(721099117305687972.4052)
,p_name=>'Wizard Progress List'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898412622980603153.4052)
,p_page_template_id=>wwv_flow_api.id(721099117305687972.4052)
,p_name=>'Wizard Title'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(1898412708480603153.4052)
,p_page_template_id=>wwv_flow_api.id(721099117305687972.4052)
,p_name=>'Wizard Buttons'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(721103220819687982.4052)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.fr'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4052
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140025854131349528.4052)
,p_page_template_id=>wwv_flow_api.id(721103220819687982.4052)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140025998313349528.4052)
,p_page_template_id=>wwv_flow_api.id(721103220819687982.4052)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140026046192349528.4052)
,p_page_template_id=>wwv_flow_api.id(721103220819687982.4052)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/html_image_legacy_apex_5_migration
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(3791713542864.4052)
,p_template_name=>'HTML image (legacy - APEX 5 migration)'
,p_internal_name=>'HTML_IMAGE_LEGACY_APEX_5_MIGRATION'
,p_template=>'<a href="#LINK#" id="#BUTTON_ID#" title="#LABEL!ATTR#"><img src="#BUTTON_CSS_CLASSES#" alt="#LABEL!ATTR#" border="#" #BUTTON_ATTRIBUTES# /></a>'
,p_hot_template=>'<a href="#LINK#" id="#BUTTON_ID#" title="#LABEL!ATTR#"><img src="#BUTTON_CSS_CLASSES#" alt="#LABEL!ATTR#" border="#" #BUTTON_ATTRIBUTES# /></a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>13
,p_template_comment=>'5.0 upgrade'
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_4_2_icon_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(202619211737261364.4052)
,p_template_name=>'APEX 4.2 - Icon Button'
,p_internal_name=>'APEX_4.2_ICON_BUTTON'
,p_template=>'<a href="#LINK#" class="aIconButton" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES# role="button"><img src="#IMAGE_PREFIX#f_spacer.gif" class="#BUTTON_CSS_CLASSES#" alt="#LABEL!ATTR#" /></a>'
,p_hot_template=>'<a href="#LINK#" class="aIconButton" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES# role="button"><img src="#IMAGE_PREFIX#f_spacer.gif" class="#BUTTON_CSS_CLASSES#" alt="#LABEL!ATTR#" /></a>'
,p_reference_id=>46198532248154431.4052
,p_translate_this_template=>'N'
,p_theme_class_id=>0
,p_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="xpbutton" cellspacing="0" cellpadding="0" border="0"  summary="">',
'<tbody class="FFFFFF">',
'<tr>',
'<td class="L" width="4"><img src="#IMAGE_PREFIX#1px_trans.gif" alt="" height="1" width="4"/></td>',
'<td class="C"><a href="#LINK#">#LABEL#</a></td>',
'<td class="R" width="4"><img src="#IMAGE_PREFIX#1px_trans.gif" alt="" height="1" width="4"/></td>',
'</tr>',
'</tbody>',
'</table>'))
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_4_2_next_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(202619414551261366.4052)
,p_template_name=>'APEX 4.2 - Next Button'
,p_internal_name=>'APEX_4.2_NEXT_BUTTON'
,p_template=>'<button class="aButton nextButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span>#LABEL!HTML#<img src="#IMAGE_PREFIX#f_spacer.gif" class="nextBlack" alt=""/></span></button>'
,p_hot_template=>'<button class="aButton hotButton nextButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span>#LABEL!HTML#<img src="#IMAGE_PREFIX#f_spacer.gif" class="nextWhite" alt=""/></span></button>'
,p_reference_id=>40780910892272674.4052
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_4_2_previous_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(202619726455261367.4052)
,p_template_name=>'APEX 4.2 - Previous Button'
,p_internal_name=>'APEX_4.2_PREVIOUS_BUTTON'
,p_template=>'<button title="#LABEL!ATTR#" class="aButton prevButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span><img src="#IMAGE_PREFIX#f_spacer.gif" class="prevBlack" alt="#LABEL!ATTR#" /></span></button>'
,p_hot_template=>'<button title="#LABEL!ATTR#" class="aButton hotButton prevButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span><img src="#IMAGE_PREFIX#f_spacer.gif" class="prevWhite" alt="#LABEL!ATTR#" /></span></button>'
,p_reference_id=>40781222929295107.4052
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_4_1_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(296326723097791037.4052)
,p_template_name=>'APEX 4.1 - Button'
,p_internal_name=>'APEX_4.1_BUTTON'
,p_template=>'<button class="aButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span>#LABEL!HTML#</span></button> '
,p_hot_template=>'<button class="aButton hotButton" onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" type="button"><span>#LABEL!HTML#</span></button> '
,p_reference_id=>275775519061831382.4052
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="button-gray" role="button" title="#LABEL#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span>#LABEL#</span></a> ',
'',
'',
'<a href="#LINK#" class="button-orange" role="button" title="#LABEL#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span>#LABEL#</span></a> '))
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_4_0_next_gray_bg
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(504434004298772014.4052)
,p_template_name=>'APEX 4.0 - Next (gray bg)'
,p_internal_name=>'APEX_4.0_NEXT_GRAY_BG'
,p_template=>'<button onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" class="aButton nextButton rightPill #BUTTON_CSS_CLASSES#" title="#LABEL!ATTR#" type="button"><span><img src="#IMAGE_PREFIX#f_spacer.gif" class="nextBlack" alt="#LABEL!ATTR#" /></span></but'
||'ton> '
,p_hot_template=>'<button onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" class="aButton hotButton nextButton rightPill #BUTTON_CSS_CLASSES#" title="#LABEL!ATTR#" type="button"><span><img src="#IMAGE_PREFIX#f_spacer.gif" class="nextWhite" alt="#LABEL!ATTR#" /></'
||'span></button> '
,p_reference_id=>430240008284905073.4052
,p_translate_this_template=>'N'
,p_theme_class_id=>6
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_4_0_previous_gray_bg
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(504434222085772019.4052)
,p_template_name=>'APEX 4.0 - Previous (gray bg)'
,p_internal_name=>'APEX_4.0_PREVIOUS_GRAY_BG'
,p_template=>'<button onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" class="aButton prevButton leftPill #BUTTON_CSS_CLASSES#" title="#LABEL!ATTR#" type="button"><span><img src="#IMAGE_PREFIX#f_spacer.gif" class="prevBlack" alt="#LABEL!ATTR#" /></span></butt'
||'on>'
,p_hot_template=>'<button onclick="#LINK#" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" class="aButton hotButton prevButton leftPill #BUTTON_CSS_CLASSES#" title="#LABEL!ATTR#" type="button"><span><img src="#IMAGE_PREFIX#f_spacer.gif" class="prevWhite" alt="#LABEL!ATTR#" /></s'
||'pan></button>'
,p_reference_id=>430240500796912446.4052
,p_translate_this_template=>'N'
,p_theme_class_id=>6
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(517372214551202759.4052)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4052
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(517372670814202760.4052)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4052
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(517372928661202760.4052)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4052
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(517373248988202760.4052)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4052
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/html_button_legacy_apex_5_migration
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(517849275695867600.4052)
,p_template_name=>'HTML button (legacy - APEX 5 migration)'
,p_internal_name=>'HTML_BUTTON_LEGACY_APEX_5_MIGRATION'
,p_template=>'<input type="button" value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" id="#BUTTON_ID#" class="#BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES#/>'
,p_hot_template=>'<input type="button" value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" id="#BUTTON_ID#" class="#BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES#/>'
,p_translate_this_template=>'N'
,p_theme_class_id=>13
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/hide_and_show_region_2
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(24425502725250282.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="hide-show-region" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="hide-show-top">',
'    <div class="hide-show-title"><h3>',
'      <a href="#" onclick="htmldb_ToggleTableBody(''i#REGION_STATIC_ID#'',''body#REGION_STATIC_ID#''); return false;">',
'        <img src="#IMAGE_PREFIX#htmldb/builder/rollup_plus_dgray.gif" class="pseudoButtonActive" id="i#REGION_STATIC_ID#" alt="" />',
'        #TITLE#',
'      </a></h3>    ',
'    </div>',
'  </div>',
'  <div class="hide-show-body" style="display:none;" id="body#REGION_STATIC_ID#">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'Hide and Show Region (2)'
,p_internal_name=>'HIDE_AND_SHOW_REGION_2'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>106535103160611208.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140492807779344522.4052)
,p_plug_template_id=>wwv_flow_api.id(24425502725250282.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140492938299344521.4052)
,p_plug_template_id=>wwv_flow_api.id(24425502725250282.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_rounded_corner_large_content
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(29320203159835418.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion altHeading #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.0 Rounded Corner Large  (Content)'
,p_internal_name=>'APEX_4.0_ROUNDED_CORNER_LARGE_CONTENT'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>27763613494297374.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140493050573344521.4052)
,p_plug_template_id=>wwv_flow_api.id(29320203159835418.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140493161639344521.4052)
,p_plug_template_id=>wwv_flow_api.id(29320203159835418.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140493284614344521.4052)
,p_plug_template_id=>wwv_flow_api.id(29320203159835418.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140493321805344521.4052)
,p_plug_template_id=>wwv_flow_api.id(29320203159835418.4052)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140493407010344521.4052)
,p_plug_template_id=>wwv_flow_api.id(29320203159835418.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140493586468344521.4052)
,p_plug_template_id=>wwv_flow_api.id(29320203159835418.4052)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140493656646344521.4052)
,p_plug_template_id=>wwv_flow_api.id(29320203159835418.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140493724006344521.4052)
,p_plug_template_id=>wwv_flow_api.id(29320203159835418.4052)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140493825140344521.4052)
,p_plug_template_id=>wwv_flow_api.id(29320203159835418.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140493975230344520.4052)
,p_plug_template_id=>wwv_flow_api.id(29320203159835418.4052)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140494017415344520.4052)
,p_plug_template_id=>wwv_flow_api.id(29320203159835418.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140494117509344520.4052)
,p_plug_template_id=>wwv_flow_api.id(29320203159835418.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_rounded_corner_small
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(29321105756835436.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion altHeading #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.0 Rounded Corner Small'
,p_internal_name=>'APEX_4.0_ROUNDED_CORNER_SMALL'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>26881811222918187.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140494256755344520.4052)
,p_plug_template_id=>wwv_flow_api.id(29321105756835436.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140494345659344520.4052)
,p_plug_template_id=>wwv_flow_api.id(29321105756835436.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140494418354344520.4052)
,p_plug_template_id=>wwv_flow_api.id(29321105756835436.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140494547350344520.4052)
,p_plug_template_id=>wwv_flow_api.id(29321105756835436.4052)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140494649032344520.4052)
,p_plug_template_id=>wwv_flow_api.id(29321105756835436.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140494717089344520.4052)
,p_plug_template_id=>wwv_flow_api.id(29321105756835436.4052)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140494871250344519.4052)
,p_plug_template_id=>wwv_flow_api.id(29321105756835436.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140494926637344519.4052)
,p_plug_template_id=>wwv_flow_api.id(29321105756835436.4052)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140495057682344519.4052)
,p_plug_template_id=>wwv_flow_api.id(29321105756835436.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140495121633344519.4052)
,p_plug_template_id=>wwv_flow_api.id(29321105756835436.4052)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140495240610344519.4052)
,p_plug_template_id=>wwv_flow_api.id(29321105756835436.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140495368440344519.4052)
,p_plug_template_id=>wwv_flow_api.id(29321105756835436.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_message_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(29446610665366048.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-SystemMessage #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Message Region'
,p_internal_name=>'APEX_5.0_MESSAGE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>29333927116050844.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140495481945344519.4052)
,p_plug_template_id=>wwv_flow_api.id(29446610665366048.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140495532279344519.4052)
,p_plug_template_id=>wwv_flow_api.id(29446610665366048.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_div_with_id_c_htmldbhid
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(29794925290987920.4052)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'APEX 4.0 Div  with ID (c:htmldbHID)'
,p_internal_name=>'APEX_4.0_DIV_WITH_ID_C:HTMLDBHID'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>245224629509817478.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140495645115344519.4052)
,p_plug_template_id=>wwv_flow_api.id(29794925290987920.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140495713682344519.4052)
,p_plug_template_id=>wwv_flow_api.id(29794925290987920.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_rounded_corner_small_gray_top
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(46791917808357778.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.0 - Rounded Corner Small (Gray Top)'
,p_internal_name=>'APEX_4.0_ROUNDED_CORNER_SMALL_GRAY_TOP'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>32612420016685806.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140495849040344518.4052)
,p_plug_template_id=>wwv_flow_api.id(46791917808357778.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140495967168344518.4052)
,p_plug_template_id=>wwv_flow_api.id(46791917808357778.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140496050697344518.4052)
,p_plug_template_id=>wwv_flow_api.id(46791917808357778.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140496111520344518.4052)
,p_plug_template_id=>wwv_flow_api.id(46791917808357778.4052)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140496225188344518.4052)
,p_plug_template_id=>wwv_flow_api.id(46791917808357778.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140496330587344518.4052)
,p_plug_template_id=>wwv_flow_api.id(46791917808357778.4052)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140496453396344518.4052)
,p_plug_template_id=>wwv_flow_api.id(46791917808357778.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140496551798344518.4052)
,p_plug_template_id=>wwv_flow_api.id(46791917808357778.4052)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140496644439344518.4052)
,p_plug_template_id=>wwv_flow_api.id(46791917808357778.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140496719062344518.4052)
,p_plug_template_id=>wwv_flow_api.id(46791917808357778.4052)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140496849309344517.4052)
,p_plug_template_id=>wwv_flow_api.id(46791917808357778.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140496981119344517.4052)
,p_plug_template_id=>wwv_flow_api.id(46791917808357778.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_div_with_id_c_htmldbhid_002
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(47529013609325628.4052)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'APEX 4.0 - Div  with ID (c:htmldbHID)'
,p_internal_name=>'APEX_4.0_DIV_WITH_ID_C:HTMLDBHID'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>245224629509817478.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140497072317344517.4052)
,p_plug_template_id=>wwv_flow_api.id(47529013609325628.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140497193915344517.4052)
,p_plug_template_id=>wwv_flow_api.id(47529013609325628.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_top_bar
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(47530423486325747.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion buttonRegion" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    #BODY#',
'    <span class="aButtonContainer">',
'      #CLOSE##COPY##DELETE##CHANGE##EDIT##PREVIOUS##NEXT##CREATE##EXPAND#',
'    </span>',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.0 - Top Bar '
,p_internal_name=>'APEX_4.0_TOP_BAR_'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>17357218626599946.4052
,p_translate_this_template=>'N'
,p_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <table class="TopBarUIFix" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_STATIC_ID#" width="100%"><tbody class="GreenBar"><tr><td valign="middle" class="L">#BODY#</td><td width="30" class="C"><br /></td><td valign="middle" class='
||'"R" align="right"><span style="margin-right:10px;">#CLOSE#</span>#COPY##DELETE##CHANGE##EDIT##PREVIOUS##NEXT##CREATE##EXPAND#</td></tr></tbody></table>',
''))
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140497260903344517.4052)
,p_plug_template_id=>wwv_flow_api.id(47530423486325747.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140497346614344517.4052)
,p_plug_template_id=>wwv_flow_api.id(47530423486325747.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140497455716344517.4052)
,p_plug_template_id=>wwv_flow_api.id(47530423486325747.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140497561493344517.4052)
,p_plug_template_id=>wwv_flow_api.id(47530423486325747.4052)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140497643692344517.4052)
,p_plug_template_id=>wwv_flow_api.id(47530423486325747.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140497704140344517.4052)
,p_plug_template_id=>wwv_flow_api.id(47530423486325747.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140497890789344516.4052)
,p_plug_template_id=>wwv_flow_api.id(47530423486325747.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140497994361344516.4052)
,p_plug_template_id=>wwv_flow_api.id(47530423486325747.4052)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140498069199344516.4052)
,p_plug_template_id=>wwv_flow_api.id(47530423486325747.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140498147046344516.4052)
,p_plug_template_id=>wwv_flow_api.id(47530423486325747.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140498200512344516.4052)
,p_plug_template_id=>wwv_flow_api.id(47530423486325747.4052)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_div_float_left
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(47565030313994649.4052)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# style="float:left;clear:both;">#BODY#</div>'
,p_page_plug_template_name=>'APEX 4.0 - Div (Float Left)'
,p_internal_name=>'APEX_4.0_DIV_FLOAT_LEFT'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>35964702876463547.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140498389190344516.4052)
,p_plug_template_id=>wwv_flow_api.id(47565030313994649.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140498475843344516.4052)
,p_plug_template_id=>wwv_flow_api.id(47565030313994649.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(75821319588166981.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="rounded-corner-region" id="#REGION_STATIC_ID#" style="width:100%">',
'  <div class="rc-gray-top"><div class="rc-gray-top-r">',
'    <div class="rc-title"><h2>#TITLE#</h2></div>',
'    <div class="rc-buttons">#EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#</div>',
'  </div></div>',
'  <div class="rc-body"><div class="rc-body-r"><div class="rc-content">#BODY#</div></div></div>',
'  <div class="rc-bottom"><div class="rc-bottom-r"></div></div>',
'</div>'))
,p_page_plug_template_name=>'Report Region'
,p_internal_name=>'REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>17354512447599941.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140498576429344516.4052)
,p_plug_template_id=>wwv_flow_api.id(75821319588166981.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140498661656344516.4052)
,p_plug_template_id=>wwv_flow_api.id(75821319588166981.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140498730748344516.4052)
,p_plug_template_id=>wwv_flow_api.id(75821319588166981.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140498813901344515.4052)
,p_plug_template_id=>wwv_flow_api.id(75821319588166981.4052)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140498921522344515.4052)
,p_plug_template_id=>wwv_flow_api.id(75821319588166981.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140499061211344515.4052)
,p_plug_template_id=>wwv_flow_api.id(75821319588166981.4052)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140499174435344515.4052)
,p_plug_template_id=>wwv_flow_api.id(75821319588166981.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140499285630344515.4052)
,p_plug_template_id=>wwv_flow_api.id(75821319588166981.4052)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140499365192344515.4052)
,p_plug_template_id=>wwv_flow_api.id(75821319588166981.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140499409081344515.4052)
,p_plug_template_id=>wwv_flow_api.id(75821319588166981.4052)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140499525469344515.4052)
,p_plug_template_id=>wwv_flow_api.id(75821319588166981.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140499651120344515.4052)
,p_plug_template_id=>wwv_flow_api.id(75821319588166981.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/info_c_htmldbinfo_from_4999
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(79623830123907946.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion sideRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'Info (c:htmldbInfo)  From 4999'
,p_internal_name=>'INFO_C:HTMLDBINFO_FROM_4999'
,p_plug_table_bgcolor=>'#F7F7E7'
,p_theme_id=>3
,p_theme_class_id=>2
,p_plug_heading_bgcolor=>'#F7F7E7'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>17355419405599943.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140499787183344515.4052)
,p_plug_template_id=>wwv_flow_api.id(79623830123907946.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140499894109344514.4052)
,p_plug_template_id=>wwv_flow_api.id(79623830123907946.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140499958451344514.4052)
,p_plug_template_id=>wwv_flow_api.id(79623830123907946.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140500012981344514.4052)
,p_plug_template_id=>wwv_flow_api.id(79623830123907946.4052)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140500135055344514.4052)
,p_plug_template_id=>wwv_flow_api.id(79623830123907946.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140500291246344514.4052)
,p_plug_template_id=>wwv_flow_api.id(79623830123907946.4052)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140500359464344514.4052)
,p_plug_template_id=>wwv_flow_api.id(79623830123907946.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140500442516344514.4052)
,p_plug_template_id=>wwv_flow_api.id(79623830123907946.4052)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140500572989344514.4052)
,p_plug_template_id=>wwv_flow_api.id(79623830123907946.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140500691861344514.4052)
,p_plug_template_id=>wwv_flow_api.id(79623830123907946.4052)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140500785667344513.4052)
,p_plug_template_id=>wwv_flow_api.id(79623830123907946.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140500877587344513.4052)
,p_plug_template_id=>wwv_flow_api.id(79623830123907946.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/titleless_and_borderless
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(102441323786892882.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="rounded-corner-region" id="#REGION_STATIC_ID#" style="width:100%">',
'  <div class="rc-gray-top"><div class="rc-gray-top-r">',
'    <div class="rc-title"><h2>#TITLE#</h2></div>',
'    <div class="rc-buttons">#EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#</div>',
'  </div></div>',
'  <div class="rc-body"><div class="rc-body-r"><div class="rc-content">#BODY#</div></div></div>',
'  <div class="rc-bottom"><div class="rc-bottom-r"></div></div>',
'</div>'))
,p_page_plug_template_name=>'titleless and borderless'
,p_internal_name=>'TITLELESS_AND_BORDERLESS'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>17354512447599941.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140500916246344513.4052)
,p_plug_template_id=>wwv_flow_api.id(102441323786892882.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140501064135344513.4052)
,p_plug_template_id=>wwv_flow_api.id(102441323786892882.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140501141380344513.4052)
,p_plug_template_id=>wwv_flow_api.id(102441323786892882.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140501283412344513.4052)
,p_plug_template_id=>wwv_flow_api.id(102441323786892882.4052)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140501312178344513.4052)
,p_plug_template_id=>wwv_flow_api.id(102441323786892882.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140501447986344513.4052)
,p_plug_template_id=>wwv_flow_api.id(102441323786892882.4052)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140501568793344513.4052)
,p_plug_template_id=>wwv_flow_api.id(102441323786892882.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140501611639344513.4052)
,p_plug_template_id=>wwv_flow_api.id(102441323786892882.4052)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140501705912344512.4052)
,p_plug_template_id=>wwv_flow_api.id(102441323786892882.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140501800280344512.4052)
,p_plug_template_id=>wwv_flow_api.id(102441323786892882.4052)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140501943993344512.4052)
,p_plug_template_id=>wwv_flow_api.id(102441323786892882.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140502034308344512.4052)
,p_plug_template_id=>wwv_flow_api.id(102441323786892882.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/loading_region_hidden_by_default
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(120649317132520102.4052)
,p_layout=>'TABLE'
,p_template=>'<div class="htmldbLoadingRegion" id="#REGION_STATIC_ID#" style="display:none;">#BODY#<br /><img src="#IMAGE_PREFIX#htmldb/icons/wait.gif"  id="loadingIcon" alt="" /></div>'
,p_page_plug_template_name=>'Loading Region (Hidden by Default)'
,p_internal_name=>'LOADING_REGION_HIDDEN_BY_DEFAULT'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>227227325128090607.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140502116163344512.4052)
,p_plug_template_id=>wwv_flow_api.id(120649317132520102.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140502224222344512.4052)
,p_plug_template_id=>wwv_flow_api.id(120649317132520102.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/graybox_no_top_link
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(159419508372158325.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion altHeading editRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'gray-box (no top link)'
,p_internal_name=>'GRAYBOX_NO_TOP_LINK'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>17352808493599936.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140502316026344512.4052)
,p_plug_template_id=>wwv_flow_api.id(159419508372158325.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140502442574344512.4052)
,p_plug_template_id=>wwv_flow_api.id(159419508372158325.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140502509074344512.4052)
,p_plug_template_id=>wwv_flow_api.id(159419508372158325.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140502686233344512.4052)
,p_plug_template_id=>wwv_flow_api.id(159419508372158325.4052)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140502715618344511.4052)
,p_plug_template_id=>wwv_flow_api.id(159419508372158325.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140502812114344511.4052)
,p_plug_template_id=>wwv_flow_api.id(159419508372158325.4052)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140502903024344511.4052)
,p_plug_template_id=>wwv_flow_api.id(159419508372158325.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140503017239344511.4052)
,p_plug_template_id=>wwv_flow_api.id(159419508372158325.4052)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140503128885344511.4052)
,p_plug_template_id=>wwv_flow_api.id(159419508372158325.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140503226350344511.4052)
,p_plug_template_id=>wwv_flow_api.id(159419508372158325.4052)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140503318993344511.4052)
,p_plug_template_id=>wwv_flow_api.id(159419508372158325.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140503468786344511.4052)
,p_plug_template_id=>wwv_flow_api.id(159419508372158325.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/wizard_box_success
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(160718619893151437.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion successRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    <div class="aActionRegionIcon">',
'      <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'    </div>',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'Wizard Box (Success)'
,p_internal_name=>'WIZARD_BOX_SUCCESS'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>149030901078827666.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140503581621344511.4052)
,p_plug_template_id=>wwv_flow_api.id(160718619893151437.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140503638121344511.4052)
,p_plug_template_id=>wwv_flow_api.id(160718619893151437.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140503760540344510.4052)
,p_plug_template_id=>wwv_flow_api.id(160718619893151437.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140503850837344510.4052)
,p_plug_template_id=>wwv_flow_api.id(160718619893151437.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140503964027344510.4052)
,p_plug_template_id=>wwv_flow_api.id(160718619893151437.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140504088628344510.4052)
,p_plug_template_id=>wwv_flow_api.id(160718619893151437.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140504199269344510.4052)
,p_plug_template_id=>wwv_flow_api.id(160718619893151437.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140504226185344510.4052)
,p_plug_template_id=>wwv_flow_api.id(160718619893151437.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140504327801344510.4052)
,p_plug_template_id=>wwv_flow_api.id(160718619893151437.4052)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/wizard_box_confirm
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(162417015526175958.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion confirmRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    <div class="aActionRegionIcon">',
'      <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'    </div>',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'Wizard Box (Confirm)'
,p_internal_name=>'WIZARD_BOX_CONFIRM'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>186682507972859454.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140504467430344510.4052)
,p_plug_template_id=>wwv_flow_api.id(162417015526175958.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140504562236344510.4052)
,p_plug_template_id=>wwv_flow_api.id(162417015526175958.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140504635478344509.4052)
,p_plug_template_id=>wwv_flow_api.id(162417015526175958.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140504777890344509.4052)
,p_plug_template_id=>wwv_flow_api.id(162417015526175958.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140504829790344509.4052)
,p_plug_template_id=>wwv_flow_api.id(162417015526175958.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140504927821344509.4052)
,p_plug_template_id=>wwv_flow_api.id(162417015526175958.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140505006489344509.4052)
,p_plug_template_id=>wwv_flow_api.id(162417015526175958.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140505106410344509.4052)
,p_plug_template_id=>wwv_flow_api.id(162417015526175958.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140505275350344509.4052)
,p_plug_template_id=>wwv_flow_api.id(162417015526175958.4052)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_sidebar_gray_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(195768826832737518.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion sideRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.0 - Sidebar (Gray Header)'
,p_internal_name=>'APEX_4.0_SIDEBAR_GRAY_HEADER'
,p_plug_table_bgcolor=>'#F7F7E7'
,p_theme_id=>3
,p_theme_class_id=>2
,p_plug_heading_bgcolor=>'#F7F7E7'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>17355419405599943.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140505399019344509.4052)
,p_plug_template_id=>wwv_flow_api.id(195768826832737518.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140505447025344509.4052)
,p_plug_template_id=>wwv_flow_api.id(195768826832737518.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140505514940344509.4052)
,p_plug_template_id=>wwv_flow_api.id(195768826832737518.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140505696012344509.4052)
,p_plug_template_id=>wwv_flow_api.id(195768826832737518.4052)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140505787900344508.4052)
,p_plug_template_id=>wwv_flow_api.id(195768826832737518.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140505825980344508.4052)
,p_plug_template_id=>wwv_flow_api.id(195768826832737518.4052)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140505952955344508.4052)
,p_plug_template_id=>wwv_flow_api.id(195768826832737518.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140506021578344508.4052)
,p_plug_template_id=>wwv_flow_api.id(195768826832737518.4052)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140506142878344508.4052)
,p_plug_template_id=>wwv_flow_api.id(195768826832737518.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140506233427344508.4052)
,p_plug_template_id=>wwv_flow_api.id(195768826832737518.4052)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140506308943344508.4052)
,p_plug_template_id=>wwv_flow_api.id(195768826832737518.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140506406026344508.4052)
,p_plug_template_id=>wwv_flow_api.id(195768826832737518.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_anchors
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(195775112470763477.4052)
,p_layout=>'TABLE'
,p_template=>'<div class="a-PageAnchors #COMPONENT_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Page Anchors'
,p_internal_name=>'APEX_5.0_PAGE_ANCHORS'
,p_plug_table_bgcolor=>'white'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'white'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>17354206769599941.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140506596601344508.4052)
,p_plug_template_id=>wwv_flow_api.id(195775112470763477.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140506649119344507.4052)
,p_plug_template_id=>wwv_flow_api.id(195775112470763477.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_wizard_box
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(195777031029763479.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.0 - Wizard Box'
,p_internal_name=>'APEX_4.0_WIZARD_BOX'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>18253116293565611.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140506737249344507.4052)
,p_plug_template_id=>wwv_flow_api.id(195777031029763479.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140506818822344507.4052)
,p_plug_template_id=>wwv_flow_api.id(195777031029763479.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140506950788344507.4052)
,p_plug_template_id=>wwv_flow_api.id(195777031029763479.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140507068037344507.4052)
,p_plug_template_id=>wwv_flow_api.id(195777031029763479.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140507164476344507.4052)
,p_plug_template_id=>wwv_flow_api.id(195777031029763479.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140507227482344507.4052)
,p_plug_template_id=>wwv_flow_api.id(195777031029763479.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140507328628344507.4052)
,p_plug_template_id=>wwv_flow_api.id(195777031029763479.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140507403546344507.4052)
,p_plug_template_id=>wwv_flow_api.id(195777031029763479.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140507567933344507.4052)
,p_plug_template_id=>wwv_flow_api.id(195777031029763479.4052)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_wizard_box_800px
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(195777618558763486.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="rounded-corner-wiz-region" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# style="width:100%;">',
'  <div class="rc-blue-top"><div class="rc-blue-top-r">',
'    <div class="rc-title"><h2>#TITLE#</h2></div>',
'    <div class="rc-buttons">#CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#</div>',
'  </div></div>',
'  <div class="rc-body"><div class="rc-body-r"><div class="rc-content">#BODY#</div></div></div>',
'  <div class="rc-bottom"><div class="rc-bottom-r"></div></div>',
'</div>'))
,p_page_plug_template_name=>'APEX 4.0 - Wizard Box (800px)'
,p_internal_name=>'APEX_4.0_WIZARD_BOX_800PX'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>35936104232216540.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140507644213344506.4052)
,p_plug_template_id=>wwv_flow_api.id(195777618558763486.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140507703984344506.4052)
,p_plug_template_id=>wwv_flow_api.id(195777618558763486.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140507811660344506.4052)
,p_plug_template_id=>wwv_flow_api.id(195777618558763486.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140507906032344506.4052)
,p_plug_template_id=>wwv_flow_api.id(195777618558763486.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140508062000344506.4052)
,p_plug_template_id=>wwv_flow_api.id(195777618558763486.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140508145008344506.4052)
,p_plug_template_id=>wwv_flow_api.id(195777618558763486.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140508225261344506.4052)
,p_plug_template_id=>wwv_flow_api.id(195777618558763486.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140508323578344506.4052)
,p_plug_template_id=>wwv_flow_api.id(195777618558763486.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140508432646344506.4052)
,p_plug_template_id=>wwv_flow_api.id(195777618558763486.4052)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_action_box
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(202652905551384773.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.2 - Action Box'
,p_internal_name=>'APEX_4.2_ACTION_BOX'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>18253116293565611.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140508594987344506.4052)
,p_plug_template_id=>wwv_flow_api.id(202652905551384773.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140508694647344505.4052)
,p_plug_template_id=>wwv_flow_api.id(202652905551384773.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140508758088344505.4052)
,p_plug_template_id=>wwv_flow_api.id(202652905551384773.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140508856064344505.4052)
,p_plug_template_id=>wwv_flow_api.id(202652905551384773.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140508902860344505.4052)
,p_plug_template_id=>wwv_flow_api.id(202652905551384773.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140509058392344505.4052)
,p_plug_template_id=>wwv_flow_api.id(202652905551384773.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140509188209344505.4052)
,p_plug_template_id=>wwv_flow_api.id(202652905551384773.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140509285658344505.4052)
,p_plug_template_id=>wwv_flow_api.id(202652905551384773.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140509387952344505.4052)
,p_plug_template_id=>wwv_flow_api.id(202652905551384773.4052)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_action_box_confirm
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(202653318365384775.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion confirmRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    <div class="aActionRegionIcon">',
'      <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'    </div>',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.2 - Action Box (Confirm)'
,p_internal_name=>'APEX_4.2_ACTION_BOX_CONFIRM'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>186682507972859454.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140509446136344505.4052)
,p_plug_template_id=>wwv_flow_api.id(202653318365384775.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140509500688344505.4052)
,p_plug_template_id=>wwv_flow_api.id(202653318365384775.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140509697638344504.4052)
,p_plug_template_id=>wwv_flow_api.id(202653318365384775.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140509737493344504.4052)
,p_plug_template_id=>wwv_flow_api.id(202653318365384775.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140509858354344504.4052)
,p_plug_template_id=>wwv_flow_api.id(202653318365384775.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140509904513344504.4052)
,p_plug_template_id=>wwv_flow_api.id(202653318365384775.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140510021054344504.4052)
,p_plug_template_id=>wwv_flow_api.id(202653318365384775.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140510186226344504.4052)
,p_plug_template_id=>wwv_flow_api.id(202653318365384775.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140510233173344504.4052)
,p_plug_template_id=>wwv_flow_api.id(202653318365384775.4052)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_wizard_body
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(202653921804384775.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</section>'))
,p_page_plug_template_name=>'APEX 4.2 - Wizard Body'
,p_internal_name=>'APEX_4.2_WIZARD_BODY'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42209615589242480.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140510321608344504.4052)
,p_plug_template_id=>wwv_flow_api.id(202653921804384775.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140510417172344504.4052)
,p_plug_template_id=>wwv_flow_api.id(202653921804384775.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_wizard_body_divider
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(202654431224384775.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion dividerTop" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'<div class="wizardRegionHeading">',
'  <h1>#TITLE#</h1>',
'  <div class="buttonContainer">',
'#EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'  </div>',
'</div>',
'  #BODY#',
'</section>'))
,p_page_plug_template_name=>'APEX 4.2 - Wizard Body (Divider)'
,p_internal_name=>'APEX_4.2_WIZARD_BODY_DIVIDER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42209811475242480.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140510582431344504.4052)
,p_plug_template_id=>wwv_flow_api.id(202654431224384775.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140510637608344503.4052)
,p_plug_template_id=>wwv_flow_api.id(202654431224384775.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140510749175344503.4052)
,p_plug_template_id=>wwv_flow_api.id(202654431224384775.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140510806087344503.4052)
,p_plug_template_id=>wwv_flow_api.id(202654431224384775.4052)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140510923924344503.4052)
,p_plug_template_id=>wwv_flow_api.id(202654431224384775.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140511061537344503.4052)
,p_plug_template_id=>wwv_flow_api.id(202654431224384775.4052)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140511156538344503.4052)
,p_plug_template_id=>wwv_flow_api.id(202654431224384775.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140511266491344503.4052)
,p_plug_template_id=>wwv_flow_api.id(202654431224384775.4052)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140511329148344503.4052)
,p_plug_template_id=>wwv_flow_api.id(202654431224384775.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140511439653344503.4052)
,p_plug_template_id=>wwv_flow_api.id(202654431224384775.4052)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140511523726344502.4052)
,p_plug_template_id=>wwv_flow_api.id(202654431224384775.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140511614715344502.4052)
,p_plug_template_id=>wwv_flow_api.id(202654431224384775.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(202654901374384775.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion dividerTop" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h1><a href="javascript:void(0);" onclick="$(''##REGION_STATIC_ID#_content'').slideToggle();$(''##REGION_STATIC_ID#_img'').toggleClass(''expanded'');" class="hideShowLink"><img src="#IMAGE_PREFIX#f_spacer.gif" class="hideShow" alt="" id="#REGION_STATIC'
||'_ID#_img"/>#TITLE#</a></h1>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.2 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_4.2_WIZARD_BODY_HIDE/SHOW'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210116661242480.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140511748244344502.4052)
,p_plug_template_id=>wwv_flow_api.id(202654901374384775.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140511863757344502.4052)
,p_plug_template_id=>wwv_flow_api.id(202654901374384775.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140511973446344502.4052)
,p_plug_template_id=>wwv_flow_api.id(202654901374384775.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140512045671344502.4052)
,p_plug_template_id=>wwv_flow_api.id(202654901374384775.4052)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140512181052344502.4052)
,p_plug_template_id=>wwv_flow_api.id(202654901374384775.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140512219762344502.4052)
,p_plug_template_id=>wwv_flow_api.id(202654901374384775.4052)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140512316263344502.4052)
,p_plug_template_id=>wwv_flow_api.id(202654901374384775.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140512482340344502.4052)
,p_plug_template_id=>wwv_flow_api.id(202654901374384775.4052)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140512571169344501.4052)
,p_plug_template_id=>wwv_flow_api.id(202654901374384775.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140512692976344501.4052)
,p_plug_template_id=>wwv_flow_api.id(202654901374384775.4052)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140512762516344501.4052)
,p_plug_template_id=>wwv_flow_api.id(202654901374384775.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140512860208344501.4052)
,p_plug_template_id=>wwv_flow_api.id(202654901374384775.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_wizard_buttons
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(202655418716384775.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardButtonsContainer" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="leftButtons">',
'    #PREVIOUS##DELETE##CHANGE##CLOSE#',
'  </div>',
'  <div class="rightButtons">',
'    #EDIT##CREATE##NEXT#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 4.2 - Wizard Buttons'
,p_internal_name=>'APEX_4.2_WIZARD_BUTTONS'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210411889242480.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140512972298344501.4052)
,p_plug_template_id=>wwv_flow_api.id(202655418716384775.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140513018943344501.4052)
,p_plug_template_id=>wwv_flow_api.id(202655418716384775.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140513178603344501.4052)
,p_plug_template_id=>wwv_flow_api.id(202655418716384775.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140513206180344501.4052)
,p_plug_template_id=>wwv_flow_api.id(202655418716384775.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140513341563344501.4052)
,p_plug_template_id=>wwv_flow_api.id(202655418716384775.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140513428026344501.4052)
,p_plug_template_id=>wwv_flow_api.id(202655418716384775.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140513527312344500.4052)
,p_plug_template_id=>wwv_flow_api.id(202655418716384775.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140513632203344500.4052)
,p_plug_template_id=>wwv_flow_api.id(202655418716384775.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140513724627344500.4052)
,p_plug_template_id=>wwv_flow_api.id(202655418716384775.4052)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_wizard_box_confirm
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(203640520174520127.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion confirmRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    <div class="aActionRegionIcon">',
'      <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'    </div>',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.0 - Wizard Box (Confirm)'
,p_internal_name=>'APEX_4.0_WIZARD_BOX_CONFIRM'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>186682507972859454.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140513869018344500.4052)
,p_plug_template_id=>wwv_flow_api.id(203640520174520127.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140513937834344500.4052)
,p_plug_template_id=>wwv_flow_api.id(203640520174520127.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140514020419344500.4052)
,p_plug_template_id=>wwv_flow_api.id(203640520174520127.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140514159720344500.4052)
,p_plug_template_id=>wwv_flow_api.id(203640520174520127.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140514203837344500.4052)
,p_plug_template_id=>wwv_flow_api.id(203640520174520127.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140514359868344500.4052)
,p_plug_template_id=>wwv_flow_api.id(203640520174520127.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140514451009344500.4052)
,p_plug_template_id=>wwv_flow_api.id(203640520174520127.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140514582767344499.4052)
,p_plug_template_id=>wwv_flow_api.id(203640520174520127.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140514638711344499.4052)
,p_plug_template_id=>wwv_flow_api.id(203640520174520127.4052)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/copy_of_apex_4_2_edit_region_gray_box_c_htmldbgbr_100
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(254125117493020184.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion altHeading editRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'      <a href="#" class="aIconButton" onclick="uF();return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" class="upIcon" alt="&TOP." /></a>',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'Copy of APEX 4.2 - Edit Region - Gray Box (c:htmldbGBR) (100%)'
,p_internal_name=>'COPY_OF_APEX_4.2_EDIT_REGION_GRAY_BOX_C:HTMLDBGBR_100%'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>17353903289599940.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140514756147344499.4052)
,p_plug_template_id=>wwv_flow_api.id(254125117493020184.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140514869572344499.4052)
,p_plug_template_id=>wwv_flow_api.id(254125117493020184.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140514973918344499.4052)
,p_plug_template_id=>wwv_flow_api.id(254125117493020184.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140515034457344499.4052)
,p_plug_template_id=>wwv_flow_api.id(254125117493020184.4052)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140515151769344499.4052)
,p_plug_template_id=>wwv_flow_api.id(254125117493020184.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140515209152344499.4052)
,p_plug_template_id=>wwv_flow_api.id(254125117493020184.4052)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140515315481344499.4052)
,p_plug_template_id=>wwv_flow_api.id(254125117493020184.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140515410041344498.4052)
,p_plug_template_id=>wwv_flow_api.id(254125117493020184.4052)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140515556121344498.4052)
,p_plug_template_id=>wwv_flow_api.id(254125117493020184.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140515633999344498.4052)
,p_plug_template_id=>wwv_flow_api.id(254125117493020184.4052)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140515790453344498.4052)
,p_plug_template_id=>wwv_flow_api.id(254125117493020184.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140515839090344498.4052)
,p_plug_template_id=>wwv_flow_api.id(254125117493020184.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_sidebar_navigation
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(466735715814370929.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion sideRegion sideNavRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.0 - Sidebar Navigation'
,p_internal_name=>'APEX_4.0_SIDEBAR_NAVIGATION'
,p_plug_table_bgcolor=>'#F7F7E7'
,p_theme_id=>3
,p_theme_class_id=>2
,p_plug_heading_bgcolor=>'#F7F7E7'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>456726627253419549.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140515994447344498.4052)
,p_plug_template_id=>wwv_flow_api.id(466735715814370929.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140516058466344498.4052)
,p_plug_template_id=>wwv_flow_api.id(466735715814370929.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140516188208344498.4052)
,p_plug_template_id=>wwv_flow_api.id(466735715814370929.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140516273172344498.4052)
,p_plug_template_id=>wwv_flow_api.id(466735715814370929.4052)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140516398187344497.4052)
,p_plug_template_id=>wwv_flow_api.id(466735715814370929.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140516441419344497.4052)
,p_plug_template_id=>wwv_flow_api.id(466735715814370929.4052)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140516501341344497.4052)
,p_plug_template_id=>wwv_flow_api.id(466735715814370929.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140516610816344497.4052)
,p_plug_template_id=>wwv_flow_api.id(466735715814370929.4052)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140516701991344497.4052)
,p_plug_template_id=>wwv_flow_api.id(466735715814370929.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140516892584344497.4052)
,p_plug_template_id=>wwv_flow_api.id(466735715814370929.4052)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140516999704344497.4052)
,p_plug_template_id=>wwv_flow_api.id(466735715814370929.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140517036957344497.4052)
,p_plug_template_id=>wwv_flow_api.id(466735715814370929.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/hide_and_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(472643325100618624.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="hide-show-region" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="hide-show-top">',
'    <div class="hide-show-title"><h3>',
'      <a href="#" onclick="htmldb_ToggleTableBody(''i#REGION_STATIC_ID#'',''body#REGION_STATIC_ID#''); return false;">',
'        <img src="#IMAGE_PREFIX#htmldb/builder/rollup_plus_dgray.gif" class="pseudoButtonActive" id="i#REGION_STATIC_ID#" alt="" />',
'        #TITLE#',
'      </a></h3>    ',
'    </div>',
'  </div>',
'  <div class="hide-show-body" style="display:none;" id="body#REGION_STATIC_ID#">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'Hide and Show Region'
,p_internal_name=>'HIDE_AND_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>18662712241194598.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140517187263344497.4052)
,p_plug_template_id=>wwv_flow_api.id(472643325100618624.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140517286905344497.4052)
,p_plug_template_id=>wwv_flow_api.id(472643325100618624.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_rounded_corner_large_blue
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(484944923953702457.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion altHeading #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.0 - Rounded Corner Large (Blue)'
,p_internal_name=>'APEX_4.0_ROUNDED_CORNER_LARGE_BLUE'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>27763613494297374.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140517358985344496.4052)
,p_plug_template_id=>wwv_flow_api.id(484944923953702457.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140517453564344496.4052)
,p_plug_template_id=>wwv_flow_api.id(484944923953702457.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140517524039344496.4052)
,p_plug_template_id=>wwv_flow_api.id(484944923953702457.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140517601185344496.4052)
,p_plug_template_id=>wwv_flow_api.id(484944923953702457.4052)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140517750513344496.4052)
,p_plug_template_id=>wwv_flow_api.id(484944923953702457.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140517811865344496.4052)
,p_plug_template_id=>wwv_flow_api.id(484944923953702457.4052)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140517953400344496.4052)
,p_plug_template_id=>wwv_flow_api.id(484944923953702457.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140518003026344496.4052)
,p_plug_template_id=>wwv_flow_api.id(484944923953702457.4052)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140518166734344496.4052)
,p_plug_template_id=>wwv_flow_api.id(484944923953702457.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140518210831344496.4052)
,p_plug_template_id=>wwv_flow_api.id(484944923953702457.4052)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140518339309344495.4052)
,p_plug_template_id=>wwv_flow_api.id(484944923953702457.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140518418796344495.4052)
,p_plug_template_id=>wwv_flow_api.id(484944923953702457.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(517376500704206647.4052)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140518599826344495.4052)
,p_plug_template_id=>wwv_flow_api.id(517376500704206647.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140518602785344495.4052)
,p_plug_template_id=>wwv_flow_api.id(517376500704206647.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140518746422344495.4052)
,p_plug_template_id=>wwv_flow_api.id(517376500704206647.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140518805678344495.4052)
,p_plug_template_id=>wwv_flow_api.id(517376500704206647.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(517418631967368160.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4052
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140518981580344495.4052)
,p_plug_template_id=>wwv_flow_api.id(517418631967368160.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140519096335344495.4052)
,p_plug_template_id=>wwv_flow_api.id(517418631967368160.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140519182817344495.4052)
,p_plug_template_id=>wwv_flow_api.id(517418631967368160.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140519296779344495.4052)
,p_plug_template_id=>wwv_flow_api.id(517418631967368160.4052)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140519308577344494.4052)
,p_plug_template_id=>wwv_flow_api.id(517418631967368160.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140519473686344494.4052)
,p_plug_template_id=>wwv_flow_api.id(517418631967368160.4052)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140519540066344494.4052)
,p_plug_template_id=>wwv_flow_api.id(517418631967368160.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140519659294344494.4052)
,p_plug_template_id=>wwv_flow_api.id(517418631967368160.4052)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140519712958344494.4052)
,p_plug_template_id=>wwv_flow_api.id(517418631967368160.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140519874669344494.4052)
,p_plug_template_id=>wwv_flow_api.id(517418631967368160.4052)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140519982533344494.4052)
,p_plug_template_id=>wwv_flow_api.id(517418631967368160.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140520039555344494.4052)
,p_plug_template_id=>wwv_flow_api.id(517418631967368160.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140520162736344494.4052)
,p_plug_template_id=>wwv_flow_api.id(517418631967368160.4052)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_top_buttons
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(517418935080368162.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--left">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--right">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region (Top Buttons)'
,p_internal_name=>'APEX_5.0_REGION_TOP_BUTTONS'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174747104640428780.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140478301979344537.4052)
,p_plug_template_id=>wwv_flow_api.id(517418935080368162.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140478441212344537.4052)
,p_plug_template_id=>wwv_flow_api.id(517418935080368162.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140478551032344536.4052)
,p_plug_template_id=>wwv_flow_api.id(517418935080368162.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140478676399344536.4052)
,p_plug_template_id=>wwv_flow_api.id(517418935080368162.4052)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140478793229344536.4052)
,p_plug_template_id=>wwv_flow_api.id(517418935080368162.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140478875553344536.4052)
,p_plug_template_id=>wwv_flow_api.id(517418935080368162.4052)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140478900956344536.4052)
,p_plug_template_id=>wwv_flow_api.id(517418935080368162.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140479051835344536.4052)
,p_plug_template_id=>wwv_flow_api.id(517418935080368162.4052)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140479157088344536.4052)
,p_plug_template_id=>wwv_flow_api.id(517418935080368162.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140479226013344536.4052)
,p_plug_template_id=>wwv_flow_api.id(517418935080368162.4052)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140479396803344536.4052)
,p_plug_template_id=>wwv_flow_api.id(517418935080368162.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140479466959344536.4052)
,p_plug_template_id=>wwv_flow_api.id(517418935080368162.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140479573644344535.4052)
,p_plug_template_id=>wwv_flow_api.id(517418935080368162.4052)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(721110277025730268.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140479656705344535.4052)
,p_plug_template_id=>wwv_flow_api.id(721110277025730268.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140479724670344535.4052)
,p_plug_template_id=>wwv_flow_api.id(721110277025730268.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140479893289344535.4052)
,p_plug_template_id=>wwv_flow_api.id(721110277025730268.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140479999683344535.4052)
,p_plug_template_id=>wwv_flow_api.id(721110277025730268.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140480047405344535.4052)
,p_plug_template_id=>wwv_flow_api.id(721110277025730268.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140480198451344535.4052)
,p_plug_template_id=>wwv_flow_api.id(721110277025730268.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140480201390344535.4052)
,p_plug_template_id=>wwv_flow_api.id(721110277025730268.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140480348441344535.4052)
,p_plug_template_id=>wwv_flow_api.id(721110277025730268.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140480420031344535.4052)
,p_plug_template_id=>wwv_flow_api.id(721110277025730268.4052)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(721115784857730284.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140480560754344534.4052)
,p_plug_template_id=>wwv_flow_api.id(721115784857730284.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140480603608344534.4052)
,p_plug_template_id=>wwv_flow_api.id(721115784857730284.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140480777952344534.4052)
,p_plug_template_id=>wwv_flow_api.id(721115784857730284.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140480843837344534.4052)
,p_plug_template_id=>wwv_flow_api.id(721115784857730284.4052)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140480993153344534.4052)
,p_plug_template_id=>wwv_flow_api.id(721115784857730284.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140481034316344534.4052)
,p_plug_template_id=>wwv_flow_api.id(721115784857730284.4052)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140481115933344534.4052)
,p_plug_template_id=>wwv_flow_api.id(721115784857730284.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140481249857344534.4052)
,p_plug_template_id=>wwv_flow_api.id(721115784857730284.4052)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140481314714344534.4052)
,p_plug_template_id=>wwv_flow_api.id(721115784857730284.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140481410103344533.4052)
,p_plug_template_id=>wwv_flow_api.id(721115784857730284.4052)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140481567190344533.4052)
,p_plug_template_id=>wwv_flow_api.id(721115784857730284.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140481681731344533.4052)
,p_plug_template_id=>wwv_flow_api.id(721115784857730284.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140481791861344533.4052)
,p_plug_template_id=>wwv_flow_api.id(721115784857730284.4052)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(721125879764730304.4052)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140481818700344533.4052)
,p_plug_template_id=>wwv_flow_api.id(721125879764730304.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140481987809344533.4052)
,p_plug_template_id=>wwv_flow_api.id(721125879764730304.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140482074541344533.4052)
,p_plug_template_id=>wwv_flow_api.id(721125879764730304.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140482174620344533.4052)
,p_plug_template_id=>wwv_flow_api.id(721125879764730304.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(721128767486730308.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140482281062344533.4052)
,p_plug_template_id=>wwv_flow_api.id(721128767486730308.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140482304711344533.4052)
,p_plug_template_id=>wwv_flow_api.id(721128767486730308.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140482490287344532.4052)
,p_plug_template_id=>wwv_flow_api.id(721128767486730308.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140482563334344532.4052)
,p_plug_template_id=>wwv_flow_api.id(721128767486730308.4052)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140482625069344532.4052)
,p_plug_template_id=>wwv_flow_api.id(721128767486730308.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140482769264344532.4052)
,p_plug_template_id=>wwv_flow_api.id(721128767486730308.4052)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140482822224344532.4052)
,p_plug_template_id=>wwv_flow_api.id(721128767486730308.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140482970426344532.4052)
,p_plug_template_id=>wwv_flow_api.id(721128767486730308.4052)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140483003454344532.4052)
,p_plug_template_id=>wwv_flow_api.id(721128767486730308.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140483152139344532.4052)
,p_plug_template_id=>wwv_flow_api.id(721128767486730308.4052)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140483278127344532.4052)
,p_plug_template_id=>wwv_flow_api.id(721128767486730308.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140483354077344532.4052)
,p_plug_template_id=>wwv_flow_api.id(721128767486730308.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(721129403626730309.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140483485532344531.4052)
,p_plug_template_id=>wwv_flow_api.id(721129403626730309.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140483587802344531.4052)
,p_plug_template_id=>wwv_flow_api.id(721129403626730309.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(721130166613730309.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140483656616344531.4052)
,p_plug_template_id=>wwv_flow_api.id(721130166613730309.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140483750299344531.4052)
,p_plug_template_id=>wwv_flow_api.id(721130166613730309.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(721130822791730313.4052)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140483891951344531.4052)
,p_plug_template_id=>wwv_flow_api.id(721130822791730313.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140483993056344531.4052)
,p_plug_template_id=>wwv_flow_api.id(721130822791730313.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_div_with_id_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(810047731426039801.4052)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'APEX 4.0 - Div with ID and Region Attributes'
,p_internal_name=>'APEX_4.0_DIV_WITH_ID_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>2974803291668087.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140484083799344531.4052)
,p_plug_template_id=>wwv_flow_api.id(810047731426039801.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140484156639344531.4052)
,p_plug_template_id=>wwv_flow_api.id(810047731426039801.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(829706609080810173.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140484246198344531.4052)
,p_plug_template_id=>wwv_flow_api.id(829706609080810173.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140484398818344530.4052)
,p_plug_template_id=>wwv_flow_api.id(829706609080810173.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140484456535344530.4052)
,p_plug_template_id=>wwv_flow_api.id(829706609080810173.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140484581582344530.4052)
,p_plug_template_id=>wwv_flow_api.id(829706609080810173.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140484614191344530.4052)
,p_plug_template_id=>wwv_flow_api.id(829706609080810173.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140484722251344530.4052)
,p_plug_template_id=>wwv_flow_api.id(829706609080810173.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_with_icon
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(966388705490342505.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hasIcon #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'    <div class="a-RegionMedia">',
'      <div class="a-RegionMedia-graphic">',
'        <span class="a-Icon a-Icon--regionIcon #ICON_CSS_CLASSES#"></span>',
'      </div>',
'      <div class="a-RegionMedia-content">',
'        #BODY#',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region with Icon'
,p_internal_name=>'APEX_5.0_REGION_WITH_ICON'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>698829239393878937.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140484877093344530.4052)
,p_plug_template_id=>wwv_flow_api.id(966388705490342505.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140484948913344530.4052)
,p_plug_template_id=>wwv_flow_api.id(966388705490342505.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140485024450344530.4052)
,p_plug_template_id=>wwv_flow_api.id(966388705490342505.4052)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140485192368344530.4052)
,p_plug_template_id=>wwv_flow_api.id(966388705490342505.4052)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140485204389344530.4052)
,p_plug_template_id=>wwv_flow_api.id(966388705490342505.4052)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140485340833344529.4052)
,p_plug_template_id=>wwv_flow_api.id(966388705490342505.4052)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140485408160344529.4052)
,p_plug_template_id=>wwv_flow_api.id(966388705490342505.4052)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140485557672344529.4052)
,p_plug_template_id=>wwv_flow_api.id(966388705490342505.4052)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140485628629344529.4052)
,p_plug_template_id=>wwv_flow_api.id(966388705490342505.4052)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140485751063344529.4052)
,p_plug_template_id=>wwv_flow_api.id(966388705490342505.4052)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140485862715344529.4052)
,p_plug_template_id=>wwv_flow_api.id(966388705490342505.4052)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140485956033344529.4052)
,p_plug_template_id=>wwv_flow_api.id(966388705490342505.4052)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140486066548344529.4052)
,p_plug_template_id=>wwv_flow_api.id(966388705490342505.4052)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1150740889542098395.4052)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4052
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140486144032344529.4052)
,p_plug_template_id=>wwv_flow_api.id(1150740889542098395.4052)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140486253627344528.4052)
,p_plug_template_id=>wwv_flow_api.id(1150740889542098395.4052)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/simple_image_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(15441414872198826.4052)
,p_list_template_current=>'<li><a href="#LINK#" title="#TEXT#">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#" title="#TEXT#">#TEXT#</a></li>'
,p_list_template_name=>'Simple Image List'
,p_internal_name=>'SIMPLE_IMAGE_LIST'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="listwithicon">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>32421627622986728.4052
,p_list_template_comment=>'<img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_large_icons_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(20308202747121796.4052)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX#f_spacer.gif" #IMAGE_ATTR# class="gi-Icon-#IMAGE#" alt="" /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX#f_spacer.gif" #IMAGE_ATTR# class="gi-Icon-#IMAGE#" alt="" /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
,p_list_template_name=>'[EBA] Large Icons List'
,p_internal_name=>'[EBA]_LARGE_ICONS_LIST'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<table class="ebaLargeIcons" width="100%" cellspacing="0" cellpadding="0" border="0" summary=""><tr>'
,p_list_template_after_rows=>'</tr></table>'
,p_reference_id=>20148806760577112.4052
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(27525012681104508.4052)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List (2)'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4052
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_sub_tabs
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(40112922633318119.4052)
,p_list_template_current=>'<li class="a-Tabs-item is-active" aria-current="page"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li class="a-Tabs-item"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_name=>'APEX 5.0 - Sub Tabs'
,p_internal_name=>'APEX_5.0_SUB_TABS'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer a-TabsContainer--subTabs">',
'  <ul class="a-Tabs a-Tabs--subTabButtons">'))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  </ul>',
'</div>'))
,p_reference_id=>168708522102193705.4052
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aSubTabs"><ul>',
'<li class="active"><a href="#LINK#" title="#TEXT_ESC_SC#"><span>#TEXT#</span></a></li>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/horizontal_with_images
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(82702000896937873.4052)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="current">',
'  <div class="image">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# alt="" /></a>',
'  </div>',
'  <div class="label">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a>',
'  </div>',
'</div>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="noncurrent">',
'  <div class="image">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# alt="" /></a>',
'  </div>',
'  <div class="label">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a>',
'  </div>',
'</div>'))
,p_list_template_name=>'horizontal with images'
,p_internal_name=>'HORIZONTAL_WITH_IMAGES'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<div class="apex-list-horizontal">'
,p_list_template_after_rows=>'</div>'
,p_reference_id=>17386714276888490.4052
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_sub_tabs_002
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(169533626431592276.4052)
,p_list_template_current=>'<li class="a-Tabs-item is-active" aria-current="page"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li class="a-Tabs-item"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_name=>'APEX 5.0 - Sub Tabs (2)'
,p_internal_name=>'APEX_5.0_SUB_TABS'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer a-TabsContainer--subTabs">',
'  <ul class="a-Tabs a-Tabs--subTabButtons">'))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  </ul>',
'</div>'))
,p_reference_id=>168708522102193705.4052
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aSubTabs"><ul>',
'<li class="active"><a href="#LINK#" title="#TEXT_ESC_SC#"><span>#TEXT#</span></a></li>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_standard_tabs_with_pull_down
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(192005124361583785.4052)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#LIST_ITEM_ID#" class="current">',
'    <a class="nosub" href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a>',
'</div>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#LIST_ITEM_ID#" class="non-current">',
'    <a class="nosub" href="#LINK#" title="#TEXT_ESC_SC#">#TEXT#</a>',
'</div>',
''))
,p_list_template_name=>'APEX Standard Tabs with pull down'
,p_internal_name=>'APEX_STANDARD_TABS_WITH_PULL_DOWN'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<div id="tabs" class="dhtmlMenuLG">'
,p_list_template_after_rows=>'</div>'
,p_before_sub_list=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul id="S#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="aTabs dhtmlSubMenu pulldown-tabs" style="display:none;">',
''))
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#1px_trans.gif"  width="1" height="1" alt=""  class="dhtmlMenuSep" /></li>'
,p_sub_list_item_noncurrent=>'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)" title="#TEXT_ESC_SC#">#TEXT#</a></li>'
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#LIST_ITEM_ID#" class="current">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#" class="link_text">#TEXT#</a>',
'    <a href="#" onclick="app_AppMenuMultiOpenBottom3(this,''S#LIST_ITEM_ID#'',''#LIST_ITEM_ID#'',false); return false;" class="link_icon">',
'        <img src="#IMAGE_PREFIX#apex/builder/down_dark_12x12.gif" width="12" height="12" class="dhtmlMenu" alt="#IMAGE_ALT#"/>',
'    </a>',
'</div>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#LIST_ITEM_ID#" class="non-current">',
'    <a href="#LINK#" title="#TEXT_ESC_SC#" class="link_text">#TEXT#</a>',
'    <a href="#" onclick="app_AppMenuMultiOpenBottom3(this,''S#LIST_ITEM_ID#'',''#LIST_ITEM_ID#'',false); return false;" class="link_icon">',
'        <img src="#IMAGE_PREFIX#apex/builder/down_dark_12x12.gif" width="12" height="12" class="dhtmlMenu" alt="#IMAGE_ALT#"/>',
'    </a>',
'</div>',
''))
,p_sub_templ_curr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')" title="#TEXT_ESC_SC#"><span>#TEXT#</span><img class="htmldbMIMG" alt="" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></'
||'li>'
,p_sub_templ_noncurr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')" title="#TEXT_ESC_SC#"><span>#TEXT#</span><img class="htmldbMIMG" alt="" src="#IMAGE_PREFIX#menu_open_right2.gif" /></a></'
||'li>'
,p_reference_id=>9651611091899590.4052
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list_002
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(202626814415270397.4052)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List (2) (3)'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4052
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_4_2_wizard_progress_bar
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(202627300168270397.4052)
,p_list_template_current=>'<li class="#LIST_STATUS#"><span>#TEXT#</span></li>'
,p_list_template_noncurrent=>'<li class="#LIST_STATUS#"><span>#TEXT#</span></li>'
,p_list_template_name=>'APEX 4.2 - Wizard Progress Bar'
,p_internal_name=>'APEX_4.2_WIZARD_PROGRESS_BAR'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardProgress">',
'<ul>'))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'</div>'))
,p_reference_id=>42216127932260877.4052
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(517380133540212757.4052)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4052
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(517380464558212757.4052)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4052
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(517410251255325302.4052)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4052
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list_003
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(517410627877325303.4052)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4052
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(721136580461780231.4052)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4052
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(1104606511149216228.4052)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4052
);
end;
/
prompt --application/shared_components/user_interface/templates/report/dhtml_automatic_ppr_pagination_report_from_4999
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(6897002870390711.4052)
,p_row_template_name=>'(DHTML) Automatic PPR Pagination Report  from 4999'
,p_internal_name=>'DHTML_AUTOMATIC_PPR_PAGINATION_REPORT_FROM_4999'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" cellspacing="0" class="u-Report"  border="0" summary="#REGION_TITLE#" id="#REGION_ID#" htmldb:href="p=&APP_ID.:&APP_PAGE_ID.:&SESSION.:pg_R_#REGION_ID#:NO:">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'<tfoot>#PAGINATION#</tfoot>',
'</table>',
'<span class="htmldbCSV">#CSV_LINK#</span>',
'',
'<script language=JavaScript type=text/javascript>',
'<!--',
'init_htmlPPRReport(''#REGION_ID#'');',
'',
'//-->',
'</script>',
'</htmldb:#REGION_ID#>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><span class="a-Icon icon-right-chevron"></span></a>'
,p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><span class="a-Icon icon-left-chevron"></span></a>'
,p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_row_style_mouse_over=>'#CCCCCC'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>6574616710304003.4052
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_4_1_eba_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(20400705845449628.4052)
,p_row_template_name=>'APEX 4.1 [EBA] Standard Report'
,p_internal_name=>'APEX_4.1_[EBA]_STANDARD_REPORT'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" border="0" cellspacing="0" summary="" #REPORT_ATTRIBUTES# id="report_#REGION_STATIC_ID#">#TOP_PAGINATION#',
'<tr>',
'<td><table class="ebaStandardReport" cellspacing="0" cellpadding="0" summary="#REGION_TITLE#" width="100%">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table><div class="CSV">#EXTERNAL_LINK##CSV_LINK#</div></td>',
'</tr>',
'#PAGINATION#',
'</table>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_next_page_template=>'<a href="#LINK#" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_page_template=>'<a href="#LINK#" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_next_set_template=>'<a href="#LINK#" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="#LINK#" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>20327811817377113.4052
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/vertical_plain_c_htmldbverticalregion
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(22621917280199870.4052)
,p_row_template_name=>'Vertical Plain (c:htmldbVerticalRegion)'
,p_internal_name=>'VERTICAL_PLAIN_C:HTMLDBVERTICALREGION'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<tr>',
'<th scope="row" style="text-align:right;" align="right">#COLUMN_HEADER#</th>',
'<td width="100%">#COLUMN_VALUE#</td>',
'</tr>'))
,p_row_template_before_rows=>'#CSV_LINK#<table class="apex-vertical-region"  summary="#REGION_TITLE#" cellpadding="0" cellspacing="0" border="0">'
,p_row_template_after_rows=>'</table>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>82057303211040344.4052
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_4_0_portlet_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(46450823627307947.4052)
,p_row_template_name=>'APEX 4.0 - Portlet Report'
,p_internal_name=>'APEX_4.0_PORTLET_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4052
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_4_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(47555718632924155.4052)
,p_row_template_name=>'APEX 4.0 - Portlet Row Template'
,p_internal_name=>'APEX_4.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4052
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/2_dhtml_automatic_ppr_pagination_report_from_4999
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(81008210556197147.4052)
,p_row_template_name=>'(2) (DHTML) Automatic PPR Pagination Report From 4999 '
,p_internal_name=>'2_DHTML_AUTOMATIC_PPR_PAGINATION_REPORT_FROM_4999_'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="report#REGION_ID#"><htmldb:#REGION_ID#><table cellpadding="0" cellspacing="0" class="u-Report"  border="0" summary="#REGION_TITLE#" id="#REGION_ID#" htmldb:href="p=&APP_ID.:&APP_PAGE_ID.:&SESSION.:pg_R_#REGION_ID#:NO:">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'<tfoot>#PAGINATION#</tfoot>',
'</table>',
'<span class="htmldbCSV">#CSV_LINK#</span>',
'',
'<script language=JavaScript type=text/javascript>',
'<!--',
'init_htmlPPRReport(''#REGION_ID#'');',
'',
'//-->',
'</script>',
'</htmldb:#REGION_ID#>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><span class="a-Icon icon-right-chevron"></span></a>'
,p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><span class="a-Icon icon-left-chevron"></span></a>'
,p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_row_style_mouse_over=>'#CCCCCC'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>6574616710304003.4052
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(805663950138677747.4052)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4052
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(805668813229677842.4052)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4052
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(805669497254677844.4052)
,p_row_template_name=>' APEX 5.0 - Links List'
,p_internal_name=>'_APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4052
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(805670753642677848.4052)
,p_row_template_name=>'APEX 5.0 - Portlet Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4052
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(805671421026677848.4052)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4052
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(805672157251677851.4052)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4052
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_4_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(833359513519625692.4052)
,p_row_template_name=>'APEX 4.0 - Standard Report'
,p_internal_name=>'APEX_4.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4052
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/label_tag_only
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(4925632660752163.4052)
,p_template_name=>'LABEL Tag Only'
,p_internal_name=>'LABEL_TAG_ONLY'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4052
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/form_field_optional
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(111843720754869910.4052)
,p_template_name=>'Form Field Optional'
,p_internal_name=>'FORM_FIELD_OPTIONAL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="aLabel aOptional"><a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_on_error_after_label=>'<small class="aError">#ERROR_MESSAGE#</small>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17388415351892041.4052
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/f_fromfield_required
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(111844628719872228.4052)
,p_template_name=>'f: FromField_Required'
,p_internal_name=>'F:_FROMFIELD_REQUIRED'
,p_template_body1=>'<em>*</em><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="aLabel aRequired"><a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>' <span class="hideMeButHearMe">(#VALUE_REQUIRED#)</span></a></label>'
,p_on_error_after_label=>'<small class="aError">#ERROR_MESSAGE#</small>'
,p_theme_id=>3
,p_theme_class_id=>2
,p_reference_id=>17388508175892042.4052
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(143266721929021448.4052)
,p_template_name=>'Dynamic Attribute'
,p_internal_name=>'DYNAMIC_ATTRIBUTE'
,p_template_body1=>'<em>*</em><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="aLabel aRequired"><a href="javascript:apex.builder.dynamicAttributes.help(''&FB_FLOW_ID.'',''#CURRENT_ITEM_NAME#'');" tabindex="999">'
,p_template_body2=>' <span class="hideMeButHearMe">(#VALUE_REQUIRED#)</span></a></label>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>180457716461887221.4052
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/done_label_optional_no_link
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(148842116797733609.4052)
,p_template_name=>'(Done) Label Optional (No Link)'
,p_internal_name=>'DONE_LABEL_OPTIONAL_NO_LINK'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#"><span class="htmldbLabelOptional">'
,p_template_body2=>'</span></label>'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>238114715839717766.4052
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/htmldb_greenarealabel_c_htmldbgalabel
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(343399818250317904.4052)
,p_template_name=>'htmldb_GreenAreaLabel (c:htmldbGALabel)'
,p_internal_name=>'HTMLDB_GREENAREALABEL_C:HTMLDBGALABEL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#"><a class="apex-ga-label" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>57728329098847875.4052
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(452952500586130526.4052)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4052
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(721133390982759781.4052)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4052
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(721133403814759785.4052)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4052
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(721133598269759785.4052)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4052
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(721133686751759785.4052)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4052
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(832237223281900733.4052)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1405202261752384510.4052)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4052
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(4589126493175495.4052)
,p_name=>'breadcrumbs'
,p_internal_name=>'BREADCRUMBS'
,p_current_page_option=>'<span class="htmldbBreadcrumb">#NAME#</span>'
,p_non_current_page_option=>'<a href="#LINK#" class="htmldbBreadcrumb" title="#NAME#">#NAME#</a>'
,p_between_levels=>'<span class="htmldbBreadcrumbSep"><img alt="" src="#IMAGE_PREFIX#apex/apex_top_sep.gif"></span>'
,p_max_levels=>12
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>60115300853820165.4052
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(517472004210010979.4052)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4052
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(19619131469326417.4052)
,p_page_name=>'winlov'
,p_page_title=>'Dialogue de recherche'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>'Rechercher'
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>'Fermer'
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>'Suivant &gt;'
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>unistr('&lt; Pr\00E9c\00E9dent')
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Ligne(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4052
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/htmldb_calendar_from_4350
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(291623505663181263.4052)
,p_cal_template_name=>'HTMLDB Calendar from 4350'
,p_internal_name=>'HTMLDB_CALENDAR_FROM_4350'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4052
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(72330278206509731.4052)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(204023405870765307.4052)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(556396783772095832.4052)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(556397202054096672.4052)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689622957538993961.4052)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689623969329993963.4052)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689624693980993963.4052)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689626529804993964.4052)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(697060993016402983.4052)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(697230396344708843.4052)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(698684569822187813.4052)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(698685246722187813.4052)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(698685982234187814.4052)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(698687551302187815.4052)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(721118031100730295.4052)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(741002786712616811.4052)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(741003546630616812.4052)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(741003881511616812.4052)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(741004108847616813.4052)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(741004885396616813.4052)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(741005111768616813.4052)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(741005400644616813.4052)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(741005709269616813.4052)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(741006077738616813.4052)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(741006441348616813.4052)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(741006771182616813.4052)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(805664352602677797.4052)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(805665239190677809.4052)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(829707024511810176.4052)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(1104606929671216232.4052)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741058941526941269.4052)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(741002786712616811)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741059100079941270.4052)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(741002786712616811)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741059383377941271.4052)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(741002786712616811)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741059547362941271.4052)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(741002786712616811)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741059767574941271.4052)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(741002786712616811)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741059963746941271.4052)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(741002786712616811)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741060150257941271.4052)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(741003546630616812)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741060352743941271.4052)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(741003881511616812)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741060562611941271.4052)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(741004108847616813)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741060777764941272.4052)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(741003881511616812)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741060923252941272.4052)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(741003881511616812)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741061147880941272.4052)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(741003881511616812)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741061355608941272.4052)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(741004108847616813)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741061562454941272.4052)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(741004885396616813)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741061785251941272.4052)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(741005111768616813)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741061930408941272.4052)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(741005400644616813)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741062140679941272.4052)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(741005709269616813)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741062374659941272.4052)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(741006077738616813)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741062572126941272.4052)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(741004108847616813)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741062777866941272.4052)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(741006441348616813)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741062993093941272.4052)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(741006771182616813)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741063041165941273.4052)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741063226712941273.4052)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(741005400644616813)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741063478339941273.4052)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(741005709269616813)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741063652736941273.4052)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(741006077738616813)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741063738666941273.4052)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741063868051941273.4052)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787115814178949708.4052)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(833359513519625692.4052)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(698684569822187813)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787116053276949708.4052)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(833359513519625692.4052)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(698685246722187813)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787116272015949709.4052)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(833359513519625692.4052)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(698685982234187814)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787116463221949709.4052)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(833359513519625692.4052)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(698685982234187814)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787116655041949709.4052)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(833359513519625692.4052)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(698685982234187814)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787116768540949709.4052)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(833359513519625692.4052)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787116930836949713.4052)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(833359513519625692.4052)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(698687551302187815)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(926398446964707528.4052)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(517380464558212757.4052)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(926398552870707528.4052)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(517380464558212757.4052)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(940696902849341582.4052)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967652406149899654.4052)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(721110277025730268.4052)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967652677759899654.4052)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(721110277025730268.4052)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(689624693980993963)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967652870869899654.4052)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(721110277025730268.4052)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(689624693980993963)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967653049020899654.4052)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(721110277025730268.4052)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(689622957538993961)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967653251462899654.4052)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(721110277025730268.4052)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(689622957538993961)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967653316877899654.4052)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(721110277025730268.4052)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967653518578899654.4052)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(721110277025730268.4052)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(697060993016402983)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967653745948899654.4052)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(721110277025730268.4052)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(697060993016402983)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967654517211901036.4052)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(805663950138677747.4052)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(805664352602677797)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967654725307901036.4052)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(805663950138677747.4052)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(805664352602677797)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967654990742901036.4052)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(805663950138677747.4052)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(805664352602677797)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967655151651901036.4052)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(805663950138677747.4052)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(805665239190677809)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967655310868901036.4052)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(805663950138677747.4052)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(805665239190677809)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967655531082901036.4052)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(805663950138677747.4052)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(805665239190677809)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967655733265901036.4052)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(805663950138677747.4052)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(805665239190677809)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967655999997901036.4052)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(805663950138677747.4052)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(805665239190677809)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967656143487901036.4052)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(805663950138677747.4052)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(805664352602677797)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967656346981901036.4052)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(805663950138677747.4052)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(805664352602677797)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967656530819901037.4052)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(805663950138677747.4052)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(805664352602677797)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967656779856901037.4052)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(805663950138677747.4052)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(805664352602677797)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967656945340901037.4052)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(805663950138677747.4052)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(805664352602677797)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967717343742903434.4052)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(805672157251677851.4052)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(698684569822187813)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967717571202903434.4052)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(805672157251677851.4052)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(698685246722187813)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967717740507903435.4052)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(805672157251677851.4052)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(698685982234187814)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967717902448903435.4052)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(805672157251677851.4052)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(698685982234187814)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967718196465903435.4052)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(805672157251677851.4052)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(698685982234187814)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967718265262903435.4052)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(805672157251677851.4052)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967718461294903435.4052)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(805672157251677851.4052)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(698687551302187815)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967719843756911507.4052)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829706609080810173.4052)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967719965533911507.4052)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829706609080810173.4052)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967720120106911508.4052)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829706609080810173.4052)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(829707024511810176)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967720327654911509.4052)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829706609080810173.4052)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(829707024511810176)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967720583879911509.4052)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829706609080810173.4052)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(829707024511810176)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967720733358911509.4052)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829706609080810173.4052)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(721118031100730295)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967720959540911509.4052)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829706609080810173.4052)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(721118031100730295)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967721004874911509.4052)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829706609080810173.4052)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(967721285604911509.4052)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(829706609080810173.4052)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(829707024511810176)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1104608494214216242.4052)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(1104606511149216228.4052)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(1104606929671216232)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1104608656046216242.4052)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(1104606511149216228.4052)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(1104606929671216232)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1104608867454216242.4052)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(1104606511149216228.4052)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(1104606929671216232)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1104609040571216242.4052)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(1104606511149216228.4052)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(1104606929671216232)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1104609259667216242.4052)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(1104606511149216228.4052)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(1104606929671216232)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1104609398533216242.4052)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(1104606511149216228.4052)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1104609436927216242.4052)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(1104606511149216228.4052)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1104609518065216242.4052)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(1104606511149216228.4052)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1104609672179216242.4052)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(1104606511149216228.4052)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1104609733068216242.4052)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(1104606511149216228.4052)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1199562374089032433.4052)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(741006441348616813)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1241666318933396953.4052)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1150740889542098395.4052)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525651284559182055.4052)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(202626814415270397.4052)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525651360640182055.4052)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(202626814415270397.4052)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525651434587182055.4052)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(202626814415270397.4052)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525651525816182055.4052)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(202626814415270397.4052)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525651779626182055.4052)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(202626814415270397.4052)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(697230396344708843)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525651978926182055.4052)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(202626814415270397.4052)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(697230396344708843)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525653392112182064.4052)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(27525012681104508.4052)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525653440648182064.4052)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(27525012681104508.4052)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525653596475182064.4052)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(27525012681104508.4052)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525653658347182064.4052)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(27525012681104508.4052)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525653836168182064.4052)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(27525012681104508.4052)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(697230396344708843)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525654036872182064.4052)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(27525012681104508.4052)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(697230396344708843)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525657387923182087.4052)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525657473823182087.4052)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525657543497182087.4052)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525657663628182087.4052)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525657833692182087.4052)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(697230396344708843)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525658090172182088.4052)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(697230396344708843)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1544818255170478020.4052)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(805669497254677844.4052)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1544818366864478020.4052)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(805669497254677844.4052)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1544818490278478020.4052)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(805669497254677844.4052)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554805829158408352.4052)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(517418631967368160.4052)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(697060993016402983)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554806001590408352.4052)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(517418631967368160.4052)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(697060993016402983)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554806241730408352.4052)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(517418631967368160.4052)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(689622957538993961)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554806417746408352.4052)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(517418631967368160.4052)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(689622957538993961)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554806699208408352.4052)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(517418631967368160.4052)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(689623969329993963)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554806824411408353.4052)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(517418631967368160.4052)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(689624693980993963)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554807043080408353.4052)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(517418631967368160.4052)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(689626529804993964)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554807217289408353.4052)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(517418631967368160.4052)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(689626529804993964)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554807484461408353.4052)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(517418631967368160.4052)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(689622957538993961)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554807578586408353.4052)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(517418631967368160.4052)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554807728864408353.4052)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(517418631967368160.4052)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(689624693980993963)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554832646705526808.4052)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(721125879764730304.4052)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554832743576526808.4052)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(721125879764730304.4052)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554832892239526808.4052)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(721125879764730304.4052)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554844990556542270.4052)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(721115784857730284.4052)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554845094082542270.4052)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(721115784857730284.4052)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554845229074542270.4052)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(721115784857730284.4052)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(689622957538993961)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554845436412542270.4052)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(721115784857730284.4052)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(689622957538993961)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554845665255542270.4052)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(721115784857730284.4052)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(689623969329993963)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554845827258542271.4052)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(721115784857730284.4052)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(689624693980993963)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554846022920542271.4052)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(721115784857730284.4052)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(689626529804993964)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554846298269542271.4052)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(721115784857730284.4052)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(689626529804993964)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554846416962542271.4052)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(721115784857730284.4052)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(721118031100730295)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554846634990542271.4052)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(721115784857730284.4052)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(721118031100730295)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554858103728550790.4052)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(966388705490342505.4052)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554858341380550790.4052)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(966388705490342505.4052)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(697060993016402983)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554858589140550790.4052)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(966388705490342505.4052)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(689626529804993964)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554858747894550790.4052)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(966388705490342505.4052)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(689624693980993963)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554858923710550790.4052)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(966388705490342505.4052)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(689622957538993961)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554859100162550790.4052)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(966388705490342505.4052)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(697060993016402983)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554859327262550790.4052)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(966388705490342505.4052)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(689622957538993961)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554859544487550790.4052)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(966388705490342505.4052)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(689626529804993964)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554859732911550790.4052)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(966388705490342505.4052)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(689623969329993963)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554859906782550790.4052)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(966388705490342505.4052)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(689622957538993961)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(1082456635473282144.4052)
,p_build_option_name=>'To Be Deleted'
,p_build_option_status=>'EXCLUDE'
,p_build_option_comment=>'Components which should be deleted once verified that it is safe to do so.'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(3913175260740993520.4052)
,p_build_option_name=>'Full Access Only'
,p_build_option_status=>'INCLUDE'
,p_on_upgrade_keep_status=>true
,p_build_option_comment=>'Elements marked with this build option are only to be available to a full (aka on-prem) release of apex.'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(4226407758971148501.4052)
,p_build_option_name=>'Exclude on 5.1.4'
,p_build_option_status=>'INCLUDE'
,p_build_option_comment=>'This build option is used to exclude changes to 5.1.4''s 4050 which were actually made for 5.2 or newer. We are actively developing in 5.1.4 and at some time importing the patchset''s 4050 into trunk.'
);
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/user_interface/shortcuts/mon_sessions
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(3410213449861369.4052)
,p_shortcut_name=>'MON_SESSIONS'
,p_shortcut_type=>'HTML_TEXT'
,p_shortcut=>'<table class="instructiontext" ><tr><td>&nbsp;</td><td><table class="instructiontext" bgcolor="#ffffff" cellspacing=0 cellpadding=0 border="1"><tr><td><a href="f?p=&FLOW_ID.:63:&SESSION."><img src="#IMAGE_PREFIX#monitor_icons_pipes.gif" width="100" h'
||'eight="75" border="0"></a><br/><span class="tiny">&nbsp;Menu&nbsp;Session...</span></td></tr></table></td></tr></table>'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/item_help
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(181820822914271039.4052)
,p_shortcut_name=>'ITEM_HELP'
,p_shortcut_type=>'HTML_TEXT'
,p_error_text=>'Impossible d''afficher l''aide.'
,p_reference_id=>24184979678.4052
,p_shortcut=>'<a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999"><img src="#IMAGE_PREFIX#infoicon_status_gray.gif" width=16 height=16 border=0></a>'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/mon_home
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(190225219130761917.4052)
,p_shortcut_name=>'MON_HOME'
,p_shortcut_type=>'HTML_TEXT'
,p_shortcut=>'<table><tr><td>&nbsp;</td><td><table bgcolor="#ffffff" cellspacing=0 cellpadding=0 border="1"><tr><td><a href="f?p=4050:29:&SESSION."><img src="#IMAGE_PREFIX#flow_monitor2.gif" width="100" height="75" border="0"></a><br><font size="-2" face="arial">M'
||'enu&nbsp;Surveiller...</font></td></tr></table></td></tr></table>'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/install_svg_plugin
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(277012116764271142.4052)
,p_shortcut_name=>'INSTALL_SVG_PLUGIN'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_shortcut=>'Installez le visualiseur SVG pour visualiser le graphique.'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/delete_confirm_msg
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(277511229763806315.4052)
,p_shortcut_name=>'DELETE_CONFIRM_MSG'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_shortcut=>'Voulez-vous effectuer cette action de suppression ?'
);
end;
/
prompt --application/shared_components/security/authentications/saml
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(38542995972952686.4052)
,p_name=>'SAML'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_help_text=>unistr('Ce mod\00E8le utilise l''authentification SAML. Application Express pr\00E9sente les espaces de travail disponibles pour l''utilisateur.')
);
end;
/
prompt --application/shared_components/security/authentications/social_sign_in
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(117701201325189372.4052)
,p_name=>'Social Sign-In'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'
,p_attribute_02=>'OPENID_CONNECT'
,p_attribute_03=>'https://accounts.example.com/.well-known/openid-configuration'
,p_attribute_07=>'profile'
,p_attribute_09=>'email'
,p_attribute_13=>'Y'
,p_cookie_name=>'ORA_WWV_USER_&INSTANCE_ID.'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_help_text=>unistr('Ce mod\00E8le utilise OAuth2 avec un fournisseur d''authentification tiers, comme Oracle Identity Cloud Service.')
);
end;
/
prompt --application/shared_components/security/authentications/database_accounts
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(141712901769416420.4052)
,p_name=>'Database Accounts'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.DB'
,p_cookie_name=>'ORA_WWV_USER_&INSTANCE_ID.'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_help_text=>unistr('Ce mod\00E8le utilise des informations d''identification de base de donn\00E9es. Le nom utilisateur et le mot de passe du compte de base de donn\00E9es servent \00E0 authentifier l''utilisateur.')
);
end;
/
prompt --application/shared_components/security/authentications/application_express_accounts
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(142379011979648757.4052)
,p_name=>'Application Express Accounts'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'
,p_invalid_session_type=>'LOGIN'
,p_cookie_name=>'ORA_WWV_USER_&INSTANCE_ID.'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Il s''agit du mod\00E8le d''authentification par d\00E9faut.'),
unistr('Il authentifie les utilisateurs par rapport au r\00E9f\00E9rentiel utilisateur d''espace de travail.')))
);
end;
/
prompt --application/shared_components/security/authentications/http_header_variable
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(142379504646652140.4052)
,p_name=>'HTTP Header Variable'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.HEADER'
,p_attribute_01=>'OAM_REMOTE_USER'
,p_attribute_02=>'BUILTIN_URL'
,p_attribute_06=>'ALWAYS'
,p_cookie_name=>'ORA_WWV_USER_&INSTANCE_ID.'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ce mod\00E8le repose sur la pr\00E9sence du nom utilisateur dans une variable d''en-t\00EAte HTTP et sur une m\00E9thode de connexion externe.'),
unistr('Application Express pr\00E9sente les espaces de travail disponibles pour l''utilisateur.')))
);
end;
/
prompt --application/shared_components/security/authentications/oracle_application_server_single_sign_on
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(155904925460322166.4052)
,p_name=>'Oracle Application Server Single Sign-On'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SSO'
,p_invalid_session_type=>'URL'
,p_invalid_session_url=>'f?p=4550:20:&SESSION.:::SESSION'
,p_cookie_name=>'ORA_WWV_USER_&INSTANCE_ID.'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ce mod\00E8le permet d''authentifier les d\00E9veloppeurs avec Oracle Single Sign-On,'),
unistr('\00E0 l''aide de la page de connexion externe de SSO.'),
unistr('Apr\00E8s l''authentification, Application Express pr\00E9sente les espaces de travail disponibles pour l''utilisateur.')))
);
end;
/
prompt --application/shared_components/security/authentications/oracle_cloud_identity_management
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(155905406697330949.4052)
,p_name=>'Oracle Cloud Identity Management'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.CLOUD_IDM'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/shared_components/security/authentications/ldap_directory
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(156147800875761157.4052)
,p_name=>'LDAP Directory'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.LDAP'
,p_attribute_01=>'ldap.example.com'
,p_attribute_03=>'NO_SSL'
,p_attribute_04=>'dc=example,dc=com'
,p_attribute_05=>'N'
,p_attribute_06=>'uid=%LDAP_USER%'
,p_attribute_08=>'STD'
,p_invalid_session_type=>'LOGIN'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_help_text=>unistr('Ce mod\00E8le v\00E9rifie les informations d''identification par rapport \00E0 un annuaire LDAP.')
);
end;
/
prompt --application/shared_components/security/authentications/internal_authentication
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(540226219724705040.4052)
,p_name=>'Internal Authentication'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'
,p_invalid_session_type=>'LOGIN'
,p_logout_url=>'f?p=4550:8:&SESSION.'
,p_cookie_name=>'ORA_WWV_USER_&INSTANCE_ID.'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_reference_id=>142379011979648757.4052
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_searchbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1900106178348190.4052)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.SEARCHBOX'
,p_display_name=>'Zone de recherche'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.SEARCHBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_searchbox'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT'
,p_substitute_attributes=>true
,p_reference_id=>42609120788689442.4052
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1513165269066230017.4052)
,p_plugin_id=>wwv_flow_api.id(1900106178348190.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Redirect URL'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_default_value=>'f?p=&APP_ID.:<target page>:&SESSION.::&DEBUG.::<target item>:'
,p_display_length=>80
,p_max_length=>4000
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1513165627970230017.4052)
,p_plugin_id=>wwv_flow_api.id(1900106178348190.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Search Text'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Search'
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
''))
);
end;
/
prompt --application/shared_components/plugins/authorization_type/com_oracle_apex_developer_authorization
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(12523412714527909.4052)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_display_name=>unistr('Autorisation du d\00E9veloppeur')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'),'')
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function is_authorized (',
'    p_authorization in wwv_flow_plugin_api.t_authorization,',
'    p_plugin        in wwv_flow_plugin_api.t_plugin )',
'    return wwv_flow_plugin_api.t_authorization_exec_result',
'is',
'    l_result               wwv_flow_plugin_api.t_authorization_exec_result;',
'begin',
'    l_result.is_authorized := wwv_flow_authorization.is_authorized_developer ( ',
'                                  p_developer_authorization => p_authorization.attribute_01 );',
'    return l_result;',
'exception',
'    when no_data_found then',
'        l_result.is_authorized := false;',
'        return l_result;',
'end;'))
,p_api_version=>1
,p_execution_function=>'is_authorized'
,p_substitute_attributes=>true
,p_reference_id=>12457518297512494.4052
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(651539069522363731.4052)
,p_plugin_id=>wwv_flow_api.id(12523412714527909.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Developer Role'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651539479622363731.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(651539069522363731.4052)
,p_display_sequence=>10
,p_display_value=>'ADMIN: Ability to manage flow developer privileges'
,p_return_value=>'ADMIN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651539960533363731.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(651539069522363731.4052)
,p_display_sequence=>20
,p_display_value=>'EDIT: Ability change all attributes of specified flow(s)'
,p_return_value=>'EDIT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651540498558363732.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(651539069522363731.4052)
,p_display_sequence=>30
,p_display_value=>'HELP: Ability edit help page for a given company'
,p_return_value=>'HELP'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651540919126363741.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(651539069522363731.4052)
,p_display_sequence=>40
,p_display_value=>'BROWSE: Access to Oracle data dictionary browser'
,p_return_value=>'BROWSE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651541427607363741.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(651539069522363731.4052)
,p_display_sequence=>50
,p_display_value=>'CREATE: Ability to create new flows'
,p_return_value=>'CREATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651541944399363741.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(651539069522363731.4052)
,p_display_sequence=>60
,p_display_value=>'MONITOR: Ability to monitor flow activity'
,p_return_value=>'MONITOR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651542483083363741.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(651539069522363731.4052)
,p_display_sequence=>70
,p_display_value=>'DB_MONITOR: Ability to monitor Oracle database attributes'
,p_return_value=>'DB_MONITOR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651542992412363742.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(651539069522363731.4052)
,p_display_sequence=>80
,p_display_value=>'SQL: Ability to issues SQL statements'
,p_return_value=>'SQL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651543405662363742.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(651539069522363731.4052)
,p_display_sequence=>90
,p_display_value=>'USER_MANAGER: Manage user accounts for cookie based authentication'
,p_return_value=>'USER_MANAGER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651543919894363742.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(651539069522363731.4052)
,p_display_sequence=>100
,p_display_value=>'DATA_LOADER: Data Workshop'
,p_return_value=>'DATA_LOADER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651544498595363743.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(651539069522363731.4052)
,p_display_sequence=>110
,p_display_value=>'RESTFUL: Ability to enable RESTful Services'
,p_return_value=>'RESTFUL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651544925039363743.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(651539069522363731.4052)
,p_display_sequence=>130
,p_display_value=>'EDIT or SQL'
,p_return_value=>'EDIT:SQL'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_saml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(77082398185639908.4052)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_display_name=>'INTERNAL SAML'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'),'')
,p_api_version=>2
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_saml'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_saml'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_saml'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_saml'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_saml'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_apex
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(113737019268347425.4052)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'
,p_display_name=>'Comptes Application Express INTERNAL'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_apex'
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_db
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(113749511183746276.4052)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.DB'
,p_display_name=>unistr('Comptes de base de donn\00E9es INTERNAL')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.DB'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_db'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_cloud_idm
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(113749806821809026.4052)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.CLOUD_IDM'
,p_display_name=>'Oracle Cloud Identity Management INTERNAL'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.CLOUD_IDM'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_cloud'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_cloud'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_cloud'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_cloud'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_cloud'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_sso
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(113750429890071859.4052)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SSO'
,p_display_name=>'Oracle Application Server Single Sign-On INTERNAL'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SSO'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_osso'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_osso'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_osso'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_osso'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_osso'
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_social
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(117694777698093086.4052)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'
,p_display_name=>unistr('Connexion par r\00E9seau social INTERNAL')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'),'')
,p_api_version=>2
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_social'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_social'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_social'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_social'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_social'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(117695687338118595.4052)
,p_plugin_id=>wwv_flow_api.id(117694777698093086.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Authentication Provider'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OPENID_CONNECT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(117695928229119805.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(117695687338118595.4052)
,p_display_sequence=>10
,p_display_value=>'OpenID Connect Provider'
,p_return_value=>'OPENID_CONNECT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(117696352639120891.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(117695687338118595.4052)
,p_display_sequence=>20
,p_display_value=>'Generic OAuth2 Provider'
,p_return_value=>'OAUTH2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(117696783335121519.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(117695687338118595.4052)
,p_display_sequence=>30
,p_display_value=>'Google'
,p_return_value=>'GOOGLE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(117697164316122317.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(117695687338118595.4052)
,p_display_sequence=>40
,p_display_value=>'Facebook'
,p_return_value=>'FACEBOOK'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(117697531642127596.4052)
,p_plugin_id=>wwv_flow_api.id(117694777698093086.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Discovery URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(117695687338118595.4052)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OPENID_CONNECT'
,p_examples=>'https://accounts.example.com/.well-known/openid-configuration'
,p_help_text=>'Enter the OpenID Connect provider''s discovery URL.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(117697833997131789.4052)
,p_plugin_id=>wwv_flow_api.id(117694777698093086.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Authorization Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(117695687338118595.4052)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s authorization endpoint URL.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(117698773594144445.4052)
,p_plugin_id=>wwv_flow_api.id(117694777698093086.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Token Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(117695687338118595.4052)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s token endpoint URL.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(117699026040147499.4052)
,p_plugin_id=>wwv_flow_api.id(117694777698093086.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'User Info Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(117695687338118595.4052)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s user info endpoint URL.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(117699383669150422.4052)
,p_plugin_id=>wwv_flow_api.id(117694777698093086.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Scope'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'profile'
,p_is_translatable=>false
,p_help_text=>'Enter a comma separated list of permissions to request for the user who is logging in. The acceptable values depend on your authentication provider. For OpenID Connect and Google, Application Express automatically adds the "openid" scope. The authent'
||'ication provider returns user attributes based on these permissions. You can use a Post Authentication procedure to process these attributes, using the APEX_JSON.GET_% functions.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(117699669144153515.4052)
,p_plugin_id=>wwv_flow_api.id(117694777698093086.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Authentication URI Parameters'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter optional parameters for the authentication URI. Consult the authentication provider''s documentation for supported parameters.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(117699930798156032.4052)
,p_plugin_id=>wwv_flow_api.id(117694777698093086.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Username Attribute'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'email'
,p_is_translatable=>false
,p_help_text=>'Enter the attribute which contains the username. Consult the authentication provider''s documentation for supported attributes.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(117700266287158350.4052)
,p_plugin_id=>wwv_flow_api.id(117694777698093086.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Additional User Attributes'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter a comma separated list of additional user data attributes. Consult the authentication provider''s documentation for supported attributes.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(118714805380694539.4052)
,p_plugin_id=>wwv_flow_api.id(117694777698093086.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Logout URL'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Use this attribute to specify a URL to log out from your authentication provider.',
'For <em>OpenID Connect</em>, &PRODUCT_NAME. automatically uses the <em>end_session</em> endpoint, if that is defined in the <em>Discovery URL</em>.',
'For others, you can use #ID_TOKEN# and #REDIRECT_URI# in the URL, to substitute the ID token that was returned when logging in and the full URL to /apex on your instance, e.g. https://www.example.com/apex/apex.',
'Note that the redirect URI often has to be registered with your authentication provider.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(545772663404782860.4052)
,p_plugin_id=>wwv_flow_api.id(117694777698093086.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>'Token Authentication Method'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BASIC_AND_CLID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(117695687338118595.4052)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_lov_type=>'STATIC'
,p_help_text=>'Enter how the credential''s client ID and client secret should be passed to the server.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545773635912787511.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(545772663404782860.4052)
,p_display_sequence=>10
,p_display_value=>'Basic Authentication'
,p_return_value=>'BASIC'
,p_help_text=>'Send client id and client secret in a Basic Authentication header.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545774284399794249.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(545772663404782860.4052)
,p_display_sequence=>20
,p_display_value=>'Basic Authentication and Client ID in Body'
,p_return_value=>'BASIC_AND_CLID'
,p_help_text=>'Send client id and client secret in a Basic Authentication header, but also send client it in the request body.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545774656584796082.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(545772663404782860.4052)
,p_display_sequence=>30
,p_display_value=>'Client ID and Client Secret in Body'
,p_return_value=>'BODY'
,p_help_text=>'Send client id and client secret in the request body.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(829911836468674176.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(545772663404782860.4052)
,p_display_sequence=>40
,p_display_value=>'Client ID in Body'
,p_return_value=>'CLID'
,p_help_text=>'Only send client id in the request body.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328065699619423743.4052)
,p_plugin_id=>wwv_flow_api.id(117694777698093086.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>91
,p_prompt=>'Verify Username'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'If enabled, &PRODUCT_NAME. will look for an attribute "#username#_verified" (e.g. "email_verified" for Username Attribute "email"). If this is set to "false", the username will not be accepted.'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_plugin_dynamic_attribute
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(143089423556992866.4052)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_display_name=>'Attribut dynamique de module d''extension'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_plugin_attribute'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_plugin_attribute'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:SOURCE'
,p_substitute_attributes=>true
,p_reference_id=>6480508142096556.4052
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_clob_textarea
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(202899010831671075.4052)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.CLOB_TEXTAREA'
,p_display_name=>'Zone de texte CLOB'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.CLOB_TEXTAREA'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_clob_textarea'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_clob_textarea'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:ELEMENT:WIDTH:HEIGHT'
,p_substitute_attributes=>false
,p_reference_id=>200125518386793215.4052
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(729202683815819165.4052)
,p_plugin_id=>wwv_flow_api.id(202899010831671075.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'SQL or PL/SQL to get CLOB value'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_display_length=>80
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This item supports sql statements, like',
'<pre>',
'select big_data',
'from my_table',
'where id=:P4711_ID',
'</pre>',
'and function results, like',
'<pre>',
'return wwv_flow_xxx.get_big_data(p_id => :P4711_ID);',
'</pre>',
'to get a clob value for rendering.',
'',
'To write the data back, the CLOB Textarea makes an AJAX call before the actual page submit, which stores the clob value in wwv_flow_collections.clob001, with a collection name that equals the item name.',
'Developers can then define a page process that stores the clob value where it belongs, either directly',
'<pre>',
'update my_table',
'   set big_data = (select clob001',
'                     from wwv_flow_collections',
'                    where collection_name=''P4711_BIG_DATA'')',
' where id = :P4711_ID;',
'</pre>',
'or via the built-in function wwv_flow_f4000_plugins.get_clob_textarea_value:',
'',
'<pre>',
'update my_table',
'   set agreement_text = wwv_flow_f4000_plugins.get_clob_textarea_value(''P4711_BIG_DATA'')',
' where id = :P4711_ID;',
'</pre>',
''))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(729203035298819166.4052)
,p_plugin_id=>wwv_flow_api.id(202899010831671075.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Textarea Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'HTML'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729203464537819166.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(729203035298819166.4052)
,p_display_sequence=>10
,p_display_value=>'HTML Textarea'
,p_return_value=>'HTML'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(729203974712819166.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(729203035298819166.4052)
,p_display_sequence=>20
,p_display_value=>'Rich Text Editor'
,p_return_value=>'CKEDITOR-Full'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_header
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(708795120396802284.4052)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.HEADER'
,p_display_name=>unistr('Variable d''en-t\00EAte HTTP INTERNAL')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.HEADER'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_header'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_header'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_header'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_header'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_header'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708802916025810450.4052)
,p_plugin_id=>wwv_flow_api.id(708795120396802284.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'HTTP Header Variable Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'OAM_REMOTE_USER'
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specifies the name of the HTTP header variable which contains the username.',
'The default OAM_REMOTE_USER is used by Oracle Access Manager and has to be changed',
'if another authentication provider is used.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708807203689816438.4052)
,p_plugin_id=>wwv_flow_api.id(708795120396802284.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Action if Username is Empty'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BUILTIN_URL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies the action which should be performed if the username stored in the HTTP header variable is empty. The following options are available:',
'</p>',
'<p>',
'<ul>',
'  <li><strong>Redirect to Built-In URL</strong> to initiate a login by the web server. This Built-In URL has to be setup to be protected by the web server, in order to force a login when called. After login, the web server must store the validated us'
||'ername in the HTTP header variable, so it is available to the authentication scheme. The Built-In URL is',
'<pre>/apex/apex_authentication.callback</pre>',
'The prefix <code>/apex/</code> depends on your server configuration.',
'</li>',
'  <li><strong>Redirect to URL</strong> to initiate a login on an external server which then sets the validated username in the HTTP header variable. The external server should redirect back to the application using the URL generated by the <code>#CAL'
||'LBACK#</code> placeholder to complete authentication in the application.</li>',
'  <li><strong>Display Error</strong> will display the specified error message and no login will be performed in the application.</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708811517195820338.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(708807203689816438.4052)
,p_display_sequence=>10
,p_display_value=>'Redirect to Built-In URL'
,p_return_value=>'BUILTIN_URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708823430832833673.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(708807203689816438.4052)
,p_display_sequence=>20
,p_display_value=>'Redirect to URL'
,p_return_value=>'URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708843733040843771.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(708807203689816438.4052)
,p_display_sequence=>30
,p_display_value=>'Display Error'
,p_return_value=>'ERROR'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708855521528859444.4052)
,p_plugin_id=>wwv_flow_api.id(708795120396802284.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(708807203689816438.4052)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_examples=>'http://sso.example.com/?success=#CALLBACK#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies the URL of an external login server which sets the validated username in the HTTP header variable. The external server should redirect back to the application using the URL generated by the <code>#CALLBACK#</code> placeholder to complete au'
||'thentication in the application.',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708859829493861703.4052)
,p_plugin_id=>wwv_flow_api.id(708795120396802284.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Error Message'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(708807203689816438.4052)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ERROR'
,p_help_text=>'Specifies the error message to be displayed if the HTTP header variable does not contain a value or the HTTP header variable does not exist.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1035483720020538244.4052)
,p_plugin_id=>wwv_flow_api.id(708795120396802284.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Verify Username'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALWAYS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(708807203689816438.4052)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'BUILTIN_URL,URL'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies how often the username stored in the HTTP header variable is verified. The following options are available:',
'</p>',
'<p>',
'<ul>',
'  <li><strong>Each Request</strong> will expect that the CGI variable is always set as soon as the login has been performed by the web server. If the username is not identical to the one stored in the current &PRODUCT_NAME. session, the session will '
||'be invalidated and a new login will be initiated. This is the most secure option because it detects logouts or username changes.',
'  </li>',
'  <li><strong>After Login</strong> will only verify and store the username in the &PRODUCT_NAME. session after the web server has performed the login and calls the callback to complete authentication in the application. For callback see "Action if Us'
||'ername is Empty" configuration.',
'  </li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1035499301796542365.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(1035483720020538244.4052)
,p_display_sequence=>10
,p_display_value=>'Each Request'
,p_return_value=>'ALWAYS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1035503608376544352.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(1035483720020538244.4052)
,p_display_sequence=>20
,p_display_value=>'After Login'
,p_return_value=>'CALLBACK'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(195660709366291246.4052)
,p_plugin_id=>wwv_flow_api.id(708795120396802284.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Logout URL of SSO Server'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If the authentication scheme is based on Oracle Access Manager or similar servers,',
'you can use this attribute to specify a URL to log out of the central single sign-on server.',
'<p/>',
'For Oracle Access Manager based SSO, enter for example',
'<pre>',
'/oamsso/logout.html?end_url=%POST_LOGOUT_URL%',
'</pre>',
'The substitution parameter <strong>%POST_LOGOUT_URL%</strong> will be replaced by an encoded URL to the login page of your application.'))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_ldap
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(863910941135523528.4052)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.LDAP'
,p_display_name=>'Annuaire LDAP INTERNAL'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.LDAP'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_ldap'
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le nom utilisateur et le mot de passe permettant l''authentification par rapport \00E0 l''annuaire LDAP identifi\00E9 dans la page de connexion. N''oubliez pas que, pour les mots de passe, il peut y avoir distinction entre les majuscules et les min')
||'uscules.</p>',
''))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(864164037419579163.4052)
,p_plugin_id=>wwv_flow_api.id(863910941135523528.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Host'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'The hostname of your LDAP directory server.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(864172428546586063.4052)
,p_plugin_id=>wwv_flow_api.id(863910941135523528.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Port'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>6
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>'The port number of your LDAP directory host. The default is 389.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(864187751403592682.4052)
,p_plugin_id=>wwv_flow_api.id(863910941135523528.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Use SSL'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Choose whether to use SSL to bind to the LDAP directory. If SSL with Authentication is chosen, a wallet must be configured for the &PRODUCT_NAME. instance.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(864195025907594763.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(864187751403592682.4052)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(864199231794596530.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(864187751403592682.4052)
,p_display_sequence=>20
,p_display_value=>'SSL with Authentication'
,p_return_value=>'SSL_AUTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(864203434218597234.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(864187751403592682.4052)
,p_display_sequence=>30
,p_display_value=>'No SSL'
,p_return_value=>'NO_SSL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(864316046947619765.4052)
,p_plugin_id=>wwv_flow_api.id(863910941135523528.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Distinguished Name (DN) String'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the pattern used to construct the fully qualified distinguished name (DN) string to DBMS_LDAP.SIMPLE_BIND_S if using exact DN or the search base if using non-exact DN. Use <strong>%LDAP_USER%</strong> as a placeholder for the username.  For exa'
||'mple:',
'<p>',
'<strong>Exact DN</strong>',
'</p>',
'<p>',
'cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com',
'</p>',
'<p>',
'<strong>Non-Exact DN (Search Base)</strong>',
'</p>',
'<p>',
'dc=yourdomain,dc=com',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(864250538851608010.4052)
,p_plugin_id=>wwv_flow_api.id(863910941135523528.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Use Exact Distinguished Name (DN)'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Choose whether the LDAP Distinguished Name (DN) String is exact or non-exact. If non-exact, LDAP Distinguished Name (DN) is the search base and you must supply a Search Filter.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(864353444308628540.4052)
,p_plugin_id=>wwv_flow_api.id(863910941135523528.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Search Filter'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(864250538851608010.4052)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the search filter when not using an exact distinguished name (DN). Use <strong>%LDAP_USER%</strong> as a place-holder for the username. For example:',
'</p>',
'<p><pre>cn=%LDAP_USER%</pre></p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(864446826908642374.4052)
,p_plugin_id=>wwv_flow_api.id(863910941135523528.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'LDAP Username Edit Function'
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'You may provide additional code to be executed to transform the username into a format perfectly suited to the LDAP directory entry or LDAP username.',
'The bind variable :USERNAME contains the name the end user specified.',
'For example, the following code calls a function which replaces all "."''s with "_"''s in the DN string:</p>',
'',
'<p><pre>',
'return apex_custom_auth.ldap_dnprep(p_username => :USERNAME);',
'</pre></p>',
'',
'<p>&PRODUCT_NAME. will escape the returned username based on the authentication attribute <strong>Username Escaping</strong>.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(194434206895698724.4052)
,p_plugin_id=>wwv_flow_api.id(863910941135523528.4052)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Username Escaping'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Before replacing <strong>%LDAP_USER%</strong> in the LDAP distinguished name and search string,',
'&PRODUCT_NAME. can automatically escape special characters in the username.',
'<p/>',
'The possible rules for escaping are:',
'<ul>',
'<li><strong>Standard</strong>:',
'Escape special characters based on RFC 4514 (for distinguished names) and RFC 4515 (for search strings).',
'Additionally, escape unicode characters.',
'This is the most secure setting, but may cause problems with some LDAP servers.</li>',
'<li><strong>Only special characters</strong>:',
'Escape special characters based on RFC 4514 (for distinguished names) and RFC 4515 (for search strings).',
'Do not escape unicode characters.</li>',
'<li><strong>No escaping</strong>:',
'Do not escape any characters.',
'This setting is potentially insecure,',
'unless a <strong>Username Edit Function</strong> is employed that already',
'escapes the username (for example with apex_escape.ldap_dn or apex_escape.ldap_search_filter).</li>',
'</ul>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(194434514860701032.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(194434206895698724.4052)
,p_display_sequence=>10
,p_display_value=>'Standard'
,p_return_value=>'STD'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(194434920747702762.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(194434206895698724.4052)
,p_display_sequence=>20
,p_display_value=>'Only special characters'
,p_return_value=>'ONLY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(194435325596704212.4052)
,p_plugin_attribute_id=>wwv_flow_api.id(194434206895698724.4052)
,p_display_sequence=>30
,p_display_value=>'No Escaping'
,p_return_value=>'NO'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/com_oracle_apex_add_checkall_checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2446594583478207883.4052)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
,p_display_name=>'Ajouter la case Cocher tout'
,p_category=>'MISC'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_add_check_all_checkbox'
,p_standard_attributes=>'ONLOAD'
,p_substitute_attributes=>true
,p_reference_id=>1223290239742970512.4052
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>L''action dynamique "Ajouter la case Cocher tout" transforme un en-t\00EAte de colonne contenant la cha\00EEne #CHECK_ALL_CHECKBOX# en une case de type Cocher tout accessible, qui s\00E9lectionnera ou d\00E9s\00E9lectionnera toutes les cases dans la colonne correspond')
||'ante.<p>',
'<p>',
unistr('Pour utiliser ce module d''extension, assurez-vous que les attributs suivants sont d\00E9finis :'),
'<ol>',
unistr('<li>Dans la colonne d''\00E9tat, d\00E9finissez la valeur ''#CHECK_ALL_CHECKBOX#'' comme valeur d''en-t\00EAte.</li>'),
unistr('<li>Pour l''attribut Action dynamique lorsque, s\00E9lectionnez la r\00E9gion d''\00E9tat contenant la colonne.</li>'),
unistr('<li>D\00E9finissez l''action dynamique sur un d\00E9clenchement ''Apr\00E8s r\00E9g\00E9n\00E9ration'' et l''action sur ''D\00E9clencher lors du chargement de la page''. (Les valeurs par d\00E9faut de ces deux actions seront d\00E9finies de fa\00E7on appropri\00E9e si l''action dynamique est cr\00E9\00E9e en')
||unistr(' s\00E9lectionnant la r\00E9gion dans la section ''Affichage'' du concepteur de page et en cr\00E9ant l''action dynamique \00E0 partir de l\00E0.</li>'),
unistr('<li>Cela ne permet pas de g\00E9rer l''accessibilit\00E9 des cases affich\00E9es sur chaque ligne, ce qui doit \00EAtre effectu\00E9 s\00E9par\00E9ment dans la source de r\00E9gion. (Pour obtenir un exemple, reportez-vous \00E0 la r\00E9gion R\00E9gions 4000:656).</li>'),
'</ol>',
'</p>'))
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(4973826483302347.4052)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Bureau'
,p_display_seq=>10
,p_use_auto_detect=>true
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=4050:3:&SESSION.'
,p_login_url=>'f?p=4550:10:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_global_page_id=>.4052
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_include_jquery_migrate=>true
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00000
begin
wwv_flow_api.create_page(
 p_id=>.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('z\00E9ro')
,p_step_title=>unistr('z\00E9ro')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(517338613979160813.4052)
,p_plug_name=>'APEX 5 - Header'
,p_region_css_classes=>'a-Header apex-instance-admin'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517376500704206647.4052)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_07'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(517338869335160813.4052)
,p_plug_name=>'APEX 5 - Header Left'
,p_parent_plug_id=>wwv_flow_api.id(517338613979160813.4052)
,p_region_css_classes=>'a-Header-col a-Header-col--left'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517376500704206647.4052)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(517339036280160813.4052)
,p_plug_name=>'APEX 5 - Logo'
,p_parent_plug_id=>wwv_flow_api.id(517338869335160813.4052)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517376500704206647.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'sys.htp.p(''<a href="f?p=4050:3:''||:APP_SESSION||''::''||:DEBUG||''::::" class="a-Header-logo" title="''||wwv_flow_lang.system_message(''INSTANCE_ADMIN_HOME_NAV'')||''"><span class="a-Header-apexLogo"><span class="u-VisuallyHidden">''||wwv_flow_lang.system_me'
||'ssage(''INSTANCE_ADMIN_HOME_NAV'')||''</span></span></a>'');'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(517339235689160818.4052)
,p_plug_name=>'APEX 5 - Tabs'
,p_parent_plug_id=>wwv_flow_api.id(517338869335160813.4052)
,p_region_css_classes=>'a-Header-tabsContainer'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_api.id(517376500704206647.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(40102013671283832.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(517380133540212757.4052)
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(517339498543160818.4052)
,p_plug_name=>'APEX 5 - Header Right'
,p_parent_plug_id=>wwv_flow_api.id(517338613979160813.4052)
,p_region_css_classes=>'a-Header-col a-Header-col--right'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517376500704206647.4052)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(517339884402160818.4052)
,p_plug_name=>'APEX 5 - Header Navigation Links'
,p_parent_plug_id=>wwv_flow_api.id(517339498543160818.4052)
,p_region_css_classes=>'a-Header-navLinks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517376500704206647.4052)
,p_plug_display_sequence=>70
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(517340077689160819.4052)
,p_plug_name=>'APEX 5 - Admin Menu'
,p_parent_plug_id=>wwv_flow_api.id(517339884402160818.4052)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517376500704206647.4052)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2101406451333034428.4052)
,p_plug_name=>'APEX 5 - Help'
,p_region_name=>'helpMenu'
,p_parent_plug_id=>wwv_flow_api.id(517339884402160818.4052)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517376500704206647.4052)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(2105958267784095383.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(517380464558212757.4052)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(517340236798160820.4052)
,p_plug_name=>'APEX 5 - Account'
,p_parent_plug_id=>wwv_flow_api.id(517339498543160818.4052)
,p_region_css_classes=>'a-Header-account'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517376500704206647.4052)
,p_plug_display_sequence=>90
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4000_ui.account_mega_menu (',
'    p_username          => :APP_USER,',
'    p_workspace_id      => :WORKSPACE_ID,',
'    p_session           => :APP_SESSION,',
'    p_logout_url        => :LOGOUT_URL',
');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(517340434349160820.4052)
,p_plug_name=>'APEX 5 - Control Bar'
,p_region_css_classes=>'a-ControlBar apex-instance-admin'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517376500704206647.4052)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_07'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'3'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(517340605882160820.4052)
,p_plug_name=>'APEX 5 - Control Bar Left'
,p_parent_plug_id=>wwv_flow_api.id(517340434349160820.4052)
,p_region_css_classes=>'a-ControlBar-col a-ControlBar-col--noPadding'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517376500704206647.4052)
,p_plug_display_sequence=>110
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(517340807756160820.4052)
,p_plug_name=>'APEX 5 - Breadcrumb'
,p_parent_plug_id=>wwv_flow_api.id(517340605882160820.4052)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517376500704206647.4052)
,p_plug_display_sequence=>120
,p_plug_display_point=>'SUB_REGIONS'
,p_menu_id=>wwv_flow_api.id(4585800473139662.4052)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(517472004210010979.4052)
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2101406596781034429.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(517339884402160818.4052)
,p_button_name=>'Help'
,p_button_static_id=>'header-helpMenu'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372928661202760.4052)
,p_button_image_alt=>'Aide'
,p_button_position=>'NEXT'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-help'
,p_button_cattributes=>'data-menu="helpMenu_menu"'
);
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Espaces de travail existants'
,p_step_title=>'Espaces de travail existants'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_wrkspc_existing.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(24550226216.4052)
,p_plug_name=>'Espaces de travail'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Cette page permet de rechercher les espaces de travail provisionn\00E9s. Cliquez sur le nom d''un espace de travail pour obtenir un \00E9tat d\00E9taill\00E9 sur ce dernier. Cliquez sur <strong>Supprimer</strong> dans la colonne d''action pour lancer l''assistant Su')
||'ppression d''espace de travail.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated by create flow wizard'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1123402460345350.4052)
,p_plug_name=>'Espaces de travail'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P1a */',
'       short_name,',
'       (case account_status ',
'        when ''AVAILABLE'' then wwv_flow_lang.system_message(''F4050.AVAILABLE'')',
'        when ''ASSIGNED'' then wwv_flow_lang.system_message(''F4050.ASSIGNED'')',
'        when ''SUSPENDED'' then wwv_flow_lang.system_message(''F4050.SUSPENDED'')',
'        when ''TERMINATE'' then wwv_flow_lang.system_message(''F4050.TERMINATE'')',
'        else account_status',
'        end ) account_status ,',
'       display_name,',
'       rm_consumer_group,',
'       nvl(ALLOW_TO_BE_PURGED_YN,''Y'') auto_purge,',
'       (select count(*) from wwv_flow_fnd_user where  SECURITY_GROUP_ID = c.PROVISIONING_COMPANY_ID) c, ',
'       (select count(*) c from wwv_flow_developers where security_group_id=c.PROVISIONING_COMPANY_ID) d,',
'       (select count(*) c from wwv_flows where security_group_id = c.PROVISIONING_COMPANY_ID) f,',
'       (select project_status from wwv_flow_provision_company where security_group_id=c.PROVISIONING_COMPANY_ID) status,',
'       (select project_approval_date from wwv_flow_provision_company where security_group_id=c.PROVISIONING_COMPANY_ID) provision_date,',
'       (select project_approval_date from wwv_flow_provision_company where security_group_id=c.PROVISIONING_COMPANY_ID) provision_date2,',
'       PROVISIONING_COMPANY_ID,',
'       SOURCE_IDENTIFIER,',
'       allow_restful_services_yn,',
'       path_prefix,',
'       decode( provisioning_company_id,',
'               ''10'', '' '',',
'               ''<a href="''||',
'               wwv_flow_utilities.prepare_url (',
'                   ''f?p=4050:81:''||:flow_session||',
'                   '':BRANCH_TO_PAGE_ACCEPT|NEXT::81,82:P81_COMPANY:''||',
'                   short_name )||',
'               ''">''||',
'               wwv_flow_lang.system_message(''F4350.DELETE'') ) || ''</a>'' delete_me',
'  from WWV_FLOW_COMPANIES c ',
' where upper(short_name) != ''UNKNOWN'' ',
'   and provisioning_company_id not in ( 11, 12 )'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1123501416345350.4052)
,p_name=>'Workspaces'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="" />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1123707388345359.4052)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nom de l''espace de travail'
,p_column_link=>'f?p=&APP_ID.:78:&SESSION.:REPORT:&DEBUG.:RP,78:P78_PROVISIONING_COMPANY_ID:#PROVISIONING_COMPANY_ID#'
,p_column_linktext=>'#SHORT_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1123820269345360.4052)
,p_db_column_name=>'C'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Utilisateurs'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1123913070345360.4052)
,p_db_column_name=>'D'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('D\00E9veloppeurs')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1124007202345360.4052)
,p_db_column_name=>'F'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1124118550345360.4052)
,p_db_column_name=>'STATUS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Statut de provisionnement'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(316820619150159698)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1124224550345360.4052)
,p_db_column_name=>'PROVISION_DATE'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Date de provisionnement'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1124324365345361.4052)
,p_db_column_name=>'PROVISIONING_COMPANY_ID'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'ID d''espace de travail'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1124415825345361.4052)
,p_db_column_name=>'DELETE_ME'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(484700015910994745.4052)
,p_db_column_name=>'AUTO_PURGE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Purge automatique'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(157992123774592395)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(484701200027018549.4052)
,p_db_column_name=>'PROVISION_DATE2'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Provisionn\00E9')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(484860511289026229.4052)
,p_db_column_name=>'SOURCE_IDENTIFIER'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Identificateur de source'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(356783130548564595.4052)
,p_db_column_name=>'ACCOUNT_STATUS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Statut d''espace de travail'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(378216319396668186.4052)
,p_db_column_name=>'DISPLAY_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nom d''affichage'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(16904813381618873.4052)
,p_db_column_name=>'RM_CONSUMER_GROUP'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Groupe de consommateurs'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(385885140328363834.4052)
,p_db_column_name=>'ALLOW_RESTFUL_SERVICES_YN'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Services RESTful'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(157992123774592395)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(385885208621363841.4052)
,p_db_column_name=>'PATH_PREFIX'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>unistr('Pr\00E9fixe de chemin')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(484700307037001616.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1123402460345350.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:1,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(254106119813882628.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1123402460345350.4052)
,p_button_name=>'CREATE_WORKSPACE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er un espace de travail')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:RP,27,79,72,73,74::'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(357640492667810948.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1123402460345350.4052)
,p_button_name=>'CREATE_WORKSPACE_ATP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er un espace de travail')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:142:&SESSION.::&DEBUG.:RP,142:LAST_VIEW:1'
,p_required_patch=>-wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(24599238284.4052)
,p_branch_action=>'1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(270581419969760339.4052)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1'
);
end;
/
prompt --application/pages/page_00003
begin
wwv_flow_api.create_page(
 p_id=>3.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Services d''administration Application Express'
,p_step_title=>'Services d''administration Application Express'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216800021154677630)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style>',
'#fixed_height_region .rc-content {min-height: 200px; padding: 0;}',
'</style>'))
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_deep_linking=>'Y'
,p_help_text=>'AEADM/adm_wrkspc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(118635692071.4052)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Acc\00E9dez aux t\00E2ches d''administration d''une instance compl\00E8te &PRODUCT_NAME. et ex\00E9cutez-les.</p>'),
'<p><a target="_blank" href="&SYSTEM_HELP_URL./aeadm/overview-of-oracle-application-express-administration-services.html#GUID-CC197B14-5114-4F63-A003-587ACC0B433B">En savoir plus...</a></p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(20401325723455881.4052)
,p_name=>'Nouvelles demandes de service'
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_report_attributes=>'width="100%"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P4651d */',
'    ''<a href="''||provision_link||''">''||',
'       wwv_flow_escape.html(',
'          wwv_flow_lang.system_message(''REQUEST_WORKSPACE'',',
'              admin_email,',
'              workspace_name,',
'              request_size))||''</a>''',
'       the_request,',
'    request_date',
'from',
'(',
'select ',
'    ADMIN_EMAIL,',
'    COMPANY_NAME                         workspace_name,',
'    DATABASE_SIZE||''MB''                  request_size,',
'    request_date                         request_date,',
'    ''f?p=4050:4:''||:app_session||',
'       ''::NO::PROVISION_ID:''||id         provision_link',
'from WWV_FLOW_PROVISION_COMPANY',
'where project_status = ''REQUESTED''',
')',
'union',
'select ',
'        decode(m.request_status,',
'          ''REQUESTED'',''<a href="f?p=4050:110:''||:flow_session||''::NO:110:P110_REQUEST_ID,P110_SGID:''||m.id||'',''||m.security_group_id,',
'          ''APPROVED'', ''<a href="f?p=4050:110:''||:flow_session||''::NO:110,RP:P110_REQUEST_ID,P110_SGID:''||m.id||'',''||m.security_group_id',
'          ) ||''">''||',
'        wwv_flow_escape.html(',
'          decode(m.service_name,',
'          ''NEW_SCHEMA'',wwv_flow_lang.system_message(',
'                 ''REQUEST_NEW_SCHEMA'',',
'                 m.REQUESTED_BY, ',
'                 c.short_name, ',
'                 m.service_attribute_1',
'                 ),',
'          ''CHANGE_DB_SIZE'',       wwv_flow_lang.system_message(',
'                          ''REQUEST_CHANGE_DB_SIZE'',',
'                          m.REQUESTED_BY, ',
'                          c.short_name, ',
'                          m.service_attribute_1||''MB''',
'                          ),',
'           c.short_name ||',
'           '' - ''||m.service_name || ',
'           '' - ''||m.service_attribute_1)',
'        )||',
'        ''</a>'' the_request,',
'         m.requested_on        request_date',
'    from wwv_flow_provision_serice_mod m, ',
'         wwv_flow_companies c',
'   where m.security_group_id = c.provisioning_company_id',
'             and   m.request_status = ''REQUESTED''',
'order by 2 desc'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Aucune nouvelle demande de service'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(20401325723455881.4052)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(20401615462455886.4052)
,p_query_column_id=>1
,p_column_alias=>'THE_REQUEST'
,p_column_display_sequence=>1
,p_column_heading=>'Demande'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(20401715743455886.4052)
,p_query_column_id=>2
,p_column_alias=>'REQUEST_DATE'
,p_column_display_sequence=>2
,p_column_heading=>'Date'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29327206513889261.4052)
,p_plug_name=>unistr('T\00E2ches de l''instance')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_api.id(47534314618390800.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(27525012681104508.4052)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29719518059693725.4052)
,p_plug_name=>unistr('T\00E2ches de l''espace de travail')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(29722514446881924.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(27525012681104508.4052)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29937821359675476.4052)
,p_plug_name=>'Provisionnement'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare v varchar2(500); ',
'begin',
'v := wwv_flow_platform.get_preference( p_preference_name => ''SERVICE_REQUEST_FLOW'' );',
'if v = ''MANUAL'' then',
'   sys.htp.p(wwv_flow_lang.system_message(''PROVISIONING_MODE_MANUAL''));',
'elsif v = ''4700'' then',
'   sys.htp.p(wwv_flow_lang.system_message(''PROVISIONING_MODE_REQUEST''));   ',
'elsif v = ''EMAIL'' then',
'   sys.htp.p(wwv_flow_lang.system_message(''PROVISIONING_MODE_EMAIL''));',
'else',
'   sys.htp.p(''<p>''||wwv_flow_escape.html(v)||''</p>'');',
'end if;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(46453013260349027.4052)
,p_name=>unistr('R\00E9capitulatif de l''espace de travail')
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h240'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P3a */',
'    (select trim(to_char(count(*),''999G999G999G990'')) c ',
'     from wwv_flow_companies ',
'     where PROVISIONING_COMPANY_ID not in (0,10,11)) ',
'    workspaces,',
'    (select trim(to_char(count(*),''999G999G999G990'')) c ',
'     from WWV_FLOW_COMPANY_SCHEMAS ',
'     where security_group_id not in (0,10,11)) ',
'    schemas,',
'    (select trim(to_char(count(*),''999G999G999G990'')) c ',
'     from WWV_FLOWS ',
'     where SECURITY_GROUP_ID not in (0,10,11)) ',
'    Applications,',
'    (select trim(to_char(count(*),''999G999G999G990'')) c ',
'     from WWV_FLOW_FND_USER ',
'     ) ',
'    users,',
'    (select trim(to_char(count(*),''999G999G999G990'')) c ',
'     from wwv_flow_mail_queue',
'     ) ',
'    mail_queue_entries,',
'    (select trim(to_char(count(*),''999G999G999G999G990'')) c',
'     from wwv_flow_worksheets w, ',
'       wwv_flow_ws_websheet_attr a',
'     where w.id = a.worksheet_id and        ',
'       a.websheet_type != ''TEMPLATE'') ',
'    websheets,',
'    null sql_scripts',
'from dual'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46450823627307947.4052)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(46453013260349027.4052)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46453303454349039.4052)
,p_query_column_id=>1
,p_column_alias=>'WORKSPACES'
,p_column_display_sequence=>1
,p_column_heading=>'Espaces de travail'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46453400739349041.4052)
,p_query_column_id=>2
,p_column_alias=>'SCHEMAS'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Sch\00E9mas')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46453525576349042.4052)
,p_query_column_id=>3
,p_column_alias=>'APPLICATIONS'
,p_column_display_sequence=>3
,p_column_heading=>'Applications'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46453620768349042.4052)
,p_query_column_id=>4
,p_column_alias=>'USERS'
,p_column_display_sequence=>4
,p_column_heading=>'Utilisateurs'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46453725854349042.4052)
,p_query_column_id=>5
,p_column_alias=>'MAIL_QUEUE_ENTRIES'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Entr\00E9es de file d''attente des courriels')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47526422491265777.4052)
,p_query_column_id=>6
,p_column_alias=>'WEBSHEETS'
,p_column_display_sequence=>6
,p_column_heading=>'Feuilles Web'
,p_use_as_row_header=>'N'
,p_report_column_required_role=>wwv_flow_api.id(610289739776900562)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47526519634265779.4052)
,p_query_column_id=>7
,p_column_alias=>'SQL_SCRIPTS'
,p_column_display_sequence=>7
,p_column_heading=>'SQL Scripts'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168904510438515608.4052)
,p_plug_name=>'Administration d''instance'
,p_region_sub_css_classes=>'instance-admin'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_api.id(168902912946497370.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(517410251255325302.4052)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168920123999973593.4052)
,p_plug_name=>unistr('Message du syst\00E8me')
,p_region_css_classes=>'a-Alert--inline'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--noIcon:a-Alert--warning:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829706609080810173.4052)
,p_plug_display_sequence=>40
,p_plug_source=>'wwv_flow_4050_ui.show_system_message( p_app_session => :APP_SESSION );'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(183463511911929201.4052)
,p_name=>unistr('Param\00E8tres d''instance')
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>110
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX 4050P4651c */',
'    wwv_flow_platform.get_preference(''INSTANCE_ID'') instance_id,',
'    wwv_flow_platform.get_preference(''NOTIFICATION_EMAIL'' ) ',
'        notification_email,',
'    wwv_flow_platform.get_preference(''EMAIL_INSTANCE_URL'' )',
'        instance_url,',
'    decode(wwv_flow_platform.get_preference(''SERVICE_REQUEST_FLOW''),',
'        ''EMAIL'',wwv_flow_lang.system_message(''PROVISIONING_MODE_EMAIL''),',
'        ''4700'',wwv_flow_lang.system_message(''PROVISIONING_MODE_REQUEST''),',
'        ''MANUAL'',wwv_flow_lang.system_message(''PROVISIONING_MODE_MANUAL''),',
'        wwv_flow_lang.system_message(''UNKNOWN''))',
'        provisioning_mode,',
'    decode ( wwv_flow_platform.get_preference(''REQ_NEW_SCHEMA'' ) ,',
'        ''Y'',wwv_flow_lang.system_message(''YES''),',
'        ''N'',wwv_flow_lang.system_message(''NO''),',
'        wwv_flow_lang.system_message(''UNKNOWN''))',
'        new_schema,',
'    decode(wwv_flow_platform.get_preference(''PRINT_BIB_LICENSED'' ),',
'        ''ADVANCED'',wwv_flow_lang.system_message(''print_server_advanced''),',
'        ''STANDARD'',wwv_flow_lang.system_message(''STANDARD''),',
'        wwv_flow_lang.system_message(''UNKNOWN''))',
'        print_server,',
'    wwv_flow_platform.get_preference(''PRINT_SVR_HOST'' )',
'        print_server_host_address,',
'    wwv_flow_platform.get_preference(''SMTP_HOST_ADDRESS'' )',
'        SMTP_HOST_ADDRESS',
'from dual'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46450823627307947.4052)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(183463511911929201.4052)
,p_plug_column_width=>'apex-col--bottomBorder apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(16863222023876407.4052)
,p_query_column_id=>1
,p_column_alias=>'INSTANCE_ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID d''instance'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183463813490929210.4052)
,p_query_column_id=>2
,p_column_alias=>'NOTIFICATION_EMAIL'
,p_column_display_sequence=>2
,p_column_heading=>'Courriel de notification'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(20133310180661802.4052)
,p_query_column_id=>3
,p_column_alias=>'INSTANCE_URL'
,p_column_display_sequence=>3
,p_column_heading=>'URL d''instance'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183465031566953824.4052)
,p_query_column_id=>4
,p_column_alias=>'PROVISIONING_MODE'
,p_column_display_sequence=>4
,p_column_heading=>'Mode de provisionnement'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183765727327988271.4052)
,p_query_column_id=>5
,p_column_alias=>'NEW_SCHEMA'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Exiger un nouveau sch\00E9ma ?')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183766604733000610.4052)
,p_query_column_id=>6
,p_column_alias=>'PRINT_SERVER'
,p_column_display_sequence=>6
,p_column_heading=>'Serveur d''impression'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183769506773048520.4052)
,p_query_column_id=>7
,p_column_alias=>'PRINT_SERVER_HOST_ADDRESS'
,p_column_display_sequence=>7
,p_column_heading=>unistr('Adresse d''h\00F4te de serveur d''impression')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183766808327011155.4052)
,p_query_column_id=>8
,p_column_alias=>'SMTP_HOST_ADDRESS'
,p_column_display_sequence=>8
,p_column_heading=>unistr('Adresse de l''h\00F4te SMTP')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(183769726644063701.4052)
,p_name=>unistr('Param\00E8tres de s\00E9curit\00E9')
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>90
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h240'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX 4050P4651b */',
'    decode(',
'    wwv_flow_platform.get_preference(''REQUIRE_HTTPS'' ) ,',
'        ''Y'',wwv_flow_lang.system_message(''YES''),',
'        ''N'',wwv_flow_lang.system_message(''NO''),',
'        ''A'',wwv_flow_lang.system_message(''ALWAYS''),',
'        wwv_flow_lang.system_message(''UNKNOWN''))',
'        require_https,',
'    nvl(wwv_flow_platform.get_preference(''MAX_SESSION_IDLE_SEC''),3600)',
'        maximum_session_idle_seconds,',
'    nvl(wwv_flow_platform.get_preference(''MAX_SESSION_LENGTH_SEC''),28800)',
'        maximum_session_length_seconds,',
'    decode(wwv_flow_platform.get_preference(''EXPIRE_FND_USER_ACCOUNTS''),',
'        ''Y'',wwv_flow_lang.system_message(''YES''),',
'        ''N'',wwv_flow_lang.system_message(''NO''),',
'        wwv_flow_lang.system_message(''UNKNOWN''))',
'        expire_user_accounts,',
'    wwv_flow_platform.get_preference(''MAX_LOGIN_FAILURES'')',
'        max_login_failures,',
'    wwv_flow_platform.get_preference(''ACCOUNT_LIFETIME_DAYS'')',
'        password_lifetime_days,',
'    decode(wwv_flow_platform.get_preference(''STRONG_SITE_ADMIN_PASSWORD'') ,',
'        ''Y'',wwv_flow_lang.system_message(''YES''),',
'        ''N'',wwv_flow_lang.system_message(''NO''),',
'        wwv_flow_lang.system_message(''UNKNOWN''))',
'        require_strong_admin_password',
'from dual'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46450823627307947.4052)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(183769726644063701.4052)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183772408383115226.4052)
,p_query_column_id=>1
,p_column_alias=>'REQUIRE_HTTPS'
,p_column_display_sequence=>1
,p_column_heading=>'Exiger HTTPS'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183772517652115226.4052)
,p_query_column_id=>2
,p_column_alias=>'MAXIMUM_SESSION_IDLE_SECONDS'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Temps maximal d''inactivit\00E9 de session (secondes)')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183772604474115226.4052)
,p_query_column_id=>3
,p_column_alias=>'MAXIMUM_SESSION_LENGTH_SECONDS'
,p_column_display_sequence=>3
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183772700820115226.4052)
,p_query_column_id=>4
,p_column_alias=>'EXPIRE_USER_ACCOUNTS'
,p_column_display_sequence=>4
,p_column_heading=>'Invalider les comptes utilisateur'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183772814386115227.4052)
,p_query_column_id=>5
,p_column_alias=>'MAX_LOGIN_FAILURES'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Nombre maximal d''\00E9checs de connexion')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183772932553115227.4052)
,p_query_column_id=>6
,p_column_alias=>'PASSWORD_LIFETIME_DAYS'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Dur\00E9e de validit\00E9 du mot de passe (jours)')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183773017254115227.4052)
,p_query_column_id=>7
,p_column_alias=>'REQUIRE_STRONG_ADMIN_PASSWORD'
,p_column_display_sequence=>7
,p_column_heading=>'Demander un mot de passe fort d''administrateur'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(466818203845023502.4052)
,p_plug_name=>'Language'
,p_region_name=>'builder_home_lang_selector'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>120
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'sys.htp.p( wwv_flow_lang.get_language_selector_list );'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_4000_ui.is_translation_installed( p_flow_id => 4000 )'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(619976314155172583.4052)
,p_name=>'Travaux'
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>80
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h240'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.job_name,',
'       case when j.job_name is not null then apex_util.get_since_tswtz(j.last_start_date)',
'            else wwv_flow_lang.system_message(''NOT_FOUND'')',
'       end as last_start_date',
'  from ( select decode(level, 1, ''ORACLE_APEX_AUTO_APPROVAL'',',
'                              2, ''ORACLE_APEX_PURGE_SESSIONS'',',
'                              3, ''ORACLE_APEX_MAIL_QUEUE'',',
'                              4, ''ORACLE_APEX_WS_NOTIFICATIONS'',',
'                              5, ''ORACLE_APEX_DAILY_MAINTENANCE''',
'                      ) as job_name',
'           from sys.dual',
'        connect by level <= 5) x,',
'       sys.user_scheduler_jobs j',
' where x.job_name = j.job_name (+)',
' order by x.job_name'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(47555718632924155.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(619976605315172588.4052)
,p_query_column_id=>1
,p_column_alias=>'JOB_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nom du travail'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(619976727550172590.4052)
,p_query_column_id=>2
,p_column_alias=>'LAST_START_DATE'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Date du dernier d\00E9marrage')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(620840201547500783.4052)
,p_plug_name=>'Jobs'
,p_parent_plug_id=>wwv_flow_api.id(619976314155172583.4052)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>90
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'sys.htp.p(''<p class="margin-bottom-none padding-sm">''||wwv_flow_escape.html(wwv_flow_lang.system_message(''DATE_OF_LAST_RUN''))||''</p>'');'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(663451466498166105.4052)
,p_plug_name=>unistr('Mises \00E0 jour disponibles')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>190
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_upgrade_date         varchar2(255);',
'    l_apex_upgrade_version varchar2(4000);',
'    l_state                varchar2(4000);',
'begin',
'',
'    l_state := wwv_flow_cloud_db_services.get_upgrade_status().state;',
'    l_upgrade_date := to_char(wwv_flow_cloud_db_services.get_upgrade_status().upgrade_date, ''fmMonth DD, YYYY'');',
'    l_apex_upgrade_version := wwv_flow_cloud_db_services.get_upgrade_status().upgrade_version;',
'    ',
'    if l_state = ''RUNNING'' then',
'       sys.htp.p(''<p>'' ||',
'                  wwv_flow_lang.system_message(''F4050_P3_UPGRADING'',',
'                                               ''&PRODUCT_NAME.'',',
'                                               l_apex_upgrade_version) ||',
'                  ''</p>'');',
'    elsif l_upgrade_date is not null then',
'        sys.htp.p(''<p>'' ||',
'                  wwv_flow_lang.system_message(''F4050_P3_UPGRADE_AVAILABLE'',',
'                                               ''&PRODUCT_NAME.'',',
'                                               l_apex_upgrade_version,',
'                                               ''https://apex.oracle.com/adb-latest'') ||',
'                  ''</p>'');',
'        sys.htp.p(''<p>'' ||',
'                  wwv_flow_lang.system_message(''F4050_P3_UPGRADE_DEFERRED_P'', l_upgrade_date) ||',
'                  ''</p>'');',
'',
'    elsif nvl( wwv_flow_platform.get_preference( ''UPGRADE_DEFERRED'' ), ''N'' ) = ''N'' then',
'        sys.htp.p(''<p>'' ||',
'                  wwv_flow_lang.system_message(''F4050_P3_SYSTEM_UP_TO_DATE'') ||',
'                  ''</p>'');',
'        sys.htp.p(''<p>'' ||',
'                  wwv_flow_lang.system_message(''F4050_P3_UPGRADE_DEFERRED_N'', ''&PRODUCT_NAME.'') ||',
'                  ''</p>'');',
'',
'    else',
'        sys.htp.p(''<p>'' ||',
'                  wwv_flow_lang.system_message(''F4050_P3_SYSTEM_UP_TO_DATE'') ||',
'                  ''</p>'');',
'        sys.htp.p(''<p>'' ||',
'                  wwv_flow_lang.system_message(''F4050_P3_UPGRADE_DEFERRED_Y'', ''&PRODUCT_NAME.'') ||',
'                  ''</p>'');',
'    end if;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_required_patch=>-wwv_flow_api.id(3913175260740993520.4052)
,p_plug_comment=>'Feature #1437'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(777604149198624201.4052)
,p_plug_name=>unistr('Mises \00E0 jour disponibles')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>180
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'sys.htp.prn( ''<div id="updates"></div>'' );'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_plug_comment=>'Feature #1437'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(926451766177861836.4052)
,p_plug_name=>'Demandes en suspens'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:h240'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(926449801871861817.4052)
,p_name=>'Demandes en suspens'
,p_parent_plug_id=>wwv_flow_api.id(926451766177861836.4052)
,p_template=>wwv_flow_api.id(517376500704206647.4052)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--fixed:a-BadgeList--xlarge'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4500P1000cMH */',
'    wwv_flow_provisioning.total_open_service_requests new_service,',
'    --',
'    wwv_flow_provisioning.total_open_change_requests service_change',
'from dual'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805663950138677747.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
end;
/
begin
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(968678541063060714.4052)
,p_query_column_id=>1
,p_column_alias=>'NEW_SERVICE'
,p_column_display_sequence=>1
,p_column_heading=>'Nouveau service'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:RP,RIR:::'
,p_column_linktext=>'#NEW_SERVICE#'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(968798125219081788.4052)
,p_query_column_id=>2
,p_column_alias=>'SERVICE_CHANGE'
,p_column_display_sequence=>2
,p_column_heading=>'Modification de service'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.:RP,RIR:::'
,p_column_linktext=>'#SERVICE_CHANGE#'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(926451651092861835.4052)
,p_plug_name=>'Mode'
,p_parent_plug_id=>wwv_flow_api.id(926451766177861836.4052)
,p_region_css_classes=>'padding-md apex-col--bottomBorder'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517376500704206647.4052)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Mode de provisionnement : provisionnement en libre-service'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(926451866270861837.4052)
,p_plug_name=>'Services d''administration'
,p_region_css_classes=>'a-Region--noTopBorder'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>20
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(183774608083143536.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(183463511911929201.4052)
,p_button_name=>'EDIT_SET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>'Modifier'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.:131::'
,p_icon_css_classes=>'icon-edit'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203133126735284812.4052)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(183463511911929201.4052)
,p_button_name=>'VIEW_INSTANCE_SETTINGS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('Visualiser les param\00E8tres d''instance')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(183774323405129018.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(183769726644063701.4052)
,p_button_name=>'EDIT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>'Modifier'
,p_button_position=>'CREATE2'
,p_button_redirect_url=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:130::'
,p_icon_css_classes=>'icon-edit'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(256279016122801246.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46453013260349027.4052)
,p_button_name=>'VIEW_MONITOR'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('Surveiller l''activit\00E9')
,p_button_position=>'CREATE2'
,p_button_redirect_url=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(202704411977539506.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(926451766177861836.4052)
,p_button_name=>'VIEW_REQUESTS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>'Visualiser les demandes'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(202796708138602663.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(926451866270861837.4052)
,p_button_name=>'CREATE_workspace'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er un espace de travail')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:27,79,72,73,74::'
,p_icon_css_classes=>'icon-right-chevron'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(663451568099166106.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(663451466498166105.4052)
,p_button_name=>'set_deferred_preference'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('D\00E9finir les pr\00E9f\00E9rences pour les mises \00E0 jour diff\00E9r\00E9es')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:158:&SESSION.::&DEBUG.:RP,158::'
,p_button_css_classes=>'a-Button a-Button--withIcon a-Button--noLabel a-Button--small a-Button--noUI'
,p_icon_css_classes=>'icon-gear'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1143246809648567421.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(168920123999973593.4052)
,p_button_name=>'EDIT_MESSAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('Modifier le message du syst\00E8me')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:132:&SESSION.::&DEBUG.:132:::'
,p_icon_css_classes=>'icon-edit'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1427416875824615006.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(777604149198624201.4052)
,p_button_name=>'set_preferences_updates'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('D\00E9finir les pr\00E9f\00E9rences pour les mises \00E0 jour disponibles')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:70:&SESSION.::&DEBUG.:RP,70::'
,p_button_css_classes=>'a-Button a-Button--withIcon a-Button--noLabel a-Button--small a-Button--noUI'
,p_icon_css_classes=>'icon-gear'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(357640585498810948.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(926451866270861837.4052)
,p_button_name=>'CREATE_workspace_ATP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er un espace de travail')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:142:&SESSION.::&DEBUG.:142:LAST_VIEW:3'
,p_icon_css_classes=>'icon-right-chevron'
,p_required_patch=>-wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(831947701939695434.4052)
,p_branch_action=>'f?p=&APP_ID.:78:&SESSION.::&DEBUG.:RR,78:P78_PROVISIONING_COMPANY_ID:&P3_WORKSPACE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'JUMP_TO_WORKSPACE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(663451828304166109.4052)
,p_name=>'P3_UPGRADE_DATE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(926451866270861837.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(831947441311695431.4052)
,p_name=>'P3_WORKSPACE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(29327206513889261.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Espace de travail'
,p_placeholder=>unistr('Acc\00E9der \00E0 l''espace de travail...')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'WORKSPACES_RETURNING_ID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id > 0',
'order by 1'))
,p_lov_display_null=>'YES'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(832237223281900733.4052)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'NO_FETCH'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(29945304933859964.4052)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'3'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1427416964580615007.4052)
,p_name=>'Updates - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1427416875824615006.4052)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1427417053117615008.4052)
,p_event_id=>wwv_flow_api.id(1427416964580615007.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(777604149198624201.4052)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Reload page. We have to do it with a timer, because Firefox prevents the redirect otherwise',
'setTimeout( function() {',
'    apex.navigation.redirect( apex.util.makeApplicationUrl( {} ));',
'}, 0 );'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(831947586611695432.4052)
,p_name=>'Jump to Workspace Details Page'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3_WORKSPACE'
,p_condition_element=>'P3_WORKSPACE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(831947696975695433.4052)
,p_event_id=>wwv_flow_api.id(831947586611695432.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'JUMP_TO_WORKSPACE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(777604227083624202.4052)
,p_process_sequence=>10
,p_process_point=>'BEFORE_FOOTER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check for updates'
,p_process_sql_clob=>'wwv_flow_4000_ui.updates();'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(359767105825562475.4052)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'F4050_P72_ADMIN_PASS,F4050_P79_SCHEMA_PASSWORD,F4050_P23_WEB_PASSWORD,P53_PASSWORD,P53_PASSWORD2,P53_GEN_PASSWORD,P106_PASSWORD,P277_SCHEMA_PASSWORD'
);
end;
/
prompt --application/pages/page_00004
begin
wwv_flow_api.create_page(
 p_id=>4.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Administration du provisionnement'
,p_step_title=>'Administration du provisionnement'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216766430018595041)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>'AEADM/adm_create_wkspc.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(173724892445.4052)
,p_name=>'Demande d''espace de travail'
,p_template=>wwv_flow_api.id(829706609080810173.4052)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Alert--defaultIcons:a-Alert--warning:a-Alert--wizard'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select     ',
'    COMPANY_NAME,',
'    ADMIN_FIRST_NAME,',
'    ADMIN_LAST_NAME,',
'    ADMIN_TITLE,',
'    ADMIN_EMAIL,',
'    ADMIN_PHONE,',
'    ADMIN_USERID,',
'    COMPANY_ADDRESS,',
'    CITY,',
'    STATE,',
'    ZIP,',
'    COUNTRY,',
'    COMPANY_TYPE,',
'    COMPANY_WEBSITE,',
'    NUMBER_OF_EMPLOYEES,',
'    COMPANY_PHONE,',
'    COMPANY_FAX,',
'    ORACLE_PARTNER,',
'    HOW_DID_YOU_HEAR_ABOUT_US,',
'    SERVICE_USE_STATUS,',
'    DATABASE_SIZE,',
'    SERVICE_START_DATE,',
'    SERVICE_TERMINATION_DATE,',
'    SCHEMA_NAME,',
'    ESTIMATED_END_USERS,',
'    PAGE_VIEWS_PER_DAY,',
'    PROJECT_DESCRIPTION,',
'    PROJECT_JUSTIFICATION,',
'    PROJECT_APPROVAL_DATE,',
'    PROJECT_ACTUAL_BEGIN_DATE,',
'    PROJECT_ACTUAL_END_DATE,',
'    PROJECT_STATUS,',
'    request_date,',
'    SECURITY_GROUP_ID,',
'    id',
'from WWV_FLOW_PROVISION_COMPANY',
'where id = :provision_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>2
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48687419982771655.4052)
,p_query_column_id=>1
,p_column_alias=>'COMPANY_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nom de l''espace de travail'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48687515843771656.4052)
,p_query_column_id=>2
,p_column_alias=>'ADMIN_FIRST_NAME'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Pr\00E9nom de l''administrateur')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48687628068771656.4052)
,p_query_column_id=>3
,p_column_alias=>'ADMIN_LAST_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nom de l''administrateur'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48687729004771656.4052)
,p_query_column_id=>4
,p_column_alias=>'ADMIN_TITLE'
,p_column_display_sequence=>4
,p_column_heading=>'Admin Title'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48687805987771656.4052)
,p_query_column_id=>5
,p_column_alias=>'ADMIN_EMAIL'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Adresse \00E9lectronique de l''administrateur')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48687909288771656.4052)
,p_query_column_id=>6
,p_column_alias=>'ADMIN_PHONE'
,p_column_display_sequence=>6
,p_column_heading=>'Admin Phone'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48688029577771656.4052)
,p_query_column_id=>7
,p_column_alias=>'ADMIN_USERID'
,p_column_display_sequence=>7
,p_column_heading=>'ID utilisateur de l''administrateur'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48688118304771656.4052)
,p_query_column_id=>8
,p_column_alias=>'COMPANY_ADDRESS'
,p_column_display_sequence=>8
,p_column_heading=>'Company Address'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48688207126771656.4052)
,p_query_column_id=>9
,p_column_alias=>'CITY'
,p_column_display_sequence=>9
,p_column_heading=>'City'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48688309531771656.4052)
,p_query_column_id=>10
,p_column_alias=>'STATE'
,p_column_display_sequence=>10
,p_column_heading=>'State'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48688426433771657.4052)
,p_query_column_id=>11
,p_column_alias=>'ZIP'
,p_column_display_sequence=>11
,p_column_heading=>'Zip'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48688501652771657.4052)
,p_query_column_id=>12
,p_column_alias=>'COUNTRY'
,p_column_display_sequence=>12
,p_column_heading=>'Country'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48688632281771657.4052)
,p_query_column_id=>13
,p_column_alias=>'COMPANY_TYPE'
,p_column_display_sequence=>13
,p_column_heading=>'Company Type'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48688721428771657.4052)
,p_query_column_id=>14
,p_column_alias=>'COMPANY_WEBSITE'
,p_column_display_sequence=>14
,p_column_heading=>'Company Website'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48688808773771657.4052)
,p_query_column_id=>15
,p_column_alias=>'NUMBER_OF_EMPLOYEES'
,p_column_display_sequence=>15
,p_column_heading=>'Number Of Employees'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48688903783771657.4052)
,p_query_column_id=>16
,p_column_alias=>'COMPANY_PHONE'
,p_column_display_sequence=>16
,p_column_heading=>'Company Phone'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48689016797771657.4052)
,p_query_column_id=>17
,p_column_alias=>'COMPANY_FAX'
,p_column_display_sequence=>17
,p_column_heading=>'Company Fax'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48689116782771657.4052)
,p_query_column_id=>18
,p_column_alias=>'ORACLE_PARTNER'
,p_column_display_sequence=>18
,p_column_heading=>'Oracle Partner'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48689200152771658.4052)
,p_query_column_id=>19
,p_column_alias=>'HOW_DID_YOU_HEAR_ABOUT_US'
,p_column_display_sequence=>19
,p_column_heading=>'How Did You Hear About Us'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48689300933771658.4052)
,p_query_column_id=>20
,p_column_alias=>'SERVICE_USE_STATUS'
,p_column_display_sequence=>20
,p_column_heading=>'Statut d''utilisation d''espace de travail'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48689400444771658.4052)
,p_query_column_id=>21
,p_column_alias=>'DATABASE_SIZE'
,p_column_display_sequence=>21
,p_column_heading=>unistr('Taille de base de donn\00E9es')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48689521409771658.4052)
,p_query_column_id=>22
,p_column_alias=>'SERVICE_START_DATE'
,p_column_display_sequence=>22
,p_column_heading=>'Service Start Date'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48689621142771658.4052)
,p_query_column_id=>23
,p_column_alias=>'SERVICE_TERMINATION_DATE'
,p_column_display_sequence=>23
,p_column_heading=>'Service Termination Date'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48689700511771658.4052)
,p_query_column_id=>24
,p_column_alias=>'SCHEMA_NAME'
,p_column_display_sequence=>24
,p_column_heading=>unistr('Nom de sch\00E9ma')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48689810534771658.4052)
,p_query_column_id=>25
,p_column_alias=>'ESTIMATED_END_USERS'
,p_column_display_sequence=>25
,p_column_heading=>'Estimated End Users'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48689908996771658.4052)
,p_query_column_id=>26
,p_column_alias=>'PAGE_VIEWS_PER_DAY'
,p_column_display_sequence=>26
,p_column_heading=>'Page Views Per Day'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48690003327771658.4052)
,p_query_column_id=>27
,p_column_alias=>'PROJECT_DESCRIPTION'
,p_column_display_sequence=>27
,p_column_heading=>'Description'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48690115108771658.4052)
,p_query_column_id=>28
,p_column_alias=>'PROJECT_JUSTIFICATION'
,p_column_display_sequence=>28
,p_column_heading=>'Justification'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48690213710771659.4052)
,p_query_column_id=>29
,p_column_alias=>'PROJECT_APPROVAL_DATE'
,p_column_display_sequence=>29
,p_column_heading=>'Project Approval Date'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48690326689771659.4052)
,p_query_column_id=>30
,p_column_alias=>'PROJECT_ACTUAL_BEGIN_DATE'
,p_column_display_sequence=>30
,p_column_heading=>'Project Actual Begin Date'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48690425411771659.4052)
,p_query_column_id=>31
,p_column_alias=>'PROJECT_ACTUAL_END_DATE'
,p_column_display_sequence=>31
,p_column_heading=>'Project Actual End Date'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48690503555771659.4052)
,p_query_column_id=>32
,p_column_alias=>'PROJECT_STATUS'
,p_column_display_sequence=>32
,p_column_heading=>'Project Status'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48690621397771659.4052)
,p_query_column_id=>33
,p_column_alias=>'REQUEST_DATE'
,p_column_display_sequence=>33
,p_column_heading=>'Date de demande'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48690710746771659.4052)
,p_query_column_id=>34
,p_column_alias=>'SECURITY_GROUP_ID'
,p_column_display_sequence=>34
,p_column_heading=>'Workspace'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48690814352771659.4052)
,p_query_column_id=>35
,p_column_alias=>'ID'
,p_column_display_sequence=>35
,p_column_heading=>'Identification Number'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(179795422363234062.4052)
,p_plug_name=>'Avertissements'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829706609080810173.4052)
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'l_schema                    wwv_flow_provision_company.schema_name%type;',
'l_schema_exists             boolean := false;',
'l_schema_in_use             boolean := false;',
'l_schema_cannot_be_assigned boolean := false;',
'begin',
'',
'for c1 in (select upper(schema_name) sa1',
'    from wwv_flow_provision_company',
'    where id = :PROVISION_ID) loop',
'    l_schema := c1.sa1;',
'end loop;',
'',
'l_schema_exists := wwv_flow_security.get_db_user_or_role(p_username => l_schema) is not null;',
'',
'for c1 in (select 1 from wwv_flow_company_schemas ',
'  where schema = l_schema) loop',
'  l_schema_in_use := true;',
'end loop;',
'',
'for c1 in (select 1 from dual',
'  where wwv_flow_provisioning.reserved_schema_i(l_schema) = 1',
'  or wwv_flow_provisioning.restricted_schema_i(l_schema, :P4_COMPANY_NAME) = 1) loop',
'    l_schema_cannot_be_assigned := true;',
'end loop;',
'',
'sys.htp.p(''<br />'');sys.htp.p(''<br />'');',
'',
'if l_schema_exists then',
'  sys.htp.p(''<p />''||',
'  wwv_flow_lang.system_message(''F4050.SCHEMA_EXISTS''));',
'end if;',
'',
'if l_schema_in_use then',
'  sys.htp.p(''<p />''||',
'  wwv_flow_lang.system_message(''F4050.SCHEMA_ASSIGNED''));',
'end if;',
'',
'if l_schema_cannot_be_assigned then',
'  sys.htp.p(''<p />''||',
'  wwv_flow_lang.system_message(''F4050.RESTRICTED_ADMIN''));',
'end if;',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'l_schema wwv_flow_provision_company.schema_name%type;',
'l_schema_exists             boolean := false;',
'l_schema_in_use             boolean := false;',
'l_schema_restricted         boolean := false;',
'begin',
'',
'for c1 in (select upper(schema_name) sa1',
'    from wwv_flow_provision_company',
'    where id = :PROVISION_ID) loop',
'    l_schema := c1.sa1;',
'end loop;',
'',
'l_schema_exists := wwv_flow_security.get_db_user_or_role(p_username => l_schema) is not null;',
'',
'for c1 in (select 1 from wwv_flow_company_schemas ',
'  where schema = l_schema) loop',
'  l_schema_in_use := true;',
'end loop;',
'',
'for c1 in (select 1 from dual',
'  where wwv_flow_provisioning.reserved_schema_i(l_schema) = 1',
'  or wwv_flow_provisioning.restricted_schema_i(l_schema,:P4_COMPANY_NAME) = 1) loop',
'  l_schema_restricted := true;',
'end loop;',
'',
'return l_schema_exists or l_schema_in_use or l_schema_restricted ;',
'',
'end;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(179796001715237593.4052)
,p_name=>unistr('Espaces de travail utilisant le sch\00E9ma demand\00E9')
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name from wwv_flow_companies where provisioning_company_id in (select security_group_id from wwv_flow_company_schemas where schema = (',
' select upper(schema_name)',
'    from wwv_flow_provision_company',
'    where id = :PROVISION_ID))'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_company_schemas where schema = (',
' select upper(schema_name)',
'    from wwv_flow_provision_company',
'    where id = :PROVISION_ID)'))
,p_display_condition_type=>'EXISTS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(6897002870390711.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(179796231768237594.4052)
,p_query_column_id=>1
,p_column_alias=>'SHORT_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Espace de travail'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(955890703465997318.4052)
,p_plug_name=>'boutons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1433457275968958953.4052)
,p_name=>unistr('R\00E9ponses \00E0 l''enqu\00EAte')
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select     ',
'    survey_question_01,',
'    survey_answer_01,',
'    survey_question_02,',
'    survey_answer_02,',
'    survey_question_03,',
'    survey_answer_03,',
'    survey_question_04,',
'    survey_answer_04,',
'    survey_question_05,',
'    survey_answer_05,',
'    survey_question_06,',
'    survey_answer_06,',
'    survey_question_07,',
'    survey_answer_07,',
'    survey_question_08,',
'    survey_answer_08,',
'    survey_question_09,',
'    survey_answer_09,',
'    survey_question_10,',
'    survey_answer_10',
'from WWV_FLOW_PROVISION_COMPANY',
'where id = :provision_id'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null      ',
'from WWV_FLOW_PROVISION_COMPANY',
'where id = :provision_id and',
'    ( survey_answer_01 is not null or',
'      survey_answer_02 is not null or',
'      survey_answer_03 is not null or',
'      survey_answer_04 is not null or',
'      survey_answer_05 is not null or',
'      survey_answer_06 is not null or',
'      survey_answer_07 is not null or',
'      survey_answer_08 is not null or',
'      survey_answer_09 is not null or',
'      survey_answer_10 is not null )'))
,p_display_condition_type=>'EXISTS'
,p_ajax_items_to_submit=>'PROVISION_ID'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805670753642677848.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1433457585099958965.4052)
,p_query_column_id=>1
,p_column_alias=>'SURVEY_QUESTION_01'
,p_column_display_sequence=>1
,p_column_heading=>'Question 1'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1433457692977958969.4052)
,p_query_column_id=>2
,p_column_alias=>'SURVEY_ANSWER_01'
,p_column_display_sequence=>2
,p_column_heading=>unistr('R\00E9ponse 1')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1433457710480958969.4052)
,p_query_column_id=>3
,p_column_alias=>'SURVEY_QUESTION_02'
,p_column_display_sequence=>3
,p_column_heading=>'Question 2'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1433457800100958969.4052)
,p_query_column_id=>4
,p_column_alias=>'SURVEY_ANSWER_02'
,p_column_display_sequence=>4
,p_column_heading=>unistr('R\00E9ponse 2')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1433457960885958969.4052)
,p_query_column_id=>5
,p_column_alias=>'SURVEY_QUESTION_03'
,p_column_display_sequence=>5
,p_column_heading=>'Question 3'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1433458067626958969.4052)
,p_query_column_id=>6
,p_column_alias=>'SURVEY_ANSWER_03'
,p_column_display_sequence=>6
,p_column_heading=>unistr('R\00E9ponse 3')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1433458181108958970.4052)
,p_query_column_id=>7
,p_column_alias=>'SURVEY_QUESTION_04'
,p_column_display_sequence=>7
,p_column_heading=>'Question 4'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1433458215472958970.4052)
,p_query_column_id=>8
,p_column_alias=>'SURVEY_ANSWER_04'
,p_column_display_sequence=>8
,p_column_heading=>unistr('R\00E9ponse 4')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1433458355035958970.4052)
,p_query_column_id=>9
,p_column_alias=>'SURVEY_QUESTION_05'
,p_column_display_sequence=>9
,p_column_heading=>'Question 5'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1433458464778958970.4052)
,p_query_column_id=>10
,p_column_alias=>'SURVEY_ANSWER_05'
,p_column_display_sequence=>10
,p_column_heading=>unistr('R\00E9ponse 5')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1433458525808958970.4052)
,p_query_column_id=>11
,p_column_alias=>'SURVEY_QUESTION_06'
,p_column_display_sequence=>11
,p_column_heading=>'Question 6'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1433458664310958970.4052)
,p_query_column_id=>12
,p_column_alias=>'SURVEY_ANSWER_06'
,p_column_display_sequence=>12
,p_column_heading=>unistr('R\00E9ponse 6')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1433458782369958971.4052)
,p_query_column_id=>13
,p_column_alias=>'SURVEY_QUESTION_07'
,p_column_display_sequence=>13
,p_column_heading=>'Question 7'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1433458832624958971.4052)
,p_query_column_id=>14
,p_column_alias=>'SURVEY_ANSWER_07'
,p_column_display_sequence=>14
,p_column_heading=>unistr('R\00E9ponse 7')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1433458949321958971.4052)
,p_query_column_id=>15
,p_column_alias=>'SURVEY_QUESTION_08'
,p_column_display_sequence=>15
,p_column_heading=>'Question 8'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1433459046464958971.4052)
,p_query_column_id=>16
,p_column_alias=>'SURVEY_ANSWER_08'
,p_column_display_sequence=>16
,p_column_heading=>unistr('R\00E9ponse 8')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1433459117563958971.4052)
,p_query_column_id=>17
,p_column_alias=>'SURVEY_QUESTION_09'
,p_column_display_sequence=>17
,p_column_heading=>'Question 9'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1433459281317958971.4052)
,p_query_column_id=>18
,p_column_alias=>'SURVEY_ANSWER_09'
,p_column_display_sequence=>18
,p_column_heading=>unistr('R\00E9ponse 9')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1433459328870958971.4052)
,p_query_column_id=>19
,p_column_alias=>'SURVEY_QUESTION_10'
,p_column_display_sequence=>19
,p_column_heading=>'Question 10'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1433459404441958971.4052)
,p_query_column_id=>20
,p_column_alias=>'SURVEY_ANSWER_10'
,p_column_display_sequence=>20
,p_column_heading=>unistr('R\00E9ponse 10')
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(225165738087.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(955890703465997318.4052)
,p_button_name=>'DECLINE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_image_alt=>'Refuser'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:56:&SESSION.::&DEBUG.:56::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200345928591.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(955890703465997318.4052)
,p_button_name=>'Approve'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Approuver'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:55:&SESSION.::&DEBUG.:55::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare l_schema varchar2(30) := null;',
'begin',
'    for c1 in (select upper(schema_name) sa1',
'        from wwv_flow_provision_company',
'        where id = :PROVISION_ID) loop',
'        l_schema := c1.sa1;',
'    end loop;',
'    ',
'    if l_schema is not null then        ',
'        for c1 in (',
'          select 1 from dual',
'          where ',
'(wwv_flow_provisioning.reserved_schema_i(l_schema) = 1)',
' or',
'(wwv_flow_provisioning.restricted_schema_i(l_schema,:P4_COMPANY_NAME) = 1)) loop',
'            return false;',
'        end loop;',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203403932651.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(955890703465997318.4052)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(168826226311399329.4052)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183253903897.4052)
,p_name=>'PROVISION_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(173724892445.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48853112333141000.4052)
,p_name=>'P4_COMPANY_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(173724892445.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(48857919699199941.4052)
,p_computation_sequence=>10
,p_computation_item=>'P4_COMPANY_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select company_name from wwv_flow_provision_company',
' where id = :PROVISION_ID'))
);
end;
/
prompt --application/pages/page_00005
begin
wwv_flow_api.create_page(
 p_id=>5.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('G\00E9rer les demandes')
,p_step_title=>unistr('G\00E9rer les demandes')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216800021154677630)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_ser_rqst.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6119928615239299.4052)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Approuver ou refuser les demandes de service envoy\00E9es par les administrateurs d''espace de travail</p>'),
'<p><a target="_blank" href="&SYSTEM_HELP_URL./aeadm/managing-workspace-and-change-requests.html">En savoir plus...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168703709392622412.4052)
,p_plug_name=>'manage service requests'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(168703120343616153.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(169533626431592276.4052)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(363047307212822256.4052)
,p_plug_name=>'Demandes en suspens'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'sys.htp.p(''<p>'' || wwv_flow_lang.system_message(''INST_RUNNING_IN_MAN_MODE_4050'') || ''</p>'');'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(wwv_flow_platform.get_preference(''SERVICE_REQUEST_FLOW''), ''MANUAL'') = ''MANUAL'''
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--sys.htp.p(wwv_flow_workspace_reports.get_pending_requests(p_session_id => :app_session));',
''))
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(466784027754334318.4052)
,p_plug_name=>'Nouvelles demandes de service'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P5a */',
'    provision_link the_link,',
'    wwv_flow_lang.system_message(''REQUEST_WORKSPACE'',',
'        admin_email,',
'        workspace_name,',
'        request_size ) as the_request,',
'    request_date',
'from',
'(',
'select ',
'    ADMIN_EMAIL,',
'    COMPANY_NAME                         workspace_name,',
'    DATABASE_SIZE||''MB''                  request_size,',
'    request_date                         request_date,',
'    ''f?p=4050:4:''||:app_session||',
'       ''::NO::PROVISION_ID:''||id         provision_link',
'from WWV_FLOW_PROVISION_COMPANY',
'where project_status = ''REQUESTED''',
')',
'union',
'select ',
'        decode(m.request_status,',
'          ''REQUESTED'',''f?p=4050:110:''||:flow_session||',
'                      ''::NO:110:P110_REQUEST_ID,P110_SGID:''||m.id||'',''||',
'                      m.security_group_id,',
'          ''APPROVED'', ''f?p=4050:110:''||:flow_session||',
'                      ''::NO:110,RP:P110_REQUEST_ID,P110_SGID:''||m.id||'',''||',
'                      m.security_group_id) the_link,',
'          decode(m.service_name,',
'          ''NEW_SCHEMA'',wwv_flow_lang.system_message(',
'                 ''REQUEST_NEW_SCHEMA'',',
'                 m.REQUESTED_BY, ',
'                 c.short_name, ',
'                 m.service_attribute_1',
'                 ),',
'          ''CHANGE_DB_SIZE'',       wwv_flow_lang.system_message(',
'                          ''REQUEST_CHANGE_DB_SIZE'',',
'                          m.REQUESTED_BY, ',
'                          c.short_name, ',
'                          m.service_attribute_1||''MB''',
'                          ),',
'           c.short_name ||',
'           '' - ''||m.service_name || ',
'           '' - ''||m.service_attribute_1) as the_request,',
'         m.requested_on        request_date',
'    from wwv_flow_provision_serice_mod m, ',
'         wwv_flow_companies c',
'   where m.security_group_id = c.provisioning_company_id',
'             and   m.request_status = ''REQUESTED'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(466784129153334318.4052)
,p_name=>'New Service Requests'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_show_aggregate=>'N'
,p_show_group_by=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_detail_link=>'#THE_LINK#'
,p_detail_link_text=>'<span class="a-Icon icon-edit"></span>'
,p_detail_link_attr=>'class="a-Button a-Button--small a-Button--noLabel a-Button--withIcon a-Button--noUI"'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(466784329387334331.4052)
,p_db_column_name=>'THE_REQUEST'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Demande de service'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(466784425269334336.4052)
,p_db_column_name=>'REQUEST_DATE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Date de la demande'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472988616335136594.4052)
,p_db_column_name=>'THE_LINK'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Lien'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1080987107325523904.4052)
,p_name=>'Demandes en suspens'
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>80
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--stacked:a-BadgeList--large'
,p_display_point=>'REGION_POSITION_03'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_provisioning.total_open_service_requests new_services,',
'    wwv_flow_provisioning.total_open_change_requests service_change',
'from dual'))
,p_display_when_condition=>'nvl(wwv_flow_platform.get_preference(''SERVICE_REQUEST_FLOW''), ''MANUAL'') != ''MANUAL'''
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805663950138677747.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
,p_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--sys.htp.p(wwv_flow_workspace_reports.get_pending_requests(p_session_id => :app_session));',
''))
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1080987275465523905.4052)
,p_query_column_id=>1
,p_column_alias=>'NEW_SERVICES'
,p_column_display_sequence=>1
,p_column_heading=>'Nouveau service'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:RP,RIR:::'
,p_column_linktext=>'#NEW_SERVICES#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1080987374026523906.4052)
,p_query_column_id=>2
,p_column_alias=>'SERVICE_CHANGE'
,p_column_display_sequence=>2
,p_column_heading=>'Modification de service'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.:RP,RIR:::'
,p_column_linktext=>'#SERVICE_CHANGE#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(484348231779602259.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(466784027754334318.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:5,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(202780809310222232.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(466784027754334318.4052)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er un espace de travail')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:27,79,72,73,74::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(357640393972810948.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(466784027754334318.4052)
,p_button_name=>'CREATE_ATP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517849275695867600.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er un espace de travail')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:142:&SESSION.::&DEBUG.:142:LAST_VIEW:5'
,p_icon_css_classes=>'icon-right-chevron'
,p_required_patch=>-wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(168507612620814711.4052)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'5'
);
end;
/
prompt --application/pages/page_00006
begin
wwv_flow_api.create_page(
 p_id=>6.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Demande de provisionnement'
,p_step_title=>'Demande de provisionnement'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216766430018595041)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>'AEADM/adm_ser_rqst.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(225183790487.4052)
,p_plug_name=>unistr('D\00E9tails de la demande')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_plug_query_num_rows=>15
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'generated 23-FEB-2001 17:53:48'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(825539548181735504.4052)
,p_plug_name=>'Usage Info'
,p_parent_plug_id=>wwv_flow_api.id(225183790487.4052)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517376500704206647.4052)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_required_role=>wwv_flow_api.id(825639761147256575)
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(225294842695.4052)
,p_plug_name=>'Modifier la demande'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Modifiez la demande d''espace de travail en cours.</p>',
unistr('<p>Cliquez sur le bouton <strong>Appliquer les modifications</strong>, s''il est pr\00E9sent,  pour enregistrer vos modifications. Cliquez sur le bouton <strong>Interrompre ou supprimer</strong>, s''il est pr\00E9sent,  pour interrompre la demande. Cliquez sur')
||unistr(' le bouton <strong>Supprimer</strong>, s''il est pr\00E9sent, pour supprimer la demande.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS_INITCAP'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(195699107817256786.4052)
,p_plug_name=>'Modifier une demande de provisionnement'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(225186790489.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(195699107817256786.4052)
,p_button_name=>'Cancel'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2934116575079521.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(195699107817256786.4052)
,p_button_name=>'Terminate_or_Delete'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Interrompre ou supprimer'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_provision_company',
'',
'where id = :F4050_P6_ID',
'',
'and project_status = ''APPROVED'''))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(52722223258062562.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(195699107817256786.4052)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Supprimer'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.::D_PROVISION_ID:&F4050_P6_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_provision_company',
'',
'where id = :F4050_P6_ID',
'',
'and project_status = ''APPROVED'''))
,p_button_condition_type=>'NOT_EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(225190790490.4052)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(195699107817256786.4052)
,p_button_name=>'Apply_Changes'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'NEXT'
,p_button_condition=>'F4050_P6_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(135407227774354772.4052)
,p_branch_action=>'f?p=&FLOW_ID.:81:&SESSION.::&DEBUG.:81,82:P81_COMPANY:&F4050_P6_COMPANY_NAME.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2934116575079521.4052)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(225180790486.4052)
,p_branch_action=>'26'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(225182790487.4052)
,p_branch_action=>'26'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Cancel'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225194790494.4052)
,p_name=>'F4050_P6_ID'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_api.id(225183790487.4052)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225196790494.4052)
,p_name=>'F4050_P6_SECURITY_GROUP_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(225183790487.4052)
,p_use_cache_before_default=>'NO'
,p_source=>'SECURITY_GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225198790495.4052)
,p_name=>'F4050_P6_COMPANY_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(225183790487.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Espace de travail'
,p_source=>'COMPANY_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Saissez un espace de travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225200790495.4052)
,p_name=>'F4050_P6_ADMIN_FIRST_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(225183790487.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Pr\00E9nom de l''administrateur')
,p_source=>'ADMIN_FIRST_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez le pr\00E9nom.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225202790496.4052)
,p_name=>'F4050_P6_ADMIN_LAST_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(225183790487.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nom de l''administrateur'
,p_source=>'ADMIN_LAST_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Saisissez le nom.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225204790497.4052)
,p_name=>'F4050_P6_ADMIN_TITLE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(225183790487.4052)
,p_use_cache_before_default=>'NO'
,p_source=>'ADMIN_TITLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225206790497.4052)
,p_name=>'F4050_P6_ADMIN_EMAIL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(225183790487.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Courriel de l''administrateur'
,p_source=>'ADMIN_EMAIL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez l''adresse \00E9lectronique.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225208790498.4052)
,p_name=>'F4050_P6_ADMIN_PHONE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(225183790487.4052)
,p_use_cache_before_default=>'NO'
,p_source=>'ADMIN_PHONE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225210790498.4052)
,p_name=>'F4050_P6_ADMIN_USERID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(225183790487.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'ID d''utilisateur d''administrateur'
,p_source=>'ADMIN_USERID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifiez l''ID utilisateur de l''administrateur.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225212790499.4052)
,p_name=>'F4050_P6_COMPANY_ADDRESS'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(225183790487.4052)
,p_use_cache_before_default=>'NO'
,p_source=>'COMPANY_ADDRESS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225214790500.4052)
,p_name=>'F4050_P6_CITY'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(225183790487.4052)
,p_use_cache_before_default=>'NO'
,p_source=>'CITY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225216790500.4052)
,p_name=>'F4050_P6_STATE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(225183790487.4052)
,p_use_cache_before_default=>'NO'
,p_source=>'STATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225218790501.4052)
,p_name=>'F4050_P6_ZIP'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(225183790487.4052)
,p_use_cache_before_default=>'NO'
,p_source=>'ZIP'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225220790501.4052)
,p_name=>'P6_COUNTRY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(825539548181735504.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Pays'
,p_source=>'COUNTRY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'COUNTRIES'
,p_lov=>'.'||wwv_flow_api.id(825654386458276754.4052)||'.'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225222790502.4052)
,p_name=>'F4050_P6_COMPANY_TYPE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(225183790487.4052)
,p_use_cache_before_default=>'NO'
,p_source=>'COMPANY_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225236790507.4052)
,p_name=>'F4050_P6_SERVICE_USE_STATUS'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(225183790487.4052)
,p_use_cache_before_default=>'NO'
,p_source=>'SERVICE_USE_STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225238790508.4052)
,p_name=>'F4050_P6_DATABASE_SIZE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(225183790487.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Taille de base de donn\00E9es')
,p_source=>'DATABASE_SIZE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifiez la taille de base de donn\00E9es.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225240790509.4052)
,p_name=>'F4050_P6_SERVICE_START_DATE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(225183790487.4052)
,p_use_cache_before_default=>'NO'
,p_source=>'SERVICE_START_DATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifiez la date de d\00E9but de service.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225242790509.4052)
,p_name=>'F4050_P6_SERVICE_TERMINATION_DATE'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(225183790487.4052)
,p_use_cache_before_default=>'NO'
,p_source=>'SERVICE_TERMINATION_DATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifiez la date d''interruption de service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225244790510.4052)
,p_name=>'F4050_P6_SCHEMA_NAME'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(225183790487.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nom de sch\00E9ma')
,p_source=>'SCHEMA_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select username d,',
'       username r',
'  from wwv_flow_admin_all_schemas s',
' where (   restricted_to_workspace is null',
'        or restricted_to_workspace = upper(:F4050_P6_COMPANY_NAME))',
' order by 1'))
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Identifiez le nom de sch\00E9ma.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225250790511.4052)
,p_name=>'F4050_P6_PROJECT_DESCRIPTION'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(225183790487.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Description de projet'
,p_source=>'PROJECT_DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifier une description de projet'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225254790513.4052)
,p_name=>'F4050_P6_PROJECT_APPROVAL_DATE'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(225183790487.4052)
,p_use_cache_before_default=>'NO'
,p_source=>'PROJECT_APPROVAL_DATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifie la date d''approbation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225256790513.4052)
,p_name=>'F4050_P6_PROJECT_ACTUAL_BEGIN_DATE'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(225183790487.4052)
,p_use_cache_before_default=>'NO'
,p_source=>'PROJECT_ACTUAL_BEGIN_DATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifie la date de provisionnement.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225260790515.4052)
,p_name=>'F4050_P6_PROJECT_STATUS'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(225183790487.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Statut de projet :'
,p_source=>'PROJECT_STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'SERVICE.REQUEST.STATUS'
,p_lov=>'.'||wwv_flow_api.id(87755726864223308.4052)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifiez le statut de projet.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(825539691666735505.4052)
,p_name=>'P6_USAGE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(825539548181735504.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Utilisation'
,p_source=>'USAGE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'USAGE_TYPE'
,p_lov=>'.'||wwv_flow_api.id(825928575701276934.4052)||'.'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(825539783247735506.4052)
,p_name=>'P6_ORG_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(825539548181735504.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Organisation'
,p_source=>'ORG_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P6_USAGE_TYPE'
,p_display_when2=>'ORG'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183384800804268476.4052)
,p_validation_name=>'schema not restricted'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (wwv_flow_provisioning.site_admin_is_restricted and',
'     wwv_flow_provisioning.restricted_schema(',
'         p_schema => upper(:F4050_P6_SCHEMA_NAME),',
'         p_workspace_name => upper(:F4050_P6_COMPANY_NAME)',
'         )) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Le sch\00E9ma demand\00E9 est restreint. Les sch\00E9mas restreints ne peuvent pas \00EAtre affect\00E9s \00E0 des espaces de travail.')
,p_when_button_pressed=>wwv_flow_api.id(225190790490.4052)
,p_associated_item=>wwv_flow_api.id(225244790510.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183404521151643333.4052)
,p_validation_name=>'schema not reserved'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_provisioning.reserved_schema(p_schema =>   ',
'    upper(:F4050_P6_SCHEMA_NAME)) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Le sch\00E9ma demand\00E9 est r\00E9serv\00E9.')
,p_when_button_pressed=>wwv_flow_api.id(225190790490.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(225264790516.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_PROVISION_COMPANY'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PROVISION_COMPANY'
,p_attribute_03=>'F4050_P6_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Erreur lors de l''extraction de la ligne.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(225266790517.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_PROVISION_COMPANY'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PROVISION_COMPANY'
,p_attribute_03=>'F4050_P6_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Erreur lors du traitement de la ligne.'
,p_process_when_button_id=>wwv_flow_api.id(225190790490.4052)
,p_process_success_message=>unistr('Action trait\00E9e.')
);
end;
/
prompt --application/pages/page_00007
begin
wwv_flow_api.create_page(
 p_id=>7.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Ajuster une demande'
,p_step_title=>'Ajuster une demande'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216766430018595041)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>'AEADM/adm_create_wkspc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(43187720190328736.4052)
,p_plug_name=>'Attribut de provisionnement pour statut de modification'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS_INITCAP'
,p_plug_query_num_rows=>5
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_footer=>unistr('<div class="htmldbInstructionText">Les informations ci-dessus proviennent de la demande d''espace de travail. Le nom r\00E9el de l''espace de travail et d''autres attributs peuvent \00EAtre diff\00E9rents pour un utilisateur provisionn\00E9. Il ne s''agit ici que de la ')
||'demande.</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'generated 16-MAR-2001 18:11:26'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(43202121056423198.4052)
,p_plug_name=>'Statut de modification'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Cette page permet aux administrateurs des espaces de travail de modifier le statut d''une demande d''espace de travail.</p>',
unistr('<p>Faire repasser une demande \00E0 <strong>Demand\00E9</strong> permet de reprovisionner un espace de travail.</p>'),
unistr('<p><strong>Remarque :</strong> attention lorsque vous faites passer le statut de projet \00E0 <strong>Demand\00E9</strong>. Bien que le statut <strong>Demand\00E9</strong> vous permette de reprovisionner un espace de travail, les donn\00E9es peuvent se trouver endom')
||unistr('mag\00E9es en raison de la fa\00E7on dont le provisionnement est fourni pour les comptes. Le syst\00E8me de provisionnement consid\00E8re qu''il n''y a pas, pour les demandes d''espace de travail ayant le statut <strong>Demand\00E9</strong>, de sch\00E9mas et d''entr\00E9es de dict')
||unistr('ionnaire correspondants pour des d\00E9veloppeurs ou un administrateur d''espace de travail. Si vous devez faire passer le statut de projet d''un espace de travail <strong>Approuv\00E9</strong> \00E0 <strong>Demand\00E9</strong>, interrompez d''abord l''espace de travai')
||unistr('l puis faites passer le statut \00E0 <strong>Demand\00E9</strong>.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS_INITCAP'
,p_plug_query_num_rows=>5
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(48679045286466446.4052)
,p_name=>'Etat Demande de provisionnement'
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    ID,',
'    SECURITY_GROUP_ID,',
'    COMPANY_NAME,',
'    ADMIN_FIRST_NAME,',
'    ADMIN_LAST_NAME,',
'    ADMIN_TITLE,',
'    ADMIN_EMAIL,',
'    ADMIN_PHONE,',
'    ADMIN_ID,',
'    ADMIN_USERID,',
'    COMPANY_ADDRESS,',
'    CITY,',
'    STATE,',
'    ZIP,',
'    COUNTRY,',
'    SERVICE_USE_STATUS,',
'    DATABASE_SIZE,',
'    SERVICE_START_DATE,',
'    SERVICE_TERMINATION_DATE,',
'    SCHEMA_NAME,',
'    ESTIMATED_END_USERS,',
'    PAGE_VIEWS_PER_DAY,',
'    PROJECT_DESCRIPTION,',
'    PROJECT_JUSTIFICATION,',
'    PROJECT_STATUS,',
'    REQUEST_DATE,',
'   SURVEY_QUESTION_01,',
'    SURVEY_ANSWER_01,',
'    SURVEY_QUESTION_02,',
'    SURVEY_ANSWER_02,',
'    SURVEY_QUESTION_03,',
'    SURVEY_ANSWER_03,',
'    SURVEY_QUESTION_04,',
'    SURVEY_ANSWER_04,',
'    SURVEY_QUESTION_05,',
'    SURVEY_ANSWER_05,',
'    SURVEY_QUESTION_06,',
'    SURVEY_ANSWER_06,',
'    SURVEY_QUESTION_07,',
'    SURVEY_ANSWER_07,',
'    SURVEY_QUESTION_08,',
'    SURVEY_ANSWER_08,',
'    SURVEY_QUESTION_09,',
'    SURVEY_ANSWER_09,',
'    SURVEY_QUESTION_10,',
'    SURVEY_ANSWER_10,',
'    AGREEMENT_ACCEPTANCE_DATE,',
'    AGREEMENT_NAME,',
'    AGREEMENT_USER_ENV',
'from WWV_FLOW_PROVISION_COMPANY',
'where id = :T_PROVISION_ID'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>2
,p_query_num_rows=>5
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48556132422770818.4052)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'ID'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48556223377770818.4052)
,p_query_column_id=>2
,p_column_alias=>'SECURITY_GROUP_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Espace de travail'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48556324615770818.4052)
,p_query_column_id=>3
,p_column_alias=>'COMPANY_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nom de l''espace de travail'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48556402156770818.4052)
,p_query_column_id=>4
,p_column_alias=>'ADMIN_FIRST_NAME'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Pr\00E9nom')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48556509895770818.4052)
,p_query_column_id=>5
,p_column_alias=>'ADMIN_LAST_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Nom'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48556604610770818.4052)
,p_query_column_id=>6
,p_column_alias=>'ADMIN_TITLE'
,p_column_display_sequence=>6
,p_column_heading=>'Fonction'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48556719143770818.4052)
,p_query_column_id=>7
,p_column_alias=>'ADMIN_EMAIL'
,p_column_display_sequence=>7
,p_column_heading=>'Courriel'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48556819251770818.4052)
,p_query_column_id=>8
,p_column_alias=>'ADMIN_PHONE'
,p_column_display_sequence=>8
,p_column_heading=>unistr('T\00E9l\00E9phone')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48556903983770819.4052)
,p_query_column_id=>9
,p_column_alias=>'ADMIN_ID'
,p_column_display_sequence=>9
,p_column_heading=>'ID de l''administrateur'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48557019200770819.4052)
,p_query_column_id=>10
,p_column_alias=>'ADMIN_USERID'
,p_column_display_sequence=>10
,p_column_heading=>'Administrateur'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48557116708770819.4052)
,p_query_column_id=>11
,p_column_alias=>'COMPANY_ADDRESS'
,p_column_display_sequence=>11
,p_column_heading=>'Adresse'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48557212730770819.4052)
,p_query_column_id=>12
,p_column_alias=>'CITY'
,p_column_display_sequence=>12
,p_column_heading=>'Ville'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48557300303770819.4052)
,p_query_column_id=>13
,p_column_alias=>'STATE'
,p_column_display_sequence=>13
,p_column_heading=>unistr('Province/D\00E9partement')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48557417190770819.4052)
,p_query_column_id=>14
,p_column_alias=>'ZIP'
,p_column_display_sequence=>14
,p_column_heading=>'Code postal'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48557531161770819.4052)
,p_query_column_id=>15
,p_column_alias=>'COUNTRY'
,p_column_display_sequence=>15
,p_column_heading=>'Pays'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48558301343770820.4052)
,p_query_column_id=>16
,p_column_alias=>'SERVICE_USE_STATUS'
,p_column_display_sequence=>16
,p_column_heading=>'Statut d''utilisation d''espace de travail'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48558416989770820.4052)
,p_query_column_id=>17
,p_column_alias=>'DATABASE_SIZE'
,p_column_display_sequence=>17
,p_column_heading=>unistr('Taille de base de donn\00E9es')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48558502328770820.4052)
,p_query_column_id=>18
,p_column_alias=>'SERVICE_START_DATE'
,p_column_display_sequence=>18
,p_column_heading=>unistr('Date de d\00E9but d''espace de travail')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48558608436770821.4052)
,p_query_column_id=>19
,p_column_alias=>'SERVICE_TERMINATION_DATE'
,p_column_display_sequence=>19
,p_column_heading=>'Date de fin d''espace de travail'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48558732412770821.4052)
,p_query_column_id=>20
,p_column_alias=>'SCHEMA_NAME'
,p_column_display_sequence=>20
,p_column_heading=>unistr('Nom de sch\00E9ma')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48558828706770821.4052)
,p_query_column_id=>21
,p_column_alias=>'ESTIMATED_END_USERS'
,p_column_display_sequence=>21
,p_column_heading=>unistr('Utilisateurs finals estim\00E9s')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48558926502770821.4052)
,p_query_column_id=>22
,p_column_alias=>'PAGE_VIEWS_PER_DAY'
,p_column_display_sequence=>22
,p_column_heading=>'Vues de page par jour'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48559028941770821.4052)
,p_query_column_id=>23
,p_column_alias=>'PROJECT_DESCRIPTION'
,p_column_display_sequence=>23
,p_column_heading=>'Description de projet'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48559105122770821.4052)
,p_query_column_id=>24
,p_column_alias=>'PROJECT_JUSTIFICATION'
,p_column_display_sequence=>24
,p_column_heading=>'Justification de projet'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48559505641770822.4052)
,p_query_column_id=>25
,p_column_alias=>'PROJECT_STATUS'
,p_column_display_sequence=>25
,p_column_heading=>'Statut de projet'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(316820619150159698)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48559715673770822.4052)
,p_query_column_id=>26
,p_column_alias=>'REQUEST_DATE'
,p_column_display_sequence=>26
,p_column_heading=>'Date de demande'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(127233300885112327.4052)
,p_query_column_id=>27
,p_column_alias=>'SURVEY_QUESTION_01'
,p_column_display_sequence=>27
,p_column_heading=>unistr('Question 1 de l''enqu\00EAte')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(127233418541112327.4052)
,p_query_column_id=>28
,p_column_alias=>'SURVEY_ANSWER_01'
,p_column_display_sequence=>28
,p_column_heading=>unistr('R\00E9ponse 1 \00E0 l''enqu\00EAte')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(127233515172112327.4052)
,p_query_column_id=>29
,p_column_alias=>'SURVEY_QUESTION_02'
,p_column_display_sequence=>29
,p_column_heading=>unistr('Question 2 de l''enqu\00EAte')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(127233615113112327.4052)
,p_query_column_id=>30
,p_column_alias=>'SURVEY_ANSWER_02'
,p_column_display_sequence=>30
,p_column_heading=>unistr('R\00E9ponse 2 \00E0 l''enqu\00EAte')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(127233706102112327.4052)
,p_query_column_id=>31
,p_column_alias=>'SURVEY_QUESTION_03'
,p_column_display_sequence=>31
,p_column_heading=>unistr('Question 3 de l''enqu\00EAte')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(127233801078112327.4052)
,p_query_column_id=>32
,p_column_alias=>'SURVEY_ANSWER_03'
,p_column_display_sequence=>32
,p_column_heading=>unistr('R\00E9ponse 3 \00E0 l''enqu\00EAte')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(127233932661112327.4052)
,p_query_column_id=>33
,p_column_alias=>'SURVEY_QUESTION_04'
,p_column_display_sequence=>33
,p_column_heading=>unistr('Question 4 de l''enqu\00EAte')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(127234021629112327.4052)
,p_query_column_id=>34
,p_column_alias=>'SURVEY_ANSWER_04'
,p_column_display_sequence=>34
,p_column_heading=>unistr('R\00E9ponse 4 \00E0 l''enqu\00EAte')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(127234122858112327.4052)
,p_query_column_id=>35
,p_column_alias=>'SURVEY_QUESTION_05'
,p_column_display_sequence=>35
,p_column_heading=>unistr('Question 5 de l''enqu\00EAte')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(127234232119112327.4052)
,p_query_column_id=>36
,p_column_alias=>'SURVEY_ANSWER_05'
,p_column_display_sequence=>36
,p_column_heading=>unistr('R\00E9ponse 5 \00E0 l''enqu\00EAte')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(127234323875112327.4052)
,p_query_column_id=>37
,p_column_alias=>'SURVEY_QUESTION_06'
,p_column_display_sequence=>37
,p_column_heading=>unistr('Question 6 de l''enqu\00EAte')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(127234415961112327.4052)
,p_query_column_id=>38
,p_column_alias=>'SURVEY_ANSWER_06'
,p_column_display_sequence=>38
,p_column_heading=>unistr('R\00E9ponse 6 \00E0 l''enqu\00EAte')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(127234512307112327.4052)
,p_query_column_id=>39
,p_column_alias=>'SURVEY_QUESTION_07'
,p_column_display_sequence=>39
,p_column_heading=>unistr('Question 7 de l''enqu\00EAte')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(127234601873112328.4052)
,p_query_column_id=>40
,p_column_alias=>'SURVEY_ANSWER_07'
,p_column_display_sequence=>40
,p_column_heading=>unistr('R\00E9ponse 7 \00E0 l''enqu\00EAte')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(127234717583112328.4052)
,p_query_column_id=>41
,p_column_alias=>'SURVEY_QUESTION_08'
,p_column_display_sequence=>41
,p_column_heading=>unistr('Question 8 de l''enqu\00EAte')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(127234801062112328.4052)
,p_query_column_id=>42
,p_column_alias=>'SURVEY_ANSWER_08'
,p_column_display_sequence=>42
,p_column_heading=>unistr('R\00E9ponse 8 \00E0 l''enqu\00EAte')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(127234916016112328.4052)
,p_query_column_id=>43
,p_column_alias=>'SURVEY_QUESTION_09'
,p_column_display_sequence=>43
,p_column_heading=>unistr('Question 9 de l''enqu\00EAte')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(127235000735112328.4052)
,p_query_column_id=>44
,p_column_alias=>'SURVEY_ANSWER_09'
,p_column_display_sequence=>44
,p_column_heading=>unistr('R\00E9ponse 9 \00E0 l''enqu\00EAte')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(127235111807112328.4052)
,p_query_column_id=>45
,p_column_alias=>'SURVEY_QUESTION_10'
,p_column_display_sequence=>45
,p_column_heading=>unistr('Question 10 de l''enqu\00EAte')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(127235211618112328.4052)
,p_query_column_id=>46
,p_column_alias=>'SURVEY_ANSWER_10'
,p_column_display_sequence=>46
,p_column_heading=>unistr('R\00E9ponse 10 \00E0 l''enqu\00EAte')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(127235322684112328.4052)
,p_query_column_id=>47
,p_column_alias=>'AGREEMENT_ACCEPTANCE_DATE'
,p_column_display_sequence=>47
,p_column_heading=>'Date d''acceptation de l''accord'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(127235407487112328.4052)
,p_query_column_id=>48
,p_column_alias=>'AGREEMENT_NAME'
,p_column_display_sequence=>48
,p_column_heading=>'Nom d''accord'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(127235506714112328.4052)
,p_query_column_id=>49
,p_column_alias=>'AGREEMENT_USER_ENV'
,p_column_display_sequence=>49
,p_column_heading=>'Environnement de l''utilisateur de l''accord'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168823108472356352.4052)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(227262248958.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(168823108472356352.4052)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(43186036285311765.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(168823108472356352.4052)
,p_button_name=>'Apply_Changes'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'CREATE'
,p_button_condition=>'(:T_PROVISION_ID is not null)'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(23895428675298516.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(168823108472356352.4052)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Supprimer'
,p_button_position=>'CREATE'
,p_button_condition=>'F4050_P26_STATUS'
,p_button_condition2=>'ACCEPTED'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(168825819600387963.4052)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(227275281088.4052)
,p_name=>'T_PROVISION_ID'
,p_item_sequence=>10
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_prompt=>'<b>New Service Provisioning Request ID</b>:'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3143616388404027.4052)
,p_name=>'F4050_P7_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(43187720190328736.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'ID de demande :'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'ID de la demande de provisionnement.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3147132094442338.4052)
,p_name=>'F4050_P7_SECURITY_GROUP_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(43187720190328736.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('ID de groupe de s\00E9curit\00E9 (identifie un espace de travail) :')
,p_source=>'SECURITY_GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('ID de l''espace de travail provisionn\00E9.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3149427134444600.4052)
,p_name=>'F4050_P7_COMPANY_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(43187720190328736.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Espace de travail :'
,p_source=>'COMPANY_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nom de l''espace de travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3151719586448120.4052)
,p_name=>'F4050_P7_ADMIN_EMAIL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(43187720190328736.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Courriel de l''administrateur :'
,p_source=>'ADMIN_EMAIL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Adresse \00E9lectronique de l''administrateur pour l''espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3154014626450405.4052)
,p_name=>'F4050_P7_SCHEMA_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(43187720190328736.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nom de sch\00E9ma :')
,p_source=>'SCHEMA_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Sch\00E9ma \00E0 provisionner.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3156308803453087.4052)
,p_name=>'F4050_P7_PROJECT_STATUS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(43187720190328736.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Statut de projet'
,p_source=>'PROJECT_STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SERVICE.REQUEST.STATUS'
,p_lov=>'.'||wwv_flow_api.id(87755726864223308.4052)||'.'
,p_cHeight=>1
,p_read_only_when=>'F4050_P7_PROJECT_STATUS'
,p_read_only_when2=>'TERMINATED'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Statut de projet.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(52855125454514117.4052)
,p_name=>'F4050_P7_PREV_PROJ_STATUS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(43187720190328736.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'F4050_P7_PREV_PROJ_STATUS'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select project_status',
'',
'from wwv_flow_provision_company',
'',
'where id = :F4050_P7_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(52862315508549089.4052)
,p_validation_name=>'status error'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4050_P7_PREV_PROJ_STATUS = ''APPROVED'' then',
'  if :F4050_P7_PROJECT_STATUS = ''TERMINATED'' then',
'    return true;',
'  else',
'    return false;',
'  end if;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Un service approuv\00E9 ne peut qu''\00EAtre interrompu. Toute autre modification de statut endommagera les donn\00E9es.')
,p_when_button_pressed=>wwv_flow_api.id(43186036285311765.4052)
,p_associated_item=>wwv_flow_api.id(3156308803453087.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(43195820508328757.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_PROVISION_COMPANY'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PROVISION_COMPANY'
,p_attribute_03=>'T_PROVISION_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Erreur lors de l''extraction de la ligne.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(43196090106328758.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_PROVISION_COMPANY'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PROVISION_COMPANY'
,p_attribute_03=>'T_PROVISION_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Erreur lors du traitement de la ligne.'
,p_process_when_button_id=>wwv_flow_api.id(43186036285311765.4052)
,p_process_when=>'F4050_P7_PROJECT_STATUS'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_process_when2=>'TERMINATED'
,p_process_success_message=>unistr('Action trait\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(52670212528973146.4052)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'terminate service'
,p_process_sql_clob=>'wwv_flow_provisioning.terminate_service(p_id=>:F4050_P7_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors de l''interruption du service.'
,p_process_when_button_id=>wwv_flow_api.id(43186036285311765.4052)
,p_process_when=>'F4050_P7_PROJECT_STATUS'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'TERMINATED'
,p_process_success_message=>'Service interrompu.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22250501311969152.4052)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete service'
,p_process_sql_clob=>'wwv_flow_provisioning.delete_accepted_request(p_id=>:F4050_P7_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors de la suppression du service.'
,p_process_when_button_id=>wwv_flow_api.id(23895428675298516.4052)
,p_process_when=>'F4050_P26_STATUS'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'ACCEPTED'
,p_process_success_message=>unistr('Service supprim\00E9.')
);
end;
/
prompt --application/pages/page_00008
begin
wwv_flow_api.create_page(
 p_id=>8.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Supprimer une demande'
,p_step_title=>'Supprimer une demande'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216766430018595041)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>'AEADM/adm_create_wkspc.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(2842620068855323.4052)
,p_name=>'Demande de provisionnement'
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>'select * from wwv_flow_provision_company where id = :D_PROVISION_ID'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>2
,p_query_num_rows=>5
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48631213889771330.4052)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48631331903771330.4052)
,p_query_column_id=>2
,p_column_alias=>'SECURITY_GROUP_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Espace de travail'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48631423316771330.4052)
,p_query_column_id=>3
,p_column_alias=>'COMPANY_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nom de l''espace de travail'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48631502805771331.4052)
,p_query_column_id=>4
,p_column_alias=>'ADMIN_FIRST_NAME'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Pr\00E9nom de l''administrateur')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48631615946771331.4052)
,p_query_column_id=>5
,p_column_alias=>'ADMIN_LAST_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Nom de l''administrateur'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48631701678771331.4052)
,p_query_column_id=>6
,p_column_alias=>'ADMIN_TITLE'
,p_column_display_sequence=>6
,p_column_heading=>'Titre de l''administrateur'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48631811461771331.4052)
,p_query_column_id=>7
,p_column_alias=>'ADMIN_EMAIL'
,p_column_display_sequence=>7
,p_column_heading=>'Courriel de l''administrateur'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48631925591771331.4052)
,p_query_column_id=>8
,p_column_alias=>'ADMIN_PHONE'
,p_column_display_sequence=>8
,p_column_heading=>unistr('T\00E9l\00E9phone de l''administrateur')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48632024673771331.4052)
,p_query_column_id=>9
,p_column_alias=>'ADMIN_ID'
,p_column_display_sequence=>9
,p_column_heading=>'Administrateur'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48632117814771331.4052)
,p_query_column_id=>10
,p_column_alias=>'ADMIN_USERID'
,p_column_display_sequence=>10
,p_column_heading=>'ID d''utilisateur de l''administrateur'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48632218354771331.4052)
,p_query_column_id=>11
,p_column_alias=>'COMPANY_ADDRESS'
,p_column_display_sequence=>11
,p_column_heading=>unistr('Adresse de soci\00E9t\00E9')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48632328727771331.4052)
,p_query_column_id=>12
,p_column_alias=>'CITY'
,p_column_display_sequence=>12
,p_column_heading=>'Ville'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48632405878771332.4052)
,p_query_column_id=>13
,p_column_alias=>'STATE'
,p_column_display_sequence=>13
,p_column_heading=>unistr('Province/D\00E9partement')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48632521698771332.4052)
,p_query_column_id=>14
,p_column_alias=>'ZIP'
,p_column_display_sequence=>14
,p_column_heading=>'Code postal'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48632632685771332.4052)
,p_query_column_id=>15
,p_column_alias=>'COUNTRY'
,p_column_display_sequence=>17
,p_column_heading=>'Pays'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_report_column_required_role=>wwv_flow_api.id(825639761147256575)
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(825654386458276754)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48632706380771332.4052)
,p_query_column_id=>16
,p_column_alias=>'COMPANY_TYPE'
,p_column_display_sequence=>20
,p_column_heading=>unistr('Type de soci\00E9t\00E9')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48632818574771332.4052)
,p_query_column_id=>17
,p_column_alias=>'COMPANY_WEBSITE'
,p_column_display_sequence=>21
,p_column_heading=>unistr('Site Web de soci\00E9t\00E9')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48632908699771332.4052)
,p_query_column_id=>18
,p_column_alias=>'NUMBER_OF_EMPLOYEES'
,p_column_display_sequence=>22
,p_column_heading=>'Nombre de collaborateurs'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48633014812771332.4052)
,p_query_column_id=>19
,p_column_alias=>'COMPANY_PHONE'
,p_column_display_sequence=>23
,p_column_heading=>unistr('T\00E9l\00E9phone de soci\00E9t\00E9')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48633113309771332.4052)
,p_query_column_id=>20
,p_column_alias=>'COMPANY_FAX'
,p_column_display_sequence=>24
,p_column_heading=>unistr('Fax de soci\00E9t\00E9')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48633231303771332.4052)
,p_query_column_id=>21
,p_column_alias=>'ORACLE_PARTNER'
,p_column_display_sequence=>25
,p_column_heading=>'Partenaire Oracle'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48633303328771333.4052)
,p_query_column_id=>22
,p_column_alias=>'HOW_DID_YOU_HEAR_ABOUT_US'
,p_column_display_sequence=>26
,p_column_heading=>'Comment nous avez-vous connus'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48633407898771333.4052)
,p_query_column_id=>23
,p_column_alias=>'SERVICE_USE_STATUS'
,p_column_display_sequence=>27
,p_column_heading=>'Statut d''utilisation d''espace de travail'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48633520261771333.4052)
,p_query_column_id=>24
,p_column_alias=>'DATABASE_SIZE'
,p_column_display_sequence=>28
,p_column_heading=>unistr('Taille de base de donn\00E9es')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236237917010177041.4052)
,p_query_column_id=>25
,p_column_alias=>'DATABASE_INITIAL_SIZE'
,p_column_display_sequence=>42
,p_column_heading=>unistr('Taille initiale de la base de donn\00E9es')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48633625766771333.4052)
,p_query_column_id=>26
,p_column_alias=>'SERVICE_START_DATE'
,p_column_display_sequence=>29
,p_column_heading=>unistr('Date de d\00E9but d''espace de travail')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48633723979771333.4052)
,p_query_column_id=>27
,p_column_alias=>'SERVICE_TERMINATION_DATE'
,p_column_display_sequence=>30
,p_column_heading=>'Date de fin d''espace de travail'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48633823851771333.4052)
,p_query_column_id=>28
,p_column_alias=>'SCHEMA_NAME'
,p_column_display_sequence=>31
,p_column_heading=>unistr('Nom de sch\00E9ma')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48633922599771333.4052)
,p_query_column_id=>29
,p_column_alias=>'ESTIMATED_END_USERS'
,p_column_display_sequence=>32
,p_column_heading=>unistr('Utilisateurs finals estim\00E9s')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48634022185771333.4052)
,p_query_column_id=>30
,p_column_alias=>'PAGE_VIEWS_PER_DAY'
,p_column_display_sequence=>33
,p_column_heading=>'Vues de page par jour'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236238009656177041.4052)
,p_query_column_id=>31
,p_column_alias=>'SURVEY_QUESTION_01'
,p_column_display_sequence=>43
,p_column_heading=>unistr('Question 01 de l''enqu\00EAte')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236238124332177041.4052)
,p_query_column_id=>32
,p_column_alias=>'SURVEY_ANSWER_01'
,p_column_display_sequence=>44
,p_column_heading=>unistr('R\00E9ponse 01 \00E0 l''enqu\00EAte')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236238225708177041.4052)
,p_query_column_id=>33
,p_column_alias=>'SURVEY_QUESTION_02'
,p_column_display_sequence=>45
,p_column_heading=>unistr('Question 02 de l''enqu\00EAte')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236238319647177041.4052)
,p_query_column_id=>34
,p_column_alias=>'SURVEY_ANSWER_02'
,p_column_display_sequence=>46
,p_column_heading=>unistr('R\00E9ponse 02 \00E0 l''enqu\00EAte')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236238404563177041.4052)
,p_query_column_id=>35
,p_column_alias=>'SURVEY_QUESTION_03'
,p_column_display_sequence=>47
,p_column_heading=>unistr('Question 03 de l''enqu\00EAte')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236238510917177041.4052)
,p_query_column_id=>36
,p_column_alias=>'SURVEY_ANSWER_03'
,p_column_display_sequence=>48
,p_column_heading=>unistr('R\00E9ponse 03 \00E0 l''enqu\00EAte')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236238617141177041.4052)
,p_query_column_id=>37
,p_column_alias=>'SURVEY_QUESTION_04'
,p_column_display_sequence=>49
,p_column_heading=>unistr('Question 04 de l''enqu\00EAte')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236238722774177041.4052)
,p_query_column_id=>38
,p_column_alias=>'SURVEY_ANSWER_04'
,p_column_display_sequence=>50
,p_column_heading=>unistr('R\00E9ponse 04 \00E0 l''enqu\00EAte')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236238832744177041.4052)
,p_query_column_id=>39
,p_column_alias=>'SURVEY_QUESTION_05'
,p_column_display_sequence=>51
,p_column_heading=>unistr('Question 05 de l''enqu\00EAte')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236238918528177041.4052)
,p_query_column_id=>40
,p_column_alias=>'SURVEY_ANSWER_05'
,p_column_display_sequence=>52
,p_column_heading=>unistr('R\00E9ponse 05 \00E0 l''enqu\00EAte')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236239032365177041.4052)
,p_query_column_id=>41
,p_column_alias=>'SURVEY_QUESTION_06'
,p_column_display_sequence=>53
,p_column_heading=>unistr('Question 06 de l''enqu\00EAte')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236239120445177041.4052)
,p_query_column_id=>42
,p_column_alias=>'SURVEY_ANSWER_06'
,p_column_display_sequence=>54
,p_column_heading=>unistr('R\00E9ponse 06 \00E0 l''enqu\00EAte')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236239200835177041.4052)
,p_query_column_id=>43
,p_column_alias=>'SURVEY_QUESTION_07'
,p_column_display_sequence=>55
,p_column_heading=>unistr('Question 07 de l''enqu\00EAte')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236239311259177041.4052)
,p_query_column_id=>44
,p_column_alias=>'SURVEY_ANSWER_07'
,p_column_display_sequence=>56
,p_column_heading=>unistr('R\00E9ponse 07 \00E0 l''enqu\00EAte')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236239414214177041.4052)
,p_query_column_id=>45
,p_column_alias=>'SURVEY_QUESTION_08'
,p_column_display_sequence=>57
,p_column_heading=>unistr('Question 08 de l''enqu\00EAte')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236239531458177042.4052)
,p_query_column_id=>46
,p_column_alias=>'SURVEY_ANSWER_08'
,p_column_display_sequence=>58
,p_column_heading=>unistr('R\00E9ponse 08 \00E0 l''enqu\00EAte')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236239615538177042.4052)
,p_query_column_id=>47
,p_column_alias=>'SURVEY_QUESTION_09'
,p_column_display_sequence=>59
,p_column_heading=>unistr('Question 09 de l''enqu\00EAte')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236239730325177042.4052)
,p_query_column_id=>48
,p_column_alias=>'SURVEY_ANSWER_09'
,p_column_display_sequence=>60
,p_column_heading=>unistr('R\00E9ponse 09 \00E0 l''enqu\00EAte')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236239807463177042.4052)
,p_query_column_id=>49
,p_column_alias=>'SURVEY_QUESTION_10'
,p_column_display_sequence=>61
,p_column_heading=>unistr('Question 10 de l''enqu\00EAte')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236239927232177042.4052)
,p_query_column_id=>50
,p_column_alias=>'SURVEY_ANSWER_10'
,p_column_display_sequence=>62
,p_column_heading=>unistr('R\00E9ponse 10 \00E0 l''enqu\00EAte')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236240012349177042.4052)
,p_query_column_id=>51
,p_column_alias=>'AGREEMENT_ACCEPTANCE_DATE'
,p_column_display_sequence=>63
,p_column_heading=>'Date d''acceptation de l''accord'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236240132249177042.4052)
,p_query_column_id=>52
,p_column_alias=>'AGREEMENT_NAME'
,p_column_display_sequence=>64
,p_column_heading=>'Nom d''accord'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236240230795177042.4052)
,p_query_column_id=>53
,p_column_alias=>'AGREEMENT_USER_ENV'
,p_column_display_sequence=>65
,p_column_heading=>'Environnement de l''utilisateur de l''accord'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236240329233177042.4052)
,p_query_column_id=>54
,p_column_alias=>'AGREEMENT_CHECKSUM'
,p_column_display_sequence=>66
,p_column_heading=>'Checksum de l''accord'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48634128002771334.4052)
,p_query_column_id=>55
,p_column_alias=>'PROJECT_DESCRIPTION'
,p_column_display_sequence=>34
,p_column_heading=>'Description de projet'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48634202021771334.4052)
,p_query_column_id=>56
,p_column_alias=>'PROJECT_JUSTIFICATION'
,p_column_display_sequence=>35
,p_column_heading=>'Justification de projet'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48634307951771334.4052)
,p_query_column_id=>57
,p_column_alias=>'PROJECT_APPROVAL_DATE'
,p_column_display_sequence=>36
,p_column_heading=>'Date d''approbation de projet'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48634404873771334.4052)
,p_query_column_id=>58
,p_column_alias=>'PROJECT_ACTUAL_BEGIN_DATE'
,p_column_display_sequence=>37
,p_column_heading=>unistr('Date de d\00E9but r\00E9elle de projet')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48634508156771334.4052)
,p_query_column_id=>59
,p_column_alias=>'PROJECT_ACTUAL_END_DATE'
,p_column_display_sequence=>38
,p_column_heading=>unistr('Date de fin r\00E9elle de projet')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48634623965771334.4052)
,p_query_column_id=>60
,p_column_alias=>'PROJECT_STATUS'
,p_column_display_sequence=>39
,p_column_heading=>'Statut de projet'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48634727595771334.4052)
,p_query_column_id=>61
,p_column_alias=>'WORK_LOG'
,p_column_display_sequence=>40
,p_column_heading=>'Journal de travail'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48634805072771335.4052)
,p_query_column_id=>62
,p_column_alias=>'REQUEST_DATE'
,p_column_display_sequence=>41
,p_column_heading=>'Date de demande'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(852083723823313781.4052)
,p_query_column_id=>63
,p_column_alias=>'WORKSPACE_TYPE'
,p_column_display_sequence=>67
,p_column_heading=>'Type d''espace de travail'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(825539888042735507.4052)
,p_query_column_id=>64
,p_column_alias=>'IP_ADDRESS'
,p_column_display_sequence=>68
,p_column_heading=>'Adresse IP'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(825539908447735508.4052)
,p_query_column_id=>65
,p_column_alias=>'USAGE_TYPE'
,p_column_display_sequence=>18
,p_column_heading=>'Utilisation'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_report_column_required_role=>wwv_flow_api.id(825639761147256575)
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(825928575701276934)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(825540065042735509.4052)
,p_query_column_id=>66
,p_column_alias=>'ORG_NAME'
,p_column_display_sequence=>19
,p_column_heading=>'Organisation'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_report_column_required_role=>wwv_flow_api.id(825639761147256575)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(56499914833442395.4052)
,p_plug_name=>'Supprimer une demande'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Si l''espace de travail est interrompu ou refus\00E9, vous pouvez supprimer la totalit\00E9 de la demande dans le syst\00E8me \00E0 l''aide de cette page.  ')
,p_plug_query_headings=>'Edit:Seq.:Col.:Name:Display:Template:Source:Items:Buttons:BuildOption:DisplayWhenType'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
,p_plug_query_col_allignments=>'L:L:L:L:L:L:L:R:R:L:L:L:L'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(227287494596.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2842620068855323.4052)
,p_button_name=>'Cancel'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(227285494595.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2842620068855323.4052)
,p_button_name=>'DeleteRequest'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Supprimer une demande'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(227291494598.4052)
,p_branch_action=>'26'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(227285494595.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(227319764028.4052)
,p_branch_action=>'26'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(227293494598.4052)
,p_branch_action=>'26'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(227287494596.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2847701305864055.4052)
,p_name=>'D_PROVISION_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2842620068855323.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2855101293879192.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete request'
,p_process_sql_clob=>'wwv_flow_provisioning.delete_provision_request(p_id=>:D_PROVISION_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors de la suppression de la demande d''espace de travail.'
,p_process_when_button_id=>wwv_flow_api.id(227285494595.4052)
,p_process_success_message=>unistr('Demande supprim\00E9e.')
);
end;
/
prompt --application/pages/page_00009
begin
wwv_flow_api.create_page(
 p_id=>9.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('G\00E9rer une instance')
,p_step_title=>unistr('G\00E9rer une instance')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931176884177111905)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_ser_rqst.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168495707597569444.4052)
,p_plug_name=>unistr('Param\00E8tres d''instance')
,p_icon_css_classes=>'icon-utilities-ui-defaults'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:h240'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_api.id(966388705490342505.4052)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(47534314618390800.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168503102999717326.4052)
,p_plug_name=>unistr('G\00E9rer les composants partag\00E9s')
,p_icon_css_classes=>'icon-util-shared-components'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:h240'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_api.id(966388705490342505.4052)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(137961006165346808.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168503812265738931.4052)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cette page pour contr\00F4ler et d\00E9finir les fonctions et fonctionnalit\00E9s de cette instance &PRODUCT_NAME..</p>'),
'<p><a target="_blank" href="&SYSTEM_HELP_URL./aeadm/overview-of-oracle-application-express-administration-services.html#GUID-94198B56-CABC-42F3-8795-F38212936763">En savoir plus...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168504112396748429.4052)
,p_plug_name=>unistr('G\00E9rer les m\00E9tadonn\00E9es')
,p_icon_css_classes=>'icon-util-object-dependencies'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:h240'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_api.id(966388705490342505.4052)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_api.id(19017202882431374.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168506212358795720.4052)
,p_plug_name=>'Messages'
,p_icon_css_classes=>'icon-sc-list'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:h240'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_api.id(966388705490342505.4052)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(168505619846788416.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(192441415743903627.4052)
,p_plug_name=>unistr('G\00E9rer des journaux et des fichiers')
,p_region_css_classes=>'h390'
,p_icon_css_classes=>'icon-util-logs'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_api.id(966388705490342505.4052)
,p_plug_display_sequence=>50
,p_list_id=>wwv_flow_api.id(5021913929565780.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203029008911057378.4052)
,p_plug_name=>'Inscription en libre-service'
,p_region_css_classes=>'h390'
,p_icon_css_classes=>'icon-admin-service-request'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_api.id(966388705490342505.4052)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(203028225668057376.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--bottomBorder'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(254701518341001744.4052)
,p_plug_name=>'Mode de provisionnement'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_output     varchar2(32767);',
'    l_session_id varchar2(255) := :APP_SESSION;',
'    x            varchar2(4000);',
'begin',
'    x := wwv_flow_platform.get_preference( p_preference_name => ''SERVICE_REQUEST_FLOW'' );',
'    l_output := ''<strong><a href="f?p=4050:131:''||l_session_id||'':::RIR:">'';',
'    if x = ''EMAIL'' then',
'        l_output:=l_output||wwv_flow_lang.system_message(''SELF_SERVICE_WITH_EMAIL'');',
'    elsif x = ''4700'' then',
'        l_output:=l_output||wwv_flow_lang.system_message(''SELF_SERVICE'');',
'    elsif x = ''AUTO'' then',
'        l_output:=l_output||wwv_flow_lang.system_message(''F4050.AUTOMATIC'');',
'    else',
'        l_output:=l_output||wwv_flow_lang.system_message(''MANUAL'');',
'    end if;',
'    l_output:=l_output||''</a></strong>'';',
'    sys.htp.p(l_output);',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(968837253318525063.4052)
,p_name=>'Mesures'
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--stacked:a-BadgeList--xlarge'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_point=>'REGION_POSITION_03'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4500P1000cMH9 */',
'   (select to_char(nvl(wwv_flow_platform.get_preference( p_preference_name => ''MAX_SESSION_IDLE_SEC''),3600),''999G999G999G999G990'') x from dual)  max_session_idle_time',
'from dual'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805663950138677747.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(968839153112542694.4052)
,p_query_column_id=>1
,p_column_alias=>'MAX_SESSION_IDLE_TIME'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Temps maximal d''inactivit\00E9 de session en secondes')
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(168507403963812268.4052)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'9'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1364682309896820101.4052)
,p_name=>'Close Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(192441415743903627.4052)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1364682468819820102.4052)
,p_event_id=>wwv_flow_api.id(1364682309896820101.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    // use new API to show the success message if any that came from the dialog',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
end;
/
prompt --application/pages/page_00010
begin
wwv_flow_api.create_page(
 p_id=>10.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('G\00E9rer les espaces de travail')
,p_step_title=>unistr('G\00E9rer les espaces de travail')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style>',
'#fixed_height_region .rc-content {min-height: 200px; padding: 0;}',
'</style>'))
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_wrkspc_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6049701880928601.4052)
,p_plug_name=>'Actions d''espace de travail'
,p_region_css_classes=>'h360'
,p_icon_css_classes=>'icon-util-workspace-actions'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_api.id(966388705490342505.4052)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(19017606691432489.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6144611534376254.4052)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Un espace de travail est une zone de travail partag\00E9e dans laquelle plusieurs d\00E9veloppeurs peuvent cr\00E9er des applications. Chaque espace de travail a le privil\00E8ge d''analyser des sch\00E9mas de base de donn\00E9es.</p>'),
'<p><a target="_blank" href="&SYSTEM_HELP_URL./aeadm/overview-of-oracle-application-express-administration-services.html#GUID-191CB956-10A7-4F8D-A522-018835864928">En savoir plus...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10332829289896519.4052)
,p_plug_name=>'Etats sur l''espace de travail'
,p_region_css_classes=>'h360'
,p_icon_css_classes=>'icon-sc-report-query'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_api.id(966388705490342505.4052)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(10332318553893424.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32847028451566366.4052)
,p_plug_name=>'reset'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>':F4050_P79_SCHEMA_PASSWORD  := null;'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47561719374965004.4052)
,p_plug_name=>'Exporter/Importer'
,p_region_css_classes=>'h240'
,p_icon_css_classes=>'icon-utilities-data-workshop'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_api.id(966388705490342505.4052)
,p_plug_display_sequence=>40
,p_list_id=>wwv_flow_api.id(47558804136960608.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168490221110504940.4052)
,p_plug_name=>unistr('G\00E9rer les applications')
,p_region_css_classes=>'h240'
,p_icon_css_classes=>'icon-util-manage'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_api.id(966388705490342505.4052)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(244253103570784647.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1080988572880523918.4052)
,p_name=>'Statut en cours'
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>80
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--stacked:a-BadgeList--large'
,p_display_point=>'REGION_POSITION_03'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    (   select count(*) c',
'        from wwv_flow_companies',
'        where provisioning_company_id not in (0,10,11) )  workspace_count,',
'    (   select count(*) c',
'        from wwv_flow_fnd_user ) workspace_users,',
'    (   select count(*) c',
'        from wwv_flow_company_schemas cs,',
'             wwv_flow_companies c',
'        where cs.security_group_id = c.provisioning_company_id(+)',
'             and short_name != ''INTERNAL'' ) workspace_schemas,',
'    (   select count(*) c',
'        from wwv_flows',
'        where security_group_id not in (0,10,11) ) applications',
'from dual'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805663950138677747.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'0'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1080988619379523919.4052)
,p_query_column_id=>1
,p_column_alias=>'WORKSPACE_COUNT'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre d''espaces de travail'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP,RIR:::'
,p_column_linktext=>'#WORKSPACE_COUNT#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1080988755941523920.4052)
,p_query_column_id=>2
,p_column_alias=>'WORKSPACE_USERS'
,p_column_display_sequence=>2
,p_column_heading=>'Utilisateurs d''espace de travail'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:RP,RIR:::'
,p_column_linktext=>'#WORKSPACE_USERS#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1080988827320523921.4052)
,p_query_column_id=>3
,p_column_alias=>'WORKSPACE_SCHEMAS'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Sch\00E9mas d''espace de travail')
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:RP,RIR:::'
,p_column_linktext=>'#WORKSPACE_SCHEMAS#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1080988927572523922.4052)
,p_query_column_id=>4
,p_column_alias=>'APPLICATIONS'
,p_column_display_sequence=>4
,p_column_heading=>'Applications'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:RP,RIR:::'
,p_column_linktext=>'#APPLICATIONS#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(30177820127829133.4052)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'10'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00011
begin
wwv_flow_api.create_page(
 p_id=>11.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Attributs d''application'
,p_step_title=>'Attributs d''application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(275228225185505839)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_app.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1154929605958289.4052)
,p_plug_name=>'Applications'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.ID, ',
'       c.short_name as SECURITY_GROUP_ID,',
'       f.SECURITY_GROUP_ID as workspace_id,',
'       f.OWNER,',
'       f.NAME,',
'       f.alias,',
'       f.LAST_UPDATED_BY,',
'       f.LAST_UPDATED_ON,',
'       (select count(*) from wwv_flow_steps where flow_id = f.id) as pages,',
'       f.CHARSET,',
'       f.CREATED_ON as created,',
'       f.FLOW_LANGUAGE,',
'       f.WEBDB_LOGGING as logging,',
'       f.DATE_FORMAT,',
'       f.FLOW_IMAGE_PREFIX as image_prefix,',
'       f.FLOW_VERSION as version,',
'       f.FLOW_STATUS as application_status,',
'       f.FLOW_UNAVAILABLE_TEXT as unavailable_text,',
'       f.RESTRICT_TO_USER_LIST as restrict_to_users,',
'       f.BUILD_STATUS,',
'       f.SECURITY_SCHEME',
'  from WWV_FLOWS f,',
'       WWV_FLOW_COMPANIES c',
' where f.security_group_id = c.provisioning_company_id',
'   and f.security_group_id not in (10, 11, 12)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NOT_DISPLAYING_INLINE_VALIDATION_ERRORS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1155017179958289.4052)
,p_name=>'Applications'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1155308703958298.4052)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1155213723958298.4052)
,p_db_column_name=>'ID'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1155425625958298.4052)
,p_db_column_name=>'OWNER'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Sch\00E9ma d''analyse')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1155519945958298.4052)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Nom d''application'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1155614168958299.4052)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Mis \00E0 jour par')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1155710134958299.4052)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Mis \00E0 jour')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1155820920958299.4052)
,p_db_column_name=>'PAGES'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1155923375958299.4052)
,p_db_column_name=>'CHARSET'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>unistr('Jeu de caract\00E8res')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1156000595958300.4052)
,p_db_column_name=>'FLOW_LANGUAGE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Langue'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1170023688080440.4052)
,p_db_column_name=>'LOGGING'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Journalisation'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(110344620122166929)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1170128212080441.4052)
,p_db_column_name=>'DATE_FORMAT'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Format de date'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1170207128080445.4052)
,p_db_column_name=>'IMAGE_PREFIX'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>unistr('Pr\00E9fixe d''image')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1170516700080446.4052)
,p_db_column_name=>'VERSION'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Version'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1170611697080446.4052)
,p_db_column_name=>'APPLICATION_STATUS'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Statut de l''application'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(85746300886317667)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1171928667091381.4052)
,p_db_column_name=>'UNAVAILABLE_TEXT'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Texte non disponible'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1172004705091382.4052)
,p_db_column_name=>'RESTRICT_TO_USERS'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Restreindre aux utilisateurs'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1172110334091382.4052)
,p_db_column_name=>'BUILD_STATUS'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Statut de construction'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(244320808989852457)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1172220531091382.4052)
,p_db_column_name=>'SECURITY_SCHEME'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>unistr('Mod\00E8le de s\00E9curit\00E9')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1173327198109877.4052)
,p_db_column_name=>'CREATED'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>unistr('Cr\00E9\00E9')
,p_column_type=>'DATE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254152603061181874.4052)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'ID d''espace de travail'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(144298924302584758.4052)
,p_db_column_name=>'ALIAS'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Alias'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(254091311699719427.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1154929605958289.4052)
,p_button_name=>'RESET_REPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser l''\00E9tat')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(244651516120077672.4052)
,p_branch_action=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
end;
/
prompt --application/pages/page_00012
begin
wwv_flow_api.create_page(
 p_id=>12.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('G\00E9rer les d\00E9veloppeurs et les utilisateurs')
,p_step_title=>unistr('G\00E9rer les d\00E9veloppeurs et les utilisateurs')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216787602191653217)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_users.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6318778195.4052)
,p_plug_name=>unistr('D\00E9veloppeurs et utilisateurs')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Les applications internes de &PRODUCT_NAME. (App Builder, SQL Workshop, etc.) authentifient les informations d''identification',
unistr('utilisateur par rapport aux entr\00E9es du r\00E9f\00E9rentiel des comptes &PRODUCT_NAME.. Les applications d\00E9velopp\00E9es par l''utilisateur peuvent \00E9galement'),
unistr('utiliser ce r\00E9f\00E9rentiel pour l''authentification.</p>'),
'',
unistr('<p>Cet \00E9tat pr\00E9sente les entr\00E9es de nom utilisateur de ce r\00E9f\00E9rentiel par espace de travail. Cliquez sur le nom d''un utilisateur dans l''\00E9tat pour modifier'),
unistr('cet utilisateur ou sur <strong>Cr\00E9er</strong> pour cr\00E9er un utilisateur. S\00E9lectionnez le lien <strong>R\00E9initialiser</strong> pour modifier le mot de passe de l''utilisateur.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1301955870026853711.4052)
,p_plug_name=>unistr('G\00E9rer les d\00E9veloppeurs et utilisateurs d''application')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select u.user_id,',
'       u.workspace_id,',
'       u."USER",',
'       u.first_name||'' ''||u.last_name full_name,',
'       u."eMail" as email,',
'       u.df, -- default schema',
'       u.ul, -- is user locked?',
'       u.dev_type account_type,',
'       u.last_update_date,',
'       u.creation_date,',
'       c.short_name workspace,',
'       (select ''<a href="f?p=4050:53:''||:flow_session||',
'               ''::NO:53:F4050_P53_USER_ID:''||wwv_flow_escape.html(u.user_id)||''">''||',
'               wwv_flow_lang.system_message(''F4050.RESET'')||''</a>''',
'          from wwv_flow_workspace_users',
'         where user_id = u.user_id',
'           and "USER" <> ''ADMIN''',
'           and "eMail" is not null',
'           and (wwv_flow_authentication_dev.get_internal_authentication <> ''DB'' or u.dev_type = ''End User'')',
'        ) p',
'  from wwv_flow_workspace_users u,',
'       wwv_flow_companies c',
' where u.workspace_id = c.provisioning_company_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1301955948511853712.4052)
,p_max_row_count=>'1000000'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'JASON'
,p_internal_uid=>1301955948511853712
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1301956426284853717.4052)
,p_db_column_name=>'USER_ID'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'ID utilisateur'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1301956557228853718.4052)
,p_db_column_name=>'USER'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Utilisateur'
,p_column_link=>'f?p=&APP_ID.:23:&SESSION.::&DEBUG.:RP,23:F4050_P23_USER_ID:#USER_ID#'
,p_column_linktext=>'#USER#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1301956930963853722.4052)
,p_db_column_name=>'DF'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>unistr('Sch\00E9ma par d\00E9faut')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(222860275257540030.4052)
,p_db_column_name=>'EMAIL'
,p_display_order=>110
,p_column_identifier=>'AT'
,p_column_label=>unistr('Adresse \00E9lectronique')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1301957424892853727.4052)
,p_db_column_name=>'UL'
,p_display_order=>120
,p_column_identifier=>'O'
,p_column_label=>unistr('Verrouill\00E9')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1301958980212853742.4052)
,p_db_column_name=>'LAST_UPDATE_DATE'
,p_display_order=>130
,p_column_identifier=>'AD'
,p_column_label=>unistr('Mis \00E0 jour')
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1301959124887853744.4052)
,p_db_column_name=>'CREATION_DATE'
,p_display_order=>140
,p_column_identifier=>'AF'
,p_column_label=>unistr('Cr\00E9\00E9')
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1796417210487006101.4052)
,p_db_column_name=>'FULL_NAME'
,p_display_order=>150
,p_column_identifier=>'AM'
,p_column_label=>'Nom complet'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1796417582391006104.4052)
,p_db_column_name=>'ACCOUNT_TYPE'
,p_display_order=>160
,p_column_identifier=>'AP'
,p_column_label=>'Type de compte'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1796417696532006105.4052)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>170
,p_column_identifier=>'AQ'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1796417728321006106.4052)
,p_db_column_name=>'P'
,p_display_order=>180
,p_column_identifier=>'AR'
,p_column_label=>'Mot de passe'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_display_condition_type=>'EXPRESSION'
,p_display_condition=>'wwv_flow_platform.get_preference(p_preference_name  => ''SMTP_HOST_ADDRESS'') is not null'
,p_display_condition2=>'PLSQL'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2024852857686481305.4052)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>190
,p_column_identifier=>'AS'
,p_column_label=>'ID d''espace de travail'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(484702204098038644.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1301955870026853711.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:12,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(43040243631941918.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1301955870026853711.4052)
,p_button_name=>'Create_New'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er un utilisateur')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:23:&SESSION.::&DEBUG.:23,EDIT_USER_PRIVS::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(25567619615581607.4052)
,p_branch_action=>'f?p=&FLOW_ID.:12:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(25564831604575604.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00013
begin
wwv_flow_api.create_page(
 p_id=>13.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Vues de page par syst\00E8me d''exploitation')
,p_step_title=>unistr('Vues de page par syst\00E8me d''exploitation')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_inline_css=>'td[headers=GRAPH] {min-width: 150px;}'
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(2584726337646135.4052)
,p_name=>unistr('Vues de page par syst\00E8me d''exploitation')
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_count as',
'(select /* APEX 4050P13a */ count(*) a ',
'from wwv_flow_activity_log ',
'where security_group_id = :flow_security_group_id and ',
'time_stamp >= sysdate - nvl(:P13_TIME,1)',
') ',
'select os, page_views , 100*page_views/total_count.a pct, round(100*page_views/total_count.a) graph',
'from (',
'select ',
' x.os, ',
' sum(x.c) page_views',
'from',
'(',
'select session_id, max(decode(user_agent,null,'' Null'',',
'       nvl(',
'       decode(instr(user_agent,''Mac OS X''),0,'''',''Mac OS X'')||',
'       decode(instr(user_agent,''Linux''),0,'''',''Linux'')||',
'       decode(instr(user_agent,''Windows NT 5.0''),0,'''',''Windows 2000'')||',
'       decode(instr(user_agent,''Windows NT 6.0''),0,'''',''Windows Vista'')||',
'       decode(instr(user_agent,''Windows NT 7''),0,'''',''Windows 7'')||',
'       decode(instr(user_agent,''Windows NT 8''),0,'''',''Windows 8'')||',
'       decode(instr(user_agent,''Windows NT 9''),0,'''',''Windows 9'')||',
'       decode(instr(user_agent,''Windows NT 10''),0,'''',''Windows 10'')||',
'       decode(instr(user_agent,''Windows NT 11''),0,'''',''Windows 11'')||',
'       decode(instr(user_agent,''Windows NT 5.1''),0,'''',''Windows XP''),',
'       t.other))) os, count(*) c',
'from wwv_flow_activity_log, ',
'    (select wwv_flow_lang.system_message(''other'') other from dual) t',
'where security_group_id = :flow_security_group_id',
'       and time_stamp >= sysdate - nvl(:P13_TIME,1)',
'group by session_id',
') x',
'group by os) d, ',
'total_count',
'where (:P13_SEARCH is null or instr(upper(os),upper(:P13_SEARCH)) > 0)'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Aucune vue de page n''a \00E9t\00E9 trouv\00E9e.')
,p_query_num_rows_item=>'P13_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'Y'
,p_csv_output_link_text=>unistr('T\00E9l\00E9charger en local')
,p_prn_output=>'Y'
,p_prn_format=>'PDF'
,p_prn_output_show_link=>'Y'
,p_prn_output_link_text=>'Impression'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'&PRODUCT_NAME.'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3213125863900959.4052)
,p_query_column_id=>1
,p_column_alias=>'OS'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Syst\00E8me d''exploitation')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'40'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2585103254646189.4052)
,p_query_column_id=>2
,p_column_alias=>'PAGE_VIEWS'
,p_column_display_sequence=>2
,p_column_heading=>'Vues de page'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'30'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3213229658900959.4052)
,p_query_column_id=>3
,p_column_alias=>'PCT'
,p_column_display_sequence=>3
,p_column_heading=>'Pourcentage'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'30'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3213317952900970.4052)
,p_query_column_id=>4
,p_column_alias=>'GRAPH'
,p_column_display_sequence=>4
,p_column_heading=>'Graphique'
,p_column_format=>'PCT_GRAPH:#cccccc:#777777:'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(108275219905850320.4052)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3216622316918896.4052)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(108275219905850320.4052)
,p_button_name=>'P13_GO'
,p_button_static_id=>'P13_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'OK'
,p_button_alignment=>'LEFT'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3215505347913957.4052)
,p_name=>'P13_TIME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(108275219905850320.4052)
,p_item_default=>'1'
,p_prompt=>'Inclure'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Limitez l''\00E9tat \00E0 une tranche de temps sp\00E9cifique. Indiquez la quantit\00E9 de temps \00E0 inclure dans l''\00E9tat et cliquez sur <strong>OK</strong>.<p />'),
unistr('Si vous s\00E9lectionnez 1 jour, seules les derni\00E8res 24 heures s''affichent.  ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(92431227952006274.4052)
,p_name=>'P13_ROWS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(108275219905850320.4052)
,p_item_default=>'100'
,p_prompt=>'Lignes'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAX_ROWS_G'
,p_lov=>'.'||wwv_flow_api.id(87738929453259457.4052)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez le nombre de lignes \00E0 afficher et cliquez sur <strong>OK</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(92433515962012317.4052)
,p_name=>'P13_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(108275219905850320.4052)
,p_prompt=>'Rechercher'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez des crit\00E8res de requ\00EAte sans distinction entre les majuscules et les minuscules et cliquez sur <strong>OK</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
end;
/
prompt --application/pages/page_00014
begin
wwv_flow_api.create_page(
 p_id=>14.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('D\00E9tails de l''espace de travail')
,p_step_title=>unistr('D\00E9tails de l''espace de travail')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_wrkspc_details.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2882705150907846.4052)
,p_plug_name=>'Workspace Details'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-Form--labelsAbove:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_query_row_template=>wwv_flow_api.id(81008210556197147.4052)
,p_plug_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'blue_arrow_down.gif::blue_arrow_up.gif:|2,3,4\1|',
'',
'&nbsp;:',
'',
'<font color="black" class="nounderline">Schema</font>:',
'',
'<font color="black" class="nounderline">Company</font>:',
'',
'<font color="black" class="nounderline">CompanyID</font>'))
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177744611327233052.4052)
,p_plug_name=>unistr('D\00E9tails de l''espace de travail')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Cette page affiche les attributs cl\00E9 de l''espace de travail s\00E9lectionn\00E9.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(180211706270323234.4052)
,p_plug_name=>unistr('Etat r\00E9capitulatif de l''espace de travail')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_workspace_reports.report_workspace_usage (',
'    p_security_group_id => :SGID,',
'    p_max_apps => 5,',
'    p_max_db_objects=> 5,',
'    p_max_websheets=> 5,',
'    p_time_frame_DWMY => nvl(:P14_REPORTING_PERIOD,''W''),',
'    p_date_format => :DATE_TIME_FORMAT );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'SGID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(180427220917510105.4052)
,p_plug_name=>'Hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517376500704206647.4052)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19471711351438457.4052)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(2882705150907846.4052)
,p_button_name=>'P14_GO'
,p_button_static_id=>'P14_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('D\00E9finir')
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(180478505463215176.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2882705150907846.4052)
,p_button_name=>'REMOVE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Enlever'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:81:P81_COMPANY:&P14_WORKSPACE_NAME.'
,p_button_condition=>'SGID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(360939525109430983.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2882705150907846.4052)
,p_button_name=>'EDIT_WS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Modifier'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:78:&SESSION.::&DEBUG.::P78_PROVISIONING_COMPANY_ID:&SGID.'
,p_button_condition=>'SGID'
,p_button_condition2=>'10'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(360949518239533093.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(2882705150907846.4052)
,p_button_name=>'MAN_WS_SCHEMAS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('Affectations de sch\00E9ma')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:21,RIR:IR_SECURITY_GROUP_ID:&SGID.'
,p_button_condition=>'SGID'
,p_button_condition2=>'10'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(361023100417991549.4052)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(2882705150907846.4052)
,p_button_name=>'MAN_USERS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('G\00E9rer les utilisateurs')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:12,RIR:IR_WORKSPACE_ID:&SGID.'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(184089511347405635.4052)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(2882705150907846.4052)
,p_button_name=>'EMAIL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Courriel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:76:&SESSION.::&DEBUG.::P76_REPORTING_PERIOD,P76_WORKSPACE_ID:&P14_REPORTING_PERIOD.,&SGID.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(317937565640.4052)
,p_branch_action=>'14'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(297977429861.4052)
,p_name=>'SGID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2882705150907846.4052)
,p_prompt=>'Espace de travail'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name, PROVISIONING_COMPANY_ID',
'from   WWV_FLOW_COMPANIES',
'where provisioning_company_id not in (0, 11)',
'order  by short_name'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('S\00E9lectionnez un espace de travail et cliquez sur <strong>OK</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180427011913507481.4052)
,p_name=>'P14_WORKSPACE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2882705150907846.4052)
,p_prompt=>'Workspace Name'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180730012565372136.4052)
,p_name=>'P14_REPORTING_PERIOD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2882705150907846.4052)
,p_item_default=>'W'
,p_prompt=>unistr('P\00E9riode de g\00E9n\00E9ration d''\00E9tat')
,p_source=>'W'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORTING PERIOD'
,p_lov=>'.'||wwv_flow_api.id(180726228364333770.4052)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(180427400962513786.4052)
,p_computation_sequence=>10
,p_computation_item=>'P14_WORKSPACE_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select short_name from wwv_flow_companies where provisioning_company_id = :SGID'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(180400628882162317.4052)
,p_computation_sequence=>20
,p_computation_item=>'SGID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_name varchar2(255);',
'   l_next_sgid number;',
'begin',
'   select short_name into l_name ',
'   from wwv_flow_companies ',
'   where provisioning_company_id = :SGID;',
'   for c1 in (select provisioning_company_id',
'              from wwv_flow_companies ',
'              where short_name > l_name',
'              order by short_name) loop',
'       l_next_sgid := c1.provisioning_company_id;',
'       exit;',
'   end loop;',
'   return nvl(l_next_sgid,:SGID);',
'end;'))
,p_compute_when=>'NEXT'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(180401916892168333.4052)
,p_computation_sequence=>30
,p_computation_item=>'SGID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_name varchar2(255);',
'   l_next_sgid number;',
'begin',
'   select short_name into l_name ',
'   from wwv_flow_companies ',
'   where provisioning_company_id = :SGID;',
'   for c1 in (select provisioning_company_id',
'              from wwv_flow_companies ',
'              where short_name < l_name',
'              order by short_name desc) loop',
'       l_next_sgid := c1.provisioning_company_id;',
'       exit;',
'   end loop;',
'   return nvl(l_next_sgid,:SGID);',
'end;'))
,p_compute_when=>'PREVIOUS'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(19034431362034300.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_api.id(19471711351438457.4052)
);
end;
/
prompt --application/pages/page_00015
begin
wwv_flow_api.create_page(
 p_id=>15.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Vues de page par navigateur'
,p_step_title=>'Vues de page par navigateur'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_inline_css=>'td[headers=GRAPH] {min-width: 150px;}'
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(2597607668687988.4052)
,p_name=>'Vues de page par navigateur'
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_count as',
'(',
'select /* APEX 4050P15a */ count(*) a ',
'from   wwv_flow_activity_log ',
'where  security_group_id = :flow_security_group_id and ',
'       time_stamp >= sysdate - nvl(:P15_TIME,1) and',
'       user_agent is not null',
') ',
'select os, page_views , 100*page_views/total_count.a pct, round(100*page_views/total_count.a) graph',
'from (',
'select ',
' x.os, ',
' sum(x.c) page_views',
'from',
'(',
'select session_id, ',
'       case ',
'       when user_agent is null then ''No User Agent''',
'       when instr(user_agent,''Chrome/'') > 0 then ''Chrome''',
'       when instr(user_agent,''Edge/'') > 0 then ''Edge''',
'       when instr(user_agent,''Safari/'') > 0 then ''Safari''',
'       when instr(user_agent,''Opera/'') > 0 then ''Opera''',
'       when instr(user_agent,''Firefox/'') > 0 then ''Firefox''',
'       when instr(user_agent,''AppleWebKit/'') > 0 then ''AppleWebKit''',
'       when instr(user_agent,''Mozilla/'') > 0 then ''Mozilla''',
'       when instr(user_agent,''Trident/'') > 0 then ''Trident''',
'       else ''Unkonwn'' end os,',
'       count(*) c',
'from wwv_flow_activity_log',
'where security_group_id = :flow_security_group_id',
'       and time_stamp >= sysdate - nvl(:P15_TIME,1)',
'       and user_agent is not null',
'group by session_id,',
'case ',
'       when user_agent is null then ''No User Agent''',
'       when instr(user_agent,''Chrome/'') > 0 then ''Chrome''',
'       when instr(user_agent,''Edge/'') > 0 then ''Edge''',
'       when instr(user_agent,''Safari/'') > 0 then ''Safari''',
'       when instr(user_agent,''Opera/'') > 0 then ''Opera''',
'       when instr(user_agent,''Firefox/'') > 0 then ''Firefox''',
'       when instr(user_agent,''AppleWebKit/'') > 0 then ''AppleWebKit''',
'       when instr(user_agent,''Mozilla/'') > 0 then ''Mozilla''',
'       when instr(user_agent,''Trident/'') > 0 then ''Trident''',
'       else ''Unkonwn'' end',
') x',
'group by os) d, total_count'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>unistr('Aucune vue de page n''a \00E9t\00E9 trouv\00E9e.')
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>unistr('T\00E9l\00E9charger en local')
,p_prn_output=>'Y'
,p_prn_format=>'PDF'
,p_prn_output_show_link=>'Y'
,p_prn_output_link_text=>'Impression'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'&PRODUCT_NAME.'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2597921064687990.4052)
,p_query_column_id=>1
,p_column_alias=>'OS'
,p_column_display_sequence=>1
,p_column_heading=>'Navigateur'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'50'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2598028849688000.4052)
,p_query_column_id=>2
,p_column_alias=>'PAGE_VIEWS'
,p_column_display_sequence=>2
,p_column_heading=>'Vues de page'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'25'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3207811487858971.4052)
,p_query_column_id=>3
,p_column_alias=>'PCT'
,p_column_display_sequence=>3
,p_column_heading=>'Pourcentage'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'25'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3207921931858972.4052)
,p_query_column_id=>4
,p_column_alias=>'GRAPH'
,p_column_display_sequence=>4
,p_column_heading=>'Graphique'
,p_column_format=>'PCT_GRAPH:#cccccc:#777777:'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(108279024884861232.4052)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3210024085872083.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(108279024884861232.4052)
,p_button_name=>'P15_GO'
,p_button_static_id=>'P15_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('D\00E9finir')
,p_button_alignment=>'LEFT'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200369623299026784.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(108279024884861232.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:15:&SESSION.::&DEBUG.:15,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3208727763863613.4052)
,p_name=>'P15_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(108279024884861232.4052)
,p_item_default=>'1'
,p_prompt=>'Inclure'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Limitez l''\00E9tat \00E0 une tranche de temps sp\00E9cifique. Indiquez la quantit\00E9 de temps \00E0 inclure dans l''\00E9tat et cliquez sur <strong>OK</strong>.<p />'),
unistr('Si vous s\00E9lectionnez 1 jour, seules les derni\00E8res 24 heures s''affichent.  ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00016
begin
wwv_flow_api.create_page(
 p_id=>16.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Configuration des fonctionnalit\00E9s')
,p_step_title=>unistr('Configuration des fonctionnalit\00E9s')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216766702444596508)
,p_step_template=>wwv_flow_api.id(704456563630760825.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_config_feature.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1220877187620120.4052)
,p_plug_name=>unistr('D\00E9veloppement d''\00E9quipe')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(169304800930079016.4052)
,p_plug_name=>unistr('D\00E9veloppement d''applications')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(169306214436082917.4052)
,p_plug_name=>'SQL Workshop'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(169312431105116196.4052)
,p_plug_name=>'Surveillance'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(169386325798256586.4052)
,p_plug_name=>unistr('Configuration des fonctionnalit\00E9s')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(521637608266366438.4052)
,p_plug_name=>'REST'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(617449525355766463.4052)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>G\00E9rez les param\00E8tres applicables \00E0 l''int\00E9gralit\00E9 de l''instance &PRODUCT_NAME..</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(907405108418643658.4052)
,p_plug_name=>'Anchor'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(195775112470763477.4052)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(908012317600684138.4052)
,p_plug_name=>'Administration d''espace de travail'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(12936728094071536.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(169386325798256586.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(169388709307261209.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(169386325798256586.4052)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(168521612246937591.4052)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1220904441620121.4052)
,p_name=>'P16_ISSUE_FILES_YN'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1220877187620120.4052)
,p_item_default=>'Y'
,p_prompt=>unistr('Activer le r\00E9f\00E9rentiel de fichiers de probl\00E8me')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez <strong>Oui</strong> pour tous les espaces de travail cr\00E9\00E9s dans cette instance afin d''autoriser le t\00E9l\00E9chargement de fichiers dans le r\00E9f\00E9rentiel de fichiers central du d\00E9veloppement d''\00E9quipe. S\00E9lectionnez <strong>Non</strong> pour tous')
||unistr(' les espaces de travail cr\00E9\00E9s dans cette instance afin de ne pas autoriser le t\00E9l\00E9chargement de fichiers dans le r\00E9f\00E9rentiel de fichiers central du d\00E9veloppement d''\00E9quipe.'),
'<br>',
'<br>',
unistr('Ce param\00E8tre n''a aucun effet sur les espaces de travail existants.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1221084382620122.4052)
,p_name=>'P16_ISSUE_FS_LIMIT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1220877187620120.4052)
,p_item_default=>'15728640'
,p_prompt=>unistr('Taille maximale de fichier de probl\00E8me (en Mo)')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TEAM_DEV_FS_LIMIT'
,p_lov=>'.'||wwv_flow_api.id(689538645438591983.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez la taille maximale pour les fichiers t\00E9l\00E9charg\00E9s dans le r\00E9f\00E9rentiel de fichiers central du d\00E9veloppement d''\00E9quipe. La valeur par d\00E9faut est 15 Mo.</p>'),
'',
unistr('<p>Ce param\00E8tre n''a aucun effet sur les espaces de travail existants.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13154621528187520.4052)
,p_name=>'P16_BACKUP_LIMIT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(169304800930079016.4052)
,p_prompt=>'Nombre de sauvegardes par application'
,p_source=>'return wwv_flow_backup.backup_limit();'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>D\00E9termine le nombre maximal de sauvegardes \00E0 conserver par application. Les sauvegardes les plus anciennes seront supprim\00E9es au cours de la maintenance quotidienne.</p>'),
unistr('<p>Une valeur NULL ou z\00E9ro (0) d\00E9sactive la fonctionnalit\00E9 de sauvegarde automatique. Au maximum, 30 sauvegardes seront conserv\00E9es par application.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_02=>'30'
,p_attribute_03=>'left'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15317323587906632.4052)
,p_name=>'P16_APP_ACTIVITY_LOGGING'
,p_is_required=>true
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(169312431105116196.4052)
,p_item_default=>'U'
,p_prompt=>unistr('Journalisation de l''activit\00E9 d''application')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION ACTIVITY LOGGING'
,p_lov=>'.'||wwv_flow_api.id(15203330831314824.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez la fa\00E7on dont l''activit\00E9 d''application est journalis\00E9e pour toutes les applications de l''instance.'),
'<p>Options disponibles :',
'<ul>',
unistr('<li><strong>Utiliser les param\00E8tres d''application (par d\00E9faut) :</strong> permet d''utiliser l''attribut de journalisation de chaque application pour d\00E9terminer si l''activit\00E9 est journalis\00E9e.</li>'),
unistr('<li><strong>Jamais :</strong> permet de d\00E9sactiver la journalisation de l''activit\00E9 de toutes les applications de l''instance.</li>'),
unistr('<li><strong>Toujours :</strong> permet d''activer la journalisation de l''activit\00E9 de toutes les applications de l''instance.</li>'),
unistr('<li><strong>Initialement d\00E9sactiv\00E9 pour les nouvelles applications :</strong> pour les nouvelles applications, la journalisation de l''activit\00E9 est initialement d\00E9sactiv\00E9e.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169297610580053441.4052)
,p_name=>'P16_ALLOW_DB_MONITOR'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(169312431105116196.4052)
,p_item_default=>'Y'
,p_prompt=>unistr('Activer la surveillance de base de donn\00E9es')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Activez ou d\00E9sactivez la surveillance dans SQL Workshop.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169297816049053446.4052)
,p_name=>'P16_PLSQL_EDITING'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(169304800930079016.4052)
,p_item_default=>'Y'
,p_prompt=>unistr('Autoriser la modification d''unit\00E9s de programme PL/SQL')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Par d\00E9faut, les d\00E9veloppeurs peuvent modifier et compiler du code source PL/SQL lorsqu''ils parcourent des proc\00E9dures de base de donn\00E9es, des packages et des fonctions dans le navigateur d''objet. Pour d\00E9sactiver la modification et la compilation d''uni')
||unistr('t\00E9s de programme PL/SQL dans le navigateur d''objet, s\00E9lectionnez <strong>Non</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169298013657053447.4052)
,p_name=>'P16_WORKSPACE_P_DEMO_OBJECT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(169304800930079016.4052)
,p_item_default=>'Y'
,p_prompt=>unistr('Cr\00E9er des objets de d\00E9monstration dans de nouveaux espaces de travail')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Contr\00F4le la cr\00E9ation d''objets de base de donn\00E9es de d\00E9monstration lors de la cr\00E9ation d''espaces de travail. Pour d\00E9sactiver la cr\00E9ation d''objets de base de donn\00E9es de d\00E9monstration, s\00E9lectionnez <strong>Non</strong>.  '),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169299221292053451.4052)
,p_name=>'P16_SQL_C_MAX_INACTIVITY'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(169306214436082917.4052)
,p_item_default=>'60'
,p_prompt=>unistr('Inactivit\00E9 maximum des commandes SQL en minutes')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifiez la dur\00E9e maximum pendant laquelle attendra une commande SQL transactionnelle dans le processeur de commandes SQL avant expiration.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169299418817053452.4052)
,p_name=>'P16_SQL_SCRIPT_MAX_OUTPUT_SIZE'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(169306214436082917.4052)
,p_prompt=>'Taille maximale de sortie des scripts SQL en octets'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifiez la quantit\00E9 maximum de sorties que peut g\00E9n\00E9rer un script SQL. Les scripts SQL sont ex\00E9cut\00E9s \00E0 partir de SQL Workshop.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169299604071053452.4052)
,p_name=>'P16_WORKSPACE_MAX_OUTPUT_SIZE'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(169306214436082917.4052)
,p_prompt=>'Taille maximale de sortie d''espace de travail des scripts SQL en octets'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifiez la quantit\00E9 maximum d''espace que peut consommer l''ensemble des scripts dans un espace de travail. Les r\00E9sultats des scripts SQL sont les sorties qu''ils g\00E9n\00E8rent lorsqu''ils sont ex\00E9cut\00E9s \00E0 partir du processeur de commandes SQL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169299802122053454.4052)
,p_name=>'P16_MAX_SCRIPT_SIZE'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(169306214436082917.4052)
,p_prompt=>'Taille maximale des scripts SQL en octets'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifiez la taille maximum d''un script SQL utilis\00E9 dans SQL Workshop.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(175483619946469918.4052)
,p_name=>'P16_ENABLE_TRANSACTIONAL_SQL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(169306214436082917.4052)
,p_item_default=>'N'
,p_prompt=>'Activer les commandes SQL transactionnelles'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Activez les commandes SQL transactionnelles pour toute l''instance. Lorsque cette fonctionnalit\00E9 est activ\00E9e, les utilisateurs des commandes SQL peuvent \00E9mettre plusieurs commandes SQL dans la m\00EAme transaction de base de donn\00E9es physique.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(218527933367706511.4052)
,p_name=>'P16_DATA_LOADING_JOB_CLASS'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(169306214436082917.4052)
,p_prompt=>unistr('Classe de travail de chargement des donn\00E9es')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Identifiez la classe de travail DBMS_SCHEDULER dans laquelle les travaux de chargement des donn\00E9es SQL Workshop seront ex\00E9cut\00E9s. Ceci permet d''attribuer des travaux de chargement des donn\00E9es \00E0 un groupe de consommateurs Resource Manager sp\00E9cifiqu')
||unistr('e. Si elle n''est pas d\00E9finie, la classe de travail <strong>SYS.DEFAULT_JOB_CLASS</strong> sera utilis\00E9e. Pour plus d''informations sur les classes de travail, consultez le guide de l''administrateur Oracle Database.'),
'</p>',
'<p>',
unistr('    Exemple. Ex\00E9cuter avec des privil\00E8ges DBA :'),
'</p>',
'<pre>',
unistr('-- 1. cr\00E9er la classe de travail'),
'--   ',
'begin ',
'    dbms_scheduler.create_job_class(',
'         job_class_name          => ''MY_LOADER_CLASS'', ',
'         resource_consumer_group => ''RES_MGR_LOW_PRIO_GROUP'', -- this assumes, that a RES_MGR_LOW_PRIO_GROUP consumer group exists',
'         comments                => ''This is a job class for SQL Workshop Data Loading jobs'' );',
'end;',
'/',
'',
unistr('-- 2. accorder un privil\00E8ge EXECUTE sur la classe de travail \00E0 l''utilisateur du moteur APEX'),
'--',
unistr('accorder un privil\00E8ge d''ex\00E9cution sur MY_LOADER_CLASS \00E0 apex_NNNNNN'),
'/',
'',
'-- 3. configurer la classe de travail ici ou utiliser APEX_INSTANCE_ADMIN.SET_PARAMETER',
'--',
'begin ',
'    apex_instance_admin.set_parameter( ',
'        p_parameter => ''DATA_LOADING_JOB_CLASS'', ',
'        p_value     => ''MY_LOADER_CLASS'' ); ',
'end;',
'/',
'</pre>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(335464077854351503.4052)
,p_name=>'P16_DATA_LOADING_MAX_FILE_SIZE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(169306214436082917.4052)
,p_prompt=>unistr('Taille maximale de fichier pour le chargement des donn\00E9es en octets')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Indiquez la taille de fichier maximale globale pour le chargement des donn\00E9es SQL Workshop. Des limites plus petites existent pour les fichiers XML et XSLX ainsi que pour les fichiers JSON sur les bases de donn\00E9es version 11.2 et 12.1. Ce param\00E8tre c')
||'onfigure la limite de la taille de fichier globale pour tous les types de fichier.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(337361432473658487.4052)
,p_name=>'P16_ALLOW_TRACING'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(169312431105116196.4052)
,p_item_default=>'Y'
,p_prompt=>'Activer la fonction de trace d''application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Activez ou d\00E9sactivez la fonction de trace des applications &PRODUCT_NAME.. Lorsque cette fonction est activ\00E9e, les d\00E9veloppeurs peuvent g\00E9n\00E9rer un fichier trace de base de donn\00E9es pour l''ex\00E9cution de l''ensemble d''un \00E9v\00E9nement de page.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(483424604396106602.4052)
,p_name=>'P16_WEBSHEET_OBJECT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(169304800930079016.4052)
,p_item_default=>'Y'
,p_prompt=>unistr('Cr\00E9er des objets de feuille Web dans de nouveaux espaces de travail')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_security_scheme=>wwv_flow_api.id(610289739776900562)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Contr\00F4le la cr\00E9ation d''objets de feuille Web lors de la cr\00E9ation d''espaces de travail. Pour d\00E9sactiver la cr\00E9ation d''objets de fiche de travail, s\00E9lectionnez <strong>Non</strong>.  '),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(492054609484746145.4052)
,p_name=>'P16_WEBSHEET_SQL_ACCESS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(169304800930079016.4052)
,p_item_default=>'Y'
,p_prompt=>unistr('Autoriser l''acc\00E8s SQL dans les feuilles Web')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_security_scheme=>wwv_flow_api.id(610289739776900562)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Contr\00F4le la capacit\00E9 d''utiliser la balise SQL et de cr\00E9er des \00E9tats SQL dans des feuilles Web &PRODUCT_NAME.. Si cette option est d\00E9sactiv\00E9e, aucune application Web dans tous les espaces de travail de l''instance ne pourra utiliser la balise SQL ou cr')
||unistr('\00E9er des \00E9tats SQL.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(521637788671366439.4052)
,p_name=>'P16_SWAGGER_UI_URL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(521637608266366438.4052)
,p_prompt=>'URL Swagger UI'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>D\00E9finit une URL pointant vers le serveur SWAGGER UI 2.0+ que doit utiliser ORDS REST Workshop lors de la g\00E9n\00E9ration de la documentation relative \00E0 un module. Si une URL est indiqu\00E9e, l''URI de la documentation SWAGGER du service Web est transmis au')
||' serveur SWAGGER UI. En l''absence d''URL, un JSON brut est produit.</p>',
'',
unistr('<p>Le serveur SWAGGER UI doit pouvoir atteindre l''URI de service Web r\00E9f\00E9renc\00E9 pour g\00E9n\00E9rer la documentation. Lors de l''utilisation d''un service SWAGGER UI tiers, consultez sa charte de confidentialit\00E9 pour conna\00EEtre les modalit\00E9s d''utilisation et de')
||unistr(' partage des informations collect\00E9es par ce service.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(582421357301226501.4052)
,p_name=>'P16_WEBSERVICE_LOGGING'
,p_is_required=>true
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(169312431105116196.4052)
,p_item_default=>'U'
,p_prompt=>unistr('Journalisation des activit\00E9s de service Web')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEBSERVICE LOGGING'
,p_lov=>'.'||wwv_flow_api.id(582428114482274404.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez la fa\00E7on dont l''activit\00E9 de service Web est journalis\00E9e pour tous les espaces de travail de l''instance.'),
'<p>Options disponibles :',
'<ul>',
unistr('<li><strong>Utiliser les param\00E8tres d''espace de travail (par d\00E9faut) :</strong> permet d''utiliser l''attribut de journalisation de service Web de chaque espace de travail pour d\00E9terminer si l''activit\00E9 est journalis\00E9e.</li>'),
unistr('<li><strong>Jamais :</strong> permet de d\00E9sactiver la journalisation de service Web de tous les espaces de travail de l''instance.</li>'),
'<li><strong>Toujours :</strong> permet d''activer la journalisation de service Web de tous les espaces de travail de l''instance.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(689844200493496911.4052)
,p_name=>'P16_TEAM_DEV_FILES_YN'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1220877187620120.4052)
,p_item_default=>'Y'
,p_prompt=>unistr('Activer le r\00E9f\00E9rentiel de fichiers d''informations en retour')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez <strong>Oui</strong> pour tous les espaces de travail cr\00E9\00E9s dans cette instance afin d''autoriser le t\00E9l\00E9chargement de fichier dans le r\00E9f\00E9rentiel de fichiers d''informations en retour. S\00E9lectionnez <strong>Non</strong> pour tous les espac')
||unistr('es de travail cr\00E9\00E9s dans cette instance afin de ne pas autoriser le t\00E9l\00E9chargement de fichier dans le r\00E9f\00E9rentiel de fichiers d''informations en retour.'),
'<br>',
'<br>',
unistr('Ce param\00E8tre n''a aucun effet sur les espaces de travail existants.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(689845678483533445.4052)
,p_name=>'P16_TEAM_DEV_FS_LIMIT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1220877187620120.4052)
,p_item_default=>'15728640'
,p_prompt=>'Taille maximale de fichier d''informations en retour (en Mo)'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TEAM_DEV_FS_LIMIT'
,p_lov=>'.'||wwv_flow_api.id(689538645438591983.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez la taille maximale pour les fichiers t\00E9l\00E9charg\00E9s dans le r\00E9f\00E9rentiel de fichiers d''informations en retour. La valeur par d\00E9faut est 15 Mo.</p>'),
'',
unistr('<p>Ce param\00E8tre n''a aucun effet sur les espaces de travail existants.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(801931419084659361.4052)
,p_name=>'P16_RESTFUL_SERVICES'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(521637608266366438.4052)
,p_item_default=>'Y'
,p_prompt=>'Activer les services RESTful'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Contr\00F4le la cr\00E9ation des services RESTful mapp\00E9s \00E0 SQL et PL/SQL et l''acc\00E8s \00E0 ceux-ci. Les services RESTful peuvent \00E9galement \00EAtre activ\00E9s ou d\00E9sactiv\00E9s pour les espaces de travail individuels.</p>'),
'',
unistr('<p>La fonctionnalit\00E9s des services RESTful est disponible uniquement lors de l''utilisation d''Oracle REST Data Services version 2.0 ou sup\00E9rieure en tant que processus d''\00E9coute Web.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(908176812321701564.4052)
,p_name=>'P16_SERVICE_REQUESTS'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(908012317600684138.4052)
,p_item_default=>'Y'
,p_prompt=>'Activer les demandes de service'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Contr\00F4le la capacit\00E9 des administrateurs d''espace de travail \00E0 effectuer des demandes de service \00E0 partir de l''administration d''espace de travail, ce qui permet de demander un nouveau sch\00E9ma, de l''espace de stockage ou l''interruption de leur espace d')
||'e travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
begin
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(637919682872057.4052)
,p_computation_sequence=>10
,p_computation_item=>'F4050_P15_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_comment=>'Set the value of the item conainting the primary key to null when asked to create a new row.'
,p_compute_when=>'CREATE_ROW'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(171947423698040938.4052)
,p_validation_name=>'P16_SQL_C_MAX_INACTIVITY must be positive integer'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P16_SQL_C_MAX_INACTIVITY );',
'    if l_number = abs(trunc(l_number)) then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La valeur doit \00EAtre un entier positif.')
,p_when_button_pressed=>wwv_flow_api.id(169388709307261209.4052)
,p_associated_item=>wwv_flow_api.id(169299221292053451.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(172007922499154166.4052)
,p_validation_name=>'P16_SQL_SCRIPT_MAX_OUTPUT_SIZE positive integer'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P16_SQL_SCRIPT_MAX_OUTPUT_SIZE );',
'    if l_number = abs(trunc(l_number)) then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La valeur doit \00EAtre un entier positif.')
,p_when_button_pressed=>wwv_flow_api.id(169388709307261209.4052)
,p_associated_item=>wwv_flow_api.id(169299418817053452.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(172010617436162145.4052)
,p_validation_name=>'P16_WORKSPACE_MAX_OUTPUT_SIZE positive integer'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P16_WORKSPACE_MAX_OUTPUT_SIZE );',
'    if l_number = abs(trunc(l_number)) then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La valeur doit \00EAtre un entier positif.')
,p_when_button_pressed=>wwv_flow_api.id(169388709307261209.4052)
,p_associated_item=>wwv_flow_api.id(169299604071053452.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(172014314796170894.4052)
,p_validation_name=>'P16_MAX_SCRIPT_SIZE positive integer'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P16_MAX_SCRIPT_SIZE );',
'    if l_number = abs(trunc(l_number)) then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La valeur doit \00EAtre un entier positif.')
,p_when_button_pressed=>wwv_flow_api.id(169388709307261209.4052)
,p_associated_item=>wwv_flow_api.id(169299802122053454.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(689846059611545544.4052)
,p_name=>'Show/Hide Team Dev File Size Limit'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P16_TEAM_DEV_FILES_YN'
,p_condition_element=>'P16_TEAM_DEV_FILES_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'N'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(689846384315545545.4052)
,p_event_id=>wwv_flow_api.id(689846059611545544.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P16_TEAM_DEV_FS_LIMIT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(689846540959545546.4052)
,p_event_id=>wwv_flow_api.id(689846059611545544.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P16_TEAM_DEV_FS_LIMIT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1221105941620123.4052)
,p_name=>'Show/Hide Issue File Size'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P16_ISSUE_FILES_YN'
,p_condition_element=>'P16_ISSUE_FILES_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1221256529620124.4052)
,p_event_id=>wwv_flow_api.id(1221105941620123.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P16_ISSUE_FS_LIMIT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1221395384620125.4052)
,p_event_id=>wwv_flow_api.id(1221105941620123.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P16_ISSUE_FS_LIMIT'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(169602917870557035.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch values from platform prefs table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P16_PLSQL_EDITING := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''PLSQL_EDITING'' );',
'',
':P16_WORKSPACE_P_DEMO_OBJECT := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''WORKSPACE_PROVISION_DEMO_OBJECTS'' );',
'',
':P16_WEBSHEET_OBJECT := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''WORKSPACE_WEBSHEET_OBJECTS'' );',
'',
':P16_SQL_C_MAX_INACTIVITY := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''SQL_COMMAND_MAX_INACTIVITY'' );',
'',
':P16_SQL_SCRIPT_MAX_OUTPUT_SIZE := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''SQL_SCRIPT_MAX_OUTPUT_SIZE'' );',
'',
':P16_WORKSPACE_MAX_OUTPUT_SIZE := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''WORKSPACE_MAX_OUTPUT_SIZE'' );',
'',
':P16_MAX_SCRIPT_SIZE := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''MAX_SCRIPT_SIZE'' );',
'',
':P16_ALLOW_DB_MONITOR := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''ALLOW_DB_MONITOR'' );',
'',
':P16_ENABLE_TRANSACTIONAL_SQL := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''ENABLE_TRANSACTIONAL_SQL'' );',
'',
':P16_WEBSHEET_SQL_ACCESS := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''WEBSHEET_SQL_ACCESS'' );',
'',
':P16_APP_ACTIVITY_LOGGING := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''APPLICATION_ACTIVITY_LOGGING'' );',
'    ',
':P16_WEBSERVICE_LOGGING := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''WEBSERVICE_LOGGING'' );',
'',
':P16_RESTFUL_SERVICES :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''RESTFUL_SERVICES_ENABLED'' );',
'',
':P16_SWAGGER_UI_URL :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''SWAGGER_UI_URL'' );',
'    ',
':P16_SERVICE_REQUESTS :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''SERVICE_REQUESTS_ENABLED'' );',
'',
':P16_ALLOW_TRACING :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''TRACING_ENABLED'' );',
'',
':P16_TEAM_DEV_FILES_YN :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''WORKSPACE_TEAM_DEV_FILES_YN'' );',
'',
':P16_TEAM_DEV_FS_LIMIT :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''WORKSPACE_TEAM_DEV_FS_LIMIT'' );',
'    ',
'    ',
':P16_DATA_LOADING_JOB_CLASS :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''DATA_LOADING_JOB_CLASS'' );',
'',
':P16_DATA_LOADING_MAX_FILE_SIZE :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''DATA_LOADING_MAX_FILE_SIZE'' );',
'    ',
':P16_ISSUE_FILES_YN :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''WORKSPACE_ISSUE_FILES_YN'' );',
'',
':P16_ISSUE_FS_LIMIT :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''WORKSPACE_ISSUE_FS_LIMIT'' );',
'',
'',
''))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1222261495620134.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Remove Spaces from File Types'
,p_process_sql_clob=>':P16_ISSUE_ALLOWED_FILE_TYPES := trim(BOTH '':'' FROM replace(:P16_ISSUE_ALLOWED_FILE_TYPES,'' '',''''));'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(169524720875349790.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Apply Changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- See if the preference value for activity logging has changed, and if so, then update the logging attribute of all non-internal applications in the instance',
'--',
'if nvl(wwv_flow_platform.get_preference( p_preference_name => ''APPLICATION_ACTIVITY_LOGGING'' ),''X'') <> nvl(:P16_APP_ACTIVITY_LOGGING,''Y'') then',
'    update wwv_flows',
'       set webdb_logging = decode(:P16_APP_ACTIVITY_LOGGING,''A'',''YES'',''N'',''NO'',webdb_logging)',
'     where security_group_id not in (10,11);',
'end if;',
'',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''PLSQL_EDITING'',',
'                                  p_preference_value => :P16_PLSQL_EDITING );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''WORKSPACE_PROVISION_DEMO_OBJECTS'',',
'                                  p_preference_value => :P16_WORKSPACE_P_DEMO_OBJECT );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''WORKSPACE_WEBSHEET_OBJECTS'',',
'                                  p_preference_value => :P16_WEBSHEET_OBJECT );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''SQL_COMMAND_MAX_INACTIVITY'',',
'                                  p_preference_value => :P16_SQL_C_MAX_INACTIVITY );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''SQL_SCRIPT_MAX_OUTPUT_SIZE'',',
'                                  p_preference_value => :P16_SQL_SCRIPT_MAX_OUTPUT_SIZE );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''WORKSPACE_MAX_OUTPUT_SIZE'',',
'                                  p_preference_value => :P16_WORKSPACE_MAX_OUTPUT_SIZE );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''MAX_SCRIPT_SIZE'',',
'                                  p_preference_value => :P16_MAX_SCRIPT_SIZE );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''ALLOW_DB_MONITOR'',',
'                                  p_preference_value => :P16_ALLOW_DB_MONITOR );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''ENABLE_TRANSACTIONAL_SQL'',',
'                                  p_preference_value => :P16_ENABLE_TRANSACTIONAL_SQL );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''WEBSHEET_SQL_ACCESS'',',
'                                  p_preference_value => :P16_WEBSHEET_SQL_ACCESS );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''APPLICATION_ACTIVITY_LOGGING'',',
'                                  p_preference_value => :P16_APP_ACTIVITY_LOGGING );',
'if :P16_WEBSERVICE_LOGGING is not null then                                  ',
'wwv_flow_platform.set_preference( p_preference_name => ''WEBSERVICE_LOGGING'',',
'                                  p_preference_value => :P16_WEBSERVICE_LOGGING );',
'end if;',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''RESTFUL_SERVICES_ENABLED'',',
'                                  p_preference_value => :P16_RESTFUL_SERVICES );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''SWAGGER_UI_URL'',',
'                                  p_preference_value => :P16_SWAGGER_UI_URL );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''SERVICE_REQUESTS_ENABLED'',',
'                                  p_preference_value => :P16_SERVICE_REQUESTS );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''TRACING_ENABLED'',',
'                                  p_preference_value => :P16_ALLOW_TRACING );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''WORKSPACE_TEAM_DEV_FILES_YN'',',
'                                  p_preference_value => :P16_TEAM_DEV_FILES_YN );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''WORKSPACE_TEAM_DEV_FS_LIMIT'',',
'                                  p_preference_value => :P16_TEAM_DEV_FS_LIMIT );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''DATA_LOADING_JOB_CLASS'',',
'                                  p_preference_value => :P16_DATA_LOADING_JOB_CLASS );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''DATA_LOADING_MAX_FILE_SIZE'',',
'                                  p_preference_value => :P16_DATA_LOADING_MAX_FILE_SIZE );',
'                                  ',
'wwv_flow_platform.set_preference( p_preference_name => ''WORKSPACE_ISSUE_FILES_YN'',',
'                                  p_preference_value => :P16_ISSUE_FILES_YN );',
'',
'wwv_flow_platform.set_preference( p_preference_name => ''WORKSPACE_ISSUE_FS_LIMIT'',',
'                                  p_preference_value => :P16_ISSUE_FS_LIMIT );',
'                                  ',
'wwv_flow_instance_admin.set_parameter( p_parameter => ''MAX_APPLICATION_BACKUPS'',',
'                                       p_value => :P16_BACKUP_LIMIT );                                 ',
'commit;',
'',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible d''enregistrer les param\00E8tres de configuration des fonctionnalit\00E9s.')
,p_process_when_button_id=>wwv_flow_api.id(169388709307261209.4052)
,p_process_success_message=>unistr('Les param\00E8tres de configuration des fonctionnalit\00E9s ont \00E9t\00E9 enregistr\00E9s.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(35198113704069357.4052)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'16'
);
end;
/
prompt --application/pages/page_00017
begin
wwv_flow_api.create_page(
 p_id=>17.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Cr\00E9er/Modifier des ressources propres au site')
,p_step_title=>unistr('Cr\00E9er/Modifier des ressources propres au site')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216789322970659213)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_env_sec.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(951627136736335.4052)
,p_plug_name=>'Ressources propres au site'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'generated 04-MAR-2001 19:43:24'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(952029128736337.4052)
,p_plug_name=>'Ressources propres au site'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Indiquez les ressources qui apparaissent sur la page de connexion \00E0 l''espace de travail et sur la page d''accueil de l''espace de travail.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168832320396520620.4052)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>5
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(952714907736406.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(168832320396520620.4052)
,p_button_name=>'Cancel'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(953528940736408.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(168832320396520620.4052)
,p_button_name=>'Delete'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Supprimer'
,p_button_position=>'CREATE'
,p_button_condition=>'P17_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(952400766736345.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(168832320396520620.4052)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'CREATE'
,p_button_condition=>'P17_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(953110060736407.4052)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(168832320396520620.4052)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er')
,p_button_position=>'CREATE'
,p_button_condition=>'P17_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(75294331022650118.4052)
,p_branch_action=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.:17::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(75293614053645275.4052)
,p_branch_action=>'f?p=&FLOW_ID.:18:&SESSION.::&DEBUG.:17::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(952714907736406.4052)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(953917950736415.4052)
,p_name=>'P17_TASK_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(951627136736335.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nom'
,p_source=>'TASK_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez le texte \00E0 afficher avec la cible de lien.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(954517336736480.4052)
,p_name=>'P17_TASK_LINK'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(951627136736335.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Lien'
,p_source=>'TASK_LINK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Saisissez la cible de lien pour cette ressource. Par exemple :',
'<pre>https://www.oracle.com</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(955210485736485.4052)
,p_name=>'P17_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(951627136736335.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(75234509655426344.4052)
,p_name=>'P17_DISPLAY_SEQUENCE'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_api.id(951627136736335.4052)
,p_use_cache_before_default=>'NO'
,p_item_default=>'10'
,p_prompt=>unistr('S\00E9quence d''affichage')
,p_source=>'DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>5
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('D\00E9finit l''ordre relatif d''affichage des liens dans la liste des ressources.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(75236031126432516.4052)
,p_name=>'P17_DISPLAYED'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(951627136736335.4052)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>unistr('Affich\00E9')
,p_source=>'DISPLAYED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('D\00E9termine si la ressource est affich\00E9e.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(75239916843447392.4052)
,p_name=>'P17_DISPLAY_LOCATION'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(951627136736335.4052)
,p_use_cache_before_default=>'NO'
,p_item_default=>'WORKSPACE_HOME'
,p_prompt=>'Emplacement d''affichage'
,p_source=>'DISPLAY_LOCATION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'TASK_DISPLAY_LOCATION'
,p_lov=>'.'||wwv_flow_api.id(75242612126455451.4052)||'.'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez l''emplacement o\00F9 la ressource doit appara\00EEtre. Options :'),
'<ul>',
'<li>Page d''accueil d''espace de travail</li>',
'<li>Page de connexion d''espace de travail</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(956110817736502.4052)
,p_validation_name=>'value is required'
,p_validation_sequence=>20
,p_validation=>'P17_TASK_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le texte doit \00EAtre indiqu\00E9.')
,p_validation_condition=>'Create,ApplyChanges'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(953917950736415.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(152718005693876831.4052)
,p_validation_name=>'name not whitespace'
,p_validation_sequence=>30
,p_validation=>'replace(:P17_TASK_NAME,'' '',null) is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Le nom de lien ne peut pas \00EAtre constitu\00E9 uniquement d''espaces')
,p_validation_condition=>'ApplyChanges,Create'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(953917950736415.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(202090127032390388.4052)
,p_validation_name=>'display sequence must be numeric'
,p_validation_sequence=>40
,p_validation=>'P17_DISPLAY_SEQUENCE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('La valeur doit \00EAtre num\00E9rique.')
,p_validation_condition=>'Create, ApplyChanges'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(75234509655426344.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(956523719736519.4052)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_CUSTOMIZED_TASKS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CUSTOMIZED_TASKS'
,p_attribute_03=>'P17_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Erreur lors de l''extraction de la ligne.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(152749516531012440.4052)
,p_process_sequence=>11
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set ID'
,p_process_sql_clob=>':P17_ID := wwv_flow_id.next_val;'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P17_ID'
,p_process_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(956903422736535.4052)
,p_process_sequence=>21
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_CUSTOMIZED_TASKS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CUSTOMIZED_TASKS'
,p_attribute_03=>'P17_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Erreur lors du traitement de la ligne de la table WWV_FLOW_CUSTOMIZED_TASKS.'
,p_process_success_message=>unistr('Action trait\00E9e.')
);
end;
/
prompt --application/pages/page_00018
begin
wwv_flow_api.create_page(
 p_id=>18.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Ressources propres au site'
,p_step_title=>'Ressources propres au site'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_env_sec.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(960020599743353.4052)
,p_plug_name=>'Ressources propres au site'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Ces liens s''affichent dans la page d''accueil de l''espace de travail et dans la page de connexion \00E0 l''espace de travail, sous forme de listes de ressources propres au site.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(964406793756833.4052)
,p_name=>'Ressources propres au site'
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, ',
'   display_sequence, ',
'   task_name, ',
'   task_link, ',
'   decode(',
'      display_location,',
'     ''WORKSPACE_HOME'',',
'      wwv_flow_lang.system_message(''F4050.WORKSPACE_HOME''),',
'     ''WORKSPACE_LOGIN'',',
'     wwv_flow_lang.system_message(''F4050.WORKSPACE_LOGIN'')',
'     ) display_location, ',
'   decode(',
'     displayed,',
'     ''Y'',',
'     wwv_flow_lang.system_message(''F4000.YES''),',
'     wwv_flow_lang.system_message(''F4000.NO'')',
'     ) displayed',
'from wwv_flow_customized_tasks'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('Aucune t\00E2che trouv\00E9e')
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(75164114382143826.4052)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(965130942757270.4052)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>11
,p_column_heading=>unistr('S\00E9quence')
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_default_sort_column_sequence=>2
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(964932084757269.4052)
,p_query_column_id=>3
,p_column_alias=>'TASK_NAME'
,p_column_display_sequence=>21
,p_column_heading=>'Nom'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:17:P17_ID:#ID#'
,p_column_linktext=>'#TASK_NAME#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(965011042757269.4052)
,p_query_column_id=>4
,p_column_alias=>'TASK_LINK'
,p_column_display_sequence=>41
,p_column_heading=>'Lien'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(965232430757270.4052)
,p_query_column_id=>5
,p_column_alias=>'DISPLAY_LOCATION'
,p_column_display_sequence=>31
,p_column_heading=>unistr('Affich\00E9 sur la page')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(965320533757270.4052)
,p_query_column_id=>6
,p_column_alias=>'DISPLAYED'
,p_column_display_sequence=>51
,p_column_heading=>'Afficher'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200723903023857946.4052)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>40
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(961500556743430.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(200723903023857946.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(961902894743435.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(200723903023857946.4052)
,p_button_name=>'CREATE_ROW'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er')
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(962710881743501.4052)
,p_branch_action=>'17'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>1
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CREATE_ROW'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(963118584743503.4052)
,p_branch_action=>'5'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(962412919743490.4052)
,p_computation_sequence=>1
,p_computation_item=>'P17_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_comment=>'Set the value of the item conainting the primary key to null when asked to create a new row.'
,p_compute_when=>'CREATE_ROW'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00019
begin
wwv_flow_api.create_page(
 p_id=>19.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('G\00E9rer le journal des activit\00E9s de d\00E9veloppeur')
,p_step_title=>unistr('G\00E9rer le journal des activit\00E9s de d\00E9veloppeur')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216783731365642767)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>'AEADM/adm_logs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19799503430565082.4052)
,p_plug_name=>unistr('Entr\00E9es du journal des activit\00E9s de d\00E9veloppeur')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829706609080810173.4052)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   c_dev pls_integer := 0;',
'',
'begin',
'/*',
'sys.htp.p(''<table class="htmldbInstructionText" role="presentation"><tbody>'');',
'select count(*) into c_dev from wwv_flow_builder_audit_trail;',
'sys.htp.p(''<tr><td>''||wwv_flow_lang.system_message(''4050_19_LOG_ENTRIES'')||''</td>'');',
'sys.htp.p(''<td align="right">''|| to_char(c_dev,''999,999,999,990'') || ''</td></tr>'');',
'sys.htp.p(''</tbody></table>'');',
'*/',
'select count(*) into c_dev from wwv_flow_builder_audit_trail;',
'sys.htp.p(''<p>''||wwv_flow_lang.system_message(''4050_19_LOG_ENTRIES'')||'': '');',
'sys.htp.p(to_char(c_dev,''999,999,999,990'')||''</p>'');',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(982230745511899631.4052)
,p_plug_name=>'Boutons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(582425076905226538.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(982230745511899631.4052)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('Enregistrer le param\00E8tre de conservation')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19803315335578026.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(982230745511899631.4052)
,p_button_name=>'DELETE_ENTRIES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Supprimer des entr\00E9es')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19847614137691252.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(982230745511899631.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(19803703152578047.4052)
,p_branch_action=>'19'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(19803315335578026.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(19801228364572352.4052)
,p_name=>'P19_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(19799503430565082.4052)
,p_prompt=>unistr('Supprimer les entr\00E9es datant du nombre de jours suivant ou plus :')
,p_source=>'31'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIME_INTERVALS'
,p_lov=>'.'||wwv_flow_api.id(87720511660244788.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Supprimez dans le journal des activit\00E9s les entr\00E9es d\00E9passant le nombre de jours identifi\00E9.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(582424812492226536.4052)
,p_name=>'P19_AUDIT_LOG_RETENTION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(19799503430565082.4052)
,p_prompt=>unistr('Jours de conservation du journal de d\00E9veloppeur')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>6
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez le nombre de jours de conservation des entr\00E9es de journal de d\00E9veloppeur. Les entr\00E9es ant\00E9rieures \00E0 ce param\00E8tre seront supprim\00E9es au cours de la maintenance quotidienne.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(19880014493766985.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete rows'
,p_process_sql_clob=>'delete from WWV_FLOW_BUILDER_AUDIT_TRAIL where AUDIT_DATE < (sysdate - nvl(:p19_time,31))'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Erreur lors de la suppression du journal des activit\00E9s de d\00E9veloppeur.')
,p_process_when_button_id=>wwv_flow_api.id(19803315335578026.4052)
,p_process_success_message=>unistr('Le journal des activit\00E9s de d\00E9veloppeur a \00E9t\00E9 supprim\00E9.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(582425141822226539.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Apply Changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_platform.set_preference( ',
'    p_preference_name  => ''AUDIT_LOG_RETENTION'',',
'    p_preference_value => :P19_AUDIT_LOG_RETENTION );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(582425076905226538.4052)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(582424972443226537.4052)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch value from platform_prefs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P19_AUDIT_LOG_RETENTION := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''AUDIT_LOG_RETENTION'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00020
begin
wwv_flow_api.create_page(
 p_id=>20.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Modifier l''affectation de sch\00E9mas \00E0 des espaces de travail')
,p_alias=>'P20'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Modifier l''affectation de sch\00E9mas \00E0 des espaces de travail')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(721098050798687927.4052)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'250'
,p_dialog_width=>'450'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEADM/adm_mg_wrkspc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(680521474522216.4052)
,p_plug_name=>unistr('Affectation de sch\00E9ma d''espace de travail')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'generated 10-MAR-2001 10:51:46'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(982230881241899632.4052)
,p_plug_name=>'Boutons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(681012794522218.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(982230881241899632.4052)
,p_button_name=>'Delete'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Supprimer'
,p_button_position=>'NEXT'
,p_button_condition=>':F4050_P20_ID is not null and :P20_IS_FIRST_SCHEMA = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(681208267522219.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(982230881241899632.4052)
,p_button_name=>'Apply_Changes'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'NEXT'
,p_button_condition=>'F4050_P20_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(681404738522220.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(982230881241899632.4052)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er')
,p_button_position=>'NEXT'
,p_button_condition=>'F4050_P20_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(680801594522218.4052)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(982230881241899632.4052)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(680228915522216.4052)
,p_branch_action=>'21'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(274506709117217135.4052)
,p_branch_action=>'f?p=&APP_ID.:78:&SESSION.::&DEBUG.::P78_PROVISIONING_COMPANY_ID:&F4050_P20_SECURITY_GROUP_ID.'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4050_P20_SECURITY_GROUP_ID'
,p_branch_condition_text=>'10'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(681626422522223.4052)
,p_name=>'F4050_P20_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(680521474522216.4052)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(681827271522225.4052)
,p_name=>'F4050_P20_SECURITY_GROUP_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(680521474522216.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Espace de travail'
,p_source=>'SECURITY_GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST_DEVELOPER_WORKSPACES_NO_NULL_OPTION'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id not in (0,10,11, 12)',
'order by 1'))
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifiez l''espace de travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(682001271522225.4052)
,p_name=>'F4050_P20_SCHEMA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(680521474522216.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Sch\00E9ma de base de donn\00E9es')
,p_source=>'SCHEMA'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select username d,',
'       username r',
'  from wwv_flow_admin_all_schemas s,',
'       ( select short_name',
'           from wwv_flow_companies',
'          where provisioning_company_id = :F4050_P20_SECURITY_GROUP_ID ) ws',
' where (   restricted_to_workspace is null',
'        or restricted_to_workspace = ws.short_name)',
' order by 1'))
,p_lov_cascade_parent_items=>'F4050_P20_SECURITY_GROUP_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifiez le sch\00E9ma correspondant.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12950002945536473.4052)
,p_name=>'P20_PREVIOUS_SCHEMA'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(680521474522216.4052)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(135418406612396046.4052)
,p_name=>'P20_IS_FIRST_SCHEMA'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(680521474522216.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(12950302646564854.4052)
,p_computation_sequence=>10
,p_computation_item=>'P20_PREVIOUS_SCHEMA'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'     l_schema varchar2(4000);',
'begin',
'     for c1 in (select schema from wwv_flow_company_schemas where security_group_id = :F4050_P20_SECURITY_GROUP_ID and id = :F4050_P20_ID) loop',
'         l_schema := c1.schema;',
'     end loop;',
'    return l_schema;',
'end;  '))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(135422609644415804.4052)
,p_computation_sequence=>10
,p_computation_item=>'P20_IS_FIRST_SCHEMA'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select a.schema, b.first_schema_provisioned',
'             from wwv_flow_company_schemas a, wwv_flow_companies b',
'            where a.security_group_id = b.provisioning_company_id',
'              and a.id = :F4050_P20_ID ) loop',
'  if c1.schema = c1.first_schema_provisioned then',
'    return ''Y'';',
'  else ',
'    return ''N'';',
'  end if;',
'  exit;',
'end loop;'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(206354662431953019.4052)
,p_name=>'Cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(680801594522218.4052)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(206354732706953020.4052)
,p_event_id=>wwv_flow_api.id(206354662431953019.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(682212029522226.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_COMPANY_SCHEMAS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_COMPANY_SCHEMAS'
,p_attribute_03=>'F4050_P20_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Erreur lors de l''extraction de la ligne.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(274482203755203147.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check schema'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_provisioning.reserved_schema(p_schema => :F4050_P20_SCHEMA)',
' or ',
'  (wwv_flow_provisioning.site_admin_is_restricted and ',
'   wwv_flow_provisioning.restricted_schema(',
'     p_schema =>  :F4050_P20_SCHEMA, ',
'     p_workspace_name => wwv_flow_security.find_company_name(:F4050_P20_SECURITY_GROUP_ID))) then',
'  :F4050_P20_SCHEMA := ''INVALID'';',
'end if;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(682401703522227.4052)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_COMPANY_SCHEMAS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_COMPANY_SCHEMAS'
,p_attribute_03=>'F4050_P20_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Erreur lors du traitement de la ligne.'
,p_process_success_message=>unistr('Action trait\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(12121519965351173.4052)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Users'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4050_P20_SCHEMA <> ''INVALID'' then',
'  wwv_flow_provisioning.update_user_default_schema(',
'           p_security_group_id     => :F4050_P20_SECURITY_GROUP_ID,',
'           p_new_schema            => :F4050_P20_SCHEMA,',
'           p_old_schema            => :P20_PREVIOUS_SCHEMA);',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors du traitement de la ligne.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(681208267522219.4052)
,p_process_success_message=>unistr('Action trait\00E9e.')
);
end;
/
prompt --application/pages/page_00021
begin
wwv_flow_api.create_page(
 p_id=>21.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('G\00E9rer les affectations d''espaces de travail \00E0 des sch\00E9mas')
,p_step_title=>unistr('G\00E9rer les affectations d''espaces de travail \00E0 des sch\00E9mas')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_schema_assign.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19713719462515413.4052)
,p_plug_name=>unistr('Sch\00E9mas d''espace de travail')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Cet \00E9tat r\00E9pertorie les sch\00E9mas dans lesquels il est possible de construire un espace de travail donn\00E9. Lorsque les d\00E9veloppeurs cr\00E9ent de nouvelles applications, ils doivent choisir, dans la liste des sch\00E9mas affect\00E9s \00E0 l''espace de travail, un sc')
||unistr('h\00E9ma dans lequel construire pour que leur SQL soit analys\00E9 au titre de ce dernier.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32859321338800843.4052)
,p_plug_name=>'reset'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>':P106_PASSWORD := null;'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472503211871482476.4052)
,p_plug_name=>unistr('Sch\00E9mas provisionn\00E9s par espace de travail')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select cs.SCHEMA,',
'       c.short_name,',
'       cs.SECURITY_GROUP_ID,',
'       cs.id,',
'       case when u.username is not null then ''Y'' else ''N'' end as schema_exists,',
'       case when cs.schema = c.first_schema_provisioned then ''Y'' else ''N'' end as first_schema_provisioned',
'  from WWV_FLOW_COMPANY_SCHEMAS cs,',
'       wwv_flow_companies c,',
'       sys.all_users u',
' where cs.security_group_id = c.PROVISIONING_COMPANY_ID (+)',
'   and cs.schema = u.username (+)',
'   and cs.security_group_id not in ( 10, 11, 12 )'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(472503303297482477.4052)
,p_name=>'Schemas Provisioned by Workspace'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472503608089482489.4052)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Espace de travail'
,p_column_link=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.::F4050_P20_ID:#ID#'
,p_column_linktext=>'#SHORT_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472503509106482485.4052)
,p_db_column_name=>'SCHEMA'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>unistr('Sch\00E9ma')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(206354546530953018.4052)
,p_db_column_name=>'SCHEMA_EXISTS'
,p_display_order=>12
,p_column_identifier=>'E'
,p_column_label=>unistr('Le sch\00E9ma existe')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(157992123774592395)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(279108352595806131.4052)
,p_db_column_name=>'FIRST_SCHEMA_PROVISIONED'
,p_display_order=>22
,p_column_identifier=>'F'
,p_column_label=>unistr('Premier sch\00E9ma provisionn\00E9')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(157992123774592395)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472503726508482490.4052)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>32
,p_column_identifier=>'C'
,p_column_label=>'ID d''espace de travail'
,p_column_type=>'NUMBER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472503806891482491.4052)
,p_db_column_name=>'ID'
,p_display_order=>42
,p_column_identifier=>'D'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(472517919866500137.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(472503211871482476.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19713915330515414.4052)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_api.id(472503211871482476.4052)
,p_button_name=>'Create'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Ajouter un sch\00E9ma')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:105:&SESSION.::&DEBUG.:105,106,107::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(19715800116515426.4052)
,p_branch_action=>'21'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(982230976761899633.4052)
,p_name=>'Handle Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(472503211871482476.4052)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(982231061401899634.4052)
,p_event_id=>wwv_flow_api.id(982230976761899633.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(472503211871482476.4052)
);
end;
/
prompt --application/pages/page_00022
begin
wwv_flow_api.create_page(
 p_id=>22.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('G\00E9rer les privil\00E8ges de base de donn\00E9es d''espace de travail')
,p_step_title=>unistr('G\00E9rer les privil\00E8ges de base de donn\00E9es d''espace de travail')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_wrkspc_privs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168541603401017650.4052)
,p_plug_name=>unistr('Privil\00E8ges d''espace de travail')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P22a */',
'  cs.SCHEMA,',
'  c.short_name,',
'  cs.SECURITY_GROUP_ID,',
'  cs.id, p.privilege, p.admin_option',
'from ',
'  WWV_FLOW_COMPANY_SCHEMAS cs, ',
'  wwv_flow_companies c, ',
'  sys.dba_sys_privs p',
'where ',
'cs.schema = p.grantee and',
'(:P22_FIND is null or ',
' instr(p.privilege,upper(:P22_FIND)) > 0 or',
' instr(upper(cs.schema),upper(:P22_FIND)) > 0 or',
' instr(upper(c.short_name),upper(:P22_FIND)) > 0)  and',
'cs.security_group_id = c.PROVISIONING_COMPANY_ID(+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(168541709855017650.4052)
,p_name=>'Workspace Privileges'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(168542020537017667.4052)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Espace de travail'
,p_column_link=>'f?p=4050:14:&SESSION.:REPORT:NO:14:SGID:#SECURITY_GROUP_ID#'
,p_column_linktext=>'#SHORT_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(168541906509017665.4052)
,p_db_column_name=>'SCHEMA'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>unistr('Sch\00E9ma')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(168542124780017668.4052)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('ID de groupe de s\00E9curit\00E9')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(168542210066017668.4052)
,p_db_column_name=>'ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(168542300521017669.4052)
,p_db_column_name=>'PRIVILEGE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Privil\00E8ge')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(168542430129017669.4052)
,p_db_column_name=>'ADMIN_OPTION'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Option d''administration'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(110344620122166929)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(982231175324899635.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(168541603401017650.4052)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:RP,RIR,22:::'
);
end;
/
prompt --application/pages/page_00023
begin
wwv_flow_api.create_page(
 p_id=>23.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Cr\00E9er/modifier un utilisateur')
,p_step_title=>unistr('Cr\00E9er/modifier un utilisateur')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(216787602191653217)
,p_step_template=>wwv_flow_api.id(704456563630760825.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_users.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4789806742494505.4052)
,p_plug_name=>unistr('Privil\00E8ges du compte')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20502200062918881.4052)
,p_plug_name=>'reset'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4050_P23_WEB_PASSWORD := null;',
':F4050_P23_CONFIRM_PASSWD := null;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(43032554506866236.4052)
,p_plug_name=>'Attributs utilisateur'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings=>'UserID:Security<br>GroupID:<font color=green>Company</font>:Web<br>Password'
,p_plug_query_num_rows=>15
,p_plug_query_no_data_found=>unistr('Aucun utilisateur bas\00E9 sur le cookie n''a \00E9t\00E9 d\00E9fini. Cliquez sur l''ic\00F4ne d''ajout pour cr\00E9er un nouvel utilisateur.')
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'generated 16-MAR-2001 11:21:01'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(61303115419117985.4052)
,p_plug_name=>'&F4050_PASSWORD_REGION_TITLE.'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(161703707200871657.4052)
,p_plug_name=>'Links'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(182517420179163788.4052)
,p_plug_name=>unistr('Cr\00E9er/modifier un utilisateur')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_04'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(190667230101179100.4052)
,p_plug_name=>'Groupes d''utilisateurs'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings=>'&nbsp;:Flow:User:Developer Role(s)'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_fnd boolean default false;',
'begin',
'for c1 in (',
'select 1',
'from wwv_flow_fnd_user_groups_noapp',
'where security_group_id = :F4050_P23_SECURITY_GROUP_ID ) loop',
'  l_fnd := true;',
'end loop;',
'return l_fnd;',
'end;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(254117224240978570.4052)
,p_plug_name=>unistr('S\00E9lecteur d''affichage de r\00E9gion')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(195775112470763477.4052)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(504825819331106161.4052)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Les administrateurs du service &PRODUCT_NAME. peuvent g\00E9rer les comptes utilisateur pour n''importe quel espace de travail.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(43032820185866237.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(182517420179163788.4052)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:23::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(43033071157866237.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(182517420179163788.4052)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Supprimer un utilisateur'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>':F4050_P23_USER_ID is not null and :F4050_P23_USER_ID != wwv_flow_user_api.get_user_id(:FLOW_USER)'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(43033257856866238.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(182517420179163788.4052)
,p_button_name=>'Apply_Changes'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'NEXT'
,p_button_condition=>'F4050_P23_USER_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(39279805171990401.4052)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(182517420179163788.4052)
,p_button_name=>'CREATE_ANOTHER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('Cr\00E9er et cr\00E9er un autre')
,p_button_position=>'NEXT'
,p_button_condition=>'F4050_P23_USER_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(43033414946866238.4052)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(182517420179163788.4052)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er un utilisateur')
,p_button_position=>'NEXT'
,p_button_condition=>'F4050_P23_USER_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(43031812037866231.4052)
,p_branch_name=>'Go To Page 12'
,p_branch_action=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:23::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Create'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(39280113672990404.4052)
,p_branch_name=>'Go To Page 23'
,p_branch_action=>'f?p=&APP_ID.:23:&SESSION.::&DEBUG.:23,EDIT_USER_PRIVS:F4050_P23_SECURITY_GROUP_ID:&F4050_P23_SECURITY_GROUP_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(39279805171990401.4052)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(43032215890866234.4052)
,p_branch_name=>'Go To Page 12'
,p_branch_action=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:23::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2691628386326712.4052)
,p_name=>'F4050_P23_DEFAULT_SCHEMA'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(4789806742494505.4052)
,p_prompt=>unistr('Sch\00E9ma par d\00E9faut')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select schema d, schema r',
' from wwv_flow_company_schemas',
'where security_group_id = :F4050_P23_SECURITY_GROUP_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- S\00E9lectionner un sch\00E9ma -')
,p_lov_cascade_parent_items=>'F4050_P23_SECURITY_GROUP_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Sch\00E9ma par d\00E9faut de cet utilisateur.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12480015129149970.4052)
,p_name=>'P23_ACCOUNT_EXPIRY'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(4789806742494505.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12480931059154603.4052)
,p_name=>'P23_ACCOUNT_LOCKED'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(4789806742494505.4052)
,p_item_default=>'N'
,p_prompt=>unistr('Disponibilit\00E9 du compte')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ACCOUNT_LOCK_STATUS'
,p_lov=>'.'||wwv_flow_api.id(12506800188785204.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Options disponibles :',
'<ul>',
unistr('<li>S\00E9lectionnez <strong>Verrouill\00E9</strong> pour emp\00EAcher l''utilisation du compte.</li> '),
unistr('<li>S\00E9lectionnez <strong>D\00E9verrouill\00E9</strong> pour que le compte puisse \00EAtre utilis\00E9.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12481506257156915.4052)
,p_name=>'P23_FAILED_ACCESS_ATTEMPTS'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_api.id(61303115419117985.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12482115260159568.4052)
,p_name=>'P23_CHANGE_PWD_ON_FIRST_USE'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(61303115419117985.4052)
,p_item_default=>'''Y'''
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Demander la modification du mot de passe \00E0 la premi\00E8re utilisation')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_cattributes_element=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez <strong>Oui</strong> pour que l''utilisateur soit oblig\00E9 de modifier son mot de passe juste apr\00E8s la connexion avec le mot de passe temporaire en cours. '),
unistr('<p>Cette r\00E8gle s''applique \00E0 l''utilisation de ce compte par les d\00E9veloppeurs et les administrateurs d''espace de travail. Elle s''applique \00E9galement \00E0 tous les utilisateurs qui emploient ce compte pour se connecter aux applications d\00E9velopp\00E9es.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12482722533161601.4052)
,p_name=>'P23_FIRST_PWD_USE_OCCURRED'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(61303115419117985.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12496823435353552.4052)
,p_name=>'P23_SHOW_EXPIRE_FLAG'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(61303115419117985.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12498809783385770.4052)
,p_name=>'P23_EXPIRATION_STATUS1'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(61303115419117985.4052)
,p_prompt=>unistr('Mot de passe du d\00E9veloppeur ou de l''administrateur :')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>':F4050_P23_USER_ID is not null and :P23_EXPIRATION_STATUS1 <> ''NA'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Indique si le mot de passe a expir\00E9 ou est valide pour la connexion du d\00E9veloppeur ou de l''administrateur.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12499022628385770.4052)
,p_name=>'P23_EXPIRATION_STATUS2'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(61303115419117985.4052)
,p_prompt=>'Mot de passe de l''utilisateur final :'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>':F4050_P23_USER_ID is not null and :P23_EXPIRATION_STATUS2 <> ''NA'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Indique si le mot de passe a expir\00E9 ou est valide pour la connexion de l''utilisateur final.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12501217642408601.4052)
,p_name=>'P23_EXPIRE'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_api.id(61303115419117985.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Invalider le mot de passe'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'select null d, ''Y'' r from dual'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>':P23_SHOW_EXPIRE_FLAG = ''Y'' and :F4050_P23_USER_ID is not null'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Cochez cette case pour invalider le mot de passe de l''utilisateur. Ceci affecte \00E0 la fois la connexion et l''acc\00E8s du d\00E9veloppeur ou de l''administrateur en tant qu''utilisateur final. Si le mot de passe est invalid\00E9, la prochaine fois que l''utilisateur')
||unistr(' acc\00E8de \00E0 ce compte, il devra fournir son ancien mot de passe ainsi que le nouveau pour pouvoir se connecter.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(43033620636866241.4052)
,p_name=>'F4050_P23_USER_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(43032554506866236.4052)
,p_prompt=>'User ID'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(43033813964866242.4052)
,p_name=>'F4050_P23_USER_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(43032554506866236.4052)
,p_prompt=>'Nom utilisateur'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Saisissez le nom utilisateur.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(43034067641866243.4052)
,p_name=>'F4050_P23_FIRST_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(43032554506866236.4052)
,p_prompt=>unistr('Pr\00E9nom')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez le pr\00E9nom de l''utilisateur.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(43034227119866244.4052)
,p_name=>'F4050_P23_LAST_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(43032554506866236.4052)
,p_prompt=>'Nom'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Saisissez le nom de l''utilisateur.',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(43035819093866248.4052)
,p_name=>'F4050_P23_DESCRIPTION'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(43032554506866236.4052)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>200
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Saisissez une description de l''utilisateur (facultatif).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(43037241672866252.4052)
,p_name=>'F4050_P23_EMAIL_ADDRESS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(43032554506866236.4052)
,p_prompt=>unistr('Adresse \00E9lectronique')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>240
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez l''adresse \00E9lectronique de l''utilisateur.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(43037870063866254.4052)
,p_name=>'F4050_P23_WEB_PASSWORD'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(61303115419117985.4052)
,p_prompt=>'Mot de passe'
,p_post_element_text=>' <span class="instructiontext">Pour les mots de passe, il y a distinction entre les majuscules et les minuscules</span>'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>32
,p_cMaxlength=>255
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Saisissez le mot de passe (uniquement si cr\00E9ez un nouveau compte avec un mot de passe ou si vous modifiez le mot de passe d''un compte existant).')
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(43042986599987259.4052)
,p_name=>'F4050_P23_SECURITY_GROUP_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(4789806742494505.4052)
,p_prompt=>'Espace de travail'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST_ALL_COMPANIES_NO_NULL_OPTION'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id > 0',
'  and  provisioning_company_id != 11',
'  and  provisioning_company_id != 12',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_read_only_when=>':F4050_P23_USER_ID is not null'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Choisissez un espace de travail pour l''utilisateur dans la liste instantan\00E9e.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(157994413889601615.4052)
,p_name=>'P23_DEVELOPER'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(4789806742494505.4052)
,p_item_default=>'Y'
,p_prompt=>unistr('L''utilisateur est un d\00E9veloppeur :')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_tag_attributes=>'onClick="javascript:if (document.forms[0].P23_ADMIN_0.checked) document.forms[0].P23_DEVELOPER_0.checked = true;"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez si cet utilisateur doit avoir les privil\00E8ges de d\00E9veloppeur. Les d\00E9veloppeurs doivent d\00E9tenir des droits d''acc\00E8s \00E0 App Builder et/ou \00E0 SQL Workshop.'),
'',
unistr('Les composants risquent de ne pas \00EAtre disponibles s''ils sont d\00E9sactiv\00E9s par les administrateurs d''instance.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(157996406317627808.4052)
,p_name=>'P23_ADMIN'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(4789806742494505.4052)
,p_item_default=>'Y'
,p_prompt=>'L''utilisateur est un administrateur :'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'onClick="javascript:if (document.forms[0].P23_ADMIN_0.checked) document.forms[0].P23_DEVELOPER_0.checked = true;"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez si cet utilisateur doit avoir les privil\00E8ges d''administrateur d''espace de travail. Les droits d''acc\00E8s \00E0 tous les composants sont accord\00E9s aux administrateurs. En outre, ces derniers peuvent g\00E9rer les comptes utilisateur, groupes et services ')
||unistr('de d\00E9veloppement.'),
'',
unistr('Les composants risquent de ne pas \00EAtre disponibles s''ils sont d\00E9sactiv\00E9s par les administrateurs d''instance.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(182810818563091386.4052)
,p_name=>'F4050_P23_DEV_PRIVS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(4789806742494505.4052)
,p_prompt=>'Developer Privileges (Click only ADMIN to receive all privileges)'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(190665205313175398.4052)
,p_name=>'F4050_P23_GROUPS'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(190667230101179100.4052)
,p_prompt=>'Groupes'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'USER.GROUPS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, id r',
'from wwv_flow_fnd_user_groups_noapp',
'where security_group_id = :F4050_P23_SECURITY_GROUP_ID order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>8
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifiez les groupes auxquels appartient l''utilisateur.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(240387620119665972.4052)
,p_name=>'F4050_P23_CONFIRM_PASSWD'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(61303115419117985.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Confirmer le mot de passe'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Saisissez de nouveau le mot de passe pour confirmation (uniquement si vous cr\00E9ez un nouveau compte avec un mot de passe ou si vous mettez \00E0 jour le mot de passe d''un compte existant).')
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(351317726029487696.4052)
,p_name=>'P23_ALLOW_ACCESS_SCHEMAS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(4789806742494505.4052)
,p_prompt=>unistr('Sch\00E9mas accessibles (Null pour tous)')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_read_only_when=>'F4050_P23_SECURITY_GROUP_ID'
,p_read_only_when2=>'10'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez la liste des sch\00E9mas, s\00E9par\00E9s par des deux-points, pour lesquels ce d\00E9veloppeur a des droits d''acc\00E8s lorsqu''il utilise SQL Workshop. La liste des sch\00E9mas saisie ici limite l''utilisateur \00E0 un sous-ensemble des sch\00E9mas provisionn\00E9s pour l''esp')
||unistr('ace de travail et d\00E9termine les noms de sch\00E9ma que l''utilisateur visualise dans SQL Workshop.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(367577404458914012.4052)
,p_name=>'P23_DEFAULT_DATE_FORMAT'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(43032554506866236.4052)
,p_prompt=>unistr('Format de date par d\00E9faut')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'DATE_FORMAT_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r',
'  from wwv_flow_format_masks',
' where t=''D'''))
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Sp\00E9cifiez le format de date Oracle par d\00E9faut pour l''utilisateur. Cela contr\00F4lera le format de date par d\00E9faut dans SQL Workshop.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(499671720750978400.4052)
,p_name=>'P23_ALLOW_APP_BUILDING_YN'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(4789806742494505.4052)
,p_item_default=>'Y'
,p_prompt=>unistr('Acc\00E8s \00E0 App Builder')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from WWV_FLOW_COMPANIES',
'where (provisioning_company_id = :F4050_P23_SECURITY_GROUP_ID',
'and    NVL(allow_app_building_yn,''Y'') = ''Y'')',
'or :F4050_P23_SECURITY_GROUP_ID IS NULL'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('D\00E9termine si un d\00E9veloppeur a acc\00E8s \00E0 App Builder.<br>'),
'<br>',
unistr('Un administrateur a toujours acc\00E8s \00E0 App Builder.<br>'),
unistr('Un d\00E9veloppeur doit avoir acc\00E8s \00E0 App Builder et/ou \00E0 SQL Workshop.<br>'),
'<br>',
unistr('Cet attribut est toujours d\00E9sactiv\00E9 lorsqu''un administrateur a d\00E9sactiv\00E9 l''acc\00E8s \00E0 App Builder pour l''espace de travail.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(499672130451978402.4052)
,p_name=>'P23_ALLOW_SQL_WORKSHOP_YN'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(4789806742494505.4052)
,p_item_default=>'Y'
,p_prompt=>unistr('Acc\00E8s \00E0 SQL Workshop')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from WWV_FLOW_COMPANIES',
'where (provisioning_company_id = :F4050_P23_SECURITY_GROUP_ID',
'and    NVL(allow_sql_workshop_yn,''Y'') = ''Y'')',
'or :F4050_P23_SECURITY_GROUP_ID IS NULL'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('D\00E9termine si un d\00E9veloppeur a acc\00E8s \00E0 SQL Workshop.<br>'),
'<br>',
unistr('Un administrateur a toujours acc\00E8s \00E0 SQL Workshop.<br>'),
unistr('Un d\00E9veloppeur doit avoir acc\00E8s \00E0 App Builder et/ou \00E0 SQL Workshop.<br>'),
'<br>',
unistr('Cet attribut est toujours d\00E9sactiv\00E9 lorsqu''un administrateur a d\00E9sactiv\00E9 l''acc\00E8s \00E0 SQL Workshop pour l''espace de travail.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(499672303492978402.4052)
,p_name=>'P23_ALLOW_TEAM_DEVELOPMENT_YN'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(4789806742494505.4052)
,p_item_default=>'Y'
,p_prompt=>unistr('Acc\00E8s au d\00E9veloppement d''\00E9quipe')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from WWV_FLOW_COMPANIES',
'where (provisioning_company_id = :F4050_P23_SECURITY_GROUP_ID',
'and    NVL(allow_team_development_yn,''Y'') = ''Y'')',
'or :F4050_P23_SECURITY_GROUP_ID IS NULL'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('D\00E9termine si un utilisateur a acc\00E8s au d\00E9veloppement d''\00E9quipe.<br>'),
'<br>',
unistr('Un administrateur a toujours acc\00E8s au d\00E9veloppement d''\00E9quipe.<br>'),
'<br>',
unistr('Cet attribut est toujours d\00E9sactiv\00E9 lorsqu''un administrateur a d\00E9sactiv\00E9 l''acc\00E8s au d\00E9veloppement d''\00E9quipe pour l''espace de travail.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(499944115009587837.4052)
,p_name=>'P23_DISALLOW_APP_BUILDING'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(4789806742494505.4052)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Acc\00E8s \00E0 App Builder')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from WWV_FLOW_COMPANIES',
'where provisioning_company_id = :F4050_P23_SECURITY_GROUP_ID',
'and   NVL(allow_app_building_yn,''Y'') = ''N'''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('D\00E9termine si un d\00E9veloppeur a acc\00E8s \00E0 App Builder.<br>'),
'<br>',
unistr('Un administrateur a toujours acc\00E8s \00E0 App Builder.<br>'),
unistr('Un d\00E9veloppeur doit avoir acc\00E8s \00E0 App Builder et/ou \00E0 SQL Workshop.<br>'),
'<br>',
unistr('Cet attribut est toujours d\00E9sactiv\00E9 lorsqu''un administrateur a d\00E9sactiv\00E9 l''acc\00E8s \00E0 App Builder pour l''espace de travail.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(499945108907595575.4052)
,p_name=>'P23_DISALLOW_SQL_WORKSHOP'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(4789806742494505.4052)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Acc\00E8s \00E0 SQL Workshop')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from WWV_FLOW_COMPANIES',
'where provisioning_company_id = :F4050_P23_SECURITY_GROUP_ID',
'and   NVL(allow_sql_workshop_yn,''Y'') = ''N'''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('D\00E9termine si un d\00E9veloppeur a acc\00E8s \00E0 SQL Workshop.<br>'),
'<br>',
unistr('Un administrateur a toujours acc\00E8s \00E0 SQL Workshop.<br>'),
unistr('Un d\00E9veloppeur doit avoir acc\00E8s \00E0 App Builder et/ou \00E0 SQL Workshop.<br>'),
'<br>',
unistr('Cet attribut est toujours d\00E9sactiv\00E9 lorsqu''un administrateur a d\00E9sactiv\00E9 l''acc\00E8s \00E0 SQL Workshop pour l''espace de travail.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(499945618950598529.4052)
,p_name=>'P23_DISALLOW_TEAM_DEVELOPMENT'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(4789806742494505.4052)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Acc\00E8s au d\00E9veloppement d''\00E9quipe')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from WWV_FLOW_COMPANIES',
'where provisioning_company_id = :F4050_P23_SECURITY_GROUP_ID',
'and   NVL(allow_team_development_yn,''Y'') = ''N'''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('D\00E9termine si un utilisateur a acc\00E8s au d\00E9veloppement d''\00E9quipe.<br>'),
'<br>',
unistr('Un administrateur a toujours acc\00E8s au d\00E9veloppement d''\00E9quipe.<br>'),
'<br>',
unistr('Cet attribut est toujours d\00E9sactiv\00E9 lorsqu''un administrateur a d\00E9sactiv\00E9 l''acc\00E8s au d\00E9veloppement d''\00E9quipe pour l''espace de travail.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(316540319552589525.4052)
,p_computation_sequence=>10
,p_computation_item=>'F4050_P23_DEFAULT_SCHEMA'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'replace(:F4050_P23_DEFAULT_SCHEMA,''%''||''null%'',null)'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(240393507137700064.4052)
,p_computation_sequence=>20
,p_computation_item=>'F4050_P23_CONFIRM_PASSWD'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'ltrim(rtrim(:F4050_P23_CONFIRM_PASSWD))'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(12554726371767163.4052)
,p_computation_sequence=>40
,p_computation_item=>'P23_EXPIRE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P23_EXPIRE,''N'') <> ''Y'' then',
'  return ''N'';',
'else',
'  return ''Y'';',
'end if;'))
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(12555506070770774.4052)
,p_computation_sequence=>50
,p_computation_item=>'P23_ACCOUNT_LOCKED'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P23_ACCOUNT_LOCKED,''N'') <> ''Y'' then',
'  return ''N'';',
'else',
'  return ''Y'';',
'end if;'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(182745532211009071.4052)
,p_validation_name=>'F4050_P23_USER_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'F4050_P23_USER_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le nom utilisateur doit \00EAtre indiqu\00E9.')
,p_validation_condition=>':REQUEST in (''Apply_Changes'',''CREATE'',''CREATE_ANOTHER'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(43033813964866242.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 22-FEB-2002 12:40'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(111539302381125034.4052)
,p_validation_name=>'Invalid characters in username'
,p_validation_sequence=>20
,p_validation=>'F4050_P23_USER_NAME'
,p_validation2=>'<>'
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>'Nom utilisateur non valide.'
,p_validation_condition=>'Apply_Changes,CREATE,CREATE_ANOTHER'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(43033813964866242.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(164285025826484749.4052)
,p_validation_name=>'prevent duplicate username'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 r',
'  from wwv_flow_fnd_user',
' where user_name = upper(:F4050_P23_USER_NAME)',
'   and security_group_id = :F4050_P23_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Le nom utilisateur doit \00EAtre unique dans l''espace de travail.')
,p_validation_condition=>':REQUEST in (''CREATE'',''CREATE_ANOTHER'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(43033813964866242.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(182742403109007422.4052)
,p_validation_name=>'F4050_P23_EMAIL_ADDRESS Not Null'
,p_validation_sequence=>40
,p_validation=>'F4050_P23_EMAIL_ADDRESS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('L''adresse \00E9lectronique doit \00EAtre indiqu\00E9e.')
,p_validation_condition=>':REQUEST IN (''Apply_Changes'',''CREATE'',''CREATE_ANOTHER'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(43037241672866252.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 22-FEB-2002 12:40'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(39286930629035660.4052)
,p_validation_name=>'workspace not null'
,p_validation_sequence=>50
,p_validation=>'F4050_P23_SECURITY_GROUP_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('L''espace de travail doit \00EAtre indiqu\00E9.')
,p_validation_condition=>':REQUEST in (''Apply_Changes'',''CREATE'',''CREATE_ANOTHER'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(43042986599987259.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(149174714581321552.4052)
,p_validation_name=>'WorkspaceNumeric'
,p_validation_sequence=>60
,p_validation=>'F4050_P23_SECURITY_GROUP_ID'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('L''espace de travail doit \00EAtre num\00E9rique.')
,p_validation_condition=>':REQUEST in (''Apply_Changes'',''CREATE'',''CREATE_ANOTHER'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(43042986599987259.4052)
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(149172103583299374.4052)
,p_validation_name=>'WorkspaceValid'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1'' ',
'  from WWV_FLOW_COMPANIES',
' where provisioning_company_id > 0',
'   and :F4050_P23_SECURITY_GROUP_ID = PROVISIONING_COMPANY_ID'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('Vous devez s\00E9lectionner un espace de travail valide.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST in (''Apply_Changes'',''CREATE'',''CREATE_ANOTHER'') and',
':P23_IS_ADMIN != ''Y'''))
,p_validation_condition_type=>'NEVER'
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(488453630588913316.4052)
,p_validation_name=>'when username change, password must be set'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select user_name',
'     from wwv_flow_fnd_user',
'    where user_id = :F4050_P23_USER_ID',
'      and security_group_id = :F4050_P23_SECURITY_GROUP_ID )',
'loop',
'   if c1.user_name != :F4050_P23_USER_NAME and',
'      :F4050_P23_WEB_PASSWORD is null then',
'   return false;',
'   else return true;',
'   end if;',
'end loop;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Si vous mettez \00E0 jour le nom utilisateur, vous devez fournir un nouveau mot de passe.')
,p_when_button_pressed=>wwv_flow_api.id(43033257856866238.4052)
,p_associated_item=>wwv_flow_api.id(43037870063866254.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(182742730875007426.4052)
,p_validation_name=>'F4050_P23_WEB_PASSWORD Not Null'
,p_validation_sequence=>90
,p_validation=>'F4050_P23_WEB_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Vous devez indiquer un mot de passe.'
,p_validation_condition=>'CREATE,CREATE_ANOTHER'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(43037870063866254.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 22-FEB-2002 12:40'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(23877827234193982.4052)
,p_validation_name=>'strong password verification'
,p_validation_sequence=>100
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_use_strong_rules boolean;',
'begin',
'  if :F4050_P23_SECURITY_GROUP_ID = 10 and nvl(wwv_flow_platform.get_preference(''STRONG_SITE_ADMIN_PASSWORD''),''N'') = ''Y'' then',
'    l_use_strong_rules := true;',
'  else',
'    l_use_strong_rules := false;',
'  end if;',
'  ',
'  return wwv_flow_security.strong_password_validation(',
'      p_username              => :F4050_P23_USER_NAME,',
'      p_password              => :F4050_P23_WEB_PASSWORD,',
'      p_old_password          => null,',
'      p_workspace_name        => wwv_flow_security.find_company_name(:F4050_P23_SECURITY_GROUP_ID),',
'      p_use_strong_rules      => l_use_strong_rules);',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :REQUEST IN (''Apply_Changes'',''CREATE'',''CREATE_ANOTHER'')',
'and wwv_flow_authentication_dev.is_builder_password_required (',
'        p_developer_yn => :P23_DEVELOPER )',
'and wwv_flow_authentication_dev.get_internal_authentication <> ''DB'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(43037870063866254.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(384616289309738714.4052)
,p_validation_name=>'Validate DB Password'
,p_validation_sequence=>110
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4050_P23_WEB_PASSWORD is null then',
'    return false;',
'else',
'    return wwv_flow_4050_ui.p79_validate_password (',
'           p_username => upper(:F4050_P23_USER_NAME),',
'           p_password => :F4050_P23_WEB_PASSWORD );',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Le mot de passe n''est pas conforme \00E0 la strat\00E9gie de complexit\00E9 de mot de passe de base de donn\00E9es.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(:REQUEST IN (''CREATE'',''CREATE_ANOTHER'') ',
'   and :P23_DEVELOPER = ''Y'' ',
'   and wwv_flow_authentication_dev.get_internal_authentication = ''DB'')',
'or',
'(:REQUEST = ''Apply_Changes'' ',
'   and :P23_DEVELOPER = ''Y'' ',
'   and wwv_flow_authentication_dev.get_internal_authentication = ''DB''',
'   and :F4050_P23_DEV_PRIVS is null)'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(43037870063866254.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(240392628824696884.4052)
,p_validation_name=>'Confirm PAssword'
,p_validation_sequence=>120
,p_validation=>':F4050_P23_WEB_PASSWORD = :F4050_P23_CONFIRM_PASSWD'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Le mot de passe n''a pas \00E9t\00E9 confirm\00E9 correctement. Saisissez exactement le m\00EAme mot de passe les deux fois.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST IN (''Apply_Changes'',''CREATE'',''CREATE_ANOTHER'')',
'and ( :F4050_P23_WEB_PASSWORD is not null ',
'      or :F4050_P23_CONFIRM_PASSWD is not null )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(43037870063866254.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(499739807740135447.4052)
,p_validation_name=>'Developer must have Access'
,p_validation_sequence=>130
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'BEGIN',
'  IF :P23_DEVELOPER = ''Y'' THEN',
'    IF :P23_ALLOW_APP_BUILDING_YN = ''N''',
'    AND :P23_ALLOW_SQL_WORKSHOP_YN = ''N'' THEN',
'      RETURN FALSE;',
'    END IF;',
'  END IF;',
'',
'  RETURN TRUE;',
'END;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Un d\00E9veloppeur doit d\00E9tenir les droits d''acc\00E8s \00E0 App Builder et/ou \00E0 SQL Workshop.')
,p_validation_condition=>'CREATE,CREATE_ANOTHER,Apply_Changes'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(157994413889601615.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(609896630929899250.4052)
,p_validation_name=>'non APEX auth username validate'
,p_validation_sequence=>140
,p_validation=>'return regexp_like(:F4050_P23_USER_NAME,wwv_flow_platform.get_preference(''USERNAME_VALIDATION''));'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Le nom utilisateur ne concorde pas avec l''expression d\00E9finie pour l''instance.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :REQUEST in (''Apply_Changes'',''CREATE'',''CREATE_ANOTHER'')',
'and nvl(wwv_flow_platform.get_preference(''USERNAME_VALIDATION''),''*'') != ''*''',
'and (:P23_ADMIN = ''Y'' or :P23_DEVELOPER = ''Y'')'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(43033813964866242.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(354473531133800559.4052)
,p_validation_name=>'Default schema in accessible schemas'
,p_validation_sequence=>150
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'instr(upper(:P23_ALLOW_ACCESS_SCHEMAS),:F4050_P23_DEFAULT_SCHEMA) > 0 or',
'v(''P23_ALLOW_ACCESS_SCHEMAS'') is null'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Le sch\00E9ma par d\00E9faut doit figurer dans les sch\00E9mas accessibles.')
,p_validation_condition=>':REQUEST in (''CREATE'',''CREATE_ANOTHER'',''Apply_Changes'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(2691628386326712.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(480959017736120646.4052)
,p_name=>'default schema'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4050_P23_SECURITY_GROUP_ID'
,p_condition_element=>'F4050_P23_SECURITY_GROUP_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(480958907602115765.4052)
,p_event_id=>wwv_flow_api.id(480959017736120646.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4050_P23_DEFAULT_SCHEMA'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(480959329587120647.4052)
,p_event_id=>wwv_flow_api.id(480959017736120646.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4050_P23_DEFAULT_SCHEMA'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(499697614357090089.4052)
,p_name=>'Set Admin Defaults'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P23_ADMIN'
,p_condition_element=>'P23_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499697929955090089.4052)
,p_event_id=>wwv_flow_api.id(499697614357090089.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_DEVELOPER'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499698127833090090.4052)
,p_event_id=>wwv_flow_api.id(499697614357090089.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_DEVELOPER'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499830900523587430.4052)
,p_event_id=>wwv_flow_api.id(499697614357090089.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_DEVELOPER'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499921922469353484.4052)
,p_event_id=>wwv_flow_api.id(499697614357090089.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_APP_BUILDING_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499735730765104258.4052)
,p_event_id=>wwv_flow_api.id(499697614357090089.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_APP_BUILDING_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499698800636095529.4052)
,p_event_id=>wwv_flow_api.id(499697614357090089.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_APP_BUILDING_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499922306670358385.4052)
,p_event_id=>wwv_flow_api.id(499697614357090089.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499922808317377807.4052)
,p_event_id=>wwv_flow_api.id(499697614357090089.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499813118803337317.4052)
,p_event_id=>wwv_flow_api.id(499697614357090089.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499809324774320148.4052)
,p_event_id=>wwv_flow_api.id(499697614357090089.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>80
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_SQL_WORKSHOP_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499922602430376131.4052)
,p_event_id=>wwv_flow_api.id(499697614357090089.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>90
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499709507216097424.4052)
,p_event_id=>wwv_flow_api.id(499697614357090089.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>100
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_TEAM_DEVELOPMENT_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(499737110941117419.4052)
,p_name=>'Set Developer Defaults'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P23_DEVELOPER'
,p_condition_element=>'P23_DEVELOPER'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499737403632117420.4052)
,p_event_id=>wwv_flow_api.id(499737110941117419.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_APP_BUILDING_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499737619358117420.4052)
,p_event_id=>wwv_flow_api.id(499737110941117419.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_APP_BUILDING_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499738123062120991.4052)
,p_event_id=>wwv_flow_api.id(499737110941117419.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_APP_BUILDING_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499739114535127949.4052)
,p_event_id=>wwv_flow_api.id(499737110941117419.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_APP_BUILDING_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499814504735342729.4052)
,p_event_id=>wwv_flow_api.id(499737110941117419.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499818103182380057.4052)
,p_event_id=>wwv_flow_api.id(499737110941117419.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_SQL_WORKSHOP_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499815726206348925.4052)
,p_event_id=>wwv_flow_api.id(499737110941117419.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_SQL_WORKSHOP_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(499818719458384786.4052)
,p_event_id=>wwv_flow_api.id(499737110941117419.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_SQL_WORKSHOP_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(150598110355090725.4052)
,p_event_id=>wwv_flow_api.id(499737110941117419.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>80
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(150598356406090727.4052)
,p_event_id=>wwv_flow_api.id(499737110941117419.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>80
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_TEAM_DEVELOPMENT_YN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(150598244537090726.4052)
,p_event_id=>wwv_flow_api.id(499737110941117419.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>90
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_TEAM_DEVELOPMENT_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(150598427398090728.4052)
,p_event_id=>wwv_flow_api.id(499737110941117419.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>90
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_ALLOW_TEAM_DEVELOPMENT_YN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1318698319941939287.4052)
,p_name=>'Set Admin Defaults - ADW'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P23_ADMIN'
,p_condition_element=>'P23_ADMIN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'FUNCTION_BODY'
,p_display_when_cond=>'return wwv_flow_authentication_dev.get_internal_authentication = ''DB'';'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1318698735426939344.4052)
,p_event_id=>wwv_flow_api.id(1318698319941939287.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_CHANGE_PWD_ON_FIRST_USE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1318699187539939369.4052)
,p_event_id=>wwv_flow_api.id(1318698319941939287.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_CHANGE_PWD_ON_FIRST_USE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(504001616238039246.4052)
,p_name=>'Disable Disallow App Building'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P23_DISALLOW_APP_BUILDING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504001915415039251.4052)
,p_event_id=>wwv_flow_api.id(504001616238039246.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_DISALLOW_APP_BUILDING'
);
end;
/
begin
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1318699502648948371.4052)
,p_name=>'Set Developer Defaults - ADW'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P23_DEVELOPER'
,p_condition_element=>'P23_DEVELOPER'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'FUNCTION_BODY'
,p_display_when_cond=>'return wwv_flow_authentication_dev.get_internal_authentication = ''DB'';'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1318699953045948371.4052)
,p_event_id=>wwv_flow_api.id(1318699502648948371.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_CHANGE_PWD_ON_FIRST_USE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1318700465969948372.4052)
,p_event_id=>wwv_flow_api.id(1318699502648948371.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_CHANGE_PWD_ON_FIRST_USE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1318700964715948372.4052)
,p_event_id=>wwv_flow_api.id(1318699502648948371.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_CHANGE_PWD_ON_FIRST_USE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1318701487141948372.4052)
,p_event_id=>wwv_flow_api.id(1318699502648948371.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_CHANGE_PWD_ON_FIRST_USE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(504036521572475963.4052)
,p_name=>'Disable Disallow SQL Workshop'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P23_DISALLOW_SQL_WORKSHOP'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504036823683475964.4052)
,p_event_id=>wwv_flow_api.id(504036521572475963.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_DISALLOW_SQL_WORKSHOP'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(504037206466481072.4052)
,p_name=>'Disable Disallow Team Development'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P23_DISALLOW_TEAM_DEVELOPMENT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504037512684481073.4052)
,p_event_id=>wwv_flow_api.id(504037206466481072.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P23_DISALLOW_TEAM_DEVELOPMENT'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(9870827930449349.4052)
,p_name=>'Copy User name to Email'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4050_P23_USER_NAME'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'this.triggeringElement.value.match(/@/)!=null'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(9871100461449350.4052)
,p_event_id=>wwv_flow_api.id(9870827930449349.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4050_P23_EMAIL_ADDRESS'
,p_attribute_01=>'$s(''F4050_P23_EMAIL_ADDRESS'',$v(''F4050_P23_USER_NAME''));'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(43038016537866257.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch user information'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_admin_api.fetch_user (     ',
'     p_user_id         => :F4050_P23_USER_ID,     ',
'     p_user_name       => :F4050_P23_USER_NAME,',
'     p_first_name      => :F4050_P23_FIRST_NAME,',
'     p_last_name       => :F4050_P23_LAST_NAME,     ',
'     p_email_address   => :F4050_P23_EMAIL_ADDRESS,     ',
'     p_groups          => :F4050_P23_GROUPS,',
'     p_developer_role  => :F4050_P23_DEV_PRIVS,',
'     p_default_schema  => :F4050_P23_DEFAULT_SCHEMA,',
'     p_description     => :F4050_P23_DESCRIPTION,',
'     p_account_expiry     => :P23_ACCOUNT_EXPIRY,',
'     p_account_locked     => :P23_ACCOUNT_LOCKED,',
'     p_failed_access_attempts     => :P23_FAILED_ACCESS_ATTEMPTS,',
'     p_change_password_on_first_use     => :P23_CHANGE_PWD_ON_FIRST_USE, ',
'     p_first_password_use_occurred     => :P23_FIRST_PWD_USE_OCCURRED,',
'     p_security_group_id => :F4050_P23_SECURITY_GROUP_ID',
'     );',
'',
'if :F4050_P23_DEV_PRIVS is null then',
'  :P23_DEVELOPER := ''N'';',
'  :P23_ADMIN := ''N'';',
'elsif instr(:F4050_P23_DEV_PRIVS,''ADMIN'') > 0 then',
'  :P23_DEVELOPER := ''Y'';',
'  :P23_ADMIN := ''Y'';',
'else',
'  :P23_DEVELOPER := ''Y'';',
'  :P23_ADMIN := ''N'';',
'end if;',
'',
'FOR c1 IN (select ALLOW_APP_BUILDING_YN',
'           ,      ALLOW_WEBSHEET_DEV_YN',
'           ,      ALLOW_SQL_WORKSHOP_YN',
'           ,      ALLOW_TEAM_DEVELOPMENT_YN ',
'           ,      allow_access_to_schemas',
'           ,      default_date_format',
'           from wwv_flow_fnd_user',
'           where user_id = :F4050_P23_USER_ID',
'          ) LOOP',
'  :P23_ALLOW_APP_BUILDING_YN := c1.ALLOW_APP_BUILDING_YN;',
'  :P23_ALLOW_SQL_WORKSHOP_YN := c1.ALLOW_SQL_WORKSHOP_YN;',
'  :P23_ALLOW_TEAM_DEVELOPMENT_YN := c1.ALLOW_TEAM_DEVELOPMENT_YN;',
'  :P23_ALLOW_ACCESS_SCHEMAS := c1.allow_access_to_schemas;',
'  :P23_DEFAULT_DATE_FORMAT := c1.default_date_format;',
'END LOOP;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors de l''extraction de la ligne.'
,p_process_when=>'F4050_P23_USER_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(68692203366535952.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_site_account_lifetime number := ',
'    nvl(wwv_flow_platform.get_preference(''ACCOUNT_LIFETIME_DAYS''),45);',
'  l_workspace_account_lifetime number;',
'  l_account_last_updated date;',
'  l_dev_admin_expired boolean := false;',
'  l_end_user_expired boolean := false;',
'  l_found boolean := false;',
'begin',
'',
'--',
'-- account expiration notices',
'--',
'l_account_last_updated := nvl(:P23_ACCOUNT_EXPIRY, trunc(sysdate));',
'for c1 in (select ACCOUNT_LIFETIME_DAYS from WWV_FLOW_COMPANIES',
'           where provisioning_company_id = :F4050_P23_SECURITY_GROUP_ID) loop',
'  l_workspace_account_lifetime := c1.account_lifetime_days;',
'end loop;',
'',
':P23_SHOW_EXPIRE_FLAG := ''N'';',
'if :P23_DEVELOPER = ''Y'' then',
'  if l_account_last_updated + l_site_account_lifetime < sysdate then',
'    l_dev_admin_expired := true;',
'    :P23_EXPIRATION_STATUS1 := wwv_flow_lang.system_message(''EXPIRED'');',
'  else',
'    :P23_EXPIRATION_STATUS1 := wwv_flow_lang.system_message(''VALID'');',
'    :P23_SHOW_EXPIRE_FLAG := ''Y'';',
'  end if;',
'else',
'  :P23_EXPIRATION_STATUS1 := ''NA'';',
'end if;',
'',
'for c1 in (select ACCOUNT_LIFETIME_DAYS from WWV_FLOW_COMPANIES',
'           where EXPIRE_FND_USER_ACCOUNTS = ''Y''',
'           and provisioning_company_id = :F4050_P23_SECURITY_GROUP_ID) loop',
'  l_found := true;',
'  if l_account_last_updated + l_workspace_account_lifetime < sysdate then',
'    l_end_user_expired := true;',
'    :P23_EXPIRATION_STATUS2 := wwv_flow_lang.system_message(''EXPIRED'');',
'  else',
'    :P23_EXPIRATION_STATUS2 := wwv_flow_lang.system_message(''VALID'');',
'    :P23_SHOW_EXPIRE_FLAG := ''Y'';',
'  end if;',
'end loop;',
'if not l_found then',
'  :P23_EXPIRATION_STATUS2 := ''NA'';',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(384616171979738713.4052)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create DB user'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_num number;',
'begin',
'    select count(*) into l_num from sys.dba_users where username = upper(:F4050_P23_USER_NAME);',
'    ',
'    if l_num = 0 then',
'        wwv_flow_provision.create_user(',
'            p_username    => upper(:F4050_P23_USER_NAME),',
'            p_password    => :f4050_p23_web_password);',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(:REQUEST IN (''CREATE'',''CREATE_ANOTHER'') ',
'   and :P23_DEVELOPER = ''Y'' ',
'   and wwv_flow_authentication_dev.get_internal_authentication = ''DB'')',
'or',
'(:REQUEST = ''Apply_Changes'' ',
'   and :P23_DEVELOPER = ''Y'' ',
'   and wwv_flow_authentication_dev.get_internal_authentication = ''DB''',
'   and :F4050_P23_DEV_PRIVS is null)'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(182690830061736577.4052)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'cascade delete to developer privs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_admin_api.remove_user (p_user_id => :F4050_P23_USER_ID,',
'                                p_security_group_id => :F4050_P23_SECURITY_GROUP_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors de la suppression de l''utilisateur.'
,p_process_when_button_id=>wwv_flow_api.id(43033071157866237.4052)
,p_process_success_message=>unistr('Utilisateur &F4050_P23_USER_NAME. supprim\00E9.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(43038214859866258.4052)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'edit user'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_p1 varchar2(256) := v(''F4050_P23_WEB_PASSWORD'');',
'  l_p2 varchar2(256) := v(''F4050_P23_CONFIRM_PASSWD'');',
'  l_site_account_lifetime number :=',
'    nvl(wwv_flow_platform.get_preference(''ACCOUNT_LIFETIME_DAYS''),45);',
'  l_workspace_account_lifetime number;',
'  l_account_last_updated date;',
'  l_account_next_updated date;',
'  l_new_expiry date;',
'  l_developer_roles varchar2(255) := null;',
'  l_ALLOW_APP_BUILDING_YN     varchar2(1);',
'  l_ALLOW_SQL_WORKSHOP_YN  varchar2(1);',
'  l_ALLOW_WEBSHEET_DEV_YN   varchar2(1);',
'  l_ALLOW_TEAM_DEVELOPMENT_YN varchar2(1);',
'begin',
'    l_ALLOW_APP_BUILDING_YN     := v(''P23_ALLOW_APP_BUILDING_YN'');',
'    l_ALLOW_SQL_WORKSHOP_YN     := v(''P23_ALLOW_SQL_WORKSHOP_YN'');',
'    l_ALLOW_WEBSHEET_DEV_YN     := ''N'';',
'    l_ALLOW_TEAM_DEVELOPMENT_YN := v(''P23_ALLOW_TEAM_DEVELOPMENT_YN'');',
'',
'  l_account_last_updated := nvl(:P23_ACCOUNT_EXPIRY, trunc(sysdate));',
'  for c1 in (select ACCOUNT_LIFETIME_DAYS from WWV_FLOW_COMPANIES',
'           where provisioning_company_id = :F4050_P23_SECURITY_GROUP_ID) loop',
'    l_workspace_account_lifetime := nvl(c1.account_lifetime_days,l_site_account_lifetime);',
'  end loop;',
'  l_account_next_updated := trunc(sysdate) -',
'    greatest(l_workspace_account_lifetime,l_site_account_lifetime);',
'  if v(''P23_EXPIRE'') = ''N'' then',
'    l_new_expiry := l_account_last_updated;',
'  else',
'    l_new_expiry := l_account_next_updated;',
'  end if;',
'',
'  wwv_flow.update_cache_with_write(''F4050_P23_WEB_PASSWORD'',null);',
'  wwv_flow.update_cache_with_write(''F4050_P23_CONFIRM_PASSWD'',null);',
'',
'wwv_flow_admin_api.edit_user_and_group (',
'     p_user_id            => :F4050_P23_USER_ID,',
'     p_security_group_id  => :F4050_P23_SECURITY_GROUP_ID,',
'     p_user_name          => :F4050_P23_USER_NAME,',
'     p_first_name         => :F4050_P23_FIRST_NAME,',
'     p_last_name          => :F4050_P23_LAST_NAME,',
'     p_web_password       => l_p1,',
'     p_new_password       => l_p2,',
'     p_email_address      => :F4050_P23_EMAIL_ADDRESS,',
'     p_default_schema     => :F4050_P23_DEFAULT_SCHEMA,',
'     p_default_date_format => :P23_DEFAULT_DATE_FORMAT,',
'     p_allow_access_to_schemas => :P23_ALLOW_ACCESS_SCHEMAS,',
'     p_group_ids          => :F4050_P23_GROUPS,',
'     p_description        => :F4050_P23_DESCRIPTION,',
'     p_account_expiry     => l_new_expiry,',
'     p_account_locked     => :P23_ACCOUNT_LOCKED,',
'     p_failed_access_attempts => 0,',
'     p_change_password_on_first_use => nvl(:P23_CHANGE_PWD_ON_FIRST_USE,''N''),',
'     --',
'     p_allow_app_building_yn   => l_allow_app_building_yn,',
'     p_allow_sql_workshop_yn   => l_allow_sql_workshop_yn,',
'     p_allow_websheet_dev_yn   => l_allow_websheet_dev_yn,',
'     p_allow_team_development_yn => l_allow_team_development_yn );',
'  --',
'  -- Developer and Admin roles',
'  --',
'  if :P23_ADMIN = ''N'' and :P23_DEVELOPER = ''N'' then',
'    delete from wwv_flow_developers where user_id = :F4050_P23_USER_ID;',
'  else',
'    -- {Trigger on WWV_FLOW_DEVELOPERS sets all developer roles for ADMINS',
'    --  irrespective of what set here providing includes ''ADMIN''}',
'    if :P23_ADMIN = ''Y'' then',
'      l_developer_roles := ''ADMIN'';',
'    end if;',
'    if v(''P23_ALLOW_APP_BUILDING_YN'') = ''Y'' then',
'      if l_developer_roles is not null then',
'        l_developer_roles := l_developer_roles||'':'';',
'      end if;',
'      l_developer_roles := l_developer_roles||''CREATE:EDIT:HELP:MONITOR'';',
'    end if;',
'    if v(''P23_ALLOW_SQL_WORKSHOP_YN'') = ''Y'' then',
'      if l_developer_roles is not null then',
'        l_developer_roles := l_developer_roles||'':'';',
'      end if;',
'      l_developer_roles := l_developer_roles||''SQL:MONITOR:DATA_LOADER'';',
'    end if;',
'    wwv_flow_admin_api.edit_developer_role(',
'             p_id => 1,',
'             p_user_id => :F4050_P23_USER_ID,',
'             p_security_group_id => :F4050_P23_SECURITY_GROUP_ID,',
'             p_user_name => :F4050_P23_USER_NAME,',
'             p_developer_roles => l_developer_roles);',
'  end if;',
'',
'commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Erreur lors de la mise \00E0 jour de l''utilisateur.')
,p_process_when_button_id=>wwv_flow_api.id(43033257856866238.4052)
,p_process_success_message=>unistr('Utilisateur &F4050_P23_USER_NAME. mis \00E0 jour.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(190972529902954165.4052)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create user'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_ALLOW_APP_BUILDING_YN     varchar2(1);',
'  l_ALLOW_SQL_WORKSHOP_YN     varchar2(1);',
'  l_ALLOW_WEBSHEET_DEV_YN     varchar2(1);',
'  l_ALLOW_TEAM_DEVELOPMENT_YN varchar2(1);',
'  l_change_password_on_first_use varchar2(1)   := ''N'';',
'begin',
'  -- ',
'  -- Set ALLOW Values as necessary',
'  --',
'  l_ALLOW_APP_BUILDING_YN     := nvl(v(''P23_ALLOW_APP_BUILDING_YN''),''N'');',
'  l_ALLOW_WEBSHEET_DEV_YN     := ''N'';',
'  l_ALLOW_SQL_WORKSHOP_YN     := nvl(v(''P23_ALLOW_SQL_WORKSHOP_YN''),''N'');',
'  l_ALLOW_TEAM_DEVELOPMENT_YN := nvl(v(''P23_ALLOW_TEAM_DEVELOPMENT_YN''),''N'');',
' ',
'  IF :P23_ADMIN = ''Y'' THEN',
'    l_ALLOW_APP_BUILDING_YN     := ''Y'';',
'    l_ALLOW_WEBSHEET_DEV_YN     := ''Y'';',
'    l_ALLOW_SQL_WORKSHOP_YN     := ''Y'';',
'    l_ALLOW_TEAM_DEVELOPMENT_YN := ''Y'';',
'  ELSIF :P23_DEVELOPER = ''N'' THEN',
'    l_ALLOW_APP_BUILDING_YN     := ''N'';',
'    l_ALLOW_WEBSHEET_DEV_YN     := ''N'';',
'    l_ALLOW_SQL_WORKSHOP_YN     := ''N'';',
'  END IF;',
'  ',
'  if :P23_CHANGE_PWD_ON_FIRST_USE = ''Y'' then',
'    l_change_password_on_first_use := ''Y'';',
'  end if;',
'',
'wwv_flow_admin_api.create_user (    ',
'    p_security_group_id            => :F4050_P23_SECURITY_GROUP_ID,',
'    p_user_name                    => :F4050_P23_USER_NAME,',
'    p_first_name                   => :F4050_P23_FIRST_NAME,',
'    p_last_name                    => :F4050_P23_LAST_NAME,',
'    p_description                  => :F4050_P23_DESCRIPTION,',
'    p_email_address                => :F4050_P23_EMAIL_ADDRESS,',
'    p_default_schema               => :F4050_P23_DEFAULT_SCHEMA,',
'    p_default_date_format          => :P23_DEFAULT_DATE_FORMAT,',
'    p_allow_access_to_schemas      => :P23_ALLOW_ACCESS_SCHEMAS,  ',
'    p_web_password                 => :F4050_P23_WEB_PASSWORD,    ',
'    p_group_ids                    => :F4050_P23_GROUPS,',
'    p_account_expiry               => :P23_ACCOUNT_EXPIRY,              ',
'    p_account_locked               => :P23_ACCOUNT_LOCKED,              ',
'    p_failed_access_attempts       => :P23_FAILED_ACCESS_ATTEMPTS,      ',
'    p_change_password_on_first_use => l_change_password_on_first_use,',
'    p_first_password_use_occurred  => :P23_FIRST_PWD_USE_OCCURRED,',
'    --',
'    p_is_admin                     => :P23_ADMIN,',
'    p_allow_app_building_yn        => l_allow_app_building_yn,',
'    p_allow_sql_workshop_yn        => l_allow_sql_workshop_yn,',
'    p_allow_websheet_dev_yn        => l_allow_websheet_dev_yn,',
'    p_allow_team_development_yn    => l_allow_team_development_yn',
'    );',
'',
'  wwv_flow.update_cache_with_write(''F4050_P23_WEB_PASSWORD'',null);',
'',
'  commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Erreur lors de la cr\00E9ation de l''utilisateur.')
,p_process_when=>'CREATE,CREATE_ANOTHER'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>unistr('Utilisateur &F4050_P23_USER_NAME. cr\00E9\00E9.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(356667207485298761.4052)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'always developer if admin'
,p_process_sql_clob=>':P23_DEVELOPER := ''Y'';'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P23_ADMIN'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(341059407111970570.4052)
,p_process_sequence=>70
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'generate random password for SSO accounts'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_random_password boolean;',
'begin',
'    --',
'    -- if external user (who does not have to enter a password)',
'    --    and password field is null',
'    --    and either',
'    --        - create / create_another pressed',
'    --        - apply_changes pressed and user name changed',
'    --',
'    -- => create random password',
'    --',
'    if wwv_flow_authentication_dev.is_builder_password_required (',
'           p_developer_yn => :P23_DEVELOPER )',
'    then',
'        l_random_password := false;',
'    elsif :F4050_P23_WEB_PASSWORD is not null then',
'        l_random_password := false;',
'    elsif :request in (''CREATE'',''CREATE_ANOTHER'') then',
'        l_random_password := true;',
'    elsif :request = ''Apply_Changes'' then',
'        for c1 in ( select user_name',
'                      from wwv_flow_fnd_user',
'                     where user_id = :F4050_P23_USER_ID',
'                       and security_group_id = :F4050_P23_SECURITY_GROUP_ID',
'                       and user_name         <> :F4050_P23_USER_NAME )',
'        loop',
'            l_random_password := true;',
'        end loop;',
'    end if;',
'    ',
'    if l_random_password then',
'        :F4050_P23_WEB_PASSWORD   := wwv_flow_authentication_dev.create_shadow_user_password;',
'        :F4050_P23_CONFIRM_PASSWD := :F4050_P23_WEB_PASSWORD;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00024
begin
wwv_flow_api.create_page(
 p_id=>24.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Tentatives de connexion'
,p_step_title=>'Tentatives de connexion'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12733303372664460.4052)
,p_plug_name=>'Tentatives de connexion'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Cet \00E9tat pr\00E9sente les derni\00E8res connexions aux espaces de travail et aux applications. Les connexions au service &PRODUCT_NAME., les connexions des d\00E9veloppeurs aux espaces de travail et les connexions des utilisateurs finals aux applications qui uti')
||unistr('lisent l''API de connexion &PRODUCT_NAME. dans leur mod\00E8le d''authentification sont \00E9galement consign\00E9es.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472565327781535916.4052)
,p_plug_name=>'tentatives de connexion'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P24a */',
'       login_name,',
'       application,',
'       owner,',
'       decode(authentication_method,''FND_ACCOUNT'',v(''PRODUCT_NAME''),',
'        ''CUSTOM'',wwv_flow_lang.system_message(''CUSTOM_AUTH_SCHEME_DESC''),',
'        ''$SITE_INTERNAL$'',wwv_flow_lang.system_message(''SERVICE_LOGIN''),',
'        ''$WORKSPACE_INTERNAL$'',wwv_flow_lang.system_message(''WORKSPACE_LOGIN''),',
'        ''DB ACCOUNT'',wwv_flow_lang.system_message(''DBACCOUNT_AUTH_SCHEME_DESC''),',
'        ''LDAP'',wwv_flow_lang.system_message(''LDAP_AUTH_SCHEME_DESC''),',
'         authentication_method) authentication_method,',
'       access_date,',
'       access_date access_time,',
'       decode(nvl(authentication_result,0),',
'            0,wwv_flow_lang.system_message(''AUTH_SUCCESS''),',
'            1,wwv_flow_lang.system_message(''AUTH_UNKNOWN_USER''),',
'            2,wwv_flow_lang.system_message(''AUTH_ACCOUNT_LOCKED''),',
'            3,wwv_flow_lang.system_message(''AUTH_ACCOUNT_EXPIRED''),',
'            4,wwv_flow_lang.system_message(''AUTH_PASSWORD_INCORRECT''),',
'            5,wwv_flow_lang.system_message(''AUTH_PASSWORD_FIRST_USE''),',
'            6,wwv_flow_lang.system_message(''AUTH_ATTEMPTS_EXCEEDED''),',
'            7,wwv_flow_lang.system_message(''AUTH_INTERNAL_ERROR''),',
'            8,wwv_flow_lang.system_message(''AUTH_UNKNOWN_WORKSPACE''),',
'            authentication_result) authentication_result,',
'       custom_status_text,',
'       wwv_flow_security.find_company_name(security_group_id) workspace',
'  from wwv_flow_user_access_log_v'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(472565431030535916.4052)
,p_name=>'login attempts'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472565602555535921.4052)
,p_db_column_name=>'LOGIN_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nom de connexion'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472565714133535923.4052)
,p_db_column_name=>'APPLICATION'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472565827489535924.4052)
,p_db_column_name=>'OWNER'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Propri\00E9taire')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472565931549535925.4052)
,p_db_column_name=>'AUTHENTICATION_METHOD'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('M\00E9thode d''authentification')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472566027408535926.4052)
,p_db_column_name=>'ACCESS_DATE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Date d''acc\00E8s')
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472566102099535927.4052)
,p_db_column_name=>'ACCESS_TIME'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Acc\00E8s')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472566227798535928.4052)
,p_db_column_name=>'AUTHENTICATION_RESULT'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('R\00E9sultat de l''authentification')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472566308258535929.4052)
,p_db_column_name=>'CUSTOM_STATUS_TEXT'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>unistr('Statut personnalis\00E9')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472566420014535930.4052)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(982231297425899636.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(472565327781535916.4052)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:24:&SESSION.::&DEBUG.:RP,RIR,24:::'
);
end;
/
prompt --application/pages/page_00025
begin
wwv_flow_api.create_page(
 p_id=>25.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Dernier espace de travail utilis\00E9')
,p_step_title=>unistr('Dernier espace de travail utilis\00E9')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472575120602615156.4052)
,p_plug_name=>'Utilisation de l''espace de travail'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P25a */',
'    short_name,',
'    last_login,',
'    LAST_LOGIN since',
'from   WWV_FLOW_COMPANIES c ',
'where short_name <> ''Unknown''',
'  and provisioning_company_id <> 11'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_prn_output_show_link=>'Y'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(472575218581615156.4052)
,p_name=>'Workspace Usage'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472575422712615160.4052)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472575504208615161.4052)
,p_db_column_name=>'LAST_LOGIN'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Derni\00E8re session purg\00E9e')
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472575632503615162.4052)
,p_db_column_name=>'SINCE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(982231305764899637.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(472575120602615156.4052)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:25:&SESSION.::&DEBUG.:RP,RIR,25:::'
);
end;
/
prompt --application/pages/page_00026
begin
wwv_flow_api.create_page(
 p_id=>26.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Demandes d''espace de travail'
,p_step_title=>'Demandes d''espace de travail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931176750964111248)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_ser_rqst.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47544422518431589.4052)
,p_plug_name=>'Demandes de provisionnement'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P26a */',
'    id,',
'    COMPANY_NAME,',
'    schema_name,',
'    lower(ADMIN_userid),',
'    ''<a href="mailto:''||wwv_flow_escape.html(admin_email)||''">''||wwv_flow_escape.html(admin_email)||''</a>'' admin_email,',
'    DATABASE_SIZE,',
'    country,',
'    usage_type,',
'    org_name,',
'    request_date,',
'    decode(project_status,',
'            ''REQUESTED'',m_requested,',
'            ''APPROVED'',m_approved,',
'            ''ACCEPTED'',m_accepted,',
'            ''DECLINED'', m_declined,',
'            ''TERMINATED'', m_terminated)',
'            project_status,',
'    decode(project_status,',
'            ''REQUESTED'',''1'',',
'            ''APPROVED'',''2'',',
'            ''ACCEPTED'',''3'',',
'            ''DECLINED'', ''4'',',
'            ''5'')',
'            status_code,',
'    decode(project_status,',
'      ''REQUESTED'',''f?p=4050:4:''||:flow_session||''::NO::PROVISION_ID:''||id,',
'      ''APPROVED'', ''f?p=4050:7:''||:flow_session||''::NO::T_PROVISION_ID:''||id,',
'      ''ACCEPTED'',''f?p=4050:7:''||:flow_session||''::NO::T_PROVISION_ID:''||id,',
'      ''f?p=4050:7:''||:flow_session||''::NO::T_PROVISION_ID:''||id',
'      ) action,',
'    decode(project_status,',
'      ''REQUESTED'',m.f4050_provision,',
'      ''APPROVED'',m.f4050_adjust,',
'      ''ACCEPTED'',m.f4050_adjust,',
'       m.f4050_adjust',
'       ) action_label',
'from WWV_FLOW_PROVISION_COMPANY p,',
'  (select wwv_flow_lang.system_message(''F4050.ADJUST'') f4050_adjust,',
'       wwv_flow_lang.system_message(''F4050.PROVISION'') f4050_provision,',
'       wwv_flow_lang.system_message(''APPROVED'') m_approved ,',
'       wwv_flow_lang.system_message(''ACCEPTED'') m_accepted,',
'       wwv_flow_lang.system_message(''REQUESTED'') m_requested,',
'       wwv_flow_lang.system_message(''DECLINED'') m_DECLINED,',
'       wwv_flow_lang.system_message(''F4050.TERMINATED'') m_terminated',
'  from dual) m'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(47544525436431589.4052)
,p_name=>'Provisioning Requests'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47544808184431599.4052)
,p_db_column_name=>'COMPANY_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Espace de travail'
,p_column_link=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:6:F4050_P6_ID:#ID#:'
,p_column_linktext=>'#COMPANY_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47544922561431600.4052)
,p_db_column_name=>'SCHEMA_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Sch\00E9ma ')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47545013912431600.4052)
,p_db_column_name=>'LOWER(ADMIN_USERID)'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Administrateur'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47545102155431601.4052)
,p_db_column_name=>'ADMIN_EMAIL'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Courriel de l''administrateur'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47545227637431601.4052)
,p_db_column_name=>'DATABASE_SIZE'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Taille de base de donn\00E9es')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47545321456431602.4052)
,p_db_column_name=>'COUNTRY'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Pays'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(825654386458276754)
,p_rpt_show_filter_lov=>'1'
,p_security_scheme=>wwv_flow_api.id(825639761147256575)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(825539320755735502.4052)
,p_db_column_name=>'USAGE_TYPE'
,p_display_order=>17
,p_column_identifier=>'N'
,p_column_label=>'Utilisation'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(825928575701276934)
,p_rpt_show_filter_lov=>'1'
,p_security_scheme=>wwv_flow_api.id(825639761147256575)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(825539491815735503.4052)
,p_db_column_name=>'ORG_NAME'
,p_display_order=>27
,p_column_identifier=>'O'
,p_column_label=>'Organisation'
,p_column_type=>'STRING'
,p_security_scheme=>wwv_flow_api.id(825639761147256575)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47545420976431602.4052)
,p_db_column_name=>'REQUEST_DATE'
,p_display_order=>37
,p_column_identifier=>'H'
,p_column_label=>'Date de demande'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47545519532431602.4052)
,p_db_column_name=>'PROJECT_STATUS'
,p_display_order=>47
,p_column_identifier=>'I'
,p_column_label=>'Statut'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47545614820431603.4052)
,p_db_column_name=>'ACTION'
,p_display_order=>57
,p_column_identifier=>'J'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(195687823513119397.4052)
,p_db_column_name=>'STATUS_CODE'
,p_display_order=>67
,p_column_identifier=>'K'
,p_column_label=>'Code de statut'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255467506347301520.4052)
,p_db_column_name=>'ACTION_LABEL'
,p_display_order=>77
,p_column_identifier=>'L'
,p_column_label=>'Action'
,p_column_link=>'#ACTION#'
,p_column_linktext=>'#ACTION_LABEL#'
,p_column_link_attr=>'class="a-Button a-Button--primary" role="button"'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1143247153210567424.4052)
,p_db_column_name=>'ID'
,p_display_order=>87
,p_column_identifier=>'M'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168707426642147776.4052)
,p_plug_name=>'manage service requests'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(168703120343616153.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(169533626431592276.4052)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(195677710307087167.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47544422518431589.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:26,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(202781117061233804.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47544422518431589.4052)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er un espace de travail')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:27,79,72,73,74::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(357640242999810948.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47544422518431589.4052)
,p_button_name=>'CREATE_ATP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517849275695867600.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er un espace de travail')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:142:&SESSION.::&DEBUG.:142:LAST_VIEW:26'
,p_icon_css_classes=>'icon-right-chevron'
,p_required_patch=>-wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(168823031543353530.4052)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'26'
);
end;
/
prompt --application/pages/page_00027
begin
wwv_flow_api.create_page(
 p_id=>27.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Cr\00E9er un espace de travail - Identifier un espace de travail')
,p_step_title=>unistr('Cr\00E9er un espace de travail')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931243707245169747)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_create_wkspc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12052824814385644.4052)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(12048115202363924.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32847912999571331.4052)
,p_plug_name=>'reset'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>':F4050_P79_SCHEMA_PASSWORD := null;'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(51837012095286656.4052)
,p_plug_name=>unistr('Cr\00E9er &P27_WORKSPACE_TITLE.')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>20
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202717910302643127.4052)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204655309624392338.4052)
,p_plug_name=>unistr('T\00E2ches')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(202654431224384775.4052)
,p_plug_display_sequence=>60
,p_list_id=>wwv_flow_api.id(204654810731392335.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(15441414872198826.4052)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752110175246695866.4052)
,p_plug_name=>unistr('Cr\00E9er un espace de travail')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(51838114075301402.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(202717910302643127.4052)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(12005721821568003.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(202717910302643127.4052)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suivant '
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(12006017199568012.4052)
,p_branch_action=>'79'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(12005721821568003.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(56575929733626519.4052)
,p_branch_action=>'27'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(51839319663316706.4052)
,p_name=>'F4050_P27_COMPANY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(51837012095286656.4052)
,p_prompt=>'Nom de l''espace de travail'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Saisissez le nom de l''espace de travail. Un espace de travail est une zone de travail partag\00E9e dans laquelle plusieurs d\00E9veloppeurs peuvent cr\00E9er des applications.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(52809911597500660.4052)
,p_name=>'F4050_P27_PROJDESC'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(51837012095286656.4052)
,p_prompt=>'Description de l''espace de travail'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>50
,p_cMaxlength=>32767
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Saisissez la description de cet espace de travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(102040200715981237.4052)
,p_name=>'F4050_P27_SECURITY_GROUP_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(51837012095286656.4052)
,p_prompt=>'ID d''espace de travail'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('N''indiquez pas l''ID d''espace de travail pour que le nouvel ID d''espace de travail soit automatiquement g\00E9n\00E9r\00E9. Cet ID doit \00EAtre un entier positif sup\00E9rieur \00E0 100 000.'),
'<br /><br />',
unistr('G\00E9n\00E9ralement, vous n''indiquez l''ID d''espace de travail que si vous souhaitez qu''un espace de travail ait le m\00EAme ID dans au moins deux instances &PRODUCT_NAME.. Indiquer l''ID d''espace de travail lors de la cr\00E9ation manuelle d''un espace de travail n''e')
||unistr('st pas une op\00E9ration courante.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'100000'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1140167911817840047.4052)
,p_name=>'P27_WORKSPACE_TITLE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(51837012095286656.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1140210524284843727.4052)
,p_computation_sequence=>10
,p_computation_item=>'P27_WORKSPACE_TITLE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_lang.system_message(''WORKSPACE_INIT_CAP'');'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(175961730770991651.4052)
,p_validation_name=>'F4050_P27_COMPANY Not Null'
,p_validation_sequence=>10
,p_validation=>'F4050_P27_COMPANY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('L''espace de travail doit \00EAtre indiqu\00E9.')
,p_associated_item=>wwv_flow_api.id(51839319663316706.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 15-FEB-2002 13:56'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(13103125946032313.4052)
,p_validation_name=>'security group id not exists'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_companies',
' where provisioning_company_id = :F4050_P27_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('L''ID d''espace de travail existe d\00E9j\00E0.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_num number;',
'begin',
'  l_num := to_number(nvl(:F4050_P27_SECURITY_GROUP_ID,''1''));',
'  return true;',
'exception when others then',
'  return false;',
'end;'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'FUNCTION_BODY'
,p_when_button_pressed=>wwv_flow_api.id(12005721821568003.4052)
,p_associated_item=>wwv_flow_api.id(102040200715981237.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(72385310766234746.4052)
,p_validation_name=>'reserved company name'
,p_validation_sequence=>30
,p_validation=>'nvl(upper(:F4050_P27_COMPANY),''x'') not in (''INTERNAL'',''UNKNOWN'',''CSS'',''JAVASCRIPT'',''THEMES'',''TUTORIAL'',''XML'',''DOC'',''DP'',''TEMPLATES'')'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Workspace est un nom r\00E9serv\00E9 ; la demande est refus\00E9e.')
,p_associated_item=>wwv_flow_api.id(51839319663316706.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(14411726317427900.4052)
,p_validation_name=>'company already exists or requested'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select null',
'             from wwv_flow_provision_company',
'            where company_name = upper(:F4050_P27_COMPANY)',
'  ) loop',
'  return false;',
'  exit;',
'end loop;',
'for c1 in (select null',
'             from wwv_flow_companies',
'            where short_name = upper(:F4050_P27_COMPANY) ) loop',
'   return false;',
'   exit;',
'end loop;',
'',
'if not nvl(length(trim(:F4050_P27_COMPANY)),0) > 0 then',
'  return false;',
'end if;',
'',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Le nom d''espace de travail existe d\00E9j\00E0.')
,p_validation_condition=>'F4050_P27_COMPANY'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(12005721821568003.4052)
,p_associated_item=>wwv_flow_api.id(51839319663316706.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(111441226211952153.4052)
,p_validation_name=>'Invalid characters in workspace name'
,p_validation_sequence=>50
,p_validation=>'F4050_P27_COMPANY'
,p_validation2=>'<>'
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>'Nom d''espace de travail non valide.'
,p_when_button_pressed=>wwv_flow_api.id(12005721821568003.4052)
,p_associated_item=>wwv_flow_api.id(51839319663316706.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(505004404683036318.4052)
,p_validation_name=>'F4050_P27_SECURITY_GROUP_ID'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if abs(trunc(:F4050_P27_SECURITY_GROUP_ID)) = :F4050_P27_SECURITY_GROUP_ID then',
'        return TRUE;',
'    else',
'        return FALSE;',
'    end if;',
'exception when others then',
'    return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('L''ID d''espace de travail doit \00EAtre un entier positif sup\00E9rieur \00E0 100 000.')
,p_validation_condition=>'F4050_P27_SECURITY_GROUP_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(12005721821568003.4052)
,p_associated_item=>wwv_flow_api.id(102040200715981237.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00028
begin
wwv_flow_api.create_page(
 p_id=>28.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Demandes de modification'
,p_step_title=>'Demandes de modification'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931176750964111248)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_chg_rqst.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47550321334827183.4052)
,p_plug_name=>'Demandes de modification'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P28a */',
'        c.short_name           workspace,',
'        m.service_name        requested_change,',
'        m.service_attribute_1 value,',
'        m.requested_on        request_date,',
'        m.requested_by        requested_by,',
'       decode(m.request_status,',
'            ''REQUESTED'',m_requested,',
'            ''APPROVED'',m_approved,',
'            ''ACCEPTED'',m_accepted,',
'            ''DECLINED'',m_DECLINED,',
'            m.request_status)',
'            project_status,',
'       decode(m.request_status,',
'            ''REQUESTED'',''1'',',
'            ''APPROVED'',''2'',',
'            ''ACCEPTED'',''3'',',
'            ''DECLINED'',''4'',',
'            ''5'')',
'            status_code,',
'        request_status,',
'        decode(m.request_status,',
'          ''REQUESTED'',sm.f4050_request,',
'          ''APPROVED'',sm.f4050_request,',
'          ''DECLINED'',sm.f4050_request,',
'          '''') ',
'         action,',
'        decode(m.request_status,',
'          ''REQUESTED'',''f?p=4050:110:''||:flow_session||''::NO:110:P110_REQUEST_ID,P110_SGID:''||m.id||'',''||m.security_group_id,',
'          ''APPROVED'',''f?p=4050:110:''||:flow_session||''::NO:110,RP:P110_REQUEST_ID,P110_SGID:''||m.id||'',''||m.security_group_id,',
'          ''DECLINED'',''f?p=4050:110:''||:flow_session||''::NO:110,RP:P110_REQUEST_ID,P110_SGID:''||m.id||'',''||m.security_group_id,',
'          ''#'') ',
'         action_url',
'    from wwv_flow_provision_serice_mod m, ',
'         wwv_flow_companies c,',
'         (select wwv_flow_lang.system_message(''F4050.NO_ACTION'') f4050_action,',
'                 wwv_flow_lang.system_message(''F4050.VIEW_REQUEST'') f4050_request,',
'                 wwv_flow_lang.system_message(''REQUESTED'') m_requested,',
'                 wwv_flow_lang.system_message(''APPROVED'') m_approved,',
'                 wwv_flow_lang.system_message(''ACCEPTED'') m_accepted,',
'                 wwv_flow_lang.system_message(''DECLINED'') m_DECLINED',
'          from dual) sm',
'   where m.security_group_id = c.provisioning_company_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(47550429366827183.4052)
,p_name=>'Change Requests'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47550607307827218.4052)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47550727309827219.4052)
,p_db_column_name=>'REQUESTED_CHANGE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Modification demand\00E9e')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(110368323210290856)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47550822950827219.4052)
,p_db_column_name=>'VALUE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Valeur'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47550913112827220.4052)
,p_db_column_name=>'REQUEST_DATE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47551009969827221.4052)
,p_db_column_name=>'REQUESTED_BY'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Demand\00E9 par')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47551128912827222.4052)
,p_db_column_name=>'REQUEST_STATUS'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Statut'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(195675721688062095.4052)
,p_db_column_name=>'PROJECT_STATUS'
,p_display_order=>7
,p_column_identifier=>'H'
,p_column_label=>'Statut'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47551326543834614.4052)
,p_db_column_name=>'ACTION'
,p_display_order=>8
,p_column_identifier=>'G'
,p_column_label=>'Action'
,p_column_link=>'#ACTION_URL#'
,p_column_linktext=>'<span>#ACTION#</span>'
,p_column_link_attr=>'class="a-Button a-Button--primary" role="button"'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(195688928146130168.4052)
,p_db_column_name=>'STATUS_CODE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Code de statut'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(256232203074880367.4052)
,p_db_column_name=>'ACTION_URL'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'URL d''action'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(59534981464167587.4052)
,p_plug_name=>'Demandes de modification'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Cette page r\00E9pertorie les demandes de modification de services existants. Pour revoir une demande, cliquez sur <strong>Voir une demande</strong>. Cliquez sur l''action pour l''espace de travail que vous voulez traiter. Les actions pour lesquelles est i')
||unistr('ndiqu\00E9 <strong>Aucune action</strong> sont termin\00E9es, il n''y a plus rien \00E0 faire.')
,p_plug_query_row_template=>wwv_flow_api.id(81008210556197147.4052)
,p_plug_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'blue_arrow_down.gif::blue_arrow_up.gif:|2,3\1,9|',
'',
'&nbsp;:',
'',
'<font class="nounderline" color="black">Company</font>:',
'',
'<font class="nounderline" color="black">Schema</font>:',
'',
'<font class="nounderline" color="black">AdminUserID</font>:',
'',
'<font class="nounderline" color="black">Email</font>:',
'',
'<font class="nounderline" color="black">DBsize</font>:',
'',
'<font class="nounderline" color="black">Requested</font>:',
'',
'<font class="nounderline" color="black">Status</font>:',
'',
'<font class="nounderline" color="black">Action</font>'))
,p_plug_query_num_rows=>25
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_no_data_found=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_plug_query_show_nulls_as=>'-'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168706908287142461.4052)
,p_plug_name=>'manage service requests'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(168703120343616153.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(169533626431592276.4052)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(195681908360096073.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47550321334827183.4052)
,p_button_name=>'reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.:28,RIR::'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(168822021023341018.4052)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'28'
);
end;
/
prompt --application/pages/page_00029
begin
wwv_flow_api.create_page(
 p_id=>29.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Surveiller l''activit\00E9')
,p_step_title=>unistr('Surveiller l''activit\00E9')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14723216460004096.4052)
,p_plug_name=>'Etats sur le calendrier'
,p_icon_css_classes=>'icon-util-calendar-reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--paddedBody:h320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(966388705490342505.4052)
,p_plug_display_sequence=>90
,p_plug_grid_column_span=>4
,p_list_id=>wwv_flow_api.id(14738731575074699.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
,p_plug_column_width=>'apex-col--rightBorder  apex-col--bottomBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14755429806121434.4052)
,p_plug_name=>unistr('Activit\00E9s de d\00E9veloppeur')
,p_icon_css_classes=>'icon-util-developer-activity'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--paddedBody:h320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(966388705490342505.4052)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_grid_column_span=>4
,p_list_id=>wwv_flow_api.id(206097723808588940.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
,p_plug_column_width=>'apex-col--rightBorder  apex-col--bottomBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(49038908699379385.4052)
,p_plug_name=>'Tentatives de connexion'
,p_icon_css_classes=>'icon-util-login-attempts'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(966388705490342505.4052)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(49036204543378170.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(82696814914931381.4052)
,p_plug_name=>'Vues de page'
,p_icon_css_classes=>'icon-util-page-views'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(966388705490342505.4052)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_api.id(159973015345793688.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--rightBorder '
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(130807619772581428.4052)
,p_plug_name=>'Demandes de service'
,p_icon_css_classes=>'icon-util-manage-dynamic-translation'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(966388705490342505.4052)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(130557109467559465.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--rightBorder '
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(179853623006946463.4052)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Les liens de cette page permettent d''afficher divers \00E9tats sur les activit\00E9s d''application, de d\00E9veloppeur et de session pour tous les espaces de travail.</p>'),
'<p><a target="_blank" href="&SYSTEM_HELP_URL./aeadm/monitoring-activity-across-a-development-instance.html">En savoir plus...</a></p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(206100700867601271.4052)
,p_plug_name=>'Etats d''environnement'
,p_icon_css_classes=>'icon-util-environment-reports'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(966388705490342505.4052)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(14750409028115431.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--rightBorder '
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(505825804390240661.4052)
,p_plug_name=>'Purge de l''espace de travail'
,p_icon_css_classes=>'icon-util-purge-sessions-age'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(966388705490342505.4052)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(505826028978247783.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(619444920398900055.4052)
,p_plug_name=>'Journaux'
,p_icon_css_classes=>'icon-util-logs'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(966388705490342505.4052)
,p_plug_display_sequence=>60
,p_list_id=>wwv_flow_api.id(619447801744923075.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--rightBorder '
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(880587954287852291.4052)
,p_plug_name=>unistr('R\00E9capitulatif de l''activit\00E9')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>1
,p_list_id=>wwv_flow_api.id(880586104026852286.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(517410251255325302.4052)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1066580874943368101.4052)
,p_plug_name=>unistr('Activit\00E9 archiv\00E9e')
,p_icon_css_classes=>'icon-database-object'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--paddedBody:h320'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(966388705490342505.4052)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(201292222959269624.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(517410627877325303.4052)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1066581069870368105.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1066580874943368101.4052)
,p_button_name=>'ARCHIVE_ACTIVITY_LOG'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('Journal des activit\00E9s d''archivage')
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:34:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(162276418488133798.4052)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'29'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00030
begin
wwv_flow_api.create_page(
 p_id=>30.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Activit\00E9s par vue de page')
,p_step_title=>unistr('Activit\00E9s par vue de page')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1144801668849676.4052)
,p_plug_name=>unistr('Derni\00E8res vues de page')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P30a */',
' security_group_id,',
' time_stamp page_view,',
' time_stamp t2,',
' lower(l.userid) userid,',
' lower(c.short_name) company,',
' elap,',
' num_rows,',
' l.flow_id,',
' content_length,',
' (select name ',
'  from wwv_flows ',
'  where id = l.flow_id) application_name,',
' step_id page_id,',
' (select name ',
'  from wwv_flow_steps ',
'  where flow_id = l.flow_id and id=l.step_id) page_name,',
' cached_regions,',
' decode(page_mode,',
'        ''A'',m.m_PAGE_PROCESSING,',
'        ''C'',m.m_CACHE_CREATED,',
'        ''D'',m.m_DYNAMIC,',
'        ''P'',m.m_PARTIAL_PAGE, ',
'        ''R'',m.m_CACHED,',
'        page_mode) page_mode,',
' sqlerrm,',
' websheet_id,',
' decode(l.flow_id,4900,(select name from wwv_flow_ws_applications where id = l.websheet_id),null) websheet_name,',
' page_view_type,',
' request_value,',
' debug_page_view_id',
' from (',
'select ',
' security_group_id,',
' time_stamp,',
' userid,',
' elap,',
' num_rows,',
' cached_regions,',
' flow_id,',
' step_id,',
' page_mode,',
' sqlerrm,',
' websheet_id,',
' content_length,',
' page_view_type,',
' request_value,',
' debug_page_view_id',
'from   #OWNER#.wwv_flow_activity_log',
'where time_stamp > (sysdate - :P30_SINCE)',
'order  by time_stamp desc) l,',
'wwv_flow_companies c,',
'   (select wwv_flow_lang.system_message(''PAGE_PROCESSING'') m_PAGE_PROCESSING,',
'           wwv_flow_lang.system_message(''CACHE_CREATED'') m_CACHE_CREATED,',
'           wwv_flow_lang.system_message(''F4000.DYNAMIC'') m_DYNAMIC,',
'           wwv_flow_lang.system_message(''PARTIAL_PAGE'') m_PARTIAL_PAGE,',
'           wwv_flow_lang.system_message(''CACHED'') m_CACHED',
'    from dual) m',
'where security_group_id = provisioning_company_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P30_SINCE'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1144928525849676.4052)
,p_name=>'Recent Page Views'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1145108267849684.4052)
,p_db_column_name=>'PAGE_VIEW'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Date'
,p_column_type=>'DATE'
,p_format_mask=>'Dy &DATE_TIME_FORMAT.'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1145203039849685.4052)
,p_db_column_name=>'T2'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Heure'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1145307063849685.4052)
,p_db_column_name=>'USERID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Utilisateur'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1145411401849685.4052)
,p_db_column_name=>'COMPANY'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1145720209849685.4052)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>5
,p_column_identifier=>'G'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1145828697849686.4052)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>6
,p_column_identifier=>'H'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1145611705849685.4052)
,p_db_column_name=>'ELAP'
,p_display_order=>8
,p_column_identifier=>'F'
,p_column_label=>unistr('Ecoul\00E9')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1145930736849686.4052)
,p_db_column_name=>'CACHED_REGIONS'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>unistr('R\00E9gions en m\00E9moire cache')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1146029978849686.4052)
,p_db_column_name=>'PAGE_MODE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Mode page'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1149606738876853.4052)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Nom d''application'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1151320029890154.4052)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Nom de page'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201520806846077646.4052)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Contenu'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(473017014819476725.4052)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>unistr('Espace de travail s\00E9lectionn\00E9')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(499004912497329769.4052)
,p_db_column_name=>'WEBSHEET_ID'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'ID de feuille Web'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_security_scheme=>wwv_flow_api.id(610289739776900562)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(499005025566329772.4052)
,p_db_column_name=>'WEBSHEET_NAME'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Feuille Web'
,p_column_type=>'STRING'
,p_security_scheme=>wwv_flow_api.id(610289739776900562)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1475460660459625311.4052)
,p_db_column_name=>'PAGE_VIEW_TYPE'
,p_display_order=>27
,p_column_identifier=>'R'
,p_column_label=>'Type de vue de page'
,p_column_type=>'NUMBER'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(1582102292640264559)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1475460717902625312.4052)
,p_db_column_name=>'REQUEST_VALUE'
,p_display_order=>37
,p_column_identifier=>'S'
,p_column_label=>'Valeur de demande'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1475460887017625313.4052)
,p_db_column_name=>'DEBUG_PAGE_VIEW_ID'
,p_display_order=>47
,p_column_identifier=>'T'
,p_column_label=>unistr('ID de d\00E9bogage')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1475460953195625314.4052)
,p_db_column_name=>'NUM_ROWS'
,p_display_order=>57
,p_column_identifier=>'U'
,p_column_label=>'Interroger des lignes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1475461081382625315.4052)
,p_db_column_name=>'SQLERRM'
,p_display_order=>67
,p_column_identifier=>'V'
,p_column_label=>'Message d''erreur'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(190796222078501880.4052)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_header=>'<h1>'
,p_plug_footer=>'</h1>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(59665949535463099.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(190796222078501880.4052)
,p_button_name=>'F4050_P30_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('D\00E9finir')
,p_button_alignment=>'LEFT'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(192026400173820140.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(190796222078501880.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.:30,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47128703206222148.4052)
,p_name=>'P30_SINCE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(190796222078501880.4052)
,p_item_default=>'1'
,p_prompt=>'Depuis'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Limitez l''\00E9tat \00E0 une tranche de temps sp\00E9cifique. Indiquez la quantit\00E9 de temps \00E0 inclure dans l''\00E9tat et cliquez sur <strong>D\00E9finir</strong>.<p />'),
unistr('Si vous s\00E9lectionnez 1 jour, seules les derni\00E8res 24 heures s''affichent.  ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00031
begin
wwv_flow_api.create_page(
 p_id=>31.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Journal de connexions \00E0 Access')
,p_step_title=>unistr('Journal de connexions \00E0 Access')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216783731365642767)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>'AEADM/adm_logs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15366007090981094.4052)
,p_plug_name=>unistr('Entr\00E9es du journal de connexions \00E0 Access')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829706609080810173.4052)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   c_dev pls_integer := 0;',
'',
'begin',
'--   sys.htp.p(''<table class="instructiontext" role="presentation">'');',
'   select count(*) into c_dev from wwv_flow_user_access_log_v;',
'   sys.htp.p(''<p>''||wwv_flow_lang.system_message(''4050_31_LOG_COUNT'')||'': '');',
'   sys.htp.p(to_char(c_dev,''999,999,999,990'')||''</p>'');',
'/*',
'   sys.htp.p(''<tr><td>''||wwv_flow_lang.system_message(''4050_31_LOG_COUNT'')||''</td><td align="right">'');',
'   sys.htp.p(to_char(c_dev,''999,999,999,990''));',
'   sys.htp.p(''</td><td><br /></td></tr>'');',
'   sys.htp.p(''</table>'');',
'*/',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(982231408806899638.4052)
,p_plug_name=>'Boutons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15367111801981107.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(982231408806899638.4052)
,p_button_name=>'DELETE_ENTRIES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Supprimer des entr\00E9es')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15366901763981105.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(982231408806899638.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(15368103316981118.4052)
,p_branch_action=>'31'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(15367111801981107.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15367328334981108.4052)
,p_name=>'P31_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(15366007090981094.4052)
,p_prompt=>unistr('Supprimer les entr\00E9es datant du nombre de jours suivant ou plus :')
,p_source=>'31'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIME_INTERVALS'
,p_lov=>'.'||wwv_flow_api.id(87720511660244788.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Purgez les entr\00E9es d\00E9passant ce nombre de jours.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15367807877981115.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete rows'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_user_access_log1$',
'where access_date < (sysdate - nvl(:p31_time,31));',
'delete from wwv_flow_user_access_log2$',
'where access_date < (sysdate - nvl(:p31_time,31));'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Erreur lors de la purge du journal de connexions \00E0 Access.')
,p_process_when_button_id=>wwv_flow_api.id(15367111801981107.4052)
,p_process_success_message=>unistr('Journal de connexions \00E0 Access purg\00E9.')
);
end;
/
prompt --application/pages/page_00032
begin
wwv_flow_api.create_page(
 p_id=>32.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Activit\00E9 par espace de travail')
,p_step_title=>unistr('Activit\00E9 par espace de travail')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(758054002774278408.4052)
,p_plug_name=>'Button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1081290709913302621.4052)
,p_plug_name=>unistr('Activit\00E9 par espace de travail')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    --WORKSPACE_ID workspace,',
'    max(LOG_DAY) last_day,',
'    min(LOG_DAY) min_day,',
'    nvl(workspace_name, ''- Removed Workspaces -'') as workspace_name,',
'    count(distinct APPLICATION_ID) applications,',
'    sum(page_events) PAGE_EVENTS,',
'    sum(page_views) PAGE_VIEWS,',
'    sum(page_accepts) PAGE_ACCEPTS,',
'    sum(partial_page_views) PARTIAL_PAGE_VIEWS,',
'    sum(websheet_views) WEBSHEET_VIEWS,',
'    sum(rows_fetched) ROWS_FETCHED,',
'    sum(ir_searches) IR_SEARCHES,',
'    sum(distinct_pages) DISTINCT_PAGES,',
'    sum(distinct_users) DISTINCT_USERS,',
'    sum(distinct_sessions) DISTINCT_SESSIONS,',
'    sum(total_render_time) TOTAL_RENDER_TIME,',
'    sum(error_count) ERROR_COUNT,',
'    sum(nvl(content_length,0)) content_length,',
'    sum(public_page_events) public_page_events',
'from WWV_FLOW_LOG_HISTORY_V',
'where log_day >= sysdate-NVL(:P32_SINCE,365)',
'group by workspace_name'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1081290886190302628.4052)
,p_name=>'Activity by Day'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1081290886190302628
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(879918052750689306.4052)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(879918453481689307.4052)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Ev\00E9nements de page')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(879924498725689317.4052)
,p_db_column_name=>'PUBLIC_PAGE_EVENTS'
,p_display_order=>15
,p_column_identifier=>'T'
,p_column_label=>unistr('Ev\00E9nements de page publique')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(879918882121689311.4052)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>25
,p_column_identifier=>'F'
,p_column_label=>'Vues de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(879919255306689311.4052)
,p_db_column_name=>'PAGE_ACCEPTS'
,p_display_order=>35
,p_column_identifier=>'G'
,p_column_label=>'Envois de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(879919621539689312.4052)
,p_db_column_name=>'PARTIAL_PAGE_VIEWS'
,p_display_order=>45
,p_column_identifier=>'H'
,p_column_label=>'Vues de page partielle'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(879920048075689312.4052)
,p_db_column_name=>'WEBSHEET_VIEWS'
,p_display_order=>55
,p_column_identifier=>'I'
,p_column_label=>'Vues de feuille Web'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_security_scheme=>wwv_flow_api.id(610289739776900562)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(879920450211689313.4052)
,p_db_column_name=>'ROWS_FETCHED'
,p_display_order=>65
,p_column_identifier=>'J'
,p_column_label=>'Lignes extraites'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(879920814584689313.4052)
,p_db_column_name=>'IR_SEARCHES'
,p_display_order=>75
,p_column_identifier=>'K'
,p_column_label=>unistr('Recherches d''\00E9tat interactif')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(879921212650689314.4052)
,p_db_column_name=>'DISTINCT_PAGES'
,p_display_order=>85
,p_column_identifier=>'L'
,p_column_label=>'Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(879921655636689315.4052)
,p_db_column_name=>'DISTINCT_USERS'
,p_display_order=>95
,p_column_identifier=>'M'
,p_column_label=>'Utilisateurs'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(879922016471689315.4052)
,p_db_column_name=>'DISTINCT_SESSIONS'
,p_display_order=>105
,p_column_identifier=>'N'
,p_column_label=>'Sessions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(879922424269689315.4052)
,p_db_column_name=>'TOTAL_RENDER_TIME'
,p_display_order=>115
,p_column_identifier=>'O'
,p_column_label=>'Temps d''affichage total'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(879922805299689316.4052)
,p_db_column_name=>'ERROR_COUNT'
,p_display_order=>125
,p_column_identifier=>'P'
,p_column_label=>'Erreurs'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(879923255906689316.4052)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>135
,p_column_identifier=>'Q'
,p_column_label=>'Contenu'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(879924062356689317.4052)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>155
,p_column_identifier=>'S'
,p_column_label=>'Nom de l''espace de travail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(758053744109278405.4052)
,p_db_column_name=>'LAST_DAY'
,p_display_order=>165
,p_column_identifier=>'U'
,p_column_label=>'Dernier jour'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(758053867239278406.4052)
,p_db_column_name=>'MIN_DAY'
,p_display_order=>175
,p_column_identifier=>'V'
,p_column_label=>'Jour min.'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(758054454402278412.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(758054002774278408.4052)
,p_button_name=>'Set'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('D\00E9finir')
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(879925217543689326.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1081290709913302621.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:32:&SESSION.::&DEBUG.:80,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(758053904365278407.4052)
,p_name=>'P32_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(758054002774278408.4052)
,p_item_default=>'365'
,p_prompt=>'Depuis'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME_ARCHIVE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 30 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 186 t from dual union all',
'select ''9 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 279 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00033
begin
wwv_flow_api.create_page(
 p_id=>33.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Vues de page par espace de travail'
,p_step_title=>'Vues de page par espace de travail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(61103509800592682.4052)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(192031217790858683.4052)
,p_plug_name=>unistr('Ev\00E9nements de page par espace de travail')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_views as (',
'select /* APEX 4050P33a */ count(*) tv ',
'from WWV_FLOW_ACTIVITY_LOG ',
' where time_stamp>=(select sysdate - to_number(:P33_DAYS) from dual) )',
'select c.short_name workspace, ',
'       count(*) page_views, ',
'       sum(elap) elapsed, ',
'       count(distinct ip_address) ip_addresses, ',
'       sum(num_rows) report_rows, ',
'       100*count(*)/max(tv) pct, ',
'       round(100*count(*)/max(tv)) graph,',
'       sum(nvl(content_length,0)) content_length',
'from WWV_FLOW_ACTIVITY_LOG l, ',
'     wwv_flow_companies c, total_views',
'where l.security_group_id = c.provisioning_company_id(+)',
'--and l.page_mode != ''A''',
'and l.time_stamp>=(select sysdate - to_number(',
':P33_DAYS) x from dual ) ',
'group by c.short_name'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P33_DAYS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(192031320627858683.4052)
,p_name=>'Page Views by Workspace'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192031514692858685.4052)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192031600401858687.4052)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Vues de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192032016190858690.4052)
,p_db_column_name=>'PCT'
,p_display_order=>3
,p_column_identifier=>'F'
,p_column_label=>'Pourcentage'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192032125647858690.4052)
,p_db_column_name=>'GRAPH'
,p_display_order=>4
,p_column_identifier=>'G'
,p_column_label=>'Pourcentage de vue de page'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:300'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192031720928858687.4052)
,p_db_column_name=>'ELAPSED'
,p_display_order=>5
,p_column_identifier=>'C'
,p_column_label=>unistr('Temps \00E9coul\00E9')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192031803217858688.4052)
,p_db_column_name=>'IP_ADDRESSES'
,p_display_order=>6
,p_column_identifier=>'D'
,p_column_label=>'Adresses IP'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192031927191858689.4052)
,p_db_column_name=>'REPORT_ROWS'
,p_display_order=>7
,p_column_identifier=>'E'
,p_column_label=>unistr('Lignes d''\00E9tat')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(200561403147891384.4052)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Contenu'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(61106528978607676.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(61103509800592682.4052)
,p_button_name=>'P33_GO'
,p_button_static_id=>'P33_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('D\00E9finir')
,p_button_alignment=>'LEFT'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(192030908878851071.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(61103509800592682.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.:33,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(61104914087603350.4052)
,p_name=>'P33_DAYS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(61103509800592682.4052)
,p_item_default=>'to_number(.000694444)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Inclure'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Limitez l''\00E9tat \00E0 une tranche de temps sp\00E9cifique. Indiquez la quantit\00E9 de temps \00E0 inclure dans l''\00E9tat et cliquez sur <strong>D\00E9finir</strong>.<p />'),
unistr('Si vous s\00E9lectionnez 1 jour, seules les derni\00E8res 24 heures s''affichent.  ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(276626302334689749.4052)
,p_computation_sequence=>10
,p_computation_item=>'P33_DAYS'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return to_number(:P33_DAYS);',
'exception',
'    when others then',
'        return to_number(.000694444);',
'end;        '))
);
end;
/
prompt --application/pages/page_00034
begin
wwv_flow_api.create_page(
 p_id=>34.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Journal des activit\00E9s d''archivage')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Journal des activit\00E9s d''archivage')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931176884177111905)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'300'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(982231502665899639.4052)
,p_plug_name=>'Boutons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(2024852435896481301.4052)
,p_name=>unistr('Activit\00E9 d''archivage')
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select max(log_day) d,',
'       count(distinct(log_day)) c,',
'       count(distinct workspace_id) w',
'  from wwv_flow_log_history'))
,p_header=>unistr('<p>Ce processus prendra le journal des activit\00E9s &PRODUCT_NAME., le r\00E9capitulera et \00E9crira les r\00E9sultats dans le journal des activit\00E9s archiv\00E9es.  </p>')
,p_lazy_loading=>false
,p_query_row_template=>2
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2024852704122481304.4052)
,p_query_column_id=>1
,p_column_alias=>'D'
,p_column_display_sequence=>1
,p_column_heading=>'Date du dernier archivage :'
,p_use_as_row_header=>'N'
,p_column_format=>'&LONG_DATE_FORMAT.'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2024852684404481303.4052)
,p_query_column_id=>2
,p_column_alias=>'C'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre de jours d''archivage :'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2024852595428481302.4052)
,p_query_column_id=>3
,p_column_alias=>'W'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre d''espaces de travail :'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(162275803752126514.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(982231502665899639.4052)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('R\00E9capitulatif des activit\00E9s d''archivage')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(162275625976126513.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(982231502665899639.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(162274914763113875.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'archive activity summary'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'  select PROVISIONING_COMPANY_ID',
'  from WWV_FLOW_COMPANIES) loop',
'wwv_flow_admin_api.archive_activity_log (',
'   p_workspace_id  => c1.PROVISIONING_COMPANY_ID);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Erreur lors de l''archivage du journal des activit\00E9s.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(162275803752126514.4052)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(982231774544899641.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Modal'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Journal des activit\00E9s archiv\00E9.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(982231615649899640.4052)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Cancel Modal'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(162275625976126513.4052)
);
end;
/
prompt --application/pages/page_00035
begin
wwv_flow_api.create_page(
 p_id=>35.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Derni\00E8re connexion de d\00E9veloppeur')
,p_step_title=>unistr('Derni\00E8re connexion de d\00E9veloppeur')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472578008272666412.4052)
,p_plug_name=>unistr('Derni\00E8re connexion de d\00E9veloppeur')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX 4050P35a */ ',
'         u.USER_NAME, u.EMAIL_ADDRESS, u.LAST_LOGIN, u.LAST_IP, u.LAST_AGENT, w.short_name',
'from  WWV_FLOW_FND_USER u,',
'         WWV_FLOW_COMPANIES w',
'where u.security_group_id = w.PROVISIONING_COMPANY_ID',
'  and u.last_login is not null'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(472578115032666412.4052)
,p_name=>'Developer Last Login'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472578800631666423.4052)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>1
,p_column_identifier=>'F'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472578327281666418.4052)
,p_db_column_name=>'USER_NAME'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Utilisateur'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472578417746666419.4052)
,p_db_column_name=>'EMAIL_ADDRESS'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Courriel'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472578530500666420.4052)
,p_db_column_name=>'LAST_LOGIN'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Connexion'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472578618711666421.4052)
,p_db_column_name=>'LAST_IP'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Adresse IP'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472578707789666422.4052)
,p_db_column_name=>'LAST_AGENT'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Agent'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(982231807874899642.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(472578008272666412.4052)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:35:&SESSION.::&DEBUG.:RP,RIR,35:::'
);
end;
/
prompt --application/pages/page_00036
begin
wwv_flow_api.create_page(
 p_id=>36.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Vues de page par espace de travail et utilisateur'
,p_step_title=>'Vues de page par espace de travail et utilisateur'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29699608010437593.4052)
,p_plug_name=>'Vues de page par utilisateur'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with messages as (',
'select /* APEX 4050P36a */ wwv_flow_lang.system_message(''AUTH.LOGIN_PAGE'') login_page,',
'wwv_flow_lang.system_message(''UNAUTHENTICATED_USER'') unauth_user,',
'(select count(*) tv',
'from wwv_flow_activity_log l',
'where l.time_stamp>=(select sysdate - to_number(',
':F4050_P36_DAYS) x from dual )  ) tv',
'from dual)',
'select ',
'decode(lower(l.userid),null,',
'  messages.login_page,''nobody'',',
'  messages.unauth_user,lower(l.userid))',
'   user_name,',
'lower(c.short_name) workspace,',
' sum(nvl(content_length,0)) content_length,',
' count(*) page_views, ',
' 100*count(*)/tv pct, ',
' sum(num_rows) report_rows, count(distinct(ip_address)) ip_addresses, sum(elap) total_elapsed, avg(elap) average_elapsed, count(distinct to_char(time_stamp,''YYYYMMDDHH24'')) distinct_hours, count(distinct to_char(time_stamp,''YYYYMMDD'')) distinct_days',
'from wwv_flow_activity_log l, ',
'     wwv_flow_companies c, messages',
'where l.security_group_id = c.provisioning_company_id (+)',
'and page_mode != ''A''',
'and l.time_stamp>=(select sysdate - to_number(',
':F4050_P36_DAYS) x from dual )  ',
'group by decode(lower(l.userid),null,',
'  login_page,''nobody'',',
'  unauth_user,lower(l.userid)),',
'  lower(c.short_name),',
'  tv'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'F4050_P36_DAYS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(29699725380437593.4052)
,p_name=>'Page Views by User'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29700017280437611.4052)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29699919697437605.4052)
,p_db_column_name=>'USER_NAME'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Nom utilisateur'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29700119116437611.4052)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Vues de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29700209070437611.4052)
,p_db_column_name=>'PCT'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Pourcentage'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29700329762437611.4052)
,p_db_column_name=>'REPORT_ROWS'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>unistr('Lignes d''\00E9tat')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29700428081437611.4052)
,p_db_column_name=>'IP_ADDRESSES'
,p_display_order=>7
,p_column_identifier=>'F'
,p_column_label=>'Adresses IP'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29700530668437612.4052)
,p_db_column_name=>'TOTAL_ELAPSED'
,p_display_order=>8
,p_column_identifier=>'G'
,p_column_label=>unistr('Temps total \00E9coul\00E9')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29700630362437612.4052)
,p_db_column_name=>'AVERAGE_ELAPSED'
,p_display_order=>9
,p_column_identifier=>'H'
,p_column_label=>unistr('Temps moyen \00E9coul\00E9')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29700720568437612.4052)
,p_db_column_name=>'DISTINCT_HOURS'
,p_display_order=>10
,p_column_identifier=>'I'
,p_column_label=>'Heures distinctes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29700820921437612.4052)
,p_db_column_name=>'DISTINCT_DAYS'
,p_display_order=>11
,p_column_identifier=>'J'
,p_column_label=>'Jours distincts'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201522023038101249.4052)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>12
,p_column_identifier=>'K'
,p_column_label=>'Contenu'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(190804631770512632.4052)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_header=>'<h1>'
,p_plug_footer=>'</h1>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78416586194793694.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(190804631770512632.4052)
,p_button_name=>'P36_GO'
,p_button_static_id=>'P36_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('D\00E9finir')
,p_button_alignment=>'LEFT'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(201522110702107141.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(190804631770512632.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:36:&SESSION.::&DEBUG.:36,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(78411482361787247.4052)
,p_name=>'F4050_P36_DAYS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(190804631770512632.4052)
,p_item_default=>'to_number(.000694444)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Depuis'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Limitez l''\00E9tat \00E0 une tranche de temps sp\00E9cifique. Indiquez la quantit\00E9 de temps \00E0 inclure dans l''\00E9tat et cliquez sur <strong>OK</strong>.<p />'),
unistr('Si vous s\00E9lectionnez 1 jour, seules les derni\00E8res 24 heures s''affichent.  ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(276626473692689750.4052)
,p_computation_sequence=>10
,p_computation_item=>'F4050_P36_DAYS'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return to_number(:F4050_P36_DAYS);',
'exception',
'    when others then',
'        return to_number(.000694444);',
'end;        '))
);
end;
/
prompt --application/pages/page_00037
begin
wwv_flow_api.create_page(
 p_id=>37.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Vues de page par jour par application et utilisateur'
,p_step_title=>'Vues de page par jour par application et utilisateur'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(982231934072899643.4052)
,p_plug_name=>'Calendrier des vues de page'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P37a */',
'    trunc(TIME_STAMP) ts, ',
'    wwv_flow_lang.system_message(''views'')||'': ''',
'        ||to_char(count(*),''999G999G999G999G990'')||''<br>''',
'        ||chr(10)',
'        ||wwv_flow_lang.system_message(''users'')||'': ''',
'        ||count(distinct upper(USERID))||''<br>''',
'        ||chr(10)',
'        ||wwv_flow_lang.system_message(''applications'')||'': ''',
'        ||to_char(count(distinct flow_id),''999G999G999G990'')||''<br>''',
'        ||chr(10)',
'        ||wwv_flow_lang.system_message(''pages'')||'': ''',
'        ||to_char(count(distinct step_id),''999G999G990'') display',
'from WWV_FLOW_ACTIVITY_LOG',
'group by trunc(time_stamp)'))
,p_lazy_loading=>true
,p_plug_source_type=>'NATIVE_CSS_CALENDAR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'TS'
,p_attribute_03=>'DISPLAY'
,p_attribute_09=>'month:list:navigation'
,p_attribute_13=>'N'
,p_attribute_17=>'Y'
,p_attribute_19=>'N'
,p_attribute_21=>'10'
,p_attribute_22=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(291646014277240138.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Calendar Date -Previous'
,p_process_sql_clob=>' wwv_flow_utilities.decrement_calendar;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors du changement de la date de calendrier.'
,p_process_comment=>'Generated 06-AUG-04'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(291646406278240158.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Calendar Date -Next'
,p_process_sql_clob=>' wwv_flow_utilities.increment_calendar;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors du changement de la date de calendrier.'
,p_process_comment=>'Generated 06-AUG-04'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(291646229414240158.4052)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Calendar Date -Today'
,p_process_sql_clob=>' wwv_flow_utilities.today_calendar;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors du changement de la date de calendrier.'
,p_process_comment=>'Generated 06-AUG-04'
);
end;
/
prompt --application/pages/page_00038
begin
wwv_flow_api.create_page(
 p_id=>38.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Vues de page par agent utilisateur'
,p_step_title=>'Vues de page par agent utilisateur'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1139626278807865.4052)
,p_plug_name=>'Vues de page par agent utilisateur'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_views as (',
'select /* APEX 4050P38a */ count(*) tv ',
'    from wwv_flow_activity_log ',
'    where (:P38_SEARCH is null or instr(upper(user_agent),upper(:P38_SEARCH))>0)',
'          and user_agent is not null',
'    )',
'select user_agent, count(distinct ip_address) ip_addresses, ',
'       sum(the_count) page_views, ',
'       100*sum(the_count)/max(tv) pct, ',
'       round(100*sum(the_count)/max(tv)) graph',
'  from',
'   (select   session_id, ',
'             max(substr(nvl(user_agent,'' Unknown''),1,100)) user_agent, ',
'             count(*) the_count,',
'             max(ip_address) ip_address',
'      from   wwv_flow_activity_log',
'      where  time_stamp >= (select sysdate - to_number(:p38_include) x from dual)',
'             and (:P38_SEARCH is null or instr(upper(user_agent),upper(:P38_SEARCH))>0)',
'             and user_agent is not null',
'      group  by session_id) l,',
'total_views',
' group by user_agent'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P38_INCLUDE'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1139714426807865.4052)
,p_name=>'Page Views by User Agent'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1139914254807872.4052)
,p_db_column_name=>'USER_AGENT'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Agent utilisateur'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1140010212807873.4052)
,p_db_column_name=>'IP_ADDRESSES'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Adresses IP'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1140103841807873.4052)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Vues de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1140222535807873.4052)
,p_db_column_name=>'PCT'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Pourcentage'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1140319248807873.4052)
,p_db_column_name=>'GRAPH'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Graphique'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:200'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7600207230119070.4052)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200336310009013487.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(7600207230119070.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:38:&SESSION.::&DEBUG.:38,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7601517273121938.4052)
,p_name=>'P38_INCLUDE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(7600207230119070.4052)
,p_item_default=>'1'
,p_prompt=>'Inclure'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Limitez l''\00E9tat \00E0 une tranche de temps sp\00E9cifique. Indiquez la quantit\00E9 de temps \00E0 inclure dans l''\00E9tat et cliquez sur <strong>OK</strong>.<p />'),
unistr('Si vous s\00E9lectionnez 1 jour, seules les derni\00E8res 24 heures s''affichent.  ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(514940926156998805.4052)
,p_computation_sequence=>10
,p_computation_item=>'P38_INCLUDE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return to_number(:P38_INCLUDE);',
'exception',
'    when others then',
'        return to_number(.000694444);',
'end;       ',
''))
);
end;
/
prompt --application/pages/page_00039
begin
wwv_flow_api.create_page(
 p_id=>39.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Utilisation de fichier par espace de travail'
,p_step_title=>'Utilisation de fichier par espace de travail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_file_util.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168486127574421772.4052)
,p_plug_name=>'Utilisation de fichier par espace de travail'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P39a */',
'    (select short_name from wwv_flow_companies where PROVISIONING_COMPANY_ID = q.workspace_id) workspace_name,',
'    total_file_size,',
'    count_of_files,',
'    workspace_id,',
'    newest_file,',
'    oldest_file',
'from (',
'select security_group_id workspace_id, nvl(sum(sys.dbms_lob.getlength(BLOB_CONTENT)),0) total_file_size, count(*) count_of_files,',
'max(created_on) newest_file,',
'min(created_on) oldest_file',
'from WWV_FLOW_FILE_OBJECTS$ ',
'group by security_group_id',
') q'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(168486201858421772.4052)
,p_name=>'File Utiliaztion by Workspace'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(168486406232421778.4052)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID d''espace de travail'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(168486506600421780.4052)
,p_db_column_name=>'TOTAL_FILE_SIZE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Taille totale des fichiers'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(168486627845421780.4052)
,p_db_column_name=>'COUNT_OF_FILES'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Nombre de fichiers'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(168487624348439653.4052)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Nom de l''espace de travail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(168487830928441569.4052)
,p_db_column_name=>'NEWEST_FILE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Fichier le plus r\00E9cent')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(168487900636441570.4052)
,p_db_column_name=>'OLDEST_FILE'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Fichier le plus ancien'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(468245232054195576.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(168486127574421772.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.:RIR::'
);
end;
/
prompt --application/pages/page_00040
begin
wwv_flow_api.create_page(
 p_id=>40.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Tableau de bord'
,p_step_title=>'Tableau de bord'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168510101521826105.4052)
,p_plug_name=>'Principaux espaces de travail'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4050_ui.top_workspaces (',
'    p_app_session   => :app_session,',
'    p_days          => :P40_TIME,',
'    p_image_prefix  => :image_prefix,',
'    p_chart_width   => 100,',
'    p_display_count => 10);'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168510500623826106.4052)
,p_plug_name=>'Principales applications'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>50
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4050_ui.top_applications (',
'    p_app_session   => :app_session,',
'    p_days          => :P40_TIME,',
'    p_image_prefix  => :image_prefix,',
'    p_chart_width   => 100,',
'    p_display_count => 10);'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168510708105826106.4052)
,p_plug_name=>'Principaux utilisateurs'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4050_ui.top_users (',
'    p_app_session   => :app_session,',
'    p_days          => :P40_TIME,',
'    p_image_prefix  => :image_prefix,',
'    p_chart_width   => 100,',
'    p_display_count => 10);'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168510902814826107.4052)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_header=>'<h1>'
,p_plug_footer=>'</h1>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(201291722136259899.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(168510902814826107.4052)
,p_button_name=>'P40_SET'
,p_button_static_id=>'P40_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('D\00E9finir')
,p_button_alignment=>'LEFT'
,p_request_source=>'Set'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(168654712688961177.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(168510902814826107.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.:40,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(168655015458961962.4052)
,p_branch_action=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(168511327180826108.4052)
,p_name=>'P40_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(168510902814826107.4052)
,p_item_default=>'43200'
,p_prompt=>'Heure'
,p_source=>'43200'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P40_RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, to_char(t) t',
'from (',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 60 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5*60 t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15*60 t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30*60 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 3600 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 2*3600  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 3*3600  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 4*3600  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6*3600 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8*3600 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12*3600 t from dual union all',
'select ''18 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 18*3600 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1*24*60*60 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2*24*60*60 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 3*24*60*60 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 4*24*60*60 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 5*24*60*60 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 6*24*60*60 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7*24*60*60 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14*24*60*60 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28*24*60*60 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365*24*60*60 t from dual order by 2',
') q'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(168511623943826111.4052)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'29'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00041
begin
wwv_flow_api.create_page(
 p_id=>41.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Message de connexion'
,p_page_mode=>'MODAL'
,p_step_title=>'Message de connexion'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216766702444596508)
,p_step_template=>wwv_flow_api.id(721103220819687982.4052)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'450'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEADM/adm_env_sec.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168805726894149252.4052)
,p_plug_name=>'Message de connexion'
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168806123768149255.4052)
,p_plug_name=>'buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(955890401700997315.4052)
,p_plug_name=>'Message de connexion'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>11
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(168807329606149261.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(168806123768149255.4052)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(168807109764149260.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(168806123768149255.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(168810627520149271.4052)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(168808009400149264.4052)
,p_name=>'P41_CUSTOM_MESSAGE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(168805726894149252.4052)
,p_prompt=>'Message'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>10
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez le texte \00E0 afficher sur la page de connexion. Ce texte doit comprendre du code HTML.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(206354858435953021.4052)
,p_name=>'Cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(168807109764149260.4052)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(206354902602953022.4052)
,p_event_id=>wwv_flow_api.id(206354858435953021.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(168809920803149267.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch values from platform prefs table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- Login message',
'--',
':P41_CUSTOM_MESSAGE := wwv_flow_platform.get_preference( p_preference_name => ''LOGIN_MESSAGE'' );'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(168810111601149270.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Apply Changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- If custom login message, then set the actual message to be displayed.',
'--',
'if trim( :P41_CUSTOM_MESSAGE ) is not null then',
'    wwv_flow_platform.set_preference( p_preference_name  => ''LOGIN_MESSAGE'',',
'                                      p_preference_value => trim( :P41_CUSTOM_MESSAGE ) );',
'else',
'    --',
'    -- Otherwise, clear out the message',
'    --',
'    wwv_flow_platform.set_preference( p_preference_name => ''LOGIN_MESSAGE'',',
'                                      p_preference_value => null );',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de mettre \00E0 jour le message de connexion.')
,p_process_when_button_id=>wwv_flow_api.id(168807329606149261.4052)
,p_process_success_message=>unistr('Message de connexion mis \00E0 jour.')
);
end;
/
prompt --application/pages/page_00042
begin
wwv_flow_api.create_page(
 p_id=>42.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Modifier un th\00E8me public')
,p_step_title=>unistr('Modifier un th\00E8me public')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_pub_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(138031028642631493.4052)
,p_plug_name=>unistr('Th\00E8me public')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(231656925133898319.4052)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752110265314695866.4052)
,p_plug_name=>unistr('Modifier un th\00E8me public')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(138031725433631494.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(231656925133898319.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:555:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1429076119383875907.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(231656925133898319.4052)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9g\00E9n\00E9rer le th\00E8me')
,p_button_position=>'CREATE'
,p_button_condition_type=>'NEVER'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(138032120818631497.4052)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(231656925133898319.4052)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'CREATE'
,p_button_condition=>'P42_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(138031909392631497.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(231656925133898319.4052)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Supprimer'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P42_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(138035131295631504.4052)
,p_branch_action=>'f?p=&APP_ID.:555:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>1
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138032320063631498.4052)
,p_name=>'P42_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(138031028642631493.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(148842116797733609.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138032507109631498.4052)
,p_name=>'P42_THEME_ID'
,p_item_sequence=>21
,p_item_plug_id=>wwv_flow_api.id(138031028642631493.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Num\00E9ro')
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Le num\00E9ro identifie de fa\00E7on unique un th\00E8me dans un espace de travail. Vous devez entrer une valeur sup\00E9rieure \00E0 100.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138033017002631498.4052)
,p_name=>'P42_THEME_NAME'
,p_item_sequence=>31
,p_item_plug_id=>wwv_flow_api.id(138031028642631493.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nom'
,p_source=>'THEME_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifie le th\00E8me d''espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138033530776631499.4052)
,p_name=>'P42_THEME_DESCRIPTION'
,p_item_sequence=>41
,p_item_plug_id=>wwv_flow_api.id(138031028642631493.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Description'
,p_source=>'THEME_DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Br\00E8ve description du th\00E8me.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2026325277918671801.4052)
,p_name=>'P42_REFERENCE_ID'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_api.id(138031028642631493.4052)
,p_use_cache_before_default=>'NO'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(138034118219631500.4052)
,p_validation_name=>'P42_THEME_ID not null'
,p_validation_sequence=>30
,p_validation=>'P42_THEME_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le num\00E9ro de th\00E8me doit comporter une valeur.')
,p_associated_item=>wwv_flow_api.id(138032507109631498.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(138034321549631503.4052)
,p_validation_name=>'P42_THEME_NAME not null'
,p_validation_sequence=>50
,p_validation=>'P42_THEME_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le nom de th\00E8me doit comporter une valeur.')
,p_associated_item=>wwv_flow_api.id(138033017002631498.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(138034819862631504.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_THEMES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_THEMES'
,p_attribute_03=>'P42_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Impossible d''extraire la ligne.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(138034431628631503.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'apply changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.change_public_theme (',
'   p_id           => :P42_ID,',
'   p_theme_name   => :P42_THEME_NAME,',
'   p_theme_number => :P42_THEME_ID,',
'   p_theme_desc   => :P42_THEME_DESCRIPTION);'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(138032120818631497.4052)
,p_process_success_message=>unistr('Action trait\00E9e')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(138034606078631504.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.delete_public_theme (',
'p_id=>:P42_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(138031909392631497.4052)
,p_process_success_message=>unistr('Action trait\00E9e')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1429076290019875908.4052)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'New'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'null;',
'-- to be completed'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Erreur lors de la r\00E9g\00E9n\00E9ration du th\00E8me')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1429076119383875907.4052)
,p_process_success_message=>unistr('Th\00E8me r\00E9g\00E9n\00E9r\00E9')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1331351348942223315.4052)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_theme (',
'    p_master_theme_id      => :P42_REFERENCE_ID,',
'    p_subscribing_theme_id => :P42_ID',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Erreur lors de la r\00E9g\00E9n\00E9ration du th\00E8me.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1429076119383875907.4052)
,p_process_success_message=>unistr('Le th\00E8me a \00E9t\00E9 r\00E9g\00E9n\00E9r\00E9.')
);
end;
/
prompt --application/pages/page_00043
begin
wwv_flow_api.create_page(
 p_id=>43.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Modifications d''application par d\00E9veloppeur')
,p_step_title=>unistr('Modifications d''application par d\00E9veloppeur')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472582008463696710.4052)
,p_plug_name=>unistr('Modifications d''application par espace de travail et d\00E9veloppeur')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P43a */',
'a.flow_user uu, ',
'c.short_name,                            ',
'count(*) c ,',
'min(a.audit_date) first_change,',
'max(a.audit_date) last_change,',
'count(distinct FLOW_ID) applications,',
'count(distinct page_id) pages,',
'count(distinct FLOW_TABLE) components',
'from ',
'   wwv_flow_builder_audit_trail a, ',
'   wwv_flow_companies c ',
'where ',
'  c.provisioning_company_id = a.security_group_id  ',
'group by a.flow_user ,c.short_name'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(472582126350696710.4052)
,p_name=>'Application Changes by Workspace and Developer'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472582407921696718.4052)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472582311966696717.4052)
,p_db_column_name=>'UU'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Utilisateur'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472582531424696719.4052)
,p_db_column_name=>'C'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Nombre'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472582615030696720.4052)
,p_db_column_name=>'FIRST_CHANGE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Premi\00E8re modification')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472582728052696722.4052)
,p_db_column_name=>'LAST_CHANGE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Derni\00E8re modification')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472582829521696723.4052)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472582912769696724.4052)
,p_db_column_name=>'PAGES'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472583000344696725.4052)
,p_db_column_name=>'COMPONENTS'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Composants'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(982232095154899644.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(472582008463696710.4052)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:43:&SESSION.::&DEBUG.:RP,RIR,43:::'
);
end;
/
prompt --application/pages/page_00044
begin
wwv_flow_api.create_page(
 p_id=>44.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Vues de page par application'
,p_alias=>'MON_BY_FLOW'
,p_step_title=>'Vues de page par application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(134117404639991595.4052)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'blue_arrow_down.gif::blue_arrow_up.gif:|3,3,4\1,2|',
'',
'&nbsp;:',
'',
'<font class="nounderline" color="black">CompanyShortName</font>:',
'',
'<font class="nounderline" color="green">Users</font>:',
'',
'<font class="nounderline" color="green">Developers</font>:',
'',
'<font class="nounderline" color="green">Flows</font>:<font color=green>ProvStatus</font>:',
'',
'<font class="nounderline" color="black">CompanyID</font>:'))
,p_plug_query_num_rows=>25
,p_plug_query_num_rows_item=>'F4050_P1_ROWS'
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:L:L:R:R:R:L'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(192033217981888915.4052)
,p_plug_name=>'Vues de page par application'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_views as (select /* APEX 4050P44a */ count(*) tv from wwv_flow_activity_log',
'where  time_stamp >= (select sysdate - to_number(:F4050_P44_DAYS) x from dual) and page_mode != ''A'')',
'select f.name,  x.flow_id application, x.c page_views, f.security_group_id, 100*x.c/tv pct, round(100*x.c/tv ) graph, c.short_name',
'from (',
'select flow_id, count(*) c',
'from   wwv_flow_activity_log',
'where  time_stamp >= (select sysdate - to_number(:F4050_P44_DAYS) x from dual) and page_mode != ''A''',
'group by flow_id) x, ',
'wwv_flows f,',
'total_views,',
'wwv_flow_companies c',
'where x.flow_id = f.id and f.security_group_id = c.provisioning_company_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'F4050_P44_DAYS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(192033331944888915.4052)
,p_name=>'Page Views by Application'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192034113082888923.4052)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>1
,p_column_identifier=>'G'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192033623344888919.4052)
,p_db_column_name=>'APPLICATION'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192033532146888918.4052)
,p_db_column_name=>'NAME'
,p_display_order=>3
,p_column_identifier=>'A'
,p_column_label=>'Nom d''application'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192033832304888920.4052)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Espace de travail'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192033721853888920.4052)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>5
,p_column_identifier=>'C'
,p_column_label=>'Vues de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192033914686888921.4052)
,p_db_column_name=>'PCT'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Pourcentage'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192034012312888922.4052)
,p_db_column_name=>'GRAPH'
,p_display_order=>7
,p_column_identifier=>'F'
,p_column_label=>'Graphique'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:300'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(134122621233999084.4052)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(134117404639991595.4052)
,p_button_name=>'F4050_P44_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('D\00E9finir')
,p_button_alignment=>'LEFT'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(192030007015841102.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(134117404639991595.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:44:&SESSION.::&DEBUG.:RP,44,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(134120128565995681.4052)
,p_name=>'F4050_P44_DAYS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(134117404639991595.4052)
,p_item_default=>'1'
,p_prompt=>'Inclure'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Limitez l''\00E9tat \00E0 une tranche de temps sp\00E9cifique. Indiquez la quantit\00E9 de temps \00E0 inclure dans l''\00E9tat et cliquez sur <strong>D\00E9finir</strong>.<p />'),
unistr('Si vous s\00E9lectionnez 1 jour, seules les derni\00E8res 24 heures s''affichent.  ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(514940572159998801.4052)
,p_computation_sequence=>10
,p_computation_item=>'F4050_P44_DAYS'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return to_number(:F4050_P44_DAYS);',
'exception',
'    when others then',
'        return to_number(.000694444);',
'end;        '))
);
end;
/
prompt --application/pages/page_00045
begin
wwv_flow_api.create_page(
 p_id=>45.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Vues de page par site externe'
,p_alias=>'TOP_CLICKS'
,p_step_title=>'Vues de page par site externe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(7686024329483531.4052)
,p_name=>'Vues de page par site externe'
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with total_clicks as (',
'select /* APEX 4050P45a */ count(*) tc',
'from wwv_flow_clickthru_log_v ',
'where clickdate >= (sysdate - (select :F4050_P45_DAYS from dual)) )',
'select  category, count(*) clicks, 100*count(*)/max(tc) pct, 100*count(*)/max(tc) graph',
'from wwv_flow_clickthru_log_v , total_clicks',
'where clickdate >= (sysdate - (select :F4050_P45_DAYS from dual)) ',
'group by category'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('L''\00E9tat n''a renvoy\00E9 aucune donn\00E9e.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7686327013483538.4052)
,p_query_column_id=>1
,p_column_alias=>'CATEGORY'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Cat\00E9gorie')
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7686410853483538.4052)
,p_query_column_id=>2
,p_column_alias=>'CLICKS'
,p_column_display_sequence=>2
,p_column_heading=>'Clics'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7690220436501333.4052)
,p_query_column_id=>3
,p_column_alias=>'PCT'
,p_column_display_sequence=>3
,p_column_heading=>'Pourcentage'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990D00'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7690321393501333.4052)
,p_query_column_id=>4
,p_column_alias=>'GRAPH'
,p_column_display_sequence=>4
,p_use_as_row_header=>'N'
,p_column_format=>'PCT_GRAPH'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(145277907592163494.4052)
,p_plug_name=>unistr('D\00E9compte des clics externes')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Cette page pr\00E9sente les clics utilisateur sur des liens menant \00E0 des sites externes. Ces clics ont \00E9t\00E9 r\00E9pertori\00E9s \00E0 l''aide de la proc\00E9dure de &PRODUCT_NAME. nomm\00E9e <code>APEX_UTIL.COUNT_CLICK</code> ou par des \00E9l\00E9ments de liste configur\00E9s pour compt')
||'er les clics.'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(190854513377597141.4052)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(145349821954263192.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(190854513377597141.4052)
,p_button_name=>'F4050_P45_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('D\00E9finir')
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(145345501048257700.4052)
,p_name=>'F4050_P45_DAYS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(190854513377597141.4052)
,p_item_default=>'1'
,p_prompt=>'Inclure'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Limitez l''\00E9tat \00E0 une tranche de temps sp\00E9cifique. Indiquez la quantit\00E9 de temps \00E0 inclure dans l''\00E9tat et cliquez sur <strong>OK</strong>.<p />'),
unistr('Si vous s\00E9lectionnez 1 jour, seules les derni\00E8res 24 heures s''affichent.  '),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00046
begin
wwv_flow_api.create_page(
 p_id=>46.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Journaux de SQL Workshop'
,p_step_title=>'Journaux de SQL Workshop'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216783731365642767)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>'AEADM/adm_logs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22617807253644948.4052)
,p_plug_name=>'Journaux de SQL Workshop'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<table class="instructiontext" role="presentation">'');',
'sys.htp.p(''<tr>'');',
'sys.htp.p(''<td align="right">'');',
'sys.htp.p(''<a href="''',
'          ||apex_util.prepare_url(''f?p=4050:75:''||:flow_session||''::::P75_LOG_TYPE:SCRIPT'')',
'          ||''">''||wwv_flow_lang.system_message(''4050_46_SCRIPT_FILE'')||''</a>''||'':'');',
'sys.htp.p(''</td>'');',
'sys.htp.prn(''<td align="left">'');',
'for c1 in (select count(*) c from wwv_flow_sw_results) loop',
'    sys.htp.p(to_char(c1.c,''999,999,999,999,990''));',
'end loop;',
'sys.htp.prn(''</td>'');',
'sys.htp.p(''</tr>'');',
'sys.htp.p(''<tr>'');',
'sys.htp.p(''<td align="right">'');',
'sys.htp.p(''<a href="''',
'          ||apex_util.prepare_url(''f?p=4050:75:''||:flow_session||''::::P75_LOG_TYPE:HISTORY'')',
'          ||''">''||wwv_flow_lang.system_message(''4050_46_AD_HOC'')||''</a>''||'':'');',
'sys.htp.p(''</td>'');',
'sys.htp.prn(''<td align="left">'');',
'for c1 in (select count(*) c from wwv_flow_sw_sql_cmds) loop',
'    sys.htp.p(to_char(c1.c,''999,999,999,999,990''));',
'end loop;',
'sys.htp.prn(''</td>'');',
'sys.htp.p(''</tr>'');',
'sys.htp.p(''</table>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22619003706662819.4052)
,p_plug_name=>'Journaux de SQL Workshop'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('SQL Workshop conserve un historique des instructions SQL. Celui-ci est accessible aux utilisateurs de SQL Workshop via l''utilitaire d''historique. Cette table peut \00EAtre vid\00E9e pour r\00E9duire l''utilisation d''espace.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(982232116190899645.4052)
,p_plug_name=>'Boutons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1080989976388523932.4052)
,p_plug_name=>'Journaux de SQL Workshop'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(161897913639838567.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(982232116190899645.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22620213748665756.4052)
,p_branch_action=>'46'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00047
begin
wwv_flow_api.create_page(
 p_id=>47.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Cr\00E9er un th\00E8me public - Espace de travail')
,p_step_title=>unistr('Cr\00E9er un th\00E8me public')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931176884177111905)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_pub_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(138041907898643265.4052)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(138045104803643281.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(138042300956643271.4052)
,p_plug_name=>unistr('Cr\00E9er un th\00E8me public')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>10
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Les th\00E8mes publics sont des th\00E8mes disponibles pour tous les espaces de travail. Lorsqu''ils cr\00E9ent des applications, les d\00E9veloppeurs peuvent s\00E9lectionner un th\00E8me public en plus des th\00E8mes de &PRODUCT_NAME., ainsi que des th\00E8mes d''espace de travail.')
||' ',
'<p/>',
unistr('Identifiez l''espace de travail propri\00E9taire du th\00E8me d''application \00E0 copier dans le r\00E9f\00E9rentiel des th\00E8mes publics.'),
'<p/>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208270002919476408.4052)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752110359958695866.4052)
,p_plug_name=>unistr('Cr\00E9er un th\00E8me public')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(138043401976643278.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208270002919476408.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:555:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(138043000845643273.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208270002919476408.4052)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(138044704585643280.4052)
,p_branch_action=>'f?p=&APP_ID.:57:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(138043000845643273.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138044131207643279.4052)
,p_name=>'P47_WORKSPACE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(138042300956643271.4052)
,p_prompt=>'Espace de travail'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST_DEVELOPER_WORKSPACES_NO_NULL_OPTION'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id not in (0,10,11, 12)',
'order by 1'))
,p_cSize=>50
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifie l''espace de travail dans lequel le th\00E8me d''application \00E0 copier r\00E9side.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(138164321008022878.4052)
,p_validation_name=>'P47_WORKSPACE'
,p_validation_sequence=>10
,p_validation=>'P47_WORKSPACE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('L''espace de travail doit \00EAtre indiqu\00E9.')
,p_when_button_pressed=>wwv_flow_api.id(138043000845643273.4052)
,p_associated_item=>wwv_flow_api.id(138044131207643279.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00048
begin
wwv_flow_api.create_page(
 p_id=>48.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Cr\00E9er un th\00E8me public - Nom')
,p_step_title=>unistr('Cr\00E9er un th\00E8me public')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931176884177111905)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_pub_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(138052410467655077.4052)
,p_plug_name=>unistr('Cr\00E9er un th\00E8me public')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>10
,p_plug_header=>unistr('<p>Vous pouvez modifier le nom et le num\00E9ro du th\00E8me public \00E0 cr\00E9er.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(138052802537655078.4052)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(138045104803643281.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
,p_translate_title=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(138053023370655078.4052)
,p_name=>unistr('Th\00E8mes publics existants')
,p_template=>wwv_flow_api.id(202654901374384775.4052)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.theme_id,',
'       t.theme_name,',
'       t.theme_description',
'  from wwv_flow_themes t, wwv_flows f',
' where t.flow_id = f.id',
'   and f.application_type = ''STANDARD''',
'   and t.theme_security_group_id is null',
'   and f.security_group_id = 11',
' order by t.theme_id',
' ',
' '))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes',
' where theme_security_group_id is null',
'   and security_group_id = 11'))
,p_display_condition_type=>'EXISTS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(6897002870390711.4052)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Aucun th\00E8me public n''existe.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(138053207858655079.4052)
,p_query_column_id=>1
,p_column_alias=>'THEME_ID'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Num\00E9ro')
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(138053325066655079.4052)
,p_query_column_id=>2
,p_column_alias=>'THEME_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nom'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(138053423313655079.4052)
,p_query_column_id=>3
,p_column_alias=>'THEME_DESCRIPTION'
,p_column_display_sequence=>3
,p_column_heading=>'Description'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208271825344501885.4052)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752110451825695867.4052)
,p_plug_name=>unistr('Cr\00E9er un th\00E8me public')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(138054212644655080.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208271825344501885.4052)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:58:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(138054424254655080.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208271825344501885.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:555:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(138054000479655080.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208271825344501885.4052)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(138057525436655086.4052)
,p_branch_action=>'f?p=&APP_ID.:51:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(138054000479655080.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138054611163655081.4052)
,p_name=>'P48_THEME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(138052410467655077.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Th\00E8me s\00E9lectionn\00E9 :')
,p_source=>'P58_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||theme_name d, theme_id',
'  from wwv_flow_themes',
' where security_group_id = :P47_WORKSPACE',
'  and flow_id = :P57_APPLICATION',
'order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifie le th\00E8me \00E0 copier dans le r\00E9f\00E9rentiel de th\00E8mes d''espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138055124156655081.4052)
,p_name=>'P48_THEME_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(138052410467655077.4052)
,p_prompt=>unistr('Nom de th\00E8me')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_name',
'  from wwv_flow_themes',
' where security_group_id = :P47_WORKSPACE',
'   and flow_id = :P57_APPLICATION',
'   and theme_id = :P58_THEME'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifie le th\00E8me d''espace de travail. Ce nom peut \00EAtre identique ou diff\00E9rent du nom du th\00E8me d''application.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138055609809655082.4052)
,p_name=>'P48_THEME_NUMBER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(138052410467655077.4052)
,p_prompt=>unistr('Num\00E9ro de th\00E8me')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(greatest(theme_id,99),99,theme_id+100,theme_id) theme_id',
'  from wwv_flow_themes',
' where security_group_id = :P47_WORKSPACE',
'   and flow_id = :P57_APPLICATION',
'   and theme_id = :P58_THEME'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Le num\00E9ro identifie de fa\00E7on unique un th\00E8me dans un espace de travail. Vous devez entrer une valeur sup\00E9rieure \00E0 100.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138056117408655083.4052)
,p_name=>'P48_DESCRIPTION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(138052410467655077.4052)
,p_prompt=>'Description'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select THEME_DESCRIPTION',
'  from wwv_flow_themes',
' where security_group_id = :P47_WORKSPACE',
'   and flow_id = :P57_APPLICATION',
'   and theme_id = :P58_THEME'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>50
,p_cMaxlength=>32767
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Br\00E8ve description du th\00E8me.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138251117956901802.4052)
,p_name=>'P48_WORKSPACE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(138052410467655077.4052)
,p_prompt=>'Espace de travail :'
,p_source=>'P47_WORKSPACE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_ALL_COMPANIES_NO_NULL_OPTION'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id > 0',
'  and  provisioning_company_id != 11',
'  and  provisioning_company_id != 12',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifie l''espace de travail dans lequel le th\00E8me d''application \00E0 copier r\00E9side.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138252024536903773.4052)
,p_name=>'P48_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(138052410467655077.4052)
,p_prompt=>'Application :'
,p_source=>'P57_APPLICATION'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PUBLIC.THEME.APP.SELECTOR'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name d, id v',
'  from WWV_FLOWS',
' where security_group_id = :P47_WORKSPACE',
'   and security_group_id not in (0,10,11)',
' order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez l''application dans laquelle le th\00E8me \00E0 copier r\00E9side.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(138057110365655085.4052)
,p_validation_name=>'P48_THEME_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'P48_THEME_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Une valeur doit \00EAtre indiqu\00E9e.')
,p_associated_item=>wwv_flow_api.id(138055124156655081.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 28-NOV-2007 17:59'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(138057314081655085.4052)
,p_validation_name=>'P48_THEME_NUMBER Not Null'
,p_validation_sequence=>20
,p_validation=>'P48_THEME_NUMBER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Une valeur doit \00EAtre indiqu\00E9e.')
,p_associated_item=>wwv_flow_api.id(138055609809655082.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 28-NOV-2007 17:59'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(138056920473655085.4052)
,p_validation_name=>'valid theme number'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'if :P48_THEME_NUMBER < 100 then',
'  return false;',
'else ',
'  return true;',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La valeur doit \00EAtre sup\00E9rieure ou \00E9gale \00E0 100.')
,p_when_button_pressed=>wwv_flow_api.id(138054000479655080.4052)
,p_associated_item=>wwv_flow_api.id(138055609809655082.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(138056707385655083.4052)
,p_validation_name=>'theme number unique (edit me)'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes',
' where theme_id = :P48_THEME_NUMBER',
'   and security_group_id = 11',
'   and theme_security_group_id = :WORKSPACE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Le nombre doit \00EAtre unique dans un espace de travail.')
,p_when_button_pressed=>wwv_flow_api.id(138054000479655080.4052)
,p_associated_item=>wwv_flow_api.id(138055609809655082.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00049
begin
wwv_flow_api.create_page(
 p_id=>49.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Vues de page par application et utilisateur'
,p_step_title=>'Vues de page par application et utilisateur'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(68967412200798364.4052)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings=>'Company:Flow:User:Avg:Max:Min:Count'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:L:R:R:R:R'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(192019632350715193.4052)
,p_plug_name=>'Vues de page par espace de travail, application et utilisateur'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P49a */',
'    w.short_name,',
'    l.flow_id,',
'    l.userid,',
'    avg(l.elap) avg_elap,',
'    median(l.elap) median_elap,',
'    max(l.elap) max_elap,',
'    min(l.elap) min_elap,',
'    count(*) c,',
'    sum(nvl(content_length,0)) content_length',
'from WWV_FLOW_ACTIVITY_LOG l, wwv_flow_companies w ',
'where l.time_stamp > (sysdate - nvl(:F4050_P49_SINCE,1))',
'  and w.provisioning_company_id=l.security_group_id',
'  and page_mode != ''A''',
'group by l.userid,l.flow_id,w.short_name'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'F4050_P49_SINCE'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(192019712989715193.4052)
,p_name=>'Page Views by Workspace, Application and User'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192019920820715257.4052)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192020010055715261.4052)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192020113630715262.4052)
,p_db_column_name=>'USERID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Utilisateur'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192020207889715262.4052)
,p_db_column_name=>'AVG_ELAP'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Temps moyen \00E9coul\00E9')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G990D000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(499022627220371913.4052)
,p_db_column_name=>'MEDIAN_ELAP'
,p_display_order=>5
,p_column_identifier=>'I'
,p_column_label=>unistr('Temps m\00E9dian \00E9coul\00E9')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G990D999'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192020314500715263.4052)
,p_db_column_name=>'MAX_ELAP'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>unistr('Temps \00E9coul\00E9 maximal')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G990D000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192020414767715264.4052)
,p_db_column_name=>'MIN_ELAP'
,p_display_order=>7
,p_column_identifier=>'F'
,p_column_label=>unistr('Temps \00E9coul\00E9 minimal')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G990D000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192020521781715265.4052)
,p_db_column_name=>'C'
,p_display_order=>8
,p_column_identifier=>'G'
,p_column_label=>'Vues de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(200533800068843164.4052)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>9
,p_column_identifier=>'H'
,p_column_label=>'Contenu'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(68983926625822046.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(68967412200798364.4052)
,p_button_name=>'F4050_P49_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('D\00E9finir')
,p_button_alignment=>'LEFT'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(192027532380829469.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(68967412200798364.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.:49,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(68978320814809562.4052)
,p_name=>'F4050_P49_SINCE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(68967412200798364.4052)
,p_item_default=>'1'
,p_prompt=>'Depuis'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Limitez l''\00E9tat \00E0 une tranche de temps sp\00E9cifique. Indiquez la quantit\00E9 de temps \00E0 inclure dans l''\00E9tat et cliquez sur <strong>D\00E9finir</strong>.<p />'),
unistr('Si vous s\00E9lectionnez 1 jour, seules les derni\00E8res 24 heures s''affichent.  ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(276960932086906566.4052)
,p_computation_sequence=>10
,p_computation_item=>'F4050_P49_SINCE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1'
,p_compute_when=>'F4050_P49_SINCE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(38536518152143458.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rest pg'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00050
begin
wwv_flow_api.create_page(
 p_id=>50.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Activit\00E9 par application')
,p_step_title=>unistr('Activit\00E9 par application')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1081487685020772212.4052)
,p_plug_name=>unistr('Activit\00E9 par application')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    WORKSPACE_ID workspace,',
'    min(LOG_DAY) first_day,',
'    max(log_day) last_day,',
'    (select short_name from wwv_flow_companies where provisioning_company_id = workspace_id) workspace_name,',
'    APPLICATION_ID applications,',
'    (select max(name) from wwv_flows where id = application_id) application_name,',
'    sum(page_events) PAGE_EVENTS,',
'    sum(page_views) PAGE_VIEWS,',
'    sum(page_accepts) PAGE_ACCEPTS,',
'    sum(partial_page_views) PARTIAL_PAGE_VIEWS,',
'    sum(websheet_views) WEBSHEET_VIEWS,',
'    sum(rows_fetched) ROWS_FETCHED,',
'    sum(ir_searches) IR_SEARCHES,',
'    sum(distinct_pages) DISTINCT_PAGES,',
'    sum(distinct_users) DISTINCT_USERS,',
'    sum(distinct_sessions) DISTINCT_SESSIONS,',
'    sum(total_render_time) TOTAL_RENDER_TIME,',
'    sum(error_count) ERROR_COUNT,',
'    sum(nvl(content_length,0)) content_length,',
'    sum(public_page_events) public_page_events',
'from WWV_FLOW_LOG_HISTORY ',
'where log_day >= sysdate - (NVL(:P50_SINCE,365) + 1)',
'group by workspace_id, application_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1081487887243772215.4052)
,p_name=>'Activity by Day'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1081487887243772215
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(880154177420277485.4052)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(880154509535277486.4052)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Ev\00E9nements de page')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(880160928322277496.4052)
,p_db_column_name=>'PUBLIC_PAGE_EVENTS'
,p_display_order=>15
,p_column_identifier=>'U'
,p_column_label=>unistr('Ev\00E9nements de page publique')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(880154952458277486.4052)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>25
,p_column_identifier=>'F'
,p_column_label=>'Vues de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(880155310320277487.4052)
,p_db_column_name=>'PAGE_ACCEPTS'
,p_display_order=>35
,p_column_identifier=>'G'
,p_column_label=>'Envois de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(880155784363277489.4052)
,p_db_column_name=>'PARTIAL_PAGE_VIEWS'
,p_display_order=>45
,p_column_identifier=>'H'
,p_column_label=>'Vues de page partielle'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(880156174940277489.4052)
,p_db_column_name=>'WEBSHEET_VIEWS'
,p_display_order=>55
,p_column_identifier=>'I'
,p_column_label=>'Vues de feuille Web'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_security_scheme=>wwv_flow_api.id(610289739776900562)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(880156577105277490.4052)
,p_db_column_name=>'ROWS_FETCHED'
,p_display_order=>65
,p_column_identifier=>'J'
,p_column_label=>'Lignes extraites'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(880156927005277490.4052)
,p_db_column_name=>'IR_SEARCHES'
,p_display_order=>75
,p_column_identifier=>'K'
,p_column_label=>unistr('Recherches d''\00E9tat interactif')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(880157319628277491.4052)
,p_db_column_name=>'DISTINCT_PAGES'
,p_display_order=>85
,p_column_identifier=>'L'
,p_column_label=>'Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(880157763288277491.4052)
,p_db_column_name=>'DISTINCT_USERS'
,p_display_order=>95
,p_column_identifier=>'M'
,p_column_label=>'Utilisateurs'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(880158149745277492.4052)
,p_db_column_name=>'DISTINCT_SESSIONS'
,p_display_order=>105
,p_column_identifier=>'N'
,p_column_label=>'Sessions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(880158590150277493.4052)
,p_db_column_name=>'TOTAL_RENDER_TIME'
,p_display_order=>115
,p_column_identifier=>'O'
,p_column_label=>'Temps d''affichage total'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(880158971246277494.4052)
,p_db_column_name=>'ERROR_COUNT'
,p_display_order=>125
,p_column_identifier=>'P'
,p_column_label=>'Erreurs'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(880159314715277494.4052)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>135
,p_column_identifier=>'Q'
,p_column_label=>'Contenu'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(880159712423277494.4052)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>145
,p_column_identifier=>'R'
,p_column_label=>'Espace de travail'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(880160110386277495.4052)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>155
,p_column_identifier=>'S'
,p_column_label=>'Nom de l''espace de travail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(880160557330277495.4052)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>165
,p_column_identifier=>'T'
,p_column_label=>'Nom d''application'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(758054560886278413.4052)
,p_db_column_name=>'FIRST_DAY'
,p_display_order=>175
,p_column_identifier=>'V'
,p_column_label=>'Premier jour'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(758054693598278414.4052)
,p_db_column_name=>'LAST_DAY'
,p_display_order=>185
,p_column_identifier=>'W'
,p_column_label=>'Dernier jour'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1638217419722573136.4052)
,p_plug_name=>'Button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(880163742133294728.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1638217419722573136.4052)
,p_button_name=>'Set'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('D\00E9finir')
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(880161731332277508.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1081487685020772212.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:50:&SESSION.::&DEBUG.:77,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(880164170584294729.4052)
,p_name=>'P50_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1638217419722573136.4052)
,p_item_default=>'365'
,p_prompt=>'Depuis'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME_ARCHIVE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 30 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 186 t from dual union all',
'select ''9 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 279 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00051
begin
wwv_flow_api.create_page(
 p_id=>51.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Cr\00E9er un th\00E8me public - Confirmer')
,p_step_title=>unistr('Cr\00E9er un th\00E8me public')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931176884177111905)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_pub_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(138063615372663615.4052)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(138045104803643281.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(138063831884663615.4052)
,p_plug_name=>unistr('Cr\00E9er un th\00E8me public')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>10
,p_plug_header=>unistr('<p>Toute classe de mod\00E8le manquante implique que le th\00E8me s\00E9lectionn\00E9 est incomplet.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208277100719542102.4052)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752110574623695867.4052)
,p_plug_name=>unistr('Cr\00E9er un th\00E8me public')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(138065123623663617.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208277100719542102.4052)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:48:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(138064919629663617.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208277100719542102.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(138065416670663617.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208277100719542102.4052)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er un th\00E8me public')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(138067408337663624.4052)
,p_branch_action=>'f?p=&APP_ID.:555:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138066127066663621.4052)
,p_name=>'P51_THEME_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(138063831884663615.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nom de th\00E8me :')
,p_source=>'&P48_THEME_NAME.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifie le nom du th\00E8me de l''espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138066630251663622.4052)
,p_name=>'P51_THEME_NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(138063831884663615.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Num\00E9ro de th\00E8me :')
,p_source=>'&P48_THEME_NUMBER.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifie le num\00E9ro du th\00E8me de l''espace de travail. Ce num\00E9ro permet d''identifier de fa\00E7on unique un th\00E8me dans un espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(138067113086663622.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create public theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.create_new_public_theme (',
'   p_workspace_id     => :P47_WORKSPACE,',
'   p_app_id           => :P57_APPLICATION,',
'   p_app_theme_id     => :P58_THEME,',
'   p_theme_name       => :P48_THEME_NAME,',
'   p_theme_number     => :P48_THEME_NUMBER,',
'   p_theme_desc       => :P48_DESCRIPTION,',
'   p_subscribe_theme  => :P58_SUBSCRIBE_THEME);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur'
,p_process_when_button_id=>wwv_flow_api.id(138065416670663617.4052)
,p_process_success_message=>unistr('Th\00E8me public cr\00E9\00E9')
);
end;
/
prompt --application/pages/page_00052
begin
wwv_flow_api.create_page(
 p_id=>52.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Composants de l''espace de travail'
,p_step_title=>'Composants de l''espace de travail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_comp.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(173284328782752219.4052)
,p_plug_name=>'Composants de l''espace de travail'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX 4050P52a */',
'  "ID", ',
'  "PROVISIONING_COMPANY_ID",',
'  "SHORT_NAME",',
'  "FIRST_SCHEMA_PROVISIONED",',
'  decode(nvl(ALLOW_PLSQL_EDITING,''Y''),''Y'',m.yes,m.n) ALLOW_PLSQL_EDITING,',
'  "LAST_LOGIN",',
'  "BUILDER_NOTIFICATION_MESSAGE",',
'  decode(nvl(ALLOW_APP_BUILDING_YN,''Y''),''Y'',m.yes,m.n) ALLOW_APP_BUILDING_YN,',
'  decode(nvl(ALLOW_SQL_WORKSHOP_YN,''Y''),''Y'',m.yes,m.n) ALLOW_SQL_WORKSHOP_YN,',
'  decode(nvl(ALLOW_TEAM_DEVELOPMENT_YN,''Y''),''Y'',m.yes,m.n) ALLOW_TEAM_DEVELOPMENT_YN',
'from WWV_FLOW_COMPANIES w,',
'    (select wwv_flow_lang.system_message(''F4000.NO'') n,',
'            wwv_flow_lang.system_message(''F4000.YES'') yes',
'     from dual) m',
'where provisioning_company_id not in (0, 10, 11, 12)  ',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(173284520699752220.4052)
,p_name=>'Workspace Components'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(173284618560752223.4052)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(173284700127752227.4052)
,p_db_column_name=>'PROVISIONING_COMPANY_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('ID de groupe de s\00E9curit\00E9')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(173284830050752228.4052)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Espace de travail'
,p_column_link=>'f?p=&APP_ID.:59:&SESSION.::&DEBUG.::P59_ID,LAST_VIEW:#ID#,52'
,p_column_linktext=>'#SHORT_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(173284913038752228.4052)
,p_db_column_name=>'FIRST_SCHEMA_PROVISIONED'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Premier sch\00E9ma provisionn\00E9')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(173285002538752229.4052)
,p_db_column_name=>'ALLOW_PLSQL_EDITING'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Autoriser la modification du code PL/SQL'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(173285119516752229.4052)
,p_db_column_name=>'LAST_LOGIN'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Derni\00E8re connexion')
,p_column_type=>'DATE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(173285522534752235.4052)
,p_db_column_name=>'BUILDER_NOTIFICATION_MESSAGE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Message de notification Builder'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(173285614402752236.4052)
,p_db_column_name=>'ALLOW_APP_BUILDING_YN'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Autoriser la construction de l''application'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(173285717153752236.4052)
,p_db_column_name=>'ALLOW_SQL_WORKSHOP_YN'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Autoriser SQL Workshop'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(173285911306752238.4052)
,p_db_column_name=>'ALLOW_TEAM_DEVELOPMENT_YN'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>unistr('Autoriser le d\00E9veloppement d''\00E9quipe')
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(484952701077761252.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(173284328782752219.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:52:&SESSION.::&DEBUG.:52,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(173287818900788701.4052)
,p_branch_action=>'f?p=&APP_ID.:52:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(173291107088832520.4052)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'52'
);
end;
/
prompt --application/pages/page_00053
begin
wwv_flow_api.create_page(
 p_id=>53.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('R\00E9initialiser le mot de passe')
,p_step_title=>unistr('R\00E9initialiser le mot de passe')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(216787602191653217)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_users.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(71896102812290746.4052)
,p_plug_name=>unistr('R\00E9initialiser le mot de passe')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829706609080810173.4052)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(71892807988288321.4052)
,p_name=>'Informations utilisateur'
,p_parent_plug_id=>wwv_flow_api.id(71896102812290746.4052)
,p_template=>wwv_flow_api.id(721115784857730284.4052)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:is-expanded:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select user_name,',
'       first_name,',
'       last_name,',
'       description,',
'       email_address,',
'       default_schema,',
'       security_group_id',
'  from wwv_flow_fnd_user',
' where user_id = :F4050_P53_USER_ID'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>2
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48946423742773239.4052)
,p_query_column_id=>1
,p_column_alias=>'USER_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nom utilisateur'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48946512249773239.4052)
,p_query_column_id=>2
,p_column_alias=>'FIRST_NAME'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Pr\00E9nom')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48946614685773239.4052)
,p_query_column_id=>3
,p_column_alias=>'LAST_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nom'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48946718700773239.4052)
,p_query_column_id=>4
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>4
,p_column_heading=>'Description'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48946830175773239.4052)
,p_query_column_id=>5
,p_column_alias=>'EMAIL_ADDRESS'
,p_column_display_sequence=>5
,p_column_heading=>'Courriel'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48946902018773239.4052)
,p_query_column_id=>6
,p_column_alias=>'DEFAULT_SCHEMA'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Sch\00E9ma par d\00E9faut')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48947006063773239.4052)
,p_query_column_id=>7
,p_column_alias=>'SECURITY_GROUP_ID'
,p_column_display_sequence=>7
,p_column_heading=>'Espace de travail'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(71920520447343310.4052)
,p_plug_name=>unistr('R\00E9initialiser le mot de passe')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('R\00E9initialisez le mot de passe de l''utilisateur en g\00E9n\00E9rant un mot de passe al\00E9atoire par d\00E9faut ou en saisissant un nouveau mot de passe. Un courriel sera envoy\00E9 \00E0 l''utilisateur pour l''avertir de la modification du mot de passe.')
,p_plug_query_headings=>'User Name:First Name:Last Name:Description:Email:Default Schema:Security Group ID'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_mail.is_email_configured'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(222860680683540034.4052)
,p_plug_name=>unistr('R\00E9initialiser le mot de passe')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('R\00E9initialisez le mot de passe de l''utilisateur en g\00E9n\00E9rant un mot de passe al\00E9atoire par d\00E9faut ou en saisissant un nouveau mot de passe.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'not wwv_flow_mail.is_email_configured'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(71928331765356926.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(71896102812290746.4052)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:53::'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(71930910079360146.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(71896102812290746.4052)
,p_button_name=>'Save'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Modifier le mot de passe'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(71931303937360148.4052)
,p_branch_action=>'12'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(71898928679293879.4052)
,p_name=>'P53_PASSWORD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(71896102812290746.4052)
,p_prompt=>'Mot de passe'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>255
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Saisissez le nouveau mot de passe.'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(71906923922311296.4052)
,p_name=>'F4050_P53_USER_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(71892807988288321.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(481109527842703479.4052)
,p_name=>'P53_PASSWORD2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(71896102812290746.4052)
,p_prompt=>'Confirmer le mot de passe'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>255
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Entrez de nouveau le mot de passe.'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(481110803517715438.4052)
,p_name=>'P53_PASSWORD_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(71896102812290746.4052)
,p_item_default=>'G'
,p_prompt=>'Type de mot de passe :'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'RESET PASSWORD TYPE'
,p_lov=>'.'||wwv_flow_api.id(25472316973371525.4052)||'.'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Indiquez si vous voulez g\00E9n\00E9rer le nouveau mot de passe ou en saisir un.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(481155122573796532.4052)
,p_name=>'P53_GEN_PASSWORD'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(71896102812290746.4052)
,p_use_cache_before_default=>'NO'
,p_source=>'wwv_flow_provision.get_random_password(6)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(71901726307295001.4052)
,p_validation_name=>'P53_PASSWORD Not Null'
,p_validation_sequence=>10
,p_validation=>'P53_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Vous devez indiquer un mot de passe.'
,p_validation_condition=>'P53_PASSWORD_TYPE'
,p_validation_condition2=>'D'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(71898928679293879.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 11-JUL-2002 09:59'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(481133310836745905.4052)
,p_validation_name=>'P53_PASSWORD2 Not Null'
,p_validation_sequence=>20
,p_validation=>'P53_PASSWORD2'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Vous devez indiquer un mot de passe de confirmation.'
,p_validation_condition=>'P53_PASSWORD_TYPE'
,p_validation_condition2=>'D'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(481109527842703479.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 11-JUL-2002 09:59'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(481134317678766766.4052)
,p_validation_name=>'P53_PASSWORD matches P53_PASSWORD2'
,p_validation_sequence=>30
,p_validation=>':P53_PASSWORD = :P53_PASSWORD2'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Le mot de passe n''a pas \00E9t\00E9 confirm\00E9 correctement. Saisissez exactement le m\00EAme mot de passe les deux fois.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P53_PASSWORD is not null and',
':P53_PASSWORD2 is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(71898928679293879.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(481158606821829923.4052)
,p_name=>'hide password'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P53_PASSWORD_TYPE'
,p_condition_element=>'P53_PASSWORD_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'G'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(481158912890829933.4052)
,p_event_id=>wwv_flow_api.id(481158606821829923.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P53_PASSWORD,P53_PASSWORD2'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(481159325998844871.4052)
,p_name=>'show password'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P53_PASSWORD_TYPE'
,p_condition_element=>'P53_PASSWORD_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'D'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(481159613309844872.4052)
,p_event_id=>wwv_flow_api.id(481159325998844871.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P53_PASSWORD,P53_PASSWORD2'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(71891512517286221.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update passwd'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P53_PASSWORD_TYPE = ''D'' then',
'',
'begin',
'  wwv_flow_api.g_fnd_user_password_action := true;',
'  update wwv_flow_fnd_user ',
'     set web_password = :P53_PASSWORD,',
'         change_password_on_first_use = ''Y'', ',
'         first_password_use_occurred = ''N''',
'   where user_id = :F4050_P53_USER_ID;',
'  wwv_flow_api.g_fnd_user_password_action := false;',
'exception when others then  ',
'  wwv_flow.update_cache_with_write(''P53_PASSWORD'',null);',
'  wwv_flow.update_cache_with_write(''P53_PASSWORD2'',null);',
'  wwv_flow.update_cache_with_write(''P53_GEN_PASSWORD'',null);',
'  raise_application_error(-20001,wwv_flow_lang.system_message(''WWV_FLOW_CHANGE_PASSWORD.PSSWD_ERR''));',
'end;',
'',
'else',
'',
'begin',
'  wwv_flow_api.g_fnd_user_password_action := true;',
'  update wwv_flow_fnd_user ',
'     set web_password = :P53_GEN_PASSWORD,',
'         change_password_on_first_use = ''Y'', ',
'         first_password_use_occurred = ''N''',
'   where user_id = :F4050_P53_USER_ID;',
'  wwv_flow_api.g_fnd_user_password_action := false;',
'exception when others then',
'  wwv_flow.update_cache_with_write(''P53_PASSWORD'',null);',
'  wwv_flow.update_cache_with_write(''P53_PASSWORD2'',null);',
'  wwv_flow.update_cache_with_write(''P53_GEN_PASSWORD'',null);',
'',
' raise_application_error(-20001,wwv_flow_lang.system_message(''WWV_FLOW_CHANGE_PASSWORD.PSSWD_ERR''));',
'end;',
'',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Erreur lors de la r\00E9initialisation du mot de passe.')
,p_process_when=>'nvl(:REQUEST,''Save'') = ''Save'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('Mot de passe r\00E9initialis\00E9.  ')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(71951012622422885.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'send email'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_msg    varchar2(4000);',
'   l_subj   varchar2(255);',
'   l_p      varchar2(256);     ',
'begin',
'if :P53_PASSWORD_TYPE = ''D'' then',
'   l_p := v(''P53_PASSWORD'');',
'else',
'   l_p := v(''P53_GEN_PASSWORD'');',
'end if;',
'   ',
'wwv_flow.update_cache_with_write(''P53_PASSWORD'',null);',
'wwv_flow.update_cache_with_write(''P53_PASSWORD2'',null);',
'wwv_flow.update_cache_with_write(''P53_GEN_PASSWORD'',null);',
'',
'for  c1 in (select user_name, last_name, first_name, email_address, security_group_id',
'            from wwv_flow_fnd_user',
'            where user_id = :F4050_P53_USER_ID) ',
'loop',
'  l_subj:= wwv_flow_lang.system_message(''F4050_EMAIL_SUBJECT_PASSWORD_CHANGED'');',
'  l_msg:=l_msg || wwv_flow_lang.system_message(''F4050_EMAIL_BODY_PASSWORD_CHANGED'',c1.user_name) || ',
'          chr(10) || chr(10);',
'  l_msg:=l_msg || wwv_flow_lang.system_message(''F4050_EMAIL_BODY_NEW_PASSWORD'')||'':  '' || l_p || ',
'          chr(10) || chr(10);',
'',
'  l_msg:=l_msg || wwv_flow_mail.get_instance_url (p_security_group_id => c1.security_group_id ) || chr(10); ',
'',
'  wwv_flow_mail.send(p_to    => c1.email_address,                     ',
'                     p_from  => nvl(wwv_flow_platform.get_preference(''SMTP_FROM''),c1.email_address),',
'                     p_body  => l_msg,',
'                     p_subj  => l_subj,',
'                     p_cc    => null);',
'end loop;',
'wwv_flow_mail.push_queue_background;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors de l''envoi du courriel.'
,p_process_when=>'wwv_flow_mail.is_email_configured'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('Courriel envoy\00E9.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(359769230375616804.4052)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'53'
);
end;
/
prompt --application/pages/page_00054
begin
wwv_flow_api.create_page(
 p_id=>54.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Ev\00E9nements de page par jour')
,p_step_title=>unistr('Ev\00E9nements de page par jour')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(171237511268284524.4052)
,p_plug_name=>unistr('Ev\00E9nements de page par jour')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P54a */',
'       to_char(time_stamp,''YYYY.MM.DD Day'') day, ',
'       count(*) page_events, ',
'       sum(decode(PAGE_MODE,''A'',0,1)) page_views, ',
'       count(distinct security_group_id) workspaces,',
'       sum(nvl(content_length,0)) content_length',
'from wwv_flow_activity_log l',
'where l.time_stamp>=(select sysdate - to_number(',
'nvl(:P54_INCLUDE,1)) x from dual ) ',
'group by to_char(time_stamp,''YYYY.MM.DD Day'')',
'order by 1 desc'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(171237618830284524.4052)
,p_name=>'Page Views by Day'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(171237827128284533.4052)
,p_db_column_name=>'DAY'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Jour'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(171237930312284535.4052)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Vues de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(171239512278309693.4052)
,p_db_column_name=>'WORKSPACES'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Espaces de travail'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(171240226607323292.4052)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Ev\00E9nements de page')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(200564107218911437.4052)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Contenu'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200563315745904438.4052)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(248917204401238233.4052)
,p_plug_name=>'Vues de page par jour'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Cet \00E9tat affiche toutes les vues de page de cette instance, regroup\00E9es par jour.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200570012113941288.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(200563315745904438.4052)
,p_button_name=>'P54_SET'
,p_button_static_id=>'P54_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('D\00E9finir')
,p_request_source=>'Set'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200569504841939221.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(200563315745904438.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:54:&SESSION.::&DEBUG.:54,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200564508735921337.4052)
,p_name=>'P54_INCLUDE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(200563315745904438.4052)
,p_item_default=>'to_number(.000694444)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Heure'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Limitez l''\00E9tat \00E0 une tranche de temps sp\00E9cifique. Indiquez la quantit\00E9 de temps \00E0 inclure dans l''\00E9tat et cliquez sur <strong>D\00E9finir</strong>.<p />'),
unistr('Si vous s\00E9lectionnez 1 jour, seules les derni\00E8res 24 heures s''affichent.  ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(514940685077998802.4052)
,p_computation_sequence=>10
,p_computation_item=>'P54_INCLUDE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return to_number(:P54_INCLUDE);',
'exception',
'    when others then',
'        return to_number(.000694444);',
'end;        '))
);
end;
/
prompt --application/pages/page_00055
begin
wwv_flow_api.create_page(
 p_id=>55.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Approuver une demande de provisionnement '
,p_step_title=>'Approuver une demande de provisionnement '
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216766430018595041)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>'AEADM/adm_create_wkspc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(225164729934.4052)
,p_plug_name=>'Approve'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS_INITCAP'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(72893511420289265.4052)
,p_plug_name=>'Approuver une demande de provisionnement '
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829706609080810173.4052)
,p_plug_display_sequence=>20
,p_plug_source=>unistr('L''approbation de cette demande entra\00EEnera la cr\00E9ation d''un sch\00E9ma de base de donn\00E9es, la cr\00E9ation d''une connexion pour un administrateur d''espace de travail et l''envoi d''un courriel d''approbation. Comptez environ 30 secondes pour la cr\00E9ation du compt')
||'e.'
,p_plug_query_headings_type=>'QUERY_COLUMNS_INITCAP'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(72938202558059173.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(225164729934.4052)
,p_button_name=>'Approve'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Approuver et envoyer un courriel'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(72933229308047993.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(225164729934.4052)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:55::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(231152215417604601.4052)
,p_branch_action=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(72938202558059173.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22117323900740039.4052)
,p_name=>'F4050_P55_ACCEPT_MSG'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(72893511420289265.4052)
,p_prompt=>'Courriel : '
,p_source=>'wwv_flow_lang.system_message(''APEX.EMAIL.WS_REQ_APPR_INTRO'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>15
,p_display_when=>'wwv_flow_platform.get_preference(''SERVICE_REQUEST_FLOW'') = ''EMAIL'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72898300637294240.4052)
,p_name=>'F4050_P55_APPROVE_MSG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(72893511420289265.4052)
,p_prompt=>'Courriel'
,p_source=>'wwv_flow_lang.system_message(''APEX.EMAIL.WS_REQ_APPR_READY_INTRO'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>15
,p_display_when=>'wwv_flow_platform.get_preference(''SERVICE_REQUEST_FLOW'') = ''4700'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(213504146316.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Provision company now'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_fnd_developer_api.f4050_55_provision_workspace(',
'   p_provision_id       => :PROVISION_ID,',
'   p_approval_message   => :F4050_P55_APPROVE_MSG,',
'   p_acceptance_message => :F4050_P55_ACCEPT_MSG',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors du provisionnement de l''espace de travail &P4_COMPANY_NAME..'
,p_process_when_button_id=>wwv_flow_api.id(72938202558059173.4052)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_schema varchar2(30);',
'begin',
'    for c1 in (select upper(schema_name) sa1',
'                 from wwv_flow_provision_company',
'                where id = :PROVISION_ID) loop',
'        l_schema := c1.sa1;',
'    end loop;',
'',
'    if l_schema is not null then        ',
'        for c1 in (select 1',
'                     from sys.dual',
'                    where wwv_flow_provisioning.restricted_schema_i(',
'                          l_schema, :P4_COMPANY_NAME) = 1',
'                      and wwv_flow_provisioning.site_admin_is_restricted_i = 1) loop',
'            return false;',
'        end loop;',
'',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;'))
,p_process_when_type=>'FUNCTION_BODY'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('Espace de travail &P4_COMPANY_NAME. accept\00E9 et courriel d''approbation envoy\00E9.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(359770518516632382.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'55'
);
end;
/
prompt --application/pages/page_00056
begin
wwv_flow_api.create_page(
 p_id=>56.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Refuser une demande de provisionnement'
,p_step_title=>'Refuser une demande de provisionnement'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216766430018595041)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>'AEADM/adm_create_wkspc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(73108300635357821.4052)
,p_plug_name=>'Refuser une demande de provisionnement'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829706609080810173.4052)
,p_plug_display_sequence=>30
,p_plug_source=>unistr('Le refus de la demande entra\00EEnera le rejet de la demande d''espace de travail et le demandeur en sera inform\00E9 par courriel. Vous devez choisir Supprimer une demande pour autoriser un espace de travail de m\00EAme nom \00E0 faire l''objet d''une nouvelle demande')
||'.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(955890678433997317.4052)
,p_plug_name=>'boutons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(73116915409365767.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(955890678433997317.4052)
,p_button_name=>'Decline'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refuser et envoyer un courriel'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(73113102942362154.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(955890678433997317.4052)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:56::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(73117322203365771.4052)
,p_branch_action=>'26'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(73116915409365767.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(73135015059381475.4052)
,p_name=>'F4050_P56_DECLINE_MSG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(73108300635357821.4052)
,p_prompt=>'Courriel'
,p_source=>'wwv_flow_lang.system_message(''APEX.EMAIL.WS_REQ_DECL_INTRO'');'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>15
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Message personnalis\00E9 pour le demandeur d''espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(663452364602166114.4052)
,p_name=>'P56_DELETE_REQUEST'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(73108300635357821.4052)
,p_item_default=>'Y'
,p_prompt=>'Supprimer une demande'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(225170763161.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Decline request'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_subj             varchar2(255);',
'   l_plain_format     varchar2(32767);',
'   l_formatted_html   varchar2(32767);',
'begin',
'    wwv_flow_provisioning.deny_request(p_id => :PROVISION_ID);',
'',
'    for  c1 in (select prov.admin_email, prov.admin_first_name, prov.admin_last_name, prov.security_group_id',
'                  from wwv_flow_provision_company prov',
'                 where prov.id = :PROVISION_ID',
'                   and prov.PROJECT_STATUS = ''DECLINED'') ',
'    loop',
'          wwv_flow_mail.get_formatted_message(',
'             p_provision_id      => :PROVISION_ID,',
'             p_message_type      => ''DECLINED'',',
'             p_custom_msg        => :F4050_P56_DECLINE_MSG,',
'             out_html            => l_formatted_html,',
'             out_plain           => l_plain_format);',
'        ',
'        l_subj := wwv_flow_lang.system_message(',
'            p_name => ''F4050.DECLINED_ACCOUNT_REQ_EMAIL_SUBJ'',',
'            p0     => c1.ADMIN_FIRST_NAME || '' '' ||c1.ADMIN_LAST_NAME',
'        );',
'',
'        wwv_flow_mail.send(',
'            p_to        => c1.admin_email,',
'            p_from      => nvl(wwv_flow_platform.get_preference(''SMTP_FROM''), c1.admin_email),',
'            p_body      => l_plain_format,',
'            p_body_html => l_formatted_html,',
'            p_subj      => l_subj,',
'            p_cc        => null',
'        );',
'    end loop;',
'',
'    if nvl(:P56_DELETE_REQUEST,''N'') = ''Y'' then',
'        delete from wwv_flow_provision_company where id = :PROVISION_ID;',
'    end if;',
'',
'    wwv_flow_mail.push_queue_background();',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors du traitement de la demande.'
,p_process_when_button_id=>wwv_flow_api.id(73116915409365767.4052)
,p_process_success_message=>unistr('Statut Refus\00E9 affect\00E9 \00E0 la demande &P4_COMPANY_NAME. et courriel envoy\00E9.')
);
end;
/
prompt --application/pages/page_00057
begin
wwv_flow_api.create_page(
 p_id=>57.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Cr\00E9er un th\00E8me public - Application')
,p_step_title=>unistr('Cr\00E9er un th\00E8me public')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931176884177111905)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_pub_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(138136012726914164.4052)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(138045104803643281.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(138136215748914164.4052)
,p_plug_name=>unistr('Cr\00E9er un th\00E8me public')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>10
,p_plug_header=>unistr('<p>Identifiez l''application de l''espace de travail s\00E9lectionn\00E9 o\00F9 r\00E9side le th\00E8me \00E0 copier.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208279100850551554.4052)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752110668997695867.4052)
,p_plug_name=>unistr('Cr\00E9er un th\00E8me public')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(138153021345947268.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208279100850551554.4052)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:47:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(138137300856914177.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208279100850551554.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:555:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(138137124005914175.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208279100850551554.4052)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(138139124623914184.4052)
,p_branch_action=>'f?p=&APP_ID.:58:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(138137124005914175.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138137503839914178.4052)
,p_name=>'P57_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(138136215748914164.4052)
,p_prompt=>'Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PUBLIC.THEME.APP.SELECTOR'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name d, id v',
'  from WWV_FLOWS',
' where security_group_id = :P47_WORKSPACE',
'   and security_group_id not in (0,10,11)',
' order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez l''application dans laquelle le th\00E8me \00E0 copier r\00E9side.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138175212575086624.4052)
,p_name=>'P57_WORKSPACE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(138136215748914164.4052)
,p_prompt=>'Espace de travail :'
,p_source=>'P47_WORKSPACE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_ALL_COMPANIES_NO_NULL_OPTION'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id > 0',
'  and  provisioning_company_id != 11',
'  and  provisioning_company_id != 12',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifie l''espace de travail dans lequel le th\00E8me d''application \00E0 copier r\00E9side.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(138209025445194385.4052)
,p_validation_name=>'P57_APPLICATION'
,p_validation_sequence=>10
,p_validation=>'P57_APPLICATION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('L''application doit \00EAtre indiqu\00E9e.')
,p_when_button_pressed=>wwv_flow_api.id(138137124005914175.4052)
,p_associated_item=>wwv_flow_api.id(138137503839914178.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00058
begin
wwv_flow_api.create_page(
 p_id=>58.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Cr\00E9er un th\00E8me public - Th\00E8me')
,p_step_title=>unistr('Cr\00E9er un th\00E8me public')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931176884177111905)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_pub_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(138140920605918465.4052)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(138045104803643281.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(138141116387918465.4052)
,p_plug_name=>unistr('Cr\00E9er un th\00E8me public')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>10
,p_plug_header=>unistr('<p>Identifiez les th\00E8mes \00E0 copier dans le r\00E9f\00E9rentiel de th\00E8mes publics.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208327612465668473.4052)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752110789883695868.4052)
,p_plug_name=>unistr('Cr\00E9er un th\00E8me public')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(138158100614969669.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208327612465668473.4052)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:57:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(138142223665918467.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208327612465668473.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:555:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(138142002007918467.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208327612465668473.4052)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(138144008862918469.4052)
,p_branch_action=>'f?p=&APP_ID.:48:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(138142002007918467.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138142915903918468.4052)
,p_name=>'P58_THEME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(138141116387918465.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Th\00E8me \00E0 copier')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where security_group_id = :P47_WORKSPACE',
'  and flow_id = :P57_APPLICATION',
'order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifie le th\00E8me \00E0 copier dans le r\00E9f\00E9rentiel de th\00E8mes publics.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138192524789146971.4052)
,p_name=>'P58_WORKSPACE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(138141116387918465.4052)
,p_prompt=>'Espace de travail :'
,p_source=>'P47_WORKSPACE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_ALL_COMPANIES_NO_NULL_OPTION'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id > 0',
'  and  provisioning_company_id != 11',
'  and  provisioning_company_id != 12',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifie l''espace de travail dans lequel le th\00E8me d''application \00E0 copier r\00E9side.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138194511068152390.4052)
,p_name=>'P58_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(138141116387918465.4052)
,p_prompt=>'Application :'
,p_source=>'P57_APPLICATION'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PUBLIC.THEME.APP.SELECTOR'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name d, id v',
'  from WWV_FLOWS',
' where security_group_id = :P47_WORKSPACE',
'   and security_group_id not in (0,10,11)',
' order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez l''application dans laquelle le th\00E8me \00E0 copier r\00E9side.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1429076056376875906.4052)
,p_name=>'P58_SUBSCRIBE_THEME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(138141116387918465.4052)
,p_item_default=>'N'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>unistr('Indiquez si le th\00E8me public doit \00EAtre abonn\00E9 au th\00E8me s\00E9lectionn\00E9. Le th\00E8me public sera ainsi mis \00E0 jour avec les modifications apport\00E9es au th\00E8me s\00E9lectionn\00E9 ult\00E9rieurement.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_00059
begin
wwv_flow_api.create_page(
 p_id=>59.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Param\00E8tres d''espace de travail')
,p_step_title=>unistr('Param\00E8tres d''espace de travail')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(704456563630760825.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_comp.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(173281331752752178.4052)
,p_plug_name=>unistr('Param\00E8tres d''espace de travail')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(173288117299797704.4052)
,p_plug_name=>unistr('Param\00E8tres d''espace de travail : &P59_SHORT_NAME.')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(173290507996823360.4052)
,p_plug_name=>'Message d''espace de travail'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(502221800416182760.4052)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Contr\00F4lez la disponibilit\00E9 des composants par espace de travail.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(955890812785997319.4052)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(195775112470763477.4052)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(173281732345752184.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(173288117299797704.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(173281530427752183.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(173288117299797704.4052)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'NEXT'
,p_button_condition=>'P59_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(173281906971752184.4052)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(173282117191752185.4052)
,p_name=>'P59_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(173281331752752178.4052)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(173282307369752201.4052)
,p_name=>'P59_BUILDER_NOTIFICATION_MESSA'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(173290507996823360.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Message'
,p_source=>'BUILDER_NOTIFICATION_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez le message \00E0 afficher sur la page d''accueil de cet espace de travail et dans App Builder.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(173282502471752203.4052)
,p_name=>'P59_ALLOW_APP_BUILDING_YN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(173281331752752178.4052)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Activer App Builder'
,p_source=>'ALLOW_APP_BUILDING_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('D\00E9termine la disponibilit\00E9 d''App Builder pour cet espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(173282723495752204.4052)
,p_name=>'P59_ALLOW_SQL_WORKSHOP_YN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(173281331752752178.4052)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Activer SQL Workshop'
,p_source=>'ALLOW_SQL_WORKSHOP_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('D\00E9termine la disponibilit\00E9 de SQL Workshop pour cet espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(173282909754752204.4052)
,p_name=>'P59_ALLOW_WEBSHEET_DEV_YN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(173281331752752178.4052)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_source=>'ALLOW_WEBSHEET_DEV_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>unistr('D\00E9termine la disponibilit\00E9 de Websheet Development pour cet espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(173283131136752205.4052)
,p_name=>'P59_ALLOW_TEAM_DEVELOPMENT_YN'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(173281331752752178.4052)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>unistr('Activer le d\00E9veloppement d''\00E9quipe')
,p_source=>'ALLOW_TEAM_DEVELOPMENT_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('D\00E9termine la disponibilit\00E9 du d\00E9veloppement d''\00E9quipe pour cet espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(500066311950007719.4052)
,p_name=>'P59_ALLOW_PLSQL_EDITING_YN'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(173281331752752178.4052)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Autoriser la modification du code PL/SQL dans SQL Workshop'
,p_source=>'ALLOW_PLSQL_EDITING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Autorisez la modification des proc\00E9dures, packages, fonctions et d\00E9clencheurs PL/SQL dans le navigateur Web.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(955890992447997320.4052)
,p_name=>'P59_SHORT_NAME'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(173281331752752178.4052)
,p_use_cache_before_default=>'NO'
,p_source=>'SHORT_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(499983019763882546.4052)
,p_computation_sequence=>10
,p_computation_item=>'P59_ALLOW_WEBSHEET_DEV_YN'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P59_ALLOW_APP_BUILDING_YN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(378102002917566360.4052)
,p_computation_sequence=>20
,p_computation_item=>'P59_ALLOW_PLSQL_EDITING_YN'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
,p_compute_when=>'P59_ALLOW_SQL_WORKSHOP_YN'
,p_compute_when_text=>'N'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(504251027783126810.4052)
,p_name=>'Show/Hide Allow PLSQL'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P59_ALLOW_SQL_WORKSHOP_YN'
,p_condition_element=>'P59_ALLOW_SQL_WORKSHOP_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504251307730126815.4052)
,p_event_id=>wwv_flow_api.id(504251027783126810.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P59_ALLOW_PLSQL_EDITING_YN'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504251508368126817.4052)
,p_event_id=>wwv_flow_api.id(504251027783126810.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P59_ALLOW_PLSQL_EDITING_YN'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(173283405938752205.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_COMPANIES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_COMPANIES'
,p_attribute_03=>'P59_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Impossible d''extraire la ligne.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(173283624443752206.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_COMPANIES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_COMPANIES'
,p_attribute_03=>'P59_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Impossible de traiter la ligne de la table WWV_FLOW_COMPANIES.'
,p_process_success_message=>unistr('Action trait\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(173283826209752207.4052)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'59'
);
end;
/
prompt --application/pages/page_00061
begin
wwv_flow_api.create_page(
 p_id=>61.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Journaux des activit\00E9s de vue de page')
,p_step_title=>unistr('Journaux des activit\00E9s de vue de page')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216783731365642767)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>'AEADM/adm_logs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3365221264702845.4052)
,p_plug_name=>'Statut de journal'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select min(time_stamp) f, max(time_stamp) l, count(*) c',
'           from wwv_flow_activity_log1$) loop',
'   sys.htp.p(''<br />'');',
'   sys.htp.bold(wwv_flow_lang.system_message(''LOG'',''Log'')||'' 1: wwv_flow_activity_log1$'');',
'   sys.htp.br; sys.htp.p(wwv_flow_lang.system_message(''FIRST_ENTRY'')||'': ''||to_char(c1.f,''&LONG_DATE_FORMAT. &TIME_FORMAT.''));',
'   sys.htp.br; sys.htp.p(wwv_flow_lang.system_message(''LAST_ENTRY'')||'': ''||to_char(c1.l,''&LONG_DATE_FORMAT. &TIME_FORMAT.''));',
'   sys.htp.br; sys.htp.p(wwv_flow_lang.system_message(''COUNT'')||'': ''||to_char(c1.c,''999,999,999,999,990''));',
'end loop;',
'for c1 in (select min(time_stamp) f, max(time_stamp) l, count(*) c',
'           from wwv_flow_activity_log2$) loop',
'   sys.htp.br; sys.htp.br; ',
'   sys.htp.bold(wwv_flow_lang.system_message(''LOG'',''Log'')||'' 2: wwv_flow_activity_log2$'');',
'   sys.htp.br; sys.htp.p(wwv_flow_lang.system_message(''FIRST_ENTRY'')||'': ''||to_char(c1.f,''&LONG_DATE_FORMAT. &TIME_FORMAT.''));',
'   sys.htp.br; sys.htp.p(wwv_flow_lang.system_message(''LAST_ENTRY'')||'': ''||to_char(c1.l,''&LONG_DATE_FORMAT. &TIME_FORMAT.''));',
'   sys.htp.br; sys.htp.p(wwv_flow_lang.system_message(''COUNT'')||'': ''||to_char(c1.c,''999,999,999,999,990''));',
'end loop;',
'for c1 in (select * from wwv_flow_log_numbers where log_name = ''ACTIVITY'') loop',
'   sys.htp.br; sys.htp.br;',
'   sys.htp.bold(wwv_flow_lang.system_message(''4050_61_ACTIVE_LOG''));',
'   sys.htp.br; sys.htp.p(wwv_flow_lang.system_message(''4050_61_CURRENT_LOG_NO'')||'': ''||c1.CURRENT_LOG_NUMBER);',
'   sys.htp.br; sys.htp.p(wwv_flow_lang.system_message(''4050_61_CUR_LOG_TIME'')||'': ''||',
'      to_char(c1.log_switched_date,''&LONG_DATE_FORMAT. &TIME_FORMAT.''));',
'   sys.htp.p(''<br>&nbsp;<br><strong>''||wwv_flow_lang.system_message(''LOG_INTERVAL'')||''</strong>:<br>'');',
'   sys.htp.p(wwv_flow_lang.system_message(''4050_61_INTERVAL_DAYS'')||'': ''||c1.log_switch_after_days);',
'   sys.htp.p(''<br />''||wwv_flow_lang.system_message(''4050_61_NEXT_LOG_SWITCH'')||'': ''||',
'     to_char(c1.log_switched_date + c1.log_switch_after_days,',
'     ''&LONG_DATE_FORMAT. &TIME_FORMAT.''));',
'   sys.htp.p(''<br />''||wwv_flow_lang.system_message(''4050_61_HOURS_UNTIL'')||'': ''||to_char(',
'      ((c1.log_switched_date + c1.log_switch_after_days) - sysdate) * 24,''999,999,990.000''));',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3365902695706940.4052)
,p_plug_name=>unistr('Journaux des activit\00E9s de vue de page')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--sideRegion:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('&PRODUCT_NAME. consigne l''activit\00E9 des utilisateurs dans deux journaux. A tout moment, un journal peut \00EAtre d\00E9sign\00E9 comme journal en cours. Pour chaque vue de page affich\00E9e, le moteur &PRODUCT_NAME. ins\00E8re une ligne dans le fichier journal. Il y a ch')
||unistr('angement de journal en cours \00E0 l''issue de l''intervalle indiqu\00E9 dans cette page. Le moteur &PRODUCT_NAME. enl\00E8ve alors toutes les entr\00E9es du journal qui n''est pas en cours et le d\00E9signe comme journal en cours. ')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(982232364415899647.4052)
,p_plug_name=>'Boutons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1080990124415523934.4052)
,p_plug_name=>unistr('Journaux des activit\00E9s de vue de page')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3380119972759223.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(982232364415899647.4052)
,p_button_name=>'MANAGE_LOGS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Vider des journaux'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&FLOW_ID.:62:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'class="BUTTON10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(37832832720730254.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(982232364415899647.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:RP:::'
,p_button_cattributes=>'class="button10"'
);
end;
/
prompt --application/pages/page_00062
begin
wwv_flow_api.create_page(
 p_id=>62.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Vider des journaux'
,p_step_title=>'Vider des journaux'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216783731365642767)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_logs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3378319841749695.4052)
,p_plug_name=>'Vidage de journal'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829706609080810173.4052)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Le vidage des tables de journalisation entra\00EEnera la suppression de toutes les entr\00E9es de journal. Les entr\00E9es de journal sont g\00E9n\00E9r\00E9es par les applications s''ex\00E9cutant en mode journalisation.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(982232597134899649.4052)
,p_plug_name=>'Boutons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3382006251764735.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(982232597134899649.4052)
,p_button_name=>'TRUNCATE_LOG_1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Vider le journal 1'
,p_button_position=>'NEXT'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3386510192775267.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(982232597134899649.4052)
,p_button_name=>'TRUNCATE_LOG_2'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Vider le journal 2'
,p_button_position=>'NEXT'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3379103350754380.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(982232597134899649.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:61:&SESSION.::&DEBUG.:::'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3386829123775269.4052)
,p_branch_action=>'61'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3384323220769569.4052)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'truncate log 1'
,p_process_sql_clob=>'execute immediate ''truncate table wwv_flow_activity_log1$'';'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors du vidage du journal 1.'
,p_process_when_button_id=>wwv_flow_api.id(3382006251764735.4052)
,p_process_success_message=>unistr('Journal 1 vid\00E9.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3392115864786425.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'truncate log 2'
,p_process_sql_clob=>'execute immediate ''truncate table wwv_flow_activity_log2$'';'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors du vidage du journal 2.'
,p_process_when_button_id=>wwv_flow_api.id(3386510192775267.4052)
,p_process_success_message=>unistr('Journal 2 vid\00E9.')
);
end;
/
prompt --application/pages/page_00063
begin
wwv_flow_api.create_page(
 p_id=>63.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Statut de session'
,p_step_title=>'Statut de session'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216784004831644541)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_sessions.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3414400551876616.4052)
,p_plug_name=>'Gestion des statuts de session'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(3417102067886535.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1104606511149216228.4052)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3416327217884305.4052)
,p_plug_name=>'Statut de session'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Cliquez sur les liens figurant dans cette page pour surveiller et g\00E9rer le r\00E9f\00E9rentiel de statuts de session.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_00064
begin
wwv_flow_api.create_page(
 p_id=>64.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Statistiques sur les statuts de session'
,p_step_title=>'Statistiques sur les statuts de session'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216784004831644541)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_sessions.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(26076915239076069.4052)
,p_name=>'Statistiques sur les statuts de session'
,p_template=>wwv_flow_api.id(721130166613730309.4052)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select (select count(*) from wwv_flow_sessions$) thecount,',
'       (select count(*) from wwv_flow_data) cache_entries,',
'       (select count(*) from wwv_flow_data)/(select count(*) from wwv_flow_sessions$) avg_per_session',
'  from dual'))
,p_header=>unistr('<p>Les sessions d''application conservent le statut de session entre les vues de page d''application. Il peut y avoir pour chaque session z\00E9ro, une ou plusieurs entr\00E9es (\00E9l\00E9ments d''application) servant \00E0 conserver le statut de la session. Chaque utilis')
||'ateur peut avoir une ou plusieurs sessions.</p>'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>2
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(26077314226076090.4052)
,p_query_column_id=>1
,p_column_alias=>'THECOUNT'
,p_column_display_sequence=>1
,p_column_heading=>'Sessions'
,p_column_format=>'999G999G999G999G990'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(26077427148076090.4052)
,p_query_column_id=>2
,p_column_alias=>'CACHE_ENTRIES'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Nombre total d''entr\00E9es de statut de session')
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(26077613945076090.4052)
,p_query_column_id=>3
,p_column_alias=>'AVG_PER_SESSION'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Nombre moyen d''entr\00E9es par session')
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(982232636079899650.4052)
,p_plug_name=>'Boutons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1080986871939523901.4052)
,p_plug_name=>'Statistiques sur les statuts de session'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>11
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3481228031168376.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(982232636079899650.4052)
,p_button_name=>'PURGE_SESSIONS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Purger les sessions'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:66:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19629412621244661.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(982232636079899650.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:63:&SESSION.::&DEBUG.:::'
);
end;
/
prompt --application/pages/page_00065
begin
wwv_flow_api.create_page(
 p_id=>65.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Derni\00E8res sessions')
,p_step_title=>unistr('Derni\00E8res sessions')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216784004831644541)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_sessions.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3426218737919742.4052)
,p_plug_name=>unistr('Derni\00E8res sessions')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Cette page r\00E9pertorie toutes les sessions des espaces de travail g\00E9r\00E9s par ce service.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472649322781647206.4052)
,p_plug_name=>unistr('Derni\00E8res sessions')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    ''<a href="f?p=&FLOW_ID.:67:''||:FLOW_SESSION||'':::67:P67_SESSION_ID:''||s.id||''">''||s.id||''</a>'' id,',
'    s.created_on,',
'    s.username,',
'    c.short_name workspace_name,',
'    s.remote_addr,',
'    s.idle_timeout_on,',
'    s.life_timeout_on',
'from WWV_FLOW_SESSIONS$ s,',
'     wwv_flow_companies c',
'where s.security_group_id = c.provisioning_company_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(472649430593647206.4052)
,p_name=>'Recent Sessions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472649625084647211.4052)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID de session'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472649805920647214.4052)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Cr\00E9\00E9')
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_FORMAT. HH24:MI:SS Day'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(217246420447662394.4052)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Nom de l''espace de travail'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(93233311113568936.4052)
,p_db_column_name=>'USERNAME'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Nom utilisateur'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(93233529432575589.4052)
,p_db_column_name=>'IDLE_TIMEOUT_ON'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('D\00E9lai<br/>d''inactivit\00E9')
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_FORMAT. HH24:MI:SS Day'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(93233618362575590.4052)
,p_db_column_name=>'LIFE_TIMEOUT_ON'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>unistr('D\00E9lai<br/>d''activit\00E9')
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_FORMAT. HH24:MI:SS Day'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(93233808716600352.4052)
,p_db_column_name=>'REMOTE_ADDR'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Adresse distante'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(195763010848676782.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(472649322781647206.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:65:&SESSION.::&DEBUG.:RP,65,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3484821928176079.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(472649322781647206.4052)
,p_button_name=>'PURGE_SESSIONS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Purger les sessions'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&FLOW_ID.:66:&SESSION.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3424913014912195.4052)
,p_branch_action=>'65'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(25337511380084159.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_api.id(195763010848676782.4052)
);
end;
/
prompt --application/pages/page_00066
begin
wwv_flow_api.create_page(
 p_id=>66.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Purger les sessions'
,p_step_title=>'Purger les sessions'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216784004831644541)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_sessions.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3449327235035686.4052)
,p_plug_name=>'Purger les sessions'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829706609080810173.4052)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1080987058332523903.4052)
,p_plug_name=>'Boutons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3467901665132376.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1080987058332523903.4052)
,p_button_name=>'PURGE_SESSIONS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Purger les sessions'
,p_button_position=>'NEXT'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3456216462079941.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1080987058332523903.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&FLOW_ID.:63:&SESSION.'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3468212665132377.4052)
,p_branch_action=>'66'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(3467901665132376.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3468906167133685.4052)
,p_branch_action=>'63'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3451813299050623.4052)
,p_name=>'P66_MAX_SESSIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3449327235035686.4052)
,p_item_default=>'1000'
,p_prompt=>unistr('Nombre maximum de sessions \00E0 purger')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifiez le nombre maximum de sessions \00E0 supprimer.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3453000270056286.4052)
,p_name=>'P66_AGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3449327235035686.4052)
,p_prompt=>'Ne purger que les sessions de plus de'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Supprimez les sessions correspondant au moins \00E0 ce nombre de jours.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(149034515911867765.4052)
,p_validation_name=>'MaxSessionsNumeric'
,p_validation_sequence=>10
,p_validation=>'P66_MAX_SESSIONS'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('Le nombre maximum de sessions doit \00EAtre num\00E9rique.')
,p_when_button_pressed=>wwv_flow_api.id(3467901665132376.4052)
,p_associated_item=>wwv_flow_api.id(3451813299050623.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3469927637139934.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'purge sessions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_cache.purge_oldest_sessions (',
'p_num_sessions_to_purge     => :P66_MAX_SESSIONS,',
'p_purge_sess_older_then_hrs => :P66_AGE * 24);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors de la purge des sessions.'
,p_process_when_button_id=>wwv_flow_api.id(3467901665132376.4052)
,p_process_success_message=>unistr('Sessions purg\00E9es.')
);
end;
/
prompt --application/pages/page_00067
begin
wwv_flow_api.create_page(
 p_id=>67.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('D\00E9tails de session')
,p_step_title=>unistr('D\00E9tails de session')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216784004831644541)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_sessions.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(3500119382241626.4052)
,p_name=>'Session'
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID, ',
'       CREATED_ON,',
'       USERNAME,',
'       ON_NEW_INSTANCE_FIRED_FOR, ',
'       COOKIE_VALUE,',
'       SECURITY_GROUP_ID',
'  from WWV_FLOW_SESSIONS$',
'where id = :P67_SESSION_ID'))
,p_display_condition_type=>'NOT_DISPLAYING_INLINE_VALIDATION_ERRORS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>2
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Aucune donn\00E9e de session n''a \00E9t\00E9 trouv\00E9e.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48918208799773092.4052)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'ID de session'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48918511397773093.4052)
,p_query_column_id=>2
,p_column_alias=>'CREATED_ON'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Cr\00E9\00E9')
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(93232619524565011.4052)
,p_query_column_id=>3
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>4
,p_column_heading=>'Nom utilisateur'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48918702625773093.4052)
,p_query_column_id=>4
,p_column_alias=>'ON_NEW_INSTANCE_FIRED_FOR'
,p_column_display_sequence=>7
,p_column_heading=>unistr('D\00E9clenchement sur \00E9v\00E9nement de nouvelle instance pour')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(93232714943565012.4052)
,p_query_column_id=>5
,p_column_alias=>'COOKIE_VALUE'
,p_column_display_sequence=>6
,p_column_heading=>'Valeur de cookie'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48919009084773093.4052)
,p_query_column_id=>6
,p_column_alias=>'SECURITY_GROUP_ID'
,p_column_display_sequence=>5
,p_column_heading=>'Espace de travail'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22404018785536392.4052)
,p_plug_name=>'Statut de session'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select item_name,',
'       item_value,',
'       data_item_id item_id,',
'       session_state_status,',
'       application_id flow_id',
'  from wwv_flow_data_view',
' where session_id = :P67_SESSION_ID',
'order by 1'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NOT_DISPLAYING_INLINE_VALIDATION_ERRORS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(22404119048536392.4052)
,p_name=>'Session State'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22404301361536429.4052)
,p_db_column_name=>'ITEM_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('Nom d''\00E9l\00E9ment')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22404403927536434.4052)
,p_db_column_name=>'ITEM_VALUE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Valeur du statut de session'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22404501293536434.4052)
,p_db_column_name=>'ITEM_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Num\00E9ro de l''\00E9l\00E9ment')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22405709352553829.4052)
,p_db_column_name=>'SESSION_STATE_STATUS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Statut du statut de session'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22405814028553829.4052)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'ID d''application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(72939501718823858.4052)
,p_plug_name=>'Select'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3503225747252936.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(72939501718823858.4052)
,p_button_name=>'P67_GO'
,p_button_static_id=>'P67_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--padLeft'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('D\00E9finir')
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3505105446256528.4052)
,p_branch_action=>'67'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3500824577243155.4052)
,p_name=>'P67_SESSION_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(72939501718823858.4052)
,p_prompt=>'ID de session'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>'select id||'' - ''||nvl(username,wwv_flow_lang.system_message(''NULL_IN_PAREN''))||'' ''||security_group_id a, id from wwv_flow_sessions$ order by created_on desc'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(343399818250317904.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Identifiez l''ID de session.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(72924925155622381.4052)
,p_computation_sequence=>10
,p_computation_item=>'P67_SESSION_ID'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'trim(:P67_SESSION_ID)'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(72925505893626312.4052)
,p_validation_name=>'session numeric'
,p_validation_sequence=>10
,p_validation=>'P67_SESSION_ID'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('L''ID de session doit \00EAtre num\00E9rique.')
,p_associated_item=>wwv_flow_api.id(3500824577243155.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3503931288254475.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pg'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00068
begin
wwv_flow_api.create_page(
 p_id=>68.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Activit\00E9 par jour')
,p_step_title=>unistr('Activit\00E9 par jour')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(201316113467446335.4052)
,p_plug_name=>unistr('Activit\00E9 par jour')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    LOG_DAY,',
'    to_char(log_day,''Day'') day,',
'    count(distinct WORKSPACE_ID) workspaces,',
'    count(distinct APPLICATION_ID) applications,',
'    sum(page_events) PAGE_EVENTS,',
'    sum(page_views) PAGE_VIEWS,',
'    sum(page_accepts) PAGE_ACCEPTS,',
'    sum(partial_page_views) PARTIAL_PAGE_VIEWS,',
'    sum(websheet_views) WEBSHEET_VIEWS,',
'    sum(rows_fetched) ROWS_FETCHED,',
'    sum(ir_searches) IR_SEARCHES,',
'    sum(distinct_pages) DISTINCT_PAGES,',
'    sum(distinct_users) DISTINCT_USERS,',
'    sum(distinct_sessions) DISTINCT_SESSIONS,',
'    sum(total_render_time) TOTAL_RENDER_TIME,',
'    sum(error_count) ERROR_COUNT,',
'    sum(nvl(content_length,0)) content_length,',
'    sum(public_page_events) public_page_events',
'from WWV_FLOW_LOG_HISTORY ',
'group by LOG_DAY'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(201316216575446335.4052)
,p_name=>'Activity by Day'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201316428056446338.4052)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Consigner le jour dans le journal'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201316500422446339.4052)
,p_db_column_name=>'DAY'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Jour'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201316621937446340.4052)
,p_db_column_name=>'WORKSPACES'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Espaces de travail'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201316706177446341.4052)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201316823094446342.4052)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Ev\00E9nements de page')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(582264300897682814.4052)
,p_db_column_name=>'PUBLIC_PAGE_EVENTS'
,p_display_order=>15
,p_column_identifier=>'R'
,p_column_label=>unistr('Ev\00E9nements de page publique')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201316916848446343.4052)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>25
,p_column_identifier=>'F'
,p_column_label=>'Vues de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201317015142446344.4052)
,p_db_column_name=>'PAGE_ACCEPTS'
,p_display_order=>35
,p_column_identifier=>'G'
,p_column_label=>'Envois de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201317116723446345.4052)
,p_db_column_name=>'PARTIAL_PAGE_VIEWS'
,p_display_order=>45
,p_column_identifier=>'H'
,p_column_label=>'Vues de page partielle'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201317201964446346.4052)
,p_db_column_name=>'WEBSHEET_VIEWS'
,p_display_order=>55
,p_column_identifier=>'I'
,p_column_label=>'Vues de feuille Web'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_security_scheme=>wwv_flow_api.id(610289739776900562)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201317314218446347.4052)
,p_db_column_name=>'ROWS_FETCHED'
,p_display_order=>65
,p_column_identifier=>'J'
,p_column_label=>'Lignes extraites'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201317419181446348.4052)
,p_db_column_name=>'IR_SEARCHES'
,p_display_order=>75
,p_column_identifier=>'K'
,p_column_label=>unistr('Recherches d''\00E9tat interactif')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201317507501446349.4052)
,p_db_column_name=>'DISTINCT_PAGES'
,p_display_order=>85
,p_column_identifier=>'L'
,p_column_label=>'Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201317609579446350.4052)
,p_db_column_name=>'DISTINCT_USERS'
,p_display_order=>95
,p_column_identifier=>'M'
,p_column_label=>'Utilisateurs'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201317725892446351.4052)
,p_db_column_name=>'DISTINCT_SESSIONS'
,p_display_order=>105
,p_column_identifier=>'N'
,p_column_label=>'Sessions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201317813682446352.4052)
,p_db_column_name=>'TOTAL_RENDER_TIME'
,p_display_order=>115
,p_column_identifier=>'O'
,p_column_label=>'Temps d''affichage total'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201317914296446353.4052)
,p_db_column_name=>'ERROR_COUNT'
,p_display_order=>125
,p_column_identifier=>'P'
,p_column_label=>'Nombre d''erreurs'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201318025927446354.4052)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>135
,p_column_identifier=>'Q'
,p_column_label=>'Contenu'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(484703226739054598.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(201316113467446335.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:68:&SESSION.::&DEBUG.:68,RIR::'
);
end;
/
prompt --application/pages/page_00069
begin
wwv_flow_api.create_page(
 p_id=>69.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Vues de page par heure'
,p_step_title=>'Vues de page par heure'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23251413763556683.4052)
,p_plug_name=>'Button Bar'
,p_region_css_classes=>'a-Region--noTopBorder'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(201523520914118911.4052)
,p_plug_name=>'Vues de page par heure'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P69a */',
'    to_char(time_stamp,''YYYY.MM.DD HH24'') ts, ',
'count(*), ',
'sum(decode(page_mode,''A'',0,1)) page_views,',
'sum(decode(page_mode,''A'',1,0)) page_processing,',
'max(elap) max_elap, ',
'min(elap) min_elap, ',
'avg(elap) avg_elap,',
'count(distinct flow_id) distinct_applications,',
'count(distinct flow_id||''.''||step_id) distinct_pages,',
'sum(cached_regions) cached_regions,',
'count(distinct to_char(time_stamp,''YYYYMMDDHH24MI'')) distinct_minutes,',
'count(distinct userid) distinct_users',
'from WWV_FLOW_ACTIVITY_LOG',
'where time_stamp >= sysdate - nvl(:P69_TIME,1)',
'group by to_char(time_stamp,''YYYY.MM.DD HH24'')'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(201523601755118911.4052)
,p_name=>'Page Views by Hour'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201523804138118920.4052)
,p_db_column_name=>'TS'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Heure'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201523927023118922.4052)
,p_db_column_name=>'COUNT(*)'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Ev\00E9nements<br />de page')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201524028456118924.4052)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Vues de<br />page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201524104608118925.4052)
,p_db_column_name=>'PAGE_PROCESSING'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Traitement<br />de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201524215350118926.4052)
,p_db_column_name=>'MAX_ELAP'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Temps \00E9coul\00E9<br />maximum')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201524306502118927.4052)
,p_db_column_name=>'MIN_ELAP'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Temps \00E9coul\00E9<br />minimum ')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201524411012118928.4052)
,p_db_column_name=>'AVG_ELAP'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Temps \00E9coul\00E9<br />moyen')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201524715586118931.4052)
,p_db_column_name=>'CACHED_REGIONS'
,p_display_order=>8
,p_column_identifier=>'J'
,p_column_label=>unistr('R\00E9gions en<br />m\00E9moire cache')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201524915127118933.4052)
,p_db_column_name=>'DISTINCT_USERS'
,p_display_order=>9
,p_column_identifier=>'L'
,p_column_label=>'Utilisateurs<br />distincts'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201524818861118932.4052)
,p_db_column_name=>'DISTINCT_MINUTES'
,p_display_order=>10
,p_column_identifier=>'K'
,p_column_label=>'Minutes<br />distinctes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201524518368118929.4052)
,p_db_column_name=>'DISTINCT_APPLICATIONS'
,p_display_order=>11
,p_column_identifier=>'H'
,p_column_label=>'Applications<br />distinctes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201524622664118930.4052)
,p_db_column_name=>'DISTINCT_PAGES'
,p_display_order=>12
,p_column_identifier=>'I'
,p_column_label=>'Pages<br />distinctes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(10154323915376546.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(23251413763556683.4052)
,p_button_name=>'P69_GO'
,p_button_static_id=>'P69_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('D\00E9finir')
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(468249015740238071.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(23251413763556683.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:69:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10139722558253165.4052)
,p_name=>'P69_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(23251413763556683.4052)
,p_item_default=>'1'
,p_prompt=>'Depuis'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Limitez l''\00E9tat \00E0 une tranche de temps sp\00E9cifique. Indiquez la quantit\00E9 de temps \00E0 inclure dans l''\00E9tat et cliquez sur <strong>OK</strong>.<p />'),
unistr('Si vous s\00E9lectionnez 1 jour, seules les derni\00E8res 24 heures s''affichent.  ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00070
begin
wwv_flow_api.create_page(
 p_id=>70.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Rechercher les mises \00E0 jour disponibles')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Mises \00E0 jour disponibles')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931176884177111905)
,p_step_template=>wwv_flow_api.id(721098050798687927.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_dialog_height=>'240'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1143248891749567441.4052)
,p_plug_name=>'Check for Available Updates'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_header=>unistr('<p>Cette page permet de d\00E9finir quelles informations font l''objet de requ\00EAtes et sont envoy\00E9es \00E0 Oracle Corporation \00E0 partir de cette instance &PRODUCT_NAME.. </p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1143248948629567442.4052)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1143249049592567443.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1143248948629567442.4052)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1143249116879567444.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1143248948629567442.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1143249422016567447.4052)
,p_name=>'P70_SHOW_UPDATES'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1143248891749567441.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Rechercher les mises \00E0 jour disponibles')
,p_source=>'nvl( wwv_flow_platform.get_preference( ''CHECK_FOR_UPDATES'' ), ''Y'' )'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cet attribut contr\00F4le si cette instance &PRODUCT_NAME. est autoris\00E9e \00E0 v\00E9rifier si des mises \00E0 jour sont disponibles pour &PRODUCT_NAME. et Oracle REST Data Services. Si la v\00E9rification des mises \00E0 jour de produit est d\00E9sactiv\00E9e dans les services ')
||unistr('d''administration, il est prioritaire sur les pr\00E9f\00E9rences indiqu\00E9es par chaque d\00E9veloppeur.</p>'),
'',
unistr('<p>Remarque : pour effectuer cette v\00E9rification, &PRODUCT_NAME. transmet le num\00E9ro de version de &PRODUCT_NAME. et d''autres composants syst\00E8me \00E0 Oracle Corporation. Afin d''am\00E9liorer toujours plus ses produits, Oracle veut en savoir plus sur leur util')
||unistr('isation. Pour cela, des statistiques peuvent occasionnellement \00EAtre envoy\00E9es \00E0 Oracle pour d\00E9crire les fonctionnalit\00E9s de produit en cours d''utilisation. Aucune information d''identification personnelle ne sera envoy\00E9e. Vous pouvez consulter la <a hre')
||unistr('f="https://www.oracle.com/privacy">Charte de confidentialit\00E9 d''Oracle</a>.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Feature #1437'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1143249283022567445.4052)
,p_name=>'Cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1143249116879567444.4052)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1143249314939567446.4052)
,p_event_id=>wwv_flow_api.id(1143249283022567445.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1143249593714567448.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set CHECK_FOR_UPDATES'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_platform.set_preference( p_preference_name  => ''CHECK_FOR_UPDATES'',',
'                                  p_preference_value => :P70_SHOW_UPDATES );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1143249049592567443.4052)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1143249613585567449.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00071
begin
wwv_flow_api.create_page(
 p_id=>71.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'10 principales applications'
,p_step_title=>'10 principales applications'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(825642334996263219.4052)
,p_plug_name=>unistr('S\00E9lecteur d''affichage de r\00E9gion')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>11
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(880590463437877633.4052)
,p_plug_name=>'10 principales applications'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>21
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_jet_chart(
 p_id=>wwv_flow_api.id(880590808162877633.4052)
,p_region_id=>wwv_flow_api.id(880590463437877633.4052)
,p_chart_type=>'bar'
,p_height=>'320'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_spark_chart=>'N'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>false
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(880592091145877634.4052)
,p_chart_id=>wwv_flow_api.id(880590808162877633.4052)
,p_seq=>10
,p_name=>unistr('S\00E9rie 1')
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from (',
'    select sum(page_events) Page_Events,',
'    NVL((select max(name||'' - ''||f.id) from wwv_flows f where f.id = h.application_id), ''Unknown'') App_Name',
'from WWV_FLOW_LOG_HISTORY h',
'where log_day > sysdate - (NVL(:P71_SINCE,7)+1)',
'      and application_id not between 4000 and 5000',
'group by application_id',
'order by 1 desc) where rownum <= 10'))
,p_ajax_items_to_submit=>'P71_SINCE'
,p_items_value_column_name=>'PAGE_EVENTS'
,p_group_name_column_name=>'APP_NAME'
,p_items_label_column_name=>'APP_NAME'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'outsideBarEdge'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(880591690727877634.4052)
,p_chart_id=>wwv_flow_api.id(880590808162877633.4052)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(880591227860877634.4052)
,p_chart_id=>wwv_flow_api.id(880590808162877633.4052)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1651120171573687541.4052)
,p_name=>'Rapports des principales applications'
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>31
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select "Page Events" ,',
'       errors,',
'       "App Name",',
'       "App ID",',
'       max_DISTINCT_PAGES,',
'       most_recent_event,',
'       workspace_id,',
'       (select SHORT_NAME from wwv_flow_companies c where c.PROVISIONING_COMPANY_ID = x.workspace_id) workspace_name,',
'       (select count(*) from wwv_flow_steps s where s.flow_id = "App ID") app_pages,',
'       RANK() OVER (ORDER BY "Page Events" desc) app_rank',
'from (',
'select sum(page_events) "Page Events",',
'    nvl((select max(name) from wwv_flows where id = application_id),sm.t_not_available) "App Name",',
'    APPLICATION_ID "App ID", ',
'    workspace_id, ',
'    max(log_day) most_recent_event,',
'    sum(ERROR_COUNT) errors,',
'    max(DISTINCT_PAGES) max_DISTINCT_PAGES',
'from WWV_FLOW_LOG_HISTORY,',
'     (select wwv_flow_lang.system_message(''NOT AVAILABLE'') t_not_available from dual) sm',
'where log_day > sysdate - (NVL(:P71_SINCE,7)+1)',
'  and application_id not between 4000 and 5000',
'group by application_id, workspace_id, t_not_available',
'order by 1 desc) x',
'where rownum < 1001',
''))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P71_SINCE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>1001
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'ROWS_X_TO_Y'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>unistr('T\00E9l\00E9charger en local')
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(825610633969086340.4052)
,p_query_column_id=>1
,p_column_alias=>'Page Events'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Ev\00E9nements de page')
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(825514194192601245.4052)
,p_query_column_id=>2
,p_column_alias=>'ERRORS'
,p_column_display_sequence=>6
,p_column_heading=>'Erreurs'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(825611015173086340.4052)
,p_query_column_id=>3
,p_column_alias=>'App Name'
,p_column_display_sequence=>2
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(825611493328086341.4052)
,p_query_column_id=>4
,p_column_alias=>'App ID'
,p_column_display_sequence=>3
,p_column_heading=>'ID d''application'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(825514501334601249.4052)
,p_query_column_id=>5
,p_column_alias=>'MAX_DISTINCT_PAGES'
,p_column_display_sequence=>8
,p_column_heading=>'Nombre maximal quotidien de pages actives'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(825611801482086341.4052)
,p_query_column_id=>6
,p_column_alias=>'MOST_RECENT_EVENT'
,p_column_display_sequence=>9
,p_column_heading=>unistr('Ev\00E9nement le plus r\00E9cent')
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(825612268515086341.4052)
,p_query_column_id=>7
,p_column_alias=>'WORKSPACE_ID'
,p_column_display_sequence=>10
,p_column_heading=>'ID d''espace de travail'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(825612667154086341.4052)
,p_query_column_id=>8
,p_column_alias=>'WORKSPACE_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Espace de travail'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(825514679478601250.4052)
,p_query_column_id=>9
,p_column_alias=>'APP_PAGES'
,p_column_display_sequence=>7
,p_column_heading=>'Pages d''application'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(825613007733086342.4052)
,p_query_column_id=>10
,p_column_alias=>'APP_RANK'
,p_column_display_sequence=>1
,p_column_heading=>'Rang'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2518812136188497587.4052)
,p_plug_name=>'Button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>1
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(825613563870088243.4052)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(2518812136188497587.4052)
,p_button_name=>'RESET_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:71:&SESSION.::&DEBUG.:RR,71::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(880595465785924453.4052)
,p_name=>'P71_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2518812136188497587.4052)
,p_item_default=>'7'
,p_prompt=>'Depuis'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME_ARCHIVE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 30 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 186 t from dual union all',
'select ''9 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 279 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(390435721015898133.4052)
,p_name=>'Refresh Report'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P71_SINCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(390435829900898134.4052)
,p_event_id=>wwv_flow_api.id(390435721015898133.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(880590463437877633.4052)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(390435936009898135.4052)
,p_event_id=>wwv_flow_api.id(390435721015898133.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1651120171573687541.4052)
);
end;
/
prompt --application/pages/page_00072
begin
wwv_flow_api.create_page(
 p_id=>72.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Cr\00E9er un espace de travail - Identifier un administrateur')
,p_step_title=>unistr('Cr\00E9er un espace de travail')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(3931243707245169747)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_create_wkspc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12012705423629513.4052)
,p_plug_name=>unistr('Cr\00E9er &P27_WORKSPACE_TITLE.')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(187657525264854490.4052)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(12048115202363924.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202756611350719138.4052)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752110819847695868.4052)
,p_plug_name=>unistr('Cr\00E9er un espace de travail')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13216515182502313.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(202756611350719138.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(12021900060665808.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(202756611350719138.4052)
,p_button_name=>'next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(12022102892665810.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(202756611350719138.4052)
,p_button_name=>'previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(12023517029670675.4052)
,p_branch_action=>'73'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(12021900060665808.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(12024121877672100.4052)
,p_branch_action=>'79'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(12022102892665810.4052)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13216829929502321.4052)
,p_branch_action=>'10'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(13216515182502313.4052)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12014129318636436.4052)
,p_name=>'F4050_P72_ADMINNAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(12012705423629513.4052)
,p_prompt=>'Nom utilisateur de l''administrateur'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Saisissez le nom utilisateur de l''administrateur d''espace de travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12020406163658104.4052)
,p_name=>'F4050_P72_EMAIL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(12012705423629513.4052)
,p_prompt=>'Courriel'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez l''adresse \00E9lectronique de l''administrateur d''espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12850829056207052.4052)
,p_name=>'F4050_P72_ADMIN_PASS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(12012705423629513.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Mot de passe de l''administrateur'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>50
,p_cMaxlength=>2000
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_security_scheme=>wwv_flow_api.id(3699181830199)
,p_help_text=>'Identifiez le mot de passe de l''administrateur d''espace de travail.'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13027609755658621.4052)
,p_name=>'F4050_P72_FIRSTNAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(12012705423629513.4052)
,p_prompt=>unistr('Pr\00E9nom')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifiez le pr\00E9nom de l''administrateur.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13029600189665308.4052)
,p_name=>'F4050_P72_LASTNAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(12012705423629513.4052)
,p_prompt=>'Nom'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifiez le nom de l''administrateur.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3699176817193.4052)
,p_computation_sequence=>10
,p_computation_item=>'F4050_P72_ADMIN_PASS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_authentication_dev.create_shadow_user_password'
,p_security_scheme=>'!'||wwv_flow_api.id(3699181830199)
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(12975203588136370.4052)
,p_validation_name=>'username required'
,p_validation_sequence=>10
,p_validation=>'F4050_P72_ADMINNAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le nom utilisateur doit \00EAtre indiqu\00E9.')
,p_when_button_pressed=>wwv_flow_api.id(12021900060665808.4052)
,p_associated_item=>wwv_flow_api.id(12014129318636436.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(12987418375358280.4052)
,p_validation_name=>'admin password not null'
,p_validation_sequence=>20
,p_validation=>'F4050_P72_ADMIN_PASS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Un mot de passe d''administrateur doit \00EAtre indiqu\00E9.')
,p_when_button_pressed=>wwv_flow_api.id(12021900060665808.4052)
,p_associated_item=>wwv_flow_api.id(12850829056207052.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(12989708941374516.4052)
,p_validation_name=>'validate email'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_at number;',
'  l_dot number;',
'begin',
'  l_at := instr(nvl(:F4050_P72_EMAIL,''x''),''@'');',
'  l_dot := instr(nvl(:F4050_P72_EMAIL,''x''),''.'',l_at);',
'  return l_at > 1 and l_dot > 1 and (l_dot - l_at) > 1;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Adresse \00E9lectronique non valide.')
,p_when_button_pressed=>wwv_flow_api.id(12021900060665808.4052)
,p_associated_item=>wwv_flow_api.id(12020406163658104.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(111257629778385447.4052)
,p_validation_name=>'strong password'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_security.strong_password_validation(',
'    p_username              => :F4050_P72_ADMINNAME,',
'    p_password              => :F4050_P72_ADMIN_PASS,',
'    p_old_password          => null,',
'    p_workspace_name        => :F4050_P27_COMPANY);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Erreur'
,p_validation_condition=>'F4050_P72_ADMIN_PASS'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(12021900060665808.4052)
,p_associated_item=>wwv_flow_api.id(12850829056207052.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_security_scheme=>wwv_flow_api.id(3699181830199)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(9873516568625893.4052)
,p_name=>'Copy User name to Email'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4050_P72_ADMINNAME'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'this.triggeringElement.value.match(/@/)!=null'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(9873813037625894.4052)
,p_event_id=>wwv_flow_api.id(9873516568625893.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4050_P72_EMAIL'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$s(''F4050_P72_EMAIL'',$v(''F4050_P72_ADMINNAME''));',
''))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(13033112918687930.4052)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'pop defaults'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  wwv_flow.update_cache_with_write(''F4050_P72_ADMINNAME'', :FLOW_USER);',
'  for c1 in (select * ',
'               from wwv_flow_fnd_user',
'              where user_name = upper(:FLOW_USER)',
'                and security_group_id = :FLOW_SECURITY_GROUP_ID) loop',
'    wwv_flow.update_cache_with_write(''F4050_P72_FIRSTNAME'', nvl(c1.FIRST_NAME,''''));',
'    wwv_flow.update_cache_with_write(''F4050_P72_LASTNAME'', nvl(c1.LAST_NAME,''''));',
'    wwv_flow.update_cache_with_write(''F4050_P72_EMAIL'', c1.EMAIL_ADDRESS);',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_type=>'NEVER'
,p_process_comment=>'When we are creating a new workspace (most likely for someone else), not sure why we would want to use the current Instance Administrator''s information. Set this process to NEVER. Vlad, 11-JUL-2019'
);
end;
/
prompt --application/pages/page_00073
begin
wwv_flow_api.create_page(
 p_id=>73.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Cr\00E9er un espace de travail - Confirmer la demande')
,p_step_title=>unistr('Cr\00E9er un espace de travail')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931243707245169747)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_create_wkspc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12994410158412679.4052)
,p_plug_name=>'Train'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(12048115202363924.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202760814382738900.4052)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752110980519695868.4052)
,p_plug_name=>unistr('Cr\00E9er un espace de travail')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1339901111918284611.4052)
,p_plug_name=>'Region Container'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin: 0 auto; max-width: 640px;"'
,p_plug_template=>wwv_flow_api.id(517376500704206647.4052)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(924624894430884402.4052)
,p_plug_name=>'Informations d''espace de travail'
,p_parent_plug_id=>wwv_flow_api.id(1339901111918284611.4052)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Form--leftLabels:a-Form--fixedLabels'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(924624933224884403.4052)
,p_plug_name=>'Informations d''administrateur'
,p_parent_plug_id=>wwv_flow_api.id(1339901111918284611.4052)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Form--leftLabels:a-Form--fixedLabels'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(924625061933884404.4052)
,p_plug_name=>unistr('Informations sur le sch\00E9ma de base de donn\00E9es')
,p_parent_plug_id=>wwv_flow_api.id(1339901111918284611.4052)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Form--leftLabels:a-Form--fixedLabels'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(12027510019687640.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(202760814382738900.4052)
,p_button_name=>'back'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'CLOSE'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13260331814582778.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(202760814382738900.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(12027721414687641.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(202760814382738900.4052)
,p_button_name=>'provision'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er un espace de travail')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(282434411208624614.4052)
,p_branch_action=>'f?p=&APP_ID.:74:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P73_CREATED'
,p_branch_condition_text=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(12029125602692160.4052)
,p_branch_action=>'72'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(12027510019687640.4052)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10290320351706181.4052)
,p_name=>'P73_CREATED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(12994410158412679.4052)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(924625113182884405.4052)
,p_name=>'P73_WORKSPACE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(924624894430884402.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nom d''espace de travail'
,p_source=>'F4050_P27_COMPANY'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(924625243443884406.4052)
,p_name=>'P73_WORKSPACE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(924624894430884402.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'ID d''espace de travail'
,p_source=>'nvl(:F4050_P27_SECURITY_GROUP_ID,wwv_flow_lang.system_message(p_name=>''PROVISION_REQUEST.SYSTEM_ASSIGNED''))'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(924625333830884407.4052)
,p_name=>'P73_WORKSPACE_DESCRIPTION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(924624894430884402.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Description'
,p_source=>'F4050_P27_PROJDESC'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(924625460542884408.4052)
,p_name=>'P73_USER_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(924624933224884403.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nom utilisateur'
,p_source=>'F4050_P72_ADMINNAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(924625526487884409.4052)
,p_name=>'P73_EMAIL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(924624933224884403.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Courriel'
,p_source=>'F4050_P72_EMAIL'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(924625667230884410.4052)
,p_name=>'P73_REUSE_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(924625061933884404.4052)
,p_prompt=>unistr('R\00E9utiliser un sch\00E9ma existant')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4050_P79_EXISTING = ''1'' then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(924625745577884411.4052)
,p_name=>'P73_SCHEMA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(924625061933884404.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nom de sch\00E9ma')
,p_source=>'F4050_P79_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(924625862320884412.4052)
,p_name=>'P73_TABLESPACE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(924625061933884404.4052)
,p_prompt=>'Tablespace'
,p_source=>'coalesce(wwv_flow_instance_admin.get_parameter(''INSTANCE_TABLESPACE''),''APEX_XXX'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'F4050_P79_EXISTING'
,p_display_when2=>'0'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(924625946739884413.4052)
,p_name=>'P73_DATAFILE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(924625061933884404.4052)
,p_prompt=>unistr('Fichier de donn\00E9es')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_ts_path varchar2(512);',
'  l_omf     boolean := FALSE;',
'begin',
'    for c1 in (select null',
'                 from v$parameter',
'                where upper(name) = ''DB_CREATE_FILE_DEST''',
'                  and trim(value) is not null) loop',
'        -- OMF is potentially in use',
'        l_omf := TRUE;',
'        exit;',
'    end loop;',
'',
'    --',
'    -- Only compute the file path if OMF is not in use',
'    -- ',
'    if l_omf = FALSE and wwv_flow_instance_admin.get_parameter(''INSTANCE_TABLESPACE'') is null then',
'        select replace(f.file_name,''\'',''/'')',
'          into l_ts_path',
'          from sys.dba_data_files f, sys.dba_tables t',
'         where t.table_name = ''WWV_FLOWS''',
'           and t.tablespace_name = f.tablespace_name',
'           and rownum = 1;',
'',
'        <<stripfilename>>',
'        for i in reverse 1 .. length(l_ts_path) loop',
'            if substr(l_ts_path,i,1) = ''/'' then',
'                l_ts_path := substr(l_ts_path,1,i);',
'                exit stripfilename;',
'            end if;',
'        end loop;',
'        --',
'        return wwv_flow_escape.html(l_ts_path) || ''APEX_XXX.DBF'';',
'    elsif wwv_flow_instance_admin.get_parameter(''INSTANCE_TABLESPACE'') is not null and l_omf = FALSE then',
'        for c1 in (select replace(f.file_name,''\'',''/'') file_name',
'          from sys.dba_data_files f  ',
'         where f.tablespace_name = wwv_flow_instance_admin.get_parameter(''INSTANCE_TABLESPACE'') ',
'           and rownum=1) loop',
'             return wwv_flow_escape.html(c1.file_name);',
'         end loop;',
'    else',
'        return wwv_flow_lang.system_message(p_name=>''PROVISION_REQUEST.SYSTEM_ASSIGNED'');',
'    end if;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'F4050_P79_EXISTING'
,p_display_when2=>'0'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(217808816560578351.4052)
,p_name=>'Show Waiting on Submit'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(12027721414687641.4052)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(217809121167578351.4052)
,p_event_id=>wwv_flow_api.id(217808816560578351.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'provision'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(12036710522324711.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Provision company'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_p1 varchar2(256) := v(''F4050_P79_SCHEMA_PASSWORD'');',
'    l_p2 varchar2(256) := v(''F4050_P72_ADMIN_PASS'');',
'begin',
'    wwv_flow.update_cache_with_write(''F4050_P79_SCHEMA_PASSWORD'', null);',
'    wwv_flow.update_cache_with_write(''F4050_P72_ADMIN_PASS'', null);',
'',
'    wwv_flow_provisioning.auto_provision_company(',
'        p_company_name        => :F4050_P27_COMPANY,',
'        p_schema_name         => :F4050_P79_SCHEMA,',
'        p_schema_password     => l_p1,',
'        p_admin_password      => l_p2,',
'        p_database_size       => :F4050_P79_QUOTA,',
'        p_admin_userid        => :F4050_P72_ADMINNAME,',
'        p_admin_first_name    => :F4050_P72_FIRSTNAME,',
'        p_admin_last_name     => :F4050_P72_LASTNAME,',
'        p_admin_title         => :F4050_P72_TITLE,',
'        p_admin_email         => :F4050_P72_EMAIL,',
'        --',
'        p_project_description => :F4050_P27_PROJDESC,',
'        p_security_group_id   => :F4050_P27_SECURITY_GROUP_ID',
'    );',
'',
'    :P73_CREATED := ''Y'';',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors du provisionnement de &F4050_P27_COMPANY..'
,p_process_when_button_id=>wwv_flow_api.id(12027721414687641.4052)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_provisioning.reserved_schema(p_schema => upper(:F4050_P79_SCHEMA)) = false and ',
'not (wwv_flow_provisioning.site_admin_is_restricted and wwv_flow_provisioning.restricted_schema(p_schema => upper(:F4050_P79_SCHEMA),p_workspace_name => :F4050_P27_COMPANY) )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(267835524796024753.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear pw'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'F4050_P72_ADMIN_PASS,F4050_P79_SCHEMA_PASSWORD'
,p_process_when_button_id=>wwv_flow_api.id(12027721414687641.4052)
);
end;
/
prompt --application/pages/page_00074
begin
wwv_flow_api.create_page(
 p_id=>74.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Cr\00E9er un espace de travail - Confirmation de succ\00E8s')
,p_step_title=>unistr('Cr\00E9er un espace de travail')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216766430018595041)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.wrap-region .a-Alert-body {',
'word-break: break-all;',
'}'))
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_create_wkspc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12026518199680536.4052)
,p_plug_name=>unistr('Espace de travail cr\00E9\00E9.')
,p_region_css_classes=>'wrap-region'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829706609080810173.4052)
,p_plug_display_sequence=>10
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4050_P79_EXISTING = ''0'' then',
'',
'  for c1 in (select b.default_tablespace, a.file_name ',
'               from sys.dba_data_files a, sys.dba_users b',
'              where b.default_tablespace = a.tablespace_name',
'                and b.username = upper(:F4050_P79_SCHEMA) ) ',
'  loop',
'      sys.htp.p( wwv_flow_lang.system_message( ''F4050_P74_PROVISION1'',',
'                                               wwv_flow_escape.html(:F4050_P27_COMPANY),',
'                                               wwv_flow_escape.html(:F4050_P72_ADMINNAME) ) ||',
'                 '' '' || ',
'                 wwv_flow_lang.system_message( ''F4050_P74_PROVISION'',',
'                                               upper(wwv_flow_escape.html(:F4050_P79_SCHEMA)),',
'                                               c1.default_tablespace,c1.file_name ) );',
'  end loop;',
'',
'else',
'    sys.htp.p( wwv_flow_lang.system_message( ''F4050_P74_PROVISION1'',',
'                                             wwv_flow_escape.html(:F4050_P27_COMPANY),',
'                                             wwv_flow_escape.html(:F4050_P72_ADMINNAME) ) );',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(207916425010826926.4052)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(10040114009483080.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(207916425010826926.4052)
,p_button_name=>'EDIT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Modifier l''espace de travail'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:78:&SESSION.:REPORT:&DEBUG.:RP,78:P78_PROVISIONING_COMPANY_ID:&P74_PROVISIONING_COMPANY_ID.'
,p_button_condition=>'P74_PROVISIONING_COMPANY_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19144406840293644.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(207916425010826926.4052)
,p_button_name=>'DONE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Termin\00E9')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10058931905548807.4052)
,p_name=>'P74_PROVISIONING_COMPANY_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(207916425010826926.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(10059331233579580.4052)
,p_computation_sequence=>10
,p_computation_item=>'P74_PROVISIONING_COMPANY_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_security.find_security_group_id(p_company => :F4050_P27_COMPANY)'
);
end;
/
prompt --application/pages/page_00075
begin
wwv_flow_api.create_page(
 p_id=>75.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Nettoyer les journaux'
,p_step_title=>'Nettoyer les journaux'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216783731365642767)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_logs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23588620617408071.4052)
,p_plug_name=>'Nettoyer les journaux'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   c pls_integer := 0;',
'begin',
'   sys.htp.p(''<table class="instructiontext" role="presentation">'');   ',
'   if :P75_LOG_TYPE = ''SCRIPT'' then',
'      select count(*) into c from wwv_flow_sw_results;',
'      sys.htp.p(''<tr><td>''||wwv_flow_lang.system_message(''4050_75_SCRIPT_FILE'')||'': </td><td align="right">'');',
'      sys.htp.p(to_char(c,''999,999,999,990''));   ',
'   elsif :P75_LOG_TYPE = ''HISTORY'' then',
'      select count(*) into c from wwv_flow_sw_sql_cmds;',
'      sys.htp.p(''<tr><td>''||wwv_flow_lang.system_message(''4050_75_AD_HOC'')||'': </td><td align="right">'');',
'      sys.htp.p(to_char(c,''999,999,999,990''));   ',
'   end if;',
'   sys.htp.p(''</td><td><br /></td></tr>'');',
'   sys.htp.p(''</table>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(199174420727145797.4052)
,p_plug_name=>'Journaux de SQL Workshop'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829706609080810173.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Avec <strong>Vider un journal</strong>, toutes les entr\00E9es du journal s\00E9lectionn\00E9 sont supprim\00E9es. Avec <strong>Supprimer des entr\00E9es</strong>, les entr\00E9es dont l''anciennet\00E9 est sup\00E9rieure au nombre de jours s\00E9lectionn\00E9 sont supprim\00E9es.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(982232224821899646.4052)
,p_plug_name=>'Boutons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(23614222816410273.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(982232224821899646.4052)
,p_button_name=>'TRUNCATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Vider un journal'
,p_button_position=>'NEXT'
,p_button_cattributes=>'class="BUTTON10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(23589416938416560.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(982232224821899646.4052)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Supprimer des entr\00E9es')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(23590525942419157.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(982232224821899646.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_button_cattributes=>'class="BUTTON10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(23589714883416570.4052)
,p_branch_action=>'75'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(23590809276419158.4052)
,p_branch_action=>'46'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(23590525942419157.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(23592027805429118.4052)
,p_name=>'P75_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(23588620617408071.4052)
,p_item_default=>'31'
,p_prompt=>unistr('Supprimer les entr\00E9es datant du nombre de jours suivant ou plus :')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIME_INTERVALS'
,p_lov=>'.'||wwv_flow_api.id(87720511660244788.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Supprimez les entr\00E9es correspondant au moins \00E0 ce nombre de jours.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(23593431183448977.4052)
,p_name=>'P75_LOG_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(23588620617408071.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(23623509692409481.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete script logs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_sw_results ',
'where started < (sysdate - nvl(:P75_TIME,31));'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Erreur lors du traitement du journal d''ex\00E9cution de fichier de script.')
,p_process_when_button_id=>wwv_flow_api.id(23589416938416560.4052)
,p_process_when=>'P75_LOG_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'SCRIPT'
,p_process_success_message=>unistr('Journal d''ex\00E9cution de fichier de script trait\00E9.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(23625811171466668.4052)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete history'
,p_process_sql_clob=>'delete from wwv_flow_sw_sql_cmds where created_on < (sysdate - nvl(:P75_TIME,31));'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors du traitement de l''historique de processeur de commandes SQL.'
,p_process_when_button_id=>wwv_flow_api.id(23589416938416560.4052)
,p_process_when=>'P75_LOG_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'HISTORY'
,p_process_success_message=>unistr('Historique de processeur de commandes SQL trait\00E9.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(23628422693526797.4052)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'truncate script logs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_sw_results;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Erreur lors du vidage du journal d''ex\00E9cution de fichier de script.')
,p_process_when_button_id=>wwv_flow_api.id(23614222816410273.4052)
,p_process_when=>'P75_LOG_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'SCRIPT'
,p_process_success_message=>unistr('Journal d''ex\00E9cution de fichier de script vid\00E9.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(23630707811598252.4052)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'truncate history'
,p_process_sql_clob=>'execute immediate(''truncate table wwv_flow_sw_sql_cmds'');'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors du vidage de l''historique de processeur de commandes SQL.'
,p_process_when_button_id=>wwv_flow_api.id(23614222816410273.4052)
,p_process_when=>'P75_LOG_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'HISTORY'
,p_process_success_message=>unistr('Historique de processeur de commandes SQL trait\00E9.')
);
end;
/
prompt --application/pages/page_00076
begin
wwv_flow_api.create_page(
 p_id=>76.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Courriel'
,p_step_title=>'Courriel'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_wrkspc_details.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(184031003334137773.4052)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(184031224534137777.4052)
,p_plug_name=>'Courriel'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(184034721016181323.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(184031003334137773.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(184034917696181328.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(184031003334137773.4052)
,p_button_name=>'email'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Courriel'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(184035526126201755.4052)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184033318329161657.4052)
,p_name=>'P76_TO'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(184031224534137777.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'A'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select email_address ',
'from wwv_flow_fnd_user ',
'where security_group_id = :flow_security_group_id and ',
'      user_name = :app_user'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184033527414161659.4052)
,p_name=>'P76_SUBJECT'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(184031224534137777.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Objet'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''WORKSPACE_WORKSPACE_SUMMARY'',:P76_WORKSPACE_NAME) m',
'from dual'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184033708260161659.4052)
,p_name=>'P76_BODY'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(184031224534137777.4052)
,p_prompt=>'Corps'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184038131021231488.4052)
,p_name=>'P76_REPORTING_PERIOD'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(184031003334137773.4052)
,p_item_default=>'W'
,p_prompt=>unistr('P\00E9riode de g\00E9n\00E9ration d''\00E9tat')
,p_source=>'W'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORTING PERIOD'
,p_lov=>'.'||wwv_flow_api.id(180726228364333770.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifier une p\00E9riode de g\00E9n\00E9ration d''\00E9tat')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184084915709321735.4052)
,p_name=>'P76_WORKSPACE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(184031003334137773.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184086521034332765.4052)
,p_name=>'P76_WORKSPACE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(184031003334137773.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(184085521942323519.4052)
,p_computation_sequence=>10
,p_computation_item=>'P76_WORKSPACE_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name',
'from wwv_flow_companies',
'where provisioning_company_id = :P76_WORKSPACE_ID'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(184033008633158879.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'send email'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4350_ui.p83_send_ws_usage_mail (',
'    p_security_group_id => :P76_WORKSPACE_ID,',
'    p_to                => :P76_TO,',
'    p_subject           => :P76_SUBJECT,',
'    p_body              => :P76_BODY,',
'    p_reporting_period  => :P76_REPORTING_PERIOD,',
'    p_date_time_format  => :DATE_TIME_FORMAT );'))
,p_process_clob_language=>'PLSQL'
,p_process_success_message=>unistr('Courriel envoy\00E9')
);
end;
/
prompt --application/pages/page_00077
begin
wwv_flow_api.create_page(
 p_id=>77.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Activit\00E9 par application')
,p_step_title=>unistr('Activit\00E9 par application')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(201334900977494764.4052)
,p_plug_name=>unistr('Activit\00E9 par application')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    LOG_DAY,',
'    to_char(log_day,''Day'') day,',
'    WORKSPACE_ID workspace,',
'    (select short_name from wwv_flow_companies where provisioning_company_id = workspace_id) workspace_name,',
'    APPLICATION_ID applications,',
'    (select max(name) from wwv_flows where id = application_id) application_name,',
'    page_events PAGE_EVENTS,',
'    page_views PAGE_VIEWS,',
'    page_accepts PAGE_ACCEPTS,',
'    partial_page_views PARTIAL_PAGE_VIEWS,',
'    websheet_views WEBSHEET_VIEWS,',
'    rows_fetched ROWS_FETCHED,',
'    ir_searches IR_SEARCHES,',
'    distinct_pages DISTINCT_PAGES,',
'    distinct_users DISTINCT_USERS,',
'    distinct_sessions DISTINCT_SESSIONS,',
'    total_render_time TOTAL_RENDER_TIME,',
'    error_count ERROR_COUNT,',
'    nvl(content_length,0) content_length,',
'    public_page_events public_page_events,',
'    additional_attributes,',
'    case when application_id between 4000 and 4999 then t.y else t.n end apex_application,',
'    nvl(decode(instr(additional_attributes,''"hash":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"hash":'')+8,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"hash":'')+8),'','')-2)),null)  application_hash,',
'    nvl(decode(instr(additional_attributes,''"pages":''),0,''0'',',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"pages":'')+8,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"pages":'')+8),'','')-1)),''0'')  pages,',
'    nvl(decode(instr(additional_attributes,''"jetCharts":''),0,''0'',',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"jetCharts":'')+12,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"jetCharts":'')+12),'','')-1)),''0'') jetcharts,',
'    nvl(decode(instr(additional_attributes,''"interactiveReports":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"interactiveReports":'')+21,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"interactiveReports":'')+21),'','')-1)),''0'')  interactiveReports,',
'    nvl(decode(instr(additional_attributes,''"classicReports":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"classicReports":'')+length(''classicReports'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"classicReports":'')+length(''classicReports'')+3),'','')-1)),''0'')  classicReports,',
'    nvl(decode(instr(additional_attributes,''"interactiveGrids":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"interactiveGrids":'')+length(''interactiveGrids'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"interactiveGrids":'')+length(''interactiveGrids'')+3),'','')-1)),''0'')  interactiveGrids,',
'    nvl(decode(instr(additional_attributes,''"aclUsers":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"aclUsers":'')+length(''aclUsers'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"aclUsers":'')+length(''aclUsers'')+3),'','')-1)),''0'')  aclUsers,        ',
'    nvl(decode(instr(additional_attributes,''"appSettings":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"appSettings":'')+length(''appSettings'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"appSettings":'')+length(''appSettings'')+3),'','')-1)),''0'')  appSettings,          ',
'    nvl(decode(instr(additional_attributes,''"buildOptions":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"buildOptions":'')+length(''buildOptions'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"buildOptions":'')+length(''buildOptions'')+3),'','')-1)),''0'')  buildOptions,         ',
'    nvl(decode(instr(additional_attributes,''"emailTemplates":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"emailTemplates":'')+length(''emailTemplates'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"emailTemplates":'')+length(''emailTemplates'')+3),'','')-1)),''0'')  emailTemplates,         ',
'    nvl(decode(instr(additional_attributes,''"plugins":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"plugins":'')+length(''plugins'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"plugins":'')+length(''plugins'')+3),'','')-1)),''0'')  plugins,       ',
'    nvl(decode(instr(additional_attributes,''"tabularForms":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"tabularForms":'')+length(''tabularForms'')+3,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"tabularForms":'')+length(''tabularForms'')+3),'','')-1)),''0'')  tabularForms      ',
'from WWV_FLOW_LOG_HISTORY h, (select wwv_flow_lang.system_message(''Yes'') y, wwv_flow_lang.system_message(''No'') n from dual) t',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(201335103200494767.4052)
,p_name=>'Activity by Day'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201335207896494770.4052)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Consigner le jour dans le journal'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201335327208494771.4052)
,p_db_column_name=>'DAY'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Jour'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201335523254494773.4052)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201335613642494774.4052)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Ev\00E9nements de page')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(582264440165682815.4052)
,p_db_column_name=>'PUBLIC_PAGE_EVENTS'
,p_display_order=>15
,p_column_identifier=>'U'
,p_column_label=>unistr('Ev\00E9nements de page publique')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201335718041494775.4052)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>25
,p_column_identifier=>'F'
,p_column_label=>'Vues de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201335801210494776.4052)
,p_db_column_name=>'PAGE_ACCEPTS'
,p_display_order=>35
,p_column_identifier=>'G'
,p_column_label=>'Envois de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201335923569494777.4052)
,p_db_column_name=>'PARTIAL_PAGE_VIEWS'
,p_display_order=>45
,p_column_identifier=>'H'
,p_column_label=>'Vues de page partielle'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201336014251494778.4052)
,p_db_column_name=>'WEBSHEET_VIEWS'
,p_display_order=>55
,p_column_identifier=>'I'
,p_column_label=>'Vues de feuille Web'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201336107132494779.4052)
,p_db_column_name=>'ROWS_FETCHED'
,p_display_order=>65
,p_column_identifier=>'J'
,p_column_label=>'Lignes extraites'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201336221224494780.4052)
,p_db_column_name=>'IR_SEARCHES'
,p_display_order=>75
,p_column_identifier=>'K'
,p_column_label=>unistr('Recherches d''\00E9tat interactif')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201336321763494781.4052)
,p_db_column_name=>'DISTINCT_PAGES'
,p_display_order=>85
,p_column_identifier=>'L'
,p_column_label=>'Pages actives'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201336408590494782.4052)
,p_db_column_name=>'DISTINCT_USERS'
,p_display_order=>95
,p_column_identifier=>'M'
,p_column_label=>'Utilisateurs'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201336505856494783.4052)
,p_db_column_name=>'DISTINCT_SESSIONS'
,p_display_order=>105
,p_column_identifier=>'N'
,p_column_label=>'Sessions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201336612996494784.4052)
,p_db_column_name=>'TOTAL_RENDER_TIME'
,p_display_order=>115
,p_column_identifier=>'O'
,p_column_label=>'Temps d''affichage total'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201336722324494785.4052)
,p_db_column_name=>'ERROR_COUNT'
,p_display_order=>125
,p_column_identifier=>'P'
,p_column_label=>'Erreurs'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201336815191494786.4052)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>135
,p_column_identifier=>'Q'
,p_column_label=>'Contenu'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201370019533571396.4052)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>145
,p_column_identifier=>'R'
,p_column_label=>'Espace de travail'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201373110576597156.4052)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>155
,p_column_identifier=>'S'
,p_column_label=>'Nom de l''espace de travail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201373214940597158.4052)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>165
,p_column_identifier=>'T'
,p_column_label=>'Nom d''application'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84538753787706813.4052)
,p_db_column_name=>'ADDITIONAL_ATTRIBUTES'
,p_display_order=>175
,p_column_identifier=>'V'
,p_column_label=>unistr('Attributs suppl\00E9mentaires')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84539045432706816.4052)
,p_db_column_name=>'APEX_APPLICATION'
,p_display_order=>185
,p_column_identifier=>'W'
,p_column_label=>'Application interne APEX'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176252184846916921.4052)
,p_db_column_name=>'JETCHARTS'
,p_display_order=>205
,p_column_identifier=>'AC'
,p_column_label=>'Graphiques JET'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176252270600916922.4052)
,p_db_column_name=>'INTERACTIVEREPORTS'
,p_display_order=>215
,p_column_identifier=>'AD'
,p_column_label=>'Etats interactifs'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176252389058916923.4052)
,p_db_column_name=>'CLASSICREPORTS'
,p_display_order=>225
,p_column_identifier=>'AE'
,p_column_label=>'Etats classiques'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176252454408916924.4052)
,p_db_column_name=>'INTERACTIVEGRIDS'
,p_display_order=>235
,p_column_identifier=>'AF'
,p_column_label=>'Grilles interactives'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176252507712916925.4052)
,p_db_column_name=>'ACLUSERS'
,p_display_order=>245
,p_column_identifier=>'AG'
,p_column_label=>unistr('Utilisateurs de la liste de contr\00F4le d''acc\00E8s')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176252647407916926.4052)
,p_db_column_name=>'APPSETTINGS'
,p_display_order=>255
,p_column_identifier=>'AH'
,p_column_label=>unistr('Param\00E8tres d''application')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176252745489916927.4052)
,p_db_column_name=>'BUILDOPTIONS'
,p_display_order=>265
,p_column_identifier=>'AI'
,p_column_label=>'Options de construction'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176252882601916928.4052)
,p_db_column_name=>'EMAILTEMPLATES'
,p_display_order=>275
,p_column_identifier=>'AJ'
,p_column_label=>unistr('Mod\00E8les de courriel')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176252984135916929.4052)
,p_db_column_name=>'PLUGINS'
,p_display_order=>285
,p_column_identifier=>'AK'
,p_column_label=>'Modules d''extension'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176253185667916931.4052)
,p_db_column_name=>'TABULARFORMS'
,p_display_order=>305
,p_column_identifier=>'AM'
,p_column_label=>'Panneaux tabulaires'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176253500432916935.4052)
,p_db_column_name=>'PAGES'
,p_display_order=>315
,p_column_identifier=>'AQ'
,p_column_label=>'Pages'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176253673764916936.4052)
,p_db_column_name=>'APPLICATION_HASH'
,p_display_order=>325
,p_column_identifier=>'AR'
,p_column_label=>'Hachage d''application'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(484704101222057793.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(201334900977494764.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:77:&SESSION.::&DEBUG.:77,RIR::'
);
end;
/
prompt --application/pages/page_00078
begin
wwv_flow_api.create_page(
 p_id=>78.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Modifier les informations d''espace de travail'
,p_step_title=>'Modifier les informations d''espace de travail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(704456563630760825.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_wrkspc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16616205365518560.4052)
,p_plug_name=>'Apparence de l''espace de travail'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(64856003162546445.4052)
,p_plug_name=>'Modifier les informations d''espace de travail'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P78_PROVISIONING_COMPANY_ID'
,p_plug_display_when_cond2=>'10'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 20-JUN-2003 14:39:53'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(68662405051157913.4052)
,p_plug_name=>'Espace de travail interne'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829706609080810173.4052)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source=>'Vous ne pouvez pas modifier l''espace de travail interne.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P78_PROVISIONING_COMPANY_ID'
,p_plug_display_when_cond2=>'10'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(254114322593959129.4052)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(195775112470763477.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(254150210407125975.4052)
,p_plug_name=>'Informations d''espace de travail'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_output varchar2(32767) := null;',
'   l_session_id varchar2(255) := :APP_SESSION;',
'begin',
'    l_output:=l_output||''<ul class="aChartList">'';',
'    for c1 in (',
'        select count(*) c, max(security_group_id) sgid',
'        from WWV_FLOW_FND_USER',
'        where security_group_id = (select provisioning_company_id from WWV_FLOW_COMPANIES where  id = :P78_ID)',
'        ) loop',
'            l_output:=l_output||''<li class="aNumber aGrid col_1 col_start">'';',
'            l_output:=l_output||''<a href="f?p=4050:12:''||l_session_id||'':::RIR:IR_WORKSPACE_ID:''||c1.sgid||''">'';',
'            l_output:=l_output||''<big class="aValue">''||trim(to_char(c1.c,''999G999G999G990''));',
'            l_output:=l_output||''</big><small class="aLabel">''||wwv_flow_escape.html(wwv_flow_lang.system_message(''WORKSPACE_USERS''));',
'            l_output:=l_output||''</small></a>'';',
'            l_output:=l_output||''</li>'';',
'    end loop;',
'    for c1 in (',
'        select count(*) c, max(security_group_id) sgid',
'        from WWV_FLOW_COMPANY_SCHEMAS cs,',
'             wwv_flow_companies c',
'        where cs.security_group_id = c.PROVISIONING_COMPANY_ID(+)',
'             and security_group_id = (select provisioning_company_id from WWV_FLOW_COMPANIES where  id = :P78_ID)',
'             and short_name != ''INTERNAL''',
'        ) loop',
'            l_output:=l_output||''<li class="aNumber aGrid col_1 col_start">'';',
'            l_output:=l_output||''<a href="f?p=4050:21:''||l_session_id||'':::RIR:IR_SECURITY_GROUP_ID:''||c1.sgid||''">'';',
'            l_output:=l_output||''<big class="aValue">''||trim(to_char(c1.c,''999G999G999G990''));',
'            l_output:=l_output||''</big><small class="aLabel">''||wwv_flow_escape.html(wwv_flow_lang.system_message(''WORKSPACE_SCHEMAS''));',
'            l_output:=l_output||''</small></a>'';',
'            l_output:=l_output||''</li>'';',
'    end loop;',
'    for c1 in (',
'        select count(*) c, max(security_group_id) sgid',
'        from WWV_FLOWS',
'        where security_group_id not in (0,10,11) and',
'              security_group_id = (select provisioning_company_id from WWV_FLOW_COMPANIES where  id = :P78_ID)',
'        ) loop',
'            l_output:=l_output||''<li class="aNumber aGrid col_1 col_start">'';',
'            l_output:=l_output||''<a href="f?p=4050:11:''||l_session_id||'':::RIR:IR_WORKSPACE_ID:''||c1.sgid||''">'';',
'            l_output:=l_output||''<big class="aValue">''||trim(to_char(c1.c,''999G999G999G990''));',
'            l_output:=l_output||''</big><small class="aLabel">''||wwv_flow_escape.html(wwv_flow_lang.system_message(''APPLICATIONS_INITCAP''));',
'            l_output:=l_output||''</small></a>'';',
'            l_output:=l_output||''</li>'';',
'    end loop;',
'    ',
'    l_output:=l_output||''</ul>'';',
'    sys.htp.p(l_output);',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_required_patch=>wwv_flow_api.id(1082456635473282144.4052)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(254180529905013099.4052)
,p_plug_name=>unistr('T\00E2ches')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>65
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_api.id(254179102637013097.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(202626814415270397.4052)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(484950212196717193.4052)
,p_plug_name=>'Modifier les informations d''espace de travail'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(484963511353906096.4052)
,p_plug_name=>unistr('Contr\00F4le de connexion')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(484966712963972830.4052)
,p_plug_name=>unistr('Composant - Disponibilit\00E9')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(495344484107866205.4052)
,p_plug_name=>'Isolement d''espace de travail'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(503818025402228218.4052)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>G\00E9rez les param\00E8tres d''espace de travail s\00E9lectionn\00E9s. Utilisez la r\00E9gion de t\00E2ches ci-dessous pour effectuer des actions suppl\00E9mentaires.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(537738109072133270.4052)
,p_plug_name=>unistr('D\00E9lai d''expiration de session')
,p_region_name=>'sessiontimeout'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1119586265779190522.4052)
,p_name=>'Informations d''espace de travail'
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>80
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--stacked:a-BadgeList--xlarge'
,p_display_point=>'REGION_POSITION_03'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ( select count(*) as workspace_users',
'           from wwv_flow_fnd_user',
'          where security_group_id = sgid.id ) as workspace_users,',
'       ( select count(*) as workspace_schemas',
'           from wwv_flow_company_schemas cs,',
'                wwv_flow_companies c',
'          where cs.security_group_id = c.provisioning_company_id (+)',
'            and security_group_id = sgid.id',
'            and short_name != ''INTERNAL'' ) as workspace_schemas,',
'       ( select count(*) as applications',
'           from wwv_flows',
'          where security_group_id not in ( 0, 10, 11 )',
'            and security_group_id = sgid.id ) as applications,',
'       sgid.id as sgid',
'  from ( select provisioning_company_id as id',
'           from WWV_FLOW_COMPANIES',
'          where id = :P78_ID ) sgid'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P78_ID'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805663950138677747.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1119586383992190523.4052)
,p_query_column_id=>1
,p_column_alias=>'WORKSPACE_USERS'
,p_column_display_sequence=>1
,p_column_heading=>'Utilisateurs d''espace de travail'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:RP,RIR:IR_WORKSPACE_ID:#SGID#'
,p_column_linktext=>'#WORKSPACE_USERS#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1119586422447190524.4052)
,p_query_column_id=>2
,p_column_alias=>'WORKSPACE_SCHEMAS'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Sch\00E9mas d''espace de travail')
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:RP,RIR:IR_SECURITY_GROUP_ID:#SGID#:'
,p_column_linktext=>'#WORKSPACE_SCHEMAS#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1119586570285190525.4052)
,p_query_column_id=>3
,p_column_alias=>'APPLICATIONS'
,p_column_display_sequence=>3
,p_column_heading=>'Applications'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:RP,RIR:IR_WORKSPACE_ID:#SGID#:'
,p_column_linktext=>'#APPLICATIONS#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1119586604568190526.4052)
,p_query_column_id=>4
,p_column_alias=>'SGID'
,p_column_display_sequence=>4
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(64856327858546450.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(484950212196717193.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_button_condition_type=>'NEVER'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(68666010900206937.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(484950212196717193.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(64856416813546450.4052)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(484950212196717193.4052)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'NEXT'
,p_button_condition=>':P78_ID is not null and :P78_PROVISIONING_COMPANY_ID != ''10'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(503857325907464969.4052)
,p_branch_action=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P78_PROVISIONING_COMPANY_ID'
,p_branch_condition_text=>'P14_SGID'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(64857217258546458.4052)
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_comment=>'Generated 20-JUN-2003 14:39:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1589702746325019.4052)
,p_name=>'P78_SESSION_TIMEOUT_WARN_SEC'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(537738109072133270.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Avertissement d''expiration de session en secondes'
,p_source=>'SESSION_TIMEOUT_WARNING_SEC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS_SMALL'
,p_lov=>'.'||wwv_flow_api.id(1501535454230180.4052)||'.'
,p_cSize=>6
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le d\00E9lai d''avertissement d''expiration de session d\00E9finit (en secondes) combien de temps avant l''expiration de la session (dur\00E9e maximale de session ou d\00E9lai d''inactivit\00E9 maximal de la session) l''utilisateur en est averti. Pour l''avertissement de d')
||unistr('\00E9lai d''inactivit\00E9 maximal de la session, l''utilisateur pourra prolonger la session. Pour l''avertissement de dur\00E9e maximale de session, l''utilisateur sera invit\00E9 \00E0 enregistrer son travail pour \00E9viter de perdre des donn\00E9es lorsque la dur\00E9e maximale de ')
||unistr('session sera \00E9coul\00E9e.</p>'),
unistr('<p>Remarque : ce param\00E8tre est remplac\00E9 par le param\00E8tre de niveau espace de travail et le param\00E8tre de niveau application correspondants.</p>'),
'<p>',
'<ul>',
unistr('    <li>Saisissez un entier positif pour contr\00F4ler le temps d''inactivit\00E9 par d\00E9faut des sessions utilis\00E9es par les applications dans cet espace de travail.</li>'),
unistr('    <li>Saisissez 0 pour d\00E9sactiver les avertissements d''expiration des sessions utilis\00E9es par les applications dans cet espace de travail.</li>'),
unistr('    <li>Laissez la valeur vide pour utiliser le d\00E9lai d''avertissement d\00E9fini au niveau de l''instance.</li>'),
'</ul>  ',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13874018831207468.4052)
,p_name=>'P78_RM_CONSUMER_GROUP'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(495344484107866205.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Groupe de consommateurs de ressources'
,p_source=>'RM_CONSUMER_GROUP'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'RESOURCE CONSUMER GROUPS (NON  SYSTEM)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select consumer_group d, consumer_group r',
'  from sys.dba_rsrc_consumer_groups',
' where consumer_group not like ''ORA$%''',
'   and consumer_group <> ''SYS_GROUP''',
'order by 1'))
,p_cSize=>45
,p_cMaxlength=>255
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez le groupe de consommateurs Database Resource Manager \00E0 utiliser pour tous les \00E9v\00E9nements de page associ\00E9s \00E0 cet espace de travail.'),
unistr('Si cet attribut reste vide, la valeur de niveau d''instance est appliqu\00E9e.'),
unistr('Au d\00E9but de chaque demande, le moteur &PRODUCT_NAME. remplace le groupe de consommateurs de la session de base de donn\00E9es en cours par le groupe de consommateurs de l''espace de travail. Ce comportement s''applique \00E0 la fois aux applications en cours d')
||unistr('''ex\00E9cution et aux applications utilis\00E9es dans l''environnement de d\00E9veloppement &PRODUCT_NAME..'),
'',
'<p />',
'',
unistr('Le privil\00E8ge permettant le remplacement du groupe de consommateurs doit \00EAtre accord\00E9 au sch\00E9ma PUBLIC ou &PRODUCT_NAME.. Ce privil\00E8ge est g\00E9n\00E9ralement accord\00E9 \00E0 l''aide de la proc\00E9dure DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16617016362540639.4052)
,p_name=>'P78_DISPLAY_NAME'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(16616205365518560.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nom d''affichage'
,p_source=>'DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>45
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Le nom d''affichage constitue un nom alternatif d''espace de travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(64857525070546458.4052)
,p_name=>'P78_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(64856003162546445.4052)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 20-JUN-2003 14:39:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(64857823340546465.4052)
,p_name=>'P78_PROVISIONING_COMPANY_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(64856003162546445.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Identificateur d''espace de travail :'
,p_source=>'PROVISIONING_COMPANY_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifie l''espace de travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 20-JUN-2003 14:39:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(64858304246546470.4052)
,p_name=>'P78_SHORT_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(64856003162546445.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nom de l''espace de travail'
,p_source=>'SHORT_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>45
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifie le nom de l''espace de travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 20-JUN-2003 14:39:54'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(64858932679546471.4052)
,p_name=>'P78_FIRST_SCHEMA_PROVISIONED'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(64856003162546445.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Premier sch\00E9ma provisionn\00E9')
,p_source=>'FIRST_SCHEMA_PROVISIONED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifie le sch\00E9ma d''origine \00E0 provisionner.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 20-JUN-2003 14:39:54'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(254190316454208827.4052)
,p_name=>'P78_SN'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(64856003162546445.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(356927208955624683.4052)
,p_name=>'P78_ACCOUNT_STATUS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(64856003162546445.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Statut d''espace de travail :'
,p_source=>'ACCOUNT_STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'WORKSPACE STATUS'
,p_lov=>'.'||wwv_flow_api.id(2379160755129464721.4052)||'.'
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifie le statut de l''espace de travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(385817323351295593.4052)
,p_name=>'P78_ALLOW_RESTFUL_SERVICES_YN'
,p_item_sequence=>185
,p_item_plug_id=>wwv_flow_api.id(484966712963972830.4052)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Autoriser les services RESTful'
,p_source=>'ALLOW_RESTFUL_SERVICES_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Contr\00F4le la cr\00E9ation des services RESTful dans l''espace de travail en cours et l''acc\00E8s \00E0 ceux-ci. Cette pr\00E9f\00E9rence est ignor\00E9e si les services RESTful sont d\00E9sactiv\00E9s au niveau de l''instance.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(385818782057330239.4052)
,p_name=>'P78_PATH_PREFIX'
,p_item_sequence=>186
,p_item_plug_id=>wwv_flow_api.id(484966712963972830.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Pr\00E9fixe de chemin RESTful')
,p_source=>'PATH_PREFIX'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>45
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Indiquez le pr\00E9fixe de chemin d''URI unique \00E0 utiliser pour acc\00E9der aux services RESTful dans l''espace de travail en cours. La valeur de pr\00E9fixe de chemin par d\00E9faut est le nom de l''espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484699530539980014.4052)
,p_name=>'P78_ALLOW_TO_BE_PURGED_YN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(64856003162546445.4052)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Autoriser la purge automatique de l''espace de travail'
,p_source=>'ALLOW_TO_BE_PURGED_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>unistr('D\00E9termine si cet espace de travail peut \00EAtre concern\00E9 par la purge automatique des espaces de travail non utilis\00E9s.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484863413498036412.4052)
,p_name=>'P78_SOURCE_IDENTIFIER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(64856003162546445.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Identificateur de la source de synchronisation des informations en retour'
,p_source=>'SOURCE_IDENTIFIER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>12
,p_cMaxlength=>8
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Utilisez cet attribut pour identifier la source des informations en retour de l''application. Par exemple, si vous synchronisez des informations en retour \00E0 partir d''un syst\00E8me de production vers votre syst\00E8me de d\00E9veloppement, vous pouvez identifier ')
||unistr('la source des informations en retour et \00E9viter les collisions des num\00E9ros des fonctionnalit\00E9s.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484883430747211661.4052)
,p_name=>'P78_ALLOW_APP_BUILDING_YN'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(484966712963972830.4052)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Autoriser App Builder'
,p_source=>'ALLOW_APP_BUILDING_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Activez App Builder pour cet espace de travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484883707676214401.4052)
,p_name=>'P78_ALLOW_SQL_WORKSHOP_YN'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(484966712963972830.4052)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Autoriser SQL Workshop'
,p_source=>'ALLOW_SQL_WORKSHOP_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Activez SQL Workshop pour cet espace de travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484884523260218887.4052)
,p_name=>'P78_ALLOW_TEAM_DEVELOPMENT_YN'
,p_item_sequence=>206
,p_item_plug_id=>wwv_flow_api.id(484966712963972830.4052)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>unistr('Autoriser le d\00E9veloppement d''\00E9quipe')
,p_source=>'ALLOW_TEAM_DEVELOPMENT_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Activez le d\00E9veloppement d''\00E9quipe dans cet espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484885405729223343.4052)
,p_name=>'P78_BUILDER_NOTIFICATION_MESSAGE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(64856003162546445.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Message d''espace de travail'
,p_source=>'BUILDER_NOTIFICATION_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez le message \00E0 afficher sur la page d''accueil de cet espace de travail et dans App Builder.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484891004952242081.4052)
,p_name=>'P78_ALLOW_PLSQL_EDITING'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(484966712963972830.4052)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Autoriser la modification du code PL/SQL dans SQL Workshop'
,p_source=>'ALLOW_PLSQL_EDITING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Autorisez la modification des proc\00E9dures, packages, fonctions et d\00E9clencheurs PL/SQL dans le navigateur Web.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484963722912918937.4052)
,p_name=>'P78_EXPIRE_FND_USER_ACCOUNTS'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(484963511353906096.4052)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Expiration et verrouillage de compte :'
,p_source=>'EXPIRE_FND_USER_ACCOUNTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'ENABLE Y, DISABLE N'
,p_lov=>'.'||wwv_flow_api.id(484964000318931321.4052)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Indiquez si les comptes d''utilisateur final &PRODUCT_NAME. peuvent \00EAtre invalid\00E9s ou verrouill\00E9s. Cette fonctionnalit\00E9 ne s''applique qu''aux comptes d''utilisateur final cr\00E9\00E9s \00E0 l''aide de l''interface de gestion des utilisateurs &PRODUCT_NAME.. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484965522398956659.4052)
,p_name=>'P78_FND_USER_MAX_LOGIN_FAILURES'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(484963511353906096.4052)
,p_use_cache_before_default=>'NO'
,p_item_default=>'15'
,p_prompt=>unistr('Nombre maximum d''\00E9checs de connexion autoris\00E9')
,p_source=>'FND_USER_MAX_LOGIN_FAILURES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Saisissez un entier positif indiquant le nombre maximal autoris\00E9 de tentatives d''authentification cons\00E9cutives ayant \00E9chou\00E9 avant qu''un compte utilisateur final ne soit bloqu\00E9. Si vous n''indiquez pas de valeur dans ce champ, le param\00E8tre d''environnem')
||unistr('ent Nombre maximum d''\00E9checs de connexion autoris\00E9 sera utilis\00E9.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484965707637961794.4052)
,p_name=>'P78_ACCOUNT_LIFETIME_DAYS'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(484963511353906096.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Dur\00E9e de validit\00E9 des comptes utilisateur final (jours)')
,p_source=>'ACCOUNT_LIFETIME_DAYS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Saisissez un entier positif indiquant le nombre maximal de jours d''utilisation d''un mot de passe de compte utilisateur final avant que le compte n''arrive \00E0 expiration. Si vous n''indiquez pas de valeur dans ce champ, le param\00E8tre d''environnement Dur\00E9e')
||unistr(' de validit\00E9 du mot de passe de compte sera utilis\00E9.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(495344596646866206.4052)
,p_name=>'P78_QOS_MAX_WORKSPACE_REQUESTS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(495344484107866205.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nombre maximal de demandes d''espace de travail simultan\00E9es')
,p_source=>'QOS_MAX_WORKSPACE_REQUESTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Saisissez le nombre maximal d''\00E9v\00E9nements de page simultan\00E9s pris en charge par &PRODUCT_NAME. pour toutes les applications de cet espace de travail.'),
'Si vous laissez cet attribut vide, la valeur de niveau instance s''applique.',
unistr('Au lieu de traiter un \00E9v\00E9nement de page, &PRODUCT_NAME. affiche un message d''erreur lorsque la limite est d\00E9j\00E0 atteinte.'),
'</p>',
'<p>',
'&PRODUCT_NAME. suit les demandes d''espace de travail en interrogeant la colonne CLIENT_INFO de GV$SESSION.',
unistr('Ce suivi ne fonctionnera pas si les d\00E9veloppeurs remplacent CLIENT_INFO, par exemple par un appel \00E0 DBMS_APPLICATION_INFO.SET_CLIENT_INFO.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(495345284427866213.4052)
,p_name=>'P78_QOS_MAX_SESSION_REQUESTS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(495344484107866205.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nombre maximal de demandes de session simultan\00E9es')
,p_source=>'QOS_MAX_SESSION_REQUESTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Saisissez le nombre maximal d''\00E9v\00E9nements de page simultan\00E9s autoris\00E9s par &PRODUCT_NAME. pour chaque session des applications de cet espace de travail.'),
unistr('Au lieu de traiter un nouvel \00E9v\00E9nement de page, &PRODUCT_NAME. affiche un message d''erreur lorsque la limite est d\00E9j\00E0 atteinte.'),
unistr('Vous pouvez \00E9galement utiliser l''attribut <em>D\00E9lai de fermeture des demandes de session simultan\00E9es</em> pour fermer une session de base de donn\00E9es active, afin de traiter le nouvel \00E9v\00E9nement de page.'),
'</p>',
'<p>',
'&PRODUCT_NAME. suit les demandes de session en interrogeant la colonne CLIENT_IDENTIFIER de GV$SESSION.',
unistr('Ce suivi ne fonctionnera pas si les d\00E9veloppeurs remplacent CLIENT_IDENTIFIER, par exemple par un appel \00E0 DBMS_SESSION.SET_IDENTIFIER.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(495345336315866214.4052)
,p_name=>'P78_QOS_MAX_SESSION_KILL_TIMEOUT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(495344484107866205.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('D\00E9lai de fermeture des demandes de session simultan\00E9es')
,p_source=>'QOS_MAX_SESSION_KILL_TIMEOUT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('En cas de survenue d''un nouvel \00E9v\00E9nement de page situ\00E9 en dehors des limites du'),
unistr('param\00E8tre <em>Nombre maximal de demandes de session simultan\00E9es</em>,'),
unistr('&PRODUCT_NAME. peut ex\00E9cuter <code>alter system kill session</code> sur la'),
unistr('session de base de donn\00E9es active la plus ancienne qui traite un autre \00E9v\00E9nement de page pour cette session &PRODUCT_NAME..'),
unistr('L''attribut <em>D\00E9lai de fermeture des demandes de session simultan\00E9es</em> indique le nombre de secondes'),
unistr('pendant lequel un processus de base de donn\00E9es doit \00EAtre actif, avant qu''il puisse \00EAtre ferm\00E9.'),
'Si vous laissez cet attribut vide, la valeur de niveau instance s''applique.',
'</p>',
'<p>',
unistr('<strong>Avertissement :</strong> la fermeture de sessions peut entra\00EEner des probl\00E8mes au niveau du pool de sessions de base de donn\00E9es du serveur d''applications.    '),
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(495345482229866215.4052)
,p_name=>'P78_HOST_PREFIX'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(495344484107866205.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Autoriser les noms d''h\00F4te')
,p_source=>'HOST_PREFIX'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>45
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Saisissez la liste des noms d''h\00F4te, s\00E9par\00E9s par des virgules, qui peuvent \00EAtre utilis\00E9s pour acc\00E9der \00E0 cet espace de travail.'),
'Si vous laissez cet attribut vide, la valeur de niveau instance s''applique.',
unistr('Si vous saisissez des noms d''h\00F4te,'),
unistr('la partie nom d''h\00F4te de l''URL de demande HTTP entrante doit correspondre \00E0 l''un des noms d''h\00F4te r\00E9pertori\00E9s.'),
'</p>',
'<p>',
'Par exemple, vous pouvez inscrire l''alias DNS "hr.example.com" pour le serveur Web "www.example.com".',
unistr('Si vous d\00E9finissez le param\00E8tre <em>Autoriser les noms d''h\00F4te</em> de l''espace de travail HR sur "hr.example.com",'),
unistr('les utilisateurs doivent acc\00E9der aux applications HR via "hr.example.com"'),
unistr('et \00E0 toutes les autres applications de cette instance via "www.example.com".'),
'Avec cette configuration,',
unistr('le param\00E8tre <strong>Strat\00E9gie de s\00E9curit\00E9 de m\00EAme origine</strong> du navigateur Web fournit une barri\00E8re c\00F4t\00E9 client entre les applications HR'),
'et les autres applications de l''instance,',
unistr('qui sont ex\00E9cut\00E9es dans une autre fen\00EAtre ou un autre onglet du navigateur Web.'),
'</p>',
'<p>',
'Si votre espace de travail utilise les services RESTful,',
unistr('vous devez \00E9galement configurer un pool dans le fichier de configuration <strong>url-mapping.xml</strong>'),
unistr('d''<strong>Oracle REST Data Services</strong> \00E0 des fins d''isolement.'),
unistr('Oracle REST Data Services ignorera l''attribut d''espace de travail <strong>Pr\00E9fixe de chemin RESTful</strong>'),
unistr('si l''option <strong>Autoriser les noms d''h\00F4te</strong> est configur\00E9e.'),
'</p>',
'<p>',
'L''exemple ci-dessous configure les services RESTful de l''espace de travail HR pour les rendre uniquement accessibles via',
'https://hr.example.com/apex/<em>resource-handler</em>:',
'<pre>',
'  &lt;pool base-url="https://hr.example.com/apex" name="apex" workspace-id="hr" /&gt;',
'</pre>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(537738384746133274.4052)
,p_name=>'P78_MAX_SESSION_LENGTH_SEC'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(537738109072133270.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Dur\00E9e maximale de session en secondes')
,p_source=>'MAX_SESSION_LENGTH_SEC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS'
,p_lov=>'.'||wwv_flow_api.id(15314811390892155.4052)||'.'
,p_cSize=>6
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('D\00E9finit la dur\00E9e (en secondes) pendant laquelle les sessions peuvent exister et \00EAtre utilis\00E9es par des applications dans cet espace de travail. Ce param\00E8tre est remplac\00E9'),
unistr('par le param\00E8tre de niveau application correspondant.'),
'',
'<ul>',
unistr('    <li>Saisissez un entier positif pour contr\00F4ler la dur\00E9e d''existence d''une session.</li>'),
unistr('    <li>Saisissez 0 pour que les sessions existent ind\00E9finiment.</li>'),
unistr('    <li>Laissez la valeur vide pour utiliser la dur\00E9e d\00E9finie au niveau de l''instance.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(537738844730133278.4052)
,p_name=>'P78_MAX_SESSION_IDLE_SEC'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(537738109072133270.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Temps total d''inactivit\00E9 de session en secondes')
,p_source=>'MAX_SESSION_IDLE_SEC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS'
,p_lov=>'.'||wwv_flow_api.id(15314811390892155.4052)||'.'
,p_cSize=>6
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Le temps d''inactivit\00E9 de session est la dur\00E9e entre la derni\00E8re demande de page et la demande de page suivante. Ce param\00E8tre est remplac\00E9 par'),
unistr('le param\00E8tre de niveau application correspondant.'),
'',
'<ul>',
unistr('    <li>Saisissez un entier positif pour contr\00F4ler le temps d''inactivit\00E9 par d\00E9faut des sessions utilis\00E9es par les applications dans cet espace de travail.</li>'),
unistr('    <li>Laissez la valeur vide pour utiliser le temps d''inactivit\00E9 d\00E9fini au niveau de l''instance.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(582421442619226502.4052)
,p_name=>'P78_WEBSERVICE_LOGGING_YN'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(64856003162546445.4052)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Journaliser les demandes de service Web'
,p_source=>'WEBSERVICE_LOGGING_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('D\00E9termine si les demandes de service Web sont journalis\00E9es pour cet espace de travail. Ce param\00E8tre n''est pertinent que si le param\00E8tre d''instance Journalisation des activit\00E9s de service Web est d\00E9fini sur Utiliser les param\00E8tres d''espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(582421516116226503.4052)
,p_name=>'P78_MAX_WEBSERVICE_REQUESTS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(495344484107866205.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre maximal de demandes de service Web'
,p_source=>'MAX_WEBSERVICE_REQUESTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez le nombre maximal de demandes de service Web qui peuvent \00EAtre envoy\00E9es par p\00E9riode de 24 heures.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(620835263564373115.4052)
,p_name=>'P78_MAX_FILE_BYTES'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(495344484107866205.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Taille maximale des fichiers dans l''espace de travail'
,p_source=>'MAX_FILE_BYTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez la taille maximale (en octets) de tous les fichiers pouvant \00EAtre t\00E9l\00E9charg\00E9s sur cet espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(644504642352249007.4052)
,p_name=>'P78_CONTENT_CACHE_TARGET_SIZE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(495344484107866205.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Taille cible du cache de contenu'
,p_source=>'CONTENT_CACHE_SIZE_TARGET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>15
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Indique la taille cible du cache de contenu au niveau de l''espace de travail. Le cache de contenu peut actuellement \00EAtre utilis\00E9 par les services de source Web et SQL compatibles REST. La cible de taille de cache sert de limite ajustable qui, pour de')
||unistr('s raisons de performances, n''est observ\00E9e que par les travaux de programmateur Application Express. Ainsi, Application Express peut d\00E9passer la limite sp\00E9cifi\00E9e lors des op\00E9rations normales. A l''ex\00E9cution suivante du travail de maintenance, le conten')
||unistr('u mis en cache avec la validit\00E9 restante la plus courte sera enlev\00E9 jusqu''\00E0 ce que la taille de cache repasse sous la limite d\00E9finie.</p>'),
'<p>',
unistr('    Cette valeur remplace le param\00E8tre de niveau instance.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(644504774903249008.4052)
,p_name=>'P78_CONTENT_CACHE_MAX_FILE_SIZE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(495344484107866205.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Taille maximale des entr\00E9es dans le cache de contenu')
,p_source=>'CONTENT_CACHE_MAX_FILE_SIZE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>15
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Indique la taille maximale du contenu \00E0 placer dans le cache de contenu. Cette valeur remplace le param\00E8tre de niveau instance.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(741568130904681315.4052)
,p_name=>'P78_MAX_EMAIL_MESSAGES'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(495344484107866205.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre maximal de courriels'
,p_source=>'MAX_EMAIL_MESSAGES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez le nombre maximal de courriels pouvant \00EAtre envoy\00E9s avec l''API <code>APEX_MAIL</code> en 24 heures. Cette valeur remplace le param\00E8tre de niveau instance.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(64863709969555108.4052)
,p_computation_sequence=>10
,p_computation_item=>'P78_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select id from wwv_flow_companies where provisioning_company_id = :P78_PROVISIONING_COMPANY_ID'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(254190817089223715.4052)
,p_computation_sequence=>20
,p_computation_item=>'P78_SN'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name',
'from wwv_flow_companies',
'where id = :P78_ID'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(64858201225546468.4052)
,p_validation_name=>'P78_PROVISIONING_COMPANY_ID not null'
,p_validation_sequence=>10
,p_validation=>'P78_PROVISIONING_COMPANY_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le provisionnement de l''espace de travail doit \00EAtre indiqu\00E9.')
,p_associated_item=>wwv_flow_api.id(64857823340546465.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1143247246142567425.4052)
,p_validation_name=>'P78_PROVISIONING_COMPANY_ID not internal'
,p_validation_sequence=>20
,p_validation=>'to_number( :P78_PROVISIONING_COMPANY_ID ) != 10'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Vous ne pouvez pas modifier l''espace de travail interne.'
,p_associated_item=>wwv_flow_api.id(64857823340546465.4052)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(64858728443546471.4052)
,p_validation_name=>'P78_SHORT_NAME not null'
,p_validation_sequence=>30
,p_validation=>'P78_SHORT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le nom abr\00E9g\00E9 doit \00EAtre indiqu\00E9.')
,p_associated_item=>wwv_flow_api.id(64858304246546470.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(64859332313546472.4052)
,p_validation_name=>'P78_FIRST_SCHEMA_PROVISIONED not null'
,p_validation_sequence=>40
,p_validation=>'P78_FIRST_SCHEMA_PROVISIONED'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le premier sch\00E9ma provisionn\00E9 doit \00EAtre indiqu\00E9.')
,p_associated_item=>wwv_flow_api.id(64858932679546471.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(111447707426965624.4052)
,p_validation_name=>'Invalid characters in workspace name'
,p_validation_sequence=>50
,p_validation=>'P78_SHORT_NAME'
,p_validation2=>'<>'
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>'Nom d''espace de travail non valide.'
,p_when_button_pressed=>wwv_flow_api.id(64856416813546450.4052)
,p_associated_item=>wwv_flow_api.id(64858304246546470.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(385905783290008661.4052)
,p_validation_name=>'Path Prefix must have value'
,p_validation_sequence=>60
,p_validation=>'trim( :P78_PATH_PREFIX ) is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Le champ #LABEL# doit contenir une valeur.'
,p_when_button_pressed=>wwv_flow_api.id(64856416813546450.4052)
,p_associated_item=>wwv_flow_api.id(385818782057330239.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(385887145438492395.4052)
,p_validation_name=>'Path Prefix already exists'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select null',
'              from wwv_flow_companies',
'             where path_prefix = upper( trim( :P78_PATH_PREFIX ) )',
'               and id != :P78_ID ) loop',
'    return false;',
'    exit;',
'end loop;',
'',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('#LABEL# existe d\00E9j\00E0.')
,p_when_button_pressed=>wwv_flow_api.id(64856416813546450.4052)
,p_associated_item=>wwv_flow_api.id(385818782057330239.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1405738480336504.4052)
,p_validation_name=>'P78_MAX_SESSION_LENGTH_SEC is positive integer'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return :P78_MAX_SESSION_LENGTH_SEC is null ',
'       or to_number(:P78_MAX_SESSION_LENGTH_SEC) >= 0;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La valeur doit \00EAtre un entier positif.')
,p_when_button_pressed=>wwv_flow_api.id(64856416813546450.4052)
,p_associated_item=>wwv_flow_api.id(537738384746133274.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1405894281336505.4052)
,p_validation_name=>'P78_MAX_SESSION_IDLE_SEC is positive integer'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return :P78_MAX_SESSION_IDLE_SEC is null ',
'       or to_number(:P78_MAX_SESSION_IDLE_SEC) >= 0;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La valeur doit \00EAtre un entier positif.')
,p_when_button_pressed=>wwv_flow_api.id(64856416813546450.4052)
,p_associated_item=>wwv_flow_api.id(537738844730133278.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1405904601336506.4052)
,p_validation_name=>'P78_SESSION_TIMEOUT_WARN_SEC is positive integer'
,p_validation_sequence=>100
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return :P78_SESSION_TIMEOUT_WARN_SEC is null ',
'       or to_number(:P78_SESSION_TIMEOUT_WARN_SEC) >= 0;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La valeur doit \00EAtre un entier positif.')
,p_when_button_pressed=>wwv_flow_api.id(64856416813546450.4052)
,p_associated_item=>wwv_flow_api.id(1589702746325019.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(64859623535546474.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_COMPANIES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_COMPANIES'
,p_attribute_03=>'P78_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Erreur lors de l''extraction de la ligne.'
,p_process_comment=>'Generated 20-JUN-2003 14:39:54'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(64859916890546475.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_COMPANIES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_COMPANIES'
,p_attribute_03=>'P78_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Erreur lors du traitement de la ligne de la table WWV_FLOW_COMPANIES.'
,p_process_success_message=>unistr('Action trait\00E9e.')
,p_process_comment=>'Generated 20-JUN-2003 14:39:54'
);
end;
/
prompt --application/pages/page_00079
begin
wwv_flow_api.create_page(
 p_id=>79.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Cr\00E9er un espace de travail - Identification du sch\00E9ma')
,p_step_title=>unistr('Cr\00E9er un espace de travail')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(3931243707245169747)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_create_wkspc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12534431790828540.4052)
,p_plug_name=>unistr('Cr\00E9er &P27_WORKSPACE_TITLE.')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>20
,p_plug_header=>unistr('<p>Indiquez si le sch\00E9ma existe d\00E9j\00E0. S''il existe, s\00E9lectionnez-le dans la liste. S''il n''existe pas, saisissez un nom et un mot de passe et choisissez la taille du tablespace associ\00E9 \00E0 cr\00E9er.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(500069818015047367.4052)
,p_plug_name=>unistr('Composant - Disponibilit\00E9')
,p_parent_plug_id=>wwv_flow_api.id(12534431790828540.4052)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_api.id(102441323786892882.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12661715260239327.4052)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(12048115202363924.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32845704425549915.4052)
,p_plug_name=>'reset'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>':F4050_P79_SCHEMA_PASSWORD := null;'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202750517190692387.4052)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(241507625027179516.4052)
,p_name=>unistr('Informations sur le sch\00E9ma &F4050_P79_SCHEMA.')
,p_region_name=>'missing_privs'
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with user_roles as (',
'    select upper(:F4050_P79_SCHEMA) ur from sys.dual',
'    union',
'    select granted_role',
'      from sys.dba_role_privs',
'     start with grantee = upper(:F4050_P79_SCHEMA)',
'     connect by grantee = prior granted_role ),',
'ur_privs as (',
'    select p.privilege',
'      from sys.dba_sys_privs p,',
'           user_roles ur',
'     where p.grantee = ur.ur ),',
'missing as (',
'select privilege',
'  from sys.dba_sys_privs p',
' where grantee = ''APEX_GRANTS_FOR_NEW_USERS_ROLE''',
'   and exists ( select null',
'                  from sys.dba_users',
'                 where username = upper(:F4050_P79_SCHEMA) )',
' minus',
'select privilege',
'  from ur_privs )',
'select account_status,',
'       default_tablespace,',
'       ( select listagg(privilege, '', '') within group (order by privilege) from missing ) missing_privs',
'  from sys.dba_users',
' where username = upper(:F4050_P79_SCHEMA)'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'F4050_P79_SCHEMA'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805670753642677848.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>unistr('Sch\00E9ma &F4050_P79_SCHEMA. introuvable.')
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
,p_required_patch=>wwv_flow_api.id(4226407758971148501.4052)
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(241507755929179517.4052)
,p_query_column_id=>1
,p_column_alias=>'ACCOUNT_STATUS'
,p_column_display_sequence=>1
,p_column_heading=>'Statut du compte'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(241507836534179518.4052)
,p_query_column_id=>2
,p_column_alias=>'DEFAULT_TABLESPACE'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Tablespace par d\00E9faut')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(241507985246179519.4052)
,p_query_column_id=>3
,p_column_alias=>'MISSING_PRIVS'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Privil\00E8ges suppl\00E9mentaires sugg\00E9r\00E9s')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752111107467695869.4052)
,p_plug_name=>unistr('Cr\00E9er un espace de travail')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(12557314353889752.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(202750517190692387.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(12559200978895311.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(202750517190692387.4052)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(12562912752898723.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(202750517190692387.4052)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(12557622294889762.4052)
,p_branch_action=>'10'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(12557314353889752.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(12563202884898724.4052)
,p_branch_action=>'27'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(12562912752898723.4052)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(12559510217895312.4052)
,p_branch_action=>'72'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(12559200978895311.4052)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12536920970844342.4052)
,p_name=>'F4050_P79_SCHEMA'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(12534431790828540.4052)
,p_prompt=>unistr('Nom de sch\00E9ma')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select username d,',
'       username r',
'  from wwv_flow_admin_all_schemas',
' where (   restricted_to_workspace is null',
'        or restricted_to_workspace = upper(:F4050_P27_COMPANY))',
' order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Si vous r\00E9utilisez un sch\00E9ma existant, s\00E9lectionnez-le \00E0 partir de la liste. Si vous cr\00E9ez un nouveau sch\00E9ma, saisissez-en le nom.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12541530105856426.4052)
,p_name=>'F4050_P79_SCHEMA_PASSWORD'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(12534431790828540.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Mot de passe de sch\00E9ma')
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez le mot de passe du sch\00E9ma. Celui-ci est obligatoire uniquement si vous cr\00E9ez un nouveau sch\00E9ma.')
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12543318462862552.4052)
,p_name=>'F4050_P79_QUOTA'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(12534431790828540.4052)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_default number;',
'begin',
'    for c1 in (select req_size',
'                 from wwv_flow_workspace_req_size',
'                where request_type = ''N''',
'                  and default_size = ''Y'') loop',
'        l_default := c1.req_size;',
'        exit;',
'    end loop;',
'    return l_default;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Quota d''espace (Mo)'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NEW WORKSPACE REQUEST STORAGE SIZES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select req_size d, req_size r',
'  from wwv_flow_workspace_req_size',
' where request_type = ''C''',
'order by to_number(req_size)',
''))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Si vous cr\00E9ez un nouveau sch\00E9ma, indiquez la taille maximum du tablespace \00E0 lui associer. Ce maximum peut \00EAtre modifi\00E9 par la suite.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12579427045959576.4052)
,p_name=>'F4050_P79_EXISTING'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(12534431790828540.4052)
,p_item_default=>'0'
,p_prompt=>unistr('R\00E9utiliser le sch\00E9ma existant ?')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES.NO.RETURNS.1_OR_0'
,p_lov=>'.'||wwv_flow_api.id(87817312158083090.4052)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Indiquez si, au d\00E9part, cet espace de travail utilisera un sch\00E9ma de base de donn\00E9es existant ou un sch\00E9ma nouvellement cr\00E9\00E9.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(500070508436047375.4052)
,p_name=>'P79_ALLOW_APP_BUILDING_YN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(500069818015047367.4052)
,p_item_default=>'Y'
,p_prompt=>'Autoriser App Builder'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Activez App Builder pour cet espace de travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(500071003880047376.4052)
,p_name=>'P79_ALLOW_SQL_WORKSHOP_YN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(500069818015047367.4052)
,p_item_default=>'Y'
,p_prompt=>'Autoriser SQL Workshop'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Activez SQL Workshop pour cet espace de travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(500071507566047376.4052)
,p_name=>'P79_ALLOW_TEAM_DEVELOPMENT_YN'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(500069818015047367.4052)
,p_item_default=>'Y'
,p_prompt=>unistr('Autoriser le d\00E9veloppement d''\00E9quipe')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Activez le d\00E9veloppement d''\00E9quipe dans cet espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(500072025033047378.4052)
,p_name=>'P79_ALLOW_PLSQL_EDITING'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(500069818015047367.4052)
,p_item_default=>'Y'
,p_prompt=>'Autoriser la modification du code PL/SQL dans SQL Workshop'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Autorisez la modification des proc\00E9dures, packages, fonctions et d\00E9clencheurs PL/SQL dans le navigateur Web.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(114756701339208327.4052)
,p_computation_sequence=>10
,p_computation_item=>'F4050_P79_SCHEMA'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'ltrim(rtrim(upper(:F4050_P79_SCHEMA)))'
,p_compute_when=>'F4050_P79_SCHEMA'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(12903312985817444.4052)
,p_validation_name=>'schema name is valid'
,p_validation_sequence=>20
,p_validation=>'wwv_flow_utilities.is_valid_identifier(p_identifier=>:F4050_P79_SCHEMA,p_quote=>true)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Le nom de sch\00E9ma doit \00EAtre un identificateur Oracle valide.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from sys.dba_users',
' where username = ''ANONYMOUS'''))
,p_validation_condition_type=>'EXISTS'
,p_when_button_pressed=>wwv_flow_api.id(12559200978895311.4052)
,p_associated_item=>wwv_flow_api.id(12536920970844342.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(12907532640841968.4052)
,p_validation_name=>'check if schema exists'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from sys.dba_users',
' where username = upper(:F4050_P79_SCHEMA)'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('Le sch\00E9ma n''existe pas.')
,p_validation_condition=>':F4050_P79_EXISTING = ''1'' and :F4050_P79_SCHEMA is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(12559200978895311.4052)
,p_associated_item=>wwv_flow_api.id(12536920970844342.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(12920702259889987.4052)
,p_validation_name=>'password required'
,p_validation_sequence=>40
,p_validation=>'F4050_P79_SCHEMA_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Vous devez indiquer un mot de passe.'
,p_validation_condition=>':F4050_P79_EXISTING = ''0'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(12559200978895311.4052)
,p_associated_item=>wwv_flow_api.id(12541530105856426.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(12941526463944301.4052)
,p_validation_name=>'quota not 0'
,p_validation_sequence=>50
,p_validation=>'F4050_P79_QUOTA'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>unistr('Le quota doit \00EAtre indiqu\00E9.')
,p_validation_condition=>':F4050_P79_EXISTING = ''0'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(12559200978895311.4052)
,p_associated_item=>wwv_flow_api.id(12543318462862552.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(13051609305876166.4052)
,p_validation_name=>'check if schema doesn''t exist'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from sys.dba_users',
' where username = upper(:F4050_P79_SCHEMA)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Le sch\00E9ma existe d\00E9j\00E0.')
,p_validation_condition=>':F4050_P79_EXISTING = ''0'' and :F4050_P79_SCHEMA is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(12559200978895311.4052)
,p_associated_item=>wwv_flow_api.id(12536920970844342.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(68152924708064446.4052)
,p_validation_name=>'check existing schema not internal'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_companies',
' where provisioning_company_id = 10',
'   and first_schema_provisioned = upper(:F4050_P79_SCHEMA)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Impossible d''utiliser le sch\00E9ma INTERNAL.')
,p_validation_condition=>':F4050_P79_EXISTING = ''1'' and :F4050_P79_SCHEMA is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(12559200978895311.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(114752711027135415.4052)
,p_validation_name=>'schema not reserved/restricted'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_provision.schema_name_valid(',
'    p_schema            => :F4050_P79_SCHEMA,',
'    p_workspace_name    => :F4050_P27_COMPANY);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Le sch\00E9ma est r\00E9serv\00E9 ou restreint.')
,p_when_button_pressed=>wwv_flow_api.id(12559200978895311.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(56740204823780291.4052)
,p_validation_name=>'password format rules'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_4050_ui.p79_validate_password (',
'           p_username => :F4050_P79_SCHEMA,',
'           p_password => :F4050_P79_SCHEMA_PASSWORD );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Le mot de passe de sch\00E9ma doit comporter 30 caract\00E8res ASCII au maximum et ne doit pas contenir de guillemets. Il doit \00E9galement \00EAtre conforme \00E0 toutes les r\00E8gles de complexit\00E9 de mot de passe d\00E9finies pour la base de donn\00E9es. ')
,p_validation_condition=>':F4050_P79_EXISTING = ''0'' and :F4050_P79_SCHEMA_PASSWORD is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(12559200978895311.4052)
,p_associated_item=>wwv_flow_api.id(12541530105856426.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1213282613785258420.4052)
,p_name=>'Reuse Schema'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4050_P79_EXISTING'
,p_condition_element=>'F4050_P79_EXISTING'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1213282932418258421.4052)
,p_event_id=>wwv_flow_api.id(1213282613785258420.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4050_P79_SCHEMA_PASSWORD,F4050_P79_QUOTA'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1213283115062258422.4052)
,p_event_id=>wwv_flow_api.id(1213282613785258420.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4050_P79_SCHEMA_PASSWORD,F4050_P79_QUOTA'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(241508530030179525.4052)
,p_name=>'Refresh Schema Info if Reuse'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4050_P79_EXISTING'
,p_condition_element=>'F4050_P79_EXISTING'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_required_patch=>wwv_flow_api.id(4226407758971148501.4052)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(241508851019179528.4052)
,p_event_id=>wwv_flow_api.id(241508530030179525.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(241507625027179516.4052)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(241508974917179529.4052)
,p_event_id=>wwv_flow_api.id(241508530030179525.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(241507625027179516.4052)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(241509064010179530.4052)
,p_event_id=>wwv_flow_api.id(241508530030179525.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(241507625027179516.4052)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(241508317987179523.4052)
,p_name=>'Refresh Schema Info if schema changed'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4050_P79_SCHEMA'
,p_condition_element=>'F4050_P79_EXISTING'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_required_patch=>wwv_flow_api.id(4226407758971148501.4052)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(241508422473179524.4052)
,p_event_id=>wwv_flow_api.id(241508317987179523.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(241507625027179516.4052)
);
end;
/
prompt --application/pages/page_00080
begin
wwv_flow_api.create_page(
 p_id=>80.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Activit\00E9 par espace de travail par jour')
,p_step_title=>unistr('Activit\00E9 par espace de travail par jour')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(201374126243613345.4052)
,p_plug_name=>unistr('Activit\00E9 par espace de travail')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    LOG_DAY,',
'    to_char(log_day,''Day'') day,',
'    WORKSPACE_ID workspace,',
'    (select short_name from wwv_flow_companies where provisioning_company_id = workspace_id) workspace_name,',
'    count(distinct APPLICATION_ID) applications,',
'    sum(page_events) PAGE_EVENTS,',
'    sum(page_views) PAGE_VIEWS,',
'    sum(page_accepts) PAGE_ACCEPTS,',
'    sum(partial_page_views) PARTIAL_PAGE_VIEWS,',
'    sum(websheet_views) WEBSHEET_VIEWS,',
'    sum(rows_fetched) ROWS_FETCHED,',
'    sum(ir_searches) IR_SEARCHES,',
'    sum(distinct_pages) DISTINCT_PAGES,',
'    sum(distinct_users) DISTINCT_USERS,',
'    sum(distinct_sessions) DISTINCT_SESSIONS,',
'    sum(total_render_time) TOTAL_RENDER_TIME,',
'    sum(error_count) ERROR_COUNT,',
'    sum(nvl(content_length,0)) content_length,',
'    sum(public_page_events) public_page_events',
'from WWV_FLOW_LOG_HISTORY ',
'group by LOG_DAY, workspace_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(201374302520613352.4052)
,p_name=>'Activity by Day'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201374421565613353.4052)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Consigner le jour dans le journal'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201374517849613354.4052)
,p_db_column_name=>'DAY'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Jour'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201374632459613355.4052)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201374701774613356.4052)
,p_db_column_name=>'PAGE_EVENTS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Ev\00E9nements de page')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(582264518231682816.4052)
,p_db_column_name=>'PUBLIC_PAGE_EVENTS'
,p_display_order=>15
,p_column_identifier=>'T'
,p_column_label=>unistr('Ev\00E9nements de page publique')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201374827012613357.4052)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>25
,p_column_identifier=>'F'
,p_column_label=>'Vues de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201374917308613358.4052)
,p_db_column_name=>'PAGE_ACCEPTS'
,p_display_order=>35
,p_column_identifier=>'G'
,p_column_label=>'Envois de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201375011933613359.4052)
,p_db_column_name=>'PARTIAL_PAGE_VIEWS'
,p_display_order=>45
,p_column_identifier=>'H'
,p_column_label=>'Vues de page partielle'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201375124567613360.4052)
,p_db_column_name=>'WEBSHEET_VIEWS'
,p_display_order=>55
,p_column_identifier=>'I'
,p_column_label=>'Vues de feuille Web'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_security_scheme=>wwv_flow_api.id(610289739776900562)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201375224837613361.4052)
,p_db_column_name=>'ROWS_FETCHED'
,p_display_order=>65
,p_column_identifier=>'J'
,p_column_label=>'Lignes extraites'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201375302032613362.4052)
,p_db_column_name=>'IR_SEARCHES'
,p_display_order=>75
,p_column_identifier=>'K'
,p_column_label=>unistr('Recherches d''\00E9tat interactif')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201375427908613363.4052)
,p_db_column_name=>'DISTINCT_PAGES'
,p_display_order=>85
,p_column_identifier=>'L'
,p_column_label=>'Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201375519884613364.4052)
,p_db_column_name=>'DISTINCT_USERS'
,p_display_order=>95
,p_column_identifier=>'M'
,p_column_label=>'Utilisateurs'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201375629818613365.4052)
,p_db_column_name=>'DISTINCT_SESSIONS'
,p_display_order=>105
,p_column_identifier=>'N'
,p_column_label=>'Sessions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201375713682613366.4052)
,p_db_column_name=>'TOTAL_RENDER_TIME'
,p_display_order=>115
,p_column_identifier=>'O'
,p_column_label=>'Temps d''affichage total'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201375809425613367.4052)
,p_db_column_name=>'ERROR_COUNT'
,p_display_order=>125
,p_column_identifier=>'P'
,p_column_label=>'Erreurs'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201375906686613368.4052)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>135
,p_column_identifier=>'Q'
,p_column_label=>'Contenu'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201376015353613369.4052)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>145
,p_column_identifier=>'R'
,p_column_label=>'Espace de travail'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(201376117728613370.4052)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>155
,p_column_identifier=>'S'
,p_column_label=>'Nom de l''espace de travail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(484705024716062089.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(201374126243613345.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.:80,RIR::'
);
end;
/
prompt --application/pages/page_00081
begin
wwv_flow_api.create_page(
 p_id=>81.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Enlever un espace de travail'
,p_step_title=>'Enlever un espace de travail - Identifier un espace de travail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_wrkspc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14594219371324854.4052)
,p_plug_name=>unistr('S\00E9lectionner un espace de travail')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14913329255048880.4052)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(14571819699173520.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202765904517773962.4052)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752111225869695869.4052)
,p_plug_name=>'Enlever un espace de travail'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14602029470431848.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(202765904517773962.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14602914018436860.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(202765904517773962.4052)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(14603212719436863.4052)
,p_branch_action=>'82'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'nvl(:REQUEST,''NEXT'') = ''NEXT'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(14602323502431864.4052)
,p_branch_action=>'3'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(14602029470431848.4052)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14614023639074072.4052)
,p_name=>'P81_COMPANY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(14594219371324854.4052)
,p_prompt=>'Espace de travail'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST.WORKSPACES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name d, short_name v',
'  from wwv_flow_companies',
' where (provisioning_company_id not in (0,10,11,12))',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez un espace de travail dans la liste.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14614600006086241.4052)
,p_name=>'P81_SGID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(14594219371324854.4052)
,p_prompt=>'Sgid'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(14617300446143134.4052)
,p_validation_name=>'valid company'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
' l_sgid number;',
'begin',
'for c1 in (select provisioning_company_id',
'             from wwv_flow_companies',
'            where short_name = upper(:P81_COMPANY) ) loop',
'  l_sgid := c1.provisioning_company_id;',
'  exit;',
'end loop;',
':P81_SGID := l_sgid;',
'return nvl(:P81_SGID,''0'') not in (''0'',''10'');',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Espace de travail non valide.'
,p_validation_condition=>'nvl(:REQUEST,''NEXT'') = ''NEXT'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00082
begin
wwv_flow_api.create_page(
 p_id=>82.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Enlever un espace de travail'
,p_step_title=>unistr('Enlever un espace de travail - V\00E9rifier les applications')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216766430018595041)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_wrkspc_lock.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14593705173320764.4052)
,p_plug_name=>'Applications et utilisateurs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>10
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_cc number;',
'  l_uc number;',
'begin',
'  select count(*)',
'    into l_cc',
'    from wwv_flows',
'   where security_group_id = :P81_SGID;',
'  --',
'  select count(*)',
'    into l_uc',
'    from wwv_flow_fnd_user',
'   where security_group_id = :P81_SGID;',
'  --',
'  sys.htp.p(''<p>''||wwv_flow_lang.system_message(''4050_82_WORKSPACE'',null,wwv_flow_escape.html(:P81_COMPANY),l_cc,l_uc)||''</p>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_header=>unistr('Notez le nombre d''applications et d''utilisateurs dans &P81_COMPANY.. Effectuez une s\00E9lection pour indiquer si vous voulez continuer, et si vous voulez \00E9galement supprimer la demande.')
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14914429863067996.4052)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(14571819699173520.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202768115037786443.4052)
,p_plug_name=>'wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752111382363695869.4052)
,p_plug_name=>'Enlever un espace de travail'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14603914495446450.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(202768115037786443.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14604824538449331.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(202768115037786443.4052)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14605700081451745.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(202768115037786443.4052)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(14604224784446451.4052)
,p_branch_action=>'3'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(14603914495446450.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(14606013354451746.4052)
,p_branch_action=>'81'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(14605700081451745.4052)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(14605118530449332.4052)
,p_branch_action=>'83'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(14604824538449331.4052)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14923621870188674.4052)
,p_name=>'P82_PROCEED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(14593705173320764.4052)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CONFIRM.REMOVAL'
,p_lov=>'.'||wwv_flow_api.id(87818332243088870.4052)||'.'
,p_tag_attributes2=>'class="instructiontext"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14924614036195964.4052)
,p_name=>'P82_REQUEST'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(14593705173320764.4052)
,p_item_default=>'Yes'
,p_source=>'Yes'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes2=>'class="instructiontext"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifiez si vous souhaitez \00E9galement enlever la demande pour l''espace de travail en question.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(14931826737341549.4052)
,p_validation_name=>'must check proceed'
,p_validation_sequence=>10
,p_validation=>'nvl(:P82_PROCEED,''No'') = ''Yes'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Vous devez cocher pour continuer.'
,p_when_button_pressed=>wwv_flow_api.id(14604824538449331.4052)
,p_associated_item=>wwv_flow_api.id(14923621870188674.4052)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
end;
/
prompt --application/pages/page_00083
begin
wwv_flow_api.create_page(
 p_id=>83.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Enlever un espace de travail'
,p_step_title=>'Enlever un espace de travail - Confirmer la suppression de l''espace de travail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216766430018595041)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_wrkspc.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(14593004003310937.4052)
,p_name=>unistr('Objets de base de donn\00E9es')
,p_template=>wwv_flow_api.id(721130166613730309.4052)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner user_name,',
'       tablespace_name tblspc_name',
'  from sys.dba_segments',
' where owner in (select schema',
'                   from wwv_flow_company_schemas',
'                  where security_group_id = :P81_SGID)',
' group by owner,',
'          tablespace_name'))
,p_header=>unistr('<p>Vous pouvez enlever les objets de base de donn\00E9es suivants, qui sont associ\00E9s \00E0 l''espace de travail, \00E0 l''aide de votre outil d''administration de base de donn\00E9es favori. Cliquer sur le bouton Enlever <strong>n''enl\00E8ve pas</strong> ces objets de la b')
||unistr('ase de donn\00E9es.</p>')
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'1'
,p_query_row_count_max=>500
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48758313236772048.4052)
,p_query_column_id=>1
,p_column_alias=>'USER_NAME'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Sch\00E9ma')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48758414533772048.4052)
,p_query_column_id=>2
,p_column_alias=>'TBLSPC_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Tablespaces'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14917018912074297.4052)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(14571819699173520.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(15181710710380687.4052)
,p_name=>unistr('Autres sch\00E9mas utilisant les tablespaces ci-dessus')
,p_template=>wwv_flow_api.id(202654431224384775.4052)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.default_tablespace, a.username',
'  from sys.dba_users a',
' where default_tablespace in (select default_tablespace ',
'                                from sys.dba_users',
'                               where username in (select schema ',
'                      from wwv_flow_company_schemas d',
'                     where d.security_group_id = :P81_SGID))',
'group by a.username, a.default_tablespace'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>unistr('<p />Aucun autre sch\00E9ma utilisant les tablespaces ci-dessus n''a \00E9t\00E9 trouv\00E9.')
,p_query_row_count_max=>500
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(27281122243677013.4052)
,p_query_column_id=>1
,p_column_alias=>'DEFAULT_TABLESPACE'
,p_column_display_sequence=>1
,p_column_heading=>'Tablespace'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(27281231350677018.4052)
,p_query_column_id=>2
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Sch\00E9mas')
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19230510658720488.4052)
,p_plug_name=>unistr('Objets de base de donn\00E9es')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(202654431224384775.4052)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Lisez les informations relatives aux \00E9tats dans cette page. Utilisez-les pour d\00E9cider si vous voulez utiliser un outil d''administration de base de donn\00E9es pour supprimer les objets de base de donn\00E9es associ\00E9s \00E0 l''espace de travail. Cliquez sur <st')
||'rong>Enlever un espace de travail</strong> pour enlever l''espace de travail.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202769707334803166.4052)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752111474238695870.4052)
,p_plug_name=>'Enlever un espace de travail'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14606702898020828.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(202769707334803166.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14608612726033126.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(202769707334803166.4052)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Enlever un espace de travail'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14607701644029883.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(202769707334803166.4052)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(14607015917020918.4052)
,p_branch_action=>'3'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(14606702898020828.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(14608922159033128.4052)
,p_branch_action=>'84'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(14608612726033126.4052)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(14608029060029885.4052)
,p_branch_action=>'82'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(14607701644029883.4052)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15237905291663011.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove company'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_provisioning.terminate_service_by_sgid(:P81_SGID);',
'if :P82_REQUEST = ''Yes'' then',
'  for c1 in (select id',
'               from wwv_flow_provision_company',
'              where security_group_id = :P81_SGID ) loop',
'    wwv_flow_provisioning.delete_provision_request(c1.id);',
'    exit;',
'  end loop;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors de la suppression de l''espace de travail.'
,p_process_when_button_id=>wwv_flow_api.id(14608612726033126.4052)
,p_process_success_message=>unistr('Espace de travail supprim\00E9.')
);
end;
/
prompt --application/pages/page_00084
begin
wwv_flow_api.create_page(
 p_id=>84.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Enlever un espace de travail'
,p_step_title=>'Enlever un espace de travail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216766430018595041)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_wrkspc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14592527767308349.4052)
,p_plug_name=>unistr('Succ\00E8s')
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829706609080810173.4052)
,p_plug_display_sequence=>10
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
' wwv_flow_wiz_confirm.create_success_page(',
'    p_success_msg => wwv_flow_lang.system_message(''REMOVE_WORKSPACE_SUCCESS_MSG''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(207758923297627802.4052)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752111523341695870.4052)
,p_plug_name=>'Enlever un espace de travail'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19257111051749035.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(207758923297627802.4052)
,p_button_name=>'DONE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Termin\00E9')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::'
);
end;
/
prompt --application/pages/page_00085
begin
wwv_flow_api.create_page(
 p_id=>85.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('G\00E9rer le journal des clics')
,p_step_title=>unistr('G\00E9rer le journal des clics')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216783731365642767)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>'AEADM/adm_logs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(64963723000904073.4052)
,p_plug_name=>unistr('Supprimer les entr\00E9es du journal des clics')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   c_dev pls_integer := 0;',
'',
'begin',
'/*',
'   sys.htp.p(''<table class="instructiontext" role="presentation">'');',
'   -- wwv_flow_builder_audit_trail ',
'   select count(*) into c_dev from wwv_flow_clickthru_log_v;',
'   sys.htp.p(''<tr><td>''||wwv_flow_lang.system_message(''4050_85_CLICK_COUNT'')||''</td><td align="right">'');',
'   sys.htp.p(to_char(c_dev,''999,999,999,990''));',
'   sys.htp.p(''</td><td><br /></td></tr>'');',
'   sys.htp.p(''</table>'');',
'*/',
'   select count(*) into c_dev from wwv_flow_clickthru_log_v;',
'   sys.htp.p(''<p>''||wwv_flow_lang.system_message(''4050_85_CLICK_COUNT'')||'': '');',
'   sys.htp.p(to_char(c_dev,''999,999,999,990'')||''</p>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1080987434530523907.4052)
,p_plug_name=>'Boutons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1082458667726299596.4052)
,p_plug_name=>'Journal des clics externes'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829706609080810173.4052)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Il est possible de compter les liens vers des URL externes \00E0 l''aide de la proc\00E9dure APEX_UTIL.COUNT_CLICK. ')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(64964604942904082.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1080987434530523907.4052)
,p_button_name=>'DELETE_ENTRIES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Supprimer des entr\00E9es')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(64964329194904080.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1080987434530523907.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(64965617138904089.4052)
,p_branch_action=>'85'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(64964604942904082.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(64964910248904083.4052)
,p_name=>'P85_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(64963723000904073.4052)
,p_prompt=>unistr('Supprimer les entr\00E9es datant du nombre de jours suivant ou plus :')
,p_source=>'31'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIME_INTERVALS'
,p_lov=>'.'||wwv_flow_api.id(87720511660244788.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Purgez les entr\00E9es d\00E9passant ce nombre de jours.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(64965310351904088.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete rows'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_clickthru_log$',
'where clickdate < (sysdate - nvl(:p85_time,31));',
'delete from wwv_flow_clickthru_log2$',
'where clickdate < (sysdate - nvl(:p85_time,31));'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors de la purge du journal des clics.'
,p_process_when_button_id=>wwv_flow_api.id(64964604942904082.4052)
,p_process_success_message=>unistr('Journal des clics externes purg\00E9.')
);
end;
/
prompt --application/pages/page_00086
begin
wwv_flow_api.create_page(
 p_id=>86.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Ev\00E9nements de page par jour')
,p_step_title=>unistr('Ev\00E9nements de page par jour')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(692988924470464115.4052)
,p_plug_name=>unistr('Ev\00E9nements de page par jour')
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517376500704206647.4052)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_comment=>'NOTE: the Time Axis Type attribute cannot be used with this chart, as it will render the chart data in chronological order instead of reverse order. Have discussed with the JET team, and the only way around this is to apply formatting in the query. A'
||' Format Type of date will not work in this situation either.'
);
wwv_flow_api.create_jet_chart(
 p_id=>wwv_flow_api.id(692989033227464116.4052)
,p_region_id=>wwv_flow_api.id(692988924470464115.4052)
,p_chart_type=>'bar'
,p_height=>'500'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_spark_chart=>'N'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'delayed'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>false
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'on'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( options ){',
'    options.initialZooming = ''first'';',
'    return options;',
'}'))
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(692989152686464117.4052)
,p_chart_id=>wwv_flow_api.id(692989033227464116.4052)
,p_seq=>10
,p_name=>unistr('Ev\00E9nements de page')
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(LOG_DAY,''dd/mm/yyyy'') LOG_DAY_FORMAT,',
'       sum(page_events) PAGE_EVENTS,',
'       to_char(LOG_DAY,''dd/mm/yyyy'') ||'' - ''||sum(page_events) TOOLTIP',
' from WWV_FLOW_LOG_HISTORY ',
' where log_day >= sysdate - (nvl(:P86_SINCE,365)+ 1)',
'group by LOG_DAY',
'order by log_day desc'))
,p_items_value_column_name=>'PAGE_EVENTS'
,p_items_label_column_name=>'LOG_DAY_FORMAT'
,p_items_short_desc_column_name=>'TOOLTIP'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'outsideBarEdge'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(692989208016464118.4052)
,p_chart_id=>wwv_flow_api.id(692989033227464116.4052)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(692989348943464119.4052)
,p_chart_id=>wwv_flow_api.id(692989033227464116.4052)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2518799722329348512.4052)
,p_plug_name=>'Button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>1
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(880582675247775376.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2518799722329348512.4052)
,p_button_name=>'Set'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('D\00E9finir')
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(880583028228775377.4052)
,p_name=>'P86_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2518799722329348512.4052)
,p_item_default=>'365'
,p_prompt=>'Depuis'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME_ARCHIVE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 30 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 186 t from dual union all',
'select ''9 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 279 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00087
begin
wwv_flow_api.create_page(
 p_id=>87.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Espaces de travail inactifs'
,p_step_title=>'Espaces de travail inactifs'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(505829811233279931.4052)
,p_plug_name=>'Espaces de travail inactifs'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.security_group_id, p.workspace_name, p.admin_email, p.status, p.date_to_purge, p.purged_ts, ',
'case when status in (''NEW'',''STAGE1'',''STAGE2'')  then trunc(date_to_purge - sysdate + 1)',
'else null end days_until_purge',
'  from wwv_purge_workspaces p'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(505829910729279931.4052)
,p_name=>'Inactive workspaces'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(505830114353279935.4052)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nom de l''espace de travail'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(505830215491279937.4052)
,p_db_column_name=>'ADMIN_EMAIL'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Adresse \00E9lectronique de l''administrateur')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(505830310938279937.4052)
,p_db_column_name=>'STATUS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Statut'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(615479015710157661)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(505830425352279937.4052)
,p_db_column_name=>'DATE_TO_PURGE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Date \00E0 purger')
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(615371414664780015.4052)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'ID d''espace de travail'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(628538101320762044.4052)
,p_db_column_name=>'PURGED_TS'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Date de la purge'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(628538231731762047.4052)
,p_db_column_name=>'DAYS_UNTIL_PURGE'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Jours restants avant la purge'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
end;
/
prompt --application/pages/page_00088
begin
wwv_flow_api.create_page(
 p_id=>88.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('D\00E9tails d''utilisation de tablespace d''espace de travail')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('D\00E9tails d''utilisation de tablespace d''espace de travail')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(721098050798687927.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEADM/adm_mg_wrkspc.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(20473405904587601.4052)
,p_name=>'Utilisation de tablespace d''espace de travail'
,p_template=>wwv_flow_api.id(721130166613730309.4052)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with workspace_tablespace as',
'    ( select distinct default_tablespace',
'        from sys.dba_users',
'       where username in ',
'             (select schema',
'                from wwv_flow_company_schemas',
'               where security_group_id = :P88_SGID)',
'    )',
'select tm.tablespace_name name,',
'       tm.tablespace_size * ts.block_size bytes,',
'       (tm.tablespace_size-tm.used_space) * ts.block_size free,',
'       tm.used_space * ts.block_size used,',
'       tm.used_percent pct_used',
'  from workspace_tablespace wt,',
'       sys.dba_tablespaces  ts,',
'       sys.dba_tablespace_usage_metrics tm',
' where wt.default_tablespace = ts.tablespace_name',
'   and ts.tablespace_name    = tm.tablespace_name',
''))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  select name, bytes, bytes-free used, free, (bytes-free)/bytes*100 pct_used from',
'(select t.tablespace_name name,',
'       ( select sum(user_blocks * t.block_size)',
'             from sys.dba_data_files',
'            where tablespace_name = t.tablespace_name ) bytes,',
'       ( select sum(bytes)',
'             from sys.dba_free_space',
'            where tablespace_name = t.tablespace_name ) free',
'   from sys.dba_tablespaces t',
'  where tablespace_name in (select default_tablespace',
'           from sys.dba_users where username in (select schema from wwv_flow_company_schemas',
'           where security_group_id= :P88_SGID )))',
'  order by 1'))
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48758714618772055.4052)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nom de tablespace'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48758816637772055.4052)
,p_query_column_id=>2
,p_column_alias=>'BYTES'
,p_column_display_sequence=>2
,p_column_heading=>'Octets'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48759019303772055.4052)
,p_query_column_id=>3
,p_column_alias=>'FREE'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Quantit\00E9 libre')
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48758922966772055.4052)
,p_query_column_id=>4
,p_column_alias=>'USED'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Quantit\00E9 utilis\00E9e')
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48759100469772055.4052)
,p_query_column_id=>5
,p_column_alias=>'PCT_USED'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Pourcentage utilis\00E9')
,p_column_format=>'999D99'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(955891504788997326.4052)
,p_plug_name=>'Nouveau'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(955891291846997323.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(955891504788997326.4052)
,p_button_name=>'Close'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Fermer'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20474119756591606.4052)
,p_name=>'P88_SGID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20473405904587601.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(955891358314997324.4052)
,p_name=>'Close dialogue'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(955891291846997323.4052)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(955891426517997325.4052)
,p_event_id=>wwv_flow_api.id(955891358314997324.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
end;
/
prompt --application/pages/page_00089
begin
wwv_flow_api.create_page(
 p_id=>89.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Verrouiller l''espace de travail'
,p_step_title=>'Verrouiller l''espace de travail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_wrkspc_lock.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(74652808599025380.4052)
,p_plug_name=>unistr('S\00E9lectionner un espace de travail')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(85915716857846509.4052)
,p_plug_name=>'Verrouiller l''espace de travail'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(202654431224384775.4052)
,p_plug_display_sequence=>200
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Verrouiller l''espace de travail verrouille tous les comptes d''administrateur, de d\00E9veloppeur et d''utilisateur final de l''espace de travail, et fait passer le statut de toutes les applications de l''espace de travail \00E0 <strong>Non disponible</strong')
||'>.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202792128823310849.4052)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752111603710695870.4052)
,p_plug_name=>'Verrouiller l''espace de travail'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(74653918545025411.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(202792128823310849.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(74654109803025411.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(202792128823310849.4052)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(74655525602025412.4052)
,p_branch_action=>'90'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'nvl(:REQUEST,''NEXT'') = ''NEXT'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(74654301592025411.4052)
,p_name=>'P89_COMPANY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(74652808599025380.4052)
,p_prompt=>'Espace de travail'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST.WORKSPACES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name d, short_name v',
'  from wwv_flow_companies',
' where (provisioning_company_id not in (0,10,11,12))',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Saisissez le nom de l''espace de travail ou choisissez-le dans la liste instantan\00E9e.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(74654819424025411.4052)
,p_name=>'P89_SGID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(74652808599025380.4052)
,p_prompt=>'Workspace ID'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(74655127973025412.4052)
,p_validation_name=>'valid company'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
' l_sgid number;',
'begin',
'for c1 in (select provisioning_company_id',
'             from wwv_flow_companies',
'            where short_name = upper(:P89_COMPANY) ) loop',
'  l_sgid := c1.provisioning_company_id;',
'  exit;',
'end loop;',
':P89_SGID := l_sgid;',
'return nvl(:P89_SGID,''0'') not in (''0'',''10'');',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Espace de travail non valide.'
,p_validation_condition=>'nvl(:REQUEST,''NEXT'') = ''NEXT'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(74654301592025411.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00090
begin
wwv_flow_api.create_page(
 p_id=>90.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Verrouiller l''espace de travail'
,p_step_title=>'Verrouiller l''espace de travail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216766430018595041)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_wrkspc_lock.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(74669328104071891.4052)
,p_plug_name=>'Verrouiller l''espace de travail'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>5
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Verrouiller l''espace de travail verrouille tous les comptes d''administrateur, de d\00E9veloppeur et d''utilisateur final de l''espace de travail, et fait passer le statut de toutes les applications de l''espace de travail \00E0 Non disponible.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(85653808387907448.4052)
,p_plug_name=>'Verrouiller l''espace de travail'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(85674623437148366.4052)
,p_name=>'Applications'
,p_template=>wwv_flow_api.id(721128767486730308.4052)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, name, owner, flow_status',
'  from wwv_flows',
' where security_group_id = :P90_SGID',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('Aucune application n''a \00E9t\00E9 trouv\00E9e dans l''espace de travail.')
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(85675011809148369.4052)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID d''application'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(85674820363148369.4052)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nom d''application'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(85674919778148369.4052)
,p_query_column_id=>3
,p_column_alias=>'OWNER'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Sch\00E9ma d''application')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(85780729736329933.4052)
,p_query_column_id=>4
,p_column_alias=>'FLOW_STATUS'
,p_column_display_sequence=>4
,p_column_heading=>'Statut'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(85746300886317667)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(85676332095150788.4052)
,p_name=>'Utilisateurs de &PRODUCT_NAME.'
,p_template=>wwv_flow_api.id(721128767486730308.4052)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select user_name, default_schema, email_address, nvl(account_locked,''N'') account_locked',
'  from wwv_flow_fnd_user',
' where security_group_id = :P90_SGID',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('Aucun utilisateur n''a \00E9t\00E9 trouv\00E9.')
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(85676514972150788.4052)
,p_query_column_id=>1
,p_column_alias=>'USER_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Utilisateur'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(85676628931150788.4052)
,p_query_column_id=>2
,p_column_alias=>'DEFAULT_SCHEMA'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Sch\00E9ma par d\00E9faut')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(85676726660150788.4052)
,p_query_column_id=>3
,p_column_alias=>'EMAIL_ADDRESS'
,p_column_display_sequence=>3
,p_column_heading=>'Courriel'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(85689614658212069.4052)
,p_query_column_id=>4
,p_column_alias=>'ACCOUNT_LOCKED'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Disponibilit\00E9 du compte')
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(12506800188785204)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168835408368573854.4052)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752111718873695870.4052)
,p_plug_name=>'Verrouiller l''espace de travail'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(74670426220071893.4052)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(168835408368573854.4052)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'CLOSE'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(74670021900071892.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(168835408368573854.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::'
,p_button_cattributes=>'class="BUTTON10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(74670217088071892.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(168835408368573854.4052)
,p_button_name=>'LOCK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Verrouiller l''espace de travail'
,p_button_position=>'NEXT'
,p_button_cattributes=>'class="BUTTON10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(74671131723071894.4052)
,p_branch_action=>'89'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(74670426220071893.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(85925801975917954.4052)
,p_branch_action=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(74670217088071892.4052)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(85656725141921763.4052)
,p_name=>'P90_SGID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(85653808387907448.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Espace de travail :'
,p_source=>'P89_SGID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_ALL_COMPANIES_NO_NULL_OPTION'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id > 0',
'  and  provisioning_company_id != 11',
'  and  provisioning_company_id != 12',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Nom de l''espace de travail \00E0 verrouiller.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(74670619125071893.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'lock workspace'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P89_SGID,''0'') not in (''0'',''10'') then',
'  wwv_flow_admin_api.lock_workspace( p_security_group_id => :P89_SGID );',
'  commit;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors du verrouillage de l''espace de travail'
,p_process_when_button_id=>wwv_flow_api.id(74670217088071892.4052)
,p_process_success_message=>unistr('Espace de travail verrouill\00E9.')
);
end;
/
prompt --application/pages/page_00091
begin
wwv_flow_api.create_page(
 p_id=>91.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Espaces de travail purg\00E9s')
,p_step_title=>unistr('Espaces de travail purg\00E9s')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(505836210479512428.4052)
,p_plug_name=>unistr('Espaces de travail purg\00E9s')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct w.workspace_name, s.schema, d.tablespace_name, d.bytes',
'                 from wwv_purge_log w, wwv_purge_schemas s, wwv_purge_datafiles d',
'                where w.log_code = ''PURGE_COMPLETE''',
'                  and w.created_ts > (systimestamp - numtodsinterval(nvl(:P91_DAYS,1), ''day''))',
'                  and w.security_group_id = s.security_group_id',
'                  and w.security_group_id = d.security_group_id',
'                order by 1, 2, 3, 4'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(505836315529512428.4052)
,p_name=>'Workspaces Purged Today'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(505836503851512431.4052)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nom de l''espace de travail'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(505836613500512432.4052)
,p_db_column_name=>'SCHEMA'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Sch\00E9ma')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(505836725519512432.4052)
,p_db_column_name=>'TABLESPACE_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Nom de tablespace'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(505836816343512432.4052)
,p_db_column_name=>'BYTES'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Octets'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(505847413010640446.4052)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(505848023530652971.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(505847413010640446.4052)
,p_button_name=>'P91_SET'
,p_button_static_id=>'P91_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('D\00E9finir')
,p_request_source=>'Set'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(505848407731657863.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(505847413010640446.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:91:&SESSION.::&DEBUG.:91,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(505848201681652972.4052)
,p_branch_action=>'f?p=&FLOW_ID.:91:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(505847814526650412.4052)
,p_name=>'P91_DAYS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(505847413010640446.4052)
,p_item_default=>'1'
,p_prompt=>'Depuis'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PURGE.DAYS_LIST'
,p_lov=>'.'||wwv_flow_api.id(615512721869254091.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Limitez l''\00E9tat \00E0 une tranche de temps sp\00E9cifique. Indiquez la quantit\00E9 de temps \00E0 inclure dans l''\00E9tat et cliquez sur <strong>D\00E9finir</strong>.<p />'),
unistr('Si vous s\00E9lectionnez 1 jour, seules les derni\00E8res 24 heures s''affichent.  ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00092
begin
wwv_flow_api.create_page(
 p_id=>92.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Espaces de travail devenus actifs'
,p_step_title=>'Espaces de travail devenus actifs'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(505838125174522495.4052)
,p_plug_name=>'Espaces de travail devenus actifs'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P92 */ distinct workspace_name, security_group_id',
'from wwv_purge_log',
'where log_code = ''DELETE''',
'   and created_ts > (systimestamp - numtodsinterval(nvl(:P92_DAYS,1), ''day''))'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(505838232270522495.4052)
,p_name=>'Workspaces Removed from the Purge List today'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(505838422421522498.4052)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(505838513808522499.4052)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'ID d''espace de travail'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(505849527948673205.4052)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(615472630424124073.4052)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Les espaces de travail qui deviennent actifs au cours de la p\00E9riode indiqu\00E9e dans Jours restants avant la purge sont automatiquement enlev\00E9s de la liste des espaces de travail inactifs et ne sont plus concern\00E9s par la purge.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(505850123231681263.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(505849527948673205.4052)
,p_button_name=>'P92_SET'
,p_button_static_id=>'P92_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('D\00E9finir')
,p_request_source=>'Set'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(505850309163686715.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(505849527948673205.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:92:&SESSION.::&DEBUG.:92,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(505849812149678096.4052)
,p_name=>'P92_DAYS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(505849527948673205.4052)
,p_item_default=>'1'
,p_prompt=>'Depuis'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PURGE.DAYS_LIST'
,p_lov=>'.'||wwv_flow_api.id(615512721869254091.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Limitez l''\00E9tat \00E0 une tranche de temps sp\00E9cifique. Indiquez la quantit\00E9 de temps \00E0 inclure dans l''\00E9tat et cliquez sur <strong>D\00E9finir</strong>.<p />'),
unistr('Si vous s\00E9lectionnez 1 jour, seules les derni\00E8res 24 heures s''affichent.  ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00093
begin
wwv_flow_api.create_page(
 p_id=>93.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Espaces de travail actifs par jour'
,p_step_title=>'Espaces de travail actifs par jour'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(692989966723464125.4052)
,p_plug_name=>unistr('Ev\00E9nements de page par jour')
,p_region_name=>'pageeventsbyday'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_jet_chart(
 p_id=>wwv_flow_api.id(692990050991464126.4052)
,p_region_id=>wwv_flow_api.id(692989966723464125.4052)
,p_chart_type=>'bar'
,p_height=>'500'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_spark_chart=>'N'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'delayed'
,p_initial_zooming=>'none'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'on'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( options ){',
'    options.initialZooming = ''last'';',
'    return options;',
'}'))
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(692990176523464127.4052)
,p_chart_id=>wwv_flow_api.id(692990050991464126.4052)
,p_seq=>10
,p_name=>unistr('Ev\00E9nements de page')
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(LOG_DAY,''dd/mm/yyyy'') LOG_DAY_FORMAT,',
'       count(distinct workspace_id) PAGE_EVENTS,',
'       to_char(LOG_DAY,''dd/mm/yyyy'')||'' - ''||count(distinct workspace_id) TOOLTIP',
'from WWV_FLOW_LOG_HISTORY ',
'group by LOG_DAY',
'order by log_day asc'))
,p_items_value_column_name=>'PAGE_EVENTS'
,p_items_label_column_name=>'LOG_DAY_FORMAT'
,p_items_short_desc_column_name=>'TOOLTIP'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'outsideBarEdge'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(692990212509464128.4052)
,p_chart_id=>wwv_flow_api.id(692990050991464126.4052)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(692990324626464129.4052)
,p_chart_id=>wwv_flow_api.id(692990050991464126.4052)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
end;
/
prompt --application/pages/page_00094
begin
wwv_flow_api.create_page(
 p_id=>94.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Vues de page par utilisateur et par jour'
,p_step_title=>'Vues de page par utilisateur et par jour'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1843561779293435779.4052)
,p_plug_name=>'Vues de page par utilisateur'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with messages as (',
'select /* APEX 4050P94a */ wwv_flow_lang.system_message(''AUTH.LOGIN_PAGE'') login_page,',
'wwv_flow_lang.system_message(''UNAUTHENTICATED_USER'') unauth_user,',
'(select count(*) tv',
'from wwv_flow_activity_log l',
'where l.time_stamp>=(select sysdate - to_number(',
':F4050_P94_DAYS) x from dual )  ) tv',
'from dual)',
'select ',
'decode(lower(l.userid),null,',
'  messages.login_page,''nobody'',',
'  messages.unauth_user,lower(l.userid))',
'   user_name,',
'lower(c.short_name) workspace,',
' sum(nvl(content_length,0)) content_length,',
' count(*) page_views, ',
' 100*count(*)/tv pct, ',
' sum(num_rows) report_rows, count(distinct(ip_address)) ip_addresses, sum(elap) total_elapsed, avg(elap) average_elapsed, count(distinct to_char(time_stamp,''YYYYMMDDHH24'')) distinct_hours, count(distinct to_char(time_stamp,''YYYYMMDD'')) distinct_days',
'from wwv_flow_activity_log l, ',
'     wwv_flow_companies c, messages',
'where l.security_group_id = c.provisioning_company_id (+)',
'and page_mode != ''A''',
'and l.time_stamp>=(select sysdate - to_number(',
':F4050_P94_DAYS) x from dual )  ',
'group by decode(lower(l.userid),null,',
'  login_page,''nobody'',',
'  unauth_user,lower(l.userid)),',
'  lower(c.short_name),',
'  tv'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'F4050_P94_DAYS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1843561896663435779.4052)
,p_name=>'Page Views by User'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1843561896663435779
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1813863265807998223.4052)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1813862802541998218.4052)
,p_db_column_name=>'USER_NAME'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Nom utilisateur'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1813863605962998223.4052)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Vues de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1813864037040998224.4052)
,p_db_column_name=>'PCT'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Pourcentage'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1813864435773998224.4052)
,p_db_column_name=>'REPORT_ROWS'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>unistr('Lignes d''\00E9tat')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1813864800637998224.4052)
,p_db_column_name=>'IP_ADDRESSES'
,p_display_order=>7
,p_column_identifier=>'F'
,p_column_label=>'Adresses IP'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1813865255820998225.4052)
,p_db_column_name=>'TOTAL_ELAPSED'
,p_display_order=>8
,p_column_identifier=>'G'
,p_column_label=>unistr('Temps total \00E9coul\00E9')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1813865674712998225.4052)
,p_db_column_name=>'AVERAGE_ELAPSED'
,p_display_order=>9
,p_column_identifier=>'H'
,p_column_label=>unistr('Temps moyen \00E9coul\00E9')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1813866074061998225.4052)
,p_db_column_name=>'DISTINCT_HOURS'
,p_display_order=>10
,p_column_identifier=>'I'
,p_column_label=>'Heures distinctes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1813866401301998226.4052)
,p_db_column_name=>'DISTINCT_DAYS'
,p_display_order=>11
,p_column_identifier=>'J'
,p_column_label=>'Jours distincts'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1813866865177998226.4052)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>12
,p_column_identifier=>'K'
,p_column_label=>'Contenu'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2004666803053510818.4052)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_header=>'<h1>'
,p_plug_footer=>'</h1>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1813867914075998239.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2004666803053510818.4052)
,p_button_name=>'P94_GO'
,p_button_static_id=>'P36_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('D\00E9finir')
,p_button_alignment=>'LEFT'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1813868379678998241.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2004666803053510818.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:94:&SESSION.::&DEBUG.:36,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1813868711832998242.4052)
,p_name=>'F4050_P94_DAYS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2004666803053510818.4052)
,p_item_default=>'to_number(.000694444)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Depuis'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''10 ''||wwv_flow_lang.system_message(initcap(''SECONDS'')) d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MINUTE'')) d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''MINUTES'')) d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''HOUR'')) d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 1/12  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(initcap(''HOURS'')) d, 12/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual order by 2'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Limitez l''\00E9tat \00E0 une tranche de temps sp\00E9cifique. Indiquez la quantit\00E9 de temps \00E0 inclure dans l''\00E9tat et cliquez sur <strong>OK</strong>.<p />'),
unistr('Si vous s\00E9lectionnez 1 jour, seules les derni\00E8res 24 heures s''affichent.  ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1813870099414998271.4052)
,p_computation_sequence=>10
,p_computation_item=>'F4050_P94_DAYS'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return to_number(:F4050_P94_DAYS);',
'exception',
'    when others then',
'        return to_number(.000694444);',
'end;        '))
);
end;
/
prompt --application/pages/page_00095
begin
wwv_flow_api.create_page(
 p_id=>95.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('URL autoris\00E9es')
,p_step_title=>unistr('URL autoris\00E9es')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931176884177111905)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_config_sec.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(799808515820155857.4052)
,p_plug_name=>unistr('URL autoris\00E9es')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  id,',
'  url,',
'  description,',
'  created_on created,',
'  created_by,',
'  last_updated_on updated,',
'  last_updated_by updated_by',
'from wwv_flow_authorized_urls'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(799808631492155857.4052)
,p_name=>'Authorized URLs'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_detail_link=>'f?p=&APP_ID.:96:&SESSION.::&DEBUG.:96:P96_ID:#ID#'
,p_detail_link_text=>'<span class="a-Icon icon-edit"></span>'
,p_detail_link_attr=>'class="a-Button a-Button--small a-Button--noLabel a-Button--withIcon a-Button--noUI"'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(799808828808155888.4052)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(799808912154155890.4052)
,p_db_column_name=>'URL'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'URL'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(799809012209155891.4052)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(799809122999155891.4052)
,p_db_column_name=>'CREATED'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Cr\00E9\00E9')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(799809210914155891.4052)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Cr\00E9ation par')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(799809302456155891.4052)
,p_db_column_name=>'UPDATED'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Mis \00E0 jour')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(799809408125155892.4052)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Mis \00E0 jour par')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(799822323172262989.4052)
,p_plug_name=>'Security Second Level Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517376500704206647.4052)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(799821322334262935.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(169533626431592276.4052)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(799823125582273390.4052)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(799808515820155857.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:95:&SESSION.::&DEBUG.:95,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(799822914500270176.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(799808515820155857.4052)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er une URL autoris\00E9e')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:96:&SESSION.::&DEBUG.:96::'
,p_icon_css_classes=>'icon-right-chevron'
);
end;
/
prompt --application/pages/page_00096
begin
wwv_flow_api.create_page(
 p_id=>96.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('URL autoris\00E9e')
,p_step_title=>unistr('URL autoris\00E9e')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931176884177111905)
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_config_sec.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(799810302142166499.4052)
,p_plug_name=>'URL'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(799815518609242981.4052)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Les URL autoris\00E9es identifient la liste d''URL pouvant servir de valeurs de param\00E8tre pour certaines proc\00E9dures &PRODUCT_NAME.. Ceci inclut la proc\00E9dure <code>APEX_UTIL.COUNT_CLICK</code>, qui comporte un param\00E8tre d''entr\00E9e nomm\00E9 <code>P_NEXT_URL</cod')
||unistr('e>. Si la valeur du param\00E8tre <code>P_NEXT_URL</code> n''est pas une URL relative et ne correspond pas au nom de l''h\00F4te en cours, il doit figurer dans la liste des URL autoris\00E9es.'),
unistr('<p><br />Les URL autoris\00E9es sont \00E9galement utilis\00E9es pour d\00E9finir des points d''extr\00E9mit\00E9 autoris\00E9s pour les demandes de services Web. Si au moins une URL autoris\00E9e est d\00E9finie, alors seuls les points d''extr\00E9mit\00E9 figurant dans la liste d''URL autoris\00E9e')
||'s sont accessibles.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(799824626106311381.4052)
,p_name=>unistr('URL autoris\00E9es actuellement d\00E9finies')
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>'select url from wwv_flow_authorized_urls order by 1'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('Aucune URL autoris\00E9e actuellement d\00E9finie.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(799824908148311388.4052)
,p_query_column_id=>1
,p_column_alias=>'URL'
,p_column_display_sequence=>1
,p_column_heading=>unistr('URL autoris\00E9e')
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(955891803989997329.4052)
,p_plug_name=>unistr('URL autoris\00E9e')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(799810819548166502.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(955891803989997329.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:95:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(799810722590166501.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(955891803989997329.4052)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Supprimer'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'P96_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(799810618017166501.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(955891803989997329.4052)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'NEXT'
,p_button_condition=>'P96_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(799810528858166501.4052)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(955891803989997329.4052)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er une URL autoris\00E9e')
,p_button_position=>'NEXT'
,p_button_condition=>'P96_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(799811505458166508.4052)
,p_branch_action=>'f?p=&APP_ID.:95:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(799811718294166515.4052)
,p_name=>'P96_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(799810302142166499.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(799811922979166616.4052)
,p_name=>'P96_URL'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(799810302142166499.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('URL autoris\00E9e')
,p_source=>'URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Identifiez une URL autoris\00E9e pouvant servir de valeur de param\00E8tre \00E0 certaines proc\00E9dures &PRODUCT_NAME., notamment <code>APEX_UTIL.COUNT_CLICK</code>.</p>'),
'',
unistr('<p>La valeur d''URL autoris\00E9e enti\00E8re sera compar\00E9e \00E0 celle du param\00E8tre d''URL dans ces proc\00E9dures. En cas de correspondance exacte avec la longueur compl\00E8te de la valeur de l''URL autoris\00E9e, la valeur du param\00E8tre d''URL sera autoris\00E9e.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(799812102826166621.4052)
,p_name=>'P96_DESCRIPTION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(799810302142166499.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Description'
,p_source=>'DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Description de l''URL.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(801767632534619488.4052)
,p_validation_name=>'P96_URL'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_duplicate_found boolean := FALSE;',
'begin',
'    for c1 in (select null',
'                 from wwv_flow_authorized_urls',
'                where url = trim(lower(:P96_URL))',
'                  and (:P96_ID is null or id <> :P96_ID)) loop',
'        l_duplicate_found := TRUE;',
'        exit;',
'    end loop;',
'    return not l_duplicate_found;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('L''URL &P96_URL. est d\00E9j\00E0 d\00E9finie en tant qu''URL autoris\00E9e.')
,p_associated_item=>wwv_flow_api.id(799811922979166616.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(799812316965166623.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_AUTHORIZED_URLS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_AUTHORIZED_URLS'
,p_attribute_03=>'P96_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Impossible d''extraire la ligne.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(799812507948166628.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_AUTHORIZED_URLS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_AUTHORIZED_URLS'
,p_attribute_03=>'P96_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>unistr('Erreur lors du traitement de l''URL autoris\00E9e.')
,p_process_success_message=>unistr('Action trait\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(799812701639166628.4052)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'96'
,p_process_when_button_id=>wwv_flow_api.id(799810722590166501.4052)
);
end;
/
prompt --application/pages/page_00098
begin
wwv_flow_api.create_page(
 p_id=>98.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Journal de purge d''espace de travail'
,p_step_title=>'Journal de purge d''espace de travail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931176884177111905)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(505840525468583836.4052)
,p_plug_name=>'Journal de purge d''espace de travail'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.workspace_name, l.purge_workspace_id, l.security_group_id, l.created_ts, l.log_code, l.log_action, l.log_statement, l.log_error',
'  from wwv_purge_log l;'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(505840630703583836.4052)
,p_name=>'Workspace Purge Log'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(505840811195583839.4052)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(505840916651583842.4052)
,p_db_column_name=>'PURGE_WORKSPACE_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Num\00E9ro d''identification de purge')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(505841002894583842.4052)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Num\00E9ro d''espace de travail')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(505841129052583842.4052)
,p_db_column_name=>'CREATED_TS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Cr\00E9\00E9')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(505841212471583842.4052)
,p_db_column_name=>'LOG_CODE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Code'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(615495005199220912)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(505841319355583843.4052)
,p_db_column_name=>'LOG_ACTION'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(505841431546583843.4052)
,p_db_column_name=>'LOG_STATEMENT'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Instruction'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(505841513103583843.4052)
,p_db_column_name=>'LOG_ERROR'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Erreur'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
end;
/
prompt --application/pages/page_00099
begin
wwv_flow_api.create_page(
 p_id=>99.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Tableau de bord de purge d''espace de travail'
,p_step_title=>'Tableau de bord de purge d''espace de travail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(''#psummary .rc-content-bin'').css(''height'',''270px'');',
'apex.jQuery(''#psettings .rc-content-bin'').css(''height'',''270px'');',
''))
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(505853305316732860.4052)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Les espaces de travail inactifs pendant une dur\00E9e sup\00E9rieure \00E0 celle indiqu\00E9e dans Jours d''inactivit\00E9 sont concern\00E9s par la purge. Si l''inactivit\00E9 d''un espace de travail se prolonge et qu''un administrateur d''espace de travail n''indique pas qu''il s')
||unistr('ouhaite le conserver, l''espace de travail sera purg\00E9.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(505863112813801279.4052)
,p_name=>unistr('Param\00E8tres')
,p_region_name=>'psettings'
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:h480'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(',
'wwv_flow_platform.get_preference( ''PURGE_ENABLED'' ),',
'''Y'',wwv_flow_lang.system_message(''YES''),wwv_flow_lang.system_message(''NO'')) purge_enabled,',
'wwv_flow_platform.get_preference( ''EMAIL_INSTANCE_URL'' ) instance_url,',
'wwv_flow_platform.get_preference( ''PURGE_DAYS_TO_PURGE'' ) days_to_purge,',
'wwv_flow_platform.get_preference( ''PURGE_REMINDER_DAYS_IN_ADVANCE'' ) reminder_days_in_advance,',
'wwv_flow_platform.get_preference( ''PURGE_DAYS_INACTIVE'' ) days_inactive,',
'wwv_flow_platform.get_preference( ''PURGE_GRACE_PERIOD_DAYS'' ) grace_period,',
'wwv_flow_platform.get_preference( ''PURGE_MAX_RUN_HOURS'' ) max_run_hours,',
'wwv_flow_platform.get_preference( ''PURGE_MAX_WORKSPACES'' ) max_workspaces_to_purge,',
'wwv_flow_platform.get_preference( ''PURGE_LANG'' ) purge_language',
'from dual'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46450823627307947.4052)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(505863409536801393.4052)
,p_query_column_id=>1
,p_column_alias=>'PURGE_ENABLED'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Purge automatique activ\00E9e')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(505863502565801395.4052)
,p_query_column_id=>2
,p_column_alias=>'INSTANCE_URL'
,p_column_display_sequence=>2
,p_column_heading=>'URL d''instance'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(505863611939801395.4052)
,p_query_column_id=>3
,p_column_alias=>'DAYS_TO_PURGE'
,p_column_display_sequence=>3
,p_column_heading=>'Jours restants avant la purge'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(505863721454801395.4052)
,p_query_column_id=>4
,p_column_alias=>'REMINDER_DAYS_IN_ADVANCE'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Jours \00E0 l''avance du rappel')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(505863807390801395.4052)
,p_query_column_id=>5
,p_column_alias=>'DAYS_INACTIVE'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Jours d''inactivit\00E9')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(505863918648801395.4052)
,p_query_column_id=>6
,p_column_alias=>'GRACE_PERIOD'
,p_column_display_sequence=>6
,p_column_heading=>unistr('D\00E9lai de gr\00E2ce')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(505864025910801395.4052)
,p_query_column_id=>7
,p_column_alias=>'MAX_RUN_HOURS'
,p_column_display_sequence=>7
,p_column_heading=>unistr('Nombre maximal d''heures d''ex\00E9cution')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(505864126160801395.4052)
,p_query_column_id=>8
,p_column_alias=>'MAX_WORKSPACES_TO_PURGE'
,p_column_display_sequence=>8
,p_column_heading=>unistr('Nombre maximal d''espaces de travail \00E0 purger')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(505864212540801395.4052)
,p_query_column_id=>9
,p_column_alias=>'PURGE_LANGUAGE'
,p_column_display_sequence=>9
,p_column_heading=>'Langue de la purge'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(505873013656962336.4052)
,p_plug_name=>'Etats'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(505826028978247783.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(27525012681104508.4052)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(505876725523022507.4052)
,p_name=>unistr('Conserv\00E9s r\00E9cemment')
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:h480'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select workspace_name, created_ts from',
'(select l.workspace_name, max(l.created_ts) created_ts',
'  from wwv_purge_log l',
' where l.log_code  = ''RESPONSE_RETAIN''',
' group by l.workspace_name)',
'order by 2 desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(47555718632924155.4052)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Aucun espace de travail conserv\00E9 r\00E9cemment.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(505877023800022511.4052)
,p_query_column_id=>1
,p_column_alias=>'WORKSPACE_NAME'
,p_column_display_sequence=>2
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(505877307229022512.4052)
,p_query_column_id=>2
,p_column_alias=>'CREATED_TS'
,p_column_display_sequence=>1
,p_column_format=>'SINCE'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1080987645373523909.4052)
,p_name=>unistr('R\00E9capitulatif hebdomadaire')
,p_region_name=>'psummary'
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:h240'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--fixed:a-BadgeList--large'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    (   select count(distinct security_group_id )',
'        from wwv_purge_log',
'        where log_code = ''PURGE_COMPLETE''',
'            and created_ts > (systimestamp - numtodsinterval(7, ''day'')) ) purged,',
'    (   select count(distinct security_group_id )',
'        from wwv_purge_workspaces',
'        where status = ''RETAIN''',
'            and updated_ts > (systimestamp - numtodsinterval(7, ''day'')) ) retained,',
'    (   select count(distinct security_group_id )',
'        from wwv_purge_log',
'        where log_code = ''DELETE''',
'            and created_ts > (systimestamp - numtodsinterval(7, ''day'')) ) removed_due_to_activity,',
'    (   select count(distinct security_group_id )',
'        from wwv_purge_log',
'        where log_code = ''NEW''',
'            and created_ts > (systimestamp - numtodsinterval(7, ''day'')) ) added_to_purge_list',
'from dual'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805663950138677747.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1080987729929523910.4052)
,p_query_column_id=>1
,p_column_alias=>'PURGED'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Purg\00E9')
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1080987895339523911.4052)
,p_query_column_id=>2
,p_column_alias=>'RETAINED'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Conserv\00E9')
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1080987997883523912.4052)
,p_query_column_id=>3
,p_column_alias=>'REMOVED_DUE_TO_ACTIVITY'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Enlev\00E9 en raison d''une activit\00E9')
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1080988062718523913.4052)
,p_query_column_id=>4
,p_column_alias=>'ADDED_TO_PURGE_LIST'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Ajout\00E9 \00E0 la liste de purge')
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1080988148411523914.4052)
,p_name=>unistr('Espaces de travail \00E0 purger')
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:h240'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--fixed:a-BadgeList--large'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    (   select count(distinct security_group_id ) c',
'        from wwv_purge_workspaces',
'        where status in (''NEW'',''STAGE1'',''STAGE2'')',
'            and date_to_purge < (systimestamp + numtodsinterval(1, ''day'')) )  within_next_1_day,',
'    (   select count(distinct security_group_id ) c',
'        from wwv_purge_workspaces',
'        where status in (''NEW'',''STAGE1'',''STAGE2'')',
'            and date_to_purge < (systimestamp + numtodsinterval(3, ''day'')) ) within_next_3_days,',
'    (   select count(distinct security_group_id ) c',
'        from wwv_purge_workspaces',
'        where status in (''NEW'',''STAGE1'',''STAGE2'')',
'            and date_to_purge < (systimestamp + numtodsinterval(7, ''day'')) ) within_next_7_days',
'from dual'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805663950138677747.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1080988255613523915.4052)
,p_query_column_id=>1
,p_column_alias=>'WITHIN_NEXT_1_DAY'
,p_column_display_sequence=>1
,p_column_heading=>'Dans le jour qui vient'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:87:&SESSION.::&DEBUG.:RP,RIR:IRLTE_DAYS_UNTIL_PURGE:1:'
,p_column_linktext=>'#WITHIN_NEXT_1_DAY#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1080988396270523916.4052)
,p_query_column_id=>2
,p_column_alias=>'WITHIN_NEXT_3_DAYS'
,p_column_display_sequence=>2
,p_column_heading=>'Dans les 3 prochains jours'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:87:&SESSION.::&DEBUG.:RP,RIR:IRLTE_DAYS_UNTIL_PURGE:3:'
,p_column_linktext=>'#WITHIN_NEXT_3_DAYS#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1080988456169523917.4052)
,p_query_column_id=>3
,p_column_alias=>'WITHIN_NEXT_7_DAYS'
,p_column_display_sequence=>3
,p_column_heading=>'Dans les 7 prochains jours'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_link=>'f?p=&APP_ID.:87:&SESSION.::&DEBUG.:RP,RIR:IRLTE_DAYS_UNTIL_PURGE:7:'
,p_column_linktext=>'#WITHIN_NEXT_7_DAYS#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(505871108367904029.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(505863112813801279.4052)
,p_button_name=>'MANAGE_SETTINGS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('G\00E9rer les param\00E8tres')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:133:&SESSION.::&DEBUG.:133::'
,p_icon_css_classes=>'icon-edit'
);
end;
/
prompt --application/pages/page_00100
begin
wwv_flow_api.create_page(
 p_id=>100.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Traductions install\00E9es')
,p_step_title=>unistr('Traductions install\00E9es')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931176884177111905)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_translate.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(195763900538696201.4052)
,p_plug_name=>unistr('Traductions charg\00E9es')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l, decode(t,''Y'',m_yes,''N'',m_no,t) t',
'from ',
'(',
'select ''en'' l, nvl((select ''Y'' from wwv_flows where id = 4000),''N'') t from dual',
'union all',
'select ''es'' l, nvl((select ''Y'' from wwv_flows where id = 4001),''N'') t from dual',
'union all',
'select ''fr'' l, nvl((select ''Y'' from wwv_flows where id = 4002),''N'') t from dual',
'union all',
'select ''de'' l, nvl((select ''Y'' from wwv_flows where id = 4003),''N'') t from dual',
'union all',
'select ''it'' l, nvl((select ''Y'' from wwv_flows where id = 4004),''N'') t from dual',
'union all',
'select ''pt-br'' l, nvl((select ''Y'' from wwv_flows where id = 4005),''N'') t from dual',
'union all',
'select ''zh-cn'' l, nvl((select ''Y'' from wwv_flows where id = 4006),''N'') t from dual',
'union all',
'select ''zh-tw'' l, nvl((select ''Y'' from wwv_flows where id = 4007),''N'') t from dual',
'union all',
'select ''ko'' l, nvl((select ''Y'' from wwv_flows where id = 4008),''N'') t from dual',
'union all',
'select ''ja'' l, nvl((select ''Y'' from wwv_flows where id = 4009),''N'') t from dual',
') x,',
'(select wwv_flow_lang.system_message(''YES'') m_yes,',
'          wwv_flow_lang.system_message(''NO'') m_no',
' from dual) m'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(195764012510696201.4052)
,p_name=>'Translations Loaded'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(195764223383696204.4052)
,p_db_column_name=>'L'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Langue'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(195764305596696206.4052)
,p_db_column_name=>'T'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Traduction charg\00E9e')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(195766411849724341.4052)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cet \00E9tat indique les versions traduites de &PRODUCT_NAME. qui ont \00E9t\00E9 charg\00E9es dans cette instance.</p>'),
'<p><a target="_blank" href="&SYSTEM_HELP_URL./htmig/installing-translated-versions-of-apex.html">En savoir plus...</a></p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(195765915527715946.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(195763900538696201.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:100:&SESSION.::&DEBUG.:100,RIR::'
);
end;
/
prompt --application/pages/page_00101
begin
wwv_flow_api.create_page(
 p_id=>101.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Journal des activit\00E9s de service Web')
,p_step_title=>unistr('Journal des activit\00E9s de service Web')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216784309333645873)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*.break-url {',
'    word-break: break-all;',
'}*/'))
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_logs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(670457839215463341.4052)
,p_plug_name=>unistr('Journal des activit\00E9s de service Web')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Le journal des activit\00E9s de service Web contient l''URL, la m\00E9thode HTTP, la longueur de la demande, le code de statut HTTP, la longueur de la r\00E9ponse, les secondes \00E9coul\00E9es, l''utilisateur d''application et la date des appels de service Web sortants ef')
||unistr('fectu\00E9s \00E0 partir de cette instance &PRODUCT_NAME..')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(670458250602463344.4052)
,p_plug_name=>unistr('Journal des activit\00E9s')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>15
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(812399646803979420.4052)
,p_plug_name=>unistr('Journal des activit\00E9s de service Web')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select replace(l.url,''/'',''/<wbr>'') "url", ',
'       l.http_method,',
'       l.content_length,',
'       l.status_code,',
'       l.resp_content_length,',
'       l.elapsed_sec,',
'       l.flow_user application_user,',
'       c.short_name,',
'       l.request_date',
'from  wwv_flow_webservice_log l, wwv_flow_companies c',
'where c.provisioning_company_id = l.security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'%null%'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(812399756925979420.4052)
,p_name=>'Mail Log'
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>812399756925979420
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(582423922173226527.4052)
,p_db_column_name=>'url'
,p_display_order=>10
,p_column_identifier=>'Z'
,p_column_label=>'URL'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(582423009729226518.4052)
,p_db_column_name=>'HTTP_METHOD'
,p_display_order=>20
,p_column_identifier=>'R'
,p_column_label=>unistr('M\00E9thode HTTP')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(582423199685226519.4052)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>30
,p_column_identifier=>'S'
,p_column_label=>'Longueur de la demande'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(582423592823226523.4052)
,p_db_column_name=>'STATUS_CODE'
,p_display_order=>40
,p_column_identifier=>'W'
,p_column_label=>'Code de statut'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(582423785181226525.4052)
,p_db_column_name=>'RESP_CONTENT_LENGTH'
,p_display_order=>50
,p_column_identifier=>'Y'
,p_column_label=>unistr('Longueur de r\00E9ponse')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(582423680714226524.4052)
,p_db_column_name=>'ELAPSED_SEC'
,p_display_order=>60
,p_column_identifier=>'X'
,p_column_label=>unistr('Ecoul\00E9')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(582423284263226520.4052)
,p_db_column_name=>'APPLICATION_USER'
,p_display_order=>70
,p_column_identifier=>'T'
,p_column_label=>'Utilisateur d''application'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(582423323091226521.4052)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>80
,p_column_identifier=>'U'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(582423498136226522.4052)
,p_db_column_name=>'REQUEST_DATE'
,p_display_order=>90
,p_column_identifier=>'V'
,p_column_label=>'Date de demande'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(619962444515121928.4052)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(670458250602463344.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:RIR,121::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(619962846891121930.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(670458250602463344.4052)
,p_button_name=>'TRUNCATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Vider'
,p_button_position=>'CREATE'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(619971577290121956.4052)
,p_branch_action=>'f?p=&FLOW_ID.:101:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(619970665525121953.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Truncate log'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_webservice_log;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors du vidage du journal des courriels.'
,p_process_when_button_id=>wwv_flow_api.id(619962846891121930.4052)
,p_process_success_message=>unistr('Journal des courriels vid\00E9 avec succ\00E8s.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(619971052060121953.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_api.id(619962444515121928.4052)
);
end;
/
prompt --application/pages/page_00102
begin
wwv_flow_api.create_page(
 p_id=>102.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Graphique d''utilisation de composants natifs'
,p_step_title=>'Graphique d''utilisation de composants natifs'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1916526379032165170.4052)
,p_plug_name=>'Etat'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>10
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_footer=>'Ce graphique exclut les applications internes.'
);
wwv_flow_api.create_jet_chart(
 p_id=>wwv_flow_api.id(155223489191557546.4052)
,p_region_id=>wwv_flow_api.id(1916526379032165170.4052)
,p_chart_type=>'bar'
,p_height=>'500'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_spark_chart=>'N'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'value-desc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>false
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(155225145484557548.4052)
,p_chart_id=>wwv_flow_api.id(155223489191557546.4052)
,p_seq=>10
,p_name=>unistr('S\00E9rie 1')
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       decode(',
'           trim(substr(plug_source_type,8)),',
'           ''STATIC'', wwv_flow_lang.system_message(''STATIC_REGION''),',
'           ''LIST'', wwv_flow_lang.system_message(''LIST_REGION''),',
'           ''SQL_REPORT'', wwv_flow_lang.system_message(''CLASSIC_REPORT''),',
'           ''IR'', wwv_flow_lang.system_message(''INTERACTIVE_REPORT''),',
'           ''IG'', wwv_flow_lang.system_message(''INTERACTIVE_GRID''),',
'           ''DISPLAY_SELECTOR'', wwv_flow_lang.system_message(''REGION_DISPLAY_SELECTOR''),',
'           ''TABFORM'', wwv_flow_lang.system_message(''TABULAR_FORM''),',
'           ''JET_CHART'', wwv_flow_lang.system_message(''JET_CHART''),',
'           ''JSTREE'', wwv_flow_lang.system_message(''JSTREE''),',
'           ''BREADCRUMB'', wwv_flow_lang.system_message(''BREADCRUMB_REGION''),',
'           ''CSS_CALENDAR'', wwv_flow_lang.system_message(''CSS_CALENDAR''),',
'           ''CALENDAR'', wwv_flow_lang.system_message(''CLASSIC_CALENDAR''),',
'           ''TREE'', wwv_flow_lang.system_message(''CLASSIC_TREE''),',
'           ''HELP_TEXT'', wwv_flow_lang.system_message(''HELP_TEXT''),',
'           ''JQM_COLUMN_TOGGLE'', wwv_flow_lang.system_message(''JQM COLUMN TOGGLE''),',
'           ''JQM_REFLOW'', wwv_flow_lang.system_message(''JQM REFLOW''),',
'           ''SVG_CHART'', wwv_flow_lang.system_message(''SVG CHART''),',
'           ''SIMPLE_CHART'', wwv_flow_lang.system_message(''SIMPLE_CHART''),',
'           ''PLSQL'', wwv_flow_lang.system_message(''PLSQL_REGION''),',
'           ''DATA_UPLOAD_COLUMN_MAPPING'',wwv_flow_lang.system_message(''DATA_UPLOAD_COLUMN_MAPPING''),',
'           ''JQM_LIST_VIEW'',wwv_flow_lang.system_message(''JQM_LIST_VIEW''),',
'           replace(substr(plug_source_type,8),''_'','' ''))',
'           region_type, ',
'       count(*) region_type_count',
'from wwv_flow_page_plugs r',
'where plug_source_type not like ''PLUGIN%'' and security_group_id != 10',
'group by substr(plug_source_type,8)',
'order by 2 desc'))
,p_items_value_column_name=>'REGION_TYPE_COUNT'
,p_items_label_column_name=>'REGION_TYPE'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(155223966323557546.4052)
,p_chart_id=>wwv_flow_api.id(155223489191557546.4052)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(155224546840557547.4052)
,p_chart_id=>wwv_flow_api.id(155223489191557546.4052)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
end;
/
prompt --application/pages/page_00105
begin
wwv_flow_api.create_page(
 p_id=>105.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Ajouter un sch\00E9ma')
,p_step_title=>unistr('Ajouter un sch\00E9ma - Nouveau ou existant')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_schema_assign.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18707931422356386.4052)
,p_plug_name=>unistr('Sch\00E9ma nouveau ou existant')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18714129138440964.4052)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(18701007817245520.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19062129715751379.4052)
,p_plug_name=>unistr('Sch\00E9ma')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(202654431224384775.4052)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Indiquez si vous souhaitez ajouter un sch\00E9ma existant ou un nouveau sch\00E9ma au mapping d''espace de travail. Si vous choisissez d''ajouter un nouveau sch\00E9ma, l''utilisateur de base de donn\00E9es sera cr\00E9\00E9 automatiquement. Cliquez sur le bouton <strong>Su')
||'ivant</strong> pour continuer.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202781828945244607.4052)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752111942043695871.4052)
,p_plug_name=>unistr('Ajouter un sch\00E9ma')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18708408351359249.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(202781828945244607.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_cattributes=>'class="BUTTON10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18712526930430865.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(202781828945244607.4052)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(18712821032430866.4052)
,p_branch_action=>'107'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(18712526930430865.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(18708711604359253.4052)
,p_branch_action=>'21'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(18708408351359249.4052)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18709815193380164.4052)
,p_name=>'P105_NEW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(18707931422356386.4052)
,p_item_default=>'Existing'
,p_prompt=>unistr('Le sch\00E9ma est : ')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'NEW_OR_EXISTING'
,p_lov=>'.'||wwv_flow_api.id(87820927180096887.4052)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifiez si le sch\00E9ma \00E0 provisionner pour l''espace de travail existe ou non.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
end;
/
prompt --application/pages/page_00106
begin
wwv_flow_api.create_page(
 p_id=>106.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Ajouter un sch\00E9ma')
,p_step_title=>unistr('Ajouter un sch\00E9ma - Identifier un sch\00E9ma')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_schema_assign.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18717630140488489.4052)
,p_plug_name=>unistr('Identifier un sch\00E9ma')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<p>'');',
'',
'if :P105_NEW = ''New'' then',
'  sys.htp.p(wwv_flow_lang.system_message(''4050_106_ENTER_SCHEMA_NAME''));',
'else',
'  sys.htp.p(''''||wwv_flow_lang.system_message(''4050_106_EXISTING_SCHEMA''));',
'end if;',
'sys.htp.p(wwv_flow_lang.system_message(''4050_106_WHEN_DONE''));',
'',
'sys.htp.p(''</p>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18722616297560221.4052)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(18701007817245520.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32849825297612790.4052)
,p_plug_name=>'reset'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>':P106_PASSWORD := null;'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202785409945267526.4052)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752112028982695871.4052)
,p_plug_name=>unistr('Ajouter un sch\00E9ma')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18719928539497524.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(202785409945267526.4052)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18719018150494496.4052)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(202785409945267526.4052)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18718107415491444.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(202785409945267526.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_button_cattributes=>'class="BUTTON10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(18718421414491445.4052)
,p_branch_action=>'21'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(18718107415491444.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(18720208258497525.4052)
,p_branch_action=>'108'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(18719928539497524.4052)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(18719314728494497.4052)
,p_branch_action=>'107'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(18719018150494496.4052)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18721014303540748.4052)
,p_name=>'P106_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(18717630140488489.4052)
,p_prompt=>unistr('Sch\00E9ma')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select username d,',
'       username r',
'  from wwv_flow_admin_all_schemas s',
' where (   restricted_to_workspace is null',
'        or restricted_to_workspace = upper(:P107_COMPANY))',
'   and username not in ( select cs.schema',
'                           from wwv_flow_company_schemas cs,',
'                                wwv_flow_companies c',
'                          where cs.security_group_id = c.provisioning_company_id',
'                            and cs.schema = s.username',
'                            and c.short_name = upper(:P107_COMPANY) )',
' order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_tag_css_classes=>'u-textUpper'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Saisissez le nom du nouveau sch\00E9ma.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18721601275546427.4052)
,p_name=>'P106_PASSWORD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(18717630140488489.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Mot de passe'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_tag_attributes=>'autocomplete="new-password"'
,p_display_when=>'P105_NEW'
,p_display_when2=>'New'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez le mot de passe du sch\00E9ma.')
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18783728660131536.4052)
,p_name=>'P106_DEFAULT_TS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(18717630140488489.4052)
,p_prompt=>unistr('Tablespace par d\00E9faut')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'DB.TABLESPACES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tablespace_name tname_disp, tablespace_name tname_ret',
'  from sys.dba_tablespaces'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_display_when=>'P105_NEW'
,p_display_when2=>'New'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_read_only_when=>'wwv_flow_platform.get_preference(''INSTANCE_TABLESPACE'') is not null'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Saisissez le tablespace par d\00E9faut du sch\00E9ma provisionn\00E9, ou s\00E9lectionnez-le dans la liste instantan\00E9e.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18784705242134205.4052)
,p_name=>'P106_TEMPORARY_TS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(18717630140488489.4052)
,p_prompt=>'Tablespace temporaire'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'DB.TABLESPACES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tablespace_name tname_disp, tablespace_name tname_ret',
'  from sys.dba_tablespaces'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_display_when=>'P105_NEW'
,p_display_when2=>'New'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_read_only_when=>'wwv_flow_platform.get_preference(''INSTANCE_TABLESPACE'') is not null'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Saisissez le tablespace temporaire du sch\00E9ma provisionn\00E9, ou s\00E9lectionnez-le dans la liste instantan\00E9e.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(384615932078738711.4052)
,p_computation_sequence=>10
,p_computation_item=>'P106_SCHEMA'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:P106_SCHEMA)'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(384615659188738708.4052)
,p_computation_sequence=>10
,p_computation_item=>'P106_DEFAULT_TS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_platform.get_preference(''INSTANCE_TABLESPACE'');'
,p_compute_when=>'wwv_flow_platform.get_preference(''INSTANCE_TABLESPACE'') is not null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(384615792981738709.4052)
,p_computation_sequence=>20
,p_computation_item=>'P106_TEMPORARY_TS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select property_value ',
'  from database_properties ',
' where property_name = ''DEFAULT_TEMP_TABLESPACE'';'))
,p_compute_when=>'wwv_flow_platform.get_preference(''INSTANCE_TABLESPACE'') is not null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(18726721885590232.4052)
,p_validation_name=>'schema not null'
,p_validation_sequence=>10
,p_validation=>'P106_SCHEMA'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le sch\00E9ma doit \00EAtre indiqu\00E9.')
,p_when_button_pressed=>wwv_flow_api.id(18719928539497524.4052)
,p_associated_item=>wwv_flow_api.id(18721014303540748.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(18727325825600827.4052)
,p_validation_name=>'schema exists'
,p_validation_sequence=>20
,p_validation=>'wwv_flow_security.exists_db_user(p_username => upper(:P106_SCHEMA))'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Le sch\00E9ma doit exister.')
,p_validation_condition=>':P106_SCHEMA is not null and :P105_NEW = ''Existing'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(18719928539497524.4052)
,p_associated_item=>wwv_flow_api.id(18721014303540748.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(18727925263610141.4052)
,p_validation_name=>'schema does not exist'
,p_validation_sequence=>30
,p_validation=>'wwv_flow_security.get_db_user_or_role(p_username => upper(:P106_SCHEMA)) is null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Le sch\00E9ma ne doit pas exister.')
,p_validation_condition=>':P106_SCHEMA is not null and :P105_NEW = ''New'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(18719928539497524.4052)
,p_associated_item=>wwv_flow_api.id(18721014303540748.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(73770513847184141.4052)
,p_validation_name=>'mapping doesn''t already exist'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_company_schemas',
' where schema = upper(:P106_SCHEMA)',
'   and security_group_id = :P107_SGID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Le mapping de sch\00E9ma existe d\00E9j\00E0.')
,p_when_button_pressed=>wwv_flow_api.id(18719928539497524.4052)
,p_associated_item=>wwv_flow_api.id(18721014303540748.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(18729518599627072.4052)
,p_validation_name=>'password not null'
,p_validation_sequence=>50
,p_validation=>'P106_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Vous devez indiquer un mot de passe.'
,p_validation_condition=>':P105_NEW = ''New'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(18719928539497524.4052)
,p_associated_item=>wwv_flow_api.id(18721601275546427.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(18797002781180853.4052)
,p_validation_name=>'defaut ts not null'
,p_validation_sequence=>60
,p_validation=>'P106_DEFAULT_TS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le tablespace par d\00E9faut doit \00EAtre indiqu\00E9.')
,p_validation_condition=>':P105_NEW = ''New'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(18719928539497524.4052)
,p_associated_item=>wwv_flow_api.id(18783728660131536.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(18799024944187246.4052)
,p_validation_name=>'temporary ts not null'
,p_validation_sequence=>70
,p_validation=>'P106_TEMPORARY_TS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le tablespace temporaire doit \00EAtre indiqu\00E9.')
,p_validation_condition=>':P105_NEW = ''New'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(18719928539497524.4052)
,p_associated_item=>wwv_flow_api.id(18784705242134205.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(18807120620223811.4052)
,p_validation_name=>'default ts exists'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from sys.dba_tablespaces',
' where tablespace_name = upper(:P106_DEFAULT_TS)'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Le tablespace n''existe pas.'
,p_validation_condition=>':P105_NEW = ''New'' and :P106_DEFAULT_TS is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(18719928539497524.4052)
,p_associated_item=>wwv_flow_api.id(18783728660131536.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(18808118673232702.4052)
,p_validation_name=>'temporary tablespace exists'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from sys.dba_tablespaces',
' where tablespace_name = upper(:P106_TEMPORARY_TS)'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Le tablespace n''existe pas.'
,p_validation_condition=>':P105_NEW = ''New'' and :P106_TEMPORARY_TS is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(18719928539497524.4052)
,p_associated_item=>wwv_flow_api.id(18784705242134205.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(161245717628127122.4052)
,p_validation_name=>'cannot add internal schema'
,p_validation_sequence=>100
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_companies',
' where first_schema_provisioned = upper(:P106_SCHEMA)',
'   and provisioning_company_id = 10'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Le mapping n''est pas possible pour le sch\00E9ma interne.')
,p_validation_condition=>'P105_NEW'
,p_validation_condition2=>'Existing'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(18719928539497524.4052)
,p_associated_item=>wwv_flow_api.id(18721014303540748.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183395003986449179.4052)
,p_validation_name=>'schema not reserved/restricted'
,p_validation_sequence=>110
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_provision.schema_name_valid(',
'    p_schema            => upper(:P106_SCHEMA),',
'    p_workspace_name    => :P107_COMPANY);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Le sch\00E9ma demand\00E9 est r\00E9serv\00E9 ou restreint ; il ne peut pas \00EAtre affect\00E9 \00E0 un espace de travail.')
,p_when_button_pressed=>wwv_flow_api.id(18719928539497524.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00107
begin
wwv_flow_api.create_page(
 p_id=>107.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Ajouter un sch\00E9ma')
,p_step_title=>unistr('Ajouter un sch\00E9ma - Choisir un espace de travail')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_schema_assign.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18731208472643073.4052)
,p_plug_name=>unistr('S\00E9lectionner un espace de travail')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>20
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18748418103816181.4052)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(18701007817245520.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32852404781625769.4052)
,p_plug_name=>'reset'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>':P106_PASSWORD := null;'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202783403927256373.4052)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752112181943695872.4052)
,p_plug_name=>unistr('Ajouter un sch\00E9ma')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18735306011689736.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(202783403927256373.4052)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18734429428687003.4052)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(202783403927256373.4052)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18733414406673241.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(202783403927256373.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(18735619743689738.4052)
,p_branch_action=>'106'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(18734725566687004.4052)
,p_branch_action=>'105'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(18734429428687003.4052)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18731914968663934.4052)
,p_name=>'P107_COMPANY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(18731208472643073.4052)
,p_prompt=>'Espace de travail'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST.WORKSPACES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name d, short_name v',
'  from wwv_flow_companies',
' where (provisioning_company_id not in (0,10,11,12))',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Saisissez le nom de l''espace de travail ou choisissez-le dans la liste instantan\00E9e.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18732521201665702.4052)
,p_name=>'P107_SGID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(18731208472643073.4052)
,p_prompt=>'Sgid'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(18736308219699832.4052)
,p_validation_name=>'company not null'
,p_validation_sequence=>10
,p_validation=>'P107_COMPANY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('L''espace de travail doit \00EAtre indiqu\00E9.')
,p_associated_item=>wwv_flow_api.id(18731914968663934.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(18736902809707708.4052)
,p_validation_name=>'company exists'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_companies',
' where short_name = upper(:P107_COMPANY)'))
,p_validation_type=>'EXISTS'
,p_error_message=>'L''espace de travail doit exister.'
,p_validation_condition=>':P107_COMPANY is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(18731914968663934.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(18738207096718392.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'pop sgid'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select provisioning_company_id',
'             from wwv_flow_companies',
'            where short_name = upper(:P107_COMPANY)) loop',
'  :P107_SGID := c1.provisioning_company_id;',
'  exit;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00108
begin
wwv_flow_api.create_page(
 p_id=>108.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Ajouter un sch\00E9ma')
,p_step_title=>unistr('Ajouter un sch\00E9ma - Confirmer')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_schema_assign.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18742411345776408.4052)
,p_plug_name=>'Confirmation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin-right: 12px;"'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<div class="a-Report a-Report--confirmReport a-Report--stretch a-Report--staticRowColors"><div class="a-Report-wrap"><div class="a-Report-tableWrap">'');',
'sys.htp.p(''<table class="a-Report-report" ''||wwv_flow_utilities.get_layout_table_attributes||''>'');',
'sys.htp.p(''<tr>'');',
'sys.htp.p(''<td class="u-tR a-Report-cell a-Report-cell--header">''||wwv_flow_lang.system_message(''NEW_OR_EXISTING'')||''</td>'');',
'sys.htp.p(''<td class="a-Report-cell">''||wwv_flow_item.text_from_lov(wwv_flow_escape.html(:P105_NEW),''NEW_OR_EXISTING'')||''</td>'');',
'sys.htp.p(''</tr>'');',
'sys.htp.p(''<tr>'');',
'sys.htp.p(''<td class="u-tR a-Report-cell a-Report-cell--header">''||wwv_flow_lang.system_message(''DEMO_APPLICATION.SCHEMA'')||''</td>'');',
'sys.htp.p(''<td class="a-Report-cell">''||wwv_flow_escape.html(:P106_SCHEMA)||''</td>'');',
'sys.htp.p(''</tr>'');',
'---',
'if :P105_NEW = ''New'' then',
'  sys.htp.p(''<tr>'');',
'  sys.htp.p(''<td class="u-tR a-Report-cell a-Report-cell--header">''||wwv_flow_lang.system_message(''SCHEMA_PASSWORD'')||''</td>'');',
'  sys.htp.p(''<td class="a-Report-cell">''||rpad(''*'',length(:P106_PASSWORD),''*'')||''</td>'');',
'  sys.htp.p(''</tr>'');',
'  sys.htp.p(''<tr>'');',
'  sys.htp.p(''<td class="u-tR a-Report-cell a-Report-cell--header">''||wwv_flow_lang.system_message(''DEFAULT_TABLESPACE_INIT'')||''</td>'');',
'  sys.htp.p(''<td class="a-Report-cell">''||wwv_flow_escape.html(:P106_DEFAULT_TS)||''</td>'');',
'  sys.htp.p(''</tr>'');',
'  sys.htp.p(''<tr>'');',
'  sys.htp.p(''<td class="u-tR a-Report-cell a-Report-cell--header">''||wwv_flow_lang.system_message(''TEMPORARY_TABLESPACE'')||''</td>'');',
'  sys.htp.p(''<td class="a-Report-cell">''||wwv_flow_escape.html(:P106_TEMPORARY_TS)||''</td>'');',
'  sys.htp.p(''</tr>'');',
'end if;',
'---',
'sys.htp.p(''<tr>'');',
'sys.htp.p(''<td class="u-tR a-Report-cell a-Report-cell--header">''||wwv_flow_lang.system_message(''WORKSPACE_INIT_CAP'')||''</td>'');',
'sys.htp.p(''<td class="a-Report-cell">''||wwv_flow_escape.html(:P107_COMPANY)||''</td>'');',
'sys.htp.p(''</tr>'');',
'sys.htp.p(''</table>'');',
'sys.htp.p(''</div></div></div>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18746317972806666.4052)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(18701007817245520.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19697422692474698.4052)
,p_plug_name=>unistr('Ajouter un sch\00E9ma')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>V\00E9rifiez les informations figurant dans la table ci-dessous. Si elles sont correctes, cliquez sur le bouton <strong>Ajouter un sch\00E9ma</strong> pour ajouter ce sch\00E9ma \00E0 l''espace de travail &P107_COMPANY.. Sinon, cliquez sur le bouton <strong>Pr\00E9c\00E9d')
||'ent</strong>.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202788304666284965.4052)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752112260763695872.4052)
,p_plug_name=>unistr('Ajouter un sch\00E9ma')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18745102950792918.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(202788304666284965.4052)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Ajouter un sch\00E9ma')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18743915978787185.4052)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(202788304666284965.4052)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18742925198780454.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(202788304666284965.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(18744206082787186.4052)
,p_branch_action=>'106'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(18743915978787185.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(18743220747780455.4052)
,p_branch_action=>'21'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(18817308247277016.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create schema'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_p varchar2(256) := v(''P106_PASSWORD'');',
'begin',
'  wwv_flow.update_cache_with_write(''P106_PASSWORD'',null);',
'',
'wwv_flow_provision.create_user(',
'    p_username    => :P106_SCHEMA,',
'    p_password    => l_p);',
'',
'wwv_flow_provision.set_user_tablespace(',
'    p_username    => :P106_SCHEMA,',
'    p_default_ts  => :P106_DEFAULT_TS,',
'    p_temp_ts     => :P106_TEMPORARY_TS);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(18745102950792918.4052)
,p_process_when=>':P105_NEW = ''New'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(18818203529285103.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'grant privs'
,p_process_sql_clob=>'wwv_flow_provision.grant_initial_privs(:P106_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(18745102950792918.4052)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(18823010849315600.4052)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create mapping'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'insert into wwv_flow_company_schemas (security_group_id, schema)',
'values (:P107_SGID, upper(:P106_SCHEMA));',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Erreur lors de l''ajout d''un sch\00E9ma.')
,p_process_when_button_id=>wwv_flow_api.id(18745102950792918.4052)
,p_process_success_message=>unistr('Sch\00E9ma ajout\00E9 \00E0 &P107_COMPANY..')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(359762415297498901.4052)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'106'
,p_process_when=>'CANCEL,CREATE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
end;
/
prompt --application/pages/page_00110
begin
wwv_flow_api.create_page(
 p_id=>110.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Voir une demande de modification'
,p_step_title=>'Voir une demande de modification'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216766430018595041)
,p_step_template=>wwv_flow_api.id(704456563630760825.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_chg_rqst.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(20489617348146909.4052)
,p_name=>unistr('Tablespaces de sch\00E9ma')
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner schemas1, tablespace_name tablespaces2',
'  from sys.dba_segments',
' where owner in ( select schema',
'                    from wwv_flow_company_schemas',
'                   where security_group_id = :P110_SGID )',
'group by owner,',
'         tablespace_name'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(47555718632924155.4052)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>unistr('Aucun sch\00E9ma n''a \00E9t\00E9 trouv\00E9.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(167797424959859102.4052)
,p_query_column_id=>1
,p_column_alias=>'SCHEMAS1'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(167797513180859103.4052)
,p_query_column_id=>2
,p_column_alias=>'TABLESPACES2'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(20489920551146915.4052)
,p_name=>unistr('Application pour les mappings de sch\00E9ma')
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name name, owner',
'  from wwv_flows',
' where security_group_id = :P110_SGID',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(47555718632924155.4052)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Aucune application n''a \00E9t\00E9 trouv\00E9e dans l''espace de travail.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(20489920551146915.4052)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48612823196771186.4052)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48612923298771186.4052)
,p_query_column_id=>2
,p_column_alias=>'OWNER'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20490805037146920.4052)
,p_plug_name=>'Demande de modification'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cliquez sur le bouton correspondant \00E0 l''action voulue pour une demande de modification donn\00E9e.</p>'),
unistr('<p>Pour rejeter une demande et la supprimer, s\00E9lectionnez <strong>Supprimer cette demande en cas de refus ?</strong> puis cliquez sur <strong>Rejeter la demande</strong>.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(20491723109146926.4052)
,p_name=>unistr('Sch\00E9mas d''espace de travail et tablespaces par d\00E9faut')
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.schema schemas2, c.tablespace_name  ||'' - '' ||c.file_name default_tablespaces',
'  from wwv_flow_company_schemas a, sys.dba_users b , sys.dba_data_files c',
' where a.schema = b.username',
'   and b.default_tablespace  = c.tablespace_name',
'   and a.security_group_id = :P110_SGID',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(47555718632924155.4052)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(167816703666890783.4052)
,p_query_column_id=>1
,p_column_alias=>'SCHEMAS2'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(167811004326878369.4052)
,p_query_column_id=>2
,p_column_alias=>'DEFAULT_TABLESPACES'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(20492023928146928.4052)
,p_name=>'Nombre d''objets'
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.object_type,',
'       count(*) cnt',
'  from sys.dba_objects o, wwv_flow_company_schemas s',
' where o.owner = s.schema',
'   and s.security_group_id = :P110_SGID',
' group by o.object_type',
' order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(47555718632924155.4052)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Aucun objet de base de donn\00E9es n''a \00E9t\00E9 trouv\00E9.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(20492023928146928.4052)
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48555719955770792.4052)
,p_query_column_id=>1
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48555820934770792.4052)
,p_query_column_id=>2
,p_column_alias=>'CNT'
,p_column_display_sequence=>2
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(20514532353304920.4052)
,p_name=>'Demande de modification'
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="width:100%;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select service_name,',
'       service_attribute_1,',
'       requested_on,',
'       requested_by,',
'       request_status STATUS,',
'       case',
'       when request_work_log is null',
'       then null',
'       when regexp_like(request_work_log,''^\d+$'')',
'       then wwv_flow_lang.system_message (',
'                ''APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'',',
'                request_work_log )',
'       else request_work_log',
'       end request_work_log,',
'       request_comments',
'  from wwv_flow_provision_serice_mod',
' where id = :P110_REQUEST_ID'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48768306417772111.4052)
,p_query_column_id=>1
,p_column_alias=>'SERVICE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nom de service'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(110368323210290856)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48768422851772111.4052)
,p_query_column_id=>2
,p_column_alias=>'SERVICE_ATTRIBUTE_1'
,p_column_display_sequence=>2
,p_column_heading=>'Valeur'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48768515025772112.4052)
,p_query_column_id=>3
,p_column_alias=>'REQUESTED_ON'
,p_column_display_sequence=>3
,p_column_heading=>'Demande le'
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT. Day'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48768631295772112.4052)
,p_query_column_id=>4
,p_column_alias=>'REQUESTED_BY'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Demand\00E9 par')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162850504660813639.4052)
,p_query_column_id=>5
,p_column_alias=>'STATUS'
,p_column_display_sequence=>7
,p_column_heading=>'Statut'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(87755726864223308)
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48768807098772112.4052)
,p_query_column_id=>6
,p_column_alias=>'REQUEST_WORK_LOG'
,p_column_display_sequence=>5
,p_column_heading=>'Journal de travail de demande'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48768922367772112.4052)
,p_query_column_id=>7
,p_column_alias=>'REQUEST_COMMENTS'
,p_column_display_sequence=>6
,p_column_heading=>'Request Comments'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46266312139679026.4052)
,p_plug_name=>unistr('S\00E9lecteur d''affichage de r\00E9gion')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(195775112470763477.4052)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168501300266669286.4052)
,p_plug_name=>'Voir une demande de modification'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_04'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(179770911638256315.4052)
,p_name=>unistr('Espaces de travail utilisant le sch\00E9ma demand\00E9')
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name from wwv_flow_companies where provisioning_company_id in (select security_group_id from wwv_flow_company_schemas where schema = (',
' select upper(service_attribute_1)',
'    from wwv_flow_provision_serice_mod',
'    where id = :P110_REQUEST_ID))'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_company_schemas where schema = (',
' select upper(service_attribute_1)',
'    from wwv_flow_provision_serice_mod',
'    where id = :P110_REQUEST_ID)'))
,p_display_condition_type=>'EXISTS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(47555718632924155.4052)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(179772831489470215.4052)
,p_query_column_id=>1
,p_column_alias=>'SHORT_NAME'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(179776307837681077.4052)
,p_plug_name=>'Avertissements'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'l_schema wwv_flow_provision_serice_mod.service_attribute_1%type;',
'l_schema_exists             boolean := false;',
'l_schema_in_use             boolean := false;',
'l_schema_restricted         boolean := false;',
'begin',
'',
'for c1 in (select upper(service_attribute_1) sa1',
'    from wwv_flow_provision_serice_mod',
'    where id = :P110_REQUEST_ID) loop',
'    l_schema := c1.sa1;',
'end loop;',
'',
'l_schema_exists := wwv_flow_security.get_db_user_or_role(p_username => l_schema) is not null;',
'',
'for c1 in (select 1 from wwv_flow_company_schemas ',
'  where schema = l_schema) loop',
'  l_schema_in_use := true;',
'end loop;',
'',
'for c1 in (select 1 from dual',
'  where wwv_flow_provisioning.reserved_schema_i(l_schema) = 1',
'  or wwv_flow_provisioning.restricted_schema_i(l_schema,',
'        wwv_flow_security.find_company_name(:P110_SGID)) = 1) loop',
'    l_schema_restricted := true;',
'end loop;',
'',
'sys.htp.p(''<br />''); sys.htp.p(''<br />'');',
'',
'if l_schema_exists then',
'  sys.htp.p(''<p />''||',
'  wwv_flow_lang.system_message(''F4050.SCHEMA_EXISTS''));',
'end if;',
'',
'if l_schema_in_use then',
'  sys.htp.p(''<p />''||',
'  wwv_flow_lang.system_message(''F4050.SCHEMA_ASSIGNED''));',
'end if;',
'',
'if l_schema_restricted then',
'  sys.htp.p(''<p />''||',
'  wwv_flow_lang.system_message(''F4050.RESTRICTED_ADMIN''));',
'end if;',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'l_schema wwv_flow_provision_serice_mod.service_attribute_1%type;',
'l_schema_exists             boolean := false;',
'l_schema_in_use             boolean := false;',
'l_schema_restricted         boolean := false;',
'begin',
'',
'for c1 in (select upper(service_attribute_1) sa1',
'    from wwv_flow_provision_serice_mod',
'    where id = :P110_REQUEST_ID) loop',
'    l_schema := c1.sa1;',
'end loop;',
'',
'l_schema_exists := wwv_flow_security.get_db_user_or_role(p_username => l_schema) is not null;',
'',
'for c1 in (select 1 from wwv_flow_company_schemas ',
'  where schema = l_schema) loop',
'  l_schema_in_use := true;',
'end loop;',
'',
'for c1 in (select 1 from dual',
'  where wwv_flow_provisioning.reserved_schema_i(l_schema) = 1',
'  or wwv_flow_provisioning.restricted_schema_i(l_schema,',
'        wwv_flow_security.find_company_name(:P110_SGID)) = 1) loop',
'  l_schema_restricted := true;',
'end loop;',
'',
'if l_schema_exists or l_schema_in_use or l_schema_restricted then',
'  return true;',
'else',
'  return false;',
'end if;',
'',
'end;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<table alt=""><tr><td valign="top"><img src="	#IMAGE_PREFIX#menu/alarm_bell_wbg_64x64.png" height="64" width="64" alt="" /></td><td valign="top">'
,p_plug_footer=>'</td></tr></table>'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(361089923326552991.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20489617348146909.4052)
,p_button_name=>'UTIL_RPT'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('Afficher les d\00E9tails')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:88:&SESSION.::&DEBUG.:RP:P88_SGID:&P110_SGID.:'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(202272511206460867.4052)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(168501300266669286.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(20596428918530967.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(168501300266669286.4052)
,p_button_name=>'DENY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Rejeter une demande'
,p_button_position=>'NEXT'
,p_button_cattributes=>'class="BUTTON10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(20601325024548816.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(168501300266669286.4052)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er un sch\00E9ma')
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PROVISION_SERICE_MOD m',
' where id = :P110_REQUEST_ID',
'   and service_name = ''NEW_SCHEMA''                  ',
'   and not exists ( select null',
'                      from sys.all_users u',
'                     where u.username = upper(m.SERVICE_ATTRIBUTE_1))',
' and not exists',
'  (select 1 from dual where (wwv_flow_provisioning.reserved_schema_i(upper(m.SERVICE_ATTRIBUTE_1)) = 1)',
'    or',
'    (wwv_flow_provisioning.site_admin_is_restricted_i = 1',
'     and',
'     wwv_flow_provisioning.restricted_schema_i(',
'    upper(m.SERVICE_ATTRIBUTE_1),',
'    wwv_flow_security.find_company_name(:P110_SGID)) = 1)',
'   );'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(20603005069552511.4052)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(168501300266669286.4052)
,p_button_name=>'CREATE2'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Ajouter de l''espace'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_provision_serice_mod',
' where service_name = ''CHANGE_DB_SIZE''',
'   and id = :P110_REQUEST_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(179763609196754195.4052)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(168501300266669286.4052)
,p_button_name=>'CREATE1'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Affecter un sch\00E9ma')
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare l_schema varchar2(30) := null;',
'l_sgid number := 0;',
'begin',
'    for c1 in (select upper(service_attribute_1) sa1,',
'                      security_group_id sgid',
'                 from wwv_flow_provision_serice_mod m',
'                where id = :P110_REQUEST_ID',
'                  and service_name = ''NEW_SCHEMA''                  ',
'                  and exists ( select 1',
'                                 from sys.all_users',
'                                where username = upper(m.SERVICE_ATTRIBUTE_1)))',
'    loop',
'      l_schema := c1.sa1;',
'      l_sgid := c1.sgid;',
'    end loop;',
'    if l_schema is not null then',
'        for c1 in (select 1 from wwv_flow_company_schemas',
'          where schema = l_schema and security_group_id =',
'          l_sgid) loop',
'          return false;',
'        end loop;    ',
'        for c1 in (',
'          select 1 from dual',
'          where',
'    (wwv_flow_provisioning.reserved_schema_i(l_schema) = 1) ',
' or (wwv_flow_provisioning.restricted_schema_i(l_schema,',
'       wwv_flow_security.find_company_name(:P110_SGID)) = 1',
'     and wwv_flow_provisioning.site_admin_is_restricted_i = 1)) loop',
'            return false;',
'        end loop;',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(20624429367663600.4052)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(168501300266669286.4052)
,p_button_name=>'TERMINATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Interrompre un service'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_provision_serice_mod',
' where service_name = ''REMOVE_EXISTING_SERVICE''',
'   and id = :P110_REQUEST_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(168821700937335203.4052)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20521406212335229.4052)
,p_name=>'P110_REQUEST_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20514532353304920.4052)
,p_prompt=>'Request Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20523821449339566.4052)
,p_name=>'P110_SGID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(20514532353304920.4052)
,p_prompt=>'Sgid'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20621819062641674.4052)
,p_name=>'P110_DELETE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(20514532353304920.4052)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CONFIRM.DELETE.DENIED.REQUEST'
,p_lov=>'.'||wwv_flow_api.id(87822015190102927.4052)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Il n''y a pas de texte d''aide.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(26721610368198076.4052)
,p_name=>'P110_COMMENTS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(20514532353304920.4052)
,p_prompt=>'Commentaires : '
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>5
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Saisissez un commentaire sur cette demande de modification.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(109497808800721425.4052)
,p_name=>'P110_DROP'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(20514532353304920.4052)
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''4050_110_DROP_USERS'', ''<font class="fielddatabold">'' || wwv_flow_provisioning.get_schemas_by_sgid(:P110_SGID,'', '') || ',
'''</font>'') d, ''U'' r from dual',
'union all',
'select wwv_flow_lang.system_message(''4050_110_DROP_TABLESPACES'', ''<font class="fielddatabold">'' || wwv_flow_provisioning.get_tablespaces_by_sgid( :P110_SGID,'', '') || ''</font>'') d, ''T'' r from dual'))
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result            boolean := FALSE;',
'    l_security_group_id number;',
'begin',
'    -- Show if service request is to terminate',
'    for c1 in (select security_group_id',
'                 from wwv_flow_provision_serice_mod',
'                where service_name = ''REMOVE_EXISTING_SERVICE''',
'                  and id = :P110_REQUEST_ID) loop',
'        l_security_group_id := c1.security_group_id;',
'        l_result := TRUE;',
'        exit;',
'    end loop;',
'    -- Don''t show if a restricted schema',
'    if l_result = TRUE then',
'        for c1 in (select null',
'                     from wwv_flow_company_schemas s',
'                    where security_group_id = l_security_group_id',
'                      and exists (select null',
'                                    from wwv_flow_restricted_schemas r',
'                                   where r.schema = s.schema)) loop',
'            l_result := FALSE;',
'            exit;',
'        end loop;',
'    end if;',
'    -- Don''t show if a restricted tablespace',
'    if l_result = TRUE then',
'        for c1 in (select u.default_tablespace',
'                     from wwv_flow_company_schemas s,',
'                          sys.dba_users u',
'                    where s.schema          = u.username',
'                      and security_group_id = l_security_group_id)',
'        loop',
'            if c1.default_tablespace in (''SYSTEM'',''SYSAUX'',''TEMP'',''USERS'') then',
'                l_result := FALSE;',
'                exit;',
'            end if;',
'        end loop;',
'    end if;',
'    --',
'    return l_result;',
'end;',
''))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(20698013240819860.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Schema'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_msg varchar2(4000);',
'  l_email varchar2(4000);',
'  l_schema_exists boolean := false;',
'  l_body_html varchar2(32767);',
'  l_workspace_id number;',
'begin',
'  for c1 in (select m.service_attribute_1',
'               from WWV_FLOW_PROVISION_SERICE_MOD m',
'              where id           = :P110_REQUEST_ID',
'                and service_name = ''NEW_SCHEMA'')',
'  loop',
'     l_schema_exists := wwv_flow_security.get_db_user_or_role(p_username => upper(c1.service_attribute_1)) is not null;',
'  end loop;  ',
' ',
'  wwv_flow_provisioning.add_schema_by_request(',
'    p_request_id   => :P110_REQUEST_ID,',
'    p_use_existing => l_schema_exists);',
'                 ',
'    for c1 in (select a.service_attribute_1, a.service_attribute_2 email_address, c.short_name, a.security_group_id',
'                   from wwv_flow_provision_serice_mod a,',
'                        wwv_flow_companies c',
'                  where a.security_group_id = c.provisioning_company_id',
'                    and a.id                = :P110_REQUEST_ID',
'                    and a.request_status    = ''APPROVED'') loop',
'        l_msg := chr(10)||',
'          wwv_flow_lang.system_message(p_name=>''F4050.PROV_SCHEMA_REQ_APPROVED'',',
'            p0=>c1.service_attribute_1,p1=>c1.short_name)||',
'          chr(10)||chr(10);',
'        l_email := c1.email_address;',
'        l_workspace_id := c1.security_group_id;',
'    end loop;',
'    ',
'    if l_workspace_id is null then',
'        raise program_error;',
'    end if;',
'        ',
'    l_msg := l_msg || :P110_Comments || chr(10) || chr(10);',
'    l_msg := l_msg || wwv_flow_mail.get_instance_url(p_security_group_id => l_workspace_id) || chr(10);',
'    l_body_html := wwv_flow_mail.convert_txt_to_html(p_txt_message => l_msg,p_security_group_id => l_workspace_id);',
'',
'    if l_email is null then',
'        for c1 in ( select ',
'                    b.email_address from wwv_flow_provision_serice_mod a, wwv_flow_fnd_user b               ',
'                    where a.security_group_id = b.security_group_id',
'                    and a.requested_by = b.user_name',
'                    and a.id = :P110_REQUEST_ID) loop',
'            l_email := c1.email_address;',
'        end loop;',
'    end if;',
'    ',
'    if l_email is not null then',
'        wwv_flow_mail.send(',
'            p_to     => l_email,',
'            p_from   => nvl(wwv_flow_platform.get_preference(''SMTP_FROM''),l_email),',
'            p_subj   => wwv_flow_lang.system_message(''F4050.PROV_CHANGE_REQ_APPROVED''),',
'            p_body   => l_msg,',
'            p_body_html => l_body_html); ',
'        wwv_flow_mail.push_queue_background;',
'    end if;           ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Erreur lors de la cr\00E9ation ou de l''affectation d''un sch\00E9ma.')
,p_process_when=>'CREATE1,CREATE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>unistr('Sch\00E9ma cr\00E9\00E9 ou affect\00E9.')
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(20701804367826675.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Provision Space'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_msg varchar2(4000);',
'  l_email varchar2(4000) := null;',
'  l_body_html varchar2(32767) := null;',
'  l_workspace_id number;',
'begin',
'',
'   wwv_flow_provisioning.provision_storage_by_request(p_request_id=>:P110_REQUEST_ID );',
'',
'   for c1 in (select a.service_attribute_1, a.service_attribute_2 email_address, c.short_name, a.security_group_id',
'                from wwv_flow_provision_serice_mod a, wwv_flow_companies c',
'               where a.security_group_id = c.provisioning_company_id',
'                 and a.id = :P110_REQUEST_ID',
'                 and a.request_status = ''APPROVED'') loop',
'     l_msg := chr(10)||wwv_flow_lang.system_message(',
'        ''F4050.APPROVE_ADD_STORAGE_EMAIL'',',
'        p0=>c1.service_attribute_1,p1=>c1.short_name)||chr(10)||chr(10);',
'     l_email := c1.email_address;',
'     l_workspace_id := c1.security_group_id;',
'   end loop;',
'   ',
'   if l_workspace_id is null then',
'       commit;',
'       raise program_error;',
'   end if;',
'',
'   l_msg := l_msg || :P110_Comments || chr(10) || chr(10);',
'   l_msg := l_msg || wwv_flow_mail.get_instance_url(p_security_group_id => l_workspace_id) || chr(10);',
'   l_body_html := wwv_flow_mail.convert_txt_to_html(p_txt_message => l_msg, p_security_group_id => l_workspace_id);',
'',
'   if l_email is null then',
'       for c1 in ( select ',
'                    b.email_address from wwv_flow_provision_serice_mod a, wwv_flow_fnd_user b               ',
'                    where a.security_group_id = b.security_group_id',
'                    and a.requested_by = b.user_name',
'                    and a.id = :P110_REQUEST_ID) loop',
'            l_email := c1.email_address;',
'        end loop;',
'   end if;',
'    ',
'   if l_email is not null then',
'        wwv_flow_mail.send(',
'          p_to        => l_email,',
'          p_from      => nvl(wwv_flow_platform.get_preference(''SMTP_FROM''),l_email),',
'          p_subj      => wwv_flow_lang.system_message(''F4050.CHANGE_APPROVED_EMAIL''),',
'          p_body      => l_msg,',
'          p_body_html => l_body_html );',
'        wwv_flow_mail.push_queue_background;',
'   end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors de l''ajout d''espace.'
,p_process_when_button_id=>wwv_flow_api.id(20603005069552511.4052)
,p_process_success_message=>unistr('Espace ajout\00E9.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(20696321420812715.4052)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Reject Request'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_msg varchar2(4000);',
'  l_email varchar2(4000) := null;',
'  l_body_html varchar2(32767) := null;',
'  l_workspace_id number;',
'begin',
'',
'  wwv_flow_provisioning.reject_modification_request (',
'    p_request_id => :P110_REQUEST_ID);',
'',
'  for c1 in (select a.service_attribute_1, a.service_name, ',
'                    a.service_attribute_2 email_address, c.short_name, a.security_group_id',
'               from wwv_flow_provision_serice_mod a, wwv_flow_companies c',
'              where a.security_group_id = c.provisioning_company_id',
'                and a.id = :P110_REQUEST_ID) loop',
'    if c1.service_name = ''NEW_SCHEMA'' then',
'      l_msg := chr(10)||wwv_flow_lang.system_message(p_name=>''F4050.DENY_NEW_SCHEMA_EMAIL'',',
'        p0=>c1.service_attribute_1,p1=>c1.short_name)||chr(10)||chr(10);      ',
'    elsif c1.service_name = ''REMOVE_EXISTING_SERVICE'' then',
'      l_msg := chr(10)||wwv_flow_lang.system_message(p_name=>''F4050.DENY_REMOVE_SERVICE_EMAIL'',p0=>c1.short_name)||chr(10)||chr(10);',
'    else',
'      l_msg := wwv_flow_lang.system_message(p_name=>''F4050.DENY_ADD_STORAGE_EMAIL'',p0=>c1.service_attribute_1,p1=>c1.short_name)||chr(10)||chr(10);',
'    end if;',
'    l_email := c1.email_address;',
'    l_workspace_id := c1.security_group_id;',
'  end loop;',
'  ',
'  l_msg := l_msg || :P110_Comments || chr(10) || chr(10);',
'  l_msg := l_msg || wwv_flow_mail.get_instance_url(p_security_group_id => l_workspace_id) || chr(10);',
'  l_body_html := wwv_flow_mail.convert_txt_to_html(p_txt_message => l_msg,p_security_group_id => l_workspace_id);',
'',
'  if l_email is null then',
'      for c1 in ( select ',
'                  b.email_address from wwv_flow_provision_serice_mod a, wwv_flow_fnd_user b               ',
'                  where a.security_group_id = b.security_group_id',
'                  and a.requested_by = b.user_name',
'                  and a.id = :P110_REQUEST_ID) loop',
'          l_email := c1.email_address;',
'      end loop;',
'  end if;',
'        ',
'  if :P110_DELETE = ''YES'' then',
'    wwv_flow_provisioning.delete_modification_request(p_request_id=>:P110_REQUEST_ID);',
'  end if;',
'',
'  if l_email is not null then',
'      wwv_flow_mail.send(',
'        p_to     => l_email,',
'        p_from   => nvl(wwv_flow_platform.get_preference(''SMTP_FROM''),l_email),',
'        p_subj   => wwv_flow_lang.system_message(''F4050.CHANGE_DENIED_EMAIL''),',
'        p_body   => l_msg,',
'        p_body_html => l_body_html);',
'        wwv_flow_mail.push_queue_background;',
'  end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors du refus de la demande.'
,p_process_when_button_id=>wwv_flow_api.id(20596428918530967.4052)
,p_process_success_message=>unistr('Demande rejet\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(20705626924861635.4052)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Terminate Service'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_msg              varchar2(4000);',
'  l_email            varchar2(4000) := null;',
'  l_body_html        varchar2(32767) := null;',
'  l_drop_users       varchar2(2);',
'  l_drop_tablespaces varchar2(2);',
'  l_workspace_id     number;',
'begin',
'',
'  for c1 in (select a.service_attribute_2 email_address, c.short_name, a.security_group_id',
'               from wwv_flow_provision_serice_mod a, wwv_flow_companies c',
'                where a.security_group_id = c.provisioning_company_id',
'                and a.id = :P110_REQUEST_ID) loop',
'    l_msg := chr(10)||wwv_flow_lang.system_message(p_name=>''F4050.SERVICE_TERMINATED_EMAIL_BODY'',',
'      p0=>c1.short_name)||chr(10)||chr(10)||chr(10);',
'    l_email := c1.email_address;',
'    l_workspace_id := c1.security_group_id;',
'  end loop;',
'',
'  l_msg := l_msg || :P110_Comments || chr(10) || chr(10);',
'  l_msg := l_msg || wwv_flow_mail.get_instance_url(p_security_group_id => l_workspace_id) || chr(10);',
'  l_body_html := wwv_flow_mail.convert_txt_to_html(p_txt_message => l_msg,p_security_group_id => l_workspace_id);',
'',
'  if l_email is null then',
'      for c1 in ( select ',
'                  b.email_address from wwv_flow_provision_serice_mod a, wwv_flow_fnd_user b               ',
'                  where a.security_group_id = b.security_group_id',
'                  and a.requested_by = b.user_name',
'                  and a.id = :P110_REQUEST_ID) loop',
'          l_email := c1.email_address;',
'      end loop;',
'  end if;',
'',
'  if l_email is not null then',
'      wwv_flow_mail.send(',
'        p_to     => l_email,',
'        p_from   => nvl(wwv_flow_platform.get_preference(''SMTP_FROM''),l_email),',
'        p_subj   => wwv_flow_lang.system_message(''F4050.SERVICE_TERMINATED_EMAIL''),',
'        p_body   => l_msg,',
'        p_body_html => l_body_html );',
'  end if;',
'',
'  if instr(:P110_DROP,''U'') > 0 then',
'      l_drop_users := ''Y'';',
'  else',
'      l_drop_users := ''N'';',
'  end if;',
'',
'  if instr(:P110_DROP,''T'') > 0 then',
'      l_drop_tablespaces := ''Y'';',
'  else',
'      l_drop_tablespaces := ''N'';',
'  end if;',
'',
'  wwv_flow_provisioning.terminate_service_by_sgid(',
'      p_security_group_id => :P110_SGID,',
'      p_drop_users        => l_drop_users,',
'      p_drop_tablespaces  => l_drop_tablespaces );',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors de l''interruption du service.'
,p_process_when_button_id=>wwv_flow_api.id(20624429367663600.4052)
,p_process_success_message=>'Service interrompu.'
);
end;
/
prompt --application/pages/page_00111
begin
wwv_flow_api.create_page(
 p_id=>111.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Assistant Inscription \00E0 un service')
,p_step_title=>unistr('Assistant Inscription \00E0 un service')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931176884177111905)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(25757919570127293.4052)
,p_plug_name=>unistr('Questions de l''enqu\00EAte')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(25766127986758492.4052)
,p_plug_name=>'Free Text'
,p_parent_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(25765312963744663.4052)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(25776204287940829.4052)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(195775112470763477.4052)
,p_plug_display_sequence=>20
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(26171132179430105.4052)
,p_plug_name=>unistr('Questions de l''enqu\00EAte')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Vous pouvez \00E9galement inclure une enqu\00EAte lorsque les utilisateurs ex\00E9cutent l''assistant Inscription \00E0 un nouveau service. Pour ce faire, s\00E9lectionnez <strong>Oui</strong> pour l''option Activer l''enqu\00EAte et saisissez les questions de votre enqu\00EAte. L')
||unistr('e nombre de r\00E9ponses \00E0 chaque question est illimit\00E9. Entrez toutes les r\00E9ponses possibles \00E0 chaque question dans un champ, en les d\00E9limitant par une nouvelle ligne.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(27046311255907726.4052)
,p_plug_name=>'Options'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(27048505761934540.4052)
,p_plug_name=>'Options'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('En tant qu''administrateur d''instance, vous pouvez exiger que les utilisateurs remplissent une justification et qu''ils acceptent un accord avant que l''assistant Inscription \00E0 un nouveau service soumette une demande. Pour exiger une justification, s\00E9le')
||unistr('ctionnez <strong>Oui</strong> pour l''option Exiger une justification. Pour activer les accords, s\00E9lectionnez <strong>Oui</strong> pour l''option Activer l''accord et saisissez le texte de l''accord.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(25758324210127295.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(25765312963744663.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(25758126701127295.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(25765312963744663.4052)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'NEXT'
,p_button_condition=>'P111_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(25758512252127297.4052)
,p_branch_action=>'f?p=&APP_ID.:9:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25758722630127301.4052)
,p_name=>'P111_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25758928149127308.4052)
,p_name=>'P111_SURVEY_ENABLED_YN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Activer l''enqu\00EAte')
,p_source=>'SURVEY_ENABLED_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('D\00E9termine l''inclusion ou l''exclusion de l''enqu\00EAte. S\00E9lectionnez <strong>Oui</strong> pour afficher les questions de l''enqu\00EAte que vous d\00E9finissez dans l''assistant Inscription au nouveau service.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25759109354127309.4052)
,p_name=>'P111_PRE_SURVEY_TEXT'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(25766127986758492.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Texte d''introduction'
,p_source=>'PRE_SURVEY_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez le texte \00E0 afficher avant les questions de l''enqu\00EAte.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25759318323127310.4052)
,p_name=>'P111_POST_SURVEY_TEXT'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(25766127986758492.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Texte de conclusion'
,p_source=>'POST_SURVEY_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez le texte \00E0 afficher apr\00E8s les questions de l''enqu\00EAte.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25759525123127311.4052)
,p_name=>'P111_SURVEY_QUESTION_01'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'1'
,p_source=>'SURVEY_QUESTION_01'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25759726384127311.4052)
,p_name=>'P111_SURVEY_ANSWER_01'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'1'
,p_source=>'SURVEY_ANSWER_01'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25759919171127311.4052)
,p_name=>'P111_SURVEY_QUESTION_02'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'2'
,p_source=>'SURVEY_QUESTION_02'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25760106891127311.4052)
,p_name=>'P111_SURVEY_ANSWER_02'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'2'
,p_source=>'SURVEY_ANSWER_02'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25760327261127311.4052)
,p_name=>'P111_SURVEY_QUESTION_03'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'3'
,p_source=>'SURVEY_QUESTION_03'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25760505242127312.4052)
,p_name=>'P111_SURVEY_ANSWER_03'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'3'
,p_source=>'SURVEY_ANSWER_03'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25760728486127313.4052)
,p_name=>'P111_SURVEY_QUESTION_04'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'4'
,p_source=>'SURVEY_QUESTION_04'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25760930263127313.4052)
,p_name=>'P111_SURVEY_ANSWER_04'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'4'
,p_source=>'SURVEY_ANSWER_04'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25761101337127313.4052)
,p_name=>'P111_SURVEY_QUESTION_05'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'5'
,p_source=>'SURVEY_QUESTION_05'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25761327565127313.4052)
,p_name=>'P111_SURVEY_ANSWER_05'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'5'
,p_source=>'SURVEY_ANSWER_05'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25761519360127313.4052)
,p_name=>'P111_SURVEY_QUESTION_06'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'6'
,p_source=>'SURVEY_QUESTION_06'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25761732052127313.4052)
,p_name=>'P111_SURVEY_ANSWER_06'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'6'
,p_source=>'SURVEY_ANSWER_06'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25761923300127313.4052)
,p_name=>'P111_SURVEY_QUESTION_07'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'7'
,p_source=>'SURVEY_QUESTION_07'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25762118414127313.4052)
,p_name=>'P111_SURVEY_ANSWER_07'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'7'
,p_source=>'SURVEY_ANSWER_07'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25762319516127314.4052)
,p_name=>'P111_SURVEY_QUESTION_08'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'8'
,p_source=>'SURVEY_QUESTION_08'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25762518135127314.4052)
,p_name=>'P111_SURVEY_ANSWER_08'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'8'
,p_source=>'SURVEY_ANSWER_08'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25762704783127315.4052)
,p_name=>'P111_SURVEY_QUESTION_09'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'9'
,p_source=>'SURVEY_QUESTION_09'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25762931672127315.4052)
,p_name=>'P111_SURVEY_ANSWER_09'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'9'
,p_source=>'SURVEY_ANSWER_09'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25763104897127315.4052)
,p_name=>'P111_SURVEY_QUESTION_10'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'10'
,p_source=>'SURVEY_QUESTION_10'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25763305979127315.4052)
,p_name=>'P111_SURVEY_ANSWER_10'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'10'
,p_source=>'SURVEY_ANSWER_10'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(26172118289473345.4052)
,p_name=>'P111_QUESTION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_source=>'return wwv_flow_lang.system_message(''QUESTIONS'');'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(26172914957481925.4052)
,p_name=>'P111_ANSWERS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(25757919570127293.4052)
,p_source=>'return wwv_flow_lang.system_message(''ANSWERS'');'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27046932726913906.4052)
,p_name=>'P111_AGREEMENT_ENABLED_YN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(27046311255907726.4052)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Activer l''accord'
,p_source=>'AGREEMENT_ENABLED_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('D\00E9termine l''inclusion ou l''exclusion d''un accord. S\00E9lectionnez <strong>Oui</strong> pour afficher l''accord que vous d\00E9finissez dans l''assistant Inscription au nouveau service.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27048327794931424.4052)
,p_name=>'P111_AGREEMENT_TEXT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(27046311255907726.4052)
,p_prompt=>'Texte de l''accord'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CLOB_TEXTAREA'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>10
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Saisissez le texte de l''accord.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select agreement_text',
'from wwv_flow_prov_signup_q',
'where id = :P111_ID'))
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63400686627961702.4052)
,p_name=>'P111_SHOW_SCHEMA_YN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(27046311255907726.4052)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Activer la s\00E9lection de sch\00E9ma ')
,p_source=>'SHOW_SCHEMA_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('D\00E9termine si l''utilisateur sera invit\00E9 \00E0 fournir les informations de sch\00E9ma de base de donn\00E9es ou si le sch\00E9ma sera d\00E9fini par d\00E9faut.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(80388818537961401.4052)
,p_name=>'P111_REQUEST_SUCCESS_MSG'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(27046311255907726.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Message de demande trait\00E9e')
,p_source=>'REQUEST_SUCCESS_MSG'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>90
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Message \00E0 afficher destin\00E9 \00E0 l''utilisateur lorsque celui-ci atteint la page Demande d''espace de travail une fois celle-ci envoy\00E9e.<br>'),
'<em><strong>Remarque :</strong> ce message remplacera le message standard fourni.</em>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(516327521980435333.4052)
,p_name=>'P111_JUSTIFICATION_REQUIRED'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(27046311255907726.4052)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Exiger une justification'
,p_source=>'JUSTIFICATION_REQUIRED_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('D\00E9termine si une justification de cr\00E9ation de l''espace de travail doit \00EAtre demand\00E9e \00E0 l''utilisateur.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2039741916796109422.4052)
,p_name=>'P111_BLOCKED_EMAIL_DOMAINS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(27046311255907726.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Domaines de messagerie bloqu\00E9s')
,p_source=>'BLOCKED_EMAIL_DOMAINS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Indiquez la liste des domaines de messagerie, s\00E9par\00E9s par des virgules, qui ne sont pas autoris\00E9s \00E0 demander un espace de travail, par exemple : "example1.com,example2.com". Utilisez le pr\00E9fixe ! pour indiquer un domaine de messagerie qui est uniquem')
||unistr('ent autoris\00E9 \00E0 demander un espace de travail, par exemple : "!example1.com".')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2039742079336109423.4052)
,p_name=>'P111_BLOCKED_EMAIL_MESSAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(27046311255907726.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Courriel bloqu\00E9')
,p_source=>'BLOCKED_EMAIL_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>65
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Message \00E0 afficher destin\00E9 \00E0 l''utilisateur lorsqu''une adresse \00E9lectronique avec un domaine bloqu\00E9 est saisie.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(72758156451714601.4052)
,p_computation_sequence=>10
,p_computation_item=>'P111_BLOCKED_EMAIL_DOMAINS'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'replace(:P111_BLOCKED_EMAIL_DOMAINS, chr(32), '''')'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(504761321518822989.4052)
,p_validation_name=>'P111_SURVEY_ANSWER_01'
,p_validation_sequence=>10
,p_validation=>'P111_SURVEY_ANSWER_01'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Les r\00E9ponses \00E0 la question #LABEL# doivent comporter une valeur.')
,p_validation_condition=>'P111_SURVEY_QUESTION_01'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(25758126701127295.4052)
,p_associated_item=>wwv_flow_api.id(25759726384127311.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(504810824765833328.4052)
,p_validation_name=>'P111_SURVEY_ANSWER_02'
,p_validation_sequence=>20
,p_validation=>'P111_SURVEY_ANSWER_02'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Les r\00E9ponses \00E0 la question #LABEL# doivent comporter une valeur.')
,p_validation_condition=>'P111_SURVEY_QUESTION_02'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(25758126701127295.4052)
,p_associated_item=>wwv_flow_api.id(25760106891127311.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(504949812261877054.4052)
,p_validation_name=>'P111_SURVEY_ANSWER_03'
,p_validation_sequence=>30
,p_validation=>'P111_SURVEY_ANSWER_03'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Les r\00E9ponses \00E0 la question #LABEL# doivent comporter une valeur.')
,p_validation_condition=>'P111_SURVEY_QUESTION_03'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(25758126701127295.4052)
,p_associated_item=>wwv_flow_api.id(25760505242127312.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(505048426852909686.4052)
,p_validation_name=>'P111_SURVEY_ANSWER_04'
,p_validation_sequence=>40
,p_validation=>'P111_SURVEY_ANSWER_04'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Les r\00E9ponses \00E0 la question #LABEL# doivent comporter une valeur.')
,p_validation_condition=>'P111_SURVEY_QUESTION_04'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(25758126701127295.4052)
,p_associated_item=>wwv_flow_api.id(25760930263127313.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(505071005859913035.4052)
,p_validation_name=>'P111_SURVEY_ANSWER_05'
,p_validation_sequence=>50
,p_validation=>'P111_SURVEY_ANSWER_05'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Les r\00E9ponses \00E0 la question #LABEL# doivent comporter une valeur.')
,p_validation_condition=>'P111_SURVEY_QUESTION_05'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(25758126701127295.4052)
,p_associated_item=>wwv_flow_api.id(25761327565127313.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(505093622481917841.4052)
,p_validation_name=>'P111_SURVEY_ANSWER_06'
,p_validation_sequence=>60
,p_validation=>'P111_SURVEY_ANSWER_06'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Les r\00E9ponses \00E0 la question #LABEL# doivent comporter une valeur.')
,p_validation_condition=>'P111_SURVEY_QUESTION_06'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(25758126701127295.4052)
,p_associated_item=>wwv_flow_api.id(25761732052127313.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
begin
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(505148414994925171.4052)
,p_validation_name=>'P111_SURVEY_ANSWER_07'
,p_validation_sequence=>70
,p_validation=>'P111_SURVEY_ANSWER_07'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Les r\00E9ponses \00E0 la question #LABEL# doivent comporter une valeur.')
,p_validation_condition=>'P111_SURVEY_QUESTION_07'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(25758126701127295.4052)
,p_associated_item=>wwv_flow_api.id(25762118414127313.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(505190731616929904.4052)
,p_validation_name=>'P111_SURVEY_ANSWER_08'
,p_validation_sequence=>80
,p_validation=>'P111_SURVEY_ANSWER_08'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Les r\00E9ponses \00E0 la question #LABEL# doivent comporter une valeur.')
,p_validation_condition=>'P111_SURVEY_QUESTION_08'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(25758126701127295.4052)
,p_associated_item=>wwv_flow_api.id(25762518135127314.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(505236310277933237.4052)
,p_validation_name=>'P111_SURVEY_ANSWER_09'
,p_validation_sequence=>90
,p_validation=>'P111_SURVEY_ANSWER_09'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Les r\00E9ponses \00E0 la question #LABEL# doivent comporter une valeur.')
,p_validation_condition=>'P111_SURVEY_QUESTION_09'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(25758126701127295.4052)
,p_associated_item=>wwv_flow_api.id(25762931672127315.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(505267522397936778.4052)
,p_validation_name=>'P111_SURVEY_ANSWER_10'
,p_validation_sequence=>100
,p_validation=>'P111_SURVEY_ANSWER_10'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Les r\00E9ponses \00E0 la question #LABEL# doivent comporter une valeur.')
,p_validation_condition=>'P111_SURVEY_QUESTION_10'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(25758126701127295.4052)
,p_associated_item=>wwv_flow_api.id(25763305979127315.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(25763632173127315.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_PROV_SIGNUP_Q'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PROV_SIGNUP_Q'
,p_attribute_03=>'P111_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(25763820070127316.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_PROV_SIGNUP_Q'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PROV_SIGNUP_Q'
,p_attribute_03=>'P111_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Action trait\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(203269131787714919.4052)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update AGREEMENT_TEXT (clob value)'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_prov_signup_q',
'   set agreement_text = (select clob001',
'                           from wwv_flow_collections',
'                          where collection_name=''P111_AGREEMENT_TEXT'')',
' where id = :P111_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors de l''enregistrement du texte de l''accord : #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(25758126701127295.4052)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(25764025774127317.4052)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'111'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00113
begin
wwv_flow_api.create_page(
 p_id=>113.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Enqu\00EAte \00E0 l''inscription')
,p_step_title=>unistr('Enqu\00EAte \00E0 l''inscription')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931176884177111905)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(131604720559638411.4052)
,p_name=>unistr('R\00E9ponses \00E0 l''enqu\00EAte')
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1. ''||SURVEY_QUESTION_01 survey_question, SURVEY_ANSWER_01 survey_answer, count(*) answer_count, 1 seq',
'from WWV_FLOW_PROVISION_COMPANY',
'where SURVEY_ANSWER_01 is not null',
'group by ''1. ''||SURVEY_QUESTION_01, SURVEY_ANSWER_01',
'union all',
'select ''2. ''||SURVEY_QUESTION_02 survey_question, SURVEY_ANSWER_02 survey_answer, count(*) answer_count, 2 seq',
'from WWV_FLOW_PROVISION_COMPANY',
'where SURVEY_ANSWER_02 is not null',
'group by ''2. ''||SURVEY_QUESTION_02, SURVEY_ANSWER_02',
'union all',
'select ''3. ''||SURVEY_QUESTION_03 survey_question, SURVEY_ANSWER_03 survey_answer, count(*) answer_count, 3 seq',
'from WWV_FLOW_PROVISION_COMPANY',
'where SURVEY_ANSWER_03 is not null',
'group by ''3. ''||SURVEY_QUESTION_03, SURVEY_ANSWER_03',
'union all',
'select ''4. ''||SURVEY_QUESTION_04 survey_question, SURVEY_ANSWER_04 survey_answer, count(*) answer_count, 4 seq',
'from WWV_FLOW_PROVISION_COMPANY',
'where SURVEY_ANSWER_04 is not null',
'group by ''4. ''||SURVEY_QUESTION_04, SURVEY_ANSWER_04',
'union all',
'select ''5. ''||SURVEY_QUESTION_05 survey_question, SURVEY_ANSWER_05 survey_answer, count(*) answer_count, 5 seq',
'from WWV_FLOW_PROVISION_COMPANY',
'where SURVEY_ANSWER_05 is not null',
'group by ''5. ''||SURVEY_QUESTION_05, SURVEY_ANSWER_05',
'union all',
'select ''6. ''||SURVEY_QUESTION_06 survey_question, SURVEY_ANSWER_06 survey_answer, count(*) answer_count, 6 seq',
'from WWV_FLOW_PROVISION_COMPANY',
'where SURVEY_ANSWER_06 is not null',
'group by ''6. ''||SURVEY_QUESTION_06, SURVEY_ANSWER_06',
'union all',
'select ''7. ''||SURVEY_QUESTION_07 survey_question, SURVEY_ANSWER_07 survey_answer, count(*) answer_count, 7 seq',
'from WWV_FLOW_PROVISION_COMPANY',
'where SURVEY_ANSWER_07 is not null',
'group by ''7. ''||SURVEY_QUESTION_07, SURVEY_ANSWER_07',
'union all',
'select ''8. ''||SURVEY_QUESTION_08 survey_question, SURVEY_ANSWER_08 survey_answer, count(*) answer_count, 8 seq',
'from WWV_FLOW_PROVISION_COMPANY',
'where SURVEY_ANSWER_08 is not null',
'group by ''8. ''||SURVEY_QUESTION_08, SURVEY_ANSWER_08',
'union all',
'select ''9. ''||SURVEY_QUESTION_09 survey_question, SURVEY_ANSWER_09 survey_answer, count(*) answer_count, 9 seq',
'from WWV_FLOW_PROVISION_COMPANY',
'where SURVEY_ANSWER_09 is not null',
'group by ''9. ''||SURVEY_QUESTION_09, SURVEY_ANSWER_09',
'union all',
'select ''10. ''||SURVEY_QUESTION_10 survey_question, SURVEY_ANSWER_10 survey_answer, count(*) answer_count, 10 seq',
'from WWV_FLOW_PROVISION_COMPANY',
'where SURVEY_ANSWER_10 is not null',
'group by ''10. ''||SURVEY_QUESTION_10, SURVEY_ANSWER_10',
'order by 4, 3 desc, 2'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>unistr('Aucune r\00E9ponse \00E0 l''enqu\00EAte n''a \00E9t\00E9 trouv\00E9e.')
,p_query_row_count_max=>5000
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_prn_format=>'PDF'
,p_prn_output_show_link=>'Y'
,p_prn_output_link_text=>'Impression'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width_units=>'PERCENTAGE'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(131605030833638415.4052)
,p_query_column_id=>1
,p_column_alias=>'SURVEY_QUESTION'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Question de l''enqu\00EAte')
,p_include_in_export=>'Y'
,p_print_col_width=>'33'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(131605125021638415.4052)
,p_query_column_id=>2
,p_column_alias=>'SURVEY_ANSWER'
,p_column_display_sequence=>2
,p_column_heading=>unistr('R\00E9ponse \00E0 l''enqu\00EAte')
,p_include_in_export=>'Y'
,p_print_col_width=>'33'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(131605210163638415.4052)
,p_query_column_id=>3
,p_column_alias=>'ANSWER_COUNT'
,p_column_display_sequence=>3
,p_column_heading=>unistr('R\00E9ponses')
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'33'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(132129429179688152.4052)
,p_query_column_id=>4
,p_column_alias=>'SEQ'
,p_column_display_sequence=>4
,p_column_heading=>'Question Number'
,p_hidden_column=>'Y'
,p_include_in_export=>'N'
,p_print_col_width=>'0'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(131809401905661364.4052)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(131872714372664990.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(131809401905661364.4052)
,p_button_name=>'RESET_REPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser l''\00E9tat')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:113:&SESSION.::&DEBUG.:RP,113::'
);
end;
/
prompt --application/pages/page_00114
begin
wwv_flow_api.create_page(
 p_id=>114.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Nouvelles demandes de service'
,p_step_title=>'Nouvelles demandes de service'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216766430018595041)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(132942231190729355.4052)
,p_plug_name=>'Nouvelles demandes de service'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>11
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    ID,',
'    SECURITY_GROUP_ID,',
'    COMPANY_NAME,',
'    ADMIN_FIRST_NAME first_name,',
'    ADMIN_LAST_NAME last_name,',
'    ADMIN_TITLE,',
'    ADMIN_EMAIL email,',
'    ADMIN_PHONE phone,',
'    ADMIN_ID,',
'    lower(admin_userid) ADMIN_USERID,',
'    DATABASE_SIZE,',
'    SERVICE_START_DATE,',
'    SERVICE_TERMINATION_DATE,',
'    SCHEMA_NAME,',
'    PROJECT_DESCRIPTION,',
'    PROJECT_JUSTIFICATION,',
'    PROJECT_STATUS,',
'    WORK_LOG,',
'    REQUEST_DATE',
'from WWV_FLOW_PROVISION_COMPANY'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(132942304290729355.4052)
,p_name=>'New Service Requests'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de #MAX_ROW_COUNT# lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(132942519864729357.4052)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(132942632134729357.4052)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('ID de groupe de s\00E9curit\00E9')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(132942707252729357.4052)
,p_db_column_name=>'COMPANY_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(132942807981729357.4052)
,p_db_column_name=>'FIRST_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Pr\00E9nom')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(132942905076729357.4052)
,p_db_column_name=>'LAST_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Nom'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(132943011031729357.4052)
,p_db_column_name=>'ADMIN_TITLE'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Titre de l''administrateur'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(132943100401729358.4052)
,p_db_column_name=>'EMAIL'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Courriel'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(132943221788729358.4052)
,p_db_column_name=>'PHONE'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>unistr('T\00E9l\00E9phone')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(132943316044729358.4052)
,p_db_column_name=>'ADMIN_ID'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'ID d''administrateur'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(132943405944729358.4052)
,p_db_column_name=>'ADMIN_USERID'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'ID d''utilisateur de l''administrateur'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(132943509408729358.4052)
,p_db_column_name=>'DATABASE_SIZE'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>unistr('Taille de base de donn\00E9es')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(132943609456729358.4052)
,p_db_column_name=>'SERVICE_START_DATE'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>unistr('Date de d\00E9but')
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(132943724496729359.4052)
,p_db_column_name=>'SERVICE_TERMINATION_DATE'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Interrompu'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(132943817284729359.4052)
,p_db_column_name=>'SCHEMA_NAME'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>unistr('Sch\00E9ma')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(132943930652729359.4052)
,p_db_column_name=>'PROJECT_DESCRIPTION'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(132944016379729359.4052)
,p_db_column_name=>'PROJECT_JUSTIFICATION'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Justification'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(132944131871729359.4052)
,p_db_column_name=>'PROJECT_STATUS'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Statut'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(316820619150159698)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(132944231402729359.4052)
,p_db_column_name=>'WORK_LOG'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Journal'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(132944307335729360.4052)
,p_db_column_name=>'REQUEST_DATE'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Demand\00E9')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(163634703537874157.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(132942231190729355.4052)
,p_button_name=>'RESET_REPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser l''\00E9tat')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:114:&SESSION.::&DEBUG.:RIR::'
);
end;
/
prompt --application/pages/page_00115
begin
wwv_flow_api.create_page(
 p_id=>115.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Cr\00E9er plusieurs espaces de travail')
,p_step_title=>unistr('Cr\00E9er plusieurs espaces de travail')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931243707245169747)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203134704189329471.4052)
,p_plug_name=>unistr('Cr\00E9er plusieurs espaces de travail')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>20
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203135026158329473.4052)
,p_plug_name=>'Informations'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>10
,p_plug_source=>unistr('<p>Utilisez cet assistant pour cr\00E9er plusieurs espaces de travail.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203142214430364147.4052)
,p_plug_name=>'create multiple workspaces'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_api.id(203141106443364145.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203142925490369582.4052)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752112544307695872.4052)
,p_plug_name=>unistr('Cr\00E9er plusieurs espaces de travail')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203135318288329474.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(203142925490369582.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203135632207329474.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(203142925490369582.4052)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(203136017877329476.4052)
,p_branch_action=>'f?p=&APP_ID.:116:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(203135632207329474.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203152218241433622.4052)
,p_name=>'P115_EMAIL_ADDRESSES'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(203134704189329471.4052)
,p_prompt=>unistr('Adresses \00E9lectroniques (couper et coller tout texte contenant des adresses \00E9lectroniques)')
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>10
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203193808097243593.4052)
,p_name=>'P115_WORKSPACE_NAMES'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(203134704189329471.4052)
,p_item_default=>'DOMAIN'
,p_prompt=>'Provisionner des espaces de travail avec'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WORKSPACE NAME COMPUTATION'
,p_lov=>'.'||wwv_flow_api.id(203194513911255730.4052)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifiez la m\00E9thode \00E0 utiliser pour cr\00E9er plusieurs espaces de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203196329195279379.4052)
,p_name=>'P115_WORKSPACE_PREFIX'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(203134704189329471.4052)
,p_prompt=>unistr('Pr\00E9fixe d''espace de travail')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Saisissez le pr\00E9fixe \00E0 utiliser lors de la g\00E9n\00E9ration de noms d''espace de travail. Par exemple, si un pr\00E9fixe ''DB'' est sp\00E9cifi\00E9, les noms d''espace de travail g\00E9n\00E9r\00E9s seront de type DB_001, DB_002, DB_003.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203291518171314934.4052)
,p_name=>'P115_BATCH_IDENTIFIER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(203134704189329471.4052)
,p_item_default=>'return to_char(sysdate,''YYYYMMDDHH24MI'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Identificateur de batch'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203291925276326850.4052)
,p_name=>'P115_INSTALL_SAMPLE_TABLES'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(203134704189329471.4052)
,p_prompt=>unistr('Installer les tables EMP et DEPT \00E9chantillon')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Installez les tables EMP et DEPT \00E9chantillon dans chaque espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203293032571369004.4052)
,p_name=>'P115_QUOTA'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(203134704189329471.4052)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_default number;',
'begin',
'    for c1 in (select req_size',
'                 from wwv_flow_workspace_req_size',
'                where request_type = ''N''',
'                  and default_size = ''Y'') loop',
'        l_default := c1.req_size;',
'        exit;',
'    end loop;',
'    return l_default;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Quota d''espace (Mo)'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NEW WORKSPACE REQUEST STORAGE SIZES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select req_size d, req_size r',
'  from wwv_flow_workspace_req_size',
' where request_type = ''C''',
'order by to_number(req_size)',
''))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Si vous cr\00E9ez un nouveau sch\00E9ma, indiquez la taille maximum du tablespace \00E0 lui associer. Ce maximum peut \00EAtre modifi\00E9 par la suite.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203295328449401307.4052)
,p_name=>'P115_PASSWORD_GENERATION'
,p_is_required=>true
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(203134704189329471.4052)
,p_item_default=>'RANDOM'
,p_prompt=>'Password Generation'
,p_source=>'STATIC'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Les mots de passe des espaces de travail peuvent \00EAtre une valeur fixe ou \00EAtre g\00E9n\00E9r\00E9s par le syst\00E8me.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(204258530823279427.4052)
,p_name=>'P115_WORKSPACE_COUNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(203134704189329471.4052)
,p_item_default=>'10'
,p_prompt=>'Nombre d''espaces de travail'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>8
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Saisissez le nombre total d''espaces de travail \00E0 cr\00E9er.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'200'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(204311127557584792.4052)
,p_name=>'P115_RM_CONSUMER_GROUP'
,p_item_sequence=>145
,p_item_plug_id=>wwv_flow_api.id(203134704189329471.4052)
,p_prompt=>'Groupe de consommateurs Resource Manager'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RESOURCE CONSUMER GROUPS (NON  SYSTEM)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select consumer_group d, consumer_group r',
'  from sys.dba_rsrc_consumer_groups',
' where consumer_group not like ''ORA$%''',
'   and consumer_group <> ''SYS_GROUP''',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ne pas d\00E9finir -')
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez le groupe de consommateurs Database Resource Manager \00E0 utiliser pour tous les \00E9v\00E9nements de page associ\00E9s \00E0 cet espace de travail. Au d\00E9but de chaque demande, le moteur &PRODUCT_NAME. remplace le groupe de consommateurs de la session de base')
||unistr(' de donn\00E9es en cours par le groupe de consommateurs de l''espace de travail. Ce comportement s''applique \00E0 la fois aux applications en cours d''ex\00E9cution et aux applications utilis\00E9es dans l''environnement de d\00E9veloppement &PRODUCT_NAME..'),
'',
'<p />',
'',
unistr('Le privil\00E8ge permettant le remplacement du groupe de consommateurs doit \00EAtre accord\00E9 au sch\00E9ma PUBLIC ou &PRODUCT_NAME.. Ce privil\00E8ge est g\00E9n\00E9ralement accord\00E9 \00E0 l''aide de la proc\00E9dure DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(204337203125672113.4052)
,p_name=>'P115_SEND_EMAIL'
,p_item_sequence=>167
,p_item_plug_id=>wwv_flow_api.id(203134704189329471.4052)
,p_item_default=>'Y'
,p_prompt=>'Envoyer une invitation par courriel'
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(204801825868457264.4052)
,p_name=>'P115_AUTO_PURGE'
,p_item_sequence=>155
,p_item_plug_id=>wwv_flow_api.id(203134704189329471.4052)
,p_item_default=>'Y'
,p_prompt=>'Autoriser la purge automatique des espaces de travail'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('D\00E9termine si l''espace de travail peut \00EAtre concern\00E9 par la purge automatique des espaces de travail non utilis\00E9s.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(204802717031719730.4052)
,p_name=>'P115_COMMENTS'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(203134704189329471.4052)
,p_prompt=>'Description de l''espace de travail'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Saisissez une description ou un commentaire facultatif de l''espace de travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(204681222200605271.4052)
,p_validation_name=>'P115_EMAIL_ADDRESSES'
,p_validation_sequence=>10
,p_validation=>'P115_EMAIL_ADDRESSES'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Le champ #LABEL# doit contenir une valeur.'
,p_validation_condition=>'P115_WORKSPACE_NAMES'
,p_validation_condition2=>'DOMAIN'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(203152218241433622.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(204682131461616196.4052)
,p_validation_name=>'P115_WORKSPACE_PREFIX'
,p_validation_sequence=>20
,p_validation=>'P115_WORKSPACE_PREFIX'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Le champ #LABEL# doit contenir une valeur.'
,p_validation_condition=>'P115_WORKSPACE_NAMES'
,p_validation_condition2=>'PREFIX'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(203196329195279379.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(204682424991619233.4052)
,p_validation_name=>'P115_WORKSPACE_COUNT'
,p_validation_sequence=>30
,p_validation=>'P115_WORKSPACE_COUNT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Le champ #LABEL# doit contenir une valeur.'
,p_validation_condition=>'P115_WORKSPACE_NAMES'
,p_validation_condition2=>'DOMAIN'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(204258530823279427.4052)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(211624009309511306.4052)
,p_validation_name=>'P115_PASSWORD_CONFIRM'
,p_validation_sequence=>40
,p_validation=>'P115_PASSWORD_CONFIRM'
,p_validation2=>'&P115_PASSWORD.'
,p_validation_type=>'ITEM_IN_VALIDATION_EQ_STRING2'
,p_error_message=>unistr('Le mot de passe et la saisie de confirmation sont diff\00E9rents')
,p_validation_condition=>'P115_PASSWORD_GENERATION'
,p_validation_condition2=>'FIXED'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(203135632207329474.4052)
,p_associated_item=>wwv_flow_api.id(211623229809486651.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(204256632755263181.4052)
,p_name=>'show hide prefix'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P115_WORKSPACE_NAMES'
,p_condition_element=>'P115_WORKSPACE_NAMES'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'PREFIX'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(204256919762263182.4052)
,p_event_id=>wwv_flow_api.id(204256632755263181.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P115_WORKSPACE_PREFIX'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(204257110865263183.4052)
,p_event_id=>wwv_flow_api.id(204256632755263181.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P115_WORKSPACE_PREFIX'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(204257223536270067.4052)
,p_name=>'show hide email & workspace count'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P115_WORKSPACE_NAMES'
,p_condition_element=>'P115_WORKSPACE_NAMES'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DOMAIN'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(204257502482270067.4052)
,p_event_id=>wwv_flow_api.id(204257223536270067.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P115_EMAIL_ADDRESSES,P115_SEND_EMAIL'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(204257729890270067.4052)
,p_event_id=>wwv_flow_api.id(204257223536270067.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P115_EMAIL_ADDRESSES,P115_SEND_EMAIL'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(378139003180037220.4052)
,p_event_id=>wwv_flow_api.id(204257223536270067.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P115_WORKSPACE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(378139326244041710.4052)
,p_event_id=>wwv_flow_api.id(204257223536270067.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P115_WORKSPACE_COUNT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(204269515318324376.4052)
,p_name=>'show hide pw'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P115_PASSWORD_GENERATION'
,p_condition_element=>'P115_PASSWORD_GENERATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'RANDOM'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(204269828087324376.4052)
,p_event_id=>wwv_flow_api.id(204269515318324376.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P115_PASSWORD'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(211623522908489869.4052)
,p_event_id=>wwv_flow_api.id(204269515318324376.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P115_PASSWORD_CONFIRM'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(204270018247324376.4052)
,p_event_id=>wwv_flow_api.id(204269515318324376.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>22
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P115_PASSWORD'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(211623717085492498.4052)
,p_event_id=>wwv_flow_api.id(204269515318324376.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P115_PASSWORD_CONFIRM'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(203152328831436871.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_count     integer;',
'   l_workspace varchar2(255);',
'   l_username  varchar2(255);',
'   l_domain    varchar2(255);',
'   l_email     varchar2(255);',
'   l_schema    varchar2(255);',
'   c_collection_name constant varchar2(255) := ''BULK_USER_CREATE'';',
'   x           integer;',
'   function workspace_exists (p_workspace_name in varchar2) return boolean',
'   is',
'       l_found boolean := false;',
'   begin',
'       for c1 in (select 1 x from wwv_flow_companies where short_name = upper(p_workspace_name)) loop',
'          l_found := true;',
'       end loop;',
'       return l_found;',
'   end;',
'   function schema_exists (p_schema_name in varchar2) return boolean',
'   is',
'       l_found boolean := false;',
'   begin',
'       for c1 in (select 1 x from sys.dba_users where username = upper(p_schema_name)) loop',
'          l_found := true;',
'       end loop;',
'       return l_found;',
'   end;',
'   function workspace_in_collection (p_workspace_name in varchar2) return boolean',
'   is',
'       l_found boolean := false;',
'   begin',
'       for c1 in (select 1 x ',
'                  from   wwv_flow_collections ',
'                  where  collection_name = c_collection_name and ',
'                         upper(c003) = upper(p_workspace_name)  ) loop',
'          l_found := true;',
'       end loop;',
'       return l_found;',
'   end;',
'begin',
'    if :P115_WORKSPACE_NAMES = ''DOMAIN'' then',
'        wwv_flow_fnd_user_api.create_user_coll_from_csv (',
'            p_users => :P115_EMAIL_ADDRESSES,',
'            p_security_group_id => :flow_security_group_id,',
'            p_strip_domain => ''N'' );',
'        commit;',
'        for c1 in (',
'             select seq_id , c001, c002',
'             from wwv_flow_collections ',
'             where collection_name = c_collection_name order by 1) loop',
'             --',
'             l_email     := lower(c1.c002);',
'             --l_username  := upper(apex_util.compress_int(wwv_flow_id.next_val));',
'             l_username  := l_email;',
'             l_workspace := substr(c1.c001,instr(c1.c001,''@'')+1);',
'             l_workspace := substr(l_workspace,1,instr(l_workspace,''.'')-1);',
'             l_workspace := replace(trim(l_workspace),'' '',''_'');',
'             l_domain    := l_workspace;',
'             x := 0;',
'             for j in 1..999 loop',
'                 if not workspace_exists(p_workspace_name=>l_workspace) and',
'                    not workspace_in_collection(p_workspace_name=>l_workspace) and',
'                    not schema_exists(p_schema_name=>l_workspace',
'                    ) then',
'                    exit;',
'                 end if;',
'                 x := x + 1;',
'                 l_workspace := l_domain||''_''||lpad(x,3,''000'');',
'             end loop;',
'             --',
'             --l_username := l_workspace;',
'             l_schema := l_workspace;',
'             ',
'             wwv_flow_collection.update_member(',
'                p_collection_name => c_collection_name,',
'                p_seq => c1.seq_id,',
'                p_c001 => l_username,',
'                p_c002 => l_email,',
'                p_c003 => l_workspace,',
'                p_c006 => :P115_INSTALL_SAMPLE_TABLES,',
'                p_c007 => :P115_QUOTA,',
'                p_c009 => :P115_RM_CONSUMER_GROUP,',
'                p_c010 => :P115_SEND_EMAIL,',
'                p_c011 => :P115_AUTO_PURGE,',
'                p_c012 => :P115_COMMENTS,',
'                p_c013 => l_schema',
'                );',
'        end loop;',
'        commit;',
'    elsif :P115_WORKSPACE_NAMES = ''GENERATED'' then',
'         l_count := :P115_WORKSPACE_COUNT;',
'         wwv_flow_collection.create_or_truncate_collection(',
'            p_collection_name => c_collection_name);',
'         x := 0;',
'         for i in 1..l_count loop',
'             x := x + 1;',
'             l_email := '''';',
'             for j in 0..100 loop',
'                  x := x + j;',
'                  l_workspace := upper(apex_util.compress_int(wwv_flow_id.next_val));',
'                  l_username  := lower(l_workspace);',
'                  if not workspace_exists(p_workspace_name=>l_workspace) and',
'                     not schema_exists(p_schema_name=>l_workspace) ',
'                     then',
'                     exit;',
'                  end if;',
'             end loop;',
'             l_schema := l_workspace;',
'             --',
'             wwv_flow_collection.add_member (',
'                p_collection_name => c_collection_name,',
'                p_c001 => l_username,',
'                p_c002 => l_email,',
'                p_c003 => l_workspace,',
'                p_c006 => :P115_INSTALL_SAMPLE_TABLES,',
'                p_c007 => :P115_QUOTA,',
'                p_c009 => :P115_RM_CONSUMER_GROUP,',
'                p_c010 => :P115_SEND_EMAIL,',
'                p_c011 => :P115_AUTO_PURGE,',
'                p_c012 => :P115_COMMENTS,',
'                p_c013 => l_schema',
'                );',
'         end loop;',
'         commit;',
'    elsif :P115_WORKSPACE_NAMES = ''PREFIX'' then',
'         l_count := :P115_WORKSPACE_COUNT;',
'         wwv_flow_collection.create_or_truncate_collection(',
'            p_collection_name => c_collection_name);',
'         x := 0;',
'         for i in 1..l_count loop',
'             x := x + 1;',
'             for j in 0..100 loop',
'                  x := x + j;',
'                  l_workspace := upper(:P115_WORKSPACE_PREFIX)||''_''||lpad(x,3,''000'');',
'                  l_workspace := replace(trim(l_workspace),'' '',''_'');',
'                  if not workspace_exists(p_workspace_name=>l_workspace) and',
'                     not schema_exists(p_schema_name=>l_workspace) ',
'                     then',
'                     exit;',
'                  end if;',
'             end loop;',
'             l_email     := '''';',
'             l_username  := lower(l_workspace);',
'             l_schema := l_workspace;',
'             --',
'             wwv_flow_collection.add_member (',
'                p_collection_name => c_collection_name,',
'                p_c001 => l_username,',
'                p_c002 => l_email,',
'                p_c003 => l_workspace,',
'                p_c006 => :P115_INSTALL_SAMPLE_TABLES,',
'                p_c007 => :P115_QUOTA,',
'                p_c009 => :P115_RM_CONSUMER_GROUP,',
'                p_c010 => :P115_SEND_EMAIL,',
'                p_c011 => :P115_AUTO_PURGE,',
'                p_c012 => :P115_COMMENTS,',
'                p_c013 => l_schema',
'                );',
'         end loop;',
'         commit;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00116
begin
wwv_flow_api.create_page(
 p_id=>116.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Cr\00E9er plusieurs espaces de travail')
,p_step_title=>unistr('Cr\00E9er plusieurs espaces de travail')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931243707245169747)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203136525128329478.4052)
,p_plug_name=>unistr('Cr\00E9er plusieurs espaces de travail')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>20
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(203155004253505460.4052)
,p_name=>'Administrateurs de l''espace de travail'
,p_parent_plug_id=>wwv_flow_api.id(203136525128329478.4052)
,p_template=>wwv_flow_api.id(721130166613730309.4052)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null as edit_link,',
'       lower(c001) username, ',
'       lower(c002) email, ',
'       c003 workspace,',
'       c013 schema,',
'       c006 tab,',
'       c007 quota,',
'       c009 consumer_group,',
'       c010 invite,',
'       c011 auto_purge,',
'       decode(c012,null,null,trim(substr(c012,1,5))||''...'') comments,',
'       SEQ_ID',
'  from wwv_flow_collections',
' where collection_name = ''BULK_USER_CREATE''',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('Aucun espace de travail \00E0 cr\00E9er.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(10660903644899003.4052)
,p_query_column_id=>1
,p_column_alias=>'EDIT_LINK'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(203155327273505476.4052)
,p_query_column_id=>2
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nom utilisateur'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(203155422558505479.4052)
,p_query_column_id=>3
,p_column_alias=>'EMAIL'
,p_column_display_sequence=>4
,p_column_heading=>'Courriel'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(203180629534127281.4052)
,p_query_column_id=>4
,p_column_alias=>'WORKSPACE'
,p_column_display_sequence=>2
,p_column_heading=>'Espace de travail'
,p_column_link=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:RP,118:P118_SEQ_ID:#SEQ_ID#:'
,p_column_linktext=>'#WORKSPACE#'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(388223026397691509.4052)
,p_query_column_id=>5
,p_column_alias=>'SCHEMA'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Sch\00E9ma')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(204291616462482173.4052)
,p_query_column_id=>6
,p_column_alias=>'TAB'
,p_column_display_sequence=>9
,p_column_heading=>'Tables'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(157992123774592395)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(203297621112430175.4052)
,p_query_column_id=>7
,p_column_alias=>'QUOTA'
,p_column_display_sequence=>6
,p_column_heading=>'Quota (Mo)'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(204327009010593464.4052)
,p_query_column_id=>8
,p_column_alias=>'CONSUMER_GROUP'
,p_column_display_sequence=>12
,p_column_heading=>'Groupe de consommateurs'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(204739012340065688.4052)
,p_query_column_id=>9
,p_column_alias=>'INVITE'
,p_column_display_sequence=>11
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(204803331456743407.4052)
,p_query_column_id=>10
,p_column_alias=>'AUTO_PURGE'
,p_column_display_sequence=>10
,p_column_heading=>'Purge automatique'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(157992123774592395)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(204803406634743408.4052)
,p_query_column_id=>11
,p_column_alias=>'COMMENTS'
,p_column_display_sequence=>13
,p_column_heading=>'Commentaires'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(204702515773821001.4052)
,p_query_column_id=>12
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>14
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(203156112134526583.4052)
,p_name=>unistr('Adresses \00E9lectroniques non valides')
,p_parent_plug_id=>wwv_flow_api.id(203136525128329478.4052)
,p_template=>wwv_flow_api.id(721128767486730308.4052)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lower(c001) username, lower(c002) email, c003 error',
'  from apex_collections',
' where collection_name = ''BULK_USER_INVALID''',
'order by c001'))
,p_display_when_condition=>'P115_WORKSPACE_NAMES'
,p_display_when_cond2=>'DOMAIN'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('Aucune adresse \00E9lectronique non valide n''a \00E9t\00E9 trouv\00E9e.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(203156427373526584.4052)
,p_query_column_id=>1
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nom utilisateur'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(203156501517526584.4052)
,p_query_column_id=>2
,p_column_alias=>'EMAIL'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Adresse \00E9lectronique')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(203156605916526584.4052)
,p_query_column_id=>3
,p_column_alias=>'ERROR'
,p_column_display_sequence=>3
,p_column_heading=>'Erreur'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203136813721329479.4052)
,p_plug_name=>'Information'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>10
,p_plug_source=>unistr('<p>V\00E9rifiez la liste des espaces de travail qui seront cr\00E9\00E9s. Vous pouvez modifier une entr\00E9e pour ajuster les param\00E8tres d''espace de travail ou enlever une demande de provisionnement d''espace de travail.</p>')
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203142400911364147.4052)
,p_plug_name=>'create multiple workspaces'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_api.id(203141106443364145.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203144411900384588.4052)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752112632459695873.4052)
,p_plug_name=>unistr('Cr\00E9er plusieurs espaces de travail')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203137121232329479.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(203144411900384588.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203137425162329479.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(203144411900384588.4052)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203137304527329479.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(203144411900384588.4052)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(203138127529329480.4052)
,p_branch_action=>'f?p=&APP_ID.:117:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(203137425162329479.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(203137825813329480.4052)
,p_branch_action=>'f?p=&APP_ID.:115:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(203137304527329479.4052)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(10659826615751613.4052)
,p_validation_name=>'Workspaces exist in list'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from apex_collections',
' where collection_name = ''BULK_USER_CREATE'''))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('Aucun espace de travail \00E0 cr\00E9er.')
,p_when_button_pressed=>wwv_flow_api.id(203137425162329479.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00117
begin
wwv_flow_api.create_page(
 p_id=>117.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Cr\00E9er plusieurs espaces de travail')
,p_step_title=>unistr('Cr\00E9er plusieurs espaces de travail')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(3931243707245169747)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203142625502364148.4052)
,p_plug_name=>'create multiple workspaces'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_api.id(203141106443364145.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203145321035396682.4052)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(204747326360125429.4052)
,p_name=>'Espaces de travail (&P117_WORKSPACE_COUNT.)'
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lower(c001) username, ',
'       lower(c002) email, ',
'       c003 workspace,',
'       c013 schema,',
'       c006 tab,',
'       c007 quota,',
'       c009 consumer_group,',
'       c010 invite,',
'       SEQ_ID',
'  from apex_collections',
' where collection_name = ''BULK_USER_CREATE''',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('Aucun espace de travail \00E0 cr\00E9er.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(204747527037125436.4052)
,p_query_column_id=>1
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nom utilisateur'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(204747604390125436.4052)
,p_query_column_id=>2
,p_column_alias=>'EMAIL'
,p_column_display_sequence=>3
,p_column_heading=>'Courriel'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(204748507975125438.4052)
,p_query_column_id=>3
,p_column_alias=>'WORKSPACE'
,p_column_display_sequence=>1
,p_column_heading=>'Espace de travail'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(388224100302703612.4052)
,p_query_column_id=>4
,p_column_alias=>'SCHEMA'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Sch\00E9ma')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(204748201325125437.4052)
,p_query_column_id=>5
,p_column_alias=>'TAB'
,p_column_display_sequence=>8
,p_column_heading=>'Tables'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(157992123774592395)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(204747929987125437.4052)
,p_query_column_id=>6
,p_column_alias=>'QUOTA'
,p_column_display_sequence=>5
,p_column_heading=>'Quota (Mo)'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(204747706388125436.4052)
,p_query_column_id=>7
,p_column_alias=>'CONSUMER_GROUP'
,p_column_display_sequence=>10
,p_column_heading=>'Groupe de consommateurs'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(204747826149125437.4052)
,p_query_column_id=>8
,p_column_alias=>'INVITE'
,p_column_display_sequence=>9
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(204748408256125437.4052)
,p_query_column_id=>9
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>11
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(388982521929319912.4052)
,p_plug_name=>'Mot de passe &PRODUCT_NAME.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>35
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Saisissez le mot de passe des comptes d''administrateur d''espace de travail et confirmez la liste des espaces de travail qui seront cr\00E9\00E9s.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752112771229695873.4052)
,p_plug_name=>unistr('Cr\00E9er plusieurs espaces de travail')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203139215977329481.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(203145321035396682.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203139300916329481.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(203145321035396682.4052)
,p_button_name=>'FINISH'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Provisionner des espaces de travail'
,p_button_position=>'CREATE'
,p_button_condition=>'to_number(:P117_WORKSPACE_COUNT) > 0'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203139424404329481.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(203145321035396682.4052)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(203140209185329481.4052)
,p_branch_action=>'f?p=&APP_ID.:135:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(203139300916329481.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(203139928802329481.4052)
,p_branch_action=>'f?p=&APP_ID.:116:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(203139424404329481.4052)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10525617128224276.4052)
,p_name=>'P117_WORKSPACE_COUNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(388982521929319912.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(388982807343323259.4052)
,p_name=>'P117_PASSWORD'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(388982521929319912.4052)
,p_prompt=>'Mot de passe'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Saisissez le mot de passe pour les comptes d''administrateur d''espace de travail &PRODUCT_NAME.. Tous les comptes seront cr\00E9\00E9s avec le m\00EAme mot de passe, qui peut \00EAtre modifi\00E9 ult\00E9rieurement.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(388983301089326245.4052)
,p_name=>'P117_PASSWORD_CONFIRM'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(388982521929319912.4052)
,p_prompt=>'Confirmer le mot de passe'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Confirmez le mot de passe pour les comptes d''administrateur d''espace de travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(10657900354703091.4052)
,p_computation_sequence=>10
,p_computation_item=>'P117_WORKSPACE_COUNT'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) as cnt',
'  from apex_collections',
' where collection_name = ''BULK_USER_CREATE'''))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(390370505112415516.4052)
,p_validation_name=>'P117_PASSWORD_CONFIRM'
,p_validation_sequence=>10
,p_validation=>'P117_PASSWORD'
,p_validation2=>'&P117_PASSWORD_CONFIRM.'
,p_validation_type=>'ITEM_IN_VALIDATION_EQ_STRING2'
,p_error_message=>'Non-concordance entre le mot de passe et le mot de passe de confirmation.'
,p_validation_condition=>':P117_PASSWORD is not null and :P117_PASSWORD_CONFIRM is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(203139300916329481.4052)
,p_associated_item=>wwv_flow_api.id(388983301089326245.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1475459903460625304.4052)
,p_validation_name=>'strong password verification'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    declare',
'        l_error varchar2(32767);',
'    begin',
'        --',
'        -- return message for first validation error or null',
'        --',
'        for c1 in ( select upper(c001) username,',
'                           upper(c003) workspace',
'                      from wwv_flow_collections',
'                     where collection_name = ''BULK_USER_CREATE''',
'                     order by 1 )',
'        loop',
'',
'            l_error := wwv_flow_security.strong_password_validation(',
'                           p_username       => c1.username,',
'                           p_password       => :P117_PASSWORD,',
'                           p_old_password   => null,',
'                           p_workspace_name => c1.workspace );',
'            exit when l_error is not null;',
'        end loop;',
'',
'        return l_error;',
'    end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'erreur'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_authentication_dev.is_builder_password_required (',
'    p_developer_yn => ''Y'' )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(388982807343323259.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(204714102784891523.4052)
,p_name=>'Finish'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(203139300916329481.4052)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(204714407002891533.4052)
,p_event_id=>wwv_flow_api.id(204714102784891523.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'FINISH'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(203182018750181417.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create workspaces'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_security_group_id number;',
'   l_password          varchar2(255);',
'   l_email             varchar2(512);',
'   function get_security_group_id( p_workspace_name in varchar2 ) return number',
'   is',
'       l_security_group_id number := null;',
'   begin',
'       for c1 in (select provisioning_company_id',
'                    from wwv_flow_companies',
'                   where short_name = trim(upper(p_workspace_name))) loop',
'           l_security_group_id := c1.provisioning_company_id;',
'           exit;',
'       end loop;',
'       --',
'       return l_security_group_id;',
'   end get_security_group_id;',
'   ',
'begin',
'',
'    l_password := :P117_PASSWORD;',
'    :P117_PASSWORD := null;',
'',
'for c1 in (',
'select upper(c001) username, ',
'       lower(c002) email, ',
'       upper(c003) workspace,',
'       upper(c013) schema,',
'       c006 tab,',
'       c007 quota,',
'       c009 consumer_group,',
'       c010 invite,',
'       c011 auto_purge,',
'       c012 comments,',
'       SEQ_ID',
'  from wwv_flow_collections',
' where collection_name = ''BULK_USER_CREATE''',
'order by 1) loop',
'',
'    wwv_flow_cloud_db_services.create_workspace(',
'        p_workspace_name         => c1.workspace,',
'        p_schema_name            => c1.schema,',
'        p_max_size_mb            => c1.quota,',
'        p_initial_size_mb        => 5,',
'        p_install_sample_app     => ''N'',',
'        p_install_sample_ws      => ''N'',',
'        p_install_emp_dept       => c1.tab,',
'        p_allow_to_be_purged_yn  => c1.auto_purge,',
'        p_rm_consumer_group      => c1.consumer_group,',
'        p_workspace_description  => c1.comments);',
'',
'    wwv_flow_cloud_db_services.set_workspace_status(',
'        p_workspace_name => c1.workspace,',
'        p_workspace_status => ''ASSIGNED'' );',
'',
'    l_security_group_id  := get_security_group_id( p_workspace_name => c1.workspace );',
'    --    l_password := wwv_flow_provision.get_random_password( 32 );',
'',
'',
'    if instr(c1.username,''@'') > 0 and instr(c1.username,''.'') > 0 then',
'        l_email := c1.username;',
'    else',
'        l_email := null;',
'    end if;',
'',
'    wwv_flow_admin_api.create_user(',
'            p_security_group_id            => l_security_group_id,',
'            p_user_name                    => c1.username,',
'            p_first_name                   => null,',
'            p_last_name                    => null,',
'            p_web_password                 => l_password,',
'            p_email_address                => l_email,',
'            p_is_admin                     => ''Y'',',
'            p_change_password_on_first_use => ''N'' );',
'',
'end loop;',
'commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Erreur lors de la cr\00E9ation des espaces de travail.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Espaces de travail cr\00E9\00E9s.')
);
end;
/
prompt --application/pages/page_00118
begin
wwv_flow_api.create_page(
 p_id=>118.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Modifier la demande de provisionnement de l''espace de travail'
,p_step_title=>'Modifier la demande de provisionnement de l''espace de travail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931176750964111248)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10529205453313232.4052)
,p_plug_name=>'Wizard buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204693530359730650.4052)
,p_plug_name=>'Workspace Request'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752112842780695873.4052)
,p_plug_name=>'Modifier la demande de provisionnement de l''espace de travail'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(204704923093832859.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(10529205453313232.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:116:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(204705303596832861.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(10529205453313232.4052)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Supprimer'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(204705113527832861.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(10529205453313232.4052)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(204723032686965081.4052)
,p_branch_name=>'back to wizard'
,p_branch_action=>'f?p=&APP_ID.:116:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(204700124196801945.4052)
,p_name=>'P118_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(204693530359730650.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(204711717233881083.4052)
,p_name=>'P118_WORKSPACE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(204693530359730650.4052)
,p_prompt=>'Nom de l''espace de travail'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>35
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Saisissez le nom de l''espace de travail \00E0 cr\00E9er.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(204711919936881083.4052)
,p_name=>'P118_SCHEMA'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(204693530359730650.4052)
,p_prompt=>unistr('Sch\00E9ma')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>35
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Saisissez le nom du sch\00E9ma de base de donn\00E9es \00E0 cr\00E9er et \00E0 associer \00E0 cet espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(204712106692881084.4052)
,p_name=>'P118_EMAIL'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(204693530359730650.4052)
,p_prompt=>'Courriel'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez l''adresse \00E9lectronique de l''administrateur d''espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(204712313604881085.4052)
,p_name=>'P118_QUOTA'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(204693530359730650.4052)
,p_prompt=>'Quota d''espace (Mo)'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>8
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Saisissez la taille maximale du tablespace \00E0 associer au sch\00E9ma d''espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
,p_attribute_02=>'10000'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(204712512007881086.4052)
,p_name=>'P118_INSTALL_SAMPLE_APP'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(204693530359730650.4052)
,p_prompt=>unistr('Installer l''application \00E9chantillon')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Installez l''application de base de donn\00E9es \00E9chantillon dans cet espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(204712705122881089.4052)
,p_name=>'P118_INSTALL_SAMPLE_WS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(204693530359730650.4052)
,p_prompt=>unistr('Installer la feuille Web \00E9chantillon')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_security_scheme=>wwv_flow_api.id(610289739776900562)
,p_help_text=>unistr('Installez la feuille Web \00E9chantillon dans cet espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(204712912974881089.4052)
,p_name=>'P118_INSTALL_SAMPLE_TAB'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(204693530359730650.4052)
,p_prompt=>unistr('Installer les tables \00E9chantillon EMP et DEPT')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Installez les tables EMP et DEPT \00E9chantillon dans cet espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(204713128286881089.4052)
,p_name=>'P118_CONSUMER_GROUP'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(204693530359730650.4052)
,p_prompt=>'Groupe de consommateurs Resource Manager'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RESOURCE CONSUMER GROUPS (NON  SYSTEM)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select consumer_group d, consumer_group r',
'  from sys.dba_rsrc_consumer_groups',
' where consumer_group not like ''ORA$%''',
'   and consumer_group <> ''SYS_GROUP''',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ne pas d\00E9finir -')
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez le groupe de consommateurs Database Resource Manager \00E0 utiliser pour tous les \00E9v\00E9nements de page associ\00E9s \00E0 cet espace de travail. Au d\00E9but de chaque demande, le moteur &PRODUCT_NAME. remplace le groupe de consommateurs de la session de base')
||unistr(' de donn\00E9es en cours par le groupe de consommateurs de l''espace de travail. Ce comportement s''applique \00E0 la fois aux applications en cours d''ex\00E9cution et aux applications utilis\00E9es dans l''environnement de d\00E9veloppement &PRODUCT_NAME..'),
'',
'<p />',
'',
unistr('Le privil\00E8ge permettant le remplacement du groupe de consommateurs doit \00EAtre accord\00E9 au sch\00E9ma PUBLIC ou &PRODUCT_NAME.. Ce privil\00E8ge est g\00E9n\00E9ralement accord\00E9 \00E0 l''aide de la proc\00E9dure DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(204740226561074303.4052)
,p_name=>'P118_SEND_EMAIL'
,p_item_sequence=>85
,p_item_plug_id=>wwv_flow_api.id(204693530359730650.4052)
,p_prompt=>'Envoyer une invitation par courriel'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(204803923199823235.4052)
,p_name=>'P118_AUTO_PURGE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(204693530359730650.4052)
,p_prompt=>'Autoriser la purge automatique de l''espace de travail'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('D\00E9termine si l''espace de travail peut \00EAtre concern\00E9 par la purge automatique des espaces de travail non utilis\00E9s.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(204804212188843537.4052)
,p_name=>'P118_COMMENTS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(204693530359730650.4052)
,p_prompt=>'Description de l''espace de travail'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>3
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Saisissez une description ou un commentaire facultatif de l''espace de travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(388229314702757742.4052)
,p_name=>'P118_USERNAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(204693530359730650.4052)
,p_prompt=>'Nom utilisateur'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Saisissez le nom utilisateur de l''administrateur d''espace de travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(204722307164959043.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Apply changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_member (',
'    p_collection_name => ''BULK_USER_CREATE'',',
'    p_seq             => :P118_SEQ_ID,',
'    p_c001            => upper(:P118_USERNAME),',
'    p_c002            => lower(:P118_EMAIL),',
'    p_c003            => upper(:P118_WORKSPACE),',
'    p_c004            => :P118_INSTALL_SAMPLE_APP,',
'    p_c005            => :P118_INSTALL_SAMPLE_WS,',
'    p_c006            => :P118_INSTALL_SAMPLE_TAB,',
'    p_c007            => :P118_QUOTA,',
'    p_c009            => :P118_CONSUMER_GROUP,',
'    p_c010            => :P118_SEND_EMAIL,',
'    p_c011            => :P118_AUTO_PURGE,',
'    p_c012            => :P118_COMMENTS,',
'    p_c013            => :P118_SCHEMA );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(204705113527832861.4052)
,p_process_success_message=>unistr('Demande de provisionnement de l''espace de travail mise \00E0 jour.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(10657131894604722.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.delete_member (',
'    p_collection_name => ''BULK_USER_CREATE'',',
'    p_seq             => :P118_SEQ_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(204705303596832861.4052)
,p_process_success_message=>unistr('Demande de provisionnement de l''espace de travail supprim\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(204721213005932269.4052)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select upper(c001) un, ',
'       lower(c002) email, ',
'       c003 workspace,',
'       c004 app, ',
'       c005 ws,',
'       c006 tab,',
'       c007 quota,',
'       c008 password,',
'       c009 consumer_group,',
'       c010 send_mail,',
'       c011 auto_purge,',
'       c012 comments,',
'       c013 schema',
'  from apex_collections',
' where collection_name = ''BULK_USER_CREATE'' and ',
'       seq_id = :P118_SEQ_ID',
'     ) loop',
'    :P118_WORKSPACE := c1.workspace;',
'    :P118_USERNAME  := c1.un;',
'    :P118_SCHEMA    := c1.schema;',
'    :P118_EMAIL     := c1.email;',
'    :P118_QUOTA     := c1.quota;',
'    :P118_INSTALL_SAMPLE_APP := c1.app;',
'    :P118_INSTALL_SAMPLE_WS  := c1.ws;',
'    :P118_INSTALL_SAMPLE_TAB := c1.tab;',
'    :P118_CONSUMER_GROUP     := c1.consumer_group;',
'    :P118_SEND_EMAIL         := c1.send_mail;',
'    :P118_AUTO_PURGE         := c1.auto_purge;',
'    :P118_COMMENTS           := c1.comments;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00119
begin
wwv_flow_api.create_page(
 p_id=>119.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('G\00E9rer l''intervalle de journalisation')
,p_step_title=>unistr('G\00E9rer l''intervalle de journalisation')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931176884177111905)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(217670729607373979.4052)
,p_plug_name=>unistr('G\00E9rer l''intervalle de journalisation')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829706609080810173.4052)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>D\00E9finissez le nombre minimal de jours pendant lesquels les informations sur le journal sont conserv\00E9es pour les journaux indiqu\00E9s. La valeur maximale est de 180 jours et la valeur par d\00E9faut de 14 jours. La conservation prolong\00E9e des informations ')
||unistr('sur le journal peut r\00E9duire les performances d''ex\00E9cution.</p>'),
'',
unistr('<p>Les journaux sont impl\00E9ment\00E9s \00E0 l''aide de deux tables sous-jacentes. Un changement de table de journalisation a lieu une fois que le nombre de jours indiqu\00E9s dans le champ Changement de journal apr\00E8s est \00E9coul\00E9.</p>'),
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(220474109124626169.4052)
,p_name=>unistr('G\00E9rer l''intervalle de journalisation')
,p_template=>wwv_flow_api.id(721130166613730309.4052)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'"LOG_NAME",',
'"CURRENT_LOG_NUMBER",',
'"LOG_SWITCHED_DATE",',
'"LOG_SWITCH_AFTER_DAYS",',
'"LOG_NAME" LOG_NAME_DISPLAY',
'from "#OWNER#"."WWV_FLOW_LOG_NUMBERS"',
''))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>10
,p_query_show_nulls_as=>'(null)'
,p_query_no_data_found=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(220474418004626171.4052)
,p_query_column_id=>1
,p_column_alias=>'LOG_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Log Name'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_column_width=>16
,p_pk_col_source_type=>'T'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LOG_NUMBERS'
,p_ref_column_name=>'LOG_NAME'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(220474520209626171.4052)
,p_query_column_id=>2
,p_column_alias=>'CURRENT_LOG_NUMBER'
,p_column_display_sequence=>3
,p_column_heading=>'Current Log Number'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LOG_NUMBERS'
,p_ref_column_name=>'CURRENT_LOG_NUMBER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(220474606112626171.4052)
,p_query_column_id=>3
,p_column_alias=>'LOG_SWITCHED_DATE'
,p_column_display_sequence=>4
,p_column_heading=>'Date de changement de journal'
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_column_width=>7
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LOG_NUMBERS'
,p_ref_column_name=>'LOG_SWITCHED_DATE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(220474704579626171.4052)
,p_query_column_id=>4
,p_column_alias=>'LOG_SWITCH_AFTER_DAYS'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Changement de journal apr\00E8s')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LOG_NUMBERS'
,p_ref_column_name=>'LOG_SWITCH_AFTER_DAYS'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(220474822223626171.4052)
,p_query_column_id=>5
,p_column_alias=>'LOG_NAME_DISPLAY'
,p_column_display_sequence=>2
,p_column_heading=>'Nom de journal'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(220529904687804674)
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LOG_NUMBERS'
,p_ref_column_name=>'LOG_NAME_DISPLAY'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(220476731217631908.4052)
,p_column_sequence=>1
,p_query_column_name=>'LOG_NAME'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(220476821007631909.4052)
,p_column_sequence=>2
,p_query_column_name=>'CURRENT_LOG_NUMBER'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(220476901338631909.4052)
,p_column_sequence=>3
,p_query_column_name=>'LOG_SWITCHED_DATE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(220477010434631909.4052)
,p_column_sequence=>4
,p_query_column_name=>'LOG_SWITCH_AFTER_DAYS'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(220477104991631909.4052)
,p_column_sequence=>5
,p_query_column_name=>'LOG_NAME_DISPLAY'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1080989061119523923.4052)
,p_plug_name=>'Boutons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(220475031437626173.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1080989061119523923.4052)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(220474918866626173.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1080989061119523923.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(220476109027626175.4052)
,p_branch_action=>'f?p=&APP_ID.:119:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>1
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(220475612889626174.4052)
,p_tabular_form_region_id=>wwv_flow_api.id(220474109124626169.4052)
,p_validation_name=>'LOG_SWITCH_AFTER_DAYS not null'
,p_validation_sequence=>40
,p_validation=>'LOG_SWITCH_AFTER_DAYS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'La valeur #COLUMN_HEADER# doit comporter une valeur.'
,p_when_button_pressed=>wwv_flow_api.id(220475031437626173.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_associated_column=>'LOG_SWITCH_AFTER_DAYS'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(220475820099626174.4052)
,p_tabular_form_region_id=>wwv_flow_api.id(220474109124626169.4052)
,p_validation_name=>'LOG_SWITCH_AFTER_DAYS must be numeric'
,p_validation_sequence=>40
,p_validation=>'LOG_SWITCH_AFTER_DAYS'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('La valeur #COLUMN_HEADER# doit \00EAtre num\00E9rique.')
,p_when_button_pressed=>wwv_flow_api.id(220475031437626173.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_associated_column=>'LOG_SWITCH_AFTER_DAYS'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(220561017110808463.4052)
,p_tabular_form_region_id=>wwv_flow_api.id(220474109124626169.4052)
,p_validation_name=>'Log Switch After Days must be a positive integer between 1 and 180'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if abs(trunc(to_number(:LOG_SWITCH_AFTER_DAYS))) <> to_number(:LOG_SWITCH_AFTER_DAYS) then',
'        return FALSE;',
'    end if;',
'    if to_number(:LOG_SWITCH_AFTER_DAYS) between 1 and 180 then',
'        return TRUE;',
'    else',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('#COLUMN_HEADER# doit \00EAtre un entier positif compris entre 1 et 180.')
,p_when_button_pressed=>wwv_flow_api.id(220475031437626173.4052)
,p_exec_cond_for_each_row=>'Y'
,p_associated_item=>wwv_flow_api.id(.4052)
,p_associated_column=>'LOG_SWITCH_AFTER_DAYS'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(582425338101226541.4052)
,p_tabular_form_region_id=>wwv_flow_api.id(220474109124626169.4052)
,p_validation_name=>'Log Switch After Days must be a positive integer greater than 14 for cloud'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if to_number(:LOG_SWITCH_AFTER_DAYS) > 13 then',
'        return TRUE;',
'    else',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('#COLUMN_HEADER# doit \00EAtre au moins \00E9gal \00E0 14.')
,p_validation_condition=>'return wwv_flow_global.g_cloud;'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'FUNCTION_BODY'
,p_when_button_pressed=>wwv_flow_api.id(220475031437626173.4052)
,p_exec_cond_for_each_row=>'Y'
,p_associated_item=>wwv_flow_api.id(.4052)
,p_associated_column=>'LOG_SWITCH_AFTER_DAYS'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(220475920386626174.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(220474109124626169.4052)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_LOG_NUMBERS'
,p_attribute_03=>'LOG_NAME'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(220475031437626173.4052)
,p_process_success_message=>unistr('#MRU_COUNT# ligne(s) mise(s) \00E0 jour.')
);
end;
/
prompt --application/pages/page_00120
begin
wwv_flow_api.create_page(
 p_id=>120.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'File d''attente des courriels'
,p_step_title=>'File d''attente des courriels'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216784309333645873)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_mail.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(49446201769803487.4052)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>15
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(50268723520030341.4052)
,p_plug_name=>'File d''attente des courriels'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Surveillez les courriels dans la file d''attente des courriels. Vous pouvez en supprimer.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(52072302092220942.4052)
,p_name=>'File d''attente des courriels'
,p_template=>wwv_flow_api.id(517376500704206647.4052)
,p_display_sequence=>25
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, ',
'       mail_to, ',
'       mail_from, ',
'       mail_subj, ',
'       mail_cc, ',
'       mail_bcc, ',
'       last_updated_on, ',
'       last_updated_by,',
'       mail_send_error,',
'       mail_send_count',
'from wwv_flow_mail_queue'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' -'
,p_query_no_data_found=>unistr('L''\00E9tat ne contient aucune donn\00E9e')
,p_query_num_rows_item=>'P120_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>10000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(52079921055245360.4052)
,p_query_column_id=>1
,p_column_alias=>'CHECK$01'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_display_as=>'CHECKBOX'
,p_derived_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(52072918944220953.4052)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'ID'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'DISPLAY_AND_SAVE'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(52073024837220953.4052)
,p_query_column_id=>3
,p_column_alias=>'MAIL_TO'
,p_column_display_sequence=>3
,p_column_heading=>'A'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(52073128821220954.4052)
,p_query_column_id=>4
,p_column_alias=>'MAIL_FROM'
,p_column_display_sequence=>4
,p_column_heading=>'De'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(52073227085220954.4052)
,p_query_column_id=>5
,p_column_alias=>'MAIL_SUBJ'
,p_column_display_sequence=>5
,p_column_heading=>'Objet'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(52073318409220954.4052)
,p_query_column_id=>6
,p_column_alias=>'MAIL_CC'
,p_column_display_sequence=>6
,p_column_heading=>'CC'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(52073402357220954.4052)
,p_query_column_id=>7
,p_column_alias=>'MAIL_BCC'
,p_column_display_sequence=>7
,p_column_heading=>'CCI'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(52073505633220954.4052)
,p_query_column_id=>8
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>8
,p_column_heading=>unistr('Mis \00E0 jour')
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(52073606743220954.4052)
,p_query_column_id=>9
,p_column_alias=>'LAST_UPDATED_BY'
,p_column_display_sequence=>9
,p_column_heading=>'Created By'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(27759304778424826.4052)
,p_query_column_id=>10
,p_column_alias=>'MAIL_SEND_ERROR'
,p_column_display_sequence=>11
,p_column_heading=>'Erreur'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(345054819878396473.4052)
,p_query_column_id=>11
,p_column_alias=>'MAIL_SEND_COUNT'
,p_column_display_sequence=>10
,p_column_heading=>unistr('Nombre de courriels envoy\00E9s')
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(52076517114234733.4052)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(52076621951234734.4052)
,p_column_sequence=>2
,p_query_column_name=>'MAIL_TO'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(52076715067234734.4052)
,p_column_sequence=>3
,p_query_column_name=>'MAIL_FROM'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(52076807247234734.4052)
,p_column_sequence=>4
,p_query_column_name=>'MAIL_SUBJ'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(52076910607234734.4052)
,p_column_sequence=>5
,p_query_column_name=>'MAIL_CC'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(52077014613234734.4052)
,p_column_sequence=>6
,p_query_column_name=>'MAIL_BCC'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(52077106520234734.4052)
,p_column_sequence=>7
,p_query_column_name=>'LAST_UPDATED_ON'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(52077202857234734.4052)
,p_column_sequence=>8
,p_query_column_name=>'LAST_UPDATED_BY'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(27759202939424825.4052)
,p_column_sequence=>9
,p_query_column_name=>'MAIL_SEND_ERROR'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(345054619550396473.4052)
,p_column_sequence=>10
,p_query_column_name=>'MAIL_SEND_COUNT'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(195763210632686096.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(49446201769803487.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:120:&SESSION.::&DEBUG.:RP,120,RIR::'
,p_button_condition_type=>'NEVER'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48462126508690371.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(49446201769803487.4052)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Supprimer'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(345061314377421688.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(49446201769803487.4052)
,p_button_name=>'FORCESEND'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Forcer l''envoi de tous les courriels'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(50605032251638488.4052)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(49446201769803487.4052)
,p_button_name=>'SEND'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Envoyer tous les courriels'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48515711186704875.4052)
,p_branch_action=>'f?p=&APP_ID.:120:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(61617713712144160.4052)
,p_validation_name=>'Something checked on delete'
,p_validation_sequence=>10
,p_validation=>'wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Aucun message \00E0 supprimer n''a \00E9t\00E9 coch\00E9.')
,p_when_button_pressed=>wwv_flow_api.id(48462126508690371.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(48518317897716201.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(52072302092220942.4052)
,p_process_type=>'NATIVE_TABFORM_DELETE'
,p_process_name=>'Delete Checked'
,p_attribute_02=>'WWV_FLOW_MAIL_QUEUE'
,p_attribute_03=>'ID'
,p_process_error_message=>'Erreur lors de la suppression des courriels de la file d''attente.'
,p_process_when_button_id=>wwv_flow_api.id(48462126508690371.4052)
,p_process_success_message=>unistr('Courriels supprim\00E9s avec succ\00E8s de la file d''attente.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(50611232167657317.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Send Mail'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_mail.push_queue_immediate( p_force_yn => ''N'');',
'--',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors de l''envoi du courriel.'
,p_process_when_button_id=>wwv_flow_api.id(50605032251638488.4052)
,p_process_success_message=>unistr('Courriel envoy\00E9 avec succ\00E8s.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(345064911254426069.4052)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Force Send Mail'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_mail.push_queue_immediate( p_force_yn => ''Y'');',
'--',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors de l''envoi du courriel.'
,p_process_when_button_id=>wwv_flow_api.id(345061314377421688.4052)
,p_process_success_message=>unistr('Courriel envoy\00E9 avec succ\00E8s.')
);
end;
/
prompt --application/pages/page_00121
begin
wwv_flow_api.create_page(
 p_id=>121.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Journal des courriels'
,p_step_title=>'Journal des courriels'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216784309333645873)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_logs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(50496401272341432.4052)
,p_plug_name=>'Journal des courriels &PRODUCT_NAME.'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Le journal des courriels contient les champs d''en-t\00EAte et la date de tous les messages envoy\00E9s sans erreur.  ')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(50496812659341435.4052)
,p_plug_name=>'Journal des courriels'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>15
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(192438208860857511.4052)
,p_plug_name=>'Journal des courriels'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select replace(mail_to,'','','', '') mail_to, ',
'       mail_from, ',
'       mail_subj, ',
'       mail_cc,',
'       mail_bcc, ',
'       last_updated_on, ',
'       last_updated_on since_date,',
'       last_updated_by,',
'       mail_send_error,',
'       mail_message_created,',
'       mail_message_send_begin,',
'       mail_message_send_end,',
'       mail_body_size,',
'       mail_body_html_size,',
'       mail_attachment_count,',
'       mail_attachment_size,',
'       mail_message_id',
'from wwv_flow_mail_log'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(192438318982857511.4052)
,p_name=>'Mail Log'
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192438507088857516.4052)
,p_db_column_name=>'MAIL_TO'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'A'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192438629698857518.4052)
,p_db_column_name=>'MAIL_FROM'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'De'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192438715159857518.4052)
,p_db_column_name=>'MAIL_SUBJ'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Objet'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192438831304857519.4052)
,p_db_column_name=>'MAIL_CC'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'CC'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192438914422857520.4052)
,p_db_column_name=>'MAIL_BCC'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'CCI'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192439021960857521.4052)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Entr\00E9e de journal cr\00E9\00E9e')
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192439104693857521.4052)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Message cr\00E9\00E9 par')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192439215943857522.4052)
,p_db_column_name=>'MAIL_SEND_ERROR'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Erreur'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192440600375889711.4052)
,p_db_column_name=>'SINCE_DATE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>unistr('Entr\00E9e de journal cr\00E9\00E9e depuis')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(741568285578681316.4052)
,p_db_column_name=>'MAIL_MESSAGE_CREATED'
,p_display_order=>19
,p_column_identifier=>'J'
,p_column_label=>unistr('Message cr\00E9\00E9')
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(279105603897806104.4052)
,p_db_column_name=>'MAIL_MESSAGE_ID'
,p_display_order=>29
,p_column_identifier=>'Q'
,p_column_label=>'ID de message'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(741568340024681317.4052)
,p_db_column_name=>'MAIL_MESSAGE_SEND_BEGIN'
,p_display_order=>39
,p_column_identifier=>'K'
,p_column_label=>unistr('D\00E9but de l''envoi du message')
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(741568428493681318.4052)
,p_db_column_name=>'MAIL_MESSAGE_SEND_END'
,p_display_order=>49
,p_column_identifier=>'L'
,p_column_label=>'Fin de l''envoi du message'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(741568555179681319.4052)
,p_db_column_name=>'MAIL_BODY_SIZE'
,p_display_order=>59
,p_column_identifier=>'M'
,p_column_label=>'Taille du corps du message'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(741568632901681320.4052)
,p_db_column_name=>'MAIL_BODY_HTML_SIZE'
,p_display_order=>69
,p_column_identifier=>'N'
,p_column_label=>'Taille du corps des messages HTML'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(741568730024681321.4052)
,p_db_column_name=>'MAIL_ATTACHMENT_COUNT'
,p_display_order=>79
,p_column_identifier=>'O'
,p_column_label=>unistr('Nombre de pi\00E8ces jointes')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(741568816710681322.4052)
,p_db_column_name=>'MAIL_ATTACHMENT_SIZE'
,p_display_order=>89
,p_column_identifier=>'P'
,p_column_label=>unistr('Taille de pi\00E8ce jointe')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(192440923924896543.4052)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(50496812659341435.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:121:&SESSION.::&DEBUG.:RIR,121::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(108302731174967188.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(50496812659341435.4052)
,p_button_name=>'TRUNCATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Vider'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(50500825272341463.4052)
,p_branch_action=>'f?p=&FLOW_ID.:121:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(50542609292499337.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Truncate log'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_mail_log;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors du vidage du journal des courriels.'
,p_process_when_button_id=>wwv_flow_api.id(108302731174967188.4052)
,p_process_success_message=>unistr('Journal des courriels vid\00E9 avec succ\00E8s.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(108304121608973821.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_api.id(192440923924896543.4052)
);
end;
/
prompt --application/pages/page_00122
begin
wwv_flow_api.create_page(
 p_id=>122.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Travaux'
,p_step_title=>'Travaux'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(619287213627143211.4052)
,p_plug_name=>'Travaux'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('L''\00E9tat des travaux contient la liste de tous les travaux de base de donn\00E9es associ\00E9s \00E0 &PRODUCT_NAME..'),
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(619293913679166083.4052)
,p_plug_name=>'Travaux'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>'select * from user_scheduler_jobs'
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(619294030254166083.4052)
,p_name=>'Jobs'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'JOEL'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619294232226166109.4052)
,p_db_column_name=>'JOB_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nom du travail'
,p_column_link=>'f?p=&APP_ID.:123:&SESSION.::&DEBUG.:123,RIR:IR_JOB_NAME:#JOB_NAME#'
,p_column_linktext=>'#JOB_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619294305961166110.4052)
,p_db_column_name=>'JOB_SUBNAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Sous-nom du travail'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619294416630166110.4052)
,p_db_column_name=>'JOB_STYLE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Style du travail'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619294516377166110.4052)
,p_db_column_name=>'JOB_CREATOR'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Cr\00E9ateur du travail')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619294621699166110.4052)
,p_db_column_name=>'CLIENT_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'ID de client'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619294719986166111.4052)
,p_db_column_name=>'GLOBAL_UID'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'UID global'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619294804252166111.4052)
,p_db_column_name=>'PROGRAM_OWNER'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Propri\00E9taire du programme')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619294901886166111.4052)
,p_db_column_name=>'PROGRAM_NAME'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Nom de programme'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619295019204166111.4052)
,p_db_column_name=>'JOB_TYPE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Type de travail'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619295100644166111.4052)
,p_db_column_name=>'JOB_ACTION'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Action de travail'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619295227963166112.4052)
,p_db_column_name=>'NUMBER_OF_ARGUMENTS'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Nombre d''arguments'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619295306216166112.4052)
,p_db_column_name=>'SCHEDULE_OWNER'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>unistr('Propri\00E9taire de la programmation')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619295409833166112.4052)
,p_db_column_name=>'SCHEDULE_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nom de programmation'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619295532117166112.4052)
,p_db_column_name=>'SCHEDULE_TYPE'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Type de programmation'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619295616537166112.4052)
,p_db_column_name=>'START_DATE'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>unistr('Date de d\00E9but')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'DS FMHH24:MI:SS TZR'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619295702828166113.4052)
,p_db_column_name=>'REPEAT_INTERVAL'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>unistr('Intervalle de r\00E9p\00E9tition')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619295804093166113.4052)
,p_db_column_name=>'EVENT_QUEUE_OWNER'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>unistr('Propri\00E9taire de la file d''attente des \00E9v\00E9nements')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619295913719166113.4052)
,p_db_column_name=>'EVENT_QUEUE_NAME'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Nom de la file d''attente des \00E9v\00E9nements')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619296031026166113.4052)
,p_db_column_name=>'EVENT_QUEUE_AGENT'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Agent de la file d''attente des \00E9v\00E9nements')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619296105540166113.4052)
,p_db_column_name=>'EVENT_CONDITION'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>unistr('Condition d''\00E9v\00E9nement')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619296211650166114.4052)
,p_db_column_name=>'EVENT_RULE'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>unistr('R\00E8gle d''\00E9v\00E9nement')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619296331450166114.4052)
,p_db_column_name=>'END_DATE'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Date de fin'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619296403147166114.4052)
,p_db_column_name=>'JOB_CLASS'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Classe de travail'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619296508234166114.4052)
,p_db_column_name=>'ENABLED'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>unistr('Activ\00E9')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(1351993194329853612)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619296610013166114.4052)
,p_db_column_name=>'AUTO_DROP'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'Suppression automatique'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619296702820166115.4052)
,p_db_column_name=>'RESTARTABLE'
,p_display_order=>26
,p_column_identifier=>'Z'
,p_column_label=>unistr('Qui peut \00EAtre red\00E9marr\00E9')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619296816948166115.4052)
,p_db_column_name=>'STATE'
,p_display_order=>27
,p_column_identifier=>'AA'
,p_column_label=>unistr('Province/D\00E9partement')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(1352009278507904884)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619296914488166115.4052)
,p_db_column_name=>'JOB_PRIORITY'
,p_display_order=>28
,p_column_identifier=>'AB'
,p_column_label=>unistr('Priorit\00E9 de travail')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619297025922166115.4052)
,p_db_column_name=>'RUN_COUNT'
,p_display_order=>29
,p_column_identifier=>'AC'
,p_column_label=>unistr('Nombre d''ex\00E9cutions')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619297119343166115.4052)
,p_db_column_name=>'MAX_RUNS'
,p_display_order=>30
,p_column_identifier=>'AD'
,p_column_label=>unistr('Nombre maximal d''ex\00E9cutions')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619297214556166116.4052)
,p_db_column_name=>'FAILURE_COUNT'
,p_display_order=>31
,p_column_identifier=>'AE'
,p_column_label=>unistr('Nombre d''\00E9checs')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619297316831166116.4052)
,p_db_column_name=>'MAX_FAILURES'
,p_display_order=>32
,p_column_identifier=>'AF'
,p_column_label=>unistr('Nombre maximal d''\00E9checs')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619297404830166116.4052)
,p_db_column_name=>'RETRY_COUNT'
,p_display_order=>33
,p_column_identifier=>'AG'
,p_column_label=>'Nombre de nouvelles tentatives'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619297509411166116.4052)
,p_db_column_name=>'LAST_START_DATE'
,p_display_order=>34
,p_column_identifier=>'AH'
,p_column_label=>unistr('Date du dernier d\00E9marrage')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'DS FMHH24:MI:SS TZR'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619297618587166116.4052)
,p_db_column_name=>'LAST_RUN_DURATION'
,p_display_order=>35
,p_column_identifier=>'AI'
,p_column_label=>unistr('Dur\00E9e de la derni\00E8re ex\00E9cution')
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'OTHER'
,p_heading_alignment=>'LEFT'
,p_rpt_show_filter_lov=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619297731109166117.4052)
,p_db_column_name=>'NEXT_RUN_DATE'
,p_display_order=>36
,p_column_identifier=>'AJ'
,p_column_label=>unistr('Date de l''ex\00E9cution suivante')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'DS FMHH24:MI:SS TZR'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619297812228166117.4052)
,p_db_column_name=>'SCHEDULE_LIMIT'
,p_display_order=>37
,p_column_identifier=>'AK'
,p_column_label=>'Limite de la programmation'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'OTHER'
,p_heading_alignment=>'LEFT'
,p_rpt_show_filter_lov=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619297914868166117.4052)
,p_db_column_name=>'MAX_RUN_DURATION'
,p_display_order=>38
,p_column_identifier=>'AL'
,p_column_label=>unistr('Dur\00E9e maximale d''ex\00E9cution')
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'OTHER'
,p_heading_alignment=>'LEFT'
,p_rpt_show_filter_lov=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619298014140166122.4052)
,p_db_column_name=>'LOGGING_LEVEL'
,p_display_order=>39
,p_column_identifier=>'AM'
,p_column_label=>'Niveau de journalisation'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619298112899166122.4052)
,p_db_column_name=>'STOP_ON_WINDOW_CLOSE'
,p_display_order=>40
,p_column_identifier=>'AN'
,p_column_label=>unistr('Arr\00EAt \00E0 la fermeture de la fen\00EAtre')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619298216218166122.4052)
,p_db_column_name=>'INSTANCE_STICKINESS'
,p_display_order=>41
,p_column_identifier=>'AO'
,p_column_label=>'Affectation d''instance'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619298331678166123.4052)
,p_db_column_name=>'RAISE_EVENTS'
,p_display_order=>42
,p_column_identifier=>'AP'
,p_column_label=>unistr('D\00E9clencher des \00E9v\00E9nements')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619298425930166123.4052)
,p_db_column_name=>'SYSTEM'
,p_display_order=>43
,p_column_identifier=>'AQ'
,p_column_label=>unistr('Syst\00E8me')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619298523582166123.4052)
,p_db_column_name=>'JOB_WEIGHT'
,p_display_order=>44
,p_column_identifier=>'AR'
,p_column_label=>'Poids du travail'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619298624453166123.4052)
,p_db_column_name=>'NLS_ENV'
,p_display_order=>45
,p_column_identifier=>'AS'
,p_column_label=>'Environnement NLS'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619298719871166124.4052)
,p_db_column_name=>'SOURCE'
,p_display_order=>46
,p_column_identifier=>'AT'
,p_column_label=>'Source'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619298824989166124.4052)
,p_db_column_name=>'DESTINATION'
,p_display_order=>47
,p_column_identifier=>'AU'
,p_column_label=>'Destination'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619298914276166124.4052)
,p_db_column_name=>'CREDENTIAL_OWNER'
,p_display_order=>48
,p_column_identifier=>'AV'
,p_column_label=>unistr('Propri\00E9taire des informations d''identification')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619299021458166124.4052)
,p_db_column_name=>'CREDENTIAL_NAME'
,p_display_order=>49
,p_column_identifier=>'AW'
,p_column_label=>'Nom des informations d''identification'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619299116212166124.4052)
,p_db_column_name=>'INSTANCE_ID'
,p_display_order=>50
,p_column_identifier=>'AX'
,p_column_label=>'ID d''instance'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619299203876166125.4052)
,p_db_column_name=>'DEFERRED_DROP'
,p_display_order=>51
,p_column_identifier=>'AY'
,p_column_label=>unistr('Suppression diff\00E9r\00E9e')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619299321227166125.4052)
,p_db_column_name=>'COMMENTS'
,p_display_order=>52
,p_column_identifier=>'AZ'
,p_column_label=>'Commentaires'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619299420709166125.4052)
,p_db_column_name=>'FLAGS'
,p_display_order=>53
,p_column_identifier=>'BA'
,p_column_label=>'Indicateurs'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(619290502375143231.4052)
,p_branch_action=>'f?p=&FLOW_ID.:122:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
end;
/
prompt --application/pages/page_00123
begin
wwv_flow_api.create_page(
 p_id=>123.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('D\00E9tails du travail')
,p_step_title=>unistr('D\00E9tails du travail')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(619320610324379345.4052)
,p_plug_name=>'Informations sur le travail'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('L''\00E9tat des d\00E9tails des travaux contient la liste d\00E9taill\00E9e de tous les travaux de base de donn\00E9es associ\00E9s \00E0 &PRODUCT_NAME..'),
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(619328401632399515.4052)
,p_plug_name=>unistr('D\00E9tails du travail')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>'select * from user_scheduler_job_run_details'
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(619328506946399515.4052)
,p_name=>'Job Details'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'JOEL'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619328703645399517.4052)
,p_db_column_name=>'LOG_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID de journal'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619328802813399517.4052)
,p_db_column_name=>'LOG_DATE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Consigner la date dans le journal'
,p_column_type=>'DATE'
,p_format_mask=>'DS FMHH24:MI:SS TZR'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619328902016399517.4052)
,p_db_column_name=>'OWNER'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Propri\00E9taire')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619329004665399517.4052)
,p_db_column_name=>'JOB_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Nom du travail'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619329131960399517.4052)
,p_db_column_name=>'JOB_SUBNAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Sous-nom du travail'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619329224814399518.4052)
,p_db_column_name=>'STATUS'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Statut'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619329327897399518.4052)
,p_db_column_name=>'ERROR#'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Num\00E9ro d''erreur')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619329422639399518.4052)
,p_db_column_name=>'REQ_START_DATE'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>unistr('Date de d\00E9but demand\00E9e')
,p_column_type=>'DATE'
,p_format_mask=>'DS FMHH24:MI:SS TZR'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619329512301399518.4052)
,p_db_column_name=>'ACTUAL_START_DATE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>unistr('Date de d\00E9but r\00E9elle')
,p_column_type=>'DATE'
,p_format_mask=>'DS FMHH24:MI:SS TZR'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619329602367399518.4052)
,p_db_column_name=>'RUN_DURATION'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Dur\00E9e de l''ex\00E9cution')
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'OTHER'
,p_tz_dependent=>'N'
,p_rpt_show_filter_lov=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619329724251399519.4052)
,p_db_column_name=>'INSTANCE_ID'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'ID d''instance'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619329818078399519.4052)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'ID de session'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619329917351399519.4052)
,p_db_column_name=>'SLAVE_PID'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'PID esclave'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619330022964399519.4052)
,p_db_column_name=>'CPU_USED'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>unistr('UC utilis\00E9e')
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'OTHER'
,p_tz_dependent=>'N'
,p_rpt_show_filter_lov=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619330130204399519.4052)
,p_db_column_name=>'DESTINATION'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Destination'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(619330222156399520.4052)
,p_db_column_name=>'ADDITIONAL_INFO'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>unistr('Informations suppl\00E9mentaires')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(619327605091379390.4052)
,p_branch_action=>'f?p=&FLOW_ID.:123:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
end;
/
prompt --application/pages/page_00124
begin
wwv_flow_api.create_page(
 p_id=>124.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Journal de suppression de fichier automatique'
,p_step_title=>'Journal de suppression de fichier automatique'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216784309333645873)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_logs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(161574730450240735.4052)
,p_plug_name=>'Journal de suppression de fichier automatique'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Le journal de suppression de fichier automatique contient une liste des fichiers enlev\00E9s par le travail de maintenance quotidien. Ce processus est contr\00F4l\00E9 via les param\00E8tres d''instance de l''administration interne.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(161574904734240739.4052)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>15
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(161978910035273483.4052)
,p_plug_name=>'Journal de suppression de fichier automatique'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>'select * from wwv_flow_auto_file_delete_log'
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(161979018152273483.4052)
,p_name=>'Automatic File Delete Log'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de #MAX_ROW_COUNT# lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'JOEL'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(161979204270273485.4052)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(161979315225273485.4052)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'ID d''espace de travail'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(161979425537273485.4052)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Nom de l''espace de travail'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(161979510903273485.4052)
,p_db_column_name=>'FILE_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Nom de fichier'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(161979602399273485.4052)
,p_db_column_name=>'FILE_TYPE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Type de fichier'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(164450631905355420)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(161979701670273485.4052)
,p_db_column_name=>'FILE_SIZE'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Taille de fichier (octets)'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(161979807752273485.4052)
,p_db_column_name=>'DELETED_ON'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Fichier de donn\00E9es supprim\00E9')
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(161979923095273485.4052)
,p_db_column_name=>'WORKSPACE_DISPLAY_NAME'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Nom d''affichage de l''espace de travail'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(161980008445273485.4052)
,p_db_column_name=>'FILE_ID'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'ID de fichier'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(161575123049240741.4052)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(161574904734240739.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:124:&SESSION.::&DEBUG.:RIR,124::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(161575307016240741.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(161574904734240739.4052)
,p_button_name=>'TRUNCATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Vider'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(161578102866240779.4052)
,p_branch_action=>'f?p=&FLOW_ID.:124:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(161577605948240778.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Truncate log'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_auto_file_delete_log;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors du vidage du journal.'
,p_process_when_button_id=>wwv_flow_api.id(161575307016240741.4052)
,p_process_success_message=>unistr('Journal vid\00E9 avec succ\00E8s.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(161577812626240778.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_api.id(161575123049240741.4052)
);
end;
/
prompt --application/pages/page_00129
begin
wwv_flow_api.create_page(
 p_id=>129.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Abonnements d''\00E9tat interactif')
,p_step_title=>unistr('Abonnements d''\00E9tat interactif')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931176884177111905)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(274054417366299775.4052)
,p_plug_name=>unistr('Abonnements d''\00E9tat interactif')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1, n.id, null,null,'':'',''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'wwv_flow_lang.system_message(''IR_SUBSCRIPTION_LABEL'',i.flow_id,i.page_id,n.owner))||wwv_flow_item.hidden(2,n.id)||wwv_flow_item.hidden(3,n.security_group_id) id,',
'i.flow_id nflow_id,',
'i.page_id npage_id,',
'region_id nregion_id,',
'(select short_name from wwv_flow_companies c where c.provisioning_company_id = n.security_group_id) workspace,',
'(select plug_name from wwv_flow_page_plugs where id = i.region_id) region_name,',
'n.owner    application_user,',
'n.language language,',
'decode(n.download_format,',
'    ''XLSX'',''Excel'',',
'    n.download_format) download_format,',
'decode(n.strip_rich_text,',
'    ''Y'',m.m_yes,',
'    ''N'',m.m_no) strip_rich_text,',
'decode(n.data_only,',
'    ''Y'',m.m_yes,',
'    ''N'',m.m_no,',
'    m.m_no) data_only,',
'decode(n.pdf_page_size,',
'    ''A3'',m.m_a3,',
'    ''A4'',m.m_a4,',
'    ''LEGAL'',m.m_legal,',
'    ''LETTER'',m.m_letter,',
'    ''CUSTOM'',m.m_custom,',
'    ''TABLOID'',m.m_tabloid,',
'    pdf_page_size) pdf_page_size,',
'decode(n.pdf_page_orientation,',
'    ''VERTICAL'',m.m_vertical,',
'    ''HORIZONTAL'',m.m_horizontal,',
'    pdf_page_orientation) pdf_page_orientation,',
'decode(n.pdf_accessible,',
'    ''Y'',m.m_yes,',
'    ''N'',m.m_no) pdf_accessible,',
'decode(n.skip_no_data_found,',
'    ''Y'',m.m_yes,',
'    ''N'',m.m_no) skip_no_data_found,',
'n.start_date at time zone sessiontimezone start_date,',
'n.end_date at time zone sessiontimezone end_date,',
'case when nvl(n.end_date,systimestamp) >= systimestamp then',
'    n.offset_date',
'end offset_date,',
'n.notify_interval,',
'n.status,',
'n.notify_error,',
'n.email_from,',
'n.email_address,',
'n.created_by,',
'n.created_on,',
'case when :flow_security_group_id!=10 and i.flow_id between 4000 and 4999 then',
'  null',
'else',
'  ''f?p=4000:1:''||:app_session||''::NO:RP:FB_FLOW_ID,F4000_P1_FLOW:''||i.flow_id||'',''||i.flow_id',
'end application_link,',
'case when :flow_security_group_id!=10 and i.flow_id between 4000 and 4999 then',
'  null',
'else',
'  ''f?p=4000:4150:''||:app_session||''::NO::FB_FLOW_ID,FB_FLOW_PAGE_ID:''||i.flow_id||'',''||i.page_id',
'end page_link,',
'case when :flow_security_group_id!=10 and i.flow_id between 4000 and 4999 then',
'  null',
'else',
'  ''f?p=4000:4651:''||:app_session||'':::4651,960,420,601:FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_P4651_ID:''||i.flow_id||'',''||i.page_id||'',''||i.region_id',
'end region_link',
'from wwv_flow_worksheet_notify n,',
'wwv_flow_worksheets i,',
'wwv_flow_worksheet_rpts r,',
'(select ',
'       wwv_flow_lang.system_message(''F4000.YES'') m_yes,',
'       wwv_flow_lang.system_message(''F4000.NO'') m_no,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_ORIENTATION_VERTICAL'') m_vertical,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_ORIENTATION_HORIZONTAL'') m_horizontal,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_A3'') m_a3,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_A4'') m_a4,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_LEGAL'') m_legal,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_LETTER'') m_letter,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_CUSTOM'') m_custom,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_TABLOID'') m_tabloid',
'from dual) m',
'where n.worksheet_id = i.id',
'and n.report_id = r.id',
'and n.websheet_id is null',
'and i.flow_id not in (select id from wwv_flows where build_status = ''RUN_AND_HIDDEN'' and security_group_id=i.security_group_id)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(274054523343299775.4052)
,p_name=>'Interactive Report Subscriptions'
,p_max_row_count=>'100000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de #MAX_ROW_COUNT# lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:EMAIL'
,p_enable_mail_download=>'N'
,p_owner=>'CBCHO'
,p_internal_uid=>274054523343299775
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(274054732028299777.4052)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(274054819621299777.4052)
,p_db_column_name=>'NFLOW_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(274054901224299778.4052)
,p_db_column_name=>'NPAGE_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(274055025754299778.4052)
,p_db_column_name=>'NREGION_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('ID de r\00E9gion')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(274055118775299778.4052)
,p_db_column_name=>'REGION_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('R\00E9gion')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(274055229007299778.4052)
,p_db_column_name=>'APPLICATION_USER'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Abonn\00E9 par')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(274055301825299778.4052)
,p_db_column_name=>'LANGUAGE'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Langue'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(274055406365299778.4052)
,p_db_column_name=>'START_DATE'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>unistr('Date de d\00E9but')
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(274055514662299778.4052)
,p_db_column_name=>'END_DATE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Date de fin'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(274055626342299778.4052)
,p_db_column_name=>'OFFSET_DATE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Date de d\00E9calage')
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(274055724675299778.4052)
,p_db_column_name=>'NOTIFY_INTERVAL'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>unistr('Fr\00E9quence')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(274103227902682659)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(274055809517299778.4052)
,p_db_column_name=>'STATUS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Statut'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(294656516286709966)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(274055924639299779.4052)
,p_db_column_name=>'NOTIFY_ERROR'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Message d''erreur'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(274056003214299779.4052)
,p_db_column_name=>'EMAIL_FROM'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>unistr('Exp\00E9diteur du courriel')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(274056114231299779.4052)
,p_db_column_name=>'EMAIL_ADDRESS'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Destinataire du courriel'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(274056200590299779.4052)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>unistr('Cr\00E9ation par')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(274056325676299779.4052)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>unistr('Cr\00E9\00E9')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(274056415876299779.4052)
,p_db_column_name=>'APPLICATION_LINK'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Lien d''application'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(274056507071299779.4052)
,p_db_column_name=>'PAGE_LINK'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Lien de page'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(274056623165299779.4052)
,p_db_column_name=>'REGION_LINK'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>unistr('Lien de r\00E9gion')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(274100414545640594.4052)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3802595409307223.4052)
,p_db_column_name=>'DOWNLOAD_FORMAT'
,p_display_order=>31
,p_column_identifier=>'V'
,p_column_label=>'Format'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3802651518307224.4052)
,p_db_column_name=>'STRIP_RICH_TEXT'
,p_display_order=>41
,p_column_identifier=>'W'
,p_column_label=>'Enlever le texte enrichi'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3802744628307225.4052)
,p_db_column_name=>'DATA_ONLY'
,p_display_order=>51
,p_column_identifier=>'X'
,p_column_label=>unistr('Donn\00E9es uniquement')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3802814708307226.4052)
,p_db_column_name=>'PDF_PAGE_SIZE'
,p_display_order=>61
,p_column_identifier=>'Y'
,p_column_label=>'Taille de page PDF'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3802904468307227.4052)
,p_db_column_name=>'PDF_PAGE_ORIENTATION'
,p_display_order=>71
,p_column_identifier=>'Z'
,p_column_label=>'Orientation de page PDF'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3803077226307228.4052)
,p_db_column_name=>'PDF_ACCESSIBLE'
,p_display_order=>81
,p_column_identifier=>'AA'
,p_column_label=>'Accessible au format PDF'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(4162727686589922.4052)
,p_db_column_name=>'SKIP_NO_DATA_FOUND'
,p_display_order=>91
,p_column_identifier=>'AB'
,p_column_label=>unistr('Ignorer si aucune donn\00E9e trouv\00E9e')
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1199225378493189312.4052)
,p_plug_name=>'Abonnements'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>unistr('Cet \00E9tat affiche les abonnements cr\00E9\00E9s par les utilisateurs finals \00E0 l''aide d''\00E9tats interactifs dans l''instance. Les abonnements peuvent \00EAtre supprim\00E9s.')
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(274096506831583379.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(274054417366299775.4052)
,p_button_name=>'RESET_REPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:129:&SESSION.::&DEBUG.:129,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(274100010016611306.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(274054417366299775.4052)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Supprimer ce qui est coch\00E9')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(274118217644806344.4052)
,p_branch_action=>'f?p=&APP_ID.:129:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(274100010016611306.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(274117516362791706.4052)
,p_validation_name=>'must select subscription to delete'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count = 0 then',
'  return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Pour supprimer l''abonnement, vous devez le s\00E9lectionner.')
,p_when_button_pressed=>wwv_flow_api.id(274100010016611306.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1199174726823878423.4052)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(274054417366299775.4052)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1199174894473878424.4052)
,p_event_id=>wwv_flow_api.id(1199174726823878423.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(274117809866800453.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_delete_list varchar2(32767);',
'begin',
'    l_delete_list := wwv_flow_utilities.table_to_string(wwv_flow.g_f01);',
'    -- loop through hidden subscription id, if found in delete list, delete',
'    for i in 1..wwv_flow.g_f02.count',
'    loop',
'        if instr(l_delete_list,wwv_flow.g_f02(i),1) > 0 then',
'            wwv_flow_worksheet_api.delete_subscription (',
'                p_subscription_id     => wwv_flow.g_f02(i),',
'                p_security_group_id   => wwv_flow.g_f03(i));',
'        end if;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible d''enlever l''abonnement.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(274100010016611306.4052)
,p_process_success_message=>unistr('Abonnements enlev\00E9s.')
);
end;
/
prompt --application/pages/page_00130
begin
wwv_flow_api.create_page(
 p_id=>130.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('S\00E9curit\00E9')
,p_step_title=>unistr('S\00E9curit\00E9')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216766702444596508)
,p_step_template=>wwv_flow_api.id(704456563630760825.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_config_sec.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15278408311776983.4052)
,p_plug_name=>unistr('D\00E9lai d''expiration de session')
,p_region_name=>'sessiontimeout'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19444600150915683.4052)
,p_plug_name=>'Protocole HTTP'
,p_region_name=>'HTTPS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Avertissement :</strong>',
'<em>Exiger HTTPS</em> rend &PRODUCT_NAME. inaccessible via le protocole HTTP.',
unistr('Avant d''activer ce param\00E8tre, assurez-vous que le protocole HTTPS est activ\00E9 et configur\00E9 correctement sur votre serveur.')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46267619456679028.4052)
,p_plug_name=>unistr('S\00E9lecteur d''affichage de r\00E9gion')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(195775112470763477.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47633503888931997.4052)
,p_plug_name=>unistr('S\00E9curit\00E9')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47634100990931998.4052)
,p_plug_name=>unistr('S\00E9curit\00E9')
,p_region_name=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Configurez les param\00E8tres de s\00E9curit\00E9 de niveau de service g\00E9n\00E9ralement utilis\00E9s pour verrouiller un service de production.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47634329213931998.4052)
,p_plug_name=>unistr('Strat\00E9gie de mot de passe')
,p_region_name=>'P'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>170
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>G\00E9rez la strat\00E9gie de mot de passe pour les utilisateurs de &PRODUCT_NAME. (administrateurs, d\00E9veloppeurs et utilisateurs finals d''espace de travail) dans tous les espaces de travail.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(73979710971500445.4052)
,p_plug_name=>'Start Div'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_source=>'<div id="ContentArea" style="display:none;">'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(73979900344500446.4052)
,p_plug_name=>'End Div'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>180
,p_plug_source=>'</div>'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(91386804125361972.4052)
,p_plug_name=>unistr('Domaines exclus de r\00E9gion et de service Web')
,p_region_name=>'U'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(125782409759878809.4052)
,p_plug_name=>'Real Application Security'
,p_region_name=>'RAS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_required_role=>wwv_flow_api.id(125787708037171062)
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(495347036629866231.4052)
,p_plug_name=>unistr('Contr\00F4le d''authentification')
,p_region_name=>'LOGIN'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16335907971250620.4052)
,p_plug_name=>unistr('Param\00E8tres g\00E9n\00E9raux')
,p_region_name=>'SETTINGS'
,p_parent_plug_id=>wwv_flow_api.id(495347036629866231.4052)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>150
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>G\00E9rez les param\00E8tres de s\00E9curit\00E9 pour la connexion des d\00E9veloppeurs et des utilisateurs finals.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47634507195931998.4052)
,p_plug_name=>unistr('Param\00E8tres d''environnement de d\00E9veloppement')
,p_region_name=>'G'
,p_parent_plug_id=>wwv_flow_api.id(495347036629866231.4052)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>160
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('G\00E9rez les param\00E8tres de s\00E9curit\00E9 pour les comptes d''administrateur d''espace de travail et de d\00E9veloppeur d''espace de travail.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(155891929306865755.4052)
,p_name=>unistr('Mod\00E8les d''authentification d''environnement de d\00E9veloppement')
,p_parent_plug_id=>wwv_flow_api.id(495347036629866231.4052)
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>170
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.id,',
'       trunc(a.id) base_id,',
'       a.name,',
'       help_text description,',
'       case master.scheme_type',
'         when a.scheme_type then consts.is_current',
'         else consts.not_current',
'       end is_current',
'  from wwv_flow_authentications a,',
'       ( select master.id,',
'                master.flow_id,',
'                master.scheme_type',
'           from wwv_flow_authentications master,',
'                wwv_flows f',
'          where f.security_group_id      = 10',
'            and master.id                = f.authentication_id',
'            and master.security_group_id = f.security_group_id ) master,',
'       ( select wwv_flow_lang.system_message(''CURRENT'') is_current,',
'                wwv_flow_lang.system_message(''NOT_CURRENT'') not_current,',
'                nvl(wwv_flow_lang.get_translated_application_id, 4050) translated_flow_id',
'           from sys.dual ) consts',
' where a.security_group_id = 10',
'   and a.flow_id           = consts.translated_flow_id',
'   and a.flow_id           = master.flow_id',
'   and a.id                <> master.id',
'   and a.scheme_type       not like ''%CLOUD_IDM''',
'   and ( a.scheme_type not like ''%.SSO''',
'         or exists ( select null',
'                       from sys.user_objects',
'                      where object_type = ''PACKAGE''',
'                        and object_name = ''WWV_FLOW_CUSTOM_AUTH_SSO'' ))',
'   and ( a.scheme_type not like ''%.SAML''',
'         or (select wwv_flow_public_key_util.is_supported_yn from sys.dual)=''Y'' )',
' order by a.name'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e')
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(155892215448865778.4052)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'<span class="u-VisuallyHidden">Modifier</span>'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:136:&SESSION.::&DEBUG.::P136_ID:#ID#'
,p_column_linktext=>'<span class="a-Icon icon-edit"></span>'
,p_column_link_attr=>'class="a-Button"'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(155892315338865782.4052)
,p_query_column_id=>2
,p_column_alias=>'BASE_ID'
,p_column_display_sequence=>2
,p_column_heading=>'BASE_ID'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(155892418427865782.4052)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nom'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(155892520999865782.4052)
,p_query_column_id=>4
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>4
,p_column_heading=>'Description'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(155896407785993308.4052)
,p_query_column_id=>5
,p_column_alias=>'IS_CURRENT'
,p_column_display_sequence=>5
,p_column_heading=>'Statut'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(517218991177696240.4052)
,p_plug_name=>'Isolement d''espace de travail'
,p_region_name=>'Q'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Configurez les valeurs par d\00E9faut de limitation de ressources et d''isolement pour tous les espaces de travail.'),
unistr('Remplacez ces valeurs par d\00E9faut au niveau de l''espace de travail.')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(617449319814764841.4052)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>G\00E9rez les param\00E8tres applicables \00E0 l''int\00E9gralit\00E9 de l''instance &PRODUCT_NAME..</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(799822118800262985.4052)
,p_plug_name=>'Security Second Level Tabs'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_list_id=>wwv_flow_api.id(799821322334262935.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(169533626431592276.4052)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47636632210932000.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47633503888931997.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47636805241932002.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47633503888931997.4052)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(168522406143945325.4052)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1405441760336501.4052)
,p_name=>'P130_SESSION_TIMEOUT_WARN_SEC'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(15278408311776983.4052)
,p_prompt=>'Avertissement d''expiration de session en secondes'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS_SMALL'
,p_lov=>'.'||wwv_flow_api.id(1501535454230180.4052)||'.'
,p_cSize=>6
,p_cMaxlength=>6
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le d\00E9lai d''avertissement d''expiration de session d\00E9finit (en secondes) combien de temps avant l''expiration de la session (dur\00E9e maximale de session ou d\00E9lai d''inactivit\00E9 maximal de la session) l''utilisateur en est averti. Pour l''avertissement de d')
||unistr('\00E9lai d''inactivit\00E9 maximal de la session, l''utilisateur pourra prolonger la session. Pour l''avertissement de dur\00E9e maximale de session, l''utilisateur sera invit\00E9 \00E0 enregistrer son travail pour \00E9viter de perdre des donn\00E9es lorsque la dur\00E9e maximale de ')
||unistr('session sera \00E9coul\00E9e.</p>'),
unistr('<p>Remarque : ce param\00E8tre est remplac\00E9 par le param\00E8tre de niveau espace de travail et le param\00E8tre de niveau application correspondants.</p>'),
'<p>',
'<ul>',
unistr('    <li>Saisissez un entier positif pour contr\00F4ler le d\00E9lai d''avertissement d''expiration des sessions utilis\00E9es par cette application dans cette instance &PRODUCT_NAME..</li>'),
unistr('    <li>Saisissez 0 pour d\00E9sactiver les avertissements d''expiration de session.</li>'),
unistr('    <li>Laissez la valeur vide pour r\00E9tablir la valeur par d\00E9faut de 5 minutes (300 secondes).</li>'),
'</ul>  ',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13778107968094341.4052)
,p_name=>'P130_INSTANCE_PROXY'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(47634100990931998.4052)
,p_prompt=>'Proxy de l''instance'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>unistr('Pour exiger que l''ensemble du trafic HTTP(S) sortant issu d''une instance &PRODUCT_NAME. utilise un serveur proxy sp\00E9cifique, entrez l''adresse et le port du serveur proxy dans ce champ. Par exemple, <code>www-proxy.example.com:80</code>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13778824721108564.4052)
,p_name=>'P130_OUTBOUND_HTTPS'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_api.id(19444600150915683.4052)
,p_item_default=>'N'
,p_prompt=>'Exiger le trafic HTTPS sortant'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>unistr('S\00E9lectionnez <strong>Oui</strong> pour exiger que l''ensemble du trafic sortant issu d''une instance &PRODUCT_NAME. utilise le protocole HTTPS.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15060228156098057.4052)
,p_name=>'P130_MAX_SESSION_LENGTH_SEC'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(15278408311776983.4052)
,p_prompt=>unistr('Dur\00E9e maximale de session en secondes')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS'
,p_lov=>'.'||wwv_flow_api.id(15314811390892155.4052)||'.'
,p_cSize=>6
,p_cMaxlength=>6
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('D\00E9finit la dur\00E9e (en secondes) pendant laquelle les sessions peuvent exister et \00EAtre utilis\00E9es par des applications dans cette instance &PRODUCT_NAME.. Ce param\00E8tre est remplac\00E9'),
unistr('par le param\00E8tre de niveau espace de travail et le param\00E8tre de niveau application correspondants.'),
'',
'<ul>',
unistr('    <li>Saisissez un entier positif pour contr\00F4ler la dur\00E9e d''existence d''une session.</li>'),
unistr('    <li>Saisissez 0 pour que les sessions existent ind\00E9finiment.</li>'),
unistr('    <li>Laissez la valeur vide pour r\00E9tablir la valeur par d\00E9faut de 8 heures (28 800 secondes).</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15060417898104569.4052)
,p_name=>'P130_MAX_SESSION_IDLE_SEC'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(15278408311776983.4052)
,p_prompt=>unistr('Temps total d''inactivit\00E9 de session en secondes')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS'
,p_lov=>'.'||wwv_flow_api.id(15314811390892155.4052)||'.'
,p_cSize=>6
,p_cMaxlength=>6
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Le temps d''inactivit\00E9 de session est la dur\00E9e entre la derni\00E8re demande de page et la demande de page suivante. Ce param\00E8tre est remplac\00E9 par le param\00E8tre de niveau espace de travail et le param\00E8tre de niveau application correspondants.'),
'',
'<ul>',
unistr('    <li>Saisissez un entier positif pour contr\00F4ler le temps d''inactivit\00E9 par d\00E9faut des sessions utilis\00E9es par les applications dans cette instance &PRODUCT_NAME..</li>'),
unistr('    <li>Laissez la valeur vide pour r\00E9tablir la valeur par d\00E9faut d''1 heure (3 600 secondes).</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16337406502269055.4052)
,p_name=>'P130_LOGIN_THROTTLE_DELAY'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(16335907971250620.4052)
,p_prompt=>unistr('D\00E9lai apr\00E8s les tentatives de connexion ayant \00E9chou\00E9 en secondes')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Apr\00E8s plusieurs \00E9checs de connexion, &PRODUCT_NAME. affichera le d\00E9compte du nombre de tentatives de connexion ayant \00E9chou\00E9 avant d''accepter de nouvelles tentatives de connexion avec le m\00EAme nom utilisateur.'),
'<p/>',
unistr('Saisissez 0 pour d\00E9sactiver le d\00E9compte et autoriser l''acc\00E8s imm\00E9diat.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_02=>'99'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18969210051656230.4052)
,p_name=>'P130_REQUIRE_HTTPS'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(19444600150915683.4052)
,p_item_default=>'N'
,p_prompt=>'Exiger HTTPS'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRE_HTTPS'
,p_lov=>'.'||wwv_flow_api.id(403484377450328143.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Les options sont les suivantes :',
'<ul>',
unistr('<li><strong>Toujours :</strong> permet d''imposer le protocole HTTPS pour toutes les applications (y compris les applications de d\00E9veloppement et d''administration &PRODUCT_NAME.) afin qu''elles exigent HTTPS.'),
unistr('Si cette option est d\00E9finie sur Toujours, l''attribut Dur\00E9e maximale de Strict-Transport-Security est affich\00E9. Utilisez ce champ pour indiquer la dur\00E9e en secondes pendant laquelle le navigateur doit acc\00E9der au serveur uniquement avec HTTPS.</li>'),
unistr('<li><strong>D\00E9veloppement et administration :</strong> permet de forcer toutes les applications contenues dans &PRODUCT_NAME. (c''est-\00E0-dire, App Builder, SQL Workshop, l''administration d''instance, etc.) \00E0 exiger HTTPS.</li>'),
unistr('<li><strong>Pour une application sp\00E9cifique :</strong>rend l''utilisation du protocole HTTPS d\00E9pendante de l''attribut de cookie de session "S\00E9curis\00E9" dans les mod\00E8les d''authentification de vos applications.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21799626940198644.4052)
,p_name=>'P130_ALLOW_PUBLIC_FILE_UPLOAD'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(47634100990931998.4052)
,p_item_default=>'N'
,p_prompt=>unistr('Autoriser le t\00E9l\00E9chargement de fichiers publics')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez <strong>Oui</strong> pour autoriser les utilisateurs non authentifi\00E9s \00E0 t\00E9l\00E9charger des fichiers dans les applications qui fournissent des contr\00F4les de t\00E9l\00E9chargement de fichiers. S\00E9lectionnez <strong>Non</strong> pour emp\00EAcher les utili')
||unistr('sateurs non authentifi\00E9s de t\00E9l\00E9charger des fichiers dans ce type d''application.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47637030913932004.4052)
,p_name=>'P130_WORKSPACE_NAME_USR_COOKIE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(47634100990931998.4052)
,p_item_default=>'Y'
,p_prompt=>unistr('D\00E9finir le cookie d''espace de travail')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('S\00E9lectionnez <strong>Oui</strong> pour autoriser &PRODUCT_NAME. \00E0 enregistrer des cookies persistants dans le navigateur.'),
unistr('S\00E9lectionnez <strong>Non</strong> pour emp\00EAcher l''envoi de cookies persistants.'),
'</p>',
'<p>',
'&PRODUCT_NAME. utilise les cookies persistants suivants :',
'<ul>',
unistr('<li>ORA_WWV_REMEMBER_UN : la page de connexion de l''environnement de d\00E9veloppement stocke les donn\00E9es relatives \00E0 l''espace de travail et au nom utilisateur dans ce cookie. Il est utilis\00E9 pour remplir ces attributs avec des valeurs par d\00E9faut, lorsque')
||' vous vous reconnectez.</li>        ',
unistr('<li>LOGIN_USERNAME_COOKIE : les pages de connexion d''application client utilisent ce cookie pour stocker le nom utilisateur. Il est utilis\00E9 pour remplir l''attribut avec une valeur par d\00E9faut, lorsque les clients se reconnectent.</li>    '),
unistr('<li>ORA_WWV_REMEMBER_LANG : lors de l''utilisation de la s\00E9lection de langue dans l''environnement de d\00E9veloppement et les feuilles de calcul, &PRODUCT_NAME. stocke la langue et le territoire dans ce cookie. Il est utilis\00E9 pour afficher automatiquement')
||unistr(' l''application dans la langue s\00E9lectionn\00E9e lors de votre prochaine utilisation de l''application.</li>'),
'</ul>',
'</p>',
'<p>',
unistr('Si votre ordinateur a d\00E9j\00E0 re\00E7u ces cookies, vous pouvez les enlever physiquement de leur emplacement persistant sur le disque \00E0 l''aide d''outils de navigateur ou d''utilitaires syst\00E8me. '),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47646415366932012.4052)
,p_name=>'P130_DISABLE_ADMIN_LOGIN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(47634100990931998.4052)
,p_item_default=>'N'
,p_prompt=>unistr('D\00E9sactiver la connexion administrateur')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez <strong>Oui</strong> pour restreindre l''acc\00E8s des utilisateurs \00E0 &PRODUCT_NAME. en d\00E9sactivant la connexion administrateur. D\00E9sactiver la connexion administrateur dans les environnements de production permet d''emp\00EAcher les utilisateurs n')
||unistr('on autoris\00E9s de se connecter aux services d''administration de &PRODUCT_NAME. et d''intervenir sur les informations d''identification des utilisateurs.'),
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47646911123932013.4052)
,p_name=>'P130_RESTRICT_IP_RANGE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(47634100990931998.4052)
,p_prompt=>unistr('Restreindre l''acc\00E8s par adresse IP')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Pour n''autoriser l''acc\00E8s aux services d''administration et \00E0 l''environnement de d\00E9veloppement de &PRODUCT_NAME. qu''\00E0 une plage sp\00E9cifique d''adresses IP, saisissez la liste de ces adresses, s\00E9par\00E9es par des virgules.'),
unistr('<p>Si n\00E9cessaire, vous pouvez utiliser le caract\00E8re g\00E9n\00E9rique ast\00E9risque (*), \00E0 condition de ne pas le faire suivre de valeurs num\00E9riques. Par exemple, 138.*.41.2 <i>n''est pas</i> une valeur valide. '),
unistr('<p>Les adresses IP indiqu\00E9es peuvent comporter entre 1 et 4 niveaux. Exemples : '),
'<ul>',
'<li>141, 141.*</li>',
'<li>192.128.23.1</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47647419618932013.4052)
,p_name=>'P130_DISABLE_WORKSPACE_LOGIN'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(47634100990931998.4052)
,p_item_default=>'N'
,p_prompt=>unistr('D\00E9sactiver la connexion \00E0 l''espace de travail')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez <strong>Oui</strong> pour restreindre l''acc\00E8s des utilisateurs \00E0 &PRODUCT_NAME. en d\00E9sactivant la connexion \00E0 l''espace de travail. D\00E9sactiver la connexion \00E0 l''espace de travail dans les environnements de production permet d''emp\00EAcher les ')
||unistr('utilisateurs d''ex\00E9cuter des applications &PRODUCT_NAME. comme App Builder.'),
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47647919390932013.4052)
,p_name=>'P130_ACCOUNT_LIFETIME_DAYS'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(47634507195931998.4052)
,p_prompt=>unistr('Dur\00E9e de validit\00E9 du mot de passe de compte (jours)')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez un entier positif pour le nombre maximal de jours d''utilisation d''un mot de passe de compte de d\00E9veloppeur ou administrateur avant expiration du compte. La valeur par d\00E9faut est 45.</p>'),
unistr('</p>Ce param\00E8tre s''applique aux comptes utilis\00E9s pour acc\00E9der \00E0 l''environnement d''administration et de d\00E9veloppement &PRODUCT_NAME. uniquement. Il ne s''applique pas aux comptes de l''utilisateur final utilis\00E9s par les applications d\00E9velopp\00E9es dans &PR')
||'ODUCT_NAME..</p>',
unistr('</p>Ce param\00E8tre est toutefois utilis\00E9 comme pr\00E9f\00E9rence <strong>Dur\00E9e de validit\00E9 des comptes utilisateur final</strong> de niveau espace de travail par d\00E9faut, que les administrateurs d''espace de travail peuvent modifier. La pr\00E9f\00E9rence de niveau esp')
||'ace de travail s''applique aux comptes d''utilisateur final figurant dans l''espace de travail en question.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47649932493932015.4052)
,p_name=>'P130_USER_MAX_LOGIN_FAILURES'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(47634507195931998.4052)
,p_prompt=>unistr('Nombre maximum d''\00E9checs de connexion autoris\00E9')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>5
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez un entier positif pour le nombre maximal de tentatives d''authentification infructueuses cons\00E9cutives'),
unistr('autoris\00E9es avant que le compte de d\00E9veloppeur ou administrateur ne soit verrouill\00E9. La valeur par d\00E9faut est 4.</p>'),
'',
unistr('<p>Ce param\00E8tre s''applique aux comptes utilis\00E9s pour acc\00E9der \00E0 l''environnement de d\00E9veloppement et d''administration &PRODUCT_NAME.'),
unistr('uniquement. Il ne s''applique pas aux comptes d''utilisateur final utilis\00E9s par les applications d\00E9velopp\00E9es dans &PRODUCT_NAME..</p>'),
'',
unistr('<p>La valeur saisie est utilis\00E9e comme valeur par d\00E9faut pour la pr\00E9f\00E9rence <strong>Nombre maximum d''\00E9checs de connexion autoris\00E9</strong>'),
unistr('de niveau espace de travail si l''administrateur de l''espace de travail ne sp\00E9cifie aucune valeur. La pr\00E9f\00E9rence est utilis\00E9e'),
'pour les comptes d''utilisateur final de l''espace de travail en question.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47650422637932015.4052)
,p_name=>'P130_EXPIRE_FND_USER_ACCOUNTS'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(47634507195931998.4052)
,p_item_default=>'N'
,p_prompt=>'Demander l''expiration et le verrouillage du compte utilisateur'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Les fonctionnalit\00E9s de verrouillage et d''expiration de compte utilisateur &PRODUCT_NAME. s''appliquent aux comptes d''utilisateur final cr\00E9\00E9s \00E0 l''aide de l''interface de gestion des comptes d''utilisateur final &PRODUCT_NAME..</p>'),
unistr('<p>S\00E9lectionnez <strong>Oui</strong> pour activer les fonctionnalit\00E9s de verrouillage et d''expiration des comptes utilisateur &PRODUCT_NAME. dans tous les espaces de travail. Cette s\00E9lection emp\00EAche de d\00E9sactiver cette m\00EAme fonctionnalit\00E9 au niveau d')
||'e l''espace de travail.</p>',
unistr('<p>S\00E9lectionnez <strong>Non</strong> pour accorder le contr\00F4le \00E0 l''administrateur de chaque espace de travail.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47650925096932015.4052)
,p_name=>'P130_PW_MIN_LENGTH'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(47634329213931998.4052)
,p_prompt=>'Longueur minimum du mot de passe'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>3
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez le nombre minimum de caract\00E8res que doivent comporter les mots de passe des comptes d''administrateur, de d\00E9veloppeur et d''utilisateur final d''espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47651414651932016.4052)
,p_name=>'P130_PW_ONE_NUMERIC'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(47634329213931998.4052)
,p_item_default=>'N'
,p_prompt=>'Doit contenir au moins un chiffre'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_cattributes_element=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez <strong>Oui</strong> pour demander que les mots passe des comptes d''administrateur, de d\00E9veloppeur et d''utilisateur final d''espace de travail contiennent au moins un chiffre arabe (soit 0, 1, 2, 3, 4, 5, 6, 7, 8, 9).')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47651903529932016.4052)
,p_name=>'P130_PW_ALPHA_CHARS'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(47634329213931998.4052)
,p_item_default=>'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ '
,p_prompt=>unistr('Caract\00E8res alphab\00E9tiques')
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>2
,p_cAttributes=>'nowrap="nowrap"'
,p_cattributes_element=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez de nouveaux caract\00E8res alphab\00E9tiques ou modifiez ceux existants. Il s''agit du jeu de caract\00E8res utilis\00E9 dans les validations de mot de passe impliquant des caract\00E8res alphab\00E9tiques. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47652625102932017.4052)
,p_name=>'P130_PW_NOT_LIKE_USERNAME'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(47634329213931998.4052)
,p_item_default=>'N'
,p_prompt=>'Ne doit pas contenir le nom utilisateur'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_cattributes_element=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez <strong>Oui</strong> pour que les mots de passe des comptes d''administrateur, de d\00E9veloppeur et d''utilisateur final d''espace de travail ne puissent pas contenir le nom utilisateur.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47653123193932018.4052)
,p_name=>'P130_PW_ONE_LOWER_CASE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(47634329213931998.4052)
,p_item_default=>'N'
,p_prompt=>'Doit contenir au moins une lettre minuscule'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_cattributes_element=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez <strong>Oui</strong> pour demander que les mots de passe des comptes d''administrateur, de d\00E9veloppeur et d''utilisateur final d''espace de travail contiennent au moins une lettre minuscule.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47653613129932018.4052)
,p_name=>'P130_PW_ONE_ALPHA'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(47634329213931998.4052)
,p_item_default=>'N'
,p_prompt=>'Doit contenir au moins un chiffre'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_cattributes_element=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez <strong>Oui</strong> pour demander que les mots de passe des comptes d''administrateur, de d\00E9veloppeur et d''utilisateur final d''espace de travail contiennent au moins l''une des lettres indiqu\00E9es dans le champ Caract\00E8res alphab\00E9tiques ci-d')
||'essous.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47654118447932018.4052)
,p_name=>'P130_PW_NEW_DIFFERS_BY'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(47634329213931998.4052)
,p_prompt=>unistr('Nombre minimal de diff\00E9rences du mot de passe')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>4
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez le nombre de diff\00E9rences devant exister entre l''ancien et le nouveau mot de passe. Les mots de passe sont compar\00E9s caract\00E8re par caract\00E8re et chaque diff\00E9rence \00E0 une position donn\00E9e est comptabilis\00E9e. '),
unistr('<p>Ce param\00E8tre s''applique aux comptes d''administrateur, de d\00E9veloppeur et d''utilisateur final d''espace de travail. ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47654617743932018.4052)
,p_name=>'P130_PW_ONE_PUNCTUATION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(47634329213931998.4052)
,p_item_default=>'N'
,p_prompt=>'Doit contenir au moins un signe de ponctuation'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_cattributes_element=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez <strong>Oui</strong> pour demander que les mots de passe des comptes d''administrateur, de d\00E9veloppeur et d''utilisateur final d''espace de travail contiennent au moins l''un des signes de ponctuation indiqu\00E9s dans le champ Signes de ponctua')
||'tion ci-dessous.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47655120422932019.4052)
,p_name=>'P130_PW_PUNCTUATION_CHARS'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(47634329213931998.4052)
,p_item_default=>'!"#$%&()``*+,-/:;<=>?_'
,p_prompt=>'Signes de ponctuation'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>25
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_cattributes_element=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez de nouveaux caract\00E8res de ponctuation ou modifiez ceux existants. Il s''agit du jeu de caract\00E8res utilis\00E9 dans les validations de mot de passe impliquant des caract\00E8res de ponctuation.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47655613669932019.4052)
,p_name=>'P130_PW_ONE_UPPER_CASE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(47634329213931998.4052)
,p_item_default=>'N'
,p_prompt=>'Doit contenir au moins une lettre majuscule'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_cattributes_element=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez <strong>Oui</strong> pour demander que les mots de passe des comptes d''administrateur, de d\00E9veloppeur et d''utilisateur final d''espace de travail contiennent au moins une lettre majuscule.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47656132356932019.4052)
,p_name=>'P130_PW_NOT_LIKE_WS_NAME'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(47634329213931998.4052)
,p_item_default=>'N'
,p_prompt=>'Ne doit pas contenir le nom d''espace de travail'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_cattributes_element=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez <strong>Oui</strong> pour que les mots de passe des comptes d''administrateur, de d\00E9veloppeur et d''utilisateur final d''espace de travail ne puissent pas contenir le nom de l''espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47656601012932020.4052)
,p_name=>'P130_PW_NOT_LIKE_WORDS'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(47634329213931998.4052)
,p_item_default=>'oracle:hello:welcome:guest:user:database'
,p_prompt=>'Ne doit pas contenir'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>5
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Saisissez les mots, s\00E9par\00E9s par des deux-points, que les mots de passe des comptes d''administrateur, de d\00E9veloppeur et d''utilisateur final d''espace de travail ne peuvent pas contenir. Ces mots ne doivent pas figurer dans le mot de passe, quelle que s')
||'oit la combinaison majuscule-minuscule. ',
unistr('<p>Cette fonctionnalit\00E9 am\00E9liore la s\00E9curit\00E9 en emp\00EAchant la cr\00E9ation de mots de passe simples et faciles \00E0 deviner, comportant des mots comme "bonjour", "invit\00E9", "bienvenue", etc.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47657120063932020.4052)
,p_name=>'P130_STRONG_SITE_ADMIN_PWD'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(47634329213931998.4052)
,p_item_default=>'N'
,p_prompt=>unistr('Strat\00E9gie de mot de passe d''administrateur de service')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SITE ADMIN PASSWORD OPTION'
,p_lov=>'.'||wwv_flow_api.id(25698924524085246.4052)||'.'
,p_cattributes_element=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez une strat\00E9gie de mot de passe pour les administrateurs de service &PRODUCT_NAME. :<br/>'),
'<ul>',
unistr('<li><strong>Utiliser la strat\00E9gie indiqu\00E9e dans Strat\00E9gie de mot de passe d''espace de travail :</strong> les r\00E8gles de mot de passe indiqu\00E9es plus haut dans Strat\00E9gie de mot de passe d''espace de travail sont appliqu\00E9es aux mots de passe d''administrat')
||'eur de service.</li>',
unistr('<li><strong>Utiliser la strat\00E9gie de mot de passe renforc\00E9 par d\00E9faut :</strong> les mots de passe d''administrateur de service sont soumis aux restrictions suivantes :</li>'),
'<ul>',
unistr('<li>ils doivent comporter au moins six caract\00E8res</li>'),
'<li>ils doivent contenir au moins une lettre minuscule, une lettre majuscule, un chiffre et un signe de ponctuation</li>',
'<li>ils ne doivent pas contenir le nom utilisateur</li>',
'<li>ils ne doivent pas contenir le mot "internal"</li>',
unistr('<li>ils ne doivent contenir aucun des mots figurant dans le champ Ne doit pas contenir ci-dessus, dans Strat\00E9gie de mot de passe d''espace de travail</li>'),
'</ul>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(91387829059369221.4052)
,p_name=>'P130_BAD_URLS'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(91386804125361972.4052)
,p_prompt=>'Le domaine ne doit pas contenir'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez les domaines (sans le port), s\00E9par\00E9s par des deux-points, qui ne doivent pas \00EAtre autoris\00E9s dans des r\00E9gions de type URL ou exploit\00E9s en tant que services Web. Par exemple :'),
'<pre>example1.com:example2.com:example3.com</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(125785225487919808.4052)
,p_name=>'P130_ALLOW_RAS'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_api.id(125782409759878809.4052)
,p_item_default=>'N'
,p_prompt=>'Autoriser Real Application Security'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez <strong>Oui</strong> pour activer la prise en charge de Real Application Security pour les applications.'),
unistr('Si Real Application Security est configur\00E9 dans le mod\00E8le d''authentification d''une application,'),
unistr('&PRODUCT_NAME. cr\00E9e une session Real Application Security pour une nouvelle session &PRODUCT_NAME. et l''y associe'),
'automatiquement.',
'<p/>',
unistr('S\00E9lectionnez <strong>Non</strong> pour d\00E9sactiver Real Application Security.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(182544230023543041.4052)
,p_name=>'P130_BUILDER_AUTH'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(47634507195931998.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Mod\00E8le d''authentification d''espace de travail en cours')
,p_source=>'wwv_flow_authentication_dev.get_internal_scheme_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ACCESSIBILITY_MODE'
,p_lov=>'.'||wwv_flow_api.id(1141279207071321310.4052)||'.'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_protection_level=>'I'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Mod\00E8le d''authentification en cours pour les services d''administration &PRODUCT_NAME. et l''environnement de d\00E9veloppement &PRODUCT_NAME..'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(182581525998551347.4052)
,p_name=>'P130_SSO_LOGOUT_URL'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_api.id(16335907971250620.4052)
,p_prompt=>unistr('URL de d\00E9connexion SSO')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Entrez l''URL vers laquelle &PRODUCT_NAME. effectue un r\00E9acheminement afin de d\00E9clencher la d\00E9connexion du serveur Single Sign-On.'),
'&PRODUCT_NAME. ajoute automatiquement "?p_done_url=...login url...".',
'</p>',
'<p>Exemple :</p>',
'<pre>https://login.example.com/pls/orasso/orasso.wwsso_app_admin.ls_logout</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(244018932039989237.4052)
,p_name=>'P130_LOGIN_THROTTLE_METHODS'
,p_is_required=>true
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(16335907971250620.4052)
,p_prompt=>unistr('M\00E9thode de calcul du d\00E9lai')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LOGIN THROTTLE METHODS'
,p_lov=>'.'||wwv_flow_api.id(244019724554013154.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('S\00E9lectionnez une m\00E9thode de calcul de d\00E9lai pour les \00E9checs de connexion.'),
unistr('Les m\00E9thodes de calcul sont bas\00E9es sur les donn\00E9es r\00E9centes du journal des connexions \00E0 Access.'),
'</p>',
'',
'<ul>',
'<li><em>Nom utilisateur et adresse IP client</em>:',
unistr('Nombre de tentatives de connexion ayant \00E9chou\00E9 du m\00EAme utilisateur et de la m\00EAme adresse IP client.'),
unistr('Cette m\00E9thode peut emp\00EAcher de deviner le mot de passe du m\00EAme nom utilisateur provenant du m\00EAme client.'),
unistr('Il s''agit de la m\00E9thode la moins restrictive.'),
'</li>',
'',
'<li><em>Nom utilisateur</em>:',
unistr('Nombre de tentatives de connexion ayant \00E9chou\00E9 du m\00EAme utilisateur, quelle que soit l''adresse IP client.'),
unistr('Cette m\00E9thode peut emp\00EAcher de deviner le mot de passe du m\00EAme nom utilisateur, quel que soit le client.'),
'</li>',
'',
'<li><em>Adresse IP client</em>:',
unistr('Nombre de tentatives de connexion ayant \00E9chou\00E9 \00E0 partir de la m\00EAme adresse IP client, quel que soit le nom utilisateur.'),
unistr('Cette m\00E9thode peut emp\00EAcher de deviner le mot de passe de noms d''utilisateur diff\00E9rents provenant du m\00EAme client.'),
'</li>',
'',
'<li><em>Nom utilisateur ou adresse IP client</em>:',
unistr('Calcule \00E0 la fois le nombre de tentatives de connexion ayant \00E9chou\00E9 par <em>nom utilisateur</em> et par <em>adresse IP client</em>,'),
'puis prend la valeur maximale.',
unistr('Il s''agit de la m\00E9thode la plus restrictive.'),
'</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(245896310903818453.4052)
,p_name=>'P130_INBOUND_PROXIES'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(16335907971250620.4052)
,p_prompt=>'Serveurs proxy entrants'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez une liste d''adresses IP s\00E9par\00E9es par des virgules pour les serveurs proxy connus, desquels proviennent les demandes.'),
unistr('&PRODUCT_NAME. utilise cette liste pour calculer l''adresse client r\00E9elle \00E0 partir des en-t\00EAtes HTTP <em>X-Forwarded-For</em> et <em>REMOTE_ADDR</em>.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(366798407533246711.4052)
,p_name=>'P130_PASSWORD_HASH_FUNCTION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(47634329213931998.4052)
,p_prompt=>'Fonction de hachage de mot de passe'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'HASH_FUNCTION'
,p_lov=>'.'||wwv_flow_api.id(366796514610241309.4052)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('Le plus s\00E9curis\00E9')
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez une fonction de hachage utilis\00E9e par &PRODUCT_NAME. pour g\00E9n\00E9rer des cha\00EEnes de hachage unidirectionnelles pour les mots de passe utilisateur d''espace de travail.'),
'<p/>',
unistr('Les algorithmes <strong>SHA-2</strong> sont pris en charge uniquement dans la version RDBMS 12c ou sup\00E9rieure.'),
unistr('Le param\00E8tre <strong>Le plus s\00E9curis\00E9</strong> s\00E9lectionne automatiquement l''algorithme le plus s\00E9curis\00E9 disponible ; il s''agit du param\00E8tre recommand\00E9.'),
unistr('Dans la version 12c ou sup\00E9rieure, il renvoie la valeur <strong>SHA-2, 512 bits</strong> et dans la version 11g,'),
unistr('<strong>SHA-1</strong> est l''algorithme le plus s\00E9curis\00E9.'),
unistr('L''algorithme <strong>MD5</strong> est obsol\00E8te et ne doit plus \00EAtre utilis\00E9.'),
'<p/>',
unistr('Si vous devez exporter des utilisateurs d''espace de travail dans la version 12c et les importer dans une base de donn\00E9es 11g,'),
unistr('ce param\00E8tre doit \00EAtre abaiss\00E9 \00E0 <strong>SHA-1</strong>.'),
unistr('Sinon, les valeurs de hachage ne peuvent pas \00EAtre v\00E9rifi\00E9es dans la version 11g.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(367947311075071643.4052)
,p_name=>'P130_CHECKSUM_HASH_FUNCTION'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(47634100990931998.4052)
,p_prompt=>'Fonction de hachage de checksum'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'HASH_FUNCTION'
,p_lov=>'.'||wwv_flow_api.id(366796514610241309.4052)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('Le plus s\00E9curis\00E9')
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez une fonction de hachage utilis\00E9e par &PRODUCT_NAME. afin de g\00E9n\00E9rer des cha\00EEnes de hachage unidirectionnelles pour les checksums.'),
'<p/>',
unistr('Les algorithmes <strong>SHA-2</strong> sont pris en charge uniquement dans la version Oracle Database 12<em>c</em> ou sup\00E9rieure.'),
unistr('Le param\00E8tre <strong>Le plus s\00E9curis\00E9</strong> s\00E9lectionne automatiquement l''algorithme le plus s\00E9curis\00E9 disponible. Il s''agit du param\00E8tre recommand\00E9 par Oracle.'),
unistr('Dans la version Oracle Database 12<em>c</em> ou sup\00E9rieure, il renvoie la valeur <strong>SHA-2, 512 bits</strong> et dans la version Oracle Database 11<em>c</em>,'),
unistr('<strong>SHA-1</strong> est l''algorithme le plus s\00E9curis\00E9.'),
unistr('L''algorithme <strong>MD5</strong> est obsol\00E8te et ne fait plus partie des recommandations d''Oracle.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(384790103050553247.4052)
,p_name=>'P130_REJOIN_EXISTING_SESSIONS'
,p_is_required=>true
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(47634100990931998.4052)
,p_prompt=>'Rejoindre des sessions'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REJOIN_EXISTING_SESSIONS'
,p_lov=>'.'||wwv_flow_api.id(492748357556507488.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cet attribut pour d\00E9terminer si &PRODUCT_NAME. doit prendre en charge les URL d''application qui ne contiennent pas d''ID de session.'),
'S''il est possible de rejoindre des sessions, &PRODUCT_NAME. tente d''utiliser le cookie de session pour rejoindre une session existante, lorsqu''une URL ne contient pas d''ID de session.',
'</p>',
'<p>Les valeurs possibles sont les suivantes :',
'</p>',
'<ul>',
unistr('    <li><strong>D\00E9sactiv\00E9 :</strong> '),
unistr('      Si l''URL ne contient pas d''ID de session, &PRODUCT_NAME. cr\00E9e une session.'),
'    </li>',
unistr('    <li><strong>Activ\00E9 pour des sessions publiques :</strong> '),
unistr('      Si une URL m\00E8ne \00E0 une page publique et ne contient pas d''ID de session, &PRODUCT_NAME. tente d''utiliser le cookie de session existant d\00E9fini pour cette application.'),
unistr('      Pour les applications avec \00E0 la fois des pages publiques et authentifi\00E9es, un ID de session est d\00E9fini apr\00E8s l''authentification de l''utilisateur final.'),
unistr('      &PRODUCT_NAME. rejoint la session \00E0 l''aide du cookie uniquement si celle-ci n''est pas encore authentifi\00E9e.'),
'    </li>',
unistr('    <li><strong>Activ\00E9 pour toutes les sessions :</strong> '),
unistr('      Si l''URL ne contient pas d''ID de session, &PRODUCT_NAME. tente d''utiliser le cookie de session existant d\00E9fini pour cette application, pourvu que les conditions suivantes soient remplies :'),
'      <ul>',
unistr('        <li>La protection de statut de session est activ\00E9e pour l''application et l''URL comprend un checksum valide.'),
unistr('        Pour les signets publics, le niveau de protection d''\00E9l\00E9ment le plus restrictif doit \00EAtre <em>Non restreint</em> ou <em>Checksum requis - niveau application</em>.</li>'),
unistr('        <li>Ou l''URL ne contient pas de donn\00E9es trait\00E9es (param\00E8tre de demande, effacement de cache ou paires de valeurs de donn\00E9es).</li>'),
'      </ul>',
unistr('      Ce param\00E8tre n\00E9cessite \00E9galement que l''attribut <em>Imbriquer dans les cadres</em> soit d\00E9fini sur <em>Autoriser \00E0 partir de la m\00EAme origine</em> ou sur <em>Refuser</em> pour l''application.'),
'    </li>',
'</ul>',
unistr('<p><em><strong>Remarque :</em></strong> l''autorisation de rejoindre des sessions expose votre application \00E0 des failles de s\00E9curit\00E9 '),
unistr('  en permettant aux individus malveillants de prendre le contr\00F4le des sessions existantes des utilisateurs finals. '),
'Pour plus d''informations, reportez-vous aux sections <em>Rejoin Sessions</em> du chapitre "Managing Application Security" dans le manuel App Builder User''s Guide.',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(402391282626267518.4052)
,p_name=>'P130_HTTP_STS_MAX_AGE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(19444600150915683.4052)
,p_prompt=>unistr('Dur\00E9e maximale de Strict-Transport-Security')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez la p\00E9riode, en secondes, pendant laquelle le navigateur doit acc\00E9der au serveur uniquement avec HTTPS.'),
unistr('Si vous indiquez une valeur sup\00E9rieure \00E0 0,'),
unistr('&PRODUCT_NAME. envoie l''en-t\00EAte HTTP'),
'<pre>',
'  Strict-Transport-Security: max-age=NNN',
'</pre>',
unistr('sur chaque r\00E9ponse, o\00F9 NNN correspond \00E0 la p\00E9riode indiqu\00E9e dans cet attribut.'),
unistr('L''en-t\00EAte signale aux navigateurs qui le prennent en charge que les pages de cet h\00F4te doivent toujours \00EAtre demand\00E9es via HTTPS,'),
unistr('pendant la p\00E9riode indiqu\00E9e.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(402398009003374821.4052)
,p_name=>'P130_HTTP_RESPONSE_HEADERS'
,p_item_sequence=>460
,p_item_plug_id=>wwv_flow_api.id(19444600150915683.4052)
,p_prompt=>unistr('En-t\00EAtes de r\00E9ponse HTTP')
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Saisissez des en-t\00EAtes de r\00E9ponse HTTP suppl\00E9mentaires que &PRODUCT_NAME. doit envoyer sur chaque demande, pour toutes les applications.'),
unistr('Les d\00E9veloppeurs peuvent indiquer des en-t\00EAtes suppl\00E9mentaires au niveau de l''application.'),
unistr('Chaque en-t\00EAte doit commencer sur une nouvelle ligne.'),
unistr('La prise en charge des divers en-t\00EAtes diff\00E8re d''un navigateur \00E0 l''autre.'),
'</p>',
'<p>',
unistr('<code>Content-Security-Policy</code> est un en-t\00EAte de s\00E9curit\00E9 important. L''envoi de cet en-t\00EAte peut consid\00E9rablement r\00E9duire le risque de scriptage inter-site et d''attaques associ\00E9es. Voici un exemple :'),
'<pre>',
'  Content-Security-Policy: default-src ''self'' ''unsafe-inline'' ''unsafe-eval'' #CDN#; object-src ''self''; img-src ''self'' data:;',
'</pre>',
unistr('&PRODUCT_NAME. g\00E9n\00E8re des codes JavaScript et CSS incorpor\00E9s, la valeur de strat\00E9gie doit donc les autoriser. &PRODUCT_NAME. remplace automatiquement la cha\00EEne <code>#CDN#</code> par la liste des r\00E9seaux CDN pris en charge, s\00E9par\00E9s par des espaces.</')
||'p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(517219119539696241.4052)
,p_name=>'P130_ALLOW_HOSTNAMES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(517218991177696240.4052)
,p_prompt=>unistr('Autoriser les noms d''h\00F4te')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>45
,p_cMaxlength=>255
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Saisissez la liste des noms d''h\00F4te, s\00E9par\00E9s par des virgules, qui peuvent \00EAtre utilis\00E9s pour acc\00E9der \00E0 cette instance.'),
unistr('Cet attribut peut \00EAtre utilis\00E9 pour indiquer les alias DNS du serveur Web qui peuvent \00EAtre utilis\00E9s'),
'avec des applications.',
unistr('Vous pouvez configurer des valeurs plus sp\00E9cifiques qui remplacent celle-ci au niveau de l''espace de travail.'),
unistr('Si vous saisissez au moins un nom d''h\00F4te,'),
unistr('la partie nom d''h\00F4te de l''URL de la demande HTTP entrante doit correspondre \00E0 l''un des noms d''h\00F4te r\00E9pertori\00E9s.'),
'</p>',
'<p>',
'Par exemple, vous pouvez inscrire l''alias DNS "hr.example.com" pour votre serveur Web "www.example.com".',
unistr('La valeur d''instance de <em>Noms d''h\00F4te autoris\00E9s</em> peut \00EAtre d\00E9finie sur "www.example.com".'),
unistr('Si vous d\00E9finissez le param\00E8tre <em>Autoriser les noms d''h\00F4te</em>de l''espace de travail HR sur "hr.example.com",'),
unistr('les utilisateurs doivent acc\00E9der aux applications HR via "hr.example.com" et \00E0 toutes les autres applications de'),
'cette instance via "www.example.com".',
unistr('Avec cette configuration, le param\00E8tre <strong>Strat\00E9gie de s\00E9curit\00E9 de m\00EAme origine</strong>'),
unistr('du navigateur fournit une barri\00E8re cot\00E9 client entre les applications HR'),
unistr('et les autres applications de l''instance, qui sont ex\00E9cut\00E9es dans une autre fen\00EAtre ou un autre onglet de navigateur.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(517219667745696245.4052)
,p_name=>'P130_RM_CONSUMER_GROUP'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(517218991177696240.4052)
,p_prompt=>'Groupe de consommateurs de ressources'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'RESOURCE CONSUMER GROUPS (NON  SYSTEM)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select consumer_group d, consumer_group r',
'  from sys.dba_rsrc_consumer_groups',
' where consumer_group not like ''ORA$%''',
'   and consumer_group <> ''SYS_GROUP''',
'order by 1'))
,p_cSize=>45
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez le groupe de consommateurs Database Resource Manager \00E0 utiliser pour tous les \00E9v\00E9nements de page sur l''instance.'),
unistr('Vous pouvez configurer des valeurs plus sp\00E9cifiques qui remplacent celle-ci au niveau de l''espace de travail.'),
unistr('Au d\00E9but de chaque demande, le moteur &PRODUCT_NAME. remplace le groupe de consommateurs de la session de base de donn\00E9es'),
unistr('en cours par le groupe de consommateurs qui est d\00E9fini au niveau de l''espace de travail ou de l''instance.'),
unistr('Ce comportement s''applique \00E0 la fois aux applications en cours d''ex\00E9cution'),
unistr('et aux applications utilis\00E9es dans l''environnement de d\00E9veloppement &PRODUCT_NAME..'),
'',
'<p />',
'',
unistr('Le privil\00E8ge permettant le remplacement du groupe de consommateurs doit \00EAtre accord\00E9 au sch\00E9ma PUBLIC ou &PRODUCT_NAME..'),
unistr('Ce privil\00E8ge est g\00E9n\00E9ralement accord\00E9 \00E0 l''aide de la proc\00E9dure DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(517220102538696246.4052)
,p_name=>'P130_QOS_MAX_WORKSPACE_REQ'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(517218991177696240.4052)
,p_prompt=>unistr('Nombre maximal de demandes d''espace de travail simultan\00E9es')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Saisissez le nombre maximal d''\00E9v\00E9nements de page simultan\00E9s pris en charge par &PRODUCT_NAME. pour toutes les applications.'),
unistr('Vous pouvez configurer une valeur plus sp\00E9cifique au niveau de l''espace de travail.'),
unistr('Au lieu de traiter un \00E9v\00E9nement de page, &PRODUCT_NAME. affiche un message d''erreur lorsque la limite est d\00E9j\00E0 atteinte.'),
'</p>',
'<p>',
'&PRODUCT_NAME. suit les demandes d''espace de travail en interrogeant la colonne CLIENT_INFO de GV$SESSION.',
unistr('Ce suivi ne fonctionnera pas si les d\00E9veloppeurs remplacent CLIENT_INFO, par exemple par un appel \00E0 DBMS_APPLICATION_INFO.SET_CLIENT_INFO.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(517220644490696246.4052)
,p_name=>'P130_QOS_MAX_SESSION_REQUESTS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(517218991177696240.4052)
,p_prompt=>unistr('Nombre maximal de demandes de session simultan\00E9es')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Saisissez le nombre maximal d''\00E9v\00E9nements de page simultan\00E9s pris en charge par &PRODUCT_NAME. pour chaque session des applications de cette instance.'),
unistr('Vous pouvez configurer une valeur plus sp\00E9cifique au niveau de l''espace de travail.'),
unistr('Au lieu de traiter un nouvel \00E9v\00E9nement de page, &PRODUCT_NAME. affiche un message d''erreur lorsque la limite est d\00E9j\00E0 atteinte.'),
unistr('Vous pouvez \00E9galement utiliser l''attribut D\00E9lai de fermeture des demandes de session simultan\00E9es pour fermer une session de base de donn\00E9es active, afin de traiter le nouvel \00E9v\00E9nement de page.'),
'</p>',
'<p>',
'&PRODUCT_NAME. suit les demandes de session en interrogeant la colonne CLIENT_IDENTIFIER de GV$SESSION.',
unistr('Ce suivi ne fonctionnera pas si les d\00E9veloppeurs remplacent CLIENT_IDENTIFIER, par exemple par un appel \00E0 DBMS_SESSION.SET_IDENTIFIER.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(517221174023696247.4052)
,p_name=>'P130_QOS_MAX_SESSION_KILL_TO'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(517218991177696240.4052)
,p_prompt=>unistr('D\00E9lai de fermeture des demandes de session simultan\00E9es')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('En cas de survenue d''un nouvel \00E9v\00E9nement de page situ\00E9 en dehors des limites du param\00E8tre Nombre maximal de demandes de session simultan\00E9es, &PRODUCT_NAME. peut ex\00E9cuter <code>alter system kill session</code> sur la session de base de donn\00E9es active ')
||unistr('la plus ancienne qui traite un autre \00E9v\00E9nement de page pour cette session &PRODUCT_NAME.. L''attribut D\00E9lai de fermeture des demandes de session simultan\00E9es indique le nombre de secondes pendant lequel un processus de base de donn\00E9es doit \00EAtre actif, ')
||unistr('avant qu''il puisse \00EAtre ferm\00E9. Si vous laissez cet attribut vide, &PRODUCT_NAME. ne ferme aucune session de base de donn\00E9es.'),
'</p>',
'<p>',
unistr('<strong>Avertissement :</strong> la fermeture de sessions peut entra\00EEner des probl\00E8mes au niveau du pool de sessions de base de donn\00E9es du serveur d''applications.    '),
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(538533433403939920.4052)
,p_name=>'P130_INSTANCE_NO_PROXY_DOMAINS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(47634100990931998.4052)
,p_prompt=>'Aucun domaine proxy dans l''instance'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>500
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>unistr('Indiquez la liste des domaines, s\00E9par\00E9s par des virgules, pour lesquels le <strong>proxy de l''instance</strong> ne doit pas \00EAtre utilis\00E9.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(556474331897031379.4052)
,p_name=>'P130_USERNAME_VALIDATION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(47634507195931998.4052)
,p_prompt=>'Expression de validation de nom utilisateur'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Saisissez une expression r\00E9guli\00E8re pour valider les noms utilisateur des d\00E9veloppeurs et des administrateurs. Saisissez * pour passer outre \00E0 la validation.'),
'<p>',
unistr('Exemple (valide le fait que le nom utilisateur est une adresse \00E9lectronique) :<br/>'),
'<pre>',
'^[[:alnum:]._%-]+@[[:alnum:].-]+\.[[:alpha:]]{2,4}$',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(582421603229226504.4052)
,p_name=>'P130_MAX_WEBSERVICE_REQUESTS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(517218991177696240.4052)
,p_prompt=>'Nombre maximal de demandes de service Web'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez le nombre maximal de demandes de service Web que &PRODUCT_NAME. prend en charge pour chaque espace de travail dans cette instance. Vous pouvez configurer une valeur plus sp\00E9cifique au niveau de l''espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(620835000719373113.4052)
,p_name=>'P130_WORKSPACE_MAX_FILE_BYTES'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(517218991177696240.4052)
,p_prompt=>'Taille maximale des fichiers dans l''espace de travail'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez la taille maximale (en octets) de tous les fichiers pouvant \00EAtre t\00E9l\00E9charg\00E9s sur un espace de travail. Vous pouvez configurer une valeur plus sp\00E9cifique au niveau de l''espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(663453643599166127.4052)
,p_name=>'P130_MAX_WS_UPPER_LIMIT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(517218991177696240.4052)
,p_source=>'wwv_flow_platform.get_preference(''MAX_WS_UPPER_LIMIT'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(741568985781681323.4052)
,p_name=>'P130_UNHANDLED_ERRORS'
,p_is_required=>true
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(47634100990931998.4052)
,p_item_default=>'N'
,p_prompt=>unistr('Erreurs non g\00E9r\00E9es')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'UNHANDLED ERRORS'
,p_lov=>'.'||wwv_flow_api.id(818371130728427287.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilisez cet attribut pour d\00E9terminer la fa\00E7on dont &PRODUCT_NAME. affiche les r\00E9sultats des erreurs non g\00E9r\00E9es. Si &PRODUCT_NAME. rencontre une erreur non g\00E9r\00E9e pendant le traitement, l''utilisateur final de l''application verra s''afficher une page')
||unistr(' d''erreur. D''un point de vue s\00E9curitaire, il est souvent pr\00E9f\00E9rable de ne pas montrer ces messages et codes d''erreur \00E0 l''utilisateur final et de simplement renvoyer le code d''erreur HTTP 400 (demande incorrecte) au navigateur client.'),
'</p>',
'<p>Les valeurs possibles sont les suivantes :',
'</p>',
'<ul>',
'    <li><strong>Afficher la page d''erreur</strong> : ',
unistr('      Il s''agit de la valeur par d\00E9faut. Pour toute erreur ou exception non g\00E9r\00E9e par le traitement d''erreur de l''application, elle permet d''indiquer \00E0 l''utilisateur final l''erreur sp\00E9cifique et son code sur une page d''erreur.'),
'    </li>',
'    <li><strong>Renvoyer l''erreur HTTP 400</strong> : ',
unistr('      Elle permet de renvoyer le statut HTTP 400 au navigateur client de l''utilisateur final si une erreur non g\00E9r\00E9e est rencontr\00E9e.'),
'    </li>',
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(47662111179932031.4052)
,p_validation_name=>'P130_EXPIRE_FND_USER_ACCOUNTS'
,p_validation_sequence=>10
,p_validation=>'P130_EXPIRE_FND_USER_ACCOUNTS'
,p_validation2=>'YN'
,p_validation_type=>'ITEM_IN_VALIDATION_IN_STRING2'
,p_error_message=>'Valeur hors limites.'
,p_when_button_pressed=>wwv_flow_api.id(47636805241932002.4052)
,p_associated_item=>wwv_flow_api.id(47650422637932015.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(47661530661932030.4052)
,p_validation_name=>'max login failures positive integer'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P130_USER_MAX_LOGIN_FAILURES );',
'    if l_number = abs(trunc(l_number)) and l_number > 0 then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La valeur doit \00EAtre un entier positif.')
,p_validation_condition=>'P130_USER_MAX_LOGIN_FAILURES'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(47636805241932002.4052)
,p_associated_item=>wwv_flow_api.id(47649932493932015.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(47661914041932030.4052)
,p_validation_name=>'account lifetime days positive integer'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P130_ACCOUNT_LIFETIME_DAYS );',
'    if l_number = abs(trunc(l_number)) and l_number > 0 then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La valeur doit \00EAtre un entier positif.')
,p_validation_condition=>'P130_ACCOUNT_LIFETIME_DAYS'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(47636805241932002.4052)
,p_associated_item=>wwv_flow_api.id(47647919390932013.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(47661715832932030.4052)
,p_validation_name=>'P130_PW_MIN_LENGTH  positive integer'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P130_PW_MIN_LENGTH );',
'    if l_number >= 0 and l_number = abs(trunc(l_number)) then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La valeur doit \00EAtre un entier positif.')
,p_validation_condition=>'P130_PW_MIN_LENGTH'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(47636805241932002.4052)
,p_associated_item=>wwv_flow_api.id(47650925096932015.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(47661111116932029.4052)
,p_validation_name=>'P130_NEW_DIFFERS_BY  positive int or zero'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P130_PW_NEW_DIFFERS_BY );',
'    if l_number is null or l_number = abs(trunc(l_number)) then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La valeur doit \00EAtre un entier positif.')
,p_when_button_pressed=>wwv_flow_api.id(47636805241932002.4052)
,p_associated_item=>wwv_flow_api.id(47654118447932018.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(15063329653306616.4052)
,p_validation_name=>'P130_MAX_SESSION_LENGTH_SEC'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return :P130_MAX_SESSION_LENGTH_SEC is null ',
'       or to_number(:P130_MAX_SESSION_LENGTH_SEC) >= 0;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La valeur doit \00EAtre un entier positif.')
,p_when_button_pressed=>wwv_flow_api.id(47636805241932002.4052)
,p_associated_item=>wwv_flow_api.id(15060228156098057.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(15063504158308694.4052)
,p_validation_name=>'P130_MAX_SESSION_IDLE_SEC'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return :P130_MAX_SESSION_IDLE_SEC is null ',
'       or to_number(:P130_MAX_SESSION_IDLE_SEC) >= 0;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La valeur doit \00EAtre un entier positif.')
,p_when_button_pressed=>wwv_flow_api.id(47636805241932002.4052)
,p_associated_item=>wwv_flow_api.id(15060417898104569.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1405537360336502.4052)
,p_validation_name=>'P130_SESSION_TIMEOUT_WARN_SEC'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return :P130_SESSION_TIMEOUT_WARN_SEC is null ',
'       or to_number(:P130_SESSION_TIMEOUT_WARN_SEC) >= 0;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La valeur doit \00EAtre un entier positif.')
,p_when_button_pressed=>wwv_flow_api.id(47636805241932002.4052)
,p_associated_item=>wwv_flow_api.id(1405441760336501.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(498599028906577030.4052)
,p_validation_name=>'P130_USER_MAX_LOGIN_FAILURES not null'
,p_validation_sequence=>90
,p_validation=>'P130_USER_MAX_LOGIN_FAILURES'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le champ #LABEL# doit \00EAtre d\00E9fini, m\00EAme quand l''option Demander l''expiration et le verrouillage du compte utilisateur est d\00E9finie sur Non.')
,p_when_button_pressed=>wwv_flow_api.id(47636805241932002.4052)
,p_associated_item=>wwv_flow_api.id(47649932493932015.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(498599704103579333.4052)
,p_validation_name=>'P130_ACCOUNT_LIFETIME_DAYS not null'
,p_validation_sequence=>100
,p_validation=>'P130_ACCOUNT_LIFETIME_DAYS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le champ #LABEL# doit \00EAtre d\00E9fini, m\00EAme quand l''option Demander l''expiration et le verrouillage du compte utilisateur est d\00E9finie sur Non.')
,p_when_button_pressed=>wwv_flow_api.id(47636805241932002.4052)
,p_associated_item=>wwv_flow_api.id(47647919390932013.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(244019626204007152.4052)
,p_validation_name=>'P130_LOGIN_THROTTLE_METHODS'
,p_validation_sequence=>110
,p_validation=>'P130_LOGIN_THROTTLE_METHODS'
,p_validation2=>'^USERNAME|IP|USERNAME_IP|USERNAME:IP$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'#LABEL# doit avoir des valeurs autres que USERNAME, IP et USERNAME_IP'
,p_when_button_pressed=>wwv_flow_api.id(47636805241932002.4052)
,p_associated_item=>wwv_flow_api.id(244018932039989237.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(245896807341956895.4052)
,p_validation_name=>'P130_INBOUND_PROXIES'
,p_validation_sequence=>120
,p_validation=>'P130_INBOUND_PROXIES'
,p_validation2=>'^(([0-9]{1,3}(\.[0-9]{1,3}){3})|([a-fA-F0-9]{0,4}([:.][a-fA-F0-9]{0,4}){3,7}),?)*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('#LABEL# doit contenir une liste d''adresses IPv4 ou IPv6 s\00E9par\00E9es par des virgules.')
,p_associated_item=>wwv_flow_api.id(245896310903818453.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(366799026270268448.4052)
,p_validation_name=>'P130_PASSWORD_HASH_FUNCTION'
,p_validation_sequence=>130
,p_validation=>'sys.dbms_db_version.version >= 12 or :PASSWORD_HASH_FUNCTION in (''MD5'',''SH1'')'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('La fonction de hachage de mot de passe s\00E9lectionn\00E9e n''est pas prise en charge sur cette instance.')
,p_when_button_pressed=>wwv_flow_api.id(47636805241932002.4052)
,p_associated_item=>wwv_flow_api.id(366798407533246711.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(663453528666166126.4052)
,p_validation_name=>'Max Web Service Req Upper Limit'
,p_validation_sequence=>140
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P130_MAX_WS_UPPER_LIMIT is not null and (:P130_MAX_WEBSERVICE_REQUESTS > to_number(:P130_MAX_WS_UPPER_LIMIT)',
'    or :P130_MAX_WEBSERVICE_REQUESTS is null) then',
'    return false;',
'else ',
'    return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La valeur ne doit pas \00EAtre sup\00E9rieure \00E0 &P130_MAX_WS_UPPER_LIMIT..')
,p_validation_condition=>'P130_MAX_WS_UPPER_LIMIT'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(47636805241932002.4052)
,p_associated_item=>wwv_flow_api.id(582421603229226504.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(182648918164558490.4052)
,p_name=>'en/dis Oracle Single Sign-On'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P130_BUILDER_AUTH'
,p_condition_element=>'P130_BUILDER_AUTH'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SSO'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(182649215360558490.4052)
,p_event_id=>wwv_flow_api.id(182648918164558490.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_BUILDER_AUTH_SSO_LOGOUT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(182649406402558490.4052)
,p_event_id=>wwv_flow_api.id(182648918164558490.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_BUILDER_AUTH_SSO_LOGOUT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(182798709076574791.4052)
,p_event_id=>wwv_flow_api.id(182648918164558490.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ALERT'
,p_attribute_01=>unistr('N''oubliez pas de cr\00E9er des utilisateurs \00E0 acc\00E8s avec connexion unique ou vous verrouillerez l''acc\00E8s de tous les utilisateurs.')
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(557878209667545379.4052)
,p_name=>'hide username validation'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P130_BUILDER_AUTH'
,p_condition_element=>'P130_BUILDER_AUTH'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'APEX'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557878506052545382.4052)
,p_event_id=>wwv_flow_api.id(557878209667545379.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_USERNAME_VALIDATION'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557878701806545382.4052)
,p_event_id=>wwv_flow_api.id(557878209667545379.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_USERNAME_VALIDATION'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(402391795667306463.4052)
,p_name=>'en/dis P130_HTTP_STS_MAX_AGE'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P130_HTTP_STS'
,p_condition_element=>'P130_HTTP_STS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(402392064260306472.4052)
,p_event_id=>wwv_flow_api.id(402391795667306463.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_HTTP_STS_MAX_AGE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(402392899885311931.4052)
,p_event_id=>wwv_flow_api.id(402391795667306463.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_HTTP_STS_MAX_AGE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(402393062428316425.4052)
,p_event_id=>wwv_flow_api.id(402391795667306463.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_HTTP_STS_MAX_AGE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'1'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(402398804834394459.4052)
,p_name=>'en/dis P130_HTTP_CSP_POLICY'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P130_HTTP_CSP'
,p_condition_element=>'P130_HTTP_CSP'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(402399199507394459.4052)
,p_event_id=>wwv_flow_api.id(402398804834394459.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_HTTP_CSP_VALUE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(402399336712394460.4052)
,p_event_id=>wwv_flow_api.id(402398804834394459.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_HTTP_CSP_VALUE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(403539113314034942.4052)
,p_name=>'en/dis P130_HTTP_STS_MAX_AGE'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P130_REQUIRE_HTTPS'
,p_condition_element=>'P130_REQUIRE_HTTPS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'A'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(403539406261034944.4052)
,p_event_id=>wwv_flow_api.id(403539113314034942.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_HTTP_STS_MAX_AGE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(403539793681039063.4052)
,p_event_id=>wwv_flow_api.id(403539113314034942.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_HTTP_STS_MAX_AGE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(538533525580939921.4052)
,p_name=>'Instance Proxy'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P130_INSTANCE_PROXY'
,p_condition_element=>'P130_INSTANCE_PROXY'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(538533641768939922.4052)
,p_event_id=>wwv_flow_api.id(538533525580939921.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_INSTANCE_NO_PROXY_DOMAINS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(538533728417939923.4052)
,p_event_id=>wwv_flow_api.id(538533525580939921.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_INSTANCE_NO_PROXY_DOMAINS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(538533811903939924.4052)
,p_event_id=>wwv_flow_api.id(538533525580939921.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P130_INSTANCE_NO_PROXY_DOMAINS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(47662222355932032.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch values from platform prefs table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- Authentication',
'--',
':P130_WORKSPACE_NAME_USR_COOKIE := nvl(wwv_flow_platform.get_preference(''WORKSPACE_NAME_USER_COOKIE''),''Y'');',
':P130_DISABLE_ADMIN_LOGIN       := wwv_flow_platform.get_preference( p_preference_name => ''DISABLE_ADMIN_LOGIN'' );',
':P130_DISABLE_WORKSPACE_LOGIN   := wwv_flow_platform.get_preference( p_preference_name => ''DISABLE_WORKSPACE_LOGIN'' );',
':P130_ALLOW_PUBLIC_FILE_UPLOAD  := wwv_flow_platform.get_preference( p_preference_name => ''ALLOW_PUBLIC_FILE_UPLOAD'' );',
':P130_RESTRICT_IP_RANGE         := wwv_flow_platform.get_preference( p_preference_name => ''RESTRICT_IP_RANGE'' );',
':P130_INSTANCE_PROXY            := wwv_flow_platform.get_preference( p_preference_name => ''INSTANCE_PROXY'' );',
':P130_INSTANCE_NO_PROXY_DOMAINS := wwv_flow_platform.get_preference( p_preference_name => ''INSTANCE_NO_PROXY_DOMAINS'' );',
':P130_CHECKSUM_HASH_FUNCTION    := wwv_flow_platform.get_preference(''CHECKSUM_HASH_FUNCTION'');',
':P130_REJOIN_EXISTING_SESSIONS  := wwv_flow_platform.get_preference(''REJOIN_EXISTING_SESSIONS'');',
':P130_UNHANDLED_ERRORS          := wwv_flow_platform.get_preference(''HTTP_ERROR_STATUS_ON_ERROR_PAGE_ENABLED'');',
'--',
'-- HTTP Protocol',
'--',
':P130_REQUIRE_HTTPS         := wwv_flow_platform.get_preference(p_preference_name => ''REQUIRE_HTTPS'' );',
':P130_HTTP_STS_MAX_AGE      := wwv_flow_platform.get_preference(p_preference_name => ''HTTP_STS_MAX_AGE'');',
':P130_OUTBOUND_HTTPS        := wwv_flow_platform.get_preference(p_preference_name => ''REQUIRE_OUT_HTTPS'' );',
':P130_HTTP_RESPONSE_HEADERS := wwv_flow_platform.get_preference(p_preference_name => ''HTTP_RESPONSE_HEADERS'');',
'--',
'-- RAS',
'--',
':P130_ALLOW_RAS := wwv_flow_platform.get_preference( p_preference_name => ''ALLOW_RAS'' );',
'--',
'-- Session Timeout',
'--',
':P130_MAX_SESSION_IDLE_SEC        := nvl(wwv_flow_platform.get_preference( p_preference_name => ''MAX_SESSION_IDLE_SEC''),3600);',
':P130_MAX_SESSION_LENGTH_SEC      := nvl(wwv_flow_platform.get_preference( p_preference_name => ''MAX_SESSION_LENGTH_SEC''),28800);',
':P130_SESSION_TIMEOUT_WARN_SEC    := nvl(wwv_flow_platform.get_preference( p_preference_name => ''SESSION_TIMEOUT_WARNING_SEC''),180);',
'--',
'-- Quality Of Service',
'--',
':P130_ALLOW_HOSTNAMES          := wwv_flow_platform.get_preference( p_preference_name => ''ALLOW_HOSTNAMES'');',
':P130_RM_CONSUMER_GROUP        := wwv_flow_platform.get_preference( p_preference_name => ''RM_CONSUMER_GROUP'');',
':P130_QOS_MAX_WORKSPACE_REQ    := wwv_flow_platform.get_preference( p_preference_name => ''QOS_MAX_WORKSPACE_REQUESTS'');',
':P130_QOS_MAX_SESSION_REQUESTS := wwv_flow_platform.get_preference( p_preference_name => ''QOS_MAX_SESSION_REQUESTS'');',
':P130_QOS_MAX_SESSION_KILL_TI  := wwv_flow_platform.get_preference( p_preference_name => ''QOS_MAX_SESSION_KILL_TIMEOUT '');',
':P130_WORKSPACE_MAX_FILE_BYTES := wwv_flow_platform.get_preference( p_preference_name => ''WORKSPACE_MAX_FILE_BYTES'');',
':P130_MAX_WEBSERVICE_REQUESTS  := wwv_flow_platform.get_preference( p_preference_name => ''MAX_WEBSERVICE_REQUESTS'');',
'--',
'-- Region and Web Service Excluded Domains',
'--',
':P130_BAD_URLS                 := wwv_flow_platform.get_preference( p_preference_name => ''BAD_URLS'');',
'--',
'-- Authentication Control',
'--',
':P130_LOGIN_THROTTLE_DELAY     := wwv_flow_platform.get_preference(''LOGIN_THROTTLE_DELAY'');',
':P130_LOGIN_THROTTLE_METHODS   := wwv_flow_platform.get_preference(''LOGIN_THROTTLE_METHODS'');',
':P130_INBOUND_PROXIES          := wwv_flow_platform.get_preference(''INBOUND_PROXIES'');',
':P130_SSO_LOGOUT_URL            := wwv_flow_platform.get_preference(''SSO_LOGOUT_URL'');',
':P130_USERNAME_VALIDATION       := nvl(wwv_flow_platform.get_preference(''USERNAME_VALIDATION''),''^[[:alnum:]._%-]+@[[:alnum:].-]+\.[[:alpha:]]{2,4}$'');',
':P130_EXPIRE_FND_USER_ACCOUNTS := wwv_flow_platform.get_preference(''EXPIRE_FND_USER_ACCOUNTS'');',
':P130_USER_MAX_LOGIN_FAILURES  := nvl(wwv_flow_platform.get_preference(''MAX_LOGIN_FAILURES''),''4'');',
':P130_ACCOUNT_LIFETIME_DAYS    := nvl(wwv_flow_platform.get_preference(''ACCOUNT_LIFETIME_DAYS''),''45'');',
'',
':P130_PASSWORD_HASH_FUNCTION   := wwv_flow_platform.get_preference(''PASSWORD_HASH_FUNCTION'');',
':P130_STRONG_SITE_ADMIN_PWD    := wwv_flow_platform.get_preference(''STRONG_SITE_ADMIN_PASSWORD'');',
':P130_PW_MIN_LENGTH            := wwv_flow_platform.get_preference( p_preference_name => ''PASSWORD_MIN_LENGTH'');',
':P130_PW_NEW_DIFFERS_BY        := wwv_flow_platform.get_preference( p_preference_name => ''PASSWORD_NEW_DIFFERS_BY'');',
':P130_PW_ONE_ALPHA             := wwv_flow_platform.get_preference( p_preference_name => ''PASSWORD_ONE_ALPHA'');',
':P130_PW_ONE_NUMERIC           := wwv_flow_platform.get_preference( p_preference_name => ''PASSWORD_ONE_NUMERIC'');',
':P130_PW_ONE_PUNCTUATION       := wwv_flow_platform.get_preference( p_preference_name => ''PASSWORD_ONE_PUNCTUATION'');',
':P130_PW_ONE_UPPER_CASE        := wwv_flow_platform.get_preference( p_preference_name => ''PASSWORD_ONE_UPPER_CASE'');',
':P130_PW_ONE_LOWER_CASE        := wwv_flow_platform.get_preference( p_preference_name => ''PASSWORD_ONE_LOWER_CASE'');',
':P130_PW_NOT_LIKE_USERNAME     := wwv_flow_platform.get_preference( p_preference_name => ''PASSWORD_NOT_LIKE_USERNAME'');',
':P130_PW_NOT_LIKE_WS_NAME      := wwv_flow_platform.get_preference( p_preference_name => ''PASSWORD_NOT_LIKE_WS_NAME'');',
':P130_PW_NOT_LIKE_WORDS        := wwv_flow_platform.get_preference( p_preference_name => ''PASSWORD_NOT_LIKE_WORDS'');',
':P130_PW_ALPHA_CHARS           := wwv_flow_platform.get_preference( p_preference_name => ''PASSWORD_ALPHA_CHARACTERS'');',
':P130_PW_PUNCTUATION_CHARS     := wwv_flow_platform.get_preference( p_preference_name => ''PASSWORD_PUNCTUATION_CHARACTERS'');',
''))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(47662403843932033.4052)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Apply Changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- Security',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''WORKSPACE_NAME_USER_COOKIE'',',
'                                  p_preference_value => :P130_WORKSPACE_NAME_USR_COOKIE);',
'wwv_flow_platform.set_preference( p_preference_name => ''DISABLE_ADMIN_LOGIN'',',
'                                  p_preference_value => :P130_DISABLE_ADMIN_LOGIN );',
'wwv_flow_platform.set_preference( p_preference_name => ''DISABLE_WORKSPACE_LOGIN'',',
'                                  p_preference_value => :P130_DISABLE_WORKSPACE_LOGIN );',
'wwv_flow_platform.set_preference( p_preference_name => ''ALLOW_PUBLIC_FILE_UPLOAD'',',
'                                  p_preference_value => :P130_ALLOW_PUBLIC_FILE_UPLOAD );',
'wwv_flow_platform.set_preference( p_preference_name => ''RESTRICT_IP_RANGE'',',
'                                  p_preference_value => :P130_RESTRICT_IP_RANGE );',
'wwv_flow_platform.set_preference( p_preference_name => ''INSTANCE_PROXY'',',
'                                  p_preference_value => :P130_INSTANCE_PROXY );',
'wwv_flow_platform.set_preference( p_preference_name => ''INSTANCE_NO_PROXY_DOMAINS'',',
'                                  p_preference_value => :P130_INSTANCE_NO_PROXY_DOMAINS );',
'wwv_flow_platform.set_preference( p_preference_name => ''CHECKSUM_HASH_FUNCTION'',',
'                                  p_preference_value => :P130_CHECKSUM_HASH_FUNCTION );',
'wwv_flow_platform.set_preference( p_preference_name => ''REJOIN_EXISTING_SESSIONS'',',
'                                  p_preference_value => :P130_REJOIN_EXISTING_SESSIONS );',
'                                  ',
'wwv_flow_platform.set_preference( p_preference_name => ''HTTP_ERROR_STATUS_ON_ERROR_PAGE_ENABLED'',',
'                                  p_preference_value => :P130_UNHANDLED_ERRORS );                                                                    ',
'--',
'-- HTTP Protocol',
'--',
'wwv_flow_platform.set_preference( p_preference_name  => ''REQUIRE_HTTPS'',',
'                                  p_preference_value => :P130_REQUIRE_HTTPS );',
'wwv_flow_platform.set_preference( p_preference_name  => ''HTTP_STS_MAX_AGE'',',
'                                  p_preference_value => :P130_HTTP_STS_MAX_AGE );',
'wwv_flow_platform.set_preference( p_preference_name  => ''REQUIRE_OUT_HTTPS'',',
'                                  p_preference_value => :P130_OUTBOUND_HTTPS );',
'wwv_flow_platform.set_preference( p_preference_name  => ''HTTP_RESPONSE_HEADERS'',',
'                                  p_preference_value => :P130_HTTP_RESPONSE_HEADERS );',
'--',
'-- RAS',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''ALLOW_RAS'',',
'                                  p_preference_value => :P130_ALLOW_RAS );',
'--',
'-- Quality Of Service',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''ALLOW_HOSTNAMES'',',
'                                  p_preference_value => :P130_ALLOW_HOSTNAMES );',
'wwv_flow_platform.set_preference( p_preference_name => ''RM_CONSUMER_GROUP'',',
'                                  p_preference_value => :P130_RM_CONSUMER_GROUP );',
'wwv_flow_platform.set_preference( p_preference_name => ''QOS_MAX_WORKSPACE_REQUESTS'',',
'                                  p_preference_value => :P130_QOS_MAX_WORKSPACE_REQ );',
'wwv_flow_platform.set_preference( p_preference_name => ''QOS_MAX_SESSION_REQUESTS'',',
'                                  p_preference_value => :P130_QOS_MAX_SESSION_REQUESTS );',
'wwv_flow_platform.set_preference( p_preference_name => ''QOS_MAX_SESSION_KILL_TIMEOUT'',',
'                                  p_preference_value => :P130_QOS_MAX_SESSION_KILL_TO );',
'wwv_flow_platform.set_preference( p_preference_name => ''WORKSPACE_MAX_FILE_BYTES'',',
'                                  p_preference_value => :P130_WORKSPACE_MAX_FILE_BYTES );',
'wwv_flow_platform.set_preference( p_preference_name => ''MAX_WEBSERVICE_REQUESTS'',',
'                                  p_preference_value => :P130_MAX_WEBSERVICE_REQUESTS );',
'--',
'-- General Authentication Control',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''LOGIN_THROTTLE_DELAY'',',
'                                  p_preference_value => :P130_LOGIN_THROTTLE_DELAY );',
'wwv_flow_platform.set_preference( p_preference_name => ''LOGIN_THROTTLE_METHODS'',',
'                                  p_preference_value => :P130_LOGIN_THROTTLE_METHODS );',
'wwv_flow_platform.set_preference( p_preference_name => ''INBOUND_PROXIES'',',
'                                  p_preference_value => :P130_INBOUND_PROXIES );',
'wwv_flow_platform.set_preference( p_preference_name => ''SSO_LOGOUT_URL'',',
'                                  p_preference_value => :P130_SSO_LOGOUT_URL );',
'--',
'-- Workspace Authentication Control',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''USERNAME_VALIDATION'',',
'                                  p_preference_value => :P130_USERNAME_VALIDATION );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''EXPIRE_FND_USER_ACCOUNTS'',',
'                                  p_preference_value => :P130_EXPIRE_FND_USER_ACCOUNTS );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''MAX_LOGIN_FAILURES'',',
'                                  p_preference_value => nvl(:P130_USER_MAX_LOGIN_FAILURES,4) );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''ACCOUNT_LIFETIME_DAYS'',',
'                                  p_preference_value => nvl(:P130_ACCOUNT_LIFETIME_DAYS,45) );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_HASH_FUNCTION'',',
'                                  p_preference_value => :P130_PASSWORD_HASH_FUNCTION );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''STRONG_SITE_ADMIN_PASSWORD'',',
'                                  p_preference_value => nvl(:P130_STRONG_SITE_ADMIN_PWD,''N'') );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_MIN_LENGTH'',',
'                                  p_preference_value => nvl(:P130_PW_MIN_LENGTH,0) );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_NEW_DIFFERS_BY'',',
'                                  p_preference_value => nvl(:P130_PW_NEW_DIFFERS_BY,0) );',
'--                                 ',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_ONE_ALPHA'',',
'                                  p_preference_value => nvl(:P130_PW_ONE_ALPHA,''N'') );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_ONE_NUMERIC'',',
'                                  p_preference_value => nvl(:P130_PW_ONE_NUMERIC,''N'') );  ',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_ONE_PUNCTUATION'',',
'                                  p_preference_value => nvl(:P130_PW_ONE_PUNCTUATION,''N'') ); ',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_ONE_UPPER_CASE'',',
'                                  p_preference_value => nvl(:P130_PW_ONE_UPPER_CASE,''N'') ); ',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_ONE_LOWER_CASE'',',
'                                  p_preference_value => nvl(:P130_PW_ONE_LOWER_CASE,''N'') ); ',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_NOT_LIKE_USERNAME'',',
'                                  p_preference_value => nvl(:P130_PW_NOT_LIKE_USERNAME,''N'') );   ',
'--                                ',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_NOT_LIKE_WS_NAME'',',
'                                  p_preference_value => nvl(:P130_PW_NOT_LIKE_WS_NAME,''N'') );  ',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_NOT_LIKE_WORDS'',',
'                                  p_preference_value => substr(ltrim(rtrim(replace(replace(replace(',
'                                                            :P130_PW_NOT_LIKE_WORDS,'' '',null),chr(10),null),chr(13),null))),1,4000));',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_PUNCTUATION_CHARACTERS'',',
'                                  p_preference_value => substr(ltrim(rtrim(replace(replace(replace(',
'                                                            :P130_PW_PUNCTUATION_CHARS,'' '',null),chr(10),null),chr(13),null))),1,4000));',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PASSWORD_ALPHA_CHARACTERS'',',
'                                  p_preference_value => substr(ltrim(rtrim(replace(replace(replace(',
'                                                            :P130_PW_ALPHA_CHARS,'' '',null),chr(10),null),chr(13),null))),1,4000));',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''BAD_URLS'',',
'                                  p_preference_value => substr(ltrim(rtrim(replace(replace(replace(',
'                                                            :P130_BAD_URLS,'' '',null),chr(10),null),chr(13),null))),1,4000));',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''MAX_SESSION_IDLE_SEC'',',
'                                  p_preference_value => nvl(:P130_MAX_SESSION_IDLE_SEC,3600) );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''MAX_SESSION_LENGTH_SEC'',',
'                                  p_preference_value => nvl(:P130_MAX_SESSION_LENGTH_SEC,28800) );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''SESSION_TIMEOUT_WARNING_SEC'',',
'                                  p_preference_value => nvl(:P130_SESSION_TIMEOUT_WARN_SEC,300) );',
'--',
'wwv_flow_authorization.reset_cache (',
'    p_save_state => true );',
'--',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible d''enregistrer les param\00E8tres de s\00E9curit\00E9.')
,p_process_when_button_id=>wwv_flow_api.id(47636805241932002.4052)
,p_process_success_message=>unistr('Param\00E8tres de s\00E9curit\00E9 enregistr\00E9s.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(47662604945932033.4052)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'130'
);
end;
/
prompt --application/pages/page_00131
begin
wwv_flow_api.create_page(
 p_id=>131.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Param\00E8tres d''instance')
,p_step_title=>unistr('Param\00E8tres d''instance')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(216766702444596508)
,p_step_template=>wwv_flow_api.id(704456563630760825.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_env.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(51160113641211250.4052)
,p_plug_name=>'Courriel'
,p_region_name=>'EMAIL'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(51160527136211251.4052)
,p_plug_name=>unistr('Cr\00E9ation d''espace de travail')
,p_region_name=>'SELFSERVICE'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(51160911256211251.4052)
,p_plug_name=>unistr('Param\00E8tres d''instance')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(51162104747211252.4052)
,p_name=>'Taille de la demande de modification d''espace de travail'
,p_region_name=>'CHANGE_WORKSPACE_SIZE'
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_item.hidden(5,wwv_flow_escape.html(s.id)) || apex_item.text(6, wwv_flow_escape.html(s.req_size), 25) display_req_size,',
'       apex_item.select_list_from_lov(7, wwv_flow_escape.html(s.display), ''YES_NO_RETURNS_Y_OR_N'',null,''NO'') display,',
'       to_number(s.req_size),       apex_item.radiogroup(8,wwv_flow_escape.html(s.id),decode(s.default_size,''Y'',s.id,0)) default_selection',
'  from  wwv_flow_workspace_req_size s',
' where s.request_type = ''C'''))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(51162400177211252.4052)
,p_query_column_id=>1
,p_column_alias=>'DISPLAY_REQ_SIZE'
,p_column_display_sequence=>1
,p_column_heading=>'Taille (en Mo)'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(51162324177211252.4052)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY'
,p_column_display_sequence=>2
,p_column_heading=>'Afficher'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(51162514609211253.4052)
,p_query_column_id=>3
,p_column_alias=>'TO_NUMBER(S.REQ_SIZE)'
,p_column_display_sequence=>3
,p_column_heading=>'To Number(S.Req Size)'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(51478902378846758.4052)
,p_query_column_id=>4
,p_column_alias=>'DEFAULT_SELECTION'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Valeur par d\00E9faut')
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(51162614555211253.4052)
,p_plug_name=>unistr('Impression d''\00E9tat')
,p_region_name=>'REPORT_PRINTING'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(51162800040211253.4052)
,p_plug_name=>'Portefeuille'
,p_region_name=>'WALLET'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(51163027227211253.4052)
,p_name=>'Taille de la demande de nouvel espace de travail'
,p_region_name=>'NEW_WORKSPACE_SIZE'
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'       apex_item.hidden(1,wwv_flow_escape.html(s.id)) || apex_item.text(2, wwv_flow_escape.html(s.req_size), 25) display_req_size,',
'       apex_item.select_list_from_lov(3, wwv_flow_escape.html(s.display), ''YES_NO_RETURNS_Y_OR_N'',null,''NO'') display,',
'       to_number(s.req_size) req_size,       apex_item.radiogroup(4,s.id,decode(wwv_flow_escape.html(s.default_size),''Y'',s.id,0)) default_selection',
'  from  wwv_flow_workspace_req_size s',
' where s.request_type = ''N'''))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(51163431134211253.4052)
,p_query_column_id=>1
,p_column_alias=>'DISPLAY_REQ_SIZE'
,p_column_display_sequence=>1
,p_column_heading=>'Taille (en Mo)'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(51163223408211253.4052)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY'
,p_column_display_sequence=>2
,p_column_heading=>'Afficher'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(51163314175211253.4052)
,p_query_column_id=>3
,p_column_alias=>'REQ_SIZE'
,p_column_display_sequence=>4
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(51474332113827028.4052)
,p_query_column_id=>4
,p_column_alias=>'DEFAULT_SELECTION'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Valeur par d\00E9faut')
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(102772806051895487.4052)
,p_plug_name=>'Fourniture de provisionnement par courriel'
,p_region_name=>'EMAIL_PROVISIONING'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(103242102881123907.4052)
,p_plug_name=>'Stockage'
,p_region_name=>'STORAGE'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203127322177179431.4052)
,p_plug_name=>'Plage d''ID de l''application'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(319958722234296913.4052)
,p_plug_name=>unistr('Travaux d''arri\00E8re-plan')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472895007879833572.4052)
,p_plug_name=>'Ancre'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(195775112470763477.4052)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(473748116639968529.4052)
,p_plug_name=>'Aide'
,p_region_name=>'HELP'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(617449002845759911.4052)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>G\00E9rez les param\00E8tres applicables \00E0 l''int\00E9gralit\00E9 de l''instance &PRODUCT_NAME..</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(51164000306211254.4052)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(51160911256211251.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(51164206531211254.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(51160911256211251.4052)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(168826527481409095.4052)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1402891439294845.4052)
,p_name=>'P131_BACKGRND_MIN_EXEC_CADENCE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(319958722234296913.4052)
,p_prompt=>unistr('Cadence d''ex\00E9cution minimale (minutes)')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifiez la cadence d''ex\00E9cution minimale (en minutes) pour les travaux de synchronisation REST et d''automatisation.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3044413246294304.4052)
,p_name=>'P131_CHANGE_WALLET_PWD'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(51162800040211253.4052)
,p_prompt=>'&nbsp;'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CONFIRM.PWD.REMOVAL'
,p_lov=>'.'||wwv_flow_api.id(35215801480283409.4052)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'VERTICAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5736822385779722.4052)
,p_name=>'P131_AUTOAPPROVE_STORAGE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(103242102881123907.4052)
,p_item_default=>'N'
,p_prompt=>'Approuver automatiquement les demandes'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<= '' || req_size ||''MB'' d, req_size r',
'  from wwv_flow_workspace_req_size',
' where request_type = ''C''',
'   and display = ''Y''',
' order by to_number(r)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Jamais'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_display_when=>'wwv_flow_platform.get_preference(''INSTANCE_TABLESPACE'') is null'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Approuvez automatiquement les demandes de stockage dont la taille ne d\00E9passe pas la taille s\00E9lectionn\00E9e. '),
'<br /><br />',
unistr('<strong>Remarque :</strong> la m\00E9thode de provisionnement de l''espace de travail doit \00EAtre d\00E9finie sur Automatique pour que cette fonctionnalit\00E9 soit activ\00E9e. Si la m\00E9thode de provisionnement est d\00E9finie sur Manuel ou Demande, aucune demande de stock')
||unistr('age ne sera approuv\00E9e automatiquement.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20135520532712091.4052)
,p_name=>'P131_INSTANCE_URL'
,p_is_required=>true
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(51160113641211250.4052)
,p_item_default=>'wwv_flow_utilities.host_url( ''SCRIPT'' )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'URL d''instance &PRODUCT_NAME.'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>100
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez l''URL de cette instance &PRODUCT_NAME., y compris la barre oblique finale apr\00E8s la racine de contexte. Ce param\00E8tre est utilis\00E9 pour les courriels g\00E9n\00E9r\00E9s par le syst\00E8me.</p>'),
'',
'<p>Par exemple : <code>https://www.example.com/apex/</code></p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20136029536714683.4052)
,p_name=>'P131_IMAGES_URL'
,p_is_required=>true
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(51160113641211250.4052)
,p_item_default=>'wwv_flow_utilities.host_url( ''IMGPRE'' )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'URL des images &PRODUCT_NAME.'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>100
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez l''URL compl\00E8te permettant d''acc\00E9der au r\00E9pertoire d''images de cette instance &PRODUCT_NAME., y compris la barre oblique finale'),
unistr('apr\00E8s le r\00E9pertoire d''images. Ce param\00E8tre est utilis\00E9 pour les courriels g\00E9n\00E9r\00E9s par le syst\00E8me.</p>'),
'',
'<p>Par exemple : <code>https://www.example.com/i/</code></p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(26960006390704550.4052)
,p_name=>'P131_REQUIRE_VERIFICATION_CODE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(51160527136211251.4052)
,p_item_default=>'Y'
,p_prompt=>unistr('Exiger un code de v\00E9rification')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Lorsque le statut de provisionnement est d\00E9fini sur Demande ou V\00E9rification d''adresse \00E9lectronique, ce param\00E8tre contr\00F4le si le code de v\00E9rification est affich\00E9 et requis pour toute demande d''un nouvel espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27397518631059800.4052)
,p_name=>'P131_SMTP_USERNAME'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(51160113641211250.4052)
,p_prompt=>'Nom utilisateur d''authentification SMTP'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Saisissez un nom utilisateur si votre serveur SMTP exige une authentification.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27397701447064365.4052)
,p_name=>'P131_SMTP_PASSWORD'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(51160113641211250.4052)
,p_prompt=>'Mot de passe d''authentification SMTP'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Entrez un mot de passe si le serveur SMTP exige une authentification. S\00E9lectionnez <strong>Cocher pour confirmer que vous voulez modifier le mot de passe associ\00E9 au nom utilisateur d''authentification SMTP</strong> afin d''indiquer que vous avez modifi')
||unistr('\00E9 le mot de passe.')
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27398215309143987.4052)
,p_name=>'P131_SMTP_TLS_MODE'
,p_is_required=>true
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(51160113641211250.4052)
,p_prompt=>'Utiliser SSL/TLS'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P131_SMTP_TLS_MODE'
,p_lov=>'.'||wwv_flow_api.id(44180513498106696.4052)||'.'
,p_cHeight=>1
,p_display_when=>'not wwv_flow_db_version.c_ver_le_11_2_0_1'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('&PRODUCT_NAME. prend en charge les connexions SMTP s\00E9curis\00E9es. Options disponibles :'),
'<ul>',
unistr('<li><strong>Oui :</strong> une connexion s\00E9curis\00E9e avec SSL/TLS est \00E9tablie avant la communication SMTP.</li>'),
unistr('<li><strong>Une fois la connexion \00E9tablie :</strong> &PRODUCT_NAME. envoie la commande SMTP <code>STARTTLS</code> imm\00E9diatement apr\00E8s que la connexion a \00E9t\00E9 ouverte.</li>'),
unistr('<li><strong>Non :</strong> une connexion non s\00E9curis\00E9e est ouverte.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38853230345769930.4052)
,p_name=>'P131_BIGFILE_TABLESPACES'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(103242102881123907.4052)
,p_item_default=>'N'
,p_prompt=>'Tablespaces BIGFILE'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_display_when=>'wwv_flow_platform.get_preference(''INSTANCE_TABLESPACE'') is null'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si l''option Tablespaces bigfile est activ\00E9e, les tablespaces provisionn\00E9s avec &PRODUCT_NAME. sont cr\00E9\00E9s en tant que tablespaces bigfile. Un tablespace bigfile est un tablespace comprenant un fichier de donn\00E9es unique et tr\00E8s volumineux. A l''inver')
||unistr('se, les tablespaces smallfile traditionnels comportent plusieurs fichiers de donn\00E9es moins volumineux.</p>'),
'',
unistr('<p>L''utilisation de tablespaces bigfile sur des plates-formes ne prenant pas en charge les fichiers volumineux n''est pas recommand\00E9e et peut limiter la capacit\00E9 du tablespace. Pour plus d''informations sur les tailles maximales de fichier prises en ch')
||unistr('arge, reportez-vous \00E0 la documentation sp\00E9cifique de votre syst\00E8me d''exploitation.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38854402902780924.4052)
,p_name=>'P131_ENCRYPTED_TABLESPACES'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(103242102881123907.4052)
,p_item_default=>'N'
,p_prompt=>unistr('Tablespaces crypt\00E9s')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_display_when=>'wwv_flow_platform.get_preference(''INSTANCE_TABLESPACE'') is null'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si l''option Tablespaces crypt\00E9s est activ\00E9e, les tablespaces provisionn\00E9s avec &PRODUCT_NAME. sont cr\00E9\00E9s en tant que tablespaces'),
unistr('crypt\00E9s \00E0 l''aide de la fonctionnalit\00E9 de cryptage transparent des donn\00E9es (TDE) de base de donn\00E9es Oracle. Cette derni\00E8re crypte les donn\00E9es confidentielles stock\00E9es'),
unistr('dans les fichiers de donn\00E9es. Afin d''emp\00EAcher tout d\00E9cryptage non autoris\00E9, la fonctionnalit\00E9 TDE stocke les cl\00E9s de cryptage dans un module de s\00E9curit\00E9 externe \00E0'),
unistr('la base de donn\00E9es.</p>'),
'',
unistr('<p>Pour pouvoir exploiter cette fonctionnalit\00E9 de &PRODUCT_NAME., vous devez cr\00E9er un portefeuille de cryptage avec un ensemble de cl\00E9s de'),
unistr('cryptage ma\00EEtre. Par ailleurs, le portefeuille de cryptage devra \00EAtre ouvert avant de provisionner un nouvel espace de travail &PRODUCT_NAME..</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(51168829641211258.4052)
,p_name=>'P131_SERVICE_REQUEST_FLOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(51160527136211251.4052)
,p_item_default=>'MANUAL'
,p_prompt=>unistr('M\00E9thode de provisionnement:')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PROVISIONING.STATUS'
,p_lov=>'.'||wwv_flow_api.id(87819917137094037.4052)||'.'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indique le processus de cr\00E9ation et de demande d''espace de travail. Les options sont les suivantes :</p>'),
'',
'<ul>',
unistr('<li><strong>Manuel :</strong> un administrateur &PRODUCT_NAME. doit cr\00E9er manuellement les espaces de travail et communiquer les informations de connexion \00E0 l''administrateur d''espace de travail.</li>'),
unistr('<li><strong>Demande :</strong> un utilisateur peut demander un espace de travail. Si un administrateur approuve la demande, un message contenant un lien permettant de valider l''adresse \00E9lectronique de l''utilisateur est envoy\00E9. L''espace de travail est')
||unistr(' cr\00E9\00E9 aussit\00F4t l''adresse \00E9lectronique valid\00E9e. </li>'),
unistr('<li><strong>Automatique :</strong> fonctionne de la m\00EAme mani\00E8re que l''option <strong>Demande</strong> si ce n''est que les demandes sont approuv\00E9es automatiquement, sans l''intervention d''un administrateur.</li>'),
'</ul>',
'',
unistr('<p>Pour activer l''approbation automatique des demandes de stockage, la m\00E9thode de provisionnement doit \00EAtre d\00E9finie sur <strong>Automatique</strong>.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(51169810102211258.4052)
,p_name=>'P131_SMTP_FROM'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(51160113641211250.4052)
,p_prompt=>unistr('Adresse \00E9lectronique d''exp\00E9diteur par d\00E9faut')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('D\00E9finit l''adresse de l''\00E9metteur pour les t\00E2ches g\00E9n\00E9rant des courriels, telles que l''approbation d''une demande de provisionnement ou la r\00E9initialisation d''un mot de passe.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(51170329748211259.4052)
,p_name=>'P131_SMTP_HOST_ADDRESS'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(51160113641211250.4052)
,p_prompt=>unistr('Adresse de l''h\00F4te SMTP')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('D\00E9finit l''adresse du serveur SMTP. La valeur par d\00E9faut est <code>localhost</code>. Si vous n''utilisez pas ce serveur comme relais SMTP, modifiez ce param\00E8tre pour y indiquer l''adresse de ce serveur. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(51170811596211259.4052)
,p_name=>'P131_SMTP_HOST_PORT'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(51160113641211250.4052)
,p_prompt=>unistr('Port de l''h\00F4te SMTP')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('D\00E9finit le port sur lequel le serveur SMTP \00E9coute les demandes de messagerie. La valeur par d\00E9faut est <code>25</code>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(51175812830211262.4052)
,p_name=>'P131_PRINT_SVR_HOST'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_api.id(51162614555211253.4052)
,p_prompt=>unistr('Adresse de l''h\00F4te')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Indique l''adresse de l''h\00F4te du moteur de conversion de serveur d''impression.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(51176319252211263.4052)
,p_name=>'P131_PRINT_SVR_PORT'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(51162614555211253.4052)
,p_prompt=>'Port'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('D\00E9finit le port du moteur de serveur d''impression.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(51176814346211263.4052)
,p_name=>'P131_PRINT_SVR_SCRIPT'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(51162614555211253.4052)
,p_prompt=>'Script'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Ce param\00E8tre d\00E9finit le script constituant le moteur de serveur d''impression.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(51185628873211268.4052)
,p_name=>'P131_WALLET_PATH'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(51162800040211253.4052)
,p_prompt=>'Chemin du portefeuille'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>45
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Un portefeuille est un contenant prot\00E9g\00E9 par mot de passe utilis\00E9 pour stocker les informations d''identification pour l''authentification et la signature. Le portefeuille Oracle est utilis\00E9 pour toutes les demandes HTTP via SSL (Secured Socket Layer),')
||' autrement dit HTTPS.<p />',
'',
unistr('Indiquez le chemin du portefeuille dans le syst\00E8me de fichiers avec le format suivant :'),
'',
'<pre>file:&lt;directory-path&gt;</pre>',
'',
'Exemples :',
'<ul>',
unistr('<li>Syst\00E8me Windows : <pre>file:c:\005CWINNT\005CProfiles\005C&lt;username&gt;\005CWALLETS</pre></li>'),
unistr('<li>Syst\00E8me UNIX  - <pre>file:/home/&lt;username&gt;/wallets</pre></li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(51185817336211269.4052)
,p_name=>'P131_WALLET_PWD'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(51162800040211253.4052)
,p_prompt=>'Mot de passe du portefeuille'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>45
,p_cMaxlength=>2000
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Saisissez le mot de passe requis pour ouvrir le portefeuille. Vous n''avez pas besoin d''indiquer un mot de passe pour les portefeuilles de connexion automatique. S\00E9lectionnez <strong>Cocher pour confirmer que vous souhaitez modifier le mot de passe de')
||unistr(' portefeuille</strong> pour indiquer que vous avez modifi\00E9 le mot de passe.')
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(51186010724211269.4052)
,p_name=>'P131_PRINT_SVR_PROTOCOL'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(51162614555211253.4052)
,p_item_default=>'http'
,p_prompt=>'Protocole'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P16.PRINTSVR.PROTOCOL'
,p_lov=>'.'||wwv_flow_api.id(41576101209699161.4052)||'.'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Indiquez si le serveur d''impression utilise le protocole HTTP ou HTTPS.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(64572769329929401.4052)
,p_name=>'P131_GETTING_STARTED'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(473748116639968529.4052)
,p_item_default=>'N'
,p_prompt=>'Afficher le contenu d''initiation'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Une fois activ\00E9es, les informations d''initiation seront affich\00E9es sur la page d''accueil et d''autres pages.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(66036410030684131.4052)
,p_name=>'P131_PRINT_BIB_LICENSED'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(51162614555211253.4052)
,p_item_default=>'STANDARD'
,p_prompt=>'Serveur d''impression'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BIPUBLISHER_SUPPORT'
,p_lov=>'.'||wwv_flow_api.id(66524307689014582.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('S\00E9lectionnez l''option appropri\00E9e :'),
'<ul>',
unistr('<li><strong>Oracle REST Data Services :</strong> s\00E9lectionnez cette option si vous utilisez Oracle REST Data Services 2.0 ou une version plus r\00E9cente. Cette option permet d''utiliser la fonctionnalit\00E9 d''impression de base, qui inclut la cr\00E9ation de re')
||unistr('qu\00EAtes d''\00E9tat, ainsi que l''impression de r\00E9gions d''\00E9tat \00E0 l''aide des mod\00E8les par d\00E9faut fournis dans &PRODUCT_NAME. et des mod\00E8les XSL-FO personnalis\00E9s. Cette option n''est plus prise en charge \00E0 compter de la version &PRODUCT_NAME. 19.2</li>'),
unistr('<li><strong>Externe (Apache FOP) :</strong> s\00E9lectionnez cette option si vous utilisez Apache FOP sur un serveur J2EE externe. Cette option permet d''utiliser la fonctionnalit\00E9 d''impression de base, qui inclut la cr\00E9ation de requ\00EAtes d''\00E9tat, ainsi que')
||unistr(' l''impression de r\00E9gions d''\00E9tat \00E0 l''aide des mod\00E8les par d\00E9faut fournis dans &PRODUCT_NAME. et des mod\00E8les XSL-FO personnalis\00E9s.</li>'),
unistr('<li><strong>Oracle BI Publisher :</strong> s\00E9lectionnez cette option si vous utilisez une version sous licence d''Oracle BI Publisher. Cette option permet de convertir les r\00E9sultats de requ\00EAte d''\00E9tat (format XML) au format RTF \00E0 l''aide d''Oracle BI Pub')
||unistr('lisher. S\00E9lectionnez cette option si vous souhaitez t\00E9l\00E9charger vos mod\00E8les RTF ou XSL-FO personnalis\00E9s en vue de l''impression des \00E9tats dans &PRODUCT_NAME..</li>'),
unistr('<li><strong>APEX Office Print :</strong> s\00E9lectionnez cette option si vous utilisez APEX Office Print. Elle vous permet d''avoir acc\00E8s \00E0 la fonctionnalit\00E9 d''impression de base, qui inclut la cr\00E9ation de requ\00EAtes d''\00E9tat et l''impression de r\00E9gions d''\00E9ta')
||unistr('t \00E0 l''aide des mod\00E8les par d\00E9faut fournis dans &PRODUCT_NAME..</li>'),
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(102775409346934271.4052)
,p_name=>'P131_DISABLE_WS_PROV'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(102772806051895487.4052)
,p_prompt=>'Fourniture de provisionnement par courriel'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WS_PROVISIONING_STATUS'
,p_lov=>'.'||wwv_flow_api.id(113228404836854036.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Lorsque vous s\00E9lectionnez <strong>D\00E9sactiv\00E9</strong>, le message fourni expliquant les raisons du provisionnement pour l''espace de travail appara\00EEt.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(102999118515639517.4052)
,p_name=>'P131_DISABLE_WS_MSG'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(102772806051895487.4052)
,p_prompt=>'Message'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>3
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Lorsque le provisionnement par courriel est d\00E9sactiv\00E9e, les utilisateurs peuvent visualiser le texte saisi ici en cliquant sur un lien de provisionnement pour l''espace de travail. Ce message doit expliquer que le provisionnement est actuellement d\00E9sa')
||unistr('ctiv\00E9 et \00E0 quel moment il sera \00E0 nouveau disponible.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(103236805427058416.4052)
,p_name=>'P131_REQ_NEW_SCHEMA'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(103242102881123907.4052)
,p_prompt=>unistr('Exiger un nouveau sch\00E9ma')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>unistr('D\00E9termine si l''utilisateur demandant un espace de travail peut s\00E9lectionner un sch\00E9ma existant ou doit demander un nouveau sch\00E9ma.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(137126007769887471.4052)
,p_name=>'P131_NOTIFICATION_EMAIL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(51160527136211251.4052)
,p_prompt=>unistr('Adresse \00E9lectronique pour la notification')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Saisissez l''adresse \00E9lectronique \00E0 laquelle les messages de notification seront envoy\00E9s pour les demandes de nouvel espace de travail ou de modification de l''espace de travail. Si aucune adresse n''est indiqu\00E9e, aucun message \00E9lectronique de notificat')
||unistr('ion d''espace de travail n''est envoy\00E9.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138925711619515767.4052)
,p_name=>'P131_DELETE_UPLOADED_FILES'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(103242102881123907.4052)
,p_prompt=>unistr('Supprimer les fichiers t\00E9l\00E9charg\00E9s apr\00E8s (jours)')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez le nombre de jours apr\00E8s lequel &PRODUCT_NAME. supprime automatiquement les fichiers t\00E9l\00E9charg\00E9s. Ce processus de suppression automatique s''ex\00E9cute dans tous les espaces de travail de l''instance &PRODUCT_NAME.. Types de fichiers supprim\00E9')
||'s :</p>',
'',
'<ul>',
'<li>Export d''application</li>',
'<li>Export de feuille de style CSS</li>',
'<li>Export d''images</li>',
'<li>Export de page</li>',
'<li>Module d''extension</li>',
'<li>Export de script</li>',
unistr('<li>Import de feuilles de calcul/donn\00E9es textuelles</li>'),
'<li>Export de fichiers statiques</li>',
unistr('<li>Th\00E8mes</li>'),
unistr('<li>Valeurs par d\00E9faut d''interface utilisateur</li>'),
'<li>Export de feuille Web</li>',
'<li>Export d''espace de travail</li>',
unistr('<li>Import de donn\00E9es XML</li>'),
'</ul>',
'',
unistr('<p>Ce param\00E8tre doit \00EAtre un entier positif. S''il a la valeur NULL, aucun fichier ne sera supprim\00E9 automatiquement par &PRODUCT_NAME.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'10000'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183851252666893723.4052)
,p_name=>'P131_API_KEY'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(51162614555211253.4052)
,p_prompt=>unistr('Cl\00E9 d''API')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Cl\00E9 d''API de serveur d''impression.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203128029832230759.4052)
,p_name=>'P131_APPLICATION_ID_MIN'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(203127322177179431.4052)
,p_item_default=>'100'
,p_prompt=>'ID minimal'
,p_source=>'100'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<em>ID minimal</em> et <em>ID maximal</em>',
unistr('d\00E9finissent la plage autoris\00E9e pour les ID de base de donn\00E9es et d''application Web.'),
unistr('Saisissez la limite inf\00E9rieure dans <em>ID minimal</em>.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'100'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203128222931233942.4052)
,p_name=>'P131_APPLICATION_ID_MAX'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(203127322177179431.4052)
,p_prompt=>'ID maximal'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<em>ID minimal</em> et <em>ID maximal</em>',
unistr('d\00E9finissent la plage autoris\00E9e pour les ID de base de donn\00E9es et d''application Web.'),
unistr('Saisissez la limite sup\00E9rieure dans <em>ID maximal</em>.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(319958832716296914.4052)
,p_name=>'P131_BACKGROUND_JOB_CLASS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(319958722234296913.4052)
,p_prompt=>unistr('Classe de travail en arri\00E8re-plan')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Identifiez la classe de travail DBMS_SCHEDULER dans laquelle ex\00E9cuter les travaux d''automatisation, de synchronisation REST et de notification d''\00E9tat. Ceci permet d''affecter des travaux de chargement des donn\00E9es \00E0 un groupe de consommateurs Resou')
||unistr('rce Manager sp\00E9cifique. Si elle n''est pas d\00E9finie, la classe de travail <strong>SYS.DEFAULT_JOB_CLASS</strong> sera utilis\00E9e. Pour plus d''informations sur les classes de travail, consultez le guide de l''administrateur Oracle Database.'),
'</p>',
'<p>',
unistr('    Exemple. Ex\00E9cuter avec des privil\00E8ges DBA :'),
'</p>',
'<pre>',
unistr('-- 1. cr\00E9er la classe de travail'),
'--   ',
'begin ',
'    dbms_scheduler.create_job_class(',
'         job_class_name          => ''MY_LOADER_CLASS'', ',
'         -- this assumes that a RES_MGR_LOW_PRIO_GROUP consumer group exists',
'         resource_consumer_group => ''RES_MGR_LOW_PRIO_GROUP'', ',
'         comments                => ''This is a job class for SQL Workshop Data Loading jobs'' );',
'end;',
'/',
'',
unistr('-- 2. accorder un privil\00E8ge EXECUTE sur la classe de travail \00E0 l''utilisateur du moteur APEX'),
'--',
unistr('accorder un privil\00E8ge d''ex\00E9cution sur MY_LOADER_CLASS \00E0 apex_NNNNNN'),
'/',
'',
'-- 3. configurer la classe de travail ici ou utiliser APEX_INSTANCE_ADMIN.SET_PARAMETER',
'--',
'begin ',
'    apex_instance_admin.set_parameter( ',
'        p_parameter => ''BACKGROUND_JOB_CLASS'', ',
'        p_value     => ''MY_LOADER_CLASS'' ); ',
'end;',
'/',
'</pre>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(342227708889542932.4052)
,p_name=>'P131_CHANGE_SMTP_PWD'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(51160113641211250.4052)
,p_prompt=>'&nbsp;'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CONFIRM.SMTP.PWD.REMOVAL'
,p_lov=>'.'||wwv_flow_api.id(391596105997880413.4052)||'.'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(473369805402061276.4052)
,p_name=>'P131_AUTOEXTEND_TABLESPACES'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(103242102881123907.4052)
,p_item_default=>'N'
,p_prompt=>'Extension automatique des tablespaces'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_display_when=>'wwv_flow_platform.get_preference(''INSTANCE_TABLESPACE'') is null'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Si l''option Extension automatique des tablespaces est activ\00E9e, les tablespaces provisionn\00E9s avec &PRODUCT_NAME. sont cr\00E9\00E9s avec un fichier de donn\00E9es d''une taille correspondant au dixi\00E8me de la taille demand\00E9e. Le fichier de donn\00E9es sera automatiquem')
||unistr('ent \00E9tendu jusqu''\00E0 la taille demand\00E9e. Par exemple, si un utilisateur demande un espace de travail de 100 Mo, la taille initiale du fichier de donn\00E9es sera de 10 Mo et elle sera automatiquement \00E9tendue jusqu''\00E0 un maximum de 100 Mo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(473830021272979396.4052)
,p_name=>'P131_SYSTEM_HELP_URL'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(473748116639968529.4052)
,p_prompt=>'URL de l''aide'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Saisissez l''URL qui appara\00EEtra lorsque les utilisateurs cliqueront sur le lien d''aide \00E0 partir de l''environnement de d\00E9veloppement &PRODUCT_NAME.. En g\00E9n\00E9ral, il n''est pas n\00E9cessaire de modifier cette valeur.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(621102739327076424.4052)
,p_name=>'P131_PRINT_SVR_TIMEOUT'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_api.id(51162614555211253.4052)
,p_item_default=>'300'
,p_prompt=>unistr('D\00E9lai d''expiration de l''impression')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('D\00E9finit le d\00E9lai d''expiration du transfert lors de la communication avec le serveur d''impression, en secondes.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(663452589767166116.4052)
,p_name=>'P131_INSTANCE_TABLESPACE'
,p_item_sequence=>75
,p_item_plug_id=>wwv_flow_api.id(103242102881123907.4052)
,p_prompt=>'Tablespace d''instance'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_display_when=>'not wwv_flow_global.g_cloud'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Entrez le nom d''un tablespace de donn\00E9es existant qui servira pour l''utilisateur de base de donn\00E9es pour tous les nouveaux espaces de travail. S''il n''est pas d\00E9fini, un tablespace est cr\00E9\00E9.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(950438226578435659.4052)
,p_name=>'P131_WORKSPACE_EMAIL_MAXIMUM'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(51160113641211250.4052)
,p_prompt=>'Nombre maximal de courriels par espace de travail'
,p_format_mask=>'9999999999'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('D\00E9finit le nombre de messages \00E9lectroniques pouvant \00EAtre envoy\00E9s avec l''API <code>APEX_MAIL</code> par espace de travail en 24 heures.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(342227857468542933.4052)
,p_computation_sequence=>10
,p_computation_item=>'P131_CHANGE_SMTP_PWD'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Y'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P131_SMTP_USERNAME is null ',
'and ',
'wwv_flow_crypto.aes_decrypt_hex (',
'    wwv_flow_platform.get_preference( p_preference_name => ''SMTP_PASSWORD'' ),',
'    sys.wwv_flow_key.g_key ) is not null'))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(395969783618132297.4052)
,p_computation_sequence=>20
,p_computation_item=>'P131_SMTP_PASSWORD'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P131_SMTP_USERNAME is null ',
'and ',
'wwv_flow_crypto.aes_decrypt_hex (',
'    wwv_flow_platform.get_preference( p_preference_name => ''SMTP_PASSWORD'' ),',
'    sys.wwv_flow_key.g_key ) is not null'))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(103000728820661486.4052)
,p_validation_name=>'P131_DISABLE_WS_MSG'
,p_validation_sequence=>10
,p_validation=>'P131_DISABLE_WS_MSG'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Entrez le message que les utilisateurs doivent voir appara\00EEtre lorsque le provisionnement de l''espace de travail est d\00E9sactiv\00E9.')
,p_validation_condition=>'P131_DISABLE_WS_PROV'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(51164206531211254.4052)
,p_associated_item=>wwv_flow_api.id(102999118515639517.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(51188322273211271.4052)
,p_validation_name=>'P131_SMTP_HOST_PORT positive integer'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P131_SMTP_HOST_PORT );',
'    if l_number = abs(trunc(l_number)) then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La valeur doit \00EAtre un entier positif.')
,p_when_button_pressed=>wwv_flow_api.id(51164206531211254.4052)
,p_associated_item=>wwv_flow_api.id(51170811596211259.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(51188718999211271.4052)
,p_validation_name=>'P131_PRINT_SVR_PORT positive integer'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P131_PRINT_SVR_PORT);',
'    if l_number = abs(trunc(l_number)) then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La valeur doit \00EAtre un entier positif.')
,p_validation_condition=>'P131_PRINT_SVR_PORT'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(51164206531211254.4052)
,p_associated_item=>wwv_flow_api.id(51176319252211263.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57855403575150538.4052)
,p_validation_name=>'Validate numbers for workspace request size'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result boolean := TRUE;',
'    l_dummy  number;',
'begin',
'    for i in 1..apex_application.g_f01.count loop',
'        begin',
'            l_dummy := to_number(apex_application.g_f02(i));',
'        exception',
'            when others then',
'                l_result := FALSE;',
'        end;',
'    end loop;',
'    return l_result;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La taille de la demande de nouvel espace de travail doit \00EAtre une valeur num\00E9rique.')
,p_when_button_pressed=>wwv_flow_api.id(51164206531211254.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57860227124157419.4052)
,p_validation_name=>'Validate numbers for workspace change request size'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result boolean := TRUE;',
'    l_dummy  number;',
'begin',
'    for i in 1..apex_application.g_f05.count loop',
'        begin',
'            l_dummy := to_number(apex_application.g_f06(i));',
'        exception',
'            when others then',
'                l_result := FALSE;',
'        end;',
'    end loop;',
'    return l_result;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La taille de la demande de modification d''espace de travail doit \00EAtre une valeur num\00E9rique.')
,p_when_button_pressed=>wwv_flow_api.id(51164206531211254.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57865902583178701.4052)
,p_validation_name=>'Validate one size displayed for New Workspace Request'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result boolean := FALSE;',
'begin',
'    for i in 1..apex_application.g_f01.count loop',
'        if apex_application.g_f03(i) = ''Y'' then',
'            l_result := TRUE;',
'            exit;',
'        end if;',
'    end loop;',
'   return l_result;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Vous devez afficher au moins une taille de demande de nouvel espace de travail.'
,p_when_button_pressed=>wwv_flow_api.id(51164206531211254.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57870422107193812.4052)
,p_validation_name=>'Validate one size displayed for Workspace Change Request'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result boolean := FALSE;',
'begin',
'    for i in 1..apex_application.g_f05.count loop',
'        if apex_application.g_f07(i) = ''Y'' then',
'            l_result := TRUE;',
'            exit;',
'        end if;',
'    end loop;',
'   return l_result;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Vous devez afficher au moins une taille de demande de modification d''espace de travail.'
,p_when_button_pressed=>wwv_flow_api.id(51164206531211254.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57880021807222056.4052)
,p_validation_name=>'Validate default size is displayed for New Workspace Request'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result boolean := TRUE;',
'begin',
'    for i in 1..apex_application.g_f01.count loop',
'        if apex_application.g_f04(1) = apex_application.g_f01(i) then',
'            if apex_application.g_f03(i) = ''N'' then',
'                l_result := FALSE;',
'                exit;',
'            end if;',
'        end if;',
'    end loop;',
'   return l_result;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Vous devez afficher la taille de demande de nouvel espace de travail par d\00E9faut.')
,p_when_button_pressed=>wwv_flow_api.id(51164206531211254.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57883425532242100.4052)
,p_validation_name=>'Validate default size is displayed for Workspace Change Request'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result boolean := TRUE;',
'begin',
'    for i in 1..apex_application.g_f05.count loop',
'        if apex_application.g_f08(1) = apex_application.g_f05(i) then',
'            if apex_application.g_f07(i) = ''N'' then',
'                l_result := FALSE;',
'                exit;',
'            end if;',
'        end if;',
'    end loop;',
'   return l_result;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Vous devez afficher la taille de demande de modification d''espace de travail par d\00E9faut.')
,p_when_button_pressed=>wwv_flow_api.id(51164206531211254.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(139697330628568620.4052)
,p_validation_name=>'P131_DELETE_UPLOADED_FILES must be positive, whole number'
,p_validation_sequence=>100
,p_validation=>'P131_DELETE_UPLOADED_FILES'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('Le param\00E8tre Supprimer les fichiers t\00E9l\00E9charg\00E9s apr\00E8s doit \00EAtre un entier positif.')
,p_when_button_pressed=>wwv_flow_api.id(51164206531211254.4052)
,p_associated_item=>wwv_flow_api.id(138925711619515767.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(208085229932907015.4052)
,p_validation_name=>'P131_APPLICATION_ID_MIN'
,p_validation_sequence=>110
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'   :P131_APPLICATION_ID_MAX is null',
'or :P131_APPLICATION_ID_MIN is not null'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Indiquer un ID minimal si un ID maximal est sp\00E9cifi\00E9')
,p_when_button_pressed=>wwv_flow_api.id(51164206531211254.4052)
,p_associated_item=>wwv_flow_api.id(203128029832230759.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(621102866377076425.4052)
,p_validation_name=>'transfer timeout in seconds'
,p_validation_sequence=>120
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_number number;',
'begin',
'    l_number := to_number( :P131_PRINT_SVR_TIMEOUT);',
'    if l_number = abs(trunc(l_number)) then',
'        return TRUE;',
'    else ',
'        return FALSE;',
'    end if;',
'exception',
'    when others then',
'        return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Le d\00E9lai d''expiration du transfert doit \00EAtre un nombre sup\00E9rieur \00E0 0.')
,p_associated_item=>wwv_flow_api.id(621102739327076424.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
end;
/
begin
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(8024913989822393.4052)
,p_name=>'disable print settings'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P131_PRINT_BIB_LICENSED'
,p_condition_element=>'P131_PRINT_BIB_LICENSED'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'APEX_LISTENER, NONE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(8025226260822401.4052)
,p_event_id=>wwv_flow_api.id(8024913989822393.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P131_PRINT_SVR_PROTOCOL,P131_PRINT_SVR_HOST,P131_PRINT_SVR_PORT,P131_PRINT_SVR_SCRIPT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(8025428770822403.4052)
,p_event_id=>wwv_flow_api.id(8024913989822393.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P131_PRINT_SVR_PROTOCOL,P131_PRINT_SVR_HOST,P131_PRINT_SVR_PORT,P131_PRINT_SVR_SCRIPT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(189719304618358023.4052)
,p_event_id=>wwv_flow_api.id(8024913989822393.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P131_PRINT_SVR_PROTOCOL,P131_PRINT_SVR_HOST,P131_PRINT_SVR_PORT,P131_PRINT_SVR_SCRIPT'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(183851346897893724.4052)
,p_name=>'Enable API Key'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P131_PRINT_BIB_LICENSED'
,p_condition_element=>'P131_PRINT_BIB_LICENSED'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'AOP'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183851482372893725.4052)
,p_event_id=>wwv_flow_api.id(183851346897893724.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P131_API_KEY'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183851593197893726.4052)
,p_event_id=>wwv_flow_api.id(183851346897893724.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P131_API_KEY'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(51189632142211272.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch values from platform prefs table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P131_SERVICE_REQUEST_FLOW := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''SERVICE_REQUEST_FLOW'' );',
'',
':P131_INSTANCE_URL := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''EMAIL_INSTANCE_URL'' );',
'',
':P131_INSTANCE_TABLESPACE := ',
'     wwv_flow_platform.get_preference( p_preference_name => ''INSTANCE_TABLESPACE'');',
'',
':P131_IMAGES_URL := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''EMAIL_IMAGES_URL'' );',
'',
':P131_DISABLE_WS_PROV := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''DISABLE_WS_PROV'' );',
'',
'if nvl(:P131_DISABLE_WS_PROV,''x'') = ''Y'' then',
'   :P131_DISABLE_WS_MSG := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''DISABLE_WS_MSG'' );',
'end if;',
'',
':P131_req_new_schema := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''REQ_NEW_SCHEMA'' );',
'',
':P131_SMTP_FROM := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''SMTP_FROM'' );',
'',
':P131_SMTP_HOST_ADDRESS := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''SMTP_HOST_ADDRESS'' );',
'',
':P131_SMTP_HOST_PORT := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''SMTP_HOST_PORT'' );',
'',
':P131_SMTP_USERNAME := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''SMTP_USERNAME'' );',
'',
':P131_SMTP_PASSWORD := ',
'    wwv_flow_crypto.aes_decrypt_hex (',
'        wwv_flow_platform.get_preference( p_preference_name => ''SMTP_PASSWORD'' ),',
'        sys.wwv_flow_key.g_key );',
'',
':P131_SMTP_TLS_MODE := ',
'    nvl(wwv_flow_platform.get_preference( p_preference_name => ''SMTP_TLS_MODE'' ), ''N'');',
'',
':P131_PRINT_BIB_LICENSED  := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''PRINT_BIB_LICENSED'' );',
'',
':P131_PRINT_SVR_PROTOCOL := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''PRINT_SVR_PROTOCOL'' );',
'',
':P131_PRINT_SVR_HOST := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''PRINT_SVR_HOST'' );',
'',
':P131_PRINT_SVR_PORT := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''PRINT_SVR_PORT'' );',
'',
':P131_PRINT_SVR_SCRIPT := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''PRINT_SVR_SCRIPT'' );',
'',
':P131_API_KEY := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''PRINT_SVR_API_KEY'' );',
'',
':P131_PRINT_SVR_TIMEOUT := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''PRINT_SVR_TIMEOUT'' );',
'',
':P131_BIGFILE_TABLESPACES :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''BIGFILE_TABLESPACES_ENABLED'' );',
'',
':P131_ENCRYPTED_TABLESPACES :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''ENCRYPTED_TABLESPACES_ENABLED'' );',
'',
':P131_AUTOAPPROVE_STORAGE := ',
'    wwv_flow_platform.get_preference( p_preference_name => ''AUTOAPPROVE_STORAGE_LIMIT'' );',
'',
'declare',
'    l_wallet wwv_flow_security.t_wallet := wwv_flow_security.get_wallet;',
'begin',
'    :P131_WALLET_PATH := l_wallet.wallet_path;',
'    :P131_WALLET_PWD := l_wallet.wallet_pwd;',
'end;',
'',
':P131_NOTIFICATION_EMAIL :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''NOTIFICATION_EMAIL'' );',
'',
':P131_AUTOEXTEND_TABLESPACES :=     ',
'    wwv_flow_platform.get_preference( p_preference_name => ''AUTOEXTEND_TABLESPACES'' );',
'',
':P131_REQUIRE_VERIFICATION_CODE :=     ',
'    wwv_flow_platform.get_preference( p_preference_name => ''REQUIRE_VERIFICATION_CODE'' );',
'',
':P131_DELETE_UPLOADED_FILES :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''DELETE_UPLOADED_FILES_AFTER_DAYS'' );',
'',
':P131_SYSTEM_HELP_URL :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''SYSTEM_HELP_URL'' );',
'',
':P131_GETTING_STARTED := ',
'    wwv_flow_platform.get_preference( p_preference_name  => ''GETTING_STARTED_ENABLED'' );',
'',
':P131_WORKSPACE_EMAIL_MAXIMUM :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''WORKSPACE_EMAIL_MAXIMUM'' );',
'',
':P131_APPLICATION_ID_MIN :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''APPLICATION_ID_MIN'' );',
'',
':P131_APPLICATION_ID_MAX :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''APPLICATION_ID_MAX'' );',
'    ',
':P131_BACKGROUND_JOB_CLASS :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''BACKGROUND_JOB_CLASS'' );',
'    ',
':P131_BACKGRND_MIN_EXEC_CADENCE :=',
'    wwv_flow_platform.get_preference( p_preference_name => ''BACKGROUND_MIN_EXECUTION_CADENCE'' );',
'    ',
''))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(51189800276211273.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Apply Changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* replaced with call to set_provisioning_method()',
'wwv_flow_platform.set_preference( ',
'    p_preference_name  => ''SERVICE_REQUEST_FLOW'',',
'    p_preference_value => :P131_SERVICE_REQUEST_FLOW );',
'*/',
'',
'wwv_flow_admin_api.set_provisioning_method(',
'    p_method => :P131_SERVICE_REQUEST_FLOW );',
'',
'wwv_flow_platform.set_preference( ',
'    p_preference_name  => ''EMAIL_INSTANCE_URL'',',
'    p_preference_value => :P131_INSTANCE_URL );',
'',
'wwv_flow_platform.set_preference( ',
'    p_preference_name  => ''EMAIL_IMAGES_URL'',',
'    p_preference_value => :P131_IMAGES_URL );',
'',
'wwv_flow_platform.set_preference( ',
'    p_preference_name  => ''DISABLE_WS_PROV'',',
'    p_preference_value => :P131_DISABLE_WS_PROV );',
'',
'wwv_flow_platform.set_preference( ',
'    p_preference_name  => ''INSTANCE_TABLESPACE'',',
'    p_preference_value => :P131_INSTANCE_TABLESPACE );',
'    ',
'wwv_flow_platform.set_preference( ',
'    p_preference_name  => ''BACKGROUND_JOB_CLASS'',',
'    p_preference_value => :P131_BACKGROUND_JOB_CLASS );',
'',
'wwv_flow_platform.set_preference( ',
'    p_preference_name  => ''BACKGROUND_MIN_EXECUTION_CADENCE'',',
'    p_preference_value => :P131_BACKGRND_MIN_EXEC_CADENCE );',
'',
'if nvl(:P131_DISABLE_WS_PROV,''x'') = ''Y'' then',
'   wwv_flow_platform.set_preference(',
'       p_preference_name  => ''DISABLE_WS_MSG'',',
'       p_preference_value => :P131_DISABLE_WS_MSG );',
'end if;',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''REQ_NEW_SCHEMA'',',
'    p_preference_value => :P131_req_new_schema );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''SMTP_FROM'',',
'    p_preference_value => :P131_SMTP_FROM );',
'',
'wwv_flow_platform.set_preference( ',
'    p_preference_name  => ''SMTP_HOST_ADDRESS'',',
'    p_preference_value => :P131_SMTP_HOST_ADDRESS );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''SMTP_HOST_PORT'',',
'    p_preference_value => :P131_SMTP_HOST_PORT );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''SMTP_USERNAME'',',
'    p_preference_value => :P131_SMTP_USERNAME );',
'',
'if :P131_CHANGE_SMTP_PWD = ''Y'' then',
'    wwv_flow_platform.set_preference(',
'        p_preference_name  => ''SMTP_PASSWORD'',',
'        p_preference_value => wwv_flow_crypto.aes_encrypt_hex (',
'                              p_src => :P131_SMTP_PASSWORD,',
'                              p_key => sys.wwv_flow_key.g_key ) );',
'end if;',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''SMTP_TLS_MODE'',',
'    p_preference_value => :P131_SMTP_TLS_MODE );',
'',
'wwv_flow_platform.set_preference( ',
'    p_preference_name  => ''PRINT_BIB_LICENSED'',',
'    p_preference_value => :P131_PRINT_BIB_LICENSED );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''PRINT_SVR_PROTOCOL'',',
'    p_preference_value => :P131_PRINT_SVR_PROTOCOL );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''PRINT_SVR_HOST'',',
'    p_preference_value => :P131_PRINT_SVR_HOST );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''PRINT_SVR_PORT'',',
'    p_preference_value => :P131_PRINT_SVR_PORT );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''PRINT_SVR_SCRIPT'',',
'    p_preference_value => :P131_PRINT_SVR_SCRIPT );',
'    ',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''PRINT_SVR_TIMEOUT'',',
'    p_preference_value => :P131_PRINT_SVR_TIMEOUT );    ',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''PRINT_SVR_API_KEY'',',
'    p_preference_value => :P131_API_KEY );    ',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''NOTIFICATION_EMAIL'',',
'    p_preference_value => :P131_NOTIFICATION_EMAIL );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''AUTOEXTEND_TABLESPACES'',',
'    p_preference_value => :P131_AUTOEXTEND_TABLESPACES );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''AUTOAPPROVE_STORAGE_LIMIT'',',
'    p_preference_value => :P131_AUTOAPPROVE_STORAGE );',
'    ',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''REQUIRE_VERIFICATION_CODE'',',
'    p_preference_value => :P131_REQUIRE_VERIFICATION_CODE );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''DELETE_UPLOADED_FILES_AFTER_DAYS'',',
'    p_preference_value => :P131_DELETE_UPLOADED_FILES );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''SYSTEM_HELP_URL'',',
'    p_preference_value => :P131_SYSTEM_HELP_URL );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''GETTING_STARTED_ENABLED'',',
'    p_preference_value => :P131_GETTING_STARTED );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''WORKSPACE_EMAIL_MAXIMUM'',',
'    p_preference_value => :P131_WORKSPACE_EMAIL_MAXIMUM );',
'',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''BIGFILE_TABLESPACES_ENABLED'',',
'    p_preference_value => :P131_BIGFILE_TABLESPACES );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''ENCRYPTED_TABLESPACES_ENABLED'',',
'    p_preference_value => :P131_ENCRYPTED_TABLESPACES );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''APPLICATION_ID_MIN'',',
'    p_preference_value => :P131_APPLICATION_ID_MIN );',
'',
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''APPLICATION_ID_MAX'',',
'    p_preference_value => :P131_APPLICATION_ID_MAX );',
'',
'declare',
'    l_wallet wwv_flow_security.t_wallet;',
'begin',
'    l_wallet := wwv_flow_security.get_wallet;',
'    l_wallet.wallet_path := :P131_WALLET_PATH;',
'    if :P131_CHANGE_WALLET_PWD = ''Y'' then',
'        l_wallet.wallet_pwd  := :P131_WALLET_PWD;',
'    end if;',
'    wwv_flow_security.set_wallet(l_wallet);',
'end;',
'',
'--',
'-- Update the rows for new workspace request sizes',
'--',
'',
'for i in 1..apex_application.g_f01.count loop',
'    update wwv_flow_workspace_req_size',
'       set req_size = apex_application.g_f02(i),',
'           display = apex_application.g_f03(i),',
'           default_size = decode(apex_application.g_f04(1),apex_application.g_f01(i),''Y'',''N'')',
'     where id = apex_application.g_f01(i);',
'end loop;',
'',
'--',
'-- Update the rows for new workspace request sizes',
'--',
'for i in 1..apex_application.g_f05.count loop',
'    update wwv_flow_workspace_req_size',
'       set req_size = apex_application.g_f06(i),',
'           display = apex_application.g_f07(i),',
'           default_size = decode(apex_application.g_f08(1),apex_application.g_f05(i),''Y'',''N'')',
'     where id = apex_application.g_f05(i);',
'end loop;',
'',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible d''enregistrer les param\00E8tres d''instance.')
,p_process_when_button_id=>wwv_flow_api.id(51164206531211254.4052)
,p_process_success_message=>unistr('Param\00E8tres d''instance enregistr\00E9s.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(51190008410211273.4052)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'131'
);
end;
/
prompt --application/pages/page_00132
begin
wwv_flow_api.create_page(
 p_id=>132.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Message du syst\00E8me')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Message du syst\00E8me')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216766702444596508)
,p_step_template=>wwv_flow_api.id(721103220819687982.4052)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'450'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEADM/adm_env_sec.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(51277208235355971.4052)
,p_plug_name=>unistr('Message du syst\00E8me')
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>150
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(955889433218997305.4052)
,p_plug_name=>'wizard buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>160
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(955889525421997306.4052)
,p_plug_name=>unistr('Message du syst\00E8me')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(51281510605355975.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(955889433218997305.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(51281700671355975.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(955889433218997305.4052)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(168507923702817963.4052)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(51284327975355978.4052)
,p_name=>'P132_CUSTOM_SYSTEM_MESSAGE'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(51277208235355971.4052)
,p_prompt=>'Message'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>10
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Saisissez le texte \00E0 afficher dans les pages d''accueil &PRODUCT_NAME.. Ce texte peut comprendre du HTML.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(206355098017953023.4052)
,p_name=>'Cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(51281510605355975.4052)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(206355114399953024.4052)
,p_event_id=>wwv_flow_api.id(206355098017953023.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(51307110864355993.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch values from platform prefs table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- System message',
'--',
':P132_CUSTOM_SYSTEM_MESSAGE := wwv_flow_platform.get_preference( p_preference_name => ''SYSTEM_MESSAGE'' );'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(51307320446355994.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Apply Changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- If custom system message, then set the actual message to be displayed.',
'--',
'if trim( :P132_CUSTOM_SYSTEM_MESSAGE ) is not null then',
'    wwv_flow_platform.set_preference( p_preference_name  => ''SYSTEM_MESSAGE'',',
'                                      p_preference_value => trim( :P132_CUSTOM_SYSTEM_MESSAGE ) );',
'else',
'    --',
'    -- Otherwise, clear out the message.',
'    --',
'    wwv_flow_platform.set_preference( p_preference_name => ''SYSTEM_MESSAGE'',',
'                                      p_preference_value => null );',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible de mettre \00E0 jour le message du syst\00E8me.')
,p_process_when_button_id=>wwv_flow_api.id(51281700671355975.4052)
,p_process_success_message=>unistr('Message du syst\00E8me mis \00E0 jour.')
);
end;
/
prompt --application/pages/page_00133
begin
wwv_flow_api.create_page(
 p_id=>133.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Param\00E8tres de purge d''espace de travail')
,p_step_title=>unistr('Param\00E8tres de purge d''espace de travail')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931176884177111905)
,p_step_template=>wwv_flow_api.id(704456563630760825.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>'AEADM/adm_purge_wrkspc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(499047717270425788.4052)
,p_plug_name=>unistr('Param\00E8tres de purge d''espace de travail')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(505870209144885310.4052)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Les espaces de travail inactifs pendant une dur\00E9e sup\00E9rieure \00E0 celle indiqu\00E9e dans <strong>Jours d''inactivit\00E9</strong> sont concern\00E9s par la purge. Si l''inactivit\00E9 d''un espace de travail se prolonge et qu''un administrateur d''espace de travail n''in')
||unistr('dique pas qu''il souhaite le conserver dans le champ <strong>Jours restants avant la purge</strong>, l''espace de travail sera purg\00E9.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1000726106612503643.4052)
,p_plug_name=>unistr('Param\00E8tres de purge d''espace de travail')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(505870712392895770.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(499047717270425788.4052)
,p_button_name=>'MONITOR_ACTIVITY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_image_alt=>unistr('Surveiller l''activit\00E9')
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:99:&SESSION.::&DEBUG.:99::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(499039317740409355.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1000726106612503643.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(499039505384409356.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1000726106612503643.4052)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(499041117486416415.4052)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(499058222306540814.4052)
,p_name=>'P133_ENABLED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(499047717270425788.4052)
,p_item_default=>'N'
,p_prompt=>unistr('Activ\00E9')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Si vous activez le processus de purge d''espace de travail, un travail de base de donn\00E9es sera ex\00E9cut\00E9 pendant la nuit et recherchera les espaces de travail inactifs de votre instance. Les administrateurs d''espace de travail seront inform\00E9s par messag')
||unistr('e \00E9lectronique de la purge de leur espace de travail, qu''ils auront la possibilit\00E9 de refuser.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(499080721463729720.4052)
,p_name=>'P133_ADMIN_EMAIL'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(499047717270425788.4052)
,p_item_default=>'wwv_flow_platform.get_preference( p_preference_name => ''SMTP_FROM'' )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Adresse \00E9lectronique de l''administration de la purge')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Entrez l''adresse \00E9lectronique qui sera utilis\00E9e pour le processus de purge d''espace de travail. Cette adresse \00E9lectronique sera utilis\00E9e comme exp\00E9diteur dans les messages envoy\00E9s aux administrateurs d''espace de travail. Elle sera \00E9galement affich\00E9e ')
||unistr('sur la page Purge de l''espace de travail, pour que les utilisateurs puissent y avoir acc\00E8s en cas de probl\00E8mes ou de questions.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(499096026442740631.4052)
,p_name=>'P133_SUMMARY_EMAIL_TO'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(499047717270425788.4052)
,p_item_default=>'wwv_flow_platform.get_preference( p_preference_name => ''NOTIFICATION_EMAIL'' )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Envoyer un courriel r\00E9capitulatif \00E0')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Entrez une liste d''adresses \00E9lectroniques s\00E9par\00E9es par des virgules pour recevoir l''\00E9tat r\00E9capitulatif quotidien des purges automatiques d''espace de travail par courriel. Si aucune adresse n''est indiqu\00E9e, aucun \00E9tat r\00E9capitulatif ne sera g\00E9n\00E9r\00E9.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(499096813067746221.4052)
,p_name=>'P133_DAYS_TO_PURGE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(499047717270425788.4052)
,p_item_default=>'10'
,p_prompt=>'Jours restants avant la purge'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Entrez le nombre de jours dont dispose un administrateur d''espace de travail entre la premi\00E8re notification par courriel indiquant que son espace de travail va \00EAtre purg\00E9 et la purge de l''espace de travail. Par exemple, si la valeur ''10'' est indiqu\00E9e')
||unistr(', chaque administrateur d''espace de travail re\00E7oit une notification par courriel indiquant que la purge aura lieu dans 10 jours.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(499097827743759953.4052)
,p_name=>'P133_REMINDER_DAYS_IN_ADVANCE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(499047717270425788.4052)
,p_item_default=>'3'
,p_prompt=>unistr('Jours \00E0 l''avance du rappel')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Entrez le nombre de jours entre la date de l''envoi d''un message \00E9lectronique de rappel \00E0 l''administrateur d''espace de travail et la purge de l''espace de travail. Ce nombre doit \00EAtre inf\00E9rieur \00E0 la valeur des jours restants avant la purge. Par exemple')
||unistr(', si la valeur ''3'' est indiqu\00E9e, un courriel de rappel est envoy\00E9 \00E0 chaque administrateur d''espace de travail 3 jours avant la purge.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(499098203979762532.4052)
,p_name=>'P133_DAYS_INACTIVE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(499047717270425788.4052)
,p_item_default=>'45'
,p_prompt=>unistr('Jours d''inactivit\00E9')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Entrez le nombre de jours d''inactivit\00E9 \00E0 partir duquel le processus de purge d''espace de travail signale un espace de travail comme inactif. "Inactif" signifie que personne ne s''est connect\00E9 \00E0 l''espace de travail et qu''aucune de ses applications n''a ')
||unistr('\00E9t\00E9 utilis\00E9e pendant cette p\00E9riode. Par exemple, la valeur ''45'' signifie qu''un espace de travail sera jug\00E9 inactif s''il n''a pas \00E9t\00E9 utilis\00E9 au cours des 45 derniers jours.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(499098415754765978.4052)
,p_name=>'P133_GRACE_PERIOD_DAYS'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(499047717270425788.4052)
,p_item_default=>'45'
,p_prompt=>unistr('D\00E9lai de gr\00E2ce (jours)')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Entrez le nombre de jours dont dispose un administrateur d''espace de travail avant que l''espace de travail ne soit \00E0 nouveau jug\00E9 inactif. Cela ne s''applique qu''aux espaces de travail inactifs qui ont d\00E9j\00E0 \00E9t\00E9 signal\00E9s comme tels et pour lesquels l''a')
||unistr('dministrateur a refus\00E9 la purge.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(499098709997773731.4052)
,p_name=>'P133_MAX_RUN_HOURS'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(499047717270425788.4052)
,p_prompt=>unistr('Temps maximal d''ex\00E9cution (heures)')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Entrez la dur\00E9e maximale, en heures, pendant laquelle le processus de purge d''espace de travail peut \00EAtre ex\00E9cut\00E9 chaque jour.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(499098922464777386.4052)
,p_name=>'P133_MAX_WORKSPACES'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(499047717270425788.4052)
,p_prompt=>'Nombre maximal d''espaces de travail'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Entrez le nombre maximal d''espaces de travail qui peuvent \00EAtre purg\00E9s par le processus de purge lors de chaque ex\00E9cution. Par exemple, si l''option Nombre maximal d''espaces de travail est d\00E9finie sur ''1'', un seul espace de travail peut \00EAtre purg\00E9 par ')
||'jour.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(499099100432780444.4052)
,p_name=>'P133_MAX_EMAILS'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(499047717270425788.4052)
,p_prompt=>'Nombre maximal de courriels'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Entrez le nombre maximal de courriels qui peuvent \00EAtre envoy\00E9s par le processus de purge d''espace de groupe lors de chaque ex\00E9cution. Par exemple, si l''option Nombre maximal de courriels est d\00E9finie sur ''1'', un seul espace de travail peut \00EAtre purg\00E9 ')
||'par jour.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(502998908381251930.4052)
,p_name=>'P133_PURGE_LANG'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(499047717270425788.4052)
,p_item_default=>'wwv_flow.g_browser_language'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Langue'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LANGUAGES_INSTALLED'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lang_name, flow_language from ',
'(select (select max( translated_lang_name) from wwv_flow_languages l where l.lang_id = f.flow_language) lang_name, flow_language',
'  from wwv_flows f',
' where id = 4411',
'   and security_group_id = 10',
' union',
' select (select max(translated_lang_name) from wwv_flow_languages l where l.lang_id = f.flow_language) lang_name, flow_language',
'   from wwv_flows f',
'  where security_group_id = 10',
'    and id in ',
'      ( select translation_flow_id',
'          from wwv_flow_language_map',
'         where security_group_id = 10',
'           and primary_language_flow_id = 4411)',
'  order by 1)'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Indiquez la langue \00E0 utiliser dans les courriels g\00E9n\00E9r\00E9s \00E0 partir du processus de purge d''espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(502716121149177100.4052)
,p_validation_name=>'P133_ADMIN_EMAIL'
,p_validation_sequence=>20
,p_validation=>'P133_ADMIN_EMAIL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Vous devez indiquer une valeur.'
,p_validation_condition=>'P133_ENABLED'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(499080721463729720.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(502716430845179900.4052)
,p_validation_name=>'P133_DAYS_INACTIVE'
,p_validation_sequence=>30
,p_validation=>'P133_DAYS_INACTIVE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Vous devez indiquer une valeur.'
,p_validation_condition=>'P133_ENABLED'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(499098203979762532.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(502716603272181381.4052)
,p_validation_name=>'P133_DAYS_TO_PURGE'
,p_validation_sequence=>40
,p_validation=>'P133_DAYS_TO_PURGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Vous devez indiquer une valeur.'
,p_validation_condition=>'P133_ENABLED'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(499096813067746221.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(502717308813183024.4052)
,p_validation_name=>'P133_GRACE_PERIOD_DAYS'
,p_validation_sequence=>50
,p_validation=>'P133_GRACE_PERIOD_DAYS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Vous devez indiquer une valeur.'
,p_validation_condition=>'P133_ENABLED'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(499098415754765978.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(502717515046184868.4052)
,p_validation_name=>'P133_REMINDER_DAYS_IN_ADVANCE'
,p_validation_sequence=>60
,p_validation=>'P133_REMINDER_DAYS_IN_ADVANCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Vous devez indiquer une valeur.'
,p_validation_condition=>'P133_ENABLED'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(499097827743759953.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(502677028187037234.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Apply Changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_platform.set_preference( p_preference_name => ''PURGE_ENABLED'',',
'                                  p_preference_value => :P133_ENABLED );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PURGE_LANG'',',
'                                  p_preference_value => :P133_PURGE_LANG );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PURGE_ADMIN_EMAIL'',',
'                                  p_preference_value => :P133_ADMIN_EMAIL );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PURGE_SUMMARY_EMAIL_TO'',',
'                                  p_preference_value => :P133_SUMMARY_EMAIL_TO );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PURGE_DAYS_TO_PURGE'',',
'                                  p_preference_value => :P133_DAYS_TO_PURGE );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PURGE_REMINDER_DAYS_IN_ADVANCE'',',
'                                  p_preference_value => :P133_REMINDER_DAYS_IN_ADVANCE );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PURGE_DAYS_INACTIVE'',',
'                                  p_preference_value => :P133_DAYS_INACTIVE );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PURGE_GRACE_PERIOD_DAYS'',',
'                                  p_preference_value => :P133_GRACE_PERIOD_DAYS );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PURGE_MAX_RUN_HOURS'',',
'                                  p_preference_value => :P133_MAX_RUN_HOURS );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PURGE_MAX_WORKSPACES'',',
'                                  p_preference_value => :P133_MAX_WORKSPACES );',
'--',
'wwv_flow_platform.set_preference( p_preference_name => ''PURGE_MAX_EMAILS'',',
'                                  p_preference_value => :P133_MAX_EMAILS );',
'--'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Impossible d''enregistrer les param\00E8tres de purge d''espace de travail.')
,p_process_when_button_id=>wwv_flow_api.id(499039505384409356.4052)
,p_process_success_message=>unistr('Param\00E8tres de purge d''espace de travail enregistr\00E9s.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(502505801129001088.4052)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Purge Preference Values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P133_ENABLED := wwv_flow_platform.get_preference( p_preference_name => ''PURGE_ENABLED'' );',
':P133_ADMIN_EMAIL := wwv_flow_platform.get_preference( p_preference_name => ''PURGE_ADMIN_EMAIL'' );',
':P133_SUMMARY_EMAIL_TO := wwv_flow_platform.get_preference( p_preference_name => ''PURGE_SUMMARY_EMAIL_TO'' );',
':P133_DAYS_TO_PURGE := wwv_flow_platform.get_preference( p_preference_name => ''PURGE_DAYS_TO_PURGE'' );',
':P133_REMINDER_DAYS_IN_ADVANCE := wwv_flow_platform.get_preference( p_preference_name => ''PURGE_REMINDER_DAYS_IN_ADVANCE'' );',
':P133_DAYS_INACTIVE := wwv_flow_platform.get_preference( p_preference_name => ''PURGE_DAYS_INACTIVE'' );',
':P133_GRACE_PERIOD_DAYS := wwv_flow_platform.get_preference( p_preference_name => ''PURGE_GRACE_PERIOD_DAYS'' );',
':P133_MAX_RUN_HOURS := wwv_flow_platform.get_preference( p_preference_name => ''PURGE_MAX_RUN_HOURS'' );',
':P133_MAX_WORKSPACES := wwv_flow_platform.get_preference( p_preference_name => ''PURGE_MAX_WORKSPACES'' );',
':P133_MAX_EMAILS := wwv_flow_platform.get_preference( p_preference_name => ''PURGE_MAX_EMAILS'' );',
':P133_PURGE_LANG := wwv_flow_platform.get_preference( p_preference_name => ''PURGE_LANG'' );',
'--',
'commit;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00135
begin
wwv_flow_api.create_page(
 p_id=>135.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Cr\00E9er plusieurs espaces de travail')
,p_step_title=>unistr('Cr\00E9er plusieurs espaces de travail')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931243707245169747)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(388175530101368961.4052)
,p_plug_name=>'Create Multiple Workspaces'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(388175723863368963.4052)
,p_name=>'Workspace Administrators'
,p_parent_plug_id=>wwv_flow_api.id(388175530101368961.4052)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lower(c001) username, ',
'       lower(c002) email, ',
'       c003 workspace,',
'       c013 schema,',
'       c004 app, ',
'       c005 ws,',
'       c006 tab,',
'       c007 quota,',
'       c009 consumer_group,',
'       c010 invite,',
'       c011 auto_purge,',
'       decode(c012,null,null,substr(c012,1,5)||''...'') comments,',
'       SEQ_ID',
'  from apex_collections',
' where collection_name = ''BULK_USER_CREATE''',
'order by 1'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(388175927775368964.4052)
,p_query_column_id=>1
,p_column_alias=>'USERNAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nom utilisateur'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(388176006661368964.4052)
,p_query_column_id=>2
,p_column_alias=>'EMAIL'
,p_column_display_sequence=>3
,p_column_heading=>'Email'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(388177113081368964.4052)
,p_query_column_id=>3
,p_column_alias=>'WORKSPACE'
,p_column_display_sequence=>1
,p_column_heading=>'Espace de travail'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(388313116913954235.4052)
,p_query_column_id=>4
,p_column_alias=>'SCHEMA'
,p_column_display_sequence=>13
,p_column_heading=>unistr('Sch\00E9ma de base de donn\00E9es')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(388176412190368964.4052)
,p_query_column_id=>5
,p_column_alias=>'APP'
,p_column_display_sequence=>6
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_hidden_column=>'Y'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(157992123774592395)
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(388176523678368964.4052)
,p_query_column_id=>6
,p_column_alias=>'WS'
,p_column_display_sequence=>5
,p_column_heading=>'Websheet'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_hidden_column=>'Y'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(157992123774592395)
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(388176624329368964.4052)
,p_query_column_id=>7
,p_column_alias=>'TAB'
,p_column_display_sequence=>7
,p_column_heading=>'Tables'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_hidden_column=>'Y'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(157992123774592395)
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(388176311196368964.4052)
,p_query_column_id=>8
,p_column_alias=>'QUOTA'
,p_column_display_sequence=>4
,p_column_heading=>'Quota (MB)'
,p_heading_alignment=>'RIGHT'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(388176121257368964.4052)
,p_query_column_id=>9
,p_column_alias=>'CONSUMER_GROUP'
,p_column_display_sequence=>10
,p_column_heading=>'Consumer Group'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(388176210056368964.4052)
,p_query_column_id=>10
,p_column_alias=>'INVITE'
,p_column_display_sequence=>9
,p_column_heading=>'Email Invitation'
,p_column_alignment=>'CENTER'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(388176931692368964.4052)
,p_query_column_id=>11
,p_column_alias=>'AUTO_PURGE'
,p_column_display_sequence=>8
,p_column_heading=>'Automatic Purge'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_hidden_column=>'Y'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(157992123774592395)
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(388177027338368964.4052)
,p_query_column_id=>12
,p_column_alias=>'COMMENTS'
,p_column_display_sequence=>11
,p_column_heading=>'Comments'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(388176806010368964.4052)
,p_query_column_id=>13
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>12
,p_column_heading=>'Sequence ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(388177705986368965.4052)
,p_plug_name=>'Information'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>10
,p_plug_source=>unistr('<p>Les espaces de travail suivants ont \00E9t\00E9 provisionn\00E9s. Prenez note de ces informations.</p>')
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(388177907687368965.4052)
,p_plug_name=>'create multiple workspaces'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_api.id(203141106443364145.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(388178122034368965.4052)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752112983897695873.4052)
,p_plug_name=>unistr('Cr\00E9er plusieurs espaces de travail')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(388178328415368965.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(388178122034368965.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(388178720999368966.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(388178122034368965.4052)
,p_button_name=>'DONE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Termin\00E9')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::'
);
end;
/
prompt --application/pages/page_00136
begin
wwv_flow_api.create_page(
 p_id=>136.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Mod\00E8le d''authentification de d\00E9veloppeur')
,p_step_title=>unistr('Mod\00E8le d''authentification de d\00E9veloppeur')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>'AEADM/adm_config_sec.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(39564106377656610.4052)
,p_plug_name=>unistr('SAML pour les applications internes et d''espace de travail : attributs de fournisseur d''identit\00E9s')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P136_SCHEME_TYPE'
,p_plug_display_when_cond2=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(117761677507717707.4052)
,p_plug_name=>'Informations d''identification OAuth2'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P136_SCHEME_TYPE'
,p_plug_display_when_cond2=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(141706009970230961.4052)
,p_plug_name=>unistr('Modifier un mod\00E8le d''authentification')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>10
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_AUTHENTICATIONS'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
unistr('// masquer instantan\00E9ment les attributs dynamiques une fois affich\00E9s, '),
unistr('// l''ex\00E9cution de jQuery.ready peut \00EAtre trop longue. '),
'apex.builder.dynamicAttributes.hide(''P136_'');',
'</script>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(141708219487230974.4052)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('L''authentification est le processus consistant \00E0 \00E9tablir l''identit\00E9 de chaque utilisateur pour que celui-ci puisse acc\00E9der \00E0 votre application.'),
'</p>',
'<p>',
unistr('Utilisez cette page pour modifier les mod\00E8les d''authentification et d\00E9finir le mod\00E8le que les applications Application Express internes doivent employer. Le mod\00E8le d''authentification en cours d\00E9termine la fa\00E7on dont les applications identifient et v\00E9')
||unistr('rifient le d\00E9veloppeur. En fonction du type de mod\00E8le d''authentification s\00E9lectionn\00E9, vous pouvez configurer divers param\00E8tres pour affiner le comportement de l''authentification.'),
'</p>',
'<p>',
unistr('<strong>Remarque :</strong> m\00EAme pour les mod\00E8les d''authentification externes (par exemple, <em>Variable d''en-t\00EAte HTTP</em>), vous devez vous assurer que les utilisateurs existent en tant que d\00E9veloppeurs ou administrateurs dans les espaces de trava')
||unistr('il. Sinon, &PRODUCT_NAME. ne pourra pas v\00E9rifier dans quel espace de travail un utilisateur est autoris\00E9 \00E0 travailler.')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(141711500624292722.4052)
,p_plug_name=>'Add Javascript code for Plugins'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>60
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- create the onChange event for the P136_SCHEME_TYPE and',
'    -- also the initialization code for the dynamic attributes',
'    wwv_flow_plugin_dev.add_onload_code (',
'        p_application_id      => wwv_flow.g_flow_id,',
'        p_plugin_type         => wwv_flow_plugin.c_plugin_type_authentication,',
'        p_type_page_item_name => ''P136_SCHEME_TYPE'',',
'        p_page_item_prefix    => ''P136_'' );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(156067817002093304.4052)
,p_plug_name=>unistr('Attributs de mod\00E8le d''authentification')
,p_region_name=>'PLUGIN'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>50
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(815130519409112136.4052)
,p_plug_name=>'SAML pour les applications internes et d''espace de travail : attributs APEX'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P136_SCHEME_TYPE'
,p_plug_display_when_cond2=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(155890431859815022.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_button_name=>'APPLY_CHANGES_MAKE_CURRENT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('Activer le mod\00E8le')
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P136_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(141706417848230962.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'CREATE'
,p_button_condition=>'P136_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(141706218852230961.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(141710320697230988.4052)
,p_branch_action=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(117762395154717714.4052)
,p_name=>'P136_CRED_CLIENT_ID'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(117761677507717707.4052)
,p_prompt=>'ID de client'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Saisissez l''ID de client de votre fournisseur d''authentification.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(117762443712717715.4052)
,p_name=>'P136_CRED_CLIENT_SECRET'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(117761677507717707.4052)
,p_prompt=>unistr('Cl\00E9 secr\00E8te du client')
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Saisissez la cl\00E9 secr\00E8te de client de votre fournisseur d''authentification.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(117763368155717724.4052)
,p_name=>'P136_CRED_CLIENT_SEC_CONFIRM'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(117761677507717707.4052)
,p_prompt=>unistr('Confirmer la cl\00E9 secr\00E8te client')
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Saisissez la cl\00E9 secr\00E8te de client de votre fournisseur d''authentification.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(117763681380717727.4052)
,p_name=>'P136_CRED_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(117761677507717707.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(141707016770230962.4052)
,p_name=>'P136_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_item_source_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(141711223243254442.4052)
,p_name=>'P136_ATTRIBUTE_01'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(156067817002093304.4052)
,p_item_source_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_prompt=>'Attribut 01'
,p_source=>'ATTRIBUTE_01'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(1405202261752384510.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(141711404480263230.4052)
,p_name=>'P136_SCHEME_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_item_source_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_source=>'SCHEME_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(143974801921352400.4052)
,p_name=>'P136_ATTRIBUTE_02'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(156067817002093304.4052)
,p_item_source_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_prompt=>'Attribut 02'
,p_source=>'ATTRIBUTE_02'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(1405202261752384510.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(143975428866355033.4052)
,p_name=>'P136_ATTRIBUTE_03'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(156067817002093304.4052)
,p_item_source_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_prompt=>'Attribut 03'
,p_source=>'ATTRIBUTE_03'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(1405202261752384510.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(143975621534358519.4052)
,p_name=>'P136_ATTRIBUTE_04'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(156067817002093304.4052)
,p_item_source_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_prompt=>'Attribut 04'
,p_source=>'ATTRIBUTE_04'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(1405202261752384510.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(143975817652360226.4052)
,p_name=>'P136_ATTRIBUTE_05'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(156067817002093304.4052)
,p_item_source_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_prompt=>'Attribut 05'
,p_source=>'ATTRIBUTE_05'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(1405202261752384510.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(143976014417361794.4052)
,p_name=>'P136_ATTRIBUTE_06'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(156067817002093304.4052)
,p_item_source_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_prompt=>'Attribut 06'
,p_source=>'ATTRIBUTE_06'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(1405202261752384510.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(143976210320363634.4052)
,p_name=>'P136_ATTRIBUTE_07'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(156067817002093304.4052)
,p_item_source_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_prompt=>'Attribut 07'
,p_source=>'ATTRIBUTE_07'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(1405202261752384510.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(143976406438365461.4052)
,p_name=>'P136_ATTRIBUTE_08'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(156067817002093304.4052)
,p_item_source_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_prompt=>'Attribut 08'
,p_source=>'ATTRIBUTE_08'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(1405202261752384510.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(143976609660379220.4052)
,p_name=>'P136_ATTRIBUTE_09'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(156067817002093304.4052)
,p_item_source_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_prompt=>'Attribut 09'
,p_source=>'ATTRIBUTE_09'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(1405202261752384510.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(143976804053381753.4052)
,p_name=>'P136_ATTRIBUTE_10'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(156067817002093304.4052)
,p_item_source_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_prompt=>'Attribut 10'
,p_source=>'ATTRIBUTE_10'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(1405202261752384510.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(143977013098392741.4052)
,p_name=>'P136_ATTRIBUTE_11'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(156067817002093304.4052)
,p_item_source_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_prompt=>'Attribut 11'
,p_source=>'ATTRIBUTE_11'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(1405202261752384510.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(143977209432394478.4052)
,p_name=>'P136_ATTRIBUTE_12'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(156067817002093304.4052)
,p_item_source_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_prompt=>'Attribut 12'
,p_source=>'ATTRIBUTE_12'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(1405202261752384510.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(143977405550396288.4052)
,p_name=>'P136_ATTRIBUTE_13'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(156067817002093304.4052)
,p_item_source_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_prompt=>'Attribut 13'
,p_source=>'ATTRIBUTE_13'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(1405202261752384510.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(143977601884397924.4052)
,p_name=>'P136_ATTRIBUTE_14'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(156067817002093304.4052)
,p_item_source_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_prompt=>'Attribut 14'
,p_source=>'ATTRIBUTE_14'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(1405202261752384510.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(143977831202399571.4052)
,p_name=>'P136_ATTRIBUTE_15'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(156067817002093304.4052)
,p_item_source_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_prompt=>'Attribut 15'
,p_source=>'ATTRIBUTE_15'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(1405202261752384510.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(156067131462078761.4052)
,p_name=>'P136_HELP_TEXT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_item_source_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_prompt=>'Texte d''aide'
,p_source=>'HELP_TEXT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(156069915490101393.4052)
,p_name=>'P136_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_item_source_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_prompt=>'Nom'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(156137816805994124.4052)
,p_name=>'P136_PLSQL_CODE'
,p_source_data_type=>'CLOB'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_item_source_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_prompt=>'Code PL/SQL'
,p_source=>'PLSQL_CODE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Saisissez un bloc de code anonyme PL/SQL contenant les proc\00E9dures pour les points d''entr\00E9e avant et apr\00E8s authentification'),
'',
unistr('Pour am\00E9liorer de performances, vous pouvez \00E9galement stocker ce code dans un package PL/SQL de la base de donn\00E9es.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(156138131889002313.4052)
,p_name=>'P136_PRE_AUTH_PROCESS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_item_source_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_prompt=>unistr('Nom de proc\00E9dure de pr\00E9authentification')
,p_source=>'PRE_AUTH_PROCESS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>61
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indiquez le nom d''une proc\00E9dure \00E0 ex\00E9cuter apr\00E8s la soumission de la page de connexion et juste avant la v\00E9rification des informations d''identification. '),
unistr('Vous pouvez d\00E9finir cette proc\00E9dure dans l''attribut de code PL/SQL ou dans la base de donn\00E9es.'),
'',
unistr('Les mod\00E8les d''authentification pour lesquels la v\00E9rification des informations d''identification de l''utilisateur est effectu\00E9e en dehors d''Application Express n''ex\00E9cutent g\00E9n\00E9ralement pas '),
unistr('la proc\00E9dure avant l''authentification. Exemples : variable d''en-t\00EAte HTTP, Oracle Application Server Single Sign-On et '),
unistr('les mod\00E8les d''authentification personnalis\00E9s qui utilisent <code>apex_authentication.post_login</code> au lieu de <code>apex_authentication.login</code>.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(156138323047006368.4052)
,p_name=>'P136_POST_AUTH_PROCESS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_item_source_plug_id=>wwv_flow_api.id(141706009970230961.4052)
,p_prompt=>unistr('Nom de proc\00E9dure de postauthentification')
,p_source=>'POST_AUTH_PROCESS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>61
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Indiquez le nom de la proc\00E9dure que doit ex\00E9cuter la proc\00E9dure de connexion Application Express (API de connexion) apr\00E8s l''\00E9tape d''authentification (v\00E9rification des informations d''identification). La proc\00E9dure de connexion ex\00E9cutera ce code apr\00E8s le')
||unistr('s op\00E9rations normales (d\00E9finition d''un cookie et inscription de la session) et juste avant le r\00E9acheminement vers la page d''application voulue. La proc\00E9dure peut \00EAtre d\00E9finie dans l''attribut de code PL/SQL ou dans la base de donn\00E9es.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(815130824560112139.4052)
,p_name=>'P136_SAML_ENABLED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(815130519409112136.4052)
,p_prompt=>'Activer SAML pour les applications'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Activez cette option si les applications d''espace de travail doivent pouvoir utiliser l''authentification SAML.',
unistr('Vous pouvez activer d''autres mod\00E8les d''authentification pour les applications internes, mais utiliser tout de m\00EAme SAML dans des applications si cet attribut est activ\00E9.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(815130946631112140.4052)
,p_name=>'P136_SAML_IP_ISSUER'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(39564106377656610.4052)
,p_prompt=>'Emetteur'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>61
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez l''attribut "Emetteur" des m\00E9tadonn\00E9es du fournisseur d''identit\00E9s.'),
'<p/>',
'Exemple : https://login.example.com/oam/fed'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(815131007729112141.4052)
,p_name=>'P136_SAML_IP_SIGNING_CERT'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(39564106377656610.4052)
,p_prompt=>'Certificat de signature'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>61
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez le certificat des m\00E9tadonn\00E9es du fournisseur d''identit\00E9s.'),
'<p/>',
'Exemple :',
'<pre>',
'<p/>',
'Exemple :',
'<pre>',
'-----BEGIN CERTIFICATE-----',
'MIIDVzCCAj+gAwIBAgIJAJVYart+UJrOMA0GCSqGSIb3DQEBCwUAMEIxCzAJBgNV',
'...',
'Vva8Fj5O8YgtlYKKMmCZKYZC0nMNVRjI3A7cL71ffE7JKMI43EqaTg7m1Q==',
'-----END CERTIFICATE-----',
'</pre>',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(815131129986112142.4052)
,p_name=>'P136_SAML_IP_SIGNING_CERT2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(39564106377656610.4052)
,p_prompt=>'Autre certificat de signature'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>61
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez un autre certificat des m\00E9tadonn\00E9es du fournisseur d''identit\00E9s.'),
'<p/>',
'Exemple :',
'<pre>',
'<p/>',
'Exemple :',
'<pre>',
'-----BEGIN CERTIFICATE-----',
'MIIDVzCCAj+gAwIBAgIJAJVYart+UJrOMA0GCSqGSIb3DQEBCwUAMEIxCzAJBgNV',
'...',
'Vva8Fj5O8YgtlYKKMmCZKYZC0nMNVRjI3A7cL71ffE7JKMI43EqaTg7m1Q==',
'-----END CERTIFICATE-----',
'</pre>',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(815131297577112143.4052)
,p_name=>'P136_SAML_SIGN_IN_URL'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(39564106377656610.4052)
,p_prompt=>'URL de connexion'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>61
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez l''URL de connexion du fournisseur d''identit\00E9s.'),
'<p/>',
'Exemple : https://login.example.com/oamfed/idp/samlv20'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(815131363004112144.4052)
,p_name=>'P136_SAML_SIGN_OUT_URL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(39564106377656610.4052)
,p_prompt=>unistr('URL de d\00E9connexion')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>61
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Entrez l''URL de d\00E9connexion du fournisseur d''identit\00E9s. Si elle n''est pas indiqu\00E9e, la valeur par d\00E9faut indiqu\00E9e est l''URL de connexion, qui est normalement suffisante.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(815131455681112145.4052)
,p_name=>'P136_SAML_SP_ISSUER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(815130519409112136.4052)
,p_prompt=>'Emetteur'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>61
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Entrez l''attribut "Emetteur" envoy\00E9 par &PRODUCT_NAME.. Par d\00E9faut, il s''agit de l''URL de callback (https://apex.example.com/ords/apex_authentication.saml_callback), qui est normalement suffisante.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(815131541700112146.4052)
,p_name=>'P136_SAML_USERNAME_ATTRIBUTE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(815130519409112136.4052)
,p_prompt=>'Attribut du nom utilisateur'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>61
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Les r\00E9ponses SAML peuvent contenir des attributs suppl\00E9mentaires concernant l''utilisateur. Si l''attribut est d\00E9fini, &PRODUCT_NAME. utilise sa valeur comme nom utilisateur. Par d\00E9faut, &PRODUCT_NAME. utilise l''attribut NameID du sujet d''assertion.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(815131628561112147.4052)
,p_name=>'P136_SAML_APEX_CERTIFICATE'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(815130519409112136.4052)
,p_prompt=>'Certificat'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>61
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez le certificat principal du c\00F4t\00E9 &PRODUCT_NAME..'),
'<p/>',
'Exemple :',
'<pre>',
'-----BEGIN CERTIFICATE-----',
'MIIDVzCCAj+gAwIBAgIJAJVYart+UJrOMA0GCSqGSIb3DQEBCwUAMEIxCzAJBgNV',
'...',
'Vva8Fj5O8YgtlYKKMmCZKYZC0nMNVRjI3A7cL71ffE7JKMI43EqaTg7m1Q==',
'-----END CERTIFICATE-----',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(815131705621112148.4052)
,p_name=>'P136_SAML_APEX_CERTIFICATE2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(815130519409112136.4052)
,p_prompt=>'Autre certificat'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>61
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez l''autre certificat du c\00F4t\00E9 &PRODUCT_NAME..'),
'<p/>',
'Exemple :',
'<pre>',
'-----BEGIN CERTIFICATE-----',
'MIIDVzCCAj+gAwIBAgIJAJVYart+UJrOMA0GCSqGSIb3DQEBCwUAMEIxCzAJBgNV',
'...',
'Vva8Fj5O8YgtlYKKMmCZKYZC0nMNVRjI3A7cL71ffE7JKMI43EqaTg7m1Q==',
'-----END CERTIFICATE-----',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(815131844777112149.4052)
,p_name=>'P136_SAML_APEX_PRIVATE_KEY'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(815130519409112136.4052)
,p_prompt=>unistr('Cl\00E9 priv\00E9e')
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>61
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez la cl\00E9 priv\00E9e du c\00F4t\00E9 &PRODUCT_NAME..'),
unistr('&PRODUCT_NAME. n''affiche pas de cl\00E9 priv\00E9e existante'),
'mais vous pouvez en entrer une nouvelle.',
'<p/>',
'Exemple :',
'<pre>',
'-----BEGIN PRIVATE KEY-----',
'MIIEvgIBADANBgkqhkiG9w0BAQEFAASCBKgwggSkAgEAAoIBAQDVksEJGbmdG4D/',
'...',
'3tUtCQOnuWFjkj7n9h3dZSl8',
'-----END PRIVATE KEY-----',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(815131929854112150.4052)
,p_name=>'P136_SAML_APEX_PRIVATE_KEY2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(815130519409112136.4052)
,p_prompt=>unistr('Autre cl\00E9 priv\00E9e')
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>61
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entrez l''autre cl\00E9 priv\00E9e du c\00F4t\00E9 &PRODUCT_NAME..'),
unistr('&PRODUCT_NAME. n''affiche pas de cl\00E9 priv\00E9e existante'),
'mais vous pouvez en entrer une nouvelle.',
'<p/>',
'Exemple :',
'<pre>',
'-----BEGIN PRIVATE KEY-----',
'MIIEvgIBADANBgkqhkiG9w0BAQEFAASCBKgwggSkAgEAAoIBAQDVksEJGbmdG4D/',
'...',
'3tUtCQOnuWFjkj7n9h3dZSl8',
'-----END PRIVATE KEY-----',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(143089014295981941.4052)
,p_validation_name=>'Validate Plugin Attributes'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.validate_attribute_items (',
'        p_application_id   => wwv_flow.g_flow_id,',
'        p_plugin_type      => wwv_flow_plugin.c_plugin_type_authentication,',
'        p_plugin_name      => :P136_SCHEME_TYPE,',
'        p_attribute_scope  => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix => ''P136_'' );',
'end;'))
,p_validation_type=>'PLSQL_ERROR'
,p_error_message=>'Erreur'
,p_when_button_pressed=>wwv_flow_api.id(141706417848230962.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(117763404786717725.4052)
,p_validation_name=>'Verify Client Secret'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P136_CRED_CLIENT_SEC_CONFIRM is not null',
'and :P136_CRED_CLIENT_SECRET = :P136_CRED_CLIENT_SEC_CONFIRM'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('La cl\00E9 secr\00E8te du client n''a pas \00E9t\00E9 confirm\00E9e correctement. Saisissez exactement la m\00EAme cl\00E9 secr\00E8te du client les deux fois.')
,p_validation_condition=>'P136_CRED_CLIENT_SECRET'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(141706417848230962.4052)
,p_associated_item=>wwv_flow_api.id(117762443712717715.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(39563314659656602.4052)
,p_validation_name=>'Parse SAML_IP_SIGNING_CERT'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_public_key_util.is_certificate (',
'    p_src => :P136_SAML_IP_SIGNING_CERT )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Certificat non valide'
,p_validation_condition=>'P136_SCHEME_TYPE'
,p_validation_condition2=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(141706417848230962.4052)
,p_associated_item=>wwv_flow_api.id(815131007729112141.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(39563442524656603.4052)
,p_validation_name=>'Parse SAML_IP_SIGNING_CERT2'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_public_key_util.is_certificate (',
'    p_src => :P136_SAML_IP_SIGNING_CERT2 )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Certificat non valide'
,p_validation_condition=>'P136_SCHEME_TYPE'
,p_validation_condition2=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(141706417848230962.4052)
,p_associated_item=>wwv_flow_api.id(815131129986112142.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(39563529487656604.4052)
,p_validation_name=>'Parse P136_SAML_APEX_CERTIFICATE'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_public_key_util.is_certificate (',
'    p_src => :P136_SAML_APEX_CERTIFICATE )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Certificat non valide'
,p_validation_condition=>'P136_SCHEME_TYPE'
,p_validation_condition2=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(141706417848230962.4052)
,p_associated_item=>wwv_flow_api.id(815131628561112147.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(39563679484656605.4052)
,p_validation_name=>'Parse P136_SAML_APEX_CERTIFICATE2'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_public_key_util.is_certificate (',
'    p_src => :P136_SAML_APEX_CERTIFICATE2 )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Certificat non valide'
,p_validation_condition=>'P136_SCHEME_TYPE'
,p_validation_condition2=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(141706417848230962.4052)
,p_associated_item=>wwv_flow_api.id(815131705621112148.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(39563731704656606.4052)
,p_validation_name=>'P136_SAML_SIGN_IN_URL Is URL'
,p_validation_sequence=>80
,p_validation=>'P136_SAML_SIGN_IN_URL'
,p_validation2=>'http[s]?://.*'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'Entrez une URL qui commence par http:// ou https://.'
,p_validation_condition=>'P136_SCHEME_TYPE'
,p_validation_condition2=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(141706417848230962.4052)
,p_associated_item=>wwv_flow_api.id(815131297577112143.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(39563891685656607.4052)
,p_validation_name=>'P136_SAML_SIGN_OUT_URL Is URL'
,p_validation_sequence=>90
,p_validation=>'P136_SAML_SIGN_OUT_URL'
,p_validation2=>'http[s]?://.*'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'Entrez une URL qui commence par http:// ou https://.'
,p_validation_condition=>'P136_SCHEME_TYPE'
,p_validation_condition2=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(141706417848230962.4052)
,p_associated_item=>wwv_flow_api.id(815131363004112144.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(161096405621281308.4052)
,p_name=>'Make current'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(155890431859815022.4052)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(161096729476281309.4052)
,p_event_id=>wwv_flow_api.id(161096405621281308.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si les param\00E8tres et le serveur Web ne sont pas configur\00E9s correctement, la modification du mod\00E8le d''authentification en cours peut rendre &PRODUCT_NAME. inaccessible. En cas de probl\00E8me, vous pouvez red\00E9finir le mod\00E8le d''authentification interne sur')
||unistr(' la valeur par d\00E9faut avec'),
'',
'apex_instance_admin.set_parameter(&#x27;APEX_BUILDER_AUTHENTICATION&#x27;,&#x27;APEX&#x27;);',
'',
unistr('Voulez-vous modifier le mod\00E8le d''authentification en cours maintenant ?')))
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(161096925872283827.4052)
,p_event_id=>wwv_flow_api.id(161096405621281308.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'APPLY_CHANGES_MAKE_CURRENT'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(141709817048230987.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(141706009970230961.4052)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process Row of WWV_FLOW_AUTHENTICATIONS'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_process_error_message=>'Erreur lors du traitement de l''authentification.'
,p_process_when_button_id=>wwv_flow_api.id(141706417848230962.4052)
,p_process_success_message=>unistr('Action trait\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(117763597814717726.4052)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save Credential'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4050_ui.p136_save_credential (',
'    p_id            => :P136_CRED_ID,',
'    p_client_id     => :P136_CRED_CLIENT_ID,',
'    p_client_secret => :P136_CRED_CLIENT_SECRET );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(141706417848230962.4052)
,p_process_when=>'P136_CRED_CLIENT_SECRET'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(39563203481656601.4052)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save SAML Attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4050_ui.p136_save_saml_attributes (',
'    p_saml_enabled                 => :P136_SAML_ENABLED,',
'    p_saml_ip_issuer               => :P136_SAML_IP_ISSUER,',
'    p_saml_ip_signing_certificate  => :P136_SAML_IP_SIGNING_CERT,',
'    p_saml_ip_signing_certificate2 => :P136_SAML_IP_SIGNING_CERT2,',
'    p_saml_sign_in_url             => :P136_SAML_SIGN_IN_URL,',
'    p_saml_sign_out_url            => :P136_SAML_SIGN_OUT_URL,',
'    p_saml_sp_issuer               => :P136_SAML_SP_ISSUER,',
'    p_saml_username_attribute      => :P136_SAML_USERNAME_ATTRIBUTE,',
'    p_saml_apex_certificate        => :P136_SAML_APEX_CERTIFICATE,',
'    p_saml_apex_certificate2       => :P136_SAML_APEX_CERTIFICATE2,',
'    p_saml_apex_private_key        => :P136_SAML_APEX_PRIVATE_KEY,',
'    p_saml_apex_private_key2       => :P136_SAML_APEX_PRIVATE_KEY2 );',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(141706417848230962.4052)
,p_process_when=>'P136_SCHEME_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(151902109875088387.4052)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'push changes to other schemes of same type'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_authentication_dev.internal_push_changes (',
'    p_authentication_id => :P136_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(155890807311821474.4052)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'make current authentication scheme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_authentication_dev.internal_make_current (',
'    p_authentication_id => :P136_ID );',
'--',
'-- reload placeholder item for create/edit user password region',
'--',
':F4050_PASSWORD_REGION_TITLE := wwv_flow_lang.system_message (',
'                                    ''APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.''||',
'                                    replace(wwv_flow_authentication_dev.get_internal_authentication,''DB'',''LDAP'')||',
'                                    ''-AUTH'');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(155890431859815022.4052)
,p_process_success_message=>unistr('Le mod\00E8le d''authentification en cours pour les applications internes a \00E9t\00E9 modifi\00E9. Vous devrez peut-\00EAtre cr\00E9er des administrateurs et d\00E9veloppeurs d''espace de travail suppl\00E9mentaires afin de vous connecter.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(117761779144717708.4052)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_api.id(141706009970230961.4052)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Developer Authentication Scheme'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(117761548349717706.4052)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Credentials'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4050_ui.p136_fetch_credential (',
'    p_id        => :P136_CRED_ID,',
'    p_client_id => :P136_CRED_CLIENT_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P136_SCHEME_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(815130652541112137.4052)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch SAML Attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4050_ui.p136_fetch_saml_attributes (',
'    p_saml_enabled                 => :P136_SAML_ENABLED,',
'    p_saml_ip_issuer               => :P136_SAML_IP_ISSUER,',
'    p_saml_ip_signing_certificate  => :P136_SAML_IP_SIGNING_CERT,',
'    p_saml_ip_signing_certificate2 => :P136_SAML_IP_SIGNING_CERT2,',
'    p_saml_sign_in_url             => :P136_SAML_SIGN_IN_URL,',
'    p_saml_sign_out_url            => :P136_SAML_SIGN_OUT_URL,',
'    p_saml_sp_issuer               => :P136_SAML_SP_ISSUER,',
'    p_saml_username_attribute      => :P136_SAML_USERNAME_ATTRIBUTE,',
'    p_saml_apex_certificate        => :P136_SAML_APEX_CERTIFICATE,',
'    p_saml_apex_certificate2       => :P136_SAML_APEX_CERTIFICATE2,',
'    p_saml_apex_private_key        => :P136_SAML_APEX_PRIVATE_KEY,',
'    p_saml_apex_private_key2       => :P136_SAML_APEX_PRIVATE_KEY2 );',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P136_SCHEME_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
);
end;
/
prompt --application/pages/page_00137
begin
wwv_flow_api.create_page(
 p_id=>137.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'10 principaux espaces de travail'
,p_step_title=>'10 principaux espaces de travail'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1761218334857168235.4052)
,p_plug_name=>'Principales applications'
,p_region_css_classes=>'js-refresh-region'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>10
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_jet_chart(
 p_id=>wwv_flow_api.id(880628551033290603.4052)
,p_region_id=>wwv_flow_api.id(1761218334857168235.4052)
,p_chart_type=>'bar'
,p_height=>'320'
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_spark_chart=>'N'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>false
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(880629728907290607.4052)
,p_chart_id=>wwv_flow_api.id(880628551033290603.4052)
,p_seq=>10
,p_name=>unistr('S\00E9rie 1')
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'from (',
'    select sum(page_events) Page_Events,',
'    NVL((select max(SHORT_NAME ) from wwv_flow_companies c where c.PROVISIONING_COMPANY_ID  = h.WORKSPACE_ID ),''Unknown'') App_Name',
'    from WWV_FLOW_LOG_HISTORY h',
'    where log_day > sysdate - (NVL(:P137_SINCE,7)+1)',
'    group by h.WORKSPACE_ID',
'    order by 1 desc) ',
'where rownum <= 10'))
,p_ajax_items_to_submit=>'P137_SINCE'
,p_items_value_column_name=>'PAGE_EVENTS'
,p_group_name_column_name=>'APP_NAME'
,p_items_label_column_name=>'APP_NAME'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'outsideBarEdge'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(880628974255290606.4052)
,p_chart_id=>wwv_flow_api.id(880628551033290603.4052)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(880629374523290606.4052)
,p_chart_id=>wwv_flow_api.id(880628551033290603.4052)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'auto'
,p_minor_tick_rendered=>'auto'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(2232511086998620885.4052)
,p_name=>unistr('D\00E9tail de l''activit\00E9 des espaces de travail')
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_css_classes=>'js-refresh-region'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select "Page Events" ,',
'       errors,',
'       workspace_id,',
'       (select SHORT_NAME from wwv_flow_companies c where c.PROVISIONING_COMPANY_ID = x.workspace_id) workspace_name,',
'       development_activity,',
'       runtime_activity,',
'       RANK() OVER (ORDER BY "Page Events" desc) ws_rank',
'from (',
'select sum(page_events) "Page Events",',
'    workspace_id, max(log_day) most_recent_event,',
'    sum(CASE WHEN application_id BETWEEN 4000 AND 5000 THEN page_events else 0 end) development_activity,',
'    sum(CASE WHEN application_id NOT BETWEEN 4000 AND 5000 THEN page_events else 0 end) runtime_activity,',
'    sum(ERROR_COUNT) errors',
'from WWV_FLOW_LOG_HISTORY ',
'where log_day > sysdate - (NVL(:P137_SINCE,7)+1)',
'group by workspace_id',
'order by 1 desc) x',
'where rownum < 101',
''))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P137_SINCE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>101
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'ROWS_X_TO_Y'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>unistr('T\00E9l\00E9charger en local')
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(825586844014000626.4052)
,p_query_column_id=>1
,p_column_alias=>'Page Events'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Ev\00E9nements de page')
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(825514289073601246.4052)
,p_query_column_id=>2
,p_column_alias=>'ERRORS'
,p_column_display_sequence=>7
,p_column_heading=>'Erreurs'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(825588434276000627.4052)
,p_query_column_id=>3
,p_column_alias=>'WORKSPACE_ID'
,p_column_display_sequence=>8
,p_column_heading=>'ID d''espace de travail'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(825588841133000627.4052)
,p_query_column_id=>4
,p_column_alias=>'WORKSPACE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Espace de travail'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(825512102229601225.4052)
,p_query_column_id=>5
,p_column_alias=>'DEVELOPMENT_ACTIVITY'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Activit\00E9 de d\00E9veloppement')
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(825512231698601226.4052)
,p_query_column_id=>6
,p_column_alias=>'RUNTIME_ACTIVITY'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Activit\00E9 d''ex\00E9cution')
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(825593242951000629.4052)
,p_query_column_id=>7
,p_column_alias=>'WS_RANK'
,p_column_display_sequence=>1
,p_column_heading=>'Rang'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3399440007607788189.4052)
,p_plug_name=>'Button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>1
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(825605541633063665.4052)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(3399440007607788189.4052)
,p_button_name=>'reset_page'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:137:&SESSION.::&DEBUG.:RR,137::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(880630806348290610.4052)
,p_name=>'P137_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3399440007607788189.4052)
,p_item_default=>'7'
,p_prompt=>'Depuis'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME_ARCHIVE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 30 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 186 t from dual union all',
'select ''9 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 279 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(390436229055898138.4052)
,p_name=>'Refresh Regions'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P137_SINCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(390436382517898139.4052)
,p_event_id=>wwv_flow_api.id(390436229055898138.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'.js-refresh-region'
);
end;
/
prompt --application/pages/page_00138
begin
wwv_flow_api.create_page(
 p_id=>138.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('R\00E9capitulatif de l''activit\00E9')
,p_step_title=>unistr('R\00E9capitulatif de l''activit\00E9')
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(390436644901898142.4052)
,p_plug_name=>unistr('Activit\00E9 d''espace de travail')
,p_region_css_classes=>'js-refresh-region'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with x',
'as',
'(',
'    select trunc(sysdate) - rownum log_day, ',
'           30 considered_active',
'    from dual',
'    connect by level <= NVL(:P138_SINCE,7)',
'    order by 1 desc)',
'select * from',
'(',
'select x.log_day, ',
'       (select count(distinct workspace_id)   ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_workspaces,',
'       (select sum(page_events)   ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) window_page_events,',
'       (select count(distinct application_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id not between 4000 and 5000 and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_applications,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id not between 4000 and 5000 and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) workspaces_with_active_apps,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id in (4000,4020) and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_appbuilder,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id = 4500 and ',
'              DISTINCT_PAGES > 1 and',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_sqlworkshop,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id in (4020) and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_create_app,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id = 4850 and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_rest,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id = 4300 and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_data_workshop,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id = 4600 and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_team_dev,',
'       x.log_day - considered_active window_start,',
'       x.log_day window_end',
'from x',
') y',
'order by 1 desc',
''))
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_ajax_items_to_submit=>'P138_SINCE'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_jet_chart(
 p_id=>wwv_flow_api.id(390436714047898143.4052)
,p_region_id=>wwv_flow_api.id(390436644901898142.4052)
,p_chart_type=>'line'
,p_title=>unistr('Activit\00E9 d''espace de travail - 30 jours de fin')
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'withRescale'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_fill_multi_series_gaps=>false
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_position=>'bottom'
,p_overview_rendered=>'off'
,p_time_axis_type=>'enabled'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(390436877343898144.4052)
,p_chart_id=>wwv_flow_api.id(390436714047898143.4052)
,p_seq=>10
,p_name=>'Espaces de travail actifs'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'ACTIVE_WORKSPACES'
,p_items_label_column_name=>'LOG_DAY'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(831944451410695401.4052)
,p_chart_id=>wwv_flow_api.id(390436714047898143.4052)
,p_seq=>30
,p_name=>'App Builder'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'ACTIVE_APPBUILDER'
,p_items_label_column_name=>'LOG_DAY'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(831944583172695402.4052)
,p_chart_id=>wwv_flow_api.id(390436714047898143.4052)
,p_seq=>40
,p_name=>'REST Workshop'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'ACTIVE_REST'
,p_items_label_column_name=>'LOG_DAY'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(831944652308695403.4052)
,p_chart_id=>wwv_flow_api.id(390436714047898143.4052)
,p_seq=>50
,p_name=>'SQL Workshop'
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'ACTIVE_SQLWORKSHOP'
,p_items_label_column_name=>'LOG_DAY'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(831944755855695404.4052)
,p_chart_id=>wwv_flow_api.id(390436714047898143.4052)
,p_seq=>60
,p_name=>unistr('D\00E9veloppement d''\00E9quipe')
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'ACTIVE_TEAM_DEV'
,p_items_label_column_name=>'LOG_DAY'
,p_line_style=>'solid'
,p_line_width=>1
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(390436972856898145.4052)
,p_chart_id=>wwv_flow_api.id(390436714047898143.4052)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(390437059060898146.4052)
,p_chart_id=>wwv_flow_api.id(390436714047898143.4052)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(390437404321898150.4052)
,p_chart_id=>wwv_flow_api.id(390436714047898143.4052)
,p_axis=>'y2'
,p_is_rendered=>'on'
,p_title=>unistr('Ev\00E9nements de page')
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_split_dual_y=>'auto'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(581427921268177850.4052)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>L''aper\00E7u fournit des donn\00E9es en temps r\00E9el. Le rapport de l''activit\00E9 de d\00E9veloppement et des principales applications est \00E9tabli \00E0 partir du journal quotidien r\00E9capitulatif des activit\00E9s. </p>'),
unistr('<p>Les principales applications sont les applications APEX, sauf l''interface de d\00E9veloppement de conception.</p>'),
unistr('<p>Le nombre de lignes dans les rapports est limit\00E9 \00E0 200.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(825511736357601221.4052)
,p_plug_name=>unistr('S\00E9lecteur d''affichage de r\00E9gion')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(831944814412695405.4052)
,p_plug_name=>unistr('Ev\00E9nements de page')
,p_region_css_classes=>'js-refresh-region'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with events_per_day as',
'(',
'select',
'  h.log_day,',
'  sum(page_events) page_events',
'from   WWV_FLOW_LOG_HISTORY h',
'where  h.log_day >= sysdate-NVL(:P138_SINCE,7)',
'group by h.log_day',
'),',
'rolling30 as',
'(',
'select',
'  log_day,',
'  sum(page_events) over ( order by log_day range between 30 preceding and current row) as last_30_days',
'from events_per_day',
'),',
'x as (',
'    select trunc(sysdate) - rownum log_day',
'    from dual',
'    connect by level <= NVL(:P138_SINCE,7)',
')   ',
'select x.log_day,',
'       nvl(last_value(r.last_30_days ignore nulls) over ( order by x.log_day ),0) as last_30_days',
'from   x, rolling30 r',
'where  x.log_day = r.log_day(+)',
'order by 1',
''))
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_ajax_items_to_submit=>'P138_SINCE'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_jet_chart(
 p_id=>wwv_flow_api.id(831945070251695407.4052)
,p_region_id=>wwv_flow_api.id(831944814412695405.4052)
,p_chart_type=>'line'
,p_title=>unistr('Ev\00E9nements de page - 30 jours de fin')
,p_animation_on_display=>'auto'
,p_animation_on_data_change=>'auto'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hide_and_show_behavior=>'withRescale'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_fill_multi_series_gaps=>false
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'on'
,p_legend_position=>'bottom'
,p_overview_rendered=>'off'
,p_time_axis_type=>'enabled'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(831945101909695408.4052)
,p_chart_id=>wwv_flow_api.id(831945070251695407.4052)
,p_seq=>10
,p_name=>unistr('Ev\00E9nements de page')
,p_location=>'REGION_SOURCE'
,p_items_value_column_name=>'LAST_30_DAYS'
,p_items_label_column_name=>'LOG_DAY'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(831945638565695413.4052)
,p_chart_id=>wwv_flow_api.id(831945070251695407.4052)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_type=>'date-short'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(831945797163695414.4052)
,p_chart_id=>wwv_flow_api.id(831945070251695407.4052)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(831945802132695415.4052)
,p_chart_id=>wwv_flow_api.id(831945070251695407.4052)
,p_axis=>'y2'
,p_is_rendered=>'on'
,p_title=>unistr('Ev\00E9nements de page')
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_split_dual_y=>'auto'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(861306615814654928.4052)
,p_plug_name=>unistr('Rapports d''activit\00E9 d\00E9taill\00E9s')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(831980164720776427.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(27525012681104508.4052)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1807086836541256590.4052)
,p_name=>unistr('Aper\00E7u')
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>22
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_css_classes=>'js-refresh-region'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--cols a-BadgeList--3cols:a-BadgeList--medium'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with x as (',
'select to_char(count(*),''999G999G999G999G990'') total_page_views, ',
'       to_char(count(distinct flow_id),''999G999G999G999G990'')  active_apps, ',
'       to_char(count(distinct userid),''999G999G999G999G990'')  distinct_users,',
'       to_char(count(distinct flow_id),''999G999G999G999G990'') active_workspaces',
'  from wwv_flow_activity_log',
' where time_stamp >= sysdate - (NVL(:P138_SINCE,7)+1)',
'    ),',
'y as (',
' select ',
'     (select to_char(count(*),''999G999G999G999G990'') from wwv_flow_companies) workspace_count,',
'     (select to_char(count(*),''999G999G999G999G990'') from wwv_flows) app_count,',
'     (select to_char(count(*),''999G999G999G999G990'') from wwv_flow_provision_company where PROJECT_STATUS = ''APPROVED'' ',
'     and request_date >= sysdate - (NVL(:P138_SINCE,7)+1)) workspaces_approved,',
'     (select to_char(count(*),''999G999G999G999G990'') from wwv_flow_provision_company where PROJECT_STATUS = ''PURGED'' ',
'     and request_date >= sysdate - (NVL(:P138_SINCE,7)+1)) workspaces_purged,',
'     (select to_char(count(*),''999G999G999G999G990'') tbp',
'      from wwv_purge_workspaces',
'      where status in (''NEW'',''STAGE1'',''STAGE2'')',
'      and date_to_purge between sysdate and sysdate + 7) to_be_purged_1w',
' from dual',
')',
'select x.total_page_views,',
'       x.active_apps,',
'       y.app_count total_apps,',
'       x.distinct_users active_users,',
'       x.active_workspaces,',
'       y.workspace_count total_workspaces,',
'       y.workspaces_approved,',
'       y.workspaces_purged,',
'       y.to_be_purged_1w',
'from x, y'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P138_SINCE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805663950138677747.4052)
,p_query_num_rows=>5
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(758054754169278415.4052)
,p_query_column_id=>1
,p_column_alias=>'TOTAL_PAGE_VIEWS'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Nombre total d''\00E9v\00E9nements de page')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(758055086804278418.4052)
,p_query_column_id=>2
,p_column_alias=>'ACTIVE_APPS'
,p_column_display_sequence=>3
,p_column_heading=>'Applications actives'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(758055605099278424.4052)
,p_query_column_id=>3
,p_column_alias=>'TOTAL_APPS'
,p_column_display_sequence=>4
,p_column_heading=>'Nombre total d''applications'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(758055764419278425.4052)
,p_query_column_id=>4
,p_column_alias=>'ACTIVE_USERS'
,p_column_display_sequence=>2
,p_column_heading=>'Utilisateurs actifs'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(758055157005278419.4052)
,p_query_column_id=>5
,p_column_alias=>'ACTIVE_WORKSPACES'
,p_column_display_sequence=>5
,p_column_heading=>'Espaces de travail actifs'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(758055806732278426.4052)
,p_query_column_id=>6
,p_column_alias=>'TOTAL_WORKSPACES'
,p_column_display_sequence=>6
,p_column_heading=>'Nombre total d''espaces de travail'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(758055423236278422.4052)
,p_query_column_id=>7
,p_column_alias=>'WORKSPACES_APPROVED'
,p_column_display_sequence=>7
,p_column_heading=>unistr('Espaces de travail approuv\00E9s')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(758055543547278423.4052)
,p_query_column_id=>8
,p_column_alias=>'WORKSPACES_PURGED'
,p_column_display_sequence=>8
,p_column_heading=>unistr('Espaces de travail purg\00E9s')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(825511851915601222.4052)
,p_query_column_id=>9
,p_column_alias=>'TO_BE_PURGED_1W'
,p_column_display_sequence=>9
,p_column_heading=>'A purger - 1 semaine'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4280073096315101852.4052)
,p_plug_name=>'Button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(390437227575898148.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(390436644901898142.4052)
,p_button_name=>'VIEW_DETAILS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('Voir les d\00E9tails')
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:153:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(581427897662177849.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(4280073096315101852.4052)
,p_button_name=>'reset_page'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:138:&SESSION.::&DEBUG.:RR,138::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(880633731011313664.4052)
,p_name=>'P138_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4280073096315101852.4052)
,p_item_default=>'7'
,p_prompt=>'Depuis'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME_ARCHIVE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 30 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 186 t from dual union all',
'select ''9 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 279 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(390436011156898136.4052)
,p_name=>'Refresh Regions'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P138_SINCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(390436159952898137.4052)
,p_event_id=>wwv_flow_api.id(390436011156898136.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'.js-refresh-region'
);
end;
/
prompt --application/pages/page_00139
begin
wwv_flow_api.create_page(
 p_id=>139.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('G\00E9rer le journal des activit\00E9s de service Web')
,p_step_title=>unistr('G\00E9rer le journal des activit\00E9s de service Web')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216783731365642767)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>'AEADM/adm_logs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(685765931892976233.4052)
,p_plug_name=>unistr('Supprimer des entr\00E9es du journal des activit\00E9s de service Web')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   c_dev pls_integer := 0;',
'',
'begin',
'/*',
'   sys.htp.p(''<table class="instructiontext" role="presentation">'');',
'   -- wwv_flow_builder_audit_trail ',
'   select count(*) into c_dev from wwv_flow_clickthru_log_v;',
'   sys.htp.p(''<tr><td>''||wwv_flow_lang.system_message(''4050_85_CLICK_COUNT'')||''</td><td align="right">'');',
'   sys.htp.p(to_char(c_dev,''999,999,999,990''));',
'   sys.htp.p(''</td><td><br /></td></tr>'');',
'   sys.htp.p(''</table>'');',
'*/',
'   select count(*) into c_dev from wwv_flow_webservice_log;',
'   sys.htp.p(''<p>''||wwv_flow_lang.system_message(''4050_139_WEB_SERVICE_ACTIVITY_LOG'')||'': '');',
'   sys.htp.p(to_char(c_dev,''999,999,999,990'')||''</p>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1701789643422596067.4052)
,p_plug_name=>'Boutons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1703260876618371756.4052)
,p_plug_name=>unistr('Journal des activit\00E9s de service Web')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829706609080810173.4052)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Cette instance &PRODUCT_NAME. peut \00EAtre configur\00E9e en vue de journaliser l''activit\00E9 de service Web.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(620804032051072188.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1701789643422596067.4052)
,p_button_name=>'DELETE_ENTRIES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Supprimer des entr\00E9es')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(620804455539072191.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1701789643422596067.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(620805938503072198.4052)
,p_branch_name=>'Go To Page 139'
,p_branch_action=>'139'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(620804032051072188.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(620802973440072180.4052)
,p_name=>'P139_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(685765931892976233.4052)
,p_prompt=>unistr('Supprimer les entr\00E9es datant du nombre de jours suivant ou plus :')
,p_source=>'31'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIME_INTERVALS'
,p_lov=>'.'||wwv_flow_api.id(87720511660244788.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Purgez les entr\00E9es d\00E9passant ce nombre de jours.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(620805415839072197.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete rows'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_webservice_log1$',
'where request_date < (sysdate - nvl(:p139_time,31));',
'delete from wwv_flow_webservice_log2$',
'where request_date < (sysdate - nvl(:p139_time,31));'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Erreur lors de la purge du journal des activit\00E9s de service Web.')
,p_process_when_button_id=>wwv_flow_api.id(620804032051072188.4052)
,p_process_success_message=>unistr('Journal des activit\00E9s de service Web purg\00E9.')
);
end;
/
prompt --application/pages/page_00140
begin
wwv_flow_api.create_page(
 p_id=>140.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Etat d''utilisation de composants natifs'
,p_step_title=>'Etat d''utilisation de composants natifs'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(84539284934706818.4052)
,p_plug_name=>'Etat'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517376500704206647.4052)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEXcc_p140 */',
'    security_group_id,',
'    (select short_name from wwv_flow_companies c where c.PROVISIONING_COMPANY_ID = p.security_group_id) workspace,',
'    flow_id,',
'    (select name from wwv_flows f where f.id = p.flow_id) application,',
'    sum(decode(plug_source_type, ''NATIVE_JET_CHART'', 1, 0))        jc_count,',
'    sum(decode(plug_source_type, ''NATIVE_IG'', 1, 0))               ig_count,',
'    sum(decode(plug_source_type, ''NATIVE_IR'', 1, 0))               ir_count,',
'    sum(decode(plug_source_type, ''NATIVE_SQL_REPORT'', 1, 0))       cr_count,',
'    sum(decode(plug_source_type, ''NATIVE_CALENDAR'', 1, 0))         cal_count,',
'    sum(decode(plug_source_type, ''NATIVE_CSS_CALENDAR'', 1, 0))     cssc_count,',
'    sum(decode(plug_source_type, ''NATIVE_PLSQL'', 1, 0))            pl_count,',
'    sum(decode(plug_source_type, ''NATIVE_DISPLAY_SELECTOR'', 1, 0)) ds_count,',
'    sum(decode(plug_source_type, ''NATIVE_TABFORM'', 1, 0))          tf_count,',
'    sum(decode(plug_source_type, ''NATIVE_STATIC'', 1, 0))           ns_count,',
'    sum(decode(plug_source_type, ''NATIVE_JSTREE'', 1, 0))           jst_count,',
'    sum(decode(plug_source_type, ''NATIVE_BREADCRUMB'', 1, 0))       nb_count,',
'    sum(decode(plug_source_type, ''NATIVE_LIST'', 1, 0))             nl_count',
'from wwv_flow_page_plugs p',
'where security_group_id != 10 and',
'   plug_source_type  in (',
'      ''NATIVE_JET_CHART'', ''NATIVE_IG'', ''NATIVE_IR'', ''NATIVE_SQL_REPORT'', ',
'      ''NATIVE_CALENDAR'', ''NATIVE_PLSQL'', ''NATIVE_CSS_CALENDAR'',',
'      ''NATIVE_TABFORM'',''NATIVE_DISPLAY_SELECTOR'',''NATIVE_CSS_CALENDAR'',',
'      ''NATIVE_JSTREE'',''NATIVE_STATIC'', ''NATIVE_BREADCRUMB'', ''NATIVE_LIST'')',
'group by security_group_id, flow_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(84539367321706819.4052)
,p_max_row_count=>'1000000'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>84539367321706819
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84541134438706837.4052)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>10
,p_column_identifier=>'R'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84541290053706838.4052)
,p_db_column_name=>'APPLICATION'
,p_display_order=>20
,p_column_identifier=>'S'
,p_column_label=>'Application'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84539442962706820.4052)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>30
,p_column_identifier=>'A'
,p_column_label=>'ID d''espace de travail'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84539514266706821.4052)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>40
,p_column_identifier=>'B'
,p_column_label=>'ID d''application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84539676154706822.4052)
,p_db_column_name=>'JC_COUNT'
,p_display_order=>50
,p_column_identifier=>'C'
,p_column_label=>'Graphiques JET'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84539735475706823.4052)
,p_db_column_name=>'IG_COUNT'
,p_display_order=>60
,p_column_identifier=>'D'
,p_column_label=>'Grilles interactives'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84539830573706824.4052)
,p_db_column_name=>'IR_COUNT'
,p_display_order=>70
,p_column_identifier=>'E'
,p_column_label=>'Etats interactifs'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84539970222706825.4052)
,p_db_column_name=>'CR_COUNT'
,p_display_order=>80
,p_column_identifier=>'F'
,p_column_label=>'Etats classiques'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84540020048706826.4052)
,p_db_column_name=>'CAL_COUNT'
,p_display_order=>90
,p_column_identifier=>'G'
,p_column_label=>'Calendriers classiques'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84541076822706836.4052)
,p_db_column_name=>'CSSC_COUNT'
,p_display_order=>100
,p_column_identifier=>'Q'
,p_column_label=>'Calendriers CSS'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84540185317706827.4052)
,p_db_column_name=>'PL_COUNT'
,p_display_order=>110
,p_column_identifier=>'H'
,p_column_label=>unistr('R\00E9gions PL/SQL')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84540265566706828.4052)
,p_db_column_name=>'FC_COUNT'
,p_display_order=>120
,p_column_identifier=>'I'
,p_column_label=>'Graphiques Flash'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84540360844706829.4052)
,p_db_column_name=>'DS_COUNT'
,p_display_order=>130
,p_column_identifier=>'J'
,p_column_label=>unistr('S\00E9lecteurs d''affichage')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84540448009706830.4052)
,p_db_column_name=>'TF_COUNT'
,p_display_order=>140
,p_column_identifier=>'K'
,p_column_label=>'Panneaux tabulaires'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84540541018706831.4052)
,p_db_column_name=>'FM_COUNT'
,p_display_order=>150
,p_column_identifier=>'L'
,p_column_label=>'Cartes Flash'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84540690326706832.4052)
,p_db_column_name=>'NS_COUNT'
,p_display_order=>160
,p_column_identifier=>'M'
,p_column_label=>unistr('R\00E9gions statiques')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84540794520706833.4052)
,p_db_column_name=>'JST_COUNT'
,p_display_order=>170
,p_column_identifier=>'N'
,p_column_label=>'Arborescences JavaScript'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84540864185706834.4052)
,p_db_column_name=>'NB_COUNT'
,p_display_order=>180
,p_column_identifier=>'O'
,p_column_label=>'Chemins de navigation'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84540973307706835.4052)
,p_db_column_name=>'NL_COUNT'
,p_display_order=>190
,p_column_identifier=>'P'
,p_column_label=>'Listes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
end;
/
prompt --application/pages/page_00141
begin
wwv_flow_api.create_page(
 p_id=>141.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Hachage d''application par jour'
,p_step_title=>'Hachage d''application par jour'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(420391910446831714.4052)
,p_plug_name=>'Hachage d''application par jour'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    LOG_DAY,',
'    to_char(log_day,''Day'') day,',
'    WORKSPACE_ID workspace,',
'    WORKSPACE_NAME workspace_name,',
'    APPLICATION_ID applications,',
'    APPLICATION_NAME application_name,',
'    nvl(decode(instr(additional_attributes,''"hash":''),0,null,',
'        substr(additional_attributes,',
'        instr(additional_attributes,''"hash":'')+8,',
'        instr(substr(additional_attributes,',
'        instr(additional_attributes,''"hash":'')+8),'','')-2)),null)  application_hash',
'from WWV_FLOW_LOG_HISTORY h',
'where instr(additional_attributes,''"hash":'') > 0',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(420392112669831717.4052)
,p_name=>'Activity by Day'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>420392112669831717
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(219063789436336973.4052)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Consigner le jour dans le journal'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(219064113077336974.4052)
,p_db_column_name=>'DAY'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Jour'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(219064567381336975.4052)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(219070135037336989.4052)
,p_db_column_name=>'WORKSPACE'
,p_display_order=>145
,p_column_identifier=>'R'
,p_column_label=>'Espace de travail'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(219070507206336989.4052)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>155
,p_column_identifier=>'S'
,p_column_label=>'Nom de l''espace de travail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(219070978694336990.4052)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>165
,p_column_identifier=>'T'
,p_column_label=>'Nom d''application'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(219063342368336971.4052)
,p_db_column_name=>'APPLICATION_HASH'
,p_display_order=>325
,p_column_identifier=>'AR'
,p_column_label=>'Hachage d''application'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(219072159957336999.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(420391910446831714.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:141:&SESSION.::&DEBUG.:77,RIR::'
);
end;
/
prompt --application/pages/page_00142
begin
wwv_flow_api.create_page(
 p_id=>142.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Cr\00E9er un espace de travail')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Cr\00E9er un espace de travail')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_inline_css=>'.is-disabled {opacity: .5}'
,p_step_template=>wwv_flow_api.id(721103220819687982.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>-wwv_flow_api.id(3913175260740993520.4052)
,p_dialog_height=>'450'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEADM/adm_env_sec.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(206356585666953038.4052)
,p_plug_name=>unistr('Avanc\00E9')
,p_region_template_options=>'#DEFAULT#:a-Region--stacked:is-collapsed:a-Region--noBorder'
,p_plug_template=>wwv_flow_api.id(721115784857730284.4052)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(553411572570635317.4052)
,p_plug_name=>unistr('Cr\00E9er un espace de travail')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('Identifiez un utilisateur de base de donn\00E9es, nouveau ou existant, \00E0 utiliser avec le nouvel espace de travail.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(553411969444635320.4052)
,p_plug_name=>'buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1340496247377483380.4052)
,p_plug_name=>unistr('Cr\00E9er un espace de travail')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>11
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(384607787358486094.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(553411969444635320.4052)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er un espace de travail')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(384608102047486098.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(553411969444635320.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(384610182674486116.4052)
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(52034952058715305.4052)
,p_name=>'P142_PASSWORD'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(553411572570635317.4052)
,p_prompt=>'Mot de passe'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Saisissez un mot de passe pour l''utilisateur de base de donn\00E9es. Un mot de passe est requis uniquement si vous cr\00E9ez un utilisateur.</p>'),
'',
unistr('<p>Autonomous Database exige l''utilisation de mots de passe renforc\00E9s. Le mot de passe indiqu\00E9 doit satisfaire les r\00E8gles de complexit\00E9 de mot de passe par d\00E9faut.</p>'),
'',
'<ul>',
unistr('    <li>Le mot de passe doit contenir entre 12 et 30 caract\00E8res, dont au moins une lettre majuscule, une lettre minuscule et un caract\00E8re num\00E9rique.</li>'),
'',
'    <li>Le mot de passe ne peut pas contenir le nom utilisateur.</li>',
'',
unistr('    <li>Le mot de passe ne peut pas \00EAtre l''un des quatre derniers mots de passe utilis\00E9s pour le m\00EAme nom utilisateur.</li>'),
'',
'    <li>Le mot de passe ne peut pas contenir de guillemets (").</li>',
'',
unistr('    <li>Le mot de passe ne doit pas \00EAtre identique \00E0 un mot de passe d\00E9fini moins de 24 heures auparavant.</li>    '),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(52035228106715308.4052)
,p_name=>'P142_NEW_USER_YN'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(553411572570635317.4052)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(384610700214515462.4052)
,p_name=>'P142_DATABASE_USER'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(553411572570635317.4052)
,p_prompt=>unistr('Utilisateur de base de donn\00E9es')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.username d, a.username r ',
'  from wwv_flow_admin_all_schemas a, sys.all_users u',
' where u.username = a.username',
'   and u.common = ''NO''',
'   and u.oracle_maintained = ''N''',
' order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_tag_css_classes=>'u-textUpper'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('S\00E9lectionnez l''utilisateur de base de donn\00E9es existant pour l''espace de travail dans la liste ou saisissez un nouveau nom utilisateur. Il s''agira du nom utilisateur de l''administrateur d''espace de travail et les applications seront cr\00E9\00E9es sur des obj')
||unistr('ets de base de donn\00E9es de ce sch\00E9ma.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(384611825796547479.4052)
,p_name=>'P142_COMPANY'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(553411572570635317.4052)
,p_prompt=>'Nom de l''espace de travail'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>30
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Saisissez le nom de l''espace de travail. Un espace de travail est une zone de travail partag\00E9e dans laquelle plusieurs d\00E9veloppeurs peuvent construire des applications.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(384612667869558383.4052)
,p_name=>'P142_SECURITY_GROUP_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(206356585666953038.4052)
,p_prompt=>'ID d''espace de travail'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('N''indiquez pas l''ID d''espace de travail pour que le nouvel ID d''espace de travail soit automatiquement g\00E9n\00E9r\00E9. Cet ID doit \00EAtre un entier positif sup\00E9rieur \00E0 100 000.'),
'<br /><br />',
unistr('G\00E9n\00E9ralement, vous n''indiquez l''ID d''espace de travail que si vous souhaitez qu''un espace de travail ait le m\00EAme ID dans au moins deux instances &PRODUCT_NAME.. Indiquer l''ID d''espace de travail lors de la cr\00E9ation manuelle d''un espace de travail n''e')
||unistr('st pas une op\00E9ration courante.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'100000'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(663452492781166115.4052)
,p_name=>'P142_ADMIN'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(553411572570635317.4052)
,p_prompt=>'Nom utilisateur de l''administrateur'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_inline_help_text=>'Saisissez le nom utilisateur de l''administrateur d''espace de travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(206356635743953039.4052)
,p_computation_sequence=>10
,p_computation_item=>'P142_DATABASE_USER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:P142_DATABASE_USER)'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(384620781272788403.4052)
,p_validation_name=>'reserved company name'
,p_validation_sequence=>10
,p_validation=>'nvl(upper(:P142_COMPANY),''x'') not in (''INTERNAL'',''UNKNOWN'',''CSS'',''JAVASCRIPT'',''THEMES'',''TUTORIAL'',''XML'',''DOC'',''DP'',''TEMPLATES'')'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Workspace est un nom r\00E9serv\00E9 ; la demande est refus\00E9e.')
,p_when_button_pressed=>wwv_flow_api.id(384607787358486094.4052)
,p_associated_item=>wwv_flow_api.id(384611825796547479.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(384621098980790776.4052)
,p_validation_name=>'company already exists or requested'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select null',
'             from wwv_flow_provision_company',
'            where company_name = upper(:P142_COMPANY)',
'  ) loop',
'  return false;',
'  exit;',
'end loop;',
'for c1 in (select null',
'             from wwv_flow_companies',
'            where short_name = upper(:P142_COMPANY) ) loop',
'   return false;',
'   exit;',
'end loop;',
'',
'if not nvl(length(trim(:P142_COMPANY)),0) > 0 then',
'  return false;',
'end if;',
'',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Le nom d''espace de travail existe d\00E9j\00E0.')
,p_validation_condition=>'P142_COMPANY'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(384607787358486094.4052)
,p_associated_item=>wwv_flow_api.id(384611825796547479.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(384621373688792305.4052)
,p_validation_name=>'Invalid characters in workspace name'
,p_validation_sequence=>30
,p_validation=>'P142_COMPANY'
,p_validation2=>'<>'
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>'Nom d''espace de travail non valide.'
,p_when_button_pressed=>wwv_flow_api.id(384607787358486094.4052)
,p_associated_item=>wwv_flow_api.id(384611825796547479.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(384623220944823230.4052)
,p_validation_name=>'security group id not exists'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_companies',
' where provisioning_company_id = :P142_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('L''ID d''espace de travail existe d\00E9j\00E0.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_num number;',
'begin',
'  l_num := to_number(nvl(:P142_SECURITY_GROUP_ID,''1''));',
'  return true;',
'exception when others then',
'  return false;',
'end;'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'FUNCTION_BODY'
,p_when_button_pressed=>wwv_flow_api.id(384607787358486094.4052)
,p_associated_item=>wwv_flow_api.id(384612667869558383.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(384623543336826352.4052)
,p_validation_name=>'P142_SECURITY_GROUP_ID'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if abs(trunc(:P142_SECURITY_GROUP_ID)) = :P142_SECURITY_GROUP_ID then',
'        return TRUE;',
'    else',
'        return FALSE;',
'    end if;',
'exception when others then',
'    return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('L''ID d''espace de travail doit \00EAtre un entier positif sup\00E9rieur \00E0 100 000.')
,p_validation_condition=>'P142_SECURITY_GROUP_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(384607787358486094.4052)
,p_associated_item=>wwv_flow_api.id(384612667869558383.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(384616042224738712.4052)
,p_validation_name=>'Password not null'
,p_validation_sequence=>55
,p_validation=>'P142_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Vous devez fournir un mot de passe pour l''utilisateur de base de donn\00E9es.')
,p_validation_condition=>'P142_NEW_USER_YN'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(384615872128738710.4052)
,p_validation_name=>'Validate Password'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_4050_ui.p79_validate_password (',
'           p_username => :P142_DATABASE_USER,',
'           p_password => :P142_PASSWORD );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Le mot de passe n''est pas conforme aux r\00E8gles de complexit\00E9 de mot de passe de base de donn\00E9es.')
,p_validation_condition=>'nvl(:P142_NEW_USER_YN,''N'')=''Y'' and :P142_PASSWORD is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(384614956128738701.4052)
,p_name=>'Set P142_COMPANY'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P142_DATABASE_USER'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(384615054939738702.4052)
,p_event_id=>wwv_flow_api.id(384614956128738701.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P142_COMPANY'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'upper(:P142_DATABASE_USER)'
,p_attribute_07=>'P142_DATABASE_USER'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(206356296564953035.4052)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(384608102047486098.4052)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(206356366822953036.4052)
,p_event_id=>wwv_flow_api.id(206356296564953035.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(52035076390715306.4052)
,p_name=>'Set New User YN'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P142_DATABASE_USER'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(52035186175715307.4052)
,p_event_id=>wwv_flow_api.id(52035076390715306.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P142_NEW_USER_YN'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_new_user_yn varchar2(1) := ''Y'';',
'begin',
'    for c1 in (',
'        select null',
'          from wwv_flow_admin_all_schemas a, sys.all_users u',
'         where u.username = a.username',
'           and u.common = ''NO''',
'           and u.oracle_maintained = ''N''',
'           and upper(a.username) = upper(:P142_DATABASE_USER)',
'    ) loop',
'        l_new_user_yn := ''N'';',
'    end loop;',
'    return l_new_user_yn;',
'end;'))
,p_attribute_07=>'P142_DATABASE_USER'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(52035352212715309.4052)
,p_name=>'Toggle Password'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P142_NEW_USER_YN'
,p_condition_element=>'P142_NEW_USER_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(52035495891715310.4052)
,p_event_id=>wwv_flow_api.id(52035352212715309.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P142_PASSWORD'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(52035854244715314.4052)
,p_event_id=>wwv_flow_api.id(52035352212715309.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P142_PASSWORD'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(52035513707715311.4052)
,p_event_id=>wwv_flow_api.id(52035352212715309.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P142_PASSWORD'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(52036037626715316.4052)
,p_event_id=>wwv_flow_api.id(52035352212715309.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_REMOVE_CLASS'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P142_PASSWORD_CONTAINER'
,p_attribute_01=>'is-disabled'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(52035960698715315.4052)
,p_event_id=>wwv_flow_api.id(52035352212715309.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ADD_CLASS'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P142_PASSWORD_CONTAINER'
,p_attribute_01=>'is-disabled'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(384609241818486114.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Workspace'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_landing_page        constant wwv_flow_platform_prefs.name%type := ''LANDING_PAGE_OVERRIDE'';',
'    l_p1 varchar2(256) := wwv_flow_provision.get_random_password(16);',
'    l_p2 varchar2(256);',
'begin',
'',
'   if :P142_SECURITY_GROUP_ID is null then',
'       :P142_SECURITY_GROUP_ID := wwv_flow_id.next_val;',
'   end if;',
'   ',
'   if nvl(:P142_NEW_USER_YN,''N'') = ''Y'' then',
'       l_p1 := :P142_PASSWORD;',
'       l_p2 := :P142_PASSWORD;',
'   end if;',
'',
'    wwv_flow_provisioning.auto_provision_company(',
'        p_company_name        => :P142_COMPANY,',
'        p_schema_name         => :P142_DATABASE_USER,',
'        p_schema_password     => l_p2,',
'        p_admin_password      => l_p1,',
'        p_admin_userid        => :P142_DATABASE_USER,',
'        p_security_group_id   => :P142_SECURITY_GROUP_ID',
'    );',
'    ',
'    if nvl(:P142_NEW_USER_YN,''N'') = ''Y'' then',
'        update wwv_flow_fnd_user',
'           set FIRST_PASSWORD_USE_OCCURRED = ''Y'',',
'               CHANGE_PASSWORD_ON_FIRST_USE = ''N''',
'         where user_name = upper(:P142_DATABASE_USER)',
'           and security_group_id = :P142_SECURITY_GROUP_ID;',
'    end if;',
'',
'    -- Now that the user created at least one workspace, reset the landing page if it is still set to',
'    -- the "first time login" state',
'    if wwv_flow_platform.get_preference(c_landing_page) = ''apex_admin'' then',
'        wwv_flow_platform.set_preference(p_preference_name  => c_landing_page,',
'                                         p_preference_value => '''');',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Erreur lors de la cr\00E9ation de l''espace de travail.')
,p_process_when_button_id=>wwv_flow_api.id(384607787358486094.4052)
,p_process_success_message=>unistr('Espace de travail cr\00E9\00E9. D\00E9connectez-vous des services d''administration et connectez-vous \00E0 <a href="f?p=4550:1:::::F4550_P1_COMPANY,F4550_P1_USERNAME:&P142_COMPANY!ATTR.,&P142_DATABASE_USER!ATTR.">&P142_COMPANY!HTML.</a> pour commencer \00E0 construire d')
||'es applications.'
);
end;
/
prompt --application/pages/page_00144
begin
wwv_flow_api.create_page(
 p_id=>144.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Travaux de chargement des donn\00E9es')
,p_step_title=>unistr('Travaux de chargement des donn\00E9es')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(218528064999706512.4052)
,p_plug_name=>'Data Loading Jobs'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    j.job_name,',
'    j.state,',
'    substr( j.job_name, 18 ) as dataload_job_id,',
'    wwv_flow_utilities.prepare_url( ''f?p=4050:145:'' || :APP_SESSION || ''::::P145_JOB_NAME:''|| job_name ) as link,    ',
'    j.comments,',
'    j.start_date,',
'    regexp_substr( comments, ''(\:)(.*?)(\:)'',1,1,''i'',2 ) as workspace_id,',
'    regexp_substr( comments, ''(\:)(.*?)(\:)'',1,2,''i'',2 ) as workspace_user,',
'    regexp_substr( comments, ''(\:)(.*?)(\:)'',1,3,''i'',2 ) as table_owner,',
'    regexp_substr( comments, ''(\:)(.*?)(\:)'',1,4,''i'',2 ) as table_name,',
'    c.display_name',
'from user_scheduler_jobs j, wwv_flow_companies c',
'where c.provisioning_company_id = regexp_substr( comments, ''(\:)(.*?)(\:)'',1,1,''i'',2 )',
'and job_name like ''ORACLE_APEX_DTLD$%'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(218528160760706513.4052)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>unistr('Aucun travail de chargement des donn\00E9es SQL Workshop n''est actif.')
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_show_actions_menu=>'N'
,p_report_list_mode=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'CARSTEN'
,p_internal_uid=>218528160760706513
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(218528250253706514.4052)
,p_db_column_name=>'JOB_NAME'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Nom du travail DBMS_SCHEDULER'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(218528371017706515.4052)
,p_db_column_name=>'DATALOAD_JOB_ID'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'&nbsp;'
,p_column_link=>'#LINK#'
,p_column_linktext=>unistr('Arr\00EAter')
,p_column_link_attr=>'class="a-Button a-Button--iconTextButton"'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_rpt_show_filter_lov=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(218528575173706517.4052)
,p_db_column_name=>'START_DATE'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>unistr('D\00E9marr\00E9')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(218528492404706516.4052)
,p_db_column_name=>'COMMENTS'
,p_display_order=>50
,p_column_identifier=>'C'
,p_column_label=>unistr('D\00E9tails')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(218528693715706518.4052)
,p_db_column_name=>'STATE'
,p_display_order=>60
,p_column_identifier=>'E'
,p_column_label=>'Etat du travail'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(218528711746706519.4052)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>70
,p_column_identifier=>'F'
,p_column_label=>'ID d''espace de travail'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(218528880092706520.4052)
,p_db_column_name=>'TABLE_OWNER'
,p_display_order=>80
,p_column_identifier=>'G'
,p_column_label=>unistr('Propri\00E9taire de table')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(218528948474706521.4052)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>90
,p_column_identifier=>'H'
,p_column_label=>'Nom de table'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(218529097388706522.4052)
,p_db_column_name=>'DISPLAY_NAME'
,p_display_order=>100
,p_column_identifier=>'I'
,p_column_label=>'Nom de l''espace de travail'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(218529172770706523.4052)
,p_db_column_name=>'WORKSPACE_USER'
,p_display_order=>110
,p_column_identifier=>'J'
,p_column_label=>'Utilisateur d''espace de travail'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(384102019184736250.4052)
,p_db_column_name=>'LINK'
,p_display_order=>120
,p_column_identifier=>'K'
,p_column_label=>'Lien'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(335463803332351501.4052)
,p_name=>'Stop Job Dialog closed.'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(218528064999706512.4052)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(335463917606351502.4052)
,p_event_id=>wwv_flow_api.id(335463803332351501.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(218528064999706512.4052)
);
end;
/
prompt --application/pages/page_00145
begin
wwv_flow_api.create_page(
 p_id=>145.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Arr\00EAter le travail de chargement des donn\00E9es')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Arr\00EAter le travail de chargement des donn\00E9es')
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(218529958866706531.4052)
,p_plug_name=>'Boutons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(218530043769706532.4052)
,p_plug_name=>unistr('Arr\00EAter le travail')
,p_region_css_classes=>'a-Alert--inlineDialog'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(829706609080810173.4052)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>unistr('Voulez-vous arr\00EAter le travail de chargement des donn\00E9es &P145_JOB_NAME. ?')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from user_scheduler_jobs',
'where job_name = :P145_JOB_NAME'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(218530855375706540.4052)
,p_plug_name=>unistr('Travail d\00E9j\00E0 termin\00E9')
,p_region_css_classes=>'a-Alert--inlineDialog'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(829706609080810173.4052)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>unistr('Le travail de chargement des donn\00E9es &P145_JOB_NAME. est d\00E9j\00E0 termin\00E9.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from user_scheduler_jobs',
'where job_name = :P145_JOB_NAME'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(218530154317706533.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(218529958866706531.4052)
,p_button_name=>'STOP_JOB'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Arr\00EAter le travail')
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from user_scheduler_jobs',
'where job_name = :P145_JOB_NAME'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(218530224732706534.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(218529958866706531.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(218530747187706539.4052)
,p_name=>'P145_JOB_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(218530043769706532.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(218530365994706535.4052)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(218530224732706534.4052)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(218530460090706536.4052)
,p_event_id=>wwv_flow_api.id(218530365994706535.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(218530537372706537.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Stop Job'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    sys.dbms_scheduler.stop_job( job_name => :P145_JOB_NAME );',
'end;',
'   '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(218530154317706533.4052)
,p_process_success_message=>unistr('Travail de chargement des donn\00E9es &P145_JOB_NAME. arr\00EAt\00E9.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(218530651319706538.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(218530154317706533.4052)
);
end;
/
prompt --application/pages/page_00147
begin
wwv_flow_api.create_page(
 p_id=>147.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Journal de sauvegarde'
,p_step_title=>'Journal de sauvegarde'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216784309333645873)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_logs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239497587857621454.4052)
,p_plug_name=>'A propos de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Le journal de sauvegarde indique \00E0 quel moment un travail de sauvegarde a \00E9t\00E9 ex\00E9cut\00E9, le nombre d''applications sauvegard\00E9es par le travail et le temps \00E9coul\00E9 requis pour sauvegarder les applications.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239901767442654202.4052)
,p_plug_name=>'Journal de sauvegarde'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.batch_id,  regexp_substr (b.duration, ''\d{2}:\d{2}:\d{2}\.\d{3}'') as duration, b.comments, b.created_on, count(*) as app_count',
'from wwv_flow_backup_log b',
'join wwv_flow_backup_log d on (d.batch_id = b.batch_id)',
'where b.application_id is null',
'and d.application_id is not null',
'group by b.batch_id, b.duration, b.comments, b.created_on;'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(239901875559654202.4052)
,p_name=>'Automatic File Delete Log'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de #MAX_ROW_COUNT# lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'JOEL'
,p_internal_uid=>239901875559654202
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(8001499918535609.4052)
,p_db_column_name=>'BATCH_ID'
,p_display_order=>12
,p_column_identifier=>'J'
,p_column_label=>'Batch'
,p_column_link=>'f?p=&APP_ID.:151:&SESSION.::&DEBUG.:RP,151:P151_BATCH_ID:#BATCH_ID#'
,p_column_linktext=>'#BATCH_ID#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(8001751453535612.4052)
,p_db_column_name=>'COMMENTS'
,p_display_order=>42
,p_column_identifier=>'M'
,p_column_label=>'Commentaires'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(8001803945535613.4052)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>52
,p_column_identifier=>'N'
,p_column_label=>unistr('Cr\00E9ation le')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(8002286775535617.4052)
,p_db_column_name=>'APP_COUNT'
,p_display_order=>72
,p_column_identifier=>'P'
,p_column_label=>'Nombre de sauvegardes d''application'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(8002377664535618.4052)
,p_db_column_name=>'DURATION'
,p_display_order=>82
,p_column_identifier=>'Q'
,p_column_label=>unistr('Dur\00E9e')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(77923751191380757.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(239901767442654202.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:147:&SESSION.::&DEBUG.:RIR,124::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(77924110747380760.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(239901767442654202.4052)
,p_button_name=>'TRUNCATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Vider'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(77929972153380794.4052)
,p_branch_action=>'f?p=&FLOW_ID.:147:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(77929007382380791.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Truncate log'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_backup_log;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors du vidage du journal.'
,p_process_when_button_id=>wwv_flow_api.id(77924110747380760.4052)
,p_process_success_message=>unistr('Journal vid\00E9 avec succ\00E8s.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(77929427811380792.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_api.id(77923751191380757.4052)
);
end;
/
prompt --application/pages/page_00148
begin
wwv_flow_api.create_page(
 p_id=>148.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Cache de dictionnaire'
,p_step_title=>'Cache de dictionnaire'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(60096224377984114.4052)
,p_plug_name=>unistr('Objets mis en cache du dictionnaire de donn\00E9es APEX')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID,',
'       APX_CACHE_DATE,',
'       APX_COL_CACHE_DATE,',
'       APX_WORKSPACE,',
'       APX_WORKSPACE_CREATED,',
'       APX_WORKSPACE_LAST_LOGIN,',
'       APX_WORKSPACE_STATUS,',
'       OBJECT_ID,',
'       OBJECT_OWNER,',
'       OBJECT_NAME,',
'       OBJECT_PREFIX,',
'       OBJECT_TYPE,',
'       OBJECT_CREATED,',
'       OBJECT_LAST_DDL_TIME,',
'       OBJECT_PK_COLUMNS,',
'       DISPLAY_COL_1,',
'       DISPLAY_COL_2,',
'       TAB_LAST_ANALYZED,',
'       TAB_CACHE_NUM_ROWS,',
'       DEFAULT_QUERY,',
'       PREFIX_REMOVED_TAB_NAME,',
'       SINGULAR_DISPLAY_LABEL,',
'       PLURAL_DISPLAY_LABEL,',
'       GEOMETRY_TYPE,',
'       decode(HAS_FK_REFERENCES,''Y'',m.yes,''N'',m.n,HAS_FK_REFERENCES)     HAS_FK_REFERENCES,',
'       decode(HAS_PRIMARY_KEY_YN,''Y'',m.yes,''N'',m.n,HAS_PRIMARY_KEY_YN)   HAS_PRIMARY_KEY_YN,',
'       decode(HAS_LONG_COLUMNS_YN,''Y'',m.yes,''N'',m.n,HAS_LONG_COLUMNS_YN) HAS_LONG_COLUMNS_YN',
'  from WWV_DICTIONARY_CACHE_OBJ co,',
'      (select wwv_flow_lang.system_message(''F4000.NO'') n,',
'            wwv_flow_lang.system_message(''F4000.YES'') yes',
'     from dual) m',
'  where SECURITY_GROUP_ID = :P148_WORKSPACE_ID',
'  and SECURITY_GROUP_ID not in (0,10,11,12)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(60096364688984115.4052)
,p_max_row_count=>'1000000'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>60096364688984115
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60096429759984116.4052)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60096548710984117.4052)
,p_db_column_name=>'APX_CACHE_DATE'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Date du cache'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60096621794984118.4052)
,p_db_column_name=>'APX_COL_CACHE_DATE'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Date du cache de colonne'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60096705053984119.4052)
,p_db_column_name=>'APX_WORKSPACE'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60096948060984121.4052)
,p_db_column_name=>'APX_WORKSPACE_CREATED'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>unistr('Espace de travail cr\00E9\00E9.')
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60097027543984122.4052)
,p_db_column_name=>'APX_WORKSPACE_LAST_LOGIN'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>unistr('Derni\00E8re connexion \00E0 l''espace de travail')
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60097154206984123.4052)
,p_db_column_name=>'APX_WORKSPACE_STATUS'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Statut d''espace de travail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60097297620984124.4052)
,p_db_column_name=>'OBJECT_ID'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'ID d''objet'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60097394102984125.4052)
,p_db_column_name=>'OBJECT_OWNER'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>unistr('Propri\00E9taire d''objet')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60097428309984126.4052)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>110
,p_column_identifier=>'K'
,p_column_label=>'Nom d''objet'
,p_column_link=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:RP,149:P149_OBJECT_CACHE_ID:#ID#'
,p_column_linktext=>'#OBJECT_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60097542185984127.4052)
,p_db_column_name=>'OBJECT_PREFIX'
,p_display_order=>120
,p_column_identifier=>'L'
,p_column_label=>unistr('Pr\00E9fixe d''objet')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60097603274984128.4052)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>130
,p_column_identifier=>'M'
,p_column_label=>'Type d''objet'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60097764975984129.4052)
,p_db_column_name=>'OBJECT_CREATED'
,p_display_order=>140
,p_column_identifier=>'N'
,p_column_label=>unistr('Objet cr\00E9\00E9')
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60097859601984130.4052)
,p_db_column_name=>'OBJECT_LAST_DDL_TIME'
,p_display_order=>150
,p_column_identifier=>'O'
,p_column_label=>unistr('Derni\00E8re d\00E9finition de donn\00E9es')
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60097913039984131.4052)
,p_db_column_name=>'OBJECT_PK_COLUMNS'
,p_display_order=>160
,p_column_identifier=>'P'
,p_column_label=>unistr('Colonnes de cl\00E9 primaire')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(579565817708721526.4052)
,p_db_column_name=>'DISPLAY_COL_1'
,p_display_order=>170
,p_column_identifier=>'Z'
,p_column_label=>'Colonne d''affichage principale'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(579565969446721527.4052)
,p_db_column_name=>'DISPLAY_COL_2'
,p_display_order=>180
,p_column_identifier=>'AA'
,p_column_label=>'Colonne d''affichage secondaire'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60098042827984132.4052)
,p_db_column_name=>'TAB_LAST_ANALYZED'
,p_display_order=>190
,p_column_identifier=>'Q'
,p_column_label=>unistr('Statistiques collect\00E9es')
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60098113789984133.4052)
,p_db_column_name=>'TAB_CACHE_NUM_ROWS'
,p_display_order=>200
,p_column_identifier=>'R'
,p_column_label=>'Nombre de lignes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60098200570984134.4052)
,p_db_column_name=>'DEFAULT_QUERY'
,p_display_order=>210
,p_column_identifier=>'S'
,p_column_label=>unistr('Requ\00EAte par d\00E9faut')
,p_allow_sorting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'CLOB'
,p_rpt_show_filter_lov=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60098368409984135.4052)
,p_db_column_name=>'PREFIX_REMOVED_TAB_NAME'
,p_display_order=>220
,p_column_identifier=>'T'
,p_column_label=>unistr('Ajouter un pr\00E9fixe au nom de la table enlev\00E9e')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60098447224984136.4052)
,p_db_column_name=>'SINGULAR_DISPLAY_LABEL'
,p_display_order=>230
,p_column_identifier=>'U'
,p_column_label=>unistr('Libell\00E9 au singulier')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60098580548984137.4052)
,p_db_column_name=>'PLURAL_DISPLAY_LABEL'
,p_display_order=>240
,p_column_identifier=>'V'
,p_column_label=>unistr('Libell\00E9 au pluriel')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(564900691516013101.4052)
,p_db_column_name=>'GEOMETRY_TYPE'
,p_display_order=>250
,p_column_identifier=>'AB'
,p_column_label=>unistr('Type de g\00E9om\00E9trie')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(564921851272063247)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60098678821984138.4052)
,p_db_column_name=>'HAS_FK_REFERENCES'
,p_display_order=>260
,p_column_identifier=>'W'
,p_column_label=>unistr('A des r\00E9f\00E9rences de cl\00E9 \00E9trang\00E8re')
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60098728006984139.4052)
,p_db_column_name=>'HAS_PRIMARY_KEY_YN'
,p_display_order=>270
,p_column_identifier=>'X'
,p_column_label=>unistr('A une cl\00E9 primaire')
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60098825711984140.4052)
,p_db_column_name=>'HAS_LONG_COLUMNS_YN'
,p_display_order=>280
,p_column_identifier=>'Y'
,p_column_label=>'A des colonnes de type Long'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1049900178760634715.4052)
,p_plug_name=>'Filtre de cache de dictionnaire d''espace de travail'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>2
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(525110925345577129.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1049900178760634715.4052)
,p_button_name=>'analyze_refresh'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--padLeft'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('Collecter des statistiques et r\00E9g\00E9n\00E9rer le cache')
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(525108173850577101.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1049900178760634715.4052)
,p_button_name=>'refresh'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--padLeft'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9g\00E9n\00E9rer le cache uniquement')
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(525111487137577134.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(60096224377984114.4052)
,p_button_name=>'reset_report'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:148:&SESSION.::&DEBUG.:RP,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(525095890207396166.4052)
,p_name=>'P148_WORKSPACE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1049900178760634715.4052)
,p_prompt=>'Espace de travail'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name, PROVISIONING_COMPANY_ID',
'from WWV_FLOW_COMPANIES',
'order by 1'))
,p_lov_display_null=>'YES'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
,p_attribute_06=>'0'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(525108317868577103.4052)
,p_name=>'workspace'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P148_WORKSPACE_ID'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(525108467585577104.4052)
,p_event_id=>wwv_flow_api.id(525108317868577103.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(525108226704577102.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ComputeStats'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_dictionary_cache_dev.builder_set_workspace_cache (',
'    p_workspace_id            => :P148_WORKSPACE_ID,',
'    p_gather_stats            => false,',
'    p_max_cache_stale_seconds => 5,     -- seconds',
'    p_max_tables_per_schema   => 1000,  -- tables',
'    p_stats_mode              => ''estimate'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(525108173850577101.4052)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(525111048901577130.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ComputeStats_analyze'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_dictionary_cache_dev.builder_set_workspace_cache (',
'    p_workspace_id            => :P148_WORKSPACE_ID,',
'    p_gather_stats            => true,',
'    p_max_stats_age_seconds   => 10,',
'    p_max_cache_stale_seconds => 10,     -- seconds',
'    p_max_tables_per_schema   => 1000,   -- tables',
'    p_stats_mode              => ''estimate'',',
'    p_max_elap_exec_time_sec  => 600     -- if it takes 10 minutes, exit',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(525110925345577129.4052)
,p_process_success_message=>unistr('Statistiques calcul\00E9es pour l''espace de travail s\00E9lectionn\00E9')
);
end;
/
prompt --application/pages/page_00149
begin
wwv_flow_api.create_page(
 p_id=>149.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Colonnes de table de cache de dictionnaire de donn\00E9es')
,p_step_title=>unistr('Colonnes de table de cache de dictionnaire de donn\00E9es')
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(524803615085238539.4052)
,p_plug_name=>'Filtres de rapport'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(525111938241577139.4052)
,p_name=>unistr('D\00E9tails de table')
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_sub_css_classes=>'a-AVPList--leftAligned'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID,',
'       APX_CACHE_DATE,',
'       OBJECT_NAME,',
'       OBJECT_TYPE,',
'       OBJECT_CREATED,',
'       --OBJECT_LAST_DDL_TIME,',
'       OBJECT_PK_COLUMNS,',
'       TAB_LAST_ANALYZED,',
'       TAB_CACHE_NUM_ROWS,',
'       decode(HAS_FK_REFERENCES,''Y'',m.yes,''N'',m.n,HAS_FK_REFERENCES)     HAS_FK_REFERENCES',
'  from WWV_DICTIONARY_CACHE_OBJ co,',
'      (select wwv_flow_lang.system_message(''F4000.NO'') n,',
'            wwv_flow_lang.system_message(''F4000.YES'') yes',
'     from dual) m',
' where id = :P149_OBJECT_CACHE_ID'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805670753642677848.4052)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e')
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(525112016945577140.4052)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(525112126586577141.4052)
,p_query_column_id=>2
,p_column_alias=>'APX_CACHE_DATE'
,p_column_display_sequence=>5
,p_column_heading=>'Date du cache'
,p_use_as_row_header=>'N'
,p_column_format=>'DD-MON-YYYY HH24:MI:SS'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(525113084679577150.4052)
,p_query_column_id=>3
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nom d''objet'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(562146788838879302.4052)
,p_query_column_id=>4
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Type d''objet'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(562146817766879303.4052)
,p_query_column_id=>5
,p_column_alias=>'OBJECT_CREATED'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Objet cr\00E9\00E9')
,p_use_as_row_header=>'N'
,p_column_format=>'DD-MON-YYYY HH24:MI:SS'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(562147050273879305.4052)
,p_query_column_id=>6
,p_column_alias=>'OBJECT_PK_COLUMNS'
,p_column_display_sequence=>7
,p_column_heading=>unistr('Colonnes de cl\00E9 primaire')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(562147161214879306.4052)
,p_query_column_id=>7
,p_column_alias=>'TAB_LAST_ANALYZED'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Statistiques collect\00E9es')
,p_use_as_row_header=>'N'
,p_column_format=>'DD-MON-YYYY HH24:MI:SS'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(562147255245879307.4052)
,p_query_column_id=>8
,p_column_alias=>'TAB_CACHE_NUM_ROWS'
,p_column_display_sequence=>8
,p_column_heading=>'Lignes'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(562147795985879312.4052)
,p_query_column_id=>9
,p_column_alias=>'HAS_FK_REFERENCES'
,p_column_display_sequence=>9
,p_column_heading=>unistr('R\00E9f\00E9rences de cl\00E9 \00E9trang\00E8re')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(562148217569879317.4052)
,p_name=>unistr('Requ\00EAtes de colonne')
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select FILTERABLE_SCORE, ',
'       decode(RECOMMEND_CHART_TYPE,''PIE'',m.PIE_CHART,''BAR'',m.BAR_CHART,RECOMMEND_CHART_TYPE) RECOMMEND_CHART_TYPE,',
'       decode(FK_CHART_QUERY,',
'              null,',
'              ''select "''||COLUMN_NAME||''", count(*) c ''||chr(10)||',
'              ''from "''||TABLE_NAME||''" ''||chr(10)||',
'              ''group by "''||COLUMN_NAME||''" ''||chr(10)||',
'              ''order by 2 desc'',FK_CHART_QUERY) chart_query',
'from WWV_DICTIONARY_CACHE_COL,',
'        (select wwv_flow_lang.system_message(''BAR_CHART'')   BAR_CHART,',
'                wwv_flow_lang.system_message(''PIE_CHART'')   PIE_CHART',
'         from dual) m',
'where OBJECT_CACHE_ID = :P149_OBJECT_CACHE_ID and ',
'     FILTERABLE_SCORE >= 20 and',
'     (DATA_TYPE in (''VARCHAR'',''VARCHAR2'',''CHAR'') or FK_CHART_QUERY is not null)',
'order by FILTERABLE_SCORE desc'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 x',
'from WWV_DICTIONARY_CACHE_COL',
'where OBJECT_CACHE_ID = :P149_OBJECT_CACHE_ID and ',
'     FILTERABLE_SCORE >= 20 and',
'     (DATA_TYPE in (''VARCHAR'',''VARCHAR2'',''CHAR'') or FK_CHART_QUERY is not null)'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(565825012543226210.4052)
,p_query_column_id=>1
,p_column_alias=>'FILTERABLE_SCORE'
,p_column_display_sequence=>1
,p_column_heading=>'Pertinence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(562148362693879318.4052)
,p_query_column_id=>2
,p_column_alias=>'RECOMMEND_CHART_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Type de graphique'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(562148951029879324.4052)
,p_query_column_id=>3
,p_column_alias=>'CHART_QUERY'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Requ\00EAte')
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<pre>#CHART_QUERY#</pre>'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(565824800545226208.4052)
,p_plug_name=>unistr('Requ\00EAte de table')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select sys.dbms_lob.substr(DEFAULT_QUERY,32767,1) DEFAULT_QUERY',
'  from WWV_DICTIONARY_CACHE_OBJ',
' where id = :P149_OBJECT_CACHE_ID ) ',
'loop',
'',
'    sys.htp.prn(''<pre class="padding-md">'');',
'    sys.htp.prn(wwv_flow_escape.html(c1.DEFAULT_QUERY));',
'    sys.htp.prn(''</pre>'');',
'',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(584885052401216767.4052)
,p_plug_name=>unistr('Cache de colonne de dictionnaire de donn\00E9es')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID,',
'       OBJECT_CACHE_ID,',
'       APX_CACHE_DATE,',
'       OWNER_NAME,',
'       TABLE_NAME,',
'       COLUMN_NAME,',
'       DATA_TYPE_DISPLAY,',
'       DATA_TYPE,',
'       DATA_LENGTH,',
'       DATA_SCALE,',
'       DATA_PRECISION,',
'       has_char_semantics_yn,',
'       NULLABLE,',
'       DENSITY,',
'       NUM_NULLS,',
'       LAST_ANALYZED,',
'       AVG_COL_LEN,',
'       NUM_DISTINCT,',
'       COLUMN_ID,',
'       --',
'       decode(ITEM_DISPLAY_AS,',
'          ''TEXT'',m.m_text,',
'          ''NUMBER'',m.m_number,',
'          ''CHECKBOX'',m.checkbox,',
'          ''DATE_PICKER'',m.date_picker,',
'          ''TEXTAREA'',m.TEXTAREA,',
'          ITEM_DISPLAY_AS)',
'          ITEM_DISPLAY_AS,',
'       decode(FILTER_DISPLAY_AS,''CHECKBOX'',m.checkbox,',
'          ''RANGE'',m.range,',
'          ''DATE_PICKER'',m.date_picker,',
'          FILTER_DISPLAY_AS)',
'          FILTER_DISPLAY_AS,',
'       --',
'       LABEL,',
'       FORMAT_MASK,',
'       --',
'       decode(RECOMMEND_DISP_ON_RPT_YN,    ''Y'',m.yes,''N'',m.n) RECOMMEND_DISP_ON_RPT_YN,',
'       decode(RECOMMEND_DISP_ON_FORMS_YN,  ''Y'',m.yes,''N'',m.n) RECOMMEND_DISP_ON_FORMS_YN,',
'       decode(HAS_LEADING_IDX_YN,          ''Y'',m.yes,''N'',m.n) HAS_LEADING_IDX_YN,    ',
'       decode(IS_SINGLE_COL_PK_YN,         ''Y'',m.yes,''N'',m.n) IS_SINGLE_COL_PK_YN,',
'       decode(FILTER_GLOBAL_SEARCHABLE_YN, ''Y'',m.yes,''N'',m.n) facet_search_col_yn,',
'       decode(SINGLE_COL_UNIQUE_CON_YN,    ''Y'',m.yes,''N'',m.n) SINGLE_COL_UNIQUE_CON_YN,',
'       decode(IS_VIRTUALLY_UNIQUE_YN,      ''Y'',m.yes,''N'',m.n) IS_VIRTUALLY_UNIQUE_YN,',
'       --',
'       PK_POSITION,',
'       is_identity_yn,',
'       IS_FK_YN,',
'       IS_FK_INDEXED_YN,',
'       DRILL_DOWN_TABLE,',
'       DRILL_DOWN_DISPLAY_COLUMN,',
'       DRILL_DOWN_RETURN_COLUMN,',
'       LOW_VALUE,',
'       HIGH_VALUE,',
'       LOW_NUMBER,',
'       HIGH_NUMBER,',
'       LOW_DATE,',
'       HIGH_DATE,',
'       FILTERABLE_SCORE,',
'       NUM_NOT_NULL,',
'       PCT_NULL,',
'       RECOMMEND_CHART_TYPE,',
'       FK_CHART_QUERY,',
'       CHART_LABEL_COLUMN,',
'       CHART_VALUE_COLUMN,',
'       COLUMN_QUERY,',
'       STATIC_LOV',
'  from WWV_DICTIONARY_CACHE_COL cc,',
'        (select wwv_flow_lang.system_message(''F4000.NO'')    n,',
'                wwv_flow_lang.system_message(''F4000.YES'')   yes,',
'                wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_CHECKBOX'')    checkbox,',
'                wwv_flow_lang.system_message(''APEX.IG.RANGE'')                range,',
'                wwv_flow_lang.system_message(''ITEM_NAME.TEXT'')               m_text,',
'                wwv_flow_lang.system_message(''WS_NUMBER'')                    m_number,',
'                wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_DATE_PICKER'') date_picker,',
'                wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_RADIOGROUP'')  RADIOGROUP,',
'                wwv_flow_lang.system_message(''ITEM_NAME.NATIVE_TEXTAREA'')    TEXTAREA',
'         from dual) m',
'  where OBJECT_CACHE_ID = :P149_OBJECT_CACHE_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(584885192712216768.4052)
,p_max_row_count=>'1000000'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>584885192712216768
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524789425659232668.4052)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524789817808232670.4052)
,p_db_column_name=>'APX_CACHE_DATE'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Date du cache'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60098945549984141.4052)
,p_db_column_name=>'OBJECT_CACHE_ID'
,p_display_order=>30
,p_column_identifier=>'Z'
,p_column_label=>'ID de cache d''objet'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60099016342984142.4052)
,p_db_column_name=>'OWNER_NAME'
,p_display_order=>40
,p_column_identifier=>'AA'
,p_column_label=>unistr('Propri\00E9taire')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60099148004984143.4052)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>50
,p_column_identifier=>'AB'
,p_column_label=>'Nom de table'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60099212143984144.4052)
,p_db_column_name=>'COLUMN_NAME'
,p_display_order=>60
,p_column_identifier=>'AC'
,p_column_label=>'Nom de colonne'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524800787276238510.4052)
,p_db_column_name=>'LABEL'
,p_display_order=>70
,p_column_identifier=>'AS'
,p_column_label=>unistr('Libell\00E9')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60099350774984145.4052)
,p_db_column_name=>'DATA_TYPE_DISPLAY'
,p_display_order=>80
,p_column_identifier=>'AD'
,p_column_label=>'Afficher en tant que'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60099436968984146.4052)
,p_db_column_name=>'DATA_TYPE'
,p_display_order=>90
,p_column_identifier=>'AE'
,p_column_label=>unistr('Type de donn\00E9es')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60099578575984147.4052)
,p_db_column_name=>'DATA_LENGTH'
,p_display_order=>100
,p_column_identifier=>'AF'
,p_column_label=>unistr('Longueur de donn\00E9es')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60099698797984148.4052)
,p_db_column_name=>'DATA_SCALE'
,p_display_order=>110
,p_column_identifier=>'AG'
,p_column_label=>unistr('Echelle de donn\00E9es ')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60099777889984149.4052)
,p_db_column_name=>'DATA_PRECISION'
,p_display_order=>120
,p_column_identifier=>'AH'
,p_column_label=>unistr('Pr\00E9cision des donn\00E9es')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(606264386193993803.4052)
,p_db_column_name=>'HAS_CHAR_SEMANTICS_YN'
,p_display_order=>130
,p_column_identifier=>'BW'
,p_column_label=>unistr('Utilise la s\00E9mantique de caract\00E8re')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(157992123774592395)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(60099827535984150.4052)
,p_db_column_name=>'NULLABLE'
,p_display_order=>140
,p_column_identifier=>'AI'
,p_column_label=>'Nullable'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(157992123774592395)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524799872884238501.4052)
,p_db_column_name=>'DENSITY'
,p_display_order=>150
,p_column_identifier=>'AJ'
,p_column_label=>unistr('Densit\00E9')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524799948789238502.4052)
,p_db_column_name=>'NUM_NULLS'
,p_display_order=>160
,p_column_identifier=>'AK'
,p_column_label=>'Nombre de valeurs NULL'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524800002669238503.4052)
,p_db_column_name=>'LAST_ANALYZED'
,p_display_order=>170
,p_column_identifier=>'AL'
,p_column_label=>unistr('Statistiques collect\00E9es')
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE_SHORT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524800171102238504.4052)
,p_db_column_name=>'AVG_COL_LEN'
,p_display_order=>180
,p_column_identifier=>'AM'
,p_column_label=>unistr('Longueur moyenne des donn\00E9es')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524800211104238505.4052)
,p_db_column_name=>'NUM_DISTINCT'
,p_display_order=>190
,p_column_identifier=>'AN'
,p_column_label=>'Distinct'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524800302405238506.4052)
,p_db_column_name=>'COLUMN_ID'
,p_display_order=>200
,p_column_identifier=>'AO'
,p_column_label=>'ID de colonne'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524800453878238507.4052)
,p_db_column_name=>'ITEM_DISPLAY_AS'
,p_display_order=>210
,p_column_identifier=>'AP'
,p_column_label=>unistr('Affichage d''\00E9l\00E9ment')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524800584988238508.4052)
,p_db_column_name=>'FILTER_DISPLAY_AS'
,p_display_order=>220
,p_column_identifier=>'AQ'
,p_column_label=>'Affichage de facet'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524800822260238511.4052)
,p_db_column_name=>'FORMAT_MASK'
,p_display_order=>230
,p_column_identifier=>'AT'
,p_column_label=>'Masque de format'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524800904796238512.4052)
,p_db_column_name=>'RECOMMEND_DISP_ON_RPT_YN'
,p_display_order=>240
,p_column_identifier=>'AU'
,p_column_label=>unistr('Recommander l''affichage dans l''\00E9tat')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524801041508238513.4052)
,p_db_column_name=>'RECOMMEND_DISP_ON_FORMS_YN'
,p_display_order=>250
,p_column_identifier=>'AV'
,p_column_label=>'Recommander l''affichage dans les panneaux'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524801144818238514.4052)
,p_db_column_name=>'HAS_LEADING_IDX_YN'
,p_display_order=>260
,p_column_identifier=>'AW'
,p_column_label=>unistr('A un index de d\00E9but')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524801224945238515.4052)
,p_db_column_name=>'IS_SINGLE_COL_PK_YN'
,p_display_order=>270
,p_column_identifier=>'AX'
,p_column_label=>unistr('Cl\00E9 primaire \00E0 colonne unique')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524801373558238516.4052)
,p_db_column_name=>'PK_POSITION'
,p_display_order=>280
,p_column_identifier=>'AY'
,p_column_label=>unistr('Position de la cl\00E9 primaire')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(606264461819993804.4052)
,p_db_column_name=>'IS_IDENTITY_YN'
,p_display_order=>290
,p_column_identifier=>'BX'
,p_column_label=>unistr('Colonne d''identit\00E9')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(157992123774592395)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524801410753238517.4052)
,p_db_column_name=>'SINGLE_COL_UNIQUE_CON_YN'
,p_display_order=>300
,p_column_identifier=>'AZ'
,p_column_label=>'Contrainte unique'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524801565830238518.4052)
,p_db_column_name=>'IS_VIRTUALLY_UNIQUE_YN'
,p_display_order=>310
,p_column_identifier=>'BA'
,p_column_label=>'Est presque unique'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524801666963238519.4052)
,p_db_column_name=>'IS_FK_YN'
,p_display_order=>320
,p_column_identifier=>'BB'
,p_column_label=>unistr('Est une cl\00E9 \00E9trang\00E8re')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(157992123774592395)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524801738525238520.4052)
,p_db_column_name=>'IS_FK_INDEXED_YN'
,p_display_order=>330
,p_column_identifier=>'BC'
,p_column_label=>unistr('Cl\00E9 \00E9trang\00E8re index\00E9e')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524801865482238521.4052)
,p_db_column_name=>'DRILL_DOWN_TABLE'
,p_display_order=>340
,p_column_identifier=>'BD'
,p_column_label=>'Table d''analyse descendante'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524801907346238522.4052)
,p_db_column_name=>'DRILL_DOWN_DISPLAY_COLUMN'
,p_display_order=>350
,p_column_identifier=>'BE'
,p_column_label=>'Colonne d''affichage d''analyse descendante'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524802097646238523.4052)
,p_db_column_name=>'DRILL_DOWN_RETURN_COLUMN'
,p_display_order=>360
,p_column_identifier=>'BF'
,p_column_label=>unistr('Colonne renvoy\00E9e d''analyse descendante')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524802187839238524.4052)
,p_db_column_name=>'LOW_VALUE'
,p_display_order=>370
,p_column_identifier=>'BG'
,p_column_label=>'Valeur faible'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524802265102238525.4052)
,p_db_column_name=>'HIGH_VALUE'
,p_display_order=>380
,p_column_identifier=>'BH'
,p_column_label=>unistr('Valeur \00E9lev\00E9e')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524802344292238526.4052)
,p_db_column_name=>'LOW_NUMBER'
,p_display_order=>390
,p_column_identifier=>'BI'
,p_column_label=>'Nombre faible'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524802414098238527.4052)
,p_db_column_name=>'HIGH_NUMBER'
,p_display_order=>400
,p_column_identifier=>'BJ'
,p_column_label=>unistr('Nombre \00E9lev\00E9')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524802586684238528.4052)
,p_db_column_name=>'LOW_DATE'
,p_display_order=>410
,p_column_identifier=>'BK'
,p_column_label=>'Date faible'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524802693693238529.4052)
,p_db_column_name=>'HIGH_DATE'
,p_display_order=>420
,p_column_identifier=>'BL'
,p_column_label=>unistr('Date \00E9lev\00E9e')
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524802798505238530.4052)
,p_db_column_name=>'FILTERABLE_SCORE'
,p_display_order=>430
,p_column_identifier=>'BM'
,p_column_label=>unistr('Score de recherche \00E0 facets')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(606264590935993805.4052)
,p_db_column_name=>'FACET_SEARCH_COL_YN'
,p_display_order=>440
,p_column_identifier=>'BY'
,p_column_label=>'Colonne de facet pouvant faire l''objet d''une recherche'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524802852545238531.4052)
,p_db_column_name=>'NUM_NOT_NULL'
,p_display_order=>450
,p_column_identifier=>'BN'
,p_column_label=>'Non NULL'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524802955741238532.4052)
,p_db_column_name=>'PCT_NULL'
,p_display_order=>460
,p_column_identifier=>'BO'
,p_column_label=>'Pourcentage de valeurs NULL'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G990D0000'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524803068508238533.4052)
,p_db_column_name=>'RECOMMEND_CHART_TYPE'
,p_display_order=>470
,p_column_identifier=>'BP'
,p_column_label=>'Recommander un graphique'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524803149342238534.4052)
,p_db_column_name=>'FK_CHART_QUERY'
,p_display_order=>480
,p_column_identifier=>'BQ'
,p_column_label=>unistr('Requ\00EAte de graphique de cl\00E9 \00E9trang\00E8re')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524803270358238535.4052)
,p_db_column_name=>'CHART_LABEL_COLUMN'
,p_display_order=>490
,p_column_identifier=>'BR'
,p_column_label=>unistr('Colonne de libell\00E9 de graphique')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524803382264238536.4052)
,p_db_column_name=>'CHART_VALUE_COLUMN'
,p_display_order=>500
,p_column_identifier=>'BS'
,p_column_label=>'Colonne de valeur de graphique'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524803459631238537.4052)
,p_db_column_name=>'COLUMN_QUERY'
,p_display_order=>510
,p_column_identifier=>'BT'
,p_column_label=>unistr('Requ\00EAte de colonne')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524803507332238538.4052)
,p_db_column_name=>'STATIC_LOV'
,p_display_order=>520
,p_column_identifier=>'BU'
,p_column_label=>'Liste de valeurs (LOV) statique'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(525315256234977749.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(524803615085238539.4052)
,p_button_name=>'gather_stats'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('Collecter des statistiques et r\00E9g\00E9n\00E9rer le cache')
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(525111820549577138.4052)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(524803615085238539.4052)
,p_button_name=>'refresh_cache'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--padLeft'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9g\00E9n\00E9rer le cache uniquement')
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(525111344357577133.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(584885052401216767.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:RP,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(524803758352238540.4052)
,p_name=>'P149_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(524803615085238539.4052)
,p_prompt=>'Nom de table'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select OBJECT_NAME',
'from wwv_dictionary_cache_obj',
'where id = :P149_OBJECT_CACHE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(525110886602577128.4052)
,p_name=>'P149_OBJECT_CACHE_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(524803615085238539.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(525303525750948617.4052)
,p_name=>'P149_TABLE_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(524803615085238539.4052)
,p_prompt=>unistr('Propri\00E9taire de table')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_owner',
'from wwv_dictionary_cache_obj',
'where id = :P149_OBJECT_CACHE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(525108740586577107.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh table cache with stats'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_new_object_cache_id number;',
'begin',
'    l_new_object_cache_id := wwv_dictionary_cache_dev.builder_reset_object_cache(',
'                                 p_workspace_id             => :P148_WORKSPACE_ID,',
'                                 p_object_id                => :P149_OBJECT_CACHE_ID,',
'                                 p_cache_fk_references      => true,',
'                                 p_gather_stats             => true );',
'                                 ',
'    :P149_OBJECT_CACHE_ID := l_new_object_cache_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(525315256234977749.4052)
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(525111566533577135.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Cache'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_new_object_cache_id number;',
'begin',
'    l_new_object_cache_id := wwv_dictionary_cache_dev.builder_reset_object_cache(',
'                                 p_workspace_id             => :P148_WORKSPACE_ID,',
'                                 p_object_id                => :P149_OBJECT_CACHE_ID,',
'                                 p_cache_fk_references      => true,',
'                                 p_gather_stats             => false );',
'                                 ',
'    :P149_OBJECT_CACHE_ID := l_new_object_cache_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(525111820549577138.4052)
);
null;
end;
/
prompt --application/pages/page_00150
begin
wwv_flow_api.create_page(
 p_id=>150.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Cache de dictionnaire de donn\00E9es - Espaces de travail')
,p_step_title=>unistr('Cache de dictionnaire de donn\00E9es - Espaces de travail')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(585156988233310532.4052)
,p_plug_name=>unistr('Dictionnaire de donn\00E9es - Espaces de travail')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID,',
'       PROVISIONING_COMPANY_ID,',
'       DISPLAY_NAME workspace_name,',
'       --',
'       (select count(*) ',
'        from WWV_DICTIONARY_CACHE_OBJ d ',
'        where d.SECURITY_GROUP_ID = c.PROVISIONING_COMPANY_ID) cached_objects,',
'        --',
'       (select count(distinct OBJECT_OWNER) ',
'        from WWV_DICTIONARY_CACHE_OBJ d ',
'        where d.SECURITY_GROUP_ID = c.PROVISIONING_COMPANY_ID) schemas,',
'        --',
'        (select max(OBJECT_LAST_DDL_TIME) x',
'        from WWV_DICTIONARY_CACHE_OBJ d ',
'        where d.SECURITY_GROUP_ID = c.PROVISIONING_COMPANY_ID) last_ddl_time,',
'        --',
'        (select max(APX_CACHE_DATE) x',
'        from WWV_DICTIONARY_CACHE_OBJ d ',
'        where d.SECURITY_GROUP_ID = c.PROVISIONING_COMPANY_ID) last_cache_time ',
'  from WWV_FLOW_COMPANIES c',
'where PROVISIONING_COMPANY_ID not in (0,10,11,12)',
' '))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(585157128544310533.4052)
,p_max_row_count=>'1000000'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>585157128544310533
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(525061346641326421.4052)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524804085454238543.4052)
,p_db_column_name=>'PROVISIONING_COMPANY_ID'
,p_display_order=>20
,p_column_identifier=>'Z'
,p_column_label=>'ID d''espace de travail'
,p_column_type=>'NUMBER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524804145713238544.4052)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>30
,p_column_identifier=>'AA'
,p_column_label=>'Espace de travail'
,p_column_link=>'f?p=&APP_ID.:148:&SESSION.::&DEBUG.:RP,148:P148_WORKSPACE_ID:#PROVISIONING_COMPANY_ID#'
,p_column_linktext=>'#WORKSPACE_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524804250665238545.4052)
,p_db_column_name=>'CACHED_OBJECTS'
,p_display_order=>40
,p_column_identifier=>'AB'
,p_column_label=>unistr('Objets en m\00E9moire cache')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524804319247238546.4052)
,p_db_column_name=>'SCHEMAS'
,p_display_order=>50
,p_column_identifier=>'AC'
,p_column_label=>unistr('Nombre de sch\00E9mas')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524804473203238547.4052)
,p_db_column_name=>'LAST_DDL_TIME'
,p_display_order=>60
,p_column_identifier=>'AD'
,p_column_label=>unistr('Derni\00E8re d\00E9finition de donn\00E9es')
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524804508974238548.4052)
,p_db_column_name=>'LAST_CACHE_TIME'
,p_display_order=>70
,p_column_identifier=>'AE'
,p_column_label=>'Dernier cache de dictionnaire'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(525111272338577132.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(585156988233310532.4052)
,p_button_name=>'reset_report'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:150:&SESSION.::&DEBUG.:RP,150,RIR::'
);
end;
/
prompt --application/pages/page_00151
begin
wwv_flow_api.create_page(
 p_id=>151.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('D\00E9tails du journal de sauvegarde')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('D\00E9tails du journal de sauvegarde')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216784309333645873)
,p_step_template=>wwv_flow_api.id(721098050798687927.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_logs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(318102195946685150.4052)
,p_plug_name=>'Journal de sauvegarde'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.batch_id, b.application_id, b.security_group_id, regexp_substr (b.duration, ''\d{2}:\d{2}:\d{2}\.\d{3}'') as duration, b.created_on',
'from wwv_flow_backup_log b',
'where b.application_id is not null',
'and b.batch_id = :P151_BATCH_ID;'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(318102304063685150.4052)
,p_name=>'Automatic File Delete Log'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de #MAX_ROW_COUNT# lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'JOEL'
,p_internal_uid=>318102304063685150
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(78201382123031006.4052)
,p_db_column_name=>'BATCH_ID'
,p_display_order=>12
,p_column_identifier=>'J'
,p_column_label=>'ID de batch'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(78202100719031010.4052)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>52
,p_column_identifier=>'N'
,p_column_label=>unistr('Cr\00E9ation le')
,p_column_type=>'DATE'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(78202992687031011.4052)
,p_db_column_name=>'DURATION'
,p_display_order=>82
,p_column_identifier=>'Q'
,p_column_label=>unistr('Dur\00E9e')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(8002552665535620.4052)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>92
,p_column_identifier=>'R'
,p_column_label=>'ID d''application'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(8002664121535621.4052)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>102
,p_column_identifier=>'S'
,p_column_label=>unistr('ID de groupe de s\00E9curit\00E9')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78203725704031019.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(318102195946685150.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:151:&SESSION.::&DEBUG.:RIR,124::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(78205478605031033.4052)
,p_branch_action=>'f?p=&FLOW_ID.:151:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8002447137535619.4052)
,p_name=>'P151_BATCH_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(318102195946685150.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(78204980627031031.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_api.id(78203725704031019.4052)
);
end;
/
prompt --application/pages/page_00152
begin
wwv_flow_api.create_page(
 p_id=>152.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Recherche \00E0 facets d''un espace de travail')
,p_step_title=>unistr('Recherche \00E0 facets d''un espace de travail')
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(500583153011311249.4052)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(470837694635277726.4052)
,p_plug_name=>'Facets actifs'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--slimPadding:a-ButtonRegion--noBorder:a-ButtonRegion--accessibleTitle'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<div id="active_facets"></div>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472532155894148648.4052)
,p_plug_name=>'Facets'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source_type=>'NATIVE_FACETED_SEARCH'
,p_filtered_region_id=>wwv_flow_api.id(500561639362993025.4052)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_06=>'E'
,p_attribute_08=>'#active_facets'
,p_attribute_09=>'N'
,p_attribute_13=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(500561639362993025.4052)
,p_name=>'Espaces de travail'
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with data as (',
'    select /*+ MATERIALIZE */ c.short_name  workspace, ',
'       c.PROVISIONING_COMPANY_ID,',
'       nvl((select sum(PAGE_EVENTS) from WWV_FLOW_LOG_HISTORY h where h.WORKSPACE_ID = c.PROVISIONING_COMPANY_ID),0) page_views, ',
'       nvl((select sum(PAGE_EVENTS) from WWV_FLOW_LOG_HISTORY h where h.WORKSPACE_ID = c.PROVISIONING_COMPANY_ID and log_day >= sysdate - 30),0) page_views_30d, ',
'       nvl((select sum(PAGE_EVENTS) from WWV_FLOW_LOG_HISTORY h where h.WORKSPACE_ID = c.PROVISIONING_COMPANY_ID and log_day >= sysdate - 90),0) page_views_90d, ',
'       nvl((select count(*) from wwv_flows f where f.SECURITY_GROUP_ID = c.PROVISIONING_COMPANY_ID),0) applications,',
'       (select max(log_day) from WWV_FLOW_LOG_HISTORY h where h.WORKSPACE_ID = c.PROVISIONING_COMPANY_ID) last_archived_view,',
'       decode(nvl((select 1 from dual where exists (',
'           select 1 from WWV_FLOW_LOG_HISTORY h where h.WORKSPACE_ID = c.PROVISIONING_COMPANY_ID and log_day >= sysdate - 30)),',
'                  0),0,sm.t_no,sm.t_yes) views_30_yn,',
'       decode(nvl((select 1 from dual where exists (',
'           select 1 from WWV_FLOW_LOG_HISTORY h where h.WORKSPACE_ID = c.PROVISIONING_COMPANY_ID and log_day >= sysdate - 90)),',
'                  0),0,sm.t_no,sm.t_yes) views_90_yn',
'      from wwv_flow_companies c ,',
'           (select wwv_flow_lang.system_message(''F4000.YES'') t_yes,',
'                   wwv_flow_lang.system_message(''F4000.NO'') t_no',
'              from sys.dual) sm',
'     where c.provisioning_company_id not in (11, 12)',
'    )',
'    select * from data'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>unistr('aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>100000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_prn_format=>'PDF'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(472531603993148643.4052)
,p_query_column_id=>1
,p_column_alias=>'WORKSPACE'
,p_column_display_sequence=>1
,p_column_heading=>'Espace de travail'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(626566385737636306.4052)
,p_query_column_id=>2
,p_column_alias=>'PROVISIONING_COMPANY_ID'
,p_column_display_sequence=>7
,p_column_heading=>'ID d''espace de travail'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(472531751247148644.4052)
,p_query_column_id=>3
,p_column_alias=>'PAGE_VIEWS'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Nombre total d''\00E9v\00E9nements de page')
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(626566502195636308.4052)
,p_query_column_id=>4
,p_column_alias=>'PAGE_VIEWS_30D'
,p_column_display_sequence=>3
,p_column_heading=>'Vues de page - 30 jours'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(626566142865636304.4052)
,p_query_column_id=>5
,p_column_alias=>'PAGE_VIEWS_90D'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Ev\00E9nements de page (90 jours)')
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(472531917964148646.4052)
,p_query_column_id=>6
,p_column_alias=>'APPLICATIONS'
,p_column_display_sequence=>2
,p_column_heading=>'Applications'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(626566489982636307.4052)
,p_query_column_id=>7
,p_column_alias=>'LAST_ARCHIVED_VIEW'
,p_column_display_sequence=>6
,p_column_heading=>'Vue de dernier archivage'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(626566791364636310.4052)
,p_query_column_id=>8
,p_column_alias=>'VIEWS_30_YN'
,p_column_display_sequence=>8
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(626566887180636311.4052)
,p_query_column_id=>9
,p_column_alias=>'VIEWS_90_YN'
,p_column_display_sequence=>9
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(390433810159898114.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(470837694635277726.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:152:&SESSION.::&DEBUG.:RR,152::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472532298348148649.4052)
,p_name=>'P152_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(472532155894148648.4052)
,p_prompt=>'Rechercher'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_SEARCH'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ROW'
,p_attribute_02=>'FACET'
,p_fc_show_label=>true
,p_fc_show_chart=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626565882430636301.4052)
,p_name=>'P152_PAGE_VIEWS'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(472532155894148648.4052)
,p_prompt=>unistr('Nombre total d''\00E9v\00E9nements de page')
,p_source=>'PAGE_VIEWS'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_RANGE'
,p_lov=>'STATIC2:0 - 9;|10,10 - 99;10|100,100 - 499;100|500,500 - 2k;500|2000,2k - 10k;2000|10000,10k - 100k;10000|100000,100k - 1m;100000|1000000,1m - 10m;1000000|10000000,> 10m;10000000|'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'D'
,p_fc_show_more_count=>12
,p_fc_filter_values=>false
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626565997188636302.4052)
,p_name=>'P152_APPLICATIONS'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(472532155894148648.4052)
,p_prompt=>'Applications'
,p_source=>'APPLICATIONS'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_RANGE'
,p_lov=>'STATIC2:0;|1,1;1|2,2 - 5;2|6,6 - 10;6|11,11 - 20;11|21,21 - 50;21|51,> 50;51|'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'D'
,p_fc_show_more_count=>10
,p_fc_filter_values=>false
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626566259962636305.4052)
,p_name=>'P152_PAGE_VIEWS_90D'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(472532155894148648.4052)
,p_prompt=>unistr('Ev\00E9nements de page - 90 jours')
,p_source=>'PAGE_VIEWS_90D'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_RANGE'
,p_lov=>'STATIC2:0 - 9;|10,10 - 99;10|100,100 - 499;100|500,500 - 2k;500|2000,2k - 10k;2000|10000,10k - 100k;10000|100000,100k - 1m;100000|1000000,1m - 10m;1000000|10000000,> 10m;10000000|'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'D'
,p_fc_show_more_count=>12
,p_fc_filter_values=>false
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626566664921636309.4052)
,p_name=>'P152_PAGE_VIEWS_30D'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(472532155894148648.4052)
,p_prompt=>unistr('Ev\00E9nements de page - 30 jours')
,p_source=>'PAGE_VIEWS_30D'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_RANGE'
,p_lov=>'STATIC2:0 - 9;|10,10 - 99;10|100,100 - 499;100|500,500 - 2k;500|2000,2k - 10k;2000|10000,10k - 100k;10000|100000,100k - 1m;100000|1000000,1m - 10m;1000000|10000000,> 10m;10000000|'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'D'
,p_fc_show_more_count=>12
,p_fc_filter_values=>false
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626567084198636313.4052)
,p_name=>'P152_VIEWS_90_YN'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(472532155894148648.4052)
,p_prompt=>unistr('Ev\00E9nements - 90 derniers jours')
,p_source=>'VIEWS_90_YN'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626567162994636314.4052)
,p_name=>'P152_VIEWS_30_YN'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(472532155894148648.4052)
,p_prompt=>unistr('Ev\00E9nements - 30 derniers jours')
,p_source=>'VIEWS_30_YN'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
end;
/
prompt --application/pages/page_00153
begin
wwv_flow_api.create_page(
 p_id=>153.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('D\00E9tail de l''activit\00E9 dans le temps')
,p_alias=>'ACTIVITY-OVER-TIME-DETAIL'
,p_step_title=>unistr('D\00E9tail de l''activit\00E9 dans le temps')
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(831359903391183020.4052)
,p_plug_name=>unistr('Activit\00E9 dans le temps')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with x',
'as ',
'(',
'    select trunc(sysdate) - rownum log_day, 30 considered_active',
'    from wwv_flow_steps',
'    where rownum <= (365 * 5)',
'    order by 1 desc)',
'select * from ',
'(',
'select x.log_day, ',
'       (select count(distinct workspace_id)   ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_workspaces,',
'       (select sum(page_events)   ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) window_page_events,',
'       (select count(distinct application_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id not between 4000 and 5000 and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_applications,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id not between 4000 and 5000 and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) workspaces_with_active_apps,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id in (4000,4020) and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_appbuilder,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id = 4500 and ',
'              DISTINCT_PAGES > 1 and',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_sqlworkshop,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id in (4020) and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_create_app,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id = 4850 and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_rest,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id = 4300 and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_data_workshop,',
'       (select count(distinct workspace_id) ',
'        from WWV_FLOW_LOG_HISTORY h ',
'        where application_id = 4600 and ',
'              h.log_day >= x.log_day - considered_active and ',
'              h.log_day <= x.log_day) active_team_dev,',
'       x.log_day - considered_active window_start,',
'       x.log_day window_end',
'from x',
') y',
'where active_workspaces > 0',
'order by 1 desc'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>unistr('Activit\00E9 dans le temps')
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(831945954734695416.4052)
,p_max_row_count=>'1000000'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'SHAKEEB'
,p_internal_uid=>831945954734695416
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(831946090471695417.4052)
,p_db_column_name=>'LOG_DAY'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Consigner le jour dans le journal'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(831946146502695418.4052)
,p_db_column_name=>'ACTIVE_WORKSPACES'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Espaces de travail actifs'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(831946239289695419.4052)
,p_db_column_name=>'WINDOW_PAGE_EVENTS'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>unistr('Ev\00E9nements de page')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(831946305425695420.4052)
,p_db_column_name=>'ACTIVE_APPLICATIONS'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Applications actives'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(831946467970695421.4052)
,p_db_column_name=>'WORKSPACES_WITH_ACTIVE_APPS'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Espaces de travail avec applications actives'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(831946575983695422.4052)
,p_db_column_name=>'ACTIVE_APPBUILDER'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'App Builder'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(831946606755695423.4052)
,p_db_column_name=>'ACTIVE_SQLWORKSHOP'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'SQL Workshop'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(831946726803695424.4052)
,p_db_column_name=>'ACTIVE_CREATE_APP'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>unistr('Assistant Cr\00E9er une application')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(831946875472695425.4052)
,p_db_column_name=>'ACTIVE_REST'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'REST Workshop'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(831946949484695426.4052)
,p_db_column_name=>'ACTIVE_DATA_WORKSHOP'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>unistr('Atelier de donn\00E9es')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(831947063923695427.4052)
,p_db_column_name=>'ACTIVE_TEAM_DEV'
,p_display_order=>110
,p_column_identifier=>'K'
,p_column_label=>unistr('D\00E9veloppement d''\00E9quipe')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(831947111922695428.4052)
,p_db_column_name=>'WINDOW_START'
,p_display_order=>120
,p_column_identifier=>'L'
,p_column_label=>unistr('Date de d\00E9but')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(831947203623695429.4052)
,p_db_column_name=>'WINDOW_END'
,p_display_order=>130
,p_column_identifier=>'M'
,p_column_label=>'Date de fin'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
end;
/
prompt --application/pages/page_00155
begin
wwv_flow_api.create_page(
 p_id=>155.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Activit\00E9 de l''application')
,p_alias=>'APPLICATION-ACTIVITY'
,p_step_title=>unistr('Activit\00E9 de l''application')
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1663598275521083786.4052)
,p_plug_name=>unistr('Activit\00E9 de l''application')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select "Page Events" ,',
'       errors,',
'       "App Name",',
'       "App ID",',
'       most_recent_event,',
'       max_daily_active_pages,',
'      (select count(*) from wwv_flow_steps s where s.flow_id = "App ID" and s.security_group_id = x.workspace_id) page_count,',
'       workspace_id,',
'       nvl((select SHORT_NAME from wwv_flow_companies c where c.PROVISIONING_COMPANY_ID = x.workspace_id),t_not_available) workspace_name,',
'       RANK() OVER (ORDER BY "Page Events" desc) app_rank',
'from (',
'select sum(page_events) "Page Events",',
'    sum(ERROR_COUNT) errors,',
'    nvl((select max(name) from wwv_flows where id = application_id),t_not_available) "App Name",',
'    APPLICATION_ID "App ID", ',
'    workspace_id, ',
'    max(log_day) most_recent_event,',
'    t_not_available,',
'    max(DISTINCT_PAGES) max_daily_active_pages',
'from WWV_FLOW_LOG_HISTORY h,',
'     (select wwv_flow_lang.system_message(''NOT AVAILABLE'') t_not_available from dual) sm',
'where log_day > sysdate - (NVL(:P155_SINCE,7)+1)',
'  and application_id not between 4000 and 5000',
'group by application_id, workspace_id, t_not_available',
'order by 1 desc) x',
'',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P155_SINCE'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>unistr('Activit\00E9 dans le temps')
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1664184326864596182.4052)
,p_max_row_count=>'1000000'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'SHAKEEB'
,p_internal_uid=>1664184326864596182
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(825644454061263240.4052)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>20
,p_column_identifier=>'V'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(825643893722263234.4052)
,p_db_column_name=>'App Name'
,p_display_order=>30
,p_column_identifier=>'P'
,p_column_label=>'Nom d''application'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(825643696428263232.4052)
,p_db_column_name=>'Page Events'
,p_display_order=>40
,p_column_identifier=>'N'
,p_column_label=>unistr('Ev\00E9nements de page')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(825643773065263233.4052)
,p_db_column_name=>'ERRORS'
,p_display_order=>50
,p_column_identifier=>'O'
,p_column_label=>'Erreurs'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(825643971058263235.4052)
,p_db_column_name=>'App ID'
,p_display_order=>60
,p_column_identifier=>'Q'
,p_column_label=>'ID d''application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(825644176799263237.4052)
,p_db_column_name=>'MAX_DAILY_ACTIVE_PAGES'
,p_display_order=>80
,p_column_identifier=>'S'
,p_column_label=>'Nombre maximal quotidien de pages actives'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(825644281404263238.4052)
,p_db_column_name=>'PAGE_COUNT'
,p_display_order=>90
,p_column_identifier=>'T'
,p_column_label=>'Nombre de pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(825644312126263239.4052)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>100
,p_column_identifier=>'U'
,p_column_label=>'ID d''espace de travail'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(825644506590263241.4052)
,p_db_column_name=>'APP_RANK'
,p_display_order=>110
,p_column_identifier=>'W'
,p_column_label=>'Rang'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(825644016062263236.4052)
,p_db_column_name=>'MOST_RECENT_EVENT'
,p_display_order=>120
,p_column_identifier=>'R'
,p_column_label=>unistr('Plus r\00E9cent')
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5112343547996051513.4052)
,p_plug_name=>'Button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>1
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(832270736677949662.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(5112343547996051513.4052)
,p_button_name=>'reset_page'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:155:&SESSION.::&DEBUG.:RR,155::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(832271128497949664.4052)
,p_name=>'P155_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(5112343547996051513.4052)
,p_item_default=>'7'
,p_prompt=>'Depuis'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME_ARCHIVE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 30 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 186 t from dual union all',
'select ''9 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 279 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(825644664644263242.4052)
,p_name=>'refresh regions'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P155_SINCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(825644798450263243.4052)
,p_event_id=>wwv_flow_api.id(825644664644263242.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1663598275521083786.4052)
);
end;
/
prompt --application/pages/page_00156
begin
wwv_flow_api.create_page(
 p_id=>156.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('D\00E9tail des activit\00E9s de d\00E9veloppeur')
,p_alias=>'DEVELOPER-ACTIVITY-DETAIL'
,p_step_title=>unistr('D\00E9tail des activit\00E9s de d\00E9veloppeur')
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2496103078767098096.4052)
,p_plug_name=>unistr('Activit\00E9 de d\00E9veloppeur')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select "Page Events" ,',
'       app_builder_events,',
'       create_app_events,',
'       sql_workshop_events,',
'       team_development_events,',
'       workspace_admin_events,',
'       most_recent_event,',
'       rest_workshop_events,',
'       login_page_events,',
'       scheme_login_events,',
'       productivity_apps_events,',
'       data_workshop_events,',
'       app_migration_events,',
'       new_service_events,',
'       websheet_events,',
'       workspace_id,',
'       (select SHORT_NAME from wwv_flow_companies c where c.PROVISIONING_COMPANY_ID = x.workspace_id) workspace_name,',
'        RANK() OVER (ORDER BY "Page Events" desc) ws_rank',
'from (',
'select sum(page_events) "Page Events",',
'    sum(decode(application_id,4000,page_events,0)) app_builder_events,',
'    sum(decode(application_id,4020,page_events,0)) create_app_events,',
'    sum(decode(application_id,4500,page_events,0)) sql_workshop_events,',
'    sum(decode(application_id,4600,page_events,0)) team_development_events,',
'    sum(decode(application_id,4350,page_events,0)) workspace_admin_events,',
'    sum(decode(application_id,4850,page_events,0)) rest_workshop_events,',
'    sum(decode(application_id,4550,page_events,0)) login_page_events,',
'    sum(decode(application_id,4155,page_events,0)) scheme_login_events,',
'    sum(decode(application_id,4750,page_events,0)) productivity_apps_events,',
'    sum(decode(application_id,4300,page_events,0)) data_workshop_events,',
'    sum(decode(application_id,4400,page_events,0)) app_migration_events,',
'    sum(decode(application_id,4700,page_events,0)) new_service_events,',
'    sum(decode(application_id,4900,page_events,0)) websheet_events,',
'    workspace_id, max(log_day) most_recent_event',
'from WWV_FLOW_LOG_HISTORY ',
'where log_day > sysdate - (NVL(:P156_SINCE,7)+1)',
'  and application_id  between 4000 and 5000',
'group by workspace_id',
') x',
'',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P156_SINCE'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>unistr('Activit\00E9 dans le temps')
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(2496689130110610492.4052)
,p_max_row_count=>'1000000'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'SHAKEEB'
,p_internal_uid=>2496689130110610492
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(832510007230014316.4052)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>20
,p_column_identifier=>'V'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(832506597343014313.4052)
,p_db_column_name=>'Page Events'
,p_display_order=>40
,p_column_identifier=>'N'
,p_column_label=>unistr('Ev\00E9nements de page')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(832509614387014315.4052)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>100
,p_column_identifier=>'U'
,p_column_label=>'ID d''espace de travail'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(832508419778014314.4052)
,p_db_column_name=>'MOST_RECENT_EVENT'
,p_display_order=>120
,p_column_identifier=>'R'
,p_column_label=>unistr('Plus r\00E9cent')
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(825644830421263244.4052)
,p_db_column_name=>'APP_BUILDER_EVENTS'
,p_display_order=>130
,p_column_identifier=>'X'
,p_column_label=>'App Builder'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(825644970303263245.4052)
,p_db_column_name=>'CREATE_APP_EVENTS'
,p_display_order=>140
,p_column_identifier=>'Y'
,p_column_label=>unistr('Cr\00E9er une application')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(825645069798263246.4052)
,p_db_column_name=>'SQL_WORKSHOP_EVENTS'
,p_display_order=>150
,p_column_identifier=>'Z'
,p_column_label=>'SQL Workshop'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(825645142547263247.4052)
,p_db_column_name=>'TEAM_DEVELOPMENT_EVENTS'
,p_display_order=>160
,p_column_identifier=>'AA'
,p_column_label=>unistr('D\00E9veloppement d''\00E9quipe')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(825645229683263248.4052)
,p_db_column_name=>'WORKSPACE_ADMIN_EVENTS'
,p_display_order=>170
,p_column_identifier=>'AB'
,p_column_label=>'Administration d''espace de travail'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(825645307459263249.4052)
,p_db_column_name=>'REST_WORKSHOP_EVENTS'
,p_display_order=>180
,p_column_identifier=>'AC'
,p_column_label=>'REST Workshop'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(825645441008263250.4052)
,p_db_column_name=>'LOGIN_PAGE_EVENTS'
,p_display_order=>190
,p_column_identifier=>'AD'
,p_column_label=>'Page de connexion'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(832512186655014901.4052)
,p_db_column_name=>'SCHEME_LOGIN_EVENTS'
,p_display_order=>200
,p_column_identifier=>'AE'
,p_column_label=>unistr('Connexion de mod\00E8le')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(832512228167014902.4052)
,p_db_column_name=>'PRODUCTIVITY_APPS_EVENTS'
,p_display_order=>210
,p_column_identifier=>'AF'
,p_column_label=>unistr('Applications de productivit\00E9')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(832512364258014903.4052)
,p_db_column_name=>'DATA_WORKSHOP_EVENTS'
,p_display_order=>220
,p_column_identifier=>'AG'
,p_column_label=>unistr('Atelier de donn\00E9es')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(832512407516014904.4052)
,p_db_column_name=>'APP_MIGRATION_EVENTS'
,p_display_order=>230
,p_column_identifier=>'AH'
,p_column_label=>'Migration d''applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(832512531962014905.4052)
,p_db_column_name=>'NEW_SERVICE_EVENTS'
,p_display_order=>240
,p_column_identifier=>'AI'
,p_column_label=>'Nouveau service'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(832512661543014906.4052)
,p_db_column_name=>'WEBSHEET_EVENTS'
,p_display_order=>250
,p_column_identifier=>'AJ'
,p_column_label=>'Feuille Web'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_security_scheme=>wwv_flow_api.id(610289739776900562)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(832512778150014907.4052)
,p_db_column_name=>'WS_RANK'
,p_display_order=>260
,p_column_identifier=>'AK'
,p_column_label=>'Rang'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5944848351242065823.4052)
,p_plug_name=>'Button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>1
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(832505402655014311.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(5944848351242065823.4052)
,p_button_name=>'reset_page'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:156:&SESSION.::&DEBUG.:RR,156::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(832505807624014311.4052)
,p_name=>'P156_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(5944848351242065823.4052)
,p_item_default=>'7'
,p_prompt=>'Depuis'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME_ARCHIVE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 30 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 186 t from dual union all',
'select ''9 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 279 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(832511281525014317.4052)
,p_name=>'refresh regions'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P156_SINCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(832511754901014318.4052)
,p_event_id=>wwv_flow_api.id(832511281525014317.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2496103078767098096.4052)
);
end;
/
prompt --application/pages/page_00157
begin
wwv_flow_api.create_page(
 p_id=>157.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Activit\00E9 de l''application d''ex\00E9cution')
,p_alias=>'RUNTIME-APPLICATION-ACTIVITY'
,p_step_title=>unistr('Activit\00E9 de l''application d''ex\00E9cution')
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3329112700151283490.4052)
,p_plug_name=>unistr('Activit\00E9 de l''application d''ex\00E9cution')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select "Page Events" ,',
'       errors,',
'       workspace_id,',
'       (select SHORT_NAME from wwv_flow_companies c where c.PROVISIONING_COMPANY_ID = x.workspace_id) workspace_name,',
'       active_applications,',
'       (select count(*) from wwv_flows f where f.security_group_id = x.workspace_id) applications,',
'       RANK() OVER (ORDER BY "Page Events" desc) ws_rank',
'from (',
'select sum(page_events) "Page Events",',
'    sum(ERROR_COUNT) errors,',
'    max(DISTINCT_PAGES) active_pages,',
'    workspace_id, ',
'    max(log_day) most_recent_event,',
'    count(distinct APPLICATION_ID) active_applications',
'from WWV_FLOW_LOG_HISTORY ',
'where log_day > sysdate - (NVL(:P157_SINCE,7)+1)',
'  and application_id NOT between 4000 and 5000',
'group by workspace_id',
') x',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P157_SINCE'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>unistr('Activit\00E9 dans le temps')
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(3329698751494795886.4052)
,p_max_row_count=>'1000000'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'SHAKEEB'
,p_internal_uid=>3329698751494795886
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(833015386511185403.4052)
,p_db_column_name=>'WORKSPACE_NAME'
,p_display_order=>20
,p_column_identifier=>'V'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(833014104522185402.4052)
,p_db_column_name=>'Page Events'
,p_display_order=>40
,p_column_identifier=>'N'
,p_column_label=>unistr('Ev\00E9nements de page')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(833014952781185403.4052)
,p_db_column_name=>'WORKSPACE_ID'
,p_display_order=>100
,p_column_identifier=>'U'
,p_column_label=>'ID d''espace de travail'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(833018152225185405.4052)
,p_db_column_name=>'WS_RANK'
,p_display_order=>260
,p_column_identifier=>'AK'
,p_column_label=>'Rang'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(832512879303014908.4052)
,p_db_column_name=>'ERRORS'
,p_display_order=>270
,p_column_identifier=>'AL'
,p_column_label=>'Erreurs'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(832512924066014909.4052)
,p_db_column_name=>'ACTIVE_APPLICATIONS'
,p_display_order=>280
,p_column_identifier=>'AM'
,p_column_label=>'Applications actives'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(832513065669014910.4052)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>290
,p_column_identifier=>'AN'
,p_column_label=>'Applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6777857972626251217.4052)
,p_plug_name=>'Button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>1
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(833010248746185395.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(6777857972626251217.4052)
,p_button_name=>'reset_page'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:157:&SESSION.::&DEBUG.:RR,157::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(833010639330185397.4052)
,p_name=>'P157_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(6777857972626251217.4052)
,p_item_default=>'7'
,p_prompt=>'Depuis'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT_TIME_ARCHIVE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''1 ''||wwv_flow_lang.system_message(initcap(''DAY'')) d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 2 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''WEEK'')) d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''WEEKS'')) d, 14 t  from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(initcap(''DAYS'')) d, 30 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''MONTH'')) d, 31 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 62 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 93 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 186 t from dual union all',
'select ''9 ''||wwv_flow_lang.system_message(initcap(''MONTHS'')) d, 279 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(initcap(''YEAR'')) d, 365 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 730 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1095 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1460 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 1825 t from dual union all',
'select ''10 ''||wwv_flow_lang.system_message(initcap(''YEARS'')) d, 3650 t from dual ',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(833018956496185407.4052)
,p_name=>'refresh regions'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P157_SINCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(833019424037185407.4052)
,p_event_id=>wwv_flow_api.id(833018956496185407.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3329112700151283490.4052)
);
end;
/
prompt --application/pages/page_00158
begin
wwv_flow_api.create_page(
 p_id=>158.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Mises \00E0 jour disponibles (ADB)')
,p_alias=>'DEFER-UPGRADE'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Mises \00E0 jour disponibles')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931176884177111905)
,p_inline_css=>'.a-Wizard-regionBody { padding: 12px 12px 0 12px }'
,p_step_template=>wwv_flow_api.id(721098050798687927.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>-wwv_flow_api.id(3913175260740993520.4052)
,p_dialog_height=>'280'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1977121301299032781.4052)
,p_plug_name=>'Defer Upgrade'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_defer_days constant number := to_number(:P158_DEFER_DAYS);',
'begin',
'    sys.htp.p(''<p>'' ||',
'              wwv_flow_lang.system_message(''F4050_P158_INTRO_TEXT'', ''&PRODUCT_NAME.'', c_defer_days) ||',
'             ''</p>'');',
'    if wwv_flow_cloud_db_services.get_upgrade_status().state = ''SCHEDULED'' then',
'        sys.htp.p(''<p>'' ||',
'                  wwv_flow_lang.system_message(',
'                      ''F4050_P158_UPGRADE_NOW'',',
'                      to_char(wwv_flow_cloud_db_services.get_upgrade_status().upgrade_date,',
'                              ''fmMonth DD, YYYY'')) ||',
'                  ''</p>'');',
'    end if;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'foo'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1977121358179032782.4052)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(663451924482166110.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1977121358179032782.4052)
,p_button_name=>'UPGRADE_NOW'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('Mettre \00E0 niveau maintenant')
,p_button_position=>'CREATE'
,p_button_condition=>'wwv_flow_cloud_db_services.get_upgrade_status().state = ''SCHEDULED'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(833874292607465348.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1977121358179032782.4052)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(833874659436465350.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1977121358179032782.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(735033421901168729.4052)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(1977121358179032782.4052)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Aide'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:apex.navigation.openInNewWindow(''https://www.oracle.com/pls/topic/lookup?ctx=en/cloud/paas/autonomous-database&id=ADBSA-GUID-AA58811B-3C26-4BFB-A794-872531A590EC'');'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(663451758078166108.4052)
,p_branch_name=>'refresh page 3'
,p_branch_action=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(222858335888540011.4052)
,p_name=>'P158_DEFER_DAYS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1977121301299032781.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(833873008562465345.4052)
,p_name=>'P158_UPGRADE_DEFERRED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1977121301299032781.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Diff\00E9rer la mise \00E0 niveau')
,p_source=>'nvl( wwv_flow_platform.get_preference( ''UPGRADE_DEFERRED'' ), ''N'' )'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>En d\00E9finissant Diff\00E9rer la mise \00E0 niveau sur <strong>Non</strong>, la prochaine mise \00E0 niveau de &PRODUCT_NAME. sera imm\00E9diatement appliqu\00E9e \00E0 l''instance, si elle est disponible.</p>'),
'',
unistr('<p>Si vous d\00E9finissez Diff\00E9rer la mise \00E0 niveau sur <strong>Oui</strong>, la prochaine mise \00E0 niveau de &PRODUCT_NAME. sera diff\00E9r\00E9e de &P158_DEFER_DAYS. jours au maximum. Pendant cette p\00E9riode, vous pouvez lancer imm\00E9diatement la mise \00E0 niveau en cl')
||unistr('iquant sur Mettre \00E0 niveau maintenant.</p>'),
'',
unistr('<p>La modification de la valeur de Diff\00E9rer la mise \00E0 niveau n''aura aucune incidence sur la version de &PRODUCT_NAME. qui est d\00E9j\00E0 disponible pour votre instance.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(222858456450540012.4052)
,p_computation_sequence=>10
,p_computation_item=>'P158_DEFER_DAYS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'nvl(wwv_flow_platform.get_preference(''UPGRADE_DEFER_DAYS''),30)'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(833875845667465352.4052)
,p_name=>'Cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(833874659436465350.4052)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(833876370380465352.4052)
,p_event_id=>wwv_flow_api.id(833875845667465352.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(833875019791465351.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set UPGRADE_DEFERRED'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_platform.set_preference( p_preference_name  => ''UPGRADE_DEFERRED'',',
'                                  p_preference_value => :P158_UPGRADE_DEFERRED );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(833874292607465348.4052)
,p_process_success_message=>unistr('Pr\00E9f\00E9rence &PRODUCT_NAME. upgrade mise \00E0 jour.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(663452058759166111.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Upgrade Now'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_sql varchar2(255);',
'begin',
'    if wwv_flow_cloud_db_services.get_upgrade_status().state = ''SCHEDULED'' then',
'        l_sql := '' begin sys.wwv_util_''||wwv_flow.g_flow_schema_owner||''.adb_upgrade_now; end;'';',
'        execute immediate l_sql;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(663451924482166110.4052)
);
end;
/
prompt --application/pages/page_00161
begin
wwv_flow_api.create_page(
 p_id=>161.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Journal de synchronisation REST'
,p_alias=>'REST-SYNCHRONIZATION-LOG'
,p_step_title=>'Journal de synchronisation REST'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216784309333645873)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*.break-url {',
'    word-break: break-all;',
'}*/'))
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_logs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(671821573063112246.4052)
,p_plug_name=>'Journal de synchronisation'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Le journal de synchronisation REST contient des informations d\00E9taill\00E9es sur les synchronisations REST ex\00E9cut\00E9es par l''instance &PRODUCT_NAME. : ID d''application, nom de la source de donn\00E9es REST, lignes trait\00E9es, demandes HTTP envoy\00E9es et horodatages')
||unistr(' de d\00E9but et de fin.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(671821984450112249.4052)
,p_plug_name=>'Journal de synchronisation'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>15
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(813763380651628325.4052)
,p_plug_name=>'Journal de synchronisation REST'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select m.flow_id,',
'       m.name,',
'       l.web_src_sync_static_id,',
'       wwv_flow_lang.system_message( ''APEX.WEBSRC.SYNC.STATUS_'' || l.status ) as status,',
'       l.start_timestamp,',
'       extract( SECOND from l.end_timestamp - l.start_timestamp ) +',
'       extract( MINUTE from l.end_timestamp - l.start_timestamp ) * 60 +',
'       extract( HOUR   from l.end_timestamp - l.start_timestamp ) * 3600 as seconds_elapsed,',
'       l.processed_row_count,',
'       ( select count(*) from wwv_flow_webservice_log wl where wl.web_src_sync_id = l.synchronization_id ) as http_requests,',
'       ( select sum(resp_content_length)  from wwv_flow_webservice_log wl where wl.web_src_sync_id = l.synchronization_id ) as bytes,',
'       l.sync_to_table_owner,',
'       l.sync_to_table_name,',
'       c.short_name',
'from  wwv_flow_websource_sync_log l, wwv_flow_web_src_modules m, wwv_flow_companies c',
'where c.provisioning_company_id = l.security_group_id',
'  and l.web_src_module_id    = m.id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'%null%'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(813763490773628325.4052)
,p_name=>'Mail Log'
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>813763490773628325
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1366953305648938.4052)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>80
,p_column_identifier=>'U'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5904329369682543.4052)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>90
,p_column_identifier=>'AA'
,p_column_label=>'ID d''application'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5904421254682544.4052)
,p_db_column_name=>'NAME'
,p_display_order=>100
,p_column_identifier=>'AB'
,p_column_label=>'Nom de source REST'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5904515056682545.4052)
,p_db_column_name=>'WEB_SRC_SYNC_STATIC_ID'
,p_display_order=>110
,p_column_identifier=>'AC'
,p_column_label=>'Etape de synchronisation'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5904661125682546.4052)
,p_db_column_name=>'STATUS'
,p_display_order=>120
,p_column_identifier=>'AD'
,p_column_label=>'Statut'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5904759209682547.4052)
,p_db_column_name=>'START_TIMESTAMP'
,p_display_order=>130
,p_column_identifier=>'AE'
,p_column_label=>unistr('D\00E9marr\00E9 ')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'CENTER'
,p_format_mask=>'YYYY/MM/DD HH24:MI:SS TZR'
,p_tz_dependent=>'Y'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5904922739682549.4052)
,p_db_column_name=>'PROCESSED_ROW_COUNT'
,p_display_order=>150
,p_column_identifier=>'AG'
,p_column_label=>unistr('Lignes trait\00E9es')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5905085620682550.4052)
,p_db_column_name=>'SYNC_TO_TABLE_OWNER'
,p_display_order=>160
,p_column_identifier=>'AH'
,p_column_label=>unistr('Propri\00E9taire de table')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1371184912674201.4052)
,p_db_column_name=>'SYNC_TO_TABLE_NAME'
,p_display_order=>170
,p_column_identifier=>'AI'
,p_column_label=>'Nom de table'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1371263048674202.4052)
,p_db_column_name=>'HTTP_REQUESTS'
,p_display_order=>180
,p_column_identifier=>'AJ'
,p_column_label=>'Demandes HTTP'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1371383782674203.4052)
,p_db_column_name=>'BYTES'
,p_display_order=>190
,p_column_identifier=>'AK'
,p_column_label=>'Octets'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1371453152674204.4052)
,p_db_column_name=>'SECONDS_ELAPSED'
,p_display_order=>200
,p_column_identifier=>'AL'
,p_column_label=>unistr('Secondes \00E9coul\00E9es')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999990D0'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1364690535648928.4052)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(671821984450112249.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:161:&SESSION.::&DEBUG.:RIR,121::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1365077527648929.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(671821984450112249.4052)
,p_button_name=>'TRUNCATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Vider'
,p_button_position=>'CREATE'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1370600991648952.4052)
,p_branch_action=>'f?p=&FLOW_ID.:161:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1369755842648950.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Truncate log'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_websource_sync_log;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors du vidage du journal des courriels.'
,p_process_when_button_id=>wwv_flow_api.id(1365077527648929.4052)
,p_process_success_message=>unistr('Journal de synchronisation REST vid\00E9 avec succ\00E8s.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1370173185648951.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_api.id(1364690535648928.4052)
);
end;
/
prompt --application/pages/page_00162
begin
wwv_flow_api.create_page(
 p_id=>162.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('G\00E9rer le journal de synchronisation REST')
,p_alias=>'MANAGE-REST-SYNC-LOG'
,p_step_title=>unistr('G\00E9rer le journal de synchronisation REST')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216783731365642767)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>'AEADM/adm_logs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(687175365399927299.4052)
,p_plug_name=>unistr('Supprimer des entr\00E9es du journal de synchronisation REST')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   c_dev pls_integer := 0;',
'',
'begin',
'   select count(*) into c_dev from wwv_flow_websource_sync_log;',
'   sys.htp.p(''<p>''||wwv_flow_lang.system_message(''4050_162_WEB_SOURCE_SYNC_LOG'')||'': '');',
'   sys.htp.p(to_char(c_dev,''999,999,999,990'')||''</p>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1703199076929547133.4052)
,p_plug_name=>'Boutons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1704670310125322822.4052)
,p_plug_name=>'Journal de synchronisation REST'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829706609080810173.4052)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Cette instance &PRODUCT_NAME. peut \00EAtre configur\00E9e en vue de journaliser des synchronisations REST.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1411162732951093.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1703199076929547133.4052)
,p_button_name=>'DELETE_ENTRIES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Supprimer des entr\00E9es')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1411581743951094.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1703199076929547133.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1412751734951112.4052)
,p_branch_name=>'Go To Page 162'
,p_branch_action=>'162'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(1411162732951093.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1410051469951086.4052)
,p_name=>'P162_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(687175365399927299.4052)
,p_prompt=>unistr('Supprimer les entr\00E9es datant du nombre de jours suivant ou plus :')
,p_source=>'31'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIME_INTERVALS'
,p_lov=>'.'||wwv_flow_api.id(87720511660244788.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Purgez les entr\00E9es d\00E9passant ce nombre de jours.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1412265643951111.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete rows'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_websource_sync_log1$',
'where start_timestamp < (localtimestamp - numtodsinterval(nvl(:p162_time,31), ''DAY''));',
'delete from wwv_flow_websource_sync_log2$',
'where start_timestamp < (localtimestamp - numtodsinterval(nvl(:p162_time,31), ''DAY''));'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Erreur lors de la purge du journal des activit\00E9s de service Web.')
,p_process_when_button_id=>wwv_flow_api.id(1411162732951093.4052)
,p_process_success_message=>unistr('Journal des activit\00E9s de service Web purg\00E9.')
);
end;
/
prompt --application/pages/page_00163
begin
wwv_flow_api.create_page(
 p_id=>163.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Importer un espace de travail'
,p_step_title=>'Importer un espace de travail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_wrkspc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44752928830688498.4052)
,p_plug_name=>'Wizard buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44755004167775947.4052)
,p_plug_name=>unistr('T\00E2ches')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(202654431224384775.4052)
,p_plug_display_sequence=>50
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(79863815294295743.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(27525012681104508.4052)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44756515866873949.4052)
,p_plug_name=>'Invalid export file'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>10
,p_plug_source=>unistr('<p>Le fichier d''export a \00E9t\00E9 import\00E9 dans le r\00E9f\00E9rentiel, mais ce n''est pas un export d''espace de travail valide.</p>')
,p_translate_title=>'N'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.is_company_export(:P163_FILE_ID) = false'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44757316437940400.4052)
,p_plug_name=>'Wizard progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(44758222502979988.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(165852216817050925.4052)
,p_plug_name=>unistr('Fichier import\00E9')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>30
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.is_company_export(:P163_FILE_ID) = true'
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Le fichier d''export a \00E9t\00E9 import\00E9.</p>'),
'<p>Pour installer cet espace de travail maintenant, cliquez sur <strong>Installer</strong>.</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752113024376695873.4052)
,p_plug_name=>'Importer un espace de travail'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(79848401947178315.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44752928830688498.4052)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(53559826117651901.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44752928830688498.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:173:&SESSION.::&DEBUG.:::'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(53562040315656070.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44752928830688498.4052)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Installer'
,p_button_position=>'NEXT'
,p_button_condition=>'wwv_flow_imp_parser.is_company_export(:P163_FILE_ID)'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(53787635215429074.4052)
,p_branch_action=>'f?p=&FLOW_ID.:277:&SESSION.::&DEBUG.:277,165:P277_FILE_ID:&P163_FILE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(53562040315656070.4052)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53575939070740849.4052)
,p_name=>'P163_FILE_ID'
,p_item_sequence=>10
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_prompt=>'File Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(93372831129235626.4052)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(53792036385438823.4052)
,p_validation_name=>'only internal can import company'
,p_validation_sequence=>10
,p_validation=>':flow_security_group_id = 10'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Seul un espace de travail interne peut installer des informations d''espace de travail.'
,p_validation_condition=>'P460_FILE_TYPE'
,p_validation_condition2=>'COMPANY_EXPORT'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(53562040315656070.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00165
begin
wwv_flow_api.create_page(
 p_id=>165.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Installer un espace de travail'
,p_step_title=>'Installer un espace de travail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_wrkspc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44774026779615134.4052)
,p_plug_name=>'Wizard progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(44806708563745373.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44774229895616022.4052)
,p_plug_name=>'Wizard buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47834934594717909.4052)
,p_plug_name=>'Installer un espace de travail'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>20
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47835339096719184.4052)
,p_plug_name=>'Install Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('L''espace de travail sera cr\00E9\00E9 s''il n''existe pas et tous les utilisateurs seront import\00E9s.  ')
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752113142732695873.4052)
,p_plug_name=>'Installer un espace de travail'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47838938188728411.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44774229895616022.4052)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:278:&SESSION.::&DEBUG.:::'
,p_button_condition=>'P165_WS_EXISTS'
,p_button_condition2=>'N'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47836225721724856.4052)
,p_button_sequence=>15
,p_button_plug_id=>wwv_flow_api.id(44774229895616022.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:173:&SESSION.::&DEBUG.:::'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47840213385730684.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44774229895616022.4052)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Installer un espace de travail'
,p_button_position=>'CREATE'
,p_button_condition=>'P165_WS_EXISTS'
,p_button_condition2=>'N'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(47840534124730685.4052)
,p_branch_action=>'f?p=&FLOW_ID.:173:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(47840213385730684.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(45255124812664433.4052)
,p_name=>'P165_WS_EXISTS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(47834934594717909.4052)
,p_item_default=>'N'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47842236587737441.4052)
,p_name=>'P165_LOGGED_IN_COMPANY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(47834934594717909.4052)
,p_item_default=>'&COMPANY.'
,p_prompt=>unistr('Connect\00E9 en tant que :')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Vous \00EAtes connect\00E9 \00E0 cet espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47844625075752996.4052)
,p_name=>'P165_IMP_COMPANY_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(47834934594717909.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'ID d''espace de travail du fichier d''installation :'
,p_source=>'P277_IMP_COMPANY_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Ceci est l''ID d''espace de travail provenant du fichier d''export d''espace de travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48276826242931230.4052)
,p_name=>'P165_IMP_COMPANY'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(47834934594717909.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nom d''espace de travail du fichier d''installation :'
,p_source=>'wwv_flow_imp_parser.get_workspace_name(p_file_id => :P277_FILE_ID)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Ceci est le nom d''espace de travail provenant du fichier d''export d''espace de travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48413732634219929.4052)
,p_name=>'P165_COMPANY_EXISTS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(47834934594717909.4052)
,p_prompt=>'L''espace de travail existe :'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Indique si un espace de travail portant le m\00EAme nom que celui provenant du fichier d''export d''espace de travail existe actuellement.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48414716835224801.4052)
,p_name=>'P165_COMPANY_ACTION'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(47834934594717909.4052)
,p_prompt=>'Demande :'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Indique si l''espace de travail sera ou non install\00E9.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48421828918275617.4052)
,p_name=>'P165_IMP_COMPANY_SCHEMA'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(47834934594717909.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Sch\00E9ma d''espace de travail du fichier d''installation :')
,p_source=>'wwv_flow_imp_parser.get_schema_provisioned (p_file_id => :P277_FILE_ID)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifie le fichier contenant le script d''installation de l''espace de travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(189039725972495323.4052)
,p_name=>'P165_PRIMARY_SCHEMA'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(47834934594717909.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Sch\00E9ma principal :')
,p_source=>'P277_SCHEMA'
,p_source_type=>'ITEM'
,p_source_post_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_provisioning.validate_schema_name(p_schema => :P277_SCHEMA,',
'  p_workspace_name => wwv_flow_security.find_company_name(:P277_IMP_COMPANY_ID))'))
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Ce sch\00E9ma sera le sch\00E9ma principal de l''espace de travail install\00E9. Il sera cr\00E9\00E9 si sa cr\00E9ation a \00E9t\00E9 demand\00E9e. On l''appelle parfois premier sch\00E9ma provisionn\00E9 de l''espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(53852128186644629.4052)
,p_validation_name=>'only internal can import company'
,p_validation_sequence=>10
,p_validation=>':flow_security_group_id = 10'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Seul un espace de travail interne peut installer des informations d''espace de travail.'
,p_when_button_pressed=>wwv_flow_api.id(47840213385730684.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(48219913570295031.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create company schema'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_p varchar2(256) := v(''P277_SCHEMA_PASSWORD'');',
'begin',
'  wwv_flow.update_cache_with_write(''P277_SCHEMA_PASSWORD'',null);',
'  wwv_flow_provision.provision_company(',
'      p_company         => :P277_SCHEMA,',
'      p_password        => l_p,',
'      p_quota           => :P277_QUOTA );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Erreur lors de la cr\00E9ation du sch\00E9ma d''espace de travail.')
,p_process_when_button_id=>wwv_flow_api.id(47840213385730684.4052)
,p_process_when=>':P277_EXISTING = ''0'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('Sch\00E9ma d''espace de travail cr\00E9\00E9.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(47863923943046073.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'import company'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_imp_parser.parse (',
'     p_file_id         => :P277_FILE_ID,',
'     p_parse_as_schema => wwv_flow.g_flow_schema_owner',
'     );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors de l''installation de l''espace de travail.'
,p_process_when_button_id=>wwv_flow_api.id(47840213385730684.4052)
,p_process_success_message=>unistr('Espace de travail install\00E9.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(48233814197465485.4052)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update provisioned schemas'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_found boolean := false;',
'    l_first_schema wwv_flow_companies.first_schema_provisioned%type := upper(:P277_SCHEMA);',
'begin',
'    if wwv_flow_provisioning.site_admin_is_restricted and ',
'      wwv_flow_provisioning.restricted_schema(p_schema => l_first_schema,',
'          p_workspace_name => wwv_flow_security.find_company_name(:P277_IMP_COMPANY_ID)) then',
'      l_first_schema := ''INVALID'';',
'    end if;',
'    update wwv_flow_companies',
'      set FIRST_SCHEMA_PROVISIONED = l_first_schema',
'      where PROVISIONING_COMPANY_ID = :P277_IMP_COMPANY_ID;',
'    for c1 in ',
'      (select schema from wwv_flow_company_schemas where security_group_id = :P277_IMP_COMPANY_ID ',
'       and schema = upper(:P277_SCHEMA)) loop',
'       l_found := true;',
'    end loop;',
'    if not l_found then',
'      insert into wwv_flow_company_schemas (security_group_id,schema)  ',
'        values(:P277_IMP_COMPANY_ID,:P277_SCHEMA);',
'    end if;',
'    if wwv_flow_provisioning.site_admin_is_restricted then',
'        for c1 in ',
'          (select id from wwv_flow_company_schemas ',
'              where security_group_id = :P277_IMP_COMPANY_ID and',
'              wwv_flow_provisioning.restricted_schema_i(schema,',
'                wwv_flow_security.find_company_name(:P277_IMP_COMPANY_ID)) = 1) loop',
'           delete wwv_flow_company_schemas where id = c1.id;           ',
'        end loop;',
'    end if;    ',
'    for c1 in ',
'      (select id from wwv_flow_company_schemas ',
'          where security_group_id = :P277_IMP_COMPANY_ID and',
'          not exists (select 1 from sys.dba_users where username = schema)) loop',
'       delete wwv_flow_company_schemas where id = c1.id;           ',
'    end loop;        ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Erreur lors de la d\00E9finition de sch\00E9mas provisionn\00E9s.')
,p_process_when_button_id=>wwv_flow_api.id(47840213385730684.4052)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(359772209428648663.4052)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'P277_SCHEMA_PASSWORD'
,p_process_when_button_id=>wwv_flow_api.id(47840213385730684.4052)
);
end;
/
prompt --application/pages/page_00173
begin
wwv_flow_api.create_page(
 p_id=>173.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Fichiers d''export d''espace de travail import\00E9')
,p_step_title=>unistr('Fichiers d''export d''espace de travail import\00E9')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'function p173_Delete(){',
'if (apex.jQuery("input:checked").length == 0) {',
'  apex.submit(''Delete'');',
'} else {',
'  apex.confirm(htmldb_delete_message,''Delete'');',
'}',
'}'))
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_wrkspc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32855528723661056.4052)
,p_plug_name=>'reset'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P277_SCHEMA_PASSWORD := null;',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(49518022356125296.4052)
,p_plug_name=>'topbar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>5
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(78240022072921217.4052)
,p_name=>unistr('Fichiers d''export d''espace de travail import\00E9')
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
' q varchar2(32767) := null;',
' l_workspace_export varchar2(400);',
' l_install         varchar2(200);',
'',
'begin',
'',
'select wwv_flow_lang.system_message(''F4050.WORKSPACE_EXPORT'')',
'  into l_workspace_export',
'  from dual;',
'',
'select wwv_flow_lang.system_message(''F4050.INSTALL'')',
'  into l_install',
'  from dual;',
'',
'  l_workspace_export := replace(l_workspace_export,chr(39),chr(39)||chr(39));',
'',
'  q:=''select '';  ',
'  q:=q||''''''<INPUT TYPE="checkbox" NAME="f01" VALUE="''''||id||''''">'''' cb, '';',
'  q:=q||''title, '';',
'  q:=q||''mime_type, '';',
'  q:=q||''doc_size, '';',
'  q:=q||''created_by, '';',
'  q:=q||''created_on co, '';',
'  q:=q||''decode(file_type,''''COMPANY_EXPORT'''',''''''||l_workspace_export||'''''') filetype, '';',
'  q:=q||''id, '';',
'  q:=q||''htf.anchor(''''f?p=&FLOW_ID.:277:&SESSION.:::277,165:P277_FILE_ID:''''||',
'    id,''''''||l_install||'''''') action, '';',
'  q:=q||''created_on + delete_after_days to_be_deleted '';',
'  q:=q||''from WWV_FLOW_FILE_OBJECTS$, (select wwv_flow_platform.get_preference(''''DELETE_UPLOADED_FILES_AFTER_DAYS'''') delete_after_days from dual) x  '';',
'  q:=q||''where /*security_group_id = :flow_security_group_id and*/  '';',
'  q:=q||''   deleted_as_of = to_date(''''01.01.0001'''',''''MM.DD.YYYY'''') and '';',
'  q:=q||''  file_type = ''''COMPANY_EXPORT'''''';',
'  return q;',
'end;'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(833359513519625692.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>unistr('Aucun export n''a \00E9t\00E9 trouv\00E9.')
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'arrow_down_gray_light.gif'
,p_query_asc_image_attr=>' width="13" height="12" '
,p_query_desc_image=>'arrow_up_gray_light.gif'
,p_query_desc_image_attr=>' width="13" height="12" '
,p_plug_query_strip_html=>'Y'
,p_comment=>'generated 31-JUL-2001 13:40:41'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48739309529422421.4052)
,p_query_column_id=>1
,p_column_alias=>'CB'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48739518518422421.4052)
,p_query_column_id=>2
,p_column_alias=>'TITLE'
,p_column_display_sequence=>2
,p_column_heading=>'Titre d''export'
,p_column_link=>'p?n=#ID#'
,p_column_linktext=>'#TITLE#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48739636254422421.4052)
,p_query_column_id=>3
,p_column_alias=>'MIME_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'MIME Type'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48739736741422421.4052)
,p_query_column_id=>4
,p_column_alias=>'DOC_SIZE'
,p_column_display_sequence=>4
,p_column_heading=>'Taille'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48739836227422422.4052)
,p_query_column_id=>5
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Cr\00E9ation par')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48739914100422422.4052)
,p_query_column_id=>6
,p_column_alias=>'CO'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Cr\00E9\00E9')
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_column_css_style=>'white-space: nowrap;'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79831208892981636.4052)
,p_query_column_id=>7
,p_column_alias=>'FILETYPE'
,p_column_display_sequence=>9
,p_column_heading=>'Type de fichier'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48740121990422422.4052)
,p_query_column_id=>8
,p_column_alias=>'ID'
,p_column_display_sequence=>7
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(53489613183364312.4052)
,p_query_column_id=>9
,p_column_alias=>'ACTION'
,p_column_display_sequence=>8
,p_column_heading=>'Action '
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(175468831839456833.4052)
,p_query_column_id=>10
,p_column_alias=>'TO_BE_DELETED'
,p_column_display_sequence=>10
,p_column_heading=>'A supprimer'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(78242129508922453.4052)
,p_plug_name=>'Fichiers d''export d''espace de travail'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Pour t\00E9l\00E9charger sur votre ordinateur un fichier d''export d''espace de travail, cliquez sur le titre d''export. Pour installer le fichier, cliquez sur le lien d''action <strong>Installer</strong>.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78283825369247714.4052)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(49518022356125296.4052)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('Supprimer ce qui est coch\00E9')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:p173_Delete();'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47003309260720447.4052)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_api.id(49518022356125296.4052)
,p_button_name=>'IMPORT_FILE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Importer un fichier'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:460::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(78241025735921225.4052)
,p_branch_action=>'173'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(78294233672258872.4052)
,p_validation_name=>'File Selection Not Null'
,p_validation_sequence=>10
,p_validation=>'wwv_flow_utilities.table_to_string2(wwv_flow.g_f01) is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Les fichiers \00E0 supprimer doivent \00EAtre indiqu\00E9s.')
,p_when_button_pressed=>wwv_flow_api.id(78283825369247714.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(49561131144137374.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(78289512334253555.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'forall i in 1..wwv_flow.g_f01.count',
'    delete from wwv_flow_file_objects$',
'     where id = wwv_flow.g_f01(i)',
'     and file_type in (''COMPANY_EXPORT'');',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors de la suppression d''un ou de plusieurs fichiers.'
,p_process_when_button_id=>wwv_flow_api.id(78283825369247714.4052)
,p_process_success_message=>unistr('Fichier(s) supprim\00E9(s).')
);
end;
/
prompt --application/pages/page_00181
begin
wwv_flow_api.create_page(
 p_id=>181.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Journal d''automatisation'
,p_alias=>'AUTOMATION-LOG'
,p_step_title=>'Journal d''automatisation'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216784309333645873)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*.break-url {',
'    word-break: break-all;',
'}*/'))
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_logs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(673230794801484126.4052)
,p_plug_name=>'Journal d''automatisation'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Le journal d''automatisation contient des informations d\00E9taill\00E9es sur les automatisations ex\00E9cut\00E9es par l''instance &PRODUCT_NAME. : ID d''application, nom de l''automatisation, lignes trait\00E9es avec r\00E9ussite et avec des erreurs.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(673231206188484129.4052)
,p_plug_name=>'Journal d''automatisation'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>15
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(815172602390000205.4052)
,p_plug_name=>'Journal d''automatisation'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.flow_id,',
'       a.name,',
'       l.status,',
'       l.start_timestamp,',
'       extract( SECOND from l.end_timestamp - l.start_timestamp ) +',
'       extract( MINUTE from l.end_timestamp - l.start_timestamp ) * 60 +',
'       extract( HOUR   from l.end_timestamp - l.start_timestamp ) * 3600 as seconds_elapsed,',
'       l.successful_row_count,',
'       l.error_row_count,',
'       c.short_name',
'from  wwv_flow_automation_log l, wwv_flow_automations a, wwv_flow_companies c',
'where c.provisioning_company_id = l.security_group_id',
'  and l.automation_id           = a.id (+)',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'%null%'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(815172712512000205.4052)
,p_name=>'Mail Log'
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>815172712512000205
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1411212363371995.4052)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>80
,p_column_identifier=>'U'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1413129271372044.4052)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>90
,p_column_identifier=>'AA'
,p_column_label=>'ID d''application'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1413570251372044.4052)
,p_db_column_name=>'NAME'
,p_display_order=>100
,p_column_identifier=>'AB'
,p_column_label=>'Nom de l''automatisation'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1414326870372045.4052)
,p_db_column_name=>'STATUS'
,p_display_order=>120
,p_column_identifier=>'AD'
,p_column_label=>'Statut'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(1581480830428587)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1414710595372045.4052)
,p_db_column_name=>'START_TIMESTAMP'
,p_display_order=>130
,p_column_identifier=>'AE'
,p_column_label=>unistr('D\00E9marr\00E9 ')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'YYYY/MM/DD HH24:MI:SS TZR'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1412719348372044.4052)
,p_db_column_name=>'SECONDS_ELAPSED'
,p_display_order=>200
,p_column_identifier=>'AL'
,p_column_label=>unistr('Secondes \00E9coul\00E9es')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999990D0'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1403077046294847.4052)
,p_db_column_name=>'SUCCESSFUL_ROW_COUNT'
,p_display_order=>210
,p_column_identifier=>'AM'
,p_column_label=>unistr('Lignes de r\00E9ussite')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1403113152294848.4052)
,p_db_column_name=>'ERROR_ROW_COUNT'
,p_display_order=>220
,p_column_identifier=>'AN'
,p_column_label=>'Lignes d''erreur'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1410153513371976.4052)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(673231206188484129.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:181:&SESSION.::&DEBUG.:RIR,121::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1410584309371986.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(673231206188484129.4052)
,p_button_name=>'TRUNCATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Vider'
,p_button_position=>'CREATE'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1417271818372086.4052)
,p_branch_action=>'f?p=&FLOW_ID.:181:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1416397216372082.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Truncate log'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_websource_sync_log;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors du vidage du journal des courriels.'
,p_process_when_button_id=>wwv_flow_api.id(1410584309371986.4052)
,p_process_success_message=>unistr('Journal de synchronisation REST vid\00E9 avec succ\00E8s.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1416799164372085.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_api.id(1410153513371976.4052)
);
end;
/
prompt --application/pages/page_00182
begin
wwv_flow_api.create_page(
 p_id=>182.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('G\00E9rer le journal d''automatisation')
,p_alias=>'MANAGE-AUTOMATION-LOG'
,p_step_title=>unistr('G\00E9rer le journal d''automatisation')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216783731365642767)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
,p_help_text=>'AEADM/adm_logs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(688760584507364699.4052)
,p_plug_name=>unistr('Supprimer les entr\00E9es du journal d''automatisation')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   c_dev pls_integer := 0;',
'',
'begin',
'   select count(*) into c_dev from wwv_flow_automation_log;',
'   sys.htp.p(''<p>''||wwv_flow_lang.system_message(''4050_182_AUTOMATION_LOG'')||'': '');',
'   sys.htp.p(to_char(c_dev,''999,999,999,990'')||''</p>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1704784296036984533.4052)
,p_plug_name=>'Boutons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1706255529232760222.4052)
,p_plug_name=>'Journal d''automatisation'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829706609080810173.4052)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Cette instance &PRODUCT_NAME. peut \00EAtre configur\00E9e en vue de journaliser des ex\00E9cutions d''automatisation.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1587017782437430.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1704784296036984533.4052)
,p_button_name=>'DELETE_ENTRIES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Supprimer des entr\00E9es')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1587421169437431.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1704784296036984533.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1588636771437446.4052)
,p_branch_name=>'Go To Page 182'
,p_branch_action=>'182'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(1587017782437430.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1585811381437422.4052)
,p_name=>'P182_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(688760584507364699.4052)
,p_prompt=>unistr('Supprimer les entr\00E9es datant du nombre de jours suivant ou plus :')
,p_source=>'31'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIME_INTERVALS'
,p_lov=>'.'||wwv_flow_api.id(87720511660244788.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Purgez les entr\00E9es d\00E9passant ce nombre de jours.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1588165486437445.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete rows'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_automation_msg_log1$',
'where message_timestamp < (localtimestamp - numtodsinterval(nvl(:p182_time,31), ''DAY''));',
'delete from wwv_flow_automation_msg_log2$',
'where message_timestamp < (localtimestamp - numtodsinterval(nvl(:p182_time,31), ''DAY''));',
'',
'delete from wwv_flow_automation_log1$',
'where start_timestamp < (localtimestamp - numtodsinterval(nvl(:p182_time,31), ''DAY''));',
'delete from wwv_flow_automation_log2$',
'where start_timestamp < (localtimestamp - numtodsinterval(nvl(:p182_time,31), ''DAY''));'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors de la purge du journal d''automatisation.'
,p_process_when_button_id=>wwv_flow_api.id(1587017782437430.4052)
,p_process_success_message=>unistr('Journal d''automatisation purg\00E9.')
);
end;
/
prompt --application/pages/page_00277
begin
wwv_flow_api.create_page(
 p_id=>277.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Installer un espace de travail'
,p_step_title=>'Installer un espace de travail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_wrkspc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32853819457639405.4052)
,p_plug_name=>'reset'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>':P277_SCHEMA_PASSWORD := null;'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44762414687138585.4052)
,p_plug_name=>'Wizard progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(44806708563745373.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44763124645160393.4052)
,p_plug_name=>'Wizard buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48176739757943065.4052)
,p_plug_name=>'Schema Information'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('Indiquez si le sch\00E9ma \00E0 utiliser avec cet espace de travail existe d\00E9j\00E0, puis saisissez son nom. Si le sch\00E9ma n''existe pas, saisissez un mot de passe et choisissez la taille du tablespace associ\00E9 \00E0 cr\00E9er. Cliquez sur <strong>Suivant</strong> pour con')
||'tinuer.'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752113264001695874.4052)
,p_plug_name=>'Installer un espace de travail'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48177713223944782.4052)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(44763124645160393.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:173:&SESSION.::&DEBUG.:::'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48179628114949129.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44763124645160393.4052)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48179934045949130.4052)
,p_branch_action=>'f?p=&FLOW_ID.:278:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(48179628114949129.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48180827899958515.4052)
,p_name=>'P277_EXISTING'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(48176739757943065.4052)
,p_item_default=>'0'
,p_prompt=>unistr('R\00E9utiliser le sch\00E9ma existant ?')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES.NO.RETURNS.1_OR_0'
,p_lov=>'.'||wwv_flow_api.id(87817312158083090.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('D\00E9terminez si vous souhaitez r\00E9utiliser un sch\00E9ma de base de donn\00E9es existant.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48182621104966064.4052)
,p_name=>'P277_SCHEMA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(48176739757943065.4052)
,p_prompt=>unistr('Nom de sch\00E9ma')
,p_source=>'wwv_flow_imp_parser.get_schema_provisioned (p_file_id => :P277_FILE_ID)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       username d,',
'       username r',
'  from wwv_flow_admin_all_schemas s',
' where restricted_to_workspace is null',
' order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Si vous r\00E9utilisez, pour l''espace de travail, un sch\00E9ma de base de donn\00E9es existant, saisissez-en le nom. Si vous voulez cr\00E9er un nouveau sch\00E9ma et l''affecter \00E0 l''espace de travail, indiquez le nom de ce sch\00E9ma. Vous devez indiquer un nom de sch\00E9ma d')
||unistr('e base de donn\00E9es Oracle valide. Certains noms de sch\00E9ma peuvent ne pas \00EAtre disponibles pour affectation \00E0 des espaces de travail, en fonction de ce qu''ont d\00E9fini les administrateurs de base de donn\00E9es et l''administrateur de site &PRODUCT_NAME. pour')
||' le site.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48183232878969473.4052)
,p_name=>'P277_SCHEMA_PASSWORD'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(48176739757943065.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Mot de passe de sch\00E9ma')
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Si vous choisissez de cr\00E9er un nouveau sch\00E9ma, indiquez-en le mot de passe. Ce dernier pourra \00EAtre modifi\00E9 \00E0 tout moment apr\00E8s la cr\00E9ation du sch\00E9ma, \00E0 l''aide d''outils standard, sans incidence sur le fonctionnement de &PRODUCT_NAME..')
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48184219503975036.4052)
,p_name=>'P277_QUOTA'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(48176739757943065.4052)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_default number;',
'begin',
'    for c1 in (select req_size',
'                 from wwv_flow_workspace_req_size',
'                where request_type = ''C''',
'                  and default_size = ''Y'') loop',
'        l_default := c1.req_size;',
'        exit;',
'    end loop;',
'    return l_default;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Quota d''espace (Mo)'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select req_size d, req_size r',
'  from wwv_flow_workspace_req_size',
' where request_type = ''C''',
' order by to_number(req_size)'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Si vous cr\00E9ez un nouveau sch\00E9ma, indiquez la taille maximum du tablespace \00E0 lui associer. Ce maximum peut \00EAtre modifi\00E9 par la suite.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48315238971303971.4052)
,p_name=>'P277_IMP_COMPANY_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(48176739757943065.4052)
,p_use_cache_before_default=>'NO'
,p_source=>'wwv_flow_imp_parser.get_security_group_id (p_file_id => :p277_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53807517254452276.4052)
,p_name=>'P277_FILE_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(48176739757943065.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(48269636491849041.4052)
,p_computation_sequence=>10
,p_computation_item=>'P277_EXISTING'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1'
,p_computation_error_message=>unistr('Impossible de calculer la valeur de l''\00E9l\00E9ment.')
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from sys.dba_users',
' where username = wwv_flow_imp_parser.get_schema_provisioned (:P277_file_ID)'))
,p_compute_when_type=>'EXISTS'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(48205936501206990.4052)
,p_validation_name=>'check if schema exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from sys.dba_users',
' where username = upper(:P277_SCHEMA)'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('Le sch\00E9ma n''existe pas.')
,p_validation_condition=>':P277_EXISTING = ''1'' and :P277_SCHEMA is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(48179628114949129.4052)
,p_associated_item=>wwv_flow_api.id(48182621104966064.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(48206824858213114.4052)
,p_validation_name=>'schema name required'
,p_validation_sequence=>10
,p_validation=>'P277_SCHEMA'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le sch\00E9ma doit \00EAtre indiqu\00E9.')
,p_when_button_pressed=>wwv_flow_api.id(48179628114949129.4052)
,p_associated_item=>wwv_flow_api.id(48182621104966064.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(48207414253219488.4052)
,p_validation_name=>'check if schema doesn''t exist'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from sys.dba_users',
' where username = upper(:P277_SCHEMA)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Le sch\00E9ma existe d\00E9j\00E0.')
,p_validation_condition=>':P277_EXISTING = ''0'' and :P277_SCHEMA is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(48179628114949129.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(48208237109226103.4052)
,p_validation_name=>'password required'
,p_validation_sequence=>10
,p_validation=>'P277_SCHEMA_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Vous devez indiquer un mot de passe.'
,p_validation_condition=>':P277_EXISTING = ''0'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(48179628114949129.4052)
,p_associated_item=>wwv_flow_api.id(48183232878969473.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(48208822695231456.4052)
,p_validation_name=>'quota not 0'
,p_validation_sequence=>10
,p_validation=>'P277_QUOTA'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>unistr('Le quota doit \00EAtre indiqu\00E9.')
,p_validation_condition=>':P277_EXISTING = ''0'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(48179628114949129.4052)
,p_associated_item=>wwv_flow_api.id(48184219503975036.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(79842714274096727.4052)
,p_validation_name=>'is workspace export'
,p_validation_sequence=>10
,p_validation=>'wwv_flow_imp_parser.is_company_export(:P277_FILE_ID) = true'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Ce fichier n''est pas un fichier d''export d''espace de travail valide.'
,p_when_button_pressed=>wwv_flow_api.id(48179628114949129.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183433405098755253.4052)
,p_validation_name=>'schema not reserved'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_provisioning.reserved_schema(p_schema =>   ',
'    upper(:P277_SCHEMA)) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Le sch\00E9ma principal demand\00E9 pour l''espace de travail est r\00E9serv\00E9.')
,p_when_button_pressed=>wwv_flow_api.id(48179628114949129.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183434421505769421.4052)
,p_validation_name=>'schema not restricted'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (wwv_flow_provisioning.site_admin_is_restricted and',
'     wwv_flow_provisioning.restricted_schema(upper(:P277_SCHEMA),',
'        wwv_flow_security.find_company_name(:P277_IMP_COMPANY_ID))) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Le sch\00E9ma demand\00E9 est restreint. Les sch\00E9mas restreints ne peuvent pas \00EAtre affect\00E9s \00E0 des espaces de travail.')
,p_when_button_pressed=>wwv_flow_api.id(48179628114949129.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1214618732513490893.4052)
,p_name=>'Reuse Schema'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P277_EXISTING'
,p_condition_element=>'P277_EXISTING'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1214619022528490894.4052)
,p_event_id=>wwv_flow_api.id(1214618732513490893.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P277_SCHEMA_PASSWORD,P277_QUOTA'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1214619214307490894.4052)
,p_event_id=>wwv_flow_api.id(1214618732513490893.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P277_SCHEMA_PASSWORD,P277_QUOTA'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(48416722507235934.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'determine company import action'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_done boolean := false;',
'  l_company_cnt pls_integer := 0;',
'  l_workspace_name varchar2(255) :=  upper(wwv_flow_imp_parser.get_workspace_name(:P277_FILE_ID));',
'begin',
'  for c1 in (select count(*) cnt',
'             from wwv_flow_companies',
'             where provisioning_company_id = :P277_IMP_COMPANY_ID',
'             or short_name = l_workspace_name)',
'  loop',
'    l_company_cnt := c1.cnt;',
'  end loop;',
'  ',
'  if l_company_cnt = 0 then',
'    :P165_COMPANY_EXISTS := wwv_flow_lang.system_message(''F4000.NO'');',
'    :P165_COMPANY_ACTION := wwv_flow_lang.system_message(''F4050.WS_TOBE_CREATED'');',
'    :P165_WS_EXISTS := ''N'';',
'  else  ',
'      :P165_COMPANY_EXISTS := wwv_flow_lang.system_message(''F4000.YES'');  ',
'      :P165_WS_EXISTS := ''Y'';',
'      for c1 in (select 1',
'                 from wwv_flow_companies',
'                 where provisioning_company_id = :P277_IMP_COMPANY_ID',
'                 and short_name = l_workspace_name)',
'      loop',
'        l_done := true;',
'        :P165_COMPANY_ACTION := wwv_flow_lang.system_message(''F4050.WS_EXISTS'');',
'      end loop;',
'      ',
'      if not l_done then',
'          for c1 in (select 1',
'                     from wwv_flow_companies',
'                     where provisioning_company_id != :P277_IMP_COMPANY_ID',
'                     and short_name = l_workspace_name)',
'          loop',
'            l_done := true;',
'            :P165_COMPANY_ACTION := wwv_flow_lang.system_message(''F4050.WSNAME_EXISTS'');',
'          end loop;',
'          ',
'          if not l_done then',
'              for c1 in (select 1',
'                         from wwv_flow_companies',
'                         where provisioning_company_id = :P277_IMP_COMPANY_ID',
'                         and short_name != l_workspace_name)',
'              loop',
'                :P165_COMPANY_ACTION := wwv_flow_lang.system_message(''F4050.WSID_EXISTS'');',
'              end loop; ',
'          end if;',
'      end if;   ',
'  end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00278
begin
wwv_flow_api.create_page(
 p_id=>278.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Installer un espace de travail'
,p_step_title=>'Installer un espace de travail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_mg_wrkspc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44769711139506518.4052)
,p_plug_name=>'Wizard progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(44806708563745373.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44770620274518637.4052)
,p_plug_name=>'Wizard buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(73838711357869610.4052)
,p_plug_name=>'Verify'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('L''installation d''un espace de travail \00E0 partir d''un fichier import\00E9 s''ex\00E9cutera en tant qu''utilisateur privil\00E9gi\00E9. Il est donc important que vous ayez confiance en la source du fichier import\00E9.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(188853515443356856.4052)
,p_plug_name=>unistr('Statut d''affectation de sch\00E9ma')
,p_region_template_options=>'#DEFAULT#:a-Form--autoWidthLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>60
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_schemas           varchar2(32767);',
'  l_schemas_t         wwv_flow_global.vc_arr2;',
'  l_primary_schema    varchar2(256);',
'  l_schema_in_use     boolean;',
'  l_schema_restricted boolean;',
'  l_schema_reserved   boolean;',
'  l_schema_exists     boolean;',
'  l_no_assign         boolean;',
'begin',
'  l_primary_schema := upper(:P277_SCHEMA);',
'  l_schemas := '':''||rtrim(wwv_flow_imp_parser.get_workspace_schemas(:P277_FILE_ID),'':'')||'':'';',
'  l_schemas := replace(l_schemas,'':''||l_primary_schema||'':'',null);',
'  l_schemas := ltrim(rtrim(l_schemas,'':''),'':'');',
'  sys.htp.p(''<p />'');',
'  sys.htp.p(''<div class="a-Report a-Report--confirmReport a-Report--stretch a-Report--staticRowColors"><div class="a-Report-wrap"><div class="a-Report-tableWrap">'');',
'  sys.htp.p(''<table class="a-Report-report" ''||wwv_flow_utilities.get_layout_table_attributes||''>'');',
'  sys.htp.p(''<tr><td class="u-tR a-Report-cell a-Report-cell--header">''||wwv_flow_lang.system_message(''F4050.PRIMARY_SCHEMA'')||''<td class="a-Report-cell">''||',
'        wwv_flow_escape.html(l_primary_schema)||''</td></tr>'');',
'  sys.htp.p(''<tr><td class="u-tR a-Report-cell a-Report-cell--header">''||wwv_flow_lang.system_message(''F4000_P801_ACTION'')||''<td class="a-Report-cell">'');',
'',
'  if :P277_EXISTING = ''0'' then',
'      sys.htp.p(wwv_flow_lang.system_message(''F4050.CREATE_SCHEMA'')||''</td></tr>'');',
'  else',
'      sys.htp.p(wwv_flow_lang.system_message(''F4050.REUSE_SCHEMA'')||''</td></tr>'');',
'  end if; ',
'  ',
'  l_schema_in_use := false;  ',
'  for c1 in (select 1 from wwv_flow_company_schemas ',
'             where schema = l_primary_schema) loop',
'      l_schema_in_use := true;',
'  end loop;',
'  ',
'  l_schema_restricted :=  wwv_flow_provisioning.restricted_schema(l_primary_schema,',
'   wwv_flow_security.find_company_name(:P277_IMP_COMPANY_ID));',
'  ',
'  if l_schema_in_use or l_schema_restricted then',
'      if l_schema_restricted then',
'          sys.htp.p(''<tr><td class="u-tR a-Report-cell a-Report-cell--header">''||''&nbsp;''||''</td><td class="a-Report-cell">'');  ',
'          sys.htp.p(wwv_flow_lang.system_message(''F4050.SCHEMA_RESTRICTED'')||''</td></tr>'');',
'      end if;',
'      if l_schema_in_use then',
'          sys.htp.p(''<tr><td class="u-tR a-Report-cell a-Report-cell--header">''||''&nbsp;''||''</td><td class="a-Report-cell">'');        ',
'          sys.htp.p(wwv_flow_lang.system_message(''F4050.SCHEMA_ASSIGNED'')||''</td></tr>'');',
'      end if;',
'  end if;',
'  --',
'  l_schemas_t := wwv_flow_utilities.string_to_table2(l_schemas);',
'  ',
'  for i in 1..l_schemas_t.count loop',
'     sys.htp.p(''<tr><td>''||''&nbsp;''||''</td><td>''||''&nbsp;''||''</td></tr>'');           ',
'     sys.htp.p(''<tr><td class="u-tR a-Report-cell a-Report-cell--header">''||wwv_flow_lang.system_message(''F4050.ADDITIONAL_SCHEMA'')||''''||',
'           ''</td><td class="a-Report-cell">''||wwv_flow_escape.html(l_schemas_t(i))||''</td></tr>'');',
'     sys.htp.p(''<tr><td>''||wwv_flow_lang.system_message(''F4000_P801_ACTION'')||'''');  ',
'     ',
'     l_schema_exists := wwv_flow_security.get_db_user_or_role(p_username => l_schemas_t(i)) is not null;',
'     ',
'     l_schema_restricted := wwv_flow_provisioning.restricted_schema(l_schemas_t(i),',
'    wwv_flow_security.find_company_name(:P277_IMP_COMPANY_ID));',
'     l_schema_reserved := wwv_flow_provisioning.reserved_schema(l_schemas_t(i));     ',
'     l_no_assign := false;',
'     ',
'     if l_schema_exists = false or l_schema_restricted or l_schema_reserved then',
'         sys.htp.p(''<td class="a-Report-cell">''||wwv_flow_lang.system_message(''F4050.ACTION_NO_ASSIGN'')||''</td></tr>'');',
'         if l_schema_exists = false then',
'             l_no_assign := true;',
'             sys.htp.p(''<tr><td class="u-tR a-Report-cell a-Report-cell--header">''||''&nbsp;''||''</td>'');  ',
'             sys.htp.p(''<td class="a-Report-cell">''||wwv_flow_lang.system_message(''F4050.SCHEMA_NOT_EXIST'')||''</td></tr>'');',
'         end if;',
'         if l_schema_restricted then',
'             l_no_assign := true;',
'             sys.htp.p(''<tr><td class="u-tR a-Report-cell a-Report-cell--header">''||''&nbsp;''||''</td>'');           ',
'             sys.htp.p(''<td class="a-Report-cell">''||wwv_flow_lang.system_message(''F4050.SCHEMA_RESTRICTED_NO_WARN'')||''</td></tr>'');        ',
'         end if;',
'         if l_schema_reserved then',
'             l_no_assign := true;',
'             sys.htp.p(''<tr><td class="u-tR a-Report-cell a-Report-cell--header">''||''&nbsp;''||''</td>'');           ',
'             sys.htp.p(''<td class="a-Report-cell">''||wwv_flow_lang.system_message(''F4050.SCHEMA_RESERVED_NO_WARN'')||''</td></tr>'');         ',
'         end if;        ',
'     else',
'         sys.htp.p(''<td class="a-Report-cell">''||wwv_flow_lang.system_message(''F4050.ACTION_ASSIGN'')||''</td></tr>'');',
'     end if;    ',
'            ',
'     l_schema_in_use := false;  ',
'     for c1 in (select 1 from wwv_flow_company_schemas ',
'                where schema = l_schemas_t(i)) loop',
'        l_schema_in_use := true;',
'     end loop;',
'     ',
'     if l_no_assign = false and (l_schema_in_use or l_schema_restricted) then',
'        if l_schema_restricted then',
'           sys.htp.p(''<tr><td class="u-tR a-Report-cell a-Report-cell--header">''||''&nbsp;''||''</td><td class="a-Report-cell">'');  ',
'           sys.htp.p(wwv_flow_lang.system_message(''F4050.SCHEMA_RESTRICTED'')||''</td></tr>'');',
'        end if;',
'        if l_schema_in_use then',
'           sys.htp.p(''<tr><td class="u-tR a-Report-cell a-Report-cell--header">''||''&nbsp;''||''</td><td class="a-Report-cell">'');        ',
'           sys.htp.p(wwv_flow_lang.system_message(''F4050.SCHEMA_ASSIGNED'')||''</td></tr>'');',
'        end if;',
'     end if;',
'  end loop;',
'  ',
'  sys.htp.p(''</table>'');',
'  sys.htp.p(''</div></div></div>''); ',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752113393905695874.4052)
,p_plug_name=>'Installer un espace de travail'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(73839503943869615.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44770620274518637.4052)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(73839910398869615.4052)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(44770620274518637.4052)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:277:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(73839113159869612.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44770620274518637.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:173:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(44772801495559707.4052)
,p_branch_action=>'f?p=&APP_ID.:165:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(73839503943869615.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(73841032039869622.4052)
,p_name=>'P278_PROCEED'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(188853515443356856.4052)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CONFIRM.WORKSPACE_INSTALL'
,p_lov=>'.'||wwv_flow_api.id(73876902692924600.4052)||'.'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(73841817383869626.4052)
,p_validation_name=>'must check proceed'
,p_validation_sequence=>10
,p_validation=>'nvl(:P278_PROCEED,''No'') = ''Yes'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Vous devez cocher pour continuer.'
,p_when_button_pressed=>wwv_flow_api.id(73839503943869615.4052)
,p_associated_item=>wwv_flow_api.id(73841032039869622.4052)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
end;
/
prompt --application/pages/page_00280
begin
wwv_flow_api.create_page(
 p_id=>280.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Banni\00E8re d''environnement')
,p_alias=>'ENVIRONMENT-BANNER'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Banni\00E8re d''environnement')
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2700645148653301.4052)
,p_plug_name=>unistr('D\00E9finir une banni\00E8re d''environnement')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(171512435967812715.4052)
,p_plug_name=>'buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(182275369038854302.4052)
,p_plug_name=>'INSTANCE BANNER INTRO'
,p_region_css_classes=>'a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--info:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829706609080810173.4052)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>unistr('Vous pouvez d\00E9finir une banni\00E8re d''environnement de niveau instance pour faire la distinction dans plusieurs instances &PRODUCT_NAME.. La banni\00E8re sera affich\00E9e dans l''environnement de d\00E9veloppement &PRODUCT_NAME..')
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2706665346663469.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(171512435967812715.4052)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2707032211663471.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(171512435967812715.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2701753005653312.4052)
,p_branch_name=>'Go To Page &LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2701043767653305.4052)
,p_name=>'P280_BANNER_LABEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(2700645148653301.4052)
,p_prompt=>unistr('Libell\00E9')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Saisissez un bref libell\00E9 descriptif qui sera affich\00E9 dans cette banni\00E8re d''environnement.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2701247028653307.4052)
,p_name=>'P280_BANNER_COLOR'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(2700645148653301.4052)
,p_prompt=>'Couleur'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P280_ENV_BANNER_COLORS'
,p_lov=>'.'||wwv_flow_api.id(2805702200728881.4052)||'.'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_css_classes=>'a-EnvBanner-colorSelector'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('S\00E9lectionnez une couleur d''accentuation pour le message de banni\00E8re. Cette couleur sera \00E9galement appliqu\00E9e \00E0 la barre d''outils de d\00E9veloppeur.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'8'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2701648028653311.4052)
,p_name=>'P280_ENABLE_BANNER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2700645148653301.4052)
,p_prompt=>unistr('Activer la banni\00E8re')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indiquez si la banni\00E8re d''environnement pour l''instance &PRODUCT_NAME. doit \00EAtre activ\00E9e.</p>'),
'',
unistr('<p>Lorsque cette option est activ\00E9e, la banni\00E8re est affich\00E9e dans l''environnement de d\00E9veloppement &PRODUCT_NAME..</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(883418470222822204.4052)
,p_name=>'P280_BANNER_POS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2700645148653301.4052)
,p_prompt=>'Position'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P280_ENV_BANNER_POS'
,p_lov=>'.'||wwv_flow_api.id(147094582352565991.4052)||'.'
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('S\00E9lectionnez la position d''affichage de la banni\00E8re.')
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2417567561910715.4052)
,p_validation_name=>'if enabled, label required'
,p_validation_sequence=>10
,p_validation=>'P280_BANNER_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le champ #LABEL# doit \00EAtre d\00E9fini.')
,p_validation_condition=>'P280_ENABLE_BANNER'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(2706665346663469.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2417648621910716.4052)
,p_validation_name=>'if enabled, color required'
,p_validation_sequence=>20
,p_validation=>'P280_BANNER_COLOR'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le champ #LABEL# doit \00EAtre d\00E9fini.')
,p_validation_condition=>'P280_ENABLE_BANNER'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(2706665346663469.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(883418551112822205.4052)
,p_validation_name=>'if enabled, position required'
,p_validation_sequence=>30
,p_validation=>'P280_BANNER_POS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le champ #LABEL# doit \00EAtre d\00E9fini.')
,p_validation_condition=>'P280_ENABLE_BANNER'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(2706665346663469.4052)
,p_associated_item=>wwv_flow_api.id(.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2700876795653303.4052)
,p_name=>'Cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2707032211663471.4052)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2700988910653304.4052)
,p_event_id=>wwv_flow_api.id(2700876795653303.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2417288077910712.4052)
,p_name=>'toggle  label and color'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P280_ENABLE_BANNER'
,p_condition_element=>'P280_ENABLE_BANNER'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2417392466910713.4052)
,p_event_id=>wwv_flow_api.id(2417288077910712.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P280_BANNER_LABEL,P280_BANNER_COLOR,P280_BANNER_POS'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2417489734910714.4052)
,p_event_id=>wwv_flow_api.id(2417288077910712.4052)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P280_BANNER_LABEL,P280_BANNER_COLOR,P280_BANNER_POS'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2701197792653306.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save environment banner settings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_platform.set_preference(',
'    p_preference_name  => ''ENV_BANNER_ENABLE'',',
'    p_preference_value => :P280_ENABLE_BANNER );',
'if :P280_ENABLE_BANNER = ''Y'' then',
'    -- If environment banner enabled, set the preference value',
'    wwv_flow_platform.set_preference(',
'        p_preference_name => ''ENV_BANNER_LABEL'',',
'        p_preference_value => :P280_BANNER_LABEL );',
'    wwv_flow_platform.set_preference(',
'        p_preference_name => ''ENV_BANNER_COLOR'',',
'        p_preference_value => :P280_BANNER_COLOR );',
'    wwv_flow_platform.set_preference(',
'        p_preference_name => ''ENV_BANNER_POS'',',
'        p_preference_value => :P280_BANNER_POS );',
'else',
'    -- Otherwise, clear out the settings',
'    wwv_flow_platform.set_preference(',
'        p_preference_name => ''ENV_BANNER_LABEL'',',
'        p_preference_value => null );',
'    wwv_flow_platform.set_preference(',
'        p_preference_name => ''ENV_BANNER_COLOR'',',
'        p_preference_value => null );',
'    wwv_flow_platform.set_preference(',
'        p_preference_name => ''ENV_BANNER_POS'',',
'        p_preference_value => null );',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2706665346663469.4052)
,p_process_success_message=>unistr('Param\00E8tres de banni\00E8re d''environnement enregistr\00E9s.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2701815482653313.4052)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch environment banner settings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P280_ENABLE_BANNER := coalesce( wwv_flow_platform.get_preference( p_preference_name => ''ENV_BANNER_ENABLE'' ), ''N'' );',
':P280_BANNER_LABEL := wwv_flow_platform.get_preference( p_preference_name => ''ENV_BANNER_LABEL'' );',
':P280_BANNER_COLOR := wwv_flow_platform.get_preference( p_preference_name => ''ENV_BANNER_COLOR'' );',
':P280_BANNER_POS   := coalesce( wwv_flow_platform.get_preference( p_preference_name => ''ENV_BANNER_POS'' ), ''LEFT'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00400
begin
wwv_flow_api.create_page(
 p_id=>400.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Statut de construction'
,p_step_title=>'Statut de construction'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(275228225185505839)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_bld_status.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(179857814095000652.4052)
,p_plug_name=>'Statut de construction'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cet \00E9tat permet de v\00E9rifier et de modifier l''attribut Statut de construction d''une application de cette instance &PRODUCT_NAME..</p>'),
'',
unistr('<p>Lorsque le statut de construction d''une application est d\00E9fini sur Ex\00E9cuter et construire l''application, les d\00E9veloppeurs qui sont dans l''espace de travail de l''application peuvent utiliser App Builder pour modifier la d\00E9finition de l''application.')
||unistr(' Lorsque le statut de construction d''une application est d\00E9fini sur Ex\00E9cuter l''application uniquement, App Builder peut voir l''application, mais pas ses d\00E9tails (qui sont donc impossibles \00E0 modifier). Les utilisateurs finals peuvent tout de m\00EAme ex\00E9c')
||'uter cette application.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472838728637137224.4052)
,p_plug_name=>'Applications'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P400a */',
'       f.ID,',
'       f.id as application,',
'       c.short_name as SECURITY_GROUP_ID,',
'       f.OWNER,',
'       f.NAME,',
'       f.BUILD_STATUS,',
'       f.last_updated_on,',
'       (select count(*) from wwv_flow_steps where flow_id = f.id) as pages',
'  from WWV_FLOWS f,',
'       WWV_FLOW_COMPANIES c',
' where f.security_group_id = c.provisioning_company_id',
'   and f.security_group_id not in (10, 11, 12)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(472838830978137224.4052)
,p_name=>'Applications'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472839026320137263.4052)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472839221209137270.4052)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472839112824137269.4052)
,p_db_column_name=>'APPLICATION'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_link=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.:NONE,4001:P4001_ID:#ID#'
,p_column_linktext=>'#APPLICATION#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472839401842137273.4052)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Nom d''application'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472839314318137271.4052)
,p_db_column_name=>'OWNER'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>unistr('Sch\00E9ma d''analyse')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472839503103137274.4052)
,p_db_column_name=>'BUILD_STATUS'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Statut de construction'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(244320808989852457)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472839609286137275.4052)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Mis \00E0 jour')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472839718429137276.4052)
,p_db_column_name=>'PAGES'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(244305721912824543.4052)
,p_computation_sequence=>10
,p_computation_item=>'P4001_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'CREATE_ROW'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(222857701376540005.4052)
,p_name=>'Dialog closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(472838728637137224.4052)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(222857882841540006.4052)
,p_event_id=>wwv_flow_api.id(222857701376540005.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(472838728637137224.4052)
);
end;
/
prompt --application/pages/page_00401
begin
wwv_flow_api.create_page(
 p_id=>401.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Sch\00E9mas d''analyse')
,p_step_title=>unistr('Sch\00E9mas d''analyse')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(275228225185505839)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_app_parse_as.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(179855710932971339.4052)
,p_plug_name=>unistr('Sch\00E9mas d''analyse')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Cet \00E9tat permet d''identifier le sch\00E9ma d''analyse en cours de chaque application d''un espace de travail. Cet attribut identifie le sch\00E9ma de base de donn\00E9es Oracle dont les privil\00E8ges sont utilis\00E9s lorsque &PRODUCT_NAME. ex\00E9cute dynamiquement le co')
||'de SQL et PL/SQL de l''application.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472846306399177022.4052)
,p_plug_name=>'Applications'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P401a */',
'ID, ',
'(select short_name  from WWV_FLOW_COMPANIES where PROVISIONING_COMPANY_ID = f.security_group_id) SECURITY_GROUP_ID,',
'OWNER,',
'"NAME"',
'from WWV_FLOWS f',
'where f.security_group_id not in (10, 11, 12)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(472846424011177022.4052)
,p_name=>'Applications'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472846808824177027.4052)
,p_db_column_name=>'OWNER'
,p_display_order=>1
,p_column_identifier=>'C'
,p_column_label=>unistr('Sch\00E9ma d''analyse')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472846720499177026.4052)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Espace de travail'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472846630839177025.4052)
,p_db_column_name=>'ID'
,p_display_order=>3
,p_column_identifier=>'A'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472846918998177028.4052)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Nom d''application'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
end;
/
prompt --application/pages/page_00460
begin
wwv_flow_api.create_page(
 p_id=>460.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Importer un espace de travail'
,p_step_title=>'Importer un espace de travail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_wrkspc_exprt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44759932077048957.4052)
,p_plug_name=>'Wizard progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(44758222502979988.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(721136580461780231.4052)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(45313433799096703.4052)
,p_plug_name=>'Import Workspace'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 16-MAY-2003 17:18:02'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(45313828464096704.4052)
,p_plug_name=>'Importer un espace de travail'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(202654431224384775.4052)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>S\00E9lectionnez le fichier \00E0 importer dans le r\00E9ferentiel d''export. Une fois le fichier import\00E9, vous pouvez installer l''espace de travail.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 16-MAY-2003 17:18:02'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(58921039077841151.4052)
,p_plug_name=>unistr('T\00E2ches')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(202654431224384775.4052)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(79863815294295743.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(27525012681104508.4052)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(255043524592205262.4052)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752113457730695874.4052)
,p_plug_name=>'Importer un espace de travail'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721130822791730313.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(45314324875096707.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(255043524592205262.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(45314634840096707.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(255043524592205262.4052)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suivant'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(45316039608096712.4052)
,p_branch_action=>'f?p=&FLOW_ID.:163:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(45314634840096707.4052)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 16-MAY-2003 17:18:02'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(45314136696096704.4052)
,p_name=>'P460_FILE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(45313433799096703.4052)
,p_prompt=>'Importer un fichier'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>50
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Utilisez le bouton Parcourir pour identifier le fichier d''export d''espace de travail que vous voulez ajouter au r\00E9f\00E9rentiel d''export.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_06=>'Y'
,p_attribute_08=>'inline'
,p_attribute_12=>'INLINE'
,p_item_comment=>'Generated 16-MAY-2003 17:18:02'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(47823437609586317.4052)
,p_validation_name=>'file not null'
,p_validation_sequence=>10
,p_validation=>'P460_FILE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le fichier doit \00EAtre indiqu\00E9.')
,p_when_button_pressed=>wwv_flow_api.id(45314634840096707.4052)
,p_associated_item=>wwv_flow_api.id(45314136696096704.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(46711940675496390.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'upload export file'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_title     varchar2(4000) := null;',
'  l_start     number := 0;',
'begin',
'  l_start := instr(:P460_FILE,''/'',1)+1;',
'  l_title := substr(:P460_FILE,l_start);',
'  --',
'  -- save file attributes',
'  --',
'  update wwv_flow_file_objects$ ',
'  set    title = l_title,',
'         file_type = ''COMPANY_EXPORT'', ',
'         description = l_title||'' upload'',',
'         security_group_id = :flow_security_group_id,      ',
'         mime_type = ''application/text'',',
'         created_by = :flow_user',
'  where name = :P460_FILE;           ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Erreur lors du t\00E9l\00E9chargement du fichier d''export.')
,p_process_when_button_id=>wwv_flow_api.id(45314634840096707.4052)
,p_process_success_message=>unistr('Fichier d''export t\00E9l\00E9charg\00E9.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(53577817515753555.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set p163_file_id'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_file_id number := null;',
'begin',
'  for c1 in (select id',
'             from wwv_flow_file_objects$',
'             where name = :P460_FILE)',
'  loop',
'     l_file_id := c1.id;',
'  end loop;',
'  :P163_FILE_ID := l_file_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(45314634840096707.4052)
);
end;
/
prompt --application/pages/page_00461
begin
wwv_flow_api.create_page(
 p_id=>461.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Exporter un espace de travail'
,p_step_title=>'Exporter un espace de travail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_wrkspc_exprt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(81345113041600234.4052)
,p_plug_name=>'Identifier un espace de travail'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>10
,p_plug_query_row_template=>wwv_flow_api.id(81008210556197147.4052)
,p_plug_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'blue_arrow_down.gif::blue_arrow_up.gif:|2,3,4\1|',
'',
'&nbsp;:',
'',
'<font color="black" class="nounderline">Schema</font>:',
'',
'<font color="black" class="nounderline">Company</font>:',
'',
'<font color="black" class="nounderline">CompanyID</font>'))
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_display_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_plug_display_when_condition=>'EXPORT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(81350720528600259.4052)
,p_plug_name=>'Exporter un espace de travail'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Indiquez un nom d''espace de travail et cliquez sur <strong>Exporter un espace de travail</strong> pour continuer.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_plug_display_when_condition=>'EXPORT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(81389602375977783.4052)
,p_plug_name=>unistr('T\00E2ches')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(79863815294295743.4052)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(27525012681104508.4052)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(81637012348652051.4052)
,p_plug_name=>'Exporter un espace de travail'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cliquez sur <strong>Enregistrer un fichier</strong> pour exporter l''espace de travail s\00E9lectionn\00E9 dans un fichier. Cliquez sur <strong>Annuler</strong> pour revenir \00E0 l''administration d''espace de travail.</p>'),
unistr('<p>N''incluez pas les donn\00E9es de d\00E9veloppement d''\00E9quipe si vous voulez importer l''espace de travail dans un environnement d''ex\00E9cution uniquement.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'EXPORT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(81719123560014772.4052)
,p_plug_name=>'Exporter un espace de travail'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(829706609080810173.4052)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'EXPORT'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Vous avez s\00E9lectionn\00E9 l''espace de travail <strong>&P461_WORKSPACE.</strong> pour export vers un fichier. Cliquez sur <strong>Enregistrer un fichier</strong> pour continuer.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(955891698622997327.4052)
,p_plug_name=>'Nouveau'
,p_parent_plug_id=>wwv_flow_api.id(81719123560014772.4052)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(81615605843555548.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(81345113041600234.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:461::'
,p_button_condition=>'EXPORT'
,p_button_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(81625912647623713.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(81345113041600234.4052)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Exporter un espace de travail'
,p_button_position=>'CREATE'
,p_button_condition=>'EXPORT'
,p_button_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(81367606709666813.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(955891698622997327.4052)
,p_button_name=>'EXPORT'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Enregistrer un fichier'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.submit(''EXPORT'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(81611420210521837.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(955891698622997327.4052)
,p_button_name=>'DONE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:461::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(81690503989971319.4052)
,p_branch_action=>'f?p=&FLOW_ID.:461:&SESSION.:EXPORT:&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(81625912647623713.4052)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2300102571866943.4052)
,p_name=>'P461_INCLUDE_TEAM_DEVELOPMENT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(81719123560014772.4052)
,p_item_default=>'Y'
,p_prompt=>unistr('Inclure le d\00E9veloppement d''\00E9quipe')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(157992123774592395.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('D\00E9finissez la valeur sur <strong>Oui</strong> si vous souhaitez inclure les donn\00E9es de d\00E9veloppement d''\00E9quipe, telles que les libell\00E9s, jalons, mod\00E8les, probl\00E8mes et informations en retour, dans votre fichier d''export d''espace de travail.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(81351023663600263.4052)
,p_name=>'P461_WORKSPACE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(81345113041600234.4052)
,p_prompt=>'Espace de travail'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST.WORKSPACES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name d, short_name v',
'  from wwv_flow_companies',
' where (provisioning_company_id not in (0,10,11,12))',
'order by 1'))
,p_cSize=>60
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(721133598269759785.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifiez l''espace de travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(175838302006261649.4052)
,p_name=>'P461_FILE_CHARSET'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(81719123560014772.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Jeu de caract\00E8res de fichier')
,p_source=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_api.id(175798011541253458.4052)||'.'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifie le jeu de caract\00E8res indiqu\00E9 pour le fichier d''export. Lors de l''import de ce fichier, vous devrez indiquer le m\00EAme jeu de caract\00E8res. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1796417910368006108.4052)
,p_name=>'P461_MINIMAL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(81719123560014772.4052)
,p_item_default=>'MIN'
,p_prompt=>'Type d''export'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'EXPORT_TYPES'
,p_lov=>'.'||wwv_flow_api.id(2046991831712786495.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('D\00E9finissez la valeur <strong>Complet</strong> uniquement si vous voulez r\00E9pliquer tous les artefacts d''espace de travail vers une autre instance, y compris les scripts SQL, l''historique des commandes SQL, le SQL enregistr\00E9, les pr\00E9f\00E9rences utilisateu')
||unistr('r, l''historique des connexions des d\00E9veloppeurs, les journaux des courriels et les valeurs par d\00E9faut d''interface utilisateur. Dans la plupart des cas, vous ne devez pas modifier la valeur par d\00E9faut <strong>Minimal</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(478209805683252492.4052)
,p_validation_name=>'P461_WORKSPACE exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id != 0',
'  and upper(:P461_WORKSPACE) = SHORT_NAME'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('Vous devez s\00E9lectionner un espace de travail valide.')
,p_validation_condition=>'P461_WORKSPACE'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(81625912647623713.4052)
,p_associated_item=>wwv_flow_api.id(81351023663600263.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(81370514936688072.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'export workspace'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_orig_sgid number := wwv_flow_security.g_security_group_id;',
'begin',
'  for c1 in (select provisioning_company_id  ',
'    from wwv_flow_companies ',
'    where short_name = upper(:P461_WORKSPACE)) loop',
'    wwv_flow_security.g_security_group_id := c1.provisioning_company_id;',
'  end loop;',
'  --',
'  sys.htp.init;',
'  wwv_flow.g_page_text_generated := true;',
'  wwv_flow_fnd_user_api.g_mime_shown := true;',
'  ',
'  wwv_flow_utilities.print_download_header(',
'    p_mime_type =>     ''application/x-sql'',',
'    p_file_name =>      :P461_WORKSPACE || ''.sql'',',
'    p_is_attachment => true',
'  );  ',
'  ',
'  sys.owa_util.http_header_close;',
'  --',
'  wwv_flow_utilities.export_workspace (',
'      p_workspace_id             => wwv_flow_security.g_security_group_id,',
'      p_format                   => ''UNIX'',',
'      p_include_team_development => (nvl(:P461_INCLUDE_TEAM_DEVELOPMENT, ''Y'') = ''Y''),',
'      p_minimal                  => (nvl(:P461_MINIMAL,''x'') = ''MIN'') );',
'  --',
'  wwv_flow.g_page_text_generated := true;',
'  wwv_flow.g_unrecoverable_error := true;',
'  wwv_flow_security.g_security_group_id := l_orig_sgid;',
'  --',
'exception when others then',
'  wwv_flow_security.g_security_group_id := l_orig_sgid;',
'  raise;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Erreur lors de l''export de l''espace de travail.'
,p_process_when_button_id=>wwv_flow_api.id(81367606709666813.4052)
,p_process_when=>'EXPORT'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>unistr('Espace de travail export\00E9.')
);
end;
/
prompt --application/pages/page_00500
begin
wwv_flow_api.create_page(
 p_id=>500.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Modifications d''application par espace de travail'
,p_step_title=>'Modifications d''application par espace de travail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472857622906290870.4052)
,p_plug_name=>'Modifications d''application par espace de travail'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P500a */ c.provisioning_company_id security_group_id,',
'       c.short_name,count(s.schema) schemas,',
'       -- apps',
'       max(f.apps) apps,max(f.pages) pages,',
'       max(f.last_updated_on) last_updated_on,',
'       --mail',
'       max(nvl(m.mail_sent,0)) mail_sent,',
'       -- page views',
'       max(nvl(pv.page_views,0)) page_views,',
'       max(nvl(pv.end_users,0)) end_users,',
'       max(nvl(pv.total_elap,0)) total_elap,',
'       max(nvl(pv.avg_page_view_time,0)) avg_page_view_time,',
'       max(nvl(dv.d_page_views,0)) d_page_views,',
'       max(nvl(pv.distinct_ip,0)) distinct_ip',
'  from wwv_flow_companies c, wwv_flow_company_schemas s,',
'       -- flows and pages',
'       (select f1.security_group_id,',
'               count(distinct f1.id) apps,',
'               count(p1.id) pages,',
'               max(f1.last_updated_on) last_updated_on',
'          from wwv_flow_steps p1, wwv_flows f1',
'         where f1.security_group_id = p1.security_group_id',
'           and p1.flow_id = f1.id',
'         group by f1.security_group_id) f,',
'       -- email',
'       (select security_group_id,count(*) mail_sent',
'          from wwv_flow_mail_log',
'         group by security_group_id) m,',
'       -- app page views',
'       (select security_group_id,count(*) page_views,count(distinct userid) end_users,',
'               sum(elap) total_elap,avg(ELAP) avg_page_view_time,',
'               count(distinct IP_ADDRESS) distinct_ip',
'          from wwv_flow_activity_log',
'         where (flow_id > 4999 or flow_id < 4000)',
'         group by security_group_id) pv,',
'       -- developer page views',
'       (select security_group_id,count(*) d_page_views',
'          from wwv_flow_activity_log',
'         where flow_id between 4000 and 4999',
'         group by security_group_id) dv',
' where s.security_group_id = c.provisioning_company_id',
'   and c.provisioning_company_id > 10',
'   and c.provisioning_company_id = f.security_group_id',
'   and c.provisioning_company_id = m.security_group_id(+)',
'   and c.provisioning_company_id = pv.security_group_id(+)',
'   and c.provisioning_company_id = dv.security_group_id(+)',
'   and c.provisioning_company_id <> 11',
' group by c.provisioning_company_id,c.short_name'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(472857730758290870.4052)
,p_name=>'Application Changes by Workspace'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472857903552290887.4052)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('ID de groupe de s\00E9curit\00E9')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472858029095290888.4052)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Espace de travail'
,p_column_link=>'f?p=&APP_ID.:501:&SESSION.:REPORT:&DEBUG.:501:P501_SGID:#SECURITY_GROUP_ID#'
,p_column_linktext=>'#SHORT_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472858116192290889.4052)
,p_db_column_name=>'SCHEMAS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Sch\00E9mas')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472858225817290890.4052)
,p_db_column_name=>'APPS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472858318712290892.4052)
,p_db_column_name=>'PAGES'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472858404727290893.4052)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Mise \00E0 jour la plus r\00E9cente')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472858503358290894.4052)
,p_db_column_name=>'MAIL_SENT'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Courriel envoy\00E9')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472858627932290895.4052)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Vues de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472858715333290896.4052)
,p_db_column_name=>'END_USERS'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Utilisateurs finals'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472858811769290897.4052)
,p_db_column_name=>'TOTAL_ELAP'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Temps total de vue de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472858910412290898.4052)
,p_db_column_name=>'AVG_PAGE_VIEW_TIME'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Temps moyen de vue de page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472859006752290899.4052)
,p_db_column_name=>'D_PAGE_VIEWS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>unistr('Vues de page de d\00E9veloppeur')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472859111689290900.4052)
,p_db_column_name=>'DISTINCT_IP'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Adresses IP distinctes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1080989578091523928.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(472857622906290870.4052)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:500:&SESSION.::&DEBUG.:RP,RIR,500:::'
);
end;
/
prompt --application/pages/page_00501
begin
wwv_flow_api.create_page(
 p_id=>501.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('D\00E9tails de l''activit\00E9 d''espace de travail')
,p_step_title=>unistr('D\00E9tails de l''activit\00E9 d''espace de travail')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216662902659587159)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_activity.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(22547304320952975.4052)
,p_name=>unistr('D\00E9tails de l''espace de travail')
,p_template=>wwv_flow_api.id(517418631967368160.4052)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_column=>false
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    x   varchar2(32767) := null;',
'begin',
'    x:= ''',
'    select c.provisioning_company_id security_group_id,',
'           c.short_name,count(s.schema) schemas,',
'           -- apps',
'           max(f.apps) apps,max(f.pages) pages,',
'           max(f.last_updated_on) last_updated_on,',
'           --mail',
'           max(nvl(m.mail_sent,0)) mail_sent,',
'           max(nvl(mq.mail_count,0)) mail_in_queue,',
'           -- page views',
'           max(nvl(pv.page_views,0)) page_views,',
'           max(nvl(pv.end_users,0)) end_users,',
'           max(nvl(pv.total_elap,0)) total_elap,',
'           max(nvl(pv.avg_page_view_time,0)) avg_page_view_time,',
'           max(nvl(dv.d_page_views,0)) d_page_views,',
'           max(nvl(dv.act_developers,0)) act_developers       ',
'      from wwv_flow_companies c, wwv_flow_company_schemas s,',
'           -- flows and pages',
'           (select f1.security_group_id,',
'                   count(distinct f1.id) apps,',
'                   count(p1.id) pages,',
'                   max(f1.last_updated_on) last_updated_on',
'              from wwv_flow_steps p1, wwv_flows f1',
'             where f1.security_group_id = p1.security_group_id',
'               and p1.flow_id = f1.id',
'             group by f1.security_group_id) f,',
'           -- email',
'           (select security_group_id,count(*) mail_sent',
'              from wwv_flow_mail_log',
'             group by security_group_id) m,',
'           -- email queue',
'           (select security_group_id,count(*) mail_count',
'              from wwv_flow_mail_queue',
'             where last_updated_on < sysdate - 1',
'             group by security_group_id) mq,',
'             -- app page views',
'           (select security_group_id,count(*) page_views,count(distinct userid) end_users,',
'                   sum(elap) total_elap,avg(ELAP) avg_page_view_time',
'                      from wwv_flow_activity_log',
'                     where (flow_id > 4999 or flow_id < 4000)',
'                     group by security_group_id) pv,',
'             -- developer page views',
'           (select security_group_id,count(*) d_page_views,count(distinct userid) act_developers',
'                      from wwv_flow_activity_log',
'                     where flow_id between 4000 and 4999',
'                     group by security_group_id) dv',
'     where s.security_group_id = c.provisioning_company_id '';',
'     if :P501_SEARCH is not null then',
'        x:=x||'' and upper(c.short_name) like ''''%''''||upper(:P501_SEARCH)||''''%'''' '';',
'     end if;',
'     x:=x||''',
'       and c.provisioning_company_id = :P501_SGID',
'       and c.provisioning_company_id = f.security_group_id',
'       and c.provisioning_company_id = m.security_group_id(+)',
'       and c.provisioning_company_id = mq.security_group_id(+)',
'       and c.provisioning_company_id = pv.security_group_id(+)',
'       and c.provisioning_company_id = dv.security_group_id(+)',
'     group by c.provisioning_company_id,c.short_name '';',
'',
'    return x;',
'end;',
'     '))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(22621917280199870.4052)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_query_num_rows_item=>'P501_ROWS'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>15000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22547503569952980.4052)
,p_query_column_id=>1
,p_column_alias=>'SECURITY_GROUP_ID'
,p_column_display_sequence=>1
,p_column_heading=>'SECURITY_GROUP_ID'
,p_heading_alignment=>'RIGHT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22547605797952980.4052)
,p_query_column_id=>2
,p_column_alias=>'SHORT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Espace de travail'
,p_heading_alignment=>'RIGHT'
,p_display_when_condition=>'f?p=4050:14:&SESSION.:REPORT:NO:14:SGID:#ID#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22547829529952980.4052)
,p_query_column_id=>3
,p_column_alias=>'SCHEMAS'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Sch\00E9mas')
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22547705746952980.4052)
,p_query_column_id=>4
,p_column_alias=>'APPS'
,p_column_display_sequence=>4
,p_column_heading=>'Applications'
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22548016245952981.4052)
,p_query_column_id=>5
,p_column_alias=>'PAGES'
,p_column_display_sequence=>5
,p_column_heading=>'Pages'
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22548102604952981.4052)
,p_query_column_id=>6
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>10
,p_column_heading=>unistr('Mise \00E0 jour la plus r\00E9cente')
,p_column_format=>'SINCE'
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22547928028952980.4052)
,p_query_column_id=>7
,p_column_alias=>'MAIL_SENT'
,p_column_display_sequence=>14
,p_column_heading=>unistr('Courriel envoy\00E9')
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22548211462952981.4052)
,p_query_column_id=>8
,p_column_alias=>'MAIL_IN_QUEUE'
,p_column_display_sequence=>13
,p_column_heading=>unistr('Courriel dans la <br />file d''attente depuis plus <br />d''une journ\00E9e')
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22548322899952981.4052)
,p_query_column_id=>9
,p_column_alias=>'PAGE_VIEWS'
,p_column_display_sequence=>6
,p_column_heading=>'Vues de<br /> page'
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22548424140952981.4052)
,p_query_column_id=>10
,p_column_alias=>'END_USERS'
,p_column_display_sequence=>7
,p_column_heading=>'Nombre d''utilisateurs finals'
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22548531510952981.4052)
,p_query_column_id=>11
,p_column_alias=>'TOTAL_ELAP'
,p_column_display_sequence=>8
,p_column_heading=>'Temps total de vue de page'
,p_column_format=>'999G990D9'
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22548604426952981.4052)
,p_query_column_id=>12
,p_column_alias=>'AVG_PAGE_VIEW_TIME'
,p_column_display_sequence=>9
,p_column_heading=>'Temps moyen de vue de page'
,p_column_format=>'999G990D9'
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22548711632952981.4052)
,p_query_column_id=>13
,p_column_alias=>'D_PAGE_VIEWS'
,p_column_display_sequence=>11
,p_column_heading=>unistr('Vues<br /> de page<br /> de d\00E9veloppeur')
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22548827859952982.4052)
,p_query_column_id=>14
,p_column_alias=>'ACT_DEVELOPERS'
,p_column_display_sequence=>12
,p_column_heading=>unistr('D\00E9veloppeurs actifs')
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(22562529150986872.4052)
,p_name=>unistr('Sch\00E9mas')
,p_template=>wwv_flow_api.id(721115784857730284.4052)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.schema,df.bytes/1024/1024 size_mb,',
'       o.tables,o.views,o.packages,o.procedures,o.functions',
'  from wwv_flow_companies c, wwv_flow_company_schemas s,',
'        sys.dba_users u, sys.dba_data_files df,',
'        (select owner,',
'                count(decode(object_type,''TABLE'',1,''MATERIALIZED VIEW'',1)) tables,',
'                count(decode(object_type,''VIEW'',1)) views,',
'                count(decode(object_type,''PACKAGE'',1)) packages,',
'                count(decode(object_type,''PROCEDURE'',1)) procedures,',
'                count(decode(object_type,''FUNCTION'',1)) functions',
'           from sys.dba_objects a, wwv_flow_company_schemas s1',
'          where s1.security_group_id = :P501_SGID',
'            and s1.schema = a.owner',
'            and a.object_type in (''TABLE'',''MATERIALIZED VIEW'',''VIEW'',''PACKAGE'',''PROCEDURE'',''FUNCTION'')',
'          group by a.owner) o          ',
' where s.security_group_id = c.provisioning_company_id ',
'   and c.provisioning_company_id = :P501_SGID',
'   and u.username = s.schema',
'   and u.default_tablespace = df.tablespace_name',
'   and o.owner = u.username'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('Aucun sch\00E9ma trouv\00E9.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22562808087986878.4052)
,p_query_column_id=>1
,p_column_alias=>'SCHEMA'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Sch\00E9ma')
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22569512574010449.4052)
,p_query_column_id=>2
,p_column_alias=>'SIZE_MB'
,p_column_display_sequence=>2
,p_column_heading=>'Taille (Mo)'
,p_column_format=>'999G990D9'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(23499620413597463.4052)
,p_query_column_id=>3
,p_column_alias=>'TABLES'
,p_column_display_sequence=>3
,p_column_heading=>'Tables'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(23499701273597463.4052)
,p_query_column_id=>4
,p_column_alias=>'VIEWS'
,p_column_display_sequence=>4
,p_column_heading=>'Vues'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(23500831973610243.4052)
,p_query_column_id=>5
,p_column_alias=>'PACKAGES'
,p_column_display_sequence=>5
,p_column_heading=>'Packages'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(23500906437610243.4052)
,p_query_column_id=>6
,p_column_alias=>'PROCEDURES'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Proc\00E9dures')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(23501023387610243.4052)
,p_query_column_id=>7
,p_column_alias=>'FUNCTIONS'
,p_column_display_sequence=>7
,p_column_heading=>'Fonctions'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(22635832565309520.4052)
,p_name=>'Applications'
,p_template=>wwv_flow_api.id(721115784857730284.4052)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f1.id,f1.name,',
'       count(p1.id) pages,',
'       max(f1.last_updated_on) last_updated_on,',
'       max(nvl(pv.page_views,0)) page_views,',
'       max(nvl(end_users,0)) end_users,',
'       max(nvl(total_elap,0)) total_elap,',
'       max(nvl(avg_page_view_time,0)) avg_page_view_time,',
'       max(nvl(latest_changes,0)) latest_changes, ',
'       max(nvl(act_developers,0)) act_developers',
' from wwv_flow_steps p1, wwv_flows f1,',
'                   (select flow_id,count(*) page_views,count(distinct userid) end_users,',
'                           sum(elap) total_elap,avg(ELAP) avg_page_view_time',
'                      from wwv_flow_activity_log',
'                     where security_group_id = :P501_SGID',
'                     group by flow_id) pv,',
'           (select flow_id,count(id) latest_changes,count(distinct FLOW_USER) act_developers',
'              from WWV_FLOW_BUILDER_AUDIT_TRAIL',
'             where security_group_id = :P501_SGID',
'               and audit_date > trunc(sysdate - 7)',
'             group by flow_id ) a',
'where :P501_SGID = f1.security_group_id',
'       and f1.id = p1.flow_id',
'       and f1.id = pv.flow_id(+)',
'       and f1.id = a.flow_id(+)',
'group by f1.name,f1.id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('Aucune application trouv\00E9e.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(23496432394515738.4052)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22636100280309530.4052)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Application'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22636203092309530.4052)
,p_query_column_id=>3
,p_column_alias=>'PAGES'
,p_column_display_sequence=>3
,p_column_heading=>'Pages'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22636320699309531.4052)
,p_query_column_id=>4
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Derni\00E8re<br /> mise \00E0 jour')
,p_column_format=>'SINCE'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22647825125345216.4052)
,p_query_column_id=>5
,p_column_alias=>'PAGE_VIEWS'
,p_column_display_sequence=>5
,p_column_heading=>'Vues de <br />page'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22647921593345216.4052)
,p_query_column_id=>6
,p_column_alias=>'END_USERS'
,p_column_display_sequence=>9
,p_column_heading=>'Utilisateurs<br />finaux'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22648010587345216.4052)
,p_query_column_id=>7
,p_column_alias=>'TOTAL_ELAP'
,p_column_display_sequence=>6
,p_column_heading=>'Temps total<br />de vue de page'
,p_column_format=>'999G990D9'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22648128286345216.4052)
,p_query_column_id=>8
,p_column_alias=>'AVG_PAGE_VIEW_TIME'
,p_column_display_sequence=>7
,p_column_heading=>'Temps moyen<br /> de vue <br />de page'
,p_column_format=>'999G990D9'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22669100200413779.4052)
,p_query_column_id=>9
,p_column_alias=>'LATEST_CHANGES'
,p_column_display_sequence=>8
,p_column_heading=>'Modifications au cours <br />des 7 derniers jours'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22669204938413779.4052)
,p_query_column_id=>10
,p_column_alias=>'ACT_DEVELOPERS'
,p_column_display_sequence=>10
,p_column_heading=>unistr('D\00E9veloppeurs <br />actifs')
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(23504624625702720.4052)
,p_name=>unistr('Courriel envoy\00E9')
,p_template=>wwv_flow_api.id(721115784857730284.4052)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mail_to,mail_subj,last_updated_on',
'  from wwv_flow_mail_log',
' where security_group_id = :P501_SGID'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('Aucun courriel envoy\00E9 trouv\00E9.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(23504903559702727.4052)
,p_query_column_id=>1
,p_column_alias=>'MAIL_TO'
,p_column_display_sequence=>1
,p_column_heading=>'A'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(23505001594702727.4052)
,p_query_column_id=>2
,p_column_alias=>'MAIL_SUBJ'
,p_column_display_sequence=>2
,p_column_heading=>'Objet'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(23505113305702727.4052)
,p_query_column_id=>3
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Envoy\00E9 le')
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(23507724887721798.4052)
,p_name=>'Courriel dans la file d''attente'
,p_template=>wwv_flow_api.id(721115784857730284.4052)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mail_to,mail_subj,last_updated_on',
'  from wwv_flow_mail_queue',
' where security_group_id = :P501_SGID'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('Aucun courriel dans la file d''attente trouv\00E9.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(23508028120721802.4052)
,p_query_column_id=>1
,p_column_alias=>'MAIL_TO'
,p_column_display_sequence=>1
,p_column_heading=>'A'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(23508131834721802.4052)
,p_query_column_id=>2
,p_column_alias=>'MAIL_SUBJ'
,p_column_display_sequence=>2
,p_column_heading=>'Objet'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(23508201647721802.4052)
,p_query_column_id=>3
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Envoy\00E9')
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(23526615593823115.4052)
,p_name=>unistr('D\00E9veloppeurs')
,p_template=>wwv_flow_api.id(721115784857730284.4052)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select u.email_address,u.first_name,u.last_name,',
'       count(t.id) changes',
'  from wwv_flow_developers d,wwv_flow_fnd_user u,',
'       wwv_flow_builder_audit_trail t',
' where d.user_id = u.user_id',
'   and t.flow_user(+) = u.user_name',
'   and d.security_group_id = :P501_SGID',
' group by u.email_address,u.first_name,u.last_name'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(805672157251677851.4052)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('Aucun d\00E9veloppeur n''a \00E9t\00E9 trouv\00E9.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(23528901656838001.4052)
,p_query_column_id=>1
,p_column_alias=>'EMAIL_ADDRESS'
,p_column_display_sequence=>1
,p_column_heading=>'Courriel'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(23527025585823120.4052)
,p_query_column_id=>2
,p_column_alias=>'FIRST_NAME'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Pr\00E9nom')
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(23527131181823120.4052)
,p_query_column_id=>3
,p_column_alias=>'LAST_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nom'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(23527223558823120.4052)
,p_query_column_id=>4
,p_column_alias=>'CHANGES'
,p_column_display_sequence=>4
,p_column_heading=>'Modifications'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22550506916952996.4052)
,p_branch_action=>'f?p=&FLOW_ID.:501:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22551518367955360.4052)
,p_name=>'P501_SGID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(22547304320952975.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22550308257952994.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'P501_GO,P501_SEARCH'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
end;
/
prompt --application/pages/page_00555
begin
wwv_flow_api.create_page(
 p_id=>555.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('Th\00E8mes publics')
,p_step_title=>unistr('Th\00E8mes publics')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(3931176884177111905)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_pub_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(138015530198611860.4052)
,p_plug_name=>unistr('Th\00E8mes publics')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Lorsque vous cr\00E9ez un th\00E8me public, vous l''ajoutez au r\00E9f\00E9rentiel de th\00E8mes. Les th\00E8mes publics sont disponibles lorsque vous cr\00E9ez une application ou un th\00E8me pour une application existante.</p>'),
unistr('<p>Pour cr\00E9er un th\00E8me public, vous le s\00E9lectionnez dans un espace de travail et une application. Une fois cr\00E9\00E9, vous ne pouvez pas le modifier directement. Pour cela, cr\00E9ez une application \00E0 partir de ce th\00E8me, puis modifiez celui-ci dans l''applicat')
||unistr('ion. Cr\00E9ez ensuite un autre th\00E8me public avec le th\00E8me de l''application mis \00E0 jour (et supprimez l''ancien si vous le souhaitez).</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472913831407970593.4052)
,p_plug_name=>unistr('Th\00E8mes publics')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.id,',
'       t.theme_id,',
'       t.theme_name,',
'       ''<img src="''||decode(nvl(t.CUSTOM_IMAGE,''N''),''N'',',
'          m.ip||''htmldb/icons/ws_theme.png'',',
'         ''wwv_flow_utilities.get_theme_file?p_id=''||t.id||''&''||',
'         ''p_app_id=''||flow_id)||''" width="150" height="80" alt="" />''',
'       theme_image,',
'       t.theme_description,',
'       t.flow_id application_id,',
'       (select count(*) from wwv_flow_templates where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) page_templates,',
'       (select count(*) from WWV_FLOW_BUTTON_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) button_templates,',
'       (select count(*) from WWV_FLOW_CAL_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) calendar_templates,',
'       (select count(*) from WWV_FLOW_FIELD_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) label_templates,',
'       (select count(*) from WWV_FLOW_LIST_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) list_templates,',
'       (select count(*) from WWV_FLOW_MENU_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) breadcrumb_templates,',
'       (select count(*) from WWV_FLOW_PAGE_PLUG_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) region_templates,',
'       (select count(*) from WWV_FLOW_ROW_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) report_templates,',
'       (select count(*) from WWV_FLOW_POPUP_LOV_TEMPLATE where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) POPUP_LOV_template,',
'       decode(nvl(t.CUSTOM_IMAGE,''N''),''N'',',
'          m.ip||''htmldb/icons/ws_theme.png'',',
'         ''wwv_flow_utilities.get_theme_file?p_id=''||t.id||''&''||',
'         ''p_app_id=''||t.flow_id)',
'         img,',
'       t.theme_name image_alt,',
'       ''f?p=4050:42:''||:app_session||''::::P42_ID:''|| t.id image_url,',
'       t.theme_name||'' - ''||t.theme_id image_text',
'  from wwv_flow_themes t,',
'       (select v(''IMAGE_PREFIX'') ip from dual) m',
' where t.theme_security_group_id is null',
'   and t.security_group_id = 11',
'   and t.flow_id in (select id from wwv_flows where application_type = ''STANDARD'' and security_group_id = 11)',
'   and t.theme_id > 99'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(472913908256970593.4052)
,p_name=>'Workspace Themes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="" />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_link_column=>'IMAGE_URL'
,p_icon_view_img_src_column=>'IMG'
,p_icon_view_label_column=>'IMAGE_TEXT'
,p_icon_view_alt_text=>'#IMAGE_ALT#'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472914227983970604.4052)
,p_db_column_name=>'THEME_ID'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>unistr('Num\00E9ro')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472914327199970605.4052)
,p_db_column_name=>'THEME_NAME'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Nom'
,p_column_link=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.::P42_ID:#ID#'
,p_column_linktext=>'#THEME_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472914417204970606.4052)
,p_db_column_name=>'THEME_IMAGE'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Image'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472914504507970607.4052)
,p_db_column_name=>'THEME_DESCRIPTION'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472914604665970608.4052)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'Application<br />d''espace de travail '
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472914719936970609.4052)
,p_db_column_name=>'PAGE_TEMPLATES'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>unistr('Mod\00E8les<br />de page')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472914816346970611.4052)
,p_db_column_name=>'BUTTON_TEMPLATES'
,p_display_order=>7
,p_column_identifier=>'H'
,p_column_label=>unistr('Mod\00E8les<br />de bouton')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472914924536970612.4052)
,p_db_column_name=>'CALENDAR_TEMPLATES'
,p_display_order=>8
,p_column_identifier=>'I'
,p_column_label=>unistr('Mod\00E8les<br />de calendrier')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472915030342970613.4052)
,p_db_column_name=>'LABEL_TEMPLATES'
,p_display_order=>9
,p_column_identifier=>'J'
,p_column_label=>unistr('Mod\00E8les<br />de libell\00E9')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472915100138970614.4052)
,p_db_column_name=>'LIST_TEMPLATES'
,p_display_order=>10
,p_column_identifier=>'K'
,p_column_label=>unistr('Mod\00E8les<br />de liste')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472915200253970615.4052)
,p_db_column_name=>'BREADCRUMB_TEMPLATES'
,p_display_order=>11
,p_column_identifier=>'L'
,p_column_label=>unistr('Mod\00E8les<br />de chemin de navigation')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472915308766970616.4052)
,p_db_column_name=>'REGION_TEMPLATES'
,p_display_order=>12
,p_column_identifier=>'M'
,p_column_label=>unistr('Mod\00E8les<br />de r\00E9gion')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472915426426970617.4052)
,p_db_column_name=>'REPORT_TEMPLATES'
,p_display_order=>13
,p_column_identifier=>'N'
,p_column_label=>unistr('Mod\00E8les<br />d''\00E9tat')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472915522119970618.4052)
,p_db_column_name=>'POPUP_LOV_TEMPLATE'
,p_display_order=>14
,p_column_identifier=>'O'
,p_column_label=>unistr('Mod\00E8le de liste de valeurs (LOV)<br />instantan\00E9e')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472914132092970603.4052)
,p_db_column_name=>'ID'
,p_display_order=>15
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472918912507984112.4052)
,p_db_column_name=>'IMG'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Img'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472919002293984114.4052)
,p_db_column_name=>'IMAGE_ALT'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Texte Alt de l''image'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472919131467984115.4052)
,p_db_column_name=>'IMAGE_URL'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'URL de l''image'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472919207424984116.4052)
,p_db_column_name=>'IMAGE_TEXT'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Texte de l''image'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(472972504505029059.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(472913831407970593.4052)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:555:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(138085025043740205.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(472913831407970593.4052)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er un th\00E8me public')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:47:&SESSION.::&DEBUG.:47,48,51::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(138020924841611867.4052)
,p_branch_action=>'f?p=&APP_ID.:555:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
end;
/
prompt --application/pages/page_00900
begin
wwv_flow_api.create_page(
 p_id=>900.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>unistr('D\00E9marrage de bienvenue')
,p_step_title=>'Bienvenue dans Oracle Application Express'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* Hide breadcrumb bar */',
'.a-ControlBar.apex-instance-admin {display: none;}',
'',
'/* Set Large Icon Size */',
'.a-Alert--wizard .a-Alert-icon .a-Icon.large-icon {width: 96px;height: 96px;}'))
,p_step_template=>wwv_flow_api.id(721099117305687972.4052)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(52036166580715317.4052)
,p_plug_name=>'Bienvenue dans &PRODUCT_NAME..'
,p_icon_css_classes=>'large-icon gi-icon-apex-logo-icon'
,p_region_template_options=>'a-Alert--info:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(829706609080810173.4052)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Avant de commencer, prenez le temps de cr\00E9er un espace de travail. Un espace de travail est une zone de travail partag\00E9e dans laquelle plusieurs d\00E9veloppeurs peuvent construire des applications.</p>'),
'',
unistr('<p>Une fois cr\00E9\00E9, connectez-vous \00E0 votre espace de travail pour commencer \00E0 construire des applications. Revenez aux services d''administration pour cr\00E9er d''autres espaces de travail ou pour g\00E9rer l''instance &PRODUCT_NAME.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(52036219048715318.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(52036166580715317.4052)
,p_button_name=>'CREATE_WORKSPACE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er un espace de travail')
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:27,79,72,73,74::'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(206356434016953037.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(52036166580715317.4052)
,p_button_name=>'CREATE_WORKSPACE_ATP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er un espace de travail')
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:142:&SESSION.::&DEBUG.:RP,142:LAST_VIEW:3'
,p_required_patch=>-wwv_flow_api.id(3913175260740993520.4052)
);
end;
/
prompt --application/pages/page_04001
begin
wwv_flow_api.create_page(
 p_id=>4001.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Modifier un statut de construction'
,p_page_mode=>'MODAL'
,p_step_title=>'Modifier un statut de construction'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'350'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'AEADM/adm_bld_status.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(244297732473824476.4052)
,p_plug_name=>'Modifier un statut de construction'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721130166613730309.4052)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(955891016107997321.4052)
,p_plug_name=>'boutons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(244298131468824477.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(955891016107997321.4052)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Appliquer les modifications'
,p_button_position=>'NEXT'
,p_button_condition=>'P4001_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(244298330675824481.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(955891016107997321.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(244299330227824486.4052)
,p_name=>'P4001_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(244297732473824476.4052)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(244299726832824494.4052)
,p_name=>'P4001_SECURITY_GROUP_ID'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(244297732473824476.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Espace de travail :'
,p_source=>'SECURITY_GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_ALL_COMPANIES_ESCAPED'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'wwv_flow_lang.system_message(''F4050_SHOW_ALL_WORKSPACES'')||',
''' -'' d, 0 r from dual union all',
'select wwv_flow_escape.html(short_name)||'' (''||PROVISIONING_COMPANY_ID||'')'' d,',
'       PROVISIONING_COMPANY_ID r',
'from   WWV_FLOW_COMPANIES',
'where  provisioning_company_id > 0',
'order by 1'))
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifie le nom et l''ID de l''espace de travail.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(244300515591824500.4052)
,p_name=>'P4001_OWNER'
,p_item_sequence=>6
,p_item_plug_id=>wwv_flow_api.id(244297732473824476.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Sch\00E9ma d''analyse :')
,p_source=>'OWNER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifie le sch\00E9ma de base de donn\00E9es au titre duquel cette application analysera les instructions SQL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(244301232268824502.4052)
,p_name=>'P4001_NAME'
,p_item_sequence=>7
,p_item_plug_id=>wwv_flow_api.id(244297732473824476.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application :'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifie le nom d''application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(244302030007824504.4052)
,p_name=>'P4001_BUILD_STATUS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(244297732473824476.4052)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Statut de construction'
,p_source=>'BUILD_STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BUILD_STATUS'
,p_lov=>'.'||wwv_flow_api.id(244320808989852457.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00E9lectionnez un statut de construction. Les options sont les suivantes :</p>'),
'<ul>',
unistr('<li><strong>Ex\00E9cuter l''application uniquement :</strong> les d\00E9veloppeurs peuvent uniquement ex\00E9cuter l''application. L''application figurera dans la liste des applications d''App Builder pour l''espace de travail, mais elle ne pourra pas \00EAtre modifi\00E9e.<')
||'/li>',
unistr('<li><strong>Ex\00E9cuter et construire l''application :</strong> les d\00E9veloppeurs peuvent ex\00E9cuter l''application et la modifier. L''application figurera dans la liste des applications d''App Builder pour l''espace de travail.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Identifies the build status of the current application.  If the current status does not allow editing, then developers are locked out of the application.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(244300201396824498.4052)
,p_validation_name=>'P4001_SECURITY_GROUP_ID not null'
,p_validation_sequence=>2
,p_validation=>'P4001_SECURITY_GROUP_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('L''ID de groupe de s\00E9curit\00E9 doit avoir une valeur.')
,p_associated_item=>wwv_flow_api.id(244299726832824494.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(244300910172824501.4052)
,p_validation_name=>'P4001_OWNER not null'
,p_validation_sequence=>6
,p_validation=>'P4001_OWNER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Le propri\00E9taire doit avoir une valeur.')
,p_associated_item=>wwv_flow_api.id(244300515591824500.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(244301701272824502.4052)
,p_validation_name=>'P4001_NAME not null'
,p_validation_sequence=>7
,p_validation=>'P4001_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'L''application doit avoir une valeur.'
,p_associated_item=>wwv_flow_api.id(244301232268824502.4052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(222857324280540001.4052)
,p_name=>'Cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(244298330675824481.4052)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(222857445143540002.4052)
,p_event_id=>wwv_flow_api.id(222857324280540001.4052)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(244302528363824510.4052)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOWS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOWS'
,p_attribute_03=>'P4001_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Impossible d''extraire la ligne.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(359906830604609955.4052)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_security.g_security_group_id := :P4001_SECURITY_GROUP_ID;',
'',
'update wwv_flows',
'   set build_status = :P4001_BUILD_STATUS',
' where id = :P4001_ID',
'   and security_group_id = :P4001_SECURITY_GROUP_ID;',
'',
'wwv_flow_security.g_security_group_id := 10;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Impossible de traiter la ligne de la table WWV_FLOWS.'
,p_process_when_button_id=>wwv_flow_api.id(244298131468824477.4052)
,p_process_success_message=>unistr('Action trait\00E9e.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(222857971181540007.4052)
,p_process_sequence=>11
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(244298131468824477.4052)
,p_process_success_message=>unistr('Action trait\00E9e.')
);
end;
/
prompt --application/pages/page_08000
begin
wwv_flow_api.create_page(
 p_id=>8000.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Recherche d''un espace de travail'
,p_step_title=>'Recherche d''un espace de travail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(721098416706687971.4052)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_wrkspc_srch.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29812203483293080.4052)
,p_plug_name=>'Espaces de travail'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(721125879764730304.4052)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    ID,',
'    PROVISIONING_COMPANY_ID,',
'    SHORT_NAME,',
'    FIRST_SCHEMA_PROVISIONED,',
'    ALLOW_PLSQL_EDITING,',
'    LAST_LOGIN,',
'    EXPIRE_FND_USER_ACCOUNTS,',
'    ACCOUNT_LIFETIME_DAYS,',
'    FND_USER_MAX_LOGIN_FAILURES,',
'    BUILDER_NOTIFICATION_MESSAGE,',
'    (select count(*) from wwv_flows f where f.security_group_id = w.PROVISIONING_COMPANY_ID) Applications,',
'    (select count(*) from WWV_FLOW_COMPANY_SCHEMAS f where f.SECURITY_GROUP_ID = w.PROVISIONING_COMPANY_ID) schemas,',
'    nvl((select ''YES'' from dual where exists (select 1 from WWV_FLOW_SESSIONS$ s where s.SECURITY_GROUP_ID = w.PROVISIONING_COMPANY_ID)),''NO'') active_sessions',
'from WWV_FLOW_COMPANIES w',
'where PROVISIONING_COMPANY_ID not in (0,10,11,12)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(29812322315293080.4052)
,p_name=>'Workspaces'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Cette requ\00EAte renvoie plus de 10 000 lignes. Filtrez vos donn\00E9es pour \00EAtre s\00FBr d''obtenir des r\00E9sultats complets.')
,p_no_data_found_message=>unistr('Aucune donn\00E9e n''a \00E9t\00E9 trouv\00E9e.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29812514805293088.4052)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29812613782293090.4052)
,p_db_column_name=>'PROVISIONING_COMPANY_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'ID d''espace de travail'
,p_column_type=>'NUMBER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29812729987293090.4052)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Espace de travail'
,p_column_link=>'f?p=&APP_ID.:8001:&SESSION.::&DEBUG.:8001:P8001_WORKSPACE_ID:#PROVISIONING_COMPANY_ID#'
,p_column_linktext=>'#SHORT_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29812813321293090.4052)
,p_db_column_name=>'FIRST_SCHEMA_PROVISIONED'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Premier sch\00E9ma provisionn\00E9')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29812901281293091.4052)
,p_db_column_name=>'ALLOW_PLSQL_EDITING'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Autoriser la modification du code PL/SQL'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29813015705293091.4052)
,p_db_column_name=>'LAST_LOGIN'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Derni\00E8re connexion')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29813108595293092.4052)
,p_db_column_name=>'EXPIRE_FND_USER_ACCOUNTS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Expir\00E9')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29813211663293092.4052)
,p_db_column_name=>'ACCOUNT_LIFETIME_DAYS'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>unistr('Dur\00E9e de validit\00E9 du compte (jours)')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29813308615293092.4052)
,p_db_column_name=>'FND_USER_MAX_LOGIN_FAILURES'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>unistr('Nombre maximal d''\00E9checs de connexion')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29813431684293092.4052)
,p_db_column_name=>'BUILDER_NOTIFICATION_MESSAGE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Message de notification Builder'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29817130683334112.4052)
,p_db_column_name=>'APPLICATIONS'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Applications'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29819407312365146.4052)
,p_db_column_name=>'SCHEMAS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>unistr('Sch\00E9mas')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29859420874189997.4052)
,p_db_column_name=>'ACTIVE_SESSIONS'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Sessions actives'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(110344620122166929)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1080989625371523929.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(29812203483293080.4052)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('R\00E9initialiser')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:8000:&SESSION.::&DEBUG.:RP,RIR,8000:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30179614848846477.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(29812203483293080.4052)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372670814202760.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er un espace de travail')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:27,79,72,73,74::'
,p_icon_css_classes=>'icon-right-chevron'
,p_required_patch=>wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(357640153218810948.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(29812203483293080.4052)
,p_button_name=>'CREATE_ATP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517849275695867600.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Cr\00E9er un espace de travail')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:142:&SESSION.::&DEBUG.:142:LAST_VIEW:8000'
,p_icon_css_classes=>'icon-right-chevron'
,p_required_patch=>-wwv_flow_api.id(3913175260740993520.4052)
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(29946031991896157.4052)
,p_computation_sequence=>10
,p_computation_item=>'LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'8000'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_08001
begin
wwv_flow_api.create_page(
 p_id=>8001.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Espace de travail'
,p_step_title=>'Espace de travail'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216765317551591446)
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/adm_wrkspc_srch.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29818204757354956.4052)
,p_plug_name=>unistr('D\00E9tails de l''espace de travail')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_workspace_reports.report_workspace_usage (',
'    p_time_frame_DWMY  => nvl(:P8001_REPORTING_PERIOD,''W''),',
'    p_date_format      => :DATE_TIME_FORMAT,',
'    p_security_group_id => :P8001_WORKSPACE_ID );',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30187402353965943.4052)
,p_plug_name=>'hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(29794925290987920.4052)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(180424225671454717.4052)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(721110277025730268.4052)
,p_plug_display_sequence=>15
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(180504904780290631.4052)
,p_plug_name=>unistr('D\00E9tails de l''espace de travail')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(517418631967368160.4052)
,p_plug_display_sequence=>110
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Cette page affiche les attributs d''espace de travail cl\00E9. Vous pouvez envoyer cet \00E9tat par courriel \00E0 l''aide du bouton pr\00E9vu \00E0 cet effet en haut de la page.'),
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(180729515289344564.4052)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(180424225671454717.4052)
,p_button_name=>'P8001_GO'
,p_button_static_id=>'P8001_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>unistr('D\00E9finir')
,p_request_source=>'SET'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(29945712598890529.4052)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(180424225671454717.4052)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Annuler'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30183916458913195.4052)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(180424225671454717.4052)
,p_button_name=>'EDIT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Modifier l''espace de travail'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:78:&SESSION.::&DEBUG.:78:P78_PROVISIONING_COMPANY_ID:&P8001_WORKSPACE_ID.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(184031721530143625.4052)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(180424225671454717.4052)
,p_button_name=>'EMAIL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Courriel'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:76:&SESSION.::&DEBUG.::P76_REPORTING_PERIOD,P76_WORKSPACE_ID:&P8001_REPORTING_PERIOD.,&P8001_WORKSPACE_ID.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30182823469896286.4052)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(180424225671454717.4052)
,p_button_name=>'EDIT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_image_alt=>'Modifier le nom'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:78:&SESSION.::&DEBUG.::P78_PROVISIONING_COMPANY_ID:&P8001_WORKSPACE_ID.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(29944501339849457.4052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(180424225671454717.4052)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>unistr('Pr\00E9c\00E9dent')
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(29944016445844390.4052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(180424225671454717.4052)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(517373248988202760.4052)
,p_button_image_alt=>'Suivant'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(29944320254845455.4052)
,p_branch_action=>'f?p=&APP_ID.:8001:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(29820129261380917.4052)
,p_name=>'P8001_WORKSPACE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(30187402353965943.4052)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30185725855944331.4052)
,p_name=>'P8001_WORKSPACE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(30187402353965943.4052)
,p_use_cache_before_default=>'NO'
,p_source=>'select wwv_flow_escape.html(short_name) n from wwv_flow_companies where provisioning_company_id = :P8001_WORKSPACE_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180729332473340047.4052)
,p_name=>'P8001_REPORTING_PERIOD'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(180424225671454717.4052)
,p_item_default=>'W'
,p_prompt=>unistr('P\00E9riode de g\00E9n\00E9ration d''\00E9tat')
,p_source=>'W'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORTING PERIOD'
,p_lov=>'.'||wwv_flow_api.id(180726228364333770.4052)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(721133390982759781.4052)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifier une p\00E9riode de g\00E9n\00E9ration d''\00E9tat')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(29948927414989445.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'next and previous navigation'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare n varchar2(255); i number := 0;',
'begin',
'   select max(short_name) into n',
'   from WWV_FLOW_COMPANIES ',
'   where PROVISIONING_COMPANY_ID = :P8001_WORKSPACE_ID;',
'',
'if v(''REQUEST'') = ''NEXT'' then',
'   for c1 in (select PROVISIONING_COMPANY_ID',
'       from WWV_FLOW_COMPANIES',
'       where SHORT_NAME > n and PROVISIONING_COMPANY_ID not in (0,10,11)',
'       order by short_name) loop',
'       i := c1.PROVISIONING_COMPANY_ID;',
'       exit;',
'   end loop;',
'elsif v(''REQUEST'') = ''PREVIOUS'' then',
'   for c1 in (select PROVISIONING_COMPANY_ID',
'       from WWV_FLOW_COMPANIES',
'       where SHORT_NAME < n and PROVISIONING_COMPANY_ID not in (0,10,11)',
'       order by short_name desc) loop',
'       i := c1.PROVISIONING_COMPANY_ID;',
'       exit;',
'   end loop;',
'else',
'   i := :P8001_WORKSPACE_ID;',
'end if;',
'if i > 0 then',
':P8001_WORKSPACE_ID := i;',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_08011
begin
wwv_flow_api.create_page(
 p_id=>8011.4052
,p_user_interface_id=>wwv_flow_api.id(4973826483302347.4052)
,p_name=>'Page de connexion'
,p_alias=>'LOGIN'
,p_step_title=>'Accueil de l''administration interne d''Oracle APEX - Connexion'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(517336519765126407.4052)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(38543621788954541.4052)
,p_plug_name=>'Oracle APEX Internal Administration'
,p_region_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(38545727848954559.4052)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(38543621788954541.4052)
,p_button_name=>'LOGIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(517372214551202759.4052)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Connexion'
,p_button_position=>'CREATE'
,p_button_alignment=>'LEFT'
,p_grid_new_row=>'Y'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38544067168954546.4052)
,p_name=>'P8011_USERNAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(38543621788954541.4052)
,p_prompt=>'Nom utilisateur'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>100
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38544435607954549.4052)
,p_name=>'P8011_PASSWORD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(38543621788954541.4052)
,p_prompt=>'Mot de passe'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>40
,p_cMaxlength=>100
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38544886798954550.4052)
,p_name=>'P8011_REMEMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(38543621788954541.4052)
,p_prompt=>unistr('M\00E9moriser le nom utilisateur')
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'LOGIN_REMEMBER_USERNAME'
,p_lov=>'.'||wwv_flow_api.id(117703408573204417.4052)||'.'
,p_label_alignment=>'RIGHT'
,p_display_when=>'apex_authentication.persistent_cookies_enabled'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Si vous cochez cette case, l''application enregistre votre nom utilisateur dans un cookie de navigateur persistant nomm\00E9 "LOGIN_USERNAME_COOKIE".'),
unistr('Lors de votre prochain acc\00E8s \00E0 la page de connexion,'),
unistr('cette valeur est automatiquement renseign\00E9e dans le champ de nom utilisateur.'),
'</p>',
'<p>',
unistr('Si vous d\00E9sactivez cette case \00E0 cocher et que votre nom utilisateur est d\00E9j\00E0 enregistr\00E9 dans le cookie,'),
'l''application le remplace par une valeur vide.',
unistr('Vous pouvez \00E9galement utiliser les outils de d\00E9veloppement de votre navigateur pour enlever enti\00E8rement le cookie.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(38546534520954564.4052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Username Cookie'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_authentication.send_login_username_cookie (',
'    p_username => lower(:P8011_USERNAME),',
'    p_consent  => :P8011_REMEMBER = ''Y'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(38546136119954562.4052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Login'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_authentication.login(',
'    p_username => :P8011_USERNAME,',
'    p_password => :P8011_PASSWORD );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(38547344548954564.4052)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear Page(s) Cache'
,p_attribute_01=>'CLEAR_CACHE_CURRENT_PAGE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(38546985930954564.4052)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Get Username Cookie'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P8011_USERNAME := apex_authentication.get_login_username_cookie;',
':P8011_REMEMBER := case when :P8011_USERNAME is not null then ''Y'' end;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
